prompt --application/set_environment
set define off verify off feedback off
--------------------------------------------------------------------------------
--
-- ORACLE Application Express (APEX) export file
--
-- You should run the script connected to SQL*Plus as the Oracle user
-- APEX_210200 or as the owner (parsing schema) of the application.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_api.import_begin (
 p_version_yyyy_mm_dd=>'2021.10.15'
,p_release=>'21.2.0-19'
,p_default_workspace_id=>10
,p_default_application_id=>4420
,p_default_id_offset=>0
,p_default_owner=>'APEX_210200'
);
end;
/
 
prompt APPLICATION 4420 - Oracle APEX Builder, Wizard Messages and Native Plug-Ins
--
-- Application Export:
--   Application:     4420
--   Name:            Oracle APEX Builder, Wizard Messages and Native Plug-Ins
--   Exported By:     APEX_210200
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                      1
--     Shared Components:
--       Logic:
--       Navigation:
--         Lists:                  3
--       Security:
--         Authentication:         1
--       User Interface:
--         Templates:
--           Page:                 2
--           Region:               1
--           Label:                1
--           List:                 1
--           Popup LOV:            1
--           Calendar:             3
--           Breadcrumb:           2
--           Button:               1
--           Report:               1
--         Plug-ins:             133
--       Globalization:
--         Messages:          13,405
--       Reports:
--       E-Mail:
--     Supporting Objects:  Excluded
--   Version:         21.2.0-19
--   Instance ID:     697872254810262
--

prompt --application/delete_application
begin
wwv_flow_api.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_flow_api.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'APEX_210200')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Oracle APEX Builder, Wizard Messages and Native Plug-Ins')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'A110305728823364184')
,p_page_view_logging=>'YES'
,p_charset=>'utf-8'
,p_page_protection_enabled_y_n=>'N'
,p_checksum_salt_last_reset=>'20211020110857'
,p_bookmark_checksum_function=>'SH1'
,p_compatibility_mode=>'5.0'
,p_flow_language=>'ja'
,p_flow_language_derived_from=>'SESSION'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_authentication=>'PLUGIN'
,p_authentication_id=>wwv_flow_api.id(91645213681389498.442)
,p_populate_roles=>'A'
,p_application_tab_set=>0
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'&PRODUCT_NAME. 21.2.0-19'
,p_flow_status=>'UNAVAILABLE'
,p_flow_unavailable_text=>'This application is currently unavailable.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'D'
,p_deep_linking=>'Y'
,p_authorize_public_pages_yn=>'Y'
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'N'
,p_auto_time_zone=>'N'
,p_friendly_url=>'N'
,p_last_updated_by=>'APEX_210200'
,p_last_upd_yyyymmddhh24miss=>'20211020112716'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_ui_type_name => null
,p_print_server_type=>'INSTANCE'
,p_is_pwa=>'N'
);
end;
/
prompt --application/shared_components/navigation/lists/spotlight_custom_entries_global
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(562090986404402217.442)
,p_name=>'Spotlight \ Custom Entries - Global'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(48650898565635010.442)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('\30B5\30A4\30F3\30A2\30A6\30C8')
,p_list_item_link_target=>'&LOGOUT_URL.'
,p_list_text_01=>unistr('Application Express\306E\30B5\30A4\30F3\30A2\30A6\30C8')
,p_list_text_09=>unistr('\306F\3044')
,p_list_text_10=>'logout exit quit :q'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(281916990329150760.442)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('\30B9\30D7\30EC\30C3\30C9\30B7\30FC\30C8\3067\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\4F5C\6210\3057\307E\3059')
,p_list_item_link_target=>'f?p=4000:56:&APP_SESSION.::NO:56,103,104,106,130,131,35,227,3020,3000,3001'
,p_list_text_01=>unistr('Excel\30D5\30A1\30A4\30EB\307E\305F\306FCSV\30D5\30A1\30A4\30EB\3092\30A4\30F3\30DD\30FC\30C8\3057\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\4F5C\6210\3057\307E\3059')
,p_list_text_09=>unistr('\306F\3044')
,p_list_text_10=>'excel csv xsl xslx spreadsheet data paste load import'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(282255839842182292.442)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Oracle APEX\30DB\30FC\30E0')
,p_list_item_link_target=>'f?p=4500:1000:&APP_SESSION.'
,p_list_text_10=>'homepage start '
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(296033420364984683.442)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('\30D5\30A9\30F3\30C8APEX\30A2\30A4\30B3\30F3\3092\53C2\7167')
,p_list_item_link_target=>'javascript:apex.navigation.openInNewWindow(''https://apex.oracle.com/fontapex'');'
,p_list_text_01=>unistr('\30D5\30A9\30F3\30C8APEX\30A2\30A4\30B3\30F3\3092\53C2\7167\3057\3001\4FEE\98FE\5B50\3092\8FFD\52A0\3057\3066\3001\5FC5\8981\306ACSS\307E\305F\306FHTML\3092\30B3\30D4\30FC\3057\307E\3059\3002')
,p_list_text_09=>unistr('\306F\3044')
,p_list_text_10=>'icons font apex library graphics'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/spotlight_custom_entries_app_level
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(562091518091404815.442)
,p_name=>'Spotlight \ Custom Entries - App Level'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(562091727563404815.442)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30A8\30AF\30B9\30DD\30FC\30C8')
,p_list_item_link_target=>'f?p=4000:4900:&SESSION.::NO:::'
,p_list_text_01=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3{APP_ID}\3092SQL\30D5\30A1\30A4\30EB\3068\3057\3066\30A8\30AF\30B9\30DD\30FC\30C8')
,p_list_text_09=>unistr('\306F\3044')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(562093357853428158.442)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('\672A\4F7F\7528\306E\30EA\30B9\30C8')
,p_list_item_link_target=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/spotlight_custom_entries_page_designer
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(562092153904409717.442)
,p_name=>'Spotlight \ Custom Entries - Page Designer'
,p_list_status=>'PUBLIC'
);
end;
/
prompt --application/plugin_settings
begin
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(14843831009863117.442)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(14859012524941040.442)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(86380554411225400.442)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_RICH_TEXT_EDITOR'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(91997339122572414.442)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_RICH_TEXT_EDITOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(99844881073888905.442)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(146861159122292557.442)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(176128961688506820.442)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(176129003012506820.442)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(183033629816949774.442)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(460407779408652225.442)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_COM.ORACLE.APEX.STARRATING_MODERN'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(497671453666914719.442)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_STAR_RATING'
,p_attribute_01=>'fa-star'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(592236161067709447.442)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(631035363954639049.442)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1082458703597614427.442)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1082517678315623391.442)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_CSS_CALENDAR'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1765072678475712055.442)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1831649180083980462.442)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1831780276458994154.442)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1832884277947217587.442)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_COLOR_PICKER'
,p_attribute_01=>'modern'
,p_attribute_02=>'POPUP'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1840861033969283097.442)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_DISPLAY_SELECTOR'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1917665913120940054.442)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1990227023531717243.442)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_CSS_CALENDAR'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
null;
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
null;
end;
/
prompt --application/pages/page_groups
begin
null;
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/one_level_tabs
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(91626406749381989.442)
,p_theme_id=>1
,p_name=>'One Level Tabs.ja'
,p_internal_name=>'ONE_LEVEL_TABS'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">',
'',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'',
'<title>#TITLE#</title>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_1/theme_V3.css" type="text/css" />',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table width="100%" cellpadding="0" cellspacing="0" border="0" summary="">',
'  <tr>',
'    <td valign="top" class="t1Logo">#LOGO##REGION_POSITION_06#</td>',
'	<td valign="top" width="100%">#REGION_POSITION_07#</td>',
'    <td align="right" valign="top">#NAVIGATION_BAR##REGION_POSITION_08#</td>',
'  </tr>',
'</table>',
'<table width="100%" cellpadding="0" cellspacing="0" border="0" summary="" height="70%">',
'  <tr>',
'    <td colspan="5" class="t1ParentTabHolder"><table border="0" cellpadding="0" cellspacing="0" summary="" align="right"><tr><td><br /></td>#TAB_CELLS#</tr></table></td>',
'  </tr>',
'  <tr>',
'    <td valign="top"><img src="#IMAGE_PREFIX#themes/theme_1/top_bar_left.png" alt="" /></td>',
'    <td class="t1topbarMiddle" valign="bottom"><table cellpadding="0" cellspacing="0" border="0" summary=""><tr><td height="50%"><br /></td></tr><tr><td height="50%">#REGION_POSITION_01#</td></tr></table></td>',
'    <td valign="top"><img src="#IMAGE_PREFIX#themes/theme_1/top_bar_right.png" alt="" /></td>',
'  </tr>',
'<tr>',
'<td><br /></td>',
'<td class="t1PageCenter" colspan="2" valign="top" height="100%"><table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">',
'<tr>',
'<td width="100%" valign="top" class="t1PageBody"><div class="t1messages">#GLOBAL_NOTIFICATION##SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>#BODY##REGION_POSITION_02##REGION_POSITION_04#</td>',
'<td valign="top">#REGION_POSITION_03#<br /></td>',
'</tr>',
'</table></td>',
'</tr>',
'</table>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table width="100%" cellpadding="0" cellspacing="0" border="0" summary="">',
'  <tr>',
'    <td><img src="#IMAGE_PREFIX#themes/theme_1/bot_bar_left.png" alt="" /></td>',
'    <td class="t1BotbarMiddle"><div id="t1user">&APP_USER.</div></td>',
'    <td class="t1BotbarMiddle"><div id="t1copy"><!-- Copyright Here --><span class="t1Customize">#CUSTOMIZE#</span></div></td>',
'    <td><img src="#IMAGE_PREFIX#themes/theme_1/bot_bar_right.png" alt="" /></td>',
'  </tr>',
'</table>',
'<br />',
'#REGION_POSITION_05#',
'#FORM_CLOSE# ',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>'<div class="t1success">#SUCCESS_MESSAGE#</div>'
,p_current_tab=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_on_left.png" border="0" alt="" /></td>',
'<td class="t1ParentTabCenterOn">#TAB_LABEL##TAB_INLINE_EDIT#</td>',
'<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_on_right.png" border="0" alt="" /></td>',
'',
''))
,p_non_current_tab=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_off_left.png" border="0" alt="" /></td>',
'<td class="t1ParentTabCenterOff"><a href="#TAB_LINK#">#TAB_LABEL#</a>#TAB_INLINE_EDIT#</td>',
'<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_off_right.png" border="0" alt="" /></td>',
''))
,p_notification_message=>'<div class="t1notification">#MESSAGE#</div>'
,p_navigation_bar=>'<div class="t1NavigationBar">#BAR_BODY#</div>'
,p_navbar_entry=>'<a href="#LINK#" class="t1NavigationBar">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>1
,p_grid_type=>'TABLE'
,p_dialog_browser_frame=>'MODAL'
,p_template_comment=>'12'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140001488931349566.442)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.442)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140001517815349566.442)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.442)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140001699115349566.442)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.442)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140001740672349566.442)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.442)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140001820430349566.442)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.442)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140001949447349565.442)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.442)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140002088971349565.442)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.442)
,p_name=>'Page Position 6'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140002117005349565.442)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.442)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140002264345349565.442)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.442)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/printer_friendly
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(91626529080381989.442)
,p_theme_id=>1
,p_name=>'Printer Friendly.ja'
,p_internal_name=>'PRINTER_FRIENDLY'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">',
'',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'',
'<title>#TITLE#</title>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_1/theme_V3.css" type="text/css" />',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">',
'<tr>',
'<td width="100%" valign="top">',
'<div style="border:1px solid black;">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>',
'#BODY##REGION_POSITION_04#</td>',
'<td valign="top">#REGION_POSITION_03#<br /></td>',
'</tr>',
'</table>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE##DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_theme_class_id=>5
,p_grid_type=>'TABLE'
,p_dialog_browser_frame=>'MODAL'
,p_template_comment=>'3'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140002343913349565.442)
,p_page_template_id=>wwv_flow_api.id(91626529080381989.442)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140002490586349565.442)
,p_page_template_id=>wwv_flow_api.id(91626529080381989.442)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140002552177349565.442)
,p_page_template_id=>wwv_flow_api.id(91626529080381989.442)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/button/button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(91626823864381990.442)
,p_template_name=>'Button'
,p_internal_name=>'BUTTON'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="t1Button" cellspacing="0" cellpadding="0" border="0"  summary="">',
'<tr>',
'<td class="t1L"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_1/button_left.gif" alt="" width="4" height="24" /></a></td>',
'<td class="t1C"><a href="#LINK#">#LABEL!HTML#</a></td>',
'<td class="t1R"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_1/button_right.gif" width="4" height="24" alt="" /></a></td>',
'</tr>',
'</table>'))
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>1
);
end;
/
prompt --application/shared_components/user_interface/templates/region/reports_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(91632832228382001.442)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t1ReportsRegion" id="#REGION_ID#">',
'<tr>',
'<td class="t1RegionHeader">#TITLE#</td>',
'<td class="t1ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##HELP#</td>',
'</tr>',
'<tr>',
'<td class="t1Body" colspan="2">#BODY#</td>',
'</tr>',
'</table>'))
,p_page_plug_template_name=>'Reports Region'
,p_internal_name=>'REPORTS_REGION'
,p_plug_table_bgcolor=>'#ffffff'
,p_theme_id=>1
,p_theme_class_id=>9
,p_plug_heading_bgcolor=>'#ffffff'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
,p_template_comment=>'Red Theme'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140382691031344638.442)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.442)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140382773788344638.442)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.442)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140382895312344637.442)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.442)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140382923760344637.442)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.442)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140383001370344637.442)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.442)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140383101590344637.442)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.442)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140383260593344637.442)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.442)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140383343091344637.442)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.442)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140383417298344637.442)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.442)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140383590781344637.442)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.442)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/vertical_unordered_list_with_bullets
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(91636711305382010.442)
,p_list_template_current=>'<li class="t1current">#TEXT#</li>'
,p_list_template_noncurrent=>'<li><a href="#LINK#">#TEXT#</a></li>'
,p_list_template_name=>'Vertical Unordered List with Bullets'
,p_internal_name=>'VERTICAL_UNORDERED_LIST_WITH_BULLETS'
,p_theme_id=>1
,p_theme_class_id=>1
,p_list_template_before_rows=>'<ul class="t1VerticalUnorderedListwithBullets">'
,p_list_template_after_rows=>'</ul>'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/standard
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(91638400927382012.442)
,p_row_template_name=>'Standard'
,p_internal_name=>'STANDARD'
,p_row_template1=>'<td#ALIGNMENT# headers="#COLUMN_HEADER_NAME#" class="t1data">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellpadding="0" border="0" cellspacing="0" summary="">#TOP_PAGINATION#',
'<tr>',
'<td><table cellpadding="0" border="0" cellspacing="0" summary="" class="t1standard">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table><div class="t1CVS">#EXTERNAL_LINK##CSV_LINK#</div></td>',
'</tr>',
'#PAGINATION#',
'</table>'))
,p_row_template_before_first=>'<tr #HIGHLIGHT_ROW#>'
,p_row_template_after_last=>'</tr>'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#" class="t1header">#COLUMN_HEADER#</th>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_next_page_template=>'<a href="#LINK#" class="t1pagination">#PAGINATION_NEXT#<img src="#IMAGE_PREFIX#themes/theme_1/paginate_next.gif" alt="Next"></a>'
,p_previous_page_template=>'<a href="#LINK#" class="t1pagination"><img src="#IMAGE_PREFIX#themes/theme_1/paginate_prev.gif" alt="Previous">#PAGINATION_PREVIOUS#</a>'
,p_next_set_template=>'<a href="#LINK#" class="t1pagination">#PAGINATION_NEXT_SET#<img src="#IMAGE_PREFIX#themes/theme_1/paginate_next.gif" alt="Next"></a>'
,p_previous_set_template=>'<a href="#LINK#" class="t1pagination"><img src="#IMAGE_PREFIX#themes/theme_1/paginate_prev.gif" alt="Previous">#PAGINATION_PREVIOUS_SET#</a>'
,p_row_style_checked=>'#CCCCCC'
,p_theme_id=>1
,p_theme_class_id=>4
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/optional_with_help
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(91641225667382016.442)
,p_template_name=>'Optional with help'
,p_internal_name=>'OPTIONAL_WITH_HELP'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999"><a class="t1OptionalwithHelp" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'')" tabindex="999">'
,p_template_body2=>'</a></label>'
,p_on_error_before_label=>'<div class="t1InlineError">'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#</div>'
,p_theme_id=>1
,p_theme_class_id=>1
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/hierarchical_menu
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(91641730492382017.442)
,p_name=>'Hierarchical Menu'
,p_internal_name=>'HIERARCHICAL_MENU'
,p_before_first=>'<ul class="t1HierarchicalMenu">'
,p_current_page_option=>'<li class="t1current">#NAME#</li>'
,p_non_current_page_option=>'<li><a href="#LINK#">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>11
,p_start_with_node=>'CHILD_MENU'
,p_theme_id=>1
,p_theme_class_id=>2
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/breadcrumb_menu
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(91641814330382017.442)
,p_name=>'Breadcrumb Menu'
,p_internal_name=>'BREADCRUMB_MENU'
,p_before_first=>'<div class="t1BreadcrumbMenu">'
,p_current_page_option=>'<span class="t1current">#NAME#</span>'
,p_non_current_page_option=>'<a href="#LINK#">#NAME#</a>'
,p_between_levels=>'&nbsp;&gt;&nbsp;'
,p_after_last=>'</div>'
,p_max_levels=>12
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>1
,p_theme_class_id=>1
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_api.create_popup_lov_template(
 p_id=>wwv_flow_api.id(91642503902382024.442)
,p_popup_icon=>'#IMAGE_PREFIX#list_gray.gif'
,p_popup_icon_attr=>'width="13" height="13" alt="Popup Lov"'
,p_page_name=>'winlov'
,p_page_title=>unistr('\691C\7D22\30C0\30A4\30A2\30ED\30B0\30FB\30DC\30C3\30AF\30B9')
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#APEX_JAVASCRIPT#',
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_1/theme_V2.css" type="text/css">',
'',
'#THEME_CSS#',
'</head>'))
,p_page_body_attr=>'onload="first_field()" style="margin:0;"'
,p_before_field_text=>'<div class="t1PopupHead">'
,p_filter_width=>'20'
,p_filter_max_width=>'100'
,p_find_button_text=>unistr('\691C\7D22')
,p_close_button_text=>unistr('\9589\3058\308B')
,p_next_button_text=>unistr('\6B21 >')
,p_prev_button_text=>unistr('< \524D')
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'400'
,p_height=>'450'
,p_result_row_x_of_y=>'<br /><div style="padding:2px; font-size:8pt;">Row(s) #FIRST_ROW# - #LAST_ROW#</div>'
,p_result_rows_per_pg=>500
,p_before_result_set=>'<div class="t1PopupBody">'
,p_theme_id=>1
,p_theme_class_id=>1
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/small_calendar
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(91641910982382018.442)
,p_cal_template_name=>'Small Calendar'
,p_internal_name=>'SMALL_CALENDAR'
,p_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#DY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1SmallCalendarHolder"> ',
' <tr>',
'   <td class="t1MonthTitle">#IMONTH# #YYYY#</td>',
' </tr>',
' <tr>',
' <td>'))
,p_month_open_format=>'<table border="0" cellpadding="0" cellspacing="1" summary="#CALENDAR_TITLE# #IMONTH# #YYYY#" class="t1SmallCalendar">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td>',
'</tr>',
'</table>'))
,p_day_title_format=>'<div class="t1DayTitle">#DD#</div>'
,p_day_open_format=>'<td class="t1Day" valign="top">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td valign="top" class="t1Today">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="t1WeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td valign="top" class="t1WeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="t1NonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="t1NonDay" valign="top">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr> '
,p_daily_title_format=>'<table cellspacing="0" cellpadding="0" border="0" summary="" class="t1DayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr> <tr> <td>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_weekly_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1SmallWeekCalendarHolder">',
'<tr>',
'<td class="t1MonthTitle" id="test">#WTITLE#</td>',
'</tr>',
'<tr>',
'<td>'))
,p_weekly_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY#<br />#MM#/#DD#</th>'
,p_weekly_month_open_format=>'<table border="0" cellpadding="0" cellspacing="1" summary="#CALENDAR_TITLE# #START_DL# - #END_DL#" class="t1SmallWeekCalendar">'
,p_weekly_month_close_format=>'</table></td></tr></table>'
,p_weekly_day_open_format=>'<td class="t1Day" valign="top">'
,p_weekly_day_close_format=>'<br /></td>'
,p_weekly_today_open_format=>'<td class="t1Today" valign="top">'
,p_weekly_weekend_open_format=>'<td valign="top" class="t1NonDay">'
,p_weekly_weekend_close_format=>'<br /></td>'
,p_weekly_time_open_format=>'<th scope="row" class="t1Hour">'
,p_weekly_time_close_format=>'<br /></th>'
,p_weekly_time_title_format=>'#TIME#'
,p_weekly_hour_open_format=>'<tr>'
,p_weekly_hour_close_format=>'</tr>'
,p_daily_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY# #DD#/#MM#</th>'
,p_daily_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1SmallDayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr><tr><td>',
''))
,p_daily_month_open_format=>'<table border="0" cellpadding="2" cellspacing="1" summary="#CALENDAR_TITLE# #START_DL#" class="t1SmallDayCalendar">'
,p_daily_month_close_format=>'</table></td></tr></table>'
,p_daily_day_open_format=>'<td valign="top" class="t1Day">'
,p_daily_day_close_format=>'<br /></td>'
,p_daily_today_open_format=>'<td valign="top" class="t1Today">'
,p_daily_time_open_format=>'<th scope="row" class="t1Hour">'
,p_daily_time_close_format=>'<br /></th>'
,p_daily_time_title_format=>'#TIME#'
,p_daily_hour_open_format=>'<tr>'
,p_daily_hour_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>1
,p_theme_class_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/calendar
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(91642102481382020.442)
,p_cal_template_name=>'Calendar'
,p_internal_name=>'CALENDAR'
,p_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1CalendarHolder"> ',
' <tr>',
'   <td class="t1MonthTitle">#IMONTH# #YYYY#</td>',
' </tr>',
' <tr>',
' <td>'))
,p_month_open_format=>'<table border="0" cellpadding="0" cellspacing="0" summary="0" class="t1Calendar">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td>',
'</tr>',
'</table>',
''))
,p_day_title_format=>'<div class="t1DayTitle">#DD#</div>'
,p_day_open_format=>'<td class="t1Day" valign="top">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td valign="top" class="t1Today">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="t1WeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td valign="top" class="t1WeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="t1NonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="t1NonDay" valign="top">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr> '
,p_daily_title_format=>'<table cellspacing="0" cellpadding="0" border="0" summary="" class="t1DayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr> <tr> <td>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_weekly_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1WeekCalendarHolder">',
'<tr>',
'<td class="t1MonthTitle" id="test">#WTITLE#</td>',
'</tr>',
'<tr>',
'<td>'))
,p_weekly_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY#<br>#MM#/#DD#</th>'
,p_weekly_month_open_format=>'<table border="0" cellpadding="0" cellspacing="0" summary="#CALENDAR_TITLE# #START_DL# - #END_DL#" class="t1WeekCalendar">'
,p_weekly_month_close_format=>'</table></td></tr></table>'
,p_weekly_day_open_format=>'<td class="t1Day" valign="top">'
,p_weekly_day_close_format=>'<br /></td>'
,p_weekly_today_open_format=>'<td class="t1Today" valign="top">'
,p_weekly_weekend_open_format=>'<td valign="top" class="t1NonDay">'
,p_weekly_weekend_close_format=>'<br /></td>'
,p_weekly_time_open_format=>'<th scope="row" class="t1Hour">'
,p_weekly_time_close_format=>'<br /></th>'
,p_weekly_time_title_format=>'#TIME#'
,p_weekly_hour_open_format=>'<tr>'
,p_weekly_hour_close_format=>'</tr>'
,p_daily_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY# #DD#/#MM#</th>'
,p_daily_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1DayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr> <tr> <td>',
''))
,p_daily_month_open_format=>'<table border="0" cellpadding="2" cellspacing="0" summary="#CALENDAR_TITLE# #START_DL#" class="t1DayCalendar">'
,p_daily_month_close_format=>'</table></td> </tr> </table>'
,p_daily_day_open_format=>'<td valign="top" class="t1Day">'
,p_daily_day_close_format=>'<br /></td>'
,p_daily_today_open_format=>'<td valign="top" class="t1Today">'
,p_daily_time_open_format=>'<th scope="row" class="t1Hour">'
,p_daily_time_close_format=>'<br /></th>'
,p_daily_time_title_format=>'#TIME#'
,p_daily_hour_open_format=>'<tr>'
,p_daily_hour_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>1
,p_theme_class_id=>1
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/calendar_alternative_1
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(91642303533382020.442)
,p_cal_template_name=>'Calendar, Alternative 1'
,p_internal_name=>'CALENDAR,_ALTERNATIVE_1'
,p_day_of_week_format=>'<th scope="col" valign="bottom" class="t1DayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1CalendarAlternative1Holder"> ',
' <tr>',
'   <td class="t1MonthTitle">#IMONTH# #YYYY#</td>',
' </tr>',
' <tr>',
' <td>'))
,p_month_open_format=>'<table border="0" cellpadding="0" cellspacing="2" summary="0" class="t1CalendarAlternative1">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td>',
'</tr>',
'</table>',
''))
,p_day_title_format=>'<div class="t1DayTitle">#DD#</div>'
,p_day_open_format=>'<td class="t1Day" valign="top" height="100" height="100">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td valign="top" class="t1Today">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="t1WeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td valign="top" class="t1WeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="t1NonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="t1NonDay" valign="top">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr> '
,p_daily_title_format=>'<table cellspacing="0" cellpadding="0" border="0" summary="" class="t1DayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr> <tr> <td>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_weekly_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1WeekCalendarAlternative1Holder">',
'<tr>',
'<td class="t1MonthTitle" id="test">#WTITLE#</td>',
'</tr>',
'<tr>',
'<td>'))
,p_weekly_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY#<br>#MM#/#DD#</th>'
,p_weekly_month_open_format=>'<table border="0" cellpadding="0" cellspacing="2" summary="#CALENDAR_TITLE# #START_DL# - #END_DL#" class="t1WeekCalendarAlternative1">'
,p_weekly_month_close_format=>'</table></td></tr></table>'
,p_weekly_day_open_format=>'<td class="t1Day" valign="top">'
,p_weekly_day_close_format=>'<br /></td>'
,p_weekly_today_open_format=>'<td class="t1Today" valign="top">'
,p_weekly_weekend_open_format=>'<td valign="top" class="t1NonDay">'
,p_weekly_weekend_close_format=>'<br /></td>'
,p_weekly_time_open_format=>'<th scope="row" class="t1Hour">'
,p_weekly_time_close_format=>'<br /></th>'
,p_weekly_time_title_format=>'#TIME#'
,p_weekly_hour_open_format=>'<tr>'
,p_weekly_hour_close_format=>'</tr>'
,p_daily_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY# #DD#/#MM#</th>'
,p_daily_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1DayCalendarAlternative1Holder"> <tr><td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td></tr><tr><td>',
''))
,p_daily_month_open_format=>'<table border="0" cellpadding="2" cellspacing="2" summary="#CALENDAR_TITLE# #START_DL#" class="t1DayCalendarAlternative1">'
,p_daily_month_close_format=>'</table></td> </tr> </table>'
,p_daily_day_open_format=>'<td valign="top" class="t1Day">'
,p_daily_day_close_format=>'<br /></td>'
,p_daily_today_open_format=>'<td valign="top" class="t1Today">'
,p_daily_time_open_format=>'<th scope="row" class="t1Hour">'
,p_daily_time_close_format=>'<br /></th>'
,p_daily_time_title_format=>'#TIME#'
,p_daily_hour_open_format=>'<tr>'
,p_daily_hour_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>1
,p_theme_class_id=>2
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_options
begin
null;
end;
/
prompt --application/shared_components/globalization/language
begin
null;
end;
/
prompt --application/shared_components/logic/build_options
begin
null;
end;
/
prompt --application/shared_components/globalization/messages
begin
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103526091429308034)
,p_name=>'2DCOLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('2D\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103528189833308036)
,p_name=>'2DCOLUMN_LINE'
,p_message_language=>'ja'
,p_message_text=>unistr('2D\5217\4ED8\304D\6298\308C\7DDA')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103526182123308034)
,p_name=>'2DDOUGHNUT'
,p_message_language=>'ja'
,p_message_text=>unistr('2D\30C9\30FC\30CA\30C4')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103527939761308036)
,p_name=>'2DHSTACKED_PCT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7A4D\4E0A\3052\6C34\5E732D\5217(%)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103526257496308034)
,p_name=>'2DLINE'
,p_message_language=>'ja'
,p_message_text=>unistr('2D\6298\308C\7DDA')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103526331055308034)
,p_name=>'2DPIE'
,p_message_language=>'ja'
,p_message_text=>unistr('2D\5186')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103527782214308035)
,p_name=>'2DSTACKED_PCT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7A4D\4E0A\30522D\5217(%)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103526427515308034)
,p_name=>'3DCOLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('3D\5217')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103528030089308036)
,p_name=>'3DHSTACKED_PCT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7A4D\4E0A\3052\6C34\5E733D\5217(%)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103526534523308035)
,p_name=>'3DPIE'
,p_message_language=>'ja'
,p_message_text=>unistr('3D\5186')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103527822111308036)
,p_name=>'3DSTACKED_PCT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7A4D\4E0A\30523D\5217(%)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104295963334308679)
,p_name=>'4000.912.0.ITEMS.FOR.INSERT.INTO.AD'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C5E\6027\30C7\30A3\30AF\30B7\30E7\30CA\30EA\3078\306E\633F\5165\7528\306E0\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104295782376308679)
,p_name=>'4000.912.0.ITEMS.FOR.UPDATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F4\65B0\7528\306E0\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104296166913308679)
,p_name=>'4000.912.0.ITEMS.FOR.UPDATE.OF.AD'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C5E\6027\30C7\30A3\30AF\30B7\30E7\30CA\30EA\66F4\65B0\7528\306E0\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104296574417308680)
,p_name=>'4000.912.0.RC.FOR.INSERT.INTO.AD'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C5E\6027\30C7\30A3\30AF\30B7\30E7\30CA\30EA\3078\306E\633F\5165\7528\306E0\30EC\30DD\30FC\30C8\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104296793998308680)
,p_name=>'4000.912.0.RC.FOR.UPDATE.OF.AD'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C5E\6027\30C7\30A3\30AF\30B7\30E7\30CA\30EA\66F4\65B0\7528\306E0\30EC\30DD\30FC\30C8\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104295662714308679)
,p_name=>'4000.912.REVIEW.N.ITEMS.FOR.UPDATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F4\65B0\7528\306E%0\30A2\30A4\30C6\30E0\306E\78BA\8A8D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104296300020308679)
,p_name=>'4000:912:0.RC.FOR.UPDATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F4\65B0\7528\306E0\30EC\30DD\30FC\30C8\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104295852726308679)
,p_name=>'4000:912:REVIEW.N.ITEMS.FOR.INSERT.INTO.AD'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C5E\6027\30C7\30A3\30AF\30B7\30E7\30CA\30EA\3078\306E\633F\5165\7528\306E%0\30A2\30A4\30C6\30E0\306E\78BA\8A8D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104296088578308679)
,p_name=>'4000:912:REVIEW.N.ITEMS.FOR.UPDATE.OF.AD'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C5E\6027\30C7\30A3\30AF\30B7\30E7\30CA\30EA\66F4\65B0\7528\306E%0\30A2\30A4\30C6\30E0\306E\78BA\8A8D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104296420903308679)
,p_name=>'4000:912:REVIEW.N.RC.FOR.INSERT.INTO.AD'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C5E\6027\30C7\30A3\30AF\30B7\30E7\30CA\30EA\3078\306E\633F\5165\7528\306E%0\30EC\30DD\30FC\30C8\5217\306E\78BA\8A8D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104296268305308679)
,p_name=>'4000:912:REVIEW.N.RC.FOR.UPDATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F4\65B0\7528\306E%0\30EC\30DD\30FC\30C8\5217\306E\78BA\8A8D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104296676416308680)
,p_name=>'4000:912:REVIEW.N.RC.FOR.UPDATE.OF.AD'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C5E\6027\30C7\30A3\30AF\30B7\30E7\30CA\30EA\66F4\65B0\7528\306E%0\30EC\30DD\30FC\30C8\5217\306E\78BA\8A8D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104088342938308507)
,p_name=>'4000_424_VALUE_MUST_BE_NUMERIC'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024\306F\6570\5024\3067\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104073536259308494)
,p_name=>'4000_639_SEQ_MESG'
,p_message_language=>'ja'
,p_message_text=>unistr('<span class="fielddata">\30EA\30FC\30B8\30E7\30F3\306E\9806\5E8F\304C\4E00\610F\3067\306A\3044\305F\3081\3001\9806\5E8F\5909\66F4\3067\304D\307E\305B\3093\3002</span>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104073683249308495)
,p_name=>'4000_641_SEQ_MESG'
,p_message_language=>'ja'
,p_message_text=>unistr('<span class="fielddata">\30DC\30BF\30F3\306E\9806\5E8F\304C\4E00\610F\3067\306A\3044\305F\3081\3001\9806\5E8F\5909\66F4\3067\304D\307E\305B\3093\3002</span>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104073713046308495)
,p_name=>'4000_646_SEQ_MESG'
,p_message_language=>'ja'
,p_message_text=>unistr('<span class="fielddata">\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30D0\30FC\306E\9806\5E8F\304C\4E00\610F\3067\306A\3044\305F\3081\3001\9806\5E8F\5909\66F4\3067\304D\307E\305B\3093\3002</span>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104073813487308495)
,p_name=>'4000_749_SEQ_MESG'
,p_message_language=>'ja'
,p_message_text=>unistr('<span class="fielddata">\30EA\30FC\30B8\30E7\30F3\30FB\30A2\30A4\30C6\30E0\306E\9806\5E8F\304C\4E00\610F\3067\306A\3044\305F\3081\3001\9806\5E8F\5909\66F4\3067\304D\307E\305B\3093\3002</span>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104142791078308552)
,p_name=>'4000_APPLICATION_ID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103657406792308134)
,p_name=>'4000_EDIT_APPLICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\7DE8\96C6: %0 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104047004169308473)
,p_name=>'4000_INVALID_DATE_FORMAT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6307\5B9A\3055\308C\305F\65E5\4ED8\66F8\5F0F\306F\7121\52B9\3067\3059\3002  \30AB\30EC\30F3\30C0\306B\306F\3001YYYYMMDD\3068\3044\3046\66F8\5F0F\306E\65E5\4ED8\304C\5FC5\8981\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104093003258308511)
,p_name=>'4000_TREE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C4\30EA\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104142820727308552)
,p_name=>'4000_WORKSPACE_ID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9ID')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103937408203308388)
,p_name=>'4050_106_ENTER_SCHEMA_NAME'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4F5C\6210\3059\308B\65B0\3057\3044\30B9\30AD\30FC\30DE\306E\540D\524D\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002\30B9\30AD\30FC\30DE\306E'),
unistr('\30D1\30B9\30EF\30FC\30C9\9078\629E\3057\3001\30C7\30D5\30A9\30EB\30C8\306E\8868\9818\57DF\304A\3088\3073\4E00\6642\8868\9818\57DF\3092'),
unistr('\9078\629E\3057\3066\304F\3060\3055\3044\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103937544565308388)
,p_name=>'4050_106_EXISTING_SCHEMA'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E2\5B58\306E\30B9\30AD\30FC\30DE\306E\540D\524D\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103937647983308388)
,p_name=>'4050_106_WHEN_DONE'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D42\4E86\3057\305F\3089\3001<strong>\300C\6B21\3078\300D</strong>\3092\30AF\30EA\30C3\30AF\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103807737874308253)
,p_name=>'4050_110_DROP_TABLESPACES'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\9818\57DF\304A\3088\3073\95A2\9023\30C7\30FC\30BF\30D5\30A1\30A4\30EB\306E\524A\9664: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103807681121308253)
,p_name=>'4050_110_DROP_USERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30E6\30FC\30B6\30FC\306E\524A\9664: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104671527470308976)
,p_name=>'4050_139_WEB_SERVICE_ACTIVITY_LOG'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B5\30FC\30D3\30B9\30FB\30A2\30AF\30C6\30A3\30D3\30C6\30A3\30FB\30ED\30B0\30FB\30A8\30F3\30C8\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103519671423308030)
,p_name=>'4050_162_WEB_SOURCE_SYNC_LOG'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\540C\671F\30ED\30B0\30FB\30A8\30F3\30C8\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103520475102308030)
,p_name=>'4050_182_AUTOMATION_LOG'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\52D5\5316\30ED\30B0\30FB\30A8\30F3\30C8\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103931383377308383)
,p_name=>'4050_19_LOG_ENTRIES'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\767A\8005\30A2\30AF\30C6\30A3\30D3\30C6\30A3\30FB\30ED\30B0\306E\30A8\30F3\30C8\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103570287452308066)
,p_name=>'4050_31_LOG_COUNT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30B0\30A4\30F3\30FB\30A2\30AF\30BB\30B9\30FB\30ED\30B0\306E\30A8\30F3\30C8\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103930804722308383)
,p_name=>'4050_3_CHANGE_REQUESTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5909\66F4\30EA\30AF\30A8\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103930997808308383)
,p_name=>'4050_3_RUNTIME_REQUESTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30F3\30BF\30A4\30E0\30FB\30EA\30AF\30A8\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103930602803308382)
,p_name=>'4050_3_SERVICE_REQUESTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\30FB\30EA\30AF\30A8\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103933120871308384)
,p_name=>'4050_46_AD_HOC'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\30B3\30DE\30F3\30C9\30FB\30D7\30ED\30BB\30C3\30B5\306E\5C65\6B74\30A8\30F3\30C8\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103933067603308384)
,p_name=>'4050_46_CONTROL_FILE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5236\5FA1\30D5\30A1\30A4\30EB\306E\5B9F\884C\30ED\30B0\30FB\30A8\30F3\30C8\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103932989398308384)
,p_name=>'4050_46_SCRIPT_FILE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AF\30EA\30D7\30C8\30FB\30D5\30A1\30A4\30EB\306E\5B9F\884C\30ED\30B0\30FB\30A8\30F3\30C8\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103933227073308384)
,p_name=>'4050_46_SQL_ARCHIVES'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\30A2\30FC\30AB\30A4\30D6\30FB\30A8\30F3\30C8\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103934967193308386)
,p_name=>'4050_61_ACTIVE_LOG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30C6\30A3\30D6\30FB\30ED\30B0\60C5\5831')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103935055788308386)
,p_name=>'4050_61_CURRENT_LOG_NO'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30EC\30F3\30C8\30FB\30ED\30B0\756A\53F7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103935106153308386)
,p_name=>'4050_61_CUR_LOG_TIME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30EC\30F3\30C8\30FB\30ED\30B0\306E\30BF\30A4\30E0\30B9\30BF\30F3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103935768157308386)
,p_name=>'4050_61_HOURS_UNTIL'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\30ED\30B0\30FB\30B9\30A4\30C3\30C1\307E\3067\306E\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103935373147308386)
,p_name=>'4050_61_INTERVAL_DAYS'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5\6570\3067\306E\9593\9694(\5B9A\6570)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103935639827308386)
,p_name=>'4050_61_NEXT_LOG_SWITCH'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30B1\30B8\30E5\30FC\30EB\3055\308C\305F\6B21\306E\30ED\30B0\30FB\30B9\30A4\30C3\30C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103936088549308387)
,p_name=>'4050_70_DEV_ACT'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\767A\8005\30A2\30AF\30C6\30A3\30D3\30C6\30A3\30FB\30ED\30B0\306E\30A8\30F3\30C8\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103936291505308387)
,p_name=>'4050_71_CLICK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30EA\30C3\30AF\30B9\30EB\30FC\30FB\30ED\30B0\306E\30A8\30F3\30C8\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103937068416308387)
,p_name=>'4050_75_AD_HOC'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\30B3\30DE\30F3\30C9\30FB\30D7\30ED\30BB\30C3\30B5\306E\5C65\6B74\30A8\30F3\30C8\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103936945201308387)
,p_name=>'4050_75_CTRL_FILE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5236\5FA1\30D5\30A1\30A4\30EB\306E\5B9F\884C\30ED\30B0\30FB\30A8\30F3\30C8\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103936701788308387)
,p_name=>'4050_75_SCRIPT_FILE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AF\30EA\30D7\30C8\30FB\30D5\30A1\30A4\30EB\306E\5B9F\884C\30ED\30B0\30FB\30A8\30F3\30C8\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103937112778308387)
,p_name=>'4050_75_SQL_ARCH'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\30A2\30FC\30AB\30A4\30D6\30FB\30A8\30F3\30C8\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103937297143308388)
,p_name=>'4050_82_WORKSPACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9%1\306B\306F\3001%2\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3068%3\30E6\30FC\30B6\30FC\304C\5B58\5728\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103937310556308388)
,p_name=>'4050_85_CLICK_COUNT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30EA\30C3\30AF\30FB\30AB\30A6\30F3\30C8\30FB\30ED\30B0\306E\30A8\30F3\30C8\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104118403205308532)
,p_name=>'4050_PACKAGED_APPLICATIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\751F\7523\6027\304A\3088\3073\30B5\30F3\30D7\30EB\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104118522295308532)
,p_name=>'4050_PACKAGED_WEBSHEETS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30F3\30D7\30EBWeb\30B7\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104117757333308531)
,p_name=>'4050_WORKSPACE_COUNT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\6570')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103864882379308297)
,p_name=>'4350_APPLICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103864911966308297)
,p_name=>'4350_EDIT_APPLICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\7DE8\96C6')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103584760489308076)
,p_name=>'4500 800 HD DBA'
,p_message_language=>'ja'
,p_message_text=>unistr('\300EOracle Database Express Edition 2 Day DBA\300F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103584873984308077)
,p_name=>'4500 800 HD DEV'
,p_message_language=>'ja'
,p_message_text=>unistr('\300EOracle Database Express Edition 2 Day Developer Guide\300F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103584657145308076)
,p_name=>'4500 800 HD HTMLDB'
,p_message_language=>'ja'
,p_message_text=>unistr('\300EOracle Application Express 2 Day Plus Developer Guide\300F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103584904174308077)
,p_name=>'4500 800 HD JAVA'
,p_message_language=>'ja'
,p_message_text=>unistr('\300EOracle Database Express Edition 2 Day Plus Java Developer Guide\300F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103585036474308077)
,p_name=>'4500 800 HD NET'
,p_message_language=>'ja'
,p_message_text=>unistr('\300EOracle Database Express Edition 2 Day Plus .NET Developer Guide\300F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103585150655308077)
,p_name=>'4500 800 HD PHP'
,p_message_language=>'ja'
,p_message_text=>unistr('\300EOracle Database Express Edition 2 Day Plus PHP Developer\300F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103585283365308077)
,p_name=>'4500 800 MSG DBA'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5\5E38\306E\7BA1\7406\30BF\30B9\30AF\306B\3064\3044\3066\8AAC\660E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103585362024308077)
,p_name=>'4500 800 MSG DEV'
,p_message_language=>'ja'
,p_message_text=>unistr('Oracle Database Express Edition\958B\767A\74B0\5883\306E\4F7F\7528\65B9\6CD5\306B\3064\3044\3066\8AAC\660E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103585430033308077)
,p_name=>'4500 800 MSG HTMLDB'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\96C6\4E2D\578B\306EWeb\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\69CB\7BC9\65B9\6CD5\3092\8AAC\660E\3059\308B\4E00\9023\306E\30C1\30E5\30FC\30C8\30EA\30A2\30EB\3092\63D0\4F9B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103585626392308077)
,p_name=>'4500 800 MSG JAVA'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30C9\30AD\30E5\30E1\30F3\30C8\3067\306F\3001Java\304A\3088\3073JDBC\3092\4F7F\7528\3057\305FOracle Database XE\3078\306E\63A5\7D9A\65B9\6CD5\3092\793A\3059\30C1\30E5\30FC\30C8\30EA\30A2\30EB\3092\63D0\4F9B\3057\307E\3059\3002\307E\305F\3001\30C7\30FC\30BF\306B\5BFE\3059\308B\30A2\30AF\30BB\30B9\3068\5909\66F4\3092\884C\3046\7C21\5358\306AJava\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\958B\767A\65B9\6CD5\306B\3064\3044\3066\3082\8AAC\660E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103585771452308077)
,p_name=>'4500 800 MSG NET'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30C9\30AD\30E5\30E1\30F3\30C8\3067\306F\3001Oracle Data Provider for .NET\304A\3088\3073Oracle Developer Tools for Visual Studio .NET\306E\4E3B\306A\6A5F\80FD\306B\3064\3044\3066\8AAC\660E\3057\307E\3059\3002\30A4\30F3\30B9\30C8\30FC\30EB\304A\3088\3073\69CB\6210\3001Oracle Data Provider for .NET\304A\3088\3073Oracle Developer Tools for Visual Studio .NET\3092\4F7F\7528\3057\305F\57FA\672C\7684\306A\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\69CB\7BC9\65B9\6CD5\3001PL/SQL\304A\3088\3073.NET\30B9\30C8\30A2\30C9\30FB\30D7\30ED\30B7\30FC\30B8\30E3\306E\4F5C\6210\304A\3088\3073\4F7F\7528\65B9\6CD5\306B')
||unistr('\3064\3044\3066\8AAC\660E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103585578809308077)
,p_name=>'4500 800 MSG PHP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30C9\30AD\30E5\30E1\30F3\30C8\3067\306F\3001Apache\304A\3088\3073Zend Core PHP\30C9\30E9\30A4\30D0\306E\30C0\30A6\30F3\30ED\30FC\30C9\304A\3088\3073\30A4\30F3\30B9\30C8\30FC\30EB\65B9\6CD5\3068\3001PHP\3092\4F7F\7528\3057\305FOracle Database XE\3078\306E\63A5\7D9A\65B9\6CD5\3092\793A\3059\30C1\30E5\30FC\30C8\30EA\30A2\30EB\3092\63D0\4F9B\3057\307E\3059\3002PHP\3092\4F7F\7528\3057\3066\3001\30C7\30FC\30BF\306B\5BFE\3059\308B\30A2\30AF\30BB\30B9\3068\5909\66F4\3092\884C\3046\7C21\5358\306A\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\958B\767A\3059\308B\65B9\6CD5\306B\3064\3044\3066\3082\8AAC\660E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103556214971308056)
,p_name=>'4500_1002_QB_CLONE_ALIAS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5225\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103556175440308056)
,p_name=>'4500_1002_QB_CLONE_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103556496341308056)
,p_name=>'4500_1002_QB_CLONE_CONDITION'
,p_message_language=>'ja'
,p_message_text=>unistr('\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103988003672308426)
,p_name=>'4500_1002_QB_CLONE_DEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103556887834308057)
,p_name=>'4500_1002_QB_CLONE_FUNCTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30F3\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103556991030308057)
,p_name=>'4500_1002_QB_CLONE_GROUP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30EB\30FC\30D7\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103556343375308056)
,p_name=>'4500_1002_QB_CLONE_OBJECT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30D6\30B8\30A7\30AF\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103556751806308056)
,p_name=>'4500_1002_QB_CLONE_OUTPUT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103556509397308056)
,p_name=>'4500_1002_QB_CLONE_SORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BD\30FC\30C8\30FB\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103556604180308056)
,p_name=>'4500_1002_QB_CLONE_SORT_ORDER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BD\30FC\30C8\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103559465095308058)
,p_name=>'4500_1002_QB_JOIN'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D50\5408')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103553285804308054)
,p_name=>'4500_1002_QB_JOIN_HINT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D50\5408\3059\308B\5217\3092\9078\629E\3059\308B\306B\306F\3001\3053\3053\3092\30AF\30EA\30C3\30AF\3057\3066\304F\3060\3055\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103559835406308059)
,p_name=>'4500_1002_QB_MAX_COLS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\592760\5217\3092\9078\629E\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103553103875308054)
,p_name=>'4500_1002_QB_REMOVE_TABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103553003762308054)
,p_name=>'4500_1002_QB_SHOW_COLS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\306E\8868\793A/\975E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103559517165308058)
,p_name=>'4500_1002_QB_TO'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9B\5148')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103552047652308053)
,p_name=>'4500_1220_SCRIPT_RESULT'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306E\7D50\679C(%1\3092\5B9F\884C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103808382285308253)
,p_name=>'4500_46_RET_TO_QUERY'
,p_message_language=>'ja'
,p_message_text=>unistr('\554F\5408\305B\3092\5143\306B\623B\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103567265188308064)
,p_name=>'4500_OBJECT_BROWSER_ONLY_N_COLS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\521D\306E%0\5217\304C\8868\793A\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104015676509308447)
,p_name=>'4500_SESS_EVENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30D9\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104015586633308447)
,p_name=>'4500_SESS_KILOBYTES'
,p_message_language=>'ja'
,p_message_text=>'KB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104015428466308447)
,p_name=>'4500_SESS_MEGABYTES'
,p_message_language=>'ja'
,p_message_text=>'MB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103588039849308079)
,p_name=>'4500_UI_DEF_HINT_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\306E\30C7\30D5\30A9\30EB\30C8\5024\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30D3\30EB\30C0\30FC\3067\4F7F\7528\3055\308C\3001\30EA\30FC\30B8\30E7\30F3\304A\3088\3073\30A2\30A4\30C6\30E0\306E\30D7\30ED\30D1\30C6\30A3\306E\521D\671F\5024\306B\79FB\5165\3055\308C\3066\30011\3064\307E\305F\306F\8907\6570\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5185\306E\8907\6570\306E\30DA\30FC\30B8\9593\3067\306E\4E00\8CAB\6027\3092\5B9F\73FE\3059\308B\305F\3081\306B\4F7F\7528\3055\308C\307E\3059\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103618195040308101)
,p_name=>'4550_COOKIES_ENABLED'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\306F\3001Cookie\304C\6709\52B9\306B\306A\3063\3066\3044\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103618023296308101)
,p_name=>'4550_JAVASCRIPT_ENABLED'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\306F\3001JavaScript\304C\6709\52B9\306B\306A\3063\3066\3044\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104045305215308471)
,p_name=>'ABOUT'
,p_message_language=>'ja'
,p_message_text=>unistr('\60C5\5831')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104738854191309034)
,p_name=>'ABOUT_TO_CREATE_USERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E%0\30E6\30FC\30B6\30FC\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9\3078\306E\8FFD\52A0\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104056893267308481)
,p_name=>'ACCEPTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\627F\8A8D\6E08')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104024997893308455)
,p_name=>'ACCESSIBILITY_ASSIGNEE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30BB\30B7\30D3\30EA\30C6\30A3\5272\5F53\3066\5148')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104023014326308453)
,p_name=>'ACCESSIBILITY_IMPACT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30BB\30B7\30D3\30EA\30C6\30A3\306E\5F71\97FF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104025318046308455)
,p_name=>'ACCESSIBILITY_STATUS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30BB\30B7\30D3\30EA\30C6\30A3\30FB\30B9\30C6\30FC\30BF\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104789718830309080)
,p_name=>'ACCESSIBILITY_TESTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30BB\30B7\30D3\30EA\30C6\30A3\306E\30C6\30B9\30C8\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103698557603308165)
,p_name=>'ACCESS_CONTROL_ADMIN_AUTH'
,p_message_language=>'ja'
,p_message_text=>unistr('\7BA1\7406\6A29\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103564807080308062)
,p_name=>'ACCESS_CONTROL_ADMIN_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30BB\30B9\5236\5FA1\7BA1\7406\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103977226676308418)
,p_name=>'ACCESS_CONTROL_ADMIN_ROLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\7BA1\7406\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104082162841308502)
,p_name=>'ACCESS_CONTROL_ADMIN_ROLE_DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\7BA1\7406\8005\306B\5272\308A\5F53\3066\3089\308C\305F\30ED\30FC\30EB\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103565025231308062)
,p_name=>'ACCESS_CONTROL_APP_ADMIN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103565636876308063)
,p_name=>'ACCESS_CONTROL_APP_MODE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30E2\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103565577833308063)
,p_name=>'ACCESS_CONTROL_APP_MODE_HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3078\306E\30A2\30AF\30BB\30B9\306E\5236\5FA1\65B9\6CD5\3092\6307\5B9A\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103566633713308064)
,p_name=>'ACCESS_CONTROL_APP_MODE_SET_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30E2\30FC\30C9\306E\8A2D\5B9A\30EA\30AF\30A8\30B9\30C8\3092\51E6\7406\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103566754782308064)
,p_name=>'ACCESS_CONTROL_APP_MODE_SET_SUCCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30E2\30FC\30C9\304C\8A2D\5B9A\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103698935464308166)
,p_name=>'ACCESS_CONTROL_CANNOT_DELETE'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\5206\81EA\8EAB\306F\524A\9664\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103699076710308166)
,p_name=>'ACCESS_CONTROL_CANNOT_REMOVE_ADMIN'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\5206\81EA\8EAB\306E\7BA1\7406\8005\6A29\9650\306F\524A\9664\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103564928750308062)
,p_name=>'ACCESS_CONTROL_CONFIRM_TABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103977159137308418)
,p_name=>'ACCESS_CONTROL_CONTRIB_AUTH'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30C8\30EA\30D3\30E5\30FC\30B7\30E7\30F3\6A29\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103977335768308418)
,p_name=>'ACCESS_CONTROL_CONTRIB_ROLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30C8\30EA\30D3\30E5\30FC\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104082209317308502)
,p_name=>'ACCESS_CONTROL_CONTRIB_ROLE_DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30B3\30F3\30C8\30EA\30D3\30E5\30FC\30BF\306B\5272\308A\5F53\3066\3089\308C\305F\30ED\30FC\30EB\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104017856375308449)
,p_name=>'ACCESS_CONTROL_CREATE_APP_SETTINGS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\8A2D\5B9A\304C\4F5C\6210\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103977471261308418)
,p_name=>'ACCESS_CONTROL_CREATE_AUTH_ROLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30AF\30BB\30B9\30FB\30ED\30FC\30EB\304C\4F5C\6210\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103582201807308075)
,p_name=>'ACCESS_CONTROL_CREATE_AUTH_SCHEME'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\8A8D\53EF\30B9\30AD\30FC\30E0\304C\4F5C\6210\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103638098057308119)
,p_name=>'ACCESS_CONTROL_CREATE_PAGE_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30BB\30B9\5236\5FA1\30DA\30FC\30B8\3092\4F5C\6210\3067\304D\307E\305B\3093\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103637900072308119)
,p_name=>'ACCESS_CONTROL_CREATE_TABLE_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30BB\30B9\5236\5FA1\8868\3092\4F5C\6210\3067\304D\307E\305B\3093\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103700385646308167)
,p_name=>'ACCESS_CONTROL_DUP_USERNAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\91CD\8907\3057\305F\30E6\30FC\30B6\30FC\540D\306F\5165\529B\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103698632148308165)
,p_name=>'ACCESS_CONTROL_EDIT_AUTH'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30BB\30B9\5236\5FA1 - \7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103566302384308063)
,p_name=>'ACCESS_CONTROL_FIND_HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5927/\5C0F\6587\5B57\3092\533A\5225\3057\306A\3044\554F\5408\305B\57FA\6E96\3092\5165\529B\3057\3001\300C<strong>\5B9F\884C</strong>\300D\30DC\30BF\30F3\3092\62BC\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103566419963308063)
,p_name=>'ACCESS_CONTROL_GET_APP_MODE_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\7BA1\7406\30E2\30FC\30C9\3092\53D6\5F97\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103566249648308063)
,p_name=>'ACCESS_CONTROL_LAST_CHANGED_BY'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\7D42\5909\66F4\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103565956691308063)
,p_name=>'ACCESS_CONTROL_LIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30BB\30B9\5236\5FA1\30EA\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103565163135308062)
,p_name=>'ACCESS_CONTROL_MODE1'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\306E\5BFE\8C61\3078\306E\5B8C\5168\306A\30A2\30AF\30BB\30B9\6A29\3002\30A2\30AF\30BB\30B9\5236\5FA1\30EA\30B9\30C8\306F\4F7F\7528\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103565291712308063)
,p_name=>'ACCESS_CONTROL_MODE2'
,p_message_language=>'ja'
,p_message_text=>unistr('\5236\9650\4ED8\304D\30A2\30AF\30BB\30B9\6A29\3002\30A2\30AF\30BB\30B9\5236\5FA1\30EA\30B9\30C8\306B\5B9A\7FA9\3055\308C\305F\30E6\30FC\30B6\30FC\306E\307F\304C\8A31\53EF\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103565358397308063)
,p_name=>'ACCESS_CONTROL_MODE3'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30D6\30EA\30C3\30AF\8AAD\53D6\308A\5C02\7528\3002\30A2\30AF\30BB\30B9\5236\5FA1\30EA\30B9\30C8\306B\3088\3063\3066\5236\5FA1\3055\308C\308B\7DE8\96C6\304A\3088\3073\7BA1\7406\306E\6A29\9650\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103565418468308063)
,p_name=>'ACCESS_CONTROL_MODE4'
,p_message_language=>'ja'
,p_message_text=>unistr('\7BA1\7406\30A2\30AF\30BB\30B9\5C02\7528\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103566514876308063)
,p_name=>'ACCESS_CONTROL_NO_PRIV'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A66\884C\3057\305F\30A2\30AF\30B7\30E7\30F3\306E\6A29\9650\304C\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103566148794308063)
,p_name=>'ACCESS_CONTROL_PRIV'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A29\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104017732402308449)
,p_name=>'ACCESS_CONTROL_READER_AUTH'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30C0\30FC\6A29\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104017649352308449)
,p_name=>'ACCESS_CONTROL_READER_ROLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30C0\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104082389840308502)
,p_name=>'ACCESS_CONTROL_READER_ROLE_DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30EA\30FC\30C0\30FC\306B\5272\308A\5F53\3066\3089\308C\305F\30ED\30FC\30EB\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103583027485308075)
,p_name=>'ACCESS_CONTROL_RPT_REGION_HEADER'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\8A8D\8A3C\30B9\30AD\30FC\30E0\306B\5BFE\5FDC\3059\308B\30E6\30FC\30B6\30FC\540D\3092\6307\5B9A\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103565707110308063)
,p_name=>'ACCESS_CONTROL_SET_APP_MODE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30E2\30FC\30C9\306E\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103664139668308139)
,p_name=>'ACCESS_CONTROL_SUCCESS_MSG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30BB\30B9\5236\5FA1\30DA\30FC\30B8\304C\6B63\5E38\306B\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103977565788308418)
,p_name=>'ACCESS_CONTROL_USE_AUTH_ROLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E2\5B58\306E\30A2\30AF\30BB\30B9\5236\5FA1\30ED\30FC\30EB\3092\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103582909524308075)
,p_name=>'ACCESS_CONTROL_USE_AUTH_SCHEME'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E2\5B58\306E\8A8D\53EF\30B9\30AD\30FC\30E0\306E\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103582187091308075)
,p_name=>'ACCESS_CONTROL_USE_TABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E2\5B58\306E\8868\306E\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103698787559308166)
,p_name=>'ACCESS_CONTROL_VIEW_AUTH'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30BB\30B9\5236\5FA1 - \8868\793A')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103585970895308077)
,p_name=>'ACCOUNT_CREATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AB\30A6\30F3\30C8\304C\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104271652168308661)
,p_name=>'ACCOUNT_MENU'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AB\30A6\30F3\30C8\30FB\30E1\30CB\30E5\30FC')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104005582449308439)
,p_name=>'ACKNOWLEDGED'
,p_message_language=>'ja'
,p_message_text=>unistr('\78BA\8A8D\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104005764627308440)
,p_name=>'ACKNOWLEDGED_NO_ACTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\78BA\8A8D\6E08\3001\30A2\30AF\30B7\30E7\30F3\306A\3057')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104066299738308488)
,p_name=>'ACL_ADD_USER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104674860466308979)
,p_name=>'ACL_TABLE.ACCESS_DASHBOARD'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30BB\30B9\30FB\30C0\30C3\30B7\30E5\30DC\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104674958544308979)
,p_name=>'ACL_TABLE.ACCESS_MONITOR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30BB\30B9\30FB\30E2\30CB\30BF\30FC\30FB\30A2\30AF\30C6\30A3\30D3\30C6\30A3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104674437813308979)
,p_name=>'ACL_TABLE.ADD_MODIFY'
,p_message_language=>'ja'
,p_message_text=>unistr('\8FFD\52A0/\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104674722736308979)
,p_name=>'ACL_TABLE.ADMIN_WHEN_RUNNING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5B9F\884C\6642\306E\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104673635991308978)
,p_name=>'ACL_TABLE.ADMIN_WITHIN_BUILDER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30D3\30EB\30C0\30FC\5185\304B\3089\306E\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104674300641308978)
,p_name=>'ACL_TABLE.ANNOTATIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6CE8\91C8(\30D5\30A1\30A4\30EB\3001\30BF\30B0\3001\30CE\30FC\30C8)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104673380214308978)
,p_name=>'ACL_TABLE.APEX_AUTH_WO_ACL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30BB\30B9\5236\5FA1\30EA\30B9\30C8\3092\4F7F\7528\3057\306A\3044Application Express\30A2\30AB\30A6\30F3\30C8\8A8D\8A3C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104673274416308978)
,p_name=>'ACL_TABLE.AUTH_WITH_ACL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30BB\30B9\5236\5FA1\30EA\30B9\30C8\306B\3088\308B\8A8D\8A3C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104674085085308978)
,p_name=>'ACL_TABLE.EDIT_SQL_ACCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\30A2\30AF\30BB\30B9\304A\3088\3073\63A8\5968\30AA\30D6\30B8\30A7\30AF\30C8\306E\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104678079871308981)
,p_name=>'ACL_TABLE.INTRO_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3078\306E\8A8D\8A3C\304C\7D42\308F\308B\3068\3001\30A2\30AF\30BB\30B9\5236\5FA1\3067\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5185\3067\30E6\30FC\30B6\30FC\304C\5B9F\884C\3067\304D\308B\64CD\4F5C\304C\6307\5B9A\3055\308C\307E\3059\3002\4E0B\306E\8868\306F\3001\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5185\3067\4F7F\7528\4E2D\306E\8A8D\8A3C\306B\57FA\3065\3044\3066\5404\7A2E\306E\30E6\30FC\30B6\30FC\306B\4ED8\4E0E\3055\308C\308B\6A29\9650\3092\793A\3057\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104675069108308979)
,p_name=>'ACL_TABLE.MAINTAIN_ACL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30BB\30B9\5236\5FA1\30EA\30B9\30C8\306E\4FDD\6301')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104674127231308978)
,p_name=>'ACL_TABLE.RUN_AND_VIEW'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9F\884C\304A\3088\3073\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104673849252308978)
,p_name=>'ACL_TABLE.UPDATE_APP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30D7\30ED\30D1\30C6\30A3\306E\66F4\65B0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104291177924308676)
,p_name=>'ACTIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104672752405308977)
,p_name=>'ACTION_MENU_SETTINGS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC\306E\8A2D\5B9A')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103594402736308084)
,p_name=>'ACTIVE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30C6\30A3\30D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103984560373308424)
,p_name=>'ACTIVITY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30C6\30A3\30D3\30C6\30A3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104026223381308456)
,p_name=>'ACTIVITY_SUMMARY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30C6\30A3\30D3\30C6\30A3\30FB\30B5\30DE\30EA\30FC')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104226831483308629)
,p_name=>'ADDED_BY'
,p_message_language=>'ja'
,p_message_text=>unistr('\8FFD\52A0\5143')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104669156635308974)
,p_name=>'ADDED_TO_PURGE_LIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30FC\30B8\30FB\30EA\30B9\30C8\306B\8FFD\52A0\6E08')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104284050932308670)
,p_name=>'ADDITIONAL_INFORMATION_REQUESTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30AF\30A8\30B9\30C8\3055\308C\305F\8FFD\52A0\60C5\5831')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103944352353308393)
,p_name=>'ADD_ARGUEMENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5F15\6570\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103934733821308386)
,p_name=>'ADD_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104132020468308543)
,p_name=>'ADD_COLUMN_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217%0\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103773982875308226)
,p_name=>'ADD_CONSTRAINT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5236\7D04\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103932878952308384)
,p_name=>'ADD_MORE...'
,p_message_language=>'ja'
,p_message_text=>unistr('\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103998637677308434)
,p_name=>'ADD_ROW'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104137104736308547)
,p_name=>'ADD_USER_INTERFACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\306E\8FFD\52A0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104140615309308550)
,p_name=>'ADJUST_PROVISIONED_SPACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30D3\30B8\30E7\30CB\30F3\30B0\6E08\9818\57DF\3092%0MB\3054\3068\306B\8ABF\6574')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103931538988308383)
,p_name=>'ADMIN'
,p_message_language=>'ja'
,p_message_text=>unistr('\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103520394494308030)
,p_name=>'ADMIN.WORKSPACE_BANNER_COLOR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D0\30CA\30FC\306E\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103520141004308030)
,p_name=>'ADMIN.WORKSPACE_BANNER_ENABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\74B0\5883\30D0\30CA\30FC\306E\6709\52B9\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103520232690308030)
,p_name=>'ADMIN.WORKSPACE_BANNER_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D0\30CA\30FC\30FB\30E9\30D9\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103939530691308389)
,p_name=>'ADMIN.WORKSPACE_BANNER_POS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D0\30CA\30FC\306E\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103578352913308072)
,p_name=>'ADMINISTRATOR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\7BA1\7406\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104026092226308455)
,p_name=>'ADMINISTRATORS'
,p_message_language=>'ja'
,p_message_text=>unistr('\7BA1\7406\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103938276990308388)
,p_name=>'ADMIN_EMAIL_MUST_BE_PROV'
,p_message_language=>'ja'
,p_message_text=>unistr('\7BA1\7406\8005\306E\96FB\5B50\30E1\30FC\30EB\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104090504690308509)
,p_name=>'ADVISOR.CATEGORY.ACCESSIBILITY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30BB\30B7\30D3\30EA\30C6\30A3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103600808615308088)
,p_name=>'ADVISOR.CATEGORY.ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103601175346308089)
,p_name=>'ADVISOR.CATEGORY.PERFORMANCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30D5\30A9\30FC\30DE\30F3\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103601203856308089)
,p_name=>'ADVISOR.CATEGORY.QA'
,p_message_language=>'ja'
,p_message_text=>unistr('\54C1\8CEA\4FDD\8A3C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103600964202308088)
,p_name=>'ADVISOR.CATEGORY.SECURITY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30AD\30E5\30EA\30C6\30A3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103601302849308089)
,p_name=>'ADVISOR.CATEGORY.USABILITY'
,p_message_language=>'ja'
,p_message_text=>unistr('\6709\7528\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103601051800308088)
,p_name=>'ADVISOR.CATEGORY.WARNING'
,p_message_language=>'ja'
,p_message_text=>unistr('\8B66\544A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104195545656308606)
,p_name=>'ADVISOR.CHECK.AJAX_ITEMS_WITH_SSP.MSG_AJAX_ITEMS_WITH_SSP.DA'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0"%1"\304C\4FDD\8B77\3055\308C\3001Ajax\30B3\30FC\30EB\3092\4ECB\3057\3066\8A2D\5B9A\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104195625218308606)
,p_name=>'ADVISOR.CHECK.AJAX_ITEMS_WITH_SSP.MSG_AJAX_ITEMS_WITH_SSP.ITEM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0"%1"\304C\4FDD\8B77\3055\308C\3001Ajax\30B3\30FC\30EB\3092\4ECB\3057\3066\8A2D\5B9A\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104224924878308628)
,p_name=>'ADVISOR.CHECK.AJAX_ITEMS_WITH_SSP.MSG_AJAX_ITEMS_WITH_SSP.REGION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0"%1"\304C\4FDD\8B77\3055\308C\3001Ajax\30B3\30FC\30EB\3092\4ECB\3057\3066\8A2D\5B9A\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103627242143308107)
,p_name=>'ADVISOR.CHECK.APEX_CODE_SMELL.MSG_MISSING_SYS_PREFIX'
,p_message_language=>'ja'
,p_message_text=>unistr('SYS\30B9\30AD\30FC\30DE\63A5\982D\8F9E\304C\3042\308A\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104331288844308705)
,p_name=>'ADVISOR.CHECK.APEX_CODE_SMELL.MSG_WWV_FLOW'
,p_message_language=>'ja'
,p_message_text=>unistr('WWV_FLOW API\306E\4F7F\7528\72B6\6CC1(\304B\308F\308A\306BAPEX API\3092\4F7F\7528)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104281591510308668)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_IG_COLUMN_NOT_EXISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217%0\306F\30EA\30FC\30B8\30E7\30F3\30FB\30BD\30FC\30B9\306ESQL\6587\306B\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103610960142308096)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_IR_FILTER_NOT_EXISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\306E\5217%0\306F\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103608667968308094)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_NOT_EXISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103588951612308079)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_REGION_COLUMN_NOT_EXISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217%0\306F\30EA\30FC\30B8\30E7\30F3\30FB\30BD\30FC\30B9\306ESQL\6587\306B\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104361347615308727)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_TABFORM_COLUMN_NOT_EXISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\5F62\5F0F\306E\5217%0\306F\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103608708508308094)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_WRONG_REFERENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\307E\305F\306F\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\540D\3068\3057\3066\53C2\7167\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104743908896309037)
,p_name=>'ADVISOR.CHECK.AUTHORIZATION.MSG_NO_APP_PROC_AUTHORIZATION'
,p_message_language=>'ja'
,p_message_text=>unistr('Ajax\30B3\30FC\30EB\30D0\30C3\30AF\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30D7\30ED\30BB\30B9\306F\3001\8A8D\53EF\30B9\30AD\30FC\30E0\306B\3088\3063\3066\4FDD\8B77\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104743569509309037)
,p_name=>'ADVISOR.CHECK.AUTHORIZATION.MSG_NO_PAGE_AUTHORIZATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306F\3001\8A8D\53EF\30B9\30AD\30FC\30E0\306B\3088\3063\3066\4FDD\8B77\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103609658449308095)
,p_name=>'ADVISOR.CHECK.AUTHORIZATION.MSG_NO_TARGET_AUTH_DEFINED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30FC\30B2\30C3\30C8\30FB\30DA\30FC\30B8%1(\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3%0\5185)\306B\8A8D\53EF\30B9\30AD\30FC\30E0\304C\5B9A\7FA9\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104745252027309039)
,p_name=>'ADVISOR.CHECK.AUTHORIZATION.MSG_PARENT_PAGE_AUTH_DIFFERENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DA\30FC\30B8\306E\8A8D\53EF\306F\3001\89AA\30DA\30FC\30B8%0\306E\8A8D\53EF"%1"\3068\7570\306A\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103609768163308095)
,p_name=>'ADVISOR.CHECK.AUTHORIZATION.MSG_TARGET_AUTH_DIFFERENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30FC\30B2\30C3\30C8\30FB\30DA\30FC\30B8\306E\8A8D\53EF"%0"\306F\3001"%1"\3068\7570\306A\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103608264188308094)
,p_name=>'ADVISOR.CHECK.BIND_VARIABLE_SYNTAX.MSG_NOT_EXISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103608114579308094)
,p_name=>'ADVISOR.CHECK.BIND_VARIABLE_SYNTAX.MSG_UNKNOWN_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D0\30A4\30F3\30C9\5909\6570\69CB\6587\306E\30C1\30A7\30C3\30AF\3092\5B9F\884C\3067\304D\307E\305B\3093\3067\3057\305F\3002\30A8\30E9\30FC: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103608382641308094)
,p_name=>'ADVISOR.CHECK.BIND_VARIABLE_SYNTAX.MSG_WRONG_REFERENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\30D0\30A4\30F3\30C9\5909\6570\69CB\6587\3067\53C2\7167\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103610329826308095)
,p_name=>'ADVISOR.CHECK.BRANCH_SEQUENCE.MSG_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\4ED6\306E\30D6\30E9\30F3\30C1\306E\524D\306E\6761\4EF6\306A\3057\30D6\30E9\30F3\30C1\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104743345339309037)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_AUTOCOMPLETE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30B9\30EF\30FC\30C9\30FB\30A2\30A4\30C6\30E0\3092\542B\3080\30DA\30FC\30B8\306F\3001\30AA\30FC\30C8\30B3\30F3\30D7\30EA\30FC\30C8\304C\300C\30AA\30F3\300D\306B\8A2D\5B9A\3055\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104743431161309037)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_BROWSER_CACHE'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\30AD\30E3\30C3\30B7\30E5\300D\306B\3088\3063\3066\30D6\30E9\30A6\30B6\3067\306E\6A5F\5BC6\30C7\30FC\30BF\306E\30AD\30E3\30C3\30B7\30E5\304C\53EF\80FD\306B\306A\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104543061967308870)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_BROWSER_FRAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\30D5\30EC\30FC\30E0\3078\306E\57CB\8FBC\307F\300D\306B\3088\3063\3066\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306F\30AF\30EA\30C3\30AF\30B8\30E3\30C3\30AF\653B\6483\3092\53D7\3051\3084\3059\304F\306A\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104543148633308870)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_HTML_ESCAPING_MODE'
,p_message_language=>'ja'
,p_message_text=>unistr('\300CHTML\30A8\30B9\30B1\30FC\30D7\30FB\30E2\30FC\30C9\300D\3067\306F\3001\9650\3089\308C\305F\6587\5B57\306E\30BB\30C3\30C8\306E\307F\3092\30A8\30B9\30B1\30FC\30D7\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103531607974308038)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_ITEM_OUTPUT_ESCAPING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\3067\306F\3001\30AF\30ED\30B9\30B5\30A4\30C8\30FB\30B9\30AF\30EA\30D7\30C6\30A3\30F3\30B0\653B\6483(XSS)\3092\9632\3050\305F\3081\306B\7279\6B8A\6587\5B57\3092\30A8\30B9\30B1\30FC\30D7\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104550189772308875)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_REFERRER_POLICY'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('HTTP\300C\30EA\30D5\30A1\30E9\300D\30EA\30AF\30A8\30B9\30C8\30FB\30D8\30C3\30C0\30FC\306B\3088\3063\3066\3001\6A5F\5BC6\6027\306E\9AD8\3044\30BB\30C3\30B7\30E7\30F3\60C5\5831\304C\30B5\30FC\30C9\30FB\30D1\30FC\30C6\30A3\306B\6F0F\6D29\3059\308B\53EF\80FD\6027\304C\3042\308A\307E\3059\3002'),
unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\306F\300C\30EA\30D5\30A1\30E9\30FB\30DD\30EA\30B7\30FC\300D\3092\300Cstrict-origin\300D\306B\8A2D\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103547748790308050)
,p_name=>'ADVISOR.CHECK.BUTTON_DA_COMPATIBLE.MSG_ID_FOUND_IN_ATTRIBUTES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\52D5\7684\30A2\30AF\30B7\30E7\30F3(%0)\3067\53C2\7167\3055\308C\3066\3044\308B\30DC\30BF\30F3\306E\30DC\30BF\30F3\5C5E\6027\306BID\304C\691C\51FA\3055\308C\307E\3057\305F\3002 '),
'',
unistr('\30DC\30BF\30F3\5C5E\6027\3067ID\304C\5B9A\7FA9\3055\308C\3066\3044\308B\3068\3001\30DC\30BF\30F3\3092\53C2\7167\3059\308B\52D5\7684\30A2\30AF\30B7\30E7\30F3\304C\52D5\4F5C\3057\307E\305B\3093\3002\30DC\30BF\30F3\306F\30C7\30D5\30A9\30EB\30C8\3067ID\3092\751F\6210\3059\308B\305F\3081\3001\3053\306EID\3092\524A\9664\3057\3066\304F\3060\3055\3044\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103547810769308050)
,p_name=>'ADVISOR.CHECK.BUTTON_DA_COMPATIBLE.MSG_TEMPLATE_BUTTON_NO_BUTTON_ID'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\52D5\7684\30A2\30AF\30B7\30E7\30F3(%0)\3067\53C2\7167\3055\308C\3066\3044\308B\30DC\30BF\30F3\304C\4F7F\7528\3059\308B\30DC\30BF\30F3\30C6\30F3\30D7\30EC\30FC\30C8\306B\3001#BUTTON_ID#\7F6E\63DB\6587\5B57\5217\304C\542B\307E\308C\3066\3044\307E\305B\3093\3002'),
'',
unistr('\30C6\30F3\30D7\30EC\30FC\30C8:'),
'%1',
'',
unistr('\3053\306E\30C6\30F3\30D7\30EC\30FC\30C8\306B#BUTTON_ID#\7F6E\63DB\6587\5B57\5217\3092\8FFD\52A0\3059\308B\304B\3001\307E\305F\306F\30DC\30BF\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092#BUTTON_ID#\7F6E\63DB\6587\5B57\5217\304C\542B\307E\308C\3066\3044\308B\3082\306E\306B\5909\66F4\3057\3066\304F\3060\3055\3044\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103551139402308052)
,p_name=>'ADVISOR.CHECK.BUTTON_DA_INCONSISTENT_REFS.MSG_ACTION_NOT_DEFINED_BY_DA'
,p_message_language=>'ja'
,p_message_text=>unistr('\52D5\7684\30A2\30AF\30B7\30E7\30F3(%0)\3067\53C2\7167\3055\308C\3066\3044\308B\30DC\30BF\30F3\306E\300C\30A2\30AF\30B7\30E7\30F3\300D\304C\300C\52D5\7684\30A2\30AF\30B7\30E7\30F3\306B\3088\308B\5B9A\7FA9\300D\3067\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103557205342308057)
,p_name=>'ADVISOR.CHECK.BUTTON_DA_INCONSISTENT_REFS.MSG_NO_BUTTON_DEFINED_FOR_DA'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3(%0)\306E\300C\30A2\30AF\30B7\30E7\30F3\300D\304C\300C\52D5\7684\30A2\30AF\30B7\30E7\30F3\306B\3088\308B\5B9A\7FA9\300D\3067\3059\304C\3001\3053\306E\30DC\30BF\30F3\3092\53C2\7167\3059\308B\3001\5BFE\5FDC\3059\308B\52D5\7684\30A2\30AF\30B7\30E7\30F3\304C\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103609344926308094)
,p_name=>'ADVISOR.CHECK.CLEAR_CACHE_PAGE_NUMBER.MSG_OTHER_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AD\30E3\30C3\30B7\30E5\3092\30AF\30EA\30A2\3059\308B\30DA\30FC\30B8%0\306F\3001\30AB\30EC\30F3\30C8\307E\305F\306F\30BF\30FC\30B2\30C3\30C8\30FB\30DA\30FC\30B8%1\3067\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103608042669308094)
,p_name=>'ADVISOR.CHECK.COLUMN_SYNTAX.MSG_NOT_EXISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104717148274309014)
,p_name=>'ADVISOR.CHECK.DEPRECATED_ATTRIBUTES.MSG_ATTRIBUTE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\5C5E\6027\5024\306F\975E\63A8\5968\306B\306A\308A\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104719686353309016)
,p_name=>'ADVISOR.CHECK.DEPRECATED_ATTRIBUTES.MSG_COMPONENT_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\30FB\30BF\30A4\30D7\306F\975E\63A8\5968\306B\306A\308A\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104195771615308606)
,p_name=>'ADVISOR.CHECK.DESC_AJAX_ITEMS_WITH_SSP'
,p_message_language=>'ja'
,p_message_text=>unistr('Ajax\30B3\30FC\30EB\306E\4FDD\8B77\3055\308C\305F\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103627110407308107)
,p_name=>'ADVISOR.CHECK.DESC_APEX_CODE_SMELL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30FC\30C9\30FB\30B9\30E1\30EB(APEX\5185\90E8)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103606118369308092)
,p_name=>'ADVISOR.CHECK.DESC_APPL_PAGE_ITEM_REF'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3001\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3001\5217\3084\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\306E\30D5\30A3\30EB\30BF\306E\5BA3\8A00\7684\53C2\7167')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104743289385309037)
,p_name=>'ADVISOR.CHECK.DESC_AUTHORIZATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\53EF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103605864384308092)
,p_name=>'ADVISOR.CHECK.DESC_BIND_VARIABLE_SYNTAX'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D0\30A4\30F3\30C9\5909\6570\69CB\6587\3067\306E\53C2\7167')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103607241312308093)
,p_name=>'ADVISOR.CHECK.DESC_BRANCH_SEQUENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\4ED6\306E\30D6\30E9\30F3\30C1\306E\524D\306E\6761\4EF6\306A\3057\30D6\30E9\30F3\30C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104743766763309037)
,p_name=>'ADVISOR.CHECK.DESC_BROWSER_SECURITY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30E9\30A6\30B6\30FB\30BB\30AD\30E5\30EA\30C6\30A3\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103547683593308050)
,p_name=>'ADVISOR.CHECK.DESC_BUTTON_DA_COMPATIBLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3\306F\52D5\7684\30A2\30AF\30B7\30E7\30F3\3068\4E92\63DB\6027\304C\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103557087419308057)
,p_name=>'ADVISOR.CHECK.DESC_BUTTON_DA_INCONSISTENT_REFS'
,p_message_language=>'ja'
,p_message_text=>unistr('\52D5\7684\30A2\30AF\30B7\30E7\30F3\3068\30DC\30BF\30F3\9593\306E\53C2\7167\306B\4E00\8CAB\6027\304C\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103606437003308092)
,p_name=>'ADVISOR.CHECK.DESC_CLEAR_CACHE_PAGE_NUMBER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AD\30E3\30C3\30B7\30E5\3092\30AF\30EA\30A2\3059\308B\30DA\30FC\30B8\756A\53F7\3068\30BF\30FC\30B2\30C3\30C8\307E\305F\306F\73FE\5728\306E\30DA\30FC\30B8\304C\4E00\81F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103605772991308092)
,p_name=>'ADVISOR.CHECK.DESC_COLUMN_SYNTAX'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\69CB\6587\3067\306E\53C2\7167')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104717025569309014)
,p_name=>'ADVISOR.CHECK.DESC_DEPRECATED_ATTRIBUTES'
,p_message_language=>'ja'
,p_message_text=>unistr('\975E\63A8\5968\306E\5C5E\6027\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103606753006308093)
,p_name=>'ADVISOR.CHECK.DESC_DML_PROCESSES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A7\30C3\30C1\3001DML\3001MR*\30D7\30ED\30BB\30B9\304C\6709\52B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103607106461308093)
,p_name=>'ADVISOR.CHECK.DESC_HARDCODED_APPLICATION_ID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CF\30FC\30C9\30B3\30FC\30C9\3055\308C\305F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104002885053308437)
,p_name=>'ADVISOR.CHECK.DESC_HAS_HELP_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306B\30D8\30EB\30D7\30FB\30C6\30AD\30B9\30C8\304C\3042\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104090334253308508)
,p_name=>'ADVISOR.CHECK.DESC_HAS_PAGE_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306B\30DA\30FC\30B8\30FB\30BF\30A4\30C8\30EB\304C\3042\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104114551918308528)
,p_name=>'ADVISOR.CHECK.DESC_IMAGE_ITEM_HAS_ALT'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\30A4\30E1\30FC\30B8\306E\8868\793A\300D\30A2\30A4\30C6\30E0\306B\306F\30A4\30E1\30FC\30B8ALT\30C6\30AD\30B9\30C8\304C\5B9A\7FA9\6E08\307F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104542819304308869)
,p_name=>'ADVISOR.CHECK.DESC_INSECURE_APPLICATION_DEFAULTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30C3\30AF\30FB\30C0\30A6\30F3\53EF\80FD\306A\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103605999132308092)
,p_name=>'ADVISOR.CHECK.DESC_IS_ITEM_OF_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\53C2\7167\30A2\30A4\30C6\30E0\306F\73FE\5728\306E\30DA\30FC\30B8\306B\3042\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103606003927308092)
,p_name=>'ADVISOR.CHECK.DESC_IS_ITEM_OF_TARGET_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\53C2\7167\30A2\30A4\30C6\30E0\306F\3001\30BF\30FC\30B2\30C3\30C8\30FB\30DA\30FC\30B8\306E\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104091065990308509)
,p_name=>'ADVISOR.CHECK.DESC_ITEMS_NO_CONTEXT_CHANGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3067\4E88\671F\3057\306A\3044\30B3\30F3\30C6\30AD\30B9\30C8\5909\66F4\304C\767A\751F\3057\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104091769806308510)
,p_name=>'ADVISOR.CHECK.DESC_ITEM_HAS_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306B\30E9\30D9\30EB\304C\3042\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103607415911308093)
,p_name=>'ADVISOR.CHECK.DESC_ITEM_NAME_LENGTH'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\307E\305F\306F\8868\5F62\5F0F\30D5\30A9\30FC\30E0\306E\5217\540D\306E\9577\3055')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103606217716308092)
,p_name=>'ADVISOR.CHECK.DESC_PAGE_ITEM_REF_AS_STRING'
,p_message_language=>'ja'
,p_message_text=>unistr('\6587\5B57\5217\5185\306E\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306E\53C2\7167')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103606327797308092)
,p_name=>'ADVISOR.CHECK.DESC_PAGE_NUMBER_EXISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\53C2\7167\30DA\30FC\30B8\756A\53F7\304C\5B58\5728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104090667230308509)
,p_name=>'ADVISOR.CHECK.DESC_REGION_HAS_ROW_HEADER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\306B\884C\30D8\30C3\30C0\30FC\304C\3042\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103607642355308093)
,p_name=>'ADVISOR.CHECK.DESC_REPORT_DEFAULT_ORDER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\306B\30C7\30D5\30A9\30EB\30C8\306E\9806\5E8F\304C\3042\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104743864343309037)
,p_name=>'ADVISOR.CHECK.DESC_SESSION_STATE_PROTECTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\4FDD\8B77')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103606898693308093)
,p_name=>'ADVISOR.CHECK.DESC_SQL_INJECTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\7F6E\63DB\69CB\6587\306E\4F7F\7528\304C\4E0D\9069\5207')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103605600639308092)
,p_name=>'ADVISOR.CHECK.DESC_SUBSTITUTION_SYNTAX'
,p_message_language=>'ja'
,p_message_text=>unistr('\7F6E\63DB\69CB\6587\3067\306E\53C2\7167')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103606686083308093)
,p_name=>'ADVISOR.CHECK.DESC_TARGET_PAGE_AUTH_USABILITY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30FC\30B2\30C3\30C8\30FB\30DA\30FC\30B8\306E\8A8D\53EF\304C\73FE\5728\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\3082\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104090841484308509)
,p_name=>'ADVISOR.CHECK.DESC_THEME_STYLE_IS_ACCESSIBLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB\306E\30A2\30AF\30BB\30B7\30D3\30EA\30C6\30A3\306E\30C6\30B9\30C8\6E08\307F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104185617929308597)
,p_name=>'ADVISOR.CHECK.DESC_UI_INCLUDES_COMPATIBILITY_JS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\306B\4E92\63DB\6027JavaScript\304C\542B\307E\308C\3066\3044\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103607312428308093)
,p_name=>'ADVISOR.CHECK.DESC_VALIDATION_ASSOCIATED_ITEM'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C\306E\95A2\9023\4ED8\3051\3089\308C\305F\30A2\30A4\30C6\30E0\307E\305F\306F\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103606579286308092)
,p_name=>'ADVISOR.CHECK.DESC_VALID_SQL_PLSQL_CODE'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\307E\305F\306FPL/SQL\30B3\30FC\30C9\304C\6709\52B9\304B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103607090803308093)
,p_name=>'ADVISOR.CHECK.DESC_VERIFY_CLOB_PROPERTY'
,p_message_language=>'ja'
,p_message_text=>unistr('Clob\30D7\30ED\30D1\30C6\30A3\306E\691C\8A3C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103606975868308093)
,p_name=>'ADVISOR.CHECK.DESC_V_FUNCTION_IN_SQL'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\6587\3067\4F7F\7528\3055\308C\308BV\30D5\30A1\30F3\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103607543804308093)
,p_name=>'ADVISOR.CHECK.DESC_WHEN_BUTTON_PRESSED'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\30DC\30BF\30F3\62BC\4E0B\6642\300D\5185\306E\300C\53C2\7167\30DC\30BF\30F3\300D\304C\5B58\5728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103609966034308095)
,p_name=>'ADVISOR.CHECK.DML_PROCESSES.MSG_INVALID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30D1\30A4\30EB\30FB\30A8\30E9\30FC - %0\6587: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103610207539308095)
,p_name=>'ADVISOR.CHECK.HARDCODED_APPLICATION_ID.MSG_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30F3\30AF\306B\3001\73FE\5728\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3ID\304C\30CF\30FC\30C9\30B3\30FC\30C9\5024\3068\3057\3066\542B\307E\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104002726058308437)
,p_name=>'ADVISOR.CHECK.HAS_HELP_TEXT.MSG_NOT_DEFINED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D8\30EB\30D7\30FB\30C6\30AD\30B9\30C8\304C\5B9A\7FA9\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104090497689308508)
,p_name=>'ADVISOR.CHECK.HAS_PAGE_TITLE.MSG_NOT_DEFINED'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DA\30FC\30B8\306B\306F\30DA\30FC\30B8\30FB\30BF\30A4\30C8\30EB\304C\3042\308A\307E\305B\3093\3002\30E6\30FC\30B6\30FC\304C\73FE\5728\306E\30DA\30FC\30B8\306E\5185\5BB9\3084\76EE\7684\3092\7406\89E3\3057\3084\3059\3044\3088\3046\306A\610F\5473\306E\3042\308B\30DA\30FC\30B8\30FB\30BF\30A4\30C8\30EB\3092\4ED8\3051\308B\3053\3068\304C\3001\30A2\30AF\30BB\30B7\30D3\30EA\30C6\30A3\306E\305F\3081\306B\91CD\8981\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104114675504308528)
,p_name=>'ADVISOR.CHECK.IMAGE_ITEM_HAS_ALT.MSG_NOT_DEFINED'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30A4\30C6\30E0\306B\306F\3001\30A4\30E1\30FC\30B8\306B\5FC5\8981\306A\4EE3\66FF\30C6\30AD\30B9\30C8\304C\3042\308A\307E\305B\3093\3002\3053\308C\306B\4F7F\7528\3059\308B\30C6\30AD\30B9\30C8\306F\3001\30A4\30E1\30FC\30B8\306E\5185\5BB9\3092\9069\5207\306B\8868\3057\3066\3044\308B\3082\306E\306B\3057\3001\307E\305F\30A4\30E1\30FC\30B8\306E\30B3\30F3\30C6\30AD\30B9\30C8\3067\8868\793A\3055\308C\308B\30DA\30FC\30B8\306B\8868\793A\53EF\80FD\306A\3044\305A\308C\306E\60C5\5831\3068\3082\91CD\8907\3057\306A\3044\3082\306E\306B\3059\308B\5FC5\8981\304C\3042\308A\307E\3059(\91CD\8907\56DE\907F\306E\305F\3081)\3002\30CE\30FC\30C8: \30A4\30E1\30FC\30B8\3092\30E6\30FC\30B6\30FC\304C\63D0\4F9B\3059\308B\5834\5408\306F\3001\30A4\30E1\30FC\30B8\4EE3\66FF\30C6\30AD\30B9\30C8\3082\30E6\30FC\30B6\30FC\304C\63D0\4F9B\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\305D\306E\969B\306F\3001\30E6\30FC\30B6\30FC\304C\9AD8\54C1\8CEA\306A\30C6\30AD\30B9\30C8\3092\63D0\4F9B\3067\304D\308B\3088\3046\306B\9069\5207\306A\30AC\30A4\30C0\30F3\30B9\304C\5FC5\8981\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104542977873308869)
,p_name=>'ADVISOR.CHECK.INSECURE_APPLICATION_DEFAULTS.MSG_RUNTIME_API_USAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\30E9\30F3\30BF\30A4\30E0API\306E\4F7F\7528\72B6\6CC1\300D\3067\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3068\30EF\30FC\30AF\30B9\30DA\30FC\30B9\3092\5909\66F4\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103608408742308094)
,p_name=>'ADVISOR.CHECK.IS_ITEM_OF_PAGE.MSG_NOT_ITEM_OF_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\3001\30DA\30FC\30B8%1\306E\30A2\30A4\30C6\30E0\3067\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103608521434308094)
,p_name=>'ADVISOR.CHECK.IS_ITEM_OF_TARGET_PAGE.MSG_NOT_ITEM_OF_TARGET_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\3001\30BF\30FC\30B2\30C3\30C8\30FB\30DA\30FC\30B8%1\306E\30A2\30A4\30C6\30E0\3067\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104091142105308509)
,p_name=>'ADVISOR.CHECK.ITEMS_NO_CONTEXT_CHANGE.MSG_CAUSES_CHANGE_OF_CONTEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306E\8A2D\5B9A\300C\9078\629E\6642\306E\30DA\30FC\30B8\30FB\30A2\30AF\30B7\30E7\30F3\300D\3067\306F\3001\30E6\30FC\30B6\30FC\306E\30B3\30F3\30C6\30AD\30B9\30C8\304C\4E88\671F\305B\305A\5909\66F4\3055\308C\308B\53EF\80FD\6027\304C\3042\308A\307E\3059\3002\30B3\30F3\30C6\30AD\30B9\30C8\304C\5909\66F4\3055\308C\308B\3053\3068\304C\306A\3044\3088\3046\306B\300C\306A\3057\300D\306B\5207\308A\66FF\3048\3001\3053\306E\6A5F\80FD\3092\52D5\7684\30A2\30AF\30B7\30E7\30F3\3084\30AB\30B9\30B1\30FC\30C9LOV\3067\7F6E\304D\63DB\3048\308B(\540C\3058\30DA\30FC\30B8\306B\7559\307E\308B\5FC5\8981\304C\3042\308B\5834\5408)\3053\3068\3092\691C\8A0E\3057\3066\304F\3060\3055\3044\3002\3042\308B\3044\306F\3001\5909\66F4\3055\308C\308B\3053\3068\304C\4E8B\524D\306B\30E6\30FC\30B6\30FC\306B\308F\304B\308B\3088\3046\306B\3001\30E6\30FC\30B6\30FC\306B\60C5\5831\3092\63D0\4F9B\3059\308B(\305F\3068\3048\3070\3001\30E9\30D9\30EB\306B\300C\65B0\3057\3044\30DA\30FC\30B8\304C\958B\304B\308C\308B\300D\3068\8FFD\52A0\3059\308B)\3053\3068\3092\691C\8A0E\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104114444712308528)
,p_name=>'ADVISOR.CHECK.ITEM_HAS_LABEL.MSG_NO_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306E\30E9\30D9\30EB\3092\5B9A\7FA9\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\8868\793A\53EF\80FD\306A\30E9\30D9\30EB\3092\975E\8868\793A\306B\3059\308B\5834\5408\3067\3082\3001\30E9\30D9\30EB\3092\5B9A\7FA9\3057\3066\304B\3089\3001\300C\975E\8868\793A\300D\30E9\30D9\30EB\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\9078\629E\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104091820611308510)
,p_name=>'ADVISOR.CHECK.ITEM_HAS_LABEL.MSG_PLACEHOLDER_BUT_NO_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30A4\30C6\30E0\306F\300CValue Placeholder\300D\3068\3044\3046\5024\3092\5B9A\7FA9\3057\3066\3044\307E\3059\304C\3001\30E9\30D9\30EB\3092\5B9A\7FA9\3057\3066\3044\307E\305B\3093\3002\30D7\30EC\30FC\30B9\30DB\30EB\30C0\30FB\30C6\30AD\30B9\30C8\306F\3001\30A2\30A4\30C6\30E0\306E\30E9\30D9\30EB\4ED8\3051\306E\307F\3092\76EE\7684\3068\3057\3066\4F7F\7528\3057\306A\3044\3067\304F\3060\3055\3044\3002\3053\308C\306F\30A2\30AF\30BB\30B7\30D3\30EA\30C6\30A3\306E\554F\984C\306E\539F\56E0\3068\306A\308A\307E\3059\3002\30A2\30AF\30BB\30B7\30D3\30EA\30C6\30A3\3092\5411\4E0A\3055\305B\308B\305F\3081\306B\3001\30A2\30A4\30C6\30E0\30FB\30E9\30D9\30EB\3092\5B9A\7FA9\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\8868\793A\53EF\80FD\306A\30E9\30D9\30EB\3092\975E\8868\793A\306B\3059\308B\5834\5408\3067\3082\3001\30E9\30D9\30EB\3092\5B9A\7FA9\3057\3066\304B\3089\3001\300C\975E\8868\793A\300D\30E9\30D9\30EB\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\9078\629E\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103610634851308095)
,p_name=>'ADVISOR.CHECK.ITEM_NAME_LENGTH.MSG_TOO_LONG'
,p_message_language=>'ja'
,p_message_text=>unistr('\540D\524D\306F%0\6587\5B57\306E\9577\3055\304C\3042\308A\307E\3059\304C\3001\6700\5927\9577\306F30\6587\5B57\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103608817237308094)
,p_name=>'ADVISOR.CHECK.PAGE_ITEM_REF_AS_STRING.MSG_NOT_EXISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\5B58\5728\3057\306A\3044\53EF\80FD\6027\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103608998639308094)
,p_name=>'ADVISOR.CHECK.PAGE_ITEM_REF_AS_STRING.MSG_WRONG_REFERENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\3001\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3067\306A\3044\53EF\80FD\6027\304C\3042\308A\307E\3059')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103609231074308094)
,p_name=>'ADVISOR.CHECK.PAGE_NUMBER_EXISTS.MSG_CLEAR_CACHE_NOT_EXISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AD\30E3\30C3\30B7\30E5\3092\30AF\30EA\30A2\3059\308B\30DA\30FC\30B8%1(\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3%0\5185)\306F\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103609033147308094)
,p_name=>'ADVISOR.CHECK.PAGE_NUMBER_EXISTS.MSG_NOT_EXISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8%0\306F\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103609179722308094)
,p_name=>'ADVISOR.CHECK.PAGE_NUMBER_EXISTS.MSG_TARGET_NOT_EXISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30FC\30B2\30C3\30C8\30FB\30DA\30FC\30B8%1(\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3%0\5185)\306F\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104017993668308449)
,p_name=>'ADVISOR.CHECK.REGION_HAS_ROW_HEADER.MSG_COL_TOGGLE_NOT_DEFINED'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\300C\5217\5207\66FF\3048\300D\30EA\30FC\30B8\30E7\30F3\306B\306F\3001\300C\884C\30D8\30C3\30C0\30FC\3068\3057\3066\4F7F\7528\300D\304C\300C\306F\3044\300D\306B\8A2D\5B9A\3055\308C\305F\5217\304C\3042\308A\307E\305B\3093\3002\884C\30D8\30C3\30C0\30FC\5217\306F\3001\73FE\5728\306E\884C\3092\6700\3082\6B63\78BA\306B\8B58\5225\3059\308B\5217\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059(\9867\5BA2\60C5\5831\306E\30EC\30DD\30FC\30C8\306E\9867\5BA2\540D\306A\3069)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104018047879308449)
,p_name=>'ADVISOR.CHECK.REGION_HAS_ROW_HEADER.MSG_REFLOW_NOT_DEFINED'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\300C\30EA\30D5\30ED\30FC\300D\30EA\30FC\30B8\30E7\30F3\306B\306F\3001\300C\884C\30D8\30C3\30C0\30FC\3068\3057\3066\4F7F\7528\300D\304C\300C\306F\3044\300D\306B\8A2D\5B9A\3055\308C\305F\5217\304C\3042\308A\307E\305B\3093\3002\884C\30D8\30C3\30C0\30FC\5217\306F\3001\73FE\5728\306E\884C\3092\6700\3082\6B63\78BA\306B\8B58\5225\3059\308B\5217\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059(\9867\5BA2\60C5\5831\306E\30EC\30DD\30FC\30C8\306E\9867\5BA2\540D\306A\3069)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104090712459308509)
,p_name=>'ADVISOR.CHECK.REGION_HAS_ROW_HEADER.MSG_TABFORM_NOT_DEFINED'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\300C\8868\5F62\5F0F\30D5\30A9\30FC\30E0\300D\30EA\30FC\30B8\30E7\30F3\306B\306F\3001\300C\884C\30D8\30C3\30C0\30FC\3068\3057\3066\4F7F\7528\300D\304C\300C\306F\3044\300D\306B\8A2D\5B9A\3055\308C\305F\5217\304C\3042\308A\307E\305B\3093\3002\884C\30D8\30C3\30C0\30FC\5217\306F\3001\73FE\5728\306E\884C\3092\6700\3082\6B63\78BA\306B\8B58\5225\3059\308B\5217\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059(\9867\5BA2\60C5\5831\306E\8868\306E\9867\5BA2\540D\306A\3069)\3002\3053\306E\60C5\5831\306F\3001\8868\5F62\5F0F\30D5\30A9\30FC\30E0\306E\30EC\30F3\30C0\30EA\30F3\30B0\6642\306B\3001\5404\884C\306E\30D5\30A9\30FC\30E0\30FB\30D5\30A3\30FC\30EB\30C9\306B\4E00\610F\306E\30E9\30D9\30EB\3092\63D0\4F9B\3059\308B\305F\3081\306B\4F7F\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103610844789308096)
,p_name=>'ADVISOR.CHECK.REPORT_DEFAULT_ORDER.MSG_NO_DEFAULT_ORDER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\306B\30C7\30D5\30A9\30EB\30C8\306E\9806\5E8F\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104543261263308870)
,p_name=>'ADVISOR.CHECK.SESSION_STATE_PROTECTION.MSG_BOOKMARK_CHECKSUM_FUNCTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\30D6\30C3\30AF\30DE\30FC\30AF\30FB\30CF\30C3\30B7\30E5\95A2\6570\300D\306F\30EC\30AC\30B7\30FC\30FB\30A2\30EB\30B4\30EA\30BA\30E0\306B\8A2D\5B9A\3055\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104543387716308870)
,p_name=>'ADVISOR.CHECK.SESSION_STATE_PROTECTION.MSG_NO_APP_PROTECTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\4FDD\8B77\300D\304C\7121\52B9\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104743639953309037)
,p_name=>'ADVISOR.CHECK.SESSION_STATE_PROTECTION.MSG_NO_PAGE_PROTECTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A7\30C3\30C1\30FB\30D7\30ED\30BB\30B9\3092\4F7F\7528\3057\305F\30DA\30FC\30B8\306E\5834\5408\3001\30DA\30FC\30B8\30FB\30A2\30AF\30BB\30B9\4FDD\8B77\3092\4F7F\7528\3057\3066\3001URL\3092\4ECB\3057\3066\6E21\3059\30A2\30A4\30C6\30E0\306E\4FDD\8B77\3092\6709\52B9\306B\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103580447614308073)
,p_name=>'ADVISOR.CHECK.SESSION_STATE_PROTECTION.MSG_NO_PREPARE_URL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\306B\3001APEX_UTIL.PREPARE_URL\3092\4ECB\3057\3066\6E21\3055\308C\306A\3044"f?p" URL\304C\542B\307E\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103610045451308095)
,p_name=>'ADVISOR.CHECK.SQL_INJECTION.MSG_ITEM_SUBSTITUTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\53EF\80FD\6027\306E\3042\308BSQL\30A4\30F3\30B8\30A7\30AF\30B7\30E7\30F3\304C\691C\51FA\3055\308C\307E\3057\305F\3002SQL\3001PL/SQL\30B3\30FC\30C9\306E\7F6E\63DB\69CB\6587\307E\305F\306F\30D7\30ED\30BB\30B9\8868\540D\306B%0\304C\4F7F\7528\3055\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103607855209308093)
,p_name=>'ADVISOR.CHECK.SUBSTITUTION_SYNTAX.MSG_NOT_EXISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103607947432308093)
,p_name=>'ADVISOR.CHECK.SUBSTITUTION_SYNTAX.MSG_WRONG_REFERENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\7F6E\63DB\69CB\6587\3067\53C2\7167\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103609832362308095)
,p_name=>'ADVISOR.CHECK.TARGET_PAGE_AUTH_USABILITY.MSG_NO_AUTH_DEFINED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30FC\30B2\30C3\30C8\30FB\30DA\30FC\30B8%1(\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3%0\5185)\306B\8A8D\53EF\30B9\30AD\30FC\30E0\304C\5B9A\7FA9\3055\308C\3066\3044\307E\3059\304C\3001\73FE\5728\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\306F\5B9A\7FA9\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104090912149308509)
,p_name=>'ADVISOR.CHECK.THEME_STYLE_IS_ACCESSIBLE.MSG_NOT_ACCESSIBLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\73FE\5728\306E\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB\306F\3001\30A2\30AF\30BB\30B7\30D3\30EA\30C6\30A3\306B\3064\3044\3066\30C6\30B9\30C8\3055\308C\3066\3044\307E\305B\3093\3002\300C\30C6\30B9\30C8\3055\308C\305F\30A2\30AF\30BB\30B7\30D3\30EA\30C6\30A3\300D\304C\300C\306F\3044\300D\306B\8A2D\5B9A\3055\308C\3066\3044\308B\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB\306B\5207\308A\66FF\3048\308B\304B\3001\73FE\5728\306E\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB\304C\30C6\30B9\30C8\3055\308C\3066\3044\308B\5834\5408\306F\300C\30C6\30FC\30DE\300D\8A2D\5B9A\3067\300C\30C6\30B9\30C8\3055\308C\305F\30A2\30AF\30BB\30B7\30D3\30EA\30C6\30A3\300D\5C5E\6027\3092\300C\306F\3044\300D\306B\8A2D\5B9A\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104185891231308598)
,p_name=>'ADVISOR.CHECK.UI_INCLUDES_COMPATIBILITY_JS.MSG_JQUERY_MIGRATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\306BjQuery Migrate\304C\542B\307E\308C\3066\3044\307E\3059\3002jQuery Migrate\3067\306F\3001\524A\9664\6E08\306EAPI\3092\30EA\30B9\30C8\30A2\3059\308B\3053\3068\306B\3088\3063\3066\65B0\3057\3044\30D0\30FC\30B8\30E7\30F3\306EjQuery\3078\306E\79FB\884C\304C\5BB9\6613\306B\306A\308A\3001\524A\9664\6E08\306EAPI\3084\975E\63A8\5968API\3092\4F7F\7528\3059\308B\3068\3001\30D6\30E9\30A6\30B6\30FB\30B3\30F3\30BD\30FC\30EB\306B\8B66\544A\304C\8868\793A\3055\308C\307E\3059\3002\3053\308C\306B\3088\308A\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\3059\3079\3066\306E\30DA\30FC\30B8\306B\8FFD\52A0\306EJavaScript\30D5\30A1\30A4\30EB\304C\7D44\307F\8FBC\307E\308C\307E\3059\3002\3053\308C\3092\524A\9664\3059\308B\305F\3081\306B\3001jQuery Migrate\306E\30A2\30C3\30D7\30B0\30EC\30FC\30C9\30FB\30AC\30A4\30C9\3067\3001\5909\66F4\304C\5FC5\8981\306AAPI\306E\8A73\7D30\3092\53C2\7167\3057\3066\304F\3060\3055\3044')
||unistr('\3002\3053\306E\3088\3046\306AAPI\3078\306E\4F9D\5B58\6027\304C\3059\3079\3066\306A\304F\306A\3063\305F\3089\3001\300CjQuery Migrate\3092\542B\3081\308B\300D\3092\300C\3044\3044\3048\300D\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104185773087308598)
,p_name=>'ADVISOR.CHECK.UI_INCLUDES_COMPATIBILITY_JS.MSG_LEGACY_JS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\306B\975E\63A8\5968\307E\305F\306F\30B5\30DD\30FC\30C8\5BFE\8C61\5916\306EJavaScript\95A2\6570\304C\542B\307E\308C\3066\3044\307E\3059\3002\3053\308C\306B\3088\308A\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\3059\3079\3066\306E\30DA\30FC\30B8\306B\8FFD\52A0\306EJavaScript\30D5\30A1\30A4\30EB\304C\7D44\307F\8FBC\307E\308C\307E\3059\3002\3053\308C\3092\524A\9664\3059\308B\305F\3081\306B\3001\30EA\30EA\30FC\30B9\30FB\30CE\30FC\30C8\306E\975E\63A8\5968\6A5F\80FD\306B\95A2\3059\308B\9805\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002\3053\306E\9805\306B\306F\3001\975E\63A8\5968\307E\305F\306F\30B5\30DD\30FC\30C8\5BFE\8C61\5916\95A2\6570\3078\306E\4F9D\5B58\6027\3092\30C1\30A7\30C3\30AF\3057\3001\3053\308C\3092\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304B\3089\7070\4E0A\3057\3066\3044\304F\65B9\6CD5\306B\95A2\3059\308B\624B\9806\304C\8A18\8F09\3055\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103610578780308095)
,p_name=>'ADVISOR.CHECK.VALIDATION_ASSOCIATED_ITEM.MSG_NOT_DEFINED'
,p_message_language=>'ja'
,p_message_text=>unistr('\95A2\9023\4ED8\3051\3089\308C\305F\30A2\30A4\30C6\30E0\3084\5217\304C\5B9A\7FA9\3055\308C\3066\3044\307E\305B\3093\304C\3001\300C\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\8868\793A\4F4D\7F6E\300D\306B\3053\308C\304C\5FC5\8981\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103610425358308095)
,p_name=>'ADVISOR.CHECK.VALIDATION_ASSOCIATED_ITEM.MSG_NOT_EQUAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\95A2\9023\4ED8\3051\3089\308C\3066\3044\308B\30A2\30A4\30C6\30E0\3084\5217\304C\3001\691C\8A3C\5F0F1\306B\6307\5B9A\3055\308C\3066\3044\308B"%0"\3068\7B49\3057\304F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103609461932308095)
,p_name=>'ADVISOR.CHECK.VALID_SQL_PLSQL_CODE.MSG_INVALID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30D1\30A4\30EB\30FB\30A8\30E9\30FC - %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103609543189308095)
,p_name=>'ADVISOR.CHECK.VALID_SQL_PLSQL_CODE.MSG_NOT_DEFINED'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\307E\305F\306FPL/SQL\30B3\30FC\30C9\304C\5B9A\7FA9\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103607755677308093)
,p_name=>'ADVISOR.CHECK.VERIFY_CLOB_PROPERTY.MSG_TOO_LONG'
,p_message_language=>'ja'
,p_message_text=>unistr('32767\3088\308A\9577\3044\304B\3002\6700\521D\306E32767\306E\307F\304C\30C1\30A7\30C3\30AF\3055\308C\307E\3059\3002\9577\3055: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103610132912308095)
,p_name=>'ADVISOR.CHECK.V_FUNCTION_IN_SQL.MSG_CONTAINS_CALL'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\6587\306BV/NV/DV\30D5\30A1\30F3\30AF\30B7\30E7\30F3\30FB\30B3\30FC\30EB\304C\542B\307E\308C\3066\3044\307E\3059(\30D1\30D5\30A9\30FC\30DE\30F3\30B9\4E0A\306E\554F\984C\3068\306A\308B\53EF\80FD\6027\304C\3042\308A\307E\3059)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103610727431308095)
,p_name=>'ADVISOR.CHECK.WHEN_BUTTON_PRESSED.MSG_NOT_EXISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\53C2\7167\3055\308C\305F\30DC\30BF\30F3\306F\3059\3067\306B\5B58\5728\3057\307E\305B\3093\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103990433205308428)
,p_name=>'AFTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\5F8C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103937725116308388)
,p_name=>'AGREEMENT_MISSING'
,p_message_language=>'ja'
,p_message_text=>unistr('\540C\610F\66F8\306E\6B20\843D')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103731801623308193)
,p_name=>'ALIAS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5225\540D')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104334064563308707)
,p_name=>'ALLOW_APP_BUILDING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\69CB\7BC9\3092\8A31\53EF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104275493424308664)
,p_name=>'ALLOW_PACKAGED_APP_INS'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\751F\7523\6027\304A\3088\3073\30B5\30F3\30D7\30EB\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30A4\30F3\30B9\30C8\30FC\30EB\3092\8A31\53EF\3057\307E\3059\3002'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104177201429308590)
,p_name=>'ALLOW_RESTFUL_SERVICES'
,p_message_language=>'ja'
,p_message_text=>unistr('RESTful\30B5\30FC\30D3\30B9\306E\4F7F\7528\306E\8A31\53EF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104334150410308707)
,p_name=>'ALLOW_SQL_WORKSHOP'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\30EF\30FC\30AF\30B7\30E7\30C3\30D7\306E\4F7F\7528\3092\8A31\53EF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104334350785308707)
,p_name=>'ALLOW_TEAM_DEVELOPMENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30FC\30E0\958B\767A\306E\4F7F\7528\3092\8A31\53EF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104333982722308707)
,p_name=>'ALLOW_TO_BE_PURGED_YN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306E\30D1\30FC\30B8\3092\8A31\53EF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104334274855308707)
,p_name=>'ALLOW_WEBSHEET_DEV'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B7\30FC\30C8\958B\767A\3092\8A31\53EF')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103751038694308208)
,p_name=>'ALL_APPLICATIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103568220102308065)
,p_name=>'ALL_APPLICATIONS_NULL_DISP'
,p_message_language=>'ja'
,p_message_text=>unistr('- \3059\3079\3066 - ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103568090621308065)
,p_name=>'ALL_CATEGORIES'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\306E\30AB\30C6\30B4\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103568356867308065)
,p_name=>'ALL_CATEGORIES_NULL_DISP'
,p_message_language=>'ja'
,p_message_text=>unistr('- \3059\3079\3066\306E\30AB\30C6\30B4\30EA -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104336665977308709)
,p_name=>'ALL_MILESTONES'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\306E\30DE\30A4\30EB\30B9\30C8\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104116058873308530)
,p_name=>'ALL_RELEASES'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\306E\30EA\30EA\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103755498977308212)
,p_name=>'ALL_STATIC_FILES'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\306E\9759\7684\30D5\30A1\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103754011509308211)
,p_name=>'ALL_THEMES'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\306E\30C6\30FC\30DE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104354782211308722)
,p_name=>'ALL_TYPES'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\306E\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104355137516308723)
,p_name=>'ALL_TYPES_NULL_DISP'
,p_message_language=>'ja'
,p_message_text=>unistr('- \3059\3079\3066\306E\30BF\30A4\30D7 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103751101949308208)
,p_name=>'ALL_USERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\306E\30E6\30FC\30B6\30FC')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104739059179309034)
,p_name=>'ALREADY_IN_ACL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\306F\3059\3067\306BAPEX\30A2\30AB\30A6\30F3\30C8\3092\6301\3063\3066\3044\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104728959420309024)
,p_name=>'ALREADY_IN_WS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\306F\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306B\3059\3067\306B\5B58\5728\3057\307E\3059')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104695326495308996)
,p_name=>'ALWAYS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5E38\6642')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104005347334308439)
,p_name=>'ANALYSIS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306E\5206\6790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104005472018308439)
,p_name=>'ANALYZE'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306B\3088\308B\5206\6790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104133051175308544)
,p_name=>'ANALYZE_TABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\30E1\30BD\30C3\30C9\3092\4F7F\7528\3057\305F\89E3\6790')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103752935170308210)
,p_name=>'ANONYMOUS_BLOCK'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\540D\30D6\30ED\30C3\30AF')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103614085679308098)
,p_name=>'ANSWERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\56DE\7B54')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103580176537308073)
,p_name=>'ANY_DEVELOPER'
,p_message_language=>'ja'
,p_message_text=>unistr('(\4EFB\610F\306E\958B\767A\8005)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104781028533309074)
,p_name=>'APEX.ACTIVITY_BY_HOUR.APPCHANGES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5909\66F4:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104780961341309074)
,p_name=>'APEX.ACTIVITY_BY_HOUR.HOUR'
,p_message_language=>'ja'
,p_message_text=>unistr('\6642\9593:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104785084474309077)
,p_name=>'APEX.ACTIVITY_BY_HOUR.K'
,p_message_language=>'ja'
,p_message_text=>'%0 K'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104781198811309074)
,p_name=>'APEX.ACTIVITY_BY_HOUR.PAGEVIEWS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30D3\30E5\30FC: ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104537782723308866)
,p_name=>'APEX.API.RUNTIME_API_USAGE.ERROR'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('API\30B3\30FC\30EB\306F\7981\6B62\3055\308C\3066\3044\307E\3059\3002'),
unistr('\7BA1\7406\8005\306B\9023\7D61\3057\3066\304F\3060\3055\3044\3002'),
unistr('\3053\306E\30A4\30F3\30B7\30C7\30F3\30C8\306E\8A73\7D30\306F\3001\30C7\30D0\30C3\30B0ID "%0"\3088\308A\53C2\7167\3067\304D\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103639398201308120)
,p_name=>'APEX.ASSERT.DESUPPORTED_API'
,p_message_language=>'ja'
,p_message_text=>unistr('API\30B3\30FC\30EB"%0"\306F\3001Application Express\30D0\30FC\30B8\30E7\30F3%1\3067\306F\30C7\30B5\30DD\30FC\30C8\3055\308C\307E\3057\305F\3002\3053\306E\30A4\30F3\30B7\30C7\30F3\30C8\306E\8A73\7D30\306F\3001\30C7\30D0\30C3\30B0ID "%2"\3088\308A\53C2\7167\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104015233634308447)
,p_name=>'APEX.AUTO_COMPLETE.NOT_IN_LIST'
,p_message_language=>'ja'
,p_message_text=>unistr('#LABEL#\306F\30EA\30B9\30C8\306B\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104292439371308676)
,p_name=>'APEX.BRANCH.SHOW_ONLY_NOT_SUPPORTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\5C02\7528\30D6\30E9\30F3\30C1\306F\3001\30DA\30FC\30B8\5C5E\6027\306E\300C\9001\4FE1\6642\306B\30EA\30ED\30FC\30C9\300D\304C\300C\6210\529F\306E\307F\300D\306B\8A2D\5B9A\3055\308C\3066\3044\308B\5834\5408\3001\30B5\30DD\30FC\30C8\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103757196875308213)
,p_name=>'APEX.BRANCH.UNHANDLED_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30E9\30F3\30C1\306E\51E6\7406\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103546494927308049)
,p_name=>'APEX.COMPUTATION.UNHANDLED_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A08\7B97\51E6\7406\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103737210064308197)
,p_name=>'APEX.CONDITION.UNHANDLED_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\6761\4EF6\306E\51E6\7406\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103788727098308238)
,p_name=>'APEX.CONDITION.UNKNOWN_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0D\660E\306E\6761\4EF6\30BF\30A4\30D7"%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103542445494308046)
,p_name=>'APEX.DATA.LOAD.INVALID_FILE_BROWSE_ITEM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\53C2\7167\30A2\30A4\30C6\30E0%0\306F\3001APEX_APPLICATION_TEMP_FILES\8868\3092\4F7F\7528\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103519878975308030)
,p_name=>'APEX.DATA.LOAD.MERGE_NOT_ALLOWED_FOR_COLLECTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\30DE\30FC\30B8\300D\30ED\30FC\30C9\30FB\30BF\30A4\30D7\306F\3001\30B3\30EC\30AF\30B7\30E7\30F3\3078\306E\30ED\30FC\30C9\3067\306F\30B5\30DD\30FC\30C8\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104673046173308977)
,p_name=>'APEX.DATA.LOAD.MERGE_REQUIRES_PRIMARY_KEY'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\30DE\30FC\30B8\300D\30ED\30FC\30C9\30FB\30BF\30A4\30D7\306B\306F\3001\30C7\30FC\30BF\30FB\30D7\30ED\30D5\30A1\30A4\30EB\306B\5C11\306A\304F\3068\30821\3064\306E\4E3B\30AD\30FC\5217\304C\5FC5\8981\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104672820742308977)
,p_name=>'APEX.DATA.LOAD.SQL_QUERY_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BD\30FC\30B9SQL\554F\5408\305B\306E\30ED\30FC\30C9\3092\89E3\6790\3067\304D\307E\305B\3093: %0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104672911468308977)
,p_name=>'APEX.DATA.LOAD.SQL_QUERY_RETURNS_WRONG_DATA_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BD\30FC\30B9SQL\554F\5408\305B\306E\30ED\30FC\30C9\306FVARCHAR2\3001CLOB\307E\305F\306FBLOB\3092\8FD4\3059\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103950120380308398)
,p_name=>'APEX.DIALOG.PAGE.ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3%0\306E\30C0\30A4\30A2\30ED\30B0\30FB\30DA\30FC\30B8%1\3092\6B63\5E38\306B\30EC\30F3\30C0\30EA\30F3\30B0\3067\304D\307E\305B\3093\3002\30DA\30FC\30B8%1\3067\4F7F\7528\3055\308C\3066\3044\308B\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306E\30C6\30F3\30D7\30EC\30FC\30C8\30FB\30BF\30A4\30D7\304C\30C0\30A4\30A2\30ED\30B0\30FB\30DA\30FC\30B8\3067\3001\9069\5207\306AJavaScript\30C0\30A4\30A2\30ED\30B0\521D\671F\5316\3001\30C0\30A4\30A2\30ED\30B0\30FB\30AF\30ED\30FC\30BA\304A\3088\3073\30C0\30A4\30A2\30ED\30B0\53D6\6D88\306E\30B3\30FC\30C9\304C\5B9A\7FA9\3055\308C\3066\3044\308B\3053\3068\3092\78BA\8A8D\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104770049228309066)
,p_name=>'APEX.EMAIL.COPYRIGHT'
,p_message_language=>'ja'
,p_message_text=>'Copyright &copy; %0, All rights reserved.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104770887819309066)
,p_name=>'APEX.EMAIL.CREATE_WORKSPACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104769941915309066)
,p_name=>'APEX.EMAIL.DISCLAIMER'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\308C\306F\30B7\30B9\30C6\30E0\751F\6210\306E\30E1\30C3\30BB\30FC\30B8\3067\3059\3002\3053\306E\30E1\30C3\30BB\30FC\30B8\306B\8FD4\4FE1\3057\306A\3044\3067\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104778471148309072)
,p_name=>'APEX.EMAIL.ENVIRONMENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\74B0\5883')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104789004182309080)
,p_name=>'APEX.EMAIL.GENERIC_USER'
,p_message_language=>'ja'
,p_message_text=>unistr('Oracle Application Express\30E6\30FC\30B6\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104771473026309067)
,p_name=>'APEX.EMAIL.GET_STARTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\306F\3058\3081\306B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104770129102309066)
,p_name=>'APEX.EMAIL.GREETING'
,p_message_language=>'ja'
,p_message_text=>unistr('\3088\3046\3053\305D\3001%0\3055\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104771120379309067)
,p_name=>'APEX.EMAIL.PASSWORD'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30B9\30EF\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104778568526309072)
,p_name=>'APEX.EMAIL.PREVENT_PURGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306E\30D1\30FC\30B8\306E\9632\6B62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104771351841309067)
,p_name=>'APEX.EMAIL.PURGE.BODY'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3057\3066\753B\9762\4E0A\306E\6307\793A\306B\5F93\3046\3053\3068\3067\3001\30EF\30FC\30AF\30B9\30DA\30FC\30B9\304C\30D1\30FC\30B8\3055\308C\308B\3053\3068\3092\56DE\907F\3067\304D\307E\3059\3002%0\65E5\9593\64CD\4F5C\3092\884C\308F\306A\3044\3068\3001\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306F\81EA\52D5\7684\306B\524A\9664\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104778244787309072)
,p_name=>'APEX.EMAIL.PURGE.FOOTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\304C\5FC5\8981\306A\304F\306A\3063\305F\5834\5408\3001\30A2\30AF\30B7\30E7\30F3\306F\4E0D\8981\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104778781822309072)
,p_name=>'APEX.EMAIL.PURGE.HEADING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\3092\30D1\30FC\30B8\3057\3088\3046\3068\3057\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104778047909309072)
,p_name=>'APEX.EMAIL.PURGE.INTRO'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9%0\306F\3001\6700\8FD1\306E\30A2\30AF\30C6\30A3\30D3\30C6\30A3\3092\8868\793A\3057\3066\304A\3089\305A\3001\307E\3082\306A\304F\30D1\30FC\30B8\3055\308C\308B\4E88\5B9A\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104777978774309072)
,p_name=>'APEX.EMAIL.PURGE.SUBJECT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8B66\544A\3002\30EF\30FC\30AF\30B9\30DA\30FC\30B9"%0"\3092\30D1\30FC\30B8\3057\3088\3046\3068\3057\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104778327937309072)
,p_name=>'APEX.EMAIL.PURGE_DATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30FC\30B8\65E5\4ED8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104779041610309073)
,p_name=>'APEX.EMAIL.REQUEST_ACTION_REQ'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\30FB\30EA\30AF\30A8\30B9\30C8\3092\5B8C\4E86\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104778804553309072)
,p_name=>'APEX.EMAIL.REQUEST_APPROVED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9"%0"\306E\6E96\5099\304C\5B8C\4E86\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104779107081309073)
,p_name=>'APEX.EMAIL.REQUEST_APPROVE_2'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9"%0"\306F\627F\8A8D\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104778938199309072)
,p_name=>'APEX.EMAIL.REQUEST_DECLINED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\30FB\30EA\30AF\30A8\30B9\30C8\306F\62D2\5426\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104770788987309066)
,p_name=>'APEX.EMAIL.USERNAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104778631377309072)
,p_name=>'APEX.EMAIL.WARNING'
,p_message_language=>'ja'
,p_message_text=>unistr('\8B66\544A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104770664478309066)
,p_name=>'APEX.EMAIL.WORKSPACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104770232201309066)
,p_name=>'APEX.EMAIL.WS_REQ_APPR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\30FB\30EA\30AF\30A8\30B9\30C8\306F\627F\8A8D\3055\308C\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104770916720309066)
,p_name=>'APEX.EMAIL.WS_REQ_APPR_FOOTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\627F\8A8D\30D7\30ED\30BB\30B9\3092\5B9F\884C\3057\3066\30D1\30B9\30EF\30FC\30C9\3092\8A2D\5B9A\3059\308B\306B\306F\3001\6B21\306E\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104770439467309066)
,p_name=>'APEX.EMAIL.WS_REQ_APPR_INTRO'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\30FB\30EA\30AF\30A8\30B9\30C8\306F\627F\8A8D\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104771024780309066)
,p_name=>'APEX.EMAIL.WS_REQ_APPR_READY_FOOTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\59CB\3059\308B\306B\306F\3001\6B21\306E\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104771234324309067)
,p_name=>'APEX.EMAIL.WS_REQ_APPR_READY_INTRO'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306E\6E96\5099\304C\5B8C\4E86\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104770381351309066)
,p_name=>'APEX.EMAIL.WS_REQ_DECL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\30FB\30EA\30AF\30A8\30B9\30C8\306F\62D2\5426\3055\308C\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104770548805309066)
,p_name=>'APEX.EMAIL.WS_REQ_DECL_INTRO'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\30FB\30EA\30AF\30A8\30B9\30C8\306F\62D2\5426\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103546851228308049)
,p_name=>'APEX.EXPORT.DOWNLOAD_NOT_SUPPORTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C0\30A6\30F3\30ED\30FC\30C9\306F\3001\30DA\30FC\30B8\5C5E\6027\306E\300C\9001\4FE1\6642\306B\30EA\30ED\30FC\30C9\300D\304C\300C\6210\529F\306E\307F\300D\306B\8A2D\5B9A\3055\308C\3066\3044\308B\5834\5408\3001\30B5\30DD\30FC\30C8\3055\308C\307E\305B\3093\3002\30DA\30FC\30B8\5C5E\6027\306E\300C\9001\4FE1\6642\306B\30EA\30ED\30FC\30C9\300D\3092\300C\5E38\6642\300D\306B\5909\66F4\3059\308B\304B\3001\30D8\30C3\30C0\30FC\306E\524D\30D7\30ED\30BB\30B9\3092\4F7F\7528\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104080675109308500)
,p_name=>'APEX.FEATURE.EMAIL_REPORTING.QUEUED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AD\30E5\30FC\5F85\6A5F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104080720030308500)
,p_name=>'APEX.FEATURE.EMAIL_REPORTING.SENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\9001\4FE1\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103576694239308071)
,p_name=>'APEX.FEEDBACK.FEEDBACK_ENTRIES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30FC\30C9\30D0\30C3\30AF\30FB\30A8\30F3\30C8\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103576752990308071)
,p_name=>'APEX.FEEDBACK.OPEN_FEEDBACK_ENTRIES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30FC\30D7\30F3\30FB\30D5\30A3\30FC\30C9\30D0\30C3\30AF\30FB\30A8\30F3\30C8\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103576889992308071)
,p_name=>'APEX.FEEDBACK.USERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103915810090308371)
,p_name=>'APEX.GROUP.NOT_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30EB\30FC\30D7"%0"\304C\898B\3064\304B\308A\307E\305B\3093\3067\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104750821499309043)
,p_name=>'APEX.HELP.VIEW_DOC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C9\30AD\30E5\30E1\30F3\30C8\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103658738285308135)
,p_name=>'APEX.HTTP.HEADER.DUPLICATE'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('HTTP\30D8\30C3\30C0\30FC%0\304C2\56DE\9001\4FE1\3055\308C\307E\3057\305F\3002\653B\6483\3067\3042\308B\53EF\80FD\6027\304C\3042\308A\307E\3059\3002'),
'<ul>',
unistr('<li>1\756A\76EE\306E\5024: "%1"</li>'),
unistr('<li>2\756A\76EE\306E\5024: "%2"</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103695969361308163)
,p_name=>'APEX.INSTANCE_ADMIN.BIPUB_OPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30EA\30F3\30C8\30FB\30B5\30DD\30FC\30C8\306F\3001STANDARD\3001ADVANCED\3001APEX_LISTENER\3001AOP\307E\305F\306FNONE\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103696004391308163)
,p_name=>'APEX.INSTANCE_ADMIN.FIRST_SCHEMA'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\521D\306B\30D7\30ED\30D3\30B8\30E7\30CB\30F3\30B0\3055\308C\305F\30B9\30AD\30FC\30DE\3092\524A\9664\3067\304D\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103599339897308087)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_APPLICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9\306A\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3ID\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104115495156308529)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_EMAIL_ADDRESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9\306A\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103591611652308081)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_HISTORY_DAYS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024\306F\30BC\30ED\304B\6B63\306E\6574\6570\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103696100398308163)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_PORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DD\30FC\30C8\756A\53F7\304C\7121\52B9\3067\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104143148479308552)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_SUBSCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30D6\30B9\30AF\30EA\30D7\30B7\30E7\30F3ID\304C\7121\52B9\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103696246766308163)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_WALLET'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A6\30A9\30EC\30C3\30C8\30FB\30D1\30B9\306Ffile:<filesystempath>\306E\66F8\5F0F\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103775187313308228)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_WORKSPACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\304C\898B\3064\304B\308A\307E\305B\3093\3067\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103775005609308227)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_WORKSPACE_ID'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9\306A\30EF\30FC\30AF\30B9\30DA\30FC\30B9ID\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103800485218308247)
,p_name=>'APEX.INSTANCE_ADMIN.LIMIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024\306F%0\4EE5\4E0B\306B\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103710875805308176)
,p_name=>'APEX.INSTANCE_ADMIN.PARAMETER_REGEXP_MISMATCH'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30B9\30BF\30F3\30B9\30FB\30D1\30E9\30E1\30FC\30BF"%0"\306E\5024"%1"\304C\3001\6B63\898F\8868\73FE"%2"\306B\4E00\81F4\3057\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103710799934308176)
,p_name=>'APEX.INSTANCE_ADMIN.PARAMETER_REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30B9\30BF\30F3\30B9\30FB\30D1\30E9\30E1\30FC\30BF"%0"\306B\306F\5024\304C\5FC5\8981\3067\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103696360305308163)
,p_name=>'APEX.INSTANCE_ADMIN.PARM_NOTFOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30B9\30BF\30F3\30B9\30FB\30D1\30E9\30E1\30FC\30BF\304C\898B\3064\304B\308A\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104139220498308549)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.APEX-AUTH'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30B9\30EF\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103546510271308049)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.CLOUD_IDM-AUTH'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30B9\30EF\30FC\30C9(\30EF\30FC\30AF\30B9\30DA\30FC\30B9\30FB\30E6\30FC\30B6\30FC\30FB\30A2\30AB\30A6\30F3\30C8\30FB\30EA\30DD\30B8\30C8\30EA\306B\5BFE\3057\3066\306E\307F\306E\8A8D\8A3C\7528)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104331693761308705)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.HEADER-AUTH'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30B9\30EF\30FC\30C9(\30EF\30FC\30AF\30B9\30DA\30FC\30B9\30FB\30E6\30FC\30B6\30FC\30FB\30A2\30AB\30A6\30F3\30C8\30FB\30EA\30DD\30B8\30C8\30EA\306B\5BFE\3057\3066\306E\307F\306E\8A8D\8A3C\7528)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104224815249308628)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.LDAP-AUTH'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30B9\30EF\30FC\30C9(\30EF\30FC\30AF\30B9\30DA\30FC\30B9\30FB\30E6\30FC\30B6\30FC\30FB\30A2\30AB\30A6\30F3\30C8\30FB\30EA\30DD\30B8\30C8\30EA\306B\5BFE\3057\3066\306E\307F\306E\8A8D\8A3C\7528)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103630872440308113)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.SAML-AUTH'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30B9\30EF\30FC\30C9(\30EF\30FC\30AF\30B9\30DA\30FC\30B9\30FB\30E6\30FC\30B6\30FC\30FB\30A2\30AB\30A6\30F3\30C8\30FB\30EA\30DD\30B8\30C8\30EA\306B\5BFE\3057\3066\306E\307F\306E\8A8D\8A3C\7528)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103854059242308288)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.SOCIAL-AUTH'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30B9\30EF\30FC\30C9(\30EF\30FC\30AF\30B9\30DA\30FC\30B9\30FB\30E6\30FC\30B6\30FC\30FB\30A2\30AB\30A6\30F3\30C8\30FB\30EA\30DD\30B8\30C8\30EA\306B\5BFE\3057\3066\306E\307F\306E\8A8D\8A3C\7528)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104139123433308549)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.SSO-AUTH'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30B9\30EF\30FC\30C9(\30EF\30FC\30AF\30B9\30DA\30FC\30B9\30FB\30E6\30FC\30B6\30FC\30FB\30A2\30AB\30A6\30F3\30C8\30FB\30EA\30DD\30B8\30C8\30EA\306B\5BFE\3057\3066\306E\307F\306E\8A8D\8A3C\7528)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103698270045308165)
,p_name=>'APEX.INSTANCE_ADMIN.PRINTSVR_PROTOCOL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30EA\30F3\30C8\30FB\30B5\30FC\30D0\30FC\306E\30D7\30ED\30C8\30B3\30EB\306F\3001HTTP\304BHTTPS\306E\3044\305A\308C\304B\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103698338441308165)
,p_name=>'APEX.INSTANCE_ADMIN.SCHEMA_DOES_NOT_EXIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AD\30FC\30DE\304C\5B58\5728\3057\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103698489167308165)
,p_name=>'APEX.INSTANCE_ADMIN.SCHEMA_RESTRICTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AD\30FC\30DE\306F\5236\9650\3055\308C\3066\3044\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103571770831308067)
,p_name=>'APEX.ISSUES.APPLICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103571553902308067)
,p_name=>'APEX.ISSUES.APPLICATION_NO_LONGER_EXISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306F\3059\3067\306B\5B58\5728\3057\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104376458394308739)
,p_name=>'APEX.ISSUES.ASSIGN'
,p_message_language=>'ja'
,p_message_text=>unistr('\5272\5F53\3066')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103773342676308226)
,p_name=>'APEX.ISSUES.ATTACHMENTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6DFB\4ED8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104703400440309003)
,p_name=>'APEX.ISSUES.CARDS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30FC\30C9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103577153463308071)
,p_name=>'APEX.ISSUES.CLOSED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30ED\30FC\30BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103573684409308069)
,p_name=>'APEX.ISSUES.COMMENTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30E1\30F3\30C8\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103573557139308068)
,p_name=>'APEX.ISSUES.COMMENTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30E1\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103577287014308071)
,p_name=>'APEX.ISSUES.COMPLETE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B8C\4E86')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103958613876308404)
,p_name=>'APEX.ISSUES.CREATED_THIS_ISSUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\554F\984C%0\3092\4F5C\6210\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103548217154308050)
,p_name=>'APEX.ISSUES.DELETE'
,p_message_language=>'ja'
,p_message_text=>unistr('\524A\9664')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103548091208308050)
,p_name=>'APEX.ISSUES.DELETE_COMMENT_CONFIRM'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B3\30E1\30F3\30C8\3092\524A\9664\3057\307E\3059\304B\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104360871879308727)
,p_name=>'APEX.ISSUES.DELETE_ISSUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\554F\984C\306E\524A\9664')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103557959841308057)
,p_name=>'APEX.ISSUES.DELETE_ISSUE_CONFIRM'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\554F\984C\3092\524A\9664\3057\307E\3059\304B\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103575200276308070)
,p_name=>'APEX.ISSUES.DOCUMENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C9\30AD\30E5\30E1\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103574144132308069)
,p_name=>'APEX.ISSUES.DOCUMENTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C9\30AD\30E5\30E1\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103548125703308050)
,p_name=>'APEX.ISSUES.EDIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7DE8\96C6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104488989509308830)
,p_name=>'APEX.ISSUES.EDIT_COMMENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30E1\30F3\30C8\306E\7DE8\96C6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104489094401308830)
,p_name=>'APEX.ISSUES.EDIT_ISSUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\554F\984C\306E\7DE8\96C6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103572305038308068)
,p_name=>'APEX.ISSUES.ERR_APP_DOES_NOT_EXIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\6307\5B9A\3055\308C\305F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306F\3053\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306B\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103572707101308068)
,p_name=>'APEX.ISSUES.ERR_ATTEMPTING_TO_DELETE_COMMENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30E1\30F3\30C8\306E\524A\9664\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103572612865308068)
,p_name=>'APEX.ISSUES.ERR_COMMENT_NOT_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30E1\30F3\30C8\304C\898B\3064\304B\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103572953305308068)
,p_name=>'APEX.ISSUES.ERR_ISSUE_NOT_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\554F\984C\304C\898B\3064\304B\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103573021824308068)
,p_name=>'APEX.ISSUES.ERR_MARKING_ISSUE_FOR_DELETE'
,p_message_language=>'ja'
,p_message_text=>unistr('\524A\9664\5BFE\8C61\306E\554F\984C\306E\30DE\30FC\30AF\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103572495910308068)
,p_name=>'APEX.ISSUES.ERR_PAGE_DOES_NOT_EXIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\6307\5B9A\3055\308C\305F\30DA\30FC\30B8\306F\3053\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9\307E\305F\306F\4ED8\5C5E\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103572867153308068)
,p_name=>'APEX.ISSUES.ERR_USER_NOT_AUTH_DELETE_COMMENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\306F\3001\3053\306E\30B3\30E1\30F3\30C8\3092\524A\9664\3059\308B\6A29\9650\3092\6301\3063\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103573185787308068)
,p_name=>'APEX.ISSUES.ERR_USER_NOT_AUTH_TO_DELETE_ISSUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\306F\3001\3053\306E\554F\984C\3092\524A\9664\3059\308B\6A29\9650\3092\6301\3063\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103572594683308068)
,p_name=>'APEX.ISSUES.ERR_USER_NOT_AUTH_VISIBILITY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\306F\3001\3053\306E\30B3\30E1\30F3\30C8\3092\8868\793A\3059\308B\304B\3069\3046\304B\3092\5909\66F4\3059\308B\6A29\9650\3092\6301\3063\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104582413773308905)
,p_name=>'APEX.ISSUES.FILE_SIZE_CHECK_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\30FB\30B5\30A4\30BA\306E\30C1\30A7\30C3\30AF\4E2D\306B\554F\984C\304C\767A\751F\3057\307E\3057\305F\3002\30B7\30B9\30C6\30E0\7BA1\7406\8005\306B\9023\7D61\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104582392505308905)
,p_name=>'APEX.ISSUES.FILE_SIZE_PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\308C\3089\306E\3044\305A\308C\304B\306E\30D5\30A1\30A4\30EB\306E\5927\304D\3055\304C\3001\6700\5927\30D5\30A1\30A4\30EB\30FB\30B5\30A4\30BA\306E%0\30D0\30A4\30C8\3092\8D85\3048\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104582239699308904)
,p_name=>'APEX.ISSUES.FILE_SIZE_SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30D5\30A1\30A4\30EB\306E\5927\304D\3055\306F\3001\6700\5927\30D5\30A1\30A4\30EB\30FB\30B5\30A4\30BA\306E%0\30D0\30A4\30C8\3092\8D85\3048\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103548306399308050)
,p_name=>'APEX.ISSUES.HIDE'
,p_message_language=>'ja'
,p_message_text=>unistr('\975E\8868\793A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103575000316308070)
,p_name=>'APEX.ISSUES.IMAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30E1\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103573948625308069)
,p_name=>'APEX.ISSUES.IMAGES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30E1\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103571375231308067)
,p_name=>'APEX.ISSUES.ISSUE_NOT_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30B9\30C6\30E0\3067\898B\3064\304B\3089\306A\304B\3063\305F\554F\984C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103520701341308030)
,p_name=>'APEX.ISSUES.JS.ADD_NOTIFICATION_PREFS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\306E\30D7\30EA\30D5\30A1\30EC\30F3\30B9\306E\8FFD\52A0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103573791807308069)
,p_name=>'APEX.ISSUES.JS.ATTACH_FILES'
,p_message_language=>'ja'
,p_message_text=>unistr('\6DFB\4ED8\30D5\30A1\30A4\30EB')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103573481207308068)
,p_name=>'APEX.ISSUES.JS.CLOSED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30ED\30FC\30BA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104707366396309006)
,p_name=>'APEX.ISSUES.JS.HEADING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D8\30C3\30C0\30FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103574799373308069)
,p_name=>'APEX.ISSUES.JS.IS_EMPTY'
,p_message_language=>'ja'
,p_message_text=>unistr('\7A7A\3067\3059')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103574553157308069)
,p_name=>'APEX.ISSUES.JS.ONE_OF_THESE_FILES_IS'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\308C\3089\306E\30D5\30A1\30A4\30EB\306E1\3064\306F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103573334892308068)
,p_name=>'APEX.ISSUES.JS.OPEN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30FC\30D7\30F3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103575807806308070)
,p_name=>'APEX.ISSUES.JS.PERMANENTLY_DELETE_SELECTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\9805\76EE\3092\5B8C\5168\306B\524A\9664')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104361737915308728)
,p_name=>'APEX.ISSUES.JS.PURGE_ALL'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\30D1\30FC\30B8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103575765262308070)
,p_name=>'APEX.ISSUES.JS.RESINSTATE_SELECTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\9805\76EE\306E\56DE\5FA9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103573815248308069)
,p_name=>'APEX.ISSUES.JS.RESPONSE_TEMPLATES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30B9\30DD\30F3\30B9\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103574698153308069)
,p_name=>'APEX.ISSUES.JS.SINGLE_TOO_LARGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5927\304D\3059\304E\3066\30A2\30C3\30D7\30ED\30FC\30C9\3067\304D\307E\305B\3093\3002<br>\30D5\30A1\30A4\30EB\306F\6B21\3088\308A\5C0F\3055\3044\30B5\30A4\30BA\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103574984793308070)
,p_name=>'APEX.ISSUES.JS.SUPPORTED_FILE_TYPES_ARE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30DD\30FC\30C8\3055\308C\308B\30D5\30A1\30A4\30EB\30FB\30BF\30A4\30D7\306F\6B21\306E\3068\304A\308A\3067\3059: ')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104557389478308885)
,p_name=>'APEX.ISSUES.JS.TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30B9\30DD\30F3\30B9\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306E\9078\629E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103574465943308069)
,p_name=>'APEX.ISSUES.JS.THIS_FILE_IS'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30D5\30A1\30A4\30EB\306F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103574822793308069)
,p_name=>'APEX.ISSUES.JS.UNSUPPORTED_FILE_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30DD\30FC\30C8\3055\308C\308B\30D5\30A1\30A4\30EB\30FB\30BF\30A4\30D7\3067\306F\3042\308A\307E\305B\3093\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104304253041308685)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.BUG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D0\30B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104304872558308686)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.DOCUMENTATIONISSUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C9\30AD\30E5\30E1\30F3\30C8\306E\554F\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104304378347308685)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.ENHANCEMENTREQUEST'
,p_message_language=>'ja'
,p_message_text=>unistr('\62E1\5F35\30EA\30AF\30A8\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104304452935308685)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.FEATUREREQUEST'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A5F\80FD\30EA\30AF\30A8\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104304724349308686)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.INSTALLATIONISSUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30B9\30C8\30FC\30EB\306E\554F\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104304673674308686)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.PERFORMANCEISSUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30D5\30A9\30FC\30DE\30F3\30B9\306E\554F\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104304523620308686)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.SECURITYISSUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30AD\30E5\30EA\30C6\30A3\306E\554F\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104304920091308686)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.TRAININGISSUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C8\30EC\30FC\30CB\30F3\30B0\306E\554F\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104305616763308686)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.ADMINISTRATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104305388595308686)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.CSSHTML'
,p_message_language=>'ja'
,p_message_text=>'CSS / HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104305482772308686)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.DAJAVASCRIPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\52D5\7684\30A2\30AF\30B7\30E7\30F3 / JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104305150344308686)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.DATABASE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104305780359308686)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.EXTINTEGRATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\5916\90E8\30B7\30B9\30C6\30E0\7D71\5408')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104305280839308686)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.RESTINTEGRATION'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\7D71\5408')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104305531976308686)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.SECURITY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30AD\30E5\30EA\30C6\30A3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104305090191308686)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.UIUX'
,p_message_language=>'ja'
,p_message_text=>'UI / UX'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104304119204308685)
,p_name=>'APEX.ISSUES.LABELS.GROUP.CATEGORY.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\554F\984C\306B\5272\308A\5F53\3066\3089\308C\305F\30AB\30C6\30B4\30EA\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104303225295308685)
,p_name=>'APEX.ISSUES.LABELS.GROUP.CATEGORY.NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30C6\30B4\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104304082563308685)
,p_name=>'APEX.ISSUES.LABELS.GROUP.FUNCTIONALAREA.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\554F\984C\306B\3088\3063\3066\5F71\97FF\3092\53D7\3051\308B\6A5F\80FD\9818\57DF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104303320793308685)
,p_name=>'APEX.ISSUES.LABELS.GROUP.FUNCTIONALAREA.NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A5F\80FD\9818\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104303941030308685)
,p_name=>'APEX.ISSUES.LABELS.GROUP.IMPORTANCE.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\554F\984C\306B\5272\308A\5F53\3066\3089\308C\305F\91CD\8981\5EA6\306E\30EC\30D9\30EB\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104303473530308685)
,p_name=>'APEX.ISSUES.LABELS.GROUP.IMPORTANCE.NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\91CD\8981\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104303861929308685)
,p_name=>'APEX.ISSUES.LABELS.GROUP.LEVELOFEFFORT.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\554F\984C\306B\5BFE\51E6\3059\308B\4F5C\696D\306E\30EC\30D9\30EB\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104303560075308685)
,p_name=>'APEX.ISSUES.LABELS.GROUP.LEVELOFEFFORT.NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F5C\696D\306E\30EC\30D9\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104303766415308685)
,p_name=>'APEX.ISSUES.LABELS.GROUP.PROGRESS.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\554F\984C\306B\5BFE\3059\308B\9032\6357\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104303662094308685)
,p_name=>'APEX.ISSUES.LABELS.GROUP.PROGRESS.NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\9032\6357')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104306169077308687)
,p_name=>'APEX.ISSUES.LABELS.IMPORTANCE.BACKLOG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D0\30C3\30AF\30ED\30B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104305816265308686)
,p_name=>'APEX.ISSUES.LABELS.IMPORTANCE.CRITICAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30EA\30C6\30A3\30AB\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104305902128308687)
,p_name=>'APEX.ISSUES.LABELS.IMPORTANCE.IMPORTANT'
,p_message_language=>'ja'
,p_message_text=>unistr('\91CD\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104306070261308687)
,p_name=>'APEX.ISSUES.LABELS.IMPORTANCE.NORMAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A19\6E96')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104306235292308687)
,p_name=>'APEX.ISSUES.LABELS.IMPORTANCE.WILLNOTADDRESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5BFE\51E6\3057\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104306337599308687)
,p_name=>'APEX.ISSUES.LABELS.LEVELOFEFFORT.EASY'
,p_message_language=>'ja'
,p_message_text=>unistr('\7C21\5358\306A\4FEE\6B63')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104306551362308687)
,p_name=>'APEX.ISSUES.LABELS.LEVELOFEFFORT.LARGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5927\898F\6A21\958B\767A\306E\4F5C\696D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104306474194308687)
,p_name=>'APEX.ISSUES.LABELS.LEVELOFEFFORT.MODERATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E2D\7A0B\5EA6\306E\4F5C\696D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104306983588308687)
,p_name=>'APEX.ISSUES.LABELS.PROGRESS.CANNOTFIX'
,p_message_language=>'ja'
,p_message_text=>unistr('\4FEE\6B63\4E0D\53EF\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104307096057308687)
,p_name=>'APEX.ISSUES.LABELS.PROGRESS.COMPLETE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B8C\4E86')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104306728102308687)
,p_name=>'APEX.ISSUES.LABELS.PROGRESS.REQUIRESMOREINFO'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A73\7D30\60C5\5831\304C\5FC5\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104306833419308687)
,p_name=>'APEX.ISSUES.LABELS.PROGRESS.WAITINGONTHIRDPARTY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30FC\30C9\30D1\30FC\30C6\30A3\3067\5F85\6A5F\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104306664643308687)
,p_name=>'APEX.ISSUES.LABELS.PROGRESS.WORKINGONIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F5C\696D\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104317104720308695)
,p_name=>'APEX.ISSUES.LABEL_GROUP_DELETE_WARNING'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30E9\30D9\30EB\30FB\30B0\30EB\30FC\30D7\306F\3001\305D\306E1\3064\4EE5\4E0A\306E\30E1\30F3\30D0\30FC\304C\554F\984C\306B\5272\308A\5F53\3066\3089\308C\3066\3044\308B\305F\3081\3001\524A\9664\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103576978804308071)
,p_name=>'APEX.ISSUES.LAST_UPDATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\7D42\66F4\65B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103573239913308068)
,p_name=>'APEX.ISSUES.MARKED_DUPLICATE_OF'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\91CD\8907\3068\3057\3066\30DE\30FC\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104361236674308727)
,p_name=>'APEX.ISSUES.MENU.ASSIGNEES'
,p_message_language=>'ja'
,p_message_text=>unistr('\5272\5F53\3066\5148')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104361167719308727)
,p_name=>'APEX.ISSUES.MENU.LABELS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104361673298308728)
,p_name=>'APEX.ISSUES.MENU.MILESTONES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30A4\30EB\30B9\30C8\30F3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104361071127308727)
,p_name=>'APEX.ISSUES.MENU.STATUS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30C6\30FC\30BF\30B9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103571193290308067)
,p_name=>'APEX.ISSUES.MILESTONES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30A4\30EB\30B9\30C8\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104307411089308688)
,p_name=>'APEX.ISSUES.MILESTONES.CODEFREEZE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30FC\30C9\30FB\30D5\30EA\30FC\30BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104307651733308688)
,p_name=>'APEX.ISSUES.MILESTONES.FINALRELEASE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\7D42\30EA\30EA\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104307549867308688)
,p_name=>'APEX.ISSUES.MILESTONES.UIFREEZE'
,p_message_language=>'ja'
,p_message_text=>unistr('UI\30D5\30EA\30FC\30BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103575664400308070)
,p_name=>'APEX.ISSUES.NOTIFY.ADDED_A_COMMENT_TO'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\304C%1 %2\306B\30B3\30E1\30F3\30C8\3092\8FFD\52A0\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103519794585308030)
,p_name=>'APEX.ISSUES.NOTIFY.HAS_CHANGED'
,p_message_language=>'ja'
,p_message_text=>unistr('\5909\66F4\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104324719296308700)
,p_name=>'APEX.ISSUES.NOTIFY.ISSUE_HAS_CHANGED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9%1\306E\554F\984C\756A\53F7%0\304C\5909\66F4\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104582160360308904)
,p_name=>'APEX.ISSUES.NO_LABLES_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB\304C\5B9A\7FA9\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103577019700308071)
,p_name=>'APEX.ISSUES.OPEN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30FC\30D7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103574309795308069)
,p_name=>'APEX.ISSUES.OTHER'
,p_message_language=>'ja'
,p_message_text=>unistr('\305D\306E\4ED6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103571803983308067)
,p_name=>'APEX.ISSUES.PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103571697731308067)
,p_name=>'APEX.ISSUES.PAGE_NO_LONGER_EXISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306F\3059\3067\306B\5B58\5728\3057\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104700904447309001)
,p_name=>'APEX.ISSUES.PURGE_BUTTON'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\30D1\30FC\30B8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104376504703308739)
,p_name=>'APEX.ISSUES.REMOVE'
,p_message_language=>'ja'
,p_message_text=>unistr('\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103571479928308067)
,p_name=>'APEX.ISSUES.REMOVED_ASSOCIATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3068\30DA\30FC\30B8\306E\95A2\9023\4ED8\3051\306E\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103572175640308068)
,p_name=>'APEX.ISSUES.REMOVED_THE_ATTACHMENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6DFB\4ED8\306E\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104675658935308980)
,p_name=>'APEX.ISSUES.REPLACE_COMMENT_CONFIRM'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30B3\30E1\30F3\30C8\3092\3053\306E\30C6\30F3\30D7\30EC\30FC\30C8\306B\7F6E\304D\63DB\3048\307E\3059\304B\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104677666373308981)
,p_name=>'APEX.ISSUES.SAMPLE_ISSUE_BODY'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\3088\3046\3053\305D\3002'),
'',
unistr('\3053\308C\306F\3042\306A\305F\306B\3068\3063\3066\4E00\756A\6700\521D\306E\554F\984C\3067\3059\3002\554F\984C\3092\4F5C\6210\3059\308B\3068\3001\3059\3079\3066\306EAPEX\30D7\30ED\30B8\30A7\30AF\30C8\306E\30BF\30B9\30AF\3001\6A5F\80FD\3001\30D0\30B0\304A\3088\3073\30D5\30A3\30FC\30C9\30D0\30C3\30AF\3092\30C8\30E9\30C3\30AD\30F3\30B0\3067\304D\307E\3059\3002\554F\984C\3078\306E\30E9\30D9\30EB\306E\8FFD\52A0\3001\5272\5F53\3066\5148\306E\8FFD\52A0\3001\30DE\30A4\30EB\30B9\30C8\30F3\306E\8A2D\5B9A\306B\52A0\3048\3001Markdown\8A18\6CD5\3092\4F7F\7528\3057\305F\66F8\5F0F\8A2D\5B9A\306E\9069\7528\307E\3067\884C\3046\3053\3068\304C\3067\304D\307E\3059\3002'),
'',
unistr('\6B21\306B\3001Markdown\3067\5B9F\884C\3067\304D\308B\3053\3068\306E\7C21\5358\306A\30B5\30F3\30D7\30EB\3092\793A\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104677509459308981)
,p_name=>'APEX.ISSUES.SAMPLE_ISSUE_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('Oracle APEX\306E\30C1\30FC\30E0\958B\767A\3078\3088\3046\3053\305D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104376699844308739)
,p_name=>'APEX.ISSUES.SELECT'
,p_message_language=>'ja'
,p_message_text=>unistr('- \9078\629E -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103572273591308068)
,p_name=>'APEX.ISSUES.SET_STATUS_TO'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30C6\30FC\30BF\30B9\306E\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103548593152308051)
,p_name=>'APEX.ISSUES.SHOW_ACTIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104677400542308981)
,p_name=>'APEX.ISSUES.SHOW_MORE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3055\3089\306B\8868\793A...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103571941279308067)
,p_name=>'APEX.ISSUES.SUBSCRIBED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30D6\30B9\30AF\30E9\30A4\30D6\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104582538439308905)
,p_name=>'APEX.ISSUES.SUMMARY_LINE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9%1\306E%0\306B%2\306E\65B0\3057\3044\901A\77E5\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104300733683308683)
,p_name=>'APEX.ISSUES.TEMPLATE.BUG.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D0\30B0\3092\8A18\9332\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\30C6\30F3\30D7\30EC\30FC\30C8\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104300662175308683)
,p_name=>'APEX.ISSUES.TEMPLATE.BUG.NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D0\30B0\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104300509280308683)
,p_name=>'APEX.ISSUES.TEMPLATE.BUG.TEXT'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('**\4E88\671F\3055\308C\308B\52D5\4F5C**'),
unistr('- \901A\5E38\767A\751F\3059\308B\3068\8003\3048\3089\308C\308B\52D5\4F5C\3092\6559\3048\3066\304F\3060\3055\3044\3002'),
'',
'',
unistr('**\73FE\5728\306E\52D5\4F5C**'),
unistr('- \73FE\5728\306E\52D5\4F5C\3092\6559\3048\3066\304F\3060\3055\3044\3002'),
'',
'',
unistr('**\5F71\97FF\3092\53D7\3051\308B\30E6\30FC\30B6\30FC**'),
unistr('- \8AB0\304C/\4F55\304C\5F71\97FF\3092\53D7\3051\308B\304B\3092\6559\3048\3066\304F\3060\3055\3044\3002'),
'',
unistr('**\53EF\80FD\306A\89E3\6C7A\7B56**'),
unistr('- \53EF\80FD\3067\3042\308C\3070\3001\3053\306E\30D0\30B0\3092\4FEE\6B63\3059\308B\65B9\6CD5\3092\793A\3057\3066\304F\3060\3055\3044\3002'),
'',
unistr('**\518D\73FE\3059\308B\624B\9806**'),
unistr('- \5FC5\8981\306B\5FDC\3058\3066\30B9\30AF\30EA\30FC\30F3\30B7\30E7\30C3\30C8\3084\30B3\30FC\30C9\30FB\30B9\30CB\30DA\30C3\30C8\3092\542B\3081\306A\304C\3089\3001\73FE\8C61\3092\518D\73FE\3059\308B\660E\78BA\306A\624B\9806\306E\30BB\30C3\30C8\3092\793A\3057\3066\304F\3060\3055\3044\3002'),
'1.',
'2.',
'3.',
'',
unistr('**\30B3\30F3\30C6\30AD\30B9\30C8**'),
unistr('- \30D0\30B0\306E\767A\751F\6642\306B\5B9F\884C\3057\3088\3046\3068\3057\3066\3044\305F\3053\3068\306F\4F55\3067\3059\304B\3002\305D\306E\30D0\30B0\306F\3001\4E00\5B9A\306E\6761\4EF6\4E0B\3067\306E\307F\767A\751F\3057\307E\3059\304B\3001\307E\305F\306F\7279\5B9A\306E\6642\9593\5E2F\306A\3069\306B\767A\751F\3057\307E\3059\304B\3002'),
'',
unistr('**\74B0\5883**'),
'',
unistr('- \30D0\30FC\30B8\30E7\30F3: '),
unistr('- \30D7\30E9\30C3\30C8\30D5\30A9\30FC\30E0: '),
unistr('- \30B5\30D6\30B7\30B9\30C6\30E0:'),
'',
'______',
'',
unistr('_**\30CE\30FC\30C8:** \554F\984C\3092\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\307E\305F\306F\30DA\30FC\30B8(\3042\308B\3044\306F\305D\306E\4E21\65B9)\306B\95A2\9023\4ED8\3051\308B\306B\306F\3001\6700\521D\306B\554F\984C\3092\30ED\30B0\306B\8A18\9332\3057\3001\6B21\306B\300C**\30A2\30AF\30B7\30E7\30F3**\300D\30C9\30ED\30C3\30D7\30C0\30A6\30F3\3092\4F7F\7528\3057\3066\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304A\3088\3073\30DA\30FC\30B8\3092\95A2\9023\4ED8\3051\307E\3059\3002_')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104301881808308684)
,p_name=>'APEX.ISSUES.TEMPLATE.BUGRAISED.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D0\30B0\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104301721148308683)
,p_name=>'APEX.ISSUES.TEMPLATE.BUGRAISED.NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D0\30B0\306E\767A\751F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104301928919308684)
,p_name=>'APEX.ISSUES.TEMPLATE.BUGRAISED.TEXT'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9069\5207\306A\5916\90E8\30B7\30B9\30C6\30E0\306B**\30D0\30B0**\304C\63D0\51FA\3055\308C\307E\3057\305F\3002'),
'',
unistr('- \30D0\30B0\30FB\30C8\30E9\30C3\30AD\30F3\30B0\30FB\30B7\30B9\30C6\30E0: '),
unistr('- \30D0\30B0ID: '),
unistr('- \30D0\30B0\306EURL: '),
'',
unistr('\30B3\30E1\30F3\30C8:')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104300937944308683)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATURE.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A5F\80FD\30EA\30AF\30A8\30B9\30C8\3092\8A18\9332\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\30C6\30F3\30D7\30EC\30FC\30C8\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104300878068308683)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATURE.NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A5F\80FD\30EA\30AF\30A8\30B9\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104301052933308683)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATURE.TEXT'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('**\6A5F\80FD\30B5\30DE\30EA\30FC**'),
unistr(' - \6A5F\80FD\30EA\30AF\30A8\30B9\30C8\306E1\6BB5\843D\7A0B\5EA6\306E\6982\8981\3092\63D0\4F9B\3057\3066\304F\3060\3055\3044\3002'),
'',
'',
unistr('**\30B3\30F3\30C6\30AD\30B9\30C8**'),
unistr(' - \3053\306E\30EA\30AF\30A8\30B9\30C8\306F\7279\5B9A\306E\72B6\6CC1\307E\305F\306F\30D7\30ED\30BB\30B9\306B\95A2\9023\3057\3066\3044\307E\3059\304B\3002\305F\3068\3048\3070\3001\300C\79C1\306F\3044\3064\3082[...]\306E\3068\304D\306B\4E0D\6E80\3092\611F\3058\307E\3059\300D\306A\3069'),
'',
'',
unistr(' - \30B9\30AF\30EA\30FC\30F3\30B7\30E7\30C3\30C8\3084\4F7F\7528\4E8B\4F8B\306A\3069\306E\4ED8\968F\60C5\5831\3092\63D0\4F9B\3057\3066\304F\3060\3055\3044\3002'),
'',
'',
unistr('**\512A\5148\3055\308C\308B\89E3\6C7A\7B56**'),
unistr('- \5E0C\671B\3059\308B\5B9F\88C5\5185\5BB9\306E\660E\78BA\306A\8AAC\660E\3092\63D0\4F9B\3057\3066\304F\3060\3055\3044\3002'),
'',
'',
unistr('**\4EE3\66FF\53EF\80FD\306A\89E3\6C7A\7B56**'),
unistr('- \8003\3048\3089\308C\308B\4EE3\66FF\53EF\80FD\306A\89E3\6C7A\7B56\307E\305F\306F\6A5F\80FD(\3042\308B\3044\306F\4F7F\7528\3059\308B\56DE\907F\7B56)\306E\8AAC\660E\3092\63D0\4F9B\3057\3066\304F\3060\3055\3044\3002'),
'',
'',
'______',
unistr('_**\30CE\30FC\30C8:** \554F\984C\3092\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\307E\305F\306F\30DA\30FC\30B8(\3042\308B\3044\306F\305D\306E\4E21\65B9)\306B\95A2\9023\4ED8\3051\308B\306B\306F\3001\6700\521D\306B\554F\984C\3092\30ED\30B0\306B\8A18\9332\3057\3001\6B21\306B\300C**\30A2\30AF\30B7\30E7\30F3**\300D\30C9\30ED\30C3\30D7\30C0\30A6\30F3\3092\4F7F\7528\3057\3066\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304A\3088\3073\30DA\30FC\30B8\3092\95A2\9023\4ED8\3051\307E\3059\3002_')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104302128063308684)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATUREFILED.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A5F\80FD\30EA\30AF\30A8\30B9\30C8\304C\63D0\51FA\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104302051981308684)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATUREFILED.NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A5F\80FD\30EA\30AF\30A8\30B9\30C8\306E\63D0\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104302233901308684)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATUREFILED.TEXT'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9069\5207\306A\5916\90E8\30B7\30B9\30C6\30E0\306B**\6A5F\80FD\30EA\30AF\30A8\30B9\30C8**\304C\63D0\51FA\3055\308C\307E\3057\305F\3002'),
'',
unistr('- \6A5F\80FD\30C8\30E9\30C3\30AD\30F3\30B0\30FB\30B7\30B9\30C6\30E0: '),
unistr('- \6A5F\80FDID: '),
unistr('- \6A5F\80FD\5B9A\7FA9\306EURL: '),
'',
unistr('\30B3\30E1\30F3\30C8:')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104303006705308684)
,p_name=>'APEX.ISSUES.TEMPLATE.FOLLOWUP.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30ED\30FC\30A2\30C3\30D7\30FB\30A2\30AF\30B7\30E7\30F3\304C\5FC5\8981\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104302948124308684)
,p_name=>'APEX.ISSUES.TEMPLATE.FOLLOWUP.NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30ED\30FC\30A2\30C3\30D7\30FB\30A2\30AF\30B7\30E7\30F3\304C\5FC5\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104303104054308684)
,p_name=>'APEX.ISSUES.TEMPLATE.FOLLOWUP.TEXT'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6B21\306E\30A2\30AF\30B7\30E7\30F3\3092\5B9F\884C\3057\3066\304F\3060\3055\3044: '),
'',
'1.',
'2.',
'3.',
'4.',
'',
unistr('\30B3\30E1\30F3\30C8: ')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104301251555308683)
,p_name=>'APEX.ISSUES.TEMPLATE.HOWDOI.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\624B\9806\306E\8CEA\554F\3092\5C0B\306D\308B\305F\3081\306B\4F7F\7528\3059\308B\30C6\30F3\30D7\30EC\30FC\30C8\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104301152040308683)
,p_name=>'APEX.ISSUES.TEMPLATE.HOWDOI.NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F7F\7528\65B9\6CD5 ...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104301321955308683)
,p_name=>'APEX.ISSUES.TEMPLATE.HOWDOI.TEXT'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('**\8CEA\554F**'),
unistr('- \3067\304D\308B\304B\304E\308A\7C21\6F54\306B\8CEA\554F\307E\305F\306F\30EA\30AF\30A8\30B9\30C8\3092\8A18\8F09\3057\3066\304F\3060\3055\3044\3002'),
'',
unistr('**\4E00\822C\30B3\30F3\30C6\30AD\30B9\30C8**'),
unistr('- \4F55\3092\3057\3088\3046\3068\3057\3066\3044\307E\3059\304B\3002'),
'',
'',
unistr('- \56DE\7B54\3092\898B\3064\3051\308B\305F\3081\306B\3069\3053\304B\5225\306E\5834\6240\3092\63A2\3057\305F\308A\3001\8AB0\304B\5225\306E\4EBA\7269\306B\9023\7D61\3057\305F\3053\3068\306F\3042\308A\307E\3059\304B\3002'),
'',
'',
unistr('**\74B0\5883** '),
unistr('\3053\306E\8CEA\554F\306F\3001\74B0\5883\3001\30D7\30ED\30B0\30E9\30DF\30F3\30B0\8A00\8A9E\307E\305F\306F\4ED6\306E\5206\91CE\306B\56FA\6709\3067\3059\304B\3002'),
'',
'______',
unistr('_**\30CE\30FC\30C8:** \554F\984C\3092\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\307E\305F\306F\30DA\30FC\30B8(\3042\308B\3044\306F\305D\306E\4E21\65B9)\306B\95A2\9023\4ED8\3051\308B\306B\306F\3001\6700\521D\306B\554F\984C\3092\30ED\30B0\306B\8A18\9332\3057\3001\6B21\306B\300C**\30A2\30AF\30B7\30E7\30F3**\300D\30C9\30ED\30C3\30D7\30C0\30A6\30F3\3092\4F7F\7528\3057\3066\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304A\3088\3073\30DA\30FC\30B8\3092\95A2\9023\4ED8\3051\307E\3059\3002_')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104302750616308684)
,p_name=>'APEX.ISSUES.TEMPLATE.KNOWNISSUE.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E2\77E5\306E\554F\984C\3092\53C2\7167\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104302635562308684)
,p_name=>'APEX.ISSUES.TEMPLATE.KNOWNISSUE.NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E2\77E5\306E\554F\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104302811171308684)
,p_name=>'APEX.ISSUES.TEMPLATE.KNOWNISSUE.TEXT'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\78BA\8A8D\3057\305F\3068\3053\308D\3001\3053\308C\306F\65E2\77E5\306E\554F\984C\3067\3042\308B\3068\78BA\5B9A\3057\307E\3057\305F\3002\6B21\306E\8A73\7D30\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002'),
'',
unistr('- \30D0\30B0\30FB\30C8\30E9\30C3\30AD\30F3\30B0\30FB\30B7\30B9\30C6\30E0: '),
unistr('- \30D0\30B0ID: '),
unistr('- \30D0\30B0\306EURL: '),
'',
unistr('\30B3\30E1\30F3\30C8: ')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104302488766308684)
,p_name=>'APEX.ISSUES.TEMPLATE.MOREINFO.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A73\7D30\60C5\5831\306E\30EA\30AF\30A8\30B9\30C8\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104302395777308684)
,p_name=>'APEX.ISSUES.TEMPLATE.MOREINFO.NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A73\7D30\60C5\5831\304C\5FC5\8981')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104302518722308684)
,p_name=>'APEX.ISSUES.TEMPLATE.MOREINFO.TEXT'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('**\3053\306E\554F\984C\306E\8A73\7D30\60C5\5831\304C\5FC5\8981\3067\3059:**'),
'',
unistr('\6B21\306B\30EA\30AF\30A8\30B9\30C8\3055\308C\3066\3044\308B\60C5\5831\3092\63D0\4F9B\3057\3066\304F\3060\3055\3044\3002\3053\306E\60C5\5831\304C\306A\3044\3068\3001\3053\308C\4EE5\4E0A\3053\306E\554F\984C\3092\9078\5225\3057\3066\5BFE\51E6\3059\308B\3053\3068\304C\96E3\3057\304F\306A\308A\307E\3059\3002'),
'',
'',
unistr('\30B3\30E1\30F3\30C8:')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104301554124308683)
,p_name=>'APEX.ISSUES.TEMPLATE.WONTACTION.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\554F\984C\306B\5BFE\3057\3066\30A2\30AF\30B7\30E7\30F3\306F\884C\308F\308C\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104301480622308683)
,p_name=>'APEX.ISSUES.TEMPLATE.WONTACTION.NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3\5BFE\8C61\5916')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104301653215308683)
,p_name=>'APEX.ISSUES.TEMPLATE.WONTACTION.TEXT'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\614E\91CD\306B\691C\8A0E\3057\307E\3057\305F\304C\3001**\3053\306E\554F\984C\306B\5BFE\3057\3066\3053\308C\4EE5\4E0A\306E\30A2\30AF\30B7\30E7\30F3\306F\884C\308F\308C\307E\305B\3093**\3002'),
'',
unistr('\30B3\30E1\30F3\30C8:')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103575368891308070)
,p_name=>'APEX.ISSUES.TEXT_FILE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8\30FB\30D5\30A1\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103574225087308069)
,p_name=>'APEX.ISSUES.TEXT_FILES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8\30FB\30D5\30A1\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103571050299308067)
,p_name=>'APEX.ISSUES.THIS_ISSUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\554F\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104325802432308701)
,p_name=>'APEX.ISSUES.TIMELINE.ADDED_ATTACHMENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6DFB\4ED8%0\304C%1 %2\306B\8FFD\52A0\3055\308C\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104324849040308700)
,p_name=>'APEX.ISSUES.TIMELINE.ADDED_LABELS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\304C%1 %2\306B\8FFD\52A0\3055\308C\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104326474682308702)
,p_name=>'APEX.ISSUES.TIMELINE.ADDED_MILESTONES'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\304C%1 %2\306B\8FFD\52A0\3055\308C\307E\3057\305F				')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104325016022308701)
,p_name=>'APEX.ISSUES.TIMELINE.ASSIGNED'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\304C%1 %2\306B\5272\308A\5F53\3066\3089\308C\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104325489691308701)
,p_name=>'APEX.ISSUES.TIMELINE.ASSOCIATED'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\304C%1 %2\306B\95A2\9023\4ED8\3051\3089\308C\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103575535879308070)
,p_name=>'APEX.ISSUES.TIMELINE.EDITED_A_COMMENT_FOR'
,p_message_language=>'ja'
,p_message_text=>unistr('%0	%1\306E\30B3\30E1\30F3\30C8\3092\7DE8\96C6\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103773291301308226)
,p_name=>'APEX.ISSUES.TIMELINE.EDITED_ISSUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\7DE8\96C6\3055\308C\305F\554F\984C%0 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104326311800308702)
,p_name=>'APEX.ISSUES.TIMELINE.HIDDEN'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\554F\984C\306F\975E\8868\793A\306B\306A\308A\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104325297388308701)
,p_name=>'APEX.ISSUES.TIMELINE.MARKED_DUP'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\304C%1 %2\306E\91CD\8907\3068\3057\3066\30DE\30FC\30AF\3055\308C\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104326248999308702)
,p_name=>'APEX.ISSUES.TIMELINE.OPENED'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306B\3088\3063\3066%0\304C\958B\304B\308C\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104325981191308701)
,p_name=>'APEX.ISSUES.TIMELINE.REMOVED_ATTACHMENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6DFB\4ED8%0\304C%1 %2\304B\3089\524A\9664\3055\308C\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104324925837308701)
,p_name=>'APEX.ISSUES.TIMELINE.REMOVED_LABELS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\304C%1 %2\304B\3089\524A\9664\3055\308C\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104326571562308702)
,p_name=>'APEX.ISSUES.TIMELINE.REMOVED_MILESTONES'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\304C%1 %2\304B\3089\524A\9664\3055\308C\307E\3057\305F 			')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104326080003308701)
,p_name=>'APEX.ISSUES.TIMELINE.STATUS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306E\30B9\30C6\30FC\30BF\30B9\304C%1 %2\306B\8A2D\5B9A\3055\308C\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104325696934308701)
,p_name=>'APEX.ISSUES.TIMELINE.SUBSCRIBED'
,p_message_language=>'ja'
,p_message_text=>unistr('%0 %1\306B\30B5\30D6\30B9\30AF\30E9\30A4\30D6\3055\308C\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104325166268308701)
,p_name=>'APEX.ISSUES.TIMELINE.UNASSIGNED'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\304C%1 %2\304B\3089\5272\5F53\3066\89E3\9664\3055\308C\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104325527137308701)
,p_name=>'APEX.ISSUES.TIMELINE.UNASSOCIATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3068\30DA\30FC\30B8\306E\95A2\9023\4ED8\3051\304C%0 %1\304B\3089\524A\9664\3055\308C\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104325336977308701)
,p_name=>'APEX.ISSUES.TIMELINE.UNMARKED_DUP'
,p_message_language=>'ja'
,p_message_text=>unistr('\91CD\8907%1\3068\3057\3066\306E%0\304C\30DE\30FC\30AF\89E3\9664\3055\308C\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104325750888308701)
,p_name=>'APEX.ISSUES.TIMELINE.UNSUBSCRIBED'
,p_message_language=>'ja'
,p_message_text=>unistr('%0 %1\304B\3089\30B5\30D6\30B9\30AF\30E9\30A4\30D6\89E3\9664\3055\308C\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104326108698308701)
,p_name=>'APEX.ISSUES.TIMELINE_MARKED_DUPLICATE_OF'
,p_message_language=>'ja'
,p_message_text=>unistr('%0 %1\306E\91CD\8907\304C%2\306B\3088\3063\3066\30DE\30FC\30AF\3055\308C\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103571265335308067)
,p_name=>'APEX.ISSUES.UNASSIGNED'
,p_message_language=>'ja'
,p_message_text=>unistr('\672A\5272\5F53\3066')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103548422314308050)
,p_name=>'APEX.ISSUES.UNHIDE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103572019310308067)
,p_name=>'APEX.ISSUES.UNSUBSCRIBED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30D6\30B9\30AF\30E9\30A4\30D6\89E3\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104360988034308727)
,p_name=>'APEX.ISSUES.UPDATE_MENU'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F4\65B0...')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103575180609308070)
,p_name=>'APEX.ISSUES.ZIP_FILE'
,p_message_language=>'ja'
,p_message_text=>unistr('ZIP\30D5\30A1\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103574094257308069)
,p_name=>'APEX.ISSUES.ZIP_FILES'
,p_message_language=>'ja'
,p_message_text=>unistr('ZIP\30D5\30A1\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103532349368308039)
,p_name=>'APEX.ITEM.GEOCODE.ERROR_DA_AFFECTED_ELEM'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\3001\30B8\30AA\30B3\30FC\30C7\30A3\30F3\30B0\3055\308C\305F\4F4F\6240\30A2\30A4\30C6\30E0\3067\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104670692459308975)
,p_name=>'APEX.ITEM.NOT_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0%0\304C\898B\3064\304B\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104561045971308887)
,p_name=>'APEX.PAGE.CHECKSUM.DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30C1\30A7\30C3\30AF\30B5\30E0\3092\4F7F\7528\3059\308B\3068\3001\540C\3058\30DA\30FC\30B8\304C\4ED6\306E\5834\6240\306B\30C7\30D7\30ED\30A4\3055\308C\3066\3044\308B\304B\3069\3046\304B\3092\7C21\5358\306B\5224\5225\3067\304D\307E\3059\3002\3053\306E\30C1\30A7\30C3\30AF\30B5\30E0\3092\6BD4\8F03\3057\3066\3001\4E00\81F4\3059\308B\3082\306E\304C\3042\308B\304B\3069\3046\304B\3092\5224\5225\3067\304D\307E\3059\3002\3053\306E\30DA\30FC\30B8\3067\4F7F\7528\3055\308C\3066\3044\308B\5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\5BFE\3059\308B\5909\66F4\306F\3001\3053\306E\30C1\30A7\30C3\30AF\30B5\30E0\5185\3067\306F\53CD\6620\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104716675475309014)
,p_name=>'APEX.PAGE_NAME.ABOUT_THIS_APP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\3064\3044\3066')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104716406665309014)
,p_name=>'APEX.PAGE_NAME.CONFIGURATION_OPTIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\69CB\6210\30AA\30D7\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104716546784309014)
,p_name=>'APEX.PAGE_NAME.THEME_STYLE_SELECTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB\306E\9078\629E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103549078425308051)
,p_name=>'APEX.PDF.ERROR.CFF_MULTIPLE_FONTS'
,p_message_language=>'ja'
,p_message_text=>unistr('1\3064\306E\30D5\30A9\30F3\30C8\3092\4F7F\7528\3057\305FCompact Font Format (CFF)\30D5\30A9\30F3\30C8\306E\307F\304C\8A31\53EF\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103549183017308051)
,p_name=>'APEX.PDF.ERROR.CFF_MULTIPLE_TOP_DICTS'
,p_message_language=>'ja'
,p_message_text=>unistr('1\3064\306ETop DICT\3092\4F7F\7528\3057\305FCompact Font Format (CFF)\30D5\30A9\30F3\30C8\306E\307F\304C\8A31\53EF\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103549280106308051)
,p_name=>'APEX.PDF.ERROR.CFF_NOT_TYPE2_CHARSTRINGS'
,p_message_language=>'ja'
,p_message_text=>unistr('Type 2 CharString\5F62\5F0F\3092\4F7F\7528\3057\305FCompact Font Format (CFF)\30D5\30A9\30F3\30C8\306E\307F\304C\8A31\53EF\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103561431146308060)
,p_name=>'APEX.PDF.ERROR.FONT_NOT_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30F3\30C8\304C\898B\3064\304B\308A\307E\305B\3093\3067\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103561373116308060)
,p_name=>'APEX.PDF.ERROR.INVALID_CMAP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30FC\30DE\30C3\30C84\304A\3088\307312 cmap\30C6\30FC\30D6\30EB\306E\307F\304C\30B5\30DD\30FC\30C8\3055\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103561747315308060)
,p_name=>'APEX.PDF.ERROR.INVALID_ORIENTATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306E\5411\304D\304C\7121\52B9\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103561518113308060)
,p_name=>'APEX.PDF.ERROR.NOT_INITIALIZED'
,p_message_language=>'ja'
,p_message_text=>unistr('PDF\304C\521D\671F\5316\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103561279636308060)
,p_name=>'APEX.PDF.ERROR.NO_CMAP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30F3\30C8\306B\6709\52B9\306Acmap\30B5\30D6\30C6\30FC\30D6\30EB\304C\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103561653788308060)
,p_name=>'APEX.PDF.ERROR.NO_PAGES'
,p_message_language=>'ja'
,p_message_text=>unistr('PDF\306B\30DA\30FC\30B8\304C\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103996672296308433)
,p_name=>'APEX.PDF.INTERNAL_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('PDF\30D5\30A1\30A4\30EB\306E\4F5C\6210\4E2D\306B\5185\90E8\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103567050555308064)
,p_name=>'APEX.PROCESS.INVALID_EDITABLE_REGION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30BB\30B9"%0"\306B\7121\52B9\306A(\8907\6570\884C\3067\306A\3044)\7DE8\96C6\53EF\80FD\30EA\30FC\30B8\30E7\30F3\304C\5272\308A\5F53\3066\3089\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103555136324308055)
,p_name=>'APEX.PROCESS.NATIVE.GET_NEXT_OR_PREV_PK_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\4E3B\30AD\30FC\5024\307E\305F\306F\524D\306E\4E3B\30AD\30FC\5024\3092\53D6\5F97\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104224658796308628)
,p_name=>'APEX.PROCESS.NATIVE.WEB_SERVICE.NOT_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B5\30FC\30D3\30B9\304C\898B\3064\304B\308A\307E\305B\3093\3067\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103762468530308217)
,p_name=>'APEX.PROCESS.UNHANDLED_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30BB\30B9\306E\51E6\7406\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103581795380308074)
,p_name=>'APEX.QOS.REQUEST_LIMIT_REACHED'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30BB\30C3\30B7\30E7\30F3\306E\30EA\30BD\30FC\30B9\5236\9650\306E\305F\3081\3001Application Express\3067\30EA\30AF\30A8\30B9\30C8\3092\51E6\7406\3067\304D\307E\305B\3093\3067\3057\305F\3002\5F8C\3067\518D\8A66\884C\3057\3066\304F\3060\3055\3044\3002'),
'<p/>',
unistr('\3053\306E\30A4\30F3\30B7\30C7\30F3\30C8\306E\8A73\7D30\306F\3001\30C7\30D0\30C3\30B0ID "%0"\3088\308A\53C2\7167\3067\304D\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103555997966308056)
,p_name=>'APEX.REMOTEDEPLOY.ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30C7\30D7\30ED\30A4\4E2D\306B\6B21\306E\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103558663347308058)
,p_name=>'APEX.REMOTEDEPLOY.SUCCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3%0\306F\30EA\30E2\30FC\30C8\30FB\30B5\30FC\30D0\30FC\306B\6B63\5E38\306B\30C7\30D7\30ED\30A4\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103562324500308060)
,p_name=>'APEX.REMOTEDEPLOY.SUCCESS2'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3%0\306F\30EA\30E2\30FC\30C8\30FB\30B5\30FC\30D0\30FC\306B%1\3068\3057\3066\6B63\5E38\306B\30C7\30D7\30ED\30A4\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104196849851308607)
,p_name=>'APEX.REMOTESQL.AUTHENTICATION_FAILED'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\5BFE\5FDCSQL\30B5\30FC\30D3\30B9\306E\8A8D\8A3C\306B\5931\6557\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103582009242308075)
,p_name=>'APEX.REMOTESQL.AUTHENTICATION_FAILED_FOR_LOV'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\306B\5931\6557\3057\307E\3057\305F\3002\7121\52B9\306AWeb\8CC7\683C\8A3C\660E\3092\53C2\7167\3057\3066\3044\308BREST\5BFE\5FDCSQL\30C7\30FC\30BF\30FB\30BD\30FC\30B9\304CLOV\3067\4F7F\7528\3055\308C\3066\3044\308B\305F\3081\3001\3053\306ELOV\306E\5217\60C5\5831\306F\7DE8\96C6\3067\304D\307E\305B\3093\3002\8A8D\8A3C\8CC7\683C\8A3C\660E\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104703157189309003)
,p_name=>'APEX.REMOTESQL.COMMUNICATION_FAILURE'
,p_message_language=>'ja'
,p_message_text=>unistr('\901A\4FE1\969C\5BB3\3002LOV\3067\53C2\7167\3055\308C\3066\3044\308BREST\5BFE\5FDCSQL\30C7\30FC\30BF\30FB\30BD\30FC\30B9\306E\8D77\52D5\4E2D\306B\554F\984C\304C\767A\751F\3057\305F\305F\3081\3001LOV\306E\5217\60C5\5831\3092\7DE8\96C6\3067\304D\307E\305B\3093\3002REST\5BFE\5FDCSQL\30C7\30FC\30BF\30FB\30BD\30FC\30B9\304C\6B63\5E38\306B\52D5\4F5C\3057\3066\3044\308B\3053\3068\3068\3001\5BFE\5FDC\3059\308B\8A8D\8A3C\8CC7\683C\8A3C\660E\304C\6B63\3057\3044\3053\3068\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104198167541308608)
,p_name=>'APEX.REMOTESQL.REMOTE_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30E2\30FC\30C8\30FB\30B5\30FC\30D0\30FC\3067\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104172932203308586)
,p_name=>'APEX.REMOTESQL.SERVER_NOT_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\6307\5B9A\3057\305FORDS REST\5BFE\5FDCSQL\30A4\30F3\30B9\30BF\30F3\30B9\304C\898B\3064\304B\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103778729160308230)
,p_name=>'APEX.REMOTESQL.SERVER_SENT_REDIRECT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30FC\30D0\30FC\306F\30EA\30C0\30A4\30EC\30AF\30B7\30E7\30F3\3092\9001\4FE1\3057\307E\3057\305F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104073276255308494)
,p_name=>'APEX.REMOTESQL.SQL_STATEMENT_TOO_LONG'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\6587\304C32.767\30D0\30A4\30C8\3092\8D85\3048\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104091929687308510)
,p_name=>'APEX.REMOTESQL.TEST_MESSAGE'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Hello, Application Express! \3042\306A\305F\306F#USER#\3068\3057\3066\63A5\7D9A\3057\3066\3044\307E\3059\3002'),
unistr('\30ED\30FC\30AB\30EB\30FB\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30BF\30A4\30E0\30B9\30BF\30F3\30D7\306F\3001#SYSDATE#\3067\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104317099773308695)
,p_name=>'APEX.REST.DEFAULT_SCHEMA_WARNING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306E\30C7\30D5\30A9\30EB\30C8\30FB\30B9\30AD\30FC\30DE\306E\5225\540D\3092\7DE8\96C6\3057\3088\3046\3068\3057\3066\3044\307E\3059\3002\3053\306E\5225\540D\3092\8A2D\5B9A\3059\308B\3068\3001\30EF\30FC\30AF\30B9\30DA\30FC\30B9\30FB\30EC\30D9\30EB\306E\30D1\30B9\63A5\982D\8F9E\3082\5909\66F4\3055\308C\307E\3059\3002\3053\308C\306B\3088\308A\3001\5B9A\7FA9\3055\308C\3066\3044\308B\53EF\80FD\6027\306E\3042\308BAPEX\30D9\30FC\30B9\306ERESTful\30B5\30FC\30D3\30B9\306EURL\304C\5F71\97FF\3092\53D7\3051\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104070940278308492)
,p_name=>'APEX.SC.REFERENCES'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\53C2\7167')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104308314469308688)
,p_name=>'APEX.SEARCH.AU.APPLICATION_UTILITIES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30C6\30A3\30EA\30C6\30A3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104308404670308688)
,p_name=>'APEX.SEARCH.AU.APPLICATION_UTILITIES_DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\79FB\52D5\5148: \30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30E6\30FC\30C6\30A3\30EA\30C6\30A3 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104315865254308694)
,p_name=>'APEX.SEARCH.GO_TO_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306B\79FB\52D5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104315702941308694)
,p_name=>'APEX.SEARCH.GO_TO_SHARED_COMPONENTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\79FB\52D5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104308552295308688)
,p_name=>'APEX.SEARCH.P1500.APP_BUILDER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30D3\30EB\30C0\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104308640658308689)
,p_name=>'APEX.SEARCH.P1500.APP_BUILDER_TASKS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30D3\30EB\30C0\30FC\30FB\30BF\30B9\30AF > ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104308763503308689)
,p_name=>'APEX.SEARCH.SC.APP_ITEMS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104308811650308689)
,p_name=>'APEX.SEARCH.SC.APP_ITEMS_DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\79FB\52D5\5148: \5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8 \005C \30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104308950719308689)
,p_name=>'APEX.SEARCH.SC.APP_LOGIC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30ED\30B8\30C3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104309079893308689)
,p_name=>'APEX.SEARCH.SC.AUTHENTICATION_SCHEMES'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\30B9\30AD\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104309131219308689)
,p_name=>'APEX.SEARCH.SC.AUTHENTICATION_SCHEMES_DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\79FB\52D5\5148: \5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8 \005C \30BB\30AD\30E5\30EA\30C6\30A3\8A8D\8A3C\30B9\30AD\30FC\30E0 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104309252488308689)
,p_name=>'APEX.SEARCH.SC.AUTHORIZATION_SCHEMES'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\53EF\30B9\30AD\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104309337698308689)
,p_name=>'APEX.SEARCH.SC.AUTHORIZATION_SCHEMES_DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\79FB\52D5\5148: \5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8 \005C \30BB\30AD\30E5\30EA\30C6\30A3\8A8D\53EF\30B9\30AD\30FC\30E0 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104309443695308689)
,p_name=>'APEX.SEARCH.SC.BREADCRUMBS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104309559024308689)
,p_name=>'APEX.SEARCH.SC.BREADCRUMBS_DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\79FB\52D5\5148: \5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8 \005C \30D6\30EC\30C3\30C9\30AF\30E9\30E0 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104309681426308689)
,p_name=>'APEX.SEARCH.SC.BUILD_OPTIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D3\30EB\30C9\30FB\30AA\30D7\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104309706128308689)
,p_name=>'APEX.SEARCH.SC.BUILD_OPTIONS_DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\79FB\52D5\5148: \5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8 \005C \30D3\30EB\30C9\30FB\30AA\30D7\30B7\30E7\30F3 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104309810531308689)
,p_name=>'APEX.SEARCH.SC.COMPONENT_SETTINGS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30DD\30FC\30CD\30F3\30C8\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104309973008308689)
,p_name=>'APEX.SEARCH.SC.COMPONENT_SETTINGS_DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\79FB\52D5\5148: \5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8 \005C \30B3\30F3\30DD\30FC\30CD\30F3\30C8\8A2D\5B9A \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104310020186308690)
,p_name=>'APEX.SEARCH.SC.COMPUTATIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A08\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104310100478308690)
,p_name=>'APEX.SEARCH.SC.COMPUTATIONS_DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\79FB\52D5\5148: \5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8 \005C \30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\8A08\7B97 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104310222513308690)
,p_name=>'APEX.SEARCH.SC.CREATE_APPLICATION_ITEM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104310339517308690)
,p_name=>'APEX.SEARCH.SC.CREATE_AUTHENTICATION_SCHEME'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\30B9\30AD\30FC\30E0\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104310439116308690)
,p_name=>'APEX.SEARCH.SC.CREATE_BUILD_OPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D3\30EB\30C9\30FB\30AA\30D7\30B7\30E7\30F3\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104310567152308690)
,p_name=>'APEX.SEARCH.SC.CREATE_COMPUTATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\8A08\7B97\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104310694746308690)
,p_name=>'APEX.SEARCH.SC.CREATE_EMAIL_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104310766338308690)
,p_name=>'APEX.SEARCH.SC.CREATE_PLUG-IN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30E9\30B0\30A4\30F3\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104310813502308690)
,p_name=>'APEX.SEARCH.SC.CREATE_THEME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104310936267308690)
,p_name=>'APEX.SEARCH.SC.CREATE_WEB_CREDENTIALS'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\8CC7\683C\8A3C\660E\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104311077954308690)
,p_name=>'APEX.SEARCH.SC.DATA_LOAD_DEFINITIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30ED\30FC\30C9\5B9A\7FA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104311101489308690)
,p_name=>'APEX.SEARCH.SC.DATA_LOAD_DEFINITIONS_DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\79FB\52D5\5148: \5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8 \005C \30C7\30FC\30BF\30FB\30ED\30FC\30C9\5B9A\7FA9 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104311252184308690)
,p_name=>'APEX.SEARCH.SC.DATA_SOURCES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30BD\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104311305583308691)
,p_name=>'APEX.SEARCH.SC.DEFINITION_ATTRIBUTES'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9A\7FA9\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104311405448308691)
,p_name=>'APEX.SEARCH.SC.EMAIL_TEMPLATES'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104311504297308691)
,p_name=>'APEX.SEARCH.SC.LAYOUTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\30FB\30EC\30A4\30A2\30A6\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104311696776308691)
,p_name=>'APEX.SEARCH.SC.LAYOUTS_DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\79FB\52D5\5148: \5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8 \005C \30EC\30DD\30FC\30C8\30FB\30EC\30A4\30A2\30A6\30C8 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104311734245308691)
,p_name=>'APEX.SEARCH.SC.LEGACY_WEB_SERVICES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30AC\30B7\30FCWeb\30B5\30FC\30D3\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104311897939308691)
,p_name=>'APEX.SEARCH.SC.LEGACY_WEB_SERVICES_DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\79FB\52D5\5148: \5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8 \005C \30EC\30AC\30B7\30FCWeb\30B5\30FC\30D3\30B9 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104311989252308691)
,p_name=>'APEX.SEARCH.SC.LISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30EA\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104312076182308691)
,p_name=>'APEX.SEARCH.SC.LISTS_DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\79FB\52D5\5148: \5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8 \005C \30AF\30E9\30B7\30C3\30AF\30FB\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30EA\30B9\30C8 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104312122698308691)
,p_name=>'APEX.SEARCH.SC.LIST_OF_VALUES'
,p_message_language=>'ja'
,p_message_text=>'LOV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104312215218308691)
,p_name=>'APEX.SEARCH.SC.LIST_OF_VALUES_DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\79FB\52D5\5148: \5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8 \005C LOV \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104312311513308691)
,p_name=>'APEX.SEARCH.SC.NAVIGATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CA\30D3\30B2\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104312414364308691)
,p_name=>'APEX.SEARCH.SC.OTHER_COMPONENTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\4ED6\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104312582072308691)
,p_name=>'APEX.SEARCH.SC.PLUG-INS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30E9\30B0\30A4\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104312653456308691)
,p_name=>'APEX.SEARCH.SC.PLUG-INS_DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\79FB\52D5\5148: \5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8 \005C \30D7\30E9\30B0\30A4\30F3 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104312766734308692)
,p_name=>'APEX.SEARCH.SC.PROCESSES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30BB\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104312871606308692)
,p_name=>'APEX.SEARCH.SC.PROCESSES_DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\79FB\52D5\5148: \5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8 \005C \30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30D7\30ED\30BB\30B9 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104312918676308692)
,p_name=>'APEX.SEARCH.SC.QUERIES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\554F\5408\305B')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104313036800308692)
,p_name=>'APEX.SEARCH.SC.QUERIES_DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\79FB\52D5\5148: \5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8 \005C \30EC\30DD\30FC\30C8\554F\5408\305B \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104313151480308692)
,p_name=>'APEX.SEARCH.SC.REPORTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104313230447308692)
,p_name=>'APEX.SEARCH.SC.REST_ENABLED_SQL'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\5BFE\5FDCSQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104313384974308692)
,p_name=>'APEX.SEARCH.SC.REST_ENABLED_SQL_DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\79FB\52D5\5148: \5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8 \005C REST\5BFE\5FDCSQL \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104313477113308692)
,p_name=>'APEX.SEARCH.SC.SECURITY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30AD\30E5\30EA\30C6\30A3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104313545756308692)
,p_name=>'APEX.SEARCH.SC.SESSION_STATE_PROTECTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\4FDD\8B77')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104313629992308692)
,p_name=>'APEX.SEARCH.SC.SET_APPLICATION_SESSION_STATE_PROTECTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\72B6\614B\4FDD\8B77\306E\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104313848248308692)
,p_name=>'APEX.SEARCH.SC.SHARED_COMPONENTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104313973862308692)
,p_name=>'APEX.SEARCH.SC.SHARED_COMPONENTS_DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\79FB\52D5\5148: \5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104314091905308693)
,p_name=>'APEX.SEARCH.SC.SHORTCUTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30E7\30FC\30C8\30AB\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104314139798308693)
,p_name=>'APEX.SEARCH.SC.SHORTCUTS_DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\79FB\52D5\5148: \5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8 \005C \30B7\30E7\30FC\30C8\30AB\30C3\30C8 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104314260994308693)
,p_name=>'APEX.SEARCH.SC.TABS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30D6(\30EC\30AC\30B7\30FC)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104314334622308693)
,p_name=>'APEX.SEARCH.SC.TEMPLATES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104314478680308693)
,p_name=>'APEX.SEARCH.SC.TEMPLATES_DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\79FB\52D5\5148: \5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8 \005C UI\30C6\30F3\30D7\30EC\30FC\30C8 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104314552887308693)
,p_name=>'APEX.SEARCH.SC.THEMES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104314662833308693)
,p_name=>'APEX.SEARCH.SC.THEMES_DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\79FB\52D5\5148: \5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8 \005C UI\30C6\30FC\30DE \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104314722653308693)
,p_name=>'APEX.SEARCH.SC.UI'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104314891438308693)
,p_name=>'APEX.SEARCH.SC.WEB_CREDENTIALS'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\8CC7\683C\8A3C\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104314903141308693)
,p_name=>'APEX.SEARCH.SC.WEB_CREDENTIALS_DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\79FB\52D5\5148: \5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8 \005C \30BB\30AD\30E5\30EA\30C6\30A3Web\8CC7\683C\8A3C\660E \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104315078556308693)
,p_name=>'APEX.SEARCH.SC.WEB_SOURCE_MODULES'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\30C7\30FC\30BF\30FB\30BD\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104315169708308693)
,p_name=>'APEX.SEARCH.SC.WEB_SOURCE_MODULES_DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\79FB\52D5\5148: \5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8 \005C REST\30C7\30FC\30BF\30FB\30BD\30FC\30B9 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104315250976308693)
,p_name=>'APEX.SEARCH.SQL_WORKSHOP'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\30EF\30FC\30AF\30B7\30E7\30C3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104315303314308693)
,p_name=>'APEX.SEARCH.SQL_WORKSHOP.CREATE_OBJECT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30D6\30B8\30A7\30AF\30C8\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104315485385308694)
,p_name=>'APEX.SEARCH.SQL_WORKSHOP.CREATE_OBJECT_DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\30EF\30FC\30AF\30B7\30E7\30C3\30D7\3067\306E%LIST_ITEM_NAME%\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104315579902308694)
,p_name=>'APEX.SEARCH.SQL_WORKSHOP.SCRIPT_EDITOR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AF\30EA\30D7\30C8\30FB\30A8\30C7\30A3\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104315621264308694)
,p_name=>'APEX.SEARCH.SQL_WORKSHOP.TASKS'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\30EF\30FC\30AF\30B7\30E7\30C3\30D7\30FB\30BF\30B9\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104774468079309069)
,p_name=>'APEX.SESSION_STATE.DB_COLUMN_SOURCE_USED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0%0\306F\30C7\30FC\30BF\30D9\30FC\30B9\5217\306B\57FA\3065\3044\3066\3044\307E\3059\304C\3001\5C5E\6027\300C\4F7F\7528\3055\308C\308B\30BD\30FC\30B9\300D\304C\300C\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\306E\5024\304CNULL\306E\5834\5408\306E\307F\300D\306B\8A2D\5B9A\3055\308C\3066\3044\307E\3059\3002\8907\6570\306E\30EC\30B3\30FC\30C9\3092\8868\793A\304A\3088\3073\4FDD\5B58\3059\308B\5834\5408\3001\3053\308C\306F\975E\5E38\306B\5371\967A\3067\3042\308A\3001\8AA4\3063\3066\30C7\30FC\30BF\3092\4E0A\66F8\304D\3059\308B\53EF\80FD\6027\304C\3042\308A\307E\3059\3002\5E38\306B\300C\4F7F\7528\3055\308C\308B\30BD\30FC\30B9\300D\3092\300C\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\306E\65E2\5B58\306E\5024\3092\5E38\306B\7F6E\63DB\300D\306B\8A2D\5B9A\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104711701257309010)
,p_name=>'APEX.SESSION_STATE.DISABLED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\3078\306E\30A2\30AF\30BB\30B9\306F\7121\52B9\3067\3059\3002\8AAD\53D6\308A/\66F8\8FBC\307F\306E\8A66\884C\306F\30D6\30ED\30C3\30AF\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103595188617308084)
,p_name=>'APEX.SESSION_STATE.INTERNAL_ONLY_VIOLATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\51E6\7406\4E2D\306B\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\306E\30A2\30A4\30C6\30E0%0\3092\4FDD\5B58\3057\3088\3046\3068\3057\307E\3057\305F\3002\30A2\30A4\30C6\30E0\306F\5185\90E8\306E\307F\306E\4FDD\8B77\304C\8A2D\5B9A\3055\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103587953123308079)
,p_name=>'APEX.SESSION_STATE.INTERNAL_ONLY_VIOLATION2'
,p_message_language=>'ja'
,p_message_text=>unistr('\53D7\5165\308C\51E6\7406\4E2D\306B\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\306E\30A2\30A4\30C6\30E0%0\3092\4FDD\5B58\3057\3088\3046\3068\3057\307E\3057\305F\3002\30A2\30A4\30C6\30E0\306F\5185\90E8\306E\307F\306E\4FDD\8B77\304C\8A2D\5B9A\3055\308C\3066\3044\308B\304B\3001\30DD\30B9\30C8\3067\304D\308B\30D5\30A9\30FC\30E0\30FB\30A2\30A4\30C6\30E0\3067\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103587726643308079)
,p_name=>'APEX.SESSION_STATE.SSP_VIOLATION2_FOR_DEVELOPERS'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30EA\30AF\30A8\30B9\30C8\3001\30AD\30E3\30C3\30B7\30E5\306E\30AF\30EA\30A2\3001\5F15\6570\540D\304A\3088\3073\5F15\6570\5024(%0)\3067\8A08\7B97\3055\308C\305F\30C1\30A7\30C3\30AF\30B5\30E0\306F\3001\8868\793A\30D7\30ED\30B7\30FC\30B8\30E3(%1)\306B\6E21\3055\308C\305F\30C1\30A7\30C3\30AF\30B5\30E0\3068\4E00\81F4\3057\307E\305B\3093\3067\3057\305F\3002'),
'',
unistr('\30CE\30FC\30C8: \30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\306F\7570\306A\308B\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\304C\8868\793A\3055\308C\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103587213738308078)
,p_name=>'APEX.SESSION_STATE.SSP_VIOLATION_FOR_DEVELOPERS'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8868\793A\51E6\7406\4E2D\306B\3001\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\306E\30A2\30A4\30C6\30E0%0\3092\4FDD\5B58\3057\3088\3046\3068\3057\307E\3057\305F\3002\30A2\30A4\30C6\30E0\4FDD\8B77\30EC\30D9\30EB:'),
'  %1',
'',
unistr('\30C1\30A7\30C3\30AF\30B5\30E0\304C\6E21\3055\308C\3066\3044\306A\3044\304B\3001\307E\305F\306F\6E21\3055\308C\305F\30C1\30A7\30C3\30AF\30B5\30E0\306F\4FDD\8B77\30EC\30D9\30EB%2\306E\30A2\30A4\30C6\30E0\306B\9069\3057\3066\3044\307E\3059\3002'),
'',
unistr('\30CE\30FC\30C8: \30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\306F\7570\306A\308B\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\304C\8868\793A\3055\308C\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103762235163308217)
,p_name=>'APEX.SESSION_STATE.UNHANDLED_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('ERR-1022 \5C5E\6027\3092\4FDD\5B58\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103531831960308039)
,p_name=>'APEX.SPATIAL.CANNOT_CONVERT_SDO_GEOMETRY_TO_GEOJSON'
,p_message_language=>'ja'
,p_message_text=>unistr('SDO_GEOMETRY\5024\3092GeoJSON\306B\5909\63DB\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103529300821308037)
,p_name=>'APEX.SPATIAL.CANNOT_CONVERT_TEXT_TO_SDO_GEOMETRY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8\3092SDO_GEOMETRY\30AA\30D6\30B8\30A7\30AF\30C8\306B\5909\63DB\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103530578321308038)
,p_name=>'APEX.SPATIAL.INVALID_GEOJSON'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306B\306F\3001\6709\52B9\306AGeoJSON\304C\542B\307E\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103546124146308049)
,p_name=>'APEX.TABULAR_FORM.COLUMN_DEFAULT_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217#COMPONENT_NAME#\306E\30C7\30D5\30A9\30EB\30C8\5024\3092\8A08\7B97\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103547016476308049)
,p_name=>'APEX.TABULAR_FORM.MRD.UNHANDLED_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\8907\6570\884C\306E\524A\9664\51E6\7406\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103789293105308239)
,p_name=>'APEX.TABULAR_FORM.MRU.FCS_MISSING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30A7\30C3\30AF\30B5\30E0\5217(\300CFCS\300D)\304C\5FC5\8981\3067\3059\304C\3001\6307\5B9A\3055\308C\307E\305B\3093\3067\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103789488965308239)
,p_name=>'APEX.TABULAR_FORM.MRU.NO_PRIM_KEY_VALS'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E3B\30AD\30FC\5024\304C\6307\5B9A\3055\308C\307E\305B\3093\3067\3057\305F\3002\66F4\65B0\3092\884C\3046\306B\306F\30011\884C\4EE5\4E0A\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103790205568308239)
,p_name=>'APEX.TABULAR_FORM.MRU.NO_SEC_KEY_VALS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6307\5B9A\3055\308C\305F2\6B21\30AD\30FC\5217\306B2\6B21\5024\304C\6307\5B9A\3055\308C\3066\3044\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103929810580308382)
,p_name=>'APEX.TABULAR_FORM.MRU.NO_VALUES'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\5F62\5F0F\306E\30C7\30FC\30BF\304C\898B\3064\304B\308A\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103789169960308239)
,p_name=>'APEX.TABULAR_FORM.MRU.PRIM_KEY_COL_NOT_SPECIFIED'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E3B\30AD\30FC\5217\304C\6307\5B9A\3055\308C\307E\305B\3093\3067\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103790117397308239)
,p_name=>'APEX.TABULAR_FORM.MRU.SEC_KEY_COL_NOT_IN_SELECT_LIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\6307\5B9A\3055\308C\305F2\6B21\30AD\30FC\5217\304C\3001\554F\5408\305B\306ESELECT\69CB\6587\306E\30EA\30B9\30C8\306B\898B\3064\304B\308A\307E\305B\3093\3067\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103789014213308239)
,p_name=>'APEX.TABULAR_FORM.MRU.TABLE_NAME_NOT_SPECIFIED'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\540D\304C\6307\5B9A\3055\308C\307E\305B\3093\3067\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103788990230308238)
,p_name=>'APEX.TABULAR_FORM.MRU.TABLE_OWNER_NOT_SPECIFIED'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\306E\6240\6709\8005\304C\6307\5B9A\3055\308C\307E\305B\3093\3067\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103810106713308255)
,p_name=>'APEX.TABULAR_FORM.MRU.UNHANDLED_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\8907\6570\884C\306E\66F4\65B0\51E6\7406\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103570389398308066)
,p_name=>'APEX.THEMES.COPY_THEME_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3"%1"\3067\30C6\30FC\30DE"%0"\3092\30B3\30D4\30FC\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104767912693309064)
,p_name=>'APEX.THEMES.INCOMPATIBLE_THEME'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30A4\30F3\30DD\30FC\30C8\3057\305F\30C6\30FC\30DE\306F\73FE\5728\306E\30C6\30FC\30DE\3068\4E92\63DB\6027\304C\3042\308A\307E\305B\3093\3002'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104750068288309042)
,p_name=>'APEX.THEMES.INVALID_THEME_NUMBER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\756A\53F7\304C\7121\52B9\3067\3042\308B\304B\3001\30C6\30FC\30DE\304C\73FE\5728\306EUI\30C6\30FC\30DE\3067\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104710876645309009)
,p_name=>'APEX.TREE.ID_AND_PARENT_ID_COLUMNS_REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\968E\5C64\306E\8A08\7B97\306B\5FC5\8981\306A\4E3B\30AD\30FC\5217\304A\3088\3073\89AA\30AD\30FC\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104710952993309009)
,p_name=>'APEX.TREE.NODE_LEVEL_AND_STATUS_COLUMNS_REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\968E\5C64\304C\8A08\7B97\3055\308C\306A\3044\5834\5408\306B\5FC5\8981\306A\30CE\30FC\30C9\30FB\30EC\30D9\30EB\5217\304A\3088\3073\30CE\30FC\30C9\30FB\30B9\30C6\30FC\30BF\30B9\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104729256640309025)
,p_name=>'APEX.UI.APPEARANCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5916\89B3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104488278668308829)
,p_name=>'APEX.UI.AUTO_MODE'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103702776697308169)
,p_name=>'APEX.UI.DARK_MODE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C0\30FC\30AF\30FB\30E2\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103702893009308169)
,p_name=>'APEX.UI.DISABLED'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104488144110308829)
,p_name=>'APEX.UI.LIGHT_MODE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8EFD\91CF\30E2\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104131677336308543)
,p_name=>'APEX.UI_TYPE.CLIENT_DETECTION.DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306B\793A\3059\30EA\30B9\30C8\304B\3089\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\3092\9078\629E\3057\3066\304F\3060\3055\3044:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104133976637308545)
,p_name=>'APEX.UI_TYPE.CLIENT_DETECTION.TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('%0 - \30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\306E\9078\629E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103673452220308145)
,p_name=>'APEX.USER.CHECK_SGID'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0D\5F53\306A\30A2\30AF\30BB\30B9\3067\3059(\30BB\30AD\30E5\30EA\30C6\30A3\30FB\30B0\30EB\30FC\30D7\30FB\30D1\30C3\30B1\30FC\30B8\5909\6570\304C\8A2D\5B9A\3055\308C\3066\3044\307E\305B\3093)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103673854813308146)
,p_name=>'APEX.USER.FETCH_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\691C\7D22\60C5\5831\3092\30D5\30A7\30C3\30C1\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103659641497308135)
,p_name=>'APEX.USER.NOT_ADMIN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC%0\306B\306F\3001\3053\306E\64CD\4F5C\3092\5B9F\884C\3059\308BADMIN\6A29\9650\304C\5FC5\8981\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103673720359308145)
,p_name=>'APEX.USER.NO_EMAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC%0\306F\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9\3092\6307\5B9A\3057\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103629597244308112)
,p_name=>'APEX.USER.UNAUTHORIZED'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0D\5F53\306A\30A2\30AF\30BB\30B9\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103673629402308145)
,p_name=>'APEX.USER.USER_DOES_NOT_EXIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC%0\306F\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103588694110308079)
,p_name=>'APEX.VALIDATION.INVALID_EDITABLE_REGION'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C"%0"\306B\7121\52B9\306A(\8907\6570\884C\3067\306A\3044)\7DE8\96C6\53EF\80FD\30EA\30FC\30B8\30E7\30F3\304C\5272\308A\5F53\3066\3089\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103762339993308217)
,p_name=>'APEX.VALIDATION.UNHANDLED_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C\51E6\7406\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104712118146309010)
,p_name=>'APEX.WEBSRC.CANNOT_PARSE_DATA'
,p_message_language=>'ja'
,p_message_text=>unistr('Application Express\306F\30BF\30A4\30D7: %0\306E\30EC\30B9\30DD\30F3\30B9\30FB\30C7\30FC\30BF\304B\3089\30C7\30FC\30BF\30FB\30D7\30ED\30D5\30A1\30A4\30EB\3092\8A08\7B97\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104178889028308592)
,p_name=>'APEX.WEBSRC.DATAPROFILE.MANY'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104178733250308591)
,p_name=>'APEX.WEBSRC.DATAPROFILE.ONE'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104698760368308999)
,p_name=>'APEX.WEBSRC.FILTER_EXPR_INVALID_JSON'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30EB\30BF\5F0F\306F\6709\52B9\306AJSON\3067\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104691989749308993)
,p_name=>'APEX.WEBSRC.FILTER_NOT_SUPPORTED_BY_ORDS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30EB\30BF\306F\3001Oracle REST Data Services\3067\306F\30B5\30DD\30FC\30C8\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104070833218308492)
,p_name=>'APEX.WEBSRC.HTTP.PAGINATION_PARAMETER_CONFLICT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\533A\5207\308AURL\30D1\30E9\30E1\30FC\30BF"%0"\306FREST\30BD\30FC\30B9\30FB\30D1\30E9\30E1\30FC\30BF\3068\7AF6\5408\3057\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104173790125308587)
,p_name=>'APEX.WEBSRC.HTTP200'
,p_message_language=>'ja'
,p_message_text=>unistr('HTTP 200: \6210\529F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104173897760308587)
,p_name=>'APEX.WEBSRC.HTTP201'
,p_message_language=>'ja'
,p_message_text=>unistr('HTTP 201: \4F5C\6210\3055\308C\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104173258013308586)
,p_name=>'APEX.WEBSRC.HTTP400'
,p_message_language=>'ja'
,p_message_text=>unistr('HTTP 400: \4E0D\6B63\306A\30EA\30AF\30A8\30B9\30C8\3067\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104173060762308586)
,p_name=>'APEX.WEBSRC.HTTP401'
,p_message_language=>'ja'
,p_message_text=>unistr('HTTP 401: \8A8D\8A3C\306B\5931\6557\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104173380280308587)
,p_name=>'APEX.WEBSRC.HTTP403'
,p_message_language=>'ja'
,p_message_text=>unistr('HTTP 403: \8A31\53EF\3055\308C\3066\3044\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104173190943308586)
,p_name=>'APEX.WEBSRC.HTTP404'
,p_message_language=>'ja'
,p_message_text=>unistr('HTTP 404: \898B\3064\304B\308A\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104173425086308587)
,p_name=>'APEX.WEBSRC.HTTP405'
,p_message_language=>'ja'
,p_message_text=>unistr('HTTP 405: \30E1\30BD\30C3\30C9\306F\8A31\53EF\3055\308C\3066\3044\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103531112693308038)
,p_name=>'APEX.WEBSRC.HTTP407'
,p_message_language=>'ja'
,p_message_text=>unistr('HTTP 407: \30D7\30ED\30AD\30B7\8A8D\8A3C\304C\5FC5\8981\3067\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103531443071308038)
,p_name=>'APEX.WEBSRC.HTTP409'
,p_message_language=>'ja'
,p_message_text=>unistr('HTTP 409: \7AF6\5408')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103531205493308038)
,p_name=>'APEX.WEBSRC.HTTP412'
,p_message_language=>'ja'
,p_message_text=>unistr('HTTP 412: \524D\63D0\6761\4EF6\3067\5931\6557\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103531376336308038)
,p_name=>'APEX.WEBSRC.HTTP428'
,p_message_language=>'ja'
,p_message_text=>unistr('HTTP 428: \524D\63D0\6761\4EF6\304C\5FC5\8981\3067\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104173540436308587)
,p_name=>'APEX.WEBSRC.HTTP500'
,p_message_language=>'ja'
,p_message_text=>unistr('HTTP 500: \5185\90E8\30B5\30FC\30D0\30FC\30FB\30A8\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104173665424308587)
,p_name=>'APEX.WEBSRC.HTTP502'
,p_message_language=>'ja'
,p_message_text=>unistr('HTTP 502: \4E0D\6B63\306A\30B2\30FC\30C8\30A6\30A7\30A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104712527290309011)
,p_name=>'APEX.WEBSRC.HTTP503'
,p_message_language=>'ja'
,p_message_text=>unistr('HTTP 503: \30B5\30FC\30D3\30B9\4F7F\7528\4E0D\53EF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104712656876309011)
,p_name=>'APEX.WEBSRC.HTTP504'
,p_message_language=>'ja'
,p_message_text=>unistr('HTTP 504: \30B2\30FC\30C8\30A6\30A7\30A4\30FB\30BF\30A4\30E0\30A2\30A6\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104554704007308878)
,p_name=>'APEX.WEBSRC.HTTP_ERROR_OCCURRED'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\30C7\30FC\30BF\30FB\30BD\30FC\30B9\306FHTTP\30A8\30E9\30FC\3092\623B\3057\307E\3057\305F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104172895471308586)
,p_name=>'APEX.WEBSRC.MODULE_NOT_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\30C7\30FC\30BF\30FB\30BD\30FC\30B9\304C\898B\3064\304B\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103728644776308190)
,p_name=>'APEX.WEBSRC.NO_ARRAY_SELECTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\30BB\30EC\30AF\30BF"%0"\306F\3001\30AA\30D6\30B8\30A7\30AF\30C8\306E\914D\5217\3092\8868\3068\3057\3066\51E6\7406\3059\308B\3088\3046\306B\9078\629E\3057\307E\305B\3093\3067\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103728721177308190)
,p_name=>'APEX.WEBSRC.NO_SINGLE_ROW_SELECTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\30BB\30EC\30AF\30BF"%0"\306F\3001\30AA\30D6\30B8\30A7\30AF\30C8\3092\5358\4E00\884C\3068\3057\3066\51E6\7406\3059\308B\3088\3046\306B\9078\629E\3057\307E\305B\3093\3067\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103534379980308040)
,p_name=>'APEX.WEBSRC.RATELIMIT_EXCEEDED'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\30C7\30FC\30BF\30FB\30BD\30FC\30B9\306E\30EC\30FC\30C8\5236\9650(%1\79D2\5185\306B%0\30EA\30AF\30A8\30B9\30C8)\3092\8D85\3048\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103523309691308032)
,p_name=>'APEX.WEBSRC.RATELIMIT_EXCEEDED_CANNOT_WAIT'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\30C7\30FC\30BF\30FB\30BD\30FC\30B9\306E\30EC\30FC\30C8\5236\9650(%1\79D2\5185\306B%0\30EA\30AF\30A8\30B9\30C8)\3092\8D85\3048\307E\3057\305F\3002\5FC5\8981\306A\5F85\6A5F\6642\9593\304C\9577\3059\304E\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104554604524308878)
,p_name=>'APEX.WEBSRC.REQUIRED_PARAM_MISSING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7"%1"\306E\5FC5\9808REST\30BD\30FC\30B9IN\30D1\30E9\30E1\30FC\30BF"%0"\306B\5024\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104472631123308811)
,p_name=>'APEX.WEBSRC.RESPONSE_BODY_TOO_LARGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30B9\30DD\30F3\30B9\672C\6587\304C\5927\304D\3059\304E\308B\305F\3081\3001\8868\793A\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104138001400308548)
,p_name=>'APEX.WEBSRC.SMALL_ORDS2_FIXED_PAGE_SIZE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30AC\30B7\30FCORDS REST\30B5\30FC\30D3\30B9\3067\306F\3001\5C0F\3055\3044\56FA\5B9A\30DA\30FC\30B8\30FB\30B5\30A4\30BA\3092\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103537914360308043)
,p_name=>'APEX.WEBSRC.SYNC.API_CALL_COMMENT'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('-- \3053\306EAPI\30B3\30FC\30EB\306F\3001ALTER TABLE\6587\3092\5B9F\884C\3059\308B\3053\3068\3067\3001'),
unistr('-- \8868\306E\5217\3092REST\30C7\30FC\30BF\30FB\30BD\30FC\30B9\306E\30C7\30FC\30BF\30FB\30D7\30ED\30D5\30A1\30A4\30EB\306B\52D5\7684\306B\540C\671F\5316\3057\307E\3059\3002'),
unistr('-- ALTER TABLE\3092\4F7F\7528\3057\3066\5217\306E\30C7\30FC\30BF\578B\3092\5909\66F4\3067\304D\306A\3044\5834\5408\3001'),
unistr('-- \30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\304C\751F\6210\3055\308C\307E\3059\3002'),
'--'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103536893749308042)
,p_name=>'APEX.WEBSRC.SYNC.CANNOT_SYNC_TABLE_COLUMNS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30D7\30ED\30D5\30A1\30A4\30EB\306E\5909\66F4\3092\81EA\52D5\7684\306B\9069\7528\3067\304D\307E\305B\3093\3002\30ED\30FC\30AB\30EB\8868\306E\5217\3092\624B\52D5\3067\8ABF\6574\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103538026928308043)
,p_name=>'APEX.WEBSRC.SYNC.DDL_CALL_COMMENT'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('-- %0\306E\6642\70B9\3067\3053\308C\306F\6B21\3092\5B9F\884C\3057\307E\3059:'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103536040084308041)
,p_name=>'APEX.WEBSRC.SYNC.MERGE_REQUIRES_PRIMARY_KEY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30FC\30B8\540C\671F\5316\30E1\30BD\30C3\30C9\3067\306F\3001\30C7\30FC\30BF\30FB\30D7\30ED\30D5\30A1\30A4\30EB\306B\4E3B\30AD\30FC\3092\5B9A\7FA9\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103536329349308042)
,p_name=>'APEX.WEBSRC.SYNC.NO_COMMON_COLUMNS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30FC\30AB\30EB\8868\3068\30C7\30FC\30BF\30FB\30D7\30ED\30D5\30A1\30A4\30EB\306B\5171\901A\306E\5217\304C\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103522909569308032)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_ABORTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B8\30E7\30D6\304C\4E2D\65AD\3055\308C\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103536546126308042)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_FAILURE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5931\6557')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103536601825308042)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_INCOMPLETE'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0D\5B8C\5168(\30EA\30AF\30A8\30B9\30C8\5236\9650\8D85\904E)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103536757252308042)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_JOB_ALREADY_RUNNING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B8\30E7\30D6\306F\3059\3067\306B\5B9F\884C\4E2D\3067\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103523840707308033)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_RUNNING'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9F\884C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103523955409308033)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_SCHEDULED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30B1\30B8\30E5\30FC\30EB\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103536414727308042)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_SUCCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6210\529F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103536125437308042)
,p_name=>'APEX.WEBSRC.SYNC.STEP_STATIC_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\540C\671F\5316\30B9\30C6\30C3\30D7%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103536297525308042)
,p_name=>'APEX.WEBSRC.SYNC.STEP_STATIC_LABEL_COPY'
,p_message_language=>'ja'
,p_message_text=>unistr('%0 (\65B0\898F)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104020979126308451)
,p_name=>'APEX.WEBSRC.TEST_OPERATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30B9\30C8\64CD\4F5C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104092054840308510)
,p_name=>'APEX.WEBSRC.TIMEOUT_EXCEEDED'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\306EREST\30BD\30FC\30B9\30FB\30C7\30FC\30BF\306E\30D5\30A7\30C3\30C1\4E2D\306B\30BF\30A4\30E0\30A2\30A6\30C8\3092\8D85\3048\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104067931208308490)
,p_name=>'APEX.WEBSRC.TOO_MANY_NEXT_PAGE_REQUESTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30ED\30FC\30AB\30EBSQL\30D5\30A3\30EB\30BF\304CREST\30B5\30FC\30D3\30B9\306B\5BFE\3057\3066\8981\6C42\3059\308B\300C\6B21\306E\30DA\30FC\30B8\300D\30EA\30AF\30A8\30B9\30C8\304C\591A\3059\304E\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104137928184308548)
,p_name=>'APEX.WEBSRC.UNKNOWN_ORDS2_FIXED_PAGE_SIZE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30AC\30B7\30FCORDS REST\30B5\30FC\30D3\30B9\306E\56FA\5B9A\30DA\30FC\30B8\30FB\30B5\30A4\30BA\304C\4E0D\660E\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103844314489308281)
,p_name=>'APEXAPP.BRANCH.ADMIN'
,p_message_language=>'ja'
,p_message_text=>unistr('\7BA1\7406\30DA\30FC\30B8\306B\30D6\30E9\30F3\30C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103818877611308262)
,p_name=>'APEXAPP.BREADCRUMB.DEFAULT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103840417206308278)
,p_name=>'APEXAPP.BUILD_OPTION.COMMENTED_OUT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30E1\30F3\30C8\30FB\30A2\30A6\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103824983018308266)
,p_name=>'APEXAPP.BUTTON.ADD'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103825237569308266)
,p_name=>'APEXAPP.BUTTON.ADD_ENTITY'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103825696606308267)
,p_name=>'APEXAPP.BUTTON.ADD_MULTIPLE_USERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\8907\6570\30E6\30FC\30B6\30FC\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103825766848308267)
,p_name=>'APEXAPP.BUTTON.ADD_USER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103825871885308267)
,p_name=>'APEXAPP.BUTTON.ADD_USERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103824649661308266)
,p_name=>'APEXAPP.BUTTON.APPLY'
,p_message_language=>'ja'
,p_message_text=>unistr('\5909\66F4\306E\9069\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103824734471308266)
,p_name=>'APEXAPP.BUTTON.CANCEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\53D6\6D88')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103824816358308266)
,p_name=>'APEXAPP.BUTTON.CLOSE'
,p_message_language=>'ja'
,p_message_text=>unistr('\9589\3058\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103824547201308266)
,p_name=>'APEXAPP.BUTTON.CREATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103813819797308258)
,p_name=>'APEXAPP.BUTTON.DELETE'
,p_message_language=>'ja'
,p_message_text=>unistr('\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103825090261308266)
,p_name=>'APEXAPP.BUTTON.DELETE_CHECKED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30A7\30C3\30AF\3057\305F\9805\76EE\306E\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103825147039308266)
,p_name=>'APEXAPP.BUTTON.EDIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103825339422308266)
,p_name=>'APEXAPP.BUTTON.FINISH'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D42\4E86')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103813685934308258)
,p_name=>'APEXAPP.BUTTON.GO'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9F\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103814398705308258)
,p_name=>'APEXAPP.BUTTON.LOAD_DATA'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\306E\30ED\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103825470555308267)
,p_name=>'APEXAPP.BUTTON.LOGIN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30A4\30F3\30A4\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103814033572308258)
,p_name=>'APEXAPP.BUTTON.NEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103813915886308258)
,p_name=>'APEXAPP.BUTTON.PREVIOUS'
,p_message_language=>'ja'
,p_message_text=>unistr('\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103813782794308258)
,p_name=>'APEXAPP.BUTTON.RESET'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30BB\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103814129693308258)
,p_name=>'APEXAPP.BUTTON.SAVE'
,p_message_language=>'ja'
,p_message_text=>unistr('\4FDD\5B58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103814231740308258)
,p_name=>'APEXAPP.BUTTON.SUBMIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\9001\4FE1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103825975864308267)
,p_name=>'APEXAPP.BUTTON.SUBMIT_FEEDBACK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30FC\30C9\30D0\30C3\30AF\306E\9001\4FE1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103825543354308267)
,p_name=>'APEXAPP.BUTTON.VIEW_DETAILS'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A73\7D30\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103818703893308261)
,p_name=>'APEXAPP.CHART.LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103837990362308276)
,p_name=>'APEXAPP.CHART.SERIES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30EA\30FC\30BA%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103830306912308270)
,p_name=>'APEXAPP.COLUMN.ACL_ROLES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103818563796308261)
,p_name=>'APEXAPP.COLUMN.ACTIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103829361053308270)
,p_name=>'APEXAPP.COLUMN.ACTIVITY_BY_HOUR'
,p_message_language=>'ja'
,p_message_text=>unistr('\6642\9593\3054\3068\306E\30A2\30AF\30C6\30A3\30D3\30C6\30A3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103828631687308269)
,p_name=>'APEXAPP.COLUMN.APPLICATION_SESSIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30BB\30C3\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103818418011308261)
,p_name=>'APEXAPP.COLUMN.ATTACHMENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6DFB\4ED8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103817623482308261)
,p_name=>'APEXAPP.COLUMN.AUTOMATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\52D5\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103828210018308269)
,p_name=>'APEXAPP.COLUMN.AVG_ELAPSED'
,p_message_language=>'ja'
,p_message_text=>unistr('\5E73\5747\7D4C\904E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103827628658308268)
,p_name=>'APEXAPP.COLUMN.COMPONENT_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30DD\30FC\30CD\30F3\30C8\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103829264891308270)
,p_name=>'APEXAPP.COLUMN.CONTEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103826563450308267)
,p_name=>'APEXAPP.COLUMN.CURRENT_STATUS'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\884C\306E\30B9\30C6\30FC\30BF\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103826249062308267)
,p_name=>'APEXAPP.COLUMN.DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\8AAC\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103828558105308269)
,p_name=>'APEXAPP.COLUMN.DISTINCT_USERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\500B\5225\30E6\30FC\30B6\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103817456279308260)
,p_name=>'APEXAPP.COLUMN.EDIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103827361220308268)
,p_name=>'APEXAPP.COLUMN.ELAPSED'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D4C\904E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103830241888308270)
,p_name=>'APEXAPP.COLUMN.ENDED'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D42\4E86')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103827985101308269)
,p_name=>'APEXAPP.COLUMN.ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103817572328308261)
,p_name=>'APEXAPP.COLUMN.ERRORS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103830142168308270)
,p_name=>'APEXAPP.COLUMN.ERROR_ROWS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103826036534308267)
,p_name=>'APEXAPP.COLUMN.FEATURE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A5F\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103818167959308261)
,p_name=>'APEXAPP.COLUMN.FEEDBACK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30FC\30C9\30D0\30C3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103817920392308261)
,p_name=>'APEXAPP.COLUMN.FILED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103830583949308271)
,p_name=>'APEXAPP.COLUMN.FILED_BY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103829092787308269)
,p_name=>'APEXAPP.COLUMN.FULL_PAGE_VIEWS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5168\4F53\30DA\30FC\30B8\30FB\30D3\30E5\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103827849035308268)
,p_name=>'APEXAPP.COLUMN.IR_SEARCH'
,p_message_language=>'ja'
,p_message_text=>unistr('IR\691C\7D22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103826616162308267)
,p_name=>'APEXAPP.COLUMN.LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103826929831308268)
,p_name=>'APEXAPP.COLUMN.LAST_ACTIVITY'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5F8C\306E\30A2\30AF\30C6\30A3\30D3\30C6\30A3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103828188894308269)
,p_name=>'APEXAPP.COLUMN.MAX_ELAPSED'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5927\7D4C\904E\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103828325922308269)
,p_name=>'APEXAPP.COLUMN.MEDIAN_ELAPSED'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E2D\9593\7D4C\904E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103829760827308270)
,p_name=>'APEXAPP.COLUMN.MESSAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E1\30C3\30BB\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103829816610308270)
,p_name=>'APEXAPP.COLUMN.MESSAGE_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E1\30C3\30BB\30FC\30B8\30FB\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103828030746308269)
,p_name=>'APEXAPP.COLUMN.MIN_ELAPSED'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5C0F\7D4C\904E\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103829639715308270)
,p_name=>'APEXAPP.COLUMN.MOST_RECENT'
,p_message_language=>'ja'
,p_message_text=>'Most_Recent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103827743943308268)
,p_name=>'APEXAPP.COLUMN.NUM_ROWS'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103829195454308269)
,p_name=>'APEXAPP.COLUMN.OCCURRENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\767A\751F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103827478258308268)
,p_name=>'APEXAPP.COLUMN.PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103829475249308270)
,p_name=>'APEXAPP.COLUMN.PAGE_EVENTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30A4\30D9\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103827528343308268)
,p_name=>'APEXAPP.COLUMN.PAGE_MODE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E2\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103827089540308268)
,p_name=>'APEXAPP.COLUMN.PAGE_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103828795493308269)
,p_name=>'APEXAPP.COLUMN.PAGE_VIEWS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30D3\30E5\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103828978242308269)
,p_name=>'APEXAPP.COLUMN.PARTIAL_PAGE_VIEWS'
,p_message_language=>'ja'
,p_message_text=>unistr('\90E8\5206\30DA\30FC\30B8\30FB\30D3\30E5\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103829983923308270)
,p_name=>'APEXAPP.COLUMN.PK_VALUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E3B\30AD\30FC\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103818046511308261)
,p_name=>'APEXAPP.COLUMN.RATING'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A55\4FA1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103830464701308270)
,p_name=>'APEXAPP.COLUMN.REASON'
,p_message_language=>'ja'
,p_message_text=>unistr('\7406\7531')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103818261470308261)
,p_name=>'APEXAPP.COLUMN.RESPONSE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30B9\30DD\30F3\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103829536714308270)
,p_name=>'APEXAPP.COLUMN.ROWS_FETCHED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A7\30C3\30C1\3055\308C\305F\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103817864511308261)
,p_name=>'APEXAPP.COLUMN.SCHEDULED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30B1\30B8\30E5\30FC\30EB\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103817771774308261)
,p_name=>'APEXAPP.COLUMN.STARTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103826115674308267)
,p_name=>'APEXAPP.COLUMN.STATUS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30C6\30FC\30BF\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103830033067308270)
,p_name=>'APEXAPP.COLUMN.SUCCESSFUL_ROWS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6210\529F\3057\305F\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103827211065308268)
,p_name=>'APEXAPP.COLUMN.TIMESTAMP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30E0\30B9\30BF\30F3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103828807419308269)
,p_name=>'APEXAPP.COLUMN.TOTAL_ROWS'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\5408\8A08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103826450672308267)
,p_name=>'APEXAPP.COLUMN.UPDATED_BY'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F4\65B0\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103826381823308267)
,p_name=>'APEXAPP.COLUMN.UPDATED_ON'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F4\65B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103827194242308268)
,p_name=>'APEXAPP.COLUMN.USER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103826825907308268)
,p_name=>'APEXAPP.COLUMN.USERNAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103818356124308261)
,p_name=>'APEXAPP.COLUMN.USER_AGENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\30FB\30A8\30FC\30B8\30A7\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103826777201308268)
,p_name=>'APEXAPP.COLUMN.VALUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103828444722308269)
,p_name=>'APEXAPP.COLUMN.WEIGHTED_PERFORMANCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\91CD\307F\4ED8\3051\30D1\30D5\30A9\30FC\30DE\30F3\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103811018773308256)
,p_name=>'APEXAPP.DA.AFTER_CLOSE_DIALOG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C0\30A4\30A2\30ED\30B0\306E\30AF\30ED\30FC\30BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103823923984308265)
,p_name=>'APEXAPP.DA.CANCEL_BUTTON.DIALOG_CANCEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C0\30A4\30A2\30ED\30B0\3092\53D6\308A\6D88\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103824448937308266)
,p_name=>'APEXAPP.DA.CHANGE_FILTERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30EB\30BF\306E\5909\66F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103824010367308265)
,p_name=>'APEXAPP.DA.CREATE_BUTTON.DIALOG_CLOSED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3\306E\4F5C\6210 - \30C0\30A4\30A2\30ED\30B0\306E\30AF\30ED\30FC\30BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103824193311308266)
,p_name=>'APEXAPP.DA.EDIT_REPORT.DIALOG_CLOSED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\306E\7DE8\96C6 - \30C0\30A4\30A2\30ED\30B0\306E\30AF\30ED\30FC\30BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103824252260308266)
,p_name=>'APEXAPP.DA.PERFORM_SEARCH'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22\306E\5B9F\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103824352263308266)
,p_name=>'APEXAPP.DA.REFRESH_REPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\306E\30EA\30D5\30EC\30C3\30B7\30E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103813577116308257)
,p_name=>'APEXAPP.DATA_LOAD.CHAR_SET_ITEM_HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\306E\6587\5B57\30BB\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103813157293308257)
,p_name=>'APEXAPP.ITEM.ACL_ROLES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103836779894308275)
,p_name=>'APEXAPP.ITEM.ACL_ROLES.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30A2\30AF\30BB\30B9\5236\5FA1\304C\6709\52B9\306A\5834\5408\3001\7BA1\7406\8005\306F\3001\7279\5B9A\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\6A5F\80FD\3078\306E\30A2\30AF\30BB\30B9\3092\8A8D\8A3C\3055\308C\305F\30E6\30FC\30B6\30FC\306B\5236\9650\3067\304D\307E\3059\3002\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\306F\3001\30EA\30FC\30C0\30FC\3001\30B3\30F3\30C8\30EA\30D3\30E5\30FC\30BF\304A\3088\3073\7BA1\7406\8005\3068\3044\30463\3064\306E\30ED\30FC\30EB\304C\30B5\30DD\30FC\30C8\3055\308C\307E\3059\3002<p>'),
'<ul>',
unistr('  <li><strong>\30EA\30FC\30C0\30FC</strong>\306F\3001\3059\3079\3066\306E\60C5\5831\306B\5BFE\3059\308B\8AAD\53D6\308A\5C02\7528\30A2\30AF\30BB\30B9\6A29\3092\6301\3061\3001\30EC\30DD\30FC\30C8\3092\53C2\7167\3067\304D\307E\3059\3002</li>'),
unistr('  <li><strong>\30B3\30F3\30C8\30EA\30D3\30E5\30FC\30BF</strong>\306F\3001\60C5\5831\306E\4F5C\6210\3001\7DE8\96C6\304A\3088\3073\524A\9664\304C\53EF\80FD\3067\3001\30EC\30DD\30FC\30C8\3092\53C2\7167\3067\304D\307E\3059\3002</li>'),
unistr('  <li><strong>\7BA1\7406\8005</strong>\306F\3001\30B3\30F3\30C8\30EA\30D3\30E5\30FC\30BF\306E\6A5F\80FD\306B\52A0\3048\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\69CB\6210\3092\5B9F\884C\3067\304D\307E\3059\3002</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103836501635308275)
,p_name=>'APEXAPP.ITEM.ANY_USER_HAS_ACCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\3055\308C\305F\30E6\30FC\30B6\30FC\306F\3001\8AB0\3067\3082\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\30A2\30AF\30BB\30B9\3067\304D\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103836615084308275)
,p_name=>'APEXAPP.ITEM.ANY_USER_HAS_ACCESS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\306E\30E6\30FC\30B6\30FC\304C\30A2\30AF\30BB\30B9\5236\5FA1\30EA\30B9\30C8\306B\5B9A\7FA9\3055\308C\3066\3044\308B\5834\5408\3001<strong>\300C\3044\3044\3048\300D</strong>\3092\9078\629E\3057\307E\3059\3002\30A2\30AF\30BB\30B9\5236\5FA1\30EA\30B9\30C8\306B\5B58\5728\3057\306A\3044\8A8D\8A3C\3055\308C\305F\30E6\30FC\30B6\30FC\3082\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\4F7F\7528\3059\308B\5834\5408\3001<strong>\300C\306F\3044\300D</strong>\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103834871492308274)
,p_name=>'APEXAPP.ITEM.APP_DATE_FORMAT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F7F\7528\3059\308B\65E5\4ED8/\6570\5024\66F8\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103834991419308274)
,p_name=>'APEXAPP.ITEM.APP_DATE_FORMAT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30B9\30BF\30E0\66F8\5F0F\30DE\30B9\30AF\3092\6307\5B9A\3059\308B\304B\3001\6A19\6E96\66F8\5F0F\30DE\30B9\30AF\3092\4F7F\7528\3059\308B\304B\3092\9078\629E\3057\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103837393531308276)
,p_name=>'APEXAPP.ITEM.ATTACHMENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6DFB\4ED8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103836323965308275)
,p_name=>'APEXAPP.ITEM.AUTOMATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\52D5\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103835047498308274)
,p_name=>'APEXAPP.ITEM.CHAR_SET'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\306E\6587\5B57\30BB\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103833892544308273)
,p_name=>'APEXAPP.ITEM.COPY_PASTE'
,p_message_language=>'ja'
,p_message_text=>unistr('\533A\5207\308A\30C7\30FC\30BF\3092\30B3\30D4\30FC\30FB\30A2\30F3\30C9\30FB\30DA\30FC\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103835141750308274)
,p_name=>'APEXAPP.ITEM.CURRENCY'
,p_message_language=>'ja'
,p_message_text=>unistr('\901A\8CA8\8A18\53F7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103835268527308274)
,p_name=>'APEXAPP.ITEM.CURRENCY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\306B\56FD\969B\901A\8CA8\8A18\53F7\304C\542B\307E\308C\3066\3044\308B\5834\5408\306F\3001\305D\306E\8A18\53F7\3092\3053\3053\306B\5165\529B\3057\3066\304F\3060\3055\3044\3002\305F\3068\3048\3070\3001\30C7\30FC\30BF\306B&euro;1,234.56\307E\305F\306F&yen;1,234.56\304C\542B\307E\308C\3066\3044\308B\5834\5408\306F\3001&euro;\307E\305F\306F&yen;\3068\5165\529B\3057\3066\304F\3060\3055\3044\3002\5165\529B\3057\306A\3044\5834\5408\3001\30C7\30FC\30BF\306F\6B63\5E38\306B\30ED\30FC\30C9\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103833545576308273)
,p_name=>'APEXAPP.ITEM.DATA_LOAD_IMPORT_FROM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30DD\30FC\30C8\5143')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103835579521308274)
,p_name=>'APEXAPP.ITEM.DECIMAL_CHARACTER_HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C0F\6570\70B9\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103835666766308274)
,p_name=>'APEXAPP.ITEM.DECIMAL_CHARACTER_HELP.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5C0F\6570\70B9\6587\5B57\306F\3001\6570\5024\306E\6574\6570\90E8\5206\3068\5C0F\6570\90E8\5206\3092\533A\5207\308A\307E\3059\3002</p>'),
unistr('<p>\5C0F\6570\70B9\6587\5B57\306B\306F\3001\4EFB\610F\306E\6587\5B57\3092\6307\5B9A\3067\304D\307E\3059\3002\6307\5B9A\3057\305F\6587\5B57\306F\30B7\30F3\30B0\30EB\30D0\30A4\30C8\3067\3001\5C0F\6570\70B9\6587\5B57\306F\30B0\30EB\30FC\30D7\30FB\30BB\30D1\30EC\30FC\30BF\3068\7570\306A\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\5C0F\6570\70B9\6587\5B57\306B\306F\3001\7A7A\767D\3092\6307\5B9A\3067\304D\307E\3059\304C\3001\6570\5B57\304A\3088\3073\6B21\306B\793A\3059\6587\5B57\306F\6307\5B9A\3067\304D\307E\305B\3093\3002</p>'),
'<ul class="noIndent">',
unistr('<li>\30D7\30E9\30B9(+)</li>'),
unistr('<li>\30CF\30A4\30D5\30F3(-)</li> '),
unistr('<li>\5C0F\306A\308A\8A18\53F7(<)</li>'),
unistr('<li>\5927\306A\308A\8A18\53F7(>)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103812786689308257)
,p_name=>'APEXAPP.ITEM.DISPLAY'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103837476210308276)
,p_name=>'APEXAPP.ITEM.ENABLE_ATTACHEMENTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6DFB\4ED8\6709\52B9\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103834128334308273)
,p_name=>'APEXAPP.ITEM.ENCLOSED_BY'
,p_message_language=>'ja'
,p_message_text=>unistr('\56F2\307F\6587\5B57(\30AA\30D7\30B7\30E7\30F3)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103813022460308257)
,p_name=>'APEXAPP.ITEM.ENCLOSED_BY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30EA\30DF\30BF\6587\5B57\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002\3053\306E\6587\5B57\3092\4F7F\7528\3057\3066\3001\30C7\30FC\30BF\5024\306E\958B\59CB\5883\754C\304A\3088\3073\7D42\4E86\5883\754C\3092\5B9A\3081\308B\3053\3068\304C\3067\304D\307E\3059\3002\30C7\30EA\30DF\30BF\6587\5B57\3092\6307\5B9A\3059\308B\3068\3001\30C7\30FC\30BF\30FB\30EF\30FC\30AF\30B7\30E7\30C3\30D7\3067\306F\30C7\30FC\30BF\5024\306E\958B\59CB\5883\754C\304A\3088\3073\7D42\4E86\5883\754C\306E\524D\306E\7A7A\767D\304C\7121\8996\3055\308C\307E\3059\3002\307E\305F\3001\3053\306E\30AA\30D7\30B7\30E7\30F3\3092\4F7F\7528\3057\3066\3001\6307\5B9A\3057\305F\30C7\30EA\30DF\30BF\6587\5B57\3067\30C7\30FC\30BF\5024\3092\56F2\3080\3053\3068\304C\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103837241460308276)
,p_name=>'APEXAPP.ITEM.EXPERIENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30AF\30B9\30DA\30EA\30A8\30F3\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103834587164308274)
,p_name=>'APEXAPP.ITEM.FAILED_COUNT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5931\6557\3057\305F\884C:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103813269192308257)
,p_name=>'APEXAPP.ITEM.FEEDBACK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30FC\30C9\30D0\30C3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103837575898308276)
,p_name=>'APEXAPP.ITEM.FILED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103833651197308273)
,p_name=>'APEXAPP.ITEM.FILE_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103833753495308273)
,p_name=>'APEXAPP.ITEM.FILE_NAME.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30C3\30D7\30ED\30FC\30C9\3059\308B\30D5\30A1\30A4\30EB\306E\540D\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103834257050308273)
,p_name=>'APEXAPP.ITEM.FIRST_ROW.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\306E\6700\521D\306E\884C\306B\5217\540D\304C\542B\307E\308C\308B\5834\5408\306F\3001\3053\306E\30DC\30C3\30AF\30B9\3092\9078\629E\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103835344083308274)
,p_name=>'APEXAPP.ITEM.GROUP_SEPARATOR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30EB\30FC\30D7\30FB\30BB\30D1\30EC\30FC\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103835453944308274)
,p_name=>'APEXAPP.ITEM.GROUP_SEPARATOR.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30B0\30EB\30FC\30D7\30FB\30BB\30D1\30EC\30FC\30BF\306F\3001\5343\306E\4F4D\3084\767E\4E07\306E\4F4D\306A\3069\306E\6574\6570\30B0\30EB\30FC\30D7\3092\533A\5207\308A\307E\3059\3002</p>'),
unistr('<p>\30B0\30EB\30FC\30D7\30FB\30BB\30D1\30EC\30FC\30BF\306B\306F\3001\4EFB\610F\306E\6587\5B57\3092\6307\5B9A\3067\304D\307E\3059\3002\6307\5B9A\3057\305F\6587\5B57\306F\30B7\30F3\30B0\30EB\30D0\30A4\30C8\3067\3001\30B0\30EB\30FC\30D7\30FB\30BB\30D1\30EC\30FC\30BF\306F\4ED6\306E\5C0F\6570\70B9\6587\5B57\3068\7570\306A\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\30BB\30D1\30EC\30FC\30BF\306B\306F\3001\7A7A\767D\3092\6307\5B9A\3067\304D\307E\3059\304C\3001\6570\5B57\304A\3088\3073\6B21\306B\793A\3059\6587\5B57\306F\6307\5B9A\3067\304D\307E\305B\3093\3002</p>'),
'<ul class="noIndent">',
unistr('<li>\30D7\30E9\30B9(+)</li>'),
unistr('<li>\30CF\30A4\30D5\30F3(-)</li> '),
unistr('<li>\5C0F\306A\308A\8A18\53F7(<)</li>'),
unistr('<li>\5927\306A\308A\8A18\53F7(>)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103834348637308273)
,p_name=>'APEXAPP.ITEM.INSERTED_COUNT'
,p_message_language=>'ja'
,p_message_text=>unistr('\633F\5165\3055\308C\305F\884C:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103813330255308257)
,p_name=>'APEXAPP.ITEM.PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103812916727308257)
,p_name=>'APEXAPP.ITEM.PASSWORD'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30B9\30EF\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103837641392308276)
,p_name=>'APEXAPP.ITEM.RATING'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A55\4FA1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103833363801308273)
,p_name=>'APEXAPP.ITEM.REMEMBER_USERNAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\540D\3092\8A18\61B6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103833446802308273)
,p_name=>'APEXAPP.ITEM.REMEMBER_USERNAME.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('\3053\306E\30C1\30A7\30C3\30AF\30FB\30DC\30C3\30AF\30B9\3092\9078\629E\3059\308B\3068\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\306F\3001"LOGIN_USERNAME_COOKIE"\3068\3044\3046\540D\524D\306E\6C38\7D9A\7684\306A\30D6\30E9\30A6\30B6cookie\306B\30E6\30FC\30B6\30FC\540D\304C\4FDD\5B58\3055\308C\307E\3059\3002'),
unistr('\6B21\56DE\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8\306B\30A2\30AF\30BB\30B9\3059\308B\3068\3001'),
unistr('\30E6\30FC\30B6\30FC\540D\30D5\30A3\30FC\30EB\30C9\306B\3053\306E\5024\304C\81EA\52D5\7684\306B\79FB\5165\3055\308C\307E\3059\3002'),
'</p>',
'<p>',
unistr('\3053\306E\30C1\30A7\30C3\30AF\30FB\30DC\30C3\30AF\30B9\306E\9078\629E\3092\89E3\9664\3057\3001\30E6\30FC\30B6\30FC\540D\304C\3059\3067\306Bcookie\306B\4FDD\5B58\3055\308C\3066\3044\308B\5834\5408\3001'),
unistr('\7A7A\306E\5024\3067\4E0A\66F8\3055\308C\307E\3059\3002'),
unistr('\30D6\30E9\30A6\30B6\306E\958B\767A\8005\30C4\30FC\30EB\3092\4F7F\7528\3057\3066\3001cookie\3092\5B8C\5168\306B\524A\9664\3059\308B\3053\3068\3082\3067\304D\307E\3059\3002'),
'</p>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103837714529308276)
,p_name=>'APEXAPP.ITEM.RESPONSE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30B9\30DD\30F3\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103834660378308274)
,p_name=>'APEXAPP.ITEM.REVIEW_COUNT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30D3\30E5\30FC\306E\5FC5\8981\306A\884C:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103812541940308257)
,p_name=>'APEXAPP.ITEM.SEARCH'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103812608787308257)
,p_name=>'APEXAPP.ITEM.SEARCH.PLACEHOLDER'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103833927064308273)
,p_name=>'APEXAPP.ITEM.SEPARATOR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30D1\30EC\30FC\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103834099300308273)
,p_name=>'APEXAPP.ITEM.SEPARATOR.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\30BB\30D1\30EC\30FC\30BF\6587\5B57\3092\6307\5B9A\3057\3066\304F\3060\3055\3044\3002\30BF\30D6\30FB\30BB\30D1\30EC\30FC\30BF\306B\306F<code>\005Ct</code>\3092\4F7F\7528\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103834794889308274)
,p_name=>'APEXAPP.ITEM.SHOW_ADVANCED_SETTINGS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30ED\30FC\30C9\306E\8A73\7D30\8A2D\5B9A\306E\8868\793A: \901A\8CA8\8A18\53F7\3001\5C0F\6570\70B9\6587\5B57\3001\30D5\30A1\30A4\30EB\30FB\30A8\30F3\30B3\30FC\30C7\30A3\30F3\30B0\307E\305F\306F\65E5\4ED8\66F8\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103836403770308275)
,p_name=>'APEXAPP.ITEM.STARTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103813494038308257)
,p_name=>'APEXAPP.ITEM.STATUS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30C6\30FC\30BF\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103836033133308275)
,p_name=>'APEXAPP.ITEM.THEME_PREFERENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306E\30C6\30FC\30DE\30FB\30D7\30EA\30D5\30A1\30EC\30F3\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103836180857308275)
,p_name=>'APEXAPP.ITEM.THEME_PREFERENCE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3059\308B\3068\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\3001\300C\30AB\30B9\30BF\30DE\30A4\30BA\300D\30EA\30F3\30AF\3092\4F7F\7528\3057\3066\72EC\81EA\306E\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB\3092\9078\629E\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103835860245308275)
,p_name=>'APEXAPP.ITEM.THEME_STYLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30B9\30AF\30C8\30C3\30D7\30FB\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103835998148308275)
,p_name=>'APEXAPP.ITEM.THEME_STYLE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\306E\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB\306F\3059\3079\3066\306E\30E6\30FC\30B6\30FC\306B\9069\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103835722431308274)
,p_name=>'APEXAPP.ITEM.TIMEFRAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\6642\9593\67A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103834461249308273)
,p_name=>'APEXAPP.ITEM.UPDATED_COUNT'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F4\65B0\3055\308C\305F\884C:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103812856029308257)
,p_name=>'APEXAPP.ITEM.USERNAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103836807647308275)
,p_name=>'APEXAPP.ITEM.USERNAMES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103837065912308275)
,p_name=>'APEXAPP.ITEM.USERNAMES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30F3\30DE\3001\30BB\30DF\30B3\30ED\30F3\307E\305F\306F\7A7A\767D\3067\533A\5207\3063\305F\30E6\30FC\30B6\30FC\540D\3092\5165\529B\3057\307E\3059\3002\65E2\5B58\307E\305F\306F\91CD\8907\3059\308B\30E6\30FC\30B6\30FC\540D\306F\81EA\52D5\7684\306B\7121\8996\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103836991320308275)
,p_name=>'APEXAPP.ITEM.USERNAMES.PLACEHOLDER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\540D\3092\3053\3053\306B\5165\529B\3057\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103837157705308276)
,p_name=>'APEXAPP.ITEM.USERNAME_FORMAT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\540D\306E\5F62\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103837809729308276)
,p_name=>'APEXAPP.ITEM.USER_AGENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\30FB\30A8\30FC\30B8\30A7\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103836261731308275)
,p_name=>'APEXAPP.ITEM.VIEW_AS'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\5F62\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103815533642308259)
,p_name=>'APEXAPP.LIST.ACCESS_CONTROL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30BB\30B9\5236\5FA1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103815449423308259)
,p_name=>'APEXAPP.LIST.ACTIVITY_REPORTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30C6\30A3\30D3\30C6\30A3\30FB\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103840143222308278)
,p_name=>'APEXAPP.LIST.APP_ADMINISTRATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103815363232308259)
,p_name=>'APEXAPP.LIST.APP_CONFIGURATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\69CB\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103815732114308259)
,p_name=>'APEXAPP.LIST.EMAIL_REPORTING'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\30FB\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103815658640308259)
,p_name=>'APEXAPP.LIST.FEEDBACK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30FC\30C9\30D0\30C3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103840017407308278)
,p_name=>'APEXAPP.LIST.HOME_NAVIGATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30CA\30D3\30B2\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103815899665308259)
,p_name=>'APEXAPP.LIST.JOB_REPORTING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B8\30E7\30D6\30FB\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103839978689308278)
,p_name=>'APEXAPP.LIST.NAVIGATION_BAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30D0\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103840264598308278)
,p_name=>'APEXAPP.LIST.NAVIGATION_MENU'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103815283682308259)
,p_name=>'APEXAPP.LIST.USER_INTERFACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103840317074308278)
,p_name=>'APEXAPP.LIST_ENTRY.APP_ADMIN.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306E\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103816063110308259)
,p_name=>'APEXAPP.LIST_ENTRY.HOME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DB\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103816114658308260)
,p_name=>'APEXAPP.LIST_ENTRY.LOGOUT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30B0\30A2\30A6\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103815918003308259)
,p_name=>'APEXAPP.LIST_ENTRY.STEP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30C6\30C3\30D7%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103838111260308276)
,p_name=>'APEXAPP.LOV.RPT_MAX_ROW'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\3054\3068\306E\884C\6570\3092\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103839678623308277)
,p_name=>'APEXAPP.LOV_ENTRY.ACKNOWLEDGED'
,p_message_language=>'ja'
,p_message_text=>unistr('\78BA\8A8D\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103839071076308277)
,p_name=>'APEXAPP.LOV_ENTRY.CHART'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\30FB\30DA\30FC\30B8\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103839891502308278)
,p_name=>'APEXAPP.LOV_ENTRY.CLOSED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30ED\30FC\30BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103838367636308276)
,p_name=>'APEXAPP.LOV_ENTRY.COPY_PASTE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30D4\30FC\30FB\30A2\30F3\30C9\30FB\30DA\30FC\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103838698324308277)
,p_name=>'APEXAPP.LOV_ENTRY.DATE_FORMAT_APP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\6A19\6E96\66F8\5F0F\30DE\30B9\30AF\306E\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103838714106308277)
,p_name=>'APEXAPP.LOV_ENTRY.DATE_FORMAT_CUSTOM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30C3\30D7\30ED\30FC\30C9\5217\306E\30AB\30B9\30BF\30E0\66F8\5F0F\306E\63D0\4F9B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103839171509308277)
,p_name=>'APEXAPP.LOV_ENTRY.EMAIL_ADDRESSES'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103838813172308277)
,p_name=>'APEXAPP.LOV_ENTRY.END_USER_THEME_SELECTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\3088\308B\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB\306E\9078\629E\3092\8A31\53EF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103838435377308277)
,p_name=>'APEXAPP.LOV_ENTRY.FIRST_ROW'
,p_message_language=>'ja'
,p_message_text=>unistr('1\884C\76EE\306B\5217\540D\304C\3042\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103839491852308277)
,p_name=>'APEXAPP.LOV_ENTRY.NEGATIVE'
,p_message_language=>'ja'
,p_message_text=>unistr('\60AA\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103839363114308277)
,p_name=>'APEXAPP.LOV_ENTRY.NEUTRAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\3069\3061\3089\3068\3082\3044\3048\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103839545870308277)
,p_name=>'APEXAPP.LOV_ENTRY.NO_ACTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103839704467308278)
,p_name=>'APEXAPP.LOV_ENTRY.OPEN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30FC\30D7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103839255345308277)
,p_name=>'APEXAPP.LOV_ENTRY.POSITIVE'
,p_message_language=>'ja'
,p_message_text=>unistr('\826F\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103838936973308277)
,p_name=>'APEXAPP.LOV_ENTRY.REPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\30FB\30DA\30FC\30B8\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103838558293308277)
,p_name=>'APEXAPP.LOV_ENTRY.SHOW_ADVANCED_SETTINGS'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A73\7D30\8A2D\5B9A\306E\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103838245237308276)
,p_name=>'APEXAPP.LOV_ENTRY.UPLOAD_FILE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\3092\30A2\30C3\30D7\30ED\30FC\30C9(\30AB\30F3\30DE\533A\5207\308A(*.csv)\307E\305F\306F\30BF\30D6\533A\5207\308A)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103842257781308279)
,p_name=>'APEXAPP.PAGE.ACTIVITY_DASHBOARD'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30C6\30A3\30D3\30C6\30A3\30FB\30C0\30C3\30B7\30E5\30DC\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103816730439308260)
,p_name=>'APEXAPP.PAGE.ADD_MULTIPLE_USERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\8907\6570\30E6\30FC\30B6\30FC\306E\8FFD\52A0 - \30B9\30C6\30C3\30D7%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103816915492308260)
,p_name=>'APEXAPP.PAGE.ADD_MULTIPLE_USERS.TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8907\6570\30E6\30FC\30B6\30FC\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103841838503308279)
,p_name=>'APEXAPP.PAGE.ADMIN'
,p_message_language=>'ja'
,p_message_text=>unistr('\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103841906161308279)
,p_name=>'APEXAPP.PAGE.ADMIN.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\7BA1\7406\30DA\30FC\30B8\3067\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\6240\6709\8005(\7BA1\7406\8005)\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\69CB\6210\3057\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5168\4F53\3067\4F7F\7528\3055\308C\308B\5171\901A\30C7\30FC\30BF\3092\7BA1\7406\3067\304D\307E\3059\3002'),
unistr('\7BA1\7406\8005\306F\3001\4F7F\7528\53EF\80FD\306A\8A2D\5B9A\306E\3044\305A\308C\304B\3092\9078\629E\3057\3066\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\8868\793A\65B9\6CD5\307E\305F\306F\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\4F7F\7528\53EF\80FD\306A\6A5F\80FD(\3042\308B\3044\306F\305D\306E\4E21\65B9)\3092\5FC5\8981\306B\5FDC\3058\3066\5909\66F4\3067\304D\307E\3059\3002</p>'),
unistr('<p>\3053\306E\30DA\30FC\30B8\3078\306E\30A2\30AF\30BB\30B9\306F\3001\7BA1\7406\8005\306E\307F\306B\5236\9650\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103842457236308280)
,p_name=>'APEXAPP.PAGE.AUTOMATIONS_LOG'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\52D5\5316\30ED\30B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103842522494308280)
,p_name=>'APEXAPP.PAGE.AUTOMATIONS_LOG.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30DA\30FC\30B8\3067\306F\3001\81EA\52D5\5316\30ED\30B0\306E\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\304C\63D0\4F9B\3055\308C\307E\3059\3002</p>'),
unistr('<p>\30ED\30B0\306B\8A18\9332\6E08\306E\524D\306E\81EA\52D5\5316\5B9F\884C\306B\95A2\3059\308B\60C5\5831\3092\78BA\8A8D\3057\307E\3059\3002\30ED\30B0\306B\306F\958B\59CB\30B9\30BF\30F3\30D7\3001\7D42\4E86\30B9\30BF\30F3\30D7\304A\3088\3073\51E6\7406\6E08\884C\306B\95A2\3059\308B\8A73\7D30(\6210\529F\3057\305F\884C\3068\30A8\30E9\30FC\306E\3042\308B\884C)\304C\542B\307E\308C\3066\3044\307E\3059\3002\30E1\30C3\30BB\30FC\30B8\306B\30C9\30EA\30EB\30C0\30A6\30F3\3057\3066\51E6\7406\3055\308C\305F\884C\306E\500B\3005\306E\30E1\30C3\30BB\30FC\30B8\3092\78BA\8A8D\3057\307E\3059\3002</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103842195478308279)
,p_name=>'APEXAPP.PAGE.CONFIGURATION_SETTINGS.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\69CB\6210\8A2D\5B9A\306B\3088\3063\3066\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\5BFE\3057\3066\7279\5B9A\306E\6A5F\80FD\3092\4F7F\7528\53EF\80FD(\6709\52B9)\306B\3059\308B\304B\3001\4F7F\7528\4E0D\53EF(\7121\52B9)\306B\3059\308B\3053\3068\304C\3067\304D\307E\3059\3002</p>'),
unistr('<p>\7279\5B9A\306E\6A5F\80FD\3092100%\6E96\5099\3067\304D\3066\3044\306A\3044\5834\5408\3001\307E\305F\306F\4E00\6642\7684\306B\524A\9664\3059\308B\5FC5\8981\304C\3042\308B\5834\5408\3001<strong>\300C\7121\52B9\300D</strong>\3092\30AF\30EA\30C3\30AF\3057\307E\3059\3002'),
unistr('\4F7F\7528\53EF\80FD\306B\306A\3063\305F\3089\3001<strong>\300C\6709\52B9\300D</strong>\3092\30AF\30EA\30C3\30AF\3059\308B\3060\3051\3067\3059\3002</p>'),
unistr('<p><em><strong>\30CE\30FC\30C8:</strong> \3053\3053\3067\884C\3063\305F\5909\66F4\306F\3001\73FE\5728\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\5B9F\884C\4E2D\306E\500B\5225\306E\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\306F\53CD\6620\3055\308C\307E\305B\3093\3002\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\30B5\30A4\30F3\30A2\30A6\30C8\3057\3066\304B\3089\518D\5EA6\30B5\30A4\30F3\30A4\30F3\3059\308B\3068\3001\5909\66F4\3055\308C\305F\6A5F\80FD\8A2D\5B9A\304C\9069\7528\3055\308C\307E\3059\3002</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103843597363308280)
,p_name=>'APEXAPP.PAGE.CONFIG_ACCESS_CONTROL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30BB\30B9\5236\5FA1\306E\69CB\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103843697120308280)
,p_name=>'APEXAPP.PAGE.CONFIG_ACCESS_CONTROL.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8A8D\8A3C\3055\308C\305F\30E6\30FC\30B6\30FC\306E\9069\5207\306A\9078\629E\9805\76EE\3092\9078\629E\3057\307E\3059\3002<br>'),
unistr('<strong>\300C\3044\3044\3048\300D</strong>\3092\9078\629E\3059\308B\3068\3001\6307\5B9A\3057\305F\30E6\30FC\30B6\30FC\306E\307F\304C\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\30A2\30AF\30BB\30B9\3067\304D\308B\3053\3068\306B\306A\308B\305F\3081\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30BB\30AD\30E5\30EA\30C6\30A3\304C\5411\4E0A\3057\307E\3059\3002'),
unistr('\305F\3060\3057\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304C\5927\898F\6A21\306A\30E6\30FC\30B6\30FC\30FB\30B3\30DF\30E5\30CB\30C6\30A3\3092\6301\3063\3066\3044\308B\5834\5408\306F\3001\30E6\30FC\30B6\30FC\306E\7BA1\7406\304C\8CA0\62C5\306B\306A\308B\53EF\80FD\6027\304C\3042\308B\305F\3081\3001<strong>\300C\306F\3044\300D</strong>\3092\512A\5148\7684\306B\9078\629E\3057\3066\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\7BA1\7406\8005\3068\30B3\30F3\30C8\30EA\30D3\30E5\30FC\30BF\306E\307F\3092\5165\529B\3067\304D\307E\3059\3002<br>'),
unistr('<strong>\300C\306F\3044\300D</strong>\3092\9078\629E\3059\308B\5834\5408\3001\30E6\30FC\30B6\30FC\30FB\30EA\30B9\30C8\306B\542B\3081\306A\3044\30E6\30FC\30B6\30FC\306E\51E6\7406\65B9\6CD5\3082\9078\629E\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>'),
unistr('<p>\30E6\30FC\30B6\30FC\540D\306B\5BFE\3057\3066\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9\3092\8981\6C42\3059\308B\304B\3001\4EFB\610F\306E\82F1\6570\5B57\5024\3092\4F7F\7528\53EF\80FD\306B\3059\308B\304B\3092\9078\629E\3057\307E\3059\3002<br>'),
unistr('\901A\5E38\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067Oracle Access Manager\3084SSO\306A\3069\306E\4E2D\592E\7BA1\7406\8A8D\8A3C\30B9\30AD\30FC\30E0\3092\4F7F\7528\3057\3066\3044\308B(\307E\305F\306F\5C06\6765\4F7F\7528\3059\308B\3088\3046\306B\69CB\6210\3059\308B)\5834\5408\3001\3053\306E\8A2D\5B9A\306F<strong>\300C\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9\300D</strong>\306B\8A2D\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>'),
unistr('<p><em><strong>\30CE\30FC\30C8:</strong> \3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\306F\3001\30EA\30FC\30C0\30FC\3001\30B3\30F3\30C8\30EA\30D3\30E5\30FC\30BF\304A\3088\3073\7BA1\7406\8005\3068\3044\30463\3064\306E\30A2\30AF\30BB\30B9\30FB\30EC\30D9\30EB\304C\30B5\30DD\30FC\30C8\3055\308C\307E\3059\3002'),
'<ul>',
unistr('  <li><strong>\30EA\30FC\30C0\30FC</strong>\306F\3001\3059\3079\3066\306E\60C5\5831\306B\5BFE\3059\308B\8AAD\53D6\308A\5C02\7528\30A2\30AF\30BB\30B9\6A29\3092\6301\3061\3001\30EC\30DD\30FC\30C8\3092\53C2\7167\3067\304D\307E\3059\3002</li>'),
unistr('  <li><strong>\30B3\30F3\30C8\30EA\30D3\30E5\30FC\30BF</strong>\306F\3001\60C5\5831\306E\4F5C\6210\3001\7DE8\96C6\304A\3088\3073\524A\9664\304C\53EF\80FD\3067\3001\30EC\30DD\30FC\30C8\3092\53C2\7167\3067\304D\307E\3059\3002</li>'),
unistr('  <li><strong>\7BA1\7406\8005</strong>\306F\3001\30B3\30F3\30C8\30EA\30D3\30E5\30FC\30BF\306E\6A5F\80FD\306B\52A0\3048\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\300C\7BA1\7406\300D\30BB\30AF\30B7\30E7\30F3\306B\30A2\30AF\30BB\30B9\3057\3066\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\69CB\6210\3092\5B9F\884C\3067\304D\307E\3059\3002</li>'),
'</ul>',
'</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103843069415308280)
,p_name=>'APEXAPP.PAGE.ERROR_LOG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A8\30E9\30FC\30FB\30ED\30B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103843128440308280)
,p_name=>'APEXAPP.PAGE.ERROR_LOG.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30DA\30FC\30B8\3067\306F\3001\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\3088\3063\3066\8A18\9332\3055\308C\305F\3059\3079\3066\306E\4E88\671F\3057\306A\3044\30A8\30E9\30FC\306E\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\304C\63D0\4F9B\3055\308C\307E\3059\3002</p>'),
unistr('<p>\5217\30D8\30C3\30C0\30FC\3092\30AF\30EA\30C3\30AF\3057\3066\30C7\30FC\30BF\3092\30BD\30FC\30C8\304A\3088\3073\30D5\30A3\30EB\30BF\3059\308B\304B\3001<strong>\300C\30A2\30AF\30B7\30E7\30F3\300D</strong>\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3057\3066\5217\8868\793A\3068\591A\304F\306E\8FFD\52A0\306E\62E1\5F35\6A5F\80FD\3092\30AB\30B9\30BF\30DE\30A4\30BA\3057\307E\3059\3002<strong>\300C\30EA\30BB\30C3\30C8\300D</strong>\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\3092\30C7\30D5\30A9\30EB\30C8\8A2D\5B9A\306B\623B\3059\3053\3068\304C\3067\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103843833348308281)
,p_name=>'APEXAPP.PAGE.FEEDBACK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30FC\30C9\30D0\30C3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103843932764308281)
,p_name=>'APEXAPP.PAGE.FEEDBACK_SETTINGS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30FC\30C9\30D0\30C3\30AF\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103844020458308281)
,p_name=>'APEXAPP.PAGE.FEEDBACK_SETTINGS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p><strong>\6DFB\4ED8\6709\52B9\5316</strong> - \300C\306F\3044\300D\306B\3057\305F\5834\5408\3001\30E6\30FC\30B6\30FC\306F\30D5\30A3\30FC\30C9\30D0\30C3\30AF\306B\4F7F\7528\3059\308B\6DFB\4ED8\3092\30A2\30C3\30D7\30ED\30FC\30C9\3067\304D\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103816831436308260)
,p_name=>'APEXAPP.PAGE.FEEDBACK_SUBMITTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30FC\30C9\30D0\30C3\30AF\304C\767A\884C\3055\308C\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103816522257308260)
,p_name=>'APEXAPP.PAGE.GLOBAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30ED\30FC\30D0\30EB\30FB\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103816265545308260)
,p_name=>'APEXAPP.PAGE.HOME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DB\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103840927734308278)
,p_name=>'APEXAPP.PAGE.HOME.HELP.FEEDBACK'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\3069\306E\30DA\30FC\30B8\304B\3089\3067\3082\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30D0\30FC\306E\30D5\30A3\30FC\30C9\30D0\30C3\30AF\30FB\30A2\30A4\30B3\30F3( <span class="fa fa-comment-o" aria-hidden="true"></span> )\3092\30AF\30EA\30C3\30AF\3057\3066\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\7BA1\7406\8005\306B\30D5\30A3\30FC\30C9\30D0\30C3\30AF\3092\6B8B\3059\3053\3068\304C\3067\304D\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103840700000308278)
,p_name=>'APEXAPP.PAGE.HOME.HELP.SIDE_MENU'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\3053\308C\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30DB\30FC\30E0\30DA\30FC\30B8\3067\3059\3002\30AB\30FC\30C9\3092\30AF\30EA\30C3\30AF\3057\3066\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5185\306E\7570\306A\308B\30DA\30FC\30B8\306B\30A2\30AF\30BB\30B9\3059\308B\304B\3001\30DA\30FC\30B8\306E\6A2A\5074\306B\3042\308B\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC\3092\4F7F\7528\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103841354465308279)
,p_name=>'APEXAPP.PAGE.HOME.HELP.SIGNOUT'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30D0\30FC\306E\81EA\5206\306E\540D\524D\306E\30C9\30ED\30C3\30D7\30C0\30A6\30F3\3092\30AF\30EA\30C3\30AF\3057\3066\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304B\3089\30B5\30A4\30F3\30A2\30A6\30C8\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103841261700308279)
,p_name=>'APEXAPP.PAGE.HOME.HELP.TIMEZONE'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30D0\30FC\306E\30E6\30FC\30B6\30FC\30FB\30E1\30CB\30E5\30FC( <span class="fa fa-user" aria-hidden="true"></span> )\3092\30AF\30EA\30C3\30AF\3057\3066\3001\30BF\30A4\30E0\30BE\30FC\30F3\30FB\30D7\30EA\30D5\30A1\30EC\30F3\30B9\306E\66F4\65B0\3068\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304B\3089\306E\30B5\30A4\30F3\30A2\30A6\30C8\3092\884C\3044\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103840651155308278)
,p_name=>'APEXAPP.PAGE.HOME.HELP.TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DB\30FC\30E0\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103840840208308278)
,p_name=>'APEXAPP.PAGE.HOME.HELP.TOP_MENU'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\3053\308C\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30DB\30FC\30E0\30DA\30FC\30B8\3067\3059\3002\30AB\30FC\30C9\3092\30AF\30EA\30C3\30AF\3057\3066\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5185\306E\7570\306A\308B\30DA\30FC\30B8\306B\30A2\30AF\30BB\30B9\3059\308B\304B\3001\30DA\30FC\30B8\306E\4E00\756A\4E0A\306B\3042\308B\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC\3092\4F7F\7528\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103841165334308279)
,p_name=>'APEXAPP.PAGE.HOME.HELP.USER'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30D0\30FC(\30DA\30FC\30B8\306E\53F3\4E0A)\306E\30E6\30FC\30B6\30FC\30FB\30E1\30CB\30E5\30FC( <span class="fa fa-user" aria-hidden="true"></span> )\3092\30AF\30EA\30C3\30AF\3057\3066\3001\30E6\30FC\30B6\30FC\30FB\30D7\30ED\30D5\30A1\30A4\30EB\3078\306E\30A2\30AF\30BB\30B9\3068\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304B\3089\306E\30B5\30A4\30F3\30A2\30A6\30C8\3092\884C\3044\307E\3059\3002<br>'),
unistr('<strong>\300C\30D7\30ED\30D5\30A1\30A4\30EB\306E\8868\793A\300D</strong>\3092\30AF\30EA\30C3\30AF\3059\308B\5834\5408\3001<strong>\300C\30D7\30ED\30D5\30A1\30A4\30EB\306E\66F4\65B0\300D</strong>\3092\30AF\30EA\30C3\30AF\3057\3001\500B\4EBA\60C5\5831\306E\8A73\7D30\3092\5165\529B\3057\3066\5199\771F\3084\30A2\30D0\30BF\30FC\3092\30A2\30C3\30D7\30ED\30FC\30C9\3067\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103841033926308278)
,p_name=>'APEXAPP.PAGE.HOME.HELP.USER_TIMEZONE'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30D0\30FC\306E\30E6\30FC\30B6\30FC\30FB\30E1\30CB\30E5\30FC( <span class="fa fa-user" aria-hidden="true"></span> )\3092\30AF\30EA\30C3\30AF\3057\3066\3001\30E6\30FC\30B6\30FC\30FB\30D7\30ED\30D5\30A1\30A4\30EB\3078\306E\30A2\30AF\30BB\30B9\3001\30BF\30A4\30E0\30BE\30FC\30F3\30FB\30D7\30EA\30D5\30A1\30EC\30F3\30B9\306E\66F4\65B0\3001\304A\3088\3073\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304B\3089\306E\30B5\30A4\30F3\30A2\30A6\30C8\3092\884C\3044\307E\3059\3002<br>'),
unistr('<strong>\300C\30D7\30ED\30D5\30A1\30A4\30EB\306E\8868\793A\300D</strong>\3092\30AF\30EA\30C3\30AF\3059\308B\5834\5408\3001<strong>\300C\30D7\30ED\30D5\30A1\30A4\30EB\306E\66F4\65B0\300D</strong>\3092\30AF\30EA\30C3\30AF\3057\3001\500B\4EBA\60C5\5831\306E\8A73\7D30\3092\5165\529B\3057\3066\5199\771F\3084\30A2\30D0\30BF\30FC\3092\30A2\30C3\30D7\30ED\30FC\30C9\3067\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103841539491308279)
,p_name=>'APEXAPP.PAGE.IG.HELP.EDITABLE'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\5BFE\8A71\30B0\30EA\30C3\30C9\5185\3067\30C7\30FC\30BF\3092\76F4\63A5\633F\5165\3001\66F4\65B0\304A\3088\3073\524A\9664\3067\304D\307E\3059\3002<br>'),
unistr('  \300C\884C\306E\8FFD\52A0\300D\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\65B0\3057\3044\884C\3092\633F\5165\3067\304D\307E\3059\3002<br>'),
unistr('  \30BB\30EB\5185\3092\30C0\30D6\30EB\30AF\30EA\30C3\30AF\3059\308B\304B\3001<strong>\300C\7DE8\96C6\300D</strong>\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\30B9\30D7\30EC\30C3\30C9\30B7\30FC\30C8\3067\30C7\30FC\30BF\3092\7DE8\96C6\3059\308B\5834\5408\3068\540C\3058\3088\3046\306B\30C7\30FC\30BF\5024\3092\66F4\65B0\3067\304D\307E\3059\3002</p>'),
'',
unistr('<p>\30EC\30DD\30FC\30C8\306E\4E00\756A\4E0A\306B\3042\308B\300C\884C\30A2\30AF\30B7\30E7\30F3\300D\30E1\30CB\30E5\30FC(<span class="fa fa-bars" aria-hidden="true"></span>)\3092\4F7F\7528\3057\3066\3001\9078\629E\3057\305F\884C\3092\8907\88FD\3001\524A\9664\3001\30EA\30D5\30EC\30C3\30B7\30E5\307E\305F\306F\56DE\5FA9\3057\307E\3059\3002<br>'),
unistr('  \500B\3005\306E\884C\306E\300C\884C\30A2\30AF\30B7\30E7\30F3\300D\30E1\30CB\30E5\30FC\3092\4F7F\7528\3057\3066\3001\5358\4E00\884C\30D3\30E5\30FC\306B\30A2\30AF\30BB\30B9\3057\305F\308A\3001\65B0\3057\3044\884C\3092\8FFD\52A0\3057\305F\308A\3059\308B\3053\3068\3082\3067\304D\307E\3059\3002</p>'),
'',
unistr('<p>\30C7\30FC\30BF\3092\898B\3064\3051\308B\306B\306F\3001\691C\7D22\30C0\30A4\30A2\30ED\30B0\306B\691C\7D22\6587\5B57\5217\3092\5165\529B\3059\308B\304B\3001\5217\30D8\30C3\30C0\30FC\3092\30AF\30EA\30C3\30AF\3057\3066\623B\3055\308C\308B\30EC\30B3\30FC\30C9\3092\5236\9650\3057\307E\3059\3002</p>'),
'',
unistr('<p><strong>\300C\30A2\30AF\30B7\30E7\30F3\300D</strong>\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\591A\304F\306E\6A5F\80FD\3092\5B9F\884C\3067\304D\307E\3059\3002\3053\308C\306B\306F\3001\8868\793A\5217\307E\305F\306F\975E\8868\793A\5217\306E\9078\629E\3068\305D\306E\8868\793A\9806\5E8F\306B\52A0\3048\3001\591A\304F\306E\30C7\30FC\30BF\304A\3088\3073\66F8\5F0F\8A2D\5B9A\6A5F\80FD\304C\542B\307E\308C\307E\3059\3002\30C1\30E3\30FC\30C8\30FB\30AA\30D7\30B7\30E7\30F3\3092\4F7F\7528\3057\3066\3001\30C7\30FC\30BF\306E\8FFD\52A0\30D3\30E5\30FC\3092\5B9A\7FA9\3059\308B\3053\3068\3082\3067\304D\307E\3059\3002</p>'),
'',
unistr('<p>\72EC\81EA\306E\30AB\30B9\30BF\30DE\30A4\30BA\5185\5BB9\3092\4FDD\5B58\3059\308B\5834\5408\3001\30EC\30DD\30FC\30C8\3092\9078\629E\3059\308B\304B\3001\300C\30C0\30A6\30F3\30ED\30FC\30C9\300D\3092\30AF\30EA\30C3\30AF\3057\3066\30C7\30FC\30BF\3092\30A2\30F3\30ED\30FC\30C9\3057\307E\3059\3002<p>'),
'',
unistr('<p>\8FFD\52A0\60C5\5831\3092\5165\624B\3059\308B\306B\306F\3001\300C\30A2\30AF\30B7\30E7\30F3\300D\30E1\30CB\30E5\30FC\306E\4E00\756A\4E0B\306E\300C\30D8\30EB\30D7\300D\3092\30AF\30EA\30C3\30AF\3057\307E\3059\3002</p>'),
'',
unistr('<p><strong>\300C\30EA\30BB\30C3\30C8\300D</strong>\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\5BFE\8A71\30B0\30EA\30C3\30C9\3092\30C7\30D5\30A9\30EB\30C8\8A2D\5B9A\306B\623B\3059\3053\3068\304C\3067\304D\307E\3059\3002</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103841648756308279)
,p_name=>'APEXAPP.PAGE.IG.HELP.READONLY'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30C7\30FC\30BF\3092\898B\3064\3051\308B\306B\306F\3001\691C\7D22\30C0\30A4\30A2\30ED\30B0\306B\691C\7D22\6587\5B57\5217\3092\5165\529B\3059\308B\304B\3001\5217\30D8\30C3\30C0\30FC\3092\30AF\30EA\30C3\30AF\3057\3066\623B\3055\308C\308B\30EC\30B3\30FC\30C9\3092\5236\9650\3057\307E\3059\3002</p>'),
'',
unistr('<p><strong>\300C\30A2\30AF\30B7\30E7\30F3\300D</strong>\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\591A\304F\306E\6A5F\80FD\3092\5B9F\884C\3067\304D\307E\3059\3002\3053\308C\306B\306F\3001\8868\793A\5217\307E\305F\306F\975E\8868\793A\5217\306E\9078\629E\3068\305D\306E\8868\793A\9806\5E8F\306B\52A0\3048\3001\591A\304F\306E\30C7\30FC\30BF\304A\3088\3073\66F8\5F0F\8A2D\5B9A\6A5F\80FD\304C\542B\307E\308C\307E\3059\3002\30C1\30E3\30FC\30C8\30FB\30AA\30D7\30B7\30E7\30F3\3092\4F7F\7528\3057\3066\3001\30C7\30FC\30BF\306E\8FFD\52A0\30D3\30E5\30FC\3092\5B9A\7FA9\3059\308B\3053\3068\3082\3067\304D\307E\3059\3002</p>'),
'',
unistr('<p>\72EC\81EA\306E\30AB\30B9\30BF\30DE\30A4\30BA\5185\5BB9\3092\4FDD\5B58\3059\308B\5834\5408\3001\30EC\30DD\30FC\30C8\3092\9078\629E\3059\308B\304B\3001\300C\30C0\30A6\30F3\30ED\30FC\30C9\300D\3092\30AF\30EA\30C3\30AF\3057\3066\30C7\30FC\30BF\3092\30A2\30F3\30ED\30FC\30C9\3057\307E\3059\3002<p>'),
'<br>',
unistr('<p>\8FFD\52A0\60C5\5831\3092\5165\624B\3059\308B\306B\306F\3001\300C\30A2\30AF\30B7\30E7\30F3\300D\30E1\30CB\30E5\30FC\306E\4E00\756A\4E0B\306E\300C\30D8\30EB\30D7\300D\3092\30AF\30EA\30C3\30AF\3057\307E\3059\3002</p>'),
'',
unistr('<p><strong>\300C\30EA\30BB\30C3\30C8\300D</strong>\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\3092\30C7\30D5\30A9\30EB\30C8\8A2D\5B9A\306B\623B\3059\3053\3068\304C\3067\304D\307E\3059\3002</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103841437868308279)
,p_name=>'APEXAPP.PAGE.IR.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30C7\30FC\30BF\3092\898B\3064\3051\308B\306B\306F\3001\691C\7D22\30C0\30A4\30A2\30ED\30B0\306B\691C\7D22\6587\5B57\5217\3092\5165\529B\3059\308B\304B\3001\5217\30D8\30C3\30C0\30FC\3092\30AF\30EA\30C3\30AF\3057\3066\623B\3055\308C\308B\30EC\30B3\30FC\30C9\3092\5236\9650\3057\307E\3059\3002</p>'),
'',
unistr('<p><strong>\300C\30A2\30AF\30B7\30E7\30F3\300D</strong>\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\591A\304F\306E\6A5F\80FD\3092\5B9F\884C\3067\304D\307E\3059\3002\3053\308C\306B\306F\3001\8868\793A\5217\307E\305F\306F\975E\8868\793A\5217\306E\9078\629E\3068\305D\306E\8868\793A\9806\5E8F\306B\52A0\3048\3001\591A\304F\306E\30C7\30FC\30BF\304A\3088\3073\66F8\5F0F\8A2D\5B9A\6A5F\80FD\304C\542B\307E\308C\307E\3059\3002\30C1\30E3\30FC\30C8\3001\30B0\30EB\30FC\30D7\5316\304A\3088\3073\30D4\30DC\30C3\30C8\30FB\30AA\30D7\30B7\30E7\30F3\3092\4F7F\7528\3057\3066\3001\30C7\30FC\30BF\306E\8FFD\52A0\30D3\30E5\30FC\3092\5B9A\7FA9\3059\308B\3053\3068\3082\3067\304D\307E\3059\3002</p>'),
'',
unistr('<p>\72EC\81EA\306E\30AB\30B9\30BF\30DE\30A4\30BA\5185\5BB9\3092\4FDD\5B58\3059\308B\5834\5408\3001\30EC\30DD\30FC\30C8\3092\9078\629E\3059\308B\304B\3001\300C\30C0\30A6\30F3\30ED\30FC\30C9\300D\3092\30AF\30EA\30C3\30AF\3057\3066\30C7\30FC\30BF\3092\30A2\30F3\30ED\30FC\30C9\3057\307E\3059\3002\5B9A\671F\7684\306B\30C7\30FC\30BF\3092\9001\4FE1\3059\308B\30B5\30D6\30B9\30AF\30EA\30D7\30B7\30E7\30F3\3067\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9\3068\6642\9593\67A0\3092\5165\529B\3057\307E\3059\3002<p>'),
'',
unistr('<p>\8FFD\52A0\60C5\5831\3092\5165\624B\3059\308B\306B\306F\3001\300C\30A2\30AF\30B7\30E7\30F3\300D\30E1\30CB\30E5\30FC\306E\4E00\756A\4E0B\306E\300C\30D8\30EB\30D7\300D\3092\30AF\30EA\30C3\30AF\3057\307E\3059\3002</p>'),
'',
unistr('<p><strong>\300C\30EA\30BB\30C3\30C8\300D</strong>\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\3092\30C7\30D5\30A9\30EB\30C8\8A2D\5B9A\306B\623B\3059\3053\3068\304C\3067\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103816391252308260)
,p_name=>'APEXAPP.PAGE.LOGIN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103816470996308260)
,p_name=>'APEXAPP.PAGE.LOGIN.TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('%0 - \30ED\30B0\30A4\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103843245072308280)
,p_name=>'APEXAPP.PAGE.LOG_MESSAGES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30B0\30FB\30E1\30C3\30BB\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103844132336308281)
,p_name=>'APEXAPP.PAGE.MANAGE_FEEDBACK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30FC\30C9\30D0\30C3\30AF\306E\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103844290443308281)
,p_name=>'APEXAPP.PAGE.MANAGE_FEEDBACK.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5185\306E\901A\5E38\306E\30DA\30FC\30B8\304B\3089\30D5\30A3\30FC\30C9\30D0\30C3\30AF\3092\5165\529B\3067\304D\307E\3059\3002</p>'),
unistr('<p>\3053\306E\30EC\30DD\30FC\30C8\306B\306F\3001\5165\529B\3055\308C\305F\30D5\30A3\30FC\30C9\30D0\30C3\30AF\3001\7BA1\7406\8005\306B\3088\308A\5165\529B\3055\308C\305F\30EC\30B9\30DD\30F3\30B9\3001\304A\3088\3073\30D5\30A3\30FC\30C9\30D0\30C3\30AF\306E\30B9\30C6\30FC\30BF\30B9\304C\8868\793A\3055\308C\307E\3059\3002</p>'),
unistr('<p>\7DE8\96C6\30A2\30A4\30B3\30F3(\9EC4\8272\306E\925B\7B46)\3092\30AF\30EA\30C3\30AF\3057\3066\30EC\30B9\30DD\30F3\30B9\3092\5165\529B\3059\308B\304B\3001\30D5\30A3\30FC\30C9\30D0\30C3\30AF\30FB\30B9\30C6\30FC\30BF\30B9\3092\66F4\65B0\3057\307E\3059\3002</p>'),
unistr('<p><em><strong>\30CE\30FC\30C8:</strong> \30D5\30A3\30FC\30C9\30D0\30C3\30AF\306E\53D7\4FE1\8005\304C\5B9A\7FA9\3055\308C\3066\3044\308B\5834\5408\3001\30D5\30A3\30FC\30C9\30D0\30C3\30AF\306F\3001\30D5\30A3\30FC\30C9\30D0\30C3\30AF\53D7\4FE1\8005\30EA\30B9\30C8\306E\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9\306B\3082\9001\4FE1\3055\308C\307E\3059\3002</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103843319815308280)
,p_name=>'APEXAPP.PAGE.MANAGE_USER_ACCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\30FB\30A2\30AF\30BB\30B9\306E\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103843478990308280)
,p_name=>'APEXAPP.PAGE.MANAGE_USER_ACCESS.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30DA\30FC\30B8\306B\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30E6\30FC\30B6\30FC\3068\4ED8\4E0E\3055\308C\3066\3044\308B\30A2\30AF\30BB\30B9\30FB\30EC\30D9\30EB\306E\30EC\30DD\30FC\30C8\304C\8868\793A\3055\308C\307E\3059\3002</p>'),
unistr('<p>\5217\30D8\30C3\30C0\30FC\3092\30AF\30EA\30C3\30AF\3057\3066\30C7\30FC\30BF\3092\30BD\30FC\30C8\304A\3088\3073\30D5\30A3\30EB\30BF\3059\308B\304B\3001<strong>\300C\30A2\30AF\30B7\30E7\30F3\300D</strong>\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3057\3066\5217\8868\793A\3068\591A\304F\306E\8FFD\52A0\306E\62E1\5F35\6A5F\80FD\3092\30AB\30B9\30BF\30DE\30A4\30BA\3057\307E\3059\3002<br>'),
unistr('<strong>\300C\30EA\30BB\30C3\30C8\300D</strong>\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\3092\30C7\30D5\30A9\30EB\30C8\8A2D\5B9A\306B\623B\3059\3053\3068\304C\3067\304D\307E\3059\3002</p>'),
unistr('<p>\7DE8\96C6\30A2\30A4\30B3\30F3(\9EC4\8272\306E\925B\7B46)\3092\30AF\30EA\30C3\30AF\3057\3066\30E6\30FC\30B6\30FC\306E\8A73\7D30\3068\30A2\30AF\30BB\30B9\30FB\30EC\30D9\30EB\3092\7DE8\96C6\3059\308B\304B\3001\30E6\30FC\30B6\30FC\3092\524A\9664\3057\307E\3059\3002</p>'),
unistr('<p>\30EC\30DD\30FC\30C8\306E\4E00\756A\4E0A\306B\3042\308B<strong>\300C\30E6\30FC\30B6\30FC\306E\8FFD\52A0\300D</strong>\3092\30AF\30EA\30C3\30AF\3057\3066\3001\65B0\3057\3044\30E6\30FC\30B6\30FC\3068\305D\306E\30A2\30AF\30BB\30B9\30FB\30EC\30D9\30EB\3092\8FFD\52A0\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103843794117308281)
,p_name=>'APEXAPP.PAGE.MANAGE_USER_ACCESS_FORM.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30D5\30A9\30FC\30E0\3092\4F7F\7528\3057\3066\3001\30E6\30FC\30B6\30FC\3068\305D\306E\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9\3092\5165\529B\3057\3001\30A2\30AF\30BB\30B9\30FB\30EC\30D9\30EB\3092\8A2D\5B9A\3057\307E\3059\3002'),
unistr('<em>\300C\30A2\30AF\30BB\30B9\5236\5FA1\306E\69CB\6210\300D</em>\3067\5B9A\7FA9\3057\305F\8A2D\5B9A\306B\3088\3063\3066\3001\30E6\30FC\30B6\30FC\540D\3092\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9\306B\3059\308B\5FC5\8981\304C\3042\308B\304B\3001\4EFB\610F\306E\82F1\6570\5B57\5165\529B\3092\53EF\80FD\306B\3059\308B\304B\304C\6C7A\5B9A\3055\308C\307E\3059\3002</p>'),
unistr('<p>\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\306F\3001\30EA\30FC\30C0\30FC\3001\30B3\30F3\30C8\30EA\30D3\30E5\30FC\30BF\304A\3088\3073\7BA1\7406\8005\3068\3044\30463\3064\306E\30A2\30AF\30BB\30B9\30FB\30EC\30D9\30EB\304C\30B5\30DD\30FC\30C8\3055\308C\307E\3059\3002</p>'),
'<ul>',
unistr('  <li><strong>\30EA\30FC\30C0\30FC</strong>\306F\3001\3059\3079\3066\306E\60C5\5831\306B\5BFE\3059\308B\8AAD\53D6\308A\5C02\7528\30A2\30AF\30BB\30B9\6A29\3092\6301\3061\3001\30EC\30DD\30FC\30C8\3092\53C2\7167\3067\304D\307E\3059\3002</li>'),
unistr('  <li><strong>\30B3\30F3\30C8\30EA\30D3\30E5\30FC\30BF</strong>\306F\3001\60C5\5831\306E\4F5C\6210\3001\7DE8\96C6\304A\3088\3073\524A\9664\304C\53EF\80FD\3067\3001\30EC\30DD\30FC\30C8\3092\53C2\7167\3067\304D\307E\3059\3002</li>'),
unistr('  <li><strong>\7BA1\7406\8005</strong>\306F\3001\30B3\30F3\30C8\30EA\30D3\30E5\30FC\30BF\306E\6A5F\80FD\306B\52A0\3048\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\300C\7BA1\7406\300D\30BB\30AF\30B7\30E7\30F3\306B\30A2\30AF\30BB\30B9\3057\3066\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\69CB\6210\3092\5B9F\884C\3067\304D\307E\3059\3002</li>'),
'</ul>',
unistr('<p>\65E2\5B58\306E\30E6\30FC\30B6\30FC\3092\7DE8\96C6\3059\308B\5834\5408\3001\305D\306E\30A2\30AB\30A6\30F3\30C8\304C\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\30A2\30AF\30BB\30B9\3057\306A\3044\3088\3046\306B\30ED\30C3\30AF\3067\304D\307E\3059\3002</p>'),
unistr('<p><em><strong>\30CE\30FC\30C8:</strong> Oracle Application Express\30A2\30AB\30A6\30F3\30C8\3092\4F7F\7528\3059\308B\5834\5408\3001\3053\3053\3067\5165\529B\3059\308B\30E6\30FC\30B6\30FC\306F\3001\305D\306E\30D1\30B9\30EF\30FC\30C9\3082\8A2D\5B9A\3067\304D\308B\30EF\30FC\30AF\30B9\30DA\30FC\30B9\7BA1\7406\8005\306B\3088\3063\3066\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\3068\3057\3066\5B9A\7FA9\3055\308C\3066\3044\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103841791885308279)
,p_name=>'APEXAPP.PAGE.MD.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30EC\30DD\30FC\30C8\30FB\30DA\30FC\30B8\3067\306F\3001\30DA\30FC\30B8\306E\7AEF\306B\3042\308B\30BB\30EC\30AF\30BF\306B\30D7\30E9\30A4\30DE\30EA\30FB\30EC\30B3\30FC\30C9\304C\8868\793A\3055\308C\307E\3059\3002'),
unistr('  \30EC\30B3\30FC\30C9\3092\9078\629E\3057\3066\3001\30DE\30B9\30BF\30FC\30FB\30EC\30B3\30FC\30C9\304A\3088\3073\5B9A\7FA9\3055\308C\3066\3044\308B\30C7\30A3\30C6\30FC\30EB\30FB\30EC\30B3\30FC\30C9\3092\8868\793A\3057\307E\3059\3002<br> '),
unistr('  \7DE8\96C6\30A2\30A4\30B3\30F3(<span class="fa fa-pencil-square-o" aria-hidden="true"></span>)\3092\30AF\30EA\30C3\30AF\3057\3066\30DE\30B9\30BF\30FC\30FB\30EC\30B3\30FC\30C9\3092\7DE8\96C6\3057\307E\3059\3002'),
unistr('  \30C7\30A3\30C6\30FC\30EB\30FB\30EC\30B3\30FC\30C9\306E\5834\5408\306F\3001\5404\884C\306E\5148\982D\306B\3042\308B\925B\7B46\3092\30AF\30EA\30C3\30AF\3057\3066\3001\305D\306E\30EC\30B3\30FC\30C9\3092\7DE8\96C6\3057\307E\3059\3002</p>'),
unistr('<p>\30BB\30EC\30AF\30BF\306B\8868\793A\3055\308C\308B\30C7\30FC\30BF\3092\5236\9650\3059\308B\306B\306F\3001\691C\7D22\30C0\30A4\30A2\30ED\30B0\306B\691C\7D22\8A9E\3092\5165\529B\3057\307E\3059\3002</p>'),
'',
unistr('<p>\65B0\3057\3044\30DE\30B9\30BF\30FC\30FB\30EC\30B3\30FC\30C9\3092\8FFD\52A0\3059\308B\306B\306F\3001\30DA\30FC\30B8\306E\4E0A\90E8\306B\3042\308B<strong>\300C\4F5C\6210\300D</strong>\3092\30AF\30EA\30C3\30AF\3057\307E\3059\3002'),
unistr('  \30C7\30A3\30C6\30FC\30EB\30FB\30EC\30B3\30FC\30C9\306E\5834\5408\306F\3001\30C7\30A3\30C6\30FC\30EB\30FB\30EA\30FC\30B8\30E7\30F3\306E\4E0A\90E8\306B\3042\308B\30D7\30E9\30B9\30FB\30A2\30A4\30B3\30F3(+)\3092\30AF\30EA\30C3\30AF\3057\3066\3001\30C7\30A3\30C6\30FC\30EB\30FB\30EC\30B3\30FC\30C9\3092\8FFD\52A0\3057\307E\3059\3002</p>'),
'',
unistr('<p>\30DA\30FC\30B8\306E\4E0A\90E8\306B\3042\308B<strong>\300C\30EA\30BB\30C3\30C8\300D</strong>\3092\30AF\30EA\30C3\30AF\3057\3066\3001\30DA\30FC\30B8\3092\30C7\30D5\30A9\30EB\30C8\8A2D\5B9A\306B\30EA\30BB\30C3\30C8\3057\3001\524D\306B\5B9A\7FA9\3057\305F\691C\7D22\8A9E\3092\524A\9664\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103842871379308280)
,p_name=>'APEXAPP.PAGE.PAGE_PERFORMANCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30D1\30D5\30A9\30FC\30DE\30F3\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103842920653308280)
,p_name=>'APEXAPP.PAGE.PAGE_PERFORMANCE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30DA\30FC\30B8\3067\306F\3001\30DA\30FC\30B8\30FB\30D1\30D5\30A9\30FC\30DE\30F3\30B9\3068\4EBA\6C17\5EA6\306E\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\304C\63D0\4F9B\3055\308C\307E\3059\3002\30EC\30DD\30FC\30C8\306F\3001\4E2D\9593\7D4C\904E\6642\9593\3068\30DA\30FC\30B8\30FB\30D3\30E5\30FC\306E\6570\3092\639B\3051\308B\3053\3068\3067\8A08\7B97\3055\308C\308B<strong>\300C\91CD\307F\4ED8\3051\30D1\30D5\30A9\30FC\30DE\30F3\30B9\300D</strong>\3067\9806\5E8F\4ED8\3051\3055\308C\307E\3059\3002</p>'),
unistr('<p>\5FC5\8981\306B\5FDC\3058\3066\3001\30DA\30FC\30B8\306E\4E00\756A\4E0A\306B\3042\308B\30EC\30DD\30FC\30C8\6642\9593\67A0(\30C7\30D5\30A9\30EB\30C8 = 1\65E5)\3092\9078\629E\3057\307E\3059\3002<br>'),
unistr('\5217\30D8\30C3\30C0\30FC\3092\30AF\30EA\30C3\30AF\3057\3066\30C7\30FC\30BF\3092\30BD\30FC\30C8\304A\3088\3073\30D5\30A3\30EB\30BF\3059\308B\304B\3001<strong>\300C\30A2\30AF\30B7\30E7\30F3\300D</strong>\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3057\3066\5217\8868\793A\3068\591A\304F\306E\8FFD\52A0\306E\62E1\5F35\6A5F\80FD\3092\30AB\30B9\30BF\30DE\30A4\30BA\3057\307E\3059\3002<strong>\300C\30EA\30BB\30C3\30C8\300D</strong>\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\3092\30C7\30D5\30A9\30EB\30C8\8A2D\5B9A\306B\623B\3059\3053\3068\304C\3067\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103842672054308280)
,p_name=>'APEXAPP.PAGE.PAGE_VIEWS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30D3\30E5\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103842787030308280)
,p_name=>'APEXAPP.PAGE.PAGE_VIEWS.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30DA\30FC\30B8\3067\306F\3001\6700\65B0\306E\30DA\30FC\30B8\30FB\30D3\30E5\30FC\306E\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\304C\63D0\4F9B\3055\308C\307E\3059\3002</p>'),
unistr('<p>\5FC5\8981\306B\5FDC\3058\3066\3001\30DA\30FC\30B8\306E\4E00\756A\4E0A\306B\3042\308B\30EC\30DD\30FC\30C8\6642\9593\67A0(\30C7\30D5\30A9\30EB\30C8 = 1\65E5)\3092\9078\629E\3057\307E\3059\3002<br>'),
unistr('\5217\30D8\30C3\30C0\30FC\3092\30AF\30EA\30C3\30AF\3057\3066\30C7\30FC\30BF\3092\30BD\30FC\30C8\304A\3088\3073\30D5\30A3\30EB\30BF\3059\308B\304B\3001<strong>\300C\30A2\30AF\30B7\30E7\30F3\300D</strong>\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3057\3066\5217\8868\793A\3068\591A\304F\306E\8FFD\52A0\306E\62E1\5F35\6A5F\80FD\3092\30AB\30B9\30BF\30DE\30A4\30BA\3057\307E\3059\3002<strong>\300C\30EA\30BB\30C3\30C8\300D</strong>\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\3092\30C7\30D5\30A9\30EB\30C8\8A2D\5B9A\306B\623B\3059\3053\3068\304C\3067\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103842056016308279)
,p_name=>'APEXAPP.PAGE.THEME_SELECTOR.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\8868\793A\306B\4F7F\7528\3059\308B\30C7\30D5\30A9\30EB\30C8\306E\30AB\30E9\30FC\30FB\30B9\30AD\30FC\30E0\3092\9078\629E\3057\307E\3059\3002</p>'),
unistr('<p><strong>\300C\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB\306E\9078\629E\3092\8A31\53EF\300D</strong>\304C\9078\629E\3055\308C\3066\3044\308B\5834\5408\3001\5404\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\3001\30DB\30FC\30E0\30DA\30FC\30B8\306E\5DE6\4E0B\9685\306B\3042\308B<em>\300C\30AB\30B9\30BF\30DE\30A4\30BA\300D</em>\30EA\30F3\30AF\3092\30AF\30EA\30C3\30AF\3057\3066\3001\4F7F\7528\53EF\80FD\306A\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB\304B\3089\9078\629E\3067\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103816690190308260)
,p_name=>'APEXAPP.PAGE.TOP_USERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C8\30C3\30D7\30FB\30E6\30FC\30B6\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103842330338308279)
,p_name=>'APEXAPP.PAGE.TOP_USERS.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30EC\30DD\30FC\30C8\3068\30C1\30E3\30FC\30C8\3092\4F7F\7528\3057\3066\3001\6307\5B9A\3057\305F\6642\9593\67A0\3067\6700\5927\306E\30DA\30FC\30B8\30FB\30D3\30E5\30FC\3092\8A18\9332\3057\305F\30E6\30FC\30B6\30FC\3092\53C2\7167\3057\307E\3059\3002</p>'),
unistr('<p>\30EC\30DD\30FC\30C8\6642\9593\67A0(\30C7\30D5\30A9\30EB\30C8 = 1\65E5)\3092\9078\629E\3057\3001\30DA\30FC\30B8\306E\4E00\756A\4E0A\306B\3042\308B\30EC\30DD\30FC\30C8\30FB\30A2\30A4\30B3\30F3\3068\30C1\30E3\30FC\30C8\30FB\30A2\30A4\30B3\30F3\304B\3089\9078\629E\3057\307E\3059\3002</p>'),
unistr('<p>\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\3067\306F\3001\691C\7D22\30D5\30A3\30FC\30EB\30C9\3092\4F7F\7528\3059\308B\304B\3001<strong>\300C\30E6\30FC\30B6\30FC\300D</strong>\5217\30D8\30C3\30C0\30FC\3092\9078\629E\3057\3066\7279\5B9A\306E\30E6\30FC\30B6\30FC\3092\9078\629E\3057\307E\3059\3002<strong>\300C\30A2\30AF\30B7\30E7\30F3\300D</strong>\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\5217\306E\8868\793A/\975E\8868\793A\3001\30DA\30FC\30B8\3054\3068\306E\884C\6570\3001\30D5\30A3\30EB\30BF\306A\3069\306E\591A\304F\306E\6A5F\80FD\3092\5B9F\884C\3067\304D\307E\3059\3002<strong>\300C\30EA\30BB\30C3\30C8\300D</strong>\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\3092\30C7\30D5\30A9\30EB\30C8\8A2D\5B9A\306B\623B\3059\3053\3068\304C\3067\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103832704119308272)
,p_name=>'APEXAPP.PROCESS.ADD_USERS_TO_ACL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30BB\30B9\5236\5FA1\30EA\30B9\30C8\3078\306E\30E6\30FC\30B6\30FC\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103832866007308272)
,p_name=>'APEXAPP.PROCESS.ADD_USERS_TO_ACL.SUCCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\304C\8FFD\52A0\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103831049296308271)
,p_name=>'APEXAPP.PROCESS.CLEAR_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30AD\30E3\30C3\30B7\30E5\306E\30AF\30EA\30A2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103814645012308258)
,p_name=>'APEXAPP.PROCESS.CLOSE_DIALOG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C0\30A4\30A2\30ED\30B0\3092\9589\3058\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103832601378308272)
,p_name=>'APEXAPP.PROCESS.CREATE_COLLECTIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30EC\30AF\30B7\30E7\30F3\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103814985541308259)
,p_name=>'APEXAPP.PROCESS.DELETE_FEEDBACK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30FC\30C9\30D0\30C3\30AF\306E\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103815098455308259)
,p_name=>'APEXAPP.PROCESS.DELETE_FEEDBACK.SUCCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30FC\30C9\30D0\30C3\30AF\524A\9664\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103832501524308272)
,p_name=>'APEXAPP.PROCESS.DML_FORM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30BB\30B9\30FB\30D5\30A9\30FC\30E0%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103833279958308273)
,p_name=>'APEXAPP.PROCESS.GET_FILE_ID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EBID\306E\53D6\5F97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103832248475308272)
,p_name=>'APEXAPP.PROCESS.GET_LOG_DETAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30B0\8A73\7D30\306E\53D6\5F97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103831592759308271)
,p_name=>'APEXAPP.PROCESS.GET_NEXT_PREV_PK'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\4E3B\30AD\30FC\5024\307E\305F\306F\524D\306E\4E3B\30AD\30FC\5024\3092\53D6\5F97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103830973583308271)
,p_name=>'APEXAPP.PROCESS.GET_USERNAME_COOKIE'
,p_message_language=>'ja'
,p_message_text=>unistr('Cookie\306E\30E6\30FC\30B6\30FC\540D\3092\53D6\5F97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103830615982308271)
,p_name=>'APEXAPP.PROCESS.IG_DML'
,p_message_language=>'ja'
,p_message_text=>unistr('%0 - \5BFE\8A71\30B0\30EA\30C3\30C9\30FB\30C7\30FC\30BF\306E\4FDD\5B58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103832460974308272)
,p_name=>'APEXAPP.PROCESS.INIT_FORM'
,p_message_language=>'ja'
,p_message_text=>unistr('\521D\671F\5316\30D5\30A9\30FC\30E0%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103831418686308271)
,p_name=>'APEXAPP.PROCESS.LEGACY_FORM_DML.SUCCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3\304C\51E6\7406\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103814743364308258)
,p_name=>'APEXAPP.PROCESS.LOAD_DATA'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\306E\30ED\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103831622612308271)
,p_name=>'APEXAPP.PROCESS.LOAD_DATA.ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\306E\30ED\30FC\30C9\306B\5931\6557\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103814833232308258)
,p_name=>'APEXAPP.PROCESS.REPLY_TO_FEEDBACK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30FC\30C9\30D0\30C3\30AF\306B\8FD4\4FE1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103814486573308258)
,p_name=>'APEXAPP.PROCESS.RESET_PAGINATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\533A\5207\308A\306E\30EA\30BB\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103830794593308271)
,p_name=>'APEXAPP.PROCESS.RESET_RPT_SEARCH'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\691C\7D22\306E\30EA\30BB\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103814528889308258)
,p_name=>'APEXAPP.PROCESS.SET_ACL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30BB\30B9\5236\5FA1\306E\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103832368100308272)
,p_name=>'APEXAPP.PROCESS.SET_ACL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30BB\30B9\5236\5FA1\306E\8A2D\5B9A\304C\4FDD\5B58\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103832021896308272)
,p_name=>'APEXAPP.PROCESS.SET_CONFIG_OPTIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F4\65B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103832125447308272)
,p_name=>'APEXAPP.PROCESS.SET_CONFIG_OPTIONS.SUCCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\69CB\6210\30AA\30D7\30B7\30E7\30F3\304C\66F4\65B0\3055\308C\307E\3057\305F\3002 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103833173144308272)
,p_name=>'APEXAPP.PROCESS.SET_FEEDBACK_OPTIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A2D\5B9A\306E\4FDD\5B58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103830867986308271)
,p_name=>'APEXAPP.PROCESS.SET_USERNAME_COOKIE'
,p_message_language=>'ja'
,p_message_text=>unistr('Cookie\306E\30E6\30FC\30B6\30FC\540D\3092\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103832985305308272)
,p_name=>'APEXAPP.PROCESS.SUBMIT_FEEDBACK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30FC\30C9\30D0\30C3\30AF\306E\9001\4FE1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103833009832308272)
,p_name=>'APEXAPP.PROCESS.SUBMIT_FEEDBACK.SUCCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30FC\30C9\30D0\30C3\30AF\304C\767A\884C\3055\308C\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103831115723308271)
,p_name=>'APEXAPP.PROCESS.TABFORM_DELETE.SUCCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('#MRD_COUNT#\884C\304C\524A\9664\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103831267054308271)
,p_name=>'APEXAPP.PROCESS.TABFORM_PLSQL.SUCCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F4\65B0\304C\9069\7528\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103831303867308271)
,p_name=>'APEXAPP.PROCESS.TABFORM_UPDATE_INSERT.SUCCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('#MRU_COUNT#\884C\304C\66F4\65B0\3055\308C\3001#MRI_COUNT#\884C\304C\633F\5165\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103831988678308272)
,p_name=>'APEXAPP.PROCESS.THEME_STYLE_PREF_SAVE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306E\30B9\30BF\30A4\30EB\30FB\30D7\30EA\30D5\30A1\30EC\30F3\30B9\306E\4FDD\5B58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103815183231308259)
,p_name=>'APEXAPP.PROCESS.THEME_STYLE_PREF_SAVE.SUCCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\5916\89B3\306E\8A2D\5B9A\304C\4FDD\5B58\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103831784512308271)
,p_name=>'APEXAPP.PROCESS.THEME_STYLE_SAVE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB\306E\4FDD\5B58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103831878786308271)
,p_name=>'APEXAPP.PROCESS.THEME_STYLE_SAVE.SUCCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\5916\89B3\306E\8A2D\5B9A\304C\4FDD\5B58\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103821436896308264)
,p_name=>'APEXAPP.REGION.ACCESS_CONTROL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30BB\30B9\5236\5FA1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103821348175308263)
,p_name=>'APEXAPP.REGION.ACCESS_CONTROL_ACTIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30BB\30B9\5236\5FA1\30A2\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103823137221308265)
,p_name=>'APEXAPP.REGION.ACCESS_CONTROL_CONFIG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30BB\30B9\5236\5FA1\69CB\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103821517772308264)
,p_name=>'APEXAPP.REGION.ACCESS_CONTROL_INFO'
,p_message_language=>'ja'
,p_message_text=>unistr('ACL\60C5\5831')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103821167377308263)
,p_name=>'APEXAPP.REGION.ACTIVITY_REPORTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30C6\30A3\30D3\30C6\30A3\30FB\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103812145672308256)
,p_name=>'APEXAPP.REGION.ADMIN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103820992872308263)
,p_name=>'APEXAPP.REGION.APP_CONFIGURATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\69CB\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103822924998308265)
,p_name=>'APEXAPP.REGION.AUTOMATION_EXECUTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\52D5\5316\5B9F\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103811226807308256)
,p_name=>'APEXAPP.REGION.BREADCRUMB'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103820090269308262)
,p_name=>'APEXAPP.REGION.BUTTONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103812090558308256)
,p_name=>'APEXAPP.REGION.COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103820887583308263)
,p_name=>'APEXAPP.REGION.CONFIGURATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\69CB\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103821287124308263)
,p_name=>'APEXAPP.REGION.CONFIG_APPEARANCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5916\89B3\306E\69CB\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103811567022308256)
,p_name=>'APEXAPP.REGION.DASHBOARD_CHART'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103820456312308263)
,p_name=>'APEXAPP.REGION.DATA_LOAD_FAILED_RECORDS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5931\6557\3057\305F\30EC\30B3\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103820587147308263)
,p_name=>'APEXAPP.REGION.DATA_LOAD_JUST_CHANGED_RECORDS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30B3\30FC\30C9\304C\4ED6\306E\30E6\30FC\30B6\30FC\306B\3088\3063\3066\5909\66F4\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103820364793308263)
,p_name=>'APEXAPP.REGION.DATA_LOAD_PROGRESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30ED\30FC\30C9\30FB\30A6\30A3\30B6\30FC\30C9\306E\9032\6357\72B6\6CC1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103811852831308256)
,p_name=>'APEXAPP.REGION.DEFAULT.MAX_ROWS'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30EC\30DD\30FC\30C8\306E\6700\5927\884C\6570\306F%0\884C\3067\3059\3002\30D5\30A3\30EB\30BF\3092\9069\7528\3057\3066\3001\554F\5408\305B\306E\30EC\30B3\30FC\30C9\6570\3092\524A\6E1B\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103811702158308256)
,p_name=>'APEXAPP.REGION.DEFAULT.NO_DATA'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\304C\898B\3064\304B\308A\307E\305B\3093\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103821950698308264)
,p_name=>'APEXAPP.REGION.EMAIL_REPORTING'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\30FB\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103823398324308265)
,p_name=>'APEXAPP.REGION.EXCEPTIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F8B\5916')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103821676829308264)
,p_name=>'APEXAPP.REGION.FEEDBACK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30FC\30C9\30D0\30C3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103812408828308257)
,p_name=>'APEXAPP.REGION.FEEDBACK_SUBMITTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30FC\30C9\30D0\30C3\30AF\304C\767A\884C\3055\308C\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103822695969308264)
,p_name=>'APEXAPP.REGION.FILTERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30EB\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103823826182308265)
,p_name=>'APEXAPP.REGION.FORM_ITEMS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30FC\30E0\30FB\30A2\30A4\30C6\30E0\30FB\30EA\30FC\30B8\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103811603580308256)
,p_name=>'APEXAPP.REGION.FORM_ON'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306E\30D5\30A9\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103823742302308265)
,p_name=>'APEXAPP.REGION.HIDDEN_ITEMS'
,p_message_language=>'ja'
,p_message_text=>unistr('\975E\8868\793A\306E\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103822139541308264)
,p_name=>'APEXAPP.REGION.HOURLY_PAGE_EVENTS'
,p_message_language=>'ja'
,p_message_text=>unistr('1\6642\9593\5F53\305F\308A\306E\30DA\30FC\30B8\30FB\30A4\30D9\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103820298554308263)
,p_name=>'APEXAPP.REGION.INFORMATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\60C5\5831')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103822003447308264)
,p_name=>'APEXAPP.REGION.JOB_REPORTING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B8\30E7\30D6\30FB\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103821786669308264)
,p_name=>'APEXAPP.REGION.LANGUAGE_SELECTOR'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A00\8A9E\30BB\30EC\30AF\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103822446158308264)
,p_name=>'APEXAPP.REGION.LATEST_ACTIVITY'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\65B0\306E\30A2\30AF\30C6\30A3\30D3\30C6\30A3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103822517021308264)
,p_name=>'APEXAPP.REGION.LATEST_ACTIVITY.NO_DATA'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30C6\30A3\30D3\30C6\30A3\304C\898B\3064\304B\308A\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103820694852308263)
,p_name=>'APEXAPP.REGION.MASTER_RECORDS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30B9\30BF\30FC\30FB\30EC\30B3\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103823094565308265)
,p_name=>'APEXAPP.REGION.MESSAGES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E1\30C3\30BB\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103822248332308264)
,p_name=>'APEXAPP.REGION.MOST_ACTIVE_PAGES'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\3082\30A2\30AF\30C6\30A3\30D6\306A\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103811963239308256)
,p_name=>'APEXAPP.REGION.NAVIGATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30CA\30D3\30B2\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103811484854308256)
,p_name=>'APEXAPP.REGION.NO_RECORD_SELECTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30B3\30FC\30C9\304C\9078\629E\3055\308C\3066\3044\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103820728912308263)
,p_name=>'APEXAPP.REGION.NO_RECORD_SELECTED.NO_DATA'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30B3\30FC\30C9\304C\9078\629E\3055\308C\3066\3044\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103823561775308265)
,p_name=>'APEXAPP.REGION.NO_VALID_USERS_EXIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\6709\52B9\306A\30E6\30FC\30B6\30FC\304C\5B58\5728\3057\307E\305B\3093 - \30DA\30FC\30B8\60C5\5831')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103823627616308265)
,p_name=>'APEXAPP.REGION.NO_VALID_USERS_EXIST.SOURCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6709\52B9\306A\65B0\898F\30E6\30FC\30B6\30FC\304C\898B\3064\304B\308A\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103822370232308264)
,p_name=>'APEXAPP.REGION.RECENT_ERRORS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\65B0\306E\30A8\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103811385400308256)
,p_name=>'APEXAPP.REGION.REGION_DISPLAY_SELECTOR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\8868\793A\30BB\30EC\30AF\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103812271106308257)
,p_name=>'APEXAPP.REGION.REPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103811145516308256)
,p_name=>'APEXAPP.REGION.SEARCH'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103822790639308265)
,p_name=>'APEXAPP.REGION.TOP_USERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C8\30C3\30D7\30FB\30E6\30FC\30B6\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103822861903308265)
,p_name=>'APEXAPP.REGION.TOP_USERS_CHART'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0A\4F4D\30E6\30FC\30B6\30FC\30FB\30C1\30E3\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103812368549308257)
,p_name=>'APEXAPP.REGION.USERS_TO_ADD'
,p_message_language=>'ja'
,p_message_text=>unistr('\8FFD\52A0\3059\308B%0\4EBA\306E\30E6\30FC\30B6\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103821859018308264)
,p_name=>'APEXAPP.REGION.USER_COUNTS_REPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\6570\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103821052174308263)
,p_name=>'APEXAPP.REGION.USER_INTERFACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103823466209308265)
,p_name=>'APEXAPP.REGION.VALID_USERS_EXIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\6709\52B9\306A\30E6\30FC\30B6\30FC\304C\5B58\5728\3057\307E\3059 - \30DA\30FC\30B8\60C5\5831')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103823208871308265)
,p_name=>'APEXAPP.REGION.WIZARD_CONTAINER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A6\30A3\30B6\30FC\30C9\30FB\30B3\30F3\30C6\30CA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103820112175308263)
,p_name=>'APEXAPP.REGION.WIZARD_PROGRESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A6\30A3\30B6\30FC\30C9\9032\6357')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103840544670308278)
,p_name=>'APEXAPP.RELEASE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30EA\30FC\30B9%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103838053322308276)
,p_name=>'APEXAPP.SHORTCUT.GET_NEXT_PREV_PK'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DA\30FC\30B8\3092\4FDD\5B58\305B\305A\306B\9589\3058\307E\3059\304B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103818650854308261)
,p_name=>'APEXAPP.SUCCESS_MSG.ROWS_UPDATED'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\884C\304C\66F4\65B0\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103819884627308262)
,p_name=>'APEXAPP.VALIDATION.AT_LEAST_ONE_REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C11\306A\304F\3068\30821\3064\306E\30D5\30A3\30FC\30C9\30D0\30C3\30AF\304C\5FC5\8981\3067\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103819927335308262)
,p_name=>'APEXAPP.VALIDATION.AT_LEAST_ONE_REQUIRED.ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30FC\30C9\30D0\30C3\30AF\307E\305F\306F\30A8\30AF\30B9\30DA\30EA\30A8\30F3\30B9\3092\63D0\4F9B\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103819602733308262)
,p_name=>'APEXAPP.VALIDATION.CANNOT_REMOVE_YOURSELF_FROM_ADMIN'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\5206\81EA\8EAB\3092\7BA1\7406\8005\304B\3089\524A\9664\3067\304D\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103819780260308262)
,p_name=>'APEXAPP.VALIDATION.CANNOT_REMOVE_YOURSELF_FROM_ADMIN.ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\5206\81EA\8EAB\304B\3089\7BA1\7406\8005\30ED\30FC\30EB\3092\524A\9664\3059\308B\3053\3068\306F\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103819131583308262)
,p_name=>'APEXAPP.VALIDATION.COLUMN.DATE.ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('#COLUMN_HEADER#\306F\3001\6709\52B9\306A\65E5\4ED8\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103818989581308262)
,p_name=>'APEXAPP.VALIDATION.COLUMN.NOT_NULL.ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('#COLUMN_HEADER#\306B\5024\304C\5FC5\8981\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103819007901308262)
,p_name=>'APEXAPP.VALIDATION.COLUMN.NUMERIC.ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('#COLUMN_HEADER#\306F\6570\5024\3067\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103819219650308262)
,p_name=>'APEXAPP.VALIDATION.COLUMN.TIMESTAMP.ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('#COLUMN_HEADER#\306F\6709\52B9\306A\30BF\30A4\30E0\30B9\30BF\30F3\30D7\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103817236932308260)
,p_name=>'APEXAPP.VALIDATION.DATE'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\3001\6709\52B9\306A\65E5\4ED8\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103819460950308262)
,p_name=>'APEXAPP.VALIDATION.ITEM.DATE.ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('#LABEL#\306F\3001\6709\52B9\306A\65E5\4ED8\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103819318209308262)
,p_name=>'APEXAPP.VALIDATION.ITEM.NOT_NULL.ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('#LABEL#\306B\5024\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103819560121308262)
,p_name=>'APEXAPP.VALIDATION.ITEM.TIMESTAMP.ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('#LABEL#\306F\6709\52B9\306A\30BF\30A4\30E0\30B9\30BF\30F3\30D7\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103817054320308260)
,p_name=>'APEXAPP.VALIDATION.NOT_NULL'
,p_message_language=>'ja'
,p_message_text=>unistr('\FF050\306Fnull\3067\306F\3042\308A\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103817113208308260)
,p_name=>'APEXAPP.VALIDATION.NUMERIC'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\6570\5024\306B\3059\308B\5FC5\8981\304C\3042\308A\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103817347089308260)
,p_name=>'APEXAPP.VALIDATION.TIMESTAMP'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\3001\6709\52B9\306A\30BF\30A4\30E0\30B9\30BF\30F3\30D7\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104734553177309030)
,p_name=>'APEXDEV.IG.COLUMN_NOT_EXISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\52D5\7684\30A2\30AF\30B7\30E7\30F3''#COMPONENT_NAME#''\306B\5BFE\3057\3066\6307\5B9A\3055\308C\305F\5BFE\8A71\30B0\30EA\30C3\30C9\5217''%0''\304C\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104734781865309030)
,p_name=>'APEXDEV.IG.DML.COMPLEX_VIEW_LOCK'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\30ED\30C3\30AF\306E\5B9F\884C\4E2D\306B\30D7\30ED\30BB\30B9''%0''\3067''%1''\304C\767A\751F\3057\307E\3057\305F\3002\3053\306E\30A8\30E9\30FC\306F\3001\30D7\30ED\30BB\30B9\3067instead-of\30C8\30EA\30AC\30FC\3092\4F7F\7528\3057\3066\8907\5408\30D3\30E5\30FC\306BSELECT FOR UPDATE\3092\767A\884C\3057\3001\884C\3092\30ED\30C3\30AF\3059\308B\5834\5408\306B\767A\751F\3059\308B\3053\3068\304C\3042\308A\307E\3059\3002\30D7\30ED\30BB\30B9\5C5E\6027\306E\300C\884C\306E\30ED\30C3\30AF\300D\3092\300C\3044\3044\3048\300D\307E\305F\306F\300CPL/SQL\30B3\30FC\30C9\300D\306B\8A2D\5B9A\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104734601999309030)
,p_name=>'APEXDEV.IG.DML.VIRTUAL_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('DML\30B3\30DE\30F3\30C9\306E\5B9F\884C\4E2D\306B\30D7\30ED\30BB\30B9''%0''\3067''%1''\304C\767A\751F\3057\307E\3057\305F\3002\3053\306E\30A8\30E9\30FC\306F\3001\5217\304C\96C6\8A08\307E\305F\306FSQL\5F0F\306B\57FA\3065\3044\3066\3044\308B\5834\5408\306B\767A\751F\3059\308B\3053\3068\304C\3042\308A\307E\3059\3002\5217\5C5E\6027\306E\300C\554F\5408\305B\306E\307F\300D\3092\300C\306F\3044\300D\306B\8A2D\5B9A\3057\3066\3001INSERT\304A\3088\3073UPDATE\6587\304B\3089\5217\3092\9664\5916\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104356362171308724)
,p_name=>'APEXDEV.IG.MASTER_DETAIL_COLUMN_NOT_POPULATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30B9\30BF\30FC\30FB\30C7\30A3\30C6\30FC\30EB\5217''%0''\306B\5024\304C\542B\307E\308C\3066\3044\307E\305B\3093\3002\30D7\30ED\30BB\30B9''%1''\304C\30DE\30B9\30BF\30FC\30FB\30EA\30FC\30B8\30E7\30F3\306E\5BFE\5FDC\3059\308B\30D7\30ED\30BB\30B9\306E\5F8C\306B\5B9F\884C\3055\308C\3066\3044\308B\3053\3068\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104716830473309014)
,p_name=>'APEXDEV.IG.NO_MASTER_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\5BFE\8A71\30B0\30EA\30C3\30C9''%0''\306B\30DE\30B9\30BF\30FC\30FB\30C7\30A3\30C6\30FC\30EB\95A2\4FC2\306B\5FC5\8981\306A\5B9A\7FA9\3055\308C\305F\30DE\30B9\30BF\30FC\5217\304C\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104131218011308542)
,p_name=>'APEXDEV.IG.NO_PK'
,p_message_language=>'ja'
,p_message_text=>unistr('\5BFE\8A71\30B0\30EA\30C3\30C9''%0''\306B\7DE8\96C6\307E\305F\306F\30DE\30B9\30BF\30FC\30FB\30C7\30A3\30C6\30FC\30EB\95A2\4FC2\306B\5FC5\8981\306A\5B9A\7FA9\3055\308C\305F\4E3B\30AD\30FC\5217\304C\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104694256216308995)
,p_name=>'APEXDEV.IG.RELOAD_ON_SUBMIT_EDITABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\7DE8\96C6\53EF\80FD\5BFE\8A71\30B0\30EA\30C3\30C9\306E\5834\5408\3001\30DA\30FC\30B8\5C5E\6027\306E\300C\9001\4FE1\6642\306B\30EA\30ED\30FC\30C9\300D\3092\300C\6210\529F\306E\307F\300D\306B\8A2D\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104665250395308971)
,p_name=>'APEXDEV.PE.CODE_EDITOR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30FC\30C9\30FB\30A8\30C7\30A3\30BF: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104665376117308971)
,p_name=>'APEXDEV.PE.COLLAPSE'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\3092\9589\3058\308B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104665455882308971)
,p_name=>'APEXDEV.PE.COLOR_PICKER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30E9\30FC\30FB\30D4\30C3\30AB\30FC: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104665572854308971)
,p_name=>'APEXDEV.PE.EDIT_COMPONENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306E\7DE8\96C6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104665616819308972)
,p_name=>'APEXDEV.PE.ERROR_POSTFIX'
,p_message_language=>'ja'
,p_message_text=>unistr(' (\30A8\30E9\30FC)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104665761863308972)
,p_name=>'APEXDEV.PE.EXPAND'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\3092\958B\304F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104665192844308971)
,p_name=>'APEXDEV.PE.FILTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30EB\30BF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104665893435308972)
,p_name=>'APEXDEV.PE.FILTER_NO_MATCH'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D50\679C\304C\898B\3064\304B\308A\307E\305B\3093\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104665947939308972)
,p_name=>'APEXDEV.PE.FILTER_NO_MATCH_COMMON'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D50\679C\304C\898B\3064\304B\308A\307E\305B\3093\3002\4E0A\306E\300C\3059\3079\3066\8868\793A\300D\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3057\3066\3059\3079\3066\306E\30D7\30ED\30D1\30C6\30A3\3092\691C\7D22\3057\3066\304F\3060\3055\3044\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104666089098308972)
,p_name=>'APEXDEV.PE.FILTER_PROPERTIES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30EB\30BF\30FB\30D7\30ED\30D1\30C6\30A3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104666142402308972)
,p_name=>'APEXDEV.PE.INVALID'
,p_message_language=>'ja'
,p_message_text=>unistr('%0 (\7121\52B9)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104666262189308972)
,p_name=>'APEXDEV.PE.LIST_OF_VALUES'
,p_message_language=>'ja'
,p_message_text=>'LOV: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104666388377308972)
,p_name=>'APEXDEV.PE.NO'
,p_message_language=>'ja'
,p_message_text=>unistr('\3044\3044\3048')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104666422971308972)
,p_name=>'APEXDEV.PE.NO_COMMON_PROPERTIES'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3057\305F\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\306F\5171\901A\306E\30D7\30ED\30D1\30C6\30A3\306F\3042\308A\307E\305B\3093\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104667675822308973)
,p_name=>'APEXDEV.PE.NO_COMPONENTS_SELECTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\9078\629E\3055\308C\3066\3044\308B\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306F\3042\308A\307E\305B\3093')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104666588358308972)
,p_name=>'APEXDEV.PE.PICK'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306E\9078\629E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104666659795308972)
,p_name=>'APEXDEV.PE.PIN_FILTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30EB\30BF\306E\56FA\5B9A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104666744744308972)
,p_name=>'APEXDEV.PE.QUICK_PICK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30A4\30C3\30AF\9078\629E: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104666814556308972)
,p_name=>'APEXDEV.PE.QUICK_PICK.CLEAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\306E\30AF\30EA\30A2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104666994450308973)
,p_name=>'APEXDEV.PE.REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\5FC5\9808')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104667073776308973)
,p_name=>'APEXDEV.PE.SEARCH'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104667192037308973)
,p_name=>'APEXDEV.PE.SELECT'
,p_message_language=>'ja'
,p_message_text=>unistr('- \9078\629E -')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104667264143308973)
,p_name=>'APEXDEV.PE.VALUE_VARIES_POSTFIX'
,p_message_language=>'ja'
,p_message_text=>unistr(' (\5024\306F\3001\5834\5408\306B\3088\3063\3066\7570\306A\308A\307E\3059)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104667373747308973)
,p_name=>'APEXDEV.PE.WARNING'
,p_message_language=>'ja'
,p_message_text=>unistr('\8B66\544A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104667429910308973)
,p_name=>'APEXDEV.PE.WARNING_POSTFIX'
,p_message_language=>'ja'
,p_message_text=>unistr(' (\8B66\544A)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104667508069308973)
,p_name=>'APEXDEV.PE.YES'
,p_message_language=>'ja'
,p_message_text=>unistr('\306F\3044')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104694397304308995)
,p_name=>'APEXDEV.TABFORM.RELOAD_ON_SUBMIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\5F62\5F0F\30D5\30A9\30FC\30E0\306E\5834\5408\3001\30DA\30FC\30B8\5C5E\6027\306E\300C\9001\4FE1\6642\306B\30EA\30ED\30FC\30C9\300D\3092\300C\5E38\6642\300D\306B\8A2D\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104473907017308812)
,p_name=>'APEXIG_MULTIIG_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306B\306F\8907\6570\306E\5BFE\8A71\30B0\30EA\30C3\30C9\304C\542B\307E\308C\3066\3044\308B\305F\3081\3001\30EA\30FC\30B8\30E7\30F3\306E\9759\7684ID\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103699182250308166)
,p_name=>'APEXIR_3D'
,p_message_language=>'ja'
,p_message_text=>'3D'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103809623765308255)
,p_name=>'APEXIR_ADD'
,p_message_language=>'ja'
,p_message_text=>unistr('\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104291873318308676)
,p_name=>'APEXIR_ADD_SUBSCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30D6\30B9\30AF\30EA\30D7\30B7\30E7\30F3\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103948644750308396)
,p_name=>'APEXIR_AGGREGATE_DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\96C6\8A08\306F\3001\5404\30B3\30F3\30C8\30ED\30FC\30EB\30FB\30D6\30EC\30FC\30AF\306E\5F8C\3068\30EC\30DD\30FC\30C8\306E\6700\5F8C\306B\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103864518790308296)
,p_name=>'APEXIR_AGG_COUNT_DISTINCT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5225\3005\306B\30AB\30A6\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103810067613308255)
,p_name=>'APEXIR_AGG_MODE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E2\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104692079182308993)
,p_name=>'APEXIR_AREA'
,p_message_language=>'ja'
,p_message_text=>unistr('\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104289607506308674)
,p_name=>'APEXIR_BLACK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30E9\30C3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103810312445308255)
,p_name=>'APEXIR_CALENDAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30EC\30F3\30C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103916243031308371)
,p_name=>'APEXIR_COLUMN_HEADING'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\30D8\30C3\30C0\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104724242554309020)
,p_name=>'APEXIR_DAY'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103844577000308281)
,p_name=>'APEXIR_DELETE_CHECKED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30A7\30C3\30AF\3057\305F\9805\76EE\306E\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103948950433308397)
,p_name=>'APEXIR_DELETE_CONFIRM_JS_DIALOG'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\524A\9664\64CD\4F5C\3092\5B9F\884C\3057\307E\3059\304B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103927953086308380)
,p_name=>'APEXIR_DISABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103699331643308166)
,p_name=>'APEXIR_DISPLAY'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103677090439308148)
,p_name=>'APEXIR_DONUT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C9\30FC\30CA\30C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103548674472308051)
,p_name=>'APEXIR_DOWNLOAD_DATA_ONLY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\306E\307F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103699265839308166)
,p_name=>'APEXIR_DO_NOT_AGGREGATE'
,p_message_language=>'ja'
,p_message_text=>unistr('- \96C6\8A08\3057\306A\3044 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104675226071308979)
,p_name=>'APEXIR_EDIT_ALTERNATIVE_DEFAULT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4EE3\66FF\30C7\30D5\30A9\30EB\30C8\306E\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103927825552308380)
,p_name=>'APEXIR_ENABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6709\52B9\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103948787247308396)
,p_name=>'APEXIR_FLASHBACK_ERROR_MSG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30E9\30C3\30B7\30E5\30D0\30C3\30AF\30FB\30EA\30AF\30A8\30B9\30C8\3092\5B9F\884C\3067\304D\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104278902890308667)
,p_name=>'APEXIR_FUNCTION_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30F3\30AF\30B7\30E7\30F3\5217%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104289783286308674)
,p_name=>'APEXIR_GRAY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30EC\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103676877190308148)
,p_name=>'APEXIR_HIGHLIGHT_WHEN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CF\30A4\30E9\30A4\30C8\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104224795872308628)
,p_name=>'APEXIR_LABEL_PREFIX'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB\306E\63A5\982D\8F9E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104280703595308668)
,p_name=>'APEXIR_MANAGE_SUBSCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30D6\30B9\30AF\30EA\30D7\30B7\30E7\30F3\3092\7BA1\7406\3059\308B\306B\306F<a href=''%0''>\3053\3053\3092</a>\30AF\30EA\30C3\30AF\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103949579116308397)
,p_name=>'APEXIR_MORE_DATA'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A73\7D30\30C7\30FC\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103694913187308162)
,p_name=>'APEXIR_NEW_CATEGORY'
,p_message_language=>'ja'
,p_message_text=>unistr('- \65B0\898F\30AB\30C6\30B4\30EA -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103844629647308281)
,p_name=>'APEXIR_NO_AGGREGATION_DEFINED'
,p_message_language=>'ja'
,p_message_text=>unistr('\96C6\8A08\304C\5B9A\7FA9\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103772748639308226)
,p_name=>'APEXIR_NO_COLUMN_INFO'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\60C5\5831\304C\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103844771312308281)
,p_name=>'APEXIR_NO_COMPUTATION_DEFINED'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A08\7B97\304C\5B9A\7FA9\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104724188709309020)
,p_name=>'APEXIR_NO_END_DATE'
,p_message_language=>'ja'
,p_message_text=>unistr('- \7D42\4E86\65E5\306A\3057 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104777880905309072)
,p_name=>'APEXIR_PIVOT_ROW_COLUMN_INVALID'
,p_message_language=>'ja'
,p_message_text=>unistr('\5225\306E\884C\5217\3092\9078\629E\3057\3066\304F\3060\3055\3044\3002\884C\5217\306EHTML\5F0F\307E\305F\306F\30EA\30F3\30AF\306B\306F\3001\30D4\30DC\30C3\30C8\5217\307E\305F\306F\96C6\8A08\5217\3068\3057\3066\5B9A\7FA9\3055\308C\305F\5217\304C\542B\307E\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103809727791308255)
,p_name=>'APEXIR_REMOVE_AGGREGATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\96C6\8A08\306E\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104178453744308591)
,p_name=>'APEXIR_REPORT_DISPLAY_COLUMN_LIMIT_REACHED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\306E\8868\793A\5217\306E\6570\304C\5236\9650\306B\9054\3057\307E\3057\305F\3002\300C\30A2\30AF\30B7\30E7\30F3\300D\30E1\30CB\30E5\30FC\3067\300C\5217\306E\9078\629E\300D\3092\30AF\30EA\30C3\30AF\3057\3001\30EC\30DD\30FC\30C8\8868\793A\5217\306E\30EA\30B9\30C8\3092\6700\5C0F\9650\306B\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103783908864308234)
,p_name=>'APEXIR_ROW_ORDER'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103547979030308050)
,p_name=>'APEXIR_RPT_DISP_COL_EXCEED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\306E\8868\793A\5217\306E\6570\304C\5236\9650\306B\9054\3057\307E\3057\305F\3002\300C\30A2\30AF\30B7\30E7\30F3\300D\30E1\30CB\30E5\30FC\3067\300C\5217\306E\9078\629E\300D\3092\30AF\30EA\30C3\30AF\3057\3001\30EC\30DD\30FC\30C8\8868\793A\5217\306E\30EA\30B9\30C8\3092\6700\5C0F\9650\306B\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103844477254308281)
,p_name=>'APEXIR_SAVE_AS_DEFAULT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\3068\3057\3066\4FDD\5B58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103676964082308148)
,p_name=>'APEXIR_SELECT_CATEGORY'
,p_message_language=>'ja'
,p_message_text=>unistr('- \30AB\30C6\30B4\30EA\306E\9078\629E -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103949690455308397)
,p_name=>'APEXIR_SELECT_COLUMNS_FOOTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A08\7B97\7D50\679C\306E\5217\306F\3001\5148\982D\306B**\304C\4ED8\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104724058269309020)
,p_name=>'APEXIR_SELECT_SORT_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('- \30BD\30FC\30C8\5217\306E\9078\629E -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103949461398308397)
,p_name=>'APEXIR_SELECT_VALUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024\306E\9078\629E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104723920269309020)
,p_name=>'APEXIR_SORT_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BD\30FC\30C8\5217%0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104278843502308667)
,p_name=>'APEXIR_SUBSCRIPTION_ENDING_UNIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D42\4E86\5358\4F4D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103948882959308397)
,p_name=>'APEXIR_UNAUTHORIZED'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\53EF\3055\308C\3066\3044\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103926147889308379)
,p_name=>'APEXIR_UNIQUE_COLUMN_HEADING'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\30D8\30C3\30C0\30FC\306F\4E00\610F\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104724356989309020)
,p_name=>'APEXIR_WEEK'
,p_message_language=>'ja'
,p_message_text=>unistr('\9031')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103545247985308048)
,p_name=>'APEX_ADMIN_SERVICES'
,p_message_language=>'ja'
,p_message_text=>unistr('Application Express\7BA1\7406\30B5\30FC\30D3\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104675547007308979)
,p_name=>'APEX_AUTHENTICATION.NOT_CONFIGURED'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\306F\8A8D\8A3C\304C\69CB\6210\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103987844123308426)
,p_name=>'APEX_SAMPLE_LOAD'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30AA\30D6\30B8\30A7\30AF\30C8\306F\3001\9078\629E\3057\305F\30B9\30AD\30FC\30DE\306B%0\3055\308C\307E\3059:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103987953944308426)
,p_name=>'APEX_SAMPLE_LOAD_SUCCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30AA\30D6\30B8\30A7\30AF\30C8\306F\6B63\5E38\306B%0\3055\308C\307E\3057\305F:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104363007188308729)
,p_name=>'APEX_SCROLL_DOWN'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0B\3078\30B9\30AF\30ED\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104363127442308729)
,p_name=>'APEX_SCROLL_TO_TOP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5148\982D\306B\30B9\30AF\30ED\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103551308436308053)
,p_name=>'APEX_WIZARD_FORM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30D5\30A9\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104675189495308979)
,p_name=>'APEX_WS_EDIT_ROW'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\306E\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104142967714308552)
,p_name=>'APEX_WS_INVALID_OBJECTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9\306A\30AA\30D6\30B8\30A7\30AF\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104728332583309023)
,p_name=>'APEX_WS_NO_PEER_PAGES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D4\30A2\30FB\30DA\30FC\30B8\304C\5B58\5728\3057\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104678450279308982)
,p_name=>'APEX_WS_SETUP_CREATE_OBJ'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F5C\6210\3059\308B\30AA\30D6\30B8\30A7\30AF\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104678604726308982)
,p_name=>'APEX_WS_SETUP_DELETE_TABLES'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\304B\3089\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104678822536308982)
,p_name=>'APEX_WS_SETUP_DROP_OBJECTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30D6\30B8\30A7\30AF\30C8\306E\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104297893736308681)
,p_name=>'APEX_WS_SETUP_DROP_TABLES'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\306E\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104297146460308680)
,p_name=>'APEX_WS_SETUP_MSG1'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\308C\3089\306E\30AA\30D6\30B8\30A7\30AF\30C8\306F<strong>%0</strong>\30B9\30AD\30FC\30DE\3067\4F5C\6210\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104678993995308982)
,p_name=>'APEX_WS_SETUP_MSG10'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\308C\3089\306E\30AA\30D6\30B8\30A7\30AF\30C8\306F\3059\3067\306B<strong>%0</strong>\30B9\30AD\30FC\30DE\306B\5B58\5728\3057\3001\4ED6\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9\3067\4F7F\7528\3055\308C\3066\3044\307E\3059\3002\51E6\7406\3092\7D9A\3051\308B\3068\3001<strong>%0</strong>\3067\4FDD\6709\3055\308C\3066\3044\308B\65E2\5B58\306EWeb\30B7\30FC\30C8\30FB\30AA\30D6\30B8\30A7\30AF\30C8\304C\3053\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306B\3082\95A2\9023\4ED8\3051\3089\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104679042866308982)
,p_name=>'APEX_WS_SETUP_MSG11'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\308C\3089\306E\30AA\30D6\30B8\30A7\30AF\30C8\306B\4F7F\7528\3059\308B\30B9\30AD\30FC\30DE\3092\9078\629E\3057\3066\304F\3060\3055\3044:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104679190573308982)
,p_name=>'APEX_WS_SETUP_MSG12'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F7F\7528\4E88\5B9A\306E\65E2\5B58\306E\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104679925227308983)
,p_name=>'APEX_WS_SETUP_MSG13'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B7\30FC\30C8\30FB\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30AA\30D6\30B8\30A7\30AF\30C8\306F\6B21\306E\60C5\5831\3092\4F7F\7528\3057\3066\518D\5229\7528\3055\308C\307E\3059\3002\30EA\30AF\30A8\30B9\30C8\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104297245192308680)
,p_name=>'APEX_WS_SETUP_MSG2'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F\30B9\30AD\30FC\30DE\3067Web\30B7\30FC\30C8\30FB\30AA\30D6\30B8\30A7\30AF\30C8\3092\4F5C\6210\3059\308B\5834\5408\306F\3001<a href=%0>\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30B9\30AD\30FC\30DE\306E\30EA\30AF\30A8\30B9\30C8</a>\30FB\30A6\30A3\30B6\30FC\30C9\3092\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104297316359308680)
,p_name=>'APEX_WS_SETUP_MSG3'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B7\30FC\30C8\3092\5B9F\884C\3059\308B\306B\306F\3001\6B21\306E\30AA\30D6\30B8\30A7\30AF\30C8\304C\5FC5\8981\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104297457807308680)
,p_name=>'APEX_WS_SETUP_MSG5'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B7\30FC\30C8\30FB\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30AA\30D6\30B8\30A7\30AF\30C8\306F\6B21\306E\60C5\5831\3092\4F7F\7528\3057\3066\4F5C\6210\3055\308C\307E\3059\3002\30EA\30AF\30A8\30B9\30C8\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104297550859308680)
,p_name=>'APEX_WS_SETUP_MSG6'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F5C\6210\3059\308B\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104297638801308680)
,p_name=>'APEX_WS_SETUP_MSG7'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B7\30FC\30C8\30FB\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30AA\30D6\30B8\30A7\30AF\30C8\3092\524A\9664\3057\3088\3046\3068\3057\3066\3044\307E\3059\3002\3053\308C\306B\3088\308A\3001\30EF\30FC\30AF\30B9\30DA\30FC\30B9\5185\306EWeb\30B7\30FC\30C8\30FB\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30AA\30D6\30B8\30A7\30AF\30C8\3068\3001Web\30B7\30FC\30C8\30FB\30B3\30F3\30DD\30FC\30CD\30F3\30C8\3092\542B\3080\5185\90E8\30C7\30FC\30BF\304C\524A\9664\3055\308C\307E\3059\3002\7D9A\884C\3057\307E\3059\304B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104297984653308681)
,p_name=>'APEX_WS_SETUP_MSG8'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B7\30FC\30C8\3092\6B63\3057\304F\5B9F\884C\3059\308B\306B\306F\3001\6B21\306E\7121\52B9\306A\30AA\30D6\30B8\30A7\30AF\30C8\3092\4FEE\6B63\3059\308B\5FC5\8981\304C\3042\308A\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104678587534308982)
,p_name=>'APEX_WS_SETUP_MSG9'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306B\5BFE\3059\308BWeb\30B7\30FC\30C8\5B9A\7FA9\3092\524A\9664\3057\3088\3046\3068\3057\3066\3044\307E\3059\3002Web\30B7\30FC\30C8\30FB\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30AA\30D6\30B8\30A7\30AF\30C8\306F\4ED6\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9\3067\3082\4F7F\7528\3055\308C\3066\3044\308B\305F\3081\3001\524A\9664\3055\308C\307E\305B\3093\3002\3053\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306B\95A2\9023\4ED8\3051\3089\308C\305F\30EC\30B3\30FC\30C9\306F\524A\9664\3055\308C\307E\3059\3002\7D9A\884C\3057\307E\3059\304B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104298063063308681)
,p_name=>'APEX_WS_SETUP_OBJECT_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30D6\30B8\30A7\30AF\30C8\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104298123798308681)
,p_name=>'APEX_WS_SETUP_OBJECT_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30D6\30B8\30A7\30AF\30C8\30FB\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104297769042308680)
,p_name=>'APEX_WS_SETUP_SCHEMA'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AD\30FC\30DE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104678367826308982)
,p_name=>'APEX_WS_SETUP_USE_EXISTING_OBJ'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F7F\7528\3055\308C\308B\65E2\5B58\306E\30AA\30D6\30B8\30A7\30AF\30C8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103600654308308088)
,p_name=>'APPLICACTION_COMPUTATIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\8A08\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103600527168308088)
,p_name=>'APPLICACTION_PROCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30D7\30ED\30BB\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104136738650308547)
,p_name=>'APPLICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104197744701308608)
,p_name=>'APPLICATION BUILDER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30D3\30EB\30C0\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104052431888308477)
,p_name=>'APPLICATION COMPUTATION CONDITION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\8A08\7B97\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104055226453308479)
,p_name=>'APPLICATION IMAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A4\30E1\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104052524955308477)
,p_name=>'APPLICATION PROCESS CONDITION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30D7\30ED\30BB\30B9\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103983563182308423)
,p_name=>'APPLICATIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104118055323308531)
,p_name=>'APPLICATIONS_INITCAP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104026670237308456)
,p_name=>'APPLICATION_ACTIVITY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30AF\30C6\30A3\30D3\30C6\30A3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104064692594308487)
,p_name=>'APPLICATION_ALIAS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\5225\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104062796609308485)
,p_name=>'APPLICATION_DELETED'
,p_message_language=>'ja'
,p_message_text=>unistr('\524A\9664\3055\308C\305F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103545068824308048)
,p_name=>'APPLICATION_DEVELOPMENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\958B\767A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104063678914308486)
,p_name=>'APPLICATION_HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104023432777308453)
,p_name=>'APPLICATION_ID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\756A\53F7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103923342202308377)
,p_name=>'APPLICATION_ID_RESERVED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3ID\306F\4E88\7D04\3055\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103923228487308377)
,p_name=>'APPLICATION_ID_VALIDATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3ID\300D\306F\6B63\306E\6574\6570\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104338018651308710)
,p_name=>'APPLICATION_IMAGES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A4\30E1\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104092748485308510)
,p_name=>'APPLICATION_ITEM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103626538618308107)
,p_name=>'APPLICATION_ITEMS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103595403896308084)
,p_name=>'APPLICATION_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104064584290308487)
,p_name=>'APPLICATION_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104727907218309023)
,p_name=>'APPLICATION_NAMES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104174420030308587)
,p_name=>'APPLICATION_OVERRIDE_ID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30AA\30FC\30D0\30FC\30E9\30A4\30C9ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104062298867308485)
,p_name=>'APPLICATION_OWNER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\6240\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104727852649309023)
,p_name=>'APPLICATION_PAGES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103701919097308168)
,p_name=>'APPLICATION_SETTINGS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104062432603308485)
,p_name=>'APPLICATION_STATUS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30B9\30C6\30FC\30BF\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104138307505308548)
,p_name=>'APPLICATION_VERSION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30D0\30FC\30B8\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103560126978308059)
,p_name=>'APPLICATION_X'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3%0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104011038087308443)
,p_name=>'APPROVED'
,p_message_language=>'ja'
,p_message_text=>unistr('\627F\8A8D\6E08')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104068894440308491)
,p_name=>'APP_SUCCESS_MSG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304C\6B63\5E38\306B\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104730403352309026)
,p_name=>'APP_TEMPLATE_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103593317578308083)
,p_name=>'APP_TYPE_DATABASE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103593427203308083)
,p_name=>'APP_TYPE_PACKAGED'
,p_message_language=>'ja'
,p_message_text=>unistr('\751F\7523\6027\307E\305F\306F\30B5\30F3\30D7\30EB\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104089679726308508)
,p_name=>'APP_TYPE_PACKAGED_WS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30F3\30D7\30EBWeb\30B7\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103593213905308083)
,p_name=>'APP_TYPE_WEBSHEET'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B7\30FC\30C8\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104010521898308443)
,p_name=>'ARCHIVED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30FC\30AB\30A4\30D6\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103595789016308085)
,p_name=>'ARCHIVELOG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30B0\30FB\30A2\30FC\30AB\30A4\30D6: \30AA\30F3')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103846600855308283)
,p_name=>'ARGUMENTS_MUST_HAVE_CHECKSUM'
,p_message_language=>'ja'
,p_message_text=>unistr('\5F15\6570\306B\30C1\30A7\30C3\30AF\30B5\30E0\304C\5FC5\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103934234675308385)
,p_name=>'ARGUMENT_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\5F15\6570\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103934444105308385)
,p_name=>'ARGUMENT_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5F15\6570\306E\30BF\30A4\30D7')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104004783928308439)
,p_name=>'ASAP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3067\304D\308B\3060\3051\65E9\304F')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104002032998308437)
,p_name=>'ASSIGNED'
,p_message_language=>'ja'
,p_message_text=>unistr('\5272\5F53\3066\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103699541840308166)
,p_name=>'ASSIGNEE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5272\5F53\3066\5148')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104750149815309042)
,p_name=>'ASSIGN_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5272\5F53\3066%0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103755573913308212)
,p_name=>'ASSOCIATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\95A2\9023\4ED8\3051')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103701132192308168)
,p_name=>'ASSOCIATED_FEATURES'
,p_message_language=>'ja'
,p_message_text=>unistr('\95A2\9023\4ED8\3051\3089\308C\305F\6A5F\80FD')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104031862379308460)
,p_name=>'ATTACHMENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6DFB\4ED8')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104757908124309048)
,p_name=>'AT_RISK_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\554F\984C\3092\5F15\304D\8D77\3053\3059\53EF\80FD\6027')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103727024684308189)
,p_name=>'AUTH.CONFIRM_MIGRATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30AB\30B9\30BF\30E0\8A8D\8A3C\30AA\30D7\30B7\30E7\30F3\3092\8A8D\8A3C\30B9\30AD\30FC\30E0\306B\79FB\884C\3057\3088\3046\3068\3057\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103726513998308189)
,p_name=>'AUTH.CURRENT_AUTH_METHOD'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\884C\306E\8A8D\8A3C\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103726911279308189)
,p_name=>'AUTH.CUSTOM_AUTH_FUNCTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30B9\30BF\30E0\8A8D\8A3C\30D5\30A1\30F3\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103726680074308189)
,p_name=>'AUTH.LOGIN_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103726869444308189)
,p_name=>'AUTH.LOGIN_URL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30B0\30A4\30F3URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103726735636308189)
,p_name=>'AUTH.NONE'
,p_message_language=>'ja'
,p_message_text=>unistr('\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103732007312308193)
,p_name=>'AUTHENTICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104053495911308478)
,p_name=>'AUTHENTICATION FUNCTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\30D5\30A1\30F3\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104053137261308478)
,p_name=>'AUTHENTICATION SCHEME'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\30B9\30AD\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103747030468308205)
,p_name=>'AUTHENTICATION.CONFIRM_DELETE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3%0\304B\3089\8A8D\8A3C\30B9\30AD\30FC\30E0\3092\524A\9664\3057\3088\3046\3068\3057\3066\3044\307E\3059\3002 \30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304C\73FE\5728SCHEME\8A8D\8A3C\3092\4F7F\7528\3057\3066\3044\306A\3044\304B\3001\307E\305F\306F\30B9\30AD\30FC\30E0\304C\73FE\884C\306E\8A8D\8A3C\30B9\30AD\30FC\30E0\3067\306A\3044\5834\5408\306F\3001\30B9\30AD\30FC\30E0\3092\524A\9664\3057\3066\3082\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\64CD\4F5C\306B\5F71\97FF\306F\3042\308A\307E\305B\3093\3002\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304CSCHEME\8A8D\8A3C\3092\4F7F\7528\3057\3066\304A\308A\3001\305D\308C\304C\73FE\884C\306E\8A8D\8A3C\30B9\30AD\30FC\30E0\3067\3042\308B\5834\5408\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306F\30C7\30D5\30A9\30EB\30C8\306E\8A8D\8A3C\30B9\30AD\30FC\30E0\3092\4F7F\7528\3057\3066\5B9F\884C\3092\7D99\7D9A\3057\307E\3059\3002\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306F\3001\300C\516C\958B\300D\8CC7\683C\8A3C\660E\691C\8A3C\3092\884C\3046\7D44\8FBC\307F\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8\3092\4F7F\7528\3057\307E\3059(\3059\3079\3066\306E\30E6\30FC\30B6\30FC\304C\30A2\30D7\30EA\30B1')
||unistr('\30FC\30B7\30E7\30F3\3092\5B9F\884C\3067\304D\307E\3059)\3002 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103749012761308207)
,p_name=>'AUTHENTICATION.MAKE_CURRENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\3053\306E\8A8D\8A3C\30B9\30AD\30FC\30E0\3092\4F7F\7528\3059\308B\306B\306F\3001\300C\30AB\30EC\30F3\30C8\5316\300D\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104225020183308628)
,p_name=>'AUTHENTICATION_NAME.NATIVE_APEX_ACCOUNTS'
,p_message_language=>'ja'
,p_message_text=>unistr('Application Express\30A2\30AB\30A6\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103541687030308045)
,p_name=>'AUTHENTICATION_NAME.NATIVE_CLOUD_IDM'
,p_message_language=>'ja'
,p_message_text=>'Oracle Cloud Identity Management'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104225118751308628)
,p_name=>'AUTHENTICATION_NAME.NATIVE_CUSTOM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30B9\30BF\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104225474650308628)
,p_name=>'AUTHENTICATION_NAME.NATIVE_DAD'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104225214144308628)
,p_name=>'AUTHENTICATION_NAME.NATIVE_DB_ACCOUNTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30A2\30AB\30A6\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104486852467308828)
,p_name=>'AUTHENTICATION_NAME.NATIVE_HTTP_HEADER_VARIABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('HTTP\30D8\30C3\30C0\30FC\5909\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104225645158308628)
,p_name=>'AUTHENTICATION_NAME.NATIVE_IAS_SSO'
,p_message_language=>'ja'
,p_message_text=>'Oracle Application Server Single Sign-On'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104225322789308628)
,p_name=>'AUTHENTICATION_NAME.NATIVE_LDAP'
,p_message_language=>'ja'
,p_message_text=>unistr('LDAP\30C7\30A3\30EC\30AF\30C8\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104225540098308628)
,p_name=>'AUTHENTICATION_NAME.NATIVE_OPEN_DOOR'
,p_message_language=>'ja'
,p_message_text=>unistr('\516C\958B\8CC7\683C\8A3C\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103519598552308030)
,p_name=>'AUTHENTICATION_NAME.NATIVE_SAML'
,p_message_language=>'ja'
,p_message_text=>unistr('SAML\30B5\30A4\30F3\30A4\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103570135718308066)
,p_name=>'AUTHENTICATION_NAME.NATIVE_SOCIAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BD\30FC\30B7\30E3\30EB\30FB\30B5\30A4\30F3\30A4\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104093747671308511)
,p_name=>'AUTHENTICATION_SCHEME'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\30B9\30AD\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104053026037308478)
,p_name=>'AUTHORIZATION SCHEME'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\53EF\30B9\30AD\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103541773993308046)
,p_name=>'AUTHORIZATION_NAME.NATIVE_CLOUD_IDM'
,p_message_language=>'ja'
,p_message_text=>'Oracle Cloud Identity Management'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103560363404308059)
,p_name=>'AUTHORIZATION_NAME.NATIVE_EXISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('EXISTS SQL\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103560436937308059)
,p_name=>'AUTHORIZATION_NAME.NATIVE_FUNCTION_BODY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30FC\30EB\3092\623B\3059PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103915915888308371)
,p_name=>'AUTHORIZATION_NAME.NATIVE_IS_IN_GROUP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30FC\30EB\307E\305F\306F\30B0\30EB\30FC\30D7\5185\306B\3042\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103916046128308371)
,p_name=>'AUTHORIZATION_NAME.NATIVE_IS_NOT_IN_GROUP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30FC\30EB\307E\305F\306F\30B0\30EB\30FC\30D7\5185\306B\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103560537830308059)
,p_name=>'AUTHORIZATION_NAME.NATIVE_ITEM_EQUALS_VALUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5F0F1\306E\30A2\30A4\30C6\30E0\306E\5024 = \5F0F2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103560612090308059)
,p_name=>'AUTHORIZATION_NAME.NATIVE_ITEM_IS_NOT_NULL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5F0F1\306E\30A2\30A4\30C6\30E0\304CNOT NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103560703012308059)
,p_name=>'AUTHORIZATION_NAME.NATIVE_ITEM_IS_NULL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5F0F1\306E\30A2\30A4\30C6\30E0\304CNULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103560823188308059)
,p_name=>'AUTHORIZATION_NAME.NATIVE_ITEM_NOT_EQUALS_VALUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5F0F1\306E\30A2\30A4\30C6\30E0\306E\5024 != \5F0F2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103560915175308059)
,p_name=>'AUTHORIZATION_NAME.NATIVE_NOT_EXISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('NOT EXISTS SQL\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103561057118308060)
,p_name=>'AUTHORIZATION_NAME.NATIVE_PREF_EQUALS_VALUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5F0F1\306E\30D7\30EA\30D5\30A1\30EC\30F3\30B9\306E\5024 = \5F0F2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103561132338308060)
,p_name=>'AUTHORIZATION_NAME.NATIVE_PREF_NOT_EQUALS_VALUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5F0F1\306E\30D7\30EA\30D5\30A1\30EC\30F3\30B9\306E\5024 != \5F0F2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103612283704308097)
,p_name=>'AUTHZ_CACHE_PER_PAGE_VIEW'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\306E\30DA\30FC\30B8\30FB\30D3\30E5\30FC\3092\8A55\4FA1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103612300304308097)
,p_name=>'AUTHZ_CACHE_PER_SESSION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30C3\30B7\30E7\30F3\3054\3068\306B1\56DE\8A55\4FA1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103564035372308062)
,p_name=>'AUTH_ACCOUNT_EXPIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AB\30A6\30F3\30C8\306E\671F\9650\5207\308C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103563921231308062)
,p_name=>'AUTH_ACCOUNT_LOCKED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AB\30A6\30F3\30C8\304C\30ED\30C3\30AF\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103564383276308062)
,p_name=>'AUTH_ATTEMPTS_EXCEEDED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30B0\30A4\30F3\8A66\884C\306E\6700\5927\56DE\6570\3092\8D85\3048\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103564472980308062)
,p_name=>'AUTH_INTERNAL_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0D\660E\306A\5185\90E8\30A8\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103564237495308062)
,p_name=>'AUTH_PASSWORD_FIRST_USE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30B9\30EF\30FC\30C9\306E\521D\56DE\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103564120646308062)
,p_name=>'AUTH_PASSWORD_INCORRECT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9\306A\30D1\30B9\30EF\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103563780571308061)
,p_name=>'AUTH_SUCCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\6210\529F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103563856653308062)
,p_name=>'AUTH_UNKNOWN_USER'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0D\660E\306A\30E6\30FC\30B6\30FC\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103658686026308134)
,p_name=>'AUTH_UNKNOWN_WORKSPACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0D\660E\306A\30EF\30FC\30AF\30B9\30DA\30FC\30B9\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103668795224308142)
,p_name=>'AUTH_UNKNOWN_WORKSPACE_COLON'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0D\660E\306A\30EF\30FC\30AF\30B9\30DA\30FC\30B9\540D: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103789754087308239)
,p_name=>'AUTOCOMMIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30DF\30C3\30C8\6587\306F\9069\7528\3055\308C\307E\305B\3093\3002\3059\3079\3066\306E\6587\306F\81EA\52D5\7684\306B\30B3\30DF\30C3\30C8\3055\308C\307E\3059\3002')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104487884891308829)
,p_name=>'AUTOMATIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\52D5\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104487902950308829)
,p_name=>'AUTOMATION_ACTIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\52D5\5316\30A2\30AF\30B7\30E7\30F3')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104118694122308532)
,p_name=>'AUTOPROVISION_MODE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30D3\30B8\30E7\30CB\30F3\30B0\30FB\30E2\30FC\30C9')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103539216590308044)
,p_name=>'AUTO_FIRST_ITEM'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\521D\306E\30A2\30A4\30C6\30E0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104140137028308550)
,p_name=>'AVAILABILITY_INIT_CAP'
,p_message_language=>'ja'
,p_message_text=>unistr('\53EF\7528\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103568458220308065)
,p_name=>'AVAILABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F7F\7528\53EF\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104275023147308664)
,p_name=>'AVAILABLE_TO_DEVELOPERS_ONLY'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\767A\8005\306E\307F\4F7F\7528\53EF\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104274935347308664)
,p_name=>'AVAILABLE_WITH_EDIT_LINKS'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\767A\8005\30C4\30FC\30EB\30D0\30FC\3067\4F7F\7528\53EF\80FD')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104027422540308457)
,p_name=>'AVERAGE_RENDER_TIME_SECONDS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5E73\5747\30EC\30F3\30C0\30EA\30F3\30B0\6642\9593(\79D2)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104008931764308442)
,p_name=>'BAR_CHART'
,p_message_language=>'ja'
,p_message_text=>unistr('\68D2\30B0\30E9\30D5')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104326771487308702)
,p_name=>'BASIC'
,p_message_language=>'ja'
,p_message_text=>unistr('\57FA\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103582354017308075)
,p_name=>'BASIC_DEVELOPER'
,p_message_language=>'ja'
,p_message_text=>unistr('\57FA\672C\958B\767A\8005')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103990388510308428)
,p_name=>'BEFORE'
,p_message_language=>'ja'
,p_message_text=>unistr('\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104733227010309029)
,p_name=>'BEFORE LIST ENTRY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8\524D\306E\30A8\30F3\30C8\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104749274904309042)
,p_name=>'BEFORE_FIRST'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\521D\306E\524D')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104056353009308480)
,p_name=>'BIND_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB\306E\30D0\30A4\30F3\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104055772906308480)
,p_name=>'BIND_VARIABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D0\30A4\30F3\30C9\5909\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104055879885308480)
,p_name=>'BIND_VARIABLE_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D0\30A4\30F3\30C9\5909\6570\30E9\30D9\30EB')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104070353397308492)
,p_name=>'BLACK_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\9ED2\8272\306E\30C6\30AD\30B9\30C8')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103545620198308048)
,p_name=>'BLANK'
,p_message_language=>'ja'
,p_message_text=>unistr('\7A7A\767D')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104031050380308460)
,p_name=>'BLOB_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('BLOB\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104176152356308589)
,p_name=>'BLOB_DOWNLOAD_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C0\30A6\30F3\30ED\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103594310307308083)
,p_name=>'BLOB_FORMAT'
,p_message_language=>'ja'
,p_message_text=>unistr('BLOB\30D5\30A9\30FC\30DE\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104176504918308589)
,p_name=>'BLOB_FORMAT_ATTACHMENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6DFB\4ED8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104176234951308589)
,p_name=>'BLOB_FORMAT_DOWNLOAD'
,p_message_language=>'ja'
,p_message_text=>'DOWNLOAD'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104176322440308589)
,p_name=>'BLOB_FORMAT_IMAGE'
,p_message_language=>'ja'
,p_message_text=>'IMAGE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104176494383308589)
,p_name=>'BLOB_FORMAT_INLINE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30E9\30A4\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104032019223308460)
,p_name=>'BLOB_FORMAT_MASK'
,p_message_language=>'ja'
,p_message_text=>unistr('BLOB\30D5\30A9\30FC\30DE\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104031571408308460)
,p_name=>'BLOB_LAST_UPDATED_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('BLOB\6700\7D42\66F4\65B0\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104030969274308459)
,p_name=>'BLOB_TABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('BLOB\8868')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104070209477308492)
,p_name=>'BLUE_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\9752\8272\306E\30C6\30AD\30B9\30C8')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104047461152308473)
,p_name=>'BRANCH CONDITION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30E9\30F3\30C1\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103616076277308099)
,p_name=>'BRANCHES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30E9\30F3\30C1')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103810520555308255)
,p_name=>'BREADCRUMB'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103991003592308428)
,p_name=>'BREADCRUMB LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0\30FB\30E9\30D9\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103991106530308429)
,p_name=>'BREADCRUMB LONG NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0\306E\8A73\7D30\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103810659097308255)
,p_name=>'BREADCRUMBS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104079174246308499)
,p_name=>'BREADCRUMB_ENTRY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0\30FB\30A8\30F3\30C8\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104092926755308510)
,p_name=>'BREADCRUMB_ENTRY_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0\30FB\30A8\30F3\30C8\30EA: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103923685540308377)
,p_name=>'BREADCRUMB_PAGES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0\30FB\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103998548974308434)
,p_name=>'BREADCRUMB_REGION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0\30FB\30EA\30FC\30B8\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103672652609308145)
,p_name=>'BREADCRUMB_SUCCESS_MSG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0\304C\6B63\5E38\306B\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103993652694308430)
,p_name=>'BROWSE_ICON'
,p_message_language=>'ja'
,p_message_text=>unistr('\53C2\7167\30A2\30A4\30B3\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103993451268308430)
,p_name=>'BROWSE_PACKAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30C3\30B1\30FC\30B8\3092\53C2\7167')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103934094092308385)
,p_name=>'BROWSE_TABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\3092\53C2\7167')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103525334037308034)
,p_name=>'BU.APPLICATION_ACLS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3ACL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103521665590308031)
,p_name=>'BU.APPLICATION_COMPUTATIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\8A08\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103569914320308066)
,p_name=>'BU.APPLICATION_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30D0\30C3\30AF\30A2\30C3\30D7\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103521798009308031)
,p_name=>'BU.APPLICATION_ITEMS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103521976425308031)
,p_name=>'BU.APPLICATION_PROCESSES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30D7\30ED\30BB\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103569676157308066)
,p_name=>'BU.APPLICATION_RESTORED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3%0\306F\30EA\30D3\30B8\30E7\30F3%1\304B\3089\30EA\30B9\30C8\30A2\3055\308C\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103521545543308031)
,p_name=>'BU.APPLICATION_SETTINGS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104332488295308706)
,p_name=>'BU.APP_PROPS_MODIFIED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30D7\30ED\30D1\30C6\30A3: \5909\66F4\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104075716320308496)
,p_name=>'BU.AUTHENTICATION_SCHEME'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\30B9\30AD\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103522646980308032)
,p_name=>'BU.AUTHENTICATION_SCHEMES'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\30B9\30AD\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103522734931308032)
,p_name=>'BU.AUTHORIZATION_SCHEMES'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\53EF\30B9\30AD\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103524342112308033)
,p_name=>'BU.BREADCRUMBS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103524461215308033)
,p_name=>'BU.BREADCRUMB_TEMPLATES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103521890531308031)
,p_name=>'BU.BUILD_OPTIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D3\30EB\30C9\30FB\30AA\30D7\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103524646146308033)
,p_name=>'BU.BUTTON_TEMPLATES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103524531891308033)
,p_name=>'BU.CALENDAR_TEMPLATES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30EC\30F3\30C0\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104075558921308496)
,p_name=>'BU.COMPONENTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30DD\30FC\30CD\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104486777575308828)
,p_name=>'BU.COMPONENTS_DELETED'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\524A\9664\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104486687343308828)
,p_name=>'BU.COMPONENTS_MODIFIED'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\5909\66F4\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104486560579308828)
,p_name=>'BU.COMPONENTS_NEW'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\65B0\898F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103523069280308032)
,p_name=>'BU.COMPONENT_SETTINGS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30DD\30FC\30CD\30F3\30C8\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103529529155308037)
,p_name=>'BU.CREDENTIALS'
,p_message_language=>'ja'
,p_message_text=>unistr('\8CC7\683C\8A3C\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103525844020308034)
,p_name=>'BU.DATA_LOADING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\306E\30ED\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103533713728308040)
,p_name=>'BU.DELETED'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\524A\9664\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103533802145308040)
,p_name=>'BU.DEVELOPERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\767A\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103523274502308032)
,p_name=>'BU.EMAIL_TEMPLATES'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103570029011308066)
,p_name=>'BU.IN_PROGRESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30D0\30C3\30AF\30A2\30C3\30D7\304C\9032\884C\4E2D\3067\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103524952106308033)
,p_name=>'BU.LABEL_TEMPLATES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104075905073308496)
,p_name=>'BU.LAST_BACKUP'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\7D42\30D0\30C3\30AF\30A2\30C3\30D7: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104075458744308496)
,p_name=>'BU.LAST_UPDATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\7D42\66F4\65B0: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103522003596308031)
,p_name=>'BU.LISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103524847607308033)
,p_name=>'BU.LIST_TEMPLATES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103569758337308066)
,p_name=>'BU.LOCKED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30C3\30AF\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103522351599308032)
,p_name=>'BU.LOVS'
,p_message_language=>'ja'
,p_message_text=>'LOV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103525256594308034)
,p_name=>'BU.LOV_TEMPLATES'
,p_message_language=>'ja'
,p_message_text=>unistr('LOV\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103529472231308037)
,p_name=>'BU.MESSAGES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E1\30C3\30BB\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103533657923308040)
,p_name=>'BU.MODIFIED'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\5909\66F4\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103522516095308032)
,p_name=>'BU.NAVIGATION_MENU'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104075629955308496)
,p_name=>'BU.NEW'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\65B0\898F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103524255366308033)
,p_name=>'BU.PAGES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104486407800308828)
,p_name=>'BU.PAGES_DELETED'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\524A\9664\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104486310789308821)
,p_name=>'BU.PAGES_MODIFIED'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\5909\66F4\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104486241248308821)
,p_name=>'BU.PAGES_NEW'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\65B0\898F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103522471597308032)
,p_name=>'BU.PLUGINS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30E9\30B0\30A4\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103524780385308033)
,p_name=>'BU.REGION_TEMPLATES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103529716706308037)
,p_name=>'BU.REMOTE_SERVERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30FC\30D0\30FC\306E\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103525605788308034)
,p_name=>'BU.REPORT_LAYOUTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\30FB\30EC\30A4\30A2\30A6\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103525111875308034)
,p_name=>'BU.REPORT_TEMPLATES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104030741167308459)
,p_name=>'BU.RESTORED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8\30A2\3055\308C\305F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103560000113308059)
,p_name=>'BU.RESTORED_DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306F\30D0\30C3\30AF\30A2\30C3\30D7\30FB\30EA\30D3\30B8\30E7\30F3%0\304B\3089\30EA\30B9\30C8\30A2\3055\308C\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103523774012308033)
,p_name=>'BU.REST_ENABLED_SQL'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\5BFE\5FDCSQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103525532083308034)
,p_name=>'BU.SHARED_QUERIES'
,p_message_language=>'ja'
,p_message_text=>unistr('\5171\6709\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103523156921308032)
,p_name=>'BU.SHORTCUTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30E7\30FC\30C8\30AB\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103523480262308032)
,p_name=>'BU.STATIC_APPLICATION_FILES'
,p_message_language=>'ja'
,p_message_text=>unistr('\9759\7684\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30D5\30A1\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103523590553308032)
,p_name=>'BU.STATIC_WORKSPACE_FILES'
,p_message_language=>'ja'
,p_message_text=>unistr('\9759\7684\30EF\30FC\30AF\30B9\30DA\30FC\30B9\30FB\30D5\30A1\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103566960777308064)
,p_name=>'BU.SUMMARY_NOT_AVAILABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5909\66F4\30B5\30DE\30EA\30FC\306F\4F7F\7528\3067\304D\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103525021079308033)
,p_name=>'BU.TABS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103523671700308032)
,p_name=>'BU.TEXT_MESSAGES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8\30FB\30E1\30C3\30BB\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103522229575308031)
,p_name=>'BU.THEMES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103525461696308034)
,p_name=>'BU.TREES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C4\30EA\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103569837070308066)
,p_name=>'BU.UNLOCKED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30C3\30AF\89E3\9664\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103522150079308031)
,p_name=>'BU.USER_INTERFACES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\5C5E\6027')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103522870064308032)
,p_name=>'BU.WEB_CREDENTIALS'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\8CC7\683C\8A3C\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103525756630308034)
,p_name=>'BU.WEB_SERVICES'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B5\30FC\30D3\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103529655242308037)
,p_name=>'BU.WEB_SOURCES'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\30C7\30FC\30BF\30FB\30BD\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103549586005308051)
,p_name=>'BUFFER CACHE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D0\30C3\30D5\30A1\30FB\30AD\30E3\30C3\30B7\30E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104005225428308439)
,p_name=>'BUG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D0\30B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104028561887308457)
,p_name=>'BUGS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D0\30B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104049978009308475)
,p_name=>'BUGS_ASSIGNED'
,p_message_language=>'ja'
,p_message_text=>unistr('\5272\5F53\3066\6E08\306E\30D0\30B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104087158137308506)
,p_name=>'BUGS_ASSIGNED_COUNT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5272\5F53\3066\6E08\306E\30D0\30B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103578101822308072)
,p_name=>'BUGS_CLOSED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30ED\30FC\30BA\3057\305F\30D0\30B0(%0 / %1):')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104355631124308723)
,p_name=>'BUGS_PERCENT_CLOSED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D0\30B0\306E\30AF\30ED\30FC\30BA\7387(%0/%1):')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104087229727308506)
,p_name=>'BUGS_UNASSIGNED_COUNT'
,p_message_language=>'ja'
,p_message_text=>unistr('\672A\5272\5F53\3066\306E\30D0\30B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104087345403308506)
,p_name=>'BUGS_WITHOUT_FIXBY'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5\4ED8\5225\306E\4FEE\6B63\304C\3042\308A\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104356013042308723)
,p_name=>'BUG_FEEDBACK_DASH'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D0\30B0: %1/%0\304C\30AF\30ED\30FC\30BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104754572050309046)
,p_name=>'BUG_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D0\30B0: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104043609257308470)
,p_name=>'BUILD QUERY'
,p_message_language=>'ja'
,p_message_text=>unistr('\554F\5408\305B\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103533456215308040)
,p_name=>'BUILDER.CODE_LANGUAGE.JAVA'
,p_message_language=>'ja'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103533321578308040)
,p_name=>'BUILDER.CODE_LANGUAGE.JAVASCRIPT'
,p_message_language=>'ja'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103533274166308040)
,p_name=>'BUILDER.CODE_LANGUAGE.PLSQL'
,p_message_language=>'ja'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103533514707308040)
,p_name=>'BUILDER.CODE_LANGUAGE.PYTHON'
,p_message_language=>'ja'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103533167064308039)
,p_name=>'BUILDER.CODE_LANGUAGE.SQL'
,p_message_language=>'ja'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104137786514308548)
,p_name=>'BUILDER.PLUGINS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30E9\30B0\30A4\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104135184949308546)
,p_name=>'BUILDER.UNSUPPORTED_COMPONENT'
,p_message_language=>'ja'
,p_message_text=>unistr('[\975E\30B5\30DD\30FC\30C8]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104334468733308708)
,p_name=>'BUILDER_NOTIFICATION_MESSAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\30FB\30E1\30C3\30BB\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103739249618308199)
,p_name=>'BUILD_OPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D3\30EB\30C9\30FB\30AA\30D7\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104184791087308597)
,p_name=>'BUILD_OPTION_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D3\30EB\30C9\30FB\30AA\30D7\30B7\30E7\30F3: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104753253329309045)
,p_name=>'BUILD_STATUS_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D3\30EB\30C9\30FB\30B9\30C6\30FC\30BF\30B9: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104185553111308597)
,p_name=>'BUILD_VERSION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D3\30EB\30C9\30FB\30D0\30FC\30B8\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104081086855308501)
,p_name=>'BUILT_IN_REPORT_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D44\8FBC\307F\30EC\30DD\30FC\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103989662679308427)
,p_name=>'BUTTON'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104177887921308591)
,p_name=>'BUTTON.ADD'
,p_message_language=>'ja'
,p_message_text=>unistr('\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103557795472308057)
,p_name=>'BUTTON.DA.INVALID.BUTTON_ATTR_CONTAIN_ID'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3057\305F\30DC\30BF\30F3\306E\30DC\30BF\30F3\5C5E\6027\306BID\3092\542B\3081\308B\3053\3068\306F\3067\304D\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103557683102308057)
,p_name=>'BUTTON.DA.INVALID.NOT_DEFINED_BY_DA'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3057\305F\30DC\30BF\30F3\306F\3001\30A2\30AF\30B7\30E7\30F3\304C\300C\52D5\7684\30A2\30AF\30B7\30E7\30F3\306B\3088\308B\5B9A\7FA9\300D\306B\8A2D\5B9A\3055\308C\3066\3044\308B\30DC\30BF\30F3\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103557860288308057)
,p_name=>'BUTTON.DA.INVALID.TEMPLATE_NO_BUTTON_ID'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3057\305F\30DC\30BF\30F3\306F#BUTTON_ID#\7F6E\63DB\6587\5B57\5217\304C\542B\307E\308C\3066\3044\306A\3044\300C\30DC\30BF\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8\300D\3092\4F7F\7528\3057\3066\3044\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104177628374308590)
,p_name=>'BUTTON.DELETE'
,p_message_language=>'ja'
,p_message_text=>unistr('\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103616201174308099)
,p_name=>'BUTTON.INVALID.ACTION.REDIRECT_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103594900626308084)
,p_name=>'BUTTON.INVALID.ACTION.REPORT_QRY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\554F\5408\305B\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103593074444308082)
,p_name=>'BUTTON.INVALID.ACTION.SOURCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3\30FB\30EA\30AF\30A8\30B9\30C8\306E\30BD\30FC\30B9\30FB\30BF\30A4\30D7\304C\300C\5E38\306BNULL\300D\3067\306A\3044\5834\5408\3001\30DC\30BF\30F3\30FB\30EA\30AF\30A8\30B9\30C8\306F\3059\3079\3066\306E\30DC\30BF\30F3\30FB\30EA\30AF\30A8\30B9\30C8\306E\30BD\30FC\30B9\30FB\30BF\30A4\30D7\306B\6307\5B9A\3055\308C\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103593780383308083)
,p_name=>'BUTTON.INVALID.ACTION.SOURCE_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\30DC\30BF\30F3\30FB\30EA\30AF\30A8\30B9\30C8\306E\30BD\30FC\30B9\30FB\30BF\30A4\30D7\300D\306B\5024\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103616318479308100)
,p_name=>'BUTTON.INVALID.ACTION.URL_TARGET'
,p_message_language=>'ja'
,p_message_text=>unistr('\300CURL\30BF\30FC\30B2\30C3\30C8\300D\306B\5024\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103559760075308059)
,p_name=>'BUTTON.INVALID.BUTTON_ATTR_HAS_ID_WHEN_DA'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3\304C\300C\52D5\7684\30A2\30AF\30B7\30E7\30F3\306B\3088\308B\5B9A\7FA9\300D\306E\5834\5408\3001\30DC\30BF\30F3\5C5E\6027\306BID\3092\542B\3081\308B\3053\3068\306F\3067\304D\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103617498092308100)
,p_name=>'BUTTON.INVALID.STYLE.IMAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30E1\30FC\30B8\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103617505579308100)
,p_name=>'BUTTON.INVALID.STYLE.NO_STYLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30BF\30A4\30EB\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103617329217308100)
,p_name=>'BUTTON.INVALID.STYLE.TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103559610292308059)
,p_name=>'BUTTON.INVALID.TEMPLATE_NO_BUTTON_ID_WHEN_DA'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3\30FB\30B9\30BF\30A4\30EB\304C\300C\30C6\30F3\30D7\30EC\30FC\30C8\30FB\30D9\30FC\30B9\306E\30DC\30BF\30F3\300D\3067\30A2\30AF\30B7\30E7\30F3\304C\300C\52D5\7684\30A2\30AF\30B7\30E7\30F3\306B\3088\308B\5B9A\7FA9\300D\306E\5834\5408\3001\9078\629E\3057\305F\30DC\30BF\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306B#BUTTON_ID#\7F6E\63DB\6587\5B57\5217\304C\542B\307E\308C\3066\3044\308B\5FC5\8981\304C\3042\308A\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103547587100308050)
,p_name=>'BUTTON.INVALID_DELETE.REFERENCED_BY.DA_AFFECTED_ELEMENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\52D5\7684\30A2\30AF\30B7\30E7\30F3(\30DA\30FC\30B8: %0\3001\52D5\7684\30A2\30AF\30B7\30E7\30F3: ''%1''\3001\30A2\30AF\30B7\30E7\30F3: ''%2\3001\5C5E\6027: ''\5F71\97FF\3092\53D7\3051\308B\8981\7D20'')\3067\53C2\7167\3055\308C\3066\3044\308B\305F\3081\3001\30DC\30BF\30F3\3092\524A\9664\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103547465324308050)
,p_name=>'BUTTON.INVALID_DELETE.REFERENCED_BY.DA_WHEN'
,p_message_language=>'ja'
,p_message_text=>unistr('\52D5\7684\30A2\30AF\30B7\30E7\30F3(\30DA\30FC\30B8: %0\3001\52D5\7684\30A2\30AF\30B7\30E7\30F3: ''%1''\3001\5C5E\6027: ''\30BF\30A4\30DF\30F3\30B0'')\3067\53C2\7167\3055\308C\3066\3044\308B\305F\3081\3001\30DC\30BF\30F3\3092\524A\9664\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104177728049308590)
,p_name=>'BUTTON.SUBMIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\9001\4FE1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104173992640308587)
,p_name=>'BUTTON.TEMPLATE.JAVASCRIPT'
,p_message_language=>'ja'
,p_message_text=>unistr('"onclick"\5C5E\6027\3067\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104177129522308590)
,p_name=>'BUTTON.TEMPLATE.LINK'
,p_message_language=>'ja'
,p_message_text=>unistr('"href"\5C5E\6027\3067\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103616123183308099)
,p_name=>'BUTTONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104056763801308481)
,p_name=>'BUTTON_ATTRIBUTES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104753010372309045)
,p_name=>'BUTTON_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104061080943308484)
,p_name=>'BUTTON_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103613414456308097)
,p_name=>'BYTES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D0\30A4\30C8')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104004886851308439)
,p_name=>'BY_NEXT_PATCH'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\30D1\30C3\30C1\307E\3067')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104004982530308439)
,p_name=>'BY_NEXT_RELEASE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\30EA\30EA\30FC\30B9\307E\3067')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104827654822309108)
,p_name=>'CA.ABOUT'
,p_message_language=>'ja'
,p_message_text=>unistr('\60C5\5831')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104793904293309083)
,p_name=>'CA.ABOUT.PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\60C5\5831\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104793802197309083)
,p_name=>'CA.ABOUT.PAGE.DETAIL'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\8AAC\660E\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30D0\30FC\30B8\30E7\30F3\3001\304A\3088\3073\30DA\30FC\30B8\6570\304C\8A18\8F09\3055\308C\305F\300C\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\3064\3044\3066\300D\30DA\30FC\30B8\3092\542B\3081\307E\3059\3002'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103716834824308181)
,p_name=>'CA.ABOUT.PAGE.HELP.CONTENT.CONTAINER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30C6\30F3\30C4\30FB\30B3\30F3\30C6\30CA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104827854742309109)
,p_name=>'CA.ABOUT.THIS.APPLICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\60C5\5831\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104827952121309109)
,p_name=>'CA.ABOUT.THIS.APPLICATION.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\95A2\3059\308B\30C6\30AD\30B9\30C8\306F\3001\3053\3053\306B\914D\7F6E\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104827557494309108)
,p_name=>'CA.ABOUT.THIS.PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DA\30FC\30B8\306B\3064\3044\3066')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104838729107309117)
,p_name=>'CA.ABOUT.THIS.PREVIEW.RELEASE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30D7\30EC\30D3\30E5\30FC\30FB\30EA\30EA\30FC\30B9\306B\3064\3044\3066')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103676752009308148)
,p_name=>'CA.ACCESS.CANNOT_REMOVE_YOURSELF_FROM_ADMIN'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\5206\81EA\8EAB\3092\7BA1\7406\8005\304B\3089\524A\9664\3067\304D\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103676644197308148)
,p_name=>'CA.ACCESS.CANNOT_REMOVE_YOURSELF_FROM_ADMIN_MSG'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\5206\81EA\8EAB\304B\3089\7BA1\7406\8005\30ED\30FC\30EB\3092\524A\9664\3059\308B\3053\3068\306F\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104794271251309084)
,p_name=>'CA.ACCESS.CONTROL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30BB\30B9\5236\5FA1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104830195637309110)
,p_name=>'CA.ACCESS.CONTROL.ACTIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30BB\30B9\5236\5FA1\30A2\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104819668981309103)
,p_name=>'CA.ACCESS.CONTROL.CONFIGURATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30BB\30B9\5236\5FA1\69CB\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104792663203309083)
,p_name=>'CA.ACCESS.CONTROL.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30FC\30EB\30FB\30D9\30FC\30B9\30FB\30E6\30FC\30B6\30FC\8A8D\53EF\306E\6709\52B9\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104794334880309084)
,p_name=>'CA.ACCESS.CONTROL.DETAIL'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30ED\30FC\30EB\30FB\30D9\30FC\30B9\30FB\30E6\30FC\30B6\30FC\8A8D\8A3C\3092\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\7D44\307F\8FBC\307F\307E\3059\3002'),
unistr('\30E6\30FC\30B6\30FC\306F\3001\7BA1\7406\8005\3001\30B3\30F3\30C8\30EA\30D3\30E5\30FC\30BF\307E\305F\306F\30EA\30FC\30C0\30FC\3068\3057\3066\5B9A\7FA9\3067\304D\307E\3059\3002'),
unistr('\305D\306E\5F8C\3001\30DA\30FC\30B8\3001\30E1\30CB\30E5\30FC\30FB\30A8\30F3\30C8\30EA\3001\30EA\30FC\30B8\30E7\30F3\3001\5217\3001\30A2\30A4\30C6\30E0\3001\30DC\30BF\30F3\306A\3069\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5168\4F53\306B\308F\305F\308B\69D8\3005\306A\30B3\30F3\30DD\30FC\30CD\30F3\30C8\3092\5BFE\8C61\3068\3057\3066\3001\7570\306A\308B\30ED\30FC\30EB\306B\7570\306A\308B\30A2\30AF\30BB\30B9\6A29\3092\7C21\5358\306B\5B9A\7FA9\3067\304D\307E\3059\3002</p>'),
unistr('<p>\6B21\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\304C\542B\307E\308C\307E\3059:'),
'<ul>',
unistr('<li>\30A2\30AF\30BB\30B9\5236\5FA1\6A5F\80FD\3078\306E\30EA\30F3\30AF\304C\542B\307E\308C\308B\7BA1\7406\30DA\30FC\30B8\30FB\30EA\30FC\30B8\30E7\30F3</li>'),
unistr('<li>\30A2\30AF\30BB\30B9\5236\5FA1\3092\7BA1\7406\3059\308B\305F\3081\306E\30E6\30FC\30B6\30FC\8868</li>'),
unistr('<li>\8A8D\8A3C\3055\308C\305F\30E6\30FC\30B6\30FC\306E\30A2\30AF\30BB\30B9\30FB\30EC\30D9\30EB\3092\8A2D\5B9A\3059\308B\305F\3081\306E\69CB\6210\30DA\30FC\30B8</li>'),
unistr('<li>\30E6\30FC\30B6\30FC\540D\304C\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9\3067\3042\308B\304B\3069\3046\304B\3092\6307\5B9A\3059\308B\305F\3081\306E\69CB\6210\30DA\30FC\30B8</li>'),
unistr('<li>\30E6\30FC\30B6\30FC\30FB\30A2\30AF\30BB\30B9\3092\30EC\30DD\30FC\30C8\304A\3088\3073\7DE8\96C6\3059\308B\305F\3081\306E\30E6\30FC\30B6\30FC\30FB\30A2\30AF\30BB\30B9\30FB\30DA\30FC\30B8\306E\7BA1\7406</li>'),
unistr('<li>\5358\4E00\306E\30E6\30FC\30B6\30FC\3092\8FFD\52A0\3067\304D\308B\30E6\30FC\30B6\30FC\30FB\30DA\30FC\30B8\306E\8FFD\52A0</li>'),
unistr('<li>\8907\6570\306E\30E6\30FC\30B6\30FC\3092\8FFD\52A0\3067\304D\308B\8907\6570\30E6\30FC\30B6\30FC\30FB\30DA\30FC\30B8\306E\8FFD\52A0(\96FB\5B50\30E1\30FC\30EB\30FB\30E6\30FC\30B6\30FC\540D\306E\307F)</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104818514802309102)
,p_name=>'CA.ACCESS.ROLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104819283494309102)
,p_name=>'CA.ACCESS.ROLE.ID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30BB\30B9\30FB\30ED\30FC\30EBID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103648348639308126)
,p_name=>'CA.ACCESS.ROLES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104818638956309102)
,p_name=>'CA.ACCOUNT.LOCKED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AB\30A6\30F3\30C8\304C\30ED\30C3\30AF\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103676247635308147)
,p_name=>'CA.ACKNOWLEDGED'
,p_message_language=>'ja'
,p_message_text=>unistr('\78BA\8A8D\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104829953880309110)
,p_name=>'CA.ACL.INFORMATION'
,p_message_language=>'ja'
,p_message_text=>unistr('ACL\60C5\5831')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104830631689309111)
,p_name=>'CA.ACL.NOT.ADMIN'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A29\9650\304C\4E0D\5341\5206\3067\3059\3002\30E6\30FC\30B6\30FC\306F\7BA1\7406\8005\3067\306F\3042\308A\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104830748324309111)
,p_name=>'CA.ACL.NOT.AUTHORIZED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30BB\30B9\6A29\3092\4ED8\4E0E\3055\308C\3066\3044\306A\3044\304B\3001\30A2\30AB\30A6\30F3\30C8\304C\30ED\30C3\30AF\3055\308C\3066\3044\308B\305F\3081\3001\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\8868\793A\306F\8A31\53EF\3055\308C\307E\305B\3093\3002\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\7BA1\7406\8005\306B\9023\7D61\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104830883663309111)
,p_name=>'CA.ACL.NOT.CONTRIBUTOR'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A29\9650\304C\4E0D\5341\5206\3067\3059\3002\30E6\30FC\30B6\30FC\306F\30B3\30F3\30C8\30EA\30D3\30E5\30FC\30BF\3067\306F\3042\308A\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104820312510309103)
,p_name=>'CA.ACL.SAVED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30BB\30B9\5236\5FA1\306E\8A2D\5B9A\304C\4FDD\5B58\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104825087787309107)
,p_name=>'CA.ACTION.BUTTON.HTML'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3\30FB\30DC\30BF\30F3HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104823957503309106)
,p_name=>'CA.ACTION.LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3\30FB\30E9\30D9\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104824036143309106)
,p_name=>'CA.ACTION.LINK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3\30FB\30EA\30F3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104826638593309108)
,p_name=>'CA.ACTION.LINK.HTML'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3\30FB\30EA\30F3\30AFHTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104812185097309097)
,p_name=>'CA.ACTION.PROCESSED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3\304C\51E6\7406\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104817685111309101)
,p_name=>'CA.ACTIVITY.BY.HOUR'
,p_message_language=>'ja'
,p_message_text=>unistr('\6642\9593\3054\3068\306E\30A2\30AF\30C6\30A3\30D3\30C6\30A3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104850841388309126)
,p_name=>'CA.ACTIVITY.DASHBOARD'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30C6\30A3\30D3\30C6\30A3\30FB\30C0\30C3\30B7\30E5\30DC\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104794442564309084)
,p_name=>'CA.ACTIVITY.REPORTING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30C6\30A3\30D3\30C6\30A3\30FB\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104793672269309083)
,p_name=>'CA.ACTIVITY.REPORTING.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\30FB\30A2\30AF\30C6\30A3\30D3\30C6\30A3\304A\3088\3073\30A8\30E9\30FC\30FB\30EC\30DD\30FC\30C8\3092\542B\3081\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104794535648309084)
,p_name=>'CA.ACTIVITY.REPORTING.DETAIL'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\30FB\30A2\30AF\30C6\30A3\30D3\30C6\30A3\306B\95A2\3059\308B\591A\6570\306E\30EC\30DD\30FC\30C8\3092\542B\3081\307E\3059\3002\6700\3082\30A2\30AF\30C6\30A3\30D6\306A\30E6\30FC\30B6\30FC\3001\6700\3082\4F7F\7528\3055\308C\3066\3044\308B\30DA\30FC\30B8\3001\5404\30DA\30FC\30B8\306E\30D1\30D5\30A9\30FC\30DE\30F3\30B9\3001\304A\3088\3073\767A\751F\3057\305F\30A8\30E9\30FC\304C\7279\5B9A\3055\308C\308B\305F\3081\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\5229\7528\72B6\6CC1\3068\6539\5584\3059\308B\9818\57DF\306E\628A\63E1\306B\5F79\7ACB\3061\307E\3059\3002</p>'),
unistr('<p>\6B21\306E\3082\306E\304C\542B\307E\308C\307E\3059\3002'),
'<ul>',
unistr('<li>\4E0A\4F4D\30E6\30FC\30B6\30FC\30FB\30EC\30DD\30FC\30C8</li>'),
unistr('<li>\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A8\30E9\30FC\30FB\30ED\30B0\30FB\30EC\30DD\30FC\30C8</li>'),
unistr('<li>\30DA\30FC\30B8\30FB\30D1\30D5\30A9\30FC\30DE\30F3\30B9\3001\30DA\30FC\30B8\5225\306E\30A2\30AF\30C6\30A3\30D3\30C6\30A3\3068\30D1\30D5\30A9\30FC\30DE\30F3\30B9</li>'),
unistr('<li>\30DA\30FC\30B8\5225\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30AF\30C6\30A3\30D3\30C6\30A3\30FB\30EC\30DD\30FC\30C8</li>'),
unistr('<li>\30DA\30FC\30B8\30FB\30D3\30E5\30FC\306E\8A73\7D30\30EC\30DD\30FC\30C8</li>'),
'',
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104040677787308467)
,p_name=>'CA.ACTUAL.START.DATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9F\969B\306E\958B\59CB\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104829837908309110)
,p_name=>'CA.ADD'
,p_message_language=>'ja'
,p_message_text=>unistr('\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104825279664309107)
,p_name=>'CA.ADD.EMAIL.TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104841716513309119)
,p_name=>'CA.ADD.MULTI.USERS.STEP.2'
,p_message_language=>'ja'
,p_message_text=>unistr('\8907\6570\30E6\30FC\30B6\30FC\306E\8FFD\52A0 - \30B9\30C6\30C3\30D72')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104828137439309109)
,p_name=>'CA.ADD.NEW.WIDGET'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F%0\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104811176925309096)
,p_name=>'CA.ADD.NOTIFICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\901A\77E5\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104716731440309014)
,p_name=>'CA.ADD.PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104819327729309102)
,p_name=>'CA.ADD.USER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104842193099309119)
,p_name=>'CA.ADD.USERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104796062469309085)
,p_name=>'CA.ADDING.PAGES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104796567209309085)
,p_name=>'CA.ADDING.PAGES.DETAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('<p><strong>\300C\30DA\30FC\30B8\306E\8FFD\52A0\300D</strong>\3092\30AF\30EA\30C3\30AF\3057\3066\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\30DA\30FC\30B8\3092\8FFD\52A0\3057\307E\3059\3002\6B21\306B\3001\30DA\30FC\30B8\30FB\30BF\30A4\30D7(\7A7A\767D\3001\30C1\30E3\30FC\30C8\3001\30D5\30A9\30FC\30E0\3001\30EC\30DD\30FC\30C8\306A\3069)\3092\9078\629E\3057\3066\305D\306E\5C5E\6027\3092\5B9A\7FA9\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\5834\5408\306B\3088\3063\3066\306F\3001\6709\52B9\306A\8868\307E\305F\306F\30D3\30E5\30FC\3092\6307\5B9A\3057\305F\308A\3001SQL\30EF\30FC\30AF\30B7\30E7\30C3\30D7\3092\4F7F\7528\3057\3066\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306B\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30AA\30D6\30B8\30A7\30AF\30C8\3092\6E96\5099\3057\305F\308A\3059\308B\5FC5\8981\3082\3042\308A\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104826012993309107)
,p_name=>'CA.ADDITIONAL.HTML.TEMPLATES'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A73\7D30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104039958744308467)
,p_name=>'CA.ADDITIONAL.INFO'
,p_message_language=>'ja'
,p_message_text=>unistr('\8FFD\52A0\60C5\5831')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104819082091309102)
,p_name=>'CA.ADDRESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F4F\6240')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104799252878309088)
,p_name=>'CA.ADMIN.ACCESS.CONTROL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30BB\30B9\5236\5FA1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104799846950309088)
,p_name=>'CA.ADMIN.ACCESS.CONTROL.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\8A8D\8A3C\3055\308C\305F\30E6\30FC\30B6\30FC\306E\30A2\30AF\30BB\30B9\30FB\30EC\30D9\30EB\306E\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104798350874309087)
,p_name=>'CA.ADMIN.ACTIVITY.REPORTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30C6\30A3\30D3\30C6\30A3\30FB\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104799372795309088)
,p_name=>'CA.ADMIN.ADD'
,p_message_language=>'ja'
,p_message_text=>unistr('\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104801022431309089)
,p_name=>'CA.ADMIN.ADMINISTRATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104799744054309088)
,p_name=>'CA.ADMIN.ADMINISTRATORS'
,p_message_language=>'ja'
,p_message_text=>unistr('\7BA1\7406\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104073175634308494)
,p_name=>'CA.ADMIN.APP.CONFIGURATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\69CB\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104172791699308586)
,p_name=>'CA.ADMIN.APP.USER_INTERFACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104834631639309114)
,p_name=>'CA.ADMIN.APPLICATION.ADMINISTRATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104834789247309114)
,p_name=>'CA.ADMIN.APPLICATION.ADMINISTRATION.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306E\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104797949683309087)
,p_name=>'CA.ADMIN.APPLICATION.APPEARANCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB\306E\9078\629E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104798072518309087)
,p_name=>'CA.ADMIN.APPLICATION.APPEARANCE.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30EB\30C3\30AF\30FB\30A2\30F3\30C9\30FB\30D5\30A3\30FC\30EB\306E\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104797604753309086)
,p_name=>'CA.ADMIN.APPLICATION.CONFIGURATION.OPTIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\69CB\6210\30AA\30D7\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104797579845309086)
,p_name=>'CA.ADMIN.APPLICATION.CONFIGURATION.OPTIONS.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\6A5F\80FD\306E\6709\52B9\5316\307E\305F\306F\7121\52B9\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104798617551309087)
,p_name=>'CA.ADMIN.APPLICATION.ERROR.LOG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A8\30E9\30FC\30FB\30ED\30B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104798727117309087)
,p_name=>'CA.ADMIN.APPLICATION.ERROR.LOG.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\3088\3063\3066\30ED\30B0\306B\8A18\9332\3055\308C\308B\30A8\30E9\30FC\306E\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104798119305309087)
,p_name=>'CA.ADMIN.APPLICATION.SETTINGS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104798276968309087)
,p_name=>'CA.ADMIN.APPLICATION.SETTINGS.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\540D\3068\77ED\3044\8AAC\660E\306E\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104797731100309086)
,p_name=>'CA.ADMIN.APPLICATION.UPDATES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\66F4\65B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104797820965309087)
,p_name=>'CA.ADMIN.APPLICATION.UPDATES.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\66F4\65B0\306E\30EA\30B9\30C8\306E\4FDD\6301')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104797221286309086)
,p_name=>'CA.ADMIN.CONFIGURATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\69CB\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104799681929309088)
,p_name=>'CA.ADMIN.CONTRIBUTORS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30C8\30EA\30D3\30E5\30FC\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104849628541309125)
,p_name=>'CA.ADMIN.DASHBOARD'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C0\30C3\30B7\30E5\30DC\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104849548815309125)
,p_name=>'CA.ADMIN.DASHBOARD.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30AF\30C6\30A3\30D3\30C6\30A3\30FB\30E1\30C8\30EA\30C3\30AF\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104802725450309090)
,p_name=>'CA.ADMIN.DEFAULT.TZ'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\306E\30BF\30A4\30E0\30BE\30FC\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104802868272309090)
,p_name=>'CA.ADMIN.DEFAULT.TZ.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30C7\30D5\30A9\30EB\30C8\30FB\30BF\30A4\30E0\30BE\30FC\30F3\306E\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104800508974309089)
,p_name=>'CA.ADMIN.EMAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104802932889309090)
,p_name=>'CA.ADMIN.EMAIL.SETTINGS'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104803024097309090)
,p_name=>'CA.ADMIN.EMAIL.SETTINGS.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\3092\9001\4FE1\3059\308B\304B\3069\3046\304B\3068\3001\9001\4FE1\3059\308B\5834\5408\306F\305D\306E\8FD4\4FE1\5148\306E\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104800048098309088)
,p_name=>'CA.ADMIN.FEEDBACK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30FC\30C9\30D0\30C3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104800370813309088)
,p_name=>'CA.ADMIN.FEEDBACK.SETTINGS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30FC\30C9\30D0\30C3\30AF\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104800405404309088)
,p_name=>'CA.ADMIN.FEEDBACK.SETTINGS.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\6DFB\4ED8\3092\8A31\53EF\3059\308B\304B\3069\3046\304B\3092\7BA1\7406\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104800130711309088)
,p_name=>'CA.ADMIN.MANAGE.FEEDBACK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\30FB\30D5\30A3\30FC\30C9\30D0\30C3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104800201030309088)
,p_name=>'CA.ADMIN.MANAGE.FEEDBACK.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30E6\30FC\30B6\30FC\306B\3088\3063\3066\9001\4FE1\3055\308C\305F\3059\3079\3066\306E\30D5\30A3\30FC\30C9\30D0\30C3\30AF\306E\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104800600550309089)
,p_name=>'CA.ADMIN.MANAGE.TEMPLATES'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104800786300309089)
,p_name=>'CA.ADMIN.MANAGE.TEMPLATES.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\3088\3063\3066\4F7F\7528\3055\308C\308B\96FB\5B50\30E1\30FC\30EB\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306EHTML\3068CSS\306E\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104797302659309086)
,p_name=>'CA.ADMIN.NOTIFICATIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\901A\77E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104797418825309086)
,p_name=>'CA.ADMIN.NOTIFICATIONS.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DB\30FC\30E0\30DA\30FC\30B8\306B\901A\77E5\3092\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104835326078309114)
,p_name=>'CA.ADMIN.PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\7BA1\7406\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104717429128309014)
,p_name=>'CA.ADMIN.PAGE.AUTOMATIONS.LOG'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\52D5\5316\30ED\30B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104717557301309015)
,p_name=>'CA.ADMIN.PAGE.AUTOMATIONS.LOG.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\3088\3063\3066\30ED\30B0\306B\8A18\9332\3055\308C\308B\81EA\52D5\5316\5B9F\884C\304A\3088\3073\30E1\30C3\30BB\30FC\30B8\306E\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104798891761309087)
,p_name=>'CA.ADMIN.PAGE.PERFORMANCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30D1\30D5\30A9\30FC\30DE\30F3\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104798974305309087)
,p_name=>'CA.ADMIN.PAGE.PERFORMANCE.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30DA\30FC\30B8\5225\306E\30A2\30AF\30C6\30A3\30D3\30C6\30A3\3068\30D1\30D5\30A9\30FC\30DE\30F3\30B9\306E\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104799047828309087)
,p_name=>'CA.ADMIN.PAGE.VIEWS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30D3\30E5\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104799146534309087)
,p_name=>'CA.ADMIN.PAGE.VIEWS.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30BB\30B9\65E5\3068\7D4C\904E\6642\9593\3092\542B\3080\30E6\30FC\30B6\30FC\5225\306E\5404\30DA\30FC\30B8\30FB\30D3\30E5\30FC\306E\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104799549437309088)
,p_name=>'CA.ADMIN.READERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30C0\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104842870692309120)
,p_name=>'CA.ADMIN.SEND.EMAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\306E\9001\4FE1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104842969887309120)
,p_name=>'CA.ADMIN.SEND.EMAIL.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304B\3089\30C6\30F3\30D7\30EC\30FC\30C8\30FB\30D9\30FC\30B9\306E\96FB\5B50\30E1\30FC\30EB\3092\9001\4FE1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104798445226309087)
,p_name=>'CA.ADMIN.TOP.USERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C8\30C3\30D7\30FB\30E6\30FC\30B6\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104798549452309087)
,p_name=>'CA.ADMIN.TOP.USERS.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\3054\3068\306B\96C6\8A08\3055\308C\305F\30DA\30FC\30B8\30FB\30D3\30E5\30FC\306E\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104799450146309088)
,p_name=>'CA.ADMIN.USERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104799963534309088)
,p_name=>'CA.ADMIN.USERS.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30BB\30B9\5236\5FA1\8A2D\5B9A\306E\5909\66F4\3068\30A2\30AF\30BB\30B9\5236\5FA1\306E\7121\52B9\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104800876398309089)
,p_name=>'CA.ADMIN.VIEW.LOG'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\30FB\30ED\30B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104800959066309089)
,p_name=>'CA.ADMIN.VIEW.LOG.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\3088\3063\3066\9001\4FE1\3055\308C\305F\96FB\5B50\30E1\30FC\30EB\306E\30ED\30B0\3092\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103808490857308254)
,p_name=>'CA.ADVANCED'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'&nbsp;<br>',
'<ul>',
unistr(' <li><strong>\8A73\7D30</strong> - \5C55\958B\3057\3066\8A73\7D30\30AA\30D7\30B7\30E7\30F3\3092\8868\793A\3057\307E\3059\3002'),
'    <ul>',
unistr('      <li><strong>\30DB\30FC\30E0\30DA\30FC\30B8\3068\3057\3066\8A2D\5B9A</strong> - \3053\306E\30DA\30FC\30B8\3092\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30DB\30FC\30E0\30DA\30FC\30B8\306B\3057\307E\3059\3002<br>'),
unistr('      &nbsp;&nbsp;&nbsp;\4EE5\524D\306B\30DB\30FC\30E0\30DA\30FC\30B8\3068\3057\3066\5B9A\7FA9\3055\308C\305F\30DA\30FC\30B8\306F\3001\3059\3079\3066\66F4\65B0\3055\308C\307E\3059\3002</li>'),
unistr('      <li><strong>\7BA1\7406\30DA\30FC\30B8\3068\3057\3066\8A2D\5B9A</strong> - \30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\901A\5E38\306E\30DA\30FC\30B8\3067\306F\306A\304F\300C\7BA1\7406\300D\306E\4E0B\306B\3053\306E\30DA\30FC\30B8\3092\8FFD\52A0\3057\307E\3059\3002\30E1\30A4\30F3\30FB\30E1\30CB\30E5\30FC\3067\300C\7BA1\7406\300D\3092\30AF\30EA\30C3\30AF\3057\3001\300C\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\7BA1\7406\300D\30EA\30B9\30C8\3067\9078\629E\3059\308B\3053\3068\3067\30A2\30AF\30BB\30B9\3057\307E\3059\3002<br>'),
unistr('        <em><strong>\30CE\30FC\30C8:</strong> \30DA\30FC\30B8\3092\30DB\30FC\30E0\30DA\30FC\30B8\3068\300C\7BA1\7406\300D\306E\4E0B\306E\30DA\30FC\30B8\306E\4E21\65B9\306B\3059\308B\3053\3068\306F\3067\304D\307E\305B\3093\3002</em></li>'),
'      &nbsp;<br>',
unistr('      <li><strong>\30DA\30FC\30B8\306E\30D8\30EB\30D7</strong> - \30DA\30FC\30B8\306E\30D8\30EB\30D7\30FB\30C6\30AD\30B9\30C8\306B\8FFD\52A0\3059\308B\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002</li>'),
'    </ul>',
'  </li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103695547110308163)
,p_name=>'CA.ADVANCED.PAGE_HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'&nbsp;<br>',
'<ul>',
unistr(' <li><strong>\8A73\7D30</strong> - \5C55\958B\3057\3066\8A73\7D30\30AA\30D7\30B7\30E7\30F3\3092\8868\793A\3057\307E\3059\3002'),
'    <ul>',
unistr('      <li><strong>\30DA\30FC\30B8\306E\30D8\30EB\30D7</strong> - \30DA\30FC\30B8\306E\30D8\30EB\30D7\30FB\30C6\30AD\30B9\30C8\306B\8FFD\52A0\3055\308C\308B\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002</li>'),
'    </ul>',
'  </li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104835785483309114)
,p_name=>'CA.ADVANCED.SETTINGS'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A73\7D30\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104835882103309115)
,p_name=>'CA.ADVANCED.SETTINGS.DETAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\8FFD\52A0\306E\5B9A\7FA9\3001\30BB\30AD\30E5\30EA\30C6\30A3\304A\3088\3073\30B0\30ED\30FC\30D0\30EB\5316\8A2D\5B9A\3092\8A2D\5B9A\3057\307E\3059\3002\3053\308C\3089\306E\8A2D\5B9A\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\4F5C\6210\6642\306B\9069\7528\3067\304D\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\4F5C\6210\5F8C\306B\7DE8\96C6\3059\308B\3053\3068\3082\3067\304D\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104837754749309116)
,p_name=>'CA.ADVANCED.SETTINGS.PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\5404\8A2D\5B9A\306E\8A73\7D30\306F\3001\9805\76EE\30D8\30EB\30D7(<span class="fa fa-question-circle" aria-hidden="true"></span>)\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002</p>')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104843520586309120)
,p_name=>'CA.AFTER.ROWS'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\306E\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104824962262309106)
,p_name=>'CA.AFTER.ROWS.HTML'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\306E\5F8CHTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104828056403309109)
,p_name=>'CA.ALL.COLS'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\306E\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104824108962309106)
,p_name=>'CA.ALLOW.OPT.OUT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30D7\30C8\30FB\30A2\30A6\30C8\3092\8A31\53EF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104033586939308462)
,p_name=>'CA.ALLOW.RUNS.IN.RESTRICTED.MODE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5236\9650\30E2\30FC\30C9\3067\306E\5B9F\884C\3092\8A31\53EF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104817574624309101)
,p_name=>'CA.APP.ERROR.LOG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A8\30E9\30FC\30FB\30ED\30B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104813439583309098)
,p_name=>'CA.APP.NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104083542053308503)
,p_name=>'CA.APP.SETTING.ACL_ENABLED.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30BB\30B9\5236\5FA1\3092\6709\52B9\306B\3059\308B\304B\3069\3046\304B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104083653921308503)
,p_name=>'CA.APP.SETTING.ACL_SCOPE.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30BB\30B9\5236\5FA1\30EA\30B9\30C8\306B\5B58\5728\3057\306A\3044\8A8D\8A3C\3055\308C\305F\30E6\30FC\30B6\30FC\306B\63D0\4F9B\3055\308C\305F\30C7\30D5\30A9\30EB\30C8\306E\30A2\30AF\30BB\30B9\30FB\30EC\30D9\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104813803057309098)
,p_name=>'CA.APP.SETTINGS.UPDATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\8A2D\5B9A\304C\66F4\65B0\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104813621253309098)
,p_name=>'CA.APP.SUBTITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\77ED\3044\8AAC\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104813713134309098)
,p_name=>'CA.APP.SUBTITLE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\3053\3067\5165\529B\3057\305F\30C6\30AD\30B9\30C8\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30DB\30FC\30E0\30DA\30FC\30B8\306B\3042\308B\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\540D\306E\4E0B\306B\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104803118061309090)
,p_name=>'CA.APPEARANCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5916\89B3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104803253378309091)
,p_name=>'CA.APPEARANCE.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\30C7\30D5\30A9\30EB\30C8\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30AB\30E9\30FC\30FB\30B9\30AD\30FC\30E0(\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB)\3001\30CA\30D3\30B2\30FC\30B7\30E7\30F3\306E\914D\7F6E\5834\6240\3001\304A\3088\3073\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\4F7F\7528\3055\308C\308B\30A2\30A4\30B3\30F3\3092\5B9A\7FA9\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104822688396309105)
,p_name=>'CA.APPLICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104809752533309095)
,p_name=>'CA.APPLICATION.APPEARANCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\5916\89B3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104803788005309091)
,p_name=>'CA.APPLICATION.ICON'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30B3\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104803870536309091)
,p_name=>'CA.APPLICATION.ICON.DETAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('<p><strong>\300C\65B0\898F\30A2\30A4\30B3\30F3\306E\9078\629E\300D</strong>\3092\30AF\30EA\30C3\30AF\3057\3066\3001\30A2\30A4\30B3\30F3\306E\8272\3068\4F7F\7528\53EF\80FD\306A\30A2\30A4\30B3\30F3\306E1\3064\3092\9078\629E\3057\307E\3059\3002\9078\629E\5185\5BB9\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30DB\30FC\30E0\30DA\30FC\30B8\306B\8868\793A\3055\308C\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104804182978309091)
,p_name=>'CA.APPLICATION.ID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104804217828309091)
,p_name=>'CA.APPLICATION.ID.DETAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\4E00\610F\306E\6570\5024\8B58\5225\5B50\3092\5165\529B\3057\307E\3059\3002\3053\306E\30D5\30A3\30FC\30EB\30C9\306B\306F\3001\30C7\30D5\30A9\30EB\30C8\3067\81EA\52D5\7684\306B\751F\6210\3055\308C\305F\8B58\5225\5B50\304C\542B\307E\308C\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104823292041309105)
,p_name=>'CA.APPLICATION.PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104815497058309099)
,p_name=>'CA.APPLICATION.SESSIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30BB\30C3\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104794026818309084)
,p_name=>'CA.APPLICATION.SETTINGS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104792940747309083)
,p_name=>'CA.APPLICATION.SETTINGS.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\540D\3068\77ED\3044\8AAC\660E\306E\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104794153401309084)
,p_name=>'CA.APPLICATION.SETTINGS.DETAIL'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\7BA1\7406\8005\304C\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\540D\524D\3084\8AAC\660E\3001\30C7\30D5\30A9\30EB\30C8\30FB\30BF\30A4\30E0\30BE\30FC\30F3\306A\3069\306E\69D8\3005\306A\8A2D\5B9A\3092\66F4\65B0\3067\304D\308B\3088\3046\306B\3057\307E\3059\3002</p>'),
unistr('<p>\6B21\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\304C\542B\307E\308C\307E\3059:'),
'<ul>',
unistr('<li>\7BA1\7406\30DA\30FC\30B8\306E\30EA\30B9\30C8\30FB\30A8\30F3\30C8\30EA\304A\3088\3073\30D5\30A9\30FC\30E0</li>'),
unistr('<li>\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\540D\3092\8A2D\5B9A\3059\308B\6A5F\80FD</li>'),
unistr('<li>\30DB\30FC\30E0\30DA\30FC\30B8\306E\30D2\30FC\30ED\30FC\30FB\30EA\30FC\30B8\30E7\30F3\30FB\30B5\30D6\30BF\30A4\30C8\30EB\3092\8A2D\5B9A\3059\308B\6A5F\80FD</li>'),
unistr('<li>\30D5\30A3\30FC\30C9\30D0\30C3\30AF\3092\4F7F\7528\3059\308B\5834\5408\306B\30D5\30A3\30FC\30C9\30D0\30C3\30AF\306E\53D7\4FE1\8005\3092\8A2D\5B9A\3059\308B\6A5F\80FD</li>'),
unistr('<li>\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30C7\30D5\30A9\30EB\30C8\30FB\30BF\30A4\30E0\30BE\30FC\30F3\3092\8A2D\5B9A\3059\308B\6A5F\80FD</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104848633715309124)
,p_name=>'CA.APPLICATIONITEM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104850403499309126)
,p_name=>'CA.APPLY'
,p_message_language=>'ja'
,p_message_text=>unistr('\9069\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104852272914309127)
,p_name=>'CA.APPLY.APP.DEFAULTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30C7\30D5\30A9\30EB\30C8\306E\9069\7528\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104808927459309095)
,p_name=>'CA.APPLY.CHANGES'
,p_message_language=>'ja'
,p_message_text=>unistr('\5909\66F4\306E\9069\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104850213262309125)
,p_name=>'CA.APPLY.FILTERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30EB\30BF\306E\9069\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104170899149308584)
,p_name=>'CA.APP_BANNER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\4F5C\6210\30A6\30A3\30B6\30FC\30C9%0\304B\3089\4F5C\6210\3055\308C\305F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104172117021308585)
,p_name=>'CA.APP_SETTING.SAVE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A2D\5B9A\306E\4FDD\5B58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104854442734309129)
,p_name=>'CA.ATTACHMENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6DFB\4ED8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103910359751308335)
,p_name=>'CA.ATTACHMENT.COUNT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6DFB\4ED8\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104854565925309129)
,p_name=>'CA.ATTACHMENT.NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\6DFB\4ED8\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103910286707308335)
,p_name=>'CA.ATTACHMENT.SIZE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6DFB\4ED8\30B5\30A4\30BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104850540076309126)
,p_name=>'CA.ATTR.DEFAULT.DUPLICATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E%0\306B\306F\5C5E\6027\30C7\30D5\30A9\30EB\30C8\304C\3059\3067\306B\5B9A\7FA9\3055\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104819704432309103)
,p_name=>'CA.AUTH.USER.MAY.ACCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\3055\308C\305F\30E6\30FC\30B6\30FC\306F\3001\8AB0\3067\3082\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\30A2\30AF\30BB\30B9\3067\304D\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104804928092309092)
,p_name=>'CA.AUTHENTICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104805002510309092)
,p_name=>'CA.AUTHENTICATION.DETAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\5BFE\3059\308B\30E6\30FC\30B6\30FC\306E\8A8D\8A3C\65B9\6CD5\3092\9078\629E\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104036230312308464)
,p_name=>'CA.AUTO.DROP'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\52D5\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104718158905309015)
,p_name=>'CA.AUTOMATION_EXECUTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\52D5\5316\5B9F\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104816190591309100)
,p_name=>'CA.AVG.ELAPSED'
,p_message_language=>'ja'
,p_message_text=>unistr('\5E73\5747\7D4C\904E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104080841759308500)
,p_name=>'CA.BACK.TO.JOBS.REPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B8\30E7\30D6\30FB\30EC\30DD\30FC\30C8\306B\623B\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103911094382308336)
,p_name=>'CA.BCC'
,p_message_language=>'ja'
,p_message_text=>'BCC'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104843492019309120)
,p_name=>'CA.BEFORE.ROWS'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\306E\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104824829389309106)
,p_name=>'CA.BEFORE.ROWS.HTML'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\306E\524DHTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104826316033309107)
,p_name=>'CA.BEGIN.ROW.TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\306E\524D\30B3\30F3\30C6\30F3\30C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104801613863309089)
,p_name=>'CA.BLANK'
,p_message_language=>'ja'
,p_message_text=>unistr('\7A7A\767D\30DA\30FC\30B8\306E\8FFD\52A0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104801759891309089)
,p_name=>'CA.BLANK.DETAILS'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30D7\30EC\30FC\30B9\30DB\30EB\30C0\3068\3057\3066\7A7A\767D\30DA\30FC\30B8\3092\4F5C\6210\3057\307E\3059\3002\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\4F5C\6210\3057\305F\5F8C\3001\30DA\30FC\30B8\30FB\30C7\30B6\30A4\30CA\304B\3089\30DA\30FC\30B8\306B\30EA\30FC\30B8\30E7\30F3\3092\7C21\5358\306B\4F5C\6210\3067\304D\307E\3059\3002</p>'),
unistr('<p>\6B21\306E\5C5E\6027\3092\5165\529B\3057\307E\3059\3002</p>'),
'<ul>',
unistr('  <li><strong>\30DA\30FC\30B8\540D</strong>(\5FC5\9808) - \3053\306E\30DA\30FC\30B8\306E\540D\524D\3092\5165\529B\3057\307E\3059\3002</li>'),
unistr('  <li><strong>\30A2\30A4\30B3\30F3\306E\8A2D\5B9A</strong> - \3053\306E\30DA\30FC\30B8\306E\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC\306B\8868\793A\3059\308B\30A2\30A4\30B3\30F3\3092\9078\629E\3057\307E\3059\3002</li>'),
unistr('<!--  <li><strong>\30DA\30FC\30B8\30FB\30CA\30D3\30B2\30FC\30B7\30E7\30F3\3092\542B\3081\308B</strong> - \30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\5B9A\7FA9\3055\308C\3066\3044\308B\4ED6\306E\3059\3079\3066\306E\30DA\30FC\30B8\306E\30AB\30FC\30C9\30FB\30EA\30B9\30C8\3092\8868\793A\3059\308B\5834\5408\3001\3053\306E\30AA\30D7\30B7\30E7\30F3\3092\9078\629E\3057\307E\3059\3002<br>'),
unistr('      &nbsp;&nbsp;&nbsp;\3053\306E\30AA\30D7\30B7\30E7\30F3\306F\3001\901A\5E38\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30DB\30FC\30E0\30DA\30FC\30B8\3067\4F7F\7528\3055\308C\307E\3059\3002</li>'),
'-->',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104835022095309114)
,p_name=>'CA.BLUEPRINT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30D6\30EB\30FC\30D7\30EA\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104835136865309114)
,p_name=>'CA.BLUEPRINT.DETAIL'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30D6\30EB\30FC\30D7\30EA\30F3\30C8\306B\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5B9A\7FA9\304CJSON\5F62\5F0F\3067\30EA\30B9\30C8\3055\308C\307E\3059\3002</p>'),
unistr('<p>\3053\306E\753B\9762\306B\6700\521D\306B\5165\529B\3059\308B\3068\304D\306B\3001\73FE\5728\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5B9A\7FA9\304CJSON\30C9\30AD\30E5\30E1\30F3\30C8\306B\5909\63DB\3055\308C\3066\8868\793A\3055\308C\307E\3059\3002\30C9\30AD\30E5\30E1\30F3\30C8\3092\7DE8\96C6\3057\3066\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30D7\30ED\30D1\30C6\30A3\3092\66F4\65B0\3057\3001<strong>\300C\30D6\30EB\30FC\30D7\30EA\30F3\30C8\306E\9069\7528\300D</strong>\3092\30AF\30EA\30C3\30AF\3057\3066\73FE\5728\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\8A73\7D30\3092\5909\66F4\3067\304D\307E\3059\3002</p>'),
'<p>&nbsp;</p>',
unistr('<p>\985E\4F3C\30DA\30FC\30B8\3092\5927\91CF\306B\4F5C\6210\3059\308B\5FC5\8981\304C\3042\308B\5834\5408\306F\3001\3042\308B\30DA\30FC\30B8\306B\95A2\9023\3059\308BJSON\30B3\30FC\30C9\3092\30B3\30D4\30FC\3057\3001\8907\6570\56DE\8CBC\308A\4ED8\3051\3001JSON\3092\5C11\3057\8ABF\6574\3059\308B\65B9\304C\3001\30DA\30FC\30B8\3054\3068\306B<strong>\300C\30DA\30FC\30B8\306E\8FFD\52A0\300D</strong>\3092\624B\52D5\3067\4F7F\7528\3059\308B\3088\308A\3082\306F\308B\304B\306B\8FC5\901F\3067\3059\3002</p>'),
unistr('<p><strong>\300C\524D\306E\30D6\30EB\30FC\30D7\30EA\30F3\30C8\306E\30ED\30FC\30C9\300D</strong>\3092\30AF\30EA\30C3\30AF\3057\3066\3001\524D\306B\751F\6210\3057\305F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\5B9A\7FA9\3067\30D6\30EB\30FC\30D7\30EA\30F3\30C8\3092\7F6E\63DB\3057\307E\3059\3002\3053\3046\3059\308B\3068\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\518D\5EA6\751F\6210\3059\308B\524D\306B\3001\30DA\30FC\30B8\306E\8FFD\52A0\3001\6A5F\80FD\306E\5909\66F4\307E\305F\306F\8A2D\5B9A\306E\5FAE\8ABF\6574\306B\3088\3063\3066\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\8A2D\8A08\3092\975E\5E38\306B\7C21\5358\306B\53CD\5FA9\3067\304D\307E\3059\3002</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104823762719309106)
,p_name=>'CA.BODY1.TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\672C\65871\306E\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104823884390309106)
,p_name=>'CA.BODY2.TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\672C\65872\306E\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104843818235309120)
,p_name=>'CA.BOTH'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E21\65B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104810164610309096)
,p_name=>'CA.BRANCH.TO.ADMIN'
,p_message_language=>'ja'
,p_message_text=>unistr('\7BA1\7406\30DA\30FC\30B8\306B\30D6\30E9\30F3\30C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103807089606308252)
,p_name=>'CA.BUTTON.BAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3\30FB\30D0\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104809873948309095)
,p_name=>'CA.BUTTONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104802389506309090)
,p_name=>'CA.CALENDAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30EC\30F3\30C0\30FB\30DA\30FC\30B8\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104802435107309090)
,p_name=>'CA.CALENDAR.DETAILS'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30AB\30EC\30F3\30C0\3092\8868\793A\3059\308B\30DA\30FC\30B8\3092\4F5C\6210\3057\307E\3059\3002</p>'),
unistr('<p>\6B21\306E\5C5E\6027\3092\5165\529B\3057\307E\3059\3002</p>'),
'<ul>',
unistr('  <li><strong>\30DA\30FC\30B8\540D</strong>(\5FC5\9808) - \3053\306E\30DA\30FC\30B8\306E\540D\524D\3092\5165\529B\3057\307E\3059\3002</li>'),
unistr('  <li><strong>\30A2\30A4\30B3\30F3\306E\8A2D\5B9A</strong> - \3053\306E\30DA\30FC\30B8\306E\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC\306B\8868\793A\3059\308B\30A2\30A4\30B3\30F3\3092\9078\629E\3057\307E\3059\3002</li>'),
unistr('  <li><strong>\8868\307E\305F\306F\30D3\30E5\30FC</strong>(\5FC5\9808) - \30AB\30EC\30F3\30C0\306E\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30AA\30D6\30B8\30A7\30AF\30C8\3092\9078\629E\3057\307E\3059\3002</li>'),
unistr('  <li><strong>\8868\793A\5217</strong>(\5FC5\9808) - \30AB\30EC\30F3\30C0\30FB\30A4\30D9\30F3\30C8\306B\8868\793A\3059\308B\5217\3092\8868\307E\305F\306F\30D3\30E5\30FC\304B\3089\9078\629E\3057\307E\3059\3002</li>'),
unistr('  <li><strong>\958B\59CB\65E5\5217</strong>(\5FC5\9808) - \30AB\30EC\30F3\30C0\30FB\30A4\30D9\30F3\30C8\306E\958B\59CB\65E5\3068\3057\3066\4F7F\7528\3059\308B\65E5\4ED8\5217\3092\8868\307E\305F\306F\30D3\30E5\30FC\304B\3089\9078\629E\3057\307E\3059\3002</li>'),
unistr('  <li><strong>\7D42\4E86\65E5\5217</strong> - \30AB\30EC\30F3\30C0\30FB\30A4\30D9\30F3\30C8\306E\7D42\4E86\65E5\3068\3057\3066\4F7F\7528\3059\308B\65E5\4ED8\5217\3092\8868\307E\305F\306F\30D3\30E5\30FC\304B\3089\9078\629E\3057\307E\3059\3002<br>'),
unistr('      &nbsp;&nbsp;&nbsp;\7D42\4E86\65E5\3092\6307\5B9A\3059\308B\3068\3001\671F\9593\30D9\30FC\30B9\306E\30A4\30D9\30F3\30C8\304C\8868\793A\3055\308C\307E\3059\3002 </li>'),
unistr('  <li><strong>\6642\9593\306E\8868\793A</strong> - <strong>\300C\306F\3044\300D</strong>\3092\9078\629E\3059\308B\3068\3001\30A4\30D9\30F3\30C8\306E\6642\9593\90E8\5206\304C\8868\793A\3055\308C\3001\300C\9031\300D\304A\3088\3073\300C\65E5\300D\306E\30AB\30EC\30F3\30C0\30FB\30D3\30E5\30FC\304C\6709\52B9\5316\3055\308C\307E\3059\3002<strong>\300C\3044\3044\3048\300D</strong>\3092\9078\629E\3059\308B\3068\3001\30A4\30D9\30F3\30C8\306E\65E5\4ED8\306E\307F\304C\8868\793A\3055\308C\307E\3059\3002</li>'),
'  </ul>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104808892706309095)
,p_name=>'CA.CANCEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\53D6\6D88')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104810769401309096)
,p_name=>'CA.CANCEL.DIALOG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C0\30A4\30A2\30ED\30B0\3092\53D6\308A\6D88\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103788058134308238)
,p_name=>'CA.CANCEL.MODAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E2\30FC\30C0\30EB\306E\53D6\6D88')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104820676594309103)
,p_name=>'CA.CANNOT.REMOVE.ADMIN.RIGHTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\72EC\81EA\306E\30EC\30B3\30FC\30C9\304B\3089\7BA1\7406\6A29\9650\3092\524A\9664\3059\308B\3053\3068\306F\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104851464992309126)
,p_name=>'CA.CARD'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30FC\30C9\30FB\30DA\30FC\30B8\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104851399444309126)
,p_name=>'CA.CARD.DETAILS'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30AB\30FC\30C9\3092\8868\793A\3059\308B\30DA\30FC\30B8\3092\4F5C\6210\3057\307E\3059\3002</p>'),
unistr('<p>\6B21\306E\5C5E\6027\3092\5165\529B\3057\307E\3059\3002</p>'),
'<ul>',
unistr('  <li><strong>\30DA\30FC\30B8\540D</strong>(\5FC5\9808) - \3053\306E\30DA\30FC\30B8\306E\540D\524D\3092\5165\529B\3057\307E\3059\3002</li>'),
unistr('  <li><strong>\30A2\30A4\30B3\30F3\306E\8A2D\5B9A</strong> - \3053\306E\30DA\30FC\30B8\306E\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC\306B\8868\793A\3059\308B\30A2\30A4\30B3\30F3\3092\9078\629E\3057\307E\3059\3002</li>'),
unistr('  <li><strong>\8868\307E\305F\306F\30D3\30E5\30FC</strong>(\5FC5\9808) - \30AB\30FC\30C9\306E\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30AA\30D6\30B8\30A7\30AF\30C8\3092\9078\629E\3057\307E\3059\3002</li>'),
unistr('  <li><strong>\30AB\30FC\30C9\30FB\30BF\30A4\30C8\30EB</strong>(\5FC5\9808) - \30AB\30FC\30C9\306E\30BF\30A4\30C8\30EB\3068\3057\3066\4F7F\7528\3059\308B\5217\3092\8868\307E\305F\306F\30D3\30E5\30FC\304B\3089\9078\629E\3057\307E\3059\3002</li>'),
unistr('  <li><strong>\8AAC\660E\5217</strong>(\5FC5\9808) - \30AB\30FC\30C9\306E\8AAC\660E\3068\3057\3066\4F7F\7528\3059\308B\5217\3092\8868\307E\305F\306F\30D3\30E5\30FC\304B\3089\9078\629E\3057\307E\3059\3002</li>'),
unistr('  <li><strong>\8FFD\52A0\306E\30C6\30AD\30B9\30C8\5217</strong> - \30AB\30FC\30C9\306E\30BB\30AB\30F3\30C0\30EA\8AAC\660E\3068\3057\3066\4F7F\7528\3059\308B\5217\3092\8868\307E\305F\306F\30D3\30E5\30FC\304B\3089\9078\629E\3057\307E\3059\3002</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104849994152309125)
,p_name=>'CA.CARDS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104850047424309125)
,p_name=>'CA.CARDS.VIEW'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30FC\30C9\30FB\30D3\30E5\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103911171774308336)
,p_name=>'CA.CC'
,p_message_language=>'ja'
,p_message_text=>'CC'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104171586465308585)
,p_name=>'CA.CHANGE_FILTERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30EB\30BF\306E\5909\66F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104801472960309089)
,p_name=>'CA.CHART'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\30FB\30DA\30FC\30B8\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104801572733309089)
,p_name=>'CA.CHART.DETAILS'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9762\3001\68D2\3001\6298\308C\7DDA\307E\305F\306F\5186\30B0\30E9\30D5\3092\8868\793A\3059\308B\30DA\30FC\30B8\3092\4F5C\6210\3057\307E\3059\3002</p>'),
unistr('<p>\6B21\306E\5C5E\6027\3092\5165\529B\3057\307E\3059\3002</p>'),
'<ul>',
unistr('  <li><strong>\30DA\30FC\30B8\540D</strong>(\5FC5\9808) - \3053\306E\30DA\30FC\30B8\306E\540D\524D\3092\5165\529B\3057\307E\3059\3002</li>'),
unistr('  <li><strong>\30A2\30A4\30B3\30F3\306E\8A2D\5B9A</strong> - \3053\306E\30DA\30FC\30B8\306E\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC\306B\8868\793A\3059\308B\30A2\30A4\30B3\30F3\3092\9078\629E\3057\307E\3059\3002</li>'),
unistr('  <li><strong>\30C1\30E3\30FC\30C8\30FB\30BF\30A4\30D7</strong> - \8868\793A\3059\308B\30C1\30E3\30FC\30C8\306E\30BF\30A4\30D7[<strong>\9762</strong>\3001<strong>\68D2</strong>\3001<strong>\6298\308C\7DDA</strong>\3001<strong>\5186</strong>]\3092\9078\629E\3057\307E\3059\3002</li>'),
unistr('  <li><strong>\8868\307E\305F\306F\30D3\30E5\30FC</strong>(\5FC5\9808) - \30C1\30E3\30FC\30C8\306E\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30AA\30D6\30B8\30A7\30AF\30C8\3092\9078\629E\3057\307E\3059\3002</li>'),
unistr('  <li><strong>\30E9\30D9\30EB\5217</strong>(\5FC5\9808) - \30C1\30E3\30FC\30C8\306E\30E9\30D9\30EB\3068\3057\3066\4F7F\7528\3059\308B\5217\3092\8868\307E\305F\306F\30D3\30E5\30FC\304B\3089\9078\629E\3057\307E\3059\3002</li>'),
unistr('  <li><strong>\5024\96C6\8A08</strong> - \5024\5217\306E\8868\793A\65B9\6CD5\307E\305F\306F\96C6\8A08\65B9\6CD5\3092\9078\629E\3057\307E\3059<br>'),
unistr('      &nbsp;&nbsp;&nbsp;[\5217\5024\3001\5408\8A08\3001\4EF6\6570]\3002</li>'),
unistr('  <li><strong>\5024\5217</strong>(\5FC5\9808) - \8868\793A\3055\308C\308B\30C1\30E3\30FC\30C8\5024\306E\8A08\7B97\306B\4F7F\7528\3059\308B\6570\5024\5217\3092\8868\307E\305F\306F\30D3\30E5\30FC\304B\3089\9078\629E\3057\307E\3059\3002</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104801881079309089)
,p_name=>'CA.CHART.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<h3>\4F8B</h3>'),
unistr('<p><strong>\300C\30B5\30DE\30EA\30FC\300D</strong>\306E\7570\306A\308B\30BF\30A4\30D7\3092\4F7F\7528\3059\308B\65B9\6CD5\306E\4F8B\3092\78BA\8A8D\3057\307E\3059\3002</p>'),
unistr('<p><strong>\4F8B1:</strong> \5F93\696D\54E1\3054\3068\306B\3001\30DE\30CD\30FC\30B8\30E3\306E\5F93\696D\54E1\756A\53F7\3092\542B\3080Employees\306E\30C1\30E3\30FC\30C8\3092\8868\793A\3057\307E\3059\3002'),
'<code><ul>',
unistr('  <li>\8868\307E\305F\306F\30D3\30E5\30FC - EMP\3092\9078\629E\3057\307E\3059\3002</li>'),
unistr('  <li>\30E9\30D9\30EB\5217 - ENAME\3092\9078\629E\3057\307E\3059\3002</li>'),
unistr('  <li>\30B5\30DE\30EA\30FC - <u><strong>\300C\5217\5024\300D</strong></u>\3092\9078\629E\3057\307E\3059\3002</li>'),
unistr('  <li>\5024\5217 - MGR\3092\9078\629E\3057\307E\3059\3002</li>'),
'</ul></code>',
'</p>',
unistr('<p><strong>\4F8B2:</strong> \8077\7A2E\3054\3068\306E\5408\8A08\7D66\4E0E\3092\542B\3080Employees\306E\30C1\30E3\30FC\30C8\3092\8868\793A\3057\307E\3059\3002'),
'<code><ul>',
unistr('  <li>\8868\307E\305F\306F\30D3\30E5\30FC - EMP\3092\9078\629E\3057\307E\3059\3002</li>'),
unistr('  <li>\30E9\30D9\30EB\5217 - JOB\3092\9078\629E\3057\307E\3059\3002</li>'),
unistr('  <li>\30B5\30DE\30EA\30FC - <u><strong>\300C\5408\8A08\300D</strong></u>\3092\9078\629E\3057\307E\3059\3002</li>'),
unistr('  <li>\5024\5217 - SAL\3092\9078\629E\3057\307E\3059\3002</li>'),
'</ul></code>',
'</p>',
unistr('<p><strong>\4F8B3:</strong> \90E8\9580\3054\3068\306E\5F93\696D\54E1\306E\6570\3092\542B\3080Employees\306E\30C1\30E3\30FC\30C8\3092\8868\793A\3057\307E\3059\3002'),
'<code><ul>',
unistr('  <li>\8868\307E\305F\306F\30D3\30E5\30FC - EMP\3092\9078\629E\3057\307E\3059\3002</li>'),
unistr('  <li>\30E9\30D9\30EB\5217 - DEPTNO\3092\9078\629E\3057\307E\3059\3002</li>'),
unistr('  <li>\30B5\30DE\30EA\30FC - <u><strong>\300C\4EF6\6570\300D</strong></u>\3092\9078\629E\3057\307E\3059\3002</li>'),
unistr('  <li>\5024\5217 - EMPNO\3092\9078\629E\3057\307E\3059\3002</li>'),
'</ul></code>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104038235032308465)
,p_name=>'CA.CLIENT.ID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30E9\30A4\30A2\30F3\30C8ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104854684823309129)
,p_name=>'CA.CLOSE'
,p_message_language=>'ja'
,p_message_text=>unistr('\9589\3058\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103676121963308147)
,p_name=>'CA.CLOSED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30ED\30FC\30BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104852669648309127)
,p_name=>'CA.COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104829617814309110)
,p_name=>'CA.COLUMN.1'
,p_message_language=>'ja'
,p_message_text=>unistr('\52171')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104829774992309110)
,p_name=>'CA.COLUMN.2'
,p_message_language=>'ja'
,p_message_text=>unistr('\52172')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104817017234309101)
,p_name=>'CA.COLUMN.ALIAS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\306E\5225\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104848433657309124)
,p_name=>'CA.COMMENTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30E1\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104814747490309099)
,p_name=>'CA.COMPONENT.NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30DD\30FC\30CD\30F3\30C8\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104819539207309103)
,p_name=>'CA.CONFIG.ACCESS.CONTROL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30BB\30B9\5236\5FA1\306E\69CB\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104809969859309095)
,p_name=>'CA.CONFIG.APPEARANCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5916\89B3\306E\69CB\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104810030001309096)
,p_name=>'CA.CONFIG.APPEARANCE.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\5916\89B3\306F\3001\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB\306B\3088\3063\3066\5B9A\7FA9\3055\308C\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104813343390309098)
,p_name=>'CA.CONFIG.OPTION.UPDATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\69CB\6210\30AA\30D7\30B7\30E7\30F3\304C\66F4\65B0\3055\308C\307E\3057\305F\3002 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104795231172309084)
,p_name=>'CA.CONFIGURATION.SETTINGS'
,p_message_language=>'ja'
,p_message_text=>unistr('\69CB\6210\30AA\30D7\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104793561139309083)
,p_name=>'CA.CONFIGURATION.SETTINGS.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\6A5F\80FD\306E\6709\52B9\5316\307E\305F\306F\7121\52B9\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104795361025309084)
,p_name=>'CA.CONFIGURATION.SETTINGS.DETAIL'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\7BA1\7406\8005\304C\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5185\306E\7279\5B9A\306E\6A5F\80FD\3092\6709\52B9\5316\307E\305F\306F\7121\52B9\5316\3067\304D\308B\3088\3046\306B\3057\307E\3059\3002\3053\306E\6A5F\80FD\306F\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\4F7F\7528\3059\308B\524D\306B\8FFD\52A0\306E\958B\767A\4F5C\696D\3092\5FC5\8981\3068\3059\308B\6A5F\80FD\3092\9078\629E\3057\3066\3044\308B\5834\5408\306B\975E\5E38\306B\4FBF\5229\3067\3059\3002<br>'),
unistr('\3053\306E\6A5F\80FD\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\56FA\6709\306E\6A5F\80FD\306B\62E1\5F35\3059\308B\3053\3068\3082\3067\304D\307E\3059\3002\958B\767A\8005\304C\8FFD\52A0\306E\30D3\30EB\30C9\30FB\30AA\30D7\30B7\30E7\30F3\3092\5B9A\7FA9\3057\3066\305D\308C\3089\3092\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5168\4F53\306B\308F\305F\308B\7279\5B9A\306E\6A5F\80FD\306B\95A2\9023\4ED8\3051\308B\5834\5408\3001\305D\308C\3089\306F\7BA1\7406\8005\7528\306E\69CB\6210\8A2D\5B9A\306B\8FFD\52A0\3067\304D\307E\3059\3002\305F\3068\3048\3070\3001\9867\5BA2\30C8\30E9\30C3\30AB\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5185\3067\3001\7BA1\7406\8005\306F\3001\9023\7D61\5148\3001\30C7\30FC\30BF\30FB\30ED\30FC\30C9\3001\5730\7406\306A\3069\306E\6A5F\80FD\306E\6709\52B9\5316\3068\7121\52B9\5316\3092\5207\308A\66FF\3048\308B\3053\3068\304C\3067\304D\307E\3059\3002'),
'</p>',
unistr('<p>\6B21\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\304C\542B\307E\308C\307E\3059\3002'),
'<ul>',
unistr('<li>\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\6A5F\80FD\306E\6709\52B9\5316\3068\7121\52B9\5316\306E\5207\66FF\3048</li>'),
unistr('<li>\30C7\30D7\30ED\30A4\30E1\30F3\30C8\5358\4F4D\3067\306E\6A5F\80FD\9078\629E\3092\53EF\80FD\306B\3059\308B\6A5F\80FD\306E\4F7F\7528</li>'),
unistr('<li>\95A2\9023\3059\308B\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\8A2D\5B9A\306E\30B0\30EB\30FC\30D7\5316\306E\30B5\30DD\30FC\30C8</li>'),
unistr('<li>\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\958B\767A\8005\306B\3088\308B\30D3\30EB\30C9\30FB\30AA\30D7\30B7\30E7\30F3\3092\4F7F\7528\3057\305F\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306E\5236\5FA1\306E\8A31\53EF</li>'),
unistr('<li>\7BA1\7406\30DA\30FC\30B8\304B\3089\306E\4F7F\7528</li>'),
'</ul>',
'</p>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104033199877308461)
,p_name=>'CA.CONNECT.CREDENTIAL.NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\63A5\7D9A\306E\8CC7\683C\8A3C\660E\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104033222261308461)
,p_name=>'CA.CONNECT.CREDENTIAL.OWNER'
,p_message_language=>'ja'
,p_message_text=>unistr('\63A5\7D9A\306E\8CC7\683C\8A3C\660E\6240\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104699605627309000)
,p_name=>'CA.CONTEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104820092659309103)
,p_name=>'CA.CONTRIBUTOR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30C8\30EA\30D3\30E5\30FC\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104040141517308467)
,p_name=>'CA.CPU.USED'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F7F\7528\4E2D\306ECPU')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104828518450309109)
,p_name=>'CA.CREATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104833681244309113)
,p_name=>'CA.CREATE.ADMIN.PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\7BA1\7406\30DA\30FC\30B8\306E\4F5C\6210\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104831240796309111)
,p_name=>'CA.CREATE.APP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\4F5C\6210\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104832353361309112)
,p_name=>'CA.CREATE.APP.COMP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\8A08\7B97\306E\4F5C\6210\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104831618978309111)
,p_name=>'CA.CREATE.APP.ICON'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30B3\30F3\306E\4F5C\6210\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104832231077309112)
,p_name=>'CA.CREATE.APP.ITEM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\306E\4F5C\6210\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104832461374309112)
,p_name=>'CA.CREATE.APP.PROCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30D7\30ED\30BB\30B9\306E\4F5C\6210\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104708744473309007)
,p_name=>'CA.CREATE.APP.SETTING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\8A2D\5B9A\306E\4F5C\6210\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104838502323309117)
,p_name=>'CA.CREATE.APPLICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104082058808308502)
,p_name=>'CA.CREATE.APP_ROLES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30ED\30FC\30EB\306E\4F5C\6210\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104831884573309111)
,p_name=>'CA.CREATE.AUTH.SCHEME'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\53EF\30B9\30AD\30FC\30E0\306E\4F5C\6210\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104832629304309112)
,p_name=>'CA.CREATE.BLANK.PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\7A7A\767D\30DA\30FC\30B8\306E\4F5C\6210\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104831744528309111)
,p_name=>'CA.CREATE.BUILD.OPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D3\30EB\30C9\30FB\30AA\30D7\30B7\30E7\30F3\306E\4F5C\6210\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104833039583309112)
,p_name=>'CA.CREATE.CALENDAR.PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30EC\30F3\30C0\30FB\30DA\30FC\30B8\306E\4F5C\6210\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104844885273309121)
,p_name=>'CA.CREATE.CARDS.PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30FC\30C9\30FB\30DA\30FC\30B8\306E\4F5C\6210\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104832839031309112)
,p_name=>'CA.CREATE.CHART.PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\30FB\30DA\30FC\30B8\306E\4F5C\6210\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104833334173309113)
,p_name=>'CA.CREATE.CR.PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30E9\30B7\30C3\30AF\30FB\30EC\30DD\30FC\30C8\30FB\30DA\30FC\30B8\306E\4F5C\6210\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104832976310309112)
,p_name=>'CA.CREATE.DASHBOARD.PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C0\30C3\30B7\30E5\30DC\30FC\30C9\30FB\30DA\30FC\30B8\306E\4F5C\6210\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104831151218309111)
,p_name=>'CA.CREATE.END'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D42\4E86\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104852187708309127)
,p_name=>'CA.CREATE.FACETED_SEARCH.PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30BB\30C3\30C8\691C\7D22\30DA\30FC\30B8\306E\4F5C\6210\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104833923415309113)
,p_name=>'CA.CREATE.FEATURES'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A5F\80FD\306E\4F5C\6210\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104849404546309125)
,p_name=>'CA.CREATE.FILTERED.CONTENT.PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30EB\30BF\3055\308C\305F\30B3\30F3\30C6\30F3\30C4\30FB\30DA\30FC\30B8\306E\4F5C\6210\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104832738576309112)
,p_name=>'CA.CREATE.FORM.PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30FC\30E0\30FB\30DA\30FC\30B8\306E\4F5C\6210\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104831303673309111)
,p_name=>'CA.CREATE.GLOBAL.PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30ED\30FC\30D0\30EB\30FB\30DA\30FC\30B8\306E\4F5C\6210\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104833549648309113)
,p_name=>'CA.CREATE.HOMEPAGE.NAV.LIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DB\30FC\30E0\30DA\30FC\30B8\30FB\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30EA\30B9\30C8\306E\4F5C\6210\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104833427276309113)
,p_name=>'CA.CREATE.IG.PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5BFE\8A71\30B0\30EA\30C3\30C9\30FB\30DA\30FC\30B8\306E\4F5C\6210\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104833257138309113)
,p_name=>'CA.CREATE.IR.PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\30FB\30DA\30FC\30B8\306E\4F5C\6210\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103542698176308046)
,p_name=>'CA.CREATE.MAP.PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30C3\30D7\30FB\30DA\30FC\30B8\306E\4F5C\6210\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104838208172309116)
,p_name=>'CA.CREATE.MD.PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30B9\30BF\30FC\30FB\30C7\30A3\30C6\30FC\30EB\30FB\30DA\30FC\30B8\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104832001653309112)
,p_name=>'CA.CREATE.NAV.BAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30D0\30FC\306E\4F5C\6210\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104835298213309114)
,p_name=>'CA.CREATE.PAGE.GROUP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30B0\30EB\30FC\30D7\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104833839873309113)
,p_name=>'CA.CREATE.PERFORM.TRANSLATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\7FFB\8A33\306E\5B9F\884C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104833748938309113)
,p_name=>'CA.CREATE.PERFORM.TRANSLATION.V'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306E\7FFB\8A33\3092\5B9F\884C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104833105216309112)
,p_name=>'CA.CREATE.REPORT.FORM.PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\304A\3088\3073\30D5\30A9\30FC\30E0\30FB\30DA\30FC\30B8\306E\4F5C\6210\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104838494786309116)
,p_name=>'CA.CREATE.SAVE_BLUE.PRINT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EB\30FC\30D7\30EA\30F3\30C8\306E\4FDD\5B58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104832119442309112)
,p_name=>'CA.CREATE.SHORT.CUT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30E7\30FC\30C8\30AB\30C3\30C8\306E\4F5C\6210\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104832596114309112)
,p_name=>'CA.CREATE.SIGN.IN.PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30A4\30F3\30A4\30F3\30FB\30DA\30FC\30B8\306E\4F5C\6210\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103542361041308046)
,p_name=>'CA.CREATE.SMART_FILTERS.PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\30B9\30DE\30FC\30C8\30FB\30D5\30A3\30EB\30BF\306E\4F5C\6210\4E2D\300D\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104831060874309111)
,p_name=>'CA.CREATE.START'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104831464980309111)
,p_name=>'CA.CREATE.SUP.OBJ.SCRIPTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30DD\30FC\30C8\3059\308B\30AA\30D6\30B8\30A7\30AF\30C8\306E\30B9\30AF\30EA\30D7\30C8\306E\4F5C\6210\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104831932605309112)
,p_name=>'CA.CREATE.TEXT.MSG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8\30FB\30E1\30C3\30BB\30FC\30B8\306E\4F5C\6210\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104844908914309121)
,p_name=>'CA.CREATE.TIMELINE.PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30E0\30E9\30A4\30F3\30FB\30DA\30FC\30B8\306E\4F5C\6210\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104852398006309127)
,p_name=>'CA.CREATE.WIZARD.PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A6\30A3\30B6\30FC\30C9\30FB\30DA\30FC\30B8\306E\4F5C\6210\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104812699986309097)
,p_name=>'CA.CREATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104812795292309097)
,p_name=>'CA.CREATED.BY'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F5C\6210\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104801105276309089)
,p_name=>'CA.CREATING.APPLICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\4F5C\6210\4E2D\3067\3059 ...')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104033820889308462)
,p_name=>'CA.CREDENTIAL.NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\8CC7\683C\8A3C\660E\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104040065059308467)
,p_name=>'CA.CREDENTIAL.OWNER'
,p_message_language=>'ja'
,p_message_text=>unistr('\8CC7\683C\8A3C\660E\6240\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104813248295309098)
,p_name=>'CA.CURRENT.STATUS'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\884C\306E\30B9\30C6\30FC\30BF\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104834235644309113)
,p_name=>'CA.CUSTOM.QRY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30B9\30BF\30E0\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104123027773308536)
,p_name=>'CA.CUSTOM.THEME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30B9\30BF\30E0\30FB\30C6\30FC\30DE\306E\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104123107216308536)
,p_name=>'CA.CUSTOM.THEME.DETAIL'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30E6\30CB\30D0\30FC\30B5\30EB\30FB\30C6\30FC\30DE\3067\306F\306A\304F\30AB\30B9\30BF\30E0\30FB\30C6\30FC\30DE\3092\4F7F\7528\3059\308B\3088\3046\306B\30A6\30A3\30B6\30FC\30C9\3092\5207\308A\66FF\3048\307E\3059\3002</p>'),
'',
unistr('<p>\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9\30FB\30C6\30FC\30DE\3092\9078\629E\3057\307E\3059\3002\30C6\30FC\30DE\304C\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB\3092\30B5\30DD\30FC\30C8\3057\3066\3044\308B\5834\5408\306F\3001\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB\3082\9078\629E\3067\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103787755810308237)
,p_name=>'CA.CUSTOM_THEME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30B9\30BF\30E0\30FB\30C6\30FC\30DE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104834825486309114)
,p_name=>'CA.DASHBOARD'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C0\30C3\30B7\30E5\30DC\30FC\30C9\30FB\30DA\30FC\30B8\3092\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104698632216308999)
,p_name=>'CA.DASHBOARD.CHART.N'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104834919748309114)
,p_name=>'CA.DASHBOARD.DETAILS'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8907\6570\306E\30C1\30E3\30FC\30C8\304C\3042\308B\30C0\30C3\30B7\30E5\30DC\30FC\30C9\30FB\30DA\30FC\30B8\3092\4F5C\6210\3057\307E\3059\3002</p>'),
unistr('<p>\6B21\306E\5C5E\6027\3092\5165\529B\3057\307E\3059\3002</p>'),
'<ul>',
unistr('  <li><strong>\30DA\30FC\30B8\540D</strong>(\5FC5\9808) - \3053\306E\30DA\30FC\30B8\306E\540D\524D\3092\5165\529B\3057\307E\3059\3002</li>'),
unistr('  <li><strong>\30A2\30A4\30B3\30F3\306E\8A2D\5B9A</strong> - \3053\306E\30DA\30FC\30B8\306E\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC\306B\8868\793A\3059\308B\30A2\30A4\30B3\30F3\3092\9078\629E\3057\307E\3059\3002</li>'),
'  </ul>',
'</ul>',
'&nbsp;<br>',
unistr('<p>\5404\30C1\30E3\30FC\30C8(\30C1\30E3\30FC\30C81\3001\30C1\30E3\30FC\30C82\3001\30C1\30E3\30FC\30C83\304A\3088\3073\30C1\30E3\30FC\30C84)\306F\30C7\30D5\30A9\30EB\30C8\3067\7570\306A\308B\30C1\30E3\30FC\30C8\30FB\30BF\30A4\30D7\306B\306A\308A\3001<em>\30B5\30F3\30D7\30EB\30FB\30C7\30FC\30BF</em>\306B\57FA\3065\304D\307E\3059\3002 '),
unistr('  \305D\306E\305F\3081\3001\3053\306E\30DA\30FC\30B8\3092\8FFD\52A0\3059\308B\305F\3081\306B\8A73\7D30\3092\5165\529B\3059\308B\5FC5\8981\306F\3042\308A\307E\305B\3093\3002'),
unistr('  \305F\3060\3057\3001\5404\30C1\30E3\30FC\30C8\3092\30AB\30B9\30BF\30DE\30A4\30BA\3057\3066\3001\72EC\81EA\306E\9078\629E\3067\30C7\30D5\30A9\30EB\30C8\5024\3092\7F6E\63DB\3067\304D\307E\3059\3002<br>'),
unistr('  \30C1\30E3\30FC\30C8\3092\30AB\30B9\30BF\30DE\30A4\30BA\3059\308B\306B\306F\3001\6B21\306E\5C5E\6027\3092\5165\529B\3057\307E\3059\3002</p>'),
'<ul>',
unistr('  <li><strong>\30C1\30E3\30FC\30C8\540D</strong>(\5FC5\9808) - \30C1\30E3\30FC\30C8\306E\540D\524D\3092\5165\529B\3057\307E\3059\3002</li>'),
unistr('  <li><strong>\30C1\30E3\30FC\30C8\30FB\30BF\30A4\30D7</strong> - \8868\793A\3059\308B\30C1\30E3\30FC\30C8\306E\30BF\30A4\30D7[<strong>\9762</strong>\3001<strong>\68D2</strong>\3001<strong>\6298\308C\7DDA</strong>\3001<strong>\5186</strong>]\3092\9078\629E\3057\307E\3059\3002</li>'),
unistr('  <li><strong>\8868\307E\305F\306F\30D3\30E5\30FC</strong>(\5FC5\9808) - \30C1\30E3\30FC\30C8\306E\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30AA\30D6\30B8\30A7\30AF\30C8\3092\9078\629E\3057\307E\3059\3002</li>'),
unistr('  <li><strong>\30E9\30D9\30EB\5217</strong>(\5FC5\9808) - \30C1\30E3\30FC\30C8\306E\30E9\30D9\30EB\3068\3057\3066\4F7F\7528\3059\308B\5217\3092\8868\307E\305F\306F\30D3\30E5\30FC\304B\3089\9078\629E\3057\307E\3059\3002</li>'),
unistr('  <li><strong>\5024\96C6\8A08</strong> - \5024\5217\306E\8868\793A\65B9\6CD5\307E\305F\306F\96C6\8A08\65B9\6CD5\3092\9078\629E\3057\307E\3059<br>'),
unistr('      &nbsp;&nbsp;&nbsp;[\5217\5024\3001\5408\8A08\3001\4EF6\6570]\3002</li>'),
unistr('  <li><strong>\5024\5217</strong>(\5FC5\9808) - \8868\793A\3055\308C\308B\30C1\30E3\30FC\30C8\5024\306E\8A08\7B97\306B\4F7F\7528\3059\308B\6570\5024\5217\3092\8868\307E\305F\306F\30D3\30E5\30FC\304B\3089\9078\629E\3057\307E\3059\3002</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104845554892309122)
,p_name=>'CA.DATATYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104846678595309123)
,p_name=>'CA.DATEFORMATMASK'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5\4ED8\66F8\5F0F\30DE\30B9\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104813907747309098)
,p_name=>'CA.DEFAULT.TIME.ZONE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\306E\30BF\30A4\30E0\30BE\30FC\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104814046620309098)
,p_name=>'CA.DEFAULT.TIME.ZONE.UPDATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\30FB\30BF\30A4\30E0\30BE\30FC\30F3\304C\66F4\65B0\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104835640768309114)
,p_name=>'CA.DEFAULTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5C5E\6027\306E\30C7\30D5\30A9\30EB\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104835968072309115)
,p_name=>'CA.DEFAULTS.DETAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306EJSON\30C9\30AD\30E5\30E1\30F3\30C8\3067\306F\3001\30EC\30DD\30FC\30C8\3068\30D5\30A9\30FC\30E0\306E\5217\540D\306E\751F\6210\3001\30D5\30A9\30FC\30DE\30C3\30C8\30FB\30DE\30B9\30AF\306A\3069\3092\304D\3081\7D30\304B\304F\5236\5FA1\3067\304D\307E\3059\3002\5024\304A\3088\3073\305D\306E\4ED6\306E\5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306E\30EA\30B9\30C8\3092\5B9A\7FA9\3059\308B\3053\3068\3082\3067\304D\307E\3059\3002 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104851974716309127)
,p_name=>'CA.DEFAULTS.LOV'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024\30EA\30B9\30C8\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104852068834309127)
,p_name=>'CA.DEFAULTS.LOV.DETAIL'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5024\30EA\30B9\30C8(LOV)\5C5E\6027\3092\8FFD\52A0\3057\307E\3059\3002LOV\306F\8868\5217\5B9A\7FA9\3067\4F7F\7528\3067\304D\307E\3059\3002</p>'),
unistr('<p>\6B21\306E\5C5E\6027\3092\5165\529B\3057\307E\3059\3002'),
'  <ul>',
unistr('    <li><strong>\540D\524D</strong>(\5FC5\9808) - \5024\30EA\30B9\30C8\306E\540D\524D\3092\5165\529B\3057\307E\3059\3002</li>'),
unistr('    <li><strong>\30BF\30A4\30D7</strong> - \5024\30EA\30B9\30C8\30FB\30BF\30A4\30D7[\300C\69CB\9020\5316\300D\3001\300C\52D5\7684\300D\3001\300C\9759\7684\300D]\3092\9078\629E\3057\307E\3059\3002<br>'),
unistr('      \300C\30BF\30A4\30D7\300D\304C<u>\300C\69CB\9020\5316\300D</u>\306E\5834\5408 - '),
'      <ul>',
unistr('          <li><strong>\8868</strong>(\5FC5\9808) - \5024\30EA\30B9\30C8\306E\57FA\306B\306A\308B\8868\307E\305F\306F\30D3\30E5\30FC\3092\9078\629E\3057\307E\3059\3002</li>'),
unistr('          <li><strong>\8868\793A\5217</strong>(\5FC5\9808) - \30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\8868\793A\3055\308C\308B\5217\3092\9078\629E\3057\307E\3059\3002</li>'),
unistr('          <li><strong>\30AD\30FC\5217</strong>(\5FC5\9808) - \8FD4\3055\308C\308B\5217\5024\3092\9078\629E\3057\307E\3059\3002\3053\308C\306F\4E00\822C\306B\3001\8868\306E\4E3B\30AD\30FC\3067\3059\3002</li>'),
'      </ul>',
'      &nbsp;<br>',
unistr('      \300C\30BF\30A4\30D7\300D\304C<u>\300C\52D5\7684\300D</u>\306E\5834\5408 -'),
'      <ul>',
unistr('          <li><strong>SQL\554F\5408\305B</strong>(\5FC5\9808) - 2\3064\306E\5024(\8868\793A\5024\3068\623B\308A\5024)\3092\8FD4\3059\6709\52B9\306ASQL select\6587\3092\5165\529B\3057\307E\3059\3002</li>'),
'      </ul>',
'      &nbsp;<br>',
unistr('      \300C\30BF\30A4\30D7\300D\304C<u>\300C\9759\7684\300D</u>\306E\5834\5408 -'),
'      <ul>',
unistr('          <li><strong>\9759\7684\5024\30EA\30B9\30C8</strong>(\5FC5\9808) - \30D5\30A9\30FC\30E0\306E\6709\52B9\306A\9759\7684\30EA\30B9\30C8\3092\5165\529B\3057\307E\3059\3002'),
'          <ul>',
unistr('            <li><code>STATIC2:Display1;Value1,Display2;Value2,...</code><br>\5165\529B\3057\305F\9806\5E8F\3067\8868\793A\3055\308C\308B\30EA\30B9\30C8</li>'),
unistr('            <li><code>STATIC:Display1;Value1,Display2;Value2,...</code><br>\82F1\5B57\9806\306E\30EA\30B9\30C8</li>'),
unistr('            <li><code>STATIC2|STATIC:Value1,Value2,...</code><br>\8868\793A\5024\3068\623B\308A\5024\306F\540C\3058\3067\3059</li>'),
'          </ul>',
'      </ul>',
'    </li>',
'  </ul>',
'</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104853134203309128)
,p_name=>'CA.DEFAULTS.REPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104853242130309128)
,p_name=>'CA.DEFAULTS.REPORT.DETAIL'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3059\3079\3066\306E\30EC\30DD\30FC\30C8\306E\5C5E\6027\3092\7DE8\96C6\3057\307E\3059\3002</p>'),
unistr('<p>\6B21\306E\5C5E\6027\3092\5165\529B\3057\307E\3059\3002'),
'  <ul>',
unistr('    <li><strong>\30DA\30FC\30B8\3054\3068\306E\884C\6570</strong> - \30C7\30D5\30A9\30EB\30C8\3067\8868\793A\3059\308B\30EC\30DD\30FC\30C8\884C\6570\3092\5165\529B\3057\307E\3059\3002</li>'),
unistr('    <li><strong>\30DA\30FC\30B8\533A\5207\308A\30E1\30BD\30C3\30C9</strong> - \30EC\30DD\30FC\30C8\30FB\30DA\30FC\30B8\533A\5207\308A\306E\8868\793A\30E1\30BD\30C3\30C9\3092\9078\629E\3057\307E\3059\3002</li>'),
unistr('    <li><strong>\6570\5024\66F8\5F0F\30DE\30B9\30AF</strong> - \6570\5024\306E\5217\304A\3088\3073\30A2\30A4\30C6\30E0\306B\9069\7528\3059\308B\66F8\5F0F\30DE\30B9\30AF\3092\5165\529B\3057\307E\3059\3002</li>'),
unistr('    <li><strong>\65E5\4ED8\66F8\5F0F\30DE\30B9\30AF</strong> - \65E5\4ED8\306E\5217\304A\3088\3073\30A2\30A4\30C6\30E0\306B\9069\7528\3059\308B\66F8\5F0F\30DE\30B9\30AF\3092\5165\529B\3057\307E\3059\3002</li>'),
'  </ul>',
'</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104852908694309127)
,p_name=>'CA.DEFAULTS.TABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\306E\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104852746786309127)
,p_name=>'CA.DEFAULTS.TABLE.COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\5217\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104852819207309127)
,p_name=>'CA.DEFAULTS.TABLE.COLUMN.DETAIL'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\629E\3057\305F\8868\5217\306E\5C5E\6027\3092\7DE8\96C6\3057\307E\3059\3002</p>'),
unistr('<p>\6B21\306E\5C5E\6027\3092\5165\529B\3057\307E\3059\3002'),
'  <ul>',
unistr('    <li><strong>\8868</strong>(\8868\793A\5C02\7528) - \95A2\9023\4ED8\3051\3089\308C\305F\8868\3002</li>'),
unistr('    <li><strong>\5217</strong>(\8868\793A\5C02\7528) - \5C5E\6027\306E\5B9A\7FA9\306B\4F7F\7528\3055\308C\308B\5217\3002</li>'),
unistr('    <li><strong>\30E9\30D9\30EB</strong> - \30EC\30DD\30FC\30C8\30FB\30D8\30C3\30C0\30FC\304A\3088\3073\30D5\30A9\30FC\30E0\30FB\30E9\30D9\30EB\3067\4F7F\7528\3059\308B\30E9\30D9\30EB\3092\5165\529B\3057\307E\3059\3002</li>'),
unistr('    <li><strong>\30D5\30A9\30FC\30E0\30FB\30B3\30F3\30C8\30ED\30FC\30EB</strong> - \30D5\30A9\30FC\30E0\3067\4F7F\7528\3059\308B\30A2\30A4\30C6\30E0\30FB\30BF\30A4\30D7\3092\9078\629E\3057\307E\3059\3002</li>'),
unistr('    <li><strong>\5024\30EA\30B9\30C8</strong> - \9069\5B9C\308F\304B\308A\3084\3059\3044\540D\524D\3092\8868\793A\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\65E2\5B58\306E\5024\30EA\30B9\30C8\3092\9078\629E\3057\307E\3059\3002</li>'),
unistr('    <li><strong>\66F8\5F0F\30DE\30B9\30AF</strong> - \5217\30BF\30A4\30D7(\30C6\30AD\30B9\30C8\3001\6570\5024\3001\65E5\4ED8\306A\3069)\306B\57FA\3065\3044\3066\9069\5207\306A\66F8\5F0F\30DE\30B9\30AF\3092\5165\529B\3057\307E\3059\3002</li>'),
unistr('    <li><strong>\9759\7684\30C7\30D5\30A9\30EB\30C8\5024</strong> - \5217\306E\30C6\30AD\30B9\30C8\30FB\30C7\30D5\30A9\30EB\30C8\5024\3092\5165\529B\3057\307E\3059\3002</li>'),
unistr('    <li><strong>\30D5\30A9\30FC\30E0\306B\542B\3081\308B</strong> - \5217\3092\30D5\30A9\30FC\30E0\306B\542B\3081\308B\5834\5408\306F\3001\300C\306F\3044\300D\3092\30AF\30EA\30C3\30AF\3057\307E\3059\3002</li>'),
unistr('    <li><strong>\30EC\30DD\30FC\30C8\306B\542B\3081\308B</strong> - \5217\3092\30EC\30DD\30FC\30C8\306B\542B\3081\308B\5834\5408\306F\3001\300C\306F\3044\300D\3092\30AF\30EA\30C3\30AF\3057\307E\3059\3002</li>'),
unistr('    <li><strong>\5FC5\9808</strong> - \30D5\30A9\30FC\30E0\3067\3053\306E\5217\3078\306E\30C7\30FC\30BF\306E\5165\529B\3092\5FC5\9808\306B\3059\308B\5834\5408\306F\3001\300C\306F\3044\300D\3092\30AF\30EA\30C3\30AF\3057\307E\3059\3002</li>'),
unistr('    <li><strong>\30D8\30EB\30D7</strong> - \9805\76EE\30D8\30EB\30D7\5C5E\6027\306B\8FFD\52A0\3059\308B\30D8\30EB\30D7\30FB\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002</li>'),
'  </ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104853094370309128)
,p_name=>'CA.DEFAULTS.TABLE.DETAIL'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\629E\3057\305F\8868\306E\5C5E\6027\3092\7DE8\96C6\3057\307E\3059\3002</p>'),
unistr('<p>\6B21\306E\5C5E\6027\3092\5165\529B\3057\307E\3059\3002'),
'  <ul>',
unistr('    <li><strong>\8868</strong>(\8868\793A\5C02\7528) - \95A2\9023\4ED8\3051\3089\308C\305F\8868\3002</li>'),
unistr('    <li><strong>\30E9\30D9\30EB\3001\5358\4E00</strong>(\5FC5\9808) - \30D5\30A9\30FC\30E0\30FB\30DA\30FC\30B8\3067\4F7F\7528\3059\308B\30E9\30D9\30EB\3092\5165\529B\3057\307E\3059\3002</li>'),
unistr('    <li><strong>\30E9\30D9\30EB\3001\8907\6570</strong>(\5FC5\9808) - \30EA\30FC\30B8\30E7\30F3\30FB\30D8\30C3\30C0\30FC\304A\3088\3073\30DA\30FC\30B8\540D\3067\4F7F\7528\3059\308B\30E9\30D9\30EB\3092\5165\529B\3057\307E\3059\3002</li>'),
unistr('    <li><strong>\30D7\30E9\30A4\30DE\30EA\8868\793A\5217</strong> - \30AB\30FC\30C9\30FB\30EA\30FC\30B8\30E7\30F3\306A\3069\306B\8868\793A\3059\308B\6700\521D\306E\5217\3092\9078\629E\3057\307E\3059\3002</li>'),
unistr('    <li><strong>\30BB\30AB\30F3\30C0\30EA\8868\793A\5217</strong> - \30AB\30FC\30C9\30FB\30EA\30FC\30B8\30E7\30F3\306A\3069\306B\8868\793A\3059\308B2\756A\76EE\306E\5217\3092\9078\629E\3057\307E\3059\3002</li>'),
unistr('    <li><strong>\4E3B\30AD\30FC\5217</strong> - \8868\306E\4E00\610F\306E\4E3B\30AD\30FC\5217\3092\9078\629E\3057\307E\3059\3002</li>'),
unistr('    <li><strong>\8AAC\660E</strong> - \8868\306E\8AAC\660E\3092\5165\529B\3057\307E\3059\3002</li>'),
'  </ul>',
'</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104033697690308462)
,p_name=>'CA.DEFERRED.DROP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9045\5EF6\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104847211561309123)
,p_name=>'CA.DEFINITION'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9A\7FA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104830916967309111)
,p_name=>'CA.DEINSTALL.COMPLETE'
,p_message_language=>'ja'
,p_message_text=>unistr('\524A\9664\306F\5B8C\4E86\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104811297267309096)
,p_name=>'CA.DELETE'
,p_message_language=>'ja'
,p_message_text=>unistr('\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104830566139309111)
,p_name=>'CA.DELETE.CONFIRM'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\524A\9664\64CD\4F5C\3092\5B9F\884C\3057\307E\3059\304B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104796898743309086)
,p_name=>'CA.DELETE.PAGE.CONFIRM.MSG'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DA\30FC\30B8\3092\524A\9664\3057\307E\3059\304B\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104821037996309104)
,p_name=>'CA.DELETE.PHOTO'
,p_message_language=>'ja'
,p_message_text=>unistr('\5199\771F\306E\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104811989294309097)
,p_name=>'CA.DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\8AAC\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104829166433309109)
,p_name=>'CA.DESKTOP.NAVIGATION.BAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30D0\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104829053912309109)
,p_name=>'CA.DESKTOP.NAVIGATION.MENU'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104810270438309096)
,p_name=>'CA.DESKTOP.THEME.STYLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30B9\30AF\30C8\30C3\30D7\30FB\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104810371412309096)
,p_name=>'CA.DESKTOP.THEME.STYLE.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\306E\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB\306F\3059\3079\3066\306E\30E6\30FC\30B6\30FC\306B\9069\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104034062054308462)
,p_name=>'CA.DESTINATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9B\5148')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104034165198308462)
,p_name=>'CA.DESTINATION.OWNER'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9B\5148\6240\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103787805798308238)
,p_name=>'CA.DIALOG.BUTTONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C0\30A4\30A2\30ED\30B0\30FB\30DC\30BF\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104825553777309107)
,p_name=>'CA.DISPATCH.EMAILS'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\306E\30C7\30A3\30B9\30D1\30C3\30C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104844005457309121)
,p_name=>'CA.DISPATCH.EMAILS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\3092\96FB\5B50\30E1\30FC\30EB\30FB\30D5\30EC\30FC\30E0\30EF\30FC\30AF\304B\3089\9001\4FE1\3059\308B\5FC5\8981\304C\3042\308B\304B\3069\3046\304B\3092\6C7A\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104811733304309097)
,p_name=>'CA.DISPLAY.FROM'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\958B\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104811622166309097)
,p_name=>'CA.DISPLAY.SEQUENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104811854238309097)
,p_name=>'CA.DISPLAY.UNTIL'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\7D42\4E86')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104845786265309122)
,p_name=>'CA.DISPLAYCOLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104815329500309099)
,p_name=>'CA.DISTINCT .USERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\500B\5225\30E6\30FC\30B6\30FC')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104828687171309109)
,p_name=>'CA.DOWNLOAD'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C0\30A6\30F3\30ED\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104835531813309114)
,p_name=>'CA.DRAG.TO.REORDER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C9\30E9\30C3\30B0\3057\3066\30DA\30FC\30B8\306E\4E26\66FF\3048')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103808561324308254)
,p_name=>'CA.DRILL.DOWN.LINK'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'&nbsp;<br>',
'<ul>',
unistr('  <li><strong>\30C9\30EA\30EB\30C0\30A6\30F3\30FB\30EA\30F3\30AF</strong> - \5C55\958B\3057\3066\3001\30C9\30EA\30EB\30C0\30A6\30F3\30FB\30EA\30F3\30AF\3092\5B9A\7FA9\3059\308B\305F\3081\306E\5C5E\6027\3092\8868\793A\3057\307E\3059\3002'),
'&nbsp;<br>',
unistr('    <em><strong>\30CE\30FC\30C8:</strong> \300C\30C9\30EA\30EB\30C0\30A6\30F3\30FB\30EA\30F3\30AF\300D\304C\8868\793A\3055\308C\308B\306E\306F\3001\73FE\5728\306E\30DA\30FC\30B8\304C\8868\307E\305F\306F\30D3\30E5\30FC\306B\57FA\3065\3044\3066\304A\308A\3001\30EC\30DD\30FC\30C8\30FB\30BF\30A4\30D7\304C\300C\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\300D\3067\3042\308A\3001\304B\3064\30EC\30DD\30FC\30C8\30FB\30DA\30FC\30B8(\300C\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\300D)\307E\305F\306F\30DE\30B9\30BF\30FC\30FB\30C7\30A3\30C6\30FC\30EB\30FB\30DA\30FC\30B8(\300C\30DE\30B9\30BF\30FC\30FB\30C7\30A3\30C6\30FC\30EB\300D)\3092\5B9A\7FA9\3057\305F\5834\5408\306E\307F\3067\3059\3002</em>'),
'  <ul>',
unistr('    <li><strong>\30EA\30F3\30AF\5217</strong> - \30EC\30DD\30FC\30C8\306E\30EA\30F3\30AF\5217\306B\5909\66F4\3059\308B\5217\3092\9078\629E\3057\307E\3059\3002</li>'),
unistr('    <li><strong>\30EA\30F3\30AF\30FB\30AD\30FC</strong> - \30EA\30F3\30AF\5148\306E\30DA\30FC\30B8\306E\7279\5B9A\306E\30EC\30B3\30FC\30C9\3092\8B58\5225\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\30EA\30F3\30AF\30FB\30AD\30FC(\5916\90E8\30AD\30FC)\5217\3092\9078\629E\3057\307E\3059\3002</li>'),
unistr('    <li><strong>\30DA\30FC\30B8\3078\306E\30EA\30F3\30AF</strong> - \30EA\30F3\30AF\306E\79FB\52D5\5148\306E\30EC\30DD\30FC\30C8\307E\305F\306F\30D5\30A9\30FC\30E0\30FB\30DA\30FC\30B8\3092\9078\629E\3057\307E\3059\3002</li>'),
unistr('    <li><strong>\30BF\30FC\30B2\30C3\30C8\30FB\30AD\30FC</strong> - \30EA\30F3\30AF\306E\79FB\52D5\5148\306E\30EC\30DD\30FC\30C8\30FB\30DA\30FC\30B8\306E\57FA\306B\306A\308B\8868\304B\3089\3001\30BF\30FC\30B2\30C3\30C8\30FB\30AD\30FC(\4E3B\30AD\30FC)\5217\3092\9078\629E\3057\307E\3059\3002'),
'  </ul>',
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104814462421309099)
,p_name=>'CA.ELAPSED'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D4C\904E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104797046882309086)
,p_name=>'CA.EMAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\30FB\30D5\30EC\30FC\30E0\30EF\30FC\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104843626910309120)
,p_name=>'CA.EMAIL.ADDRESSES'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104853600870309128)
,p_name=>'CA.EMAIL.DEFAULT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104796925730309086)
,p_name=>'CA.EMAIL.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\3092\69CB\6210\3057\3066\9001\4FE1\3059\308B\6A5F\80FD\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104797178143309086)
,p_name=>'CA.EMAIL.DETAIL'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304B\3089\96FB\5B50\30E1\30FC\30EB\3092\9001\4FE1\3059\308B\6A5F\80FD\3092\542B\3081\307E\3059\3002\30B5\30F3\30D7\30EB\306E\96FB\5B50\30E1\30FC\30EB\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\4F7F\7528\3057\3066\3001\672C\683C\4ED5\69D8\306E\96FB\5B50\30E1\30FC\30EB\3092\30E6\30FC\30B6\30FC\306B\9001\4FE1\3057\307E\3059\3002\9001\4FE1\3055\308C\305F\96FB\5B50\30E1\30FC\30EB\306F\3001\7BA1\7406\8005\304C\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30AF\30C6\30A3\30D3\30C6\30A3\3092\628A\63E1\3067\304D\308B\3088\3046\306B\30ED\30B0\306B\8A18\9332\3055\308C\307E\3059\3002</p>'),
unistr('<p>\6B21\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\304C\542B\307E\308C\307E\3059:'),
'<ul>',
unistr('<li>\62E1\5F35\53EF\80FD\306AHTML\96FB\5B50\30E1\30FC\30EB\30FB\30C6\30F3\30D7\30EC\30FC\30C8\30FB\30B7\30B9\30C6\30E0</li>'),
unistr('<li>APEX\30D1\30C3\30B1\30FC\30B8\3092\901A\3058\305F\30E1\30FC\30EB\9001\4FE1\306E\305F\3081\306EPL/SQL\30D1\30C3\30B1\30FC\30B8</li>'),
unistr('<li>\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30AF\30C6\30A3\30D3\30C6\30A3\304A\3088\3073\30B9\30C6\30FC\30BF\30B9\306E\30ED\30AE\30F3\30B0</li>'),
unistr('<li>\30C6\30F3\30D7\30EC\30FC\30C8\3092\7BA1\7406\3059\308B\305F\3081\306E\7BA1\7406UI</li>'),
unistr('<li>\96FB\5B50\30E1\30FC\30EB\30FB\30ED\30B0\3092\8868\793A\3059\308B\305F\3081\306E\7BA1\7406UI</li>'),
unistr('<li>\96FB\5B50\30E1\30FC\30EB\3092\9001\4FE1\3059\308B\305F\3081\306E\7BA1\7406UI</li>'),
'</ul>',
'</p>',
unistr('<p><em>\30CE\30FC\30C8: \3053\306E\6A5F\80FD\306F\3001\300C\30D5\30A3\30FC\30C9\30D0\30C3\30AF\300D\304C\9078\629E\3055\308C\308B\3068\6709\52B9\306B\306A\308A\307E\3059</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104849324119309125)
,p_name=>'CA.EMAIL.FROM'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\5DEE\51FA\4EBA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104824510149309106)
,p_name=>'CA.EMAIL.LOG'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\30FB\30ED\30B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104854298653309129)
,p_name=>'CA.EMAIL.P10940.EMAIL.DETAILS.REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\8A2D\5B9A\306E\8A73\7D30\304C\5FC5\8981\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104853770248309128)
,p_name=>'CA.EMAIL.P10940.EMAILS.FROM.INVALID'
,p_message_language=>'ja'
,p_message_text=>unistr('\9001\4FE1\5143\30A2\30C9\30EC\30B9\304C\6709\52B9\306A\96FB\5B50\30E1\30FC\30EB\3067\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104845263087309121)
,p_name=>'CA.EMAIL.P11030.EMAILS.FROM.INVALID'
,p_message_language=>'ja'
,p_message_text=>unistr('\9001\4FE1\5143\30A2\30C9\30EC\30B9\304C\6709\52B9\306A\96FB\5B50\30E1\30FC\30EB\3067\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104844420633309121)
,p_name=>'CA.EMAIL.PROCESSED'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\304C\51E6\7406\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103911497978308336)
,p_name=>'CA.EMAIL.REPORTING'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\30FB\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104083725423308503)
,p_name=>'CA.EMAIL.REPORTING.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\9001\4FE1\30AD\30E5\30FC\306B\5165\3063\3066\3044\308B\3059\3079\3066\306E\96FB\5B50\30E1\30FC\30EB\304A\3088\3073\3059\3067\306B\9001\4FE1\3055\308C\305F\3059\3079\3066\306E\96FB\5B50\30E1\30FC\30EB\306E\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104825447481309107)
,p_name=>'CA.EMAIL.SETTINGS'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104825894173309107)
,p_name=>'CA.EMAIL.SETTINGS.UPDATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\8A2D\5B9A\304C\66F4\65B0\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104849794112309125)
,p_name=>'CA.EMAIL.STATUS'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\30FB\30B9\30C6\30FC\30BF\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104825936823309107)
,p_name=>'CA.EMAIL.TEMPLATE.DETAILS'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306E\8A73\7D30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104332144300308706)
,p_name=>'CA.EMAIL.TEMPLATE.SUBJECT_EXAMPLE.SO'
,p_message_language=>'ja'
,p_message_text=>unistr('#SERVICE_NAME#\306E\30B9\30B1\30B8\30E5\30FC\30EB\6E08\505C\6B62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104130418299308542)
,p_name=>'CA.EMAIL2'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104824423590309106)
,p_name=>'CA.EMAILS.SENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\9001\4FE1\6E08\96FB\5B50\30E1\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104853843156309128)
,p_name=>'CA.ENABLE.ATTACHMENTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6DFB\4ED8\6709\52B9\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104039116067308466)
,p_name=>'CA.ENABLED'
,p_message_language=>'ja'
,p_message_text=>unistr('\6709\52B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104036369715308464)
,p_name=>'CA.END.DATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D42\4E86\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104826593573309108)
,p_name=>'CA.END.ROW.TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\306E\5F8C\30B3\30F3\30C6\30F3\30C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104717840365309015)
,p_name=>'CA.ENDED'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D42\4E86')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104841548389309119)
,p_name=>'CA.ENTER.USERNAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\540D\3092\3053\3053\306B\5165\529B\3057\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104815048932309099)
,p_name=>'CA.ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104817383971309101)
,p_name=>'CA.ERROR.BACKTRACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC\30FB\30D0\30C3\30AF\30C8\30EC\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104817286281309101)
,p_name=>'CA.ERROR.CODE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC\30FB\30B3\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104816566213309100)
,p_name=>'CA.ERROR.MESSAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104040898305308468)
,p_name=>'CA.ERROR.NUMBER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC\756A\53F7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104039847497308467)
,p_name=>'CA.ERRORS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104718050667309015)
,p_name=>'CA.ERROR_ROWS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104036714336308464)
,p_name=>'CA.EVENT.CONDITION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30D9\30F3\30C8\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104036802027308464)
,p_name=>'CA.EVENT.QUEUE.AGENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30D9\30F3\30C8\30FB\30AD\30E5\30FC\30FB\30A8\30FC\30B8\30A7\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104036907602308464)
,p_name=>'CA.EVENT.QUEUE.NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30D9\30F3\30C8\30FB\30AD\30E5\30FC\306E\540D\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104037063633308465)
,p_name=>'CA.EVENT.QUEUE.OWNER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30D9\30F3\30C8\30FB\30AD\30E5\30FC\6240\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104036691455308464)
,p_name=>'CA.EVENT.RULE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30D9\30F3\30C8\30FB\30EB\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104841867678309119)
,p_name=>'CA.EXCEPTIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F8B\5916')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104854768405309129)
,p_name=>'CA.EXPERIENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30AF\30B9\30DA\30EA\30A8\30F3\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104038880629308466)
,p_name=>'CA.FAILURE.COUNT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5931\6557\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104813042529309098)
,p_name=>'CA.FEATURE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A5F\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104487605797308829)
,p_name=>'CA.FEATURE.ABOUT_PAGE.APP_VERSION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30D0\30FC\30B8\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104487751458308829)
,p_name=>'CA.FEATURE.ABOUT_PAGE.PAGES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104171942072308585)
,p_name=>'CA.FEATURE.ACL.ADD_USERS_TO_ACL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30BB\30B9\5236\5FA1\30EA\30B9\30C8\3078\306E\30E6\30FC\30B6\30FC\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104171792409308585)
,p_name=>'CA.FEATURE.ACL.MULTIPLE_USER.ADD.NEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\30B9\30C6\30C3\30D7\306B\9032\3080')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104171822712308585)
,p_name=>'CA.FEATURE.ACL.MULTIPLE_USER.CREATE_COLLECTIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30EC\30AF\30B7\30E7\30F3\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104171631946308585)
,p_name=>'CA.FEATURE.ACL.USER.EDIT.CANNOT_CHANGE_LAST_ADMIN'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\7D42\7BA1\7406\8005\306F\5909\66F4\3067\304D\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104487399764308829)
,p_name=>'CA.FEATURE.ACTIVITY_REPORT.LAST_ACTIVITY'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5F8C\306E\30A2\30AF\30C6\30A3\30D3\30C6\30A3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104171496200308585)
,p_name=>'CA.FEATURE.ACTIVITY_REPORT.NO_ACTIVITY_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30C6\30A3\30D3\30C6\30A3\304C\898B\3064\304B\308A\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104487517368308829)
,p_name=>'CA.FEATURE.EXCEPTION.REASON'
,p_message_language=>'ja'
,p_message_text=>unistr('\7406\7531')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104172095914308585)
,p_name=>'CA.FEATURE.FEEDBACK.AT_LEAST_ONE_REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C11\306A\304F\3068\30821\3064\306E\30D5\30A3\30FC\30C9\30D0\30C3\30AF\304C\5FC5\8981\3067\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104172391574308585)
,p_name=>'CA.FEATURE.FEEDBACK.GET_FILE_ID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EBID\306E\53D6\5F97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104170950687308584)
,p_name=>'CA.FEATURE.THEME_STYLE.SAVE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB\306E\4FDD\5B58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104171059972308584)
,p_name=>'CA.FEATURE.THEME_STYLE.SAVE_USER_PREF'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306E\30B9\30BF\30A4\30EB\30FB\30D7\30EA\30D5\30A1\30EC\30F3\30B9\306E\4FDD\5B58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104487401501308829)
,p_name=>'CA.FEATURE.USERNAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104801205357309089)
,p_name=>'CA.FEATURES'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A5F\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104801346112309089)
,p_name=>'CA.FEATURES.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A5F\80FD\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30EC\30D9\30EB\306E\6A5F\80FD\3092\63D0\4F9B\3057\3001\901A\5E38\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3054\3068\306B1\56DE\8FFD\52A0\3055\308C\307E\3059\3002\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\542B\3081\308B\6A5F\80FD\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104795129598309084)
,p_name=>'CA.FEEDBACK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30FC\30C9\30D0\30C3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104793183168309083)
,p_name=>'CA.FEEDBACK.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\306B\3088\308B\30D5\30A3\30FC\30C9\30D0\30C3\30AF\306E\63D0\4F9B\3092\8A31\53EF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104795086923309084)
,p_name=>'CA.FEEDBACK.DETAIL'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\7BA1\7406\8005\304A\3088\3073\958B\767A\8005\306B\4E00\822C\7684\306A\30B3\30E1\30F3\30C8\3092\6295\7A3F\3059\308B\30E1\30AB\30CB\30BA\30E0\3092\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\63D0\4F9B\3057\307E\3059\3002\6295\7A3F\306B\306F\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\3069\3053\304B\3089\30D5\30A3\30FC\30C9\30D0\30C3\30AF\3092\9001\4FE1\3057\305F\304B\3092\5224\65AD\3059\308B\305F\3081\306B\5F79\7ACB\3064\6709\76CA\306A\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\60C5\5831\304C\542B\307E\308C\307E\3059\3002\3053\306E\3088\3046\306B\7C21\5358\306A\30D5\30A3\30FC\30C9\30D0\30C3\30AF\30FB\30EB\30FC\30D7\3092\63D0\4F9B\3059\308B\3053\3068\3067\3001\30E6\30FC\30B6\30FC\30FB\30B3\30DF\30E5\30CB\30C6\30A3\3068\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\6240\6709\8005\306E\9593\306E\30B3\30DF\30E5\30CB\30B1\30FC\30B7\30E7\30F3\304C\62E1\5927\3057\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306E\6E80\8DB3\5EA6\304C\5927\5E45\306B\5411\4E0A\3057\307E\3059\3002</p>'),
unistr('<p>\6B21\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\304C\542B\307E\308C\307E\3059:'),
'<ul>',
unistr('<li>\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30D0\30FC\30FB\30A2\30A4\30B3\30F3\3092\30AF\30EA\30C3\30AF\3057\3066\30D5\30A3\30FC\30C9\30D0\30C3\30AF\3092\6B8B\3059\3053\3068\304C\3067\304D\308B\6A5F\80FD</li>'),
unistr('<li>\30D5\30A3\30FC\30C9\30D0\30C3\30AF\3092\8868\793A\304A\3088\3073\66F4\65B0\3059\308B\305F\3081\306E\7BA1\7406\30EC\30DD\30FC\30C8</li>'),
unistr('<li>\30D5\30A3\30FC\30C9\30D0\30C3\30AF\306B\3088\308B\30E6\30FC\30B6\30FC\3001\65E5\6642\304A\3088\3073\30E6\30FC\30B6\30FC\30FB\30A8\30FC\30B8\30A7\30F3\30C8\60C5\5831\306E\53D6\5F97</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104855130705309129)
,p_name=>'CA.FEEDBACK.OR_EXPERIENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30FC\30C9\30D0\30C3\30AF\307E\305F\306F\30A8\30AF\30B9\30DA\30EA\30A8\30F3\30B9\3092\63D0\4F9B\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104854146191309129)
,p_name=>'CA.FEEDBACK.RECIPIENTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\9001\4FE1\5148')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104853517158309128)
,p_name=>'CA.FEEDBACK.SETTINGS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30FC\30C9\30D0\30C3\30AF\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104822561136309105)
,p_name=>'CA.FEEDBACK.SETTINGS.UPDATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30FC\30C9\30D0\30C3\30AF\8A2D\5B9A\304C\66F4\65B0\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104854347645309129)
,p_name=>'CA.FEEDBACK.SUBMITTED.SUCCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30FC\30C9\30D0\30C3\30AF\304C\767A\884C\3055\308C\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104036468936308464)
,p_name=>'CA.FILE.WATCHER.NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\30FB\30A6\30A9\30C3\30C1\30E3\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104036562023308464)
,p_name=>'CA.FILE.WATCHER.OWNER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\30FB\30A6\30A9\30C3\30C1\30E3\6240\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103694662746308162)
,p_name=>'CA.FILED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103694704639308162)
,p_name=>'CA.FILED.BY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104849892865309125)
,p_name=>'CA.FILTER.REPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30EB\30BF\30FB\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104826991221309108)
,p_name=>'CA.FILTERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30EB\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104852515814309127)
,p_name=>'CA.FINISH'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D42\4E86')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104821279148309104)
,p_name=>'CA.FIRST.NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104033418614308462)
,p_name=>'CA.FLAGS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30E9\30B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104802644548309090)
,p_name=>'CA.FORM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30FC\30E0\30FB\30DA\30FC\30B8\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104802578499309090)
,p_name=>'CA.FORM.DETAILS'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\30C7\30FC\30BF\3092\30E1\30F3\30C6\30CA\30F3\30B9\3067\304D\308B\3088\3046\306B\30D5\30A9\30FC\30E0\30FB\30DA\30FC\30B8\3092\8868\793A\3059\308B\30DA\30FC\30B8\3092\4F5C\6210\3057\307E\3059\3002</p>'),
unistr('<p>\6B21\306E\5C5E\6027\3092\5165\529B\3057\307E\3059\3002</p>'),
'<ul>',
unistr('  <li><strong>\30DA\30FC\30B8\540D</strong>(\5FC5\9808) - \3053\306E\30DA\30FC\30B8\306E\540D\524D\3092\5165\529B\3057\307E\3059\3002</li>'),
unistr('  <li><strong>\30A2\30A4\30B3\30F3\306E\8A2D\5B9A</strong> - \3053\306E\30DA\30FC\30B8\306E\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC\306B\8868\793A\3059\308B\30A2\30A4\30B3\30F3\3092\9078\629E\3057\307E\3059\3002</li>'),
unistr('  <li><strong>\8868</strong>(\5FC5\9808) - \30D5\30A9\30FC\30E0\306E\8868\3092\9078\629E\3057\307E\3059\3002</li>'),
unistr('<li><strong>\30EC\30DD\30FC\30C8\3092\542B\3081\308B</strong>(\5FC5\9808) - \30EC\30DD\30FC\30C8\304A\3088\3073\30D5\30A9\30FC\30E0\3092\4F5C\6210\3059\308B\306B\306F\3001\3053\306E\30AA\30D7\30B7\30E7\30F3\3092\9078\629E\3057\307E\3059\3002\6700\521D\306E\30DA\30FC\30B8\306F\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\3067\3059\3002\5404\884C\3067\306F\3001\30E6\30FC\30B6\30FC\304C\30EC\30B3\30FC\30C9\3092\66F4\65B0\3067\304D\308B\30D5\30A9\30FC\30E0\3078\306E\30EA\30F3\30AF\304C\63D0\4F9B\3055\308C\307E\3059\3002 </li>'),
'  &nbsp;<br>',
unistr('<li><strong>\8A73\7D30</strong> - \5C55\958B\3057\3066\8A73\7D30\30AA\30D7\30B7\30E7\30F3\3092\8868\793A\3057\307E\3059\3002'),
'     <ul>',
unistr('      <li><strong>\30DA\30FC\30B8\306E\30D8\30EB\30D7</strong> - \30DA\30FC\30B8\306E\30D8\30EB\30D7\30FB\30C6\30AD\30B9\30C8\306B\8FFD\52A0\3059\308B\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002</li>'),
'      </ul>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103807154087308253)
,p_name=>'CA.FORM.ITEM.REGION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30FC\30E0\30FB\30A2\30A4\30C6\30E0\30FB\30EA\30FC\30B8\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104828851688309109)
,p_name=>'CA.FORM.ON'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306E\30D5\30A9\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104841308291309119)
,p_name=>'CA.FORM.TYPE.NOT.VALID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30FC\30E0\306E\30BF\30A4\30D7\304C\6709\52B9\306A\30BF\30A4\30D7\3067\306F\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104847741894309123)
,p_name=>'CA.FORMATMASK'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F8\5F0F\30DE\30B9\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104846759572309123)
,p_name=>'CA.FORMCONTROL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30FC\30E0\30FB\30B3\30F3\30C8\30ED\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104812469918309097)
,p_name=>'CA.FROM'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104825630039309107)
,p_name=>'CA.FROM.ADDRESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\9001\4FE1\5143\30A2\30C9\30EC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104849272338309125)
,p_name=>'CA.FROM.ADDRESS.EMAIL.SETTING'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\9001\4FE1\5143\30A2\30C9\30EC\30B9\300D\96FB\5B50\30E1\30FC\30EB\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104845156251309121)
,p_name=>'CA.FROM.EMAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('\9001\4FE1\5143\96FB\5B50\30E1\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104845001461309121)
,p_name=>'CA.FROM.WHO'
,p_message_language=>'ja'
,p_message_text=>unistr('\5DEE\51FA\4EBA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104538081362308866)
,p_name=>'CA.FS.SEARCH.TABLE_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\691C\7D22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104815928832309100)
,p_name=>'CA.FULL.PAGE.VIEWS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5168\4F53\30DA\30FC\30B8\30FB\30D3\30E5\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104824689884309106)
,p_name=>'CA.FULL.TEMPLATE.HTML'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B8C\5168\30C6\30F3\30D7\30EC\30FC\30C8HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104846266055309122)
,p_name=>'CA.FUNCTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30F3\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104795538413309085)
,p_name=>'CA.GLOBAL.SEARCH'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30ED\30FC\30D0\30EB\691C\7D22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104793325098309083)
,p_name=>'CA.GLOBAL.SEARCH.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\691C\7D22\6A5F\80FD\306E\63D0\4F9B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104795456155309085)
,p_name=>'CA.GLOBAL.SEARCH.DETAIL'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5185\306E\4E3B\8981\306A\8868\307E\305F\306F\30D3\30E5\30FC\5168\4F53\3067\30C6\30AD\30B9\30C8\3092\691C\7D22\3067\304D\308B\3088\3046\306B\3057\307E\3059\3002\62E1\5F35\691C\7D22\30DA\30FC\30B8\306B\306F\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\7D50\679C\3092\7C21\5358\306B\7D5E\308A\8FBC\3081\308B\3088\3046\306B\3059\308B\30D5\30A3\30EB\30BF\304C\542B\307E\308C\307E\3059\3002<br>'),
unistr('\3053\306E\975E\5E38\306B\5F37\529B\306A\6A5F\80FD\3092\4F7F\7528\3059\308B\306B\306F\3001(\63D0\4F9B\3055\308C\3066\3044\308B\4F8B\306B\57FA\3065\3044\3066) SQL\3092\5B9A\7FA9\3059\308B\305F\3081\306E\958B\767A\4F5C\696D\304C\5FC5\8981\3067\3059\3002</p>'),
unistr('<p>\6B21\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\304C\542B\307E\308C\307E\3059:'),
'<ul>',
unistr('<li>\30D8\30C3\30C0\30FC\30FB\30D0\30FC\306E\691C\7D22\30A2\30A4\30B3\30F3\306E\8868\793A</li>'),
unistr('<li>\30B5\30A4\30C9\30FB\30D0\30FC\30FB\30D5\30A3\30EB\30BF\4ED8\304D\306E\8A73\7D30\691C\7D22\7D50\679C\30DA\30FC\30B8\306E\7D44\8FBC\307F</li>'),
unistr('<li>\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\691C\7D22\3092\5B9A\7FA9\3059\308B\305F\3081\306E\958B\767A\8005\306B\3088\308BSQL\306E\5B9F\88C5\304C\5FC5\8981</li>'),
unistr('<li>\5B9F\4F8B\306E\305F\3081\306E\30B5\30F3\30D7\30EB\30FB\30C7\30FC\30BF\306E\7D44\8FBC\307F</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104038188487308465)
,p_name=>'CA.GLOBAL.UID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30ED\30FC\30D0\30EB\4E00\610FID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104170538036308584)
,p_name=>'CA.GLOBAL_PAGE.NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30ED\30FC\30D0\30EB\30FB\30DA\30FC\30B8 - \30C7\30B9\30AF\30C8\30C3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103787944017308238)
,p_name=>'CA.GO.TO.ADMIN.PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\7BA1\7406\30DA\30FC\30B8\306B\79FB\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104802105188309090)
,p_name=>'CA.GRID'
,p_message_language=>'ja'
,p_message_text=>unistr('\5BFE\8A71\30B0\30EA\30C3\30C9\30FB\30DA\30FC\30B8\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104802294743309090)
,p_name=>'CA.GRID.DETAILS'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30B9\30D7\30EC\30C3\30C9\30B7\30FC\30C8\306B\4F3C\305F\5BFE\8A71\30B0\30EA\30C3\30C9\3068\3057\3066\8868\793A\3059\308B\30DA\30FC\30B8\3092\4F5C\6210\3057\307E\3059\3002\7DE8\96C6\53EF\80FD\306A\5834\5408\3001\30E6\30FC\30B6\30FC\306F\30DA\30FC\30B8\4E0A\3067\76F4\63A5\8907\6570\306E\884C\3092\7DE8\96C6\3067\304D\307E\3059(\3064\307E\308A\300C\7DE8\96C6\306E\8A31\53EF\300D\304C\6709\52B9\306A\5834\5408)\3002</p>'),
unistr('<p>\6B21\306E\5C5E\6027\3092\5165\529B\3057\307E\3059\3002</p>'),
'<ul>',
unistr('  <li><strong>\30DA\30FC\30B8\540D</strong>(\5FC5\9808) - \3053\306E\30DA\30FC\30B8\306E\540D\524D\3092\5165\529B\3057\307E\3059\3002</li>'),
unistr('  <li><strong>\30A2\30A4\30B3\30F3\306E\8A2D\5B9A</strong> - \3053\306E\30DA\30FC\30B8\306E\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC\306B\8868\793A\3059\308B\30A2\30A4\30B3\30F3\3092\9078\629E\3057\307E\3059\3002</li>'),
unistr('  <li><strong>\554F\5408\305B\30BF\30A4\30D7</strong> - \30EC\30DD\30FC\30C8\306E\30BD\30FC\30B9[<strong>\8868\307E\305F\306F\30D3\30E5\30FC</strong>\307E\305F\306F<strong>SQL\554F\5408\305B</strong>]\3092\9078\629E\3057\307E\3059\3002<br>'),
unistr('    <strong>\8868\307E\305F\306F\30D3\30E5\30FC</strong>:'),
'    <ul>',
unistr('      <li><strong>\8868\307E\305F\306F\30D3\30E5\30FC</strong>(\5FC5\9808) - \30B0\30EA\30C3\30C9\306E\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30AA\30D6\30B8\30A7\30AF\30C8\3092\9078\629E\3057\307E\3059\3002</li>'),
'    </ul>',
unistr('    <strong>SQL\554F\5408\305B</strong>:'),
'    <ul>',
unistr('      <li><strong>SQL\554F\5408\305B</strong>(\5FC5\9808) - \56FA\6709\306E\5217\3092\623B\3059\6709\52B9\306ASQL\6587\3092\5165\529B\3057\307E\3059\3002</li>'),
'    </ul>',
'  </li>',
unistr('  <li><strong>\30B0\30EA\30C3\30C9\30FB\30BF\30A4\30D7</strong> - \30E6\30FC\30B6\30FC\306B\30B0\30EA\30C3\30C9\5185\306E\884C\306E\7DE8\96C6\3092\8A31\53EF\3059\308B\304B\3069\3046\304B\3092\9078\629E\3057\307E\3059[<strong>\7DE8\96C6\306E\8A31\53EF</strong>\307E\305F\306F<strong>\8AAD\53D6\308A\5C02\7528</strong>]\3002\7DE8\96C6\3092\6709\52B9\306B\3059\308B\306B\306F\3001<strong>\300C\7DE8\96C6\306E\8A31\53EF\300D</strong>\3092\9078\629E\3057\307E\3059\3002</li>'),
'  &nbsp;<br>',
unistr('  <em><strong>\8B66\544A:</strong> \300C\554F\5408\305B\30BF\30A4\30D7\300D\306B<strong>\300CSQL\554F\5408\305B\300D</strong>\3092\3001\300C\30B0\30EA\30C3\30C9\30FB\30BF\30A4\30D7\300D\306B<strong>\300C\7DE8\96C6\306E\8A31\53EF\300D</strong>\3092\9078\629E\3057\3001\554F\5408\305B\30672\3064\4EE5\4E0A\306E\8868\3092\7D50\5408\3059\308B\3068\3001\30E6\30FC\30B6\30FC\304C\30EC\30B3\30FC\30C9\3092\66F4\65B0\3057\3088\3046\3068\3057\305F\3068\304D\306B\3001\751F\6210\3055\308C\305F\5BFE\8A71\30B0\30EA\30C3\30C9\306B\969C\5BB3\304C\767A\751F\3057\307E\3059\3002'),
unistr('\307E\305F\3001\300C\30B0\30EA\30C3\30C9\30FB\30BF\30A4\30D7\300D\306B<strong>\300C\7DE8\96C6\306E\8A31\53EF\300D</strong>\3092\9078\629E\3057\3001\554F\5408\305B(\307E\305F\306F\9078\629E\3057\305F\8868\307E\305F\306F\30D3\30E5\30FC)\3067\66F4\65B0\4E0D\53EF\80FD\306A\30D3\30E5\30FC\3092\4F7F\7528\3059\308B\3068\3001\30E6\30FC\30B6\30FC\304C\30EC\30B3\30FC\30C9\3092\66F4\65B0\3057\3088\3046\3068\3057\305F\3068\304D\306B\3001\751F\6210\3055\308C\305F\5BFE\8A71\30B0\30EA\30C3\30C9\306B\969C\5BB3\304C\767A\751F\3057\307E\3059\3002</em><br>'),
'  </li>',
'</ul>',
''))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104827499200309108)
,p_name=>'CA.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D8\30EB\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104717616923309015)
,p_name=>'CA.HELP.ACTIVITY.REPORTING.AUTOMATIONS.LOG'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30DA\30FC\30B8\3067\306F\3001\81EA\52D5\5316\30ED\30B0\306E\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\304C\63D0\4F9B\3055\308C\307E\3059\3002</p>'),
unistr('<p>\30ED\30B0\306B\8A18\9332\6E08\306E\524D\306E\81EA\52D5\5316\5B9F\884C\306B\95A2\3059\308B\60C5\5831\3092\78BA\8A8D\3057\307E\3059\3002\30ED\30B0\306B\306F\958B\59CB\30B9\30BF\30F3\30D7\3001\7D42\4E86\30B9\30BF\30F3\30D7\304A\3088\3073\51E6\7406\6E08\884C\306B\95A2\3059\308B\8A73\7D30(\6210\529F\3057\305F\884C\3068\30A8\30E9\30FC\306E\3042\308B\884C)\304C\542B\307E\308C\3066\3044\307E\3059\3002\30E1\30C3\30BB\30FC\30B8\306B\30C9\30EA\30EB\30C0\30A6\30F3\3057\3066\51E6\7406\3055\308C\305F\884C\306E\500B\3005\306E\30E1\30C3\30BB\30FC\30B8\3092\78BA\8A8D\3057\307E\3059\3002</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104819804595309103)
,p_name=>'CA.HELP.ALLOW.OTHER.USERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\306E\30E6\30FC\30B6\30FC\304C\30A2\30AF\30BB\30B9\5236\5FA1\30EA\30B9\30C8\306B\5B9A\7FA9\3055\308C\3066\3044\308B\5834\5408\3001<strong>\300C\3044\3044\3048\300D</strong>\3092\9078\629E\3057\307E\3059\3002\30A2\30AF\30BB\30B9\5236\5FA1\30EA\30B9\30C8\306B\5B58\5728\3057\306A\3044\8A8D\8A3C\3055\308C\305F\30E6\30FC\30B6\30FC\3082\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\4F7F\7528\3059\308B\5834\5408\3001<strong>\300C\306F\3044\300D</strong>\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104813598662309098)
,p_name=>'CA.HELP.APP.NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\3053\3067\5165\529B\3057\305F\30C6\30AD\30B9\30C8\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5168\4F53(\7279\306B\3001\3059\3079\3066\306E\30DA\30FC\30B8\306E\5DE6\4E0A\9685)\3067\4F7F\7528\3055\308C\307E\3059\3002\5909\66F4\306F\3001\5909\66F4\3092\884C\3063\305F\7BA1\7406\8005\306B\5BFE\3057\3066\306F\5373\5EA7\306B\6709\52B9\306B\306A\308A\307E\3059\304C\3001\4ED6\306E\30E6\30FC\30B6\30FC\306F\3001\65B0\3057\3044\30BB\30C3\30B7\30E7\30F3\3092\958B\59CB\3057\305F\3068\304D(\6B21\56DE\30ED\30B0\30A4\30F3\6642\306A\3069)\306B\306E\307F\305D\306E\5909\66F4\3092\78BA\8A8D\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104808112514309094)
,p_name=>'CA.HELP.HOME.FEEDBACK'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\3069\306E\30DA\30FC\30B8\304B\3089\3067\3082\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30D0\30FC\306E\30D5\30A3\30FC\30C9\30D0\30C3\30AF\30FB\30A2\30A4\30B3\30F3( <span class="fa fa-comment-o" aria-hidden="true"></span> )\3092\30AF\30EA\30C3\30AF\3057\3066\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\7BA1\7406\8005\306B\30D5\30A3\30FC\30C9\30D0\30C3\30AF\3092\6B8B\3059\3053\3068\304C\3067\304D\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104807812234309094)
,p_name=>'CA.HELP.HOME.MAIN.SIDE.MENU'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\3053\308C\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30DB\30FC\30E0\30DA\30FC\30B8\3067\3059\3002\30AB\30FC\30C9\3092\30AF\30EA\30C3\30AF\3057\3066\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5185\306E\7570\306A\308B\30DA\30FC\30B8\306B\30A2\30AF\30BB\30B9\3059\308B\304B\3001\30DA\30FC\30B8\306E\6A2A\5074\306B\3042\308B\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC\3092\4F7F\7528\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104808079837309094)
,p_name=>'CA.HELP.HOME.MAIN.TOP.MENU'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\3053\308C\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30DB\30FC\30E0\30DA\30FC\30B8\3067\3059\3002\30AB\30FC\30C9\3092\30AF\30EA\30C3\30AF\3057\3066\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5185\306E\7570\306A\308B\30DA\30FC\30B8\306B\30A2\30AF\30BB\30B9\3059\308B\304B\3001\30DA\30FC\30B8\306E\4E00\756A\4E0A\306B\3042\308B\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC\3092\4F7F\7528\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104808227610309094)
,p_name=>'CA.HELP.HOME.SEARCH'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\3053\306E\30DA\30FC\30B8\306E<strong>\300C\691C\7D22\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\300D</strong>\30D5\30A3\30FC\30EB\30C9\306B\691C\7D22\6587\5B57\5217\3092\5165\529B\3059\308B\304B\3001\4EFB\610F\306E\30DA\30FC\30B8\304B\3089\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30D0\30FC\306E\691C\7D22\30A2\30A4\30B3\30F3( <span class="fa fa-search" aria-hidden="true"></span> )\3092\30AF\30EA\30C3\30AF\3057\3066\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5185\3067\8A9E\53E5\3092\691C\7D22\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104808518660309094)
,p_name=>'CA.HELP.HOME.SIGN.OUT'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30D0\30FC\306E\81EA\5206\306E\540D\524D\306E\30C9\30ED\30C3\30D7\30C0\30A6\30F3\3092\30AF\30EA\30C3\30AF\3057\3066\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304B\3089\30B5\30A4\30F3\30A2\30A6\30C8\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104808474662309094)
,p_name=>'CA.HELP.HOME.TIME'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30D0\30FC\306E\30E6\30FC\30B6\30FC\30FB\30E1\30CB\30E5\30FC( <span class="fa fa-user" aria-hidden="true"></span> )\3092\30AF\30EA\30C3\30AF\3057\3066\3001\30BF\30A4\30E0\30BE\30FC\30F3\30FB\30D7\30EA\30D5\30A1\30EC\30F3\30B9\306E\66F4\65B0\3068\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304B\3089\306E\30B5\30A4\30F3\30A2\30A6\30C8\3092\884C\3044\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104807907317309094)
,p_name=>'CA.HELP.HOME.TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DB\30FC\30E0\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104808638791309094)
,p_name=>'CA.HELP.HOME.USER'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30D0\30FC(\30DA\30FC\30B8\306E\53F3\4E0A)\306E\30E6\30FC\30B6\30FC\30FB\30E1\30CB\30E5\30FC( <span class="fa fa-user" aria-hidden="true"></span> )\3092\30AF\30EA\30C3\30AF\3057\3066\3001\30E6\30FC\30B6\30FC\30FB\30D7\30ED\30D5\30A1\30A4\30EB\3078\306E\30A2\30AF\30BB\30B9\3068\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304B\3089\306E\30B5\30A4\30F3\30A2\30A6\30C8\3092\884C\3044\307E\3059\3002<br>'),
unistr('<strong>\300C\30D7\30ED\30D5\30A1\30A4\30EB\306E\8868\793A\300D</strong>\3092\30AF\30EA\30C3\30AF\3059\308B\5834\5408\3001<strong>\300C\30D7\30ED\30D5\30A1\30A4\30EB\306E\66F4\65B0\300D</strong>\3092\30AF\30EA\30C3\30AF\3057\3001\500B\4EBA\60C5\5831\306E\8A73\7D30\3092\5165\529B\3057\3066\5199\771F\3084\30A2\30D0\30BF\30FC\3092\30A2\30C3\30D7\30ED\30FC\30C9\3067\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104808364852309094)
,p_name=>'CA.HELP.HOME.USER.TIME'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30D0\30FC\306E\30E6\30FC\30B6\30FC\30FB\30E1\30CB\30E5\30FC( <span class="fa fa-user" aria-hidden="true"></span> )\3092\30AF\30EA\30C3\30AF\3057\3066\3001\30E6\30FC\30B6\30FC\30FB\30D7\30ED\30D5\30A1\30A4\30EB\3078\306E\30A2\30AF\30BB\30B9\3001\30BF\30A4\30E0\30BE\30FC\30F3\30FB\30D7\30EA\30D5\30A1\30EC\30F3\30B9\306E\66F4\65B0\3001\304A\3088\3073\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304B\3089\306E\30B5\30A4\30F3\30A2\30A6\30C8\3092\884C\3044\307E\3059\3002<br>'),
unistr('<strong>\300C\30D7\30ED\30D5\30A1\30A4\30EB\306E\8868\793A\300D</strong>\3092\30AF\30EA\30C3\30AF\3059\308B\5834\5408\3001<strong>\300C\30D7\30ED\30D5\30A1\30A4\30EB\306E\66F4\65B0\300D</strong>\3092\30AF\30EA\30C3\30AF\3057\3001\500B\4EBA\60C5\5831\306E\8A73\7D30\3092\5165\529B\3057\3066\5199\771F\3084\30A2\30D0\30BF\30FC\3092\30A2\30C3\30D7\30ED\30FC\30C9\3067\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104834495175309113)
,p_name=>'CA.HELP.IG.PAGE.READONLY'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30C7\30FC\30BF\3092\898B\3064\3051\308B\306B\306F\3001\691C\7D22\30C0\30A4\30A2\30ED\30B0\306B\691C\7D22\6587\5B57\5217\3092\5165\529B\3059\308B\304B\3001\5217\30D8\30C3\30C0\30FC\3092\30AF\30EA\30C3\30AF\3057\3066\623B\3055\308C\308B\30EC\30B3\30FC\30C9\3092\5236\9650\3057\307E\3059\3002</p>'),
'',
unistr('<p><strong>\300C\30A2\30AF\30B7\30E7\30F3\300D</strong>\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\591A\304F\306E\6A5F\80FD\3092\5B9F\884C\3067\304D\307E\3059\3002\3053\308C\306B\306F\3001\8868\793A\5217\307E\305F\306F\975E\8868\793A\5217\306E\9078\629E\3068\305D\306E\8868\793A\9806\5E8F\306B\52A0\3048\3001\591A\304F\306E\30C7\30FC\30BF\304A\3088\3073\66F8\5F0F\8A2D\5B9A\6A5F\80FD\304C\542B\307E\308C\307E\3059\3002\30C1\30E3\30FC\30C8\30FB\30AA\30D7\30B7\30E7\30F3\3092\4F7F\7528\3057\3066\3001\30C7\30FC\30BF\306E\8FFD\52A0\30D3\30E5\30FC\3092\5B9A\7FA9\3059\308B\3053\3068\3082\3067\304D\307E\3059\3002</p>'),
'',
unistr('<p>\72EC\81EA\306E\30AB\30B9\30BF\30DE\30A4\30BA\5185\5BB9\3092\4FDD\5B58\3059\308B\5834\5408\3001\30EC\30DD\30FC\30C8\3092\9078\629E\3059\308B\304B\3001\300C\30C0\30A6\30F3\30ED\30FC\30C9\300D\3092\30AF\30EA\30C3\30AF\3057\3066\30C7\30FC\30BF\3092\30A2\30F3\30ED\30FC\30C9\3057\307E\3059\3002<p>'),
'<br>',
unistr('<p>\8FFD\52A0\60C5\5831\3092\5165\624B\3059\308B\306B\306F\3001\300C\30A2\30AF\30B7\30E7\30F3\300D\30E1\30CB\30E5\30FC\306E\4E00\756A\4E0B\306E\300C\30D8\30EB\30D7\300D\3092\30AF\30EA\30C3\30AF\3057\307E\3059\3002</p>'),
'',
unistr('<p><strong>\300C\30EA\30BB\30C3\30C8\300D</strong>\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\3092\30C7\30D5\30A9\30EB\30C8\8A2D\5B9A\306B\623B\3059\3053\3068\304C\3067\304D\307E\3059\3002</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104834393957309113)
,p_name=>'CA.HELP.IG.PAGE.UPDATABLE'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\5BFE\8A71\30B0\30EA\30C3\30C9\5185\3067\30C7\30FC\30BF\3092\76F4\63A5\633F\5165\3001\66F4\65B0\304A\3088\3073\524A\9664\3067\304D\307E\3059\3002<br>'),
unistr('  \300C\884C\306E\8FFD\52A0\300D\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\65B0\3057\3044\884C\3092\633F\5165\3067\304D\307E\3059\3002<br>'),
unistr('  \30BB\30EB\5185\3092\30C0\30D6\30EB\30AF\30EA\30C3\30AF\3059\308B\304B\3001<strong>\300C\7DE8\96C6\300D</strong>\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\30B9\30D7\30EC\30C3\30C9\30B7\30FC\30C8\3067\30C7\30FC\30BF\3092\7DE8\96C6\3059\308B\5834\5408\3068\540C\3058\3088\3046\306B\30C7\30FC\30BF\5024\3092\66F4\65B0\3067\304D\307E\3059\3002</p>'),
'',
unistr('<p>\30EC\30DD\30FC\30C8\306E\4E00\756A\4E0A\306B\3042\308B\300C\884C\30A2\30AF\30B7\30E7\30F3\300D\30E1\30CB\30E5\30FC(<span class="fa fa-bars" aria-hidden="true"></span>)\3092\4F7F\7528\3057\3066\3001\9078\629E\3057\305F\884C\3092\8907\88FD\3001\524A\9664\3001\30EA\30D5\30EC\30C3\30B7\30E5\307E\305F\306F\56DE\5FA9\3057\307E\3059\3002<br>'),
unistr('  \500B\3005\306E\884C\306E\300C\884C\30A2\30AF\30B7\30E7\30F3\300D\30E1\30CB\30E5\30FC\3092\4F7F\7528\3057\3066\3001\5358\4E00\884C\30D3\30E5\30FC\306B\30A2\30AF\30BB\30B9\3057\305F\308A\3001\65B0\3057\3044\884C\3092\8FFD\52A0\3057\305F\308A\3059\308B\3053\3068\3082\3067\304D\307E\3059\3002</p>'),
'',
unistr('<p>\30C7\30FC\30BF\3092\898B\3064\3051\308B\306B\306F\3001\691C\7D22\30C0\30A4\30A2\30ED\30B0\306B\691C\7D22\6587\5B57\5217\3092\5165\529B\3059\308B\304B\3001\5217\30D8\30C3\30C0\30FC\3092\30AF\30EA\30C3\30AF\3057\3066\623B\3055\308C\308B\30EC\30B3\30FC\30C9\3092\5236\9650\3057\307E\3059\3002</p>'),
'',
unistr('<p><strong>\300C\30A2\30AF\30B7\30E7\30F3\300D</strong>\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\591A\304F\306E\6A5F\80FD\3092\5B9F\884C\3067\304D\307E\3059\3002\3053\308C\306B\306F\3001\8868\793A\5217\307E\305F\306F\975E\8868\793A\5217\306E\9078\629E\3068\305D\306E\8868\793A\9806\5E8F\306B\52A0\3048\3001\591A\304F\306E\30C7\30FC\30BF\304A\3088\3073\66F8\5F0F\8A2D\5B9A\6A5F\80FD\304C\542B\307E\308C\307E\3059\3002\30C1\30E3\30FC\30C8\30FB\30AA\30D7\30B7\30E7\30F3\3092\4F7F\7528\3057\3066\3001\30C7\30FC\30BF\306E\8FFD\52A0\30D3\30E5\30FC\3092\5B9A\7FA9\3059\308B\3053\3068\3082\3067\304D\307E\3059\3002</p>'),
'',
unistr('<p>\72EC\81EA\306E\30AB\30B9\30BF\30DE\30A4\30BA\5185\5BB9\3092\4FDD\5B58\3059\308B\5834\5408\3001\30EC\30DD\30FC\30C8\3092\9078\629E\3059\308B\304B\3001\300C\30C0\30A6\30F3\30ED\30FC\30C9\300D\3092\30AF\30EA\30C3\30AF\3057\3066\30C7\30FC\30BF\3092\30A2\30F3\30ED\30FC\30C9\3057\307E\3059\3002<p>'),
'',
unistr('<p>\8FFD\52A0\60C5\5831\3092\5165\624B\3059\308B\306B\306F\3001\300C\30A2\30AF\30B7\30E7\30F3\300D\30E1\30CB\30E5\30FC\306E\4E00\756A\4E0B\306E\300C\30D8\30EB\30D7\300D\3092\30AF\30EA\30C3\30AF\3057\307E\3059\3002</p>'),
'',
unistr('<p><strong>\300C\30EA\30BB\30C3\30C8\300D</strong>\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\5BFE\8A71\30B0\30EA\30C3\30C9\3092\30C7\30D5\30A9\30EB\30C8\8A2D\5B9A\306B\623B\3059\3053\3068\304C\3067\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104807781699309094)
,p_name=>'CA.HELP.IR.PAGE'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30C7\30FC\30BF\3092\898B\3064\3051\308B\306B\306F\3001\691C\7D22\30C0\30A4\30A2\30ED\30B0\306B\691C\7D22\6587\5B57\5217\3092\5165\529B\3059\308B\304B\3001\5217\30D8\30C3\30C0\30FC\3092\30AF\30EA\30C3\30AF\3057\3066\623B\3055\308C\308B\30EC\30B3\30FC\30C9\3092\5236\9650\3057\307E\3059\3002</p>'),
'',
unistr('<p><strong>\300C\30A2\30AF\30B7\30E7\30F3\300D</strong>\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\591A\304F\306E\6A5F\80FD\3092\5B9F\884C\3067\304D\307E\3059\3002\3053\308C\306B\306F\3001\8868\793A\5217\307E\305F\306F\975E\8868\793A\5217\306E\9078\629E\3068\305D\306E\8868\793A\9806\5E8F\306B\52A0\3048\3001\591A\304F\306E\30C7\30FC\30BF\304A\3088\3073\66F8\5F0F\8A2D\5B9A\6A5F\80FD\304C\542B\307E\308C\307E\3059\3002\30C1\30E3\30FC\30C8\3001\30B0\30EB\30FC\30D7\5316\304A\3088\3073\30D4\30DC\30C3\30C8\30FB\30AA\30D7\30B7\30E7\30F3\3092\4F7F\7528\3057\3066\3001\30C7\30FC\30BF\306E\8FFD\52A0\30D3\30E5\30FC\3092\5B9A\7FA9\3059\308B\3053\3068\3082\3067\304D\307E\3059\3002</p>'),
'',
unistr('<p>\72EC\81EA\306E\30AB\30B9\30BF\30DE\30A4\30BA\5185\5BB9\3092\4FDD\5B58\3059\308B\5834\5408\3001\30EC\30DD\30FC\30C8\3092\9078\629E\3059\308B\304B\3001\300C\30C0\30A6\30F3\30ED\30FC\30C9\300D\3092\30AF\30EA\30C3\30AF\3057\3066\30C7\30FC\30BF\3092\30A2\30F3\30ED\30FC\30C9\3057\307E\3059\3002\5B9A\671F\7684\306B\30C7\30FC\30BF\3092\9001\4FE1\3059\308B\30B5\30D6\30B9\30AF\30EA\30D7\30B7\30E7\30F3\3067\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9\3068\6642\9593\67A0\3092\5165\529B\3057\307E\3059\3002<p>'),
'',
unistr('<p>\8FFD\52A0\60C5\5831\3092\5165\624B\3059\308B\306B\306F\3001\300C\30A2\30AF\30B7\30E7\30F3\300D\30E1\30CB\30E5\30FC\306E\4E00\756A\4E0B\306E\300C\30D8\30EB\30D7\300D\3092\30AF\30EA\30C3\30AF\3057\307E\3059\3002</p>'),
'',
unistr('<p><strong>\300C\30EA\30BB\30C3\30C8\300D</strong>\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\3092\30C7\30D5\30A9\30EB\30C8\8A2D\5B9A\306B\623B\3059\3053\3068\304C\3067\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104842337561309119)
,p_name=>'CA.HELP.MD.PAGE'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30EC\30DD\30FC\30C8\30FB\30DA\30FC\30B8\3067\306F\3001\30DA\30FC\30B8\306E\7AEF\306B\3042\308B\30BB\30EC\30AF\30BF\306B\30D7\30E9\30A4\30DE\30EA\30FB\30EC\30B3\30FC\30C9\304C\8868\793A\3055\308C\307E\3059\3002'),
unistr('  \30EC\30B3\30FC\30C9\3092\9078\629E\3057\3066\3001\30DE\30B9\30BF\30FC\30FB\30EC\30B3\30FC\30C9\304A\3088\3073\5B9A\7FA9\3055\308C\3066\3044\308B\30C7\30A3\30C6\30FC\30EB\30FB\30EC\30B3\30FC\30C9\3092\8868\793A\3057\307E\3059\3002<br> '),
unistr('  \7DE8\96C6\30A2\30A4\30B3\30F3(<span class="fa fa-pencil-square-o" aria-hidden="true"></span>)\3092\30AF\30EA\30C3\30AF\3057\3066\30DE\30B9\30BF\30FC\30FB\30EC\30B3\30FC\30C9\3092\7DE8\96C6\3057\307E\3059\3002'),
unistr('  \30C7\30A3\30C6\30FC\30EB\30FB\30EC\30B3\30FC\30C9\306E\5834\5408\306F\3001\5404\884C\306E\5148\982D\306B\3042\308B\925B\7B46\3092\30AF\30EA\30C3\30AF\3057\3066\3001\305D\306E\30EC\30B3\30FC\30C9\3092\7DE8\96C6\3057\307E\3059\3002</p>'),
unistr('<p>\30BB\30EC\30AF\30BF\306B\8868\793A\3055\308C\308B\30C7\30FC\30BF\3092\5236\9650\3059\308B\306B\306F\3001\691C\7D22\30C0\30A4\30A2\30ED\30B0\306B\691C\7D22\8A9E\3092\5165\529B\3057\307E\3059\3002</p>'),
'',
unistr('<p>\65B0\3057\3044\30DE\30B9\30BF\30FC\30FB\30EC\30B3\30FC\30C9\3092\8FFD\52A0\3059\308B\306B\306F\3001\30DA\30FC\30B8\306E\4E0A\90E8\306B\3042\308B<strong>\300C\4F5C\6210\300D</strong>\3092\30AF\30EA\30C3\30AF\3057\307E\3059\3002'),
unistr('  \30C7\30A3\30C6\30FC\30EB\30FB\30EC\30B3\30FC\30C9\306E\5834\5408\306F\3001\30C7\30A3\30C6\30FC\30EB\30FB\30EA\30FC\30B8\30E7\30F3\306E\4E0A\90E8\306B\3042\308B\30D7\30E9\30B9\30FB\30A2\30A4\30B3\30F3(+)\3092\30AF\30EA\30C3\30AF\3057\3066\3001\30C7\30A3\30C6\30FC\30EB\30FB\30EC\30B3\30FC\30C9\3092\8FFD\52A0\3057\307E\3059\3002</p>'),
'',
unistr('<p>\30DA\30FC\30B8\306E\4E0A\90E8\306B\3042\308B<strong>\300C\30EA\30BB\30C3\30C8\300D</strong>\3092\30AF\30EA\30C3\30AF\3057\3066\3001\30DA\30FC\30B8\3092\30C7\30D5\30A9\30EB\30C8\8A2D\5B9A\306B\30EA\30BB\30C3\30C8\3057\3001\524D\306B\5B9A\7FA9\3057\305F\691C\7D22\8A9E\3092\524A\9664\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104805736838309092)
,p_name=>'CA.HELP.P10000.ADMINISTRATION.PAGE'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\7BA1\7406\30DA\30FC\30B8\3067\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\6240\6709\8005(\7BA1\7406\8005)\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\69CB\6210\3057\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5168\4F53\3067\4F7F\7528\3055\308C\308B\5171\901A\30C7\30FC\30BF\3092\7BA1\7406\3067\304D\307E\3059\3002'),
unistr('\7BA1\7406\8005\306F\3001\4F7F\7528\53EF\80FD\306A\8A2D\5B9A\306E\3044\305A\308C\304B\3092\9078\629E\3057\3066\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\8868\793A\65B9\6CD5\307E\305F\306F\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\4F7F\7528\53EF\80FD\306A\6A5F\80FD(\3042\308B\3044\306F\305D\306E\4E21\65B9)\3092\5FC5\8981\306B\5FDC\3058\3066\5909\66F4\3067\304D\307E\3059\3002</p>'),
unistr('<p>\3053\306E\30DA\30FC\30B8\3078\306E\30A2\30AF\30BB\30B9\306F\3001\7BA1\7406\8005\306E\307F\306B\5236\9650\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104806981594309093)
,p_name=>'CA.HELP.P10100.ACCESS.CONTROL.CONFIGURE'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8A8D\8A3C\3055\308C\305F\30E6\30FC\30B6\30FC\306E\9069\5207\306A\9078\629E\9805\76EE\3092\9078\629E\3057\307E\3059\3002<br>'),
unistr('<strong>\300C\3044\3044\3048\300D</strong>\3092\9078\629E\3059\308B\3068\3001\6307\5B9A\3057\305F\30E6\30FC\30B6\30FC\306E\307F\304C\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\30A2\30AF\30BB\30B9\3067\304D\308B\3053\3068\306B\306A\308B\305F\3081\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30BB\30AD\30E5\30EA\30C6\30A3\304C\5411\4E0A\3057\307E\3059\3002'),
unistr('\305F\3060\3057\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304C\5927\898F\6A21\306A\30E6\30FC\30B6\30FC\30FB\30B3\30DF\30E5\30CB\30C6\30A3\3092\6301\3063\3066\3044\308B\5834\5408\306F\3001\30E6\30FC\30B6\30FC\306E\7BA1\7406\304C\8CA0\62C5\306B\306A\308B\53EF\80FD\6027\304C\3042\308B\305F\3081\3001<strong>\300C\306F\3044\300D</strong>\3092\512A\5148\7684\306B\9078\629E\3057\3066\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\7BA1\7406\8005\3068\30B3\30F3\30C8\30EA\30D3\30E5\30FC\30BF\306E\307F\3092\5165\529B\3067\304D\307E\3059\3002<br>'),
unistr('<strong>\300C\306F\3044\300D</strong>\3092\9078\629E\3059\308B\5834\5408\3001\30E6\30FC\30B6\30FC\30FB\30EA\30B9\30C8\306B\542B\3081\306A\3044\30E6\30FC\30B6\30FC\306E\51E6\7406\65B9\6CD5\3082\9078\629E\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>'),
unistr('<p>\30E6\30FC\30B6\30FC\540D\306B\5BFE\3057\3066\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9\3092\8981\6C42\3059\308B\304B\3001\4EFB\610F\306E\82F1\6570\5B57\5024\3092\4F7F\7528\53EF\80FD\306B\3059\308B\304B\3092\9078\629E\3057\307E\3059\3002<br>'),
unistr('\901A\5E38\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067Oracle Access Manager\3084SSO\306A\3069\306E\4E2D\592E\7BA1\7406\8A8D\8A3C\30B9\30AD\30FC\30E0\3092\4F7F\7528\3057\3066\3044\308B(\307E\305F\306F\5C06\6765\4F7F\7528\3059\308B\3088\3046\306B\69CB\6210\3059\308B)\5834\5408\3001\3053\306E\8A2D\5B9A\306F<strong>\300C\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9\300D</strong>\306B\8A2D\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>'),
unistr('<p><em><strong>\30CE\30FC\30C8:</strong> \3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\306F\3001\30EA\30FC\30C0\30FC\3001\30B3\30F3\30C8\30EA\30D3\30E5\30FC\30BF\304A\3088\3073\7BA1\7406\8005\3068\3044\30463\3064\306E\30A2\30AF\30BB\30B9\30FB\30EC\30D9\30EB\304C\30B5\30DD\30FC\30C8\3055\308C\307E\3059\3002'),
'<ul>',
unistr('  <li><strong>\30EA\30FC\30C0\30FC</strong>\306F\3001\3059\3079\3066\306E\60C5\5831\306B\5BFE\3059\308B\8AAD\53D6\308A\5C02\7528\30A2\30AF\30BB\30B9\6A29\3092\6301\3061\3001\30EC\30DD\30FC\30C8\3092\53C2\7167\3067\304D\307E\3059\3002</li>'),
unistr('  <li><strong>\30B3\30F3\30C8\30EA\30D3\30E5\30FC\30BF</strong>\306F\3001\60C5\5831\306E\4F5C\6210\3001\7DE8\96C6\304A\3088\3073\524A\9664\304C\53EF\80FD\3067\3001\30EC\30DD\30FC\30C8\3092\53C2\7167\3067\304D\307E\3059\3002</li>'),
unistr('  <li><strong>\7BA1\7406\8005</strong>\306F\3001\30B3\30F3\30C8\30EA\30D3\30E5\30FC\30BF\306E\6A5F\80FD\306B\52A0\3048\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\300C\7BA1\7406\300D\30BB\30AF\30B7\30E7\30F3\306B\30A2\30AF\30BB\30B9\3057\3066\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\69CB\6210\3092\5B9F\884C\3067\304D\307E\3059\3002</li>'),
'</ul>',
'</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104807165877309093)
,p_name=>'CA.HELP.P10100.ACCESS.CONTROL.USERS.FORM'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30D5\30A9\30FC\30E0\3092\4F7F\7528\3057\3066\3001\30E6\30FC\30B6\30FC\3068\305D\306E\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9\3092\5165\529B\3057\3001\30A2\30AF\30BB\30B9\30FB\30EC\30D9\30EB\3092\8A2D\5B9A\3057\307E\3059\3002'),
unistr('<em>\300C\30A2\30AF\30BB\30B9\5236\5FA1\306E\69CB\6210\300D</em>\3067\5B9A\7FA9\3057\305F\8A2D\5B9A\306B\3088\3063\3066\3001\30E6\30FC\30B6\30FC\540D\3092\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9\306B\3059\308B\5FC5\8981\304C\3042\308B\304B\3001\4EFB\610F\306E\82F1\6570\5B57\5165\529B\3092\53EF\80FD\306B\3059\308B\304B\304C\6C7A\5B9A\3055\308C\307E\3059\3002</p>'),
unistr('<p>\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\306F\3001\30EA\30FC\30C0\30FC\3001\30B3\30F3\30C8\30EA\30D3\30E5\30FC\30BF\304A\3088\3073\7BA1\7406\8005\3068\3044\30463\3064\306E\30A2\30AF\30BB\30B9\30FB\30EC\30D9\30EB\304C\30B5\30DD\30FC\30C8\3055\308C\307E\3059\3002</p>'),
'<ul>',
unistr('  <li><strong>\30EA\30FC\30C0\30FC</strong>\306F\3001\3059\3079\3066\306E\60C5\5831\306B\5BFE\3059\308B\8AAD\53D6\308A\5C02\7528\30A2\30AF\30BB\30B9\6A29\3092\6301\3061\3001\30EC\30DD\30FC\30C8\3092\53C2\7167\3067\304D\307E\3059\3002</li>'),
unistr('  <li><strong>\30B3\30F3\30C8\30EA\30D3\30E5\30FC\30BF</strong>\306F\3001\60C5\5831\306E\4F5C\6210\3001\7DE8\96C6\304A\3088\3073\524A\9664\304C\53EF\80FD\3067\3001\30EC\30DD\30FC\30C8\3092\53C2\7167\3067\304D\307E\3059\3002</li>'),
unistr('  <li><strong>\7BA1\7406\8005</strong>\306F\3001\30B3\30F3\30C8\30EA\30D3\30E5\30FC\30BF\306E\6A5F\80FD\306B\52A0\3048\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\300C\7BA1\7406\300D\30BB\30AF\30B7\30E7\30F3\306B\30A2\30AF\30BB\30B9\3057\3066\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\69CB\6210\3092\5B9F\884C\3067\304D\307E\3059\3002</li>'),
'</ul>',
unistr('<p>\65E2\5B58\306E\30E6\30FC\30B6\30FC\3092\7DE8\96C6\3059\308B\5834\5408\3001\305D\306E\30A2\30AB\30A6\30F3\30C8\304C\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\30A2\30AF\30BB\30B9\3057\306A\3044\3088\3046\306B\30ED\30C3\30AF\3067\304D\307E\3059\3002</p>'),
unistr('<p><em><strong>\30CE\30FC\30C8:</strong> Oracle Application Express\30A2\30AB\30A6\30F3\30C8\3092\4F7F\7528\3059\308B\5834\5408\3001\3053\3053\3067\5165\529B\3059\308B\30E6\30FC\30B6\30FC\306F\3001\305D\306E\30D1\30B9\30EF\30FC\30C9\3082\8A2D\5B9A\3067\304D\308B\30EF\30FC\30AF\30B9\30DA\30FC\30B9\7BA1\7406\8005\306B\3088\3063\3066\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\3068\3057\3066\5B9A\7FA9\3055\308C\3066\3044\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104807030045309093)
,p_name=>'CA.HELP.P10110.ACCESS.CONTROL.USERS.REPORT'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30DA\30FC\30B8\306B\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30E6\30FC\30B6\30FC\3068\4ED8\4E0E\3055\308C\3066\3044\308B\30A2\30AF\30BB\30B9\30FB\30EC\30D9\30EB\306E\30EC\30DD\30FC\30C8\304C\8868\793A\3055\308C\307E\3059\3002</p>'),
unistr('<p>\5217\30D8\30C3\30C0\30FC\3092\30AF\30EA\30C3\30AF\3057\3066\30C7\30FC\30BF\3092\30BD\30FC\30C8\304A\3088\3073\30D5\30A3\30EB\30BF\3059\308B\304B\3001<strong>\300C\30A2\30AF\30B7\30E7\30F3\300D</strong>\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3057\3066\5217\8868\793A\3068\591A\304F\306E\8FFD\52A0\306E\62E1\5F35\6A5F\80FD\3092\30AB\30B9\30BF\30DE\30A4\30BA\3057\307E\3059\3002<br>'),
unistr('<strong>\300C\30EA\30BB\30C3\30C8\300D</strong>\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\3092\30C7\30D5\30A9\30EB\30C8\8A2D\5B9A\306B\623B\3059\3053\3068\304C\3067\304D\307E\3059\3002</p>'),
unistr('<p>\7DE8\96C6\30A2\30A4\30B3\30F3(\9EC4\8272\306E\925B\7B46)\3092\30AF\30EA\30C3\30AF\3057\3066\30E6\30FC\30B6\30FC\306E\8A73\7D30\3068\30A2\30AF\30BB\30B9\30FB\30EC\30D9\30EB\3092\7DE8\96C6\3059\308B\304B\3001\30E6\30FC\30B6\30FC\3092\524A\9664\3057\307E\3059\3002</p>'),
unistr('<p>\30EC\30DD\30FC\30C8\306E\4E00\756A\4E0A\306B\3042\308B<strong>\300C\30E6\30FC\30B6\30FC\306E\8FFD\52A0\300D</strong>\3092\30AF\30EA\30C3\30AF\3057\3066\3001\65B0\3057\3044\30E6\30FC\30B6\30FC\3068\305D\306E\30A2\30AF\30BB\30B9\30FB\30EC\30D9\30EB\3092\8FFD\52A0\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104820556810309103)
,p_name=>'CA.HELP.P10120.ACCESS.ROLE'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30A2\30AF\30BB\30B9\5236\5FA1\304C\6709\52B9\306A\5834\5408\3001\7BA1\7406\8005\306F\3001\7279\5B9A\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\6A5F\80FD\3078\306E\30A2\30AF\30BB\30B9\3092\8A8D\8A3C\3055\308C\305F\30E6\30FC\30B6\30FC\306B\5236\9650\3067\304D\307E\3059\3002\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\306F\3001\30EA\30FC\30C0\30FC\3001\30B3\30F3\30C8\30EA\30D3\30E5\30FC\30BF\304A\3088\3073\7BA1\7406\8005\3068\3044\30463\3064\306E\30ED\30FC\30EB\304C\30B5\30DD\30FC\30C8\3055\308C\307E\3059\3002<p>'),
'<ul>',
unistr('  <li><strong>\30EA\30FC\30C0\30FC</strong>\306F\3001\3059\3079\3066\306E\60C5\5831\306B\5BFE\3059\308B\8AAD\53D6\308A\5C02\7528\30A2\30AF\30BB\30B9\6A29\3092\6301\3061\3001\30EC\30DD\30FC\30C8\3092\53C2\7167\3067\304D\307E\3059\3002</li>'),
unistr('  <li><strong>\30B3\30F3\30C8\30EA\30D3\30E5\30FC\30BF</strong>\306F\3001\60C5\5831\306E\4F5C\6210\3001\7DE8\96C6\304A\3088\3073\524A\9664\304C\53EF\80FD\3067\3001\30EC\30DD\30FC\30C8\3092\53C2\7167\3067\304D\307E\3059\3002</li>'),
unistr('  <li><strong>\7BA1\7406\8005</strong>\306F\3001\30B3\30F3\30C8\30EA\30D3\30E5\30FC\30BF\306E\6A5F\80FD\306B\52A0\3048\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\69CB\6210\3092\5B9F\884C\3067\304D\307E\3059\3002</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104841442055309119)
,p_name=>'CA.HELP.P10140_PRELIM_USERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30F3\30DE\3001\30BB\30DF\30B3\30ED\30F3\307E\305F\306F\7A7A\767D\3067\533A\5207\3063\305F\30E6\30FC\30B6\30FC\540D\3092\5165\529B\3057\307E\3059\3002\65E2\5B58\307E\305F\306F\91CD\8907\3059\308B\30E6\30FC\30B6\30FC\540D\306F\81EA\52D5\7684\306B\7121\8996\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104805902266309093)
,p_name=>'CA.HELP.P10200.CONFIGURATION.SETTINGS'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\69CB\6210\8A2D\5B9A\306B\3088\3063\3066\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\5BFE\3057\3066\7279\5B9A\306E\6A5F\80FD\3092\4F7F\7528\53EF\80FD(\6709\52B9)\306B\3059\308B\304B\3001\4F7F\7528\4E0D\53EF(\7121\52B9)\306B\3059\308B\3053\3068\304C\3067\304D\307E\3059\3002</p>'),
unistr('<p>\7279\5B9A\306E\6A5F\80FD\3092100%\6E96\5099\3067\304D\3066\3044\306A\3044\5834\5408\3001\307E\305F\306F\4E00\6642\7684\306B\524A\9664\3059\308B\5FC5\8981\304C\3042\308B\5834\5408\3001<strong>\300C\7121\52B9\300D</strong>\3092\30AF\30EA\30C3\30AF\3057\307E\3059\3002'),
unistr('\4F7F\7528\53EF\80FD\306B\306A\3063\305F\3089\3001<strong>\300C\6709\52B9\300D</strong>\3092\30AF\30EA\30C3\30AF\3059\308B\3060\3051\3067\3059\3002</p>'),
unistr('<p><em><strong>\30CE\30FC\30C8:</strong> \3053\3053\3067\884C\3063\305F\5909\66F4\306F\3001\73FE\5728\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\5B9F\884C\4E2D\306E\500B\5225\306E\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\306F\53CD\6620\3055\308C\307E\305B\3093\3002\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\30B5\30A4\30F3\30A2\30A6\30C8\3057\3066\304B\3089\518D\5EA6\30B5\30A4\30F3\30A4\30F3\3059\308B\3068\3001\5909\66F4\3055\308C\305F\6A5F\80FD\8A2D\5B9A\304C\9069\7528\3055\308C\307E\3059\3002</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104806085942309093)
,p_name=>'CA.HELP.P10300.THEME.SELECTOR'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\8868\793A\306B\4F7F\7528\3059\308B\30C7\30D5\30A9\30EB\30C8\306E\30AB\30E9\30FC\30FB\30B9\30AD\30FC\30E0\3092\9078\629E\3057\307E\3059\3002</p>'),
unistr('<p><strong>\300C\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB\306E\9078\629E\3092\8A31\53EF\300D</strong>\304C\9078\629E\3055\308C\3066\3044\308B\5834\5408\3001\5404\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\3001\30DB\30FC\30E0\30DA\30FC\30B8\306E\5DE6\4E0B\9685\306B\3042\308B<em>\300C\30AB\30B9\30BF\30DE\30A4\30BA\300D</em>\30EA\30F3\30AF\3092\30AF\30EA\30C3\30AF\3057\3066\3001\4F7F\7528\53EF\80FD\306A\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB\304B\3089\9078\629E\3067\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104806634280309093)
,p_name=>'CA.HELP.P10400.ACTIVITY.REPORTING.ERROR.LOG'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30DA\30FC\30B8\3067\306F\3001\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\3088\3063\3066\8A18\9332\3055\308C\305F\3059\3079\3066\306E\4E88\671F\3057\306A\3044\30A8\30E9\30FC\306E\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\304C\63D0\4F9B\3055\308C\307E\3059\3002</p>'),
unistr('<p>\5217\30D8\30C3\30C0\30FC\3092\30AF\30EA\30C3\30AF\3057\3066\30C7\30FC\30BF\3092\30BD\30FC\30C8\304A\3088\3073\30D5\30A3\30EB\30BF\3059\308B\304B\3001<strong>\300C\30A2\30AF\30B7\30E7\30F3\300D</strong>\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3057\3066\5217\8868\793A\3068\591A\304F\306E\8FFD\52A0\306E\62E1\5F35\6A5F\80FD\3092\30AB\30B9\30BF\30DE\30A4\30BA\3057\307E\3059\3002<strong>\300C\30EA\30BB\30C3\30C8\300D</strong>\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\3092\30C7\30D5\30A9\30EB\30C8\8A2D\5B9A\306B\623B\3059\3053\3068\304C\3067\304D\307E\3059\3002</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104806582477309093)
,p_name=>'CA.HELP.P10500.ACTIVITY.REPORTING.TOP.USERS'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30EC\30DD\30FC\30C8\3068\30C1\30E3\30FC\30C8\3092\4F7F\7528\3057\3066\3001\6307\5B9A\3057\305F\6642\9593\67A0\3067\6700\5927\306E\30DA\30FC\30B8\30FB\30D3\30E5\30FC\3092\8A18\9332\3057\305F\30E6\30FC\30B6\30FC\3092\53C2\7167\3057\307E\3059\3002</p>'),
unistr('<p>\30EC\30DD\30FC\30C8\6642\9593\67A0(\30C7\30D5\30A9\30EB\30C8 = 1\65E5)\3092\9078\629E\3057\3001\30DA\30FC\30B8\306E\4E00\756A\4E0A\306B\3042\308B\30EC\30DD\30FC\30C8\30FB\30A2\30A4\30B3\30F3\3068\30C1\30E3\30FC\30C8\30FB\30A2\30A4\30B3\30F3\304B\3089\9078\629E\3057\307E\3059\3002</p>'),
unistr('<p>\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\3067\306F\3001\691C\7D22\30D5\30A3\30FC\30EB\30C9\3092\4F7F\7528\3059\308B\304B\3001<strong>\300C\30E6\30FC\30B6\30FC\300D</strong>\5217\30D8\30C3\30C0\30FC\3092\9078\629E\3057\3066\7279\5B9A\306E\30E6\30FC\30B6\30FC\3092\9078\629E\3057\307E\3059\3002<strong>\300C\30A2\30AF\30B7\30E7\30F3\300D</strong>\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\5217\306E\8868\793A/\975E\8868\793A\3001\30DA\30FC\30B8\3054\3068\306E\884C\6570\3001\30D5\30A3\30EB\30BF\306A\3069\306E\591A\304F\306E\6A5F\80FD\3092\5B9F\884C\3067\304D\307E\3059\3002<strong>\300C\30EA\30BB\30C3\30C8\300D</strong>\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\3092\30C7\30D5\30A9\30EB\30C8\8A2D\5B9A\306B\623B\3059\3053\3068\304C\3067\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104806723136309093)
,p_name=>'CA.HELP.P10510.ACTIVITY.REPORTING.PERFORMANCE'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30DA\30FC\30B8\3067\306F\3001\30DA\30FC\30B8\30FB\30D1\30D5\30A9\30FC\30DE\30F3\30B9\3068\4EBA\6C17\5EA6\306E\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\304C\63D0\4F9B\3055\308C\307E\3059\3002\30EC\30DD\30FC\30C8\306F\3001\4E2D\9593\7D4C\904E\6642\9593\3068\30DA\30FC\30B8\30FB\30D3\30E5\30FC\306E\6570\3092\639B\3051\308B\3053\3068\3067\8A08\7B97\3055\308C\308B<strong>\300C\91CD\307F\4ED8\3051\30D1\30D5\30A9\30FC\30DE\30F3\30B9\300D</strong>\3067\9806\5E8F\4ED8\3051\3055\308C\307E\3059\3002</p>'),
unistr('<p>\5FC5\8981\306B\5FDC\3058\3066\3001\30DA\30FC\30B8\306E\4E00\756A\4E0A\306B\3042\308B\30EC\30DD\30FC\30C8\6642\9593\67A0(\30C7\30D5\30A9\30EB\30C8 = 1\65E5)\3092\9078\629E\3057\307E\3059\3002<br>'),
unistr('\5217\30D8\30C3\30C0\30FC\3092\30AF\30EA\30C3\30AF\3057\3066\30C7\30FC\30BF\3092\30BD\30FC\30C8\304A\3088\3073\30D5\30A3\30EB\30BF\3059\308B\304B\3001<strong>\300C\30A2\30AF\30B7\30E7\30F3\300D</strong>\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3057\3066\5217\8868\793A\3068\591A\304F\306E\8FFD\52A0\306E\62E1\5F35\6A5F\80FD\3092\30AB\30B9\30BF\30DE\30A4\30BA\3057\307E\3059\3002<strong>\300C\30EA\30BB\30C3\30C8\300D</strong>\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\3092\30C7\30D5\30A9\30EB\30C8\8A2D\5B9A\306B\623B\3059\3053\3068\304C\3067\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104806803875309093)
,p_name=>'CA.HELP.P10520.ACTIVITY.REPORTING.VIEWS'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30DA\30FC\30B8\3067\306F\3001\6700\65B0\306E\30DA\30FC\30B8\30FB\30D3\30E5\30FC\306E\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\304C\63D0\4F9B\3055\308C\307E\3059\3002</p>'),
unistr('<p>\5FC5\8981\306B\5FDC\3058\3066\3001\30DA\30FC\30B8\306E\4E00\756A\4E0A\306B\3042\308B\30EC\30DD\30FC\30C8\6642\9593\67A0(\30C7\30D5\30A9\30EB\30C8 = 1\65E5)\3092\9078\629E\3057\307E\3059\3002<br>'),
unistr('\5217\30D8\30C3\30C0\30FC\3092\30AF\30EA\30C3\30AF\3057\3066\30C7\30FC\30BF\3092\30BD\30FC\30C8\304A\3088\3073\30D5\30A3\30EB\30BF\3059\308B\304B\3001<strong>\300C\30A2\30AF\30B7\30E7\30F3\300D</strong>\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3057\3066\5217\8868\793A\3068\591A\304F\306E\8FFD\52A0\306E\62E1\5F35\6A5F\80FD\3092\30AB\30B9\30BF\30DE\30A4\30BA\3057\307E\3059\3002<strong>\300C\30EA\30BB\30C3\30C8\300D</strong>\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\3092\30C7\30D5\30A9\30EB\30C8\8A2D\5B9A\306B\623B\3059\3053\3068\304C\3067\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104805858069309092)
,p_name=>'CA.HELP.P10600.NOTIFICATION'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\901A\77E5\306F\3001\30A2\30AF\30C6\30A3\30D6\306A\5834\5408\306B\30DB\30FC\30E0\30DA\30FC\30B8\306B\8868\793A\3055\308C\307E\3059\3002</p>'),
unistr('<p>\3053\306E\30EC\30DD\30FC\30C8\306B\306F\3001\5B9A\7FA9\3055\308C\3066\3044\308B\901A\77E5\3068\3001\305D\306E\901A\77E5\306E\8868\793A\671F\9593\304C\793A\3055\308C\307E\3059\3002</p>'),
unistr('<p>\7DE8\96C6\30A2\30A4\30B3\30F3(\9EC4\8272\306E\925B\7B46)\3092\30AF\30EA\30C3\30AF\3057\3066\65E2\5B58\306E\901A\77E5\3092\7DE8\96C6\3059\308B\304B\3001<strong>\300C\901A\77E5\306E\8FFD\52A0\300D</strong>\3092\30AF\30EA\30C3\30AF\3057\3066\65B0\3057\3044\901A\77E5\3092\633F\5165\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104806102004309093)
,p_name=>'CA.HELP.P10700.APPLICATION.SETTINGS'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\540D\3068\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\7C21\5358\306A\8AAC\660E\3092\5165\529B\3057\307E\3059\3002</p>'),
unistr('<p>\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\540D\306F\30DB\30FC\30E0\30DA\30FC\30B8\306B\8868\793A\3055\308C\307E\3059\3002\7C21\5358\306A\8AAC\660E\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\540D\306E\4E0B\306B\8868\793A\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104806388416309093)
,p_name=>'CA.HELP.P10920.FEEDBACK.REPORT'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5185\306E\901A\5E38\306E\30DA\30FC\30B8\304B\3089\30D5\30A3\30FC\30C9\30D0\30C3\30AF\3092\5165\529B\3067\304D\307E\3059\3002</p>'),
unistr('<p>\3053\306E\30EC\30DD\30FC\30C8\306B\306F\3001\5165\529B\3055\308C\305F\30D5\30A3\30FC\30C9\30D0\30C3\30AF\3001\7BA1\7406\8005\306B\3088\308A\5165\529B\3055\308C\305F\30EC\30B9\30DD\30F3\30B9\3001\304A\3088\3073\30D5\30A3\30FC\30C9\30D0\30C3\30AF\306E\30B9\30C6\30FC\30BF\30B9\304C\8868\793A\3055\308C\307E\3059\3002</p>'),
unistr('<p>\7DE8\96C6\30A2\30A4\30B3\30F3(\9EC4\8272\306E\925B\7B46)\3092\30AF\30EA\30C3\30AF\3057\3066\30EC\30B9\30DD\30F3\30B9\3092\5165\529B\3059\308B\304B\3001\30D5\30A3\30FC\30C9\30D0\30C3\30AF\30FB\30B9\30C6\30FC\30BF\30B9\3092\66F4\65B0\3057\307E\3059\3002</p>'),
unistr('<p><em><strong>\30CE\30FC\30C8:</strong> \30D5\30A3\30FC\30C9\30D0\30C3\30AF\306E\53D7\4FE1\8005\304C\5B9A\7FA9\3055\308C\3066\3044\308B\5834\5408\3001\30D5\30A3\30FC\30C9\30D0\30C3\30AF\306F\3001\30D5\30A3\30FC\30C9\30D0\30C3\30AF\53D7\4FE1\8005\30EA\30B9\30C8\306E\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9\306B\3082\9001\4FE1\3055\308C\307E\3059\3002</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104822449923309105)
,p_name=>'CA.HELP.P10940.COMMA.SEP.EMAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9\306E\30AB\30F3\30DE\533A\5207\308A\306E\30EA\30B9\30C8\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104806488926309093)
,p_name=>'CA.HELP.P10940.FEEDBACK.SETTINGS'
,p_message_language=>'ja'
,p_message_text=>unistr('<p><strong>\6DFB\4ED8\6709\52B9\5316</strong> - \300C\306F\3044\300D\306B\3057\305F\5834\5408\3001\30E6\30FC\30B6\30FC\306F\30D5\30A3\30FC\30C9\30D0\30C3\30AF\306B\4F7F\7528\3059\308B\6DFB\4ED8\3092\30A2\30C3\30D7\30ED\30FC\30C9\3067\304D\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104807470906309094)
,p_name=>'CA.HELP.P11000.EMAIL.TEMPLATES.REPORT'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30DA\30FC\30B8\306B\306F\3001\5B9A\7FA9\3055\308C\3066\3044\308B\96FB\5B50\30E1\30FC\30EB\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3068\3001\9001\4FE1\3055\308C\305F\96FB\5B50\30E1\30FC\30EB\3067\30C6\30F3\30D7\30EC\30FC\30C8\304C\53C2\7167\3055\308C\305F\56DE\6570\304C\30EA\30B9\30C8\3055\308C\307E\3059\3002</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104807298506309093)
,p_name=>'CA.HELP.P11010.EMAIL.LOG'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30DA\30FC\30B8\306B\306F\3001\9001\4FE1\3055\308C\305F\96FB\5B50\30E1\30FC\30EB\304C\30EA\30B9\30C8\3055\308C\307E\3059\3002</p>'),
unistr('<p>\62E1\5927\93E1\30A2\30A4\30B3\30F3\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\9001\4FE1\3055\308C\305F\96FB\5B50\30E1\30FC\30EB\306E\8A73\7D30\3092\8868\793A\3067\304D\307E\3059\3002</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104807328105309094)
,p_name=>'CA.HELP.P11020.EMAIL.TEMPLATES.FORM.EDIT'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\96FB\5B50\30E1\30FC\30EB\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\5B9A\7FA9\3059\308B\6B21\306E\30D5\30A3\30FC\30EB\30C9\3092\5165\529B\3057\307E\3059\3002</p>'),
'<ul>',
unistr('  <li><strong>\30C6\30F3\30D7\30EC\30FC\30C8\540D</strong>(\5FC5\9808) - \30C6\30F3\30D7\30EC\30FC\30C8\306E\308F\304B\308A\3084\3059\3044\540D\524D\3092\5165\529B\3057\307E\3059\3002</li>'),
unistr('  <li><strong>HTML\30C6\30F3\30D7\30EC\30FC\30C8</strong>(\5FC5\9808) - HTML\30D9\30FC\30B9\306E\96FB\5B50\30E1\30FC\30EB\306E\914D\4FE1\3092\8A31\53EF\3059\308B\53D7\4FE1\8005\306B\9001\4FE1\3059\308B\96FB\5B50\30E1\30FC\30EB\3092\4F5C\6210\3059\308B\305F\3081\306EHTML\30B3\30FC\30C9\3092\5165\529B\3057\307E\3059\3002'),
unistr('    \7F6E\63DB\5024\306F\6B21\306E\3068\304A\308A\3067\3059\3002'),
'    <ul>',
unistr('        <li><strong>#APP_NAME#</strong> - \30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\540D\524D\3067\7F6E\63DB\3055\308C\307E\3059\3002</li>'),
unistr('        <li><strong>#BODY1#</strong> - p_body1_text\3068\3057\3066\6E21\3055\308C\305F\5024\3067\7F6E\63DB\3055\308C\307E\3059</li> '),
unistr('        <li><strong>#TABLE#</strong> - \8868\306E\958B\59CBHTML\3001\8868\306E\884CHTML\304A\3088\3073\8868\306E\7D42\4E86HTML\3092\4F7F\7528\3057\3066p_table_content\3068\3057\3066\6E21\3055\308C\305F\5024\3067\7F6E\63DB\3055\308C\307E\3059\3002</li> '),
unistr('        <li><strong>#BODY2#</strong> - p_body2_text\3068\3057\3066\6E21\3055\308C\305F\5024\3067\7F6E\63DB\3055\308C\307E\3059</li> '),
unistr('        <li><strong>#ACTION#</strong> - \300C\30A2\30AF\30B7\30E7\30F3\30FB\30EA\30F3\30AF\300D\30C6\30F3\30D7\30EC\30FC\30C8\3092\4F7F\7528\3057\3066p_action_label\304A\3088\3073p_action_link\3068\3057\3066\6E21\3055\308C\305F\5024\3067\7F6E\63DB\3055\308C\307E\3059\3002</li>'),
'     </ul></li>',
unistr('  <li><strong>\30D7\30EC\30FC\30F3\30FB\30C6\30AD\30B9\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8</strong>(\5FC5\9808) - HTML\30D9\30FC\30B9\306E\96FB\5B50\30E1\30FC\30EB\3092\53D7\3051\53D6\3089\306A\3044\53D7\4FE1\8005\306B\9001\4FE1\3059\308B\96FB\5B50\30E1\30FC\30EB\3092\4F5C\6210\3059\308B\305F\3081\306E\30D7\30EC\30FC\30F3\30FB\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002\3053\308C\306F\3001#TABLE#\304A\3088\3073#ACTION#\304C\30D7\30EC\30FC\30F3\30FB\30C6\30AD\30B9\30C8\3068\3057\3066\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\308B\3053\3068\3092\9664\3044\3066\3001HTML\30C6\30F3\30D7\30EC\30FC\30C8\3068\540C\3058\7F6E\63DB\3092\4F7F\7528\3057\307E\3059\3002</li>'),
'<ul>',
unistr('<p>\8FFD\52A0\306EHTML\30C6\30F3\30D7\30EC\30FC\30C8\306F\4ED6\306E\62E1\5F35\96FB\5B50\30E1\30FC\30EB\306B\5BFE\5FDC\3057\307E\3059\3002\3053\308C\3089\306E\30A2\30A4\30C6\30E0\306F\6B21\306E\3068\304A\308A\3067\3059\3002</p>'),
'<ul>',
unistr('  <li><strong>\884C\306E\524D</strong> - HTML\30C6\30F3\30D7\30EC\30FC\30C8\306E#TABLE#\3092\7F6E\63DB\3059\308BHTML\3092\5165\529B\3057\307E\3059\3002p_table_content\304C\6E21\3055\308C\308B\5834\5408\306B\306E\307F\4F7F\7528\3055\308C\307E\3059\3002</li>'),
unistr('  <li><strong>\884C\30C6\30F3\30D7\30EC\30FC\30C8</strong> - \8868\306E\5404\884C\3092\30EC\30F3\30C0\30EA\30F3\30B0\3059\308BHTML\3092\5165\529B\3057\307E\3059\3002\3053\308C\306B\306F\3001#LABEL#\304A\3088\3073#VALUE#\7F6E\63DB\3092\4F7F\7528\3057\305F\884C\306E\958B\59CB/\7D42\4E86\3068\30C7\30FC\30BF\306E\958B\59CB/\7D42\4E86\304C\542B\307E\308C\307E\3059\3002p_table_content\304C\6E21\3055\308C\308B\5834\5408\306B\306E\307F\4F7F\7528\3055\308C\307E\3059\3002</li>'),
unistr('  <li><strong>\884C\306E\5F8C</strong> - \8868\307E\305F\306Fdiv\3092\7D42\4E86\3059\308BHTML\3092\5165\529B\3057\307E\3059\3002p_table_content\304C\6E21\3055\308C\308B\5834\5408\306B\306E\307F\4F7F\7528\3055\308C\307E\3059\3002</li>'),
unistr('  <li><strong>\30A2\30AF\30B7\30E7\30F3\30FB\30EA\30F3\30AFHTML</strong> - HTML\30C6\30F3\30D7\30EC\30FC\30C8\306E#ACTION#\3092\7F6E\63DB\3059\308BHTML\3092\5165\529B\3057\307E\3059\3002#ACTION_LINK#\304A\3088\3073#ACTION_TEXT#\304C\542B\307E\308C\3066\3044\308B\5FC5\8981\304C\3042\308A\307E\3059\3002p_action_label\3068p_action_link\304C\6E21\3055\308C\308B\5834\5408\306B\306E\307F\4F7F\7528\3055\308C\307E\3059\3002</li>'),
'</ul>',
unistr('<p><em><strong>\30CE\30FC\30C8:</strong> \72EC\81EA\306E\30C6\30F3\30D7\30EC\30FC\30C8\3092\958B\767A\3059\308B\5834\5408\3001<strong>\30C7\30D5\30A9\30EB\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8</strong>\5185\306E\30A8\30F3\30C8\30EA\3092\4F8B\3068\3057\3066\4F7F\7528\3057\3066\304F\3060\3055\3044\3002\30C7\30D5\30A9\30EB\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3067\306F\3001\72EC\81EA\306E\96FB\5B50\30E1\30FC\30EB\30FB\30C6\30F3\30D7\30EC\30FC\30C8\5185\306B\542B\3081\308B\3053\3068\304C\3067\304D\308B\3001\307E\305F\306F\3067\304D\306A\3044\3059\3079\3066\306E\7F6E\63DB\5909\6570\3092\4F7F\7528\3057\3066\3044\307E\3059\3002</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104807585779309094)
,p_name=>'CA.HELP.P11030.EMAIL.SETTINGS'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p><strong>\300C\96FB\5B50\30E1\30FC\30EB\306E\30C7\30A3\30B9\30D1\30C3\30C1\300D</strong>\30AA\30D7\30B7\30E7\30F3\306E\3044\305A\308C\304B\3092\9078\629E\3057\3066\3001\96FB\5B50\30E1\30FC\30EB\306E\9001\4FE1\3092\6709\52B9\5316\307E\305F\306F\7121\52B9\5316\3057\307E\3059\3002</p>'),
unistr('<p>\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\554F\984C\306E\30D7\30E9\30A4\30DE\30EA\9023\7D61\5148\306E\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9\3092\4F7F\7528\3057\3066<strong>\300C\96FB\5B50\30E1\30FC\30EB\306E\9001\4FE1\5143\300D</strong>\3092\5165\529B\3057\307E\3059\3002\3053\306E\5024\306F\96FB\5B50\30E1\30FC\30EB\6A5F\80FD\3092\4F7F\7528\3059\308B\3068\304D\306B\4F7F\7528\307E\305F\306F\4E0A\66F8\304D\3067\304D\307E\3059\3002</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104825768351309107)
,p_name=>'CA.HELP.P11030.EMAILS.FROM'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\308C\306F\3001\96FB\5B50\30E1\30FC\30EB\306E\9001\4FE1\306B\4F7F\7528\3055\308C\308B\9001\4FE1\5143\30A2\30C9\30EC\30B9\3067\3059\3002\96FB\5B50\30E1\30FC\30EB\6A5F\80FD\3092\4F7F\7528\3057\3066\4E0A\66F8\304D\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104843006027309120)
,p_name=>'CA.HELP.P11060.SEND.EMAIL'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6B21\306E\9805\76EE\3092\79FB\5165\3057\3001\300C\96FB\5B50\30E1\30FC\30EB\306E\9001\4FE1\300D\3092\30AF\30EA\30C3\30AF\3057\307E\3059\3002\9001\4FE1\3055\308C\305F\3059\3079\3066\306E\96FB\5B50\30E1\30FC\30EB\304C\96FB\5B50\30E1\30FC\30EB\30FB\30ED\30B0\306B\8A18\9332\3055\308C\307E\3059\3002'),
'    <ul>',
unistr('        <li><strong>\9001\4FE1\8005</strong> - \300C\96FB\5B50\30E1\30FC\30EB\8A2D\5B9A\300D\3067\300C\9001\4FE1\5143\30A2\30C9\30EC\30B9\300D\304C\8A2D\5B9A\3055\308C\3066\3044\308B\5834\5408\3001\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9\306F\9001\4FE1\5143\30AA\30D7\30B7\30E7\30F3\306B\306A\308A\307E\3059\3002\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9\3092\30E6\30FC\30B6\30FC\540D\3068\3057\3066\4F7F\7528\3059\308B\5834\5408\306F\3001\96FB\5B50\30E1\30FC\30EB\3092\81EA\5206\306E\96FB\5B50\30E1\30FC\30EB\304B\3089\9001\4FE1\3059\308B\3053\3068\3092\9078\629E\3067\304D\307E\3059\3002\6700\5F8C\306B\3001\300C\9001\4FE1\5143\300D\3092\5E38\306B\300C\9001\4FE1\5148\300D\3068\540C\3058\306B\3059\308B\3053\3068\304C\3067\304D\307E\3059\3002</li>'),
unistr('        <li><strong>\9001\4FE1\5148</strong> - \3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304C\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9\3092\30E6\30FC\30B6\30FC\540D\3068\3057\3066\4F7F\7528\3059\308B\5834\5408\306F\3001\96FB\5B50\30E1\30FC\30EB\3092\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9\307E\305F\306F\30E6\30FC\30B6\30FC\3001\3042\308B\3044\306F\305D\306E\4E21\65B9\306B\9001\4FE1\3059\308B\3053\3068\3092\9078\629E\3067\304D\307E\3059\3002</li>'),
unistr('        <li><strong>\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9</strong> - \96FB\5B50\30E1\30FC\30EB\3092\53D7\4FE1\3059\308B\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9\306E\30AB\30F3\30DE\533A\5207\308A\30EA\30B9\30C8\3002\7121\52B9\306A\3082\306E\304C\691C\51FA\3055\308C\305F\5834\5408\3001\305D\308C\306F\542B\3081\3089\308C\307E\305B\3093\3002</li>'),
unistr('        <li><strong>\30ED\30FC\30EB</strong> - \9078\629E\3057\305F\30ED\30FC\30EB\306E\3059\3079\3066\306E\30E6\30FC\30B6\30FC\307E\305F\306F\3059\3079\3066\306E\5B9A\7FA9\3055\308C\305F\30E6\30FC\30B6\30FC\306B\96FB\5B50\30E1\30FC\30EB\3092\9001\4FE1\3057\307E\3059\3002\9078\629E\30EA\30B9\30C8\306B\306F\3001\30ED\30FC\30EB\306E\30EA\30B9\30C8\3068\305D\306E\30ED\30FC\30EB\5185\306E\30E6\30FC\30B6\30FC\6570\304C\542B\307E\308C\307E\3059\3002</li>'),
unistr('        <li><strong>\30C6\30F3\30D7\30EC\30FC\30C8</strong> - \96FB\5B50\30E1\30FC\30EB\306E\672C\6587\306E\4F5C\6210\306B\4F7F\7528\3059\308B\96FB\5B50\30E1\30FC\30EB\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\9078\629E\3057\307E\3059\3002</li>'),
unistr('        <li><strong>\4EF6\540D</strong> - \96FB\5B50\30E1\30FC\30EB\306E\4EF6\540D\3002</li>'),
unistr('        <li><strong>\96FB\5B50\30E1\30FC\30EB\672C\6587</strong> - \96FB\5B50\30E1\30FC\30EB\306E\672C\6587\3068\3057\3066\542B\3081\308B\30C6\30AD\30B9\30C8\3002</li>'),
unistr('        <li><strong>\30AA\30D7\30C8\30FB\30A2\30A6\30C8\3092\8A31\53EF</strong> - \4E00\90E8\306E\96FB\5B50\30E1\30FC\30EB\306F\3001\30E6\30FC\30B6\30FC\304C\53D7\4FE1\96FB\5B50\30E1\30FC\30EB\3092\30AA\30D7\30C8\30FB\30A2\30A6\30C8\3057\3066\3044\308B\304B\3069\3046\304B\306B\95A2\4FC2\306A\304F\9001\4FE1\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\3053\308C\3089\306B\306F\3001\30B7\30B9\30C6\30E0\505C\6B62\30E1\30C3\30BB\30FC\30B8\306A\3069\304C\542B\307E\308C\307E\3059\3002\3053\306E\30D5\30E9\30B0\306F\3001\3053\306E\96FB\5B50\30E1\30FC\30EB\306E\30AA\30D7\30C8\30FB\30A2\30A6\30C8\3092\8A31\53EF\3059\308B\304B\3069\3046\304B\3001\307E\305F\306F\30E6\30FC\30B6\30FC\306E\30D7\30EA\30D5\30A1\30EC\30F3\30B9\306B\95A2\4FC2\306A\304F\9001\4FE1\3059\308B\304B\3069\3046\304B\3092\793A\3057\307E\3059\3002</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104844724768309121)
,p_name=>'CA.HELP.P11060.SEND.EMAIL.NO.ACL'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6B21\306E\9805\76EE\3092\79FB\5165\3057\3001[\96FB\5B50\30E1\30FC\30EB\306E\9001\4FE1]\3092\30AF\30EA\30C3\30AF\3057\307E\3059\3002\9001\4FE1\3055\308C\305F\3059\3079\3066\306E\96FB\5B50\30E1\30FC\30EB\304C\96FB\5B50\30E1\30FC\30EB\30FB\30ED\30B0\306B\8A18\9332\3055\308C\307E\3059\3002'),
'    <ul>',
unistr('        <li><strong>\9001\4FE1\8005</strong> - \300C\96FB\5B50\30E1\30FC\30EB\8A2D\5B9A\300D\3067\300C\9001\4FE1\5143\30A2\30C9\30EC\30B9\300D\304C\8A2D\5B9A\3055\308C\3066\3044\308B\5834\5408\3001\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9\306F\9001\4FE1\5143\30AA\30D7\30B7\30E7\30F3\306B\306A\308A\307E\3059\3002\307E\305F\306F\3001\300C\9001\4FE1\5143\300D\3092\5E38\306B\300C\9001\4FE1\5148\300D\3068\540C\3058\306B\3059\308B\3053\3068\304C\3067\304D\307E\3059\3002</li>'),
unistr('        <li><strong>\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9</strong> - \96FB\5B50\30E1\30FC\30EB\3092\53D7\4FE1\3059\308B\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9\306E\30AB\30F3\30DE\533A\5207\308A\30EA\30B9\30C8\3002\7121\52B9\306A\3082\306E\304C\691C\51FA\3055\308C\305F\5834\5408\3001\305D\308C\306F\542B\3081\3089\308C\307E\305B\3093\3002</li>'),
unistr('        <li><strong>\30C6\30F3\30D7\30EC\30FC\30C8</strong> - \96FB\5B50\30E1\30FC\30EB\306E\672C\6587\306E\4F5C\6210\306B\4F7F\7528\3059\308B\96FB\5B50\30E1\30FC\30EB\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\9078\629E\3057\307E\3059\3002</li>'),
unistr('        <li><strong>\4EF6\540D</strong> - \96FB\5B50\30E1\30FC\30EB\306E\4EF6\540D\3002</li>'),
unistr('        <li><strong>\96FB\5B50\30E1\30FC\30EB\672C\6587</strong> - \96FB\5B50\30E1\30FC\30EB\306E\672C\6587\3068\3057\3066\542B\3081\308B\30C6\30AD\30B9\30C8\3002</li>'),
unistr('        <li><strong>\30AA\30D7\30C8\30FB\30A2\30A6\30C8\3092\8A31\53EF</strong> - \4E00\90E8\306E\96FB\5B50\30E1\30FC\30EB\306F\3001\30E6\30FC\30B6\30FC\304C\53D7\4FE1\96FB\5B50\30E1\30FC\30EB\3092\30AA\30D7\30C8\30FB\30A2\30A6\30C8\3057\3066\3044\308B\304B\3069\3046\304B\306B\95A2\4FC2\306A\304F\9001\4FE1\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\3053\308C\3089\306B\306F\3001\30B7\30B9\30C6\30E0\505C\6B62\30E1\30C3\30BB\30FC\30B8\306A\3069\304C\542B\307E\308C\307E\3059\3002\3053\306E\30D5\30E9\30B0\306F\3001\3053\306E\96FB\5B50\30E1\30FC\30EB\306E\30AA\30D7\30C8\30FB\30A2\30A6\30C8\3092\8A31\53EF\3059\308B\304B\3069\3046\304B\3001\307E\305F\306F\30E6\30FC\30B6\30FC\306E\30D7\30EA\30D5\30A1\30EC\30F3\30B9\306B\95A2\4FC2\306A\304F\9001\4FE1\3059\308B\304B\3069\3046\304B\3092\793A\3057\307E\3059\3002</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104806235180309093)
,p_name=>'CA.HELP.P12000.TIME.ZONE.SUPPORT'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\3059\3079\3066\306E\30E6\30FC\30B6\30FC\306B\5BFE\5FDC\3059\308B\30C7\30D5\30A9\30EB\30C8\30FB\30BF\30A4\30E0\30BE\30FC\30F3\3092\9078\629E\3057\307E\3059\3002</p>'),
unistr('<p>\500B\3005\306E\30E6\30FC\30B6\30FC\306F\3001\30E6\30FC\30B6\30FC\540D(\53F3\4E0A)\3092\30AF\30EA\30C3\30AF\3057\3066<strong>\300C\30D7\30EA\30D5\30A1\30EC\30F3\30B9\300D</strong>\3092\9078\629E\3057\3001\3053\306E\8A2D\5B9A\3092\30AA\30FC\30D0\30FC\30E9\30A4\30C9\3067\304D\307E\3059\3002\307E\305F\306F\3001\30DB\30FC\30E0\30DA\30FC\30B8\306E\4E00\756A\4E0B\306B\8868\793A\3055\308C\3066\3044\308B\30BF\30A4\30E0\30BE\30FC\30F3\30FB\30EA\30F3\30AF\3092\30AF\30EA\30C3\30AF\3059\308B\3053\3068\3082\3067\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104822111243309104)
,p_name=>'CA.HELP.P2000.PROFILE.PHOTO.DOWNLOAD'
,p_message_language=>'ja'
,p_message_text=>unistr('UI\3092\901A\3058\3066\3053\306E\30DA\30FC\30B8\306B\76F4\63A5\30A2\30AF\30BB\30B9\3059\308B\3053\3068\306F\3067\304D\307E\305B\3093\3002\3053\308C\306F\3001\30D7\30ED\30D5\30A1\30A4\30EB\5199\771F\3092\7C21\5358\306B\30C0\30A6\30F3\30ED\30FC\30C9\3059\308B\305F\3081\306B\4F7F\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104821874326309104)
,p_name=>'CA.HELP.P20000.USER.PROFILE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\30FB\30D7\30ED\30D5\30A1\30A4\30EB\30FB\30DA\30FC\30B8\3067\306F\3001\4F7F\3044\3084\3059\30441\3064\306E\753B\9762\3067\30E6\30FC\30B6\30FC\306B\95A2\9023\3059\308B\60C5\5831\3092\53C2\7167\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104821568798309104)
,p_name=>'CA.HELP.P20030.PHOTO.UPLOAD'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B63\65B9\5F62\306E\7E26\6A2A\6BD4\3092\6301\3064\5199\771F\3092\30A2\30C3\30D7\30ED\30FC\30C9\3057\306A\3044\3068\3001\6B6A\307F\304C\751F\3058\308B\53EF\80FD\6027\304C\3042\308A\307E\3059\3002\63A8\5968\3055\308C\308B\30A4\30E1\30FC\30B8\30FB\30B5\30A4\30BA\306F\3001250x250\30D4\30AF\30BB\30EB\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104807673557309094)
,p_name=>'CA.HELP.P20200.USER.PROFILE.MODAL'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30D5\30A9\30FC\30E0\3067\306F\3001\500B\4EBA\60C5\5831\306E\8A73\7D30\3092\66F4\65B0\3057\3066\5199\771F\3084\30A2\30D0\30BF\30FC\3092\30A2\30C3\30D7\30ED\30FC\30C9\3067\304D\307E\3059\3002</p>'),
unistr('<p>\30A4\30E1\30FC\30B8\3092\30A2\30C3\30D7\30ED\30FC\30C9\3059\308B\306B\306F\3001<strong>\300C\53C2\7167\300D</strong>\3092\30AF\30EA\30C3\30AF\3059\308B\304B\3001\30A4\30E1\30FC\30B8\3092\30DC\30BF\30F3\4E0A\306B\30C9\30E9\30C3\30B0\30FB\30A2\30F3\30C9\30FB\30C9\30ED\30C3\30D7\3057\307E\3059\3002<br>'),
unistr('\6B63\65B9\5F62\306E\7E26\6A2A\6BD4\3092\6301\3064\5199\771F\3092\30A2\30C3\30D7\30ED\30FC\30C9\3057\306A\3044\3068\3001\6B6A\307F\304C\751F\3058\308B\53EF\80FD\6027\304C\3042\308A\307E\3059\3002\63A8\5968\3055\308C\308B\30A4\30E1\30FC\30B8\30FB\30B5\30A4\30BA\306F\3001250x250\30D4\30AF\30BB\30EB\3067\3059\3002</p>'),
unistr('<p><strong>\300C\5199\771F\306E\524A\9664\300D</strong>\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\30A4\30E1\30FC\30B8\3092\524A\9664\3067\304D\307E\3059\3002</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104827708547309108)
,p_name=>'CA.HELP.P20210.ABOUT'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DA\30FC\30B8\304B\3089\3059\3079\3066\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30D8\30EB\30D7\30FB\30C6\30AD\30B9\30C8\306B\30A2\30AF\30BB\30B9\3067\304D\307E\3059\3002\300C\30C9\30AD\30E5\30E1\30F3\30C8\300D\30EA\30FC\30B8\30E7\30F3\306E\30EA\30F3\30AF\3092\4F7F\7528\3059\308B\3068\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\6A5F\80FD\3068\7279\5FB4\306E\3088\308A\8A73\7D30\306A\8AAC\660E\3092\53C2\7167\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104808733453309095)
,p_name=>'CA.HELP.P20400.APP.PREF'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DA\30FC\30B8\3067\30A2\30AB\30A6\30F3\30C8\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30D7\30EA\30D5\30A1\30EC\30F3\30B9\3092\8A2D\5B9A\3067\304D\307E\3059\3002\30D7\30EA\30D5\30A1\30EC\30F3\30B9\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\8907\6570\306E\6A5F\80FD(\30BF\30A4\30E0\30BE\30FC\30F3\306A\3069)\306B\5F71\97FF\3059\308B\53EF\80FD\6027\304C\3042\308A\307E\3059\3002\30A2\30A4\30C6\30E0\30FB\30EC\30D9\30EB\306E\30D8\30EB\30D7\30FB\30A2\30A4\30B3\30F3\3092\30AF\30EA\30C3\30AF\3057\3066\3001\5404\30D7\30EA\30D5\30A1\30EC\30F3\30B9\306E\52D5\4F5C\3092\5B66\3073\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103911556342308336)
,p_name=>'CA.HELP.P20500.EMAIL.REPORTING'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\3053\306E\30EC\30DD\30FC\30C8\306B\306F\3001\9001\4FE1\30AD\30E5\30FC\306B\5165\3063\3066\3044\308B\96FB\5B50\30E1\30FC\30EB\304A\3088\3073\3059\3067\306B\9001\4FE1\3055\308C\305F\96FB\5B50\30E1\30FC\30EB\306E\3059\3079\3066\304C\8868\793A\3055\308C\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104033083800308461)
,p_name=>'CA.HELP.P20600.JOB.REPORTING'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\3053\306E\30EC\30DD\30FC\30C8\306B\306F\3001\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\3088\3063\3066\30E2\30CB\30BF\30FC\3055\308C\308B\3088\3046\306B\9078\629E\3055\308C\305F\3059\3079\3066\306E\30B8\30E7\30D6\304C\542B\307E\308C\307E\3059\3002\5404\30B8\30E7\30D6\306E\8A73\7D30\306F\3001\30B8\30E7\30D6\540D\3092\30AF\30EA\30C3\30AF\3059\308B\3068\8868\793A\3067\304D\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104039684029308467)
,p_name=>'CA.HELP.P20610.JOB.RUN.DETAILS'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\3053\306E\30EC\30DD\30FC\30C8\306B\306F\3001\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\3088\3063\3066\30E2\30CB\30BF\30FC\3055\308C\308B\3088\3046\306B\9078\629E\3055\308C\305F\30B8\30E7\30D6\306E\5B9F\884C\306E\8A73\7D30\304C\542B\307E\308C\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104793036113309083)
,p_name=>'CA.HELP.PAGE.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\3064\3044\3066\300D\30DA\30FC\30B8\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104809451039309095)
,p_name=>'CA.HELP.RECEIVE.EMAILS'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304B\3089\96FB\5B50\30E1\30FC\30EB\3092\53D7\4FE1\3057\306A\3044\5834\5408\3001\3053\306E\30AA\30D7\30B7\30E7\30F3\3092\300C\3044\3044\3048\300D\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104842554467309120)
,p_name=>'CA.HELP.SEARCH.PAGE'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\691C\7D22\8A9E\3092\691C\7D22\30C0\30A4\30A2\30ED\30B0\306B\5165\529B\3057\3001<strong>\300C\691C\7D22\300D</strong>\3092\30AF\30EA\30C3\30AF\3057\307E\3059\3002<br>'),
unistr('\3044\305A\308C\304B\306E\7D50\679C\898B\51FA\3057\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\305D\306E\30EC\30B3\30FC\30C9\306B\79FB\52D5\3057\307E\3059\3002</p>'),
unistr('<p>\691C\7D22\3092\5236\9650\3059\308B\306B\306F\30011\3064\4EE5\4E0A\306E\30BD\30FC\30B9\306E\9078\629E\3092\89E3\9664\3059\308B\3068\3001\691C\7D22\7D50\679C\304B\3089\305D\306E\30EC\30DD\30FC\30C8\304C\524A\9664\3055\308C\307E\3059\3002</p>'),
unistr('<p>\73FE\5728\306E\691C\7D22\8A9E\3092\524A\9664\3057\3001\3059\3079\3066\306E\30BD\30FC\30B9\3092\9078\629E\3059\308B\306B\306F\3001<strong>\300C\30EA\30BB\30C3\30C8\300D</strong>\3092\30AF\30EA\30C3\30AF\3057\307E\3059\3002</p> ')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104809207416309095)
,p_name=>'CA.HELP.TIME.ZONE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5168\4F53\3067\4F7F\7528\3059\308B\512A\5148\30BF\30A4\30E0\30BE\30FC\30F3\3092\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103807487694308253)
,p_name=>'CA.HIDDEN.ITEMS'
,p_message_language=>'ja'
,p_message_text=>unistr('\975E\8868\793A\306E\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104829366737309110)
,p_name=>'CA.HOME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DB\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104835413902309114)
,p_name=>'CA.HOME.PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DB\30FC\30E0\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104850715561309126)
,p_name=>'CA.HOURLY.PAGE.EVENTS'
,p_message_language=>'ja'
,p_message_text=>unistr('1\6642\9593\5F53\305F\308A\306E\30DA\30FC\30B8\30FB\30A4\30D9\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103910641620308335)
,p_name=>'CA.HTML.BODY.SIZE'
,p_message_language=>'ja'
,p_message_text=>unistr('HTML\30DC\30C7\30A3\30FB\30B5\30A4\30BA')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104826194780309107)
,p_name=>'CA.HTML.TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('HTML\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104822865333309105)
,p_name=>'CA.IN.PROGRESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\9032\884C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104846966513309123)
,p_name=>'CA.INCLUDEONFORMS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30FC\30E0\306B\542B\3081\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104846883147309123)
,p_name=>'CA.INCLUDEONREPORTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\306B\542B\3081\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104831594313309111)
,p_name=>'CA.INSTALL.SUP.OBJ.SCRIPTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30DD\30FC\30C8\3059\308B\30AA\30D6\30B8\30A7\30AF\30C8\306E\30B9\30AF\30EA\30D7\30C8\306E\30A4\30F3\30B9\30C8\30FC\30EB\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104033708620308462)
,p_name=>'CA.INSTANCE.ID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30B9\30BF\30F3\30B9ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104034906407308463)
,p_name=>'CA.INSTANCE.STICKINESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30B9\30BF\30F3\30B9\306E\632F\5206\3051')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104805275393309092)
,p_name=>'CA.INTRO.DETAIL'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3088\308A\6A5F\80FD\8C4A\5BCC\306A\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\4F5C\6210\3059\308B\305F\3081\306B\6539\5584\3055\308C\305F\65B0\3057\3044\65B9\6CD5\3092\63D0\4F9B\3059\308B\3053\306E\30AF\30E9\30A6\30C9\5C02\7528\30D7\30EC\30D3\30E5\30FC\306B\3088\3046\3053\305D\3002\6A19\6E96\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\4F5C\6210\30A6\30A3\30B6\30FC\30C9\3067\306F\751F\6210\3059\308B\30DA\30FC\30B8\3092\9078\629E\3067\304D\308B\306E\307F\3067\3059\304C\3001\3053\306E\30A6\30A3\30B6\30FC\30C9\3067\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\8907\6570\306E\8FFD\52A0\6A5F\80FD\3092\8FC5\901F\306B\4E8B\524D\30ED\30FC\30C9\3059\308B\3053\3068\304C\3067\304D\307E\3059\3002</p>'),
unistr('<p>\3053\306E\30A6\30A3\30B6\30FC\30C9\3092\4F7F\7528\3057\3066\751F\6210\3055\308C\305F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306F\3001\5B8C\5168\306B\30B5\30DD\30FC\30C8\3055\308C\308B\3068\3068\3082\306B\3001\30A2\30AF\30BB\30B9\5236\5FA1\3001\96FB\5B50\30E1\30FC\30EB\30FB\30D5\30EC\30FC\30E0\30EF\30FC\30AF\3001\30D5\30A3\30FC\30C9\30D0\30C3\30AF\306A\3069\3001\9078\629E\3057\305F\6A5F\80FD\3092\30B5\30DD\30FC\30C8\3059\308B\30AA\30D6\30B8\30A7\30AF\30C8\3092\542B\3081\308B\3053\3068\3082\3067\304D\307E\3059\3002</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104805401911309092)
,p_name=>'CA.INTRO.HOWTO.DETAIL'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6700\521D\306B\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\540D\3092\5165\529B\3057\307E\3059\3002\6B21\306B\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B1\3064\4EE5\4E0A\306E\30DA\30FC\30B8\3092\8FFD\52A0\3057\307E\3059\3002\542B\3081\308B\6A5F\80FD\3092\9078\629E\3057\307E\3059\3002\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\5916\89B3\306B\95A2\3059\308B\9078\629E\3092\884C\3044\3001\8A2D\5B9A\3092\30EC\30D3\30E5\30FC\3057\307E\3059\3002<br>'),
unistr('\3053\308C\3060\3051\3067\7D42\4E86\3067\3059\3002<strong>\300C\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\4F5C\6210\300D</strong>\3092\30AF\30EA\30C3\30AF\3059\308C\3070\81EA\52D5\3067\4F5C\696D\304C\9032\307F\307E\3059\3002</p>'),
unistr('<p><strong>\300C\30D6\30EB\30FC\30D7\30EA\30F3\30C8\306E\8868\793A\300D</strong>\3092\30AF\30EA\30C3\30AF\3057\3066\3001\524D\306B\751F\6210\3057\305F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30E2\30C7\30EB\3092\518D\5229\7528\3059\308B\304B\3001\30DA\30FC\30B8\3092\3059\3070\3084\304F\30EC\30D7\30EA\30B1\30FC\30C8\3057\307E\3059\3002</p>'),
unistr('<p><em><strong>\30CE\30FC\30C8:</strong> \5404\30BB\30AF\30B7\30E7\30F3\3068\5404\300C\30DA\30FC\30B8\306E\8FFD\52A0\300D\306B\3001\4F5C\696D\306B\5F79\7ACB\3064\8A73\7D30\306A\30D8\30EB\30D7\304C\542B\307E\308C\307E\3059\3002</em></p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104805354372309092)
,p_name=>'CA.INTRO.HOWTO.TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A6\30A3\30B6\30FC\30C9\306E\4F7F\7528\65B9\6CD5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104838945335309117)
,p_name=>'CA.INTRO.KNOWN.ISSUES.DETAIL'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30EA\30EA\30FC\30B9\6642\306E\91CD\5927\306A\554F\984C\3092\6B21\306B\793A\3057\307E\3059\3002'),
'<ol>',
unistr('  <li>\30D6\30EB\30FC\30D7\30EA\30F3\30C8\304B\3089\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\4F5C\6210\30A6\30A3\30B6\30FC\30C9\304C\7FFB\8A33\3055\308C\3066\3044\307E\305B\3093\3002</li>'),
unistr('  <li>\3053\306E\30A6\30A3\30B6\30FC\30C9\3067\751F\6210\3055\308C\305F\7FFB\8A33\6E08\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306F\4E00\90E8\306E\307F\7FFB\8A33\3055\308C\3066\3044\307E\3059\3002</li>'),
unistr('  <li>\300C\30EC\30DD\30FC\30C8\300D\30C9\30EA\30EB\30C0\30A6\30F3\3067\306F1\3064\306E\30C9\30EA\30EB\30C0\30A6\30F3\5217\306E\307F\4F7F\7528\3067\304D\307E\3059\3002</li>'),
unistr('  <li>\30D5\30A3\30EB\30BF\30FB\30EC\30DD\30FC\30C8\30FB\30DA\30FC\30B8\3092\751F\6210\3067\304D\307E\305B\3093\3002</li>'),
unistr('  <li>\96FB\5B50\30E1\30FC\30EB\6A5F\80FD\306F\4F4E\30EC\30D9\30EB\306EAPI\3092\63D0\4F9B\3057\307E\3059\304C\3001\9AD8\30EC\30D9\30EB\306E\96FB\5B50\30E1\30FC\30EB\6A5F\80FD\306F\307E\3060\542B\307E\308C\3066\3044\307E\305B\3093\3002</li>'),
unistr('  <li>\6B20\843D\3057\3066\3044\308B\8868\3092\53C2\7167\3059\308B\30D6\30EB\30FC\30D7\30EA\30F3\30C8\304B\3089\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\751F\6210\306F\5931\6557\3057\307E\3059\3002</li>'),
unistr('  <li>\8A73\7D30\8A2D\5B9A - \751F\6210\3055\308C\305F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\65E5\4ED8\5F62\5F0F\304C\9069\7528\3055\308C\307E\305B\3093\3002</li>'),
'</ol>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104838894668309117)
,p_name=>'CA.INTRO.KNOWN.ISSUES.TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E2\77E5\306E\554F\984C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104805676779309092)
,p_name=>'CA.INTRO.RELEASE.DETAIL'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>%0\3092\30EA\30EA\30FC\30B9\3057\307E\3057\305F\3002</p>'),
'',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104805552117309092)
,p_name=>'CA.INTRO.RELEASE.TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30EA\30FC\30B9\8A73\7D30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104805121044309092)
,p_name=>'CA.INTRO.TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EB\30FC\30D7\30EA\30F3\30C8\30FB\30A6\30A3\30B6\30FC\30C9\304B\3089\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\4F5C\6210{\30AF\30E9\30A6\30C9\306E\307F\306E\30D7\30EC\30D3\30E5\30FC}')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104816735473309100)
,p_name=>'CA.IP.ADDRESS'
,p_message_language=>'ja'
,p_message_text=>unistr('IP\30A2\30C9\30EC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104814942609309099)
,p_name=>'CA.IR.SEARCH'
,p_message_language=>'ja'
,p_message_text=>unistr('IR\691C\7D22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104817918508309101)
,p_name=>'CA.IR.SEARCHES'
,p_message_language=>'ja'
,p_message_text=>unistr('IR\691C\7D22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104845310014309122)
,p_name=>'CA.ITEMNAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104037734509308465)
,p_name=>'CA.JOB.ACTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B8\30E7\30D6\30FB\30A2\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104039292698308466)
,p_name=>'CA.JOB.CLASS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B8\30E7\30D6\30FB\30AF\30E9\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104038395154308466)
,p_name=>'CA.JOB.CREATOR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B8\30E7\30D6\4F5C\6210\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104039436914308467)
,p_name=>'CA.JOB.NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B8\30E7\30D6\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104035946911308464)
,p_name=>'CA.JOB.PRIORITY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B8\30E7\30D6\306E\512A\5148\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104032909193308461)
,p_name=>'CA.JOB.REPORTING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B8\30E7\30D6\30FB\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104073029919308494)
,p_name=>'CA.JOB.REPORTING.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\30B5\30DD\30FC\30C8\3059\308B\30B8\30E7\30D6\306E\30B9\30C6\30FC\30BF\30B9\304A\3088\3073\5B9F\884C\8A73\7D30\3092\8868\793A\3057\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104039575985308467)
,p_name=>'CA.JOB.RUN.DETAILS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B8\30E7\30D6\5B9F\884C\306E\8A73\7D30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104038449971308466)
,p_name=>'CA.JOB.STYLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B8\30E7\30D6\30FB\30B9\30BF\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104038594742308466)
,p_name=>'CA.JOB.SUBNAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B8\30E7\30D6\306E\30B5\30D6\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104037806848308465)
,p_name=>'CA.JOB.TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B8\30E7\30D6\30FB\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104034599914308462)
,p_name=>'CA.JOB.WEIGHT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B8\30E7\30D6\306E\91CD\307F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104845828224309122)
,p_name=>'CA.KEYCOLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AD\30FC\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104847640023309123)
,p_name=>'CA.LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104846148557309122)
,p_name=>'CA.LABELCOLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104847890564309124)
,p_name=>'CA.LABELPLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB\8907\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104847569859309123)
,p_name=>'CA.LABELSINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\5358\4E00\30E9\30D9\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104804362007309091)
,p_name=>'CA.LANGUAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A00\8A9E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104804457940309091)
,p_name=>'CA.LANGUAGE.DETAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30D7\30E9\30A4\30DE\30EA\8A00\8A9E\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104838357590309116)
,p_name=>'CA.LANGUAGE.PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\30D7\30E9\30A4\30DE\30EA\8A00\8A9E\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30D3\30EB\30C0\30FC\3067\751F\6210\3055\308C\305F\30DA\30FC\30B8\304A\3088\3073\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306E\8868\793A\306B\4F7F\7528\3055\308C\308B\8A00\8A9E\3092\793A\3057\307E\3059\3002\8907\6570\306E\7FFB\8A33\3092\9078\629E\3059\308B\3068\3001\30E9\30F3\30BF\30A4\30E0\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30EC\30F3\30C0\30EA\30F3\30B0\306B\4F7F\7528\3055\308C\308B\8A00\8A9E\3092\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\9078\629E\3067\304D\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104170753220308584)
,p_name=>'CA.LANGUAGE_SELECTOR'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A00\8A9E\30BB\30EC\30AF\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104821369166309104)
,p_name=>'CA.LAST.NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\59D3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104038636188308466)
,p_name=>'CA.LAST.RUN.DURATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\7D42\5B9F\884C\671F\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104038706246308466)
,p_name=>'CA.LAST.START.DATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\7D42\958B\59CB\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104851169893309126)
,p_name=>'CA.LATEST.ACTIVITY'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\65B0\306E\30A2\30AF\30C6\30A3\30D3\30C6\30A3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104847021250309123)
,p_name=>'CA.LISTOFVALUES'
,p_message_language=>'ja'
,p_message_text=>'LOV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104842454195309119)
,p_name=>'CA.LOAD.BLUEPRINT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EB\30FC\30D7\30EA\30F3\30C8\306E\30ED\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104041051997308468)
,p_name=>'CA.LOG.DATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30B0\65E5\4ED8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104041109489308468)
,p_name=>'CA.LOG.ID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30B0ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104035240577308463)
,p_name=>'CA.LOGGING.LEVEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30B0\30FB\30EC\30D9\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104718425891309015)
,p_name=>'CA.LOG_MESSAGES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30B0\30FB\30E1\30C3\30BB\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103808643263308254)
,p_name=>'CA.LOOKUP.COLUMNS'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'&nbsp;<br>',
'<ul>',
unistr(' <li><strong>\30EB\30C3\30AF\30A2\30C3\30D7\5217</strong> - \5C55\958B\3057\3066\3001\5225\306E\8868\3078\306E\30EB\30C3\30AF\30A2\30C3\30D7\3092\5B9A\7FA9\3059\308B\305F\3081\306E\5C5E\6027\3092\8868\793A\3057\307E\3059\3002\30EB\30C3\30AF\30A2\30C3\30D7\5217\3092\4F7F\7528\3057\3066\3001\90E8\9580\756A\53F7\306E\304B\308F\308A\306B\90E8\9580\540D\3067\8868\793A\3059\308B\306A\3069\3001\8B58\5225\5B50\3092\8868\793A\5217\3067\7F6E\63DB\3057\307E\3059\3002<br>'),
unistr('<em><strong>\30CE\30FC\30C8:</strong> \300C\30EB\30C3\30AF\30A2\30C3\30D7\5217\300D\304C\8868\793A\3055\308C\308B\306E\306F\3001\73FE\5728\306E\30DA\30FC\30B8\304C\8868\307E\305F\306F\30D3\30E5\30FC\306B\57FA\3065\3044\3066\304A\308A\3001\73FE\5728\306E\30DA\30FC\30B8\306B\5225\306E\8868\3078\306E\5916\90E8\30AD\30FC\5236\7D04\304C\3042\308B\5834\5408\306E\307F\3067\3059\3002'),
'  <ul>',
unistr('    <li><strong>\30EB\30C3\30AF\30A2\30C3\30D7\30FB\30AD\30FC</strong> - \8868\793A\5217\3092\51FA\529B\3059\308B\305F\3081\306B\5909\66F4\3059\308B\5217\3092\9078\629E\3057\307E\3059\3002</li>'),
unistr('    <li><strong>\8868\793A\5217</strong> - \8868\793A\3059\308B\5217\3092(\30EB\30C3\30AF\30A2\30C3\30D7\8868\304B\3089)\9078\629E\3057\307E\3059\3002</li>'),
'    &nbsp;<br>',
unistr('    <em><strong>\30CE\30FC\30C8:</strong> \9078\629E\3067\304D\308B\5217\306F\3001(\5916\90E8\30AD\30FC\3092\4F7F\7528\3057\3066)\5225\306E\8868\3078\306E\53C2\7167\3092\6301\3064\5217\306E\307F\3067\3059\3002</em></li>'),
'  </ul>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104825354664309107)
,p_name=>'CA.MANAGE.EMAIL.TEMPLATES'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306E\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104823356008309105)
,p_name=>'CA.MANAGE.FEEDBACK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30FC\30C9\30D0\30C3\30AF\306E\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104819451282309102)
,p_name=>'CA.MANAGE.USER.ACCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\30FB\30A2\30AF\30BB\30B9\306E\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104851756286309127)
,p_name=>'CA.MASTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30B9\30BF\30FC\30FB\30C7\30A3\30C6\30FC\30EB\30FB\30DA\30FC\30B8\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104851825112309127)
,p_name=>'CA.MASTER.DETAILS'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\30C7\30FC\30BF\3092\8868\793A\304A\3088\3073\30E1\30F3\30C6\30CA\30F3\30B9\3067\304D\308B\3088\3046\306B\30DE\30B9\30BF\30FC\30FB\30C7\30A3\30C6\30FC\30EB\30FB\30DA\30FC\30B8\3092\8868\793A\3059\308B\30DA\30FC\30B8\3092\4F5C\6210\3057\307E\3059\3002<br>'),
'&nbsp;</p>',
unistr('<p>\6B21\306E\5C5E\6027\3092\5165\529B\3057\307E\3059\3002</p>'),
'<ul>',
unistr('  <li><strong>\30DA\30FC\30B8\540D</strong>(\5FC5\9808) - \3053\306E\30DA\30FC\30B8\306E\540D\524D\3092\5165\529B\3057\307E\3059\3002</li>'),
unistr('  <li><strong>\30A2\30A4\30B3\30F3\306E\8A2D\5B9A</strong> - \3053\306E\30DA\30FC\30B8\306E\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC\306B\8868\793A\3059\308B\30A2\30A4\30B3\30F3\3092\9078\629E\3057\307E\3059\3002</li>'),
unistr('  <li><strong>\30DA\30FC\30B8\30FB\30BF\30A4\30D7</strong> - \30DA\30FC\30B8\306E\30BF\30A4\30D7[\5DE6\53F3\3001\7A4D\4E0A\3052]\3092\9078\629E\3057\307E\3059\3002<br>'),
unistr('    <strong>\5DE6\53F3</strong>:<br>'),
unistr('<em>\5DE6\53F3\30EC\30A4\30A2\30A6\30C8\304A\3088\3073\30E2\30FC\30C0\30EB\7DE8\96C6\30A6\30A3\30F3\30C9\30A6\306B\3088\308B\30EC\30DD\30FC\30C8\30FB\30EA\30FC\30B8\30E7\30F3\3092\4F7F\7528\3059\308B\5358\4E00\30DA\30FC\30B8\30FB\30DE\30B9\30BF\30FC\30FB\30C7\30A3\30C6\30FC\30EB\3002</em>'),
'    <ul>',
unistr('      <li><strong>\8868</strong>(\5FC5\9808) - \30DA\30FC\30B8\306E\30DE\30B9\30BF\30FC\8868\3092\9078\629E\3057\307E\3059\3002</li>'),
unistr('      <li><strong>\30D7\30E9\30A4\30DE\30EA\8868\793A\5217</strong>(\5FC5\9808) - \30DE\30B9\30BF\30FC\30FB\30EC\30B3\30FC\30C9\306E\30EA\30B9\30C8\306B\8868\793A\3059\308B\5217\3092\9078\629E\3057\307E\3059\3002</li>'),
unistr('      <li><strong>\30BB\30AB\30F3\30C0\30EA\8868\793A\5217</strong>(\5FC5\9808) - \30DE\30B9\30BF\30FC\30FB\30EC\30B3\30FC\30C9\306E\30EA\30B9\30C8\306E\30D7\30E9\30A4\30DE\30EA\8868\793A\5217\306E\4E0B\306B\8868\793A\3059\308B\8AAC\660E\5217\3092\9078\629E\3057\307E\3059\3002</li>'),
unistr('      <li><strong>\30C7\30A3\30C6\30FC\30EB\88681</strong>(\5FC5\9808) - \30DA\30FC\30B8\306E\6700\521D\306E\30C7\30A3\30C6\30FC\30EB\8868\3092\9078\629E\3057\307E\3059\3002</li>'),
unistr('      <li><strong>\30C7\30A3\30C6\30FC\30EB\88682</strong> - \30DA\30FC\30B8\306E2\756A\76EE\306E\30C7\30A3\30C6\30FC\30EB\8868\3092\9078\629E\3057\307E\3059\3002</li>'),
unistr('      <li><strong>\30C7\30A3\30C6\30FC\30EB\88683</strong> - \30DA\30FC\30B8\306E3\756A\76EE\306E\30C7\30A3\30C6\30FC\30EB\8868\3092\9078\629E\3057\307E\3059\3002</li>'),
unistr('      <li><strong>\30C7\30A3\30C6\30FC\30EB\88684</strong> - \30DA\30FC\30B8\306E4\756A\76EE\306E\30C7\30A3\30C6\30FC\30EB\8868\3092\9078\629E\3057\307E\3059\3002</li>'),
'    </ul>',
unistr('   <strong>\7A4D\4E0A\3052</strong>:<br>'),
unistr('<em>\7DE8\96C6\53EF\80FD\5BFE\8A71\30B0\30EA\30C3\30C9\3092\4F7F\7528\3059\308B\3001\5358\4E00\30DA\30FC\30B8\30FB\30DE\30B9\30BF\30FC\30FB\30C7\30A3\30C6\30FC\30EB\3002</em>'),
'    <ul>',
unistr('      <li><strong>\8868</strong>(\5FC5\9808) - \7DE8\96C6\53EF\80FD\5BFE\8A71\30B0\30EA\30C3\30C9\306E\30DE\30B9\30BF\30FC\8868\3092\9078\629E\3057\307E\3059\3002</li>'),
unistr('      <li><strong>\30C7\30A3\30C6\30FC\30EB\8868</strong>(\5FC5\9808) - \30DA\30FC\30B8\306E\30C7\30A3\30C6\30FC\30EB\8868\3092\9078\629E\3057\307E\3059\3002</li>'),
unistr('      <em><strong>\30CE\30FC\30C8:</strong> \30A6\30A3\30B6\30FC\30C9\3092\4F7F\7528\3057\3066\8FFD\52A0\3067\304D\308B\306E\306F\30011\3064\306E\307F\306E\30C7\30A3\30C6\30FC\30EB\8868(\7DE8\96C6\53EF\80FD\5BFE\8A71\30B0\30EA\30C3\30C9)\3067\3059\3002\8FFD\52A0\306E\30C7\30A3\30C6\30FC\30EB\8868\306F\3001\751F\6210\5F8C\306B\7C21\5358\306B\8FFD\52A0\3067\304D\307E\3059\3002</em>'),
'    </ul>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104170600110308584)
,p_name=>'CA.MASTER_RECORDS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30B9\30BF\30FC\30FB\30EC\30B3\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104815608442309100)
,p_name=>'CA.MAX.ELAPSED'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5927\7D4C\904E\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104035794727308463)
,p_name=>'CA.MAX.FAILURES'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5927\969C\5BB3\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104035309551308463)
,p_name=>'CA.MAX.RUN.DURATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5927\5B9F\884C\671F\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104035849626308464)
,p_name=>'CA.MAX.RUNS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5927\5B9F\884C\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104846013335309122)
,p_name=>'CA.MAXIMUMROWS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5927\884C\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104849006887309124)
,p_name=>'CA.MAXIMUMWIDTH'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5927\5E45')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104839679978309117)
,p_name=>'CA.MD.ADD.FILTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30EB\30BF\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104840051003309118)
,p_name=>'CA.MD.ADD.ROW'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104839555412309117)
,p_name=>'CA.MD.APPLY.FILTERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30EB\30BF\306E\9069\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104840420944309118)
,p_name=>'CA.MD.DATE.VALUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5\4ED8\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104840577173309118)
,p_name=>'CA.MD.DATE.VALUE.2'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5\4ED8\5024 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104839781783309117)
,p_name=>'CA.MD.EDIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104839149789309117)
,p_name=>'CA.MD.FILTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30EB\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104839061522309117)
,p_name=>'CA.MD.FILTERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30EB\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104840161661309118)
,p_name=>'CA.MD.NO.FILTERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30EB\30BF\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104839460386309117)
,p_name=>'CA.MD.NO.RECORD.SELECTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30B3\30FC\30C9\304C\9078\629E\3055\308C\3066\3044\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104839320730309117)
,p_name=>'CA.MD.NO.RECORDS.FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30B3\30FC\30C9\304C\898B\3064\304B\308A\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104839950992309118)
,p_name=>'CA.MD.ROWS.DELETED'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\524A\9664\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104839870395309118)
,p_name=>'CA.MD.ROWS.UPDATED'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\66F4\65B0\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104839225807309117)
,p_name=>'CA.MD.SEARCH'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104840265129309118)
,p_name=>'CA.MD.VALUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104840312788309118)
,p_name=>'CA.MD.VALUE.2'
,p_message_language=>'ja'
,p_message_text=>unistr('\50242')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104815151586309099)
,p_name=>'CA.MEDIAN.ELAPSED'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E2D\9593\7D4C\904E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104824248297309106)
,p_name=>'CA.MESSAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E1\30C3\30BB\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104718269428309015)
,p_name=>'CA.MESSAGE_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E1\30C3\30BB\30FC\30B8\30FB\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104848518470309124)
,p_name=>'CA.METRIC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E1\30C8\30EA\30C3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104816049634309100)
,p_name=>'CA.MIN.ELAPSED'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5C0F\7D4C\904E\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104818863879309102)
,p_name=>'CA.MOBILE.PHONE'
,p_message_language=>'ja'
,p_message_text=>unistr('\643A\5E2F\96FB\8A71')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104814661358309099)
,p_name=>'CA.MODE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E2\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104828458040309109)
,p_name=>'CA.MORE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A73\7D30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104818031384309101)
,p_name=>'CA.MOST RECENT'
,p_message_language=>'ja'
,p_message_text=>'Most_Recent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104850908439309126)
,p_name=>'CA.MOST.ACTIVE.PAGES'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\3082\30A2\30AF\30C6\30A3\30D6\306A\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103808758477308254)
,p_name=>'CA.MULTIPLE.REPORTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\8907\6570\306E\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103808815890308254)
,p_name=>'CA.MULTIPLE.REPORTS.DETAILS'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>1\3064\4EE5\4E0A\306E\8868\540D\307E\305F\306F\30D3\30E5\30FC\540D\3092\9078\629E\3057\307E\3059\3002\307E\305F\306F\3001\30D8\30C3\30C0\30FC\306E\30C1\30A7\30C3\30AF\30FB\30DC\30C3\30AF\30B9\3092\30AF\30EA\30C3\30AF\3057\3066\3001\30EA\30B9\30C8\3055\308C\305F\3059\3079\3066\306E\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30AA\30D6\30B8\30A7\30AF\30C8\3092\9078\629E\307E\305F\306F\9078\629E\89E3\9664\3057\307E\3059\3002</p>'),
unistr('<p>\9078\629E\3055\308C\305F\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30AA\30D6\30B8\30A7\30AF\30C8\3054\3068\306B\3001\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\3092\542B\3080\30DA\30FC\30B8\304C\8FFD\52A0\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104812031973309097)
,p_name=>'CA.MUST.BE.VALID.TIMESTAMP'
,p_message_language=>'ja'
,p_message_text=>unistr('#LABEL#\306F\6709\52B9\306A\30BF\30A4\30E0\30B9\30BF\30F3\30D7\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104848369113309124)
,p_name=>'CA.NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\540D\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104803577643309091)
,p_name=>'CA.NAVIGATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CA\30D3\30B2\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104803617610309091)
,p_name=>'CA.NAVIGATION.DETAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\30E1\30CB\30E5\30FC\3092\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\6A2A\5074\306B\8868\793A\3059\308B\304B\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\4E0A\90E8\306B\8868\793A\3059\308B\304B\3092\9078\629E\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104855082589309129)
,p_name=>'CA.NEGATIVE'
,p_message_language=>'ja'
,p_message_text=>unistr('\60AA\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104854979415309129)
,p_name=>'CA.NEUTRAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\3069\3061\3089\3068\3082\3044\3048\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104841093828309118)
,p_name=>'CA.NEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104035577799308463)
,p_name=>'CA.NEXT.RUN.DATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\56DE\5B9F\884C\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104034448615308462)
,p_name=>'CA.NLS.ENV'
,p_message_language=>'ja'
,p_message_text=>unistr('NLS\74B0\5883')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104123444248308536)
,p_name=>'CA.NO'
,p_message_language=>'ja'
,p_message_text=>unistr('\3044\3044\3048')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104822997758309105)
,p_name=>'CA.NO.ACTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104834562725309114)
,p_name=>'CA.NO.HELP.AVAILABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DA\30FC\30B8\3067\4F7F\7528\53EF\80FD\306A\30D8\30EB\30D7\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103807517053308253)
,p_name=>'CA.NO.VALID.USER.EXIST.PAGEINFO'
,p_message_language=>'ja'
,p_message_text=>unistr('\6709\52B9\306A\30E6\30FC\30B6\30FC\304C\5B58\5728\3057\307E\305B\3093 - \30DA\30FC\30B8\60C5\5831')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104842021779309119)
,p_name=>'CA.NO.VALID.USER.FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\6709\52B9\306A\65B0\898F\30E6\30FC\30B6\30FC\304C\898B\3064\304B\308A\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104838110603309116)
,p_name=>'CA.NONE'
,p_message_language=>'ja'
,p_message_text=>unistr('\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104819136736309102)
,p_name=>'CA.NOTE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CE\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104794602886309084)
,p_name=>'CA.NOTIFICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\901A\77E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104793405253309083)
,p_name=>'CA.NOTIFICATION.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DB\30FC\30E0\30DA\30FC\30B8\306B\901A\77E5\3092\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104794734606309084)
,p_name=>'CA.NOTIFICATION.DETAIL'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30DB\30FC\30E0\30DA\30FC\30B8\4E0A\3067\3059\3079\3066\306E\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\8868\793A\3059\308B\30A2\30E9\30FC\30C8(\9EC4)\307E\305F\306F\30A8\30E9\30FC(\8D64)\3092\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\7BA1\7406\8005\304C\6307\5B9A\3067\304D\308B\3088\3046\306B\3057\307E\3059\3002\3053\306E\6A5F\80FD\306F\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\30FB\30B3\30DF\30E5\30CB\30C6\30A3\306B\91CD\8981\306A\60C5\5831\3092\4E2D\7D99\3059\308B\5834\5408\306B\4FBF\5229\3067\3059\3002</p>'),
unistr('<p>\6B21\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\304C\542B\307E\308C\307E\3059\3002<ul>'),
unistr('<li>\901A\77E5\3092\5B9A\7FA9\3059\308B\6A5F\80FD</li>'),
unistr('<li>\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30DB\30FC\30E0\30DA\30FC\30B8\4E0A\3067\306E\901A\77E5\306E\8868\793A</li>'),
unistr('<li>\901A\77E5\8868\793A\306E\6642\9593\30A6\30A3\30F3\30C9\30A6\3092\5236\5FA1\3059\308B\6A5F\80FD</li>'),
unistr('<li>\30BF\30A4\30D7\5225\306E\901A\77E5\306E\8272\5206\3051\306E\30B5\30DD\30FC\30C8</li>'),
'</ul>',
'</p>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104811367337309096)
,p_name=>'CA.NOTIFICATION.NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\540D\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104814898078309099)
,p_name=>'CA.NUM.ROWS'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104037645737308465)
,p_name=>'CA.NUMBER.OF.ARGUMENTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5F15\6570\306E\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104034266470308462)
,p_name=>'CA.NUMBER.OF.DESTINATIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9B\5148\306E\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104846565496309123)
,p_name=>'CA.NUMBERFORMATMASK'
,p_message_language=>'ja'
,p_message_text=>unistr('\6570\5024\66F8\5F0F\30DE\30B9\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104816338860309100)
,p_name=>'CA.OCCURRENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\767A\751F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104855260089309129)
,p_name=>'CA.ONE.ADMIN.REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\5225\306E\7BA1\7406\8005\304C\3044\306A\3044\5834\5408\3001\3053\306E\51E6\7406\3092\5B9F\884C\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104823125530309105)
,p_name=>'CA.OPEN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30FC\30D7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104796139135309085)
,p_name=>'CA.ORGANIZING.PAGES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306E\7DE8\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104796486757309085)
,p_name=>'CA.ORGANIZING.PAGES.DETAIL'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\8868\793A\3059\308B\76EE\7684\3067\30DA\30FC\30B8\306E\9806\5E8F\3092\5909\66F4\3057\307E\3059\3002 <br>'),
unistr('\30EA\30B9\30C8\5185\306E\30DA\30FC\30B8\306E\9806\5E8F\3092\5909\66F4\3059\308B\306B\306F\3001\5404\30DA\30FC\30B8\306E\30EA\30B9\30C8\306E\6700\5F8C\306B\3042\308B<em>\300C\30C9\30E9\30C3\30B0\3057\3066\30DA\30FC\30B8\306E\4E26\66FF\3048\300D</em>\30A2\30A4\30B3\30F3( <span class="fa fa-bars" aria-hidden="true"></span> )\3092\30AF\30EA\30C3\30AF\3057\3066\4FDD\6301\3057\3001\305D\306E\30DA\30FC\30B8\3092\4E0A\4E0B\306B\30C9\30E9\30C3\30B0\30FB\30A2\30F3\30C9\30FB\30C9\30ED\30C3\30D7\3057\307E\3059\3002</p>'),
unistr('<p>\30DB\30FC\30E0\30DA\30FC\30B8\306F\3001\5E38\306B\6700\521D\306B\8868\793A\3055\308C\308B\305F\3081\3001\9806\5E8F\3092\5909\66F4\3059\308B\3053\3068\306F\3067\304D\307E\305B\3093\3002<br>'),
unistr('\7BA1\7406\30DA\30FC\30B8\306F\5E38\306B\30EA\30B9\30C8\306E\4E0B\90E8\306B\8868\793A\3055\308C\3001\305D\306E\9806\5E8F\306F\300C\7BA1\7406\300D\30DA\30FC\30B8\306E\300C\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\7BA1\7406\300D\30EA\30B9\30C8\306B\8868\793A\3055\308C\308B\9806\5E8F\3092\793A\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104039760802308467)
,p_name=>'CA.OUTPUT'
,p_message_language=>'ja'
,p_message_text=>unistr('\51FA\529B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104040929178308468)
,p_name=>'CA.OWNER'
,p_message_language=>'ja'
,p_message_text=>unistr('\6240\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104814516532309099)
,p_name=>'CA.PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104817735301309101)
,p_name=>'CA.PAGE.EVENTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30A4\30D9\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104830247367309110)
,p_name=>'CA.PAGE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306E\30D8\30EB\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104816867022309101)
,p_name=>'CA.PAGE.ITEM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104172432044308586)
,p_name=>'CA.PAGE.MD.EDIT_MASTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30B9\30BF\30FC\30FB\30EC\30B3\30FC\30C9\306E\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104172632528308586)
,p_name=>'CA.PAGE.MD.PERFORM_SEARCH'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22\306E\5B9F\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104814109903309099)
,p_name=>'CA.PAGE.NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104829536783309110)
,p_name=>'CA.PAGE.NAVIGATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30CA\30D3\30B2\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104816230884309100)
,p_name=>'CA.PAGE.PERFORMANCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30D1\30D5\30A9\30FC\30DE\30F3\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104841149316309118)
,p_name=>'CA.PAGE.TYPE.NOT.VALID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30BF\30A4\30D7"%0"\306F\6709\52B9\306A\30BF\30A4\30D7\3067\306F\3042\308A\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104815549380309100)
,p_name=>'CA.PAGE.VIEWS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30D3\30E5\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104796668308309086)
,p_name=>'CA.PAGES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104796749838309086)
,p_name=>'CA.PAGES.DETAIL'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\521D\671F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\542B\3081\308B1\3064\4EE5\4E0A\306E\30DA\30FC\30B8\3092\5B9A\7FA9\3057\307E\3059\3002\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\4F5C\6210\3059\308B\306B\306F\3001\5C11\306A\304F\3068\30821\3064\306E\30DA\30FC\30B8\3092\5B9A\7FA9\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>'),
unistr('<p>\3053\306E\30A6\30A3\30B6\30FC\30C9\3092\4F7F\7528\3057\3066\4EFB\610F\306E\6570\306E\30DA\30FC\30B8\3092\4F5C\6210\3057\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\30B9\30BF\30D6\3067\7F6E\63DB\3067\304D\307E\3059\3002\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\4F5C\6210\5F8C\3001\30DA\30FC\30B8\306E\4F5C\6210\30A6\30A3\30B6\30FC\30C9\3092\4F7F\7528\3057\3066\5225\306E\30DA\30FC\30B8\3092\8FFD\52A0\3057\307E\3059\3002</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104846476549309122)
,p_name=>'CA.PAGINATIONMETHOD'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\533A\5207\308A\30E1\30BD\30C3\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104815819788309100)
,p_name=>'CA.PARTIAL.PAGE.VIEWS'
,p_message_language=>'ja'
,p_message_text=>unistr('\90E8\5206\30DA\30FC\30B8\30FB\30D3\30E5\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104821687640309104)
,p_name=>'CA.PHOTO'
,p_message_language=>'ja'
,p_message_text=>unistr('\5199\771F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104822284594309105)
,p_name=>'CA.PHOTO.DELETED'
,p_message_language=>'ja'
,p_message_text=>unistr('\5199\771F\304C\524A\9664\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104821765396309104)
,p_name=>'CA.PHOTO.NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\5199\771F\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104821451726309104)
,p_name=>'CA.PHOTO.UPLOAD'
,p_message_language=>'ja'
,p_message_text=>unistr('\5199\771F\306E\30A2\30C3\30D7\30ED\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104718337967309015)
,p_name=>'CA.PK_VALUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E3B\30AD\30FC\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104826206192309107)
,p_name=>'CA.PLAIN.TEXT.TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30EC\30FC\30F3\30FB\30C6\30AD\30B9\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104854811493309129)
,p_name=>'CA.POSITIVE'
,p_message_language=>'ja'
,p_message_text=>unistr('\826F\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104809061683309095)
,p_name=>'CA.PREFERENCES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30EA\30D5\30A1\30EC\30F3\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104852458125309127)
,p_name=>'CA.PREVIOUS'
,p_message_language=>'ja'
,p_message_text=>unistr('\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104847150556309123)
,p_name=>'CA.PRIMARYDISPLAYCOLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30E9\30A4\30DE\30EA\8868\793A\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104848052256309124)
,p_name=>'CA.PRIMARYKEYCOLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E3B\30AD\30FC\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104848147590309124)
,p_name=>'CA.PRIMARYPARENTTABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30E9\30A4\30DE\30EA\89AA\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104816476441309100)
,p_name=>'CA.PROCEDURE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30B7\30FC\30B8\30E3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104809677404309095)
,p_name=>'CA.PROCESS.EMAIL.SUCCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\30FB\30D7\30EA\30D5\30A1\30EC\30F3\30B9\304C\66F4\65B0\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104172230066308585)
,p_name=>'CA.PROCESS.FETCH_ROW'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\306E\30D5\30A7\30C3\30C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104718597160309015)
,p_name=>'CA.PROCESS.GET_LOG_DETAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30B0\8A73\7D30\306E\53D6\5F97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104810822525309096)
,p_name=>'CA.PROCESS.THEME.PREFERENCE.SUCCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\5916\89B3\306E\8A2D\5B9A\304C\4FDD\5B58\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104809560503309095)
,p_name=>'CA.PROCESS.TIME.ZONE.SUCCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30E0\30BE\30FC\30F3\30FB\30D7\30EA\30D5\30A1\30EC\30F3\30B9\304C\66F4\65B0\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104822027698309104)
,p_name=>'CA.PROFILE.PHOTO.DOWNLOAD'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30D5\30A1\30A4\30EB\5199\771F\306E\30C0\30A6\30F3\30ED\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104037994844308465)
,p_name=>'CA.PROGRAM.NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30B0\30E9\30E0\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104038067415308465)
,p_name=>'CA.PROGRAM.OWNER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30B0\30E9\30E0\6240\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103550950434308052)
,p_name=>'CA.PWA'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30B0\30EC\30C3\30B7\30D6Web\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30A4\30F3\30B9\30C8\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103550894099308052)
,p_name=>'CA.PWA.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\30A4\30F3\30B9\30C8\30FC\30EB\6A5F\80FD\3092\63D0\4F9B\3057\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103551004727308052)
,p_name=>'CA.PWA.DETAIL'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30D7\30ED\30B0\30EC\30C3\30B7\30D6Web\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306F\3001\80FD\529B\304A\3088\3073\4FE1\983C\6027\304C\9AD8\304F\3001\30A4\30F3\30B9\30C8\30FC\30EB\304C\53EF\80FD\306A\3088\3046\306B\8A2D\8A08\3055\308C\305FWeb\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\3059\3002\30D7\30ED\30B0\30EC\30C3\30B7\30D6Web\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306F\3001\30D7\30E9\30C3\30C8\30D5\30A9\30FC\30E0\56FA\6709\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\3088\3046\306B\898B\3048\307E\3059\3002</p>'),
unistr('<p>\3053\306E\30AA\30D7\30B7\30E7\30F3\3092\6709\52B9\306B\3059\308B\3068:</p>'),
'<ul>',
unistr('<li>\65B0\898F\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30D0\30FC\30FB\30A8\30F3\30C8\30EA\300C\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30A4\30F3\30B9\30C8\30FC\30EB\300D\304C\8FFD\52A0\3055\308C\307E\3059</li>'),
unistr('<li>\30E6\30FC\30B6\30FC\304C\3053\306EAPEX\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\30C7\30D0\30A4\30B9\306B\30A4\30F3\30B9\30C8\30FC\30EB\3067\304D\307E\3059</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103546914774308049)
,p_name=>'CA.PWA.INSTALL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30A4\30F3\30B9\30C8\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104847465340309123)
,p_name=>'CA.QUERY'
,p_message_language=>'ja'
,p_message_text=>unistr('\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104034787960308463)
,p_name=>'CA.RAISE.EVENTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30D9\30F3\30C8\306E\751F\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103676454106308147)
,p_name=>'CA.RATING'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A55\4FA1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104819923658309103)
,p_name=>'CA.READERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30C0\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104809314737309095)
,p_name=>'CA.RECEIVE.EMAILS'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\306E\53D7\4FE1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104851052880309126)
,p_name=>'CA.RECENT.ERRORS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\65B0\306E\30A8\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104487101693308829)
,p_name=>'CA.RECENT.ERRORS.LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104487278731308829)
,p_name=>'CA.RECENT.ERRORS.VALUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104811559524309097)
,p_name=>'CA.RED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30C3\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104825188889309107)
,p_name=>'CA.REFERENCED'
,p_message_language=>'ja'
,p_message_text=>unistr('\53C2\7167')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104171343599308585)
,p_name=>'CA.REFRESH.ADMIN_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\7BA1\7406\30DA\30FC\30B8\306E\30EA\30D5\30EC\30C3\30B7\30E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103788640337308238)
,p_name=>'CA.REFRESH.ON.DIALOG.CLOSE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C0\30A4\30A2\30ED\30B0\306E\30AF\30ED\30FC\30BA\6642\306B\30EA\30D5\30EC\30C3\30B7\30E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104172526402308586)
,p_name=>'CA.REFRESH_REPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\306E\30EA\30D5\30EC\30C3\30B7\30E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104811004960309096)
,p_name=>'CA.REGION.BUTTONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3\30FB\30EA\30FC\30B8\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104810902075309096)
,p_name=>'CA.REGION.FORM.ITEMS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30FC\30E0\30FB\30A2\30A4\30C6\30E0\30FB\30EA\30FC\30B8\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104816939748309101)
,p_name=>'CA.REGION.ID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104828913366309109)
,p_name=>'CA.RELEASE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30EA\30FC\30B9%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104796289158309085)
,p_name=>'CA.REMOVING.PAGES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306E\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104796379735309085)
,p_name=>'CA.REMOVING.PAGES.DETAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('<p><strong>\300C\7DE8\96C6\300D</strong>\3092\30AF\30EA\30C3\30AF\3057\3066\30DA\30FC\30B8\3092\9078\629E\3057\3001<strong>\300C\30DA\30FC\30B8\306E\524A\9664\300D</strong>\3092\30AF\30EA\30C3\30AF\3057\3066\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304B\3089\30DA\30FC\30B8\3092\524A\9664\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104039351389308466)
,p_name=>'CA.REPEAT.INTERVAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\7E70\8FD4\3057\9593\9694')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103911281394308336)
,p_name=>'CA.REPLY.TO'
,p_message_language=>'ja'
,p_message_text=>unistr('\8FD4\4FE1\5148')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104802085673309090)
,p_name=>'CA.REPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\30FB\30DA\30FC\30B8\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104801921316309090)
,p_name=>'CA.REPORT.DETAILS'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\307E\305F\306F\30AF\30E9\30B7\30C3\30AF\30FB\30EC\30DD\30FC\30C8\3068\3057\3066\8868\793A\3059\308B\30DA\30FC\30B8\3092\4F5C\6210\3057\307E\3059\3002</p>'),
unistr('<p>\6B21\306E\5C5E\6027\3092\5165\529B\3057\307E\3059\3002</p>'),
'<ul>',
unistr('  <li><strong>\30DA\30FC\30B8\540D</strong>(\5FC5\9808) - \3053\306E\30DA\30FC\30B8\306E\540D\524D\3092\5165\529B\3057\307E\3059\3002</li>'),
unistr('  <li><strong>\30A2\30A4\30B3\30F3\306E\8A2D\5B9A</strong> - \3053\306E\30DA\30FC\30B8\306E\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC\306B\8868\793A\3059\308B\30A2\30A4\30B3\30F3\3092\9078\629E\3057\307E\3059\3002</li>'),
unistr('  <li><strong>\554F\5408\305B\30BF\30A4\30D7</strong> - \30EC\30DD\30FC\30C8\306E\30BD\30FC\30B9[<strong>\8868\307E\305F\306F\30D3\30E5\30FC</strong>\307E\305F\306F<strong>SQL\554F\5408\305B</strong>]\3092\9078\629E\3057\307E\3059\3002<br>'),
unistr('    <strong>\8868\307E\305F\306F\30D3\30E5\30FC</strong>:'),
'    <ul>',
unistr('      <li>\8868\307E\305F\306F\30D3\30E5\30FC(\5FC5\9808) - \30EC\30DD\30FC\30C8\306E\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30AA\30D6\30B8\30A7\30AF\30C8\3092\9078\629E\3057\307E\3059\3002</li>'),
unistr('      <li>\30D5\30A9\30FC\30E0\3092\542B\3081\308B - \30E6\30FC\30B6\30FC\304C\8868\306E\5024\3092\7BA1\7406\3067\304D\308B\3088\3046\306B\3001\30EA\30F3\30AF\3055\308C\305F\30D5\30A9\30FC\30E0\30FB\30DA\30FC\30B8\3092\542B\3081\308B\5834\5408\306B\9078\629E\3057\307E\3059\3002</li>'),
'    </ul>',
unistr('    <strong>SQL\554F\5408\305B</strong>:'),
'    <ul>',
unistr('      <li>SQL\554F\5408\305B(\5FC5\9808) - \56FA\6709\306E\5217\3092\623B\3059\6709\52B9\306ASQL\6587\3092\5165\529B\3057\307E\3059\3002</li>'),
'    </ul>',
'  </li>',
unistr('  <li><strong>\30EC\30DD\30FC\30C8\30FB\30BF\30A4\30D7</strong> - \30EC\30DD\30FC\30C8\306E\30BF\30A4\30D7(<strong>\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8</strong>\307E\305F\306F<strong>\30AF\30E9\30B7\30C3\30AF\30FB\30EC\30DD\30FC\30C8</strong>)\3092\9078\629E\3057\307E\3059\3002</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104793774634309083)
,p_name=>'CA.REPORT.N.WITH.FORM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30FC\30E0\4ED8\304D\306E%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104676353576308980)
,p_name=>'CA.REPORT.TABLE_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104850130609309125)
,p_name=>'CA.REPORT.VIEW'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\30FB\30D3\30E5\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104848764432309124)
,p_name=>'CA.REPORTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104040714109308468)
,p_name=>'CA.REQ.START.DATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30AF\30A8\30B9\30C8\3055\308C\305F\958B\59CB\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104848958219309124)
,p_name=>'CA.REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\5FC5\9808')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104827028756309108)
,p_name=>'CA.RESET'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30BB\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104823071421309105)
,p_name=>'CA.RESOLVED'
,p_message_language=>'ja'
,p_message_text=>unistr('\89E3\6C7A\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104822777129309105)
,p_name=>'CA.RESPONSE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30B9\30DD\30F3\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104036071841308464)
,p_name=>'CA.RESTART.ON.FAILURE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5931\6557\6642\306B\518D\8D77\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104036147710308464)
,p_name=>'CA.RESTART.ON.RECOVERY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30AB\30D0\30EA\6642\306B\518D\8D77\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104033354293308461)
,p_name=>'CA.RESTARTABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\518D\8D77\52D5\53EF\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104035684797308463)
,p_name=>'CA.RETRY.COUNT'
,p_message_language=>'ja'
,p_message_text=>unistr('\518D\8A66\884C\56DE\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104843944541309121)
,p_name=>'CA.ROLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104817134958309101)
,p_name=>'CA.ROW.NUMBER'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\756A\53F7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104826482445309108)
,p_name=>'CA.ROW.TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104843341147309120)
,p_name=>'CA.ROW.TEMPLATE.HTML'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\30C6\30F3\30D7\30EC\30FC\30C8HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104844682807309121)
,p_name=>'CA.ROWS.CONTENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\30B3\30F3\30C6\30F3\30C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104817802767309101)
,p_name=>'CA.ROWS.FETCHED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A7\30C3\30C1\3055\308C\305F\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104846378475309122)
,p_name=>'CA.ROWSPERPAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\3054\3068\306E\884C\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104038953497308466)
,p_name=>'CA.RUN.COUNT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9F\884C\56DE\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104040573387308467)
,p_name=>'CA.RUN.DURATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9F\884C\671F\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104035464835308463)
,p_name=>'CA.SCHEDULE.LIMIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30B1\30B8\30E5\30FC\30EB\5236\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104037402183308465)
,p_name=>'CA.SCHEDULE.NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30B1\30B8\30E5\30FC\30EB\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104037534011308465)
,p_name=>'CA.SCHEDULE.OWNER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30B1\30B8\30E5\30FC\30EB\6240\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104037338851308465)
,p_name=>'CA.SCHEDULE.TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30B1\30B8\30E5\30FC\30EB\30FB\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104804508517309091)
,p_name=>'CA.SCHEMA'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AD\30FC\30DE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104804640913309092)
,p_name=>'CA.SCHEMA.DETAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\4F7F\7528\3059\308B\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30AA\30D6\30B8\30A7\30AF\30C8\3092\683C\7D0D\3059\308B\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30B9\30AD\30FC\30DE\3092\9078\629E\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104845422069309122)
,p_name=>'CA.SCOPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6709\52B9\7BC4\56F2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104827159610309108)
,p_name=>'CA.SEARCH'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104827273005309108)
,p_name=>'CA.SEARCH.APPLICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104827396513309108)
,p_name=>'CA.SEARCH.DIALOG'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22\30C0\30A4\30A2\30ED\30B0\30FB\30DC\30C3\30AF\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104850384783309125)
,p_name=>'CA.SEARCH.FILTERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22\30D5\30A3\30EB\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104834075827309113)
,p_name=>'CA.SEARCH.HIDDEN.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\3053\306E\30DA\30FC\30B8\306F\3001\691C\7D22\6E08\306E\8868\3068\3044\3046\5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8\30FB\30EA\30B9\30C8\304B\3089\5C0E\51FA\3055\308C\307E\3059\3002'),
'',
unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\4F5C\6210\30A6\30A3\30B6\30FC\30C9\304B\3089\6700\521D\306B\751F\6210\3055\308C\305F\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\30FB\30DA\30FC\30B8\306F\30EA\30B9\30C8\306B\81EA\52D5\7684\306B\8FFD\52A0\3055\308C\307E\3059\3002 '),
unistr('\72EC\81EA\306E\8868\3092\30EA\30B9\30C8\306B\8FFD\52A0\3059\308B\306B\306F\3001\300C\5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8\300D\306B\79FB\52D5\3057\3001\300C\30EA\30B9\30C8\300D\3092\9078\629E\3057\3066\300C\691C\7D22\6E08\306E\8868\300D\3092\30AF\30EA\30C3\30AF\3057\307E\3059\3002'),
unistr('  \6B21\306E\5C5E\6027\3092\5165\529B\3057\307E\3059\3002'),
unistr('    \30A8\30F3\30C8\30EA: \30EA\30B9\30C8\30FB\30A8\30F3\30C8\30EA\30FB\30E9\30D9\30EB - \8868\306E\8868\793A\540D\3092\5165\529B\3057\307E\3059\3002'),
unistr('    \30BF\30FC\30B2\30C3\30C8: \30DA\30FC\30B8 - \30CA\30D3\30B2\30FC\30C8\5148\306E\9069\5207\306A\30DA\30FC\30B8\3092\9078\629E\3057\307E\3059(\304A\305D\3089\304F\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8)'),
unistr('    \30BF\30FC\30B2\30C3\30C8: \30AD\30E3\30C3\30B7\30E5\306E\30AF\30EA\30A2 - \30AF\30EA\30A2\3059\308B\5FC5\8981\306E\3042\308B\30DA\30FC\30B8\3092\5165\529B\3057\307E\3059(\4E00\822C\306B\306F\3001\30DA\30FC\30B8\3067\5165\529B\3057\305F\306E\3068\540C\3058\756A\53F7)\3002'),
unistr('       \5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\30FB\30DA\30FC\30B8\306B\30CA\30D3\30B2\30FC\30C8\3059\308B\5834\5408\306F\3001\305F\3068\3048\3070CIR,RIR\3092\8FFD\52A0\3057\3066\65E2\5B58\306E\30D5\30A3\30EB\30BF\3092\30AF\30EA\30A2\3057\307E\3059\3002'),
unistr('    \30BF\30FC\30B2\30C3\30C8: \3053\308C\3089\306E\30A2\30A4\30C6\30E0\3092\8A2D\5B9A - \79FB\5165\3059\308B\9069\5207\306A\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3092\9078\629E(\307E\305F\306F\5165\529B)\3057\307E\3059\3002'),
unistr('       \5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\30FB\30DA\30FC\30B8\306B\30CA\30D3\30B2\30FC\30C8\3059\308B\5834\5408\306F\3001IR_[COLUMN_NAME]\3068\5165\529B\3057\307E\3059\3002'),
unistr('    \30BF\30FC\30B2\30C3\30C8: \3053\308C\3089\306E\5024\3092\4F7F\7528\3057\307E\3059 - =PK=\3068\5165\529B\3057\307E\3059'),
unistr('    \30E6\30FC\30B6\30FC\5B9A\7FA9\5C5E\6027: 1 - \691C\7D22\3059\308B\8868\540D\3092\5927\6587\5B57\3067\5165\529B\3057\307E\3059\3002'),
unistr('    \30E6\30FC\30B6\30FC\5B9A\7FA9\5C5E\6027: 2 - \30D7\30E9\30A4\30DE\30EA\5217\540D\3092\5927\6587\5B57\3067\5165\529B\3057\307E\3059\3002'),
unistr('    \30E6\30FC\30B6\30FC\5B9A\7FA9\5C5E\6027: 3 (\30AA\30D7\30B7\30E7\30F3) -  \691C\7D22\3059\308B\5217\306E\30AB\30F3\30DE\533A\5207\308A\30EA\30B9\30C8\3002'),
unistr('       \5217\304C\6307\5B9A\3055\308C\3066\3044\306A\3044\5834\5408\306F\3001\3059\3079\3066\306E\30C6\30AD\30B9\30C8(varchar2)\304A\3088\3073\30AD\30E3\30E9\30AF\30BF\30FB\30E9\30FC\30B8\30FB\30AA\30D6\30B8\30A7\30AF\30C8(clob)\5217\304C\691C\7D22\3055\308C\307E\3059\3002'),
'',
unistr('\30CE\30FC\30C8: \8907\6570\306E\8868\304C\30EA\30B9\30C8\3055\308C\3066\3044\308B\5834\5408\306F\3001\691C\7D22\53EF\80FD\306A\8868\306E\30EA\30B9\30C8\306E\307F\30E6\30FC\30B6\30FC\306B\8868\793A\3055\308C\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104826854452309108)
,p_name=>'CA.SEARCH.RESULTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22\7D50\679C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104847946300309124)
,p_name=>'CA.SECONDARYDISPLAYCOLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30AB\30F3\30C0\30EA\8868\793A\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104823436146309105)
,p_name=>'CA.SELECTED.TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3057\305F\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103910513263308335)
,p_name=>'CA.SEND.BEGIN'
,p_message_language=>'ja'
,p_message_text=>unistr('\9001\4FE1\958B\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103910920289308336)
,p_name=>'CA.SEND.COUNT'
,p_message_language=>'ja'
,p_message_text=>unistr('\9001\4FE1\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103910441180308335)
,p_name=>'CA.SEND.END'
,p_message_language=>'ja'
,p_message_text=>unistr('\9001\4FE1\7D42\4E86')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103910879133308336)
,p_name=>'CA.SEND.ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\9001\4FE1\30A8\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104853985005309128)
,p_name=>'CA.SEND.FEEDBACK.EMAILS'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\306E\9001\4FE1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104854070745309128)
,p_name=>'CA.SEND.FEEDBACK.EMAILS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\3057\3044\30D5\30A3\30FC\30C9\30D0\30C3\30AF\306E\53D7\4FE1\6642\306B\96FB\5B50\30E1\30FC\30EB\3092\9001\4FE1\3059\308B\304B\3069\3046\304B\3092\6C7A\5B9A\3057\307E\3059\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104850682715309126)
,p_name=>'CA.SEND.FROM'
,p_message_language=>'ja'
,p_message_text=>unistr('\9001\4FE1\5143')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104843197993309120)
,p_name=>'CA.SEND.TO'
,p_message_language=>'ja'
,p_message_text=>unistr('\9001\4FE1\5148')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104828724850309109)
,p_name=>'CA.SERIES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30EA\30FC\30BA%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104040420321308467)
,p_name=>'CA.SESSION.ID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30C3\30B7\30E7\30F3ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104845685993309122)
,p_name=>'CA.SESSIONSTATEPROTECTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\4FDD\8B77')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104803943853309091)
,p_name=>'CA.SETTINGS'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104804005080309091)
,p_name=>'CA.SETTINGS.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\751F\6210\306B\4F7F\7528\3055\308C\308B\8A2D\5B9A\3092\6307\5B9A\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104828339964309109)
,p_name=>'CA.SHOW.ALL'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103788114499308238)
,p_name=>'CA.SHOW.HIDE.SCOPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6709\52B9\7BC4\56F2\306E\8868\793A/\975E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104829457081309110)
,p_name=>'CA.SHOW.TIMEZONE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30E0\30BE\30FC\30F3\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104829298200309110)
,p_name=>'CA.SIGN.IN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30A4\30F3\30A4\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104830420161309110)
,p_name=>'CA.SIGN.OUT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30A4\30F3\30A2\30A6\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104040337212308467)
,p_name=>'CA.SLAVE.PID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30EC\30FC\30D6PID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104034387022308462)
,p_name=>'CA.SOURCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BD\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104841232771309119)
,p_name=>'CA.SOURCE.TYPE.NOT.VALID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BD\30FC\30B9\30FB\30BF\30A4\30D7\304C\6709\52B9\306A\30BF\30A4\30D7\3067\306F\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104834177173309113)
,p_name=>'CA.SOURCES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BD\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104037261366308465)
,p_name=>'CA.START.DATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\59CB\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104717786266309015)
,p_name=>'CA.STARTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104039054828308466)
,p_name=>'CA.STATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\72B6\614B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104848838529309124)
,p_name=>'CA.STATICDEFAULT'
,p_message_language=>'ja'
,p_message_text=>unistr('\9759\7684\30C7\30D5\30A9\30EB\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104813126619309098)
,p_name=>'CA.STATUS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30C6\30FC\30BF\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104035035294308463)
,p_name=>'CA.STOP.ON.WINDOW.CLOSE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A6\30A3\30F3\30C9\30A6\3092\9589\3058\308B\969B\306E\505C\6B62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104035117953308463)
,p_name=>'CA.STORE.OUTPUT'
,p_message_language=>'ja'
,p_message_text=>unistr('\51FA\529B\306E\683C\7D0D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104823666807309106)
,p_name=>'CA.SUBJECT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4EF6\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104822371842309105)
,p_name=>'CA.SUBMIT.FEEDBACK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30FC\30C9\30D0\30C3\30AF\306E\9001\4FE1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104717950339309015)
,p_name=>'CA.SUCCESSFUL_ROWS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6210\529F\3057\305F\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104845922980309122)
,p_name=>'CA.SUGGESTEDVISULIZATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\63A8\5968\3055\308C\308B\8996\899A\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104837832121309116)
,p_name=>'CA.SUPPORTING.OBJECTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30DD\30FC\30C8\3059\308B\30AA\30D6\30B8\30A7\30AF\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104837978439309116)
,p_name=>'CA.SUPPORTING.OBJECTS.DETAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\30A4\30F3\30B9\30C8\30FC\30EB\30FB\30B9\30AF\30EA\30D7\30C8\306B\306F\3001\4E00\822C\306B\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30AA\30D6\30B8\30A7\30AF\30C8\306E\4F5C\6210\3084\64CD\4F5C\3001\307E\305F\306F\65E2\5B58\306E\30EC\30B3\30FC\30C9\306B\5BFE\3059\308B\633F\5165/\66F4\65B0/\524A\9664\306E\5B9F\884C\306E\305F\3081\306E\30B3\30FC\30C9\3092\5165\529B\3057\307E\3059\3002\524A\9664\30B9\30AF\30EA\30D7\30C8\306B\306F\3001\4E00\822C\306B\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30AA\30D6\30B8\30A7\30AF\30C8\3092\524A\9664\3059\308B\305F\3081\306E\30B3\30FC\30C9\3092\5165\529B\3057\307E\3059\3002\3053\308C\3089\306E\30B9\30AF\30EA\30D7\30C8\306F\300C\30B5\30DD\30FC\30C8\3059\308B\30AA\30D6\30B8\30A7\30AF\30C8\300D\306B\7D44\307F\8FBC\307E\308C\308B\305F\3081\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30A8\30AF\30B9\30DD\30FC\30C8\6642\306B\3001\30C6\30B9\30C8\304A\3088\3073\672C\756A\74B0\5883\3067\3053\308C\3089\306E\540C\3058\66F4\65B0\304C\5B9F\884C\3055\308C\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104838099275309116)
,p_name=>'CA.SUPPORTING.OBJECTS.PAGE'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30A4\30F3\30DD\30FC\30C8\6642\306B\5B9F\884C\3055\308C\308B\30A4\30F3\30B9\30C8\30FC\30EB\30FB\30B9\30AF\30EA\30D7\30C8\306B\6709\52B9\306ASQL\307E\305F\306FPL/SQL\6587\3001\3042\308B\3044\306F\305D\306E\4E21\65B9\3092\5165\529B\3057\307E\3059\3002</p>'),
unistr('<p>\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304C\5225\306E\74B0\5883\306B\30A4\30F3\30DD\30FC\30C8\3055\308C\305F\3068\304D\3060\3051\3067\306A\304F\73FE\5728\306E\74B0\5883\3067\3082\3053\308C\3089\306E\6587\3092\5B9F\884C\3059\308B\5834\5408\306F\3001<strong>\300C\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\4F5C\6210\6642\306B\5B9F\884C\300D</strong>\3092\30AF\30EA\30C3\30AF\3057\307E\3059\3002</p>'),
unistr('<p>\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304C\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30D3\30EB\30C0\30FC\304B\3089\524A\9664\3055\308C\305F\3068\304D\306B\5B9F\884C\3055\308C\308B\524A\9664\30B9\30AF\30EA\30D7\30C8\306B\6709\52B9\306ASQL\307E\305F\306FPL/SQL\6587\3001\3042\308B\3044\306F\305D\306E\4E21\65B9\3092\5165\529B\3057\307E\3059\3002</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104034624422308463)
,p_name=>'CA.SYSTEM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30B9\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104847356026309123)
,p_name=>'CA.TABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104804769609309092)
,p_name=>'CA.TABLE.PREFIX'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30EC\30FC\30E0\30EF\30FC\30AF\30FB\30AA\30D6\30B8\30A7\30AF\30C8\63A5\982D\8F9E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104804808798309092)
,p_name=>'CA.TABLE.PREFIX.DETAIL'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\4F7F\7528\3059\308B\30AA\30D6\30B8\30A7\30AF\30C8\63A5\982D\8F9E\3092\5165\529B\3057\307E\3059\3002\4E00\90E8\306E\6A5F\80FD\306F\3001\4F5C\6210\3059\308B\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30AA\30D6\30B8\30A7\30AF\30C8(\30D1\30C3\30B1\30FC\30B8\3084\8868\3092\542B\3080)\306B\3053\306E\63A5\982D\8F9E\3092\8FFD\52A0\3057\307E\3059\3002</p>'),
unistr('<p>\8B66\544A: \5FC5\305A\4ED6\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\4F7F\7528\3055\308C\3066\3044\306A\3044\4E00\610F\306E\63A5\982D\8F9E\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002\4E00\610F\3067\306F\306A\3044\5834\5408\3001\4F5C\6210\6642\306B\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\30A8\30E9\30FC\304C\767A\751F\3057\3001\6B63\3057\304F\52D5\4F5C\3057\306A\3044\53EF\80FD\6027\304C\3042\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104848225348309124)
,p_name=>'CA.TABLECOLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\306E\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104843285095309120)
,p_name=>'CA.TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104826769961309108)
,p_name=>'CA.TEMPLATE.EXISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30C6\30F3\30D7\30EC\30FC\30C8\540D\306F\3059\3067\306B\4F7F\7528\3055\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104823594002309105)
,p_name=>'CA.TEMPLATE.NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104812216224309097)
,p_name=>'CA.TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103910770560308335)
,p_name=>'CA.TEXT.BODY.SIZE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8\30FB\30DC\30C7\30A3\30FB\30B5\30A4\30BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104824793970309106)
,p_name=>'CA.TEXT.TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104810431257309096)
,p_name=>'CA.THEME.PREFERENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306E\30C6\30FC\30DE\30FB\30D7\30EA\30D5\30A1\30EC\30F3\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104810616486309096)
,p_name=>'CA.THEME.PREFERENCE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3059\308B\3068\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\3001\300C\30AB\30B9\30BF\30DE\30A4\30BA\300D\30EA\30F3\30AF\3092\4F7F\7528\3057\3066\72EC\81EA\306E\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB\3092\9078\629E\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104810566499309096)
,p_name=>'CA.THEME.PREFERENCE.LOV'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\3088\308B\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB\306E\9078\629E\3092\8A31\53EF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104794876731309084)
,p_name=>'CA.THEME.SELECTOR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB\306E\9078\629E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104793278470309083)
,p_name=>'CA.THEME.SELECTOR.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30EB\30C3\30AF\30FB\30A2\30F3\30C9\30FB\30D5\30A3\30FC\30EB\306E\66F4\65B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104794929406309084)
,p_name=>'CA.THEME.SELECTOR.DETAIL'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\7BA1\7406\8005\304C\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30C7\30D5\30A9\30EB\30C8\306E\30AB\30E9\30FC\30FB\30B9\30AD\30FC\30E0(\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB)\3092\9078\629E\3067\304D\308B\3088\3046\306B\3057\307E\3059\3002\7BA1\7406\8005\306F\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\305D\306E\72EC\81EA\306E\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB\306E\9078\629E\3092\8A31\53EF\3059\308B\3053\3068\3082\3067\304D\307E\3059\3002\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\3001\30DB\30FC\30E0\30DA\30FC\30B8\306E\4E00\756A\4E0B\306B\3042\308B<em>\300C\30AB\30B9\30BF\30DE\30A4\30BA\300D</em>\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3057\3066\3001\4F7F\7528\53EF\80FD\306A\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB\304B\3089\9078\629E\3059\308B\3060\3051\3067\3059\3002\305F\3068\3048\3070\3001\8996\529B\306B\969C\5BB3\306E\3042\308B\30E6\30FC\30B6\30FC\306F\3001\30AB\30E9\30FC\30FB\30B3\30F3\30C8\30E9\30B9\30C8\304C\975E\5E38\306B\9AD8\3044<em>\300CVista\300D</em>\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB\3092\512A\5148\7684\306B\4F7F\7528\3067\304D\307E\3059\3002</p>'),
unistr('<p>\6B21\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\304C\542B\307E\308C\307E\3059\3002'),
'<ul>',
unistr('<li>\7BA1\7406\8005\306B\3088\308B\30C7\30D5\30A9\30EB\30C8\30FB\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB\306E\5B9A\7FA9\306E\8A31\53EF</li>'),
unistr('<li>\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\3088\308B\69D8\3005\306A\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB\306E\9078\629E\306E\8A31\53EF</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104803322489309091)
,p_name=>'CA.THEME.STYLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104803496531309091)
,p_name=>'CA.THEME.STYLE.DETAIL'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\8868\793A\306B\4F7F\7528\3059\308B\30C7\30D5\30A9\30EB\30C8\306E\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB\3092\9078\629E\3057\307E\3059\3002</p>'),
unistr('<p>\30B9\30BF\30A4\30EB\306F\3001\4E8B\524D\5B9A\7FA9\3055\308C\305F\5225\306E\30B9\30BF\30A4\30EB\306B\7C21\5358\306B\5909\66F4\3057\305F\308A\3001\751F\6210\5F8C\306B\5909\66F4\3057\305F\308A\3067\304D\307E\3059\3002\30B9\30BF\30A4\30EB\3092\5909\66F4\3059\308B\306B\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\5B9F\884C\3057\3066\300C\958B\767A\8005\300D\30C4\30FC\30EB\30D0\30FC\306E<strong>\300C\30C6\30FC\30DE\30FB\30ED\30FC\30E9\30FC\300D</strong>\3092\30AF\30EA\30C3\30AF\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104817402693309101)
,p_name=>'CA.TIME'
,p_message_language=>'ja'
,p_message_text=>unistr('\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104809174988309095)
,p_name=>'CA.TIME.ZONE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30E0\30BE\30FC\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104795991371309085)
,p_name=>'CA.TIME.ZONE.SUPPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30E0\30BE\30FC\30F3\30FB\30B5\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104792864539309083)
,p_name=>'CA.TIME.ZONE.SUPPORT.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\304A\3088\3073\30E6\30FC\30B6\30FC\30FB\30BF\30A4\30E0\30BE\30FC\30F3\306E\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104795638480309085)
,p_name=>'CA.TIME.ZONE.SUPPORT.DETAIL'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\30ED\30FC\30AB\30EB\30FB\30BF\30A4\30E0\30BE\30FC\30F3\3092\8A2D\5B9A\3067\304D\308B\3088\3046\306B\3057\307E\3059\3002\3053\308C\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\8868\3067\30BF\30A4\30E0\30BE\30FC\30F3\5BFE\5FDC\306E\65E5\4ED8\30BF\30A4\30D7(Timestamp with Local Time Zone\306A\3069)\3092\4F7F\7528\3057\3066\304A\308A\3001\30EC\30DD\30FC\30C8\3084\30C7\30FC\30BF\5165\529B\3067\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306E\6240\5728\5834\6240\3092\53CD\6620\3059\308B\5834\5408\306B\91CD\8981\3067\3059\3002</p>'),
unistr('<p>\6B21\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\304C\542B\307E\308C\307E\3059:'),
'<ul>',
unistr('<li>\7BA1\7406\8005\306B\3088\308B\30C7\30D5\30A9\30EB\30C8\30FB\30BF\30A4\30E0\30BE\30FC\30F3\306E\8A2D\5B9A\306E\8A31\53EF</li>'),
unistr('<li>\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\3088\308B\5404\81EA\306E\30BF\30A4\30E0\30BE\30FC\30F3\30FB\30D7\30EA\30D5\30A1\30EC\30F3\30B9\306E\9078\629E\306E\8A31\53EF</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104851231113309126)
,p_name=>'CA.TIMEFRAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\6642\9593\67A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104851506084309126)
,p_name=>'CA.TIMELINE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30E0\30E9\30A4\30F3\30FB\30DA\30FC\30B8\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104851638080309126)
,p_name=>'CA.TIMELINE.DETAILS'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\7279\306B\66F4\65B0\3092\8868\793A\3059\308B\5834\5408\306B\5F79\7ACB\3064\30BF\30A4\30E0\30E9\30A4\30F3\3092\8868\793A\3059\308B\30DA\30FC\30B8\3092\4F5C\6210\3057\307E\3059\3002</p>'),
unistr('<p>\6B21\306E\5C5E\6027\3092\5165\529B\3057\307E\3059\3002</p>'),
'<ul>',
unistr('  <li><strong>\30DA\30FC\30B8\540D</strong>(\5FC5\9808) - \3053\306E\30DA\30FC\30B8\306E\540D\524D\3092\5165\529B\3057\307E\3059\3002</li>'),
unistr('  <li><strong>\30A2\30A4\30B3\30F3\306E\8A2D\5B9A</strong> - \3053\306E\30DA\30FC\30B8\306E\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC\306B\8868\793A\3059\308B\30A2\30A4\30B3\30F3\3092\9078\629E\3057\307E\3059\3002</li>'),
unistr('  <li><strong>\8868\307E\305F\306F\30D3\30E5\30FC</strong>(\5FC5\9808) - \30BF\30A4\30E0\30E9\30A4\30F3\306E\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30AA\30D6\30B8\30A7\30AF\30C8\3092\9078\629E\3057\307E\3059\3002</li>'),
unistr('  <li><strong>\30E6\30FC\30B6\30FC\540D</strong>(\5FC5\9808) - \30BF\30A4\30E0\30E9\30A4\30F3\30FB\30A8\30F3\30C8\30EA\306B\8868\793A\3055\308C\308B\30E6\30FC\30B6\30FC\3068\3057\3066\4F7F\7528\3059\308B\5217\3092\8868\307E\305F\306F\30D3\30E5\30FC\304B\3089\9078\629E\3057\307E\3059\3002</li>'),
unistr('  <li><strong>\65E5\4ED8</strong>(\5FC5\9808) - \30BF\30A4\30E0\30E9\30A4\30F3\30FB\30A8\30F3\30C8\30EA\306E\65E5\4ED8\3068\3057\3066\4F7F\7528\3059\308B\5217\3092\8868\307E\305F\306F\30D3\30E5\30FC\304B\3089\9078\629E\3057\307E\3059\3002</li>'),
unistr('  <li><strong>\30A4\30D9\30F3\30C8\540D</strong>(\5FC5\9808) - \30BF\30A4\30E0\30E9\30A4\30F3\30FB\30A8\30F3\30C8\30EA\306E\30BF\30A4\30C8\30EB\3068\3057\3066\4F7F\7528\3059\308B\5217\3092\8868\307E\305F\306F\30D3\30E5\30FC\304B\3089\9078\629E\3057\307E\3059\3002</li>'),
unistr('  <li><strong>\8AAC\660E</strong> - \30BF\30A4\30E0\30E9\30A4\30F3\30FB\30A8\30F3\30C8\30EA\306E\8AAC\660E\3068\3057\3066\4F7F\7528\3059\308B\5217\3092\8868\307E\305F\306F\30D3\30E5\30FC\304B\3089\9078\629E\3057\307E\3059\3002</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104814393485309099)
,p_name=>'CA.TIMESTAMP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30E0\30B9\30BF\30F3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104818924228309102)
,p_name=>'CA.TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30C8\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103911350216308336)
,p_name=>'CA.TO'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9B\5148')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104818182819309101)
,p_name=>'CA.TOP.USERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C8\30C3\30D7\30FB\30E6\30FC\30B6\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104818244978309102)
,p_name=>'CA.TOP.USERS.CHART'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0A\4F4D\30E6\30FC\30B6\30FC\30FB\30C1\30E3\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104815701517309100)
,p_name=>'CA.TOTAL.ROWS'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\5408\8A08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104820159723309103)
,p_name=>'CA.TREAT.AUTH.USERS.NO.IN.ACL.AS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30BB\30B9\5236\5FA1\30EA\30B9\30C8\306B\5B58\5728\3057\306A\3044\30E6\30FC\30B6\30FC\306E\30C7\30D5\30A9\30EB\30C8\306E\30ED\30FC\30EB:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104812344789309097)
,p_name=>'CA.TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104122875854308535)
,p_name=>'CA.UI.DEFAULTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\306E\30C7\30D5\30A9\30EB\30C8\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104122931710308536)
,p_name=>'CA.UI.DEFAULTS.DETAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\3054\3068\306E\884C\6570\306A\3069\306E\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\8A2D\5B9A\306E\30C7\30D5\30A9\30EB\30C8\3092\8A2D\5B9A\3057\3001LOV\306E\5B9A\7FA9\3092\8FFD\52A0\3057\307E\3059\3002\3053\308C\3089\306E\8A2D\5B9A\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5185\3067\30B3\30F3\30DD\30FC\30CD\30F3\30C8\3092\751F\6210\3059\308B\969B\306B\4F7F\7528\3055\308C\307E\3059\3002 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104812567825309097)
,p_name=>'CA.UNTIL'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D42\4E86')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104171190051308584)
,p_name=>'CA.UPDATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F4\65B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104821983072309104)
,p_name=>'CA.UPDATE.PROFILE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30D5\30A1\30A4\30EB\306E\66F4\65B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104812864724309098)
,p_name=>'CA.UPDATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F4\65B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104812921032309098)
,p_name=>'CA.UPDATED.BY'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F4\65B0\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104814268494309099)
,p_name=>'CA.USER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104840768994309118)
,p_name=>'CA.USER.ADD_MULTIPLE_1'
,p_message_language=>'ja'
,p_message_text=>unistr('\8907\6570\30E6\30FC\30B6\30FC\306E\8FFD\52A0 - \30B9\30C6\30C3\30D71')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104840833570309118)
,p_name=>'CA.USER.ADD_MULTIPLE_2'
,p_message_language=>'ja'
,p_message_text=>unistr('\8907\6570\30E6\30FC\30B6\30FC\306E\8FFD\52A0 - \30B9\30C6\30C3\30D72')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104840999754309118)
,p_name=>'CA.USER.ADD_MULTIPLE_USERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\8907\6570\30E6\30FC\30B6\30FC\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104816639937309100)
,p_name=>'CA.USER.AGENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\30FB\30A8\30FC\30B8\30A7\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104830045007309110)
,p_name=>'CA.USER.COUNTS.REPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\6570\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104818498005309102)
,p_name=>'CA.USER.NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104820964682309104)
,p_name=>'CA.USER.PROFILE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\30FB\30D7\30ED\30D5\30A1\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104795820324309085)
,p_name=>'CA.USER.PROFILES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\30FB\30D7\30ED\30D5\30A1\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104792779303309083)
,p_name=>'CA.USER.PROFILES.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\306B\3088\308B\30D7\30ED\30D5\30A1\30A4\30EB\306E\66F4\65B0\3092\8A31\53EF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104795759212309085)
,p_name=>'CA.USER.PROFILES.DETAIL'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\753B\50CF\3084\30A2\30D0\30BF\30FC\306A\3069\81EA\8EAB\306B\95A2\3059\308B\8FFD\52A0\60C5\5831\3092\5165\529B\3057\3066\81EA\5206\306E\30A2\30AB\30A6\30F3\30C8\3092\30D1\30FC\30BD\30CA\30E9\30A4\30BA\3067\304D\308B\3088\3046\306B\3057\307E\3059\3002</p>'),
unistr('<p>\6B21\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\304C\542B\307E\308C\307E\3059:'),
'<ul>',
unistr('<li>\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\81EA\5206\306E\30D7\30ED\30D5\30A1\30A4\30EB\3092\8A2D\5B9A\3059\308B\305F\3081\306E\30DA\30FC\30B8\306E\8A2D\5B9A</li>'),
unistr('<li>\5199\771F/\30A2\30D0\30BF\30FC\3092\30A2\30C3\30D7\30ED\30FC\30C9\3059\308B\6A5F\80FD</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104821136186309104)
,p_name=>'CA.USERNAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104820295387309103)
,p_name=>'CA.USERNAME.FORMAT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\540D\306E\5F62\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104841642375309119)
,p_name=>'CA.USERNAMES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104130388234308542)
,p_name=>'CA.USERNAME_FORMAT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\540D\306E\5F62\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104842261843309119)
,p_name=>'CA.USERS.ADDED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\304C\8FFD\52A0\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104843795691309120)
,p_name=>'CA.USERS.BY.ROLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30FC\30EB\5225\30E6\30FC\30B6\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104824331837309106)
,p_name=>'CA.USERS.INCLUDED'
,p_message_language=>'ja'
,p_message_text=>unistr('\542B\307E\308C\308B\30E6\30FC\30B6\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104841981489309119)
,p_name=>'CA.USERS.TO.ADD'
,p_message_language=>'ja'
,p_message_text=>unistr('\8FFD\52A0\3059\308B\30E6\30FC\30B6\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104820471645309103)
,p_name=>'CA.USRENAME.FORMAT.UPDATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\540D\306E\5F62\5F0F\304C\66F4\65B0\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103807315985308253)
,p_name=>'CA.VALID.USER.EXIST.PAGEINFO'
,p_message_language=>'ja'
,p_message_text=>unistr('\6709\52B9\306A\30E6\30FC\30B6\30FC\304C\5B58\5728\3057\307E\3059 - \30DA\30FC\30B8\60C5\5831')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104836086471309115)
,p_name=>'CA.VALIDATION.APP.ID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3ID\306F\3059\3067\306B\5B58\5728\3059\308B\304B\3001\5225\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\4E88\7D04\3055\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104077627407308498)
,p_name=>'CA.VALIDATION.APP.NAME.NOT.NULL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\540D\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104844382356309121)
,p_name=>'CA.VALIDATION.EMAIL.REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\306E\9001\4FE1\5148\306E\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104844180752309121)
,p_name=>'CA.VALIDATION.EMAIL.ROLE.REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9\3092\6307\5B9A\3059\308B\304B\3001\96FB\5B50\30E1\30FC\30EB\306E\9001\4FE1\5148\30E6\30FC\30B6\30FC\306E\30BB\30C3\30C8\3092\9078\629E\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104844279724309121)
,p_name=>'CA.VALIDATION.ROLE.REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\306E\9001\4FE1\5148\30E6\30FC\30B6\30FC\306E\30BB\30C3\30C8\3092\9078\629E\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104836128646309115)
,p_name=>'CA.VALIDATION.TABLE.PREFIX'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\63A5\982D\8F9E\306F\30016\6587\5B57\4EE5\4E0B\3067\3001\6587\5B57\304B\3089\59CB\3081\308B\5FC5\8981\304C\3042\308A\3001\6587\5B57\3001\6570\5B57\304A\3088\3073\30A2\30F3\30C0\30FC\30B9\30B3\30A2\306E\307F\542B\3081\308B\3053\3068\304C\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104836281668309115)
,p_name=>'CA.VALIDATION.TABLE.PREFIX.USED'
,p_message_language=>'ja'
,p_message_text=>unistr('\5225\306E\8868\63A5\982D\8F9E\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002\6B21\306E\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30AA\30D6\30B8\30A7\30AF\30C8\306F\3059\3067\306B\5B58\5728\3057\307E\3059: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104820802419309103)
,p_name=>'CA.VERIFY.EMAIL.ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\540D\304C\6709\52B9\306A\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9\5F62\5F0F\3067\306F\3042\308A\307E\305B\3093\3002\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\6B21\306E\30E6\30FC\30B6\30FC\540D\306E\5F62\5F0F\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104820738524309103)
,p_name=>'CA.VERIFY.EMAIL.FORMAT'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\5F62\5F0F\306E\78BA\8A8D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104818382020309102)
,p_name=>'CA.VIEW.AS'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\5F62\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104838692407309117)
,p_name=>'CA.VIEW.BLUEPRINT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EB\30FC\30D7\30EA\30F3\30C8\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104828247149309109)
,p_name=>'CA.VIEW.DETAILS'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A73\7D30\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104844503982309121)
,p_name=>'CA.VIEW.EMAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\306E\8868\793A')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104830351131309110)
,p_name=>'CA.VIEW.MY.PROFILE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30D5\30A1\30A4\30EB\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104815296009309099)
,p_name=>'CA.WEIGHTED.PERFORMANCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\91CD\307F\4ED8\3051\30D1\30D5\30A9\30FC\30DE\30F3\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104849183966309125)
,p_name=>'CA.WIDTH'
,p_message_language=>'ja'
,p_message_text=>unistr('\5E45')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104853365281309128)
,p_name=>'CA.WIZARD'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A6\30A3\30B6\30FC\30C9\30FB\30DA\30FC\30B8\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103807219069308253)
,p_name=>'CA.WIZARD.CONTAINER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A6\30A3\30B6\30FC\30C9\30FB\30B3\30F3\30C6\30CA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104853423303309128)
,p_name=>'CA.WIZARD.DETAILS'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30A6\30A3\30B6\30FC\30C9\3068\3057\3066\4F7F\7528\3059\308B\30DA\30FC\30B8\306E\30B3\30EC\30AF\30B7\30E7\30F3\3092\4F5C\6210\3057\307E\3059\3002\4E00\822C\306B\3001\30A6\30A3\30B6\30FC\30C9\306F\3001\8907\6570\306E\30B9\30C6\30C3\30D7\3067\30C7\30FC\30BF\3092\5165\529B\3059\308B\5834\5408\306B\4F7F\7528\3057\307E\3059\3002</p>'),
unistr('<p>\6B21\306E\5C5E\6027\3092\5165\529B\3057\307E\3059\3002</p>'),
'<ul>',
unistr('  <li><strong>\30A6\30A3\30B6\30FC\30C9\540D</strong>(\5FC5\9808) - \3053\306E\30DA\30FC\30B8\306E\540D\524D\3092\5165\529B\3057\307E\3059\3002</li>'),
unistr('  <li><strong>\30A2\30A4\30B3\30F3\306E\8A2D\5B9A</strong> - \3053\306E\30DA\30FC\30B8\306E\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC\306B\8868\793A\3059\308B\30A2\30A4\30B3\30F3\3092\9078\629E\3057\307E\3059\3002</li>'),
unistr('  <li><strong>\30DA\30FC\30B8\30FB\30E2\30FC\30C9</strong>(\5FC5\9808) - \30A6\30A3\30B6\30FC\30C9\306E\30B9\30C6\30C3\30D7\3092\30E2\30FC\30C0\30EB\30FB\30DA\30FC\30B8\304B\901A\5E38\306E\30DA\30FC\30B8\306E\3069\3061\3089\3067\8868\793A\3059\308B\304B\3092\9078\629E\3057\307E\3059\3002<strong>\30E2\30FC\30C0\30EB\30FB\30DA\30FC\30B8</strong>\307E\305F\306F<strong>\30D5\30EB\30FB\30DA\30FC\30B8</strong>\306E\3044\305A\308C\304B\3092\9078\629E\3057\307E\3059\3002</li>'),
unistr('  <li><strong>\30B9\30C6\30C3\30D71 ... 8</strong> - \30A6\30A3\30B6\30FC\30C9\306E\30B9\30C6\30C3\30D7\306E\30DA\30FC\30B8\540D\3092\5165\529B\3057\307E\3059\3002<br><em><strong>\30CE\30FC\30C8:</strong> \30B9\30C6\30C3\30D75\304B\30898\307E\3067\306F\3001\305D\306E\524D\306E\30B9\30C6\30C3\30D7\3067\540D\524D\304C\5165\529B\3055\308C\308B\3068\8868\793A\3055\308C\307E\3059\3002</em></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104818728173309102)
,p_name=>'CA.WORK.PHONE'
,p_message_language=>'ja'
,p_message_text=>unistr('\52E4\52D9\5148\96FB\8A71')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104811422434309097)
,p_name=>'CA.YELLOW'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30A8\30ED\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104123372756308536)
,p_name=>'CA.YES'
,p_message_language=>'ja'
,p_message_text=>unistr('\306F\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103676355833308147)
,p_name=>'CACHED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AD\30E3\30C3\30B7\30E5\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103579545172308073)
,p_name=>'CACHE_CREATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F5C\6210\6E08\306E\30AD\30E3\30C3\30B7\30E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103567181406308064)
,p_name=>'CALENDAR.CHECK.AJAX_DELETE_NOT_ENABLED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\306E\524A\9664\6A5F\80FD\304C\7121\52B9\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103552161389308053)
,p_name=>'CALENDAR.CHECK.AJAX_INSERT_NOT_ENABLED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\306E\8FFD\52A0\6A5F\80FD\304C\7121\52B9\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103552255956308053)
,p_name=>'CALENDAR.CHECK.AJAX_UPDATE_NOT_ENABLED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\306E\66F4\65B0\6A5F\80FD\304C\7121\52B9\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103705095271308171)
,p_name=>'CALENDAR.NEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103704923405308171)
,p_name=>'CALENDAR.PREVIOUS'
,p_message_language=>'ja'
,p_message_text=>unistr('\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103591352821308081)
,p_name=>'CALENDAR_EASY_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\7C21\6613\30AB\30EC\30F3\30C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104609299995308926)
,p_name=>'CALENDAR_ENTRY_EDIT_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30EC\30F3\30C0\30FB\30A8\30F3\30C8\30EA\306E\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103540671121308045)
,p_name=>'CALENDAR_POPUP'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306E\30AB\30EC\30F3\30C0\30FB\30DD\30C3\30D7\30A2\30C3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103672058060308144)
,p_name=>'CALENDAR_SUCCESS_MSG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30EC\30F3\30C0\304C\6B63\5E38\306B\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104061671808308485)
,p_name=>'CALENDAR_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30AC\30B7\30FC\30FB\30AB\30EC\30F3\30C0\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103591221131308081)
,p_name=>'CALENDAR_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30EC\30F3\30C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103924635330308378)
,p_name=>'CAL_TEMPLATE_NOT_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3%0\3068\30C6\30F3\30D7\30EC\30FC\30C8ID %1\304B\3089\30B3\30D4\30FC\3092\8A66\884C\3057\307E\3057\305F\304C\3001\30AB\30EC\30F3\30C0\30FB\30C6\30F3\30D7\30EC\30FC\30C8\304C\898B\3064\304B\308A\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104063029271308486)
,p_name=>'CANCEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\53D6\6D88')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103547102991308049)
,p_name=>'CARD_ACTIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30FC\30C9\30FB\30A2\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104295064967308678)
,p_name=>'CASCADING STYLE SHEETS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30B9\30B1\30FC\30C9\30FB\30B9\30BF\30A4\30EB\30B7\30FC\30C8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104142499428308552)
,p_name=>'CHANGES'
,p_message_language=>'ja'
,p_message_text=>unistr('\5909\66F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104719591041309016)
,p_name=>'CHANGE_AUTHENTICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\306E\5909\66F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104058377528308482)
,p_name=>'CHANGE_DATABASE_SIZE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30B5\30A4\30BA\306E\5909\66F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104058161783308482)
,p_name=>'CHANGE_REQUEST'
,p_message_language=>'ja'
,p_message_text=>unistr('\5909\66F4\30EA\30AF\30A8\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104271899976308662)
,p_name=>'CHANGE_WORKSPACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306E\5909\66F4')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104031679762308460)
,p_name=>'CHARACTER_SET_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\6587\5B57\30BB\30C3\30C8\5217')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103753224134308210)
,p_name=>'CHART'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103535968563308041)
,p_name=>'CHART.CHART_QUERY_SYNTAX_INVALID'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\7121\52B9\306A\30C1\30E3\30FC\30C8\554F\5408\305B: %0<br><br>'),
unistr('\6B21\306E\69CB\6587\3092\4F7F\7528:'),
'<pre>',
'SELECT LINK, LABEL, VALUE',
'FROM   ...',
'</pre>',
'<table class="instructiontext">',
'<tr><td>LINK</td><td>URL</td></tr>',
unistr('<tr><td>LABEL</td><td>\30D0\30FC\306B\5C5E\3059\308B\30C6\30AD\30B9\30C8</td></tr>'),
unistr('<tr><td>VALUE</td><td>\30D0\30FC\30FB\30B5\30A4\30BA\3092\5B9A\7FA9\3059\308B\6570\5024\5217</td></tr>'),
'</table>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103700808707308168)
,p_name=>'CHART.DIAL_CHART_QUERY_SYNTAX_INVALID'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\7121\52B9\306A\30C1\30E3\30FC\30C8\554F\5408\305B\3002<br /><br /> \6B21\306E\69CB\6587\3092\4F7F\7528: <pre> SELECT VALUE, MAX, (LOW), (HIGH) VALUE FROM ... </pre>'),
'<table class="instructiontext">',
'<tr>',
'<td>VALUE</td>',
unistr('<td>\30C0\30A4\30E4\30EB\5024\3092\5B9A\7FA9\3059\308B\6570\5024\5217\3002</td>'),
'</tr>',
'<tr>',
'<td>MAX</td>',
unistr('<td>\6700\5927\30C0\30A4\30E4\30EB\5024\3092\5B9A\7FA9\3059\308B\6570\5024\5217\3002</td>'),
'</tr>',
'<tr>',
unistr('<td>LOW (\30AA\30D7\30B7\30E7\30F3)</td>'),
unistr('<td>\524D\306E\6700\5C0F\30C0\30A4\30E4\30EB\5024\3092\5B9A\7FA9\3059\308B\6570\5024\5217\3002</td>'),
'</tr>',
'<tr>',
unistr('<td>HIGH (\30AA\30D7\30B7\30E7\30F3)</td>'),
unistr('<td>\524D\306E\6700\5927\30C0\30A4\30E4\30EB\5024\3092\5B9A\7FA9\3059\308B\6570\5024\5217\3002</td>'),
'</tr>',
'</table>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103767610185308222)
,p_name=>'CHART.INVALID_CHART_TYPE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\30FB\30BF\30A4\30D7\304C\7121\52B9\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103535811011308041)
,p_name=>'CHART.INVALID_QUERY'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('SQL\554F\5408\305B\306E\89E3\6790\306B\5931\6557\3002'),
'<p>%0</p>',
unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\5B9F\884C\6642\306B\7279\5B9A\306E\554F\5408\305B\306E\307F\304C\5B9F\884C\3055\308C\3001\554F\5408\305B\306E\69CB\6587\304C\6B63\3057\3044\5834\5408\306F\3001\691C\8A3C\3092\884C\308F\306A\304F\3066\3082\305D\306E\554F\5408\305B\3092\4FDD\5B58\3067\304D\307E\3059(\6B21\306E\554F\5408\305B\30BD\30FC\30B9\306E\30AA\30D7\30B7\30E7\30F3\3092\53C2\7167)\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104759186893309049)
,p_name=>'CHART_DEGREES'
,p_message_language=>'ja'
,p_message_text=>unistr('\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104009137321308442)
,p_name=>'CHART_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306E\30C1\30E3\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103567689303308064)
,p_name=>'CHART_SERIES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\30FB\30B7\30EA\30FC\30BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104054896403308479)
,p_name=>'CHART_SERIES_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('%1\306E\30C1\30E3\30FC\30C8\30FB\30B7\30EA\30FC\30BA\30FB\30A8\30E9\30FC%0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103663805757308138)
,p_name=>'CHART_SUCCESS_MSG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\304C\6B63\5E38\306B\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104012980686308445)
,p_name=>'CHECKSUM_REQUIRED_APPLICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30A7\30C3\30AF\30B5\30E0\304C\5FC5\8981 - \30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30EC\30D9\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103846015739308282)
,p_name=>'CHECKSUM_REQUIRED_SESSION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30A7\30C3\30AF\30B5\30E0\304C\5FC5\8981 - \30BB\30C3\30B7\30E7\30F3\30FB\30EC\30D9\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103845995795308282)
,p_name=>'CHECKSUM_REQUIRED_USER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30A7\30C3\30AF\30B5\30E0\304C\5FC5\8981 - \30E6\30FC\30B6\30FC\30FB\30EC\30D9\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103845807165308282)
,p_name=>'CHECKSUM_REQUIRED_WORKSPACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30A7\30C3\30AF\30B5\30E0\304C\5FC5\8981 - \30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30EC\30D9\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104759979151309050)
,p_name=>'CHECK_ALL'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\3092\30C1\30A7\30C3\30AF')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103998406859308434)
,p_name=>'CLASSIC_CALENDAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30E9\30B7\30C3\30AF\30FB\30AB\30EC\30F3\30C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104001134008308436)
,p_name=>'CLASSIC_REPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30E9\30B7\30C3\30AF\30FB\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103699608178308166)
,p_name=>'CLASSIC_REPORT_COLUMNS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30E9\30B7\30C3\30AF\30FB\30EC\30DD\30FC\30C8\306E\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103998874778308434)
,p_name=>'CLASSIC_TREE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30E9\30B7\30C3\30AF\30FB\30C4\30EA\30FC')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103996790218308433)
,p_name=>'CLEAN_UP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306E\30AF\30EA\30FC\30F3\30A2\30C3\30D7')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103562425797308061)
,p_name=>'CLEAR_COMMAND'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30DE\30F3\30C9\306E\30AF\30EA\30A2')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104006055919308440)
,p_name=>'CLOSED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30ED\30FC\30BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104051677665308476)
,p_name=>'CLOSED_LAST_7_DAYS'
,p_message_language=>'ja'
,p_message_text=>unistr('\904E\53BB7\65E5\9593\306B\30AF\30ED\30FC\30BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103804754216308251)
,p_name=>'CLOSE_WINDOW'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A6\30A3\30F3\30C9\30A6\3092\9589\3058\308B')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104540182318308867)
,p_name=>'CODE_EDITOR.ACCESSIBILITY_MODE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30BB\30B7\30D3\30EA\30C6\30A3\30FB\30E2\30FC\30C9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104836353590309115)
,p_name=>'CODE_EDITOR.CLOSE'
,p_message_language=>'ja'
,p_message_text=>unistr('\9589\3058\308B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104837305206309116)
,p_name=>'CODE_EDITOR.FIND'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104837241644309116)
,p_name=>'CODE_EDITOR.HINT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30FC\30C8\30B3\30F3\30D7\30EA\30FC\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104664921559308971)
,p_name=>'CODE_EDITOR.INDENTATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30C7\30F3\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104836688402309115)
,p_name=>'CODE_EDITOR.INDENT_SIZE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30C7\30F3\30C8\30FB\30B5\30A4\30BA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104836892748309115)
,p_name=>'CODE_EDITOR.INDENT_WITH_TABS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30D6\633F\5165\9818\57DF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104540257237308868)
,p_name=>'CODE_EDITOR.ITEM_DOES_NOT_EXIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0%0\306F\5B58\5728\3057\307E\305B\3093')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104541371681308868)
,p_name=>'CODE_EDITOR.MINIMAP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DF\30CB\30DE\30C3\30D7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104541231755308868)
,p_name=>'CODE_EDITOR.MINIMAP_CONDITIONAL'
,p_message_language=>'ja'
,p_message_text=>unistr('100\884C\3092\8D85\3048\308B\5834\5408\306E\307F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104840640468309118)
,p_name=>'CODE_EDITOR.QUERY_BUILDER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30A8\30EA\30FC\30FB\30D3\30EB\30C0\30FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104837443849309116)
,p_name=>'CODE_EDITOR.REDO'
,p_message_language=>'ja'
,p_message_text=>unistr('\3084\308A\76F4\3057')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104837084713309115)
,p_name=>'CODE_EDITOR.SETTINGS'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A2D\5B9A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104836905936309115)
,p_name=>'CODE_EDITOR.SHOW_LINE_NUMBERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\756A\53F7\306E\8868\793A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104836401266309115)
,p_name=>'CODE_EDITOR.SHOW_RULER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EB\30FC\30E9\30FC\306E\8868\793A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104541136388308868)
,p_name=>'CODE_EDITOR.SUGGESTIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5019\88DC\306E\8868\793A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104836769132309115)
,p_name=>'CODE_EDITOR.TAB_SIZE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30D6\30FB\30B5\30A4\30BA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104836585996309115)
,p_name=>'CODE_EDITOR.THEMES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104541067160308868)
,p_name=>'CODE_EDITOR.THEME_AUTOMATIC'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\52D5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104540931799308868)
,p_name=>'CODE_EDITOR.THEME_DARK'
,p_message_language=>'ja'
,p_message_text=>unistr('\6FC3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104540799272308868)
,p_name=>'CODE_EDITOR.THEME_HIGH_CONTRAST_DARK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CF\30A4\30FB\30B3\30F3\30C8\30E9\30B9\30C8\6FC3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104540808770308868)
,p_name=>'CODE_EDITOR.THEME_LIGHT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6DE1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104540645860308868)
,p_name=>'CODE_EDITOR.TRANSFORM_CODE_CASE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30FC\30C9\30FB\30B1\30FC\30B9\306E\5909\63DB')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104837577129309116)
,p_name=>'CODE_EDITOR.UNDO'
,p_message_language=>'ja'
,p_message_text=>unistr('\5143\306B\623B\3059')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104540440140308868)
,p_name=>'CODE_EDITOR.UTIL_OFF'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30D5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104540592519308868)
,p_name=>'CODE_EDITOR.UTIL_ON'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30F3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104837173641309115)
,p_name=>'CODE_EDITOR.VALIDATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104837694270309116)
,p_name=>'CODE_EDITOR.VALIDATION_SUCCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C\6210\529F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104540304947308868)
,p_name=>'CODE_EDITOR.WHITESPACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\7A7A\767D\306E\8868\793A')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103943881878308393)
,p_name=>'COLLAPSE'
,p_message_language=>'ja'
,p_message_text=>unistr('\9589\3058\308B')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103575462958308070)
,p_name=>'COLOR_PALETTE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30E9\30FC\30FB\30D1\30EC\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103764827739308219)
,p_name=>'COLOR_PALETTE_ANALOGIC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30CA\30ED\30B8\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103764480270308219)
,p_name=>'COLOR_PALETTE_COMPLEMENTARY'
,p_message_language=>'ja'
,p_message_text=>unistr('\88DC\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103765044883308219)
,p_name=>'COLOR_PALETTE_COMPLEMENTARY_COLORS'
,p_message_language=>'ja'
,p_message_text=>unistr('\88DC\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103764994325308219)
,p_name=>'COLOR_PALETTE_MONOTONE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E2\30CE\30C8\30FC\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103764535122308219)
,p_name=>'COLOR_PALETTE_SPLIT_COMPLEMENTARY'
,p_message_language=>'ja'
,p_message_text=>unistr('\96A3\63A5\88DC\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103764775442308219)
,p_name=>'COLOR_PALETTE_TETRADE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30C8\30E9\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103764664491308219)
,p_name=>'COLOR_PALETTE_TRIADE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C8\30E9\30A4\30A2\30FC\30C9')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104752844020309044)
,p_name=>'COLUMN_DISPLAY_NAME_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\540D: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103936313265308387)
,p_name=>'COLUMN_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\540D')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104124507177308537)
,p_name=>'COM.ORACLE.APEX.ACL_ALL_USERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\306E\8A8D\8A3C\6E08\30E6\30FC\30B6\30FC\304C\3001\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\30A2\30AF\30BB\30B9\3067\304D\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104124653171308537)
,p_name=>'COM.ORACLE.APEX.ACL_ONLY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30A2\30AF\30BB\30B9\5236\5FA1\30EA\30B9\30C8\306B\5B9A\7FA9\3055\308C\305F\30E6\30FC\30B6\30FC\306E\307F\304C\3001\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\30A2\30AF\30BB\30B9\3067\304D\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104124769120308537)
,p_name=>'COM.ORACLE.APEX.ACL_SETTING_VALUE_INVALID'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E88\671F\3057\306A\3044\30A2\30AF\30BB\30B9\5236\5FA1\8A2D\5B9A\5024: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103568529576308065)
,p_name=>'COMING_SOON'
,p_message_language=>'ja'
,p_message_text=>unistr('\3057\3070\3089\304F\304A\5F85\3061\304F\3060\3055\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103936817013308387)
,p_name=>'COMMENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30E1\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103805891072308252)
,p_name=>'COMPILE_FAILURE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30D1\30A4\30EB\306F\5931\6557\3057\307E\3057\305F\3002\884C<a href="javascript:goToLine(''%0'')">%0</a> (%2)<br />%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104137094528308547)
,p_name=>'COMPILE_FAILURE_TRIGGER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30D1\30A4\30EB\306F\5931\6557\3057\307E\3057\305F\3002\884C%0 (%2) \30B3\30F3\30D1\30A4\30EB\30FB\30A8\30E9\30FC\306B\95A2\9023\4ED8\3051\3089\308C\305F\884C\756A\53F7\306F\3001\6700\521D\306EBEGIN\6587\306B\5BFE\3059\308B\756A\53F7\3067\3059\3002\3053\308C\306F\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30C8\30EA\30AC\30FC\306E\30B3\30F3\30D1\30A4\30EB\306B\306E\307F\5F71\97FF\3057\307E\3059\3002<br />%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103805700343308251)
,p_name=>'COMPILE_SUCCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\30B3\30FC\30C9\306F\6B63\5E38\306B\30B3\30F3\30D1\30A4\30EB\3055\308C\307E\3057\305F(%0)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104003421632308438)
,p_name=>'COMPLETE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B8C\4E86')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104010466314308443)
,p_name=>'COMPLETED'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B8C\4E86')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104017368983308448)
,p_name=>'COMPLETE_NO_ISSUES'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B8C\4E86/\554F\984C\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104052102566308477)
,p_name=>'COMPONENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30DD\30FC\30CD\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104180295526308593)
,p_name=>'COMPONENT_NAME_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30DD\30FC\30CD\30F3\30C8\540D: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104371283573308735)
,p_name=>'COMPONENT_NOT_ENABLED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30DD\30FC\30CD\30F3\30C8\304C\6709\52B9\3067\306F\3042\308A\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103667494270308141)
,p_name=>'COMPONENT_SUCCESS_MSG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306F\6B63\5E38\306B\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104750533941309043)
,p_name=>'COMPONENT_SUMMARY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30DD\30FC\30CD\30F3\30C8\30FB\30B5\30DE\30EA\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103615974292308099)
,p_name=>'COMPUTATIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A08\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104074388923308495)
,p_name=>'COMP_SUCCESS_MSG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30B3\30F3\30DD\30FC\30CD\30F3\30C8\304C\6B63\5E38\306B\30A4\30F3\30B9\30C8\30FC\30EB\3055\308C\307E\3057\305F\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103806348490308252)
,p_name=>'CONDITIONAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\6761\4EF6\4ED8\304D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103922030187308376)
,p_name=>'CONDITIONS_POPUP_LOV'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DD\30C3\30D7\30A2\30C3\30D7LOV')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103996249910308433)
,p_name=>'CONDITIONS_SHORTCUT_ALWAYS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5E38\6642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103727808517308190)
,p_name=>'CONDITIONS_SHORTCUT_EXISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B58\5728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103727281711308189)
,p_name=>'CONDITIONS_SHORTCUT_EXPRESSION'
,p_message_language=>'ja'
,p_message_text=>unistr('\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103727360424308189)
,p_name=>'CONDITIONS_SHORTCUT_ITEM_E_VAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0/\5217=\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103727401825308189)
,p_name=>'CONDITIONS_SHORTCUT_ITEM_NOT_NULL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0/\5217\306FNULL\3067\306F\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104541427179308868)
,p_name=>'CONDITIONS_SHORTCUT_ITEM_NULL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0/\5217\306FNULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103727968142308190)
,p_name=>'CONDITIONS_SHORTCUT_NEVER'
,p_message_language=>'ja'
,p_message_text=>unistr('\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103728026572308190)
,p_name=>'CONDITIONS_SHORTCUT_NONE'
,p_message_language=>'ja'
,p_message_text=>unistr('\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103727647104308189)
,p_name=>'CONDITIONS_SHORTCUT_PAGE_IN'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B58\5728\3059\308B\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103727780346308190)
,p_name=>'CONDITIONS_SHORTCUT_PAGE_NOT_IN'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B58\5728\3057\306A\3044\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103727574357308189)
,p_name=>'CONDITIONS_SHORTCUT_REQ_E_E1'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30AF\30A8\30B9\30C8=\5F0F1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103738974409308199)
,p_name=>'CONDITION_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6761\4EF6\30BF\30A4\30D7')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103959282869308405)
,p_name=>'CONFIRM'
,p_message_language=>'ja'
,p_message_text=>unistr('\78BA\8A8D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103528300277308036)
,p_name=>'CONFIRM.2_PAGE_MASTER_DETAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('2\30DA\30FC\30B8\306E\30DE\30B9\30BF\30FC\30FB\30C7\30A3\30C6\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103528295778308036)
,p_name=>'CONFIRM.3_PAGE_MASTER_DETAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('3\30DA\30FC\30B8\306E\30DE\30B9\30BF\30FC\30FB\30C7\30A3\30C6\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103713755333308178)
,p_name=>'CONFIRM.ACTUAL_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9F\969B\306E\540D\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104003212500308438)
,p_name=>'CONFIRM.AGG_COLS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\5225\306E\96C6\8A08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104003322102308438)
,p_name=>'CONFIRM.AGG_FUNCTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F7F\7528\3059\308B\96C6\8A08\95A2\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103711125795308176)
,p_name=>'CONFIRM.APPLICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103724621371308187)
,p_name=>'CONFIRM.APPLICATION_ALIAS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5225\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103724716495308187)
,p_name=>'CONFIRM.APPLICATION_DEFAULT_LANG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\8A00\8A9E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103724558134308187)
,p_name=>'CONFIRM.APPLICATION_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\540D\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103621583079308103)
,p_name=>'CONFIRM.ARRAY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\5BFE\8C61\306E\7D50\679C\30C4\30EA\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103621608532308103)
,p_name=>'CONFIRM.ARRAY_PARMS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\5BFE\8C61\306E\7D50\679C\30D1\30E9\30E1\30FC\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103724888472308187)
,p_name=>'CONFIRM.AUTHENTICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104178346965308591)
,p_name=>'CONFIRM.BRANCH_TO'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306B\30D6\30E9\30F3\30C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103927565876308380)
,p_name=>'CONFIRM.BREAK_COLUMNS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30FC\30AF\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103713506182308178)
,p_name=>'CONFIRM.BUTTON_BRANCH'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\30DC\30BF\30F3\30FB\30D6\30E9\30F3\30C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103713404776308178)
,p_name=>'CONFIRM.BUTTON_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\30DC\30BF\30F3\8868\793A\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103548864728308051)
,p_name=>'CONFIRM.CALENDAR_ENABLE_AJAX_DATA_ADD'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\306E\8FFD\52A0\3092\6709\52B9\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103548736736308051)
,p_name=>'CONFIRM.CALENDAR_ENABLE_DRAG_AND_DROP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C9\30E9\30C3\30B0\30FB\30A2\30F3\30C9\30FB\30C9\30ED\30C3\30D7\306E\6709\52B9\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104126832991308539)
,p_name=>'CONFIRM.CANCEL_BRANCH'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30E9\30F3\30C1\306E\53D6\6D88')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104178177975308591)
,p_name=>'CONFIRM.CANCEL_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\53D6\6D88\300D\30DC\30BF\30F3\30FB\30E9\30D9\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104170214228308584)
,p_name=>'CONFIRM.CASE_SENSITIVE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5927/\5C0F\6587\5B57\533A\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103804271915308250)
,p_name=>'CONFIRM.CHANGE_INTERACTIVE_RPT_REGION'
,p_message_language=>'ja'
,p_message_text=>unistr('\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\554F\5408\305B\306E\5909\66F4\3092\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002\554F\5408\305B\304B\3089\5217\3092\524A\9664\3057\305F\5834\5408\3001\65E2\5B58\306E\30D5\30A3\30EB\30BF\3001\30CF\30A4\30E9\30A4\30C8\898F\5247\3001\304A\3088\3073\305D\306E\5217\3092\53C2\7167\3059\308B\4ED6\306E\30EC\30DD\30FC\30C8\8A2D\5B9A\306F\7121\52B9\306B\306A\308A\307E\3059\3002\30EA\30AF\30A8\30B9\30C8\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103714678007308179)
,p_name=>'CONFIRM.CHART_AXIS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\8EF8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104063471768308486)
,p_name=>'CONFIRM.CHART_DIAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C0\30A4\30E4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104063597871308486)
,p_name=>'CONFIRM.CHART_DIALSWEEP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C0\30A4\30E4\30EB(\30B9\30A4\30FC\30D7)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103715320434308180)
,p_name=>'CONFIRM.CHART_HORIZONTAL_BAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A2A\68D2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103715504985308180)
,p_name=>'CONFIRM.CHART_LINE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6298\308C\7DDA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103714842900308179)
,p_name=>'CONFIRM.CHART_NUMBER_MASK'
,p_message_language=>'ja'
,p_message_text=>unistr('\6570\5024\30DE\30B9\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103715430237308180)
,p_name=>'CONFIRM.CHART_PIE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5186')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103714590215308179)
,p_name=>'CONFIRM.CHART_QUERY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103714716550308179)
,p_name=>'CONFIRM.CHART_SCALE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30B1\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103715603790308180)
,p_name=>'CONFIRM.CHART_SCATTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\6563\5E03')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103715101930308179)
,p_name=>'CONFIRM.CHART_SIZE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\30FB\30B5\30A4\30BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103715022061308179)
,p_name=>'CONFIRM.CHART_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\30FB\30BF\30A4\30C8\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103714950072308179)
,p_name=>'CONFIRM.CHART_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\30FB\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103715229342308180)
,p_name=>'CONFIRM.CHART_VERTICAL_BAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\7E26\68D2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103621775691308103)
,p_name=>'CONFIRM.COLLECTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E00\6642\7D50\679C\30BB\30C3\30C8\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103711957947308177)
,p_name=>'CONFIRM.COLUMNS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103927322204308380)
,p_name=>'CONFIRM.COLUMN_HEADING'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\30D8\30C3\30C0\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104090035860308508)
,p_name=>'CONFIRM.COLUMN_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104127041311308539)
,p_name=>'CONFIRM.COLUMN_NAMES'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103724286125308187)
,p_name=>'CONFIRM.COL_HEAD_SORTING'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\30D8\30C3\30C0\30FC\30FB\30BD\30FC\30C8\3092\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103848229270308284)
,p_name=>'CONFIRM.COPY_APPLICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\5C5E\6027\3092\6301\3064\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\30B3\30D4\30FC\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002\9078\629E\5185\5BB9\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103722855854308186)
,p_name=>'CONFIRM.COPY_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\5C5E\6027\3092\6301\3064\30DA\30FC\30B8\3092\30B3\30D4\30FC\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002\9078\629E\5185\5BB9\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103712404081308177)
,p_name=>'CONFIRM.CREATE.NEW.TABSET'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F\30BF\30D6\30FB\30BB\30C3\30C8\300C%0\300D\304C\3053\306E\30DA\30FC\30B8\3067\4F5C\6210\304A\3088\3073\4F7F\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103724434821308187)
,p_name=>'CONFIRM.CREATE_APPLICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\5C5E\6027\3092\6301\3064\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\4F5C\6210\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002\9078\629E\5185\5BB9\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103716918799308181)
,p_name=>'CONFIRM.CREATE_CALENDAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\5C5E\6027\3092\6301\3064\30AB\30EC\30F3\30C0\30FB\30DA\30FC\30B8\3092\4F5C\6210\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002\9078\629E\5185\5BB9\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103720130380308184)
,p_name=>'CONFIRM.CREATE_DRILL_DOWN'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\5C5E\6027\3092\6301\3064\30C9\30EA\30EB\30C0\30A6\30F3\30FB\30EC\30DD\30FC\30C8\30FB\30DA\30FC\30B8\3092\4F5C\6210\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002\9078\629E\5185\5BB9\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103773067765308226)
,p_name=>'CONFIRM.CREATE_DYNAMIC_QUERY'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\5C5E\6027\3092\6301\3064\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\3092\4F5C\6210\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002\9078\629E\5185\5BB9\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103723189770308186)
,p_name=>'CONFIRM.CREATE_EASY_REPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\5C5E\6027\3092\6301\3064\30EC\30DD\30FC\30C8\30FB\30DA\30FC\30B8\3092\4F5C\6210\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002\9078\629E\5185\5BB9\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104731557326309027)
,p_name=>'CONFIRM.CREATE_FLOW_APP_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\884C\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306E\65E2\5B58\306E\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3068\540C\3058ID\3092\4F7F\7528\3057\3066\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\4F5C\6210\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002\65E2\5B58\306E\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304C\524A\9664\3055\308C\305F\5F8C\3001\65B0\3057\3044\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\7F6E\304D\63DB\3048\3089\308C\307E\3059\3002\9078\629E\5185\5BB9\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104086920041308506)
,p_name=>'CONFIRM.CREATE_FORM_AND_LIST_VIEW'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\5C5E\6027\3092\6301\3064\30D5\30A9\30FC\30E0\3068\30EA\30B9\30C8\30FB\30D3\30E5\30FC\306E\30DA\30FC\30B8\3092\4F5C\6210\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002\9078\629E\5185\5BB9\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104002937488308438)
,p_name=>'CONFIRM.CREATE_FORM_AND_REPORT_WITH_ANALYSIS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5206\6790\30DA\30FC\30B8\3092\6301\3064\30D5\30A9\30FC\30E0\30FB\30DA\30FC\30B8\304A\3088\3073\30EC\30DD\30FC\30C8\30FB\30DA\30FC\30B8\3092\4F5C\6210\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002\9078\629E\5185\5BB9\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103716525766308181)
,p_name=>'CONFIRM.CREATE_FORM_ON_QUERY'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\5C5E\6027\3092\6301\3064SQL\554F\5408\305B\306E\30D5\30A9\30FC\30E0\3092\4F5C\6210\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002\9078\629E\5185\5BB9\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103716495976308180)
,p_name=>'CONFIRM.CREATE_FORM_ON_SP'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\5C5E\6027\3092\6301\3064\30B9\30C8\30A2\30C9\30FB\30D7\30ED\30B7\30FC\30B8\30E3\306E\30D5\30A9\30FC\30E0\3092\4F5C\6210\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002\9078\629E\5185\5BB9\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103716386038308180)
,p_name=>'CONFIRM.CREATE_FORM_ON_TABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\5C5E\6027\3092\6301\3064\8868\30DA\30FC\30B8\306E\30D5\30A9\30FC\30E0\3092\4F5C\6210\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002\9078\629E\5185\5BB9\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103592043185308082)
,p_name=>'CONFIRM.CREATE_FORM_ON_WS'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B5\30FC\30D3\30B9\53C2\7167\30DA\30FC\30B8\3067\6B21\306E\5C5E\6027\3092\6301\3064\30D5\30A9\30FC\30E0\3092\4F5C\6210\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002   \9078\629E\5185\5BB9\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103632237697308114)
,p_name=>'CONFIRM.CREATE_FORM_ON_WS_RPT'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B5\30FC\30D3\30B9\53C2\7167\30DA\30FC\30B8\3067\6B21\306E\5C5E\6027\3092\6301\3064\30D5\30A9\30FC\30E0\304A\3088\3073\30EC\30DD\30FC\30C8\3092\4F5C\6210\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002   \9078\629E\5185\5BB9\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104030579624308459)
,p_name=>'CONFIRM.CREATE_MAP'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\5C5E\6027\3092\6301\3064\30DE\30C3\30D7\30FB\30DA\30FC\30B8\3092\4F5C\6210\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002\9078\629E\5185\5BB9\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103525958830308034)
,p_name=>'CONFIRM.CREATE_MASTER_DETAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\5C5E\6027\3092\6301\3064\30DE\30B9\30BF\30FC\30FB\30C7\30A3\30C6\30FC\30EB\30FB\30DA\30FC\30B8\3092\4F5C\6210\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002 \9078\629E\5185\5BB9\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103718110849308182)
,p_name=>'CONFIRM.CREATE_MENU'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\5C5E\6027\3092\6301\3064\30D6\30EC\30C3\30C9\30AF\30E9\30E0\30FB\30EA\30FC\30B8\30E7\30F3\304A\3088\3073\30D6\30EC\30C3\30C9\30AF\30E9\30E0\30FB\30AA\30D7\30B7\30E7\30F3\3092\4F5C\6210\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002\9078\629E\5185\5BB9\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104009215495308442)
,p_name=>'CONFIRM.CREATE_MODE'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F5C\6210\30E2\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103716160982308180)
,p_name=>'CONFIRM.CREATE_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\5C5E\6027\3092\6301\3064\30DA\30FC\30B8\3092\4F5C\6210\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002\9078\629E\5185\5BB9\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104780595611309074)
,p_name=>'CONFIRM.CREATE_PAGE_ID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104780697534309074)
,p_name=>'CONFIRM.CREATE_PAGE_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\540D\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103718910564308183)
,p_name=>'CONFIRM.CREATE_QUERY_AND_UPDATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\5C5E\6027\3092\6301\3064\30D5\30A9\30FC\30E0\3068\30EC\30DD\30FC\30C8\306E\30DA\30FC\30B8\3092\4F5C\6210\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002\9078\629E\5185\5BB9\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104727401673309022)
,p_name=>'CONFIRM.CREATE_REGION_PLUGIN_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\5C5E\6027\3092\6301\3064\30DA\30FC\30B8\3092\4F5C\6210\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002\9078\629E\5185\5BB9\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103722997651308186)
,p_name=>'CONFIRM.CREATE_REPORT_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\5C5E\6027\3092\6301\3064\30EC\30DD\30FC\30C8\30FB\30DA\30FC\30B8\3092\4F5C\6210\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002\9078\629E\5185\5BB9\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103716614197308181)
,p_name=>'CONFIRM.CREATE_SIMPLE_CHART'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\5C5E\6027\3092\6301\3064HTML\68D2\30B0\30E9\30D5\30FB\30DA\30FC\30B8\3092\4F5C\6210\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002\9078\629E\5185\5BB9\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103722524382308185)
,p_name=>'CONFIRM.CREATE_SUMMARY_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\5C5E\6027\3092\6301\3064\30B5\30DE\30EA\30FC\30FB\30DA\30FC\30B8\3092\4F5C\6210\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002\4ED6\306E\30DA\30FC\30B8\307E\305F\306F\30EA\30FC\30B8\30E7\30F3(\3042\308B\3044\306F\305D\306E\4E21\65B9)\304B\3089\30A2\30A4\30C6\30E0\3092\8FFD\52A0\3059\308B\306B\306F\3001\300C\8FFD\52A0\300D\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3057\3066\304F\3060\3055\3044\3002\30B5\30DE\30EA\30FC\30FB\30A2\30A4\30C6\30E0\3092\4F5C\6210\3059\308B\306B\306F\3001\300C\7D42\4E86\300D\3092\30AF\30EA\30C3\30AF\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103716763416308181)
,p_name=>'CONFIRM.CREATE_SVG_CHART'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\5C5E\6027\3092\6301\3064SVG\30C1\30E3\30FC\30C8\30FB\30DA\30FC\30B8\3092\4F5C\6210\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002\9078\629E\5185\5BB9\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103716007701308180)
,p_name=>'CONFIRM.CREATE_TABULAR_FORM'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\5C5E\6027\3092\6301\3064\8868\5F62\5F0F\306E\30DA\30FC\30B8\3092\4F5C\6210\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002\9078\629E\5185\5BB9\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103717249292308181)
,p_name=>'CONFIRM.CREATE_TREE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\5C5E\6027\3092\6301\3064\30C4\30EA\30FC\30FB\30DA\30FC\30B8\3092\4F5C\6210\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002\9078\629E\5185\5BB9\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103716280978308180)
,p_name=>'CONFIRM.CREATE_WIZARD'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\5C5E\6027\3092\6301\3064\30A6\30A3\30B6\30FC\30C9\3092\4F5C\6210\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002\9078\629E\5185\5BB9\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104731458903309027)
,p_name=>'CONFIRM.CREATE_WS_APP_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\884C\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306E\65E2\5B58\306EWeb\30B7\30FC\30C8\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3068\540C\3058ID\3092\4F7F\7528\3057\3066Web\30B7\30FC\30C8\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\4F5C\6210\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002\65E2\5B58\306EWeb\30B7\30FC\30C8\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304C\524A\9664\3055\308C\305F\5F8C\3001\65B0\3057\3044Web\30B7\30FC\30C8\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\7F6E\304D\63DB\3048\3089\308C\307E\3059\3002\9078\629E\5185\5BB9\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103924059998308377)
,p_name=>'CONFIRM.CSV_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30F3\30AF\30FB\30E9\30D9\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104668169174308974)
,p_name=>'CONFIRM.DATA_LOAD_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30ED\30FC\30C9\5B9A\7FA9\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104738545151309033)
,p_name=>'CONFIRM.DATA_LOAD_NAME_EXISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30C7\30FC\30BF\30FB\30ED\30FC\30C9\5B9A\7FA9\306F\3001\65E2\5B58\306E\8868\30EB\30C3\30AF\30A2\30C3\30D7\3068\30C8\30E9\30F3\30B9\30D5\30A9\30FC\30E1\30FC\30B7\30E7\30F3\30FB\30EB\30FC\30EB\3092\4F7F\7528\3057\3066\4F5C\6210\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104170333427308584)
,p_name=>'CONFIRM.DATA_LOAD_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\756A\53F7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103717055310308181)
,p_name=>'CONFIRM.DATE_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5\4ED8\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104009367328308442)
,p_name=>'CONFIRM.DEFAULT_AUTH_SCHEME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\306E\8A8D\8A3C\30B9\30AD\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103715988640308180)
,p_name=>'CONFIRM.DELETE_PROCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103720818957308184)
,p_name=>'CONFIRM.DETAIL_DISPLAY_COLS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\8868\793A\5217\306E\8A73\7D30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103528799214308036)
,p_name=>'CONFIRM.DETAIL_DISPLAY_COLUMNS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30A3\30C6\30FC\30EB\8868\793A\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103722431405308185)
,p_name=>'CONFIRM.DETAIL_MENU_COL'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A73\7D30\30D6\30EC\30C3\30C9\30AF\30E9\30E0\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103721612269308185)
,p_name=>'CONFIRM.DETAIL_ORDER_BY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30A3\30C6\30FC\30EB\8868%0\306E\4E26\66FF\3048\57FA\6E96')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103720300731308184)
,p_name=>'CONFIRM.DETAIL_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A73\7D30\30DA\30FC\30B8%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103528639915308036)
,p_name=>'CONFIRM.DETAIL_TABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30A3\30C6\30FC\30EB\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103720695875308184)
,p_name=>'CONFIRM.DETAIL_TABLE_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A73\7D30\8868\540D%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103720427419308184)
,p_name=>'CONFIRM.DETAIL_TAB_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A73\7D30\30BF\30D6\30FB\30E9\30D9\30EB%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104127309865308539)
,p_name=>'CONFIRM.DISPLAY_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30C3\30D7\30ED\30FC\30C9\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103714099972308179)
,p_name=>'CONFIRM.DISPLAY_COLUMNS'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104089701430308508)
,p_name=>'CONFIRM.DISPLAY_COLUMN_2'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30C3\30D7\30ED\30FC\30C9\52172')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104089888975308508)
,p_name=>'CONFIRM.DISPLAY_COLUMN_3'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30C3\30D7\30ED\30FC\30C9\52173')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103718344141308182)
,p_name=>'CONFIRM.DISPLAY_POINT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104788123414309079)
,p_name=>'CONFIRM.EDIT_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306E\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104788273800309079)
,p_name=>'CONFIRM.EDIT_PAGE_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\540D\306E\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103913965846308338)
,p_name=>'CONFIRM.ENABLE_CSV_OUTPUT'
,p_message_language=>'ja'
,p_message_text=>unistr('CSV\51FA\529B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103914603519308338)
,p_name=>'CONFIRM.ENABLE_PRINT_OUTPUT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30EA\30F3\30C8\51FA\529B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103915268426308339)
,p_name=>'CONFIRM.ENABLE_SORTING'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\30D8\30C3\30C0\30FC\30FB\30BD\30FC\30C8\306E\6709\52B9\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103961188835308406)
,p_name=>'CONFIRM.EXISTING_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\304C\65E2\5B58\306E\7BA1\7406\30DA\30FC\30B8\306B\8FFD\52A0\3055\308C\307E\3059:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104126911387308539)
,p_name=>'CONFIRM.FINISH_BRANCH'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30E9\30F3\30C1\306E\5B8C\4E86')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103719405402308183)
,p_name=>'CONFIRM.FORM_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30FC\30E0\30FB\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103719591560308183)
,p_name=>'CONFIRM.FORM_PAGE_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30FC\30E0\30FB\30DA\30FC\30B8\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103719783663308183)
,p_name=>'CONFIRM.FORM_PAGE_TAB_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30FC\30E0\30FB\30DA\30FC\30B8\306E\30BF\30D6\30FB\30E9\30D9\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103719646859308183)
,p_name=>'CONFIRM.FORM_PAGE_TAB_SET'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30FC\30E0\30FB\30DA\30FC\30B8\306E\30BF\30D6\30FB\30BB\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104009485092308442)
,p_name=>'CONFIRM.IMPORT_SHARED_COMPONENTS_FROM'
,p_message_language=>'ja'
,p_message_text=>unistr('\5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306E\30A4\30F3\30DD\30FC\30C8\5143')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104356201205308724)
,p_name=>'CONFIRM.INCLUDE_CUSTOM_CALENDAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30B9\30BF\30E0\30FB\30AB\30EC\30F3\30C0\3092\542B\3081\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103528997725308036)
,p_name=>'CONFIRM.INCLUDE_MASTER_REPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30B9\30BF\30FC\30FB\30EC\30DD\30FC\30C8\3092\542B\3081\307E\3059\304B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103722174132308185)
,p_name=>'CONFIRM.INC_BREAD_CRUMB'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0\3092\542B\3080')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103713249397308178)
,p_name=>'CONFIRM.INFORMATION_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\60C5\5831\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103713378572308178)
,p_name=>'CONFIRM.INFORMATION_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\60C5\5831\306E\30C7\30D5\30A9\30EB\30C8\30FB\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103592230952308082)
,p_name=>'CONFIRM.INPUT_ITEMS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30FC\30E0\30FB\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103621947825308104)
,p_name=>'CONFIRM.INPUT_REGION_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30FC\30E0\30FB\30EA\30FC\30B8\30E7\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103621879775308103)
,p_name=>'CONFIRM.INPUT_REGION_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30FC\30E0\30FB\30EA\30FC\30B8\30E7\30F3\30FB\30BF\30A4\30C8\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103715731832308180)
,p_name=>'CONFIRM.INSERT_PROCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\633F\5165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103713020109308178)
,p_name=>'CONFIRM.ITEMS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104127263929308539)
,p_name=>'CONFIRM.KEY_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\623B\308A\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104126180387308538)
,p_name=>'CONFIRM.KEY_COLUMN_1'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EB\30C3\30AF\30A2\30C3\30D7\30FB\30AD\30FC\52171')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104126271969308538)
,p_name=>'CONFIRM.KEY_COLUMN_2'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AD\30FC\52172')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104126383384308538)
,p_name=>'CONFIRM.KEY_COLUMN_3'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AD\30FC\52173')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103717100413308181)
,p_name=>'CONFIRM.LABEL_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104089950094308508)
,p_name=>'CONFIRM.LOOKUP_OWNER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EB\30C3\30AF\30A2\30C3\30D7\6240\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104127119883308539)
,p_name=>'CONFIRM.LOOKUP_TABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EB\30C3\30AF\30A2\30C3\30D7\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103529047499308036)
,p_name=>'CONFIRM.MASTER_DETAIL_LAYOUT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30B9\30BF\30FC\30FB\30C7\30A3\30C6\30FC\30EB\30FB\30EC\30A4\30A2\30A6\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103528520371308036)
,p_name=>'CONFIRM.MASTER_DISPLAY_COLUMNS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30B9\30BF\30FC\8868\793A\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103528836182308036)
,p_name=>'CONFIRM.MASTER_SORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30B9\30BF\30FC\30FB\30EC\30B3\30FC\30C9\306E\30CA\30D3\30B2\30FC\30C8\65B9\6CD5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103528494648308036)
,p_name=>'CONFIRM.MASTER_TABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30B9\30BF\30FC\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103927463832308380)
,p_name=>'CONFIRM.MAXIMUM_COLUMNS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5927\5217\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103923816382308377)
,p_name=>'CONFIRM.MAX_ROWS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\3054\3068\306E\884C\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103780144366308231)
,p_name=>'CONFIRM.MENU'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103718637184308182)
,p_name=>'CONFIRM.MENU_LINK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0\30FB\30EA\30F3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103722278256308185)
,p_name=>'CONFIRM.MENU_ROOT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0\30FB\30EB\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103718475909308182)
,p_name=>'CONFIRM.MENU_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103718729668308182)
,p_name=>'CONFIRM.MENU_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0\30FB\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103594729273308084)
,p_name=>'CONFIRM.MIGRATE_HTML_TO_HTML5'
,p_message_language=>'ja'
,p_message_text=>unistr('HTML\30C1\30E3\30FC\30C8\3092\65B0\3057\3044HTML5\30C1\30E3\30FC\30C8\306B\30A2\30C3\30D7\30B0\30EC\30FC\30C9\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002\30EA\30AF\30A8\30B9\30C8\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104747109270309040)
,p_name=>'CONFIRM.MIGRATE_JSTREE_TO_APEXTREE'
,p_message_language=>'ja'
,p_message_text=>unistr('jsTree\3092\65B0\3057\3044\30C4\30EA\30FC\306B\30A2\30C3\30D7\30B0\30EC\30FC\30C9\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002\30EA\30AF\30A8\30B9\30C8\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103704881204308171)
,p_name=>'CONFIRM.MIGRATE_SVG_RESTRICTION'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('SVG\30C1\30E3\30FC\30C8\306E\30A2\30C3\30D7\30B0\30EC\30FC\30C9\306B\306F\6B21\306E\5236\9650\304C\3042\308A\307E\3059\3002'),
'<ul>',
'<li>',
unistr('\8EF8\306E\66F8\5F0F\6587\5B57\5217\306B\5B9A\7FA9\3055\308C\305F\6570\5024\66F8\5F0F\306E\307F\304C\79FB\884C\3055\308C\307E\3059\3002\65E5\4ED8\304A\3088\3073\6642\9593\306E\66F8\5F0F\306F\7121\8996\3055\308C\307E\3059\3002'),
'</li>',
'<li>',
unistr('\6B21\3092\542B\3080\6570\5024\66F8\5F0F\306E\8981\7D20\304C\79FB\884C\3055\308C\307E\3059\3002'),
'<br />',
unistr('0\30019\3001D\3001G\3001, (\30AB\30F3\30DE)\3001. (\30D4\30EA\30AA\30C9)\3001$\3001C\3001L\3001FM'),
'</li>',
'<li>',
unistr('Flash\30C1\30E3\30FC\30C8\306B\304A\3051\308B\5404\30B7\30EA\30FC\30BA\306E\30E9\30D9\30EB\306F\3001\5404\30B7\30EA\30FC\30BA\306E\5217\306E\5225\540D\304B\3089\5C0E\51FA\3055\308C\307E\3059\3002'),
unistr('\3053\306E\70B9\306B\304A\3044\3066\3001\5404\30B7\30EA\30FC\30BA\306E\30E9\30D9\30EB\304C\30B7\30EA\30FC\30BA\540D\5C5E\6027\304B\3089\5C0E\51FA\3059\308BSVG\30C1\30E3\30FC\30C8\3068\306F\7570\306A\308A\307E\3059\3002'),
'</li>',
'<li>',
unistr('Flash\30C0\30A4\30E4\30EB\30FB\30C1\30E3\30FC\30C8\306B\306F\3001\5272\5408\3067\306F\306A\304F\5B9F\969B\306E\5024\304C\8868\793A\3055\308C\307E\3059\3002'),
'</li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103668880104308142)
,p_name=>'CONFIRM.MIGRATE_SVG_TO_HTML5'
,p_message_language=>'ja'
,p_message_text=>unistr('SVG\30C1\30E3\30FC\30C8\3092HTML5\30C1\30E3\30FC\30C8\306B\30A2\30C3\30D7\30B0\30EC\30FC\30C9\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002\30EA\30AF\30A8\30B9\30C8\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104727292936309022)
,p_name=>'CONFIRM.NAVIGATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CA\30D3\30B2\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103725198948308187)
,p_name=>'CONFIRM.NAV_BAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30D0\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104338577589308711)
,p_name=>'CONFIRM.NAV_LIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC\30FB\30EA\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104020770674308451)
,p_name=>'CONFIRM.NEW_ADMIN_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\3057\3044\7BA1\7406\30DA\30FC\30B8\304C\8FFD\52A0\3055\308C\307E\3059\3002\30DA\30FC\30B8:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103804459871308250)
,p_name=>'CONFIRM.NEW_COLUMNS'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103713864032308178)
,p_name=>'CONFIRM.NEW_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104177929777308591)
,p_name=>'CONFIRM.NEXT_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\6B21\3078\300D\30DC\30BF\30F3\30FB\30E9\30D9\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103712363211308177)
,p_name=>'CONFIRM.NO.TABSET.SELECTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DA\30FC\30B8\3067\306F\30BF\30D6\30FB\30BB\30C3\30C8\304C\9078\629E\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103712908095308178)
,p_name=>'CONFIRM.NO_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103592366645308082)
,p_name=>'CONFIRM.OUTPUT_ITEMS'
,p_message_language=>'ja'
,p_message_text=>unistr('\51FA\529B\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103714228337308179)
,p_name=>'CONFIRM.OWNER'
,p_message_language=>'ja'
,p_message_text=>unistr('\6240\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103711298932308176)
,p_name=>'CONFIRM.PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103724982753308187)
,p_name=>'CONFIRM.PAGES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103711363894308176)
,p_name=>'CONFIRM.PAGE_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103712258771308177)
,p_name=>'CONFIRM.PAGE_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30BF\30A4\30C8\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103720748192308184)
,p_name=>'CONFIRM.PARENT_DISPLAY_COLS'
,p_message_language=>'ja'
,p_message_text=>unistr('\89AA\306E\8868\793A\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103718884771308182)
,p_name=>'CONFIRM.PARENT_MENU'
,p_message_language=>'ja'
,p_message_text=>unistr('\89AA\30D6\30EC\30C3\30C9\30AF\30E9\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103722363151308185)
,p_name=>'CONFIRM.PARENT_MENU_COL'
,p_message_language=>'ja'
,p_message_text=>unistr('\89AA\30D6\30EC\30C3\30C9\30AF\30E9\30E0\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103720911301308184)
,p_name=>'CONFIRM.PARENT_ORDER_BY'
,p_message_language=>'ja'
,p_message_text=>unistr('\89AA\8868\306E\4E26\66FF\3048\57FA\6E96')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103720277883308184)
,p_name=>'CONFIRM.PARENT_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\89AA\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103720502047308184)
,p_name=>'CONFIRM.PARENT_TABLE_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\89AA\8868\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103712868740308178)
,p_name=>'CONFIRM.PARENT_TAB_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\89AA\30BF\30D6\30FB\30E9\30D9\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103712765076308178)
,p_name=>'CONFIRM.PARENT_TAB_SET'
,p_message_language=>'ja'
,p_message_text=>unistr('\89AA\30BF\30D6\30FB\30BB\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103804191453308250)
,p_name=>'CONFIRM.PARSING_SCHEMA'
,p_message_language=>'ja'
,p_message_text=>unistr('\89E3\6790\5BFE\8C61\30B9\30AD\30FC\30DE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103810850451308255)
,p_name=>'CONFIRM.PARTIAL_REFRESH_CALENDAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\90E8\5206\30DA\30FC\30B8\30FB\30EA\30D5\30EC\30C3\30B7\30E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104178045354308591)
,p_name=>'CONFIRM.PREVIOUS_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\623B\308B\300D\30DC\30BF\30F3\30FB\30E9\30D9\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103712145430308177)
,p_name=>'CONFIRM.PRIMARY_KEY'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E3B\30AD\30FC\5217%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103719871739308183)
,p_name=>'CONFIRM.PRIMARY_KEY_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E3B\30AD\30FC\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103924139654308377)
,p_name=>'CONFIRM.PRINT_FORMAT'
,p_message_language=>'ja'
,p_message_text=>unistr('\51FA\529B\5F62\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103927608491308380)
,p_name=>'CONFIRM.PRINT_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30F3\30AF\30FB\30E9\30D9\30EB\306E\51FA\529B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103924224438308377)
,p_name=>'CONFIRM.PRINT_OUTPUT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\51FA\529B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103714195740308179)
,p_name=>'CONFIRM.PROCESS_OPTIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30BB\30B9\30FB\30AA\30D7\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103923960945308377)
,p_name=>'CONFIRM.REGION_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\306E\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103713181261308178)
,p_name=>'CONFIRM.REGION_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103711461852308177)
,p_name=>'CONFIRM.REGION_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\30FB\30BF\30A4\30C8\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103718259041308182)
,p_name=>'CONFIRM.REGION_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\30FB\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103804302633308250)
,p_name=>'CONFIRM.REMOVED_COLUMNS'
,p_message_language=>'ja'
,p_message_text=>unistr('\524A\9664\3055\308C\305F\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103719950255308183)
,p_name=>'CONFIRM.REPORT_COLUMNS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103943940773308393)
,p_name=>'CONFIRM.REPORT_IMPLEMENTATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\5B9F\88C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103719079854308183)
,p_name=>'CONFIRM.REPORT_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\30FB\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103719137609308183)
,p_name=>'CONFIRM.REPORT_PAGE_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\30FB\30DA\30FC\30B8\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103719384971308183)
,p_name=>'CONFIRM.REPORT_PAGE_TAB_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\30FB\30DA\30FC\30B8\306E\30BF\30D6\30FB\30E9\30D9\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103719246901308183)
,p_name=>'CONFIRM.REPORT_PAGE_TAB_SET'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\30FB\30DA\30FC\30B8\306E\30BF\30D6\30FB\30BB\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103622195690308104)
,p_name=>'CONFIRM.REPORT_REGION_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\30FB\30EA\30FC\30B8\30E7\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103622047075308104)
,p_name=>'CONFIRM.REPORT_REGION_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\30FB\30EA\30FC\30B8\30E7\30F3\30FB\30BF\30A4\30C8\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103723278049308186)
,p_name=>'CONFIRM.REPORT_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103624648196308105)
,p_name=>'CONFIRM.ROW_VERSION_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\30D0\30FC\30B8\30E7\30F3\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103723491735308186)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME1'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8: HTML(\6A19\6E96)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103723709331308186)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME11'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8: Look 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103723835498308186)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME12'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8: Look 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103803905175308250)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME13'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8: Look 3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103804030976308250)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME14'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8: Look 4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103622626960308104)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME15'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8: Look 5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103723529443308186)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME2'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8: \7E26\306E\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103723905163308186)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME21'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30AF\30B9\30DD\30FC\30C8: CSV')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103724071331308187)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME22'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30AF\30B9\30DD\30FC\30C8: XML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103723611062308186)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME3'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8: \7E26\306E\30EC\30DD\30FC\30C8\3001look 1(NULL\5217\3092\542B\3080)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103803771118308250)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME4'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8: \7E26\306E\30EC\30DD\30FC\30C8\3001look 2(NULL\5217\3092\9664\5916)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103803875224308250)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME5'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8: \7E26\306E\30EC\30DD\30FC\30C8\3001look 2(NULL\5217\3092\542B\3080)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104127424278308539)
,p_name=>'CONFIRM.RULE_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EB\30FC\30EB\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104127643267308539)
,p_name=>'CONFIRM.RULE_SEQUENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104127701335308539)
,p_name=>'CONFIRM.RULE_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EB\30FC\30EB\30FB\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103567362805308064)
,p_name=>'CONFIRM.RUN_SCRIPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\30B9\30AF\30EA\30D7\30C8\3092\5B9F\884C\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002\30EA\30AF\30A8\30B9\30C8\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103718543306308182)
,p_name=>'CONFIRM.SEQUENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103723307525308186)
,p_name=>'CONFIRM.SORT_OPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BD\30FC\30C8\30FB\30AA\30D7\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103714497166308179)
,p_name=>'CONFIRM.SQL_QUERY'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103810734012308255)
,p_name=>'CONFIRM.STANDARD_CALENDAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A19\6E96')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103958865192308404)
,p_name=>'CONFIRM.STARTING_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\3067\59CB\307E\308B\8907\6570\306E\30DA\30FC\30B8\304C\4F5C\6210\3055\308C\307E\3059:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103714325274308179)
,p_name=>'CONFIRM.STORED_PROCEDURE_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30C8\30A2\30C9\30FB\30D7\30ED\30B7\30FC\30B8\30E3\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103805681644308251)
,p_name=>'CONFIRM.STORED_PROCEDURE_OWNER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30C8\30A2\30C9\30FB\30D7\30ED\30B7\30FC\30B8\30E3\306E\6240\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104178268246308591)
,p_name=>'CONFIRM.SUBMIT_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\7D42\4E86\300D\30DC\30BF\30F3\30FB\30E9\30D9\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104742553833309036)
,p_name=>'CONFIRM.SUBSCRIBE_THEME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\306E\30B5\30D6\30B9\30AF\30E9\30A4\30D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103713627707308178)
,p_name=>'CONFIRM.SUGGESTED_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\63A8\5968\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104003001626308438)
,p_name=>'CONFIRM.TABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868/\30D3\30E5\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104003168285308438)
,p_name=>'CONFIRM.TABLE_COLS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\5225\306E\30B5\30DE\30EA\30FC\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104189366829308601)
,p_name=>'CONFIRM.TABLE_LOOKUPS'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\30EB\30C3\30AF\30A2\30C3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103711841367308177)
,p_name=>'CONFIRM.TABLE_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103711793237308177)
,p_name=>'CONFIRM.TABLE_OWNER'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\306E\6240\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104289408385308674)
,p_name=>'CONFIRM.TABLE_RULE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C8\30E9\30F3\30B9\30D5\30A9\30FC\30E1\30FC\30B7\30E7\30F3\30FB\30EB\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104127853738308540)
,p_name=>'CONFIRM.TABLE_RULES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C8\30E9\30F3\30B9\30D5\30A9\30FC\30E1\30FC\30B7\30E7\30F3\30FB\30EB\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103804649849308251)
,p_name=>'CONFIRM.TABLE_VIEW_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868/\30D3\30E5\30FC\306E\540D\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103804547732308251)
,p_name=>'CONFIRM.TABLE_VIEW_OWNER'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868/\30D3\30E5\30FC\306E\6240\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103725042492308187)
,p_name=>'CONFIRM.TABS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103712626166308177)
,p_name=>'CONFIRM.TABSET.INCOMPLETE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8B66\544A\3002\30BF\30D6\30FB\30BB\30C3\30C8\60C5\5831\304C\4E0D\5B8C\5168\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103711626000308177)
,p_name=>'CONFIRM.TAB_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30D6\30FB\30E9\30D9\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103723063830308186)
,p_name=>'CONFIRM.TAB_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30D6\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103711566714308177)
,p_name=>'CONFIRM.TAB_SET'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30D6\30FB\30BB\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103724106050308187)
,p_name=>'CONFIRM.TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103717852694308182)
,p_name=>'CONFIRM.TREE_LOV'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DD\30C3\30D7\30A2\30C3\30D7LOV\3092\542B\3080\65B0\3057\3044\30A2\30A4\30C6\30E0\306B\57FA\3065\304F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103717515170308181)
,p_name=>'CONFIRM.TREE_MAX_LEVEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5927\30EC\30D9\30EB\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103717382206308181)
,p_name=>'CONFIRM.TREE_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C4\30EA\30FC\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103717700769308182)
,p_name=>'CONFIRM.TREE_QUERY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C4\30EA\30FC\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103717921251308182)
,p_name=>'CONFIRM.TREE_SQL'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B\306B\57FA\3065\304F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103717695110308182)
,p_name=>'CONFIRM.TREE_START'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C4\30EA\30FC\3092\958B\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103718098183308182)
,p_name=>'CONFIRM.TREE_STATIC'
,p_message_language=>'ja'
,p_message_text=>unistr('\9759\7684\306A\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103717432128308181)
,p_name=>'CONFIRM.TREE_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C4\30EA\30FC\30FB\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103725280590308188)
,p_name=>'CONFIRM.UI_THEME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103725327951308188)
,p_name=>'CONFIRM.UI_THEME1'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EB\30FC\304A\3088\3073\30BF\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103725484761308188)
,p_name=>'CONFIRM.UI_THEME2'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30C3\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103725585365308188)
,p_name=>'CONFIRM.UI_THEME4'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CD\30A4\30D3\30FC\304A\3088\3073\30B0\30EC\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103725664946308188)
,p_name=>'CONFIRM.UI_THEME5'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30EA\30FC\30D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103725778426308188)
,p_name=>'CONFIRM.UI_THEME6'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30EB\30FC\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103725887950308188)
,p_name=>'CONFIRM.UI_THEME7'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30F3\30D7\30EB\30FB\30D6\30EB\30FC\304A\3088\3073\30BF\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103725965671308188)
,p_name=>'CONFIRM.UI_THEME8'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EB\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103726070476308188)
,p_name=>'CONFIRM.UI_THEME_NONE'
,p_message_language=>'ja'
,p_message_text=>unistr('\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103712050398308177)
,p_name=>'CONFIRM.UPDATEABLE_COLUMNS'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F4\65B0\53EF\80FD\306A\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103715891868308180)
,p_name=>'CONFIRM.UPDATE_PROCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F4\65B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103712585701308177)
,p_name=>'CONFIRM.USE.EXISTING.TABSET'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DA\30FC\30B8\3067\306F\65E2\5B58\306E\30BF\30D6\30FB\30BB\30C3\30C8\300C%0\300D\3092\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103592169907308082)
,p_name=>'CONFIRM.WEB_SERVICE_REF'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B5\30FC\30D3\30B9\53C2\7167\3001\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103720057009308183)
,p_name=>'CONFIRM.WHERE_CLAUSE'
,p_message_language=>'ja'
,p_message_text=>unistr('WHERE\53E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103993556821308430)
,p_name=>'CONFIRMATION_ICON'
,p_message_language=>'ja'
,p_message_text=>unistr('\78BA\8A8D\30A2\30A4\30B3\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104003822068308438)
,p_name=>'CONFIRMED'
,p_message_language=>'ja'
,p_message_text=>unistr('\78BA\8A8D\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104004165729308438)
,p_name=>'CONFIRMED_BY_QA'
,p_message_language=>'ja'
,p_message_text=>unistr('QA\306B\3088\308A\78BA\8A8D\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103924475672308378)
,p_name=>'CONFIRM_BREAK_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30FC\30AF\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103924336793308377)
,p_name=>'CONFIRM_PRINT_FORMAT'
,p_message_language=>'ja'
,p_message_text=>unistr('\51FA\529B\5F62\5F0F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104031730023308460)
,p_name=>'CONTENT_DISPOSITION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30C6\30F3\30C4\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104064426028308487)
,p_name=>'CONTENT_SERVED_IN_KBYTES'
,p_message_language=>'ja'
,p_message_text=>unistr('\63D0\4F9B\3055\308C\305F\30B3\30F3\30C6\30F3\30C4')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104842691286309120)
,p_name=>'CONTRIBUTORS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30C8\30EA\30D3\30E5\30FC\30BF')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104757265377309048)
,p_name=>'COPY.PAGE.NEW_STATIC_ID'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F\9759\7684ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103803520836308250)
,p_name=>'COPY_ACTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30D4\30FC\30FB\30A2\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103668634776308142)
,p_name=>'COPY_APP_SUCCESS_MSG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304C\30B3\30D4\30FC\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103782933288308234)
,p_name=>'COPY_BUTTON.EXECUTION_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('copy_button\306E\5B9F\884C\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F: %0 >> %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103848807203308284)
,p_name=>'COPY_DEPLOYMENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30D6\30B8\30A7\30AF\30C8\5B9A\7FA9\5C5E\6027\306E\30B3\30D4\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103643792477308123)
,p_name=>'COPY_EXISTING_APP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30B3\30D4\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104087761961308506)
,p_name=>'COPY_FEATURE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A5F\80FD\306E\30B3\30D4\30FC: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103848456766308284)
,p_name=>'COPY_FROM_APPLICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304B\3089\30B3\30D4\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104229371181308631)
,p_name=>'COPY_FROM_APP_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\57FA\3065\304F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103848596708308284)
,p_name=>'COPY_FROM_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\540D\524D\304B\3089\30B3\30D4\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103672401643308145)
,p_name=>'COPY_LIST_ENTRY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8\30FB\30A8\30F3\30C8\30EA\306E\30B3\30D4\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103783332754308234)
,p_name=>'COPY_NAMED_LOV.EXECUTION_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('copy_named_lov\306E\5B9F\884C\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103783269550308234)
,p_name=>'COPY_NAMED_LOV.NOT_FOUND_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('LOV ID "%0"\304C\898B\3064\304B\308A\307E\305B\3093\3067\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103783192564308234)
,p_name=>'COPY_NAMED_LOV.NUMERIC_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('LOV ID "%0"\306F\6570\5024\3067\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104069218846308491)
,p_name=>'COPY_PAGE.COPY_FROM_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30D4\30FC\5143\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104069398363308491)
,p_name=>'COPY_PAGE.COPY_TO_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30D4\30FC\5148\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104068346054308490)
,p_name=>'COPY_PAGE.SELECT_AUTHORIZATION'
,p_message_language=>'ja'
,p_message_text=>unistr('- \8A8D\53EF\306E\9078\629E -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104068282057308490)
,p_name=>'COPY_PAGE.SELECT_LIST'
,p_message_language=>'ja'
,p_message_text=>unistr('- \30EA\30B9\30C8\306E\9078\629E -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104068155357308490)
,p_name=>'COPY_PAGE.SELECT_NAMED_LOV'
,p_message_language=>'ja'
,p_message_text=>unistr('- LOV\306E\9078\629E -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104132518074308543)
,p_name=>'COPY_TABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868%1\3078\306E%0\306E\30B3\30D4\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103848695964308284)
,p_name=>'COPY_TO_APPLICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3078\30B3\30D4\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103848748743308284)
,p_name=>'COPY_TO_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\540D\524D\3078\30B3\30D4\30FC')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103755339166308212)
,p_name=>'CORE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30A2')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104198361519308608)
,p_name=>'CREATE APPLICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104198407101308608)
,p_name=>'CREATE OBJECT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30D6\30B8\30A7\30AF\30C8\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104087460772308506)
,p_name=>'CREATED_LAST_7_DAYS'
,p_message_language=>'ja'
,p_message_text=>unistr('\904E\53BB7\65E5\9593\306B\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103643899309308123)
,p_name=>'CREATE_APP_FROM_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8\304B\3089')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104670932982308976)
,p_name=>'CREATE_APP_WIZ.CANDLE_CHARTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30FC\30BD\30AF\8DB3\30C1\30E3\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104670769757308976)
,p_name=>'CREATE_APP_WIZ.COL_CHARTS'
,p_message_language=>'ja'
,p_message_text=>unistr('2D\304A\3088\30733D\306E\5217\3001\68D2\304A\3088\3073\7A4D\4E0A\3052\30C1\30E3\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104671494736308976)
,p_name=>'CREATE_APP_WIZ.GAUGE_CHARTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C0\30A4\30E4\30EB\304A\3088\3073\30C0\30A4\30E4\30EB(%)\30FB\30C1\30E3\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104670888358308976)
,p_name=>'CREATE_APP_WIZ.PIE_CHARTS'
,p_message_language=>'ja'
,p_message_text=>unistr('2D\304A\3088\30733D\306E\5186\304A\3088\3073\30C9\30FC\30CA\30C4\30FB\30B0\30E9\30D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104671127379308976)
,p_name=>'CREATE_APP_WIZ.PROJECTGANTT_CHARTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30B8\30A7\30AF\30C8\30FB\30AC\30F3\30C8\30FB\30C1\30E3\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104671343258308976)
,p_name=>'CREATE_APP_WIZ.RANGE_CHARTS'
,p_message_language=>'ja'
,p_message_text=>unistr('2D\304A\3088\30733D\306E\30EC\30F3\30B8\30FB\30C1\30E3\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104671201563308976)
,p_name=>'CREATE_APP_WIZ.RESOURCEGANTT_CHARTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30BD\30FC\30B9\30FB\30AC\30F3\30C8\30FB\30C1\30E3\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104671027145308976)
,p_name=>'CREATE_APP_WIZ.SCATTER_CHARTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6563\5E03/\30DE\30FC\30AB\30FC\30FB\30C1\30E3\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103748725290308206)
,p_name=>'CREATE_CONDITION.AND'
,p_message_language=>'ja'
,p_message_text=>'AND'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103748577474308206)
,p_name=>'CREATE_CONDITION.ARROW_DOWN'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0B\77E2\5370')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103748645771308206)
,p_name=>'CREATE_CONDITION.ARROW_RIGHT'
,p_message_language=>'ja'
,p_message_text=>unistr('\53F3\77E2\5370')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103748324364308206)
,p_name=>'CREATE_CONDITION.COLUMNS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103748443082308206)
,p_name=>'CREATE_CONDITION.CONDITIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103748899482308206)
,p_name=>'CREATE_CONDITION.OR'
,p_message_language=>'ja'
,p_message_text=>'OR'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103748951371308207)
,p_name=>'CREATE_CONDITION.PREVIEW'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30EC\30D3\30E5\30FC\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104088119853308507)
,p_name=>'CREATE_DEMO_APP.GRANT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\300C\6A29\9650\4ED8\4E0E\300D\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3057\3066\3001\3059\3050\306B%0\306B\3053\308C\3089\306E\6A29\9650\3092\4ED8\4E0E\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104087925986308506)
,p_name=>'CREATE_DEMO_APP.NO_CREATE_PRIV'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306B\306FCREATE TABLE\3001CREATE VIEW\3001CREATE TRIGGER\3001CREATE SEQUENCE\307E\305F\306FCREATE PROCEDURE\6A29\9650\304C\306A\304F\3001\30C7\30E2\30F3\30B9\30C8\30EC\30FC\30B7\30E7\30F3\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\30A4\30F3\30B9\30C8\30FC\30EB\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104088085922308506)
,p_name=>'CREATE_DEMO_APP.NO_EXEC_PRIV'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('%0\306B\306FCTX_DOC\304A\3088\3073CTX_DDL\306E\5B9F\884C\6A29\9650\304C\306A\304F\3001\5927\7D71\9818\5C31\4EFB\6F14\8AAC\30C7\30E2\3092\30A4\30F3\30B9\30C8\30FC\30EB\3067\304D\307E\305B\3093\3002\6A29\9650\3092\4ED8\4E0E\3055\308C\305F\30E6\30FC\30B6\30FC\3068\3057\3066\3001\6B21\306E\6A29\9650\4ED8\4E0E\3092\5B9F\884C\3057\3066\304F\3060\3055\3044\3002'),
'<pre>',
'GRANT EXECUTE ON CTXSYS.CTX_DDL TO %0; ',
'GRANT EXECUTE ON CTXSYS.CTX_DOC TO %0;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104331917308308706)
,p_name=>'CREATE_DIALOG_CLOSED_DA'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3\306E\4F5C\6210 - \30C0\30A4\30A2\30ED\30B0\306E\30AF\30ED\30FC\30BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103564758647308062)
,p_name=>'CREATE_DYNAMIC_LIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\52D5\7684\30EA\30B9\30C8\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103805476541308251)
,p_name=>'CREATE_DYNAMIC_LOV'
,p_message_language=>'ja'
,p_message_text=>unistr('\52D5\7684LOV\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103542775403308046)
,p_name=>'CREATE_FLOW.CLOUD_IDM'
,p_message_language=>'ja'
,p_message_text=>'Oracle Cloud Identity Management'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103581826816308074)
,p_name=>'CREATE_FLOW.DBACCOUNT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30A2\30AB\30A6\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104223035764308626)
,p_name=>'CREATE_FLOW.HTMLDB_AUTH'
,p_message_language=>'ja'
,p_message_text=>unistr('Application Express\8A8D\8A3C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104088535900308507)
,p_name=>'CREATE_FLOW.LDAP'
,p_message_language=>'ja'
,p_message_text=>'LDAP'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104727315155309022)
,p_name=>'CREATE_FLOW.NAVIGATION_LIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC\30FB\30EA\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104223113896308626)
,p_name=>'CREATE_FLOW.NO_AUTH'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104222701915308626)
,p_name=>'CREATE_FLOW.NO_TABS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30D6\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104222814635308626)
,p_name=>'CREATE_FLOW.ONE_LEVEL_TABS'
,p_message_language=>'ja'
,p_message_text=>unistr('1\30EC\30D9\30EB\306E\30BF\30D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104088696928308507)
,p_name=>'CREATE_FLOW.SSO'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30F3\30B0\30EB\30FB\30B5\30A4\30F3\30AA\30F3(SSO)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104222950034308626)
,p_name=>'CREATE_FLOW.TWO_LEVEL_TABS'
,p_message_language=>'ja'
,p_message_text=>unistr('2\30EC\30D9\30EB\306E\30BF\30D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103643624138308123)
,p_name=>'CREATE_FROM_SPREADSHEET'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30D7\30EC\30C3\30C9\30B7\30FC\30C8\304B\3089')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103537391192308042)
,p_name=>'CREATE_GLOBAL_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30ED\30FC\30D0\30EB\30FB\30DA\30FC\30B8\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306F\3001\305D\306E\30EA\30FC\30B8\30E7\30F3\306E\8868\793A\30DD\30A4\30F3\30C8\304C\9078\629E\3057\305F\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306B\542B\307E\308C\3066\3044\308B\5834\5408\3001\3059\3079\3066\306E\30DA\30FC\30B8\306B\8868\793A\3055\308C\307E\3059\3002\6761\4EF6\4ED8\304D\8868\793A\5C5E\6027\306F\3001\8868\793A\3092\6291\6B62\3059\308B\305F\3081\306B\4F7F\7528\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103774089342308227)
,p_name=>'CREATE_INDEX'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D22\5F15\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103947385511308395)
,p_name=>'CREATE_ITEM_WIZ.NO_REGION'
,p_message_language=>'ja'
,p_message_text=>unistr('\95A2\9023\4ED8\3051\3089\308C\3066\3044\308B\30EA\30FC\30B8\30E7\30F3\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103755080376308211)
,p_name=>'CREATE_NEW_LOGIN_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103750487863308208)
,p_name=>'CREATE_PACKAGE.BACK'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\4F5C\6210\30A6\30A3\30B6\30FC\30C9\306B\623B\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103749977653308207)
,p_name=>'CREATE_PACKAGE.BROWSE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30C3\30B1\30FC\30B8\3092\53C2\7167')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103749865743308207)
,p_name=>'CREATE_PACKAGE.CREATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C%1\300D\30B9\30AD\30FC\30DE\306B\3001\30D1\30C3\30B1\30FC\30B8\300C%0\300D\304C\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103750573327308208)
,p_name=>'CREATE_PACKAGE.FAILED'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\300C%0\300D\306E\4F5C\6210\306B\5931\6557\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103750385819308208)
,p_name=>'CREATE_PACKAGE.HOME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DB\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103750118621308207)
,p_name=>'CREATE_PACKAGE.RETURN_TO'
,p_message_language=>'ja'
,p_message_text=>unistr('\623B\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103750252915308208)
,p_name=>'CREATE_PACKAGE.SQL_WORKSHOP'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\30EF\30FC\30AF\30B7\30E7\30C3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103750046851308207)
,p_name=>'CREATE_PACKAGE.SQL_WORKSHOP_HOME'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\30EF\30FC\30AF\30B7\30E7\30C3\30D7\30FB\30DB\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103745682787308204)
,p_name=>'CREATE_PAGE_ITEM.NO_ITEM_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\304C\898B\3064\304B\308A\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103745299183308204)
,p_name=>'CREATE_PAGE_ITEM.PAGE_ITEMS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103745518401308204)
,p_name=>'CREATE_PAGE_ITEM.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30F3\30D7\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103745353290308204)
,p_name=>'CREATE_PAGE_ITEM.REGION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103745469859308204)
,p_name=>'CREATE_PAGE_ITEM.SET_REGION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30EA\30C3\30AF\3057\3066\30EA\30FC\30B8\30E7\30F3\3092\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103743394637308202)
,p_name=>'CREATE_PROCESS.PAGE_ITEMS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103743481471308202)
,p_name=>'CREATE_PROCESS.REGION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103749794561308207)
,p_name=>'CREATE_TABLE.HOME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DB\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103749523841308207)
,p_name=>'CREATE_TABLE.RETURN_TO'
,p_message_language=>'ja'
,p_message_text=>unistr('\623B\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103749470932308207)
,p_name=>'CREATE_TABLE.RUN_SCRIPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AF\30EA\30D7\30C8\306E\5B9F\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103749189087308207)
,p_name=>'CREATE_TABLE.SCRIPT_CREATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868%0\306B\5BFE\3059\308B\8868\4F5C\6210\30B9\30AF\30EA\30D7\30C8\304CSQL\30B9\30AF\30EA\30D7\30C8\30FB\30EA\30DD\30B8\30C8\30EA\3067\4F5C\6210\3055\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103749267121308207)
,p_name=>'CREATE_TABLE.SCRIPT_REPOSITORY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AF\30EA\30D7\30C8\30FB\30EA\30DD\30B8\30C8\30EA\306B\79FB\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103749657124308207)
,p_name=>'CREATE_TABLE.SQL_WORKSHOP'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\30EF\30FC\30AF\30B7\30E7\30C3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103749349535308207)
,p_name=>'CREATE_TABLE.SQL_WORKSHOP_HOME'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\30EF\30FC\30AF\30B7\30E7\30C3\30D7\30FB\30DB\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104178924968308592)
,p_name=>'CREATE_TABULAR_FORM'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\5F62\5F0F\30D5\30A9\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104745180402309038)
,p_name=>'CREATE_TO_DO'
,p_message_language=>'ja'
,p_message_text=>unistr('To Do\306E\4F5C\6210')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104133175975308544)
,p_name=>'CREATE_TRIGGER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C8\30EA\30AC\30FC%0\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104079451009308499)
,p_name=>'CREATE_WS_OBJ_SUCCESS_MSG'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B7\30FC\30C8\30FB\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30AA\30D6\30B8\30A7\30AF\30C8\304C\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104033967288308462)
,p_name=>'CREDENTIAL.OWNER'
,p_message_language=>'ja'
,p_message_text=>unistr('\8CC7\683C\8A3C\660E\6240\6709\8005')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103998374605308434)
,p_name=>'CSS_CALENDAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30EC\30F3\30C0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103921735830308375)
,p_name=>'CURRENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30EC\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103990825626308428)
,p_name=>'CURRENT ENTRY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30EC\30F3\30C8\30FB\30A8\30F3\30C8\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103990511528308428)
,p_name=>'CURRENT FORM ELEMENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\884C\306E\30D5\30A9\30FC\30E0\8981\7D20')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103765157014308219)
,p_name=>'CURRENT ITEM HELP TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30A2\30A4\30C6\30E0\30FB\30D8\30EB\30D7\30FB\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103990658542308428)
,p_name=>'CURRENT ITEM IDENTIFICATION NUMBER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30EC\30F3\30C8\30FB\30A2\30A4\30C6\30E0\8B58\5225\756A\53F7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103990749005308428)
,p_name=>'CURRENT ITEM LABEL NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30EC\30F3\30C8\30FB\30A2\30A4\30C6\30E0\30FB\30E9\30D9\30EB\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104046455555308472)
,p_name=>'CURRENT TAB'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30EC\30F3\30C8\30FB\30BF\30D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103731712023308193)
,p_name=>'CURRENT_APPLICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30EC\30F3\30C8\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103738504404308198)
,p_name=>'CURRENT_IMAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30EC\30F3\30C8\30FB\30A4\30E1\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104272034912308662)
,p_name=>'CURRENT_ITEM_CONTAINER_ID'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30D5\30A3\30FC\30EB\30C9\3092\56F2\3080\30B3\30F3\30C6\30CA\8981\7D20\3067\4F7F\7528\53EF\80FD\306A\3001\300C\30E9\30D9\30EB\306E\524D\300D\3068\30A2\30A4\30C6\30E0\5C5E\6027\306EID\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104749874031309042)
,p_name=>'CURRENT_ITEM_HELP_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30EC\30F3\30C8\30FB\30A2\30A4\30C6\30E0\30FB\30D8\30EB\30D7\30FB\30E9\30D9\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103700201058308167)
,p_name=>'CURRENT_MILESTONE'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DE\30A4\30EB\30B9\30C8\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103737618606308198)
,p_name=>'CURRENT_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30EC\30F3\30C8\30FB\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104015129985308447)
,p_name=>'CURRENT_PAGE_CONTAINS_NO_ITEMS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30EC\30F3\30C8\30FB\30DA\30FC\30B8\306B\306F\30A2\30A4\30C6\30E0\304C\3042\308A\307E\305B\3093\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103986406486308425)
,p_name=>'CUSTOMIZE LINK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30F3\30AF\306E\30AB\30B9\30BF\30DE\30A4\30BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104546003485308872)
,p_name=>'CUSTOM_APPLICATIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30B9\30BF\30E0\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103563699797308061)
,p_name=>'CUSTOM_AUTH_SCHEME_DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9A\7FA9\3055\308C\305F\958B\767A\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103778891547308230)
,p_name=>'CUSTOM_AUTH_SSO_GENERIC_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\3067\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103700402948308167)
,p_name=>'CUSTOM_AUTH_STD.LOGIN_PAGE_1'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30BB\30C3\30B7\30E7\30F3\306E\30E6\30FC\30B6\30FC\8B58\5225\5B50\3068\3057\3066\4F7F\7528\3059\308B\6587\5B57\5217\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103700528918308167)
,p_name=>'CUSTOM_AUTH_STD.LOGIN_PAGE_2'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306E\30E6\30FC\30B6\30FC\540D\3068\30D1\30B9\30EF\30FC\30C9\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103700640423308167)
,p_name=>'CUSTOM_AUTH_STD.LOGIN_PAGE_3'
,p_message_language=>'ja'
,p_message_text=>unistr('LDAP\30DB\30B9\30C8: %0\3067\306E\691C\8A3C\306B\5BFE\3059\308B\30E6\30FC\30B6\30FC\540D\3068\30D1\30B9\30EF\30FC\30C9\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103700749508308167)
,p_name=>'CUSTOM_AUTH_STD.LOGIN_PAGE_4'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30B9\30AD\30FC\30DE\306E\30E6\30FC\30B6\30FC\540D\3068\30D1\30B9\30EF\30FC\30C9\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104356509439308724)
,p_name=>'CUSTOM_CALENDAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30ED\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104361597670308728)
,p_name=>'CUSTOM_CALENDAR.END_DATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D42\4E86\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104361472008308728)
,p_name=>'CUSTOM_CALENDAR.START_DATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\59CB\65E5')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104134052236308545)
,p_name=>'DA.SET_VALUE.SQL.HELP_MSG'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>True\30A2\30AF\30B7\30E7\30F3\304C\30BF\30A4\30D7\306E\8A2D\5B9A\306BSQL\6587\3092\4F7F\7528\3057\305F\300C\5024\306E\8A2D\5B9A\300D\306E\5834\5408\3001SQL\6587\306E\5217\306E\9806\5E8F\3068\540C\3058\9806\5E8F\3067\5F71\97FF\3092\53D7\3051\308B\8981\7D20\3092\5B9A\7FA9\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\5B9A\7FA9\3057\305FSQL\6587\306F\6B21\306E\3068\304A\308A\3067\3059\3002</p>'),
'<pre>%0</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103931646014308383)
,p_name=>'DATA'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104197912910308608)
,p_name=>'DATA WORKSHOP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30EF\30FC\30AF\30B7\30E7\30C3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103786713977308237)
,p_name=>'DATA.LOAD.ALL_COL_MAPPED'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\5217\3059\3079\3066\304C%1\8868\306B\81EA\52D5\7684\306B\30DE\30C3\30D7\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103787550227308237)
,p_name=>'DATA.LOAD.APPEND_INCOMPLETE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868<code>%0</code>\306E\30C7\30FC\30BF\306B<b id="incompl_success_row_count"></b>\884C\304C\65B0\898F\306B\8FFD\52A0\3055\308C\307E\3057\305F\3002<b class="u-danger-text" id="incompl_fail_row_count"></b>\884C\304C\62D2\5426\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103787196060308237)
,p_name=>'DATA.LOAD.APPEND_SUCCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868<code>%0</code>\306E\30C7\30FC\30BF\306B<b id="success_row_count"></b>\884C\304C\65B0\898F\306B\8FFD\52A0\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103787350533308237)
,p_name=>'DATA.LOAD.APPEND_WARNING'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868<code>%0</code>\306E\30C7\30FC\30BF\306B<b id="err_success_row_count"></b>\884C\304C\65B0\898F\306B\8FFD\52A0\3055\308C\307E\3057\305F\3002<b class="u-danger-text" id="err_fail_row_count"></b>\884C\304C\62D2\5426\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103539832853308044)
,p_name=>'DATA.LOAD.CHOOSE_FILE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\306E\9078\629E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103534473238308040)
,p_name=>'DATA.LOAD.COLUMN_MAPPING_REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\30DE\30C3\30D4\30F3\30B0\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103577409022308071)
,p_name=>'DATA.LOAD.CONFIGURATION_SAVED'
,p_message_language=>'ja'
,p_message_text=>unistr('\69CB\6210\304C\4FDD\5B58\3055\308C\307E\3057\305F\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103539429445308044)
,p_name=>'DATA.LOAD.DATA_PROFILE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30D7\30ED\30D5\30A1\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103539522031308044)
,p_name=>'DATA.LOAD.DATA_PROFILE_COLS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30D7\30ED\30D5\30A1\30A4\30EB\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103538861395308043)
,p_name=>'DATA.LOAD.DATA_SOURCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30BD\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103786880430308237)
,p_name=>'DATA.LOAD.DEFINE_COL_MAPPING'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30C7\30FC\30BF\3092%0\8868\306B\30ED\30FC\30C9\3059\308B\305F\3081\306E\5217\30DE\30C3\30D4\30F3\30B0\3092\5B9A\7FA9\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103539368186308044)
,p_name=>'DATA.LOAD.DEFINITION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30ED\30FC\30C9\5B9A\7FA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103539789543308044)
,p_name=>'DATA.LOAD.DRAG_DROP_FILE_HERE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\3092\3053\3053\306B\30C9\30E9\30C3\30B0\30FB\30A2\30F3\30C9\30FB\30C9\30ED\30C3\30D7\3001\307E\305F\306F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103539644023308044)
,p_name=>'DATA.LOAD.FILE_FORMATS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30DD\30FC\30C8\3055\308C\3066\3044\308B\5F62\5F0F\306Fcsv\3001xlsx\3001txt\3001xml\3001json\3067\3059')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104195933411308606)
,p_name=>'DATA.LOAD.JOB_INTERMITTENTLY_FAILED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30ED\30FC\30C9\30FB\30B8\30E7\30D6\306E\5B9F\884C\306F\3001\4E88\671F\305B\305A\505C\6B62\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104138899579308549)
,p_name=>'DATA.LOAD.JOB_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9%0\306E\30C7\30FC\30BF\30FB\30ED\30FC\30C9\30FB\30B8\30E7\30D6: \8868%1\3078\306E\30ED\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103539024489308044)
,p_name=>'DATA.LOAD.LOADED_FILE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30FC\30C9\6E08\30D5\30A1\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103786901518308237)
,p_name=>'DATA.LOAD.MAP_REMAINING_COLS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\5217(%1\5217\4E2D)\304C%2\8868\306B\81EA\52D5\7684\306B\30DE\30C3\30D7\3055\308C\307E\3057\305F\3002\6B8B\308A\306E%3\5217\3092\69CB\6210\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104177051075308590)
,p_name=>'DATA.LOAD.PASTED_DATA'
,p_message_language=>'ja'
,p_message_text=>unistr('\8CBC\308A\4ED8\3051\3089\308C\305F\30C7\30FC\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103787638230308237)
,p_name=>'DATA.LOAD.REPLACE_INCOMPLETE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868<code>%0</code>\306E\30C7\30FC\30BF\304C\65B0\898F\306E<b id="incompl_success_row_count"></b>\884C\3067\7F6E\63DB\3055\308C\307E\3057\305F\3002<b class="u-danger-text" id="incompl_fail_row_count"></b>\884C\304C\62D2\5426\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103787203700308237)
,p_name=>'DATA.LOAD.REPLACE_SUCCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868<code>%0</code>\306E\30C7\30FC\30BF\304C\65B0\898F\306E<b id="success_row_count"></b>\884C\3067\7F6E\63DB\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103787422749308237)
,p_name=>'DATA.LOAD.REPLACE_WARNING'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868<code>%0</code>\306E\30C7\30FC\30BF\304C\65B0\898F\306E<b id="err_success_row_count"></b>\884C\3067\7F6E\63DB\3055\308C\307E\3057\305F\3002<b class="u-danger-text" id="err_fail_row_count"></b>\884C\304C\62D2\5426\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103787074338308237)
,p_name=>'DATA.LOAD.SELECT_COLS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30FC\30C9\3059\308B\5217\3092\9078\629E\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103519967571308030)
,p_name=>'DATA.LOAD.SUPPORTED_FORMATS_N'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30DD\30FC\30C8\3055\308C\3066\3044\308B\5F62\5F0F%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103538972533308044)
,p_name=>'DATA.LOAD.UPLOAD_A_FILE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\306E\30A2\30C3\30D7\30ED\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103539113243308044)
,p_name=>'DATA.LOAD.XLSX_WORKSHEET'
,p_message_language=>'ja'
,p_message_text=>unistr('XLSX\30EF\30FC\30AF\30B7\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104739292430309034)
,p_name=>'DATABASE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104198576026308608)
,p_name=>'DATABASE BROWSER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30D6\30E9\30A6\30B6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104684358714308986)
,p_name=>'DATABASE.DEMO.SAMPLE.APP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30F3\30D7\30EB\30FB\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104739355347309034)
,p_name=>'DATABASE_APPLICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103583305840308075)
,p_name=>'DATABASE_APPLICATIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103598904558308087)
,p_name=>'DATABASE_APPS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104074199003308495)
,p_name=>'DATABASE_APP_SUCCESS_MSG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3<strong>%0</strong>\304C\6B63\5E38\306B\30A4\30F3\30B9\30C8\30FC\30EB\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103976823594308418)
,p_name=>'DATABASE_LINK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30EA\30F3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104026329339308456)
,p_name=>'DATABASE_OBJECT_COUNTS_BY_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30D6\30B8\30A7\30AF\30C8\30FB\30BF\30A4\30D7\5225\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30AA\30D6\30B8\30A7\30AF\30C8\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104029503021308458)
,p_name=>'DATABASE_ROLE_PRIVILEGES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30ED\30FC\30EB\306E\6A29\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103594635552308084)
,p_name=>'DATABASE_USERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104128352284308540)
,p_name=>'DATA_GRID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30B0\30EA\30C3\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104674273141308978)
,p_name=>'DATA_GRIDS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30B0\30EA\30C3\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104674662707308979)
,p_name=>'DATA_GRID_DATA'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30B0\30EA\30C3\30C9\30FB\30C7\30FC\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104661115145308968)
,p_name=>'DATA_LOAD.ADVANCED_SETTINGS_REGION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30ED\30FC\30C9\306E\8A73\7D30\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103674366585308146)
,p_name=>'DATA_LOAD.APP_DATE_FORMAT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F7F\7528\3059\308B\65E5\4ED8/\6570\5024\66F8\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103674410048308146)
,p_name=>'DATA_LOAD.APP_DATE_FORMAT_HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30B9\30BF\30E0\66F8\5F0F\30DE\30B9\30AF\3092\6307\5B9A\3059\308B\304B\3001\6A19\6E96\66F8\5F0F\30DE\30B9\30AF\3092\4F7F\7528\3059\308B\304B\3092\9078\629E\3057\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103595006541308084)
,p_name=>'DATA_LOAD.CHARSET'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\306E\6587\5B57\30BB\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104187761325308599)
,p_name=>'DATA_LOAD.COLUMN_NAMES'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104072275979308493)
,p_name=>'DATA_LOAD.COLUMN_NAME_ALIASES'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\540D\306E\5225\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104327180607308702)
,p_name=>'DATA_LOAD.CONFIRM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\306F\6B63\5E38\306B\8868\306B\30A2\30C3\30D7\30ED\30FC\30C9\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104332631114308706)
,p_name=>'DATA_LOAD.COPY_PASTE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30D4\30FC\30FB\30A2\30F3\30C9\30FB\30DA\30FC\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104321532958308698)
,p_name=>'DATA_LOAD.COPY_PASTE_TEXTAREA'
,p_message_language=>'ja'
,p_message_text=>unistr('\533A\5207\308A\30C7\30FC\30BF\3092\30B3\30D4\30FC\30FB\30A2\30F3\30C9\30FB\30DA\30FC\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104703627626309003)
,p_name=>'DATA_LOAD.CURRENCY_ITEM'
,p_message_language=>'ja'
,p_message_text=>unistr('\901A\8CA8\8A18\53F7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104703724793309003)
,p_name=>'DATA_LOAD.CURRENCY_ITEM_HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\306B\56FD\969B\901A\8CA8\8A18\53F7\304C\542B\307E\308C\3066\3044\308B\5834\5408\306F\3001\305D\306E\8A18\53F7\3092\3053\3053\306B\5165\529B\3057\3066\304F\3060\3055\3044\3002\305F\3068\3048\3070\3001\30C7\30FC\30BF\306B&euro;1,234.56\307E\305F\306F&yen;1,234.56\304C\542B\307E\308C\3066\3044\308B\5834\5408\306F\3001&euro;\307E\305F\306F&yen;\3068\5165\529B\3057\3066\304F\3060\3055\3044\3002\5165\529B\3057\306A\3044\5834\5408\3001\30C7\30FC\30BF\306F\6B63\5E38\306B\30ED\30FC\30C9\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103599751005308087)
,p_name=>'DATA_LOAD.DATA_LOADING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\306E\30ED\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104661227110308968)
,p_name=>'DATA_LOAD.DATE_FORMAT_APP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\6A19\6E96\66F8\5F0F\30DE\30B9\30AF\306E\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104661300472308968)
,p_name=>'DATA_LOAD.DATE_FORMAT_CUSTOM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30C3\30D7\30ED\30FC\30C9\5217\306E\30AB\30B9\30BF\30E0\66F8\5F0F\306E\63D0\4F9B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104704958268309004)
,p_name=>'DATA_LOAD.DECIMAL_CHARACTER_HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5C0F\6570\70B9\6587\5B57\306F\3001\6570\5024\306E\6574\6570\90E8\5206\3068\5C0F\6570\90E8\5206\3092\533A\5207\308A\307E\3059\3002</p>'),
unistr('<p>\5C0F\6570\70B9\6587\5B57\306B\306F\3001\4EFB\610F\306E\6587\5B57\3092\6307\5B9A\3067\304D\307E\3059\3002\6307\5B9A\3057\305F\6587\5B57\306F\30B7\30F3\30B0\30EB\30D0\30A4\30C8\3067\3001\5C0F\6570\70B9\6587\5B57\306F\30B0\30EB\30FC\30D7\30FB\30BB\30D1\30EC\30FC\30BF\3068\7570\306A\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\5C0F\6570\70B9\6587\5B57\306B\306F\3001\7A7A\767D\3092\6307\5B9A\3067\304D\307E\3059\304C\3001\6570\5B57\304A\3088\3073\6B21\306B\793A\3059\6587\5B57\306F\6307\5B9A\3067\304D\307E\305B\3093\3002</p>'),
'<ul class="noIndent">',
unistr('<li>\30D7\30E9\30B9(+)</li>'),
unistr('<li>\30CF\30A4\30D5\30F3(-)</li> '),
unistr('<li>\5C0F\306A\308A\8A18\53F7(<)</li>'),
unistr('<li>\5927\306A\308A\8A18\53F7(>)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104704046207309003)
,p_name=>'DATA_LOAD.DECIMAL_CHARACTER_ITEM'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C0F\6570\70B9\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103702933059308169)
,p_name=>'DATA_LOAD.DECIMAL_CHAR_REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\FF050\8868\5217\306B\30B0\30EB\30FC\30D7\30FB\30BB\30D1\30EC\30FC\30BF\304C\5B9A\7FA9\3055\308C\3066\3044\308B\5834\5408\3001\5C0F\6570\70B9\6587\5B57\304C\5FC5\8981\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104072404558308494)
,p_name=>'DATA_LOAD.DISPLAY'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104138988832308549)
,p_name=>'DATA_LOAD.DUPLICATE_MAPPING'
,p_message_language=>'ja'
,p_message_text=>unistr('\8907\6570\306E\30BD\30FC\30B9\5217\304C%0\8868\306E\5217\306B\30DE\30C3\30D7\3055\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104470310788308810)
,p_name=>'DATA_LOAD.FAILED_COUNT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5931\6557\3057\305F\884C:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104685784703308987)
,p_name=>'DATA_LOAD.FAILED_RECORD'
,p_message_language=>'ja'
,p_message_text=>unistr('\5931\6557\3057\305F\30EC\30B3\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104703268403309003)
,p_name=>'DATA_LOAD.FILE_NAME_ITEM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30C3\30D7\30ED\30FC\30C9\3059\308B\30D5\30A1\30A4\30EB\306E\540D\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104329726659308704)
,p_name=>'DATA_LOAD.FIRST_ROW'
,p_message_language=>'ja'
,p_message_text=>unistr('1\884C\76EE\306B\5217\540D\304C\3042\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104703317717309003)
,p_name=>'DATA_LOAD.FIRST_ROW_HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\306E\6700\521D\306E\884C\306B\5217\540D\304C\542B\307E\308C\308B\5834\5408\306F\3001\3053\306E\30DC\30C3\30AF\30B9\3092\9078\629E\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104703586224309003)
,p_name=>'DATA_LOAD.GLOBALIZATION_REGION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30ED\30FC\30D0\30EA\30BC\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104703917542309003)
,p_name=>'DATA_LOAD.GROUP_SEPARATOR_HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30B0\30EB\30FC\30D7\30FB\30BB\30D1\30EC\30FC\30BF\306F\3001\5343\306E\4F4D\3084\767E\4E07\306E\4F4D\306A\3069\306E\6574\6570\30B0\30EB\30FC\30D7\3092\533A\5207\308A\307E\3059\3002</p>'),
unistr('<p>\30B0\30EB\30FC\30D7\30FB\30BB\30D1\30EC\30FC\30BF\306B\306F\3001\4EFB\610F\306E\6587\5B57\3092\6307\5B9A\3067\304D\307E\3059\3002\6307\5B9A\3057\305F\6587\5B57\306F\30B7\30F3\30B0\30EB\30D0\30A4\30C8\3067\3001\30B0\30EB\30FC\30D7\30FB\30BB\30D1\30EC\30FC\30BF\306F\4ED6\306E\5C0F\6570\70B9\6587\5B57\3068\7570\306A\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\30BB\30D1\30EC\30FC\30BF\306B\306F\3001\7A7A\767D\3092\6307\5B9A\3067\304D\307E\3059\304C\3001\6570\5B57\304A\3088\3073\6B21\306B\793A\3059\6587\5B57\306F\6307\5B9A\3067\304D\307E\305B\3093\3002</p>'),
'<ul class="noIndent">',
unistr('<li>\30D7\30E9\30B9(+)</li>'),
unistr('<li>\30CF\30A4\30D5\30F3(-)</li> '),
unistr('<li>\5C0F\306A\308A\8A18\53F7(<)</li>'),
unistr('<li>\5927\306A\308A\8A18\53F7(>)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104703882834309003)
,p_name=>'DATA_LOAD.GROUP_SEPARATOR_ITEM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30EB\30FC\30D7\30FB\30BB\30D1\30EC\30FC\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104470122708308809)
,p_name=>'DATA_LOAD.INSERTED_COUNT'
,p_message_language=>'ja'
,p_message_text=>unistr('\633F\5165\3055\308C\305F\884C:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104700722051309001)
,p_name=>'DATA_LOAD.IR_MAX_ROW_COUNT'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\554F\5408\305B\306F#MAX_ROW_COUNT#\3088\308A\591A\3044\884C\6570\3092\8FD4\3057\307E\3059\3002\7D50\679C\304C\5B8C\5168\306B\306A\308B\3088\3046\306B\30C7\30FC\30BF\3092\30D5\30A3\30EB\30BF\51E6\7406\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104071147260308493)
,p_name=>'DATA_LOAD.JUSTCHANGED_RECORD'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30B3\30FC\30C9\304C\4ED6\306E\30E6\30FC\30B6\30FC\306B\3088\3063\3066\5909\66F4\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103694372274308162)
,p_name=>'DATA_LOAD.LABEL_CASE_SENSITIVE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5927/\5C0F\6587\5B57\533A\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103694299884308162)
,p_name=>'DATA_LOAD.LABEL_UNIQUE_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E00\610F\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104293248067308677)
,p_name=>'DATA_LOAD.LOAD_DATA_PROCESS_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\306E\30ED\30FC\30C9\306B\5931\6557\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104293369962308677)
,p_name=>'DATA_LOAD.LOAD_DATA_PROCESS_SUCCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3\304C\51E6\7406\3055\308C\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104317381322308695)
,p_name=>'DATA_LOAD.LOAD_TO'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30DD\30FC\30C8\5143')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104126565924308538)
,p_name=>'DATA_LOAD.MAPPING_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\624B\98062 - \30DA\30FC\30B8\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104751626646309044)
,p_name=>'DATA_LOAD.NO_PREVIEW'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F7F\7528\53EF\80FD\306A\30D5\30A1\30A4\30EB\30FB\30D7\30EC\30D3\30E5\30FC\306F\3042\308A\307E\305B\3093')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104702454959309002)
,p_name=>'DATA_LOAD.OPTIONAL_ENCLOSE_ITEM'
,p_message_language=>'ja'
,p_message_text=>unistr('\56F2\307F\6587\5B57(\30AA\30D7\30B7\30E7\30F3)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104664615794308971)
,p_name=>'DATA_LOAD.PROGRESS_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30ED\30FC\30C9\30FB\30A6\30A3\30B6\30FC\30C9\306E\9032\6357\72B6\6CC1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104126736569308539)
,p_name=>'DATA_LOAD.RESULTS_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\624B\98064 - \30DA\30FC\30B8\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104072365359308493)
,p_name=>'DATA_LOAD.RETURN'
,p_message_language=>'ja'
,p_message_text=>unistr('\623B\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104070665308308492)
,p_name=>'DATA_LOAD.REVIEW_COUNT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30D3\30E5\30FC\306E\5FC5\8981\306A\884C:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104184854695308597)
,p_name=>'DATA_LOAD.RULES_PLSQL_EXPRESSION_EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'to_char(sysdate)',
'',
'my_func (',
'    p_1 => :SAL,',
'    p_2 => :COMM)',
'',
unistr('\3053\3053\3067\3001SAL\3068COMM\306F\30A2\30C3\30D7\30ED\30FC\30C9\3055\308C\305F\30C7\30FC\30BF\306E\5217\540D\3001'),
unistr('my_func\306F\5024\3092\8FD4\3059\30D5\30A1\30F3\30AF\30B7\30E7\30F3\3067\3059\3002\8FD4\3055\308C\305F\5024\306F\3001'),
unistr('\3053\306E\30C8\30E9\30F3\30B9\30D5\30A9\30FC\30E1\30FC\30B7\30E7\30F3\30FB\30EB\30FC\30EB\304C\5B9A\7FA9\3055\308C\3066\3044\308B\5217\306E\65B0\3057\3044\5024\3068\306A\308A\307E\3059\3002'),
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104185005141308597)
,p_name=>'DATA_LOAD.RULES_PLSQL_FUNCTION_EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'declare',
'    l_result number;',
'begin',
'    l_result := :SAL * :COMM;',
'    return l_result;',
'end;',
'',
unistr('\8FD4\3055\308C\305F\7D50\679C\306F\3053\306E\30C8\30E9\30F3\30B9\30D5\30A9\30FC\30E1\30FC\30B7\30E7\30F3\30FB\30EB\30FC\30EB\304C\5B9A\7FA9\3055\308C\3066\3044\308B\5217\306E\65B0\3057\3044\5024\3068\306A\308A\307E\3059\3002'),
'',
unistr(':SAL\3068:COMM\306F\3001\30A2\30C3\30D7\30ED\30FC\30C9\3055\308C\305F\30C7\30FC\30BF\306ESAL\5217\304A\3088\3073COMM\5217\306E\540D\524D\3092\53C2\7167\3057\307E\3059\3002'),
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104184906083308597)
,p_name=>'DATA_LOAD.RULES_SQL_QUERY_EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select depno',
' from dept',
'where dname = :DEPTNAME',
'  and loc   = :LOC',
'',
unistr(':DEPNAME\3068:LOC\306F\3001\30A2\30C3\30D7\30ED\30FC\30C9\3055\308C\305F\30C7\30FC\30BF\306EDEPNAME\5217\304A\3088\3073LOC\5217\306E\540D\524D\3092\53C2\7167\3057\307E\3059\3002'),
'',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103711032477308176)
,p_name=>'DATA_LOAD.SAME_GROUP_DECIMAL_CHARS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\8868\306E\5217\3067\3001\540C\3058\6587\5B57\3092\30B0\30EB\30FC\30D7\30FB\30BB\30D1\30EC\30FC\30BF\3068\5C0F\6570\70B9\6587\5B57\306E\4E21\65B9\3068\3057\3066\5B9A\7FA9\3059\308B\3053\3068\306F\3067\304D\307E\305B\3093\3002\7570\306A\308B\6587\5B57\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104702255282309002)
,p_name=>'DATA_LOAD.SEPARATOR_ITEM_HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\30BB\30D1\30EC\30FC\30BF\6587\5B57\3092\6307\5B9A\3057\3066\304F\3060\3055\3044\3002\30BF\30D6\30FB\30BB\30D1\30EC\30FC\30BF\306B\306F<code>\005Ct</code>\3092\4F7F\7528\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104702355785309002)
,p_name=>'DATA_LOAD.SEPARATOR_ITEM_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30D1\30EC\30FC\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104072578130308494)
,p_name=>'DATA_LOAD.SEQUENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104660953654308968)
,p_name=>'DATA_LOAD.SHOW_ADVANCED_SETTINGS'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A73\7D30\8A2D\5B9A\306E\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104661072898308968)
,p_name=>'DATA_LOAD.SHOW_ADVANCED_SETTINGS_HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30ED\30FC\30C9\306E\8A73\7D30\8A2D\5B9A\306E\8868\793A: \901A\8CA8\8A18\53F7\3001\5C0F\6570\70B9\6587\5B57\3001\30D5\30A1\30A4\30EB\30FB\30A8\30F3\30B3\30FC\30C7\30A3\30F3\30B0\307E\305F\306F\65E5\4ED8\66F8\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104337267304308710)
,p_name=>'DATA_LOAD.SOURCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30ED\30FC\30C9\30FB\30BD\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104126495410308538)
,p_name=>'DATA_LOAD.SOURCE_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\624B\98061 - \30DA\30FC\30B8\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104739542486309034)
,p_name=>'DATA_LOAD.TAB_SEPARTOR_NOTE'
,p_message_language=>'ja'
,p_message_text=>unistr('(\30BF\30D6\306F\005Ct)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104701093035309001)
,p_name=>'DATA_LOAD.UNIQUE_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E00\610F\5217%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104470207940308809)
,p_name=>'DATA_LOAD.UPDATED_COUNT'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F4\65B0\3055\308C\305F\884C:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104780892522309074)
,p_name=>'DATA_LOAD.UPLOADED_NULL_VALUE'
,p_message_language=>'ja'
,p_message_text=>unistr('NULL\5024\304C\30A2\30C3\30D7\30ED\30FC\30C9\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104332562912308706)
,p_name=>'DATA_LOAD.UPLOAD_FILE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\3092\30A2\30C3\30D7\30ED\30FC\30C9(\30AB\30F3\30DE\533A\5207\308A(*.csv)\307E\305F\306F\30BF\30D6\533A\5207\308A)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104337439534308710)
,p_name=>'DATA_LOAD.UPLOAD_RESULTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30ED\30FC\30C9\7D50\679C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104337315875308710)
,p_name=>'DATA_LOAD.VALIDATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\691C\8A3C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104126615230308539)
,p_name=>'DATA_LOAD.VALIDATION_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\624B\98063 - \30DA\30FC\30B8\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104130765757308542)
,p_name=>'DATA_LOAD_WIZARD_CREATED_SUCCESSFULLY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30ED\30FC\30C9\30FB\30A6\30A3\30B6\30FC\30C9\30FB\30DA\30FC\30B8\304C\6B63\5E38\306B\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104293467928308677)
,p_name=>'DATA_SAVE.LOAD_DATA_PROCESS_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\3068\8868\306E\30DE\30C3\30D4\30F3\30B0\306B\5931\6557\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104293598440308677)
,p_name=>'DATA_SAVE.LOAD_DATA_PROCESS_SUCCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3\304C\51E6\7406\3055\308C\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103999501131308435)
,p_name=>'DATA_UPLOAD_COLUMN_MAPPING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30A2\30C3\30D7\30ED\30FC\30C9\5217\306E\30DE\30C3\30D4\30F3\30B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103724375088308187)
,p_name=>'DATA_WORKSHOP.CONFIGURE.COLUMN_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\30BF\30A4\30D7: \5217%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103586103423308077)
,p_name=>'DATA_WORKSHOP.CONFIGURE.DECIMAL_CHARACTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C0F\6570\70B9\6587\5B57: \5217%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103586308531308078)
,p_name=>'DATA_WORKSHOP.CONFIGURE.FORMAT_MASK'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F8\5F0F\30DE\30B9\30AF: \5217%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103586286963308078)
,p_name=>'DATA_WORKSHOP.CONFIGURE.GROUP_SEPARATOR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30EB\30FC\30D7\30FB\30BB\30D1\30EC\30FC\30BF: \5217%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103586554828308078)
,p_name=>'DATA_WORKSHOP.CONFIGURE.MAP_TO_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30C3\30D7\5148: \5217%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103773486273308226)
,p_name=>'DATA_WORKSHOP.CONFIGURE.MAX_LENGTH'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5927\9577: \5217%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103586439443308078)
,p_name=>'DATA_WORKSHOP.CONFIGURE.UNMAPPED'
,p_message_language=>'ja'
,p_message_text=>unistr('- \672A\30DE\30C3\30D7\5217 -')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104119667066308533)
,p_name=>'DATEPICKER.DEFAULT_DATE_INVALID'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3057\305F\30A2\30A4\30C6\30E0%1\306E\300C\30CF\30A4\30E9\30A4\30C8\3055\308C\305F\65E5\4ED8\300D\5C5E\6027\306E\5024%0\304C\3001%2\306E\5F62\5F0F\3068\4E00\81F4\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104124884847308537)
,p_name=>'DATEPICKER.DEFAULT_DATE_INVALID_RELATIVE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3057\305F\30A2\30A4\30C6\30E0%1\306E\300C\30CF\30A4\30E9\30A4\30C8\3055\308C\305F\65E5\4ED8\300D\5C5E\6027\306E\5024%0\304C\3001\76F8\5BFE\65E5\4ED8\3067\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104119899932308533)
,p_name=>'DATEPICKER.MAX_DATE_INVALID'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3057\305F\30A2\30A4\30C6\30E0%1\306E\300C\6700\5927\65E5\4ED8\300D\5C5E\6027\306E\5024%0\304C\3001%2\306E\5F62\5F0F\3068\4E00\81F4\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104125073309308537)
,p_name=>'DATEPICKER.MAX_DATE_INVALID_RELATIVE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3057\305F\30A2\30A4\30C6\30E0%1\306E\300C\6700\5927\65E5\4ED8\300D\5C5E\6027\306E\5024%0\304C\3001\76F8\5BFE\65E5\4ED8\3067\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103537114226308042)
,p_name=>'DATEPICKER.MAX_STATIC_INVALID'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3057\305F\30A2\30A4\30C6\30E0%1\306E\300C\6700\5927\9759\7684\300D\5C5E\6027\306E\5024%0\304C\3001%2\306E\5F62\5F0F\3068\4E00\81F4\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104119741549308533)
,p_name=>'DATEPICKER.MIN_DATE_INVALID'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3057\305F\30A2\30A4\30C6\30E0%1\306E\300C\6700\5C0F\65E5\4ED8\300D\5C5E\6027\306E\5024%0\304C\3001%2\306E\5F62\5F0F\3068\4E00\81F4\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104124904721308537)
,p_name=>'DATEPICKER.MIN_DATE_INVALID_RELATIVE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3057\305F\30A2\30A4\30C6\30E0%1\306E\300C\6700\5C0F\65E5\4ED8\300D\5C5E\6027\306E\5024%0\304C\3001\76F8\5BFE\65E5\4ED8\3067\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103537054276308042)
,p_name=>'DATEPICKER.MIN_STATIC_INVALID'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3057\305F\30A2\30A4\30C6\30E0%1\306E\300C\6700\5C0F\9759\7684\300D\5C5E\6027\306E\5024%0\304C\3001%2\306E\5F62\5F0F\3068\4E00\81F4\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104226948429308629)
,p_name=>'DATE_ADDED'
,p_message_language=>'ja'
,p_message_text=>unistr('\8FFD\52A0\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104671677490308976)
,p_name=>'DATE_OF_LAST_RUN'
,p_message_language=>'ja'
,p_message_text=>unistr('\524D\56DE\306E\5B9F\884C\6642\9593\3092\793A\3059Oracle APEX\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30B8\30E7\30D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104049435154308475)
,p_name=>'DAYS_BEFORE_FINAL_MILESTONE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\7D42\30DE\30A4\30EB\30B9\30C8\30F3\307E\3067')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104049558396308475)
,p_name=>'DAYS_BEFORE_FINAL_MILESTONE_OF_RELASE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30EA\30FC\30B9%0\306E\6700\7D42\30DE\30A4\30EB\30B9\30C8\30F3\307E\3067')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104124263277308537)
,p_name=>'DA_NAME.NATIVE_ADD_CLASS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30E9\30B9\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104677048454308981)
,p_name=>'DA_NAME.NATIVE_ALERT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30E9\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104675860392308980)
,p_name=>'DA_NAME.NATIVE_CANCEL_EVENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30D9\30F3\30C8\306E\53D6\6D88')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104677255763308981)
,p_name=>'DA_NAME.NATIVE_CLEAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30EA\30A2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104677176434308981)
,p_name=>'DA_NAME.NATIVE_CONFIRM'
,p_message_language=>'ja'
,p_message_text=>unistr('\78BA\8A8D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103516528904308027)
,p_name=>'DA_NAME.NATIVE_DIALOG_CANCEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C0\30A4\30A2\30ED\30B0\3092\53D6\308A\6D88\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103516647870308027)
,p_name=>'DA_NAME.NATIVE_DIALOG_CLOSE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C0\30A4\30A2\30ED\30B0\3092\9589\3058\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103668503188308142)
,p_name=>'DA_NAME.NATIVE_DISABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103668496200308142)
,p_name=>'DA_NAME.NATIVE_ENABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6709\52B9\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104668712877308974)
,p_name=>'DA_NAME.NATIVE_EXECUTE_PLSQL_CODE'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\30B3\30FC\30C9\306E\5B9F\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103668310518308142)
,p_name=>'DA_NAME.NATIVE_HIDE'
,p_message_language=>'ja'
,p_message_text=>unistr('\975E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104044744301308471)
,p_name=>'DA_NAME.NATIVE_JAVASCRIPT_CODE'
,p_message_language=>'ja'
,p_message_text=>unistr('JavaScript\30B3\30FC\30C9\306E\5B9F\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104298922164308681)
,p_name=>'DA_NAME.NATIVE_REFRESH'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30D5\30EC\30C3\30B7\30E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104124333051308537)
,p_name=>'DA_NAME.NATIVE_REMOVE_CLASS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30E9\30B9\306E\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104124474319308537)
,p_name=>'DA_NAME.NATIVE_SET_CSS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30BF\30A4\30EB\306E\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104281816455308669)
,p_name=>'DA_NAME.NATIVE_SET_FOCUS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30FC\30AB\30B9\306E\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104044681159308471)
,p_name=>'DA_NAME.NATIVE_SET_VALUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024\306E\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103668293804308142)
,p_name=>'DA_NAME.NATIVE_SHOW'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104281954262308669)
,p_name=>'DA_NAME.NATIVE_SUBMIT_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306E\9001\4FE1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104263425259308656)
,p_name=>'DA_NAME.NATIVE_TREE_COLLAPSE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C4\30EA\30FC\3092\9589\3058\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104263375170308655)
,p_name=>'DA_NAME.NATIVE_TREE_EXPAND'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C4\30EA\30FC\3092\958B\304F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103565822548308063)
,p_name=>'DBACCOUNT_AUTH_SCHEME_DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30A2\30AB\30A6\30F3\30C8')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104041366639308468)
,p_name=>'DB_COLS_CASE_SEN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\306E\8868\540D\304A\3088\3073\5217\540D\3067\306F\5927/\5C0F\6587\5B57\304C\533A\5225\3055\308C\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104141025750308551)
,p_name=>'DB_OBJECT_CREATION_EXCEPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('DB\30AA\30D6\30B8\30A7\30AF\30C8\306E\4F5C\6210\4F8B\5916')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103579488549308073)
,p_name=>'DB_PRODUCT_NAME'
,p_message_language=>'ja'
,p_message_text=>'Oracle Database'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104729793251309025)
,p_name=>'DB_SERVICES_ALIAS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5225\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104726409796309022)
,p_name=>'DB_SERVICES_ALL_MIMES'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\306EMime')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104729482617309025)
,p_name=>'DB_SERVICES_CREATE_HANDLER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CF\30F3\30C9\30E9\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104726735724309022)
,p_name=>'DB_SERVICES_CREATE_METHOD'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E1\30BD\30C3\30C9\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104726517717309022)
,p_name=>'DB_SERVICES_CREATE_PARAMETER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30E9\30E1\30FC\30BF\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104726623456309022)
,p_name=>'DB_SERVICES_CREATE_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104733604301309029)
,p_name=>'DB_SERVICES_DB_SERVICES_MODULE'
,p_message_language=>'ja'
,p_message_text=>unistr('RESTful\30B5\30FC\30D3\30B9\30FB\30E2\30B8\30E5\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104729341257309025)
,p_name=>'DB_SERVICES_HANDLER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CF\30F3\30C9\30E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104734103641309030)
,p_name=>'DB_SERVICES_HANDLER_BIND_VARIABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CF\30F3\30C9\30E9\30FB\30D0\30A4\30F3\30C9\5909\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104706588481309005)
,p_name=>'DB_SERVICES_HANDLER_METHOD'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CF\30F3\30C9\30E9\30FB\30E1\30BD\30C3\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104734491367309030)
,p_name=>'DB_SERVICES_HANDLER_SOURCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CF\30F3\30C9\30E9\30FB\30BD\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104706639677309005)
,p_name=>'DB_SERVICES_HANDLER_SRC_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CF\30F3\30C9\30E9\30FB\30BD\30FC\30B9\30FB\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104726202411309021)
,p_name=>'DB_SERVICES_METHOD'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E1\30BD\30C3\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104733739552309029)
,p_name=>'DB_SERVICES_MODULE_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E2\30B8\30E5\30FC\30EB\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104734277914309030)
,p_name=>'DB_SERVICES_MODULE_URI'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E2\30B8\30E5\30FC\30EBURI\63A5\982D\8F9E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104726870949309022)
,p_name=>'DB_SERVICES_NO_SOURCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BD\30FC\30B9\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104726164630309021)
,p_name=>'DB_SERVICES_PARAMETER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30E9\30E1\30FC\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104733946222309030)
,p_name=>'DB_SERVICES_RESTFUL_SERVICES'
,p_message_language=>'ja'
,p_message_text=>unistr('RESTful\30B5\30FC\30D3\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104726396994309021)
,p_name=>'DB_SERVICES_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104734327358309030)
,p_name=>'DB_SERVICES_TEMPLATE_URI'
,p_message_language=>'ja'
,p_message_text=>unistr('URI\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104706472712309005)
,p_name=>'DB_SERVICES_URI'
,p_message_language=>'ja'
,p_message_text=>'Uniform Resource Identifier (URI)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104733440769309029)
,p_name=>'DB_SERVICES_URI_PRIFIX'
,p_message_language=>'ja'
,p_message_text=>unistr('URI\63A5\982D\8F9E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104733543654309029)
,p_name=>'DB_SERVICES_URI_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('URI\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104706771750309006)
,p_name=>'DB_SERVICE_QUERY_ONE_ROW'
,p_message_language=>'ja'
,p_message_text=>unistr('1\884C\554F\3044\5408\305B\308B')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103950625093308398)
,p_name=>'DEBUG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D0\30C3\30B0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104057004965308481)
,p_name=>'DECLINED'
,p_message_language=>'ja'
,p_message_text=>unistr('\62D2\5426')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104779375580309073)
,p_name=>'DEFAULT_DIALOGBTNR_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\306E\30C0\30A4\30A2\30ED\30B0\30FB\30DC\30BF\30F3\30FB\30EA\30FC\30B8\30E7\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104779209899309073)
,p_name=>'DEFAULT_DIALOGR_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\306E\30C0\30A4\30A2\30ED\30B0\30FB\30B3\30F3\30C6\30F3\30C4\30FB\30EA\30FC\30B8\30E7\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104294170532308678)
,p_name=>'DEFAULT_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\30FB\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103936426976308387)
,p_name=>'DEFAULT_TABLESPACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\306E\8868\9818\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103938036830308388)
,p_name=>'DEFAULT_TABLESPACE_INIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\306E\8868\9818\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104186587090308598)
,p_name=>'DEFAULT_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\306E\30C6\30F3\30D7\30EC\30FC\30C8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103561898225308060)
,p_name=>'DEFINED_BY_DA'
,p_message_language=>'ja'
,p_message_text=>unistr('\52D5\7684\30A2\30AF\30B7\30E7\30F3\3067\5B9A\7FA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104352821303308721)
,p_name=>'DEFINED_TABS'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\306F\3001%0\306E\30BF\30D6\304C%1\306E\30BF\30D6\30FB\30BB\30C3\30C8\306B\7DE8\6210\3055\308C\3001%2\306E\89AA\30BF\30D6\304C\5B9A\7FA9\3055\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103805383238308251)
,p_name=>'DEFINE_LOV'
,p_message_language=>'ja'
,p_message_text=>unistr('LOV\306E\5B9A\7FA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103986594960308425)
,p_name=>'DEFINITION'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9A\7FA9')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104138746672308549)
,p_name=>'DEINSTALLATION_SCRIPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\524A\9664\30B9\30AF\30EA\30D7\30C8')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103657021162308133)
,p_name=>'DELETED'
,p_message_language=>'ja'
,p_message_text=>unistr('\524A\9664\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104673718411308978)
,p_name=>'DELETE_APPLICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104179037569308592)
,p_name=>'DELETE_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\524A\9664: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104171215703308584)
,p_name=>'DELETE_LINK_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306E\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103589012049308080)
,p_name=>'DELETE_MSG'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\524A\9664\64CD\4F5C\3092\5B9F\884C\3057\307E\3059\304B\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103613334250308097)
,p_name=>'DEMO.COLLECT.DESCR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30EC\30AF\30B7\30E7\30F3\30FB\30B7\30E7\30A6\30B1\30FC\30B9\3067\306F\3001Oracle APEX\30BB\30C3\30B7\30E7\30F3\5185\3067\4F7F\7528\3059\308B\30C7\30FC\30BF\306E\884C\3092\683C\7D0D\3067\304D\307E\3059\3002\3053\306E\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306F\3001PL/SQL\3092\4F7F\7528\3057\3066\30B3\30EC\30AF\30B7\30E7\30F3\30D9\30FC\30B9\306E\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\3092\4F5C\6210\304A\3088\3073\7BA1\7406\3059\308B\65B9\6CD5\3092\793A\3057\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103613156659308097)
,p_name=>'DEMO.SAMPLE.APP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30F3\30D7\30EB\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103613257890308097)
,p_name=>'DEMO.SAMPLE.APP.DESCR'
,p_message_language=>'ja'
,p_message_text=>unistr('\88FD\54C1\30DD\30FC\30BF\30EB\306F\3001\3088\304F\4F7F\7528\3055\308C\308B\8A2D\8A08\6982\5FF5\3092\5F37\8ABF\3059\308B\305F\3081\306E\30B5\30F3\30D7\30EB\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\3059\3002\9867\5BA2\3001\88FD\54C1\3001\30AA\30FC\30C0\30FC\306E\5C02\7528\30DA\30FC\30B8\304C\3042\308A\3001\30EC\30DD\30FC\30C8\3001\30C1\30E3\30FC\30C8\3001\30AB\30EC\30F3\30C0\3001\30DE\30C3\30D7\3001\30C4\30EA\30FC\306E\4F7F\7528\65B9\6CD5\3082\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104007481821308441)
,p_name=>'DEMONSTRABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30E2\53EF\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103734126497308195)
,p_name=>'DEMO_APPLICATION.ABOUT_BUSINESS_LOOK'
,p_message_language=>'ja'
,p_message_text=>unistr('\5F37\529B\306A\30EC\30DD\30FC\30C8\304A\3088\3073\30DA\30FC\30B8\533A\5207\308A\306E\6982\5FF5\306E\4F8B\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103733820199308194)
,p_name=>'DEMO_APPLICATION.ABOUT_PETSTORE'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\3067\4F5C\6210\3055\308C\305F\30AA\30F3\30E9\30A4\30F3\30FB\30B9\30C8\30A2\306E\4F8B\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103734593867308195)
,p_name=>'DEMO_APPLICATION.ABOUT_PRESIDENTIAL'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\3067\306EOracle Text\306E\4F7F\7528\65B9\6CD5\306B\3064\3044\3066\5B66\7FD2\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103734942379308195)
,p_name=>'DEMO_APPLICATION.ABOUT_PROJ_TRACKING'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\3067\4F5C\6210\3055\308C\305F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\30C8\30E9\30C3\30AD\30F3\30B0\3059\308B\30D7\30ED\30B8\30A7\30AF\30C8\30FB\30B9\30C6\30FC\30BF\30B9\306E\4F8B\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103734312739308195)
,p_name=>'DEMO_APPLICATION.ABOUT_WEBSERVICES'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\3067\306EWeb\30B5\30FC\30D3\30B9\306E\4F7F\7528\65B9\6CD5\3092\5B66\3073\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103732741431308194)
,p_name=>'DEMO_APPLICATION.ACTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103730633605308192)
,p_name=>'DEMO_APPLICATION.APPLICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103730305785308192)
,p_name=>'DEMO_APPLICATION.BASIC_LEXER'
,p_message_language=>'ja'
,p_message_text=>'BASIC_LEXER'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103734030784308195)
,p_name=>'DEMO_APPLICATION.BUSINESS_LOOK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D3\30B8\30CD\30B9\30FB\30EB\30C3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103732892514308194)
,p_name=>'DEMO_APPLICATION.COLLECTION_SHOWCASE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30EC\30AF\30B7\30E7\30F3\30FB\30B7\30E7\30A6\30B1\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103730461952308192)
,p_name=>'DEMO_APPLICATION.CONTEXT_INDEX'
,p_message_language=>'ja'
,p_message_text=>'CONTEXT INDEX'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103729869423308191)
,p_name=>'DEMO_APPLICATION.CREATE_BASIC'
,p_message_language=>'ja'
,p_message_text=>unistr('\57FA\672C\7684\306A\30B5\30F3\30D7\30EB\30FB\30C7\30E2\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\4F5C\6210\3057\3088\3046\3068\3057\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103728440863308190)
,p_name=>'DEMO_APPLICATION.CREATE_BUSINESS_LOOK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D3\30B8\30CD\30B9\30FB\30EB\30C3\30AF\30FB\30C7\30E2\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092(\518D)\4F5C\6210\3057\3088\3046\3068\3057\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103729967402308191)
,p_name=>'DEMO_APPLICATION.CREATE_COLLECTION_SHOWCASE'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\30B3\30EC\30AF\30B7\30E7\30F3\30FB\30B7\30E7\30A6\30B1\30FC\30B9\300D\30C7\30E2\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\4F5C\6210\3057\3088\3046\3068\3057\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103730045040308191)
,p_name=>'DEMO_APPLICATION.CREATE_OR_RECREATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AD\30FC\30DE%0\3067\4F5C\6210\307E\305F\306F\518D\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103728396831308190)
,p_name=>'DEMO_APPLICATION.CREATE_WEB_SERVICES'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B5\30FC\30D3\30B9\306B\3064\3044\3066\8AAC\660E\3059\308B\30B5\30F3\30D7\30EB\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\4F5C\6210\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103728543007308190)
,p_name=>'DEMO_APPLICATION.CREATE_WORLDCUP_MANIA'
,p_message_language=>'ja'
,p_message_text=>unistr('WorldCup Mania\30C7\30E2\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\4F5C\6210\3057\3088\3046\3068\3057\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103569577553308066)
,p_name=>'DEMO_APPLICATION.DEINSTALL'
,p_message_language=>'ja'
,p_message_text=>unistr('\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103732548364308193)
,p_name=>'DEMO_APPLICATION.DEMO_APP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30E2\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103730960503308192)
,p_name=>'DEMO_APPLICATION.FREE_SPACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D04%0MB\306E\7A7A\304D\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103733333491308194)
,p_name=>'DEMO_APPLICATION.INSTALL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30B9\30C8\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103733052921308194)
,p_name=>'DEMO_APPLICATION.INSTALLED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30B9\30C8\30FC\30EB\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103865055774308297)
,p_name=>'DEMO_APPLICATION.INSTALL_DEMO_APP'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306E\4E3B\8981\6A5F\80FD\3092\8AAC\660E\3059\308B\30B5\30F3\30D7\30EB\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\30A4\30F3\30B9\30C8\30FC\30EB\3057\3088\3046\3068\3057\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103733982299308195)
,p_name=>'DEMO_APPLICATION.INSTALL_NOW'
,p_message_language=>'ja'
,p_message_text=>unistr('\4ECA\3059\3050\30A4\30F3\30B9\30C8\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103732914527308194)
,p_name=>'DEMO_APPLICATION.LEARN_ABOUT'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\30B7\30E7\30C3\30D4\30F3\30B0\30FB\30AB\30FC\30C8\306E\6982\5FF5\306B\3064\3044\3066\5B66\7FD2\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104174030241308587)
,p_name=>'DEMO_APPLICATION.LOCKED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30C3\30AF\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103730727200308192)
,p_name=>'DEMO_APPLICATION.NEED_7M'
,p_message_language=>'ja'
,p_message_text=>unistr('\5927\7D71\9818\5C31\4EFB\6F14\8AAC\30C7\30E2\306B\306F\7D047MB\306E\7A7A\304D\30C7\30A3\30B9\30AF\9818\57DF\304C\5FC5\8981\3067\3059\3002\307E\305F\3001\3053\306E\30C7\30E2\3092\30B9\30AD\30FC\30DE\306B\30A4\30F3\30B9\30C8\30FC\30EB\3059\308B\5834\5408\306F\6700\59272\5206\304B\304B\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103864736714308297)
,p_name=>'DEMO_APPLICATION.NOT_ENOUGH_SPACE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30C7\30E2\30F3\30B9\30C8\30EC\30FC\30B7\30E7\30F3\3092\4F5C\6210\3059\308B\305F\3081\306E\5341\5206\306A\9818\57DF\304C\3042\308A\307E\305B\3093\3067\3057\305F\3002\7BA1\7406\30DA\30FC\30B8\306B\79FB\52D5\3057\3066\8FFD\52A0\306E\8A18\61B6\57DF\3092\30EA\30AF\30A8\30B9\30C8\3057\3066\304F\3060\3055\3044\3002(\30D7\30ED\30D3\30B8\30E7\30CB\30F3\30B0\30FB\30B5\30FC\30D3\30B9\306B\79FB\52D5\3057\3066\3001\8FFD\52A0\306E\8A18\61B6\57DF\3092\30EA\30AF\30A8\30B9\30C8\3059\308B\305F\3081\306E\30EA\30F3\30AF\3092\30AF\30EA\30C3\30AF\3057\3066\304F\3060\3055\3044\3002) %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103733255803308194)
,p_name=>'DEMO_APPLICATION.NOT_INSTALLED'
,p_message_language=>'ja'
,p_message_text=>unistr('\672A\30A4\30F3\30B9\30C8\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103729287930308191)
,p_name=>'DEMO_APPLICATION.OBJECT_EXIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B58\5728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103728130464308190)
,p_name=>'DEMO_APPLICATION.OBJECT_EXISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B58\5728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103729191971308191)
,p_name=>'DEMO_APPLICATION.OBJECT_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\540D\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103730264285308192)
,p_name=>'DEMO_APPLICATION.OBJECT_NAME2'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30D6\30B8\30A7\30AF\30C8\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103728230380308190)
,p_name=>'DEMO_APPLICATION.OBJECT_NOT_EXISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B58\5728\3057\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103728829820308190)
,p_name=>'DEMO_APPLICATION.OBJECT_RECREATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30AA\30D6\30B8\30A7\30AF\30C8\304C\5B58\5728\3059\308B\5834\5408\306F\3001\518D\4F5C\6210\3055\308C\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103729060469308191)
,p_name=>'DEMO_APPLICATION.OBJECT_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30D6\30B8\30A7\30AF\30C8\30FB\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103729791595308191)
,p_name=>'DEMO_APPLICATION.PACKAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30C3\30B1\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103733723763308194)
,p_name=>'DEMO_APPLICATION.PETSTORE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30C3\30C8\30FB\30B7\30E7\30C3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103734462972308195)
,p_name=>'DEMO_APPLICATION.PRESIDENTIAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5927\7D71\9818\5C31\4EFB\6F14\8AAC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103734732931308195)
,p_name=>'DEMO_APPLICATION.PROJECT_TRACKING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30B8\30A7\30AF\30C8\306E\30C8\30E9\30C3\30AD\30F3\30B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103941982971308391)
,p_name=>'DEMO_APPLICATION.RE_INSTALL'
,p_message_language=>'ja'
,p_message_text=>unistr('\518D\30A4\30F3\30B9\30C8\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103733138075308194)
,p_name=>'DEMO_APPLICATION.RUN'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9F\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103728926020308190)
,p_name=>'DEMO_APPLICATION.SCHEMA'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AD\30FC\30DE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103729587865308191)
,p_name=>'DEMO_APPLICATION.SEQUENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103732646274308193)
,p_name=>'DEMO_APPLICATION.STATUS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30C6\30FC\30BF\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103729315452308191)
,p_name=>'DEMO_APPLICATION.TABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103732436171308193)
,p_name=>'DEMO_APPLICATION.TABLE_SUMMARY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30E2\30F3\30B9\30C8\30EC\30FC\30B7\30E7\30F3\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30A4\30F3\30B9\30C8\30FC\30EB\30FB\30B9\30C6\30FC\30BF\30B9\30FB\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103729637387308191)
,p_name=>'DEMO_APPLICATION.TRIGGER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C8\30EA\30AC\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104174100094308587)
,p_name=>'DEMO_APPLICATION.UNLOCKED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30C3\30AF\89E3\9664\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103594876887308084)
,p_name=>'DEMO_APPLICATION.UPDATE_AVAILABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F4\65B0\304C\3042\308A\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104752482311309044)
,p_name=>'DEMO_APPLICATION.WEBSHEET_OBJECT_VALIDATE'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B7\30FC\30C8\3092\6B63\3057\304F\5B9F\884C\3059\308B\306B\306F\3001\6B21\306E\7121\52B9\306A\30AA\30D6\30B8\30A7\30AF\30C8\3092\4FEE\6B63\3059\308B\5FC5\8981\304C\3042\308A\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103734254425308195)
,p_name=>'DEMO_APPLICATION.WEB_SERVICES'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B5\30FC\30D3\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103731022946308192)
,p_name=>'DEMO_APPLICATION.WILL_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30C7\30E2\30F3\30B9\30C8\30EC\30FC\30B7\30E7\30F3\3092\518D\4F5C\6210\3057\306A\3044\5834\5408\3001\30A8\30E9\30FC\304C\767A\751F\3059\308B\53EF\80FD\6027\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103676047924308147)
,p_name=>'DEMO_FLOW.CREATED_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30C7\30E2\30F3\30B9\30C8\30EC\30FC\30B7\30E7\30F3\3092\4F5C\6210\3059\308B\305F\3081\306E\5341\5206\306A\9818\57DF\304C\3042\308A\307E\305B\3093\3067\3057\305F\3002\7BA1\7406\30DA\30FC\30B8\306B\79FB\52D5\3057\3001\300C\73FE\884C\306E\30B5\30FC\30D3\30B9\3078\306E\5909\66F4\3092\30EA\30AF\30A8\30B9\30C8\300D\30EA\30F3\30AF\3092\30AF\30EA\30C3\30AF\3057\3066\3001\8FFD\52A0\306E\8A18\61B6\57DF\3092\30EA\30AF\30A8\30B9\30C8\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103675917162308147)
,p_name=>'DEMO_FLOW.CREATED_SUCCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\30C7\30E2\30F3\30B9\30C8\30EC\30FC\30B7\30E7\30F3\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304C\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104331346639308705)
,p_name=>'DEPRECATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\975E\63A8\5968')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103627057598308107)
,p_name=>'DERIVED$'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C0E\51FA\5217')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104007324144308441)
,p_name=>'DESIRABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\671B\307E\3057\3044')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104080160369308500)
,p_name=>'DETAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30A3\30C6\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104136866285308547)
,p_name=>'DETAILS_FOR_ALT_TAG'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A73\7D30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104080297760308500)
,p_name=>'DETAIL_2'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30A3\30C6\30FC\30EB2')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103578485476308072)
,p_name=>'DEVELOPER'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\767A\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104142268262308552)
,p_name=>'DEVELOPERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\767A\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104026923703308456)
,p_name=>'DEVELOPER_ACTIVITY_SUMMARY'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\767A\8005\30A2\30AF\30C6\30A3\30D3\30C6\30A3\30FB\30B5\30DE\30EA\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104050702137308476)
,p_name=>'DEVELOPER_SUMMARY'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\767A\8005\30B5\30DE\30EA\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103535298422308041)
,p_name=>'DEVELOPER_TOOLBAR_APPLICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104044057196308470)
,p_name=>'DEVELOPER_TOOLBAR_APP_CUSTOMIZATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30AB\30B9\30BF\30DE\30A4\30BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104200160069308610)
,p_name=>'DEVELOPER_TOOLBAR_CLEAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30EA\30A2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104200022542308609)
,p_name=>'DEVELOPER_TOOLBAR_COPY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30D4\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104548499687308874)
,p_name=>'DEVELOPER_TOOLBAR_CUSTOMIZE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30B9\30BF\30DE\30A4\30BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104226393618308629)
,p_name=>'DEVELOPER_TOOLBAR_DEBUG_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D0\30C3\30B0(%0)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104225857055308628)
,p_name=>'DEVELOPER_TOOLBAR_DEBUG_LEVEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\30FB\30C7\30D0\30C3\30B0\30FB\30EC\30D9\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104226057795308629)
,p_name=>'DEVELOPER_TOOLBAR_DEBUG_LEVEL4'
,p_message_language=>'ja'
,p_message_text=>unistr('\60C5\5831(\30C7\30D5\30A9\30EB\30C8)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104226127170308629)
,p_name=>'DEVELOPER_TOOLBAR_DEBUG_LEVEL6'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30C8\30EC\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104226256495308629)
,p_name=>'DEVELOPER_TOOLBAR_DEBUG_LEVEL9'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B8C\5168\30C8\30EC\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103535373357308041)
,p_name=>'DEVELOPER_TOOLBAR_EDIT_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104189279469308601)
,p_name=>'DEVELOPER_TOOLBAR_ERRORS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\304C\30ED\30FC\30C9\3055\308C\305F\5F8C\30011\3064\4EE5\4E0A\306E\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002\30D6\30E9\30A6\30B6\306EJavaScript\30B3\30F3\30BD\30FC\30EB\3092\958B\3044\3066\3001\30A8\30E9\30FC\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104189475974308601)
,p_name=>'DEVELOPER_TOOLBAR_ERRORS_BTN'
,p_message_language=>'ja'
,p_message_text=>unistr('JavaScript\30A8\30E9\30FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104548515404308874)
,p_name=>'DEVELOPER_TOOLBAR_LOGO_EDITOR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30B4\306E\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104263083293308655)
,p_name=>'DEVELOPER_TOOLBAR_NO_BUILDER'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6A5F\80FD\3067\306F\3001Application Express\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30D3\30EB\30C0\30FC\30FB\30A6\30A3\30F3\30C9\30A6\3092\958B\304F\5FC5\8981\304C\3042\308A\307E\3059\3002\3053\306E\30A6\30A3\30F3\30C9\30A6\3067\30D3\30EB\30C0\30FC\3092\958B\304D\307E\3059\304B\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104259155618308652)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\767A\8005\30C4\30FC\30EB\30D0\30FC\30FB\30AA\30D7\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104260878128308654)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_AUTO_HIDE'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\52D5\975E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104261060256308654)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_DISPLAY'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104260931001308654)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_ICONS_ONLY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3\306E\307F\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104261258132308654)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_POS_BOTTOM'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104261195548308654)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_POS_LEFT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5DE6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104261306339308654)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_POS_RIGHT'
,p_message_language=>'ja'
,p_message_text=>unistr('\53F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104262689009308655)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_POS_TOP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C8\30C3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104195162765308606)
,p_name=>'DEVELOPER_TOOLBAR_PAGE_INFO'
,p_message_language=>'ja'
,p_message_text=>unistr('\60C5\5831')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104195338705308606)
,p_name=>'DEVELOPER_TOOLBAR_PERF_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30D1\30D5\30A9\30FC\30DE\30F3\30B9\30FB\30BF\30A4\30DF\30F3\30B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104259255075308652)
,p_name=>'DEVELOPER_TOOLBAR_QUICK_EDIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30A4\30C3\30AF\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104195271678308606)
,p_name=>'DEVELOPER_TOOLBAR_SHOW_PERF'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30BF\30A4\30DF\30F3\30B0\3092\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104760163992309050)
,p_name=>'DEVELOPER_TOOLBAR_THEME_ROLLER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\30FB\30ED\30FC\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104260792251308654)
,p_name=>'DEVELOPER_TOOLBAR_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\767A\8005\30C4\30FC\30EB\30D0\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104001682030308437)
,p_name=>'DEVELOPMENT_TASK'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\767A\30BF\30B9\30AF')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104169994080308583)
,p_name=>'DIAL_CHART_ALERT_VALUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30E9\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104169876533308583)
,p_name=>'DIAL_CHART_HIGH_VALUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\9AD8\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104169729630308583)
,p_name=>'DIAL_CHART_LOW_VALUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F4E\3044\5024')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103519037775308029)
,p_name=>'DICTIONARY.APEX_APPL_PAGE_ITEM_GROUPS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\30FB\30B0\30EB\30FC\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103601406917308089)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103603810731308090)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_AUTH'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\30B9\30AD\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103603965376308091)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_AUTHORIZATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\53EF\30B9\30AD\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103603055148308090)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_BC_ENTRIES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C8\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103602974813308090)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_BREADCRUMBS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104789530918309080)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_BUILD_OPTIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D3\30EB\30C9\30FB\30AA\30D7\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103602661173308090)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_COMPUTATIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\8A08\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103602842690308090)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_ITEMS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103603166688308090)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_LISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103603240465308090)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_LIST_ENTRIES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C8\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103603313948308090)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_LOVS'
,p_message_language=>'ja'
,p_message_text=>'LOV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103552618304308054)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_LOV_COLS'
,p_message_language=>'ja'
,p_message_text=>unistr('LOV\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103603473399308090)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_LOV_ENTRIES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C8\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103603585961308090)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_NAV_BAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30D0\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103601542412308089)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103602515386308090)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_BRANCHES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30E9\30F3\30C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103601939870308089)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_BUTTONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103976339338308417)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_CHARTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103976558495308418)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_CHART_A'
,p_message_language=>'ja'
,p_message_text=>unistr('\8EF8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103976420918308418)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_CHART_S'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30EA\30FC\30BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103602221108308089)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_COMP'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A08\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103643152844308122)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_DA'
,p_message_language=>'ja'
,p_message_text=>unistr('\52D5\7684\30A2\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103643250564308123)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_DA_ACTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\52D5\7684\30A2\30AF\30B7\30E7\30F3 - \30A2\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103602026177308089)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_IR'
,p_message_language=>'ja'
,p_message_text=>unistr('IR\30EA\30FC\30B8\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103602186456308089)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_IR_COL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103601740472308089)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_ITEMS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103602424167308089)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_PROC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30BB\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103601663135308089)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_REGIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104542660970308869)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_REG_COLS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103601888545308089)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_RPT_COLS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104724639060309020)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_TREES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C4\30EA\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103602310533308089)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_VAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103603627773308090)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PARENT_TABS'
,p_message_language=>'ja'
,p_message_text=>unistr('\89AA\30BF\30D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103602710381308090)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PROCESSES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30D7\30ED\30BB\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104750360509309042)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_RPT_LAYOUTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\30FB\30EC\30A4\30A2\30A6\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104750699868309043)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_RPT_QRY_STMTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\554F\5408\305BSQL\6587')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104750254886309042)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_RPT_QUERIES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104699304697308999)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SETTINGS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103604010186308091)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SHORTCUTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30E7\30FC\30C8\30AB\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103599578193308087)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_STATIC_FILES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30D5\30A1\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103605544965308092)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SUBSTITUTIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\7F6E\63DB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104789201369309080)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SUPP_OBJECTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30DD\30FC\30C8\3059\308B\30AA\30D6\30B8\30A7\30AF\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104789342276309080)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SUPP_OBJ_BOPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30DD\30FC\30C8\3059\308B\30AA\30D6\30B8\30A7\30AF\30C8\306E\30D3\30EB\30C9\30FB\30AA\30D7\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103605387571308092)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SUPP_OBJ_CHCK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30DD\30FC\30C8\3059\308B\30AA\30D6\30B8\30A7\30AF\30C8\306E\691C\8A3C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103605493799308092)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SUPP_OBJ_SCR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30DD\30FC\30C8\3059\308B\30AA\30D6\30B8\30A7\30AF\30C8\30FB\30B9\30AF\30EA\30D7\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103603767984308090)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TABS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103604429056308091)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_BC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103604587880308091)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_BUTTON'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103604681051308091)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_CALENDAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30EC\30F3\30C0\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103667957311308141)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_GRID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30EA\30C3\30C9\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103604773390308091)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103604855730308091)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_LIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103604994670308091)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103605025928308091)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_POPUPLOV'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DD\30C3\30D7\30A2\30C3\30D7LOV\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103605160818308091)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_REGION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103605274761308092)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_REPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103604303903308091)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_THEMES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103592965281308082)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_THEME_FILES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\30FB\30D5\30A1\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103540717559308045)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_THEME_STYLES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104032147274308460)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TRANSLATIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8\30FB\30E1\30C3\30BB\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103586760403308078)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TRANS_DYNAMIC'
,p_message_language=>'ja'
,p_message_text=>unistr('\52D5\7684\7FFB\8A33')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103586837118308078)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TRANS_REPOS'
,p_message_language=>'ja'
,p_message_text=>unistr('\7FFB\8A33\53EF\80FD\306A\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103604289006308091)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TREES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C4\30EA\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103604179631308091)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_WEB_SERVICES'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B5\30FC\30D3\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104716289066309013)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_ACL_ROLES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30BB\30B9\5236\5FA1\30ED\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104716301168309014)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_ACL_USERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30BB\30B9\5236\5FA1\30E6\30FC\30B6\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104071343896308493)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_ACL_USER_ROLES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30BB\30B9\5236\5FA1\30E6\30FC\30B6\30FC\30FB\30ED\30FC\30EB\5272\5F53\3066')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103529898040308037)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_AUTOMATIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\52D5\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103530064061308037)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_AUTOMATION_ACTIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\52D5\5316 - \30A2\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104752199793309044)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_CONCATENATED_FILES'
,p_message_language=>'ja'
,p_message_text=>unistr('\9023\7D50\3055\308C\305F\30D5\30A1\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103557362811308057)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_DATA_LOADS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30ED\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103983836839308423)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_DATA_PROFILES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\89E3\6790\30D7\30ED\30D5\30A1\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103983929486308423)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_DATA_PROFILE_COLS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\89E3\6790\30D7\30ED\30D5\30A1\30A4\30EB\306E\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104767517107309064)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_DEVELOPER_COMMENTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\767A\8005\306E\30B3\30E1\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104731203945309027)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_EMAIL_TEMPLATES'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104289306079308674)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_LOAD_TABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30ED\30FC\30C9\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104283641206308670)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_LOAD_TABLES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30ED\30FC\30C9\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104283776565308670)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_LOAD_TABLE_LOOKUPS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30ED\30FC\30C9\8868\30EB\30C3\30AF\30A2\30C3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104283800689308670)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_LOAD_TABLE_RULES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30ED\30FC\30C9\8868\30C8\30E9\30F3\30B9\30D5\30A9\30FC\30E1\30FC\30B7\30E7\30F3\30FB\30EB\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103547281079308050)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_CALENDARS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30EC\30F3\30C0\30FB\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103546215338308049)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_CARDS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103546399503308049)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_CARD_ACTIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30FC\30C9\30FB\30A2\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104260274228308653)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_IGS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5BFE\8A71\30B0\30EA\30C3\30C9\30FB\30EA\30FC\30B8\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104260393600308653)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_IG_COLUMNS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104260419719308653)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_IG_COL_GROUPS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\30B0\30EB\30FC\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103521292369308031)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_MAPS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30C3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103521384083308031)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_MAP_LAYERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30C3\30D7\30FB\30EC\30A4\30E4\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103619197736308102)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGINS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30E9\30B0\30A4\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103619259405308102)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_ATTRIBUTES'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104030685225308459)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_ATTR_VALUES'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103674170201308146)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_EVENTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30D9\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103621319454308103)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_FILES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104080462417308500)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_ITEM_FILTERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30EB\30BF\6F14\7B97\5B50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104789437191309080)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_SETTINGS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30DD\30FC\30CD\30F3\30C8\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104730123266309026)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_STD_ATTRS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30E9\30B0\30A4\30F3\6A19\6E96\5C5E\6027\306E\30E1\30BF\30C7\30FC\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103983725373308423)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_REMOTE_SQL'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\5BFE\5FDCSQL\30B5\30FC\30D0\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104542592858308869)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TEMPLATE_OPTIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8\30FB\30AA\30D7\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104789187127309080)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TEMPLATE_OPT_GROUPS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8\30FB\30AA\30D7\30B7\30E7\30F3\30FB\30B0\30EB\30FC\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104705444480309004)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TEMPLATE_OPT_GRP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8\30FB\30AA\30D7\30B7\30E7\30F3\30FB\30B0\30EB\30FC\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104758666086309049)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TEMP_PAGE_DP'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104758790238309049)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TEMP_REGION_DP'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103672595053308145)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_THEME_DISPLAY_POINTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\8868\793A\30DD\30A4\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103599401438308087)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_USER_INTERFACES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103984447405308424)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_COMP_PARAMS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30DD\30FC\30CD\30F3\30C8REST\30BD\30FC\30B9\30FB\30D1\30E9\30E1\30FC\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103984109939308423)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_MODULES'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\30C7\30FC\30BF\30FB\30BD\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103984220766308423)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_OPERATIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\30BD\30FC\30B9\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103984332057308423)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_PARAMETERS'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\30BD\30FC\30B9\30FB\30D1\30E9\30E1\30FC\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103984089667308423)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_SERVERS'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\30BD\30FC\30B9\30FB\30EA\30E2\30FC\30C8\30FB\30B5\30FC\30D0\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103530389117308037)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_SYNC_STEPS'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\540C\671F\5316\30B9\30C6\30C3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103530262023308037)
,p_name=>'DICTIONARY_VIEW.APEX_AUTOMATION_LOG'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\52D5\5316\30ED\30B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103530419596308037)
,p_name=>'DICTIONARY_VIEW.APEX_AUTOMATION_MSG_LOG'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\52D5\5316\30E1\30C3\30BB\30FC\30B8\30FB\30ED\30B0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104732881974309029)
,p_name=>'DISABLED_NEXT_BUTTON'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\6B21\3078\300D\30DC\30BF\30F3\3092\7121\52B9\306B\3059\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104732744548309029)
,p_name=>'DISABLED_PREVIOUS_BUTTON'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\623B\308B\300D\30DC\30BF\30F3\3092\7121\52B9\306B\3059\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104133455360308544)
,p_name=>'DISABLE_TRIGGER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C8\30EA\30AC\30FC%0\306E\7121\52B9\5316')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103738853238308199)
,p_name=>'DISPLAY_CONDITION'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103739090740308199)
,p_name=>'DISPLAY_CONDITION_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\6761\4EF6\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104179180369308592)
,p_name=>'DISPLAY_ORDER_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\9806\5E8F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103625380189308106)
,p_name=>'DISPLAY_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104788892425309080)
,p_name=>'DISPLAY_VALUE.N'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\5024: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104728146144309023)
,p_name=>'DISTINCT_PAGES'
,p_message_language=>'ja'
,p_message_text=>unistr('\500B\5225\306E\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104728238818309023)
,p_name=>'DISTINCT_USERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\500B\5225\30E6\30FC\30B6\30FC')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103552387876308053)
,p_name=>'DML_FORM'
,p_message_language=>'ja'
,p_message_text=>unistr('DML\30D5\30A9\30FC\30E0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103846592310308283)
,p_name=>'DO NOT UPDATE PAGE ITEMS'
,p_message_language=>'ja'
,p_message_text=>'DO_NOT_UPDATE_PAGE_ITEMS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104022767466308453)
,p_name=>'DOC_IMPACT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C9\30AD\30E5\30E1\30F3\30C8\306E\5F71\97FF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104023982963308454)
,p_name=>'DOC_STATUS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C9\30AD\30E5\30E1\30F3\30C8\30FB\30B9\30C6\30FC\30BF\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104024172617308454)
,p_name=>'DOC_WRITER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C9\30AD\30E5\30E1\30F3\30C8\30FB\30E9\30A4\30BF\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103911732417308336)
,p_name=>'DOWN'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0B\3078')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104031969389308460)
,p_name=>'DOWNLOAD_LINK_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30F3\30AF\30FB\30C6\30AD\30B9\30C8\306E\30C0\30A6\30F3\30ED\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103846292190308282)
,p_name=>'DO_NOT_UPDATE_APPLICATION_ITEMS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\66F4\65B0\3057\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103846392480308283)
,p_name=>'DO_NOT_UPDATE_DATA_ENTRY_ITEMS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30A8\30F3\30C8\30EA\30FB\30A2\30A4\30C6\30E0\3092\66F4\65B0\3057\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103846473010308283)
,p_name=>'DO_NOT_UPDATE_DISPLAY_ONLY_ITEMS'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\5C02\7528\30A2\30A4\30C6\30E0\3092\66F4\65B0\3057\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103846173933308282)
,p_name=>'DO_NOT_UPDATE_PAGES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\3092\66F4\65B0\3057\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103846986266308283)
,p_name=>'DO_NOT_UPDATE_PAGE_ITEMS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3092\66F4\65B0\3057\306A\3044')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103708923752308174)
,p_name=>'DRAG_AND_DROP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C9\30E9\30C3\30B0\30FB\30A2\30F3\30C9\30FB\30C9\30ED\30C3\30D7')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103616732303308100)
,p_name=>'DRILLDOWN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C9\30EA\30EB\30C0\30A6\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103616614603308100)
,p_name=>'DRILLUP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C9\30EA\30EB\30A2\30C3\30D7')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103754224581308211)
,p_name=>'DRIVEN'
,p_message_language=>'ja'
,p_message_text=>unistr('\99C6\52D5')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104133205755308544)
,p_name=>'DROP TRIGGER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C8\30EA\30AC\30FC%0\306E\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104132333225308543)
,p_name=>'DROP_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217%0\306E\524A\9664')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104279725898308667)
,p_name=>'DS_ACCESS_METHOD'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30BB\30B9\30FB\30E1\30BD\30C3\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104279508415308667)
,p_name=>'DS_BIND_VARIABLE_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D0\30A4\30F3\30C9\5909\6570\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104279986040308667)
,p_name=>'DS_HANDLER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CF\30F3\30C9\30E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104280386907308668)
,p_name=>'DS_ITEMS_PER_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\5F53\305F\308A\306E\30A2\30A4\30C6\30E0\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104280164122308667)
,p_name=>'DS_MIME_TYPES_ALLOWED'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F7F\7528\53EF\80FD\306AMIME\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104280215554308668)
,p_name=>'DS_ORIGINS_ALLOWED'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F7F\7528\53EF\80FD\306A\8D77\70B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104279802281308667)
,p_name=>'DS_PARAMETER_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30E9\30E1\30FC\30BF\30FB\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104280409210308668)
,p_name=>'DS_SECURITY_CONSTRAINT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30AD\30E5\30EA\30C6\30A3\5236\7D04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104279610511308667)
,p_name=>'DS_SOURCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BD\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104280005551308667)
,p_name=>'DS_SOURCE_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BD\30FC\30B9\30FB\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104280500425308668)
,p_name=>'DS_URI_PREFIX'
,p_message_language=>'ja'
,p_message_text=>unistr('URI\63A5\982D\8F9E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104279257904308667)
,p_name=>'DS_URI_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('URI\30C6\30F3\30D7\30EC\30FC\30C8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104750719115309043)
,p_name=>'DUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\671F\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104023761867308454)
,p_name=>'DUE_DATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\671F\65E5')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104004228384308438)
,p_name=>'DUPLICATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\91CD\8907')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104728855346309024)
,p_name=>'DUPLICATE_USER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8\5185\3067\30E6\30FC\30B6\30FC\304C\91CD\8907\3057\3066\3044\307E\3059')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103541128667308045)
,p_name=>'DYNAMIC ACTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\52D5\7684\30A2\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103541008126308045)
,p_name=>'DYNAMIC ACTIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\52D5\7684\30A2\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103551216182308053)
,p_name=>'DYNAMIC_FORM'
,p_message_language=>'ja'
,p_message_text=>unistr('\52D5\7684\30D5\30A9\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103657135531308133)
,p_name=>'DYNAMIC_HTML'
,p_message_language=>'ja'
,p_message_text=>unistr('\52D5\7684HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103707868453308174)
,p_name=>'DYNAMIC_QUERY'
,p_message_language=>'ja'
,p_message_text=>unistr('\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103534217574308040)
,p_name=>'DYNAMIC_REFERENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\52D5\7684\53C2\7167')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103803621049308250)
,p_name=>'EASY_REPORT.INVALID_CONDITION'
,p_message_language=>'ja'
,p_message_text=>unistr('\8FFD\52A0\4E2D\306E\6761\4EF6\306B\3088\3063\3066\554F\5408\305B\304C\7121\52B9\306B\306A\3063\3066\3044\307E\3059\3002')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103545714162308048)
,p_name=>'EDIT PAGE GROUP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30B0\30EB\30FC\30D7\306E\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104064396204308487)
,p_name=>'EDITOR_EXIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\300COK\300D\3092\9078\629E\3059\308B\3068\3001\672A\4FDD\5B58\306E\5909\66F4\306F\5931\308F\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103577717292308071)
,p_name=>'EDIT_ALL'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103804849500308251)
,p_name=>'EDIT_ALL_PAGE_DEFINITION_ATTRIBUTES'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\306E\30DA\30FC\30B8\5B9A\7FA9\5C5E\6027\306E\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104059245040308483)
,p_name=>'EDIT_ALL_REGION'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30EA\30FC\30B8\30E7\30F3\5185\306E\3059\3079\3066\306E\30A2\30A4\30C6\30E0\306E\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103989974776308428)
,p_name=>'EDIT_APPLICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104078980759308499)
,p_name=>'EDIT_ATTRIBUTE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C5E\6027\306E\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104673948483308978)
,p_name=>'EDIT_AUTHENTICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\306E\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104068752086308490)
,p_name=>'EDIT_COMPONENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306E\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104079069693308499)
,p_name=>'EDIT_COMPONENT_DEF'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30DD\30FC\30CD\30F3\30C8\5B9A\7FA9\306E\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104170446601308584)
,p_name=>'EDIT_LINK_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306E\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104078826460308499)
,p_name=>'EDIT_LIST_DEV'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8\5B9A\7FA9\306E\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104742701030309037)
,p_name=>'EDIT_LOCK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30C3\30AF\306E\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103950491386308398)
,p_name=>'EDIT_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306E\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103806952620308252)
,p_name=>'EDIT_PAGE_ATTRIBUTES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\5C5E\6027\306E\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104337863931308710)
,p_name=>'EDIT_PROFILE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30D5\30A1\30A4\30EB\306E\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104355266558308723)
,p_name=>'EDIT_PROFILE.USER_NO_PRIV_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC0%\306B\306F\5225\306E\30E6\30FC\30B6\30FC\306E\60C5\5831\3092\66F4\65B0\3059\308B\6A29\9650\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104068562149308490)
,p_name=>'EDIT_REGION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\306E\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104143039664308552)
,p_name=>'EDIT_REPORTING_TIMEFRAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\6642\9593\67A0\306E\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104068689121308490)
,p_name=>'EDIT_REPORT_COLS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\5217\306E\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104332077042308706)
,p_name=>'EDIT_REPORT_DIALOG_CLOSED_DA'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\306E\7DE8\96C6 - \30C0\30A4\30A2\30ED\30B0\306E\30AF\30ED\30FC\30BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104058538819308482)
,p_name=>'EDIT_SYSTEM_MESSAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30B9\30C6\30E0\30FB\30E1\30C3\30BB\30FC\30B8\306E\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104293936456308678)
,p_name=>'EDIT_TAB'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30D6\306E\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104080315566308500)
,p_name=>'EDIT_THIS_ATTRIBUTE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\5C5E\6027\306E\7DE8\96C6')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103932716534308384)
,p_name=>'ELAPSED_TIME'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D4C\904E\6642\9593')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104011320521308444)
,p_name=>'EMAIL.TEMPLATE.FOOTER_EXAMPLE'
,p_message_language=>'ja'
,p_message_text=>unistr('<a href="#MY_APPLICATION_LINK#">\300C\30DE\30A4\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\300D\306B\30A2\30AF\30BB\30B9\3057\3001\96FB\5B50\30E1\30FC\30EB\30FB\30D7\30EA\30D5\30A1\30EC\30F3\30B9\3092\7BA1\7406\3057\307E\3059</a>\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104018287052308449)
,p_name=>'EMAIL.TEMPLATE.HEADER_EXAMPLE'
,p_message_language=>'ja'
,p_message_text=>unistr('<b style="font-size: 24px;">\30DE\30A4\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3</b>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104132711800308544)
,p_name=>'EMAIL.TEMPLATE.HTML_BODY_EXAMPLE.EV'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<strong>\3088\3046\3053\305D\3001#INVITEE#\3055\3093\3001</strong><br>'),
'<br>',
unistr('\3053\308C\306F\3001\62DB\5F85\3055\308C\3066\3044\308B\4ECA\5F8C\306E\30A4\30D9\30F3\30C8\306E\30EA\30DE\30A4\30F3\30C0\3067\3059\3002\6B21\306E\30A4\30D9\30F3\30C8\8A73\7D30\3092\53C2\7167\3057\3066\304F\3060\3055\3044:<br>'),
'<br>',
'<table width="100%">',
'  <tr>',
unistr('    <th align="left">\958B\50AC\8005</th>'),
'    <td>#ORGANIZER#</td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left">\30A4\30D9\30F3\30C8\65E5\4ED8</th>'),
'    <td>#EVENT_DATE#</td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left">\958B\59CB\6642\9593</th>'),
'    <td>#START_TIME#</td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left">\671F\9593</th>'),
'    <td>#DURATION#</td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left" valign="top">\5834\6240</th>'),
'    <td>#LOCATION#</td>',
'  </tr>',
'  <tr>',
'    <th align="left">URL</th>',
'    <td><a href="#URL_LINK#">#URL_NAME#</a></td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left" valign="top">\30CE\30FC\30C8</th>'),
'    <td>#NOTES#</td>',
'  </tr>',
'</table>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104011247417308444)
,p_name=>'EMAIL.TEMPLATE.HTML_BODY_EXAMPLE.OD'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<strong>\3088\3046\3053\305D\3001#CUSTOMER_NAME#\3055\3093</strong>\3001<br>'),
'<br>',
unistr('\30AA\30FC\30C0\30FC\3042\308A\304C\3068\3046\3054\3056\3044\307E\3059\3002<br>'),
'<br>',
unistr('<strong>\30AA\30FC\30C0\30FC\8A73\7D30</strong><br>'),
'<br>',
'<table width="100%">',
'  <tr>',
unistr('    <th align="left">\30AA\30FC\30C0\30FC\65E5</th>'),
'    <td>#ORDER_DATE#</td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left">\30AA\30FC\30C0\30FC\756A\53F7</th>'),
'    <td>#ORDER_NUMBER#</td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left">\51FA\8377\5148</th>'),
'    <td>#SHIP_TO#</td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left" valign="top">\51FA\8377\5148\4F4F\6240</th>'),
'    <td>',
'      #SHIPPING_ADDRESS_LINE_1#<br>',
'      #SHIPPING_ADDRESS_LINE_2#',
'    </td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left" valign="top">\30AA\30FC\30C0\30FC\30FB\30A2\30A4\30C6\30E0</th>'),
'    <td>#ITEMS_ORDERED#</td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left">\30AA\30FC\30C0\30FC\5408\8A08</th>'),
'    <td>#ORDER_TOTAL#</td>',
'  </tr>',
'</table>',
'<br>',
'<br>',
unistr('\30AA\30FC\30C0\30FC\3092\5909\66F4\3057\307E\3059\304B\3002<a href="#ORDER_URL#">\304A\5BA2\69D8\306E\30AA\30FC\30C0\30FC#ORDER_NUMBER#\306F\3053\3053\3067\7BA1\7406\3057\3066\3044\307E\3059\3002</a>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104332314112308706)
,p_name=>'EMAIL.TEMPLATE.HTML_BODY_EXAMPLE.SO'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\3088\3046\3053\305D\3001#SERVICE_USER#\3055\3093\3001<br>'),
'<br>',
unistr('\4ECA\5F8C\3001\30B5\30FC\30D3\30B9#SERVICE_NAME#\306E\505C\6B62\304C\30B9\30B1\30B8\30E5\30FC\30EB\3055\308C\3066\3044\307E\3059\3002<br>'),
unistr('\505C\6B62\306F#OUTAGE_START#\306B\958B\59CB\3059\308B\3088\3046\30B9\30B1\30B8\30E5\30FC\30EB\3055\308C\3066\304A\308A\3001#OUTAGE_DURATION# #OUTAGE_TIMEFRAME#\306E\9593\306F\3054\5229\7528\3044\305F\3060\3051\306A\304F\306A\308B\4E88\5B9A\3067\3059\3002<br>'),
'<br>',
unistr('\3053\306E\30B9\30B1\30B8\30E5\30FC\30EB\3055\308C\305F\505C\6B62\4E2D\306B\6B21\306E\4F5C\696D\304C\5B9F\884C\3055\308C\307E\3059:<br>'),
'#OUTAGE_REASON#<br>',
'<br>',
'<br>',
unistr('\3053\306E\505C\6B62\306B\95A2\9023\3059\308B\554F\984C\304C\3042\308B\5834\5408\306F\3001#OUTAGE_CONTACT#\306B\3054\9023\7D61\304F\3060\3055\3044\3002<br>'),
'<br>',
unistr('\3054\5354\529B\3042\308A\304C\3068\3046\3054\3056\3044\307E\3059\3002<br>'),
'#SERVICE_TEAM#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104331711212308706)
,p_name=>'EMAIL.TEMPLATE.SUBJECT_EXAMPLE.EV'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30D9\30F3\30C8\30FB\30EA\30DE\30A4\30F3\30C0: #EVENT_NAME#')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104331891460308706)
,p_name=>'EMAIL.TEMPLATE.SUBJECT_EXAMPLE.OD'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30FC\30C0\30FC(#ORDER_NUMBER#)\3092\78BA\8A8D\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104132950635308544)
,p_name=>'EMAIL.TEMPLATE.TEXT_BODY_EXAMPLE.EV'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\3088\3046\3053\305D\3001#INVITEE#\3055\3093'),
'',
unistr('\3053\306E\96FB\5B50\30E1\30FC\30EB\306F\3001\95A2\9023\4ED8\3051\3089\308C\3066\3044\308B\4ECA\5F8C\306E\30A4\30D9\30F3\30C8\306E\30EA\30DE\30A4\30F3\30C0\3067\3059\3002'),
'',
unistr('\30A4\30D9\30F3\30C8\65E5\4ED8: #EVENT_DATE#'),
unistr('\958B\59CB\6642\9593: #START_TIME#'),
unistr('\671F\9593:   #DURATION#'),
unistr('\958B\50AC\8005:  #ORGANIZER#'),
unistr('\5834\6240:   #LOCATION#'),
'URL:        #URL_NAME# (#URL_LINK#)',
unistr('\30CE\30FC\30C8:      #NOTES#'),
'',
unistr('\305D\306E\4ED6\306E\30A4\30D9\30F3\30C8\8A73\7D30\306F\3001\3053\3061\3089\3092\53C2\7167\3057\3066\304F\3060\3055\3044: #EVENT_LINK#')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104132898315308544)
,p_name=>'EMAIL.TEMPLATE.TEXT_BODY_EXAMPLE.OD'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\3088\3046\3053\305D\3001#CUSTOMER_NAME#\3055\3093\3001'),
'',
unistr('\30AA\30FC\30C0\30FC\3042\308A\304C\3068\3046\3054\3056\3044\307E\3059\3002'),
'',
unistr('\30AA\30FC\30C0\30FC\8A73\7D30'),
'--------------------------------------------------------------------------------',
unistr('  \30AA\30FC\30C0\30FC\65E5:       #ORDER_DATE#'),
unistr('  \30AA\30FC\30C0\30FC\756A\53F7:     #ORDER_NUMBER#'),
unistr('  \51FA\8377\5148:          #SHIP_TO#'),
unistr('  \51FA\8377\5148\4F4F\6240: #SHIPPING_ADDRESS_LINE_1#'),
'                    #SHIPPING_ADDRESS_LINE_2#',
unistr('  \30AA\30FC\30C0\30FC\30FB\30A2\30A4\30C6\30E0:    #ITEMS_ORDERED#'),
unistr('  \30AA\30FC\30C0\30FC\5408\8A08:      #ORDER_TOTAL#'),
'--------------------------------------------------------------------------------',
'',
unistr('\30AA\30FC\30C0\30FC\3092\5909\66F4\3057\307E\3059\304B\3002\304A\5BA2\69D8\306E\30AA\30FC\30C0\30FC#ORDER_NUMBER#\306F\3053\3053\3067\7BA1\7406\3057\3066\3044\307E\3059: #ORDER_URL#')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104332236288308706)
,p_name=>'EMAIL.TEMPLATE.TEXT_BODY_EXAMPLE.SO'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\3088\3046\3053\305D\3001#SERVICE_USER#\3055\3093\3001'),
'',
unistr('\4ECA\5F8C\3001\30B5\30FC\30D3\30B9#SERVICE_NAME#\306E\505C\6B62\304C\30B9\30B1\30B8\30E5\30FC\30EB\3055\308C\3066\3044\307E\3059\3002'),
unistr('\505C\6B62\306F#OUTAGE_START#\306B\958B\59CB\3059\308B\3088\3046\30B9\30B1\30B8\30E5\30FC\30EB\3055\308C\3066\304A\308A\3001#OUTAGE_DURATION# #OUTAGE_TIMEFRAME#\306E\9593\306F\3054\5229\7528\3044\305F\3060\3051\306A\304F\306A\308B\4E88\5B9A\3067\3059\3002'),
'',
unistr('\3053\306E\30B9\30B1\30B8\30E5\30FC\30EB\3055\308C\305F\505C\6B62\4E2D\306B\6B21\306E\4F5C\696D\304C\5B9F\884C\3055\308C\307E\3059:'),
'#OUTAGE_REASON#',
'',
unistr('\3053\306E\505C\6B62\306B\95A2\9023\3059\308B\554F\984C\304C\3042\308B\5834\5408\306F\3001#OUTAGE_CONTACT#\306B\3054\9023\7D61\304F\3060\3055\3044\3002'),
'',
unistr('\3054\5354\529B\3042\308A\304C\3068\3046\3054\3056\3044\307E\3059\3002'),
'#SERVICE_TEAM#',
''))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104062548015308485)
,p_name=>'ENABLE_DEBUGGING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D0\30C3\30B0\306E\6709\52B9\5316 (\306F\3044/\3044\3044\3048)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104133339575308544)
,p_name=>'ENABLE_TRIGGER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C8\30EA\30AC\30FC%0\306E\6709\52B9\5316')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103579959571308073)
,p_name=>'ENCRYPTION_INPUT_TOO_LONG'
,p_message_language=>'ja'
,p_message_text=>unistr('\6697\53F7\5316\3059\308B\5024\306E\9577\3055\306F\30014000\30D0\30A4\30C8\3092\8D85\3048\306A\3044\3088\3046\306B\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103578524430308072)
,p_name=>'END_USER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104001385668308436)
,p_name=>'ENHANCEMENT_REQUEST'
,p_message_language=>'ja'
,p_message_text=>unistr('\62E1\5F35\30EA\30AF\30A8\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104355955227308723)
,p_name=>'ENHANCEMENT_REQUEST_DASH'
,p_message_language=>'ja'
,p_message_text=>unistr('\62E1\5F35\30EA\30AF\30A8\30B9\30C8: %1/%0\304C\30AF\30ED\30FC\30BA')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104003770503308438)
,p_name=>'ENTERED'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103544989989308048)
,p_name=>'ENTER_WEBSHEETS_CREDENTIALS'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B7\30FC\30C8\306E\8CC7\683C\8A3C\660E\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103991572510308429)
,p_name=>'ENTRY LINK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C8\30EA\30FB\30EA\30F3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103991469875308429)
,p_name=>'ENTRY TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C8\30EA\30FB\30C6\30AD\30B9\30C8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104046802437308472)
,p_name=>'ERROR PAGE TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC\30FB\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103909952369308335)
,p_name=>'ERRORPAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC\30FB\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104059598258308483)
,p_name=>'ERRORS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103992713345308430)
,p_name=>'ERROR_ICON'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC\30FB\30A2\30A4\30B3\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104749706762309042)
,p_name=>'ERROR_MESSAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103984949757308424)
,p_name=>'ESCAPED_COL_TOO_LARGE'
,p_message_language=>'ja'
,p_message_text=>unistr('<br><strong>\30A8\30B9\30B1\30FC\30D7\3055\308C\305F\30C7\30FC\30BF\306F\8A31\5BB9\5236\9650\3092\8D85\3048\3066\3044\308B\305F\3081\300132K\306B\5207\308A\6368\3066\3089\308C\307E\3059</strong>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103753412267308210)
,p_name=>'ESCAPE_SC'
,p_message_language=>'ja'
,p_message_text=>unistr('\7279\6B8A\6587\5B57\3092\30A8\30B9\30B1\30FC\30D7')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104025144202308455)
,p_name=>'ESTIMATED_EFFORT_IN_HOURS'
,p_message_language=>'ja'
,p_message_text=>unistr('\63A8\5B9A\4F5C\696D(\6642\9593)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104279452611308667)
,p_name=>'ETAG_QUERY'
,p_message_language=>'ja'
,p_message_text=>unistr('ETAG\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104279376076308667)
,p_name=>'ETAG_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('ETAG\30BF\30A4\30D7')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104001831533308437)
,p_name=>'EVENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30D9\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104336424517308709)
,p_name=>'EVENT.APEX.APEXAFTERREFRESH'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30D5\30EC\30C3\30B7\30E5\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104336740313308709)
,p_name=>'EVENT.APEX.APEXBEFOREPAGESUBMIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306E\9001\4FE1\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104336367794308709)
,p_name=>'EVENT.APEX.APEXBEFOREREFRESH'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30D5\30EC\30C3\30B7\30E5\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104338999863308711)
,p_name=>'EVENT.BROWSER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30E9\30A6\30B6\30FB\30A4\30D9\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103800061260308247)
,p_name=>'EVENT.BROWSER.APEXDOUBLETAP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C0\30D6\30EB\30BF\30C3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103800220287308247)
,p_name=>'EVENT.BROWSER.APEXPAN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103800188405308247)
,p_name=>'EVENT.BROWSER.APEXPRESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\62BC\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103800304634308247)
,p_name=>'EVENT.BROWSER.APEXSWIPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30EF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103799909127308247)
,p_name=>'EVENT.BROWSER.APEXTAP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30C3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104335884554308709)
,p_name=>'EVENT.BROWSER.CHANGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5909\66F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104335168864308708)
,p_name=>'EVENT.BROWSER.CLICK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30EA\30C3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104335238711308708)
,p_name=>'EVENT.BROWSER.DBLCLICK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C0\30D6\30EB\30AF\30EA\30C3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104334624924308708)
,p_name=>'EVENT.BROWSER.FOCUSIN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30FC\30AB\30B9\3092\53D6\5F97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104334576387308708)
,p_name=>'EVENT.BROWSER.FOCUSOUT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30FC\30AB\30B9\3092\5931\3046')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104336070601308709)
,p_name=>'EVENT.BROWSER.KEYDOWN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AD\30FC\30FB\30C0\30A6\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104336114354308709)
,p_name=>'EVENT.BROWSER.KEYPRESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AD\30FC\30FB\30D7\30EC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104336212542308709)
,p_name=>'EVENT.BROWSER.KEYUP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AD\30FC\30FB\30EA\30EA\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104334717499308708)
,p_name=>'EVENT.BROWSER.LOAD'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30BD\30FC\30B9\306E\30ED\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104335319836308708)
,p_name=>'EVENT.BROWSER.MOUSEDOWN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30A6\30B9\30FB\30DC\30BF\30F3\30FB\30D7\30EC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104335694167308708)
,p_name=>'EVENT.BROWSER.MOUSEENTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30A6\30B9\30FB\30A8\30F3\30BF\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104335736573308709)
,p_name=>'EVENT.BROWSER.MOUSELEAVE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30A6\30B9\30FB\30EA\30FC\30D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104335517532308708)
,p_name=>'EVENT.BROWSER.MOUSEMOVE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30A6\30B9\30FB\30E0\30FC\30D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104335402496308708)
,p_name=>'EVENT.BROWSER.MOUSEUP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30A6\30B9\30FB\30DC\30BF\30F3\30FB\30EA\30EA\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103543947651308047)
,p_name=>'EVENT.BROWSER.ORIENTATIONCHANGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B9\5411\306E\5909\66F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104342210006308713)
,p_name=>'EVENT.BROWSER.READY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306E\30ED\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104334806030308708)
,p_name=>'EVENT.BROWSER.RESIZE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30A4\30BA\5909\66F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104334996261308708)
,p_name=>'EVENT.BROWSER.SCROLL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AF\30ED\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103544067451308047)
,p_name=>'EVENT.BROWSER.SCROLLSTART'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AF\30ED\30FC\30EB\30FB\30B9\30BF\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103544185523308047)
,p_name=>'EVENT.BROWSER.SCROLLSTOP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AF\30ED\30FC\30EB\30FB\30B9\30C8\30C3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104335999202308709)
,p_name=>'EVENT.BROWSER.SELECT'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103543179116308047)
,p_name=>'EVENT.BROWSER.SWIPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30EF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103543215996308047)
,p_name=>'EVENT.BROWSER.SWIPELEFT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5DE6\30B9\30EF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103543360256308047)
,p_name=>'EVENT.BROWSER.SWIPERIGHT'
,p_message_language=>'ja'
,p_message_text=>unistr('\53F3\30B9\30EF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103542962641308046)
,p_name=>'EVENT.BROWSER.TAP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30C3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103543098085308046)
,p_name=>'EVENT.BROWSER.TAPHOLD'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30C3\30D7\30FB\30A2\30F3\30C9\30FB\30DB\30FC\30EB\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104335033371308708)
,p_name=>'EVENT.BROWSER.UNLOAD'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306E\30A2\30F3\30ED\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103543733218308047)
,p_name=>'EVENT.BROWSER.VCLICK'
,p_message_language=>'ja'
,p_message_text=>unistr('\4EEE\60F3\30AF\30EA\30C3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103543862994308047)
,p_name=>'EVENT.BROWSER.VMOUSECANCEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30C3\30C1\30FB\30AD\30E3\30F3\30BB\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103543472186308047)
,p_name=>'EVENT.BROWSER.VMOUSEDOWN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30C3\30C1\30FB\30B9\30BF\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103543593621308047)
,p_name=>'EVENT.BROWSER.VMOUSEMOVE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30C3\30C1\30FB\30E0\30FC\30D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103543629576308047)
,p_name=>'EVENT.BROWSER.VMOUSEUP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30C3\30C1\30FB\30A8\30F3\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104339179217308711)
,p_name=>'EVENT.COMPONENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30DD\30FC\30CD\30F3\30C8\30FB\30A4\30D9\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103539901648308044)
,p_name=>'EVENT.CUSTOM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30B9\30BF\30E0\30FB\30A4\30D9\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103540003864308044)
,p_name=>'EVENT.CUSTOM.CUSTOM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30B9\30BF\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104339074649308711)
,p_name=>'EVENT.FRAMEWORK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30EC\30FC\30E0\30EF\30FC\30AF\30FB\30A4\30D9\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103916334879308371)
,p_name=>'EVENT.FRAMEWORK.APEXAFTERCLOSECANCELDIALOG'
,p_message_language=>'ja'
,p_message_text=>unistr('\9589\3058\3089\308C\305F\304B\53D6\308A\6D88\3055\308C\305F\30C0\30A4\30A2\30ED\30B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104068485330308490)
,p_name=>'EVENT.FRAMEWORK.APEXAFTERCLOSEDIALOG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C0\30A4\30A2\30ED\30B0\306E\30AF\30ED\30FC\30BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104757684045309048)
,p_name=>'EVENT.FRAMEWORK.APEXAFTERREFRESH'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30D5\30EC\30C3\30B7\30E5\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104757798353309048)
,p_name=>'EVENT.FRAMEWORK.APEXBEFOREPAGESUBMIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306E\9001\4FE1\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104757553605309048)
,p_name=>'EVENT.FRAMEWORK.APEXBEFOREREFRESH'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30D5\30EC\30C3\30B7\30E5\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103986639338308425)
,p_name=>'EVENTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30D9\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104023823928308454)
,p_name=>'EVENT_ID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30A4\30EB\30B9\30C8\30F3\756A\53F7')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104064781203308487)
,p_name=>'EXACT_SUBS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B8C\5168\7F6E\63DB')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104178520985308591)
,p_name=>'EXAMPLE_1'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F8B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104178620150308591)
,p_name=>'EXAMPLE_2'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F8B2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104678770722308982)
,p_name=>'EXAMPLE_OF_XML_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\308C\306FXML\30C7\30FC\30BF\30D9\30FC\30B9\5217\5185\306B\542B\307E\308C\308B\30C7\30FC\30BF\306E\4F8B\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104728786553309024)
,p_name=>'EXAMPLE_URI'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30F3\30D7\30EBURI')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104134427579308545)
,p_name=>'EXCLUDE'
,p_message_language=>'ja'
,p_message_text=>unistr('\9664\5916')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104114090904308528)
,p_name=>'EXISTING_SCHEMA_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E2\5B58\306E\30B9\30AD\30FC\30DE\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104056059593308480)
,p_name=>'EXISTS'
,p_message_language=>'ja'
,p_message_text=>'EXISTS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103611351911308096)
,p_name=>'EXISTS_SQL_QUERY'
,p_message_language=>'ja'
,p_message_text=>unistr('EXISTS SQL\554F\5408\305B')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104326654303308702)
,p_name=>'EXPANDED'
,p_message_language=>'ja'
,p_message_text=>unistr('\62E1\5F35\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104724528454309020)
,p_name=>'EXPAND_ALL'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\958B\304F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103676503767308147)
,p_name=>'EXPIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\671F\9650\5207\308C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103990138783308428)
,p_name=>'EXPLAIN PLAN'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9F\884C\8A08\753B')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103986930991308425)
,p_name=>'EXPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30AF\30B9\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104295263155308679)
,p_name=>'EXPORT REPOSITORY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30AF\30B9\30DD\30FC\30C8\30FB\30EA\30DD\30B8\30C8\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104069096452308491)
,p_name=>'EXPORTED_FROM_ANOTHER_WORKSPACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5225\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304B\3089\30A8\30AF\30B9\30DD\30FC\30C8\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104069149742308491)
,p_name=>'EXPORTED_FROM_CURRENT_WORKSPACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\884C\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9\304B\3089\30A8\30AF\30B9\30DD\30FC\30C8\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104138431543308548)
,p_name=>'EXPORT_APPLICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30A8\30AF\30B9\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104142635695308552)
,p_name=>'EXPORT_PKG_APP_FOR_DEPLOYMENT'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\7570\306A\308BOracle APEX\30A4\30F3\30B9\30C8\30FC\30EB\306E\30C7\30D7\30ED\30A4\30E1\30F3\30C8\306B\306F\3001\3053\308C\3089\306E\30EA\30F3\30AF\3092\4F7F\7528\3057\3066\3001\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304A\3088\3073\5BFE\5FDC\3059\308B\30C7\30FC\30BF\30D9\30FC\30B9\306E\30B5\30DD\30FC\30C8\3059\308B\30AA\30D6\30B8\30A7\30AF\30C8\3092\30C0\30A6\30F3\30ED\30FC\30C9\3057\307E\3059\3002\30C0\30A6\30F3\30ED\30FC\30C9\3057\305F\30D5\30A1\30A4\30EB\306F\3001SQL*Plus\3001SQL Developer\307E\305F\306FOracle APEX\5185\306ESQL\30B9\30AF\30EA\30D7\30C8\304B\3089\5B9F\884C\3067\304D\308BSQL\30B9\30AF\30EA\30D7\30C8\3067\3059\3002'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104138564834308548)
,p_name=>'EXPORT_SUPPORTING_OBJECTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30DD\30FC\30C8\3059\308B\30AA\30D6\30B8\30A7\30AF\30C8\306E\30A8\30AF\30B9\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103987210686308426)
,p_name=>'EXPORT_TYPES.APP_EXPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30A8\30AF\30B9\30DD\30FC\30C8  ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103987462509308426)
,p_name=>'EXPORT_TYPES.CSS_EXPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30B9\30B1\30FC\30C9\30FB\30B9\30BF\30A4\30EB\30B7\30FC\30C8\306E\30A8\30AF\30B9\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103987622879308426)
,p_name=>'EXPORT_TYPES.FILE_EXPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\9759\7684\30D5\30A1\30A4\30EB\306E\30A8\30AF\30B9\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103987504084308426)
,p_name=>'EXPORT_TYPES.IMAGE_EXPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30E1\30FC\30B8\306E\30A8\30AF\30B9\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103987323436308426)
,p_name=>'EXPORT_TYPES.PAGE_EXPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306E\30A8\30AF\30B9\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103987777435308426)
,p_name=>'EXPORT_TYPES.SCRIPT_FILE_EXPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AF\30EA\30D7\30C8\30FB\30D5\30A1\30A4\30EB\306E\30A8\30AF\30B9\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103983638446308423)
,p_name=>'EXPORT_TYPES.UI_DEFAULTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\306E\30C7\30D5\30A9\30EB\30C8\5024')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103914707343308339)
,p_name=>'F4000.APPLICATION_COMPUTATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\8A08\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103912775171308337)
,p_name=>'F4000.APPLICATION_ITEM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103914556620308338)
,p_name=>'F4000.APPLICATION_PROCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30D7\30ED\30BB\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103729424722308191)
,p_name=>'F4000.APPLICATION_RESERVED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3ID\306E3000\304B\30898999\306F\4E88\7D04\3055\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103612550595308097)
,p_name=>'F4000.APP_EXPORT_CURR_WS'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306F\3001\73FE\884C\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9\304B\3089\30A8\30AF\30B9\30DD\30FC\30C8\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103612664518308097)
,p_name=>'F4000.APP_EXPORT_NON_CURR_WS'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306F\3001\5225\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9\304B\3089\30A8\30AF\30B9\30DD\30FC\30C8\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104546360285308872)
,p_name=>'F4000.APP_PRINT_CREDENTIALS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3%0\30EA\30E2\30FC\30C8\30FB\30D7\30EA\30F3\30C8\30FB\30B5\30FC\30D0\30FC\8CC7\683C\8A3C\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104546176875308872)
,p_name=>'F4000.APP_REMOTE_PRINT_SERVER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3%0\30EA\30E2\30FC\30C8\30FB\30D7\30EA\30F3\30C8\30FB\30B5\30FC\30D0\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103914472317308338)
,p_name=>'F4000.BRANCH'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30E9\30F3\30C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103928356953308381)
,p_name=>'F4000.BRANCH_FROM_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\304B\3089\30D6\30E9\30F3\30C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103928544121308381)
,p_name=>'F4000.BRANCH_TO_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306B\30D6\30E9\30F3\30C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103914029895308338)
,p_name=>'F4000.BUTTON'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104055071002308479)
,p_name=>'F4000.BUTTON.ITEM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3\30FB\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103667867983308141)
,p_name=>'F4000.CALENDAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30EC\30F3\30C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103790310783308240)
,p_name=>'F4000.CALENDAR_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30EC\30F3\30C0\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103928958499308381)
,p_name=>'F4000.COLUMN_ATTRIBUTES'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104692957950308994)
,p_name=>'F4000.COLUMN_NAME_RESERVED_WORD'
,p_message_language=>'ja'
,p_message_text=>unistr('\6307\5B9A\3055\308C\305F\5217\540D\306F\3001Oracle\306E\4E88\7D04\8A9E\3067\3059\3002  \5225\306E\540D\524D\3092\9078\629E\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104056463956308480)
,p_name=>'F4000.COPY_LIST_ENTRY_X'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8\30FB\30A8\30F3\30C8\30EA\306E\30B3\30D4\30FC: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103942248775308391)
,p_name=>'F4000.DYNAMIC'
,p_message_language=>'ja'
,p_message_text=>unistr('\52D5\7684')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103626743897308107)
,p_name=>'F4000.DYNAMIC ACTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\52D5\7684\30A2\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103612413019308097)
,p_name=>'F4000.EXPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30AF\30B9\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103944429063308393)
,p_name=>'F4000.FIX_ME'
,p_message_language=>'ja'
,p_message_text=>unistr('\4FEE\6B63\3057\3066\304F\3060\3055\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103941818720308391)
,p_name=>'F4000.FOR_USER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103941710010308391)
,p_name=>'F4000.FOR_USER_SESSION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\30FB\30BB\30C3\30B7\30E7\30F3\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103928686918308381)
,p_name=>'F4000.FROM'
,p_message_language=>'ja'
,p_message_text=>unistr('\304B\3089')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103730512361308192)
,p_name=>'F4000.HEADER_VALIDATION1'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D8\30C3\30C0\30FC\306B\306F\3001<strong> &lt;head&gt;</strong>\304A\3088\3073<strong>&lt;/head&gt;</strong>\30BF\30B0\3092\542B\3081\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103730808588308192)
,p_name=>'F4000.HEADER_VALIDATION2'
,p_message_language=>'ja'
,p_message_text=>unistr('<strong>#HEAD#</strong>\7F6E\63DB\6587\5B57\5217\306F\3001<strong> &lt;head&gt;</strong>\3068<strong>&lt;/head&gt;</strong>\30BF\30B0\306E\9593\306B\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103999401234308435)
,p_name=>'F4000.INVALID_FILE_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB"%0"\306E\30BF\30A4\30D7\304C\7121\52B9\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103913769747308338)
,p_name=>'F4000.ITEM_DISPLAY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103913838799308338)
,p_name=>'F4000.ITEM_READ_ONLY'
,p_message_language=>'ja'
,p_message_text=>unistr('\8AAD\53D6\308A\5C02\7528\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103559187547308058)
,p_name=>'F4000.LEGACY_SQL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30AC\30B7\30FCSQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104082435468308502)
,p_name=>'F4000.LINK_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30F3\30AF\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103946950624308395)
,p_name=>'F4000.LIST_INITCAP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103915114709308339)
,p_name=>'F4000.LIST_ITEM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8\30FB\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103559022182308058)
,p_name=>'F4000.LOCAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30FC\30AB\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103915473373308339)
,p_name=>'F4000.LOV_ENTRY'
,p_message_language=>'ja'
,p_message_text=>unistr('LOV\30A8\30F3\30C8\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103928730167308381)
,p_name=>'F4000.MENU'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103915350736308339)
,p_name=>'F4000.MENU_OPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0\30FB\30A8\30F3\30C8\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103958715635308404)
,p_name=>'F4000.MUST_SELECT_AT_LEAST_ONE_TO_COPY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30D4\30FC\307E\305F\306F\30B5\30D6\30B9\30AF\30E9\30A4\30D6\3059\308B\3082\306E\30921\3064\4EE5\4E0A\9078\629E\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103914840905308339)
,p_name=>'F4000.NAVIGATION_BAR_ENTRY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30D0\30FC\30FB\30A8\30F3\30C8\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103845566296308282)
,p_name=>'F4000.NAVIGATION_BAR_ICON'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30D0\30FC\30FB\30A2\30A4\30B3\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103912697902308337)
,p_name=>'F4000.NO'
,p_message_language=>'ja'
,p_message_text=>unistr('\3044\3044\3048')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103942328780308391)
,p_name=>'F4000.NOT_REFERENCED'
,p_message_language=>'ja'
,p_message_text=>unistr('\53C2\7167\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103926805676308379)
,p_name=>'F4000.NO_DATA_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\304C\898B\3064\304B\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104752261396309044)
,p_name=>'F4000.P1.APP_DOES_NOT_EXIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3%0\304C\73FE\5728\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306B\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104353193222308721)
,p_name=>'F4000.P1000.UPDATE_CHECK_DISABLED'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F4\65B0\30C1\30A7\30C3\30AF\304C\7121\52B9\3067\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103951510776308399)
,p_name=>'F4000.P104.PARENT_TAB_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\89AA\30BF\30D6\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103615264780308099)
,p_name=>'F4000.P111.CANCEL_BUTTON_BRANCH'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\53D6\6D88\300D\30DC\30BF\30F3\30FB\30D6\30E9\30F3\30C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103614822738308098)
,p_name=>'F4000.P111.CANCEL_BUTTON_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\53D6\6D88\300D\30DC\30BF\30F3\8868\793A\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103615370605308099)
,p_name=>'F4000.P111.FINISH_BUTTON_BRANCH'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\7D42\4E86\300D\30DC\30BF\30F3\30FB\30D6\30E9\30F3\30C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103614993007308098)
,p_name=>'F4000.P111.FINISH_BUTTON_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\7D42\4E86\300D\30DC\30BF\30F3\8868\793A\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103615183712308099)
,p_name=>'F4000.P111.NEXT_BUTTON_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\6B21\3078\300D\30DC\30BF\30F3\8868\793A\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103615077440308099)
,p_name=>'F4000.P111.PREVIOUS_BUTTON_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\623B\308B\300D\30DC\30BF\30F3\8868\793A\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103951650249308399)
,p_name=>'F4000.P112.TREE_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C4\30EA\30FC\30FB\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103951761548308399)
,p_name=>'F4000.P119.GO'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9F\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103951800378308399)
,p_name=>'F4000.P130.USING_SAME_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\540C\3058\30C6\30F3\30D7\30EC\30FC\30C8\3092\65E2\5B58\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3068\3057\3066\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104754788754309046)
,p_name=>'F4000.P135.COPY'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306E\30B3\30D4\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104756431970309047)
,p_name=>'F4000.P149.PUBLISH_AUTHORIZATION'
,p_message_language=>'ja'
,p_message_text=>unistr('<strong>%0</strong>\3092\30D1\30D6\30EA\30C3\30B7\30E5\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002\3053\308C\306B\3088\308A\3001\6B21\306E\8A8D\53EF\30B9\30AD\30FC\30E0\304C\30EA\30D5\30EC\30C3\30B7\30E5\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104756747312309047)
,p_name=>'F4000.P149.PUBLISH_BREADCRUMB_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('<strong>%0</strong>\3092\30D1\30D6\30EA\30C3\30B7\30E5\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002\3053\308C\306B\3088\308A\3001\6B21\306E\30D6\30EC\30C3\30C9\30AF\30E9\30E0\30FB\30C6\30F3\30D7\30EC\30FC\30C8\304C\30EA\30D5\30EC\30C3\30B7\30E5\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104756883968309048)
,p_name=>'F4000.P149.PUBLISH_BUTTON_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('<strong>%0</strong>\3092\30D1\30D6\30EA\30C3\30B7\30E5\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002\3053\308C\306B\3088\308A\3001\6B21\306E\30DC\30BF\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8\304C\30EA\30D5\30EC\30C3\30B7\30E5\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104756950888309048)
,p_name=>'F4000.P149.PUBLISH_CALENDAR_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('<strong>%0</strong>\3092\30D1\30D6\30EA\30C3\30B7\30E5\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002\3053\308C\306B\3088\308A\3001\6B21\306E\30AB\30EC\30F3\30C0\30FB\30C6\30F3\30D7\30EC\30FC\30C8\304C\30EA\30D5\30EC\30C3\30B7\30E5\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103538579438308043)
,p_name=>'F4000.P149.PUBLISH_DATA_LOAD'
,p_message_language=>'ja'
,p_message_text=>unistr('<strong>%0</strong>\3092\30D1\30D6\30EA\30C3\30B7\30E5\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002\3053\308C\306B\3088\308A\3001\6B21\306E\30C7\30FC\30BF\30FB\30ED\30FC\30C9\5B9A\7FA9\304C\30EA\30D5\30EC\30C3\30B7\30E5\3055\308C\307E\3059:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104756335955309047)
,p_name=>'F4000.P149.PUBLISH_FIELD_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('<strong>%0</strong>\3092\30D1\30D6\30EA\30C3\30B7\30E5\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002\3053\308C\306B\3088\308A\3001\6B21\306E\30E9\30D9\30EB\30FB\30C6\30F3\30D7\30EC\30FC\30C8\304C\30EA\30D5\30EC\30C3\30B7\30E5\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104756117019309047)
,p_name=>'F4000.P149.PUBLISH_LIST_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('<strong>%0</strong>\3092\30D1\30D6\30EA\30C3\30B7\30E5\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002\3053\308C\306B\3088\308A\3001\6B21\306E\30EA\30B9\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\304C\30EA\30D5\30EC\30C3\30B7\30E5\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104755802383309047)
,p_name=>'F4000.P149.PUBLISH_LOV'
,p_message_language=>'ja'
,p_message_text=>unistr('<strong>%0</strong>\3092\30D1\30D6\30EA\30C3\30B7\30E5\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002\3053\308C\306B\3088\308A\3001\6B21\306ELOV\304C\30EA\30D5\30EC\30C3\30B7\30E5\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104756612842309047)
,p_name=>'F4000.P149.PUBLISH_NAVBAR'
,p_message_language=>'ja'
,p_message_text=>unistr('<strong>%0</strong>\3092\30D1\30D6\30EA\30C3\30B7\30E5\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002\3053\308C\306B\3088\308A\3001\6B21\306E\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30D0\30FC\30FB\30A8\30F3\30C8\30EA\304C\30EA\30D5\30EC\30C3\30B7\30E5\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104755911056309047)
,p_name=>'F4000.P149.PUBLISH_PAGE_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('<strong>%0</strong>\3092\30D1\30D6\30EA\30C3\30B7\30E5\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002\3053\308C\306B\3088\308A\3001\6B21\306E\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\304C\30EA\30D5\30EC\30C3\30B7\30E5\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104757029451309048)
,p_name=>'F4000.P149.PUBLISH_PLUGIN'
,p_message_language=>'ja'
,p_message_text=>unistr('<strong>%0</strong>\3092\30D1\30D6\30EA\30C3\30B7\30E5\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002\3053\308C\306B\3088\308A\3001\6B21\306E\30D7\30E9\30B0\30A4\30F3\304C\30EA\30D5\30EC\30C3\30B7\30E5\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104757103413309048)
,p_name=>'F4000.P149.PUBLISH_POPUP_LOV_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('<strong>%0</strong>\3092\30D1\30D6\30EA\30C3\30B7\30E5\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002\3053\308C\306B\3088\308A\3001\6B21\306E\30DD\30C3\30D7\30A2\30C3\30D7LOV\30C6\30F3\30D7\30EC\30FC\30C8\304C\30EA\30D5\30EC\30C3\30B7\30E5\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104756051370309047)
,p_name=>'F4000.P149.PUBLISH_REGION_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('<strong>%0</strong>\3092\30D1\30D6\30EA\30C3\30B7\30E5\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002\3053\308C\306B\3088\308A\3001\6B21\306E\30EA\30FC\30B8\30E7\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8\304C\30EA\30D5\30EC\30C3\30B7\30E5\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104756261861309047)
,p_name=>'F4000.P149.PUBLISH_REPORT_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('<strong>%0</strong>\3092\30D1\30D6\30EA\30C3\30B7\30E5\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002\3053\308C\306B\3088\308A\3001\6B21\306E\30EC\30DD\30FC\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\304C\30EA\30D5\30EC\30C3\30B7\30E5\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104756582591309047)
,p_name=>'F4000.P149.PUBLISH_SHORTCUT'
,p_message_language=>'ja'
,p_message_text=>unistr('<strong>%0</strong>\3092\30D1\30D6\30EA\30C3\30B7\30E5\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002\3053\308C\306B\3088\308A\3001\6B21\306E\30B7\30E7\30FC\30C8\30AB\30C3\30C8\304C\30EA\30D5\30EC\30C3\30B7\30E5\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104115104942308529)
,p_name=>'F4000.P149.PUBLISH_WEB_SRC_MODULE'
,p_message_language=>'ja'
,p_message_text=>unistr('<strong>%0</strong>\3092\30D1\30D6\30EA\30C3\30B7\30E5\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002\3053\308C\306B\3088\308A\3001\6B21\306EREST\30C7\30FC\30BF\30FB\30BD\30FC\30B9\304C\30EA\30D5\30EC\30C3\30B7\30E5\3055\308C\307E\3059:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103959567875308405)
,p_name=>'F4000.P158.COPY_OF'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306E\30B3\30D4\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104754651875309046)
,p_name=>'F4000.P1701.LOOKUP_DEFINITION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EB\30C3\30AF\30A2\30C3\30D7\5B9A\7FA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104752346344309044)
,p_name=>'F4000.P1704.REGION_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103730166369308191)
,p_name=>'F4000.P19.VALIDATION'
,p_message_language=>'ja'
,p_message_text=>unistr('NOT NULL\691C\8A3C\3092\4F5C\6210\3059\308B\306B\306F\30011\3064\4EE5\4E0A\306E\30A2\30A4\30C6\30E0\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104664549440308971)
,p_name=>'F4000.P1935.NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3%0\306E\30D7\30EA\30F3\30C8\30FB\30B5\30FC\30D0\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104376333265308738)
,p_name=>'F4000.P2.UPDATE_EXPORT_SETTINGS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\30FB\30A8\30AF\30B9\30DD\30FC\30C8\8A2D\5B9A\306E\66F4\65B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104488071375308829)
,p_name=>'F4000.P203.ACTION='
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103995790115308432)
,p_name=>'F4000.P203.COMMENT='
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30E1\30F3\30C8=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103993827066308431)
,p_name=>'F4000.P203.COMP.MSG'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A08\7B97\306E\5B9F\884C\306B\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104761139115309051)
,p_name=>'F4000.P203.CONCATENATED_FILE'
,p_message_language=>'ja'
,p_message_text=>unistr('\9023\7D50\3055\308C\305F\30D5\30A1\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103994477607308431)
,p_name=>'F4000.P203.DISPVAL='
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\5024=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104761099263309051)
,p_name=>'F4000.P203.FILE='
,p_message_language=>'ja'
,p_message_text=>'file='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103994119258308431)
,p_name=>'F4000.P203.ICONBAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3\30FB\30D0\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103994623494308431)
,p_name=>'F4000.P203.LOV='
,p_message_language=>'ja'
,p_message_text=>'LOV='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103994329019308431)
,p_name=>'F4000.P203.LOVDATA'
,p_message_language=>'ja'
,p_message_text=>unistr('LOV\30C7\30FC\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103994281394308431)
,p_name=>'F4000.P203.NAME='
,p_message_language=>'ja'
,p_message_text=>unistr('\540D\524D=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103993715881308431)
,p_name=>'F4000.P203.PAGE.MSG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306E\8868\793A\306B\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103995643435308432)
,p_name=>'F4000.P203.PAGEBRANCH'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30D6\30E9\30F3\30C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103994763663308431)
,p_name=>'F4000.P203.PGTEMP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103994079613308431)
,p_name=>'F4000.P203.PROC.MSG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30BB\30B9\306E\5B9F\884C\306B\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103993922725308431)
,p_name=>'F4000.P203.PROCESSING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30BB\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103994531594308431)
,p_name=>'F4000.P203.RETVAL='
,p_message_language=>'ja'
,p_message_text=>unistr('\623B\308A\5024=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104757345142309048)
,p_name=>'F4000.P2222.REPARENT_LIST_ENTRY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8\30FB\30A8\30F3\30C8\30EA\306E\89AA\306E\5909\66F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103789910204308239)
,p_name=>'F4000.P254.VALIDATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F5C\6210\3059\308B\30EA\30FC\30B8\30E7\30F3\30921\3064\4EE5\4E0A\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103912372242308337)
,p_name=>'F4000.P277.WORKSPACE_NOT_CREATED_ALREADY_EXISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306F\3001\3059\3067\306B\5B58\5728\3059\308B\305F\3081\4F5C\6210\3055\308C\307E\305B\3093\3067\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103912428791308337)
,p_name=>'F4000.P277.WORKSPACE_WILL_BE_CREATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\304C\4F5C\6210\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104758101013309049)
,p_name=>'F4000.P291.VIEW_LOCK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30C3\30AF\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103790048847308239)
,p_name=>'F4000.P295.VALIDATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F5C\6210\3059\308B\30DA\30FC\30B8\30921\3064\4EE5\4E0A\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104758287493309049)
,p_name=>'F4000.P337.PAGE_UNLOCKED'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DA\30FC\30B8\306F\73FE\5728\30ED\30C3\30AF\89E3\9664\3055\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104321603354308698)
,p_name=>'F4000.P371.POPUP_LOV'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DD\30C3\30D7\30A2\30C3\30D7LOV')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103952214897308399)
,p_name=>'F4000.P374.POS.1'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F4D\7F6E1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103952303563308399)
,p_name=>'F4000.P374.POS.2'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F4D\7F6E2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103952406844308399)
,p_name=>'F4000.P374.POS.3'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F4D\7F6E3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103952557714308399)
,p_name=>'F4000.P374.POS.4'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F4D\7F6E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103550419956308052)
,p_name=>'F4000.P374.POS.5'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F4D\7F6E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104119390166308532)
,p_name=>'F4000.P374.POS.6'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F4D\7F6E6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104119414198308532)
,p_name=>'F4000.P374.POS.7'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F4D\7F6E7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104119581968308533)
,p_name=>'F4000.P374.POS.8'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F4D\7F6E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103952676831308399)
,p_name=>'F4000.P381_XBUTTON_HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('DML\30DC\30BF\30F3\304A\3088\3073\30DA\30FC\30B8\533A\5207\308A\30DC\30BF\30F3\306B\306F\7279\5B9A\306E\30DC\30BF\30F3\540D\304C\5FC5\8981\3067\3059\3002\3053\308C\3089\306E\30DC\30BF\30F3\306F\30D8\30EB\30D7\30FB\30C6\30AD\30B9\30C8\3092\8868\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104754863329309046)
,p_name=>'F4000.P386.CLASS_MATCHES'
,p_message_language=>'ja'
,p_message_text=>unistr('%0 (\30AF\30E9\30B9\306E\4E00\81F4)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103952781008308400)
,p_name=>'F4000.P4001.AUTH_HOME'
,p_message_language=>'ja'
,p_message_text=>unistr('\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104761403040309051)
,p_name=>'F4000.P4001.ORIGINAL_VALUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5143\306E\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103952870357308400)
,p_name=>'F4000.P4001.SUBSTITUTION_STR'
,p_message_language=>'ja'
,p_message_text=>unistr('\7F6E\63DB\6587\5B57\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103952958611308400)
,p_name=>'F4000.P4001.SUBSTITUTION_VALUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\7F6E\63DB\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103926235692308379)
,p_name=>'F4000.P4017.HELP_REGION_SOURCE'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<font class="instructiontext">\6B21\306E\69CB\6587\3092\4F7F\7528\3057\3066\30B3\30FC\30EB\3059\308B\3068\3001\3053\306E\30EA\30FC\30B8\30E7\30F3\306B\73FE\884C\306E\30DA\30FC\30B8\3068\305D\306E\30DA\30FC\30B8\306B\5BFE\3059\308B\30A2\30A4\30C6\30E0\30FB\30D8\30EB\30D7\304C\8868\793A\3055\308C\307E\3059\3002<br>'),
'<pre><escape sc>f?p=&AMP;APP_ID.:Page:Session:&APP_PAGE_ID.</pre></font>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103953035558308400)
,p_name=>'F4000.P4039.FORM_ON'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306E\30D5\30A9\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103953166465308400)
,p_name=>'F4000.P404.VALUES'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103677233222308148)
,p_name=>'F4000.P4045.BRANCH='
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30E9\30F3\30C1=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103945387461308394)
,p_name=>'F4000.P4045.BUTTON='
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103567969198308064)
,p_name=>'F4000.P4045.CHART_SERIES='
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\30FB\30B7\30EA\30FC\30BA=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103945575207308394)
,p_name=>'F4000.P4045.COMPUTATION='
,p_message_language=>'ja'
,p_message_text=>unistr('\8A08\7B97=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103944958852308394)
,p_name=>'F4000.P4045.ICON_SUBTEXT='
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3\30FB\30B5\30D6\30C6\30AD\30B9\30C8=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103944825438308393)
,p_name=>'F4000.P4045.IMAGE='
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30E1\30FC\30B8=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103945461000308394)
,p_name=>'F4000.P4045.ITEM='
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103945026205308394)
,p_name=>'F4000.P4045.LIST='
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103677348810308148)
,p_name=>'F4000.P4045.MENU_OPTION='
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0\30FB\30A8\30F3\30C8\30EA=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103945273830308394)
,p_name=>'F4000.P4045.PAGE='
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103945646178308394)
,p_name=>'F4000.P4045.PROCESS='
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30BB\30B9=')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103567875550308064)
,p_name=>'F4000.P4045.REGION='
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103942483280308391)
,p_name=>'F4000.P4045.REQUIRED_BY_EVERY_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\3059\3079\3066\306E\30DA\30FC\30B8\3067\5FC5\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103944520593308393)
,p_name=>'F4000.P4045.REQUIRED_TO_DISPLAY_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103944616671308393)
,p_name=>'F4000.P4045.REQUIRED_TO_RUN_APP_COMPUTATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\8A08\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103944791421308393)
,p_name=>'F4000.P4045.REQUIRED_TO_RUN_APP_PROCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30D7\30ED\30BB\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103945887405308394)
,p_name=>'F4000.P4045.TAB_NAME='
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30D6\540D=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103945934304308394)
,p_name=>'F4000.P4045.TAB_SET='
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30D6\30FB\30BB\30C3\30C8=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103945149573308394)
,p_name=>'F4000.P4045.TEXT='
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103945770625308394)
,p_name=>'F4000.P4045.VALIDATION='
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103954821379308401)
,p_name=>'F4000.P420.CSV_EXPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C0\30A6\30F3\30ED\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103955472320308402)
,p_name=>'F4000.P420.CVS'
,p_message_language=>'ja'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103954498832308401)
,p_name=>'F4000.P420.DEFAULT_LOOK1'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\306ELook 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103954552405308401)
,p_name=>'F4000.P420.DEFAULT_LOOK2'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\306ELook 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103954610961308401)
,p_name=>'F4000.P420.DEFAULT_LOOK3'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\306ELook 3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103954774645308401)
,p_name=>'F4000.P420.DEFAULT_LOOK4'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\306ELook 4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103953573680308400)
,p_name=>'F4000.P420.EXTERNAL_PAGINATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\5916\90E8\3067\4F5C\6210\3055\308C\305F\30DA\30FC\30B8\533A\5207\308A\30DC\30BF\30F3\3092\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103954377734308401)
,p_name=>'F4000.P420.HTML_STD'
,p_message_language=>'ja'
,p_message_text=>unistr('HTML\306E\6A19\6E96\306E\5916\89B3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103955078278308401)
,p_name=>'F4000.P420.LOOK1'
,p_message_language=>'ja'
,p_message_text=>'Look 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103955193422308401)
,p_name=>'F4000.P420.LOOK2'
,p_message_language=>'ja'
,p_message_text=>'Look 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103955275073308402)
,p_name=>'F4000.P420.LOOK3'
,p_message_language=>'ja'
,p_message_text=>'Look 3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103955303472308402)
,p_name=>'F4000.P420.LOOK4'
,p_message_language=>'ja'
,p_message_text=>'Look 4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103954076323308401)
,p_name=>'F4000.P420.ROWS_X_TO_Y'
,p_message_language=>'ja'
,p_message_text=>unistr('\884CX\304B\3089\884CY')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103953798804308400)
,p_name=>'F4000.P420.ROW_RANGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\30EA\30B9\30C8\306E1\304B\308915\300116\304B\308930\306E\7BC4\56F2\306E\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103954228146308401)
,p_name=>'F4000.P420.SEARCH_ENGINE'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22\30A8\30F3\30B8\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103953891091308400)
,p_name=>'F4000.P420.SEARCH_ENGINE_123'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22\30A8\30F3\30B8\30F31\30012\30013\30014(\30DA\30FC\30B8\533A\5207\308A\306B\57FA\3065\3044\3066\8A2D\5B9A)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103954122264308401)
,p_name=>'F4000.P420.SELECT_LIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\30EA\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103953343112308400)
,p_name=>'F4000.P420.SET_DEFAULTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\306E\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103953453342308400)
,p_name=>'F4000.P420.TURN_OFF_PAGINATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\533A\5207\308A\306E\7121\52B9\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103953943054308401)
,p_name=>'F4000.P420.USE_PAGINATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\533A\5207\308A\30DC\30BF\30F3\3092\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103955585528308402)
,p_name=>'F4000.P420.XML'
,p_message_language=>'ja'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103954984252308401)
,p_name=>'F4000.P420.XML_EXPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('XML\306E\30A8\30AF\30B9\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103955628178308402)
,p_name=>'F4000.P422.GEN_LINK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30F3\30AF\306E\751F\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103953682939308400)
,p_name=>'F4000.P429.ROWS_X_TO_Y'
,p_message_language=>'ja'
,p_message_text=>unistr('X\304B\3089Y\306E\7BC4\56F2\306E\884C(\300C\6B21\3078\300D\304A\3088\3073\300C\623B\308B\300D\30EA\30F3\30AF)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104780704230309074)
,p_name=>'F4000.P4311.P371.ALWAYS_NULL'
,p_message_language=>'ja'
,p_message_text=>'NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104079669447308500)
,p_name=>'F4000.P4311.P371.DB_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('DB\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104079897557308500)
,p_name=>'F4000.P4311.P371.PLSQL_EXP'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104079937520308500)
,p_name=>'F4000.P4311.P371.PLSQL_FUNC_BODY'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104079734881308500)
,p_name=>'F4000.P4311.P371.SQL_QUERY'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104079513365308499)
,p_name=>'F4000.P4311.P371.STATIC_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\9759\7684\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103955719250308402)
,p_name=>'F4000.P4314_XBUTTON_HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('DML\30DC\30BF\30F3\306B\306F\7279\5B9A\306E\30DC\30BF\30F3\540D\304C\5FC5\8981\3067\3059\3002\3053\308C\3089\306E\30DC\30BF\30F3\306F\30D8\30EB\30D7\30FB\30C6\30AD\30B9\30C8\3092\8868\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103622340112308104)
,p_name=>'F4000.P4450.ACTION_CREATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3%0\306B\65B0\3057\3044\30D7\30E9\30B0\30A4\30F3\304C\4F5C\6210\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103622236477308104)
,p_name=>'F4000.P4450.ACTION_REPLACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3%0\306E\65E2\5B58\306E\30D7\30E9\30B0\30A4\30F3\306F\7F6E\304D\63DB\3048\3089\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103955843085308402)
,p_name=>'F4000.P4651.HTML_W_SHORTCUTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30E7\30FC\30C8\30AB\30C3\30C8\4ED8\304D\306EHTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103956027803308402)
,p_name=>'F4000.P4651.PLSQL'
,p_message_language=>'ja'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103946737950308395)
,p_name=>'F4000.P4656.DEFAULT_BUTTON_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\30FB\30DC\30BF\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103667771619308141)
,p_name=>'F4000.P4656.DEFAULT_CALENDAR_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\306E\30AB\30EC\30F3\30C0\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104777038290309071)
,p_name=>'F4000.P4656.DEFAULT_CHART_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\306E\30C1\30E3\30FC\30C8\30FB\30EA\30FC\30B8\30E7\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103667561237308141)
,p_name=>'F4000.P4656.DEFAULT_DIALOG_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\30FB\30C0\30A4\30A2\30ED\30B0\30FB\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104777190072309071)
,p_name=>'F4000.P4656.DEFAULT_FORM_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\306E\30D5\30A9\30FC\30E0\30FB\30EA\30FC\30B8\30E7\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104777516334309071)
,p_name=>'F4000.P4656.DEFAULT_IRR_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\306E\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\30FB\30EA\30FC\30B8\30E7\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103946615351308395)
,p_name=>'F4000.P4656.DEFAULT_LABEL_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\30FB\30E9\30D9\30EB\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104777204656309071)
,p_name=>'F4000.P4656.DEFAULT_LISTR_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\306E\30EA\30B9\30C8\30FB\30EA\30FC\30B8\30E7\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103946565003308395)
,p_name=>'F4000.P4656.DEFAULT_LIST_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\30FB\30EA\30B9\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104777724754309072)
,p_name=>'F4000.P4656.DEFAULT_MENUR_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\30FB\30D6\30EC\30C3\30C9\30AF\30E9\30E0\30FB\30EA\30FC\30B8\30E7\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103946880806308395)
,p_name=>'F4000.P4656.DEFAULT_MENU_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\30FB\30D6\30EC\30C3\30C9\30AF\30E9\30E0\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104776894221309071)
,p_name=>'F4000.P4656.DEFAULT_NAV_BAR_LIST_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\306E\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30D0\30FC\30FB\30EA\30B9\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104776519946309071)
,p_name=>'F4000.P4656.DEFAULT_NAV_LIST_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\306E\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC\30FB\30EA\30B9\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104776392837309071)
,p_name=>'F4000.P4656.DEFAULT_OPTION_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\306E\30AA\30D7\30B7\30E7\30F3\30FB\30E9\30D9\30EB\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103946209357308395)
,p_name=>'F4000.P4656.DEFAULT_PAGE_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\30FB\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103946396184308395)
,p_name=>'F4000.P4656.DEFAULT_REGION_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\30FB\30EA\30FC\30B8\30E7\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104777362406309071)
,p_name=>'F4000.P4656.DEFAULT_REPORTR_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\306E\30EC\30DD\30FC\30C8\30FB\30EA\30FC\30B8\30E7\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103946432544308395)
,p_name=>'F4000.P4656.DEFAULT_REPORT_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\30FB\30EC\30DD\30FC\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104776410236309071)
,p_name=>'F4000.P4656.DEFAULT_REQUIRED_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\306E\5FC5\9808\30E9\30D9\30EB\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104776720339309071)
,p_name=>'F4000.P4656.DEFAULT_SIDE_NAV_LIST_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\306E\30B5\30A4\30C9\30FB\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC\30FB\30EA\30B9\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104777453854309071)
,p_name=>'F4000.P4656.DEFAULT_TABFORM_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\306E\8868\5F62\5F0F\30D5\30A9\30FC\30E0\30FB\30EA\30FC\30B8\30E7\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104776627739309071)
,p_name=>'F4000.P4656.DEFAULT_TOP_NAV_LIST_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\306E\30C8\30C3\30D7\30FB\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC\30FB\30EA\30B9\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104777632600309072)
,p_name=>'F4000.P4656.DEFAULT_WIZARD_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\306E\30A6\30A3\30B6\30FC\30C9\30FB\30EA\30FC\30B8\30E7\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103946138597308394)
,p_name=>'F4000.P4656.ERROR_PAGE_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\306E\30A8\30E9\30FC\30FB\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104776971239309071)
,p_name=>'F4000.P4656.LOGIN_PAGE_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\306E\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103946087855308394)
,p_name=>'F4000.P4656.PRINT_MODE_PAGE_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\306E\51FA\529B\30E2\30FC\30C9\30FB\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103953208256308400)
,p_name=>'F4000.P4703.REPORT_ON'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306E\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103949896585308397)
,p_name=>'F4000.P4717.ALERT_INFO'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30E9\30FC\30C8\60C5\5831')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103950011310308397)
,p_name=>'F4000.P4717.NEW_REGION'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F\30EA\30FC\30B8\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103949779253308397)
,p_name=>'F4000.P4717.REGION_MUST_EXIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3092\4F5C\6210\3059\308B\306B\306F\30011\3064\4EE5\4E0A\306E\30EA\30FC\30B8\30E7\30F3\3092\4F5C\6210\3057\3066\304A\304F\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103949971452308397)
,p_name=>'F4000.P4717.USE_WIZARD'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A6\30A3\30B6\30FC\30C9\3092\4F7F\7528\3057\3066\65B0\3057\3044\30EA\30FC\30B8\30E7\30F3\3092\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103951276912308398)
,p_name=>'F4000.P4719.ALPHABETIC_SORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30EB\30D5\30A1\30D9\30C3\30C8\9806\306B\30BD\30FC\30C8\3055\308C\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103951426459308399)
,p_name=>'F4000.P4719.BIND_VAR_LOV'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F8B4: \30D0\30A4\30F3\30C9\5909\6570\3092\542B\3080LOV')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103951338238308398)
,p_name=>'F4000.P4719.CREATION_SORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F5C\6210\9806\306B\683C\7D0D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103950932836308398)
,p_name=>'F4000.P4719.D_R_LOV'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F8B2: \540C\3058\8868\793A\5024\304A\3088\3073\623B\308A\5024\3092\6301\3064LOV')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104043768721308470)
,p_name=>'F4000.P4719.INLINE'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F8B5: \554F\5408\305B\306B\30A4\30F3\30E9\30A4\30F3\554F\5408\305B\304C\542B\307E\308C\3001SQL\6587\306E\6700\521D\306EFROM\53E5\304C\30A4\30F3\30E9\30A4\30F3\554F\5408\305B\306B\5C5E\3057\3066\3044\306A\3044\3053\3068\3092\78BA\8A8D\3059\308B\5FC5\8981\304C\3042\308B\5834\5408')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103950886597308398)
,p_name=>'F4000.P4719.SQL_QUERY_LOV'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F8B1: SQL\554F\5408\305B\306B\57FA\3065\304FLOV')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103951118443308398)
,p_name=>'F4000.P4719.STATIC_LOV'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F8B3: \9759\7684\30EA\30B9\30C8\306E\4F8B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103951023699308398)
,p_name=>'F4000.P4719.USE_ALIAS'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\5024\3068\623B\308A\5024\306E\4E21\65B9\306B\540C\3058\5217\3092\9078\629E\3059\308B\5834\5408\306F\3001\5217\306E\5225\540D\3092\4F7F\7528\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103621239086308103)
,p_name=>'F4000.P4719.YN'
,p_message_language=>'ja'
,p_message_text=>unistr('\306F\3044/\3044\3044\3048\3092\8868\793A\3001Y\304A\3088\3073N\3092\623B\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103956658085308403)
,p_name=>'F4000.P4728.AFTER_PROCESSING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30BB\30B9\306E\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103956356666308402)
,p_name=>'F4000.P4728.BEFORE_COMPUTATIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A08\7B97\306E\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103956513319308402)
,p_name=>'F4000.P4728.BEFORE_PROCESSING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30BB\30B9\306E\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103956423348308402)
,p_name=>'F4000.P4728.BEFORE_VALIDATIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C\306E\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103627636623308108)
,p_name=>'F4000.P4731.ADD'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103956721256308403)
,p_name=>'F4000.P4731.APPLY'
,p_message_language=>'ja'
,p_message_text=>unistr('\9069\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103624507266308105)
,p_name=>'F4000.P4731.DELETE'
,p_message_language=>'ja'
,p_message_text=>unistr('\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103956945691308403)
,p_name=>'F4000.P4731.FINISH'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D42\4E86')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103956843252308403)
,p_name=>'F4000.P4731.SUBMIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\9001\4FE1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103957183754308403)
,p_name=>'F4000.P4735_RP_ALL'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30D7\30ED\30B7\30FC\30B8\30E3\3092\5B9F\884C\3059\308B\3068\3001\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5185\306E\3059\3079\3066\306E\30DA\30FC\30B8\306E\30DA\30FC\30B8\533A\5207\308A\304C\30EA\30BB\30C3\30C8\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103969274971308412)
,p_name=>'F4000.P4738.REGEXP_WARNING'
,p_message_language=>'ja'
,p_message_text=>unistr('\8B66\544A: \6B63\898F\8868\73FE\30BF\30A4\30D7\306E\691C\8A3C\3092\9078\629E\3057\307E\3057\305F\304C\3001\3053\306E\30BF\30A4\30D7\306E\691C\8A3C\306F\3054\4F7F\7528\306E\30C7\30FC\30BF\30D9\30FC\30B9\306E\30D0\30FC\30B8\30E7\30F3\3067\306F\30B5\30DD\30FC\30C8\3055\308C\3066\3044\307E\305B\3093\3002\3053\306E\691C\8A3C\306F\5E38\306Btrue\3092\623B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104706178509309005)
,p_name=>'F4000.P4761.TRANSLATIONS_NOT_USED'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\7FFB\8A33\306F\73FE\5728\6709\52B9\3067\306F\3042\308A\307E\305B\3093\3002<a href="%0">\30B0\30ED\30FC\30D0\30EA\30BC\30FC\30B7\30E7\30F3\5C5E\6027</a>\306E<em>\300C\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\8A00\8A9E\306E\5C0E\51FA\5143\300D</em>\8A2D\5B9A\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104768399760309064)
,p_name=>'F4000.P509.INSTANCE_MAX_SESSION_IDLE_SEC'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5927\30BB\30C3\30B7\30E7\30F3\30FB\30A2\30A4\30C9\30EB\6642\9593\304C\8A2D\5B9A\3055\308C\3066\3044\306A\3044\5834\5408\3001\30EF\30FC\30AF\30B9\30DA\30FC\30B9\30FB\30EC\30D9\30EB\307E\305F\306F\30A4\30F3\30B9\30BF\30F3\30B9\30FB\30EC\30D9\30EB\5024\304C\4F7F\7528\3055\308C\307E\3059(\73FE\5728\3001%0\79D2)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104768435022309064)
,p_name=>'F4000.P509.INSTANCE_MAX_SESSION_LENGTH_SEC'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5927\30BB\30C3\30B7\30E7\30F3\306E\9577\3055\304C\8A2D\5B9A\3055\308C\3066\3044\306A\3044\5834\5408\3001\30EF\30FC\30AF\30B9\30DA\30FC\30B9\30FB\30EC\30D9\30EB\307E\305F\306F\30A4\30F3\30B9\30BF\30F3\30B9\30FB\30EC\30D9\30EB\5024\304C\4F7F\7528\3055\308C\307E\3059(\73FE\5728\3001%0\79D2)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104758833309309049)
,p_name=>'F4000.P593.NEW_BRANCH'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F\30D6\30E9\30F3\30C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104069903305308492)
,p_name=>'F4000.P598.EXPORTED_FROM_ANOTHER_APP_OR_WORKSPACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\308C\3089\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306F\3001\5225\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\307E\305F\306F\5225\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304B\3089\30A8\30AF\30B9\30DD\30FC\30C8\3055\308C\307E\3057\305F\3002\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\306F\30A4\30F3\30B9\30C8\30FC\30EB\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104073976610308495)
,p_name=>'F4000.P612.EXPORTED_FROM_ANOTHER_WORKSPACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\308C\3089\306E\30D5\30A1\30A4\30EB\306F\3001\5225\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9\304B\3089\30A8\30AF\30B9\30DD\30FC\30C8\3055\308C\307E\3057\305F\3002\3053\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306B\306F\30A4\30F3\30B9\30C8\30FC\30EB\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104758934617309049)
,p_name=>'F4000.P622.TO_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8\306B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104759730285309050)
,p_name=>'F4000.P623.COPY_OPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30D7\30B7\30E7\30F3\306E\30B3\30D4\30FC: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104759864206309050)
,p_name=>'F4000.P623.EXISTING_LOV'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E2\5B58\306ELOV: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104010847778308443)
,p_name=>'F4000.P67.EXPORTED_FROM_ANOTHER_APP_OR_WORKSPACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DA\30FC\30B8\306F\3001\5225\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\307E\305F\306F\5225\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304B\3089\30A8\30AF\30B9\30DD\30FC\30C8\3055\308C\307E\3057\305F\3002\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\306F\30A4\30F3\30B9\30C8\30FC\30EB\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103912290464308337)
,p_name=>'F4000.P67.EXPORTED_FROM_ANOTHER_WORKSPACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DA\30FC\30B8\306F\3001\5225\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304B\3089\30A8\30AF\30B9\30DD\30FC\30C8\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103912104538308337)
,p_name=>'F4000.P67.EXPORTED_FROM_CURRENT_WORKSPACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DA\30FC\30B8\306F\3001\73FE\884C\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304B\3089\30A8\30AF\30B9\30DD\30FC\30C8\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104331184133308705)
,p_name=>'F4000.P67.PAGE_LOCKED'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DA\30FC\30B8\306F\73FE\5728\30ED\30C3\30AF\3055\308C\3066\3044\307E\3059\3002\30ED\30C3\30AF\3055\308C\3066\3044\308B\30DA\30FC\30B8\306B\5BFE\3059\308B\30A4\30F3\30DD\30FC\30C8\306F\3067\304D\307E\305B\3093\3002\30DA\30FC\30B8\306E\30ED\30C3\30AF\3092\89E3\9664\3057\3066\304B\3089\30A4\30F3\30B9\30C8\30FC\30EB\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104757476716309048)
,p_name=>'F4000.P712.CLEAR_PARENT_ENTRY'
,p_message_language=>'ja'
,p_message_text=>unistr('\89AA\30A8\30F3\30C8\30EA\306E\30AF\30EA\30A2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104759216141309049)
,p_name=>'F4000.P765.SELECT_PARAM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30E9\30E1\30FC\30BF%0\306E\9078\629E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103731154298308192)
,p_name=>'F4000.P818.VALIDATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30D4\30FC\3059\308B\30B9\30AD\30FC\30E0\30921\3064\4EE5\4E0A\9078\629E\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104759427892309050)
,p_name=>'F4000.P875.HTTP_HEADER_VAL'
,p_message_language=>'ja'
,p_message_text=>unistr('HTTP\30D8\30C3\30C0\30FC%0\306E\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104759308127309050)
,p_name=>'F4000.P875.INPUT_PARAM_VAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\30D1\30E9\30E1\30FC\30BF%0\306E\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104759609617309050)
,p_name=>'F4000.P876.DELETE_HEADER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D8\30C3\30C0\30FC\306E\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104759503492309050)
,p_name=>'F4000.P876.DELETE_PARAM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30E9\30E1\30FC\30BF\306E\524A\9664: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103958963830308404)
,p_name=>'F4000.P904.REQUIRED_STYLE_SHEET'
,p_message_language=>'ja'
,p_message_text=>unistr('\5FC5\8981\306A\30B9\30BF\30A4\30EB\30B7\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103928072800308380)
,p_name=>'F4000.PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103942663458308392)
,p_name=>'F4000.PAGE_BUTTON'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30DC\30BF\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103914121513308338)
,p_name=>'F4000.PAGE_COMPUTATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\8A08\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103668985492308142)
,p_name=>'F4000.PAGE_DYNAMIC_ACTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\52D5\7684\30A2\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103529928224308037)
,p_name=>'F4000.PAGE_DYNAMIC_ACTION_ACTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\52D5\7684\30A2\30AF\30B7\30E7\30F3 - \30A2\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103912833262308337)
,p_name=>'F4000.PAGE_ITEM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103532169680308039)
,p_name=>'F4000.PAGE_ITEM_GROUP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\30FB\30B0\30EB\30FC\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103947095980308395)
,p_name=>'F4000.PAGE_MAYBE_PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103928132906308380)
,p_name=>'F4000.PAGE_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103914227133308338)
,p_name=>'F4000.PAGE_PROCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30D7\30ED\30BB\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103942562472308392)
,p_name=>'F4000.PAGE_REGION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30EA\30FC\30B8\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103942783993308392)
,p_name=>'F4000.PAGE_VALIDATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\691C\8A3C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103915040242308339)
,p_name=>'F4000.PARENT_TAB'
,p_message_language=>'ja'
,p_message_text=>unistr('\89AA\30BF\30D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103929065771308381)
,p_name=>'F4000.POPUP_LOV_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DD\30C3\30D7\30A2\30C3\30D7LOV\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104546264598308872)
,p_name=>'F4000.PRINT_CREDENTIALS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30E2\30FC\30C8\30FB\30D7\30EA\30F3\30C8\30FB\30B5\30FC\30D0\30FC\8CC7\683C\8A3C\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103929657745308382)
,p_name=>'F4000.PUBLISH'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30D6\30EA\30C3\30B7\30E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103913673853308338)
,p_name=>'F4000.REGION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104542775301308869)
,p_name=>'F4000.REGION_COLUMNS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\306E\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103928273942308381)
,p_name=>'F4000.RELATED_PAGES_AND_COMPONENTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\95A2\9023\30DA\30FC\30B8\304A\3088\3073\30B3\30F3\30DD\30FC\30CD\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104546441095308872)
,p_name=>'F4000.REMOTE_DATABASE'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\5BFE\5FDCSQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104043594920308470)
,p_name=>'F4000.REPORT_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103559298420308058)
,p_name=>'F4000.REST_ENABLED_SQL'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\5BFE\5FDCSQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103929554715308382)
,p_name=>'F4000.SEED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103914916490308339)
,p_name=>'F4000.STANDARD_TAB'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A19\6E96\30BF\30D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103942187456308391)
,p_name=>'F4000.STATIC'
,p_message_language=>'ja'
,p_message_text=>unistr('\9759\7684')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103928843989308381)
,p_name=>'F4000.TAB'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103929140523308381)
,p_name=>'F4000.TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103772980423308226)
,p_name=>'F4000.TEMPLATE_NAME_ALREADY_EXISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8\540D%0\306F\3059\3067\306B\5B58\5728\3057\307E\3059\3002\65B0\3057\3044\540D\524D\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103731234904308192)
,p_name=>'F4000.TEMPLATE_NAME_MAND'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\30C6\30F3\30D7\30EC\30FC\30C8\540D\300D\306B\5024\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103929383455308381)
,p_name=>'F4000.THEME_IMPORT_CREATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3%0\306B\65B0\3057\3044\30C6\30FC\30DE\304C\4F5C\6210\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103929487049308381)
,p_name=>'F4000.THEME_IMPORT_REPLACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3%0\306E\65E2\5B58\306E\30C6\30FC\30DE\306F\7F6E\304D\63DB\3048\3089\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103928495098308381)
,p_name=>'F4000.TO'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9B\5148')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103915525296308339)
,p_name=>'F4000.UNKNOWN_APPLICATION_ELEMENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0D\660E\306A\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\8981\7D20')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103929746880308382)
,p_name=>'F4000.UPDATEABLE_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F4\65B0\53EF\80FD\306A\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104054922531308479)
,p_name=>'F4000.UTILITIES.INFO'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30C6\30A3\30EA\30C6\30A3\306B\306F\3001\9078\629E\3057\305F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5185\306E\5168\30DA\30FC\30B8\306B\5BFE\3059\308B\30B0\30EA\30C3\30C9\7DE8\96C6\30DA\30FC\30B8\3068\30EC\30DD\30FC\30C8\304C\542B\307E\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103914317822308338)
,p_name=>'F4000.VALIDATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103559348240308058)
,p_name=>'F4000.WEB_SOURCE'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\30C7\30FC\30BF\30FB\30BD\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104546520995308872)
,p_name=>'F4000.WEB_SRC_MODULE'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\30C7\30FC\30BF\30FB\30BD\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103912541401308337)
,p_name=>'F4000.YES'
,p_message_language=>'ja'
,p_message_text=>unistr('\306F\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103988631584308427)
,p_name=>'F4000_4738_DATE_MMDDYYY'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5\4ED8(MMDDYYYY)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104142383741308552)
,p_name=>'F4000_APPLICATIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103694480083308162)
,p_name=>'F4000_AS_APP_ON_EXIST_TABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\8868\306B\5BFE\3059\308B\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3068\3057\3066')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103947464365308395)
,p_name=>'F4000_AS_APP_ON_EXIST_TABLES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\8868\306B\5BFE\3059\308B\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3068\3057\3066')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103959049701308404)
,p_name=>'F4000_BUTTON_POS_NOT_IN_REGION'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DC\30BF\30F3\306E\4F4D\7F6E\306F\30EA\30FC\30B8\30E7\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306B\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104695029603308996)
,p_name=>'F4000_CHART'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103959322739308405)
,p_name=>'F4000_CLOSE'
,p_message_language=>'ja'
,p_message_text=>unistr('\9589\3058\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103975944194308417)
,p_name=>'F4000_COPY_AND_SUBSCRIBE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30D4\30FC\304A\3088\3073\30B5\30D6\30B9\30AF\30E9\30A4\30D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103959606624308405)
,p_name=>'F4000_DATE_NOT_REC'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5\4ED8\66F8\5F0F\304C\8A8D\8B58\3055\308C\307E\305B\3093\3067\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103627389860308108)
,p_name=>'F4000_F1500_LOCKED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30C3\30AF\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104058702422308482)
,p_name=>'F4000_HELP_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D8\30EB\30D7\30FB\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104141466340308551)
,p_name=>'F4000_LOV_NAME_EXISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('LOV\540D%0\306F\3059\3067\306B\5B58\5728\3057\307E\3059\3002\65B0\3057\3044\540D\524D\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103982571850308422)
,p_name=>'F4000_NONE_SELECTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F\9805\76EE\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103938803972308389)
,p_name=>'F4000_NO_APP_ASSOC'
,p_message_language=>'ja'
,p_message_text=>unistr('\95A2\9023\4ED8\3051\3089\308C\305F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103570668136308066)
,p_name=>'F4000_OFF'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103570528728308066)
,p_name=>'F4000_ON'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103630993478308113)
,p_name=>'F4000_P122_CAL_TEMPL'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30C6\30F3\30D7\30EC\30FC\30C8\3092\53C2\7167\3059\308B\30AB\30EC\30F3\30C0\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104011739033308444)
,p_name=>'F4000_P128.VIEW_PAGES'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30BF\30A4\30D7\306E\30DA\30FC\30B8\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103740285932308200)
,p_name=>'F4000_P173_NO_HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30A4\30C6\30E0\306B\30D8\30EB\30D7\306F\3042\308A\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103732291610308193)
,p_name=>'F4000_P1_AUTHENTICATION_HOME'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\30DB\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103732146503308193)
,p_name=>'F4000_P1_EDIT_THIS_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30C6\30F3\30D7\30EC\30FC\30C8\306E\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103747781644308206)
,p_name=>'F4000_P232_RESET_CSS'
,p_message_language=>'ja'
,p_message_text=>unistr('CSS\3092\30EA\30BB\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104353263129308721)
,p_name=>'F4000_P295_PAGE_EXISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306F\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\3059\3067\306B\5B58\5728\3057\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103627745727308108)
,p_name=>'F4000_P295_PAGE_MUST_BE_NUMERIC'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\30DA\30FC\30B8\300D\306F\6570\5024\3067\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103627890686308108)
,p_name=>'F4000_P295_PAGE_MUST_BE_POSITIVE'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\30DA\30FC\30B8\300D\306F\6B63\306E\6570\3067\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103627914879308108)
,p_name=>'F4000_P295_PAGE_MUST_BE_WHOLE_NUMBER'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\30DA\30FC\30B8\300D\306F\6574\6570\3067\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104060008476308483)
,p_name=>'F4000_P3005.IMPORT_AUTHORIZATION SCHEME'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\53EF\30B9\30AD\30FC\30E0\306E\30A4\30F3\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104009544495308442)
,p_name=>'F4000_P3005.IMPORT_AUTH_SCHEME'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\30B9\30AD\30FC\30E0\306E\30A4\30F3\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104060156595308483)
,p_name=>'F4000_P3005.IMPORT_NAVBAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30D0\30FC\306E\30A4\30F3\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104009667812308442)
,p_name=>'F4000_P3005.IMPORT_THEME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\306E\30A4\30F3\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103957535246308403)
,p_name=>'F4000_P33_REGION_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\5F62\5F0F\30D5\30A9\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103988315547308426)
,p_name=>'F4000_P3890_AUTHENTICATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103988469326308426)
,p_name=>'F4000_P3890_AUTH_FAILED'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\306B\5931\6557\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103980285046308420)
,p_name=>'F4000_P395_NO_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103960831309308406)
,p_name=>'F4000_P4001_UNAVAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306F\3001\73FE\6642\70B9\3067\306F\4F7F\7528\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103709747381308175)
,p_name=>'F4000_P430_DATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5\4ED8: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103709806883308175)
,p_name=>'F4000_P430_DATE2'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5\4ED8(\81EA\7531\5F62\5F0F): \30BB\30D1\30EC\30FC\30BF\4ED8\304D\306E%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103710527852308176)
,p_name=>'F4000_P430_DATE2_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8B58\3055\308C\306A\3044\65E5\4ED8\66F8\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103710475985308176)
,p_name=>'F4000_P430_DATE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5\4ED8\306F\3001%0\3068\3044\3046\5F62\5F0F\3067\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103709299537308175)
,p_name=>'F4000_P430_IP'
,p_message_language=>'ja'
,p_message_text=>unistr('IP\30A2\30C9\30EC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103710027787308175)
,p_name=>'F4000_P430_IP_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9\306AIP\30A2\30C9\30EC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103709354899308175)
,p_name=>'F4000_P430_PHONE'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\8A71\756A\53F7\3001\7C73\56FD: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103709443936308175)
,p_name=>'F4000_P430_PHONE2'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\8A71\756A\53F7\3001\7C73\56FD(\81EA\7531\5F62\5F0F): 999.999.9999\3001(999)-999-9999\3001999 999 9999\306A\3069')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103710243246308176)
,p_name=>'F4000_P430_PHONE2_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8B58\3055\308C\306A\3044\96FB\8A71\756A\53F7\5F62\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103710142968308175)
,p_name=>'F4000_P430_PHONE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\8A71\756A\53F7\306F\3001%0\3068\3044\3046\5F62\5F0F\3067\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103709161848308175)
,p_name=>'F4000_P430_URL'
,p_message_language=>'ja'
,p_message_text=>unistr('URL: http(s)://domain/path/doc(pdf\3001html\306A\3069)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103709977732308175)
,p_name=>'F4000_P430_URL_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9\306AURL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103709578375308175)
,p_name=>'F4000_P430_ZIP'
,p_message_language=>'ja'
,p_message_text=>unistr('\90F5\4FBF\756A\53F7: 99999')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103709652091308175)
,p_name=>'F4000_P430_ZIP2'
,p_message_language=>'ja'
,p_message_text=>'ZIP + 4: 99999-9999'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103710315025308176)
,p_name=>'F4000_P430_ZIP_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\90F5\4FBF\756A\53F7\306F\3001%0\3068\3044\3046\5F62\5F0F\3067\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103640609430308121)
,p_name=>'F4000_P4495.COPIED_FROM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30D4\30FC\5143\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103640737197308121)
,p_name=>'F4000_P4495.MASTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\308C\304C\3053\306E\8A8D\8A3C\30B9\30AD\30FC\30E0\306E\300C\30DE\30B9\30BF\30FC\300D\30B3\30D4\30FC\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103640912680308121)
,p_name=>'F4000_P4495.NO_SUBSCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\8A8D\8A3C\30B9\30AD\30FC\30E0\306B\5BFE\3059\308B\30B5\30D6\30B9\30AF\30E9\30A4\30D0\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103640899980308121)
,p_name=>'F4000_P4495.REFERENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\8A8D\8A3C\30B9\30AD\30FC\30E0\306B\30B5\30D6\30B9\30AF\30E9\30A4\30D6\3057\3066\3044\308B\30B9\30AD\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103695667223308163)
,p_name=>'F4000_P4495_LOV_NO_SCHEME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AD\30FC\30E0\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103956124771308402)
,p_name=>'F4000_P4701_PAGE_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C81')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103960956062308406)
,p_name=>'F4000_P4705_FORM_ON_A_PROC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30C8\30A2\30C9\30FB\30D7\30ED\30B7\30FC\30B8\30E3\306E\30D5\30A9\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103956264584308402)
,p_name=>'F4000_P4710_PAGE_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C81')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103960270894308405)
,p_name=>'F4000_P4717_DISPLAY'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\306E\307F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103960173582308405)
,p_name=>'F4000_P4717_HIDDEN'
,p_message_language=>'ja'
,p_message_text=>unistr('\975E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103959804754308405)
,p_name=>'F4000_P4734_CLEAR_ITEMS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\30FB\30AD\30E3\30C3\30B7\30E5\306E\30AF\30EA\30A2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103959724799308405)
,p_name=>'F4000_P4734_CLEAR_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30AD\30E3\30C3\30B7\30E5\306E\30AF\30EA\30A2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103982843868308422)
,p_name=>'F4000_P4734_RESET_PAG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\533A\5207\308A\306E\30EA\30BB\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103960069258308405)
,p_name=>'F4000_P4734_SET_ITEM'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\4F7F\7528\3057\3066\30A2\30A4\30C6\30E0\3092\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103959963961308405)
,p_name=>'F4000_P4734_STATIC_ITEM'
,p_message_language=>'ja'
,p_message_text=>unistr('\9759\7684\30A2\30A4\30C6\30E0\306E\5272\5F53\3066')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103957023083308403)
,p_name=>'F4000_P4735_INITIALIZE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30EC\30F3\30C8\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\30AD\30E3\30C3\30B7\30E5\3055\308C\306A\3044\3059\3079\3066\306E\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306F\3001NULL\306B\521D\671F\5316\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103960656198308406)
,p_name=>'F4000_P4737_EXISTS'
,p_message_language=>'ja'
,p_message_text=>'EXISTS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103960391834308405)
,p_name=>'F4000_P4737_ITEM_NOT_NULL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\304CNOT NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103960458752308405)
,p_name=>'F4000_P4737_ITEM_NOT_ZERO'
,p_message_language=>'ja'
,p_message_text=>unistr('0(\30BC\30ED)\3067\306F\306A\3044\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103960578217308406)
,p_name=>'F4000_P4737_PLSQL_EXP'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103988851136308427)
,p_name=>'F4000_P4738_DATE_DDMMYYYY'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5\4ED8(DDMMYYYY)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103988738157308427)
,p_name=>'F4000_P4738_PHONE_NUM'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\8A71\756A\53F7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104727110771309022)
,p_name=>'F4000_P473_DATABASE_OBJECT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30AA\30D6\30B8\30A7\30AF\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103957294616308403)
,p_name=>'F4000_P4759_VIEW'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30E9\30A6\30B6\5185')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103957317365308403)
,p_name=>'F4000_P4785_REGION_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30EC\30F3\30C01')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103695843235308163)
,p_name=>'F4000_P4790_DATE_TIMESTAMP_NOTE'
,p_message_language=>'ja'
,p_message_text=>unistr('(\65E5\4ED8\5217\307E\305F\306F\30BF\30A4\30E0\30B9\30BF\30F3\30D7\5217\3092\542B\3080)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104175678808308589)
,p_name=>'F4000_P4790_SYNTAX_HEADING'
,p_message_language=>'ja'
,p_message_text=>unistr('\69CB\6587: select id, name, date from ...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104175981926308589)
,p_name=>'F4000_P4790_SYNTAX_HELP_EXAMPLE1'
,p_message_language=>'ja'
,p_message_text=>unistr('ROWID\64EC\4F3C\5217\3092\4F7F\7528\3057\305F\4F8B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104176099558308589)
,p_name=>'F4000_P4790_SYNTAX_HELP_EXAMPLE2'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BD\30FC\30B9\8868\306E\4E3B\30AD\30FC\3092\4F7F\7528\3057\305F\4F8B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104175761290308589)
,p_name=>'F4000_P4790_SYNTAX_HELP_LINE1'
,p_message_language=>'ja'
,p_message_text=>unistr('1. 2\3064\4EE5\4E0A\306E\5217(\305D\306E\3046\30611\3064\306FDATE\5217)\3092\542B\3081\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104175812952308589)
,p_name=>'F4000_P4790_SYNTAX_HELP_LINE2'
,p_message_language=>'ja'
,p_message_text=>unistr('2. \6700\521D\306E\5217\306F\3001\30C7\30FC\30BF\64CD\4F5C\8A00\8A9E(DML)\306E\64CD\4F5C\306E\7BA1\7406\306B\4F7F\7528\3059\308B\4E3B\30AD\30FC\5217\3092\793A\3059\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103957465043308403)
,p_name=>'F4000_P4810_PAGE_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30FC\30E01')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104070533226308492)
,p_name=>'F4000_P48_MANIFEST'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30DD\30FC\30CD\30F3\30C8\30FB\30A8\30AF\30B9\30DD\30FC\30C8\306E\30DE\30CB\30D5\30A7\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104011681920308444)
,p_name=>'F4000_P497.VIEW_PAGE_DEF'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\5B9A\7FA9\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103957651509308403)
,p_name=>'F4000_P5100_PAGE_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30DE\30EA\30FC\30FB\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103976299379308417)
,p_name=>'F4000_P52_TAB_LINK_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30EA\30C3\30AF\3057\3066\30BF\30D6\30FB\30BB\30C3\30C8\3092\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104230315048308632)
,p_name=>'F4000_P643_NO_PARENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3067\306F2\30EC\30D9\30EB\306E\30BF\30D6\304C\30B5\30DD\30FC\30C8\3055\308C\3066\3044\307E\3059\304C\3001\6A19\6E96\30BF\30D6\3067\306F\89AA\30BF\30D6\306E\30BB\30C3\30C8\306F\8B58\5225\3055\308C\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104230222453308632)
,p_name=>'F4000_P643_NO_TAB'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DA\30FC\30B8\306B\306F\30BF\30D6\306F\8868\793A\3055\308C\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104230067656308632)
,p_name=>'F4000_P643_ONE_LVL'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DA\30FC\30B8\306B\306F\30011\30EC\30D9\30EB\306E\30BF\30D6\304C\8868\793A\3055\308C\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104230422645308632)
,p_name=>'F4000_P643_PAGE_NO_TAB'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30D6\306A\3057\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104230592586308632)
,p_name=>'F4000_P643_PAGE_NO_TAB_TTL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5408\8A08%0\30DA\30FC\30B8\306B\30BF\30D6\304C\5B9A\7FA9\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104229967287308631)
,p_name=>'F4000_P643_TAB_DISPLAY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30D6\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104230180478308632)
,p_name=>'F4000_P643_TWO_LVL'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DA\30FC\30B8\306B\306F\30012\30EC\30D9\30EB\306E\30BF\30D6\304C\8868\793A\3055\308C\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104677830155308981)
,p_name=>'F4000_P78_UPGRADE_AVAILABLE'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p><strong>Oracle APEX %0\306F\4F7F\7528\53EF\80FD\3067\3059\3002</strong> \30A4\30F3\30B9\30BF\30F3\30B9\306F<strong>%1</strong>\306B\81EA\52D5\7684\306B\30A2\30C3\30D7\30B0\30EC\30FC\30C9\3055\308C\307E\3059\3002\30A4\30F3\30B9\30BF\30F3\30B9\7BA1\7406\8005\306F\3001\7BA1\7406\30B5\30FC\30D3\30B9\3067\3053\306E\65E5\4ED8\3088\308A\524D\306E\3044\3064\3067\3082\30A2\30C3\30D7\30B0\30EC\30FC\30C9\3092\958B\59CB\3067\304D\307E\3059\3002</p>'),
unistr('<p>Oracle APEX %0\306E\65B0\6A5F\80FD\304A\3088\3073\6A5F\80FD\62E1\5F35\306B\3064\3044\3066\3055\3089\306B\5B66\7FD2\3059\308B\306B\306F\3001<a href="%2" target="_blank" rel="noreferrer">\304A\77E5\3089\305B</a>\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104677729054308981)
,p_name=>'F4000_P78_UPGRADING'
,p_message_language=>'ja'
,p_message_text=>unistr('<strong>%0\30A4\30F3\30B9\30BF\30F3\30B9\3092\65B0\3057\3044\30EA\30EA\30FC\30B9\306B\30A2\30C3\30D7\30B0\30EC\30FC\30C9\4E2D\3067\3059\3002</strong> \30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3078\306E\5909\66F4\306F\3001\30A2\30C3\30D7\30B0\30EC\30FC\30C9\30FB\30D7\30ED\30BB\30B9\306E\9593\306F\7121\52B9\5316\3055\308C\307E\3059\3002\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304A\3088\3073%0\958B\767A\74B0\5883\3078\306E\30A2\30AF\30BB\30B9\306F\3001\6700\5927%1\5206\9593\4E2D\65AD\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103639566256308120)
,p_name=>'F4000_P801_ACTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103640439743308120)
,p_name=>'F4000_P801_ACTIVATE1'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B9\30AD\30FC\30E0\3092\30AB\30EC\30F3\30C8\306E\30B9\30AD\30FC\30E0\306B\3057\3066\304F\3060\3055\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103640521012308121)
,p_name=>'F4000_P801_ACTIVATE2'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30EC\30F3\30C8\306B\3059\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103695430877308162)
,p_name=>'F4000_P801_CURRENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30EC\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103640238526308120)
,p_name=>'F4000_P801_DEACTIVATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30C6\30FC\30BF\30B9\3092\975E\30A2\30AF\30C6\30A3\30D6\306B\5909\66F4\3057\3066\304F\3060\3055\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103639030262308119)
,p_name=>'F4000_P801_DETAILS'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A73\7D30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103639168531308119)
,p_name=>'F4000_P801_DETAILS_BI1'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\7D44\8FBC\307F\30BB\30C3\30B7\30E7\30F3\306E\7BA1\7406\30ED\30B8\30C3\30AF\3001\7D44\8FBC\307F\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8\3001\304A\3088\3073\5185\90E8\300CCookie\30E6\30FC\30B6\30FC\300D\30A2\30AB\30A6\30F3\30C8\30FB\30EA\30DD\30B8\30C8\30EA\306B\5BFE\3059\308B\30E6\30FC\30B6\30FC\8A8D\8A3C\3002'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103639289917308120)
,p_name=>'F4000_P801_DETAILS_OBS1'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\65B9\5F0F\306E\304B\308F\308A\306B\3001SCHEME\8A8D\8A3C\304C\4F7F\7528\3055\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103693419026308161)
,p_name=>'F4000_P801_EDIT_DEPRECATED1'
,p_message_language=>'ja'
,p_message_text=>unistr('\975E\63A8\5968\306E\8A8D\8A3C\5C5E\6027\306E\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103693560949308161)
,p_name=>'F4000_P801_EDIT_DEPRECATED2'
,p_message_language=>'ja'
,p_message_text=>unistr('\975E\63A8\5968\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103693608752308161)
,p_name=>'F4000_P801_EDIT_DEPRECATED3'
,p_message_language=>'ja'
,p_message_text=>unistr('\307E\305F\306F\8A8D\8A3C\65B9\5F0F\3092%0\306B\5909\66F4\3059\308B\6E96\5099\304C\3067\304D\308B\307E\3067\305D\306E\307E\307E\306B\3057\3066\304A\3044\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103693977974308161)
,p_name=>'F4000_P801_EDIT_DEPRECATED4'
,p_message_language=>'ja'
,p_message_text=>unistr('1\3064\4EE5\4E0A\306E\975E\63A8\5968\8A8D\8A3C\5C5E\6027\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103694149712308161)
,p_name=>'F4000_P801_EDIT_DEPRECATED5'
,p_message_language=>'ja'
,p_message_text=>unistr('\307E\305F\306F\305D\308C\3089\3092\8A8D\8A3C\30B9\30AD\30FC\30E0\306B\79FB\884C\3057\3066\304F\3060\3055\3044\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103693127011308161)
,p_name=>'F4000_P801_FLOW'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103640156709308120)
,p_name=>'F4000_P801_MANAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\524D\8FF0\306E\30EC\30DD\30FC\30C8\3092\4F7F\7528\3057\3066\8A8D\8A3C\30B9\30AD\30FC\30E0\3092\7BA1\7406\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103638913176308119)
,p_name=>'F4000_P801_METHOD'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E1\30BD\30C3\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103695324514308162)
,p_name=>'F4000_P801_NO_EDIT'
,p_message_language=>'ja'
,p_message_text=>unistr('(\7DE8\96C6\4E0D\53EF\80FD)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103640350083308120)
,p_name=>'F4000_P801_PAREN_CURRENT'
,p_message_language=>'ja'
,p_message_text=>unistr('(\30AB\30EC\30F3\30C8)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103693215104308161)
,p_name=>'F4000_P801_PAREN_DEPRECATED'
,p_message_language=>'ja'
,p_message_text=>unistr('(\975E\63A8\5968)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103640097922308120)
,p_name=>'F4000_P801_PAREN_NONE'
,p_message_language=>'ja'
,p_message_text=>unistr('(\306A\3057)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103639475552308120)
,p_name=>'F4000_P801_PUBLIC_PAGES'
,p_message_language=>'ja'
,p_message_text=>unistr('\516C\958B\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103639668044308120)
,p_name=>'F4000_P801_REVIEW1'
,p_message_language=>'ja'
,p_message_text=>unistr('\78BA\8A8D\307E\305F\306F\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103639784821308120)
,p_name=>'F4000_P801_REVIEW2'
,p_message_language=>'ja'
,p_message_text=>unistr('\307E\305F\306F\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103639877952308120)
,p_name=>'F4000_P801_REVIEW3'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30C3\30B7\30E7\30F3\7BA1\7406\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103639913103308120)
,p_name=>'F4000_P801_REVIEW4'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5C5E\6027\30DA\30FC\30B8\306E\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\3064\3044\3066\3001\307E\305F\306F\3001\524D\8FF0\306E\30EC\30DD\30FC\30C8\3092\4F7F\7528\3057\3066\8A8D\8A3C\30B9\30AD\30FC\30E0\3092\4F5C\6210\304A\3088\3073\7BA1\7406\3057\3066\304F\3060\3055\3044\3002\8A8D\8A3C\30B9\30AD\30FC\30E0\306F\3001\8A8D\8A3C\65B9\5F0F\3092%0\306B\5909\66F4\3059\308B\3068\4F7F\7528\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103693710317308161)
,p_name=>'F4000_P801_REVIEW5'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30BB\30C3\30B7\30E7\30F3\7BA1\7406\5C5E\6027\3092\78BA\8A8D\307E\305F\306F\7DE8\96C6'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103694047171308161)
,p_name=>'F4000_P801_REVIEW6'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\308C\3089\3092\78BA\8A8D\307E\305F\306F\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103693394899308161)
,p_name=>'F4000_P801_SCHEME_CONVERT'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\8A8D\8A3C\306F\975E\63A8\5968\306E\65B9\5F0F\3067\3059\3002\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\3044\305A\308C\304B\306E\8A8D\8A3C\30B9\30AD\30FC\30E0\306E\300C\30AB\30EC\30F3\30C8\306B\3059\308B\300D\30EA\30F3\30AF(\524D\8FF0\306E\56F3\3092\53C2\7167)\3092\30AF\30EA\30C3\30AF\3059\308B\304B\3001\307E\305F\306F\65B0\3057\3044\8A8D\8A3C\30B9\30AD\30FC\30E0\3092\4F5C\6210\3057\3066\30AB\30EC\30F3\30C8\306B\3059\308B\3053\3068\3092\304A\85A6\3081\3057\307E\3059\3002INTERNAL-SETUP\8A8D\8A3C\30B9\30AD\30FC\30E0\306F\3001%0\65B9\5F0F\3068\540C\69D8\306B\6A5F\80FD\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103693839927308161)
,p_name=>'F4000_P801_SCHEME_DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\8A8D\8A3C\304A\3088\3073\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30BB\30C3\30B7\30E7\30F3\7BA1\7406\306E\4ED6\306E\3059\3079\3066\306E\8A2D\5B9A\3092\5236\5FA1\3059\308B\306B\306F\3001\8A8D\8A3C\30B9\30AD\30FC\30E0\3092\4F7F\7528\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103957974826308404)
,p_name=>'F4000_P805_X'
,p_message_language=>'ja'
,p_message_text=>unistr('\524D\306E\30B9\30C6\30C3\30D7\3067\30DA\30FC\30B8\76E3\8996\30D5\30A1\30F3\30AF\30B7\30E7\30F3\3092\6307\5B9A\3057\307E\3057\305F\3002\305D\306E\30D5\30A1\30F3\30AF\30B7\30E7\30F3\304C\5404\30DA\30FC\30B8\3067\306E\30BB\30C3\30B7\30E7\30F3\691C\8A3C\3092\884C\3046\305F\3081\3001\3053\3053\3067\306F\30BB\30C3\30B7\30E7\30F3\691C\8A3C\30D5\30A1\30F3\30AF\30B7\30E7\30F3\306F\5165\529B\3057\307E\305B\3093\3002\3053\306E\3088\3046\306A\64CD\4F5C\3092\884C\308F\306A\3044\5834\5408\306F\3001\3053\306E\30A6\30A3\30B6\30FC\30C9\306E\524D\306E\30B9\30C6\30C3\30D7\306B\623B\308A\3001\6307\5B9A\3092\5909\66F4\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103696469197308163)
,p_name=>'F4000_P806_BUILTIN_LOGIN_PG'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D44\8FBC\307F\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103696815781308164)
,p_name=>'F4000_P806_NONE'
,p_message_language=>'ja'
,p_message_text=>unistr('\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103696558601308163)
,p_name=>'F4000_P806_PAGE_IN_THIS_FLOW'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103696710858308164)
,p_name=>'F4000_P806_SSO_SERVER'
,p_message_language=>'ja'
,p_message_text=>'Oracle Application Server Single Sign-On'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103696664541308164)
,p_name=>'F4000_P806_URL'
,p_message_language=>'ja'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103696923219308164)
,p_name=>'F4000_P808_AUTH_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\306B%0\30A2\30AB\30A6\30F3\30C8\306E\30E6\30FC\30B6\30FC\540D\304A\3088\3073\30D1\30B9\30EF\30FC\30C9\3092\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103582700636308075)
,p_name=>'F4000_P808_DBAUTH_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\306B\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30A2\30AB\30A6\30F3\30C8\306E\30E6\30FC\30B6\30FC\540D\304A\3088\3073\30D1\30B9\30EF\30FC\30C9\3092\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103697000145308164)
,p_name=>'F4000_P808_NO_VERIFY_CRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\8CC7\683C\8A3C\660E\306E\691C\8A3C\7981\6B62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103697258333308164)
,p_name=>'F4000_P808_USE_CUSTOM'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\306B\72EC\81EA\306E\30AB\30B9\30BF\30E0\30FB\30D5\30A1\30F3\30AF\30B7\30E7\30F3\3092\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103697187806308164)
,p_name=>'F4000_P808_USE_LDAP'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\306BLDAP\30B5\30FC\30D0\30FC\3092\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103961005250308406)
,p_name=>'F4000_P80_NO_PAGE_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('- \30DA\30FC\30B8\540D\306A\3057 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103641670471308121)
,p_name=>'F4000_P811_AUTH'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8A8D\8A3C\30D5\30A1\30F3\30AF\30B7\30E7\30F3'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103642459993308122)
,p_name=>'F4000_P811_C_DOMAIN'
,p_message_language=>'ja'
,p_message_text=>unistr('Cookie\30C9\30E1\30A4\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103642211141308122)
,p_name=>'F4000_P811_C_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('Cookie\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103642355461308122)
,p_name=>'F4000_P811_C_PATH'
,p_message_language=>'ja'
,p_message_text=>unistr('Cookie\30D1\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103579838074308073)
,p_name=>'F4000_P811_C_SECURE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30AD\30E5\30A2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103641450966308121)
,p_name=>'F4000_P811_INV_SESS_TGT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9\306A\30BB\30C3\30B7\30E7\30F3\30FB\30BF\30FC\30B2\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103641904437308122)
,p_name=>'F4000_P811_LDAP_DN'
,p_message_language=>'ja'
,p_message_text=>unistr('LDAP\691C\7D22\30D9\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103642058481308122)
,p_name=>'F4000_P811_LDAP_EDIT'
,p_message_language=>'ja'
,p_message_text=>unistr('LDAP\30E6\30FC\30B6\30FC\540D\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103641730595308121)
,p_name=>'F4000_P811_LDAP_HOST'
,p_message_language=>'ja'
,p_message_text=>unistr('LDAP\30DB\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103641896088308122)
,p_name=>'F4000_P811_LDAP_PORT'
,p_message_language=>'ja'
,p_message_text=>unistr('LDAP\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103642562358308122)
,p_name=>'F4000_P811_LOGOUT_URL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30B0\30A2\30A6\30C8URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103641158110308121)
,p_name=>'F4000_P811_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\540D\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103641028548308121)
,p_name=>'F4000_P811_PAREN_BUILTIN'
,p_message_language=>'ja'
,p_message_text=>unistr('(\7D44\8FBC\307F)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103642613518308122)
,p_name=>'F4000_P811_PAREN_DBAUTH'
,p_message_language=>'ja'
,p_message_text=>unistr('(\30C7\30FC\30BF\30D9\30FC\30B9\8A8D\8A3C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103641258598308121)
,p_name=>'F4000_P811_PG_SENTRY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\76E3\8996\30D5\30A1\30F3\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103642106070308122)
,p_name=>'F4000_P811_POST_AUTH'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\5F8C\306E\51E6\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103641587379308121)
,p_name=>'F4000_P811_PRE_AUTH'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\524D\306E\51E6\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103641384049308121)
,p_name=>'F4000_P811_SESS_VERIFY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30C3\30B7\30E7\30F3\691C\8A3C\30D5\30A1\30F3\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103697422582308164)
,p_name=>'F4000_P815_COPY'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E2\5B58\306E\8A8D\8A3C\30B9\30AD\30FC\30E0\306E\30B3\30D4\30FC\3068\3057\3066')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103697560810308164)
,p_name=>'F4000_P815_GALLERY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AE\30E3\30E9\30EA\304B\3089\306E\4E8B\524D\69CB\6210\6E08\30B9\30AD\30FC\30E0\306B\57FA\3065\304F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103697368234308164)
,p_name=>'F4000_P815_SCRATCH'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AE\30E3\30E9\30EA\304B\3089\306E\4E8B\524D\69CB\6210\6E08\30B9\30AD\30FC\30E0\306B\57FA\3065\304F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103655297300308132)
,p_name=>'F4000_P817_REFRESH_AUTH_SCHEME_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\30B9\30AD\30FC\30E0\306E\30EA\30D5\30EC\30C3\30B7\30E5\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103642866768308122)
,p_name=>'F4000_P819_AUTH_METHOD'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103710630396308176)
,p_name=>'F4000_P819_CURR_WARN'
,p_message_language=>'ja'
,p_message_text=>unistr('\8B66\544A: \3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\73FE\884C\306E\8A8D\8A3C\30B9\30AD\30FC\30E0\3092\524A\9664\3057\3088\3046\3068\3057\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103643038265308122)
,p_name=>'F4000_P819_DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\8AAC\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103642764001308122)
,p_name=>'F4000_P819_FLOW_ID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103642900561308122)
,p_name=>'F4000_P819_SCHEME_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AD\30FC\30E0\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103698002997308165)
,p_name=>'F4000_P820_MY_PARTNER'
,p_message_language=>'ja'
,p_message_text=>unistr('Oracle Application Server Single Sign-On(\30D1\30FC\30C8\30CA\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3068\3057\3066\306E\72EC\81EA\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103697690959308164)
,p_name=>'F4000_P820_SHOW_ACCOUNT_CRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8\306E\8868\793A\304A\3088\3073%0\30A2\30AB\30A6\30F3\30C8\8CC7\683C\8A3C\660E\306E\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103697790568308165)
,p_name=>'F4000_P820_SHOW_BUILTIN_PG_OPEN'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D44\8FBC\307F\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8\306E\8868\793A\304A\3088\3073\516C\958B\8CC7\683C\8A3C\660E\306E\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103697819648308165)
,p_name=>'F4000_P820_SHOW_USE_LDAP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8\306E\8868\793A\304A\3088\3073LDAP\30C7\30A3\30EC\30AF\30C8\30EA\8CC7\683C\8A3C\660E\306E\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103697995753308165)
,p_name=>'F4000_P820_SSO_HTMLDB_PARTNER'
,p_message_language=>'ja'
,p_message_text=>unistr('Oracle Application Server Single Sign-On(\30D1\30FC\30C8\30CA\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3068\3057\3066\306E%0\30A8\30F3\30B8\30F3)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103643337486308123)
,p_name=>'F4000_P822_CURR_METHOD'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\884C\306E\8A8D\8A3C\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103655325423308132)
,p_name=>'F4000_P826_CREATE1'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30F3\30B0\30EB\30FB\30B5\30A4\30F3\30AA\30F3(Oracle\5C02\7528)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103655403798308132)
,p_name=>'F4000_P826_CREATE2'
,p_message_language=>'ja'
,p_message_text=>unistr('Oracle Application Server Single Sign-On(\30D1\30FC\30C8\30CA\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3068\3057\3066\306E%0)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103655505603308132)
,p_name=>'F4000_P826_CREATE3'
,p_message_language=>'ja'
,p_message_text=>unistr('Oracle Application Server Single Sign-On(\30D1\30FC\30C8\30CA\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3068\3057\3066\306E\72EC\81EA\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103655667960308132)
,p_name=>'F4000_P826_CREATE4'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D44\8FBC\307F\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8: %0\30A2\30AB\30A6\30F3\30C8\8CC7\683C\8A3C\660E\3092\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103678134425308149)
,p_name=>'F4000_P826_CREATE4A'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\3057\304F\4F5C\6210\3055\308C\305F\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8: %0\30A2\30AB\30A6\30F3\30C8\8CC7\683C\8A3C\660E\3092\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103678223463308149)
,p_name=>'F4000_P826_CREATE4B'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E2\5B58\306E\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8: %0\30A2\30AB\30A6\30F3\30C8\8CC7\683C\8A3C\660E\3092\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103655799924308132)
,p_name=>'F4000_P826_CREATE5'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D44\8FBC\307F\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8: \516C\958B\8CC7\683C\8A3C\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103655833543308132)
,p_name=>'F4000_P826_CREATE6'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D44\8FBC\307F\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8: LDAP\30C7\30A3\30EC\30AF\30C8\30EA\8CC7\683C\8A3C\660E\3092\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103677903053308149)
,p_name=>'F4000_P826_CREATE6A'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\3057\304F\4F5C\6210\3055\308C\305F\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8: LDAP\30C7\30A3\30EC\30AF\30C8\30EA\8CC7\683C\8A3C\660E\3092\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103678058091308149)
,p_name=>'F4000_P826_CREATE6B'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E2\5B58\306E\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8: LDAP\30C7\30A3\30EC\30AF\30C8\30EA\8CC7\683C\8A3C\660E\3092\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103655953331308132)
,p_name=>'F4000_P826_CREATE7'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AE\30E3\30E9\30EA\304B\3089\306E\8A8D\8A3C\30B9\30AD\30FC\30E0\306B\57FA\3065\304F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103698131955308165)
,p_name=>'F4000_P826_NEW'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103734878172308195)
,p_name=>'F4000_P88_FLASHBACK_QUERY'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306E\300C\5143\306B\623B\3059\300D\6A5F\80FD\3067\306F\3001\300C\30D5\30E9\30C3\30B7\30E5\30D0\30C3\30AF\554F\5408\305B\300D\3068\3044\3046\7D44\8FBC\307F\30C7\30FC\30BF\30D9\30FC\30B9\6A5F\80FD\3092\4F7F\7528\3057\3066\3001\7279\5B9A\306E\6642\9593\3067\306E\30C7\30FC\30BF\3092\554F\3044\5408\305B\308B\3053\3068\304C\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103734606959308195)
,p_name=>'F4000_P88_SELECT_TIME'
,p_message_language=>'ja'
,p_message_text=>unistr('\623B\308B\6642\9593\3092\9078\629E\3057\305F\5F8C\3001\300C\9069\7528\300D\3092\30AF\30EA\30C3\30AF\3057\3066\30BD\30FC\30B9\3092\30EA\30FC\30B8\30E7\30F3\7DE8\96C6\30DA\30FC\30B8\306B\66F8\304D\8FBC\307F\3001\3053\306E\30C0\30A4\30A2\30ED\30B0\3092\9589\3058\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103735074456308195)
,p_name=>'F4000_P88_UNDO_RETENTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30D1\30E9\30E1\30FC\30BF\300CUNDO_RETENTION\300D\306B\57FA\3065\3044\3066\3001%0\6642\9593\4EE5\5185\306B\884C\308F\308C\305F\5909\66F4\306E\307F\5143\306B\623B\3059\3053\3068\304C\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103735503512308196)
,p_name=>'F4000_P92_CONFIRM_CREATE_STD_TAB'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\306E\6A19\6E96\30BF\30D6\4F5C\6210\306E\78BA\8A8D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103735987994308196)
,p_name=>'F4000_P92_NEW_TABSET_WILL_BE_CREATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F\30BF\30D6\30FB\30BB\30C3\30C8%0\304C\4F5C\6210\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103735873904308196)
,p_name=>'F4000_P92_PAGE_WILL_USE_EXISTNG_TABSET'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8%0\3067\306F\65E2\5B58\306E\30BF\30D6\30FB\30BB\30C3\30C8\300C%1\300D\3092\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103735690436308196)
,p_name=>'F4000_P92_TABSET_INFO_INCOMPLETE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8B66\544A\3002\30BF\30D6\30FB\30BB\30C3\30C8\60C5\5831\304C\4E0D\5B8C\5168\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104177389474308590)
,p_name=>'F4000_P975_VALUE_FOR'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306E\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103959442361308405)
,p_name=>'F4000_PREV'
,p_message_language=>'ja'
,p_message_text=>'Prev.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103947788844308396)
,p_name=>'F4000_QUICK_APP_FINISH'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C<strong>\7D42\4E86</strong>\300D\3092\30AF\30EA\30C3\30AF\3057\3066\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\4F5C\6210\307E\305F\306F\62E1\5F35\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103947500944308396)
,p_name=>'F4000_QUICK_APP_OPT_DISP1'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0\30FB\30CA\30D3\30B2\30FC\30B7\30E7\30F3\6A5F\80FD\3092\542B\3080')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103947686234308396)
,p_name=>'F4000_QUICK_APP_OPT_DISP2'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\30FB\30DA\30FC\30B8\306E\4E3B\30AD\30FC\306E\975E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104093249512308511)
,p_name=>'F4000_SHORTCUT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30E7\30FC\30C8\30AB\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103853869175308288)
,p_name=>'F4000_SVG_CHART'
,p_message_language=>'ja'
,p_message_text=>unistr('SVG\30C1\30E3\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103959182038308404)
,p_name=>'F4000_TOP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C8\30C3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104058809153308482)
,p_name=>'F4000_TREE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C4\30EA\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104174274248308587)
,p_name=>'F4000_WORKSPACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103611172924308096)
,p_name=>'F4000_WS_ENTIRE_RESPONSE_DOC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30B9\30DD\30F3\30B9\30FB\30C9\30AD\30E5\30E1\30F3\30C8\5168\4F53')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103621122085308103)
,p_name=>'F400_P107_STEP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30C6\30C3\30D7%0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103591847110308082)
,p_name=>'F4050.ACCEPTED'
,p_message_language=>'ja'
,p_message_text=>'DELETE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104175585541308589)
,p_name=>'F4050.ACCEPTED_MSG'
,p_message_language=>'ja'
,p_message_text=>unistr('\627F\8A8D\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104045527729308471)
,p_name=>'F4050.ACTION_ASSIGN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AD\30FC\30DE\304C\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306B\5272\308A\5F53\3066\3089\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104045617357308472)
,p_name=>'F4050.ACTION_NO_ASSIGN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AD\30FC\30DE\306F\6B21\306E\7406\7531\3067\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306B\5272\308A\5F53\3066\3089\308C\307E\305B\3093:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104045194873308471)
,p_name=>'F4050.ADDITIONAL_SCHEMA'
,p_message_language=>'ja'
,p_message_text=>unistr('\8FFD\52A0\306E\30B9\30AD\30FC\30DE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103940381264308390)
,p_name=>'F4050.ADJUST'
,p_message_language=>'ja'
,p_message_text=>unistr('\8ABF\6574')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103939616678308389)
,p_name=>'F4050.ALL'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104175065947308588)
,p_name=>'F4050.APPROVED'
,p_message_language=>'ja'
,p_message_text=>unistr('\627F\8A8D\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103595674892308084)
,p_name=>'F4050.APPROVED_ACCOUNT_REQ_DISPLAY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306B\3064\3044\3066\306E\30EA\30AF\30A8\30B9\30C8\304C\627F\8A8D\3055\308C\305F\305F\3081\3001\767B\9332\6642\306B\6307\5B9A\3057\305F\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9\306B\8CC7\683C\8A3C\660E\304C\9001\4FE1\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104013747951308446)
,p_name=>'F4050.APPROVED_ACCOUNT_REQ_EMAIL_BODY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AB\30A6\30F3\30C8\30FB\30EA\30AF\30A8\30B9\30C8\306F\627F\8A8D\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104013625919308445)
,p_name=>'F4050.APPROVED_ACCOUNT_REQ_EMAIL_SUBJ'
,p_message_language=>'ja'
,p_message_text=>unistr('\627F\8A8D\6E08: %0\306E\30A2\30AB\30A6\30F3\30C8\30FB\30EA\30AF\30A8\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104014142984308446)
,p_name=>'F4050.APPROVE_ADD_STORAGE_EMAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9%1\306B\5BFE\3059\308B%0M\30D0\30A4\30C8\306E\8A18\61B6\57DF\306E\8FFD\52A0\30EA\30AF\30A8\30B9\30C8\306F\627F\8A8D\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104174705913308588)
,p_name=>'F4050.ASSIGNED'
,p_message_language=>'ja'
,p_message_text=>unistr('\5272\5F53\3066\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104686070034308988)
,p_name=>'F4050.AUTOMATIC'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104174682733308588)
,p_name=>'F4050.AVAILABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F7F\7528\53EF\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104766256321309063)
,p_name=>'F4050.BROKEN'
,p_message_language=>'ja'
,p_message_text=>unistr('\7834\640D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104766690110309063)
,p_name=>'F4050.CHAIN_STALLED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30A7\30FC\30F3\505C\6B62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104014504016308446)
,p_name=>'F4050.CHANGE_APPROVED_EMAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5909\66F4\30EA\30AF\30A8\30B9\30C8\306F\627F\8A8D\3055\308C\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104014624915308446)
,p_name=>'F4050.CHANGE_DENIED_EMAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5909\66F4\30EA\30AF\30A8\30B9\30C8\306F\62D2\5426\3055\308C\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104766136231309063)
,p_name=>'F4050.COMPLETED'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B8C\4E86')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104045293809308471)
,p_name=>'F4050.CREATE_SCHEMA'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AD\30FC\30DE\304C\4F5C\6210\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104175173289308588)
,p_name=>'F4050.DECLINED'
,p_message_language=>'ja'
,p_message_text=>unistr('\62D2\5426')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104014059395308446)
,p_name=>'F4050.DECLINED_ACCOUNT_REQ_EMAIL_SUBJ'
,p_message_language=>'ja'
,p_message_text=>unistr('\62D2\5426: %0\306E\30A2\30AB\30A6\30F3\30C8\30FB\30EA\30AF\30A8\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104014460191308446)
,p_name=>'F4050.DENY_ADD_STORAGE_EMAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9%1\306B\5BFE\3059\308B%0M\30D0\30A4\30C8\306E\8A18\61B6\57DF\306E\8FFD\52A0\30EA\30AF\30A8\30B9\30C8\306F\62D2\5426\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104014285571308446)
,p_name=>'F4050.DENY_NEW_SCHEMA_EMAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9%1\306E\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30B9\30AD\30FC\30DE%0\3078\306E\30EA\30AF\30A8\30B9\30C8\306F\62D2\5426\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104014387530308446)
,p_name=>'F4050.DENY_REMOVE_SERVICE_EMAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9%0\306E\30B5\30FC\30D3\30B9\306E\7D42\4E86\30EA\30AF\30A8\30B9\30C8\306F\62D2\5426\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104765856459309062)
,p_name=>'F4050.DISABLED'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103591756357308081)
,p_name=>'F4050.EMAIL_CLICK_ON_LINK'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\627F\8A8D\30D7\30ED\30BB\30B9\3092\5B9F\884C\3059\308B\306B\306F\3001\6B21\306E\30EA\30F3\30AF\3092\30AF\30EA\30C3\30AF\3057\3066\304F\3060\3055\3044\3002\5B8C\4E86\3059\308B\3068\3001\30D5\30A9\30ED\30FC\30FB\30A2\30C3\30D7\96FB\5B50\30E1\30FC\30EB\3067\30EF\30FC\30AF\30B9\30DA\30FC\30B9\8CC7\683C\8A3C\660E\3092\5165\624B\3067\304D\307E\3059\3002'),
'',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104013983297308446)
,p_name=>'F4050.EMAIL_GETSTARTED'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\958B\59CB\3059\308B\306B\306F\3001\6B21\306E\30EA\30F3\30AF\3092\30AF\30EA\30C3\30AF\3057\3066\304F\3060\3055\3044\3002'),
'',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104766387066309063)
,p_name=>'F4050.FAILED'
,p_message_language=>'ja'
,p_message_text=>unistr('\5931\6557')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103619492864308102)
,p_name=>'F4050.HTML_EMAIL_CLICK_ON_LINK'
,p_message_language=>'ja'
,p_message_text=>unistr('\627F\8A8D\30D7\30ED\30BB\30B9\3092\5B9F\884C\3057\3066\8CC7\683C\8A3C\660E\3092\53D7\3051\53D6\308B\306B\306F\3001<a href=''%0''>\3053\3053</a>\3092\30AF\30EA\30C3\30AF\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103929983315308382)
,p_name=>'F4050.INFORMATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\60C5\5831')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103941188658308391)
,p_name=>'F4050.INSTALL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30B9\30C8\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104175213762308588)
,p_name=>'F4050.IN_PROGRESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\9032\884C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103939912315308390)
,p_name=>'F4050.NO_ACTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103958028305308404)
,p_name=>'F4050.P23.USE'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104769351388309065)
,p_name=>'F4050.P3.UPDATE_CHECK_DISABLED'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F4\65B0\30C1\30A7\30C3\30AF\304C\30A4\30F3\30B9\30BF\30F3\30B9\5168\4F53\306B\5BFE\3057\3066\7121\52B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103958111844308404)
,p_name=>'F4050.P39_OPEN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30FC\30D7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104045028514308471)
,p_name=>'F4050.PRIMARY_SCHEMA'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30E9\30A4\30DE\30EA\30FB\30B9\30AD\30FC\30DE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103940292682308390)
,p_name=>'F4050.PROVISION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30D3\30B8\30E7\30CB\30F3\30B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104013410829308445)
,p_name=>'F4050.PROV_CHANGE_REQ_APPROVED'
,p_message_language=>'ja'
,p_message_text=>unistr('\5909\66F4\30EA\30AF\30A8\30B9\30C8\306F\627F\8A8D\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104013391203308445)
,p_name=>'F4050.PROV_SCHEMA_REQ_APPROVED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9%1\306E\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30B9\30AD\30FC\30DE%0\3078\306E\30EA\30AF\30A8\30B9\30C8\306F\627F\8A8D\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104766433143309063)
,p_name=>'F4050.REMOTE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30E2\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104175323625308588)
,p_name=>'F4050.REQUESTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30AF\30A8\30B9\30C8\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103939401053308389)
,p_name=>'F4050.RESET'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30BB\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104013573829308445)
,p_name=>'F4050.RESTRICTED_ADMIN'
,p_message_language=>'ja'
,p_message_text=>unistr('\8B66\544A: \30EA\30AF\30A8\30B9\30C8\3057\305F\30B9\30AD\30FC\30DE\306F\3001\30C7\30D5\30A9\30EB\30C8\306EOracle\30B9\30AD\30FC\30DE\3067\3042\308B\304B\3001\307E\305F\306F\30B5\30A4\30C8\56FA\6709\306E\30DD\30EA\30B7\30FC\306B\3088\3063\3066\5236\9650\3055\308C\3066\3044\307E\3059\3002\5236\9650\4ED8\304D\30B9\30AD\30FC\30DE\3092\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306B\5272\308A\5F53\3066\308B\3053\3068\306F\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104765974388309063)
,p_name=>'F4050.RETRY SCHEDULED'
,p_message_language=>'ja'
,p_message_text=>unistr('\518D\8A66\884C\30B9\30B1\30B8\30E5\30FC\30EB\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104045481202308471)
,p_name=>'F4050.REUSE_SCHEMA'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E2\5B58\306E\30B9\30AD\30FC\30DE\304C\518D\5229\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104766070077309063)
,p_name=>'F4050.RUNNING'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9F\884C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104765705381309062)
,p_name=>'F4050.SCHEDULED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30B1\30B8\30E5\30FC\30EB\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104013166056308445)
,p_name=>'F4050.SCHEMA_ASSIGNED'
,p_message_language=>'ja'
,p_message_text=>unistr('\8B66\544A: \30EA\30AF\30A8\30B9\30C8\3057\305F\30B9\30AD\30FC\30DE\306F\3059\3067\306B1\3064\4EE5\4E0A\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306B\5272\308A\5F53\3066\3089\308C\3066\3044\307E\3059\3002\3053\306E\30EA\30AF\30A8\30B9\30C8\3092\627F\8A8D\3059\308B\524D\306B\3001\30B5\30A4\30C8\306E\30BB\30AD\30E5\30EA\30C6\30A3\30FB\30DD\30EA\30B7\30FC\3067\3001\540C\3058\30B9\30AD\30FC\30DE\3078\306E\8907\6570\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306E\30A2\30AF\30BB\30B9\304C\8A31\53EF\3055\308C\3066\3044\308B\3053\3068\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104013078416308445)
,p_name=>'F4050.SCHEMA_EXISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\8B66\544A: \30EA\30AF\30A8\30B9\30C8\3057\305F\30B9\30AD\30FC\30DE\306F\3059\3067\306B\5B58\5728\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104045797932308472)
,p_name=>'F4050.SCHEMA_NOT_EXIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AD\30FC\30DE\304C\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104045933765308472)
,p_name=>'F4050.SCHEMA_RESERVED_NO_WARN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AD\30FC\30DE\304C\4E88\7D04\6E08\306E\305F\3081\3001\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306B\5272\308A\5F53\3066\3089\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104013296921308445)
,p_name=>'F4050.SCHEMA_RESTRICTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\8B66\544A: \30EA\30AF\30A8\30B9\30C8\3057\305F\30B9\30AD\30FC\30DE\306F\3001\30C7\30D5\30A9\30EB\30C8\306EOracle\30B9\30AD\30FC\30DE\3067\3042\308B\304B\3001\307E\305F\306F\30B5\30A4\30C8\56FA\6709\306E\30DD\30EA\30B7\30FC\306B\3088\3063\3066\5236\9650\3055\308C\3066\3044\307E\3059\3002\3053\306E\30B9\30AD\30FC\30DE\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9\3078\306E\5272\5F53\3066\3092\7D9A\884C\3059\308B\5834\5408\3001\305D\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9\5185\306E\958B\767A\8005\306B\30B9\30AD\30FC\30DE\3078\306E\5B8C\5168\306A\30A2\30AF\30BB\30B9\6A29\3092\4ED8\4E0E\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\3053\306E\30EA\30AF\30A8\30B9\30C8\3092\627F\8A8D\3059\308B\524D\306B\3001\305D\306E\64CD\4F5C\304C\30B5\30A4\30C8\306E\30BB\30AD\30E5\30EA\30C6\30A3\30FB\30DD\30EA\30B7\30FC\306B\9055\53CD\3057\306A\3044\3053\3068\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104045872412308472)
,p_name=>'F4050.SCHEMA_RESTRICTED_NO_WARN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AD\30FC\30DE\306F\30BB\30AD\30E5\30EA\30C6\30A3\30FB\30DD\30EA\30B7\30FC\306B\3088\3063\3066\5236\9650\3055\308C\3066\3044\307E\3059\3002\5236\9650\4ED8\304D\30B9\30AD\30FC\30DE\3092\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306B\5272\308A\5F53\3066\308B\3053\3068\306F\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104014702402308446)
,p_name=>'F4050.SERVICE_TERMINATED_EMAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30FC\30D3\30B9\306F\7D42\4E86\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104014878302308446)
,p_name=>'F4050.SERVICE_TERMINATED_EMAIL_BODY'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\767A\30B5\30FC\30D3\30B9"%0"\306F\7D42\4E86\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104766500919309063)
,p_name=>'F4050.SUCCEEDED'
,p_message_language=>'ja'
,p_message_text=>unistr('\6210\529F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104174898048308588)
,p_name=>'F4050.SUSPENDED'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E2D\65AD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104174932599308588)
,p_name=>'F4050.TERMINATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D42\4E86')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104175429335308588)
,p_name=>'F4050.TERMINATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D42\4E86')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104765658045309062)
,p_name=>'F4050.TERMINATION_IN_PROGRESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D42\4E86\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103940501401308390)
,p_name=>'F4050.VIEW_REQUEST'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30AF\30A8\30B9\30C8\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103940926269308390)
,p_name=>'F4050.WORKSPACE_EXPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306E\30A8\30AF\30B9\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103706984879308173)
,p_name=>'F4050.WORKSPACE_HOME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\30FB\30DB\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103707024270308173)
,p_name=>'F4050.WORKSPACE_LOGIN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\30FB\30ED\30B0\30A4\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104010783690308443)
,p_name=>'F4050.WSID_EXISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3067\306B\540C\3058ID\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9\304C\5B58\5728\3059\308B\306E\3067\4F5C\6210\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104010632827308443)
,p_name=>'F4050.WSNAME_EXISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3067\306B\540C\3058\540D\524D\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9\304C\5B58\5728\3059\308B\306E\3067\4F5C\6210\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103783520988308234)
,p_name=>'F4050.WS_CREATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9%0\304C%1\306B\4F5C\6210\3055\308C\3001\767B\9332\6642\306B\6307\5B9A\3057\305F\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9\306B\78BA\8A8D\304C\9001\4FE1\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103612749746308097)
,p_name=>'F4050.WS_EXISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306F\3001\3059\3067\306B\5B58\5728\3059\308B\305F\3081\4F5C\6210\3055\308C\307E\305B\3093\3067\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103612859052308097)
,p_name=>'F4050.WS_TOBE_CREATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\304C\4F5C\6210\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103847998443308284)
,p_name=>'F4050_EMAIL_BODY_NEW_PASSWORD'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F\30D1\30B9\30EF\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103847806465308284)
,p_name=>'F4050_EMAIL_BODY_PASSWORD_CHANGED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC%0\306B\5BFE\3057\3066\30A2\30AB\30A6\30F3\30C8\306E\30D1\30B9\30EF\30FC\30C9\304C\5909\66F4\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103847708116308284)
,p_name=>'F4050_EMAIL_SUBJECT_PASSWORD_CHANGED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30B9\30EF\30FC\30C9\304C\5909\66F4\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104730859904309027)
,p_name=>'F4050_P158_INTRO_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DA\30FC\30B8\306F\3001\6B21\306E\30EA\30EA\30FC\30B9\304C\4F7F\7528\53EF\80FD\306B\306A\308B\3068%0\304C\3059\3050\306B\30A2\30C3\30D7\30B0\30EC\30FC\30C9\3055\308C\308B\306E\304B\3001\30A2\30C3\30D7\30B0\30EC\30FC\30C9\304C\6700\5927%1\65E5\9593\9045\5EF6\3059\308B\306E\304B\3092\5236\5FA1\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104730973522309027)
,p_name=>'F4050_P158_UPGRADE_NOW'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\3067\306F\306A\304F\4ECA\3059\3050\30A2\30C3\30D7\30B0\30EC\30FC\30C9\3092\958B\59CB\3059\308B\306B\306F\3001\300C\5373\6642\30A2\30C3\30D7\30B0\30EC\30FC\30C9\300D\3092\30AF\30EA\30C3\30AF\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104730595724309026)
,p_name=>'F4050_P3_SYSTEM_UP_TO_DATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30B9\30C6\30E0\306F\6700\65B0\3067\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104730696971309026)
,p_name=>'F4050_P3_UPGRADE_AVAILABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('%0 %1\304C<a href="%2" target="_blank" rel="noreferrer">\4F7F\7528\53EF\80FD</a>\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104729695459309025)
,p_name=>'F4050_P3_UPGRADE_DEFERRED_N'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\3057\3044%0\30EA\30EA\30FC\30B9\304C\4F7F\7528\53EF\80FD\306B\306A\308B\3068\3001\30A4\30F3\30B9\30BF\30F3\30B9\306F<strong>\3059\3050\306B</strong>\30A2\30C3\30D7\30B0\30EC\30FC\30C9\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104730357570309026)
,p_name=>'F4050_P3_UPGRADE_DEFERRED_P'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30B9\30BF\30F3\30B9\306F<strong>%0</strong>\306B\81EA\52D5\7684\306B\30A2\30C3\30D7\30B0\30EC\30FC\30C9\3055\308C\307E\3059\3002\4ECA\3059\3050\30A2\30C3\30D7\30B0\30EC\30FC\30C9\3059\308B\306B\306F\3001\6B6F\8ECA\30A2\30A4\30B3\30F3\3092\30AF\30EA\30C3\30AF\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104729519068309025)
,p_name=>'F4050_P3_UPGRADE_DEFERRED_Y'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30B9\30BF\30F3\30B9\306E%0\30A2\30C3\30D7\30B0\30EC\30FC\30C9\306F<strong>\9045\5EF6\3057\3066\3044\307E\3059</strong>\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104271534058308661)
,p_name=>'F4050_P3_UPGRADING'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\3001\73FE\5728%1\306B\30A2\30C3\30D7\30B0\30EC\30FC\30C9\3055\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103599610162308087)
,p_name=>'F4050_P74_PROVISION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D5\30A1\30A4\30EB%2\3092\4F7F\7528\3057\3066\30C7\30D5\30A9\30EB\30C8\306E\8868\9818\57DF%1\3067\4F5C\6210\3055\308C\305F\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30E6\30FC\30B6\30FC%0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103616494808308100)
,p_name=>'F4050_P74_PROVISION1'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9%0\306F\3001\7BA1\7406\8005%1\306B\3088\3063\3066\30D7\30ED\30D3\30B8\30E7\30CB\30F3\30B0\6E08\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103748255397308206)
,p_name=>'F4050_SHOW_ALL_WORKSPACES'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306E\8868\793A')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103739581244308199)
,p_name=>'F4300.COL_LENGTH_NOT_NULL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\9577\306FNULL\306B\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103739486616308199)
,p_name=>'F4300.COL_LENGTH_NOT_ZERO'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\9577\306F0(\30BC\30ED)\306B\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103739735874308199)
,p_name=>'F4300.COL_NAMES_NOT_LONGER_THAN_30'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\540D\306F%0\6587\5B57\3092\8D85\3048\3066\6307\5B9A\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103739840108308199)
,p_name=>'F4300.COL_NAMES_NOT_NULL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\540D\306FNULL\306B\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103740321678308200)
,p_name=>'F4300.F4500.NAME_ALREADY_USED'
,p_message_language=>'ja'
,p_message_text=>unistr('<strong>%0</strong>\306F\3001\65E2\5B58\306E\30AA\30D6\30B8\30A7\30AF\30C8\3067\3059\3067\306B\4F7F\7528\3055\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103740598055308200)
,p_name=>'F4300.F4500.NOT_VALID_SEQ_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('<strong>%0</strong>\306F\3001\6709\52B9\306A\9806\5E8F\540D\3067\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103739155110308199)
,p_name=>'F4300.F4500.TABLE_ALREADY_EXISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\540D\304C\3059\3067\306B\5B58\5728\3057\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103740114866308200)
,p_name=>'F4300.NOT_VALID_PK_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('<strong>%0</strong>\306F\3001\6709\52B9\306A\4E3B\30AD\30FC\540D\3067\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103958273585308404)
,p_name=>'F4300.P180_FILE_FORMAT'
,p_message_language=>'ja'
,p_message_text=>'DOS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103929275583308381)
,p_name=>'F4300.SPREADSHEET_IMPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30D7\30EC\30C3\30C9\30B7\30FC\30C8\306E\30A4\30F3\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103740019630308200)
,p_name=>'F4300.TABLE_NAMES_NOT_LONGER_THAN_30'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\540D\306F%0\6587\5B57\672A\6E80\306B\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103750741071308208)
,p_name=>'F4300_INSTRUCT_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('1\884C\76EE\306E\30C7\30FC\30BF\306B\5217\540D\304C\542B\307E\308C\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104076577206308497)
,p_name=>'F4300_TEXT_IMPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8\306E\30A4\30F3\30DD\30FC\30C8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103776537685308229)
,p_name=>'F4350.APPLICATION_OWNER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\6240\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103939228906308389)
,p_name=>'F4350.AVAILABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('(\4F7F\7528\53EF\80FD)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103939084525308389)
,p_name=>'F4350.CHANGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5909\66F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104114127042308528)
,p_name=>'F4350.CONFIRM_SCHEMA_EXISTING'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E2\5B58\306E\30B9\30AD\30FC\30DE%0\3092\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306B\5272\308A\5F53\3066\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104114222141308528)
,p_name=>'F4350.CONFIRM_SCHEMA_NEW'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AD\30FC\30DE%0\3092\4F5C\6210\3057\3066\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306B\5272\308A\5F53\3066\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103938708973308389)
,p_name=>'F4350.CREATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103782651419308233)
,p_name=>'F4350.CREATING_WORKSPACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306E\4F5C\6210\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103939139245308389)
,p_name=>'F4350.CURRENT'
,p_message_language=>'ja'
,p_message_text=>unistr('(\30AB\30EC\30F3\30C8)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103777022415308229)
,p_name=>'F4350.CURRENT_TIME_ON_SERVER'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\6642\9593(\30B5\30FC\30D0\30FC\4E0A)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103776886976308229)
,p_name=>'F4350.CURRENT_USER'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\884C\30E6\30FC\30B6\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103938929140308389)
,p_name=>'F4350.DELETE'
,p_message_language=>'ja'
,p_message_text=>unistr('\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103783721349308234)
,p_name=>'F4350.DISABLE.WORK.PROV'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306E\4F5C\6210\304C\4E00\6642\7684\306B\7121\52B9\306B\306A\3063\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103776449435308229)
,p_name=>'F4350.HOST_SCHEMA'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DB\30B9\30C8\30FB\30B9\30AD\30FC\30DE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103938472091308389)
,p_name=>'F4350.INSERTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\633F\5165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103776988352308229)
,p_name=>'F4350.LANGUAGE_PREFERENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A00\8A9E\30D7\30EA\30D5\30A1\30EC\30F3\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103776353834308228)
,p_name=>'F4350.LAST_DDL_TIME'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\7D42DDL\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104260140839308653)
,p_name=>'F4350.LAST_PATCH_TIME'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\7D42\30D1\30C3\30C1\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103583235555308075)
,p_name=>'F4350.MORE'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\4EE5\4E0A...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104260048954308653)
,p_name=>'F4350.PATCH_VERSION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30C3\30C1\30FB\30D0\30FC\30B8\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103776194887308228)
,p_name=>'F4350.PRODUCT_BUILD'
,p_message_language=>'ja'
,p_message_text=>unistr('\88FD\54C1\306E\30D0\30FC\30B8\30E7\30F3\60C5\5831')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104307979737308688)
,p_name=>'F4350.RESET'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30BB\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103776235403308228)
,p_name=>'F4350.SCHEMA_COMPATIBILITY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AD\30FC\30DE\4E92\63DB\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103583164970308075)
,p_name=>'F4350.TRANSLATED_APPLICATIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('(+%0\7FFB\8A33\6E08\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103938675823308389)
,p_name=>'F4350.UNKNOWN'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0D\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103938524534308389)
,p_name=>'F4350.UPDATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F4\65B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103776696858308229)
,p_name=>'F4350.WORKSPACE_ID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103776732924308229)
,p_name=>'F4350.WORKSPACE_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104484884877308820)
,p_name=>'F4350_AJAX'
,p_message_language=>'ja'
,p_message_text=>'AJAX'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104484791686308820)
,p_name=>'F4350_AUTHENTICATION_CALLBACK'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\30B3\30FC\30EB\30D0\30C3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103940197904308390)
,p_name=>'F4350_CLICKTHRU_LOG_ENTRIES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30EA\30C3\30AF\30B9\30EB\30FC\30FB\30ED\30B0\306E\30A8\30F3\30C8\30EA:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103940027390308390)
,p_name=>'F4350_DEV_LOG_ENTRIES'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\767A\8005\30A2\30AF\30C6\30A3\30D3\30C6\30A3\30FB\30ED\30B0\306E\30A8\30F3\30C8\30EA:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103940657292308390)
,p_name=>'F4350_DISTINCT_USERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30C3\30B7\30E7\30F3\5168\4F53\306E\500B\5225\30E6\30FC\30B6\30FC=%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103941049601308390)
,p_name=>'F4350_NO_USER_SELECTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\304C\9078\629E\3055\308C\3066\3044\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103941380347308391)
,p_name=>'F4350_PREFS_EXISTS_FOR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\300C%2\300D\306E%1\30E6\30FC\30B6\30FC\7528\306B%0\30D7\30EA\30D5\30A1\30EC\30F3\30B9\304C\5B58\5728\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103557561743308057)
,p_name=>'F4350_PREFS_EXISTS_FOR2'
,p_message_language=>'ja'
,p_message_text=>unistr('%1\30E6\30FC\30B6\30FC\7528\306B%0\30D7\30EA\30D5\30A1\30EC\30F3\30B9\304C\5B58\5728\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103939856430308390)
,p_name=>'F4350_RESET_PREFS'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E8B\524D\306B\8A2D\5B9A\3055\308C\305F\5024\3092\4F7F\7528\3057\306A\3044\3067\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\5B9F\884C\3059\308B\5834\5408\306F\3001\30D7\30EA\30D5\30A1\30EC\30F3\30B9\3092\30EA\30BB\30C3\30C8\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103614538727308098)
,p_name=>'F4350_RESET_SESSION'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E8B\524D\306B\8A2D\5B9A\3055\308C\305F\5024\3092\4F7F\7528\3057\306A\3044\3067\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\5B9F\884C\3059\308B\5834\5408\306F\3001\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\3092\30EA\30BB\30C3\30C8\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103941479021308391)
,p_name=>'F4350_SELECTED_USER'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3057\305F\30E6\30FC\30B6\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103940763574308390)
,p_name=>'F4350_SESSIONS_OLDER_THAN'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\65E5\4EE5\4E0A\524D\306E\30BB\30C3\30B7\30E7\30F3=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103940863187308390)
,p_name=>'F4350_SESSIONS_OLDER_THAN_MINS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\5206\4EE5\4E0A\524D\306E\30BB\30C3\30B7\30E7\30F3=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103939344325308389)
,p_name=>'F4350_SESSION_STATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30C3\30B7\30E7\30F3\306F\3001%0\306B\3088\3063\3066\8B58\5225\3055\308C\3001%1\30A8\30F3\30C8\30EA\3092\542B\3093\3067\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103942083332308391)
,p_name=>'F4350_SQL'
,p_message_language=>'ja'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103941264144308391)
,p_name=>'F4350_SUMMARY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30DE\30EA\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103940458806308390)
,p_name=>'F4350_TOTAL_SESSIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\300C%0\300D\306E\30BB\30C3\30B7\30E7\30F3\306E\5408\8A08\306F%1\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103557432567308057)
,p_name=>'F4350_TOTAL_SESSIONS2'
,p_message_language=>'ja'
,p_message_text=>unistr('\5408\8A08\30BB\30C3\30B7\30E7\30F3: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103941566961308391)
,p_name=>'F4350_USER_HAS_X_PREFS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC%0\306B\306F%1\30D7\30EA\30D5\30A1\30EC\30F3\30B9\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103939794757308389)
,p_name=>'F4350_USER_PREFS'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\884C\30E6\30FC\30B6\30FC%0\306B\306F%1\30D7\30EA\30D5\30A1\30EC\30F3\30B9\304C\8A2D\5B9A\3055\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103941654183308391)
,p_name=>'F4350_WORKSPACE_SCHEMAS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\30FB\30B9\30AD\30FC\30DE')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103944174386308393)
,p_name=>'F4500.DISPLAY_SEQ_IN_FORM_NUMERIC'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\30D5\30A9\30FC\30E0\3067\306E\8868\793A\9806\5E8F\300D\306F\6570\5024\3067\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103944241820308393)
,p_name=>'F4500.DISPLAY_SEQ_IN_REPORT_NUMERIC'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\30EC\30DD\30FC\30C8\3067\306E\8868\793A\9806\5E8F\300D\306F\6570\5024\3067\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103747649313308206)
,p_name=>'F4500.DUP_ARG_NAMES'
,p_message_language=>'ja'
,p_message_text=>unistr('\5F15\6570\540D<strong>%0</strong>\306F\3001\3053\306E\30D5\30A1\30F3\30AF\30B7\30E7\30F3\3067\8907\6570\56DE\4F7F\7528\3055\308C\3066\3044\307E\3059\3002<br/>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103947299540308395)
,p_name=>'F4500.EXECUTION_ORDER_MAND'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\5B9F\884C\9806\5E8F\300D\306B\5024\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103947116053308395)
,p_name=>'F4500.EXECUTION_ORDER_NUMERIC'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\5B9F\884C\9806\5E8F\300D\306F\6570\5024\3067\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103930007376308382)
,p_name=>'F4500.FIND'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103958481772308404)
,p_name=>'F4500.HIDE_SQL'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\3092\975E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103930426880308382)
,p_name=>'F4500.MAGNIFY'
,p_message_language=>'ja'
,p_message_text=>unistr('\62E1\5927')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103930340070308382)
,p_name=>'F4500.MOVE_COLUMN_DOWN'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\3092\4E0B\306B\79FB\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103930232200308382)
,p_name=>'F4500.MOVE_COLUMN_UP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\3092\4E0A\306B\79FB\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103741376802308201)
,p_name=>'F4500.NEED_UNIQUE_EXECUTION_ORDER'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E00\610F\306E\5B9F\884C\9806\5E8F\756A\53F7\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103542584701308046)
,p_name=>'F4500.NEW_COLUMNS'
,p_message_language=>'ja'
,p_message_text=>unistr('\8FFD\52A0\3059\308B\65B0\898F\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103740995607308200)
,p_name=>'F4500.NOT_VALID_OBJECT_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('<strong>%0</strong>\306F\3001\6709\52B9\306A\30AA\30D6\30B8\30A7\30AF\30C8\540D\3067\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103740716092308200)
,p_name=>'F4500.NOT_VALID_TABLE_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('<strong>%0</strong>\306F\3001\6709\52B9\306A\8868\540D\3067\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103930104847308382)
,p_name=>'F4500.NO_IMAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30E1\30FC\30B8\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103930567079308382)
,p_name=>'F4500.NULLABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('NULL\5024\53EF\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104043836502308470)
,p_name=>'F4500.P40.PREVIOUS.RUNS'
,p_message_language=>'ja'
,p_message_text=>unistr('\4EE5\524D\306E\5B9F\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103747197472308205)
,p_name=>'F4500.P602.DUP_COL_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\540D<strong>%0</strong>\306F\3001\3053\306E\8868\3067\8907\6570\56DE\4F7F\7528\3055\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103747562786308205)
,p_name=>'F4500.P602.ENTER_AT_LEAST_ONE_COL'
,p_message_language=>'ja'
,p_message_text=>unistr('1\3064\4EE5\4E0A\306E\5217\306E\540D\524D\3092\5165\529B\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103747478562308205)
,p_name=>'F4500.P602.INVALID_COL_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\540D<strong>%0</strong>\304C\7121\52B9\3067\3059\3002<br />')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103747260303308205)
,p_name=>'F4500.P602.INVALID_PRECISION'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217<strong>%0</strong>\306E\7CBE\5EA6\304C\7121\52B9\3067\3059\3002<br/>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103747324692308205)
,p_name=>'F4500.P602.INVALID_SCALE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217<strong>%0</strong>\306E\30B9\30B1\30FC\30EB\304C\7121\52B9\3067\3059\3002<br/>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103597649792308086)
,p_name=>'F4500.P602.SCALE_REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217<strong>%0</strong>\306E\30B9\30B1\30FC\30EB\304C\5FC5\8981\3067\3059\3002<br/>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103958557460308404)
,p_name=>'F4500.P99.CREATE_SYNONYM_ON'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30CE\30CB\30E0\306E\4F5C\6210\5BFE\8C61')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103958341785308404)
,p_name=>'F4500.SHOW_SQL'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103741029319308200)
,p_name=>'F4500.TABLE_NOT_FOUND_IN_SCHEMA'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AD\30FC\30DE<strong>%1</strong>\5185\306B\8868<strong>%0</strong>\304C\898B\3064\304B\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103546693359308049)
,p_name=>'F4500.WARNING_STATEMENTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\8B66\544A\6587')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103943252370308392)
,p_name=>'F4500_BROKEN'
,p_message_language=>'ja'
,p_message_text=>unistr('\7834\640D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103943723064308393)
,p_name=>'F4500_BYTES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D0\30A4\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103943648318308393)
,p_name=>'F4500_CARD'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103943013300308392)
,p_name=>'F4500_CHECK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30A7\30C3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103935536593308386)
,p_name=>'F4500_CLICK_POP_QUERY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30EA\30C3\30AF\3057\3066\554F\5408\305B\30D5\30A3\30FC\30EB\30C9\3092\79FB\5165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103943588270308392)
,p_name=>'F4500_COST'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103934857979308386)
,p_name=>'F4500_CREATE_SUCCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F5C\6210\64CD\4F5C\304C\6B63\5E38\306B\5B9F\884C\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104712906232309011)
,p_name=>'F4500_DICTIONARY_OBJECTS_WO_DEFAULTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\5024\3092\4F7F\7528\3057\306A\3044\30AA\30D6\30B8\30A7\30AF\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104712820260309011)
,p_name=>'F4500_DICTIONARY_OBJECTS_W_DEFAULTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\5024\3092\4F7F\7528\3059\308B\30AA\30D6\30B8\30A7\30AF\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103934136172308385)
,p_name=>'F4500_DROP_SUCCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\524A\9664\64CD\4F5C\304C\6B63\5E38\306B\5B9F\884C\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103586635561308078)
,p_name=>'F4500_FOREIGN'
,p_message_language=>'ja'
,p_message_text=>unistr('\5916\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103848165113308284)
,p_name=>'F4500_FOREIGN_KEY'
,p_message_language=>'ja'
,p_message_text=>unistr('\5916\90E8\30AD\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103747988199308206)
,p_name=>'F4500_NATIVE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CD\30A4\30C6\30A3\30D6\30FB\30D5\30A1\30A4\30EB\5F62\5F0F\3067\4FDD\5B58\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103933879915308385)
,p_name=>'F4500_NOT_AVAIL_EDIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7DE8\96C6\3067\304D\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103943381964308392)
,p_name=>'F4500_NOT_AVAIL_SEARCH'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22\3067\304D\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103943165280308392)
,p_name=>'F4500_OF'
,p_message_language=>'ja'
,p_message_text=>'/'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103943445358308392)
,p_name=>'F4500_OPTIMIZER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30D7\30C6\30A3\30DE\30A4\30B6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103935860658308386)
,p_name=>'F4500_OP_SUCCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\64CD\4F5C\304C\6B63\5E38\306B\5B9F\884C\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103923579391308377)
,p_name=>'F4500_P1000_NO_WS_MESSAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\30FB\30E1\30C3\30BB\30FC\30B8\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104076458839308497)
,p_name=>'F4500_P101_NO_VARCHAR'
,p_message_language=>'ja'
,p_message_text=>unistr('VARCHAR\5217\578B\304C\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103620801478308103)
,p_name=>'F4500_P1023_PARSING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AF\30EA\30D7\30C8\3092\89E3\6790\4E2D\3067\3059 - \304A\5F85\3061\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103567563137308064)
,p_name=>'F4500_P10_NUM_STMTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6587\306E\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103809301181308254)
,p_name=>'F4500_P10_ON_BY'
,p_message_language=>'ja'
,p_message_text=>'%0 - %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103931229330308383)
,p_name=>'F4500_P10_PARAMETERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AF\30EA\30D7\30C8\306B\30D1\30E9\30E1\30FC\30BF\304C\3042\308B\5834\5408\306F\3001\5B9F\884C\3059\308B\524D\306B\305D\308C\3089\3092\5B9A\7FA9\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103567447352308064)
,p_name=>'F4500_P10_SCRIPT_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AF\30EA\30D7\30C8\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103809238487308254)
,p_name=>'F4500_P10_SCRIPT_SIZE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AF\30EA\30D7\30C8\30FB\30B5\30A4\30BA(\30D0\30A4\30C8)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103805535991308251)
,p_name=>'F4500_P10_UPDATED_BY'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F4\65B0\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103931464636308383)
,p_name=>'F4500_P10_VALUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104090167120308508)
,p_name=>'F4500_P115.CONFIRM'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\30B9\30AF\30EA\30D7\30C8\3092\30A4\30F3\30DD\30FC\30C8\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002\30EA\30AF\30A8\30B9\30C8\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104090217547308508)
,p_name=>'F4500_P115.ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30DD\30FC\30C8\3092\30EA\30AF\30A8\30B9\30C8\3057\305F\30B9\30AF\30EA\30D7\30C8\306F\8A18\61B6\57DF\306E\6700\5927\30B5\30A4\30BA\3092\8D85\3048\3066\3044\307E\3059\3002%0\306E\7BA1\7406\8005\306B\9023\7D61\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104091242787308509)
,p_name=>'F4500_P115.SCRIPTS_TO_INSTALL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30DD\30FC\30C8\3059\308B\30B9\30AF\30EA\30D7\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103931940232308383)
,p_name=>'F4500_P11_NO_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103931765358308383)
,p_name=>'F4500_P11_NUM'
,p_message_language=>'ja'
,p_message_text=>unistr('\6570\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103911662600308336)
,p_name=>'F4500_P1224_VIEW_OUTPUT'
,p_message_language=>'ja'
,p_message_text=>unistr('\51FA\529B\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103992576841308430)
,p_name=>'F4500_P129_BROWSE_SEQ'
,p_message_language=>'ja'
,p_message_text=>unistr('\9806\5E8F\3092\53C2\7167')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103992657493308430)
,p_name=>'F4500_P129_NO_SUCCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\304C\539F\56E0\3067\3001\9806\5E8F\4F5C\6210\64CD\4F5C\304C\6B63\5E38\306B\5B9F\884C\3055\308C\307E\305B\3093\3067\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103992416747308430)
,p_name=>'F4500_P129_SEQUENCE_CREATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C%1\300D\30B9\30AD\30FC\30DE\306B\3001\9806\5E8F\300C%0\300D\304C\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103932189820308384)
,p_name=>'F4500_P12_STATEMENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6587')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103992973036308430)
,p_name=>'F4500_P130_BROWSE_DB_SYN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30B7\30CE\30CB\30E0\3092\53C2\7167')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103993178261308430)
,p_name=>'F4500_P130_CREATE_NOT_SUCCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\304C\539F\56E0\3067\3001\30B7\30CE\30CB\30E0\4F5C\6210\64CD\4F5C\304C\6B63\5E38\306B\5B9F\884C\3055\308C\307E\305B\3093\3067\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103992883810308430)
,p_name=>'F4500_P130_SYNONYM_CREATE_SUCCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C%1\300D\30B9\30AD\30FC\30DE\306B\3001\30B7\30CE\30CB\30E0\300C%0\300D\304C\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103993296097308430)
,p_name=>'F4500_P132_CREATE_FAILED'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\304C\539F\56E0\3067\3001\30D1\30C3\30B1\30FC\30B8\4F5C\6210\64CD\4F5C\304C\6B63\5E38\306B\5B9F\884C\3055\308C\307E\305B\3093\3067\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103993300326308430)
,p_name=>'F4500_P132_PACKAGE_CREATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C%1\300D\30B9\30AD\30FC\30DE\306B\3001\30D1\30C3\30B1\30FC\30B8\300C%0\300D\304C\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103774900924308227)
,p_name=>'F4500_P24_SAVE_TO_WORKSHEET'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B7\30FC\30C8\306B\4FDD\5B58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103932493893308384)
,p_name=>'F4500_P25_BY'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F5C\6210\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103932353283308384)
,p_name=>'F4500_P25_CREATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103932260453308384)
,p_name=>'F4500_P25_FILE_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103588369031308079)
,p_name=>'F4500_P2610_EXPIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\671F\9650\5207\308C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103588409171308079)
,p_name=>'F4500_P2610_EXPIRED_AND_LOCKED'
,p_message_language=>'ja'
,p_message_text=>unistr('\671F\9650\5207\308C\304A\3088\3073\30ED\30C3\30AF\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103588236699308079)
,p_name=>'F4500_P2610_LOCKED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30C3\30AF\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103588128421308079)
,p_name=>'F4500_P2610_OPEN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30FC\30D7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103992360628308430)
,p_name=>'F4500_P402_OPERATION_FAILED'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\304C\539F\56E0\3067\3001\64CD\4F5C\304C\6B63\5E38\306B\5B9F\884C\3055\308C\307E\305B\3093\3067\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103969402009308412)
,p_name=>'F4500_P51_NOT_AVAIL_INSERT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\3092\633F\5165\3067\304D\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103992233957308429)
,p_name=>'F4500_P54_BROWSE_VIEW'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30D3\30E5\30FC\3092\53C2\7167')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103991904605308429)
,p_name=>'F4500_P54_NOT_SUCCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\304C\539F\56E0\3067\3001\30D3\30E5\30FC\4F5C\6210\64CD\4F5C\304C\6B63\5E38\306B\5B9F\884C\3055\308C\307E\305B\3093\3067\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103992026518308429)
,p_name=>'F4500_P54_SQL_WORKSHOP_HOME'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\30EF\30FC\30AF\30B7\30E7\30C3\30D7\30FB\30DB\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103992174153308429)
,p_name=>'F4500_P54_VIEW_CREATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C%1\300D\30B9\30AD\30FC\30DE\306B\3001\30D3\30E5\30FC\300C%0\300D\304C\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103960773757308406)
,p_name=>'F4500_P553_GET_COLUMN_COMMENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\30B3\30E1\30F3\30C8\3092\53D6\5F97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104118344285308532)
,p_name=>'F4500_P602_IDENTITY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C7\30F3\30C6\30A3\30C6\30A3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103619352366308102)
,p_name=>'F4500_P602_NO_DATATYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306B\30C7\30FC\30BF\578B\304C\6307\5B9A\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103933934879308385)
,p_name=>'F4500_P68_TABLE_OP_SUCCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\64CD\4F5C\304C\6B63\5E38\306B\5B9F\884C\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103931066660308383)
,p_name=>'F4500_P6_STATEMENT_CNT'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30D5\30A1\30A4\30EB\306B\306F%0\6587\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103931115840308383)
,p_name=>'F4500_P6_USER_DEFINED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\304C\3001\6B21\306E%0\30D1\30E9\30E1\30FC\30BF\3092\5B9A\7FA9\6E08\3067\3059:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103748194693308206)
,p_name=>'F4500_PARSE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B9\30AF\30EA\30D7\30C8\3092\89E3\6790\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103942861795308392)
,p_name=>'F4500_PRIMARY'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E3B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103551799795308053)
,p_name=>'F4500_REFERENTIAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\53C2\7167')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103748053388308206)
,p_name=>'F4500_TEXT_FILE_FORMAT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C9\30AD\30E5\30E1\30F3\30C8\3092\30C6\30AD\30B9\30C8\3068\3057\3066\8868\793A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103942993095308392)
,p_name=>'F4500_UNIQUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E00\610F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104792371382309082)
,p_name=>'F4550.STATIC_FILES_NOT_CONFIGURED'
,p_message_language=>'ja'
,p_message_text=>unistr('\74B0\5883\5185\306E\9759\7684\30D5\30A1\30A4\30EB\306E\69CB\6210\306B\554F\984C\304C\3042\308A\307E\3059\3002Application Express\30A4\30F3\30B9\30C8\30EC\30FC\30B7\30E7\30F3\30FB\30AC\30A4\30C9\306E\9759\7684\30D5\30A1\30A4\30EB\30FB\30B5\30DD\30FC\30C8\69CB\6210\306B\95A2\3059\308B\9805\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104135714755308546)
,p_name=>'F4550.WELCOME_TO_APEX_ADB'
,p_message_language=>'ja'
,p_message_text=>unistr('Oracle APEX\3078\3088\3046\3053\305D\3002\81EA\5F8B\578B\30C7\30FC\30BF\30D9\30FC\30B9\306E\7BA1\7406\8005(ADMIN)\30D1\30B9\30EF\30FC\30C9\3092\4F7F\7528\3057\3066\30B5\30A4\30F3\30A4\30F3\3057\3066\304F\3060\3055\3044\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104788488817309079)
,p_name=>'F4700.ACCOUNT_REQ_EMAIL_BODY'
,p_message_language=>'ja'
,p_message_text=>unistr('Oracle APEX\30EF\30FC\30AF\30B9\30DA\30FC\30B9\3092\30EA\30AF\30A8\30B9\30C8\3057\305F\305F\3081\3001\3053\306E\96FB\5B50\30E1\30FC\30EB\3092\53D7\4FE1\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104788399995309079)
,p_name=>'F4700.ACCOUNT_REQ_EMAIL_SUBJ'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3\304C\5FC5\8981\3067\3059: %0\306B\5BFE\3059\308B\30A2\30AB\30A6\30F3\30C8\30FB\30EA\30AF\30A8\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104012075363308444)
,p_name=>'F4700.EMAIL_NOTE'
,p_message_language=>'ja'
,p_message_text=>unistr('(\8A3C\660E\66F8\306E\9001\4FE1\306B\4F7F\7528)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104012271934308444)
,p_name=>'F4700.EXISTING_SCHEMA_HINT'
,p_message_language=>'ja'
,p_message_text=>unistr('Oracle\30C7\30FC\30BF\30D9\30FC\30B9\306B\65E2\5B58\306E\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30B9\30AD\30FC\30DE\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002\30BB\30AD\30E5\30EA\30C6\30A3\4E0A\306E\7406\7531\304B\3089\3001LOV\306F\63D0\4F9B\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104012165674308444)
,p_name=>'F4700.NEW_SCHEMA_HINT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\7528\306B\4F5C\6210\3057\3066\304A\304FOracle\30C7\30FC\30BF\30D9\30FC\30B9\306E\30B9\30AD\30FC\30DE\540D\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104011482822308444)
,p_name=>'F4700.P26_JUSTIFY_RESTRICTED_SCHEMA'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6B21\306E\8AAC\660E\306B\3001\5236\9650\4ED8\304D\30B9\30AD\30FC\30DE\3092\30EA\30AF\30A8\30B9\30C8\3059\308B\7406\7531\3092\793A\3057\3066\304F\3060\3055\3044\3002'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104011572552308444)
,p_name=>'F4700.P26_JUSTIFY_SHARED_SCHEMA'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\8AAC\660E\306B\30011\3064\4EE5\4E0A\306E\4ED6\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9\3067\3059\3067\306B\4F7F\7528\4E2D\306E\30B9\30AD\30FC\30DE\3092\30EA\30AF\30A8\30B9\30C8\3059\308B\7406\7531\3092\793A\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104011933711308444)
,p_name=>'F4700.P26_WARN_RESTRICTED_SCHEMA'
,p_message_language=>'ja'
,p_message_text=>unistr('\8B66\544A: \30EA\30AF\30A8\30B9\30C8\3057\305F\30B9\30AD\30FC\30DE\306F\30BB\30AD\30E5\30EA\30C6\30A3\4E0A\306E\7406\7531\304B\3089\5236\9650\3055\308C\3066\3044\307E\3059\3002%0\306E\7BA1\7406\8005\306B\3088\3063\3066\3001\3053\306E\30B9\30AD\30FC\30DE\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9\3078\306E\5272\5F53\3066\30EA\30AF\30A8\30B9\30C8\304C\62D2\5426\3055\308C\308B\5834\5408\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104011824212308444)
,p_name=>'F4700.P26_WARN_SHARED_SCHEMA'
,p_message_language=>'ja'
,p_message_text=>unistr('\8B66\544A: \30EA\30AF\30A8\30B9\30C8\3057\305F\30B9\30AD\30FC\30DE\306F\3059\3067\306B\4ED6\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9\3067\4F7F\7528\3055\308C\3066\3044\307E\3059\3002%0\306E\7BA1\7406\8005\306B\3088\3063\3066\3001\3053\306E\30B9\30AD\30FC\30DE\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9\3078\306E\5272\5F53\3066\30EA\30AF\30A8\30B9\30C8\304C\62D2\5426\3055\308C\308B\5834\5408\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104008847034308442)
,p_name=>'F4700.SCHEMA_RESTRICTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\7528\306B\30EA\30AF\30A8\30B9\30C8\3057\305F\65B0\3057\3044\30B9\30AD\30FC\30DE\306F\3001\30C7\30D5\30A9\30EB\30C8\306EOracle\30B9\30AD\30FC\30DE\3067\3042\308B\304B\3001\307E\305F\306F\30BB\30AD\30E5\30EA\30C6\30A3\4E0A\306E\7406\7531\304B\3089\30B5\30A4\30C8\3067\7279\5225\306B\5236\9650\3055\308C\3066\3044\308B\305F\3081\3001\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306B\5272\308A\5F53\3066\308B\3053\3068\304C\3067\304D\307E\305B\3093\3002\30B5\30A4\30C8\306E\30BB\30AD\30E5\30EA\30C6\30A3\30FB\30DD\30EA\30B7\30FC\306B\9055\53CD\3059\308B\5834\5408\3001\30B5\30A4\30C8\7BA1\7406\8005\306B\3088\3063\3066\30D7\30ED\30D3\30B8\30E7\30CB\30F3\30B0\30FB\30EA\30AF\30A8\30B9\30C8\304C\62D2\5426\3055\308C\308B\5834\5408\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104008763637308442)
,p_name=>'F4700.SCHEMA_USED_BY_WORKSPACES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\7528\306B\30EA\30AF\30A8\30B9\30C8\3057\305F\30B9\30AD\30FC\30DE\306F\3059\3067\306B%0\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306B\5272\308A\5F53\3066\3089\308C\3066\3044\307E\3059\3002\30B5\30A4\30C8\306E\30BB\30AD\30E5\30EA\30C6\30A3\30FB\30DD\30EA\30B7\30FC\306B\9055\53CD\3059\308B\5834\5408\3001\30B5\30A4\30C8\7BA1\7406\8005\306B\3088\3063\3066\30D7\30ED\30D3\30B8\30E7\30CB\30F3\30B0\30FB\30EA\30AF\30A8\30B9\30C8\304C\62D2\5426\3055\308C\308B\5834\5408\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103584047489308076)
,p_name=>'F4700P1_A'
,p_message_language=>'ja'
,p_message_text=>unistr('Oracle APEX\3067\306F\3001Oracle\30C7\30FC\30BF\30D9\30FC\30B9\304A\3088\3073\30D6\30E9\30A6\30B6\30FB\30D9\30FC\30B9\306E\958B\767A\30C4\30FC\30EB\306B\30A2\30AF\30BB\30B9\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103584186760308076)
,p_name=>'F4700P1_B'
,p_message_language=>'ja'
,p_message_text=>unistr('\5BA3\8A00\7684\306BWeb\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\69CB\7BC9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103584285592308076)
,p_name=>'F4700P1_C'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30AA\30D6\30B8\30A7\30AF\30C8\306E\4F5C\6210\3068\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103584375642308076)
,p_name=>'F4700P1_D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30A4\30EB\30B9\30C8\30F3\3001\30D0\30B0\3001\6A5F\80FD\3068todo\306E\30C8\30E9\30C3\30AD\30F3\30B0<')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104722867188309019)
,p_name=>'F4750.P209.DB_APP_USER_SETUP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306F\6B63\5E38\306B\30A4\30F3\30B9\30C8\30FC\30EB\3055\308C\307E\3057\305F\3002\305F\3060\3057\3001Application Express\306E\30A2\30AB\30A6\30F3\30C8\8A8D\8A3C\3067\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\5B9F\884C\3059\308B\306B\306F\3001Application Express\30E6\30FC\30B6\30FC\30FB\30A2\30AB\30A6\30F3\30C8\3092\8A2D\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104722996539309019)
,p_name=>'F4750.P209.WEBSHEET_ADMIN_SETUP'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B7\30FC\30C8\306F\6B63\5E38\306B\30A4\30F3\30B9\30C8\30FC\30EB\3055\308C\307E\3057\305F\3002\305F\3060\3057\3001Application Express\306E\30A2\30AB\30A6\30F3\30C8\8A8D\8A3C\3067Web\30B7\30FC\30C8\3092\5B9F\884C\3059\308B\306B\306F\3001Application Express\306E\30A2\30AB\30A6\30F3\30C8\3092\6301\3064\7BA1\7406\8005\3092\8A2D\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104076665239308497)
,p_name=>'F4750.VERSION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D0\30FC\30B8\30E7\30F3')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104746989037309040)
,p_name=>'F4850.P1.SCHEMA_DOES_NOT_EXIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30F3\30D7\30EB\306ERESTful Services\30C7\30FC\30BF\3092\30EA\30BB\30C3\30C8\3067\304D\307E\305B\3093: \30B9\30AD\30FC\30DE<code>%0</code>\306F\5B58\5728\3057\307E\305B\3093\3002')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104321795773308698)
,p_name=>'F4900_P11_AUTH_TYPE_MESSAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\306F%0\8A8D\8A3C\30B9\30AD\30FC\30E0\304C\4F7F\7528\3055\308C\307E\3059\3002')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104356122102308724)
,p_name=>'FACETED_SEARCH'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30BB\30C3\30C8\691C\7D22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104329526239308704)
,p_name=>'FACETED_SEARCH.INVALID.SOURCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A6\30A3\30B6\30FC\30C9\3067\306F\30EC\30DD\30FC\30C8\30FB\30BD\30FC\30B9\3092\4F7F\7528\3057\3066\30D5\30A1\30BB\30C3\30C8\691C\7D22\3092\4F5C\6210\3067\304D\307E\305B\3093\3002\691C\7D22\3059\308B\5217\304C\3042\308A\307E\305B\3093\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104141370663308551)
,p_name=>'FAILURE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5931\6557')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103932617313308384)
,p_name=>'FAILURES'
,p_message_language=>'ja'
,p_message_text=>unistr('\5931\6557')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104007050089308441)
,p_name=>'FDASH1'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\6A5F\80FD')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104048549675308474)
,p_name=>'FEATURE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A5F\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104767383703309064)
,p_name=>'FEATURE OWNERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A5F\80FD\6240\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103721044673308184)
,p_name=>'FEATURE.ABOUT_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\60C5\5831\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103721709450308185)
,p_name=>'FEATURE.ABOUT_PAGE.DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\3064\3044\3066\300D\30DA\30FC\30B8\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103721106388308184)
,p_name=>'FEATURE.ACCESS_CONTROL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30BB\30B9\5236\5FA1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103721895024308185)
,p_name=>'FEATURE.ACCESS_CONTROL.DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30FC\30EB\30FB\30D9\30FC\30B9\30FB\30E6\30FC\30B6\30FC\8A8D\8A3C\3092\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\7D44\307F\8FBC\307F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30ED\30FC\30EB\3078\306E\30E6\30FC\30B6\30FC\540D\30DE\30C3\30D4\30F3\30B0\3092\7BA1\7406\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103721261496308184)
,p_name=>'FEATURE.ACTIVITY_REPORTING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30C6\30A3\30D3\30C6\30A3\30FB\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103721917798308185)
,p_name=>'FEATURE.ACTIVITY_REPORTING.DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\30FB\30A2\30AF\30C6\30A3\30D3\30C6\30A3\306B\95A2\3059\308B\591A\6570\306E\30EC\30DD\30FC\30C8\304A\3088\3073\30C1\30E3\30FC\30C8\3092\542B\3081\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103721328273308184)
,p_name=>'FEATURE.CONFIGURATION_OPTIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\69CB\6210\30AA\30D7\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103722782445308186)
,p_name=>'FEATURE.CONFIGURATION_OPTIONS.DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\7BA1\7406\8005\304C\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5185\304B\3089Application Express\30D3\30EB\30C9\30FB\30AA\30D7\30B7\30E7\30F3\306B\95A2\9023\4ED8\3051\3089\308C\305F\7279\5B9A\306E\6A5F\80FD\3092\6709\52B9\5316\307E\305F\306F\7121\52B9\5316\3067\304D\308B\3088\3046\306B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104020891176308451)
,p_name=>'FEATURE.CREATE_BUILD_OPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\30D3\30EB\30C9\30FB\30AA\30D7\30B7\30E7\30F3\304C\4F5C\6210\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104081534228308501)
,p_name=>'FEATURE.EMAIL_REPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\30FB\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104081620570308501)
,p_name=>'FEATURE.EMAIL_REPORT.DESCRIOTION'
,p_message_language=>'ja'
,p_message_text=>unistr('APEX_SEND()\96FB\5B50\30E1\30FC\30EB\30FB\30AD\30E5\30FC\306B\3042\308B\30EC\30DD\30FC\30C8\3092\542B\3081\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104138207405308548)
,p_name=>'FEATURE.EMAIL_REPORT.DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3067\306B\9001\4FE1\3055\308C\305F\96FB\5B50\30E1\30FC\30EB\306E\30ED\30B0\3068\7D50\5408\3057\3066\9001\4FE1\3055\308C\308B\30E1\30FC\30EB\3092\8868\793A\3059\308B\30EC\30DD\30FC\30C8\3092\542B\3081\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103721499719308185)
,p_name=>'FEATURE.FEEDBACK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30FC\30C9\30D0\30C3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103722046775308185)
,p_name=>'FEATURE.FEEDBACK.DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\4E00\822C\7684\306A\30B3\30E1\30F3\30C8\3092\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\7BA1\7406\8005\304A\3088\3073\958B\767A\8005\306B\9001\4FE1\3059\308B\305F\3081\306E\30E1\30AB\30CB\30BA\30E0\3092\63D0\4F9B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104081717096308501)
,p_name=>'FEATURE.JOB_REPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B8\30E7\30D6\30FB\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104081826162308501)
,p_name=>'FEATURE.JOB_REPORT.DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\7279\5B9A\306E\30B8\30E7\30D6\3092\30C9\30EA\30EB\30C0\30A6\30F3\3057\3066\8A73\7D30\3092\8868\793A\3067\304D\308B\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30B8\30E7\30D6\306B\95A2\3059\308B\30EC\30DD\30FC\30C8\3092\542B\3081\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103721561413308185)
,p_name=>'FEATURE.THEME_STYLE_SELECTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB\306E\9078\629E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103722694456308185)
,p_name=>'FEATURE.THEME_STYLE_SELECTION.DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\7BA1\7406\8005\304C\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30C7\30D5\30A9\30EB\30C8\306E\30AB\30E9\30FC\30FB\30B9\30AD\30FC\30E0(\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB)\3092\9078\629E\3067\304D\308B\3088\3046\306B\3057\307E\3059\3002\7BA1\7406\8005\306F\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\305D\306E\72EC\81EA\306E\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB\306E\9078\629E\3092\8A31\53EF\3059\308B\3053\3068\3082\3067\304D\307E\3059\3002 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104028783171308458)
,p_name=>'FEATURES'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A5F\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104336864694308709)
,p_name=>'FEATURES_100_PCT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A5F\80FD100%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104085926578308505)
,p_name=>'FEATURES_100_PERCENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A5F\80FD100% (%0/%1)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104051199321308476)
,p_name=>'FEATURES_80_PCT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A5F\80FD80%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103579139563308073)
,p_name=>'FEATURES_AT_LEAST_80'
,p_message_language=>'ja'
,p_message_text=>' %0 >= 80%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103577901338308072)
,p_name=>'FEATURES_COMPLETE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B8C\4E86\3057\305F\6A5F\80FD(%0 / %1):')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103579006257308072)
,p_name=>'FEATURES_COMPLETED'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B8C\4E86 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104339361337308711)
,p_name=>'FEATURES_FOR_RELEASE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30EA\30FC\30B9%0\306E\6A5F\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104086153250308505)
,p_name=>'FEATURES_PAST_DUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\671F\9650\8D85\904E(%0/%1)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104355404319308723)
,p_name=>'FEATURES_PERCENT_COMPLETE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A5F\80FD\958B\767A\306E\5B8C\4E86\7387(%0/%1):')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104086040146308505)
,p_name=>'FEATURES_WITH_DATES'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5\4ED8\4ED8\304D(%0/%1)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104118237750308531)
,p_name=>'FEATURE_CONFIGURATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A5F\80FD\69CB\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104024293525308454)
,p_name=>'FEATURE_CONTRIBUTOR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30C8\30EA\30D3\30E5\30FC\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104085845569308505)
,p_name=>'FEATURE_COUNT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A5F\80FD\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104332881691308706)
,p_name=>'FEATURE_DASH_01'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\4EF6\306E\6A5F\80FD\3001%1\4EF6\304C100%\5B8C\4E86(%2\4EF6\306E\30EA\30EA\30FC\30B9)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104332912686308706)
,p_name=>'FEATURE_DASH_02'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\4E0A\4F4D\30EC\30D9\30EB\306E\6A5F\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104333070610308706)
,p_name=>'FEATURE_DASH_03'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\4EF6\306F\671F\9650\306A\3057\3001%1\4EF6\306F\671F\9650\7D4C\904E\304B\3064\5B8C\4E86\7387\304C80%\672A\6E80')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104333183779308707)
,p_name=>'FEATURE_DASH_04'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\4EF6\306E\6A5F\80FD\306F\958B\767A\5B8C\4E86\3001%1\4EF6\306F\6A5F\80FD\958B\767A\304C\672A\5B8C\4E86')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104336544678308709)
,p_name=>'FEATURE_DASH_05'
,p_message_language=>'ja'
,p_message_text=>unistr('%0%\306E\6A5F\80FD\306F100%\5B8C\4E86')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104022586890308453)
,p_name=>'FEATURE_DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A5F\80FD\306E\8AAC\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104023599720308453)
,p_name=>'FEATURE_DESIRABILITY'
,p_message_language=>'ja'
,p_message_text=>unistr('\671B\307E\3057\3055')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104754465287309046)
,p_name=>'FEATURE_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A5F\80FD: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104022114990308452)
,p_name=>'FEATURE_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A5F\80FD\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104022238626308452)
,p_name=>'FEATURE_OWNER'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A5F\80FD\6240\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104023280941308453)
,p_name=>'FEATURE_PRIORITY'
,p_message_language=>'ja'
,p_message_text=>unistr('\512A\5148\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104023309278308453)
,p_name=>'FEATURE_STATUS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30C6\30FC\30BF\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104023115692308453)
,p_name=>'FEATURE_TAGS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104767429108309064)
,p_name=>'FEATURE_WITHOUT_OWNERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\672A\5272\5F53\3066')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104769846089309066)
,p_name=>'FEEBACK.LOGGED.AS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\3092\30ED\30B0\306B\8A18\9332\3057\3066\3001%1\306B\5272\308A\5F53\3066\307E\3057\305F')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104048455630308474)
,p_name=>'FEEDBACK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30FC\30C9\30D0\30C3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104064037900308487)
,p_name=>'FEEDBACK_ATTRIBUTE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30FC\30C9\30D0\30C3\30AF\3068\3057\3066\30ED\30B0\306B\8A18\9332\3055\308C\308B\3053\306E\60C5\5831\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104134570850308545)
,p_name=>'FEEDBACK_DASHBOARD'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30FC\30C9\30D0\30C3\30AF\30FB\30C0\30C3\30B7\30E5\30DC\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104028364244308457)
,p_name=>'FEEDBACK_ENTRIES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30FC\30C9\30D0\30C3\30AF\30FB\30A8\30F3\30C8\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103578234766308072)
,p_name=>'FEEDBACK_ENTRIES_CLOSED'
,p_message_language=>'ja'
,p_message_text=>unistr('%2\30D5\30A3\30FC\30C9\30D0\30C3\30AF\30FB\30A8\30F3\30C8\30EA\304C\958B\3044\3066\3044\307E\3059(%0\304C\9589\3058\3066\3044\307E\3059)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104063833878308486)
,p_name=>'FEEDBACK_HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30FC\30C9\30D0\30C3\30AF\3092\5165\529B\3057\3066\3001\30D5\30A3\30FC\30C9\30D0\30C3\30AF\306E\9001\4FE1\30DC\30BF\30F3\3092\62BC\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104355701066308723)
,p_name=>'FEEDBACK_PERCENT_CLOSED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30FC\30C9\30D0\30C3\30AF\306E\30AF\30ED\30FC\30BA\7387(%0/%1):')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104059097751308482)
,p_name=>'FEEDBACK_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30FC\30C9\30D0\30C3\30AF\30FB\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104063933807308486)
,p_name=>'FEEDBACK_TYPE_HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3059\308B\30D5\30A3\30FC\30C9\30D0\30C3\30AF\306E\30BF\30A4\30D7\3092\6307\5B9A\3057\3066\304F\3060\3055\3044\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104226759100308629)
,p_name=>'FILENAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104031417952308460)
,p_name=>'FILENAME_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\540D\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104274118854308663)
,p_name=>'FILENAME_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\540D: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104029981149308459)
,p_name=>'FILES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104709467726309008)
,p_name=>'FILES_WITH_COUNT'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\30D5\30A1\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104029401404308458)
,p_name=>'FILES_WITH_COUNT_AND_SIZE'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\30D5\30A1\30A4\30EB\3001%1K\3092\6D88\8CBB')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104754268258309046)
,p_name=>'FILE_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103557156350308057)
,p_name=>'FILE_TOO_BIG'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30C6\30AD\30B9\30C8\30FB\30D5\30A1\30A4\30EB\306F\3001\7DE8\96C6\3059\308B\306B\306F\5927\304D\3059\304E\307E\3059\3002\30B3\30F3\30C6\30F3\30C4\3092\5909\66F4\3059\308B\306B\306F\3001\30ED\30FC\30AB\30EB\30FB\30DE\30B7\30F3\3067\30D5\30A1\30A4\30EB\3092\7DE8\96C6\3057\3066\3001\518D\5EA6\30A2\30C3\30D7\30ED\30FC\30C9\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103591530684308081)
,p_name=>'FILE_UPLOAD_NOSESSION_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\6709\52B9\306A\30BB\30C3\30B7\30E7\30F3\304C\306A\304F\30011\3064\4EE5\4E0A\306E\30D5\30A1\30A4\30EB\304C\30A2\30C3\30D7\30ED\30FC\30C9\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103591419174308081)
,p_name=>'FILE_UPLOAD_TOOMANYFILES_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\3067\5B9A\7FA9\3055\308C\3066\3044\308B\30D5\30A1\30A4\30EB\30FB\30A2\30A4\30C6\30E0\30FB\30BF\30A4\30D7\6570\4EE5\4E0A\306E\30D5\30A1\30A4\30EB\304C\3053\306E\30EA\30AF\30A8\30B9\30C8\3067\30A2\30C3\30D7\30ED\30FC\30C9\3055\308C\307E\3057\305F\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104081970196308501)
,p_name=>'FIND_MY_WORKSPACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306E\691C\7D22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103562583020308061)
,p_name=>'FIND_TABLES'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\306E\691C\7D22')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104789678424309080)
,p_name=>'FINISH'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D42\4E86')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103934514720308385)
,p_name=>'FIRST_ENTRY'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\521D\306E\30A8\30F3\30C8\30EA')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104087626313308506)
,p_name=>'FIXBY_PAST_DUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\4FEE\6B63\671F\9650\65E5\3092\8D85\904E')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104004003088308438)
,p_name=>'FIXED_IN_DEVELOPMENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\767A\6642\306B\4FEE\6B63\6E08')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104022335116308452)
,p_name=>'FOCUS_AREA'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30FC\30AB\30B9\9818\57DF')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103805090788308251)
,p_name=>'FOOTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30C3\30BF\30FC\30FB\30C6\30AD\30B9\30C8')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103544296406308047)
,p_name=>'FORM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104752966667309045)
,p_name=>'FORMAT_MASK_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F8\5F0F\30DE\30B9\30AF: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104086257981308505)
,p_name=>'FORM_AND_LIST_VIEW'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30FC\30E0\3068\30EA\30B9\30C8\30FB\30D3\30E5\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104086347875308505)
,p_name=>'FORM_AND_REPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30FC\30E0\4ED8\304D\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103922253859308376)
,p_name=>'FORM_ON'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306E\30D5\30A9\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103663701691308138)
,p_name=>'FORM_ON_A_TABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\306E\30D5\30A9\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104065583341308488)
,p_name=>'FORM_QUERY_SUCCESS_MSG'
,p_message_language=>'ja'
,p_message_text=>unistr('\554F\5408\305B\306E\30D5\30A9\30FC\30E0\304C\6B63\5E38\306B\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104065863929308488)
,p_name=>'FORM_REPORT_WS_SUCCESS_MSG'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B5\30FC\30D3\30B9\53C2\7167\306E\30D5\30A9\30FC\30E0\3068\30EC\30DD\30FC\30C8\304C\6B63\5E38\306B\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104063129883308486)
,p_name=>'FORM_SUCCESS_MSG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30FC\30E0\304C\6B63\5E38\306B\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104065610552308488)
,p_name=>'FORM_SUMMARY_SUCCESS_MSG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30DE\30EA\30FC\30FB\30DA\30FC\30B8\304C\6B63\5E38\306B\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104065273462308488)
,p_name=>'FORM_TABLE_SUCCESS_MSG'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\306E\30D5\30A9\30FC\30E0\304C\6B63\5E38\306B\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104065788121308488)
,p_name=>'FORM_WS_SUCCESS_MSG'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B5\30FC\30D3\30B9\53C2\7167\306E\30D5\30A9\30FC\30E0\304C\6B63\5E38\306B\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103612972236308097)
,p_name=>'FORWARD'
,p_message_language=>'ja'
,p_message_text=>unistr('\9032\3080')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104122745528308535)
,p_name=>'FROM_ATTRIBUTE_DICTIONARY'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C5E\6027\30C7\30A3\30AF\30B7\30E7\30CA\30EA\304B\3089')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103751265387308208)
,p_name=>'FUNCTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30F3\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104012503591308445)
,p_name=>'FUNCTIONALLY_COMPLETE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A5F\80FD\958B\767A\5B8C\4E86')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104002370309308437)
,p_name=>'FUNCTIONAL_IMPLEMENTATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30F3\30AF\30B7\30E7\30F3\5B9F\88C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103806660911308252)
,p_name=>'FUNCTION_BODY'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103752663569308210)
,p_name=>'FUNCTION_BODY_RETURNING_QUERY'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B\3092\623B\3059PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104062802067308486)
,p_name=>'FUNCTION_RETURNING_REF_CURSOR'
,p_message_language=>'ja'
,p_message_text=>unistr('\53C2\7167\30AB\30FC\30BD\30EB\3092\623B\3059PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104055970873308480)
,p_name=>'FUNC_BODY_RETURNING_BOOLEAN	'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30FC\30EB\3092\623B\3059PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103611778191308096)
,p_name=>'FUNC_RET_BOOLEAN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30FC\30EB\3092\623B\3059PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104049661590308475)
,p_name=>'FUTURE_MILESTONES'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C06\6765\306E\30DE\30A4\30EB\30B9\30C8\30F3')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104702107097309002)
,p_name=>'GANTT_BASELINEDATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D9\30FC\30B9\30E9\30A4\30F3\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104702030982309002)
,p_name=>'GANTT_BASELINEEND'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D9\30FC\30B9\30E9\30A4\30F3\7D42\4E86')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104701917913309002)
,p_name=>'GANTT_BASELINESTART'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D9\30FC\30B9\30E9\30A4\30F3\958B\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104055597250308480)
,p_name=>'GANTT_CHART.END_DATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D42\4E86\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104055452993308480)
,p_name=>'GANTT_CHART.START_DATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\59CB\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104289558740308674)
,p_name=>'GANTT_CHART.TASK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30B9\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104701674090309001)
,p_name=>'GANTT_DATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5\4ED8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104701553448309001)
,p_name=>'GANTT_END'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D42\4E86')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104701726275309001)
,p_name=>'GANTT_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104701850107309002)
,p_name=>'GANTT_PROGRESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\9032\6357')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104701386593309001)
,p_name=>'GANTT_ROW'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104701416174309001)
,p_name=>'GANTT_START'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\59CB')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104486938485308828)
,p_name=>'GATHER_TABLE_STATS'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\7D71\8A08\306E\53CE\96C6')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104005115840308439)
,p_name=>'GENERAL_COMMENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E00\822C\7684\306A\30B3\30E1\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104355802212308723)
,p_name=>'GENERAL_COMMENT_DASH'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E00\822C\7684\306A\30B3\30E1\30F3\30C8: %1/%0\304C\30AF\30ED\30FC\30BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103616873862308100)
,p_name=>'GENERATED_TABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\8868\306F\3001\8868\30A6\30A3\30B6\30FC\30C9\3092\4F7F\7528\3057\3066\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103701272729308168)
,p_name=>'GENERIC.CHANGES_SAVED'
,p_message_language=>'ja'
,p_message_text=>unistr('\5909\66F4\304C\4FDD\5B58\3055\308C\307E\3057\305F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104011181059308444)
,p_name=>'GET_STATIC_LOV'
,p_message_language=>'ja'
,p_message_text=>unistr('\9759\7684LOV\306E\4F5C\6210\307E\305F\306F\7DE8\96C6')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104024486820308454)
,p_name=>'GLOBALIZATION_ASSIGNEE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30ED\30FC\30D0\30EA\30BC\30FC\30B7\30E7\30F3\5272\5F53\3066\5148')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104022690548308453)
,p_name=>'GLOBALIZATION_IMPACT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30ED\30FC\30D0\30EA\30BC\30FC\30B7\30E7\30F3\306E\5F71\97FF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104025490510308455)
,p_name=>'GLOBALIZATION_STATUS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30ED\30FC\30D0\30EA\30BC\30FC\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30BF\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103545498383308048)
,p_name=>'GLOBAL_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30ED\30FC\30D0\30EB\30FB\30DA\30FC\30B8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104070069649308492)
,p_name=>'GRAY_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7070\8272\306E\30C6\30AD\30B9\30C8')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104044935048308471)
,p_name=>'GRID_DEBUG_OFF'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30A4\30A2\30A6\30C8\5217\306E\975E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104044898129308471)
,p_name=>'GRID_DEBUG_ON'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30A4\30A2\30A6\30C8\5217\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103643519621308123)
,p_name=>'GRID_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30EA\30C3\30C9\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103987054426308425)
,p_name=>'GROUPS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30EB\30FC\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104179597307308592)
,p_name=>'GROUP_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30EB\30FC\30D7: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103804950001308251)
,p_name=>'HEADER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D8\30C3\30C0\30FC\30FB\30C6\30AD\30B9\30C8')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104179333591308592)
,p_name=>'HEADING_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D8\30C3\30C0\30FC: %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104749914971309042)
,p_name=>'HELP_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D8\30EB\30D7\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103753049264308210)
,p_name=>'HELP_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D8\30EB\30D7\30FB\30C6\30AD\30B9\30C8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103848036020308284)
,p_name=>'HIDDEN_AND_PROTECTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\975E\8868\793A\3067\4FDD\8B77')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104006275293308440)
,p_name=>'HIGHLY_DESIRABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\975E\5E38\306B\671B\307E\3057\3044')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104708982660309007)
,p_name=>'HIGH_CONTRAST'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CF\30A4\30FB\30B3\30F3\30C8\30E9\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104470559525308810)
,p_name=>'HIGH_CONTRAST_TOGGLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CF\30A4\30FB\30B3\30F3\30C8\30E9\30B9\30C8\306E\5207\66FF\3048')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103986894754308425)
,p_name=>'HISTORY'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C65\6B74')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104062645537308485)
,p_name=>'HOME_LINK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DB\30FC\30E0\30FB\30EA\30F3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103541392334308045)
,p_name=>'HOME_NAV'
,p_message_language=>'ja'
,p_message_text=>unistr('Oracle APEX\30DB\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103594152374308083)
,p_name=>'HOME_PAGE_USERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC:')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103780032258308231)
,p_name=>'HORIZONTAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\6C34\5E73')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103526694719308035)
,p_name=>'HORIZONTAL2DCOLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\6C34\5E732D\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103526729559308035)
,p_name=>'HORIZONTAL3DCOLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\6C34\5E733D\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103526859475308035)
,p_name=>'HORIZONTALRANGE2DCOLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\6C34\5E73\7BC4\56F22D\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103526959203308035)
,p_name=>'HORIZONTALRANGE3DCOLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\6C34\5E73\7BC4\56F23D\5217')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104749344837309042)
,p_name=>'HOT_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DB\30C3\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103584540658308076)
,p_name=>'HR_ACCOUNT_UNLOCKED'
,p_message_language=>'ja'
,p_message_text=>unistr('HR\30A2\30AB\30A6\30F3\30C8\306F\30ED\30C3\30AF\89E3\9664\3055\308C\3066\3044\307E\3059\3002')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103754180282308211)
,p_name=>'HTML'
,p_message_language=>'ja'
,p_message_text=>'HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103773109937308226)
,p_name=>'HTMLWITHSHORTCUTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30E7\30FC\30C8\30AB\30C3\30C8\4ED8\304DHTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103772857438308226)
,p_name=>'HTML_BODY'
,p_message_language=>'ja'
,p_message_text=>unistr('HTML\30DC\30C7\30A3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103615455723308099)
,p_name=>'HTML_BUTTON'
,p_message_language=>'ja'
,p_message_text=>unistr('HTML\30DC\30BF\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103624821918308106)
,p_name=>'HTML_CHART'
,p_message_language=>'ja'
,p_message_text=>unistr('HTML\30C1\30E3\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103805278743308251)
,p_name=>'HTML_HEADER'
,p_message_language=>'ja'
,p_message_text=>unistr('HTML\30D8\30C3\30C0\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103624936341308106)
,p_name=>'HTML_SLASH_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('HTML/\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103752716224308210)
,p_name=>'HTML_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('HTML\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103625069794308106)
,p_name=>'HTML_TEXT_WITH_SHORTCUTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30E7\30FC\30C8\30AB\30C3\30C8\4ED8\304DHTML\30C6\30AD\30B9\30C8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104749583601309042)
,p_name=>'ICON_CSS_CLASSES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3CSS\30AF\30E9\30B9')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104685218407308987)
,p_name=>'IE6_COMPATIBLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\306BIE6\306E\4E92\63DB\6027\304C\3042\308B\3053\3068\3092\793A\3057\3066\3044\307E\3059')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104092365521308510)
,p_name=>'IG_ALLOW_EDITING'
,p_message_language=>'ja'
,p_message_text=>unistr('\7DE8\96C6\3092\8A31\53EF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104092478909308510)
,p_name=>'IG_READ_ONLY'
,p_message_language=>'ja'
,p_message_text=>unistr('\8AAD\53D6\308A\5C02\7528')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103754326380308211)
,p_name=>'IMAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30E1\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104295134097308679)
,p_name=>'IMAGES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30E1\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103738713292308198)
,p_name=>'IMAGE_ATTRIBUTES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30E1\30FC\30B8\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104062025744308485)
,p_name=>'IMAGE_PREFIX'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30E1\30FC\30B8\63A5\982D\8F9E')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103999972071308435)
,p_name=>'IMPORT FROM APPLICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304B\3089\30A4\30F3\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104761259149309051)
,p_name=>'IMPORT_APP_NEW_SUBSTRING'
,p_message_language=>'ja'
,p_message_text=>unistr('\7F6E\63DB\6587\5B57\5217%0\306E\65B0\3057\3044\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104229844869308631)
,p_name=>'IMPORT_APP_SUCCESS_MSG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30DD\30FC\30C8\3057\305F\30D5\30A1\30A4\30EB\306F<a href="%0">\30A8\30AF\30B9\30DD\30FC\30C8\30FB\30EA\30DD\30B8\30C8\30EA</a>\306B\5B58\5728\3057\307E\3059\3002\518D\5EA6\30A4\30F3\30B9\30C8\30FC\30EB\3059\308B\5834\5408\4EE5\5916\306F\3001\524A\9664\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103935403544308386)
,p_name=>'IN/OUT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\51FA\529B')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103551955420308053)
,p_name=>'INACTIVE'
,p_message_language=>'ja'
,p_message_text=>unistr('\975E\30A2\30AF\30C6\30A3\30D6')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104134390234308545)
,p_name=>'INCLUDE'
,p_message_language=>'ja'
,p_message_text=>unistr('\542B\3081\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104753848294309045)
,p_name=>'INCLUDE_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5BFE\8C61: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103751331606308208)
,p_name=>'INDEX'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D22\5F15')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104131755002308543)
,p_name=>'INDEX_NOUN'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D22\5F15')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103695719987308163)
,p_name=>'INITCAP_REFRESH'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30D5\30EC\30C3\30B7\30E5')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103909743292308335)
,p_name=>'INLINE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30E9\30A4\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104699290191308999)
,p_name=>'INLINE_HELP_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30E9\30A4\30F3\30FB\30D8\30EB\30D7\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103909635784308335)
,p_name=>'INLINE_NOTIFICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30E9\30A4\30F3\304A\3088\3073\901A\77E5')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104055643833308480)
,p_name=>'INPUT_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\30BF\30A4\30D7')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103752094511308209)
,p_name=>'INSERT'
,p_message_language=>'ja'
,p_message_text=>unistr('\633F\5165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104141131382308551)
,p_name=>'INSERT_EXCEPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('wwv_flow_companies\4F8B\5916\306B\633F\5165:')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104071736578308493)
,p_name=>'INSTALLER.APPLICATION_CSS'
,p_message_language=>'ja'
,p_message_text=>unistr('CSS (\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104071572745308493)
,p_name=>'INSTALLER.APPLICATION_IMAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30E1\30FC\30B8(\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104071906633308493)
,p_name=>'INSTALLER.APPLICATION_STATIC'
,p_message_language=>'ja'
,p_message_text=>unistr('\9759\7684\30D5\30A1\30A4\30EB(\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103580898544308074)
,p_name=>'INSTALLER.BUILD_OPTIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D3\30EB\30C9\30FB\30AA\30D7\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103638386483308119)
,p_name=>'INSTALLER.BUILD_OPTIONS_MESSAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\30D3\30EB\30C9\30FB\30AA\30D7\30B7\30E7\30F3\3092\542B\3081\308B\3088\3046\306B\9078\629E\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103580740588308074)
,p_name=>'INSTALLER.CONFIGURATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\7F6E\63DB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103638283332308119)
,p_name=>'INSTALLER.CONFIGURATION_MESSAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\6B21\306E\5C5E\6027\3092\69CB\6210\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103581038227308074)
,p_name=>'INSTALLER.CONFIRMATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30B9\30C8\30FC\30EB\306E\78BA\8A8D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103638558145308119)
,p_name=>'INSTALLER.CONFIRMATION_MESSAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304C\30B5\30DD\30FC\30C8\3059\308B\30AA\30D6\30B8\30A7\30AF\30C8\3092\30A4\30F3\30B9\30C8\30FC\30EB\3059\308B\3053\3068\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103581433873308074)
,p_name=>'INSTALLER.CONFIRM_DEINSTALL'
,p_message_language=>'ja'
,p_message_text=>unistr('\524A\9664\306E\78BA\8A8D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103556018048308056)
,p_name=>'INSTALLER.DEINSTALL'
,p_message_language=>'ja'
,p_message_text=>unistr('\524A\9664\30B9\30AF\30EA\30D7\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103581598954308074)
,p_name=>'INSTALLER.DEINSTALL_SUCCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\524A\9664\306E\6210\529F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103638808060308119)
,p_name=>'INSTALLER.DEINSTALL_SUCCESS_MESSAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\524A\9664\306F\5B8C\4E86\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103925780464308379)
,p_name=>'INSTALLER.ERROR.IN_CHECK'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30A4\30F3\30B9\30C8\30FC\30EB\30FB\30C1\30A7\30C3\30AF"%0"\306E\5B9F\884C\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F:'),
'<pre>%1</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103925874923308379)
,p_name=>'INSTALLER.ERROR.IN_SCRIPT'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30A4\30F3\30B9\30C8\30FC\30EB\30FB\30B9\30AF\30EA\30D7\30C8"%0"\306E\5B9F\884C\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F:'),
'<pre>%1</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103580657136308074)
,p_name=>'INSTALLER.EXISTENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B58\5728\30C1\30A7\30C3\30AF\306E\5931\6557')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103581236338308074)
,p_name=>'INSTALLER.FAILURE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30B9\30C8\30FC\30EB\5F8C\306E\5931\6557')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103638786640308119)
,p_name=>'INSTALLER.FAILURE_MESSAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30AA\30D6\30B8\30A7\30AF\30C8\3068\30B7\30FC\30C9\30FB\30C7\30FC\30BF\306E\30A4\30F3\30B9\30C8\30FC\30EB\306B\5931\6557\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103988164267308426)
,p_name=>'INSTALLER.INSTALL_FAILURE_MESSAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30B5\30DD\30FC\30C8\3059\308B\30AA\30D6\30B8\30A7\30AF\30C8\3092\4EE5\524D\306B\30A4\30F3\30B9\30C8\30FC\30EB\3057\305F\3053\3068\304C\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A4\30F3\30B9\30C8\30FC\30E9\306B\3088\3063\3066\691C\51FA\3055\308C\307E\3057\305F\3002\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\30A4\30F3\30B9\30C8\30FC\30EB\3059\308B\524D\306B\3001SQL\30EF\30FC\30AF\30B7\30E7\30C3\30D7\3092\4F7F\7528\3057\3066\305D\306E\30AA\30D6\30B8\30A7\30AF\30C8\3092\524A\9664\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103581312590308074)
,p_name=>'INSTALLER.LICENSE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30A4\30BB\30F3\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103576587533308071)
,p_name=>'INSTALLER.SCRIPT.FAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103576463549308071)
,p_name=>'INSTALLER.SCRIPT.SUCCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6210\529F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103581155656308074)
,p_name=>'INSTALLER.SUCCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30B9\30C8\30FC\30EB\5F8C\306E\6210\529F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103638695910308119)
,p_name=>'INSTALLER.SUCCESS_MESSAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30B5\30DD\30FC\30C8\3057\3066\3044\308B\30AA\30D6\30B8\30A7\30AF\30C8\304C\30A4\30F3\30B9\30C8\30FC\30EB\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103677665441308148)
,p_name=>'INSTALLER.UPGRADE_CONFIRM_MESSAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30B5\30DD\30FC\30C8\3059\308B\30AA\30D6\30B8\30A7\30AF\30C8\3092\30A2\30C3\30D7\30B0\30EC\30FC\30C9\3059\308B\3053\3068\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103677517733308148)
,p_name=>'INSTALLER.UPGRADE_FAILURE_MESSAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30B5\30DD\30FC\30C8\3059\308B\30AA\30D6\30B8\30A7\30AF\30C8\306E\30A2\30C3\30D7\30B0\30EC\30FC\30C9\306B\5931\6557\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103677196276308148)
,p_name=>'INSTALLER.UPGRADE_MESSAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30B5\30DD\30FC\30C8\3059\308B\30AA\30D6\30B8\30A7\30AF\30C8\3092\4EE5\524D\306B\30A4\30F3\30B9\30C8\30FC\30EB\3057\305F\3053\3068\304C\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A4\30F3\30B9\30C8\30FC\30E9\306B\3088\3063\3066\691C\51FA\3055\308C\307E\3057\305F\3002\3053\306E\30A6\30A3\30B6\30FC\30C9\3067\306F\3001\3053\308C\3089\306E\30B5\30DD\30FC\30C8\3059\308B\30AA\30D6\30B8\30A7\30AF\30C8\306E\30A2\30C3\30D7\30B0\30EC\30FC\30C9\30FB\30D7\30ED\30BB\30B9\3092\3001\9806\3092\8FFD\3063\3066\8AAC\660E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103677449763308148)
,p_name=>'INSTALLER.UPGRADE_SUCCESS_MESSAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30B5\30DD\30FC\30C8\3059\308B\30AA\30D6\30B8\30A7\30AF\30C8\304C\30A2\30C3\30D7\30B0\30EC\30FC\30C9\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103580931689308074)
,p_name=>'INSTALLER.VALIDATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103638441700308119)
,p_name=>'INSTALLER.VALIDATION_MESSAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\691C\8A3C\306F\3001\3054\4F7F\7528\306E\30B7\30B9\30C6\30E0\3068\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\4E92\63DB\6027\3092\78BA\8A8D\3059\308B\305F\3081\306B\5B9F\884C\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103580565246308073)
,p_name=>'INSTALLER.WELCOME'
,p_message_language=>'ja'
,p_message_text=>unistr('\3088\3046\3053\305D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103638123187308119)
,p_name=>'INSTALLER.WELCOME_MESSAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A4\30F3\30B9\30C8\30FC\30E9\3067\306F\3001\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30AA\30D6\30B8\30A7\30AF\30C8\3068\30B7\30FC\30C9\30FB\30C7\30FC\30BF\306E\4F5C\6210\30D7\30ED\30BB\30B9\306E\624B\9806\304C\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104071628833308493)
,p_name=>'INSTALLER.WORKSPACE_CSS'
,p_message_language=>'ja'
,p_message_text=>unistr('CSS (\30EF\30FC\30AF\30B9\30DA\30FC\30B9)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104071451151308493)
,p_name=>'INSTALLER.WORKSPACE_IMAGES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30E1\30FC\30B8(\30EF\30FC\30AF\30B9\30DA\30FC\30B9)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104071843891308493)
,p_name=>'INSTALLER.WORKSPACE_STATIC'
,p_message_language=>'ja'
,p_message_text=>unistr('\9759\7684\30D5\30A1\30A4\30EB(\30EF\30FC\30AF\30B9\30DA\30FC\30B9)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103568859820308065)
,p_name=>'INSTALL_APPLICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30A4\30F3\30B9\30C8\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104072027987308493)
,p_name=>'INSTALL_SAMPLE_APPS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30F3\30D7\30EB\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\30A4\30F3\30B9\30C8\30FC\30EB\3057\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104469989235308809)
,p_name=>'INSTANCE_ADMIN_HOME_NAV'
,p_message_language=>'ja'
,p_message_text=>unistr('Oracle APEX\7BA1\7406\30B5\30FC\30D3\30B9\30FB\30DB\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104119213879308532)
,p_name=>'INSTANCE_SETTINGS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30B9\30BF\30F3\30B9\306E\8A2D\5B9A')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104021218464308452)
,p_name=>'INST_RUNNING_IN_MAN_MODE_4050'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A4\30F3\30B9\30BF\30F3\30B9\306F\624B\52D5\30D7\30ED\30D3\30B8\30E7\30CB\30F3\30B0\30FB\30E2\30FC\30C9\3067\5B9F\884C\4E2D\306E\305F\3081\3001\30B5\30FC\30D3\30B9\30FB\30EA\30AF\30A8\30B9\30C8\3092\53D7\3051\5165\308C\307E\305B\3093')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104114326168308528)
,p_name=>'INSUFFICIENT_INSTALL_SPACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\30A4\30F3\30B9\30C8\30FC\30EB\3059\308B\9818\57DF\304C\4E0D\5341\5206\3067\3059\3002')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104002410264308437)
,p_name=>'INTEGRATION_COMPLETE'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D71\5408\5B8C\4E86')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104007685379308441)
,p_name=>'INTEGRATION_SIGNOFF'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D71\5408\306E\30B5\30A4\30F3\30AA\30D5')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103998138809308434)
,p_name=>'INTERACTIVE_GRID'
,p_message_language=>'ja'
,p_message_text=>unistr('\5BFE\8A71\30B0\30EA\30C3\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103773891250308226)
,p_name=>'INTERACTIVE_REPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104027604642308457)
,p_name=>'INTERACTIVE_REPORT_SEARCHES'
,p_message_language=>'ja'
,p_message_text=>unistr('\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\306E\691C\7D22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103592877043308082)
,p_name=>'INTERNAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5185\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103545196597308048)
,p_name=>'INTERNAL_ADMINISTRATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\5185\90E8\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103594589891308084)
,p_name=>'INTERNAL_USERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5185\90E8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103921898294308375)
,p_name=>'INVALID_APPLICATION_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\6709\52B9\306A\540D\524D\3092\5165\529B\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103551863474308053)
,p_name=>'INVALID_APP_ARCHIVE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\304C\6709\52B9\306A\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30FC\30AB\30A4\30D6\3067\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103922377365308376)
,p_name=>'INVALID_GROUP_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\6709\52B9\306A\30B0\30EB\30FC\30D7\540D\3092\5165\529B\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103613636970308098)
,p_name=>'INVALID_OBJECT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30D6\30B8\30A7\30AF\30C8%0\306F\7121\52B9\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104275525115308664)
,p_name=>'INVALID_PAGE_GROUP_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\6709\52B9\306A\30DA\30FC\30B8\30FB\30B0\30EB\30FC\30D7\540D\3092\5165\529B\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104790115514309081)
,p_name=>'INVALID_POSITION'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9\306A\4F4D\7F6E[\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\306A\3044]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104140857525308550)
,p_name=>'INVALID_SCHEMA_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9\306A\30B9\30AD\30FC\30DE\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104054674530308479)
,p_name=>'INVALID_SORT_ORDER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C8\30EA\304C\7121\52B9\3067\3059\3002\5024\306F\6570\5024\3067\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104738922409309034)
,p_name=>'INVALID_USERS_NOT_CREATED'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\6587\5B57\5217\306F\7121\52B9\306A\30E6\30FC\30B6\30FC\540D\3067\3042\3063\305F\3053\3068\306B\6CE8\610F\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104140796696308550)
,p_name=>'INVALID_WORKSPACE_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9\306A\30EF\30FC\30AF\30B9\30DA\30FC\30B9\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104081369373308501)
,p_name=>'INVALID_WS_OBJ'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9\306AWeb\30B7\30FC\30C8\30FB\30AA\30D6\30B8\30A7\30AF\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104079220901308499)
,p_name=>'INVALID_WS_OBJ_SUCCESS_MSG'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9\306AWeb\30B7\30FC\30C8\30FB\30AA\30D6\30B8\30A7\30AF\30C8\304C\4FEE\6B63\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104081423597308501)
,p_name=>'INVALID_WS_OBJ_WARNING_MSG'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B7\30FC\30C8\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\4F5C\6210\306B\5FC5\8981\306A\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30AA\30D6\30B8\30A7\30AF\30C8\304C\7121\52B9\304B\3001\5B58\5728\3057\307E\305B\3093\3002\30EF\30FC\30AF\30B9\30DA\30FC\30B9\7BA1\7406\8005\306B\9023\7D61\3057\3066\304F\3060\3055\3044\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103527044095308035)
,p_name=>'INVERSE2DLINE'
,p_message_language=>'ja'
,p_message_text=>unistr('\90062D\6298\308C\7DDA')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104003974436308438)
,p_name=>'IN_PROGRESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\9032\884C\4E2D')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103699733136308166)
,p_name=>'IR_COLUMNS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\306E\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103948101656308396)
,p_name=>'IR_DEVELOPER'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\767A\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103948076336308396)
,p_name=>'IR_END_USER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103948410811308396)
,p_name=>'IR_INTERACTIVE_REPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103924569224308378)
,p_name=>'IR_ONLY_ONE_PER_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('1\30DA\30FC\30B8\306B\8868\793A\3067\304D\308B\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\306F1\3064\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103948210152308396)
,p_name=>'IR_SAVE_ONLY_FOR_DEV'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30C0\30A4\30A2\30ED\30B0\30FB\30DC\30C3\30AF\30B9\306F\3001\958B\767A\8005\306B\306E\307F\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103947908342308396)
,p_name=>'IR_SAVE_REPORT_STAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\306E\4FDD\5B58*')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103948389839308396)
,p_name=>'IR_SAVE_STAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\4FDD\5B58*')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104753489791309045)
,p_name=>'IR_SUBSCRIPTION_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3: %0\3001\30DA\30FC\30B8: %1\3001\30B5\30D6\30B9\30AF\30E9\30A4\30D6\5143: %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104067251594308489)
,p_name=>'IR_SUCCESS_MSG'
,p_message_language=>'ja'
,p_message_text=>unistr('\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\30FB\30DA\30FC\30B8\304C\6B63\5E38\306B\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103948583968308396)
,p_name=>'IR_UNITS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5358\4F4D')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104488614044308830)
,p_name=>'ISSUES'
,p_message_language=>'ja'
,p_message_text=>unistr('\554F\984C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103936107480308387)
,p_name=>'IS_WRAPPED'
,p_message_language=>'ja'
,p_message_text=>unistr('\6298\8FD4\3057')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104047328853308473)
,p_name=>'ITEM CONDITION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103625239375308106)
,p_name=>'ITEM NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103592515734308082)
,p_name=>'ITEM.BUTTONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\30FB\30DC\30BF\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104774177942309069)
,p_name=>'ITEM_COLUMN_SPAN'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30A2\30A4\30C6\30E0\5217\30B9\30D1\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103612088127308096)
,p_name=>'ITEM_EXP1_EQ_EXP2'
,p_message_language=>'ja'
,p_message_text=>unistr('\5F0F1\306E\30A2\30A4\30C6\30E0\306E\5024 = \5F0F2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103612140061308096)
,p_name=>'ITEM_EXP1_NE_EXP2'
,p_message_language=>'ja'
,p_message_text=>unistr('\5F0F1\306E\30A2\30A4\30C6\30E0\306E\5024 != \5F0F2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103611603962308096)
,p_name=>'ITEM_IN_EXP1_NOT_NULL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5F0F1\306E\30A2\30A4\30C6\30E0\304CNOT NULL\3067\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103611504237308096)
,p_name=>'ITEM_IN_EXP1_NULL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5F0F1\306E\30A2\30A4\30C6\30E0\304CNULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104752689809309044)
,p_name=>'ITEM_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103669701129308143)
,p_name=>'ITEM_NAME.DATE_PICKER'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5\4ED8\30D4\30C3\30AB\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103669825077308143)
,p_name=>'ITEM_NAME.HIDDEN'
,p_message_language=>'ja'
,p_message_text=>unistr('\975E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104012643494308445)
,p_name=>'ITEM_NAME.NATIVE_AUTO_COMPLETE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30FC\30C8\30B3\30F3\30D7\30EA\30FC\30C8\304C\6709\52B9\306A\30C6\30AD\30B9\30C8\30FB\30D5\30A3\30FC\30EB\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104298384843308681)
,p_name=>'ITEM_NAME.NATIVE_CHECKBOX'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30A7\30C3\30AF\30DC\30C3\30AF\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104668084347308973)
,p_name=>'ITEM_NAME.NATIVE_COLOR_PICKER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30E9\30FC\30FB\30D4\30C3\30AB\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104127919919308540)
,p_name=>'ITEM_NAME.NATIVE_DATE_PICKER'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5\4ED8\30D4\30C3\30AB\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104290575647308675)
,p_name=>'ITEM_NAME.NATIVE_DATE_PICKER_CLASSIC'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5\4ED8\30D4\30C3\30AB\30FC(\30AF\30E9\30B7\30C3\30AF)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103537292496308042)
,p_name=>'ITEM_NAME.NATIVE_DATE_PICKER_HTML5'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5\4ED8\30D4\30C3\30AB\30FC(HTML5)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104332765659308706)
,p_name=>'ITEM_NAME.NATIVE_DISPLAY_IMAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30E1\30FC\30B8\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104292058120308676)
,p_name=>'ITEM_NAME.NATIVE_DISPLAY_ONLY'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\306E\307F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104331559112308705)
,p_name=>'ITEM_NAME.NATIVE_FILE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\53C2\7167...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104667842455308973)
,p_name=>'ITEM_NAME.NATIVE_HIDDEN'
,p_message_language=>'ja'
,p_message_text=>unistr('\975E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104338467852308711)
,p_name=>'ITEM_NAME.NATIVE_LIST_MANAGER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8\30FB\30DE\30CD\30FC\30B8\30E3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104354653941308722)
,p_name=>'ITEM_NAME.NATIVE_MARKDOWN_EDITOR'
,p_message_language=>'ja'
,p_message_text=>unistr('Markdown\30A8\30C7\30A3\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104282411818308669)
,p_name=>'ITEM_NAME.NATIVE_NUMBER_FIELD'
,p_message_language=>'ja'
,p_message_text=>unistr('\6570\5024\30D5\30A3\30FC\30EB\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104283970039308670)
,p_name=>'ITEM_NAME.NATIVE_PASSWORD'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30B9\30EF\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104291205445308676)
,p_name=>'ITEM_NAME.NATIVE_POPUP_LOV'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DD\30C3\30D7\30A2\30C3\30D7LOV')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104298219043308681)
,p_name=>'ITEM_NAME.NATIVE_RADIOGROUP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30B8\30AA\30FB\30B0\30EB\30FC\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104044108523308470)
,p_name=>'ITEM_NAME.NATIVE_RICH_TEXT_EDITOR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30C3\30C1\30FB\30C6\30AD\30B9\30C8\30FB\30A8\30C7\30A3\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104290696876308675)
,p_name=>'ITEM_NAME.NATIVE_SELECT_LIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\30EA\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104292681639308677)
,p_name=>'ITEM_NAME.NATIVE_SHUTTLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30E3\30C8\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103558342070308058)
,p_name=>'ITEM_NAME.NATIVE_SLIDER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30E9\30A4\30C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103669988916308143)
,p_name=>'ITEM_NAME.NATIVE_STOP_AND_START_HTML_TABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30EA\30C3\30C9\30FB\30EC\30A4\30A2\30A6\30C8\306E\505C\6B62\3068\958B\59CB(\975E\63A8\5968)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104046188655308472)
,p_name=>'ITEM_NAME.NATIVE_TEXTAREA'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8\9818\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104667946715308973)
,p_name=>'ITEM_NAME.NATIVE_TEXT_FIELD'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8\30FB\30D5\30A3\30FC\30EB\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103558087473308057)
,p_name=>'ITEM_NAME.NATIVE_YES_NO'
,p_message_language=>'ja'
,p_message_text=>unistr('\306F\3044/\3044\3044\3048')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103619503423308102)
,p_name=>'ITEM_NAME.PLUGIN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30E9\30B0\30A4\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103670060964308143)
,p_name=>'ITEM_NAME.POPUP_LIST_OF_VALUES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DD\30C3\30D7\30A2\30C3\30D7LOV')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104307345126308688)
,p_name=>'ITEM_NAME.STAR_RATING'
,p_message_language=>'ja'
,p_message_text=>unistr('\661F\8A55\4FA1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103670147060308143)
,p_name=>'ITEM_NAME.TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104707528210309006)
,p_name=>'ITEM_POST_TEXT_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\4E8B\5F8C\30C6\30AD\30B9\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104707438001309006)
,p_name=>'ITEM_PRE_TEXT_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\4E8B\524D\30C6\30AD\30B9\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104072661528308494)
,p_name=>'ITEM_ROW_2'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104072778890308494)
,p_name=>'ITEM_ROW_3'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104072884420308494)
,p_name=>'ITEM_ROW_4'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104072943876308494)
,p_name=>'ITEM_ROW_5'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104282357851308669)
,p_name=>'ITEM_TYPE.ATTRIBUTE.MAX_VALUE_INVALID'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3057\305F\30A2\30A4\30C6\30E0%1\306E\6700\5927\5024%0\304C\6570\5024\3067\306F\3042\308A\307E\305B\3093\3002\5024\306B\5C0F\6570\70B9\304C\542B\307E\308C\308B\5834\5408\3001\5C0F\6570\70B9\30BB\30D1\30EC\30FC\30BF\3068\3057\3066\30D4\30EA\30AA\30C9\3092\6307\5B9A\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104282282427308669)
,p_name=>'ITEM_TYPE.ATTRIBUTE.MIN_VALUE_INVALID'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3057\305F\30A2\30A4\30C6\30E0%1\306E\6700\5C0F\5024%0\304C\6570\5024\3067\306F\3042\308A\307E\305B\3093\3002\5024\306B\5C0F\6570\70B9\304C\542B\307E\308C\308B\5834\5408\3001\5C0F\6570\70B9\30BB\30D1\30EC\30FC\30BF\3068\3057\3066\30D4\30EA\30AA\30C9\3092\6307\5B9A\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103558258540308058)
,p_name=>'ITEM_TYPE.ATTRIBUTE.STEP_INVALID'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3057\305F\30A2\30A4\30C6\30E0%1\306E\30B9\30C6\30C3\30D7\5024%0\304C\6570\5024\3067\306F\3042\308A\307E\305B\3093\3002\5024\306B\5C0F\6570\70B9\304C\542B\307E\308C\308B\5834\5408\3001\5C0F\6570\70B9\30BB\30D1\30EC\30FC\30BF\3068\3057\3066\30D4\30EA\30AA\30C9\3092\6307\5B9A\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103619978023308102)
,p_name=>'ITEM_TYPE.BUTTON'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103620019187308102)
,p_name=>'ITEM_TYPE.FILE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\53C2\7167...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103620135208308102)
,p_name=>'ITEM_TYPE.HIDDEN'
,p_message_language=>'ja'
,p_message_text=>unistr('\975E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103620265278308102)
,p_name=>'ITEM_TYPE.HIDDEN_PROTECTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\975E\8868\793A\3067\4FDD\8B77')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103620325913308102)
,p_name=>'ITEM_TYPE.POPUP_COLOR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DD\30C3\30D7\30A2\30C3\30D7\30FB\30AB\30E9\30FC\30FB\30D4\30C3\30AB\30FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103620413156308102)
,p_name=>'ITEM_TYPE.TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8\30FB\30D5\30A3\30FC\30EB\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103620544940308103)
,p_name=>'ITEM_TYPE.TEXT_DISABLED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8\30FB\30D5\30A3\30FC\30EB\30C9(\7121\52B9\3001\72B6\614B\3092\4FDD\5B58\3057\306A\3044)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103620683207308103)
,p_name=>'ITEM_TYPE.TEXT_DISABLED_AND_SAVE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8\30FB\30D5\30A3\30FC\30EB\30C9(\7121\52B9\3001\72B6\614B\3092\4FDD\5B58\3059\308B)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103620750830308103)
,p_name=>'ITEM_TYPE.TEXT_WITH_ENTER_SUBMIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8\30FB\30D5\30A3\30FC\30EB\30C9([Enter]\3092\62BC\3059\3068\5E38\306B\30DA\30FC\30B8\3092\9001\4FE1)')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103997971147308434)
,p_name=>'JET_CHART'
,p_message_language=>'ja'
,p_message_text=>unistr('JET\30C1\30E3\30FC\30C8')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103933339258308385)
,p_name=>'JOB'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B8\30E7\30D6')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103999157435308435)
,p_name=>'JQM COLUMN TOGGLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\5207\66FF\3048')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103999096188308435)
,p_name=>'JQM REFLOW'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30D5\30ED\30FC\30FB\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104074607656308495)
,p_name=>'JQM_FOOTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30C3\30BF\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104074584714308495)
,p_name=>'JQM_HEADER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D8\30C3\30C0\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104001067556308436)
,p_name=>'JQM_LIST_VIEW'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8\30FB\30D3\30E5\30FC')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103998252222308434)
,p_name=>'JSTREE'
,p_message_language=>'ja'
,p_message_text=>unistr('Javascript\30C4\30EA\30FC')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104024339213308454)
,p_name=>'JUSTIFICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B63\5F53\6027')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104488712045308830)
,p_name=>'LABELS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104774069301309069)
,p_name=>'LABEL_COLUMN_SPAN'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30E9\30D9\30EB\5217\30B9\30D1\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104767682699309064)
,p_name=>'LABEL_ID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30EC\30F3\30C8\30FB\30A2\30A4\30C6\30E0\30FB\30E9\30D9\30EBID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104061191348308484)
,p_name=>'LABEL_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103726193585308188)
,p_name=>'LABEL_TEMPLATE.COPIED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30D4\30FC\5143\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103726227445308188)
,p_name=>'LABEL_TEMPLATE.MASTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\308C\304C\3053\306E\30C6\30F3\30D7\30EC\30FC\30C8\306E\300C\30DE\30B9\30BF\30FC\300D\30B3\30D4\30FC\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103726482731308189)
,p_name=>'LABEL_TEMPLATE.NO_SUBSCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30C6\30F3\30D7\30EC\30FC\30C8\3092\30B5\30D6\30B9\30AF\30E9\30A4\30D6\3059\308B\30C6\30F3\30D7\30EC\30FC\30C8\306F\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103726325745308188)
,p_name=>'LABEL_TEMPLATE.REFERENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30C6\30F3\30D7\30EC\30FC\30C8\3092\30B5\30D6\30B9\30AF\30E9\30A4\30D6\3057\3066\3044\308B\30E9\30D9\30EB\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103569356898308066)
,p_name=>'LANGUAGES'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A00\8A9E')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104027194336308456)
,p_name=>'LAST_CHANGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\7D42\306E\5909\66F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103934625414308385)
,p_name=>'LAST_ENTRY'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5F8C\306E\30A8\30F3\30C8\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104030088898308459)
,p_name=>'LAST_LOGIN'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\7D42\30ED\30B0\30A4\30F3')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103546767925308049)
,p_name=>'LAYOUT'
,p_message_language=>'ja'
,p_message_text=>unistr('%0 - \30EC\30A4\30A2\30A6\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103583726381308076)
,p_name=>'LAYOUT.AFTER_BODY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30C7\30A3\306E\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103923071842308376)
,p_name=>'LAYOUT.AFTER_ERROR_HEADER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC\30FB\30DA\30FC\30B8\30FB\30D8\30C3\30C0\30FC\306E\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103922774615308376)
,p_name=>'LAYOUT.AFTER_FOOTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30C3\30BF\30FC\306E\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103989066580308427)
,p_name=>'LAYOUT.AFTER_HEADER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D8\30C3\30C0\30FC\306E\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104337646723308710)
,p_name=>'LAYOUT.AFTER_ITEM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306E\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104272221958308662)
,p_name=>'LAYOUT.AFTER_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB\306E\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104272667049308662)
,p_name=>'LAYOUT.AFTER_LABEL_AND_ITEM'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\30E9\30D9\30EB\306E\5F8C\300D\3068\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103674052975308146)
,p_name=>'LAYOUT.AFTER_LOGIN'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103913516815308338)
,p_name=>'LAYOUT.AFTER_PROCESSING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30BB\30B9\306E\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103922589038308376)
,p_name=>'LAYOUT.AFTER_REGIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\306E\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103922833782308376)
,p_name=>'LAYOUT.AFTER_SUBMIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\9001\4FE1\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103583604565308076)
,p_name=>'LAYOUT.BEFORE_BODY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30C7\30A3\306E\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103913273673308337)
,p_name=>'LAYOUT.BEFORE_COMPUTATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A08\7B97\306E\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103923167223308377)
,p_name=>'LAYOUT.BEFORE_ERROR_FOOTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC\30FB\30DA\30FC\30B8\30FB\30D5\30C3\30BF\30FC\306E\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103922614774308376)
,p_name=>'LAYOUT.BEFORE_FOOTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30C3\30BF\30FC\306E\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103913174418308337)
,p_name=>'LAYOUT.BEFORE_HEADER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D8\30C3\30C0\30FC\306E\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104337576490308710)
,p_name=>'LAYOUT.BEFORE_ITEM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306E\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104272170829308662)
,p_name=>'LAYOUT.BEFORE_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB\306E\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104272589831308662)
,p_name=>'LAYOUT.BEFORE_LABEL_AND_ITEM'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\30E9\30D9\30EB\306E\524D\300D\3068\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103913445179308338)
,p_name=>'LAYOUT.BEFORE_PROCESSING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30BB\30B9\306E\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103922409249308376)
,p_name=>'LAYOUT.BEFORE_REGIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\306E\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103913396346308337)
,p_name=>'LAYOUT.BEFORE_VALIDATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C\306E\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103982795546308422)
,p_name=>'LAYOUT.BRANCHES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30E9\30F3\30C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103664743346308139)
,p_name=>'LAYOUT.BUTTON.ABOVE_BOX'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30C3\30AF\30B9\306E\4E0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103664807655308139)
,p_name=>'LAYOUT.BUTTON.BELOW_BOX'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30C3\30AF\30B9\306E\4E0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103664914709308139)
,p_name=>'LAYOUT.BUTTON.BOTTOM'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103665046381308139)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_CHANGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8\306E\5909\66F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103665112672308139)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_CLOSE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8\306E\30AF\30ED\30FC\30BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103665222745308139)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_COPY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8\306E\30B3\30D4\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103665352514308139)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_CREATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103665460134308139)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_DELETE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8\306E\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103665591943308140)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_EDIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8\306E\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103665688961308140)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_EXPAND'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8\306E\62E1\5F35')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103665730810308140)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_NEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103665858597308140)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_PREVIOUS'
,p_message_language=>'ja'
,p_message_text=>unistr('\524D\306E\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103665935219308140)
,p_name=>'LAYOUT.BUTTON.TOP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C8\30C3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103905949637308332)
,p_name=>'LAYOUT.CHANGE_BUTTON'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\5909\66F4\300D\30DC\30BF\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103976637359308418)
,p_name=>'LAYOUT.CHART'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104125438356308538)
,p_name=>'LAYOUT.CHART_SERIES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30EA\30FC\30BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103905146881308331)
,p_name=>'LAYOUT.CLOSE_BUTTON'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\30AF\30ED\30FC\30BA\300D\30DC\30BF\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103905670927308331)
,p_name=>'LAYOUT.COPY_BUTTON'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\30B3\30D4\30FC\300D\30DC\30BF\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103905346572308331)
,p_name=>'LAYOUT.CREATE2_BUTTON'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\4F5C\62102\300D\30DC\30BF\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103537479199308042)
,p_name=>'LAYOUT.CUSTOM_POSITION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30B9\30BF\30E0\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104125101904308537)
,p_name=>'LAYOUT.DA_EVENT_FALSE'
,p_message_language=>'ja'
,p_message_text=>'False'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104125231305308537)
,p_name=>'LAYOUT.DA_EVENT_TRUE'
,p_message_language=>'ja'
,p_message_text=>'True'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103905522005308331)
,p_name=>'LAYOUT.DELETE_BUTTON'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\524A\9664\300D\30DC\30BF\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104342015229308713)
,p_name=>'LAYOUT.EMPTY_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\7A7A\306E\30E9\30D9\30EB - #0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104749694410309042)
,p_name=>'LAYOUT.ERROR_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103905236204308331)
,p_name=>'LAYOUT.EXPAND_BUTTON'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\5C55\958B\300D\30DC\30BF\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103847262598308283)
,p_name=>'LAYOUT.FUNCTION_RETURNING_SQL_QUERY'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B\3092\623B\3059\30D5\30A1\30F3\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104125535408308538)
,p_name=>'LAYOUT.GLOBAL_PAGE_REGION_PREFIX'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30ED\30FC\30D0\30EB\30FB\30DA\30FC\30B8:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103905485992308331)
,p_name=>'LAYOUT.HELP_BUTTON'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\30D8\30EB\30D7\300D\30DC\30BF\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104337715159308710)
,p_name=>'LAYOUT.HELP_LINK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\30FB\30D8\30EB\30D7\30FB\30EA\30F3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104342191680308713)
,p_name=>'LAYOUT.HIDDEN_FIELD'
,p_message_language=>'ja'
,p_message_text=>unistr('\975E\8868\793A - #0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103847107717308283)
,p_name=>'LAYOUT.HTML_TEXT_ESCAPE_SC'
,p_message_language=>'ja'
,p_message_text=>unistr('\7279\6B8A\6587\5B57\3092\30A8\30B9\30B1\30FC\30D7\3059\308BHTML\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104699144418308999)
,p_name=>'LAYOUT.INLINE_HELP_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30E9\30A4\30F3\30FB\30D8\30EB\30D7\30FB\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104707787714309006)
,p_name=>'LAYOUT.ITEM_POST_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\4E8B\5F8C\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104707641450309006)
,p_name=>'LAYOUT.ITEM_PRE_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\4E8B\524D\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103905787000308332)
,p_name=>'LAYOUT.NEXT_BUTTON'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\6B21\3078\300D\30DC\30BF\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103982611505308422)
,p_name=>'LAYOUT.NOREGION_AT_DISP_POINT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\30DD\30A4\30F3\30C8\306B\30EA\30FC\30B8\30E7\30F3\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104125617390308538)
,p_name=>'LAYOUT.NO_REGION_ASSIGNED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\306E\306A\3044\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3068\30DC\30BF\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104015307285308447)
,p_name=>'LAYOUT.ON_DEMAND'
,p_message_language=>'ja'
,p_message_text=>unistr('Ajax\30B3\30FC\30EB\30D0\30C3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104272461090308662)
,p_name=>'LAYOUT.ON_ERROR_AFTER_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB\306E\5F8C\306E\30A8\30E9\30FC\767A\751F\6642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104272341698308662)
,p_name=>'LAYOUT.ON_ERROR_BEFORE_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB\306E\524D\306E\30A8\30E9\30FC\767A\751F\6642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103915646229308339)
,p_name=>'LAYOUT.ON_NEW_INSTANCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F\30A4\30F3\30B9\30BF\30F3\30B9\958B\59CB\6642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103915769991308339)
,p_name=>'LAYOUT.ON_SUBMIT_BEFORE_COMPUTATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\9001\4FE1\6642\304A\3088\3073\8A08\7B97\306E\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103905832030308332)
,p_name=>'LAYOUT.PREVIOUS_BUTTON'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\623B\308B\300D\30DC\30BF\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104125837161308538)
,p_name=>'LAYOUT.PROCESSING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30BB\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103514861266308026)
,p_name=>'LAYOUT.REGION_POS_BODY'
,p_message_language=>'ja'
,p_message_text=>unistr('\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104125995929308538)
,p_name=>'LAYOUT.REGION_POS_BODY_X'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30C7\30A3(#0)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104126046861308538)
,p_name=>'LAYOUT.REGION_POS_NUMBER'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F4D\7F6E#0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104125399847308538)
,p_name=>'LAYOUT.REPORT_COLUMNS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104128290622308540)
,p_name=>'LAYOUT.RUN_JAVASCRIPT'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306E\5B9F\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103847308194308283)
,p_name=>'LAYOUT.SIMPLE_CHART'
,p_message_language=>'ja'
,p_message_text=>unistr('\5358\7D14\306A\30C1\30E3\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103847667895308284)
,p_name=>'LAYOUT.STRUCTURED_QUERY'
,p_message_language=>'ja'
,p_message_text=>unistr('\69CB\9020\5316\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104128185679308540)
,p_name=>'LAYOUT.SUBMIT_AS'
,p_message_language=>'ja'
,p_message_text=>unistr('"%0"\3068\3057\3066\9001\4FE1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103999658002308435)
,p_name=>'LAYOUT.SUB_REGION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30D6\30EA\30FC\30B8\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103847520179308283)
,p_name=>'LAYOUT.SVG_CHART'
,p_message_language=>'ja'
,p_message_text=>unistr('SVG\30C1\30E3\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103632379457308114)
,p_name=>'LAYOUT.T_#APEX_CSS#'
,p_message_language=>'ja'
,p_message_text=>unistr('&PRODUCT_NAME.\3067\4F7F\7528\3055\308C\308B\30AB\30B9\30B1\30FC\30C9\30FB\30B9\30BF\30A4\30EB\30B7\30FC\30C8\30FB\30D5\30A1\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103632738062308115)
,p_name=>'LAYOUT.T_#APEX_JAVASCRIPT#'
,p_message_language=>'ja'
,p_message_text=>unistr('&PRODUCT_NAME.\3067\4F7F\7528\3055\308C\308BJavaScript\30D5\30A1\30A4\30EB\304A\3088\3073\30B3\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104751736652309044)
,p_name=>'LAYOUT.T_#APPLICATION_CSS#'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30B9\30B1\30FC\30C9\30FB\30B9\30BF\30A4\30EB\30B7\30FC\30C8\30FB\30D5\30A1\30A4\30EB\304C\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\30FB\30EC\30D9\30EB\3067\5B9A\7FA9\3055\308C\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103632932110308115)
,p_name=>'LAYOUT.T_#APPLICATION_JAVASCRIPT#'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\30FB\30EC\30D9\30EB\3067\5B9A\7FA9\3055\308C\3066\3044\308BJavaScript\30D5\30A1\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104078498341308499)
,p_name=>'LAYOUT.T_#DIALOG_ATTRIBUTES#'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C0\30A4\30A2\30ED\30B0\306E\5C5E\6027(\5BA3\8A00\7684\306B\30B5\30DD\30FC\30C8\3055\308C\3066\3044\306A\3044\30C0\30A4\30A2\30ED\30B0\306E\5C5E\6027\306E\5B9A\7FA9)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104700846631309001)
,p_name=>'LAYOUT.T_#DIALOG_CSS_CLASSES#'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C0\30A4\30A2\30ED\30B0CSS\30AF\30E9\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104078009431308498)
,p_name=>'LAYOUT.T_#DIALOG_HEIGHT#'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C0\30A4\30A2\30ED\30B0\306E\9AD8\3055')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104078208012308498)
,p_name=>'LAYOUT.T_#DIALOG_MAX_WIDTH#'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C0\30A4\30A2\30ED\30B0\306E\6700\5927\5E45')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104078105377308498)
,p_name=>'LAYOUT.T_#DIALOG_WIDTH#'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C0\30A4\30A2\30ED\30B0\306E\5E45')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104772573054309068)
,p_name=>'LAYOUT.T_#EXPAND_COLLAPSE_NAV_LABEL#'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CA\30D3\30B2\30FC\30B7\30E7\30F3\306E\62E1\5F35/\7E2E\5C0F\306E\30E9\30D9\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104772626866309068)
,p_name=>'LAYOUT.T_#EXPAND_COLLAPSE_SIDE_COL_LABEL#'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A2A\306E\5217\306E\62E1\5F35/\7E2E\5C0F\306E\30E9\30D9\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104742095442309036)
,p_name=>'LAYOUT.T_#FAVICONS#'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30D3\30B3\30F3HTML\30B3\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103632641996308115)
,p_name=>'LAYOUT.T_#GENERATED_CSS#'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30F3\30B6\30D5\30E9\30A4\65B9\5F0F\3067\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\3088\3063\3066\4F5C\6210\3055\308C\308B\30AB\30B9\30B1\30FC\30C9\30FB\30B9\30BF\30A4\30EB\30B7\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103633057373308115)
,p_name=>'LAYOUT.T_#GENERATED_JAVASCRIPT#'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30F3\30B6\30D5\30E9\30A4\65B9\5F0F\3067\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\3088\3063\3066\4F5C\6210\3055\308C\308BJavaScript\30B3\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104078348912308498)
,p_name=>'LAYOUT.T_#IS_MODAL#'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C0\30A4\30A2\30ED\30B0\306E\30DA\30FC\30B8\30FB\30E2\30FC\30C9(\305F\3068\3048\3070\3001\30E2\30FC\30C0\30EB\306E\5834\5408\306F''true''\3001\975E\30E2\30FC\30C0\30EB\306E\5834\5408\306F''false'')')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103632514311308115)
,p_name=>'LAYOUT.T_#PAGE_CSS#'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30EC\30D9\30EB\3067\5B9A\7FA9\3055\308C\3066\3044\308B\30AB\30B9\30B1\30FC\30C9\30FB\30B9\30BF\30A4\30EB\30B7\30FC\30C8\30FB\30D5\30A1\30A4\30EB\3068\30A4\30F3\30E9\30A4\30F3\30FB\30B9\30BF\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103626232562308107)
,p_name=>'LAYOUT.T_#PAGE_CSS_CLASSES#'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8CSS\30AF\30E9\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104281653056308669)
,p_name=>'LAYOUT.T_#PAGE_JAVASCRIPT#'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30EC\30D9\30EB\3067\5B9A\7FA9\3055\308C\3066\3044\308BJavaScript\30D5\30A1\30A4\30EB\304A\3088\3073\30B3\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103544440877308048)
,p_name=>'LAYOUT.T_#PAGE_STATIC_ID#'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306E\9759\7684ID (\305F\3068\3048\3070''P100'')')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103540814427308045)
,p_name=>'LAYOUT.T_#PAGE_TRANSITION#'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F\30DA\30FC\30B8\3078\306E\30CA\30D3\30B2\30FC\30C8\306B\4F7F\7528\3055\308C\308B\9077\79FB\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104077914186308498)
,p_name=>'LAYOUT.T_#PAGE_URL#'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103540955792308045)
,p_name=>'LAYOUT.T_#POPUP_TRANSITION#'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DD\30C3\30D7\30A2\30C3\30D7\3092\958B\304F\305F\3081\306B\4F7F\7528\3055\308C\308B\9077\79FB\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104081107933308501)
,p_name=>'LAYOUT.T_#REQUESTED_URL#'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30E9\30A6\30B6\306B\3088\3063\3066\30EA\30AF\30A8\30B9\30C8\3055\308C\305F\30DA\30FC\30B8URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104751992841309044)
,p_name=>'LAYOUT.T_#SIDE_GLOBAL_NAVIGATION_LIST#'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC(\30B5\30A4\30C9)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103632484397308114)
,p_name=>'LAYOUT.T_#TEMPLATE_CSS#'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8\3067\5B9A\7FA9\3055\308C\3066\3044\308B\30AB\30B9\30B1\30FC\30C9\30FB\30B9\30BF\30A4\30EB\30B7\30FC\30C8\30FB\30D5\30A1\30A4\30EB\3068\30A4\30F3\30E9\30A4\30F3\30FB\30B9\30BF\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103632887624308115)
,p_name=>'LAYOUT.T_#TEMPLATE_JAVASCRIPT#'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8\3067\5B9A\7FA9\3055\308C\3066\3044\308BJavaScript\30D5\30A1\30A4\30EB\304A\3088\3073\30B3\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103633154953308115)
,p_name=>'LAYOUT.T_#THEME_CSS#'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\30FB\30EC\30D9\30EB\3067\5B9A\7FA9\3055\308C\3066\3044\308B\30AB\30B9\30B1\30FC\30C9\30FB\30B9\30BF\30A4\30EB\30B7\30FC\30C8\30FB\30D5\30A1\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104760710564309051)
,p_name=>'LAYOUT.T_#THEME_JAVASCRIPT#'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\30FB\30EC\30D9\30EB\3067\5B9A\7FA9\3055\308C\3066\3044\308BJavaScript\30D5\30A1\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104760847108309051)
,p_name=>'LAYOUT.T_#THEME_STYLE_CSS#'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB\30FB\30EC\30D9\30EB\3067\5B9A\7FA9\3055\308C\3066\3044\308B\30AB\30B9\30B1\30FC\30C9\30FB\30B9\30BF\30A4\30EB\30B7\30FC\30C8\30FB\30D5\30A1\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104751873136309044)
,p_name=>'LAYOUT.T_#TOP_GLOBAL_NAVIGATION_LIST#'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC(\30C8\30C3\30D7)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104078582365308499)
,p_name=>'LAYOUT.T_#TRIGGERING_ELEMENT#'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C8\30EA\30AC\30FC\8981\7D20(\305F\3068\3048\3070\3001\73FE\5728\306EDOM\8981\7D20)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103691562007308159)
,p_name=>'LAYOUT.T_ACTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104281709150308669)
,p_name=>'LAYOUT.T_AFFECTED_ELEMENTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5F71\97FF\3092\53D7\3051\308B\8981\7D20')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103688594563308157)
,p_name=>'LAYOUT.T_ALT_APPLICATION_TAB'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30BF\30D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103684525646308154)
,p_name=>'LAYOUT.T_ALT_ARROW_DOWN'
,p_message_language=>'ja'
,p_message_text=>unistr('\505C\6B62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103688127650308157)
,p_name=>'LAYOUT.T_ALT_BODY_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30C7\30A3\30FB\30BF\30A4\30C8\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103683944091308153)
,p_name=>'LAYOUT.T_ALT_BRANCH'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30E9\30F3\30C1\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103684668672308154)
,p_name=>'LAYOUT.T_ALT_BUTTON'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103687238196308156)
,p_name=>'LAYOUT.T_ALT_CHANGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5909\66F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103686317249308155)
,p_name=>'LAYOUT.T_ALT_CLOSE'
,p_message_language=>'ja'
,p_message_text=>unistr('\9589\3058\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103688672911308157)
,p_name=>'LAYOUT.T_ALT_COMPANY_IMG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\30FB\30A4\30E1\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103683774235308153)
,p_name=>'LAYOUT.T_ALT_COMPUTATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A08\7B97\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103686937204308156)
,p_name=>'LAYOUT.T_ALT_COPY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30D4\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103686126220308155)
,p_name=>'LAYOUT.T_ALT_CREATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103686275367308155)
,p_name=>'LAYOUT.T_ALT_CREATE2'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103686805241308156)
,p_name=>'LAYOUT.T_ALT_DELETE'
,p_message_language=>'ja'
,p_message_text=>unistr('\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103685943672308155)
,p_name=>'LAYOUT.T_ALT_EDIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103686046187308155)
,p_name=>'LAYOUT.T_ALT_EXPAND'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\304F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103686681873308156)
,p_name=>'LAYOUT.T_ALT_FORM_CLOSE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30ED\30FC\30BA\72B6\614B\306E\30D5\30A9\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103686595030308155)
,p_name=>'LAYOUT.T_ALT_FORM_OPEN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30FC\30D7\30F3\72B6\614B\306E\30D5\30A9\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103687762438308156)
,p_name=>'LAYOUT.T_ALT_GLOBAL_NOTIFICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30ED\30FC\30D0\30EB\901A\77E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103686754075308156)
,p_name=>'LAYOUT.T_ALT_HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D8\30EB\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103684762790308154)
,p_name=>'LAYOUT.T_ALT_ITEM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103687583440308156)
,p_name=>'LAYOUT.T_ALT_NAV_BAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30D0\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103687044188308156)
,p_name=>'LAYOUT.T_ALT_NEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103687627525308156)
,p_name=>'LAYOUT.T_ALT_NOTIFICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\901A\77E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103688436432308157)
,p_name=>'LAYOUT.T_ALT_PARENT_TAB'
,p_message_language=>'ja'
,p_message_text=>unistr('\89AA\30BF\30D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103687134374308156)
,p_name=>'LAYOUT.T_ALT_PREVIOUS'
,p_message_language=>'ja'
,p_message_text=>unistr('\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103683681341308153)
,p_name=>'LAYOUT.T_ALT_PROCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30BB\30B9\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103683545531308153)
,p_name=>'LAYOUT.T_ALT_REGION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103686402655308155)
,p_name=>'LAYOUT.T_ALT_REGION_BODY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\30FB\30DC\30C7\30A3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103688209563308157)
,p_name=>'LAYOUT.T_ALT_REGION_POSITION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103685896470308155)
,p_name=>'LAYOUT.T_ALT_REGION_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\30FB\30BF\30A4\30C8\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103688384309308157)
,p_name=>'LAYOUT.T_ALT_STD_TAB'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103687959060308157)
,p_name=>'LAYOUT.T_ALT_SUCCESS_MSG'
,p_message_language=>'ja'
,p_message_text=>unistr('\6210\529F\30E1\30C3\30BB\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103687851326308156)
,p_name=>'LAYOUT.T_ALT_TEMPLATE_BODY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8\30FB\30DC\30C7\30A3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103688029821308157)
,p_name=>'LAYOUT.T_ALT_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30C8\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103683849283308153)
,p_name=>'LAYOUT.T_ALT_VALIDATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103683400805308153)
,p_name=>'LAYOUT.T_ALT_WARNING'
,p_message_language=>'ja'
,p_message_text=>unistr('\8B66\544A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104128893747308540)
,p_name=>'LAYOUT.T_AUTHORIZATION_SCHEME'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\53EF\30B9\30AD\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104749111086309042)
,p_name=>'LAYOUT.T_BC_LABEL_ESC_SC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0\30FB\30E9\30D9\30EB(HTML\6587\5B57\3092\30A8\30B9\30B1\30FC\30D7)')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104339433509308711)
,p_name=>'LAYOUT.T_BIND_EVENT_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('WHEN\30A4\30D9\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103689021969308157)
,p_name=>'LAYOUT.T_BODY'
,p_message_language=>'ja'
,p_message_text=>unistr('\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103576339800308070)
,p_name=>'LAYOUT.T_BRANCH2'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30E9\30F3\30C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103681837852308152)
,p_name=>'LAYOUT.T_BRANCHING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30E9\30F3\30C1\51E6\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104130293939308542)
,p_name=>'LAYOUT.T_BRANCH_ACTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30E9\30F3\30C1\30FB\30A2\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103666384338308140)
,p_name=>'LAYOUT.T_BRANCH_TO_FUNCTION_RETURNING_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\3092\623B\3059\30D5\30A1\30F3\30AF\30B7\30E7\30F3\306B\30D6\30E9\30F3\30C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103666418853308140)
,p_name=>'LAYOUT.T_BRANCH_TO_FUNCTION_RETURNING_URL'
,p_message_language=>'ja'
,p_message_text=>unistr('URL\3092\623B\3059\30D5\30A1\30F3\30AF\30B7\30E7\30F3\306B\30D6\30E9\30F3\30C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103666086166308140)
,p_name=>'LAYOUT.T_BRANCH_TO_PAGE_ACCEPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\53D7\5165\308C\306B\30D6\30E9\30F3\30C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103666180291308140)
,p_name=>'LAYOUT.T_BRANCH_TO_PAGE_IDENTIFIED_BY_ITEM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\3067\6307\5B9A\3057\305F\30DA\30FC\30B8\306B\30D6\30E9\30F3\30C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103692095663308160)
,p_name=>'LAYOUT.T_BRANCH_TO_PG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306B\79FB\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103666520288308140)
,p_name=>'LAYOUT.T_BRANCH_TO_PLSQL'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\30D7\30ED\30B7\30FC\30B8\30E3\306B\30D6\30E9\30F3\30C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103666287709308140)
,p_name=>'LAYOUT.T_BRANCH_TO_URL_IDENTIFIED_BY_ITEM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\3067\6307\5B9A\3057\305FURL\306B\30D6\30E9\30F3\30C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104128972644308540)
,p_name=>'LAYOUT.T_BUILD_OPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D3\30EB\30C9\30FB\30AA\30D7\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103680597157308151)
,p_name=>'LAYOUT.T_BUTTON'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103691964827308160)
,p_name=>'LAYOUT.T_BUTTON2'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104129632317308541)
,p_name=>'LAYOUT.T_BUTTON_ACTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3\30FB\30A2\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104307893125308688)
,p_name=>'LAYOUT.T_BUTTON_EXECUTE_VAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C\306E\5B9F\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103685469841308155)
,p_name=>'LAYOUT.T_BUTTON_W_NO_REGION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\306A\3057\306E\30DC\30BF\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104130067934308541)
,p_name=>'LAYOUT.T_CHART_QUERY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104129995341308541)
,p_name=>'LAYOUT.T_COLUMN_HEADING'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\30D8\30C3\30C0\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104748938023309041)
,p_name=>'LAYOUT.T_COMPONENT_CSS_CLASSES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30DD\30FC\30CD\30F3\30C8CSS\30AF\30E9\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103680720776308151)
,p_name=>'LAYOUT.T_COMPUTATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A08\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103692632176308160)
,p_name=>'LAYOUT.T_COMPUTATION2'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A08\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103680822679308151)
,p_name=>'LAYOUT.T_COMPUTATION_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B80(\30BC\30ED)\306F\8A08\7B97\3092\30B5\30DD\30FC\30C8\3057\307E\305B\3093\3002\3059\3079\3066\306E\30DA\30FC\30B8\3067\5B9F\884C\3055\308C\308B\8A08\7B97\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30EC\30D9\30EB\306E\8A08\7B97\3067\51E6\7406\3055\308C\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104129320935308541)
,p_name=>'LAYOUT.T_COMPUTATION_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A08\7B97\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103691617088308159)
,p_name=>'LAYOUT.T_CONDITION'
,p_message_language=>'ja'
,p_message_text=>unistr('\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104128638650308540)
,p_name=>'LAYOUT.T_CONDITION_EXPR1'
,p_message_language=>'ja'
,p_message_text=>unistr('\5F0F1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104128784010308540)
,p_name=>'LAYOUT.T_CONDITION_EXPR2'
,p_message_language=>'ja'
,p_message_text=>unistr('\5F0F2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104128586885308540)
,p_name=>'LAYOUT.T_CONDITION_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6761\4EF6\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103678883262308149)
,p_name=>'LAYOUT.T_COPY_BUTTON'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30D4\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103678622142308149)
,p_name=>'LAYOUT.T_CREATE_BUTTON'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104747042646309040)
,p_name=>'LAYOUT.T_CURRENT_PROGRESS'
,p_message_language=>'ja'
,p_message_text=>unistr('<em>APEX.CURRENT_PROGRESS</em>\5185\90E8\30C6\30AD\30B9\30C8\30FB\30E1\30C3\30BB\30FC\30B8\304B\3089\5C0E\51FA\3055\308C\308B\30C6\30AD\30B9\30C8(\30C7\30D5\30A9\30EB\30C8\306F<em>\73FE\5728\306E\9032\884C\72B6\6CC1</em>)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103689599297308158)
,p_name=>'LAYOUT.T_DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\8AAC\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103691891764308160)
,p_name=>'LAYOUT.T_DISPLAY'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104129764797308541)
,p_name=>'LAYOUT.T_DISPLAY_AS'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\5F62\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103680356012308151)
,p_name=>'LAYOUT.T_DISPLAY_PT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\30DD\30A4\30F3\30C8:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104677931128308981)
,p_name=>'LAYOUT.T_DYNAMIC_ACTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\52D5\7684\30A2\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103678747491308149)
,p_name=>'LAYOUT.T_EDIT_BUTTON'
,p_message_language=>'ja'
,p_message_text=>unistr('\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103576279637308070)
,p_name=>'LAYOUT.T_EDIT_PAGE_IN_BUILDER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D3\30EB\30C0\30FC\3067\30DA\30FC\30B8\3092\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103663988062308138)
,p_name=>'LAYOUT.T_EDIT_REGION_ATTRIBUTES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\5C5E\6027\306E\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103664599710308139)
,p_name=>'LAYOUT.T_ERROR_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC\30FB\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103691710106308159)
,p_name=>'LAYOUT.T_EXP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30AF\30B9\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103683341143308153)
,p_name=>'LAYOUT.T_FLOW_NO_BRANCHING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30E9\30F3\30C1\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103683075858308153)
,p_name=>'LAYOUT.T_FLOW_NO_COMPUTATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A08\7B97\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103682866747308153)
,p_name=>'LAYOUT.T_FLOW_NO_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\304C\9078\629E\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103683136690308153)
,p_name=>'LAYOUT.T_FLOW_NO_PROCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30BB\30B9\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103682965653308153)
,p_name=>'LAYOUT.T_FLOW_NO_REGION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103683289149308153)
,p_name=>'LAYOUT.T_FLOW_NO_VALIDATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103689164299308157)
,p_name=>'LAYOUT.T_FOOTER_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30C3\30BF\30FC\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103690484932308159)
,p_name=>'LAYOUT.T_FORM_CLOSE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30ED\30FC\30BA\72B6\614B\306EHTML\30D5\30A9\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103689985039308158)
,p_name=>'LAYOUT.T_FORM_OPEN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30FC\30D7\30F3\72B6\614B\306EHTML\30D5\30A9\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103689446204308158)
,p_name=>'LAYOUT.T_FROM'
,p_message_language=>'ja'
,p_message_text=>unistr('\5909\63DB\5143')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103681325838308151)
,p_name=>'LAYOUT.T_GLOBAL_PAGE_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30ED\30FC\30D0\30EB\30FB\30DA\30FC\30B8\306F\30D6\30E9\30F3\30C1\3001\8A08\7B97\3001\30D7\30ED\30BB\30B9\307E\305F\306F\691C\8A3C\3092\30B5\30DD\30FC\30C8\3057\307E\305B\3093\3002\3059\3079\3066\306E\30DA\30FC\30B8\3067\5B9F\884C\3055\308C\308B\8A08\7B97\304A\3088\3073\30D7\30ED\30BB\30B9\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30EC\30D9\30EB\306E\8A08\7B97\304A\3088\3073\30D7\30ED\30BB\30B9\3067\51E6\7406\3055\308C\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104341800559308713)
,p_name=>'LAYOUT.T_GRID_COLUMN_NO'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30EA\30C3\30C9\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104060751552308484)
,p_name=>'LAYOUT.T_GRID_COLUMN_SPAN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30EA\30C3\30C9\306E\5217\30B9\30D1\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103688998382308157)
,p_name=>'LAYOUT.T_HEADER_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D8\30C3\30C0\30FC\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103664343686308139)
,p_name=>'LAYOUT.T_INLINE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30E9\30A4\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103664254795308139)
,p_name=>'LAYOUT.T_INLINE_PLUS_NOTIFICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30E9\30A4\30F3+\901A\77E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103679590990308150)
,p_name=>'LAYOUT.T_INVALID_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9\306A\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103680678199308151)
,p_name=>'LAYOUT.T_ITEM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104012713849308445)
,p_name=>'LAYOUT.T_ITEM2'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103685743159308155)
,p_name=>'LAYOUT.T_ITEM_EXCEEDS_MAX'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\30FB\30AB\30A6\30F3\30C8\304C\6700\5927\6570\306E200\3092\8D85\3048\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104129842903308541)
,p_name=>'LAYOUT.T_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103550032117308052)
,p_name=>'LAYOUT.T_LISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104733387627309029)
,p_name=>'LAYOUT.T_LIST_ID'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E00\610F\306E\30EA\30B9\30C8ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103664604156308139)
,p_name=>'LAYOUT.T_LOCATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103708652740308174)
,p_name=>'LAYOUT.T_LOV'
,p_message_language=>'ja'
,p_message_text=>'LOV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103549943681308052)
,p_name=>'LAYOUT.T_MENUS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104341924221308713)
,p_name=>'LAYOUT.T_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\540D\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103692259396308160)
,p_name=>'LAYOUT.T_NAVIGATE_TO_PG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306B\30CA\30D3\30B2\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103682507615308152)
,p_name=>'LAYOUT.T_NAV_BAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30D0\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104007731673308441)
,p_name=>'LAYOUT.T_NAV_LISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103666916116308141)
,p_name=>'LAYOUT.T_NEVER'
,p_message_language=>'ja'
,p_message_text=>unistr('\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104060485326308484)
,p_name=>'LAYOUT.T_NEW_GRID'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F\30B0\30EA\30C3\30C9\306E\958B\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104060691053308484)
,p_name=>'LAYOUT.T_NEW_GRID_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F\30B0\30EA\30C3\30C9\5217\306E\958B\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104060553898308484)
,p_name=>'LAYOUT.T_NEW_GRID_ROW'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F\30B0\30EA\30C3\30C9\884C\306E\958B\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103688875207308157)
,p_name=>'LAYOUT.T_NO'
,p_message_language=>'ja'
,p_message_text=>unistr('\3044\3044\3048')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103666602975308140)
,p_name=>'LAYOUT.T_NONE'
,p_message_language=>'ja'
,p_message_text=>unistr('\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103664405633308139)
,p_name=>'LAYOUT.T_NOTIFICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\901A\77E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103690031913308158)
,p_name=>'LAYOUT.T_NOTIFICATION_MSG'
,p_message_language=>'ja'
,p_message_text=>unistr('\901A\77E5\30E1\30C3\30BB\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103681933054308152)
,p_name=>'LAYOUT.T_NO_BRANCHING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\300C%0\300D\306B\30D6\30E9\30F3\30C1\304C\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103685545027308155)
,p_name=>'LAYOUT.T_NO_BUTTON'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\300C%0\300D\306B\30DC\30BF\30F3\304C\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103685662063308155)
,p_name=>'LAYOUT.T_NO_ITEM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\300C%0\300D\306B\30A2\30A4\30C6\30E0\304C\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103550208500308052)
,p_name=>'LAYOUT.T_NO_LISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8\304C\4F7F\7528\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103708705845308174)
,p_name=>'LAYOUT.T_NO_LOV'
,p_message_language=>'ja'
,p_message_text=>unistr('\5171\6709LOV\306F\4F7F\7528\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103550390298308052)
,p_name=>'LAYOUT.T_NO_MENUS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0\304C\4F7F\7528\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103682657616308152)
,p_name=>'LAYOUT.T_NO_NAV_BAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\300C%0\300D\306B\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30D0\30FC\304C\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103681090136308151)
,p_name=>'LAYOUT.T_NO_ONLOAD_COMPUTATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\300C%0\300D\306BonLoad\8A08\7B97\304C\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103681299085308151)
,p_name=>'LAYOUT.T_NO_ONLOAD_PROCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\300C%0\300D\306BonLoad\30D7\30ED\30BB\30B9\304C\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103681411712308151)
,p_name=>'LAYOUT.T_NO_ONSUBMIT_COMPUTATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\300C%0\300D\306BonSubmit\8A08\7B97\304C\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103681761057308152)
,p_name=>'LAYOUT.T_NO_ONSUBMIT_PROCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\300C%0\300D\306BonSubmit\30D7\30ED\30BB\30B9\304C\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103678417655308149)
,p_name=>'LAYOUT.T_NO_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\304C\9078\629E\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103682192342308152)
,p_name=>'LAYOUT.T_NO_PARENT_TAB'
,p_message_language=>'ja'
,p_message_text=>unistr('\89AA\30EC\30D9\30EB\306E\30BF\30D6\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103680408339308151)
,p_name=>'LAYOUT.T_NO_REGION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\300C%0\300D\306B\30EA\30FC\30B8\30E7\30F3\304C\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103682471326308152)
,p_name=>'LAYOUT.T_NO_TAB_SET'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8%0\306B\30BF\30D6\30FB\30BB\30C3\30C8\304C\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103708899149308174)
,p_name=>'LAYOUT.T_NO_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8\304C\4F7F\7528\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103681632861308152)
,p_name=>'LAYOUT.T_NO_VALIDATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\300C%0\300D\306B\691C\8A3C\304C\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103664027284308138)
,p_name=>'LAYOUT.T_NUMBER_OF_ITEMS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103678558140308149)
,p_name=>'LAYOUT.T_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103679323224308150)
,p_name=>'LAYOUT.T_PAGE_ALIAS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5225\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103679996716308150)
,p_name=>'LAYOUT.T_PAGE_AUTHENTICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103679789728308150)
,p_name=>'LAYOUT.T_PAGE_AUTHORIZATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\53EF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103690261401308158)
,p_name=>'LAYOUT.T_PAGE_BODY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30DC\30C7\30A3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103690340992308158)
,p_name=>'LAYOUT.T_PAGE_BODY_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30DC\30C7\30A3\30FB\30BF\30A4\30C8\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103679833971308150)
,p_name=>'LAYOUT.T_PAGE_BUILD_OPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D3\30EB\30C9\30FB\30AA\30D7\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103689817495308158)
,p_name=>'LAYOUT.T_PAGE_HEAD'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30D8\30C3\30C0\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103679109246308150)
,p_name=>'LAYOUT.T_PAGE_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\540D\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103679078395308150)
,p_name=>'LAYOUT.T_PAGE_NOT_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\304C\898B\3064\304B\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103689635666308158)
,p_name=>'LAYOUT.T_PAGE_ONLOAD'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8Onload')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103680079154308150)
,p_name=>'LAYOUT.T_PAGE_PUBLIC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30D6\30EA\30C3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103680149362308150)
,p_name=>'LAYOUT.T_PAGE_REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\5FC5\9808')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103679619907308150)
,p_name=>'LAYOUT.T_PAGE_TABSET'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A19\6E96\30BF\30D6\30FB\30BB\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103679453089308150)
,p_name=>'LAYOUT.T_PAGE_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103679223505308150)
,p_name=>'LAYOUT.T_PAGE_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30C8\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103689706135308158)
,p_name=>'LAYOUT.T_PAGE_TITLE2'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30BF\30A4\30C8\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103682095031308152)
,p_name=>'LAYOUT.T_PARENT_TAB'
,p_message_language=>'ja'
,p_message_text=>unistr('\89AA\30BF\30D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103681109114308151)
,p_name=>'LAYOUT.T_PROCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30BB\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103692537214308160)
,p_name=>'LAYOUT.T_PROCESS2'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30BB\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103680986308308151)
,p_name=>'LAYOUT.T_PROCESS_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B80(\30BC\30ED)\306F\30D7\30ED\30BB\30B9\3092\30B5\30DD\30FC\30C8\3057\307E\305B\3093\3002\3059\3079\3066\306E\30DA\30FC\30B8\3067\5B9F\884C\3055\308C\308B\30D7\30ED\30BB\30B9\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30EC\30D9\30EB\306E\30D7\30ED\30BB\30B9\3067\51E6\7406\3055\308C\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104130150251308541)
,p_name=>'LAYOUT.T_PROCESS_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30BB\30B9\30FB\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103692166612308160)
,p_name=>'LAYOUT.T_REDIRECT_TO_PG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306B\79FB\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103689320768308158)
,p_name=>'LAYOUT.T_REFERENCED'
,p_message_language=>'ja'
,p_message_text=>unistr('\53C2\7167')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104749085478309041)
,p_name=>'LAYOUT.T_REFERENCED_FROM'
,p_message_language=>'ja'
,p_message_text=>unistr('\53C2\7167\5143')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103680218831308150)
,p_name=>'LAYOUT.T_REGION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103692949315308160)
,p_name=>'LAYOUT.T_REGION2'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104001290897308436)
,p_name=>'LAYOUT.T_REGION_ATTRIBUTES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103540449389308045)
,p_name=>'LAYOUT.T_REGION_CSS_CLASSES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\306ECSS\30AF\30E9\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104000050684308435)
,p_name=>'LAYOUT.T_REGION_ID'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E00\610F\306E\30EA\30FC\30B8\30E7\30F3ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104059372496308483)
,p_name=>'LAYOUT.T_REGION_POS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103690504213308159)
,p_name=>'LAYOUT.T_REGION_POS1'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\4F4D\7F6E1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103994928071308431)
,p_name=>'LAYOUT.T_REGION_POS10'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\4F4D\7F6E10')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103995001577308432)
,p_name=>'LAYOUT.T_REGION_POS11'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\4F4D\7F6E11')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103995158217308432)
,p_name=>'LAYOUT.T_REGION_POS12'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\4F4D\7F6E12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103995275879308432)
,p_name=>'LAYOUT.T_REGION_POS13'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\4F4D\7F6E13')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103995328096308432)
,p_name=>'LAYOUT.T_REGION_POS14'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\4F4D\7F6E14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103995457491308432)
,p_name=>'LAYOUT.T_REGION_POS15'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\4F4D\7F6E15')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103995528078308432)
,p_name=>'LAYOUT.T_REGION_POS16'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\4F4D\7F6E16')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103690665537308159)
,p_name=>'LAYOUT.T_REGION_POS2'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\4F4D\7F6E2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103690799555308159)
,p_name=>'LAYOUT.T_REGION_POS3'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\4F4D\7F6E3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103690887822308159)
,p_name=>'LAYOUT.T_REGION_POS4'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\4F4D\7F6E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103690916543308159)
,p_name=>'LAYOUT.T_REGION_POS5'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\4F4D\7F6E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103691016903308159)
,p_name=>'LAYOUT.T_REGION_POS6'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\4F4D\7F6E6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103691189101308159)
,p_name=>'LAYOUT.T_REGION_POS7'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\4F4D\7F6E7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103691274212308159)
,p_name=>'LAYOUT.T_REGION_POS8'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\4F4D\7F6E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103994889433308431)
,p_name=>'LAYOUT.T_REGION_POS9'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\4F4D\7F6E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104000128210308435)
,p_name=>'LAYOUT.T_REGION_STATIC_ID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\306E\9759\7684ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104341724553308713)
,p_name=>'LAYOUT.T_REGION_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\30FB\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103666887222308141)
,p_name=>'LAYOUT.T_STANDARD_CONDITION'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A19\6E96\7684\306A\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103682269082308152)
,p_name=>'LAYOUT.T_STD_TAB'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A19\6E96\30BF\30D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103689222938308158)
,p_name=>'LAYOUT.T_SUBSTITUTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\7F6E\63DB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104000889522308436)
,p_name=>'LAYOUT.T_SUB_PLUG_HEADER_ENTRY_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30D6\30EA\30FC\30B8\30E7\30F3 - \30D8\30C3\30C0\30FC\30FB\30A8\30F3\30C8\30EA\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104000987574308436)
,p_name=>'LAYOUT.T_SUB_PLUG_HEADER_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30D6\30EA\30FC\30B8\30E7\30F3 - \30D8\30C3\30C0\30FC\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104000786977308436)
,p_name=>'LAYOUT.T_SUB_PLUG_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30D6\30EA\30FC\30B8\30E7\30F3 - \30C6\30F3\30D7\30EC\30FC\30C8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104000561720308436)
,p_name=>'LAYOUT.T_SUB_REGIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30D6\30EA\30FC\30B8\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104000641418308436)
,p_name=>'LAYOUT.T_SUB_REGION_HEADERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30D6\30EA\30FC\30B8\30E7\30F3\306E\30D8\30C3\30C0\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104000492369308436)
,p_name=>'LAYOUT.T_SUB_REGION_HEADER_ENTRIES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30D6\30EA\30FC\30B8\30E7\30F3\306E\30D8\30C3\30C0\30FC\30FB\30A8\30F3\30C8\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104000234837308436)
,p_name=>'LAYOUT.T_SUB_REGION_ID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30D6\30EA\30FC\30B8\30E7\30F3\306E\9759\7684ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104000345210308436)
,p_name=>'LAYOUT.T_SUB_REGION_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30D6\30EA\30FC\30B8\30E7\30F3\306E\30BF\30A4\30C8\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103690176053308158)
,p_name=>'LAYOUT.T_SUCCESS_MSG'
,p_message_language=>'ja'
,p_message_text=>unistr('\6210\529F\30E1\30C3\30BB\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103549720971308051)
,p_name=>'LAYOUT.T_TABULAR_FORM'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\5F62\5F0F\30D5\30A9\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103682394157308152)
,p_name=>'LAYOUT.T_TAB_SET'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30D6\30FB\30BB\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103687384755308156)
,p_name=>'LAYOUT.T_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103707905867308174)
,p_name=>'LAYOUT.T_TEMPLATES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103684405818308154)
,p_name=>'LAYOUT.T_TITLE_CREATE_BRANCH'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30E9\30F3\30C1\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103684969475308154)
,p_name=>'LAYOUT.T_TITLE_CREATE_BUTTON'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103684168650308154)
,p_name=>'LAYOUT.T_TITLE_CREATE_COMPUTATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A08\7B97\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103685150346308154)
,p_name=>'LAYOUT.T_TITLE_CREATE_ITEM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103684269800308154)
,p_name=>'LAYOUT.T_TITLE_CREATE_PROCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30BB\30B9\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103684003835308154)
,p_name=>'LAYOUT.T_TITLE_CREATE_REGION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103684354429308154)
,p_name=>'LAYOUT.T_TITLE_CREATE_VALIDATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103685065560308154)
,p_name=>'LAYOUT.T_TITLE_EDIT_BUTTON'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3\306E\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103685288476308154)
,p_name=>'LAYOUT.T_TITLE_EDIT_BUTTON_ITEM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3\30FB\30A2\30A4\30C6\30E0\306E\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103685376187308155)
,p_name=>'LAYOUT.T_TITLE_EDIT_ITEM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306E\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103684848290308154)
,p_name=>'LAYOUT.T_TITLE_REGION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\30FB\30BF\30A4\30C8\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104129542927308541)
,p_name=>'LAYOUT.T_TRIGGERING_CONDITION'
,p_message_language=>'ja'
,p_message_text=>unistr('WHEN\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104129496774308541)
,p_name=>'LAYOUT.T_TRIGGERING_ELEMENT'
,p_message_language=>'ja'
,p_message_text=>unistr('WHEN\8981\7D20')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103666779216308140)
,p_name=>'LAYOUT.T_UNCONDITIONAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\6761\4EF6\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103681580991308151)
,p_name=>'LAYOUT.T_VALIDATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103692412275308160)
,p_name=>'LAYOUT.T_VALIDATION2'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104307755059308688)
,p_name=>'LAYOUT.T_VALIDATION_ALWAYS_EXEC'
,p_message_language=>'ja'
,p_message_text=>unistr('\5E38\306B\5B9F\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104129112981308541)
,p_name=>'LAYOUT.T_VALIDATION_EXPR1'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C\5F0F1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104129289667308541)
,p_name=>'LAYOUT.T_VALIDATION_EXPR2'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C\5F0F2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104129088203308541)
,p_name=>'LAYOUT.T_VALIDATION_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103678935924308149)
,p_name=>'LAYOUT.T_VIEW_BUTTON'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D3\30E5\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104128422946308540)
,p_name=>'LAYOUT.T_WHEN_BUTTON_PRESSED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3\62BC\4E0B\6642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103688780325308157)
,p_name=>'LAYOUT.T_YES'
,p_message_language=>'ja'
,p_message_text=>unistr('\306F\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103847406927308283)
,p_name=>'LAYOUT.UPDATABLE_SQL_QUERY'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F4\65B0\53EF\80FD\306ASQL\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103809454953308254)
,p_name=>'LAYOUT.USE_APP_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30C7\30D5\30A9\30EB\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104125785346308538)
,p_name=>'LAYOUT.VALIDATING'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103806409246308252)
,p_name=>'LAYOUT_NEVER'
,p_message_language=>'ja'
,p_message_text=>unistr('\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103849114287308285)
,p_name=>'LAYOUT_RUN'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9F\884C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104053680874308478)
,p_name=>'LDAP USERNAME EDIT FUNCTION'
,p_message_language=>'ja'
,p_message_text=>unistr('LDAP\30E6\30FC\30B6\30FC\540D\7DE8\96C6\30D5\30A1\30F3\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103566025848308063)
,p_name=>'LDAP_AUTH_SCHEME_DESC'
,p_message_language=>'ja'
,p_message_text=>'LDAP'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103584426491308076)
,p_name=>'LEARN MORE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3055\3089\306B\5B66\3076')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103702362376308169)
,p_name=>'LEARN_MORE_APEX_HOME'
,p_message_language=>'ja'
,p_message_text=>unistr('Oracle APEX\306B\3064\3044\3066\3055\3089\306B\5B66\7FD2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103702109911308169)
,p_name=>'LEARN_MORE_APP_BUILDER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30D3\30EB\30C0\30FC\306B\3064\3044\3066\3055\3089\306B\5B66\7FD2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103710910880308176)
,p_name=>'LEARN_MORE_PAGE_DESIGNER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30C7\30B6\30A4\30CA\306B\3064\3044\3066\3055\3089\306B\5B66\7FD2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103702222219308169)
,p_name=>'LEARN_MORE_PROD_APPS'
,p_message_language=>'ja'
,p_message_text=>unistr('\751F\7523\6027\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\3064\3044\3066\3055\3089\306B\5B66\7FD2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103702043099308169)
,p_name=>'LEARN_MORE_SQL_WORKSHOP'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\30EF\30FC\30AF\30B7\30E7\30C3\30D7\306B\3064\3044\3066\3055\3089\306B\5B66\7FD2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104307123786308687)
,p_name=>'LEARN_WEBSHEETS'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B7\30FC\30C8\306B\3064\3044\3066\5B66\7FD2\3059\308B\306F\3001\3053\3053\3092\30AF\30EA\30C3\30AF\3057\3066\304F\3060\3055\3044')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104116258275308530)
,p_name=>'LEFT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5DE6')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104760619671309051)
,p_name=>'LEGACY_CALENDAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30AC\30B7\30FC\30FB\30AB\30EC\30F3\30C0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103591149884308081)
,p_name=>'LINES'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104356444568308724)
,p_name=>'LINK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30F3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103626901437308107)
,p_name=>'LINK$'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\30EA\30F3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104028177315308457)
,p_name=>'LINKS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30F3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104754136290309045)
,p_name=>'LINK_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30F3\30AF: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104133788713308544)
,p_name=>'LINK_TO_THIS'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E%0\3078\306E\30EA\30F3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103947852217308396)
,p_name=>'LINK_TO_THIS_PAGE_ITEM'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0%0\306B\30EA\30F3\30AF\3057\307E\3059')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103753943132308211)
,p_name=>'LIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104052650861308477)
,p_name=>'LIST ITEM CONDITION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8\30FB\30A2\30A4\30C6\30E0\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104049141277308474)
,p_name=>'LIST OF VALUES'
,p_message_language=>'ja'
,p_message_text=>'LOV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103622464248308104)
,p_name=>'LISTVIEW'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104086442573308505)
,p_name=>'LISTVIEW_FORM_SUCCESS_MSG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30FC\30E0\304A\3088\3073\30EA\30B9\30C8\30FB\30D3\30E5\30FC\304C\6B63\5E38\306B\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104092801413308510)
,p_name=>'LIST_ENTRY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8\30FB\30A8\30F3\30C8\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104792524945309082)
,p_name=>'LIST_ENTRY_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8\30FB\30A8\30F3\30C8\30EA\30FB\30E9\30D9\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104080940200308501)
,p_name=>'LIST_INITCAP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104197311777308608)
,p_name=>'LIST_ITEMS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8\30FB\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103997841625308434)
,p_name=>'LIST_REGION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8\30FB\30EA\30FC\30B8\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104061227585308484)
,p_name=>'LIST_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103773604514308226)
,p_name=>'LIST_TEMPLATES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103809120084308254)
,p_name=>'LIST_UTILIZATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8\306E\4F7F\7528\72B6\6CC1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104086746815308505)
,p_name=>'LIST_VIEW_ATTRIBUTES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8\30FB\30D3\30E5\30FC\30FB\30DA\30FC\30B8\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104087001235308506)
,p_name=>'LIST_VIEW_PAGE_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8\30FB\30D3\30E5\30FC\30FB\30DA\30FC\30B8\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104086636697308505)
,p_name=>'LIST_VIEW_PAGE_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8\30FB\30D3\30E5\30FC\30FB\30DA\30FC\30B8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104739640675309034)
,p_name=>'LOAD_DATA'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\306E\30ED\30FC\30C9')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104136173936308546)
,p_name=>'LOCK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30C3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104224152535308627)
,p_name=>'LOCKED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30C3\30AF\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103921921299308376)
,p_name=>'LOCKED BY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30C3\30AF\8005: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104742409928309036)
,p_name=>'LOCKED_DATE_BY_USER'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\304C%1\306B\3088\3063\3066\30ED\30C3\30AF\3055\308C\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104742650408309036)
,p_name=>'LOCK_SCRIPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AF\30EA\30D7\30C8\306E\30ED\30C3\30AF')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103934394888308385)
,p_name=>'LOG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104062119601308485)
,p_name=>'LOGGING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30AE\30F3\30B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104130524183308542)
,p_name=>'LOGIN.REMEMBER_USERNAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\540D\3092\8A18\61B6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104130644493308542)
,p_name=>'LOGIN.REMEMBER_USERNAME.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('\3053\306E\30C1\30A7\30C3\30AF\30FB\30DC\30C3\30AF\30B9\3092\9078\629E\3059\308B\3068\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\306F\3001"LOGIN_USERNAME_COOKIE"\3068\3044\3046\540D\524D\306E\6C38\7D9A\7684\306A\30D6\30E9\30A6\30B6cookie\306B\30E6\30FC\30B6\30FC\540D\304C\4FDD\5B58\3055\308C\307E\3059\3002'),
unistr('\6B21\56DE\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8\306B\30A2\30AF\30BB\30B9\3059\308B\3068\3001'),
unistr('\30E6\30FC\30B6\30FC\540D\30D5\30A3\30FC\30EB\30C9\306B\3053\306E\5024\304C\81EA\52D5\7684\306B\79FB\5165\3055\308C\307E\3059\3002'),
'</p>',
'<p>',
unistr('\3053\306E\30C1\30A7\30C3\30AF\30FB\30DC\30C3\30AF\30B9\306E\9078\629E\3092\89E3\9664\3057\3001\30E6\30FC\30B6\30FC\540D\304C\3059\3067\306Bcookie\306B\4FDD\5B58\3055\308C\3066\3044\308B\5834\5408\3001'),
unistr('\7A7A\306E\5024\3067\4E0A\66F8\3055\308C\307E\3059\3002'),
unistr('\30D6\30E9\30A6\30B6\306E\958B\767A\8005\30C4\30FC\30EB\3092\4F7F\7528\3057\3066\3001cookie\3092\5B8C\5168\306B\524A\9664\3059\308B\3053\3068\3082\3067\304D\307E\3059\3002'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104061912775308485)
,p_name=>'LOGIN_URL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30B0\30A4\30F3URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104061842512308485)
,p_name=>'LOGO'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30B4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104548225683308873)
,p_name=>'LOGO.DEFAULT.IMAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30E1\30FC\30B8\304C\8A2D\5B9A\3055\308C\3066\3044\307E\305B\3093\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104548320798308873)
,p_name=>'LOGO.DEFAULT.TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30ED\30B4\30FB\30C6\30AD\30B9\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104546795038308872)
,p_name=>'LOGO.EDITOR.APP.GROUP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30ED\30B4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104547241283308873)
,p_name=>'LOGO.FILE.SIZE.EXCEEDED'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30D5\30A1\30A4\30EB\306F\8A31\5BB9\5236\9650\306E%0\3092\8D85\3048\3066\3044\307E\3059')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104547752284308873)
,p_name=>'LOGO.LABEL.CUSTOM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30B9\30BF\30E0\30FB\30ED\30B4\30FB\30DE\30FC\30AF\30A2\30C3\30D7\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30D3\30EB\30C0\30FC\3067\8A2D\5B9A\3067\304D\307E\3059\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104547698385308873)
,p_name=>'LOGO.LABEL.DRAG_AND_DROP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\3092\30C9\30E9\30C3\30B0\30FB\30A2\30F3\30C9\30FB\30C9\30ED\30C3\30D7\3059\308B\304B\3001\30AF\30EA\30C3\30AF\3057\3066\9078\629E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104547543141308873)
,p_name=>'LOGO.LABEL.IMAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30E1\30FC\30B8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104547893795308873)
,p_name=>'LOGO.LABEL.NONE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30ED\30B4\306F\8868\793A\3055\308C\307E\305B\3093\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104547498663308873)
,p_name=>'LOGO.LABEL.TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104547385170308873)
,p_name=>'LOGO.LABEL.TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104548069114308873)
,p_name=>'LOGO.MSG.IMAGE_REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30ED\30B4\30FB\30BF\30A4\30D7\306B\306F\30ED\30B4\30FB\30A4\30E1\30FC\30B8\304C\5FC5\8981\3067\3059\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104548166923308873)
,p_name=>'LOGO.MSG.SAVE_SUCCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30B4\306F\6B63\5E38\306B\4FDD\5B58\3055\308C\307E\3057\305F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104547948626308873)
,p_name=>'LOGO.MSG.TEXT_REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30ED\30B4\30FB\30BF\30A4\30D7\306B\306F\30ED\30B4\30FB\30C6\30AD\30B9\30C8\304C\5FC5\8981\3067\3059\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104547118073308873)
,p_name=>'LOGO.WRONG.MIME.TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30E1\30FC\30B8\306E\307F\304C\8A31\53EF\3055\308C\307E\3059')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104728577371309024)
,p_name=>'LOG_FEEDBACK_AS_BUG_CONFIRM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30FC\30C9\30D0\30C3\30AF\3092\3054\63D0\4F9B\3044\305F\3060\304D\3001\3042\308A\304C\3068\3046\3054\3056\3044\307E\3059\3002\3053\306E\554F\984C\306B\5BFE\3057\3066\30D0\30B0\304C\4F5C\6210\3055\308C\307E\3057\305F\3002 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104730037363309026)
,p_name=>'LOG_FEEDBACK_AS_FEATURE_CONFIRM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30FC\30C9\30D0\30C3\30AF\3092\3054\63D0\4F9B\3044\305F\3060\304D\3001\3042\308A\304C\3068\3046\3054\3056\3044\307E\3059\3002\3053\306E\30EA\30AF\30A8\30B9\30C8\306F\4ECA\5F8C\306E\30EA\30EA\30FC\30B9\3067\691C\8A0E\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104353331174308721)
,p_name=>'LOG_FEEDBACK_AS_ISSUE_CONFIRM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30FC\30C9\30D0\30C3\30AF\3092\3054\63D0\4F9B\3044\305F\3060\304D\3001\3042\308A\304C\3068\3046\3054\3056\3044\307E\3059\3002\30B7\30B9\30C6\30E0\306E\30ED\30B0\306B\554F\984C\304C\8A18\9332\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104730221853309026)
,p_name=>'LOG_FEEDBACK_AS_TODO_CONFIRM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30FC\30C9\30D0\30C3\30AF\3092\3054\63D0\4F9B\3044\305F\3060\304D\3001\3042\308A\304C\3068\3046\3054\3056\3044\307E\3059\3002\3053\306E\554F\984C\306B\5BFE\51E6\3059\308B\305F\3081\306B\30BF\30B9\30AF\304C\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104758089116309049)
,p_name=>'LOG_IN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30B0\30A4\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103935240476308386)
,p_name=>'LOG_INTERVAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30B0\9593\9694')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104049091082308474)
,p_name=>'LOV ITEM CONDITION'
,p_message_language=>'ja'
,p_message_text=>unistr('LOV\30A2\30A4\30C6\30E0\6761\4EF6')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104006933851308440)
,p_name=>'LOW_PRIORITY'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F4E\512A\5148\5EA6')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103550174620308052)
,p_name=>'MANAGE PAGE GROUPS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30B0\30EB\30FC\30D7\306E\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104198840693308609)
,p_name=>'MANAGE SERVICE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30FC\30D3\30B9\306E\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104198642634308608)
,p_name=>'MANAGE USERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\306E\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104198034834308608)
,p_name=>'MANAGE WORKSPACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306E\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104142532006308552)
,p_name=>'MANAGE_APPLICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103764182624308219)
,p_name=>'MANAGE_UNASSIGNED'
,p_message_language=>'ja'
,p_message_text=>unistr('\672A\5272\5F53\3066\306E\7BA1\7406')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103581681429308074)
,p_name=>'MANUAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\624B\52D5')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103520036552308030)
,p_name=>'MAP_LAYER='
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30A4\30E4\30FC=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103521439932308031)
,p_name=>'MAP_LAYERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30C3\30D7\30FB\30EC\30A4\30E4\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103667321685308141)
,p_name=>'MAP_SUCCESS_MSG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30C3\30D7\306F\6B63\5E38\306B\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104006160627308440)
,p_name=>'MARQUEE_FEATURE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30FC\30AD\30FC\6A5F\80FD')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104080022558308500)
,p_name=>'MASTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30B9\30BF\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104065384378308488)
,p_name=>'MASTERDETAIL_SUCCESS_MSG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30B9\30BF\30FC\30FB\30C7\30A3\30C6\30FC\30EB\30FB\30DA\30FC\30B8\304C\6B63\5E38\306B\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103518761064308029)
,p_name=>'MASTER_DETAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30B9\30BF\30FC\30FB\30C7\30A3\30C6\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103518944198308029)
,p_name=>'MASTER_DETAIL_DETAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306E\8A73\7D30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103518870041308029)
,p_name=>'MASTER_DETAIL_EDIT'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306E\7DE8\96C6')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104131879674308543)
,p_name=>'MATERIALIZED_VIEW'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30C6\30EA\30A2\30E9\30A4\30BA\30C9\30FB\30D3\30E5\30FC')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104027559875308457)
,p_name=>'MAXIMUM_RENDER_TIME_SECONDS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5927\30EC\30F3\30C0\30EA\30F3\30B0\6642\9593(\79D2)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104118721526308532)
,p_name=>'MAXIMUM_SESSION_IDLE_TIME'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5927\30BB\30C3\30B7\30E7\30F3\30FB\30A2\30A4\30C9\30EB\6642\9593(\79D2)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104118832505308532)
,p_name=>'MAXIMUM_SESSION_LENGTH'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5927\30BB\30C3\30B7\30E7\30F3\306E\9577\3055(\79D2)')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103701840435308168)
,p_name=>'MAY_NOT_DELETE'
,p_message_language=>'ja'
,p_message_text=>unistr('\95A2\9023\4ED8\3051\3089\308C\305F\6A5F\80FD\306E\3042\308B\30DE\30A4\30EB\30B9\30C8\30F3\306E\524A\9664\306F\8A31\53EF\3055\308C\3066\3044\307E\305B\3093\3002')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103594007257308083)
,p_name=>'MEMORY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E1\30E2\30EA\30FC:')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103752363825308209)
,p_name=>'MENU'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104052719418308477)
,p_name=>'MENU ITEM CONDITION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0\30FB\30A2\30A4\30C6\30E0\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104061506499308485)
,p_name=>'MENU_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104294666389308678)
,p_name=>'MIGRATION FILES'
,p_message_language=>'ja'
,p_message_text=>unistr('\79FB\884C\30D5\30A1\30A4\30EB')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104048634970308474)
,p_name=>'MILESTONE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30A4\30EB\30B9\30C8\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104028656941308458)
,p_name=>'MILESTONES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30A4\30EB\30B9\30C8\30F3')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104484928304308820)
,p_name=>'MILLISECONDS_MS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DF\30EA\79D2')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104031388573308460)
,p_name=>'MIME_TYPE_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('MIME\30BF\30A4\30D7\5217')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104004681517308439)
,p_name=>'MINIMAL_IMPACT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5C0F\9650\306E\5F71\97FF')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103569182965308065)
,p_name=>'MIN_VERSION'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\4F4E\30D0\30FC\30B8\30E7\30F3')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104729101534309025)
,p_name=>'MISSING_AT_SIGN'
,p_message_language=>'ja'
,p_message_text=>unistr('@\8A18\53F7\304C\3042\308A\307E\305B\3093')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103952146217308399)
,p_name=>'MODEL_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8%0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104006368134308440)
,p_name=>'MODERATELY_DESIRABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E2D\7A0B\5EA6\306B\671B\307E\3057\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104004515079308439)
,p_name=>'MODERATE_IMPACT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E2D\7A0B\5EA6\306E\5F71\97FF')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103691335533308159)
,p_name=>'MODIFIED_ATTRIBUTE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5909\66F4\6E08\5C5E\6027\3092\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104132132224308543)
,p_name=>'MODIFY_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217%0\306E\5909\66F4')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103931894256308383)
,p_name=>'MONITOR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E2\30CB\30BF\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104198758912308608)
,p_name=>'MONITOR ACTIVITY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30C6\30A3\30D3\30C6\30A3\306E\30E2\30CB\30BF\30FC')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104057920574308482)
,p_name=>'MORE_DOT_DOT_DOT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A73\7D30...')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104027011647308456)
,p_name=>'MOST_ACTIVE_APPLICATIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\6700\3082\30A2\30AF\30C6\30A3\30D6\306A\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104022012268308452)
,p_name=>'MOST_RECENT_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\65B0\306E\30A8\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104322641254308699)
,p_name=>'MOST_RECENT_FILE_UPLOAD'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\65B0\306E\30D5\30A1\30A4\30EB\306F%1\306B\3088\3063\3066%2\306B\30A2\30C3\30D7\30ED\30FC\30C9\3055\308C\305F%0\3067\3059 ')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103790406234308240)
,p_name=>'MRU.ERROR_IN_MRU'
,p_message_language=>'ja'
,p_message_text=>unistr('MRU\3067\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F: \884C=%0\3001%1\3001%2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103789343468308239)
,p_name=>'MRU.INVALID_PRIM_KEY_COL'
,p_message_language=>'ja'
,p_message_text=>unistr('\6307\5B9A\3055\308C\305F\4E3B\30AD\30FC\5217\304C\3001\554F\5408\305B\306ESELECT\69CB\6587\306E\30EA\30B9\30C8\306B\898B\3064\304B\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103790585806308240)
,p_name=>'MRU.LOST_UPDATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\304C\66F4\65B0\51E6\7406\3092\958B\59CB\3057\3066\304B\3089\3001\30C7\30FC\30BF\30D9\30FC\30B9\5185\306E\73FE\884C\30D0\30FC\30B8\30E7\30F3\306E\30C7\30FC\30BF\304C\5909\66F4\3055\308C\3066\3044\307E\3059\3002 \73FE\884C\30C1\30A7\30C3\30AF\30B5\30E0=\300C%0\300D\3001\30A2\30A4\30C6\30E0\30FB\30C1\30A7\30C3\30AF\30B5\30E0=\300C%1\300D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103788859892308238)
,p_name=>'MRU.NO_ROWS_TO_PROCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\51E6\7406\3059\308B\5217\304C\5B58\5728\3057\307E\305B\3093')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103706708573308173)
,p_name=>'MUST_BE_XSL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\62E1\5F35\5B50\3068\3057\3066''.xsl''\3092\4F7F\7528\3057\3066\3001\30EC\30DD\30FC\30C8\30FB\30EC\30A4\30A2\30A6\30C8\30FB\30D5\30A1\30A4\30EB\306E\30D5\30A1\30A4\30EB\30FB\30BF\30A4\30D7\3092XSL-FO\306B\6307\5B9A\3057\3066\304F\3060\3055\3044\3002')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103615690444308099)
,p_name=>'MY_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104728079572309023)
,p_name=>'NAMES'
,p_message_language=>'ja'
,p_message_text=>unistr('\540D\524D')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104136016056308546)
,p_name=>'NAVBAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30D0\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104048816435308474)
,p_name=>'NAVBAR ITEM CONDITION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30D0\30FC\30FB\30A2\30A4\30C6\30E0\6761\4EF6')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104731632401309028)
,p_name=>'NAVIGATE_GO_TO_TOP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5148\982D\306B\79FB\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104046719711308472)
,p_name=>'NAVIGATION BAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30D0\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104061764884308485)
,p_name=>'NAVIGATION_LIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CA\30D3\30B2\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103549817885308051)
,p_name=>'NAVIGATION_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30DA\30FC\30B8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103541297559308045)
,p_name=>'NAV_APP_BUILDER_HOME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30D3\30EB\30C0\30FC\306E\30DB\30FC\30E0\30DA\30FC\30B8\306B\30CA\30D3\30B2\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104767822129309064)
,p_name=>'NAV_BAR_LIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9F\88C5: \30EA\30B9\30C8%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104767773758309064)
,p_name=>'NAV_BAR_TRADITIONAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9F\88C5: \30AF\30E9\30B7\30C3\30AF')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104017057874308448)
,p_name=>'NEEDS_REVIEW'
,p_message_language=>'ja'
,p_message_text=>unistr('\78BA\8A8D\304C\5FC5\8981')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104010194023308443)
,p_name=>'NEED_INFORMATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\60C5\5831\304C\5FC5\8981')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104028264936308457)
,p_name=>'NEWS_ENTRIES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CB\30E5\30FC\30B9\30FB\30A8\30F3\30C8\30EA')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104761527738309051)
,p_name=>'NEW_BIND_VARIABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D0\30A4\30F3\30C9\5909\6570%0\306E\65B0\3057\3044\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103771105000308224)
,p_name=>'NEW_EMAIL_ADDRESS'
,p_message_language=>'ja'
,p_message_text=>unistr('Application Express\30A2\30AB\30A6\30F3\30C8\7528\306E\65B0\3057\3044\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104005619827308440)
,p_name=>'NEW_FEATURE_REQUEST'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\6A5F\80FD\306E\30EA\30AF\30A8\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103937883415308388)
,p_name=>'NEW_OR_EXISTING'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F\307E\305F\306F\65E2\5B58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104113951439308528)
,p_name=>'NEW_SCHEMA_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F\30B9\30AD\30FC\30DE\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104021393485308452)
,p_name=>'NEW_SERVICE'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F\30B5\30FC\30D3\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103752202525308209)
,p_name=>'NEW_TABSET'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F\30BF\30D6\30FB\30BB\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104746835481309040)
,p_name=>'NEW_TOP_LEVEL'
,p_message_language=>'ja'
,p_message_text=>unistr('- \89AA\304C\9078\629E\3055\308C\3066\3044\307E\305B\3093 - ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104058262343308482)
,p_name=>'NEW_WORKSPACE_REQUEST'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F\30EF\30FC\30AF\30B9\30DA\30FC\30B9\30FB\30EA\30AF\30A8\30B9\30C8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104066492505308489)
,p_name=>'NO CORRESPONDING REGION'
,p_message_language=>'ja'
,p_message_text=>unistr('\5BFE\5FDC\3059\308B\30EA\30FC\30B8\30E7\30F3\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103999703729308435)
,p_name=>'NO PRIMARY KEY'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\306B\4E3B\30AD\30FC\304C\5B9A\7FA9\3055\308C\3066\3044\307E\305B\3093\3002\30D5\30A9\30FC\30E0\4ED8\304D\30EC\30DD\30FC\30C8\306E\4F5C\6210\6642\306B\306F\4E3B\30AD\30FC\304C\5FC5\8981\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103595847375308085)
,p_name=>'NOARCHIVELOG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30B0\30FB\30A2\30FC\30AB\30A4\30D6: \30AA\30D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103990933116308428)
,p_name=>'NON CURRENT ENTRY'
,p_message_language=>'ja'
,p_message_text=>unistr('\975E\30AB\30EC\30F3\30C8\30FB\30A8\30F3\30C8\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104046599940308472)
,p_name=>'NON CURRENT TAB'
,p_message_language=>'ja'
,p_message_text=>unistr('\975E\30AB\30EC\30F3\30C8\30FB\30BF\30D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104051054415308476)
,p_name=>'NONE_SPECIFIED'
,p_message_language=>'ja'
,p_message_text=>unistr('\672A\6307\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103738620640308198)
,p_name=>'NON_CURRENT_IMAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\975E\30AB\30EC\30F3\30C8\30FB\30A4\30E1\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104115636739308529)
,p_name=>'NON_PACKAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('-\975E\751F\7523\6027\307E\305F\306F\30B5\30F3\30D7\30EB\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3-')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104006856824308440)
,p_name=>'NORMAL_PRIORITY'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A19\6E96\512A\5148\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104728667128309024)
,p_name=>'NOT AVAILABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F7F\7528\4E0D\53EF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104754070012309045)
,p_name=>'NOTE_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CE\30FC\30C8: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103909883588308335)
,p_name=>'NOTIFICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\901A\77E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104003525884308438)
,p_name=>'NOT_A_BUG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D0\30B0\3067\306F\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104760512370309051)
,p_name=>'NOT_CURRENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30EC\30F3\30C8\3067\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104006597433308440)
,p_name=>'NOT_DESIRABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\671B\307E\3057\304F\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104056129750308480)
,p_name=>'NOT_EXISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B58\5728\3057\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103611428128308096)
,p_name=>'NOT_EXISTS_SQL_QUERY'
,p_message_language=>'ja'
,p_message_text=>unistr('NOT EXISTS SQL\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104003659063308438)
,p_name=>'NOT_FEASIBLE_TO_FIX'
,p_message_language=>'ja'
,p_message_text=>unistr('\4FEE\6B63\4E0D\53EF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104135871159308546)
,p_name=>'NOT_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\898B\3064\304B\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104767228638309064)
,p_name=>'NOT_FUNCTIONALLY_COMPLETE'
,p_message_language=>'ja'
,p_message_text=>unistr('80%\4EE5\4E0B\304C\5B8C\4E86\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104068984661308491)
,p_name=>'NOT_INSTALLED'
,p_message_language=>'ja'
,p_message_text=>unistr('\672A\30A4\30F3\30B9\30C8\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103752190132308209)
,p_name=>'NOT_IN_DATA_DICT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30C7\30A3\30AF\30B7\30E7\30CA\30EA\306B\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104007227274308441)
,p_name=>'NOT_PRIORITIZED'
,p_message_language=>'ja'
,p_message_text=>unistr('\512A\5148\5EA6\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104005085275308439)
,p_name=>'NOT_PRORITIZED'
,p_message_language=>'ja'
,p_message_text=>unistr('\512A\5148\5EA6\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104051210872308476)
,p_name=>'NOT_PROVIDED'
,p_message_language=>'ja'
,p_message_text=>unistr('\672A\5165\529B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104326906230308702)
,p_name=>'NOT_REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0D\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104009992659308443)
,p_name=>'NOT_STARTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\672A\958B\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104088482821308507)
,p_name=>'NOT_VALID_VIEW_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('<strong>%0</strong>\306F\3001\6709\52B9\306A\30D3\30E5\30FC\540D\3067\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103568658986308065)
,p_name=>'NO_APPLICATIONS_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304C\898B\3064\304B\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104072103007308493)
,p_name=>'NO_APPLICATION_SELECTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304C\9078\629E\3055\308C\3066\3044\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103846748500308283)
,p_name=>'NO_ARGUMENTS_ALLOWED'
,p_message_language=>'ja'
,p_message_text=>unistr('\5F15\6570\4F7F\7528\4E0D\53EF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104002667275308437)
,p_name=>'NO_ASSIGNED_PRIORITY'
,p_message_language=>'ja'
,p_message_text=>unistr('\5272\5F53\3066\6E08\306E\512A\5148\5EA6\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103614409578308098)
,p_name=>'NO_AUTHORIZATION_SCHEME'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\53EF\30B9\30AD\30FC\30E0\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104051488880308476)
,p_name=>'NO_AVAIL_JOBS'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4F7F\7528\53EF\80FD\306A\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30B8\30E7\30D6\306E\30AD\30E5\30FC\30FB\30D7\30ED\30BB\30B9\304C\3042\308A\307E\305B\3093\3002\7BA1\7406\8005\306B\78BA\8A8D\3057\3066\3001<br>\521D\671F\5316\30D1\30E9\30E1\30FC\30BFJOB_QUEUE_PROCESSES\306E\5024\3092\5897\3084\3059\304B\3001<br>'),
unistr('\307E\305F\306F\4ED6\306E\30B8\30E7\30D6\304C\5B8C\4E86\3059\308B\307E\3067\5F85\6A5F\3057\3066\304F\3060\3055\3044\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103925349290308378)
,p_name=>'NO_BREADCRUMB_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\306B\30D6\30EC\30C3\30C9\30AF\30E9\30E0\30FB\30C6\30F3\30D7\30EC\30FC\30C8\304C\898B\3064\304B\308A\307E\305B\3093\3002\5C11\306A\304F\3068\30821\3064\306E\30D6\30EC\30C3\30C9\30AF\30E9\30E0\30FB\30C6\30F3\30D7\30EC\30FC\30C8\304C\5FC5\8981\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103925458525308378)
,p_name=>'NO_BUTTON_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\306B\30DC\30BF\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8\304C\898B\3064\304B\308A\307E\305B\3093\3002\5C11\306A\304F\3068\30821\3064\306E\30DC\30BF\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8\304C\5FC5\8981\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103924989826308378)
,p_name=>'NO_CALENDAR_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\306B\30AB\30EC\30F3\30C0\30FB\30C6\30F3\30D7\30EC\30FC\30C8\304C\898B\3064\304B\308A\307E\305B\3093\3002\5C11\306A\304F\3068\30821\3064\306E\30AB\30EC\30F3\30C0\30FB\30C6\30F3\30D7\30EC\30FC\30C8\304C\5FC5\8981\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103700922349308168)
,p_name=>'NO_DATE_SPECIFIED'
,p_message_language=>'ja'
,p_message_text=>unistr('\6307\5B9A\3055\308C\305F\65E5\4ED8\304C\3042\308A\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103950746617308398)
,p_name=>'NO_DEBUG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D0\30C3\30B0\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103562866927308061)
,p_name=>'NO_DEVELOPER_PRIV'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\767A\8005\6A29\9650\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103624218199308105)
,p_name=>'NO_DISPLAY_VALUE'
,p_message_language=>'ja'
,p_message_text=>unistr('- \8868\793A\306A\3057 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103579327981308073)
,p_name=>'NO_FEATURES_TARGETED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30FC\30B2\30C3\30C8\6A5F\80FD\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103922906346308376)
,p_name=>'NO_HELP_AVAILABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306B\3064\3044\3066\30D8\30EB\30D7\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104787953738309079)
,p_name=>'NO_ICON_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3\304C\898B\3064\304B\308A\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103673139066308145)
,p_name=>'NO_IMAGES_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30E1\30FC\30B8\304C\898B\3064\304B\308A\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103910172756308335)
,p_name=>'NO_IMAGE_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30E1\30FC\30B8\304C\898B\3064\304B\308A\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103754585544308211)
,p_name=>'NO_ITEM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104116183258308530)
,p_name=>'NO_JOB_QUEUE_PROCESSES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30B8\30E7\30D6\306E\30AD\30E5\30FC\30FB\30D7\30ED\30BB\30B9\304C\6709\52B9\3067\306F\3042\308A\307E\305B\3093\3002<br>'),
unistr('\7BA1\7406\8005\306B\78BA\8A8D\3057\3066\3001\521D\671F\5316\30D1\30E9\30E1\30FC\30BFJOB_QUEUE_PROCESSES\3092\8A2D\5B9A\3057\3066\304F\3060\3055\3044\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103925083201308378)
,p_name=>'NO_LABEL_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\306B\30E9\30D9\30EB\30FB\30C6\30F3\30D7\30EC\30FC\30C8\304C\898B\3064\304B\308A\307E\305B\3093\3002\5C11\306A\304F\3068\30821\3064\306E\30E9\30D9\30EB\30FB\30C6\30F3\30D7\30EC\30FC\30C8\304C\5FC5\8981\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103656755028308133)
,p_name=>'NO_LAYOUT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\30FB\30EC\30A4\30A2\30A6\30C8\304C\9078\629E\3055\308C\3066\3044\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103925274365308378)
,p_name=>'NO_LIST_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\306B\30EA\30B9\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\304C\898B\3064\304B\308A\307E\305B\3093\3002\5C11\306A\304F\3068\30821\3064\306E\30EA\30B9\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\304C\5FC5\8981\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104005856622308440)
,p_name=>'NO_LONGER_AN_ISSUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3067\306B\554F\984C\3067\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103614209701308098)
,p_name=>'NO_LOV'
,p_message_language=>'ja'
,p_message_text=>unistr('LOV\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104049795541308475)
,p_name=>'NO_MILESTONES_EXIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30A4\30EB\30B9\30C8\30F3\304C\672A\5B9A\7FA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104276491569308665)
,p_name=>'NO_NAVIGATION_LIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC\30FB\30EA\30B9\30C8\3092\8868\793A\3057\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103656679352308133)
,p_name=>'NO_PAGE_DEV_PRIV'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\767A\8005\306F\3001\3053\306E\30DA\30FC\30B8\306B\30B3\30F3\30DD\30FC\30CD\30F3\30C8\3092\4F5C\6210\3059\308B\6A29\9650\3092\6240\6709\3057\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103925692165308379)
,p_name=>'NO_PAGE_TEMPLATES_FOUND_IN_APP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\3092\30B3\30D4\30FC\3057\3088\3046\3068\3057\307E\3057\305F\304C\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3%0\306B\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\304C\898B\3064\304B\308A\307E\305B\3093\3067\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103924776731308378)
,p_name=>'NO_PAGE_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\306B\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\304C\898B\3064\304B\308A\307E\305B\3093\3002\5C11\306A\304F\3068\30821\3064\306E\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\304C\5FC5\8981\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103848382185308284)
,p_name=>'NO_PARENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\89AA\30D6\30EC\30C3\30C9\30AF\30E9\30E0\30FB\30A8\30F3\30C8\30EA\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104296864892308680)
,p_name=>'NO_PARENT_TABS_HAVE_BEEN_DEFINED'
,p_message_language=>'ja'
,p_message_text=>unistr('\89AA\30BF\30D6\304C\5B9A\7FA9\3055\308C\3066\3044\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104057827472308482)
,p_name=>'NO_PENDING_REQUESTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\4FDD\7559\4E2D\306E\30EA\30AF\30A8\30B9\30C8\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103925586162308378)
,p_name=>'NO_POPUP_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\306B\30DD\30C3\30D7\30A2\30C3\30D7LOV\30C6\30F3\30D7\30EC\30FC\30C8\304C\898B\3064\304B\308A\307E\305B\3093\3002\30DD\30C3\30D7\30A2\30C3\30D7LOV\30C6\30F3\30D7\30EC\30FC\30C8\304C1\3064\5FC5\8981\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104007122412308441)
,p_name=>'NO_PRIORITY'
,p_message_language=>'ja'
,p_message_text=>unistr('\512A\5148\5EA6\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104094190247308511)
,p_name=>'NO_REGION_POSITION_IN_PAGE_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30EA\30FC\30B8\30E7\30F3\306E\4F4D\7F6E\306F\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306B\306F\3042\308A\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103924815840308378)
,p_name=>'NO_REGION_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\306B\30EA\30FC\30B8\30E7\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8\304C\898B\3064\304B\308A\307E\305B\3093\3002\5C11\306A\304F\3068\30821\3064\306E\30EA\30FC\30B8\30E7\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8\304C\5FC5\8981\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103925126232308378)
,p_name=>'NO_REPORT_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\306B\30EC\30DD\30FC\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\304C\898B\3064\304B\308A\307E\305B\3093\3002\5C11\306A\304F\3068\30821\3064\306E\30EC\30DD\30FC\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\304C\5FC5\8981\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103614397554308098)
,p_name=>'NO_SHORTCUT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30E7\30FC\30C8\30AB\30C3\30C8\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104009807575308443)
,p_name=>'NO_STATUS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30C6\30FC\30BF\30B9\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104058457078308482)
,p_name=>'NO_SYSTEM_MESSAGE_DEFINED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30B9\30C6\30E0\30FB\30E1\30C3\30BB\30FC\30B8\304C\5B9A\7FA9\3055\308C\3066\3044\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104352757267308721)
,p_name=>'NO_TABS_DEFINED'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\306F\30BF\30D6\304C\5B9A\7FA9\3055\308C\3066\3044\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104297075293308680)
,p_name=>'NO_TABS_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30D6\304C\898B\3064\304B\308A\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104294209470308678)
,p_name=>'NO_TABS_HAVE_BEEN_DEFINED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30D6\304C\5B9A\7FA9\3055\308C\3066\3044\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104296961960308680)
,p_name=>'NO_TABS_SELECTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30D6\304C\9078\629E\3055\308C\3066\3044\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104728454788309023)
,p_name=>'NO_TAGS_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30B0\304C\898B\3064\304B\308A\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103754457910308211)
,p_name=>'NO_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103846820250308283)
,p_name=>'NO_URL_ACCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('URL\30A2\30AF\30BB\30B9\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104338764115308711)
,p_name=>'NO_WHITE_LIST_DEFINED'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\30BF\30B0\3092\4F7F\7528\3059\308B\306B\306F\3001\8A31\5BB9\3055\308C\308B\8868\306E\30EA\30B9\30C8\3092\5B9A\7FA9\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\3053\308C\306F\30BB\30AD\30E5\30EA\30C6\30A3\4E0A\306E\7406\7531\306B\3088\308B\3082\306E\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104004393917308439)
,p_name=>'NO_WORKAROUND_AVAILABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F7F\7528\53EF\80FD\306A\56DE\907F\7B56\306A\3057')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103750618108308208)
,p_name=>'NULL_IN_PAREN'
,p_message_language=>'ja'
,p_message_text=>'(NULL)'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104135275989308546)
,p_name=>'NUMBER_OF_FEEDBACK_ENTRIES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C8\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104088283496308507)
,p_name=>'NUMBER_OF_USERS_FILING_FEEDBACK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103579292770308073)
,p_name=>'NUM_TOTAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5408\8A08 %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103986749078308425)
,p_name=>'OBJECTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30D6\30B8\30A7\30AF\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104282173843308669)
,p_name=>'OBJECTS_WITHOUT_DEFAULTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\5024\3092\4F7F\7528\3057\306A\3044\30AA\30D6\30B8\30A7\30AF\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104282078622308669)
,p_name=>'OBJECTS_WITH_DEFAULTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\5024\3092\4F7F\7528\3059\308B\30AA\30D6\30B8\30A7\30AF\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104753665529309045)
,p_name=>'OBJECT_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30D6\30B8\30A7\30AF\30C8: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104075022975308496)
,p_name=>'OB_CASCADE_DELETE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30B9\30B1\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104016317033308448)
,p_name=>'OB_CHECK_CON_NN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30A7\30C3\30AF\5236\7D04\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103570400116308066)
,p_name=>'OB_COMPILE_ERRORS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\30A8\30E9\30FC\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104076133622308497)
,p_name=>'OB_CONSTRAINT_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\5236\7D04\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104076298518308497)
,p_name=>'OB_CONS_INFO'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217/\30C1\30A7\30C3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104016149015308447)
,p_name=>'OB_CONS_NAME_NN'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\5236\7D04\540D\300D\306B\5024\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104016578719308448)
,p_name=>'OB_CONS_NAME_USED'
,p_message_language=>'ja'
,p_message_text=>unistr('\5236\7D04\540D\306F\3059\3067\306B\4F7F\7528\3055\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104074726323308495)
,p_name=>'OB_FK_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\5916\90E8\30AD\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104015771824308447)
,p_name=>'OB_FK_NAME_NOT_NULL'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\5916\90E8\30AD\30FC\540D\300D\306B\5024\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104016445094308448)
,p_name=>'OB_FK_NAME_USED'
,p_message_language=>'ja'
,p_message_text=>unistr('\5916\90E8\30AD\30FC\540D\306F\3059\3067\306B\4F7F\7528\3055\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104074892722308496)
,p_name=>'OB_FK_REFERENCED'
,p_message_language=>'ja'
,p_message_text=>unistr('\53C2\7167\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104074906710308496)
,p_name=>'OB_FK_REFERENCED_TAB'
,p_message_language=>'ja'
,p_message_text=>unistr('\53C2\7167\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104016084554308447)
,p_name=>'OB_FK_REF_COLS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5916\90E8\30AD\30FC\306E\53C2\7167\5217\3092\9078\629E\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104015943065308447)
,p_name=>'OB_FK_REF_TAB'
,p_message_language=>'ja'
,p_message_text=>unistr('\5916\90E8\30AD\30FC\306E\53C2\7167\8868\3092\9078\629E\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104015862167308447)
,p_name=>'OB_FK_SEL_COLS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5916\90E8\30AD\30FC\5217\3092\9078\629E\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104136579375308547)
,p_name=>'OB_POSITION'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104076392853308497)
,p_name=>'OB_SELECT_DATATYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('- \30C7\30FC\30BF\578B\306E\9078\629E -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104075174392308496)
,p_name=>'OB_SET_NULL'
,p_message_language=>'ja'
,p_message_text=>unistr('NULL\306B\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104016200193308448)
,p_name=>'OB_UK_COLS'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E00\610F\30AD\30FC\306B\306F\5217\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104485187006308820)
,p_name=>'ODG.API.START'
,p_message_language=>'ja'
,p_message_text=>'%0  START'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104485050837308820)
,p_name=>'ODG.API.UNHANDLED'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\672A\51E6\7406\4F8B\5916')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104485268431308820)
,p_name=>'ODG.API.UNHANDLED_BUILTIN'
,p_message_language=>'ja'
,p_message_text=>unistr('\672A\51E6\7406\7D44\8FBC\307Fdata_source: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104486066928308821)
,p_name=>'ODG.BLUEPRINT.BLUEPRINT_NOT_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EB\30FC\30D7\30EA\30F3\30C8\304C\898B\3064\304B\3089\306A\3044\304B\4F5C\6210\3055\308C\3066\3044\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103537670679308043)
,p_name=>'ODG.BLUEPRINT.DATA_SOURCE_NAME_26'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30BD\30FC\30B9\540D\306F26\6587\5B57\4EE5\4E0B\306B\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103537533306308043)
,p_name=>'ODG.BLUEPRINT.ERROR_IMPORTING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30DD\30FC\30C8\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104485946122308821)
,p_name=>'ODG.BLUEPRINT.ERR_INSERT_SELECT'
,p_message_language=>'ja'
,p_message_text=>unistr('INSERT-SELECT SQL\6587\306E\4F5C\6210\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104485491684308821)
,p_name=>'ODG.BLUEPRINT.ERR_JSON_DATA'
,p_message_language=>'ja'
,p_message_text=>unistr('%0 JSON\30C7\30FC\30BF\3092\53D6\5F97\3057\3066\3044\307E\3059\3002URL: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104486182207308821)
,p_name=>'ODG.BLUEPRINT.INSERT_INTO_SCRIPT'
,p_message_language=>'ja'
,p_message_text=>unistr('INSERT INTO\30B9\30AF\30EA\30D7\30C8:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103537821161308043)
,p_name=>'ODG.BLUEPRINT.INVALID_BUILTIN'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D44\8FBC\307F\30C7\30FC\30BF\30FB\30BD\30FC\30B9\304C\7121\52B9\3067\3059: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104485844418308821)
,p_name=>'ODG.BLUEPRINT.JSON_NULL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC: JSON\30C7\30FC\30BF\304Cnull\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104485567666308821)
,p_name=>'ODG.BLUEPRINT.NOT_VALID_OBJECT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6709\52B9\306A\30AA\30D6\30B8\30A7\30AF\30C8\3067\306F\3042\308A\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104485641077308821)
,p_name=>'ODG.BLUEPRINT.NO_ROWS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC\3002\30EA\30AF\30A8\30B9\30C8\3055\308C\305F\884C\306F\3042\308A\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104485380503308820)
,p_name=>'ODG.BLUEPRINT.TO_MANY_ROWS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30AF\30A8\30B9\30C8\3055\308C\305F\884C\304C\591A\3059\304E\307E\3059\3002\8A31\53EF\3055\308C\308B\6700\5927\884C\6570\306F%0\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104485712277308821)
,p_name=>'ODG.BLUEPRINT.UNEXPECTED_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306E\30ED\30FC\30C9\4E2D\306B\4E88\671F\3057\306A\3044\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103537758309308043)
,p_name=>'ODG.BLUEPRINT.VALUE_Y_N'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306FY\307E\305F\306FN\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103615501372308099)
,p_name=>'ONE'
,p_message_language=>'ja'
,p_message_text=>'1'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103568151411308065)
,p_name=>'ONLY_INSTALLED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30B9\30C8\30FC\30EB\6E08\306E\307F')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103805130634308251)
,p_name=>'ON_LOAD'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30FC\30C9\6642')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104005905526308440)
,p_name=>'OPEN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30FC\30D7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104051596886308476)
,p_name=>'OPENED_LAST_7_DAYS'
,p_message_language=>'ja'
,p_message_text=>unistr('\904E\53BB7\65E5\9593\306B\30AA\30FC\30D7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104050630394308476)
,p_name=>'OPEN_BUGS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30FC\30D7\30F3\30FB\30D0\30B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104050347444308475)
,p_name=>'OPEN_FEATURES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30FC\30D7\30F3\6A5F\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104284190746308670)
,p_name=>'OPEN_PROCESSING_FEEDBACK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30FC\30C9\30D0\30C3\30AF\3092\30AA\30FC\30D7\30F3\3057\3066\51E6\7406\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104050582729308475)
,p_name=>'OPEN_TO_DOS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30FC\30D7\30F3To Do')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103657768264308134)
,p_name=>'OPEN_WEBSHEET'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B7\30FC\30C8%0\3092\958B\304F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103991712388308429)
,p_name=>'OPTIONAL ATTRIBUTE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30D7\30B7\30E7\30F3\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104771995226309067)
,p_name=>'OPTIONAL ICON CSS CLASSES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30D7\30B7\30E7\30F3\306E\30A2\30A4\30B3\30F3CSS\30AF\30E9\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103991675146308429)
,p_name=>'OPTIONAL IMAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30D7\30B7\30E7\30F3\306E\30A4\30E1\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103991875902308429)
,p_name=>'OPTIONAL IMAGE ATTRIBUTES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30D7\30B7\30E7\30F3\306E\30A4\30E1\30FC\30B8\5C5E\6027')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104294738665308678)
,p_name=>'ORACLE FORMS'
,p_message_language=>'ja'
,p_message_text=>'Oracle Forms'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104699588465309000)
,p_name=>'ORDS_BASED_PRINTING_DESUPPORTED'
,p_message_language=>'ja'
,p_message_text=>unistr('Oracle REST Data Services\30D9\30FC\30B9\306E\51FA\529B\306F\3001Oracle APEX 19.1\3067\975E\63A8\5968\3068\306A\308A\3001\30B5\30DD\30FC\30C8\3055\308C\306A\304F\306A\308A\307E\3057\305F\3002')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103549617836308051)
,p_name=>'OTHER'
,p_message_language=>'ja'
,p_message_text=>unistr('\305D\306E\4ED6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104295306348308679)
,p_name=>'OTHER WORKSPACE FILES'
,p_message_language=>'ja'
,p_message_text=>unistr('\4ED6\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9\30FB\30D5\30A1\30A4\30EB')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104044285139308470)
,p_name=>'OTN'
,p_message_language=>'ja'
,p_message_text=>'Oracle Technology Network'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104044301022308470)
,p_name=>'OTN_FORUM'
,p_message_language=>'ja'
,p_message_text=>unistr('Oracle Technology Network\30C7\30A3\30B9\30AB\30C3\30B7\30E7\30F3\30FB\30D5\30A9\30FC\30E9\30E0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104174391714308587)
,p_name=>'OVERRIDE_ID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30FC\30D0\30FC\30E9\30A4\30C9ID')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104750464394309043)
,p_name=>'OVERVIEW'
,p_message_language=>'ja'
,p_message_text=>unistr('\6982\8981')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103731920881308193)
,p_name=>'OWNER'
,p_message_language=>'ja'
,p_message_text=>unistr('\6240\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103578904511308072)
,p_name=>'OWNERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6240\6709\8005')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103955926127308402)
,p_name=>'P4000.P4651.SQL_QUERY.FUNC_BODY'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B\30D5\30A1\30F3\30AF\30B7\30E7\30F3\3002\672C\4F53')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104093524161308511)
,p_name=>'P4001_APPLICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3%0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103706351820308172)
,p_name=>'P4111_USED_ON_PAGES'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306ELOV\306F\524A\9664\3067\304D\307E\305B\3093\3002%0\30DA\30FC\30B8\3067\4F7F\7528\3055\308C\3066\3044\307E\3059\3002')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104056208449308480)
,p_name=>'P4316_BIND_ITEM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306E\30D0\30A4\30F3\30C9(\30A2\30A4\30C6\30E0\540D\306E\5165\529B)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104705014228309004)
,p_name=>'P473_NEEDS_REFRESH'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30D5\30EC\30C3\30B7\30E5\304C\5FC5\8981\306A\53EF\80FD\6027\304C\3042\308A\307E\3059\3002')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104707834243309006)
,p_name=>'P4905_BUTTON_ALT_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D7\30ED\30A4\30E1\30F3\30C8\30FB\30B5\30FC\30D0\30FC\306E\8FFD\52A0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103982447040308422)
,p_name=>'P58_BROWSE_SEQ'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30EA\30F3\30AF\3092\53C2\7167')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103978483323308419)
,p_name=>'P58_NO_SUCCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\304C\539F\56E0\3067\3001\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30EA\30F3\30AF\4F5C\6210\64CD\4F5C\304C\6B63\5E38\306B\5B9F\884C\3055\308C\307E\305B\3093\3067\3057\305F:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103978549731308419)
,p_name=>'P58_SEQUENCE_CREATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C%1\300D\30B9\30AD\30FC\30DE\306B\3001\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30EA\30F3\30AF\300C%0\300D\304C\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103751427963308208)
,p_name=>'PACKAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30C3\30B1\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103926057987308379)
,p_name=>'PACKAGED_APPLICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\751F\7523\6027\307E\305F\306F\30B5\30F3\30D7\30EB\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103588789157308079)
,p_name=>'PACKAGED_APPLICATIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\751F\7523\6027\304A\3088\3073\30B5\30F3\30D7\30EB\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104137816068308548)
,p_name=>'PACKAGED_APP_INSTALL_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30A4\30F3\30B9\30C8\30FC\30EB\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103969120871308412)
,p_name=>'PACKAGE_BODY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30C3\30B1\30FC\30B8\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104115556783308529)
,p_name=>'PACKAGE_GLOBALS'
,p_message_language=>'ja'
,p_message_text=>unistr('-\30B0\30ED\30FC\30D0\30EB-')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103733430666308194)
,p_name=>'PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104053807847308478)
,p_name=>'PAGE COMPUTATION CONDITION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\8A08\7B97\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104134146650308545)
,p_name=>'PAGE HEADER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30D8\30C3\30C0\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104046393506308472)
,p_name=>'PAGE HEADER, BODY, AND FOOTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D8\30C3\30C0\30FC\30FB\30D8\30C3\30C0\30FC\3001\30DC\30C7\30A3\304A\3088\3073\30D5\30C3\30BF\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104054165487308478)
,p_name=>'PAGE ITEM DEFAULT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306E\30C7\30D5\30A9\30EB\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104054367707308479)
,p_name=>'PAGE ITEM DISPLAY CONDITION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306E\8868\793A\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104054540728308479)
,p_name=>'PAGE ITEM LOV'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306ELOV')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104054298049308478)
,p_name=>'PAGE ITEM POST COMPUTATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306E\8A08\7B97\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104054476447308479)
,p_name=>'PAGE ITEM READ-ONLY DISPLAY CONDITION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306E\8AAD\53D6\308A\5C02\7528\8868\793A\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104054066211308478)
,p_name=>'PAGE ITEM SOURCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\30FB\30BD\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103969515438308412)
,p_name=>'PAGE ITEMS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104047177038308473)
,p_name=>'PAGE PROCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30D7\30ED\30BB\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104047205377308473)
,p_name=>'PAGE PROCESS CONDITION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30D7\30ED\30BB\30B9\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104053913153308478)
,p_name=>'PAGE VALIDATION CONDITION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\691C\8A3C\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103983482088308423)
,p_name=>'PAGES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104197536839308608)
,p_name=>'PAGE_ATTRIBUTES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104028049802308457)
,p_name=>'PAGE_EVENTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30A4\30D9\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104064209034308487)
,p_name=>'PAGE_EVENTS_FOR_LAST_X'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30A4\30D9\30F3\30C8: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104780440051309074)
,p_name=>'PAGE_FINDER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30D5\30A1\30A4\30F3\30C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103542891960308046)
,p_name=>'PAGE_GROUP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30B0\30EB\30FC\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104063711492308486)
,p_name=>'PAGE_HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5185\306E\30DA\30FC\30B8\3092\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104228958883308631)
,p_name=>'PAGE_ID_LOCKED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8%0\304C\30ED\30C3\30AF\3055\308C\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104229053085308631)
,p_name=>'PAGE_ID_UNLOCKED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8%0\304C\30ED\30C3\30AF\304C\89E3\9664\3055\308C\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104074276693308495)
,p_name=>'PAGE_INSTALL_SUCCESS_MSG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30DA\30FC\30B8\304C\6B63\5E38\306B\30A4\30F3\30B9\30C8\30FC\30EB\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103970041365308413)
,p_name=>'PAGE_ITEM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104180151726308593)
,p_name=>'PAGE_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104014999168308446)
,p_name=>'PAGE_LOCKED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\304C\30ED\30C3\30AF\3055\308C\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103923407738308377)
,p_name=>'PAGE_LOCKED_BY'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306B\3088\3063\3066\30ED\30C3\30AF\3055\308C\305F\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104043907902308470)
,p_name=>'PAGE_NAME_REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\540D\306F\3059\3079\3066\306E\30DA\30FC\30B8\306B\5FC5\8981\3067\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104027861912308457)
,p_name=>'PAGE_POSTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30DD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104197614271308608)
,p_name=>'PAGE_PROCESSES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30D7\30ED\30BB\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103579605486308073)
,p_name=>'PAGE_PROCESSING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30D7\30ED\30BB\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104065051643308487)
,p_name=>'PAGE_PROTECTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\4FDD\8B77')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103744916425308203)
,p_name=>'PAGE_REGION.LIST_ITEM_SEQ'
,p_message_language=>'ja'
,p_message_text=>unistr('\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103745104781308204)
,p_name=>'PAGE_REGION.LIST_ITEM_TARGET'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30FC\30B2\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103745062518308204)
,p_name=>'PAGE_REGION.LIST_ITEM_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103744717124308203)
,p_name=>'PAGE_REGION.LIST_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\540D\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103744827977308203)
,p_name=>'PAGE_REGION.LIST_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103744684729308203)
,p_name=>'PAGE_REGION.QUERY_HIDE_SOURCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BD\30FC\30B9\3092\975E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103744580931308203)
,p_name=>'PAGE_REGION.QUERY_SHOW_SOURCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BD\30FC\30B9\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103744336292308203)
,p_name=>'PAGE_REGION.TREE_ITEM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103744108520308203)
,p_name=>'PAGE_REGION.TREE_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C4\30EA\30FC\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103744410541308203)
,p_name=>'PAGE_REGION.TREE_QUERY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C4\30EA\30FC\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103744274038308203)
,p_name=>'PAGE_REGION.TREE_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103667115309308141)
,p_name=>'PAGE_SUCCESS_MSG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8%0\304C\6B63\5E38\306B\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104046231259308472)
,p_name=>'PAGE_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104015048368308446)
,p_name=>'PAGE_UNLOCKED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\304C\30ED\30C3\30AF\89E3\9664\3055\308C\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104027912296308457)
,p_name=>'PAGE_VIEWS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30D3\30E5\30FC')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104023642672308454)
,p_name=>'PARENT_FEATURE_ID'
,p_message_language=>'ja'
,p_message_text=>unistr('\89AA\6A5F\80FD\756A\53F7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104133812145308545)
,p_name=>'PARENT_REPORT_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\89AA\30EC\30DD\30FC\30C8\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104295549703308679)
,p_name=>'PARENT_TAB'
,p_message_language=>'ja'
,p_message_text=>unistr('\89AA\30BF\30D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104293825799308678)
,p_name=>'PARENT_TABS'
,p_message_language=>'ja'
,p_message_text=>unistr('\89AA\30BF\30D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103738102082308198)
,p_name=>'PARENT_TAB_SET'
,p_message_language=>'ja'
,p_message_text=>unistr('\89AA\30BF\30D6\30FB\30BB\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103738203940308198)
,p_name=>'PARENT_TAB_SET_NEW'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F\89AA\30BF\30D6\30FB\30BB\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103738379776308198)
,p_name=>'PARENT_TAB_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\89AA\30BF\30D6\30FB\30C6\30AD\30B9\30C8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104294523351308678)
,p_name=>'PARRENT_TAB_SET'
,p_message_language=>'ja'
,p_message_text=>unistr('\89AA\30BF\30D6\30FB\30BB\30C3\30C8')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103582861832308075)
,p_name=>'PARSING_SCHEMA'
,p_message_language=>'ja'
,p_message_text=>unistr('\89E3\6790\5BFE\8C61\30B9\30AD\30FC\30DE')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103579753561308073)
,p_name=>'PARTIAL_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\90E8\5206\30DA\30FC\30B8')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103563029617308061)
,p_name=>'PASSWORD_EXPIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30B9\30EF\30FC\30C9\306E\671F\9650\5207\308C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103550770291308052)
,p_name=>'PASSWORD_MUST_BE_CHANGED'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30AB\30A6\30F3\30C8\306E\30D1\30B9\30EF\30FC\30C9\3092\5909\66F4\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103562992161308061)
,p_name=>'PASSWORD_VALID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30B9\30EF\30FC\30C9\304C\6709\52B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103570769626308067)
,p_name=>'PASSWORD_WITH_SUBMIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30B9\30EF\30FC\30C9([Enter]\3092\62BC\3059\3068\9001\4FE1)')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104087557234308506)
,p_name=>'PAST_DUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\671F\9650\7D4C\904E')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104177459443308590)
,p_name=>'PATH'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30B9')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104336933925308709)
,p_name=>'PCT_CLOSED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30ED\30FC\30BA%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104333264437308707)
,p_name=>'PCT_GRAPH_FORMAT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30FC\30BB\30F3\30C6\30FC\30B8\306E\30B0\30E9\30D5\30A3\30AB\30EB\306A\66F8\5F0F\30010\304B\3089100\307E\3067\306E\6574\6570')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104246063632308643)
,p_name=>'PE.COMPONEN.TYPE.APPLICATION.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104246132884308643)
,p_name=>'PE.COMPONEN.TYPE.APPLICATION.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104582697391308905)
,p_name=>'PE.COMPONEN.TYPE.APP_COMPUTATION.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\8A08\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104582766702308905)
,p_name=>'PE.COMPONEN.TYPE.APP_COMPUTATION.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\8A08\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104248022033308644)
,p_name=>'PE.COMPONEN.TYPE.APP_ITEM.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104248113156308645)
,p_name=>'PE.COMPONEN.TYPE.APP_ITEM.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104582861163308905)
,p_name=>'PE.COMPONEN.TYPE.APP_PROCESS.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30D7\30ED\30BB\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104582943372308905)
,p_name=>'PE.COMPONEN.TYPE.APP_PROCESS.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30D7\30ED\30BB\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104248477115308645)
,p_name=>'PE.COMPONEN.TYPE.AUTHENTICATION.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104248532467308645)
,p_name=>'PE.COMPONEN.TYPE.AUTHENTICATION.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104248660458308645)
,p_name=>'PE.COMPONEN.TYPE.AUTHORIZATION.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\53EF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104248793592308645)
,p_name=>'PE.COMPONEN.TYPE.AUTHORIZATION.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\53EF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104483205063308819)
,p_name=>'PE.COMPONEN.TYPE.AUTOMATION.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\52D5\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104483361684308819)
,p_name=>'PE.COMPONEN.TYPE.AUTOMATION.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\52D5\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104719952036309016)
,p_name=>'PE.COMPONEN.TYPE.AUTOMATION_ACTION.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\52D5\5316\30A2\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104720074071309017)
,p_name=>'PE.COMPONEN.TYPE.AUTOMATION_ACTION.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\52D5\5316\30A2\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104252277093308647)
,p_name=>'PE.COMPONEN.TYPE.BRANCH.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30E9\30F3\30C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104252326069308648)
,p_name=>'PE.COMPONEN.TYPE.BRANCH.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30E9\30F3\30C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104248893260308645)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104248984337308645)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104583077014308905)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB_ENTRY.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0\30FB\30A8\30F3\30C8\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104583135536308905)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB_ENTRY.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0\30FB\30A8\30F3\30C8\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104247481429308644)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB_TEMPLATE.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104247591033308644)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB_TEMPLATE.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104248208221308645)
,p_name=>'PE.COMPONEN.TYPE.BUILD_OPTION.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D3\30EB\30C9\30FB\30AA\30D7\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104248380910308645)
,p_name=>'PE.COMPONEN.TYPE.BUILD_OPTION.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D3\30EB\30C9\30FB\30AA\30D7\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104251028397308647)
,p_name=>'PE.COMPONEN.TYPE.BUTTON.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104251177807308647)
,p_name=>'PE.COMPONEN.TYPE.BUTTON.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104247013822308644)
,p_name=>'PE.COMPONEN.TYPE.BUTTON_TEMPLATE.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104247115534308644)
,p_name=>'PE.COMPONEN.TYPE.BUTTON_TEMPLATE.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104247613356308644)
,p_name=>'PE.COMPONEN.TYPE.CALENDAR_TEMPLATE.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30AC\30B7\30FC\30FB\30AB\30EC\30F3\30C0\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104247742758308644)
,p_name=>'PE.COMPONEN.TYPE.CALENDAR_TEMPLATE.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30AC\30B7\30FC\30FB\30AB\30EC\30F3\30C0\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104563464325308889)
,p_name=>'PE.COMPONEN.TYPE.CARD.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104563522216308889)
,p_name=>'PE.COMPONEN.TYPE.CARD.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104563613795308889)
,p_name=>'PE.COMPONEN.TYPE.CARD_ACTION.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104563773182308889)
,p_name=>'PE.COMPONEN.TYPE.CARD_ACTION.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104265602281308657)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_CALENDAR.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104265730633308657)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_CALENDAR.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104253846983308649)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104253991945308649)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104254064697308649)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT_COLUMN.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104254152840308649)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT_COLUMN.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104343200674308714)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT_PRINT_ATTR.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\51FA\529B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104343345497308714)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT_PRINT_ATTR.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\51FA\529B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104550216486308875)
,p_name=>'PE.COMPONEN.TYPE.DATA_LOAD_DEFINITION.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30ED\30FC\30C9\5B9A\7FA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104550394195308875)
,p_name=>'PE.COMPONEN.TYPE.DATA_LOAD_DEFINITION.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30ED\30FC\30C9\5B9A\7FA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104249864364308646)
,p_name=>'PE.COMPONEN.TYPE.DATA_LOAD_TABLE.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30AC\30B7\30FC\30FB\30C7\30FC\30BF\30FB\30ED\30FC\30C9\5B9A\7FA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104249969791308646)
,p_name=>'PE.COMPONEN.TYPE.DATA_LOAD_TABLE.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30AC\30B7\30FC\30FB\30C7\30FC\30BF\30FB\30ED\30FC\30C9\5B9A\7FA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104251439841308647)
,p_name=>'PE.COMPONEN.TYPE.DYNAMIC_ACTION_ACTION.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104251578029308647)
,p_name=>'PE.COMPONEN.TYPE.DYNAMIC_ACTION_ACTION.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104251243096308647)
,p_name=>'PE.COMPONEN.TYPE.DYNAMIC_ACTION_EVENT.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\52D5\7684\30A2\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104251381652308647)
,p_name=>'PE.COMPONEN.TYPE.DYNAMIC_ACTION_EVENT.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\52D5\7684\30A2\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103807801296308253)
,p_name=>'PE.COMPONEN.TYPE.EMAIL_TEMPLATE.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103807945234308253)
,p_name=>'PE.COMPONEN.TYPE.EMAIL_TEMPLATE.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104483573534308819)
,p_name=>'PE.COMPONEN.TYPE.FACET.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30BB\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104483615432308819)
,p_name=>'PE.COMPONEN.TYPE.FACET.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30BB\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104554898952308878)
,p_name=>'PE.COMPONEN.TYPE.FACET_GROUP.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30BB\30C3\30C8\30FB\30B0\30EB\30FC\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104554938554308883)
,p_name=>'PE.COMPONEN.TYPE.FACET_GROUP.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30BB\30C3\30C8\30FB\30B0\30EB\30FC\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104555076262308883)
,p_name=>'PE.COMPONEN.TYPE.FACET_GROUP_ITEM.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30A7\30C3\30AF\30DC\30C3\30AF\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104555182057308883)
,p_name=>'PE.COMPONEN.TYPE.FACET_GROUP_ITEM.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30A7\30C3\30AF\30DC\30C3\30AF\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104246834322308644)
,p_name=>'PE.COMPONEN.TYPE.FIELD_TEMPLATE.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30FC\30EB\30C9\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104246911887308644)
,p_name=>'PE.COMPONEN.TYPE.FIELD_TEMPLATE.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30FC\30EB\30C9\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104094384257308512)
,p_name=>'PE.COMPONEN.TYPE.IG_ATTRIBUTES.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104094420060308512)
,p_name=>'PE.COMPONEN.TYPE.IG_ATTRIBUTES.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104094729763308512)
,p_name=>'PE.COMPONEN.TYPE.IG_COLUMN.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104094851068308512)
,p_name=>'PE.COMPONEN.TYPE.IG_COLUMN.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104094518879308512)
,p_name=>'PE.COMPONEN.TYPE.IG_COLUMN_GROUP.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\30B0\30EB\30FC\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104094638039308512)
,p_name=>'PE.COMPONEN.TYPE.IG_COLUMN_GROUP.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\30B0\30EB\30FC\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104094961013308512)
,p_name=>'PE.COMPONEN.TYPE.IG_PRINT_ATTR.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\51FA\529B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104095037620308512)
,p_name=>'PE.COMPONEN.TYPE.IG_PRINT_ATTR.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\51FA\529B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104561607142308888)
,p_name=>'PE.COMPONEN.TYPE.IG_SAVED_REPORT.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\4FDD\5B58\3055\308C\305F\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104562377220308888)
,p_name=>'PE.COMPONEN.TYPE.IG_SAVED_REPORT.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\4FDD\5B58\3055\308C\305F\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104252412505308648)
,p_name=>'PE.COMPONEN.TYPE.IR_ATTRIBUTES.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104252589134308648)
,p_name=>'PE.COMPONEN.TYPE.IR_ATTRIBUTES.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104253081346308648)
,p_name=>'PE.COMPONEN.TYPE.IR_COLUMN.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104253127108308648)
,p_name=>'PE.COMPONEN.TYPE.IR_COLUMN.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104252819438308648)
,p_name=>'PE.COMPONEN.TYPE.IR_COLUMN_GROUP.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\30B0\30EB\30FC\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104252967032308648)
,p_name=>'PE.COMPONEN.TYPE.IR_COLUMN_GROUP.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\30B0\30EB\30FC\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104343012451308714)
,p_name=>'PE.COMPONEN.TYPE.IR_PRINT_ATTR.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\51FA\529B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104343118823308714)
,p_name=>'PE.COMPONEN.TYPE.IR_PRINT_ATTR.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\51FA\529B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104252643575308648)
,p_name=>'PE.COMPONEN.TYPE.IR_SAVED_REPORT.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\4FDD\5B58\3055\308C\305F\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104252700289308648)
,p_name=>'PE.COMPONEN.TYPE.IR_SAVED_REPORT.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\4FDD\5B58\3055\308C\305F\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104141766171308551)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104141810398308551)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104141541775308551)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_AXES.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\8EF8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104141667612308551)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_AXES.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\8EF8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104141972600308551)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_SERIES.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30EA\30FC\30BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104142090997308551)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_SERIES.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30EA\30FC\30BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104712386325309010)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_WS_PARAM.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30E9\30E1\30FC\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104712453972309011)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_WS_PARAM.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30E9\30E1\30FC\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104249036490308645)
,p_name=>'PE.COMPONEN.TYPE.LIST.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104249174728308645)
,p_name=>'PE.COMPONEN.TYPE.LIST.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104583235559308905)
,p_name=>'PE.COMPONEN.TYPE.LIST_ENTRY.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8\30FB\30A8\30F3\30C8\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104583371012308905)
,p_name=>'PE.COMPONEN.TYPE.LIST_ENTRY.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8\30FB\30A8\30F3\30C8\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104247245553308644)
,p_name=>'PE.COMPONEN.TYPE.LIST_TEMPLATE.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104247365921308644)
,p_name=>'PE.COMPONEN.TYPE.LIST_TEMPLATE.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104249275387308645)
,p_name=>'PE.COMPONEN.TYPE.LOV.PLURAL'
,p_message_language=>'ja'
,p_message_text=>'LOV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104249377409308645)
,p_name=>'PE.COMPONEN.TYPE.LOV.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>'LOV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104583493684308905)
,p_name=>'PE.COMPONEN.TYPE.LOV_ENTRY.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('LOV\30A8\30F3\30C8\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104583589825308906)
,p_name=>'PE.COMPONEN.TYPE.LOV_ENTRY.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('LOV\30A8\30F3\30C8\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104489341345308830)
,p_name=>'PE.COMPONEN.TYPE.MAP_LAYER.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30A4\30E4\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104489466439308830)
,p_name=>'PE.COMPONEN.TYPE.MAP_LAYER.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30A4\30E4\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104489561158308830)
,p_name=>'PE.COMPONEN.TYPE.MAP_LAYER_WS_PARAM.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30E9\30E1\30FC\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104489606551308830)
,p_name=>'PE.COMPONEN.TYPE.MAP_LAYER_WS_PARAM.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30E9\30E1\30FC\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104489134320308830)
,p_name=>'PE.COMPONEN.TYPE.MAP_REGION.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104489239807308830)
,p_name=>'PE.COMPONEN.TYPE.MAP_REGION.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104250673790308646)
,p_name=>'PE.COMPONEN.TYPE.PAGE.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104250716296308646)
,p_name=>'PE.COMPONEN.TYPE.PAGE.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104251835262308647)
,p_name=>'PE.COMPONEN.TYPE.PAGE_COMPUTATION.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A08\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104251911844308647)
,p_name=>'PE.COMPONEN.TYPE.PAGE_COMPUTATION.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A08\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104250422059308646)
,p_name=>'PE.COMPONEN.TYPE.PAGE_GROUP.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30B0\30EB\30FC\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104250504512308646)
,p_name=>'PE.COMPONEN.TYPE.PAGE_GROUP.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30B0\30EB\30FC\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103949074035308397)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103949155588308397)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104252012653308647)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30BB\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104252161631308647)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30BB\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104253605493308648)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_AUTH.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\57FA\672C\8A8D\8A3C\30D1\30E9\30E1\30FC\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104253710057308649)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_AUTH.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\57FA\672C\8A8D\8A3C\30D1\30E9\30E1\30FC\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104253296246308648)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_IN.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('IN\30D1\30E9\30E1\30FC\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104253308702308648)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_IN.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('IN\30D1\30E9\30E1\30FC\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104253466410308648)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_OUT.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('OUT\30D1\30E9\30E1\30FC\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104253599470308648)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_OUT.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('OUT\30D1\30E9\30E1\30FC\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104246425712308643)
,p_name=>'PE.COMPONEN.TYPE.PAGE_TEMPLATE.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104246531759308643)
,p_name=>'PE.COMPONEN.TYPE.PAGE_TEMPLATE.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104584012874308906)
,p_name=>'PE.COMPONEN.TYPE.PLUGIN.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30E9\30B0\30A4\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104584180265308906)
,p_name=>'PE.COMPONEN.TYPE.PLUGIN.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30E9\30B0\30A4\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104250841307308646)
,p_name=>'PE.COMPONEN.TYPE.REGION.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104250993683308646)
,p_name=>'PE.COMPONEN.TYPE.REGION.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104542069161308869)
,p_name=>'PE.COMPONEN.TYPE.REGION_COLUMN.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104542166493308869)
,p_name=>'PE.COMPONEN.TYPE.REGION_COLUMN.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104478783367308816)
,p_name=>'PE.COMPONEN.TYPE.REGION_PLUGIN_ATTRIBUTES.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104478885021308816)
,p_name=>'PE.COMPONEN.TYPE.REGION_PLUGIN_ATTRIBUTES.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104246658295308643)
,p_name=>'PE.COMPONEN.TYPE.REGION_TEMPLATE.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104246776321308644)
,p_name=>'PE.COMPONEN.TYPE.REGION_TEMPLATE.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104189801029308601)
,p_name=>'PE.COMPONEN.TYPE.REGION_WS_PARAM.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30E9\30E1\30FC\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104189913393308601)
,p_name=>'PE.COMPONEN.TYPE.REGION_WS_PARAM.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30E9\30E1\30FC\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103970426993308413)
,p_name=>'PE.COMPONEN.TYPE.REMOTE_DATABASE.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30E2\30FC\30C8\30FB\30C7\30FC\30BF\30D9\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103970522246308413)
,p_name=>'PE.COMPONEN.TYPE.REMOTE_DATABASE.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\5BFE\5FDCSQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104350289189308719)
,p_name=>'PE.COMPONEN.TYPE.REPORT LAYOUT.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\30FB\30EC\30A4\30A2\30A6\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104350317751308719)
,p_name=>'PE.COMPONEN.TYPE.REPORT LAYOUT.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\30FB\30EC\30A4\30A2\30A6\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104247838234308644)
,p_name=>'PE.COMPONEN.TYPE.REPORT_TEMPLATE.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30E9\30B7\30C3\30AF\30FB\30EC\30DD\30FC\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104247903273308644)
,p_name=>'PE.COMPONEN.TYPE.REPORT_TEMPLATE.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30E9\30B7\30C3\30AF\30FB\30EC\30DD\30FC\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103916478442308371)
,p_name=>'PE.COMPONEN.TYPE.SFILTER.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30EB\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103916545247308371)
,p_name=>'PE.COMPONEN.TYPE.SFILTER.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30EB\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103916683219308371)
,p_name=>'PE.COMPONEN.TYPE.SFILTER_GROUP.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30EB\30FC\30D7\306E\30D5\30A3\30EB\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103916780662308371)
,p_name=>'PE.COMPONEN.TYPE.SFILTER_GROUP.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30EB\30BF\30FB\30B0\30EB\30FC\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103916828404308371)
,p_name=>'PE.COMPONEN.TYPE.SFILTER_GROUP_ITEM.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30A7\30C3\30AF\30DC\30C3\30AF\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103916951398308371)
,p_name=>'PE.COMPONEN.TYPE.SFILTER_GROUP_ITEM.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30A7\30C3\30AF\30DC\30C3\30AF\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104583668173308906)
,p_name=>'PE.COMPONEN.TYPE.SHORTCUT.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30E7\30FC\30C8\30AB\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104583706795308906)
,p_name=>'PE.COMPONEN.TYPE.SHORTCUT.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30E7\30FC\30C8\30AB\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104250079264308646)
,p_name=>'PE.COMPONEN.TYPE.TAB SET.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A19\6E96\30BF\30D6\30FB\30BB\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104250146499308646)
,p_name=>'PE.COMPONEN.TYPE.TAB SET.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A19\6E96\30BF\30D6\30FB\30BB\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104256013820308650)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C5E\6027')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104256101680308650)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104256278734308650)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM_COLUMN.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104256317871308650)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM_COLUMN.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104343400331308714)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM_PRINT_ATTR.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\51FA\529B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104343544316308714)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM_PRINT_ATTR.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\51FA\529B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104246218111308643)
,p_name=>'PE.COMPONEN.TYPE.THEME.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104246332676308643)
,p_name=>'PE.COMPONEN.TYPE.THEME.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104583876266308906)
,p_name=>'PE.COMPONEN.TYPE.TREE.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C4\30EA\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104583954535308906)
,p_name=>'PE.COMPONEN.TYPE.TREE.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C4\30EA\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104250268867308646)
,p_name=>'PE.COMPONEN.TYPE.USER_INTERFACE.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104250355035308646)
,p_name=>'PE.COMPONEN.TYPE.USER_INTERFACE.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104251652366308647)
,p_name=>'PE.COMPONEN.TYPE.VALIDATION.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104251736366308647)
,p_name=>'PE.COMPONEN.TYPE.VALIDATION.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104249444975308645)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REFERENCE.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B5\30FC\30D3\30B9\53C2\7167')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104249569357308646)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REFERENCE.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B5\30FC\30D3\30B9\53C2\7167')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104249600822308646)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REFERENCE_OPERATION.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B5\30FC\30D3\30B9\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104249711000308646)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REFERENCE_OPERATION.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B5\30FC\30D3\30B9\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104719090403309016)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_A.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\57FA\672C\8A8D\8A3C\30D1\30E9\30E1\30FC\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104719160586309016)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_A.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\57FA\672C\8A8D\8A3C\30D1\30E9\30E1\30FC\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104719267713309016)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_H.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('HTTP\30D8\30C3\30C0\30FC\30FB\30D1\30E9\30E1\30FC\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104719349271309016)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_H.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('HTTP\30D8\30C3\30C0\30FC\30FB\30D1\30E9\30E1\30FC\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104718644393309015)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_I.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('IN\30D1\30E9\30E1\30FC\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104718798479309015)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_I.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('IN\30D1\30E9\30E1\30FC\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104718818119309016)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_O.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('OUT\30D1\30E9\30E1\30FC\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104718958074309016)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_O.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('OUT\30D1\30E9\30E1\30FC\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104083829410308503)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_MODULE.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\30C7\30FC\30BF\30FB\30BD\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104083934610308503)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_MODULE.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\30C7\30FC\30BF\30FB\30BD\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104194543587308605)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_MODULE_PARAM.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\30BD\30FC\30B9\30FB\30D1\30E9\30E1\30FC\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104194657728308605)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_MODULE_PARAM.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\30BD\30FC\30B9\30FB\30D1\30E9\30E1\30FC\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104189699917308601)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_OPERATION.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\30BD\30FC\30B9\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104189790027308601)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_OPERATION.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\30BD\30FC\30B9\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104194761788308605)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_OPER_PARAM.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\30BD\30FC\30B9\64CD\4F5C\306E\30D1\30E9\30E1\30FC\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104194867335308605)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_OPER_PARAM.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\30BD\30FC\30B9\64CD\4F5C\306E\30D1\30E9\30E1\30FC\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104194973885308605)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_PARAM.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\30BD\30FC\30B9\30FB\30D1\30E9\30E1\30FC\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104195068792308606)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_PARAM.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\30BD\30FC\30B9\30FB\30D1\30E9\30E1\30FC\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104084032280308503)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_QUERY.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\30BD\30FC\30B9\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104084164538308503)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_QUERY.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\30BD\30FC\30B9\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104205481349308613)
,p_name=>'PE.DISPLAY_GROUP.ACTIONS_MENU'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104720109718309017)
,p_name=>'PE.DISPLAY_GROUP.ADDITIONAL_CODE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8FFD\52A0\306E\30B3\30FC\30C9\5B9F\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103866820020308298)
,p_name=>'PE.DISPLAY_GROUP.ADVANCED'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A73\7D30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103867142652308298)
,p_name=>'PE.DISPLAY_GROUP.AFFECTED_ELEMENTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5F71\97FF\3092\53D7\3051\308B\8981\7D20')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104144195626308553)
,p_name=>'PE.DISPLAY_GROUP.ANIMATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30CB\30E1\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103868151440308299)
,p_name=>'PE.DISPLAY_GROUP.APPEARANCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5916\89B3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103865338146308297)
,p_name=>'PE.DISPLAY_GROUP.ATTRIBUTES'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103515058218308026)
,p_name=>'PE.DISPLAY_GROUP.AUDIT_INFORMATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\76E3\67FB\60C5\5831')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103866991384308298)
,p_name=>'PE.DISPLAY_GROUP.AUTHORIZATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\53EF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104584365539308906)
,p_name=>'PE.DISPLAY_GROUP.AUTHORIZATION_SCHEME'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\53EF\30B9\30AD\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104262950762308655)
,p_name=>'PE.DISPLAY_GROUP.AUTOMATIC_REFRESH'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\52D5\30EA\30D5\30EC\30C3\30B7\30E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103868051934308299)
,p_name=>'PE.DISPLAY_GROUP.BEHAVIOR'
,p_message_language=>'ja'
,p_message_text=>unistr('\52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104238084209308637)
,p_name=>'PE.DISPLAY_GROUP.BLOB'
,p_message_language=>'ja'
,p_message_text=>unistr('BLOB\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104564049455308890)
,p_name=>'PE.DISPLAY_GROUP.BODY'
,p_message_language=>'ja'
,p_message_text=>unistr('\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104240321590308639)
,p_name=>'PE.DISPLAY_GROUP.BREAK_FORMATTING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30FC\30AF\66F8\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104273011511308662)
,p_name=>'PE.DISPLAY_GROUP.CALENDAR_STATE_ITEMS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30EC\30F3\30C0\30FB\30B9\30C6\30FC\30C8\30FB\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104563815761308889)
,p_name=>'PE.DISPLAY_GROUP.CARD'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104229528147308631)
,p_name=>'PE.DISPLAY_GROUP.CASCADING_LOV'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30B9\30B1\30FC\30C9LOV')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104264535776308656)
,p_name=>'PE.DISPLAY_GROUP.CHART'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104734932492309031)
,p_name=>'PE.DISPLAY_GROUP.CLIENT_SIDE_CONDITION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30E9\30A4\30A2\30F3\30C8\5074\306E\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104720242292309017)
,p_name=>'PE.DISPLAY_GROUP.CODE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104266234227308658)
,p_name=>'PE.DISPLAY_GROUP.COLORS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104343940359308715)
,p_name=>'PE.DISPLAY_GROUP.COLUMNS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104342319682308713)
,p_name=>'PE.DISPLAY_GROUP.COLUMN_FILTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\30D5\30A3\30EB\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104200218953308610)
,p_name=>'PE.DISPLAY_GROUP.COLUMN_FORMATTING'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\306E\66F8\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104343819368308715)
,p_name=>'PE.DISPLAY_GROUP.COLUMN_HEADINGS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\30D8\30C3\30C0\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104143456034308553)
,p_name=>'PE.DISPLAY_GROUP.COLUMN_MAPPING'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\306E\30DE\30C3\30D4\30F3\30B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103865437353308297)
,p_name=>'PE.DISPLAY_GROUP.COMMENTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30E1\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103866790202308298)
,p_name=>'PE.DISPLAY_GROUP.COMPUTATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A08\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103865625933308297)
,p_name=>'PE.DISPLAY_GROUP.CONFIGURATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\69CB\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103777118852308229)
,p_name=>'PE.DISPLAY_GROUP.CONFIRMATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\78BA\8A8D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104275637589308664)
,p_name=>'PE.DISPLAY_GROUP.CONTROLS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30C8\30ED\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103865719282308297)
,p_name=>'PE.DISPLAY_GROUP.CSS'
,p_message_language=>'ja'
,p_message_text=>'CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103962359422308407)
,p_name=>'PE.DISPLAY_GROUP.CUSTOMIZATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30B9\30BF\30DE\30A4\30BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104266036033308657)
,p_name=>'PE.DISPLAY_GROUP.DAILY_WEEKLY_CALENDAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5\6B21\304A\3088\3073\9031\6B21\30AB\30EC\30F3\30C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104584404480308906)
,p_name=>'PE.DISPLAY_GROUP.DATABASE_SESSION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30BB\30C3\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104264673463308656)
,p_name=>'PE.DISPLAY_GROUP.DATAGRID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30B0\30EA\30C3\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104143394303308552)
,p_name=>'PE.DISPLAY_GROUP.DATA_CURSOR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30AB\30FC\30BD\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103867269003308299)
,p_name=>'PE.DISPLAY_GROUP.DEFAULT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104229401777308631)
,p_name=>'PE.DISPLAY_GROUP.DEPENDING_ON'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F9D\5B58\5148')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104205547238308613)
,p_name=>'PE.DISPLAY_GROUP.DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\8AAC\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104205601217308614)
,p_name=>'PE.DISPLAY_GROUP.DETAIL_VIEW'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A73\7D30\30D3\30E5\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104274298100308663)
,p_name=>'PE.DISPLAY_GROUP.DIALOG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C0\30A4\30A2\30ED\30B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104205712127308614)
,p_name=>'PE.DISPLAY_GROUP.DOWNLOAD'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C0\30A6\30F3\30ED\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104266358308308658)
,p_name=>'PE.DISPLAY_GROUP.DRAG_AND_DROP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C9\30E9\30C3\30B0\30FB\30A2\30F3\30C9\30FB\30C9\30ED\30C3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104144028034308553)
,p_name=>'PE.DISPLAY_GROUP.DUAL_Y_AXES'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E8C\91CDY\8EF8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104095285552308512)
,p_name=>'PE.DISPLAY_GROUP.EDIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104227593849308630)
,p_name=>'PE.DISPLAY_GROUP.EDIT_AUTH'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\53EF\306E\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103867344510308299)
,p_name=>'PE.DISPLAY_GROUP.ELEMENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8981\7D20')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104095112376308512)
,p_name=>'PE.DISPLAY_GROUP.ENABLE_USER_TO'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\306E\6709\52B9\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104273126549308662)
,p_name=>'PE.DISPLAY_GROUP.ENTRY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C8\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103865508618308297)
,p_name=>'PE.DISPLAY_GROUP.ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103865847672308297)
,p_name=>'PE.DISPLAY_GROUP.ERROR_HANDLING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC\51E6\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103866626511308298)
,p_name=>'PE.DISPLAY_GROUP.EXECUTION_OPTIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9F\884C\30AA\30D7\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104233930589308634)
,p_name=>'PE.DISPLAY_GROUP.EXPORT_PRINTING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30AF\30B9\30DD\30FC\30C8/\51FA\529B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104240417752308639)
,p_name=>'PE.DISPLAY_GROUP.EXTERNAL_PROCESSING'
,p_message_language=>'ja'
,p_message_text=>unistr('\5916\90E8\30D7\30ED\30BB\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104488399004308829)
,p_name=>'PE.DISPLAY_GROUP.GANTT_START_DATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\59CB\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104264443355308656)
,p_name=>'PE.DISPLAY_GROUP.GANTT_TIMELINE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6642\7CFB\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104686145275308988)
,p_name=>'PE.DISPLAY_GROUP.GANTT_VIEWPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D3\30E5\30FC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104264087768308656)
,p_name=>'PE.DISPLAY_GROUP.GAUGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B2\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103865902224308298)
,p_name=>'PE.DISPLAY_GROUP.HEADER_AND_FOOTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D8\30C3\30C0\30FC\304A\3088\3073\30D5\30C3\30BF\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104240671582308639)
,p_name=>'PE.DISPLAY_GROUP.HEADING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D8\30C3\30C0\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103866030047308298)
,p_name=>'PE.DISPLAY_GROUP.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D8\30EB\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103867437874308299)
,p_name=>'PE.DISPLAY_GROUP.HELP_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D8\30EB\30D7\30FB\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103866174404308298)
,p_name=>'PE.DISPLAY_GROUP.HTML_HEADER'
,p_message_language=>'ja'
,p_message_text=>unistr('HTML\30D8\30C3\30C0\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104564219927308890)
,p_name=>'PE.DISPLAY_GROUP.ICON_AND_BADGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3\3068\30D0\30C3\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104205873593308614)
,p_name=>'PE.DISPLAY_GROUP.ICON_VIEW'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3\30FB\30D3\30E5\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103865170356308297)
,p_name=>'PE.DISPLAY_GROUP.IDENTIFICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\8B58\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103866284055308298)
,p_name=>'PE.DISPLAY_GROUP.JAVASCRIPT'
,p_message_language=>'ja'
,p_message_text=>'JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103867583936308299)
,p_name=>'PE.DISPLAY_GROUP.LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103868263385308299)
,p_name=>'PE.DISPLAY_GROUP.LAYOUT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30A4\30A2\30A6\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104263550398308656)
,p_name=>'PE.DISPLAY_GROUP.LEGEND'
,p_message_language=>'ja'
,p_message_text=>unistr('\51E1\4F8B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104143559942308553)
,p_name=>'PE.DISPLAY_GROUP.LINE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6298\308C\7DDA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104220633664308625)
,p_name=>'PE.DISPLAY_GROUP.LINK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30F3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104327587214308702)
,p_name=>'PE.DISPLAY_GROUP.LIST_ENTRIES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8\30FB\30A8\30F3\30C8\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103867675814308299)
,p_name=>'PE.DISPLAY_GROUP.LIST_OF_VALUES'
,p_message_language=>'ja'
,p_message_text=>'LOV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104266196684308658)
,p_name=>'PE.DISPLAY_GROUP.LIST_VIEW_CALENDAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E88\5B9A\8868\30D3\30E5\30FC\30FB\30AB\30EC\30F3\30C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104695940378308997)
,p_name=>'PE.DISPLAY_GROUP.LOCAL_POST_PROCESSING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30FC\30AB\30EB\5F8C\51E6\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103961740731308406)
,p_name=>'PE.DISPLAY_GROUP.LOGIN_PROCESSING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30B0\30A4\30F3\30FB\30D7\30ED\30BB\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104143766698308553)
,p_name=>'PE.DISPLAY_GROUP.MAJOR_TICKS'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E3B\8981\76EE\76DB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104489821041308831)
,p_name=>'PE.DISPLAY_GROUP.MAP_LAYER_ZOOM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BA\30FC\30E0\30FB\30EC\30D9\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104489765203308831)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30C3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104490399360308831)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION_FEATURE_INFO_WINDOW'
,p_message_language=>'ja'
,p_message_text=>unistr('\60C5\5831\30A6\30A3\30F3\30C9\30A6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104489981973308831)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION_INIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\521D\671F\4F4D\7F6E\304A\3088\3073\30BA\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104490197613308831)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION_POINT_CLUSTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DD\30A4\30F3\30C8\30FB\30AF\30E9\30B9\30BF\30EA\30F3\30B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104490005904308831)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION_POINT_FEATURE_STYLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DD\30A4\30F3\30C8\30FB\30AA\30D6\30B8\30A7\30AF\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104490226241308831)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION_ROW_SELECTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\5272\5F53\3066')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104263699708308656)
,p_name=>'PE.DISPLAY_GROUP.MARGIN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30FC\30B8\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104143672794308553)
,p_name=>'PE.DISPLAY_GROUP.MARKER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30FC\30AB\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104289118606308674)
,p_name=>'PE.DISPLAY_GROUP.MASTER_DETAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30B9\30BF\30FC\30FB\30C7\30A3\30C6\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104564320402308890)
,p_name=>'PE.DISPLAY_GROUP.MEDIA'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E1\30C7\30A3\30A2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104240599665308639)
,p_name=>'PE.DISPLAY_GROUP.MESSAGES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E1\30C3\30BB\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104143882634308553)
,p_name=>'PE.DISPLAY_GROUP.MINOR_TICKS'
,p_message_language=>'ja'
,p_message_text=>unistr('\88DC\52A9\76EE\76DB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104265816439308657)
,p_name=>'PE.DISPLAY_GROUP.MONTHLY_CALENDAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\6708\6B21\30AB\30EC\30F3\30C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103668107680308141)
,p_name=>'PE.DISPLAY_GROUP.MULTIPLE_VALUES'
,p_message_language=>'ja'
,p_message_text=>unistr('\8907\6570\306E\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103997490269308433)
,p_name=>'PE.DISPLAY_GROUP.MULTI_SERIES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30EB\30C1\30B7\30EA\30FC\30BA\30FB\30C1\30E3\30FC\30C8\30FB\30C7\30FC\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104584503012308906)
,p_name=>'PE.DISPLAY_GROUP.NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\540D\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104008039263308441)
,p_name=>'PE.DISPLAY_GROUP.NAVIGATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CA\30D3\30B2\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104772040403309067)
,p_name=>'PE.DISPLAY_GROUP.NAVIGATION_MENU'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104351993796308720)
,p_name=>'PE.DISPLAY_GROUP.OUTPUT'
,p_message_language=>'ja'
,p_message_text=>unistr('\51FA\529B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104143200987308552)
,p_name=>'PE.DISPLAY_GROUP.OVERVIEW'
,p_message_language=>'ja'
,p_message_text=>unistr('\6982\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104343745154308714)
,p_name=>'PE.DISPLAY_GROUP.PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104344173754308715)
,p_name=>'PE.DISPLAY_GROUP.PAGE_FOOTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30D5\30C3\30BF\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104344088558308715)
,p_name=>'PE.DISPLAY_GROUP.PAGE_HEADER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30D8\30C3\30C0\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104205973562308614)
,p_name=>'PE.DISPLAY_GROUP.PAGINATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\533A\5207\308A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104225918099308629)
,p_name=>'PE.DISPLAY_GROUP.PARAMETER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30E9\30E1\30FC\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104095435537308512)
,p_name=>'PE.DISPLAY_GROUP.PERFORMANCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30D5\30A9\30FC\30DE\30F3\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103961840118308407)
,p_name=>'PE.DISPLAY_GROUP.POST_LOGOUT_URL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30B0\30A2\30A6\30C8\5F8CURL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104258413213308652)
,p_name=>'PE.DISPLAY_GROUP.PRIMARY_KEY_SOURCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E3B\30AD\30FC\306E\30BD\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104343656942308714)
,p_name=>'PE.DISPLAY_GROUP.PRINTING'
,p_message_language=>'ja'
,p_message_text=>unistr('\51FA\529B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104584232370308906)
,p_name=>'PE.DISPLAY_GROUP.QUERY'
,p_message_language=>'ja'
,p_message_text=>unistr('\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103867738980308299)
,p_name=>'PE.DISPLAY_GROUP.QUICK_PICKS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30A4\30C3\30AF\9078\629E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103866394708308298)
,p_name=>'PE.DISPLAY_GROUP.READ_ONLY'
,p_message_language=>'ja'
,p_message_text=>unistr('\8AAD\53D6\308A\5C02\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103961969653308407)
,p_name=>'PE.DISPLAY_GROUP.REAL_APPLICATION_SECURITY'
,p_message_language=>'ja'
,p_message_text=>'Real Application Security'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103707186590308173)
,p_name=>'PE.DISPLAY_GROUP.REFERENCE_LINES'
,p_message_language=>'ja'
,p_message_text=>unistr('\57FA\6E96\7DDA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104227057735308629)
,p_name=>'PE.DISPLAY_GROUP.REFRESH'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30D5\30EC\30C3\30B7\30E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103970671269308413)
,p_name=>'PE.DISPLAY_GROUP.REMOTE_CACHE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30E2\30FC\30C8\30FB\30AD\30E3\30C3\30B7\30E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104186227957308598)
,p_name=>'PE.DISPLAY_GROUP.SEARCH_BAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22\30D0\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104564165766308890)
,p_name=>'PE.DISPLAY_GROUP.SECONDARY_BODY'
,p_message_language=>'ja'
,p_message_text=>unistr('2\6B21\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103866457900308298)
,p_name=>'PE.DISPLAY_GROUP.SECURITY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30AD\30E5\30EA\30C6\30A3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104263796162308656)
,p_name=>'PE.DISPLAY_GROUP.SERIES_COLOR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30EA\30FC\30BA\30FB\30AB\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103866519504308298)
,p_name=>'PE.DISPLAY_GROUP.SERVER_CACHE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30FC\30D0\30FC\30FB\30AD\30E3\30C3\30B7\30E5')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104734863147309030)
,p_name=>'PE.DISPLAY_GROUP.SERVER_SIDE_CONDITION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30FC\30D0\30FC\5074\306E\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104584655942308906)
,p_name=>'PE.DISPLAY_GROUP.SESSION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30C3\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103962029872308407)
,p_name=>'PE.DISPLAY_GROUP.SESSION_COOKIE_ATTRIBUTES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30C3\30B7\30E7\30F3\306ECookie\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103962180030308407)
,p_name=>'PE.DISPLAY_GROUP.SESSION_NOT_VALID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30C3\30B7\30E7\30F3\7121\52B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103865246374308297)
,p_name=>'PE.DISPLAY_GROUP.SETTINGS'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104206144175308614)
,p_name=>'PE.DISPLAY_GROUP.SINGLE_ROW_VIEW'
,p_message_language=>'ja'
,p_message_text=>unistr('\5358\4E00\884C\30D3\30E5\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104206006358308614)
,p_name=>'PE.DISPLAY_GROUP.SORTING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103867881382308299)
,p_name=>'PE.DISPLAY_GROUP.SOURCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BD\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103962290226308407)
,p_name=>'PE.DISPLAY_GROUP.SUBSCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30D6\30B9\30AF\30EA\30D7\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104563919670308890)
,p_name=>'PE.DISPLAY_GROUP.SUB_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30D6\30BF\30A4\30C8\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104221589778308625)
,p_name=>'PE.DISPLAY_GROUP.SUCCESS_MESSAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6210\529F\30E1\30C3\30BB\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103917078329308372)
,p_name=>'PE.DISPLAY_GROUP.SUGGESTIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30B8\30A7\30B9\30C1\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104772186814309067)
,p_name=>'PE.DISPLAY_GROUP.TABS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103599857588308088)
,p_name=>'PE.DISPLAY_GROUP.THRESHOLDS'
,p_message_language=>'ja'
,p_message_text=>unistr('\3057\304D\3044\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104143953504308553)
,p_name=>'PE.DISPLAY_GROUP.TICK_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30A3\30C3\30AF\30FB\30E9\30D9\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104478284873308815)
,p_name=>'PE.DISPLAY_GROUP.TIME_SCALE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30E0\30FB\30B9\30B1\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104264393887308656)
,p_name=>'PE.DISPLAY_GROUP.TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30C8\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104095356815308512)
,p_name=>'PE.DISPLAY_GROUP.TOOLBAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C4\30FC\30EB\30D0\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104264245373308656)
,p_name=>'PE.DISPLAY_GROUP.TOOLTIP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C4\30FC\30EB\30C1\30C3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104257201687308651)
,p_name=>'PE.DISPLAY_GROUP.UI_DEFAULTS_REFERENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('UI\30C7\30D5\30A9\30EB\30C8\53C2\7167')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103867937014308299)
,p_name=>'PE.DISPLAY_GROUP.VALIDATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104264142661308656)
,p_name=>'PE.DISPLAY_GROUP.VALUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104265916897308657)
,p_name=>'PE.DISPLAY_GROUP.WEEKLY_CALENDAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\9031\6B21\30AB\30EC\30F3\30C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103867096629308298)
,p_name=>'PE.DISPLAY_GROUP.WHEN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30DF\30F3\30B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104263816756308656)
,p_name=>'PE.DISPLAY_GROUP.X_AXIS'
,p_message_language=>'ja'
,p_message_text=>unistr('X\8EF8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104263942775308656)
,p_name=>'PE.DISPLAY_GROUP.Y_AXIS'
,p_message_language=>'ja'
,p_message_text=>unistr('Y\8EF8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104190009475308601)
,p_name=>'PE.DISPLAY_GROUP.ZOOM_SCALE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BA\30FC\30E0\30FB\30B9\30B1\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104097169161308514)
,p_name=>'PE.PROPERTY.ADD_AUTHORIZATION_SCHEME.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8A8D\53EF\30B9\30AD\30FC\30E0\3092\6307\5B9A\3057\3066\3001\884C\3092\8FFD\52A0\3067\304D\308B\30E6\30FC\30B6\30FC\3092\5236\9650\3057\307E\3059\3002'),
unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\884C\3092\8FFD\52A0\3059\308B\306B\306F\3001\3053\306E\8A8D\53EF\30B9\30AD\30FC\30E0\304C\305D\306E\30E6\30FC\30B6\30FC\306B\5BFE\3057\3066TRUE\3068\8A55\4FA1\3055\308C\308B\5FC5\8981\304C\3042\308A\307E\3059\3002'),
unistr('\8A8D\53EF\30B9\30AD\30FC\30E0\304C\6307\5B9A\3055\308C\306A\3044\5834\5408\3001\3059\3079\3066\306E\30E6\30FC\30B6\30FC\304C\3053\306E\5BFE\8A71\30B0\30EA\30C3\30C9\3067\884C\3092\8FFD\52A0\3067\304D\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104097035850308514)
,p_name=>'PE.PROPERTY.ADD_AUTHORIZATION_SCHEME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104100177365308516)
,p_name=>'PE.PROPERTY.ADD_BUTTON_LABEL.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8FFD\52A0\30DC\30BF\30F3\306E\4EE3\66FF\30E9\30D9\30EB\3092\5165\529B\3057\307E\3059\3002\30C7\30D5\30A9\30EB\30C8\30FB\30E9\30D9\30EB\306F\3001<em>\300C\884C\306E\8FFD\52A0\300D</em>\3067\3059\3002</p>'),
unistr('        <p>\305F\3068\3048\3070\3001\5F93\696D\54E1\3092\4FDD\6301\3059\308B\5BFE\8A71\30B0\30EA\30C3\30C9\306B<em>\300C\5F93\696D\54E1\306E\8FFD\52A0\300D</em>\3092\5165\529B\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104100089841308516)
,p_name=>'PE.PROPERTY.ADD_BUTTON_LABEL.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8FFD\52A0\30DC\30BF\30F3\30FB\30E9\30D9\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104098328696308515)
,p_name=>'PE.PROPERTY.ADD_ROW_IF_EMPTY.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5BFE\8A71\30B0\30EA\30C3\30C9\306B\73FE\5728\623B\3055\308C\308B\30EC\30B3\30FC\30C9\304C\306A\3044\5834\5408\306B\65B0\3057\3044\884C\3092\8FFD\52A0\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002'),
unistr('        \5C11\306A\304F\3068\30821\3064\306E\30EC\30B3\30FC\30C9\304C\5E38\306B\8868\793A\3055\308C\308B\305F\3081\3001<em>\300C\30C7\30FC\30BF\304C\898B\3064\304B\308A\307E\305B\3093\300D</em>\30E1\30C3\30BB\30FC\30B8\306F\8868\793A\3055\308C\307E\305B\3093\3002</p>'),
unistr('        <p>\30CE\30FC\30C8 - \8FFD\52A0\3055\308C\305F\30EC\30B3\30FC\30C9\306B\66F4\65B0\304C\884C\308F\308C\306A\3044\5834\5408\3001\30EA\30FC\30B8\30E7\30F3\306E\4FDD\5B58\6642\306B\633F\5165\3055\308C\307E\305B\3093\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104098226591308515)
,p_name=>'PE.PROPERTY.ADD_ROW_IF_EMPTY.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7A7A\306E\5834\5408\306B\884C\3092\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104581802984308904)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.FACET.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30D5\30A1\30BB\30C3\30C8\306B\8FFD\52A0\3059\308B\30AF\30E9\30B9\3092\5165\529B\3057\307E\3059\3002\8907\6570\306E\30AF\30E9\30B9\306F\7A7A\767D\3067\533A\5207\3063\3066\8FFD\52A0\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104556895014308884)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.FACET_GROUP.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30D5\30A1\30BB\30C3\30C8\30FB\30B0\30EB\30FC\30D7\306B\8FFD\52A0\3059\308B\30AF\30E9\30B9\3092\5165\529B\3057\307E\3059\3002\8907\6570\306E\30AF\30E9\30B9\306F\7A7A\767D\3067\533A\5207\3063\3066\8FFD\52A0\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104113598452308527)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\8FFD\52A0\3059\308B\30AF\30E9\30B9\3092\5165\529B\3057\307E\3059\3002\8907\6570\306E\30AF\30E9\30B9\306F\7A7A\767D\3067\533A\5207\3063\3066\8FFD\52A0\3067\304D\307E\3059\3002</p>'),
unistr('        <p>\30CE\30FC\30C8: \5BFE\8A71\30B0\30EA\30C3\30C9\304C\7DE8\96C6\53EF\80FD\306A\5834\5408\3001\3053\306E\30D7\30ED\30D1\30C6\30A3\3092\4F7F\7528\3057\3066\3001\5BFE\5FDC\3059\308B\30A2\30A4\30C6\30E0\306E\30B9\30BF\30A4\30EB\3092\5909\66F4\3067\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104558530102308885)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\8FFD\52A0\3059\308B\30AF\30E9\30B9\3092\5165\529B\3057\307E\3059\3002\8907\6570\306E\30AF\30E9\30B9\306F\7A7A\767D\3067\533A\5207\3063\3066\8FFD\52A0\3067\304D\307E\3059\3002</p>'),
unistr('        <p>\30CE\30FC\30C8: \3053\308C\3089\306ECSS\30AF\30E9\30B9\306F\3001HTML\306E\30D5\30A9\30FC\30E0\8981\7D20\30BF\30B0\306B\9069\7528\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103920400650308374)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30D5\30A3\30EB\30BF\306B\8FFD\52A0\3059\308B\30AF\30E9\30B9\3092\5165\529B\3057\307E\3059\3002\8907\6570\306E\30AF\30E9\30B9\306F\7A7A\767D\3067\533A\5207\3063\3066\8FFD\52A0\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103921199669308375)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.SFILTER_GROUP.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30D5\30A3\30EB\30BF\30FB\30B0\30EB\30FC\30D7\306B\8FFD\52A0\3059\308B\30AF\30E9\30B9\3092\5165\529B\3057\307E\3059\3002\8907\6570\306E\30AF\30E9\30B9\306F\7A7A\767D\3067\533A\5207\3063\3066\8FFD\52A0\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104557990337308885)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>CSS\30AF\30E9\30B9<code>articlenumber</code>\304A\3088\3073<code>highlight</code>\3092\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306EHTML\30BF\30B0\306B\8FFD\52A0</dt>'),
'<dd><pre>articlenumber highlight</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104557832414308885)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\542B\3081\3089\308C\308B\8FFD\52A0\306ECSS\30AF\30E9\30B9\3092\7A7A\767D\3067\533A\5207\3063\3066\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104557749640308885)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('CSS\30AF\30E9\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103900209226308327)
,p_name=>'PE.PROPERTY.AFFECTED_BUTTON.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30AF\30B7\30E7\30F3\306B\3088\3063\3066\5F71\97FF\3092\53D7\3051\308B\30DC\30BF\30F3\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103900122417308327)
,p_name=>'PE.PROPERTY.AFFECTED_BUTTON.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104735819774309031)
,p_name=>'PE.PROPERTY.AFFECTED_COLUMNS.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\3053\306E\30A2\30AF\30B7\30E7\30F3\306B\3088\3063\3066\5F71\97FF\3092\53D7\3051\308B1\3064\4EE5\4E0A\306E\5217\3092\5165\529B\3057\307E\3059\3002'),
unistr('\8907\6570\306E\5217\306E\5834\5408\3001\5404\5217\540D\3092\30AB\30F3\30DE\3067\533A\5207\308A\307E\3059\3002'),
unistr('<p>\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\5217\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002'),
unistr('\30EA\30B9\30C8\304B\3089\9078\629E\3057\3001\3059\3067\306B\5165\529B\3055\308C\3066\3044\308B\30C6\30AD\30B9\30C8\304C\3042\308B\5834\5408\3001\65E2\5B58\306E\30C6\30AD\30B9\30C8\306E\6700\5F8C\306B\30AB\30F3\30DE\304C\4ED8\3051\3089\308C\3001\30EA\30B9\30C8\304B\3089\8FD4\3055\308C\305F\5217\540D\304C\305D\308C\306B\7D9A\304D\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104735758010309031)
,p_name=>'PE.PROPERTY.AFFECTED_COLUMNS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103900661710308328)
,p_name=>'PE.PROPERTY.AFFECTED_DOM_OBJECT.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30A2\30AF\30B7\30E7\30F3\306B\3088\3063\3066\5F71\97FF\3092\53D7\3051\308B\8981\7D20\3068\3057\3066DOM\30AA\30D6\30B8\30A7\30AF\30C8(<code>document</code>\3001<code>window</code>)\307E\305F\306FDOM\30AA\30D6\30B8\30A7\30AF\30C8\306E<em>ID</em>(<code>myElementID</code>)\306E\3044\305A\308C\304B\3092\5165\529B\3057\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8: <em>DOM\30AA\30D6\30B8\30A7\30AF\30C8</em>\306F\975E\63A8\5968\3067\3059\3002<em>JavaScript\5F0F</em>\307E\305F\306F<em>jQuery\30BB\30EC\30AF\30BF</em>\3067\7F6E\304D\63DB\3048\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103900588602308327)
,p_name=>'PE.PROPERTY.AFFECTED_DOM_OBJECT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('DOM\30AA\30D6\30B8\30A7\30AF\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103900432724308327)
,p_name=>'PE.PROPERTY.AFFECTED_ITEMS.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\3053\306E\30A2\30AF\30B7\30E7\30F3\306B\3088\3063\3066\5F71\97FF\3092\53D7\3051\308B1\3064\4EE5\4E0A\306E\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002'),
unistr('\8907\6570\306E\30A2\30A4\30C6\30E0\306E\5834\5408\3001\5404\30A2\30A4\30C6\30E0\540D\3092\30AB\30F3\30DE\3067\533A\5207\308A\307E\3059\3002'),
unistr('<p>\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002'),
unistr('\30EA\30B9\30C8\304B\3089\9078\629E\3057\3001\3059\3067\306B\5165\529B\3055\308C\3066\3044\308B\30C6\30AD\30B9\30C8\304C\3042\308B\5834\5408\3001\65E2\5B58\306E\30C6\30AD\30B9\30C8\306E\6700\5F8C\306B\30AB\30F3\30DE\304C\4ED8\3051\3089\308C\3001\30EA\30B9\30C8\304B\3089\8FD4\3055\308C\305F\30A2\30A4\30C6\30E0\540D\304C\305D\308C\306B\7D9A\304D\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103900363059308327)
,p_name=>'PE.PROPERTY.AFFECTED_ITEMS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104732221961309028)
,p_name=>'PE.PROPERTY.AFFECTED_JAVASCRIPT_EXPRESSION.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\30D6\30E9\30A6\30B6\306E<code>window</code> DOM\30AA\30D6\30B8\30A7\30AF\30C8\3078\306E\53C2\7167\3092\623B\3057\307E\3059\3002</dt>'),
'<dd><code>window</code></dd>',
unistr('<dt>\30D6\30E9\30A6\30B6\306E<code>document</code> DOM\30AA\30D6\30B8\30A7\30AF\30C8\3078\306E\53C2\7167\3092\623B\3057\307E\3059\3002</dt>'),
'<dd>document</dd>',
unistr('<dt>jQuery\30BB\30EC\30AF\30BF\306F\3001''alert''\306E\30AF\30E9\30B9\3092\6301\3064\3059\3079\3066\306EDIV\8981\7D20\3092\9078\629E\3057\3001\3059\3079\3066\306E\89AA\3092\542B\3080jQuery\30AA\30D6\30B8\30A7\30AF\30C8\3092\623B\3057\307E\3059\3002</dt>'),
'<dd><code>$( "div.alert" ).parent()</code></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104732118177309028)
,p_name=>'PE.PROPERTY.AFFECTED_JAVASCRIPT_EXPRESSION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30AF\30B7\30E7\30F3\306E\5F71\97FF\3092\53D7\3051\308B\8981\7D20\3068\3057\3066\5358\4E00\304A\3088\3073\8907\6570\306EDOM\30AA\30D6\30B8\30A7\30AF\30C8\307E\305F\306FjQuery\30AA\30D6\30B8\30A7\30AF\30C8\3092\8FD4\3059\305F\3081\306B\8A55\4FA1\3059\308BJavaScript\5F0F\3092\6307\5B9A\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104732034314309028)
,p_name=>'PE.PROPERTY.AFFECTED_JAVASCRIPT_EXPRESSION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('JavaScript\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104390633184308750)
,p_name=>'PE.PROPERTY.AFFECTED_JQUERY_SELECTOR.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>DOM ID <code>my_id</code>\3092\4F7F\7528\3057\305F\30DA\30FC\30B8\8981\7D20\306E\9078\629E</dt>'),
'<dd><pre>#my_id</pre></dd>',
unistr('<dt>\30AF\30E9\30B9<code>my_class</code>\3092\4F7F\7528\3057\305F\3059\3079\3066\306E\30DA\30FC\30B8\8981\7D20\306E\9078\629E</dt>'),
'<dd><pre>.my_class</pre></dd>',
unistr('<dt>\5165\529B\3067\3042\308B\3059\3079\3066\306E\30DA\30FC\30B8\8981\7D20\306E\9078\629E</dt>'),
'<dd><pre>input</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103900849133308328)
,p_name=>'PE.PROPERTY.AFFECTED_JQUERY_SELECTOR.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30A2\30AF\30B7\30E7\30F3\306B\3088\3063\3066\5F71\97FF\3092\53D7\3051\308B1\3064\4EE5\4E0A\306E\30DA\30FC\30B8\8981\7D20\3092\8FD4\3059jQuery\30BB\30EC\30AF\30BF\306E\69CB\6587\3092\5165\529B\3057\307E\3059\3002jQuery\30E9\30A4\30D6\30E9\30EA\306B\306F\3001\30DA\30FC\30B8\304B\30891\3064\4EE5\4E0A\306E\8981\7D20\306B\7C21\5358\306B\30A2\30AF\30BB\30B9\3059\308B\65B9\6CD5\3092\63D0\4F9B\3059\308B\975E\5E38\306B\5F37\529B\306A\30BB\30EC\30AF\30BF\69CB\6587\304C\7528\610F\3055\308C\3066\3044\307E\3059\3002</p>'),
unistr('<p>\30BB\30EC\30AF\30BF\306E\69CB\6587\306E\8A73\7D30\306F\3001<a rel="noreferrer" target="_blank" href="http://docs.jquery.com">jQuery\306E\30DB\30FC\30E0\30DA\30FC\30B8</a>\304B\3089\30A2\30AF\30BB\30B9\3067\304D\308B\516C\5F0F\306E\30C9\30AD\30E5\30E1\30F3\30C8\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103900797005308328)
,p_name=>'PE.PROPERTY.AFFECTED_JQUERY_SELECTOR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('jQuery\30BB\30EC\30AF\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103900053011308327)
,p_name=>'PE.PROPERTY.AFFECTED_REGION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30AF\30B7\30E7\30F3\306B\3088\3063\3066\5F71\97FF\3092\53D7\3051\308B\30EA\30FC\30B8\30E7\30F3\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103899945022308327)
,p_name=>'PE.PROPERTY.AFFECTED_REGION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103899800395308327)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30AF\30B7\30E7\30F3\304C\5B9F\884C\3055\308C\308B\3068\5F71\97FF\3092\53D7\3051\308B\30DA\30FC\30B8\30FB\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306E\5B9A\7FA9\65B9\6CD5\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104389420493308749)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.BUTTON.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104389544045308749)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.BUTTON.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3\306F\3001\9078\629E\3057\305F\30DC\30BF\30F3\306B\5F71\97FF\3092\53CA\307C\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104735106046309031)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.COLUMN.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104735276320309031)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3\306F\3001\5165\529B\3057\305F1\3064\4EE5\4E0A\306E\5217\306B\5F71\97FF\3092\53CA\307C\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104389823097308750)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.DOM_OBJECT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('DOM\30AA\30D6\30B8\30A7\30AF\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104389975861308750)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.DOM_OBJECT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3\306F\3001\5165\529B\3057\305FDOM\30AA\30D6\30B8\30A7\30AF\30C8\307E\305F\306FDOM ID\3067\8B58\5225\3055\308C\308B\30DA\30FC\30B8\8981\7D20\306B\5F71\97FF\3092\53CA\307C\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104390432383308750)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.EVENT_SOURCE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30D9\30F3\30C8\30FB\30BD\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104390532960308750)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.EVENT_SOURCE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30A2\30AF\30B7\30E7\30F3\306F\3001\30A4\30D9\30F3\30C8\306E\767A\751F\5143\306E\30DA\30FC\30B8\8981\7D20\306B\5F71\97FF\3092\53CA\307C\3057\307E\3059\3002\3053\308C\306F\3001\30C8\30EA\30AC\30FC\8981\7D20\3068\7570\306A\308B\5834\5408\304C\3042\308A\307E\3059\3002</p>'),
unistr('<p>\3053\306E\62E1\5F35\69CB\6210\3067\306F\3001\6307\5B9A\3055\308C\305F\30C8\30EA\30AC\30FC\8981\7D20\306F\901A\5E38\30B3\30F3\30C6\30CA\8981\7D20(\30EA\30FC\30B8\30E7\30F3\306A\3069)\3067\3001\305D\306E\3059\3079\3066\306E\30B5\30D6\8981\7D20(\305D\306E\30EA\30FC\30B8\30E7\30F3\306E\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306A\3069)\3067\767A\751F\3057\305F\30A4\30D9\30F3\30C8\3092\51E6\7406\3057\307E\3059\3002'),
unistr('\3053\306E\9078\629E\30BF\30A4\30D7\306F\3001\30B3\30F3\30C6\30CA\8981\7D20\3067\306F\306A\304F\3001\30A4\30D9\30F3\30C8\3092\30C8\30EA\30AC\30FC\3057\305F\30B5\30D6\8981\7D20\3078\306E\4F5C\7528\306B\4F7F\7528\3055\308C\307E\3059\3002'),
unistr('\305F\3068\3048\3070\3001\30DA\30FC\30B8\306E\30EA\30FC\30B8\30E7\30F3\306B\5BFE\3057\3066<strong>\300C\5909\66F4\300D</strong>\30A4\30D9\30F3\30C8\3092\5B9A\7FA9\3059\308B\52D5\7684\30A2\30AF\30B7\30E7\30F3\304C\3042\308B\5834\5408\3001\30A2\30AF\30B7\30E7\30F3\306F\3001\30EA\30FC\30B8\30E7\30F3\5185\306E\5909\66F4\3055\308C\305F\5B9F\969B\306E\30A2\30A4\30C6\30E0\306B\5F71\97FF\3092\53CA\307C\3057\307E\3059\3002</p>'),
unistr('<p>\591A\304F\306E\30DA\30FC\30B8\8981\7D20\306B\5F71\97FF\3092\53CA\307C\3059\5171\901A\306E\52D5\4F5C\3092\5B9A\7FA9\3059\308B\5834\5408\3001<em>\300C\30A4\30D9\30F3\30C8\30FB\30BD\30FC\30B9\300D</em>\3092\4F7F\7528\3059\308B\65B9\304C\3088\308A\52B9\7387\7684\3067\3059\3002'),
unistr('\30B5\30D6\8981\7D20\3067\767A\751F\3057\305F\30A4\30D9\30F3\30C8\3092\6355\6349\3059\308B\30B3\30F3\30C6\30CA\8981\7D20\306E\6A5F\80FD\306F\3001\30A4\30D9\30F3\30C8\30FB\30BF\30A4\30D7\306B\3088\3063\3066\6C7A\307E\308A\307E\3059\3002'),
unistr('\6B21\306E\30A4\30D9\30F3\30C8\30FB\30BF\30A4\30D7\304C\3053\308C\3092\30B5\30DD\30FC\30C8\3057\307E\3059</p>'),
'<ul>',
unistr('  <li><strong>\30EA\30D5\30EC\30C3\30B7\30E5\5F8C</strong>(apexafterrefresh)</li>'),
unistr('  <li><strong>\30EA\30D5\30EC\30C3\30B7\30E5\524D</strong>(apexbeforerefresh)</li>'),
unistr('  <li><strong>\5909\66F4</strong>(change)</li>'),
unistr('  <li><strong>\30AF\30EA\30C3\30AF</strong>(click)</li>'),
unistr('  <li><strong>\30C0\30D6\30EB\30AF\30EA\30C3\30AF</strong>(dblclick)</li>'),
unistr('  <li><strong>\30D5\30A9\30FC\30AB\30B9\3092\53D6\5F97</strong>(focus)</li>'),
unistr('  <li><strong>\30AD\30FC\30FB\30C0\30A6\30F3</strong>(keydown)</li>'),
unistr('  <li><strong>\30AD\30FC\30FB\30D7\30EC\30B9</strong>(keypress)</li>'),
unistr('  <li><strong>\30AD\30FC\30FB\30EA\30EA\30FC\30B9</strong>(keyup)</li>'),
unistr('  <li><strong>\30D5\30A9\30FC\30AB\30B9\3092\5931\3046</strong>(blur)</li>'),
unistr('  <li><strong>\30DE\30A6\30B9\30FB\30DC\30BF\30F3\30FB\30D7\30EC\30B9</strong>(mousedown)</li>'),
unistr('  <li><strong>\30DE\30A6\30B9\30FB\30DC\30BF\30F3\30FB\30EA\30EA\30FC\30B9</strong>(mouseup)</li>'),
unistr('  <li><strong>\30DE\30A6\30B9\30FB\30E0\30FC\30D6</strong>(mousemove)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104389263906308749)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.ITEM.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104389385138308749)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3\306F\3001\5165\529B\3057\305F1\3064\4EE5\4E0A\306E\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306B\5F71\97FF\3092\53CA\307C\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104731852561309028)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.JAVASCRIPT_EXPRESSION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('JavaScript\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104731969288309028)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.JAVASCRIPT_EXPRESSION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3\306F\3001\5165\529B\3057\305FJavaScript\5F0F\3092\4F7F\7528\3057\3066\8FD4\3055\308C\305F\30DA\30FC\30B8\8981\7D20\306B\5F71\97FF\3092\53CA\307C\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104390055237308750)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.JQUERY_SELECTOR.D'
,p_message_language=>'ja'
,p_message_text=>unistr('jQuery\30BB\30EC\30AF\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104390197071308750)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.JQUERY_SELECTOR.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3\306F\3001\5165\529B\3057\305FjQuery\30BB\30EC\30AF\30BF\69CB\6587\3092\4F7F\7528\3057\3066\8FD4\3055\308C\305F\30DA\30FC\30B8\8981\7D20\306B\5F71\97FF\3092\53CA\307C\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104389663407308749)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.REGION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104389736435308750)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.REGION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3\306F\3001\9078\629E\3057\305F\30EA\30FC\30B8\30E7\30F3\306B\5F71\97FF\3092\53CA\307C\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104390205259308750)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.TRIGGERING_ELEMENT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C8\30EA\30AC\30FC\8981\7D20')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104390363251308750)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.TRIGGERING_ELEMENT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3\306F\3001\52D5\7684\30A2\30AF\30B7\30E7\30F3\3092\30C8\30EA\30AC\30FC\3057\305F\30DA\30FC\30B8\8981\7D20\307E\305F\306F\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\5F71\97FF\3092\53CA\307C\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103899764523308327)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104012380150308444)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.COMPONENT_PROPERTY.JET_CHART_SERIES.NULL_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\96C6\8A08\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104012479176308445)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.COMPONENT_PROPERTY.JET_CHART_SERIES.NULL_TEXT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024\5217\3092\8FD4\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104662616325308969)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\95A2\9023\4ED8\3051\3089\308C\305F\30C1\30E3\30FC\30C8\5024\5217\306E\96C6\8A08\65B9\6CD5\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104664123930308970)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.APPROX_COUNT_DISTINCT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5225\3005\306B\30AB\30A6\30F3\30C8(\6982\6570)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104664236253308970)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.APPROX_COUNT_DISTINCT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\500B\5225\5024\306E\6982\6570\3092\623B\3057\307E\3059\3002\3053\306E\96C6\8A08\306F\3001\5927\91CF\306E\30C7\30FC\30BF\3092\51E6\7406\3059\308B\5834\5408\306F\3001<em>\300C\5225\3005\306B\30AB\30A6\30F3\30C8\300D</em>\3088\308A\306F\308B\304B\306B\9AD8\901F\306B\306A\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104663150152308970)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.AVG.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5E73\5747')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104663270808308970)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.AVG.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024\5217\306E\5E73\5747\3092\623B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104662717516308969)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.COUNT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\4EF6\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104662846296308969)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.COUNT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30B3\30FC\30C9\306E\6570\3092\623B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104663983625308970)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.COUNT_DISTINCT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5225\3005\306B\30AB\30A6\30F3\30C8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104664065333308970)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.COUNT_DISTINCT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\500B\5225\5024\306E\6B63\78BA\306A\6570\3092\623B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104663709262308970)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MAX.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5927')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104663838349308970)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MAX.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5927\5024\3092\623B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104663397163308970)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MEDIAN.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E1\30B8\30A2\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104663447490308970)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MEDIAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('null\3092\7121\8996\3057\305F\4E2D\592E\5024\3092\623B\3057\307E\3059\3002\3053\306E\96C6\8A08\306F\3001\4E2D\592E\306B\3042\308B\6570\5024\3092\623B\3059\305F\3081\3001\9023\7D9A\5206\5E03\30E2\30C7\30EB\306B\6700\3082\9069\3057\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104663531167308970)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MIN.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104663645119308970)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MIN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5C0F\5024\3092\623B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104662941119308969)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.SUM.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5408\8A08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104663068938308969)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.SUM.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024\5217\306E\5408\8A08\3092\623B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104662557194308969)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024\96C6\8A08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103879126289308307)
,p_name=>'PE.PROPERTY.ALLOW_DUPLICATE_PAGE_SUBMISSIONS.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\540C\3058\30DA\30FC\30B8\3092\8907\6570\56DE\9001\4FE1\3067\304D\308B\304B\3069\3046\304B\3092\9078\629E\3057\307E\3059\3002'),
unistr('\3053\306E\6A5F\80FD\3092\4F7F\7528\3057\3066\3001\540C\3058\8868\306B\91CD\8907\3057\3066\633F\5165\3055\308C\306A\3044\3088\3046\306B\3057\307E\3059\3002'),
unistr('\3053\308C\306F\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\30D6\30E9\30A6\30B6\306E\300C\623B\308B\300D\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3057\3066\30DA\30FC\30B8\3092\518D\5EA6\9001\4FE1\3057\305F\5834\5408\3084\3001\30D6\30E9\30A6\30B6\306E\300C\30EA\30ED\30FC\30C9\300D\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3057\305F\5834\5408\306B\767A\751F\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104380745317308742)
,p_name=>'PE.PROPERTY.ALLOW_DUPLICATE_PAGE_SUBMISSIONS.LOV.N.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\3044\3044\3048 - \30DA\30FC\30B8\306E\518D\30DD\30B9\30C8\3092\9632\6B62\3059\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104380829053308742)
,p_name=>'PE.PROPERTY.ALLOW_DUPLICATE_PAGE_SUBMISSIONS.LOV.Y.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\306F\3044 - \30DA\30FC\30B8\306E\518D\30DD\30B9\30C8\3092\8A31\53EF\3059\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103879077361308307)
,p_name=>'PE.PROPERTY.ALLOW_DUPLICATE_PAGE_SUBMISSIONS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306E\91CD\8907\9001\4FE1\306E\8A31\53EF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104208950215308616)
,p_name=>'PE.PROPERTY.ALLOW_EXCLUDE_NULL_VALUES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5358\4E00\30EC\30B3\30FC\30C9\30FB\30D3\30E5\30FC\3067null\5217\3092\975E\8868\793A\306B\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104208886268308616)
,p_name=>'PE.PROPERTY.ALLOW_EXCLUDE_NULL_VALUES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('NULL\5024\306E\9664\5916')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104209195968308616)
,p_name=>'PE.PROPERTY.ALLOW_HIDE_EXTRA_COLUMNS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\8868\793A\3055\308C\3066\3044\308B\5217\306E\307F\3092\5358\4E00\30EC\30B3\30FC\30C9\30FB\30D3\30E5\30FC\306B\8868\793A\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002<strong>\300C\30AA\30D5\300D</strong>\3092\9078\629E\3059\308B\3068\3001\975E\8868\793A\306E\30EC\30DD\30FC\30C8\5217\3082\5358\4E00\30EC\30B3\30FC\30C9\30FB\30D3\30E5\30FC\306B\8868\793A\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104209069518308616)
,p_name=>'PE.PROPERTY.ALLOW_HIDE_EXTRA_COLUMNS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\3055\308C\3066\3044\308B\5217\306E\307F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104203012008308612)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_AGGREGATE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\3053\306E\5217\3092\96C6\8A08\3067\304D\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104202942255308612)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_AGGREGATE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\96C6\8A08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104203440061308612)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_CHART.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\30C1\30E3\30FC\30C8\5185\3067\3053\306E\5217\3092\4F7F\7528\3067\304D\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104203394776308612)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_CHART.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104203219057308612)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_COMPUTE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\5B9A\7FA9\3059\308B\8A08\7B97\5217\3067\3053\306E\5217\3092\4F7F\7528\3067\304D\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104203185328308612)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_COMPUTE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A08\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104202842347308611)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_CONTROL_BREAK.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\30B3\30F3\30C8\30ED\30FC\30EB\30FB\30D6\30EC\30FC\30AF\3067\3053\306E\5217\3092\4F7F\7528\3067\304D\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104202745521308611)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_CONTROL_BREAK.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30C8\30ED\30FC\30EB\30FB\30D6\30EC\30FC\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104202425775308611)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_FILTER.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\3053\306E\5217\3092\30D5\30A3\30EB\30BF\3067\304D\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104202387012308611)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_FILTER.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30EB\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104203654273308612)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_GROUP_BY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\3053\306E\5217\306B\3088\3063\3066\30B0\30EB\30FC\30D7\5316\3067\304D\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104203575824308612)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_GROUP_BY.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30EB\30FC\30D7\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104202008282308611)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_HIDE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\3053\306E\5217\3092\975E\8868\793A\306B\3067\304D\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104201958371308611)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_HIDE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\975E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104202611796308611)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_HIGHLIGHT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\3053\306E\5217\3092\30CF\30A4\30E9\30A4\30C8\3067\304D\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104202581939308611)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_HIGHLIGHT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CF\30A4\30E9\30A4\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103515819099308027)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_PIVOT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\3053\306E\30EC\30DD\30FC\30C8\5185\306B\30D4\30DC\30C3\30C8\30FB\30D6\30EC\30FC\30AF\30C0\30A6\30F3\3092\5B9A\7FA9\3067\304D\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103515759526308027)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_PIVOT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D4\30DC\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104216906736308622)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_PUBLIC_REPORT.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\73FE\5728\306E\30EC\30DD\30FC\30C8\5B9A\7FA9\3092<em>\30D1\30D6\30EA\30C3\30AF</em>\30FB\30EC\30DD\30FC\30C8\3068\3057\3066\4FDD\5B58\3067\304D\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002</p>'),
unistr('<p>\30D1\30D6\30EA\30C3\30AF\30FB\30EC\30DD\30FC\30C8\306F\691C\7D22\30D0\30FC\306E\4F7F\7528\53EF\80FD\306A\30EC\30DD\30FC\30C8\306E\9078\629E\30EA\30B9\30C8\306B\8868\793A\3055\308C\3001\5168\54E1\306B\8868\793A\3055\308C\307E\3059\3002'),
unistr('\300C\30A2\30AF\30B7\30E7\30F3\300D\30E1\30CB\30E5\30FC\306E\30AA\30D7\30B7\30E7\30F3\306F\3001\8A8D\8A3C\3055\308C\305F\30E6\30FC\30B6\30FC\306E\307F\4F7F\7528\3067\304D\3001<strong>\300C\30D1\30D6\30EA\30C3\30AF\30FB\30EC\30DD\30FC\30C8\306E\4FDD\5B58\306E\8A8D\53EF\300D</strong>\3082\7D44\307F\8FBC\3080\3068\3001\3055\3089\306B\9650\5B9A\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104216807453308622)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_PUBLIC_REPORT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30D6\30EA\30C3\30AF\30FB\30EC\30DD\30FC\30C8\306E\4FDD\5B58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104216750262308622)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_REPORTS.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\73FE\5728\306E\30EC\30DD\30FC\30C8\5B9A\7FA9\3092<em>\30D7\30E9\30A4\30D9\30FC\30C8</em>\30FB\30EC\30DD\30FC\30C8\3068\3057\3066\4FDD\5B58\3067\304D\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002</p>'),
unistr('<p>\30E6\30FC\30B6\30FC\304C\8A8D\8A3C\3055\308C\3066\3044\308B\5834\5408\3001\30D7\30E9\30A4\30D9\30FC\30C8\30FB\30EC\30DD\30FC\30C8\306F\691C\7D22\30D0\30FC\306E\4F7F\7528\53EF\80FD\306A\30EC\30DD\30FC\30C8\306E\9078\629E\30EA\30B9\30C8\306B\8868\793A\3055\308C\3001\30EC\30DD\30FC\30C8\3092\4FDD\5B58\3057\305F\30E6\30FC\30B6\30FC\306B\306E\307F\8868\793A\3055\308C\307E\3059\3002'),
unistr('\300C\30A2\30AF\30B7\30E7\30F3\300D\30E1\30CB\30E5\30FC\306E\30AA\30D7\30B7\30E7\30F3\306F\3001\8A8D\8A3C\3055\308C\305F\30E6\30FC\30B6\30FC\306E\307F\4F7F\7528\3067\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104216666473308622)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_REPORTS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\306E\4FDD\5B58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104217163208308622)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_REPORT_CATEGORIES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\30EC\30DD\30FC\30C8\30FB\30AB\30C6\30B4\30EA\3092\4FDD\5B58\3067\304D\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104217020858308622)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_REPORT_CATEGORIES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\30FB\30AB\30C6\30B4\30EA\306E\4FDD\5B58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104202273942308611)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SORT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\3053\306E\5217\3092\30BD\30FC\30C8\3067\304D\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104202105651308611)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SORT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104103846415308520)
,p_name=>'PE.PROPERTY.ALTERNATIVE_LABEL.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30C0\30A4\30A2\30ED\30B0\304A\3088\3073\5358\4E00\884C\30D3\30E5\30FC\3067\4F7F\7528\3059\308B\4EE3\66FF\30E9\30D9\30EB\3092\5165\529B\3057\307E\3059\3002'),
unistr('        \30D8\30C3\30C0\30FC\306BHTML\30BF\30B0\306A\3069\306E\6B63\3057\304F\8868\793A\3055\308C\306A\3044\4F59\5206\306A\66F8\5F0F\8A2D\5B9A\304C\542B\307E\308C\308B\5834\5408\306B\4EE3\66FF\30E9\30D9\30EB\3092\4F7F\7528\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104103763629308519)
,p_name=>'PE.PROPERTY.ALTERNATIVE_LABEL.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4EE3\66FF\30E9\30D9\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103980667836308421)
,p_name=>'PE.PROPERTY.ALWAYS_EXECUTE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\691C\8A3C\3092\5E38\306B\5B9F\884C\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002'),
unistr('<strong>\300C\30AA\30F3\300D</strong>\306B\8A2D\5B9A\3057\305F\5834\5408\3001\30DA\30FC\30B8\3092\9001\4FE1\3057\305F\30DC\30BF\30F3\306B\5BFE\3057\3066\5B9A\7FA9\3055\308C\3066\3044\308B<em>\300C\691C\8A3C\306E\5B9F\884C\300D</em>\306E\8A2D\5B9A\306B\95A2\4FC2\306A\304F\3001\3053\306E\691C\8A3C\306F\5E38\306B\8A55\4FA1\3055\308C\307E\3059\3002'),
unistr('<strong>\300C\30AA\30D5\300D</strong>\306B\8A2D\5B9A\3057\305F\5834\5408\3001\3053\306E\691C\8A3C\306F\3001\30C8\30EA\30AC\30FC\5143\306E\30DC\30BF\30F3\306E<em>\300C\691C\8A3C\306E\5B9F\884C\300D</em>\8A2D\5B9A\304C<strong>\300C\30AA\30F3\300D</strong>\306E\5834\5408\306B\306E\307F\8A55\4FA1\3055\308C\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8: \3053\306E\691C\8A3C\306F\3001\8A55\4FA1\3055\308C\308B\524D\306B\6307\5B9A\3055\308C\308B\6761\4EF6\306B\9069\5408\3059\308B\5FC5\8981\3082\3042\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103980525090308421)
,p_name=>'PE.PROPERTY.ALWAYS_EXECUTE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5E38\306B\5B9F\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104146758450308555)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30C1\30E3\30FC\30C8\306E\30C7\30FC\30BF\306E\5909\66F4\6642\306B\30A2\30CB\30E1\30FC\30B7\30E7\30F3\3092\8868\793A\3059\308B\304B\3069\3046\304B\3092\9078\629E\3057\307E\3059\3002\30C1\30E3\30FC\30C8\304C\81EA\52D5\7684\306B\30EA\30D5\30EC\30C3\30B7\30E5\3055\308C\308B\5834\5408\3001\51E1\4F8B\30A2\30A4\30C6\30E0\3092\30AF\30EA\30C3\30AF\3057\305F\3068\304D\306B\8868\793A/\975E\8868\793A\52D5\4F5C\304C\5B9F\884C\3055\308C\308B\5834\5408\307E\305F\306F\30C1\30E3\30FC\30C8\30FB\30C7\30FC\30BF\304C\30AB\30B9\30BF\30E0JavaScript\30B3\30FC\30C9\307E\305F\306F\52D5\7684\30A2\30AF\30B7\30E7\30F3\3092\4ECB\3057\3066\30D7\30ED\30B0\30E9\30E0\306B\3088\3063\3066\66F4\65B0\3055\308C\308B\5834\5408\306B\30C7\30FC\30BF\5909\66F4\304C\767A\751F\3059\308B\53EF\80FD\6027\304C\3042\308A\307E\3059\3002</p>'),
unistr('        <p>\30AA\30D7\30B7\30E7\30F3<strong>\300C\5DE6\3078\30B9\30E9\30A4\30C9\300D</strong>\304A\3088\3073<strong>\300C\53F3\3078\30B9\30E9\30A4\30C9\300D</strong>\306F\3001\30C0\30A4\30E4\30EB\30FB\30C1\30E3\30FC\30C8\306B\9069\7528\3055\308C\307E\305B\3093</p>\3002  ')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104146889612308555)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.AUTO.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104277333099308666)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.AUTO.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\306EOracle JET\5B9A\7FA9\6E08\30C7\30D5\30A9\30EB\30C8\30FB\30A2\30CB\30E1\30FC\30B7\30E7\30F3\8A2D\5B9A\3092\9069\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104147162791308556)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.NONE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104286880013308672)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.NONE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\304C\5909\66F4\3055\308C\308B\3068\3001\30A2\30CB\30E1\30FC\30B7\30E7\30F3\304C\30C1\30E3\30FC\30C8\306B\9069\7528\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104146938067308555)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.SLIDETOLEFT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5DE6\3078\30B9\30E9\30A4\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104286653814308672)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.SLIDETOLEFT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\304C\5909\66F4\3055\308C\308B\3068\3001\30C7\30FC\30BF\8981\7D20\304C\5DE6\306B\30B9\30E9\30A4\30C9\3057\307E\3059\3002\3053\306E\8A2D\5B9A\306F\3001\30AC\30F3\30C8\30FB\30C1\30E3\30FC\30C8\306B\306F\9069\7528\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104147061222308556)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.SLIDETORIGHT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\53F3\3078\30B9\30E9\30A4\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104286788483308672)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.SLIDETORIGHT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\304C\5909\66F4\3055\308C\308B\3068\3001\30C7\30FC\30BF\8981\7D20\304C\53F3\306B\30B9\30E9\30A4\30C9\3057\307E\3059\3002\3053\306E\8A2D\5B9A\306F\3001\30AC\30F3\30C8\30FB\30C1\30E3\30FC\30C8\306B\306F\9069\7528\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104146644104308555)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\5909\66F4\6642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104146132470308555)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30C1\30E3\30FC\30C8\3092\6700\521D\306B\8868\793A\3059\308B\5834\5408\306B\4F7F\7528\3059\308B\30A2\30CB\30E1\30FC\30B7\30E7\30F3\306E\30BF\30A4\30D7\3092\9078\629E\3057\307E\3059\3002</p>'),
unistr('        <p>\30AA\30D7\30B7\30E7\30F3<strong>\300C\30A2\30EB\30D5\30A1\30FB\30D5\30A7\30FC\30C9\300D</strong>\304A\3088\3073<strong>\300C\30BA\30FC\30E0\300D</strong>\306F\3001\30C0\30A4\30E4\30EB\30FB\30C1\30E3\30FC\30C8\306B\9069\7528\3055\308C\307E\305B\3093\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104146347253308555)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.ALPHAFADE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30EB\30D5\30A1\30FB\30D5\30A7\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104277089242308665)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.ALPHAFADE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\521D\306B\8868\793A\3059\308B\5834\5408\306B\30C1\30E3\30FC\30C8\3092\30D5\30A7\30FC\30C9\30FB\30A4\30F3\3057\307E\3059\3002\3053\306E\8A2D\5B9A\306F\3001\30AC\30F3\30C8\30FB\30C1\30E3\30FC\30C8\306B\306F\9069\7528\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104146202738308555)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.AUTO.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104276958684308665)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.AUTO.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\306EOracle JET\5B9A\7FA9\6E08\30C7\30D5\30A9\30EB\30C8\30FB\30A2\30CB\30E1\30FC\30B7\30E7\30F3\8A2D\5B9A\3092\9069\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104146592930308555)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.NONE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104277221352308665)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.NONE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\521D\306B\8868\793A\3059\308B\5834\5408\306B\30A2\30CB\30E1\30FC\30B7\30E7\30F3\304C\30C1\30E3\30FC\30C8\306B\9069\7528\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104146434839308555)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.ZOOM.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BA\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104277161303308665)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.ZOOM.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\521D\306B\8868\793A\3059\308B\5834\5408\306B\30C1\30E3\30FC\30C8\306B\30BA\30FC\30E0\30FB\30A4\30F3\3057\307E\3059\3002\3053\306E\8A2D\5B9A\306F\3001\30AC\30F3\30C8\30FB\30C1\30E3\30FC\30C8\306B\306F\9069\7528\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104146082861308555)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\6642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104558639859308885)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.BUTTON.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\8FFD\52A0\3059\308B\30AF\30E9\30B9\3092\5165\529B\3057\307E\3059\3002\8907\6570\306E\30AF\30E9\30B9\306F\7A7A\767D\3067\533A\5207\3063\3066\8FFD\52A0\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104581715335308904)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.CARD_ACTION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\8FFD\52A0\3059\308B\30AF\30E9\30B9\3092\5165\529B\3057\307E\3059\3002\8907\6570\306E\30AF\30E9\30B9\306F\7A7A\767D\3067\533A\5207\3063\3066\8FFD\52A0\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104559411280308886)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.CLASSIC_REPORT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\306B\8FFD\52A0\3059\308B\8FFD\52A0\306ECSS\30AF\30E9\30B9\3092\7A7A\767D\3067\533A\5207\3063\3066\5165\529B\3057\307E\3059\3002\30EC\30DD\30FC\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306B<code>#COMPONENT_CSS_CLASSES#</code>\7F6E\63DB\6587\5B57\5217\3092\542B\3081\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104113387370308527)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\8FFD\52A0\3059\308B\30AF\30E9\30B9\3092\5165\529B\3057\307E\3059\3002\8907\6570\306E\30AF\30E9\30B9\306F\7A7A\767D\3067\533A\5207\3063\3066\8FFD\52A0\3067\304D\307E\3059\3002</p>'),
'',
unistr('        <p>\30CE\30FC\30C8: \3053\308C\3089\306ECSS\30AF\30E9\30B9\306F\3001\5BFE\8A71\30B0\30EA\30C3\30C9\306E\30BB\30EB\306B\9069\7528\3055\308C\307E\3059\3002\5BFE\5FDC\3059\308B\30A2\30A4\30C6\30E0\306BCSS\30AF\30E9\30B9\3092\9069\7528\3059\308B\306B\306F\3001\300C\8A73\7D30\300D\30B0\30EB\30FC\30D7\306E\4E0B\306E\300CCSS\30AF\30E9\30B9\300D\30D7\30ED\30D1\30C6\30A3\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104558316354308885)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.PAGE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\8FFD\52A0\3059\308B\30AF\30E9\30B9\3092\5165\529B\3057\307E\3059\3002\8907\6570\306E\30AF\30E9\30B9\306F\7A7A\767D\3067\533A\5207\3063\3066\8FFD\52A0\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104558420255308885)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30A2\30A4\30C6\30E0\306B\8FFD\52A0\3059\308B\30AF\30E9\30B9\3092\5165\529B\3057\307E\3059\3002\8907\6570\306E\30AF\30E9\30B9\306F\7A7A\767D\3067\533A\5207\3063\3066\8FFD\52A0\3067\304D\307E\3059\3002<p/>'),
unistr('        <p>\3053\306E\30D7\30ED\30D1\30C6\30A3\3092\4F7F\7528\3059\308B\3053\3068\3067\3001\30C6\30F3\30D7\30EC\30FC\30C8\30FB\30AA\30D7\30B7\30E7\30F3\3092\8D85\3048\305F\30B9\30BF\30A4\30EB\5909\66F4\3092\30A2\30A4\30C6\30E0\306B\8FFD\52A0\3057\305F\308A\3001JavaScript\3092\901A\3058\3066\3053\306E\30A2\30A4\30C6\30E0\3092\9078\629E\3059\308B\7C21\5358\306A\65B9\6CD5\3092\63D0\4F9B\3067\304D\307E\3059\3002</p>'),
unistr('        <p>\30CE\30FC\30C8: CSS\30AF\30E9\30B9\3092HTML\306E\30D5\30A9\30FC\30E0\8981\7D20\30BF\30B0\306B\9069\7528\3059\308B\306B\306F\3001\300C\8A73\7D30\300D\30B0\30EB\30FC\30D7\306E\4E0B\306E\300CCSS\30AF\30E9\30B9\300D\30D7\30ED\30D1\30C6\30A3\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104558760665308886)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\8FFD\52A0\3059\308B\30AF\30E9\30B9\3092\5165\529B\3057\307E\3059\3002\8907\6570\306E\30AF\30E9\30B9\306F\7A7A\767D\3067\533A\5207\3063\3066\8FFD\52A0\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104559614090308886)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.REGION_PLUGIN_ATTRIBUTES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\8FFD\52A0\3059\308B\30AF\30E9\30B9\3092\5165\529B\3057\307E\3059\3002\8907\6570\306E\30AF\30E9\30B9\306F\7A7A\767D\3067\533A\5207\3063\3066\8FFD\52A0\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104559570996308886)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.TABULAR_FORM.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\306B\8FFD\52A0\3059\308B\8FFD\52A0\306ECSS\30AF\30E9\30B9\3092\7A7A\767D\3067\533A\5207\3063\3066\5165\529B\3057\307E\3059\3002\30EC\30DD\30FC\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306B<code>#COMPONENT_CSS_CLASSES#</code>\7F6E\63DB\6587\5B57\5217\3092\542B\3081\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104558293970308885)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>CSS\30AF\30E9\30B9<code>articlenumber</code>\304A\3088\3073<code>highlight</code>\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\3078\306E\8FFD\52A0</dt>'),
'<dd><pre>articlenumber highlight</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104558114788308885)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\8FFD\52A0\3059\308B\30AF\30E9\30B9\3092\5165\529B\3057\307E\3059\3002\8907\6570\306E\30AF\30E9\30B9\306F\7A7A\767D\3067\533A\5207\3063\3066\8FFD\52A0\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104558015357308885)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('CSS\30AF\30E9\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103517332865308028)
,p_name=>'PE.PROPERTY.APP_ITEM_SCOPE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\306E\6709\52B9\7BC4\56F2\3092\9078\629E\3057\307E\3059\3002&PRODUCT_NAME.\30BB\30C3\30B7\30E7\30F3\304C\8907\6570\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\5171\6709\3055\308C\3001\30A2\30A4\30C6\30E0\306E\5024\3092\3059\3079\3066\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\540C\4E00\306B\3059\308B\306B\306F\3001<strong>\300C\30B0\30ED\30FC\30D0\30EB\300D</strong>\3092\9078\629E\3057\307E\3059\3002'),
unistr('\305D\308C\4EE5\5916\306E\5834\5408\306F<strong>\300C\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\300D</strong>\3092\6307\5B9A\3057\307E\3059(\3053\308C\304C\30C7\30D5\30A9\30EB\30C8\306E\6709\52B9\7BC4\56F2\3067\3059)\3002</p>'),
unistr('<p>\8907\6570\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\8A8D\8A3C\306B\540C\3058<em>\30BB\30C3\30B7\30E7\30F3\306ECookie\5C5E\6027</em>\304C\6307\5B9A\3055\308C\3066\3044\308B\5834\5408\3001\305D\308C\3089\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306F\540C\3058\30BB\30C3\30B7\30E7\30F3\3092\5171\6709\3067\304D\307E\3059\3002'),
unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\306E\6709\52B9\7BC4\56F2\5C5E\6027\306F\3001\3053\308C\3089\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\9593\3067\540C\4E00\3067\3042\308B\5FC5\8981\3082\3042\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104412525634308767)
,p_name=>'PE.PROPERTY.APP_ITEM_SCOPE.LOV.APP.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104412686484308767)
,p_name=>'PE.PROPERTY.APP_ITEM_SCOPE.LOV.GLOBAL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30ED\30FC\30D0\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103517200393308028)
,p_name=>'PE.PROPERTY.APP_ITEM_SCOPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6709\52B9\7BC4\56F2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104163347580308578)
,p_name=>'PE.PROPERTY.ASSIGNED_TO_Y2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30B7\30EA\30FC\30BA\3092\30C1\30E3\30FC\30C8\3067\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\308BY2\8EF8\306B\5272\308A\5F53\3066\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104163274868308578)
,p_name=>'PE.PROPERTY.ASSIGNED_TO_Y2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('Y2\8EF8\306B\5272\5F53\3066')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103981224060308421)
,p_name=>'PE.PROPERTY.ASSOCIATED_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DA\30FC\30B8\51E6\7406\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\95A2\9023\4ED8\3051\308B\5217\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103981192822308421)
,p_name=>'PE.PROPERTY.ASSOCIATED_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\95A2\9023\4ED8\3051\3089\308C\305F\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103981010863308421)
,p_name=>'PE.PROPERTY.ASSOCIATED_ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\3053\306E\691C\8A3C\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\304C\8868\793A\3055\308C\308B\30A2\30A4\30C6\30E0\3092\9078\629E\3057\307E\3059\3002'),
unistr('\30A2\30A4\30C6\30E0\3092\9078\629E\3057\3001<em>\300C\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\8868\793A\4F4D\7F6E\300D</em>\306B\300C\30D5\30A3\30FC\30EB\30C9\3067\30A4\30F3\30E9\30A4\30F3\8868\793A\300D\304C\542B\307E\308C\3066\3044\308B\5834\5408\3001\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\306F\6307\5B9A\3055\308C\305F\30A2\30A4\30C6\30E0\306E\30E9\30D9\30EB\306E\4E0B\306B\8868\793A\3055\308C\307E\3059\3002'),
unistr('<em>\300C\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\8868\793A\4F4D\7F6E\300D</em>\306B\300C\30D5\30A3\30FC\30EB\30C9\3067\30A4\30F3\30E9\30A4\30F3\8868\793A\300D\304C\542B\307E\308C\3066\3044\306A\3044\5834\5408\3001\3053\306E\5C5E\6027\306F\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\306E\8868\793A\306B\5F71\97FF\3092\53CA\307C\3057\307E\305B\3093\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103980934435308421)
,p_name=>'PE.PROPERTY.ASSOCIATED_ITEM.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\95A2\9023\4ED8\3051\3089\308C\305F\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104584748125308906)
,p_name=>'PE.PROPERTY.AUTHENTICATION_TYPE.LOV.NATIVE_CUSTOM.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30B9\30BF\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103963060087308407)
,p_name=>'PE.PROPERTY.AUTHENTICATION_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AD\30FC\30E0\30FB\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103908651060308334)
,p_name=>'PE.PROPERTY.AUTHORIZATION_SCHEME.COMPONENT_PROPERTY.PAGE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30DA\30FC\30B8\306B\9069\7528\3059\308B\8A8D\53EF\30B9\30AD\30FC\30E0\3092\9078\629E\3057\307E\3059\3002\8A8D\53EF\30B9\30AD\30FC\30E0\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30EC\30D9\30EB\3067\5B9A\7FA9\3055\308C\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5185\306E\591A\304F\306E\8981\7D20\306B\9069\7528\3067\304D\307E\3059\3002</p>'),
unistr('<p>\8A8D\53EF\30B9\30AD\30FC\30E0\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30BB\30C3\30B7\30E7\30F3\3054\3068\306B1\56DE(\30BB\30C3\30B7\30E7\30F3\4F5C\6210\6642\306B)\8A55\4FA1\3055\308C\308B\304B\3001\307E\305F\306F\30DA\30FC\30B8\30FB\30D3\30E5\30FC\3054\3068\306B1\56DE\8A55\4FA1\3055\308C\307E\3059\3002\9078\629E\3057\305F\8A8D\53EF\30B9\30AD\30FC\30E0\304C<strong>TRUE</strong>\3068\8A55\4FA1\3055\308C\308B\3068\3001\30DA\30FC\30B8\304C\8868\793A\3055\308C\3001\305D\306E\30DA\30FC\30B8\306F\4ED6\306E\5B9A\7FA9\6E08\6761\4EF6\306B\5F93\3044\307E\3059\3002<strong>FALSE</strong>\3068\8A55\4FA1\3055\308C\308B\3068\3001\30DA\30FC\30B8\306F\8868\793A\3055\308C\305A\3001\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\304C\8868\793A\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103878360612308307)
,p_name=>'PE.PROPERTY.AUTHORIZATION_SCHEME.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\3092\5236\5FA1\3059\308B\8A8D\53EF\30B9\30AD\30FC\30E0\3092\9078\629E\3057\307E\3059\3002\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\3092\30EC\30F3\30C0\30EA\30F3\30B0\307E\305F\306F\5B9F\884C\3059\308B\305F\3081\306B\306F\3001\8A8D\53EF\306FTRUE\3068\8A55\4FA1\3055\308C\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103878250403308307)
,p_name=>'PE.PROPERTY.AUTHORIZATION_SCHEME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\53EF\30B9\30AD\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103869280438308300)
,p_name=>'PE.PROPERTY.AUTHORIZATION_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9069\7528\3055\308C\308B\8A8D\53EF\30B9\30AD\30FC\30E0\3092\9078\629E\3057\307E\3059\3002\6B21\306E\8A8D\53EF\30BF\30A4\30D7\304C\30B5\30DD\30FC\30C8\3055\308C\3066\3044\307E\3059:</p>'),
'#NATIVE_PLUGINS#',
unistr('<p>\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\69CB\6210\306B\3088\3063\3066\306F\3001\305D\306E\4ED6\306E\8A8D\53EF\30BF\30A4\30D7\30FB\30D7\30E9\30B0\30A4\30F3\304C\3053\3053\3067\4F7F\7528\53EF\80FD\306A\5834\5408\304C\3042\308A\307E\3059\3002'),
unistr('\3053\308C\3089\306F\3001<em>&lt;My Plug-in&gt; [Plug-in]</em>\3068\8868\793A\3055\308C\307E\3059\3002'),
unistr('\6B21\306E\30D7\30E9\30B0\30A4\30F3\304C\3001\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8\5185\306B\30A4\30F3\30B9\30C8\30FC\30EB\3055\308C\3066\3044\307E\3059:</p>'),
'#CUSTOM_PLUGINS#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103869169391308300)
,p_name=>'PE.PROPERTY.AUTHORIZATION_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104721188953309017)
,p_name=>'PE.PROPERTY.AUTO5N_FUNC_BODY_LANG.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\306E\5B9F\884C\306B\4F7F\7528\3055\308C\308B\8A00\8A9E\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104721404776309018)
,p_name=>'PE.PROPERTY.AUTO5N_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'ja'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104721364608309018)
,p_name=>'PE.PROPERTY.AUTO5N_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'ja'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104721276713309018)
,p_name=>'PE.PROPERTY.AUTO5N_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'ja'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104721524474309018)
,p_name=>'PE.PROPERTY.AUTO5N_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'ja'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104721001222309017)
,p_name=>'PE.PROPERTY.AUTO5N_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A00\8A9E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104722343597309018)
,p_name=>'PE.PROPERTY.AUTO5N_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\52D5\5316\306E\5B9F\884C\6642\306B\8A55\4FA1\3055\308C\308B\30C7\30FC\30BF\306E\30BD\30FC\30B9\3092\6307\5B9A\3057\307E\3059\3002\81EA\52D5\5316\306F\3001\8868\3001SQL\554F\5408\305B\3001\307E\305F\306FSQL\554F\5408\305B\3092\623B\3059PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\306B\57FA\3065\304F\3053\3068\304C\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104722222639309018)
,p_name=>'PE.PROPERTY.AUTO5N_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('Java\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104722138365309018)
,p_name=>'PE.PROPERTY.AUTO5N_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3059\308B\5834\5408\3001YES\3092\8FD4\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES", "NO" );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104722008972309018)
,p_name=>'PE.PROPERTY.AUTO5N_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\52D5\5316\306E\5B9F\884C\6642\306B\8A55\4FA1\3055\308C\308B\30C7\30FC\30BF\306E\30BD\30FC\30B9\3092\6307\5B9A\3057\307E\3059\3002\81EA\52D5\5316\306F\3001\8868\3001SQL\554F\5408\305B\3001\307E\305F\306FSQL\554F\5408\305B\3092\623B\3059PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\306B\57FA\3065\304F\3053\3068\304C\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104721929991309018)
,p_name=>'PE.PROPERTY.AUTO5N_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('JavaScript\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104721864607309018)
,p_name=>'PE.PROPERTY.AUTO5N_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3059\308B\5834\5408\3001YES\3092\8FD4\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104721728570309018)
,p_name=>'PE.PROPERTY.AUTO5N_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\52D5\5316\306E\5B9F\884C\6642\306B\8A55\4FA1\3055\308C\308B\30C7\30FC\30BF\306E\30BD\30FC\30B9\3092\6307\5B9A\3057\307E\3059\3002\81EA\52D5\5316\306F\3001\8868\3001SQL\554F\5408\305B\3001\307E\305F\306FSQL\554F\5408\305B\3092\623B\3059PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\306B\57FA\3065\304F\3053\3068\304C\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104721607184309018)
,p_name=>'PE.PROPERTY.AUTO5N_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104722558472309019)
,p_name=>'PE.PROPERTY.AUTO5N_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\52D5\5316\306E\5B9F\884C\6642\306B\8A55\4FA1\3055\308C\308B\30C7\30FC\30BF\306E\30BD\30FC\30B9\3092\6307\5B9A\3057\307E\3059\3002\81EA\52D5\5316\306F\3001\8868\3001SQL\554F\5408\305B\3001\307E\305F\306FSQL\554F\5408\305B\3092\623B\3059PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\306B\57FA\3065\304F\3053\3068\304C\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104722422964309018)
,p_name=>'PE.PROPERTY.AUTO5N_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('Python\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104720615659309017)
,p_name=>'PE.PROPERTY.AUTOMATION_ADDL_PLSQL_CODE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\30B3\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104720535493309017)
,p_name=>'PE.PROPERTY.AUTOMATION_SQL_STATEMENT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104720402534309017)
,p_name=>'PE.PROPERTY.AUTOMATION_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\52D5\5316\306E\5B9F\884C\6642\306B\8A55\4FA1\3055\308C\308B\30C7\30FC\30BF\306E\30BD\30FC\30B9\3092\6307\5B9A\3057\307E\3059\3002\81EA\52D5\5316\306F\3001\8868\3001SQL\554F\5408\305B\3001\307E\305F\306FSQL\554F\5408\305B\3092\623B\3059PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\306B\57FA\3065\304F\3053\3068\304C\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104720330857309017)
,p_name=>'PE.PROPERTY.AUTOMATION_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BD\30FC\30B9\30FB\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104720970927309017)
,p_name=>'PE.PROPERTY.AUTO_ACTION_CODE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\30B3\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104720814498309017)
,p_name=>'PE.PROPERTY.AUTO_ACTION_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3\306E\30BF\30A4\30D7\3092\9078\629E\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104720763173309017)
,p_name=>'PE.PROPERTY.AUTO_ACTION_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104019630996308450)
,p_name=>'PE.PROPERTY.AUTO_DETECT.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9069\5207\306A\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\304C\81EA\52D5\7684\306B\691C\51FA\3055\308C\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002'),
unistr('\81EA\52D5\691C\51FA\304C<strong>\300C\30AA\30F3\300D</strong>\306E\5834\5408\3001\30E6\30FC\30B6\30FC\306F\3001\4F7F\7528\3057\3066\3044\308B\30C7\30D0\30A4\30B9\306E\30B5\30A4\30BA\306B\57FA\3065\3044\3066\6700\3082\9069\5207\306A\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8\307E\305F\306F\30DB\30FC\30E0\30FB\30DA\30FC\30B8\306B\81EA\52D5\7684\306B\30EA\30C0\30A4\30EC\30AF\30C8\3055\308C\307E\3059\3002'),
unistr('\30E1\30C7\30A3\30A2\554F\5408\305B\3092\4F7F\7528\3057\3066\3001\8868\793A\3059\308B\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\304C\6C7A\5B9A\3055\308C\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104019559321308450)
,p_name=>'PE.PROPERTY.AUTO_DETECT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\52D5\691C\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104165369848308580)
,p_name=>'PE.PROPERTY.AXIS_MAX.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\8EF8\306E\6700\5927\5024\3092\5165\529B\3057\307E\3059\3002\30C7\30FC\30BF\306B\57FA\3065\304F\81EA\52D5\8A08\7B97\306E\30C7\30D5\30A9\30EB\30C8\5024\306Fnull\3067\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104165257557308580)
,p_name=>'PE.PROPERTY.AXIS_MAX.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5927')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104165125013308580)
,p_name=>'PE.PROPERTY.AXIS_MIN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\8EF8\306E\6700\5C0F\5024\3092\5165\529B\3057\307E\3059\3002\30C7\30FC\30BF\306B\57FA\3065\304F\81EA\52D5\8A08\7B97\306E\30C7\30D5\30A9\30EB\30C8\5024\306Fnull\3067\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104165070907308579)
,p_name=>'PE.PROPERTY.AXIS_MIN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104166199777308580)
,p_name=>'PE.PROPERTY.AXIS_POSITION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\3067\30EC\30F3\30C0\30EA\30F3\30B0\3059\308B\30E9\30D9\30EB\306E\4F4D\7F6E\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104166297898308580)
,p_name=>'PE.PROPERTY.AXIS_POSITION.LOV.AUTO.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104166610832308581)
,p_name=>'PE.PROPERTY.AXIS_POSITION.LOV.BOTTOM.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104166413908308581)
,p_name=>'PE.PROPERTY.AXIS_POSITION.LOV.END.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D42\4E86')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104166378180308581)
,p_name=>'PE.PROPERTY.AXIS_POSITION.LOV.START.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104166556074308581)
,p_name=>'PE.PROPERTY.AXIS_POSITION.LOV.TOP.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C8\30C3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104166075594308580)
,p_name=>'PE.PROPERTY.AXIS_POSITION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104188540445308600)
,p_name=>'PE.PROPERTY.AXIS_SCALING.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\8EF8\30B9\30B1\30FC\30EB\3092\9078\629E\3057\307E\3059\3002\6570\5024\8EF8\306B\306E\307F\9069\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104188656251308600)
,p_name=>'PE.PROPERTY.AXIS_SCALING.LOV.LINEAR.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\7DDA\5F62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104188711486308600)
,p_name=>'PE.PROPERTY.AXIS_SCALING.LOV.LOG.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104188436260308600)
,p_name=>'PE.PROPERTY.AXIS_SCALING.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30B1\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104165922181308580)
,p_name=>'PE.PROPERTY.AXIS_STEP.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E3B\8981\76EE\76DB\9593\306E\5897\5206\3092\5165\529B\3057\307E\3059\3002\30C7\30FC\30BF\306B\57FA\3065\304F\81EA\52D5\8A08\7B97\306E\30C7\30D5\30A9\30EB\30C8\5024\306Fnull\3067\3059\3002\6642\9593\8EF8\304A\3088\3073\6570\5024\8EF8\306B\306E\307F\9069\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104165867714308580)
,p_name=>'PE.PROPERTY.AXIS_STEP.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30C6\30C3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104572870836308897)
,p_name=>'PE.PROPERTY.BADGE_COLUMN_NAME.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D0\30C3\30B8\3068\3057\3066\4F7F\7528\3059\308B\5217\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104572759647308897)
,p_name=>'PE.PROPERTY.BADGE_COLUMN_NAME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D0\30C3\30B8\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104573025883308897)
,p_name=>'PE.PROPERTY.BADGE_CSS_CLASSES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\8FFD\52A0\3059\308B\30AF\30E9\30B9\3092\5165\529B\3057\307E\3059\3002\8907\6570\306E\30AF\30E9\30B9\306F\7A7A\767D\3067\533A\5207\3063\3066\8FFD\52A0\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104572918776308897)
,p_name=>'PE.PROPERTY.BADGE_CSS_CLASSES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D0\30C3\30B8CSS\30AF\30E9\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104573392921308897)
,p_name=>'PE.PROPERTY.BADGE_LABEL.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>\6620\753B\306E\8A55\4FA1\3092\8868\793A\3059\308B\306B\306F</dt>'),
unistr('    <dd>\30D0\30C3\30B8\5217\3092\8A55\4FA1\5217\306B\3057\3001\30D0\30C3\30B8\30FB\30E9\30D9\30EB\3092\661F\306B\3059\308B\3053\3068\304C\3067\304D\307E\3059</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104573217613308897)
,p_name=>'PE.PROPERTY.BADGE_LABEL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D0\30C3\30B8\5024\3092\8AAC\660E\3059\308B\30D0\30C3\30B8\306E\30E9\30D9\30EB\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104573127768308897)
,p_name=>'PE.PROPERTY.BADGE_LABEL.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D0\30C3\30B8\30FB\30E9\30D9\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104268362235308659)
,p_name=>'PE.PROPERTY.BEGIN_AT_START_OF_INTERVAL.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30AB\30EC\30F3\30C0\306E\958B\59CB\65E5\3092\6C7A\5B9A\3057\307E\3059\3002\3053\306E\30AA\30D7\30B7\30E7\30F3\3092\9078\629E\3059\308B\3068\3001\9593\9694\5168\4F53\306B\308F\305F\308B\30AB\30EC\30F3\30C0\304C\4F5C\6210\3055\308C\307E\3059(1\304B\6708\306A\3069)\3002</p>'),
'<ul>',
unistr('  <li>\300C\9593\9694\306E\6700\521D\304B\3089\958B\59CB\300D\3092<strong>\300C\30AA\30F3\300D</strong>\306B\3059\308B\3068\3001\65E5\4ED8\304C6\670815\65E5\3067\3001\8868\793A\304C\6708\5225\306E\5834\5408\3001\7D50\679C\306E\30AB\30EC\30F3\30C0\306F6\67081\65E5\304B\30896\670830\65E5\306B\306A\308A\307E\3059\3002</li>'),
unistr('  <li>\300C\9593\9694\306E\6700\521D\304B\3089\958B\59CB\300D\3092<strong>\300C\30AA\30D5\300D</strong>\306B\3059\308B\3068\3001\65E5\4ED8\304C6\670815\65E5\3067\3001\8868\793A\304C\6708\5225\306E\5834\5408\3001\7D50\679C\306E\30AB\30EC\30F3\30C0\306F6\670815\65E5\304B\30896\670830\65E5\306B\306A\308A\307E\3059\3002</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104268289690308659)
,p_name=>'PE.PROPERTY.BEGIN_AT_START_OF_INTERVAL.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\9593\9694\306E\6700\521D\304B\3089\958B\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104239650410308639)
,p_name=>'PE.PROPERTY.BLOB_CHARSET_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\3059\308BBLOB\30B3\30F3\30C6\30F3\30C4\3092\683C\7D0D\3059\308B\8868\304B\3089\6587\5B57\30BB\30C3\30C8\5217\3092\9078\629E\3057\307E\3059\3002\9593\9055\3063\305F\30C7\30FC\30BF\578B\306E\5217\3092\9078\629E\3057\305F\5834\5408\3001\30A4\30E1\30FC\30B8\304C\8868\793A\3055\308C\308B\53EF\80FD\6027\306F\4F4E\3044\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104239543163308638)
,p_name=>'PE.PROPERTY.BLOB_CHARSET_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6587\5B57\30BB\30C3\30C8\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104238638195308638)
,p_name=>'PE.PROPERTY.BLOB_CONTENT_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\3059\308BBLOB\30B3\30F3\30C6\30F3\30C4\3092\683C\7D0D\3059\308B\8868\304B\3089BLOB\5217\3092\9078\629E\3057\307E\3059\3002\9593\9055\3063\305F\30C7\30FC\30BF\578B\306E\5217\3092\9078\629E\3057\305F\5834\5408\3001\30A4\30E1\30FC\30B8\304C\8868\793A\3055\308C\308B\53EF\80FD\6027\306F\4F4E\3044\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104238576988308638)
,p_name=>'PE.PROPERTY.BLOB_CONTENT_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('BLOB\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104239489621308638)
,p_name=>'PE.PROPERTY.BLOB_FILENAME_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\3059\308BBLOB\30B3\30F3\30C6\30F3\30C4\3092\683C\7D0D\3059\308B\8868\306E\30D5\30A1\30A4\30EB\540D\5217\3092\5165\529B\3057\307E\3059\3002\9593\9055\3063\305F\30C7\30FC\30BF\578B\306E\5217\3092\9078\629E\3057\305F\5834\5408\3001\30A4\30E1\30FC\30B8\304C\8868\793A\3055\308C\308B\53EF\80FD\6027\306F\4F4E\3044\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104239395189308638)
,p_name=>'PE.PROPERTY.BLOB_FILENAME_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\540D\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104239884306308639)
,p_name=>'PE.PROPERTY.BLOB_LAST_UPDATED_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\3059\308BBLOB\5217\3092\683C\7D0D\3059\308B\8868\304B\3089\6700\5F8C\306B\66F4\65B0\3055\308C\305F\5217\3092\9078\629E\3057\307E\3059\3002\65E5\4ED8\3092\4FDD\6301\3059\308B\305F\3081\306E\30C8\30EA\30AC\30FC\304C\95A2\9023\4ED8\3051\3089\308C\305F<code>UPDATED</code>\5217\304C\3059\3067\306B\3042\308B\5834\5408\3001\30A4\30E1\30FC\30B8\306E\6700\7D42\66F4\65B0\6642\5C02\7528\306E\5217\3092\65B0\305F\306B\5B9A\7FA9\3059\308B\304B\308F\308A\306B\3001\3053\306E\5217\3092\4F7F\7528\3067\304D\307E\3059\3002\305F\3060\3057\3001BLOB\30B3\30F3\30C6\30F3\30C4\4EE5\5916\306E\5217\304C\5B9A\671F\7684\306B\66F4\65B0\3055\308C\308B\5834\5408\3001\30A4\30E1\30FC\30B8\30FB\30AD\30E3\30C3\30B7\30E5\306B\60AA\5F71\97FF\3092\53CA\307C\3057\307E\3059\3002\9593\9055\3063\305F\30C7\30FC\30BF\578B\306E\5217\3092\9078\629E\3057\305F\5834\5408\3001\30A4\30E1\30FC\30B8\304C\8868\793A\3055\308C\308B\53EF\80FD\6027\306F\4F4E\3044\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104239783150308639)
,p_name=>'PE.PROPERTY.BLOB_LAST_UPDATED_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\7D42\66F4\65B0\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104239278405308638)
,p_name=>'PE.PROPERTY.BLOB_MIME_TYPE_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\3059\308BBLOB\30B3\30F3\30C6\30F3\30C4\3092\683C\7D0D\3059\308B\8868\304B\3089MIME\30BF\30A4\30D7\5217\3092\9078\629E\3057\307E\3059\3002\9593\9055\3063\305F\30C7\30FC\30BF\578B\306E\5217\3092\9078\629E\3057\305F\5834\5408\3001\30A4\30E1\30FC\30B8\304C\8868\793A\3055\308C\308B\53EF\80FD\6027\306F\4F4E\3044\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104239106589308638)
,p_name=>'PE.PROPERTY.BLOB_MIME_TYPE_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('MIME\30BF\30A4\30D7\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104238802198308638)
,p_name=>'PE.PROPERTY.BLOB_PK_COLUMN1.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\3059\308BBLOB\30B3\30F3\30C6\30F3\30C4\3092\683C\7D0D\3059\308B\8868\304B\30891\3064\76EE\306E\4E3B\30AD\30FC\5217\3092\9078\629E\3057\307E\3059\3002\3053\306E\8868\306E\4E3B\30AD\30FC\306E\5217\304C2\3064\3088\308A\591A\3044\5834\5408\3001<code>ROWID</code>\5217\3092\9078\629E\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\9593\9055\3063\305F\30C7\30FC\30BF\578B\306E\5217\3092\9078\629E\3057\305F\5834\5408\3001\30A4\30E1\30FC\30B8\304C\8868\793A\3055\308C\308B\53EF\80FD\6027\306F\4F4E\3044\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104238713994308638)
,p_name=>'PE.PROPERTY.BLOB_PK_COLUMN1.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E3B\30AD\30FC\52171')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104239008858308638)
,p_name=>'PE.PROPERTY.BLOB_PK_COLUMN2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\306E\4E3B\30AD\30FC\304C2\3064\306E\5217\304B\3089\6210\308B\5834\5408\306B\306E\307F2\3064\76EE\306E\4E3B\30AD\30FC\5217\3092\9078\629E\3057\307E\3059\30021\3064\76EE\306E\4E3B\30AD\30FC\5217\306B<code>ROWID</code>\5217\3092\9078\629E\3057\305F\5834\5408\3001\3053\306E\5217\306B\306F\79FB\5165\3057\307E\305B\3093\3002\9593\9055\3063\305F\30C7\30FC\30BF\578B\306E\5217\3092\9078\629E\3057\305F\5834\5408\3001\30A4\30E1\30FC\30B8\304C\8868\793A\3055\308C\308B\53EF\80FD\6027\306F\4F4E\3044\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104238998665308638)
,p_name=>'PE.PROPERTY.BLOB_PK_COLUMN2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E3B\30AD\30FC\52172')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104238467691308638)
,p_name=>'PE.PROPERTY.BLOB_TABLE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8868\793A\3059\308BBLOB\30B3\30F3\30C6\30F3\30C4\3092\683C\7D0D\3059\308B\8868\540D\3092\5165\529B\3057\307E\3059\3002'),
unistr('\8868\540D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\8868\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104238333885308638)
,p_name=>'PE.PROPERTY.BLOB_TABLE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104238294843308637)
,p_name=>'PE.PROPERTY.BLOB_TABLE_OWNER.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\3059\308BBLOB\30B3\30F3\30C6\30F3\30C4\3092\683C\7D0D\3059\308B\8868\3092\6240\6709\3059\308B\30B9\30AD\30FC\30DE\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104238133013308637)
,p_name=>'PE.PROPERTY.BLOB_TABLE_OWNER.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\306E\6240\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104568463649308893)
,p_name=>'PE.PROPERTY.BODY_ADV_FORMATTING.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\3092\3001\5217\307E\305F\306FHTML\5F0F\304A\3088\3073\30B5\30DD\30FC\30C8\3055\308C\3066\3044\308B\7F6E\63DB\6587\5B57\5217\3092\4F7F\7528\3059\308B\62E1\5F35\30D5\30A9\30FC\30DE\30C3\30C8\306E\3044\305A\308C\3092\4F7F\7528\3057\3066\8868\793A\3059\308B\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104568337878308893)
,p_name=>'PE.PROPERTY.BODY_ADV_FORMATTING.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\62E1\5F35\30D5\30A9\30FC\30DE\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104568651813308893)
,p_name=>'PE.PROPERTY.BODY_COLUMN_NAME.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\672C\4F53\3068\3057\3066\4F7F\7528\3059\308B\5217\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104568560919308893)
,p_name=>'PE.PROPERTY.BODY_COLUMN_NAME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104569127466308894)
,p_name=>'PE.PROPERTY.BODY_CSS_CLASSES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\8FFD\52A0\3059\308B\30AF\30E9\30B9\3092\5165\529B\3057\307E\3059\3002\8907\6570\306E\30AF\30E9\30B9\306F\7A7A\767D\3067\533A\5207\3063\3066\8FFD\52A0\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104569076742308894)
,p_name=>'PE.PROPERTY.BODY_CSS_CLASSES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('CSS\30AF\30E9\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103877978889308306)
,p_name=>'PE.PROPERTY.BODY_HEADER.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5B9F\884C\4E2D\306E\30DA\30FC\30B8\306B\8868\793A\3059\308B\30EA\30FC\30B8\30E7\30F3\306E\524D\306B\8868\793A\3059\308B\30C6\30AD\30B9\30C8\307E\305F\306FHTML\3092\5165\529B\3057\307E\3059\3002'),
unistr('\3053\3053\3067\5165\529B\3059\308B\30C6\30AD\30B9\30C8\306F\3001\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306E<code>#BODY#</code>\7F6E\63DB\6587\5B57\5217\306E\524D\306B\8868\793A\3055\308C\307E\3059\3002')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103877840191308306)
,p_name=>'PE.PROPERTY.BODY_HEADER.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30C7\30A3\30FB\30D8\30C3\30C0\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104568986515308893)
,p_name=>'PE.PROPERTY.BODY_HTML_EXPR.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>\30D0\30C3\30AF\30B0\30E9\30A6\30F3\30C9\304A\3088\3073\30C6\30AD\30B9\30C8\306E\8272\306E\5909\66F4</dt>'),
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>\30D8\30C3\30C0\30FC2\306E\4F7F\7528</dt>'),
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>SQL\554F\5408\305B\304B\3089\306E\52D5\7684\30AF\30E9\30B9\306E\4F7F\7528</dt>'),
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    \3053\306E\4F8B\3067<code>&COLUMN_CLASS.</code>\3068<code>&EMPLOYEE_STATUS.</code>\306B\4EE3\5165\3055\308C\308B\306E\306F\3001\30EC\30DD\30FC\30C8SQL\554F\5408\305B\3067\9078\629E\3055\308C\305F\5217\3067\3059\3002</dd>'),
unistr('  <dt>\30DB\30D0\30FC\3067\306E\30A4\30E1\30FC\30B8\304A\3088\3073\30C4\30FC\30EB\30C1\30C3\30D7\306E\8868\793A</dt>'),
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104568801998308893)
,p_name=>'PE.PROPERTY.BODY_HTML_EXPR.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\5217\306B\8868\793A\3055\308C\308BHTML\5F0F\3092\5165\529B\3057\307E\3059\3002<code>&COLUMN.</code>\69CB\6587\3092\4F7F\7528\3057\3066\3001HTML\306B\5217\5024\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104568710057308893)
,p_name=>'PE.PROPERTY.BODY_HTML_EXPR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('HTML\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104259500721308653)
,p_name=>'PE.PROPERTY.BRANCH_ACCEPT_REQUEST.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30E9\30F3\30C1\30FB\30EA\30F3\30AF\5185\306B\542B\3081\308B\30EA\30AF\30A8\30B9\30C8\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104259468597308653)
,p_name=>'PE.PROPERTY.BRANCH_ACCEPT_REQUEST.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30AF\30A8\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104657812975308965)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\306E\5B9F\884C\306B\4F7F\7528\3055\308C\308B\8A00\8A9E\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104658116021308965)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'ja'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104658022943308965)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'ja'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104657989897308965)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'ja'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104658256704308966)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'ja'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104657704905308965)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A00\8A9E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104233298415308634)
,p_name=>'PE.PROPERTY.BRANCH_ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30EA\30C0\30A4\30EC\30AF\30C8\5148\306E\30DA\30FC\30B8\756A\53F7\307E\305F\306FURL\3092\542B\3080\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002'),
unistr('\3053\306E\30A2\30A4\30C6\30E0\306F\30B3\30FC\30EB\5143\30DA\30FC\30B8\307E\305F\306F\30DA\30FC\30B8\304C\521D\3081\3066\30ED\30FC\30C9\3055\308C\308B\6642\3001\30D7\30ED\30BB\30B9\306B\3088\3063\3066\8A2D\5B9A\3055\308C\307E\3059\3002'),
unistr('\30A2\30A4\30C6\30E0\3092\6307\5B9A\3059\308B\3068\3001\4ED6\306E\591A\304F\306E\30DA\30FC\30B8\304B\3089\30B3\30FC\30EB\3055\308C\308B\30DA\30FC\30B8\306E\30D6\30E9\30F3\30C1\3092\52D5\7684\306B\7C21\5358\306B\8A2D\5B9A\3059\308B\65B9\6CD5\306B\306A\308A\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104233190204308634)
,p_name=>'PE.PROPERTY.BRANCH_ITEM.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104659001163308966)
,p_name=>'PE.PROPERTY.BRANCH_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30C0\30A4\30EC\30AF\30C8\5148\306E\30DA\30FC\30B8\756A\53F7\307E\305F\306FURL\3092\8FD4\3059Java\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104658932051308966)
,p_name=>'PE.PROPERTY.BRANCH_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('Java\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104658872322308966)
,p_name=>'PE.PROPERTY.BRANCH_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3059\308B\5834\5408\3001YES\3092\8FD4\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES", "NO" );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104658790289308966)
,p_name=>'PE.PROPERTY.BRANCH_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30C0\30A4\30EC\30AF\30C8\5148\306E\30DA\30FC\30B8\756A\53F7\307E\305F\306FURL\3092\8FD4\3059JavaScript\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104658682539308966)
,p_name=>'PE.PROPERTY.BRANCH_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('JavaScript\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103979550540308420)
,p_name=>'PE.PROPERTY.BRANCH_PAGE_NUMBER.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30D6\30E9\30F3\30C1\306E\30EA\30C0\30A4\30EC\30AF\30C8\5148\306E\30DA\30FC\30B8\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103979425364308420)
,p_name=>'PE.PROPERTY.BRANCH_PAGE_NUMBER.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\756A\53F7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103979723203308420)
,p_name=>'PE.PROPERTY.BRANCH_PLSQL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30E9\30F3\30C1\306B\3088\3063\3066\5B9F\884C\3055\308C\308BPL/SQL\30B3\30FC\30C9\3092\5165\529B\3057\307E\3059\3002\3053\306EPL/SQL\30D7\30ED\30B7\30FC\30B8\30E3\306F\3001\5FC5\8981\306AURL\306E\8D77\52D5\3092\62C5\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103979684446308420)
,p_name=>'PE.PROPERTY.BRANCH_PLSQL.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\30B3\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104658581545308966)
,p_name=>'PE.PROPERTY.BRANCH_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3059\308B\5834\5408\3001YES\3092\8FD4\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104658497182308966)
,p_name=>'PE.PROPERTY.BRANCH_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30C0\30A4\30EC\30AF\30C8\5148\306E\30DA\30FC\30B8\756A\53F7\307E\305F\306FURL\3092\8FD4\3059PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104658350108308966)
,p_name=>'PE.PROPERTY.BRANCH_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103979106666308420)
,p_name=>'PE.PROPERTY.BRANCH_POINT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\5185\306E\3069\306E\30DD\30A4\30F3\30C8\3067\3001\3053\306E\30D6\30E9\30F3\30C1\306E\30EC\30F3\30C0\30EA\30F3\30B0\307E\305F\306F\51E6\7406\3092\5B9F\884C\3059\308B\304B\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104401040385308758)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.AFTER_PROCESSING.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30BB\30B9\306E\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104690699496308992)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.AFTER_PROCESSING.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\51E6\7406: \51E6\7406\306E\5B9F\884C\5F8C\306B\5206\5C90\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104400729471308758)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_COMPUTATION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\9001\4FE1\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104690355247308992)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_COMPUTATION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\51E6\7406: \30DA\30FC\30B8\306E\9001\4FE1\5F8C\3067\3001\8A08\7B97\3001\691C\8A3C\304A\3088\3073\51E6\7406\306E\5B9F\884C\524D\306B\5206\5C90\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104401168724308758)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_HEADER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D8\30C3\30C0\30FC\306E\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104690787224308992)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_HEADER.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30F3\30C0\30EA\30F3\30B0: \30DA\30FC\30B8\306E\30EC\30F3\30C0\30EA\30F3\30B0\524D\306B\5206\5C90\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104400923908308758)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_PROCESSING.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30BB\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104690566068308992)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_PROCESSING.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\51E6\7406: \51E6\7406\306E\5B9F\884C\524D\306B\5206\5C90\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104400855946308758)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_VALIDATION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104690415539308992)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_VALIDATION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\51E6\7406: \691C\8A3C\306E\5B9F\884C\524D\306B\5206\5C90\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103979026364308420)
,p_name=>'PE.PROPERTY.BRANCH_POINT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DD\30A4\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104659232583308966)
,p_name=>'PE.PROPERTY.BRANCH_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30C0\30A4\30EC\30AF\30C8\5148\306E\30DA\30FC\30B8\756A\53F7\307E\305F\306FURL\3092\8FD4\3059Python\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104659104828308966)
,p_name=>'PE.PROPERTY.BRANCH_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('Python\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103978995935308419)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5B9F\884C\3059\308B\30DA\30FC\30B8\30FB\30D6\30E9\30F3\30C1\306E\30BF\30A4\30D7\3092\9078\629E\3057\307E\3059\3002</p>'),
'<dl>',
unistr('<dt>\30EA\30C0\30A4\30EC\30AF\30C8\30FB\30D6\30E9\30F3\30C1</dt>'),
unistr('<dd>&PRODUCT_NAME.\306F\3001\7D50\679C\306E\30DA\30FC\30B8\3092\8868\793A\3059\308B\524D\306B\65B0\898F\30EA\30AF\30A8\30B9\30C8\3092\5B9F\884C\3059\308B\65B0\898F\30DA\30FC\30B8\307E\305F\306FURL\3092\30D6\30E9\30A6\30B6\306B\8FD4\3057\307E\3059\3002'),
unistr('\4E3B\306A\5229\70B9\306F\3001\30D6\30E9\30A6\30B6\30FB\30A2\30C9\30EC\30B9\306B\5B8C\5168\306A\30DA\30FC\30B8URL\304C\542B\307E\308C\308B\305F\3081\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\30B3\30F3\30C6\30AD\30B9\30C8\3092\5931\3046\3053\3068\306A\304F\30DA\30FC\30B8\3092\30EA\30D5\30EC\30C3\30B7\30E5\3067\304D\308B\3053\3068\3067\3059\3002'),
unistr('\30C7\30E1\30EA\30C3\30C8\306F\3001\30DA\30FC\30B8\3092\8868\793A\3059\308B\305F\3081\306B\30D6\30E9\30A6\30B6\304C\8FFD\52A0\306E\30EA\30AF\30A8\30B9\30C8\3092\5B9F\884C\3059\308B\3053\3068\3067\3059\3002</dd>'),
unistr('<dt>\8868\793A\5C02\7528\30D6\30E9\30F3\30C1</dt>'),
unistr('<dd>&PRODUCT_NAME.\306F\3001\5225\306E\30EA\30AF\30A8\30B9\30C8\3092\5B9F\884C\3059\308B\3053\3068\306A\304F\3001\73FE\5728\306E\30DA\30FC\30B8\51E6\7406\306E\4E00\90E8\3068\3057\3066\305F\3060\3061\306B\65B0\898F\30DA\30FC\30B8\3092\30EC\30F3\30C0\30EA\30F3\30B0\3057\307E\3059\3002'),
unistr('\3053\308C\306B\306F\3001\30D6\30E9\30A6\30B6\304C\8FFD\52A0\30EA\30AF\30A8\30B9\30C8\3092\5B9F\884C\3059\308B\5FC5\8981\304C\306A\3044\3068\3044\3046\5229\70B9\304C\3042\308A\307E\3059\3002'),
unistr('\4E3B\306A\30C7\30E1\30EA\30C3\30C8\306F\3001\30D6\30E9\30A6\30B6\30FB\30A2\30C9\30EC\30B9\304C<code>wwv_flow.accept</code>\306B\306A\308B\3053\3068\3067\3059\3002'),
unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\30DA\30FC\30B8\3092\30EA\30D5\30EC\30C3\30B7\30E5\3059\308B\3068\3001\30D6\30E9\30A6\30B6\30FB\30A2\30C9\30EC\30B9\304C\5B8C\5168\306A\30DA\30FC\30B8URL\3067\306A\3044\305F\3081\3001\30D6\30E9\30A6\30B6\306F\30C7\30FC\30BF\306E\518D\9001\4FE1\3092\8981\6C42\3057\307E\3059\3002</dd>'),
'</dl>',
unistr('<p>\3088\308A\3088\3044\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\30FB\30A8\30AF\30B9\30DA\30EA\30A8\30F3\30B9\3092\63D0\4F9B\3059\308B\306B\306F\3001\30EA\30C0\30A4\30EC\30AF\30C8\30FB\30D6\30E9\30F3\30C1\306E\30BF\30A4\30D7\306E1\3064\3092\9078\629E\3059\308B\3053\3068\3092\304A\85A6\3081\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104400185700308757)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_FUNCTION_RETURNING_PAGE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\3092\8FD4\3059\30D5\30A1\30F3\30AF\30B7\30E7\30F3(\8868\793A\5C02\7528)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104400264688308757)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_FUNCTION_RETURNING_URL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('URL\3092\8FD4\3059\30D5\30A1\30F3\30AF\30B7\30E7\30F3(\30EA\30C0\30A4\30EC\30AF\30C8)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104400644141308758)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_PAGE_ACCEPT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\51E6\7406{\975E\5171\901A}')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104400483263308758)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_PAGE_IDENT_BY_ITEM.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306B\3088\3063\3066\8B58\5225\3055\308C\305F\30DA\30FC\30B8(\8868\793A\5C02\7528)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104400022762308757)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_STEP.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8(\8868\793A\5C02\7528)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104400559124308758)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_URL_IDENT_BY_ITEM.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306B\3088\3063\3066\8B58\5225\3055\308C\305FURL(\30EA\30C0\30A4\30EC\30AF\30C8)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104400325854308757)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.PLSQL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\30D7\30ED\30B7\30FC\30B8\30E3[\30EC\30AC\30B7\30FC]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104399923498308757)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.REDIRECT_URL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\307E\305F\306FURL(\30EA\30C0\30A4\30EC\30AF\30C8)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103978868864308419)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103517177097308028)
,p_name=>'PE.PROPERTY.BREADCRUMB_TEMPLATE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30D6\30EC\30C3\30C9\30AF\30E9\30E0\306B\4F7F\7528\3055\308C\308B\30D6\30EC\30C3\30C9\30AF\30E9\30E0\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103517057402308028)
,p_name=>'PE.PROPERTY.BREADCRUMB_TEMPLATE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104245243591308642)
,p_name=>'PE.PROPERTY.BREAK_AFTER_ROW.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30FC\30AF\884C\3092\8868\793A\3057\305F\3068\304D\306B\30D6\30EC\30FC\30AF\5217\306E\5F8C\306B\8868\793A\3055\308C\308B\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104245195061308642)
,p_name=>'PE.PROPERTY.BREAK_AFTER_ROW.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\306E\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104244807861308642)
,p_name=>'PE.PROPERTY.BREAK_BEFORE_ROW.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30FC\30AF\884C\3092\8868\793A\3059\308B\3068\304D\306B\30D6\30EC\30FC\30AF\5217\306E\524D\306B\8868\793A\3055\308C\308B\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104244741865308642)
,p_name=>'PE.PROPERTY.BREAK_BEFORE_ROW.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\306E\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104255561264308650)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.COMPONENT_PROPERTY.CLASSIC_REPORT.NULL_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30FC\30AF\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104256783681308651)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.COMPONENT_PROPERTY.TABULAR_FORM.NULL_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30FC\30AF\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104244009125308642)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30FC\30AF\66F8\5F0F\306B\7D44\307F\8FBC\3080\30EC\30DD\30FC\30C8\5217\306E\6570\3092\9078\629E\3057\307E\3059\3002\5217\306F\3001\30EC\30DD\30FC\30C8\306B\8868\793A\3055\308C\3066\3044\308B\6700\521D\306E\5217\304B\3089\59CB\307E\308B\9023\7D9A\3057\305F\5217\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104423037688308774)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.LOV.1.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\521D\306E\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104423149698308774)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.LOV.1:2.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\521D\30682\756A\76EE\306E\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104423238239308775)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.LOV.1:2:3.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\521D\30012\756A\76EE\304A\3088\30733\756A\76EE\306E\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104243979877308642)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30FC\30AF\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104244283865308642)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30FC\30AF\306B\3088\308B\30EC\30DD\30FC\30C8\306E\8868\793A\66F8\5F0F\3078\306E\52B9\679C\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104423519883308775)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.LOV.DEFAULT_BREAK_FORMATTING.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\30FB\30D6\30EC\30FC\30AF\66F8\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104423618073308775)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.LOV.DEFAULT_BREAK_FORMATTING.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30FC\30AF\3054\3068\306B\30D8\30C3\30C0\30FC\3092\7E70\308A\8FD4\3055\305A\30011\3064\306E\30EC\30DD\30FC\30C8\306B\30D6\30EC\30FC\30AF\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104423325441308775)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.LOV.REPEAT_HEADINGS_ON_BREAK_1.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30FC\30AF\306E\7E70\8FD4\3057\30D8\30C3\30C0\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104423452961308775)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.LOV.REPEAT_HEADINGS_ON_BREAK_1.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30FC\30AF\3054\3068\306B\30D8\30C3\30C0\30FC\3092\7E70\308A\8FD4\3057\3001\3044\304F\3064\304B\306E\30B5\30D6\30EC\30DD\30FC\30C8\3068\3057\3066\30EC\30DD\30FC\30C8\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104244135424308642)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30BF\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104244697154308642)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_TEXT_FORMAT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\30FB\30D6\30EC\30FC\30AF\306B\8868\793A\3059\308B\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002<code>#SUM_COLUMN_HEADER#</code>\7F6E\63DB\3092\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104244576331308642)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_TEXT_FORMAT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\30FB\30D6\30EC\30FC\30AF\306E\66F8\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104245097076308642)
,p_name=>'PE.PROPERTY.BREAK_GENERIC_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\30FB\30D6\30EC\30FC\30AF\3092\8868\793A\3059\308B\969B\306E\30D6\30EC\30FC\30AF\5217\306E\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002<code>#COLUMN_VALUE#</code>\7F6E\63DB\3092\4F7F\7528\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104244976540308642)
,p_name=>'PE.PROPERTY.BREAK_GENERIC_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\30D6\30EC\30FC\30AF\306E\66F8\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104244439360308642)
,p_name=>'PE.PROPERTY.BREAK_REPEAT_HEADING_FORMAT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\30FB\30D6\30EC\30FC\30AF\306B\8868\793A\3055\308C\308B\7E70\8FD4\3057\30D8\30C3\30C0\30FC\306E\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002<code>#COLUMN_VALUE#</code>\7F6E\63DB\3092\4F7F\7528\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104244397959308642)
,p_name=>'PE.PROPERTY.BREAK_REPEAT_HEADING_FORMAT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7E70\8FD4\3057\30D8\30C3\30C0\30FC\306E\66F8\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104254712494308649)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30C7\30D5\30A9\30EB\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104695868011308997)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.COMPONENT_PROPERTY.PAGE.NULL_TEXT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30BB\30AD\30E5\30EA\30C6\30A3\5C5E\6027\306B\5B9A\7FA9\3055\308C\3066\3044\308B\8A2D\5B9A\3092\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103879954968308308)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30AD\30E3\30C3\30B7\30E5\3092\6709\52B9\306B\3059\308B\3068\3001\30D6\30E9\30A6\30B6\3067\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30DA\30FC\30B8\30FB\30B3\30F3\30C6\30F3\30C4\3092\3001\30E1\30E2\30EA\30FC\5185\3068\30C7\30A3\30B9\30AF\4E0A\306E\4E21\65B9\306E\30AD\30E3\30C3\30B7\30E5\306B\4FDD\5B58\3067\304D\307E\3059\3002'),
unistr('\30E6\30FC\30B6\30FC\304C\30D6\30E9\30A6\30B6\306E\300C\623B\308B\300D\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\901A\5E38\3001\30DA\30FC\30B8\306F\30B5\30FC\30D0\30FC\304B\3089\3067\306F\306A\304F\30AD\30E3\30C3\30B7\30E5\304B\3089\30ED\30FC\30C9\3055\308C\307E\3059\3002'),
unistr('\30AD\30E3\30C3\30B7\30E5\3092\7121\52B9\306B\3059\308B\3068\3001\30D6\30E9\30A6\30B6\306F\30DA\30FC\30B8\30FB\30B3\30F3\30C6\30F3\30C4\3092\4FDD\5B58\3057\306A\3044\3088\3046\306B\6307\793A\3055\308C\3001\30B5\30FC\30D0\30FC\304B\3089\306E\30DA\30FC\30B8\30FB\30B3\30F3\30C6\30F3\30C4\3092\65B0\305F\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3059\3002</p>'),
unistr('<p>\30BB\30AD\30E5\30EA\30C6\30A3\4E0A\306E\89B3\70B9\304B\3089\3001\30AD\30E3\30C3\30B7\30E5\3092\7121\52B9\306B\3057\3001\30D6\30E9\30A6\30B6\3067\6A5F\5BC6\30C7\30FC\30BF\3092\683C\7D0D\305B\305A\3001URL\304C\5909\308F\308C\3070\5E38\306B\30DA\30FC\30B8\304C\30EA\30AF\30A8\30B9\30C8\3055\308C\308B\3088\3046\306B\3059\308B\3053\3068\3092\304A\85A6\3081\3057\307E\3059\3002'),
unistr('\7121\52B9\306B\3057\306A\3044\5834\5408\3001\30ED\30B0\30A2\30A6\30C8\5F8C\30D6\30E9\30A6\30B6\5C65\6B74\3067\524D\306B\623B\308A\3001\4EE5\524D\306E\30BB\30C3\30B7\30E7\30F3\306E\30AD\30E3\30C3\30B7\30E5\3055\308C\305F\30B3\30F3\30C6\30F3\30C4\3092\8868\793A\3059\308B\3053\3068\304C\53EF\80FD\306B\306A\308B\5834\5408\304C\3042\308A\307E\3059\3002'),
unistr('\30D6\30E9\30A6\30B6\306E\30AD\30E3\30C3\30B7\30E5\3092\7121\52B9\306B\3059\308B\3068\3001\90E8\5206\30DA\30FC\30B8\30FB\30EA\30D5\30EC\30C3\30B7\30E5\3092\4F7F\7528\3059\308B\30DA\30FC\30B8(\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\306A\3069)\3067\306E\300C\623B\308B\300D\30DC\30BF\30F3\306E\554F\984C\3082\56DE\907F\3067\304D\307E\3059\3002</p>'),
unistr('<p>\3053\306E\5C5E\6027\3092<strong>\300C\7121\52B9\300D</strong>\306B\8A2D\5B9A\3057\305F\5834\5408\3001\30DA\30FC\30B8\30FB\30B3\30F3\30C6\30F3\30C4\3092\30C7\30A3\30B9\30AF\4E0A\307E\305F\306F\30E1\30E2\30EA\30FC\5185\306B\30AD\30E3\30C3\30B7\30E5\3057\306A\3044\3088\3046\306B\30D6\30E9\30A6\30B6\306B\6307\793A\3059\308BHTTP\30D8\30C3\30C0\30FC<em>cache-control: no-store</em>\304C&PRODUCT_NAME.\306B\3088\308A\9001\4FE1\3055\308C\307E\3059\3002'),
unistr('<strong>\300C\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30C7\30D5\30A9\30EB\30C8\300D</strong>\306B\8A2D\5B9A\3057\305F\5834\5408\3001\5B9F\884C\6642\306E\5024\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E<em>\300C\30D6\30E9\30A6\30B6\30FB\30AD\30E3\30C3\30B7\30E5\300D</em>\5C5E\6027\304B\3089\53D6\5F97\3055\308C\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8: \3053\306E\6A5F\80FD\306B\306F\3001HTTP\30D8\30C3\30C0\30FC\30FB\30EC\30B9\30DD\30F3\30B9\5909\6570<code>cache-control</code>\3092\30B5\30DD\30FC\30C8\3059\308B\6700\65B0\306E\30D6\30E9\30A6\30B6\304C\5FC5\8981\3067\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104383147499308744)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.LOV.N.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104383010798308744)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.LOV.Y.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6709\52B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103879848102308308)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30E9\30A6\30B6\30FB\30AD\30E3\30C3\30B7\30E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104764775159309062)
,p_name=>'PE.PROPERTY.BUILD_OPTION.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>1. \591A\304F\306E\30A4\30F3\30B9\30C8\30FC\30EB\304C\542B\307E\308C\308B\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\958B\767A\3057\3066\3044\307E\3059\3002'),
unistr('                                        \3055\3089\306B\3001\5404\30A4\30F3\30B9\30C8\30FC\30EB\3067\306F\3001\7279\5B9A\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\6A5F\80FD\3092\6709\52B9\5316\307E\305F\306F\7121\52B9\5316\3059\308B\3088\3046\306B\9078\629E\3057\307E\3059\3002'),
unistr('                                        \300C\30D3\30EB\30C9\30FB\30AA\30D7\30B7\30E7\30F3\300D\3067\30011\3064\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\958B\767A\3057\3001\30A4\30F3\30B9\30C8\30FC\30EB\6642\306B\3001\95A2\9023\3059\308B\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\6A5F\80FD\3092\542B\3081\305F\308A\9664\5916\3059\308B\3088\3046\306B\30D3\30EB\30C9\30FB\30AA\30D7\30B7\30E7\30F3\3092\69CB\6210\3067\304D\307E\3059\3002'),
unistr('                                        API\3092\4F7F\7528\3057\3066\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5185\3067\3053\306E\6A5F\80FD\3092\516C\958B\3059\308B\3053\3068\3082\3067\304D\307E\3059\3002'),
unistr('                                        \3053\308C\306B\3088\308A\3001\6A29\9650\306E\3042\308B\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\6A5F\80FD\3092\9078\629E\7684\306B\6709\52B9\5316\307E\305F\306F\7121\52B9\5316\3067\304D\307E\3059\3002</p>'),
unistr('                                      <p>2. \307E\3060\5B8C\6210\3057\3066\3044\306A\3044\6A5F\80FD\3092\958B\767A\3057\3066\3044\308B\305F\3081\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\3078\306E\516C\958B\3092\5E0C\671B\3057\307E\305B\3093\3002'),
unistr('									    \300C\30D3\30EB\30C9\30FB\30AA\30D7\30B7\30E7\30F3\300D\3092\4F7F\7528\3059\308B\3068\3001\30C6\30B9\30C8\74B0\5883\3068\672C\756A\74B0\5883\306B\7D44\307F\8FBC\3080\3068\304D\306B\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\3053\306E\6A5F\80FD\3092\7121\52B9\5316\3067\304D\307E\3059\3002'),
unistr('									    \3053\306E\65B9\6CD5\306E\5229\70B9\306F\3001\4E0D\5B8C\5168\306A\6A5F\80FD\3092\542B\3081\306A\3044\307E\307E\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\30C7\30D7\30ED\30A4\3067\304D\308B\3053\3068\3067\3059\3002</p>'),
unistr('                                      <p>3. \30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\3068\3063\3066\4E0D\8981\3068\601D\308F\308C\308B\6A5F\80FD\3092\9664\5916\3057\3066\3044\307E\3059\304C\3001\5B89\5168\306A\64CD\4F5C\304B\3069\3046\304B\78BA\4FE1\304C\3042\308A\307E\305B\3093\3002'),
unistr('									    \3053\306E\5834\5408\3001\300C\30D3\30EB\30C9\30FB\30AA\30D7\30B7\30E7\30F3\300D\3092\4F7F\7528\3057\3066\3001\7279\5B9A\306E\6A5F\80FD\3092\5B9F\8CEA\7684\306B\30B3\30E1\30F3\30C8\30FB\30A2\30A6\30C8\3067\304D\307E\3059\3002'),
unistr('									    \30C7\30D7\30ED\30A4\30E1\30F3\30C8\6642\306B\3001\9664\5916\3057\305F\6A5F\80FD\304C\5FC5\8981\3067\3042\308B\3068\601D\308F\308C\308B\5834\5408\3001\305D\308C\3092\5FA9\5143\3067\304D\307E\3059\3002'),
unistr('									    \3053\306E\6A5F\80FD\304C\4E0D\8981\3067\3042\308B\3068\601D\308F\308C\308B\5834\5408\3001\305D\308C\3092\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304B\3089\5B89\5168\306B\524A\9664\3067\304D\307E\3059\3002</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103880129678308308)
,p_name=>'PE.PROPERTY.BUILD_OPTION.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306E\30D3\30EB\30C9\30FB\30AA\30D7\30B7\30E7\30F3\3092\9078\629E\3057\3066\304F\3060\3055\3044\3002</p>'),
unistr('                                     <p>\30D3\30EB\30C9\30FB\30AA\30D7\30B7\30E7\30F3\3092\4F7F\7528\3059\308B\3068\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30A4\30F3\30B9\30C8\30FC\30EB\6642\3084API (APEX_UTIL.SET_BUILD_OPTION_STATUS)\3092\901A\3058\305F\5B9F\884C\6642\306B\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30B3\30F3\30DD\30FC\30CD\30F3\30C8\304A\3088\3073\6A5F\80FD\3092\6761\4EF6\4ED8\304D\3067\6709\52B9\5316\307E\305F\306F\7121\52B9\5316\3067\304D\307E\3059\3002<br>'),
unistr('                                       \30D3\30EB\30C9\30FB\30AA\30D7\30B7\30E7\30F3\306B\3088\3063\3066\3001\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\3092\30E9\30F3\30BF\30A4\30E0\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\542B\3081\308B\304B\9664\5916\3059\308B\3088\3046\306B\8A2D\5B9A\3067\304D\307E\3059\3002</p>'),
unistr('									 <p><strong>\542B\3081\308B</strong> - \6709\52B9\5316\3057\3066\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\542B\3081\307E\3059\3002</p>'),
unistr('									 <p><strong>\9664\5916</strong> - \7121\52B9\5316\3057\3066\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304B\3089\9664\5916\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103880065376308308)
,p_name=>'PE.PROPERTY.BUILD_OPTION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D3\30EB\30C9\30FB\30AA\30D7\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103868677780308300)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306E\30D3\30EB\30C9\30FB\30AA\30D7\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30BF\30B9\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104377058606308739)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.LOV.EXCLUDE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\9664\5916')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104377119633308739)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.LOV.EXCLUDE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('&PRODUCT_NAME.\30A8\30F3\30B8\30F3\3067\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306F\5B58\5728\3057\306A\3044\3068\307F\306A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104376889603308739)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.LOV.INCLUDE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\542B\3081\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104376905002308739)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.LOV.INCLUDE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9F\884C\6642\3001&PRODUCT_NAME.\30A8\30F3\30B8\30F3\3067\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5B9A\7FA9\306E\4E00\90E8\3068\307F\306A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103868504486308300)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30C6\30FC\30BF\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103982247209308422)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DC\30BF\30F3\304C\30AF\30EA\30C3\30AF\3055\308C\305F\3068\304D\306B\5B9F\884C\3059\308B\30A2\30AF\30B7\30E7\30F3\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104402850213308759)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.DEFINED_BY_DA.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\52D5\7684\30A2\30AF\30B7\30E7\30F3\3067\5B9A\7FA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104402932154308759)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.DEFINED_BY_DA.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306E\9001\4FE1\3082\5225\306E\30DA\30FC\30B8\3078\306E\30EA\30C0\30A4\30EC\30AF\30C8\3082\3057\307E\305B\3093\3002\304B\308F\308A\306B\3001\30DC\30BF\30F3\306E\52D5\4F5C\304C\52D5\7684\30A2\30AF\30B7\30E7\30F3\306B\3088\3063\3066\5B9A\7FA9\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104403234548308760)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.NEXT_PAGE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104403317909308760)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.NEXT_PAGE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\30DA\30FC\30B8\306B\30EA\30C0\30A4\30EC\30AF\30C8\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104403456144308760)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.PREVIOUS_PAGE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\524D\306E\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104403543165308760)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.PREVIOUS_PAGE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\524D\306E\30DA\30FC\30B8\306B\30EA\30C0\30A4\30EC\30AF\30C8\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104402430582308759)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_APP.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5225\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30DA\30FC\30B8\306B\30EA\30C0\30A4\30EC\30AF\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104402556326308759)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_APP.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30BF\30FC\30B2\30C3\30C8\30FB\30DA\30FC\30B8\3067\306E\30DA\30FC\30B8\533A\5207\308A\306E\30EA\30BB\30C3\30C8\3001\30EA\30AF\30A8\30B9\30C8\5024\306E\8A2D\5B9A\3001\30AD\30E3\30C3\30B7\30E5\306E\30AF\30EA\30A2\304A\3088\3073\30A2\30A4\30C6\30E0\5024\306E\8A2D\5B9A\306E\305F\3081\306E\30AA\30D7\30B7\30E7\30F3\306E\8FFD\52A0\5C5E\6027\3092\6307\5B9A\3057\3066\3001\5225\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30DA\30FC\30B8\306B\30EA\30C0\30A4\30EC\30AF\30C8\3057\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8: \5225\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30DA\30FC\30B8\3078\306E\30EA\30C0\30A4\30EC\30AF\30C8\306F\3001\30BF\30FC\30B2\30C3\30C8\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\6709\52B9\5316\3055\308C\3066\3044\308B\30C7\30A3\30FC\30D7\30FB\30EA\30F3\30AF\306B\4F9D\5B58\3057\307E\3059\3002\30C7\30A3\30FC\30D7\30FB\30EA\30F3\30AF\3092\6709\52B9\5316\3059\308B\306B\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E<em>\300C\30BB\30AD\30E5\30EA\30C6\30A3\300D</em>\5C5E\6027\306B\79FB\52D5\3057\3001<em>\300C\30C7\30A3\30FC\30D7\30FB\30EA\30F3\30AF\300D</em>\3092\6709\52B9\5316\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104402228157308759)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_PAGE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30DA\30FC\30B8\306B\30EA\30C0\30A4\30EC\30AF\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104402387197308759)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_PAGE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30FC\30B2\30C3\30C8\30FB\30DA\30FC\30B8\3067\306E\30DA\30FC\30B8\533A\5207\308A\306E\30EA\30BB\30C3\30C8\3001\30EA\30AF\30A8\30B9\30C8\5024\306E\8A2D\5B9A\3001\30AD\30E3\30C3\30B7\30E5\306E\30AF\30EA\30A2\304A\3088\3073\30A2\30A4\30C6\30E0\5024\306E\8A2D\5B9A\306E\305F\3081\306E\30AA\30D7\30B7\30E7\30F3\306E\8FFD\52A0\5C5E\6027\3092\6307\5B9A\3057\3066\3001\73FE\5728\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30DA\30FC\30B8\306B\30EA\30C0\30A4\30EC\30AF\30C8\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104402662409308759)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_URL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('URL\306B\30EA\30C0\30A4\30EC\30AF\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104402701239308759)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_URL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\6307\5B9A\3057\305F\30BF\30FC\30B2\30C3\30C8URL\306B\30EA\30C0\30A4\30EC\30AF\30C8\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104403045103308760)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.RESET.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306E\30EA\30BB\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104403104576308760)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.RESET.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\90E8\5206\30DA\30FC\30B8\30FB\30EA\30D5\30EC\30C3\30B7\30E5(PPR)\3067\306F\306A\304F\3001\5B8C\5168\30DA\30FC\30B8\30FB\30EA\30D5\30EC\30C3\30B7\30E5\3092\5B9F\884C\3057\3066\30DA\30FC\30B8\3092\30EA\30BB\30C3\30C8\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104402092509308759)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.SUBMIT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306E\9001\4FE1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104402141507308759)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.SUBMIT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3\540D\3068\7B49\3057\3044REQUEST\5024\3092\4F7F\7528\3057\3066\73FE\5728\306E\30DA\30FC\30B8\3092\9001\4FE1\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103982152571308422)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103885579214308312)
,p_name=>'PE.PROPERTY.BUTTON_DATABASE_ACTION.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\3053\306E\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3059\308B\3068\5B9F\884C\3055\308C\308BSQL\64CD\4F5C\306E\30BF\30A4\30D7\3092\9078\629E\3057\307E\3059\3002'),
unistr('\3053\306E\9078\629E\306F\3001\6307\5B9A\3055\308C\305F\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30A2\30AF\30B7\30E7\30F3\3092\7D44\8FBC\307F\306E\884C\306E\81EA\52D5\51E6\7406(DML)\5185\3067\30C8\30EA\30AC\30FC\3059\308B\5834\5408\306B\4F7F\7528\3055\308C\307E\3059\3002'),
unistr('\30BF\30A4\30D7\3092\9078\629E\3057\306A\3044\5834\5408\3001\3053\306E\30DC\30BF\30F3\306B\5B9A\7FA9\3055\308C\3066\3044\308B<strong>\30DC\30BF\30F3\540D</strong>\306B\57FA\3065\3044\3066\8A2D\5B9A\3055\308C\305FREQUEST\5024\306B\57FA\3065\3044\3066\30C7\30FC\30BF\30D9\30FC\30B9\51E6\7406\304C\5B9F\884C\3055\308C\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104397040280308755)
,p_name=>'PE.PROPERTY.BUTTON_DATABASE_ACTION.LOV.DELETE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL DELETE\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104396881565308755)
,p_name=>'PE.PROPERTY.BUTTON_DATABASE_ACTION.LOV.INSERT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL INSERT\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104396900084308755)
,p_name=>'PE.PROPERTY.BUTTON_DATABASE_ACTION.LOV.UPDATE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL UPDATE\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103885498969308312)
,p_name=>'PE.PROPERTY.BUTTON_DATABASE_ACTION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30A2\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104580212625308903)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DC\30BF\30F3\306E\5916\89B3\3092\5B9A\7FA9\3059\308B\30DC\30BF\30F3\8868\793A\30BF\30A4\30D7\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104580593992308903)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.ICON.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104580672456308903)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.ICON.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3\306E\307F\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104580357267308903)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.TEXT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104580479133308903)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.TEXT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3\30FB\30E9\30D9\30EB\306E\307F\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104580739165308903)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.TEXT_WITH_ICON.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3\4ED8\304D\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104580820163308903)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.TEXT_WITH_ICON.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3\30FB\30E9\30D9\30EB\306E\96A3\306B\30A2\30A4\30B3\30F3\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104580173154308903)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104682042484308985)
,p_name=>'PE.PROPERTY.BUTTON_ELEMENT_POST_TEXT.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30E9\30B8\30AA\30FB\30B0\30EB\30FC\30D7\307E\305F\306F\4E00\9023\306E\30C1\30A7\30C3\30AF\30FB\30DC\30C3\30AF\30B9\306E\5404\30AA\30D7\30B7\30E7\30F3\3092\8868\793A\3059\308B\3001HTML\8868\30BB\30EB\306E\5F8C\306B\8868\793A\3055\308C\308B\8FFD\52A0\306E\5C5E\6027\3092\5165\529B\3057\307E\3059\3002'),
unistr('HTML\3001JavaScript\304A\3088\3073\30B7\30E7\30FC\30C8\30AB\30C3\30C8\3092\542B\3081\308B\3053\3068\304C\3067\304D\307E\3059\3002</p>'),
unistr('<p>\6B21\306E\7F6E\63DB\6587\5B57\5217\3092\53C2\7167\3067\304D\307E\3059\3002</p>'),
'<dl>',
'  <dt><code>#CURRENT_FORM_ELEMENT#</code></dt>',
unistr('  <dd>\3053\306E\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\304C\95A2\9023\4ED8\3051\3089\308C\3066\3044\308BHTML\30D5\30A9\30FC\30E0\8981\7D20\306E\540D\524D\3092\53D6\5F97\3057\307E\3059\3002</dd>'),
'  <dt><code>#CURRENT_ITEM_NAME#</code></dt>',
unistr('  <dd>\73FE\5728\306E\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306E\540D\524D\3092\53D6\5F97\3057\307E\3059\3002</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104681913069308984)
,p_name=>'PE.PROPERTY.BUTTON_ELEMENT_POST_TEXT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5F8C\306E\30C6\30AD\30B9\30C8 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104681865526308984)
,p_name=>'PE.PROPERTY.BUTTON_ELEMENT_PRE_TEXT.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30E9\30B8\30AA\30FB\30B0\30EB\30FC\30D7\307E\305F\306F\4E00\9023\306E\30C1\30A7\30C3\30AF\30FB\30DC\30C3\30AF\30B9\306E\5404\30AA\30D7\30B7\30E7\30F3\3092\8868\793A\3059\308B\3001HTML\8868\30BB\30EB\306E\524D\306B\8868\793A\3055\308C\308B\8FFD\52A0\306E\5C5E\6027\3092\5165\529B\3057\307E\3059\3002'),
unistr('HTML\3001JavaScript\304A\3088\3073\30B7\30E7\30FC\30C8\30AB\30C3\30C8\3092\542B\3081\308B\3053\3068\304C\3067\304D\307E\3059\3002</p>'),
unistr('<p>\6B21\306E\7F6E\63DB\6587\5B57\5217\3092\53C2\7167\3067\304D\307E\3059\3002</p>'),
'<dl>',
'  <dt><code>#CURRENT_FORM_ELEMENT#</code></dt>',
unistr('  <dd>\3053\306E\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\304C\95A2\9023\4ED8\3051\3089\308C\3066\3044\308BHTML\30D5\30A9\30FC\30E0\8981\7D20\306E\540D\524D\3092\53D6\5F97\3057\307E\3059\3002</dd>'),
'  <dt><code>#CURRENT_ITEM_NAME#</code></dt>',
unistr('  <dd>\73FE\5728\306E\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306E\540D\524D\3092\53D6\5F97\3057\307E\3059\3002</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104681752934308984)
,p_name=>'PE.PROPERTY.BUTTON_ELEMENT_PRE_TEXT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\524D\306E\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103885389929308312)
,p_name=>'PE.PROPERTY.BUTTON_EXECUTE_VALIDATIONS.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30DA\30FC\30B8\304C\9001\4FE1\3055\308C\3001\3053\306E\5C5E\6027\304C<strong>\300C\30AA\30F3\300D</strong>\306B\8A2D\5B9A\3055\308C\3066\3044\308B\5834\5408\3001\30DA\30FC\30B8\306B\5BFE\3057\3066\5B9A\7FA9\3055\308C\3066\3044\308B\3059\3079\3066\306E\691C\8A3C\304A\3088\3073\7D44\8FBC\307F\306E\691C\8A3C(\5FC5\9808\3001\6709\52B9\306A\6570\5B57\3001\6709\52B9\306A\65E5\4ED8\306A\3069)\304C\30B5\30FC\30D0\30FC\5074\3067\5B9F\884C\3055\308C\307E\3059\3002'),
unistr('\307E\305F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E<em>\4E92\63DB\6027\30E2\30FC\30C9</em>\304C<strong>5.1</strong>\4EE5\4E0A\306B\8A2D\5B9A\3055\308C\3066\3044\308B\5834\5408\3001&PRODUCT_NAME.\306F\30AF\30E9\30A4\30A2\30F3\30C8\5074\306E\691C\8A3C(\5FC5\9808\306E\30A2\30A4\30C6\30E0\306A\3069)\3082\5B9F\884C\3057\307E\3059\3002\8A73\7D30\306F\3001\30EA\30EA\30FC\30B9\30FB\30CE\30FC\30C8\306E\4E92\63DB\6027\30E2\30FC\30C9\306B\95A2\3059\308B\9805\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002'),
unistr('\3059\3079\3066\306E\554F\984C\304C\4FEE\6B63\3055\308C\308B\307E\3067\30DA\30FC\30B8\306F\9001\4FE1\3055\308C\307E\305B\3093\3002</p>'),
unistr('<p><strong>\300C\30AA\30D5\300D</strong>\306B\8A2D\5B9A\3055\308C\3066\3044\308B\5834\5408\3001\5B9A\7FA9\6E08\306E\691C\8A3C\3082\7D44\8FBC\307F\306E\691C\8A3C\3082\5B9F\884C\3055\308C\307E\305B\3093\3002'),
unistr('\3053\306E\8A2D\5B9A\306B\95A2\4FC2\306A\304F\7279\5B9A\306E\691C\8A3C\3092\5B9F\884C\3059\308B\5834\5408\3001\691C\8A3C\3092\4FEE\6B63\3057\3001\691C\8A3C\5C5E\6027\306E<strong>\300C\5E38\306B\5B9F\884C\300D</strong>\3092<strong>\300C\30AA\30F3\300D</strong>\306B\8A2D\5B9A\3057\307E\3059\3002</p>'),
unistr('<p>\3053\306E\5C5E\6027\306F\3001\524A\9664\3084\53D6\6D88\306A\3069\306E\3088\3046\306B\307B\3068\3093\3069\306E\691C\8A3C\3092\5B9F\884C\3057\306A\3044\30DC\30BF\30F3\306B\7279\306B\6709\7528\3067\3059\3002'),
unistr('\30A2\30A4\30C6\30E0\304Cnull\306E\5834\5408\307E\305F\306F\9593\9055\3063\305F\30BF\30A4\30D7\306E\5834\5408\3001\901A\5E38\30E6\30FC\30B6\30FC\306F\305D\306E\3088\3046\306A\30A2\30AF\30B7\30E7\30F3\306E\5B9F\884C\3092\59A8\3052\3089\308C\307E\305B\3093\3002'),
unistr('\305F\3060\3057\3001\524A\9664\306A\3069\306E\30A2\30AF\30B7\30E7\30F3\304C\3001\8A8D\53EF\3055\308C\305F\30E6\30FC\30B6\30FC\306B\3088\3063\3066\306E\307F\5B9F\884C\3055\308C\308B\3088\3046\306B\3059\308B\5834\5408\3001\5BFE\5FDC\3059\308B\691C\8A3C\5C5E\6027<strong>\300C\5E38\306B\5B9F\884C\300D</strong>\3092<strong>\300C\30AA\30F3\300D</strong>\306B\8A2D\5B9A\3059\308B\304B\3001\30DC\30BF\30F3\81EA\4F53\306B\9069\5207\306A\6761\4EF6\304C\5B9A\7FA9\3055\308C\3001\8A8D\53EF\3055\308C\305F\30E6\30FC\30B6\30FC\306B\306E\307F\30DC\30BF\30F3\304C\8868\793A\3055\308C\308B\3088\3046\306B\3059\308B\3053\3068\304C\91CD\8981\3067\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103885273326308312)
,p_name=>'PE.PROPERTY.BUTTON_EXECUTE_VALIDATIONS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C\306E\5B9F\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104581604856308904)
,p_name=>'PE.PROPERTY.BUTTON_IS_HOT.COMPONENT_PROPERTY.CARD_ACTION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DC\30BF\30F3\3092\30EC\30F3\30C0\30EA\30F3\30B0\3059\308B\969B\306B<strong>\300C\6A19\6E96\300D</strong>\3068<strong>\300C\30DB\30C3\30C8\300D</strong>\306E\3044\305A\308C\306E\30DC\30BF\30F3\3092\4F7F\7528\3059\308B\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103884959099308312)
,p_name=>'PE.PROPERTY.BUTTON_IS_HOT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DC\30BF\30F3\3092\30EC\30F3\30C0\30EA\30F3\30B0\3059\308B\969B\306B<strong>\300C\6A19\6E96\300D</strong>\3068<strong>\300C\30DB\30C3\30C8\300D</strong>\306E\3044\305A\308C\306E\30DC\30BF\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\4F7F\7528\3059\308B\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103884881650308311)
,p_name=>'PE.PROPERTY.BUTTON_IS_HOT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DB\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104581435238308904)
,p_name=>'PE.PROPERTY.BUTTON_LABEL.COMPONENT_PROPERTY.CARD_ACTION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3\306B\8868\793A\3055\308C\308B\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002\30DC\30BF\30F3\306E\8868\793A\30BF\30A4\30D7\304C\30A2\30A4\30B3\30F3\306E\5834\5408\3001\3053\306E\30C6\30AD\30B9\30C8\306F\30A2\30A4\30B3\30F3\30FB\30A4\30E1\30FC\30B8\306EALT\30C6\30AD\30B9\30C8\306B\306A\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103898283554308326)
,p_name=>'PE.PROPERTY.BUTTON_LABEL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3\304C\30C6\30AD\30B9\30C8\306E\5834\5408\3001\30DC\30BF\30F3\306B\8868\793A\3055\308C\308B\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002\30DC\30BF\30F3\304C\30A4\30E1\30FC\30B8\306E\5834\5408\3001\3053\306E\30C6\30AD\30B9\30C8\306F\30A4\30E1\30FC\30B8\306EALT\30C6\30AD\30B9\30C8\306B\306A\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103898161601308325)
,p_name=>'PE.PROPERTY.BUTTON_LABEL.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103909115911308334)
,p_name=>'PE.PROPERTY.BUTTON_NAME.COMPONENT_PROPERTY.BUTTON.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30EA\30C3\30AF\3055\308C\3066\3044\308B\30DC\30BF\30F3\306E\53C2\7167\306B\4F7F\7528\3055\308C\308B\540D\524D\3092\5165\529B\3057\307E\3059\3002\3053\306E\30DA\30FC\30B8\304C\9001\4FE1\3055\308C\308B\3068\3001REQUEST\306E\5024\306F\3053\306E\30DC\30BF\30F3\540D\306B\8A2D\5B9A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103898085771308325)
,p_name=>'PE.PROPERTY.BUTTON_NAME.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5F8C\7D9A\306E\30DA\30FC\30B8\51E6\7406\3067\3053\306E\30DC\30BF\30F3\306E\8B58\5225\306B\4F7F\7528\3055\308C\308B\540D\524D\3092\5165\529B\3057\307E\3059\3002'),
unistr('\30DA\30FC\30B8\306E\9001\4FE1\6642\3001\3053\306E\30DC\30BF\30F3\3092\62BC\3059\3068\3001REQUEST\5024\304C\5165\529B\3055\308C\305F\540D\524D\306B\8A2D\5B9A\3055\308C\307E\3059\3002</p>'),
unistr('<p>\540C\3058\30DA\30FC\30B8\307E\305F\306F\540C\3058\30EA\30FC\30B8\30E7\30F3\306E\30DC\30BF\30F3\3067\30DC\30BF\30F3\540D\304C\4E00\610F\3067\3042\308B\5FC5\8981\306F\3042\308A\307E\305B\3093\3002'),
unistr('\540C\3058\30DC\30BF\30F3\540D\3067\8907\6570\306E\30DC\30BF\30F3\3092\5B9A\7FA9\3067\304D\307E\3059\3002\30DC\30BF\30F3\304C\62BC\3055\308C\308B\3068\3001\540C\3058REQUEST\5024\304C\8A2D\5B9A\3055\308C\307E\3059\3002'),
unistr('\3053\308C\306F\3001\5358\306B\5171\901A\306EREQUEST\5024\3092\8A55\4FA1\3059\308B\3053\3068\3067\540C\3058\30DA\30FC\30B8\51E6\7406\3092\5B9F\884C\3059\308B\5FC5\8981\306E\3042\308B\3001\7570\306A\308B<strong>\30DC\30BF\30F3\30FB\30E9\30D9\30EB</strong>\307E\305F\306F\6761\4EF6\306E\30DC\30BF\30F3\3092\5B9A\7FA9\3059\308B\5834\5408\306B\6709\7528\3067\3059\3002</p>'),
unistr('<p>\30DC\30BF\30F3\306B<code>FLOW_RESET_BUTTON</code>\3068\6307\5B9A\3059\308B\3068\3001\30DC\30BF\30F3\306B\3088\3063\3066\73FE\5728\306E\30DA\30FC\30B8\304C\30EA\30BB\30C3\30C8\3055\308C\307E\3059\3002\30DA\30FC\30B8\306E\9001\4FE1\306F\884C\308F\308C\307E\305B\3093\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103897925287308325)
,p_name=>'PE.PROPERTY.BUTTON_NAME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104681451183308984)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DC\30BF\30F3\3092\62BC\3059\3068\3001\30DA\30FC\30B8\304C\9001\4FE1\3055\308C\3001\30DA\30FC\30B8\30FB\30EA\30AF\30A8\30B9\30C8\304C\3053\306E\5024\306B\8A2D\5B9A\3055\308C\307E\3059\3002\3053\306E\5024\304CNULL\3067\3001<em>\300C\30EA\30AF\30A8\30B9\30C8\30FB\30BD\30FC\30B9\30FB\30BF\30A4\30D7\300D</em>\304C<em>\300C\9759\7684\5024\300D</em>\306E\5834\5408\3001\30DC\30BF\30F3\540D\304C\30EA\30AF\30A8\30B9\30C8\5024\3068\3057\3066\4F7F\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104681369156308984)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30AF\30A8\30B9\30C8\30FB\30BD\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104679326260308982)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\308C\306F\3001\30EA\30AF\30A8\30B9\30C8\30FB\30BD\30FC\30B9\5C5E\6027\306B\542B\307E\308C\308B\5F0F\306E\30BF\30A4\30D7\3092\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104681193433308984)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.ALWAYS_NULL.D'
,p_message_language=>'ja'
,p_message_text=>'NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104681214981308984)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.ALWAYS_NULL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('null\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104679662738308983)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.DB_COLUMN.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104679704482308983)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.DB_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D44\8FBC\307F\306E\884C\306E\30D5\30A7\30C3\30C1\30FB\30D7\30ED\30BB\30B9\304B\3089\53D6\5F97\3055\308C\308B<em>\300C\30C7\30FC\30BF\30D9\30FC\30B9\5217\300D</em>\306B\5165\529B\3055\308C\305F\5217\5024\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104680586466308983)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.FUNCTION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104680690455308983)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.FUNCTION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F<em>PL/SQL\5F0F</em>\306E\5B9F\884C\7D50\679C\306E\5024\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104680770517308984)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104680843447308984)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F<em>PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53</em>\304B\3089\8FD4\3055\308C\305F\5024\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104679844931308983)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.ITEM.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104680083878308983)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\306B\4FDD\6301\3055\308C\3066\3044\308B\5024\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104680963602308984)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.PREFERENCE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30EA\30D5\30A1\30EC\30F3\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104681043788308984)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.PREFERENCE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F<em>\30D7\30EA\30D5\30A1\30EC\30F3\30B9</em>\306E\5024\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104680148495308983)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.QUERY.D'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B(\5358\4E00\306E\5024\3092\8FD4\3059)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104680205918308983)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.QUERY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F<em>SQL\554F\5408\305B</em>\304B\3089\6700\521D\306B\8FD4\3055\308C\305F\5024\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104680316143308983)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.QUERY_COLON.D'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B(\30B3\30ED\30F3\533A\5207\308A\306E\5024\3092\8FD4\3059)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104680429025308983)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.QUERY_COLON.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F<em>SQL\554F\5408\305B</em>\304B\3089\8FD4\3055\308C\305F\5404\884C\306E\5024\3092\9023\7D50\3057\305F\3001\30B3\30ED\30F3\3067\533A\5207\3089\308C\305F1\3064\306E\5024\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104679457488308982)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.STATIC.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\9759\7684\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104679535977308983)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.STATIC.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<em>\300C\9759\7684\5024\300D</em>\306B\5165\529B\3055\308C\305F\30C6\30AD\30B9\30C8\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104679255401308982)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30AF\30A8\30B9\30C8\30FB\30BD\30FC\30B9\30FB\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103885142489308312)
,p_name=>'PE.PROPERTY.BUTTON_TARGET.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E2\30FC\30C0\30EB\30FB\30C0\30A4\30A2\30ED\30B0\3092\8D77\52D5\3059\308B\30BF\30FC\30B2\30C3\30C8\3092\30AF\30EA\30C3\30AF\3057\307E\3059\3002\3053\306E\30DC\30BF\30F3\304C\30AF\30EA\30C3\30AF\3055\308C\305F\3068\304D\306B\30B3\30FC\30EB\3055\308C\308B\30BF\30FC\30B2\30C3\30C8\3092\5165\529B\3067\304D\307E\3059\3002\30AF\30EA\30C3\30AF\3055\308C\305F\3068\304D\306B\30DA\30FC\30B8\51E6\7406\3092\8D77\52D5\3057\306A\3044\30DC\30BF\30F3(\300C\53D6\6D88\300D\30DC\30BF\30F3\306A\3069)\306E\30BF\30FC\30B2\30C3\30C8\306E\307F\3092\5165\529B\3057\307E\3059\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103885084316308312)
,p_name=>'PE.PROPERTY.BUTTON_TARGET.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30FC\30B2\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103884780654308311)
,p_name=>'PE.PROPERTY.BUTTON_TEMPLATE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DC\30BF\30F3\306E\5916\89B3\3092\5B9A\7FA9\3059\308B\30DC\30BF\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103884643317308311)
,p_name=>'PE.PROPERTY.BUTTON_TEMPLATE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104560936208308887)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.COMPONENT_PROPERTY.BUTTON.NULL_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306E\30C7\30D5\30A9\30EB\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104582072464308904)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.COMPONENT_PROPERTY.BUTTON.NULL_TEXT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3\304C\30AF\30EA\30C3\30AF\3055\308C\305F\3068\304D\306B\4FDD\5B58\3055\308C\3066\3044\306A\3044\5909\66F4\3092\30C1\30A7\30C3\30AF\3057\307E\3059(\30C1\30A7\30C3\30AF\304C\30DA\30FC\30B8\30FB\30EC\30D9\30EB\3067\6709\52B9\5316\3055\308C\3066\3044\308B\5834\5408)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104560684272308887)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306B\4FDD\5B58\3055\308C\3066\3044\306A\3044\5909\66F4\304C\542B\307E\308C\308B\5834\5408\306B\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3057\3066\305D\306E\30DA\30FC\30B8\304B\3089\79FB\52D5\3057\3088\3046\3068\3057\305F\3068\304D\306B\3001\30E6\30FC\30B6\30FC\306B\8B66\544A\3092\8868\793A\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104560769144308887)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.LOV.I.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30A7\30C3\30AF\3057\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104563329135308889)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.LOV.I.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\4FDD\5B58\3055\308C\3066\3044\306A\3044\5909\66F4\306E\30C1\30A7\30C3\30AF\306F\3001\30DC\30BF\30F3\304C\30AF\30EA\30C3\30AF\3055\308C\305F\3068\304D\306B\5B9F\884C\3055\308C\307E\305B\3093\3002\3053\306E\8A2D\5B9A\306F\3001\300C\53D6\6D88\300D\3001\300C\524A\9664\300D\304A\3088\3073\300C\5909\66F4\306E\9069\7528\300D\30DC\30BF\30F3\3067\4F7F\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104560500425308887)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4FDD\5B58\3055\308C\3066\3044\306A\3044\5909\66F4\306E\8B66\544A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104611243449308928)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F\5F0F\306E\8A55\4FA1\306B\4F7F\7528\3055\308C\308B\8A00\8A9E\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104611692529308928)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'ja'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104611531084308928)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'ja'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104611400153308928)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'ja'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104611753561308928)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'ja'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104611378497308928)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'ja'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104611135950308927)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A00\8A9E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104613293592308929)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\306E\5B9F\884C\306B\4F7F\7528\3055\308C\308B\8A00\8A9E\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104613591575308930)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'ja'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104613405029308929)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'ja'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104613325952308929)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'ja'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104613628084308930)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'ja'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104613108780308929)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A00\8A9E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103886750670308313)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_ITEM1.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\3067\4F7F\7528\3055\308C\308B\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103886623887308313)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_ITEM1.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103888146380308314)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_ITEM2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\3067\4F7F\7528\3055\308C\308B\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103888035672308314)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_ITEM2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104612835371308929)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3059\308BJava\5F0F\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104612771619308929)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('Java\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104614465109308930)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3057\3066\30D6\30FC\30EB\5024\3092\8FD4\3059Java\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104614319915308930)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('Java\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104612603055308929)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3059\308B\304B\3001\30DE\30CD\30FC\30B8\30E3\3067\3042\308B\5834\5408\3001\6B63\5E38\306B\5024\3092\8FD4\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104612567469308929)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3059\308BJavaScript\5F0F\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104612475631308929)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('JavaScript\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104614267894308930)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3059\308B\5834\5408\3001\6B63\5E38\306B\5024\3092\8FD4\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104614130697308930)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3057\3066\30D6\30FC\30EB\5024\3092\8FD4\3059JavaScript\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104614031663308930)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('JavaScript\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103886981274308313)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_LIST.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3059\308B\30B3\30ED\30F3(:)\3067\533A\5207\3089\308C\305F\5024\306E\30EA\30B9\30C8\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103886867757308313)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_LIST.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103887384733308313)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PAGE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3059\308B\30DA\30FC\30B8\756A\53F7\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103887231371308313)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PAGE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103887545868308314)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PAGES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3059\308B\30DA\30FC\30B8\756A\53F7\3092\30AB\30F3\30DE\3067\533A\5207\3063\3066\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103887461821308313)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PAGES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104612333424308928)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3059\308B\304B\3001\30DE\30CD\30FC\30B8\30E3\3067\3042\308B\5834\5408\3001\6B63\5E38\306B\5024\3092\8FD4\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104612213479308928)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3059\308BPL/SQL\5F0F\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104612178416308928)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104613993000308930)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3059\308B\5834\5408\3001\6B63\5E38\306B\5024\3092\8FD4\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104613880617308930)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3057\3066\30D6\30FC\30EB\5024\3092\8FD4\3059PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104613700496308930)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103887147224308313)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PREFERENCE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3057\3066\6307\5B9A\3055\308C\305F\5024\3068\6BD4\8F03\3059\308B\30E6\30FC\30B6\30FC\30FB\30D7\30EA\30D5\30A1\30EC\30F3\30B9\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103887043675308313)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PREFERENCE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30EA\30D5\30A1\30EC\30F3\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104613056916308929)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3059\308BPython\5F0F\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104612998412308929)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('Python\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104614628799308930)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3057\3066\30D6\30FC\30EB\5024\3092\8FD4\3059Python\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104614500798308930)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('Python\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104612073027308928)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\30DE\30CD\30FC\30B8\30E3\3067\3001\90E8\9580\304C\30B7\30AB\30B4\306B\5B58\5728\3059\308B\5834\5408\3001\6B63\5E38\306B\5024\3092\8FD4\3057\307E\3059\3002</dt>'),
'<dd><pre>',
':P2_JOB = ''MANAGER'' and',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104611937659308928)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3059\308BSQL\5F0F\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104611894192308928)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104765275851309062)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_STATEMENT.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3057\3066\3044\308B\304B\3069\3046\304B\3092\30C1\30A7\30C3\30AF\3057\305F\3068\304D\306B\30011\3064\4EE5\4E0A\306E\884C\304C\5B58\5728\3059\308B\3068\3001\6B63\5E38\306B\5024\3092\8FD4\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
unistr('<dt>\5F93\696D\54E1\304C\90E8\958040\306B\6240\5C5E\3057\3066\3044\308B\304B\3069\3046\304B\3092\30C1\30A7\30C3\30AF\3057\305F\3068\304D\306B\30011\3064\3082\884C\304C\5B58\5728\3057\306A\3044\3068\3001\6B63\5E38\306B\5024\3092\8FD4\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 40',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103886361108308313)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_STATEMENT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3059\308BSQL\554F\5408\305B\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103886243299308313)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_STATEMENT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103887700969308314)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TEXT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3059\308B\30C6\30AD\30B9\30C8\5024\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103887620774308314)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TEXT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103888322147308314)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TEXT2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3059\308B\5024(<code>&ITEM.</code>\7F6E\63DB\6587\5B57\5217\3092\542B\3080)\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103888239369308314)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TEXT2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103968789161308412)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\304C\30AD\30E3\30C3\30B7\30E5\3055\308C\308B\305F\3081\306B\6E80\305F\3059\5FC5\8981\306E\3042\308B\6761\4EF6\30BF\30A4\30D7\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103886145269308312)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\6761\4EF6\3092\6307\5B9A\3057\307E\3059\3002\6761\4EF6\304C<strong>TRUE</strong>\3092\8FD4\3059\5834\5408\3001\30DA\30FC\30B8\306F\30AD\30E3\30C3\30B7\30E5\304B\3089\8868\793A\3055\308C\307E\3059\3002\6761\4EF6\304C<strong>FALSE</strong>\3092\8FD4\3059\5834\5408\3001\30DA\30FC\30B8\306F\52D5\7684\306B\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\3001\30AD\30E3\30C3\30B7\30E5\304B\3089\53D6\5F97\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104451459285308796)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ALWAYS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5E38\6642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104592922020308913)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ALWAYS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306F\5E38\306B\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104450019771308795)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.BROWSER_IS_MSIE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30E9\30A4\30A2\30F3\30C8\306E\30D6\30E9\30A6\30B6\306FMicrosoft Internet Explorer 7.0\4EE5\4E0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104450103310308795)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.BROWSER_IS_MSIE_OR_NSCP.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30E9\30A4\30A2\30F3\30C8\30FB\30D6\30E9\30A6\30B6\306FXHTML / CSS\5BFE\5FDC\30D6\30E9\30A6\30B6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104449953710308795)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.BROWSER_IS_NSCP.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30E9\30A4\30A2\30F3\30C8\306E\30D6\30E9\30A6\30B6\306FMozilla\3001Netscape 6.x/7x\4EE5\4E0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104450276923308795)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.BROWSER_IS_OTHER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30E9\30A4\30A2\30F3\30C8\306E\30D6\30E9\30A6\30B6\306F\305D\306E\4ED6\306E\30D6\30E9\30A6\30B6(\307E\305F\306F\4EE5\524D\306E\30D0\30FC\30B8\30E7\30F3)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104448650147308794)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CONDITION1_IN_VALUE_OF_ITEM_IN_CONDITION2.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8\306F\30A2\30A4\30C6\30E0\306B\542B\307E\308C\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104450628841308795)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\8A00\8A9E = \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104596513937308916)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\3001\30E6\30FC\30B6\30FC\304C<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\8A00\8A9E\3067\73FE\5728\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\5B9F\884C\3057\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104450353530308795)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\8A00\8A9E\306F\5024\306B\542B\307E\308C\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104596722191308916)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\3001\30E6\30FC\30B6\30FC\304C<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\8A00\8A9E\306E\3044\305A\308C\304B\3067\73FE\5728\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\5B9F\884C\3057\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104450571502308795)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\8A00\8A9E != \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104596644627308916)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\3001\30E6\30FC\30B6\30FC\304C<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\8A00\8A9E\3067\73FE\5728\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\5B9F\884C\3057\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104450437039308795)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\8A00\8A9E\306F\5024\306B\542B\307E\308C\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104596875566308916)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\3001\30E6\30FC\30B6\30FC\304C<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\8A00\8A9E\306E\3044\305A\308C\304B\3067\73FE\5728\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\5B9F\884C\3057\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104447859133308793)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8 = \30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104595359695308915)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8\306F\3001<em>\300C\30DA\30FC\30B8\300D</em>\306B\5165\529B\3057\305F\5024\3068\7B49\3057\3044\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104448081660308793)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8\306F\30AB\30F3\30DE\3067\533A\5207\3089\308C\305F\30EA\30B9\30C8\306B\542B\307E\308C\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104595520827308915)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8\306F\3001<em>\300C\30DA\30FC\30B8\300D</em>\306B\5165\529B\3057\305F\30AB\30F3\30DE\533A\5207\308A\306E\30EA\30B9\30C8\306B\542B\307E\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104447917491308793)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8 != \30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104595455691308915)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8\306F\3001<em>\300C\30DA\30FC\30B8\300D</em>\306B\5165\529B\3057\305F\5024\3068\7B49\3057\304F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104448192018308793)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8\306F\30AB\30F3\30DE\3067\533A\5207\3089\308C\305F\30EA\30B9\30C8\306B\542B\307E\308C\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104595667973308915)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8\306F\3001<em>\300C\30DA\30FC\30B8\300D</em>\306B\5165\529B\3057\305F\30AB\30F3\30DE\533A\5207\308A\306E\30EA\30B9\30C8\306B\542B\307E\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104450761876308795)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DAD_NAME_EQ_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('CGI_ENV: DAD_NAME = \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104450873318308795)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DAD_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('CGI_ENV: DAD_NAME != \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104449555604308794)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30E9\30A4\30F3\691C\8A3C\30A8\30E9\30FC\3042\308A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104596311352308916)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306E\9001\4FE1\5F8C\3001\30A4\30F3\30E9\30A4\30F3\691C\8A3C\30A8\30E9\30FC\304C\30DA\30FC\30B8\306B\8868\793A\3055\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104448904657308794)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISPLAY_COND_EQUAL_COND_TEXT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8 = \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104448706315308794)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISPLAY_COND_IN_COND_TEXT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8\306F\5024\306B\542B\307E\308C\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104448817422308794)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISPLAY_COND_NOT_IN_COND_TEXT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8\306F\5024\306B\542B\307E\308C\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104449097761308794)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISP_COND_NOT_EQUAL_COND_TEXT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8 != \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104445597734308791)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.EXISTS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\304C\8FD4\3055\308C\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104593038707308913)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.EXISTS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B\306F1\3064\4EE5\4E0A\306E\884C\3092\8FD4\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104610939647308927)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104611021958308927)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5F0F\306FTRUE\3068\8A55\4FA1\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104445779507308792)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104593272227308913)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\306FTRUE\3092\8FD4\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104451169495308796)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.HTTP_HOST_EQ_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('CGI_ENV: HTTP_HOST = \5024')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104451208437308796)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.HTTP_HOST_NOT_EQ_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('CGI_ENV: HTTP_HOST != \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104449277308308794)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8/\30EA\30FC\30B8\30E7\30F3\306F\8AAD\53D6\308A\5C02\7528\3067\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104596055341308915)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\304A\3088\3073\89AA\30EA\30FC\30B8\30E7\30F3(\8A72\5F53\3059\308B\5834\5408)\306F\6B63\5E38\306B\8868\793A\3055\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104449156555308794)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.IS_READ_ONLY.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8/\30EA\30FC\30B8\30E7\30F3\306F\8AAD\53D6\308A\5C02\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104595976447308915)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.IS_READ_ONLY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\307E\305F\306F\89AA\30EA\30FC\30B8\30E7\30F3(\8A72\5F53\3059\308B\5834\5408)\306E\300C\8AAD\53D6\308A\5C02\7528\300D\6761\4EF6\306FTRUE\3068\8A55\4FA1\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104447066166308792)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306B\7A7A\767D\304C\542B\307E\308C\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104594529013308914)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F\7A7A\767D\3092\542B\307F\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104447392545308793)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306F\82F1\6570\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104594847954308914)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F\82F1\6570\5B57\3067\3001\6587\5B57\307E\305F\306F\6570\5B57\306E\307F\3092\542B\307F\3001\7279\6B8A\6587\5B57\3092\542B\307F\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104446596786308792)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306FNULL\3067\306F\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104594003308308914)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F\7A7A\3067\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104447262140308793)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306F\6570\5B57\3067\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104594720472308914)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F\6570\5B57\3067\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104446788529308792)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306F0(\30BC\30ED)\3067\306F\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104594244360308914)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F0(\30BC\30ED)\3067\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104446443827308792)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NULL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306FNULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104593998452308914)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NULL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F\7A7A\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104446836804308792)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306FNULL\307E\305F\306F0(\30BC\30ED)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104594327132308914)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F\7A7A\307E\305F\306F0(\30BC\30ED)\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104447133031308793)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306F\6570\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104594624523308914)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F\6570\5B57\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104446634044308792)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_ZERO.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306F0(\30BC\30ED)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104594119825308914)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_ZERO.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F0(\30BC\30ED)\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104446989307308792)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306FNULL\3067\306A\304F\30010(\30BC\30ED)\3067\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104594471665308914)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F\7A7A\3067\306F\306A\304F\30010(\30BC\30ED)\3067\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104449798764308795)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.MAX_ROWS_LT_ROWS_FETCHED.D'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\30EC\30DD\30FC\30C8(\300COK\300D\3092\30AF\30EA\30C3\30AF\3059\308B\3068\300C\9032\3080\300D\30DC\30BF\30F3\3092\8868\793A)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104449878948308795)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.MIN_ROW_GT_THAN_ONE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\30EC\30DD\30FC\30C8(\300COK\300D\3092\30AF\30EA\30C3\30AF\3059\308B\3068\300C\623B\308B\300D\30DC\30BF\30F3\3092\8868\793A)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104451390371308796)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.NEVER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104449680053308794)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30E9\30A4\30F3\691C\8A3C\30A8\30E9\30FC\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104596437869308916)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30E9\30A4\30F3\691C\8A3C\30A8\30E9\30FC\306F\30DA\30FC\30B8\306B\8868\793A\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104445601154308791)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.NOT_EXISTS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\304C\8FD4\3055\308C\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104593149047308913)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B\306F\884C\3092\8FD4\3057\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104448424299308794)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8\306F\300C\5370\5237\7528\300D\30E2\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104595789588308915)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8\306F\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\3088\3063\3066\300C\5370\5237\7528\300D\30E2\30FC\30C9\306B\5207\308A\66FF\3048\3089\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104448509198308794)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30EC\30F3\30C8\30FB\30DA\30FC\30B8\306F\300C\5370\5237\7528\300D\30E2\30FC\30C9\3067\306F\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104595893819308915)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8\306F\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\3088\3063\3066\300C\5370\5237\7528\300D\30E2\30FC\30C9\306B\5207\308A\66FF\3048\3089\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104445800565308792)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30AF\30A8\30B9\30C8 = \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104593309721308913)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30EA\30AF\30A8\30B9\30C8\306F\3001<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\3068\7B49\3057\3044\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104446060739308792)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30AF\30A8\30B9\30C8\306F\5024\306B\542B\307E\308C\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104593595400308913)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30EA\30AF\30A8\30B9\30C8\306F\3001<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\306B\542B\307E\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104445977798308792)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30AF\30A8\30B9\30C8 != \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104593473115308913)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30EA\30AF\30A8\30B9\30C8\306F\3001<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\3068\7B49\3057\304F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104446122649308792)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30AF\30A8\30B9\30C8\306F\5024\306B\542B\307E\308C\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104593669507308913)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30EA\30AF\30A8\30B9\30C8\306F\3001<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\306B\542B\307E\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104450903685308795)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.SERVER_NAME_EQ_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('CGI_ENV: SERVER_NAME = \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104451098143308796)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.SERVER_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('CGI_ENV: SERVER_NAME != \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104449310953308794)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\6E08\30E6\30FC\30B6\30FC(\975E\30D1\30D6\30EA\30C3\30AF\30FB\30E6\30FC\30B6\30FC)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104596100534308915)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\30ED\30B0\30A4\30F3\3057\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104449443389308794)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30D6\30EA\30C3\30AF\30FB\30E6\30FC\30B6\30FC(\8A8D\8A3C\3055\308C\3066\3044\306A\3044\30E6\30FC\30B6\30FC)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104596276523308916)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\30ED\30B0\30A4\30F3\3057\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104447690315308793)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\30FB\30D7\30EA\30D5\30A1\30EC\30F3\30B9 = \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104595135721308915)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F<em>\30D7\30EA\30D5\30A1\30EC\30F3\30B9</em>\306E\5024\306F\3001<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\3068\7B49\3057\3044\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104447793623308793)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\30FB\30D7\30EA\30D5\30A1\30EC\30F3\30B9 != \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104595297745308915)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F<em>\30D7\30EA\30D5\30A1\30EC\30F3\30B9</em>\306E\5024\306F\3001<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\3068\7B49\3057\304F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104447461690308793)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306F\30B3\30ED\30F3\3067\533A\5207\3089\308C\305F\30EA\30B9\30C8\306B\542B\307E\308C\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104594919266308915)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F\3001<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\306B\5B8C\5168\306B\542B\307E\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104447526435308793)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306F\30B3\30ED\30F3\3067\533A\5207\3089\308C\305F\30EA\30B9\30C8\306B\542B\307E\308C\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104595064031308915)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F\3001<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\306B\5B8C\5168\306B\306F\542B\307E\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104446275502308792)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0 = \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104593724162308914)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F\3001<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\3068\7B49\3057\3044\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104446364068308792)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0 != \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104593818034308914)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F\3001<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\3068\7B49\3057\304F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104448388986308793)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_NOT_SUBMITTED.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8 != \9001\4FE1\30DA\30FC\30B8(\30DD\30B9\30C8\6E08)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104448266153308793)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_SUBMITTED.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8 = \9001\4FE1\30DA\30FC\30B8(\30DD\30B9\30C8\6E08)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103886082372308312)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103886525397308313)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_VALUE1.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\6761\4EF6\3068\6BD4\8F03\3059\308B\5024\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103886477930308313)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_VALUE1.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103887961338308314)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_VALUE2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3059\308B\5024(<code>&ITEM.</code>\7F6E\63DB\6587\5B57\5217\3092\542B\3080)\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103887867534308314)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_VALUE2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104705878698309005)
,p_name=>'PE.PROPERTY.CACHE_DEPENDS_ON_ITEMS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AD\30E3\30C3\30B7\30E5\3055\308C\305F\30B3\30F3\30C6\30F3\30C4\304C\4F9D\5B58\3059\308B\30A2\30A4\30C6\30E0\306E\30AB\30F3\30DE\533A\5207\308A\306E\30EA\30B9\30C8\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104705713288309005)
,p_name=>'PE.PROPERTY.CACHE_DEPENDS_ON_ITEMS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306B\4F9D\5B58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104699895705309000)
,p_name=>'PE.PROPERTY.CACHE_MODE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('&PRODUCT_NAME.\30A8\30F3\30B8\30F3\306B\3088\308B\30B5\30FC\30D0\30FC\5074\3067\306EHTML\30C6\30AD\30B9\30C8\306E\30AD\30E3\30C3\30B7\30E5\65B9\6CD5\3092\9078\629E\3057\307E\3059\3002\30AD\30E3\30C3\30B7\30E5\304C\4F7F\7528\3055\308C\308B\5834\5408\3001\518D\5EA6\8A08\7B97\3059\308B\304B\308F\308A\306B\3001\30AD\30E3\30C3\30B7\30E5\3055\308C\305F\7D50\679C\304C\4F7F\7528\3055\308C\307E\3059\3002\3053\308C\306B\3088\3063\3066\3001\30B3\30B9\30C8\306E\304B\304B\308B\30B5\30FC\30D0\30FC\3067\306E\8A08\7B97\6642\9593\304C\524A\6E1B\3055\308C\307E\3059\3002\3053\306E\6A5F\80FD\306F\30D6\30E9\30A6\30B6\306E\30AD\30E3\30C3\30B7\30E5\6A5F\80FD\3068\306F\7121\95A2\4FC2\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104700153772309000)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.CACHE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6709\52B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104700297967309000)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.CACHE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30C6\30F3\30C4\306F\30AD\30E3\30C3\30B7\30E5\3055\308C\3001\3059\3079\3066\306E\30E6\30FC\30B6\30FC\306B\3088\3063\3066\5229\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104699920663309000)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.NOCACHE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104700046867309000)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.NOCACHE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30C6\30F3\30C4\306F\30AD\30E3\30C3\30B7\30E5\3055\308C\305A\3001\30EA\30AF\30A8\30B9\30C8\3054\3068\306B\8A08\7B97\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104700592022309001)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.SESSION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30C3\30B7\30E7\30F3\5225\306E\30AD\30E3\30C3\30B7\30E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104700609983309001)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.SESSION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30C6\30F3\30C4\306F\30BB\30C3\30B7\30E7\30F3\3054\3068\306B\30AD\30E3\30C3\30B7\30E5\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104700338502309000)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.USER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\5225\306E\30AD\30E3\30C3\30B7\30E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104700430695309000)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.USER.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30C6\30F3\30C4\306F\30E6\30FC\30B6\30FC\3054\3068\306B\30AD\30E3\30C3\30B7\30E5\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104699708203309000)
,p_name=>'PE.PROPERTY.CACHE_MODE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AD\30E3\30C3\30B7\30E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103879731356308308)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AD\30E3\30C3\30B7\30E5\3055\308C\305F\30DA\30FC\30B8\304C\6709\52B9\306A\671F\9593\3092\9078\629E\3057\307E\3059\3002\30BF\30A4\30E0\30A2\30A6\30C8\306E\5834\5408\3001\5F8C\7D9A\306E\30DA\30FC\30B8\30FB\30EA\30AF\30A8\30B9\30C8\306F\30AD\30E3\30C3\30B7\30E5\3055\308C\305F\30DA\30FC\30B8\3092\4F7F\7528\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104381108065308742)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.10.D'
,p_message_language=>'ja'
,p_message_text=>unistr('10\79D2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104381738370308743)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.10800.D'
,p_message_language=>'ja'
,p_message_text=>unistr('3\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104382606096308744)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.1209600.D'
,p_message_language=>'ja'
,p_message_text=>unistr('2\9031\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104381888330308743)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.14400.D'
,p_message_language=>'ja'
,p_message_text=>unistr('4\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104382294185308743)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.172800.D'
,p_message_language=>'ja'
,p_message_text=>unistr('2\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104381439398308743)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.1800.D'
,p_message_language=>'ja'
,p_message_text=>unistr('30\5206')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104381981688308743)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.21600.D'
,p_message_language=>'ja'
,p_message_text=>unistr('6\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104382723959308744)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.2419200.D'
,p_message_language=>'ja'
,p_message_text=>unistr('4\9031\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104382352260308743)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.259200.D'
,p_message_language=>'ja'
,p_message_text=>unistr('3\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104382967024308744)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.31536000.D'
,p_message_language=>'ja'
,p_message_text=>unistr('1\5E74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104382427631308743)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.345600.D'
,p_message_language=>'ja'
,p_message_text=>unistr('4\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104381572675308743)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.3600.D'
,p_message_language=>'ja'
,p_message_text=>unistr('1\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104382029835308743)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.43200.D'
,p_message_language=>'ja'
,p_message_text=>unistr('12\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104381204298308742)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.60.D'
,p_message_language=>'ja'
,p_message_text=>unistr('1\5206')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104381329589308743)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.600.D'
,p_message_language=>'ja'
,p_message_text=>unistr('10\5206')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104382521050308744)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.604800.D'
,p_message_language=>'ja'
,p_message_text=>unistr('1\9031\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104382873955308744)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.6048000.D'
,p_message_language=>'ja'
,p_message_text=>unistr('10\9031\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104381662079308743)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.7200.D'
,p_message_language=>'ja'
,p_message_text=>unistr('2\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104382190582308743)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.86400.D'
,p_message_language=>'ja'
,p_message_text=>unistr('1\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103879680787308308)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AD\30E3\30C3\30B7\30E5\30FB\30BF\30A4\30E0\30A2\30A6\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104426724888308777)
,p_name=>'PE.PROPERTY.CALENDAR_CUSTOM_FORMAT.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\5217\5024\306E\8868\793A</dt>'),
'<dd><pre>',
'#FIRST_NAME# <strong>#LAST_NAME#</strong>',
'</pre></dd>',
unistr('<dt>\30AB\30EC\30F3\30C0\30FB\30A4\30D9\30F3\30C8\5185\306E\30A4\30E1\30FC\30B8\306E\8868\793A</dt>'),
'<dd><pre>',
'&lt;img src="#IMAGE_NAME#"&gt;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104272948050308662)
,p_name=>'PE.PROPERTY.CALENDAR_CUSTOM_FORMAT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30EC\30F3\30C0\30FB\30BB\30EB\306B\8868\793A\3059\308B\30AB\30B9\30BF\30E0\30FB\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002HTML\5F0F\3092\5165\529B\3057\305F\308A\3001<code>#COLUMN_NAME#</code>\69CB\6587\3092\4F7F\7528\3057\3066\5217\5024\3092\8868\793A\3067\304D\307E\3059\3002\3053\306E\8868\793A\30BF\30A4\30D7\3067\306F\3001\8907\6570\306E\5217\3092\8868\793A\306B\5165\308C\308B\3053\3068\304C\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104272885307308662)
,p_name=>'PE.PROPERTY.CALENDAR_CUSTOM_FORMAT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30B9\30BF\30E0\8868\793A\66F8\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104267141067308658)
,p_name=>'PE.PROPERTY.CALENDAR_DATE_ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\73FE\5728\8868\793A\3055\308C\3066\3044\308B\30AB\30EC\30F3\30C0\306E\958B\59CB\65E5\3092\4FDD\6301\3059\308B\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\9078\629E\3057\307E\3059\3002'),
unistr('\3053\306E\30A2\30A4\30C6\30E0\306F\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\524D\307E\305F\306F\6B21\306E\671F\9593\306B\30CA\30D3\30B2\30FC\30C8\3059\308B\3088\3046\9078\629E\3057\305F\5834\5408\3001&PRODUCT_NAME.\30A8\30F3\30B8\30F3\306B\3088\3063\3066\4F7F\7528\3055\308C\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104267017945308658)
,p_name=>'PE.PROPERTY.CALENDAR_DATE_ITEM.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\59CB\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104267721573308659)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30EC\30F3\30C0\306B\8868\793A\3055\308C\308B\5024\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104426159895308777)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.COL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104426244112308777)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.COL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<strong>\300C\8868\793A\5217\300D</strong>\5C5E\6027\3092\4F7F\7528\3057\3066\3001\30AB\30EC\30F3\30C0\30FB\30BB\30EB\306B\8868\793A\3059\308B\5217\3092\9078\629E\3057\307E\3059\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104426320209308777)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.CUS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30B9\30BF\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104426451435308777)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.CUS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('HTML\5F0F\304A\3088\3073\30B5\30DD\30FC\30C8\3055\308C\3066\3044\308B\7F6E\63DB\6587\5B57\5217\3092\4F7F\7528\3057\3066\30AB\30B9\30BF\30E0\5217\66F8\5F0F\3092\5165\529B\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104426555927308777)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.NONE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\5024\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104426684415308777)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.NONE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30EC\30F3\30C0\30FB\30BB\30EB\306B\30C7\30FC\30BF\306F\8868\793A\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104267663665308659)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104267335960308658)
,p_name=>'PE.PROPERTY.CALENDAR_END_DATE_ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\73FE\5728\8868\793A\3055\308C\3066\3044\308B\30AB\30EC\30F3\30C0\306E\7D42\4E86\65E5\3092\4FDD\6301\3059\308B\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\9078\629E\3057\307E\3059\3002'),
unistr('\3053\306E\30A2\30A4\30C6\30E0\306F\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\524D\307E\305F\306F\6B21\306E\671F\9593\306B\30CA\30D3\30B2\30FC\30C8\3059\308B\3088\3046\9078\629E\3057\305F\5834\5408\3001&PRODUCT_NAME.\30A8\30F3\30B8\30F3\306B\3088\3063\3066\4F7F\7528\3055\308C\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104267228205308658)
,p_name=>'PE.PROPERTY.CALENDAR_END_DATE_ITEM.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D42\4E86\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104266507231308658)
,p_name=>'PE.PROPERTY.CALENDAR_TEMPLATE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30EC\30F3\30C0\306E\30EC\30F3\30C0\30EA\30F3\30B0\6642\306B\4F7F\7528\3059\308B\30C6\30F3\30D7\30EC\30FC\30C8\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104266489702308658)
,p_name=>'PE.PROPERTY.CALENDAR_TEMPLATE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104267509877308659)
,p_name=>'PE.PROPERTY.CALENDAR_TYPE_ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\73FE\5728\8868\793A\3055\308C\3066\3044\308B\30AB\30EC\30F3\30C0\30FB\30BF\30A4\30D7\3092\4FDD\6301\3059\308B\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104267418303308658)
,p_name=>'PE.PROPERTY.CALENDAR_TYPE_ITEM.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104579995753308903)
,p_name=>'PE.PROPERTY.CARDS_PER_PAGE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\3054\3068\306B\8868\793A\3059\308B\30AB\30FC\30C9\6570\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104579837061308903)
,p_name=>'PE.PROPERTY.CARDS_PER_PAGE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('1\30DA\30FC\30B8\5F53\305F\308A\306E\30AB\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104578707770308902)
,p_name=>'PE.PROPERTY.CARD_ACTION_POSITION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30FC\30C9\4E0A\3067\30DC\30BF\30F3\3092\914D\7F6E\3059\308B\5834\6240\3092\6C7A\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104578840966308902)
,p_name=>'PE.PROPERTY.CARD_ACTION_POSITION.LOV.PRIMARY.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E3B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104578915450308902)
,p_name=>'PE.PROPERTY.CARD_ACTION_POSITION.LOV.SECONDARY.D'
,p_message_language=>'ja'
,p_message_text=>unistr('2\6B21')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104578689581308902)
,p_name=>'PE.PROPERTY.CARD_ACTION_POSITION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104577566623308901)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30AB\30FC\30C9\30FB\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\8FFD\52A0\3059\308B\30A2\30AF\30B7\30E7\30F3\306E\30BF\30A4\30D7\3092\9078\629E\3057\307E\3059\3002</p>'),
unistr('<p>\540C\3058\30BF\30A4\30D7\306E\30A2\30AF\30B7\30E7\30F3\3092\8907\6570\5B9A\7FA9\3067\304D\307E\3059\3002\305F\3060\3057\3001\8907\6570\56DE\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\308B\306E\306F\3001\30DC\30BF\30F3\30FB\30A2\30AF\30B7\30E7\30F3\306E\307F\3067\3059\3002'),
unistr('\305D\306E\4ED6\3059\3079\3066\306E\30A2\30AF\30B7\30E7\30F3\30FB\30BF\30A4\30D7\3067\306F\3001\6700\521D\306ETRUE\8868\793A\6761\4EF6\304C\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\3001\6B8B\308A\306F\7121\8996\3055\308C\307E\3059\3002</p>'),
unistr('<p>\5404\884C\3092\30C1\30A7\30C3\30AF\3059\308B\3088\3046\306B\5B9F\884C\6761\4EF6\304C\8A2D\5B9A\3055\308C\3066\3044\308B\5834\5408\3001\8868\793A\6761\4EF6\306F\5217\5024\306B\57FA\3065\3044\3066\5B9A\7FA9\3067\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104577664649308901)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.BUTTON.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104577701935308901)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.BUTTON.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30FC\30C9\306B\30DC\30BF\30F3\3092\8FFD\52A0\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104577878988308901)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.FULL_CARD.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30FC\30C9\5168\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104577930198308901)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.FULL_CARD.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30AB\30FC\30C9\5168\4F53\306B\30EA\30F3\30AF\3092\8FFD\52A0\3057\307E\3059\3002\901A\5E38\306F\3001\3053\306E\30A2\30AF\30B7\30E7\30F3\30FB\30BF\30A4\30D7\306E1\3064\3092\5B9A\7FA9\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002'),
unistr('\8907\6570\5B9A\7FA9\3059\308B\5834\5408\306F\3001\5217\5024\306B\57FA\3065\304F\8868\793A\6761\4EF6\3092\8FFD\52A0\3057\3001\5404\884C\3092\30C1\30A7\30C3\30AF\3059\308B\3088\3046\306B\8A2D\5B9A\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104578407811308901)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.MEDIA.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E1\30C7\30A3\30A2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104578572328308902)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.MEDIA.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30AB\30FC\30C9\30FB\30E1\30C7\30A3\30A2\306B\30EA\30F3\30AF\3092\8FFD\52A0\3057\307E\3059\3002\901A\5E38\306F\3001\3053\306E\30A2\30AF\30B7\30E7\30F3\30FB\30BF\30A4\30D7\306E1\3064\3092\5B9A\7FA9\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002'),
unistr('\8907\6570\5B9A\7FA9\3059\308B\5834\5408\306F\3001\5217\5024\306B\57FA\3065\304F\8868\793A\6761\4EF6\3092\8FFD\52A0\3057\3001\5404\884C\3092\30C1\30A7\30C3\30AF\3059\308B\3088\3046\306B\8A2D\5B9A\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104578241767308901)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.SUB_TITLE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30D6\30BF\30A4\30C8\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104578395436308901)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.SUB_TITLE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30AB\30FC\30C9\30FB\30B5\30D6\30BF\30A4\30C8\30EB\306B\30EA\30F3\30AF\3092\8FFD\52A0\3057\307E\3059\3002\901A\5E38\306F\3001\3053\306E\30A2\30AF\30B7\30E7\30F3\30FB\30BF\30A4\30D7\306E1\3064\3092\5B9A\7FA9\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002'),
unistr('\8907\6570\5B9A\7FA9\3059\308B\5834\5408\306F\3001\5217\5024\306B\57FA\3065\304F\8868\793A\6761\4EF6\3092\8FFD\52A0\3057\3001\5404\884C\3092\30C1\30A7\30C3\30AF\3059\308B\3088\3046\306B\8A2D\5B9A\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104578001950308901)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.TITLE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30C8\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104578138899308901)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.TITLE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30AB\30FC\30C9\30FB\30BF\30A4\30C8\30EB\306B\30EA\30F3\30AF\3092\8FFD\52A0\3057\307E\3059\3002\901A\5E38\306F\3001\3053\306E\30A2\30AF\30B7\30E7\30F3\30FB\30BF\30A4\30D7\306E1\3064\3092\5B9A\7FA9\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002'),
unistr('\8907\6570\5B9A\7FA9\3059\308B\5834\5408\306F\3001\5217\5024\306B\57FA\3065\304F\8868\793A\6761\4EF6\3092\8FFD\52A0\3057\3001\5404\884C\3092\30C1\30A7\30C3\30AF\3059\308B\3088\3046\306B\8A2D\5B9A\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104577483030308901)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104566445577308891)
,p_name=>'PE.PROPERTY.CARD_CSS_CLASSES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\500B\5225\306E\30AB\30FC\30C9\306B\9069\7528\3059\308BCSS\30AF\30E9\30B9\3092\5165\529B\3057\307E\3059\3002\8907\6570\306E\30AF\30E9\30B9\306F\7A7A\767D\3067\533A\5207\3063\3066\8FFD\52A0\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104566375028308891)
,p_name=>'PE.PROPERTY.CARD_CSS_CLASSES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('CSS\30AF\30E9\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104571691389308896)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\53F3\5411\304D\306E\77E2\5370\306E\8868\793A</dt>'),
'<dd><pre>fa-chevron-right</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104571553088308895)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\8FFD\52A0\3059\308B\30A2\30A4\30B3\30F3\306E\30AF\30E9\30B9\3092\5165\529B\3057\307E\3059\3002\8907\6570\306E\30AF\30E9\30B9\306F\7A7A\767D\3067\533A\5207\3063\3066\8FFD\52A0\3067\304D\307E\3059\3002</p>'),
unistr('        <p>\30C6\30FC\30DE\3067\30D5\30A9\30F3\30C8APEX\3092\4F7F\7528\3059\308B\5834\5408\3001<a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\30E6\30CB\30D0\30FC\30B5\30EB\30FB\30C6\30FC\30DE\306E\30B5\30F3\30D7\30EB\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3</a>\3092\78BA\8A8D\3057\3066\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30B3\30F3\3068\4FEE\98FE\5B50\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104571496655308895)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3CSS\30AF\30E9\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104672522518308977)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES_REQUIRED.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\53F3\5411\304D\306E\77E2\5370\306E\8868\793A</dt>'),
'<dd><pre>fa-chevron-right</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104672473423308977)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES_REQUIRED.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\8FFD\52A0\3059\308B\30A2\30A4\30B3\30F3\306E\30AF\30E9\30B9\3092\5165\529B\3057\307E\3059\3002\8907\6570\306E\30AF\30E9\30B9\306F\7A7A\767D\3067\533A\5207\3063\3066\8FFD\52A0\3067\304D\307E\3059\3002</p>'),
unistr('        <p>\30C6\30FC\30DE\3067\30D5\30A9\30F3\30C8APEX\3092\4F7F\7528\3059\308B\5834\5408\3001<a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\30E6\30CB\30D0\30FC\30B5\30EB\30FB\30C6\30FC\30DE\306E\30B5\30F3\30D7\30EB\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3</a>\3092\78BA\8A8D\3057\3066\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30B3\30F3\3068\4FEE\98FE\5B50\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104672333910308977)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES_REQUIRED.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3CSS\30AF\30E9\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104564880065308890)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30D7\30ED\30D1\30C6\30A3\306F\3001\30DA\30FC\30B8\4E0A\3067\306E\30AB\30FC\30C9\306E\914D\7F6E\3092\6C7A\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104565114757308891)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.FLOAT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30ED\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104565239847308891)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.FLOAT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30FC\30C9\306F\3001\753B\9762\306E\6A2A\5E45\306B\53CE\307E\308A\304D\3089\306A\304F\306A\3063\305F\5834\5408\3001\6298\308A\8FD4\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104564916236308890)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.GRID.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30EA\30C3\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104565024967308890)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.GRID.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30FC\30C9\3092\5217\306E\30B0\30EA\30C3\30C9\306B\914D\7F6E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104565383782308891)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.ROW.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6C34\5E73(\884C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104565485974308891)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.ROW.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30FC\30C9\306F\3001\4E92\3044\306B\91CD\306A\308A\5408\3063\3066\914D\7F6E\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104564746917308890)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30A4\30A2\30A6\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104579124420308902)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\6307\5B9A\3055\308C\305F\30A2\30AF\30B7\30E7\30F3\30FB\30BF\30A4\30D7\304C\30AF\30EA\30C3\30AF\3055\308C\305F\3068\304D\306B\5B9F\884C\3059\308B\30A2\30AF\30B7\30E7\30F3\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104579431311308902)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.LOV.REDIRECT_APP.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5225\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30DA\30FC\30B8\306B\30EA\30C0\30A4\30EC\30AF\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104579543133308902)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.LOV.REDIRECT_APP.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30BF\30FC\30B2\30C3\30C8\30FB\30DA\30FC\30B8\3067\306E\30DA\30FC\30B8\533A\5207\308A\306E\30EA\30BB\30C3\30C8\3001\30EA\30AF\30A8\30B9\30C8\5024\306E\8A2D\5B9A\3001\30AD\30E3\30C3\30B7\30E5\306E\30AF\30EA\30A2\304A\3088\3073\30A2\30A4\30C6\30E0\5024\306E\8A2D\5B9A\306E\305F\3081\306E\30AA\30D7\30B7\30E7\30F3\306E\8FFD\52A0\5C5E\6027\3092\6307\5B9A\3057\3066\3001\5225\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30DA\30FC\30B8\306B\30EA\30C0\30A4\30EC\30AF\30C8\3057\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8: \5225\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30DA\30FC\30B8\3078\306E\30EA\30C0\30A4\30EC\30AF\30C8\306F\3001\30BF\30FC\30B2\30C3\30C8\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\6709\52B9\5316\3055\308C\3066\3044\308B\30C7\30A3\30FC\30D7\30FB\30EA\30F3\30AF\306B\4F9D\5B58\3057\307E\3059\3002\30C7\30A3\30FC\30D7\30FB\30EA\30F3\30AF\3092\6709\52B9\5316\3059\308B\306B\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E<em>\300C\30BB\30AD\30E5\30EA\30C6\30A3\300D</em>\5C5E\6027\306B\79FB\52D5\3057\3001<em>\300C\30C7\30A3\30FC\30D7\30FB\30EA\30F3\30AF\300D</em>\3092\6709\52B9\5316\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104579271394308902)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.LOV.REDIRECT_PAGE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30DA\30FC\30B8\306B\30EA\30C0\30A4\30EC\30AF\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104579366958308902)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.LOV.REDIRECT_PAGE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30FC\30B2\30C3\30C8\30FB\30DA\30FC\30B8\3067\306E\30DA\30FC\30B8\533A\5207\308A\306E\30EA\30BB\30C3\30C8\3001\30EA\30AF\30A8\30B9\30C8\5024\306E\8A2D\5B9A\3001\30AD\30E3\30C3\30B7\30E5\306E\30AF\30EA\30A2\304A\3088\3073\30A2\30A4\30C6\30E0\5024\306E\8A2D\5B9A\306E\305F\3081\306E\30AA\30D7\30B7\30E7\30F3\306E\8FFD\52A0\5C5E\6027\3092\6307\5B9A\3057\3066\3001\73FE\5728\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30DA\30FC\30B8\306B\30EA\30C0\30A4\30EC\30AF\30C8\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104579639014308902)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.LOV.REDIRECT_URL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('URL\306B\30EA\30C0\30A4\30EC\30AF\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104579707830308903)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.LOV.REDIRECT_URL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\6307\5B9A\3057\305F\30BF\30FC\30B2\30C3\30C8URL\306B\30EA\30C0\30A4\30EC\30AF\30C8\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104579088308308902)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104692281707308994)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN1.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\30FB\30BD\30FC\30B9\304B\30891\3064\76EE\306E\4E3B\30AD\30FC\5217\3092\9078\629E\3057\307E\3059\3002\3053\306E\8868\306E\4E3B\30AD\30FC\306E\5217\304C2\3064\3088\308A\591A\3044\5834\5408\3001<code>ROWID</code>\5217\3092\9078\629E\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\30B9\30AF\30ED\30FC\30EB\306E\30DA\30FC\30B8\533A\5207\308A\3092\8868\793A\3059\308B\3088\3046\306B\30EA\30FC\30B8\30E7\30F3\304C\8A2D\5B9A\3055\308C\3066\3044\308B\5834\5408\3001\4E3B\30AD\30FC\306F\91CD\8907\884C\306E\8868\793A\3092\56DE\907F\3059\308B\305F\3081\306B\4F7F\7528\3055\308C\307E\3059\3002\30EA\30FC\30B8\30E7\30F3\306BBLOB\5217\306E\30A4\30E1\30FC\30B8\304C\8868\793A\3055\308C\308B\5834\5408\3001\4E3B\30AD\30FC\306F\30A4\30E1\30FC\30B8\3092\53D6\5F97\3059\308B\305F\3081\306B\4F7F\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104692193015308994)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN1.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E3B\30AD\30FC\52171')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104692661381308994)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN1_REQUIRED.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\30FB\30BD\30FC\30B9\304B\30891\3064\76EE\306E\4E3B\30AD\30FC\5217\3092\9078\629E\3057\307E\3059\3002\3053\306E\8868\306E\4E3B\30AD\30FC\306E\5217\304C2\3064\3088\308A\591A\3044\5834\5408\3001<code>ROWID</code>\5217\3092\9078\629E\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\30B9\30AF\30ED\30FC\30EB\306E\30DA\30FC\30B8\533A\5207\308A\3092\8868\793A\3059\308B\3088\3046\306B\30EA\30FC\30B8\30E7\30F3\304C\8A2D\5B9A\3055\308C\3066\3044\308B\5834\5408\3001\4E3B\30AD\30FC\306F\91CD\8907\884C\306E\8868\793A\3092\56DE\907F\3059\308B\305F\3081\306B\4F7F\7528\3055\308C\307E\3059\3002\30EA\30FC\30B8\30E7\30F3\306BBLOB\5217\306E\30A4\30E1\30FC\30B8\304C\8868\793A\3055\308C\308B\5834\5408\3001\4E3B\30AD\30FC\306F\30A4\30E1\30FC\30B8\3092\53D6\5F97\3059\308B\305F\3081\306B\4F7F\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104692507456308994)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN1_REQUIRED.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E3B\30AD\30FC\52171')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104692405077308994)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\30FB\30BD\30FC\30B9\306E\4E3B\30AD\30FC\304C2\3064\306E\5217\304B\3089\6210\308B\5834\5408\306B\306E\307F2\3064\76EE\306E\4E3B\30AD\30FC\5217\3092\9078\629E\3057\307E\3059\30021\3064\76EE\306E\4E3B\30AD\30FC\5217\306B<code>ROWID</code>\3092\9078\629E\3057\305F\5834\5408\3001\3053\306E\5217\306B\306F\79FB\5165\3057\307E\305B\3093\3002\30B9\30AF\30ED\30FC\30EB\306E\30DA\30FC\30B8\533A\5207\308A\3092\8868\793A\3059\308B\3088\3046\306B\30EA\30FC\30B8\30E7\30F3\304C\8A2D\5B9A\3055\308C\3066\3044\308B\5834\5408\30012\3064\76EE\306E\4E3B\30AD\30FC\306F\91CD\8907\884C\306E\8868\793A\3092\56DE\907F\3059\308B\305F\3081\306B\4F7F\7528\3055\308C\307E\3059\3002\30EA\30FC\30B8\30E7\30F3\306BBLOB\5217\306E\30A4\30E1\30FC\30B8\304C\8868\793A\3055\308C\308B\5834\5408\30012\3064\76EE\306E\4E3B\30AD\30FC\306F\30A4\30E1\30FC\30B8\3092\53D6\5F97\3059\308B\305F\3081\306B\4F7F\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104692323323308994)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E3B\30AD\30FC\52172')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104692873045308994)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN2_REQUIRED.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\30FB\30BD\30FC\30B9\306E\4E3B\30AD\30FC\304C2\3064\306E\5217\304B\3089\6210\308B\5834\5408\306B\306E\307F2\3064\76EE\306E\4E3B\30AD\30FC\5217\3092\9078\629E\3057\307E\3059\30021\3064\76EE\306E\4E3B\30AD\30FC\5217\306B<code>ROWID</code>\3092\9078\629E\3057\305F\5834\5408\3001\3053\306E\5217\306B\306F\79FB\5165\3057\307E\305B\3093\3002\30B9\30AF\30ED\30FC\30EB\306E\30DA\30FC\30B8\533A\5207\308A\3092\8868\793A\3059\308B\3088\3046\306B\30EA\30FC\30B8\30E7\30F3\304C\8A2D\5B9A\3055\308C\3066\3044\308B\5834\5408\30012\3064\76EE\306E\4E3B\30AD\30FC\306F\91CD\8907\884C\306E\8868\793A\3092\56DE\907F\3059\308B\305F\3081\306B\4F7F\7528\3055\308C\307E\3059\3002\30EA\30FC\30B8\30E7\30F3\306BBLOB\5217\306E\30A4\30E1\30FC\30B8\304C\8868\793A\3055\308C\308B\5834\5408\30012\3064\76EE\306E\4E3B\30AD\30FC\306F\30A4\30E1\30FC\30B8\3092\53D6\5F97\3059\308B\305F\3081\306B\4F7F\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104692712149308994)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN2_REQUIRED.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E3B\30AD\30FC\52172')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104580072734308903)
,p_name=>'PE.PROPERTY.CARD_USES_BLOB_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30FC\30C9\3067BLOB\5217\3092\4F7F\7528\3057\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104232758263308634)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\89AA\30D5\30A1\30BB\30C3\30C8\307E\305F\306F\30D5\30A3\30EB\30BF\306E\5024\3092\4F7F\7528\3057\305F\554F\5408\305B\306B\4F7F\7528\3055\308C\308B\3001LOV\306E\30C7\30FC\30BF\30D9\30FC\30B9\5217\540D(\5927\6587\5B57\3068\5C0F\6587\5B57\3092\533A\5225)\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104232626674308633)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('LOV\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104769648396309065)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_COLUMNS.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306ELOV\306E\30EA\30D5\30EC\30C3\30B7\30E5\3092\30C8\30EA\30AC\30FC\3059\308B\5217\3092\5165\529B\3057\307E\3059\3002'),
unistr('\8907\6570\306E\5217\306E\5834\5408\3001\5404\5217\540D\3092\30AB\30F3\30DE\3067\533A\5207\308A\307E\3059\3002'),
unistr('\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\5217\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002'),
unistr('\30EA\30B9\30C8\304B\3089\9078\629E\3057\3001\3059\3067\306B\5165\529B\3055\308C\3066\3044\308B\30C6\30AD\30B9\30C8\304C\3042\308B\5834\5408\3001\65E2\5B58\306E\30C6\30AD\30B9\30C8\306E\6700\5F8C\306B\30AB\30F3\30DE\304C\4ED8\3051\3089\308C\3001\30EA\30B9\30C8\304B\3089\8FD4\3055\308C\305F\5217\540D\304C\305D\308C\306B\7D9A\304D\307E\3059\3002</p>'),
unistr('<p>\6307\5B9A\3055\308C\305F\5217\306E\5024\304C\3053\306E\30DA\30FC\30B8\3067\5909\66F4\3055\308C\308B\3068\3001\3053\306ELOV\306F\30EA\30D5\30EC\30C3\30B7\30E5\3055\308C\307E\3059\3002</p>'),
unistr('<p>\8FD4\3055\308C\308B\5024\3092\5236\9650\3059\308B\306B\306F\3001\3053\306E\5C5E\6027\3067\6307\5B9A\3055\308C\305F\5217\3092\3053\306ELOV\306ESQL\554F\5408\305B\306E<em>where\53E5</em>\5185\306B\4F7F\7528\3057\307E\3059\3002</p>'),
unistr('<p>\305F\3068\3048\3070\3001\81EA\52D5\8ECA\306E\30E1\30FC\30AB\30FC\3068\8ECA\7A2E\306E\5217\304C\3042\308B\5834\5408\3001\8ECA\7A2E\306ELOV\5B9A\7FA9\5185\3067\30E1\30FC\30AB\30FC\3092\30AB\30B9\30B1\30FC\30C9LOV\89AA\5217\3068\3057\3066\6307\5B9A\3057\3001\305D\306ELOV\306B\5BFE\3059\308Bwhere\53E5\5185\3067\30E1\30FC\30AB\30FC\3092\4F7F\7528\3057\307E\3059\3002'),
unistr('\305D\3046\3059\308B\3068\3001\30E1\30FC\30AB\30FC\304C\5909\66F4\3055\308C\308B\305F\3073\306B\8ECA\7A2E\306ELOV\304C\30EA\30D5\30EC\30C3\30B7\30E5\3055\308C\3001\73FE\5728\9078\629E\3055\308C\3066\3044\308B\30E1\30FC\30AB\30FC\306E\5024\306E\307F\304C\30EA\30B9\30C8\306B\8868\793A\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104769540100309065)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_COLUMNS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\89AA\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104232949098308634)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_FACET.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306ELOV\306E\30EA\30D5\30EC\30C3\30B7\30E5\3092\30C8\30EA\30AC\30FC\3059\308B\30D5\30A1\30BB\30C3\30C8\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104232865971308634)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_FACET.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\89AA\30D5\30A1\30BB\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103919369898308373)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_FILTER.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306ELOV\306E\30EA\30D5\30EC\30C3\30B7\30E5\3092\30C8\30EA\30AC\30FC\3059\308B\30D5\30A3\30EB\30BF\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103919211895308373)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_FILTER.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\89AA\30D5\30A3\30EB\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103884452499308311)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_ITEMS.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306ELOV\306E\30EA\30D5\30EC\30C3\30B7\30E5\3092\30C8\30EA\30AC\30FC\3059\308B\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002'),
unistr('\8907\6570\306E\30A2\30A4\30C6\30E0\306E\5834\5408\3001\5404\30A2\30A4\30C6\30E0\540D\3092\30AB\30F3\30DE\3067\533A\5207\308A\307E\3059\3002'),
unistr('\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002'),
unistr('\30EA\30B9\30C8\304B\3089\9078\629E\3057\3001\3059\3067\306B\5165\529B\3055\308C\3066\3044\308B\30C6\30AD\30B9\30C8\304C\3042\308B\5834\5408\3001\65E2\5B58\306E\30C6\30AD\30B9\30C8\306E\6700\5F8C\306B\30AB\30F3\30DE\304C\4ED8\3051\3089\308C\3001\30EA\30B9\30C8\304B\3089\8FD4\3055\308C\305F\30A2\30A4\30C6\30E0\540D\304C\305D\308C\306B\7D9A\304D\307E\3059\3002</p>'),
unistr('<p>\6307\5B9A\3055\308C\305F\30A2\30A4\30C6\30E0\306E\5024\304C\3053\306E\30DA\30FC\30B8\3067\5909\66F4\3055\308C\308B\3068\3001\3053\306ELOV\306F\30EA\30D5\30EC\30C3\30B7\30E5\3055\308C\307E\3059\3002</p>'),
unistr('<p>\8FD4\3055\308C\308B\5024\3092\5236\9650\3059\308B\306B\306F\3001\3053\306E\5C5E\6027\3067\6307\5B9A\3055\308C\305F\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3092\3053\306ELOV\306ESQL\554F\5408\305B\306E<em>where\53E5</em>\5185\306B\4F7F\7528\3057\307E\3059\3002</p>'),
unistr('<p>\305F\3068\3048\3070\3001\81EA\52D5\8ECA\306E\30E1\30FC\30AB\30FC\3068\8ECA\7A2E\306E\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\304C\3042\308B\5834\5408\3001\8ECA\7A2E\306ELOV\5B9A\7FA9\5185\3067\30E1\30FC\30AB\30FC\3092\30AB\30B9\30B1\30FC\30C9LOV\89AA\30A2\30A4\30C6\30E0\3068\3057\3066\6307\5B9A\3057\3001\305D\306ELOV\306B\5BFE\3059\308Bwhere\53E5\5185\3067\30E1\30FC\30AB\30FC\3092\4F7F\7528\3057\307E\3059\3002'),
unistr('\305D\3046\3059\308B\3068\3001\30E1\30FC\30AB\30FC\304C\5909\66F4\3055\308C\308B\305F\3073\306B\8ECA\7A2E\306ELOV\304C\30EA\30D5\30EC\30C3\30B7\30E5\3055\308C\3001\73FE\5728\9078\629E\3055\308C\3066\3044\308B\30E1\30FC\30AB\30FC\306E\5024\306E\307F\304C\30EA\30B9\30C8\306B\8868\793A\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103884389049308311)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_ITEMS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\89AA\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104229755910308631)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_REQUIRED.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306ELOV\304C\30EA\30D5\30EC\30C3\30B7\30E5\3055\308C\308B\6761\4EF6\3092\6307\5B9A\3057\307E\3059\3002</p>'),
unistr('<p><strong>\300C\30AA\30F3\300D</strong>\306B\8A2D\5B9A\3059\308B\3068\3001\3059\3079\3066\306E<em>\300C\30AB\30B9\30B1\30FC\30C9LOV\89AA\30A2\30A4\30C6\30E0\300D</em>\304CNULL\3067\306F\306A\3044\5834\5408\306B\306E\307F\3001\65B0\3057\3044\5024\3092\53D6\5F97\3059\308B\30EA\30D5\30EC\30C3\30B7\30E5\30FB\30B3\30FC\30EB\304C\5B9F\884C\3055\308C\307E\3059\3002'),
unistr('1\3064\306E\30A2\30A4\30C6\30E0\304CNULL\306E\5834\5408\3001LOV\554F\5408\305B\306F\884C\3092\8FD4\3055\306A\3044\3068\307F\306A\3055\308C\307E\3059\3002'),
unistr('\3053\306E\3088\3046\306A\5834\5408\3001\30D6\30E9\30A6\30B6\3067\9078\629E\30EA\30B9\30C8\30FB\30A8\30F3\30C8\30EA\304C\5358\306B\30AF\30EA\30A2\3055\308C\3001\30EA\30D5\30EC\30C3\30B7\30E5\306F\5B9F\884C\3055\308C\307E\305B\3093\3002</p>'),
unistr('<p><strong>\300C\30AA\30D5\300D</strong>\306B\8A2D\5B9A\3059\308B\3068\3001\30EA\30D5\30EC\30C3\30B7\30E5\306F\5E38\306B\5B9F\884C\3055\308C\307E\3059\3002'),
unistr('\3053\306E\30AA\30D7\30B7\30E7\30F3\306F\3001NULL\3092\4F7F\7528\3067\304D\308B<em>\30AB\30B9\30B1\30FC\30C9LOV\89AA\30A2\30A4\30C6\30E0</em>\3092\3053\306ELOV\306ESQL\554F\5408\305B\306E<em>where\53E5</em>\3067\6271\3046\5834\5408\306B\306E\307F\4F7F\7528\3057\307E\3059\3002'),
unistr('NULL\3092\4F7F\7528\3067\304D\308B\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\304C\9069\5207\306B\51E6\7406\3055\308C\306A\3044\5834\5408\3001\884C\3092\8FD4\3055\306A\3044\4E0D\5FC5\8981\306A\30EA\30D5\30EC\30C3\30B7\30E5\30FB\30B3\30FC\30EB\304C\5B9F\884C\3055\308C\307E\3059\3002</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104229622981308631)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_REQUIRED.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\89AA\304C\5FC5\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103515269901308026)
,p_name=>'PE.PROPERTY.CHANGED_BY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\5C5E\6027\3092\6700\5F8C\306B\66F4\65B0\3057\305F\958B\767A\8005\306E\30E6\30FC\30B6\30FC\8CC7\683C\8A3C\660E\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103515156736308026)
,p_name=>'PE.PROPERTY.CHANGED_BY.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5909\66F4\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103515484438308027)
,p_name=>'PE.PROPERTY.CHANGED_ON.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\5C5E\6027\304C\6700\5F8C\306B\3044\3064\66F4\65B0\3055\308C\305F\304B\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103515358041308026)
,p_name=>'PE.PROPERTY.CHANGED_ON.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5909\66F4\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104265285492308657)
,p_name=>'PE.PROPERTY.CHART_HEIGHT.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30C1\30E3\30FC\30C8\306E\9AD8\3055\3092\30D4\30AF\30BB\30EB\5358\4F4D\3067\5165\529B\3057\307E\3059\3002\3053\306E\9AD8\3055\306F\3001\30C1\30E3\30FC\30C8\30FB\30EA\30FC\30B8\30E7\30F3\306E\56FA\5B9A\306E\9AD8\3055\3092\5B9A\7FA9\3057\307E\3059\3002\3042\308B\3044\306F\3001\30C1\30E3\30FC\30C8\306E\9AD8\3055\306E\81EA\52D5\30B5\30A4\30BA\5909\66F4\3092\6709\52B9\306B\3059\308B\306B\306F\3001\3053\306E\30A2\30A4\30C6\30E0\3092\7A7A\306E\307E\307E\306B\3057\307E\3059\3002'),
unistr('\305D\3046\3059\308B\3068\3001\9AD8\3055\306F\30D6\30E9\30A6\30B6\306E\9AD8\3055\306B\57FA\3065\304D\307E\3059\3002</p>'),
unistr('<p>\30C7\30D5\30A9\30EB\30C8\3067\306F\3001jQuery Mobile\30B9\30DE\30FC\30C8\30D5\30A9\30F3\30FB\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\3092\4F7F\7528\3057\3066\30DA\30FC\30B8\306B\4F5C\6210\3055\308C\305F\30C1\30E3\30FC\30C8\306B\306F\9AD8\3055\306E\5024\30BB\30C3\30C8\306F\306A\304F\3001\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\308B\30C7\30D0\30A4\30B9\306B\5408\305B\3066\9069\5207\306B\30B5\30A4\30BA\8A2D\5B9A\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104265199856308657)
,p_name=>'PE.PROPERTY.CHART_HEIGHT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\9AD8\3055')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104265363145308657)
,p_name=>'PE.PROPERTY.CHART_HEIGHT.UNIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D4\30AF\30BB\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104289074982308674)
,p_name=>'PE.PROPERTY.CHART_MAX_WIDTH.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30C1\30E3\30FC\30C8\306E\6700\5927\5E45\3092\30D4\30AF\30BB\30EB\5358\4F4D\3067\5165\529B\3057\307E\3059\3002\3053\306E\6700\5927\5E45\306F\3001\30C1\30E3\30FC\30C8\30FB\30EA\30FC\30B8\30E7\30F3\306E\56FA\5B9A\5E45\3092\5B9A\7FA9\3057\307E\3059\3002'),
unistr('\3042\308B\3044\306F\3001\30C1\30E3\30FC\30C8\306E\5E45\306E\81EA\52D5\30B5\30A4\30BA\5909\66F4\3092\6709\52B9\306B\3059\308B\306B\306F\3001\3053\306E\30A2\30A4\30C6\30E0\3092\7A7A\306E\307E\307E\306B\3057\307E\3059\3002\305D\3046\3059\308B\3068\3001\5E45\306F\30EA\30FC\30B8\30E7\30F3\306E100%\306B\81EA\52D5\7684\306B\8A2D\5B9A\3055\308C\307E\3059\3002</p>'),
unistr('<p>\30C7\30D5\30A9\30EB\30C8\3067\306F\3001jQuery Mobile\30B9\30DE\30FC\30C8\30D5\30A9\30F3\30FB\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\3092\4F7F\7528\3057\3066\30DA\30FC\30B8\306B\4F5C\6210\3055\308C\305F\30C1\30E3\30FC\30C8\306B\306F\5E45\306E\5024\30BB\30C3\30C8\306F\306A\304F\3001\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\308B\30C7\30D0\30A4\30B9\306B\5408\305B\3066\9069\5207\306B\30B5\30A4\30BA\8A2D\5B9A\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104283412683308670)
,p_name=>'PE.PROPERTY.CHART_MAX_WIDTH.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5927\5E45')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104283550923308670)
,p_name=>'PE.PROPERTY.CHART_MAX_WIDTH.UNIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D4\30AF\30BB\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104262134910308655)
,p_name=>'PE.PROPERTY.CHART_TITLE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\306E\4E0A\90E8\306B\8868\793A\3059\308B\30BF\30A4\30C8\30EB\3092\5165\529B\3057\307E\3059\3002\30AC\30F3\30C8\30FB\30C1\30E3\30FC\30C8\306E\5834\5408\3001\3053\306E\5024\306F\3001\30A2\30AF\30BB\30B9\53EF\80FD\306A\30C1\30E3\30FC\30C8\30FB\30BF\30A4\30C8\30EB\306E\5B9A\7FA9\306B\306E\307F\4F7F\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104262052921308655)
,p_name=>'PE.PROPERTY.CHART_TITLE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30C8\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104490597336308831)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\306E\5834\6240\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104490605803308831)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.LOCAL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30FC\30AB\30EB\30FB\30C7\30FC\30BF\30D9\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104490791305308831)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.LOCAL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\306F\30ED\30FC\30AB\30EB\30FB\30C7\30FC\30BF\30D9\30FC\30B9\3092\30BD\30FC\30B9\3068\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104491261681308832)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.REGION_SOURCE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\30FB\30BD\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104491314434308832)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.REGION_SOURCE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\306F\30EA\30FC\30B8\30E7\30F3\30FB\30BD\30FC\30B9\5B9A\7FA9\3067\6307\5B9A\3055\308C\305F\5834\6240\3092\30BD\30FC\30B9\3068\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104490837056308831)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.REMOTE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\5BFE\5FDCSQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104490946776308831)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.REMOTE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\306F\3001REST\5BFE\5FDCSQL\3092\4F7F\7528\3057\3066\63A5\7D9A\304C\5B9A\7FA9\3055\308C\308B\30EA\30E2\30FC\30C8\30FB\30C7\30FC\30BF\30D9\30FC\30B9\3092\30BD\30FC\30B9\3068\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104491017579308831)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.WEB_SOURCE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\30BD\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104491148345308832)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.WEB_SOURCE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\306F\3001REST\30C7\30FC\30BF\30FB\30BD\30FC\30B9\3092\4F7F\7528\3057\3066\5B9A\7FA9\3055\308C\308BRESTful Web\30B5\30FC\30D3\30B9\3092\30BD\30FC\30B9\3068\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104490414444308831)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104255853727308650)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30EC\30DD\30FC\30C8\5217\306E\30D9\30FC\30B9\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104413677217308767)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.DATE_PICKER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('* \65E5\4ED8\30D4\30C3\30AB\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104413514572308767)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.DATE_POPUP.D'
,p_message_language=>'ja'
,p_message_text=>unistr('* \65E5\4ED8\30D4\30C3\30AB\30FC(\30AF\30E9\30B7\30C3\30AF)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104413462229308767)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.DISPLAY_AND_SAVE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('* \30C6\30AD\30B9\30C8\3068\3057\3066\8868\793A(\72B6\614B\3092\4FDD\5B58\3059\308B)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104413122321308767)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.DOWNLOAD.D'
,p_message_language=>'ja'
,p_message_text=>unistr('BLOB\306E\30C0\30A6\30F3\30ED\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104590558824308911)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.DOWNLOAD.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\3092\30C0\30A6\30F3\30ED\30FC\30C9\3059\308B\305F\3081\306E\30EA\30F3\30AF\3068\3057\3066\5217\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104413347290308767)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.HIDDEN_COLUMN.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\975E\8868\793A\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104590729998308911)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.HIDDEN_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\306F\8868\793A\3055\308C\307E\305B\3093\304C\3001\53C2\7167\53EF\80FD\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104414158038308768)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.HIDDEN_FIELD.D'
,p_message_language=>'ja'
,p_message_text=>unistr('* \975E\8868\793A\30D5\30A3\30FC\30EB\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104413012979308767)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.IMAGE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30E1\30FC\30B8\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104590456173308911)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.IMAGE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30E1\30FC\30B8\3068\3057\3066\5217\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104412903195308767)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.LINK.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30F3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104590380214308911)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.LINK.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30F3\30AF\3068\3057\3066\5217\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104413263123308767)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PCT_GRAPH.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30FC\30BB\30F3\30C8\30FB\30B0\30E9\30D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104590605628308911)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PCT_GRAPH.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30FC\30BB\30F3\30C6\30FC\30B8\30FB\30B0\30E9\30D5\3068\3057\3066\5217\3092\8868\793A\3057\307E\3059\3002\53D6\5F97\3055\308C\308B\5024\306F\30010\304B\3089100\307E\3067\306E\9593\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104412789879308767)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PLAIN.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30EC\30FC\30F3\30FB\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104590121166308911)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PLAIN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\5024\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104412855076308767)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PLAIN_LOV.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30EC\30FC\30F3\30FB\30C6\30AD\30B9\30C8(LOV\306B\57FA\3065\304F)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104590278373308911)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PLAIN_LOV.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\6307\5B9A\3055\308C\305FLOV\304B\3089\8FD4\3055\308C\305F\5024\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104414275963308768)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.POPUP.D'
,p_message_language=>'ja'
,p_message_text=>unistr('* \30DD\30C3\30D7\30A2\30C3\30D7LOV')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104414345932308768)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.POPUPKEY.D'
,p_message_language=>'ja'
,p_message_text=>unistr('* \30DD\30C3\30D7\30A2\30C3\30D7\30FB\30AD\30FCLOV')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104414022480308768)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.RADIOGROUP.D'
,p_message_language=>'ja'
,p_message_text=>unistr('* \30E9\30B8\30AA\30FB\30B0\30EB\30FC\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104661643046308968)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.RICH_TEXT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30C3\30C1\30FB\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104661792530308968)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.RICH_TEXT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('HTML\307E\305F\306F\30DE\30FC\30AF\30C0\30A6\30F3\3092\4F7F\7528\3057\3066\5217\3092\30EC\30F3\30C0\30EA\30F3\30B0\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104414531332308768)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.ROW_SELECTOR.D'
,p_message_language=>'ja'
,p_message_text=>unistr('* \884C\30BB\30EC\30AF\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104413957358308768)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.SELECT_LIST.D'
,p_message_language=>'ja'
,p_message_text=>unistr('* \9078\629E\30EA\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104414440673308768)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.SIMPLE_CHECKBOX.D'
,p_message_language=>'ja'
,p_message_text=>unistr('* \5358\7D14\306A\30C1\30A7\30C3\30AF\30DC\30C3\30AF\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104413719972308768)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.TEXT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('* \30C6\30AD\30B9\30C8\30FB\30D5\30A3\30FC\30EB\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104413888240308768)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.TEXTAREA.D'
,p_message_language=>'ja'
,p_message_text=>unistr('* \30C6\30AD\30B9\30C8\9818\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104255769068308650)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104255493668308650)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.COMPONENT_PROPERTY.CLASSIC_REPORT.NULL_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\533A\5207\308A\306A\3057(\3059\3079\3066\306E\884C\306E\8868\793A)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104256687584308651)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.COMPONENT_PROPERTY.TABULAR_FORM.NULL_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\533A\5207\308A\306A\3057(\3059\3079\3066\306E\884C\306E\8868\793A)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104241825488308640)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30EC\30DD\30FC\30C8\3067\4F7F\7528\3059\308B\30DA\30FC\30B8\533A\5207\308A\30BF\30A4\30D7\3092\9078\629E\3057\307E\3059\3002'),
unistr('\901A\5E38\7D50\679C\306E\30B5\30D6\30BB\30C3\30C8\306E\307F\304C\30EC\30DD\30FC\30C8\306B\5F53\5EA7\8868\793A\3055\308C\307E\3059\3002'),
unistr('\30DA\30FC\30B8\533A\5207\308A\306B\3088\3063\3066\7D50\679C\30BB\30C3\30C8\5185\306E\884C\6570\304A\3088\3073\73FE\5728\306E\4F4D\7F6E\306B\95A2\3059\308B\60C5\5831\304C\30E6\30FC\30B6\30FC\306B\63D0\4F9B\3055\308C\307E\3059\3002\30DA\30FC\30B8\533A\5207\308A\3067\306F\3001\6B21\307E\305F\306F\524D\306E\30DA\30FC\30B8\3078\306E\30CA\30D3\30B2\30FC\30C8\306B\4F7F\7528\3055\308C\308B\30EA\30F3\30AF\307E\305F\306F\30DC\30BF\30F3\306E\30B9\30BF\30A4\30EB\3082\5B9A\7FA9\3057\307E\3059\3002</p>'),
unistr('<p>\30DA\30FC\30B8\533A\5207\308A\306F\3001\30EC\30DD\30FC\30C8\306E\4E0A\307E\305F\306F\4E0B(\3042\308B\3044\306F\305D\306E\4E21\65B9)\306B\8868\793A\3057\305F\308A\3001\5DE6\307E\305F\306F\53F3\306B\914D\7F6E\3067\304D\307E\3059</p>'),
unistr('<p><strong>X\304B\3089Y\306E\7BC4\56F2\306E\884C(\300C\6B21\3078\300D\304A\3088\3073\300C\623B\308B\300D\30EA\30F3\30AF)</strong>\306A\3069\306E\7C21\7565\5316\3055\308C\305F\30DA\30FC\30B8\533A\5207\308A\30B9\30BF\30A4\30EB\3092\4F7F\7528\3057\3066\3001\30D1\30D5\30A9\30FC\30DE\30F3\30B9\3092\5411\4E0A\3055\305B\308B\3053\3068\3082\3067\304D\307E\3059\3002'),
unistr('\300CZ\306EX\304B\3089Y\300D\5F62\5F0F\306E\30DA\30FC\30B8\533A\5207\308A\30BF\30A4\30D7\3092\4F7F\7528\3059\308B\306B\306F\3001&PRODUCT_NAME.\30A8\30F3\30B8\30F3\30672\3064\306E\554F\5408\305B\3092\5B9F\884C\3057\3066\7D50\679C\3092\8FD4\3059\5FC5\8981\304C\3042\308A\307E\3059\3002'),
unistr('1\3064\306E\554F\5408\305B\3067\8868\793A\3059\308B\73FE\5728\306E\30EC\30B3\30FC\30C9\3092\53D6\5F97\3057\3001\3082\30461\3064\306E\554F\5408\305B\3067\30DA\30FC\30B8\533A\5207\308A\30B3\30F3\30C8\30ED\30FC\30EB\306B\8868\793A\3059\308B\5408\8A08\30EC\30B3\30FC\30C9\6570\3092\53D6\5F97\3057\307E\3059\3002'),
unistr('\975E\5E38\306B\5927\898F\6A21\306A\30C7\30FC\30BF\30FB\30BB\30C3\30C8\306B\57FA\3065\304F\30EC\30DD\30FC\30C8\3084CPU\3092\5927\91CF\306B\4F7F\7528\3059\308B\554F\5408\305B(\591A\6570\306E\6700\9069\3067\306A\3044\8868\7D50\5408\3084\30B3\30B9\30C8\306E\304B\304B\308B\6761\4EF6\306A\3069)\306E\5834\5408\3001\3053\306E\8FFD\52A0\554F\5408\305B\306B\3088\3063\3066\51E6\7406\6642\9593\304C\5897\3048\3001\30EC\30DD\30FC\30C8\306E\30EC\30F3\30C0\30EA\30F3\30B0\6642\9593\304C\9577\304F\306A\308B\3053\3068\304C\3042\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104422225097308774)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.COMPUTED_BUT_NOT_DISPLAYED.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5916\90E8\3067\4F5C\6210\3055\308C\305F\30DA\30FC\30B8\533A\5207\308A\30DC\30BF\30F3\3092\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104422342241308774)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.NEXT_PREVIOUS_LINKS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('X\304B\3089Y\306E\7BC4\56F2\306E\884C(\300C\6B21\3078\300D\304A\3088\3073\300C\623B\308B\300D\30EA\30F3\30AF)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104421663477308773)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.ROWS_X_TO_Y.D'
,p_message_language=>'ja'
,p_message_text=>unistr('X\304B\3089Y\306E\7BC4\56F2\306E\884C(\30DA\30FC\30B8\533A\5207\308A\306A\3057)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104421779327308773)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.ROWS_X_TO_Y_OF_Z.D'
,p_message_language=>'ja'
,p_message_text=>unistr('Z\306EX\304B\3089Y\306E\7BC4\56F2\306E\884C(\30DA\30FC\30B8\533A\5207\308A\306A\3057)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104421972622308774)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.ROW_RANGES.D'
,p_message_language=>'ja'
,p_message_text=>unistr('1\304B\308915 16\304B\308930\306E\7BC4\56F2\306E\884C(\30DA\30FC\30B8\533A\5207\308A\3092\8A2D\5B9A)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104422088161308774)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.ROW_RANGES_IN_SELECT_LIST.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\30EA\30B9\30C8\306E1\304B\308915 16\304B\308930\306E\7BC4\56F2\306E\884C(\30DA\30FC\30B8\533A\5207\308A\3042\308A)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104421837892308773)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.ROW_RANGES_WITH_LINKS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('Z\306EX\304B\3089Y\306E\7BC4\56F2\306E\884C(\30DA\30FC\30B8\533A\5207\308A\3042\308A)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104422160877308774)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.SEARCH_ENGINE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22\30A8\30F3\30B8\30F31\30012\30013\30014(\30DA\30FC\30B8\533A\5207\308A\306B\57FA\3065\3044\3066\8A2D\5B9A)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104241762354308640)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104211328241308618)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3\30FB\30D3\30E5\30FC\30671\884C\306B\8868\793A\3055\308C\308B\30A2\30A4\30B3\30F3\306E\6570\3092\9078\629E\3057\307E\3059\30025\3092\6307\5B9A\3059\308B\3068\3001\30EC\30DD\30FC\30C8\30671\884C\5F53\305F\308A5\500B\306E\30A2\30A4\30B3\30F3\304C\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104409763985308764)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.1.D'
,p_message_language=>'ja'
,p_message_text=>'1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104409824759308765)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.2.D'
,p_message_language=>'ja'
,p_message_text=>'2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104409918010308765)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.3.D'
,p_message_language=>'ja'
,p_message_text=>'3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104410078835308765)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.4.D'
,p_message_language=>'ja'
,p_message_text=>'4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104410151570308765)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.5.D'
,p_message_language=>'ja'
,p_message_text=>'5'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104410206387308765)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.6.D'
,p_message_language=>'ja'
,p_message_text=>'6'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104410313813308765)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.7.D'
,p_message_language=>'ja'
,p_message_text=>'7'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104410471891308765)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.8.D'
,p_message_language=>'ja'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104410507541308765)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.9.D'
,p_message_language=>'ja'
,p_message_text=>'9'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104211271356308618)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('1\884C\5F53\305F\308A\306E\884C\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104201837098308611)
,p_name=>'PE.PROPERTY.COLUMN_ALIGNMENT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\8868\793A\306E\4F4D\7F6E\5408\305B\3092\9078\629E\3057\307E\3059\3002\4F4D\7F6E\5408\305B\306E\9078\629E\306F\3001\9078\629E\3057\305F\30EC\30DD\30FC\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3067\30B5\30DD\30FC\30C8\3055\308C\3066\3044\308B\5FC5\8981\304C\3042\308B\3053\3068\306B\6CE8\610F\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104405898785308762)
,p_name=>'PE.PROPERTY.COLUMN_ALIGNMENT.LOV.CENTER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E2D\592E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104405734347308762)
,p_name=>'PE.PROPERTY.COLUMN_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104405996509308762)
,p_name=>'PE.PROPERTY.COLUMN_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D42\4E86')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104201779352308611)
,p_name=>'PE.PROPERTY.COLUMN_ALIGNMENT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\306E\4F4D\7F6E\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104258104941308652)
,p_name=>'PE.PROPERTY.COLUMN_DEFAULT_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\5217\5024\30BF\30A4\30D7\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104425785101308776)
,p_name=>'PE.PROPERTY.COLUMN_DEFAULT_TYPE.LOV.FUNCTION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104425604123308776)
,p_name=>'PE.PROPERTY.COLUMN_DEFAULT_TYPE.LOV.ITEM.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104258076160308652)
,p_name=>'PE.PROPERTY.COLUMN_DEFAULT_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104113059951308527)
,p_name=>'PE.PROPERTY.COLUMN_HEADING.COMPONENT_PROPERTY.IG_COLUMN_GROUP.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30EB\30FC\30D7\30FB\30D8\30C3\30C0\30FC\30FB\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104201040536308610)
,p_name=>'PE.PROPERTY.COLUMN_HEADING.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\306E\5217\30D8\30C3\30C0\30FC\30FB\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104200956268308610)
,p_name=>'PE.PROPERTY.COLUMN_HEADING.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D8\30C3\30C0\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103630760453308113)
,p_name=>'PE.PROPERTY.COLUMN_IS_SORTABLE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BD\30FC\30C8\53EF\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104539951573308867)
,p_name=>'PE.PROPERTY.COLUMN_MAPPING_PK_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\3092\8B58\5225\3059\308B\305F\3081\306E\4E00\610F\30AD\30FC\3092\542B\3080\5217\3092\9078\629E\3057\307E\3059\3002\3053\308C\3092\4F7F\7528\3057\3066\3001\30AB\30B9\30BF\30E0JavaScript\30B3\30FC\30C9\307E\305F\306F\30DE\30C3\30D7\30FB\30A4\30D9\30F3\30C8\30FB\30CF\30F3\30C9\30E9\306B\4E3B\30AD\30FC\5024\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104539845078308867)
,p_name=>'PE.PROPERTY.COLUMN_MAPPING_PK_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E3B\30AD\30FC\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104200476190308610)
,p_name=>'PE.PROPERTY.COLUMN_NAME.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30EC\30DD\30FC\30C8\5217\306E\5217\540D\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104200314469308610)
,p_name=>'PE.PROPERTY.COLUMN_NAME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104255680281308650)
,p_name=>'PE.PROPERTY.COLUMN_SORT_DIRECTION.COMPONENT_PROPERTY.CLASSIC_REPORT_COLUMN.NULL_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6607\9806')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104257042418308651)
,p_name=>'PE.PROPERTY.COLUMN_SORT_DIRECTION.COMPONENT_PROPERTY.TABULAR_FORM_COLUMN.NULL_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6607\9806')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104236122140308636)
,p_name=>'PE.PROPERTY.COLUMN_SORT_DIRECTION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\5217\304C\964D\9806\3067\30BD\30FC\30C8\3055\308C\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002\6307\5B9A\3055\308C\306A\3044\5834\5408\3001\5217\306F\6607\9806(\30C7\30D5\30A9\30EB\30C8)\3067\30BD\30FC\30C8\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104418995374308771)
,p_name=>'PE.PROPERTY.COLUMN_SORT_DIRECTION.LOV.DESC.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\964D\9806')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104236095521308636)
,p_name=>'PE.PROPERTY.COLUMN_SORT_DIRECTION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B9\5411')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104235905673308636)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\3053\306E\5217\306E\30C7\30D5\30A9\30EB\30C8\9806\5E8F\3092\9078\629E\3057\307E\3059\3002'),
unistr('\6B63\3057\3044\9806\5E8F\3067\30EC\30DD\30FC\30C8\51FA\529B\3059\308B\306B\306F\3001\5404\5217\306B\4E00\610F\306E\9806\5E8F\3092\6301\305F\305B\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104418125017308771)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.1.D'
,p_message_language=>'ja'
,p_message_text=>'1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104418237373308771)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.2.D'
,p_message_language=>'ja'
,p_message_text=>'2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104418320787308771)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.3.D'
,p_message_language=>'ja'
,p_message_text=>'3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104418475505308771)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.4.D'
,p_message_language=>'ja'
,p_message_text=>'4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104418518229308771)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.5.D'
,p_message_language=>'ja'
,p_message_text=>'5'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104418624875308771)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.6.D'
,p_message_language=>'ja'
,p_message_text=>'6'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104418733823308771)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.7.D'
,p_message_language=>'ja'
,p_message_text=>'7'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104418891051308771)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.8.D'
,p_message_language=>'ja'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104235843203308636)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104200627093308610)
,p_name=>'PE.PROPERTY.COLUMN_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\5217\306E\30C7\30FC\30BF\578B\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104200589447308610)
,p_name=>'PE.PROPERTY.COLUMN_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\578B')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104234360874308635)
,p_name=>'PE.PROPERTY.COLUMN_WIDTH.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5217\5E45\3092\30D4\30AF\30BB\30EB\5358\4F4D\3067\5165\529B\3057\307E\3059\3002'),
unistr('\3053\306E\5C5E\6027\306F\30D6\30E9\30A6\30B6\3067\30EC\30DD\30FC\30C8\3092\8868\793A\3059\308B\969B\306B\4F7F\7528\3055\308C\307E\3059\3002'),
unistr('\5217\5E45\306E\8A2D\5B9A\306F\3001\9078\629E\3057\305F\30EC\30DD\30FC\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3067\30B5\30DD\30FC\30C8\3055\308C\3066\3044\308B\5FC5\8981\304C\3042\308B\3053\3068\306B\6CE8\610F\3057\3066\304F\3060\3055\3044\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104234253671308635)
,p_name=>'PE.PROPERTY.COLUMN_WIDTH.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30EB\5E45')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104264750434308657)
,p_name=>'PE.PROPERTY.COLUMN_WIDTH.UNIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D4\30AF\30BB\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103869036110308300)
,p_name=>'PE.PROPERTY.COMMENTS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\3053\306B\958B\767A\8005\306E\30B3\30E1\30F3\30C8\307E\305F\306F\30CE\30FC\30C8\3092\5165\529B\3057\307E\3059\3002\3053\308C\3089\306E\30B3\30E1\30F3\30C8\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30D3\30EB\30C0\30FC\5185\3067\306E\307F\8868\793A\3055\308C\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\5B9F\884C\6642\306B\306F\8868\793A\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103868955321308300)
,p_name=>'PE.PROPERTY.COMMENTS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30E1\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104566285361308891)
,p_name=>'PE.PROPERTY.COMPONENT_CSS_CLASSES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\9069\7528\3059\308BCSS\30AF\30E9\30B9\3092\5165\529B\3057\307E\3059\3002\3053\306E\30AF\30E9\30B9\306F\3001\30AB\30FC\30C9\30FB\30B3\30F3\30C6\30CA\306B\9069\7528\3055\308C\307E\3059\3002\8907\6570\306E\30AF\30E9\30B9\306F\7A7A\767D\3067\533A\5207\3063\3066\8FFD\52A0\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104566130935308891)
,p_name=>'PE.PROPERTY.COMPONENT_CSS_CLASSES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('CSS\30AF\30E9\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104626252921308940)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F\5F0F\306E\8A55\4FA1\306B\4F7F\7528\3055\308C\308B\8A00\8A9E\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104626659228308940)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'ja'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104626546365308940)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'ja'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104626490944308940)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'ja'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104626712420308940)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'ja'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104626393410308940)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'ja'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104626101079308940)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A00\8A9E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104628277718308941)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\306E\5B9F\884C\306B\4F7F\7528\3055\308C\308B\8A00\8A9E\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104628593726308941)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'ja'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104628448851308941)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'ja'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104628342301308941)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'ja'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104628625069308942)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'ja'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104628144033308941)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A00\8A9E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103873077471308303)
,p_name=>'PE.PROPERTY.COMPUTATION_ITEM_NAME.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\8A08\7B97\306B\3088\3063\3066\79FB\5165\3055\308C\308B\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103872999836308303)
,p_name=>'PE.PROPERTY.COMPUTATION_ITEM_NAME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103873817042308303)
,p_name=>'PE.PROPERTY.COMPUTATION_ITEM_VALUE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024\3092\8A08\7B97\30A2\30A4\30C6\30E0\306E\79FB\5165\306B\4F7F\7528\3059\308B\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103873744047308303)
,p_name=>'PE.PROPERTY.COMPUTATION_ITEM_VALUE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104627817777308941)
,p_name=>'PE.PROPERTY.COMPUTATION_JAVA_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A08\7B97\30A2\30A4\30C6\30E0\306E\79FB\5165\306B\4F7F\7528\3055\308C\308B\5024\3092\751F\6210\3059\308BJava\5F0F\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104627726882308941)
,p_name=>'PE.PROPERTY.COMPUTATION_JAVA_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('Java\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104629470485308942)
,p_name=>'PE.PROPERTY.COMPUTATION_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A08\7B97\30A2\30A4\30C6\30E0\306E\79FB\5165\306B\4F7F\7528\3055\308C\308B\5024\3092\8FD4\3059Java\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104629313090308942)
,p_name=>'PE.PROPERTY.COMPUTATION_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('Java\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104627624496308941)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3059\308B\304B\3001\30DE\30CD\30FC\30B8\30E3\3067\3042\308B\5834\5408\3001YES\3092\8FD4\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" ? "YES" : "NO" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104627582893308941)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A08\7B97\30A2\30A4\30C6\30E0\306E\79FB\5165\306B\4F7F\7528\3055\308C\308B\5024\3092\751F\6210\3059\308BJavaScript\5F0F\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104627432730308941)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('JavaScript\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104629229732308942)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3059\308B\5834\5408\3001YES\3092\8FD4\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES", "NO" );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104629138771308942)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A08\7B97\30A2\30A4\30C6\30E0\306E\79FB\5165\306B\4F7F\7528\3055\308C\308B\5024\3092\8FD4\3059JavaScript\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104629041217308942)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('JavaScript\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104627347764308940)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3059\308B\304B\3001\30DE\30CD\30FC\30B8\30E3\3067\3042\308B\5834\5408\3001YES\3092\8FD4\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'case when ( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' ) then ''YES'' else ''NO'' end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104627276604308940)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A08\7B97\30A2\30A4\30C6\30E0\306E\79FB\5165\306B\4F7F\7528\3055\308C\308B\5024\3092\751F\6210\3059\308BPL/SQL\5F0F\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104627127447308940)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104628984962308942)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3059\308B\5834\5408\3001YES\3092\8FD4\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104628811693308942)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A08\7B97\30A2\30A4\30C6\30E0\306E\79FB\5165\306B\4F7F\7528\3055\308C\308B\5024\3092\8FD4\3059PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104628725013308942)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103874482336308304)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30DA\30FC\30B8\306E\30EC\30F3\30C0\30EA\30F3\30B0\307E\305F\306F\51E6\7406\306E\3069\306E\6642\70B9\3067\3053\306E\8A08\7B97\3092\5B9F\884C\3059\308B\304B\3092\9078\629E\3057\307E\3059\3002'),
unistr('\6700\3082\4E00\822C\7684\306A\8A08\7B97\30DD\30A4\30F3\30C8\306F\3001<strong>\300C\9001\4FE1\5F8C\300D</strong>\3067\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104386403333308747)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_BOX_BODY.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\306E\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104687826166308990)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_BOX_BODY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30F3\30C0\30EA\30F3\30B0: \30EA\30FC\30B8\30E7\30F3\306E\30EC\30F3\30C0\30EA\30F3\30B0\5F8C\306B\5B9F\884C\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104386645079308747)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_FOOTER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30C3\30BF\30FC\306E\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104688016465308990)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_FOOTER.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30F3\30C0\30EA\30F3\30B0: \30D5\30C3\30BF\30FC\306E\30EC\30F3\30C0\30EA\30F3\30B0\5F8C\306B\5B9F\884C\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104386207970308747)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_HEADER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D8\30C3\30C0\30FC\306E\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104687607831308990)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_HEADER.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30F3\30C0\30EA\30F3\30B0: \30D8\30C3\30C0\30FC\306E\30EC\30F3\30C0\30EA\30F3\30B0\5F8C\306B\5B9F\884C\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104386746170308747)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_SUBMIT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\9001\4FE1\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104688158697308990)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_SUBMIT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\51E6\7406: \30DA\30FC\30B8\306E\9001\4FE1\5F8C\3067\30DA\30FC\30B8\51E6\7406\524D\306B\5B9F\884C\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104386371457308747)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_BOX_BODY.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\306E\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104687795348308990)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_BOX_BODY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30F3\30C0\30EA\30F3\30B0: \30EA\30FC\30B8\30E7\30F3\306E\30EC\30F3\30C0\30EA\30F3\30B0\524D\306B\5B9F\884C\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104386558004308747)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_FOOTER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30C3\30BF\30FC\306E\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104687905822308990)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_FOOTER.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30F3\30C0\30EA\30F3\30B0: \30D5\30C3\30BF\30FC\306E\30EC\30F3\30C0\30EA\30F3\30B0\524D\306B\5B9F\884C\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104386180580308747)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_HEADER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D8\30C3\30C0\30FC\306E\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104687580717308989)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_HEADER.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30F3\30C0\30EA\30F3\30B0: \30DA\30FC\30B8\306E\30EC\30F3\30C0\30EA\30F3\30B0\524D\306B\5B9F\884C\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104386048230308746)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.ON_NEW_INSTANCE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F\30BB\30C3\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104687422069308989)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.ON_NEW_INSTANCE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\3057\3044\30BB\30C3\30B7\30E7\30F3\306E\751F\6210\6642\306B\5B9F\884C\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103874352369308304)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DD\30A4\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103874019787308304)
,p_name=>'PE.PROPERTY.COMPUTATION_PREFERENCE_VALUE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A08\7B97\30A2\30A4\30C6\30E0\306E\79FB\5165\306B\4F7F\7528\3055\308C\308B\5024\3092\6301\3064\30E6\30FC\30B6\30FC\30FB\30D7\30EA\30D5\30A1\30EC\30F3\30B9\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103873939077308304)
,p_name=>'PE.PROPERTY.COMPUTATION_PREFERENCE_VALUE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30EA\30D5\30A1\30EC\30F3\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104628066764308941)
,p_name=>'PE.PROPERTY.COMPUTATION_PYTHON_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A08\7B97\30A2\30A4\30C6\30E0\306E\79FB\5165\306B\4F7F\7528\3055\308C\308B\5024\3092\751F\6210\3059\308BPython\5F0F\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104627951262308941)
,p_name=>'PE.PROPERTY.COMPUTATION_PYTHON_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('Python\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104629636015308942)
,p_name=>'PE.PROPERTY.COMPUTATION_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A08\7B97\30A2\30A4\30C6\30E0\306E\79FB\5165\306B\4F7F\7528\3055\308C\308B\5024\3092\8FD4\3059Python\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104629575293308942)
,p_name=>'PE.PROPERTY.COMPUTATION_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('Python\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104592894886308913)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_COLON.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A08\7B97\30A2\30A4\30C6\30E0\3078\306E\79FB\5165\306B\4F7F\7528\3055\308C\308B\5024\3092\63D0\4F9B\3059\308BSQL\554F\5408\305B\3092\5165\529B\3057\307E\3059\3002\7D50\679C\306B\8907\6570\306E\884C\304C\542B\307E\308C\308B\5834\5408\3001\5404\884C\306E\5024\304C\3001\30B3\30ED\30F3\3067\533A\5207\3089\308C\305F1\3064\306E\5024\306B\5F62\6210\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104592795277308913)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_COLON.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104627066454308940)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\30DE\30CD\30FC\30B8\30E3\3067\3001\90E8\9580\304C\30B7\30AB\30B4\306B\5B58\5728\3059\308B\5834\5408\3001YES\3092\8FD4\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'case',
'when :P2_JOB = ''MANAGER'' and',
'     exists ( select 1',
'                from dept',
'               where deptno = :P2_DEPTNO',
'                 and loc    = ''CHICAGO'' ) then ''YES''',
'else ''NO''',
'end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104626949892308940)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A08\7B97\30A2\30A4\30C6\30E0\306E\79FB\5165\306B\4F7F\7528\3055\308C\308B\5024\3092\751F\6210\3059\308BSQL\5F0F\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104626840318308940)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103873693457308303)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_STATEMENT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A08\7B97\30A2\30A4\30C6\30E0\3078\306E\79FB\5165\306B\4F7F\7528\3055\308C\308B\5024\3092\63D0\4F9B\3059\308BSQL\554F\5408\305B\3092\5165\529B\3057\307E\3059\3002\7D50\679C\306B\8907\6570\306E\884C\304C\542B\307E\308C\308B\5834\5408\3001\6700\521D\306E\884C\306E\5024\306E\307F\304C\8FD4\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103873562028308303)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_STATEMENT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103873422853308303)
,p_name=>'PE.PROPERTY.COMPUTATION_STATIC_VALUE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A08\7B97\30A2\30A4\30C6\30E0\306E\79FB\5165\306B\4F7F\7528\3055\308C\308B\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103873308277308303)
,p_name=>'PE.PROPERTY.COMPUTATION_STATIC_VALUE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\9759\7684\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103873206074308303)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\30EA\30B9\30C8\304B\3089\8A08\7B97\30BF\30A4\30D7\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104609371637308926)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104609456204308926)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F<em>\5F0F</em>\306E\5B9F\884C\7D50\679C\306E\5024\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104385528274308746)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104587976903308909)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F<em>\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53</em>\304B\3089\8FD4\3055\308C\305F\5024\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104385850874308746)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.ITEM_VALUE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104587660602308909)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.ITEM_VALUE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\306B\4FDD\6301\3055\308C\3066\3044\308B\5024\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104385610414308746)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.QUERY.D'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B(\5358\4E00\306E\5024\3092\8FD4\3059)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104587722133308909)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.QUERY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F<em>SQL\554F\5408\305B</em>\304B\3089\6700\521D\306B\8FD4\3055\308C\305F\5024\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104385796431308746)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.QUERY_COLON.D'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B(\30B3\30ED\30F3\533A\5207\308A\306E\5024\3092\8FD4\3059)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104587872423308909)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.QUERY_COLON.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F<em>SQL\554F\5408\305B</em>\304B\3089\8FD4\3055\308C\305F\5404\884C\306E\5024\3092\9023\7D50\3057\305F\3001\30B3\30ED\30F3\3067\533A\5207\3089\308C\305F1\3064\306E\5024\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104385956692308746)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.SET_ITEM_EQUAL_THIS_PREFERENCE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30EA\30D5\30A1\30EC\30F3\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104588034064308909)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.SET_ITEM_EQUAL_THIS_PREFERENCE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F<em>\30D7\30EA\30D5\30A1\30EC\30F3\30B9</em>\306E\5024\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104385441390308746)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.STATIC_ASSIGNMENT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\9759\7684\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104587514521308909)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.STATIC_ASSIGNMENT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<em>\300C\9759\7684\5024\300D</em>\306B\5165\529B\3055\308C\305F\30C6\30AD\30B9\30C8\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103873166746308303)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104234101781308635)
,p_name=>'PE.PROPERTY.COMPUTE_SUM.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\3053\306E\5217\306B\3064\3044\3066\3001\5408\8A08\3092\8A08\7B97\3057\3001\30EC\30DD\30FC\30C8\306E\672B\5C3E\306B\8868\793A\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002'),
unistr('\30D6\30EC\30FC\30AF\5217\3068\3068\3082\306B\4F7F\7528\3059\308B\3068\3001\7DCF\5408\8A08\304A\3088\3073\5404\30D6\30EC\30FC\30AF\3067\306E\5408\8A08\304C\8868\793A\3055\308C\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104234035103308634)
,p_name=>'PE.PROPERTY.COMPUTE_SUM.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5408\8A08\306E\8A08\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104618818316308934)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F\5F0F\306E\8A55\4FA1\306B\4F7F\7528\3055\308C\308B\8A00\8A9E\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104619299779308934)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'ja'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104619184185308934)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'ja'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104619027715308934)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'ja'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104619376523308934)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'ja'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104618933992308934)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'ja'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104618717047308934)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A00\8A9E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104620826860308935)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\306E\5B9F\884C\306B\4F7F\7528\3055\308C\308B\8A00\8A9E\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104621199576308936)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'ja'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104621097013308935)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'ja'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104620911560308935)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'ja'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104621258390308936)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'ja'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104620703975308935)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A00\8A9E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103906579926308332)
,p_name=>'PE.PROPERTY.CONDITION_ITEM1.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\3067\4F7F\7528\3055\308C\308B\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103906400883308332)
,p_name=>'PE.PROPERTY.CONDITION_ITEM1.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103907938669308333)
,p_name=>'PE.PROPERTY.CONDITION_ITEM2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\3067\4F7F\7528\3055\308C\308B\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103907831957308333)
,p_name=>'PE.PROPERTY.CONDITION_ITEM2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104620478220308935)
,p_name=>'PE.PROPERTY.CONDITION_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3059\308BJava\5F0F\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104620379044308935)
,p_name=>'PE.PROPERTY.CONDITION_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('Java\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104622055423308936)
,p_name=>'PE.PROPERTY.CONDITION_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3057\3066\30D6\30FC\30EB\5024\3092\8FD4\3059Java\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104621993442308936)
,p_name=>'PE.PROPERTY.CONDITION_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('Java\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104620217208308935)
,p_name=>'PE.PROPERTY.CONDITION_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3059\308B\304B\3001\30DE\30CD\30FC\30B8\30E3\3067\3042\308B\5834\5408\3001\6B63\5E38\306B\5024\3092\8FD4\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104620152013308935)
,p_name=>'PE.PROPERTY.CONDITION_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3059\308BJavaScript\5F0F\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104620062114308935)
,p_name=>'PE.PROPERTY.CONDITION_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('JavaScript\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104621863668308936)
,p_name=>'PE.PROPERTY.CONDITION_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3059\308B\5834\5408\3001\6B63\5E38\306B\5024\3092\8FD4\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104621798264308936)
,p_name=>'PE.PROPERTY.CONDITION_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3057\3066\30D6\30FC\30EB\5024\3092\8FD4\3059JavaScript\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104621695720308936)
,p_name=>'PE.PROPERTY.CONDITION_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('JavaScript\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103906786033308332)
,p_name=>'PE.PROPERTY.CONDITION_LIST.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3059\308B\30B3\30ED\30F3(:)\3067\533A\5207\3089\308C\305F\5024\306E\30EA\30B9\30C8\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103906605242308332)
,p_name=>'PE.PROPERTY.CONDITION_LIST.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103907110187308333)
,p_name=>'PE.PROPERTY.CONDITION_PAGE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3059\308B\30DA\30FC\30B8\756A\53F7\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103907015925308333)
,p_name=>'PE.PROPERTY.CONDITION_PAGE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103907313682308333)
,p_name=>'PE.PROPERTY.CONDITION_PAGES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3059\308B\30DA\30FC\30B8\756A\53F7\3092\30AB\30F3\30DE\3067\533A\5207\3063\3066\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103907280313308333)
,p_name=>'PE.PROPERTY.CONDITION_PAGES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104619971325308935)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3059\308B\304B\3001\30DE\30CD\30FC\30B8\30E3\3067\3042\308B\5834\5408\3001\6B63\5E38\306B\5024\3092\8FD4\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104619880628308935)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3059\308BPL/SQL\5F0F\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104619702017308934)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104621573063308936)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3059\308B\5834\5408\3001\6B63\5E38\306B\5024\3092\8FD4\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104621478362308936)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3057\3066\30D6\30FC\30EB\5024\3092\8FD4\3059PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104621393992308936)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103906908322308332)
,p_name=>'PE.PROPERTY.CONDITION_PREFERENCE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3057\3066\6307\5B9A\3055\308C\305F\5024\3068\6BD4\8F03\3059\308B\30E6\30FC\30B6\30FC\30FB\30D7\30EA\30D5\30A1\30EC\30F3\30B9\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103906876596308332)
,p_name=>'PE.PROPERTY.CONDITION_PREFERENCE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30EA\30D5\30A1\30EC\30F3\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104620689806308935)
,p_name=>'PE.PROPERTY.CONDITION_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3059\308BPython\5F0F\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104620542827308935)
,p_name=>'PE.PROPERTY.CONDITION_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('Python\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104622231427308936)
,p_name=>'PE.PROPERTY.CONDITION_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3057\3066\30D6\30FC\30EB\5024\3092\8FD4\3059Python\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104622144899308936)
,p_name=>'PE.PROPERTY.CONDITION_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('Python\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104619629152308934)
,p_name=>'PE.PROPERTY.CONDITION_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\30DE\30CD\30FC\30B8\30E3\3067\3001\90E8\9580\304C\30B7\30AB\30B4\306B\5B58\5728\3059\308B\5834\5408\3001\6B63\5E38\306B\5024\3092\8FD4\3057\307E\3059\3002</dt>'),
'<dd><pre>',
':P2_JOB = ''MANAGER'' and',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104619587092308934)
,p_name=>'PE.PROPERTY.CONDITION_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3059\308BSQL\5F0F\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104619458013308934)
,p_name=>'PE.PROPERTY.CONDITION_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104765440365309062)
,p_name=>'PE.PROPERTY.CONDITION_SQL_STATEMENT.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3057\3066\3044\308B\304B\3069\3046\304B\3092\30C1\30A7\30C3\30AF\3057\305F\3068\304D\306B\30011\3064\4EE5\4E0A\306E\884C\304C\5B58\5728\3059\308B\3068\3001\6B63\5E38\306B\5024\3092\8FD4\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
unistr('<dt>\5F93\696D\54E1\304C\90E8\958040\306B\6240\5C5E\3057\3066\3044\308B\304B\3069\3046\304B\3092\30C1\30A7\30C3\30AF\3057\305F\3068\304D\306B\30011\3064\3082\884C\304C\5B58\5728\3057\306A\3044\3068\3001\6B63\5E38\306B\5024\3092\8FD4\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 40',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103906161835308332)
,p_name=>'PE.PROPERTY.CONDITION_SQL_STATEMENT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3059\308BSQL\554F\5408\305B\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103906008797308332)
,p_name=>'PE.PROPERTY.CONDITION_SQL_STATEMENT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103907517717308333)
,p_name=>'PE.PROPERTY.CONDITION_TEXT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3059\308B\30C6\30AD\30B9\30C8\5024\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103907429230308333)
,p_name=>'PE.PROPERTY.CONDITION_TEXT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103908146682308333)
,p_name=>'PE.PROPERTY.CONDITION_TEXT2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3059\308B\5024(<code>&ITEM.</code>\7F6E\63DB\6587\5B57\5217\3092\542B\3080)\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103908023099308333)
,p_name=>'PE.PROPERTY.CONDITION_TEXT2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104281458005308668)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.COMPONENT_PROPERTY.DYNAMIC_ACTION_ACTION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30AF\30B7\30E7\30F3\3092\30A2\30AF\30C6\30A3\30D6\306B\3059\308B\305F\3081\306B\6E80\305F\3059\5FC5\8981\306E\3042\308B\6761\4EF6\30BF\30A4\30D7\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103909045960308334)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.COMPONENT_PROPERTY.DYNAMIC_ACTION_EVENT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\52D5\7684\30A2\30AF\30B7\30E7\30F3\3092\30A2\30AF\30C6\30A3\30D6\306B\3059\308B\305F\3081\306B\6E80\305F\3059\5FC5\8981\306E\3042\308B\6761\4EF6\30BF\30A4\30D7\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103905016870308331)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\3092\30EC\30F3\30C0\30EA\30F3\30B0\307E\305F\306F\51E6\7406\3059\308B\305F\3081\306B\5FC5\8981\306A\6761\4EF6\30BF\30A4\30D7\3092\9078\629E\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104463430076308805)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ALWAYS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5E38\6642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104601057816308919)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ALWAYS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306F\5E38\306B\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104462063899308804)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.BROWSER_IS_MSIE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30E9\30A4\30A2\30F3\30C8\306E\30D6\30E9\30A6\30B6\306FMicrosoft Internet Explorer 7.0\4EE5\4E0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104462131542308804)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.BROWSER_IS_MSIE_OR_NSCP.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30E9\30A4\30A2\30F3\30C8\30FB\30D6\30E9\30A6\30B6\306FXHTML / CSS\5BFE\5FDC\30D6\30E9\30A6\30B6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104461905233308803)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.BROWSER_IS_NSCP.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30E9\30A4\30A2\30F3\30C8\306E\30D6\30E9\30A6\30B6\306FMozilla\3001Netscape 6.x/7x\4EE5\4E0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104462236349308804)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.BROWSER_IS_OTHER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30E9\30A4\30A2\30F3\30C8\306E\30D6\30E9\30A6\30B6\306F\305D\306E\4ED6\306E\30D6\30E9\30A6\30B6(\307E\305F\306F\4EE5\524D\306E\30D0\30FC\30B8\30E7\30F3)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104460640870308803)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CONDITION1_IN_VALUE_OF_ITEM_IN_CONDITION2.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8\306F\30A2\30A4\30C6\30E0\306B\542B\307E\308C\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104462659919308804)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\8A00\8A9E = \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104604689509308922)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\3001\30E6\30FC\30B6\30FC\304C<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\8A00\8A9E\3067\73FE\5728\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\5B9F\884C\3057\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104462345479308804)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\8A00\8A9E\306F\5024\306B\542B\307E\308C\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104604830464308922)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\3001\30E6\30FC\30B6\30FC\304C<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\8A00\8A9E\306E\3044\305A\308C\304B\3067\73FE\5728\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\5B9F\884C\3057\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104462533261308804)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\8A00\8A9E != \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104604730419308922)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\3001\30E6\30FC\30B6\30FC\304C<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\8A00\8A9E\3067\73FE\5728\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\5B9F\884C\3057\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104462477812308804)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\8A00\8A9E\306F\5024\306B\542B\307E\308C\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104604907687308923)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\3001\30E6\30FC\30B6\30FC\304C<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\8A00\8A9E\306E\3044\305A\308C\304B\3067\73FE\5728\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\5B9F\884C\3057\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104459869367308802)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8 = \30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104603453405308921)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8\306F\3001<em>\300C\30DA\30FC\30B8\300D</em>\306B\5165\529B\3057\305F\5024\3068\7B49\3057\3044\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104460068977308802)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8\306F\30AB\30F3\30DE\3067\533A\5207\3089\308C\305F\30EA\30B9\30C8\306B\542B\307E\308C\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104603697829308922)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8\306F\3001<em>\300C\30DA\30FC\30B8\300D</em>\306B\5165\529B\3057\305F\30AB\30F3\30DE\533A\5207\308A\306E\30EA\30B9\30C8\306B\542B\307E\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104459963291308802)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8 != \30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104603519303308921)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8\306F\3001<em>\300C\30DA\30FC\30B8\300D</em>\306B\5165\529B\3057\305F\5024\3068\7B49\3057\304F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104460171431308802)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8\306F\30AB\30F3\30DE\3067\533A\5207\3089\308C\305F\30EA\30B9\30C8\306B\542B\307E\308C\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104603793806308922)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8\306F\3001<em>\300C\30DA\30FC\30B8\300D</em>\306B\5165\529B\3057\305F\30AB\30F3\30DE\533A\5207\308A\306E\30EA\30B9\30C8\306B\542B\307E\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104462793589308804)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DAD_NAME_EQ_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('CGI_ENV: DAD_NAME = \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104462898192308804)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DAD_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('CGI_ENV: DAD_NAME != \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104461542277308803)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30E9\30A4\30F3\691C\8A3C\30A8\30E9\30FC\3042\308A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104604461015308922)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306E\9001\4FE1\5F8C\3001\30A4\30F3\30E9\30A4\30F3\691C\8A3C\30A8\30E9\30FC\304C\30DA\30FC\30B8\306B\8868\793A\3055\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104460953629308803)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISPLAY_COND_EQUAL_COND_TEXT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8 = \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104460721211308803)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISPLAY_COND_IN_COND_TEXT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8\306F\5024\306B\542B\307E\308C\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104460867643308803)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISPLAY_COND_NOT_IN_COND_TEXT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8\306F\5024\306B\542B\307E\308C\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104461021083308803)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISP_COND_NOT_EQUAL_COND_TEXT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8 != \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104457560875308800)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.EXISTS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\304C\8FD4\3055\308C\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104601117522308920)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.EXISTS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B\306F1\3064\4EE5\4E0A\306E\884C\3092\8FD4\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104618575241308934)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104618690081308934)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5F0F\306FTRUE\3068\8A55\4FA1\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104457745905308800)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104601351083308920)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\306FTRUE\3092\8FD4\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104463194733308804)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.HTTP_HOST_EQ_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('CGI_ENV: HTTP_HOST = \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104463253838308804)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.HTTP_HOST_NOT_EQ_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('CGI_ENV: HTTP_HOST != \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104461204199308803)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8/\30EA\30FC\30B8\30E7\30F3\306F\8AAD\53D6\308A\5C02\7528\3067\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104604156802308922)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\304A\3088\3073\89AA\30EA\30FC\30B8\30E7\30F3(\8A72\5F53\3059\308B\5834\5408)\306F\6B63\5E38\306B\8868\793A\3055\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104461190306308803)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.IS_READ_ONLY.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8/\30EA\30FC\30B8\30E7\30F3\306F\8AAD\53D6\308A\5C02\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104604010137308922)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.IS_READ_ONLY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\307E\305F\306F\89AA\30EA\30FC\30B8\30E7\30F3(\8A72\5F53\3059\308B\5834\5408)\306E\300C\8AAD\53D6\308A\5C02\7528\300D\6761\4EF6\306FTRUE\3068\8A55\4FA1\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104459056001308801)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306B\7A7A\767D\304C\542B\307E\308C\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104602676348308921)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F\7A7A\767D\3092\542B\307F\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104459350823308802)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306F\82F1\6570\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104602920620308921)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F\82F1\6570\5B57\3067\3001\6587\5B57\307E\305F\306F\6570\5B57\306E\307F\3092\542B\307F\3001\7279\6B8A\6587\5B57\3092\542B\307F\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104458524653308801)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306FNULL\3067\306F\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104602120187308920)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F\7A7A\3067\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104459275416308802)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306F\6570\5B57\3067\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104602883522308921)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F\6570\5B57\3067\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104458776261308801)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306F0(\30BC\30ED)\3067\306F\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104602394973308921)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F0(\30BC\30ED)\3067\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104458436733308801)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NULL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306FNULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104602022369308920)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NULL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F\7A7A\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104458853517308801)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306FNULL\307E\305F\306F0(\30BC\30ED)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104602490842308921)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F\7A7A\307E\305F\306F0(\30BC\30ED)\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104459126103308801)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306F\6570\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104602737986308921)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F\6570\5B57\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104458663883308801)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_ZERO.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306F0(\30BC\30ED)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104602223951308920)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_ZERO.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F0(\30BC\30ED)\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104458910319308801)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306FNULL\3067\306A\304F\30010(\30BC\30ED)\3067\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104602553414308921)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F\7A7A\3067\306F\306A\304F\30010(\30BC\30ED)\3067\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104461735269308803)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.MAX_ROWS_LT_ROWS_FETCHED.D'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\30EC\30DD\30FC\30C8(\300COK\300D\3092\30AF\30EA\30C3\30AF\3059\308B\3068\300C\9032\3080\300D\30DC\30BF\30F3\3092\8868\793A)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104461803917308803)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.MIN_ROW_GT_THAN_ONE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\30EC\30DD\30FC\30C8(\300COK\300D\3092\30AF\30EA\30C3\30AF\3059\308B\3068\300C\623B\308B\300D\30DC\30BF\30F3\3092\8868\793A)')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104463315546308804)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NEVER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104605059067308923)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NEVER.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306F\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\307E\305B\3093\3002</p>'),
unistr('<p>\30CE\30FC\30C8: \6761\4EF6\3092<strong>\300C\306A\3057\300D</strong>\306B\5909\66F4\3059\308B\3068\3001\65E2\5B58\306E\6761\4EF6\304C\524A\9664\3055\308C\307E\3059\3002\30B3\30F3\30DD\30FC\30CD\30F3\30C8\3092\4E00\6642\7684\306B\7121\52B9\306B\3059\308B\306B\306F\3001\304B\308F\308A\306B<em>\300C\30D3\30EB\30C9\30FB\30AA\30D7\30B7\30E7\30F3\300D</em>\5C5E\6027\3092\4F7F\7528\3059\308B\3053\3068\3092\304A\85A6\3081\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104461695335308803)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30E9\30A4\30F3\691C\8A3C\30A8\30E9\30FC\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104604588875308922)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30E9\30A4\30F3\691C\8A3C\30A8\30E9\30FC\306F\30DA\30FC\30B8\306B\8868\793A\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104457602502308800)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NOT_EXISTS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\304C\8FD4\3055\308C\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104601257812308920)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B\306F\884C\3092\8FD4\3057\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104460415748308802)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8\306F\300C\5370\5237\7528\300D\30E2\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104603830997308922)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8\306F\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\3088\3063\3066\300C\5370\5237\7528\300D\30E2\30FC\30C9\306B\5207\308A\66FF\3048\3089\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104460571225308802)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30EC\30F3\30C8\30FB\30DA\30FC\30B8\306F\300C\5370\5237\7528\300D\30E2\30FC\30C9\3067\306F\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104603937959308922)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8\306F\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\3088\3063\3066\300C\5370\5237\7528\300D\30E2\30FC\30C9\306B\5207\308A\66FF\3048\3089\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104457875520308800)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30AF\30A8\30B9\30C8 = \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104601429221308920)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30EA\30AF\30A8\30B9\30C8\306F\3001<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\3068\7B49\3057\3044\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104458074681308801)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30AF\30A8\30B9\30C8\306F\5024\306B\542B\307E\308C\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104601653418308920)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30EA\30AF\30A8\30B9\30C8\306F\3001<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\306B\542B\307E\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104457929072308801)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30AF\30A8\30B9\30C8 != \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104601513809308920)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30EA\30AF\30A8\30B9\30C8\306F\3001<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\3068\7B49\3057\304F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104458144801308801)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30AF\30A8\30B9\30C8\306F\5024\306B\542B\307E\308C\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104601799884308920)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30EA\30AF\30A8\30B9\30C8\306F\3001<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\306B\542B\307E\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104462953909308804)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.SERVER_NAME_EQ_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('CGI_ENV: SERVER_NAME = \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104463053774308804)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.SERVER_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('CGI_ENV: SERVER_NAME != \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104461300833308803)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\6E08\30E6\30FC\30B6\30FC(\975E\30D1\30D6\30EA\30C3\30AF\30FB\30E6\30FC\30B6\30FC)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104604275951308922)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\30ED\30B0\30A4\30F3\3057\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104461423972308803)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30D6\30EA\30C3\30AF\30FB\30E6\30FC\30B6\30FC(\8A8D\8A3C\3055\308C\3066\3044\306A\3044\30E6\30FC\30B6\30FC)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104604333328308922)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\30ED\30B0\30A4\30F3\3057\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104459606811308802)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\30FB\30D7\30EA\30D5\30A1\30EC\30F3\30B9 = \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104603298611308921)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F<em>\30D7\30EA\30D5\30A1\30EC\30F3\30B9</em>\306E\5024\306F\3001<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\3068\7B49\3057\3044\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104459747512308802)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\30FB\30D7\30EA\30D5\30A1\30EC\30F3\30B9 != \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104603351166308921)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F<em>\30D7\30EA\30D5\30A1\30EC\30F3\30B9</em>\306E\5024\306F\3001<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\3068\7B49\3057\304F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104459446070308802)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306F\30B3\30ED\30F3\3067\533A\5207\3089\308C\305F\30EA\30B9\30C8\306B\542B\307E\308C\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104603097806308921)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F\3001<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\306B\5B8C\5168\306B\542B\307E\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104459590506308802)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306F\30B3\30ED\30F3\3067\533A\5207\3089\308C\305F\30EA\30B9\30C8\306B\542B\307E\308C\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104603134850308921)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F\3001<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\306B\5B8C\5168\306B\306F\542B\307E\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104458250843308801)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0 = \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104601869333308920)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F\3001<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\3068\7B49\3057\3044\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104458304833308801)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0 != \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104601965004308920)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F\3001<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\3068\7B49\3057\304F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104460333100308802)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.WHEN_THIS_PAGE_NOT_SUBMITTED.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8 != \9001\4FE1\30DA\30FC\30B8(\30DD\30B9\30C8\6E08)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104460220810308802)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.WHEN_THIS_PAGE_SUBMITTED.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8 = \9001\4FE1\30DA\30FC\30B8(\30DD\30B9\30C8\6E08)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103904922848308331)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103906305290308332)
,p_name=>'PE.PROPERTY.CONDITION_VALUE1.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\6761\4EF6\3068\6BD4\8F03\3059\308B\5024\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103906291832308332)
,p_name=>'PE.PROPERTY.CONDITION_VALUE1.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103907790340308333)
,p_name=>'PE.PROPERTY.CONDITION_VALUE2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3059\308B\5024(<code>&ITEM.</code>\7F6E\63DB\6587\5B57\5217\3092\542B\3080)\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103907658300308333)
,p_name=>'PE.PROPERTY.CONDITION_VALUE2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103777367423308229)
,p_name=>'PE.PROPERTY.CONFIRM_ENABLED.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\78BA\8A8D\30D7\30ED\30F3\30D7\30C8\3067\30DC\30BF\30F3\306E\52D5\4F5C\3092\4FDD\8B77\3057\307E\3059\3002\30DC\30BF\30F3\304C\30AF\30EA\30C3\30AF\3055\308C\308B\3068\3001\78BA\8A8D\30C0\30A4\30A2\30ED\30B0\304C\8868\793A\3055\308C\3001\30E6\30FC\30B6\30FC\306E\78BA\8A8D\5F8C\306B\30DC\30BF\30F3\3067\305D\306E\30A2\30AF\30B7\30E7\30F3\304C\5B9F\884C\3055\308C\307E\3059\3002</p>'),
unistr('<p>\3053\306E\6A5F\80FD\3092\4F7F\7528\3059\308B\3068\3001\30EC\30B3\30FC\30C9\306E\524A\9664\306A\3069\3001\30E6\30FC\30B6\30FC\304C\8AA4\3063\3066\91CD\8981\306A\30A2\30AF\30B7\30E7\30F3\3092\5B9F\884C\3057\306A\3044\3088\3046\306B\3059\308B\3053\3068\304C\3067\304D\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8: \30C0\30A4\30A2\30ED\30B0\306E\78BA\8A8D\30DC\30BF\30F3\306E\30E9\30D9\30EB\306F\3001\30E1\30A4\30F3\30FB\30DC\30BF\30F3\306E\30E9\30D9\30EB\304B\3089\5C0E\51FA\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103777294748308229)
,p_name=>'PE.PROPERTY.CONFIRM_ENABLED.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\78BA\8A8D\306E\8981\6C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103777668081308229)
,p_name=>'PE.PROPERTY.CONFIRM_MESSAGE.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>'<pre>&lt;strong&gt;Are you sure&lt;&#x2F;strong&gt; you wish to delete employee &amp;P1_ENAME.?</pre>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103777579679308229)
,p_name=>'PE.PROPERTY.CONFIRM_MESSAGE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\78BA\8A8D\30C0\30A4\30A2\30ED\30B0\306B\8868\793A\3055\308C\308B\30E1\30C3\30BB\30FC\30B8\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103777477009308229)
,p_name=>'PE.PROPERTY.CONFIRM_MESSAGE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E1\30C3\30BB\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103778328301308230)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.COMPONENT_PROPERTY.BUTTON.NULL_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103777872795308230)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C0\30A4\30A2\30ED\30B0\306E\30B9\30BF\30A4\30EB\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103778139535308230)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.LOV.DANGER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5371\967A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103777930614308230)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.LOV.INFORMATION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\60C5\5831')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103778205304308230)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.LOV.SUCCESS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6210\529F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103778000466308230)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.LOV.WARNING.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\8B66\544A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103777729661308230)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30BF\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104240230776308639)
,p_name=>'PE.PROPERTY.CONTENT_DISPOSITION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F7F\7528\53EF\80FD\306A\30EA\30B9\30C8\304B\3089\30B3\30F3\30C6\30F3\30C4\914D\7F6E\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104419154655308771)
,p_name=>'PE.PROPERTY.CONTENT_DISPOSITION.LOV.ATTACHMENT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6DFB\4ED8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104419276723308772)
,p_name=>'PE.PROPERTY.CONTENT_DISPOSITION.LOV.INLINE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30E9\30A4\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104240182711308639)
,p_name=>'PE.PROPERTY.CONTENT_DISPOSITION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30C6\30F3\30C4\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103965485617308409)
,p_name=>'PE.PROPERTY.COOKIE_DOMAIN.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30BB\30C3\30B7\30E7\30F3Cookie\306EURL\30C9\30E1\30A4\30F3\5C5E\6027\3092\5165\529B\3057\307E\3059\3002'),
unistr('\30EA\30AF\30A8\30B9\30C8URL\306E\672B\5C3E\6BD4\8F03\304C\6307\5B9A\3055\308C\305F\30C9\30E1\30A4\30F3\306B\4E00\81F4\3057\306A\3044\5834\5408\3001Cookie\306F\30D6\30E9\30A6\30B6\306B\9001\4FE1\3055\308C\307E\305B\3093\3002'),
unistr('\30C7\30D5\30A9\30EB\30C8\5024\306F\3001\30EA\30AF\30A8\30B9\30C8URL\306E\30DB\30B9\30C8\540D\3067\3059\3002</p>'),
unistr('<p>\5171\901A\306E\30C9\30E1\30A4\30F3\3092\6301\3064\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\9593\3067\30BB\30C3\30B7\30E7\30F3Cookie\3092\5171\6709\3059\308B\5834\5408\3001\3053\306E\5C5E\6027\3092\4F7F\7528\3057\3066\3088\308A\5236\9650\7684\3067\306A\3044\30C9\30E1\30A4\30F3\3092\6307\5B9A\3057\307E\3059\3002'),
unistr('\305F\3068\3048\3070\3001<code>yahoo.com</code>\3068\3044\3046\30C9\30E1\30A4\30F3\3092\5165\529B\3059\308B\3068\3001<code>my.yahoo.com</code>\3001<code>sport.yahoo.com</code>\304A\3088\3073<code>finance.yahoo.com</code>\306E\3059\3079\3066\3067\540C\3058Cookie\306B\30A2\30AF\30BB\30B9\3067\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103965378944308409)
,p_name=>'PE.PROPERTY.COOKIE_DOMAIN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('Cookie\30C9\30E1\30A4\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103965010899308409)
,p_name=>'PE.PROPERTY.COOKIE_NAME.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>URL\5185\306E\30BB\30C3\30B7\30E7\30F3ID\3068\3068\3082\306B\4F7F\7528\3057\3066&PRODUCT_NAME.\30BB\30C3\30B7\30E7\30F3\3092\8B58\5225\3059\308B\305F\3081\306B\5FC5\8981\306A\30BB\30C3\30B7\30E7\30F3Cookie\306E\540D\524D\3092\5165\529B\3057\307E\3059\3002'),
unistr('\30BB\30C3\30B7\30E7\30F3Cookie\540D\3092\6307\5B9A\3057\306A\3044\5834\5408\3001&PRODUCT_NAME.\306F\30C7\30D5\30A9\30EB\30C8\5024\3092\4F7F\7528\3057\307E\3059\3002</p>'),
unistr('<p>\8907\6570\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\540C\3058Cookie\540D\3092\5165\529B\3059\308B\3068\3001\5404\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\540C\3058\30BB\30C3\30B7\30E7\30F3Cookie\304C\4F7F\7528\3055\308C\307E\3059\3002'),
unistr('\3057\305F\304C\3063\3066\3001\540C\3058Cookie\540D\3092\4F7F\7528\3059\308B&PRODUCT_NAME.\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304B\3089\5225\306E&PRODUCT_NAME.\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3078\306EURL\30B3\30FC\30EB\3067\306F\3001\65B0\3057\3044\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\65E2\5B58\306E\30BB\30C3\30B7\30E7\30F3Cookie\3092\5229\7528\3067\304D\308B\305F\3081\3001\30E6\30FC\30B6\30FC\306E\518D\8A8D\8A3C\306F\5FC5\8981\3042\308A\307E\305B\3093\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103964942882308409)
,p_name=>'PE.PROPERTY.COOKIE_NAME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('Cookie\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103965278148308409)
,p_name=>'PE.PROPERTY.COOKIE_PATH.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30BB\30C3\30B7\30E7\30F3Cookie\306EURL\30D1\30B9\5C5E\6027\3092\5165\529B\3057\307E\3059\3002'),
unistr('\30EA\30AF\30A8\30B9\30C8URL\306E\5148\982D\304C\6307\5B9A\3055\308C\305F\30D1\30B9\306B\4E00\81F4\3057\306A\3044\5834\5408\3001Cookie\306F\30D6\30E9\30A6\30B6\306B\9001\4FE1\3055\308C\307E\305B\3093\3002'),
unistr('\30C7\30D5\30A9\30EB\30C8\5024\306F\3001\30EA\30AF\30A8\30B9\30C8URL\306E\30D1\30B9\3067\3059\3002</p>'),
unistr('<p>\5143\3005\4E00\81F4\3059\308BURL\30D1\30B9\3092\6301\3064\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\9593\3067\30BB\30C3\30B7\30E7\30F3Cookie\3092\5171\6709\3059\308B\5834\5408\3001\3053\306E\5C5E\6027\3092\4F7F\7528\3057\3066\3088\308A\5236\9650\7684\3067\306A\3044\30D1\30B9\3092\6307\5B9A\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103965148048308409)
,p_name=>'PE.PROPERTY.COOKIE_PATH.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('Cookie\30D1\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104385248891308746)
,p_name=>'PE.PROPERTY.CSS_FILE_URLS.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\6A19\6E96\30D5\30A1\30A4\30EB\53C2\7167</dt>'),
'<dd><pre>/mycss/main.css</pre></dd>',
unistr('<dt>\901A\5E38\30DA\30FC\30B8\30FB\30D3\30E5\30FC\306E\5834\5408\306F\7E2E\5C0F\30D5\30A1\30A4\30EBmain.min.css\3092/mycss/minified/\304B\3089\30ED\30FC\30C9\3057\3001\30C7\30D0\30C3\30B0\30FB\30E2\30FC\30C9\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30D3\30EB\30C0\30FC\304B\3089\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5B9F\884C\6642\306B\306Fmain.css\3092/mycss/\304B\3089\30ED\30FC\30C9\3059\308B\6A19\6E96\30D5\30A1\30A4\30EB\53C2\7167\3002</dt>'),
'<dd><pre>/mycss/#MIN_DIRECTORY#main#MIN#.css</pre></dd>',
unistr('<dt>\6761\4EF6\4ED8\304D\30E1\30C7\30A3\30A2\554F\5408\305B</dt>'),
'<dd><pre>[media="only screen and (max-device-width: 480px)"]/mycss/smartphone.css</pre></dd>',
unistr('<dt>URL\306B\554F\5408\305B\6587\5B57\5217\3092\4F7F\7528\3057\3066\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30D0\30FC\30B8\30E7\30F3\3092\53C2\7167\3059\308B\30D5\30A1\30A4\30EB\53C2\7167\3002\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304C\30A2\30C3\30D7\30B0\30EC\30FC\30C9\3055\308C\305F(\30D0\30FC\30B8\30E7\30F3\304C\4E0A\304C\3063\305F)\3068\304D\306A\3069\3001\65B0\898F\30D5\30A1\30A4\30EB\3092\5E38\306B\30ED\30FC\30C9\3057\3001\4EE5\524D\306B\30AD\30E3\30C3\30B7\30E5\3055\308C\305F\30D5\30A1\30A4\30EB\3092\7121\8996\3059\308B\3088\3046\30D6\30E9\30A6\30B6\306B\6307\793A\3057\307E\3059\3002</dt>'),
'<dd><pre>/mycss/main.css?version=#APP_VERSION#</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103871895717308302)
,p_name=>'PE.PROPERTY.CSS_FILE_URLS.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30DA\30FC\30B8\3067\30ED\30FC\30C9\3059\308B\30AB\30B9\30B1\30FC\30C7\30A3\30F3\30B0\30FB\30B9\30BF\30A4\30EB\30B7\30FC\30C8(CSS)\30D5\30A1\30A4\30EB\306EURL\3092\5165\529B\3057\307E\3059\3002URL\3054\3068\306B\65B0\3057\3044\884C\306B\8A18\8FF0\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002'),
unistr('\30D5\30A1\30A4\30EB\306E\7E2E\5C0F\30D0\30FC\30B8\30E7\30F3\3092\6307\5B9A\3059\308B\5834\5408\3001\7F6E\63DB\6587\5B57\5217<code>#MIN#</code>\3092\4F7F\7528\3057\3066<code>.min</code>\307E\305F\306F<code>#MIN_DIRECTORY#</code>\3092\542B\3081\3001\901A\5E38\30DA\30FC\30B8\30FB\30D3\30E5\30FC\306E\30D5\30A1\30A4\30EBURL\306B<code>minified/</code>\3092\542B\3081\305F\308A\3001\30DA\30FC\30B8\3092\30C7\30D0\30C3\30B0\30FB\30E2\30FC\30C9\3067\8868\793A\3059\308B\5834\5408\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30D3\30EB\30C0\30FC\304B\3089\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5B9F\884C\6642\306B\8868\793A\3059\308B\5834\5408\306F\7A7A\306E\6587\5B57\5217\3092\542B\3081\305F\308A\3059\308B\3053\3068\304C\3067\304D\307E\3059\3002'),
unistr('\30D5\30A1\30A4\30EBURL\306B\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30D0\30FC\30B8\30E7\30F3\3092\542B\3081\308B\5834\5408\3001\7F6E\63DB\6587\5B57\5217<code>#APP_VERSION#</code>\3082\4F7F\7528\3057\307E\3059\3002</p>'),
unistr('<p>\3053\3053\3067\5165\529B\3057\305F\30D5\30A1\30A4\30EBURL\3067\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306E<code>#PAGE_CSS#</code>\7F6E\63DB\6587\5B57\5217\304C\7F6E\63DB\3055\308C\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8: \958B\59CB\304A\3088\3073\7D42\4E86\306E<code>link</code>\30BF\30B0\3092\542B\3081\308B\5FC5\8981\306F\3042\308A\307E\305B\3093\3002\30D5\30A1\30A4\30EBURL\3092\542B\3081\308B\306E\307F\3067\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103871786695308302)
,p_name=>'PE.PROPERTY.CSS_FILE_URLS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EBURL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104418029826308771)
,p_name=>'PE.PROPERTY.CSS_STYLE.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\3053\306E\5C5E\6027\3092<code>color:#FF0000;</code>\306B\8A2D\5B9A\3059\308B\3053\3068\306B\3088\3063\3066\5217\306E\30C6\30AD\30B9\30C8\306E\8272\3092\8D64\306B\5909\66F4\3057\3001\6B21\306EHTML\3092\751F\6210</dt>'),
'<dd><pre>',
'&lt;span style="color:#FF0000"&gt;Sample Data&lt;/span&gt;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104235541060308636)
,p_name=>'PE.PROPERTY.CSS_STYLE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\5217\306E\5024\306B\9069\7528\3059\308BCSS\30B9\30BF\30A4\30EB\3092\5165\529B\3057\307E\3059\3002CSS\30B9\30BF\30A4\30EB\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104235446235308635)
,p_name=>'PE.PROPERTY.CSS_STYLE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('CSS\30B9\30BF\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104208522349308616)
,p_name=>'PE.PROPERTY.CSV_ENCLOSED_BY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\5024\306E\958B\59CB\5883\754C\304A\3088\3073\7D42\4E86\5883\754C\3092\533A\5207\308B\30C7\30EA\30DF\30BF\6587\5B57\3092\5165\529B\3057\307E\3059\3002\30C7\30D5\30A9\30EB\30C8\306E\30C7\30EA\30DF\30BF\306F\4E8C\91CD\5F15\7528\7B26\3067\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104208468247308616)
,p_name=>'PE.PROPERTY.CSV_ENCLOSED_BY.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('CSV\56F2\307F\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104243412623308641)
,p_name=>'PE.PROPERTY.CSV_EXPORT_ENABLED.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\30EC\30DD\30FC\30C8\30FB\30B3\30F3\30C6\30F3\30C4\3092CSV\30D5\30A1\30A4\30EB\306B\30C0\30A6\30F3\30ED\30FC\30C9\3067\304D\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002<em>CSV\30C0\30A6\30F3\30ED\30FC\30C9</em>\3092\6709\52B9\306B\3059\308B\306B\306F\3001<code>#CSV_LINK#</code>\7F6E\63DB\6587\5B57\5217\3092\6301\3064\30EC\30DD\30FC\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\4F7F\7528\3057\3001\3053\306E\30AA\30D7\30B7\30E7\30F3\3092<strong>\300C\30AA\30F3\300D</strong>\306B\8A2D\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104243333337308641)
,p_name=>'PE.PROPERTY.CSV_EXPORT_ENABLED.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('CSV\30A8\30AF\30B9\30DD\30FC\30C8\306E\6709\52B9\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104208343732308616)
,p_name=>'PE.PROPERTY.CSV_SEPARATOR.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\30BB\30D1\30EC\30FC\30BF\3092\5165\529B\3057\307E\3059\3002\5024\3092\5165\529B\3057\306A\3044\3068\3001\73FE\5728\306ENLS\8A2D\5B9A\306B\5FDC\3058\3066\30AB\30F3\30DE\307E\305F\306F\30BB\30DF\30B3\30ED\30F3\304C\4F7F\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104208219268308616)
,p_name=>'PE.PROPERTY.CSV_SEPARATOR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('CSV\30BB\30D1\30EC\30FC\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103876363949308305)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\521D\3081\3066\30DA\30FC\30B8\3092\8868\793A\3057\305F\3068\304D\306B\30AB\30FC\30BD\30EB\304C\30D5\30A9\30FC\30AB\30B9\3055\308C\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104378833369308740)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.LOV.AUTO_FIRST_ITEM.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306E\6700\521D\306E\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104378953952308741)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.LOV.AUTO_FIRST_ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30FC\30BD\30EB\30FB\30D5\30A9\30FC\30AB\30B9\306F\3001&PRODUCT_NAME.\30A8\30F3\30B8\30F3\306B\3088\3063\3066\751F\6210\3055\308C\3001JavaScript\3092\4F7F\7528\3057\305F\30DA\30FC\30B8\306E\6700\521D\306E\30D5\30A3\30FC\30EB\30C9\306B\7F6E\304B\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104379047494308741)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.LOV.NO_FIRST_ITEM.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30FC\30AB\30B9\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104379159233308741)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.LOV.NO_FIRST_ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30AB\30FC\30BD\30EB\306F\30D5\30A9\30FC\30AB\30B9\3055\308C\305A\3001JavaScript\306F\751F\6210\3055\308C\307E\305B\3093\3002<br>'),
unistr('\751F\6210\3055\308C\308BJavaScript\304C\30AB\30B9\30BF\30E0JavaScript\3068\7AF6\5408\3059\308B\5834\5408\3001\3053\306E\30AA\30D7\30B7\30E7\30F3\3092\9078\629E\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103870971744308301)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30FC\30BD\30EB\30FB\30D5\30A9\30FC\30AB\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103969012889308412)
,p_name=>'PE.PROPERTY.CUSTOMIZABLE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30EA\30FC\30B8\30E7\30F3\306E\8868\793A\5C5E\6027\3092\30E6\30FC\30B6\30FC\304C\30AB\30B9\30BF\30DE\30A4\30BA\3067\304D\308B\304B\3069\3046\304B\3092\9078\629E\3057\3066\304F\3060\3055\3044\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104399872964308757)
,p_name=>'PE.PROPERTY.CUSTOMIZABLE.LOV.0.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30E6\30FC\30B6\30FC\3067\306F\30AB\30B9\30BF\30DE\30A4\30BA\4E0D\53EF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104399772704308757)
,p_name=>'PE.PROPERTY.CUSTOMIZABLE.LOV.1.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\3067\30AB\30B9\30BF\30DE\30A4\30BA\53EF\80FD\304A\3088\3073\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104399686520308757)
,p_name=>'PE.PROPERTY.CUSTOMIZABLE.LOV.2.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\3067\30AB\30B9\30BF\30DE\30A4\30BA\53EF\80FD\304A\3088\3073\975E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103968983497308412)
,p_name=>'PE.PROPERTY.CUSTOMIZABLE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30B9\30BF\30DE\30A4\30BA\53EF\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103968076025308411)
,p_name=>'PE.PROPERTY.CUSTOMIZED_OPTION_NAME.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\3053\306E\30EA\30FC\30B8\30E7\30F3\306E\4E0B\306B\8868\793A\3055\308C\308B\3001\30EA\30FC\30B8\30E7\30F3\30FB\30AB\30B9\30BF\30DE\30A4\30BA\30FB\30DA\30FC\30B8\3078\306E\30A2\30AF\30BB\30B9\3092\63D0\4F9B\3059\308B\30EA\30F3\30AF\306E\30E9\30D9\30EB\3092\5165\529B\3057\307E\3059\3002'),
unistr('\3053\306E\30E9\30D9\30EB\306F\3001\30AB\30B9\30BF\30DE\30A4\30BA\53EF\80FD\306A\30EA\30FC\30B8\30E7\30F3\306B\5BFE\3057\3066\306E\307F\8868\793A\3055\308C\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103967943777308411)
,p_name=>'PE.PROPERTY.CUSTOMIZED_OPTION_NAME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\540D\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104273571642308663)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.BUTTON.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\3053\306E\30DC\30BF\30F3\7528\306B\542B\3081\308BHTML\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002'),
'<ul>',
unistr('  <li><strong>HTML\30DC\30BF\30F3</strong>\30FB\30BF\30A4\30D7\306E\30DC\30BF\30F3\306E\5834\5408\3001\3053\306E\30C6\30AD\30B9\30C8\306FHTML\8981\7D20\5B9A\7FA9\306B\8FFD\52A0\3055\308C\307E\3059\3002</li>'),
unistr('  <li>\30C6\30F3\30D7\30EC\30FC\30C8\306B\57FA\3065\3044\305F\30DC\30BF\30F3\306E\5834\5408\3001\30C6\30F3\30D7\30EC\30FC\30C8\306B<code>#BUTTON_ATTRIBUTES#</code>\7F6E\63DB\6587\5B57\5217\304C\542B\307E\308C\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</li>'),
'</ul>',
unistr('<p>\3053\306E\5C5E\6027\3092\4F7F\7528\3057\3066\3001\30BF\30D6\30FB\30B9\30C8\30C3\30D7\3092\5236\5FA1\3067\304D\307E\3059</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104273746098308663)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.CLASSIC_REPORT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\7F6E\63DB\6587\5B57\5217<code>#REPORT_ATTRIBUTES#</code>\304C\3001\3053\306E\5024\3067\7F6E\63DB\3055\308C\307E\3059\3002\7F6E\63DB\6587\5B57\5217<code>#REPORT_ATTRIBUTES#</code>\306F\3001\30EC\30DD\30FC\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306E\300C\884C\306E\524D\300D\5C5E\6027\3067\306E\307F\7F6E\63DB\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104113682305308528)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30FC\30E0\8981\7D20\306EHTML\30BF\30B0\306B\542B\3081\308B\8FFD\52A0\306E\5C5E\6027\3092\5165\529B\3057\307E\3059\3002<code>size</code>\304A\3088\3073<code>id</code> HTML\5C5E\6027\306F\751F\6210\3055\308C\308B\305F\3081\3001\6307\5B9A\3059\308B\5FC5\8981\306F\3042\308A\307E\305B\3093\3002<code>class</code> HTML\5C5E\6027\306E\5834\5408\3001\304B\308F\308A\306B\5C02\7528\306E<em>\300CCSS\30AF\30E9\30B9\300D</em>\5C5E\6027\3092\4F7F\7528\3059\308B\3053\3068\3092\304A\85A6\3081\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104273436954308663)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30FC\30E0\8981\7D20\306EHTML\30BF\30B0\306B\542B\3081\308B\8FFD\52A0\306E\5C5E\6027\3092\5165\529B\3057\307E\3059\3002<code>size</code>\304A\3088\3073<code>id</code> HTML\5C5E\6027\306F\751F\6210\3055\308C\308B\305F\3081\3001\6307\5B9A\3059\308B\5FC5\8981\306F\3042\308A\307E\305B\3093\3002<code>class</code> HTML\5C5E\6027\306E\5834\5408\3001\304B\308F\308A\306B\5C02\7528\306E<em>\300CCSS\30AF\30E9\30B9\300D</em>\5C5E\6027\3092\4F7F\7528\3059\308B\3053\3068\3092\304A\85A6\3081\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104273663434308663)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\5C5E\6027\306B\7F6E\63DB\3055\308C\308B\5024\3092\5165\529B\3057\307E\3059\3002\7F6E\63DB\6587\5B57\5217<code>#REGION_ATTRIBUTES#</code>\3092\542B\3080\30EA\30FC\30B8\30E7\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8\304C\3001\3053\306E\5024\3067\7F6E\63DB\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104273877531308663)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.TABULAR_FORM.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\7F6E\63DB\6587\5B57\5217<code>#REPORT_ATTRIBUTES#</code>\304C\3001\3053\306E\5024\3067\7F6E\63DB\3055\308C\307E\3059\3002\7F6E\63DB\6587\5B57\5217<code>#REPORT_ATTRIBUTES#</code>\306F\3001\30EC\30DD\30FC\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306E\300C\884C\306E\524D\300D\5C5E\6027\3067\306E\307F\7F6E\63DB\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104273366909308663)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30A2\30A4\30C6\30E0\30FB\30BF\30B0\306B\542B\3081\308B\8FFD\52A0\5C5E\6027\3092\7A7A\767D\3067\533A\5207\3063\3066\5165\529B\3057\307E\3059\3002'),
unistr('HTML CLASS\5C5E\6027\306E\5834\5408\3001\5C02\7528\306E\300CCSS\30AF\30E9\30B9\300D\5C5E\6027\3092\4F7F\7528\3059\308B\3053\3068\3092\304A\85A6\3081\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104273202280308663)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30B9\30BF\30E0\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104184677663308597)
,p_name=>'PE.PROPERTY.CUSTOM_COLUMN_NAME.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30B9\30BF\30E0\30FB\30C4\30FC\30EB\30C1\30C3\30D7\3092\5B9A\7FA9\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\30AB\30B9\30BF\30E0\5217\540D\3001\307E\305F\306F\30C1\30E3\30FC\30C8\8981\7D20\306B\4F7F\7528\3055\308C\308B\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30D9\30FC\30B9\306E\30AB\30E9\30FC\3092\6307\5B9A\3057\307E\3059\3002\30DC\30C3\30AF\30B9\30FB\30D7\30ED\30C3\30C8\30FB\30C1\30E3\30FC\30C8\306E\5834\5408\3001\5217\306F\3001\9078\629E\3057\305F\5024\5217\30DE\30C3\30D4\30F3\30B0\3068\4E00\81F4\3057\306A\3044\3088\3046\306B\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\5024\5217\30DE\30C3\30D4\30F3\30B0\3068\4E00\81F4\3059\308B\5217\3092\9078\629E\3059\308B\3068\3001\30AB\30B9\30BF\30E0\5217\304C\30C1\30E3\30FC\30C8\3067\4F7F\7528\3055\308C\306A\304F\306A\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104184561987308596)
,p_name=>'PE.PROPERTY.CUSTOM_COLUMN_NAME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30B9\30BF\30E0\5217 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103874897248308304)
,p_name=>'PE.PROPERTY.CUSTOM_EVENT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\6307\5B9A\3057\305F\5BA3\8A00\7684\30A4\30D9\30F3\30C8\304C\4E0D\5341\5206\306A\5834\5408\3001\30AB\30B9\30BF\30E0\306EJavaScript\30A4\30D9\30F3\30C8\540D\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103874749911308304)
,p_name=>'PE.PROPERTY.CUSTOM_EVENT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30B9\30BF\30E0\30FB\30A4\30D9\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104191315556308602)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\64CD\4F5C\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104191819920308603)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.LOV.DELETE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\306E\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104191457036308602)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.LOV.FETCH_COLLECTION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\306E\30D5\30A7\30C3\30C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104191545129308603)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.LOV.FETCH_SINGLE_ROW.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5358\4E00\884C\306E\30D5\30A7\30C3\30C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104191681362308603)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.LOV.INSERT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\3092\633F\5165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104191743301308603)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.LOV.UPDATE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\306E\66F4\65B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104191294903308602)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104429120405308779)
,p_name=>'PE.PROPERTY.DATA_BACKGROUND_COLOR.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\306AHTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\306E\4F8B\306B\306F\6B21\306E\3082\306E\304C\3042\308A\307E\3059 -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104269718204308660)
,p_name=>'PE.PROPERTY.DATA_BACKGROUND_COLOR.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30AB\30EC\30F3\30C0\306B\8868\793A\3055\308C\308B\30C7\30FC\30BF\306E\30D0\30C3\30AF\30B0\30E9\30A6\30F3\30C9\306B\4F7F\7528\3055\308C\308B\8272\3092\5165\529B\3057\307E\3059\3002</p>'),
unistr('<p>\8272\306F\300116\9032(hex)\8868\8A18\3001RGB\30AB\30E9\30FC\30FB\30B3\30FC\30C9\307E\305F\306FHTML\30AB\30E9\30FC\540D\3092\4F7F\7528\3057\3066\6307\5B9A\3055\308C\307E\3059\300216\9032\8868\8A18\306F#xxyyzz (#\306E\5F8C\306B3\3064\306E2\6841\306E16\9032\6570)\3067\5B9A\7FA9\3055\308C\3001xx\3001yy\304A\3088\3073zz\306F\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E2\6587\5B57\306E16\9032\306E\5024\3092\8868\3057\307E\3059\3002'),
unistr('RGB\30B3\30FC\30C9\306FRGB(xxx,xxx,xxx)\3067\5B9A\7FA9\3055\308C\3001xxx\306F0\304B\3089255\306E\9593\306E\6570\5024\3067\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E8\30D3\30C3\30C8\30FB\30D0\30A4\30C8\5024\3092\8868\3057\307E\3059\3002</p>'),
unistr('<p>\30A4\30F3\30BF\30FC\30CD\30C3\30C8\3067HTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\3092\691C\7D22\3059\308B\3068\3001\4F7F\7528\3059\308B\8272\306E16\9032\30B3\30FC\30C9\307E\305F\306FRGB\30B3\30FC\30C9\304C\308F\304B\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104269620743308660)
,p_name=>'PE.PROPERTY.DATA_BACKGROUND_COLOR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30D0\30C3\30AF\30B0\30E9\30A6\30F3\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103704516741308171)
,p_name=>'PE.PROPERTY.DATA_SOURCE_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30A2\30A4\30C6\30E0\5024\306E\30BD\30FC\30B9\3068\3057\3066\4F7F\7528\3055\308C\308B\3001\5927/\5C0F\6587\5B57\3092\533A\5225\3057\305F\5217\540D\3092\5165\529B\3057\307E\3059\3002</p>'),
unistr('<p>\3053\306E\5217\306F\3001\30D5\30A9\30FC\30E0\30FB\30EA\30FC\30B8\30E7\30F3\5185\3067\6307\5B9A\3055\308C\305F\30C7\30FC\30BF\30FB\30BD\30FC\30B9\306B\5B58\5728\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002'),
unistr('\5217\540D\304C\53C2\7167\8868\306B\306A\3044\5834\5408\3001\5B9F\884C\6642\306B\30A8\30E9\30FC\304C\767A\751F\3057\3001\30DA\30FC\30B8\306F\30ED\30FC\30C9\3055\308C\307E\305B\3093\3002'),
unistr('\540C\69D8\306B\3001\7D44\8FBC\307F\884C\30D5\30A7\30C3\30C1\30FB\30D7\30ED\30BB\30B9\304C\5B9A\7FA9\3055\308C\3066\304A\3089\305A\3001<strong>\300C\30C7\30FC\30BF\30D9\30FC\30B9\5217\300D</strong>\30BD\30FC\30B9\30FB\30BF\30A4\30D7\306E\30A2\30A4\30C6\30E0\304C\3042\308B\5834\5408\3001\30A8\30E9\30FC\304C\767A\751F\3057\3001\30DA\30FC\30B8\306E\30EC\30F3\30C0\30EA\30F3\30B0\306E\8A66\884C\4E2D\30DA\30FC\30B8\306F\30ED\30FC\30C9\3055\308C\307E\305B\3093\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103704478737308170)
,p_name=>'PE.PROPERTY.DATA_SOURCE_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103704378958308170)
,p_name=>'PE.PROPERTY.DATA_SOURCE_REGION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306B\5BFE\3057\3066\95A2\9023\4ED8\3051\3089\308C\308B\30D5\30A9\30FC\30E0\30FB\30EA\30FC\30B8\30E7\30F3\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103704223416308170)
,p_name=>'PE.PROPERTY.DATA_SOURCE_REGION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30FC\30E0\30FB\30EA\30FC\30B8\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104469644452308809)
,p_name=>'PE.PROPERTY.DATA_TEXT_COLOR.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\306AHTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\306E\4F8B\306B\306F\6B21\306E\3082\306E\304C\3042\308A\307E\3059 -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104269984297308660)
,p_name=>'PE.PROPERTY.DATA_TEXT_COLOR.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30AB\30EC\30F3\30C0\306E\30C7\30FC\30BF\306B\4F7F\7528\3055\308C\308B\8272\3092\5165\529B\3057\307E\3059\3002</p>'),
unistr('<p>\8272\306F\300116\9032(hex)\8868\8A18\3001RGB\30AB\30E9\30FC\30FB\30B3\30FC\30C9\307E\305F\306FHTML\30AB\30E9\30FC\540D\3092\4F7F\7528\3057\3066\6307\5B9A\3055\308C\307E\3059\300216\9032\8868\8A18\306F#xxyyzz (#\306E\5F8C\306B3\3064\306E2\6841\306E16\9032\6570)\3067\5B9A\7FA9\3055\308C\3001xx\3001yy\304A\3088\3073zz\306F\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E2\6587\5B57\306E16\9032\306E\5024\3092\8868\3057\307E\3059\3002'),
unistr('RGB\30B3\30FC\30C9\306FRGB(xxx,xxx,xxx)\3067\5B9A\7FA9\3055\308C\3001xxx\306F0\304B\3089255\306E\9593\306E\6570\5024\3067\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E8\30D3\30C3\30C8\30FB\30D0\30A4\30C8\5024\3092\8868\3057\307E\3059\3002</p>'),
unistr('<p>\30A4\30F3\30BF\30FC\30CD\30C3\30C8\3067HTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\3092\691C\7D22\3059\308B\3068\3001\4F7F\7528\3059\308B\8272\306E16\9032\30B3\30FC\30C9\307E\305F\306FRGB\30B3\30FC\30C9\304C\308F\304B\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104269804064308660)
,p_name=>'PE.PROPERTY.DATA_TEXT_COLOR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104109573866308524)
,p_name=>'PE.PROPERTY.DATA_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\57FA\790E\3068\306A\308B\30C7\30FC\30BF\30D9\30FC\30B9\5217\306E\30C7\30FC\30BF\578B\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104775957950309070)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.BFILE.D'
,p_message_language=>'ja'
,p_message_text=>'BFILE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104775757413309070)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.BLOB.D'
,p_message_language=>'ja'
,p_message_text=>'BLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104775614092309070)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.CLOB.D'
,p_message_language=>'ja'
,p_message_text=>'CLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104775080286309070)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.DATE.D'
,p_message_language=>'ja'
,p_message_text=>'DATE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104775555173309070)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.INTERVAL_D2S.D'
,p_message_language=>'ja'
,p_message_text=>'INTERVAL DAY TO SECOND'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104775493141309070)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.INTERVAL_Y2M.D'
,p_message_language=>'ja'
,p_message_text=>'INTERVAL YEAR TO MONTH'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104774999197309069)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.NUMBER.D'
,p_message_language=>'ja'
,p_message_text=>'NUMBER'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104775888418309070)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.ROWID.D'
,p_message_language=>'ja'
,p_message_text=>'ROWID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103775244321308228)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.SDO_GEOMETRY.D'
,p_message_language=>'ja'
,p_message_text=>'SDO_GEOMETRY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104775101094309070)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.TIMESTAMP.D'
,p_message_language=>'ja'
,p_message_text=>'TIMESTAMP'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104775347479309070)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.TIMESTAMP_LTZ.D'
,p_message_language=>'ja'
,p_message_text=>'TIMESTAMP WITH LOCAL TIME ZONE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104775261774309070)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.TIMESTAMP_TZ.D'
,p_message_language=>'ja'
,p_message_text=>'TIMESTAMP WITH TIME ZONE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104774839080309069)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.VARCHAR2.D'
,p_message_language=>'ja'
,p_message_text=>'VARCHAR2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104109492277308524)
,p_name=>'PE.PROPERTY.DATA_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104266775047308658)
,p_name=>'PE.PROPERTY.DATE_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30EC\30F3\30C0\306B\914D\7F6E\3059\308B\65E5\4ED8\3092\542B\3080\8868\307E\305F\306F\554F\5408\305B\304B\3089\5217\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104266634334308658)
,p_name=>'PE.PROPERTY.DATE_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5\4ED8\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104266902064308658)
,p_name=>'PE.PROPERTY.DATE_FORMAT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30EC\30F3\30C0\306B\6642\9593\3092\8868\793A\3059\308B\304B\3001\65E5\4ED8\5024\306E\307F\3092\8868\793A\3059\308B\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104266808207308658)
,p_name=>'PE.PROPERTY.DATE_FORMAT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6642\9593\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104234741703308635)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\5217\306E\65E5\4ED8\30D4\30C3\30AB\30FC\306B\9069\7528\3059\308B\66F8\5F0F\30DE\30B9\30AF\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104415164824308769)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY.D'
,p_message_language=>'ja'
,p_message_text=>'DD/MM/YYYY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104414987828308768)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_DASH.D'
,p_message_language=>'ja'
,p_message_text=>'DD-MM-YYYY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104415053263308768)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_DOT.D'
,p_message_language=>'ja'
,p_message_text=>'DD.MM.YYYY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104415757051308769)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH24_MI.D'
,p_message_language=>'ja'
,p_message_text=>'DD/MM/YYYY HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104415553350308769)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH24_MI_DASH.D'
,p_message_language=>'ja'
,p_message_text=>'DD-MM-YYYY HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104415615036308769)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH24_MI_DOT.D'
,p_message_language=>'ja'
,p_message_text=>'DD.MM.YYYY HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104415466144308769)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH_MI.D'
,p_message_language=>'ja'
,p_message_text=>'DD/MM/YYYY HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104415261979308769)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH_MI_DASH.D'
,p_message_language=>'ja'
,p_message_text=>'DD-MM-YYYY HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104415363346308769)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH_MI_DOT.D'
,p_message_language=>'ja'
,p_message_text=>'DD.MM.YYYY HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104415808010308769)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_RR.D'
,p_message_language=>'ja'
,p_message_text=>'DD-MON-RR'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104416008497308769)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_RR_HH24_MI.D'
,p_message_language=>'ja'
,p_message_text=>'DD-MON-RR HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104415929839308769)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_RR_HH_MI.D'
,p_message_language=>'ja'
,p_message_text=>'DD-MON-RR HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104416159941308769)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_YYYY.D'
,p_message_language=>'ja'
,p_message_text=>'DD-MON-YYYY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104416313463308769)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_YYYY_HH24_MI.D'
,p_message_language=>'ja'
,p_message_text=>'DD-MON-YYYY HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104416218156308769)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_YYYY_HH_MI.D'
,p_message_language=>'ja'
,p_message_text=>'DD-MON-YYYY HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104416464172308769)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_MM_DD_YYYY.D'
,p_message_language=>'ja'
,p_message_text=>'MM/DD/YYYY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104416600358308770)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_MM_DD_YYYY_HH24_MI.D'
,p_message_language=>'ja'
,p_message_text=>'MM/DD/YYYY HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104416599582308770)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_MM_DD_YYYY_HH_MI.D'
,p_message_language=>'ja'
,p_message_text=>'MM/DD/YYYY HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104416711337308770)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_RR_MON_DD.D'
,p_message_language=>'ja'
,p_message_text=>'RR-MON-DD'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104416991178308770)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_RR_MON_DD_HH24_MI.D'
,p_message_language=>'ja'
,p_message_text=>'RR-MON-DD HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104416826219308770)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_RR_MON_DD_HH_MI.D'
,p_message_language=>'ja'
,p_message_text=>'RR-MON-DD HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104414628092308768)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_USING_APP_DATE_FORMAT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\65E5\4ED8\66F8\5F0F\3092\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104414783292308768)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_USING_APP_FORMAT_MASK.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\66F8\5F0F\30DE\30B9\30AF\3092\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104414807058308768)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_USING_FORMAT_MASK.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306E\66F8\5F0F\30DE\30B9\30AF\3092\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104417060511308770)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_DD_MM_DOT.D'
,p_message_language=>'ja'
,p_message_text=>'YYYY.DD.MM'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104417235485308770)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_DD_MM_HH24_MI_DOT.D'
,p_message_language=>'ja'
,p_message_text=>'YYYY.DD.MM HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104417174351308770)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_DD_MM_HH_MI_DOT.D'
,p_message_language=>'ja'
,p_message_text=>'YYYY.DD.MM HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104417381660308770)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD.D'
,p_message_language=>'ja'
,p_message_text=>'YYYY-MM-DD'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104417789913308770)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD_HH24_MI.D'
,p_message_language=>'ja'
,p_message_text=>'YYYY-MM-DD HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104417843043308771)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD_HH24_MI_SLASH.D'
,p_message_language=>'ja'
,p_message_text=>'YYYY/MM/DD HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104417510311308770)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD_HH_MI.D'
,p_message_language=>'ja'
,p_message_text=>'YYYY-MM-DD HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104417645855308770)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD_HH_MI_SLASH.D'
,p_message_language=>'ja'
,p_message_text=>'YYYY/MM/DD HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104417410362308770)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD_SLASH.D'
,p_message_language=>'ja'
,p_message_text=>'YYYY/MM/DD'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104234625481308635)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F8\5F0F\30DE\30B9\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104271094172308661)
,p_name=>'PE.PROPERTY.DAY_LINK_TARGET.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E2\30FC\30C0\30EB\30FB\30C0\30A4\30A2\30ED\30B0\3092\8D77\52D5\3059\308B\30BF\30FC\30B2\30C3\30C8\3092\30AF\30EA\30C3\30AF\3057\307E\3059\3002\65E2\5B58\306E\30A4\30D9\30F3\30C8\5916\306E\30AB\30EC\30F3\30C0\30FB\30BB\30EB\3092\30AF\30EA\30C3\30AF\3057\3066\30A4\30D9\30F3\30C8\3092\4F5C\6210\3059\308B\969B\3001\30AB\30EC\30F3\30C0\3067\30B3\30FC\30EB\3055\308C\308B\30BF\30FC\30B2\30C3\30C8\30FB\30EA\30F3\30AF\3092\5165\529B\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104270927361308661)
,p_name=>'PE.PROPERTY.DAY_LINK_TARGET.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30FC\30B2\30C3\30C8\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103899235324308326)
,p_name=>'PE.PROPERTY.DA_ACTION_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5B9F\884C\3059\308B\30A2\30AF\30B7\30E7\30F3\3092\6307\5B9A\3057\307E\3059\3002\6B21\306E\30A2\30AF\30B7\30E7\30F3\304C\30B5\30DD\30FC\30C8\3055\308C\3066\3044\307E\3059:</p>'),
'#NATIVE_PLUGINS#',
unistr('<p>\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\69CB\6210\306B\3088\3063\3066\306F\3001\305D\306E\4ED6\306E\52D5\7684\30A2\30AF\30B7\30E7\30F3\30FB\30D7\30E9\30B0\30A4\30F3\3082\3053\3053\3067\4F7F\7528\53EF\80FD\306A\5834\5408\304C\3042\308A\307E\3059\3002'),
unistr('\3053\308C\3089\306F\3001<em>&lt;My Plug-in&gt; [Plug-in]</em>\3068\8868\793A\3055\308C\307E\3059\3002'),
unistr('\6B21\306E\30D7\30E9\30B0\30A4\30F3\304C\3001\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8\5185\306B\30A4\30F3\30B9\30C8\30FC\30EB\3055\308C\3066\3044\307E\3059:</p>'),
'#CUSTOM_PLUGINS#'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103899109579308326)
,p_name=>'PE.PROPERTY.DA_ACTION_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104222618750308626)
,p_name=>'PE.PROPERTY.DA_EVENT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F7F\7528\53EF\80FD\306A\30EA\30B9\30C8\304B\3089\9069\5207\306A\52D5\7684\30A2\30AF\30B7\30E7\30F3\30FB\30A4\30D9\30F3\30C8\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104222568080308626)
,p_name=>'PE.PROPERTY.DA_EVENT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30D9\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104585792321308907)
,p_name=>'PE.PROPERTY.DB_SESSION_CLEANUP.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\30B3\30FC\30C9\306E\30AF\30EA\30FC\30F3\30A2\30C3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104585634399308907)
,p_name=>'PE.PROPERTY.DB_SESSION_INIT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\521D\671F\5316PL/SQL\30B3\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104254608446308649)
,p_name=>'PE.PROPERTY.DEEP_LINKING.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30C7\30D5\30A9\30EB\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104695712404308996)
,p_name=>'PE.PROPERTY.DEEP_LINKING.COMPONENT_PROPERTY.PAGE.NULL_TEXT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30BB\30AD\30E5\30EA\30C6\30A3\5C5E\6027\306B\5B9A\7FA9\3055\308C\3066\3044\308B\8A2D\5B9A\3092\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103878709280308307)
,p_name=>'PE.PROPERTY.DEEP_LINKING.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\3053\306E\30DA\30FC\30B8\3078\306E\5916\90E8URL\30EA\30AF\30A8\30B9\30C8\306E\51E6\7406\65B9\6CD5\3092\9078\629E\3057\307E\3059\3002'),
unistr('\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5185\304B\3089\3053\306E\30DA\30FC\30B8\3078\306E\30DA\30FC\30B8\30FB\30EA\30AF\30A8\30B9\30C8\306F\30C7\30A3\30FC\30D7\30FB\30EA\30F3\30AF\3068\307F\306A\3055\308C\305A\3001\3053\306E\5C5E\6027\306E\8A2D\5B9A\3067\5236\5FA1\3055\308C\307E\305B\3093\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104379733570308741)
,p_name=>'PE.PROPERTY.DEEP_LINKING.LOV.N.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104379877503308741)
,p_name=>'PE.PROPERTY.DEEP_LINKING.LOV.N.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('URL\306B\6709\52B9\306A\30BB\30C3\30B7\30E7\30F3ID\304C\542B\307E\308C\3066\3044\306A\3044\5834\5408\3001&PRODUCT_NAME.\306F\65B0\898F\30BB\30C3\30B7\30E7\30F3\3092\958B\59CB\3057\3001\3053\306E\30DA\30FC\30B8\3067\306F\306A\304F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30DB\30FC\30E0\30DA\30FC\30B8\306B\30E6\30FC\30B6\30FC\3092\30EA\30C0\30A4\30EC\30AF\30C8\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104379507306308741)
,p_name=>'PE.PROPERTY.DEEP_LINKING.LOV.Y.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6709\52B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104379670033308741)
,p_name=>'PE.PROPERTY.DEEP_LINKING.LOV.Y.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\3053\306E\30DA\30FC\30B8\304CURL\3067\30BF\30FC\30B2\30C3\30C8\30FB\30DA\30FC\30B8\3068\3057\3066\6307\5B9A\3055\308C\3066\3044\308B\5834\5408\3001\6700\7D42\7684\306B\306F\3053\306E\30DA\30FC\30B8\306B\30EA\30C0\30A4\30EC\30AF\30C8\3055\308C\307E\3059\3002<br>'),
unistr('\30E6\30FC\30B6\30FC\304C\307E\3060\8A8D\8A3C\3055\308C\3066\304A\3089\305A\3001\30DA\30FC\30B8\304C\30D1\30D6\30EA\30C3\30AF\3067\306A\3044\5834\5408\3001\30E6\30FC\30B6\30FC\306F\30ED\30B0\30A4\30F3\3059\308B\3088\3046\6C42\3081\3089\308C\307E\3059\3002'),
unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\6B63\5E38\306B\30ED\30B0\30A4\30F3\3057\305F\5F8C\3001\30E6\30FC\30B6\30FC\306F\3053\306E\30DA\30FC\30B8\306B\30EA\30C0\30A4\30EC\30AF\30C8\3055\308C\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103878679648308307)
,p_name=>'PE.PROPERTY.DEEP_LINKING.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30A3\30FC\30D7\30FB\30EA\30F3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104019874402308450)
,p_name=>'PE.PROPERTY.DEFAULT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\304C\30C7\30D5\30A9\30EB\30C8\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104019702179308450)
,p_name=>'PE.PROPERTY.DEFAULT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103868878384308300)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30AF\30B9\30DD\30FC\30C8\6642\306B\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\9069\7528\3055\308C\308B\30C7\30D5\30A9\30EB\30C8\306E\30D3\30EB\30C9\30FB\30AA\30D7\30B7\30E7\30F3\3092\9078\629E\3057\307E\3059\3002\3053\306E\30AA\30D7\30B7\30E7\30F3\306F\3001\30A8\30AF\30B9\30DD\30FC\30C8\30FB\30AA\30D7\30B7\30E7\30F3\306B\3088\3063\3066\30AA\30FC\30D0\30FC\30E9\30A4\30C9\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104377269943308739)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.LOV.EXCLUDE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\9664\5916')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104687279868308989)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.LOV.EXCLUDE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9\3067\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\4E00\90E8\3067\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104377351774308739)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.LOV.INCLUDE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\542B\3081\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104687333154308989)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.LOV.INCLUDE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\6709\52B9\3067\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\4E00\90E8\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103868749000308300)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30AF\30B9\30DD\30FC\30C8\306E\30C7\30D5\30A9\30EB\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104110327030308525)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\5217\306E\30C7\30D5\30A9\30EB\30C8\5024\306E\6C7A\5B9A\65B9\6CD5\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104610312134308927)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104610431925308927)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F<em>\5F0F</em>\304B\3089\8FD4\3055\308C\305F\5024\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104610503592308927)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104610611408308927)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F<em>\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53</em>\304B\3089\8FD4\3055\308C\305F\5024\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104110633339308525)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.ITEM.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104110704475308525)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\304B\3089\8FD4\3055\308C\305F\5024\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104111249222308526)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SEQUENCE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104111326297308526)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SEQUENCE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\5165\529B\3057\305F<em>\9806\5E8F</em>\304B\3089\623B\3055\308C\305F\5024\306B\8A2D\5B9A\3057\307E\3059\3002\3053\308C\304C"\7279\6B8A"\306A\30C7\30D5\30A9\30EB\30C8\30FB\30BF\30A4\30D7\306E\5834\5408: \5BFE\8A71\30B0\30EA\30C3\30C9DML\30D7\30ED\30BB\30B9\306E\4E00\90E8\3068\3057\3066\5B9F\884C\3055\308C\3001\30DA\30FC\30B8\30FB\30ED\30FC\30C9\4E2D\306F<em>\5B9F\884C\3055\308C\307E\305B\3093</em>\3002<strong>\300C\633F\5165\5F8C\306B\4E3B\30AD\30FC\3092\8FD4\3059\300D</strong>\3092\4F7F\7528\3067\304D\306A\3044\5834\5408\3001\305F\3068\3048\3070\30D3\30E5\30FC\3068INSTEAD OF\30C8\30EA\30AC\30FC\3001\307E\305F\306F\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30EA\30F3\30AF\3092\64CD\4F5C\3057\3066\3044\308B\5834\5408\306F\3001\3053\306E\30BF\30A4\30D7\3092\81EA\52D5\751F\6210\4E3B\30AD\30FC\5024\306B\4F7F\7528\3057\307E\3059\3002\9806\5E8F\540D\306E\5927\6587\5B57\3068\5C0F\6587\5B57\306F\533A\5225\3055\308C\307E\305B\3093\3002\5927\6587\5B57\3068\5C0F\6587\5B57\304C\6DF7\5728\3059\308B\9806\5E8F\540D\3092\793A\3059\306B')
||unistr('\306F\4E8C\91CD\5F15\7528\7B26\3092\4F7F\7528\3057\307E\3059("mySequence")\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104110807345308525)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104110966639308525)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F<em>SQL\554F\5408\305B</em>\304B\3089\8FD4\3055\308C\305F\5024\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104111021330308525)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SQL_QUERY_COLON.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30ED\30F3\3067\533A\5207\3089\308C\305F\30EA\30B9\30C8\3092\623B\3059SQL\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104111107157308526)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SQL_QUERY_COLON.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5165\529B\3055\308C\305F<em>SQL\554F\5408\305B</em>\304B\3089\623B\3055\308C\308B\30B3\30ED\30F3\3067\533A\5207\3089\308C\305F\5024\306E\30EA\30B9\30C8\306B\8A2D\5B9A\3057\307E\3059\3002</p>'),
unistr('        <p>\30CE\30FC\30C8 - \5217\304C\30C1\30A7\30C3\30AF\30FB\30DC\30C3\30AF\30B9\3001\30E9\30B8\30AA\30FB\30B0\30EB\30FC\30D7\307E\305F\306F\30B7\30E3\30C8\30EB\3068\3057\3066\8868\793A\3055\308C\308B\5834\5408\3001\30B3\30ED\30F3\3067\533A\5207\3089\308C\305F\30EA\30B9\30C8\304C\5FC5\8981\3067\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104110406534308525)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.STATIC.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\9759\7684')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104110525359308525)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.STATIC.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<em>\300C\9759\7684\300D</em>\5024\306B\5165\529B\3055\308C\305F\5024\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104110206268308525)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104633408500308945)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F\5F0F\306E\8A55\4FA1\306B\4F7F\7528\3055\308C\308B\8A00\8A9E\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104633843667308946)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'ja'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104633736921308946)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'ja'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104633627926308945)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'ja'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104633990528308946)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'ja'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104633546067308945)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'ja'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104633310398308945)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A00\8A9E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104635470316308947)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\306E\5B9F\884C\306B\4F7F\7528\3055\308C\308B\8A00\8A9E\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104635714341308947)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'ja'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104635624710308947)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'ja'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104635511188308947)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'ja'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104635832796308947)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'ja'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104635331039308947)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A00\8A9E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104258339341308652)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\5024\3092\4FDD\6301\3059\308B\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104258248496308652)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_ITEM.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104635036492308947)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JAVA_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30A4\30C6\30E0\306E\5024\3092\751F\6210\3059\308BJava\5F0F\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104634983816308946)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JAVA_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('Java\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104636638636308948)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30A4\30C6\30E0\306E\5024\3092\8FD4\3059Java\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104636534290308948)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('Java\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104634823457308946)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3059\308B\304B\3001\30DE\30CD\30FC\30B8\30E3\3067\3042\308B\5834\5408\3001YES\3092\8FD4\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" ? "YES" : "NO" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104634712108308946)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30A4\30C6\30E0\306E\5024\3092\751F\6210\3059\308BJavaScript\5F0F\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104634605551308946)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('JavaScript\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104636476776308948)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3059\308B\5834\5408\3001YES\3092\8FD4\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES", "NO" );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104636349167308948)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30A4\30C6\30E0\306E\5024\3092\8FD4\3059JavaScript\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104636285193308948)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('JavaScript\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104634525689308946)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3059\308B\304B\3001\30DE\30CD\30FC\30B8\30E3\3067\3042\308B\5834\5408\3001YES\3092\8FD4\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'case when ( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' ) then ''YES'' else ''NO'' end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104634465498308946)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30A4\30C6\30E0\306E\5024\3092\751F\6210\3059\308BPL/SQL\5F0F\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104634374747308946)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104636114318308947)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3059\308B\5834\5408\3001YES\3092\8FD4\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104636098175308947)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30A4\30C6\30E0\306E\5024\3092\8FD4\3059PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104635991197308947)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104635259977308947)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PYTHON_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30A4\30C6\30E0\306E\5024\3092\751F\6210\3059\308BPython\5F0F\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104635167892308947)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PYTHON_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('Python\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104636879589308948)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30A4\30C6\30E0\306E\5024\3092\8FD4\3059Python\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104636711709308948)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('Python\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104111920092308526)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SEQUENCE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\5217\306E\30C7\30D5\30A9\30EB\30C8\5024\3092\623B\3059\30C7\30FC\30BF\30D9\30FC\30B9\9806\5E8F\306E\540D\524D\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104111872403308526)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SEQUENCE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104634281593308946)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\30DE\30CD\30FC\30B8\30E3\3067\3001\90E8\9580\304C\30B7\30AB\30B4\306B\5B58\5728\3059\308B\5834\5408\3001YES\3092\8FD4\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'case',
'when :P2_JOB = ''MANAGER'' and',
'     exists ( select 1',
'                from dept',
'               where deptno = :P2_DEPTNO',
'                 and loc    = ''CHICAGO'' ) then ''YES''',
'else ''NO''',
'end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104634147756308946)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30A4\30C6\30E0\306E\5024\3092\751F\6210\3059\308BSQL\5F0F\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104634040863308946)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104111556414308526)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_QUERY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\5217\306E\30C7\30D5\30A9\30EB\30C8\5024\3092\623B\3059SQL\554F\5408\305B\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104111466861308526)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_QUERY.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104111773123308526)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_QUERY_COLON.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\5217\306E\30C7\30D5\30A9\30EB\30C8\306E\30B3\30ED\30F3\3067\533A\5207\3089\308C\305F\5024\306E\30EA\30B9\30C8\3092\623B\3059SQL\554F\5408\305B\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104111651319308526)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_QUERY_COLON.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B\30B3\30ED\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103892424618308317)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_STATIC_TEXT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30A4\30C6\30E0\306E\30C7\30D5\30A9\30EB\30C8\5024\3092\6307\5B9A\3057\307E\3059\3002\30C7\30D5\30A9\30EB\30C8\5024\306F\3001\30A2\30A4\30C6\30E0\306E\5024\304C\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\304B\3089\5C0E\51FA\3055\308C\305A\3001\30BD\30FC\30B9\5024\304CNULL\3067\3042\308B\5834\5408\306B\4F7F\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103892309096308317)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_STATIC_TEXT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\9759\7684\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103892220734308317)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30A4\30C6\30E0\306E\30C7\30D5\30A9\30EB\30C8\306E\5024\30BF\30A4\30D7\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104609764559308926)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104609835486308926)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F<em>\5F0F</em>\304B\3089\8FD4\3055\308C\305F\5024\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104609917958308927)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104610063200308927)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F<em>\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53</em>\304B\3089\8FD4\3055\308C\305F\5024\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103703160028308169)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.ITEM.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103703226937308169)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\304B\3089\8FD4\3055\308C\305F\5024\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103703796821308170)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SEQUENCE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103703839620308170)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SEQUENCE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\5165\529B\3057\305F<em>\9806\5E8F</em>\304B\3089\623B\3055\308C\305F\5024\306B\8A2D\5B9A\3057\307E\3059\3002\3053\308C\304C"\7279\6B8A"\306A\30C7\30D5\30A9\30EB\30C8\30FB\30BF\30A4\30D7\306E\5834\5408: \30D5\30A9\30FC\30E0\30FB\30EA\30FC\30B8\30E7\30F3DML\30D7\30ED\30BB\30B9\306E\4E00\90E8\3068\3057\3066\5B9F\884C\3055\308C\3001\30DA\30FC\30B8\30FB\30ED\30FC\30C9\4E2D\306F<em>\5B9F\884C\3055\308C\307E\305B\3093</em>\3002<strong>\300C\633F\5165\5F8C\306B\4E3B\30AD\30FC\3092\8FD4\3059\300D</strong>\3092\4F7F\7528\3067\304D\306A\3044\5834\5408\3001\305F\3068\3048\3070\30D3\30E5\30FC\3068INSTEAD OF\30C8\30EA\30AC\30FC\3001\307E\305F\306F\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30EA\30F3\30AF\3092\64CD\4F5C\3057\3066\3044\308B\5834\5408\306F\3001\3053\306E\30BF\30A4\30D7\3092\81EA\52D5\751F\6210\4E3B\30AD\30FC\5024\306B\4F7F\7528\3057\307E\3059\3002\9806\5E8F\540D\306E\5927\6587\5B57\3068\5C0F\6587\5B57\306F\533A\5225\3055\308C\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103703376123308170)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103703493390308170)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F<em>SQL\554F\5408\305B</em>\304B\3089\8FD4\3055\308C\305F\5024\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103703588128308170)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SQL_QUERY_COLON.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30ED\30F3\3067\533A\5207\3089\308C\305F\30EA\30B9\30C8\3092\623B\3059SQL\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103703621977308170)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SQL_QUERY_COLON.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5165\529B\3055\308C\305F<em>SQL\554F\5408\305B</em>\304B\3089\623B\3055\308C\308B\30B3\30ED\30F3\3067\533A\5207\3089\308C\305F\5024\306E\30EA\30B9\30C8\306B\8A2D\5B9A\3057\307E\3059\3002</p>'),
unistr('        <p>\30CE\30FC\30C8 - \5217\304C\30C1\30A7\30C3\30AF\30FB\30DC\30C3\30AF\30B9\3001\30E9\30B8\30AA\30FB\30B0\30EB\30FC\30D7\307E\305F\306F\30B7\30E3\30C8\30EB\3068\3057\3066\8868\793A\3055\308C\308B\5834\5408\3001\30B3\30ED\30F3\3067\533A\5207\3089\308C\305F\30EA\30B9\30C8\304C\5FC5\8981\3067\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104394520075308753)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.STATIC_TEXT_WITH_SUBSTITUTIONS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\9759\7684')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103703023889308169)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.STATIC_TEXT_WITH_SUBSTITUTIONS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<em>\300C\9759\7684\300D</em>\5024\306B\5165\529B\3055\308C\305F\5024\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103892100159308317)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104121933697308535)
,p_name=>'PE.PROPERTY.DEFINE_CHART_VIEW.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\3053\306E\5BFE\8A71\30B0\30EA\30C3\30C9\306B\30C1\30E3\30FC\30C8\3092\5B9A\7FA9\3067\304D\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002</p>')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104121889998308535)
,p_name=>'PE.PROPERTY.DEFINE_CHART_VIEW.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\30FB\30D3\30E5\30FC\306E\5B9A\7FA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104097525313308514)
,p_name=>'PE.PROPERTY.DELETE_AUTHORIZATION_SCHEME.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8A8D\53EF\30B9\30AD\30FC\30E0\3092\9078\629E\3057\3066\3001\884C\3092\524A\9664\3067\304D\308B\30E6\30FC\30B6\30FC\3092\5236\9650\3057\307E\3059\3002'),
unistr('		\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\884C\3092\524A\9664\3059\308B\306B\306F\3001\3053\306E\8A8D\53EF\30B9\30AD\30FC\30E0\304C\305D\306E\30E6\30FC\30B6\30FC\306B\5BFE\3057\3066TRUE\3068\8A55\4FA1\3055\308C\308B\5FC5\8981\304C\3042\308A\307E\3059\3002'),
unistr('		\8A8D\53EF\30B9\30AD\30FC\30E0\304C\6307\5B9A\3055\308C\306A\3044\5834\5408\3001\3059\3079\3066\306E\30E6\30FC\30B6\30FC\304C\3053\306E\5BFE\8A71\30B0\30EA\30C3\30C9\3067\884C\3092\524A\9664\3067\304D\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104097460663308514)
,p_name=>'PE.PROPERTY.DELETE_AUTHORIZATION_SCHEME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104230968456308632)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30D5\30A1\30BB\30C3\30C8\307E\305F\306F\30D5\30A3\30EB\30BF\3092\8868\793A\3059\3079\304D\304B\3069\3046\304B\3092\5236\5FA1\3059\308B\305F\3081\306B\3001\5225\306E\30D5\30A1\30BB\30C3\30C8\307E\305F\306F\30D5\30A3\30EB\30BF\306E\5024\3092\30C1\30A7\30C3\30AF\3059\308B\6761\4EF6\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104231002243308632)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.EQUALS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\3068\7B49\3057\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104231164069308632)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.EQUALS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F9D\5B58\3059\308B<em>\30D5\30A1\30BB\30C3\30C8\307E\305F\306F\30D5\30A3\30EB\30BF</em>\306E\5024\304C\6307\5B9A\3057\305F<em>\5024</em>\3068\7B49\3057\3044\304B\3069\3046\304B\3092\30C1\30A7\30C3\30AF\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104231473882308633)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.IN_LIST.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8\306B\542B\307E\308C\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104231598525308633)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.IN_LIST.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F9D\5B58\3059\308B<em>\30D5\30A1\30BB\30C3\30C8\307E\305F\306F\30D5\30A3\30EB\30BF</em>\306E\5024\304C\6307\5B9A\3057\305F<em>\30EA\30B9\30C8</em>\306B\542B\307E\308C\308B\304B\3069\3046\304B\3092\30C1\30A7\30C3\30AF\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104231282698308632)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_EQUALS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\3068\7B49\3057\304F\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104231319161308633)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_EQUALS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F9D\5B58\3059\308B<em>\30D5\30A1\30BB\30C3\30C8\307E\305F\306F\30D5\30A3\30EB\30BF</em>\306E\5024\304C\6307\5B9A\3057\305F<em>\5024</em>\3068\7B49\3057\304F\306A\3044\304B\3069\3046\304B\3092\30C1\30A7\30C3\30AF\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104231692024308633)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_IN_LIST.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8\306B\542B\307E\308C\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104231780818308633)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_IN_LIST.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F9D\5B58\3059\308B<em>\30D5\30A1\30BB\30C3\30C8\307E\305F\306F\30D5\30A3\30EB\30BF</em>\306E\5024\304C\6307\5B9A\3057\305F<em>\30EA\30B9\30C8</em>\306B\542B\307E\308C\306A\3044\304B\3069\3046\304B\3092\30C1\30A7\30C3\30AF\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104232034142308633)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_NULL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('NULL\3067\306F\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104232135720308633)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_NULL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F9D\5B58\3059\308B<em>\30D5\30A1\30BB\30C3\30C8\307E\305F\306F\30D5\30A3\30EB\30BF</em>\306E\5024\304C\7A7A\3067\306A\3044\304B\3069\3046\304B\3092\30C1\30A7\30C3\30AF\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104231880952308633)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NULL.D'
,p_message_language=>'ja'
,p_message_text=>'NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104231972643308633)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NULL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F9D\5B58\3059\308B<em>\30D5\30A1\30BB\30C3\30C8\307E\305F\306F\30D5\30A3\30EB\30BF</em>\306E\5024\304C\7A7A\304B\3069\3046\304B\3092\30C1\30A7\30C3\30AF\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104230843429308632)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104232589099308633)
,p_name=>'PE.PROPERTY.DEPENDING_ON_COND_LIST.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3059\308B\30AB\30F3\30DE\3067\533A\5207\3089\308C\305F\5024\306E\30EA\30B9\30C8\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104232494632308633)
,p_name=>'PE.PROPERTY.DEPENDING_ON_COND_LIST.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104232319089308633)
,p_name=>'PE.PROPERTY.DEPENDING_ON_COND_VALUE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3059\308B\5024\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104232279882308633)
,p_name=>'PE.PROPERTY.DEPENDING_ON_COND_VALUE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104230796524308632)
,p_name=>'PE.PROPERTY.DEPENDING_ON_FACET.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30D5\30A1\30BB\30C3\30C8\3092\8868\793A\3059\3079\304D\304B\3069\3046\304B\3092\5224\65AD\3059\308B\305F\3081\306B\30C1\30A7\30C3\30AF\3059\308B\5FC5\8981\306E\3042\308B\3001\95A2\9023\3059\308B\30D5\30A1\30BB\30C3\30C8\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104230618578308632)
,p_name=>'PE.PROPERTY.DEPENDING_ON_FACET.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30BB\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104556272462308884)
,p_name=>'PE.PROPERTY.DEPENDING_ON_FACET_GRP_ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30C1\30A7\30C3\30AF\30FB\30DC\30C3\30AF\30B9\3092\8868\793A\3059\3079\304D\304B\3069\3046\304B\3092\5224\65AD\3059\308B\305F\3081\306B\30C1\30A7\30C3\30AF\3059\308B\5FC5\8981\306E\3042\308B\3001\95A2\9023\3059\308B\30C1\30A7\30C3\30AF\30FB\30DC\30C3\30AF\30B9\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104556156368308884)
,p_name=>'PE.PROPERTY.DEPENDING_ON_FACET_GRP_ITEM.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30A7\30C3\30AF\30DC\30C3\30AF\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103918770094308373)
,p_name=>'PE.PROPERTY.DEPENDING_ON_SFILTER.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30D5\30A3\30EB\30BF\3092\8868\793A\3059\3079\304D\304B\3069\3046\304B\3092\5224\65AD\3059\308B\305F\3081\306B\30C1\30A7\30C3\30AF\3059\308B\5FC5\8981\306E\3042\308B\3001\95A2\9023\3059\308B\30D5\30A3\30EB\30BF\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103918688318308373)
,p_name=>'PE.PROPERTY.DEPENDING_ON_SFILTER.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30EB\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103918963558308373)
,p_name=>'PE.PROPERTY.DEPENDING_ON_SFILTER_GRP_ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30C1\30A7\30C3\30AF\30FB\30DC\30C3\30AF\30B9\3092\8868\793A\3059\3079\304D\304B\3069\3046\304B\3092\5224\65AD\3059\308B\305F\3081\306B\30C1\30A7\30C3\30AF\3059\308B\5FC5\8981\306E\3042\308B\3001\95A2\9023\3059\308B\30C1\30A7\30C3\30AF\30FB\30DC\30C3\30AF\30B9\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103918834133308373)
,p_name=>'PE.PROPERTY.DEPENDING_ON_SFILTER_GRP_ITEM.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30A7\30C3\30AF\30DC\30C3\30AF\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104470840621308810)
,p_name=>'PE.PROPERTY.DERIVED_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('$$$ DJP\73FE\5728\975E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104261731593308654)
,p_name=>'PE.PROPERTY.DERIVED_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C0E\51FA\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104776250508309070)
,p_name=>'PE.PROPERTY.DESCRIPTION.COMPONENT_PROPERTY.IR_ATTRIBUTES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\306E\8AAC\660E\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104205347127308613)
,p_name=>'PE.PROPERTY.DESCRIPTION.COMPONENT_PROPERTY.IR_COLUMN_GROUP.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\30B0\30EB\30FC\30D7\306E\8AAC\660E\3092\5165\529B\3057\307E\3059\3002\3053\306E\8AAC\660E\306F\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\306F\8868\793A\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103872835123308303)
,p_name=>'PE.PROPERTY.DESCRIPTION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\8AAC\660E\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103872739898308303)
,p_name=>'PE.PROPERTY.DESCRIPTION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8AAC\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104411202495308766)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_AFTER_ROWS.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;/table&gt;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104213536647308619)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_AFTER_ROWS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\884C\306E\5F8C\306B\8868\793A\3055\308C\308BHTML\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104213438295308619)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_AFTER_ROWS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\306E\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104411080067308765)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_BEFORE_ROWS.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;table&gt;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104213194898308619)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_BEFORE_ROWS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\884C\306E\524D\306B\8868\793A\3055\308C\308BHTML\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104213009812308619)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_BEFORE_ROWS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\306E\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104112863408308527)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_ENABLED.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A73\7D30\30D3\30E5\30FC\3092\6709\52B9\306B\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002<strong>\300C\30AA\30F3\300D</strong>\3092\9078\629E\3059\308B\3068\3001\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\306E\691C\7D22\30D0\30FC\307E\305F\306F\5BFE\8A71\30B0\30EA\30C3\30C9\306E\300C\8868\793A\300D\30DC\30BF\30F3\306B\300C\8A73\7D30\306E\8868\793A\300D\30A2\30A4\30B3\30F3\304C\8FFD\52A0\3055\308C\3001\30E6\30FC\30B6\30FC\304C\3053\306E\30D3\30E5\30FC\306B\30A2\30AF\30BB\30B9\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104212913241308619)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_ENABLED.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A73\7D30\30D3\30E5\30FC\3092\6709\52B9\306B\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002<strong>\300C\30AA\30F3\300D</strong>\3092\9078\629E\3059\308B\3068\3001\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\306E\691C\7D22\30D0\30FC\307E\305F\306F\5BFE\8A71\30B0\30EA\30C3\30C9\306E\300C\8868\793A\300D\30DC\30BF\30F3\306B\300C\8A73\7D30\306E\8868\793A\300D\30A2\30A4\30B3\30F3\304C\8FFD\52A0\3055\308C\3001\30E6\30FC\30B6\30FC\304C\3053\306E\30D3\30E5\30FC\306B\30A2\30AF\30BB\30B9\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104212840589308619)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_ENABLED.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104773700319309069)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_FOR_EACH_ROW.COMPONENT_PROPERTY.IG_ATTRIBUTES.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;tr&gt;&lt;td align="right"&gt;&ENAME_LABEL.:&lt;/td&gt;&lt;td&gt;&ENAME.&lt;/td&gt;&lt;/tr&gt;',
'&lt;tr&gt;&lt;td align="right"&gt;&JOB_LABEL.:&lt;/td&gt;&lt;td&gt;&JOB.&lt;/td&gt;&lt;/tr&gt;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104773895765309069)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_FOR_EACH_ROW.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8A73\7D30\30D3\30E5\30FC\306E\30EC\30DD\30FC\30C8\884C\306E\672C\4F53\3092\5165\529B\3057\307E\3059\3002</p>'),
unistr('<p>\6B21\306E\7F6E\63DB\6587\5B57\5217\3092\4F7F\7528\3067\304D\307E\3059:'),
'<ul>',
unistr('<li><code>&&lt;COLUMN_NAME&gt;.</code> - \5217\306E\540D\524D\306E\7F6E\63DB\6587\5B57\5217\3002</li>'),
unistr('<li><code>&&lt;COLUMN_NAME&gt;_LABEL.</code> - \5217\306E\30E9\30D9\30EB\306E\7F6E\63DB\6587\5B57\5217\3002</li>'),
unistr('<li><code>&APEX$ROW_ID.</code> - \884C\306E\30EC\30B3\30FC\30C9\8B58\5225\5B50\3002</li>'),
unistr('<li><code>&APEX$ROW_INDEX.</code> - \30EC\30B3\30FC\30C9\8868\793A\9806\5E8F\756A\53F7\3002</li>'),
unistr('<li><code>&APEX$ROW_STATE_CLASSES.</code> - <code>is-inserted</code>\307E\305F\306F<code>is-deleted</code>\306A\3069\30EC\30B3\30FC\30C9\306E\72B6\614B\3002</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104411153884308766)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_FOR_EACH_ROW.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;tr&gt;&lt;td align="right"&gt;#ENAME_LABEL#:&lt;/td&gt;&lt;td&gt;#ENAME#&lt;/td&gt;&lt;/tr&gt;',
'&lt;tr&gt;&lt;td align="right"&gt;#JOB_LABEL#:&lt;/td&gt;&lt;td&gt;#JOB#&lt;/td&gt;&lt;/tr&gt;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104213345926308619)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_FOR_EACH_ROW.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A73\7D30\30D3\30E5\30FC\306E\30EC\30DD\30FC\30C8\884C\306E\672C\4F53\3092\5165\529B\3057\307E\3059\3002\5217\540D\304A\3088\3073\5217\30E9\30D9\30EB\306B<code>#COLUMN_NAME#</code>\7F6E\63DB\6587\5B57\5217\3092\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104213216186308619)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_FOR_EACH_ROW.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5404\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103872662943308303)
,p_name=>'PE.PROPERTY.DIALOG_ATTRIBUTES.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>&PRODUCT_NAME.\306E\30C0\30A4\30A2\30ED\30B0\30FB\30B5\30DD\30FC\30C8\306F\3001\30DA\30FC\30B8\306E\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\306B\3088\3063\3066\7570\306A\308A\307E\3059\3002'),
unistr('\30C0\30A4\30A2\30ED\30B0\5C5E\6027\306E\30B5\30D6\30BB\30C3\30C8\3067\3042\308B<em>\9AD8\3055\3001\5E45\304A\3088\3073\6700\5927\5E45</em>\304C\5BA3\8A00\7684\306B\30B5\30DD\30FC\30C8\3055\308C\307E\3059\3002'),
unistr('\30C0\30A4\30A2\30ED\30B0\306E\8FFD\52A0\5C5E\6027\3092\5B9A\7FA9\3059\308B\306B\306F\3001\540D\524D/\5024\306E\30DA\30A2\3092\30AB\30F3\30DE\3067\533A\5207\3089\308C\305F\30EA\30B9\30C8\306B\5165\529B\3057\307E\3059\3002</p>'),
unistr('<p>\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\30FB\30EC\30D9\30EB\3067\5B9A\7FA9\3055\308C\305F\30C0\30A4\30A2\30ED\30B0\521D\671F\5316\30B3\30FC\30C9\5185\306E\7F6E\63DB\6587\5B57\5217<code>#DIALOG_ATTRIBUTES#</code>\306F\3001\3053\306E\30A2\30A4\30C6\30E0\306B\5165\529B\3055\308C\305F\5024\3067\7F6E\304D\63DB\3048\3089\308C\307E\3059\3002</p>'),
unistr('<p>\30C7\30B9\30AF\30C8\30C3\30D7\30FB\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\3092\4F7F\7528\3057\305F\30DA\30FC\30B8\306E\5834\5408\3001jQuery UI\30C0\30A4\30A2\30ED\30B0\30FB\30A6\30A3\30B8\30A7\30C3\30C8\304C\4F7F\7528\3055\308C\307E\3059\3002'),
unistr('jQuery Mobile\30B9\30DE\30FC\30C8\30D5\30A9\30F3\30FB\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\3092\4F7F\7528\3057\305F\30DA\30FC\30B8\306E\5834\5408\3001jQuery Mobile\30C0\30A4\30A2\30ED\30B0\30FB\30A6\30A3\30B8\30A7\30C3\30C8\304C\4F7F\7528\3055\308C\307E\3059\3002</p>'),
unistr('<p>\305F\3068\3048\3070\3001\30C7\30B9\30AF\30C8\30C3\30D7\30FB\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\3092\4F7F\7528\3057\305F\30C0\30A4\30A2\30ED\30B0\30FB\30DA\30FC\30B8\306B\306F\3001<code>resizable:true, draggable:true</code>\5C5E\6027\3092\5B9A\7FA9\3067\304D\307E\3059\3002</p>'),
unistr('<p>\4F7F\7528\3067\304D\308B\5C5E\6027\306E\8A73\7D30\306F\3001<a rel="noreferrer" target="_blank" href="http://api.jqueryui.com/dialog/">jQuery UI\30C0\30A4\30A2\30ED\30B0\30FB\30A6\30A3\30B8\30A7\30C3\30C8\306E\30C9\30AD\30E5\30E1\30F3\30C8</a>\304A\3088\3073<a rel="noreferrer" target="_blank" href="http://api.jqueryui.com/dialog/">jQuery Mobile\30C0\30A4\30A2\30ED\30B0\30FB\30A6\30A3\30B8\30A7\30C3\30C8\306E\30C9\30AD\30E5\30E1\30F3\30C8</a>\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103872512053308303)
,p_name=>'PE.PROPERTY.DIALOG_ATTRIBUTES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104563143767308889)
,p_name=>'PE.PROPERTY.DIALOG_CHAINED.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\3053\306E\30C0\30A4\30A2\30ED\30B0\304C\5225\306E\30C0\30A4\30A2\30ED\30B0\306B\3088\3063\3066\958B\304B\308C\3001\540C\3058\30C0\30A4\30A2\30ED\30B0\30FB\30A6\30A3\30F3\30C9\30A6\3092\518D\5229\7528\3059\308B\5834\5408\3001<strong>\300C\30AA\30F3\300D</strong>\3092\9078\629E\3057\307E\3059\3002'),
unistr('\305F\3068\3048\3070\3001\3053\306E\30C0\30A4\30A2\30ED\30B0\304C\8907\6570\30DA\30FC\30B8\30FB\30C0\30A4\30A2\30ED\30B0\30FB\30A6\30A3\30B6\30FC\30C9\306E\4E00\90E8\3067\3001\30A6\30A3\30B6\30FC\30C9\306E\5404\30B9\30C6\30C3\30D7\306B\30C0\30A4\30A2\30ED\30B0\30FB\30A6\30A3\30F3\30C9\30A6\3092\518D\5229\7528\3059\308B\5834\5408\3067\3059\3002<p><p>'),
unistr('\3053\306E\30C0\30A4\30A2\30ED\30B0\304C\5225\306E\30C0\30A4\30A2\30ED\30B0\306B\3088\3063\3066\958B\304B\308C\3001\65B0\898F\30C0\30A4\30A2\30ED\30B0\30FB\30A6\30A3\30F3\30C9\30A6\3067\958B\304B\308C\308B\5FC5\8981\304C\3042\308B\5834\5408\3001<strong>\300C\30AA\30D5\300D</strong>\3092\9078\629E\3057\307E\3059\3002\305F\3068\3048\3070\3001\3053\306E\30C0\30A4\30A2\30ED\30B0\304C'),
unistr('\30E2\30FC\30C0\30EB\3067\3001\89AA\30E2\30FC\30C0\30EB\30FB\30C0\30A4\30A2\30ED\30B0\30FB\30A6\30A3\30F3\30C9\30A6\5185\3067\958B\304F\5834\5408\3067\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104563056182308889)
,p_name=>'PE.PROPERTY.DIALOG_CHAINED.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30A7\30FC\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104274441912308663)
,p_name=>'PE.PROPERTY.DIALOG_CSS_CLASSES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\8FFD\52A0\3059\308B\30AF\30E9\30B9\3092\5165\529B\3057\307E\3059\3002\8907\6570\306E\30AF\30E9\30B9\306F\7A7A\767D\3067\533A\5207\3063\3066\8FFD\52A0\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104274307233308663)
,p_name=>'PE.PROPERTY.DIALOG_CSS_CLASSES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('CSS\30AF\30E9\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103962967784308407)
,p_name=>'PE.PROPERTY.DIALOG_HEIGHT.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30C0\30A4\30A2\30ED\30B0\306E\9AD8\3055\3092\30D4\30AF\30BB\30EB\5358\4F4D\3067\5165\529B\3057\307E\3059(<strong><em>500</em></strong>\306A\3069)\3002'),
unistr('\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306E\30C0\30A4\30A2\30ED\30B0\521D\671F\5316\30B3\30FC\30C9\306E\7F6E\63DB\6587\5B57\5217<code>#DIALOG_HEIGHT#</code>\304C\5165\529B\3055\308C\305F\5024\3067\7F6E\304D\63DB\3048\3089\308C\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103962844315308407)
,p_name=>'PE.PROPERTY.DIALOG_HEIGHT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\9AD8\3055')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103872433119308302)
,p_name=>'PE.PROPERTY.DIALOG_MAX_WIDTH.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30C0\30A4\30A2\30ED\30B0\306E\6700\5927\5E45\3092\30D4\30AF\30BB\30EB\5358\4F4D\3067\5165\529B\3057\307E\3059\3002'),
unistr('\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306E\30C0\30A4\30A2\30ED\30B0\521D\671F\5316\30B3\30FC\30C9\5185\306E\7F6E\63DB\6587\5B57\5217<code>#DIALOG_MAX_WIDTH#</code>\306F\3001\3053\306E\30A2\30A4\30C6\30E0\306B\5165\529B\3057\305F\5024\3067\7F6E\63DB\3055\308C\307E\3059\3002</p>'),
unistr('<p>jQuery Mobile\30B9\30DE\30FC\30C8\30D5\30A9\30F3\30FB\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\3092\4F7F\7528\3057\305F\30DA\30FC\30B8\306E\5834\5408\3001\6700\5927\5E45\306F<strong><em>500</em></strong>\3067\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103872376551308302)
,p_name=>'PE.PROPERTY.DIALOG_MAX_WIDTH.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5927\5E45')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104254358285308649)
,p_name=>'PE.PROPERTY.DIALOG_TEMPLATE.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\306E\30C7\30D5\30A9\30EB\30C8\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104007916205308441)
,p_name=>'PE.PROPERTY.DIALOG_TEMPLATE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30DA\30FC\30B8\306E\5916\89B3\3068\30EC\30A4\30A2\30A6\30C8\3092\5B9A\7FA9\3059\308B\30C0\30A4\30A2\30ED\30B0\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\9078\629E\3057\307E\3059\3002</p>'),
unistr('        <p>\30C0\30A4\30A2\30ED\30B0\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30C6\30FC\30DE\3067\5B9A\7FA9\3055\308C\307E\3059\3002'),
unistr('        \30C0\30A4\30A2\30ED\30B0\30FB\30DA\30FC\30B8\304C\4F5C\6210\3055\308C\308B\3068\3001\30C6\30F3\30D7\30EC\30FC\30C8\306F\3001\73FE\5728\306E\30C6\30FC\30DE\306B\5B9A\7FA9\3055\308C\3066\3044\308B\30C7\30D5\30A9\30EB\30C8\30FB\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\4F7F\7528\3057\3066\30DA\30FC\30B8\3092\30EC\30F3\30C0\30EA\30F3\30B0\3059\308B<em>\300C\30C6\30FC\30DE\306E\30C7\30D5\30A9\30EB\30C8\5024\300D</em>\306B\81EA\52D5\7684\306B\8A2D\5B9A\3055\308C\307E\3059\3002'),
unistr('        \3053\3053\3067\9078\629E\3059\308B\3068\3001\30C7\30D5\30A9\30EB\30C8\30FB\30C0\30A4\30A2\30ED\30B0\30FB\30C6\30F3\30D7\30EC\30FC\30C8\304C\30AA\30FC\30D0\30FC\30E9\30A4\30C9\3055\308C\307E\3059\3002</p>'),
unistr('        <p>\30E6\30CB\30D0\30FC\30B5\30EB\30FB\30C6\30FC\30DE\306B\306F\3001\6B21\306E\30C0\30A4\30A2\30ED\30B0\30FB\30C6\30F3\30D7\30EC\30FC\30C8\304C\3042\308A\307E\3059\3002'),
'          <dl>',
unistr('            <dt>\30E2\30FC\30C0\30EB\30FB\30C0\30A4\30A2\30ED\30B0</dt>'),
unistr('              <dd>\307B\3068\3093\3069\306E\30C0\30A4\30A2\30ED\30B0\306E\30E6\30FC\30B9\30B1\30FC\30B9\306B\4FBF\5229\3067\3059\3002</dd>'),
unistr('            <dt>\30A6\30A3\30B6\30FC\30C9\30FB\30E2\30FC\30C0\30EB\30FB\30C0\30A4\30A2\30ED\30B0</dt>'),
unistr('              <dd>\52B9\7387\7684\306A\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\304C\63D0\4F9B\3055\308C\308B\305F\3081\3001\30E2\30FC\30C0\30EB\30FB\30C0\30A4\30A2\30ED\30B0\30FB\30A6\30A3\30B6\30FC\30C9\3001\30A2\30E9\30FC\30C8\3001\901A\77E5\307E\305F\306F\5C0F\3055\3044\30D5\30A9\30FC\30E0\306B\9069\3057\3066\3044\307E\3059\3002</dd>'),
'          </dl>',
unistr('          \95A2\9023\9805\76EE: <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\30E6\30CB\30D0\30FC\30B5\30EB\30FB\30C6\30FC\30DE\306E\30B5\30F3\30D7\30EB\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3</a>'),
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104007800931308441)
,p_name=>'PE.PROPERTY.DIALOG_TEMPLATE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C0\30A4\30A2\30ED\30B0\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103872267504308302)
,p_name=>'PE.PROPERTY.DIALOG_WIDTH.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30C0\30A4\30A2\30ED\30B0\306E\5E45\3092\30D4\30AF\30BB\30EB\307E\305F\306F\30D1\30FC\30BB\30F3\30C6\30FC\30B8\3067\5165\529B\3057\307E\3059\3002'),
unistr('\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306E\30C0\30A4\30A2\30ED\30B0\521D\671F\5316\30B3\30FC\30C9\5185\306E\7F6E\63DB\6587\5B57\5217<code>#DIALOG_WIDTH#</code>\306F\3001\3053\306E\30A2\30A4\30C6\30E0\306B\5165\529B\3057\305F\5024\3067\7F6E\63DB\3055\308C\307E\3059\3002</p>'),
unistr('<p>\30C7\30B9\30AF\30C8\30C3\30D7\30FB\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\3092\4F7F\7528\3057\305F\30DA\30FC\30B8\306E\5834\5408\3001\5024\306F<strong><em>500</em></strong>\306A\3069\306E\3088\3046\306B\30D4\30AF\30BB\30EB\3067\8A2D\5B9A\3055\308C\307E\3059\3002'),
unistr('\305F\3060\3057\3001jQuery Mobile\30B9\30DE\30FC\30C8\30D5\30A9\30F3\30FB\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\3092\4F7F\7528\3057\305F\30DA\30FC\30B8\306E\5834\5408\3001\5024\306F<strong><em>80%</em></strong>\306A\3069\306E\3088\3046\306B\30D1\30FC\30BB\30F3\30C8\3067\8A2D\5B9A\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103872196460308302)
,p_name=>'PE.PROPERTY.DIALOG_WIDTH.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5E45')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104190287141308601)
,p_name=>'PE.PROPERTY.DIRECTION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30E9\30E1\30FC\30BF\306E\65B9\5411\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104190339796308602)
,p_name=>'PE.PROPERTY.DIRECTION.LOV.IN.D'
,p_message_language=>'ja'
,p_message_text=>'In'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104190592744308602)
,p_name=>'PE.PROPERTY.DIRECTION.LOV.IN_OUT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\51FA\529B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104190411978308602)
,p_name=>'PE.PROPERTY.DIRECTION.LOV.OUT.D'
,p_message_language=>'ja'
,p_message_text=>'Out'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104190169582308601)
,p_name=>'PE.PROPERTY.DIRECTION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B9\5411')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104236382890308636)
,p_name=>'PE.PROPERTY.DISABLE_SORT_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\3092\30BD\30FC\30C8\3059\308B\305F\3081\306B\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\3088\3063\3066\3053\306E\5217\304C\4F7F\7528\3055\308C\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104236297451308636)
,p_name=>'PE.PROPERTY.DISABLE_SORT_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BD\30FC\30C8\53EF\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104267988470308659)
,p_name=>'PE.PROPERTY.DISPLAY_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30EC\30F3\30C0\30FB\30BB\30EB\306B\8868\793A\3059\308B1\3064\306E\5217\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104267834551308659)
,p_name=>'PE.PROPERTY.DISPLAY_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103883615763308311)
,p_name=>'PE.PROPERTY.DISPLAY_EXTRA_VALUES.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30A2\30A4\30C6\30E0\306B\3001\7279\5B9A\306ELOV\5B9A\7FA9\306B\306A\3044\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\5024\304C\542B\307E\308C\308B\3053\3068\304C\3042\308A\307E\3059\3002'),
unistr('\3053\306ELOV\304C\3001\3053\306E\8FFD\52A0\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\5024\3092\8868\793A\3059\308B\304B\3069\3046\304B\3092\9078\629E\3057\307E\3059\3002'),
unistr('\3053\306E\8FFD\52A0\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\5024\3092\8868\793A\3057\306A\3044\3088\3046\9078\629E\3057\3001LOV\5B9A\7FA9\5185\306B\4E00\81F4\3059\308B\5024\304C\306A\3044\5834\5408\3001LOV\5185\306E\6700\521D\306E\5024\304C\9078\629E\3055\308C\3001\8868\793A\3055\308C\308B\5024\3067\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103883568833308311)
,p_name=>'PE.PROPERTY.DISPLAY_EXTRA_VALUES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8FFD\52A0\5024\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103883843047308311)
,p_name=>'PE.PROPERTY.DISPLAY_NULL_VALUE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30A4\30C6\30E0\306B\4F7F\7528\3055\308C\308BLOV\3067NULL\5024\3092\30EA\30B9\30C8\306E\6700\4E0A\90E8\306B\8868\793A\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103883744667308311)
,p_name=>'PE.PROPERTY.DISPLAY_NULL_VALUE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('NULL\5024\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103926464022308379)
,p_name=>'PE.PROPERTY.DISPLAY_POINT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306E\8868\793A\306B\4F7F\7528\3059\308B\4F4D\7F6E\3092\9078\629E\3057\307E\3059\3002\4F4D\7F6E\306F\3001\9069\5207\306A\30DA\30FC\30B8\307E\305F\306F\30EA\30FC\30B8\30E7\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306E\8868\793A\30DD\30A4\30F3\30C8\304B\3089\5C0E\51FA\3055\308C\307E\3059\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103926355159308379)
,p_name=>'PE.PROPERTY.DISPLAY_POINT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104581535259308904)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.COMPONENT_PROPERTY.CARD_ACTION.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\3053\306E\30A2\30AF\30B7\30E7\30F3\306E\8868\793A\9806\5E8F\3092\5165\529B\3057\307E\3059\3002'),
unistr('\3053\308C\306F\3001\8868\793A\6761\4EF6\3092\8A55\4FA1\3057\3001\5B9A\7FA9\3055\308C\305F\9806\5E8F\3067\30EC\30F3\30C0\30EA\30F3\30B0\3059\308B\305F\3081\306B\4F7F\7528\3055\308C\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104113225699308527)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\5217\306E\8868\793A\9806\5E8F\3092\5165\529B\3057\307E\3059\3002\9806\5E8F\8A2D\5B9A\306B\3088\3063\3066\3001\3053\306E\5217\304C\8868\793A\3055\308C\308B\3001\4ED6\306E\5217\3068\76F8\5BFE\3057\305F\30EA\30FC\30B8\30E7\30F3\5185\306E\4F4D\7F6E\304C\6C7A\307E\308A\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8: \540C\3058\30EA\30FC\30B8\30E7\30F3\5185\306E2\3064\306E\5217\306E\9806\5E8F\5024\304C\540C\3058\5834\5408\3001\30C6\30B9\30C8\74B0\5883\3068\672C\756A\74B0\5883\306A\3069\306E\3088\3046\306B\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304C\30A8\30AF\30B9\30DD\30FC\30C8\3055\308C\3066\5225\306E\74B0\5883\306B\30A4\30F3\30DD\30FC\30C8\3055\308C\308B\3068\7570\306A\308B\9806\5E8F\3067\8868\793A\3055\308C\308B\5834\5408\304C\3042\308A\307E\3059\3002'),
unistr('\4E00\8CAB\6027\3092\4FDD\3064\305F\3081\306B\3001\5404\30A2\30A4\30C6\30E0(\5C11\306A\304F\3068\3082\540C\3058\30EA\30FC\30B8\30E7\30F3\5185\306E\5404\30A2\30A4\30C6\30E0)\306B\4E00\610F\306E\9806\5E8F\756A\53F7\3092\6307\5B9A\3059\308B\3053\3068\3092\304A\85A6\3081\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104205282018308613)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.COMPONENT_PROPERTY.IR_COLUMN_GROUP.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\5217\30B0\30EB\30FC\30D7\306E\8868\793A\9806\5E8F\3092\5165\529B\3057\307E\3059\3002\3053\306E\9806\5E8F\306F\3001\8A73\7D30\30D3\30E5\30FC\3067\5217\30B0\30EB\30FC\30D7\304C\8868\793A\3055\308C\308B\9806\756A\3092\6C7A\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104539078109308867)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30EC\30A4\30E4\30FC\306E\8868\793A\9806\5E8F\3092\5165\529B\3057\307E\3059\3002\9806\5E8F\8A2D\5B9A\306B\3088\3063\3066\3001\30DE\30C3\30D7\30FB\30EC\30A4\30E4\30FC\304C\4E92\3044\306B\91CD\306A\308A\5408\3063\3066\8868\793A\3055\308C\308B\9806\5E8F\304C\6C7A\307E\308A\307E\3059\3002\756A\53F7\306E\5927\304D\3044\30EC\30A4\30E4\30FC\306F\3001\756A\53F7\306E\5C0F\3055\3044\30EC\30A4\30E4\30FC\306E\4E0A\306B\8868\793A\3055\308C\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8: 2\3064\306E\30DE\30C3\30D7\30FB\30EC\30A4\30E4\30FC\306E\9806\5E8F\5024\304C\540C\3058\5834\5408\3001\30C6\30B9\30C8\74B0\5883\3068\672C\756A\74B0\5883\306A\3069\306E\3088\3046\306B\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304C\30A8\30AF\30B9\30DD\30FC\30C8\3055\308C\3066\5225\306E\74B0\5883\306B\30A4\30F3\30DD\30FC\30C8\3055\308C\308B\3068\7570\306A\308B\9806\5E8F\3067\8868\793A\3055\308C\308B\5834\5408\304C\3042\308A\307E\3059\3002'),
unistr('\4E00\8CAB\6027\3092\4FDD\3064\305F\3081\306B\3001\5404\30EC\30A4\30E4\30FC(\5C11\306A\304F\3068\3082\540C\3058\30DE\30C3\30D7\30FB\30EA\30FC\30B8\30E7\30F3\5185\306E\5404\30EC\30A4\30E4\30FC)\306B\4E00\610F\306E\9806\5E8F\756A\53F7\3092\6307\5B9A\3059\308B\3053\3068\3092\304A\85A6\3081\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103902077716308329)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30A2\30A4\30C6\30E0\306E\8868\793A\9806\5E8F\3092\5165\529B\3057\307E\3059\3002\9806\5E8F\304A\3088\3073\4ED6\306E\30EC\30A4\30A2\30A6\30C8\8A2D\5B9A\306B\3088\3063\3066\3001\3053\306E\30A2\30A4\30C6\30E0\304C\8868\793A\3055\308C\308B\3001\4ED6\306E\30A2\30A4\30C6\30E0\3068\76F8\5BFE\3057\305F\30EA\30FC\30B8\30E7\30F3\5185\306E\4F4D\7F6E\304C\6C7A\307E\308A\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8: \540C\3058\30EA\30FC\30B8\30E7\30F3\5185\306E2\3064\306E\30A2\30A4\30C6\30E0\306E\9806\5E8F\5024\304C\540C\3058\5834\5408\3001\30C6\30B9\30C8\74B0\5883\3068\672C\756A\74B0\5883\306A\3069\306E\3088\3046\306B\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304C\30A8\30AF\30B9\30DD\30FC\30C8\3055\308C\3066\5225\306E\74B0\5883\306B\30A4\30F3\30DD\30FC\30C8\3055\308C\308B\3068\7570\306A\308B\9806\5E8F\3067\8868\793A\3055\308C\308B\5834\5408\304C\3042\308A\307E\3059\3002\4E00\8CAB\6027\3092\4FDD\3064\305F\3081\306B\3001\5404\30A2\30A4\30C6\30E0(\5C11\306A\304F\3068\3082\540C\3058\30EA\30FC\30B8\30E7\30F3\5185\306E\5404\30A2\30A4\30C6\30E0)\306B\4E00\610F\306E\9806\5E8F\756A\53F7\3092\6307\5B9A\3059\308B\3053\3068\3092\304A\85A6\3081\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103901943929308329)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104723173730309019)
,p_name=>'PE.PROPERTY.DOWNLOAD_AUTH_SCHEME.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30C0\30A6\30F3\30ED\30FC\30C9\3067\304D\308B\30E6\30FC\30B6\30FC\3092\5236\9650\3059\308B\8A8D\53EF\30B9\30AD\30FC\30E0\3092\9078\629E\3057\307E\3059\3002'),
unistr('		\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\30C0\30A6\30F3\30ED\30FC\30C9\3067\304D\308B\305F\3081\306B\306F\3001\3053\306E\8A8D\53EF\30B9\30AD\30FC\30E0\304C\305D\306E\30E6\30FC\30B6\30FC\306B\5BFE\3057\3066TRUE\3068\8A55\4FA1\3055\308C\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>'),
unistr('		<p>\30CE\30FC\30C8 - \8A8D\53EF\30B9\30AD\30FC\30E0\3092\6307\5B9A\3057\306A\3044\5834\5408\3001\3059\3079\3066\306E\30E6\30FC\30B6\30FC\304C\30C0\30A6\30F3\30ED\30FC\30C9\3067\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104723017643309019)
,p_name=>'PE.PROPERTY.DOWNLOAD_AUTH_SCHEME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\53EF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104245796239308643)
,p_name=>'PE.PROPERTY.DOWNLOAD_FILENAME.COMPONENT_PROPERTY.CLASSIC_REPORT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('CSV\30C0\30A6\30F3\30ED\30FC\30C9\30FB\30D5\30A1\30A4\30EB\306E\540D\524D\3092\6307\5B9A\3057\307E\3059\3002\540D\524D\3092\6307\5B9A\3057\306A\3044\5834\5408\3001\30EA\30FC\30B8\30E7\30F3\540D\304C\4F7F\7528\3055\308C\3001\62E1\5F35\5B50.csv\304C\305D\308C\306B\7D9A\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104256809897308651)
,p_name=>'PE.PROPERTY.DOWNLOAD_FILENAME.COMPONENT_PROPERTY.TABULAR_FORM.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('CSV\30C0\30A6\30F3\30ED\30FC\30C9\30FB\30D5\30A1\30A4\30EB\306E\540D\524D\3092\6307\5B9A\3057\307E\3059\3002\540D\524D\3092\6307\5B9A\3057\306A\3044\5834\5408\3001\30EA\30FC\30B8\30E7\30F3\540D\304C\4F7F\7528\3055\308C\3001\62E1\5F35\5B50.csv\304C\305D\308C\306B\7D9A\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104240882294308639)
,p_name=>'PE.PROPERTY.DOWNLOAD_FILENAME.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C0\30A6\30F3\30ED\30FC\30C9\3055\308C\308B\969B\306E\30C9\30AD\30E5\30E1\30F3\30C8\306E\540D\524D\3092\5165\529B\3057\307E\3059\3002\30D5\30A1\30A4\30EB\62E1\5F35\5B50\306F\6307\5B9A\3057\306A\3044\3067\304F\3060\3055\3044\3002\62E1\5F35\5B50\306F\81EA\52D5\7684\306B\8FFD\52A0\3055\308C\307E\3059\3002\3053\306E\5C5E\6027\3092\7A7A\767D\306B\3059\308B\3068\3001\30EA\30FC\30B8\30E7\30F3\540D\304C\30D5\30A1\30A4\30EB\540D\3068\3057\3066\4F7F\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104240716199308639)
,p_name=>'PE.PROPERTY.DOWNLOAD_FILENAME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104208172532308616)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\73FE\5728\8868\793A\3055\308C\3066\3044\308B\5217\306E\30C0\30A6\30F3\30ED\30FC\30C9\306B\30E6\30FC\30B6\30FC\304C\4F7F\7528\3067\304D\308B\30C0\30A6\30F3\30ED\30FC\30C9\5F62\5F0F\3092\78BA\8A8D\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104408549403308764)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.LOV.CSV.D'
,p_message_language=>'ja'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104408675293308764)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.LOV.HTML.D'
,p_message_language=>'ja'
,p_message_text=>'HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104408758617308764)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.LOV.PDF.D'
,p_message_language=>'ja'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104483496740308819)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.LOV.XLSX.D'
,p_message_language=>'ja'
,p_message_text=>'Excel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104208046056308615)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5F62\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104243671203308641)
,p_name=>'PE.PROPERTY.DOWNLOAD_LINK_TEXT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('CSV\30C0\30A6\30F3\30ED\30FC\30C9\3092\8D77\52D5\3059\308B\30EA\30F3\30AF\306E\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104243565491308641)
,p_name=>'PE.PROPERTY.DOWNLOAD_LINK_TEXT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30F3\30AF\30FB\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104240040632308639)
,p_name=>'PE.PROPERTY.DOWNLOAD_TEXT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306E\30C0\30A6\30F3\30ED\30FC\30C9\30FB\30EA\30F3\30AF\306B\4F7F\7528\3059\308B\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\3053\306E\30EA\30F3\30AF\3092\4F7F\7528\3057\3066BLOB\30B3\30F3\30C6\30F3\30C4\3092\30C0\30A6\30F3\30ED\30FC\30C9\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104239906879308639)
,p_name=>'PE.PROPERTY.DOWNLOAD_TEXT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8\306E\30C0\30A6\30F3\30ED\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104271495940308661)
,p_name=>'PE.PROPERTY.DRAG_AND_DROP_AUTHORIZATION_SCHEME.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30C9\30E9\30C3\30B0\30FB\30A2\30F3\30C9\30FB\30C9\30ED\30C3\30D7\3092\4F7F\7528\3057\3066\65E2\5B58\306E\30AB\30EC\30F3\30C0\3092\66F4\65B0\3059\308B\6A29\9650\3092\6301\3064\30E6\30FC\30B6\30FC\3092\5236\9650\3059\308B\8A8D\53EF\30B9\30AD\30FC\30E0\3092\9078\629E\3057\307E\3059\3002'),
unistr('\6307\5B9A\3055\308C\305F\5834\5408\3001\30C9\30E9\30C3\30B0\30FB\30A2\30F3\30C9\30FB\30C9\30ED\30C3\30D7\304C\51E6\7406\3055\308C\308B\305F\3081\306B\306F\3001\3053\306E\8A8D\53EF\30B9\30AD\30FC\30E0\304CTRUE\3068\8A55\4FA1\3055\308C\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104271347675308661)
,p_name=>'PE.PROPERTY.DRAG_AND_DROP_AUTHORIZATION_SCHEME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\53EF\30B9\30AD\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104430020265308780)
,p_name=>'PE.PROPERTY.DRAG_DROP_PROCESS.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\30AB\30B9\30BF\30E0\30FB\30D7\30ED\30BB\30B9</dt>'),
'<dd><pre>',
'declare',
'    l_date_value        varchar2(32767) := apex_application.g_x01;',
'    l_primary_key_value varchar2(32767) := apex_application.g_x02;',
'begin',
'    update emp',
'       set hiredate = to_date(l_date_value, ''YYYYMMDD HH24MISS'')',
'     where rowid    = l_primary_key_value;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104271282593308661)
,p_name=>'PE.PROPERTY.DRAG_DROP_PROCESS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30EC\30F3\30C0\30FB\30A8\30F3\30C8\30EA\3092\30C9\30E9\30C3\30B0\30FB\30A2\30F3\30C9\30FB\30C9\30ED\30C3\30D7\3059\308B\3068\5B9F\884C\3055\308C\308B\30D7\30ED\30BB\30B9\3092\5B9A\7FA9\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104271176136308661)
,p_name=>'PE.PROPERTY.DRAG_DROP_PROCESS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30BB\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104112164453308526)
,p_name=>'PE.PROPERTY.DUPLICATE_VALUE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30B3\30FC\30C9\3092\91CD\8907\3059\308B\5834\5408\306B\5217\306E\30C7\30D5\30A9\30EB\30C8\3092\65E2\5B58\306E\5217\5024\306B\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104112081456308526)
,p_name=>'PE.PROPERTY.DUPLICATE_VALUE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E2\5B58\306E\5024\306E\91CD\8907\30B3\30D4\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103910095543308335)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.COMPONENT_PROPERTY.REGION_PLUGIN_ATTRIBUTES.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30C7\30FC\30BF\64CD\4F5C\8A00\8A9E(DML)\306E\3069\306E\64CD\4F5C\304C\30B5\30DD\30FC\30C8\3055\308C\308B\304B\3092\78BA\8A8D\3057\307E\3059\3002\3053\306E\30D7\30ED\30BB\30B9\3067\306F\3001\30DA\30FC\30B8\3092\9001\4FE1\3059\308B\30DC\30BF\30F3\306E<strong>\300C\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30A2\30AF\30B7\30E7\30F3\300D</strong>\5C5E\6027\306B\57FA\3065\3044\3066DML\64CD\4F5C\304C\5B9F\884C\3055\308C\307E\3059\3002\3053\306E\5C5E\6027\304C\8A2D\5B9A\3055\308C\3066\3044\306A\3044\5834\5408\3001\64CD\4F5C\306F\300C\30EA\30AF\30A8\30B9\30C8\300D\30DC\30BF\30F3\306E\5024\3067\6C7A\5B9A\3055\308C\307E\3059\3002\3053\306E\5024\306F\3001\6B21\306B\793A\3059\3088\3046\306B\3001\30DC\30BF\30F3\540D\306B\57FA\3065\3044\3066\8A2D\5B9A\3055\308C\307E\3059:</p>'),
'<ul>',
unistr('<li><strong>\300C\884C\306E\8FFD\52A0\300D</strong>\306F\6B21\306E\30EA\30AF\30A8\30B9\30C8\5024\3067\30C8\30EA\30AC\30FC\3055\308C\307E\3059: INSERT\3001CREATE\3001CREATE_AGAIN\3001CREATEAGAIN</li>'),
unistr('<li><strong>\300C\884C\306E\66F4\65B0\300D</strong>\306F\6B21\306E\30EA\30AF\30A8\30B9\30C8\5024\3067\30C8\30EA\30AC\30FC\3055\308C\307E\3059: SAVE\3001APPLY CHANGES\3001UPDATE\3001UPDATE ROW\3001CHANGE\3001APPLY\3001APPLY%CHANGES%\3001GET_NEXT%\3001GET_PREV%</li>'),
unistr('<li><strong>\300C\884C\306E\524A\9664\300D</strong>\306F\6B21\306E\30EA\30AF\30A8\30B9\30C8\5024\3067\30C8\30EA\30AC\30FC\3055\308C\307E\3059: DELETE\3001REMOVE\3001DELETE ROW\3001DROP</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104096464447308513)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\5BFE\8A71\30B0\30EA\30C3\30C9\3067\8A31\53EF\3055\308C\308B\30C7\30FC\30BF\64CD\4F5C\3092\78BA\8A8D\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104096783791308514)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.LOV.D.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\306E\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104096550548308513)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.LOV.I.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104096680487308513)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.LOV.U.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\306E\66F4\65B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104096316596308513)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9F\884C\53EF\80FD\306A\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104096916184308514)
,p_name=>'PE.PROPERTY.EDIT_ROW_OPERATIONS_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5217\5024\304C\884C\3092\66F4\65B0\307E\305F\306F\524A\9664\3067\304D\308B\304B\3069\3046\304B\3092\793A\3059\5217\3092\9078\629E\3057\307E\3059\3002\6307\5B9A\53EF\80FD\306A\5024\306F\3001\6B21\306E\3068\304A\308A\3067\3059\3002'),
'        <dl>',
'          <dt>U</dt>',
unistr('            <dd>\884C\3092\66F4\65B0\3067\304D\307E\3059</dd>'),
'          <dt>D</dt>',
unistr('            <dd>\884C\3092\524A\9664\3067\304D\307E\3059</dd>'),
'          <dt>UD</dt>',
unistr('            <dd>\884C\3092\66F4\65B0\307E\305F\306F\524A\9664\3067\304D\307E\3059</dd>'),
'        </dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104096819763308514)
,p_name=>'PE.PROPERTY.EDIT_ROW_OPERATIONS_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A31\53EF\3055\308C\305F\884C\64CD\4F5C\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103888687194308314)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('HTML\8868\30BB\30EB\306B\542B\307E\308C\3066\3044\308B\30A2\30A4\30C6\30E0\306E\305D\306E\30BB\30EB\5185\306E\4F4D\7F6E\5408\305B\3092\9078\629E\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104392218805308751)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.CENTER-BOTTOM.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E2D\592E\4E0B\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104392366064308751)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.CENTER-CENTER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E2D\592E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104392492548308752)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.CENTER-TOP.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E2D\592E\4E0A\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104392110128308751)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.CENTER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E2D\592E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104392682904308752)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.LEFT-BOTTOM.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5DE6\5074\4E0B\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104392767613308752)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.LEFT-CENTER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5DE6\5074\4E2D\592E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104392856326308752)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.LEFT-TOP.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5DE6\5074\4E0A\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104392596930308752)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5DE6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104393079175308752)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.RIGHT-BOTTOM.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\53F3\5074\4E0B\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104393163996308752)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.RIGHT-CENTER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\53F3\5074\4E2D\592E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104393240102308752)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.RIGHT-TOP.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\53F3\5074\4E0A\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104392953243308752)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\53F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103884541165308311)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F4D\7F6E\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103889277430308315)
,p_name=>'PE.PROPERTY.ELEMENT_HEIGHT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8\9818\57DF\3001\30B7\30E3\30C8\30EB\3001\8907\6570\9078\629E\30EA\30B9\30C8\304A\3088\3073\300C\9AD8\3055\5C5E\6027\3092\6307\5B9A\300D\5C5E\6027\3092\30B5\30DD\30FC\30C8\3059\308B\30D7\30E9\30B0\30A4\30F3\30FB\30A2\30A4\30C6\30E0\30FB\30BF\30A4\30D7\306E\9AD8\3055(\304A\304A\3088\305D\306E\884C\6570)\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103889160571308315)
,p_name=>'PE.PROPERTY.ELEMENT_HEIGHT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\9AD8\3055')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104274773016308664)
,p_name=>'PE.PROPERTY.ELEMENT_HEIGHT.UNIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7DDA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103889026304308315)
,p_name=>'PE.PROPERTY.ELEMENT_MAX_CHARACTERS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30A4\30C6\30E0\306B\30E6\30FC\30B6\30FC\304C\5165\529B\3067\304D\308B\6587\5B57\306E\6700\5927\6570\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103888988173308315)
,p_name=>'PE.PROPERTY.ELEMENT_MAX_CHARACTERS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5927\9577')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104274808233308664)
,p_name=>'PE.PROPERTY.ELEMENT_MAX_CHARACTERS.UNIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103889664659308315)
,p_name=>'PE.PROPERTY.ELEMENT_OPTION_HTML_ATTRIBUTES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30B8\30AA\30FB\30B0\30EB\30FC\30D7\307E\305F\306F\4E00\9023\306E\30C1\30A7\30C3\30AF\30FB\30DC\30C3\30AF\30B9\306E\5404\30AA\30D7\30B7\30E7\30F3\3092\8868\793A\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\3001HTML\8868\30BB\30EB\306E\8FFD\52A0\306E\5C5E\6027\3092\7A7A\767D\3067\533A\5207\3063\3066\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103889588799308315)
,p_name=>'PE.PROPERTY.ELEMENT_OPTION_HTML_ATTRIBUTES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30D7\30B7\30E7\30F3\306EHTML\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103890047885308315)
,p_name=>'PE.PROPERTY.ELEMENT_POST_TEXT.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30E9\30B8\30AA\30FB\30B0\30EB\30FC\30D7\307E\305F\306F\4E00\9023\306E\30C1\30A7\30C3\30AF\30FB\30DC\30C3\30AF\30B9\306E\5404\30AA\30D7\30B7\30E7\30F3\3092\8868\793A\3059\308B\3001HTML\8868\30BB\30EB\306E\5F8C\306B\8868\793A\3055\308C\308B\8FFD\52A0\306E\5C5E\6027\3092\5165\529B\3057\307E\3059\3002'),
unistr('HTML\3001JavaScript\304A\3088\3073\30B7\30E7\30FC\30C8\30AB\30C3\30C8\3092\542B\3081\308B\3053\3068\304C\3067\304D\307E\3059\3002</p>'),
unistr('<p>\6B21\306E\7F6E\63DB\6587\5B57\5217\3092\53C2\7167\3067\304D\307E\3059\3002</p>'),
'<dl>',
'  <dt><code>#CURRENT_FORM_ELEMENT#</code></dt>',
unistr('  <dd>\3053\306E\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\304C\95A2\9023\4ED8\3051\3089\308C\3066\3044\308BHTML\30D5\30A9\30FC\30E0\8981\7D20\306E\540D\524D\3092\53D6\5F97\3057\307E\3059\3002</dd>'),
'  <dt><code>#CURRENT_ITEM_NAME#</code></dt>',
unistr('  <dd>\73FE\5728\306E\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306E\540D\524D\3092\53D6\5F97\3057\307E\3059\3002</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103889935398308315)
,p_name=>'PE.PROPERTY.ELEMENT_POST_TEXT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5F8C\306E\30C6\30AD\30B9\30C8 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103889865049308315)
,p_name=>'PE.PROPERTY.ELEMENT_PRE_TEXT.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30E9\30B8\30AA\30FB\30B0\30EB\30FC\30D7\307E\305F\306F\4E00\9023\306E\30C1\30A7\30C3\30AF\30FB\30DC\30C3\30AF\30B9\306E\5404\30AA\30D7\30B7\30E7\30F3\3092\8868\793A\3059\308B\3001HTML\8868\30BB\30EB\306E\524D\306B\8868\793A\3055\308C\308B\8FFD\52A0\306E\5C5E\6027\3092\5165\529B\3057\307E\3059\3002'),
unistr('HTML\3001JavaScript\304A\3088\3073\30B7\30E7\30FC\30C8\30AB\30C3\30C8\3092\542B\3081\308B\3053\3068\304C\3067\304D\307E\3059\3002</p>'),
unistr('<p>\6B21\306E\7F6E\63DB\6587\5B57\5217\3092\53C2\7167\3067\304D\307E\3059\3002</p>'),
'<dl>',
'  <dt><code>#CURRENT_FORM_ELEMENT#</code></dt>',
unistr('  <dd>\3053\306E\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\304C\95A2\9023\4ED8\3051\3089\308C\3066\3044\308BHTML\30D5\30A9\30FC\30E0\8981\7D20\306E\540D\524D\3092\53D6\5F97\3057\307E\3059\3002</dd>'),
'  <dt><code>#CURRENT_ITEM_NAME#</code></dt>',
unistr('  <dd>\73FE\5728\306E\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306E\540D\524D\3092\53D6\5F97\3057\307E\3059\3002</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103889725437308315)
,p_name=>'PE.PROPERTY.ELEMENT_PRE_TEXT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\524D\306E\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103889424087308315)
,p_name=>'PE.PROPERTY.ELEMENT_VALUE_PLACEHOLDER.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30A2\30A4\30C6\30E0\306B\5024\304C\5165\529B\3055\308C\3066\3044\306A\3044\3068\304D\306B\3053\306E\30A2\30A4\30C6\30E0\306B\8868\793A\3055\308C\308B\30D2\30F3\30C8\30FB\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002\30A2\30A4\30C6\30E0\306B\30C6\30AD\30B9\30C8\304C\5165\529B\3055\308C\308B\3068\3001\30D2\30F3\30C8\306F\524A\9664\3055\308C\307E\3059\3002</p>'),
unistr('<p>\3053\306E\30D7\30EC\30FC\30B9\30DB\30EB\30C0\30FC\5C5E\6027\306B\306F\3001\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306B\60F3\5B9A\3055\308C\3066\3044\308B\5024\306E\8AAC\660E\306B\4F7F\7528\3055\308C\308B\77ED\3044\30D2\30F3\30C8\3092\6307\5B9A\3057\307E\3059\3002'),
unistr('\3053\306E\3088\3046\306A\30D2\30F3\30C8\306F\3001\30B5\30F3\30D7\30EB\5024\3001\60F3\5B9A\3055\308C\308B\5F62\5F0F\306E\4F8B\307E\305F\306F\6307\793A(\30BF\30A4\30C8\30EB\3001\8AAC\660E\304A\3088\3073\30BF\30B0\3067\691C\7D22\306A\3069)\3092\8868\793A\3059\308B\5834\5408\306B\6709\7528\3067\3059\3002'),
unistr('\30A2\30AF\30BB\30B7\30D3\30EA\30C6\30A3\4E0A\306E\7406\7531\304B\3089\3001\3053\306E\5C5E\6027\306F\3001\660E\78BA\306B\5B9A\7FA9\3055\308C\3001\610F\5473\306E\3042\308B\30E9\30D9\30EB\306E\304B\308F\308A\3068\3057\3066\4F7F\7528\3057\306A\3044\3067\304F\3060\3055\3044\3002</p>'),
unistr('<p><strong>\6CE8\610F: </strong>\3053\308C\306FHTML5\306E\6A5F\80FD\3067\3001\6700\8FD1\306E\30D6\30E9\30A6\30B6\3067\306E\307F\6A5F\80FD\3057\307E\3059\3002\53E4\3044\30D6\30E9\30A6\30B6\3067\306F\3001\3053\306E\5C5E\6027\306B\5165\529B\3055\308C\305F\30C6\30AD\30B9\30C8\306F\8868\793A\3055\308C\307E\305B\3093\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103889384298308315)
,p_name=>'PE.PROPERTY.ELEMENT_VALUE_PLACEHOLDER.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024\306E\30D7\30EC\30FC\30B9\30DB\30EB\30C0\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103888864545308314)
,p_name=>'PE.PROPERTY.ELEMENT_WIDTH.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30A4\30C6\30E0\306E\8868\793A\306B\4F7F\7528\3055\308C\308B\30D5\30A9\30FC\30E0\8981\7D20\306E\5E45\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103888766144308314)
,p_name=>'PE.PROPERTY.ELEMENT_WIDTH.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5E45')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104274664351308664)
,p_name=>'PE.PROPERTY.ELEMENT_WIDTH.UNIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104409694313308764)
,p_name=>'PE.PROPERTY.EMAIL_FROM_ADDRESS.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>john.doe@abc.com</code></li>',
'<li><code>&amp;MY_APP_EMAIL_FROM.</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104210988872308618)
,p_name=>'PE.PROPERTY.EMAIL_FROM_ADDRESS.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30EC\30DD\30FC\30C8\304B\3089\96FB\5B50\30E1\30FC\30EB\3092\9001\4FE1\3059\308B\969B\306B<em>\5DEE\51FA\4EBA</em>\30A2\30C9\30EC\30B9\3068\3057\3066\4F7F\7528\3059\308B\6709\52B9\306A\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9\3092\5165\529B\3057\307E\3059\3002\96FB\5B50\30E1\30FC\30EB\306F\3001\96FB\5B50\30E1\30FC\30EB\30FB\30BF\30A4\30D7\304A\3088\3073\30B5\30D6\30B9\30AF\30EA\30D7\30B7\30E7\30F3\30FB\30BF\30A4\30D7\306E\30C0\30A6\30F3\30ED\30FC\30C9\306E\5834\5408\306B\3053\306E\30EC\30DD\30FC\30C8\304B\3089\9001\4FE1\3055\308C\307E\3059\3002</p>'),
unistr('<p>\5024\306F\3001\6709\52B9\306A\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9\3092\542B\3080\30EA\30C6\30E9\30EB\6587\5B57\5217\3001\307E\305F\306F\7F6E\63DB\69CB\6587\3092\4F7F\7528\3057\3066\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\5B9A\7FA9\3055\308C\305F\9759\7684\7F6E\63DB\53C2\7167\3067\3059\3002'),
unistr('\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\7F6E\63DB\306F\3001\3053\308C\3089\306E\30A2\30A4\30C6\30E0\304C\6709\52B9\306A\30BB\30C3\30B7\30E7\30F3\5916\3067\30A2\30AF\30BB\30B9\3067\304D\305A\3001\96FB\5B50\30E1\30FC\30EB\30FB\30C0\30A6\30F3\30ED\30FC\30C9\3067\306E\307F\6A5F\80FD\3057\3066\30B5\30D6\30B9\30AF\30EA\30D7\30B7\30E7\30F3\3067\306F\6A5F\80FD\3057\306A\3044\305F\3081\3001\63A8\5968\3055\308C\307E\305B\3093\3002'),
unistr('\30B5\30D6\30B9\30AF\30EA\30D7\30B7\30E7\30F3\306F&PRODUCT_NAME.\30A8\30F3\30B8\30F3\304B\3089\76F4\63A5\9001\4FE1\3055\308C\3001\30E6\30FC\30B6\30FC\30FB\30BB\30C3\30B7\30E7\30F3\304B\3089\9001\4FE1\3055\308C\307E\305B\3093\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104210801377308617)
,p_name=>'PE.PROPERTY.EMAIL_FROM_ADDRESS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\9001\4FE1\8005\30A2\30C9\30EC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104122501059308535)
,p_name=>'PE.PROPERTY.ENABLE_CONTROL_BREAK.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\30B3\30F3\30C8\30ED\30FC\30EB\30FB\30D6\30EC\30FC\30AF\304A\3088\3073\96C6\8A08\3067\3053\306E\5217\3092\4F7F\7528\3067\304D\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002</p>'),
unistr('        <p>\30CE\30FC\30C8 - \3053\308C\3089\306E\64CD\4F5C\3092\8A31\53EF\3059\308B\3068\3001\7279\306B\5927\304D\3044\30C7\30FC\30BF\30FB\30BB\30C3\30C8\3067\30D1\30D5\30A9\30FC\30DE\30F3\30B9\306E\554F\984C\304C\767A\751F\3057\305F\308A\3001\5FC5\8981\306A\5834\5408\306B\5217\7D22\5F15\304C\4F7F\7528\3067\304D\306A\3044\53EF\80FD\6027\304C\3042\308A\307E\3059\3002</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104122467109308535)
,p_name=>'PE.PROPERTY.ENABLE_CONTROL_BREAK.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30C8\30ED\30FC\30EB\30FB\30D6\30EC\30FC\30AF/\96C6\8A08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104100932474308517)
,p_name=>'PE.PROPERTY.ENABLE_DOWNLOAD.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\6307\5B9A\3055\308C\305F\30C0\30A6\30F3\30ED\30FC\30C9\5F62\5F0F\306E\3044\305A\308C\304B\306B\30EC\30DD\30FC\30C8\3092\30C0\30A6\30F3\30ED\30FC\30C9\3067\304D\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104100884348308517)
,p_name=>'PE.PROPERTY.ENABLE_DOWNLOAD.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C0\30A6\30F3\30ED\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104105025436308521)
,p_name=>'PE.PROPERTY.ENABLE_FILTER.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\3053\306E\5217\3092\30D5\30A3\30EB\30BF\3067\304D\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104104934356308520)
,p_name=>'PE.PROPERTY.ENABLE_FILTER.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6709\52B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104121702423308534)
,p_name=>'PE.PROPERTY.ENABLE_FLASHBACK.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\3053\306E\5BFE\8A71\30B0\30EA\30C3\30C9\306B\5BFE\3057\3066\30D5\30E9\30C3\30B7\30E5\30D0\30C3\30AF\554F\5408\305B\3092\4F7F\7528\3067\304D\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002</p>'),
unistr('<p>\30D5\30E9\30C3\30B7\30E5\30D0\30C3\30AF\554F\5408\305B\3067\306F\3001Oracle Flashback Technology\304A\3088\3073\30C7\30FC\30BF\30D9\30FC\30B9\306EPoint-in-Time\30EA\30AB\30D0\30EA\3092\4F7F\7528\3057\3066\904E\53BB\306E\3042\308B\6642\70B9\306B\5B58\5728\3057\3066\3044\305F\30C7\30FC\30BF\3092\8868\793A\3057\307E\3059\3002\30E6\30FC\30B6\30FC\306F\3053\306E\30C7\30FC\30BF\306E\554F\5408\305B\306E\307F\3067\304D\307E\3059\3002\30C7\30FC\30BF\306E\5909\66F4\3092\53D6\308A\6D88\3059\3053\3068\306F\3067\304D\307E\305B\3093\3002\3069\3053\307E\3067\9061\3063\3066\30D5\30E9\30C3\30B7\30E5\30D0\30C3\30AF\554F\5408\305B\3092\6B63\5E38\306B\5B9F\884C\3067\304D\308B\304B\306F\3001Oracle Database\5185\3067REDO\30ED\30B0\30FB\30D5\30A1\30A4\30EB\304C\6700\5F8C\306B\3044\3064\5207\308A\66FF\308F\3063\305F\304B\306B\3088\3063\3066\6C7A\307E\308A\307E\3059\3002\3053\308C\306F\3001\3053\306E\30C6\30AF\30CE\30ED\30B8\3067RMAN\30D0\30C3\30AF\30A2\30C3\30D7\304C\4F7F\7528\3055\308C\308B')
||unistr('\305F\3081\3067\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104121655607308534)
,p_name=>'PE.PROPERTY.ENABLE_FLASHBACK.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30E9\30C3\30B7\30E5\30D0\30C3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104122381135308535)
,p_name=>'PE.PROPERTY.ENABLE_HIDE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\3053\306E\5217\3092\975E\8868\793A\306B\3067\304D\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104122295318308535)
,p_name=>'PE.PROPERTY.ENABLE_HIDE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\975E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104101596429308518)
,p_name=>'PE.PROPERTY.ENABLE_MAIL_DOWNLOAD.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\6DFB\4ED8\3068\3057\3066\542B\307E\308C\308B\30EC\30DD\30FC\30C8\30FB\30C0\30A6\30F3\30ED\30FC\30C9\3068\3068\3082\306B\96FB\5B50\30E1\30FC\30EB\3092\9001\4FE1\3067\304D\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002</p>'),
unistr('<p>\96FB\5B50\30E1\30FC\30EB\306F\8A8D\8A3C\6E08\30E6\30FC\30B6\30FC\306E\307F\304C\4F7F\7528\53EF\80FD\3067\3001&PRODUCT_NAME.\7BA1\7406\30B5\30FC\30D3\30B9\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5185\3067\30A4\30F3\30B9\30BF\30F3\30B9\7BA1\7406\8005\304CSMTP\3092\69CB\6210\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104101456467308518)
,p_name=>'PE.PROPERTY.ENABLE_MAIL_DOWNLOAD.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\3067\9001\4FE1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104350529253308719)
,p_name=>'PE.PROPERTY.ENABLE_PRINTING.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\306E\51FA\529B\3092\6709\52B9\5316\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002<strong>\300C\30AA\30F3\300D</strong>\3092\9078\629E\3059\308B\3068\3001\30E6\30FC\30B6\30FC\306F\3001PDF\3001Microsoft Word\3001Microsoft Excel\3001HTML\306A\3069\306E\69D8\3005\306A\66F8\5F0F\3067\30EC\30DD\30FC\30C8\3092\30C0\30A6\30F3\30ED\30FC\30C9\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104350430752308719)
,p_name=>'PE.PROPERTY.ENABLE_PRINTING.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6709\52B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104100310224308517)
,p_name=>'PE.PROPERTY.ENABLE_SAVE_PUBLIC_REPORT.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\73FE\5728\306E\30EC\30DD\30FC\30C8\5B9A\7FA9\3092<em>\30D1\30D6\30EA\30C3\30AF</em>\30FB\30EC\30DD\30FC\30C8\3068\3057\3066\4FDD\5B58\3067\304D\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002</p>'),
unistr('		<p>\30D1\30D6\30EA\30C3\30AF\30FB\30EC\30DD\30FC\30C8\306F\30C4\30FC\30EB\30D0\30FC\306E\4F7F\7528\53EF\80FD\306A\30EC\30DD\30FC\30C8\306E\9078\629E\30EA\30B9\30C8\306B\8868\793A\3055\308C\3001\5168\54E1\306B\8868\793A\3055\308C\307E\3059\3002<p>'),
unistr('		<p>\30CE\30FC\30C8 - \3053\306E\30AA\30D7\30B7\30E7\30F3\306F\3001\8A8D\8A3C\3055\308C\305F\30E6\30FC\30B6\30FC\306E\307F\4F7F\7528\3067\304D\3001<strong>\300C\30D1\30D6\30EA\30C3\30AF\30FB\30EC\30DD\30FC\30C8\306E\4FDD\5B58\306E\8A8D\53EF\300D</strong>\3082\7D44\307F\8FBC\3080\3068\3001\3055\3089\306B\9650\5B9A\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104100221725308517)
,p_name=>'PE.PROPERTY.ENABLE_SAVE_PUBLIC_REPORT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30D6\30EA\30C3\30AF\30FB\30EC\30DD\30FC\30C8\306E\4FDD\5B58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104110162435308525)
,p_name=>'PE.PROPERTY.ENABLE_SORT_GROUP.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\30BD\30FC\30C8\3067\3053\306E\5217\3092\4F7F\7528\3067\304D\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002</p>'),
unistr('        <p>\30CE\30FC\30C8 - \30BD\30FC\30C8\64CD\4F5C\3092\8A31\53EF\3059\308B\3068\3001\7279\306B\5927\304D\3044\30C7\30FC\30BF\30FB\30BB\30C3\30C8\3067\30D1\30D5\30A9\30FC\30DE\30F3\30B9\306E\554F\984C\304C\767A\751F\3057\305F\308A\3001\5FC5\8981\306A\5834\5408\306B\5217\7D22\5F15\304C\4F7F\7528\3067\304D\306A\3044\53EF\80FD\6027\304C\3042\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104110035547308525)
,p_name=>'PE.PROPERTY.ENABLE_SORT_GROUP.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104100739351308517)
,p_name=>'PE.PROPERTY.ENABLE_SUBSCRIPTIONS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\3053\306E\30EC\30DD\30FC\30C8\306B\30B5\30D6\30B9\30AF\30EA\30D7\30B7\30E7\30F3\8A2D\5B9A\3092\5B9A\7FA9\3067\304D\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104100630778308517)
,p_name=>'PE.PROPERTY.ENABLE_SUBSCRIPTIONS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30D6\30B9\30AF\30EA\30D7\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103897471742308325)
,p_name=>'PE.PROPERTY.ENCRYPT_SESSION_STATE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\306B\683C\7D0D\3059\308B\969B\3001\3053\306E\30A2\30A4\30C6\30E0\3092\6697\53F7\5316\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002'),
unistr('\30A2\30A4\30C6\30E0\306E\30B3\30F3\30C6\30F3\30C4\306B\6A5F\5BC6\30C7\30FC\30BF\304C\542B\307E\308C\308B\5834\5408\3001&PRODUCT_NAME.\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\7BA1\7406\8868\306B\683C\7D0D\3059\308B\969B\3001\5024\3092\6697\53F7\5316\3059\308B\3053\3068\3092\304A\85A6\3081\3057\307E\3059\3002'),
unistr('\305D\3046\3057\306A\3044\3068\3001&PRODUCT_NAME.\30E1\30BF\30FB\30C7\30FC\30BF\8868\3092\8AAD\307F\53D6\308B\6A29\9650\3092\6301\3064\30E6\30FC\30B6\30FC\304C\554F\5408\305B\3092\8A18\8FF0\3057\3001\3053\306E\6A5F\5BC6\30C7\30FC\30BF\3092\5F97\308B\53EF\80FD\6027\304C\3042\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103897390535308325)
,p_name=>'PE.PROPERTY.ENCRYPT_SESSION_STATE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\306B\6697\53F7\5316\3055\308C\305F\5024\3092\4FDD\5B58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104268924898308660)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9031\6B21\30AB\30EC\30F3\30C0\306B\8868\793A\3055\308C\308B\9031\306E\6700\5F8C\306E\65E5\3092\9078\629E\3057\307E\3059\3002'),
unistr('\3053\306E\5C5E\6027\3092<strong>\958B\59CB\65E5</strong>\3068\3042\308F\305B\3066\4F7F\7528\3057\3066\8868\793A\3055\308C\308B\65E5\3092\5236\9650\3057\305F\308A\3001<strong>\958B\59CB\65E5</strong>\306E\5024\3088\308A\524D\306E\65E5\3092\9078\629E\3057\30667\65E5\9593\3059\3079\3066\3092\8868\793A\3057\305F\308A\3067\304D\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104428235309308778)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721105.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5\66DC\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104428372084308778)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721106.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6708\66DC\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104428471932308778)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721107.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\706B\66DC\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104428599477308778)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721108.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6C34\66DC\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104428638480308779)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721109.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6728\66DC\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104428752974308779)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721110.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\91D1\66DC\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104428889450308779)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721111.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\571F\66DC\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104268870773308659)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D42\4E86\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104269543737308660)
,p_name=>'PE.PROPERTY.END_TIME.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9031\6B21\304A\3088\3073\65E5\6B21\30AB\30EC\30F3\30C0\306E\8868\793A\306E\30D5\30A9\30FC\30AB\30B9\306E\7D42\4E86\6642\9593\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104269429373308660)
,p_name=>'PE.PROPERTY.END_TIME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D42\4E86\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104270824914308661)
,p_name=>'PE.PROPERTY.ENTRY_LINK_TARGET.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E2\30FC\30C0\30EB\30FB\30C0\30A4\30A2\30ED\30B0\3092\8D77\52D5\3059\308B\30BF\30FC\30B2\30C3\30C8\3092\30AF\30EA\30C3\30AF\3057\307E\3059\3002\65E2\5B58\306E\30A4\30D9\30F3\30C8\306E\8A73\7D30\3092\8868\793A\3059\308B\5834\5408\306B\30AB\30EC\30F3\30C0\3067\30B3\30FC\30EB\3055\308C\308B\30BF\30FC\30B2\30C3\30C8\30FB\30EA\30F3\30AF\3092\5165\529B\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104270777207308661)
,p_name=>'PE.PROPERTY.ENTRY_LINK_TARGET.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30D9\30F3\30C8\30FB\30BF\30FC\30B2\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103871078234308301)
,p_name=>'PE.PROPERTY.ERROR_HANDLING_FUNCTION.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5185\3067\30A8\30E9\30FC\304C\767A\751F\3057\305F\969B\306B\30B3\30FC\30EB\3055\308C\308BPL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\306E\540D\524D\3092\5165\529B\3057\307E\3059\3002'),
unistr('\3053\306E\30D5\30A1\30F3\30AF\30B7\30E7\30F3\3092\4F7F\7528\3057\3066\3001Oracle Database\3067\767A\751F\3057\305F\30A8\30E9\30FC\3092\542B\3080\69D8\3005\306A\30A8\30E9\30FC\30FB\30B3\30FC\30C9\306B\5BFE\51E6\3057\3001\5FC5\8981\306B\5FDC\3058\3066\5B9A\7FA9\3057\305F\30AB\30B9\30BF\30E0\8868\306B\305D\308C\3089\306E\30A8\30E9\30FC\3092\8A18\9332\3057\307E\3059\3002'),
unistr('\30D5\30A1\30F3\30AF\30B7\30E7\30F3\306B\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\3092\5909\66F4\3057\3001\5834\6240\3092\8868\793A\3059\308B\30ED\30B8\30C3\30AF\3092\542B\3081\3001Oracle Database\30A8\30E9\30FC\3092\30E6\30FC\30B6\30FC\30FB\30D5\30EC\30F3\30C9\30EA\306A\30E1\30C3\30BB\30FC\30B8\306B\5909\63DB\3067\304D\307E\3059\3002'),
unistr('\305F\3068\3048\3070\3001<code>DEMO_CUSTOMERS</code>\3067\4E00\610F\30AD\30FC\9055\53CD\3092\6355\6349\3057\3001<code>ORA-00001</code>\30E1\30C3\30BB\30FC\30B8\3092\300C\30AB\30B9\30BF\30E0\540D\306F\4E00\610F\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\300D\3068\3044\3046\30C6\30AD\30B9\30C8\306B\7F6E\304D\63DB\3048\307E\3059\3002'),
unistr('\30D1\30C3\30B1\30FC\30B8\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304B\3089\30B5\30F3\30D7\30EB\30FB\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\30A4\30F3\30B9\30C8\30FC\30EB\3059\308B\3068\3001<code>SAMPLE_PKG</code>\30D1\30C3\30B1\30FC\30B8\304C\4F5C\6210\3055\308C\3001\3053\308C\306B<code>demo_error_handling</code>\30D5\30A1\30F3\30AF\30B7\30E7\30F3\304C\542B\307E\308C\3066\3044\307E\3059\3002'),
unistr('\3053\306E\30B5\30F3\30D7\30EB\30FB\30A8\30E9\30FC\51E6\7406\30D5\30A1\30F3\30AF\30B7\30E7\30F3\306B\306F\3001\30D5\30A1\30F3\30AF\30B7\30E7\30F3\3092\5B9A\7FA9\3059\308B\305F\3081\306E\30D9\30FC\30B9\3068\3057\3066\7C21\5358\306B\4F7F\7528\3067\304D\308B\3088\3046\591A\6570\306E\30B3\30E1\30F3\30C8\304C\542B\307E\308C\3066\3044\307E\3059\3002</p>'),
unistr('<p>\5165\529B\3055\308C\305F\30D5\30A1\30F3\30AF\30B7\30E7\30F3\540D\3067\30C7\30FC\30BF\30D9\30FC\30B9\5185\306E\30D1\30C3\30B1\30FC\30B8\30FB\30D5\30A1\30F3\30AF\30B7\30E7\30F3\307E\305F\306F\30B9\30BF\30F3\30C9\30A2\30ED\30F3\30FB\30D5\30A1\30F3\30AF\30B7\30E7\30F3\3092\53C2\7167\3067\304D\307E\3059\3002\6B21\306B\4F8B\3092\793A\3057\307E\3059\3002'),
'<pre>',
'log_apex_error',
'</pre>',
'</p>',
unistr('<p>\30C7\30FC\30BF\30D9\30FC\30B9PL/SQL\30D1\30C3\30B1\30FC\30B8\307E\305F\306F\30B9\30BF\30F3\30C9\30A2\30ED\30F3\30FB\30D5\30A1\30F3\30AF\30B7\30E7\30F3\3092\53C2\7167\3059\308B\5834\5408\3001<code>#OWNER#</code>\7F6E\63DB\6587\5B57\5217\3092\4F7F\7528\3057\3066\3001\73FE\5728\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\89E3\6790\30B9\30AD\30FC\30DE\3092\53C2\7167\3067\304D\307E\3059\3002\6B21\306B\4F8B\3092\793A\3057\307E\3059\3002'),
'<pre>#OWNER#.log_apex_error</pre>',
'</p>',
unistr('<p>\30DA\30FC\30B8\306B\30A8\30E9\30FC\51E6\7406\30D5\30A1\30F3\30AF\30B7\30E7\30F3\304C\6307\5B9A\3055\308C\3066\3044\308B\5834\5408\3001\305D\306E\30DA\30FC\30B8\306B\306F\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30EC\30D9\30EB\306E\8A2D\5B9A\306E\304B\308F\308A\306B\305D\308C\304C\4F7F\7528\3055\308C\307E\3059\3002</p>'),
unistr('<p>\30A8\30E9\30FC\51E6\7406\30D5\30A1\30F3\30AF\30B7\30E7\30F3\306F\6B21\306E\30A4\30F3\30BF\30D5\30A7\30FC\30B9\3092\5B9F\88C5\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002'),
'<pre>',
'function &lt;name of function> (',
'    p_error in apex_error.t_error )',
'    return apex_error.t_error_result',
'</pre>',
'</p>',
unistr('<p>\30D1\30C3\30B1\30FC\30B8<code>apex_error</code>\306E\8A73\7D30\306F\3001API\30EA\30D5\30A1\30EC\30F3\30B9\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103880600770308309)
,p_name=>'PE.PROPERTY.ERROR_HANDLING_FUNCTION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC\51E6\7406\30D5\30A1\30F3\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104587233553308908)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.COMPONENT_PROPERTY.APP_COMPUTATION.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\8A08\7B97\304C\5931\6557\3057\305F\5834\5408\306B\8868\793A\3059\308B\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\3092\5165\529B\3057\307E\3059\3002'),
unistr('    \5931\6557\3057\305F\8A08\7B97\306E\7D50\679C\306ESQL\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\306E\7F6E\63DB\6587\5B57\5217\3068\3057\3066<code>#SQLERRM#</code>\3092\4F7F\7528\3057\307E\3059\3002</p>'),
unistr('    <p>\8A08\7B97\306F\5E38\306B\6210\529F\3057\3001\4E88\671F\3057\306A\3044\30A8\30E9\30FC\306B\3088\3063\3066\306E\307F\5931\6557\3059\308B\3088\3046\8A2D\8A08\3055\308C\307E\3059\3002'),
unistr('    \305F\3073\305F\3073\5931\6557\3057\3001\3053\306E\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\3092\4F7F\7528\3057\3066\7591\4F3C\691C\8A3C\3068\3057\3066\6A5F\80FD\3059\308B\8A08\7B97\3092\5B9F\88C5\3059\308B\3053\3068\306F\304A\85A6\3081\3057\307E\305B\3093\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103908806406308334)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.COMPONENT_PROPERTY.PAGE_COMPUTATION.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\8A08\7B97\304C\5931\6557\3057\305F\5834\5408\306B\8868\793A\3059\308B\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\3092\5165\529B\3057\307E\3059\3002'),
unistr('    \5931\6557\3057\305F\8A08\7B97\306E\7D50\679C\306ESQL\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\306E\7F6E\63DB\6587\5B57\5217\3068\3057\3066<code>#SQLERRM#</code>\3092\4F7F\7528\3057\307E\3059\3002</p>'),
unistr('    <p>\8A08\7B97\306F\5E38\306B\6210\529F\3057\3001\4E88\671F\3057\306A\3044\30A8\30E9\30FC\306B\3088\3063\3066\306E\307F\5931\6557\3059\308B\3088\3046\8A2D\8A08\3055\308C\307E\3059\3002'),
unistr('    \305F\3073\305F\3073\5931\6557\3057\3001\3053\306E\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\3092\4F7F\7528\3057\3066\7591\4F3C\691C\8A3C\3068\3057\3066\6A5F\80FD\3059\308B\8A08\7B97\3092\5B9F\88C5\3059\308B\3053\3068\306F\304A\85A6\3081\3057\307E\305B\3093\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104222440750308626)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.COMPONENT_PROPERTY.PAGE_PROCESS.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30D7\30ED\30BB\30B9\306E\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\3092\5165\529B\3057\307E\3059\3002'),
unistr('\672A\51E6\7406\4F8B\5916\304C\767A\751F\3057\305F\5834\5408\3001\3053\306E\30E1\30C3\30BB\30FC\30B8\304C\8868\793A\3055\308C\307E\3059\3002\3069\306E\30A8\30E9\30FC\30FB\30D7\30ED\30BB\30B9\306E\505C\6B62\5F8C\3082\3001\30ED\30FC\30EB\30D0\30C3\30AF\304C\5B9F\884C\3055\308C\3001\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\304C\8868\793A\3055\308C\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8: SQL\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8(sqlerrm)\306F\3001<strong>\300C\30A8\30E9\30FC\30FB\30DA\30FC\30B8\300D</strong>\304C\30A8\30E9\30FC\306E\8868\793A\5834\6240\3068\3057\3066\5B9A\7FA9\3055\308C\3066\3044\308B\5834\5408\3001\30C7\30D5\30A9\30EB\30C8\3067\8868\793A\3055\308C\307E\3059\3002\30A8\30E9\30FC\30FB\30C6\30AD\30B9\30C8\306B<code>#SQLERRM#</code>\3092\8FFD\52A0\3059\308B\5FC5\8981\306F\3042\308A\307E\305B\3093\3002</p>'),
unistr('<p>\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\306B\306F\3001\6B21\306E\7F6E\63DB\6587\5B57\5217\3092\542B\3081\308B\3053\3068\304C\3067\304D\307E\3059\3002</p>'),
'<dl>',
'  <dt><code>#SQLERRM_TEXT#</code></dt>',
unistr('  <dd>\30A8\30E9\30FC\756A\53F7\306A\3057\306E\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\306E\30C6\30AD\30B9\30C8</dd>'),
'  <dt><code>#SQLERRM#</code></dt>',
unistr('  <dd>\5B8C\5168\306A\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104781685513309074)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>unistr('#LABEL#\306B\5024\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103869446920308300)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\691C\8A3C\306B\5408\683C\3057\306A\3044\30A4\30D9\30F3\30C8\3067\8868\793A\3055\308C\308B\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002</p>'),
unistr('<p>\30D7\30EC\30FC\30B9\30DB\30EB\30C0\3068\3057\3066\3001\95A2\9023\4ED8\3051\3089\308C\305F\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306E\30E9\30D9\30EB\306B\306F<code>#LABEL#</code>\3092\3001\95A2\9023\4ED8\3051\3089\308C\305F\7DE8\96C6\53EF\80FD\30EA\30FC\30B8\30E7\30F3\306E\5217\306E\30D8\30C3\30C0\30FC\306B\306F<code>#COLUMN_HEADER#</code>\3092\4F7F\7528\3067\304D\307E\3059\3002\30A8\30E9\30FC\8868\793A\4F4D\7F6E\304C\300C\30A8\30E9\30FC\30FB\30DA\30FC\30B8\300D\306B\8A2D\5B9A\3055\308C\3066\3044\308B\5834\5408\3001\30D7\30EC\30FC\30B9\30DB\30EB\30C0\306F\30B5\30DD\30FC\30C8\3055\308C\307E\305B\3093\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103869323891308300)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103980820914308421)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\3053\306E\691C\8A3C\306E\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\304C\8868\793A\3055\308C\308B\4F4D\7F6E\3092\9078\629E\3057\307E\3059\3002'),
unistr('\691C\8A3C\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\306F\5225\306E\30A8\30E9\30FC\30FB\30DA\30FC\30B8\306B\8868\793A\3055\308C\308B\304B\3001\65E2\5B58\306E\30DA\30FC\30B8\306B\30A4\30F3\30E9\30A4\30F3\3067\8868\793A\3055\308C\307E\3059\3002'),
unistr('\30A4\30F3\30E9\30A4\30F3\30FB\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\306F\3001\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306E\4E00\90E8\3068\3057\3066\5B9A\7FA9\3055\308C\3066\3044\308B<em>\300C\95A2\9023\4ED8\3051\3089\308C\305F\30A2\30A4\30C6\30E0\300D</em>\30E9\30D9\30EB\306E\4E0B/\901A\77E5\9818\57DF\5185\306B\8868\793A\3055\308C\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104401499371308758)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.LOV.INLINE_IN_NOTIFICATION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\901A\77E5\3067\30A4\30F3\30E9\30A4\30F3\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104401389551308758)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.LOV.INLINE_WITH_FIELD.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30FC\30EB\30C9\3067\30A4\30F3\30E9\30A4\30F3\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104401232579308758)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.LOV.INLINE_WITH_FIELD_AND_NOTIFICATION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30FC\30EB\30C9\304A\3088\3073\901A\77E5\3067\30A4\30F3\30E9\30A4\30F3\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104401553576308758)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.LOV.ON_ERROR_PAGE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC\30FB\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103980754221308421)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103897634291308325)
,p_name=>'PE.PROPERTY.ESCAPE_SPECIAL_CHARACTERS.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30AF\30ED\30B9\30B5\30A4\30C8\30FB\30B9\30AF\30EA\30D7\30C6\30A3\30F3\30B0(XSS)\653B\6483\3092\9632\3050\305F\3081\306B\306F\3001\3053\306E\5C5E\6027\3092\5E38\306B<strong>\300C\30AA\30F3\300D</strong>\306B\8A2D\5B9A\3057\307E\3059\3002'),
unistr('\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\307E\305F\306FLOV\306E\30A8\30F3\30C8\30EA\306B\683C\7D0D\3055\308C\3066\3044\308BHTML\30BF\30B0\3092\30EC\30F3\30C0\30EA\30F3\30B0\3059\308B\5FC5\8981\304C\3042\308B\5834\5408\3001\3053\306E\30D5\30E9\30B0\3092<strong>\300C\30AA\30D5\300D</strong>\306B\8A2D\5B9A\3059\308B\3053\3068\304C\3042\308A\307E\3059\3002'),
unistr('\305D\306E\3088\3046\306A\5834\5408\3001\8FFD\52A0\306E\4E88\9632\63AA\7F6E\3092\8B1B\3058\3001\5165\529B\6642\304A\3088\3073\4FDD\5B58\524D\306B\305D\306E\3088\3046\306A\30D5\30A3\30FC\30EB\30C9\3078\306E\30E6\30FC\30B6\30FC\5165\529B\304C\9069\5207\306B\30A8\30B9\30B1\30FC\30D7\3055\308C\308B\3088\3046\306B\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103897565115308325)
,p_name=>'PE.PROPERTY.ESCAPE_SPECIAL_CHARACTERS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7279\6B8A\6587\5B57\3092\30A8\30B9\30B1\30FC\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103869622179308300)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8A8D\53EF\30B9\30AD\30FC\30E0\306F\3001\30BB\30C3\30B7\30E7\30F3\3067\306E\6700\521D\306E\4F7F\7528\6642\306B\8A55\4FA1\3055\308C\307E\3059\3002'),
unistr('\6307\5B9A\3055\308C\305F\8A8D\53EF\306E\305D\306E\5F8C\306E\4F7F\7528\3067\30E1\30E2\30EA\30FC\304B\3089\7D50\679C\3092\53D6\5F97\3059\308B\304B\3001\8A8D\53EF\30B9\30AD\30FC\30E0\3092\518D\8A55\4FA1\3059\308B\304B\3092\6C7A\3081\308B\305F\3081\306E\9069\5207\306A\8A55\4FA1\30DD\30A4\30F3\30C8\3092\9078\629E\3057\307E\3059\3002</p>'),
'#LOV_VALUES#',
unistr('<p>\30C7\30D5\30A9\30EB\30C8\5024<em>\300C\30BB\30C3\30B7\30E7\30F3\3054\3068\306B1\56DE\300D</em>\304C\6700\3082\52B9\7387\7684\3067\3059\3002'),
unistr('\8A8D\53EF\30C1\30A7\30C3\30AF\304C\3001\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\306E\5909\66F4\3084\30BB\30C3\30B7\30E7\30F3\5168\4F53\3067\4E00\8CAB\3057\306A\3044\4ED6\306E\8981\56E0\306B\4F9D\5B58\3059\308B\5834\5408\3001\5225\306E\5024\3092\9078\629E\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002'),
unistr('\30AA\30D7\30B7\30E7\30F3<em>\300C\30B3\30F3\30DD\30FC\30CD\30F3\30C8\3054\3068\306B1\56DE\300D</em>\304A\3088\3073<em>\300C\5E38\6642(\30AD\30E3\30C3\30B7\30E5\306A\3057)\300D</em>\306B\306F\3001\8A8D\53EF\30B9\30AD\30FC\30E0\3067\4F7F\7528\3059\308B\305F\3081\306B\5B9A\7FA9\3067\304D\308B\8FFD\52A0\30D1\30E9\30E1\30FC\30BF\304C\3042\308A\307E\3059\3002'),
unistr('\8A8D\53EF\30D7\30E9\30B0\30A4\30F3\3067\306F\3001<em>t_authorization</em>\30D1\30E9\30E1\30FC\30BF\306E<em>component.type</em>\3001<em>component.id</em>\304A\3088\3073<em>component.name</em>\5C5E\6027\3092\4F7F\7528\3067\304D\307E\3059\3002'),
unistr('\7D44\8FBC\307F\306E<em>\300CEXISTS SQL\554F\5408\305B\300D</em>\304A\3088\3073<em>\300C\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\300D</em>\30B9\30AD\30FC\30E0\30FB\30BF\30A4\30D7\306E\5834\5408\3001\540C\7B49\306E\30D0\30A4\30F3\30C9\5909\6570\306E<em>:APP_COMPONENT_TYPE</em>\3001<em>:APP_COMPONENT_ID</em>\304A\3088\3073<em>:APP_COMPONENT_NAME</em>\3092\4F7F\7528\3067\304D\307E\3059\3002'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104377808441308740)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_COMPONENT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30DD\30FC\30CD\30F3\30C8\3054\3068\306B1\56DE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104377983181308740)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_COMPONENT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\53EF\30B9\30AD\30FC\30E0\3092\53C2\7167\3059\308B\30B3\30F3\30DD\30FC\30CD\30F3\30C8\3054\3068\306B1\56DE\8A55\4FA1\3057\307E\3059\304C\3001\30BB\30C3\30B7\30E7\30F3\306B\7D50\679C\3092\4FDD\5B58\3057\307E\3059\3002\30EC\30F3\30C0\30EA\30F3\30B0\307E\305F\306F\30B9\30AD\30FC\30DE\306E\51E6\7406\306E\4EE5\964D\306E\30EA\30AF\30A8\30B9\30C8\3067\306F\30E1\30E2\30EA\30FC\5185\306E\7D50\679C\3092\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104377635909308740)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_USER_BY_PAGE_VIEW.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30D3\30E5\30FC\3054\3068\306B1\56DE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104377779040308740)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_USER_BY_PAGE_VIEW.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\51E6\7406\3055\308C\308B\30EA\30AF\30A8\30B9\30C8\3054\3068\306B1\56DE\8A55\4FA1\3057\307E\3059\3002\30DA\30FC\30B8\306E\8907\6570\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\3067\8A8D\53EF\30B9\30AD\30FC\30E0\304C\53C2\7167\3055\308C\308B\5834\5408\3001\30E1\30E2\30EA\30FC\5185\306E\7D50\679C\3092\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104377471151308739)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_USER_BY_SESSION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30C3\30B7\30E7\30F3\3054\3068\306B1\56DE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104377541676308739)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_USER_BY_SESSION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('1\56DE\306E\307F\8A55\4FA1\3057\3001\30E1\30E2\30EA\30FC\5185\306E\7D50\679C\3092\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104378081346308740)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.NOCACHE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5E38\6642(\30AD\30E3\30C3\30B7\30E5\306A\3057)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104378138250308740)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.NOCACHE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\53EF\30B9\30AD\30FC\30E0\306F\5E38\306B\8A55\4FA1\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103869575641308300)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A55\4FA1\30DD\30A4\30F3\30C8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103874662934308304)
,p_name=>'PE.PROPERTY.EVENT.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\52D5\7684\30A2\30AF\30B7\30E7\30F3\3092\8D77\52D5\3059\308B\30A4\30D9\30F3\30C8\3092\6307\5B9A\3057\307E\3059\3002'),
unistr('\7279\5B9A\306E\30A4\30D9\30F3\30C8\306E\8A73\7D30\306F\3001<em>\300E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30D3\30EB\30C0\30FC\30FB\30E6\30FC\30B6\30FC\30BA\30FB\30AC\30A4\30C9\300F</em>\306E\95A2\9023\3059\308B\9805\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002</p>'),
unistr('\30A4\30D9\30F3\30C8\306F\3001\6B21\306E\30BF\30A4\30D7\306B\5206\985E\3055\308C\307E\3059\3002'),
'<dl>',
unistr('  <dt>\30D6\30E9\30A6\30B6\30FB\30A4\30D9\30F3\30C8</dt>'),
unistr('    <dd>\6A19\6E96\306E\30D6\30E9\30A6\30B6\30FB\30A4\30D9\30F3\30C8\3002</dd>'),
unistr('  <dt>\30D5\30EC\30FC\30E0\30EF\30FC\30AF\30FB\30A4\30D9\30F3\30C8</dt>'),
unistr('    <dd>\30D5\30EC\30FC\30E0\30EF\30FC\30AF\30FB\30A4\30D9\30F3\30C8\306F\3001Application Express\30D5\30EC\30FC\30E0\30EF\30FC\30AF\5185\304B\3089\30C8\30EA\30AC\30FC\3055\308C\307E\3059\3002</dd>'),
unistr('  <dt>\30B3\30F3\30DD\30FC\30CD\30F3\30C8\30FB\30A4\30D9\30F3\30C8</dt>'),
unistr('    <dd>\30AB\30B9\30BF\30E0\30FB\30A4\30D9\30F3\30C8\3092\30C8\30EA\30AC\30FC\3059\308B\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\4F7F\7528\53EF\80FD\306A\30B3\30F3\30DD\30FC\30CD\30F3\30C8\304C\3042\308B\5834\5408\306B\306E\307F\4F7F\7528\3067\304D\307E\3059\3002\3053\308C\3089\306E\30A4\30D9\30F3\30C8\306F\3001\30CD\30A4\30C6\30A3\30D6\30FB\30B3\30F3\30DD\30FC\30CD\30F3\30C8\304B\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\30A4\30F3\30B9\30C8\30FC\30EB\3055\308C\3066\3044\308B\30D7\30E9\30B0\30A4\30F3\30FB\30B3\30F3\30DD\30FC\30CD\30F3\30C8\304B\3089\30C8\30EA\30AC\30FC\3055\308C\307E\3059\3002</dd>'),
unistr('  <dt>\30AB\30B9\30BF\30E0\30FB\30A4\30D9\30F3\30C8</dt>'),
unistr('    <dd>\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304B\3089\30C8\30EA\30AC\30FC\3055\308C\308B\30AB\30B9\30BF\30E0\30FB\30A4\30D9\30F3\30C8\3002</dd>'),
'</dl>',
unistr('<p>\30CE\30FC\30C8: \8868\793A\3055\308C\308B\30A4\30D9\30F3\30C8\306F\3001\30DA\30FC\30B8\306E\73FE\5728\306E\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\30FB\30BF\30A4\30D7\306B\3088\3063\3066\7570\306A\308A\307E\3059\3002'),
unistr('\7570\306A\308B\30BF\30A4\30D7\306B\5BFE\5FDC\3059\308B\30A4\30D9\30F3\30C8\3092\9078\629E\3059\308B\5834\5408\306F\3001<strong>\300C\975E\30B5\30DD\30FC\30C8\306E\8868\793A\300D</strong>\3092\9078\629E\3059\308B\3053\3068\304C\53EF\80FD\3067\3059\3002'),
unistr('\3053\308C\306B\3088\308A\3001\73FE\5728\306E\30BF\30A4\30D7\306B\5BFE\5FDC\3057\306A\3044\3082\306E\3082\542B\3081\3001\3059\3079\3066\306E\30A4\30D9\30F3\30C8\304C\8868\793A\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103874536763308304)
,p_name=>'PE.PROPERTY.EVENT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30D9\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103898855784308326)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30D9\30F3\30C8\306E\6709\52B9\7BC4\56F2\3092\9078\629E\3057\307E\3059\3002\3053\308C\306B\3088\3063\3066\3001\30A4\30D9\30F3\30C8\304C2\56DE\76EE\307E\305F\306F\9023\7D9A\3057\3066\8A55\4FA1\3055\308C\308B\30BF\30A4\30DF\30F3\30B0\304C\6C7A\307E\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104388497000308749)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.BIND.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\9759\7684')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104388543095308749)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.BIND.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8\306E\5B58\7D9A\671F\9593\4E2D\3001\30A4\30D9\30F3\30C8\30FB\30CF\30F3\30C9\30E9\3092\30C8\30EA\30AC\30FC\8981\7D20\306B\30D0\30A4\30F3\30C9\3057\307E\3059\3002\305F\3060\3057\3001\30C8\30EA\30AC\30FC\8981\7D20\304C\90E8\5206\30DA\30FC\30B8\30FB\30EA\30D5\30EC\30C3\30B7\30E5(PPR)\3067\66F4\65B0\3055\308C\305F\5834\5408\306F\30D0\30A4\30F3\30C9\3055\308C\306A\304F\306A\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104388628485308749)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.LIVE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\52D5\7684')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104388751888308749)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.LIVE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\90E8\5206\30DA\30FC\30B8\30FB\30EA\30D5\30EC\30C3\30B7\30E5(PPR)\3067\518D\4F5C\6210\3055\308C\308B\30C8\30EA\30AC\30FC\8981\7D20\306B\95A2\4FC2\306A\304F\3001\73FE\5728\306E\30DA\30FC\30B8\306E\5B58\7D9A\671F\9593\4E2D\3001\30A4\30D9\30F3\30C8\30FB\30CF\30F3\30C9\30E9\3092\30C8\30EA\30AC\30FC\8981\7D20\306B\30D0\30A4\30F3\30C9\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104388850611308749)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.ONE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('1\56DE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104388998131308749)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.ONE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30D9\30F3\30C8\30FB\30CF\30F3\30C9\30E9\3092\30C8\30EA\30AC\30FC\8981\7D20\306B1\56DE\306E\307F\30D0\30A4\30F3\30C9\3057\307E\3059\3002\30DA\30FC\30B8\304C\5B8C\5168\306B\30EA\30D5\30EC\30C3\30B7\30E5\3055\308C\308B\307E\3067\3001\52D5\7684\30A2\30AF\30B7\30E7\30F3\304C\518D\5EA6\30C8\30EA\30AC\30FC\3055\308C\308B\3053\3068\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103898738678308326)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30D9\30F3\30C8\6709\52B9\7BC4\56F2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104706361458309005)
,p_name=>'PE.PROPERTY.EXCLUDE_TITLE_FROM_TRANSLATION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30BF\30A4\30C8\30EB\3092\7FFB\8A33\304B\3089\9664\5916\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002\3053\306E\5C5E\6027\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\5225\306E\8A00\8A9E\306B\7FFB\8A33\3059\308B\5834\5408\4EE5\5916\3001\5F71\97FF\3092\53CA\307C\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104706242689309005)
,p_name=>'PE.PROPERTY.EXCLUDE_TITLE_FROM_TRANSLATION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30C8\30EB\3092\7FFB\8A33\304B\3089\9664\5916')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104539599354308867)
,p_name=>'PE.PROPERTY.EXECUTE_CONDITION.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\3053\306E\30EC\30A4\30E4\30FC\6761\4EF6\306E\5B9F\884C\56DE\6570\3092\9078\629E\3057\307E\3059\3002'),
unistr('\6761\4EF6\3067<em>\5217</em>\3092\53C2\7167\3059\308B\5834\5408\3001\30EC\30A4\30E4\30FC\554F\5408\305B\306E\5404\884C\306B\5BFE\3057\3066\6761\4EF6\3092\8A55\4FA1\3059\308B\306B\306F\3001<strong>\300C\5404\884C\300D</strong>\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002'),
unistr('\305D\308C\4EE5\5916\306E\5834\5408\306F\3001<strong>\300C1\56DE\300D</strong>\3092\8A2D\5B9A\3057\3066\691C\8A3C\3092\30EA\30FC\30B8\30E7\30F3\306B\5BFE\3057\30661\56DE\8A55\4FA1\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103981670899308421)
,p_name=>'PE.PROPERTY.EXECUTE_CONDITION.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\3053\306E\7DE8\96C6\53EF\80FD\30EA\30FC\30B8\30E7\30F3\691C\8A3C\306E\5B9F\884C\56DE\6570\3092\9078\629E\3057\307E\3059\3002'),
unistr('\6761\4EF6\3067<em>\5217</em>\3092\53C2\7167\3059\308B\5834\5408\3001\7DE8\96C6\53EF\80FD\30EA\30FC\30B8\30E7\30F3\306E\5404\884C\306B\5BFE\3057\3066\6761\4EF6\3092\8A55\4FA1\3059\308B\306B\306F\3001<strong>\300C\5404\884C\300D</strong>\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002'),
unistr('\305D\308C\4EE5\5916\306E\5834\5408\306F\3001<strong>\300C1\56DE\300D</strong>\3092\8A2D\5B9A\3057\3066\691C\8A3C\3092\30EA\30FC\30B8\30E7\30F3\306B\5BFE\3057\30661\56DE\8A55\4FA1\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104401994934308759)
,p_name=>'PE.PROPERTY.EXECUTE_CONDITION.LOV.N.D'
,p_message_language=>'ja'
,p_message_text=>unistr('1\56DE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104401848896308759)
,p_name=>'PE.PROPERTY.EXECUTE_CONDITION.LOV.Y.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5404\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103981519763308421)
,p_name=>'PE.PROPERTY.EXECUTE_CONDITION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9F\884C\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104112329814308527)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\8AAD\53D6\308A\5C02\7528\6761\4EF6\3092\5B9F\884C\3059\308B\6642\9593\3092\6307\5B9A\3057\307E\3059\3002</p>'),
unistr('        <p>\8AAD\53D6\308A\5C02\7528\6761\4EF6\3067<em>\5217</em>\3092\53C2\7167\3059\308B\5834\5408\3001\5BFE\8A71\30B0\30EA\30C3\30C9\306E\5404\884C\306B\5BFE\3057\3066\6761\4EF6\3092\8A55\4FA1\3059\308B\306B\306F\3001<strong>\300C\5404\884C\300D</strong>\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002'),
unistr('		\305D\308C\4EE5\5916\306E\5834\5408\306F\3001<strong>\300C1\56DE\300D</strong>\3092\8A2D\5B9A\3057\3066\6761\4EF6\3092\30EA\30FC\30B8\30E7\30F3\306B\5BFE\3057\30661\56DE\306E\307F\8A55\4FA1\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104112577810308527)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.LOV.N.D'
,p_message_language=>'ja'
,p_message_text=>unistr('1\56DE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104228304338308630)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.LOV.N.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\5168\4F53\30671\56DE\306E\307F\8AAD\53D6\308A\5C02\7528\6761\4EF6\3092\8A55\4FA1\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104112417474308527)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.LOV.Y.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5404\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104228238124308630)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.LOV.Y.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5404\884C\3067\72EC\7ACB\3057\3066\8AAD\53D6\308A\5C02\7528\6761\4EF6\3092\8A55\4FA1\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104112237447308526)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9F\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103981487960308421)
,p_name=>'PE.PROPERTY.EXECUTION_SCOPE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\3053\306E\7DE8\96C6\53EF\80FD\30EA\30FC\30B8\30E7\30F3\691C\8A3C\306E\5B9F\884C\7BC4\56F2\3092\9078\629E\3057\307E\3059\3002'),
unistr('\7DE8\96C6\53EF\80FD\30EA\30FC\30B8\30E7\30F3\3067\4F5C\6210\304A\3088\3073\66F4\65B0\3055\308C\305F\884C\306B\5BFE\3057\3066\691C\8A3C\3092\8A55\4FA1\3059\308B\5834\5408\306F\3001<strong>\300C\4F5C\6210\6E08\304A\3088\3073\5909\66F4\6E08\306E\884C\300D</strong>\3092\9078\629E\3057\307E\3059\3002'),
unistr('\9001\4FE1\3057\305F\5404\884C\306B\5BFE\3057\3066\691C\8A3C\3092\8A55\4FA1\3059\308B\5834\5408\306F\3001<strong>\300C\3059\3079\3066\306E\9001\4FE1\6E08\306E\884C\300D</strong>\3092\9078\629E\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104401799864308759)
,p_name=>'PE.PROPERTY.EXECUTION_SCOPE.LOV.N.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\306E\9001\4FE1\6E08\306E\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104401609678308758)
,p_name=>'PE.PROPERTY.EXECUTION_SCOPE.LOV.Y.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F5C\6210\6E08\304A\3088\3073\5909\66F4\6E08\306E\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103981384747308421)
,p_name=>'PE.PROPERTY.EXECUTION_SCOPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9F\884C\30B9\30B3\30FC\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103874215887308304)
,p_name=>'PE.PROPERTY.EXECUTION_SEQUENCE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306E\9806\5E8F\3092\6307\5B9A\3057\307E\3059\3002\9806\5E8F\306B\3088\3063\3066\5B9F\884C\9806\304C\6C7A\307E\308A\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8: 2\3064\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306E\9806\5E8F\5024\304C\540C\3058\5834\5408\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\30A8\30AF\30B9\30DD\30FC\30C8\3057\3066\5225\306E\74B0\5883\306B\30A4\30F3\30DD\30FC\30C8\3059\308B\3068\3001\7570\306A\308B\9806\5E8F\3067\5B9F\884C\3055\308C\308B\5834\5408\304C\3042\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103874119867308304)
,p_name=>'PE.PROPERTY.EXECUTION_SEQUENCE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104697896307308998)
,p_name=>'PE.PROPERTY.EXTERNAL_FILTER_EXPR.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>ORDS REST\30B5\30FC\30D3\30B9\3067\3001"sal"\5C5E\6027\304C3000\672A\6E80\306E\3059\3079\3066\306E\30EC\30B3\30FC\30C9\3092\30D5\30A3\30EB\30BF\51E6\7406\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'{"sal": {"$lt": 3000}}',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104697745359308998)
,p_name=>'PE.PROPERTY.EXTERNAL_FILTER_EXPR.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5916\90E8REST\30B5\30FC\30D3\30B9\306B\6E21\3055\308C\308B\30D5\30A3\30EB\30BF\5F0F\3092\6307\5B9A\3057\307E\3059\3002\5F0F\306F\305D\306E\307E\307E\3067\30EA\30E2\30FC\30C8\30FB\30B5\30FC\30D0\30FC\306B\6E21\3055\308C\307E\3059\3002\69CB\6587\306F\3001REST\30C7\30FC\30BF\30FB\30BD\30FC\30B9\306E\30BF\30A4\30D7\306B\3088\3063\3066\7570\306A\308A\307E\3059\3002\305F\3068\3048\3070\3001Oracle REST Data Services (ORDS)\3067\306FJSON\69CB\6587\304C\5FC5\8981\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104697642157308998)
,p_name=>'PE.PROPERTY.EXTERNAL_FILTER_EXPR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5916\90E8\30D5\30A3\30EB\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104698198238308998)
,p_name=>'PE.PROPERTY.EXTERNAL_ORDER_BY_EXPR.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>ORDS REST\30B5\30FC\30D3\30B9\3067\3001"job"\5C5E\6027\306E\6607\9806\3001"ename"\5C5E\6027\306E\964D\9806\3067\4E26\3079\66FF\3048\307E\3059\3002</dt>'),
'<dd><pre>',
'{"job": "asc", "ename": "desc"}',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104698007188308998)
,p_name=>'PE.PROPERTY.EXTERNAL_ORDER_BY_EXPR.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5916\90E8REST\30B5\30FC\30D3\30B9\306B\6E21\3055\308C\308Border by\5F0F\3092\6307\5B9A\3057\307E\3059\3002\5F0F\306F\305D\306E\307E\307E\3067\30EA\30E2\30FC\30C8\30FB\30B5\30FC\30D0\30FC\306B\6E21\3055\308C\307E\3059\3002\69CB\6587\306F\3001REST\30C7\30FC\30BF\30FB\30BD\30FC\30B9\306E\30BF\30A4\30D7\306B\3088\3063\3066\7570\306A\308A\307E\3059\3002\305F\3068\3048\3070\3001Oracle REST Data Services (ORDS)\3067\306FJSON\69CB\6587\304C\5FC5\8981\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104697931177308998)
,p_name=>'PE.PROPERTY.EXTERNAL_ORDER_BY_EXPR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5916\90E8\4E26\66FF\3048\57FA\6E96')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104245979409308643)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_ENABLED.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30EC\30DD\30FC\30C8\306B\5BFE\3057\3066\5916\90E8\5F8C\51E6\7406\3092\6709\52B9\306B\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104245860459308643)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_ENABLED.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6709\52B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104245624278308643)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_LINK_TEXT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\30AF\30EA\30C3\30AF\3057\3066\5916\90E8\51E6\7406\30A8\30F3\30B8\30F3\3092\8D77\52D5\3059\308B\30EA\30F3\30AF\306E\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104245521660308643)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_LINK_TEXT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30F3\30AF\30FB\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104245493596308643)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_URL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30EC\30DD\30FC\30C8\306E\5F8C\51E6\7406\7528\306E\30B5\30FC\30D0\30FC\306EURL\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104245351957308643)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_URL.PROMPT'
,p_message_language=>'ja'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104555496031308883)
,p_name=>'PE.PROPERTY.FACET_GROUP.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30C1\30A7\30C3\30AF\30FB\30DC\30C3\30AF\30B9\304C\95A2\9023\4ED8\3051\3089\308C\308B\30D5\30A1\30BB\30C3\30C8\30FB\30B0\30EB\30FC\30D7\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104555315130308883)
,p_name=>'PE.PROPERTY.FACET_GROUP.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30BB\30C3\30C8\30FB\30B0\30EB\30FC\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104483886158308819)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('LOV\30BF\30A4\30D7\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104484590697308820)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.DISTINCT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\500B\5225\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104484696563308820)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.DISTINCT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('LOV\306F\3001\500B\5225\306E\5217\5024\3092\9078\629E\3059\308B\81EA\52D5\751F\6210\306E\554F\5408\305B\306B\57FA\3065\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104610740400308927)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B\3092\8FD4\3059\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104610899606308927)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\52D5\7684LOV\306F\3001\5165\529B\3057\305F\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\306B\3088\3063\3066\8FD4\3055\308C\308BSQL\554F\5408\305B\306B\57FA\3065\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104483970452308819)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.SHARED.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104484068219308819)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.SHARED.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('LOV\306F\3001\5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8\3067\5B9A\7FA9\3055\308C\305F\3001\4E8B\524D\5B9A\7FA9\306ELOV\306B\57FA\3065\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104484174653308820)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104484278904308820)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\52D5\7684LOV\306F\3001\5165\529B\3057\305FSQL\554F\5408\305B\306B\57FA\3065\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104484383969308820)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.STATIC.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\9759\7684\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104484498744308820)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.STATIC.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9759\7684LOV\306F\3001\5165\529B\3057\305F\30C6\30AD\30B9\30C8\5024\306B\57FA\3065\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104483788220308819)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104328762429308703)
,p_name=>'PE.PROPERTY.FC_COLLAPSIBLE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\30D5\30A1\30BB\30C3\30C8\3092\7E2E\5C0F\53EF\80FD\306B\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002<strong>\300C\30AA\30F3\300D</strong>\306B\8A2D\5B9A\3059\308B\3068\3001\30D5\30A1\30BB\30C3\30C8\306E\5DE6\5074\306B\305D\306E\30EA\30B9\30C8\30FB\30A8\30F3\30C8\30EA\306E\8868\793A/\975E\8868\793A\3092\5207\308A\66FF\3048\308B\3053\3068\306E\3067\304D\308B\30C8\30B0\30EB\304C\8868\793A\3055\308C\307E\3059\3002<strong>\300C\30AA\30D5\300D</strong>\306B\8A2D\5B9A\3059\308B\3068\3001\30D5\30A1\30BB\30C3\30C8\3068\305D\306E\30EA\30B9\30C8\30FB\30A8\30F3\30C8\30EA\306F\5E38\306B\8868\793A\3055\308C\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104328616687308703)
,p_name=>'PE.PROPERTY.FC_COLLAPSIBLE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7E2E\5C0F\53EF\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104747471807309040)
,p_name=>'PE.PROPERTY.FC_COMPUTE_COUNTS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\30D5\30A1\30BB\30C3\30C8\307E\305F\306F\30D5\30A3\30EB\30BF\306E\30EA\30B9\30C8\30FB\30A8\30F3\30C8\30EA\306E\4EF6\6570\3092\8A08\7B97\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002\3053\306E\30AA\30D7\30B7\30E7\30F3\3092\4F7F\7528\3059\308B\3068\3001\95A2\9023\3059\308B\30D1\30D5\30A9\30FC\30DE\30F3\30B9\4E0A\306E\5F71\97FF\304C\767A\751F\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104747382969309040)
,p_name=>'PE.PROPERTY.FC_COMPUTE_COUNTS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4EF6\6570\306E\8A08\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104555682724308883)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B0\30EB\30FC\30D7\5185\306E\30D5\30A3\30EB\30BF\306E\7D44\5408\305B\65B9\6CD5\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104555992839308884)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.LOV.AND.D'
,p_message_language=>'ja'
,p_message_text=>unistr('AND (\8AD6\7406\7A4D)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104556084290308884)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.LOV.AND.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30EB\30BF\306FAND\3092\4F7F\7528\3057\3066\7D44\307F\5408\305B\3089\308C\308B\305F\3081\3001\7D50\679C\306F\3059\3079\3066\306E\500B\5225\30D5\30A3\30EB\30BF\306E\8AD6\7406\7A4D\306B\306A\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104555748337308883)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.LOV.OR.D'
,p_message_language=>'ja'
,p_message_text=>unistr('OR (\548C\96C6\5408)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104555822192308883)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.LOV.OR.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30EB\30BF\306FOR\3092\4F7F\7528\3057\3066\7D44\307F\5408\305B\3089\308C\308B\305F\3081\3001\7D50\679C\306F\500B\5225\306E\30D5\30A3\30EB\30BF\306E\8AD6\7406\548C\30BB\30C3\30C8\306B\306A\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104555512627308883)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30EB\30BF\306E\7D44\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104328171469308703)
,p_name=>'PE.PROPERTY.FC_FILTER_VALUES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\30D5\30A1\30BB\30C3\30C8\307E\305F\306F\30D5\30A3\30EB\30BF\306E\30EA\30B9\30C8\30FB\30A8\30F3\30C8\30EA\3067\30AF\30E9\30A4\30A2\30F3\30C8\5074\306E\30D5\30A3\30EB\30BF\3092\8A31\53EF\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002<strong>\300C\30AA\30F3\300D</strong>\306B\8A2D\5B9A\3059\308B\3068\3001\30EA\30B9\30C8\30FB\30A8\30F3\30C8\30EA\306E\4E0A\306B\691C\7D22\30D5\30A3\30FC\30EB\30C9\304C\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\30EA\30B9\30C8\3092\30D5\30A3\30EB\30BF\3067\304D\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104328035107308703)
,p_name=>'PE.PROPERTY.FC_FILTER_VALUES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30E9\30A4\30A2\30F3\30C8\5074\306E\30D5\30A3\30EB\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104556657043308884)
,p_name=>'PE.PROPERTY.FC_INITIAL_CHART.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\30C1\30E3\30FC\30C8\3092\6700\521D\306B\8868\793A\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002\3053\306E\30D7\30ED\30D1\30C6\30A3\306F\3001\30D5\30A1\30BB\30C3\30C8\691C\7D22\30EA\30FC\30B8\30E7\30F3\306E\30D7\30ED\30D1\30C6\30A3\300C\30C1\30E3\30FC\30C8\306E\8868\793A\300D\304C\300C\30BB\30EC\30AF\30BF\300D\306E\5834\5408\306B\306E\307F\9069\7528\3055\308C\307E\3059\3002\30D6\30E9\30A6\30B6\30FB\30BB\30C3\30B7\30E7\30F3\3067\306F\30E6\30FC\30B6\30FC\304C\8868\793A\3057\305F\30C1\30E3\30FC\30C8\306E\30BB\30C3\30C8\304C\7DAD\6301\3055\308C\308B\305F\3081\3001\3053\306E\30D7\30ED\30D1\30C6\30A3\306B\5BFE\3059\308B\5909\66F4\306F\3001\3059\3050\306B\306F\8868\793A\3055\308C\306A\3044\5834\5408\304C\3042\308A\307E\3059\3002\3053\306E\30D7\30ED\30D1\30C6\30A3\306B\5BFE\3059\308B\5909\66F4\306E\52B9\679C\3092\78BA\8A8D\3059\308B\306B\306F\3001\30A6\30A3\30B6\30FC\30C9\3067\751F\6210\3055\308C\305F\300C\30EA\30BB\30C3\30C8\300D\30DC\30BF\30F3\306A\3069\3001\300C\30EA\30FC\30B8\30E7\30F3\306E\30EA\30BB\30C3\30C8\300D\30AD\30E3\30C3\30B7\30E5\5236\5FA1\30AA\30D7\30B7\30E7\30F3\306E\30EA\30F3\30AF\3092\4F7F\7528\3057\3066\30EC\30DD\30FC\30C8\3092\30EA\30BB\30C3\30C8\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104556571082308884)
,p_name=>'PE.PROPERTY.FC_INITIAL_CHART.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\521D\306B\30C1\30E3\30FC\30C8\3092\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104328933936308703)
,p_name=>'PE.PROPERTY.FC_INITIAL_COLLAPSED.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\30D5\30A1\30BB\30C3\30C8\3092\6700\521D\306B\7E2E\5C0F\72B6\614B\3067\30EC\30F3\30C0\30EA\30F3\30B0\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002\30D6\30E9\30A6\30B6\30FB\30BB\30C3\30B7\30E7\30F3\3067\306F\5C55\958B\72B6\614B\304C\7DAD\6301\3055\308C\308B\305F\3081\3001\3053\306E\30D7\30ED\30D1\30C6\30A3\306B\5BFE\3059\308B\5909\66F4\306F\3001\3059\3050\306B\306F\8868\793A\3055\308C\306A\3044\5834\5408\304C\3042\308A\307E\3059\3002\3053\306E\30D7\30ED\30D1\30C6\30A3\306B\5BFE\3059\308B\5909\66F4\306E\52B9\679C\3092\78BA\8A8D\3059\308B\306B\306F\3001\30A6\30A3\30B6\30FC\30C9\3067\751F\6210\3055\308C\305F\300C\30EA\30BB\30C3\30C8\300D\30DC\30BF\30F3\306A\3069\3001\300C\30EA\30FC\30B8\30E7\30F3\306E\30EA\30BB\30C3\30C8\300D\30AD\30E3\30C3\30B7\30E5\5236\5FA1\30AA\30D7\30B7\30E7\30F3\306E\30EA\30F3\30AF\3092\4F7F\7528\3057\3066\30EC\30DD\30FC\30C8\3092\30EA\30BB\30C3\30C8\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104328820516308703)
,p_name=>'PE.PROPERTY.FC_INITIAL_COLLAPSED.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\521D\306F\7E2E\5C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104561594823308888)
,p_name=>'PE.PROPERTY.FC_INITIAL_TOGGLED.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\30D5\30A1\30BB\30C3\30C8\3092\30C7\30D5\30A9\30EB\30C8\3067\8868\793A\3059\308B\304B\3069\3046\304B\3092\6C7A\5B9A\3057\307E\3059\3002\30D6\30E9\30A6\30B6\30FB\30BB\30C3\30B7\30E7\30F3\3067\306F\8868\793A\72B6\614B\304C\7DAD\6301\3055\308C\308B\305F\3081\3001\3053\306E\30D7\30ED\30D1\30C6\30A3\306B\5BFE\3059\308B\5909\66F4\306F\3001\3059\3050\306B\306F\8868\793A\3055\308C\306A\3044\5834\5408\304C\3042\308A\307E\3059\3002\3053\306E\30D7\30ED\30D1\30C6\30A3\306B\5BFE\3059\308B\5909\66F4\306E\52B9\679C\3092\78BA\8A8D\3059\308B\306B\306F\3001\30A6\30A3\30B6\30FC\30C9\3067\751F\6210\3055\308C\305F\300C\30EA\30BB\30C3\30C8\300D\30DC\30BF\30F3\306A\3069\3001\300C\30EA\30FC\30B8\30E7\30F3\306E\30EA\30BB\30C3\30C8\300D\30AD\30E3\30C3\30B7\30E5\5236\5FA1\30AA\30D7\30B7\30E7\30F3\306E\30EA\30F3\30AF\3092\4F7F\7528\3057\3066\30EC\30DD\30FC\30C8\3092\30EA\30BB\30C3\30C8\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104561443167308888)
,p_name=>'PE.PROPERTY.FC_INITIAL_TOGGLED.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\521D\671F\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104329191580308704)
,p_name=>'PE.PROPERTY.FC_MAX_HEIGHT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D4\30AF\30BB\30EB\5358\4F4D\3067\30D5\30A1\30BB\30C3\30C8\306E\6700\5927\306E\9AD8\3055\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104329049648308704)
,p_name=>'PE.PROPERTY.FC_MAX_HEIGHT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5927\9AD8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104329231288308704)
,p_name=>'PE.PROPERTY.FC_MAX_HEIGHT.UNIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D4\30AF\30BB\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103671410581308144)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30EB\30BF\30EA\30F3\30B0\6642\306B\500B\3005\306E\5024\3092\7D44\307F\5408\305B\308B\65B9\6CD5\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103671717310308144)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.LOV.AND.D'
,p_message_language=>'ja'
,p_message_text=>unistr('AND (\8AD6\7406\7A4D)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103671833020308144)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.LOV.AND.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024\306F"AND"\3092\4F7F\7528\3057\3066\7D50\5408\3055\308C\307E\3059\3002\3057\305F\304C\3063\3066\3001\7D50\679C\306F\3059\3079\3066\306E\500B\3005\306E\5024\306E\5171\901A\90E8\5206\306B\306A\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103671530066308144)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.LOV.OR.D'
,p_message_language=>'ja'
,p_message_text=>unistr('OR (\548C\96C6\5408)')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103671671330308144)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.LOV.OR.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024\306F"OR"\3092\4F7F\7528\3057\3066\7D50\5408\3055\308C\307E\3059\3002\3057\305F\304C\3063\3066\3001\7D50\679C\306F\500B\3005\306E\5024\306E\548C\96C6\5408\306B\306A\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103671378542308144)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30EB\30BF\306E\7D50\5408')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103671058876308144)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_SEPARATOR.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\901A\5E38\306E\6587\5B57:</dt>'),
'<dd><pre>,</pre></dd>',
'<dd><pre>:</pre></dd>',
unistr('<dt>\5236\5FA1\6587\5B57:</dt>'),
unistr('<dd>\30BF\30D6(<em>ASCII: 9</em>) <pre>\005Ct</pre></dd>'),
unistr('<dd>\30E9\30A4\30F3\30D5\30A3\30FC\30C9(<em>ASCII: 10</em>) <pre>\005Cn</pre></dd>'),
unistr('<dt>\305D\306E\4ED6\306E\6587\5B57:</dt>'),
unistr('<dd>''\005Cxxxx''\5F62\5F0F\306EUnicode\30A8\30F3\30B3\30FC\30C7\30A3\30F3\30B0\5024\3092\4F7F\7528\3057\307E\3059(''xxxx''\306F\3001UCS-2\30A8\30F3\30B3\30FC\30C7\30A3\30F3\30B0\5F62\5F0F\306E\6587\5B57\306E16\9032\5024\3067\3059)\3002</dd>'),
unistr('<dd>\30D8\30C3\30C0\30FC\958B\59CB(<em>ASCII: 1</em>) <pre>\005C0001</pre></dd>'),
unistr('<dd>"@"\8A18\53F7(<em>ASCII: 64</em>) <pre>\005C0040</pre></dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103670925556308143)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_SEPARATOR.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\5404\5024\306E\533A\5207\308A\3068\306A\308B\6587\5B57\3092\8B58\5225\3057\307E\3059\3002<strong>"</strong>(\4E8C\91CD\5F15\7528\7B26)\304A\3088\3073<strong>\005C</strong>(\30D0\30C3\30AF\30B9\30E9\30C3\30B7\30E5)\6587\5B57\306F\5024\306E\533A\5207\308A\6587\5B57\3068\3057\3066\30B5\30DD\30FC\30C8\3055\308C\305A\3001<strong>\005Cxxxx</strong>\5F62\5F0F\3067\3082\30B5\30DD\30FC\30C8\3055\308C\307E\305B\3093\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103670844991308143)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_SEPARATOR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30D1\30EC\30FC\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103671255197308144)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TRIM_SPACE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5206\5272\5F8C\306B\500B\3005\306E\5024\304B\3089\5148\982D\3068\672B\5C3E\306E\7A7A\767D\3092\524A\9664\3059\308B\304B\3069\3046\304B\3002</p>'),
'<pre>',
'APEX:SQL:Spatial :Oracle TEXT: Data Warehouse',
'APEX :SQL:Data Warehouse',
'</pre>',
'<dl>',
unistr('<dt>\7A7A\767D\306E\5207\6368\3066\304C<em>\7121\52B9</em>\306E\5834\5408\3001\5404\5024\306F\6B21\306E\3088\3046\306B\30AB\30A6\30F3\30C8\3055\308C\307E\3059:</dt>'),
'<dd><pre>',
'"APEX":            1',
'"APEX ":           1',
'"SQL":             2',
'"Spatial":         1',
'"Oracle TEXT":     1',
'"Data Warehouse":  1',
'" Data Warehouse": 1',
'</pre></dd>',
unistr('<dt>\7A7A\767D\306E\5207\6368\3066\304C<em>\6709\52B9</em>\306E\5834\5408\3001\5404\5024\306F\6B21\306E\3088\3046\306B\30AB\30A6\30F3\30C8\3055\308C\307E\3059:</dt>'),
'<dd><pre>',
'"APEX":            2',
'"SQL":             2',
'"Spatial":         1',
'"Oracle TEXT":     1',
'"Data Warehouse":  2',
'</pre></dd>',
unistr('<p>\7A7A\767D\306E\5207\6368\3066\306F\3001\554F\5408\305B\306E\30D1\30D5\30A9\30FC\30DE\30F3\30B9\306B\5927\5E45\306B\5F71\97FF\3059\308B\53EF\80FD\6027\304C\3042\308B\3053\3068\306B\6CE8\610F\3057\3066\304F\3060\3055\3044\3002\3088\308A\5927\304D\306A\30C7\30FC\30BF\30FB\30BB\30C3\30C8\306E\5834\5408\306F\3001\304B\308F\308A\306B\30C7\30FC\30BF\30FB\30AF\30EC\30F3\30B8\30F3\30B0\3092\691C\8A0E\3057\3066\304F\3060\3055\3044\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103671150005308144)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TRIM_SPACE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7A7A\767D\306E\5207\6368\3066')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103672189026308144)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.COMPONENT_PROPERTY.FACET.NULL_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\3044\3044\3048')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103672226252308144)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.COMPONENT_PROPERTY.FACET.NULL_TEXT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\306B\8907\6570\306E\5024\304C\542B\307E\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103920658949308375)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.COMPONENT_PROPERTY.SFILTER.NULL_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\3044\3044\3048')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103920728922308375)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.COMPONENT_PROPERTY.SFILTER.NULL_TEXT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\306B\8907\6570\306E\5024\304C\542B\307E\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103670322669308143)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\30BD\30FC\30B9\5217\306B\8907\6570\5024\304C\542B\307E\308C\308B\304B\3069\3046\304B\3084\305D\306E\30A8\30F3\30B3\30FC\30C9\65B9\6CD5\304C\6C7A\5B9A\3055\308C\307E\3059\3002</p><p><em>\8907\6570\5024\30D5\30A1\30BB\30C3\30C8\307E\305F\306F\30D5\30A3\30EB\30BF\306F12.2\4EE5\4E0A\306EOracle\30C7\30FC\30BF\30D9\30FC\30B9\3067\306E\307F\30B5\30DD\30FC\30C8\3055\308C\307E\3059\300212.1\306E\30C7\30FC\30BF\30D9\30FC\30B9\3067\306F\3001\8907\6570\5024\30D5\30A1\30BB\30C3\30C8\307E\305F\306F\30D5\30A3\30EB\30BF\304C\5B9A\7FA9\3055\308C\3066\3044\308B\5834\5408\3001&PRODUCT_NAME.\306F\30E9\30F3\30BF\30A4\30E0\30FB\30A8\30E9\30FC\3092\8868\793A\3057\307E\3059\3002</em></p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103670640201308143)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.LOV.JSON_ARRAY.D'
,p_message_language=>'ja'
,p_message_text=>unistr('JSON\914D\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103670702321308143)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.LOV.JSON_ARRAY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\30BD\30FC\30B9\5217\306B\306F\3001\30B9\30AB\30E9\30FC\5024\306EJSON\914D\5217\304C\542B\307E\308C\307E\3059\3002\5217\306B\7121\52B9\306AJSON\69CB\6587\304C\542B\307E\308C\3066\3044\308B\5834\5408\3001&PRODUCT_NAME.\306F\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\3092\8868\793A\3057\307E\3059\3002</p><pre>["APEX", "SQL", "PL/SQL"]</pre>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103670492128308143)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.LOV.SEPARATED.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\533A\5207\308A\30EA\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103670525275308143)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.LOV.SEPARATED.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\5217\306B\306F\3001\5024\304C\533A\5207\308A\30EA\30B9\30C8\3068\3057\3066\542B\307E\308C\307E\3059\3002</p><pre>APEX,SQL,PL/SQL</pre>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103670212741308143)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104556460834308884)
,p_name=>'PE.PROPERTY.FC_SHOW_CHART.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\30DC\30BF\30F3\3092\30D5\30A1\30BB\30C3\30C8\306E\6A2A\306B\8868\793A\3057\3066\3001\30E6\30FC\30B6\30FC\304C\30D5\30A1\30BB\30C3\30C8\30FB\30EA\30B9\30C8\306E\30A8\30F3\30C8\30EA\6570\306E\30C1\30E3\30FC\30C8\3092\8868\793A\3067\304D\308B\3088\3046\306B\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002\3053\306E\30D7\30ED\30D1\30C6\30A3\306F\3001\30D5\30A1\30BB\30C3\30C8\691C\7D22\30EA\30FC\30B8\30E7\30F3\306E\30D7\30ED\30D1\30C6\30A3\300C\30C1\30E3\30FC\30C8\306E\8868\793A\300D\304C\300C\3044\3044\3048\300D\3067\306A\3044\5834\5408\306B\306E\307F\9069\7528\3055\308C\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104556387785308884)
,p_name=>'PE.PROPERTY.FC_SHOW_CHART.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\30C1\30E3\30FC\30C8\300D\3092\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104327917239308703)
,p_name=>'PE.PROPERTY.FC_SHOW_COUNTS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\30D5\30A1\30BB\30C3\30C8\307E\305F\306F\30D5\30A3\30EB\30BF\306E\30EA\30B9\30C8\30FB\30A8\30F3\30C8\30EA\306E\51FA\73FE\4EF6\6570\3092\8868\793A\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002<strong>\300C\30AA\30F3\300D</strong>\306B\8A2D\5B9A\3059\308B\3068\3001\30EA\30B9\30C8\30FB\30A8\30F3\30C8\30EA\306E\6A2A\306B\3042\308B\30AB\30C3\30B3\5185\306B\4EF6\6570\304C\8868\793A\3055\308C\307E\3059\3002\4F8B: KING (3)\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104327857404308703)
,p_name=>'PE.PROPERTY.FC_SHOW_COUNTS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4EF6\6570\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104328524560308703)
,p_name=>'PE.PROPERTY.FC_SHOW_MORE_COUNT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\30D5\30A1\30BB\30C3\30C8\306B\8868\793A\3059\308B\30EA\30B9\30C8\30FB\30A8\30F3\30C8\30EA\306E\6700\5927\6570\3092\6307\5B9A\3057\307E\3059\3002\5024\304C\6307\5B9A\3055\308C\3001\30EA\30B9\30C8\306B\305D\306E\6570\3092\8D85\3048\308B\30A8\30F3\30C8\30EA\304C\542B\307E\308C\308B\5834\5408\3001\30EA\30B9\30C8\306E\4E00\756A\4E0B\306B<strong>\300C\3055\3089\306B\8868\793A\300D</strong>\30EA\30F3\30AF\304C\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\307E\3059\3002\5024\304C\6307\5B9A\3055\308C\306A\3044\5834\5408\3001\3059\3079\3066\306E\30EA\30B9\30C8\30FB\30A8\30F3\30C8\30EA\304C\8868\793A\3055\308C\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104328485030308703)
,p_name=>'PE.PROPERTY.FC_SHOW_MORE_COUNT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5927\8868\793A\30A8\30F3\30C8\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104328322540308703)
,p_name=>'PE.PROPERTY.FC_SHOW_SELECTED_FIRST.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\30D5\30A1\30BB\30C3\30C8\307E\305F\306F\30D5\30A3\30EB\30BF\306E\30EA\30B9\30C8\3067\9078\629E\3055\308C\305F\30EA\30B9\30C8\30FB\30A8\30F3\30C8\30EA\3092\6700\521D\306B\8868\793A\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002\3053\306E\5C5E\6027\306F\3001\30D5\30A1\30BB\30C3\30C8\306B\95A2\9023\4ED8\3051\3089\308C\305FLOV\304C\30B0\30EB\30FC\30D7\3092\5B9A\7FA9\3057\3066\3044\308B\5834\5408\306F\9069\7528\3055\308C\307E\305B\3093\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104328267839308703)
,p_name=>'PE.PROPERTY.FC_SHOW_SELECTED_FIRST.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\9805\76EE\3092\6700\521D\306B\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103957830644308403)
,p_name=>'PE.PROPERTY.FC_SORT_BY_TOP_COUNTS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30BB\30C3\30C8\307E\305F\306F\30D5\30A3\30EB\30BF\306E\30EA\30B9\30C8\30FB\30A8\30F3\30C8\30EA\3092\30BD\30FC\30C8\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002<strong>\300C\30AA\30F3\300D</strong>\306B\8A2D\5B9A\3059\308B\3068\3001\30EA\30B9\30C8\30FB\30A8\30F3\30C8\30EA\306F\4EF6\6570\5225\306B\964D\9806\3067\30BD\30FC\30C8\3055\308C\307E\3059\3002<strong>\300C\30AA\30D5\300D</strong>\306B\8A2D\5B9A\3059\308B\3068\3001\30EA\30B9\30C8\30FB\30A8\30F3\30C8\30EA\306FLOV\3067\5B9A\7FA9\3055\308C\305F\9806\5E8F\3067\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103957781282308403)
,p_name=>'PE.PROPERTY.FC_SORT_BY_TOP_COUNTS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0A\4F4D\4EF6\6570\3067\30BD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104561329986308888)
,p_name=>'PE.PROPERTY.FC_TOGGLEABLE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\30A8\30F3\30C9\30E6\30FC\30B6\30FC\304C\30D5\30A1\30BB\30C3\30C8\306E\8868\793A\307E\305F\306F\975E\8868\793A\3092\884C\3048\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002\5C11\306A\304F\3068\30821\3064\306E\30D5\30A1\30BB\30C3\30C8\3067\3053\306E\30AA\30D7\30B7\30E7\30F3\304C\30AA\30F3\306B\306A\3063\3066\3044\308B\5834\5408\306F\3001\8868\793A\307E\305F\306F\975E\8868\793A\306B\3059\308B\30D5\30A1\30BB\30C3\30C8\3092\9078\629E\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\300C\30D5\30A1\30BB\30C3\30C8\3092\5897\3084\3059\300D\30DC\30BF\30F3\304C\8FFD\52A0\3055\308C\307E\3059\3002\8868\793A\3055\308C\3066\3044\306A\3044\30D5\30A1\30BB\30C3\30C8\306E\6570\3092\8A08\7B97\3059\308B\30D1\30D5\30A9\30FC\30DE\30F3\30B9\30FB\30B3\30B9\30C8\306F\3042\308A\307E\305B\3093\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104561222462308888)
,p_name=>'PE.PROPERTY.FC_TOGGLEABLE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\306E\5207\66FF\3048')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104747645379309040)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\30D5\30A1\30BB\30C3\30C8\307E\305F\306F\30D5\30A3\30EB\30BF\306B\30BC\30ED\4EF6\306E\30EA\30B9\30C8\30FB\30A8\30F3\30C8\30EA\3092\8868\793A\3059\308B\65B9\6CD5\3092\6307\5B9A\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104747995850309041)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.D.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104748016067309041)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.D.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\3059\3079\3066\306E\30A8\30F3\30C8\30EA\3092\8868\793A\3057\307E\3059\304C\3001\30D5\30A3\30EB\30BF\53EF\80FD\3067\306A\3044\3082\306E\306F\7121\52B9\306B\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104747782457309040)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.H.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\975E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104747851060309041)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.H.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\30D5\30A3\30EB\30BF\53EF\80FD\306A\30EA\30B9\30C8\30FB\30A8\30F3\30C8\30EA\306E\307F\8868\793A\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104748180326309041)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.L.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5F8C\306B\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104748251023309041)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.L.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\3059\3079\3066\306E\30A8\30F3\30C8\30EA\3092\8868\793A\3057\307E\3059\304C\3001\30D5\30A3\30EB\30BF\53EF\80FD\3067\306A\3044\3082\306E\306F\7121\52B9\306B\3057\3001\30D5\30A1\30BB\30C3\30C8\307E\305F\306F\30D5\30A3\30EB\30BF\306E\30EA\30B9\30C8\306E\6700\5F8C\306B\8868\793A\3057\307E\3059\3002\3053\306E\30AA\30D7\30B7\30E7\30F3\306F\3001\95A2\9023\4ED8\3051\3089\308C\3066\3044\308B\5171\6709LOV\304C\30B0\30EB\30FC\30D7\6A5F\80FD\3092\5229\7528\3057\3066\3044\308B\5834\5408\306F\7121\8996\3055\308C\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104747500324309040)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BC\30ED\4EF6\306E\30A8\30F3\30C8\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103881017308308309)
,p_name=>'PE.PROPERTY.FIELD_TABLE_CELL_ATTRIBUTES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30E9\30D9\30EB\3092\542B\3080HTML\8868\30BB\30EB\3067\4F7F\7528\3055\308C\308B\8FFD\52A0\306E\5C5E\6027\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103880901192308309)
,p_name=>'PE.PROPERTY.FIELD_TABLE_CELL_ATTRIBUTES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\306E\30BB\30EB\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104236961617308637)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE.COMPONENT_PROPERTY.CLASSIC_REPORT_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\5F62\5F0F\30D5\30A9\30FC\30E0\30FB\30D5\30A3\30FC\30EB\30C9\3092\30EC\30F3\30C0\30EA\30F3\30B0\3059\308B\5834\5408\306B\4F7F\7528\3055\308C\308B\30D5\30A3\30FC\30EB\30C9\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\9078\629E\3057\307E\3059\3002\30C6\30F3\30D7\30EC\30FC\30C8\304C\9078\629E\3055\308C\306A\3044\5834\5408\3001\30C7\30D5\30A9\30EB\30C8\306E\30A2\30AF\30BB\30B7\30D3\30EA\30C6\30A3\6E96\62E0\30E9\30D9\30EB\3092\4F7F\7528\3057\3066\3001\30D5\30A3\30FC\30EB\30C9\304C\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104257127170308651)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE.COMPONENT_PROPERTY.TABULAR_FORM_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\5F62\5F0F\30D5\30A9\30FC\30E0\30FB\30D5\30A3\30FC\30EB\30C9\3092\30EC\30F3\30C0\30EA\30F3\30B0\3059\308B\5834\5408\306B\4F7F\7528\3055\308C\308B\30D5\30A3\30FC\30EB\30C9\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\9078\629E\3057\307E\3059\3002\30C6\30F3\30D7\30EC\30FC\30C8\304C\9078\629E\3055\308C\306A\3044\5834\5408\3001\30C7\30D5\30A9\30EB\30C8\306E\30A2\30AF\30BB\30B7\30D3\30EA\30C6\30A3\6E96\62E0\30E9\30D9\30EB\3092\4F7F\7528\3057\3066\3001\30D5\30A3\30FC\30EB\30C9\304C\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103880849030308309)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30A2\30A4\30C6\30E0\30FB\30E9\30D9\30EB\306E\5916\89B3\3068\30EC\30A4\30A2\30A6\30C8\3092\5B9A\7FA9\3059\308B\30E9\30D9\30EB\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\9078\629E\3057\307E\3059\3002</p>'),
unistr('        <p>\30E9\30D9\30EB\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30C6\30FC\30DE\3067\5B9A\7FA9\3055\308C\307E\3059\3002'),
unistr('        \30A2\30A4\30C6\30E0\304C\4F5C\6210\3055\308C\308B\3068\3001\30C6\30F3\30D7\30EC\30FC\30C8\306F\3001\73FE\5728\306E\30C6\30FC\30DE\306B\5B9A\7FA9\3055\308C\3066\3044\308B\30C7\30D5\30A9\30EB\30C8\30FB\30A2\30A4\30C6\30E0\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306B\81EA\52D5\7684\306B\8A2D\5B9A\3055\308C\307E\3059\3002</p>'),
unistr('        <p>\5FC5\9808\3001\30AA\30D7\30B7\30E7\30F3\304A\3088\3073\975E\8868\793A\306E\30E9\30D9\30EB\3092\8868\793A\3059\308B\305F\3081\306E\30E9\30D9\30EB\30FB\30C6\30F3\30D7\30EC\30FC\30C8\304C\591A\304F\306E\30C6\30FC\30DE\306B\542B\307E\308C\307E\3059\3002<br>'),
unistr('        \30E6\30CB\30D0\30FC\30B5\30EB\30FB\30C6\30FC\30DE\306B\306F\3001\6B21\306E\30E9\30D9\30EB\30FB\30C6\30F3\30D7\30EC\30FC\30C8\304C\3042\308A\307E\3059:'),
'          <dl>',
unistr('            <dt>\975E\8868\793A</dt>'),
unistr('              <dd>\3053\308C\306F\3001\30E9\30D9\30EB\3092\753B\9762\306B\8868\793A\3057\306A\3044\5834\5408\306B\4F7F\7528\3057\307E\3059\3002\305F\3060\3057\3001\30A2\30B7\30B9\30C6\30A3\30D6\30FB\30C6\30AF\30CE\30ED\30B8\3067\306F\5F15\304D\7D9A\304D\30E9\30D9\30EB\3092\8AAD\307F\53D6\308B\3053\3068\304C\3067\304D\307E\3059\3002'),
unistr('              \30C1\30A7\30C3\30AF\30FB\30DC\30C3\30AF\30B9\30FB\30A2\30A4\30C6\30E0\3067\306F\30C1\30A7\30C3\30AF\30FB\30DC\30C3\30AF\30B9\306E\5F8C\306B\30E9\30D9\30EB\3092\8868\793A\3059\308B\5FC5\8981\304C\3042\308B\305F\3081\3001\300C\975E\8868\793A\300D\306F\7121\8996\3055\308C\307E\3059\3002</dd>'),
unistr('            <dt>\30AA\30D7\30B7\30E7\30F3</dt>'),
unistr('              <dd>\3053\308C\306F\3001\30AA\30D7\30B7\30E7\30F3\306E\30D5\30A9\30FC\30E0\30FB\30A2\30A4\30C6\30E0\306B\4F7F\7528\3057\307E\3059\3002\30E9\30D9\30EB\306F\30A2\30A4\30C6\30E0\306E\6A2A\306B\8868\793A\3055\308C\307E\3059\3002</dd>'),
unistr('            <dt>\30AA\30D7\30B7\30E7\30F3 - \4E0A</dt>'),
unistr('              <dd>\3053\308C\306F\3001\30AA\30D7\30B7\30E7\30F3\306E\30D5\30A9\30FC\30E0\30FB\30A2\30A4\30C6\30E0\306B\4F7F\7528\3057\307E\3059\3002\30E9\30D9\30EB\306F\30A2\30A4\30C6\30E0\306E\4E0A\306B\8868\793A\3055\308C\307E\3059\3002</dd>'),
unistr('            <dt>\30AA\30D7\30B7\30E7\30F3 - \30D5\30ED\30FC\30C6\30A3\30F3\30B0</dt>'),
unistr('              <dd>\3053\308C\306F\3001\30AA\30D7\30B7\30E7\30F3\306E\30D5\30A9\30FC\30E0\30FB\30A2\30A4\30C6\30E0\306B\4F7F\7528\3057\307E\3059\3002\30E9\30D9\30EB\306F\5165\529B\30A2\30A4\30C6\30E0\5185\306B\8868\793A\3055\308C\308B\305F\3081\3001\5165\529B\30D5\30A3\30FC\30EB\30C9\306B\5024\304C\3042\308B\3068\81EA\52D5\7684\306B\7E2E\5C0F\3055\308C\307E\3059\3002</dd>'),
unistr('            <dt>\5FC5\9808</dt>'),
unistr('              <dd>\3053\306E\30E9\30D9\30EB\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3067\306F\3001\30E9\30D9\30EB\306E\6A2A\306B\8D64\3044\30A2\30B9\30BF\30EA\30B9\30AF\304C\8868\793A\3055\308C\308B\305F\3081\3001\30E6\30FC\30B6\30FC\306E\5165\529B\304C\5FC5\8981\306A\30D5\30A9\30FC\30E0\30FB\30A2\30A4\30C6\30E0\306B\9069\3057\3066\3044\307E\3059\3002\30E9\30D9\30EB\306F\30A2\30A4\30C6\30E0\306E\6A2A\306B\8868\793A\3055\308C\307E\3059\3002</dd>'),
unistr('            <dt>\5FC5\9808 - \4E0A</dt>'),
unistr('              <dd>\3053\306E\30E9\30D9\30EB\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3067\306F\3001\30E9\30D9\30EB\306E\6A2A\306B\8D64\3044\30A2\30B9\30BF\30EA\30B9\30AF\304C\8868\793A\3055\308C\308B\305F\3081\3001\30E6\30FC\30B6\30FC\306E\5165\529B\304C\5FC5\8981\306A\30D5\30A9\30FC\30E0\30FB\30A2\30A4\30C6\30E0\306B\9069\3057\3066\3044\307E\3059\3002\30E9\30D9\30EB\306F\30A2\30A4\30C6\30E0\306E\4E0A\306B\8868\793A\3055\308C\307E\3059\3002\30A2\30A4\30C6\30E0\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3067\306F\3001\30C6\30FC\30DE\306E\4E00\90E8\3068\3057\3066\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\5C5E\6027\3092\5B9A\7FA9\3057\3001\305D\306E\5B9A\7FA9\3092\591A\304F\306E\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\9593\3067\5171\6709\3067\304D\307E\3059\3002</dd>'),
unistr('            <dt>\5FC5\9808 - \30D5\30ED\30FC\30C6\30A3\30F3\30B0</dt>'),
unistr('              <dd>\3053\306E\30E9\30D9\30EB\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3067\306F\3001\30E9\30D9\30EB\306E\6A2A\306B\8D64\3044\30A2\30B9\30BF\30EA\30B9\30AF\304C\8868\793A\3055\308C\308B\305F\3081\3001\30E6\30FC\30B6\30FC\306E\5165\529B\304C\5FC5\8981\306A\30D5\30A9\30FC\30E0\30FB\30A2\30A4\30C6\30E0\306B\9069\3057\3066\3044\307E\3059\3002\30E9\30D9\30EB\306F\5165\529B\30A2\30A4\30C6\30E0\5185\306B\8868\793A\3055\308C\308B\305F\3081\3001\5165\529B\30D5\30A3\30FC\30EB\30C9\306B\5024\304C\3042\308B\3068\81EA\52D5\7684\306B\7E2E\5C0F\3055\308C\307E\3059\3002\30A2\30A4\30C6\30E0\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3067\306F\3001\30C6\30FC\30DE\306E\4E00\90E8\3068\3057\3066\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\5C5E\6027\3092\5B9A\7FA9\3057\3001\305D\306E\5B9A\7FA9\3092\591A\304F\306E\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\9593\3067\5171\6709\3067\304D\307E\3059\3002</dd>'),
'          </dl>',
unistr('          \95A2\9023\9805\76EE: <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\30E6\30CB\30D0\30FC\30B5\30EB\30FB\30C6\30FC\30DE\306E\30B5\30F3\30D7\30EB\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3</a>'),
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103880766145308309)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104694021837308995)
,p_name=>'PE.PROPERTY.FILTER_DATA_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\578B\306E\30D5\30A3\30EB\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104108008490308523)
,p_name=>'PE.PROPERTY.FILTER_EXACT_MATCH.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\5217\30D5\30A3\30EB\30BF\306B\30C6\30AD\30B9\30C8\3092\5165\529B\3059\308B\5834\5408\306B\5B8C\5168\4E00\81F4\691C\7D22\3092\5B9F\884C\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002'),
unistr('      <strong>\300C\30AA\30D5\300D</strong>\306B\8A2D\5B9A\3055\308C\3066\3044\308B\5834\5408\3001\30D5\30A3\30EB\30BF\306B\3088\308A\3001\6B21\3068\7B49\3057\3044\691C\7D22\3067\306F\306A\304F\6B21\3092\542B\3080\691C\7D22\304C\5B9F\884C\3055\308C\307E\3059\3002</p>'),
unistr('      <p>\305F\3068\3048\3070\3001TAGS\3068\3044\3046\5217\306E\5834\5408\3001\3053\308C\306FTAGS = ''<<value>>''\3068\540C\3058\3067\3059\3002\300C\5B8C\5168\4E00\81F4\300D\304C<strong>\300C\30AA\30D5\300D</strong>\306B\8A2D\5B9A\3055\308C\3066\3044\308B\5834\5408\3001\3053\308C\306FTAGS LIKE ''%<<value>>%''\3068\540C\3058\3067\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104107942198308523)
,p_name=>'PE.PROPERTY.FILTER_EXACT_MATCH.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B8C\5168\4E00\81F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104106445068308522)
,p_name=>'PE.PROPERTY.FILTER_IS_REQUIRED.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30D5\30A3\30EB\30BF\304C\5E38\306B\3053\306E\5217\306B\5FC5\8981\3067\3042\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002</p>'),
unistr('        <p>\30CE\30FC\30C8 - \5BFE\8A71\30B0\30EA\30C3\30C9\5C5E\6027\306E<strong>\300C\30D5\30A3\30EB\30BF\304C\5FC5\8981\300D</strong>\30AA\30D7\30B7\30E7\30F3\306B\95A2\4FC2\306A\304F\3001\30D5\30A3\30EB\30BF\306F\3001\30C7\30FC\30BF\304C\623B\3055\308C\308B\524D\306B\3053\306E\7279\5B9A\306E\5217\306B\5E38\306B\5FC5\8981\3067\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104106349778308522)
,p_name=>'PE.PROPERTY.FILTER_IS_REQUIRED.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5FC5\9808')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104106601959308522)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\304C\5217\30D8\30C3\30C0\30FC\307E\305F\306F\300C\30D5\30A3\30EB\30BF\300D\30C0\30A4\30A2\30ED\30B0\3067\30AF\30EA\30C3\30AF\3057\305F\3068\304D\306E\30D5\30A3\30EB\30BF\306ELOV\3092\5C0E\51FA\3059\308B\65B9\6CD5\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104106910799308522)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.DISTINCT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\56FA\6709\306E\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104107089103308522)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.DISTINCT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\56FA\6709\306E\5217\5024\306F\3001VARCHAR2\304A\3088\3073NUMBER\5217\306B\8868\793A\3055\308C\307E\3059\3002DATE\304A\3088\3073TIMESTAMP\5217\306F\3001\7D44\8FBC\307F\306E\4E8B\524D\5B9A\7FA9\3055\308C\305F\65E5\4ED8\7BC4\56F2\3092\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104693017779308994)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.LOV.D'
,p_message_language=>'ja'
,p_message_text=>unistr('LOV\306E\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104693173013308994)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.LOV.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024\306F\3001LOV\304B\3089\5C0E\51FA\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104106798699308522)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.NONE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104106895895308522)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.NONE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30D5\30A3\30EB\30BF\306B\8868\793A\3055\308C\308B\5024\3092\7121\52B9\5316\3057\307E\3059\3002'),
unistr('        \3053\306E\30AA\30D7\30B7\30E7\30F3\306F\3001\901A\5E38\5024\304C50\6587\5B57\3092\8D85\3048\3066\3044\305F\308A\3001\7279\5B9A\306E\30EC\30B3\30FC\30C9\3092\9078\629E\3059\308B\306E\306B\30EA\30B9\30C8\304C\3042\307E\308A\6709\76CA\3067\306A\3044\5834\5408\306E\5927\304D\3044\5217\306B\6709\52B9\3067\3059\3002'),
unistr('        \304B\308F\308A\306B\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\5024\306E\4E00\90E8\3092\5165\529B\3057\3066\7D50\679C\3092\8868\793A\3067\304D\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104107726260308523)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.PLSQL_FUNCTION_BODY.D'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B\3092\623B\3059PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104107866178308523)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.PLSQL_FUNCTION_BODY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024\306F\3001SQL\554F\5408\305B\3092\623B\3059PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\304B\3089\5C0E\51FA\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104107361620308522)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.SHARED.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104107446611308523)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.SHARED.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024\306F\3001\65E2\5B58\306ELOV\304B\3089\5C0E\51FA\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104107144370308522)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104107278215308522)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024\306F\3001SQL\554F\5408\305B\5B9A\7FA9\304B\3089\5C0E\51FA\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104107550953308523)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.STATIC.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\9759\7684\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104107601204308523)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.STATIC.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024\306F\3001\9759\7684LOV\304B\3089\5C0E\51FA\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104106559800308522)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('LOV\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104105220071308521)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\3053\306E\5217\306B\4F7F\7528\3067\304D\308B\30D5\30A3\30EB\30BF\6F14\7B97\5B50\3092\9078\629E\3057\307E\3059\3002</p>'),
unistr('        <p>\30C7\30FC\30BF\30FB\30BB\30C3\30C8\304A\3088\3073\5217\7D22\5F15\306E\30B5\30A4\30BA\306B\3088\3063\3066\306F\3001\7279\5B9A\306E\30D5\30A3\30EB\30BF\6F14\7B97\5B50\3092\7121\52B9\5316\3057\3066\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306E\30D1\30D5\30A9\30FC\30DE\30F3\30B9\306E\554F\984C\3092\56DE\907F\3067\304D\307E\3059\3002'),
unistr('        \7279\5B9A\306E\6F14\7B97\5B50\3067\306F\3001\5217\7D22\5F15\3092\4F7F\7528\3059\308B\304B\308F\308A\306B\5B8C\5168\8868\30B9\30AD\30E3\30F3\304C\767A\751F\3059\308B\5834\5408\304C\3042\308A\307E\3059\3002</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104276523129308665)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.C.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\3092\542B\3080')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104276666965308665)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.C.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30D5\30A3\30EB\30BF\306F\3001\30D5\30A3\30EB\30BF\5024\3092\542B\3080\5217\5024\306E\7D50\679C\3092\8FD4\3057\307E\3059\3002'),
unistr('        &PRODUCT_NAME.\306F\3001where\53E5\306B<code>column LIKE <strong>%</strong>filtervalue<strong>%</strong></code>\3092\4F7F\7528\3057\307E\3059\3002</p>'),
unistr('        <p>\30CE\30FC\30C8 - \3053\306E\6F14\7B97\5B50\306B\3088\308A\3001\5217\7D22\5F15\3092\4F7F\7528\3067\304D\306A\304F\306A\308A\3001\5B8C\5168\8868\30B9\30AD\30E3\30F3\306B\306A\308B\53EF\80FD\6027\304C\3042\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104105437939308521)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.CASE_INSENSITIVE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5927/\5C0F\6587\5B57\533A\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104228015781308630)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.CASE_INSENSITIVE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5217\5024\3068\30D5\30A3\30EB\30BF\5024\306E\9055\3044\306B\304B\304B\308F\3089\305A\3001\30D5\30A3\30EB\30BF\306F\5217\5024\306E\7D50\679C\3092\8FD4\3057\307E\3059\3002'),
unistr('        &PRODUCT_NAME.\306F\3001where\53E5\306B<code>UPPER(column) <em>operator</em> UPPER(filtervalue)</code>\3092\4F7F\7528\3057\307E\3059\3002</p>'),
unistr('        <p>\30CE\30FC\30C8 - \901A\5E38\3001\5217\5024\3068\30D5\30A3\30EB\30BF\5024\306E\4E21\65B9\306BUPPER\3092\5B9F\884C\3059\308B\3068\3001UPPER(<em>column</em>)\3092\4F7F\7528\3057\305F\30D5\30A1\30F3\30AF\30B7\30E7\30F3\30FB\30D9\30FC\30B9\306E\5217\7D22\5F15\3092\9664\3044\3066\5217\7D22\5F15\304C\4F7F\7528\3067\304D\306A\304F\306A\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104105331210308521)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.REGEXP.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B63\898F\8868\73FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104228179159308630)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.REGEXP.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30D5\30A3\30EB\30BF\306F\3001\5165\529B\3055\308C\305F\6B63\898F\8868\73FE\306B\57FA\3065\3044\3066\7D50\679C\3092\8FD4\3057\307E\3059\3002</p>'),
unistr('        <p>\30CE\30FC\30C8 - REGEXP\6F14\7B97\5B50\306E\4F7F\7528\306F\8907\96D1\3067\3001\901A\5E38\4E0A\7D1A\30E6\30FC\30B6\30FC\306E\307F\4F7F\7528\3057\307E\3059\3002\305D\306E\3088\3046\306A\6F14\7B97\5B50\306B\3088\308A\3001\30D1\30D5\30A9\30FC\30DE\30F3\30B9\304C\5927\5E45\306B\4F4E\4E0B\3059\308B\53EF\80FD\6027\304C\3042\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104276789889308665)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.S.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\3067\59CB\307E\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104276835312308665)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.S.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30D5\30A3\30EB\30BF\306F\3001\30D5\30A3\30EB\30BF\5024\3067\59CB\307E\308B\5217\5024\306E\7D50\679C\3092\8FD4\3057\307E\3059\3002'),
unistr('        &PRODUCT_NAME.\306F\3001where\53E5\306B<code>column LIKE filtervalue<strong>%</strong></code>\3092\4F7F\7528\3057\307E\3059\3002</p>'),
unistr('        <p>\30CE\30FC\30C8 - \3053\306E\6F14\7B97\5B50\306F\4F7F\7528\53EF\80FD\306A\5217\7D22\5F15\3092\5229\7528\3067\304D\307E\3059\3002{\4F8B\5916\306F\3001<strong>\300C\5927/\5C0F\6587\5B57\533A\5225\300D</strong>\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044}\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104105185255308521)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6F14\7B97\5B50\306B\5F71\97FF\3092\4E0E\3048\308B\30D1\30D5\30A9\30FC\30DE\30F3\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104105655993308521)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5217\5024\5185\306E\30C6\30AD\30B9\30C8\3092\5927/\5C0F\6587\5B57\3067\683C\7D0D\3059\308B\3053\3068\3092\9078\629E\3057\307E\3059\3002</p>'),
unistr('        <p><em>Username</em>\306A\3069\3001\5217\3092\5E38\306B\5927\6587\5B57\307E\305F\306F\5C0F\6587\5B57\3067\6307\5B9A\3067\304D\308B\5834\5408\3001\30D5\30A3\30EB\30BF\7D50\679C\3092\53D6\5F97\3059\308B\30D1\30D5\30A9\30FC\30DE\30F3\30B9\3092\5411\4E0A\3067\304D\307E\3059\3002'),
unistr('          <strong>\300C\5927\6587\5B57\300D</strong>\307E\305F\306F<strong>\300C\5C0F\6587\5B57\300D</strong>\304C\9078\629E\3055\308C\308B\3068\3001\5E38\306B\5927/\5C0F\6587\5B57\3092\533A\5225\3059\308B\691C\7D22\304C\5B9F\884C\3055\308C\307E\3059\3002</p>'),
unistr('        <p>\30CE\30FC\30C8 - \300C\6DF7\5728\300D\304C\9078\629E\3055\308C\308B\3068\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\300C\691C\7D22\300D\304A\3088\3073\300C\30D5\30A3\30EB\30BF\300D\30C0\30A4\30A2\30ED\30B0\3067<strong>\300C\5927/\5C0F\6587\5B57\533A\5225\300D</strong>\3092\6307\5B9A\3067\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104105956220308521)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.LOWER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C0F\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104106056901308521)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.LOWER.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5217\5024\304C\5E38\306B\5C0F\6587\5B57\3067\683C\7D0D\3055\308C\307E\3059\3002'),
unistr('        &PRODUCT_NAME.\306Fwhere\53E5\3067<code>column <em>operator</em> LOWER(filtervalue)</code>\3092\4F7F\7528\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104106161658308521)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.MIXED.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6DF7\5728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104106251161308522)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.MIXED.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\5024\304C\6DF7\5728\3059\308B\5927/\5C0F\6587\5B57\3067\683C\7D0D\3055\308C\307E\3059\3002<strong>\300C\5927/\5C0F\6587\5B57\533A\5225\300D</strong>\6F14\7B97\5B50\306E\8A2D\5B9A\306B\3088\308A\3001\4F7F\7528\3055\308C\308Bwhere\53E5\304C\6C7A\5B9A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104105752495308521)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.UPPER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5927\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104105835275308521)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.UPPER.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5217\5024\304C\5E38\306B\5927\6587\5B57\3067\683C\7D0D\3055\308C\307E\3059\3002'),
unistr('        &PRODUCT_NAME.\306Fwhere\53E5\3067<code>column <em>operator</em> UPPER(filtervalue)</code>\3092\4F7F\7528\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104105529262308521)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8\306E\5927/\5C0F\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103899651633308327)
,p_name=>'PE.PROPERTY.FIRE_ON_PAGE_LOAD.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\521D\671F\5316\6642\306B\30A2\30AF\30B7\30E7\30F3\3092\8D77\52D5\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002</p>'),
unistr('        							<p>\521D\671F\5316\306E\610F\5473\306F\3001\52D5\7684\30A2\30AF\30B7\30E7\30F3\304C\3069\306E\3088\3046\306B\5B9A\7FA9\3055\308C\3066\3044\308B\304B\306B\3088\3063\3066\591A\5C11\7570\306A\308A\307E\3059\3002\52D5\7684\30A2\30AF\30B7\30E7\30F3\304C'),
unistr('        							\5BFE\8A71\30B0\30EA\30C3\30C9\5217\3067\8D77\52D5\3059\308B\3088\3046\306B\5B9A\7FA9\3055\308C\3066\3044\308B\5834\5408\3001\3053\308C\306F\3001\5BFE\8A71\30B0\30EA\30C3\30C9\884C\304C\7DE8\96C6\306E\305F\3081\306B\30A2\30AF\30C6\30A3\30D6\5316\3055\308C\305F\3068\304D\306B'),
unistr('        							\30A2\30AF\30B7\30E7\30F3\3092\8D77\52D5\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002\4ED6\306E\3059\3079\3066\306E\52D5\7684\30A2\30AF\30B7\30E7\30F3\3067\306F\3001\3053\308C\306F\3001\30DA\30FC\30B8\304C\30ED\30FC\30C9\3055\308C\305F\3068\304D\306B\30A2\30AF\30B7\30E7\30F3\3092'),
unistr('        							\8D77\52D5\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103899569162308327)
,p_name=>'PE.PROPERTY.FIRE_ON_PAGE_LOAD.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\521D\671F\5316\6642\306B\5B9F\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103899421572308326)
,p_name=>'PE.PROPERTY.FIRE_WHEN_EVENT_RESULT_IS.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30C8\30EA\30AC\30FC\8981\7D20\6761\4EF6\304C\6E80\305F\3055\308C\305F\3068\304D\306B\30A2\30AF\30B7\30E7\30F3\3092\8D77\52D5\3059\308B(True\30A2\30AF\30B7\30E7\30F3)\304B\3001\6E80\305F\3055\308C\306A\3044\3068\304D\306B\8D77\52D5\3059\308B(False\30A2\30AF\30B7\30E7\30F3)\304B\3092<strong>True</strong>\307E\305F\306F<strong>False</strong>\3092\9078\629E\3057\3066\6307\5B9A\3057\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8: \6761\4EF6\304C\6307\5B9A\3055\308C\3066\3044\306A\3044\5834\5408\3001<strong>True</strong>\30A2\30AF\30B7\30E7\30F3\306E\307F\304C\8D77\52D5\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104389124120308749)
,p_name=>'PE.PROPERTY.FIRE_WHEN_EVENT_RESULT_IS.LOV.FALSE.D'
,p_message_language=>'ja'
,p_message_text=>'False'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104389080893308749)
,p_name=>'PE.PROPERTY.FIRE_WHEN_EVENT_RESULT_IS.LOV.TRUE.D'
,p_message_language=>'ja'
,p_message_text=>'True'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103899312889308326)
,p_name=>'PE.PROPERTY.FIRE_WHEN_EVENT_RESULT_IS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30D9\30F3\30C8\7D50\679C\6642\306B\5B9F\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104773291522309068)
,p_name=>'PE.PROPERTY.FIXED_HEADER.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\304C\30EC\30DD\30FC\30C8\3092\5782\76F4\306B\30B9\30AF\30ED\30FC\30EB\3057\305F\3068\304D\306B\5217\30D8\30C3\30C0\30FC\304C\8868\793A\3055\308C\305F\307E\307E\306B\306A\308B\3088\3046\306B\3001\30EC\30DD\30FC\30C8\306E\5217\30D8\30C3\30C0\30FC\3092<strong>\30DA\30FC\30B8</strong>\306E\6700\4E0A\90E8\307E\305F\306F<strong>\30EA\30FC\30B8\30E7\30F3</strong>\306E\6700\4E0A\90E8\306B\56FA\5B9A\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104774255366309069)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.NONE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104774323164309069)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.NONE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\30FB\30D8\30C3\30C0\30FC\304C\56FA\5B9A\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104773461596309068)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.PAGE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104773685692309069)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.PAGE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\30FB\30D8\30C3\30C0\30FC\3092\30DA\30FC\30B8\306E\6700\4E0A\90E8\306B\56FA\5B9A\3057\307E\3059\3002\30E6\30FC\30B6\30FC\304C\30DA\30FC\30B8\3092\5782\76F4\306B\30B9\30AF\30ED\30FC\30EB\3057\3066\3082\3001\30EC\30DD\30FC\30C8\30FB\30D8\30C3\30C0\30FC\306F\30DA\30FC\30B8\306E\6700\4E0A\90E8\306B\56FA\5B9A\3055\308C\305F\307E\307E\306B\306A\308A\307E\3059\3002<strong>\30DA\30FC\30B8</strong>\30FB\30EC\30D9\30EB\3067\56FA\5B9A\3055\308C\305F\30D8\30C3\30C0\30FC\306F\3001\30EC\30DD\30FC\30C8\304C\30DA\30FC\30B8\306E\30E1\30A4\30F3\30FB\30B3\30F3\30C6\30F3\30C4\3067\3042\308B\5834\5408\306B\4FBF\5229\3067\3059\3002\3053\306E\8A2D\5B9A\306F\3001\30EA\30FC\30B8\30E7\30F3\304C\30C0\30A4\30A2\30ED\30B0\5185\306B\3042\308B\5834\5408\306B\306F\30B5\30DD\30FC\30C8\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104773356543309068)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.REGION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104773571240309068)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.REGION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\30FB\30D8\30C3\30C0\30FC\3092\73FE\5728\306E\30EA\30FC\30B8\30E7\30F3\306E\6700\4E0A\90E8\306B\56FA\5B9A\3057\307E\3059\3002\30EA\30FC\30B8\30E7\30F3\5185\3067\30E6\30FC\30B6\30FC\304C\5782\76F4\306B\30B9\30AF\30ED\30FC\30EB\3057\3066\3082\3001\30EC\30DD\30FC\30C8\30FB\30D8\30C3\30C0\30FC\306F\30EA\30FC\30B8\30E7\30F3\306E\6700\4E0A\90E8\306B\56FA\5B9A\3055\308C\305F\307E\307E\306B\306A\308A\307E\3059\3002<strong>\30EA\30FC\30B8\30E7\30F3</strong>\30FB\30EC\30D9\30EB\3067\56FA\5B9A\3055\308C\305F\30D8\30C3\30C0\30FC\306F\3001\30C0\30C3\30B7\30E5\30DC\30FC\30C9\30FB\30DA\30FC\30B8\306A\3069\3001\8907\6570\306E\30EA\30FC\30B8\30E7\30F3\3092\542B\3080\30DA\30FC\30B8\306B\4FBF\5229\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104773165549309068)
,p_name=>'PE.PROPERTY.FIXED_HEADER.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\56FA\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104774654454309069)
,p_name=>'PE.PROPERTY.FIXED_HEADER_MAX_HEIGHT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D4\30AF\30BB\30EB\5358\4F4D\3067\30EC\30DD\30FC\30C8\306E\6700\5927\306E\9AD8\3055\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104774528906309069)
,p_name=>'PE.PROPERTY.FIXED_HEADER_MAX_HEIGHT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5927\306E\30EC\30DD\30FC\30C8\306E\9AD8\3055')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104774791720309069)
,p_name=>'PE.PROPERTY.FIXED_HEADER_MAX_HEIGHT.UNIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D4\30AF\30BB\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104282616575308669)
,p_name=>'PE.PROPERTY.FIXED_REPORT_HEIGHT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D4\30AF\30BB\30EB\5358\4F4D\3067\30EC\30DD\30FC\30C8\306E\56FA\5B9A\306E\9AD8\3055\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104282566373308669)
,p_name=>'PE.PROPERTY.FIXED_REPORT_HEIGHT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\56FA\5B9A\306E\30EC\30DD\30FC\30C8\306E\9AD8\3055')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104282704231308669)
,p_name=>'PE.PROPERTY.FIXED_REPORT_HEIGHT.UNIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D4\30AF\30BB\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104099136214308516)
,p_name=>'PE.PROPERTY.FIXED_ROW_HEIGHT.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\56FA\5B9A\306E\884C\306E\9AD8\3055\3067\5BFE\8A71\30B0\30EA\30C3\30C9\3092\8868\793A\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002</p>'),
unistr('        <p><em>\300C\306F\3044\300D</em>\306B\8A2D\5B9A\3055\308C\3066\3044\308B\5834\5408\3001\72ED\3059\304E\3066\3059\3079\3066\306E\30C7\30FC\30BF\3092\8868\793A\3067\304D\306A\3044\5217\306B\306F\7701\7565\8A18\53F7(...)\304C\30C7\30FC\30BF\306E\6700\5F8C\306B\8868\793A\3055\308C\307E\3059\3002'),
unistr('        <em>\300C\3044\3044\3048\300D</em>\306B\8A2D\5B9A\3055\308C\3066\3044\308B\5834\5408\3001\5FC5\8981\306B\5FDC\3058\3066\30C7\30FC\30BF\304C\8907\6570\306E\884C\3067\30E9\30C3\30D7\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104099046925308515)
,p_name=>'PE.PROPERTY.FIXED_ROW_HEIGHT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\56FA\5B9A\306E\884C\306E\9AD8\3055')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103968579412308412)
,p_name=>'PE.PROPERTY.FOOTER_TEXT.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30DC\30C7\30A3\30FB\30B3\30F3\30C6\30F3\30C4\306E\76F4\5F8C(\30EA\30FC\30B8\30E7\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306E<code>#BODY#</code>\306E\5F8C)\306B\8868\793A\3055\308C\308B\30EA\30FC\30B8\30E7\30F3\30FB\30D5\30C3\30BF\30FC\3092\5165\529B\3057\307E\3059\3002'),
unistr('\30EA\30FC\30B8\30E7\30F3\306E\30EC\30F3\30C0\30EA\30F3\30B0\306B\4F7F\7528\3055\308C\308B\6642\9593\3092\8868\793A\3059\308B\306B\306F\3001\7F6E\63DB\6587\5B57\5217<code>#TIMING#</code>\304A\3088\3073\30B7\30E7\30FC\30C8\30AB\30C3\30C8\3092\4F7F\7528\3067\304D\307E\3059\3002</p>'),
unistr('<p>\30EC\30DD\30FC\30C8\30FB\30EA\30FC\30B8\30E7\30F3\3067\306F\3001\6B21\306E\30DA\30FC\30B8\533A\5207\308A\7F6E\63DB\6587\5B57\5217\3092\4F7F\7528\3067\304D\307E\3059\3002</p>'),
'<dl>',
'  <dt><code>#ROWS_FETCHED#</code></dt>',
unistr('    <dd>\30EC\30DD\30FC\30C8\30FB\30A8\30F3\30B8\30F3\306B\3088\3063\3066\30D5\30A7\30C3\30C1\3055\308C\308B\884C\6570(\30DA\30FC\30B8\30FB\30B5\30A4\30BA)\3092\8868\793A\3057\307E\3059\3002\3053\308C\3089\306E\7F6E\63DB\6587\5B57\5217\3092\4F7F\7528\3059\308B\3068\3001\30AB\30B9\30BF\30DE\30A4\30BA\3055\308C\305F\30E1\30C3\30BB\30FC\30B8\304C\30E6\30FC\30B6\30FC\306B\8868\793A\3055\308C\307E\3059\3002</dd>'),
'  <dt><code>#TOTAL_ROWS#</code></dt>',
unistr('    <dd>\30EC\30DD\30FC\30C8\306B\4F7F\7528\3055\308C\308BSQL\554F\5408\305B\3092\6E80\305F\3059\884C\6570\306E\5408\8A08\3092\8868\793A\3057\307E\3059\3002\305F\3068\3048\3070\3001\300CZ\306E\884CX\304B\3089Y\300D\306E\300CZ\300D</dd>'),
'  <dt><code>#FIRST_ROW_FETCHED#</code></dt>',
unistr('    <dd>\300CZ\306E\884CX\304B\3089Y\300D\306E\300CX\300D</li></dd>'),
'  <dt><code>#LAST_ROW_FETCHED#</code></dt>',
unistr('    <dd>\300CZ\306E\884CX\304B\3089Y\300D\306E\300CY\300D</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103878136702308307)
,p_name=>'PE.PROPERTY.FOOTER_TEXT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\30FB\30D5\30C3\30BF\30FC\306E\524D\306B\8868\793A\3059\308B\30C6\30AD\30B9\30C8\307E\305F\306FHTML\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103878032463308307)
,p_name=>'PE.PROPERTY.FOOTER_TEXT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30C3\30BF\30FC\30FB\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104417968273308771)
,p_name=>'PE.PROPERTY.FORMATTING_CSS_CLASSES.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\3053\306E\5C5E\6027\3092<code>fielddatabold</code>\306B\8A2D\5B9A\3059\308B\3053\3068\306B\3088\3063\3066\6B21\306EHTML\3092\751F\6210</dt>'),
'<dd><pre>',
'&lt;span class="fielddatabold"&gt;Sample Data&lt;/span&gt;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104235363127308635)
,p_name=>'PE.PROPERTY.FORMATTING_CSS_CLASSES.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\5217\306E\5024\306B\9069\7528\3059\308BCSS\30AF\30E9\30B9\3092\5165\529B\3057\307E\3059\3002CSS\30AF\30E9\30B9\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002</p>'),
unistr('<p>\3053\306E\30AF\30E9\30B9\306F\3001\30C7\30D5\30A9\30EB\30C8\3067\3059\3079\3066\306E&PRODUCT_NAME.\30DA\30FC\30B8\306B\542B\307E\308C\3001<code>''.fielddatabold{font-size: 10pt; font-weight: bold; color: #000000;}''</code>\3068\3044\3046\5B9A\7FA9\3092\6301\3061\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104235201762308635)
,p_name=>'PE.PROPERTY.FORMATTING_CSS_CLASSES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('CSS\30AF\30E9\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104236815636308636)
,p_name=>'PE.PROPERTY.FORMAT_MASK.COMPONENT_PROPERTY.CLASSIC_REPORT_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\5217\306B\9069\7528\3059\308B\66F8\5F0F\30DE\30B9\30AF\3092\5165\529B\3057\307E\3059\3002'),
unistr('    \66F8\5F0F\30DE\30B9\30AF\3092\5165\529B\3059\308B\304B\3001\66F8\5F0F\30DE\30B9\30AF\306E\8868\793A\306E\30B5\30F3\30D7\30EB\306B\57FA\3065\3044\3066\3001\4E8B\524D\5B9A\7FA9\3055\308C\305F\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002</p>'),
unistr('    <p>\6570\5024\66F8\5F0F\30DE\30B9\30AF\306F\6570\5024\3092\542B\3080\5217\306B\306E\307F\9069\7528\3055\308C\3001\65E5\4ED8\66F8\5F0F\30DE\30B9\30AF\306F\65E5\4ED8\3092\542B\3080\5217\306B\306E\307F\9069\7528\3055\308C\308B\3053\3068\304C\91CD\8981\3067\3059\3002'),
unistr('    \305D\3046\3067\306F\306A\3044\5834\5408\3001\6307\5B9A\3055\308C\305F\66F8\5F0F\30DE\30B9\30AF\3092\4F7F\7528\3057\3066\5909\63DB\3067\304D\306A\3044\5024\304C\30EC\30B3\30FC\30C9\306B\542B\307E\308C\308B\5834\5408\3001\30E9\30F3\30BF\30A4\30E0\30FB\30A8\30E9\30FC\304C\767A\751F\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104256903519308651)
,p_name=>'PE.PROPERTY.FORMAT_MASK.COMPONENT_PROPERTY.TABULAR_FORM_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\5217\306B\9069\7528\3059\308B\66F8\5F0F\30DE\30B9\30AF\3092\5165\529B\3057\307E\3059\3002'),
unistr('    \66F8\5F0F\30DE\30B9\30AF\3092\5165\529B\3059\308B\304B\3001\66F8\5F0F\30DE\30B9\30AF\306E\8868\793A\306E\30B5\30F3\30D7\30EB\306B\57FA\3065\3044\3066\3001\4E8B\524D\5B9A\7FA9\3055\308C\305F\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002</p>'),
unistr('    <p>\6570\5024\66F8\5F0F\30DE\30B9\30AF\306F\6570\5024\3092\542B\3080\5217\306B\306E\307F\9069\7528\3055\308C\3001\65E5\4ED8\66F8\5F0F\30DE\30B9\30AF\306F\65E5\4ED8\3092\542B\3080\5217\306B\306E\307F\9069\7528\3055\308C\308B\3053\3068\304C\91CD\8981\3067\3059\3002'),
unistr('    \305D\3046\3067\306F\306A\3044\5834\5408\3001\6307\5B9A\3055\308C\305F\66F8\5F0F\30DE\30B9\30AF\3092\4F7F\7528\3057\3066\5909\63DB\3067\304D\306A\3044\5024\304C\30EC\30B3\30FC\30C9\306B\542B\307E\308C\308B\5834\5408\3001\30E9\30F3\30BF\30A4\30E0\30FB\30A8\30E9\30FC\304C\767A\751F\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103882835397308310)
,p_name=>'PE.PROPERTY.FORMAT_MASK.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\9069\7528\3059\308B\66F8\5F0F\30DE\30B9\30AF\3092\5165\529B\3057\307E\3059\3002'),
unistr('   \66F8\5F0F\30DE\30B9\30AF\3092\5165\529B\3059\308B\304B\3001\66F8\5F0F\30DE\30B9\30AF\306E\8868\793A\306E\30B5\30F3\30D7\30EB\306B\57FA\3065\3044\3066\3001\4E8B\524D\5B9A\7FA9\3055\308C\305F\66F8\5F0F\30DE\30B9\30AF\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002</p>'),
unistr('   <p>\6570\5024\66F8\5F0F\30DE\30B9\30AF\306F\6570\5024\3092\542B\3080\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\306E\307F\9069\7528\3055\308C\3001\65E5\4ED8\66F8\5F0F\30DE\30B9\30AF\306F\65E5\4ED8\3092\542B\3080\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\306E\307F\9069\7528\3055\308C\308B\3053\3068\304C\91CD\8981\3067\3059\3002'),
unistr('    \305D\3046\3067\306F\306A\3044\5834\5408\3001\6307\5B9A\3055\308C\305F\66F8\5F0F\30DE\30B9\30AF\3092\4F7F\7528\3057\3066\5909\63DB\3067\304D\306A\3044\5024\304C\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\542B\307E\308C\308B\5834\5408\3001\30E9\30F3\30BF\30A4\30E0\30FB\30A8\30E9\30FC\304C\767A\751F\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103882744852308310)
,p_name=>'PE.PROPERTY.FORMAT_MASK.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F8\5F0F\30DE\30B9\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103883034844308310)
,p_name=>'PE.PROPERTY.FORMAT_MASK_DATE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\9069\7528\3059\308B\65E5\4ED8\66F8\5F0F\30DE\30B9\30AF\3092\5165\529B\3057\307E\3059\3002'),
unistr('\66F8\5F0F\30DE\30B9\30AF\3092\5165\529B\3059\308B\304B\3001\66F8\5F0F\30DE\30B9\30AF\306B\3088\308B\8868\793A\306E\30B5\30F3\30D7\30EB\306B\57FA\3065\3044\3066\3001\4E8B\524D\5B9A\7FA9\3055\308C\305F\66F8\5F0F\30DE\30B9\30AF\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002'),
unistr('\7F6E\63DB\69CB\6587\3092\4F7F\7528\3057\3066\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\307E\305F\306F\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\304B\3089\52D5\7684\66F8\5F0F\30DE\30B9\30AF\3092\53C2\7167\3059\308B\3053\3068\3082\3067\304D\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103882901332308310)
,p_name=>'PE.PROPERTY.FORMAT_MASK_DATE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F8\5F0F\30DE\30B9\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103883250758308310)
,p_name=>'PE.PROPERTY.FORMAT_MASK_NUMBER.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\9069\7528\3059\308B\6570\5024\66F8\5F0F\30DE\30B9\30AF\3092\5165\529B\3057\307E\3059\3002'),
unistr('\66F8\5F0F\30DE\30B9\30AF\3092\5165\529B\3059\308B\304B\3001\66F8\5F0F\30DE\30B9\30AF\306B\3088\308B\8868\793A\306E\30B5\30F3\30D7\30EB\306B\57FA\3065\3044\3066\3001\4E8B\524D\5B9A\7FA9\3055\308C\305F\66F8\5F0F\30DE\30B9\30AF\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002'),
unistr('\7F6E\63DB\69CB\6587\3092\4F7F\7528\3057\3066\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\307E\305F\306F\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\304B\3089\66F8\5F0F\30DE\30B9\30AF\3092\53C2\7167\3059\308B\3053\3068\3082\3067\304D\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103883123873308310)
,p_name=>'PE.PROPERTY.FORMAT_MASK_NUMBER.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F8\5F0F\30DE\30B9\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103879594531308308)
,p_name=>'PE.PROPERTY.FORM_AUTO_COMPLETE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\3053\306E\30DA\30FC\30B8\306B\5BFE\3057\3066\30AA\30FC\30C8\30B3\30F3\30D7\30EA\30FC\30C8\3092\7121\52B9\306B\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002<strong>\300C\30AA\30F3\300D</strong>\306E\5024\306F\3053\306E\30DA\30FC\30B8\306B\306F\5F71\97FF\3057\307E\305B\3093\3002<strong>\300C\30AA\30D5\300D</strong>\306E\5024\306B\3088\3063\3066FORM\30BF\30B0\5185\306B\6B21\306EHTML\304C\751F\6210\3055\308C\307E\3059\3002'),
'<pre>',
'autocomplete="off"',
'</pre>',
unistr('<p>\30CE\30FC\30C8: <code>autocomplete="off"</code>\304C\512A\5148\3055\308C\305F\308A\7121\8996\3055\308C\305F\308A\3059\308B\3068\3001\30D6\30E9\30A6\30B6\306B\3088\3063\3066\7570\306A\308B\30EB\30FC\30EB\3092\6301\3064\5834\5408\304C\3042\308A\307E\3059\3002\3057\305F\304C\3063\3066\3001\3053\308C\3092<strong>\300C\30AA\30D5\300D</strong>\306B\8A2D\5B9A\3059\308B\5834\5408\306F\7279\306B\6CE8\610F\3057\3001\30BF\30FC\30B2\30C3\30C8\30FB\30D6\30E9\30A6\30B6\3067\30C6\30B9\30C8\3092\5B9F\884C\3057\3066\304F\3060\3055\3044\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104381001627308742)
,p_name=>'PE.PROPERTY.FORM_AUTO_COMPLETE.LOV.OFF.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104380973316308742)
,p_name=>'PE.PROPERTY.FORM_AUTO_COMPLETE.LOV.ON.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103879451327308308)
,p_name=>'PE.PROPERTY.FORM_AUTO_COMPLETE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30FC\30E0\306E\30AA\30FC\30C8\30B3\30F3\30D7\30EA\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103590980737308081)
,p_name=>'PE.PROPERTY.GAUGE_LABEL_COLUMN_NAME.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\306E\30E9\30D9\30EB\3092\5B9A\7FA9\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\5217\540D\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103590806478308081)
,p_name=>'PE.PROPERTY.GAUGE_LABEL_COLUMN_NAME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104233875459308634)
,p_name=>'PE.PROPERTY.GENERIC_COLUMN_COUNT.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6C4E\7528\30EC\30DD\30FC\30C8\5217\306E\6700\5927\6570\3092\5165\529B\3057\307E\3059\3002'),
unistr('\6C4E\7528\5217\540D\3092\4F7F\7528\3059\308B\30EC\30DD\30FC\30C8\306F\3001\5B9F\884C\6642\306B\306E\307F\89E3\6790\3055\308C\308B\305F\3081\3001\30EC\30DD\30FC\30C8\306E\7DE8\96C6\6642\306B\306F\5217\6570\306F\4E0D\660E\3067\3059\3002</p>'),
unistr('<p>\30EC\30DD\30FC\30C8\5217\306E\6700\5927\6570\306F\3001\4E88\60F3\3055\308C\308B\30EC\30DD\30FC\30C8\5217\306E\6570\3068\4E00\81F4\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002'),
unistr('\5B9F\969B\306E\6570\304C\6700\5927\6570\3088\308A\3082\5C11\306A\3044\5834\5408\3001\30EC\30DD\30FC\30C8\306B\306F\5B9F\969B\306E\5217\6570\304C\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\307E\3059\3002'),
unistr('\305F\3060\3057\3001\5B9F\969B\306E\6570\304C\6700\5927\6570\3088\308A\3082\591A\3044\5834\5408\306F\3001\5B9F\884C\6642\306B\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\304C\8868\793A\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104233788583308634)
,p_name=>'PE.PROPERTY.GENERIC_COLUMN_COUNT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6C4E\7528\5217\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104020623614308451)
,p_name=>'PE.PROPERTY.GLOBAL_PAGE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\306E\30B0\30ED\30FC\30D0\30EB\30FB\30DA\30FC\30B8\3092\9078\629E\3057\307E\3059(\5B9A\7FA9\3055\308C\3066\3044\306A\3044\5834\5408)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104020565822308451)
,p_name=>'PE.PROPERTY.GLOBAL_PAGE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30ED\30FC\30D0\30EB\30FB\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104681529976308984)
,p_name=>'PE.PROPERTY.GRID_COLUMN.COMPONENT_PROPERTY.BUTTON.NULL_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104254843398308649)
,p_name=>'PE.PROPERTY.GRID_COLUMN.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\52D5')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104255138209308650)
,p_name=>'PE.PROPERTY.GRID_COLUMN.COMPONENT_PROPERTY.REGION.NULL_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103881803502308309)
,p_name=>'PE.PROPERTY.GRID_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\7279\5B9A\306E\30EC\30A4\30A2\30A6\30C8\5217\3092\9078\629E\3057\307E\3059\3002\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306E\8868\793A\304C\53EF\80FD\306A\6B21\306E\30EC\30A4\30A2\30A6\30C8\5217\3092\81EA\52D5\7684\306B\6C7A\5B9A\3059\308B\306B\306F<strong>\300C\81EA\52D5\300D</strong>\3092\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103881780251308309)
,p_name=>'PE.PROPERTY.GRID_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103882616918308310)
,p_name=>'PE.PROPERTY.GRID_COLUMN_ATTRIBUTES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30A4\30A2\30A6\30C8\5217\306B\8A2D\5B9A\3055\308C\308B\8FFD\52A0\5C5E\6027\3092\5165\529B\3057\307E\3059\3002\3053\306E\5024\306B\3088\3063\3066\3001\30EC\30A4\30A2\30A6\30C8\5217\30C6\30F3\30D7\30EC\30FC\30C8\306E<code>#ATTRIBUTES#</code>\7F6E\63DB\30D7\30EC\30FC\30B9\30DB\30EB\30C0\304C\7F6E\63DB\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103882511383308310)
,p_name=>'PE.PROPERTY.GRID_COLUMN_ATTRIBUTES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104581078153308904)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.COMPONENT_PROPERTY.CARD.NULL_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104565697168308891)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\3088\3063\3066\5360\6709\3055\308C\308B\30EC\30A4\30A2\30A6\30C8\5217\6570\3092\9078\629E\3057\307E\3059\3002\540C\3058\884C\306E\3059\3079\3066\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\3067\4F7F\7528\53EF\80FD\306A\30EC\30A4\30A2\30A6\30C8\5217\3092\5747\7B49\306B\914D\7F6E\3059\308B\306B\306F\3001\300C\81EA\52D5\300D\3092\4F7F\7528\3057\307E\3059\3002</p>'),
'<dl>',
unistr('  <dt>\81EA\52D5</dt>'),
unistr('    <dd>\30AB\30FC\30C9\306E\5E45\306B\306F\521D\671F\5024\304C\4F7F\7528\3055\308C\3001\30AB\30FC\30C9\304C\53CE\307E\308A\304D\3089\306A\304F\306A\3063\305F\5834\5408\306F\3001\65B0\3057\3044\884C\306B\81EA\52D5\7684\306B\6298\308A\8FD4\3055\308C\307E\3059\3002</dd>'),
unistr('  <dt>2\5217\30013\5217\30014\5217\30015\5217</dt>'),
unistr('    <dd>\30AB\30FC\30C9\306F\3001\5404\884C\306E\9078\629E\3055\308C\305F\5217\6570\306B\53CE\307E\308B\3088\3046\306B\914D\7F6E\3055\308C\307E\3059\3002\30D3\30E5\30FC\30DD\30FC\30C8\306E\5E45\306B\5FDC\3058\3066\3001\30EC\30A4\30A2\30A6\30C8\306E\5217\6570\304C\6E1B\3089\3055\308C\308B\3053\3068\304C\3042\308A\307E\3059\3002</dd>'),
unistr('  <dt>CSS\5909\6570\3092\8A2D\5B9A\3057\3066\3001\30AB\30FC\30C9\306E\5E45\3092\69CB\6210\3067\304D\307E\3059\3002</dt>'),
unistr('    <dd>\305F\3068\3048\3070\3001\30AB\30FC\30C9\306E\5E45\3092320px\306B\8A2D\5B9A\3059\308B\306B\306F\3001\6B21\306E\30B9\30CB\30DA\30C3\30C8\3092\8FFD\52A0\3057\307E\3059\3002<pre>:root {'),
'  --a-cv-item-width: 320px;',
'}</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104565784068308891)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.LOV.2.D'
,p_message_language=>'ja'
,p_message_text=>unistr('2\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104565871119308891)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.LOV.3.D'
,p_message_language=>'ja'
,p_message_text=>unistr('3\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104565945882308891)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.LOV.4.D'
,p_message_language=>'ja'
,p_message_text=>unistr('4\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104566083629308891)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.LOV.5.D'
,p_message_language=>'ja'
,p_message_text=>unistr('5\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104565587777308891)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30EA\30C3\30C9\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104776130107309070)
,p_name=>'PE.PROPERTY.GRID_COLUMN_CSS_CLASSES.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30EA\30FC\30B8\30E7\30F3\3092\542B\3080\30EC\30A4\30A2\30A6\30C8\5217\306B\9069\7528\3059\308BCSS\30AF\30E9\30B9\3092\5165\529B\3057\307E\3059\3002\8907\6570\306E\30AF\30E9\30B9\306F\7A7A\767D\3067\533A\5207\3063\3066\8FFD\52A0\3067\304D\307E\3059\3002</p>'),
unistr('        <p>\3053\306E\30D7\30ED\30D1\30C6\30A3\3092\4F7F\7528\3057\3066\3001\30D3\30E5\30FC\30DD\30FC\30C8\30FB\30B5\30A4\30BA\306E\5909\66F4\306B\5FDC\3058\3066\30EA\30FC\30B8\30E7\30F3\306E\30EC\30A4\30A2\30A6\30C8\5217\306E\5FDC\7B54\6027\3068\30EC\30A4\30A2\30A6\30C8\306B\5BFE\3057\3066\30D5\30A1\30A4\30F3\30B0\30EC\30A4\30F3\5236\5FA1\3092\63D0\4F9B\3067\304D\307E\3059\3002'),
unistr('        \30E6\30CB\30D0\30FC\30B5\30EB\30FB\30C6\30FC\30DE\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\306F\3001\30DA\30FC\30B8\30FB\30B3\30F3\30DD\30FC\30CD\30F3\30C8\3092\62E1\5F35\3059\308B\305F\3081\306B\4F7F\7528\3067\304D\308B\591A\6570\306ECSS\4FEE\98FE\5B50\304C\3042\308A\307E\3059\3002\3055\3089\306B\5B66\7FD2\3059\308B\306B\306F\3001\30E6\30CB\30D0\30FC\30B5\30EB\30FB\30C6\30FC\30DE\306E\30B5\30F3\30D7\30EB\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30EA\30D5\30A1\30EC\30F3\30B9\30FB\30BB\30AF\30B7\30E7\30F3\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104776013610309070)
,p_name=>'PE.PROPERTY.GRID_COLUMN_CSS_CLASSES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217CSS\30AF\30E9\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104681620108308984)
,p_name=>'PE.PROPERTY.GRID_COLUMN_SPAN.COMPONENT_PROPERTY.BUTTON.NULL_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104254977054308649)
,p_name=>'PE.PROPERTY.GRID_COLUMN_SPAN.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104255239228308650)
,p_name=>'PE.PROPERTY.GRID_COLUMN_SPAN.COMPONENT_PROPERTY.REGION.NULL_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103882290521308310)
,p_name=>'PE.PROPERTY.GRID_COLUMN_SPAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\3088\3063\3066\5360\6709\3055\308C\308B\30EC\30A4\30A2\30A6\30C8\5217\6570\3092\9078\629E\3057\307E\3059\3002\540C\3058\884C\306E\3059\3079\3066\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\3067\4F7F\7528\53EF\80FD\306A\30EC\30A4\30A2\30A6\30C8\5217\3092\5747\7B49\306B\914D\7F6E\3059\308B\306B\306F\3001<strong>\300C\81EA\52D5\300D</strong>\3092\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103882129093308310)
,p_name=>'PE.PROPERTY.GRID_COLUMN_SPAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\30B9\30D1\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104773091228309068)
,p_name=>'PE.PROPERTY.GRID_LABEL_COLUMN_SPAN.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306E\30C7\30D5\30A9\30EB\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104772922572309068)
,p_name=>'PE.PROPERTY.GRID_LABEL_COLUMN_SPAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB\306B\3088\3063\3066\5360\6709\3055\308C\308B\30EC\30A4\30A2\30A6\30C8\5217\306E\6570\3092\9078\629E\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104772836432309068)
,p_name=>'PE.PROPERTY.GRID_LABEL_COLUMN_SPAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB\5217\30B9\30D1\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103882002663308309)
,p_name=>'PE.PROPERTY.GRID_NEW_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\3092\6B21\306E\5217\306B\8868\793A\3059\308B\304B\3001\307E\305F\306F\524D\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\3068\540C\3058\5217\306B\8868\793A\3059\308B\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103881948007308309)
,p_name=>'PE.PROPERTY.GRID_NEW_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103881421107308309)
,p_name=>'PE.PROPERTY.GRID_NEW_GRID.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\3092\65B0\898F\30EC\30A4\30A2\30A6\30C8\306B\8868\793A\3059\308B\304B\3001\307E\305F\306F\524D\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\3068\540C\3058\30EC\30A4\30A2\30A6\30C8\306B\8868\793A\3059\308B\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103881398532308309)
,p_name=>'PE.PROPERTY.GRID_NEW_GRID.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F\30EC\30A4\30A2\30A6\30C8\306E\958B\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103881684351308309)
,p_name=>'PE.PROPERTY.GRID_NEW_ROW.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\3092\3001\524D\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306E\6B21\306E\884C\306B\8868\793A\3059\308B\304B\3001\540C\3058\884C\306B\8868\793A\3059\308B\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103881508171308309)
,p_name=>'PE.PROPERTY.GRID_NEW_ROW.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F\884C\306E\958B\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104539775118308867)
,p_name=>'PE.PROPERTY.GRID_ROW_CSS_CLASSES.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30EA\30FC\30B8\30E7\30F3\3092\542B\3080\30EC\30A4\30A2\30A6\30C8\884C\306B\9069\7528\3059\308BCSS\30AF\30E9\30B9\3092\5165\529B\3057\307E\3059\3002\8907\6570\306E\30AF\30E9\30B9\306F\7A7A\767D\3067\533A\5207\3063\3066\8FFD\52A0\3067\304D\307E\3059\3002</p>'),
unistr('        <p>\3053\306E\30D7\30ED\30D1\30C6\30A3\3092\4F7F\7528\3057\3066\3001\30D3\30E5\30FC\30DD\30FC\30C8\30FB\30B5\30A4\30BA\306E\5909\66F4\306B\5FDC\3058\3066\30EA\30FC\30B8\30E7\30F3\306E\30EC\30A4\30A2\30A6\30C8\884C\306E\5FDC\7B54\6027\3068\30EC\30A4\30A2\30A6\30C8\306B\5BFE\3057\3066\30D5\30A1\30A4\30F3\30B0\30EC\30A4\30F3\5236\5FA1\3092\63D0\4F9B\3067\304D\307E\3059\3002'),
unistr('        \30E6\30CB\30D0\30FC\30B5\30EB\30FB\30C6\30FC\30DE\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\306F\3001\30DA\30FC\30B8\30FB\30B3\30F3\30DD\30FC\30CD\30F3\30C8\3092\62E1\5F35\3059\308B\305F\3081\306B\4F7F\7528\3067\304D\308B\591A\6570\306ECSS\4FEE\98FE\5B50\304C\3042\308A\307E\3059\3002\3055\3089\306B\5B66\7FD2\3059\308B\306B\306F\3001\30E6\30CB\30D0\30FC\30B5\30EB\30FB\30C6\30FC\30DE\306E\30B5\30F3\30D7\30EB\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30EA\30D5\30A1\30EC\30F3\30B9\30FB\30BB\30AF\30B7\30E7\30F3\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104539689045308867)
,p_name=>'PE.PROPERTY.GRID_ROW_CSS_CLASSES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\884CCSS\30AF\30E9\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103882419848308310)
,p_name=>'PE.PROPERTY.GRID_ROW_SPAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\3088\3063\3066\5360\6709\3055\308C\308BHTML\8868\5185\306E\884C\6570\3092\5165\529B\3057\307E\3059\3002\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306F\3001HTML\8868\5185\306B\914D\7F6E\3055\308C\307E\3059\3002\3053\306E\5C5E\6027\306F\3001\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306E\8868\30BB\30EB\306E<em>ROWSPAN</em>\5C5E\6027\3067\4F7F\7528\3059\308B\5024\3092\6C7A\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103882381396308310)
,p_name=>'PE.PROPERTY.GRID_ROW_SPAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\30B9\30D1\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104158954380308575)
,p_name=>'PE.PROPERTY.GROUP_NAME_COLUMN_NAME.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\51E1\4F8B\306E\30B7\30EA\30FC\30BA\540D\306E\308F\304B\308A\3084\3059\3044\77ED\3044\30AB\30B9\30BF\30E0\30FB\30C4\30FC\30EB\30C1\30C3\30D7\3092\5B9A\7FA9\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\5217\540D\3092\9078\629E\3057\307E\3059\3002\30DC\30C3\30AF\30B9\30FB\30D7\30ED\30C3\30C8\30FB\30C1\30E3\30FC\30C8\306E\5834\5408\3001\5217\306F\3001\9078\629E\3057\305F\5024\5217\30DE\30C3\30D4\30F3\30B0\3068\4E00\81F4\3057\306A\3044\3088\3046\306B\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\5024\5217\30DE\30C3\30D4\30F3\30B0\3068\4E00\81F4\3059\308B\5217\3092\9078\629E\3059\308B\3068\3001\51E1\4F8B\30C4\30FC\30EB\30C1\30C3\30D7\304C\30C1\30E3\30FC\30C8\3067\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104158823000308575)
,p_name=>'PE.PROPERTY.GROUP_NAME_COLUMN_NAME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\51E1\4F8B\306E\30C4\30FC\30EB\30C1\30C3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104159170527308575)
,p_name=>'PE.PROPERTY.GROUP_SHORT_DESC_COLUMN_NAME.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\306EX\8EF8\30E9\30D9\30EB\306E\308F\304B\308A\3084\3059\3044\77ED\3044\30AB\30B9\30BF\30E0\30FB\30C4\30FC\30EB\30C1\30C3\30D7\3092\5B9A\7FA9\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\5217\540D\3092\9078\629E\3057\307E\3059\3002\30DC\30C3\30AF\30B9\30FB\30D7\30ED\30C3\30C8\30FB\30C1\30E3\30FC\30C8\306E\5834\5408\3001\5217\306F\3001\9078\629E\3057\305F\5024\5217\30DE\30C3\30D4\30F3\30B0\3068\4E00\81F4\3057\306A\3044\3088\3046\306B\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\5024\5217\30DE\30C3\30D4\30F3\30B0\3068\4E00\81F4\3059\308B\5217\3092\9078\629E\3059\308B\3068\3001\30E9\30D9\30EB\30FB\30C4\30FC\30EB\30C1\30C3\30D7\304C\30C1\30E3\30FC\30C8\3067\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104159047974308575)
,p_name=>'PE.PROPERTY.GROUP_SHORT_DESC_COLUMN_NAME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB\306E\30C4\30FC\30EB\30C1\30C3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104233619597308634)
,p_name=>'PE.PROPERTY.HAS_GENERIC_COLUMNS.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('SQL\554F\5408\305B\304B\3089\5217\5B9A\7FA9\3092\5C0E\51FA\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002'),
unistr('\3053\306E\5C0E\51FA\3092\884C\3046\306B\306F\3001&PRODUCT_NAME.\3067\554F\5408\305B\3092\89E3\6790\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002'),
unistr('\3053\306E\6642\70B9\3067\554F\5408\305B\3092\89E3\6790\3057\306A\3044\5834\5408\306F\3001\6C4E\7528\5217\540D\3092\4F7F\7528\3057\307E\3059\3002\3053\306E\6C4E\7528\5217\306B\3088\3063\3066\30D7\30EC\30FC\30B9\30DB\30EB\30C0\306E\5217\5B9A\7FA9\304C\751F\6210\3055\308C\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104233567734308634)
,p_name=>'PE.PROPERTY.HAS_GENERIC_COLUMNS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6C4E\7528\5217\540D\306E\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103968434238308412)
,p_name=>'PE.PROPERTY.HEADER_TEXT.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\306E\4E0A\90E8(<code>#BODY#</code>\30B3\30F3\30C6\30F3\30C4\306E\524D)\306B\8868\793A\3055\308C\308BHTML\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103877776261308306)
,p_name=>'PE.PROPERTY.HEADER_TEXT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30D8\30C3\30C0\30FC\3068\30DC\30C7\30A3\30FB\30B3\30F3\30C6\30F3\30C4\306E\9593\306B\8868\793A\3059\308B\30C6\30AD\30B9\30C8\307E\305F\306FHTML\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103877651611308306)
,p_name=>'PE.PROPERTY.HEADER_TEXT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D8\30C3\30C0\30FC\30FB\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104241062274308640)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\306E\30D8\30C3\30C0\30FC\306E\5B9A\7FA9\65B9\6CD5\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104419792226308772)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.COLON_DELMITED_LIST.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30B9\30BF\30E0\30FB\30D8\30C3\30C0\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104419817902308772)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.COLON_DELMITED_LIST.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\72EC\81EA\306E\30D8\30C3\30C0\30FC\3092\5165\529B\3067\304D\307E\3059\3002\30D8\30C3\30C0\30FC\306F\6700\521D\3001\5217\540D\306E\554F\5408\305B\306B\57FA\3065\3044\3066\30C7\30D5\30A9\30EB\30C8\8A2D\5B9A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104419931139308772)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST.D'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104420038963308772)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30ED\30F3\3067\533A\5207\3089\308C\305F\540D\524D\306E\30EA\30B9\30C8\3092\8FD4\3059PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\306B\57FA\3065\3044\3066\30D8\30C3\30C0\30FC\3092\4F5C\6210\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104420180125308772)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.NO_HEADINGS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104420270047308772)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.NO_HEADINGS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\306F\3001\30EC\30DD\30FC\30C8\30FB\30D8\30C3\30C0\30FC\306A\3057\3067\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104419305692308772)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.QUERY_COLUMNS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104419430242308772)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.QUERY_COLUMNS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\540D\306E\554F\5408\305B\306B\57FA\3065\3044\3066\30D8\30C3\30C0\30FC\3092\751F\6210\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104419598645308772)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.QUERY_COLUMNS_INITCAP.D'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('\5217\540D(InitCap)')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104419677729308772)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.QUERY_COLUMNS_INITCAP.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\540D\306E\554F\5408\305B\306B\57FA\3065\3044\3066\30D8\30C3\30C0\30FC\3092\751F\6210\3057\3001\5148\982D\3092\5927\6587\5B57\306B\5909\63DB\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104240933863308639)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104201625478308611)
,p_name=>'PE.PROPERTY.HEADING_ALIGNMENT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D8\30C3\30C0\30FC\306E\4F4D\7F6E\5408\305B\3092\9078\629E\3057\307E\3059\3002\4F4D\7F6E\5408\305B\306E\9078\629E\306F\3001\9078\629E\3057\305F\30EC\30DD\30FC\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3067\30B5\30DD\30FC\30C8\3055\308C\3066\3044\308B\5FC5\8981\304C\3042\308B\3053\3068\306B\6CE8\610F\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104405556005308761)
,p_name=>'PE.PROPERTY.HEADING_ALIGNMENT.LOV.CENTER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E2D\592E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104405402481308761)
,p_name=>'PE.PROPERTY.HEADING_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104405677396308761)
,p_name=>'PE.PROPERTY.HEADING_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D42\4E86')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104201570851308611)
,p_name=>'PE.PROPERTY.HEADING_ALIGNMENT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F4D\7F6E\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104420377389308772)
,p_name=>'PE.PROPERTY.HEADING_TYPE_PLSQL_FUNCTION_BODY.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>DEPT\8868\306B\57FA\3065\3044\3066\30EC\30DD\30FC\30C8\306E\30D8\30C3\30C0\30FC\3092\63D0\4F9B</dt>'),
'<dd><pre>return ''Deptno:DName:Loc'';</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104241219310308640)
,p_name=>'PE.PROPERTY.HEADING_TYPE_PLSQL_FUNCTION_BODY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30ED\30F3\3067\533A\5207\3089\308C\305F\5217\30D8\30C3\30C0\30FC\306E\6587\5B57\5217\3092\8FD4\3059PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104241179231308640)
,p_name=>'PE.PROPERTY.HEADING_TYPE_PLSQL_FUNCTION_BODY.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104112971330308527)
,p_name=>'PE.PROPERTY.HELP_TEXT.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\3053\306E\5C5E\6027\3092\4F7F\7528\3057\3066\3001\5BFE\8A71\30B0\30EA\30C3\30C9\306E\30D8\30EB\30D7\30FB\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002\300C\30A2\30AF\30B7\30E7\30F3\300D\30E1\30CB\30E5\30FC\30FB\30D8\30EB\30D7\306E\30C7\30D5\30A9\30EB\30C8\306E\30D8\30EB\30D7\30FB\30B3\30F3\30C6\30F3\30C4\3068\3068\3082\306B\3001\5165\529B\3055\308C\305F\30D8\30EB\30D7\30FB\30C6\30AD\30B9\30C8\304C\8868\793A\3055\308C\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104113842097308528)
,p_name=>'PE.PROPERTY.HELP_TEXT.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\5217\306E\30D8\30EB\30D7\30FB\30C6\30AD\30B9\30C8\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104255911317308650)
,p_name=>'PE.PROPERTY.HELP_TEXT.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30A4\30C6\30E0\306E\30D8\30EB\30D7\30FB\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002\30D8\30EB\30D7\30FB\30C6\30AD\30B9\30C8\306F\3001\30D5\30A3\30FC\30EB\30C9\30FB\30EC\30D9\30EB\306E\72B6\6CC1\4F9D\5B58\30D8\30EB\30D7\3092\63D0\4F9B\3059\308B\305F\3081\306B\4F7F\7528\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103880593295308308)
,p_name=>'PE.PROPERTY.HELP_TEXT.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\5C5E\6027\3092\4F7F\7528\3057\3066\3001\73FE\5728\306E\30DA\30FC\30B8\306B\95A2\3059\308B\30D8\30EB\30D7\30FB\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002\30DA\30FC\30B8\30FB\30EC\30D9\30EB\306E\30D8\30EB\30D7\3067\306F\3001\6B21\306E\69CB\6587\3092\4F7F\7528\3057\305F\30B7\30E7\30FC\30C8\30AB\30C3\30C8\304C\30B5\30DD\30FC\30C8\3055\308C\307E\3059\3002</p>'),
'<pre>"SHORTCUT_NAME"</pre>',
unistr('<p>\30DA\30FC\30B8\306E\30D8\30EB\30D7\30FB\30C6\30AD\30B9\30C8\306F\3001\30C7\30D5\30A9\30EB\30C8\3067\306F\8868\793A\3055\308C\307E\305B\3093\3002\305F\3060\3057\3001\3053\306E\30C6\30AD\30B9\30C8\3092\8868\793A\3059\308B\30D8\30EB\30D7\30FB\30B7\30B9\30C6\30E0\3092\7C21\5358\306B\958B\767A\3067\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103880460651308308)
,p_name=>'PE.PROPERTY.HELP_TEXT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D8\30EB\30D7\30FB\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104134908921308545)
,p_name=>'PE.PROPERTY.HELP_TEXT_CLOB.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\5C5E\6027\3092\4F7F\7528\3057\3066\3001\73FE\5728\306E\30DA\30FC\30B8\306B\95A2\3059\308B\30D8\30EB\30D7\30FB\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002\30DA\30FC\30B8\30FB\30EC\30D9\30EB\306E\30D8\30EB\30D7\3067\306F\3001\6B21\306E\69CB\6587\3092\4F7F\7528\3057\305F\30B7\30E7\30FC\30C8\30AB\30C3\30C8\304C\30B5\30DD\30FC\30C8\3055\308C\307E\3059\3002</p>'),
'<pre>"SHORTCUT_NAME"</pre>',
unistr('<p>\30DA\30FC\30B8\306E\30D8\30EB\30D7\30FB\30C6\30AD\30B9\30C8\306F\3001\30C7\30D5\30A9\30EB\30C8\3067\306F\8868\793A\3055\308C\307E\305B\3093\3002\305F\3060\3057\3001\3053\306E\30C6\30AD\30B9\30C8\3092\8868\793A\3059\308B\30D8\30EB\30D7\30FB\30B7\30B9\30C6\30E0\3092\7C21\5358\306B\958B\767A\3067\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104134882805308545)
,p_name=>'PE.PROPERTY.HELP_TEXT_CLOB.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D8\30EB\30D7\30FB\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103917187664308372)
,p_name=>'PE.PROPERTY.HIDDEN_PARENT_REGION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104542205203308869)
,p_name=>'PE.PROPERTY.HIDDEN_REGION_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\30FB\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104154857853308570)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\51E1\4F8B\30A2\30A4\30C6\30E0\3092\30AF\30EA\30C3\30AF\3057\305F\3068\304D\306B\5B9F\884C\3055\308C\308B\8868\793A\304A\3088\3073\975E\8868\793A\306E\52D5\4F5C\3092\6307\5B9A\3057\307E\3059\3002'),
unistr('        \305F\3068\3048\3070\3001\51E1\4F8B\30A2\30A4\30C6\30E0\3092\9078\629E\89E3\9664\3059\308B\3068\3001\30C1\30E3\30FC\30C8\306E\95A2\9023\4ED8\3051\3089\308C\305F\30C7\30FC\30BF\30FB\30B7\30EA\30FC\30BA\304C\975E\8868\793A\306B\306A\308A\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104154947182308570)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.NONE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104278512618308666)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.NONE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr(' \30C1\30E3\30FC\30C8\306F\3001\975E\8868\793A\304A\3088\3073\8868\793A\306E\52D5\4F5C\3092\6709\52B9\5316\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104155153769308570)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.WITHOUTRESCALE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30A4\30BA\5909\66F4\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104278741801308666)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.WITHOUTRESCALE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr(' \30C1\30E3\30FC\30C8\8EF8\306E\30B5\30A4\30BA\306F\5909\66F4\3055\308C\307E\305B\3093\3002\3053\308C\306F\30E6\30FC\30B6\30FC\306E\30B3\30F3\30C6\30AD\30B9\30C8\3092\4FDD\6301\3059\308B\5834\5408\306B\5F79\7ACB\3061\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104155090373308570)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.WITHRESCALE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30A4\30BA\5909\66F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104278654892308666)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.WITHRESCALE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr(' \30C1\30E3\30FC\30C8\8EF8\306F\3001\8868\793A\30C7\30FC\30BF\306E\6700\5C0F\5024\3068\6700\5927\5024\304C\5897\6E1B\3059\308B\5834\5408\306B\30B5\30A4\30BA\3092\5909\66F4\3057\307E\3059\3002\3053\308C\306F\3001\5927\304D\304F\5909\52D5\3059\308B\5024\306E\30B7\30EA\30FC\30BA\306B\4FBF\5229\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104154778595308570)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\304A\3088\3073\975E\8868\793A\306E\52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104235798281308636)
,p_name=>'PE.PROPERTY.HIGHLIGHT_WORDS.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30EC\30DD\30FC\30C8\5217\3067\30CF\30A4\30E9\30A4\30C8\3059\308B\30C6\30AD\30B9\30C8\6587\5B57\5217\3092\5165\529B\3057\307E\3059\3002'),
unistr('\8907\6570\306E\8A9E\3092\30CF\30A4\30E9\30A4\30C8\3059\308B\5834\5408\306F\3001\30AB\30F3\30DE\3067\533A\5207\3089\308C\305F\30EA\30B9\30C8\3092\4F7F\7528\3057\307E\3059\3002'),
unistr('<code>&amp;ITEM.</code>\69CB\6587\3092\4F7F\7528\3057\3066\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\53C2\7167\3059\308B\3053\3068\3082\3067\304D\307E\3059\3002'),
unistr('\305F\3068\3048\3070\3001\691C\7D22\30D5\30A3\30FC\30EB\30C9\306B\5165\529B\3057\305F\6587\5B57\5217\3092\30CF\30A4\30E9\30A4\30C8\3067\304D\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104235618647308636)
,p_name=>'PE.PROPERTY.HIGHLIGHT_WORDS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A9E\306E\30CF\30A4\30E9\30A4\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104020069091308451)
,p_name=>'PE.PROPERTY.HOME_URL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\306B\5BFE\3059\308B\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30DB\30FC\30E0\30DA\30FC\30B8\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104019963295308451)
,p_name=>'PE.PROPERTY.HOME_URL.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DB\30FC\30E0URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103898459799308326)
,p_name=>'PE.PROPERTY.HORIZONTAL_ALIGNMENT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\6307\5B9A\3055\308C\305F\30C6\30F3\30D7\30EC\30FC\30C8\4F4D\7F6E\5185\306E\3053\306E\30DC\30BF\30F3\306E\6C34\5E73\65B9\5411\306E\4F4D\7F6E\5408\305B\3092\9078\629E\3057\307E\3059\3002</p>')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104396613337308755)
,p_name=>'PE.PROPERTY.HORIZONTAL_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5DE6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104396770655308755)
,p_name=>'PE.PROPERTY.HORIZONTAL_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\53F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103898315329308326)
,p_name=>'PE.PROPERTY.HORIZONTAL_ALIGNMENT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6C34\5E73\65B9\5411\306E\4F4D\7F6E\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104407523999308763)
,p_name=>'PE.PROPERTY.HTML_EXPRESSION.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>\30D0\30C3\30AF\30B0\30E9\30A6\30F3\30C9\304A\3088\3073\30C6\30AD\30B9\30C8\306E\8272\306E\5909\66F4</dt>'),
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">#EMPLOYEE_STATUS#&lt;/span></pre></dd>',
unistr('  <dt>\30D8\30C3\30C0\30FC2\306E\4F7F\7528</dt>'),
'    <dd><pre>&lt;h2>#EMPLOYEE_NAME#&lt;/h2></pre></dd>',
unistr('  <dt>SQL\554F\5408\305B\304B\3089\306E\52D5\7684\30AF\30E9\30B9\306E\4F7F\7528</dt>'),
'    <dd><pre>&lt;span class="#COLUMN_CLASS#">#EMPLOYEE_STATUS#&lt;/span></pre><br>',
unistr('    \3053\306E\4F8B\3067<code>#COLUMN_CLASS#</code>\3068<code>#EMPLOYEE_STATUS#</code>\306B\4EE3\5165\3055\308C\308B\306E\306F\3001\30EC\30DD\30FC\30C8SQL\554F\5408\305B\3067\9078\629E\3055\308C\305F\5217\3067\3059\3002</dd>'),
unistr('  <dt>\30DB\30D0\30FC\3067\306E\30A4\30E1\30FC\30B8\304A\3088\3073\30C4\30FC\30EB\30C1\30C3\30D7\306E\8868\793A</dt>'),
'    <dd><pre>&lt;img src="#IMAGE_NAME#" title="#EMPLOYEE_NAME#"&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104204249595308613)
,p_name=>'PE.PROPERTY.HTML_EXPRESSION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\5217\306B\8868\793A\3055\308C\308BHTML\5F0F\3092\5165\529B\3057\307E\3059\3002<code>#COLUMN#</code>\69CB\6587\3092\4F7F\7528\3057\3066\3001HTML\306B\5217\5024\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104204165605308612)
,p_name=>'PE.PROPERTY.HTML_EXPRESSION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('HTML\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103877316614308306)
,p_name=>'PE.PROPERTY.HTML_HEADER.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\30FB\30D8\30C3\30C0\30FC\5185\306E<code>#HEAD#</code>\7F6E\63DB\6587\5B57\5217\3092\7F6E\63DB\3059\308B\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002'),
unistr('\3053\3053\3067\5165\529B\3059\308B\5024\306F\3001HTML\306E<code>&lt;head&gt;</code>\30BF\30B0\306E\5F8C\306B\633F\5165\3055\308C\307E\3059\3002\3053\306E\30DA\30FC\30B8\5C5E\6027\3092\4F7F\7528\3057\3066\3001\30DA\30FC\30B8\56FA\6709\306E\30E1\30BF\30FB\30BF\30B0\3092\8FFD\52A0\3057\3066\304F\3060\3055\3044\3002'),
'</p>',
unistr('<p>\30CE\30FC\30C8: JavaScript\30B3\30FC\30C9\307E\305F\306F\30AB\30B9\30B1\30FC\30C9\30FB\30B9\30BF\30A4\30EB\30B7\30FC\30C8\3092\5C02\7528\306EJavaScript\304A\3088\3073CSS\5C5E\6027\306B\8FFD\52A0\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103877247167308306)
,p_name=>'PE.PROPERTY.HTML_HEADER.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('HTML\30D8\30C3\30C0\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104571175449308895)
,p_name=>'PE.PROPERTY.ICON_BLOB_COLUMN_NAME.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3\30FB\30A4\30E1\30FC\30B8\30FB\30BD\30FC\30B9\306EBLOB\3092\8FD4\3059\5217\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104571028313308895)
,p_name=>'PE.PROPERTY.ICON_BLOB_COLUMN_NAME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\753B\50CF\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104570957920308895)
,p_name=>'PE.PROPERTY.ICON_CLASS_COLUMN_NAME.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3\30FB\30A4\30E1\30FC\30B8\30FB\30BD\30FC\30B9\3068\3057\3066\4F7F\7528\3059\308B\5217\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104570819199308895)
,p_name=>'PE.PROPERTY.ICON_CLASS_COLUMN_NAME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103919620847308374)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.FACET.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30D5\30A1\30BB\30C3\30C8\306E\8B58\5225\306B\4F7F\7528\3059\308B\30A2\30A4\30B3\30F3\306E\30AF\30E9\30B9\3092\5165\529B\3057\307E\3059\3002\8907\6570\306E\30AF\30E9\30B9\306F\7A7A\767D\3067\533A\5207\3063\3066\8FFD\52A0\3067\304D\307E\3059\3002</p>'),
unistr('            <p>\30C6\30FC\30DE\3067\30D5\30A9\30F3\30C8APEX\3092\4F7F\7528\3059\308B\5834\5408\3001<a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\30E6\30CB\30D0\30FC\30B5\30EB\30FB\30C6\30FC\30DE\306E\30B5\30F3\30D7\30EB\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3</a>\3092\78BA\8A8D\3057\3066\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30B3\30F3\3068\4FEE\98FE\5B50\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103919743428308374)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.FACET_GROUP.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30D5\30A1\30BB\30C3\30C8\306E\8B58\5225\306B\4F7F\7528\3059\308B\30A2\30A4\30B3\30F3\306E\30AF\30E9\30B9\3092\5165\529B\3057\307E\3059\3002\8907\6570\306E\30AF\30E9\30B9\306F\7A7A\767D\3067\533A\5207\3063\3066\8FFD\52A0\3067\304D\307E\3059\3002</p>'),
unistr('            <p>\30C6\30FC\30DE\3067\30D5\30A9\30F3\30C8APEX\3092\4F7F\7528\3059\308B\5834\5408\3001<a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\30E6\30CB\30D0\30FC\30B5\30EB\30FB\30C6\30FC\30DE\306E\30B5\30F3\30D7\30EB\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3</a>\3092\78BA\8A8D\3057\3066\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30B3\30F3\3068\4FEE\98FE\5B50\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103919876912308374)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.FACET_GROUP_ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30D5\30A1\30BB\30C3\30C8\306E\8B58\5225\306B\4F7F\7528\3059\308B\30A2\30A4\30B3\30F3\306E\30AF\30E9\30B9\3092\5165\529B\3057\307E\3059\3002\8907\6570\306E\30AF\30E9\30B9\306F\7A7A\767D\3067\533A\5207\3063\3066\8FFD\52A0\3067\304D\307E\3059\3002</p>'),
unistr('            <p>\30C6\30FC\30DE\3067\30D5\30A9\30F3\30C8APEX\3092\4F7F\7528\3059\308B\5834\5408\3001<a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\30E6\30CB\30D0\30FC\30B5\30EB\30FB\30C6\30FC\30DE\306E\30B5\30F3\30D7\30EB\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3</a>\3092\78BA\8A8D\3057\3066\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30B3\30F3\3068\4FEE\98FE\5B50\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104698568263308999)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\8FFD\52A0\3059\308B\30A2\30A4\30B3\30F3\306E\30AF\30E9\30B9\3092\5165\529B\3057\307E\3059\3002\8907\6570\306E\30AF\30E9\30B9\306F\7A7A\767D\3067\533A\5207\3063\3066\8FFD\52A0\3067\304D\307E\3059\3002</p>'),
unistr('        <p>\30C6\30FC\30DE\3067\30D5\30A9\30F3\30C8APEX\3092\4F7F\7528\3059\308B\5834\5408\3001<a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\30E6\30CB\30D0\30FC\30B5\30EB\30FB\30C6\30FC\30DE\306E\30B5\30F3\30D7\30EB\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3</a>\3092\78BA\8A8D\3057\3066\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30B3\30F3\3068\4FEE\98FE\5B50\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002</p>'),
unistr('        <p>\30CE\30FC\30C8: \3053\306E\30A2\30A4\30B3\30F3\306F\3001\30E9\30D9\30EB\306E\4E00\90E8\3068\3057\3066\3067\306F\306A\304F\30A2\30A4\30C6\30E0\306E\5185\90E8\306B\8868\793A\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104698421083308999)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\8FFD\52A0\3059\308B\30A2\30A4\30B3\30F3\306E\30AF\30E9\30B9\3092\5165\529B\3057\307E\3059\3002\8907\6570\306E\30AF\30E9\30B9\306F\7A7A\767D\3067\533A\5207\3063\3066\8FFD\52A0\3067\304D\307E\3059\3002</p>'),
unistr('        <p>\30C6\30FC\30DE\3067\30D5\30A9\30F3\30C8APEX\3092\4F7F\7528\3059\308B\5834\5408\3001<a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\30E6\30CB\30D0\30FC\30B5\30EB\30FB\30C6\30FC\30DE\306E\30B5\30F3\30D7\30EB\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3</a>\3092\78BA\8A8D\3057\3066\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30B3\30F3\3068\4FEE\98FE\5B50\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002</p>'),
unistr('        <p>\30CE\30FC\30C8: \3053\306E\30A2\30A4\30B3\30F3\306F\3001\30E9\30D9\30EB\306E\4E00\90E8\3068\3057\3066\3067\306F\306A\304F\30A2\30A4\30C6\30E0\306E\5185\90E8\306B\8868\793A\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103920097289308374)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30D5\30A3\30EB\30BF\306E\8B58\5225\306B\4F7F\7528\3059\308B\30A2\30A4\30B3\30F3\306E\30AF\30E9\30B9\3092\5165\529B\3057\307E\3059\3002\8907\6570\306E\30AF\30E9\30B9\306F\7A7A\767D\3067\533A\5207\3063\3066\8FFD\52A0\3067\304D\307E\3059\3002</p>'),
unistr('            <p>\30C6\30FC\30DE\3067\30D5\30A9\30F3\30C8APEX\3092\4F7F\7528\3059\308B\5834\5408\3001<a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\30E6\30CB\30D0\30FC\30B5\30EB\30FB\30C6\30FC\30DE\306E\30B5\30F3\30D7\30EB\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3</a>\3092\78BA\8A8D\3057\3066\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30B3\30F3\3068\4FEE\98FE\5B50\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103920960302308375)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.SFILTER_GROUP.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30D5\30A3\30EB\30BF\306E\8B58\5225\306B\4F7F\7528\3059\308B\30A2\30A4\30B3\30F3\306E\30AF\30E9\30B9\3092\5165\529B\3057\307E\3059\3002\8907\6570\306E\30AF\30E9\30B9\306F\7A7A\767D\3067\533A\5207\3063\3066\8FFD\52A0\3067\304D\307E\3059\3002</p>'),
unistr('            <p>\30C6\30FC\30DE\3067\30D5\30A9\30F3\30C8APEX\3092\4F7F\7528\3059\308B\5834\5408\3001<a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\30E6\30CB\30D0\30FC\30B5\30EB\30FB\30C6\30FC\30DE\306E\30B5\30F3\30D7\30EB\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3</a>\3092\78BA\8A8D\3057\3066\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30B3\30F3\3068\4FEE\98FE\5B50\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103921340486308375)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.SFILTER_GROUP_ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30D5\30A3\30EB\30BF\306E\8B58\5225\306B\4F7F\7528\3059\308B\30A2\30A4\30B3\30F3\306E\30AF\30E9\30B9\3092\5165\529B\3057\307E\3059\3002\8907\6570\306E\30AF\30E9\30B9\306F\7A7A\767D\3067\533A\5207\3063\3066\8FFD\52A0\3067\304D\307E\3059\3002</p>'),
unistr('            <p>\30C6\30FC\30DE\3067\30D5\30A9\30F3\30C8APEX\3092\4F7F\7528\3059\308B\5834\5408\3001<a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\30E6\30CB\30D0\30FC\30B5\30EB\30FB\30C6\30FC\30DE\306E\30B5\30F3\30D7\30EB\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3</a>\3092\78BA\8A8D\3057\3066\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30B3\30F3\3068\4FEE\98FE\5B50\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104557612272308885)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\53F3\5411\304D\306E\77E2\5370\306E\8868\793A</dt>'),
'<dd><pre>fa-chevron-right</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104557517675308885)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\8FFD\52A0\3059\308B\30A2\30A4\30B3\30F3\306E\30AF\30E9\30B9\3092\5165\529B\3057\307E\3059\3002\8907\6570\306E\30AF\30E9\30B9\306F\7A7A\767D\3067\533A\5207\3063\3066\8FFD\52A0\3067\304D\307E\3059\3002</p>'),
unistr('        <p>\30C6\30FC\30DE\3067\30D5\30A9\30F3\30C8APEX\3092\4F7F\7528\3059\308B\5834\5408\3001<a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\30E6\30CB\30D0\30FC\30B5\30EB\30FB\30C6\30FC\30DE\306E\30B5\30F3\30D7\30EB\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3</a>\3092\78BA\8A8D\3057\3066\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30B3\30F3\3068\4FEE\98FE\5B50\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104557424628308885)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104572691015308897)
,p_name=>'PE.PROPERTY.ICON_DESCRIPTION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30C6\30AD\30B9\30C8\306F\3001\30A2\30A4\30B3\30F3\306B\3064\3044\3066\8AAC\660E\3057\3001\30A4\30E1\30FC\30B8\306E\30C4\30FC\30EB\30C1\30C3\30D7\304A\3088\3073\4EE3\66FF\30C6\30AD\30B9\30C8\3068\3057\3066\4F7F\7528\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104572563537308897)
,p_name=>'PE.PROPERTY.ICON_DESCRIPTION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3\306E\8AAC\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104571383322308895)
,p_name=>'PE.PROPERTY.ICON_IMAGE_URL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3\30FB\30A4\30E1\30FC\30B8\30FB\30BD\30FC\30B9\306EURL\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104571283606308895)
,p_name=>'PE.PROPERTY.ICON_IMAGE_URL.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30E1\30FC\30B8URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104571836341308896)
,p_name=>'PE.PROPERTY.ICON_POSITION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30FC\30C9\30FB\30D8\30C3\30C0\30FC\5185\3067\306E\30A2\30A4\30B3\30F3\306E\4F4D\7F6E\3092\6C7A\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104572319458308897)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.END.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D42\4E86')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104572441492308897)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.END.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D8\30C3\30C0\30FC\306E\7D42\4E86\4F4D\7F6E(\901A\5E38\306F\53F3\5074)\306B\30A2\30A4\30B3\30F3\3092\63C3\3048\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104572175251308896)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.START.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104572225805308896)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.START.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D8\30C3\30C0\30FC\306E\958B\59CB\4F4D\7F6E(\901A\5E38\306F\5DE6\5074)\306B\30A2\30A4\30B3\30F3\3092\63C3\3048\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104571986084308896)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.TOP.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C8\30C3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104572060934308896)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.TOP.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D8\30C3\30C0\30FC\306E\4E0A\90E8\306B\30A2\30A4\30B3\30F3\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104571730530308896)
,p_name=>'PE.PROPERTY.ICON_POSITION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104581137789308904)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.COMPONENT_PROPERTY.CARD.NULL_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104570249565308894)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30FC\30C9\30FB\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306E\30D8\30C3\30C0\30FC\306B\8868\793A\3059\308B\30A2\30A4\30B3\30F3\306E\30A2\30A4\30B3\30F3\30FB\30BD\30FC\30B9\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104570775815308895)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.LOV.BLOB.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30E1\30FC\30B8BLOB\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104570558808308895)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.LOV.DYNAMIC_CLASS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3\30FB\30AF\30E9\30B9\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104570312982308895)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.LOV.INITIALS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30CB\30B7\30E3\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104570440781308895)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.LOV.STATIC_CLASS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3\30FB\30AF\30E9\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104570657604308895)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.LOV.URL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30E1\30FC\30B8URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104570176022308894)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3\30FB\30BD\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104101842054308518)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;a href="&APEX$ROW_URL!ATTR."&gt;&lt;img src="&EMP_IMG!ATTR." title="&ENAME!ATTR." alt="&ENAME!ATTR."&gt;&lt;br&gt;&ENAME.&lt;/a&gt;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104101752177308518)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('</p>\30A2\30A4\30B3\30F3\30FB\30D3\30E5\30FC\306E\30AB\30B9\30BF\30E0\5217HTML\3092\5165\529B\3057\307E\3059\3002</p>'),
unistr('<p>\6B21\306E\7F6E\63DB\6587\5B57\5217\3092\4F7F\7528\3067\304D\307E\3059:'),
'<ul>',
unistr('<li><code>&&lt;COLUMN_NAME&gt;.</code> - \5217\540D\306E\7F6E\63DB\6587\5B57\5217\3002</li>'),
unistr('<li><code>&&lt;COLUMN_NAME&gt;_LABEL.</code> - \5217\306E\30E9\30D9\30EB\306E\7F6E\63DB\6587\5B57\5217\3002</li>'),
unistr('<li><code>&APEX$ROW_ID.</code> - \884C\306E\30EC\30B3\30FC\30C9\8B58\5225\5B50\3002</li>'),
unistr('<li><code>&APEX$ROW_INDEX.</code> - \30EC\30B3\30FC\30C9\8868\793A\9806\5E8F\756A\53F7\3002</li>'),
unistr('<li><code>&APEX$ROW_URL.</code> - \6307\5B9A\3057\305F\30EA\30F3\30AF\30FB\30BF\30FC\30B2\30C3\30C8\306E\53C2\7167\3002</li>'),
unistr('<li><code>&APEX$ROW_STATE_CLASSES.</code> - <code>is-inserted</code>\307E\305F\306F<code>is-deleted</code>\306A\3069\30EC\30B3\30FC\30C9\306E\72B6\614B\3002</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104101654752308518)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30B9\30BF\30E0\30FB\30A2\30A4\30B3\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104410984191308765)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM_LINK.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;a href="#EMP_LINK#"&gt;&lt;img src="#EMP_IMG#" title="#ENAME#" alt="#ENAME#"&gt;&lt;br&gt;#ENAME#&lt;/a&gt;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104212717315308619)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM_LINK.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3\30FB\30D3\30E5\30FC\306E\5217\30EA\30F3\30AF\3092\5165\529B\3057\307E\3059\3002\5FC5\8981\306B\5FDC\3058\3066\5217\540D\306B<code>#COLUMN_NAME#</code>\7F6E\63DB\6587\5B57\5217\3092\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104212628386308619)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM_LINK.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30B9\30BF\30E0\30FB\30EA\30F3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104112705832308527)
,p_name=>'PE.PROPERTY.ICON_VIEW_ENABLED.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3\30FB\30D3\30E5\30FC\3092\6709\52B9\306B\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002<strong>\300C\30AA\30F3\300D</strong>\3092\9078\629E\3059\308B\3068\3001\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\306E\691C\7D22\30D0\30FC\307E\305F\306F\5BFE\8A71\30B0\30EA\30C3\30C9\306E\300C\8868\793A\300D\30DC\30BF\30F3\306B\300C\30A2\30A4\30B3\30F3\306E\8868\793A\300D\30A2\30A4\30B3\30F3\304C\8FFD\52A0\3055\308C\3001\30E6\30FC\30B6\30FC\304C\3053\306E\30D3\30E5\30FC\306B\30A2\30AF\30BB\30B9\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104211195586308618)
,p_name=>'PE.PROPERTY.ICON_VIEW_ENABLED.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3\30FB\30D3\30E5\30FC\3092\6709\52B9\306B\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002<strong>\300C\30AA\30F3\300D</strong>\3092\9078\629E\3059\308B\3068\3001\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\306E\691C\7D22\30D0\30FC\307E\305F\306F\5BFE\8A71\30B0\30EA\30C3\30C9\306E\300C\8868\793A\300D\30DC\30BF\30F3\306B\300C\30A2\30A4\30B3\30F3\306E\8868\793A\300D\30A2\30A4\30B3\30F3\304C\8FFD\52A0\3055\308C\3001\30E6\30FC\30B6\30FC\304C\3053\306E\30D3\30E5\30FC\306B\30A2\30AF\30BB\30B9\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104211067397308618)
,p_name=>'PE.PROPERTY.ICON_VIEW_ENABLED.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104212303183308619)
,p_name=>'PE.PROPERTY.ICON_VIEW_HTML_ALT_TEXT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30E1\30FC\30B8\306EHTML ALT\30C6\30AD\30B9\30C8\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104212220973308618)
,p_name=>'PE.PROPERTY.ICON_VIEW_HTML_ALT_TEXT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('HTML ALT\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104212591738308619)
,p_name=>'PE.PROPERTY.ICON_VIEW_HTML_TITLE_TEXT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30E1\30FC\30B8\306EHTML TITLE\30BF\30B0\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104212464655308619)
,p_name=>'PE.PROPERTY.ICON_VIEW_HTML_TITLE_TEXT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('HTML TITLE\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104103010136308519)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_ATTRIBUTES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('HTML IMG\30BF\30B0\306B\4F7F\7528\3059\308B\30A2\30A4\30B3\30F3\30FB\30A4\30E1\30FC\30B8\5C5E\6027\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104102942894308519)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_ATTRIBUTES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104102419979308518)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_BLOB_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3\30FB\30A4\30E1\30FC\30B8\30FB\30BD\30FC\30B9\306EBLOB\3092\623B\3059\5BFE\8A71\30B0\30EA\30C3\30C9\5217\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104102369840308518)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_BLOB_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\753B\50CF\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104102858026308519)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_CSS_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3\30FB\30A4\30E1\30FC\30B8\30FB\30BD\30FC\30B9\306ECSS\30AF\30E9\30B9\3092\623B\3059\5BFE\8A71\30B0\30EA\30C3\30C9\5217\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104102722021308519)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_CSS_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104102087594308518)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3\30FB\30A4\30E1\30FC\30B8\30FB\30BD\30FC\30B9\3092\4FDD\6301\3059\308B\5217\30BF\30A4\30D7\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104102243979308518)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_TYPE.LOV.CSS_CLASSES.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3CSS\30AF\30E9\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104102125713308518)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_TYPE.LOV.URL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('URL\306E\30A4\30E1\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104101900397308518)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3\30FB\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104102657840308519)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_URL_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3\30FB\30A4\30E1\30FC\30B8\30FB\30BD\30FC\30B9\306EURL\3092\623B\3059\5BFE\8A71\30B0\30EA\30C3\30C9\5217\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104102558298308518)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_URL_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104212183298308618)
,p_name=>'PE.PROPERTY.ICON_VIEW_IMAGE_ATTRIBUTES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('HTML IMG\30BF\30B0\306B\4F7F\7528\3059\308B\30A4\30E1\30FC\30B8\5C5E\6027\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104212035830308618)
,p_name=>'PE.PROPERTY.ICON_VIEW_IMAGE_ATTRIBUTES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30E1\30FC\30B8\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104410706490308765)
,p_name=>'PE.PROPERTY.ICON_VIEW_IMAGE_SOURCE_COLUMN.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt><code>IMAGE</code>\5217\306E\78BA\8A8D</dt>'),
'<dd><pre>',
'select ename,',
'       job,',
'       ''F?P=&APP_ID.:2:'' || :APP_SESSION || ''::::P2_ID:'' || empno as link,',
'       ''#IMAGE_PREFIX#menu/user_red_64.gif'' as image',
'  from emp',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104211760995308618)
,p_name=>'PE.PROPERTY.ICON_VIEW_IMAGE_SOURCE_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30E1\30FC\30B8\30FB\30BD\30FC\30B9\3092\8FD4\3059\30EC\30DD\30FC\30C8\5217\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104211643376308618)
,p_name=>'PE.PROPERTY.ICON_VIEW_IMAGE_SOURCE_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30E1\30FC\30B8\30FB\30BD\30FC\30B9\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104410894639308765)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_COLUMN.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt><code>ENAME</code>\5217\306E\78BA\8A8D</dt>'),
'<dd><pre>',
'select ename,',
'       job,',
'       ''F?P=&APP_ID.:2:'' || :APP_SESSION || ''::::P2_ID:'' || empno as link,',
'       ''#IMAGE_PREFIX#menu/user_red_64.gif'' as image',
'  from emp',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104211959059308618)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30E1\30FC\30B8\30FB\30E9\30D9\30EB\3092\8FD4\3059\30EC\30DD\30FC\30C8\5217\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104211877501308618)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104085101063308504)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_REGION_COLUMN.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt><code>ENAME</code>\5217\306E\78BA\8A8D</dt>'),
'<dd><pre>',
'select empno,',
'       ename,',
'       job,',
'       ''#IMAGE_PREFIX#menu/user_red_64.gif'' as image',
'  from emp',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104085005365308504)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_REGION_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30E1\30FC\30B8\30FB\30E9\30D9\30EB\3092\8FD4\3059\30EC\30DD\30FC\30C8\5217\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104084940603308504)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_REGION_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104103470777308519)
,p_name=>'PE.PROPERTY.ICON_VIEW_LINK_ATTRIBUTES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5404<strong>\300C\30EA\30F3\30AF\30FB\30BF\30FC\30B2\30C3\30C8\300D</strong>\306E\8868\793A\3068\95A2\9023\4ED8\3051\3089\308C\308BHTML\5C5E\6027\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104103330966308519)
,p_name=>'PE.PROPERTY.ICON_VIEW_LINK_ATTRIBUTES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30F3\30AF\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104410687597308765)
,p_name=>'PE.PROPERTY.ICON_VIEW_LINK_COLUMN.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt><code>LINK</code>\5217\306E\78BA\8A8D</dt>'),
'<dd><pre>',
'select ename,',
'       job,',
'       ''F?P=&APP_ID.:2:'' || :APP_SESSION || ''::::P2_ID:'' || empno as link,',
'       ''#IMAGE_PREFIX#menu/user_red_64.gif'' as image',
'  from emp',
'</pre></dd>',
'</dl>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104211564304308618)
,p_name=>'PE.PROPERTY.ICON_VIEW_LINK_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3\306E\30EA\30F3\30AF\30FB\30BF\30FC\30B2\30C3\30C8\3092\8FD4\3059\30EC\30DD\30FC\30C8\5217\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104211442154308618)
,p_name=>'PE.PROPERTY.ICON_VIEW_LINK_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30F3\30AF\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104638614281308950)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\306E\5B9F\884C\306B\4F7F\7528\3055\308C\308B\8A00\8A9E\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104638981708308950)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'ja'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104638843462308950)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'ja'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104638743494308950)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'ja'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104639031193308950)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'ja'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104638566429308949)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A00\8A9E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104639873875308951)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_JAVA_FUNC_BODY_SQL.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306ELOV\3092\79FB\5165\3059\308BSQL\554F\5408\305B\3092\8FD4\3059Java\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002</p>'),
unistr('<p>SQL\554F\5408\305B\3067\306F\30011\3064\306E\5217\306E\307F\8FD4\3059\5FC5\8981\304C\3042\308A\307E\3059\3002\554F\5408\305B\304C\8907\6570\306E\5217\3092\8FD4\3059\5834\5408\3001\6700\521D\306E\5217\306E\307F\304C\30D5\30A3\30EB\30BF\691C\7D22\306B\4F7F\7528\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104639714421308950)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_JAVA_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B\3092\8FD4\3059Java\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104639613869308950)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_JS_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\90E8\9580\540D\306E\8868\793A\3068\90E8\9580\756A\53F7\306E\8A2D\5B9A</dt>'),
'<dd><pre>',
'return "select dname as d from dept order by 1";',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104639525081308950)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_JS_FUNC_BODY_SQL.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306ELOV\3092\79FB\5165\3059\308BSQL\554F\5408\305B\3092\8FD4\3059JavaScript\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002</p>'),
unistr('<p>SQL\554F\5408\305B\3067\306F\30011\3064\306E\5217\306E\307F\8FD4\3059\5FC5\8981\304C\3042\308A\307E\3059\3002\554F\5408\305B\304C\8907\6570\306E\5217\3092\8FD4\3059\5834\5408\3001\6700\521D\306E\5217\306E\307F\304C\30D5\30A3\30EB\30BF\691C\7D22\306B\4F7F\7528\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104639416477308950)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_JS_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B\3092\8FD4\3059JavaScript\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104639391794308950)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_PLSQL_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\90E8\9580\540D\3092\623B\3059\306B\306F:</dt>'),
'<dd><pre>',
'begin',
'    return ''select dname as d from dept order by 1'';',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104639232681308950)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_PLSQL_FUNC_BODY_SQL.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306ELOV\3092\79FB\5165\3059\308BSQL\554F\5408\305B\3092\623B\3059PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002</p>'),
unistr('<p>SQL\554F\5408\305B\3067\306F\30011\3064\306E\5217\306E\307F\623B\3059\5FC5\8981\304C\3042\308A\307E\3059\3002\554F\5408\305B\304C\8907\6570\306E\5217\3092\623B\3059\5834\5408\3001\6700\521D\306E\5217\306E\307F\304C\30D5\30A3\30EB\30BF\691C\7D22\306B\4F7F\7528\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104639131222308950)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_PLSQL_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B\3092\623B\3059PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104640038495308951)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_PYTHON_FUNC_BODY_SQL.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306ELOV\3092\79FB\5165\3059\308BSQL\554F\5408\305B\3092\8FD4\3059Python\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002</p>'),
unistr('<p>SQL\554F\5408\305B\3067\306F\30011\3064\306E\5217\306E\307F\8FD4\3059\5FC5\8981\304C\3042\308A\307E\3059\3002\554F\5408\305B\304C\8907\6570\306E\5217\3092\8FD4\3059\5834\5408\3001\6700\521D\306E\5217\306E\307F\304C\30D5\30A3\30EB\30BF\691C\7D22\306B\4F7F\7528\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104639973144308951)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_PYTHON_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B\3092\8FD4\3059Python\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104108384903308523)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_STATIC_VALUES.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>'<pre>Cow,Dog,Cat,Lion</pre>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104108216187308523)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_STATIC_VALUES.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\9759\7684\30EA\30B9\30C8\306E\30AB\30F3\30DE\3067\533A\5207\3089\308C\305F\5024\306E\30EA\30B9\30C8\3092\5165\529B\3057\307E\3059\3002</p>'),
unistr('        <p>\30CE\30FC\30C8 - \9759\7684\5024\306F\3001\30A2\30EB\30D5\30A1\30D9\30C3\30C8\9806\3067\306F\306A\304F\5E38\306B\6307\5B9A\3055\308C\305F\540C\3058\9806\5E8F\3067\8868\793A\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104108167780308523)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_STATIC_VALUES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\9759\7684\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104104082982308520)
,p_name=>'PE.PROPERTY.IG_COLUMN_GROUP.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\3053\306E\5217\306E\30B0\30EB\30FC\30D7\3092\9078\629E\3057\307E\3059\3002\30B0\30EB\30FC\30D7\3092\4F7F\7528\3057\3066\3001\30B0\30EA\30C3\30C9\304A\3088\3073\5358\4E00\884C\30D3\30E5\30FC\3067\5217\3092\307E\3068\3081\3066\95A2\9023\4ED8\3051\307E\3059\3002</p>'),
unistr('        <p>\30CE\30FC\30C8 - \300C\30EC\30F3\30C0\30EA\30F3\30B0\300D\30C4\30EA\30FC\5185\306E\300C\5C5E\6027\300D\30D5\30A9\30EB\30C0\3092\5C55\958B\3057\3001\300C\5217\30B0\30EB\30FC\30D7\300D\3092\53F3\30AF\30EA\30C3\30AF\3057\3066\65B0\3057\3044\30B0\30EB\30FC\30D7\3092\4F5C\6210\3059\308B\3068\3001\30B0\30EB\30FC\30D7\304C\8FFD\52A0\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104103940313308520)
,p_name=>'PE.PROPERTY.IG_COLUMN_GROUP.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30EB\30FC\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104108529248308523)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\5217\306E\5024\304C\30D9\30FC\30B9\3068\3059\308B\30BD\30FC\30B9\30FB\30BF\30A4\30D7\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104108626495308524)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.LOV.DB_COLUMN.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104108710128308524)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.LOV.DB_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\30FB\30BD\30FC\30B9SQL\554F\5408\305B\304B\3089\53D6\5F97\3055\308C\308B<em>\300C\30C7\30FC\30BF\30D9\30FC\30B9\5217\300D</em>\306B\5165\529B\3055\308C\305F\5217\5024\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104109098626308524)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.LOV.NONE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104109137720308524)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.LOV.NONE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\5024\306F\30BD\30FC\30B9\304B\3089\53D6\5F97\3055\308C\307E\305B\3093\3002\305F\3068\3048\3070\3001APEX$ROW_SELECTOR\304A\3088\3073APEX$ROW_ACTION\5217\306B\30BD\30FC\30B9\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104108827016308524)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.LOV.SQL_EXPRESSION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104108950788308524)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.LOV.SQL_EXPRESSION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F<em>SQL\5F0F</em>\304B\3089\8FD4\3055\308C\305F\5024\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104108474186308523)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104101153136308517)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\73FE\5728\8868\793A\3055\308C\3066\3044\308B\5217\306E\30C0\30A6\30F3\30ED\30FC\30C9\306B\30E6\30FC\30B6\30FC\304C\4F7F\7528\3067\304D\308B\30C0\30A6\30F3\30ED\30FC\30C9\5F62\5F0F\3092\78BA\8A8D\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104101220094308517)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.LOV.CSV.D'
,p_message_language=>'ja'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104101388143308518)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.LOV.HTML.D'
,p_message_language=>'ja'
,p_message_text=>'HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104259307272308653)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.LOV.PDF.D'
,p_message_language=>'ja'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103544618568308048)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.LOV.XLSX.D'
,p_message_language=>'ja'
,p_message_text=>'Excel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104101066506308517)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5F62\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104103286104308519)
,p_name=>'PE.PROPERTY.IG_ICON_VIEW_LINK_TARGET.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E2\30FC\30C0\30EB\30FB\30C0\30A4\30A2\30ED\30B0\3092\8D77\52D5\3059\308B\30EA\30F3\30AF\30FB\30BF\30FC\30B2\30C3\30C8\3092\30AF\30EA\30C3\30AF\3057\307E\3059\3002\30A2\30A4\30B3\30F3\304C\30AF\30EA\30C3\30AF\3055\308C\305F\3068\304D\306B\30B3\30FC\30EB\3055\308C\308B\30AB\30B9\30BF\30E0\30FB\30BF\30FC\30B2\30C3\30C8\3092\5165\529B\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104103153946308519)
,p_name=>'PE.PROPERTY.IG_ICON_VIEW_LINK_TARGET.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30F3\30AF\30FB\30BF\30FC\30B2\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104099312276308516)
,p_name=>'PE.PROPERTY.IG_PAGINATION_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30EC\30DD\30FC\30C8\306E\30DA\30FC\30B8\533A\5207\308A\30BF\30A4\30D7\3092\9078\629E\3057\307E\3059\3002\591A\304F\306E\5834\5408\3001\3059\3079\3066\306E\30EC\30DD\30FC\30C8\884C\306F\30EC\30DD\30FC\30C8\306B\8868\793A\3055\308C\307E\305B\3093\3002'),
unistr('		\8FFD\52A0\306E\884C\3092\8868\793A\3059\308B\306B\306F\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\6307\5B9A\3055\308C\305F\30DA\30FC\30B8\533A\5207\308A\3092\4F7F\7528\3067\304D\307E\3059\3002</p>'),
unistr('		<p>\30DA\30FC\30B8\533A\5207\308A\306F\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\8868\793A\3055\308C\308B\884C\6570\304A\3088\3073\7D50\679C\30BB\30C3\30C8\3067\306E\73FE\5728\306E\4F4D\7F6E\306B\95A2\3059\308B\60C5\5831\3092\63D0\4F9B\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104099508376308516)
,p_name=>'PE.PROPERTY.IG_PAGINATION_TYPE.LOV.SCROLL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AF\30ED\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104227917580308630)
,p_name=>'PE.PROPERTY.IG_PAGINATION_TYPE.LOV.SCROLL.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\521D\671F\72B6\614B\3067\5BFE\8A71\30B0\30EA\30C3\30C9\306E\9AD8\3055\3092\57CB\3081\308B\306E\306B\5341\5206\306A\884C\304C\8868\793A\3055\308C\307E\3059\3002'),
unistr('        \30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\30B9\30AF\30ED\30FC\30EB\3059\308B\3068\3001\5FC5\8981\306B\5FDC\3058\3066\30B5\30FC\30D0\30FC\304B\3089\5225\306E\30C7\30FC\30BF\304C\53D6\5F97\3055\308C\3001\8FFD\52A0\306E\884C\304C\8868\793A\3055\308C\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104099423843308516)
,p_name=>'PE.PROPERTY.IG_PAGINATION_TYPE.LOV.SET.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104227824654308630)
,p_name=>'PE.PROPERTY.IG_PAGINATION_TYPE.LOV.SET.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<em>\300C\30DA\30FC\30B8\3054\3068\306E\884C\6570\300D</em>\3067\6307\5B9A\3055\308C\305F\6570\5024\306B\57FA\3065\3044\3066\3001\6700\521D\306E\884C\304C\8868\793A\3055\308C\307E\3059\3002'),
unistr('        \8FFD\52A0\306E\884C\304C\3042\308B\5834\5408\3001\30B3\30F3\30C8\30ED\30FC\30EB\304C\30EC\30DD\30FC\30C8\30FB\30D5\30C3\30BF\30FC\306B\8FFD\52A0\3055\308C\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\884C\30BB\30C3\30C8\9593\3092\524D\5F8C\306B\30CA\30D3\30B2\30FC\30C8\3067\304D\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104099291362308516)
,p_name=>'PE.PROPERTY.IG_PAGINATION_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104769478082309065)
,p_name=>'PE.PROPERTY.IG_REGION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5BFE\8A71\30B0\30EA\30C3\30C9\30FB\30EA\30FC\30B8\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104562818919308889)
,p_name=>'PE.PROPERTY.IG_SAVED_REPORT_ALIAS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\4FDD\5B58\6E08\30EC\30DD\30FC\30C8\306E\5225\540D\3092\5165\529B\3057\307E\3059\3002\3053\306E\5225\540D\3092\4F7F\7528\3057\3066\3001\3053\306E\7279\5B9A\306E\4FDD\5B58\6E08\30EC\30DD\30FC\30C8\3078\306E\308F\304B\308A\3084\3059\3044URL\30EA\30F3\30AF\3092\5B9A\7FA9\3057\307E\3059\3002\3053\306E\30EA\30F3\30AF\3092\4F7F\7528\3057\3066\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5185\306E\5225\306E\5834\6240\304B\3089\76F4\63A5\30EA\30F3\30AF\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104561842724308888)
,p_name=>'PE.PROPERTY.IG_SAVED_REPORT_ALIAS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5225\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104562966157308889)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\4FDD\5B58\6E08\30EC\30DD\30FC\30C8\30FB\30AB\30C6\30B4\30EA\3092\8868\793A\3057\307E\3059\3002\30AB\30C6\30B4\30EA\306B\3088\3063\3066\3053\306E\30EC\30DD\30FC\30C8\304C\8868\793A\3055\308C\308B\30EC\30DD\30FC\30C8\9078\629E\30EA\30B9\30C8\5185\306E\4F4D\7F6E\304C\6C7A\307E\308A\307E\3059\3002\3053\306E\5C5E\6027\306F\8868\793A\5C02\7528\3067\66F4\65B0\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104562048747308888)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.ALTERNATIVE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\4EE3\66FF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104562578865308889)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.ALTERNATIVE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\767A\8005\306B\3088\3063\3066\4FDD\5B58\3055\308C\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\9078\629E\53EF\80FD\306A\5F8C\7D9A\306E\30EC\30DD\30FC\30C8\30FB\30EC\30A4\30A2\30A6\30C8\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104561905201308888)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PRIMARY.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E3B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104562422439308888)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PRIMARY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\767A\8005\306B\3088\3063\3066\4FDD\5B58\3055\308C\3001\30C7\30D5\30A9\30EB\30C8\3067\8868\793A\3055\308C\308B\30EC\30DD\30FC\30C8\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104562297759308888)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PRIVATE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30E9\30A4\30D9\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104562706139308889)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PRIVATE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\3088\3063\3066\4FDD\5B58\3055\308C\3001\4FDD\5B58\3057\305F\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306E\307F\304C\9078\629E\53EF\80FD\306A\30EC\30DD\30FC\30C8\30FB\30EC\30A4\30A2\30A6\30C8\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104562118072308888)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PUBLIC.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30D6\30EA\30C3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104562657585308889)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PUBLIC.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\3088\3063\3066\4FDD\5B58\3055\308C\3001\4ED6\306E\3059\3079\3066\306E\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\9078\629E\53EF\80FD\306A\30EC\30DD\30FC\30C8\30FB\30EC\30A4\30A2\30A6\30C8\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104561765322308888)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\53EF\8996\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104104235940308520)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30EB\30FC\30D7\3092\4F7F\7528\3057\3066\3053\306E\5217\3092\8868\793A\3059\308B\5834\6240\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104104346675308520)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.BOTH.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E21\65B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104104491272308520)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.BOTH.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\30FB\30D8\30C3\30C0\30FC\304A\3088\3073\5358\4E00\884C\30D3\30E5\30FC\306E\4E21\65B9\3067\30B0\30EB\30FC\30D7\304C\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104104784831308520)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.HEADING.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D8\30C3\30C0\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104104892396308520)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.HEADING.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\30FB\30D8\30C3\30C0\30FC\3067\306E\307F\3001\30B0\30EB\30FC\30D7\304C\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104104554938308520)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.SRV.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5358\4E00\884C\30D3\30E5\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104104684091308520)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.SRV.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5358\4E00\884C\30D3\30E5\30FC\3067\306E\307F\3001\30B0\30EB\30FC\30D7\304C\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104104114072308520)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30EB\30FC\30D7\306E\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103967885215308411)
,p_name=>'PE.PROPERTY.IMAGE_TAG_ATTRIBUTES.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30A4\30E1\30FC\30B8HTML\306B\542B\307E\308C\308B\30A4\30E1\30FC\30B8\30FB\30BF\30B0\306E\5C5E\6027\3092\5165\529B\3057\307E\3059\3002\9AD8\3055\3001\5E45\3001\30A4\30E1\30FC\30B8\306EALT\30C6\30AD\30B9\30C8(\88C5\98FE\7684\306A\30A4\30E1\30FC\30B8\3067\306F\306A\3044\5834\5408)\306A\3069\306E\5C5E\6027\306B\4F7F\7528\3067\304D\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8: \30A4\30E1\30FC\30B8\30FB\30BF\30B0\5C5E\6027\306BALT\304C\5B9A\7FA9\3055\308C\3066\3044\306A\3044\5834\5408\3001&PRODUCT_NAME.\306F\30C7\30D5\30A9\30EB\30C8\3067\88C5\98FE\7684\306A\30A4\30E1\30FC\30B8\3068\3057\3066\30A4\30E1\30FC\30B8\3092\30EC\30F3\30C0\30EA\30F3\30B0\3057\307E\3059(\7A7A\306EALT\30BF\30B0\306A\3069)\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103967763328308411)
,p_name=>'PE.PROPERTY.IMAGE_TAG_ATTRIBUTES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30E1\30FC\30B8\30FB\30BF\30B0\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104236590717308636)
,p_name=>'PE.PROPERTY.INCLUDE_IN_EXPORT_PRINT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\3092CSV\306B\30A8\30AF\30B9\30DD\30FC\30C8\3059\308B\969B\307E\305F\306F\51FA\529B\3059\308B\969B\3001\3053\306E\5217\3092\542B\3081\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104236444908308636)
,p_name=>'PE.PROPERTY.INCLUDE_IN_EXPORT_PRINT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30AF\30B9\30DD\30FC\30C8/\51FA\529B\306B\542B\3081\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104748491320309041)
,p_name=>'PE.PROPERTY.INCLUDE_NULL_OPTION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('LOV\3067NULL\30AA\30D7\30B7\30E7\30F3\3092\30EA\30B9\30C8\306E\6700\4E0A\90E8\306B\542B\3081\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104748398967309041)
,p_name=>'PE.PROPERTY.INCLUDE_NULL_OPTION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('NULL\30AA\30D7\30B7\30E7\30F3\3092\542B\3081\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104088958820308507)
,p_name=>'PE.PROPERTY.INCLUDE_ROWID_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\64EC\4F3C\5217ROWID\3092\9078\629E\3059\308B\5FC5\8981\304C\3042\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104088812122308507)
,p_name=>'PE.PROPERTY.INCLUDE_ROWID_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('ROWID\5217\3092\542B\3081\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104206311591308614)
,p_name=>'PE.PROPERTY.INCLUDE_SEARCH_BAR.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\691C\7D22\30D0\30FC\306F\3001\30EC\30DD\30FC\30C8\306E\4E0A\306B\8868\793A\3055\308C\307E\3059\3002\691C\7D22\30D0\30FC\3092\542B\3081\308B\5834\5408\3001\8868\793A\3059\308B\6A5F\80FD\3092\5B8C\5168\306B\30AB\30B9\30BF\30DE\30A4\30BA\3059\308B\3053\3068\3082\3067\304D\307E\3059\3002</p>'),
unistr('\691C\7D22\30D0\30FC\306B\306F\3001\6B21\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\3092\542B\3081\308B\3053\3068\304C\3067\304D\307E\3059\3002'),
'<dl>',
unistr('  <dt>\691C\7D22\30D5\30A3\30FC\30EB</dt>'),
unistr('    <dd>\691C\7D22\30D0\30FC\306B\3001\691C\7D22\57FA\6E96\306E\5165\529B\306B\4F7F\7528\3059\308B\30C6\30AD\30B9\30C8\30FB\30D5\30A3\30FC\30EB\30C9\3092\8868\793A\3057\307E\3059\3002</dd>'),
unistr('  <dt>\30D5\30A1\30A4\30F3\30C0\30FB\30C9\30ED\30C3\30D7\30FB\30C0\30A6\30F3</dt>'),
unistr('    <dd><em>\691C\7D22\30D5\30A3\30FC\30EB\30C9</em>\5185\306B\57CB\3081\8FBC\307E\308C\3001\8868\793A\3055\308C\308B\5217\306E\30C9\30ED\30C3\30D7\30C0\30A6\30F3\30FB\30EA\30B9\30C8\3092\8868\793A\3057\307E\3059\3002\5217\304C\9078\629E\3055\308C\3066\3044\308B\5834\5408\3001\9078\629E\3055\308C\305F\5217\5185\306E\5024\306B\5BFE\3057\3066\306E\307F\691C\7D22\304C\5B9F\884C\3055\308C\307E\3059\3002</dd>'),
unistr('  <dt>\30EC\30DD\30FC\30C8\9078\629E\30EA\30B9\30C8</dt>'),
unistr('    <dd>\30D7\30E9\30A4\30DE\30EA\3001\4EE3\66FF\3001\30D1\30D6\30EA\30C3\30AF\304A\3088\3073\30D7\30E9\30A4\30D9\30FC\30C8\30FB\30EC\30DD\30FC\30C8\3092\542B\3080\3001\30E6\30FC\30B6\30FC\304C\4F7F\7528\3067\304D\308B\3059\3079\3066\306E\30EC\30DD\30FC\30C8\306E\30EA\30B9\30C8\3092\8868\793A\3057\307E\3059\3002\3053\306E\30EA\30B9\30C8\306F\3001\30D7\30E9\30A4\30DE\30EA\30FB\30EC\30DD\30FC\30C8\4EE5\5916\306E\30EC\30DD\30FC\30C8\306B\30E6\30FC\30B6\30FC\304C\30A2\30AF\30BB\30B9\53EF\80FD\306A\5834\5408\306B\306E\307F\8868\793A\3055\308C\307E\3059\3002</dd>'),
unistr('  <dt>\30DA\30FC\30B8\3054\3068\306E\884C\6570\30BB\30EC\30AF\30BF</dt>'),
unistr('    <dd>\30DA\30FC\30B8\3054\3068\306B\8868\793A\3059\308B\884C\6570\306E\9078\629E\306B\4F7F\7528\3059\308B\9078\629E\30EA\30B9\30C8\3092\8868\793A\3057\307E\3059\3002</dd>'),
unistr('  <dt>\300C\30A2\30AF\30B7\30E7\30F3\300D\30E1\30CB\30E5\30FC</dt>'),
unistr('    <dd>\300C\30A2\30AF\30B7\30E7\30F3\300D\30E1\30CB\30E5\30FC\30FB\30DC\30BF\30F3\3092\8868\793A\3057\307E\3059\3002\901A\5E38\5305\62EC\7684\306A\30AA\30D7\30B7\30E7\30F3\306E\30BB\30C3\30C8\3092\542B\307F\307E\3059\3002\3053\308C\3089\306E\30AA\30D7\30B7\30E7\30F3\306B\3088\3063\3066\3001\30E6\30FC\30B6\30FC\306F\3001\4F7F\7528\53EF\80FD\306A\6A5F\80FD\306B\57FA\3065\3044\3066\30EC\30DD\30FC\30C8\3092\30AB\30B9\30BF\30DE\30A4\30BA\3067\304D\307E\3059\3002</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104206265182308614)
,p_name=>'PE.PROPERTY.INCLUDE_SEARCH_BAR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22\30D0\30FC\3092\542B\3081\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103877106740308306)
,p_name=>'PE.PROPERTY.INCLUDE_STANDARD_JAVASCRIPT_AND_CSS.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>&PRODUCT_NAME.\3067\306F\901A\5E38\3001\7279\5B9A\306EJavaScript\30D5\30A1\30A4\30EB\3068CSS\30D5\30A1\30A4\30EB\304C\5FC5\8981\3067\3059\3002'),
unistr('\30E2\30D0\30A4\30EB\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306A\3069\4E00\90E8\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\306F\3001\30DA\30FC\30B8\3067\3053\308C\3089\306E\30D5\30A1\30A4\30EB\3092\542B\3081\308B\3053\3068\3092\7981\6B62\3057\3066\3044\308B\5834\5408\304C\3042\308A\307E\3059\3002</p>'),
unistr('<p>\6A19\6E96\306E&PRODUCT_NAME.\304A\3088\3073JavaScript\30D5\30A1\30A4\30EB\3092\542B\3081\308B\306B\306F\3001<strong>\300C\30AA\30F3\300D</strong>\3092\9078\629E\3057\307E\3059\3002<strong>\300C\30AA\30D5\300D</strong>\3092\9078\629E\3059\308B\3068\3001HTML\30D8\30C3\30C0\30FC\306B\3053\308C\3089\306E\30D5\30A1\30A4\30EB\3092\542B\3081\308B\3053\3068\304C\7981\6B62\3055\308C\307E\3059\3002</p>'),
unistr('<p>\3053\308C\3089\306E\30D5\30A1\30A4\30EB\3092\542B\3081\308B\3053\3068\3092\7981\6B62\3059\308B\3068\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\6709\5BB3\306A\5F71\97FF\3092\53CA\307C\3057\3001\7834\640D\3059\308B\53EF\80FD\6027\304C\3042\308A\307E\3059\3002'),
unistr('\3057\305F\304C\3063\3066\3001\3053\306E\5C5E\6027\3092\7121\52B9\306B\3059\308B\3053\3068\306F\3001\4E0A\7D1A\306E\958B\767A\8005\306E\307F\304C\884C\3046\3053\3068\304C\63A8\5968\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103877071555308306)
,p_name=>'PE.PROPERTY.INCLUDE_STANDARD_JAVASCRIPT_AND_CSS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A19\6E96JavaScript\3068CSS\3092\542B\3081\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104498880699308837)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_GEOJSON_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30C3\30D7\306E\521D\671F\4F4D\7F6E\3092GeoJSON\30DD\30A4\30F3\30C8\30FB\30AA\30D6\30B8\30A7\30AF\30C8\3068\3057\3066\542B\3080\5217\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104498719062308837)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_GEOJSON_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('GeoJSON\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104498616816308837)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_SDOGEOM_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30C3\30D7\306E\521D\671F\4F4D\7F6E\3092\30DD\30A4\30F3\30C8\30FB\30AA\30D6\30B8\30A7\30AF\30C8\3068\3057\3066\542B\3080SDO_GEOMETRY\5217\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104498503938308837)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_SDOGEOM_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B8\30AA\30E1\30C8\30EA\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104497843108308836)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30C3\30D7\306E\521D\671F\4F4D\7F6E\306B\4F7F\7528\3059\308B\5217\30BF\30A4\30D7\3092\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104498199243308837)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.GEOJSON.D'
,p_message_language=>'ja'
,p_message_text=>'GeoJSON'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104498224479308837)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.GEOJSON.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('VARCHAR2\307E\305F\306FCLOB\5217\30BF\30A4\30D7\3068\3057\3066\306EGeoJSON\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104498370944308837)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.LONLAT_COLUMNS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D4C\5EA6/\7DEF\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104498413753308837)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.LONLAT_COLUMNS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('2\3064\306ENUMBER\5217\3068\3057\3066\306E\7D4C\5EA6\3068\7DEF\5EA6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104497931583308836)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.SDO_GEOMETRY.D'
,p_message_language=>'ja'
,p_message_text=>'SDO_GEOMETRY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104498040603308837)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.SDO_GEOMETRY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('Oracle SDO_GEOMETRY\578B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104497726887308836)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B8\30AA\30E1\30C8\30EA\5217\306E\30C7\30FC\30BF\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104496788059308836)
,p_name=>'PE.PROPERTY.INIT_POSITION_FROM_BROWSER.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\30DE\30C3\30D7\306E\4E2D\592E\306E\914D\7F6E\3092\30D6\30E9\30A6\30B6\304B\3089\73FE\5728\306E\4F4D\7F6E\306B\3059\308B\304B\3069\3046\304B\3002\6709\52B9\306B\3057\305F\5834\5408\3001\30D6\30E9\30A6\30B6\3067\73FE\5728\306E\4F4D\7F6E\306B\30A2\30AF\30BB\30B9\3067\304D\308B\3068\3001\4E0A\3067\69CB\6210\3057\305F\9759\7684\5024\3001SQL\554F\5408\305B\307E\305F\306F\7A7A\9593\7D50\679C\306B\57FA\3065\3044\3066\6C7A\5B9A\3055\308C\305F\521D\671F\4F4D\7F6E\3088\308A\3082\512A\5148\3055\308C\307E\3059\3002</p><p>\3053\308C\306F\3001APEX\30BB\30C3\30B7\30E7\30F3\5185\3067\306E\6700\521D\306E\30DA\30FC\30B8\306E\30ED\30FC\30C9\306B\306E\307F\9069\7528\3055\308C\307E\3059\3002APEX\30BB\30C3\30B7\30E7\30F3\3067\30DE\30C3\30D7\30FB\30DA\30FC\30B8\306B\518D\5EA6\30A2\30AF\30BB\30B9\3059\308B\3068\3001\30DE\30C3\30D7\306F\6700\5F8C\306E\4F4D\7F6E\304C\4E2D\592E\306B\306A\3063\3066\914D\7F6E\3055\308C\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104496625207308835)
,p_name=>'PE.PROPERTY.INIT_POSITION_FROM_BROWSER.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30E9\30A6\30B6\304B\3089\4F4D\7F6E\3092\53D6\5F97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104499260662308837)
,p_name=>'PE.PROPERTY.INIT_POSITION_LAT_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30C3\30D7\306E\521D\671F\4F4D\7F6E\306E\7DEF\5EA6\3092\542B\3080\5217\3092\9078\629E\3057\307E\3059\3002\623B\308A\5024\306F-90\304B\308990\306E\9593\306B\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104499140700308837)
,p_name=>'PE.PROPERTY.INIT_POSITION_LAT_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\521D\671F\7DEF\5EA6\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104497486287308836)
,p_name=>'PE.PROPERTY.INIT_POSITION_LAT_STATIC.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30C3\30D7\306E\521D\671F\4F4D\7F6E\306E\7DEF\5EA6\3092\6307\5B9A\3057\307E\3059\3002-90 (\5357)\304B\308990 (\5317)\307E\3067\306E\5024\3001\304A\3088\3073\5C0F\6570\70B9\6587\5B57\3068\3057\3066"."\3092\4F7F\7528\3057\307E\3059\3002\4F8B: <strong>"45.5"</strong>\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104497355263308836)
,p_name=>'PE.PROPERTY.INIT_POSITION_LAT_STATIC.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7DEF\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104499045227308837)
,p_name=>'PE.PROPERTY.INIT_POSITION_LON_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30C3\30D7\306E\521D\671F\4F4D\7F6E\306E\7D4C\5EA6\3092\542B\3080\5217\3092\9078\629E\3057\307E\3059\3002\623B\308A\5024\306F-180\304B\3089180\306E\9593\306B\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104498930651308837)
,p_name=>'PE.PROPERTY.INIT_POSITION_LON_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\521D\671F\7D4C\5EA6\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104497257762308836)
,p_name=>'PE.PROPERTY.INIT_POSITION_LON_STATIC.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30C3\30D7\306E\521D\671F\4F4D\7F6E\306E\7D4C\5EA6\3092\6307\5B9A\3057\307E\3059\3002-180 (\897F)\304B\3089180 (\6771)\307E\3067\306E\5024\3001\304A\3088\3073\5C0F\6570\70B9\6587\5B57\3068\3057\3066"."\3092\4F7F\7528\3057\307E\3059\3002\4F8B: "<strong>100.5</strong>\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104497198521308836)
,p_name=>'PE.PROPERTY.INIT_POSITION_LON_STATIC.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D4C\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104497084077308836)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_SOURCE_SQL.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30DE\30C3\30D7\306E\521D\671F\4F4D\7F6E\304A\3088\3073\30BA\30FC\30E0\30FB\30EC\30D9\30EB\3092\6C7A\5B9A\3059\308BNUMBER\5217\3092\8FD4\3059\554F\5408\305B:</p>'),
'<pre>',
'select -133.5 longituide,',
'         35.2 latitude,',
'            3 zoom',
'  from sys.dual',
'</pre>',
unistr('<p>\30DE\30C3\30D7\306E\521D\671F\4F4D\7F6E\304A\3088\3073\30BA\30FC\30E0\30FB\30EC\30D9\30EB\306ENUMBER\5217\3092\6C7A\5B9A\3059\308BSDO_GEOMETRY\5217\3092\8FD4\3059\554F\5408\305B\3002</p>'),
'<pre>',
unistr('select sdo_geometry( 2001,                                 -- 2\6B21\5143\306E\70B9'),
unistr('                     4326,                                 -- \7D4C\5EA6/\7DEF\5EA6(WGS84)'),
unistr('                     sdo_point_type( -133.5, 35.2, null ), -- \5177\4F53\7684\306A\5EA7\6A19'),
unistr('                     null,                                 -- \30DD\30A4\30F3\30C8\306B\306F\4F7F\7528\3057\306A\3044'),
unistr('                     null                                  -- \30DD\30A4\30F3\30C8\306B\306F\4F7F\7528\3057\306A\3044'),
'       )                   as geometry,',
'       3                   as zoom',
'  from sys.dual',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104496981205308836)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_SOURCE_SQL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30C3\30D7\306E\521D\671F\4F4D\7F6E\304A\3088\3073\30BA\30FC\30E0\30FB\30EC\30D9\30EB\3092\6C7A\5B9A\3059\308BSQL\554F\5408\305B\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104496859099308836)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_SOURCE_SQL.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104495956963308835)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\3057\3044APEX\30BB\30C3\30B7\30E7\30F3\3001\307E\305F\306F\30DE\30C3\30D7\30FB\30EA\30FC\30B8\30E7\30F3\306E<strong>\30AF\30EA\30A2</strong>\3084<strong>\30EA\30BB\30C3\30C8</strong>\64CD\4F5C\5F8C\306E\3001\30DE\30C3\30D7\306E\521D\671F\4F4D\7F6E\304A\3088\3073\30BA\30FC\30E0\30FB\30EC\30D9\30EB\3092\6C7A\5B9A\3059\308B\65B9\6CD5\3092\6307\5B9A\3057\307E\3059\3002APEX\30BB\30C3\30B7\30E7\30F3\5185\3067\3001\30DE\30C3\30D7\30FB\30EA\30FC\30B8\30E7\30F3\306F\30DA\30FC\30B8\30FB\30EA\30AF\30A8\30B9\30C8\9593\3067\306E\73FE\5728\306E\4F4D\7F6E\304A\3088\3073\30BA\30FC\30E0\30FB\30EC\30D9\30EB\3092\8A18\61B6\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104496485414308835)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.QUERY_RESULTS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\7A7A\9593\7D50\679C\306B\57FA\3065\304F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104496530656308835)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.QUERY_RESULTS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30C3\30D7\306F\3001\30EC\30A4\30E4\30FC\554F\5408\305B\306E\7D50\679C\3092\8868\793A\3059\308B\3088\3046\306B\914D\7F6E\3055\308C\307E\3059\3002 <em>\30EC\30A4\30E4\30FC\30FB\30B8\30AA\30E1\30C8\30EA\5217\30BF\30A4\30D7\3068\3057\3066GeoJSON\304C\9078\629E\3055\308C\3066\3044\308B\5834\5408\3001\3053\308C\306F\30B5\30DD\30FC\30C8\3055\308C\306A\3044\3053\3068\306B\6CE8\610F\3057\3066\304F\3060\3055\3044\3002</em>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104496260329308835)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.SQL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104496386273308835)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.SQL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30C3\30D7\306E\521D\671F\4F4D\7F6E\306E\5024\3092\8FD4\3059SQL\554F\5408\305B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104496054416308835)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.STATIC.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\9759\7684\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104496162369308835)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.STATIC.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30C3\30D7\306E\521D\671F\4F4D\7F6E\306E\9759\7684\5024\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104495884919308835)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104499420421308838)
,p_name=>'PE.PROPERTY.INIT_ZOOMLEVEL_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\521D\671F\30BA\30FC\30E0\30FB\30EC\30D9\30EB\3092\542B\3080\5217\3092\9078\629E\3057\307E\3059\3002\623B\308A\5024\306F1\304B\308918\306E\9593\306B\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104499352136308837)
,p_name=>'PE.PROPERTY.INIT_ZOOMLEVEL_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\521D\671F\30BA\30FC\30E0\30FB\30EC\30D9\30EB\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104497623805308836)
,p_name=>'PE.PROPERTY.INIT_ZOOMLEVEL_STATIC.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\521D\671F\30BA\30FC\30E0\30FB\30EC\30D9\30EB\3092\6307\5B9A\3057\307E\3059\30021\304B\308918\306E\9593\306E\6574\6570\5024\3092\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104497587198308836)
,p_name=>'PE.PROPERTY.INIT_ZOOMLEVEL_STATIC.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BA\30FC\30E0\30FB\30EC\30D9\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104385365744308746)
,p_name=>'PE.PROPERTY.INLINE_CSS.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>CSS\30AF\30E9\30B9<code>display_only</code>\3092\592A\5B57\306B\8A2D\5B9A</dt>'),
'<dd><pre>',
'.display_only {',
'  font-weight: bold;',
'}',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103872039847308302)
,p_name=>'PE.PROPERTY.INLINE_CSS.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30DA\30FC\30B8\3067\4F7F\7528\3059\308B\30AB\30B9\30B1\30FC\30C7\30A3\30F3\30B0\30FB\30B9\30BF\30A4\30EB\30B7\30FC\30C8(CSS)\3092\5165\529B\3057\307E\3059\3002'),
unistr('\8907\6570\306E\30DA\30FC\30B8\3067\540C\3058CSS\304C\5FC5\8981\306A\5834\5408\3001\91CD\8907\3092\907F\3051\3001\30D6\30E9\30A6\30B6\306B\3088\308B\9759\7684\30D5\30A1\30A4\30EB\306E\30AD\30E3\30C3\30B7\30E5\3092\6D3B\7528\3059\308B\305F\3081\3001\30B3\30FC\30C9\3092\5916\90E8\30D5\30A1\30A4\30EB\306B\3059\308B\3053\3068\3092\691C\8A0E\3057\3066\304F\3060\3055\3044\3002</p>'),
unistr('<p>\3053\3053\3067\5165\529B\3057\305F\30B3\30FC\30C9\3067\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306E<code>#PAGE_CSS#</code>\7F6E\63DB\6587\5B57\5217\304C\7F6E\63DB\3055\308C\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8: \958B\59CB\304A\3088\3073\7D42\4E86\306E<code>style</code>\30BF\30B0\3092\542B\3081\308B\5FC5\8981\306F\3042\308A\307E\305B\3093\3002\30AB\30B9\30B1\30FC\30C7\30A3\30F3\30B0\30FB\30B9\30BF\30A4\30EB\30B7\30FC\30C8\306E\30B3\30FC\30C9\3092\542B\3081\308B\306E\307F\3067\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103871952034308302)
,p_name=>'PE.PROPERTY.INLINE_CSS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30E9\30A4\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103880313370308308)
,p_name=>'PE.PROPERTY.INLINE_ERROR_NOTIFICATION_TEXT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DA\30FC\30B8\3067\30A8\30E9\30FC\304C\767A\751F\3057\305F\5834\5408\306B\8868\793A\3059\308B\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\3092\5165\529B\3057\307E\3059\3002\3053\306E\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\304C\3001\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306E<code>#NOTIFICATION_MESSAGE#</code>\306B\4EE3\5165\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103880226848308308)
,p_name=>'PE.PROPERTY.INLINE_ERROR_NOTIFICATION_TEXT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30E9\30A4\30F3\30FB\30A8\30E9\30FC\901A\77E5\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104698344406308999)
,p_name=>'PE.PROPERTY.INLINE_HELP_TEXT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30A4\30C6\30E0\306E\30A4\30F3\30E9\30A4\30F3\30FB\30D8\30EB\30D7\30FB\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002\30D8\30EB\30D7\30FB\30C6\30AD\30B9\30C8\306F\3001\30A2\30A4\30C6\30E0\3068\3068\3082\306B\5373\5EA7\306B\8868\793A\3055\308C\3001\30D5\30A3\30FC\30EB\30C9\30FB\30EC\30D9\30EB\306E\72B6\6CC1\4F9D\5B58\30D8\30EB\30D7\3092\63D0\4F9B\3059\308B\305F\3081\306B\4F7F\7528\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104698267304308999)
,p_name=>'PE.PROPERTY.INLINE_HELP_TEXT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30E9\30A4\30F3\30FB\30D8\30EB\30D7\30FB\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103963862090308408)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30BB\30C3\30B7\30E7\30F3\304C\6709\52B9\3067\306F\306A\3044\5834\5408\306E&PRODUCT_NAME.\306E\30EA\30C0\30A4\30EC\30AF\30C8\5148\3092\9078\629E\3057\307E\3059\3002'),
unistr('\3053\308C\306F\3001\901A\5E38\306E\30DA\30FC\30B8\30FB\30EA\30AF\30A8\30B9\30C8\3067<strong>\76E3\8996\30D5\30A1\30F3\30AF\30B7\30E7\30F3</strong>\307E\305F\306F<strong>\691C\8A3C\30D5\30A1\30F3\30AF\30B7\30E7\30F3</strong>\304CFALSE\3092\8FD4\3059\5834\5408\306B\8D77\3053\308A\307E\3059\3002Ajax\30EA\30AF\30A8\30B9\30C8\3067\306F\8D77\3053\308A\307E\305B\3093\3002</p>'),
unistr('<p>\30CE\30FC\30C8: <strong>\30AB\30B9\30BF\30E0</strong>\8A8D\8A3C\30B9\30AD\30FC\30E0\30FB\30BF\30A4\30D7\3092\4F7F\7528\3059\308B\5834\5408\3001\8A8D\8A3C\30B9\30AD\30FC\30E0\306E<strong>\300C\76E3\8996\30D5\30A1\30F3\30AF\30B7\30E7\30F3\300D</strong>\5C5E\6027\3082\4F7F\7528\3067\304D\307E\3059\3002'),
unistr('\30D7\30E9\30B0\30A4\30F3\8A8D\8A3C\30B9\30AD\30FC\30E0\30FB\30BF\30A4\30D7\306E\5834\5408\3001\3053\308C\306F\3001<strong>\300C\30BB\30C3\30B7\30E7\30F3\76E3\8996\30D5\30A1\30F3\30AF\30B7\30E7\30F3\540D\300D</strong>\30B3\30FC\30EB\30D0\30C3\30AF\3067\30D7\30E9\30B0\30A4\30F3\958B\767A\8005\306B\3088\3063\3066\5B9A\7FA9\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104398326180308756)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.BUILTIN_LOGIN.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D44\8FBC\307F\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104398434814308756)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.BUILTIN_LOGIN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('&PRODUCT_NAME.\306B\3088\3063\3066\63D0\4F9B\3055\308C\308B<code>wwv_flow_custom_auth_std.login_page</code>\3067\5B9A\7FA9\3055\308C\305FURL\306B\30EA\30C0\30A4\30EC\30AF\30C8\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104398182273308756)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.LOGIN.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104398274784308756)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.LOGIN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5C5E\6027\3067\5B9A\7FA9\3055\308C\305F\30ED\30B0\30A4\30F3URL\306B\30EA\30C0\30A4\30EC\30AF\30C8\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104398571656308756)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.URL.D'
,p_message_language=>'ja'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104398664055308756)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.URL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<code>f?p=&amp;APP_ID.:101:&amp;SESSION</code>\306A\3069\306E\5165\529B\3057\305FURL\306B\30EA\30C0\30A4\30EC\30AF\30C8\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103963763668308408)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9\306A\30BB\30C3\30B7\30E7\30F3\30FB\30EA\30C0\30A4\30EC\30AF\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103964041673308408)
,p_name=>'PE.PROPERTY.INVALID_SESSION_URL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30C3\30B7\30E7\30F3\76E3\8996\30D5\30A1\30F3\30AF\30B7\30E7\30F3\304CFALSE\3092\8FD4\3059\5834\5408\306E&PRODUCT_NAME.\306E\30EA\30C0\30A4\30EC\30AF\30C8\5148\306EURL\3092\5165\529B\3057\307E\3059\3002\901A\5E38\3001\3053\308C\306F\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8\307E\305F\306F\30B7\30F3\30B0\30EB\30FB\30B5\30A4\30F3\30AA\30F3\30FB\30DD\30FC\30BF\30EB\306EURL\3067\3059\3002\305F\3068\3048\3070\3001f?p=&amp;APP_ID.:101:&amp;SESSION\3067\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103963991930308408)
,p_name=>'PE.PROPERTY.INVALID_SESSION_URL.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9\306A\30BB\30C3\30B7\30E7\30F3URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104205013539308613)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\5024\306E\8868\793A\65B9\6CD5\3092\5B9A\7FA9\3059\308B\305F\3081\306B\95A2\9023\5217\306E\8868\793A\30BF\30A4\30D7\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104405013419308761)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.DOWNLOAD.D'
,p_message_language=>'ja'
,p_message_text=>unistr('BLOB\306E\30C0\30A6\30F3\30ED\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104589364713308910)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.DOWNLOAD.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\3092\30C0\30A6\30F3\30ED\30FC\30C9\3059\308B\305F\3081\306E\30EA\30F3\30AF\3068\3057\3066\5217\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104405384953308761)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.HIDDEN_COLUMN.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\975E\8868\793A\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104589628154308910)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.HIDDEN_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\306F\8868\793A\3055\308C\307E\305B\3093\304C\3001\53C2\7167\53EF\80FD\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104404909158308761)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.IMAGE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30E1\30FC\30B8\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104589211628308910)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.IMAGE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30E1\30FC\30B8\3068\3057\3066\5217\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104404896111308761)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.LINK.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30F3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104589172219308910)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.LINK.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30F3\30AF\3068\3057\3066\5217\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104405145402308761)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.PCT_GRAPH.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30FC\30BB\30F3\30C8\30FB\30B0\30E9\30D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104589423719308910)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.PCT_GRAPH.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30FC\30BB\30F3\30C6\30FC\30B8\30FB\30B0\30E9\30D5\3068\3057\3066\5217\3092\8868\793A\3057\307E\3059\3002\53D6\5F97\3055\308C\308B\5024\306F\30010\304B\3089100\307E\3067\306E\9593\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104404651630308761)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.PLAIN.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30EC\30FC\30F3\30FB\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104588953748308910)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.PLAIN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\5024\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104404756694308761)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.PLAIN_LOV.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30EC\30FC\30F3\30FB\30C6\30AD\30B9\30C8(LOV\306B\57FA\3065\304F)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104589057443308910)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.PLAIN_LOV.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\6307\5B9A\3055\308C\305FLOV\304B\3089\8FD4\3055\308C\305F\5024\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104661447364308968)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.RICH_TEXT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30C3\30C1\30FB\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104661512136308968)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.RICH_TEXT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('HTML\307E\305F\306F\30DE\30FC\30AF\30C0\30A6\30F3\3092\4F7F\7528\3057\3066\5217\3092\30EC\30F3\30C0\30EA\30F3\30B0\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104405246940308761)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.STRIP_HTML.D'
,p_message_language=>'ja'
,p_message_text=>unistr('HTML\306E\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104589539739308910)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.STRIP_HTML.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('HTML\30BF\30B0\3092\524A\9664\3057\3001\7279\6B8A\6587\5B57\3092\30A8\30B9\30B1\30FC\30D7\3057\305F\5F8C\3001\5217\5024\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104204910603308613)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104289221011308674)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_LOV_SQL.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\90E8\9580\540D\3092\623B\3059\306B\306F:</dt>'),
'<dd><pre>select dname from dept order by 1</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104223316968308627)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_LOV_SQL.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>1\3064\306E\5217\3092\8FD4\3059\5FC5\8981\304C\3042\308BSQL\554F\5408\305B\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002\554F\5408\305B\304C\8907\6570\306E\5217\3092\8FD4\3059\5834\5408\3001LOV\3067\306F\6700\521D\306E\5217\306E\307F\304C\4F7F\7528\3055\308C\307E\3059\3002</p>'),
unistr('<p>SQL\554F\5408\305B\3092\5165\529B\3059\308B\3053\3068\3067\3001\4E00\90E8\306E\30EC\30DD\30FC\30C8\306E\30D1\30D5\30A9\30FC\30DE\30F3\30B9\3092\5411\4E0A\3057\305F\308A\3001\8868\793A\3055\308C\308B\5024\3092\5236\9650\3067\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104223278243308627)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_LOV_SQL.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104342783840308714)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_NAMED_LOV.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9A\7FA9\3055\308C\305F\540D\524D\4ED8\304DLOV\3092\9078\629E\3057\307E\3059\3002\5217\30D5\30A3\30EB\30BF\306F\3001\52D5\7684LOV\554F\5408\305B\306E\6700\521D\306E\5217\307E\305F\306F\9759\7684LOV\306E\8868\793A\5024\306E\307F\3092\4F7F\7528\3057\3066\3001\30EC\30DD\30FC\30C8\30FB\30C7\30FC\30BF\3092\30D5\30A3\30EB\30BF\51E6\7406\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104342633391308714)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_NAMED_LOV.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\540D\524D\4ED8\304DLOV')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104203868928308612)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\5217\30C9\30ED\30C3\30D7\30FB\30C0\30A6\30F3\30FB\30EA\30B9\30C8\306B\8868\793A\3055\308C\308B\30D5\30A3\30EB\30BF\306E\5C0E\51FA\65B9\6CD5\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104406827608308762)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.1.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B8C\5168\4E00\81F4\306E\30D5\30A3\30EB\30BF\51E6\7406\306B\540D\524D\4ED8\304DLOV\3092\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104406934037308762)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.1.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\7B49\3057\3044\300D\30D5\30A3\30EB\30BF\3092\4F5C\6210\3059\308B\305F\3081\306B\540D\524D\4ED8\304D\306ELOV\304B\3089LOV\3092\5C0E\51FA\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104407053965308762)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.2.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\5358\8A9E\3092\542B\3080\300D\306E\30D5\30A3\30EB\30BF\51E6\7406\306B\540D\524D\4ED8\304DLOV\3092\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104407176000308763)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\542B\3080\300D\30D5\30A3\30EB\30BF\3092\4F5C\6210\3059\308B\305F\3081\306B\540D\524D\4ED8\304D\306ELOV\304B\3089LOV\3092\5C0E\51FA\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104406658103308762)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.C.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\5358\8A9E\3092\542B\3080\300D\306E\30D5\30A3\30EB\30BF\51E6\7406\306B\5B9A\7FA9\6E08LOV\3092\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104406719345308762)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.C.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\542B\3080\300D\30D5\30A3\30EB\30BF\3092\4F5C\6210\3059\308B\305F\3081\306BSQL\3067\554F\3044\5408\305B\308B\5B9A\7FA9\6E08\306ELOV\304B\3089LOV\3092\5C0E\51FA\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104406225351308762)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.D.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\30BF\30A4\30D7\306B\57FA\3065\304F\30C7\30D5\30A9\30EB\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104406357651308762)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.D.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('STRING\304A\3088\3073NUMBER\5217\306F\3001\500B\5225\306E\5217\306E\5024\304B\3089LOV\3092\5C0E\51FA\3057\307E\3059\3002DATE\5217\306F\3001\4E8B\524D\5B9A\7FA9\306E\65E5\4ED8\7BC4\56F2\304B\3089LOV\3092\5C0E\51FA\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104406054965308762)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.N.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104406126359308762)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.N.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30EC\30DD\30FC\30C8\306B\6307\5B9A\3055\308C\305F\5217\30D5\30A3\30EB\30BF\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104406447008308762)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.S.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B8C\5168\4E00\81F4\306E\30D5\30A3\30EB\30BF\51E6\7406\306B\5B9A\7FA9\6E08LOV\3092\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104406543045308762)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.S.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\7B49\4FA1\4E00\81F4\30D5\30A3\30EB\30BF\3092\4F5C\6210\3059\308B\305F\3081\306BSQL\3067\554F\3044\5408\305B\308B\5B9A\7FA9\6E08\306ELOV\304B\3089LOV\3092\5C0E\51FA\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104203768438308612)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104204845110308613)
,p_name=>'PE.PROPERTY.IR_COLUMN_GROUP.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\5217\306E\30B0\30EB\30FC\30D7\3092\9078\629E\3057\307E\3059\3002\30B0\30EB\30FC\30D7\306F\3001\5358\4E00\884C\30D3\30E5\30FC\3067\5217\3092\8AD6\7406\30B0\30EB\30FC\30D7\306B\307E\3068\3081\3066\8868\793A\3059\308B\305F\3081\306B\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104204795617308613)
,p_name=>'PE.PROPERTY.IR_COLUMN_GROUP.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30EB\30FC\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104208774131308616)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\3053\306E\30EC\30DD\30FC\30C8\306E\30EA\30F3\30AF\5217\30BF\30A4\30D7\3092\9078\629E\3057\307E\3059\3002'),
unistr('\30EA\30F3\30AF\5217\3092\9078\629E\3059\308B\3068\3001\305D\306E\5217\304C\5E38\306B\6700\521D\306E\5217\3068\3057\3066\30EC\30DD\30FC\30C8\306B\8868\793A\3055\308C\3001\30E6\30FC\30B6\30FC\304C\975E\8868\793A\306B\3059\308B\3053\3068\306F\3067\304D\307E\305B\3093\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104409094041308764)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.C.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30B9\30BF\30E0\30FB\30BF\30FC\30B2\30C3\30C8\3078\306E\30EA\30F3\30AF')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104409176790308764)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.C.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\3001\5165\529B\3057\305F\30BF\30FC\30B2\30C3\30C8URL\306B\57FA\3065\3044\305F\5225\306E\30DA\30FC\30B8\306B\79FB\52D5\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104409268028308764)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.N.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30F3\30AF\5217\306E\9664\5916')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104409379900308764)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.N.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30F3\30AF\5217\306F\8868\793A\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104408830382308764)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.Y.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5358\4E00\884C\30D3\30E5\30FC\3078\306E\30EA\30F3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104408932502308764)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.Y.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\3001\6307\5B9A\3055\308C\305F\884C\306E\5217\5024\3092\8868\793A\3059\308B\30DA\30FC\30B8\306B\79FB\52D5\3055\308C\307E\3059\3002\8868\793A\3055\308C\308B\5217\3068\305D\306E\8868\793A\65B9\6CD5\306F\3001\5404\7A2E\30EC\30DD\30FC\30C8\5C5E\6027\304A\3088\3073\5217\5C5E\6027\306B\3088\3063\3066\6C7A\307E\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104208628274308616)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30F3\30AF\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104255381693308650)
,p_name=>'PE.PROPERTY.IR_PAGINATION_TYPE.COMPONENT_PROPERTY.IR_ATTRIBUTES.NULL_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104206553976308614)
,p_name=>'PE.PROPERTY.IR_PAGINATION_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30EC\30DD\30FC\30C8\306E\30DA\30FC\30B8\533A\5207\308A\30BF\30A4\30D7\3092\9078\629E\3057\307E\3059\3002\591A\304F\306E\5834\5408\3001\30DA\30FC\30B8\306B\306F\3001\30EC\30DD\30FC\30C8\306E\7279\5B9A\6570\306E\5217\306E\307F\304C\8868\793A\3055\308C\307E\3059\3002'),
unistr('\305D\308C\4EE5\4E0A\306E\884C\3092\8868\793A\3059\308B\306B\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\30EC\30DD\30FC\30C8\306E\6B21\306E\30DA\30FC\30B8\306B\30CA\30D3\30B2\30FC\30C8\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>'),
unistr('<p>\30DA\30FC\30B8\533A\5207\308A\306F\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\884C\6570\304A\3088\3073\7D50\679C\30BB\30C3\30C8\3067\306E\73FE\5728\306E\4F4D\7F6E\306B\95A2\3059\308B\60C5\5831\3092\63D0\4F9B\3057\307E\3059\3002</p>'),
unistr('<p>\30DA\30FC\30B8\533A\5207\308A\306F\30EC\30DD\30FC\30C8\306E\4E0A\90E8\307E\305F\306F\4E0B\90E8(\3042\308B\3044\306F\305D\306E\4E21\65B9)\306B\8868\793A\3067\304D\3001\307E\305F\5DE6\5074\304B\53F3\5074\306B\914D\7F6E\3067\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104407862990308763)
,p_name=>'PE.PROPERTY.IR_PAGINATION_TYPE.LOV.ROWS_X_TO_Y.D'
,p_message_language=>'ja'
,p_message_text=>unistr('X\304B\3089Y\306E\7BC4\56F2\306E\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104407765691308763)
,p_name=>'PE.PROPERTY.IR_PAGINATION_TYPE.LOV.ROWS_X_TO_Y_OF_Z.D'
,p_message_language=>'ja'
,p_message_text=>unistr('Z\306EX\304B\3089Y\306E\7BC4\56F2\306E\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104206408084308614)
,p_name=>'PE.PROPERTY.IR_PAGINATION_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104221032954308625)
,p_name=>'PE.PROPERTY.IR_SAVED_REPORT_ALIAS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\4FDD\5B58\6E08\30EC\30DD\30FC\30C8\306E\5225\540D\3092\5165\529B\3057\307E\3059\3002\3053\306E\5225\540D\3092\4F7F\7528\3057\3066\3001\3053\306E\7279\5B9A\306E\4FDD\5B58\6E08\30EC\30DD\30FC\30C8\3078\306E\308F\304B\308A\3084\3059\3044URL\30EA\30F3\30AF\3092\5B9A\7FA9\3057\307E\3059\3002\3053\306E\30EA\30F3\30AF\3092\4F7F\7528\3057\3066\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5185\306E\5225\306E\5834\6240\304B\3089\76F4\63A5\30EA\30F3\30AF\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104220944031308625)
,p_name=>'PE.PROPERTY.IR_SAVED_REPORT_ALIAS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5225\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104221409806308625)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\4FDD\5B58\6E08\30EC\30DD\30FC\30C8\30FB\30AB\30C6\30B4\30EA\3092\8868\793A\3057\307E\3059\3002\30AB\30C6\30B4\30EA\306B\3088\3063\3066\3053\306E\30EC\30DD\30FC\30C8\304C\8868\793A\3055\308C\308B\30EC\30DD\30FC\30C8\9078\629E\30EA\30B9\30C8\5185\306E\4F4D\7F6E\304C\6C7A\307E\308A\307E\3059\3002\3053\306E\5C5E\6027\306F\8868\793A\5C02\7528\3067\66F4\65B0\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104411432071308766)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.ALTERNATIVE_DEFAULT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\4EE3\66FF\30C7\30D5\30A9\30EB\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104589897590308910)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.ALTERNATIVE_DEFAULT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\767A\8005\306B\3088\3063\3066\4FDD\5B58\3055\308C\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\9078\629E\53EF\80FD\306A\5F8C\7D9A\306E\30EC\30DD\30FC\30C8\30FB\30EC\30A4\30A2\30A6\30C8\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104411358466308766)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PRIMARY_DEFAULT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30E9\30A4\30DE\30EA\30FB\30C7\30D5\30A9\30EB\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104589750393308910)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PRIMARY_DEFAULT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\767A\8005\306B\3088\3063\3066\4FDD\5B58\3055\308C\3001\30C7\30D5\30A9\30EB\30C8\3067\8868\793A\3055\308C\308B\30EC\30DD\30FC\30C8\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104411639713308766)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PRIVATE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30E9\30A4\30D9\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104590003407308911)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PRIVATE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\3088\3063\3066\4FDD\5B58\3055\308C\3001\4FDD\5B58\3057\305F\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306E\307F\304C\9078\629E\53EF\80FD\306A\30EC\30DD\30FC\30C8\30FB\30EC\30A4\30A2\30A6\30C8\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104411543796308766)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PUBLIC.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30D6\30EA\30C3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104589921179308910)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PUBLIC.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\3088\3063\3066\4FDD\5B58\3055\308C\3001\4ED6\306E\3059\3079\3066\306E\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\9078\629E\53EF\80FD\306A\30EC\30DD\30FC\30C8\30FB\30EC\30A4\30A2\30A6\30C8\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104221332029308625)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\53EF\8996\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104055332545308479)
,p_name=>'PE.PROPERTY.IS_EDITABLE.COMPONENT_PROPERTY.REGION_PLUGIN_ATTRIBUTES.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\3053\306E\30D5\30A9\30FC\30E0\30FB\30EA\30FC\30B8\30E7\30F3\3092\7DE8\96C6\3067\304D\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002</p>'),
unistr('        <p>\30CE\30FC\30C8 - \30D5\30A9\30FC\30E0\30FB\30EA\30FC\30B8\30E7\30F3\304C\7DE8\96C6\53EF\80FD\306B\306A\308B\3068\3001\884C\3092\51E6\7406\3059\308B\305F\3081\306B\30D7\30ED\30BB\30B9\304C\81EA\52D5\7684\306B\4F5C\6210\3055\308C\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104096251183308513)
,p_name=>'PE.PROPERTY.IS_EDITABLE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\3053\306E\5BFE\8A71\30B0\30EA\30C3\30C9\3092\7DE8\96C6\3067\304D\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002</p>'),
unistr('        <p>\30CE\30FC\30C8 - \5BFE\8A71\30B0\30EA\30C3\30C9\304C\7DE8\96C6\53EF\80FD\306B\306A\308B\3068\3001\884C\3092\51E6\7406\3059\308B\305F\3081\306B\30D7\30ED\30BB\30B9\304C\81EA\52D5\7684\306B\4F5C\6210\3055\308C\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104096192892308513)
,p_name=>'PE.PROPERTY.IS_EDITABLE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6709\52B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104694109534308995)
,p_name=>'PE.PROPERTY.IS_GLOBAL_PAGE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30ED\30FC\30D0\30EB\30FB\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104109954404308525)
,p_name=>'PE.PROPERTY.IS_PRIMARY_KEY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\304C\57FA\790E\3068\306A\308B\8868\306E\4E3B\30AD\30FC\5024\306E\3044\305A\308C\304B\3067\3042\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104109867685308524)
,p_name=>'PE.PROPERTY.IS_PRIMARY_KEY.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E3B\30AD\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104109794178308524)
,p_name=>'PE.PROPERTY.IS_QUERY_ONLY.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>DML\64CD\4F5C\304B\3089\5217\3092\9664\5916\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002</p>'),
unistr('        <p><strong>\300C\30AA\30F3\300D</strong>\306B\8A2D\5B9A\3055\308C\3066\3044\308B\5834\5408\3001\5BFE\8A71\30B0\30EA\30C3\30C9 - \884C\306E\81EA\52D5\51E6\7406(DML)\3092\5B9F\884C\3059\308B\5834\5408\306B&PRODUCT_NAME.\306F\5217\3092\4F7F\7528\3057\307E\305B\3093\3002'),
unistr('        \305F\3068\3048\3070\3001\9023\7D50\3001\5185\90E8\9078\629E\3001\30D5\30A1\30F3\30AF\30B7\30E7\30F3\30FB\30B3\30FC\30EB\304C\542B\307E\308C\308B\5B9A\7FA9\3092\6301\3064\5217\3084\3001\5F0F\306B\57FA\3065\304F\66F4\65B0\53EF\80FD\306A\30D3\30E5\30FC\306E\5217\3092\9664\5916\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>'),
unistr('        <p>INSERT\307E\305F\306FUPDATE\6587\306B\542B\3081\308B\5FC5\8981\304C\3042\308B\3059\3079\3066\306E\5217\3067\3053\306E\30AA\30D7\30B7\30E7\30F3\3092<strong>\300C\30AA\30D5\300D</strong>\306B\8A2D\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>'),
unistr('        <p>\30CE\30FC\30C8: \3053\306E\30AA\30D7\30B7\30E7\30F3\304C<strong>\300C\30AA\30F3\300D</strong>\306B\8A2D\5B9A\3055\308C\3066\3044\306A\3044\5834\5408\3001<em>\300C\8868\793A\306E\307F\300D</em>\30BF\30A4\30D7\306E\5217<u>\3082</u>\884C\306E\81EA\52D5\51E6\7406\306B\542B\307E\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104109640607308524)
,p_name=>'PE.PROPERTY.IS_QUERY_ONLY.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\554F\5408\305B\306E\307F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104190709159308602)
,p_name=>'PE.PROPERTY.IS_STATIC.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30E9\30E1\30FC\30BF\3092\9759\7684\5024\30671\56DE\306E\307F\8A2D\5B9A\3067\304D\308B\304B\3001\307E\305F\306F\30B3\30F3\30DD\30FC\30CD\30F3\30C8\30FB\30EC\30D9\30EB\3067\4E0A\66F8\304D\3067\304D\308B\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104190656358308602)
,p_name=>'PE.PROPERTY.IS_STATIC.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\9759\7684')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104542423695308869)
,p_name=>'PE.PROPERTY.IS_VISIBLE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\5217\3092\8868\793A\3059\308B\304B\975E\8868\793A\306B\3059\308B\304B\3092\6307\5B9A\3057\307E\3059\3002\975E\8868\793A\306E\5834\5408\3067\3082\3001\7F6E\63DB\69CB\6587<code>&amp;COLUMN_NAME.</code>\3092\4F7F\7528\3057\3066\3044\3064\3067\3082\5217\3092\53C2\7167\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104542386627308869)
,p_name=>'PE.PROPERTY.IS_VISIBLE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104082879772308502)
,p_name=>'PE.PROPERTY.ITEMS_BOX_HIGH_COLUMN_NAME.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30C1\30E3\30FC\30C8\306E\4E0A\9650\5024\3092\5B9A\7FA9\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\5217\540D\3092\9078\629E\3057\307E\3059\3002\5217\3092\9078\629E\3057\306A\3044\5834\5408\3001\30DC\30C3\30AF\30B9\30FB\30D7\30ED\30C3\30C8\30FB\30C1\30E3\30FC\30C8\306E\4E0A\9650\5024\306F\30C7\30FC\30BF\30FB\30BB\30C3\30C8\306B\57FA\3065\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104082641944308502)
,p_name=>'PE.PROPERTY.ITEMS_BOX_HIGH_COLUMN_NAME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\9AD8\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104082733549308502)
,p_name=>'PE.PROPERTY.ITEMS_BOX_LOW_COLUMN_NAME.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30C1\30E3\30FC\30C8\306E\4E0B\9650\5024\3092\5B9A\7FA9\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\5217\540D\3092\9078\629E\3057\307E\3059\3002\5217\3092\9078\629E\3057\306A\3044\5834\5408\3001\30DC\30C3\30AF\30B9\30FB\30D7\30ED\30C3\30C8\30FB\30C1\30E3\30FC\30C8\306E\4E0B\9650\5024\306F\30C7\30FC\30BF\30FB\30BB\30C3\30C8\306B\57FA\3065\304D\307E\3059\3002 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104082576793308502)
,p_name=>'PE.PROPERTY.ITEMS_BOX_LOW_COLUMN_NAME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F4E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104157739502308574)
,p_name=>'PE.PROPERTY.ITEMS_CLOSE_COLUMN_NAME.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30C1\30E3\30FC\30C8\306E\7D42\5024\3092\5B9A\7FA9\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\5217\540D\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104157637634308572)
,p_name=>'PE.PROPERTY.ITEMS_CLOSE_COLUMN_NAME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\9589\3058\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104157391662308572)
,p_name=>'PE.PROPERTY.ITEMS_HIGH_COLUMN_NAME.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30C1\30E3\30FC\30C8\306E\4E0A\9650\5024\3092\5B9A\7FA9\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\5217\540D\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104157291378308572)
,p_name=>'PE.PROPERTY.ITEMS_HIGH_COLUMN_NAME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\9AD8\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104159353886308575)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_COLUMN_NAME.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\306EX\8EF8\306E\30E9\30D9\30EB\3092\5B9A\7FA9\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\5217\540D\3092\9078\629E\3057\307E\3059\3002\682A\4FA1\30C1\30E3\30FC\30C8\3067\306F\3001\682A\4FA1\60C5\5831\3092\6642\9593\8EF8\306B\8868\793A\3059\308B\305F\3081\3001\5217\306E\30C7\30FC\30BF\578B\306F\65E5\4ED8/\30BF\30A4\30E0\30B9\30BF\30F3\30D7\306B\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104159258852308575)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_COLUMN_NAME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103988583015308427)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_CSS_CLASSES.COMPONENT_PROPERTY.JET_CHART_SERIES.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'font-size:14px;color:white;</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104164721856308579)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_CSS_CLASSES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\3053\306E\30C1\30E3\30FC\30C8\306E\30E9\30D9\30EB\306E\30B9\30BF\30A4\30EB\3092\5B9A\7FA9\3059\308BCSS\30B9\30BF\30A4\30EB\6587\5B57\5217\3092\5165\529B\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104164631823308579)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_CSS_CLASSES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('CSS\30B9\30BF\30A4\30EB\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104188906117308600)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.COMPONENT_PROPERTY.JET_CHART_SERIES.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\7BC4\56F2\30B7\30EA\30FC\30BA\3067\306F\30012\3064\306E\5024\306E\914D\5217\304C\6307\5B9A\3055\308C\308B\5834\5408\3001\6700\521D\30682\756A\76EE\306E\5024\304C\4E0B\9650\3068\4E0A\9650\306B\305D\308C\305E\308C\9069\7528\3055\308C\307E\3059\3002<strong>\30B9\30E9\30A4\30B9\306E\5916\5074</strong>\5024\306F\3001\5186\30B0\30E9\30D5\306B\306E\307F\9069\7528\3055\308C\307E\3059\3002'),
unistr('        <strong>\30DE\30FC\30AB\30FC\306E\4E0A</strong>\3001<strong>\30DE\30FC\30AB\30FC\306E\4E0B</strong>\3001<strong>\30DE\30FC\30AB\30FC\306E\524D</strong>\304A\3088\3073<strong>\30DE\30FC\30AB\30FC\306E\5F8C</strong>\5024\306F\3001\6298\308C\7DDA\3001\9762\3001\6563\5E03\304A\3088\3073\30D0\30D6\30EB\30FB\30B7\30EA\30FC\30BA\306B\306E\307F\9069\7528\3055\308C\307E\3059\3002<strong>\68D2\306E\30A8\30C3\30B8\5185</strong>\304A\3088\3073<strong>\68D2\306E\30A8\30C3\30B8\5916</strong>\5024\306F\3001'),
unistr('        \6975\4EE5\5916\306E\68D2\30B7\30EA\30FC\30BA\306B\306E\307F\9069\7528\3055\308C\307E\3059\3002\7A4D\4E0A\3052\68D2\306F\3001<strong>\68D2\306E\30A8\30C3\30B8\5916</strong>\3092\30B5\30DD\30FC\30C8\3057\307E\305B\3093\3002<strong>\958B\59CB</strong>\5024\306F\3001\6A2A\3068\7E26\306E\30B9\30C6\30FC\30BF\30B9\30FB\30E1\30FC\30BF\30FC\30FB\30B2\30FC\30B8\30FB\30C1\30E3\30FC\30C8\306B\306E\307F\9069\7528\3055\308C\307E\3059\3002\30C1\30E3\30FC\30C8\3067\306F\73FE\5728\3001\63CF\753B\30A8\30EA\30A2\5185\306B\30E9\30D9\30EB\3092\53CE\3081\305F\308A\3001\30E9\30D9\30EB\9593\306E\91CD\8907\3092\51E6\7406\3059\308B\305F\3081\306B\30EC\30A4\30A2\30A6\30C8\3092\8ABF\6574\3057\307E\305B\3093\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104163785730308578)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\3067\30EC\30F3\30C0\30EA\30F3\30B0\3059\308B\30E9\30D9\30EB\306E\4F4D\7F6E\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104163900421308579)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.ABOVEMARKER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30FC\30AB\30FC\306E\4E0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104164268111308579)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.AFTERMARKER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30FC\30AB\30FC\306E\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104164581922308579)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.AUTO.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104164131854308579)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.BEFOREMARKER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30FC\30AB\30FC\306E\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104164062935308579)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.BELOWMARKER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30FC\30AB\30FC\306E\4E0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104163831418308579)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.CENTER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E2D\592E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104164362551308579)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.INSIDEBAREDGE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\68D2\306E\30A8\30C3\30B8\5185')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104188369455308600)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.NONE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104164459791308579)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.OUTSIDEBAREDGE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\68D2\306E\30A8\30C3\30B8\5916')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104188267267308600)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.OUTSIDESLICE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30E9\30A4\30B9\306E\5916\5074')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103624120007308105)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.START.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104163614515308578)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104163596586308578)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_RENDERED.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB\3092\30C1\30E3\30FC\30C8\3067\30EC\30F3\30C0\30EA\30F3\30B0\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002\3053\306E\8A2D\5B9A\306F\3001\30C0\30A4\30E4\30EB\30FB\30C1\30E3\30FC\30C8\306E\30E1\30C8\30EA\30C3\30AF\5024\306E\53EF\8996\6027\306B\9069\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104163400112308578)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_RENDERED.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104157154775308572)
,p_name=>'PE.PROPERTY.ITEMS_LOW_COLUMN_NAME.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30C1\30E3\30FC\30C8\306E\4E0B\9650\5024\3092\5B9A\7FA9\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\5217\540D\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104157026108308572)
,p_name=>'PE.PROPERTY.ITEMS_LOW_COLUMN_NAME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F4E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104158738039308575)
,p_name=>'PE.PROPERTY.ITEMS_MAX_VALUE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30C1\30E3\30FC\30C8\306E\6700\5927\5024\3092\5B9A\7FA9\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\5217\540D\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104158625368308575)
,p_name=>'PE.PROPERTY.ITEMS_MAX_VALUE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5927\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104260666550308653)
,p_name=>'PE.PROPERTY.ITEMS_MIN_VALUE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30C1\30E3\30FC\30C8\306E\6700\5C0F\5024\3092\5B9A\7FA9\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\5217\540D\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104260534947308653)
,p_name=>'PE.PROPERTY.ITEMS_MIN_VALUE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5C0F\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104157566600308572)
,p_name=>'PE.PROPERTY.ITEMS_OPEN_COLUMN_NAME.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30C1\30E3\30FC\30C8\306E\59CB\5024\3092\5B9A\7FA9\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\5217\540D\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104157493483308572)
,p_name=>'PE.PROPERTY.ITEMS_OPEN_COLUMN_NAME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30FC\30D7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104159572028308575)
,p_name=>'PE.PROPERTY.ITEMS_SHORT_DESC_COLUMN_NAME.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\306E\30C7\30FC\30BF\30FB\30DD\30A4\30F3\30C8\306E\308F\304B\308A\3084\3059\3044\77ED\3044\30AB\30B9\30BF\30E0\30FB\30C4\30FC\30EB\30C1\30C3\30D7\3092\5B9A\7FA9\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\5217\540D\3092\9078\629E\3057\307E\3059\3002\30C1\30E3\30FC\30C8\306E\30C7\30FC\30BF\30FB\30DD\30A4\30F3\30C8\3067\30C4\30FC\30EB\30C1\30C3\30D7\3092\30EC\30F3\30C0\30EA\30F3\30B0\3059\308B\306B\306F\3001\30C1\30E3\30FC\30C8\306E\30C4\30FC\30EB\30C1\30C3\30D7\5C5E\6027<strong>\300C\8868\793A\300D</strong>\304C<strong>\300C\30AA\30F3\300D</strong>\306B\8A2D\5B9A\3055\308C\3066\3044\308B\3053\3068\3092\78BA\8A8D\3057\307E\3059\3002\30DC\30C3\30AF\30B9\30FB\30D7\30ED\30C3\30C8\30FB\30C1\30E3\30FC\30C8\306E\5834\5408\3001\5217\306F\3001\9078\629E\3057\305F\5024\5217\30DE\30C3\30D4\30F3\30B0\3068\4E00\81F4\3057\306A\3044\3088\3046\306B\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\5024\5217\30DE\30C3\30D4\30F3\30B0\3068\4E00\81F4\3059\308B\5217\3092\9078\629E\3059\308B\3068\3001\30AB\30B9\30BF\30E0\30FB\30C4\30FC\30EB\30C1\30C3\30D7\304C\30C1\30E3\30FC\30C8\306B\30EC\30F3\30C0')
||unistr('\30EA\30F3\30B0\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104159452984308575)
,p_name=>'PE.PROPERTY.ITEMS_SHORT_DESC_COLUMN_NAME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30B9\30BF\30E0\30FB\30C4\30FC\30EB\30C1\30C3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104158559965308574)
,p_name=>'PE.PROPERTY.ITEMS_TARGET_VALUE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30C1\30E3\30FC\30C8\306E\30BF\30FC\30B2\30C3\30C8\5024\3092\5B9A\7FA9\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\5217\540D\3092\9078\629E\3057\307E\3059\3002\8A2D\5B9A\3055\308C\308B\5834\5408\3001\5024\5C5E\6027\306F\30B9\30E9\30A4\30B9\5185\306E\5857\308A\3064\3076\3057\9818\57DF\3092\5B9A\7FA9\3057\3001\3053\308C\304C\30B9\30E9\30A4\30B9\5168\4F53\306E\5024\3092\8868\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104158440667308574)
,p_name=>'PE.PROPERTY.ITEMS_TARGET_VALUE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30FC\30B2\30C3\30C8\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104156974132308572)
,p_name=>'PE.PROPERTY.ITEMS_VALUE_COLUMN_NAME.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30C1\30E3\30FC\30C8\306E\5024\3092\5B9A\7FA9\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\5217\540D\3092\9078\629E\3057\307E\3059\3002\30DC\30C3\30AF\30B9\30FB\30D7\30ED\30C3\30C8\30FB\30C1\30E3\30FC\30C8\306E\5834\5408\3001\3053\306E\5217\304C\3001\6570\5024\30C7\30FC\30BF\306E\30B0\30EB\30FC\30D7\306E\6700\5C0F\5024\3001\56DB\5206\4F4D\5024\3001\4E2D\9593\5024\304A\3088\3073\6700\5927\5024\3092\5B9A\7FA9\3059\308B\305F\3081\306B\4F7F\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104156823396308572)
,p_name=>'PE.PROPERTY.ITEMS_VALUE_COLUMN_NAME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104157944545308574)
,p_name=>'PE.PROPERTY.ITEMS_VOLUME_COLUMN_NAME.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30C1\30E3\30FC\30C8\306E\51FA\6765\9AD8\5024\3092\5B9A\7FA9\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\5217\540D\3092\9078\629E\3057\307E\3059\3002\5024\304C\6307\5B9A\3055\308C\308B\3068\3001\51FA\6765\9AD8\304Cy2\8EF8\306B\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104157840599308574)
,p_name=>'PE.PROPERTY.ITEMS_VOLUME_COLUMN_NAME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\51FA\6765\9AD8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104158146815308574)
,p_name=>'PE.PROPERTY.ITEMS_X_COLUMN_NAME.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30C1\30E3\30FC\30C8\306Ex\5024\3092\5B9A\7FA9\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\5217\540D\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104158046685308574)
,p_name=>'PE.PROPERTY.ITEMS_X_COLUMN_NAME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>'X'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104158312823308574)
,p_name=>'PE.PROPERTY.ITEMS_Y_COLUMN_NAME.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30C1\30E3\30FC\30C8\306Ey\5024\3092\5B9A\7FA9\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\5217\540D\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104158277743308574)
,p_name=>'PE.PROPERTY.ITEMS_Y_COLUMN_NAME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\306F\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104155715710308571)
,p_name=>'PE.PROPERTY.ITEMS_Z_COLUMN_NAME.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30C1\30E3\30FC\30C8\306Ez\5024\3092\5B9A\7FA9\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\5217\540D\3092\9078\629E\3057\307E\3059\3002z\5024\306F\3001\30D0\30D6\30EB\30FB\30C1\30E3\30FC\30C8\306E\30D0\30D6\30EB\306E\534A\5F84\3001\30DC\30C3\30AF\30B9\30FB\30D7\30ED\30C3\30C8\30FB\30A2\30A4\30C6\30E0\306E\5E45\3001\304A\3088\3073\68D2\30B0\30E9\30D5\307E\305F\306F\7D44\5408\305B\30C1\30E3\30FC\30C8\306E\68D2\306E\5E45\3092\5B9A\7FA9\3057\307E\3059\3002 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104155617216308571)
,p_name=>'PE.PROPERTY.ITEMS_Z_COLUMN_NAME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>'Z'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103967227537308411)
,p_name=>'PE.PROPERTY.ITEM_DISPLAY_POSITION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\30FB\30B3\30F3\30DD\30FC\30CD\30F3\30C8(\30B5\30D6\30FB\30EA\30FC\30B8\30E7\30F3\3001\30A2\30A4\30C6\30E0\3001\30DC\30BF\30F3)\3092\3001\30E1\30A4\30F3\30FB\30EA\30FC\30B8\30E7\30F3\30FB\30B3\30F3\30C6\30F3\30C4\306E\4E0A\307E\305F\306F\4E0B\306E\3044\305A\308C\306B\8868\793A\3059\308B\304B\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104399424722308757)
,p_name=>'PE.PROPERTY.ITEM_DISPLAY_POSITION.LOV.ABOVE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30C6\30F3\30C4\306E\4E0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104399533429308757)
,p_name=>'PE.PROPERTY.ITEM_DISPLAY_POSITION.LOV.BELOW.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30C6\30F3\30C4\306E\4E0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103967144447308411)
,p_name=>'PE.PROPERTY.ITEM_DISPLAY_POSITION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306E\30EC\30F3\30C0\30EA\30F3\30B0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103901800060308328)
,p_name=>'PE.PROPERTY.ITEM_NAME.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30A4\30C6\30E0\306E\540D\524D\3092\5165\529B\3057\307E\3059\3002\30A2\30A4\30C6\30E0\540D\306F\3001\6709\52B9\306AOracle\8B58\5225\5B50\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\30A2\30A4\30C6\30E0\540D\306F\300130\30D0\30A4\30C8\4EE5\4E0B\306B\3057\3066\3001SQL\554F\5408\305B\306E\30D0\30A4\30F3\30C9\5909\6570\3068\3057\3066\4F7F\7528\3067\304D\308B\3088\3046\306B\3059\308B\3053\3068\3092\304A\85A6\3081\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103901772861308328)
,p_name=>'PE.PROPERTY.ITEM_NAME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\540D\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104113108956308527)
,p_name=>'PE.PROPERTY.ITEM_TYPE.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\5217\306E\30EC\30F3\30C0\30EA\30F3\30B0\65B9\6CD5\3092\9078\629E\3057\307E\3059\3002\6B21\306E\5217\30BF\30A4\30D7\304C\30B5\30DD\30FC\30C8\3055\308C\3066\3044\307E\3059:</p>'),
'#NATIVE_PLUGINS#',
unistr('<p>\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\69CB\6210\306B\3088\3063\3066\306F\3001\305D\306E\4ED6\306E\5217\30BF\30A4\30D7\30FB\30D7\30E9\30B0\30A4\30F3\3082\3053\3053\3067\4F7F\7528\53EF\80FD\306A\5834\5408\304C\3042\308A\307E\3059\3002'),
unistr('\3053\308C\3089\306F\3001<em>&lt;My Plug-in&gt; [Plug-in]</em>\3068\8868\793A\3055\308C\307E\3059\3002'),
unistr('\6B21\306E\30D7\30E9\30B0\30A4\30F3\304C\3001\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8\5185\306B\30A4\30F3\30B9\30C8\30FC\30EB\3055\308C\307E\3059:</p>'),
'#CUSTOM_PLUGINS#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103901466580308328)
,p_name=>'PE.PROPERTY.ITEM_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30A2\30A4\30C6\30E0\306E\30EC\30F3\30C0\30EA\30F3\30B0\65B9\6CD5\3092\6307\5B9A\3057\307E\3059\3002\6B21\306E\30A2\30A4\30C6\30E0\30FB\30BF\30A4\30D7\304C\30B5\30DD\30FC\30C8\3055\308C\3066\3044\307E\3059:</p>'),
'#NATIVE_PLUGINS#',
unistr('<p>\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\69CB\6210\306B\3088\3063\3066\306F\3001\305D\306E\4ED6\306E\30A2\30A4\30C6\30E0\30FB\30BF\30A4\30D7\30FB\30D7\30E9\30B0\30A4\30F3\3082\3053\3053\3067\4F7F\7528\53EF\80FD\306A\5834\5408\304C\3042\308A\307E\3059\3002'),
unistr('\3053\308C\3089\306F\3001<em>&lt;My Plug-in&gt; [Plug-in]</em>\3068\8868\793A\3055\308C\307E\3059\3002'),
unistr('\6B21\306E\30D7\30E9\30B0\30A4\30F3\304C\3001\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8\5185\306B\30A4\30F3\30B9\30C8\30FC\30EB\3055\308C\307E\3059:</p>'),
'#CUSTOM_PLUGINS#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103901341504308328)
,p_name=>'PE.PROPERTY.ITEM_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104560896359308887)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306E\30C7\30D5\30A9\30EB\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104581920660308904)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\4FDD\5B58\3055\308C\3066\3044\306A\3044\5909\66F4\306E\30C1\30A7\30C3\30AF\306B\30A2\30A4\30C6\30E0\3092\542B\3081\307E\3059(\30C1\30A7\30C3\30AF\304C\30DA\30FC\30B8\30FB\30EC\30D9\30EB\3067\6709\52B9\5316\3055\308C\3066\3044\308B\5834\5408)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104560346369308887)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3092\3001\4FDD\5B58\3055\308C\3066\3044\306A\3044\5909\66F4\306E\30C1\30A7\30C3\30AF(\30DA\30FC\30B8\306B\4FDD\5B58\3055\308C\3066\3044\306A\3044\5909\66F4\304C\542B\307E\308C\308B\5834\5408\306B\305D\306E\30DA\30FC\30B8\304B\3089\79FB\52D5\3057\3088\3046\3068\3057\305F\3068\304D\306B\3001\30E6\30FC\30B6\30FC\306B\8B66\544A\3092\8868\793A\3057\307E\3059)\306B\542B\3081\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002\4E00\90E8\306E\30A2\30A4\30C6\30E0\306F\3001\30C1\30A7\30C3\30AF\3059\308B\5FC5\8981\304C\306A\3044\305F\3081\3001\7121\8996\3059\308B\3088\3046\306B\8A2D\5B9A\3067\304D\307E\3059(\305F\3068\3048\3070\3001\30C7\30FC\30BF\30D9\30FC\30B9\5217\306B\57FA\3065\304B\306A\3044\691C\7D22\30A2\30A4\30C6\30E0\306A\3069)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104560434966308887)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.LOV.I.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\8996')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104563230751308889)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.LOV.I.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306E\5909\66F4\306F\3001\4FDD\5B58\3055\308C\3066\3044\306A\3044\5909\66F4\306E\30C1\30A7\30C3\30AF\3067\7121\8996\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104560228074308887)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4FDD\5B58\3055\308C\3066\3044\306A\3044\5909\66F4\306E\8B66\544A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104705126921309004)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.COMPONENT_PROPERTY.IG_ATTRIBUTES.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function( options ) {',
'    options.toolbar = false;',
'    return options;',
'}',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104123671221308536)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5BFE\8A71\30B0\30EA\30C3\30C9\306E\69CB\6210\30AA\30D6\30B8\30A7\30AF\30C8\3092\53D6\5F97\3057\3001\30AA\30D6\30B8\30A7\30AF\30C8\3092\5909\66F4\3057\3066\305D\308C\3092\8FD4\3059JavaScript\95A2\6570\3092\5165\529B\3057\307E\3059\3002\3053\308C\306B\3088\308A\3001\5BFE\8A71\30B0\30EA\30C3\30C9\306E\5916\89B3\3001\6A5F\80FD\304A\3088\3073\52D5\4F5C(\30C4\30FC\30EB\30D0\30FC\3001\30E1\30CB\30E5\30FC\304A\3088\3073\30A2\30AF\30B7\30E7\30F3\3092\542B\3080)\306E\8A73\7D30\306A\30AB\30B9\30BF\30DE\30A4\30BA\304C\53EF\80FD\306B\306A\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104705207657309004)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.COMPONENT_PROPERTY.IG_COLUMN.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function( options ) {',
'    options.features = options.features || {};',
'    options.features.sort = false;',
'    return options;',
'}',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104259993440308653)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\306E\69CB\6210\30AA\30D6\30B8\30A7\30AF\30C8\3092\53D6\5F97\3057\3001\30AA\30D6\30B8\30A7\30AF\30C8\3092\5909\66F4\3057\3066\305D\308C\3092\8FD4\3059JavaScript\95A2\6570\3092\5165\529B\3057\307E\3059\3002\3053\308C\306B\3088\308A\3001\5217\306E\5916\89B3\3001\6A5F\80FD\304A\3088\3073\52D5\4F5C\306E\8A73\7D30\306A\30AB\30B9\30BF\30DE\30A4\30BA\304C\53EF\80FD\306B\306A\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104705371991309004)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.COMPONENT_PROPERTY.JET_CHART.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function( options ){',
unistr('    // \30C7\30FC\30BF\306E\53D6\5F97\6642\306B\30B3\30FC\30EB\3055\308C\308B\30B3\30FC\30EB\30D0\30C3\30AF\95A2\6570\3092\8A2D\5B9A\3057\3001\30B7\30EA\30FC\30BA\3092\64CD\4F5C\3067\304D\308B\3088\3046\306B\3057\307E\3059'),
'    options.dataFilter = function( data ) {',
'        data.series[ 0 ].color = "#00FF00";',
'        return data;',
'    };',
unistr('    // \30C1\30E3\30FC\30C8\521D\671F\5316\30AA\30D7\30B7\30E7\30F3\3092\8A2D\5B9A\3057\307E\3059'),
'    options.type = "line";',
'    return options;',
'}</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104169389053308583)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\30C1\30E3\30FC\30C8\3092\30AB\30B9\30BF\30DE\30A4\30BA\3059\308BJavaScript\30B3\30FC\30C9\3092\5165\529B\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104705974188309005)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function( options ) {',
'  options.advancedOption = true;',
'  return options;',
'}',
'</pre>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104103683697308519)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306E\69CB\6210\30AA\30D6\30B8\30A7\30AF\30C8\3092\53D6\5F97\3057\3001\30AA\30D6\30B8\30A7\30AF\30C8\3092\5909\66F4\3057\3066\305D\308C\3092\8FD4\3059JavaScript\95A2\6570\3092\5165\529B\3057\307E\3059\3002\3053\308C\306B\3088\308A\3001\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306E\5916\89B3\3001\6A5F\80FD\304A\3088\3073\52D5\4F5C\306E\8A73\7D30\306A\30AB\30B9\30BF\30DE\30A4\30BA\304C\53EF\80FD\306B\306A\308A\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104103573591308519)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('JavaScript\521D\671F\5316\30B3\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104474652353308813)
,p_name=>'PE.PROPERTY.JET_AXIS_POSITION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\306E\4E3B\8EF8\304A\3088\3073\526F\8EF8\306E\4F4D\7F6E\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104475314884308813)
,p_name=>'PE.PROPERTY.JET_AXIS_POSITION.LOV.BOTTOM.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104475255138308813)
,p_name=>'PE.PROPERTY.JET_AXIS_POSITION.LOV.TOP.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C8\30C3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104474567839308813)
,p_name=>'PE.PROPERTY.JET_AXIS_POSITION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8EF8\306E\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104478144004308815)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\306E\8EF8\306B\4F7F\7528\3059\308B\30BF\30A4\30E0\30FB\30B9\30B1\30FC\30EB\3092\6307\5B9A\3057\307E\3059\3002\3053\308C\306F\3001\30AC\30F3\30C8\3092\6B63\3057\304F\30EC\30F3\30C0\30EA\30F3\30B0\3059\308B\305F\3081\306B\5FC5\8981\3067\3059\3002\300C\30BA\30FC\30E0\30FB\30B9\30B1\30FC\30EB\300D\30AA\30D7\30B7\30E7\30F3\304C\9078\629E\3055\308C\3066\3044\306A\3044\5834\5408\3001\9078\629E\3057\305F\30BF\30A4\30E0\30FB\30B9\30B1\30FC\30EB\304C\30BA\30FC\30E0\306B\4F7F\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104476282155308814)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.DAYS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104476121335308814)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.HOURS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104475814973308814)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.MINUTES.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5206')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104476697428308814)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.MONTHS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6708')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104476819822308814)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.QUARTERS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\56DB\534A\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104475785554308813)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.SECONDS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\79D2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104476487080308814)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.WEEKS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\9031')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104477016288308814)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.YEARS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5E74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104478053414308815)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30B1\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104144301992308553)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\30FB\30BF\30A4\30D7\3092\9078\629E\3057\307E\3059\3002\30C1\30E3\30FC\30C8\30FB\30BF\30A4\30D7\3067\306F\3001\30C1\30E3\30FC\30C8\3092\30EC\30F3\30C0\30EA\30F3\30B0\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\8996\899A\5316\3092\6C7A\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104144489055308553)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.AREA.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104285124193308671)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.AREA.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9762\30B0\30E9\30D5\306F\3001\58F2\4E0A\50BE\5411\306E\5185\8A33\306A\3069\306E\4E00\5B9A\671F\9593\306B\308F\305F\308B\7D2F\7A4D\5024\306E\50BE\5411\3092\6BD4\8F03\3059\308B\5834\5408\306B\4FBF\5229\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104144561136308553)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BAR.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\68D2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104285297189308671)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BAR.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\68D2\30B0\30E9\30D5\306F\3001\30AB\30C6\30B4\30EA\3054\3068\307E\305F\306F\4E00\5B9A\671F\9593\306E\5024\3092\6BD4\8F03\3059\308B\5834\5408\306B\4FBF\5229\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104066093861308488)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BOXPLOT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30C3\30AF\30B9\30FB\30D7\30ED\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104066129407308488)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BOXPLOT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30C3\30AF\30B9\30FB\30D7\30ED\30C3\30C8\30FB\30C1\30E3\30FC\30C8\306B\306F\3001\6570\5024\30C7\30FC\30BF\306E\30B0\30EB\30FC\30D7\306E\6700\5C0F\5024\3001\56DB\5206\4F4D\5024\3001\4E2D\9593\5024\304A\3088\3073\6700\5927\5024\304C\8868\793A\3055\308C\3001\30C7\30FC\30BF\306E\5206\5E03\3092\5206\6790\3059\308B\5834\5408\306B\6709\7528\3067\3059\3002\30DC\30C3\30AF\30B9\30FB\30D7\30ED\30C3\30C8\306F\7BB1\3072\3052\56F3\3068\3082\547C\3070\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104144647770308553)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BUBBLE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D0\30D6\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104285343205308671)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BUBBLE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D0\30D6\30EB\30FB\30C1\30E3\30FC\30C8\306F\3001x\3001y\304A\3088\3073z\5024\3092\4F7F\7528\3057\3066\30C7\30FC\30BF\30FB\30A2\30A4\30C6\30E0\3092\5B9A\7FA9\3057\30013\6B21\5143\9593\306E\95A2\4FC2\3092\8868\793A\3059\308B\5834\5408\306B\4FBF\5229\3067\3059\30023\6B21\5143\306F\3001\30D0\30D6\30EB\306E\30B5\30A4\30BA\3067\8868\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104144777807308554)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.COMBO.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D44\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104285490687308671)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.COMBO.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D44\5408\305B\30C1\30E3\30FC\30C8\306F\3001\68D2\3001\6298\308C\7DDA\304A\3088\3073\9762\306E\7CFB\5217\3092\540C\3058\30C1\30E3\30FC\30C8\3067\8868\793A\3067\304D\307E\3059\3002\6700\3082\4E00\822C\7684\306A\30E6\30FC\30B9\30B1\30FC\30B9\306F\3001\68D2\4ED8\304D\306E\6298\308C\7DDA\307E\305F\306F\7A4D\4E0A\3052\68D2\4ED8\304D\306E\6298\308C\7DDA\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104144872103308554)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.DIAL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30C6\30FC\30BF\30B9\30FB\30E1\30FC\30BF\30FC\30FB\30B2\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104285513170308671)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.DIAL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30C6\30FC\30BF\30B9\30FB\30E1\30FC\30BF\30FC\30FB\30B2\30FC\30B8\3092\4F7F\7528\3057\3066\3001\5BFE\8C61\30E1\30C8\30EA\30C3\30AF\306B\4F7F\7528\53EF\80FD\306A\6700\5C0F\5024\304A\3088\3073\6700\5927\5024\306B\95A2\3059\308B\30E1\30C8\30EA\30C3\30AF\5024\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104179927978308593)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.DONUT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C9\30FC\30CA\30C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104285666066308671)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.DONUT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C9\30FC\30CA\30C4\30FB\30B0\30E9\30D5\306F\3001\4E2D\592E\306B\7A74\304C\3042\308B\5186\30B0\30E9\30D5\3067\3059\3002\5168\4F53\306B\5BFE\3059\308B\5404\90E8\5206\3092\8996\899A\5316\3059\308B\5834\5408\306B\4FBF\5229\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104144983827308554)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.FUNNEL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30F3\30CD\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104285728474308671)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.FUNNEL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30F3\30CD\30EB\30FB\30C1\30E3\30FC\30C8\306F\3001\8CA9\58F2\30D7\30ED\30BB\30B9\306E\30B9\30C6\30FC\30B8\306A\3069\306E\30D7\30ED\30BB\30B9\306E\30B9\30C6\30FC\30B8\306B\5BFE\3059\308B\30C7\30FC\30BF\3092\8868\793A\3059\308B\5834\5408\306B\4FBF\5229\3067\3059\3002\30D5\30A1\30F3\30CD\30EB\30FB\30B9\30E9\30A4\30B9\306E\9818\57DF\306F\3001\5BFE\5FDC\3059\308B\30B9\30C6\30FC\30B8\306E\5024\306B\6BD4\4F8B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104475066249308813)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.GANTT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AC\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104475166807308813)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.GANTT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AC\30F3\30C8\30FB\30C1\30E3\30FC\30C8\306F\3001\30D7\30ED\30B8\30A7\30AF\30C8\30FB\30B9\30B1\30B8\30E5\30FC\30EB\3092\8868\793A\3001\304A\3088\3073\30BF\30B9\30AF\306E\958B\59CB\65E5\3068\7D42\4E86\65E5\3092\793A\3059\30D0\30FC\3092\8868\793A\3059\308B\5834\5408\306B\4FBF\5229\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104145035351308554)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.LINE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6298\308C\7DDA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104285842794308672)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.LINE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\6298\308C\7DDA\30B0\30E9\30D5\306F\3001\4E00\5B9A\671F\9593\306B\308F\305F\308B\4E00\9023\306E\5024\306E\50BE\5411\3092\8996\899A\5316\3057\305F\308A\3001\7CFB\5217\3054\3068\306B\3053\308C\3089\306E\5024\3092\6BD4\8F03\3059\308B\5834\5408\306B\4FBF\5229\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104145184099308554)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.LINEWITHAREA.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\9762\4ED8\304D\6298\308C\7DDA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104285956236308672)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.LINEWITHAREA.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9762\4ED8\304D\6298\308C\7DDA\30B0\30E9\30D5\306F\3001\5404\7DDA\306E\4E0B\306E\9762\304C\5857\308A\3064\3076\3055\308C\305F\6298\308C\7DDA\30B0\30E9\30D5\3068\540C\3058\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104145291384308554)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.PIE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5186')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104286044832308672)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.PIE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5186\30B0\30E9\30D5\306F\3001\5168\4F53\306B\5BFE\3059\308B\5404\90E8\5206\3092\8996\899A\5316\3059\308B\5834\5408\306B\4FBF\5229\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104179625613308592)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.POLAR.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6975')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104286181155308672)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.POLAR.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\6975\30C1\30E3\30FC\30C8\306B\306F\3001\653E\5C04\72B6\306Ey\8EF8\304A\3088\3073\63A5\7DDA\306Ex\8EF8\304C\3042\308A\307E\3059\3002\6975\30C1\30E3\30FC\30C8\306F\3001\68D2\30B0\30E9\30D5\3001\6298\308C\7DDA\30B0\30E9\30D5\3001\9762\30B0\30E9\30D5\3001\7D44\5408\305B\30C1\30E3\30FC\30C8\3001\6563\5E03\56F3\307E\305F\306F\30D0\30D6\30EB\30FB\30C1\30E3\30FC\30C8\30FB\30B7\30EA\30FC\30BA\30FB\30BF\30A4\30D7\3068\3057\3066\30EC\30F3\30C0\30EA\30F3\30B0\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103978680318308419)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.PYRAMID.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D4\30E9\30DF\30C3\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103978728581308419)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.PYRAMID.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D4\30E9\30DF\30C3\30C9\30FB\30C1\30E3\30FC\30C8\306F\3001\968E\5C64\7684\3067\6BD4\4F8B\7684\306A\57FA\76E4\306B\57FA\3065\304F\95A2\4FC2\3001\30D7\30ED\30BB\30B9\306E\624B\9806\3001\7D44\7E54\30EC\30A4\30E4\30FC\3001\307E\305F\306F\30C8\30D4\30C3\30AF\306E\76F8\4E92\63A5\7D9A\3092\8868\793A\3059\308B\5834\5408\306B\4FBF\5229\3067\3059\3002\30D4\30E9\30DF\30C3\30C9\30FB\30B9\30E9\30A4\30B9\306E\9818\57DF\306F\3001\5BFE\5FDC\3059\308B\30B9\30C6\30FC\30B8\3067\306E\305D\306E\5024\306B\6BD4\4F8B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104179754228308592)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.RADAR.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30FC\30C0\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104286238893308672)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.RADAR.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30FC\30C0\30FC\30FB\30C1\30E3\30FC\30C8\306F\3001\5186\5468\3067\306F\306A\304F\6B63\591A\89D2\5F62\30B0\30EA\30C3\30C9\306E\5F62\72B6\3092\4F7F\7528\3057\305F\6975\30C1\30E3\30FC\30C8\3067\3059\3002\6298\308C\7DDA\304A\3088\3073\9762\30B0\30E9\30D5\30FB\30B7\30EA\30FC\30BA\30FB\30BF\30A4\30D7\3067\30B5\30DD\30FC\30C8\3055\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104179863840308593)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.RANGE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\7BC4\56F2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104286377601308672)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.RANGE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30F3\30B8\30FB\30C1\30E3\30FC\30C8\306F\3001\68D2\307E\305F\306F\9762\306E\3044\305A\308C\304B\3092\4F7F\7528\3057\3066\5404\30A8\30F3\30C8\30EA\306E\6700\5927\5024\304A\3088\3073\6700\5C0F\5024(\4E0A\9650/\4E0B\9650)\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104145382997308554)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.SCATTER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6563\5E03')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104286468410308672)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.SCATTER.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\6563\5E03\56F3\306F\3001x\304A\3088\3073y\5024\3092\4F7F\7528\3057\3066\30C7\30FC\30BF\30FB\30A2\30A4\30C6\30E0\3092\5B9A\7FA9\3057\30012\6B21\5143\9593\306E\95A2\4FC2\3092\8868\793A\3059\308B\5834\5408\306B\4FBF\5229\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104145424741308554)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.STOCK.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\682A\4FA1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104286546757308672)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.STOCK.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\682A\4FA1\30C1\30E3\30FC\30C8\306F\3001\6642\9593\8EF8\3067\682A\4FA1\306E\60C5\5831\3092\8868\793A\3059\308B\5834\5408\306B\4FBF\5229\3067\3059\3002\682A\4FA1\30C1\30E3\30FC\30C8\306E\30E6\30CB\30FC\30AF\306A\70B9\306F\3001\682A\4FA1\306E\59CB\5024\3001\7D42\5024\3001\9AD8\5024\3001\5B89\5024\3092\8868\793A\3067\304D\308B\30ED\30FC\30BD\30AF\8DB3\306E<strong>\5225\540D\3067\682A\4FA1\3092\30EC\30F3\30C0\30EA\30F3\30B0</strong>\30FB\30D7\30ED\30D1\30C6\30A3\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104144293481308553)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104083021679308502)
,p_name=>'PE.PROPERTY.JET_CONNECT_NULLS.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30DE\30EB\30C1\30B7\30EA\30FC\30BA\30FB\30C1\30E3\30FC\30C8\30FB\30C7\30FC\30BF\306E\30AE\30E3\30C3\30D7\3092\30BC\30ED\306E\5024\307E\305F\306Fnull\306E\3069\3061\3089\306B\8A2D\5B9A\3059\308B\304B\3092\6307\5B9A\3057\307E\3059\3002</p>'),
unistr('        <p><strong>\300C\30AA\30F3\300D</strong>\306B\8A2D\5B9A\3059\308B\3068\3001\30C7\30FC\30BF\306E\30AE\30E3\30C3\30D7\306F\30BC\30ED\3068\3057\3066\51E6\7406\3055\308C\307E\3059\3002\6298\308C\7DDA\30B0\30E9\30D5\3067\306F\3001\3053\308C\306B\3088\308A\3001\7DDA\306F\5E38\306B\5B9F\7DDA\3068\3057\3066\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\307E\3059\3002\7A4D\4E0A\3052\30E9\30D9\30EB\304C\300C\30AA\30F3\300D\306B\8A2D\5B9A\3055\308C\305F\7A4D\4E0A\3052\68D2\30B0\30E9\30D5\3067\306F\3001\3053\308C\306B\3088\308A\3001\7A4D\4E0A\3052\30E9\30D9\30EB\306F\5E38\306B\7A4D\4E0A\3052\3054\3068\306B\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\307E\3059\3002</p>'),
unistr('        <p><strong>\300C\30AA\30D5\300D</strong>\306B\8A2D\5B9A\3059\308B\3068\3001\30C7\30FC\30BF\306E\30AE\30E3\30C3\30D7\306Fnull\3068\3057\3066\51E6\7406\3055\308C\307E\3059\3002\6298\308C\7DDA\30B0\30E9\30D5\3067\306F\3001\7DDA\306F\7834\7DDA\3068\3057\3066\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\3001\30AE\30E3\30C3\30D7\306Fnull\30C7\30FC\30BF\30FB\30DD\30A4\30F3\30C8\3092\8868\3057\307E\3059\3002<p>'),
unistr('        <p>\3053\306E\8A2D\5B9A\306F\3001\68D2\304A\3088\3073\7DDA\3068\3057\3066\306E\30EC\30F3\30C0\30EA\30F3\30B0\3092\30B5\30DD\30FC\30C8\3059\308B\30DE\30EB\30C1\30B7\30EA\30FC\30BA\30FB\30C1\30E3\30FC\30C8\30FB\30BF\30A4\30D7(\68D2\30B0\30E9\30D5\3001\6298\308C\7DDA\30B0\30E9\30D5\3001\9762\4ED8\304D\6298\308C\7DDA\30B0\30E9\30D5\3001\7D44\5408\305B\30C1\30E3\30FC\30C8\3001\9762\30B0\30E9\30D5\3001\6975\30C1\30E3\30FC\30C8\3001\30EC\30FC\30C0\30FC\30FB\30C1\30E3\30FC\30C8\3001\6563\5E03\56F3\306A\3069)\306B\9069\7528\3055\308C\307E\3059\3002\30C7\30D5\30A9\30EB\30C8\306F<strong>\300C\30AA\30F3\300D</strong>\3067\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104082957965308502)
,p_name=>'PE.PROPERTY.JET_CONNECT_NULLS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AE\30E3\30C3\30D7\3092\30BC\30ED\3068\3057\3066\30EC\30F3\30C0\30EA\30F3\30B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104147372331308556)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30C7\30FC\30BF\30FB\30AB\30FC\30BD\30EB\3092\30C1\30E3\30FC\30C8\3067\6709\52B9\306B\3059\308B\304B\3069\3046\304B\3092\9078\629E\3057\307E\3059\3002'),
unistr('        \30C7\30FC\30BF\30FB\30AB\30FC\30BD\30EB\306F\3001\7279\306B\30BF\30C3\30C1\30FB\30C7\30D0\30A4\30B9\3067\30C7\30FC\30BF\30FB\30A2\30A4\30C6\30E0\306E\30CA\30D3\30B2\30FC\30C8\304C\96E3\3057\3044\5834\5408\306E\30C4\30FC\30EB\30C1\30C3\30D7\306E\304B\308F\308A\3068\3057\3066\4FBF\5229\3067\3059\3002<p/>'),
unistr('        <p><strong>\300C\81EA\52D5\300D</strong>\306B\8A2D\5B9A\3055\308C\3066\3044\308B\5834\5408\3001\30C7\30FC\30BF\30FB\30AB\30FC\30BD\30EB\306F\3001\30BF\30C3\30C1\30FB\30C7\30D0\30A4\30B9\3067\6298\308C\7DDA\307E\305F\306F\9762\30B0\30E9\30D5\306B\306E\307F\8868\793A\3055\308C\307E\3059\3002<p/>'),
unistr('        <p>\30CE\30FC\30C8 - \30C4\30FC\30EB\30C1\30C3\30D7\304Cnull\3067\3042\308B\5834\5408\3001\30C7\30FC\30BF\30FB\30AB\30FC\30BD\30EB\306F\8868\793A\3055\308C\307E\305B\3093\3002\6975\30C1\30E3\30FC\30C8\3067\306F\30B5\30DD\30FC\30C8\3055\308C\3066\3044\307E\305B\3093\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104147495807308565)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.AUTO.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104286940998308672)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.AUTO.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\306EOracle JET\5B9A\7FA9\6E08\30C7\30D5\30A9\30EB\30C8\30FB\30C7\30FC\30BF\30FB\30AB\30FC\30BD\30EB\8868\793A\3092\9069\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104147600773308565)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.OFF.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\3044\3044\3048')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104287102545308672)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.OFF.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30AB\30FC\30BD\30EB\304C\8868\793A\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104147559096308565)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.ON.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\306F\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104287042767308672)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.ON.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30AB\30FC\30BD\30EB\304C\5E38\306B\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104147224206308556)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30FC\30BD\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104147862680308565)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\306E\30C7\30FC\30BF\30FB\30AB\30FC\30BD\30EB\306E\52D5\4F5C\3092\9078\629E\3057\307E\3059\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104147914581308565)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.AUTO.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104277403532308666)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.AUTO.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\306EOracle JET\5B9A\7FA9\6E08\30C7\30D5\30A9\30EB\30C8\30FB\30C7\30FC\30BF\30FB\30AB\30FC\30BD\30EB\52D5\4F5C\3092\9069\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104148051578308565)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.SMOOTH.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\306A\3081\3089\304B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104287221463308673)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.SMOOTH.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30C7\30FC\30BF\30FB\30AB\30FC\30BD\30EB\306F\3001\6ED1\3089\304B\306A\30DE\30A6\30B9/\30BF\30C3\30C1\52D5\4F5C\306B\5F93\3044\307E\3059\3002\30C7\30FC\30BF\30FB\30AB\30FC\30BD\30EB\3092\7279\5B9A\306E\30C7\30FC\30BF\30FB\30DD\30A4\30F3\30C8\3060\3051\3067\306F\306A\304F\30C7\30FC\30BF\8981\7D20\306E\4E00\90E8\306E\4E0A\306B\5408\305B\308B\3068\5E38\306B\30C4\30FC\30EB\30C1\30C3\30D7\304C\8868\793A\3055\308C\307E\3059\3002\30A4\30F3\30B8\30B1\30FC\30BF\306F\3001\73FE\5728\9078\629E\3055\308C\3066\3044\308B\30C7\30FC\30BF\8981\7D20\3092\8B58\5225\3057\307E\3059\3002</p>'),
unistr('        <p>\30CE\30FC\30C8 - \3053\306E\8996\899A\5316\3092\5B8C\5168\306B\5B9F\73FE\3059\308B\306B\306F\3001<strong>\300C\30AB\30FC\30BD\30EB\300D</strong>\3092<strong>\300C\306F\3044\300D</strong>\306B\8A2D\5B9A\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104148160229308565)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.SNAP.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30CA\30C3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104287391056308673)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.SNAP.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30DE\30A6\30B9/\30BF\30C3\30C1\52D5\4F5C\304C\30C1\30E3\30FC\30C8\4E0A\3067\767A\751F\3059\308B\3068\3001\30C7\30FC\30BF\30FB\30AB\30FC\30BD\30EB\304C\30C7\30FC\30BF\8981\7D20\306B\30B9\30CA\30C3\30D7(\30B8\30E3\30F3\30D7)\3057\3001\30C7\30FC\30BF\30FB\30AB\30FC\30BD\30EB\3092\30C7\30FC\30BF\8981\7D20\306E\4E0A\306B\5408\305B\308B\3068\5E38\306B\30C4\30FC\30EB\30C1\30C3\30D7\304C\8868\793A\3055\308C\307E\3059\3002\30A4\30F3\30B8\30B1\30FC\30BF\306F\3001\73FE\5728\9078\629E\3055\308C\3066\3044\308B\30C7\30FC\30BF\8981\7D20\3092\8B58\5225\3057\307E\3059\3002</p>'),
unistr('        <p>\30CE\30FC\30C8 - \3053\306E\8996\899A\5316\3092\5B8C\5168\306B\5B9F\73FE\3059\308B\306B\306F\3001<strong>\300C\30AB\30FC\30BD\30EB\300D</strong>\3092<strong>\300C\306F\3044\300D</strong>\306B\8A2D\5B9A\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104147724063308565)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\52D5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103997683523308434)
,p_name=>'PE.PROPERTY.JET_FILL_GAPS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30EB\30C1\30B7\30EA\30FC\30BA\30FB\30C1\30E3\30FC\30C8\30FB\30C7\30FC\30BF\306E\30AE\30E3\30C3\30D7\3092\81EA\52D5\7684\306B\57CB\3081\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002\3053\306E\8A2D\5B9A\306F\3001\5358\4E00\30B7\30EA\30FC\30BA\30FB\30C1\30E3\30FC\30C8\307E\305F\306F\6B21\306E\30C1\30E3\30FC\30C8\30FB\30BF\30A4\30D7\306B\306F\9069\7528\3055\308C\307E\305B\3093: \30D0\30D6\30EB\3001\30C9\30FC\30CA\30C4\3001\30D5\30A1\30F3\30CD\30EB\3001\30AC\30F3\30C8\3001\5186\3001\30D4\30E9\30DF\30C3\30C9\3001\6563\5E03\304A\3088\3073\682A\4FA1\3002<strong>\300C\30AA\30F3\300D</strong>\306B\8A2D\5B9A\3059\308B\3068\3001Oracle Application Express 5.1.3\3067\5C0E\5165\3055\308C\305F\30C7\30FC\30BF\9AD8\5BC6\5EA6\5316\30ED\30B8\30C3\30AF\304C\30C1\30E3\30FC\30C8\30FB\30C7\30FC\30BF\306B\9069\7528\3055\308C\307E\3059\3002<strong>\300C\30AA\30D5\300D</strong>\306B\8A2D\5B9A\3059\308B\3068\3001\30C7\30FC\30BF\306E\30AE\30E3\30C3\30D7\306F\57CB\307E\3089')
||unistr('\305A\3001\30C1\30E3\30FC\30C8\306E\30EC\30F3\30C0\30EA\30F3\30B0\304C\4E0D\6B63\78BA\306B\306A\308B\3053\3068\304C\3042\308A\307E\3059\3002\30C7\30D5\30A9\30EB\30C8\306F<strong>\300C\30AA\30F3\300D</strong>\3067\3059\3002  ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103997507672308433)
,p_name=>'PE.PROPERTY.JET_FILL_GAPS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\30FB\30C7\30FC\30BF\306E\30AE\30E3\30C3\30D7\3092\57CB\3081\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104711537502309010)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_CSS_CLASS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\30AC\30F3\30C8\30FB\30C1\30E3\30FC\30C8\306E\30D9\30FC\30B9\30E9\30A4\30F3\30FB\30D0\30FC\306B\9069\7528\3055\308C\308BCSS\30AF\30E9\30B9\3092\5165\529B\3057\307E\3059\3002\8907\6570\306E\30AF\30E9\30B9\306F\7A7A\767D\3067\533A\5207\3063\3066\8FFD\52A0\3067\304D\307E\3059\3002<code>&COLUMN_VALUE.</code>\7F6E\63DB\3092\4F7F\7528\3067\304D\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104711496180309009)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_CSS_CLASS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D9\30FC\30B9\30E9\30A4\30F3CSS\30AF\30E9\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104481766122308818)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_END_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AC\30F3\30C8\30FB\30C1\30E3\30FC\30C8\3067\30D9\30FC\30B9\30E9\30A4\30F3\7D42\4E86\65E5\3092\5B9A\7FA9\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\5217\540D\3092\9078\629E\3057\307E\3059\3002\30D9\30FC\30B9\30E9\30A4\30F3\7D42\4E86\65E5\306F\3001\30BF\30B9\30AF\306E\5143\306E\8A08\753B\7D42\4E86\65E5\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104481621802308818)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_END_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D9\30FC\30B9\30E9\30A4\30F3\7D42\4E86\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104481595932308818)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_START_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AC\30F3\30C8\30FB\30C1\30E3\30FC\30C8\3067\30D9\30FC\30B9\30E9\30A4\30F3\958B\59CB\65E5\3092\5B9A\7FA9\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\5217\540D\3092\9078\629E\3057\307E\3059\3002\30D9\30FC\30B9\30E9\30A4\30F3\958B\59CB\65E5\306F\3001\30BF\30B9\30AF\306E\5143\306E\8A08\753B\958B\59CB\65E5\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104481490724308818)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_START_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D9\30FC\30B9\30E9\30A4\30F3\958B\59CB\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104479942051308816)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AC\30F3\30C8\30FB\30C1\30E3\30FC\30C8\306E\7D42\4E86\65E5\3092\5B9A\7FA9\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\5217\540D\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104479813269308816)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D42\4E86\65E5\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104480114924308817)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AC\30F3\30C8\30FB\30C1\30E3\30FC\30C8\306E\7D42\4E86\65E5\3092\5B9A\7FA9\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104480055144308817)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_ITEM.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D42\4E86\65E5\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104479185936308816)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AC\30F3\30C8\30FB\30C1\30E3\30FC\30C8\306E\7D42\4E86\65E5\3092\5B9A\7FA9\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\30BD\30FC\30B9\3092\9078\629E\3057\307E\3059\3002\30C1\30E3\30FC\30C8\3092\30EC\30F3\30C0\30EA\30F3\30B0\3059\308B\306B\306F\3001\7D42\4E86\65E5\304C\5FC5\8981\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104479368723308816)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.LOV.DB_COLUMN.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104479478687308816)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.LOV.DB_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<em>\300C\7D42\4E86\65E5\5217\300D</em>\306B\5165\529B\3055\308C\305F\5217\5024\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104479647444308816)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.LOV.ITEM.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104479729442308816)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.LOV.ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\7D42\4E86\65E5\30A2\30A4\30C6\30E0</em>\306E\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\306B\4FDD\6301\3055\308C\3066\3044\308B\5024\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104479224831308816)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D42\4E86\65E5\30BD\30FC\30B9\30FB\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104481917410308818)
,p_name=>'PE.PROPERTY.JET_GANTT_PROGRESS_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AC\30F3\30C8\30FB\30C1\30E3\30FC\30C8\3067\30BF\30B9\30AF\9032\6357\72B6\6CC1\3092\5B9A\7FA9\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\5217\540D\3092\9078\629E\3057\307E\3059\3002\9032\6357\306E\5024\306F\30010\304B\30891\307E\3067\306E\9593\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\5024\304C\7121\52B9\306A\5834\5408\3001\9032\6357\306F\8868\793A\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104481847588308818)
,p_name=>'PE.PROPERTY.JET_GANTT_PROGRESS_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\9032\6357')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104711380070309009)
,p_name=>'PE.PROPERTY.JET_GANTT_PROGRESS_CSS_CLASS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\30AC\30F3\30C8\30FB\30C1\30E3\30FC\30C8\306E\9032\6357\30D0\30FC\306B\9069\7528\3055\308C\308BCSS\30AF\30E9\30B9\3092\5165\529B\3057\307E\3059\3002\8907\6570\306E\30AF\30E9\30B9\306F\7A7A\767D\3067\533A\5207\3063\3066\8FFD\52A0\3067\304D\307E\3059\3002<code>&COLUMN_VALUE.</code>\7F6E\63DB\3092\4F7F\7528\3067\304D\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104711254467309009)
,p_name=>'PE.PROPERTY.JET_GANTT_PROGRESS_CSS_CLASS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\9032\6357CSS\30AF\30E9\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104480335656308817)
,p_name=>'PE.PROPERTY.JET_GANTT_ROW_ID.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AC\30F3\30C8\30FB\30C1\30E3\30FC\30C8\3067\884CID\3092\5B9A\7FA9\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\5217\540D\3092\9078\629E\3057\307E\3059\3002\884CID\306F\30011\884C\306B\8907\6570\306E\30BF\30B9\30AF\3092\30EC\30F3\30C0\30EA\30F3\30B0\3059\308B\5834\5408\306B\5FC5\8981\3067\3059\3002\884CID\5217\306E\30DE\30C3\30D4\30F3\30B0\304C\5B9A\7FA9\3055\308C\3066\3044\306A\3044\5834\5408\3001\5404\30BF\30B9\30AF\304C\5358\4E00\306E\30BF\30B9\30AF\3068\3057\30661\884C\3054\3068\306B\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104480278361308817)
,p_name=>'PE.PROPERTY.JET_GANTT_ROW_ID.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\884CID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104480593879308817)
,p_name=>'PE.PROPERTY.JET_GANTT_ROW_NAME.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AC\30F3\30C8\30FB\30C1\30E3\30FC\30C8\3067\884C\540D\3092\5B9A\7FA9\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\5217\540D\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104480440548308817)
,p_name=>'PE.PROPERTY.JET_GANTT_ROW_NAME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104479046303308816)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AC\30F3\30C8\30FB\30C1\30E3\30FC\30C8\306E\958B\59CB\65E5\3092\5B9A\7FA9\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\5217\540D\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104478912293308816)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\59CB\65E5\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104488572455308830)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AC\30F3\30C8\30FB\30C1\30E3\30FC\30C8\306E\958B\59CB\65E5\3092\5B9A\7FA9\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104479564236308816)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_ITEM.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\59CB\65E5\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104475560414308813)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AC\30F3\30C8\30FB\30C1\30E3\30FC\30C8\306E\958B\59CB\65E5\3092\5B9A\7FA9\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\30BD\30FC\30B9\3092\9078\629E\3057\307E\3059\3002\30C1\30E3\30FC\30C8\3092\30EC\30F3\30C0\30EA\30F3\30B0\3059\308B\306B\306F\3001\958B\59CB\65E5\304C\5FC5\8981\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104478303438308815)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.LOV.DB_COLUMN.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104478433748308815)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.LOV.DB_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<em>\300C\958B\59CB\65E5\5217\300D</em>\306B\5165\529B\3055\308C\305F\5217\5024\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104478532440308816)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.LOV.ITEM.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104478670762308816)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.LOV.ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\958B\59CB\65E5\30A2\30A4\30C6\30E0</em>\306E\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\306B\4FDD\6301\3055\308C\3066\3044\308B\5024\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104475421072308813)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\59CB\65E5\30BD\30FC\30B9\30FB\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104711135012309009)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_CSS_CLASS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\30AC\30F3\30C8\30FB\30C1\30E3\30FC\30C8\306E\30BF\30B9\30AF\30FB\30D0\30FC\306B\9069\7528\3055\308C\308BCSS\30AF\30E9\30B9\3092\5165\529B\3057\307E\3059\3002\8907\6570\306E\30AF\30E9\30B9\306F\7A7A\767D\3067\533A\5207\3063\3066\8FFD\52A0\3067\304D\307E\3059\3002<code>&COLUMN_VALUE.</code>\7F6E\63DB\3092\4F7F\7528\3067\304D\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104711093752309009)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_CSS_CLASS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30B9\30AFCSS\30AF\30E9\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104481397839308817)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_END_DATE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AC\30F3\30C8\30FB\30C1\30E3\30FC\30C8\3067\30BF\30B9\30AF\7D42\4E86\65E5\3092\5B9A\7FA9\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\5217\540D\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104481243009308817)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_END_DATE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30B9\30AF\7D42\4E86\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104480758043308817)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_ID.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AC\30F3\30C8\30FB\30C1\30E3\30FC\30C8\3067\30BF\30B9\30AFID\3092\5B9A\7FA9\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\5217\540D\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104480607605308817)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_ID.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30B9\30AFID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104480964703308817)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_NAME.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AC\30F3\30C8\30FB\30C1\30E3\30FC\30C8\3067\30BF\30B9\30AF\540D\3092\5B9A\7FA9\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\5217\540D\3092\9078\629E\3057\307E\3059\3002\884C\540D\5217\306E\30DE\30C3\30D4\30F3\30B0\304C\5B9A\7FA9\3055\308C\3066\3044\306A\3044\5834\5408\3001\30BF\30B9\30AF\540D\306F\30C1\30E3\30FC\30C8\306E\884C\8EF8\306E\884C\30E9\30D9\30EB\3068\3057\3066\4F7F\7528\3055\308C\307E\3059\3002 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104480810122308817)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_NAME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30B9\30AF\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104481141045308817)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_START_DATE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AC\30F3\30C8\30FB\30C1\30E3\30FC\30C8\3067\30BF\30B9\30AF\958B\59CB\65E5\3092\5B9A\7FA9\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\5217\540D\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104481085271308817)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_START_DATE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30B9\30AF\958B\59CB\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104691729626308993)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AC\30F3\30C8\30FB\30C1\30E3\30FC\30C8\306E\30D3\30E5\30FC\30DD\30FC\30C8\7D42\4E86\65E5\3092\5B9A\7FA9\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\5217\540D\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104686731206308988)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D42\4E86\65E5\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104691865727308993)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AC\30F3\30C8\30FB\30C1\30E3\30FC\30C8\306E\30D3\30E5\30FC\30DD\30FC\30C8\7D42\4E86\65E5\3092\5B9A\7FA9\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104686530473308988)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_ITEM.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D42\4E86\65E5\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104691411858308993)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AC\30F3\30C8\30FB\30C1\30E3\30FC\30C8\306E\30D3\30E5\30FC\30DD\30FC\30C8\306E\7D42\4E86\65E5\3092\5B9A\7FA9\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\30BD\30FC\30B9\3092\9078\629E\3057\307E\3059\3002\30D3\30E5\30FC\30DD\30FC\30C8\306F\3001\5B9A\7FA9\3059\308B\969B\306B\3001\30EC\30F3\30C0\30EA\30F3\30B0\6642\306E\30C1\30E3\30FC\30C8\306E\521D\671F\30BA\30FC\30E0\3092\5236\5FA1\3067\304D\308B\65E5\4ED8\7BC4\56F2\3067\3059\3002\30C1\30E3\30FC\30C8\306F\3001\6307\5B9A\3057\305F\65E5\4ED8\7BC4\56F2\306B\30BA\30FC\30E0\30A4\30F3\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104686903922308988)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.LOV.DB_COLUMN.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104691569324308993)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.LOV.DB_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<em>\300C\7D42\4E86\65E5\5217\300D</em>\306B\5165\529B\3055\308C\305F\5217\5024\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104687125725308989)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.LOV.ITEM.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104691631522308993)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.LOV.ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\7D42\4E86\65E5\30A2\30A4\30C6\30E0</em>\306E\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\306B\4FDD\6301\3055\308C\3066\3044\308B\5024\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104686471096308988)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D42\4E86\65E5\30BD\30FC\30B9\30FB\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104691206295308993)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AC\30F3\30C8\30FB\30C1\30E3\30FC\30C8\306E\30D3\30E5\30FC\30DD\30FC\30C8\958B\59CB\65E5\3092\5B9A\7FA9\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\5217\540D\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104686643287308988)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\59CB\65E5\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104691334052308993)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AC\30F3\30C8\30FB\30C1\30E3\30FC\30C8\306E\30D3\30E5\30FC\30DD\30FC\30C8\958B\59CB\65E5\3092\5B9A\7FA9\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104686389328308988)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_ITEM.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\59CB\65E5\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104690961383308993)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AC\30F3\30C8\30FB\30C1\30E3\30FC\30C8\306E\30D3\30E5\30FC\30DD\30FC\30C8\306E\958B\59CB\65E5\3092\5B9A\7FA9\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\30BD\30FC\30B9\3092\9078\629E\3057\307E\3059\3002\30D3\30E5\30FC\30DD\30FC\30C8\306F\3001\5B9A\7FA9\3059\308B\969B\306B\3001\30EC\30F3\30C0\30EA\30F3\30B0\6642\306E\30C1\30E3\30FC\30C8\306E\521D\671F\30BA\30FC\30E0\3092\5236\5FA1\3067\304D\308B\65E5\4ED8\7BC4\56F2\3067\3059\3002\30C1\30E3\30FC\30C8\306F\3001\6307\5B9A\3057\305F\65E5\4ED8\7BC4\56F2\306B\30BA\30FC\30E0\30A4\30F3\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104686834294308988)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.LOV.DB_COLUMN.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104691015861308993)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.LOV.DB_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<em>\300C\958B\59CB\65E5\5217\300D</em>\306B\5165\529B\3055\308C\305F\5217\5024\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104687009220308989)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.LOV.ITEM.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104691134339308993)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.LOV.ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\958B\59CB\65E5\30A2\30A4\30C6\30E0</em>\306E\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\306B\4FDD\6301\3055\308C\3066\3044\308B\5024\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104686225737308988)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\59CB\65E5\30BD\30FC\30B9\30FB\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103590505021308081)
,p_name=>'PE.PROPERTY.JET_GAUGE_ANGLE_EXTENT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5186\5F62\306E\5411\304D\3067\30B9\30C6\30FC\30BF\30B9\30FB\30E1\30FC\30BF\30FC\30FB\30B2\30FC\30B8\30FB\30C1\30E3\30FC\30C8\306E\89D2\5EA6\7BC4\56F2\3092\5EA6\6570\5358\4F4D\3067\5165\529B\3057\307E\3059\3002\89D2\5EA6\7BC4\56F2\306F\3001\5186\5F62\306E\5411\304D\306E\5B9F\969B\306E\89D2\5EA6\3067\3059\3002\6B63\306E\6570\306F\53F3\56DE\308A\306E\89D2\5EA6\3092\793A\3057\307E\3059\3002\8CA0\306E\6570\306F\5DE6\56DE\308A\306E\89D2\5EA6\3092\793A\3057\307E\3059\3002\5186\5F62\30B2\30FC\30B8\306F\4EFB\610F\306E\89D2\5EA6\3067\63CF\753B\3057\3001\9078\629E\3057\305F\89D2\5EA6\306B\5FDC\3058\3066\5F62\72B6\3092\5909\66F4\3059\308B\3053\3068\304C\3067\304D\307E\3059\3002\30B2\30FC\30B8\306E\5F62\72B6\306F\3001<strong>\958B\59CB\89D2\5EA6</strong>\3068<strong>\89D2\5EA6\7BC4\56F2</strong>\3068\3044\30462\3064\306E\8A2D\5B9A\306B\3088\3063\3066\6C7A\307E\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103590315079308080)
,p_name=>'PE.PROPERTY.JET_GAUGE_ANGLE_EXTENT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\89D2\5EA6\7BC4\56F2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103589980435308080)
,p_name=>'PE.PROPERTY.JET_GAUGE_INDICATOR_SIZE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30B8\30B1\30FC\30BF\3068\63CF\753B\30A8\30EA\30A2\306E\76F8\5BFE\7684\306A\592A\3055\306E\6BD4\3092\6307\5B9A\3057\307E\3059\3002\30C7\30D5\30A9\30EB\30C8\5024\306F1\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103589814572308080)
,p_name=>'PE.PROPERTY.JET_GAUGE_INDICATOR_SIZE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30B8\30B1\30FC\30BF\30FB\30B5\30A4\30BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103590095142308080)
,p_name=>'PE.PROPERTY.JET_GAUGE_INNER_RADIUS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5186\5F62\306E\5411\304D\3067\30B9\30C6\30FC\30BF\30B9\30FB\30E1\30FC\30BF\30FC\30FB\30B2\30FC\30B8\30FB\30C1\30E3\30FC\30C8\306E\5185\90E8\534A\5F84\3092\6307\5B9A\3057\307E\3059\3002\3053\308C\306F\3001\30B2\30FC\30B8\306E\4E2D\5FC3\304B\3089\30A4\30F3\30B8\30B1\30FC\30BF\3068\63CF\753B\30A8\30EA\30A2\306E\6700\3082\5185\5074\306E\30A8\30C3\30B8\307E\3067\306E\8DDD\96E2\3067\5B9A\7FA9\3055\308C\307E\3059\3002\6709\52B9\306A\5024\306F\3001\30D1\30FC\30BB\30F3\30C8\307E\305F\306F0\304B\30891\307E\3067\306E\6BD4\7387\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103590137587308080)
,p_name=>'PE.PROPERTY.JET_GAUGE_INNER_RADIUS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5185\90E8\534A\5F84')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103589581882308080)
,p_name=>'PE.PROPERTY.JET_GAUGE_ORIENTATION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30F3\30C0\30EA\30F3\30B0\3059\308B\30B9\30C6\30FC\30BF\30B9\30FB\30E1\30FC\30BF\30FC\30FB\30B2\30FC\30B8\30FB\30C1\30E3\30FC\30C8\306E\30BF\30A4\30D7\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103589285866308080)
,p_name=>'PE.PROPERTY.JET_GAUGE_ORIENTATION.LOV.CIRCULAR.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5186\5F62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103589398073308080)
,p_name=>'PE.PROPERTY.JET_GAUGE_ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A2A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103589479508308080)
,p_name=>'PE.PROPERTY.JET_GAUGE_ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\7E26')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103589149005308080)
,p_name=>'PE.PROPERTY.JET_GAUGE_ORIENTATION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5411\304D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103589791423308080)
,p_name=>'PE.PROPERTY.JET_GAUGE_PLOT_AREA.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30C6\30FC\30BF\30B9\30FB\30E1\30FC\30BF\30FC\30FB\30B2\30FC\30B8\30FB\30C1\30E3\30FC\30C8\306E\63CF\753B\30A8\30EA\30A2\3092\30EC\30F3\30C0\30EA\30F3\30B0\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103589629725308080)
,p_name=>'PE.PROPERTY.JET_GAUGE_PLOT_AREA.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\63CF\753B\30A8\30EA\30A2\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103703975956308170)
,p_name=>'PE.PROPERTY.JET_GAUGE_PLOT_AREA_COLOR.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\306AHTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\306E\4F8B\306B\306F\6B21\306E\3082\306E\304C\3042\308A\307E\3059 -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103600104530308088)
,p_name=>'PE.PROPERTY.JET_GAUGE_PLOT_AREA_COLOR.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30B9\30C6\30FC\30BF\30B9\30FB\30E1\30FC\30BF\30FC\30FB\30B2\30FC\30B8\30FB\30C1\30E3\30FC\30C8\306E\63CF\753B\30A8\30EA\30A2\306B\8868\793A\3055\308C\308B\8272\3092\5165\529B\3057\307E\3059\3002<code>&COLUMN_VALUE.</code>\7F6E\63DB\3092\4F7F\7528\3067\304D\307E\3059\3002\3053\306E\8272\306F\3001\3057\304D\3044\5024\306E\8272\304C\30C1\30E3\30FC\30C8\306B\5BFE\3057\3066\5B9A\7FA9\3055\308C\3066\3044\306A\3044\5834\5408\306B\306E\307F\9069\7528\3055\308C\307E\3059\3002</p>'),
unistr('<p>\8272\306F\300116\9032(hex)\8868\8A18\3001RGB\30AB\30E9\30FC\30FB\30B3\30FC\30C9\307E\305F\306FHTML\30AB\30E9\30FC\540D\3092\4F7F\7528\3057\3066\6307\5B9A\3055\308C\307E\3059\300216\9032\8868\8A18\306F#xxyyzz (#\306E\5F8C\306B3\3064\306E2\6841\306E16\9032\6570)\3067\5B9A\7FA9\3055\308C\3001xx\3001yy\304A\3088\3073zz\306F\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E2\6587\5B57\306E16\9032\306E\5024\3092\8868\3057\307E\3059\3002'),
unistr('RGB\30B3\30FC\30C9\306FRGB(xxx,xxx,xxx)\3067\5B9A\7FA9\3055\308C\3001xxx\306F0\304B\3089255\306E\9593\306E\6570\5024\3067\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E8\30D3\30C3\30C8\30FB\30D0\30A4\30C8\5024\3092\8868\3057\307E\3059\3002</p>'),
unistr('<p>\30A4\30F3\30BF\30FC\30CD\30C3\30C8\3067HTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\3092\691C\7D22\3059\308B\3068\3001\4F7F\7528\3059\308B\8272\306E16\9032\30B3\30FC\30C9\307E\305F\306FRGB\30B3\30FC\30C9\304C\308F\304B\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103600013951308088)
,p_name=>'PE.PROPERTY.JET_GAUGE_PLOT_AREA_COLOR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\63CF\753B\30FB\30A8\30EA\30A2\306E\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103590483707308081)
,p_name=>'PE.PROPERTY.JET_GAUGE_START_ANGLE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5186\5F62\306E\5411\304D\3067\30B9\30C6\30FC\30BF\30B9\30FB\30E1\30FC\30BF\30FC\30FB\30B2\30FC\30B8\30FB\30C1\30E3\30FC\30C8\306E\958B\59CB\89D2\5EA6\3092\5EA6\6570\5358\4F4D\3067\5165\529B\3057\307E\3059\3002\6B63\306E\6570\306F\53F3\56DE\308A\306E\958B\59CB\89D2\5EA6\3092\793A\3057\307E\3059\3002\8CA0\306E\6570\306F\5DE6\56DE\308A\306E\958B\59CB\89D2\5EA6\3092\793A\3057\307E\3059\3002\5186\5F62\30B2\30FC\30B8\306F\4EFB\610F\306E\89D2\5EA6\3067\63CF\753B\3057\3001\9078\629E\3057\305F\89D2\5EA6\306B\5FDC\3058\3066\5F62\72B6\3092\5909\66F4\3059\308B\3053\3068\304C\3067\304D\307E\3059\3002\30B2\30FC\30B8\306E\5F62\72B6\306F\3001<strong>\958B\59CB\89D2\5EA6</strong>\3068<strong>\89D2\5EA6\7BC4\56F2</strong>\3068\3044\30462\3064\306E\8A2D\5B9A\306B\3088\3063\3066\6C7A\307E\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103590274272308080)
,p_name=>'PE.PROPERTY.JET_GAUGE_START_ANGLE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\59CB\89D2\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104474983700308813)
,p_name=>'PE.PROPERTY.JET_HORIZONTAL_GRID.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\306E\6C34\5E73\30B0\30EA\30C3\30C9\7DDA\3092\8868\793A\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104474242451308812)
,p_name=>'PE.PROPERTY.JET_HORIZONTAL_GRID.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6C34\5E73\30B0\30EA\30C3\30C9\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104148322261308565)
,p_name=>'PE.PROPERTY.JET_HOVER_BEHAVIOR.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30C1\30E3\30FC\30C8\306E\30C7\30FC\30BF\30FB\30A2\30A4\30C6\30E0\4E0A\306B\30AB\30FC\30BD\30EB\304C\7F6E\304B\308C\305F\3068\304D\306B\9069\7528\3059\308B\52D5\4F5C\3092\6307\5B9A\3057\307E\3059\3002<p/>'),
unistr('        <strong>\300C\30AA\30F3\300D</strong>\3092\9078\629E\3057\3066\73FE\5728\30AB\30FC\30BD\30EB\304C\7F6E\304B\308C\3066\3044\306A\3044\3059\3079\3066\306E\30C7\30FC\30BF\30FB\30A2\30A4\30C6\30E0\3092\8584\304F\8868\793A\3057\3001\30AB\30FC\30BD\30EB\304C\7F6E\304B\308C\3066\3044\308B\73FE\5728\306E\30C7\30FC\30BF\30FB\30A2\30A4\30C6\30E0\306E\307F\5F37\8ABF\8868\793A\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104148238504308565)
,p_name=>'PE.PROPERTY.JET_HOVER_BEHAVIOR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30FC\30BD\30EB\304C\7F6E\304B\308C\308B\3068\8584\304F\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104736072853309031)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\306E\521D\671F\30BA\30FC\30E0\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104736159206309031)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.FIRST.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\521D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104736226709309032)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.FIRST.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\30FB\30D7\30ED\30C3\30C8\9818\57DF\306B\53CE\307E\308B\6700\521D\306E\30C7\30FC\30BF\30FB\30DD\30A4\30F3\30C8\306B\521D\671F\30BA\30FC\30E0\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104736347401309032)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.LAST.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104736416547309032)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.LAST.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\30FB\30D7\30ED\30C3\30C8\9818\57DF\306B\53CE\307E\308B\6700\5F8C\306E\30C7\30FC\30BF\30FB\30DD\30A4\30F3\30C8\306B\521D\671F\30BA\30FC\30E0\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104736569209309032)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.NONE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104736643079309032)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.NONE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\521D\671F\30BA\30FC\30E0\306E\7121\52B9\5316\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104735904883309031)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\521D\671F\30BA\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104121573423308534)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_COLOR.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\306AHTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\306E\4F8B\306B\306F\6B21\306E\3082\306E\304C\3042\308A\307E\3059 -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103864276512308296)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_COLOR.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\3055\308C\305F\5C5E\6027\306E\30D5\30A9\30F3\30C8\306E\8868\793A\306B\4F7F\7528\3055\308C\308B\8272\3092\5165\529B\3057\307E\3059\3002</p>'),
unistr('<p>\8272\306F\300116\9032(hex)\8868\8A18\3001RGB\30AB\30E9\30FC\30FB\30B3\30FC\30C9\307E\305F\306FHTML\30AB\30E9\30FC\540D\3092\4F7F\7528\3057\3066\6307\5B9A\3055\308C\307E\3059\300216\9032\8868\8A18\306F#xxyyzz (#\306E\5F8C\306B3\3064\306E2\6841\306E16\9032\6570)\3067\5B9A\7FA9\3055\308C\3001xx\3001yy\304A\3088\3073zz\306F\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E2\6587\5B57\306E16\9032\306E\5024\3092\8868\3057\307E\3059\3002'),
unistr('RGB\30B3\30FC\30C9\306FRGB(xxx,xxx,xxx)\3067\5B9A\7FA9\3055\308C\3001xxx\306F0\304B\3089255\306E\9593\306E\6570\5024\3067\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E8\30D3\30C3\30C8\30FB\30D0\30A4\30C8\5024\3092\8868\3057\307E\3059\3002</p>'),
unistr('<p>\30A4\30F3\30BF\30FC\30CD\30C3\30C8\3067HTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\3092\691C\7D22\3059\308B\3068\3001\4F7F\7528\3059\308B\8272\306E16\9032\30B3\30FC\30C9\307E\305F\306FRGB\30B3\30FC\30C9\304C\308F\304B\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103861203388308294)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_COLOR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30F3\30C8\30FB\30AB\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103862887258308295)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30F3\30C8\30FB\30D5\30A1\30DF\30EA\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103861448899308294)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.ARIAL BLACK.D'
,p_message_language=>'ja'
,p_message_text=>'Arial Black'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103861306510308294)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.ARIAL.D'
,p_message_language=>'ja'
,p_message_text=>'Arial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103861504571308294)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.BOOKMAN.D'
,p_message_language=>'ja'
,p_message_text=>'Bookman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103861661796308294)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.COMIC SANS MS.D'
,p_message_language=>'ja'
,p_message_text=>'Comic Sans MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103861849740308294)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.COURIER NEW.D'
,p_message_language=>'ja'
,p_message_text=>'Courier New'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103861727709308294)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'ja'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103861935206308294)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.GARAMOND.D'
,p_message_language=>'ja'
,p_message_text=>'Garamond'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103862075429308294)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.GEORGIA.D'
,p_message_language=>'ja'
,p_message_text=>'Georgia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103862103004308295)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'ja'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103862239698308295)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.IMPACT.D'
,p_message_language=>'ja'
,p_message_text=>'Impact'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103862374031308295)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.PALATINO.D'
,p_message_language=>'ja'
,p_message_text=>'Palatino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103862589507308295)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.TIMES NEW ROMAN.D'
,p_message_language=>'ja'
,p_message_text=>'Times New Roman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103862466802308295)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'ja'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103862666639308295)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.TREBUCHET MS.D'
,p_message_language=>'ja'
,p_message_text=>'Trebuchet MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103862797176308295)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.VERDANA.D'
,p_message_language=>'ja'
,p_message_text=>'Verdana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103860956224308294)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30F3\30C8\30FB\30D5\30A1\30DF\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103863357619308295)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30F3\30C8\30FB\30B5\30A4\30BA\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103863564212308296)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.10.D'
,p_message_language=>'ja'
,p_message_text=>'10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103863615269308296)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.12.D'
,p_message_language=>'ja'
,p_message_text=>'12'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103863798233308296)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.14.D'
,p_message_language=>'ja'
,p_message_text=>'14'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103863889301308296)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.16.D'
,p_message_language=>'ja'
,p_message_text=>'16'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103863938703308296)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.18.D'
,p_message_language=>'ja'
,p_message_text=>'18'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103864011164308296)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.20.D'
,p_message_language=>'ja'
,p_message_text=>'20'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103864198604308296)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.22.D'
,p_message_language=>'ja'
,p_message_text=>'22'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103863420730308296)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.8.D'
,p_message_language=>'ja'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103861166953308294)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30F3\30C8\30FB\30B5\30A4\30BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103862963942308295)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_STYLE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30F3\30C8\30FB\30B9\30BF\30A4\30EB\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103863166778308295)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_STYLE.LOV.ITALIC.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30BF\30EA\30C3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103863055803308295)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_STYLE.LOV.NORMAL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A19\6E96')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103863256702308295)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_STYLE.LOV.OBLIQUE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\659C\7DDA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103861075697308294)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_STYLE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30F3\30C8\30FB\30B9\30BF\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103671924124308144)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB\3092\5186\30B0\30E9\30D5\306E\30B9\30E9\30A4\30B9\306B\8868\793A\3059\308B\65B9\6CD5\3092\6307\5B9A\3057\307E\3059\3002 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104715534630309013)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.ALL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB - \5272\5408 ( \5024 )')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104716086807309013)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.ALL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\30E9\30D9\30EB\306B\306F\3001\30E9\30D9\30EB\3001\5024\304A\3088\3073\5272\5408\306E\60C5\5831\304C\300C\30E9\30D9\30EB - \5272\5408 ( \5024 )\300D\306E\5F62\5F0F\3067\8868\793A\3055\308C\307E\3059\3002\305F\3068\3048\3070\3001<strong>\30D0\30B0 - 15% ( 18 )</strong>\306A\3069\3067\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104715678765309013)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.COMBO.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5272\5408 ( \5024 )')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104716121017309013)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.COMBO.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\30E9\30D9\30EB\306F\3001\9078\629E\3057\305F\5024\5217\306E\30DE\30C3\30D4\30F3\30B0\306B\57FA\3065\3044\3066\3001\6570\5024\3068\3057\3066\8868\793A\3055\308C\307E\3059\3002\305F\3068\3048\3070\3001<strong>15% ( 18 )</strong>\306A\3069\3067\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104715218625309013)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.LABEL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104715796902309013)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.LABEL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\30E9\30D9\30EB\306F\3001\9078\629E\3057\305F\30E9\30D9\30EB\5217\306E\30DE\30C3\30D4\30F3\30B0\306B\57FA\3065\3044\3066\3001\30C1\30E3\30FC\30C8\306E\30B9\30E9\30A4\30B9\306B\8868\793A\3055\308C\307E\3059\3002\305F\3068\3048\3070\3001<strong>\30D0\30B0</strong>\306A\3069\3067\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104059811596308483)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.LBL_VAL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB - \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104059953529308483)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.LBL_VAL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\30E9\30D9\30EB\306B\306F\3001\30E9\30D9\30EB\304A\3088\3073\5024\306E\60C5\5831\304C\300C\30E9\30D9\30EB - \5024\300D\306E\5F62\5F0F\3067\8868\793A\3055\308C\307E\3059\3002\305F\3068\3048\3070\3001<strong>\30D0\30B0 - 18</strong>\306A\3069\3067\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104715396947309013)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.PERCENT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5272\5408')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104715887906309013)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.PERCENT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\30E9\30D9\30EB\306F\3001\9078\629E\3057\305F\5024\5217\306E\30DE\30C3\30D4\30F3\30B0\306B\57FA\3065\3044\3066\30010%\304B\3089100%\306E\9593\306E\5024\3068\3057\3066\8868\793A\3055\308C\307E\3059\3002\5024\306F\3001\30C1\30E3\30FC\30C8\306B\8868\3055\308C\308B\5408\8A08\5024\306E\5272\5408\3067\3059\3002\305F\3068\3048\3070\3001<strong>15%</strong>\306A\3069\3067\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104715471007309013)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.VALUE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104715976336309013)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.VALUE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\30E9\30D9\30EB\306F\3001\9078\629E\3057\305F\5024\5217\306E\30DE\30C3\30D4\30F3\30B0\306B\57FA\3065\3044\3066\3001\6570\5024\3068\3057\3066\8868\793A\3055\308C\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104715142467309013)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\5F62\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104121478022308534)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_COLOR.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\306AHTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\306E\4F8B\306B\306F\6B21\306E\3082\306E\304C\3042\308A\307E\3059 -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103858238569308292)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_COLOR.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\3055\308C\305F\5C5E\6027\306E\30D5\30A9\30F3\30C8\306E\8868\793A\306B\4F7F\7528\3055\308C\308B\8272\3092\5165\529B\3057\307E\3059\3002</p>'),
unistr('<p>\8272\306F\300116\9032(hex)\8868\8A18\3001RGB\30AB\30E9\30FC\30FB\30B3\30FC\30C9\307E\305F\306FHTML\30AB\30E9\30FC\540D\3092\4F7F\7528\3057\3066\6307\5B9A\3055\308C\307E\3059\300216\9032\8868\8A18\306F#xxyyzz (#\306E\5F8C\306B3\3064\306E2\6841\306E16\9032\6570)\3067\5B9A\7FA9\3055\308C\3001xx\3001yy\304A\3088\3073zz\306F\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E2\6587\5B57\306E16\9032\306E\5024\3092\8868\3057\307E\3059\3002'),
unistr('RGB\30B3\30FC\30C9\306FRGB(xxx,xxx,xxx)\3067\5B9A\7FA9\3055\308C\3001xxx\306F0\304B\3089255\306E\9593\306E\6570\5024\3067\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E8\30D3\30C3\30C8\30FB\30D0\30A4\30C8\5024\3092\8868\3057\307E\3059\3002</p>'),
unistr('<p>\30A4\30F3\30BF\30FC\30CD\30C3\30C8\3067HTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\3092\691C\7D22\3059\308B\3068\3001\4F7F\7528\3059\308B\8272\306E16\9032\30B3\30FC\30C9\307E\305F\306FRGB\30B3\30FC\30C9\304C\308F\304B\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103857871547308291)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_COLOR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30F3\30C8\30FB\30AB\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103857915185308291)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30F3\30C8\30FB\30D5\30A1\30DF\30EA\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103858472772308292)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.ARIAL BLACK.D'
,p_message_language=>'ja'
,p_message_text=>'Arial Black'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103858340127308292)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.ARIAL.D'
,p_message_language=>'ja'
,p_message_text=>'Arial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103858561197308292)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.BOOKMAN.D'
,p_message_language=>'ja'
,p_message_text=>'Bookman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103858634410308292)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.COMIC SANS MS.D'
,p_message_language=>'ja'
,p_message_text=>'Comic Sans MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103858871249308292)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.COURIER NEW.D'
,p_message_language=>'ja'
,p_message_text=>'Courier New'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103858719368308292)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'ja'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103858975458308292)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.GARAMOND.D'
,p_message_language=>'ja'
,p_message_text=>'Garamond'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103859010395308292)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.GEORGIA.D'
,p_message_language=>'ja'
,p_message_text=>'Georgia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103859151763308292)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'ja'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103859235097308292)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.IMPACT.D'
,p_message_language=>'ja'
,p_message_text=>'Impact'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103859371842308292)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.PALATINO.D'
,p_message_language=>'ja'
,p_message_text=>'Palatino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103859526374308292)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.TIMES NEW ROMAN.D'
,p_message_language=>'ja'
,p_message_text=>'Times New Roman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103859465793308292)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'ja'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103859689359308293)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.TREBUCHET MS.D'
,p_message_language=>'ja'
,p_message_text=>'Trebuchet MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103859748371308293)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.VERDANA.D'
,p_message_language=>'ja'
,p_message_text=>'Verdana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103857527230308291)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30F3\30C8\30FB\30D5\30A1\30DF\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103858160899308291)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30F3\30C8\30FB\30B5\30A4\30BA\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103860237778308293)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.10.D'
,p_message_language=>'ja'
,p_message_text=>'10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103860326006308293)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.12.D'
,p_message_language=>'ja'
,p_message_text=>'12'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103860431386308293)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.14.D'
,p_message_language=>'ja'
,p_message_text=>'14'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103860546770308293)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.16.D'
,p_message_language=>'ja'
,p_message_text=>'16'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103860636429308293)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.18.D'
,p_message_language=>'ja'
,p_message_text=>'18'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103860766942308293)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.20.D'
,p_message_language=>'ja'
,p_message_text=>'20'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103860860961308294)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.22.D'
,p_message_language=>'ja'
,p_message_text=>'22'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103860195862308293)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.8.D'
,p_message_language=>'ja'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103857768471308291)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30F3\30C8\30FB\30B5\30A4\30BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103858009438308291)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_STYLE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30F3\30C8\30FB\30B9\30BF\30A4\30EB\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103859911763308293)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_STYLE.LOV.ITALIC.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30BF\30EA\30C3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103859830483308293)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_STYLE.LOV.NORMAL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A19\6E96')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103860083837308293)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_STYLE.LOV.OBLIQUE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\659C\7DDA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103857688173308291)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_STYLE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30F3\30C8\30FB\30B9\30BF\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103707776521308174)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_COLORS.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl>',
unistr('<dt>\8272\306E\30AB\30F3\30DE\533A\5207\308A\30EA\30B9\30C8:</dt>'),
'<dd><pre>',
'<strong>red,yellow,blue</strong>',
'</pre></dd>',
unistr('<dt>\6B21\306E\3088\3046\306A\8272\3092\623B\3059\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\306E\30AB\30F3\30DE\533A\5207\308A\30EA\30B9\30C8:</dt>'),
'<dd><pre>',
unistr('<code>&amp;ITEM.</code>\306E\69CB\6587\3002\4F8B: <strong><code>&amp;ITEM_1.</code>,<code>&amp;ITEM_2.</code>,<code>&amp;ITEM_3.</code></strong>'),
'</pre></dd>',
unistr('<dt>\6B21\306E\3088\3046\306A\8272\3092\623B\3059\5217\306E\30AB\30F3\30DE\533A\5207\308A\30EA\30B9\30C8:</dt>'),
'<dd><pre>',
unistr('<code>&amp;COLUMN_NAME.</code>\306E\69CB\6587\3002\4F8B: <strong><code>&amp;COLUMN_NAME_1.</code>,<code>&amp;COLUMN_NAME_2.</code>,<code>&amp;COLUMN_NAME_3.</code></strong>'),
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103707621057308173)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_COLORS.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30B9\30C6\30FC\30BF\30B9\30FB\30E1\30FC\30BF\30FC\30FB\30B2\30FC\30B8\30FB\30C1\30E3\30FC\30C8\306B\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\308B\57FA\6E96\7DDA\3092\8B58\5225\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\8272\3092\5165\529B\3057\307E\3059\3002'),
unistr('\57FA\6E96\7DDA\304C\8907\6570\306E\5834\5408\3001\30AB\30F3\30DE\3067\533A\5207\3089\308C\305F\30EA\30B9\30C8\3092\4F7F\7528\3057\307E\3059\3002')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103707300975308173)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_COLORS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103707580254308173)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_VALUES.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl>',
unistr('<dt>\9759\7684\6570\5024\306E\30AB\30F3\30DE\533A\5207\308A\30EA\30B9\30C8:</dt>'),
'<dd><pre>',
'<strong>5,10,15</strong>',
'</pre></dd>',
unistr('<dt>\6B21\306E\3088\3046\306A\6570\5024\3092\623B\3059\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\306E\30AB\30F3\30DE\533A\5207\308A\30EA\30B9\30C8:</dt>'),
'<dd><pre>',
unistr('<code>&amp;ITEM.</code>\306E\69CB\6587\3002\4F8B: <strong><code>&amp;ITEM_1.</code>,<code>&amp;ITEM_2.</code>,<code>&amp;ITEM_3.</code></strong>'),
'</pre></dd>',
unistr('<dt>\6B21\306E\3088\3046\306A\6570\5024\3092\623B\3059\5217\306E\30AB\30F3\30DE\533A\5207\308A\30EA\30B9\30C8:</dt>'),
'<dd><pre>',
unistr('<code>&amp;COLUMN_NAME.</code>\306E\69CB\6587\3002\4F8B: <strong><code>&amp;COLUMN_NAME_1.</code>,<code>&amp;COLUMN_NAME_2.</code>,<code>&amp;COLUMN_NAME_3.</code></strong>'),
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103707443316308173)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_VALUES.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30B9\30C6\30FC\30BF\30B9\30FB\30E1\30FC\30BF\30FC\30FB\30B2\30FC\30B8\30FB\30C1\30E3\30FC\30C8\306B\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\308B\57FA\6E96\7DDA\3092\8B58\5225\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\6570\5024\3092\5165\529B\3057\307E\3059\3002'),
unistr('\57FA\6E96\7DDA\304C\8907\6570\306E\5834\5408\3001\30AB\30F3\30DE\3067\533A\5207\3089\308C\305F\30EA\30B9\30C8\3092\4F7F\7528\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103707274606308173)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_VALUES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104474791287308813)
,p_name=>'PE.PROPERTY.JET_ROW_AXIS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\306E\884C\30E9\30D9\30EB\3092\30EC\30F3\30C0\30EA\30F3\30B0\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104474478089308813)
,p_name=>'PE.PROPERTY.JET_ROW_AXIS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\8EF8\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104159890774308576)
,p_name=>'PE.PROPERTY.JET_SERIES_COLOR.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\306AHTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\306E\4F8B\306B\306F\6B21\306E\3082\306E\304C\3042\308A\307E\3059 -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104159730505308575)
,p_name=>'PE.PROPERTY.JET_SERIES_COLOR.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30C1\30E3\30FC\30C8\30FB\30B7\30EA\30FC\30BA\306B\95A2\9023\4ED8\3051\3089\308C\3066\3044\308B\30C7\30FC\30BF\30FB\30A2\30A4\30C6\30E0\306B\8868\793A\3055\308C\308B\8272\3092\5165\529B\3057\307E\3059\3002<code>&COLUMN_VALUE.</code>\7F6E\63DB\3092\4F7F\7528\3067\304D\307E\3059\3002\30B9\30C6\30FC\30BF\30B9\30FB\30E1\30FC\30BF\30FC\30FB\30B2\30FC\30B8\30FB\30C1\30E3\30FC\30C8\3067\306F\3001\3053\306E\8272\306F\30A4\30F3\30B8\30B1\30FC\30BF\306B\9069\7528\3055\308C\307E\3059\304C\3001\3057\304D\3044\5024\304C\5B9A\7FA9\3055\308C\3066\304A\308A\3001<strong>\300C\3057\304D\3044\5024\8868\793A\300D</strong>\5C5E\6027\304C<strong>\300C\30A4\30F3\30B8\30B1\30FC\30BF\4E0A\300D</strong>\306B\8A2D\5B9A\3055\308C\3066\3044\308B\5834\5408\306F\4F8B\5916\3067\3059\3002</p>'),
unistr('<p>\8272\306F\300116\9032(hex)\8868\8A18\3001RGB\30AB\30E9\30FC\30FB\30B3\30FC\30C9\307E\305F\306FHTML\30AB\30E9\30FC\540D\3092\4F7F\7528\3057\3066\6307\5B9A\3055\308C\307E\3059\300216\9032\8868\8A18\306F#xxyyzz (#\306E\5F8C\306B3\3064\306E2\6841\306E16\9032\6570)\3067\5B9A\7FA9\3055\308C\3001xx\3001yy\304A\3088\3073zz\306F\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E2\6587\5B57\306E16\9032\306E\5024\3092\8868\3057\307E\3059\3002'),
unistr('RGB\30B3\30FC\30C9\306FRGB(xxx,xxx,xxx)\3067\5B9A\7FA9\3055\308C\3001xxx\306F0\304B\3089255\306E\9593\306E\6570\5024\3067\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E8\30D3\30C3\30C8\30FB\30D0\30A4\30C8\5024\3092\8868\3057\307E\3059\3002</p>'),
unistr('<p>\30A4\30F3\30BF\30FC\30CD\30C3\30C8\3067HTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\3092\691C\7D22\3059\308B\3068\3001\4F7F\7528\3059\308B\8272\306E16\9032\30B3\30FC\30C9\307E\305F\306FRGB\30B3\30FC\30C9\304C\308F\304B\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104159696342308575)
,p_name=>'PE.PROPERTY.JET_SERIES_COLOR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104085696773308505)
,p_name=>'PE.PROPERTY.JET_SERIES_Q2_COLOR.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\306AHTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\306E\4F8B\306B\306F\6B21\306E\3082\306E\304C\3042\308A\307E\3059 -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104085422074308504)
,p_name=>'PE.PROPERTY.JET_SERIES_Q2_COLOR.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30DC\30C3\30AF\30B9\30FB\30D7\30ED\30C3\30C8\30FB\30C1\30E3\30FC\30C8\30FB\30B7\30EA\30FC\30BA\306Eq2\30BB\30B0\30E1\30F3\30C8\306B\8868\793A\3055\308C\308B\8272\3092\5165\529B\3057\307E\3059\3002<code>&COLUMN_VALUE.</code>\7F6E\63DB\3092\4F7F\7528\3067\304D\307E\3059\3002</p>'),
unistr('<p>\8272\306F\300116\9032(hex)\8868\8A18\3001RGB\30AB\30E9\30FC\30FB\30B3\30FC\30C9\307E\305F\306FHTML\30AB\30E9\30FC\540D\3092\4F7F\7528\3057\3066\6307\5B9A\3055\308C\307E\3059\300216\9032\8868\8A18\306F#xxyyzz (#\306E\5F8C\306B3\3064\306E2\6841\306E16\9032\6570)\3067\5B9A\7FA9\3055\308C\3001xx\3001yy\304A\3088\3073zz\306F\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E2\6587\5B57\306E16\9032\306E\5024\3092\8868\3057\307E\3059\3002'),
unistr('RGB\30B3\30FC\30C9\306FRGB(xxx,xxx,xxx)\3067\5B9A\7FA9\3055\308C\3001xxx\306F0\304B\3089255\306E\9593\306E\6570\5024\3067\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E8\30D3\30C3\30C8\30FB\30D0\30A4\30C8\5024\3092\8868\3057\307E\3059\3002</p>'),
unistr('<p>\30A4\30F3\30BF\30FC\30CD\30C3\30C8\3067HTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\3092\691C\7D22\3059\308B\3068\3001\4F7F\7528\3059\308B\8272\306E16\9032\30B3\30FC\30C9\307E\305F\306FRGB\30B3\30FC\30C9\304C\308F\304B\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104085288096308504)
,p_name=>'PE.PROPERTY.JET_SERIES_Q2_COLOR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('Q2\306E\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104085730610308505)
,p_name=>'PE.PROPERTY.JET_SERIES_Q3_COLOR.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\306AHTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\306E\4F8B\306B\306F\6B21\306E\3082\306E\304C\3042\308A\307E\3059 -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104085587045308504)
,p_name=>'PE.PROPERTY.JET_SERIES_Q3_COLOR.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30DC\30C3\30AF\30B9\30FB\30D7\30ED\30C3\30C8\30FB\30C1\30E3\30FC\30C8\30FB\30B7\30EA\30FC\30BA\306Eq3\30BB\30B0\30E1\30F3\30C8\306B\8868\793A\3055\308C\308B\8272\3092\5165\529B\3057\307E\3059\3002<code>&COLUMN_VALUE.</code>\7F6E\63DB\3092\4F7F\7528\3067\304D\307E\3059\3002</p>'),
unistr('<p>\8272\306F\300116\9032(hex)\8868\8A18\3001RGB\30AB\30E9\30FC\30FB\30B3\30FC\30C9\307E\305F\306FHTML\30AB\30E9\30FC\540D\3092\4F7F\7528\3057\3066\6307\5B9A\3055\308C\307E\3059\300216\9032\8868\8A18\306F#xxyyzz (#\306E\5F8C\306B3\3064\306E2\6841\306E16\9032\6570)\3067\5B9A\7FA9\3055\308C\3001xx\3001yy\304A\3088\3073zz\306F\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E2\6587\5B57\306E16\9032\306E\5024\3092\8868\3057\307E\3059\3002'),
unistr('RGB\30B3\30FC\30C9\306FRGB(xxx,xxx,xxx)\3067\5B9A\7FA9\3055\308C\3001xxx\306F0\304B\3089255\306E\9593\306E\6570\5024\3067\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E8\30D3\30C3\30C8\30FB\30D0\30A4\30C8\5024\3092\8868\3057\307E\3059\3002</p>'),
unistr('<p>\30A4\30F3\30BF\30FC\30CD\30C3\30C8\3067HTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\3092\691C\7D22\3059\308B\3068\3001\4F7F\7528\3059\308B\8272\306E16\9032\30B3\30FC\30C9\307E\305F\306FRGB\30B3\30FC\30C9\304C\308F\304B\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104085372526308504)
,p_name=>'PE.PROPERTY.JET_SERIES_Q3_COLOR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('Q3\306E\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104080589000308500)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\30FB\30B7\30EA\30FC\30BA\30FB\30BF\30A4\30D7\3092\9078\629E\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104067463216308489)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.LOV.AREA.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104067563907308489)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.LOV.BAR.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\68D2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104067394701308489)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.LOV.BOXPLOT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30C3\30AF\30B9\30FB\30D7\30ED\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104067645892308490)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.LOV.LINE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6298\308C\7DDA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104067704950308490)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.LOV.LINEWITHAREA.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\9762\4ED8\304D\6298\308C\7DDA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104067810080308490)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104181807187308594)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COLUMN_MAPPING.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30EA\30FC\30BA\30FB\30BF\30A4\30D7\5217\306E\30DE\30C3\30D4\30F3\30B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104182071333308594)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\30FB\30B7\30EA\30FC\30BA\30FB\30BF\30A4\30D7\3092\9078\629E\3057\307E\3059\3002\540C\3058\30C7\30FC\30BF\30FB\30D7\30ED\30C3\30C8\4E0A\306B\7570\306A\308B\30BF\30A4\30D7\306E\30B7\30EA\30FC\30BA\3092\7D44\307F\5408\305B\305F\30C1\30E3\30FC\30C8\3082\4F5C\6210\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104182123325308594)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.AREA.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104182610726308595)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.AREARANGE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\9762\306E\7BC4\56F2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104182209915308595)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.BAR.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\68D2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104182564121308595)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.BARRANGE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\68D2\306E\7BC4\56F2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104182386768308595)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.LINE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6298\308C\7DDA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104182404441308595)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.LINEWITHAREA.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\9762\4ED8\304D\6298\308C\7DDA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104181919570308594)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104183213873308595)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\30FB\30B7\30EA\30FC\30BA\30FB\30BF\30A4\30D7\3092\9078\629E\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104183336376308595)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.AREA.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104183967187308596)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.AREARANGE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\9762\306E\7BC4\56F2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104183440024308596)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.BAR.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\68D2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104183806083308596)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.BARRANGE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\68D2\306E\7BC4\56F2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104183765319308596)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.BUBBLE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D0\30D6\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104183563242308596)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.LINE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6298\308C\7DDA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104471028825308810)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.LINEWITHAREA.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\9762\4ED8\304D\6298\308C\7DDA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104183643767308596)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.SCATTER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6563\5E03')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104183129248308595)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104184115506308596)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RADAR.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\30FB\30B7\30EA\30FC\30BA\30FB\30BF\30A4\30D7\3092\9078\629E\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104184249501308596)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RADAR.LOV.AREA.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104184366559308596)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RADAR.LOV.AREARANGE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\9762\306E\7BC4\56F2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104184400100308596)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RADAR.LOV.LINE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6298\308C\7DDA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104184036778308596)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RADAR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104182888802308595)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RANGE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\30FB\30B7\30EA\30FC\30BA\30FB\30BF\30A4\30D7\3092\9078\629E\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104183096905308595)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RANGE.LOV.AREARANGE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\9762\306E\7BC4\56F2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104182917125308595)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RANGE.LOV.BARRANGE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\68D2\306E\7BC4\56F2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104182719113308595)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RANGE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104164937900308579)
,p_name=>'PE.PROPERTY.JET_SHOW_AXIS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\8EF8\3092\30C1\30E3\30FC\30C8\3067\30EC\30F3\30C0\30EA\30F3\30B0\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104164835284308579)
,p_name=>'PE.PROPERTY.JET_SHOW_AXIS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8EF8\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103706263754308172)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_BASELINE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\306E\30C4\30FC\30EB\30C1\30C3\30D7\306B\30D9\30FC\30B9\30E9\30A4\30F3\306E\60C5\5831\3092\8868\793A\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103705660986308172)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_BASELINE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D9\30FC\30B9\30E9\30A4\30F3\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103706049376308172)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_END.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\306E\30C4\30FC\30EB\30C1\30C3\30D7\306B\7D42\4E86\65E5\3092\8868\793A\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103705448541308171)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_END.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D42\4E86\65E5\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103706141556308172)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_PROGRESS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\306E\30C4\30FC\30EB\30C1\30C3\30D7\306B\9032\6357\3092\8868\793A\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103705597846308172)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_PROGRESS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\9032\6357\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103705734588308172)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_ROW.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\306E\30C4\30FC\30EB\30C1\30C3\30D7\306B\884C\306E\60C5\5831\3092\8868\793A\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103705159129308171)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_ROW.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103705917502308172)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_START.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\306E\30C4\30FC\30EB\30C1\30C3\30D7\306B\958B\59CB\65E5\3092\8868\793A\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103705320636308171)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_START.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\59CB\65E5\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103590711361308081)
,p_name=>'PE.PROPERTY.JET_SHOW_GAUGE_VALUE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024\3092\30C1\30E3\30FC\30C8\3067\30EC\30F3\30C0\30EA\30F3\30B0\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103590605725308081)
,p_name=>'PE.PROPERTY.JET_SHOW_GAUGE_VALUE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103705899950308172)
,p_name=>'PE.PROPERTY.JET_SHOW_LABEL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\306E\30C4\30FC\30EB\30C1\30C3\30D7\306B\30E9\30D9\30EB\3092\8868\793A\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103705240014308171)
,p_name=>'PE.PROPERTY.JET_SHOW_LABEL.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB\3092\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104153174599308569)
,p_name=>'PE.PROPERTY.JET_SHOW_TOOLTIP.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C4\30FC\30EB\30C1\30C3\30D7\3092\30C1\30E3\30FC\30C8\3067\30EC\30F3\30C0\30EA\30F3\30B0\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104153007876308569)
,p_name=>'PE.PROPERTY.JET_SHOW_TOOLTIP.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104153751388308569)
,p_name=>'PE.PROPERTY.JET_SHOW_VALUE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\306E\30C4\30FC\30EB\30C1\30C3\30D7\306B\5024\3092\8868\793A\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\3066\304F\3060\3055\3044\3002\5024\306F\30C1\30E3\30FC\30C8\554F\5408\305B\304B\3089\5C0E\51FA\3055\308C\3001\30C1\30E3\30FC\30C8\306E\30C7\30FC\30BF\306E\6A2A\306B\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104153693365308569)
,p_name=>'PE.PROPERTY.JET_SHOW_VALUE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104488462773308830)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\306E\5024\307E\305F\306F\30E9\30D9\30EB\306B\57FA\3065\3044\3066\3001\30DE\30EB\30C1\30B7\30EA\30FC\30BA\30FB\30C1\30E3\30FC\30C8\306E\30C7\30FC\30BF\306E\30BD\30FC\30C8\9806\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104473065446308811)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.LABEL-ASC.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB - \6607\9806')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104473455605308812)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.LABEL-ASC.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('X\8EF8\30E9\30D9\30EB\306B\57FA\3065\3044\3066\6607\9806\3067\30C1\30E3\30FC\30C8\3092\9806\5E8F\4ED8\3051\3059\308B\3088\3046\8A2D\5B9A\3057\307E\3059\3002\3053\308C\306F\30C7\30D5\30A9\30EB\30C8\306E\30BD\30FC\30C8\9806\3067\3059\3002 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104473163008308811)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.LABEL-DESC.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB - \964D\9806')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104473567037308812)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.LABEL-DESC.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('X\8EF8\30E9\30D9\30EB\306B\57FA\3065\3044\3066\964D\9806\3067\30C1\30E3\30FC\30C8\3092\9806\5E8F\4ED8\3051\3059\308B\3088\3046\8A2D\5B9A\3057\307E\3059\3002 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104472818091308811)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.VALUE-ASC.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024 - \6607\9806')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104473260562308812)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.VALUE-ASC.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024\306B\57FA\3065\3044\3066\6607\9806(1\30012\30013\3001...)\3067\30C1\30E3\30FC\30C8\3092\9806\5E8F\4ED8\3051\3059\308B\3088\3046\8A2D\5B9A\3057\307E\3059\3002\3053\306E\8A2D\5B9A\306F\3001\5186\30B0\30E9\30D5\30011\3064\306E\30B7\30EA\30FC\30BA\3092\4F7F\7528\3059\308B\68D2/\6298\308C\7DDA/\9762\30B0\30E9\30D5\3001\307E\305F\306F\7A4D\4E0A\3052\68D2/\9762\30B0\30E9\30D5\306B\306E\307F\4F7F\7528\3057\307E\3059\3002\968E\5C64\30B0\30EB\30FC\30D7\8EF8\3092\4F7F\7528\3059\308B\5834\5408\3001\30BD\30FC\30C8\306F\9069\7528\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104472957466308811)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.VALUE-DESC.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024 - \964D\9806')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104473338956308812)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.VALUE-DESC.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024\306B\57FA\3065\3044\3066\964D\9806(10\30019\30018\3001...)\3067\30C1\30E3\30FC\30C8\3092\9806\5E8F\4ED8\3051\3059\308B\3088\3046\8A2D\5B9A\3057\307E\3059\3002\3053\306E\8A2D\5B9A\306F\3001\5186\30B0\30E9\30D5\30011\3064\306E\30B7\30EA\30FC\30BA\3092\4F7F\7528\3059\308B\68D2/\6298\308C\7DDA/\9762\30B0\30E9\30D5\3001\307E\305F\306F\7A4D\4E0A\3052\68D2/\9762\30B0\30E9\30D5\306B\306E\307F\4F7F\7528\3057\307E\3059\3002\968E\5C64\30B0\30EB\30FC\30D7\8EF8\3092\4F7F\7528\3059\308B\5834\5408\3001\30BD\30FC\30C8\306F\9069\7528\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104472756187308811)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BD\30FC\30C8\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104318281052308696)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_COLOR.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\306AHTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\306E\4F8B\306B\306F\6B21\306E\3082\306E\304C\3042\308A\307E\3059 -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104318163612308696)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_COLOR.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\3055\308C\305F\5C5E\6027\306E\30D5\30A9\30F3\30C8\306E\8868\793A\306B\4F7F\7528\3055\308C\308B\8272\3092\5165\529B\3057\307E\3059\3002</p>'),
unistr('<p>\8272\306F\300116\9032(hex)\8868\8A18\3001RGB\30AB\30E9\30FC\30FB\30B3\30FC\30C9\307E\305F\306FHTML\30AB\30E9\30FC\540D\3092\4F7F\7528\3057\3066\6307\5B9A\3055\308C\307E\3059\300216\9032\8868\8A18\306F#xxyyzz (#\306E\5F8C\306B3\3064\306E2\6841\306E16\9032\6570)\3067\5B9A\7FA9\3055\308C\3001xx\3001yy\304A\3088\3073zz\306F\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E2\6587\5B57\306E16\9032\306E\5024\3092\8868\3057\307E\3059\3002'),
unistr('RGB\30B3\30FC\30C9\306FRGB(xxx,xxx,xxx)\3067\5B9A\7FA9\3055\308C\3001xxx\306F0\304B\3089255\306E\9593\306E\6570\5024\3067\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E8\30D3\30C3\30C8\30FB\30D0\30A4\30C8\5024\3092\8868\3057\307E\3059\3002</p>'),
unistr('<p>\30A4\30F3\30BF\30FC\30CD\30C3\30C8\3067HTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\3092\691C\7D22\3059\308B\3068\3001\4F7F\7528\3059\308B\8272\306E16\9032\30B3\30FC\30C9\307E\305F\306FRGB\30B3\30FC\30C9\304C\308F\304B\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104317796663308695)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_COLOR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30F3\30C8\30FB\30AB\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104317823703308695)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30F3\30C8\30FB\30D5\30A1\30DF\30EA\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104319517334308697)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.ARIAL BLACK.D'
,p_message_language=>'ja'
,p_message_text=>'Arial Black'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104319415548308696)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.ARIAL.D'
,p_message_language=>'ja'
,p_message_text=>'Arial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104319632985308697)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.BOOKMAN.D'
,p_message_language=>'ja'
,p_message_text=>'Bookman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104319791406308697)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.COMIC SANS MS.D'
,p_message_language=>'ja'
,p_message_text=>'Comic Sans MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104319942628308697)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.COURIER NEW.D'
,p_message_language=>'ja'
,p_message_text=>'Courier New'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104319828146308697)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'ja'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104320008036308697)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.GARAMOND.D'
,p_message_language=>'ja'
,p_message_text=>'Garamond'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104320122158308697)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.GEORGIA.D'
,p_message_language=>'ja'
,p_message_text=>'Georgia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104320249093308697)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'ja'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104320321210308697)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.IMPACT.D'
,p_message_language=>'ja'
,p_message_text=>'Impact'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104320484379308697)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.PALATINO.D'
,p_message_language=>'ja'
,p_message_text=>'Palatino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104320639560308697)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.TIMES NEW ROMAN.D'
,p_message_language=>'ja'
,p_message_text=>'Times New Roman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104320545953308697)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'ja'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104320746748308697)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.TREBUCHET MS.D'
,p_message_language=>'ja'
,p_message_text=>'Trebuchet MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104320898254308698)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.VERDANA.D'
,p_message_language=>'ja'
,p_message_text=>'Verdana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104317412651308695)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30F3\30C8\30FB\30D5\30A1\30DF\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104318090130308695)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30F3\30C8\30FB\30B5\30A4\30BA\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104318453468308696)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.10.D'
,p_message_language=>'ja'
,p_message_text=>'10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104318507839308696)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.12.D'
,p_message_language=>'ja'
,p_message_text=>'12'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104318652637308696)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.14.D'
,p_message_language=>'ja'
,p_message_text=>'14'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104318713589308696)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.16.D'
,p_message_language=>'ja'
,p_message_text=>'16'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104318820010308696)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.18.D'
,p_message_language=>'ja'
,p_message_text=>'18'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104318974198308696)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.20.D'
,p_message_language=>'ja'
,p_message_text=>'20'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104319061598308696)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.22.D'
,p_message_language=>'ja'
,p_message_text=>'22'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104318355915308696)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.8.D'
,p_message_language=>'ja'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104317613576308695)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30F3\30C8\30FB\30B5\30A4\30BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104317947579308695)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_STYLE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30F3\30C8\30FB\30B9\30BF\30A4\30EB\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104319260526308696)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_STYLE.LOV.ITALIC.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30BF\30EA\30C3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104319103897308696)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_STYLE.LOV.NORMAL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A19\6E96')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104319314298308696)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_STYLE.LOV.OBLIQUE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\659C\7DDA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104317589057308695)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_STYLE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30F3\30C8\30FB\30B9\30BF\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104482188334308818)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AC\30F3\30C8\30FB\30C1\30E3\30FC\30C8\306E\30BF\30B9\30AF\30FB\30E9\30D9\30EB\306E\4F4D\7F6E\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104482482361308818)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.END.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D42\4E86')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104482861001308819)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.END.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30B9\30AF\30FB\30E9\30D9\30EB\306F\3001\30AC\30F3\30C8\30FB\30C1\30E3\30FC\30C8\306E\30BF\30B9\30AF\30FB\30D0\30FC\306E\672B\5C3E\306B\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104482536811308818)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNERCENTER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5185\90E8\4E2D\592E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104482931081308819)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNERCENTER.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30B9\30AF\30FB\30E9\30D9\30EB\306F\3001\30AC\30F3\30C8\30FB\30C1\30E3\30FC\30C8\306E\30BF\30B9\30AF\30FB\30D0\30FC\306E\5185\90E8\4E2D\592E\306B\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104482757396308819)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNEREND.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5185\90E8\7D42\4E86')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104483195420308819)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNEREND.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30B9\30AF\30FB\30E9\30D9\30EB\306F\3001\30AC\30F3\30C8\30FB\30C1\30E3\30FC\30C8\306E\30BF\30B9\30AF\30FB\30D0\30FC\306E\5185\90E8\7D42\4E86\306B\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104482622150308818)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNERSTART.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5185\90E8\958B\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104483058926308819)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNERSTART.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30B9\30AF\30FB\30E9\30D9\30EB\306F\3001\30AC\30F3\30C8\30FB\30C1\30E3\30FC\30C8\306E\30BF\30B9\30AF\30FB\30D0\30FC\306E\5185\90E8\958B\59CB\306B\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104482234100308818)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.START.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104482333956308818)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.START.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30B9\30AF\30FB\30E9\30D9\30EB\306F\3001\30AC\30F3\30C8\30FB\30C1\30E3\30FC\30C8\306E\30BF\30B9\30AF\30FB\30D0\30FC\306E\5148\982D\306B\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104482042321308818)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30B9\30AF\30FB\30E9\30D9\30EB\306E\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103619077196308101)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_COLORS.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl>',
unistr('<dt>\8272\306E\30AB\30F3\30DE\533A\5207\308A\30EA\30B9\30C8:</dt>'),
'<dd><pre>',
'<strong>red,yellow,blue</strong>',
'</pre></dd>',
unistr('<dt>\6B21\306E\3088\3046\306A\8272\3092\623B\3059\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\306E\30AB\30F3\30DE\533A\5207\308A\30EA\30B9\30C8:</dt>'),
'<dd><pre>',
unistr('<code>&amp;ITEM.</code>\306E\69CB\6587\3002\4F8B: <strong><code>&amp;ITEM_1.</code>,<code>&amp;ITEM_2.</code>,<code>&amp;ITEM_3.</code></strong>'),
'</pre></dd>',
unistr('<dt>\6B21\306E\3088\3046\306A\8272\3092\623B\3059\5217\306E\30AB\30F3\30DE\533A\5207\308A\30EA\30B9\30C8:</dt>'),
'<dd><pre>',
unistr('<code>&amp;COLUMN_NAME.</code>\306E\69CB\6587\3002\4F8B: <strong><code>&amp;COLUMN_NAME_1.</code>,<code>&amp;COLUMN_NAME_2.</code>,<code>&amp;COLUMN_NAME_3.</code></strong>'),
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103618913313308101)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_COLORS.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30B9\30C6\30FC\30BF\30B9\30FB\30E1\30FC\30BF\30FC\30FB\30B2\30FC\30B8\30FB\30C1\30E3\30FC\30C8\306B\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\308B\3057\304D\3044\5024\306E\4E0A\9650\3092\8B58\5225\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\8272\3092\5165\529B\3057\307E\3059\3002'),
unistr('\3057\304D\3044\5024\304C\8907\6570\306E\5834\5408\3001\30AB\30F3\30DE\3067\533A\5207\3089\308C\305F\30EA\30B9\30C8\3092\4F7F\7528\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103600329747308088)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_COLORS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103704001937308170)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30C6\30FC\30BF\30B9\30FB\30E1\30FC\30BF\30FC\30FB\30B2\30FC\30B8\30FB\30C1\30E3\30FC\30C8\306B\3057\304D\3044\5024\3092\8868\793A\3059\308B\65B9\6CD5\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103618478861308101)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.ALL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103618502402308101)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.ALL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<strong>\3057\304D\3044\5024</strong>\5C5E\6027\3092\4F7F\7528\3057\3066\5B9A\7FA9\3055\308C\305F\3059\3079\3066\306E\3057\304D\3044\5024\306F\3001\30C1\30E3\30FC\30C8\306E\63CF\753B\30A8\30EA\30A2\306B\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103618724499308101)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.CURRENTONLY.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\3057\304D\3044\5024\306E\307F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103618822812308101)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.CURRENTONLY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<strong>\3057\304D\3044\5024</strong>\5C5E\6027\3092\4F7F\7528\3057\3066\5B9A\7FA9\3055\308C\305F\73FE\5728\306E\3057\304D\3044\5024\306F\3001\30C1\30E3\30FC\30C8\306E\63CF\753B\30A8\30EA\30A2\306B\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103618681127308101)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.ONINDICATOR.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30B8\30B1\30FC\30BF\4E0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103704149215308170)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.ONINDICATOR.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<strong>\3057\304D\3044\5024</strong>\5C5E\6027\3092\4F7F\7528\3057\3066\5B9A\7FA9\3055\308C\305F\73FE\5728\306E\3057\304D\3044\5024\306F\3001\30C1\30E3\30FC\30C8\306E\30A4\30F3\30B8\30B1\30FC\30BF\306B\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103618361506308101)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103618223622308101)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_VALUES.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl>',
unistr('<dt>\9759\7684\6570\5024\306E\30AB\30F3\30DE\533A\5207\308A\30EA\30B9\30C8:</dt>'),
'<dd><pre>',
'<strong>5,10,15</strong>',
'</pre></dd>',
unistr('<dt>\6B21\306E\3088\3046\306A\6570\5024\3092\623B\3059\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\306E\30AB\30F3\30DE\533A\5207\308A\30EA\30B9\30C8:</dt>'),
'<dd><pre>',
unistr('<code>&amp;ITEM.</code>\306E\69CB\6587\3002\4F8B: <strong><code>&amp;ITEM_1.</code>,<code>&amp;ITEM_2.</code>,<code>&amp;ITEM_3.</code></strong>'),
'</pre></dd>',
unistr('<dt>\6B21\306E\3088\3046\306A\6570\5024\3092\623B\3059\5217\306E\30AB\30F3\30DE\533A\5207\308A\30EA\30B9\30C8:</dt>'),
'<dd><pre>',
unistr('<code>&amp;COLUMN_NAME.</code>\306E\69CB\6587\3002\4F8B: <strong><code>&amp;COLUMN_NAME_1.</code>,<code>&amp;COLUMN_NAME_2.</code>,<code>&amp;COLUMN_NAME_3.</code></strong>'),
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103600259313308088)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_VALUES.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30B9\30C6\30FC\30BF\30B9\30FB\30E1\30FC\30BF\30FC\30FB\30B2\30FC\30B8\30FB\30C1\30E3\30FC\30C8\306B\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\308B\3057\304D\3044\5024\306E\4E0A\9650\3092\8B58\5225\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\6570\5024\3092\5165\529B\3057\307E\3059\3002'),
unistr('\3057\304D\3044\5024\304C\8907\6570\306E\5834\5408\3001\30AB\30F3\30DE\3067\533A\5207\3089\308C\305F\30EA\30B9\30C8\3092\4F7F\7528\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103599968087308088)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_VALUES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104121342801308534)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_COLOR.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\306AHTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\306E\4F8B\306B\306F\6B21\306E\3082\306E\304C\3042\308A\307E\3059 -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103857423966308291)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_COLOR.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\3055\308C\305F\5C5E\6027\306E\30D5\30A9\30F3\30C8\306E\8868\793A\306B\4F7F\7528\3055\308C\308B\8272\3092\5165\529B\3057\307E\3059\3002</p>'),
unistr('<p>\8272\306F\300116\9032(hex)\8868\8A18\3001RGB\30AB\30E9\30FC\30FB\30B3\30FC\30C9\307E\305F\306FHTML\30AB\30E9\30FC\540D\3092\4F7F\7528\3057\3066\6307\5B9A\3055\308C\307E\3059\300216\9032\8868\8A18\306F#xxyyzz (#\306E\5F8C\306B3\3064\306E2\6841\306E16\9032\6570)\3067\5B9A\7FA9\3055\308C\3001xx\3001yy\304A\3088\3073zz\306F\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E2\6587\5B57\306E16\9032\306E\5024\3092\8868\3057\307E\3059\3002'),
unistr('RGB\30B3\30FC\30C9\306FRGB(xxx,xxx,xxx)\3067\5B9A\7FA9\3055\308C\3001xxx\306F0\304B\3089255\306E\9593\306E\6570\5024\3067\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E8\30D3\30C3\30C8\30FB\30D0\30A4\30C8\5024\3092\8868\3057\307E\3059\3002</p>'),
unistr('<p>\30A4\30F3\30BF\30FC\30CD\30C3\30C8\3067HTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\3092\691C\7D22\3059\308B\3068\3001\4F7F\7528\3059\308B\8272\306E16\9032\30B3\30FC\30C9\307E\305F\306FRGB\30B3\30FC\30C9\304C\308F\304B\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103854438640308289)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_COLOR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30F3\30C8\30FB\30AB\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103856065382308290)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30F3\30C8\30FB\30D5\30A1\30DF\30EA\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103854622135308289)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.ARIAL BLACK.D'
,p_message_language=>'ja'
,p_message_text=>'Arial Black'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103854538156308289)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.ARIAL.D'
,p_message_language=>'ja'
,p_message_text=>'Arial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103854733405308289)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.BOOKMAN.D'
,p_message_language=>'ja'
,p_message_text=>'Bookman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103854887193308289)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.COMIC SANS MS.D'
,p_message_language=>'ja'
,p_message_text=>'Comic Sans MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103855022882308289)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.COURIER NEW.D'
,p_message_language=>'ja'
,p_message_text=>'Courier New'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103854995120308289)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'ja'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103855152869308289)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.GARAMOND.D'
,p_message_language=>'ja'
,p_message_text=>'Garamond'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103855217484308289)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.GEORGIA.D'
,p_message_language=>'ja'
,p_message_text=>'Georgia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103855387853308289)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'ja'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103855483617308289)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.IMPACT.D'
,p_message_language=>'ja'
,p_message_text=>'Impact'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103855553093308289)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.PALATINO.D'
,p_message_language=>'ja'
,p_message_text=>'Palatino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103855716298308290)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.TIMES NEW ROMAN.D'
,p_message_language=>'ja'
,p_message_text=>'Times New Roman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103855632062308290)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'ja'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103855865399308290)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.TREBUCHET MS.D'
,p_message_language=>'ja'
,p_message_text=>'Trebuchet MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103855919310308290)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.VERDANA.D'
,p_message_language=>'ja'
,p_message_text=>'Verdana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103854134743308288)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30F3\30C8\30FB\30D5\30A1\30DF\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103856551552308290)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30F3\30C8\30FB\30B5\30A4\30BA\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103856786048308290)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.10.D'
,p_message_language=>'ja'
,p_message_text=>'10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103856894686308290)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.12.D'
,p_message_language=>'ja'
,p_message_text=>'12'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103856974158308291)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.14.D'
,p_message_language=>'ja'
,p_message_text=>'14'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103857049093308291)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.16.D'
,p_message_language=>'ja'
,p_message_text=>'16'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103857198547308291)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.18.D'
,p_message_language=>'ja'
,p_message_text=>'18'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103857244688308291)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.20.D'
,p_message_language=>'ja'
,p_message_text=>'20'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103857362936308291)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.22.D'
,p_message_language=>'ja'
,p_message_text=>'22'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103856698046308290)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.8.D'
,p_message_language=>'ja'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103854308533308289)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30F3\30C8\30FB\30B5\30A4\30BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103856169778308290)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_STYLE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30F3\30C8\30FB\30B9\30BF\30A4\30EB\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103856340154308290)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_STYLE.LOV.ITALIC.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30BF\30EA\30C3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103856224681308290)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_STYLE.LOV.NORMAL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A19\6E96')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103856451653308290)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_STYLE.LOV.OBLIQUE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\659C\7DDA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103854215574308288)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_STYLE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30F3\30C8\30FB\30B9\30BF\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104148578923308566)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\3067\8868\793A\3059\308B\6642\9593\8EF8\306E\30BF\30A4\30D7\3092\9078\629E\3057\307E\3059\3002\3053\306E\8A2D\5B9A\3067\306F\3001\30C1\30E3\30FC\30C8\30FB\30C7\30FC\30BF\304C\53E4\3044\3082\306E\304B\3089\9806\306B\81EA\52D5\7684\306B\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\307E\3059\3002\30C7\30FC\30BF\3092\65B0\3057\3044\3082\306E\304B\3089\9806\306B\30EC\30F3\30C0\30EA\30F3\30B0\3059\308B\5834\5408\306F\4F7F\7528\3057\306A\3044\3067\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104148648583308566)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.AUTO.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104277542559308666)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.AUTO.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\308B\30C7\30FC\30BF\306B\57FA\3065\3044\3066\3001\30C1\30E3\30FC\30C8\306EOracle JET\5B9A\7FA9\6E08\30C7\30D5\30A9\30EB\30C8\6642\9593\8EF8\8A2D\5B9A\3092\9069\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104148776946308566)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.DISABLED.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104277675529308666)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.DISABLED.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\306B\6642\9593\8EF8\30BF\30A4\30D7\8A2D\5B9A\3092\9069\7528\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104148853147308566)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.ENABLED.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6709\52B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104277707143308666)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.ENABLED.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\306B\6642\9593\8EF8\30BF\30A4\30D7\8A2D\5B9A\3092\9069\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104148960725308566)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.MIXEDFREQUENCY.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6DF7\5408\983B\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104187848293308599)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.MIXEDFREQUENCY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\6DF7\5408\983B\5EA6\3067\30C1\30E3\30FC\30C8\8EF8\306B\8868\793A\3055\308C\308B\6642\9593\5024\3002\30C7\30FC\30BF\306E\6642\9593\5024\306F\5909\5316\3059\308B\53EF\80FD\6027\304C\3042\308B\305F\3081\3001\7A4D\4E0A\3052\306F\30B5\30DD\30FC\30C8\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104187988689308600)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.SKIPGAPS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\9593\9694\306E\30B9\30AD\30C3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104188017563308600)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.SKIPGAPS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\8EF8\306B\8868\793A\3055\308C\308B\6642\9593\5024\306F\3001\30C7\30FC\30BF\306B\5B58\5728\3059\308B\6642\9593\9593\9694\306B\304B\304B\308F\3089\305A\3001\4E00\5B9A\306E\9593\9694\3067\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104148488145308565)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6642\9593\8EF8\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104121262605308534)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_COLOR.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\306AHTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\306E\4F8B\306B\306F\6B21\306E\3082\306E\304C\3042\308A\307E\3059 -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103853639589308288)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_COLOR.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\3055\308C\305F\5C5E\6027\306E\30D5\30A9\30F3\30C8\306E\8868\793A\306B\4F7F\7528\3055\308C\308B\8272\3092\5165\529B\3057\307E\3059\3002</p>'),
unistr('<p>\8272\306F\300116\9032(hex)\8868\8A18\3001RGB\30AB\30E9\30FC\30FB\30B3\30FC\30C9\307E\305F\306FHTML\30AB\30E9\30FC\540D\3092\4F7F\7528\3057\3066\6307\5B9A\3055\308C\307E\3059\300216\9032\8868\8A18\306F#xxyyzz (#\306E\5F8C\306B3\3064\306E2\6841\306E16\9032\6570)\3067\5B9A\7FA9\3055\308C\3001xx\3001yy\304A\3088\3073zz\306F\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E2\6587\5B57\306E16\9032\306E\5024\3092\8868\3057\307E\3059\3002'),
unistr('RGB\30B3\30FC\30C9\306FRGB(xxx,xxx,xxx)\3067\5B9A\7FA9\3055\308C\3001xxx\306F0\304B\3089255\306E\9593\306E\6570\5024\3067\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E8\30D3\30C3\30C8\30FB\30D0\30A4\30C8\5024\3092\8868\3057\307E\3059\3002</p>'),
unistr('<p>\30A4\30F3\30BF\30FC\30CD\30C3\30C8\3067HTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\3092\691C\7D22\3059\308B\3068\3001\4F7F\7528\3059\308B\8272\306E16\9032\30B3\30FC\30C9\307E\305F\306FRGB\30B3\30FC\30C9\304C\308F\304B\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103853589698308288)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_COLOR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30F3\30C8\30FB\30AB\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103853240586308288)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30F3\30C8\30FB\30D5\30A1\30DF\30EA\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103851847202308287)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.ARIAL BLACK.D'
,p_message_language=>'ja'
,p_message_text=>'Arial Black'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103851702137308287)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.ARIAL.D'
,p_message_language=>'ja'
,p_message_text=>'Arial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103851929139308287)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.BOOKMAN.D'
,p_message_language=>'ja'
,p_message_text=>'Bookman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103852043786308287)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.COMIC SANS MS.D'
,p_message_language=>'ja'
,p_message_text=>'Comic Sans MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103852285429308287)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.COURIER NEW.D'
,p_message_language=>'ja'
,p_message_text=>'Courier New'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103852148118308287)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'ja'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103852365851308287)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.GARAMOND.D'
,p_message_language=>'ja'
,p_message_text=>'Garamond'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103852483637308287)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.GEORGIA.D'
,p_message_language=>'ja'
,p_message_text=>'Georgia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103852529886308287)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'ja'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103852643531308287)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.IMPACT.D'
,p_message_language=>'ja'
,p_message_text=>'Impact'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103852765873308287)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.PALATINO.D'
,p_message_language=>'ja'
,p_message_text=>'Palatino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103852900168308287)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.TIMES NEW ROMAN.D'
,p_message_language=>'ja'
,p_message_text=>'Times New Roman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103852888366308287)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'ja'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103853029142308288)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.TREBUCHET MS.D'
,p_message_language=>'ja'
,p_message_text=>'Trebuchet MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103853132478308288)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.VERDANA.D'
,p_message_language=>'ja'
,p_message_text=>'Verdana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103850332830308286)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30F3\30C8\30FB\30D5\30A1\30DF\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103853407290308288)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30F3\30C8\30FB\30B5\30A4\30BA\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103851009337308286)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.10.D'
,p_message_language=>'ja'
,p_message_text=>'10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103851104687308286)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.12.D'
,p_message_language=>'ja'
,p_message_text=>'12'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103851252312308286)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.14.D'
,p_message_language=>'ja'
,p_message_text=>'14'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103851361238308286)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.16.D'
,p_message_language=>'ja'
,p_message_text=>'16'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103851457582308286)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.18.D'
,p_message_language=>'ja'
,p_message_text=>'18'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103851566521308286)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.20.D'
,p_message_language=>'ja'
,p_message_text=>'20'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103851610107308287)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.22.D'
,p_message_language=>'ja'
,p_message_text=>'22'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103850911144308286)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.8.D'
,p_message_language=>'ja'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103850596247308286)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30F3\30C8\30FB\30B5\30A4\30BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103853325983308288)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_STYLE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30F3\30C8\30FB\30B9\30BF\30A4\30EB\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103850755697308286)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_STYLE.LOV.ITALIC.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30BF\30EA\30C3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103850687457308286)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_STYLE.LOV.NORMAL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A19\6E96')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103850838900308286)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_STYLE.LOV.OBLIQUE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\659C\7DDA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103850406363308286)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_STYLE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30F3\30C8\30FB\30B9\30BF\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104474823452308813)
,p_name=>'PE.PROPERTY.JET_VERTICAL_GRID.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\306E\5782\76F4\30B0\30EA\30C3\30C9\7DDA\3092\8868\793A\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104474324705308812)
,p_name=>'PE.PROPERTY.JET_VERTICAL_GRID.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5782\76F4\30B0\30EA\30C3\30C9\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104188846380308600)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30C1\30E3\30FC\30C8\306E\30BA\30FC\30E0\304A\3088\3073\30B9\30AF\30ED\30FC\30EB\306E\52D5\4F5C\3092\6307\5B9A\3057\307E\3059\3002<strong>\30E9\30A4\30D6</strong>\52D5\4F5C\306F\3001\30C1\30E3\30FC\30C8\304C\64CD\4F5C\3055\308C\308B\3068\7D99\7D9A\7684\306B\66F4\65B0\3055\308C\308B\3053\3068\3092\610F\5473\3057\3001'),
unistr('        <strong>\9045\5EF6</strong>\306F\3001\30BA\30FC\30E0/\30B9\30AF\30ED\30FC\30EB\306E\30A2\30AF\30B7\30E7\30F3\304C\5B8C\4E86\3059\308B\307E\3067\66F4\65B0\3092\5F85\6A5F\3059\308B\3053\3068\3092\610F\5473\3057\307E\3059\3002<strong>\30E9\30A4\30D6</strong>\30FB\30BA\30FC\30E0\304A\3088\3073\30B9\30AF\30ED\30FC\30EB\306F\3001\6700\9069\306A\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\30FB\30A8\30AF\30B9\30DA\30EA\30A8\30F3\30B9\3092\63D0\4F9B\3057\307E\3059\3002\5927\304D\3044\30C7\30FC\30BF\30FB\30BB\30C3\30C8\307E\305F\306F'),
unistr('        \9045\3044\30AF\30E9\30A4\30A2\30F3\30C8\74B0\5883\306E\30EC\30F3\30C0\30EA\30F3\30B0\30FB\30D1\30D5\30A9\30FC\30DE\30F3\30B9\307E\305F\306F\6709\7528\6027\306F\4FDD\8A3C\3055\308C\307E\305B\3093\3002\30D1\30D5\30A9\30FC\30DE\30F3\30B9\304C\554F\984C\3067\3042\308B\5834\5408\3001<strong>\9045\5EF6</strong>\30BA\30FC\30E0\304A\3088\3073\30B9\30AF\30ED\30FC\30EB\3092\304B\308F\308A\306B\4F7F\7528\3057\3066\304F\3060\3055\3044\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104149147908308566)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30C1\30E3\30FC\30C8\306E\30BA\30FC\30E0\304A\3088\3073\30B9\30AF\30ED\30FC\30EB\306E\52D5\4F5C\3092\6307\5B9A\3057\307E\3059\3002'),
unistr('        \30BA\30FC\30E0\304A\3088\3073\30B9\30AF\30ED\30FC\30EB\306B\3088\308A\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\3001\30DE\30A6\30B9\30FB\30DB\30A4\30FC\30EB\307E\305F\306F2\672C\6307\306E\30D4\30F3\30C1\3092\4F7F\7528\3057\3001\63CF\753B\30A8\30EA\30A2\306E\30C9\30E9\30C3\30B0\306A\3069\306E\30B8\30A7\30B9\30C1\30E3\3092\4F7F\7528\3057\3066\8868\793A\3055\308C\308B\5024\306E\30B5\30A4\30BA\3092\5909\66F4\3057\3001\30C1\30E3\30FC\30C8\5185\3092\30CA\30D3\30B2\30FC\30C8\3057\3066\7570\306A\308B\30C1\30E3\30FC\30C8\5024\3092\8868\793A\3067\304D\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104149386333308566)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.DELAYED.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\9045\5EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104228505819308630)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.DELAYED.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BA\30FC\30E0/\30B9\30AF\30ED\30FC\30EB\306E\30A2\30AF\30B7\30E7\30F3\304C\5B8C\4E86\3059\308B\307E\3067\3001\30C7\30FC\30BF\8868\793A\306E\5909\66F4\3092\5F85\6A5F\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104149405380308566)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.DELAYEDSCROLLONLY.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\9045\5EF6\30B9\30AF\30ED\30FC\30EB\306E\307F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104228667355308631)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.DELAYEDSCROLLONLY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AF\30ED\30FC\30EB\306E\30A2\30AF\30B7\30E7\30F3\304C\5B8C\4E86\3059\308B\307E\3067\3001\30C7\30FC\30BF\8868\793A\306E\5909\66F4\3092\5F85\6A5F\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104149505059308566)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.LIVE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30A4\30D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104228716681308631)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.LIVE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30E9\30A4\30D6\52D5\4F5C\306F\3001\30C1\30E3\30FC\30C8\304C\64CD\4F5C\3055\308C\308B\3068\7D99\7D9A\7684\306B\66F4\65B0\3055\308C\308B\3053\3068\3092\610F\5473\3057\307E\3059\3002'),
unistr('        \5927\304D\3044\30C7\30FC\30BF\30FB\30BB\30C3\30C8\307E\305F\306F\9045\3044\30AF\30E9\30A4\30A2\30F3\30C8\74B0\5883\306E\5834\5408\3001<strong>\300C\9045\5EF6\300D</strong>\3092\9078\629E\3059\308B\3053\3068\3092\304A\85A6\3081\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104149636772308566)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.LIVESCROLLONLY.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30A4\30D6\30FB\30B9\30AF\30ED\30FC\30EB\306E\307F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104228884485308631)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.LIVESCROLLONLY.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30E9\30A4\30D6\30FB\30B9\30AF\30ED\30FC\30EB\306E\307F\52D5\4F5C\306F\3001\30C1\30E3\30FC\30C8\304C\30B9\30AF\30ED\30FC\30EB\3055\308C\308B\3068\7D99\7D9A\7684\306B\66F4\65B0\3055\308C\308B\3053\3068\3092\610F\5473\3057\307E\3059\3002'),
unistr('        \5927\304D\3044\30C7\30FC\30BF\30FB\30BB\30C3\30C8\307E\305F\306F\9045\3044\30AF\30E9\30A4\30A2\30F3\30C8\74B0\5883\306E\5834\5408\3001<strong>\300C\9045\5EF6\30B9\30AF\30ED\30FC\30EB\306E\307F\300D</strong>\306E\9078\629E\3092\691C\8A0E\3057\3066\304F\3060\3055\3044\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104149244115308566)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.OFF.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\3044\3044\3048')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104228408053308630)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.OFF.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BA\30FC\30E0\304A\3088\3073\30B9\30AF\30ED\30FC\30EB\306F\30C1\30E3\30FC\30C8\306B\5BFE\3057\3066\7121\52B9\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104149020196308566)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BA\30FC\30E0\3068\30B9\30AF\30ED\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104693317370308995)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\306E\30BA\30FC\30E0\65B9\5411\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104693457607308995)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.AUTO.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E21\8EF8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104693577771308995)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.AUTO.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('X\8EF8\3068Y\8EF8\306E\4E21\65B9\5411\306B\30BA\30FC\30E0\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104693652260308995)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.X.D'
,p_message_language=>'ja'
,p_message_text=>unistr('X\8EF8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104693754154308995)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.X.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('X\8EF8\65B9\5411\306B\306E\307F\30BA\30FC\30E0\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104693833996308995)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.Y.D'
,p_message_language=>'ja'
,p_message_text=>unistr('Y\8EF8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104693961307308995)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.Y.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('Y\8EF8\65B9\5411\306B\306E\307F\30BA\30FC\30E0\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104693291127308994)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BA\30FC\30E0\65B9\5411')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104477531733308815)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_DAYS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\3067\65E5\306E\30B9\30B1\30FC\30EB\3078\306E\30BA\30FC\30E0\3092\8A31\53EF\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104476331951308814)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_DAYS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104477414498308815)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_HOURS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\3067\6642\9593\306E\30B9\30B1\30FC\30EB\3078\306E\30BA\30FC\30E0\3092\8A31\53EF\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104476031459308814)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_HOURS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104477319448308815)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_MINUTES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\3067\5206\306E\30B9\30B1\30FC\30EB\3078\306E\30BA\30FC\30E0\3092\8A31\53EF\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104475985256308814)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_MINUTES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5206')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104477770934308815)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_MONTHS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\3067\6708\306E\30B9\30B1\30FC\30EB\3078\306E\30BA\30FC\30E0\3092\8A31\53EF\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104476706330308814)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_MONTHS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6708')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104477891643308815)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_QUARTERS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\3067\56DB\534A\671F\306E\30B9\30B1\30FC\30EB\3078\306E\30BA\30FC\30E0\3092\8A31\53EF\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104476987555308814)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_QUARTERS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\56DB\534A\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104477229419308815)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_SECONDS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\3067\79D2\306E\30B9\30B1\30FC\30EB\3078\306E\30BA\30FC\30E0\3092\8A31\53EF\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104475692021308813)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_SECONDS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\79D2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104477601668308815)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_WEEKS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\3067\9031\306E\30B9\30B1\30FC\30EB\3078\306E\30BA\30FC\30E0\3092\8A31\53EF\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104476528109308814)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_WEEKS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\9031')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104477945607308815)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_YEARS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\3067\5E74\306E\30B9\30B1\30FC\30EB\3078\306E\30BA\30FC\30E0\3092\8A31\53EF\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104477175095308815)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_YEARS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5E74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104281163537308668)
,p_name=>'PE.PROPERTY.JS_CONDITION.COMPONENT_PROPERTY.DYNAMIC_ACTION_ACTION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3\3092\8D77\52D5\3059\308B\304B\3069\3046\304B\3092\5236\5FA1\3059\308B\30AF\30E9\30A4\30A2\30F3\30C8\5074\6761\4EF6\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103876224168308305)
,p_name=>'PE.PROPERTY.JS_CONDITION.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('True\307E\305F\306FFalse\306E\30A2\30AF\30B7\30E7\30F3\3092\8D77\52D5\3059\308B\304B\3069\3046\304B\3092\5236\5FA1\3059\308B\30AF\30E9\30A4\30A2\30F3\30C8\5074\306E\6761\4EF6\3092\6307\5B9A\3057\307E\3059\3002\6761\4EF6\304C'),
unistr('                                  True\306B\8A55\4FA1\3055\308C\308B\3068True\30A2\30AF\30B7\30E7\30F3\304C\8D77\52D5\3057\3001\6761\4EF6\304CFalse\306B\8A55\4FA1\3055\308C\308B\3068False\30A2\30AF\30B7\30E7\30F3\304C\8D77\52D5\3057\307E\3059\3002'),
unistr('                                  \6761\4EF6\3092\6307\5B9A\3057\306A\3044\3068\3001True\30A2\30AF\30B7\30E7\30F3\306E\307F\304C\8D77\52D5\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104387362986308748)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.EQUALS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0 = \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104744015264309038)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.EQUALS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3057\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\304C\6307\5B9A\3057\305F<em>\5024</em>\3068\7B49\3057\3044\304B\3069\3046\304B\3092\30C1\30A7\30C3\30AF\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104387503754308748)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.GREATER_THAN.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0 > \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104744278496309038)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.GREATER_THAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3057\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\304C\6307\5B9A\3057\305F<em>\5024</em>\3088\308A\5927\304D\3044\304B\3069\3046\304B\3092\30C1\30A7\30C3\30AF\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104387618398308748)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.GREATER_THAN_OR_EQUAL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0 >= \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104744399281309038)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.GREATER_THAN_OR_EQUAL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3057\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\304C\6307\5B9A\3057\305F<em>\5024</em>\4EE5\4E0A\3067\3042\308B\304B\3069\3046\304B\3092\30C1\30A7\30C3\30AF\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104388134579308748)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.IN_LIST.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306F\30EA\30B9\30C8\306B\542B\307E\308C\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104744859502309038)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.IN_LIST.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3057\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\304C\6307\5B9A\3057\305F<em>\30EA\30B9\30C8</em>\5185\306B\3042\308B\304B\3069\3046\304B\3092\30C1\30A7\30C3\30AF\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104388389127308748)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.JAVASCRIPT_EXPRESSION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('JavaScript\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104745084655309038)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.JAVASCRIPT_EXPRESSION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\6307\5B9A\3055\308C\305FJavaScript\5F0F\3092\8A55\4FA1\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104387740138308748)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.LESS_THAN.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0 < \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104744418440309038)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.LESS_THAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3057\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\304C\6307\5B9A\3057\305F<em>\5024</em>\3088\308A\5C0F\3055\3044\304B\3069\3046\304B\3092\30C1\30A7\30C3\30AF\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104387882513308748)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.LESS_THAN_OR_EQUAL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0 <= \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104744594983309038)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.LESS_THAN_OR_EQUAL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3057\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\304C\6307\5B9A\3057\305F<em>\5024</em>\4EE5\4E0B\3067\3042\308B\304B\3069\3046\304B\3092\30C1\30A7\30C3\30AF\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104387499829308748)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_EQUALS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0 != \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104744142796309038)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_EQUALS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3057\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\304C\6307\5B9A\3057\305F<em>\5024</em>\3068\7B49\3057\304F\306A\3044\304B\3069\3046\304B\3092\30C1\30A7\30C3\30AF\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104388205510308748)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_IN_LIST.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306F\30EA\30B9\30C8\306B\542B\307E\308C\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104744954424309038)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_IN_LIST.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3057\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\304C\6307\5B9A\3057\305F<em>\30EA\30B9\30C8</em>\5185\306B\306A\3044\304B\3069\3046\304B\3092\30C1\30A7\30C3\30AF\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104388032686308748)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_NULL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306Fnull\3067\306F\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104744718409309038)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_NULL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3057\305F<em>\30A2\30A4\30C6\30E0</em>\304C\7A7A\3067\306F\306A\3044\304B\3069\3046\304B\3092\30C1\30A7\30C3\30AF\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104387958664308748)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NULL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306Fnull')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104744651010309038)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NULL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3057\305F<em>\30A2\30A4\30C6\30E0</em>\304C\7A7A\3067\3042\308B\304B\3069\3046\304B\3092\30C1\30A7\30C3\30AF\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103876103480308305)
,p_name=>'PE.PROPERTY.JS_CONDITION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104745422442309039)
,p_name=>'PE.PROPERTY.JS_CONDITION_COLUMN_WHEN_IG.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\6761\4EF6\3067\4F7F\7528\3055\308C\308B\5217\3092\9078\629E\3057\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8: \307B\3068\3093\3069\306E\5834\5408\3001\3053\308C\306F\3001\4E0A\306E<em>\300C\30BF\30A4\30DF\30F3\30B0\300D\306E\300C\5217\300D</em>\3067\6307\5B9A\3057\305F\5217\306B\306A\308B\305F\3081\3001'),
unistr('\305D\308C\304C\30C7\30D5\30A9\30EB\30C8\3068\3057\3066\8A2D\5B9A\3055\308C\307E\3059\3002\305F\3060\3057\3001\6761\4EF6\3092\5225\306E\5217\306B\57FA\3065\304B\305B\308B\3053\3068\3082\3067\304D\307E\3059\3002'),
unistr('\305F\3068\3048\3070\3001EMP\8868\306B\57FA\3065\304F\5BFE\8A71\30B0\30EA\30C3\30C9\3067\3001<code>SAL</code>\304C\5909\66F4\3055\308C\305F\3068\304D\306B\3001'),
unistr('<code>JOB</code>\304C<em>SALESMAN</em>\3068\7B49\3057\3044\5834\5408\306B\306E\307F\3001\52D5\7684\30A2\30AF\30B7\30E7\30F3\3092\8D77\52D5\3059\308B\5834\5408\3001\3053\306E\5C5E\6027\3092<code>JOB</code>\306B\5909\66F4\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104740088485309034)
,p_name=>'PE.PROPERTY.JS_CONDITION_COLUMN_WHEN_IG.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104746758764309040)
,p_name=>'PE.PROPERTY.JS_CONDITION_ELEMENT_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\3067<em>\30A2\30A4\30C6\30E0</em>\307E\305F\306F<em>\5217</em>\3092\4F7F\7528\3059\308B\304B\3069\3046\304B\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104735502154309031)
,p_name=>'PE.PROPERTY.JS_CONDITION_ELEMENT_TYPE.LOV.COLUMN.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104735425723309031)
,p_name=>'PE.PROPERTY.JS_CONDITION_ELEMENT_TYPE.LOV.ITEM.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104735392220309031)
,p_name=>'PE.PROPERTY.JS_CONDITION_ELEMENT_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30DD\30FC\30CD\30F3\30C8\30FB\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104281247032308668)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM.COMPONENT_PROPERTY.DYNAMIC_ACTION_ACTION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\3053\306E\6761\4EF6\3067\4F7F\7528\3055\308C\308B\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104281038141308668)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM.COMPONENT_PROPERTY.DYNAMIC_ACTION_EVENT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\3053\306E\6761\4EF6\3067\4F7F\7528\3055\308C\308B\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104745554668309039)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\6761\4EF6\3067\4F7F\7528\3055\308C\308B\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8: \307B\3068\3093\3069\306E\5834\5408\3001\3053\308C\306F\3001\4E0A\306E<em>\300C\30BF\30A4\30DF\30F3\30B0\300D\306E\300C\30A2\30A4\30C6\30E0\300D</em>\3067\6307\5B9A\3057\305F\30A2\30A4\30C6\30E0\306B\306A\308B\305F\3081\3001'),
unistr('\305D\308C\304C\30C7\30D5\30A9\30EB\30C8\3068\3057\3066\8A2D\5B9A\3055\308C\307E\3059\3002\305F\3060\3057\3001\6761\4EF6\3092\5225\306E\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306B\57FA\3065\304B\305B\308B\3053\3068\3082\3067\304D\307E\3059\3002'),
unistr('\305F\3068\3048\3070\3001EMP\8868\306B\57FA\3065\304F\30D5\30A9\30FC\30E0\3067\3001<code>P2_SAL</code>\304C\5909\66F4\3055\308C\305F\3068\304D\306B\3001<code>P2_JOB</code>\304C<em>SALESMAN</em>\3068\7B49\3057\3044\5834\5408\306B\306E\307F\3001'),
unistr('\52D5\7684\30A2\30AF\30B7\30E7\30F3\3092\8D77\52D5\3059\308B\5834\5408\3001\3053\306E\5C5E\6027\3092<code>P2_JOB</code>\306B\5909\66F4\3057\307E\3059\3002</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104735634734309031)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104745347681309039)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM_WHEN_IG.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\3067\4F7F\7528\3055\308C\308B\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104739943326309034)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM_WHEN_IG.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104281328428308668)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.COMPONENT_PROPERTY.DYNAMIC_ACTION_ACTION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3\3092\8D77\52D5\3059\308B\304B\3069\3046\304B\3092\5236\5FA1\3059\308B\30AF\30E9\30A4\30A2\30F3\30C8\5074\6761\4EF6\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104740259702309035)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('True\307E\305F\306FFalse\306E\30A2\30AF\30B7\30E7\30F3\3092\8D77\52D5\3059\308B\304B\3069\3046\304B\3092\5236\5FA1\3059\308B\30AF\30E9\30A4\30A2\30F3\30C8\5074\306E\6761\4EF6\3092\6307\5B9A\3057\307E\3059\3002\6761\4EF6\304C'),
unistr('                                  True\306B\8A55\4FA1\3055\308C\308B\3068True\30A2\30AF\30B7\30E7\30F3\304C\8D77\52D5\3057\3001\6761\4EF6\304CFalse\306B\8A55\4FA1\3055\308C\308B\3068False\30A2\30AF\30B7\30E7\30F3\304C\8D77\52D5\3057\307E\3059\3002'),
unistr('                                  \6761\4EF6\3092\6307\5B9A\3057\306A\3044\3068\3001True\30A2\30AF\30B7\30E7\30F3\306E\307F\304C\8D77\52D5\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104740388457309035)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.EQUALS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0/\5217 = \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104745696920309039)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.EQUALS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3057\305F<em>\30A2\30A4\30C6\30E0</em>\307E\305F\306F<em>\5217</em>\306E\5024\304C\6307\5B9A\3057\305F<em>\5024</em>\3068\7B49\3057\3044\304B\3069\3046\304B\3092\30C1\30A7\30C3\30AF\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104740519308309035)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.GREATER_THAN.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0/\5217 > \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104745898367309039)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.GREATER_THAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3057\305F<em>\30A2\30A4\30C6\30E0</em>\307E\305F\306F<em>\5217</em>\306E\5024\304C\6307\5B9A\3057\305F<em>\5024</em>\3088\308A\5927\304D\3044\304B\3069\3046\304B\3092\30C1\30A7\30C3\30AF\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104740612441309035)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.GREATER_THAN_OR_EQUAL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0/\5217 >= \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104745952352309039)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.GREATER_THAN_OR_EQUAL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3057\305F<em>\30A2\30A4\30C6\30E0</em>\307E\305F\306F<em>\5217</em>\306E\5024\304C\6307\5B9A\3057\305F<em>\5024</em>\4EE5\4E0A\3067\3042\308B\304B\3069\3046\304B\3092\30C1\30A7\30C3\30AF\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104741180756309035)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.IN_LIST.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0/\5217\306F\30EA\30B9\30C8\306B\542B\307E\308C\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104746422097309039)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.IN_LIST.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3057\305F<em>\30A2\30A4\30C6\30E0</em>\307E\305F\306F<em>\5217</em>\306E\5024\304C\6307\5B9A\3057\305F<em>\30EA\30B9\30C8</em>\5185\306B\3042\308B\304B\3069\3046\304B\3092\30C1\30A7\30C3\30AF\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104741368642309035)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.JAVASCRIPT_EXPRESSION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('JavaScript\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104746656265309040)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.JAVASCRIPT_EXPRESSION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\6307\5B9A\3055\308C\305FJavaScript\5F0F\3092\8A55\4FA1\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104740773675309035)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.LESS_THAN.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0/\5217 < \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104746049047309039)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.LESS_THAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3057\305F<em>\30A2\30A4\30C6\30E0</em>\307E\305F\306F<em>\5217</em>\306E\5024\304C\6307\5B9A\3057\305F<em>\5024</em>\3088\308A\5C0F\3055\3044\304B\3069\3046\304B\3092\30C1\30A7\30C3\30AF\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104740819528309035)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.LESS_THAN_OR_EQUAL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0/\5217 <= \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104746177322309039)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.LESS_THAN_OR_EQUAL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3057\305F<em>\30A2\30A4\30C6\30E0</em>\307E\305F\306F<em>\5217</em>\306E\5024\304C\6307\5B9A\3057\305F<em>\5024</em>\4EE5\4E0B\3067\3042\308B\304B\3069\3046\304B\3092\30C1\30A7\30C3\30AF\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104740462339309035)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_EQUALS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0/\5217 != \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104745738145309039)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_EQUALS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3057\305F<em>\30A2\30A4\30C6\30E0</em>\307E\305F\306F<em>\5217</em>\306E\5024\304C\6307\5B9A\3057\305F<em>\5024</em>\3068\7B49\3057\304F\306A\3044\304B\3069\3046\304B\3092\30C1\30A7\30C3\30AF\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104741210959309035)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_IN_LIST.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0/\5217\306F\30EA\30B9\30C8\306B\542B\307E\308C\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104746511744309040)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_IN_LIST.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3057\305F<em>\30A2\30A4\30C6\30E0</em>\307E\305F\306F<em>\5217</em>\306E\5024\304C\6307\5B9A\3057\305F<em>\30EA\30B9\30C8</em>\5185\306B\306A\3044\304B\3069\3046\304B\3092\30C1\30A7\30C3\30AF\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104741058863309035)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_NULL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0/\5217\306Fnull\3067\306F\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104746358481309039)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_NULL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3057\305F<em>\30A2\30A4\30C6\30E0</em>\307E\305F\306F<em>\5217</em>\304C\7A7A\3067\306F\306A\3044\304B\3069\3046\304B\3092\30C1\30A7\30C3\30AF\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104740920937309035)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NULL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0/\5217\306Fnull')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104746237346309039)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NULL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3057\305F<em>\30A2\30A4\30C6\30E0</em>\307E\305F\306F<em>\5217</em>\304C\7A7A\3067\3042\308B\304B\3069\3046\304B\3092\30C1\30A7\30C3\30AF\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104740105231309035)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104280906481308668)
,p_name=>'PE.PROPERTY.JS_COND_JS_EXPRESSION.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\6761\4EF6\306B\5BFE\3057\3066\8A55\4FA1\3059\308BJavaScript\5F0F\3092\6307\5B9A\3057\307E\3059\3002'),
unistr('\30B3\30FC\30C9\306F\6B21\306B\793A\3059\52D5\7684\30A2\30AF\30B7\30E7\30F3\95A2\9023\306E\5C5E\6027\306B\30A2\30AF\30BB\30B9\3067\304D\307E\3059\3002</p>'),
'<dl>',
'  <dt>this.triggeringElement</dt>',
unistr('    <dd>\52D5\7684\30A2\30AF\30B7\30E7\30F3\3092\30C8\30EA\30AC\30FC\3057\305F\8981\7D20\306EDOM\30AA\30D6\30B8\30A7\30AF\30C8\3078\306E\53C2\7167\3002</dd>'),
'  <dt>this.browserEvent</dt>',
unistr('    <dd>\30A4\30D9\30F3\30C8\3092\30C8\30EA\30AC\30FC\3057\305F\30A4\30D9\30F3\30C8\30FB\30AA\30D6\30B8\30A7\30AF\30C8\3002\30CE\30FC\30C8: \30ED\30FC\30C9\6642\3001\3053\308C\306Fload\3068\540C\7B49\306B\306A\308A\307E\3059\3002</dd>'),
'  <dt>this.data</dt>',
unistr('    <dd>\30A4\30D9\30F3\30C8\30FB\30CF\30F3\30C9\30E9\304B\3089\6E21\3059\3053\3068\304C\3067\304D\308B\30AA\30D7\30B7\30E7\30F3\306E\8FFD\52A0\30C7\30FC\30BF\3002</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104280821666308668)
,p_name=>'PE.PROPERTY.JS_COND_JS_EXPRESSION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('JavaScript\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104741988037309036)
,p_name=>'PE.PROPERTY.JS_COND_JS_EXPRESSION_WHEN_IG.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\6761\4EF6\306B\5BFE\3057\3066\8A55\4FA1\3059\308BJavaScript\5F0F\3092\6307\5B9A\3057\307E\3059\3002'),
unistr('\30B3\30FC\30C9\306F\6B21\306B\793A\3059\52D5\7684\30A2\30AF\30B7\30E7\30F3\95A2\9023\306E\5C5E\6027\306B\30A2\30AF\30BB\30B9\3067\304D\307E\3059\3002</p>'),
'<dl>',
'  <dt>this.triggeringElement</dt>',
unistr('    <dd>\52D5\7684\30A2\30AF\30B7\30E7\30F3\3092\30C8\30EA\30AC\30FC\3057\305F\8981\7D20\306EDOM\30AA\30D6\30B8\30A7\30AF\30C8\3078\306E\53C2\7167\3002</dd>'),
'  <dt>this.browserEvent</dt>',
unistr('    <dd>\30A4\30D9\30F3\30C8\3092\30C8\30EA\30AC\30FC\3057\305F\30A4\30D9\30F3\30C8\30FB\30AA\30D6\30B8\30A7\30AF\30C8\3002\30CE\30FC\30C8: \30ED\30FC\30C9\6642\3001\3053\308C\306Fload\3068\540C\7B49\306B\306A\308A\307E\3059\3002</dd>'),
'  <dt>this.data</dt>',
unistr('    <dd>\30A4\30D9\30F3\30C8\30FB\30CF\30F3\30C9\30E9\304B\3089\6E21\3059\3053\3068\304C\3067\304D\308B\30AA\30D7\30B7\30E7\30F3\306E\8FFD\52A0\30C7\30FC\30BF\3002</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104741848489309036)
,p_name=>'PE.PROPERTY.JS_COND_JS_EXPRESSION_WHEN_IG.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('JavaScript\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104739834843309034)
,p_name=>'PE.PROPERTY.JS_COND_LIST.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3059\308B\30AB\30F3\30DE\3067\533A\5207\3089\308C\305F\5024\306E\30EA\30B9\30C8\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104739774949309034)
,p_name=>'PE.PROPERTY.JS_COND_LIST.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104741736700309036)
,p_name=>'PE.PROPERTY.JS_COND_LIST_WHEN_IG.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30B9\30C8\3059\308B\6761\4EF6\306E\30AB\30F3\30DE\533A\5207\308A\306E\5024\306E\30EA\30B9\30C8\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104741653404309036)
,p_name=>'PE.PROPERTY.JS_COND_LIST_WHEN_IG.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104780372424309073)
,p_name=>'PE.PROPERTY.JS_COND_VALUE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3059\308B\5024\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104780298951309073)
,p_name=>'PE.PROPERTY.JS_COND_VALUE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104741597137309036)
,p_name=>'PE.PROPERTY.JS_COND_VALUE_WHEN_IG.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30B9\30C8\3059\308B\6761\4EF6\306E\5024\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104741419570309036)
,p_name=>'PE.PROPERTY.JS_COND_VALUE_WHEN_IG.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103876910970308306)
,p_name=>'PE.PROPERTY.JS_EXECUTE_WHEN_PAGE_LOADS.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30DA\30FC\30B8\306E\30ED\30FC\30C9\6642\306B\5B9F\884C\3059\308BJavaScript\30B3\30FC\30C9\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002'),
unistr('\30B3\30FC\30C9\306F\3001&PRODUCT_NAME.\3067\751F\6210\3055\308C\305FJavaScript\30B3\30FC\30C9\306E\5F8C\306B\5B9F\884C\3055\308C\307E\3059\3002</p>'),
unistr('<p>\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306E<code>#GENERATED_JAVASCRIPT#</code>\7F6E\63DB\6587\5B57\5217\304C\3001\3053\3053\3067\5165\529B\3059\308B\30B3\30FC\30C9\306B\7F6E\63DB\3055\308C\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8: \958B\59CB\307E\305F\306F\7D42\4E86\306E<code>script</code>\30BF\30B0\3092\8FFD\52A0\3059\308B\5FC5\8981\306F\3042\308A\307E\305B\3093\3002JavaScript\30B3\30FC\30C9\306E\307F\3092\542B\3081\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103876823675308306)
,p_name=>'PE.PROPERTY.JS_EXECUTE_WHEN_PAGE_LOADS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30ED\30FC\30C9\6642\306B\5B9F\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104379270053308741)
,p_name=>'PE.PROPERTY.JS_FILE_URLS.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\6A19\6E96\30D5\30A1\30A4\30EB\53C2\7167</dt>'),
'<dd><pre>/myjs/main.js</pre></dd>',
unistr('<dt>\901A\5E38\30DA\30FC\30B8\30FB\30D3\30E5\30FC\306E\5834\5408\306F\7E2E\5C0F\30D5\30A1\30A4\30EB<code>main.min.js</code>\3092<code>/myjs/minified/</code>\304B\3089\30ED\30FC\30C9\3057\3001\30C7\30D0\30C3\30B0\30FB\30E2\30FC\30C9\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30D3\30EB\30C0\30FC\304B\3089\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5B9F\884C\6642\306B\306F<code>main.js</code>\3092<code>/myjs/</code>\304B\3089\30ED\30FC\30C9\3059\308B\6A19\6E96\30D5\30A1\30A4\30EB\53C2\7167\3002</dt>'),
'<dd><pre>/myjs/#MIN_DIRECTORY#main#MIN#.js</pre></dd>',
unistr('<dt>RequireJS\306Erequire\30B3\30FC\30EB\304B\3089\30E9\30A4\30D6\30E9\30EA\3082\4F7F\7528\3055\308C\308B\5834\5408\3001\3053\306E\69CB\6587\3092\4F7F\7528\3057\307E\3059\3002define\540D\306F\3001requirejs.config\306E\30D1\30B9\3067\4F7F\7528\3055\308C\308B\3082\306E\3068\4E00\81F4\3059\308B\5FC5\8981\304C\3042\308A\3001\5024\306F\3001\30E9\30A4\30D6\30E9\30EA\3067\516C\958B\3055\308C\3066\3044\308B\30B0\30ED\30FC\30D0\30EB\30FB\30B7\30F3\30DC\30EB\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002RequireJS\3092\4F7F\7528\3059\308B\5834\5408\306B\306E\307F\9069\7528\3055\308C\307E\3059\3002\3053\308C\306B\3088\308A\3001RequireJS\306B\3088\308B\305D\306E\30E9\30A4\30D6\30E9\30EA\306E\91CD\8907\30ED\30FC\30C9\304C\56DE\907F\3055\308C\307E\3059\3002</dt>'),
'<dd><pre>[define hammerjs=Hammer]/myjs/hammer.js</pre></dd>',
unistr('<dt>\30D5\30A1\30A4\30EB\306BRequireJS\306B\5BFE\3059\308B\4F9D\5B58\95A2\4FC2\304C\3042\308B\5834\5408\3001\3053\306E\69CB\6587\3092\4F7F\7528\3057\307E\3059\3002\3053\308C\306B\3088\308A\3001\3053\306E\30D5\30A1\30A4\30EB\306E\524D\306BRequireJS\304C\81EA\52D5\7684\306B\30ED\30FC\30C9\3055\308C\307E\3059\3002</dt>'),
'<dd><pre>[require requirejs]/myjs/main.js</pre></dd>',
unistr('<dt>\30D5\30A1\30A4\30EB\306BOracle JET\306B\5BFE\3059\308B\4F9D\5B58\95A2\4FC2\304C\3042\308B\5834\5408\3001\3053\306E\69CB\6587\3092\4F7F\7528\3057\307E\3059\3002\3053\308C\306B\3088\308A\3001\3053\306E\30D5\30A1\30A4\30EB\306E\524D\306BRequireJS\304A\3088\3073Oracle JET RequireJS\69CB\6210\304C\81EA\52D5\7684\306B\30ED\30FC\30C9\3055\308C\307E\3059\3002</dt>'),
'<dd><pre>[require jet]/myjs/main.js</pre></dd>',
unistr('<dt>URL\306B\554F\5408\305B\6587\5B57\5217\3092\4F7F\7528\3057\3066\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30D0\30FC\30B8\30E7\30F3\3092\53C2\7167\3059\308B\30D5\30A1\30A4\30EB\53C2\7167\3002\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304C\30A2\30C3\30D7\30B0\30EC\30FC\30C9\3055\308C\305F(\30D0\30FC\30B8\30E7\30F3\304C\4E0A\304C\3063\305F)\3068\304D\306A\3069\3001\65B0\898F\30D5\30A1\30A4\30EB\3092\5E38\306B\30ED\30FC\30C9\3057\3001\4EE5\524D\306B\30AD\30E3\30C3\30B7\30E5\3055\308C\305F\30D5\30A1\30A4\30EB\3092\7121\8996\3059\308B\3088\3046\30D6\30E9\30A6\30B6\306B\6307\793A\3057\307E\3059\3002</dt>'),
'<dd><pre>/myjs/main.js?version=#APP_VERSION#</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103876599100308305)
,p_name=>'PE.PROPERTY.JS_FILE_URLS.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30DA\30FC\30B8\3067\30ED\30FC\30C9\3059\308B\30B3\30FC\30C9\306EJavaScript\30D5\30A1\30A4\30EB\306EURL\3092\5165\529B\3057\307E\3059\3002URL\3054\3068\306B\65B0\3057\3044\884C\306B\8A18\8FF0\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002'),
unistr('\30D5\30A1\30A4\30EB\306E\7E2E\5C0F\30D0\30FC\30B8\30E7\30F3\3092\6307\5B9A\3059\308B\5834\5408\3001\7F6E\63DB\6587\5B57\5217<code>#MIN#</code>\3092\4F7F\7528\3057\3066<code>.min</code>\307E\305F\306F<code>#MIN_DIRECTORY#</code>\3092\542B\3081\3001\901A\5E38\30DA\30FC\30B8\30FB\30D3\30E5\30FC\306E\30D5\30A1\30A4\30EBURL\306B<code>minified/</code>\3092\542B\3081\305F\308A\3001\30DA\30FC\30B8\3092\30C7\30D0\30C3\30B0\30FB\30E2\30FC\30C9\3067\8868\793A\3059\308B\5834\5408\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30D3\30EB\30C0\30FC\304B\3089\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5B9F\884C\6642\306B\8868\793A\3059\308B\5834\5408\306F\7A7A\306E\6587\5B57\5217\3092\542B\3081\305F\308A\3059\308B\3053\3068\304C\3067\304D\307E\3059\3002'),
unistr('\30D5\30A1\30A4\30EBURL\306B\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30D0\30FC\30B8\30E7\30F3\3092\542B\3081\308B\5834\5408\3001\7F6E\63DB\6587\5B57\5217<code>#APP_VERSION#</code>\3082\4F7F\7528\3057\307E\3059\3002</p>'),
unistr('<p>\3053\3053\3067\5165\529B\3057\305FJavaScript\30D5\30A1\30A4\30EB\306EURL\3067\3001\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306E<code>#PAGE_JAVASCRIPT#</code>\7F6E\63DB\6587\5B57\5217\304C\7F6E\63DB\3055\308C\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8: \958B\59CB\304A\3088\3073\7D42\4E86\306E<code>script</code>\30BF\30B0\3092\542B\3081\308B\5FC5\8981\306F\3042\308A\307E\305B\3093\3002URL\3092\6307\5B9A\3059\308B\306E\307F\3067\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103876496267308305)
,p_name=>'PE.PROPERTY.JS_FILE_URLS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EBURL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103876708298308306)
,p_name=>'PE.PROPERTY.JS_FUNCTION_AND_GLOBAL_VARIABLE_DECLARATION.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30DA\30FC\30B8\3067\53C2\7167\3055\308C\308BJavaScript\30B3\30FC\30C9(\30D5\30A1\30F3\30AF\30B7\30E7\30F3\3084\30B0\30ED\30FC\30D0\30EB\5909\6570\5BA3\8A00)\3092\5165\529B\3057\307E\3059\3002'),
unistr('\30B7\30E7\30FC\30C8\30AB\30C3\30C8\3092\53C2\7167\3059\308B\306B\306F\3001<code>"SHORTCUTNAME"</code>\3092\4F7F\7528\3057\307E\3059\3002'),
unistr('\8907\6570\306E\30DA\30FC\30B8\3067\540C\3058JavaScript\304C\5FC5\8981\306A\5834\5408\3001\91CD\8907\3092\907F\3051\3001\30D6\30E9\30A6\30B6\306B\3088\308B\9759\7684\30D5\30A1\30A4\30EB\306E\30AD\30E3\30C3\30B7\30E5\3092\6D3B\7528\3059\308B\305F\3081\3001\30B3\30FC\30C9\3092\5916\90E8JavaScript\30D5\30A1\30A4\30EB\306B\3059\308B\3053\3068\3092\691C\8A0E\3057\3066\304F\3060\3055\3044\3002</p>'),
unistr('<p>\3053\3053\3067\5165\529B\3057\305F\30B3\30FC\30C9\3067\3001\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306E<code>#PAGE_JAVASCRIPT#</code>\7F6E\63DB\6587\5B57\5217\304C\7F6E\63DB\3055\308C\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8: \958B\59CB\307E\305F\306F\7D42\4E86\306E<code>script</code>\30BF\30B0\3092\542B\3081\308B\5FC5\8981\306F\3042\308A\307E\305B\3093\3002JavaScript\30B3\30FC\30C9\3092\542B\3081\308B\306E\307F\3067\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103876613458308306)
,p_name=>'PE.PROPERTY.JS_FUNCTION_AND_GLOBAL_VARIABLE_DECLARATION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30F3\30AF\30B7\30E7\30F3\304A\3088\3073\30B0\30ED\30FC\30D0\30EB\5909\6570\306E\5BA3\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104717336593309014)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.FACET.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30D5\30A1\30BB\30C3\30C8\306E\30E9\30D9\30EB\3092\5165\529B\3057\307E\3059\3002'),
unistr('    \30E9\30D9\30EB\306F\3001\30D5\30A1\30BB\30C3\30C8\304C\8868\793A\3055\308C\308B\5834\5408\306E\307F\30DA\30FC\30B8\4E0A\306B\8868\793A\3055\308C\307E\3059\3002<strong>\691C\7D22</strong>\30BF\30A4\30D7\306E\30E9\30D9\30EB\306F\8868\793A\3055\308C\307E\305B\3093\304C\3001\30A2\30B7\30B9\30C6\30A3\30D6\30FB\30C6\30AF\30CE\30ED\30B8\3067\306F\4F7F\7528\3067\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104556702406308884)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.FACET_GROUP.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('~\30D5\30A1\30BB\30C3\30C8\30FB\30B0\30EB\30FC\30D7\306E\30E9\30D9\30EB\3092\5165\529B\3057\307E\3059\3002~')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104556995586308884)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.FACET_GROUP_ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30D5\30A1\30BB\30C3\30C8\306E\30E9\30D9\30EB\3092\5165\529B\3057\307E\3059\3002'),
unistr('    \30E9\30D9\30EB\306F\3001\30D5\30A1\30BB\30C3\30C8\304C\8868\793A\3055\308C\308B\5834\5408\306E\307F\30DA\30FC\30B8\4E0A\306B\8868\793A\3055\308C\307E\3059\3002<strong>\691C\7D22</strong>\30BF\30A4\30D7\306E\30E9\30D9\30EB\306F\8868\793A\3055\308C\307E\305B\3093\304C\3001\30A2\30B7\30B9\30C6\30A3\30D6\30FB\30C6\30AF\30CE\30ED\30B8\3067\306F\4F7F\7528\3067\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103919958180308374)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30D5\30A3\30EB\30BF\306E\30E9\30D9\30EB\3092\5165\529B\3057\307E\3059\3002'),
unistr('    \30E9\30D9\30EB\306F\3001\30D5\30A3\30EB\30BF\304C\8868\793A\3055\308C\308B\5834\5408\306E\307F\30DA\30FC\30B8\4E0A\306B\8868\793A\3055\308C\307E\3059\3002<strong>\691C\7D22</strong>\30BF\30A4\30D7\306E\30E9\30D9\30EB\306F\8868\793A\3055\308C\307E\305B\3093\304C\3001\30A2\30B7\30B9\30C6\30A3\30D6\30FB\30C6\30AF\30CE\30ED\30B8\3067\306F\4F7F\7528\3067\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103920874744308375)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.SFILTER_GROUP.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('~\30D5\30A3\30EB\30BF\30FB\30B0\30EB\30FC\30D7\306E\30E9\30D9\30EB\3092\5165\529B\3057\307E\3059\3002~')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103921240275308375)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.SFILTER_GROUP_ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30D5\30A3\30EB\30BF\306E\30E9\30D9\30EB\3092\5165\529B\3057\307E\3059\3002'),
unistr('    \30E9\30D9\30EB\306F\3001\30D5\30A3\30EB\30BF\304C\8868\793A\3055\308C\308B\5834\5408\306E\307F\30DA\30FC\30B8\4E0A\306B\8868\793A\3055\308C\307E\3059\3002<strong>\691C\7D22</strong>\30BF\30A4\30D7\306E\30E9\30D9\30EB\306F\8868\793A\3055\308C\307E\305B\3093\304C\3001\30A2\30B7\30B9\30C6\30A3\30D6\30FB\30C6\30AF\30CE\30ED\30B8\3067\306F\4F7F\7528\3067\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103902480927308329)
,p_name=>'PE.PROPERTY.LABEL.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306E\30D5\30A3\30FC\30EB\30C9\30FB\30E9\30D9\30EB\3092\5165\529B\3057\307E\3059\3002'),
unistr('\30A2\30A4\30C6\30E0\304C\8868\793A\3055\308C\308B\5834\5408\306B\306E\307F\3001\30DA\30FC\30B8\306B\30E9\30D9\30EB\304C\8868\793A\3055\308C\307E\3059\3002'),
unistr('\30E9\30D9\30EB\306E\4F4D\7F6E\5408\305B\304A\3088\3073\8868\793A\306B\5FDC\3058\3066\3001\30E9\30D9\30EB\306F\3001\56FA\6709\306EHTML\8868\306E\30BB\30EB\307E\305F\306F\540C\3058\30BB\30EB\306B\8868\793A\3055\308C\307E\3059\3002</p>'),
unistr('<p><code>"SHORTCUT_NAME"</code>\69CB\6587\3092\4F7F\7528\3057\3066\3001\30A2\30A4\30C6\30E0\30FB\30E9\30D9\30EB\306B\30B7\30E7\30FC\30C8\30AB\30C3\30C8\3092\542B\3081\308B\3053\3068\304C\3067\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103902324076308329)
,p_name=>'PE.PROPERTY.LABEL.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103902663491308329)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30E9\30D9\30EB\306E\4F4D\7F6E\5408\305B\3092\9078\629E\3057\307E\3059\3002\30E9\30D9\30EB\306F\3001\30A2\30A4\30C6\30E0\306E\4E0A\3001\4E0B\307E\305F\306F\5DE6\306B\8868\793A\3067\304D\307E\3059\3002'),
unistr('\30D5\30A9\30FC\30E0\8981\7D20\306E\6A2A\306B\30E9\30D9\30EB\304C\8868\793A\3055\308C\308B\5834\5408\3001\30E9\30D9\30EB\306F\30E9\30D9\30EB\56FA\6709\306EHTML\8868\30BB\30EB\3092\5360\6709\3057\307E\3059\3002'),
unistr('\3053\306E\30E9\30D9\30EB\4F4D\7F6E\5408\305B\3092\5909\66F4\3059\308B\3053\3068\3067\3001\305D\306E\8868\30BB\30EB\5185\306E\30E9\30D9\30EB\306E\4F4D\7F6E\3092\5236\5FA1\3067\304D\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104390710415308750)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.ABOVE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0A\90E8 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104390854781308750)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.BELOW.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0B\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104391008196308750)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.CENTER-BOTTOM.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E2D\592E\4E0B\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104391134791308751)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.CENTER-CENTER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E2D\592E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104391276933308751)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.CENTER-TOP.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E2D\592E\4E0A\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104390926694308750)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.CENTER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E2D\592E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104391471198308751)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.LEFT-BOTTOM.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5DE6\5074\4E0B\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104391537911308751)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.LEFT-CENTER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5DE6\5074\4E2D\592E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104391679683308751)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.LEFT-TOP.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5DE6\5074\4E0A\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104391300654308751)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5DE6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104391867473308751)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.RIGHT-BOTTOM.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\53F3\5074\4E0B\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104391991711308751)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.RIGHT-CENTER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\53F3\5074\4E2D\592E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104392011612308751)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.RIGHT-TOP.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\53F3\5074\4E0A\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104391717013308751)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\53F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103902563731308329)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F4D\7F6E\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104719818008309016)
,p_name=>'PE.PROPERTY.LAZY_LOADING.COMPONENT_PROPERTY.CARD.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30EA\30FC\30B8\30E7\30F3\306E\30C7\30FC\30BF\3068\5207\308A\96E2\3057\3066\30EA\30FC\30B8\30E7\30F3\3092\30ED\30FC\30C9\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002</p>'),
unistr('        <p>\9045\5EF6\30ED\30FC\30C9\304C\6307\5B9A\3055\308C\308B\3068\3001\30DA\30FC\30B8\304C\5373\6642\306B\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\3001\30C7\30FC\30BF\304C\30ED\30FC\30C9\3055\308C\308B\307E\3067\7A7A\306E\30EA\30FC\30B8\30E7\30F3\304C\8868\793A\3055\308C\307E\3059\3002'),
unistr('        \901A\5E38\3001\3059\3079\3066\306E\30DA\30FC\30B8\304C\30ED\30FC\30C9\3055\308C\3066\30EC\30F3\30C0\30EA\30F3\30B0\306E\6E96\5099\304C\6574\3046\307E\3067\3001\30DA\30FC\30B8\304C\8868\793A\3055\308C\307E\305B\3093\3002'),
unistr('        \3057\305F\304C\3063\3066\3001\9045\5EF6\30ED\30FC\30C9\306A\3057\3067\30EA\30FC\30B8\30E7\30F3\306B\3059\3079\3066\306E\30C7\30FC\30BF\3092\30ED\30FC\30C9\3059\308B\307E\3067\306B5\79D2\304B\304B\308B\5834\5408\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\30DA\30FC\30B8\306E\30EC\30F3\30C0\30EA\30F3\30B0\3092\958B\59CB\3059\308B\307E\30675\79D2\5F85\6A5F\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>'),
unistr('        <p>\30CE\30FC\30C8 - \3053\308C\306B\3088\308A\3001\8FC5\901F\306B\30ED\30FC\30C9\3055\308C\308B\30EA\30FC\30B8\30E7\30F3\306E\30C7\30FC\30BF\30D9\30FC\30B9\306E\4E0D\8981\306A\51E6\7406\30AA\30FC\30D0\30FC\30D8\30C3\30C9\304C\8FFD\52A0\3055\308C\308B\305F\3081\3001\30ED\30FC\30C9\306B\6642\9593\304C\304B\304B\308B\30C7\30FC\30BF\30FB\30BB\30C3\30C8\306B\306E\307F\3001\9045\5EF6\30ED\30FC\30C9\3092\5229\7528\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104098776282308515)
,p_name=>'PE.PROPERTY.LAZY_LOADING.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30EA\30FC\30B8\30E7\30F3\306E\30C7\30FC\30BF\3068\5207\308A\96E2\3057\3066\30EA\30FC\30B8\30E7\30F3\3092\30ED\30FC\30C9\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002</p>'),
unistr('        <p>\9045\5EF6\30ED\30FC\30C9\304C\6307\5B9A\3055\308C\308B\3068\3001\30DA\30FC\30B8\304C\5373\6642\306B\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\3001\30C7\30FC\30BF\304C\30ED\30FC\30C9\3055\308C\308B\307E\3067\7A7A\306E\30EA\30FC\30B8\30E7\30F3\304C\8868\793A\3055\308C\307E\3059\3002'),
unistr('        \901A\5E38\3001\3059\3079\3066\306E\30DA\30FC\30B8\304C\30ED\30FC\30C9\3055\308C\3066\30EC\30F3\30C0\30EA\30F3\30B0\306E\6E96\5099\304C\6574\3046\307E\3067\3001\30DA\30FC\30B8\304C\8868\793A\3055\308C\307E\305B\3093\3002'),
unistr('        \3057\305F\304C\3063\3066\3001\9045\5EF6\30ED\30FC\30C9\306A\3057\3067\30EA\30FC\30B8\30E7\30F3\306B\3059\3079\3066\306E\30C7\30FC\30BF\3092\30ED\30FC\30C9\3059\308B\307E\3067\306B5\79D2\304B\304B\308B\5834\5408\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\30DA\30FC\30B8\306E\30EC\30F3\30C0\30EA\30F3\30B0\3092\958B\59CB\3059\308B\307E\30675\79D2\5F85\6A5F\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>'),
unistr('        <p>\30CE\30FC\30C8 - \3053\308C\306B\3088\308A\3001\8FC5\901F\306B\30ED\30FC\30C9\3055\308C\308B\30EA\30FC\30B8\30E7\30F3\306E\30C7\30FC\30BF\30D9\30FC\30B9\306E\4E0D\8981\306A\51E6\7406\30AA\30FC\30D0\30FC\30D8\30C3\30C9\304C\8FFD\52A0\3055\308C\308B\305F\3081\3001\30ED\30FC\30C9\306B\6642\9593\304C\304B\304B\308B\30C7\30FC\30BF\30FB\30BB\30C3\30C8\306B\306E\307F\3001\9045\5EF6\30ED\30FC\30C9\3092\5229\7528\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104098626856308515)
,p_name=>'PE.PROPERTY.LAZY_LOADING.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\9045\5EF6\30ED\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104538438637308866)
,p_name=>'PE.PROPERTY.LEGEND_CAN_HIDE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\51E1\4F8B\5185\306E\30EC\30A4\30E4\30FC\306E\540D\524D\3092\30AF\30EA\30C3\30AF\3057\3066\3001\30EC\30A4\30E4\30FC\306E\8868\793A\3092\5207\308A\66FF\3048\308B\3053\3068\304C\3067\304D\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104538376246308866)
,p_name=>'PE.PROPERTY.LEGEND_CAN_HIDE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\975E\8868\793A\3092\6709\52B9\306B\3059\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104538644586308866)
,p_name=>'PE.PROPERTY.LEGEND_ICON_CSS_CLASSES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\51E1\4F8B\5185\3067\3053\306E\30EC\30A4\30E4\30FC\306B\8868\793A\3059\308B\30A2\30A4\30B3\30F3\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104538547317308866)
,p_name=>'PE.PROPERTY.LEGEND_ICON_CSS_CLASSES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3CSS\30AF\30E9\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104154150931308570)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\306E\51E1\4F8B\306E\4F4D\7F6E\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104154220609308570)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.LOV.AUTO.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104154580278308570)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.LOV.BOTTOM.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104154442357308570)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.LOV.END.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D42\4E86')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104154307123308570)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.LOV.START.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104154691630308570)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.LOV.TOP.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C8\30C3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104154070163308570)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104153927542308570)
,p_name=>'PE.PROPERTY.LEGEND_RENDERED.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\51E1\4F8B\3092\30C1\30E3\30FC\30C8\3067\30EC\30F3\30C0\30EA\30F3\30B0\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104153897916308569)
,p_name=>'PE.PROPERTY.LEGEND_RENDERED.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104538890117308866)
,p_name=>'PE.PROPERTY.LEGEND_TITLE.COMPONENT_PROPERTY.MAP_REGION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\51E1\4F8B\306E\30BF\30A4\30C8\30EB\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104265012746308657)
,p_name=>'PE.PROPERTY.LEGEND_TITLE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\51E1\4F8B\306E\4E0A\90E8\306B\8868\793A\3059\308B\30BF\30A4\30C8\30EB\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104264971078308657)
,p_name=>'PE.PROPERTY.LEGEND_TITLE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30C8\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104160097346308576)
,p_name=>'PE.PROPERTY.LINE_STYLE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\3067\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\308B\6298\308C\7DDA\306E\30B9\30BF\30A4\30EB\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104160260306308576)
,p_name=>'PE.PROPERTY.LINE_STYLE.LOV.DASHED.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\7834\7DDA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104160162615308576)
,p_name=>'PE.PROPERTY.LINE_STYLE.LOV.DOTTED.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\70B9\7DDA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104160324470308576)
,p_name=>'PE.PROPERTY.LINE_STYLE.LOV.SOLID.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\7ACB\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104159926886308576)
,p_name=>'PE.PROPERTY.LINE_STYLE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30BF\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104160860627308576)
,p_name=>'PE.PROPERTY.LINE_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\3067\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\308B\6298\308C\7DDA\306E\30BF\30A4\30D7\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104160950404308576)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.AUTO.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104161283756308577)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.CENTEREDSEGMENTED.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30B0\30E1\30F3\30C8\4E2D\592E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104161053069308576)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.CENTEREDSTEPPED.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\968E\6BB5\4E2D\592E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104161110766308577)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.CURVED.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F2\7DDA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104161522661308577)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.NONE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104161441781308577)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.SEGMENTED.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30B0\30E1\30F3\30C8\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104161392674308577)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.STEPPED.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\968E\6BB5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104161626114308577)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.STRAIGHT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\76F4\7DDA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104160725995308576)
,p_name=>'PE.PROPERTY.LINE_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104160552744308576)
,p_name=>'PE.PROPERTY.LINE_WIDTH.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\3067\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\308B\6298\308C\7DDA\306E\5E45\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104160444589308576)
,p_name=>'PE.PROPERTY.LINE_WIDTH.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5E45')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104160679577308576)
,p_name=>'PE.PROPERTY.LINE_WIDTH.UNIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D4\30AF\30BB\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104407638125308763)
,p_name=>'PE.PROPERTY.LINK_ATTRIBUTES.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\65B0\898F\30A6\30A3\30F3\30C9\30A6\3067\306E\30EA\30F3\30AF\306E\30AA\30FC\30D7\30F3</dt>'),
'<dd><pre>target="_blank"</pre></dd>',
unistr('<dt>\30DB\30D0\30FC\3067\306E\30C4\30FC\30EB\30C1\30C3\30D7\306E\8868\793A</dt>'),
'<dd><pre>title="Click to edit"</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104204655767308613)
,p_name=>'PE.PROPERTY.LINK_ATTRIBUTES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<code>&lt;a href=...&gt;</code>\30BF\30B0\306B\542B\3081\308B\8FFD\52A0\306E\5217\30EA\30F3\30AF\5C5E\6027(\30EA\30F3\30AF\30FB\30BF\30FC\30B2\30C3\30C8\3001\30AF\30E9\30B9\3001\30B9\30BF\30A4\30EB\306A\3069)\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104204523305308613)
,p_name=>'PE.PROPERTY.LINK_ATTRIBUTES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30F3\30AF\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104210337063308617)
,p_name=>'PE.PROPERTY.LINK_AUTHORIZATION_SCHEME.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30F3\30AF\5217\306B\95A2\9023\4ED8\3051\308B\8A8D\53EF\30B9\30AD\30FC\30E0\3092\9078\629E\3057\307E\3059\3002\30EA\30F3\30AF\5217\3092\30EC\30DD\30FC\30C8\5185\306B\30EC\30F3\30C0\30EA\30F3\30B0\3059\308B\305F\3081\306B\306F\3001\3053\306E\8A8D\53EF\30B9\30AD\30FC\30E0\304CTRUE\3068\8A55\4FA1\3055\308C\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104210252578308617)
,p_name=>'PE.PROPERTY.LINK_AUTHORIZATION_SCHEME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\53EF\30B9\30AD\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104622670169308937)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F\5F0F\306E\8A55\4FA1\306B\4F7F\7528\3055\308C\308B\8A00\8A9E\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104623066867308937)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'ja'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104622931941308937)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'ja'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104622831388308937)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'ja'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104623101945308937)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'ja'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104622750370308937)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'ja'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104622555288308937)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A00\8A9E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104624600555308938)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\306E\5B9F\884C\306B\4F7F\7528\3055\308C\308B\8A00\8A9E\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104624988979308939)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'ja'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104624892905308938)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'ja'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104624745856308938)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'ja'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104625045275308939)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'ja'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104624509030308938)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A00\8A9E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104218913765308623)
,p_name=>'PE.PROPERTY.LINK_CONDITION_ITEM1.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\3067\4F7F\7528\3055\308C\308B\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104218809074308623)
,p_name=>'PE.PROPERTY.LINK_CONDITION_ITEM1.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104220302728308624)
,p_name=>'PE.PROPERTY.LINK_CONDITION_ITEM2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\3067\4F7F\7528\3055\308C\308B\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104220256667308624)
,p_name=>'PE.PROPERTY.LINK_CONDITION_ITEM2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104624290240308938)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3059\308BJava\5F0F\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104624167146308938)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('Java\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104625818740308939)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3057\3066\30D6\30FC\30EB\5024\3092\8FD4\3059Java\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104625787060308939)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('Java\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104624054920308938)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3059\308B\304B\3001\30DE\30CD\30FC\30B8\30E3\3067\3042\308B\5834\5408\3001\6B63\5E38\306B\5024\3092\8FD4\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104623961872308938)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3059\308BJavaScript\5F0F\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104623825711308938)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('JavaScript\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104625626567308939)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3059\308B\5834\5408\3001\6B63\5E38\306B\5024\3092\8FD4\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104625538709308939)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3057\3066\30D6\30FC\30EB\5024\3092\8FD4\3059JavaScript\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104625417678308939)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('JavaScript\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104219131162308624)
,p_name=>'PE.PROPERTY.LINK_CONDITION_LIST.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3059\308B\30B3\30ED\30F3(:)\3067\533A\5207\3089\308C\305F\5024\306E\30EA\30B9\30C8\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104219093093308623)
,p_name=>'PE.PROPERTY.LINK_CONDITION_LIST.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104219544839308624)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PAGE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3059\308B\30DA\30FC\30B8\756A\53F7\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104219410760308624)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PAGE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104219750672308624)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PAGES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3059\308B\30DA\30FC\30B8\756A\53F7\3092\30AB\30F3\30DE\3067\533A\5207\3063\3066\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104219603994308624)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PAGES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104623703375308938)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3059\308B\304B\3001\30DE\30CD\30FC\30B8\30E3\3067\3042\308B\5834\5408\3001\6B63\5E38\306B\5024\3092\8FD4\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104623678770308938)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3059\308BPL/SQL\5F0F\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104623511334308937)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104625339052308939)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3059\308B\5834\5408\3001\6B63\5E38\306B\5024\3092\8FD4\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104625245279308939)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3057\3066\30D6\30FC\30EB\5024\3092\8FD4\3059PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104625100553308939)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104219322652308624)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PREFERENCE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3057\3066\6307\5B9A\3055\308C\305F\5024\3068\6BD4\8F03\3059\308B\30E6\30FC\30B6\30FC\30FB\30D7\30EA\30D5\30A1\30EC\30F3\30B9\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104219274452308624)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PREFERENCE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30EA\30D5\30A1\30EC\30F3\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104624474014308938)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3059\308BPython\5F0F\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104624341576308938)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('Python\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104626040710308939)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3057\3066\30D6\30FC\30EB\5024\3092\8FD4\3059Python\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104625970333308939)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('Python\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104623447645308937)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\30DE\30CD\30FC\30B8\30E3\3067\3001\90E8\9580\304C\30B7\30AB\30B4\306B\5B58\5728\3059\308B\5834\5408\3001\6B63\5E38\306B\5024\3092\8FD4\3057\307E\3059\3002</dt>'),
'<dd><pre>',
':P2_JOB = ''MANAGER'' and',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104623304819308937)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3059\308BSQL\5F0F\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104623266368308937)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104765540948309062)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_STATEMENT.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3057\3066\3044\308B\304B\3069\3046\304B\3092\30C1\30A7\30C3\30AF\3057\305F\3068\304D\306B\30011\3064\4EE5\4E0A\306E\884C\304C\5B58\5728\3059\308B\3068\3001\6B63\5E38\306B\5024\3092\8FD4\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
unistr('<dt>\5F93\696D\54E1\304C\90E8\958040\306B\6240\5C5E\3057\3066\3044\308B\304B\3069\3046\304B\3092\30C1\30A7\30C3\30AF\3057\305F\3068\304D\306B\30011\3064\3082\884C\304C\5B58\5728\3057\306A\3044\3068\3001\6B63\5E38\306B\5024\3092\8FD4\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 40',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104218595843308623)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_STATEMENT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3059\308BSQL\554F\5408\305B\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104218489099308623)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_STATEMENT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104219986163308624)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TEXT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3059\308B\30C6\30AD\30B9\30C8\5024\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104219866527308624)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TEXT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104220513924308625)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TEXT2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3059\308B\5024(<code>&ITEM.</code>\7F6E\63DB\6587\5B57\5217\3092\542B\3080)\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104220453256308624)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TEXT2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104218321481308623)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30EA\30F3\30AF\3092\30EC\30F3\30C0\30EA\30F3\30B0\3059\308B\305F\3081\306B\5FC5\8981\306A\6761\4EF6\30BF\30A4\30D7\3092\9078\629E\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104469407133308809)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ALWAYS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5E38\6642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104605171629308923)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ALWAYS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306F\5E38\306B\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104468007580308808)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.BROWSER_IS_MSIE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30E9\30A4\30A2\30F3\30C8\306E\30D6\30E9\30A6\30B6\306FMicrosoft Internet Explorer 7.0\4EE5\4E0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104468116891308808)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.BROWSER_IS_MSIE_OR_NSCP.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30E9\30A4\30A2\30F3\30C8\30FB\30D6\30E9\30A6\30B6\306FXHTML / CSS\5BFE\5FDC\30D6\30E9\30A6\30B6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104467931662308808)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.BROWSER_IS_NSCP.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30E9\30A4\30A2\30F3\30C8\306E\30D6\30E9\30A6\30B6\306FMozilla\3001Netscape 6.x/7x\4EE5\4E0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104468244102308808)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.BROWSER_IS_OTHER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30E9\30A4\30A2\30F3\30C8\306E\30D6\30E9\30A6\30B6\306F\305D\306E\4ED6\306E\30D6\30E9\30A6\30B6(\307E\305F\306F\4EE5\524D\306E\30D0\30FC\30B8\30E7\30F3)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104466610090308807)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CONDITION1_IN_VALUE_OF_ITEM_IN_CONDITION2.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8\306F\30A2\30A4\30C6\30E0\306B\542B\307E\308C\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104468676858308808)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\8A00\8A9E = \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104608759313308926)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\3001\30E6\30FC\30B6\30FC\304C<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\8A00\8A9E\3067\73FE\5728\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\5B9F\884C\3057\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104468354896308808)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\8A00\8A9E\306F\5024\306B\542B\307E\308C\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104608971496308926)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\3001\30E6\30FC\30B6\30FC\304C<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\8A00\8A9E\306E\3044\305A\308C\304B\3067\73FE\5728\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\5B9F\884C\3057\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104468523367308808)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\8A00\8A9E != \5024')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104608870544308926)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\3001\30E6\30FC\30B6\30FC\304C<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\8A00\8A9E\3067\73FE\5728\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\5B9F\884C\3057\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104468478427308808)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\8A00\8A9E\306F\5024\306B\542B\307E\308C\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104609091607308926)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\3001\30E6\30FC\30B6\30FC\304C<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\8A00\8A9E\306E\3044\305A\308C\304B\3067\73FE\5728\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\5B9F\884C\3057\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104465857567308806)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8 = \30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104607516532308925)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8\306F\3001<em>\300C\30DA\30FC\30B8\300D</em>\306B\5165\529B\3057\305F\5024\3068\7B49\3057\3044\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104466099728308806)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8\306F\30AB\30F3\30DE\3067\533A\5207\3089\308C\305F\30EA\30B9\30C8\306B\542B\307E\308C\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104607784965308925)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8\306F\3001<em>\300C\30DA\30FC\30B8\300D</em>\306B\5165\529B\3057\305F\30AB\30F3\30DE\533A\5207\308A\306E\30EA\30B9\30C8\306B\542B\307E\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104465971952308806)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8 != \30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104607601652308925)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8\306F\3001<em>\300C\30DA\30FC\30B8\300D</em>\306B\5165\529B\3057\305F\5024\3068\7B49\3057\304F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104466120046308807)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8\306F\30AB\30F3\30DE\3067\533A\5207\3089\308C\305F\30EA\30B9\30C8\306B\542B\307E\308C\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104607822727308925)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8\306F\3001<em>\300C\30DA\30FC\30B8\300D</em>\306B\5165\529B\3057\305F\30AB\30F3\30DE\533A\5207\308A\306E\30EA\30B9\30C8\306B\542B\307E\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104468746379308808)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DAD_NAME_EQ_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('CGI_ENV: DAD_NAME = \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104468849976308808)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DAD_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('CGI_ENV: DAD_NAME != \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104467592310308808)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30E9\30A4\30F3\691C\8A3C\30A8\30E9\30FC\3042\308A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104608573036308925)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306E\9001\4FE1\5F8C\3001\30A4\30F3\30E9\30A4\30F3\691C\8A3C\30A8\30E9\30FC\304C\30DA\30FC\30B8\306B\8868\793A\3055\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104466927046308807)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISPLAY_COND_EQUAL_COND_TEXT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8 = \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104466725252308807)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISPLAY_COND_IN_COND_TEXT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8\306F\5024\306B\542B\307E\308C\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104466802850308807)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISPLAY_COND_NOT_IN_COND_TEXT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8\306F\5024\306B\542B\307E\308C\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104467097394308807)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISP_COND_NOT_EQUAL_COND_TEXT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8 != \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104463585508308805)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.EXISTS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\304C\8FD4\3055\308C\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104605279690308923)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.EXISTS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B\306F1\3064\4EE5\4E0A\306E\884C\3092\8FD4\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104622397036308936)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104622493475308937)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5F0F\306FTRUE\3068\8A55\4FA1\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104463725398308805)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104605407117308923)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\306FTRUE\3092\8FD4\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104469162451308809)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.HTTP_HOST_EQ_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('CGI_ENV: HTTP_HOST = \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104469221872308809)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.HTTP_HOST_NOT_EQ_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('CGI_ENV: HTTP_HOST != \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104467270289308807)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8/\30EA\30FC\30B8\30E7\30F3\306F\8AAD\53D6\308A\5C02\7528\3067\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104608275370308925)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\304A\3088\3073\89AA\30EA\30FC\30B8\30E7\30F3(\8A72\5F53\3059\308B\5834\5408)\306F\6B63\5E38\306B\8868\793A\3055\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104467187068308807)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.IS_READ_ONLY.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8/\30EA\30FC\30B8\30E7\30F3\306F\8AAD\53D6\308A\5C02\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104608143835308925)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.IS_READ_ONLY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\307E\305F\306F\89AA\30EA\30FC\30B8\30E7\30F3(\8A72\5F53\3059\308B\5834\5408)\306E\300C\8AAD\53D6\308A\5C02\7528\300D\6761\4EF6\306FTRUE\3068\8A55\4FA1\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104465087291308806)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306B\7A7A\767D\304C\542B\307E\308C\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104606711738308924)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F\7A7A\767D\3092\542B\307F\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104465323798308806)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306F\82F1\6570\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104607021651308924)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F\82F1\6570\5B57\3067\3001\6587\5B57\307E\305F\306F\6570\5B57\306E\307F\3092\542B\307F\3001\7279\6B8A\6587\5B57\3092\542B\307F\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104464576877308805)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306FNULL\3067\306F\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104606234769308924)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F\7A7A\3067\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104465221495308806)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306F\6570\5B57\3067\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104606920720308924)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F\6570\5B57\3067\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104464762559308806)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306F0(\30BC\30ED)\3067\306F\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104606440565308924)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F0(\30BC\30ED)\3067\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104464427266308805)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NULL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306FNULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104606105245308924)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NULL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F\7A7A\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104464808192308806)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306FNULL\307E\305F\306F0(\30BC\30ED)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104606532029308924)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F\7A7A\307E\305F\306F0(\30BC\30ED)\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104465128731308806)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306F\6570\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104606876375308924)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F\6570\5B57\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104464651184308805)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_ZERO.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306F0(\30BC\30ED)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104606313852308924)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_ZERO.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F0(\30BC\30ED)\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104464997875308806)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306FNULL\3067\306A\304F\30010(\30BC\30ED)\3067\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104606635478308924)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F\7A7A\3067\306F\306A\304F\30010(\30BC\30ED)\3067\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104467741019308808)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.MAX_ROWS_LT_ROWS_FETCHED.D'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\30EC\30DD\30FC\30C8(\300COK\300D\3092\30AF\30EA\30C3\30AF\3059\308B\3068\300C\9032\3080\300D\30DC\30BF\30F3\3092\8868\793A)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104467856696308808)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.MIN_ROW_GT_THAN_ONE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\30EC\30DD\30FC\30C8(\300COK\300D\3092\30AF\30EA\30C3\30AF\3059\308B\3068\300C\623B\308B\300D\30DC\30BF\30F3\3092\8868\793A)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104469327548308809)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NEVER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104609168971308926)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NEVER.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306F\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\307E\305B\3093\3002</p>'),
unistr('<p>\30CE\30FC\30C8: \6761\4EF6\3092<strong>\300C\306A\3057\300D</strong>\306B\5909\66F4\3059\308B\3068\3001\65E2\5B58\306E\6761\4EF6\304C\524A\9664\3055\308C\307E\3059\3002\30B3\30F3\30DD\30FC\30CD\30F3\30C8\3092\4E00\6642\7684\306B\7121\52B9\306B\3059\308B\306B\306F\3001\304B\308F\308A\306B<em>\300C\30D3\30EB\30C9\30FB\30AA\30D7\30B7\30E7\30F3\300D</em>\5C5E\6027\3092\4F7F\7528\3059\308B\3053\3068\3092\304A\85A6\3081\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104467607094308808)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30E9\30A4\30F3\691C\8A3C\30A8\30E9\30FC\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104608680753308925)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30E9\30A4\30F3\691C\8A3C\30A8\30E9\30FC\306F\30DA\30FC\30B8\306B\8868\793A\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104463687982308805)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NOT_EXISTS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\304C\8FD4\3055\308C\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104605391535308923)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B\306F\884C\3092\8FD4\3057\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104466470486308807)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8\306F\300C\5370\5237\7528\300D\30E2\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104607993004308925)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8\306F\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\3088\3063\3066\300C\5370\5237\7528\300D\30E2\30FC\30C9\306B\5207\308A\66FF\3048\3089\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104466562881308807)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30EC\30F3\30C8\30FB\30DA\30FC\30B8\306F\300C\5370\5237\7528\300D\30E2\30FC\30C9\3067\306F\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104608041449308925)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8\306F\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\3088\3063\3066\300C\5370\5237\7528\300D\30E2\30FC\30C9\306B\5207\308A\66FF\3048\3089\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104463806056308805)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30AF\30A8\30B9\30C8 = \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104605512581308923)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30EA\30AF\30A8\30B9\30C8\306F\3001<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\3068\7B49\3057\3044\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104464054300308805)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30AF\30A8\30B9\30C8\306F\5024\306B\542B\307E\308C\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104605775545308923)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30EA\30AF\30A8\30B9\30C8\306F\3001<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\306B\542B\307E\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104463998188308805)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30AF\30A8\30B9\30C8 != \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104605606158308923)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30EA\30AF\30A8\30B9\30C8\306F\3001<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\3068\7B49\3057\304F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104464162238308805)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30AF\30A8\30B9\30C8\306F\5024\306B\542B\307E\308C\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104605801486308923)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30EA\30AF\30A8\30B9\30C8\306F\3001<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\306B\542B\307E\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104468969196308809)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.SERVER_NAME_EQ_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('CGI_ENV: SERVER_NAME = \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104469004410308809)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.SERVER_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('CGI_ENV: SERVER_NAME != \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104467371419308807)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\6E08\30E6\30FC\30B6\30FC(\975E\30D1\30D6\30EA\30C3\30AF\30FB\30E6\30FC\30B6\30FC)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104608358666308925)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\30ED\30B0\30A4\30F3\3057\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104467482381308807)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30D6\30EA\30C3\30AF\30FB\30E6\30FC\30B6\30FC(\8A8D\8A3C\3055\308C\3066\3044\306A\3044\30E6\30FC\30B6\30FC)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104608453615308925)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\30ED\30B0\30A4\30F3\3057\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104465666977308806)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\30FB\30D7\30EA\30D5\30A1\30EC\30F3\30B9 = \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104607352337308924)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F<em>\30D7\30EA\30D5\30A1\30EC\30F3\30B9</em>\306E\5024\306F\3001<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\3068\7B49\3057\3044\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104465707079308806)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\30FB\30D7\30EA\30D5\30A1\30EC\30F3\30B9 != \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104607459792308925)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F<em>\30D7\30EA\30D5\30A1\30EC\30F3\30B9</em>\306E\5024\306F\3001<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\3068\7B49\3057\304F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104465472344308806)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306F\30B3\30ED\30F3\3067\533A\5207\3089\308C\305F\30EA\30B9\30C8\306B\542B\307E\308C\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104607192603308924)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F\3001<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\306B\5B8C\5168\306B\542B\307E\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104465555955308806)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306F\30B3\30ED\30F3\3067\533A\5207\3089\308C\305F\30EA\30B9\30C8\306B\542B\307E\308C\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104607247447308924)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F\3001<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\306B\5B8C\5168\306B\306F\542B\307E\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104464203208308805)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0 = \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104605997966308923)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F\3001<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\3068\7B49\3057\3044\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104464349578308805)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0 != \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104606020224308923)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F\3001<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\3068\7B49\3057\304F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104466380426308807)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_NOT_SUBMITTED.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8 != \9001\4FE1\30DA\30FC\30B8(\30DD\30B9\30C8\6E08)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104466295299308807)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_SUBMITTED.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8 = \9001\4FE1\30DA\30FC\30B8(\30DD\30B9\30C8\6E08)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104218243911308623)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6761\4EF6\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104218715274308623)
,p_name=>'PE.PROPERTY.LINK_CONDITION_VALUE1.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\6761\4EF6\3068\6BD4\8F03\3059\308B\5024\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104218694753308623)
,p_name=>'PE.PROPERTY.LINK_CONDITION_VALUE1.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104220168366308624)
,p_name=>'PE.PROPERTY.LINK_CONDITION_VALUE2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3059\308B\5024(<code>&ITEM.</code>\7F6E\63DB\6587\5B57\5217\3092\542B\3080)\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104220048809308624)
,p_name=>'PE.PROPERTY.LINK_CONDITION_VALUE2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104351817033308720)
,p_name=>'PE.PROPERTY.LINK_EXAMPLE.COMPONENT_PROPERTY.CLASSIC_REPORT_PRINT_ATTR.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30EC\30DD\30FC\30C8\30FB\30EA\30FC\30B8\30E7\30F3\306F\3001\30EC\30DD\30FC\30C8\30FB\30EA\30FC\30B8\30E7\30F3\306E\4E0B\306B\8868\793A\3055\308C\308B\6A19\6E96\306E\51FA\529B\30EA\30F3\30AF\3092\4F7F\7528\3057\3066\3001\307E\305F\306F\30DC\30BF\30F3\3092\4F7F\7528\3057\3066\51FA\529B\3067\304D\307E\3059\3002\30DC\30BF\30F3\3092\4F7F\7528\3059\308B\5834\5408\306F\3001\30EA\30F3\30AF\30FB\30E9\30D9\30EB\3092\524A\9664\3057\3001\30DC\30BF\30F3\30FB\30BF\30FC\30B2\30C3\30C8\3068\3057\3066\300C\51FA\529BURL\300D\306B\793A\3055\308C\308BURL\3092\4F7F\7528\3057\3066\30DA\30FC\30B8\306B\30DC\30BF\30F3\3092\4F5C\6210\3057\307E\3059\3002</p>'),
unistr('<p>\30DC\30BF\30F3\3092\4F7F\7528\3057\3066\30EC\30DD\30FC\30C8\30FB\30EA\30FC\30B8\30E7\30F3\3092\51FA\529B\3059\308B\3068\3001\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\306E\8A2D\5B9A\304C\53EF\80FD\3067\3059\3002\3053\308C\306F\3001\8907\6570\306E\7570\306A\308B\51FA\529B\5F62\5F0F(Word\3001Excel\3001PDF\306A\3069)\3078\306E\51FA\529B\3092\30B5\30DD\30FC\30C8\3057\3001\5404\30AA\30D7\30B7\30E7\30F3\7528\306E\30DC\30BF\30F3\3001\30EA\30F3\30AF\307E\305F\306F\30A4\30E1\30FC\30B8\3092\8868\793A\3059\308B\5834\5408\306B\4FBF\5229\3067\3059\3002\3053\308C\3092\5B9F\88C5\3059\308B\306B\306F\3001\30A2\30A4\30C6\30E0\30FB\30AA\30D7\30B7\30E7\30F3\304B\3089\5C0E\51FA\3057\305F\51FA\529B\5F62\5F0F\3092\4F7F\7528\3057\3066\3001\305D\306E\30A2\30A4\30C6\30E0\540D\3068\5024\3092\51FA\529BURL\306B\542B\3081\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104580908725308903)
,p_name=>'PE.PROPERTY.LINK_EXAMPLE.COMPONENT_PROPERTY.IG_SAVED_REPORT.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\4FDD\5B58\6E08\30EC\30DD\30FC\30C8\306EURL\30EA\30F3\30AF\3092\8868\793A\3057\307E\3059\3002\3053\306E\5C5E\6027\306F\8868\793A\5C02\7528\3067\66F4\65B0\3067\304D\307E\305B\3093\3002</p>'),
unistr('    <p>\3053\306E\5C5E\6027\306B\3088\3063\3066\3001\8868\793A\3055\308C\3066\3044\308BURL\3092\7C21\5358\306B\30B3\30D4\30FC\3067\304D\307E\3059\3002\3053\306EURL\3092\4F7F\7528\3057\3066\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5185\306E\5225\306E\5834\6240\304B\3089\3053\306E\7279\5B9A\306E\4FDD\5B58\6E08\30EC\30DD\30FC\30C8\306B\76F4\63A5\30EA\30F3\30AF\3067\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104352428594308721)
,p_name=>'PE.PROPERTY.LINK_EXAMPLE.COMPONENT_PROPERTY.TABULAR_FORM_PRINT_ATTR.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30EC\30DD\30FC\30C8\30FB\30EA\30FC\30B8\30E7\30F3\306F\3001\30EC\30DD\30FC\30C8\30FB\30EA\30FC\30B8\30E7\30F3\306E\4E0B\306B\8868\793A\3055\308C\308B\6A19\6E96\306E\51FA\529B\30EA\30F3\30AF\3092\4F7F\7528\3057\3066\3001\307E\305F\306F\30DC\30BF\30F3\3092\4F7F\7528\3057\3066\51FA\529B\3067\304D\307E\3059\3002\30DC\30BF\30F3\3092\4F7F\7528\3059\308B\5834\5408\306F\3001\30EA\30F3\30AF\30FB\30E9\30D9\30EB\3092\524A\9664\3057\3001\30DC\30BF\30F3\30FB\30BF\30FC\30B2\30C3\30C8\3068\3057\3066\300C\51FA\529BURL\300D\306B\793A\3055\308C\308BURL\3092\4F7F\7528\3057\3066\30DA\30FC\30B8\306B\30DC\30BF\30F3\3092\4F5C\6210\3057\307E\3059\3002</p>'),
unistr('<p>\30DC\30BF\30F3\3092\4F7F\7528\3057\3066\30EC\30DD\30FC\30C8\30FB\30EA\30FC\30B8\30E7\30F3\3092\51FA\529B\3059\308B\3068\3001\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\306E\8A2D\5B9A\304C\53EF\80FD\3067\3059\3002\3053\308C\306F\3001\8907\6570\306E\7570\306A\308B\51FA\529B\5F62\5F0F(Word\3001Excel\3001PDF\306A\3069)\3078\306E\51FA\529B\3092\30B5\30DD\30FC\30C8\3057\3001\5404\30AA\30D7\30B7\30E7\30F3\7528\306E\30DC\30BF\30F3\3001\30EA\30F3\30AF\307E\305F\306F\30A4\30E1\30FC\30B8\3092\8868\793A\3059\308B\5834\5408\306B\4FBF\5229\3067\3059\3002\3053\308C\3092\5B9F\88C5\3059\308B\306B\306F\3001\30A2\30A4\30C6\30E0\30FB\30AA\30D7\30B7\30E7\30F3\304B\3089\5C0E\51FA\3057\305F\51FA\529B\5F62\5F0F\3092\4F7F\7528\3057\3066\3001\305D\306E\30A2\30A4\30C6\30E0\540D\3068\5024\3092\51FA\529BURL\306B\542B\3081\307E\3059\3002</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104221255598308625)
,p_name=>'PE.PROPERTY.LINK_EXAMPLE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\4FDD\5B58\6E08\30EC\30DD\30FC\30C8\306EURL\30EA\30F3\30AF\3092\8868\793A\3057\307E\3059\3002\3053\306E\5C5E\6027\306F\8868\793A\5C02\7528\3067\66F4\65B0\3067\304D\307E\305B\3093\3002</p>'),
unistr('<p>\3053\306E\5C5E\6027\306B\3088\3063\3066\3001\8868\793A\3055\308C\3066\3044\308BURL\3092\7C21\5358\306B\30B3\30D4\30FC\3067\304D\307E\3059\3002\3053\306EURL\3092\4F7F\7528\3057\3066\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5185\306E\5225\306E\5834\6240\304B\3089\3053\306E\7279\5B9A\306E\4FDD\5B58\6E08\30EC\30DD\30FC\30C8\306B\76F4\63A5\30EA\30F3\30AF\3067\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104221176166308625)
,p_name=>'PE.PROPERTY.LINK_EXAMPLE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30F3\30AF\4F8B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104210180703308617)
,p_name=>'PE.PROPERTY.LINK_ICON.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30F3\30AF\306B\4F7F\7528\3055\308C\308BHTML\3092\5165\529B\3057\307E\3059\3002\30A4\30E1\30FC\30B8\30FB\30BF\30B0\3092\4F7F\7528\3057\3066\30A4\30E1\30FC\30B8\3092\8868\793A\3059\308B\304B\3001\30C7\30D5\30A9\30EB\30C8\30FB\30A4\30E1\30FC\30B8\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002\5B9A\7FA9\3057\306A\3044\5834\5408\306F\3001<code>#IMAGE_PREFIX#ws/small_page.gif</code>\304C\4F7F\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104210055030308617)
,p_name=>'PE.PROPERTY.LINK_ICON.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30F3\30AF\30FB\30A2\30A4\30B3\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104220898237308625)
,p_name=>'PE.PROPERTY.LINK_TARGET.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\300C\30BF\30FC\30B2\30C3\30C8\300D\3092\30AF\30EA\30C3\30AF\3057\3066\30E2\30FC\30C0\30EB\30FB\30C0\30A4\30A2\30ED\30B0\3092\8D77\52D5\3057\307E\3059\3002\300C\30EA\30F3\30AF\5217\300D\3092\30AF\30EA\30C3\30AF\3057\305F\3068\304D\306B\30B3\30FC\30EB\3055\308C\308B\30AB\30B9\30BF\30E0\30FB\30BF\30FC\30B2\30C3\30C8\3092\5165\529B\3067\304D\307E\3059\3002</p>'),
unistr('        <p>\8981\4EF6\306B\57FA\3065\3044\3066\300C\30EA\30F3\30AF\30FB\30D3\30EB\30C0\30FC - \30BF\30FC\30B2\30C3\30C8\300D\3067\9069\5207\306A\30BF\30A4\30D7\3092\9078\629E\3057\307E\3059\3002'),
'        <dl>',
unistr('        <dt>\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30DA\30FC\30B8</dt>'),
unistr('        <dd>\6B21\306E\3088\3046\306B\5165\529B\3057\307E\3059\3002'),
'        <ul>',
unistr('        <li>\30DA\30FC\30B8 - \30CA\30D3\30B2\30FC\30C8\3059\308B\30DA\30FC\30B8\756A\53F7\307E\305F\306F\30DA\30FC\30B8\5225\540D\3092\5165\529B\3057\307E\3059\3002\9078\629E\30EA\30B9\30C8\304B\3089\30DA\30FC\30B8\756A\53F7\3092\9078\629E\3059\308B\3053\3068\3082\3067\304D\307E\3059\3002</li>'),
unistr('        <li>\30A2\30A4\30C6\30E0\306E\8A2D\5B9A: \540D\524D - \30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\306B\8A2D\5B9A\3059\308B\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0(<code>P3_ID</code>)\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0(<code>LAST_PAGE</code>)\307E\305F\306F\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\30FB\30D5\30A3\30EB\30BF(<code>IR_EMPNO</code>)\3092\5165\529B\307E\305F\306F\9078\629E\3057\307E\3059\3002</li>'),
unistr('        <li>\30A2\30A4\30C6\30E0\306E\8A2D\5B9A: \5024 - \30EC\30DD\30FC\30C8\5217(<code>#ID#</code>)\3092\5165\529B\307E\305F\306F\9078\629E\3059\308B\304B\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\307E\305F\306F\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0(<code>&P2_EMPNO.</code>)\3092\5165\529B\3059\308B\304B\3001\9759\7684\5024(<code>2</code>)\3092\5165\529B\3057\307E\3059\3002</li>'),
unistr('        <li>\30AD\30E3\30C3\30B7\30E5\306E\30AF\30EA\30A2 - \30AF\30EA\30A2\3059\308B\30DA\30FC\30B8\756A\53F7(<code>2,3</code>)\3001\30A2\30A4\30C6\30E0(<code>P3_EMPNO,LAST_PAGE</code>)\304A\3088\3073\30EC\30DD\30FC\30C8\8A2D\5B9A\306E\30AB\30F3\30DE\533A\5207\308A\30EA\30B9\30C8\3092\5165\529B\3057\307E\3059\3002\30EC\30DD\30FC\30C8\306E\30DA\30FC\30B8\533A\5207\308A\3092\30EA\30BB\30C3\30C8\3059\308B\306B\306F\3001<code>RP</code>\3092\5165\529B\3057\307E\3059\3002\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\306E\8A2D\5B9A\3092\30AF\30EA\30A2\307E\305F\306F\30EA\30BB\30C3\30C8\3059\308B\306B\306F\3001<code>CIR</code>\307E\305F\306F<code>RIR</code>\3092\5165\529B\3057\307E\3059\3002</li>'),
unistr('        <li>\30DA\30FC\30B8\533A\5207\308A\306E\30EA\30BB\30C3\30C8 - \300C\306F\3044\300D\3092\9078\629E\3059\308B\3068\3001\30BF\30FC\30B2\30C3\30C8\30FB\30DA\30FC\30B8\306E\30EC\30DD\30FC\30C8\3067\30DA\30FC\30B8\533A\5207\308A\3092\30EA\30BB\30C3\30C8\3057\3001\30EC\30B3\30FC\30C9\306E\6700\521D\306E\30BB\30C3\30C8\306B\623B\308B\3053\3068\304C\3067\304D\307E\3059\3002\3053\308C\306F\3001\300C\30AD\30E3\30C3\30B7\30E5\306E\30AF\30EA\30A2\300D\306B<code>RP</code>\3092\6E21\3059\5834\5408\3068\540C\3058\52B9\679C\304C\3042\308A\307E\3059\3002</li>'),
unistr('        <li>\8A73\7D30: \30EA\30AF\30A8\30B9\30C8 - \4F7F\7528\3059\308B\30EA\30AF\30A8\30B9\30C8\3092\5165\529B\3057\307E\3059\3002</li>'),
'        </ul>',
'        </dd>',
unistr('        <dt>\5225\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30DA\30FC\30B8</dt>'),
unistr('        <dd>\300C\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30DA\30FC\30B8\300D\306B\30EA\30B9\30C8\3055\308C\3066\3044\308B\3082\306E\3068\540C\3058\5C5E\6027\3092\5165\529B\3057\307E\3059\304C\3001\5225\9014\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3ID\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5225\540D\3092\5165\529B\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</dd>'),
'        <dt>URL</dt>',
unistr('        <dd>URL\3092\5165\529B\3057\307E\3059</dd>'),
'        </dl></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104220793247308625)
,p_name=>'PE.PROPERTY.LINK_TARGET.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30FC\30B2\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104539212405308867)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30C3\30D7\4E0A\306E\30AA\30D6\30B8\30A7\30AF\30C8\304C\30AF\30EA\30C3\30AF\3055\308C\305F\3068\304D\306B\5B9F\884C\3059\308B\30A2\30AF\30B7\30E7\30F3\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104155923800308571)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\304C\30AF\30EA\30C3\30AF\3055\308C\305F\3068\304D\306B\5B9F\884C\3059\308B\30A2\30AF\30B7\30E7\30F3\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104115205491308529)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.DEPRECATED_LINK_COLUMN.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\521D\306E\5217\306B\3088\3063\3066\8FD4\3055\308C\305FURL\306B\30EA\30C0\30A4\30EC\30AF\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104115300033308529)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.DEPRECATED_LINK_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B\306E\6700\521D\306E\5217\306B\3088\3063\3066\8FD4\3055\308C\305F\30BF\30FC\30B2\30C3\30C8URL\306B\30EA\30C0\30A4\30EC\30AF\30C8\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104156243583308571)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_APP.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5225\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30DA\30FC\30B8\306B\30EA\30C0\30A4\30EC\30AF\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104156321655308571)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_APP.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30BF\30FC\30B2\30C3\30C8\30FB\30DA\30FC\30B8\3067\306E\30DA\30FC\30B8\533A\5207\308A\306E\30EA\30BB\30C3\30C8\3001\30EA\30AF\30A8\30B9\30C8\5024\306E\8A2D\5B9A\3001\30AD\30E3\30C3\30B7\30E5\306E\30AF\30EA\30A2\304A\3088\3073\30A2\30A4\30C6\30E0\5024\306E\8A2D\5B9A\306E\305F\3081\306E\30AA\30D7\30B7\30E7\30F3\306E\8FFD\52A0\5C5E\6027\3092\6307\5B9A\3057\3066\3001\5225\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30DA\30FC\30B8\306B\30EA\30C0\30A4\30EC\30AF\30C8\3057\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8: \5225\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30DA\30FC\30B8\3078\306E\30EA\30C0\30A4\30EC\30AF\30C8\306F\3001\30BF\30FC\30B2\30C3\30C8\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\6709\52B9\5316\3055\308C\3066\3044\308B\30C7\30A3\30FC\30D7\30FB\30EA\30F3\30AF\306B\4F9D\5B58\3057\307E\3059\3002\30C7\30A3\30FC\30D7\30FB\30EA\30F3\30AF\3092\6709\52B9\5316\3059\308B\306B\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E<em>\300C\30BB\30AD\30E5\30EA\30C6\30A3\300D</em>\5C5E\6027\306B\79FB\52D5\3057\3001<em>\300C\30C7\30A3\30FC\30D7\30FB\30EA\30F3\30AF\300D</em>\3092\6709\52B9\5316\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104156057822308571)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_PAGE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30DA\30FC\30B8\306B\30EA\30C0\30A4\30EC\30AF\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104156187390308571)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_PAGE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30FC\30B2\30C3\30C8\30FB\30DA\30FC\30B8\3067\306E\30DA\30FC\30B8\533A\5207\308A\306E\30EA\30BB\30C3\30C8\3001\30EA\30AF\30A8\30B9\30C8\5024\306E\8A2D\5B9A\3001\30AD\30E3\30C3\30B7\30E5\306E\30AF\30EA\30A2\304A\3088\3073\30A2\30A4\30C6\30E0\5024\306E\8A2D\5B9A\306E\305F\3081\306E\30AA\30D7\30B7\30E7\30F3\306E\8FFD\52A0\5C5E\6027\3092\6307\5B9A\3057\3066\3001\73FE\5728\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30DA\30FC\30B8\306B\30EA\30C0\30A4\30EC\30AF\30C8\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104156462882308571)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_URL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('URL\306B\30EA\30C0\30A4\30EC\30AF\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104156517133308571)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_URL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\6307\5B9A\3057\305F\30BF\30FC\30B2\30C3\30C8URL\306B\30EA\30C0\30A4\30EC\30AF\30C8\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104155894131308571)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104204407546308613)
,p_name=>'PE.PROPERTY.LINK_TEXT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30F3\30AF\3068\3057\3066\8868\793A\3055\308C\308BHTML\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002\30A4\30E1\30FC\30B8\3092\8868\793A\3059\308B\306B\306F\3001\30A4\30E1\30FC\30B8\30FB\30BF\30B0\3092\4F7F\7528\3059\308B\304B\3001\30C7\30D5\30A9\30EB\30C8\30FB\30A4\30E1\30FC\30B8\306E\30EA\30B9\30C8\304B\3089\30A4\30E1\30FC\30B8\3092\53D6\5F97\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104204383547308613)
,p_name=>'PE.PROPERTY.LINK_TEXT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30F3\30AF\30FB\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103516957850308028)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30EA\30B9\30C8\306E\5916\89B3\3068\30EC\30A4\30A2\30A6\30C8\3092\5B9A\7FA9\3059\308B\30C6\30F3\30D7\30EC\30FC\30C8\3092\9078\629E\3057\307E\3059\3002</p>'),
unistr('        <p>\30EA\30B9\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30C6\30FC\30DE\3067\5B9A\7FA9\3055\308C\307E\3059\3002'),
unistr('        \30EA\30B9\30C8\30FB\30EA\30FC\30B8\30E7\30F3\304C\4F5C\6210\3055\308C\308B\3068\3001\30C6\30F3\30D7\30EC\30FC\30C8\306F\3001\73FE\5728\306E\30C6\30FC\30DE\306B\5B9A\7FA9\3055\308C\3066\3044\308B\30C7\30D5\30A9\30EB\30C8\30FB\30EA\30B9\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306B\81EA\52D5\7684\306B\8A2D\5B9A\3055\308C\307E\3059\3002</p>'),
unistr('        <p>\30E6\30CB\30D0\30FC\30B5\30EB\30FB\30C6\30FC\30DE\306B\306F\3001\6B21\306E\30EA\30B9\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\304C\3042\308A\307E\3059\3002'),
'          <dl>',
unistr('            <dt>\30D0\30C3\30B8\30FB\30EA\30B9\30C8</dt>'),
unistr('            <dt>\30AB\30FC\30C9</dt>'),
unistr('            <dt>\30EA\30F3\30AF\30FB\30EA\30B9\30C8</dt>'),
unistr('            <dt>\30E1\30C7\30A3\30A2\30FB\30EA\30B9\30C8</dt>'),
unistr('            <dt>\30E1\30CB\30E5\30FC\30FB\30D0\30FC</dt>'),
unistr('            <dt>\30E1\30CB\30E5\30FC\30FB\30DD\30C3\30D7\30A2\30C3\30D7</dt>'),
unistr('            <dt>\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30D0\30FC</dt>'),
unistr('            <dt>\30B5\30A4\30C9\30FB\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC</dt>'),
unistr('            <dt>\30BF\30D6</dt>'),
unistr('            <dt>\30C8\30C3\30D7\30FB\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC</dt>'),
unistr('            <dt>\30A6\30A3\30B6\30FC\30C9\9032\6357</dt>'),
'          </dl>',
unistr('          \95A2\9023\9805\76EE: <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\30E6\30CB\30D0\30FC\30B5\30EB\30FB\30C6\30FC\30DE\306E\30B5\30F3\30D7\30EB\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3</a>'),
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103516877217308028)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104584949612308907)
,p_name=>'PE.PROPERTY.LIST_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8\30FB\30BF\30A4\30D7\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104585434698308907)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.FUNCTION_RETURNING_SQL_QUERY.D'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B\3092\623B\3059PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104585554892308907)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.FUNCTION_RETURNING_SQL_QUERY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\52D5\7684\30EA\30B9\30C8\306F\3001\5165\529B\3057\305FPL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\306B\3088\3063\3066\8FD4\3055\308C\308BSQL\554F\5408\305B\306B\57FA\3065\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104585214263308907)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104585317315308907)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\52D5\7684\30EA\30B9\30C8\306F\3001\5165\529B\3057\305FSQL\554F\5408\305B\306B\57FA\3065\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104585041494308907)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.STATIC.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\9759\7684\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104585182113308907)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.STATIC.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9759\7684\30EA\30B9\30C8\306F\3001\5165\529B\3057\305F\30C6\30AD\30B9\30C8\5024\306B\57FA\3065\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104584879688308907)
,p_name=>'PE.PROPERTY.LIST_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104270374430308661)
,p_name=>'PE.PROPERTY.LIST_VIEW_CUSTOM_DAYS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E88\5B9A\8868\30D3\30E5\30FC\306B\8868\793A\3059\308B\65E5\6570\306E\5408\8A08\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104270292808308660)
,p_name=>'PE.PROPERTY.LIST_VIEW_CUSTOM_DAYS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104270442215308661)
,p_name=>'PE.PROPERTY.LIST_VIEW_CUSTOM_DAYS.UNIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104270110731308660)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8\30FB\30D3\30E5\30FC\306B\8868\793A\3059\308B\65E5\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104429658610308779)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.CUSTOM.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30B9\30BF\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104429706047308779)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.CUSTOM.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3057\305F\65E5\6570\306B\57FA\3065\3044\3066\30AB\30EC\30F3\30C0\30FB\30A8\30F3\30C8\30EA\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104429277055308779)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.MONTH.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\6708')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104429327191308779)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.MONTH.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\6708\306E\30AB\30EC\30F3\30C0\30FB\30A8\30F3\30C8\30EA\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104429463863308779)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.YEAR.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\4ECA\5E74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104429519759308779)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.YEAR.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\5E74\306E\30AB\30EC\30F3\30C0\30FB\30A8\30F3\30C8\30EA\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104270009452308660)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104020240848308451)
,p_name=>'PE.PROPERTY.LOGIN_URL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\306B\5BFE\3059\308B\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104020122926308451)
,p_name=>'PE.PROPERTY.LOGIN_URL.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30B0\30A4\30F3URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103964686207308409)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30B0\30A2\30A6\30C8\5F8C\306E&PRODUCT_NAME.\306E\30EA\30C0\30A4\30EC\30AF\30C8\5148\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104398743360308756)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.LOV.HOME.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DB\30FC\30E0\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104398854716308756)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.LOV.HOME.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5C5E\6027\3067\6307\5B9A\3055\308C\305F\30DB\30FC\30E0\30FB\30EA\30F3\30AF\306B\30EA\30C0\30A4\30EC\30AF\30C8\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104398948828308756)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.LOV.URL.D'
,p_message_language=>'ja'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104399075506308756)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.LOV.URL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<code>f?p=&amp;APP_ID.:101:&amp;SESSION</code>\306A\3069\306E\5165\529B\3057\305FURL\306B\30EA\30C0\30A4\30EC\30AF\30C8\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103964594807308409)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30B0\30A2\30A6\30C8\30FB\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104097736453308514)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5931\308F\308C\305F\66F4\65B0\306B\5BFE\3057\3066\30C7\30FC\30BF\3092\4FDD\8B77\3059\308B\65B9\6CD5\3092\9078\629E\3057\307E\3059\3002'),
unistr('		2\4EBA\4EE5\4E0A\306E\30E6\30FC\30B6\30FC\304C\540C\3058\30C7\30FC\30BF\3092\66F4\65B0\3057\3088\3046\3068\3057\3001\5909\66F4\3092\4FDD\5B58\3059\308B\305F\3081\306B\6700\5F8C\306E\66F4\65B0\304C\6700\521D\306E\30E6\30FC\30B6\30FC\306E\66F4\65B0\3092\4E0A\66F8\304D\3059\308B\3068\3001\66F4\65B0\304C\5931\308F\308C\307E\3059\3002'),
unistr('		\3053\306E\767A\751F\3092\9632\6B62\3059\308B\306B\306F\3001\6700\521D\306E\30EC\30B3\30FC\30C9\306E\554F\5408\305B\6642\306B\53D6\5F97\3057\305F\5024\3068\3068\3082\306B\30C7\30FC\30BF\30D9\30FC\30B9\306E\65E2\5B58\306E\5217\5024\3092\66F4\65B0\3067\78BA\8A8D\3067\304D\307E\3059\3002</p>'),
unistr('		<p>\4F8B:'),
'          <ol>',
unistr('            <li>\30E6\30FC\30B6\30FCA\304C\5F93\696D\54E1(EMP)\30EC\30B3\30FC\30C9\3092\554F\3044\5408\305B\307E\3059\3002</li>'),
unistr('		    <li>\30E6\30FC\30B6\30FCB\304C\540C\3058\5F93\696D\54E1\30EC\30B3\30FC\30C9\3092\554F\3044\5408\305B\307E\3059\3002</li>'),
unistr('		    <li>\30E6\30FC\30B6\30FCB\304CEMPNO = 7839\306E\5F93\696D\54E1\8A73\7D30\3092\66F4\65B0\3057\3001\30C7\30FC\30BF\30D9\30FC\30B9\3078\306E\5909\66F4\3092\9069\7528(\30B3\30DF\30C3\30C8)\3057\307E\3059\3002</li>'),
unistr('		    <li>\30E6\30FC\30B6\30FCA\304CEMPNO = 7839\306E\5F93\696D\54E1\8A73\7D30\3092\66F4\65B0\3057\3001\30C7\30FC\30BF\30D9\30FC\30B9\3078\306E\5909\66F4\3092\9069\7528\3057\3088\3046\3068\3057\307E\3059\3002</li>'),
'          </ol>',
unistr('          \30E6\30FC\30B6\30FCA\304C\540C\3058\30EC\30B3\30FC\30C9\3092\6B63\5E38\306B\66F4\65B0\3059\308B\3068\3001\30E6\30FC\30B6\30FCB\304C\884C\3063\305F\5909\66F4\304C\5931\308F\308C\307E\3059\3002</p>'),
unistr('         <p>\30E6\30FC\30B6\30FCA\304C\5F93\696D\54E1\30EC\30B3\30FC\30C9\3092\4FDD\5B58\3057\3088\3046\3068\3059\308B\5834\5408\3001\30C7\30FC\30BF\30D9\30FC\30B9\306E\30C7\30FC\30BF\306F\30E6\30FC\30B6\30FCA\304C\6700\521D\306B\554F\3044\5408\305B\305F\5185\5BB9\3068\7570\306A\3063\3066\3044\307E\3059\3002'),
unistr('		  \524D\8FF0\306E\624B\98061\3067\3001\30E6\30FC\30B6\30FCA\304C\6700\521D\306B\554F\3044\5408\305B\305F\5217\5024\3092\53D6\5F97\3067\304D\307E\3059\3002'),
unistr('		  \524D\8FF0\306E\624B\98064\3067\3001\5024\3092\30C7\30FC\30BF\30D9\30FC\30B9\306E\73FE\5728\306E\5024\3068\6BD4\8F03\3067\304D\307E\3059\3002'),
unistr('		  \30C7\30FC\30BF\30D9\30FC\30B9\5024\304C\624B\98063\3067\30E6\30FC\30B6\30FCB\306B\3088\3063\3066\66F4\65B0\3055\308C\305F\305F\3081\3001\3053\306E\6BD4\8F03\306B\3088\308A\3001\30E6\30FC\30B6\30FCA\306B\5BFE\3057\3066\30A8\30E9\30FC\304C\767A\751F\3057\307E\3059\3002'),
unistr('		  \3053\308C\306B\3088\308A\3001\540C\3058\884C\306B\5BFE\3057\3066\5225\306E\30E6\30FC\30B6\30FC\304C\884C\3063\305F\5909\66F4\306E\4E0A\66F8\304D\304C\9632\6B62\3055\308C\307E\3059\3002</p>'),
unistr('		  <p>\30CE\30FC\30C8 - \5BFE\5FDC\3059\308B\30D7\30ED\30BB\30B9\306E\5BFE\8A71\30B0\30EA\30C3\30C9 - \884C\306E\81EA\52D5\51E6\7406(DML)\306E<strong>\300C\5931\308F\308C\305F\66F4\65B0\306E\9632\6B62\300D</strong>\304C\6709\52B9\3067\3042\308B\5834\5408\306B\306E\307F\3001\5931\308F\308C\305F\66F4\65B0\30BF\30A4\30D7\304C\4F7F\7528\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104097902890308515)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.LOV.COLUMN.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\30D0\30FC\30B8\30E7\30F3\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104227720802308630)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.LOV.COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30C7\30FC\30BF\30D9\30FC\30B9\8868\306B\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30C8\30EA\30AC\30FC(\53EF\80FD\306A\5834\5408)\306B\3088\3063\3066\30EC\30B3\30FC\30C9\304C\66F4\65B0\3055\308C\308B\305F\3073\306B\5897\3048\308B\5217\304C\542B\307E\308C\3066\3044\308B\5834\5408\3001\30C1\30A7\30C3\30AF\30B5\30E0\3092\8A08\7B97\3059\308B\304B\308F\308A\306B\3053\306E\5217\3092\4F7F\7528\3067\304D\307E\3059\3002'),
unistr('        \5BFE\8A71\30B0\30EA\30C3\30C9\3067\8907\6570\306E\8868\306E\30C7\30FC\30BF\3092\66F4\65B0\3059\308B\5834\5408\3001\3053\306E\30AA\30D7\30B7\30E7\30F3\3092\4F7F\7528\3057\306A\3044\3067\304F\3060\3055\3044\3002</p>'),
unistr('        <p>\30CE\30FC\30C8 - \884C\30D0\30FC\30B8\30E7\30F3\5217\3092\30EA\30FC\30B8\30E7\30F3\306ESQL\30BD\30FC\30B9\306B\542B\3081\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104097851961308514)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.LOV.VALUES.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\306E\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104227646494308630)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.LOV.VALUES.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30C7\30FC\30BF\3092\6700\521D\306B\554F\3044\5408\305B\308B\5834\5408\3001\30C1\30A7\30C3\30AF\30B5\30E0\5024\304C\5404\884C\306B\8A08\7B97\3055\308C\307E\3059\3002'),
unistr('        \30C1\30A7\30C3\30AF\30B5\30E0\306F\3001\3059\3079\3066\306E\66F4\65B0\53EF\80FD\306A\5217\3092\6587\5B57\5217\306B\9023\7D50\3057\3001\4E00\610F\306E\5024\3092\751F\6210\3057\3066\8A08\7B97\3055\308C\307E\3059\3002'),
unistr('        \66F4\65B0\3055\308C\305F\30EC\30B3\30FC\30C9\3092\30B3\30DF\30C3\30C8\3059\308B\3068\3001\3053\306E\30C1\30A7\30C3\30AF\30B5\30E0\304C\73FE\5728\306E\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30EC\30B3\30FC\30C9\306E\30C1\30A7\30C3\30AF\30B5\30E0\5024\3068\6BD4\8F03\3055\308C\307E\3059\3002'),
unistr('        \540C\3058\3067\306A\3044\5834\5408\3001\30A8\30E9\30FC\304C\767A\751F\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104097646818308514)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5931\308F\308C\305F\66F4\65B0\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104637079313308948)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\306E\5B9F\884C\306B\4F7F\7528\3055\308C\308B\8A00\8A9E\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104637301776308948)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'ja'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104637280872308948)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'ja'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104637175588308948)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'ja'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104637461457308949)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'ja'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104636903916308948)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A00\8A9E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104638228503308949)
,p_name=>'PE.PROPERTY.LOV_JAVA_FUNC_BODY_SQL.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306ELOV\306B\79FB\5165\3059\308B\305F\3081\306ESQL\554F\5408\305B\3092\8FD4\3059Java\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002\901A\5E38\3001LOV\554F\5408\305B\306F\6B21\306E\3088\3046\306A\5F62\5F0F\3067\3059\3002</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>\9078\629E\3055\308C\308B\5404\5217\306B\306F\4E00\610F\306E\540D\524D\307E\305F\306F\5225\540D\304C\5FC5\8981\3067\3059\3002SQL\5F0F\3092\542B\3080\5217\306B\306F\5225\540D\3092\4F7F\7528\3059\308B\3053\3068\3092\304A\85A6\3081\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104638199239308949)
,p_name=>'PE.PROPERTY.LOV_JAVA_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B\3092\8FD4\3059Java\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104638087559308949)
,p_name=>'PE.PROPERTY.LOV_JS_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\90E8\9580\540D\306E\8868\793A\3068\90E8\9580\756A\53F7\306E\8A2D\5B9A</dt>'),
'<dd><pre>',
'return "select dname as d, deptno as r from dept order by 1";',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104637906744308949)
,p_name=>'PE.PROPERTY.LOV_JS_FUNC_BODY_SQL.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306ELOV\306B\79FB\5165\3059\308B\305F\3081\306ESQL\554F\5408\305B\3092\8FD4\3059JavaScript\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002\901A\5E38\3001LOV\554F\5408\305B\306F\6B21\306E\3088\3046\306A\5F62\5F0F\3067\3059\3002</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>\9078\629E\3055\308C\308B\5404\5217\306B\306F\4E00\610F\306E\540D\524D\307E\305F\306F\5225\540D\304C\5FC5\8981\3067\3059\3002SQL\5F0F\3092\542B\3080\5217\306B\306F\5225\540D\3092\4F7F\7528\3059\308B\3053\3068\3092\304A\85A6\3081\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104637869777308949)
,p_name=>'PE.PROPERTY.LOV_JS_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B\3092\8FD4\3059JavaScript\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104233490483308634)
,p_name=>'PE.PROPERTY.LOV_NAME.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('LOV\306E\540D\524D\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104233311927308634)
,p_name=>'PE.PROPERTY.LOV_NAME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\540D\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103962599033308407)
,p_name=>'PE.PROPERTY.LOV_PAGE_ITEMS_TO_SUBMIT.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\3055\308C\305F\30AB\30B9\30B1\30FC\30C9LOV\89AA\30A2\30A4\30C6\30E0\306E\5024\304C\3053\306E\30DA\30FC\30B8\3067\5909\66F4\3055\308C\305F\3068\304D\306B\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\306B\8A2D\5B9A\3059\308B\5217\3001\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002'),
unistr('\8907\6570\306E\30A2\30A4\30C6\30E0\306E\5834\5408\3001\5404\30A2\30A4\30C6\30E0\540D\3092\30AB\30F3\30DE\3067\533A\5207\308A\307E\3059\3002'),
unistr('\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002'),
unistr('\30EA\30B9\30C8\304B\3089\9078\629E\3057\3001\3059\3067\306B\5165\529B\3055\308C\3066\3044\308B\30C6\30AD\30B9\30C8\304C\3042\308B\5834\5408\3001\65E2\5B58\306E\30C6\30AD\30B9\30C8\306E\6700\5F8C\306B\30AB\30F3\30DE\304C\4ED8\3051\3089\308C\3001\30EA\30B9\30C8\304B\3089\8FD4\3055\308C\305F\30A2\30A4\30C6\30E0\540D\304C\305D\308C\306B\7D9A\304D\307E\3059\3002</p>'),
unistr('<p>\8FD4\3055\308C\308B\5024\3092\5236\9650\3059\308B\306B\306F\3001\3053\306E\5C5E\6027\3067\6307\5B9A\3055\308C\305F\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3092\3053\306ELOV\306ESQL\554F\5408\305B\306E<em>where\53E5</em>\5185\306B\4F7F\7528\3057\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8: <em>\30AB\30B9\30B1\30FC\30C9LOV\89AA\30A2\30A4\30C6\30E0</em>\3067\5B9A\7FA9\3055\308C\305F\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306F\81EA\52D5\7684\306B\8EE2\9001\3055\308C\3001\3053\306E\5C5E\6027\306B\5165\529B\3059\308B\5FC5\8981\306F\3042\308A\307E\305B\3093\3002</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103962488885308407)
,p_name=>'PE.PROPERTY.LOV_PAGE_ITEMS_TO_SUBMIT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\9001\4FE1\3059\308B\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104637710793308949)
,p_name=>'PE.PROPERTY.LOV_PLSQL_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\90E8\9580\540D\306E\8868\793A\3068\90E8\9580\756A\53F7\306E\8A2D\5B9A</dt>'),
'<dd><pre>',
'begin',
'    return ''select dname as d, deptno as r from dept order by 1'';',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104637610534308949)
,p_name=>'PE.PROPERTY.LOV_PLSQL_FUNC_BODY_SQL.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306ELOV\306B\79FB\5165\3059\308B\305F\3081\306ESQL\554F\5408\305B\3092\623B\3059PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002\901A\5E38\3001LOV\554F\5408\305B\306F\6B21\306E\3088\3046\306A\5F62\5F0F\3067\3059\3002</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>\9078\629E\3055\308C\308B\5404\5217\306B\306F\4E00\610F\306E\540D\524D\307E\305F\306F\5225\540D\304C\5FC5\8981\3067\3059\3002SQL\5F0F\3092\542B\3080\5217\306B\306F\5225\540D\3092\4F7F\7528\3059\308B\3053\3068\3092\304A\85A6\3081\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104637500387308949)
,p_name=>'PE.PROPERTY.LOV_PLSQL_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B\3092\623B\3059PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104638489839308949)
,p_name=>'PE.PROPERTY.LOV_PYTHON_FUNC_BODY_SQL.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306ELOV\306B\79FB\5165\3059\308B\305F\3081\306ESQL\554F\5408\305B\3092\8FD4\3059Python\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002\901A\5E38\3001LOV\554F\5408\305B\306F\6B21\306E\3088\3046\306A\5F62\5F0F\3067\3059\3002</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>\9078\629E\3055\308C\308B\5404\5217\306B\306F\4E00\610F\306E\540D\524D\307E\305F\306F\5225\540D\304C\5FC5\8981\3067\3059\3002SQL\5F0F\3092\542B\3080\5217\306B\306F\5225\540D\3092\4F7F\7528\3059\308B\3053\3068\3092\304A\85A6\3081\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104638334772308949)
,p_name=>'PE.PROPERTY.LOV_PYTHON_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B\3092\8FD4\3059Python\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104701223498309001)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.FACET.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306ELOV\306B\79FB\5165\3059\308B\305F\3081\306ESQL\554F\5408\305B\5B9A\7FA9\3092\5165\529B\3057\307E\3059\3002\901A\5E38\3001LOV\554F\5408\305B\306F\6B21\306E\3088\3046\306A\5F62\5F0F\3067\3059\3002</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>\9078\629E\3055\308C\308B\5404\5217\306B\306F\4E00\610F\306E\540D\524D\307E\305F\306F\5225\540D\304C\5FC5\8981\3067\3059\3002SQL\5F0F\3092\542B\3080\5217\306B\306F\5225\540D\3092\4F7F\7528\3059\308B\3053\3068\3092\304A\85A6\3081\3057\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8: \30DD\30C3\30D7\30A2\30C3\30D7LOV\30A2\30A4\30C6\30E0\30FB\30BF\30A4\30D7\3092\5B9A\7FA9\3059\308B\3068\304D\306B\3001\30DD\30C3\30D7\30A2\30C3\30D7\3067\8907\6570\306E\5217\3092\8868\793A\3057\3088\3046\3068\3059\308B\5834\5408\3001\304B\308F\308A\306B\5FC5\9808\306E\8FFD\52A0\30E1\30BF\30C7\30FC\30BF\3068\3068\3082\306B\5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8\3067LOV\3092\5B9A\7FA9\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002'),
unistr('\30A4\30F3\30E9\30A4\30F3LOV\306F\3001\30DD\30C3\30D7\30A2\30C3\30D7LOV\3067\5358\4E00\5217\3092\8868\793A\3059\308B\5834\5408\306B\306E\307F\4F7F\7528\3067\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104557005613308884)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.FACET_GROUP_ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306ELOV\306B\79FB\5165\3059\308B\305F\3081\306ESQL\554F\5408\305B\5B9A\7FA9\3092\5165\529B\3057\307E\3059\3002\901A\5E38\3001LOV\554F\5408\305B\306F\6B21\306E\3088\3046\306A\5F62\5F0F\3067\3059\3002</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>\9078\629E\3055\308C\308B\5404\5217\306B\306F\4E00\610F\306E\540D\524D\307E\305F\306F\5225\540D\304C\5FC5\8981\3067\3059\3002SQL\5F0F\3092\542B\3080\5217\306B\306F\5225\540D\3092\4F7F\7528\3059\308B\3053\3068\3092\304A\85A6\3081\3057\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8: \30DD\30C3\30D7\30A2\30C3\30D7LOV\30A2\30A4\30C6\30E0\30FB\30BF\30A4\30D7\3092\5B9A\7FA9\3059\308B\3068\304D\306B\3001\30DD\30C3\30D7\30A2\30C3\30D7\3067\8907\6570\306E\5217\3092\8868\793A\3057\3088\3046\3068\3059\308B\5834\5408\3001\304B\308F\308A\306B\5FC5\9808\306E\8FFD\52A0\30E1\30BF\30C7\30FC\30BF\3068\3068\3082\306B\5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8\3067LOV\3092\5B9A\7FA9\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002'),
unistr('\30A4\30F3\30E9\30A4\30F3LOV\306F\3001\30DD\30C3\30D7\30A2\30C3\30D7LOV\3067\5358\4E00\5217\3092\8868\793A\3059\308B\5834\5408\306B\306E\307F\4F7F\7528\3067\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104717248939309014)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306ELOV\306B\79FB\5165\3059\308B\305F\3081\306ESQL\554F\5408\305B\5B9A\7FA9\3092\5165\529B\3057\307E\3059\3002\901A\5E38\3001LOV\554F\5408\305B\306F\6B21\306E\3088\3046\306A\5F62\5F0F\3067\3059\3002</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>\9078\629E\3055\308C\308B\5404\5217\306B\306F\4E00\610F\306E\540D\524D\307E\305F\306F\5225\540D\304C\5FC5\8981\3067\3059\3002SQL\5F0F\3092\542B\3080\5217\306B\306F\5225\540D\3092\4F7F\7528\3059\308B\3053\3068\3092\304A\85A6\3081\3057\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8: \30DD\30C3\30D7\30A2\30C3\30D7LOV\30A2\30A4\30C6\30E0\30FB\30BF\30A4\30D7\3092\5B9A\7FA9\3059\308B\3068\304D\306B\3001\30DD\30C3\30D7\30A2\30C3\30D7\3067\8907\6570\306E\5217\3092\8868\793A\3057\3088\3046\3068\3059\308B\5834\5408\3001\304B\308F\308A\306B\5FC5\9808\306E\8FFD\52A0\30E1\30BF\30C7\30FC\30BF\3068\3068\3082\306B\5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8\3067LOV\3092\5B9A\7FA9\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002'),
unistr('\30A4\30F3\30E9\30A4\30F3LOV\306F\3001\30DD\30C3\30D7\30A2\30C3\30D7LOV\3067\5358\4E00\5217\3092\8868\793A\3059\308B\5834\5408\306B\306E\307F\4F7F\7528\3067\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104701198210309001)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306ELOV\306B\79FB\5165\3059\308B\305F\3081\306ESQL\554F\5408\305B\5B9A\7FA9\3092\5165\529B\3057\307E\3059\3002\901A\5E38\3001LOV\554F\5408\305B\306F\6B21\306E\3088\3046\306A\5F62\5F0F\3067\3059\3002</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>\9078\629E\3055\308C\308B\5404\5217\306B\306F\4E00\610F\306E\540D\524D\307E\305F\306F\5225\540D\304C\5FC5\8981\3067\3059\3002SQL\5F0F\3092\542B\3080\5217\306B\306F\5225\540D\3092\4F7F\7528\3059\308B\3053\3068\3092\304A\85A6\3081\3057\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8: \30DD\30C3\30D7\30A2\30C3\30D7LOV\30A2\30A4\30C6\30E0\30FB\30BF\30A4\30D7\3092\5B9A\7FA9\3059\308B\3068\304D\306B\3001\30DD\30C3\30D7\30A2\30C3\30D7\3067\8907\6570\306E\5217\3092\8868\793A\3057\3088\3046\3068\3059\308B\5834\5408\3001\304B\308F\308A\306B\5FC5\9808\306E\8FFD\52A0\30E1\30BF\30C7\30FC\30BF\3068\3068\3082\306B\5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8\3067LOV\3092\5B9A\7FA9\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002'),
unistr('\30A4\30F3\30E9\30A4\30F3LOV\306F\3001\30DD\30C3\30D7\30A2\30C3\30D7LOV\3067\5358\4E00\5217\3092\8868\793A\3059\308B\5834\5408\306B\306E\307F\4F7F\7528\3067\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103920124198308374)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306ELOV\306B\79FB\5165\3059\308B\305F\3081\306ESQL\554F\5408\305B\5B9A\7FA9\3092\5165\529B\3057\307E\3059\3002\901A\5E38\3001LOV\554F\5408\305B\306F\6B21\306E\3088\3046\306A\5F62\5F0F\3067\3059\3002</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>\9078\629E\3055\308C\308B\5404\5217\306B\306F\4E00\610F\306E\540D\524D\307E\305F\306F\5225\540D\304C\5FC5\8981\3067\3059\3002SQL\5F0F\3092\542B\3080\5217\306B\306F\5225\540D\3092\4F7F\7528\3059\308B\3053\3068\3092\304A\85A6\3081\3057\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8: \30DD\30C3\30D7\30A2\30C3\30D7LOV\30A2\30A4\30C6\30E0\30FB\30BF\30A4\30D7\3092\5B9A\7FA9\3059\308B\3068\304D\306B\3001\30DD\30C3\30D7\30A2\30C3\30D7\3067\8907\6570\306E\5217\3092\8868\793A\3057\3088\3046\3068\3059\308B\5834\5408\3001\304B\308F\308A\306B\5FC5\9808\306E\8FFD\52A0\30E1\30BF\30C7\30FC\30BF\3068\3068\3082\306B\5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8\3067LOV\3092\5B9A\7FA9\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002'),
unistr('\30A4\30F3\30E9\30A4\30F3LOV\306F\3001\30DD\30C3\30D7\30A2\30C3\30D7LOV\3067\5358\4E00\5217\3092\8868\793A\3059\308B\5834\5408\306B\306E\307F\4F7F\7528\3067\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103921400359308375)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.SFILTER_GROUP_ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306ELOV\306B\79FB\5165\3059\308B\305F\3081\306ESQL\554F\5408\305B\5B9A\7FA9\3092\5165\529B\3057\307E\3059\3002\901A\5E38\3001LOV\554F\5408\305B\306F\6B21\306E\3088\3046\306A\5F62\5F0F\3067\3059\3002</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>\9078\629E\3055\308C\308B\5404\5217\306B\306F\4E00\610F\306E\540D\524D\307E\305F\306F\5225\540D\304C\5FC5\8981\3067\3059\3002SQL\5F0F\3092\542B\3080\5217\306B\306F\5225\540D\3092\4F7F\7528\3059\308B\3053\3068\3092\304A\85A6\3081\3057\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8: \30DD\30C3\30D7\30A2\30C3\30D7LOV\30A2\30A4\30C6\30E0\30FB\30BF\30A4\30D7\3092\5B9A\7FA9\3059\308B\3068\304D\306B\3001\30DD\30C3\30D7\30A2\30C3\30D7\3067\8907\6570\306E\5217\3092\8868\793A\3057\3088\3046\3068\3059\308B\5834\5408\3001\304B\308F\308A\306B\5FC5\9808\306E\8FFD\52A0\30E1\30BF\30C7\30FC\30BF\3068\3068\3082\306B\5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8\3067LOV\3092\5B9A\7FA9\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002'),
unistr('\30A4\30F3\30E9\30A4\30F3LOV\306F\3001\30DD\30C3\30D7\30A2\30C3\30D7LOV\3067\5358\4E00\5217\3092\8868\793A\3059\308B\5834\5408\306B\306E\307F\4F7F\7528\3067\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104472517597308811)
,p_name=>'PE.PROPERTY.LOV_SQL.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\90E8\9580\540D\306E\8868\793A\3068\90E8\9580\756A\53F7\306E\8A2D\5B9A</dt>'),
'<dd><pre>',
'select dname  as d,',
'       deptno as r',
'  from dept',
' order by 1',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104223573427308627)
,p_name=>'PE.PROPERTY.LOV_SQL.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306ELOV\306B\79FB\5165\3059\308B\305F\3081\306ESQL\554F\5408\305B\5B9A\7FA9\3092\5165\529B\3057\307E\3059\3002\901A\5E38\3001LOV\554F\5408\305B\306F\6B21\306E\3088\3046\306A\5F62\5F0F\3067\3059\3002</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>\9078\629E\3055\308C\308B\5404\5217\306B\306F\4E00\610F\306E\540D\524D\307E\305F\306F\5225\540D\304C\5FC5\8981\3067\3059\3002SQL\5F0F\3092\542B\3080\5217\306B\306F\5225\540D\3092\4F7F\7528\3059\308B\3053\3068\3092\304A\85A6\3081\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104223409825308627)
,p_name=>'PE.PROPERTY.LOV_SQL.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104223945319308627)
,p_name=>'PE.PROPERTY.LOV_STATIC_VALUES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\9759\7684LOV\306E\5024\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104223868264308627)
,p_name=>'PE.PROPERTY.LOV_STATIC_VALUES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\9759\7684\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104223700305308627)
,p_name=>'PE.PROPERTY.LOV_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('LOV\30BF\30A4\30D7\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104610153458308927)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B\3092\8FD4\3059\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104610271387308927)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\52D5\7684LOV\306F\3001\5165\529B\3057\305F\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\306B\3088\3063\3066\8FD4\3055\308C\308BSQL\554F\5408\305B\306B\57FA\3065\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104095552520308513)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.SHARED.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104095612733308513)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.SHARED.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('LOV\306F\3001\5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8\3067\5B9A\7FA9\3055\308C\305F\3001\4E8B\524D\5B9A\7FA9\306ELOV\306B\57FA\3065\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104095769600308513)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104095897031308513)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\52D5\7684LOV\306F\3001\5165\529B\3057\305FSQL\554F\5408\305B\306B\57FA\3065\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104412349424308766)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.STATIC.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\9759\7684\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104412472309308767)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.STATIC.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9759\7684LOV\306F\3001\5165\529B\3057\305F\30C6\30AD\30B9\30C8\5024\306B\57FA\3065\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104223667957308627)
,p_name=>'PE.PROPERTY.LOV_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103892077519308317)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\306E\4FDD\6301\65B9\6CD5\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103849500975308285)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.N.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30AF\30A8\30B9\30C8\3054\3068(\30E1\30E2\30EA\30FC\306E\307F)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103849670506308285)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.N.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\306B\72B6\614B\3092\4FDD\5B58\3057\306A\3044\3067\304F\3060\3055\3044\3002\72B6\614B\306F\3001\73FE\5728\306E\30EA\30AF\30A8\30B9\30C8\3092\51E6\7406\3059\308B\3068\304D\306B\306E\307F\4F7F\7528\3067\304D\307E\3059\3002AJAX\30EA\30AF\30A8\30B9\30C8\3067\30A2\30A4\30C6\30E0\3092\4F7F\7528\3059\308B\5FC5\8981\304C\3042\308B\5834\5408\306F\3001\300C\9001\4FE1\3059\308B\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\300D\3092\4ECB\3057\3066\30A2\30A4\30C6\30E0\540D\3092\6E21\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104394458368308753)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.U.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\3054\3068(\30C7\30A3\30B9\30AF)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104688956484308991)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.U.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30C3\30B7\30E7\30F3\3092\307E\305F\304C\3063\3066\30A2\30AF\30BB\30B9\3059\308B\305F\3081\306B\3001\30C7\30FC\30BF\30D9\30FC\30B9\306B\5024\3092\683C\7D0D\3059\308B\3053\3068\3067\30E6\30FC\30B6\30FC\306B\5BFE\3057\3066\4FDD\6301\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104394330186308753)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.Y.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30C3\30B7\30E7\30F3\3054\3068(\30C7\30A3\30B9\30AF)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104688888083308991)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.Y.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30AF\30A8\30B9\30C8\3092\307E\305F\304C\3063\3066\30A2\30AF\30BB\30B9\3059\308B\305F\3081\306B\3001\30C7\30FC\30BF\30D9\30FC\30B9\306B\5024\3092\683C\7D0D\3059\308B\3053\3068\3067\5404\30BB\30C3\30B7\30E7\30F3\306B\5BFE\3057\3066\4FDD\6301\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103891916550308317)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\306E\4FDD\6301')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103849813216308285)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\306E\4FDD\6301\65B9\6CD5\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103849969587308285)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.LOV.N.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30AF\30A8\30B9\30C8\3054\3068(\30E1\30E2\30EA\30FC\306E\307F)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103850019974308285)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.LOV.N.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\306B\72B6\614B\3092\4FDD\5B58\3057\306A\3044\3067\304F\3060\3055\3044\3002\72B6\614B\306F\3001\73FE\5728\306E\30EA\30AF\30A8\30B9\30C8\3092\51E6\7406\3059\308B\3068\304D\306B\306E\307F\4F7F\7528\3067\304D\307E\3059\3002AJAX\30EA\30AF\30A8\30B9\30C8\3067\30A2\30A4\30C6\30E0\3092\4F7F\7528\3059\308B\5FC5\8981\304C\3042\308B\5834\5408\306F\3001\300C\9001\4FE1\3059\308B\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\300D\3092\4ECB\3057\3066\30A2\30A4\30C6\30E0\540D\3092\6E21\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103850139642308285)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.LOV.Y.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30C3\30B7\30E7\30F3\3054\3068(\30C7\30A3\30B9\30AF)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103850280446308285)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.LOV.Y.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30AF\30A8\30B9\30C8\3092\307E\305F\304C\3063\3066\30A2\30AF\30BB\30B9\3059\308B\305F\3081\306B\3001\30C7\30FC\30BF\30D9\30FC\30B9\306B\5024\3092\683C\7D0D\3059\308B\3053\3068\3067\5404\30BB\30C3\30B7\30E7\30F3\306B\5BFE\3057\3066\4FDD\6301\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103849769659308285)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\306E\4FDD\6301')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104166843915308581)
,p_name=>'PE.PROPERTY.MAJOR_TICK_RENDERED.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E3B\8981\76EE\76DB\3092\30EC\30F3\30C0\30EA\30F3\30B0\3059\308B\304B\3069\3046\304B\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104166949138308581)
,p_name=>'PE.PROPERTY.MAJOR_TICK_RENDERED.LOV.AUTO.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104167118497308581)
,p_name=>'PE.PROPERTY.MAJOR_TICK_RENDERED.LOV.OFF.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\3044\3044\3048')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104167003816308581)
,p_name=>'PE.PROPERTY.MAJOR_TICK_RENDERED.LOV.ON.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\306F\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104166756666308581)
,p_name=>'PE.PROPERTY.MAJOR_TICK_RENDERED.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104511999332308847)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_FILL_COLOR.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\306AHTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\306E\4F8B\306B\306F\6B21\306E\3082\306E\304C\3042\308A\307E\3059 -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104511829325308847)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_FILL_COLOR.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30DD\30A4\30F3\30C8\30FB\30AF\30E9\30B9\30BF\3092\8868\793A\3059\308B\305F\3081\306E\5857\308A\3064\3076\3057\306E\8272\3092\6307\5B9A\3057\307E\3059\3002'),
unistr('<p>\8272\306F\300116\9032(hex)\8868\8A18\3001RGB\30AB\30E9\30FC\30FB\30B3\30FC\30C9\307E\305F\306FHTML\30AB\30E9\30FC\540D\3092\4F7F\7528\3057\3066\6307\5B9A\3055\308C\307E\3059\300216\9032\8868\8A18\306F#xxyyzz (#\306E\5F8C\306B3\3064\306E2\6841\306E16\9032\6570)\3067\5B9A\7FA9\3055\308C\3001xx\3001yy\304A\3088\3073zz\306F\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E2\6587\5B57\306E16\9032\306E\5024\3092\8868\3057\307E\3059\3002'),
unistr('RGB\30B3\30FC\30C9\306FRGB(xxx,xxx,xxx)\3067\5B9A\7FA9\3055\308C\3001xxx\306F0\304B\3089255\306E\9593\306E\6570\5024\3067\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E8\30D3\30C3\30C8\30FB\30D0\30A4\30C8\5024\3092\8868\3057\307E\3059\3002</p>'),
unistr('<p>\30A4\30F3\30BF\30FC\30CD\30C3\30C8\3067HTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\3092\691C\7D22\3059\308B\3068\3001\4F7F\7528\3059\308B\8272\306E16\9032\30B3\30FC\30C9\307E\305F\306FRGB\30B3\30FC\30C9\304C\308F\304B\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104511723892308847)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_FILL_COLOR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5857\308A\3064\3076\3057\306E\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104511179632308846)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_IMAGE_CSS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DD\30A4\30F3\30C8\30FB\30AF\30E9\30B9\30BF\306E\8868\793A\306B\4F7F\7528\3059\308B\30A2\30A4\30B3\30F3CSS\30AF\30E9\30B9\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104511061867308846)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_IMAGE_CSS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3CSS\30AF\30E9\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104510923021308846)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_IMAGE_PATH.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DD\30A4\30F3\30C8\30FB\30AF\30E9\30B9\30BF\306E\8868\793A\306B\4F7F\7528\3059\308B\30A4\30E1\30FC\30B8\306EURL\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104510886742308846)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_IMAGE_PATH.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104511382892308846)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DD\30A4\30F3\30C8\30FB\30AF\30E9\30B9\30BF\3092\8868\793A\3059\308BSVG\5F62\72B6\3092\6307\5B9A\3057\307E\3059\3002\4E8B\524D\5B9A\7FA9\3055\308C\305F\5F62\72B6\304B\3089\9078\629E\3059\308B\304B\3001<strong>\30AB\30B9\30BF\30E0SVG\30B9\30BF\30A4\30EB</strong>\30FB\30DE\30C3\30D7\30FB\30EA\30FC\30B8\30E7\30F3\5C5E\6027\3067\6307\5B9A\3055\308C\305F<em>\30AB\30B9\30BF\30E0SVG\5F62\72B6</em>\306E\540D\524D\3092\5165\529B\3057\307E\3059\3002\6307\5B9A\3055\308C\305F\540D\524D\304C\30C7\30D5\30A9\30EB\30C8\307E\305F\306F\30AB\30B9\30BF\30E0SVG\30B9\30BF\30A4\30EB\306E\30EA\30B9\30C8\306B\306A\3044\5834\5408\306F\3001<strong>\30C7\30D5\30A9\30EB\30C8\30FB\30DE\30FC\30AB\30FC</strong>\304C\4F7F\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104544898791308871)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CAMERA.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30E1\30E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104552605833308877)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CAMERA.HELP'
,p_message_language=>'ja'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15 4h-1.2l-.9-1.2c-.4-.5-1-.8-1.6-.8H8.8c-.7 0-1.3.3-1.6.8L6.2 4H5c-1.1 0-2 .9-2 2v5c0 1.1.9 2 2 2h2.2l2.4 4.7c.1.2.4.3.7.2.1 0 .2-.'
||'1.2-.2l2.4-4.7H15c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm-5 7c-1.4 0-2.5-1.1-2.5-2.5S8.6 6 10 6s2.5 1.1 2.5 2.5S11.4 11 10 11z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104549405011308874)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CHECK.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30A7\30C3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104553936938308878)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CHECK.HELP'
,p_message_language=>'ja'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zm2.9 4.9l-3 3c-.2.1-.6.1-.8 0L7.6 8.4c-'
||'.2-.2-.2-.5 0-.7s.5-.2.7 0l1.1 1.1L12 6.2c.2-.2.5-.2.7 0s.3.5.2.7z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104544928148308871)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE ALTERNATIVE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5186\306E\4EE3\66FF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104552847654308877)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE ALTERNATIVE.HELP'
,p_message_language=>'ja'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8v9.5c0 .2.1.4.3.5h.2c.1 0 .3-.1.4-.2l3.7-4c3.2.8 6.5-1.2 7.3-4.4.8-3.2-1.2-6.5-4.4-7.3-.5 0-1-.1-1.5-.1zm0 8c-1.'
||'1 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104511521422308846)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5186')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104552777105308877)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE.HELP'
,p_message_language=>'ja'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 2.5 1.6 4.7 3.9 5.6l1.6 4.1c.1.3.4.4.7.3l.3-.3 1.6-4.1c3.1-1.2 4.7-4.6 3.5-7.7C14.7 3.6 12.5 2 10 2zm0 8c-1.1'
||' 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104544715495308871)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.DEFAULT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104552599909308876)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.DEFAULT.HELP'
,p_message_language=>'ja'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 4.6 5.4 9.7 5.7 9.9.2.2.5.2.7 0 .2-.2 5.6-5.3 5.6-9.9 0-3.3-2.7-6-6-6zm0 7.9c-1.1 0-2-.9-2-2s.9-2 2-2 2 .9 2 '
||'2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104545044398308871)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE FROWN.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0D\6A5F\5ACC\306A\9854')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104552950496308877)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE FROWN.HELP'
,p_message_language=>'ja'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm5 3.8c-.2.1-.4.1-.5-.1-.7-.9-2-1.1-3-.4-.2.1-.3.3-.4.4-.1.2-.4.2-.5.1-.2-.1-.2-.4-.1-.5 1-1.3 2.8-1.5 4-.6l.6.6c.1.1.1.4-.1.5zm-.2-3c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104545177833308871)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE MEH.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\95A2\5FC3\306A\9854')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104553085327308877)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE MEH.HELP'
,p_message_language=>'ja'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm4.3 3.9h-3c-.2 0-.4-.2-.4-.4s.2-.4.4-.4h3c.2 0 .4.2.4.4s-.2.4-.4.4zm.5-3.1c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104545280454308871)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE SMILE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\7B11\3063\305F\9854')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104553155840308877)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE SMILE.HELP'
,p_message_language=>'ja'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm5.1 2.7c-1 1.3-2.8 1.5-4 .6l-.6-.6c-.1-.1-.1-.4.1-.5.2-.1.4-.1.5.1.7.9 2 1.1 3 .4.2-.1.3-.3.4-.4.1-.2.4-.2.5-.1s.2.4.1.5zM12 7.8c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104549938799308875)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FLAG PENNANT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30E9\30C3\30B0\30FB\30DA\30CA\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104554406404308878)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FLAG PENNANT.HELP'
,p_message_language=>'ja'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M16.7 6.5L3.7 2c-.3-.1-.6.1-.7.3v15.2c0 .3.2.5.5.5s.5-.2.5-.5v-5.6l12.7-4.4c.3-.1.4-.4.3-.6-.1-.2-.2-.3-.3-.4z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104550035704308875)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FLAG SWALLOWTAIL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30E9\30C3\30B0\30FB\30B9\30EF\30ED\30FC\30C6\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104554598964308878)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FLAG SWALLOWTAIL.HELP'
,p_message_language=>'ja'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M13.2 7l3.7-4.2c.2-.2.2-.5 0-.7-.2-.1-.3-.1-.4-.1h-13c-.3 0-.5.2-.5.5v15c0 .3.2.5.5.5s.5-.2.5-.5V12h12.5c.3 0 .5-.2.5-.5 0-.1 0-.2-.1'
||'-.3L13.2 7z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104545638511308872)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.HEART.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CF\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104553687941308877)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.HEART.HELP'
,p_message_language=>'ja'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M16 5c0-.8-.3-1.6-.9-2.1-1.2-1.2-3.1-1.2-4.3 0l-.8.8-.8-.8C8 1.7 6.1 1.7 4.9 2.9c-1.2 1.1-1.2 3 0 4.2l4.6 4.6v5.8c0 .3.2.5.5.5s.5-.2.'
||'5-.5v-5.8l4.6-4.6c.6-.5.9-1.3.9-2.1z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104549527630308874)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.HOME.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DB\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104554086088308878)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.HOME.HELP'
,p_message_language=>'ja'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M17.8 7.6l-7.5-5.5c-.2-.1-.4-.1-.6 0L2.2 7.5c-.2.2-.3.5-.1.7.2.2.5.3.7.1L4 7.5v6c0 .3.2.5.5.5h3.2l1.9 3.7c.1.2.4.3.7.2.1 0 .2-.1.2-.2'
||'l1.9-3.7h3.2c.3 0 .5-.2.5-.5v-6l1.2.9c.2.2.5.1.7-.1.1-.3 0-.6-.2-.7z"/><path d="M8.5 8.5v2c0 .3.2.5.5.5h2c.3 0 .5-.2.5-.5v-2c0-.3-.2-.5-.5-.5H9c-.3 0-.5.2-.5.5z" fill="#fff"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104545750717308872)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PENTAGON.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E94\89D2\5F62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104553779211308877)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PENTAGON.HELP'
,p_message_language=>'ja'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15 5.5l-4.7-3.4c-.2-.1-.4-.1-.6 0L5 5.5c-.2.2-.3.4-.2.6l1.8 5.6c.1.2.3.3.5.3h2.4v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12h2.4c.2 0 .4-.1.5-.3l'
||'1.8-5.6c.1-.2 0-.4-.2-.6z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104545464509308871)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PIN CIRCLE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5186\306E\30D4\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104553408090308877)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PIN CIRCLE.HELP'
,p_message_language=>'ja'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C7.2 2 5 4.2 5 7c0 2.6 1.9 4.7 4.5 5v5.6c0 .3.2.5.5.5s.5-.2.5-.5V12c2.7-.3 4.7-2.7 4.5-5.4-.3-2.7-2.4-4.6-5-4.6z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104545512544308871)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PIN SQUARE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\56DB\89D2\5F62\306E\30D4\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104553588986308877)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PIN SQUARE.HELP'
,p_message_language=>'ja'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M13 2H7c-1.1 0-2 .9-2 2v6c0 1.1.9 2 2 2h2.5v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12H13c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104549712178308874)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SHINE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\8F1D\304D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104554283299308878)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SHINE.HELP'
,p_message_language=>'ja'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 7c-2.2 0-4 1.8-4 4 0 2.3 3.2 6.4 3.6 6.8.2.2.5.2.7.1l.1-.1c.4-.5 3.6-4.5 3.6-6.8 0-2.2-1.8-4-4-4zm0 5c-.6 0-1-.4-1-1s.4-1 1-1 1 .'
||'4 1 1-.4 1-1 1zM3.6 4.9c-.2-.1-.5-.1-.7.1-.2.3-.1.6.1.7l1.9 1.4c0 .1.1.1.3.1.3 0 .5-.2.5-.5 0-.2-.1-.3-.2-.4L3.6 4.9zm4 .1c.1.2.3.3.5.3h.2c.3-.1.4-.4.3-.6l-.9-2.4c0-.2-.3-.4-.6-.3-.3.1-.4.4-.3.6L7.6 5zm9.5 0c-.2-.2-.5-.3-.7-.1l-1.9 1.4c-.2.2-.3.5-.1.'
||'7.1.1.2.2.4.2.1 0 .2 0 .3-.1L17 5.7c.2-.1.3-.4.1-.7zm-5.3.3h.2c.2 0 .4-.1.5-.3l.8-2.3c.1-.3 0-.5-.3-.6-.3-.1-.5 0-.6.3l-.8 2.3c-.2.2-.1.5.2.6z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104549650122308874)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SLASH.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30E9\30C3\30B7\30E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104554169029308878)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SLASH.HELP'
,p_message_language=>'ja'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M17.9 2.1c-.2-.2-.5-.2-.7 0l-2.3 2.3C13 1.7 9.2 1.1 6.5 3.1 4.9 4.3 4 6.1 4 8c.1 1.9.8 3.8 1.9 5.4l-3.8 3.8c-.2.2-.2.5 0 .7s.5.2.7 0l'
||'15-15c.2-.2.2-.6.1-.8zM9.5 9.8c-1.1-.3-1.7-1.4-1.4-2.4S9.5 5.7 10.5 6c.7.2 1.2.7 1.4 1.4L9.5 9.8zM7.1 15c.8 1 1.6 2 2.6 2.8.2.2.5.2.7 0 .2-.1 5.6-5.2 5.6-9.8 0-.6-.1-1.1-.2-1.6L7.1 15z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104545329360308871)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE ALTERNATIVE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\56DB\89D2\5F62\306E\4EE3\66FF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104553347355308877)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE ALTERNATIVE.HELP'
,p_message_language=>'ja'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14 2H6c-1.1 0-2 .9-2 2v13.5c0 .2.1.4.3.5h.2c.1 0 .3-.1.4-.2L8.4 14H14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-4 8c-1.1 0-2-.9-2-2s.9-2 2-2'
||' 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104511442440308846)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\56DB\89D2\5F62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104553253147308877)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE.HELP'
,p_message_language=>'ja'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14 2H6c-1.1 0-2 .9-2 2v8c0 1.1.9 2 2 2h2.1l1.5 3.7c.1.3.4.4.7.3l.3-.3 1.5-3.7H14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-4 8c-1.1 0-2-.9-2'
||'-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104549868906308875)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.STREET VIEW.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30C8\30EA\30FC\30C8\30FB\30D3\30E5\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104554338955308878)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.STREET VIEW.HELP'
,p_message_language=>'ja'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14.7 11.6c-.3-.1-.5.1-.6.3s.1.5.3.6c1.6.5 2.6 1.2 2.6 1.9 0 1.2-2.9 2.5-7 2.5s-7-1.3-7-2.5c0-.7 1-1.4 2.6-1.9.3 0 .4-.3.3-.5-.1-.3-.'
||'4-.4-.6-.3-2.1.6-3.3 1.6-3.3 2.8 0 2 3.4 3.5 8 3.5s8-1.5 8-3.5c0-1.2-1.2-2.2-3.3-2.9z"/><path d="M7.7 10.9c.2.2.3.5.3.7V14c0 .6.4 1 1 1h2c.6 0 1-.4 1-1v-2.4c0-.3.1-.5.3-.7l.1-.1c.4-.4.6-.9.6-1.4V7.8c0-.7-.3-1.3-.9-1.6-1.2 1.2-3.1 1.2-4.2 0-.6.3-.9.9-'
||'.9 1.6v1.6c0 .5.2 1 .6 1.4l.1.1z"/><circle cx="10" cy="4" r="2"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104511699991308847)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.TRIANGLE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E09\89D2\5F62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104553859598308877)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.TRIANGLE.HELP'
,p_message_language=>'ja'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15.9 11.2l-5.5-9c-.1-.2-.5-.3-.7-.1-.1 0-.1.1-.1.1l-5.5 9c-.1.2-.1.5.2.7 0 .1.1.1.2.1h5v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12h5c.3 0 .5-.2.'
||'5-.5 0-.1 0-.2-.1-.3z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104511261324308846)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5F62\72B6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104545905062308872)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE_SCALE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DD\30A4\30F3\30C8\30FB\30AF\30E9\30B9\30BF\3092\8868\793A\3059\308BSVG\5F62\72B6\306E\500D\7387\3092\6307\5B9A\3057\307E\3059\3002\6700\5927\30B9\30B1\30FC\30EB\306F<strong>10</strong>\3067\3001\30DE\30C3\30D7\30FB\30B3\30F3\30DD\30FC\30CD\30F3\30C8\3067\306F\3001\5024\304C\5C0F\6570\70B9\4EE5\4E0B1\6841\306B\4E38\3081\3089\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104545891662308872)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE_SCALE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30A7\30A4\30D7\30FB\30B9\30B1\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104515174264308849)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_THRESHOLD.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30AF\30E9\30B9\30BF\534A\5F84(\30D4\30AF\30BB\30EB)\3002\5024<strong>80</strong>\3092\6307\5B9A\3059\308B\3068\3001\4E92\3044\306E80\30D4\30AF\30BB\30EB\4EE5\5185\306E\30DD\30A4\30F3\30C8\306F'),
unistr('\30DD\30A4\30F3\30C8\30FB\30AF\30E9\30B9\30BF\306B\96C6\7D04\3055\308C\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104515006011308849)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_THRESHOLD.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30E9\30B9\30BF\30EA\30F3\30B0\534A\5F84')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104515283967308849)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_THRESHOLD.UNIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D4\30AF\30BB\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104535999480308864)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_TOOLTIP.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30C3\30D7\4E0A\306E\30AF\30E9\30B9\30BF\30FB\30DE\30FC\30AB\30FC\306B\30AB\30FC\30BD\30EB\3092\5408\305B\308B\3068\30C4\30FC\30EB\30C1\30C3\30D7\3068\3057\3066\8868\793A\3055\308C\308BHTML\5F0F\3092\5165\529B\3057\307E\3059\3002<strong>&LAYER.</strong>\304A\3088\3073<strong>&COUNT.</strong>\30D7\30EC\30FC\30B9\30DB\30EB\30C0\3092\4F7F\7528\3057\3066\3001\30AF\30E9\30B9\30BF\5185\306E\30EC\30A4\30E4\30FC\540D\304A\3088\3073\30DE\30C3\30D7\30FB\30AA\30D6\30B8\30A7\30AF\30C8\306E\91CF\3092\53C2\7167\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104535864306308864)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_TOOLTIP.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C4\30FC\30EB\30C1\30C3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104501416569308839)
,p_name=>'PE.PROPERTY.MAP_COPYRIGHT_NOTICE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30C3\30D7\306E\30D5\30C3\30BF\30FC\306B\914D\7F6E\3059\308B\30B3\30D4\30FC\30E9\30A4\30C8\3092\6307\5B9A\3057\307E\3059\3002\7A7A\306E\5834\5408\3001\4F7F\7528\3055\308C\305F\80CC\666F\30DE\30C3\30D7\306E\30B3\30D4\30FC\30E9\30A4\30C8\304C\751F\6210\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104501353988308839)
,p_name=>'PE.PROPERTY.MAP_COPYRIGHT_NOTICE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30D4\30FC\30E9\30A4\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104503184191308840)
,p_name=>'PE.PROPERTY.MAP_CUSTOM_STYLES.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'[',
'    {',
'        "name": "MyCamera",',
'        "width": 20,',
'        "height": 20,',
'        "paint-order": "stroke",',
'        "viewBox": "0 0 20 20",',
'        "elements": [',
'            {',
'                "type": "path",',
'                "d": "M15 4h-1.2l-.9-1.2c-.4-.5-1-.8-1.6-.8H8.8c-.7 0-1.3.3-1.6.8L6.2 4H5c-1.1 0-2 .9-2 2v5c0 1.1.9 2 2 2h2.2l2.4 4.7c.1.2.4.3.7.2.1 0 .2-.1.2-.2l2.4-4.7H15c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm-5 7c-1.4 0-2.5-1.1-2.5-2.5S8.6 6 10 6s2.5 1'
||'.1 2.5 2.5S11.4 11 10 11z"',
'            }',
'        ]',
'    },',
'    {',
'        "name": "MyCompany",',
'        "width": 20,',
'        "height": 20,',
'        :',
'    }',
']</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104503031504308840)
,p_name=>'PE.PROPERTY.MAP_CUSTOM_STYLES.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30DE\30C3\30D7\30FB\30DE\30FC\30AB\30FC\3068\3057\3066\4F7F\7528\3067\304D\308B\30AB\30B9\30BF\30E0SVG\5F62\72B6\306E\5B9A\7FA9\3092\6307\5B9A\3057\307E\3059\3002\3053\3053\3067\5B9A\7FA9\3055\308C\305F\30B9\30BF\30A4\30EB\306F\3001\30DD\30A4\30F3\30C8\30FB\30EC\30A4\30E4\30FC\5185\306E<strong>\300CSVG\5F62\72B6\300D</strong>\5C5E\6027\3068\3057\3066\4F7F\7528\3067\304D\307E\3059\3002</p>'),
unistr('<p>SVG\5F62\72B6\306F\3001\5E45\3068\9AD8\3055\304C<strong>20</strong>\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\5F62\72B6\306E\4E0B\90E8\306E\4E2D\592E(SVG\5EA7\6A19<strong>10</strong>\3001<strong>20</strong>)\304C\30DE\30C3\30D7\30FB\30AA\30D6\30B8\30A7\30AF\30C8\3092\6307\3059\3088\3046\306B\3001\30DE\30FC\30AB\30FC\304C\30DE\30C3\30D7\4E0A\306B\914D\7F6E\3055\308C\307E\3059\3002</p>'),
'<svg aria-labelledby="prop1526_SvgTitle" role="img" xmlns="http://www.w3.org/2000/svg" width="100px" height="100px" paint-order="stroke" viewBox="-5 -5 30 40">',
unistr('<title id="prop1526_SvgTitle">SVG\30DE\30FC\30AB\30FC\306E\5E45\3068\9AD8\3055\306F20\3067\3001\4F4D\7F6Ex=10\304A\3088\3073y=20\306E\30DE\30C3\30D7\306E\5834\6240\3092\6307\3057\307E\3059\3002</title>'),
'<path d="M10 2C6.7 2 4 4.7 4 8c0 4.6 5.4 9.7 5.7 9.9.2.2.5.2.7 0 .2-.2 5.6-5.3 5.6-9.9 0-3.3-2.7-6-6-6zm0 7.9c-1.1 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/>',
'<rect x="0" y="0" width="20" height="20" style="stroke-dasharray:1 1;fill:none;stroke-width:0.5;stroke:black;"/>',
'<line x1="7" y1="17" x2="13" y2="23" style="stroke:red; stroke-width: 0.75;"/>',
'<line x1="13" y1="17" x2="7" y2="23" style="stroke:red; stroke-width: 0.75;"/>',
'<text x="10" y="30" text-anchor="middle" style="font: 6px Sans-Serif; fill: red;">[10 20]</text>',
'</svg>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104502945152308840)
,p_name=>'PE.PROPERTY.MAP_CUSTOM_STYLES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30B9\30BF\30E0SVG\30B9\30BF\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104533673897308863)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\62BC\51FA\3057\30DD\30EA\30B4\30F3\306E\9AD8\3055\3092\6C7A\5B9A\3059\308B\5024\3092\8FD4\3059\5217\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104533565590308863)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\62BC\51FA\3057\5024\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104535304046308864)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\62BC\51FA\3057\30DD\30EA\30B4\30F3\306E\9AD8\3055\3092\6C7A\5B9A\3059\308B\5358\4F4D\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104535630896308864)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.LOV.FOOT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104535549160308864)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.LOV.KM.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AD\30ED\30E1\30FC\30C8\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104535470726308864)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.LOV.M.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E1\30FC\30C8\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104535715317308864)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.LOV.MILE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104535299637308864)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5358\4F4D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104507870246308844)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\306AHTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\306E\4F8B\306B\306F\6B21\306E\3082\306E\304C\3042\308A\307E\3059 -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104507760061308844)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5857\308A\3064\3076\3057\306E\8272\3092\6307\5B9A\3057\307E\3059\3002'),
unistr('<p>\8272\306F\300116\9032(hex)\8868\8A18\3001RGB\30AB\30E9\30FC\30FB\30B3\30FC\30C9\307E\305F\306FHTML\30AB\30E9\30FC\540D\3092\4F7F\7528\3057\3066\6307\5B9A\3055\308C\307E\3059\300216\9032\8868\8A18\306F#xxyyzz (#\306E\5F8C\306B3\3064\306E2\6841\306E16\9032\6570)\3067\5B9A\7FA9\3055\308C\3001xx\3001yy\304A\3088\3073zz\306F\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E2\6587\5B57\306E16\9032\306E\5024\3092\8868\3057\307E\3059\3002'),
unistr('RGB\30B3\30FC\30C9\306FRGB(xxx,xxx,xxx)\3067\5B9A\7FA9\3055\308C\3001xxx\306F0\304B\3089255\306E\9593\306E\6570\5024\3067\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E8\30D3\30C3\30C8\30FB\30D0\30A4\30C8\5024\3092\8868\3057\307E\3059\3002</p>'),
unistr('<p>\30A4\30F3\30BF\30FC\30CD\30C3\30C8\3067HTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\3092\691C\7D22\3059\308B\3068\3001\4F7F\7528\3059\308B\8272\306E16\9032\30B3\30FC\30C9\307E\305F\306FRGB\30B3\30FC\30C9\304C\308F\304B\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104507647143308844)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5857\308A\3064\3076\3057\306E\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104516624552308850)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_IS_SPECTRUM.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30EC\30A4\30E4\30FC\306E<em>\30AB\30E9\30FC\30FB\30B9\30AD\30FC\30E0</em>\3092\4F7F\7528\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002\30AB\30E9\30FC\30FB\30B9\30AD\30FC\30E0\306F\8272\306E\30EA\30B9\30C8\3067\3059\3002\5024\304A\3088\3073\6700\5C0F\5024\3068\6700\5927\5024\306B\57FA\3065\3044\3066\3001\30DE\30C3\30D7\30FB\30A6\30A3\30B8\30A7\30C3\30C8\306F\30EA\30B9\30C8\304B\3089\3053\306E\30AA\30D6\30B8\30A7\30AF\30C8\306E\5B9F\969B\306E\8868\793A\8272\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104516549734308850)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_IS_SPECTRUM.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30E9\30FC\30FB\30B9\30AD\30FC\30E0\306E\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104669416920308975)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_SPECTRUM.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<dl><dt>\8D64\304B\3089\767D\307E\3067\306E\7BC4\56F2\306E\30AB\30E9\30FC\30FB\30EA\30B9\30C8</dt>'),
unistr('    <dd><pre>#ff0000,#ff2020,#ff4040,#ff6060,#ff8080,#ffa0a0,#ffc0c0,#ffffff</pre></dd><dt>\9752\304B\3089\9ED2\307E\3067\306E\7BC4\56F2\306E\30AB\30E9\30FC\30FB\30EA\30B9\30C8</dt>'),
'    <dd><pre>#0000ff,#0000c0,#0000a0,#000080,#000060,#000040,#000020,#000000</pre></dd></dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104516805200308850)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_SPECTRUM.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30EC\30A4\30E4\30FC\306E\30AB\30B9\30BF\30E0\30FB<em>\30AB\30E9\30FC\30FB\30B9\30AD\30FC\30E0</em>\3092\6307\5B9A\3057\307E\3059\3002\30AB\30E9\30FC\30FB\30B9\30AD\30FC\30E0\306F\8272\306E\30EA\30B9\30C8\3067\3059\3002\5024\304A\3088\3073\6700\5C0F\5024\3068\6700\5927\5024\306B\57FA\3065\3044\3066\3001\30DE\30C3\30D7\30FB\30A6\30A3\30B8\30A7\30C3\30C8\306F\30EA\30B9\30C8\304B\3089\3053\306E\30AA\30D6\30B8\30A7\30AF\30C8\306E\5B9F\969B\306E\8868\793A\8272\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104516717667308850)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_SPECTRUM.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30B9\30BF\30E0\30FB\30AB\30E9\30FC\30FB\30EA\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104517089494308851)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_VALUE_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AD\30FC\30E0\304B\3089\8868\793A\8272\3092\6C7A\5B9A\3059\308B\306B\306F\3001\5024\3092\8FD4\3059\5217\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104516916106308850)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_VALUE_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30E9\30FC\5024\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104508078708308844)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_OPACITY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5857\308A\3064\3076\3057\306E\4E0D\900F\660E\5EA6\3092\6307\5B9A\3057\307E\3059\3002\7BC4\56F2\306F\30BC\30ED(\5B8C\5168\306B\900F\660E)\304B\30891.0 (\4E0D\900F\660E)\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104507940909308844)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_OPACITY.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5857\308A\3064\3076\3057\306E\4E0D\900F\660E\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104517214547308851)
,p_name=>'PE.PROPERTY.MAP_FEATURE_HEATMAP_VALUE_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AD\30FC\30E0\304B\3089\8868\793A\8272\3092\6C7A\5B9A\3059\308B\306B\306F\3001\5024\3092\8FD4\3059\5217\3092\9078\629E\3057\307E\3059\3002\5217\304C\9078\629E\3055\308C\3066\3044\306A\3044\5834\5408\3001\8868\793A\8272\306F\30DD\30A4\30F3\30C8\5BC6\5EA6\306E\307F\304B\3089\6C7A\5B9A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104517169924308851)
,p_name=>'PE.PROPERTY.MAP_FEATURE_HEATMAP_VALUE_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104513046005308848)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_ADV_FORMATTING.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\60C5\5831\30A6\30A3\30F3\30C9\30A6\3092\3001\5217\3001\307E\305F\306FHTML\5F0F\304A\3088\3073\30B5\30DD\30FC\30C8\3055\308C\3066\3044\308B\7F6E\63DB\6587\5B57\5217\3092\4F7F\7528\3059\308B\62E1\5F35\30D5\30A9\30FC\30DE\30C3\30C8\306E\3044\305A\308C\3092\4F7F\7528\3057\3066\8868\793A\3059\308B\304B\3092\6307\5B9A\3057\307E\3059\3002\60C5\5831\30A6\30A3\30F3\30C9\30A6\306F\3001\30DE\30C3\30D7\4E0A\306E\30AA\30D6\30B8\30A7\30AF\30C8\3092\30AF\30EA\30C3\30AF\3059\308B\3068\30DD\30C3\30D7\30A2\30C3\30D7\3068\3057\3066\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104512910256308848)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_ADV_FORMATTING.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\62E1\5F35\30D5\30A9\30FC\30DE\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104513485593308848)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_BODY_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\60C5\5831\30A6\30A3\30F3\30C9\30A6\306E\672C\6587\3068\3057\3066\4F7F\7528\3059\308B\5217\3092\9078\629E\3057\307E\3059\3002\30DE\30C3\30D7\4E0A\306E\30AA\30D6\30B8\30A7\30AF\30C8\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\60C5\5831\30A6\30A3\30F3\30C9\30A6\304C\30DD\30C3\30D7\30A2\30C3\30D7\3068\3057\3066\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104513336576308848)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_BODY_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\672C\4F53\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104513980371308848)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_CSS_CLASSES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\60C5\5831\30A6\30A3\30F3\30C9\30A6\306E\30DD\30C3\30D7\30A2\30C3\30D7\3092\30EC\30F3\30C0\30EA\30F3\30B0\3059\308B\3068\304D\306B\4F7F\7528\3059\308BCSS\30AF\30E9\30B9\3092\5165\529B\3057\307E\3059\3002\8907\6570\306E\30AF\30E9\30B9\306F\7A7A\767D\3067\533A\5207\3063\3066\8FFD\52A0\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104513811483308848)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_CSS_CLASSES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('CSS\30AF\30E9\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104513724631308848)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_HTML_EXPR.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>\30D0\30C3\30AF\30B0\30E9\30A6\30F3\30C9\304A\3088\3073\30C6\30AD\30B9\30C8\306E\8272\306E\5909\66F4</dt>'),
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>\30D8\30C3\30C0\30FC2\306E\4F7F\7528</dt>'),
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>SQL\554F\5408\305B\304B\3089\306E\52D5\7684\30AF\30E9\30B9\306E\4F7F\7528</dt>'),
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    \3053\306E\4F8B\3067<code>&COLUMN_CLASS.</code>\3068<code>&EMPLOYEE_STATUS.</code>\306B\4EE3\5165\3055\308C\308B\306E\306F\3001\30EC\30DD\30FC\30C8SQL\554F\5408\305B\3067\9078\629E\3055\308C\305F\5217\3067\3059\3002</dd>'),
unistr('  <dt>\30DB\30D0\30FC\3067\306E\30A4\30E1\30FC\30B8\304A\3088\3073\30C4\30FC\30EB\30C1\30C3\30D7\306E\8868\793A</dt>'),
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104513607100308848)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_HTML_EXPR.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\7A7A\9593\30AA\30D6\30B8\30A7\30AF\30C8\3092\30AF\30EA\30C3\30AF\3059\308B\3068\60C5\5831\30DD\30C3\30D7\30A2\30C3\30D7\3068\3057\3066\8868\793A\3055\308C\308BHTML\5F0F\3092\5165\529B\3057\307E\3059\3002<code>&COLUMN.</code>\69CB\6587\3092\4F7F\7528\3057\3066\3001HTML\306B\5217\5024\3092\8868\793A\3057\307E\3059\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104513563775308848)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_HTML_EXPR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('HTML\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104513265106308848)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_TITLE_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\60C5\5831\30A6\30A3\30F3\30C9\30A6\306E\30BF\30A4\30C8\30EB\3068\3057\3066\4F7F\7528\3059\308B\5217\3092\9078\629E\3057\307E\3059\3002\30DE\30C3\30D7\4E0A\306E\30AA\30D6\30B8\30A7\30AF\30C8\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\60C5\5831\30A6\30A3\30F3\30C9\30A6\304C\30DD\30C3\30D7\30A2\30C3\30D7\3068\3057\3066\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104513150087308848)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_TITLE_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30C8\30EB\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104536832485308865)
,p_name=>'PE.PROPERTY.MAP_FEATURE_LABEL.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\51E1\4F8B\307E\305F\306F\30C4\30FC\30EB\30C1\30C3\30D7\306B\8868\793A\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\30E9\30D9\30EB\3002\6307\5B9A\3057\306A\3044\5834\5408\3001<strong>\300C\540D\524D\300D</strong>\5C5E\6027\304C\4F7F\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104536619404308865)
,p_name=>'PE.PROPERTY.MAP_FEATURE_LABEL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\51E1\4F8B\304A\3088\3073\30C4\30FC\30EB\30C1\30C3\30D7\5185\3067\3053\306E\30EC\30A4\30E4\30FC\306B\4F7F\7528\3059\308B\30E9\30D9\30EB\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104536505914308865)
,p_name=>'PE.PROPERTY.MAP_FEATURE_LABEL.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104536495842308865)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_FILL_COLOR.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\306AHTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\306E\4F8B\306B\306F\6B21\306E\3082\306E\304C\3042\308A\307E\3059 -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104536339565308865)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_FILL_COLOR.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30DE\30FC\30AB\30FC\5857\308A\3064\3076\3057\306E\8272\3092\6307\5B9A\3057\307E\3059\3002'),
unistr('<p>\8272\306F\300116\9032(hex)\8868\8A18\3001RGB\30AB\30E9\30FC\30FB\30B3\30FC\30C9\307E\305F\306FHTML\30AB\30E9\30FC\540D\3092\4F7F\7528\3057\3066\6307\5B9A\3055\308C\307E\3059\300216\9032\8868\8A18\306F#xxyyzz (#\306E\5F8C\306B3\3064\306E2\6841\306E16\9032\6570)\3067\5B9A\7FA9\3055\308C\3001xx\3001yy\304A\3088\3073zz\306F\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E2\6587\5B57\306E16\9032\306E\5024\3092\8868\3057\307E\3059\3002'),
unistr('RGB\30B3\30FC\30C9\306FRGB(xxx,xxx,xxx)\3067\5B9A\7FA9\3055\308C\3001xxx\306F0\304B\3089255\306E\9593\306E\6570\5024\3067\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E8\30D3\30C3\30C8\30FB\30D0\30A4\30C8\5024\3092\8868\3057\307E\3059\3002</p>'),
unistr('<p>\30A4\30F3\30BF\30FC\30CD\30C3\30C8\3067HTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\3092\691C\7D22\3059\308B\3068\3001\4F7F\7528\3059\308B\8272\306E16\9032\30B3\30FC\30C9\307E\305F\306FRGB\30B3\30FC\30C9\304C\308F\304B\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104536251384308865)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_FILL_COLOR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5857\308A\3064\3076\3057\306E\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104536196407308865)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_FILL_OPACITY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5857\308A\3064\3076\3057\306E\4E0D\900F\660E\5EA6\3092\6307\5B9A\3057\307E\3059\3002\7BC4\56F2\306F\30BC\30ED(\5B8C\5168\306B\900F\660E)\304B\30891.0 (\4E0D\900F\660E)\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104536056845308864)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_FILL_OPACITY.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5857\308A\3064\3076\3057\306E\4E0D\900F\660E\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104533985878308863)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_STROKE_COLOR.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\306AHTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\306E\4F8B\306B\306F\6B21\306E\3082\306E\304C\3042\308A\307E\3059 -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104533805117308863)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_STROKE_COLOR.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30B9\30C8\30ED\30FC\30AF\306E\8272\3092\6307\5B9A\3057\307E\3059\3002'),
unistr('<p>\8272\306F\300116\9032(hex)\8868\8A18\3001RGB\30AB\30E9\30FC\30FB\30B3\30FC\30C9\307E\305F\306FHTML\30AB\30E9\30FC\540D\3092\4F7F\7528\3057\3066\6307\5B9A\3055\308C\307E\3059\300216\9032\8868\8A18\306F#xxyyzz (#\306E\5F8C\306B3\3064\306E2\6841\306E16\9032\6570)\3067\5B9A\7FA9\3055\308C\3001xx\3001yy\304A\3088\3073zz\306F\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E2\6587\5B57\306E16\9032\306E\5024\3092\8868\3057\307E\3059\3002'),
unistr('RGB\30B3\30FC\30C9\306FRGB(xxx,xxx,xxx)\3067\5B9A\7FA9\3055\308C\3001xxx\306F0\304B\3089255\306E\9593\306E\6570\5024\3067\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E8\30D3\30C3\30C8\30FB\30D0\30A4\30C8\5024\3092\8868\3057\307E\3059\3002</p>'),
unistr('<p>\30A4\30F3\30BF\30FC\30CD\30C3\30C8\3067HTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\3092\691C\7D22\3059\308B\3068\3001\4F7F\7528\3059\308B\8272\306E16\9032\30B3\30FC\30C9\307E\305F\306FRGB\30B3\30FC\30C9\304C\308F\304B\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104533753845308863)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_STROKE_COLOR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30C8\30ED\30FC\30AF\306E\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104534125981308863)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_STROKE_WIDTH.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30C8\30ED\30FC\30AF\306E\5E45\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104534004938308863)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_STROKE_WIDTH.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30C8\30ED\30FC\30AF\306E\5E45')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104514142142308848)
,p_name=>'PE.PROPERTY.MAP_FEATURE_ROW_ASSIGN_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\30FB\30BD\30FC\30B9\304B\3089\3053\306E\30EC\30A4\30E4\30FC\306B\884C\3092\5272\308A\5F53\3066\308B\305F\3081\306B\4F7F\7528\3059\308B\5217\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104514032751308848)
,p_name=>'PE.PROPERTY.MAP_FEATURE_ROW_ASSIGN_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104514333922308849)
,p_name=>'PE.PROPERTY.MAP_FEATURE_ROW_ASSIGN_VALUE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\30FB\30BD\30FC\30B9\304B\3089\3053\306E\30EC\30A4\30E4\30FC\306B\884C\3092\5272\308A\5F53\3066\308B<strong>\884C\5272\5F53\3066\5217</strong>\306E<em>\5024</em>\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104514253414308848)
,p_name=>'PE.PROPERTY.MAP_FEATURE_ROW_ASSIGN_VALUE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30EC\30A4\30E4\30FC\306E\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104507349324308843)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_COLOR.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\306AHTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\306E\4F8B\306B\306F\6B21\306E\3082\306E\304C\3042\308A\307E\3059 -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104507237291308843)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_COLOR.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30B9\30C8\30ED\30FC\30AF\306E\8272\3092\6307\5B9A\3057\307E\3059\3002'),
unistr('<p>\8272\306F\300116\9032(hex)\8868\8A18\3001RGB\30AB\30E9\30FC\30FB\30B3\30FC\30C9\307E\305F\306FHTML\30AB\30E9\30FC\540D\3092\4F7F\7528\3057\3066\6307\5B9A\3055\308C\307E\3059\300216\9032\8868\8A18\306F#xxyyzz (#\306E\5F8C\306B3\3064\306E2\6841\306E16\9032\6570)\3067\5B9A\7FA9\3055\308C\3001xx\3001yy\304A\3088\3073zz\306F\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E2\6587\5B57\306E16\9032\306E\5024\3092\8868\3057\307E\3059\3002'),
unistr('RGB\30B3\30FC\30C9\306FRGB(xxx,xxx,xxx)\3067\5B9A\7FA9\3055\308C\3001xxx\306F0\304B\3089255\306E\9593\306E\6570\5024\3067\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E8\30D3\30C3\30C8\30FB\30D0\30A4\30C8\5024\3092\8868\3057\307E\3059\3002</p>'),
unistr('<p>\30A4\30F3\30BF\30FC\30CD\30C3\30C8\3067HTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\3092\691C\7D22\3059\308B\3068\3001\4F7F\7528\3059\308B\8272\306E16\9032\30B3\30FC\30C9\307E\305F\306FRGB\30B3\30FC\30C9\304C\308F\304B\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104507139776308843)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_COLOR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30C8\30ED\30FC\30AF\306E\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104514503237308849)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30C8\30ED\30FC\30AF\30FB\30B9\30BF\30A4\30EB\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104514886243308849)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.LOV.DASHED.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\7834\7DDA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104514771927308849)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.LOV.DOTTED.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\70B9\7DDA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104514995270308849)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.LOV.DOT_DASHED.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\9396\7DDA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104514642696308849)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.LOV.SOLID.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\7ACB\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104514494587308849)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30C8\30ED\30FC\30AF\30FB\30B9\30BF\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104507525924308844)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_WIDTH.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30C8\30ED\30FC\30AF\306E\5E45\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104507469572308843)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_WIDTH.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30C8\30ED\30FC\30AF\306E\5E45')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104512116730308847)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_ADV_FORMATTING.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C4\30FC\30EB\30C1\30C3\30D7\3092\3001\5217\3001\307E\305F\306FHTML\5F0F\304A\3088\3073\30B5\30DD\30FC\30C8\3055\308C\3066\3044\308B\7F6E\63DB\6587\5B57\5217\3092\4F7F\7528\3059\308B\62E1\5F35\30D5\30A9\30FC\30DE\30C3\30C8\306E\3044\305A\308C\3092\4F7F\7528\3057\3066\8868\793A\3059\308B\304B\3092\6307\5B9A\3057\307E\3059\3002\30C4\30FC\30EB\30C1\30C3\30D7\306F\3001\30DE\30C3\30D7\4E0A\306E\30AA\30D6\30B8\30A7\30AF\30C8\306B\30AB\30FC\30BD\30EB\3092\5408\308F\305B\308B\3068\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104512010888308847)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_ADV_FORMATTING.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\62E1\5F35\30D5\30A9\30FC\30DE\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104512360361308847)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C4\30FC\30EB\30C1\30C3\30D7\3068\3057\3066\4F7F\7528\3059\308B\5217\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104512206218308847)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104512817648308847)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_CSS_CLASSES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C4\30FC\30EB\30C1\30C3\30D7\3092\30EC\30F3\30C0\30EA\30F3\30B0\3059\308B\3068\304D\306B\4F7F\7528\3059\308BCSS\30AF\30E9\30B9\3092\5165\529B\3057\307E\3059\3002\8907\6570\306E\30AF\30E9\30B9\306F\7A7A\767D\3067\533A\5207\3063\3066\8FFD\52A0\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104512742665308847)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_CSS_CLASSES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('CSS\30AF\30E9\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104512663683308847)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_HTML_EXPR.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>\30D0\30C3\30AF\30B0\30E9\30A6\30F3\30C9\304A\3088\3073\30C6\30AD\30B9\30C8\306E\8272\306E\5909\66F4</dt>'),
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>\30D8\30C3\30C0\30FC2\306E\4F7F\7528</dt>'),
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>SQL\554F\5408\305B\304B\3089\306E\52D5\7684\30AF\30E9\30B9\306E\4F7F\7528</dt>'),
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    \3053\306E\4F8B\3067<code>&COLUMN_CLASS.</code>\3068<code>&EMPLOYEE_STATUS.</code>\306B\4EE3\5165\3055\308C\308B\306E\306F\3001\30EC\30DD\30FC\30C8SQL\554F\5408\305B\3067\9078\629E\3055\308C\305F\5217\3067\3059\3002</dd>'),
unistr('  <dt>\30DB\30D0\30FC\3067\306E\30A4\30E1\30FC\30B8\304A\3088\3073\30C4\30FC\30EB\30C1\30C3\30D7\306E\8868\793A</dt>'),
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104512571584308847)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_HTML_EXPR.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30C3\30D7\4E0A\306E\30AA\30D6\30B8\30A7\30AF\30C8\306B\30AB\30FC\30BD\30EB\3092\5408\305B\308B\3068\30C4\30FC\30EB\30C1\30C3\30D7\3068\3057\3066\8868\793A\3055\308C\308BHTML\5F0F\3092\5165\529B\3057\307E\3059\3002<code>&COLUMN.</code>\69CB\6587\3092\4F7F\7528\3057\3066\3001HTML\306B\5217\5024\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104512418468308847)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_HTML_EXPR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('HTML\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104506432722308843)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_GEOJSON_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30C3\30D7\306B\8868\793A\3059\308BGeoJSON\30AA\30D6\30B8\30A7\30AF\30C8\3092\8FD4\3059\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104506315242308843)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_GEOJSON_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('GeoJSON\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104506695561308843)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_GEOMETRY_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30C3\30D7\306B\8868\793A\3059\308B\30B8\30AA\30E1\30C8\30EA\30FB\30AA\30D6\30B8\30A7\30AF\30C8\3092\8FD4\3059SDO_GEOMETRY\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104506508292308843)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_GEOMETRY_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B8\30AA\30E1\30C8\30EA\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104505066519308842)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B8\30AA\30E1\30C8\30EA\5217\306E\30C7\30FC\30BF\578B\3092\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104505347619308842)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.GEOJSON.D'
,p_message_language=>'ja'
,p_message_text=>'GeoJSON'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104505415683308842)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.GEOJSON.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('VARCHAR2\307E\305F\306FCLOB\30BF\30A4\30D7\3068\3057\3066\306EGeoJSON\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104505543809308842)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.LONLAT_COLUMNS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D4C\5EA6/\7DEF\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104505615848308842)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.LONLAT_COLUMNS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('2\3064\306ENUMBER\5217\3068\3057\3066\306E\7D4C\5EA6\3068\7DEF\5EA6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104505185877308842)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.SDO_GEOMETRY.D'
,p_message_language=>'ja'
,p_message_text=>'SDO_GEOMETRY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104505215949308842)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.SDO_GEOMETRY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('Oracle SDO_GEOMETRY\578B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104504930939308842)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B8\30AA\30E1\30C8\30EA\5217\306E\30C7\30FC\30BF\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104505881600308842)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B8\30AA\30E1\30C8\30EA\5217\306E\30C7\30FC\30BF\578B\3092\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104505957771308842)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.LOV.GEOJSON.D'
,p_message_language=>'ja'
,p_message_text=>'GeoJSON'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104506069573308842)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.LOV.GEOJSON.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('VARCHAR2\307E\305F\306FCLOB\30BF\30A4\30D7\3068\3057\3066\306EGeoJSON\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104506115855308843)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.LOV.LONLAT_COLUMNS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D4C\5EA6/\7DEF\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104506257541308843)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.LOV.LONLAT_COLUMNS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('2\3064\306ENUMBER\5217\3068\3057\3066\306E\7D4C\5EA6\3068\7DEF\5EA6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104505708452308842)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B8\30AA\30E1\30C8\30EA\5217\306E\30C7\30FC\30BF\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104504896660308842)
,p_name=>'PE.PROPERTY.MAP_HAS_SPATIAL_INDEX.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\57FA\790E\3068\306A\308B\8868\306B\7A7A\9593\7D22\5F15\304C\3042\308A\3001\30C7\30FC\30BF\30D9\30FC\30B9\304B\3089\884C\3092\30D5\30A7\30C3\30C1\3059\308B\969B\306B\30DE\30C3\30D7\30FB\30A6\30A3\30B8\30A7\30C3\30C8\304C\305D\308C\3092\4F7F\7528\3059\308B\5FC5\8981\304C\3042\308B\5834\5408\306F\3001\3053\306E\30B9\30A4\30C3\30C1\3092\6709\52B9\306B\3057\307E\3059\3002\3053\306E\5834\5408\3001\30A6\30A3\30B8\30A7\30C3\30C8\306F\30C7\30FC\30BF\30D9\30FC\30B9\304B\3089\73FE\5728\306E\30DE\30C3\30D7\30FB\30A6\30A3\30F3\30C9\30A6\306E\884C<em>\306E\307F</em>\3092\30D5\30A7\30C3\30C1\3057\307E\3059\3002\3053\308C\306B\3088\308A\3001\30C7\30FC\30BF\30FB\30BD\30FC\30B9\306B\5927\91CF\306E\884C\304C\542B\307E\308C\3066\3044\308B\5834\5408\306B\30D1\30D5\30A9\30FC\30DE\30F3\30B9\304C\5411\4E0A\3057\307E\3059\3002</p><p>\7A7A\9593\7D22\5F15\306F\3001SQL\30EF\30FC\30AF\30B7\30E7\30C3\30D7\306ESDO_GEOMETRY\5217\306B\4F5C\6210\3067\304D\307E\3059\3002</p>'),
unistr('<p>\6B21\306E\72B6\6CC1\3067\306F\3001\7A7A\9593\7D22\5F15\306F\4F7F\7528\3055\308C<em>\306A\3044</em>\3053\3068\306B\6CE8\610F\3057\3066\304F\3060\3055\3044:</p>'),
'<ul>',
unistr('<li>\8907\6570\306E\30EC\30A4\30E4\30FC\304C\30C7\30FC\30BF\30FB\30BD\30FC\30B9\3068\3057\3066<strong>\30EA\30FC\30B8\30E7\30F3\30FB\30BD\30FC\30B9</strong>\3092\53C2\7167\3057\3066\3044\308B\3002</li>'),
unistr('<li>\30DE\30C3\30D7\30FB\30A6\30A3\30F3\30C9\30A6\304C\5927\304D\3059\304E\308B\3002\3064\307E\308A\3001\5168\4F53\306E\534A\5206\4EE5\4E0A\3092\5360\3081\3066\3044\308B\5834\5408\306A\3069\3067\3059\3002</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104504746840308842)
,p_name=>'PE.PROPERTY.MAP_HAS_SPATIAL_INDEX.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7A7A\9593\7D22\5F15\306E\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104507018414308843)
,p_name=>'PE.PROPERTY.MAP_LAT_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30C3\30D7\306B\8868\793A\3055\308C\308B\7A7A\9593\30AA\30D6\30B8\30A7\30AF\30C8\306E\7DEF\5EA6\3092\542B\3080NUMBER\5217\3002\623B\308A\5024\306F-90\304B\308990\306E\9593\306B\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104506981524308843)
,p_name=>'PE.PROPERTY.MAP_LAT_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7DEF\5EA6\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104522637968308855)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E8B\524D\5B9A\7FA9\3055\308C\305F\76F8\9055\30AB\30E9\30FC\30FB\30B9\30AD\30FC\30E0\306E1\3064\3092\9078\629E\3057\307E\3059\3002\3053\308C\3089\306F\3001\3042\308B\6975\5024\304B\3089\5225\306E\6975\5024\3078\3068\5909\5316\3059\308B\76F8\9055\5024\3092\8996\899A\5316\3059\308B\5834\5408\306B\9069\3057\3066\3044\307E\3059\3002cartocolors (<a rel="noreferrer" href="https://github.com/CartoDB/cartocolor" target="_blank">GitHub\306ECARTOcolor)</a>\306E\30AB\30E9\30FC\30FB\30B9\30AD\30FC\30E0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104522748161308855)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.ARMYROSE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30FC\30DF\30FC\304B\3089\30ED\30FC\30BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104522858598308855)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.ARMYROSE.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#798234; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a3ad62; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d0d3a2;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fdfbe4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f0c6c3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#df91a'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d46780; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104523964882308856)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.EARTH.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30FC\30B9\30FB\30AB\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104524069055308856)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.EARTH.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#A16928; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#bd925a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d6bd8d;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edeac2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b5c8b8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#79a7a'
||'c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2887a1; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104522992312308855)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.FALL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\79CB\30AB\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104523001401308855)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.FALL.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#3d5941; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#778868; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b5b991;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6edbd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edbb8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#de8a5'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca562c; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104523133957308855)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.GEYSER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\9593\6B20\6CC9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104523206003308855)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.GEYSER.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#008080; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#70a494; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b4c8a8;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6edbd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edbb8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#de8a5'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca562c; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104523531267308855)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TEALROSE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30A3\30FC\30EB\304B\3089\30ED\30FC\30BA')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104523638700308855)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TEALROSE.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009392; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#72aaa1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b1c7b3;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f1eac8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e5b9ad; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d9899'
||'4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d0587e; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104523313688308855)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TEMPS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6E29\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104523412908308855)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TEMPS.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009392; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#39b185; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9ccb86;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e9e29c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eeb479; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e8847'
||'1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#cf597e; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104523788477308855)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TROPIC.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C8\30ED\30D4\30AB\30EB\30FB\30AB\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104523872132308856)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TROPIC.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009B9E; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#42B7B9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A7D3D4;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F1F1F1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#E4C1D9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#D691C'
||'1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#C75DAB; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104522535385308855)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AD\30FC\30E0\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104524281891308856)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E8B\524D\5B9A\7FA9\3055\308C\305F\5B9A\6027\30AB\30E9\30FC\30FB\30B9\30AD\30FC\30E0\306E1\3064\3092\9078\629E\3057\307E\3059\3002\3053\308C\3089\306F\3001\500B\5225\5024\3092\8996\899A\5316\3059\308B\5834\5408\306B\9069\3057\3066\3044\307E\3059\3002cartocolors (<a rel="noreferrer" href="https://github.com/CartoDB/cartocolor" target="_blank">GitHub\306ECARTOcolor)</a>\306E\30AB\30E9\30FC\30FB\30B9\30AD\30FC\30E0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104524330787308856)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.ANTIQUE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30F3\30C6\30A3\30FC\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104524416248308856)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.ANTIQUE.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#855C75; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#D9AF6B; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#AF6458;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#736F4C; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#526A83; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#62537'
||'7; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7C7C7C; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104524514660308856)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.BOLD.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\592A\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104524606574308856)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.BOLD.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#7F3C8D; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#11A579; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3969AC;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F2B701; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#E73F74; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#80BA5'
||'A; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A5AA99; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104524766110308856)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.PASTEL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30B9\30C6\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104524886951308856)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.PASTEL.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#66C5CC; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F6CF71; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F89C74;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#DCB0F2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#87C55F; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9EB9F'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#B3B3B3; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104524969183308856)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.PRISM.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30EA\30BA\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104525082609308856)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.PRISM.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#5F4690; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#1D6996; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#38A6A5;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#0F8554; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#73AF48; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#EDAD0'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#666666; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104525140892308856)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.SAFE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30FC\30D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104525226439308857)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.SAFE.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#88CCEE; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#CC6677; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#DDCC77;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#117733; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#332288; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#AA449'
||'9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#888888; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104525372071308857)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.VIVID.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D3\30D3\30C3\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104525429202308857)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.VIVID.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#E58606; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#5D69B1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#52BCA3;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#99C945; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#CC61B0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#24796'
||'C; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A5AA99; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104524176565308856)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AD\30FC\30E0\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104518616401308852)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E8B\524D\5B9A\7FA9\3055\308C\305F\9806\6B21\30AB\30E9\30FC\30FB\30B9\30AD\30FC\30E0\306E1\3064\3092\9078\629E\3057\307E\3059\3002\3053\308C\3089\306F\3001\4E0B\9650\5024\304B\3089\4E0A\9650\5024\3078\3068\5909\5316\3059\308B\9806\6B21\5024\3092\8996\899A\5316\3059\308B\5834\5408\306B\9069\3057\3066\3044\307E\3059\3002cartocolors (<a rel="noreferrer" href="https://github.com/CartoDB/cartocolor" target="_blank">GitHub\306ECARTOcolor)</a>\306E\30AB\30E9\30FC\30FB\30B9\30AD\30FC\30E0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104520158141308853)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BLUGRN.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EB\30FC\304B\3089\30B0\30EA\30FC\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104520298022308853)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BLUGRN.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#c4e6c3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#96d2a4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6dbc90;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4da284; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#36877a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#266b6'
||'e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#1d4f60; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104520725856308853)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BLUYL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EB\30FC\304B\3089\30A4\30A8\30ED\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104520806935308853)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BLUYL.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f7feae; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b7e6a5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7ccba2;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#46aea0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#089099; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#00718'
||'b; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#045275; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104522303960308854)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BRWNYL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30E9\30A6\30F3\304B\3089\30A4\30A8\30ED\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104522418716308855)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BRWNYL.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ede5cf; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e0c2a2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d39c83;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#c1766f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a65461; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#81375'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#541f3f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104518706186308852)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BURG.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D0\30FC\30AC\30F3\30C7\30A3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104518874468308852)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BURG.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ffc6c4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f4a3a8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e38191;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#cc607d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ad466c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#8b305'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#672044; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104518929755308852)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BURGYL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D0\30FC\30AC\30F3\30C7\30A3\304B\3089\30A4\30A8\30ED\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104519079671308852)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BURGYL.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fbe6c5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f5ba98; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ee8a82;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dc7176; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#c8586c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9c3f5'
||'d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#70284a; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104520349565308853)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.DARKMINT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C0\30FC\30AF\30FB\30DF\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104520478234308853)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.DARKMINT.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d2fbd4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a5dbc2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7bbcb0;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#559c9e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3a7c89; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#235d7'
||'2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#123f5a; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104520592370308853)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.EMRLD.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E1\30E9\30EB\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104520698559308853)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.EMRLD.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d3f2a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#97e196; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6cc08b;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4c9b82; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#217a79; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#10596'
||'5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#074050; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104521939710308854)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.MAGENTA.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30BC\30F3\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104522037475308854)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.MAGENTA.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3cbd3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eaa9bd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dd88ac;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca699d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b14d8e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#91357'
||'d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6c2167; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104519970220308853)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.MINT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DF\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104520043842308853)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.MINT.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#e4f1e1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b4d9cc; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#89c0b6;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#63a6a0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#448c8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#28727'
||'4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#0d585f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104519387794308852)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.ORYEL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30EC\30F3\30B8\304B\3089\30A4\30A8\30ED\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104519477993308852)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.ORYEL.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ecda9a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#efc47e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f3ad6a;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f7945d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f97b57; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6635'
||'6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ee4d5a; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104519566963308852)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PEACH.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D4\30FC\30C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104519653846308852)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PEACH.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fde0c5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#facba6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f8b58b;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f59e72; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f2855d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ef6a4'
||'c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eb4a40; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104519720125308852)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PINKYL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D4\30F3\30AF\304B\3089\30A4\30A8\30ED\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104519816575308853)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PINKYL.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fef6b5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffdd9a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffc285;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffa679; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fa8a76; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f16d7'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e15383; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104521339038308854)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PURP.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30FC\30D7\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104521444289308854)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PURP.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3e0f7; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e4c7f1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d1afe8;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b998dd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9f82ce; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#826db'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#63589f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104521548803308854)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PURPOR.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30FC\30D7\30EB\304B\3089\30AA\30EC\30F3\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104521611540308854)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PURPOR.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f9ddda; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f2b9c4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e597b9;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ce78b3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ad5fad; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#834ba'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#573b88; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104519107263308852)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.REDOR.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30C3\30C9\304B\3089\30AA\30EC\30F3\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104519244001308852)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.REDOR.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f6d2a9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f5b78e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f19c7c;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ea8171; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dd686c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca526'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b13f64; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104521735349308854)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.SUNSET.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30F3\30BB\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104521827003308854)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.SUNSET.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3e79b; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fac484; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f8a07e;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eb7f86; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ce6693; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a059a'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#5c53a5; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104522153692308854)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.SUNSETDARK.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C0\30FC\30AF\30FB\30B5\30F3\30BB\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104522292413308854)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.SUNSETDARK.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fcde9c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#faa476; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f0746e;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e34f6f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dc3977; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b9257'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7c1d6f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104520954465308853)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.TEAL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30A3\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104521074073308853)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.TEAL.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d1eeea; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a8dbd9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#85c4c9;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#68abb8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4f90a6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3b738'
||'f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2a5674; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104521146114308854)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.TEALGRN.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30A3\30FC\30EB\304B\3089\30B0\30EA\30FC\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104521247764308854)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.TEALGRN.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#b0f2bc; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#89e8ac; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#67dba5;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4cc8a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#38b2a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2c98a'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#257d98; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104518554586308852)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AD\30FC\30E0\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104537205179308865)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30B9\30BF\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104537394213308865)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('HTML\30AB\30E9\30FC\306E\30EA\30B9\30C8(#rrggbb)\3092\30AB\30F3\30DE\3067\533A\5207\3063\3066\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104517827030308851)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30E9\30FC\30FB\30B9\30AD\30FC\30E0\30FB\30BF\30A4\30D7\3092\9078\629E\3057\307E\3059\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104518179055308851)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.DIVERGING.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\76F8\9055')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104518213903308851)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.DIVERGING.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30AB\30E9\30FC\30FB\30B9\30AD\30FC\30E0\306F\3001\3042\308B\6975\5024\304B\3089\5225\306E\6975\5024\3078\3068\5909\5316\3059\308B\76F8\9055\5024\3092\8996\899A\5316\3059\308B\5834\5408\306B\9069\3057\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104518328875308851)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.QUALITATIVE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9A\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104518431221308852)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.QUALITATIVE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30AB\30E9\30FC\30FB\30B9\30AD\30FC\30E0\306F\3001\500B\5225\5024\3092\8996\899A\5316\3059\308B\5834\5408\306B\9069\3057\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104517962324308851)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.SEQUENTIAL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\9806\6B21')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104518096002308851)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.SEQUENTIAL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30AB\30E9\30FC\30FB\30B9\30AD\30FC\30E0\306F\3001\4E0B\9650\5024\304B\3089\4E0A\9650\5024\3078\3068\5909\5316\3059\308B\9806\6B21\5024\3092\8996\899A\5316\3059\308B\5834\5408\306B\9069\3057\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104517783835308851)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30E9\30FC\30FB\30B9\30AD\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104669800287308975)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_CUSTOM_SPECTRUM.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<dl><dt>\8D64\304B\3089\767D\307E\3067\306E\7BC4\56F2\306E\30AB\30E9\30FC\30FB\30EA\30B9\30C8</dt>'),
unistr('    <dd><pre>#ff0000,#ff2020,#ff4040,#ff6060,#ff8080,#ffa0a0,#ffc0c0,#ffffff</pre></dd><dt>\9752\304B\3089\9ED2\307E\3067\306E\7BC4\56F2\306E\30AB\30E9\30FC\30FB\30EA\30B9\30C8</dt>'),
'    <dd><pre>#0000ff,#0000c0,#0000a0,#000080,#000060,#000040,#000020,#000000</pre></dd></dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104533430805308863)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_CUSTOM_SPECTRUM.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30D2\30FC\30C8\30FB\30DE\30C3\30D7\30FB\30EC\30A4\30E4\30FC\306E\30AB\30B9\30BF\30E0\30FB<em>\30AB\30E9\30FC\30FB\30B9\30AD\30FC\30E0</em>\3092\6307\5B9A\3057\307E\3059\3002\30AB\30E9\30FC\30FB\30B9\30AD\30FC\30E0\306F\8272\306E\30EA\30B9\30C8\3067\3059\3002\5024\304A\3088\3073\6700\5C0F\5024\3068\6700\5927\5024\306B\57FA\3065\3044\3066\3001\30DE\30C3\30D7\30FB\30A6\30A3\30B8\30A7\30C3\30C8\306F\30EA\30B9\30C8\304B\3089\3053\306E\30AA\30D6\30B8\30A7\30AF\30C8\306E\5B9F\969B\306E\8868\793A\8272\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104533378393308862)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_CUSTOM_SPECTRUM.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30B9\30BF\30E0\30FB\30AB\30E9\30FC\30FB\30EA\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104530470529308860)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E8B\524D\5B9A\7FA9\3055\308C\305F\76F8\9055\30AB\30E9\30FC\30FB\30B9\30AD\30FC\30E0\306E1\3064\3092\9078\629E\3057\307E\3059\3002\3053\308C\3089\306F\3001\3042\308B\6975\5024\304B\3089\5225\306E\6975\5024\3078\3068\5909\5316\3059\308B\76F8\9055\5024\3092\8996\899A\5316\3059\308B\5834\5408\306B\9069\3057\3066\3044\307E\3059\3002cartocolors (<a rel="noreferrer" href="https://github.com/CartoDB/cartocolor" target="_blank">GitHub\306ECARTOcolor)</a>\306E\30AB\30E9\30FC\30FB\30B9\30AD\30FC\30E0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104530571363308860)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.ARMYROSE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30FC\30DF\30FC\304B\3089\30ED\30FC\30BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104530644898308861)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.ARMYROSE.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#798234; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a3ad62; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d0d3a2;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fdfbe4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f0c6c3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#df91a'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d46780; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104531749092308861)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.EARTH.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30FC\30B9\30FB\30AB\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104531860952308861)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.EARTH.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#A16928; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#bd925a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d6bd8d;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edeac2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b5c8b8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#79a7a'
||'c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2887a1; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104530731063308861)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.FALL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\79CB\30AB\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104530877922308861)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.FALL.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#3d5941; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#778868; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b5b991;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6edbd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edbb8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#de8a5'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca562c; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104530960919308861)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.GEYSER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\9593\6B20\6CC9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104531050970308861)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.GEYSER.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#008080; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#70a494; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b4c8a8;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6edbd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edbb8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#de8a5'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca562c; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104531365019308861)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TEALROSE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30A3\30FC\30EB\304B\3089\30ED\30FC\30BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104531410122308861)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TEALROSE.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009392; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#72aaa1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b1c7b3;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f1eac8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e5b9ad; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d9899'
||'4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d0587e; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104531134493308861)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TEMPS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6E29\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104531292089308861)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TEMPS.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009392; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#39b185; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9ccb86;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e9e29c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eeb479; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e8847'
||'1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#cf597e; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104531517134308861)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TROPIC.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C8\30ED\30D4\30AB\30EB\30FB\30AB\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104531676874308861)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TROPIC.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009B9E; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#42B7B9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A7D3D4;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F1F1F1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#E4C1D9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#D691C'
||'1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#C75DAB; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104530311043308860)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AD\30FC\30E0\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104532010849308862)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E8B\524D\5B9A\7FA9\3055\308C\305F\5B9A\6027\30AB\30E9\30FC\30FB\30B9\30AD\30FC\30E0\306E1\3064\3092\9078\629E\3057\307E\3059\3002\3053\308C\3089\306F\3001\500B\5225\5024\3092\8996\899A\5316\3059\308B\5834\5408\306B\9069\3057\3066\3044\307E\3059\3002cartocolors (<a rel="noreferrer" href="https://github.com/CartoDB/cartocolor" target="_blank">GitHub\306ECARTOcolor)</a>\306E\30AB\30E9\30FC\30FB\30B9\30AD\30FC\30E0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104532101989308862)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.ANTIQUE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30F3\30C6\30A3\30FC\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104532251681308862)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.ANTIQUE.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#855C75; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#D9AF6B; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#AF6458;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#736F4C; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#526A83; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#62537'
||'7; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7C7C7C; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104532324210308862)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.BOLD.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\592A\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104532424100308862)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.BOLD.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#7F3C8D; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#11A579; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3969AC;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F2B701; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#E73F74; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#80BA5'
||'A; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A5AA99; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104532594047308862)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.PASTEL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30B9\30C6\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104532633641308862)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.PASTEL.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#66C5CC; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F6CF71; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F89C74;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#DCB0F2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#87C55F; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9EB9F'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#B3B3B3; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104532726087308862)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.PRISM.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30EA\30BA\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104532899938308862)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.PRISM.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#5F4690; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#1D6996; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#38A6A5;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#0F8554; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#73AF48; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#EDAD0'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#666666; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104532975583308862)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.SAFE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30FC\30D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104533060552308862)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.SAFE.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#88CCEE; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#CC6677; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#DDCC77;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#117733; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#332288; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#AA449'
||'9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#888888; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104533170425308862)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.VIVID.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D3\30D3\30C3\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104533266533308862)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.VIVID.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#E58606; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#5D69B1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#52BCA3;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#99C945; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#CC61B0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#24796'
||'C; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A5AA99; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104531900013308861)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AD\30FC\30E0\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104526458804308857)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E8B\524D\5B9A\7FA9\3055\308C\305F\9806\6B21\30AB\30E9\30FC\30FB\30B9\30AD\30FC\30E0\306E1\3064\3092\9078\629E\3057\307E\3059\3002\3053\308C\3089\306F\3001\4E0B\9650\5024\304B\3089\4E0A\9650\5024\3078\3068\5909\5316\3059\308B\9806\6B21\5024\3092\8996\899A\5316\3059\308B\5834\5408\306B\9069\3057\3066\3044\307E\3059\3002cartocolors (<a rel="noreferrer" href="https://github.com/CartoDB/cartocolor" target="_blank">GitHub\306ECARTOcolor)</a>\306E\30AB\30E9\30FC\30FB\30B9\30AD\30FC\30E0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104527912534308859)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BLUGRN.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EB\30FC\304B\3089\30B0\30EA\30FC\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104528073854308859)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BLUGRN.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#c4e6c3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#96d2a4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6dbc90;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4da284; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#36877a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#266b6'
||'e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#1d4f60; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104528575338308859)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BLUYL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EB\30FC\304B\3089\30A4\30A8\30ED\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104528606033308859)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BLUYL.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f7feae; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b7e6a5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7ccba2;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#46aea0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#089099; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#00718'
||'b; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#045275; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104530159135308860)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BRWNYL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30E9\30A6\30F3\304B\3089\30A4\30A8\30ED\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104530204841308860)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BRWNYL.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ede5cf; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e0c2a2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d39c83;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#c1766f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a65461; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#81375'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#541f3f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104526524814308858)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BURG.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D0\30FC\30AC\30F3\30C7\30A3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104526624700308858)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BURG.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ffc6c4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f4a3a8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e38191;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#cc607d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ad466c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#8b305'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#672044; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104526762740308858)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BURGYL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D0\30FC\30AC\30F3\30C7\30A3\304B\3089\30A4\30A8\30ED\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104526839534308858)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BURGYL.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fbe6c5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f5ba98; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ee8a82;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dc7176; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#c8586c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9c3f5'
||'d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#70284a; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104528128423308859)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.DARKMINT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C0\30FC\30AF\30FB\30DF\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104528249302308859)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.DARKMINT.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d2fbd4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a5dbc2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7bbcb0;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#559c9e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3a7c89; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#235d7'
||'2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#123f5a; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104528305033308859)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.EMRLD.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E1\30E9\30EB\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104528491972308859)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.EMRLD.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d3f2a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#97e196; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6cc08b;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4c9b82; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#217a79; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#10596'
||'5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#074050; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104529758481308860)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.MAGENTA.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30BC\30F3\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104529843446308860)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.MAGENTA.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3cbd3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eaa9bd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dd88ac;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca699d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b14d8e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#91357'
||'d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6c2167; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104527722562308858)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.MINT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DF\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104527853710308858)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.MINT.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#e4f1e1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b4d9cc; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#89c0b6;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#63a6a0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#448c8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#28727'
||'4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#0d585f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104527161754308858)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.ORYEL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30EC\30F3\30B8\304B\3089\30A4\30A8\30ED\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104527236495308858)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.ORYEL.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ecda9a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#efc47e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f3ad6a;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f7945d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f97b57; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6635'
||'6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ee4d5a; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104527342178308858)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PEACH.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D4\30FC\30C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104527439733308858)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PEACH.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fde0c5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#facba6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f8b58b;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f59e72; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f2855d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ef6a4'
||'c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eb4a40; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104527512914308858)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PINKYL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D4\30F3\30AF\304B\3089\30A4\30A8\30ED\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104527686928308858)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PINKYL.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fef6b5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffdd9a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffc285;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffa679; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fa8a76; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f16d7'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e15383; width:30px;">&nbsp;</div></div>'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104529125576308859)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PURP.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30FC\30D7\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104529293848308859)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PURP.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3e0f7; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e4c7f1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d1afe8;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b998dd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9f82ce; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#826db'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#63589f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104529377901308860)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PURPOR.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30FC\30D7\30EB\304B\3089\30AA\30EC\30F3\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104529496535308860)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PURPOR.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f9ddda; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f2b9c4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e597b9;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ce78b3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ad5fad; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#834ba'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#573b88; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104526942470308858)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.REDOR.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30C3\30C9\304B\3089\30AA\30EC\30F3\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104527047243308858)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.REDOR.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f6d2a9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f5b78e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f19c7c;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ea8171; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dd686c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca526'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b13f64; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104529573380308860)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.SUNSET.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30F3\30BB\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104529631919308860)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.SUNSET.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3e79b; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fac484; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f8a07e;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eb7f86; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ce6693; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a059a'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#5c53a5; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104529944753308860)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.SUNSETDARK.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C0\30FC\30AF\30FB\30B5\30F3\30BB\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104530035532308860)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.SUNSETDARK.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fcde9c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#faa476; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f0746e;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e34f6f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dc3977; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b9257'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7c1d6f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104528722230308859)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.TEAL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30A3\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104528824712308859)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.TEAL.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d1eeea; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a8dbd9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#85c4c9;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#68abb8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4f90a6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3b738'
||'f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2a5674; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104528936385308859)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.TEALGRN.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30A3\30FC\30EB\304B\3089\30B0\30EA\30FC\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104529042788308859)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.TEALGRN.HELP'
,p_message_language=>'ja'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#b0f2bc; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#89e8ac; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#67dba5;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4cc8a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#38b2a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2c98a'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#257d98; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104526388483308857)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AD\30FC\30E0\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104537488555308865)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30B9\30BF\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104537524399308866)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('HTML\30AB\30E9\30FC\306E\30EA\30B9\30C8(#rrggbb)\3092\30AB\30F3\30DE\3067\533A\5207\3063\3066\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104525609080308857)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30E9\30FC\30FB\30B9\30AD\30FC\30E0\30FB\30BF\30A4\30D7\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104525949807308857)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.DIVERGING.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\76F8\9055')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104526039016308857)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.DIVERGING.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30AB\30E9\30FC\30FB\30B9\30AD\30FC\30E0\306F\3001\3042\308B\6975\5024\304B\3089\5225\306E\6975\5024\3078\3068\5909\5316\3059\308B\76F8\9055\5024\3092\8996\899A\5316\3059\308B\5834\5408\306B\9069\3057\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104526174102308857)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.QUALITATIVE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9A\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104526259326308857)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.QUALITATIVE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30AB\30E9\30FC\30FB\30B9\30AD\30FC\30E0\306F\3001\500B\5225\5024\3092\8996\899A\5316\3059\308B\5834\5408\306B\9069\3057\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104525738437308857)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.SEQUENTIAL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\9806\6B21')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104525836355308857)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.SEQUENTIAL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30AB\30E9\30FC\30FB\30B9\30AD\30FC\30E0\306F\3001\4E0B\9650\5024\304B\3089\4E0A\9650\5024\3078\3068\5909\5316\3059\308B\9806\6B21\5024\3092\8996\899A\5316\3059\308B\5834\5408\306B\9069\3057\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104525546311308857)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30E9\30FC\30FB\30B9\30AD\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104515495586308849)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30EC\30A4\30E4\30FC\306E\30BF\30A4\30D7\3092\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104516136101308850)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.HEATMAP.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D2\30FC\30C8\30FB\30DE\30C3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104516260879308850)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.HEATMAP.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D2\30FC\30C8\30FB\30DE\30C3\30D7\3068\3057\3066\8868\793A\3055\308C\308B\30DD\30A4\30F3\30C8\30FB\30AA\30D6\30B8\30A7\30AF\30C8\3002\30D2\30FC\30C8\30FB\30DE\30C3\30D7\306F\3001\30DD\30A4\30F3\30C8\30FB\30AA\30D6\30B8\30A7\30AF\30C8\306E\5BC6\5EA6\3092\8996\899A\5316\3059\308B\969B\306B\4FBF\5229\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104515753594308850)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.LINE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104515800647308850)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.LINE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\30AA\30D6\30B8\30A7\30AF\30C8\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104515505097308849)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POINT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DD\30A4\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104515626953308850)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POINT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DD\30A4\30F3\30C8\30FB\30AA\30D6\30B8\30A7\30AF\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104515916980308850)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POLYGON.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DD\30EA\30B4\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104516020965308850)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POLYGON.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DD\30EA\30B4\30F3\30FB\30AA\30D6\30B8\30A7\30AF\30C8\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104516397317308850)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POLYGON_3D.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\62BC\51FA\3057\30DD\30EA\30B4\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104516403790308850)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POLYGON_3D.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('3D\30AA\30D6\30B8\30A7\30AF\30C8\3068\3057\3066\306E"\62BC\51FA\3057"\30DD\30EA\30B4\30F3\3002\9AD8\3055\306F\3001\7D50\679C\5217\306E\5024\306B\57FA\3065\3044\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104515352042308849)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30A4\30E4\30FC\30FB\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104517667393308851)
,p_name=>'PE.PROPERTY.MAP_LAYER_VISIBLE_MAX_ZOOM_LEVEL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30EC\30A4\30E4\30FC\304C\8868\793A\3055\308C\305F\307E\307E\306B\306A\308B\6700\5927\30BA\30FC\30E0\30FB\30EC\30D9\30EB\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104517527617308851)
,p_name=>'PE.PROPERTY.MAP_LAYER_VISIBLE_MAX_ZOOM_LEVEL.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5927')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104517449352308851)
,p_name=>'PE.PROPERTY.MAP_LAYER_VISIBLE_MIN_ZOOM_LEVEL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30EC\30A4\30E4\30FC\304C\8868\793A\3055\308C\308B\6700\5C0F\30BA\30FC\30E0\30FB\30EC\30D9\30EB\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104517331130308851)
,p_name=>'PE.PROPERTY.MAP_LAYER_VISIBLE_MIN_ZOOM_LEVEL.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104506828957308843)
,p_name=>'PE.PROPERTY.MAP_LON_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30C3\30D7\306B\8868\793A\3055\308C\308B\7A7A\9593\30AA\30D6\30B8\30A7\30AF\30C8\306E\7D4C\5EA6\3092\542B\3080NUMBER\5217\3002\623B\308A\5024\306F-180\304B\3089180\306E\9593\306B\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104506733844308843)
,p_name=>'PE.PROPERTY.MAP_LON_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D4C\5EA6\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104510786975308846)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_CLUSTER.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30C3\30D7\4E0A\3067\540C\3058\5834\6240\306B\914D\7F6E\3055\308C\305F\30DD\30A4\30F3\30C8\3092\30AF\30E9\30B9\30BF\5316\3059\308B\304B\3069\3046\304B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104510663524308846)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_CLUSTER.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6709\52B9\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104508249125308844)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DD\30A4\30F3\30C8\30FB\30AA\30D6\30B8\30A7\30AF\30C8\306E\8868\793A\65B9\6CD5\3092\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104508518980308844)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.LOV.ICON.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104508668641308844)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.LOV.ICON.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3\3068\3057\3066\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104508327375308844)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.LOV.SVG.D'
,p_message_language=>'ja'
,p_message_text=>'SVG'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104508470460308844)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.LOV.SVG.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('SVG\5F62\72B6\3068\3057\3066\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104508101161308844)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30BF\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104510278651308846)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DD\30A4\30F3\30C8\30FB\30AA\30D6\30B8\30A7\30AF\30C8\3092\8868\793A\3059\308BSVG\5F62\72B6\3092\6307\5B9A\3057\307E\3059\3002\4E8B\524D\5B9A\7FA9\3055\308C\305F\5F62\72B6\304B\3089\9078\629E\3059\308B\304B\3001<strong>\30AB\30B9\30BF\30E0SVG\30B9\30BF\30A4\30EB</strong>\30FB\30DE\30C3\30D7\30FB\30EA\30FC\30B8\30E7\30F3\5C5E\6027\3067\6307\5B9A\3055\308C\305F<em>\30AB\30B9\30BF\30E0SVG\5F62\72B6</em>\306E\540D\524D\3092\5165\529B\3057\307E\3059\3002\540D\524D\304C\6307\5B9A\3055\308C\3066\3044\306A\3044\5834\5408\3001\307E\305F\306F\6307\5B9A\3055\308C\305F\540D\524D\304C\30C7\30D5\30A9\30EB\30C8\307E\305F\306F\30AB\30B9\30BF\30E0SVG\5F62\72B6\306E\30EA\30B9\30C8\306B\306A\3044\5834\5408\306F\3001<strong>\30C7\30D5\30A9\30EB\30C8</strong>\5F62\72B6\304C\4F7F\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104543577078308870)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CAMERA.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30E1\30E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104550532062308875)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CAMERA.HELP'
,p_message_language=>'ja'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15 4h-1.2l-.9-1.2c-.4-.5-1-.8-1.6-.8H8.8c-.7 0-1.3.3-1.6.8L6.2 4H5c-1.1 0-2 .9-2 2v5c0 1.1.9 2 2 2h2.2l2.4 4.7c.1.2.4.3.7.2.1 0 .2-.'
||'1.2-.2l2.4-4.7H15c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm-5 7c-1.4 0-2.5-1.1-2.5-2.5S8.6 6 10 6s2.5 1.1 2.5 2.5S11.4 11 10 11z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104548703927308874)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CHECK.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30A7\30C3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104551838736308876)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CHECK.HELP'
,p_message_language=>'ja'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zm2.9 4.9l-3 3c-.2.1-.6.1-.8 0L7.6 8.4c-'
||'.2-.2-.2-.5 0-.7s.5-.2.7 0l1.1 1.1L12 6.2c.2-.2.5-.2.7 0s.3.5.2.7z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104543623507308870)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE ALTERNATIVE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5186\306E\4EE3\66FF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104550746159308875)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE ALTERNATIVE.HELP'
,p_message_language=>'ja'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8v9.5c0 .2.1.4.3.5h.2c.1 0 .3-.1.4-.2l3.7-4c3.2.8 6.5-1.2 7.3-4.4.8-3.2-1.2-6.5-4.4-7.3-.5 0-1-.1-1.5-.1zm0 8c-1.'
||'1 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104510476420308846)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5186')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104550650061308875)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE.HELP'
,p_message_language=>'ja'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 2.5 1.6 4.7 3.9 5.6l1.6 4.1c.1.3.4.4.7.3l.3-.3 1.6-4.1c3.1-1.2 4.7-4.6 3.5-7.7C14.7 3.6 12.5 2 10 2zm0 8c-1.1'
||' 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104543459576308870)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.DEFAULT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104550493063308875)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.DEFAULT.HELP'
,p_message_language=>'ja'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 4.6 5.4 9.7 5.7 9.9.2.2.5.2.7 0 .2-.2 5.6-5.3 5.6-9.9 0-3.3-2.7-6-6-6zm0 7.9c-1.1 0-2-.9-2-2s.9-2 2-2 2 .9 2 '
||'2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104543755408308870)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE FROWN.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0D\6A5F\5ACC\306A\9854')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104550845423308875)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE FROWN.HELP'
,p_message_language=>'ja'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm5 3.8c-.2.1-.4.1-.5-.1-.7-.9-2-1.1-3-.4-.2.1-.3.3-.4.4-.1.2-.4.2-.5.1-.2-.1-.2-.4-.1-.5 1-1.3 2.8-1.5 4-.6l.6.6c.1.1.1.4-.1.5zm-.2-3c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104543859692308870)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE MEH.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\95A2\5FC3\306A\9854')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104550915532308875)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE MEH.HELP'
,p_message_language=>'ja'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm4.3 3.9h-3c-.2 0-.4-.2-.4-.4s.2-.4.4-.4h3c.2 0 .4.2.4.4s-.2.4-.4.4zm.5-3.1c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104543984160308870)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE SMILE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\7B11\3063\305F\9854')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104551054872308875)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE SMILE.HELP'
,p_message_language=>'ja'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm5.1 2.7c-1 1.3-2.8 1.5-4 .6l-.6-.6c-.1-.1-.1-.4.1-.5.2-.1.4-.1.5.1.7.9 2 1.1 3 .4.2-.1.3-.3.4-.4.1-.2.4-.2.5-.1s.2.4.1.5zM12 7.8c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104549204798308874)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FLAG PENNANT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30E9\30C3\30B0\30FB\30DA\30CA\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104552399619308876)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FLAG PENNANT.HELP'
,p_message_language=>'ja'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M16.7 6.5L3.7 2c-.3-.1-.6.1-.7.3v15.2c0 .3.2.5.5.5s.5-.2.5-.5v-5.6l12.7-4.4c.3-.1.4-.4.3-.6-.1-.2-.2-.3-.3-.4z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104549330254308874)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FLAG SWALLOWTAIL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30E9\30C3\30B0\30FB\30B9\30EF\30ED\30FC\30C6\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104552434978308876)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FLAG SWALLOWTAIL.HELP'
,p_message_language=>'ja'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M13.2 7l3.7-4.2c.2-.2.2-.5 0-.7-.2-.1-.3-.1-.4-.1h-13c-.3 0-.5.2-.5.5v15c0 .3.2.5.5.5s.5-.2.5-.5V12h12.5c.3 0 .5-.2.5-.5 0-.1 0-.2-.1'
||'-.3L13.2 7z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104544314926308871)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.HEART.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CF\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104551583320308876)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.HEART.HELP'
,p_message_language=>'ja'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M16 5c0-.8-.3-1.6-.9-2.1-1.2-1.2-3.1-1.2-4.3 0l-.8.8-.8-.8C8 1.7 6.1 1.7 4.9 2.9c-1.2 1.1-1.2 3 0 4.2l4.6 4.6v5.8c0 .3.2.5.5.5s.5-.2.'
||'5-.5v-5.8l4.6-4.6c.6-.5.9-1.3.9-2.1z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104548827022308874)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.HOME.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DB\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104551979216308876)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.HOME.HELP'
,p_message_language=>'ja'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M17.8 7.6l-7.5-5.5c-.2-.1-.4-.1-.6 0L2.2 7.5c-.2.2-.3.5-.1.7.2.2.5.3.7.1L4 7.5v6c0 .3.2.5.5.5h3.2l1.9 3.7c.1.2.4.3.7.2.1 0 .2-.1.2-.2'
||'l1.9-3.7h3.2c.3 0 .5-.2.5-.5v-6l1.2.9c.2.2.5.1.7-.1.1-.3 0-.6-.2-.7z"/><path d="M8.5 8.5v2c0 .3.2.5.5.5h2c.3 0 .5-.2.5-.5v-2c0-.3-.2-.5-.5-.5H9c-.3 0-.5.2-.5.5z" fill="#fff"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104544458820308871)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PENTAGON.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E94\89D2\5F62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104551685648308876)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PENTAGON.HELP'
,p_message_language=>'ja'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15 5.5l-4.7-3.4c-.2-.1-.4-.1-.6 0L5 5.5c-.2.2-.3.4-.2.6l1.8 5.6c.1.2.3.3.5.3h2.4v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12h2.4c.2 0 .4-.1.5-.3l'
||'1.8-5.6c.1-.2 0-.4-.2-.6z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104544113581308870)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PIN CIRCLE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5186\306E\30D4\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104551342806308876)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PIN CIRCLE.HELP'
,p_message_language=>'ja'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C7.2 2 5 4.2 5 7c0 2.6 1.9 4.7 4.5 5v5.6c0 .3.2.5.5.5s.5-.2.5-.5V12c2.7-.3 4.7-2.7 4.5-5.4-.3-2.7-2.4-4.6-5-4.6z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104544222148308870)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PIN SQUARE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\56DB\89D2\5F62\306E\30D4\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104551429263308876)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PIN SQUARE.HELP'
,p_message_language=>'ja'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M13 2H7c-1.1 0-2 .9-2 2v6c0 1.1.9 2 2 2h2.5v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12H13c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104549009271308874)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SHINE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\8F1D\304D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104552107278308876)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SHINE.HELP'
,p_message_language=>'ja'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 7c-2.2 0-4 1.8-4 4 0 2.3 3.2 6.4 3.6 6.8.2.2.5.2.7.1l.1-.1c.4-.5 3.6-4.5 3.6-6.8 0-2.2-1.8-4-4-4zm0 5c-.6 0-1-.4-1-1s.4-1 1-1 1 .'
||'4 1 1-.4 1-1 1zM3.6 4.9c-.2-.1-.5-.1-.7.1-.2.3-.1.6.1.7l1.9 1.4c0 .1.1.1.3.1.3 0 .5-.2.5-.5 0-.2-.1-.3-.2-.4L3.6 4.9zm4 .1c.1.2.3.3.5.3h.2c.3-.1.4-.4.3-.6l-.9-2.4c0-.2-.3-.4-.6-.3-.3.1-.4.4-.3.6L7.6 5zm9.5 0c-.2-.2-.5-.3-.7-.1l-1.9 1.4c-.2.2-.3.5-.1.'
||'7.1.1.2.2.4.2.1 0 .2 0 .3-.1L17 5.7c.2-.1.3-.4.1-.7zm-5.3.3h.2c.2 0 .4-.1.5-.3l.8-2.3c.1-.3 0-.5-.3-.6-.3-.1-.5 0-.6.3l-.8 2.3c-.2.2-.1.5.2.6z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104548996528308874)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SLASH.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30E9\30C3\30B7\30E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104552033685308876)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SLASH.HELP'
,p_message_language=>'ja'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M17.9 2.1c-.2-.2-.5-.2-.7 0l-2.3 2.3C13 1.7 9.2 1.1 6.5 3.1 4.9 4.3 4 6.1 4 8c.1 1.9.8 3.8 1.9 5.4l-3.8 3.8c-.2.2-.2.5 0 .7s.5.2.7 0l'
||'15-15c.2-.2.2-.6.1-.8zM9.5 9.8c-1.1-.3-1.7-1.4-1.4-2.4S9.5 5.7 10.5 6c.7.2 1.2.7 1.4 1.4L9.5 9.8zM7.1 15c.8 1 1.6 2 2.6 2.8.2.2.5.2.7 0 .2-.1 5.6-5.2 5.6-9.8 0-.6-.1-1.1-.2-1.6L7.1 15z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104544024408308870)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE ALTERNATIVE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\56DB\89D2\5F62\306E\4EE3\66FF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104551222458308876)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE ALTERNATIVE.HELP'
,p_message_language=>'ja'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14 2H6c-1.1 0-2 .9-2 2v13.5c0 .2.1.4.3.5h.2c.1 0 .3-.1.4-.2L8.4 14H14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-4 8c-1.1 0-2-.9-2-2s.9-2 2-2'
||' 2 .9 2 2-.9 2-2 2z"/></svg>'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104510310859308846)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\56DB\89D2\5F62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104551130132308875)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE.HELP'
,p_message_language=>'ja'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14 2H6c-1.1 0-2 .9-2 2v8c0 1.1.9 2 2 2h2.1l1.5 3.7c.1.3.4.4.7.3l.3-.3 1.5-3.7H14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-4 8c-1.1 0-2-.9-2'
||'-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104549157093308874)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.STREET VIEW.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30C8\30EA\30FC\30C8\30FB\30D3\30E5\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104552251966308876)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.STREET VIEW.HELP'
,p_message_language=>'ja'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14.7 11.6c-.3-.1-.5.1-.6.3s.1.5.3.6c1.6.5 2.6 1.2 2.6 1.9 0 1.2-2.9 2.5-7 2.5s-7-1.3-7-2.5c0-.7 1-1.4 2.6-1.9.3 0 .4-.3.3-.5-.1-.3-.'
||'4-.4-.6-.3-2.1.6-3.3 1.6-3.3 2.8 0 2 3.4 3.5 8 3.5s8-1.5 8-3.5c0-1.2-1.2-2.2-3.3-2.9z"/><path d="M7.7 10.9c.2.2.3.5.3.7V14c0 .6.4 1 1 1h2c.6 0 1-.4 1-1v-2.4c0-.3.1-.5.3-.7l.1-.1c.4-.4.6-.9.6-1.4V7.8c0-.7-.3-1.3-.9-1.6-1.2 1.2-3.1 1.2-4.2 0-.6.3-.9.9-'
||'.9 1.6v1.6c0 .5.2 1 .6 1.4l.1.1z"/><circle cx="10" cy="4" r="2"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104510546267308846)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.TRIANGLE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E09\89D2\5F62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104551757909308876)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.TRIANGLE.HELP'
,p_message_language=>'ja'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15.9 11.2l-5.5-9c-.1-.2-.5-.3-.7-.1-.1 0-.1.1-.1.1l-5.5 9c-.1.2-.1.5.2.7 0 .1.1.1.2.1h5v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12h5c.3 0 .5-.2.'
||'5-.5 0-.1 0-.2-.1-.3z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104510192909308845)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5F62\72B6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104544670423308871)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE_SCALE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('SVG\5F62\72B6\306E\500D\7387\3092\6307\5B9A\3057\307E\3059\3002\6700\5927\30B9\30B1\30FC\30EB\306F<strong>10</strong>\3067\3059\3002\5217\306E\7F6E\63DB\304C\4F7F\7528\3055\308C\3001\5024\304C<strong>10</strong>\3088\308A\5927\304D\3044\5834\5408\3001\30E1\30C3\30BB\30FC\30B8\304CJavaScript\30B3\30F3\30BD\30FC\30EB\306B\66F8\304D\8FBC\307E\308C\3001\30DE\30FC\30AB\30FC\306F<strong>10</strong>\306E\500D\7387\3067\8868\793A\3055\308C\307E\3059\3002\30DE\30C3\30D7\30FB\30B3\30F3\30DD\30FC\30CD\30F3\30C8\3067\306F\3001\5024\304C\5C0F\6570\70B9\4EE5\4E0B1\6841\306B\4E38\3081\3089\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104544593391308871)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE_SCALE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30A7\30A4\30D7\30FB\30B9\30B1\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104509646527308845)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_CLASS_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3CSS\30AF\30E9\30B9\3092\542B\3080\5217\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104509564128308845)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_CLASS_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104510012867308845)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_CSS_CLASSES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3\30FB\30BD\30FC\30B9\3068\3057\3066\4F7F\7528\3059\308BCSS\30AF\30E9\30B9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104509975867308845)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_CSS_CLASSES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3CSS\30AF\30E9\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104509837823308845)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_IMAGE_URL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30E1\30FC\30B8\30FB\30BD\30FC\30B9\306EURL\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104509774948308845)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_IMAGE_URL.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30E1\30FC\30B8URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104508836827308845)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3\306E\30BD\30FC\30B9\3092\9078\629E\3057\3066\3001\30DE\30C3\30D7\4E0A\306B\30DD\30A4\30F3\30C8\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104509146035308845)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.DYNAMIC_CLASS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3\30FB\30AF\30E9\30B9\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104509224742308845)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.DYNAMIC_CLASS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5404\884C\306B\500B\3005\306ECSS\30AF\30E9\30B9\3092\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104508972021308845)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.STATIC_CLASS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3\30FB\30AF\30E9\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104509030487308845)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.STATIC_CLASS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\306E\884C\306B\9759\7684CSS\30AF\30E9\30B9\3092\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104509399177308845)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.URL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30E1\30FC\30B8URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104509401580308845)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.URL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DD\30A4\30F3\30C8\306E\8868\793A\306B\4F7F\7528\3059\308B\30A4\30E1\30FC\30B8\306EURL\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104508790022308844)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3\30FB\30BD\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104499640221308838)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\305D\306E\4ED6\306E\30DE\30C3\30D7\30FB\30A6\30A3\30B8\30A7\30C3\30C8\6A5F\80FD\3092\6709\52B9\307E\305F\306F\7121\52B9\306B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104500780321308839)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.BROWSER_LOCATION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30E9\30A6\30B6\306E\4F4D\7F6E\306E\53D6\5F97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104500854021308839)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.BROWSER_LOCATION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30E9\30A6\30B6\304B\3089\30E6\30FC\30B6\30FC\306E\73FE\5728\306E\4F4D\7F6E\3092\53D6\5F97\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104500951617308839)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.CIRCLE_TOOL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5186\5F62\30C4\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104501057103308839)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.CIRCLE_TOOL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5186\5F62\30C4\30FC\30EB\3092\4F7F\7528\3059\308B\3068\3001\30E6\30FC\30B6\30FC\306F\30DE\30C3\30D7\4E0A\306B\5186\3092\63CF\304F\3053\3068\304C\3067\304D\307E\3059\3002\7D42\4E86\3059\308B\3068\3001\5186\304C\52D5\7684\30A2\30AF\30B7\30E7\30F3\307E\305F\306FJavaScript\30B3\30FC\30C9\306B\3088\3063\3066\51E6\7406\3055\308C\308B\3088\3046\306B\30A4\30D9\30F3\30C8\304C\30C8\30EA\30AC\30FC\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104501171029308839)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.DISTANCE_TOOL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\8DDD\96E2\30C4\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104501289113308839)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.DISTANCE_TOOL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\30DE\30C3\30D7\4E0A\306E\30DD\30A4\30F3\30C8\9593\306E\8DDD\96E2\3092\6E2C\5B9A\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104500526348308838)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.INFINITE_MAP.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\9650\30DE\30C3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104500611729308839)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.INFINITE_MAP.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\9650\30DE\30C3\30D7\30FB\30B9\30AF\30ED\30FC\30EB\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104499758234308838)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.MOUSEWHEEL_ZOOM.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30A6\30B9\30FB\30DB\30A4\30FC\30EB\30FB\30BA\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104499878613308838)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.MOUSEWHEEL_ZOOM.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30A6\30B9\30FB\30DB\30A4\30FC\30EB\3092\4F7F\7528\3057\3066\30BA\30FC\30E0\30FB\30A4\30F3\307E\305F\306F\30BA\30FC\30E0\30FB\30A2\30A6\30C8\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104500390376308838)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.OVERVIEW_MAP.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6982\8981\30DE\30C3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104500439219308838)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.OVERVIEW_MAP.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\6982\8981\30DE\30C3\30D7\3092\53F3\4E0B\306B\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104499910874308838)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.RECTANGLE_ZOOM.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\56DB\89D2\5F62\30BA\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104500082314308838)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.RECTANGLE_ZOOM.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30C3\30D7\4E0A\306B\56DB\89D2\5F62\3092\63CF\753B\3057\3066\3001\9818\57DF\306B\30DE\30C3\30D7\3092\30BA\30FC\30E0\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104500162084308838)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.SCALE_BAR.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30B1\30FC\30EB\30FB\30D0\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104500244396308838)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.SCALE_BAR.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30C3\30D7\306B\30B9\30B1\30FC\30EB\30FB\30D0\30FC\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104499564813308838)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30D7\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104504573990308841)
,p_name=>'PE.PROPERTY.MAP_REGION_HEIGHT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30C3\30D7\30FB\30EA\30FC\30B8\30E7\30F3\306E\9AD8\3055\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104504466498308841)
,p_name=>'PE.PROPERTY.MAP_REGION_HEIGHT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\9AD8\3055')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104504600367308841)
,p_name=>'PE.PROPERTY.MAP_REGION_HEIGHT.UNIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D4\30AF\30BB\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104502856343308840)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_CSS_CLASSES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\51E1\4F8B\306B\8FFD\52A0\3059\308BCSS\30AF\30E9\30B9\3092\5165\529B\3057\307E\3059\3002\8907\6570\306E\30AF\30E9\30B9\306F\7A7A\767D\3067\533A\5207\3063\3066\8FFD\52A0\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104502757239308840)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_CSS_CLASSES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('CSS\30AF\30E9\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104502674713308840)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITION_SELECTOR.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\51E1\4F8B\3092\8868\793A\3059\308B\8981\7D20\306EjQuery\30BB\30EC\30AF\30BF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104502556769308840)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITION_SELECTOR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30EC\30AF\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104501825106308839)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\51E1\4F8B\306E\4F4D\7F6E\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104502147687308840)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.END.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D42\4E86')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104502267708308840)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.END.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D42\4E86\4F4D\7F6E(\901A\5E38\306F\30DE\30C3\30D7\306E\4E0B)\306B\51E1\4F8B\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104502397919308840)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.SELECTOR.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30EC\30AF\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104502488688308840)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.SELECTOR.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\51E1\4F8B\3092\8868\793A\3059\308B\8981\7D20\306EjQuery\30BB\30EC\30AF\30BF\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104501967988308839)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.START.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104502075082308840)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.START.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\59CB\4F4D\7F6E(\901A\5E38\306F\30DE\30C3\30D7\306E\4E0A)\306B\51E1\4F8B\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104501717137308839)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104536776164308865)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.COMPONENT_PROPERTY.MAP_REGION.NULL_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\975E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104669612664308975)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.COMPONENT_PROPERTY.MAP_REGION.NULL_TEXT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30A4\30E4\30FC\30FB\30E1\30C3\30BB\30FC\30B8\3092\8868\793A\3057\306A\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104503359997308840)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30C3\30D7\30FB\30EC\30A4\30E4\30FC\300C\30C7\30FC\30BF\304C\898B\3064\304B\308A\307E\305B\3093\300D\304A\3088\3073\300C\3055\3089\306B\30C7\30FC\30BF\304C\898B\3064\304B\308A\307E\3057\305F\300D\306E\30E1\30C3\30BB\30FC\30B8\3092\8868\793A\3059\308B\5834\6240\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104503496151308841)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.ABOVE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0A\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104503593035308841)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.ABOVE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30C3\30D7\306E\4E0A\90E8\306B\30E1\30C3\30BB\30FC\30B8\3092\8868\793A\3057\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104503646953308841)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.BELOW.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0B\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104503716952308841)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.BELOW.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30C3\30D7\306E\4E0B\90E8\306B\30E1\30C3\30BB\30FC\30B8\3092\8868\793A\3057\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104503891408308841)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.SELECTOR.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30EC\30AF\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104503943428308841)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.SELECTOR.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E1\30C3\30BB\30FC\30B8\3092\8868\793A\3059\308B\8981\7D20\306EjQuery\30BB\30EC\30AF\30BF\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104503296610308840)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E1\30C3\30BB\30FC\30B8\306E\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104504120868308841)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_SELECTOR.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E1\30C3\30BB\30FC\30B8\3092\8868\793A\3059\308B\8981\7D20\306EjQuery\30BB\30EC\30AF\30BF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104504041915308841)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_SELECTOR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E1\30C3\30BB\30FC\30B8\30FB\30BB\30EC\30AF\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104501678425308839)
,p_name=>'PE.PROPERTY.MAP_REGION_SHOW_LEGEND.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\51E1\4F8B\3092\8868\793A\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104501518671308839)
,p_name=>'PE.PROPERTY.MAP_REGION_SHOW_LEGEND.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104504325290308841)
,p_name=>'PE.PROPERTY.MAP_REGION_STATUS_ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\304C\9078\629E\3055\308C\305F\5834\5408\3001\30DE\30C3\30D7\30FB\30EA\30FC\30B8\30E7\30F3\306F\5E38\306B\3001\73FE\5728\306E\30DE\30C3\30D7\5883\754C\30DC\30C3\30AF\30B9\3092GeoJSON\5F62\5F0F\3067\3053\306E\30A2\30A4\30C6\30E0\306E\5024\3068\3057\3066\7DAD\6301\3057\307E\3059\3002\3053\308C\3092\884C\3046\3068\3001\30DE\30C3\30D7\3092\5225\306EAPEX\30B3\30F3\30DD\30FC\30CD\30F3\30C8(\30AF\30E9\30B7\30C3\30AF\30FB\30EC\30DD\30FC\30C8\307E\305F\306F\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\306A\3069)\306B\63A5\7D9A\3059\308B\969B\306B\5F79\7ACB\3061\307E\3059: \5883\754C\30DC\30C3\30AF\30B9\30FB\30A2\30A4\30C6\30E0\306E\30B3\30F3\30C6\30F3\30C4\306F\3001\4ED6\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\304C\7A7A\9593\554F\5408\305B\3092\5B9F\884C\3057\3001\30DE\30C3\30D7\306B\8868\793A\3055\308C\3066\3044\308B\30C7\30FC\30BF\306E\307F\3092\8868\793A\3059\308B\305F\3081\306B\4F7F\7528\3067\304D\307E\3059\3002</p>'),
unistr('<p>\30DE\30C3\30D7\306E\79FB\52D5\307E\305F\306F\30BA\30FC\30E0\30FB\30EC\30D9\30EB\306E\5909\66F4\5F8C\306E\5883\754C\30DC\30C3\30AF\30B9\30FB\30A2\30A4\30C6\30E0\306E\30B3\30F3\30C6\30F3\30C4\306E\4F8B:</p>'),
'<pre>',
'{',
'  "type": "Polygon",',
'  "coordinates": [[',
'                    [-5.499,46.380],',
'                    [ 8.187,46.380],',
'                    [ 8.187,49.550],',
'                    [-5.499,49.550],',
'                    [-5.499,46.380]]]',
'}',
'</pre>',
'<p>',
unistr('\300C\52D5\7684\30A2\30AF\30B7\30E7\30F3\306E<strong>\30EA\30D5\30EC\30C3\30B7\30E5</strong>\300D\3092\4F7F\7528\3057\3066\3001\30DE\30C3\30D7\3092\30EC\30DD\30FC\30C8\30FB\30EA\30FC\30B8\30E7\30F3\306B\63A5\7D9A\3067\304D\307E\3059\3002\30EC\30DD\30FC\30C8\30FB\30EA\30FC\30B8\30E7\30F3\306F\3001\7A7A\9593\30D5\30A3\30EB\30BF\3092\9069\7528\3057\3066\3001\30DE\30C3\30D7\306B\3082\8868\793A\3055\308C\308B\7D50\679C\306E\307F\3092\8868\793A\3067\304D\307E\3059\3002</p>'),
unistr('<p>\30EC\30DD\30FC\30C8\554F\5408\305B\306E\4F8B:</p>'),
'<pre>',
'select [column1],',
'       [column2],',
'       ...',
'  from ...',
' where sdo_anyinteract(',
'           [geometry-column],',
'           sdo_util.from_geojson( :[item-name-of-bounding-box-item] )',
'       ) = ''TRUE''',
'   and ...',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104504281253308841)
,p_name=>'PE.PROPERTY.MAP_REGION_STATUS_ITEM.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5883\754C\30DC\30C3\30AF\30B9\30FB\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104534360685308863)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30B1\30FC\30EB\30FB\30D0\30FC\304A\3088\3073\8DDD\96E2\30C4\30FC\30EB\306B\4F7F\7528\3059\308B\5358\4F4D\30B7\30B9\30C6\30E0\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104534615270308863)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.IMPERIAL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30DA\30EA\30A2\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104534701310308864)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.IMPERIAL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30DA\30EA\30A2\30EB\6CD5\3092\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104534874850308864)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.ITEM.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\304B\3089\5C0E\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104534992513308864)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\306E\5024\304B\3089\5358\4F4D\30B7\30B9\30C6\30E0\3092\5C0E\51FA\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104534418613308863)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.METRIC.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E1\30C8\30EA\30C3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104534520927308863)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.METRIC.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E1\30FC\30C8\30EB\6CD5\3092\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104534294819308863)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5358\4F4D\30B7\30B9\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104535134226308864)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM_PAGE_ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30C3\30D7\5358\4F4D\30B7\30B9\30C6\30E0\3068\3057\3066\4F7F\7528\3059\308B\5024\3092\542B\3080\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059: <strong>METRIC</strong> (<strong>M</strong>)\307E\305F\306F<strong>IMPERIAL</strong> (<strong>I</strong>)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104535097587308864)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM_PAGE_ITEM.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5358\4F4D\30B7\30B9\30C6\30E0\30FB\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104161841631308577)
,p_name=>'PE.PROPERTY.MARKER_RENDERED.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30FC\30AB\30FC\3092\30C1\30E3\30FC\30C8\306E\30C7\30FC\30BF\30FB\30A2\30A4\30C6\30E0\3067\30EC\30F3\30C0\30EA\30F3\30B0\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104161959704308577)
,p_name=>'PE.PROPERTY.MARKER_RENDERED.LOV.AUTO.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104162127172308577)
,p_name=>'PE.PROPERTY.MARKER_RENDERED.LOV.OFF.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\3044\3044\3048')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104162045185308577)
,p_name=>'PE.PROPERTY.MARKER_RENDERED.LOV.ON.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\306F\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104161713954308577)
,p_name=>'PE.PROPERTY.MARKER_RENDERED.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104162308430308577)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\306E\30C7\30FC\30BF\30FB\30A2\30A4\30C6\30E0\3067\30EC\30F3\30C0\30EA\30F3\30B0\3059\308B\30DE\30FC\30AB\30FC\306E\5F62\72B6\3092\9078\629E\3057\307E\3059\3002<strong>\300C\81EA\52D5\300D</strong>\306E\307F\3001\7BC4\56F2\30B7\30EA\30FC\30BA\306B\30B5\30DD\30FC\30C8\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104162432263308577)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.AUTO.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104162510483308578)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.CIRCLE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5186')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104162628683308578)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.DIAMOND.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\3072\3057\5F62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104162786252308578)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.HUMAN.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\4EBA\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104162859730308578)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.PLUS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30E9\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104162982504308578)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.SQUARE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\56DB\89D2\5F62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104188174943308600)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.STAR.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\661F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104163017756308578)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.TRIANGLEDOWN.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0B\5411\304D\4E09\89D2\5F62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104163170591308578)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.TRIANGLEUP.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0A\5411\304D\4E09\89D2\5F62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104162206663308577)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5F62\72B6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104278286589308666)
,p_name=>'PE.PROPERTY.MASTER_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\5217\304C\30EA\30FC\30B8\30E7\30F3\8A2D\5B9A\306E<strong>\300C\30DE\30B9\30BF\30FC\30FB\30EA\30FC\30B8\30E7\30F3\300D</strong>\3067\6307\5B9A\3055\308C\3066\3044\308B\30DE\30B9\30BF\30FC\5BFE\8A71\30B0\30EA\30C3\30C9\30FB\30EA\30FC\30B8\30E7\30F3\306E\5916\90E8\30AD\30FC\5217\3067\3042\308B\5834\5408\3001\30DE\30B9\30BF\30FC\8868\304B\3089\5BFE\5FDC\3059\308B\4E3B\30AD\30FC\5217\3092\9078\629E\3057\307E\3059\3002</p>'),
unistr('        <p>\305F\3068\3048\3070\3001\30DE\30B9\30BF\30FC\30FB\30EA\30FC\30B8\30E7\30F3\304CDEPT\3067\3001\3053\306E\5BFE\8A71\30B0\30EA\30C3\30C9\304CEMP\3060\3063\305F\5834\5408\3001EMP\5BFE\8A71\30B0\30EA\30C3\30C9\5185\306EDEPTNO\5217\3092\9078\629E\3057\3066\304B\3089\3001\30DE\30B9\30BF\30FC\5217\306EDEPT\5217\306E\30EA\30B9\30C8\304B\3089DEPTNO\5217\3092\9078\629E\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104278182758308666)
,p_name=>'PE.PROPERTY.MASTER_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30B9\30BF\30FC\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104096029281308513)
,p_name=>'PE.PROPERTY.MASTER_REGION.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30C7\30A3\30C6\30FC\30EB\30FB\30EA\30FC\30B8\30E7\30F3\304C\5C5E\3059\308B\30DE\30B9\30BF\30FC\30FB\30EA\30FC\30B8\30E7\30F3\3092\9078\629E\3057\307E\3059\3002<br>'),
unistr('        \3053\306E\30DA\30FC\30B8\306E\5225\306E\30EA\30FC\30B8\30E7\30F3\3068\306E\30DE\30B9\30BF\30FC\30FB\30C7\30A3\30C6\30FC\30EB\95A2\4FC2\3067\3053\306E\30EA\30FC\30B8\30E7\30F3\304C\30C7\30A3\30C6\30FC\30EB\30FB\30EA\30FC\30B8\30E7\30F3\3067\3042\308B\5834\5408\3001\3053\308C\3092\8A2D\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>'),
unistr('        <p>\30DE\30B9\30BF\30FC\30FB\30C7\30A3\30C6\30FC\30EB\95A2\4FC2\3092\6B63\5E38\306B\6A5F\80FD\3055\305B\308B\306B\306F\3001\30DE\30B9\30BF\30FC\30FB\30EA\30FC\30B8\30E7\30F3\306E\5916\90E8\30AD\30FC\3067\3042\308B\3053\306E\30EA\30FC\30B8\30E7\30F3\306E\5217\3092\9078\629E\3057\3066\3001<strong>\30DE\30B9\30BF\30FC\5217</strong>\3092\9069\5B9C\6307\5B9A\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104095979106308513)
,p_name=>'PE.PROPERTY.MASTER_REGION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30B9\30BF\30FC\30FB\30EA\30FC\30B8\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104207948938308615)
,p_name=>'PE.PROPERTY.MAXIMUM_ROWS_PER_PAGE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\3054\3068\306E\884C\6570\30BB\30EC\30AF\30BF\306B\8868\793A\3059\308B\6700\5927\884C\6570\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104207832961308615)
,p_name=>'PE.PROPERTY.MAXIMUM_ROWS_PER_PAGE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\3054\3068\306E\6700\5927\884C\6570')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104539440617308867)
,p_name=>'PE.PROPERTY.MAXIMUM_ROW_COUNT.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30EC\30A4\30E4\30FC\3067\51E6\7406\3067\304D\308B\884C\306E\6700\5927\6570\3092\5165\529B\3057\307E\3059\3002\3053\308C\306F\3001\30C0\30A6\30F3\30ED\30FC\30C9\3055\308C\3066\30DE\30C3\30D7\306B\8868\793A\3055\308C\308B\7A7A\9593\30AA\30D6\30B8\30A7\30AF\30C8\304C\591A\3059\304E\308B\5834\5408\306B\5BFE\5FDC\3059\308B\624B\6BB5\3068\3057\3066\4F7F\7528\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104207116499308615)
,p_name=>'PE.PROPERTY.MAXIMUM_ROW_COUNT.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\554F\5408\305B\3067\51E6\7406\3067\304D\308B\6700\5927\884C\6570\3092\5165\529B\3057\307E\3059\3002\51E6\7406\3059\308B\6700\5927\884C\6570\304C\5236\9650\3092\8D85\3048\308B\3068\3001\30C7\30FC\30BF\306E\304B\308F\308A\306B\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\304C\8868\793A\3055\308C\307E\3059\3002'),
unistr('\30AB\30B9\30BF\30E0\30FB\30E1\30C3\30BB\30FC\30B8\3092\5B9A\7FA9\3059\308B\306B\306F\3001<strong>\300C\30C7\30FC\30BF\304C\3055\3089\306B\898B\3064\304B\3063\305F\5834\5408\300D</strong>\306B\30E1\30C3\30BB\30FC\30B8\3092\6307\5B9A\3057\307E\3059\3002</p>'),
unistr('<p>\3053\306E\5C5E\6027\306F\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\30BD\30FC\30C8\3084\96C6\8A08\306A\3069\306E\30A2\30AF\30B7\30E7\30F3\3092\975E\5E38\306B\5927\898F\6A21\306A\8868\307E\305F\306F\30D3\30E5\30FC\306E\3059\3079\3066\306E\30EC\30B3\30FC\30C9\306B\5BFE\3057\3066\5B9F\884C\3057\3001\30D1\30D5\30A9\30FC\30DE\30F3\30B9\304C\4F4E\4E0B\3059\308B\3053\3068\3092\4E88\9632\3057\307E\3059\3002'),
unistr('\304B\308F\308A\306B\3001\8FFD\52A0\306E\30D5\30A3\30EB\30BF\3092\8A2D\5B9A\3057\3066\3001\51E6\7406\3059\308B\30EC\30B3\30FC\30C9\306E\6570\3092\6700\521D\306B\6E1B\3089\3057\3066\304A\304F\5FC5\8981\304C\3042\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104207061683308615)
,p_name=>'PE.PROPERTY.MAXIMUM_ROW_COUNT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\51E6\7406\3059\308B\6700\5927\884C\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104573578582308898)
,p_name=>'PE.PROPERTY.MEDIA_ADV_FORMATTING.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\3092\3001\5217\307E\305F\306FHTML\5F0F\304A\3088\3073\30B5\30DD\30FC\30C8\3055\308C\3066\3044\308B\7F6E\63DB\6587\5B57\5217\3092\4F7F\7528\3059\308B\62E1\5F35\30D5\30A9\30FC\30DE\30C3\30C8\306E\3044\305A\308C\3092\4F7F\7528\3057\3066\8868\793A\3059\308B\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104573493297308897)
,p_name=>'PE.PROPERTY.MEDIA_ADV_FORMATTING.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\62E1\5F35\30D5\30A9\30FC\30DE\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104581300976308904)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.COMPONENT_PROPERTY.CARD.NULL_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104575920344308899)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30E1\30C7\30A3\30A2\306E\7E26\6A2A\6BD4\3092\6C7A\5B9A\3057\307E\3059\3002'),
unistr('<strong>\81EA\52D5</strong> \5143\306E\30E1\30C7\30A3\30A2\30FB\30B5\30A4\30BA\3092\4FDD\6301\3059\308B\305F\3081\306E\6700\9069\306A\5024\3092\4F7F\7528\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104576098029308900)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.LOV.SQUARE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\56DB\89D2\5F62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104576161212308900)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.LOV.SQUARE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B63\65B9\5F62\306E\7E26\6A2A\6BD4\3092\9069\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104576268590308900)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.LOV.WIDESCREEN.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30A4\30C9\30B9\30AF\30EA\30FC\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104576324850308900)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.LOV.WIDESCREEN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30A4\30C9\30B9\30AF\30EA\30FC\30F3\306E\7E26\6A2A\6BD4\3092\9069\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104575863148308899)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5916\89B3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104574927363308899)
,p_name=>'PE.PROPERTY.MEDIA_BLOB_COLUMN_NAME.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E1\30C7\30A3\30A2\30FB\30BD\30FC\30B9\306EBLOB\3092\8FD4\3059\5217\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104574888251308898)
,p_name=>'PE.PROPERTY.MEDIA_BLOB_COLUMN_NAME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('BLOB\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104577143148308900)
,p_name=>'PE.PROPERTY.MEDIA_CSS_CLASSES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\8FFD\52A0\3059\308B\30AF\30E9\30B9\3092\5165\529B\3057\307E\3059\3002\8907\6570\306E\30AF\30E9\30B9\306F\7A7A\767D\3067\533A\5207\3063\3066\8FFD\52A0\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104577056291308900)
,p_name=>'PE.PROPERTY.MEDIA_CSS_CLASSES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('CSS\30AF\30E9\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104577384679308901)
,p_name=>'PE.PROPERTY.MEDIA_DESCRIPTION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30C6\30AD\30B9\30C8\306F\3001\30E1\30C7\30A3\30A2\306B\3064\3044\3066\8AAC\660E\3057\3001\30A4\30E1\30FC\30B8\306E\30C4\30FC\30EB\30C1\30C3\30D7\304A\3088\3073\4EE3\66FF\30C6\30AD\30B9\30C8\3068\3057\3066\4F7F\7528\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104577298020308900)
,p_name=>'PE.PROPERTY.MEDIA_DESCRIPTION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30E1\30FC\30B8\306E\8AAC\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104575188511308899)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30FC\30C9\4E0A\3067\30E1\30C7\30A3\30A2\30FB\30B3\30F3\30DD\30FC\30CD\30F3\30C8\3092\914D\7F6E\3059\308B\5834\6240\3092\6C7A\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104575604635308899)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.BACKGROUND.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D0\30C3\30AF\30B0\30E9\30A6\30F3\30C9\30FB\30A4\30E1\30FC\30B8\3068\3057\3066')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104575776365308899)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.BACKGROUND.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30FC\30C9\306E\30D0\30C3\30AF\30B0\30E9\30A6\30F3\30C9\3068\3057\3066\30E1\30C7\30A3\30A2\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104575446152308899)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.BODY.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104575596633308899)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.BODY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30FC\30C9\672C\4F53\5185\306B\30E1\30C7\30A3\30A2\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104575292229308899)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.FIRST.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\521D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104575327745308899)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.FIRST.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30FC\30C9\30FB\30D8\30C3\30C0\30FC\306E\524D\306B\30E1\30C7\30A3\30A2\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104575013027308899)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104573854978308898)
,p_name=>'PE.PROPERTY.MEDIA_HTML_EXPR.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>\30D0\30C3\30AF\30B0\30E9\30A6\30F3\30C9\304A\3088\3073\30C6\30AD\30B9\30C8\306E\8272\306E\5909\66F4</dt>'),
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>\30D8\30C3\30C0\30FC2\306E\4F7F\7528</dt>'),
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>SQL\554F\5408\305B\304B\3089\306E\52D5\7684\30AF\30E9\30B9\306E\4F7F\7528</dt>'),
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    \3053\306E\4F8B\3067<code>&COLUMN_CLASS.</code>\3068<code>&EMPLOYEE_STATUS.</code>\306B\4EE3\5165\3055\308C\308B\306E\306F\3001\30EC\30DD\30FC\30C8SQL\554F\5408\305B\3067\9078\629E\3055\308C\305F\5217\3067\3059\3002</dd>'),
unistr('  <dt>\30DB\30D0\30FC\3067\306E\30A4\30E1\30FC\30B8\304A\3088\3073\30C4\30FC\30EB\30C1\30C3\30D7\306E\8868\793A</dt>'),
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104573773188308898)
,p_name=>'PE.PROPERTY.MEDIA_HTML_EXPR.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\5217\306B\8868\793A\3055\308C\308BHTML\5F0F\3092\5165\529B\3057\307E\3059\3002<code>&COLUMN.</code>\69CB\6587\3092\4F7F\7528\3057\3066\3001HTML\306B\5217\5024\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104573613209308898)
,p_name=>'PE.PROPERTY.MEDIA_HTML_EXPR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('HTML\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104576565071308900)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E1\30C7\30A3\30A2\30FB\30B3\30F3\30DD\30FC\30CD\30F3\30C8\5185\3067\30E1\30C7\30A3\30A2\306E\30B5\30A4\30BA\3092\6C7A\5B9A\3059\308B\65B9\6CD5\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104576882114308900)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.LOV.COVER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30D0\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104576929723308900)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.LOV.COVER.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E1\30C7\30A3\30A2\304C\30E1\30C7\30A3\30A2\8868\793A\9818\57DF\5168\4F53\3092\8986\3046\3088\3046\306B\30B5\30A4\30BA\3092\8ABF\6574\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104576675954308900)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.LOV.FIT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\9069\5408')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104576747390308900)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.LOV.FIT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E1\30C7\30A3\30A2\304C\30E1\30C7\30A3\30A2\8868\793A\9818\57DF\5185\306B\53CE\307E\308B\3088\3046\306B\30B5\30A4\30BA\3092\8ABF\6574\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104576417552308900)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30A4\30BA\6307\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104581294165308904)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.COMPONENT_PROPERTY.CARD.NULL_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E1\30C7\30A3\30A2\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104574038772308898)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E1\30C7\30A3\30A2\30FB\30BD\30FC\30B9\30FB\30BF\30A4\30D7\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104574348839308898)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.LOV.BLOB.D'
,p_message_language=>'ja'
,p_message_text=>unistr('BLOB\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104574269708308898)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.LOV.DYNAMIC_URL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('URL\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104574178254308898)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.LOV.STATIC_URL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30E1\30FC\30B8URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104573997856308898)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BD\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103871647182308302)
,p_name=>'PE.PROPERTY.MEDIA_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30A4\30F3\30BF\30FC\30CD\30C3\30C8\30FB\30E1\30C7\30A3\30A2\30FB\30BF\30A4\30D7\3092\5165\529B\3057\307E\3059\3002\30A4\30F3\30BF\30FC\30CD\30C3\30C8\30FB\30E1\30C7\30A3\30A2\30FB\30BF\30A4\30D7\306F\30012\3064\306E\90E8\5206\3067\69CB\6210\3055\308C\308B\3001\30A4\30F3\30BF\30FC\30CD\30C3\30C8\4E0A\306E\30D5\30A1\30A4\30EB\5F62\5F0F\3092\8868\3059\8B58\5225\5B50\3067\3059\3002'),
unistr('\30E1\30C7\30A3\30A2\30FB\30BF\30A4\30D7\306F\3001\5C11\306A\304F\3068\3082\30BF\30A4\30D7\3068\30B5\30D6\30BF\30A4\30D7\306E2\3064\306E\90E8\5206\3067\69CB\6210\3055\308C\3001\30AA\30D7\30B7\30E7\30F3\30671\3064\4EE5\4E0A\306E\30D1\30E9\30E1\30FC\30BF\3092\6307\5B9A\3057\307E\3059\3002'),
unistr('\3053\306E\30E1\30C7\30A3\30A2\30FB\30BF\30A4\30D7\306F\3001\30DA\30FC\30B8\306E\30EC\30F3\30C0\30EA\30F3\30B0\306E\969B\306BHTTP\30D8\30C3\30C0\30FC\306EContent-Type\3067\4F7F\7528\3055\308C\307E\3059\3002</p>'),
unistr('<p>\30DA\30FC\30B8\30FB\30EC\30D9\30EB\306E\30E1\30C7\30A3\30A2\30FB\30BF\30A4\30D7\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30EC\30D9\30EB\306E\30E1\30C7\30A3\30A2\30FB\30BF\30A4\30D7\3092\30AA\30FC\30D0\30FC\30E9\30A4\30C9\3057\307E\3059\3002'),
unistr('\30DA\30FC\30B8\30FB\30EC\30D9\30EB\3068\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30EC\30D9\30EB\306E\4E21\65B9\3067\30E1\30C7\30A3\30A2\30FB\30BF\30A4\30D7\306E\5024\304C<code>NULL</code>\306E\5834\5408\3001\30E1\30C7\30A3\30A2\30FB\30BF\30A4\30D7\3068\3057\3066<code>text/html</code>\304C\4F7F\7528\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103871513307308302)
,p_name=>'PE.PROPERTY.MEDIA_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E1\30C7\30A3\30A2\30FB\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104574575001308898)
,p_name=>'PE.PROPERTY.MEDIA_URL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E1\30C7\30A3\30A2\30FB\30BD\30FC\30B9\306EURL\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104574435435308898)
,p_name=>'PE.PROPERTY.MEDIA_URL.PROMPT'
,p_message_language=>'ja'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104574711763308898)
,p_name=>'PE.PROPERTY.MEDIA_URL_COLUMN_NAME.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E1\30C7\30A3\30A2\30FB\30BD\30FC\30B9\3068\3057\3066\4F7F\7528\3059\308B\5217\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104574673500308898)
,p_name=>'PE.PROPERTY.MEDIA_URL_COLUMN_NAME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('URL\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104167767339308582)
,p_name=>'PE.PROPERTY.MINOR_STEP.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\88DC\52A9\76EE\76DB\9593\306E\5897\5206\3092\5165\529B\3057\307E\3059\3002\30C7\30FC\30BF\306B\57FA\3065\304F\81EA\52D5\8A08\7B97\306E\30C7\30D5\30A9\30EB\30C8\5024\306Fnull\3067\3059\3002\6570\5024\8EF8\306B\306E\307F\9069\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104167607917308582)
,p_name=>'PE.PROPERTY.MINOR_STEP.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30C6\30C3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104167520036308582)
,p_name=>'PE.PROPERTY.MINOR_TICK_RENDERED.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\88DC\52A9\76EE\76DB\3092\30EC\30F3\30C0\30EA\30F3\30B0\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104167432937308581)
,p_name=>'PE.PROPERTY.MINOR_TICK_RENDERED.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104167394045308581)
,p_name=>'PE.PROPERTY.MIN_STEP.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E3B\8981\76EE\76DB\9593\306E\6700\5C0F\5897\5206\3092\5165\529B\3057\307E\3059\3002\500B\5225\306E\30E1\30B8\30E3\30FC\306E\5C0F\6570\306E\8EF8\5024\3092\9632\3050\305F\3081\306B\3053\308C\304C\901A\5E38\4F7F\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104167207683308581)
,p_name=>'PE.PROPERTY.MIN_STEP.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5C0F\30B9\30C6\30C3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104587344656308908)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.APP_PROCESS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\767A\8005\304C\5BB9\6613\306B\8B58\5225\3067\304D\308B\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30D7\30ED\30BB\30B9\306E\540D\524D\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103968876635308412)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.AUTHENTICATION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\958B\767A\8005\306B\3088\3063\3066\3053\306E\8A8D\8A3C\30B9\30AD\30FC\30E0\306E\53C2\7167\306B\4F7F\7528\3055\308C\308B\540D\524D\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103908361694308334)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.AUTHORIZATION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\53EF\30B9\30AD\30FC\30E0\3092\793A\3059\4E00\610F\306E\540D\524D\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103982033692308422)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.BRANCH.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\767A\8005\304C\5BB9\6613\306B\8B58\5225\3067\304D\308B\3088\3046\306B\30D6\30E9\30F3\30C1\306E\540D\524D\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104018944024308450)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.BREADCRUMB_TEMPLATE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30D6\30EC\30C3\30C9\30AF\30E9\30E0\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306E\308F\304B\308A\3084\3059\3044\540D\524D\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103908282326308334)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.BUILD_OPTION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30D3\30EB\30C9\30FB\30AA\30D7\30B7\30E7\30F3\306E\540D\524D\3092\5165\529B\3057\307E\3059\3002\30D3\30EB\30C9\30FB\30AA\30D7\30B7\30E7\30F3\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5185\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\304C\6709\52B9\304B\3069\3046\304B\3092\6C7A\5B9A\3059\308B\4E8B\524D\5B9A\7FA9\3055\308C\305F\8A2D\5B9A\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104018618717308449)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.BUTTON_TEMPLATE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DC\30BF\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306E\308F\304B\308A\3084\3059\3044\540D\524D\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104019042117308450)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.CALENDAR_TEMPLATE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30AB\30EC\30F3\30C0\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306E\308F\304B\308A\3084\3059\3044\540D\524D\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103908979912308334)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.DYNAMIC_ACTION_EVENT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\52D5\7684\30A2\30AF\30B7\30E7\30F3\306E\540D\524D\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104018729846308450)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.FIELD_TEMPLATE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30A4\30C6\30E0\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306E\308F\304B\308A\3084\3059\3044\540D\524D\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104205138183308613)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.IR_COLUMN_GROUP.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\30B0\30EB\30FC\30D7\306E\540D\524D\3092\5165\529B\3057\307E\3059\3002\3053\306E\540D\524D\306F\3001\8A73\7D30\30D3\30E5\30FC\3067\30EA\30FC\30B8\30E7\30F3\30FB\30D8\30C3\30C0\30FC\3068\3057\3066\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104018895469308450)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.LIST_TEMPLATE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30EA\30B9\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306E\308F\304B\308A\3084\3059\3044\540D\524D\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104538938078308867)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306E\308F\304B\308A\3084\3059\3044\540D\524D\3092\5165\529B\3057\307E\3059\3002\30DE\30C3\30D7\30FB\30EA\30FC\30B8\30E7\30F3\3067\306E\30E9\30D9\30EB\8868\793A\306BHTML\307E\305F\306F\7F6E\63DB\304C\5FC5\8981\306A\5834\5408\306F\3001<strong>\300C\30E9\30D9\30EB\300D</strong>\5C5E\6027\3092\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103908472171308334)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.PAGE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8\306E\540D\524D\3092\5165\529B\3057\307E\3059\3002\3053\306E\540D\524D\306F\3001\591A\6570\306E&PRODUCT_NAME.\30DA\30FC\30B8\304A\3088\3073\30EC\30DD\30FC\30C8\3067\3001\30DA\30FC\30B8\756A\53F7\304A\3088\3073\30BF\30A4\30C8\30EB\3068\3068\3082\306B\4F7F\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103908732470308334)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.PAGE_GROUP.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30B0\30EB\30FC\30D7\306E\540D\524D\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103909594678308335)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.PAGE_PROCESS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\767A\8005\304C\5BB9\6613\306B\8B58\5225\3067\304D\308B\30DA\30FC\30B8\30FB\30D7\30ED\30BB\30B9\306E\540D\524D\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104018400551308449)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.PAGE_TEMPLATE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\7279\5B9A\306E\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306E\308F\304B\308A\3084\3059\3044\540D\524D\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104018543744308449)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.REGION_TEMPLATE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30EA\30FC\30B8\30E7\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306E\308F\304B\308A\3084\3059\3044\540D\524D\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104019141027308450)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.REPORT_TEMPLATE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30EC\30DD\30FC\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306E\308F\304B\308A\3084\3059\3044\540D\524D\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104018380432308449)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.THEME.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30C6\30FC\30DE\306E\308F\304B\308A\3084\3059\3044\77ED\3044\540D\524D\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104019269469308450)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.USER_INTERFACE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\306E\540D\524D\3092\5165\529B\3057\307E\3059\3002\540D\524D\306F\3001\30C6\30FC\30DE\306E\4F5C\6210\30A6\30A3\30B6\30FC\30C9\306A\3069\306E\30A6\30A3\30B6\30FC\30C9\306B\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103981719613308422)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.VALIDATION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C\306E\540D\524D\3092\5165\529B\3057\307E\3059\3002\3053\306E\540D\524D\306F\3001\30C1\30A7\30C3\30AF\3055\308C\308B\6761\4EF6\3092\958B\767A\8005\304C\7C21\5358\306B\8B58\5225\3067\304D\308B\3088\3046\306A\3082\306E\306B\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103868437141308300)
,p_name=>'PE.PROPERTY.NAME.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306E\308F\304B\308A\3084\3059\3044\540D\524D\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103868332142308299)
,p_name=>'PE.PROPERTY.NAME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\540D\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103883489923308310)
,p_name=>'PE.PROPERTY.NAMED_LOV.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E2\5B58\306ELOV\306E\540D\524D\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103883331122308310)
,p_name=>'PE.PROPERTY.NAMED_LOV.PROMPT'
,p_message_language=>'ja'
,p_message_text=>'LOV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104495358877308835)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30C3\30D7\4E0A\306E\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30D0\30FC\306E\4F4D\7F6E\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104495686644308835)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.LOV.END.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D42\4E86')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104495703289308835)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.LOV.END.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30C3\30D7\306E\7D42\4E86\4F4D\7F6E(\901A\5E38\306F\53F3\5074)\306B\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30D0\30FC\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104495402580308835)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.LOV.START.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104495530344308835)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.LOV.START.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30C3\30D7\306E\958B\59CB\4F4D\7F6E(\901A\5E38\306F\5DE6\5074)\306B\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30D0\30FC\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104495211913308834)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30D0\30FC\306E\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104494528837308834)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F7F\7528\3059\308B\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30D0\30FC\306E\30BF\30A4\30D7\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104495056982308834)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.FULL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BA\30FC\30E0\304A\3088\3073\30B3\30F3\30D1\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104495131625308834)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.FULL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30C3\30D7\306E\5411\304D\3092\5236\5FA1\3059\308B\30BA\30FC\30E0\30FB\30B3\30F3\30C8\30ED\30FC\30EB\304A\3088\3073\30B3\30F3\30D1\30B9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104494682510308834)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.NONE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104494788990308834)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.NONE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30D0\30FC\304C\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104494867322308834)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.SMALL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BA\30FC\30E0\306E\307F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104494976940308834)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.SMALL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BA\30FC\30E0\30FB\30A4\30F3\304A\3088\3073\30BA\30FC\30E0\30FB\30A2\30A6\30C8\306E\30B3\30F3\30C8\30ED\30FC\30EB\306E\307F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104494427508308834)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30D0\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104751579328309043)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC\30FB\30EA\30B9\30C8\3092\8868\793A\3057\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104008428361308442)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DA\30FC\30B8\306E\30CA\30D3\30B2\30FC\30B7\30E7\30F3\306B\4F7F\7528\3055\308C\308B\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC\30FB\30EA\30B9\30C8\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104008346603308441)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104751029577309043)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_POSITION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DA\30FC\30B8\306E\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC\30FB\30EA\30B9\30C8\306E\4F4D\7F6E\3092\9078\629E\3057\307E\3059\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104751250041309043)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_POSITION.LOV.SIDE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30A4\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104751161765309043)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_POSITION.LOV.TOP.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C8\30C3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104750927415309043)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_POSITION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8\306E\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104008683284308442)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_TEMPLATE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DA\30FC\30B8\306E\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC\306B\4F7F\7528\3055\308C\308B\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC\30FB\30EA\30B9\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104008585992308442)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_TEMPLATE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104751493098309043)
,p_name=>'PE.PROPERTY.NAV_LIST_TEMPLATE_OPTIONS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\3053\306E\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30EA\30B9\30C8\306E\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\3092\30AB\30B9\30BF\30DE\30A4\30BA\3059\308B\305F\3081\306E\30C6\30F3\30D7\30EC\30FC\30C8\30FB\30AA\30D7\30B7\30E7\30F3\3092\9078\629E\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104751373943309043)
,p_name=>'PE.PROPERTY.NAV_LIST_TEMPLATE_OPTIONS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8\30FB\30AA\30D7\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104564614817308890)
,p_name=>'PE.PROPERTY.NO_DATA_FOUND_ICON_CLASSES.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\53F3\5411\304D\306E\77E2\5370\306E\8868\793A</dt>'),
'<dd><pre>fa-chevron-right</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104564595989308890)
,p_name=>'PE.PROPERTY.NO_DATA_FOUND_ICON_CLASSES.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\8FFD\52A0\3059\308B\30A2\30A4\30B3\30F3\306E\30AF\30E9\30B9\3092\5165\529B\3057\307E\3059\3002\8907\6570\306E\30AF\30E9\30B9\306F\7A7A\767D\3067\533A\5207\3063\3066\8FFD\52A0\3067\304D\307E\3059\3002</p>'),
unistr('        <p>\30C6\30FC\30DE\3067\30D5\30A9\30F3\30C8APEX\3092\4F7F\7528\3059\308B\5834\5408\3001<a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\30E6\30CB\30D0\30FC\30B5\30EB\30FB\30C6\30FC\30DE\306E\30B5\30F3\30D7\30EB\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3</a>\3092\78BA\8A8D\3057\3066\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30B3\30F3\3068\4FEE\98FE\5B50\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104564450421308890)
,p_name=>'PE.PROPERTY.NO_DATA_FOUND_ICON_CLASSES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\30C7\30FC\30BF\304C\898B\3064\304B\308A\307E\305B\3093\300D\30A2\30A4\30B3\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104748799834309041)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.COMPONENT_PROPERTY.FACET.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30EA\30B9\30C8\306E\4E00\756A\4E0A\306B\3042\308B\30EA\30B9\30C8NULL\30AA\30D7\30B7\30E7\30F3\5185\306B\8868\793A\3059\308B\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104557198410308884)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.COMPONENT_PROPERTY.FACET_GROUP_ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30EA\30B9\30C8\306E\4E00\756A\4E0A\306B\3042\308B\30EA\30B9\30C8NULL\30AA\30D7\30B7\30E7\30F3\5185\306B\8868\793A\3059\308B\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103920279955308374)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30EA\30B9\30C8\306E\4E00\756A\4E0A\306B\3042\308B\30EA\30B9\30C8NULL\30AA\30D7\30B7\30E7\30F3\5185\306B\8868\793A\3059\308B\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103921595401308375)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.COMPONENT_PROPERTY.SFILTER_GROUP_ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30EA\30B9\30C8\306E\4E00\756A\4E0A\306B\3042\308B\30EA\30B9\30C8NULL\30AA\30D7\30B7\30E7\30F3\5185\306B\8868\793A\3059\308B\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103884048457308311)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30EA\30B9\30C8\306E\6700\4E0A\90E8\306E\30EA\30B9\30C8NULL\30AA\30D7\30B7\30E7\30F3\5185\306B\8868\793A\3055\308C\308B\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002\3053\306E\5024\306F\3001\5024\304Cnull\306E\5834\5408\306B\30A2\30A4\30C6\30E0\3092\30EC\30F3\30C0\30EA\30F3\30B0\3059\308B\969B\306B\3082\8868\793A\3055\308C\307E\3059\3002\30C6\30AD\30B9\30C8\3092\5165\529B\3057\306A\3044\5834\5408\3001\30EA\30B9\30C8\3067\306F\7A7A\767D\884C\3068\3057\3066\3001\30EC\30F3\30C0\30EA\30F3\30B0\6642\306F\7A7A\767D\30A2\30A4\30C6\30E0\3068\3057\3066\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103883948935308311)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('NULL\8868\793A\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103884261303308311)
,p_name=>'PE.PROPERTY.NULL_RETURN_VALUE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306ELOV\3067NULL\5024\304C\9078\629E\3055\308C\305F\5834\5408\306B\8FD4\3055\308C\308B\5024\3092\5165\529B\3057\307E\3059\3002\5024\3092\6307\5B9A\3057\306A\3044\5834\5408\3001\3053\306E\30EA\30B9\30C8\304B\3089NULL\30AA\30D7\30B7\30E7\30F3\304C\9078\629E\3055\308C\308B\3068\3001\30A2\30A4\30C6\30E0\5024\306Fnull\306E\307E\307E\306B\306A\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103884103697308311)
,p_name=>'PE.PROPERTY.NULL_RETURN_VALUE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('NULL\623B\308A\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104242423492308641)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\30FB\30DA\30FC\30B8\3054\3068\306B\8868\793A\3059\308B\30EC\30DD\30FC\30C8\884C\306E\6570\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104242317275308640)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104242641803308641)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\30FB\30DA\30FC\30B8\3054\3068\306B\8868\793A\3059\308B\30EC\30DD\30FC\30C8\884C\306E\6570\3092\6307\5B9A\3059\308B\5024\3092\542B\3080\30A2\30A4\30C6\30E0\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104242542296308641)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_ITEM.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104242235787308640)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30EC\30DD\30FC\30C8\306E\884C\6570\306E\5165\529B\65B9\6CD5\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104422593252308774)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_TYPE.LOV.ITEM.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\5024\306B\57FA\3065\304F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104422495045308774)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_TYPE.LOV.STATIC.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\9759\7684\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104242143316308640)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\6570\306E\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103879331523308308)
,p_name=>'PE.PROPERTY.ON_DUPLICATE_PAGE_SUBMISSIONS_GO_TO_THIS_URL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C2\56DE\76EE\306E\30DA\30FC\30B8\9001\4FE1\3092\8A66\307F\305F\3068\304D\306EURL\30BF\30FC\30B2\30C3\30C8\3092\5165\529B\3057\307E\3059\3002\30E6\30FC\30B6\30FC\304C\7D9A\884C\3067\304D\308B\3088\3046\306B\3059\308B\305F\3081\306B\3001&PRODUCT_NAME.\306B\3088\3063\3066\30A8\30E9\30FC\30E1\30C3\30BB\30FC\30B8\304A\3088\3073\3053\306EURL\3078\306E\30EA\30F3\30AF\304C\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103879253054308307)
,p_name=>'PE.PROPERTY.ON_DUPLICATE_PAGE_SUBMISSIONS_GO_TO_THIS_URL.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8907\88FD\30DA\30FC\30B8\306E\9001\4FE1\6642\306F\3001\3053\306EURL\306B\79FB\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104270631053308661)
,p_name=>'PE.PROPERTY.OPEN_LINK_IN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\307E\305F\306FURL\304C\73FE\5728\306E\30DA\30FC\30B8\3092\7F6E\304D\63DB\3048\308B\304B\3001\30C0\30A4\30A2\30ED\30B0\3067\958B\304F\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104429949361308780)
,p_name=>'PE.PROPERTY.OPEN_LINK_IN.LOV.P.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C0\30A4\30A2\30ED\30B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104429843619308779)
,p_name=>'PE.PROPERTY.OPEN_LINK_IN.LOV.W.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\540C\3058\30A6\30A3\30F3\30C9\30A6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104270580285308661)
,p_name=>'PE.PROPERTY.OPEN_LINK_IN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30F3\30AF\3092\6B21\306E\5834\6240\3067\958B\304F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104194440359308605)
,p_name=>'PE.PROPERTY.OPERATION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104083341173308503)
,p_name=>'PE.PROPERTY.OPTIMIZER_HINT.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\8868<code>employee</code>\306B\30A2\30AF\30BB\30B9\3059\308B\5834\5408\3001\7D22\5F15<code>emp_department_ix</code>\3092\4F7F\7528</dt>'),
'<dd><pre>INDEX (employees emp_department_ix)</pre></dd>',
unistr('<dt>SQL\554F\5408\305B\5185\3067<code>WITH plsql_declarations</code>\53E5\306E\4F7F\7528\3092\6709\52B9\5316</dt>'),
'<dd><pre>WITH_PLSQL</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104083295214308503)
,p_name=>'PE.PROPERTY.OPTIMIZER_HINT.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>SQL\554F\5408\305B\306E\5B9F\884C\6642\306B\6700\4E0A\4F4D\306E\6587\306B\8FFD\52A0\3055\308C\308BOracle\30AA\30D7\30C6\30A3\30DE\30A4\30B6\30FB\30D2\30F3\30C8\3092\5165\529B\3057\307E\3059\3002'),
unistr('        \30D2\30F3\30C8\3068\306F\3001\30AA\30D7\30C6\30A3\30DE\30A4\30B6\306B\5BFE\3059\308B\6307\793A\306E\3053\3068\3067\3059\3002SQL\306E\4F5C\6210\6642\306B\3001\30E6\30FC\30B6\30FC\306B\308F\304B\3063\3066\3044\308B\60C5\5831\304C\30AA\30D7\30C6\30A3\30DE\30A4\30B6\306B\8A8D\8B58\3055\308C\306A\3044\3053\3068\3082\3042\308A\307E\3059\3002\30D2\30F3\30C8\3092\4F7F\7528\3059\308B\3068\3001\901A\5E38\306F\30AA\30D7\30C6\30A3\30DE\30A4\30B6\306B\3088\308A\884C\308F\308C\308B\6C7A\5B9A\3092\30E6\30FC\30B6\30FC\304C\884C\3046\3053\3068\304C\3067\304D\307E\3059\3002'),
unistr('        \3053\308C\306B\3088\308A\3001\30B3\30B9\30C8\304C\9AD8\3044\3068\307F\306A\3055\308C\308B\8A08\753B\304C\30AA\30D7\30C6\30A3\30DE\30A4\30B6\306B\3088\308A\9078\629E\3055\308C\308B\5834\5408\3082\3042\308A\307E\3059\3002</p>'),
unistr('        <p>\305F\3068\3048\3070\3001\7279\5B9A\306E\554F\5408\305B\3067\7279\5B9A\306E\7D22\5F15\306E\9078\629E\6027\304C\9AD8\3044\3053\3068\304C\30E6\30FC\30B6\30FC\306B\308F\304B\3063\3066\3044\308B\5834\5408\3001\3053\306E\60C5\5831\306B\57FA\3065\3044\3066\3001\30AA\30D7\30C6\30A3\30DE\30A4\30B6\3088\308A\3082\52B9\7387\7684\306A\5B9F\884C\8A08\753B\3092\30E6\30FC\30B6\30FC\304C\9078\629E\3067\304D\307E\3059\3002'),
unistr('        \3053\306E\3088\3046\306A\5834\5408\3001\30D2\30F3\30C8\3092\4F7F\7528\3057\3066\3001\30AA\30D7\30C6\30A3\30DE\30A4\30B6\306B\6700\9069\306A\5B9F\884C\8A08\753B\3092\4F7F\7528\3059\308B\3088\3046\306B\5F37\5236\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104083161159308502)
,p_name=>'PE.PROPERTY.OPTIMIZER_HINT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30D7\30C6\30A3\30DE\30A4\30B6\30FB\30D2\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104755731168309047)
,p_name=>'PE.PROPERTY.ORACLE_TEXT_INDEX_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Oracle Text\7D22\5F15\306B\3088\3063\3066\7D22\5F15\4ED8\3051\3055\308C\3066\3044\308B\5217\3092\9078\629E\3057\307E\3059\3002</p>'),
unistr('<p>\884C\691C\7D22\306F\3001\5165\529B\3055\308C\305FOracle Text\6F14\7B97\5B50\306B\57FA\3065\3044\3066\7D50\679C\3092\8FD4\3057\307E\3059\3002\5BFE\5FDC\3059\308BOracle Text\7D22\5F15\304C\5217\306B\4F5C\6210\3055\308C\307E\3059\3002'),
unistr('\5FC5\8981\306A\7D22\5F15\304C\5B58\5728\3057\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304COracle Text\691C\7D22\6F14\7B97\5B50\306E\4F7F\7528\65B9\6CD5\3092\8A13\7DF4\3055\308C\3066\3044\308B\5834\5408\306E\307F\3001\3053\306E\30AA\30D7\30B7\30E7\30F3\3092\6709\52B9\306B\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002'),
unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\7528\306BOracle Text\69CB\6587\3092\7C21\7565\5316\3059\308B\305F\3081\3001\300C\5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8\300D\306E\5BFE\8A71\30B0\30EA\30C3\30C9\306E<em>\300COracle Text PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\540D\300D</em>\30B3\30F3\30DD\30FC\30CD\30F3\30C8\8A2D\5B9A\306B\30D5\30A1\30F3\30AF\30B7\30E7\30F3\3092\6307\5B9A\3067\304D\307E\3059\3002<br>'),
unistr('<a rel="noreferrer" target="_blank" href="https://docs.oracle.com/en/database/oracle/oracle-database/19/ccapp/index.html">\300EOracle Text\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\958B\767A\8005\30AC\30A4\30C9\300F</a>\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002</p>'),
unistr('<p>\30CE\30FC\30C8 - \30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304COracle Text\6F14\7B97\5B50\3092\6B63\3057\304F\5165\529B\3059\308B\3068\3001\901A\5E38\3001\691C\7D22\306E\52B9\7387\306F\5927\5E45\306B\5411\4E0A\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104755617093309047)
,p_name=>'PE.PROPERTY.ORACLE_TEXT_INDEX_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('Oracle Text\7D22\5F15\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104587089663308908)
,p_name=>'PE.PROPERTY.ORDS_CLEANUP_CODE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30EA\30FC\30F3\30A2\30C3\30D7\30FB\30B3\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104586954820308908)
,p_name=>'PE.PROPERTY.ORDS_INIT_CODE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\521D\671F\5316\30B3\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104145694207308554)
,p_name=>'PE.PROPERTY.ORIENTATION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30C1\30E3\30FC\30C8\306E\5411\304D\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104145777521308554)
,p_name=>'PE.PROPERTY.ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A2A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104276311441308665)
,p_name=>'PE.PROPERTY.ORIENTATION.LOV.HORIZONTAL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\6C34\5E73\306B\30C1\30E3\30FC\30C8\306E\30C7\30FC\30BF\30FB\30A2\30A4\30C6\30E0\3092\8868\793A\3057\307E\3059\3002\305F\3068\3048\3070\3001\68D2\30B0\30E9\30D5\306E\68D2\304C\6C34\5E73\306B\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104276106469308665)
,p_name=>'PE.PROPERTY.ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\7E26')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104276205882308665)
,p_name=>'PE.PROPERTY.ORIENTATION.LOV.VERTICAL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5782\76F4\306B\30C1\30E3\30FC\30C8\306E\30C7\30FC\30BF\30FB\30A2\30A4\30C6\30E0\3092\8868\793A\3057\307E\3059\3002\305F\3068\3048\3070\3001\68D2\30B0\30E9\30D5\306E\68D2\304C\5782\76F4\306B\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104145589441308554)
,p_name=>'PE.PROPERTY.ORIENTATION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5411\304D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104155591453308571)
,p_name=>'PE.PROPERTY.OVERVIEW_HEIGHT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\3067\30EC\30F3\30C0\30EA\30F3\30B0\3059\308B\6982\8981\30B9\30AF\30ED\30FC\30EB\30D0\30FC\306E\9AD8\3055\3092\30D4\30AF\30BB\30EB(\305F\3068\3048\3070\300150px\306A\3069)\307E\305F\306F\30D1\30FC\30BB\30F3\30C8(\305F\3068\3048\3070\300115%\306A\3069)\5358\4F4D\3067\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104155436420308571)
,p_name=>'PE.PROPERTY.OVERVIEW_HEIGHT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\9AD8\3055')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104155377561308571)
,p_name=>'PE.PROPERTY.OVERVIEW_RENDERED.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6982\8981\30B9\30AF\30ED\30FC\30EB\30D0\30FC\3092\30C1\30E3\30FC\30C8\306B\30EC\30F3\30C0\30EA\30F3\30B0\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002'),
unistr('        \73FE\5728\3001\3053\306E\30AA\30D7\30B7\30E7\30F3\306F\3001\5782\76F4\68D2\30B0\30E9\30D5\3001\6298\308C\7DDA\30B0\30E9\30D5\3001\9762\30B0\30E9\30D5\3001\9762\4ED8\304D\6298\308C\7DDA\30B0\30E9\30D5\3001\682A\4FA1\30C1\30E3\30FC\30C8\304A\3088\3073\7D44\5408\305B\30C1\30E3\30FC\30C8\3067\306E\307F\30B5\30DD\30FC\30C8\3055\308C\3066\3044\307E\3059\3002</p>'),
unistr('        <p>\6CE8\610F - \6982\8981\30B9\30AF\30ED\30FC\30EB\30D0\30FC\3092\8868\793A\3059\308B\306B\306F\3001<strong>\300C\30BA\30FC\30E0\3068\30B9\30AF\30ED\30FC\30EB\300D</strong>\30AA\30D7\30B7\30E7\30F3\3092\6709\52B9\306B\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104155275976308570)
,p_name=>'PE.PROPERTY.OVERVIEW_RENDERED.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104008292463308441)
,p_name=>'PE.PROPERTY.OVERWRITE_NAVIGATION_LIST.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\306E\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\30FB\30EC\30D9\30EB\306E\30CA\30D3\30B2\30FC\30B7\30E7\30F3\3092\4E0A\66F8\304D\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002\3053\308C\306F\3001\73FE\5728\306E\30DA\30FC\30B8\306B\30CA\30D3\30B2\30FC\30B7\30E7\30F3\304C\306A\3044\5834\5408\3084\3001\73FE\5728\306E\30DA\30FC\30B8\306B\4EE3\66FF\30CA\30D3\30B2\30FC\30B7\30E7\30F3\3092\9078\629E\3059\308B\5834\5408(\305F\3068\3048\3070\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30B5\30D6\30BB\30AF\30B7\30E7\30F3\306B\3064\3044\3066\7570\306A\308B\30CA\30D3\30B2\30FC\30B7\30E7\30F3\3092\6307\5B9A\3059\308B\5834\5408)\306B\4F7F\7528\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104008157576308441)
,p_name=>'PE.PROPERTY.OVERWRITE_NAVIGATION_LIST.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\30FB\30EC\30D9\30EB\306E\30AA\30FC\30D0\30FC\30E9\30A4\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103878996006308307)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DA\30FC\30B8\306B\5B9F\88C5\3055\308C\308B\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\4FDD\8B77\306E\30BF\30A4\30D7\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104380162130308741)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.C.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5F15\6570\306B\30C1\30A7\30C3\30AF\30B5\30E0\304C\5FC5\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104380209470308742)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.C.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30EA\30AF\30A8\30B9\30C8\3001\30AD\30E3\30C3\30B7\30E5\306E\30AF\30EA\30A2\307E\305F\306F\540D\524D/\5024\306E\30DA\30A2\306E\5F15\6570\304CURL\306B\542B\307E\308C\3066\3044\308B\5834\5408\3001\30C1\30A7\30C3\30AF\30B5\30E0\3082\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002<br>'),
unistr('\30C1\30A7\30C3\30AF\30B5\30E0\30FB\30BF\30A4\30D7\306F\3001\5F15\6570\3068\3057\3066\6E21\3055\308C\308B\3059\3079\3066\306E\30A2\30A4\30C6\30E0\306E\6700\3082\53B3\3057\3044<em>\300C\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\4FDD\8B77\300D</em>\5C5E\6027\306B\5BFE\5FDC\3057\3066\3044\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104380509535308742)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.D.D'
,p_message_language=>'ja'
,p_message_text=>unistr('URL\30A2\30AF\30BB\30B9\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104380636882308742)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.D.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30DA\30FC\30B8\306F\3001URL\3092\4F7F\7528\3057\3066\30A2\30AF\30BB\30B9\3067\304D\307E\305B\3093\3002<br>'),
unistr('\305F\3060\3057\3001URL\30EA\30C0\30A4\30EC\30AF\30C8\304C\884C\308F\308C\306A\3044\305F\3081\3001\30DA\30FC\30B8\3092<em>\300C\30DA\30FC\30B8\306B\30D6\30E9\30F3\30C1\300D</em>\30D6\30E9\30F3\30C1\30FB\30BF\30A4\30D7\306E\30BF\30FC\30B2\30C3\30C8\306B\3067\304D\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104379972431308741)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.N.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5236\9650\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104380001720308741)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.N.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306F\3001\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\5F15\6570\304C\3042\308B\5834\5408\307E\305F\306F\306A\3044\5834\5408\3001\30C1\30A7\30C3\30AF\30B5\30E0\304C\5FC5\8981\306A\3044\5834\5408\3001URL\3092\4F7F\7528\3057\3066\30EA\30AF\30A8\30B9\30C8\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104380304456308742)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.U.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5F15\6570\3092\30B5\30DD\30FC\30C8\3057\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104380488020308742)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.U.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('URL\3092\4F7F\7528\3057\3066\30DA\30FC\30B8\3092\30EA\30AF\30A8\30B9\30C8\3067\304D\307E\3059\304C\3001URL\306B\30EA\30AF\30A8\30B9\30C8\3001\30AD\30E3\30C3\30B7\30E5\306E\30AF\30EA\30A2\307E\305F\306F\540D\524D/\5024\306E\30DA\30A2\306E\5F15\6570\3092\542B\3081\308B\3053\3068\306F\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103878875622308307)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30A2\30AF\30BB\30B9\4FDD\8B77')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103869867480308301)
,p_name=>'PE.PROPERTY.PAGE_ALIAS.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\3053\306E\30DA\30FC\30B8\306E\5225\540D\3092\82F1\6570\5B57\3067\5165\529B\3057\307E\3059\3002\30DA\30FC\30B8\3092\53C2\7167\3059\308B\305F\3081\306B\3001\30DA\30FC\30B8\756A\53F7\3067\306F\306A\304F\3001\3053\306E\5225\540D\3092\4F7F\7528\3067\304D\307E\3059\3002'),
unistr('\305F\3068\3048\3070\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3100\306E\30DA\30FC\30B81\3067\4F5C\696D\3057\3066\3044\308B\5834\5408\3001\5225\540D<code>home</code>\3092\4F5C\6210\3067\304D\307E\3059\3002'),
unistr('\305D\306E\5F8C\3001\6B21\306Ef?p\69CB\6587\3092\4F7F\7528\3057\3066\4ED6\306E\30DA\30FC\30B8\304B\3089\3053\306E\30DA\30FC\30B8\306B\30A2\30AF\30BB\30B9\3067\304D\307E\3059\3002'),
'<pre>f?p=100:home</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103869770265308300)
,p_name=>'PE.PROPERTY.PAGE_ALIAS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306E\5225\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103878580817308307)
,p_name=>'PE.PROPERTY.PAGE_AUTHENTICATION.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\3053\306E\30DA\30FC\30B8\304C\30D1\30D6\30EA\30C3\30AF\304B\3001\307E\305F\306F\8A8D\8A3C\304C\5FC5\8981\304B\3092\6307\5B9A\3057\307E\3059\3002'),
unistr('\30DA\30FC\30B8\304C\30D1\30D6\30EA\30C3\30AF\3068\8B58\5225\3055\308C\308B\5834\5408\3001\30DA\30FC\30B8\306B\30A2\30AF\30BB\30B9\3057\305F\3069\306E\30E6\30FC\30B6\30FC\3082\30DA\30FC\30B8\3092\8868\793A\3067\304D\307E\3059\3002'),
unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30DA\30FC\30B8\76E3\8996\30D5\30A1\30F3\30AF\30B7\30E7\30F3\306F\3001\3053\306E\30DA\30FC\30B8\5C5E\6027\306B\30A2\30AF\30BB\30B9\3057\3066\3001\8868\793A\524D\306B\4E8B\524D\8A8D\8A3C\304C\4E0D\8981\306A\30DA\30FC\30B8\3092\8B58\5225\3067\304D\307E\3059\3002'),
unistr('\8A8D\8A3C\30B9\30AD\30FC\30E0\306E\30DA\30FC\30B8\76E3\8996\30D5\30A1\30F3\30AF\30B7\30E7\30F3\306E\5B9F\88C5\306B\3088\3063\3066\3001\3053\306E\5C5E\6027\306E\52B9\679C\304C\6C7A\307E\308A\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104379395994308741)
,p_name=>'PE.PROPERTY.PAGE_AUTHENTICATION.LOV.N.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\304C\5FC5\8981\306A\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104379471880308741)
,p_name=>'PE.PROPERTY.PAGE_AUTHENTICATION.LOV.Y.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30D6\30EA\30C3\30AF\30FB\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103878402525308307)
,p_name=>'PE.PROPERTY.PAGE_AUTHENTICATION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103870079660308301)
,p_name=>'PE.PROPERTY.PAGE_GROUP.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\3053\306E\30DA\30FC\30B8\306B\95A2\9023\4ED8\3051\308B\30DA\30FC\30B8\30FB\30B0\30EB\30FC\30D7\3092\6307\5B9A\3057\307E\3059\3002'),
unistr('\30DA\30FC\30B8\30FB\30B0\30EB\30FC\30D7\306F\6A5F\80FD\306B\5F71\97FF\3057\307E\305B\3093\304C\3001\958B\767A\8005\304C\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5185\306E\30DA\30FC\30B8\3092\7BA1\7406\3059\308B\969B\306B\5F79\7ACB\3061\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103869926427308301)
,p_name=>'PE.PROPERTY.PAGE_GROUP.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30B0\30EB\30FC\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103877599711308306)
,p_name=>'PE.PROPERTY.PAGE_HTML_BODY_ATTRIBUTE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306E<code>#ONLOAD#</code>\7F6E\63DB\6587\5B57\5217\3068\7F6E\63DB\3059\308B\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002'),
unistr('\3053\306E\6A5F\80FD\3092\4F7F\7528\3059\308B\306B\306F\3001\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306B<code>#ONLOAD#</code>\7F6E\63DB\6587\5B57\5217\304C\542B\307E\308C\3066\3044\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103877434332308306)
,p_name=>'PE.PROPERTY.PAGE_HTML_BODY_ATTRIBUTE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306EHTML\30DC\30C7\30A3\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103870229459308301)
,p_name=>'PE.PROPERTY.PAGE_MODE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30DA\30FC\30B8\306E\30DA\30FC\30B8\30FB\30E2\30FC\30C9\3092\9078\629E\3057\307E\3059\3002</p>'),
'#LOV_VALUES#',
unistr('<p>\30AA\30D7\30B7\30E7\30F3<em>\300C\30E2\30FC\30C0\30EB\300D</em>\304A\3088\3073<em>\300C\975E\30E2\30FC\30C0\30EB\30FB\30C0\30A4\30A2\30ED\30B0\300D</em>\306F\3001\73FE\5728\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30C6\30FC\30DE\306B\30C7\30D5\30A9\30EB\30C8\306E<em>\30C0\30A4\30A2\30ED\30B0\30FB\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8</em>\304C\542B\307E\308C\3066\3044\308B\5834\5408\306B\306E\307F\9078\629E\3067\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104378432471308740)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.MODAL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E2\30FC\30C0\30EB\30FB\30C0\30A4\30A2\30ED\30B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104378563415308740)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.MODAL.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30DA\30FC\30B8\306F\30E2\30FC\30C0\30EB\30FB\30C0\30A4\30A2\30ED\30B0\3068\3057\3066\8868\793A\3055\308C\307E\3059\3002<br>'),
unistr('\30E2\30FC\30C0\30EB\30FB\30C0\30A4\30A2\30ED\30B0\306F\30D3\30E5\30FC\30DD\30FC\30C8\5185\306B\914D\7F6E\3055\308C\305F\30AA\30FC\30D0\30FC\30EC\30A4\30FB\30A6\30A3\30F3\30C9\30A6\3067\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\7D42\4E86\3059\308B(\9589\3058\308B)\307E\3067\30A2\30AF\30C6\30A3\30D6\3067\30D5\30A9\30FC\30AB\30B9\3055\308C\305F\307E\307E\3067\3059\3002'),
unistr('\57FA\306B\306A\308B\30DA\30FC\30B8\306F\30B0\30EC\30FC\30A2\30A6\30C8\3055\308C\3001\30C0\30A4\30A2\30ED\30B0\3092\9589\3058\308B\307E\3067\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\30DA\30FC\30B8\306E\6B8B\308A\3068\5BFE\8A71\3067\304D\307E\305B\3093\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104378699986308740)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.NON_MODAL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\975E\30E2\30FC\30C0\30EB\30FB\30C0\30A4\30A2\30ED\30B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104378790062308740)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.NON_MODAL.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30DA\30FC\30B8\306F\975E\30E2\30FC\30C0\30EB\30FB\30C0\30A4\30A2\30ED\30B0\3068\3057\3066\8868\793A\3055\308C\307E\3059\3002<br>'),
unistr('\975E\30E2\30FC\30C0\30EB\306F\30D3\30E5\30FC\30DD\30FC\30C8\5185\306B\914D\7F6E\3055\308C\308B\30AA\30FC\30D0\30FC\30EC\30A4\30FB\30A6\30A3\30F3\30C9\30A6\3067\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\30C0\30A4\30A2\30ED\30B0\304A\3088\3073\30C0\30A4\30A2\30ED\30B0\3092\8D77\52D5\3057\305F\30DA\30FC\30B8\306E\30B3\30F3\30C6\30F3\30C4\3068\5BFE\8A71\3067\304D\307E\3059\3002'),
unistr('\975E\30E2\30FC\30C0\30EB\30FB\30C0\30A4\30A2\30ED\30B0\306F\3001\30EA\30AF\30A8\30B9\30C8\3057\305F\60C5\5831\304C\7D9A\884C\3059\308B\305F\3081\306B\5FC5\9808\3067\306A\3044\5834\5408\306B\4F7F\7528\3055\308C\3001\30A6\30A3\30F3\30C9\30A6\304C\958B\3044\3066\3044\308B\9593\3082\5225\306E\5834\6240\3067\4F5C\696D\3092\7D9A\3051\3089\308C\307E\3059\3002')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104378232223308740)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.NORMAL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A19\6E96')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104378374729308740)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.NORMAL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306F\6A19\6E96&PRODUCT_NAME.\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30DA\30FC\30B8\3068\3057\3066\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103870123378308301)
,p_name=>'PE.PROPERTY.PAGE_MODE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30E2\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104719731963309016)
,p_name=>'PE.PROPERTY.PAGE_NAVIGATION_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104078756185308499)
,p_name=>'PE.PROPERTY.PAGE_PROCESS_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5B9F\884C\3055\308C\308B\30D7\30ED\30BB\30B9\30FB\30BF\30A4\30D7\3092\6307\5B9A\3057\307E\3059\3002\6B21\306E\30D7\30ED\30BB\30B9\30FB\30BF\30A4\30D7\304C\30B5\30DD\30FC\30C8\3055\308C\3066\3044\307E\3059:</p>'),
'#NATIVE_PLUGINS#',
unistr('<p>\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\69CB\6210\306B\3088\3063\3066\306F\3001\305D\306E\4ED6\306E\30D7\30ED\30BB\30B9\30FB\30BF\30A4\30D7\30FB\30D7\30E9\30B0\30A4\30F3\3082\3053\3053\3067\4F7F\7528\53EF\80FD\306A\5834\5408\304C\3042\308A\307E\3059\3002'),
unistr('\3053\308C\3089\306F\3001<em>&lt;My Plug-in&gt; [Plug-in]</em>\3068\8868\793A\3055\308C\307E\3059\3002'),
unistr('\6B21\306E\30D7\30E9\30B0\30A4\30F3\304C\3001\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8\5185\306B\30A4\30F3\30B9\30C8\30FC\30EB\3055\308C\307E\3059:</p>'),
'#CUSTOM_PLUGINS#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103901615484308328)
,p_name=>'PE.PROPERTY.PAGE_PROCESS_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104702897749309002)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_FUNCTION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30D1\30E9\30E1\30FC\30BF\306E\30BD\30FC\30B9\3068\3057\3066\4F7F\7528\3055\308C\308B\5024\3092\8FD4\3059PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104702746347309002)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_FUNCTION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104702605087309002)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30D1\30E9\30E1\30FC\30BF\306E\30BD\30FC\30B9\3068\3057\3066\4F7F\7528\3055\308C\308B\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104702595855309002)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_ITEM.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104703018795309003)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_ITEMS.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30D1\30E9\30E1\30FC\30BF\306E\5B9B\5148\3068\3057\3066\4F7F\7528\3055\308C\308B1\3064\4EE5\4E0A\306E\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002\8907\6570\306E\30A2\30A4\30C6\30E0\306E\5834\5408\3001\5404\30A2\30A4\30C6\30E0\540D\3092\30AB\30F3\30DE\3067\533A\5207\308A\307E\3059\3002</p>'),
unistr('<p>\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002'),
unistr('\30EA\30B9\30C8\304B\3089\9078\629E\3057\3001\3059\3067\306B\5165\529B\3055\308C\3066\3044\308B\30C6\30AD\30B9\30C8\304C\3042\308B\5834\5408\3001\65E2\5B58\306E\30C6\30AD\30B9\30C8\306E\6700\5F8C\306B\30AB\30F3\30DE\304C\4ED8\3051\3089\308C\3001\30EA\30B9\30C8\304B\3089\8FD4\3055\308C\305F\30A2\30A4\30C6\30E0\540D\304C\305D\308C\306B\7D9A\304D\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104702963615309002)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_ITEMS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104704206910309003)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F7F\7528\53EF\80FD\306A\30EA\30B9\30C8\304B\3089\30D1\30E9\30E1\30FC\30BF\306E\30BD\30FC\30B9\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104704758327309004)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.FUNCTION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104704816362309004)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.FUNCTION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F<em>PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53</em>\304B\3089\8FD4\3055\308C\305F\5024\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104704367682309004)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.ITEM.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104704458099309004)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\306B\4FDD\6301\3055\308C\3066\3044\308B\5024\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104704513347309004)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.STATIC.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\9759\7684\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104704650381309004)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.STATIC.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<em>\300C\9759\7684\5024\300D</em>\306B\5165\529B\3055\308C\305F\30C6\30AD\30B9\30C8\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104704178481309003)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BD\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104226508675308629)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_VALUE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30D1\30E9\30E1\30FC\30BF\306E\5024\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104226483967308629)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_VALUE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\9759\7684\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104254258284308649)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\306E\30C7\30D5\30A9\30EB\30C8\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103870414501308301)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30DA\30FC\30B8\306E\5916\89B3\3068\30EC\30A4\30A2\30A6\30C8\3092\5B9A\7FA9\3059\308B\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\9078\629E\3057\307E\3059\3002</p>'),
unistr('        <p>\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30C6\30FC\30DE\3067\5B9A\7FA9\3055\308C\307E\3059\3002'),
unistr('        \30DA\30FC\30B8\304C\4F5C\6210\3055\308C\308B\3068\3001\30C6\30F3\30D7\30EC\30FC\30C8\306F\3001\73FE\5728\306E\30C6\30FC\30DE\306B\5B9A\7FA9\3055\308C\3066\3044\308B\30C7\30D5\30A9\30EB\30C8\30FB\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\4F7F\7528\3057\3066\30DA\30FC\30B8\3092\30EC\30F3\30C0\30EA\30F3\30B0\3059\308B<em>\300C\30C6\30FC\30DE\306E\30C7\30D5\30A9\30EB\30C8\5024\300D</em>\306B\81EA\52D5\7684\306B\8A2D\5B9A\3055\308C\307E\3059\3002'),
unistr('        \3053\3053\3067\9078\629E\3059\308B\3068\3001\30C7\30D5\30A9\30EB\30C8\30FB\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\304C\30AA\30FC\30D0\30FC\30E9\30A4\30C9\3055\308C\307E\3059\3002</p>'),
unistr('        <p>\6A2A\306E\5217\3001\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8\3001\30C0\30A4\30A2\30ED\30B0\30FB\30DA\30FC\30B8\306A\3069\3092\542B\3080\30B3\30F3\30C6\30F3\30C4\3092\8868\793A\3059\308B\3068\3044\3063\305F\7279\5B9A\306E\76EE\7684\3092\6301\3064\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\304C\591A\304F\306E\30C6\30FC\30DE\306B\542B\307E\308C\307E\3059\3002<br>'),
unistr('        \30E6\30CB\30D0\30FC\30B5\30EB\30FB\30C6\30FC\30DE\306B\306F\3001\6B21\306E\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\304C\3042\308A\307E\3059\3002'),
'          <dl>',
unistr('            <dt>\6A19\6E96</dt>'),
unistr('              <dd>\30C7\30D5\30A9\30EB\30C8\30FB\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3002\6700\5927\306E\753B\9762\7BC4\56F2\304C\5FC5\8981\3068\3055\308C\308B\30DB\30FC\30E0\30DA\30FC\30B8\3001\30C0\30C3\30B7\30E5\30DC\30FC\30C9\3001\5927\898F\6A21\30EC\30DD\30FC\30C8\306A\3069\306E\30EC\30A4\30A2\30A6\30C8\306B\6700\9069\3067\3059\3002</dd>'),
unistr('            <dt>\5DE6\5074\306E\5217</dt>'),
unistr('              <dd>\691C\7D22\304A\3088\3073\30D5\30A3\30EB\30BF\30FB\30DA\30FC\30B8\306B\5F79\7ACB\3064\5DE6\5074\306E\8868\793A\4F4D\7F6E\304C\63D0\4F9B\3055\308C\307E\3059\3002</dd>'),
unistr('            <dt>\53F3\5074\306E\5217</dt>'),
unistr('              <dd>\30DC\30BF\30F3\3084\30EA\30B9\30C8\306A\3069\306E\30A2\30AF\30B7\30E7\30F3\6307\5411\306E\30B3\30F3\30C8\30ED\30FC\30EB\3092\8868\793A\3059\308B\306E\306B\5F79\7ACB\3064\7E2E\5C0F\53EF\80FD\306A\53F3\5074\306E\8868\793A\4F4D\7F6E\304C\63D0\4F9B\3055\308C\307E\3059\3002</dd>'),
unistr('            <dt>\5DE6\5074\3068\53F3\5074\306E\5217</dt>'),
unistr('              <dd>\975E\5E38\306B\8907\96D1\306A\30DA\30FC\30B8\306B\9069\3057\305F\3001\5DE6\5074\306E\5217\3068\7E2E\5C0F\53EF\80FD\306A\53F3\5074\306E\5217\306E\4E21\65B9\304C\63D0\4F9B\3055\308C\307E\3059\3002</dd>'),
unistr('            <dt>\30ED\30B0\30A4\30F3</dt>'),
unistr('              <dd>\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8\306E\307F\306B\4F7F\7528\3055\308C\307E\3059\3002</dd>'),
unistr('            <dt>\30DE\30FC\30AD\30FC</dt>'),
unistr('              <dd>\7E2E\5C0F\53EF\80FD\306A\53F3\5074\306E\5217\3068\3001\4E3B\8981\60C5\5831\3092\542B\3080\30BF\30A4\30C8\30EB\30FB\30D0\30FC\9818\57DF\304C\63D0\4F9B\3055\308C\307E\3059\3002'),
unistr('              \3053\306E\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306F\3001\8907\6570\306E\95A2\9023\30EC\30DD\30FC\30C8\307E\305F\306F\30C7\30FC\30BF\3092\542B\3080\5358\4E00\30EC\30B3\30FC\30C9\3092\8868\793A\3059\308B\306E\306B\9069\3057\3066\3044\307E\3059\3002'),
unistr('              \300C\30DE\30FC\30AD\30FC\300D\306F\3001\4E00\822C\7684\306B\3001\30EC\30DD\30FC\30C8\304B\3089\6700\521D\306B1\3064\306E\30DE\30B9\30BF\30FC\30FB\30EC\30B3\30FC\30C9\304C\9078\629E\3055\308C\308B\30DE\30B9\30BF\30FC\30FB\30C7\30A3\30C6\30FC\30EB\95A2\4FC2\3092\8868\793A\3059\308B\305F\3081\306B\4F7F\7528\3055\308C\307E\3059\3002</dd>'),
unistr('            <dt>\6700\5C0F(\30CA\30D3\30B2\30FC\30B7\30E7\30F3\306A\3057)</dt>'),
unistr('              <dd>\975E\5E38\306B\5358\7D14\306A\30DA\30FC\30B8\3001\514D\8CAC\4E8B\9805\3001\5358\4E00\30DA\30FC\30B8\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306A\3069\3001\30CA\30D3\30B2\30FC\30B7\30E7\30F3\304C\4E0D\8981\306A\5834\5408\306B\4FBF\5229\3067\3059\3002</dd>'),
'          </dl>',
unistr('          \95A2\9023\9805\76EE: <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\30E6\30CB\30D0\30FC\30B5\30EB\30FB\30C6\30FC\30DE\306E\30B5\30F3\30D7\30EB\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3</a>'),
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103870310745308301)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104254410055308649)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\306E\30C7\30D5\30A9\30EB\30C8\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104695490266308996)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.COMPONENT_PROPERTY.PAGE.NULL_TEXT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\306E\30C7\30D5\30A9\30EB\30C8\5185\306B\5B9A\7FA9\3055\308C\3066\3044\308B\8A2D\5B9A\3092\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103871231093308302)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\65B0\898F\30DA\30FC\30B8\306B\30CA\30D3\30B2\30FC\30C8\3059\308B\5834\5408\3001\307E\305F\306F\30DA\30FC\30B8\3092\9001\4FE1\3059\308B\5834\5408\306B\4F7F\7528\3059\308B\9077\79FB\3092\6307\5B9A\3057\307E\3059\3002</p>'),
unistr('<p>3D\5909\63DB\3092\30B5\30DD\30FC\30C8\3057\306A\3044\53E4\3044\30D6\30E9\30A6\30B6\3067\306F\9077\79FB\3092\6700\5927\9650\6D3B\7528\3067\304D\307E\305B\3093\3002'),
unistr('\30C7\30D5\30A9\30EB\30C8\3067\30013D\3092\30B5\30DD\30FC\30C8\3057\3066\3044\306A\3044\30C7\30D0\30A4\30B9(Android 2.x\306A\3069)\3067\306F\3001\3059\3079\3066\306E\9077\79FB\30BF\30A4\30D7\304C\30D5\30A7\30FC\30C9\3055\308C\307E\3059\3002'),
unistr('\8A73\7D30\306F\3001jQuery\30E2\30D0\30A4\30EB\306E\30C9\30AD\30E5\30E1\30F3\30C8\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104383309876308744)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.FADE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A7\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104383468521308744)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.FLIP.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30EA\30C3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104383507809308744)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.FLOW.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30ED\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104383252599308744)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.NONE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104383680298308744)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.POP.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DD\30C3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104383781750308745)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.SLIDE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30E9\30A4\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104383806881308745)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.SLIDEDOWN.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0B\306B\30B9\30E9\30A4\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104383922507308745)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.SLIDEFADE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30E9\30A4\30C9\30FB\30D5\30A7\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104384049051308745)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.SLIDEUP.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0A\306B\30B9\30E9\30A4\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104384164378308745)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.TURN.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\56DE\8EE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103871100592308302)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\9077\79FB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104559363385308886)
,p_name=>'PE.PROPERTY.PAGE_WARN_ON_UNSAVED_CHANGES.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30DA\30FC\30B8\306B\4FDD\5B58\3055\308C\3066\3044\306A\3044\5909\66F4\304C\542B\307E\308C\308B\5834\5408\306B\305D\306E\30DA\30FC\30B8\304B\3089\79FB\52D5\3057\3088\3046\3068\3057\305F\3068\304D\306B\3001\30E6\30FC\30B6\30FC\306B\8B66\544A\3092\8868\793A\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002'),
unistr('        \30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3068\30DC\30BF\30F3\3067\3082\3001\3053\306E\30C1\30A7\30C3\30AF\3092\5B9F\884C\3059\308B\30BF\30A4\30DF\30F3\30B0\3068\305D\308C\306B\542B\3081\308B\5185\5BB9\3092\8A73\7D30\306B\5236\5FA1\3067\304D\307E\3059\3002'),
unistr('        \30DC\30BF\30F3\306E\5834\5408\3001\30DC\30BF\30F3\306E\30AF\30EA\30C3\30AF\306B\3088\3063\3066\30C1\30A7\30C3\30AF\3092\5B9F\884C\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3067\304D\307E\3059\3002'),
unistr('        \30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306E\5834\5408\3001\30C1\30A7\30C3\30AF\306B\30A2\30A4\30C6\30E0\306E\5909\66F4\3092\542B\3081\308B\304B\7121\8996\3059\308B\304B\3092\6307\5B9A\3067\304D\307E\3059(\3069\3061\3089\3082<em>\300C\4FDD\5B58\3055\308C\3066\3044\306A\3044\5909\66F4\306E\8B66\544A\300D</em>\5C5E\6027\3092\53C2\7167\3057\3066\304F\3060\3055\3044)\3002</p>'),
unistr('        <p>\30CE\30FC\30C8: \3053\308C\306F\3001\30E2\30FC\30C0\30EB\30FB\30C0\30A4\30A2\30ED\30B0\30FB\30DA\30FC\30B8\3092\9589\3058\308B\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\306F\9069\7528\3055\308C\307E\305B\3093\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104559297863308886)
,p_name=>'PE.PROPERTY.PAGE_WARN_ON_UNSAVED_CHANGES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4FDD\5B58\3055\308C\3066\3044\306A\3044\5909\66F4\306E\8B66\544A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104206726241308614)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\306E\30DA\30FC\30B8\533A\5207\308A\306E\8868\793A\4F4D\7F6E\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104407992655308763)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.BOTTOM_LEFT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0B\90E8 - \5DE6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104408005229308763)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.BOTTOM_RIGHT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0B\90E8 - \53F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104408380317308763)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.TOP_AND_BOTTOM_LEFT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0A\90E8\304A\3088\3073\4E0B\90E8 - \5DE6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104408497547308764)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.TOP_AND_BOTTOM_RIGHT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0A\90E8\304A\3088\3073\4E0B\90E8 - \53F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104408158804308763)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.TOP_LEFT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0A\90E8 - \5DE6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104408249661308763)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.TOP_RIGHT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0A\90E8 - \53F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104206616239308614)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104719402999309016)
,p_name=>'PE.PROPERTY.PARAMETER_ID.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30E9\30E1\30FC\30BFID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104190962263308602)
,p_name=>'PE.PROPERTY.PARAMETER_REQUIRED.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30E9\30E1\30FC\30BF\3092\5FC5\9808\306B\3057\3001\5E38\306B\8A2D\5B9A\3057\3066\304A\304F\5FC5\8981\304C\3042\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104190827485308602)
,p_name=>'PE.PROPERTY.PARAMETER_REQUIRED.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5FC5\9808')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104191157434308602)
,p_name=>'PE.PROPERTY.PARAMETER_VALUE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30D1\30E9\30E1\30FC\30BF\306E\30C7\30D5\30A9\30EB\30C8\5024\307E\305F\306F\9759\7684\5024\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104191097459308602)
,p_name=>'PE.PROPERTY.PARAMETER_VALUE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103926762833308379)
,p_name=>'PE.PROPERTY.PARENT_REGION.COMPONENT_PROPERTY.REGION.NULL_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\89AA\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103885772983308312)
,p_name=>'PE.PROPERTY.PARENT_REGION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\3092\8868\793A\3059\308B\89AA\30EA\30FC\30B8\30E7\30F3\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103885602452308312)
,p_name=>'PE.PROPERTY.PARENT_REGION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\89AA\30EA\30FC\30B8\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104242048648308640)
,p_name=>'PE.PROPERTY.PARTIAL_PAGE_REFRESH.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\90E8\5206\30DA\30FC\30B8\30FB\30EA\30D5\30EC\30C3\30B7\30E5(PPR)\3092\4F7F\7528\3057\3066\30EC\30DD\30FC\30C8\8868\793A\3092\66F4\65B0\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002</p>'),
unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\30DA\30FC\30B8\533A\5207\308A\30EA\30AF\30A8\30B9\30C8\3084\65B0\3057\3044\30BD\30FC\30C8\5217\306E\9078\629E\306A\3069\306E\30A2\30AF\30B7\30E7\30F3\3092\5B9F\884C\3057\305F\5834\5408\3001\73FE\5728\306E\30EC\30DD\30FC\30C8\884C\3092\30EA\30D5\30EC\30C3\30B7\30E5\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\3053\306E\5C5E\6027\3092<strong>\300C\30AA\30F3\300D</strong>\306B\8A2D\5B9A\3059\308B\3068\3001\30EC\30DD\30FC\30C8\30FB\30EA\30FC\30B8\30E7\30F3\306E\307F\304C\30EA\30D5\30EC\30C3\30B7\30E5\3055\308C\307E\3059\3002\3053\306E\5C5E\6027\3092<strong>\300C\30AA\30D5\300D</strong>\306B\8A2D\5B9A\3059\308B\3068\3001\30DA\30FC\30B8\5168\4F53\304C\30EA\30D5\30EC\30C3\30B7\30E5\3055\308C\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104241925659308640)
,p_name=>'PE.PROPERTY.PARTIAL_PAGE_REFRESH.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\90E8\5206\30DA\30FC\30B8\30FB\30EA\30D5\30EC\30C3\30B7\30E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104419014501308771)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BACKGROUD_COLOR.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\306AHTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\306E\4F8B\306B\306F\6B21\306E\3082\306E\304C\3042\308A\307E\3059 -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104237516000308637)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BACKGROUD_COLOR.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30B0\30E9\30D5\306E\30D0\30C3\30AF\30B0\30E9\30A6\30F3\30C9\306B\4F7F\7528\3055\308C\308B\8272\3092\5165\529B\3057\307E\3059\3002</p>'),
unistr('<p>\8272\306F\300116\9032(hex)\8868\8A18\3001RGB\30AB\30E9\30FC\30FB\30B3\30FC\30C9\307E\305F\306FHTML\30AB\30E9\30FC\540D\3092\4F7F\7528\3057\3066\6307\5B9A\3055\308C\307E\3059\300216\9032\8868\8A18\306F#xxyyzz (#\306E\5F8C\306B3\3064\306E2\6841\306E16\9032\6570)\3067\5B9A\7FA9\3055\308C\3001xx\3001yy\304A\3088\3073zz\306F\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E2\6587\5B57\306E16\9032\306E\5024\3092\8868\3057\307E\3059\3002'),
unistr('RGB\30B3\30FC\30C9\306FRGB(xxx,xxx,xxx)\3067\5B9A\7FA9\3055\308C\3001xxx\306F0\304B\3089255\306E\9593\306E\6570\5024\3067\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E8\30D3\30C3\30C8\30FB\30D0\30A4\30C8\5024\3092\8868\3057\307E\3059\3002</p>'),
unistr('<p>\30A4\30F3\30BF\30FC\30CD\30C3\30C8\3067HTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\3092\691C\7D22\3059\308B\3068\3001\4F7F\7528\3059\308B\8272\306E16\9032\30B3\30FC\30C9\307E\305F\306FRGB\30B3\30FC\30C9\304C\308F\304B\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104237421494308637)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BACKGROUD_COLOR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D0\30C3\30AF\30B0\30E9\30A6\30F3\30C9\30FB\30AB\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104237914994308637)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BAR_WIDTH.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\68D2\30B0\30E9\30D5\306E\5E45\3092\30D4\30AF\30BB\30EB\5358\4F4D\3067\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104237896785308637)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BAR_WIDTH.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\68D2\306E\5E45')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104264848337308657)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BAR_WIDTH.UNIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D4\30AF\30BB\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104469537026308809)
,p_name=>'PE.PROPERTY.PCT_GRAPH_FOREGROUND_COLOR.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\306AHTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\306E\4F8B\306B\306F\6B21\306E\3082\306E\304C\3042\308A\307E\3059 -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104237765830308637)
,p_name=>'PE.PROPERTY.PCT_GRAPH_FOREGROUND_COLOR.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30B0\30E9\30D5\306E\524D\666F\306B\4F7F\7528\3055\308C\308B\8272\3092\5165\529B\3057\307E\3059\3002</p>'),
unistr('<p>\8272\306F\300116\9032(hex)\8868\8A18\3001RGB\30AB\30E9\30FC\30FB\30B3\30FC\30C9\307E\305F\306FHTML\30AB\30E9\30FC\540D\3092\4F7F\7528\3057\3066\6307\5B9A\3055\308C\307E\3059\300216\9032\8868\8A18\306F#xxyyzz (#\306E\5F8C\306B3\3064\306E2\6841\306E16\9032\6570)\3067\5B9A\7FA9\3055\308C\3001xx\3001yy\304A\3088\3073zz\306F\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E2\6587\5B57\306E16\9032\306E\5024\3092\8868\3057\307E\3059\3002'),
unistr('RGB\30B3\30FC\30C9\306FRGB(xxx,xxx,xxx)\3067\5B9A\7FA9\3055\308C\3001xxx\306F0\304B\3089255\306E\9593\306E\6570\5024\3067\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E8\30D3\30C3\30C8\30FB\30D0\30A4\30C8\5024\3092\8868\3057\307E\3059\3002</p>'),
unistr('<p>\30A4\30F3\30BF\30FC\30CD\30C3\30C8\3067HTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\3092\691C\7D22\3059\308B\3068\3001\4F7F\7528\3059\308B\8272\306E16\9032\30B3\30FC\30C9\307E\305F\306FRGB\30B3\30FC\30C9\304C\308F\304B\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104237639841308637)
,p_name=>'PE.PROPERTY.PCT_GRAPH_FOREGROUND_COLOR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\524D\666F\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104149866085308567)
,p_name=>'PE.PROPERTY.PIE_OTHER_THRESHOLD.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30B9\30E9\30A4\30B9\304C"\305D\306E\4ED6\306E"\30B9\30E9\30A4\30B9\306B\96C6\7D04\3055\308C\308B\5834\5408\306E\5186\30B0\30E9\30D5\5168\4F53\306E\4E00\90E8\3092\5165\529B\3057\307E\3059\3002\6709\52B9\306A\5024\306E\7BC4\56F2\306F0 (\30C7\30D5\30A9\30EB\30C8)\304B\30891\3067\3059</p>'),
unistr('        <p>\305F\3068\3048\3070\3001\5024\304C0.15\306E\5834\5408\3001\5186\306E15%\672A\6E80\306E\30B9\30E9\30A4\30B9\306F\3059\3079\3066"\305D\306E\4ED6\306E"\30B9\30E9\30A4\30B9\306B\96C6\7D04\3055\308C\307E\3059\3002</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104149726290308566)
,p_name=>'PE.PROPERTY.PIE_OTHER_THRESHOLD.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5186\30B0\30E9\30D5\306E\4ED6\306E\3057\304D\3044\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104180475003308593)
,p_name=>'PE.PROPERTY.PIE_SELECTION_EFFECT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5186\30B0\30E9\30D5\306E\30BB\30B0\30E1\30F3\30C8\304C\9078\629E\3055\308C\305F\3068\304D\306B\9069\7528\3059\308B\52B9\679C\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104180530334308593)
,p_name=>'PE.PROPERTY.PIE_SELECTION_EFFECT.LOV.EXPLODE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\304F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104180759383308593)
,p_name=>'PE.PROPERTY.PIE_SELECTION_EFFECT.LOV.HIGHLIGHT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CF\30A4\30E9\30A4\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104180638349308593)
,p_name=>'PE.PROPERTY.PIE_SELECTION_EFFECT.LOV.HIGHLIGHTANDEXPLODE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CF\30A4\30E9\30A4\30C8\304A\3088\3073\5C55\958B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104180320445308593)
,p_name=>'PE.PROPERTY.PIE_SELECTION_EFFECT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5186\9078\629E\52B9\679C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104258829255308652)
,p_name=>'PE.PROPERTY.PK_SOURCE_PLSQL_EXPRESSION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E3B\30AD\30FC\306E\5024\3092\63D0\4F9B\3059\308BPL/SQL\5F0F\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104258712281308652)
,p_name=>'PE.PROPERTY.PK_SOURCE_PLSQL_EXPRESSION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104259038214308652)
,p_name=>'PE.PROPERTY.PK_SOURCE_SEQUENCE_NAME.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E3B\30AD\30FC\306E\540D\524D\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104258950186308652)
,p_name=>'PE.PROPERTY.PK_SOURCE_SEQUENCE_NAME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\540D\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104258616800308652)
,p_name=>'PE.PROPERTY.PK_SOURCE_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E3B\30AD\30FC\306E\30BD\30FC\30B9\30FB\30BF\30A4\30D7\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104425981831308777)
,p_name=>'PE.PROPERTY.PK_SOURCE_TYPE.LOV.F.D'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104426011177308777)
,p_name=>'PE.PROPERTY.PK_SOURCE_TYPE.LOV.S.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E2\5B58\306E\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104425835902308776)
,p_name=>'PE.PROPERTY.PK_SOURCE_TYPE.LOV.T.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E2\5B58\306E\30C8\30EA\30AC\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104258538670308652)
,p_name=>'PE.PROPERTY.PK_SOURCE_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104342950640308714)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_LOV_SQL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\56FA\6709\306E\5217\5024\3092\9078\629E\3057\3066\81EA\52D5\7684\306B\751F\6210\3055\308C\308B\554F\5408\305B\306E\304B\308F\308A\306B\4F7F\7528\3059\308BSQL\554F\5408\305B\3092\5165\529B\3057\307E\3059\3002SQL\554F\5408\305B\306F1\3064\306E\5217\3092\8FD4\3059\5FC5\8981\304C\3042\308A\307E\3059\3002SQL\554F\5408\305B\3092\5165\529B\3059\308B\3068\3001\30EC\30DD\30FC\30C8\306B\3088\3063\3066\306F\30D1\30D5\30A9\30FC\30DE\30F3\30B9\304C\5411\4E0A\3059\308B\3053\3068\304C\3042\308A\307E\3059\3002\30E6\30FC\30B6\30FC\304C\5217\30D8\30C3\30C0\30FC\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\3053\306ELOV\304C\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104342851316308714)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_LOV_SQL.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104342554135308714)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\5217\30C9\30ED\30C3\30D7\30FB\30C0\30A6\30F3\30FB\30EA\30B9\30C8\306E\30D5\30A3\30EB\30BF\306ELOV\306E\5C0E\51FA\65B9\6CD5\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104430943848308780)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.1.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B8C\5168\4E00\81F4\306E\30D5\30A3\30EB\30BF\51E6\7406\306B\540D\524D\4ED8\304DLOV\3092\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104431022528308780)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.1.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\7B49\3057\3044\300D\30D5\30A3\30EB\30BF\3092\4F5C\6210\3059\308B\305F\3081\306B\540D\524D\4ED8\304D\306ELOV\304B\3089LOV\3092\5C0E\51FA\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104431154435308780)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.2.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\5358\8A9E\3092\542B\3080\300D\306E\30D5\30A3\30EB\30BF\51E6\7406\306B\540D\524D\4ED8\304DLOV\3092\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104431288945308781)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\542B\3080\300D\30D5\30A3\30EB\30BF\3092\4F5C\6210\3059\308B\305F\3081\306B\540D\524D\4ED8\304D\306ELOV\304B\3089LOV\3092\5C0E\51FA\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104430700150308780)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.C.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\5358\8A9E\3092\542B\3080\300D\306E\30D5\30A3\30EB\30BF\51E6\7406\306B\5B9A\7FA9\6E08LOV\3092\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104430853738308780)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.C.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\542B\3080\300D\30D5\30A3\30EB\30BF\3092\4F5C\6210\3059\308B\305F\3081\306BSQL\3067\554F\3044\5408\305B\308B\5B9A\7FA9\6E08\306ELOV\304B\3089LOV\3092\5C0E\51FA\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104430314240308780)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.D.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\30BF\30A4\30D7\306B\57FA\3065\304F\30C7\30D5\30A9\30EB\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104430430064308780)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.D.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('STRING\304A\3088\3073NUMBER\5217\306F\3001\500B\5225\306E\5217\306E\5024\304B\3089LOV\3092\5C0E\51FA\3057\307E\3059\3002DATE\5217\306F\3001\4E8B\524D\5B9A\7FA9\306E\65E5\4ED8\7BC4\56F2\304B\3089LOV\3092\5C0E\51FA\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104430158880308780)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.N.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104430200971308780)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.N.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('LOV\3067\30D5\30A3\30EB\30BF\3092\7121\52B9\306B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104430591385308780)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.S.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B8C\5168\4E00\81F4\306E\30D5\30A3\30EB\30BF\51E6\7406\306B\5B9A\7FA9\6E08LOV\3092\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104430664043308780)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.S.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\7B49\3057\3044\300D\30D5\30A3\30EB\30BF\3092\4F5C\6210\3059\308B\305F\3081\306BSQL\3067\554F\3044\5408\305B\308B\5B9A\7FA9\6E08\306ELOV\304B\3089LOV\3092\5C0E\51FA\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104342477045308714)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104587472857308909)
,p_name=>'PE.PROPERTY.PLSQL_CODE.COMPONENT_PROPERTY.APP_PROCESS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9F\884C\3059\308BPL/SQL\30B3\30FC\30C9\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104196705191308607)
,p_name=>'PE.PROPERTY.PLSQL_CODE.COMPONENT_PROPERTY.PAGE_PROCESS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30E2\30FC\30C8\30FB\30C7\30FC\30BF\30D9\30FC\30B9\3067\5B9F\884C\3059\308BPL/SQL\30B3\30FC\30C9\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104196697621308607)
,p_name=>'PE.PROPERTY.PLSQL_CODE.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('HTML\51FA\529B\3092\751F\6210\3059\308BPL/SQL\30B3\30FC\30C9\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103963428211308408)
,p_name=>'PE.PROPERTY.PLSQL_CODE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\8A8D\8A3C\30B9\30AD\30FC\30E0\5185\3067\4F7F\7528\3055\308C\308BPL/SQL\30BD\30FC\30B9\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103963320221308408)
,p_name=>'PE.PROPERTY.PLSQL_CODE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\30B3\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104196121288308607)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30BB\30B9\304C\5B9F\884C\3055\308C\308B\5834\6240\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104196228517308607)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.LOV.LOCAL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30FC\30AB\30EB\30FB\30C7\30FC\30BF\30D9\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104196318371308607)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.LOV.LOCAL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\30B3\30FC\30C9\306F\30ED\30FC\30AB\30EB\30FB\30C7\30FC\30BF\30D9\30FC\30B9\3067\5B9F\884C\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104196456772308607)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.LOV.REMOTE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\5BFE\5FDCSQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104196573842308607)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.LOV.REMOTE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\30B3\30FC\30C9\306F\3001REST\5BFE\5FDCSQL\3092\4F7F\7528\3057\3066\63A5\7D9A\304C\5B9A\7FA9\3055\308C\308B\30EA\30E2\30FC\30C8\30FB\30C7\30FC\30BF\30D9\30FC\30B9\3067\5B9F\884C\3055\308C\307E\3059\3002 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104196028818308606)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104077805373308498)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\3067\3069\306E\30AB\30C6\30B4\30EA\306E\4E0B\306B\30D7\30E9\30B0\30A4\30F3\304C\8868\793A\3055\308C\308B\304B\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104403833806308760)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.COMPONENT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30DD\30FC\30CD\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104403939265308760)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.EFFECT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\52B9\679C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104404078443308760)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.EXECUTE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9F\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104404102121308760)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.INIT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\521D\671F\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104404298550308760)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.MISC.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\305D\306E\4ED6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104404335178308760)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.NAVIGATION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CA\30D3\30B2\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104404439096308761)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.NOTIFICATION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\901A\77E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104404515713308761)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.STYLE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30BF\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104077778239308498)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30C6\30B4\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104729929444309025)
,p_name=>'PE.PROPERTY.PLUGIN_INIT_JAVASCRIPT_CODE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\5B9F\884C\3059\308BJavaScript\30B3\30FC\30C9\3092\5165\529B\3057\307E\3059\3002\30CE\30FC\30C8: \3053\308C\306B\3088\3063\3066\884C\308F\308C\308B\3053\3068\306E\6B63\78BA\306A\6027\8CEA\306F\3001\73FE\5728\306E\30D7\30E9\30B0\30A4\30F3\306B\3088\3063\3066\7570\306A\308A\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104729837971309025)
,p_name=>'PE.PROPERTY.PLUGIN_INIT_JAVASCRIPT_CODE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('JavaScript\521D\671F\5316\30B3\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104254575676308649)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\306E\30C7\30D5\30A9\30EB\30C8\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104695575978308996)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.COMPONENT_PROPERTY.PAGE.NULL_TEXT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\306E\30C7\30D5\30A9\30EB\30C8\5185\306B\5B9A\7FA9\3055\308C\3066\3044\308B\8A2D\5B9A\3092\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103871469772308302)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30DD\30C3\30D7\30A2\30C3\30D7\3092\958B\304F\969B\306B\4F7F\7528\3059\308B\9077\79FB\3092\6307\5B9A\3057\307E\3059\3002</p>'),
unistr('<p>3D\5909\63DB\3092\30B5\30DD\30FC\30C8\3057\306A\3044\53E4\3044\30D6\30E9\30A6\30B6\3067\306F\9077\79FB\3092\6700\5927\9650\6D3B\7528\3067\304D\307E\305B\3093\3002'),
unistr('\30C7\30D5\30A9\30EB\30C8\3067\30013D\3092\30B5\30DD\30FC\30C8\3057\3066\3044\306A\3044\30C7\30D0\30A4\30B9(Android 2.x\306A\3069)\3067\306F\3001\3059\3079\3066\306E\9077\79FB\30BF\30A4\30D7\304C\30D5\30A7\30FC\30C9\3055\308C\307E\3059\3002'),
unistr('\8A73\7D30\306F\3001jQuery\30E2\30D0\30A4\30EB\306E\30C9\30AD\30E5\30E1\30F3\30C8\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104384392517308745)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.FADE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A7\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104384415458308745)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.FLIP.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30EA\30C3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104384560980308745)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.FLOW.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30ED\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104384210162308745)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.NONE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104384632093308745)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.POP.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DD\30C3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104384799972308745)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.SLIDE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30E9\30A4\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104384846941308745)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.SLIDEDOWN.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0B\306B\30B9\30E9\30A4\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104384995101308746)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.SLIDEFADE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30E9\30A4\30C9\30FB\30D5\30A7\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104385034235308746)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.SLIDEUP.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0A\306B\30B9\30E9\30A4\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104385108687308746)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.TURN.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\56DE\8EE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103871366738308302)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DD\30C3\30D7\30A2\30C3\30D7\9077\79FB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103964470727308409)
,p_name=>'PE.PROPERTY.POST_AUTHENTICATION_PROCEDURE_NAME.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8A8D\8A3C\30B9\30C6\30C3\30D7(\30ED\30B0\30A4\30F3\8CC7\683C\8A3C\660E\306E\691C\8A3C)\306E\5F8C\306B&PRODUCT_NAME.\30ED\30B0\30A4\30F3\30FB\30D7\30ED\30B7\30FC\30B8\30E3(\30ED\30B0\30A4\30F3API)\306B\3088\3063\3066\5B9F\884C\3055\308C\308B\30D7\30ED\30B7\30FC\30B8\30E3\306E\540D\524D\3092\5165\529B\3057\307E\3059\3002'),
unistr('\30ED\30B0\30A4\30F3\30FB\30D7\30ED\30B7\30FC\30B8\30E3\306F\3001\76EE\7684\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30DA\30FC\30B8\306B\30EA\30C0\30A4\30EC\30AF\30C8\3059\308B\524D\3001Cookie\306E\8A2D\5B9A\304A\3088\3073\30BB\30C3\30B7\30E7\30F3\306E\767B\9332\3092\542B\3080\901A\5E38\306E\30ED\30B0\30A4\30F3\30FB\30D7\30ED\30B7\30FC\30B8\30E3\3092\5B9F\884C\3057\305F\5F8C\306B\3053\306E\30B3\30FC\30C9\3092\5B9F\884C\3057\307E\3059\3002'),
unistr('\30D7\30ED\30B7\30FC\30B8\30E3\306F\3001\300CPL/SQL\30B3\30FC\30C9\300D\5C5E\6027\307E\305F\306F\30C7\30FC\30BF\30D9\30FC\30B9\5185\3067\5B9A\7FA9\3067\304D\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103964360758308408)
,p_name=>'PE.PROPERTY.POST_AUTHENTICATION_PROCEDURE_NAME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\5F8C\306E\30D7\30ED\30B7\30FC\30B8\30E3\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103891866880308317)
,p_name=>'PE.PROPERTY.POST_CALCULATION_COMPUTATION.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30A2\30A4\30C6\30E0\306E\5024\3092\8ABF\6574\3059\308BPL/SQL\5F0F\3092\5165\529B\3057\307E\3059\3002</p>'),
unistr('<p>\305F\3068\3048\3070\3001\3053\306E\30A2\30A4\30C6\30E0\304C<code>P1_X</code>\3068\3044\3046\540D\524D\306E\5834\5408\3001<code>UPPER(:P1_X)</code>\3001<code>INITCAP(:P2_Y)</code>\3001<code>MIN(:P1_X, :P2_Y - 200)</code>\3001<code>NVL(:P1_X, :P2_Y)</code>\306A\3069\306E\8A08\7B97\5F8C\306E\5F0F\3001\307E\305F\306F<code>my_func(:P1_X)</code>\306A\3069\306E\30D5\30A1\30F3\30AF\30B7\30E7\30F3\30FB\30B3\30FC\30EB\3092\4F7F\7528\3057\3066\3001\30A2\30A4\30C6\30E0\306E\6700\7D42\5024\3092\8A2D\5B9A\3067\304D\307E\3059\3002'),
unistr('\3053\308C\3089\306E\4F8B\3067\306F\3001\5F0F\304C\73FE\5728\306E\30A2\30A4\30C6\30E0\3092\53C2\7167\3067\304D\308B\3053\3068\3001\307E\305F\306F\5F0F\304C\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\5185\306E\4ED6\306E\30A2\30A4\30C6\30E0\3092\53C2\7167\3067\304D\308B\3053\3068\3092\793A\3057\3066\3044\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103891710966308317)
,p_name=>'PE.PROPERTY.POST_CALCULATION_COMPUTATION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A08\7B97\5F8C\306E\8A08\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103964821915308409)
,p_name=>'PE.PROPERTY.POST_LOGOUT_URL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('&PRODUCT_NAME.\306B\3088\3063\3066\30E6\30FC\30B6\30FC\30FB\30BB\30C3\30B7\30E7\30F3\304C\30AF\30EA\30FC\30F3\30A2\30C3\30D7\3055\308C\305F\5F8C\306B\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304C\30EA\30C0\30A4\30EC\30AF\30C8\3055\308C\308BURL\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103964797142308409)
,p_name=>'PE.PROPERTY.POST_LOGOUT_URL.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30B0\30A2\30A6\30C8\5F8CURL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104641856842308952)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\306E\5B9F\884C\306B\4F7F\7528\3055\308C\308B\8A00\8A9E\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104642140843308953)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'ja'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104642052819308953)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'ja'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104641922361308953)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'ja'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104642266874308953)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'ja'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104641749116308952)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A00\8A9E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104643080818308953)
,p_name=>'PE.PROPERTY.POST_PROC_JAVA_FUNC_BODY_SQL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\8FD4\3055\308C\305FSQL\554F\5408\305B\304CWeb\30BD\30FC\30B9\304B\3089\53D6\5F97\3055\308C\305F\30C7\30FC\30BF\3092\5909\63DB\3059\308BJava\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002Java\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\306B\3088\3063\3066\8FD4\3055\308C\308BSQL\554F\5408\305B\306F\3001#APEX$SOURCE_DATA#\7591\4F3C\8868\304B\3089\9078\629E\3057\3001\30C7\30FC\30BF\30FB\30D7\30ED\30D5\30A1\30A4\30EB\3067\4F7F\7528\53EF\80FD\306A\5217\3092\8AAD\307F\53D6\308B\5FC5\8981\304C\3042\308A\307E\3059\3002SQL WITH\53E5\3092\4F7F\7528\3057\305F\526F\554F\5408\305B\30D5\30A1\30AF\30BF\306F\3001\3053\3053\3067\306F\30B5\30DD\30FC\30C8\3055\308C\3066\3044\307E\305B\3093\3002 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104642979702308953)
,p_name=>'PE.PROPERTY.POST_PROC_JAVA_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B\3092\8FD4\3059Java\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104642889916308953)
,p_name=>'PE.PROPERTY.POST_PROC_JS_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>EMPNO\3001ENAME\304A\3088\3073SAL\5217\3092\9078\629E\3057\3001SAL\304C3000\672A\6E80\306E\3059\3079\3066\306E\884C\3092\30D5\30A3\30EB\30BF\51E6\7406\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'return "select EMPNO, ENAME, SAL from #APEX$SOURCE_DATA where SAL < 3000";',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104642749019308953)
,p_name=>'PE.PROPERTY.POST_PROC_JS_FUNC_BODY_SQL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\8FD4\3055\308C\305FSQL\554F\5408\305B\304CWeb\30BD\30FC\30B9\304B\3089\53D6\5F97\3055\308C\305F\30C7\30FC\30BF\3092\5909\63DB\3059\308BJavaScript\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002JavaScript\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\306B\3088\3063\3066\8FD4\3055\308C\308BSQL\554F\5408\305B\306F\3001#APEX$SOURCE_DATA#\7591\4F3C\8868\304B\3089\9078\629E\3057\3001\30C7\30FC\30BF\30FB\30D7\30ED\30D5\30A1\30A4\30EB\3067\4F7F\7528\53EF\80FD\306A\5217\3092\8AAD\307F\53D6\308B\5FC5\8981\304C\3042\308A\307E\3059\3002SQL WITH\53E5\3092\4F7F\7528\3057\305F\526F\554F\5408\305B\30D5\30A1\30AF\30BF\306F\3001\3053\3053\3067\306F\30B5\30DD\30FC\30C8\3055\308C\3066\3044\307E\305B\3093\3002 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104642686408308953)
,p_name=>'PE.PROPERTY.POST_PROC_JS_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B\3092\8FD4\3059JavaScript\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104697322254308998)
,p_name=>'PE.PROPERTY.POST_PROC_ORDER_BY.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\6700\65B0\306E\63A1\7528\8005\3092\6700\521D\306B\3001\307E\3060\63A1\7528\3055\308C\3066\3044\306A\3044\4EBA\3092\6700\5F8C\306B\8868\793A\3057\307E\3059\3002\65E5\4ED8\304C\540C\3058\5834\5408\306F\3001\90E8\9580\756A\53F7\3067\30BD\30FC\30C8\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'HIREDATE DESC NULLS LAST, DEPTNO',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104697211167308998)
,p_name=>'PE.PROPERTY.POST_PROC_ORDER_BY.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30C7\30A3\30EC\30AF\30C6\30A3\30D6\3092\542B\30801\3064\4EE5\4E0A\306E\30AB\30F3\30DE\533A\5207\308A\306E\5217\540D\3092\5165\529B\3057\3066\3001\30EC\30B3\30FC\30C9\306E\53D6\5F97\9806\5E8F\3092\5B9A\7FA9\3057\307E\3059\3002</p>'),
unistr('        <p>\30C7\30A3\30EC\30AF\30C6\30A3\30D6\306F\6B21\306E\3068\304A\308A\3067\3059\3002'),
'          <ul>',
unistr('            <li>ASC - \5217\3092\6607\9806\3067\623B\3057\307E\3059</li>'),
unistr('            <li>DESC - \5217\3092\964D\9806\3067\623B\3057\307E\3059</li>'),
unistr('            <li>NULLS FIRST - \5024\306E\3042\308B\5217\3088\308A\524D\306B\5024\306E\306A\3044\5217\3092\623B\3057\307E\3059</li>'),
unistr('            <li>NULLS LAST - \5024\306E\306A\3044\5217\3088\308A\524D\306B\5024\306E\3042\308B\5217\3092\623B\3057\307E\3059</li>'),
'          </ul>',
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104697197422308998)
,p_name=>'PE.PROPERTY.POST_PROC_ORDER_BY.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E26\66FF\3048\57FA\6E96')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104642547864308953)
,p_name=>'PE.PROPERTY.POST_PROC_PLSQL_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>EMPNO\3001ENAME\304A\3088\3073SAL\5217\3092\9078\629E\3057\3001SAL\304C3000\672A\6E80\306E\3059\3079\3066\306E\884C\3092\30D5\30A3\30EB\30BF\51E6\7406\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'begin',
'    return ''select EMPNO, ENAME, SAL from #APEX$SOURCE_DATA where SAL < 3000'';',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104642433798308953)
,p_name=>'PE.PROPERTY.POST_PROC_PLSQL_FUNC_BODY_SQL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\623B\3055\308C\305FSQL\554F\5408\305B\304CWeb\30BD\30FC\30B9\304B\3089\53D6\5F97\3055\308C\305F\30C7\30FC\30BF\3092\5909\63DB\3059\308BPL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\306B\3088\3063\3066\623B\3055\308C\308BSQL\554F\5408\305B\306F\3001#APEX$SOURCE_DATA#\7591\4F3C\8868\304B\3089\9078\629E\3057\3001\30C7\30FC\30BF\30FB\30D7\30ED\30D5\30A1\30A4\30EB\3067\4F7F\7528\53EF\80FD\306A\5217\3092\8AAD\307F\53D6\308B\5FC5\8981\304C\3042\308A\307E\3059\3002SQL WITH\53E5\3092\4F7F\7528\3057\305F\526F\554F\5408\305B\30D5\30A1\30AF\30BF\306F\3001\3053\3053\3067\306F\30B5\30DD\30FC\30C8\3055\308C\3066\3044\307E\305B\3093\3002 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104642346612308953)
,p_name=>'PE.PROPERTY.POST_PROC_PLSQL_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B\3092\623B\3059PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104643267413308954)
,p_name=>'PE.PROPERTY.POST_PROC_PYTHON_FUNC_BODY_SQL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\8FD4\3055\308C\305FSQL\554F\5408\305B\304CWeb\30BD\30FC\30B9\304B\3089\53D6\5F97\3055\308C\305F\30C7\30FC\30BF\3092\5909\63DB\3059\308BPython\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002Python\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\306B\3088\3063\3066\8FD4\3055\308C\308BSQL\554F\5408\305B\306F\3001#APEX$SOURCE_DATA#\7591\4F3C\8868\304B\3089\9078\629E\3057\3001\30C7\30FC\30BF\30FB\30D7\30ED\30D5\30A1\30A4\30EB\3067\4F7F\7528\53EF\80FD\306A\5217\3092\8AAD\307F\53D6\308B\5FC5\8981\304C\3042\308A\307E\3059\3002SQL WITH\53E5\3092\4F7F\7528\3057\305F\526F\554F\5408\305B\30D5\30A1\30AF\30BF\306F\3001\3053\3053\3067\306F\30B5\30DD\30FC\30C8\3055\308C\3066\3044\307E\305B\3093\3002 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104643139771308954)
,p_name=>'PE.PROPERTY.POST_PROC_PYTHON_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B\3092\8FD4\3059Python\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104698843598308999)
,p_name=>'PE.PROPERTY.POST_PROC_SQL_QUERY.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>EMPNO\3001ENAME\304A\3088\3073SAL\5217\3092\9078\629E\3057\3001SAL\304C3000\672A\6E80\306E\3059\3079\3066\306E\884C\3092\30D5\30A3\30EB\30BF\51E6\7406\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'select EMPNO, ENAME, SAL',
'  from #APEX$SOURCE_DATA#',
' where SAL < 3000',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104697535215308998)
,p_name=>'PE.PROPERTY.POST_PROC_SQL_QUERY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\30C7\30FC\30BF\30FB\30BD\30FC\30B9\304B\3089\53D6\5F97\3055\308C\305F\30C7\30FC\30BF\3092\5909\63DB\3059\308BSQL\554F\5408\305B\3092\5165\529B\3057\307E\3059\3002\7591\4F3C\8868#APEX$SOURCE_DATA#\304B\3089\9078\629E\3057\3001\30C7\30FC\30BF\30FB\30D7\30ED\30D5\30A1\30A4\30EB\3067\4F7F\7528\53EF\80FD\306A\5217\3092\6307\5B9A\3057\307E\3059\3002SQL WITH\53E5\3092\4F7F\7528\3057\305F\526F\554F\5408\305B\30D5\30A1\30AF\30BF\306F\3001\3053\3053\3067\306F\30B5\30DD\30FC\30C8\3055\308C\3066\3044\307E\305B\3093\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104697439127308998)
,p_name=>'PE.PROPERTY.POST_PROC_SQL_QUERY.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104697041167308998)
,p_name=>'PE.PROPERTY.POST_PROC_WHERE.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\30DE\30CD\30FC\30B8\30E3\306E\3044\308B\5F93\696D\54E1\307E\305F\306F\30B8\30E7\30D6\304C\8CA9\58F2\62C5\5F53\306E\5F93\696D\54E1\306E\307F\3092\542B\3081\307E\3059\3002</dt>'),
'<dd><pre>',
unistr('( MGR\306Fnull\3067\306A\3044\3001\307E\305F\306FJOB = ''SALESMAN'' )'),
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104696907563308998)
,p_name=>'PE.PROPERTY.POST_PROC_WHERE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\53D6\5F97\3055\308C\308B\30EC\30B3\30FC\30C9\3092\5236\9650\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\3001\6709\52B9\306ASQL WHERE\6761\4EF6\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104696844464308997)
,p_name=>'PE.PROPERTY.POST_PROC_WHERE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('WHERE\53E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103964298556308408)
,p_name=>'PE.PROPERTY.PRE_AUTHENTICATION_PROCEDURE_NAME.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8\306E\9001\4FE1\5F8C\3001\8CC7\683C\8A3C\660E\691C\8A3C\306E\5B9F\884C\524D\306B\5B9F\884C\3059\308B\30D7\30ED\30B7\30FC\30B8\30E3\306E\540D\524D\3092\5165\529B\3057\307E\3059\3002'),
unistr('\30D7\30ED\30B7\30FC\30B8\30E3\306F\3001\300CPL/SQL\30B3\30FC\30C9\300D\5C5E\6027\307E\305F\306F\30C7\30FC\30BF\30D9\30FC\30B9\5185\3067\5B9A\7FA9\3067\304D\307E\3059\3002</p>'),
unistr('<p>\901A\5E38\3001\30E6\30FC\30B6\30FC\8CC7\683C\8A3C\660E\306E\30C1\30A7\30C3\30AF\304C&PRODUCT_NAME.\306E\5916\90E8\3067\884C\308F\308C\308B\8A8D\8A3C\30B9\30AD\30FC\30E0\306F\3001\8A8D\8A3C\524D\30D7\30ED\30B7\30FC\30B8\30E3\3092\5B9F\884C\3057\307E\305B\3093\3002'),
unistr('\4F8B\3068\3057\3066\3001<em>HTTP\30D8\30C3\30C0\30FC\5909\6570</em>\3001<em>Oracle Application Server Single Sign-On</em>\3001\304A\3088\3073<code>apex_authentication.login</code>\3067\306F\306A\304F<code>apex_authentication.post_login</code>\3092\4F7F\7528\3059\308B\30AB\30B9\30BF\30E0\8A8D\8A3C\30B9\30AD\30FC\30E0\304C\3042\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103964139684308408)
,p_name=>'PE.PROPERTY.PRE_AUTHENTICATION_PROCEDURE_NAME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\524D\306E\30D7\30ED\30B7\30FC\30B8\30E3\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104268164420308659)
,p_name=>'PE.PROPERTY.PRIMARY_KEY_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\306E\4E3B\30AD\30FC\3092\4FDD\6301\3059\308B\5217\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104268078137308659)
,p_name=>'PE.PROPERTY.PRIMARY_KEY_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E3B\30AD\30FC\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104432713572308782)
,p_name=>'PE.PROPERTY.PRINT_BORDER_COLOR.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\306AHTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\306E\4F8B\306B\306F\6B21\306E\3082\306E\304C\3042\308A\307E\3059 -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104345734981308716)
,p_name=>'PE.PROPERTY.PRINT_BORDER_COLOR.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\3055\308C\305F\5C5E\6027\306E\67A0\7DDA\306E\8868\793A\306B\4F7F\7528\3055\308C\308B\8272\3092\5165\529B\3057\307E\3059\3002</p>'),
unistr('<p>\8272\306F\300116\9032(hex)\8868\8A18\3001RGB\30AB\30E9\30FC\30FB\30B3\30FC\30C9\307E\305F\306FHTML\30AB\30E9\30FC\540D\3092\4F7F\7528\3057\3066\6307\5B9A\3055\308C\307E\3059\300216\9032\8868\8A18\306F#xxyyzz (#\306E\5F8C\306B3\3064\306E2\6841\306E16\9032\6570)\3067\5B9A\7FA9\3055\308C\3001xx\3001yy\304A\3088\3073zz\306F\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E2\6587\5B57\306E16\9032\306E\5024\3092\8868\3057\307E\3059\3002'),
unistr('RGB\30B3\30FC\30C9\306FRGB(xxx,xxx,xxx)\3067\5B9A\7FA9\3055\308C\3001xxx\306F0\304B\3089255\306E\9593\306E\6570\5024\3067\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E8\30D3\30C3\30C8\30FB\30D0\30A4\30C8\5024\3092\8868\3057\307E\3059\3002</p>'),
unistr('<p>\30A4\30F3\30BF\30FC\30CD\30C3\30C8\3067HTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\3092\691C\7D22\3059\308B\3068\3001\4F7F\7528\3059\308B\8272\306E16\9032\30B3\30FC\30C9\307E\305F\306FRGB\30B3\30FC\30C9\304C\308F\304B\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104345655145308716)
,p_name=>'PE.PROPERTY.PRINT_BORDER_COLOR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\67A0\7DDA\306E\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104345584032308716)
,p_name=>'PE.PROPERTY.PRINT_BORDER_WIDTH.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\306E\67A0\7DDA\306E\5E45\3092\30D4\30AF\30BB\30EB\5358\4F4D\3067\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104345442776308716)
,p_name=>'PE.PROPERTY.PRINT_BORDER_WIDTH.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5883\754C\7DDA\306E\5E45')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104469803566308809)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_BG_COLOR.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\306AHTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\306E\4F8B\306B\306F\6B21\306E\3082\306E\304C\3042\308A\307E\3059 -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104348961856308718)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_BG_COLOR.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306E\30D0\30C3\30AF\30B0\30E9\30A6\30F3\30C9\306E\8868\793A\306B\4F7F\7528\3055\308C\308B\8272\3092\5165\529B\3057\307E\3059\3002</p>'),
unistr('<p>\8272\306F\300116\9032(hex)\8868\8A18\3001RGB\30AB\30E9\30FC\30FB\30B3\30FC\30C9\307E\305F\306FHTML\30AB\30E9\30FC\540D\3092\4F7F\7528\3057\3066\6307\5B9A\3055\308C\307E\3059\300216\9032\8868\8A18\306F#xxyyzz (#\306E\5F8C\306B3\3064\306E2\6841\306E16\9032\6570)\3067\5B9A\7FA9\3055\308C\3001xx\3001yy\304A\3088\3073zz\306F\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E2\6587\5B57\306E16\9032\306E\5024\3092\8868\3057\307E\3059\3002'),
unistr('RGB\30B3\30FC\30C9\306FRGB(xxx,xxx,xxx)\3067\5B9A\7FA9\3055\308C\3001xxx\306F0\304B\3089255\306E\9593\306E\6570\5024\3067\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E8\30D3\30C3\30C8\30FB\30D0\30A4\30C8\5024\3092\8868\3057\307E\3059\3002</p>'),
unistr('<p>\30A4\30F3\30BF\30FC\30CD\30C3\30C8\3067HTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\3092\691C\7D22\3059\308B\3068\3001\4F7F\7528\3059\308B\8272\306E16\9032\30B3\30FC\30C9\307E\305F\306FRGB\30B3\30FC\30C9\304C\308F\304B\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104348812912308718)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_BG_COLOR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D0\30C3\30AF\30B0\30E9\30A6\30F3\30C9\30FB\30AB\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104434856096308783)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_COLOR.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\306AHTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\306E\4F8B\306B\306F\6B21\306E\3082\306E\304C\3042\308A\307E\3059 -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104348706278308718)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_COLOR.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306E\8868\793A\306B\4F7F\7528\3055\308C\308B\8272\3092\5165\529B\3057\307E\3059\3002</p>'),
unistr('<p>\8272\306F\300116\9032(hex)\8868\8A18\3001RGB\30AB\30E9\30FC\30FB\30B3\30FC\30C9\307E\305F\306FHTML\30AB\30E9\30FC\540D\3092\4F7F\7528\3057\3066\6307\5B9A\3055\308C\307E\3059\300216\9032\8868\8A18\306F#xxyyzz (#\306E\5F8C\306B3\3064\306E2\6841\306E16\9032\6570)\3067\5B9A\7FA9\3055\308C\3001xx\3001yy\304A\3088\3073zz\306F\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E2\6587\5B57\306E16\9032\306E\5024\3092\8868\3057\307E\3059\3002'),
unistr('RGB\30B3\30FC\30C9\306FRGB(xxx,xxx,xxx)\3067\5B9A\7FA9\3055\308C\3001xxx\306F0\304B\3089255\306E\9593\306E\6570\5024\3067\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E8\30D3\30C3\30C8\30FB\30D0\30A4\30C8\5024\3092\8868\3057\307E\3059\3002</p>'),
unistr('<p>\30A4\30F3\30BF\30FC\30CD\30C3\30C8\3067HTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\3092\691C\7D22\3059\308B\3068\3001\4F7F\7528\3059\308B\8272\306E16\9032\30B3\30FC\30C9\307E\305F\306FRGB\30B3\30FC\30C9\304C\308F\304B\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104348675696308718)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_COLOR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30F3\30C8\30FB\30AB\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104348172279308718)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_FAMILY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306E\30D5\30A9\30F3\30C8\30FB\30D5\30A7\30A4\30B9\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104434561526308783)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'ja'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104434381044308783)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'ja'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104434464385308783)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'ja'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104348009395308718)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_FAMILY.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104348530727308718)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_SIZE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306E\30D5\30A9\30F3\30C8\30FB\30B5\30A4\30BA\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104348480244308718)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_SIZE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30F3\30C8\30FB\30B5\30A4\30BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104348395962308718)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_WEIGHT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306E\30D5\30A9\30F3\30C8\306E\592A\3055\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104434780432308783)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_WEIGHT.LOV.BOLD.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\592A\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104434625249308783)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_WEIGHT.LOV.NORMAL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A19\6E96')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104348237437308718)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_WEIGHT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30F3\30C8\306E\592A\3055')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104469793404308809)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_BG_COLOR.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\306AHTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\306E\4F8B\306B\306F\6B21\306E\3082\306E\304C\3042\308A\307E\3059 -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104347960988308718)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_BG_COLOR.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306E\30D0\30C3\30AF\30B0\30E9\30A6\30F3\30C9\306E\8868\793A\306B\4F7F\7528\3055\308C\308B\8272\3092\5165\529B\3057\307E\3059\3002</p>'),
unistr('<p>\8272\306F\300116\9032(hex)\8868\8A18\3001RGB\30AB\30E9\30FC\30FB\30B3\30FC\30C9\307E\305F\306FHTML\30AB\30E9\30FC\540D\3092\4F7F\7528\3057\3066\6307\5B9A\3055\308C\307E\3059\300216\9032\8868\8A18\306F#xxyyzz (#\306E\5F8C\306B3\3064\306E2\6841\306E16\9032\6570)\3067\5B9A\7FA9\3055\308C\3001xx\3001yy\304A\3088\3073zz\306F\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E2\6587\5B57\306E16\9032\306E\5024\3092\8868\3057\307E\3059\3002'),
unistr('RGB\30B3\30FC\30C9\306FRGB(xxx,xxx,xxx)\3067\5B9A\7FA9\3055\308C\3001xxx\306F0\304B\3089255\306E\9593\306E\6570\5024\3067\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E8\30D3\30C3\30C8\30FB\30D0\30A4\30C8\5024\3092\8868\3057\307E\3059\3002</p>'),
unistr('<p>\30A4\30F3\30BF\30FC\30CD\30C3\30C8\3067HTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\3092\691C\7D22\3059\308B\3068\3001\4F7F\7528\3059\308B\8272\306E16\9032\30B3\30FC\30C9\307E\305F\306FRGB\30B3\30FC\30C9\304C\308F\304B\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104347829356308717)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_BG_COLOR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D0\30C3\30AF\30B0\30E9\30A6\30F3\30C9\30FB\30AB\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104434261141308783)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_COLOR.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\306AHTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\306E\4F8B\306B\306F\6B21\306E\3082\306E\304C\3042\308A\307E\3059 -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104347727399308717)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_COLOR.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306E\8868\793A\306B\4F7F\7528\3055\308C\308B\8272\3092\5165\529B\3057\307E\3059\3002</p>'),
unistr('<p>\8272\306F\300116\9032(hex)\8868\8A18\3001RGB\30AB\30E9\30FC\30FB\30B3\30FC\30C9\307E\305F\306FHTML\30AB\30E9\30FC\540D\3092\4F7F\7528\3057\3066\6307\5B9A\3055\308C\307E\3059\300216\9032\8868\8A18\306F#xxyyzz (#\306E\5F8C\306B3\3064\306E2\6841\306E16\9032\6570)\3067\5B9A\7FA9\3055\308C\3001xx\3001yy\304A\3088\3073zz\306F\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E2\6587\5B57\306E16\9032\306E\5024\3092\8868\3057\307E\3059\3002'),
unistr('RGB\30B3\30FC\30C9\306FRGB(xxx,xxx,xxx)\3067\5B9A\7FA9\3055\308C\3001xxx\306F0\304B\3089255\306E\9593\306E\6570\5024\3067\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E8\30D3\30C3\30C8\30FB\30D0\30A4\30C8\5024\3092\8868\3057\307E\3059\3002</p>'),
unistr('<p>\30A4\30F3\30BF\30FC\30CD\30C3\30C8\3067HTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\3092\691C\7D22\3059\308B\3068\3001\4F7F\7528\3059\308B\8272\306E16\9032\30B3\30FC\30C9\307E\305F\306FRGB\30B3\30FC\30C9\304C\308F\304B\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104347636943308717)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_COLOR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30F3\30C8\30FB\30AB\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104347102487308717)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_FAMILY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306E\30D5\30A9\30F3\30C8\30FB\30D5\30A7\30A4\30B9\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104433917311308783)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'ja'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104433722196308782)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'ja'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104433885962308783)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'ja'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104347075989308717)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_FAMILY.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104347532775308717)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_SIZE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306E\30D5\30A9\30F3\30C8\30FB\30B5\30A4\30BA\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104347452264308717)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_SIZE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30F3\30C8\30FB\30B5\30A4\30BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104347306414308717)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_WEIGHT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306E\30D5\30A9\30F3\30C8\306E\592A\3055\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104434177453308783)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_WEIGHT.LOV.BOLD.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\592A\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104434081591308783)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_WEIGHT.LOV.NORMAL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A19\6E96')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104347239841308717)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_WEIGHT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30F3\30C8\306E\592A\3055')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104236762600308636)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\3092\51FA\529B\3059\308B\969B\3001\3053\306E\5217\306E\30B5\30A4\30BA\8A2D\5B9A\306B\4F7F\7528\3059\308B\5217\5E45\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104236672509308636)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\51FA\529B\5E45')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104351550692308720)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH_UNITS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\5E45\306E\5024\306E\5B9A\7FA9\306B\4F7F\7528\3059\308B\5358\4F4D\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104436351976308784)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH_UNITS.LOV.PERCENTAGE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5272\5408')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104436435523308784)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH_UNITS.LOV.POINTS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DD\30A4\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104351444765308720)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH_UNITS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5E45\306E\5358\4F4D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104350714327308720)
,p_name=>'PE.PROPERTY.PRINT_FILE_NAME.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30C0\30A6\30F3\30ED\30FC\30C9\3055\308C\308B\30C9\30AD\30E5\30E1\30F3\30C8\306E\540D\524D\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002\7A7A\767D\306B\3059\308B\3068\3001\30EA\30FC\30B8\30E7\30F3\540D\304C\30D5\30A1\30A4\30EB\540D\3068\3057\3066\4F7F\7528\3055\308C\307E\3059\3002'),
'',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104350643292308720)
,p_name=>'PE.PROPERTY.PRINT_FILE_NAME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104345354393308716)
,p_name=>'PE.PROPERTY.PRINT_HEIGHT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DA\30FC\30B8\306E\9AD8\3055\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104345279095308716)
,p_name=>'PE.PROPERTY.PRINT_HEIGHT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\9AD8\3055')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104352138052308721)
,p_name=>'PE.PROPERTY.PRINT_LINK_TEXT.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30C0\30A6\30F3\30ED\30FC\30C9\30FB\30EA\30F3\30AF\306B\5BFE\3059\308B\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002\30EA\30F3\30AF\3092\30DC\30BF\30F3\306A\3069\306E\5225\306E\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\7F6E\304D\63DB\3048\308B\306B\306F\3001\3053\306E\30D5\30A3\30FC\30EB\30C9\3092\7A7A\767D\306B\3057\307E\3059\3002\30BF\30FC\30B2\30C3\30C8\3068\3057\3066\6B21\306E\69CB\6587\3092\542B\3080URL\3092\4F7F\7528\3057\3066\51FA\529B\30D7\30ED\30BB\30B9\3092\958B\59CB\3059\308B\5225\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\3092\8A2D\5B9A\3067\304D\307E\3059\3002</p>'),
'<p><pre>f?p=&amp;APP_ID.:&amp;SESSION.:FLOW_XMLP_OUTPUT_R[REGION_ID]</pre></p>',
unistr('<p><strong>\30CE\30FC\30C8</strong>: \524D\8FF0\306E\6587\5B57\5217\306E<code>[REGION_ID]</code>\3092\3001\4F7F\7528\3059\308B\30EA\30FC\30B8\30E7\30F3ID\306B\7F6E\304D\63DB\3048\3066\304F\3060\3055\3044\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104352013163308720)
,p_name=>'PE.PROPERTY.PRINT_LINK_TEXT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30F3\30AF\30FB\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104344753154308715)
,p_name=>'PE.PROPERTY.PRINT_ORIENTATION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306E\5411\304D\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104432248827308781)
,p_name=>'PE.PROPERTY.PRINT_ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A2A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104432182548308781)
,p_name=>'PE.PROPERTY.PRINT_ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\7E26')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104344657995308715)
,p_name=>'PE.PROPERTY.PRINT_ORIENTATION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5411\304D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104351617202308720)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.COMPONENT_PROPERTY.CLASSIC_REPORT_PRINT_ATTR.NULL_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\304B\3089\5C0E\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104352234777308721)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.COMPONENT_PROPERTY.TABULAR_FORM_PRINT_ATTR.NULL_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\304B\3089\5C0E\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104350941808308720)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\51FA\529B\5F62\5F0F\3092\9078\629E\3057\307E\3059\3002\51FA\529B\5F62\5F0F\3092\30A2\30A4\30C6\30E0\306B\3088\3063\3066\6307\5B9A\3059\308B\3053\3068\3082\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104436185081308784)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.LOV.HTM.D'
,p_message_language=>'ja'
,p_message_text=>'HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104435818525308784)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.LOV.PDF.D'
,p_message_language=>'ja'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104435916099308784)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.LOV.RTF.D'
,p_message_language=>'ja'
,p_message_text=>'Word'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104436014264308784)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.LOV.XLS.D'
,p_message_language=>'ja'
,p_message_text=>'Excel'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104436278929308784)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.LOV.XML.D'
,p_message_language=>'ja'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104350811049308720)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F8\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104351124280308720)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT_ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\66F8\5F0F\5024\3092\4FDD\6301\3059\308B\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002\30E6\30FC\30B6\30FC\304C\5B9F\884C\6642\306B\51FA\529B\66F8\5F0F\3092\9078\629E\3059\308B<em>\300C\9078\629E\30EA\30B9\30C8\300D</em>\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3092\542B\3081\308B\3053\3068\304C\3067\304D\307E\3059\3002\6709\52B9\306A\5024\306F\6B21\306E\3068\304A\308A\3067\3059\3002</p>'),
'<dl>',
'<dt>PDF</dt>',
unistr('<dd>PDF\30D7\30EC\30D3\30E5\30FC\30A2\3067\30C9\30AD\30E5\30E1\30F3\30C8\3092\958B\304D\307E\3059</dd>'),
'<dt>RTF</dt>',
unistr('<dd>Microsoft Word\3067\30C9\30AD\30E5\30E1\30F3\30C8\3092\958B\304D\307E\3059</dd>'),
'<dt>XLS</dt>',
unistr('<dd>Microsoft Excel\3067\30C9\30AD\30E5\30E1\30F3\30C8\3092\958B\304D\307E\3059</dd>'),
'<dt>HTM</dt>',
unistr('<dd>HTML\30D5\30A1\30A4\30EB\3068\3057\3066\30C9\30AD\30E5\30E1\30F3\30C8\3092\30C0\30A6\30F3\30ED\30FC\30C9\3057\307E\3059</dd>'),
'<dt>XML</dt>',
unistr('<dd>XML\30D5\30A1\30A4\30EB\3068\3057\3066\30C9\30AD\30E5\30E1\30F3\30C8\3092\30C0\30A6\30F3\30ED\30FC\30C9\3057\307E\3059</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104351083968308720)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT_ITEM.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F8\5F0F\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104349997905308719)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_ALIGNMENT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30D5\30C3\30BF\30FC\306E\4F4D\7F6E\5408\305B\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104435619518308784)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_ALIGNMENT.LOV.CENTER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E2D\592E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104435575526308784)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104435765592308784)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D42\4E86')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104349882273308719)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_ALIGNMENT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F4D\7F6E\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104435405142308784)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_COLOR.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\306AHTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\306E\4F8B\306B\306F\6B21\306E\3082\306E\304C\3042\308A\307E\3059 -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104349744774308719)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_COLOR.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306E\8868\793A\306B\4F7F\7528\3055\308C\308B\8272\3092\5165\529B\3057\307E\3059\3002</p>'),
unistr('<p>\8272\306F\300116\9032(hex)\8868\8A18\3001RGB\30AB\30E9\30FC\30FB\30B3\30FC\30C9\307E\305F\306FHTML\30AB\30E9\30FC\540D\3092\4F7F\7528\3057\3066\6307\5B9A\3055\308C\307E\3059\300216\9032\8868\8A18\306F#xxyyzz (#\306E\5F8C\306B3\3064\306E2\6841\306E16\9032\6570)\3067\5B9A\7FA9\3055\308C\3001xx\3001yy\304A\3088\3073zz\306F\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E2\6587\5B57\306E16\9032\306E\5024\3092\8868\3057\307E\3059\3002'),
unistr('RGB\30B3\30FC\30C9\306FRGB(xxx,xxx,xxx)\3067\5B9A\7FA9\3055\308C\3001xxx\306F0\304B\3089255\306E\9593\306E\6570\5024\3067\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E8\30D3\30C3\30C8\30FB\30D0\30A4\30C8\5024\3092\8868\3057\307E\3059\3002</p>'),
unistr('<p>\30A4\30F3\30BF\30FC\30CD\30C3\30C8\3067HTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\3092\691C\7D22\3059\308B\3068\3001\4F7F\7528\3059\308B\8272\306E16\9032\30B3\30FC\30C9\307E\305F\306FRGB\30B3\30FC\30C9\304C\308F\304B\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104349674726308719)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_COLOR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30F3\30C8\30FB\30AB\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104349186326308718)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_FAMILY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306E\30D5\30A9\30F3\30C8\30FB\30D5\30A7\30A4\30B9\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104435114968308784)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'ja'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104434981225308783)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'ja'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104435023072308783)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'ja'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104349073090308718)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_FAMILY.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104349510565308719)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_SIZE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306E\30D5\30A9\30F3\30C8\30FB\30B5\30A4\30BA\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104349405147308719)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_SIZE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30F3\30C8\30FB\30B5\30A4\30BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104349356575308719)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_WEIGHT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306E\30D5\30A9\30F3\30C8\306E\592A\3055\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104435396074308784)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_WEIGHT.LOV.BOLD.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\592A\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104435234785308784)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_WEIGHT.LOV.NORMAL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A19\6E96')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104349271099308718)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_WEIGHT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30F3\30C8\306E\592A\3055')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104350122420308719)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_TEXT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C9\30AD\30E5\30E1\30F3\30C8\306E\30D5\30C3\30BF\30FC\30FB\30BB\30AF\30B7\30E7\30F3\306B\8868\793A\3059\308B\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\306E\5024\3092\8868\793A\3059\308B\306B\306F\3001<code>&amp;ITEM_NAME.</code>\69CB\6587\3092\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104350090890308719)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_TEXT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30D5\30C3\30BF\30FC\30FB\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104346707393308717)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_ALIGNMENT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30D8\30C3\30C0\30FC\306E\4F4D\7F6E\5408\305B\3092\9078\629E\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104433551083308782)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_ALIGNMENT.LOV.CENTER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E2D\592E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104433452701308782)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104433638683308782)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D42\4E86')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104346618392308717)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_ALIGNMENT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F4D\7F6E\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104433373672308782)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_COLOR.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\306AHTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\306E\4F8B\306B\306F\6B21\306E\3082\306E\304C\3042\308A\307E\3059 -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104346573125308717)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_COLOR.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306E\8868\793A\306B\4F7F\7528\3055\308C\308B\8272\3092\5165\529B\3057\307E\3059\3002</p>'),
unistr('<p>\8272\306F\300116\9032(hex)\8868\8A18\3001RGB\30AB\30E9\30FC\30FB\30B3\30FC\30C9\307E\305F\306FHTML\30AB\30E9\30FC\540D\3092\4F7F\7528\3057\3066\6307\5B9A\3055\308C\307E\3059\300216\9032\8868\8A18\306F#xxyyzz (#\306E\5F8C\306B3\3064\306E2\6841\306E16\9032\6570)\3067\5B9A\7FA9\3055\308C\3001xx\3001yy\304A\3088\3073zz\306F\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E2\6587\5B57\306E16\9032\306E\5024\3092\8868\3057\307E\3059\3002'),
unistr('RGB\30B3\30FC\30C9\306FRGB(xxx,xxx,xxx)\3067\5B9A\7FA9\3055\308C\3001xxx\306F0\304B\3089255\306E\9593\306E\6570\5024\3067\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E8\30D3\30C3\30C8\30FB\30D0\30A4\30C8\5024\3092\8868\3057\307E\3059\3002</p>'),
unistr('<p>\30A4\30F3\30BF\30FC\30CD\30C3\30C8\3067HTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\3092\691C\7D22\3059\308B\3068\3001\4F7F\7528\3059\308B\8272\306E16\9032\30B3\30FC\30C9\307E\305F\306FRGB\30B3\30FC\30C9\304C\308F\304B\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104346497772308716)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_COLOR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30F3\30C8\30FB\30AB\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104345970090308716)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_FAMILY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306E\30D5\30A9\30F3\30C8\30FB\30D5\30A7\30A4\30B9\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104433073054308782)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'ja'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104432871920308782)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'ja'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104432953713308782)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'ja'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104345890321308716)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_FAMILY.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104346333551308716)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_SIZE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306E\30D5\30A9\30F3\30C8\30FB\30B5\30A4\30BA\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104346262793308716)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_SIZE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30F3\30C8\30FB\30B5\30A4\30BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104346164603308716)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_WEIGHT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306E\30D5\30A9\30F3\30C8\306E\592A\3055\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104433275341308782)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_WEIGHT.LOV.BOLD.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\592A\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104433120498308782)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_WEIGHT.LOV.NORMAL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A19\6E96')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104346018881308716)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_WEIGHT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30F3\30C8\306E\592A\3055')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104346998039308717)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_TEXT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C9\30AD\30E5\30E1\30F3\30C8\306E\30D8\30C3\30C0\30FC\30FB\30BB\30AF\30B7\30E7\30F3\306B\8868\793A\3059\308B\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\306E\5024\3092\8868\793A\3059\308B\306B\306F\3001<code>&amp;ITEM_NAME.</code>\69CB\6587\3092\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104346862376308717)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_TEXT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30D8\30C3\30C0\30FC\306E\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104344597878308715)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\306E\30DA\30FC\30B8\30FB\30B5\30A4\30BA\3092\9078\629E\3057\307E\3059\3002\30E6\30FC\30B6\30FC\72EC\81EA\306E\30DA\30FC\30B8\306E\5E45\304A\3088\3073\9AD8\3055\3092\5165\529B\3059\308B\306B\306F\3001<strong>\300C\30AB\30B9\30BF\30E0\300D</strong>\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104431940648308781)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.A3.D'
,p_message_language=>'ja'
,p_message_text=>'A3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104431810214308781)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.A4.D'
,p_message_language=>'ja'
,p_message_text=>'A4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104432060793308781)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.CUSTOM.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30B9\30BF\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104431668341308781)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.LEGAL.D'
,p_message_language=>'ja'
,p_message_text=>'Legal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104431505720308781)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.LETTER.D'
,p_message_language=>'ja'
,p_message_text=>'Letter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104431756226308781)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.TABLOID.D'
,p_message_language=>'ja'
,p_message_text=>'Tabloid'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104344428601308715)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30A4\30BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104344946264308715)
,p_name=>'PE.PROPERTY.PRINT_UNITS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306E\5E45\304A\3088\3073\9AD8\3055\306E\6307\5B9A\306B\4F7F\7528\3059\308B\5358\4F4D\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104432589992308781)
,p_name=>'PE.PROPERTY.PRINT_UNITS.LOV.CENTIMETERS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30F3\30C1\30E1\30FC\30C8\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104432314739308781)
,p_name=>'PE.PROPERTY.PRINT_UNITS.LOV.INCHES.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104432480285308781)
,p_name=>'PE.PROPERTY.PRINT_UNITS.LOV.MILLIMETERS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DF\30EA\30E1\30FC\30C8\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104432622089308782)
,p_name=>'PE.PROPERTY.PRINT_UNITS.LOV.POINTS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DD\30A4\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104344857156308715)
,p_name=>'PE.PROPERTY.PRINT_UNITS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5358\4F4D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104344357552308715)
,p_name=>'PE.PROPERTY.PRINT_VIEW_FILE_AS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\51FA\529B\30C9\30AD\30E5\30E1\30F3\30C8\306Econtent-disposition\3092\9078\629E\3057\307E\3059\3002content-disposition\306F\3001\30C9\30AD\30E5\30E1\30F3\30C8\306E\8868\793A\65B9\6CD5\3092\30D6\30E9\30A6\30B6\306B\6307\793A\3059\308B\3001MIME\30D7\30ED\30C8\30B3\30EB\306E\62E1\5F35\6A5F\80FD\3067\3059\3002<strong>\300C\6DFB\4ED8\300D</strong>\3092\9078\629E\3059\308B\3068\3001\30D5\30A1\30A4\30EB\3092\30A4\30F3\30E9\30A4\30F3\3067\8868\793A\305B\305A\30C7\30A3\30B9\30AF\306B\4FDD\5B58\3059\308B\3088\3046\30D6\30E9\30A6\30B6\306B\6307\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104431340331308781)
,p_name=>'PE.PROPERTY.PRINT_VIEW_FILE_AS.LOV.ATTACHMENT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6DFB\4ED8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104431414431308781)
,p_name=>'PE.PROPERTY.PRINT_VIEW_FILE_AS.LOV.INLINE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30E9\30A4\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104344218231308715)
,p_name=>'PE.PROPERTY.PRINT_VIEW_FILE_AS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\306E\8868\793A\5F62\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104345109335308716)
,p_name=>'PE.PROPERTY.PRINT_WIDTH.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DA\30FC\30B8\306E\5E45\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104345015494308715)
,p_name=>'PE.PROPERTY.PRINT_WIDTH.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5E45')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103704780179308171)
,p_name=>'PE.PROPERTY.PROCESS_DATA_SOURCE_REGION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306B\5BFE\3057\3066\95A2\9023\4ED8\3051\3089\308C\308B\30D5\30A9\30FC\30E0\30FB\30EA\30FC\30B8\30E7\30F3\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103704680788308171)
,p_name=>'PE.PROPERTY.PROCESS_DATA_SOURCE_REGION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30FC\30E0\30FB\30EA\30FC\30B8\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104222056705308626)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30D7\30ED\30BB\30B9\304C\6B63\5E38\306B\5B8C\4E86\3057\306A\304B\3063\305F\5834\5408\306E\3053\306E\30D7\30ED\30BB\30B9\30FB\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\306E\8868\793A\5834\6240\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104411910078308766)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.LOV.INLINE_IN_NOTIFICATION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\901A\77E5\3067\30A4\30F3\30E9\30A4\30F3\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104412031002308766)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.LOV.INLINE_IN_NOTIFICATION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30BB\30B9\30FB\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\304C\300C\901A\77E5\300D\9818\57DF(\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306E\4E00\90E8\3068\3057\3066\5B9A\7FA9)\306B\8868\793A\3055\308C\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104412180991308766)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.LOV.ON_ERROR_PAGE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC\30FB\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104412256664308766)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.LOV.ON_ERROR_PAGE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30BB\30B9\30FB\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\304C\30A8\30E9\30FC\30FB\30DA\30FC\30B8\306B\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104221975743308626)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103885958131308312)
,p_name=>'PE.PROPERTY.PROCESS_POINT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\5185\306E\3069\306E\30DD\30A4\30F3\30C8\3067\3001\3053\306E\30D7\30ED\30BB\30B9\306E\30EC\30F3\30C0\30EA\30F3\30B0\307E\305F\306F\51E6\7406\3092\5B9F\884C\3059\308B\304B\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104397526680308755)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_BOX_BODY.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\306E\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104689434691308991)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_BOX_BODY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30F3\30C0\30EA\30F3\30B0: \30EA\30FC\30B8\30E7\30F3\306E\30EC\30F3\30C0\30EA\30F3\30B0\5F8C\306B\5B9F\884C\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104397743247308755)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_FOOTER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30C3\30BF\30FC\306E\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104689624587308991)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_FOOTER.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30F3\30C0\30EA\30F3\30B0: \30DA\30FC\30B8\306E\30EC\30F3\30C0\30EA\30F3\30B0\5F8C\306B\5B9F\884C\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104397376075308755)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_HEADER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D8\30C3\30C0\30FC\306E\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104689237565308991)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_HEADER.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30F3\30C0\30EA\30F3\30B0: \30D8\30C3\30C0\30FC\306E\30EC\30F3\30C0\30EA\30F3\30B0\5F8C\306B\5B9F\884C\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104397928147308756)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_SUBMIT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30BB\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104689854182308992)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_SUBMIT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\51E6\7406: \30DA\30FC\30B8\51E6\7406\306E\5B9F\884C\6642\306B\3001\691C\8A3C\304A\3088\3073\8A08\7B97\306E\5B9F\884C\5F8C\306B\5B9F\884C\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104397470252308755)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_BOX_BODY.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\306E\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104689370000308991)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_BOX_BODY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30F3\30C0\30EA\30F3\30B0: \30EA\30FC\30B8\30E7\30F3\306E\30EC\30F3\30C0\30EA\30F3\30B0\524D\306B\5B9F\884C\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104397642319308755)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_FOOTER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30C3\30BF\30FC\306E\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104689520831308991)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_FOOTER.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30F3\30C0\30EA\30F3\30B0: \30D5\30C3\30BF\30FC\306E\30EC\30F3\30C0\30EA\30F3\30B0\524D\306B\5B9F\884C\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104397272659308755)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_HEADER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D8\30C3\30C0\30FC\306E\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104689109447308991)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_HEADER.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30F3\30C0\30EA\30F3\30B0: \30DA\30FC\30B8\306E\30EC\30F3\30C0\30EA\30F3\30B0\524D\306B\5B9F\884C\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104398029584308756)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_DEMAND.D'
,p_message_language=>'ja'
,p_message_text=>unistr('Ajax\30B3\30FC\30EB\30D0\30C3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104689993015308992)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_DEMAND.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('apex.server JavaScipt API\306B\3088\308B\547C\51FA\3057\6642\306B\5B9F\884C\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104397168873308755)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_NEW_INSTANCE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F\30BB\30C3\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104689099922308991)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_NEW_INSTANCE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\3057\3044\30BB\30C3\30B7\30E7\30F3\306E\751F\6210\6642\306B\5B9F\884C\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104397833507308756)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_SUBMIT_BEFORE_COMPUTATION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\9001\4FE1\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104689727093308992)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_SUBMIT_BEFORE_COMPUTATION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\51E6\7406: \30DA\30FC\30B8\306E\9001\4FE1\5F8C\3067\3001\8A08\7B97\3001\691C\8A3C\304A\3088\3073\30DA\30FC\30B8\51E6\7406\306E\5B9F\884C\524D\306B\5B9F\884C\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103885839325308312)
,p_name=>'PE.PROPERTY.PROCESS_POINT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DD\30A4\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104222294433308626)
,p_name=>'PE.PROPERTY.PROCESS_REGION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30D7\30ED\30BB\30B9\306B\95A2\9023\4ED8\3051\308B\30EA\30FC\30B8\30E7\30F3\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104222155087308626)
,p_name=>'PE.PROPERTY.PROCESS_REGION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7DE8\96C6\53EF\80FD\30EA\30FC\30B8\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104100560950308517)
,p_name=>'PE.PROPERTY.PUBLIC_REPORT_AUTH_SCHEME.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30D1\30D6\30EA\30C3\30AF\30FB\30EC\30DD\30FC\30C8\5B9A\7FA9\3092\4FDD\5B58\3067\304D\308B\30E6\30FC\30B6\30FC\3092\5236\9650\3059\308B\8A8D\53EF\30B9\30AD\30FC\30E0\3092\9078\629E\3057\307E\3059\3002'),
unistr('		\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\30D1\30D6\30EA\30C3\30AF\30FB\30EC\30DD\30FC\30C8\3092\4FDD\5B58\3067\304D\308B\305F\3081\306B\306F\3001\3053\306E\8A8D\53EF\30B9\30AD\30FC\30E0\304C\305D\306E\30E6\30FC\30B6\30FC\306B\5BFE\3057\3066TRUE\3068\8A55\4FA1\3055\308C\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>'),
unistr('		<p>\30CE\30FC\30C8 - \8A8D\53EF\30B9\30AD\30FC\30E0\3092\6307\5B9A\3057\306A\3044\5834\5408\3001\3060\308C\3067\3082\30D1\30D6\30EA\30C3\30AF\30FB\30EC\30DD\30FC\30C8\3092\4FDD\5B58\3067\304D\307E\3059\3002</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104100415546308517)
,p_name=>'PE.PROPERTY.PUBLIC_REPORT_AUTH_SCHEME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30D6\30EA\30C3\30AF\30FB\30EC\30DD\30FC\30C8\306E\4FDD\5B58\306E\8A8D\53EF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104470776513308810)
,p_name=>'PE.PROPERTY.QUERY_COLUMN_ID.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('$$$ DJP\73FE\5728\975E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104261469788308654)
,p_name=>'PE.PROPERTY.QUERY_COLUMN_ID.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\5217\554F\5408\305BID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103893099674308317)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_01.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('1\3064\76EE\306E<strong>\30AF\30A4\30C3\30AF\9078\629E</strong>\306E\30E9\30D9\30EB\3092\5165\529B\3057\307E\3059\3002\3053\306E\30E9\30D9\30EB\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\8868\793A\3055\308C\308B\30C6\30AD\30B9\30C8\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103892989787308317)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_01.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103893418122308318)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_02.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('2\3064\76EE\306E<strong>\30AF\30A4\30C3\30AF\9078\629E</strong>\306E\30E9\30D9\30EB\3092\5165\529B\3057\307E\3059\3002\3053\306E\30E9\30D9\30EB\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\8868\793A\3055\308C\308B\30C6\30AD\30B9\30C8\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103893360002308318)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_02.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103893866146308318)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_03.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('3\3064\76EE\306E<strong>\30AF\30A4\30C3\30AF\9078\629E</strong>\306E\30E9\30D9\30EB\3092\5165\529B\3057\307E\3059\3002\3053\306E\30E9\30D9\30EB\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\8868\793A\3055\308C\308B\30C6\30AD\30B9\30C8\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103893732087308318)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_03.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103894293768308318)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_04.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('4\3064\76EE\306E<strong>\30AF\30A4\30C3\30AF\9078\629E</strong>\306E\30E9\30D9\30EB\3092\5165\529B\3057\307E\3059\3002\3053\306E\30E9\30D9\30EB\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\8868\793A\3055\308C\308B\30C6\30AD\30B9\30C8\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103894180068308318)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_04.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103894605578308319)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_05.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('5\3064\76EE\306E<strong>\30AF\30A4\30C3\30AF\9078\629E</strong>\306E\30E9\30D9\30EB\3092\5165\529B\3057\307E\3059\3002\3053\306E\30E9\30D9\30EB\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\8868\793A\3055\308C\308B\30C6\30AD\30B9\30C8\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103894513029308319)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_05.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103895018525308319)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_06.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('6\3064\76EE\306E<strong>\30AF\30A4\30C3\30AF\9078\629E</strong>\306E\30E9\30D9\30EB\3092\5165\529B\3057\307E\3059\3002\3053\306E\30E9\30D9\30EB\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\8868\793A\3055\308C\308B\30C6\30AD\30B9\30C8\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103894910456308319)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_06.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103895464427308319)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_07.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('7\3064\76EE\306E<strong>\30AF\30A4\30C3\30AF\9078\629E</strong>\306E\30E9\30D9\30EB\3092\5165\529B\3057\307E\3059\3002\3053\306E\30E9\30D9\30EB\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\8868\793A\3055\308C\308B\30C6\30AD\30B9\30C8\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103895382458308319)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_07.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103895834030308324)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_08.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('8\3064\76EE\306E<strong>\30AF\30A4\30C3\30AF\9078\629E</strong>\306E\30E9\30D9\30EB\3092\5165\529B\3057\307E\3059\3002\3053\306E\30E9\30D9\30EB\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\8868\793A\3055\308C\308B\30C6\30AD\30B9\30C8\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103895708716308324)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_08.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103896221887308324)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_09.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('9\3064\76EE\306E<strong>\30AF\30A4\30C3\30AF\9078\629E</strong>\306E\30E9\30D9\30EB\3092\5165\529B\3057\307E\3059\3002\3053\306E\30E9\30D9\30EB\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\8868\793A\3055\308C\308B\30C6\30AD\30B9\30C8\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103896160827308324)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_09.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103896656492308324)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_10.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('10\500B\76EE\306E<strong>\30AF\30A4\30C3\30AF\9078\629E</strong>\306E\30E9\30D9\30EB\3092\5165\529B\3057\307E\3059\3002\3053\306E\30E9\30D9\30EB\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\8868\793A\3055\308C\308B\30C6\30AD\30B9\30C8\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103896511835308324)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_10.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB10')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103892815690308317)
,p_name=>'PE.PROPERTY.QUICK_PICK_LINK_ATTRIBUTES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5404<strong>\300C\30AF\30A4\30C3\30AF\9078\629E\300D</strong>\30EA\30F3\30AF\306E\8868\793A\3068\95A2\9023\4ED8\3051\3089\308C\308BHTML\5C5E\6027\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103892785217308317)
,p_name=>'PE.PROPERTY.QUICK_PICK_LINK_ATTRIBUTES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30F3\30AF\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103893295218308318)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_01.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('1\3064\76EE\306E<strong>\30AF\30A4\30C3\30AF\9078\629E</strong>\306B\95A2\9023\4ED8\3051\308B\5024\3092\5165\529B\3057\307E\3059\3002\30E6\30FC\30B6\30FC\304C\3053\306E\30AF\30A4\30C3\30AF\9078\629E\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\3053\306E\5024\3067\65E2\5B58\306E\30A2\30A4\30C6\30E0\5024\304C\7F6E\63DB\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103893146275308318)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_01.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\50241')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103893695941308318)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_02.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('2\3064\76EE\306E<strong>\30AF\30A4\30C3\30AF\9078\629E</strong>\306B\95A2\9023\4ED8\3051\308B\5024\3092\5165\529B\3057\307E\3059\3002\30E6\30FC\30B6\30FC\304C\3053\306E\30AF\30A4\30C3\30AF\9078\629E\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\3053\306E\5024\3067\65E2\5B58\306E\30A2\30A4\30C6\30E0\5024\304C\7F6E\63DB\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103893504668308318)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_02.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\50242')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103894019804308318)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_03.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('3\3064\76EE\306E<strong>\30AF\30A4\30C3\30AF\9078\629E</strong>\306B\95A2\9023\4ED8\3051\308B\5024\3092\5165\529B\3057\307E\3059\3002\30E6\30FC\30B6\30FC\304C\3053\306E\30AF\30A4\30C3\30AF\9078\629E\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\3053\306E\5024\3067\65E2\5B58\306E\30A2\30A4\30C6\30E0\5024\304C\7F6E\63DB\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103893906479308318)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_03.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\50243')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103894422348308319)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_04.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('4\3064\76EE\306E<strong>\30AF\30A4\30C3\30AF\9078\629E</strong>\306B\95A2\9023\4ED8\3051\308B\5024\3092\5165\529B\3057\307E\3059\3002\30E6\30FC\30B6\30FC\304C\3053\306E\30AF\30A4\30C3\30AF\9078\629E\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\3053\306E\5024\3067\65E2\5B58\306E\30A2\30A4\30C6\30E0\5024\304C\7F6E\63DB\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103894360995308318)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_04.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\50244')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103894803267308319)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_05.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('5\3064\76EE\306E<strong>\30AF\30A4\30C3\30AF\9078\629E</strong>\306B\95A2\9023\4ED8\3051\308B\5024\3092\5165\529B\3057\307E\3059\3002\30E6\30FC\30B6\30FC\304C\3053\306E\30AF\30A4\30C3\30AF\9078\629E\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\3053\306E\5024\3067\65E2\5B58\306E\30A2\30A4\30C6\30E0\5024\304C\7F6E\63DB\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103894726290308319)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_05.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\50245')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103895246620308319)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_06.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('6\3064\76EE\306E<strong>\30AF\30A4\30C3\30AF\9078\629E</strong>\306B\95A2\9023\4ED8\3051\308B\5024\3092\5165\529B\3057\307E\3059\3002\30E6\30FC\30B6\30FC\304C\3053\306E\30AF\30A4\30C3\30AF\9078\629E\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\3053\306E\5024\3067\65E2\5B58\306E\30A2\30A4\30C6\30E0\5024\304C\7F6E\63DB\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103895196914308319)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_06.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\50246')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103895669236308319)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_07.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('7\3064\76EE\306E<strong>\30AF\30A4\30C3\30AF\9078\629E</strong>\306B\95A2\9023\4ED8\3051\308B\5024\3092\5165\529B\3057\307E\3059\3002\30E6\30FC\30B6\30FC\304C\3053\306E\30AF\30A4\30C3\30AF\9078\629E\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\3053\306E\5024\3067\65E2\5B58\306E\30A2\30A4\30C6\30E0\5024\304C\7F6E\63DB\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103895545281308319)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_07.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\50247')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103896048972308324)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_08.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('8\3064\76EE\306E<strong>\30AF\30A4\30C3\30AF\9078\629E</strong>\306B\95A2\9023\4ED8\3051\308B\5024\3092\5165\529B\3057\307E\3059\3002\30E6\30FC\30B6\30FC\304C\3053\306E\30AF\30A4\30C3\30AF\9078\629E\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\3053\306E\5024\3067\65E2\5B58\306E\30A2\30A4\30C6\30E0\5024\304C\7F6E\63DB\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103895901977308324)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_08.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\50248')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103896451806308324)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_09.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('9\3064\76EE\306E<strong>\30AF\30A4\30C3\30AF\9078\629E</strong>\306B\95A2\9023\4ED8\3051\308B\5024\3092\5165\529B\3057\307E\3059\3002\30E6\30FC\30B6\30FC\304C\3053\306E\30AF\30A4\30C3\30AF\9078\629E\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\3053\306E\5024\3067\65E2\5B58\306E\30A2\30A4\30C6\30E0\5024\304C\7F6E\63DB\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103896319565308324)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_09.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\50249')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103896813570308325)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_10.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('10\500B\76EE\306E<strong>\30AF\30A4\30C3\30AF\9078\629E</strong>\306B\95A2\9023\4ED8\3051\308B\5024\3092\5165\529B\3057\307E\3059\3002\30E6\30FC\30B6\30FC\304C\3053\306E\30AF\30A4\30C3\30AF\9078\629E\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\3053\306E\5024\3067\65E2\5B58\306E\30A2\30A4\30C6\30E0\5024\304C\7F6E\63DB\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103896729379308324)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_10.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\502410')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104234905768308635)
,p_name=>'PE.PROPERTY.RADIO_COLUMNS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30E9\30B8\30AA\30FB\30B0\30EB\30FC\30D7\5217\306B\8868\793A\3059\308B\5217\306E\6570\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104234877461308635)
,p_name=>'PE.PROPERTY.RADIO_COLUMNS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\306E\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103966070856308410)
,p_name=>'PE.PROPERTY.RAS_DYNAMIC_ROLES.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Real Application Security\52D5\7684\30ED\30FC\30EB\3092\6B21\306E\3088\3046\306B\30B3\30ED\30F3\3067\533A\5207\3063\3066\5165\529B\3057\307E\3059\3002'),
'<pre>',
'DB_EMP:DB_DEPT',
'</pre></p>',
unistr('<p>&PRODUCT_NAME.\306F\3001<em>sys.dbms_xs_sessions.assign_user</em>\306E<em>enable_dynamic_roles</em>\30D1\30E9\30E1\30FC\30BF\3092\4ECB\3057\3066\6E21\3059\3053\3068\3067\3001\30ED\30B0\30AA\30F3\6642\306B\3053\308C\3089\306E\30ED\30FC\30EB\3092\6709\52B9\306B\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103965932065308410)
,p_name=>'PE.PROPERTY.RAS_DYNAMIC_ROLES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\52D5\7684\30ED\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103965831253308410)
,p_name=>'PE.PROPERTY.RAS_MODE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\306EOracle Real Application Security (RAS)\306E\4F7F\7528\65B9\6CD5\3092\9078\629E\3057\307E\3059\3002</p>'),
unistr('<p>RAS\30E2\30FC\30C9\3092\6709\52B9\306B\3059\308B\5834\5408\3001\30E6\30FC\30B6\30FC\306B\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30B9\30AD\30FC\30DE\30FB\30AA\30D6\30B8\30A7\30AF\30C8\306B\30A2\30AF\30BB\30B9\3059\308B\6A29\9650\304C\3042\308B\3053\3068\3092\78BA\8A8D\3057\307E\3059\3002'),
unistr('\305F\3068\3048\3070\3001<strong>\5916\90E8\30E6\30FC\30B6\30FC</strong>\306E\5834\5408\3001<em>RAS\52D5\7684\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30ED\30FC\30EB</em>\306B\30C7\30FC\30BF\30D9\30FC\30B9\6A29\9650\3092\4ED8\4E0E\3057\3001\3053\306E\8A8D\8A3C\30B9\30AD\30FC\30E0\3067<em>\52D5\7684\30ED\30FC\30EB</em>\3068\3057\3066\69CB\6210\3067\304D\307E\3059\3002'),
unistr('\8A8D\8A3C\5F8C\30D7\30ED\30B7\30FC\30B8\30E3\306A\3069\3067\306E<em>apex_authorization.enable_dynamic_groups</em>\3078\306E\30B3\30FC\30EB\3067\30ED\30FC\30EB\3092\6709\52B9\306B\3059\308B\3053\3068\3082\3067\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104399166091308757)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.0.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104690066726308992)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.0.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('Real Application Security\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\4F7F\7528\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104399216343308757)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.1.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5916\90E8\30E6\30FC\30B6\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104690147649308992)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.1.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('&PRODUCT_NAME.\3067\306F\3001\3059\3079\3066\306E\30E6\30FC\30B6\30FC\304C\5185\90E8\30E6\30FC\30B6\30FC\3068\307F\306A\3055\308C\3001<em>is_external</em>\30D1\30E9\30E1\30FC\30BF\3067<em>sys.dbms_xs_sessions.assign_user</em>\306B<em>false</em>\304C\6E21\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104399347326308757)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.2.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5185\90E8\30E6\30FC\30B6\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104690212628308992)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('&PRODUCT_NAME.\3067\306F\3001<em>is_external</em>\30D1\30E9\30E1\30FC\30BF\3067<em>sys.dbms_xs_sessions.assign_user</em>\306B<em>true</em>\304C\6E21\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103965741103308410)
,p_name=>'PE.PROPERTY.RAS_MODE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('RAS\30E2\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103966233496308410)
,p_name=>'PE.PROPERTY.RAS_NAMESPACES.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Real Application Security\30CD\30FC\30E0\30B9\30DA\30FC\30B9\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\6B21\306E\3088\3046\306B\30B3\30ED\30F3\3067\533A\5207\3063\3066\5165\529B\3057\307E\3059\3002'),
'<pre>',
'NS1:NS2',
'</pre></p>',
unistr('<p>&PRODUCT_NAME.\306F\3001<em>sys.dbms_xs_sessions.assign_user</em>\306E<em>namespaces</em>\30D1\30E9\30E1\30FC\30BF\3092\4ECB\3057\3066\6E21\3059\3053\3068\3067\3001\30ED\30B0\30AA\30F3\6642\306B\3053\308C\3089\306E\30CD\30FC\30E0\30B9\30DA\30FC\30B9\3092\6709\52B9\306B\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103966163961308410)
,p_name=>'PE.PROPERTY.RAS_NAMESPACES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CD\30FC\30E0\30B9\30DA\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104615078769308931)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F\5F0F\306E\8A55\4FA1\306B\4F7F\7528\3055\308C\308B\8A00\8A9E\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104615475303308931)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'ja'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104615364757308931)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'ja'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104615256225308931)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'ja'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104615547504308931)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'ja'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104615156503308931)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'ja'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104614990215308931)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A00\8A9E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104617021448308932)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\306E\5B9F\884C\306B\4F7F\7528\3055\308C\308B\8A00\8A9E\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104617374445308933)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'ja'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104617227552308933)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'ja'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104617170628308932)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'ja'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104617431739308933)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'ja'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104616910468308932)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A00\8A9E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103903211233308330)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_ITEM1.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\3067\4F7F\7528\3055\308C\308B\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103903164676308329)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_ITEM1.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103904622838308331)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_ITEM2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\3067\4F7F\7528\3055\308C\308B\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103904589693308331)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_ITEM2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104616624259308932)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3059\308BJava\5F0F\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104616572961308932)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('Java\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104618276308308933)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3057\3066\30D6\30FC\30EB\5024\3092\8FD4\3059Java\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104618150846308933)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('Java\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104616411302308932)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3059\308B\304B\3001\30DE\30CD\30FC\30B8\30E3\3067\3042\308B\5834\5408\3001\6B63\5E38\306B\5024\3092\8FD4\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104616325008308932)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3059\308BJavaScript\5F0F\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104616281241308932)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('JavaScript\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104618068091308933)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3059\308B\5834\5408\3001\6B63\5E38\306B\5024\3092\8FD4\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104617978366308933)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3057\3066\30D6\30FC\30EB\5024\3092\8FD4\3059JavaScript\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104617831136308933)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('JavaScript\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103903464857308330)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_LIST.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3059\308B\30B3\30ED\30F3(:)\3067\533A\5207\3089\308C\305F\5024\306E\30EA\30B9\30C8\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103903308478308330)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_LIST.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103903836176308330)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PAGE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3059\308B\30DA\30FC\30B8\756A\53F7\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103903730096308330)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PAGE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103904006719308330)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PAGES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3059\308B\30DA\30FC\30B8\756A\53F7\3092\30AB\30F3\30DE\3067\533A\5207\3063\3066\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103903918331308330)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PAGES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104616171257308932)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3059\308B\304B\3001\30DE\30CD\30FC\30B8\30E3\3067\3042\308B\5834\5408\3001\6B63\5E38\306B\5024\3092\8FD4\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104616095185308932)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3059\308BPL/SQL\5F0F\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104615921959308931)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104617771495308933)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3059\308B\5834\5408\3001\6B63\5E38\306B\5024\3092\8FD4\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104617656619308933)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3057\3066\30D6\30FC\30EB\5024\3092\8FD4\3059PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104617599914308933)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103903677259308330)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PREFERENCE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3057\3066\6307\5B9A\3055\308C\305F\5024\3068\6BD4\8F03\3059\308B\30E6\30FC\30B6\30FC\30FB\30D7\30EA\30D5\30A1\30EC\30F3\30B9\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103903562098308330)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PREFERENCE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30EA\30D5\30A1\30EC\30F3\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104616844692308932)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3059\308BPython\5F0F\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104616770561308932)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('Python\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104618409648308933)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3057\3066\30D6\30FC\30EB\5024\3092\8FD4\3059Python\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104618379912308933)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('Python\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104615807365308931)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\30DE\30CD\30FC\30B8\30E3\3067\3001\90E8\9580\304C\30B7\30AB\30B4\306B\5B58\5728\3059\308B\5834\5408\3001\6B63\5E38\306B\5024\3092\8FD4\3057\307E\3059\3002</dt>'),
'<dd><pre>',
':P2_JOB = ''MANAGER'' and',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104615756357308931)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3059\308BSQL\5F0F\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104615633491308931)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104765305738309062)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_STATEMENT.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3057\3066\3044\308B\304B\3069\3046\304B\3092\30C1\30A7\30C3\30AF\3057\305F\3068\304D\306B\30011\3064\4EE5\4E0A\306E\884C\304C\5B58\5728\3059\308B\3068\3001\6B63\5E38\306B\5024\3092\8FD4\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
unistr('<dt>\5F93\696D\54E1\304C\90E8\958040\306B\6240\5C5E\3057\3066\3044\308B\304B\3069\3046\304B\3092\30C1\30A7\30C3\30AF\3057\305F\3068\304D\306B\30011\3064\3082\884C\304C\5B58\5728\3057\306A\3044\3068\3001\6B63\5E38\306B\5024\3092\8FD4\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 40',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103902813859308329)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_STATEMENT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3059\308BSQL\554F\5408\305B\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103902773250308329)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_STATEMENT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103904256563308330)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TEXT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3059\308B\30C6\30AD\30B9\30C8\5024\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103904198294308330)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TEXT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103904894089308331)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TEXT2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3059\308B\5024(<code>&ITEM.</code>\7F6E\63DB\6587\5B57\5217\3092\542B\3080)\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103904796646308331)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TEXT2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104113711910308528)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\3092\8AAD\53D6\308A\5C02\7528\3068\3057\3066\30EC\30F3\30C0\30EA\30F3\30B0\3059\308B\305F\3081\306B\5FC5\8981\306A\6761\4EF6\30BF\30A4\30D7\3092\9078\629E\3057\307E\3059\3002'),
unistr('\6761\4EF6\3092\9078\629E\3057\306A\3044\5834\5408\3001\30A2\30A4\30C6\30E0\306F\901A\5E38\3069\304A\308A\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\307E\3059\3002'),
unistr('\8AAD\53D6\308A\5C02\7528\30A2\30A4\30C6\30E0\306F\8868\793A\306E\307F\306E\30A2\30A4\30C6\30E0\3068\540C\3058\8A2D\5B9A\3067\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8: \30A2\30A4\30C6\30E0\3092\5165\529B\53EF\80FD\30D5\30A3\30FC\30EB\30C9\3068\3057\3066\5E38\306B\30EC\30F3\30C0\30EA\30F3\30B0\3059\308B\306B\306F\3001\6761\4EF6\30BF\30A4\30D7\3092<strong>\300C\306A\3057\300D</strong>\306B\8A2D\5B9A\3057\3066\304F\3060\3055\3044\3002'),
unistr('\3053\306E\8A2D\5B9A\306B\3088\308A\3001\30EA\30FC\30B8\30E7\30F3\307E\305F\306F\30DA\30FC\30B8\30FB\30EC\30D9\30EB\306E\8AAD\53D6\308A\5C02\7528\6761\4EF6\8A2D\5B9A\304C\4E0A\66F8\304D\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103517788833308028)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\3092\8AAD\53D6\308A\5C02\7528\3068\3057\3066\30EC\30F3\30C0\30EA\30F3\30B0\3059\308B\305F\3081\306B\5FC5\8981\306A\6761\4EF6\30BF\30A4\30D7\3092\9078\629E\3057\307E\3059\3002'),
unistr('\6761\4EF6\3092\9078\629E\3057\306A\3044\5834\5408\3001\30A2\30A4\30C6\30E0\306F\901A\5E38\3069\304A\308A\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\307E\3059\3002'),
unistr('\8AAD\53D6\308A\5C02\7528\30A2\30A4\30C6\30E0\306F\8868\793A\306E\307F\306E\30A2\30A4\30C6\30E0\3068\540C\3058\8A2D\5B9A\3067\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8: \30A2\30A4\30C6\30E0\3092\5165\529B\53EF\80FD\30D5\30A3\30FC\30EB\30C9\3068\3057\3066\5E38\306B\30EC\30F3\30C0\30EA\30F3\30B0\3059\308B\306B\306F\3001\6761\4EF6\30BF\30A4\30D7\3092<strong>\300C\306A\3057\300D</strong>\306B\8A2D\5B9A\3057\3066\304F\3060\3055\3044\3002'),
unistr('\3053\306E\8A2D\5B9A\306B\3088\308A\3001\30EA\30FC\30B8\30E7\30F3\307E\305F\306F\30DA\30FC\30B8\30FB\30EC\30D9\30EB\306E\8AAD\53D6\308A\5C02\7528\6761\4EF6\8A2D\5B9A\304C\4E0A\66F8\304D\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103968669972308412)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30EA\30FC\30B8\30E7\30F3\3067\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3092\8AAD\53D6\308A\5C02\7528\3068\3057\3066\30EC\30F3\30C0\30EA\30F3\30B0\3059\308B\305F\3081\306B\6E80\305F\3059\5FC5\8981\306E\3042\308B\6761\4EF6\30BF\30A4\30D7\3092\9078\629E\3057\307E\3059\3002'),
unistr('\6761\4EF6\3092\9078\629E\3057\306A\3044\5834\5408\3001\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\304C\901A\5E38\3069\304A\308A\306B\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8: \3053\306E\6761\4EF6\306E\8A55\4FA1\65B9\6CD5\3068\306F\7121\95A2\4FC2\306B\3001\3053\306E\30EA\30FC\30B8\30E7\30F3\306E\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0(\305F\3068\3048\3070\3001\691C\7D22\30D5\30A3\30FC\30EB\30C9)\3092\5165\529B\53EF\80FD\306A\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3068\3057\3066\5E38\306B\30EC\30F3\30C0\30EA\30F3\30B0\3059\308B\5834\5408\3001\305D\306E\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306E\8AAD\53D6\308A\5C02\7528\6761\4EF6\3092\300C\306A\3057\300D\306B\8A2D\5B9A\3057\3001\30EA\30FC\30B8\30E7\30F3\8A2D\5B9A\3092\4E0A\66F8\304D\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103888589252308314)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30DA\30FC\30B8\3067\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3092\8AAD\53D6\308A\5C02\7528\3068\3057\3066\30EC\30F3\30C0\30EA\30F3\30B0\3059\308B\305F\3081\306B\5FC5\8981\306A\6761\4EF6\30BF\30A4\30D7\3092\9078\629E\3057\307E\3059\3002\6761\4EF6\3092\9078\629E\3057\306A\3044\5834\5408\3001\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306F\901A\5E38\3069\304A\308A\306B\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\307E\3059\3002'),
unistr('\8AAD\53D6\308A\5C02\7528\6761\4EF6\306F\3001\30D7\30ED\30BB\30B9\30FB\30DD\30A4\30F3\30C8<em>\300C\30D8\30C3\30C0\30FC\306E\524D\300D</em>\3067\30D7\30ED\30BB\30B9\3092\5B9F\884C\3057\305F\5F8C\306B\8A55\4FA1\3055\308C\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8: \3053\306E\6761\4EF6\306E\8A55\4FA1\65B9\6CD5\3068\306F\7121\95A2\4FC2\306B\3001\4E00\90E8\306E\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0(\305F\3068\3048\3070\3001\691C\7D22\30D5\30A3\30FC\30EB\30C9)\307E\305F\306F\7279\5B9A\306E\30EA\30FC\30B8\30E7\30F3\306E\3059\3079\3066\306E\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\53EF\80FD\306A\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3068\3057\3066\5E38\306B\30EC\30F3\30C0\30EA\30F3\30B0\3059\308B\5834\5408\3001\3053\308C\3089\306E\30EA\30FC\30B8\30E7\30F3/\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306E\8AAD\53D6\308A\5C02\7528\6761\4EF6\3092<strong>\300C\306A\3057\300D</strong>\306B\8A2D\5B9A\3057\3001\89AA\8A2D\5B9A\3092\4E0A\66F8\304D\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104457432829308800)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ALWAYS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5E38\6642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104596977636308916)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ALWAYS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306F\5E38\306B\8AAD\53D6\308A\5C02\7528\3068\3057\3066\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104456015536308799)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.BROWSER_IS_MSIE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30E9\30A4\30A2\30F3\30C8\306E\30D6\30E9\30A6\30B6\306FMicrosoft Internet Explorer 7.0\4EE5\4E0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104456134909308799)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.BROWSER_IS_MSIE_OR_NSCP.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30E9\30A4\30A2\30F3\30C8\30FB\30D6\30E9\30A6\30B6\306FXHTML / CSS\5BFE\5FDC\30D6\30E9\30A6\30B6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104455925330308799)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.BROWSER_IS_NSCP.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30E9\30A4\30A2\30F3\30C8\306E\30D6\30E9\30A6\30B6\306FMozilla\3001Netscape 6.x/7x\4EE5\4E0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104456273386308799)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.BROWSER_IS_OTHER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30E9\30A4\30A2\30F3\30C8\306E\30D6\30E9\30A6\30B6\306F\305D\306E\4ED6\306E\30D6\30E9\30A6\30B6(\307E\305F\306F\4EE5\524D\306E\30D0\30FC\30B8\30E7\30F3)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104454653019308798)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CONDITION1_IN_VALUE_OF_ITEM_IN_CONDITION2.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8\306F\30A2\30A4\30C6\30E0\306B\542B\307E\308C\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104456695863308800)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\8A00\8A9E = \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104600519147308919)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\3001\30E6\30FC\30B6\30FC\304C<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\8A00\8A9E\3067\73FE\5728\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\5B9F\884C\3057\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104456332629308799)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\8A00\8A9E\306F\5024\306B\542B\307E\308C\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104600715243308919)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\3001\30E6\30FC\30B6\30FC\304C<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\8A00\8A9E\306E\3044\305A\308C\304B\3067\73FE\5728\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\5B9F\884C\3057\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104456520223308799)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\8A00\8A9E != \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104600649851308919)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\3001\30E6\30FC\30B6\30FC\304C<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\8A00\8A9E\3067\73FE\5728\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\5B9F\884C\3057\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104456467566308799)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\8A00\8A9E\306F\5024\306B\542B\307E\308C\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104600863870308919)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\3001\30E6\30FC\30B6\30FC\304C<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\8A00\8A9E\306E\3044\305A\308C\304B\3067\73FE\5728\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\5B9F\884C\3057\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104453820336308798)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8 = \30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104599372458308918)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8\306F\3001<em>\300C\30DA\30FC\30B8\300D</em>\306B\5165\529B\3057\305F\5024\3068\7B49\3057\3044\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104454060078308798)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8\306F\30AB\30F3\30DE\3067\533A\5207\3089\308C\305F\30EA\30B9\30C8\306B\542B\307E\308C\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104599519163308918)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8\306F\3001<em>\300C\30DA\30FC\30B8\300D</em>\306B\5165\529B\3057\305F\30AB\30F3\30DE\533A\5207\308A\306E\30EA\30B9\30C8\306B\542B\307E\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104453904613308798)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8 != \30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104599436621308918)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8\306F\3001<em>\300C\30DA\30FC\30B8\300D</em>\306B\5165\529B\3057\305F\5024\3068\7B49\3057\304F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104454121754308798)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8\306F\30AB\30F3\30DE\3067\533A\5207\3089\308C\305F\30EA\30B9\30C8\306B\542B\307E\308C\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104599628743308918)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8\306F\3001<em>\300C\30DA\30FC\30B8\300D</em>\306B\5165\529B\3057\305F\30AB\30F3\30DE\533A\5207\308A\306E\30EA\30B9\30C8\306B\542B\307E\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104456719055308800)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DAD_NAME_EQ_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('CGI_ENV: DAD_NAME = \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104456814866308800)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DAD_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('CGI_ENV: DAD_NAME != \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104455562918308799)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30E9\30A4\30F3\691C\8A3C\30A8\30E9\30FC\3042\308A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104600302498308919)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306E\9001\4FE1\5F8C\3001\30A4\30F3\30E9\30A4\30F3\691C\8A3C\30A8\30E9\30FC\304C\30DA\30FC\30B8\306B\8868\793A\3055\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104454977282308798)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISPLAY_COND_EQUAL_COND_TEXT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8 = \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104454783250308798)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISPLAY_COND_IN_COND_TEXT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8\306F\5024\306B\542B\307E\308C\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104454843886308798)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISPLAY_COND_NOT_IN_COND_TEXT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8\306F\5024\306B\542B\307E\308C\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104455002889308798)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISP_COND_NOT_EQUAL_COND_TEXT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8 != \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104451571336308796)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.EXISTS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\304C\8FD4\3055\308C\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104597094062308916)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.EXISTS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B\306F1\3064\4EE5\4E0A\306E\884C\3092\8FD4\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104614751449308931)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104614893199308931)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5F0F\306FTRUE\3068\8A55\4FA1\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104451749809308796)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104597202107308916)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\306FTRUE\3092\8FD4\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104457197254308800)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.HTTP_HOST_EQ_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('CGI_ENV: HTTP_HOST = \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104457243301308800)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.HTTP_HOST_NOT_EQ_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('CGI_ENV: HTTP_HOST != \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104455203485308799)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8/\30EA\30FC\30B8\30E7\30F3\306F\8AAD\53D6\308A\5C02\7528\3067\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104600090128308919)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\304A\3088\3073\89AA\30EA\30FC\30B8\30E7\30F3(\8A72\5F53\3059\308B\5834\5408)\306F\6B63\5E38\306B\8868\793A\3055\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104455168907308798)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.IS_READ_ONLY.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8/\30EA\30FC\30B8\30E7\30F3\306F\8AAD\53D6\308A\5C02\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104599903092308919)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.IS_READ_ONLY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\307E\305F\306F\89AA\30EA\30FC\30B8\30E7\30F3(\8A72\5F53\3059\308B\5834\5408)\306E\300C\8AAD\53D6\308A\5C02\7528\300D\6761\4EF6\306FTRUE\3068\8A55\4FA1\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104453059652308797)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306B\7A7A\767D\304C\542B\307E\308C\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104598533233308917)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F\7A7A\767D\3092\542B\307F\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104453332726308797)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306F\82F1\6570\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104598854266308918)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F\82F1\6570\5B57\3067\3001\6587\5B57\307E\305F\306F\6570\5B57\306E\307F\3092\542B\307F\3001\7279\6B8A\6587\5B57\3092\542B\307F\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104452594793308797)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306FNULL\3067\306F\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104598077801308917)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F\7A7A\3067\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104453218400308797)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306F\6570\5B57\3067\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104598712997308918)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F\6570\5B57\3067\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104452708643308797)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306F0(\30BC\30ED)\3067\306F\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104598280306308917)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F0(\30BC\30ED)\3067\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104452435950308797)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NULL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306FNULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104597988007308917)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NULL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F\7A7A\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104452889883308797)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306FNULL\307E\305F\306F0(\30BC\30ED)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104598393994308917)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F\7A7A\307E\305F\306F0(\30BC\30ED)\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104453147467308797)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306F\6570\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104598681636308917)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F\6570\5B57\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104452677644308797)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_ZERO.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306F0(\30BC\30ED)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104598160408308917)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_ZERO.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F0(\30BC\30ED)\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104452990640308797)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306FNULL\3067\306A\304F\30010(\30BC\30ED)\3067\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104598423872308917)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F\7A7A\3067\306F\306A\304F\30010(\30BC\30ED)\3067\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104455757746308799)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.MAX_ROWS_LT_ROWS_FETCHED.D'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\30EC\30DD\30FC\30C8(\300COK\300D\3092\30AF\30EA\30C3\30AF\3059\308B\3068\300C\9032\3080\300D\30DC\30BF\30F3\3092\8868\793A)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104455834561308799)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.MIN_ROW_GT_THAN_ONE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\30EC\30DD\30FC\30C8(\300COK\300D\3092\30AF\30EA\30C3\30AF\3059\308B\3068\300C\623B\308B\300D\30DC\30BF\30F3\3092\8868\793A)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104457365550308800)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NEVER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104600978299308919)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NEVER.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306F\3001\89AA\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306E\8AAD\53D6\308A\5C02\7528\6761\4EF6\306B\95A2\4FC2\306A\304F\3001\6B63\5E38\306B\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104455610156308799)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30E9\30A4\30F3\691C\8A3C\30A8\30E9\30FC\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104600476408308919)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30E9\30A4\30F3\691C\8A3C\30A8\30E9\30FC\306F\30DA\30FC\30B8\306B\8868\793A\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104451606681308796)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NOT_EXISTS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\304C\8FD4\3055\308C\306A\3044')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104597100386308916)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B\306F\884C\3092\8FD4\3057\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104454478353308798)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8\306F\300C\5370\5237\7528\300D\30E2\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104599718964308918)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8\306F\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\3088\3063\3066\300C\5370\5237\7528\300D\30E2\30FC\30C9\306B\5207\308A\66FF\3048\3089\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104454518074308798)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30EC\30F3\30C8\30FB\30DA\30FC\30B8\306F\300C\5370\5237\7528\300D\30E2\30FC\30C9\3067\306F\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104599851953308918)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8\306F\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\3088\3063\3066\300C\5370\5237\7528\300D\30E2\30FC\30C9\306B\5207\308A\66FF\3048\3089\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104451862762308796)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30AF\30A8\30B9\30C8 = \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104597302846308916)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30EA\30AF\30A8\30B9\30C8\306F\3001<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\3068\7B49\3057\3044\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104452099255308796)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30AF\30A8\30B9\30C8\306F\5024\306B\542B\307E\308C\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104597522951308917)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30EA\30AF\30A8\30B9\30C8\306F\3001<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\306B\542B\307E\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104451977598308796)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30AF\30A8\30B9\30C8 != \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104597405429308917)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30EA\30AF\30A8\30B9\30C8\306F\3001<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\3068\7B49\3057\304F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104452169411308796)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30AF\30A8\30B9\30C8\306F\5024\306B\542B\307E\308C\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104597632263308917)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30EA\30AF\30A8\30B9\30C8\306F\3001<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\306B\542B\307E\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104456914736308800)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.SERVER_NAME_EQ_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('CGI_ENV: SERVER_NAME = \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104457008024308800)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.SERVER_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('CGI_ENV: SERVER_NAME != \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104455356774308799)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\6E08\30E6\30FC\30B6\30FC(\975E\30D1\30D6\30EA\30C3\30AF\30FB\30E6\30FC\30B6\30FC)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104600118176308919)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\30ED\30B0\30A4\30F3\3057\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104455434820308799)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30D6\30EA\30C3\30AF\30FB\30E6\30FC\30B6\30FC(\8A8D\8A3C\3055\308C\3066\3044\306A\3044\30E6\30FC\30B6\30FC)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104600239386308919)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\30ED\30B0\30A4\30F3\3057\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104453651750308797)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\30FB\30D7\30EA\30D5\30A1\30EC\30F3\30B9 = \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104599105356308918)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F<em>\30D7\30EA\30D5\30A1\30EC\30F3\30B9</em>\306E\5024\306F\3001<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\3068\7B49\3057\3044\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104453717764308797)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\30FB\30D7\30EA\30D5\30A1\30EC\30F3\30B9 != \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104599222881308918)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F<em>\30D7\30EA\30D5\30A1\30EC\30F3\30B9</em>\306E\5024\306F\3001<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\3068\7B49\3057\304F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104453412657308797)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306F\30B3\30ED\30F3\3067\533A\5207\3089\308C\305F\30EA\30B9\30C8\306B\542B\307E\308C\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104598973233308918)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F\3001<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\306B\5B8C\5168\306B\542B\307E\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104453542527308797)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306F\30B3\30ED\30F3\3067\533A\5207\3089\308C\305F\30EA\30B9\30C8\306B\542B\307E\308C\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104599023503308918)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F\3001<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\306B\5B8C\5168\306B\306F\542B\307E\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104452270485308796)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0 = \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104597772870308917)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F\3001<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\3068\7B49\3057\3044\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104452352195308796)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0 != \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104597801894308917)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\5024\306F\3001<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\3068\7B49\3057\304F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104454314045308798)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_NOT_SUBMITTED.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8 != \9001\4FE1\30DA\30FC\30B8(\30DD\30B9\30C8\6E08)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104454281520308798)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_SUBMITTED.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8 = \9001\4FE1\30DA\30FC\30B8(\30DD\30B9\30C8\6E08)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103888454982308314)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103903010738308329)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_VALUE1.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\6761\4EF6\3068\6BD4\8F03\3059\308B\5024\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103902921128308329)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_VALUE1.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103904485111308330)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_VALUE2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6761\4EF6\306B\5BFE\3059\308B\5024(<code>&ITEM.</code>\7F6E\63DB\6587\5B57\5217\3092\542B\3080)\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103904369343308330)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_VALUE2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104394615272308753)
,p_name=>'PE.PROPERTY.READ_ONLY_HTML_ATTRIBUTES.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>'<pre>bgcolor="#FF0000"</pre>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103897089095308325)
,p_name=>'PE.PROPERTY.READ_ONLY_HTML_ATTRIBUTES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\8AAD\53D6\308A\5C02\7528\30E2\30FC\30C9\3067\8868\793A\3055\308C\308B\5834\5408\306B\30A2\30A4\30C6\30E0HTML\8868\30BB\30EB\30FB\30BF\30B0(<code>&lt;td&gt;</code>)\306B\542B\307E\308C\308B\5C5E\6027\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103896901594308325)
,p_name=>'PE.PROPERTY.READ_ONLY_HTML_ATTRIBUTES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8AAD\53D6\308A\5C02\7528HTML\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104181614840308594)
,p_name=>'PE.PROPERTY.REFRESH_INTERVAL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\306E\66F4\65B0\9593\9694(\79D2)\3092\5165\529B\3057\307E\3059\3002\91CD\5927\306A\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30D1\30D5\30A9\30FC\30DE\30F3\30B9\306E\554F\984C\304C\767A\751F\3059\308B\53EF\80FD\6027\304C\3042\308B\305F\3081\30012\79D2\306A\3069\306E\975E\5E38\306B\77ED\3044\66F4\65B0\9593\9694\306F\63A8\5968\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104181563717308594)
,p_name=>'PE.PROPERTY.REFRESH_INTERVAL.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\9593\9694')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104181747331308594)
,p_name=>'PE.PROPERTY.REFRESH_INTERVAL.UNIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\79D2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103909389338308334)
,p_name=>'PE.PROPERTY.REGION.COMPONENT_PROPERTY.BUTTON.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3\3092\8868\793A\3059\308B\30EA\30FC\30B8\30E7\30F3\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103926671490308379)
,p_name=>'PE.PROPERTY.REGION.COMPONENT_PROPERTY.BUTTON.NULL_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\89AA\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103517631823308028)
,p_name=>'PE.PROPERTY.REGION.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\3092\8868\793A\3059\308B\30EA\30FC\30B8\30E7\30F3\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103926517638308379)
,p_name=>'PE.PROPERTY.REGION.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\89AA\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103902293547308329)
,p_name=>'PE.PROPERTY.REGION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\304C\95A2\9023\4ED8\3051\3089\308C\308B\30EA\30FC\30B8\30E7\30F3\3092\9078\629E\3057\307E\3059\3002\30B3\30F3\30DD\30FC\30CD\30F3\30C8\304C\8868\793A\3055\308C\308B\5834\5408\3001\6307\5B9A\3055\308C\305F\30EA\30FC\30B8\30E7\30F3\5185\306B\3001\3053\306E\30EA\30FC\30B8\30E7\30F3\5185\306E\4ED6\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\3068\76F8\5BFE\3057\3066\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103902155774308329)
,p_name=>'PE.PROPERTY.REGION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103967422990308411)
,p_name=>'PE.PROPERTY.REGION_DISPLAY_SELECTOR.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30EA\30FC\30B8\30E7\30F3\3092\30EA\30FC\30B8\30E7\30F3\8868\793A\30BB\30EC\30AF\30BF\306B\542B\3081\308B\5834\5408\3001<strong>\300C\30AA\30F3\300D</strong>\3092\6307\5B9A\3057\307E\3059\3002'),
unistr('\3053\306E\5C5E\6027\306F\3001<em>\30EA\30FC\30B8\30E7\30F3\8868\793A\30BB\30EC\30AF\30BF</em>\3068\3044\3046\30EA\30FC\30B8\30E7\30F3\30FB\30BF\30A4\30D7\304C\5B9A\7FA9\3055\308C\3001\30DA\30FC\30B8\306B\8868\793A\53EF\80FD\306A\5834\5408\306B\306E\307F\4F7F\7528\3055\308C\307E\3059\3002</p>'),
unistr('<p>\30E6\30FC\30B6\30FC\304C\3001\30EA\30FC\30B8\30E7\30F3\8868\793A\30BB\30EC\30AF\30BF\306B\542B\307E\308C\308B\30EA\30FC\30B8\30E7\30F3\540D\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\9078\629E\3057\305F\30EA\30FC\30B8\30E7\30F3\306E\307F\304C\8868\793A\3055\308C\3001\30EA\30B9\30C8\3055\308C\3066\3044\308B\4ED6\306E\30EA\30FC\30B8\30E7\30F3\306F\975E\8868\793A\306B\306A\308A\307E\3059\3002'),
unistr('\30EA\30FC\30B8\30E7\30F3\8868\793A\30BB\30EC\30AF\30BF\5185\306E\6700\521D\306E\30A8\30F3\30C8\30EA\306F<em>\300C\3059\3079\3066\8868\793A\300D</em>\3067\3001\30E6\30FC\30B6\30FC\306F\3001\4EE5\524D\306B\9078\629E\3057\305F\30EA\30FC\30B8\30E7\30F3\306E\307F\3067\306A\304F\3001\4F7F\7528\53EF\80FD\306A\3059\3079\3066\306E\30EA\30FC\30B8\30E7\30F3\3092\8868\793A\3067\304D\307E\3059\3002</p>'),
unistr('<p>\30EA\30FC\30B8\30E7\30F3\304C\30EA\30FC\30B8\30E7\30F3\6761\4EF6\306B\57FA\3065\3044\3066\8868\793A\53EF\80FD\3067\306A\3044\5834\5408\3001\30EA\30FC\30B8\30E7\30F3\8868\793A\30BB\30EC\30AF\30BF\5185\306E\30EA\30FC\30B8\30E7\30F3\306E\30EA\30B9\30C8\306B\542B\307E\308C\307E\305B\3093\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103967315600308411)
,p_name=>'PE.PROPERTY.REGION_DISPLAY_SELECTOR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\8868\793A\30BB\30EC\30AF\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103968246959308411)
,p_name=>'PE.PROPERTY.REGION_FUNCTION_RETURNING_SQL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30EA\30FC\30B8\30E7\30F3\306E\30D9\30FC\30B9\3068\3057\3066\4F7F\7528\3055\308C\308BSQL\554F\5408\305B\3092\623B\3059PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103968108656308411)
,p_name=>'PE.PROPERTY.REGION_FUNCTION_RETURNING_SQL.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B\3092\623B\3059PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103966448158308410)
,p_name=>'PE.PROPERTY.REGION_HTML_CODE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3057\305F<em>\30EA\30FC\30B8\30E7\30F3\30FB\30BF\30A4\30D7</em>\306B\5FDC\3058\3066\3001\30EA\30FC\30B8\30E7\30F3\30FB\30BD\30FC\30B9\307E\305F\306F\30B3\30F3\30C6\30F3\30C4\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103966341174308410)
,p_name=>'PE.PROPERTY.REGION_HTML_CODE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('HTML\30B3\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103967650875308411)
,p_name=>'PE.PROPERTY.REGION_IMAGE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\306E\5DE6\4E0A\306B\8868\793A\3055\308C\308B\30A4\30E1\30FC\30B8\306E\53C2\7167\3092\5165\529B\3057\307E\3059\3002\3053\306E\30A4\30E1\30FC\30B8\306E\8868\793A\306B\4F7F\7528\3055\308C\308B\8868\30BF\30B0\3092\5236\5FA1\3059\308B\3053\3068\306F\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103967521800308411)
,p_name=>'PE.PROPERTY.REGION_IMAGE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\30FB\30A4\30E1\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104261683704308654)
,p_name=>'PE.PROPERTY.REGION_PLAIN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\5BFE\3059\308B\30C6\30AD\30B9\30C8\30FB\30BD\30FC\30B9\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104261520540308654)
,p_name=>'PE.PROPERTY.REGION_PLAIN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103962750058308407)
,p_name=>'PE.PROPERTY.REGION_SQL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\5BFE\3059\308BSQL\30BD\30FC\30B9\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103962632142308407)
,p_name=>'PE.PROPERTY.REGION_SQL.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103967062294308411)
,p_name=>'PE.PROPERTY.REGION_TEMPLATE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30EA\30FC\30B8\30E7\30F3\306E\5916\89B3\3068\30EC\30A4\30A2\30A6\30C8\3092\5B9A\7FA9\3059\308B\30EA\30FC\30B8\30E7\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\9078\629E\3057\307E\3059\3002</p>'),
unistr('        <p>\30EA\30FC\30B8\30E7\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30C6\30FC\30DE\3067\5B9A\7FA9\3055\308C\307E\3059\3002'),
unistr('        \30EA\30FC\30B8\30E7\30F3\304C\4F5C\6210\3055\308C\308B\3068\3001\30C6\30F3\30D7\30EC\30FC\30C8\306F\3001\73FE\5728\306E\30C6\30FC\30DE\306B\5B9A\7FA9\3055\308C\3066\3044\308B\30C7\30D5\30A9\30EB\30C8\30FB\30EA\30FC\30B8\30E7\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306B\81EA\52D5\7684\306B\8A2D\5B9A\3055\308C\307E\3059\3002</p>'),
unistr('        <p>\30EC\30DD\30FC\30C8\3001\30D5\30A9\30FC\30E0\3001\30A2\30E9\30FC\30C8\3001\30DC\30BF\30F3\3001\7E2E\5C0F\53EF\80FD\306A(\975E\8868\793A/\8868\793A)\30B3\30F3\30C6\30F3\30C4\3001\30ED\30B0\30A4\30F3\30FB\30D5\30A9\30FC\30E0\306A\3069\3092\8868\793A\3059\308B\305F\3081\306E\30EA\30FC\30B8\30E7\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8\304C\591A\304F\306E\30C6\30FC\30DE\306B\542B\307E\308C\307E\3059\3002<br>'),
unistr('        \30E6\30CB\30D0\30FC\30B5\30EB\30FB\30C6\30FC\30DE\306B\306F\3001\6B21\306E\30EA\30FC\30B8\30E7\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8\304C\3042\308A\307E\3059\3002'),
'          <dl>',
unistr('            <dt>\30A2\30E9\30FC\30C8</dt>'),
unistr('            <dt>\5C5E\6027\306E\3042\308B\7A7A\767D</dt>'),
unistr('            <dt>\30DC\30BF\30F3\30FB\30B3\30F3\30C6\30CA</dt>'),
unistr('            <dt>\30AB\30EB\30FC\30BB\30EB\30FB\30B3\30F3\30C6\30CA</dt>'),
unistr('            <dt>\7E2E\5C0F\53EF\80FD</dt>'),
unistr('            <dt>\30B3\30F3\30C6\30F3\30C4\30FB\30D6\30ED\30C3\30AF</dt>'),
unistr('            <dt>\30D2\30FC\30ED\30FC</dt>'),
unistr('            <dt>\30A4\30F3\30E9\30A4\30F3\30FB\30C0\30A4\30A2\30ED\30B0</dt>'),
unistr('            <dt>\30A4\30F3\30E9\30A4\30F3\30FB\30DD\30C3\30D7\30A2\30C3\30D7</dt>'),
unistr('            <dt>\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8</dt>'),
unistr('            <dt>\30ED\30B0\30A4\30F3</dt>'),
unistr('            <dt>\6A19\6E96</dt>'),
unistr('            <dt>\30BF\30D6\30FB\30B3\30F3\30C6\30CA</dt>'),
unistr('            <dt>\30BF\30A4\30C8\30EB\30FB\30D0\30FC</dt>'),
unistr('            <dt>\30A6\30A3\30B6\30FC\30C9\30FB\30B3\30F3\30C6\30CA</dt>'),
'          </dl>',
unistr('          \95A2\9023\9805\76EE: <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\30E6\30CB\30D0\30FC\30B5\30EB\30FB\30C6\30FC\30DE\306E\30B5\30F3\30D7\30EB\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3</a>'),
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103966992054308410)
,p_name=>'PE.PROPERTY.REGION_TEMPLATE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104078667421308499)
,p_name=>'PE.PROPERTY.REGION_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30EA\30FC\30B8\30E7\30F3\306E\30EC\30F3\30C0\30EA\30F3\30B0\65B9\6CD5\3092\6307\5B9A\3057\307E\3059\3002\6B21\306E\30EA\30FC\30B8\30E7\30F3\30FB\30BF\30A4\30D7\304C\30B5\30DD\30FC\30C8\3055\308C\3066\3044\307E\3059:</p>'),
'#NATIVE_PLUGINS#',
unistr('<p>\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\69CB\6210\306B\3088\3063\3066\306F\3001\305D\306E\4ED6\306E\30EA\30FC\30B8\30E7\30F3\30FB\30BF\30A4\30D7\30FB\30D7\30E9\30B0\30A4\30F3\3082\3053\3053\3067\4F7F\7528\53EF\80FD\306A\5834\5408\304C\3042\308A\307E\3059\3002'),
unistr('\3053\308C\3089\306F\3001<em>&lt;My Plug-in&gt; [Plug-in]</em>\3068\8868\793A\3055\308C\307E\3059\3002'),
unistr('\6B21\306E\30D7\30E9\30B0\30A4\30F3\304C\3001\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8\5185\306B\30A4\30F3\30B9\30C8\30FC\30EB\3055\308C\307E\3059:</p>'),
'#CUSTOM_PLUGINS#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103901575215308328)
,p_name=>'PE.PROPERTY.REGION_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104340647173308712)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\691C\8A3C\306B\5BFE\3057\3066\30C6\30B9\30C8\3059\308B\7B49\4FA1\306E\30BF\30A4\30D7\3092\9078\629E\3057\307E\3059\3002\9078\629E\306B\3088\3063\3066\306F\3001\3053\306E\691C\8A3C\3092\5B8C\5168\306B\5B9A\7FA9\3059\308B\305F\3081\306B1\3064\4EE5\4E0A\306E\8FFD\52A0\5C5E\6027\304C\5FC5\8981\3067\3059\3002</p>'),
unistr('<p>\691C\8A3C\304C\7B49\4FA1\30C6\30B9\30C8\3092\30D1\30B9\3057\305F\5834\5408\3001\307E\305F\306FTRUE\3068\8A55\4FA1\3055\308C\305F\5834\5408\3001\691C\8A3C\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\306F\8868\793A\3055\308C\307E\305B\3093\3002'),
unistr('\691C\8A3C\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\306F\3001\691C\8A3C\304C\7B49\4FA1\30C6\30B9\30C8\306B\5931\6557\3057\305F\5834\5408\3001FALSE\3068\8A55\4FA1\3055\308C\305F\5834\5408\3001\307E\305F\306F\7A7A\3067\306A\3044\30C6\30AD\30B9\30C8\6587\5B57\5217\304C\8FD4\3055\308C\305F\5834\5408\306B\8868\793A\3055\308C\307E\3059\3002</p>'),
unistr('<p>\691C\8A3C\306E\5931\6557\306B\3088\3063\3066\5F8C\7D9A\306E\691C\8A3C\304C\8A55\4FA1\3055\308C\306A\304F\306A\308B\3053\3068\306F\3042\308A\307E\305B\3093\3002\3057\305F\304C\3063\3066\3001\5F8C\7D9A\306E\5404\691C\8A3C\306B\3088\3063\3066\3055\3089\306B\691C\8A3C\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\304C\767A\751F\3059\308B\53EF\80FD\6027\304C\3042\308A\307E\3059\3002\5F8C\7D9A\306E\691C\8A3C\304C\5B9F\884C\3055\308C\306A\3044\3088\3046\306B\3059\308B\306B\306F\3001\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3092\7279\5B9A\306E\5024\306B\8A2D\5B9A\3057\3066\5F8C\7D9A\306E\691C\8A3C\306E\6761\4EF6\30ED\30B8\30C3\30AF\3092\5FC5\8981\306B\5FDC\3058\3066\5F37\5316\3059\308B\306A\3069\306E\8FFD\52A0\30ED\30B8\30C3\30AF\3092\3001\5931\6557\3057\305F\6700\521D\306E\691C\8A3C\306B\8FFD\52A0\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\5F8C\7D9A\306E\30D7\30ED\30BB\30B9\304A\3088\3073\30D6\30E9\30F3\30C1\306F\30011\3064\4EE5\4E0A\306E\691C\8A3C\304C\8A55\4FA1\306B\5931\6557\3059\308B\3068\5B9F\884C\3055\308C\307E\305B\3093\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104441382461308788)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.EXISTS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\304C\8FD4\3055\308C\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104441407602308788)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.EXISTS.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('SQL\554F\5408\305B\304C\884C\30921\884C\4EE5\4E0A\8FD4\3059\5834\5408\306F\30D1\30B9\3057\307E\3059\3002<br>'),
unistr('SQL\554F\5408\305B\304C\884C\3092\8FD4\3055\306A\3044\5834\5408\306F\5931\6557\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104648719807308958)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104648826607308958)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5F0F\304CTRUE\3068\8A55\4FA1\3055\308C\308B\5834\5408\306F\30D1\30B9\3057\307E\3059\3002<br>'),
unistr('\5F0F\304CFALSE\3068\8A55\4FA1\3055\308C\308B\5834\5408\306F\5931\6557\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104441953571308789)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_BOOLEAN.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53(\30D6\30FC\30EB\3092\8FD4\3059)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104442025956308789)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\304CTRUE\3092\8FD4\3059\5834\5408\306F\30D1\30B9\3057\307E\3059\3002<br>'),
unistr('\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\304CFALSE\3092\8FD4\3059\5834\5408\306F\5931\6557\3057\307E\3059\3002<br>'),
unistr('\30CE\30FC\30C8: \30D5\30A1\30F3\30AF\30B7\30E7\30F3\304B\3089\8FD4\3055\308C\308B\7D50\679C\306F\30D6\30FC\30EB\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104442115897308789)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_ERR_TEXT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53(\30A8\30E9\30FC\30FB\30C6\30AD\30B9\30C8\3092\8FD4\3059)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104442241071308789)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_ERR_TEXT.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\304C\7A7A\306E\6587\5B57\5217\3092\8FD4\3059\5834\5408\306F\30D1\30B9\3057\307E\3059\3002<br>'),
unistr('\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\304C\7A7A\3067\306A\3044\6587\5B57\5217\3092\8FD4\3059\5834\5408\306F\5931\6557\3057\307E\3059\3002\8FD4\3055\308C\308B\6587\5B57\5217\306F\3001\691C\8A3C\306E\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\3068\3057\3066\8868\793A\3055\308C\307E\3059\3002<br>'),
unistr('\30CE\30FC\30C8: \30D5\30A1\30F3\30AF\30B7\30E7\30F3\304B\3089\8FD4\3055\308C\308B\7D50\679C\306F\30C6\30AD\30B9\30C8\6587\5B57\5217\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104442991148308789)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\306B\7A7A\767D\304C\542B\307E\308C\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104443044169308789)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5217\5024\306B\7A7A\767D\304C\542B\307E\308C\306A\3044\5834\5408\306F\30D1\30B9\3057\307E\3059\3002<br>'),
unistr('\5217\5024\306B\7A7A\767D\304C\542B\307E\308C\308B\5834\5408\306F\5931\6557\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104444900013308791)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_AT_LEAST_ONE_CHAR_IN_STRING2.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\306B\5024\306E\6587\5B57\304C1\3064\4EE5\4E0A\542B\307E\308C\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104445040926308791)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_AT_LEAST_ONE_CHAR_IN_STRING2.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5217\5024\306B<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\306E\6587\5B57\304C1\3064\4EE5\4E0A\542B\307E\308C\308B\5834\5408\306F\30D1\30B9\3057\307E\3059\3002<br>'),
unistr('\5217\5024\306B<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\306E\6587\5B57\304C\542B\307E\308C\306A\3044\5834\5408\306F\5931\6557\3057\307E\3059\3002')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104445154087308791)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\306B\5024\306E\6587\5B57\304C\542B\307E\308C\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104445267558308791)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5217\5024\306B<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\306E\6587\5B57\304C\542B\307E\308C\306A\3044\5834\5408\306F\30D1\30B9\3057\307E\3059\3002<br>'),
unistr('\5217\5024\306B<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\306E\6587\5B57\304C1\3064\4EE5\4E0A\542B\307E\308C\308B\5834\5408\306F\5931\6557\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104444740510308791)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_ONLY_CHAR_IN_STRING2.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\306B\5024\306B\6307\5B9A\3057\305F\6587\5B57\306E\307F\542B\307E\308C\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104444895529308791)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_ONLY_CHAR_IN_STRING2.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5217\5024\306B<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\5185\306E\6587\5B57\306E\307F\304C\542B\307E\308C\308B\5834\5408\306F\30D1\30B9\3057\307E\3059\3002<br>'),
unistr('\5217\5024\306B<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\4EE5\5916\306E\6587\5B57\304C\542B\307E\308C\308B\5834\5408\306F\5931\6557\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104443982332308790)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_EQ_STRING2.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217 = \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104444068195308790)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_EQ_STRING2.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5217\5024\304C<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\3068\7B49\3057\3044\5834\5408\306F\30D1\30B9\3057\307E\3059\3002<br>'),
unistr('\5217\5024\304C<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\3068\7B49\3057\304F\306A\3044\5834\5408\306F\5931\6557\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104444388323308790)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_IN_STRING2.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\306F\5024\306B\542B\307E\308C\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104444440813308791)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_IN_STRING2.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5217\5024\304C<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\306B\5B8C\5168\306B\542B\307E\308C\308B\5834\5408\306F\30D1\30B9\3057\307E\3059\3002<br>'),
unistr('\5217\5024\304C<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\306B\5B8C\5168\306B\306F\542B\307E\308C\306A\3044\5834\5408\306F\5931\6557\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104444159478308790)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_EQ_STRING2.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217 != \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104444288069308790)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_EQ_STRING2.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5217\5024\304C<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\3068\7B49\3057\304F\306A\3044\5834\5408\306F\30D1\30B9\3057\307E\3059\3002<br>'),
unistr('\5217\5024\304C<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\3068\7B49\3057\3044\5834\5408\306F\5931\6557\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104444550278308791)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_IN_STRING2.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\306F\5024\306B\542B\307E\308C\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104444626900308791)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_IN_STRING2.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5217\5024\304C<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\306B\5B8C\5168\306B\306F\542B\307E\308C\306A\3044\5834\5408\306F\30D1\30B9\3057\307E\3059\3002<br>'),
unistr('\5217\5024\304C<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\306B\5B8C\5168\306B\542B\307E\308C\308B\5834\5408\306F\5931\6557\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104443103083308790)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\306F\82F1\6570\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104443283282308790)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5217\5024\304C\82F1\6570\5B57\3067\6587\5B57\3068\6570\5B57\306E\307F\304C\542B\307E\308C\3001\7279\6B8A\6587\5B57\304C\542B\307E\308C\306A\3044\5834\5408\306F\30D1\30B9\3057\307E\3059\3002<br>'),
unistr('\5217\5024\306B\7279\6B8A\6587\5B57\304C\542B\307E\308C\308B\5834\5408\306F\5931\6557\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104443501191308790)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_DATE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\306F\6709\52B9\306A\65E5\4ED8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104443693795308790)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_DATE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5217\5024\304C\6709\52B9\306A\65E5\4ED8\306E\5834\5408\306F\30D1\30B9\3057\307E\3059\3002<br>'),
unistr('\5217\5024\304C\6709\52B9\306A\65E5\4ED8\3067\306A\3044\5834\5408\306F\5931\6557\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104443385306308790)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\306F\6570\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104443478234308790)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5217\5024\304C\6570\5B57\306E\5834\5408\306F\30D1\30B9\3057\307E\3059\3002<br>'),
unistr('\5217\5024\306B\6570\5B57\4EE5\5916\306E\6587\5B57(\5148\982D\306E\7A7A\767D\4EE5\5916\306E\7A7A\767D\3092\542B\3080)\304C\542B\307E\308C\308B\5834\5408\306F\5931\6557\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104443738047308790)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_TIMESTAMP.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\306F\6709\52B9\306A\30BF\30A4\30E0\30B9\30BF\30F3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104443800710308790)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_TIMESTAMP.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5217\5024\304C\6709\52B9\306A\30BF\30A4\30E0\30B9\30BF\30F3\30D7\306E\5834\5408\306F\30D1\30B9\3057\307E\3059\3002<br>'),
unistr('\5217\5024\304C\6709\52B9\306A\30BF\30A4\30E0\30B9\30BF\30F3\30D7\3067\306A\3044\5834\5408\306F\5931\6557\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104442325139308789)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_NULL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\306FNULL\3067\306F\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104442445209308789)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_NULL.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5217\5024\304C\7A7A\3067\306A\3044\5834\5408\306F\30D1\30B9\3057\307E\3059\3002<br>'),
unistr('\5217\5024\304C\7A7A\306E\5834\5408\306F\5931\6557\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104442509758308789)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\306FNULL\3067\306A\304F\30010(\30BC\30ED)\3067\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104442698529308789)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5217\5024\304C\7A7A\3067\306A\304F\30010(\30BC\30ED)\3067\306A\3044\5834\5408\306F\30D1\30B9\3057\307E\3059\3002<br>'),
unistr('\5217\5024\304C\7A7A\307E\305F\306F0(\30BC\30ED)\306E\5834\5408\306F\5931\6557\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104442756985308789)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_ZERO.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\306F0(\30BC\30ED)\3067\306F\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104442845278308789)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_ZERO.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5217\5024\304C0(\30BC\30ED)\3067\306A\3044\5834\5408\306F\30D1\30B9\3057\307E\3059\3002<br>'),
unistr('\5217\5024\304C0(\30BC\30ED)\306E\5834\5408\306F\5931\6557\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104441538890308788)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.NOT_EXISTS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\304C\8FD4\3055\308C\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104441695597308788)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('SQL\554F\5408\305B\304C\884C\3092\8FD4\3055\306A\3044\5834\5408\306F\30D1\30B9\3057\307E\3059\3002<br>'),
unistr('SQL\554F\5408\305B\304C\884C\30921\884C\4EE5\4E0A\8FD4\3059\5834\5408\306F\5931\6557\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104441749581308789)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.PLSQL_ERROR.D'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\30A8\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104441814194308789)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.PLSQL_ERROR.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('PL/SQL\30B3\30FC\30C9\304C\30A8\30E9\30FC\306B\306A\3089\305A\306B\5B9F\884C\3055\308C\308B\5834\5408\306F\30D1\30B9\3057\307E\3059\3002<br>'),
unistr('PL/SQL\5F0F\304C\5B9F\884C\6642\306B\30A8\30E9\30FC\306B\306A\308B\5834\5408\306F\5931\6557\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104445311297308791)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.REGULAR_EXPRESSION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\306F\6B63\898F\8868\73FE\306B\4E00\81F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104445471176308791)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.REGULAR_EXPRESSION.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5217\5024\304C<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\6B63\898F\8868\73FE\306B\4E00\81F4\3059\308B\5834\5408\306F\30D1\30B9\3057\307E\3059\3002'),
unistr('\5217\5024\304C<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\6B63\898F\8868\73FE\306B\4E00\81F4\3057\306A\3044\5834\5408\306F\5931\6557\3057\307E\3059\3002<br>'),
unistr('\30CE\30FC\30C8: \6B63\898F\8868\73FE\306B\3088\3063\3066\3001\6587\5B57\3092\76F4\63A5\6BD4\8F03\3059\308B\306E\3067\306F\306A\304F\3001\6A19\6E96\5316\3055\308C\305F\69CB\6587\898F\5247\3092\4F7F\7528\3057\3066\6587\5B57\5217\30C7\30FC\30BF\3067\30D1\30BF\30FC\30F3\3092\691C\7D22\3067\304D\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104340518552308712)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104341247187308713)
,p_name=>'PE.PROPERTY.REGION_VAL_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\691C\8A3C\7528\306E\5927/\5C0F\6587\5B57\3092\533A\5225\3057\305F\5217\540D\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\5217\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104341141455308713)
,p_name=>'PE.PROPERTY.REGION_VAL_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104650699833308959)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F\5F0F\306E\8A55\4FA1\306B\4F7F\7528\3055\308C\308B\8A00\8A9E\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104651052662308960)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'ja'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104650913821308960)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'ja'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104650836433308960)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'ja'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104651180257308960)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'ja'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104650788434308959)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'ja'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104650504630308959)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A00\8A9E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104652664199308961)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\306E\5B9F\884C\306B\4F7F\7528\3055\308C\308B\8A00\8A9E\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104652913803308961)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'ja'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104652843389308961)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'ja'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104652795151308961)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'ja'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104653075049308961)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'ja'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104652594221308961)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A00\8A9E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104649061344308958)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\306E\5B9F\884C\306B\4F7F\7528\3055\308C\308B\8A00\8A9E\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104649326615308958)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.LOV.JAVA.D'
,p_message_language=>'ja'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104649276314308958)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.LOV.JAVASCRIPT.D'
,p_message_language=>'ja'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104649132409308958)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.LOV.PLSQL.D'
,p_message_language=>'ja'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104649408303308958)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.LOV.PYTHON.D'
,p_message_language=>'ja'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104648916872308958)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A00\8A9E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104652237518308961)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C\3092\5B9A\7FA9\3059\308BJava\5F0F\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104652173971308961)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('Java\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104653877275308962)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\691C\8A3C\306E\30D9\30FC\30B9\3068\3057\3066\30D6\30FC\30EB\5024\3092\8FD4\3059Java\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104653732127308962)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('Java\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104650203946308959)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_FUNC_BODY_ERROR.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\691C\8A3C\306E\30D9\30FC\30B9\3068\3057\3066\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\30FB\30C6\30AD\30B9\30C8\3092\8FD4\3059Java\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104650133342308959)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC\30FB\30C6\30AD\30B9\30C8\3092\8FD4\3059Java\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104652014808308961)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3059\308B\304B\3001\30DE\30CD\30FC\30B8\30E3\3067\3042\308B\5834\5408\3001\691C\8A3C\306B\5408\683C\3057\3001\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\306F\51FA\529B\3055\308C\307E\305B\3093\3002</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB == "MANAGER" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104651953097308960)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C\3092\5B9A\7FA9\3059\308BJavaScript\5F0F\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104651800256308960)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('JavaScript\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104653602360308962)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3059\308B\5834\5408\3001\691C\8A3C\306B\5408\683C\3057\3001\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\306F\51FA\529B\3055\308C\307E\305B\3093\3002</dt>'),
'<dd><pre>',
'if ( apex.env.P2_DEPTNO === "30" ) {',
'    return true;',
'} else {',
'    return false;',
'}',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104653569984308962)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\691C\8A3C\306E\30D9\30FC\30B9\3068\3057\3066\30D6\30FC\30EB\5024\3092\8FD4\3059JavaScript\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104653414751308962)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('JavaScript\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104650026434308959)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_ERROR.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3059\308B\5834\5408\3001\691C\8A3C\306B\5408\683C\3057\3001\6307\5B9A\3057\305F\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\306F\51FA\529B\3055\308C\307E\305B\3093\3002</dt>'),
'<dd><pre>',
'if ( apex.env.P2_DEPTNO !== "30" ) {',
'    return "Employee is in Department " + apex.env.P2_DEPTNO + " and not Department 30";',
'}',
'return "";',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104649993444308959)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_ERROR.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\691C\8A3C\306E\30D9\30FC\30B9\3068\3057\3066\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\30FB\30C6\30AD\30B9\30C8\3092\8FD4\3059JavaScript\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104649887889308959)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC\30FB\30C6\30AD\30B9\30C8\3092\8FD4\3059JavaScript\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104765188247309062)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3059\308B\5834\5408\3001\691C\8A3C\306B\5408\683C\3057\3001\6307\5B9A\3057\305F\30A8\30E9\30FC\306F\51FA\529B\3055\308C\307E\305B\3093\3002</dt>'),
'<dd><pre>',
'begin',
'    if :P2_DEPTNO <> 30 then',
'        raise_application_error( -20000, ''Employee is in Department '' || :P2_DEPTNO || '' and not Department 30'' );',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104341002550308712)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\691C\8A3C\306E\30D9\30FC\30B9\3068\3057\3066\30A8\30E9\30FC\3092\767A\751F\3059\308BPL/SQL\5F0F\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104340976527308712)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC\3092\767A\751F\3059\308BPL/SQL\30B3\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104651764975308960)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3059\308B\304B\3001\30DE\30CD\30FC\30B8\30E3\3067\3042\308B\5834\5408\3001\691C\8A3C\306B\5408\683C\3057\3001\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\306F\51FA\529B\3055\308C\307E\305B\3093\3002</dt>'),
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104651603021308960)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C\3092\5B9A\7FA9\3059\308BPL/SQL\5F0F\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104651537891308960)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104653350147308962)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3059\308B\5834\5408\3001\691C\8A3C\306B\5408\683C\3057\3001\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\306F\51FA\529B\3055\308C\307E\305B\3093\3002</dt>'),
'<dd><pre>',
'begin',
'    if :P2_DEPTNO = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104653215350308961)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\691C\8A3C\306E\30D9\30FC\30B9\3068\3057\3066\30D6\30FC\30EB\5024\3092\8FD4\3059PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104653190712308961)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104649700218308959)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_ERROR.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3059\308B\5834\5408\3001\691C\8A3C\306B\5408\683C\3057\3001\6307\5B9A\3057\305F\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\306F\51FA\529B\3055\308C\307E\305B\3093\3002</dt>'),
'<dd><pre>',
'begin',
'    if :P2_DEPTNO <> 30 then',
'        return ''Employee is in Department '' || :P2_DEPTNO || '' and not Department 30'';',
'    end if;',
'    return null;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104649640940308959)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_ERROR.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\691C\8A3C\306E\30D9\30FC\30B9\3068\3057\3066\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\30FB\30C6\30AD\30B9\30C8\3092\8FD4\3059PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104649586788308959)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC\30FB\30C6\30AD\30B9\30C8\3092\8FD4\3059PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104652472047308961)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C\3092\5B9A\7FA9\3059\308BPython\5F0F\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104652371703308961)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('Python\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104654055236308962)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\691C\8A3C\306E\30D9\30FC\30B9\3068\3057\3066\30D6\30FC\30EB\5024\3092\8FD4\3059Python\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104653976398308962)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('Python\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104650408411308959)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_FUNC_BODY_ERROR.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\691C\8A3C\306E\30D9\30FC\30B9\3068\3057\3066\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\30FB\30C6\30AD\30B9\30C8\3092\8FD4\3059Python\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104650376842308959)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC\30FB\30C6\30AD\30B9\30C8\3092\8FD4\3059Python\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104341666824308713)
,p_name=>'PE.PROPERTY.REGION_VAL_REGULAR_EXPRESSION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\691C\8A3C\306B\6307\5B9A\3055\308C\305F\5217\3068\306E\4E00\81F4\306B\4F7F\7528\3059\308B\6B63\898F\8868\73FE\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104341574448308713)
,p_name=>'PE.PROPERTY.REGION_VAL_REGULAR_EXPRESSION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B63\898F\8868\73FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104651445798308960)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\30DE\30CD\30FC\30B8\30E3\3067\3042\308B\304B\3001\90E8\9580\304C\30B7\30AB\30B4\306B\5B58\5728\3059\308B\5834\5408\3001\691C\8A3C\306B\5408\683C\3057\3001\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\306F\51FA\529B\3055\308C\307E\305B\3093\3002</dt>'),
'<dd><pre>',
':P2_JOB = ''MANAGER'' or',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104651318856308960)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C\3092\5B9A\7FA9\3059\308BSQL\5F0F\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104651251975308960)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104765036203309062)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_STATEMENT.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt><strong>\300C\884C\304C\8FD4\3055\308C\308B\300D</strong>\3067\3001\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3059\308B\5834\5408\3001\691C\8A3C\306B\5408\683C\3057\3001\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\306F\51FA\529B\3055\308C\307E\305B\3093\3002</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
unistr('<dt><strong>\300C\884C\304C\8FD4\3055\308C\306A\3044\300D</strong>\3067\3001\5F93\696D\54E1\304C\90E8\958040\306B\6240\5C5E\3059\308B\5834\5408\3001\691C\8A3C\306B\5408\683C\3057\3001\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\306F\51FA\529B\3055\308C\307E\305B\3093\3002</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno <> 40',
'</pre></dd>',
'</dl>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104340833355308712)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_STATEMENT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\691C\8A3C\3092\5B9A\7FA9\3059\308BSQL\554F\5408\305B\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104340766405308712)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_STATEMENT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104341450413308713)
,p_name=>'PE.PROPERTY.REGION_VAL_VALUE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\691C\8A3C\306B\6307\5B9A\3055\308C\305F\5217\306E\5024\3068\306E\6BD4\8F03\306B\4F7F\7528\3059\308B\5024\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104341313284308713)
,p_name=>'PE.PROPERTY.REGION_VAL_VALUE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104355046290308723)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30C7\30D5\30A9\30EB\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104695682668308996)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.COMPONENT_PROPERTY.PAGE.NULL_TEXT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\5BFE\3057\3066\5B9A\7FA9\3055\308C\3066\3044\308B\8A2D\5B9A\3092\7D99\627F\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104354990760308723)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\5C5E\6027\3092\4F7F\7528\3057\3066\3001&PRODUCT_NAME.\3067\30BB\30C3\30B7\30E7\30F3ID\3092\542B\307E\306A\3044\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3URL\3092\30B5\30DD\30FC\30C8\3059\308B\304B\3069\3046\304B\3092\5236\5FA1\3057\307E\3059\3002'),
unistr('\30BB\30C3\30B7\30E7\30F3\306E\518D\7D50\5408\304C\6709\52B9\3067\3001URL\306B\30BB\30C3\30B7\30E7\30F3ID\304C\542B\307E\308C\3066\3044\306A\3044\5834\5408\3001&PRODUCT_NAME.\306F\30BB\30C3\30B7\30E7\30F3Cookie\3092\4F7F\7528\3057\3066\65E2\5B58\306E\30BB\30C3\30B7\30E7\30F3\3092\7D50\5408\3057\3088\3046\3068\3057\307E\3059\3002'),
'</p>',
unistr('<p>\3053\306E\30DA\30FC\30B8\30FB\30EC\30D9\30EB\306E\5024\306F\3001\3088\308A\5236\9650\7684\306A\30A4\30F3\30B9\30BF\30F3\30B9\30FB\30EC\30D9\30EB\306E\8A2D\5B9A\306B\3088\3063\3066\30AA\30FC\30D0\30FC\30E9\30A4\30C9\3055\308C\307E\3059\3002'),
'</p>',
unistr('<p><em><strong>\30CE\30FC\30C8:</em></strong> \30BB\30C3\30B7\30E7\30F3\306E\518D\7D50\5408\3092\6709\52B9\306B\3059\308B\3068\3001\653B\6483\8005\304C\65E2\5B58\306E\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\30FB\30BB\30C3\30B7\30E7\30F3\3092\4E57\3063\53D6\308B\3053\3068\304C'),
unistr('\53EF\80FD\306B\306A\308B\305F\3081\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30BB\30AD\30E5\30EA\30C6\30A3\304C\4FB5\5BB3\3055\308C\308B\53EF\80FD\6027\304C\3042\308A\307E\3059\3002'),
unistr('\3055\3089\306B\5B66\7FD2\3059\308B\306B\306F\3001\300E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30D3\30EB\30C0\30FC\30FB\30E6\30FC\30B6\30FC\30BA\30FB\30AC\30A4\30C9\300F\306E\300C\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30BB\30AD\30E5\30EA\30C6\30A3\306E\7BA1\7406\300D\306E<em>\30BB\30C3\30B7\30E7\30F3\306E\518D\7D50\5408</em>\306B\95A2\3059\308B\9805\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104436562577308785)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.N.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104436619739308785)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.N.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('URL\306B\30BB\30C3\30B7\30E7\30F3ID\304C\542B\307E\308C\3066\3044\306A\3044\5834\5408\3001&PRODUCT_NAME.\306F\65B0\898F\30BB\30C3\30B7\30E7\30F3\3092\4F5C\6210\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104436777281308785)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.P.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30D6\30EA\30C3\30AF\30FB\30BB\30C3\30B7\30E7\30F3\306B\5BFE\3057\3066\6709\52B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104436897199308785)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.P.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('URL\304C\30D1\30D6\30EA\30C3\30AF\30FB\30DA\30FC\30B8\306E\3082\306E\3067\3001\30BB\30C3\30B7\30E7\30F3ID\304C\542B\307E\308C\3066\3044\306A\3044\5834\5408\3001&PRODUCT_NAME.\306F\305D\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\5BFE\3057\3066\78BA\7ACB\3055\308C\305F\65E2\5B58\306E\30BB\30C3\30B7\30E7\30F3Cookie\306E\5229\7528\3092\8A66\307F\307E\3059\3002'),
unistr('\30D1\30D6\30EA\30C3\30AF\30FB\30DA\30FC\30B8\3068\8A8D\8A3C\6E08\30DA\30FC\30B8\306E\4E21\65B9\3092\6301\3064\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\5834\5408\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306E\8A8D\8A3C\5F8C\30BB\30C3\30B7\30E7\30F3ID\304C\5B9A\7FA9\3055\308C\307E\3059\3002'),
unistr('&PRODUCT_NAME.\306F\3001\30BB\30C3\30B7\30E7\30F3\304C\307E\3060\8A8D\8A3C\3055\308C\3066\3044\306A\3044\5834\5408\306B\306E\307FCookie\3092\4F7F\7528\3057\3066\7D50\5408\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104436905624308785)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.Y.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\306E\30BB\30C3\30B7\30E7\30F3\306B\5BFE\3057\3066\6709\52B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104437083514308785)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.Y.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>URL\306B\30BB\30C3\30B7\30E7\30F3ID\304C\542B\307E\308C\3066\304A\3089\305A\3001\6B21\306E\6761\4EF6\304C\6E80\305F\3055\308C\308B\5834\5408\3001&PRODUCT_NAME.\306F\3001\305D\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\5BFE\3057\3066\78BA\7ACB\3055\308C\305F\65E2\5B58\306E\30BB\30C3\30B7\30E7\30F3Cookie\306E\5229\7528\3092\8A66\307F\307E\3059\3002</p>'),
'<p><ul>',
unistr('  <li>\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\4FDD\8B77\304C\305D\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\5BFE\3057\3066\6709\52B9\3067\3001URL\306B\6709\52B9\306A\30C1\30A7\30C3\30AF\30B5\30E0\304C\542B\307E\308C\3066\3044\307E\3059\3002'),
unistr('    \30D1\30D6\30EA\30C3\30AF\30FB\30D6\30C3\30AF\30DE\30FC\30AF\306E\5834\5408\3001\6700\3082\5236\9650\7684\306A\30A2\30A4\30C6\30E0\30FB\30EC\30D9\30EB\306E\4FDD\8B77\306F<em>\300C\5236\9650\306A\3057\300D</em>\307E\305F\306F<em>\300C\30C1\30A7\30C3\30AF\30B5\30E0\304C\5FC5\8981 - \30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30EC\30D9\30EB\300D</em>\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</li>'),
unistr('  <li>\307E\305F\306F\3001URL\306B\30DA\30A4\30ED\30FC\30C9\304C\542B\307E\308C\3066\3044\307E\305B\3093(\30EA\30AF\30A8\30B9\30C8\30FB\30D1\30E9\30E1\30FC\30BF\3001\30AD\30E3\30C3\30B7\30E5\307E\305F\306F\30C7\30FC\30BF\5024\30DA\30A2\306E\30AF\30EA\30A2)\3002</li>'),
'</ul></p>',
unistr('<p>\3053\306E\8A2D\5B9A\3067\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E<em>\300C\30D5\30EC\30FC\30E0\3078\306E\57CB\8FBC\307F\300D</em>\304C<em>\300C\540C\3058\8D77\70B9\304B\3089\8A31\53EF\300D</em>\307E\305F\306F<em>\300C\62D2\5426\300D</em>\306B\8A2D\5B9A\3055\308C\3066\3044\308B\5FC5\8981\3082\3042\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104354814982308723)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30C3\30B7\30E7\30F3\3092\518D\7D50\5408')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104282923848308669)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\9001\4FE1\5F8C\306B\30DA\30FC\30B8\3092\3044\3064\30EA\30ED\30FC\30C9\3059\308B\304B\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104283071945308670)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.LOV.A.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5E38\6642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104283183935308670)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.LOV.A.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5E38\306B\30DA\30FC\30B8\3092\30EA\30ED\30FC\30C9\3057\3066\3001\30A8\30E9\30FC\304A\3088\3073\6210\529F\30E1\30C3\30BB\30FC\30B8\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104283217131308670)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.LOV.S.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6210\529F\306E\307F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104283394854308670)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.LOV.S.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\3092\30EA\30ED\30FC\30C9\305B\305A\306B\52D5\7684\306B\30A8\30E9\30FC\3092\8868\793A\3057\307E\3059\304C\3001\6B63\5E38\306A\51E6\7406\306E\5F8C\306B\30EA\30ED\30FC\30C9\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104282890120308669)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\9001\4FE1\6642\306B\30EA\30ED\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104664314644308970)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.COMPONENT_PROPERTY.JET_CHART_SERIES.NULL_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104664492383308971)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.COMPONENT_PROPERTY.JET_CHART_SERIES.NULL_TEXT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\306F\30AD\30E3\30C3\30B7\30E5\3055\308C\305A\3001\6BCE\56DE\30EA\30AF\30A8\30B9\30C8\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104537037671308865)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104537133050308865)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\306F\30AD\30E3\30C3\30B7\30E5\3055\308C\305A\3001\6BCE\56DE\30EA\30AF\30A8\30B9\30C8\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103974430256308416)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.COMPONENT_PROPERTY.REGION.NULL_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103974518985308416)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.COMPONENT_PROPERTY.REGION.NULL_TEXT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D50\679C\306F\30AD\30E3\30C3\30B7\30E5\3055\308C\307E\305B\3093\3002\30C7\30FC\30BF\306F\30EA\30AF\30A8\30B9\30C8\3054\3068\306B\30EA\30E2\30FC\30C8\30FB\30C7\30FC\30BF\30D9\30FC\30B9\304B\3089\30D5\30A7\30C3\30C1\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103972671394308415)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('&PRODUCT_NAME.\30A8\30F3\30B8\30F3\306B\3088\308B\30ED\30FC\30AB\30EB\30FB\30C7\30FC\30BF\30D9\30FC\30B9\3067\306E\30C7\30FC\30BF\306E\30AD\30E3\30C3\30B7\30E5\65B9\6CD5\3092\9078\629E\3057\307E\3059\3002'),
unistr('        \30AD\30E3\30C3\30B7\30E5\304C\4F7F\7528\3055\308C\308B\5834\5408\3001\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306F\3001\30EA\30E2\30FC\30C8\30FB\30C7\30FC\30BF\30D9\30FC\30B9\304B\3089\30D5\30A7\30C3\30C1\3059\308B\304B\308F\308A\306B\3001\30AD\30E3\30C3\30B7\30E5\3055\308C\305F\7D50\679C\306B\57FA\3065\3044\3066\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\307E\3059\3002'),
unistr('        \30AD\30E3\30C3\30B7\30E5\3055\308C\305F\7D50\679C\306B\3088\3063\3066\3001\30ED\30FC\30AB\30EB\30FB\30C7\30FC\30BF\30D9\30FC\30B9\3068\30EA\30E2\30FC\30C8\30FB\30C7\30FC\30BF\30D9\30FC\30B9\9593\306E\30EC\30A4\30C6\30F3\30B7\304C\3042\308B\5834\5408\306F\7279\306B\3001\30D1\30D5\30A9\30FC\30DE\30F3\30B9\304C\5927\5E45\306B\5411\4E0A\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103972703246308415)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.LOV.ALL_USERS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\306E\30E6\30FC\30B6\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103972897686308415)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.LOV.ALL_USERS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D50\679C\306F\30AD\30E3\30C3\30B7\30E5\3055\308C\3001\3059\3079\3066\306E\30E6\30FC\30B6\30FC\306B\3088\3063\3066\5229\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103973143991308415)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.LOV.SESSION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30C3\30B7\30E7\30F3\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103973236578308415)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.LOV.SESSION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D50\679C\306F\30E6\30FC\30B6\30FC\30FB\30BB\30C3\30B7\30E7\30F3\3054\3068\306B\30AD\30E3\30C3\30B7\30E5\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103972956220308415)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.LOV.USER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103973031758308415)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.LOV.USER.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D50\679C\306F\3001\30BB\30C3\30B7\30E7\30F3\3092\307E\305F\304C\308A\3001\30E6\30FC\30B6\30FC\3054\3068\306B\30AD\30E3\30C3\30B7\30E5\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103972572173308415)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AD\30E3\30C3\30B7\30E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103973566351308415)
,p_name=>'PE.PROPERTY.REMOTE_SQL_INVALIDATE_WHEN.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\30AD\30E3\30C3\30B7\30E5\3055\308C\3066\304B\308915\5206\3092\904E\304E\308B\3068\30C7\30FC\30BF\304C\671F\9650\5207\308C\306B\306A\308A\307E\3059\3002</dt>'),
'  <dd><pre>15</pre></dd>',
unistr('<dt>\6B63\6642\306B\30C7\30FC\30BF\304C\671F\9650\5207\308C\306B\306A\308A\307E\3059\3002</dt>'),
'  <dd><pre>FREQ=HOURLY;BYMINUTE=0;BYSECOND=0</pre></dd>',
unistr('<dt>\5348\524D0\6642\306B\30C7\30FC\30BF\304C\671F\9650\5207\308C\306B\306A\308A\307E\3059\3002</dt>'),
'  <dd><pre>FREQ=DAILY;BYHOUR=0;BYMINUTE=0;BYSECOND=0</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103973409247308415)
,p_name=>'PE.PROPERTY.REMOTE_SQL_INVALIDATE_WHEN.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30AD\30E3\30C3\30B7\30E5\3055\308C\305F\30C7\30FC\30BF\304C\7121\52B9\306B\306A\308B\30BF\30A4\30DF\30F3\30B0\3092\5165\529B\3057\307E\3059\3002'),
unistr('        \6642\9593(\5206)\307E\305F\306FDBMS_SCHEDULER\30AB\30EC\30F3\30C0\6587\5B57\5217\3092\6307\5B9A\3057\307E\3059\3002</p>'),
unistr('        <p>DBMS_SCHEDULER\30AB\30EC\30F3\30C0\6587\5B57\5217\306E\5834\5408\3001\30AD\30E3\30C3\30B7\30E5\3055\308C\305F\30C7\30FC\30BF\304C\3001\6B63\6642\3001\5348\524D0\6642\3001\307E\305F\306F\7279\5B9A\306E\6642\70B9\3067\7121\52B9\306B\306A\308B\3053\3068\3092\5B9A\7FA9\3067\304D\307E\3059\3002'),
unistr('        \8A73\7D30\306F\3001DBMS_SCHEDULER.EVALUATE_CALENDAR_STRING\306B\95A2\3059\308B\30C9\30AD\30E5\30E1\30F3\30C8\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103973399806308415)
,p_name=>'PE.PROPERTY.REMOTE_SQL_INVALIDATE_WHEN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AD\30E3\30C3\30B7\30E5\30FB\30BF\30A4\30E0\30A2\30A6\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104210540313308617)
,p_name=>'PE.PROPERTY.REPORT_ALIAS.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\3053\306E\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\30FB\30EA\30FC\30B8\30E7\30F3\306E\82F1\6570\5B57\306E\5225\540D\3092\5165\529B\3057\307E\3059\3002'),
unistr('\5225\540D\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5185\3067\4E00\610F\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002'),
unistr('\5225\540D\3092\4F7F\7528\3057\3066\3001\30AB\30B9\30BF\30E0API\30B3\30FC\30EB\5185\306E\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\30FB\30EA\30FC\30B8\30E7\30F3\3092\53C2\7167\3067\304D\307E\3059\3002'),
unistr('\305F\3068\3048\3070\3001<code>APEX_APPLICATION_PAGE_IR</code>\30D3\30E5\30FC\306E<code>ALIAS</code>\5217\3092\554F\3044\5408\305B\308B\3053\3068\306B\3088\3063\3066<code>INTERACTIVE_REPORT_ID</code>\3092\8FD4\3059\30D5\30A1\30F3\30AF\30B7\30E7\30F3\3092\8A18\8FF0\3067\304D\307E\3059\3002'),
unistr('<code>INTERACTIVE_REPORT_ID</code>\306E\5024\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\5225\306E\30A4\30F3\30B9\30BF\30F3\30B9\306B\30A8\30AF\30B9\30DD\30FC\30C8\307E\305F\306F\30A4\30F3\30DD\30FC\30C8\3057\305F\3068\304D\306B\5909\308F\308B\53EF\80FD\6027\304C\3042\308B\305F\3081\3001\5225\540D\3092\4F7F\7528\3057\3066\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\30FB\30EA\30FC\30B8\30E7\30F3\3092\53C2\7167\3059\308B\65B9\6CD5\306F\6709\76CA\3067\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104210498773308617)
,p_name=>'PE.PROPERTY.REPORT_ALIAS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\5225\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104204093007308612)
,p_name=>'PE.PROPERTY.REPORT_FILTER_DATE_RANGES.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('LOV\306E\65E5\4ED8\5236\9650\3092\9078\629E\3057\307E\3059\3002'),
unistr('\65E5\4ED8\5217\3067\306F\3001\30EC\30DD\30FC\30C8\5217\306E\30C9\30ED\30C3\30D7\30FB\30C0\30A6\30F3\30FB\30EA\30B9\30C8\306E\30D5\30A3\30EB\30BF\3068\3057\3066LOV\306B\904E\53BB\306E\6642\9593\3001\672A\6765\306E\6642\9593\307E\305F\306F\4E21\65B9\3092\8868\793A\3067\304D\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104407269496308763)
,p_name=>'PE.PROPERTY.REPORT_FILTER_DATE_RANGES.LOV.ALL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104407480733308763)
,p_name=>'PE.PROPERTY.REPORT_FILTER_DATE_RANGES.LOV.FUTURE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C06\6765')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104407356090308763)
,p_name=>'PE.PROPERTY.REPORT_FILTER_DATE_RANGES.LOV.PAST.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\904E\53BB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104203940620308612)
,p_name=>'PE.PROPERTY.REPORT_FILTER_DATE_RANGES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5\4ED8\7BC4\56F2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104210704462308617)
,p_name=>'PE.PROPERTY.REPORT_ID_ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5024\306B\4FDD\5B58\3055\308C\305F\30EC\30DD\30FC\30C8ID\3092\683C\7D0D\3059\308B\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\9078\629E\3057\307E\3059\3002'),
unistr('\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\3067\306F\3001\3053\306E\30A2\30A4\30C6\30E0\5024\3092\4F7F\7528\3057\3066\4FDD\5B58\3055\308C\305F\30EC\30DD\30FC\30C8\306B\30EA\30F3\30AF\3057\307E\3059\3002'),
unistr('\305F\3068\3048\3070\3001\5B9A\7FA9\3055\308C\305F\30A2\30A4\30C6\30E0\540D\306E\30EA\30F3\30AF\304A\3088\3073\4FDD\5B58\3055\308C\305F\30C7\30D5\30A9\30EB\30C8\30FB\30EC\30DD\30FC\30C8\3001\30D1\30D6\30EA\30C3\30AF\307E\305F\306F\30D7\30E9\30A4\30D9\30FC\30C8\30FB\30EC\30DD\30FC\30C8\306B\30EA\30F3\30AF\3059\308B\5024\3068\3057\3066\4FDD\5B58\3055\308C\305F\30EC\30DD\30FC\30C8ID\3068\3068\3082\306B\4FDD\5B58\3055\308C\305F\30EC\30DD\30FC\30C8\306E\30EA\30B9\30C8\3092\5B9A\7FA9\3067\304D\307E\3059\3002'),
unistr('\4FDD\5B58\3055\308C\305F\30EC\30DD\30FC\30C8ID\306F\3001<code>APEX_APPLICATION_PAGE_IR_RPT</code>\30D3\30E5\30FC\304B\3089\53D6\5F97\3067\304D\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104210632998308617)
,p_name=>'PE.PROPERTY.REPORT_ID_ITEM.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8ID\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104351706241308720)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT.COMPONENT_PROPERTY.CLASSIC_REPORT_PRINT_ATTR.NULL_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\30FB\30EC\30DD\30FC\30C8\30FB\30EC\30A4\30A2\30A6\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104352386877308721)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT.COMPONENT_PROPERTY.TABULAR_FORM_PRINT_ATTR.NULL_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\30FB\30EC\30DD\30FC\30C8\30FB\30EC\30A4\30A2\30A6\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104351305602308720)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\306E\51FA\529B\6642\306B\4F7F\7528\3059\308B\30EC\30DD\30FC\30C8\30FB\30EC\30A4\30A2\30A6\30C8\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104351242351308720)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30A4\30A2\30A6\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104241698226308640)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30EC\30DD\30FC\30C8\306E\8868\793A\3092\5236\5FA1\3059\308B\4E8B\524D\5B9A\7FA9\306E\30EC\30DD\30FC\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104420827331308773)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.1.D'
,p_message_language=>'ja'
,p_message_text=>unistr('HTML(\6A19\6E96)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104420965702308773)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.1.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A19\6E96HTML\8868\3092\4F5C\6210\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104421030672308773)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.2.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\7E26\5411\304D\306E\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104421113850308773)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5404\5217\3092\5225\306E\884C\306B\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104421235438308773)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.21.D'
,p_message_language=>'ja'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104421398604308773)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.21.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\3092CSV\30D5\30A1\30A4\30EB\3068\3057\3066\30A8\30AF\30B9\30DD\30FC\30C8\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104421487243308773)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.22.D'
,p_message_language=>'ja'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104421507259308773)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.22.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\3092XML\30D5\30A1\30A4\30EB\3068\3057\3066\30A8\30AF\30B9\30DD\30FC\30C8\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104241564937308640)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104243801354308642)
,p_name=>'PE.PROPERTY.REPORT_SUM_LABEL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\5408\8A08\5024\306E\6A2A\306B\8868\793A\3055\308C\308B\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104243789619308641)
,p_name=>'PE.PROPERTY.REPORT_SUM_LABEL.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\5408\8A08\306E\30E9\30D9\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104237177437308637)
,p_name=>'PE.PROPERTY.REPORT_TEMPLATE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30AF\30E9\30B7\30C3\30AF\30FB\30EC\30DD\30FC\30C8\306E\5916\89B3\3068\30EC\30A4\30A2\30A6\30C8\3092\5B9A\7FA9\3059\308B\30EC\30DD\30FC\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\9078\629E\3057\307E\3059\3002</p>'),
unistr('        <p>\30EC\30DD\30FC\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30C6\30FC\30DE\3067\5B9A\7FA9\3055\308C\307E\3059\3002'),
unistr('        \30AF\30E9\30B7\30C3\30AF\30FB\30EC\30DD\30FC\30C8\304C\4F5C\6210\3055\308C\308B\3068\3001\30C6\30F3\30D7\30EC\30FC\30C8\306F\3001\73FE\5728\306E\30C6\30FC\30DE\306B\5B9A\7FA9\3055\308C\3066\3044\308B\30C7\30D5\30A9\30EB\30C8\30FB\30EC\30DD\30FC\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306B\81EA\52D5\7684\306B\8A2D\5B9A\3055\308C\307E\3059\3002</p>'),
unistr('        <p>\8868\306E\30C7\30FC\30BF\3001\30AD\30FC\5024\306E\30DA\30A2\3001\691C\7D22\7D50\679C\3001\30AB\30FC\30C9\306A\3069\3092\8868\793A\3059\308B\305F\3081\306E\30AF\30E9\30B7\30C3\30AF\30FB\30EC\30DD\30FC\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\304C\591A\304F\306E\30C6\30FC\30DE\306B\542B\307E\308C\307E\3059\3002'),
unistr('        \30AB\30FC\30C9\3084\691C\7D22\7D50\679C\306A\3069\306E\4E00\90E8\306E\30EC\30DD\30FC\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306F\884C\30D9\30FC\30B9\3067\3042\308A\3001SQL\554F\5408\305B\306B\3088\3063\3066\3001\30C6\30F3\30D7\30EC\30FC\30C8\3067\7F6E\63DB\3055\308C\308B\5217\306E\5225\540D\306E\7279\5B9A\306E\30BB\30C3\30C8\304C\8FD4\3055\308C\308B\5FC5\8981\304C\3042\308B\3053\3068\306B\6CE8\610F\3057\3066\304F\3060\3055\3044\3002<br>'),
unistr('        \30E6\30CB\30D0\30FC\30B5\30EB\30FB\30C6\30FC\30DE\306B\306F\3001\6B21\306E\30EC\30DD\30FC\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\304C\3042\308A\307E\3059\3002'),
'          <dl>',
unistr('            <dt>\30A2\30E9\30FC\30C8</dt>'),
unistr('              <dd>\4EFB\610F\306E\6570\306E\6C34\5E73\30A2\30E9\30FC\30C8\307E\305F\306F\901A\77E5\304C\30DA\30FC\30B8\306B\8868\793A\3055\308C\307E\3059\3002</dd>'),
unistr('            <dt>\30D0\30C3\30B8\30FB\30EA\30B9\30C8</dt>'),
unistr('              <dd>\30C0\30C3\30B7\30E5\30DC\30FC\30C9\72B6\306E\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\306B\30AD\30FC\5024\306E\30DA\30A2\304C\8868\793A\3055\308C\307E\3059\3002</dd>'),
unistr('            <dt>\30AB\30FC\30C9</dt>'),
unistr('              <dd>\30EC\30DD\30FC\30C8\30FB\30C7\30FC\30BF\304C\30AB\30FC\30C9(\5C0F\3055\3044\30D6\30ED\30C3\30AF)\3067\8868\793A\3055\308C\308B\305F\3081\3001\69D8\3005\306A\60C5\5831\3092\793A\3059\306E\306B\4FBF\5229\3067\3059\3002\30AB\30FC\30C9\306F\3001\300C\30C6\30F3\30D7\30EC\30FC\30C8\30FB\30AA\30D7\30B7\30E7\30F3\300D\3092\901A\3058\3066\8A73\7D30\306B\30AB\30B9\30BF\30DE\30A4\30BA\3067\304D\307E\3059\3002</dd>'),
unistr('            <dt>\30B3\30E1\30F3\30C8</dt>'),
unistr('              <dd>\30B3\30E1\30F3\30C8\3068\4ED6\306E\30E1\30C3\30BB\30FC\30B8\304C\8868\793A\3055\308C\307E\3059\3002</dd>'),
unistr('            <dt>\691C\7D22\7D50\679C</dt>'),
unistr('              <dd>\691C\7D22\30A8\30F3\30B8\30F3\306E\30B9\30BF\30A4\30EB\3067\691C\7D22\7D50\679C\304C\8868\793A\3055\308C\307E\3059</dd>'),
unistr('            <dt>\6A19\6E96</dt>'),
unistr('              <dd>\3053\308C\306F\3001\8868\306E\30C7\30FC\30BF\3092\8868\793A\3059\308B\305F\3081\306E\30C7\30D5\30A9\30EB\30C8\30FB\30EC\30DD\30FC\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3067\3001\300C\30C6\30F3\30D7\30EC\30FC\30C8\30FB\30AA\30D7\30B7\30E7\30F3\300D\3092\901A\3058\3066\8A73\7D30\306B\30AB\30B9\30BF\30DE\30A4\30BA\3067\304D\307E\3059\3002</dd>'),
unistr('            <dt>\6642\7CFB\5217</dt>'),
unistr('              <dd>\30A2\30AF\30B7\30E7\30F3\306E\6642\7CFB\5217\304C\8868\793A\3055\308C\307E\3059\3002\3053\308C\306F\3001\6700\8FD1\306E\30A2\30AF\30B7\30E7\30F3\306E\30A2\30AF\30C6\30A3\30D3\30C6\30A3\30FB\30D5\30A3\30FC\30C9\304C\5FC5\8981\306A\30DB\30FC\30E0\30DA\30FC\30B8\3084\5909\66F4\30ED\30B0\306A\3069\306E\9818\57DF\306B\9069\3057\3066\3044\307E\3059\3002</dd>'),
unistr('            <dt>\5024\5C5E\6027\306E\7D44\5408\305B - \5217</dt>'),
unistr('              <dd>\5217\30D9\30FC\30B9\306E\554F\5408\305B\306E\30AD\30FC\3068\5024\306E\30DA\30A2\304C\8868\793A\3055\308C\307E\3059\3002\3053\308C\306F\3001\5404\30A2\30A4\30C6\30E0\306E\30E9\30D9\30EB\3068\3057\3066\5217\30D8\30C3\30C0\30FC\3092\4F7F\7528\3057\307E\3059\3002</dd>'),
unistr('            <dt>\5024\5C5E\6027\306E\7D44\5408\305B - \884C</dt>'),
unistr('              <dd>\884C\30D9\30FC\30B9\306E\554F\5408\305B\306E\30AD\30FC\3068\5024\306E\30DA\30A2\304C\8868\793A\3055\308C\307E\3059\3002\3053\308C\306F\3001\30E9\30D9\30EB\3068\3057\3066\6700\521D\306E\5217\3092\3001\5024\3068\3057\30662\756A\76EE\306E\5217\3092\4F7F\7528\3057\307E\3059\3002</dd>'),
'          </dl>',
unistr('          \95A2\9023\9805\76EE: <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\30E6\30CB\30D0\30FC\30B5\30EB\30FB\30C6\30FC\30DE\306E\30B5\30F3\30D7\30EB\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3</a>'),
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104237052967308637)
,p_name=>'PE.PROPERTY.REPORT_TEMPLATE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104098998151308515)
,p_name=>'PE.PROPERTY.REQUIRES_FILTER.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5C11\306A\304F\3068\30821\3064\306E\30D5\30A3\30EB\30BF\304C\30EC\30DD\30FC\30C8\5217\306E\3044\305A\308C\304B\3067\5B9A\7FA9\3055\308C\3066\3044\306A\3044\5834\5408\306B\5BFE\8A71\30B0\30EA\30C3\30C9\306E\30C7\30FC\30BF\8868\793A\3092\9632\6B62\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002'),
unistr('		\3053\306E\30AA\30D7\30B7\30E7\30F3\306F\3001\30D5\30A3\30EB\30BF\306B\57FA\3065\3044\3066\623B\3055\308C\308B\884C\3092\5236\9650\3057\3066\975E\5E38\306B\5927\304D\3044\30C7\30FC\30BF\30FB\30BB\30C3\30C8\304B\3089\30ED\30FC\30C9\3055\308C\308B\30C7\30FC\30BF\3092\5236\9650\3059\308B\3088\3046\8A2D\8A08\3055\308C\3066\3044\307E\3059\3002</p>'),
unistr('		<p>\30D5\30A3\30EB\30BF\304C\5217\306B\5FC5\8981\3067\3042\308B\3053\3068\3092\4FDD\8A3C\3059\308B\500B\3005\306E\5217\306E<strong>\300C\5217\30D5\30A3\30EB\30BF\304C\5FC5\8981\300D</strong>\3092\6709\52B9\306B\3067\304D\307E\3059\3002\305F\3060\3057\3001\3053\306E\30AA\30D7\30B7\30E7\30F3\306F\4EFB\610F\306E\5217\30671\3064\306E\30D5\30A3\30EB\30BF\306E\307F\5FC5\8981\3067\3059\3002</p>'),
unistr('		<p>\30CE\30FC\30C8 - \3053\306E\30AA\30D7\30B7\30E7\30F3\304C\8A2D\5B9A\3055\308C\3001\30D5\30A3\30EB\30BF\304C\73FE\5728\5B9A\7FA9\3055\308C\3066\3044\306A\3044\5834\5408\3001\30E6\30FC\30B6\30FC\306B\30D5\30A3\30EB\30BF\306E\5165\529B\3092\30EA\30AF\30A8\30B9\30C8\3059\308B\30E1\30C3\30BB\30FC\30B8\304C\8868\793A\3055\308C\307E\3059\3002</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104098884531308515)
,p_name=>'PE.PROPERTY.REQUIRES_FILTER.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30EB\30BF\304C\5FC5\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104255092599308649)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\306E\6587\5B57\3092\4FDD\5B58\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103897832077308325)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\306B\4FDD\5B58\3055\308C\308B\6587\5B57\3092\5236\9650\3059\308B\65B9\6CD5\3092\9078\629E\3057\307E\3059\3002'),
unistr('\30E6\30FC\30B6\30FC\304C\3001\9078\629E\3057\305F\6587\5B57\5236\9650\306B\6E96\62E0\3057\306A\3044\30C7\30FC\30BF\306E\4FDD\5B58\3092\8A66\307F\308B\3068\3001&PRODUCT_NAME.\304B\3089\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\304C\8868\793A\3055\308C\307E\3059\3002</p>'),
unistr('<p>\6587\5B57\3092\5236\9650\3059\308B\3053\3068\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30BB\30AD\30E5\30EA\30C6\30A3\3092\5F37\5316\3057\3001\30AF\30ED\30B9\30B5\30A4\30C8\30FB\30B9\30AF\30EA\30D7\30C6\30A3\30F3\30B0(XSS)\653B\6483\306E\5BFE\7B56\3068\306A\308A\5F97\3048\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104396153135308754)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.NO_SPECIAL_CHAR.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30ED\30C3\30AF\30EA\30B9\30C8&<>"/;,*|=%\304A\3088\3073--')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104396275422308754)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.NO_SPECIAL_CHAR.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\6587\5B57&amp;\3001&lt;\3001&gt;\3001"\3001/\3001;\3001","\3001*\3001|\3001=\3001%\304A\3088\3073"--"(PL/SQL\30B3\30E1\30F3\30C8)\306F\4FDD\5B58\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104396311269308754)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.NO_SPECIAL_CHAR_NL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30ED\30C3\30AF\30EA\30B9\30C8&<>"/;,*|=%\307E\305F\306F--\3068\6539\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104396448011308755)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.NO_SPECIAL_CHAR_NL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\6587\5B57&amp;\3001&lt;\3001&gt;\3001"\3001/\3001;\3001","\3001*\3001|\3001=\3001%\3001"--"\304A\3088\3073\6539\884C\6587\5B57\306F\4FDD\5B58\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104395754598308754)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.US_ONLY.D'
,p_message_language=>'ja'
,p_message_text=>unistr('a-Z\30010-9\3068\7A7A\767D\306E\8A31\53EF\30EA\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104395893224308754)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.US_ONLY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('a-z\3001A-Z\30010-9\304A\3088\3073\7A7A\767D\6587\5B57\306E\307F\4FDD\5B58\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104395959658308754)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.WEB_SAFE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30ED\30C3\30AF\30EA\30B9\30C8HTML\30B3\30DE\30F3\30C9\6587\5B57(<>")')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104396047156308754)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.WEB_SAFE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E88\7D04\6E08HTML\6587\5B57\306F\4FDD\5B58\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104396501000308755)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.WORKSPACE_SCHEMA.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\30FB\30B9\30AD\30FC\30DE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103897705427308325)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5236\9650\4ED8\304D\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104661990613308969)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\308B\30B3\30F3\30C6\30F3\30C4\306E\5165\529B\5F62\5F0F\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104662062768308969)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.LOV.HTML.D'
,p_message_language=>'ja'
,p_message_text=>'HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104662139868308969)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.LOV.HTML.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30C6\30F3\30C4\306B\306FHTML\30BF\30B0\304C\542B\307E\308C\3001\7279\6B8A\6587\5B57\306E\30A8\30B9\30B1\30FC\30D7\3092\9069\7528\305B\305A\306B\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\307E\3059\3002\30C7\30FC\30BF\304C\5B89\5168\3067\3001\30A8\30F3\30C9\30E6\30FC\30B6\30FC\304C\5165\529B\3057\305F\30C7\30FC\30BF\304C\542B\307E\308C\3066\3044\306A\3044\3053\3068\3092\78BA\8A8D\3057\3066\3001\30AF\30ED\30B9\30B5\30A4\30C9\30FB\30B9\30AF\30EA\30D7\30C6\30A3\30F3\30B0\306E\8106\5F31\6027(XSS)\3092\56DE\907F\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104662299258308969)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.LOV.MARKDOWN.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30FC\30AF\30C0\30A6\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104662394989308969)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.LOV.MARKDOWN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30C6\30F3\30C4\306B\306F\3001\30EC\30F3\30C0\30EA\30F3\30B0\306E\524D\306B\5B89\5168\306AHTML\30BF\30B0\306B\5909\63DB\3055\308C\308B\30DE\30FC\30AF\30C0\30A6\30F3\30FB\30BF\30B0\304C\542B\307E\308C\3066\3044\307E\3059\3002\65E2\77E5\306E\30DE\30FC\30AF\30C0\30A6\30F3\30FB\30BF\30B0\306E\5909\63DB\306B\3088\308A\3001\30AF\30ED\30B9\30B5\30A4\30C9\30FB\30B9\30AF\30EA\30D7\30C6\30A3\30F3\30B0\306E\8106\5F31\6027(XSS)\306E\554F\984C\304C<strong>\9632\6B62</strong>\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104661814646308968)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F8\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104098138765308515)
,p_name=>'PE.PROPERTY.ROW_VERSION_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F4\65B0\3055\308C\308B\8868\306E\884C\30D0\30FC\30B8\30E7\30F3\756A\53F7\3092\683C\7D0D\3059\308B\5217\3092\9078\629E\3057\307E\3059\3002\3053\306E\5217\304C\5931\308F\308C\305F\66F4\65B0\30C1\30A7\30C3\30AF\3067\4F7F\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104098042351308515)
,p_name=>'PE.PROPERTY.ROW_VERSION_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\30D0\30FC\30B8\30E7\30F3\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104221772082308625)
,p_name=>'PE.PROPERTY.RUN_PROCESS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30D7\30ED\30BB\30B9\304C\5B9F\884C\3055\308C\308B\983B\5EA6\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104411860803308766)
,p_name=>'PE.PROPERTY.RUN_PROCESS.LOV.N.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\3078\306E\30A2\30AF\30BB\30B9\3054\3068\306B1\56DE(\30C7\30D5\30A9\30EB\30C8)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104411779684308766)
,p_name=>'PE.PROPERTY.RUN_PROCESS.LOV.Y.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30C3\30B7\30E7\30F3\3054\3068\307E\305F\306F\30EA\30BB\30C3\30C8\6642\306B1\56DE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104221650948308625)
,p_name=>'PE.PROPERTY.RUN_PROCESS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30BB\30B9\306E\5B9F\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104207535387308615)
,p_name=>'PE.PROPERTY.SAVE_PUBLIC_REPORT_AUTHORIZATION.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30D1\30D6\30EA\30C3\30AF\30FB\30EC\30DD\30FC\30C8\5B9A\7FA9\3092\4FDD\5B58\3067\304D\308B\30E6\30FC\30B6\30FC\3092\5236\9650\3059\308B\8A8D\53EF\30B9\30AD\30FC\30E0\3092\9078\629E\3057\307E\3059\3002'),
unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\30D1\30D6\30EA\30C3\30AF\30FB\30EC\30DD\30FC\30C8\3092\4FDD\5B58\3067\304D\308B\305F\3081\306B\306F\3001\3053\306E\8A8D\53EF\30B9\30AD\30FC\30E0\304CTRUE\3068\8A55\4FA1\3055\308C\308B\5FC5\8981\304C\3042\308A\307E\3059\3002'),
unistr('\8A8D\53EF\30B9\30AD\30FC\30E0\3092\6307\5B9A\3057\306A\3044\5834\5408\3001\3060\308C\3067\3082\30EC\30DD\30FC\30C8\3092\4FDD\5B58\3067\304D\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104207474241308615)
,p_name=>'PE.PROPERTY.SAVE_PUBLIC_REPORT_AUTHORIZATION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30D6\30EA\30C3\30AF\30FB\30EC\30DD\30FC\30C8\306E\4FDD\5B58\306E\8A8D\53EF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103979919918308420)
,p_name=>'PE.PROPERTY.SAVE_STATE_BEFORE_BRANCH.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30D6\30E9\30F3\30C1\306E\5B9F\884C\524D\306B\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\306E\5024\3092\30C7\30FC\30BF\30D9\30FC\30B9\306B\4FDD\5B58\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002'),
unistr('\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304B\3089\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\5024\306B\30A2\30AF\30BB\30B9\3059\308B\5FC5\8981\306E\3042\308B\5225\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\79FB\52D5\3059\308B\5834\5408\3001\3053\306E\5C5E\6027\3092<strong>\300C\30AA\30F3\300D</strong>\306B\8A2D\5B9A\3059\308B\3053\3068\304C\91CD\8981\3067\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103979898906308420)
,p_name=>'PE.PROPERTY.SAVE_STATE_BEFORE_BRANCH.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30E9\30F3\30C1\51E6\7406\306E\524D\306B\30B9\30C6\30FC\30C8\3092\4FDD\5B58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103966860647308410)
,p_name=>'PE.PROPERTY.SCHEMA_OVERRIDE_ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30FC\30D0\30FC\30E9\30A4\30C9\89E3\6790\5BFE\8C61\30B9\30AD\30FC\30DE\3068\3057\3066\4F7F\7528\3059\308B\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002\3053\308C\306F\3001\5185\90E8\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5C02\7528\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103966747725308410)
,p_name=>'PE.PROPERTY.SCHEMA_OVERRIDE_ITEM.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AD\30FC\30DE\30FB\30AA\30FC\30D0\30FC\30E9\30A4\30C9\30FB\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104586749358308908)
,p_name=>'PE.PROPERTY.SCHEME_PLSQL_FUNCTION_BODY.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104586619349308908)
,p_name=>'PE.PROPERTY.SCHEME_SQL_STATEMENT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104585931284308907)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\3053\306E\8A8D\53EF\30B9\30AD\30FC\30E0\306E\9069\7528\65B9\6CD5\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104586081457308908)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_EXISTS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('EXISTS SQL\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104586131824308908)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_EXISTS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\554F\5408\305B\304B\3089\5024\304C\8FD4\3055\308C\305F\5834\5408\3001\8A8D\53EF\306F\30D1\30B9\3057\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104586441634308908)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_FUNCTION_BODY.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30FC\30EB\3092\623B\3059PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104586531223308908)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_FUNCTION_BODY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30FC\30EB\5024\3092\8FD4\3059PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104586204349308908)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_NOT_EXISTS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('NOT EXISTS SQL\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104586345783308908)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_NOT_EXISTS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\554F\5408\305B\304B\3089\4F55\3082\5024\304C\8FD4\3055\308C\306A\304B\3063\305F\5834\5408\3001\8A8D\53EF\306F\30D1\30B9\3057\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104585819373308907)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AD\30FC\30E0\30FB\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104207742002308615)
,p_name=>'PE.PROPERTY.SEARCH_BUTTON_LABEL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22\30DC\30BF\30F3\306E\30E9\30D9\30EB\306E\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104207624228308615)
,p_name=>'PE.PROPERTY.SEARCH_BUTTON_LABEL.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22\30DC\30BF\30F3\30FB\30E9\30D9\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104569351709308894)
,p_name=>'PE.PROPERTY.SECOND_BODY_ADV_FORMATTING.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\3092\3001\5217\307E\305F\306FHTML\5F0F\304A\3088\3073\30B5\30DD\30FC\30C8\3055\308C\3066\3044\308B\7F6E\63DB\6587\5B57\5217\3092\4F7F\7528\3059\308B\62E1\5F35\30D5\30A9\30FC\30DE\30C3\30C8\306E\3044\305A\308C\3092\4F7F\7528\3057\3066\8868\793A\3059\308B\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104569282279308894)
,p_name=>'PE.PROPERTY.SECOND_BODY_ADV_FORMATTING.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\62E1\5F35\30D5\30A9\30FC\30DE\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104569524134308894)
,p_name=>'PE.PROPERTY.SECOND_BODY_COLUMN_NAME.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('2\6B21\672C\4F53\3068\3057\3066\4F7F\7528\3059\308B\5217\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104569418787308894)
,p_name=>'PE.PROPERTY.SECOND_BODY_COLUMN_NAME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104570024551308894)
,p_name=>'PE.PROPERTY.SECOND_BODY_CSS_CLASSES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\8FFD\52A0\3059\308B\30AF\30E9\30B9\3092\5165\529B\3057\307E\3059\3002\8907\6570\306E\30AF\30E9\30B9\306F\7A7A\767D\3067\533A\5207\3063\3066\8FFD\52A0\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104569996068308894)
,p_name=>'PE.PROPERTY.SECOND_BODY_CSS_CLASSES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('CSS\30AF\30E9\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104569819945308894)
,p_name=>'PE.PROPERTY.SECOND_BODY_HTML_EXPR.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>\30D0\30C3\30AF\30B0\30E9\30A6\30F3\30C9\304A\3088\3073\30C6\30AD\30B9\30C8\306E\8272\306E\5909\66F4</dt>'),
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>\30D8\30C3\30C0\30FC2\306E\4F7F\7528</dt>'),
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>SQL\554F\5408\305B\304B\3089\306E\52D5\7684\30AF\30E9\30B9\306E\4F7F\7528</dt>'),
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    \3053\306E\4F8B\3067<code>&COLUMN_CLASS.</code>\3068<code>&EMPLOYEE_STATUS.</code>\306B\4EE3\5165\3055\308C\308B\306E\306F\3001\30EC\30DD\30FC\30C8SQL\554F\5408\305B\3067\9078\629E\3055\308C\305F\5217\3067\3059\3002</dd>'),
unistr('  <dt>\30DB\30D0\30FC\3067\306E\30A4\30E1\30FC\30B8\304A\3088\3073\30C4\30FC\30EB\30C1\30C3\30D7\306E\8868\793A</dt>'),
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104569757706308894)
,p_name=>'PE.PROPERTY.SECOND_BODY_HTML_EXPR.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\5217\306B\8868\793A\3055\308C\308BHTML\5F0F\3092\5165\529B\3057\307E\3059\3002<code>&COLUMN.</code>\69CB\6587\3092\4F7F\7528\3057\3066\3001HTML\306B\5217\5024\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104569602177308894)
,p_name=>'PE.PROPERTY.SECOND_BODY_HTML_EXPR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('HTML\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103965610597308409)
,p_name=>'PE.PROPERTY.SECURE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p><strong>\300C\30AA\30F3\300D</strong>\3092\6307\5B9A\3059\308B\3068\3001\30D7\30ED\30C8\30B3\30EB\304CHTTPS\306E\5834\5408\306B\306E\307F\3001\30BB\30C3\30B7\30E7\30F3\7BA1\7406Cookie\304C\30D6\30E9\30A6\30B6\304B\3089\9001\4FE1\3055\308C\307E\3059\3002'),
unistr('<strong>\300C\30AA\30D5\300D</strong>\3092\9078\629E\3059\308B\3068\3001\30D7\30ED\30C8\30B3\30EB\304CHTTP\307E\305F\306FHTTPS\306E\3044\305A\308C\306E\5834\5408\3082\3001\30BB\30C3\30B7\30E7\30F3\7BA1\7406Cookie\304C\30D6\30E9\30A6\30B6\304B\3089\9001\4FE1\3055\308C\307E\3059\3002</p>'),
unistr('<p>Web\30B5\30FC\30D0\30FC\306BSSL\304C\69CB\6210\3055\308C\3066\3044\308B\5834\5408\306F\3001<strong>\300C\30AA\30F3\300D</strong>\3092\9078\629E\3057\3001\6697\53F7\5316\3055\308C\3066\3044\306A\3044HTTP\30C8\30E9\30D5\30A3\30C3\30AF\3092\56DE\907F\3059\308B\3053\3068\306B\3088\308A\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30BB\30AD\30E5\30EA\30C6\30A3\3092\5F37\5316\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103965528671308409)
,p_name=>'PE.PROPERTY.SECURE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30AD\30E5\30A2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104122107990308535)
,p_name=>'PE.PROPERTY.SELECT_FIRST_ROW.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\521D\306E\884C\3092\81EA\52D5\7684\306B\9078\629E\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104122031238308535)
,p_name=>'PE.PROPERTY.SELECT_FIRST_ROW.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\521D\306E\884C\306E\9078\629E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104262207801308655)
,p_name=>'PE.PROPERTY.SERIES_CHART_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30EA\30FC\30BA\30FB\30C1\30E3\30FC\30C8\30FB\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104156751814308572)
,p_name=>'PE.PROPERTY.SERIES_NAME_COLUMN_NAME.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30EB\30C1\30B7\30EA\30FC\30BA\52D5\7684\554F\5408\305B\3092\5B9A\7FA9\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\5217\540D\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104156679143308572)
,p_name=>'PE.PROPERTY.SERIES_NAME_COLUMN_NAME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30EA\30FC\30BA\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103897240574308325)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\4FDD\8B77\30EC\30D9\30EB\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104394986557308753)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.B.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30A7\30C3\30AF\30B5\30E0\304C\5FC5\8981 - \30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30EC\30D9\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104395048598308753)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.B.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\56FA\6709\306E\30C1\30A7\30C3\30AF\30B5\30E0\3092\542B\3080URL\3067\30A2\30A4\30C6\30E0\3092\6E21\3057\3066\30A2\30A4\30C6\30E0\3092\8A2D\5B9A\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104395515349308754)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.I.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5236\9650\4ED8\304D - \30D6\30E9\30A6\30B6\304B\3089\8A2D\5B9A\4E0D\53EF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104395696916308754)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.I.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30A2\30A4\30C6\30E0\306F\3001URL\307E\305F\306FPOSTDATA\3092\4F7F\7528\3057\3066\5909\66F4\3067\304D\307E\305B\3093\3002'),
unistr('\3053\306E\30AA\30D7\30B7\30E7\30F3\3092\8A2D\5B9A\3057\3066\3001\30A2\30A4\30C6\30E0\5024\3092\5185\90E8\30D7\30ED\30BB\30B9\3001\8A08\7B97\306A\3069\306B\8A2D\5B9A\3067\304D\308B\3082\306E\3092\5236\9650\3057\307E\3059\3002'),
unistr('\3053\306E\5C5E\6027\306F\3001\30C7\30FC\30BF\30FB\30A8\30F3\30C8\30EA\30FB\30A2\30A4\30C6\30E0\3068\3057\3066\4F7F\7528\3055\308C\306A\3044\30A2\30A4\30C6\30E0\306B\306E\307F\9069\7528\3055\308C\3001\300C\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\4FDD\8B77\300D\304C\7121\52B9\306E\5834\5408\3067\3082\5E38\306B\76E3\8996\3055\308C\307E\3059\3002'),
unistr('\3053\306E\5C5E\6027\3092\6B21\306E<strong>\300C\8868\793A\5F62\5F0F\300D</strong>\30BF\30A4\30D7\306E\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\306B\4F7F\7528\3057\307E\3059\3002'),
'<ul>',
unistr('  <li>\8868\793A\306E\307F(\72B6\614B\306E\4FDD\5B58=\3044\3044\3048)</li>'),
unistr('  <li>\30C6\30AD\30B9\30C8\30FB\30D5\30A3\30FC\30EB\30C9(\7121\52B9\3001\72B6\614B\3092\4FDD\5B58\3057\306A\3044)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104394718824308753)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.N.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5236\9650\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104394827030308753)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.N.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('URL\307E\305F\306F\30D5\30A9\30FC\30E0\3067\30A2\30A4\30C6\30E0\3092\6E21\3057\3066\30A2\30A4\30C6\30E0\3092\8A2D\5B9A\3067\304D\307E\3059\3002\30C1\30A7\30C3\30AF\30B5\30E0\306FURL\306B\5FC5\8981\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104395159018308754)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.P.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30A7\30C3\30AF\30B5\30E0\304C\5FC5\8981 - \30E6\30FC\30B6\30FC\30FB\30EC\30D9\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104395298020308754)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.P.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304A\3088\3073\30E6\30FC\30B6\30FC\306B\56FA\6709\306E\30C1\30A7\30C3\30AF\30B5\30E0\3092\542B\3080URL\3067\30A2\30A4\30C6\30E0\3092\6E21\3057\3066\30A2\30A4\30C6\30E0\3092\8A2D\5B9A\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104395386040308754)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.S.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30A7\30C3\30AF\30B5\30E0\304C\5FC5\8981 - \30BB\30C3\30B7\30E7\30F3\30FB\30EC\30D9\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104395436652308754)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.S.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30C3\30B7\30E7\30F3\306B\56FA\6709\306E\30C1\30A7\30C3\30AF\30B5\30E0\3092\542B\3080URL\3067\30A2\30A4\30C6\30E0\3092\6E21\3057\3066\30A2\30A4\30C6\30E0\3092\8A2D\5B9A\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103897175105308325)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\4FDD\8B77')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103919110256308373)
,p_name=>'PE.PROPERTY.SFILTER_GROUP.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30C1\30A7\30C3\30AF\30DC\30C3\30AF\30B9\304C\95A2\9023\4ED8\3051\3089\308C\308B\30D5\30A3\30EB\30BF\30FB\30B0\30EB\30FC\30D7\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103919041554308373)
,p_name=>'PE.PROPERTY.SFILTER_GROUP.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30EB\30BF\30FB\30B0\30EB\30FC\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104682432498308985)
,p_name=>'PE.PROPERTY.SHORTCUT_NAME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\540D\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104586880009308908)
,p_name=>'PE.PROPERTY.SHORTCUT_PLSQL_FUNCTION_BODY.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104682519170308985)
,p_name=>'PE.PROPERTY.SHORTCUT_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104217927505308623)
,p_name=>'PE.PROPERTY.SHOW_ACTIONS_MENU.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<em>\300C\30A2\30AF\30B7\30E7\30F3\300D</em>\30E1\30CB\30E5\30FC\3092\691C\7D22\30D0\30FC\5185\306B\542B\3081\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104217862558308623)
,p_name=>'PE.PROPERTY.SHOW_ACTIONS_MENU.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\30A2\30AF\30B7\30E7\30F3\300D\30E1\30CB\30E5\30FC\3092\542B\3081\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104215183692308621)
,p_name=>'PE.PROPERTY.SHOW_AGGREGATE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\3053\306E\30EC\30DD\30FC\30C8\306B\96C6\8A08\3092\5B9A\7FA9\3067\304D\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104215008392308621)
,p_name=>'PE.PROPERTY.SHOW_AGGREGATE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\96C6\8A08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104200831365308610)
,p_name=>'PE.PROPERTY.SHOW_BY_DEFAULT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\5217\3092\30EC\30DD\30FC\30C8\306B\30C7\30D5\30A9\30EB\30C8\3067\8868\793A\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104200784294308610)
,p_name=>'PE.PROPERTY.SHOW_BY_DEFAULT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\3067\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104215361610308621)
,p_name=>'PE.PROPERTY.SHOW_CHART.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\3053\306E\30EC\30DD\30FC\30C8\306B\30C1\30E3\30FC\30C8\3092\5B9A\7FA9\3067\304D\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104215226715308621)
,p_name=>'PE.PROPERTY.SHOW_CHART.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104214924110308620)
,p_name=>'PE.PROPERTY.SHOW_COMPUTATION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\3053\306E\30EC\30DD\30FC\30C8\306E\8A08\7B97\5217\3092\5B9A\7FA9\3067\304D\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104214809657308620)
,p_name=>'PE.PROPERTY.SHOW_COMPUTATION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A08\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104214509788308620)
,p_name=>'PE.PROPERTY.SHOW_CONTROL_BREAK.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\3053\306E\30EC\30DD\30FC\30C8\306B\30B3\30F3\30C8\30ED\30FC\30EB\30FB\30D6\30EC\30FC\30AF\3092\5B9A\7FA9\3067\304D\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104214493728308620)
,p_name=>'PE.PROPERTY.SHOW_CONTROL_BREAK.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30C8\30ED\30FC\30EB\30FB\30D6\30EC\30FC\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103919562286308374)
,p_name=>'PE.PROPERTY.SHOW_CURRENT_FACET_LABEL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30D5\30A1\30BB\30C3\30C8\306E\30EA\30B9\30C8\3067\3001\9078\629E\3057\305F\5024\306E\6A2A\306B\30D5\30A1\30BB\30C3\30C8\30FB\30E9\30D9\30EB\3092\8868\793A\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002\9078\629E\3057\305F\5024\304C\81EA\660E\3067\3042\308B\5834\5408(\30AA\30FC\30C0\30FC\30FB\30B9\30C6\30FC\30BF\30B9\306A\3069)\3001\30E9\30D9\30EB\3092\975E\8868\793A\306B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103919425710308374)
,p_name=>'PE.PROPERTY.SHOW_CURRENT_FACET_LABEL.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30D5\30A1\30BB\30C3\30C8\306E\30E9\30D9\30EB\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104217535907308622)
,p_name=>'PE.PROPERTY.SHOW_DISPLAY_ROW_COUNT.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\72EC\7ACB\3057\305F\30C9\30ED\30C3\30D7\30FB\30C0\30A6\30F3\884C\30BB\30EC\30AF\30BF\3092\691C\7D22\30D0\30FC\306B\542B\3081\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002'),
unistr('\3053\306E\5C5E\6027\3068<strong>\30DA\30FC\30B8\3054\3068\306E\884C\6570</strong>\306E\4E21\65B9\306F\9078\629E\3067\304D\307E\305B\3093\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104217414738308622)
,p_name=>'PE.PROPERTY.SHOW_DISPLAY_ROW_COUNT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\3054\3068\306E\884C\6570\30BB\30EC\30AF\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104216354888308621)
,p_name=>'PE.PROPERTY.SHOW_DOWNLOAD.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\6307\5B9A\3055\308C\305F\30C0\30A6\30F3\30ED\30FC\30C9\5F62\5F0F\306E\3044\305A\308C\304B\306B\30EC\30DD\30FC\30C8\3092\30C0\30A6\30F3\30ED\30FC\30C9\3067\304D\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104216249766308621)
,p_name=>'PE.PROPERTY.SHOW_DOWNLOAD.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C0\30A6\30F3\30ED\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104213792048308620)
,p_name=>'PE.PROPERTY.SHOW_FILTER.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\3053\306E\30EC\30DD\30FC\30C8\306B\30D5\30A3\30EB\30BF\3092\5B9A\7FA9\3067\304D\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104213652113308620)
,p_name=>'PE.PROPERTY.SHOW_FILTER.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30EB\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104217308554308622)
,p_name=>'PE.PROPERTY.SHOW_FINDER_DROP_DOWN.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30D5\30A1\30A4\30F3\30C0\30FB\30C9\30ED\30C3\30D7\30FB\30C0\30A6\30F3\3092\691C\7D22\30D0\30FC\306E\691C\7D22\30D5\30A3\30FC\30EB\30C9\306E\5148\982D\306B\542B\3081\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002'),
unistr('\30D5\30A1\30A4\30F3\30C0\30FB\30C9\30ED\30C3\30D7\30FB\30C0\30A6\30F3\306F\3001\30E6\30FC\30B6\30FC\304C\7279\5B9A\306E\5217\306B\691C\7D22\3092\5236\9650\3067\304D\308B\5217\306E\30EA\30B9\30C8\3067\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104217211860308622)
,p_name=>'PE.PROPERTY.SHOW_FINDER_DROP_DOWN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30F3\30C0\30FB\30C9\30ED\30C3\30D7\30FB\30C0\30A6\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104215908970308621)
,p_name=>'PE.PROPERTY.SHOW_FLASHBACK.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\3053\306E\30EC\30DD\30FC\30C8\306B\5BFE\3057\3066\30D5\30E9\30C3\30B7\30E5\30D0\30C3\30AF\554F\5408\305B\3092\4F7F\7528\3067\304D\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002</p>'),
unistr('<p>\30D5\30E9\30C3\30B7\30E5\30D0\30C3\30AF\554F\5408\305B\3067\306F\3001Oracle Flashback Technology\304A\3088\3073\30C7\30FC\30BF\30D9\30FC\30B9\306EPoint-in-Time\30EA\30AB\30D0\30EA\3092\4F7F\7528\3057\3066\904E\53BB\306E\3042\308B\6642\70B9\306B\5B58\5728\3057\3066\3044\305F\30C7\30FC\30BF\3092\8868\793A\3057\307E\3059\3002\30E6\30FC\30B6\30FC\306F\3053\306E\30C7\30FC\30BF\306E\554F\5408\305B\306E\307F\3067\304D\307E\3059\3002\30C7\30FC\30BF\306E\5909\66F4\3092\53D6\308A\6D88\3059\3053\3068\306F\3067\304D\307E\305B\3093\3002\3069\3053\307E\3067\9061\3063\3066\30D5\30E9\30C3\30B7\30E5\30D0\30C3\30AF\554F\5408\305B\3092\6B63\5E38\306B\5B9F\884C\3067\304D\308B\304B\306F\3001Oracle Database\5185\3067REDO\30ED\30B0\30FB\30D5\30A1\30A4\30EB\304C\6700\5F8C\306B\3044\3064\5207\308A\66FF\308F\3063\305F\304B\306B\3088\3063\3066\6C7A\307E\308A\307E\3059\3002\3053\308C\306F\3001\3053\306E\30C6\30AF\30CE\30ED\30B8\3067RMAN\30D0\30C3\30AF\30A2\30C3\30D7\304C\4F7F\7528\3055\308C\308B')
||unistr('\305F\3081\3067\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104215817761308621)
,p_name=>'PE.PROPERTY.SHOW_FLASHBACK.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30E9\30C3\30B7\30E5\30D0\30C3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104215729975308621)
,p_name=>'PE.PROPERTY.SHOW_GROUP_BY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\3053\306E\30EC\30DD\30FC\30C8\306B\30D6\30EC\30FC\30AF\30C0\30A6\30F3\5225\30B0\30EB\30FC\30D7\3092\5B9A\7FA9\3067\304D\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104215636008308621)
,p_name=>'PE.PROPERTY.SHOW_GROUP_BY.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30EB\30FC\30D7\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104153503342308569)
,p_name=>'PE.PROPERTY.SHOW_GROUP_NAME.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30EB\30FC\30D7\540D\3092\30C1\30E3\30FC\30C8\3067\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\305F\30C4\30FC\30EB\30C1\30C3\30D7\306B\8868\793A\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104153470642308569)
,p_name=>'PE.PROPERTY.SHOW_GROUP_NAME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30EB\30FC\30D7\540D\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104216552548308622)
,p_name=>'PE.PROPERTY.SHOW_HELP.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\306E\7D44\8FBC\307F\30D8\30EB\30D7\30FB\30E2\30FC\30C0\30EB\30FB\30C0\30A4\30A2\30ED\30B0\3092\8D77\52D5\3067\304D\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002</p>'),
unistr('<p>\30D8\30EB\30D7\30FB\30C0\30A4\30A2\30ED\30B0\3067\306F\3001\73FE\5728\306E\30E6\30FC\30B6\30FC\304C\4F7F\7528\3067\304D\308B\30AA\30D7\30B7\30E7\30F3\304C\6982\8AAC\3055\308C\308B\306E\307F\3067\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104216443090308622)
,p_name=>'PE.PROPERTY.SHOW_HELP.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D8\30EB\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104214716007308620)
,p_name=>'PE.PROPERTY.SHOW_HIGHLIGHT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\3053\306E\30EC\30DD\30FC\30C8\306B\30CF\30A4\30E9\30A4\30C8\3092\5B9A\7FA9\3067\304D\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104214634055308620)
,p_name=>'PE.PROPERTY.SHOW_HIGHLIGHT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CF\30A4\30E9\30A4\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104538252407308866)
,p_name=>'PE.PROPERTY.SHOW_IN_LEGEND.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30EC\30A4\30E4\30FC\3092\51E1\4F8B\306B\8868\793A\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104538144056308866)
,p_name=>'PE.PROPERTY.SHOW_IN_LEGEND.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104215545770308621)
,p_name=>'PE.PROPERTY.SHOW_NOTIFY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\3053\306E\30EC\30DD\30FC\30C8\306B\30B5\30D6\30B9\30AF\30EA\30D7\30B7\30E7\30F3\8A2D\5B9A\3092\5B9A\7FA9\3067\304D\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104215455019308621)
,p_name=>'PE.PROPERTY.SHOW_NOTIFY.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30D6\30B9\30AF\30EA\30D7\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104206956165308615)
,p_name=>'PE.PROPERTY.SHOW_NULL_VALUES_AS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('NULL\5217\306B\8868\793A\3059\308B\30C6\30AD\30B9\30C8\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104206806557308615)
,p_name=>'PE.PROPERTY.SHOW_NULL_VALUES_AS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('NULL\5024\306E\8868\793A\5F62\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103515651377308027)
,p_name=>'PE.PROPERTY.SHOW_PIVOT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\3053\306E\30EC\30DD\30FC\30C8\306B\30D4\30DC\30C3\30C8\30FB\30D6\30EC\30FC\30AF\30C0\30A6\30F3\3092\5B9A\7FA9\3067\304D\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103515594707308027)
,p_name=>'PE.PROPERTY.SHOW_PIVOT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D4\30DC\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103892645846308317)
,p_name=>'PE.PROPERTY.SHOW_QUICK_PICKS.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306B\30AF\30A4\30C3\30AF\9078\629E\304C\8868\793A\3055\308C\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002'),
unistr('\30AF\30A4\30C3\30AF\9078\629E\3067\306F\3001\30E6\30FC\30B6\30FC\306F\3001\30C6\30AD\30B9\30C8\3092\5165\529B\3057\305F\308A\3001\4F7F\7528\53EF\80FD\306A\30AA\30D7\30B7\30E7\30F3\306E\30EA\30B9\30C8\304B\3089\9078\629E\3059\308B\304B\308F\308A\306B\3001\4E8B\524D\5B9A\7FA9\3055\308C\305F\5024\3092\30EF\30F3\30AF\30EA\30C3\30AF\3067\9078\629E\3067\304D\307E\3059\3002</p>'),
unistr('<p>\6BD4\8F03\7684\5C0F\3055\304F\3001\4E0D\9023\7D9A\306E<em>\5171\901A</em>\306E\5165\529B\5024\306E\30BB\30C3\30C8\304C\3042\308B\5834\5408\3001\30AF\30A4\30C3\30AF\9078\629E\3092\6307\5B9A\3057\307E\3059\3002'),
unistr('1\3064\306E\30A2\30A4\30C6\30E0\306B\5B9A\7FA9\3067\304D\308B\30AF\30A4\30C3\30AF\9078\629E\306F\6700\592710\500B\3067\3059\3002'),
unistr('\3053\306E\3088\3046\306A\30E6\30FC\30B6\30FC\88DC\52A9\306F\3001\4F7F\7528\53EF\80FD\306A\5024\306E\9078\629E\30EA\30B9\30C8\304C\9577\3044\30A2\30A4\30C6\30E0\306B\5BFE\3057\3066\5B9A\7FA9\3059\308B\3068\7279\306B\6709\7528\3067\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103892536164308317)
,p_name=>'PE.PROPERTY.SHOW_QUICK_PICKS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30EA\30C3\30AF\9078\629E\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104218174581308623)
,p_name=>'PE.PROPERTY.SHOW_REPORTS_SELECT_LIST.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30EC\30DD\30FC\30C8\9078\629E\30EA\30B9\30C8\3092\691C\7D22\30D0\30FC\306B\8868\793A\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002</p>'),
unistr('<p>\30EC\30DD\30FC\30C8\9078\629E\30EA\30B9\30C8\306F\3001\30D7\30E9\30A4\30DE\30EA\30FB\30EC\30DD\30FC\30C8\4EE5\5916\306E\30EC\30DD\30FC\30C8\306B\30E6\30FC\30B6\30FC\304C\30A2\30AF\30BB\30B9\53EF\80FD\306A\5834\5408\306B\306E\307F\8868\793A\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104218074059308623)
,p_name=>'PE.PROPERTY.SHOW_REPORTS_SELECT_LIST.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\9078\629E\30EA\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104216159721308621)
,p_name=>'PE.PROPERTY.SHOW_RESET.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\300C\30A2\30AF\30B7\30E7\30F3\300D\30E1\30CB\30E5\30FC\304B\3089\30EC\30DD\30FC\30C8\3092\30EA\30BB\30C3\30C8\3067\304D\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002</p>'),
unistr('<p>\30EC\30DD\30FC\30C8\3092\30EA\30BB\30C3\30C8\3059\308B\3068\3001\30E6\30FC\30B6\30FC\304C\884C\3063\305F\30AB\30B9\30BF\30DE\30A4\30BA\3084\30B3\30FC\30EB\5143\306EURL\3067\6307\5B9A\3055\308C\305F\30AB\30B9\30BF\30DE\30A4\30BA\304C\3059\3079\3066\5143\306B\623B\308A\3001\30D7\30E9\30A4\30DE\30EA\30FB\30EC\30DD\30FC\30C8\304C\8868\793A\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104216073624308621)
,p_name=>'PE.PROPERTY.SHOW_RESET.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30BB\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104214126268308620)
,p_name=>'PE.PROPERTY.SHOW_ROWS_PER_PAGE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\3053\306E\30EC\30DD\30FC\30C8\306B\8868\793A\3055\308C\308B\884C\306E\6570\3092\5909\66F4\3067\304D\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104214092140308620)
,p_name=>'PE.PROPERTY.SHOW_ROWS_PER_PAGE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\3054\3068\306E\884C\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104217733339308622)
,p_name=>'PE.PROPERTY.SHOW_SEARCH_TEXTBOX.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22\30D5\30A3\30FC\30EB\30C9\3092\691C\7D22\30D0\30FC\5185\306B\542B\3081\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104217689855308622)
,p_name=>'PE.PROPERTY.SHOW_SEARCH_TEXTBOX.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22\30D5\30A3\30FC\30EB\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104213956152308620)
,p_name=>'PE.PROPERTY.SHOW_SELECT_COLUMNS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\3053\306E\30EC\30DD\30FC\30C8\306B\8868\793A\3055\308C\308B\5217\3092\5909\66F4\3059\308B\300C\30A2\30AF\30B7\30E7\30F3\300D\30E1\30CB\30E5\30FC\306E<strong>\300C\5217\306E\9078\629E\300D</strong>\3092\4F7F\7528\3067\304D\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002\30E6\30FC\30B6\30FC\306F\3001\3053\306E\30AA\30D7\30B7\30E7\30F3\3092\4F7F\7528\3057\3066\3001\8907\6570\306E\5217\3092\9078\629E(\8868\793A)\3001\9078\629E\89E3\9664(\975E\8868\793A)\307E\305F\306F\4E26\3079\66FF\3048\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104213880595308620)
,p_name=>'PE.PROPERTY.SHOW_SELECT_COLUMNS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\306E\9078\629E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104153332514308569)
,p_name=>'PE.PROPERTY.SHOW_SERIES_NAME.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30EA\30FC\30BA\540D\3092\30C1\30E3\30FC\30C8\3067\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\305F\30C4\30FC\30EB\30C1\30C3\30D7\306B\8868\793A\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104153286901308569)
,p_name=>'PE.PROPERTY.SHOW_SERIES_NAME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30EA\30FC\30BA\540D\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104214327302308620)
,p_name=>'PE.PROPERTY.SHOW_SORT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\3053\306E\30EC\30DD\30FC\30C8\306B\30BD\30FC\30C8\5217\3092\5B9A\7FA9\3067\304D\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104214216202308620)
,p_name=>'PE.PROPERTY.SHOW_SORT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103918547774308373)
,p_name=>'PE.PROPERTY.SHOW_SUGGESTIONS_LABEL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30B8\30A7\30B9\30C1\30E7\30F3\30FB\30C1\30C3\30D7\306B\30D5\30A3\30EB\30BF\306E\30E9\30D9\30EB\3092\8868\793A\3059\308B\304B\3001\5024\306E\307F\3092\8868\793A\3059\308B\304B\3092\6307\5B9A\3057\307E\3059\3002\63D0\6848\3055\308C\305F\5024\304C\81EA\660E\3067\3042\308B\5834\5408(\30AA\30FC\30C0\30FC\30FB\30B9\30C6\30FC\30BF\30B9\306A\3069)\3001\30E9\30D9\30EB\3092\975E\8868\793A\306B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103918431023308373)
,p_name=>'PE.PROPERTY.SHOW_SUGGESTIONS_LABEL.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB\3092\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104099940377308516)
,p_name=>'PE.PROPERTY.SHOW_TOOLBAR.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C4\30FC\30EB\30D0\30FC\3092\30EC\30DD\30FC\30C8\306E\4E0A\306B\8868\793A\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002\30C4\30FC\30EB\30D0\30FC\306B\306F\3001\691C\7D22\3001\30EC\30DD\30FC\30C8\30FB\30BF\30A4\30D7\3001\4FDD\5B58\3055\308C\305F\30EC\30DD\30FC\30C8\3001\30A2\30AF\30B7\30E7\30F3\3001\5909\66F4\304A\3088\3073\30EA\30BB\30C3\30C8\6A5F\80FD\304C\542B\307E\308C\308B\53EF\80FD\6027\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104099847636308516)
,p_name=>'PE.PROPERTY.SHOW_TOOLBAR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104099794475308516)
,p_name=>'PE.PROPERTY.SHOW_TOTAL_ROW_COUNT.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30EC\30DD\30FC\30C8\30FB\30D5\30C3\30BF\30FC\306B\7DCF\884C\6570\3092\8868\793A\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002<p/>'),
unistr('        <p>\30CE\30FC\30C8 - \7DCF\884C\6570\3092\53D6\5F97\3059\308B\305F\3081\306B\8FFD\52A0\306E\554F\5408\305B\304C\5B9F\884C\3055\308C\3001\7279\306B\975E\5E38\306B\5927\304D\3044\30C7\30FC\30BF\30FB\30BB\30C3\30C8\306E\30D1\30D5\30A9\30FC\30DE\30F3\30B9\304C\59A8\3052\3089\308C\308B\5834\5408\304C\3042\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104099684889308516)
,p_name=>'PE.PROPERTY.SHOW_TOTAL_ROW_COUNT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7DCF\884C\6570\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104235103219308635)
,p_name=>'PE.PROPERTY.SIMPLE_CHECKBOX_VALUES.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\300C\5358\7D14\306A\30C1\30A7\30C3\30AF\30DC\30C3\30AF\30B9\300D\8868\793A\30BF\30A4\30D7\306E\5834\5408\30011\3064\306E\5024\307E\305F\306F\30AB\30F3\30DE\3067\533A\5207\3063\305F2\3064\306E\5024\3092\5165\529B\3057\307E\3059\3002'),
unistr('\30C1\30A7\30C3\30AF\30DC\30C3\30AF\30B9\304C\9078\629E\3055\308C\305F\5834\5408\30011\3064\76EE\306E\5024\304C\9001\4FE1\3055\308C\307E\3059\30022\3064\76EE\306E\5024\304C\5B9A\7FA9\3055\308C\3066\3044\308B\5834\5408\3001\30C1\30A7\30C3\30AF\30DC\30C3\30AF\30B9\304C\9078\629E\89E3\9664\3055\308C\308B\3068\30012\3064\3081\306E\5024\304C\9001\4FE1\3055\308C\307E\3059\3002'),
'        p_examples           => q''~<dl>',
unistr('<dt>\9078\629E\3055\308C\305F\5834\5408\300CYes\300D\3092\9001\4FE1\3057\3001\9078\629E\89E3\9664\3055\308C\305F\5834\5408\300CNo\300D\3092\9001\4FE1</dt>'),
'<dd><pre>',
'Yes,No',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104235097358308635)
,p_name=>'PE.PROPERTY.SIMPLE_CHECKBOX_VALUES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30A7\30C3\30AF\30DC\30C3\30AF\30B9\306E\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104201454081308610)
,p_name=>'PE.PROPERTY.SINGLE_ROW_VIEW_LABEL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5358\4E00\884C\30D3\30E5\30FC\3067\4F7F\7528\3059\308B\5217\30E9\30D9\30EB\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104201392189308610)
,p_name=>'PE.PROPERTY.SINGLE_ROW_VIEW_LABEL.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104243011175308641)
,p_name=>'PE.PROPERTY.SORT_NULLS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\30D8\30C3\30C0\30FC\306E\30BD\30FC\30C8\304C\6709\52B9\306A\30EC\30DD\30FC\30C8\5217\306E\5834\5408\3001null\5024\3092\542B\3080\30EC\30B3\30FC\30C9\306E\30BD\30FC\30C8\65B9\6CD5(null\4EE5\5916\306E\5024\306E\30EC\30B3\30FC\30C9\3068\306E\76F8\95A2)\3092\9078\629E\3057\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104422624020308774)
,p_name=>'PE.PROPERTY.SORT_NULLS.LOV.F.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\521D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104422766858308774)
,p_name=>'PE.PROPERTY.SORT_NULLS.LOV.F.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('null\5024\306E\30EC\30B3\30FC\30C9\306F\3001null\4EE5\5916\306E\5024\306E\5217\3088\308A\524D\306B\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104422801878308774)
,p_name=>'PE.PROPERTY.SORT_NULLS.LOV.L.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104422908786308774)
,p_name=>'PE.PROPERTY.SORT_NULLS.LOV.L.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('null\4EE5\5916\306E\5024\306E\30EC\30B3\30FC\30C9\306F\3001null\5024\306E\5217\3088\308A\524D\306B\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104242997201308641)
,p_name=>'PE.PROPERTY.SORT_NULLS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('NULL\306E\30BD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103516369130308027)
,p_name=>'PE.PROPERTY.SOURCE_BREADCRUMB.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DA\30FC\30B8\306B\95A2\9023\4ED8\3051\308B\30D6\30EC\30C3\30C9\30AF\30E9\30E0\30FB\30EA\30B9\30C8\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103516238046308027)
,p_name=>'PE.PROPERTY.SOURCE_BREADCRUMB.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104748852125309041)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.COMPONENT_PROPERTY.FACET.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\3053\306E\30D5\30A1\30BB\30C3\30C8\306E\30BD\30FC\30B9\3068\3057\3066\4F7F\7528\3055\308C\308B\30C7\30FC\30BF\30D9\30FC\30B9\5217\540D(\5927\6587\5B57\3068\5C0F\6587\5B57\3092\533A\5225)\3092\5165\529B\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104557235684308884)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.COMPONENT_PROPERTY.FACET_GROUP_ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\3053\306E\30D5\30A1\30BB\30C3\30C8\306E\30BD\30FC\30B9\3068\3057\3066\4F7F\7528\3055\308C\308B\30C7\30FC\30BF\30D9\30FC\30B9\5217\540D(\5927\6587\5B57\3068\5C0F\6587\5B57\3092\533A\5225)\3092\5165\529B\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103920588361308374)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\3053\306E\30D5\30A3\30EB\30BF\306E\30BD\30FC\30B9\3068\3057\3066\4F7F\7528\3055\308C\308B\30C7\30FC\30BF\30D9\30FC\30B9\5217\540D(\5927\6587\5B57\3068\5C0F\6587\5B57\3092\533A\5225)\3092\5165\529B\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103921606642308375)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.COMPONENT_PROPERTY.SFILTER_GROUP_ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\3053\306E\30D5\30A3\30EB\30BF\306E\30BD\30FC\30B9\3068\3057\3066\4F7F\7528\3055\308C\308B\30C7\30FC\30BF\30D9\30FC\30B9\5217\540D(\5927\6587\5B57\3068\5C0F\6587\5B57\3092\533A\5225)\3092\5165\529B\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103891427506308316)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30A2\30A4\30C6\30E0\5024\306E\30BD\30FC\30B9\3068\3057\3066\4F7F\7528\3055\308C\308B\3001\5927/\5C0F\6587\5B57\3092\533A\5225\3057\305F\30C7\30FC\30BF\30D9\30FC\30B9\5217\540D\3092\5165\529B\3057\307E\3059\3002</p>'),
unistr('<p>\3053\306E\5217\306F\3001\3053\306E\30DA\30FC\30B8\306B\5B9A\7FA9\3055\308C\305F\7D44\8FBC\307F\884C\30D5\30A7\30C3\30C1\30FB\30D7\30ED\30BB\30B9\5185\3067\6307\5B9A\3055\308C\305F\8868\5185\306B\5B58\5728\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002'),
unistr('\30C7\30FC\30BF\30D9\30FC\30B9\5217\540D\304C\53C2\7167\8868\306B\306A\3044\5834\5408\3001\30A8\30E9\30FC\304C\767A\751F\3057\3001\30DA\30FC\30B8\306F\30ED\30FC\30C9\3055\308C\307E\305B\3093\3002'),
unistr('\540C\69D8\306B\3001\7D44\8FBC\307F\884C\30D5\30A7\30C3\30C1\30FB\30D7\30ED\30BB\30B9\304C\5B9A\7FA9\3055\308C\3066\304A\3089\305A\3001<strong>\300C\30C7\30FC\30BF\30D9\30FC\30B9\5217\300D</strong>\30BD\30FC\30B9\30FB\30BF\30A4\30D7\306E\30A2\30A4\30C6\30E0\304C\3042\308B\5834\5408\3001\30A8\30E9\30FC\304C\767A\751F\3057\3001\30DA\30FC\30B8\306E\30EC\30F3\30C0\30EA\30F3\30B0\306E\8A66\884C\4E2D\30DA\30FC\30B8\306F\30ED\30FC\30C9\3055\308C\307E\305B\3093\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103891301012308316)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104629853323308942)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F\5F0F\306E\8A55\4FA1\306B\4F7F\7528\3055\308C\308B\8A00\8A9E\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104630201624308943)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'ja'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104630169857308943)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'ja'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104630093280308943)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'ja'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104630379649308943)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'ja'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104629957796308943)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'ja'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104629789456308942)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A00\8A9E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104327738428308703)
,p_name=>'PE.PROPERTY.SOURCE_FILTERED_REGION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30D5\30A1\30BB\30C3\30C8\691C\7D22\307E\305F\306F\30B9\30DE\30FC\30C8\30FB\30D5\30A3\30EB\30BF\30FB\30EA\30FC\30B8\30E7\30F3\306B\95A2\9023\4ED8\3051\3089\308C\305F\30EA\30FC\30B8\30E7\30F3\3092\9078\629E\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104327687517308703)
,p_name=>'PE.PROPERTY.SOURCE_FILTERED_REGION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30EB\30BF\6E08\30EA\30FC\30B8\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104631884151308944)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\306E\5B9F\884C\306B\4F7F\7528\3055\308C\308B\8A00\8A9E\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104632161783308944)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'ja'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104632068397308944)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'ja'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104631943907308944)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'ja'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104632289662308944)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'ja'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104631752440308944)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A00\8A9E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103891241998308316)
,p_name=>'PE.PROPERTY.SOURCE_ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\3053\306E\30A2\30A4\30C6\30E0\5024\306E\30BD\30FC\30B9\3068\3057\3066\4F7F\7528\3055\308C\308B\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002'),
unistr('\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103891107694308316)
,p_name=>'PE.PROPERTY.SOURCE_ITEM.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104660617532308967)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_CODE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9F\884C\3059\308BJava\30B3\30FC\30C9\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104660548401308967)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_CODE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('Java\30B3\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104631416973308944)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30A4\30C6\30E0\5024\306E\30BD\30FC\30B9\3068\3057\3066\4F7F\7528\3055\308C\308B\5024\3092\751F\6210\3059\308BJava\5F0F\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104631313565308944)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('Java\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104633049190308945)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30A4\30C6\30E0\5024\306E\30BD\30FC\30B9\3068\3057\3066\4F7F\7528\3055\308C\308B\5024\3092\8FD4\3059Java\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104632912392308945)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('Java\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104660480238308967)
,p_name=>'PE.PROPERTY.SOURCE_JS_CODE.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\6607\7D66\306E\8CC7\683C\304C\3042\308B\5F93\696D\54E1\306E\7D66\4E0E\30923%\5897\3084\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'var rows;',
'',
'function needsSalaryRaise( empno ) {',
'    // placeholder for some complicated logic to calculate if employee needs a raise',
'    return true;',
'}',
'',
'rows = apex.conn.execute( "select empno from emp where deptno = :deptno", { deptno: apex.env.P2_DEPTNO } ).rows;',
'for ( var row of rows ) {',
'    if ( needsSalaryRaise( row.EMPNO )) {',
'      apex.conn.execute( "update emp set sal = sal * 1.03 where empno = :empno", { empno: row.EMPNO } );',
'    }',
'}',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104660396404308967)
,p_name=>'PE.PROPERTY.SOURCE_JS_CODE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9F\884C\3059\308BJavaScript\30B3\30FC\30C9\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104660222065308967)
,p_name=>'PE.PROPERTY.SOURCE_JS_CODE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('JavaScript\30B3\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104631296866308944)
,p_name=>'PE.PROPERTY.SOURCE_JS_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3059\308B\304B\3001\30DE\30CD\30FC\30B8\30E3\3067\3042\308B\5834\5408\3001YES\3092\8FD4\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" ? "YES" : "NO" )',
'</pre></dd>',
'</dl>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104631102157308943)
,p_name=>'PE.PROPERTY.SOURCE_JS_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30A4\30C6\30E0\5024\306E\30BD\30FC\30B9\3068\3057\3066\4F7F\7528\3055\308C\308B\5024\3092\751F\6210\3059\308BJavaScript\5F0F\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104631016322308943)
,p_name=>'PE.PROPERTY.SOURCE_JS_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('JavaScript\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104632848765308945)
,p_name=>'PE.PROPERTY.SOURCE_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3059\308B\5834\5408\3001YES\3092\8FD4\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES", "NO" );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104632743251308945)
,p_name=>'PE.PROPERTY.SOURCE_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30A4\30C6\30E0\5024\306E\30BD\30FC\30B9\3068\3057\3066\4F7F\7528\3055\308C\308B\5024\3092\8FD4\3059JavaScript\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104632646652308945)
,p_name=>'PE.PROPERTY.SOURCE_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('JavaScript\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103516149504308027)
,p_name=>'PE.PROPERTY.SOURCE_LIST.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30EA\30B9\30C8\306E\30BD\30FC\30B9\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103516034243308027)
,p_name=>'PE.PROPERTY.SOURCE_LIST.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103973705017308416)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\306E\5834\6240\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103973884719308416)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.LOCAL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30FC\30AB\30EB\30FB\30C7\30FC\30BF\30D9\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103973929369308416)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.LOCAL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\306F\30ED\30FC\30AB\30EB\30FB\30C7\30FC\30BF\30D9\30FC\30B9\3092\30BD\30FC\30B9\3068\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103974013047308416)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.REMOTE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\5BFE\5FDCSQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103974104422308416)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.REMOTE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\306F\3001REST\5BFE\5FDCSQL\3092\4F7F\7528\3057\3066\63A5\7D9A\304C\5B9A\7FA9\3055\308C\308B\30EA\30E2\30FC\30C8\30FB\30C7\30FC\30BF\30D9\30FC\30B9\3092\30BD\30FC\30B9\3068\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104084292814308503)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.WEB_SOURCE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\30BD\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104690844666308992)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.WEB_SOURCE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\306F\3001REST\30C7\30FC\30BF\30FB\30BD\30FC\30B9\3092\4F7F\7528\3057\3066\5B9A\7FA9\3055\308C\308BRESTful Web\30B5\30FC\30D3\30B9\3092\30BD\30FC\30B9\3068\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103973686893308416)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104169466399308583)
,p_name=>'PE.PROPERTY.SOURCE_PAGE_ITEMS_TO_SUBMIT.COMPONENT_PROPERTY.JET_CHART_SERIES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\30FB\30C7\30FC\30BF\304C\5404\30EA\30AF\30A8\30B9\30C8\3067\8AAD\307F\53D6\3089\308C\308B\969B\306B\3001\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\306B\8A2D\5B9A\3055\308C\308B\73FE\5728\306E\30DA\30FC\30B8\306E\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306E\30AB\30F3\30DE\533A\5207\308A\30EA\30B9\30C8\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104536979142308865)
,p_name=>'PE.PROPERTY.SOURCE_PAGE_ITEMS_TO_SUBMIT.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30C3\30D7\30FB\30C7\30FC\30BF\304C\5404\30EA\30AF\30A8\30B9\30C8\3067\30D5\30A7\30C3\30C1\3055\308C\308B\969B\306B\3001\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\306B\8A2D\5B9A\3055\308C\308B\73FE\5728\306E\30DA\30FC\30B8\306E\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306E\30AB\30F3\30DE\533A\5207\308A\30EA\30B9\30C8\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103966620503308410)
,p_name=>'PE.PROPERTY.SOURCE_PAGE_ITEMS_TO_SUBMIT.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30EA\30FC\30B8\30E7\30F3\304C\90E8\5206\30DA\30FC\30B8\30FB\30EA\30D5\30EC\30C3\30B7\30E5\3067\30EA\30D5\30EC\30C3\30B7\30E5\3055\308C\305F\3068\304D\306B\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\306B\8A2D\5B9A\3059\308B\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002'),
unistr('\8907\6570\306E\30A2\30A4\30C6\30E0\306E\5834\5408\3001\5404\30A2\30A4\30C6\30E0\540D\3092\30AB\30F3\30DE\3067\533A\5207\308A\307E\3059\3002'),
unistr('\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002'),
unistr('\30EA\30B9\30C8\304B\3089\9078\629E\3057\3001\3059\3067\306B\5165\529B\3055\308C\3066\3044\308B\30C6\30AD\30B9\30C8\304C\3042\308B\5834\5408\3001\65E2\5B58\306E\30C6\30AD\30B9\30C8\306E\6700\5F8C\306B\30AB\30F3\30DE\304C\4ED8\3051\3089\308C\3001\30EA\30B9\30C8\304B\3089\8FD4\3055\308C\305F\30A2\30A4\30C6\30E0\540D\304C\305D\308C\306B\7D9A\304D\307E\3059\3002</p>'),
unistr('<p>\30EA\30FC\30B8\30E7\30F3\306F\3001\30DA\30FC\30B8\533A\5207\308A\3001<em>\300C\90E8\5206\30DA\30FC\30B8\30FB\30EA\30D5\30EC\30C3\30B7\30E5\306E\6709\52B9\5316\300D</em>\304C<strong>\300C\30AA\30F3\300D</strong>\306B\8A2D\5B9A\3055\308C\3066\3044\308B\5834\5408\3001\307E\305F\306F\52D5\7684\30A2\30AF\30B7\30E7\30F3\5185\306E\30EA\30D5\30EC\30C3\30B7\30E5\30FB\30A2\30AF\30B7\30E7\30F3\306E\3044\305A\308C\304B\306E\90E8\5206\30DA\30FC\30B8\30FB\30EA\30D5\30EC\30C3\30B7\30E5\3067\30EA\30D5\30EC\30C3\30B7\30E5\3055\308C\307E\3059\3002</p>'),
unistr('\3053\308C\3089\306E\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3092\30EA\30FC\30B8\30E7\30F3\30FB\30BD\30FC\30B9SQL\554F\5408\305B\306E<em>where\53E5</em>\3067\4F7F\7528\3057\3001\554F\5408\305B\306E\7D50\679C\3092\5236\9650\3067\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103966543200308410)
,p_name=>'PE.PROPERTY.SOURCE_PAGE_ITEMS_TO_SUBMIT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\9001\4FE1\3059\308B\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104660151544308967)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_CODE.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\6607\7D66\306E\8CC7\683C\304C\3042\308B\5F93\696D\54E1\306E\7D66\4E0E\30923%\5897\3084\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'begin',
'    for l_emp ( select empno',
'                  from emp',
'                 where deptno = :P2_DEPTNO )',
'    loop',
'        if needs_salary_raise( l_empno.empno ) then',
'            update emp',
'               set sal = sal * 1.03',
'             where empno = l_emp.empno;',
'        end if;',
'    end loop;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104660010627308967)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_CODE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9F\884C\3059\308BPL/SQL\30B3\30FC\30C9\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104659933208308967)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_CODE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\30B3\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104630929769308943)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3059\308B\304B\3001\30DE\30CD\30FC\30B8\30E3\3067\3042\308B\5834\5408\3001YES\3092\8FD4\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'case when ( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' ) then ''YES'' else ''NO'' end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104630865091308943)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30A4\30C6\30E0\5024\306E\30BD\30FC\30B9\3068\3057\3066\4F7F\7528\3055\308C\308B\5024\3092\751F\6210\3059\308BPL/SQL\5F0F\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104630785017308943)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104632500278308945)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3059\308B\5834\5408\3001YES\3092\8FD4\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104632451910308945)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30A4\30C6\30E0\5024\306E\30BD\30FC\30B9\3068\3057\3066\4F7F\7528\3055\308C\308B\5024\3092\8FD4\3059PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104632359697308944)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104696120789308997)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30FC\30AB\30EB\30FB\30C7\30FC\30BF\30D9\30FC\30B9\3067\53D6\5F97\3055\308C\305FREST\30BD\30FC\30B9\30FB\30C7\30FC\30BF\306E\5F8C\51E6\7406\65B9\6CD5\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104696643439308997)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.FUNC_BODY_RETURNING_SQL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B\3092\623B\3059PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104696750205308997)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.FUNC_BODY_RETURNING_SQL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\623B\3055\308C\305FSQL\554F\5408\305B\304C\53D6\5F97\3055\308C\305F\30C7\30FC\30BF\3092\5909\63DB\3059\308BPL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104696453875308997)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.SQL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104696509270308997)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.SQL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\53D6\5F97\3055\308C\305F\30C7\30FC\30BF\3092\5909\63DB\3059\308BSQL\554F\5408\305B\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104696280685308997)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.WHERE_ORDER_BY_CLAUSE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('WHERE/ORDER BY\53E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104696311614308997)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.WHERE_ORDER_BY_CLAUSE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\53D6\5F97\3055\308C\305F\30C7\30FC\30BF\3092\5236\9650\304A\3088\3073\9806\5E8F\4ED8\3051\3059\308BWHERE\304A\3088\3073/\307E\305F\306FORDER BY\53E5\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104696082123308997)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103891675046308316)
,p_name=>'PE.PROPERTY.SOURCE_PREFERENCE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30A4\30C6\30E0\5024\306E\30BD\30FC\30B9\3068\3057\3066\4F7F\7528\3055\308C\308B\30E6\30FC\30B6\30FC\30FB\30D7\30EA\30D5\30A1\30EC\30F3\30B9\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103891565345308316)
,p_name=>'PE.PROPERTY.SOURCE_PREFERENCE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30EA\30D5\30A1\30EC\30F3\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104660890221308968)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_CODE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9F\884C\3059\308BPython\30B3\30FC\30C9\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104660736236308968)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_CODE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('Python\30B3\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104631612519308944)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30A4\30C6\30E0\5024\306E\30BD\30FC\30B9\3068\3057\3066\4F7F\7528\3055\308C\308B\5024\3092\751F\6210\3059\308BPython\5F0F\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104631523104308944)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('Python\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104633215493308945)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30A4\30C6\30E0\5024\306E\30BD\30FC\30B9\3068\3057\3066\4F7F\7528\3055\308C\308B\5024\3092\8FD4\3059Python\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104633110065308945)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('Python\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103890864400308316)
,p_name=>'PE.PROPERTY.SOURCE_QUERY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30A4\30C6\30E0\5024\306E\30BD\30FC\30B9\3068\3057\3066\4F7F\7528\3055\308C\308BSQL\554F\5408\305B\3092\5165\529B\3057\307E\3059\3002\8907\6570\306E\884C\304C\8FD4\3055\308C\308B\5834\5408\3001\6700\521D\306E\884C\306E\5024\304C\4F7F\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103890731578308316)
,p_name=>'PE.PROPERTY.SOURCE_QUERY.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103891049893308316)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_COLON.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30A4\30C6\30E0\5024\306E\30BD\30FC\30B9\3068\3057\3066\4F7F\7528\3055\308C\308B1\884C\4EE5\4E0A\306E\884C\3092\8FD4\3059SQL\554F\5408\305B\3092\5165\529B\3057\307E\3059\3002\7D50\679C\306B\8907\6570\306E\884C\304C\542B\307E\308C\308B\5834\5408\3001\5404\884C\306E\5024\304C\3001\30B3\30ED\30F3\3067\533A\5207\3089\308C\305F1\3064\306E\5024\306B\5F62\6210\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103890929558308316)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_COLON.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104640233478308951)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\306E\5B9F\884C\306B\4F7F\7528\3055\308C\308B\8A00\8A9E\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104640592873308951)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'ja'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104640452298308951)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'ja'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104640344514308951)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'ja'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104640683444308951)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'ja'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104640105152308951)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A00\8A9E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104641479419308952)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_JAVA_FUNC_BODY_SQL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\30FB\30B7\30EA\30FC\30BA\306B\5BFE\3059\308BSQL\554F\5408\305B\3092\8FD4\3059Java\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104641352509308952)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_JAVA_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B\3092\8FD4\3059Java\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104641280283308952)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_JS_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>EMPNO\3001ENAME\304A\3088\3073SAL\5217\3092\9078\629E\3057\3001SAL\304C3000\672A\6E80\306E\3059\3079\3066\306E\884C\3092\30D5\30A3\30EB\30BF\51E6\7406\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'return "select EMPNO, ENAME, SAL from EMP where SAL < 3000";',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104641115700308952)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_JS_FUNC_BODY_SQL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\30FB\30B7\30EA\30FC\30BA\306B\5BFE\3059\308BSQL\554F\5408\305B\3092\8FD4\3059JavaScript\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104641093683308952)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_JS_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B\3092\8FD4\3059JavaScript\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103972218553308414)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_ORDER_BY.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\6700\65B0\306E\63A1\7528\8005\3092\6700\521D\306B\3001\307E\3060\63A1\7528\3055\308C\3066\3044\306A\3044\4EBA\3092\6700\5F8C\306B\8868\793A\3057\307E\3059\3002\65E5\4ED8\304C\540C\3058\5834\5408\306F\3001\90E8\9580\756A\53F7\3067\30BD\30FC\30C8\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'HIREDATE DESC NULLS LAST, DEPTNO',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103972187356308414)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_ORDER_BY.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30C7\30A3\30EC\30AF\30C6\30A3\30D6\3092\542B\30801\3064\4EE5\4E0A\306E\30AB\30F3\30DE\533A\5207\308A\306E\5217\540D\3092\5165\529B\3057\3066\3001\30EC\30B3\30FC\30C9\306E\53D6\5F97\9806\5E8F\3092\5B9A\7FA9\3057\307E\3059\3002</p>'),
unistr('        <p>\30C7\30A3\30EC\30AF\30C6\30A3\30D6\306F\6B21\306E\3068\304A\308A\3067\3059\3002'),
'          <ul>',
unistr('            <li>ASC - \5217\3092\6607\9806\3067\623B\3057\307E\3059</li>'),
unistr('            <li>DESC - \5217\3092\964D\9806\3067\623B\3057\307E\3059</li>'),
unistr('            <li>NULLS FIRST - \5024\306E\3042\308B\5217\3088\308A\524D\306B\5024\306E\306A\3044\5217\3092\623B\3057\307E\3059</li>'),
unistr('            <li>NULLS LAST - \5024\306E\306A\3044\5217\3088\308A\524D\306B\5024\306E\3042\308B\5217\3092\623B\3057\307E\3059</li>'),
'          </ul>',
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103972060447308414)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_ORDER_BY.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E26\66FF\3048\57FA\6E96')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103971407554308414)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_OWNER.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\3092\6240\6709\3059\308B\30B9\30AD\30FC\30DE\3092\9078\629E\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103971387038308414)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_OWNER.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\306E\6240\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104084844558308504)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PLSQL_FUNCTION_BODY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30EA\30FC\30B8\30E7\30F3\306E\30D9\30FC\30B9\3068\3057\3066\4F7F\7528\3055\308C\308BSQL\554F\5408\305B\3092\623B\3059PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104084753530308504)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PLSQL_FUNCTION_BODY.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B\3092\623B\3059PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104640939909308951)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PLSQL_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>EMPNO\3001ENAME\304A\3088\3073SAL\5217\3092\9078\629E\3057\3001SAL\304C3000\672A\6E80\306E\3059\3079\3066\306E\884C\3092\30D5\30A3\30EB\30BF\51E6\7406\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'begin',
'    return ''select EMPNO, ENAME, SAL from EMP where SAL < 3000'';',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104640818905308951)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PLSQL_FUNC_BODY_SQL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\30FB\30B7\30EA\30FC\30BA\306B\5BFE\3059\308BSQL\554F\5408\305B\3092\623B\3059PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104640715150308951)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PLSQL_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B\3092\623B\3059PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104641640105308952)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PYTHON_FUNC_BODY_SQL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\30FB\30B7\30EA\30FC\30BA\306B\5BFE\3059\308BSQL\554F\5408\305B\3092\8FD4\3059Python\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104641545169308952)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PYTHON_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B\3092\8FD4\3059Python\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103971617595308414)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TABLE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5927/\5C0F\6587\5B57\3092\533A\5225\3057\305F\8868\307E\305F\306F\30D3\30E5\30FC\306E\540D\524D\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103971553166308414)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TABLE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103971080244308414)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\306E\554F\5408\305B\65B9\6CD5\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104084377875308503)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.FUNC_BODY_RETURNING_SQL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B\3092\8FD4\3059\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104084454196308504)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.FUNC_BODY_RETURNING_SQL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\306F\3001\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\306E\5B9F\884C\306B\3088\3063\3066\8FD4\3055\308C\308BSQL\554F\5408\305B\306B\57FA\3065\3044\3066\53D6\5F97\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103974231960308416)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.SQL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103974375639308416)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.SQL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\306FSQL\554F\5408\305B\306B\57FA\3065\3044\3066\53D6\5F97\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103971177851308414)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.TABLE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868/\30D3\30E5\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103971279473308414)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.TABLE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\306F\8868\307E\305F\306F\30D3\30E5\30FC\306B\57FA\3065\3044\3066\53D6\5F97\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103970986913308414)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103971940329308414)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_WHERE.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\30DE\30CD\30FC\30B8\30E3\306E\3044\308B\5F93\696D\54E1\307E\305F\306F\30B8\30E7\30D6\304C\8CA9\58F2\62C5\5F53\306E\5F93\696D\54E1\306E\307F\3092\542B\3081\307E\3059\3002</dt>'),
'<dd><pre>',
unistr('( MGR\306Fnull\3067\306A\3044\3001\307E\305F\306FJOB = ''SALESMAN'' )'),
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103971860231308414)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_WHERE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\53D6\5F97\3055\308C\308B\30EC\30B3\30FC\30C9\3092\5236\9650\3059\308B\305F\3081\306B\4F7F\7528\3059\308B\3001\6709\52B9\306ASQL WHERE\6761\4EF6\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103971749509308414)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_WHERE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('WHERE\53E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103970803117308413)
,p_name=>'PE.PROPERTY.SOURCE_REMOTE_DATABASE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30E2\30FC\30C8\30FB\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30B5\30FC\30D0\30FC\3092\9078\629E\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103970750413308413)
,p_name=>'PE.PROPERTY.SOURCE_REMOTE_DATABASE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30E2\30FC\30C8\30FB\30B5\30FC\30D0\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104659409322308967)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F\30B3\30FC\30C9\306E\5B9F\884C\306B\4F7F\7528\3055\308C\308B\8A00\8A9E\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104659798204308967)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.LOV.JAVA.D'
,p_message_language=>'ja'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104659677503308967)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'ja'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104659586236308967)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.LOV.PLSQL.D'
,p_message_language=>'ja'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104659837461308967)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.LOV.PYTHON.D'
,p_message_language=>'ja'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104659393763308966)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A00\8A9E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104285027374308671)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>2\3064\306E\5217\3092\9023\7D50\3059\308B\306B\306F:</dt>'),
'<dd><pre>',
'FIRSTNAME || '' '' || LASTNAME',
'</pre></dd>',
unistr('<dt>inner select\3092\542B\3081\307E\3059\3002</dt>'),
'<dd><pre>',
'(select count(*) from emp e where e.deptno = DEPTNO)',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104109307529308524)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\5F0F\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104109219358308524)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104630612452308943)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\30DE\30CD\30FC\30B8\30E3\3067\3001\90E8\9580\304C\30B7\30AB\30B4\306B\5B58\5728\3059\308B\5834\5408\3001YES\3092\8FD4\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'case',
'when :P2_JOB = ''MANAGER'' and',
'     exists ( select 1',
'                from dept',
'               where deptno = :P2_DEPTNO',
'                 and loc    = ''CHICAGO'' ) then ''YES''',
'else ''NO''',
'end',
'</pre></dd>',
'</dl>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104630578717308943)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30A4\30C6\30E0\5024\306E\30BD\30FC\30B9\3068\3057\3066\4F7F\7528\3055\308C\308B\5024\3092\751F\6210\3059\308BSQL\5F0F\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104630486139308943)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104539189801308867)
,p_name=>'PE.PROPERTY.SOURCE_SQL_QUERY.COMPONENT_PROPERTY.MAP_LAYER.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\7D4C\5EA6\304A\3088\3073\7DEF\5EA6\306E\5024\3092NUMBER\5217\3068\3057\3066\8FD4\3059\554F\5408\305B:</p>'),
'<pre>',
'select lon,',
'       lat,',
'       cust_name',
'  from customers',
' where company_id = :PX_COMPANY_ID',
'</pre>',
unistr('<p>\9867\5BA2\306E\5834\6240\3092SDO_GEOMETRY\5217\3068\3057\3066\8FD4\3059\554F\5408\305B:</p>'),
'<pre>',
'select cust_location,',
'       cust_name',
'  from customers',
' where company_id = :PX_COMPANY_ID',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103972412113308415)
,p_name=>'PE.PROPERTY.SOURCE_SQL_QUERY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\5BFE\3059\308BSQL\30BD\30FC\30B9\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103972385070308415)
,p_name=>'PE.PROPERTY.SOURCE_SQL_QUERY.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103890658947308316)
,p_name=>'PE.PROPERTY.SOURCE_STATIC_VALUE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30A4\30C6\30E0\5024\306E\30BD\30FC\30B9\3068\3057\3066\4F7F\7528\3055\308C\308B\9759\7684\5024\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103890545046308316)
,p_name=>'PE.PROPERTY.SOURCE_STATIC_VALUE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\9759\7684\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103890424452308316)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30A2\30A4\30C6\30E0\306E\5024\304C\30D9\30FC\30B9\3068\3059\308B\30BD\30FC\30B9\30FB\30BF\30A4\30D7\3092\9078\629E\3057\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8: <strong>\300C\4F7F\7528\3055\308C\308B\30BD\30FC\30B9\300D</strong>\304C<em>\300C\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\306E\5024\304CNULL\306E\5834\5408\306E\307F\300D</em>\306B\8A2D\5B9A\3055\308C\3066\3044\308B\5834\5408\3001\5024\304C\3053\306E\30A2\30A4\30C6\30E0\306E\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\306B\8A2D\5B9A\3055\308C\3066\3044\308B\3068\3001\30BD\30FC\30B9\306F\4F7F\7528\3055\308C\307E\305B\3093\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104393547734308752)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.ALWAYS_NULL.D'
,p_message_language=>'ja'
,p_message_text=>'NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104588831306308910)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.ALWAYS_NULL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024\306E\6307\5B9A\304C\306A\3044\305F\3081null\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104393740808308753)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.DB_COLUMN.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104588210051308909)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.DB_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D44\8FBC\307F\306E\884C\306E\30D5\30A7\30C3\30C1\30FB\30D7\30ED\30BB\30B9\304B\3089\53D6\5F97\3055\308C\308B<em>\300C\30C7\30FC\30BF\30D9\30FC\30B9\5217\300D</em>\306B\5165\529B\3055\308C\305F\5217\5024\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104609570570308926)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104609691712308926)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F<em>\5F0F</em>\306E\5B9F\884C\7D50\679C\306E\5024\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104394065376308753)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104588676886308909)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F<em>\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53</em>\304B\3089\8FD4\3055\308C\305F\5024\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104394189444308753)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.ITEM.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104588360713308909)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\306B\4FDD\6301\3055\308C\3066\3044\308B\5024\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104394275873308753)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.PREFERENCE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30EA\30D5\30A1\30EC\30F3\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104588733861308910)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.PREFERENCE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F<em>\30D7\30EA\30D5\30A1\30EC\30F3\30B9</em>\306E\5024\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104393826622308753)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.QUERY.D'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B(\5358\4E00\306E\5024\3092\8FD4\3059)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104588461395308909)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.QUERY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F<em>SQL\554F\5408\305B</em>\304B\3089\6700\521D\306B\8FD4\3055\308C\305F\5024\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104393944284308753)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.QUERY_COLON.D'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B(\30B3\30ED\30F3\533A\5207\308A\306E\5024\3092\8FD4\3059)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104588532694308909)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.QUERY_COLON.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F<em>SQL\554F\5408\305B</em>\304B\3089\8FD4\3055\308C\305F\5404\884C\306E\5024\3092\9023\7D50\3057\305F\3001\30B3\30ED\30F3\3067\533A\5207\3089\308C\305F1\3064\306E\5024\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104393671494308752)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.STATIC.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\9759\7684\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104588136738308909)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.STATIC.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<em>\300C\9759\7684\5024\300D</em>\306B\5165\529B\3055\308C\305F\30C6\30AD\30B9\30C8\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103890330454308316)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103890257160308315)
,p_name=>'PE.PROPERTY.SOURCE_USED.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\304B\3089\306E\5024\307E\305F\306F\30A2\30A4\30C6\30E0\30FB\30BD\30FC\30B9\5024\306E\3069\3061\3089\3092\512A\5148\3059\308B\304B\3092\9078\629E\3057\307E\3059\3002</p>'),
unistr('<p>\30BD\30FC\30B9\30FB\30BF\30A4\30D7\304C<strong>\300C\30C7\30FC\30BF\30D9\30FC\30B9\5217\300D</strong>\306E\30A2\30A4\30C6\30E0\306B\306F\3001<strong>\300C\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\306E\65E2\5B58\306E\5024\3092\5E38\306B\7F6E\63DB\300D</strong>\3092\9078\629E\3057\3066\304F\3060\3055\3044\3002\305F\3060\3057\3001\30DA\30FC\30B8\304C\540C\3058\30DA\30FC\30B8\306B\30D6\30E9\30F3\30C1\3059\308B\5834\5408\306B\3001\95A2\9023\3059\308B\884C\306E\30D5\30A7\30C3\30C1\64CD\4F5C\3067\30A2\30A4\30C6\30E0\3092\79FB\5165\3057\306A\3044\5834\5408\306F\9664\304D\307E\3059\3002'),
unistr('\4ED6\306E\30BD\30FC\30B9\30FB\30BF\30A4\30D7\306E\5834\5408\3001\30DA\30FC\30B8\306E\4F7F\7528\65B9\6CD5\306B\57FA\3065\3044\3066\3001\4EE5\524D\306B\30BD\30FC\30B9\3060\3063\305F\5024\3092\8868\793A\3059\308B\304B\3001\307E\305F\306F\30BD\30FC\30B9\30FB\30BF\30A4\30D7\3092\5404\30DA\30FC\30B8\30FB\30D3\30E5\30FC\306B\65B0\3057\304F\9069\7528\3059\308B\304B\3092\6C7A\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104393310766308752)
,p_name=>'PE.PROPERTY.SOURCE_USED.LOV.NO.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\306E\65E2\5B58\306E\5024\3092\5E38\306B\7F6E\63DB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104393419234308752)
,p_name=>'PE.PROPERTY.SOURCE_USED.LOV.YES.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\306E\5024\304CNULL\306E\5834\5408\306E\307F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103890180123308315)
,p_name=>'PE.PROPERTY.SOURCE_USED.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104084600744308504)
,p_name=>'PE.PROPERTY.SOURCE_WEB_SRC_QUERY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30EC\30AF\30B7\30E7\30F3\306E\30D5\30A7\30C3\30C1\3092\30B5\30DD\30FC\30C8\3059\308BREST\30C7\30FC\30BF\30FB\30BD\30FC\30B9\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104084506034308504)
,p_name=>'PE.PROPERTY.SOURCE_WEB_SRC_QUERY.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\30BD\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104169253088308583)
,p_name=>'PE.PROPERTY.SPLITTER_POSITION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5206\5272\4E8C\91CD-Y\30C1\30E3\30FC\30C8\3067\3001Y\8EF8\30B5\30D6\30C1\30E3\30FC\30C8\306B\6307\5B9A\3055\308C\308B\9818\57DF\306E\90E8\5206\3092\6307\5B9A\3057\307E\3059\3002\6709\52B9\306A\5024\306F0\304B\30891\306E\6570\5024\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104169123060308583)
,p_name=>'PE.PROPERTY.SPLITTER_POSITION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30D7\30EA\30C3\30BF\306E\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104168766944308582)
,p_name=>'PE.PROPERTY.SPLIT_DUAL_Y.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\7570\306A\308BY\8EF8\306B\5272\308A\5F53\3066\3089\308C\305F\30C7\30FC\30BF\306E\30BB\30C3\30C8\304C\63CF\753B\30A8\30EA\30A2\306E\7570\306A\308B\90E8\5206\306B\8868\793A\3055\308C\308B\3088\3046\3001\63CF\753B\30A8\30EA\30A2\30922\3064\306E\30BB\30AF\30B7\30E7\30F3\306B\5206\5272\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002\682A\4FA1\30C1\30E3\30FC\30C8\306F<strong>\300C\3044\3044\3048\300D</strong>\3092\30B5\30DD\30FC\30C8\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104168807947308583)
,p_name=>'PE.PROPERTY.SPLIT_DUAL_Y.LOV.AUTO.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104169067757308583)
,p_name=>'PE.PROPERTY.SPLIT_DUAL_Y.LOV.OFF.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\3044\3044\3048')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104168905859308583)
,p_name=>'PE.PROPERTY.SPLIT_DUAL_Y.LOV.ON.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\306F\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104168601373308582)
,p_name=>'PE.PROPERTY.SPLIT_DUAL_Y.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104145975776308555)
,p_name=>'PE.PROPERTY.STACK.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\30C7\30FC\30BF\30FB\30A2\30A4\30C6\30E0\3092\7A4D\4E0A\3052\306B\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104145853945308555)
,p_name=>'PE.PROPERTY.STACK.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7A4D\4E0A\3052')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103770010009308223)
,p_name=>'PE.PROPERTY.STACK_CATEGORY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\7CFB\5217\3092\5272\308A\5F53\3066\308B\7A4D\4E0A\3052\30AB\30C6\30B4\30EA\540D\3092\6307\5B9A\3057\307E\3059\3002\30C7\30D5\30A9\30EB\30C8\3067\306F\3001\7A4D\4E0A\3052\30C1\30E3\30FC\30C8\306E\3059\3079\3066\306E\7CFB\5217\304C\540C\3058\7A4D\4E0A\3052\306B\30B0\30EB\30FC\30D7\5316\3055\308C\307E\3059\3002\3053\306E\7CFB\5217\3092\5225\3005\306E\7A4D\4E0A\3052\306B\30B0\30EB\30FC\30D7\5316\3059\308B\306B\306F\3001\7A4D\4E0A\3052\30AB\30C6\30B4\30EA\3092\8A2D\5B9A\3057\307E\3059\3002<code>&COLUMN_VALUE.</code>\7F6E\63DB\3092\5229\7528\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103769985494308223)
,p_name=>'PE.PROPERTY.STACK_CATEGORY.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7A4D\4E0A\3052\30AB\30C6\30B4\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103769875359308223)
,p_name=>'PE.PROPERTY.STACK_LABEL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\7A4D\4E0A\3052\30C7\30FC\30BF\30FB\30A2\30A4\30C6\30E0\306E\5408\8A08\5024\3092\8868\793A\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002\68D2\30B0\30E9\30D5\306B\306E\307F\9069\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103769775178308223)
,p_name=>'PE.PROPERTY.STACK_LABEL.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7A4D\4E0A\3052\30E9\30D9\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103870684451308301)
,p_name=>'PE.PROPERTY.STANDARD_TAB_SET.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DA\30FC\30B8\306B\4F7F\7528\3059\308B\6A19\6E96\30BF\30D6\30FB\30BB\30C3\30C8\3092\9078\629E\3057\307E\3059\3002\6A19\6E96\30BF\30D6\30FB\30BB\30C3\30C8\306F\3001\7279\5B9A\306E\30DA\30FC\30B8\756A\53F7\306B\95A2\9023\4ED8\3051\3089\308C\3066\3044\307E\3059\3002\6A19\6E96\30BF\30D6\3092\4F7F\7528\3059\308B\3068\3001\7279\5B9A\306E\30DA\30FC\30B8\306B\30E6\30FC\30B6\30FC\3092\30EA\30F3\30AF\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103870515498308301)
,p_name=>'PE.PROPERTY.STANDARD_TAB_SET.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A19\6E96\30BF\30D6\30FB\30BB\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104268797925308659)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9031\6B21\30AB\30EC\30F3\30C0\306B\8868\793A\3055\308C\308B\9031\306E\6700\521D\306E\65E5\3092\9078\629E\3057\307E\3059\3002'),
unistr('\3053\306E\5C5E\6027\3092<strong>\7D42\4E86\65E5</strong>\3068\3042\308F\305B\3066\4F7F\7528\3057\3066\8868\793A\3055\308C\308B\65E5\3092\5236\9650\3057\305F\308A\3001\8868\793A\3059\308B\9031\306E\6700\521D\306E\65E5\3092\5358\306B\6307\5B9A\3057\305F\308A\3067\304D\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104427598655308778)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721105.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5\66DC\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104427630504308778)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721106.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6708\66DC\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104427743007308778)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721107.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\706B\66DC\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104427833179308778)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721108.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6C34\66DC\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104427914841308778)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721109.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6728\66DC\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104428051915308778)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721110.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\91D1\66DC\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104428181110308778)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721111.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\571F\66DC\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104268637897308659)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\59CB\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104268551394308659)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\6708\6B21\30AB\30EC\30F3\30C0\3092\958B\59CB\3059\308B\66DC\65E5\3092\6C7A\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104426874650308777)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721105.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5\66DC\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104426984398308777)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721106.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6708\66DC\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104427052902308777)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721107.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\706B\66DC\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104427157601308777)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721108.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6C34\66DC\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104427225328308778)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721109.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6728\66DC\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104427389194308778)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721110.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\91D1\66DC\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104427465240308778)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721111.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\571F\66DC\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104268479951308659)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\59CB\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104269324315308660)
,p_name=>'PE.PROPERTY.START_TIME.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9031\6B21\304A\3088\3073\65E5\6B21\30AB\30EC\30F3\30C0\306E\8868\793A\306E\30D5\30A9\30FC\30AB\30B9\306E\958B\59CB\6642\9593\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104269299381308660)
,p_name=>'PE.PROPERTY.START_TIME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\59CB\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103899094328308326)
,p_name=>'PE.PROPERTY.STATIC_CONTAINER_JQUERY.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\3053\306E\52D5\7684\30A2\30AF\30B7\30E7\30F3\306B\3088\3063\3066\4F7F\7528\3055\308C\308BjQuery\30BB\30EC\30AF\30BF\306E\9759\7684\30B3\30F3\30C6\30CA\3092\5165\529B\3057\307E\3059\3002'),
unistr('<strong>\52D5\7684</strong>\30A4\30D9\30F3\30C8\30FB\30B9\30B3\30FC\30D7\306E\52D5\7684\30A2\30AF\30B7\30E7\30F3\306E\30D1\30D5\30A9\30FC\30DE\30F3\30B9\3092\6539\5584\3067\304D\307E\3059\3002'),
unistr('\3053\308C\306F\3001\305D\308C\81EA\4F53\306F\518D\4F5C\6210\3055\308C\306A\3044\304C\3001\90E8\5206\30DA\30FC\30B8\30FB\30EA\30D5\30EC\30C3\30B7\30E5(PPR)\3092\4F7F\7528\3057\3066\518D\4F5C\6210\3055\308C\308B\30C8\30EA\30AC\30FC\8981\7D20\3092\542B\3080\30DA\30FC\30B8\306E\8981\7D20\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002'),
unistr('\3053\306E\8981\7D20\53C2\7167\306F\3001jQuery\30BB\30EC\30AF\30BF\3068\3057\3066\5B9A\7FA9\3055\308C\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103898953394308326)
,p_name=>'PE.PROPERTY.STATIC_CONTAINER_JQUERY.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\9759\7684\30B3\30F3\30C6\30CA(jQuery\30BB\30EC\30AF\30BF)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103909214009308334)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.BUTTON.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30DC\30BF\30F3\306E\9759\7684ID\3092\5165\529B\3057\307E\3059\3002\5B9A\7FA9\3055\308C\3066\3044\308B\5834\5408\3001\9759\7684ID\306F\30DC\30BF\30F3\306EID\3068\3057\3066\4F7F\7528\3055\308C\307E\3059\3002\9759\7684ID\306F\3001\30DC\30BF\30F3\306E\30AB\30B9\30BF\30E0JavaScript\52D5\4F5C\3092\958B\767A\3059\308B\969B\306B\5F79\7ACB\3061\307E\3059\3002\9759\7684ID\304C\5B9A\7FA9\3055\308C\3066\3044\306A\3044\5834\5408\3001\5185\90E8ID\304C\751F\6210\3055\308C\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8: \30DC\30BF\30F3\304C\5165\529B\3055\308C\305F\9759\7684ID\3092\4F7F\7528\3059\308B\305F\3081\306B\306F\3001\30C6\30F3\30D7\30EC\30FC\30C8\306B<code>#BUTTON_ID#</code>\7F6E\63DB\6587\5B57\5217\3092\542B\3081\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104113488365308527)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\306E\9759\7684ID\3092\5165\529B\3057\307E\3059\3002\9759\7684ID\306F\3001\30AB\30B9\30BF\30E0JavaScript\52D5\4F5C\307E\305F\306F\5217\30A2\30A4\30C6\30E0\306E\30AB\30B9\30BF\30E0\30FB\30B9\30BF\30A4\30EB\3092\958B\767A\3059\308B\5834\5408\306B\4FBF\5229\3067\3059\3002\9759\7684ID\304C\5B9A\7FA9\3055\308C\3066\3044\306A\3044\5834\5408\3001\5185\90E8ID\304C\5217\30A2\30A4\30C6\30E0ID\306B\4F7F\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104790610657309081)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.IR_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\306E\9759\7684ID\3092\5165\529B\3057\307E\3059\3002\5B9A\7FA9\3055\308C\3066\3044\308B\5834\5408\3001\9759\7684ID\306F\5BFE\5FDC\3059\308B\8868\30D8\30C3\30C0\30FC(TH)\30BB\30EB\306EID\3001\304A\3088\3073\5BFE\5FDC\3059\308B\8868\30C7\30FC\30BF(TD)\30BB\30EB\306EHEADERS\5024\3068\3057\3066\4F7F\7528\3055\308C\307E\3059\3002\9759\7684ID\306F\3001\30AB\30B9\30BF\30E0JavaScript\52D5\4F5C\307E\305F\306F\5217\306E\30AB\30B9\30BF\30E0\30FB\30B9\30BF\30A4\30EB\3092\958B\767A\3059\308B\5834\5408\306B\4FBF\5229\3067\3059\3002\9759\7684ID\304C\5B9A\7FA9\3055\308C\3066\3044\306A\3044\5834\5408\3001\8868\306B\3088\3063\3066\3053\308C\3089\306E\5C5E\6027\5024\306B\5BFE\3059\308B\5185\90E8ID\304C\751F\6210\3055\308C\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104169668742308583)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.JET_CHART_AXES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\8EF8\306E\9759\7684ID\3092\5165\529B\3057\307E\3059\3002\9759\7684ID\306F\3001\30C1\30E3\30FC\30C8\8EF8\306E\30AB\30B9\30BF\30E0JavaScript\52D5\4F5C\3092\958B\767A\3059\308B\5834\5408\306B\4FBF\5229\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104169586648308583)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.JET_CHART_SERIES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\30FB\30B7\30EA\30FC\30BA\306E\9759\7684ID\3092\5165\529B\3057\307E\3059\3002\9759\7684ID\306F\3001\30C1\30E3\30FC\30C8\30FB\30B7\30EA\30FC\30BA\306E\30AB\30B9\30BF\30E0JavaScript\52D5\4F5C\3092\958B\767A\3059\308B\5834\5408\306B\4FBF\5229\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103968317788308411)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30EA\30FC\30B8\30E7\30F3\306E\9759\7684ID\3092\5165\529B\3057\307E\3059\3002\5B9A\7FA9\3055\308C\3066\3044\308B\5834\5408\3001\3053\308C\306F\3001\7F6E\63DB\6587\5B57\5217<code>#REGION_STATIC_ID#</code>\3092\4F7F\7528\3057\3066\30EA\30FC\30B8\30E7\30F3\306EID\3068\3057\3066\4F7F\7528\3055\308C\3001\30EA\30FC\30B8\30E7\30F3\306E\30AB\30B9\30BF\30E0JavaScript\52D5\4F5C\3092\958B\767A\3059\308B\969B\306B\5F79\7ACB\3061\307E\3059\3002\3053\308C\304C\5B9A\7FA9\3055\308C\3066\3044\306A\3044\5834\5408\3001\30EA\30FC\30B8\30E7\30F3\306F\5185\90E8ID\3092\751F\6210\3057\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8: \30EA\30FC\30B8\30E7\30F3\304C\5165\529B\3055\308C\305F\9759\7684ID\3092\4F7F\7528\3059\308B\305F\3081\306B\306F\3001\30C6\30F3\30D7\30EC\30FC\30C8\306B<code>#REGION_STATIC_ID#</code>\7F6E\63DB\6587\5B57\5217\3092\542B\3081\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103898657188308326)
,p_name=>'PE.PROPERTY.STATIC_ID.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306E\9759\7684ID\3092\5165\529B\3057\307E\3059\3002\3053\306EID\304C\5B9A\7FA9\3055\308C\3066\3044\308B\5834\5408\3001ID\306F\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306E\30AB\30B9\30BF\30E0JavaScript\52D5\4F5C\3092\958B\767A\3059\308B\969B\306B\5F79\7ACB\3061\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103898501537308326)
,p_name=>'PE.PROPERTY.STATIC_ID.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\9759\7684ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104180961594308593)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\305F\682A\4FA1\30C1\30E3\30FC\30C8\306B\9069\7528\3059\308B\30B7\30EA\30FC\30BA\30FB\30BF\30A4\30D7\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104181007119308594)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.LOV.AREA.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104181101916308594)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.LOV.BAR.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\68D2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104181219533308594)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.LOV.CANDLESTICK.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30FC\30BD\30AF\8DB3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104181373536308594)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.LOV.LINE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6298\308C\7DDA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104181463714308594)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.LOV.LINEWITHAREA.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\9762\4ED8\304D\6298\308C\7DDA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104180896736308593)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5225\540D\3067\63CF\753B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103901056414308328)
,p_name=>'PE.PROPERTY.STOP_EXECUTION_ON_ERROR.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\73FE\5728\306E\30A2\30AF\30B7\30E7\30F3\306E\5B9F\884C\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\305F\5834\5408\306B\4ED6\306E\3059\3079\3066\306E\4FDD\7559\4E2D\306E\30A2\30AF\30B7\30E7\30F3\306E\51E6\7406\304C\505C\6B62\3055\308C\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8: \7279\5B9A\306E\30A2\30AF\30B7\30E7\30F3\306E\5B9F\884C\306E\9806\5E8F\306F\3001\5404\30A2\30AF\30B7\30E7\30F3\306B\6307\5B9A\3055\308C\305F\9806\5E8F\306B\3088\3063\3066\6C7A\307E\308A\307E\3059\3002\30A2\30AF\30B7\30E7\30F3\304C\540C\3058\9806\5E8F\3067\5B9F\884C\3055\308C\308B\3088\3046\306B\3059\308B\305F\3081\306B\3001\3059\3079\3066\306ETrue\30A2\30AF\30B7\30E7\30F3\304A\3088\3073\3059\3079\3066\306EFalse\30A2\30AF\30B7\30E7\30F3\3067\9806\5E8F\756A\53F7\3092\4E00\610F\306B\3059\308B\3053\3068\3092\304A\85A6\3081\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103900973958308328)
,p_name=>'PE.PROPERTY.STOP_EXECUTION_ON_ERROR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC\6642\306B\5B9F\884C\505C\6B62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103978277433308419)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.COMPONENT_PROPERTY.IG_COLUMN.NULL_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\8A2D\5B9A\306E\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103978357631308419)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.COMPONENT_PROPERTY.IG_COLUMN.NULL_TEXT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\306F\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\8A2D\5B9A\3057\305F<strong>\300C\62E1\5F35\300D</strong>\30EC\30DD\30FC\30C8\8A2D\5B9A\3092\4F7F\7528\3057\3066\3001\5217\3092\62E1\5F35\3059\308B\304B\3069\3046\304B\3092\5B9A\7FA9\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103977741378308419)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5341\5206\306A\30B9\30AF\30EA\30FC\30F3\30FB\30EA\30A2\30EB\30FB\30A8\30B9\30C6\30FC\30C8\304C\3042\308B\5834\5408\306B\5217\3092\62E1\5F35\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103978014124308419)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.LOV.A.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5E38\6642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103978142313308419)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.LOV.A.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\8A2D\5B9A\3057\305F<strong>\300C\62E1\5F35\300D</strong>\30EC\30DD\30FC\30C8\8A2D\5B9A\306B\95A2\4FC2\306A\304F\3001\5217\306F\5E38\306B\62E1\5F35\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103977801395308419)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.LOV.N.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\306A\3057')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103977925252308419)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.LOV.N.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\306F\62E1\5F35\3055\308C\305A\3001\5E38\306B\6307\5B9A\3055\308C\305F\5E45\306E\307F\3092\4F7F\7528\3057\307E\3059\3002\3053\308C\306F\3001\306F\3044/\3044\3044\3048\3084\6570\5024\306A\3069\306E\77ED\3044\5185\5BB9\306E\5217\306E\5834\5408\306B\5F79\7ACB\3061\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103977690718308418)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\62E1\5F35')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104242875615308641)
,p_name=>'PE.PROPERTY.STRIP_HTML.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5143\306E\5217\5024\304B\3089HTML\30BF\30B0\3092\524A\9664\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002'),
unistr('\3053\308C\306F\3001HTML\5F0F\3092\4F7F\7528\3059\308B\5217\3001\5217\30EA\30F3\30AF\3067\4F7F\7528\3055\308C\308B\5217\3001\304A\3088\3073CSV\30D5\30A1\30A4\30EB\306B\30A8\30AF\30B9\30DD\30FC\30C8\3055\308C\308B\5217\306E\5834\5408\7279\306B\91CD\8981\3067\3059\3002</p>'),
unistr('<p>\3059\3067\306BHTML\30BF\30B0\3092\542B\3080\5024\3092\30C7\30FC\30BF\30D9\30FC\30B9\304B\3089\9078\629E\3059\308B\3068\3001\305D\308C\3089\306E\30BF\30B0\304C\539F\56E0\3067\3001HTML\5F0F\306B\5BFE\3057\3066\751F\6210\3055\308C\305FHTML\307E\305F\306F\5217\30EA\30F3\30AF\306B\5BFE\3057\3066\751F\6210\3055\308C\305FURL\3068\7AF6\5408\304C\767A\751F\3059\308B\53EF\80FD\6027\304C\3042\308A\307E\3059\3002'),
unistr('\305D\306E\3088\3046\306A\5024\3092\30A8\30AF\30B9\30DD\30FC\30C8\3059\308B\5834\5408\3001\65E2\5B58\306EHTML\30BF\30B0\306F\3001\751F\6210\3055\308C\305FCSV\30D5\30A1\30A4\30EB\306B\30D7\30EC\30FC\30F3\30FB\30C6\30AD\30B9\30C8\3068\3057\3066\542B\307E\308C\307E\3059\3002'),
unistr('\3053\306E\30AA\30D7\30B7\30E7\30F3\304C\6709\52B9\306A\5834\5408\3001\5217\5024\306E\5B9F\969B\306E\30C7\30FC\30BF\90E8\5206\306E\307F\304C\4F7F\7528\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104242706480308641)
,p_name=>'PE.PROPERTY.STRIP_HTML.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('HTML\306E\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104098552545308515)
,p_name=>'PE.PROPERTY.SUBMIT_CHECKED_ROWS.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\901A\5E38<strong>\300C\5B8C\4E86\30DE\30FC\30AF\8A2D\5B9A\65E5\300D</strong>\306A\3069\306E\30AB\30B9\30BF\30E0\30FB\30DC\30BF\30F3\3067\958B\59CB\3055\308C\308B\30DA\30FC\30B8\51E6\7406\306B\30C1\30A7\30C3\30AF\3057\305F\884C\3092\542B\3081\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002'),
unistr('        \3053\308C\3089\306E\30C1\30A7\30C3\30AF\3057\305F\884C\3092\30AB\30B9\30BF\30E0\30FB\30D7\30ED\30BB\30B9\3067\5229\7528\3057\3066\3001\5FC5\8981\306A\30A2\30AF\30B7\30E7\30F3\3092\5B9F\884C\3067\304D\307E\3059\3002</p>'),
unistr('        <p>\30CE\30FC\30C8 - \884C\304C\66F4\65B0\3055\308C\3066\3044\306A\304F\3066\3082\3001\9078\629E\884C\304C\51E6\7406\3055\308C\307E\3059\3002\901A\5E38\3001\633F\5165\3001\66F4\65B0\307E\305F\306F\524A\9664\3055\308C\305F\884C\306E\307F\51E6\7406\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104098459521308515)
,p_name=>'PE.PROPERTY.SUBMIT_CHECKED_ROWS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\9001\4FE1\306B\9078\629E\884C\3092\542B\3081\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103963286653308408)
,p_name=>'PE.PROPERTY.SUBSCRIBED_FROM.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B9\30AD\30FC\30E0\306E\30B5\30D6\30B9\30AF\30E9\30A4\30D6\5148\3068\306A\308B\8A8D\8A3C\30B9\30AD\30FC\30E0\3092\6301\3064\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\9078\629E\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103963182513308408)
,p_name=>'PE.PROPERTY.SUBSCRIBED_FROM.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30D6\30AF\30E9\30A4\30D6\5143')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104567530761308892)
,p_name=>'PE.PROPERTY.SUB_TITLE_ADV_FORMATTING.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\3092\3001\5217\307E\305F\306FHTML\5F0F\304A\3088\3073\30B5\30DD\30FC\30C8\3055\308C\3066\3044\308B\7F6E\63DB\6587\5B57\5217\3092\4F7F\7528\3059\308B\62E1\5F35\30D5\30A9\30FC\30DE\30C3\30C8\306E\3044\305A\308C\3092\4F7F\7528\3057\3066\8868\793A\3059\308B\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104567419277308892)
,p_name=>'PE.PROPERTY.SUB_TITLE_ADV_FORMATTING.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\62E1\5F35\30D5\30A9\30FC\30DE\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104567747367308893)
,p_name=>'PE.PROPERTY.SUB_TITLE_COLUMN_NAME.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30D6\30BF\30A4\30C8\30EB\3068\3057\3066\4F7F\7528\3059\308B\5217\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104567653882308892)
,p_name=>'PE.PROPERTY.SUB_TITLE_COLUMN_NAME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104568265147308893)
,p_name=>'PE.PROPERTY.SUB_TITLE_CSS_CLASSES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\8FFD\52A0\3059\308B\30AF\30E9\30B9\3092\5165\529B\3057\307E\3059\3002\8907\6570\306E\30AF\30E9\30B9\306F\7A7A\767D\3067\533A\5207\3063\3066\8FFD\52A0\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104568168550308893)
,p_name=>'PE.PROPERTY.SUB_TITLE_CSS_CLASSES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('CSS\30AF\30E9\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104568007688308893)
,p_name=>'PE.PROPERTY.SUB_TITLE_HTML_EXPR.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>\30D0\30C3\30AF\30B0\30E9\30A6\30F3\30C9\304A\3088\3073\30C6\30AD\30B9\30C8\306E\8272\306E\5909\66F4</dt>'),
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>\30D8\30C3\30C0\30FC2\306E\4F7F\7528</dt>'),
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>SQL\554F\5408\305B\304B\3089\306E\52D5\7684\30AF\30E9\30B9\306E\4F7F\7528</dt>'),
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    \3053\306E\4F8B\3067<code>&COLUMN_CLASS.</code>\3068<code>&EMPLOYEE_STATUS.</code>\306B\4EE3\5165\3055\308C\308B\306E\306F\3001\30EC\30DD\30FC\30C8SQL\554F\5408\305B\3067\9078\629E\3055\308C\305F\5217\3067\3059\3002</dd>'),
unistr('  <dt>\30DB\30D0\30FC\3067\306E\30A4\30E1\30FC\30B8\304A\3088\3073\30C4\30FC\30EB\30C1\30C3\30D7\306E\8868\793A</dt>'),
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104567929777308893)
,p_name=>'PE.PROPERTY.SUB_TITLE_HTML_EXPR.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\5217\306B\8868\793A\3055\308C\308BHTML\5F0F\3092\5165\529B\3057\307E\3059\3002<code>&COLUMN.</code>\69CB\6587\3092\4F7F\7528\3057\3066\3001HTML\306B\5217\5024\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104567895123308893)
,p_name=>'PE.PROPERTY.SUB_TITLE_HTML_EXPR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('HTML\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104222319503308626)
,p_name=>'PE.PROPERTY.SUCCESS_MESSAGE.COMPONENT_PROPERTY.PAGE_PROCESS.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30D7\30ED\30BB\30B9\306E\6210\529F\30E1\30C3\30BB\30FC\30B8\3092\5165\529B\3057\307E\3059\3002'),
unistr('\30D7\30ED\30BB\30B9\304C\5B9F\884C\3055\308C\3001\30A8\30E9\30FC\304C\767A\751F\3057\306A\3044\5834\5408\306F\3001\8868\793A\3055\308C\308B\7D50\679C\306E\30DA\30FC\30B8\306E\901A\77E5\30BB\30AF\30B7\30E7\30F3\306B\3001\3053\306E\30D7\30ED\30BB\30B9\6210\529F\30E1\30C3\30BB\30FC\30B8\304C\8868\793A\3055\308C\307E\3059\3002'),
unistr('URL\30EA\30C0\30A4\30EC\30AF\30C8\3092\4ECB\3057\3066\5225\306E\30DA\30FC\30B8\306B\30D6\30E9\30F3\30C1\3059\308B\5834\5408\306F\3001<em>\300C\6210\529F\30E1\30C3\30BB\30FC\30B8\306E\4FDD\5B58\300D</em>\5C5E\6027\3092\9078\629E\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>'),
unistr('<p>\8907\6570\884C\306E\30D7\30ED\30BB\30B9\306E\5834\5408\3001\6B21\306E\7F6E\63DB\6587\5B57\5217\3092\51E6\7406\3055\308C\305F\30EC\30B3\30FC\30C9\6570\306E\53D6\5F97\306B\4F7F\7528\3067\304D\307E\3059\3002</p>'),
'<ul>',
unistr('<li>\633F\5165: <code>#MRI_COUNT#</code></li>'),
unistr('<li>\66F4\65B0: <code>#MRU_COUNT#</code></li>'),
unistr('<li>\524A\9664: <code>#MRD_COUNT#</code></li>'),
'</ul>',
unistr('<p>\300C\96FB\5B50\30E1\30FC\30EB\306E\9001\4FE1\300D\30D7\30ED\30BB\30B9\30FB\30BF\30A4\30D7\306E\5834\5408\3001\7F6E\63DB\6587\5B57\5217<code>#TO#</code>\3092\96FB\5B50\30E1\30FC\30EB\306E\30A2\30C9\30EC\30B9\306E\53D6\5F97\306B\4F7F\7528\3067\304D\307E\3059\3002</p>'),
unistr('<p>\30D7\30E9\30B0\30A4\30F3\3067\306F\3001\4ED6\306E\7F6E\63DB\6587\5B57\5217\3082\4F7F\7528\3067\304D\307E\3059\3002\8A73\7D30\306F\3001\30D7\30E9\30B0\30A4\30F3\306E\30C9\30AD\30E5\30E1\30F3\30C8\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104376716413308739)
,p_name=>'PE.PROPERTY.SUCCESS_MESSAGE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30D7\30ED\30BB\30B9\304C\6B63\5E38\306B\5B8C\4E86\3057\305F\3068\304D\3001\300C\901A\77E5\300D\9818\57DF(\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306E\4E00\90E8\3068\3057\3066\5B9A\7FA9)\306B\8868\793A\3055\308C\308B\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104221853602308626)
,p_name=>'PE.PROPERTY.SUCCESS_MESSAGE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6210\529F\30E1\30C3\30BB\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103918355614308373)
,p_name=>'PE.PROPERTY.SUGGESTIONS_SQL_QUERY.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30B5\30B8\30A7\30B9\30C1\30E7\30F3\306E\30BD\30FC\30B9\3068\3057\3066\4F7F\7528\3059\308BSQL\554F\5408\305B\3092\5165\529B\3057\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8: \5024\306E\623B\308A\9806\3092\4F7F\7528\3057\3066\3001\8868\793A\9806\5E8F\304C\6C7A\5B9A\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103918272016308373)
,p_name=>'PE.PROPERTY.SUGGESTIONS_SQL_QUERY.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103918176471308372)
,p_name=>'PE.PROPERTY.SUGGESTIONS_STATIC_VALUES.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30B5\30B8\30A7\30B9\30C1\30E7\30F3\306E\30BD\30FC\30B9\3068\3057\3066\4F7F\7528\3059\308B\30AB\30F3\30DE\533A\5207\308A\306E\9759\7684LOV\3092\5165\529B\3057\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8: \5024\306E\6307\5B9A\9806\5E8F\3092\4F7F\7528\3057\3066\3001\8868\793A\9806\5E8F\304C\6C7A\5B9A\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103918061395308372)
,p_name=>'PE.PROPERTY.SUGGESTIONS_STATIC_VALUES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\9759\7684\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103920312323308374)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.COMPONENT_PROPERTY.SFILTER.NULL_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103921066000308375)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.COMPONENT_PROPERTY.SFILTER_GROUP.NULL_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103917345177308372)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30D5\30A3\30EB\30BF\306B\5BFE\3059\308B\30B5\30B8\30A7\30B9\30C1\30E7\30F3\306E\6C7A\5B9A\65B9\6CD5\3092\9078\629E\3057\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8: \6307\5B9A\3055\308C\305F\5024\306F\3001LOV\306E\8868\793A\3055\308C\3066\3044\308B\30A8\30F3\30C8\30EA\306B\5BFE\3057\3066\5F15\304D\7D9A\304D\30C1\30A7\30C3\30AF\3055\308C\3001\4E00\81F4\3059\308B\5834\5408\306B\306E\307F\4F7F\7528\3055\308C\307E\3059\3002'),
unistr('\5024\304C\898B\3064\304B\3089\306A\3044\5834\5408\306F\30B9\30AD\30C3\30D7\3055\308C\3001\6B21\306E\5024\304C\30C1\30A7\30C3\30AF\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103917423521308372)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.DYNAMIC.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\52D5\7684')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103917513254308372)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.DYNAMIC.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('LOV\304B\3089<strong>\6700\521D</strong>\306E\8868\793A\53EF\80FD\30A8\30F3\30C8\30EA\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103917897909308372)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103917967655308372)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3057\305F<em>SQL\554F\5408\305B</em>\304B\3089\5024\304C\8FD4\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103917674798308372)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.STATIC.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\9759\7684\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103917798738308372)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.STATIC.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30F3\30DE\533A\5207\308A\306ELOV\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103917232286308372)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104186054872308598)
,p_name=>'PE.PROPERTY.SUPPLEMENTAL_TEXT.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30C0\30A6\30F3\30ED\30FC\30C9\30FB\30D5\30A1\30A4\30EB\306E\4E0A\90E8\306B\8868\793A\3055\308C\308B\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002\30D5\30A1\30A4\30EB\5185\306E\30C7\30FC\30BF\306B\95A2\3059\308B\30C7\30FC\30BF\5206\985E\3001\6CD5\7684\307E\305F\306F\8B66\544A\30E1\30C3\30BB\30FC\30B8\3092\5165\529B\3067\304D\307E\3059\3002</p>'),
unistr('        <p> \30CE\30FC\30C8 - \5165\529B\3057\305F\30C6\30AD\30B9\30C8\306F\3001\3059\3079\3066\306E\30EC\30DD\30FC\30C8\306E\30C0\30A6\30F3\30ED\30FC\30C9\5F62\5F0F\306B\542B\307E\308C\307E\3059\3002CSV\30C0\30A6\30F3\30ED\30FC\30C9\304C\6709\52B9\306A\5834\5408\3001\5B9A\7FA9\3055\308C\305F\30C6\30AD\30B9\30C8\306B\3088\3063\3066CSV\30D5\30A1\30A4\30EB\5F62\5F0F\304C\7121\52B9\5316\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104185984232308598)
,p_name=>'PE.PROPERTY.SUPPLEMENTAL_TEXT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8FFD\52A0\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104201213297308610)
,p_name=>'PE.PROPERTY.SYNC_FORM_LABEL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\30D8\30C3\30C0\30FC\30FB\30C6\30AD\30B9\30C8\3092\8A73\7D30\30D3\30E5\30FC\306E\30E9\30D9\30EB\3068\3057\3066\4F7F\7528\3059\308B\5834\5408\306F\3001\3053\306E\5C5E\6027\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104201157046308610)
,p_name=>'PE.PROPERTY.SYNC_FORM_LABEL.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\30D8\30C3\30C0\30FC\306E\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104256505333308651)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\8868\5F62\5F0F\30D5\30A9\30FC\30E0\5217\306E\30D9\30FC\30B9\3092\9078\629E\3057\307E\3059\3002</p>'),
unistr('<p>\9078\629E\306B\3088\3063\3066\3001\8868\5F62\5F0F\30D5\30A9\30FC\30E0\5185\3067\3053\306E\5217\3092\66F4\65B0\3067\304D\308B\304B\3069\3046\304B\304C\6C7A\307E\308A\307E\3059\3002'),
unistr('\66F4\65B0\306F\3001\8907\6570\884C\306E\66F4\65B0\304C\5B9A\7FA9\3055\308C\3066\3044\308B\5834\5408\3001\307E\305F\306FPL/SQL\30D7\30ED\30BB\30B9\304C\66F4\65B0\6E08\30C7\30FC\30BF\3092\51E6\7406\3059\308B\3088\3046\306B\5B9F\88C5\3055\308C\3066\3044\308B\5834\5408\306B\306E\307F\5B9F\884C\3067\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104423929327308775)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DATE_PICKER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5\4ED8\30D4\30C3\30AB\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104592389668308912)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DATE_PICKER.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5\4ED8\3092\5165\529B\3059\308B\304B\3001\65E5\4ED8\30D4\30C3\30AB\30FC\3092\4F7F\7528\3057\3066\65E5\4ED8\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104423895126308775)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DATE_POPUP.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5\4ED8\30D4\30C3\30AB\30FC(\30AF\30E9\30B7\30C3\30AF)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104592415442308913)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DATE_POPUP.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5\4ED8\3092\5165\529B\3059\308B\304B\3001\65E5\4ED8\30D4\30C3\30AB\30FC\3092\4F7F\7528\3057\3066\65E5\4ED8\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104423766384308775)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DISPLAY_AND_SAVE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30EC\30FC\30F3\30FB\30C6\30AD\30B9\30C8(\72B6\614B\3092\4FDD\5B58\3059\308B)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104591011795308911)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DISPLAY_AND_SAVE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\5024\3092\8868\793A\3057\3001\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\306E\5024\306B\4FDD\5B58\3057\307E\3059\3002\3053\306E\5217\306F\30DA\30FC\30B8\51E6\7406\3067\5229\7528\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104425442276308776)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DOWNLOAD.D'
,p_message_language=>'ja'
,p_message_text=>unistr('BLOB\306E\30C0\30A6\30F3\30ED\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104591414493308912)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DOWNLOAD.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\3092\30C0\30A6\30F3\30ED\30FC\30C9\3059\308B\305F\3081\306E\30EA\30F3\30AF\3068\3057\3066\5217\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104424905969308776)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.HIDDEN_COLUMN.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\975E\8868\793A\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104592576445308913)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.HIDDEN_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\306F\8868\793A\3055\308C\307E\305B\3093\304C\3001\53C2\7167\53EF\80FD\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104424426009308775)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.HIDDEN_FIELD.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\975E\8868\793A\5217(\72B6\614B\3092\4FDD\5B58\3059\308B)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104592630888308913)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.HIDDEN_FIELD.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\306F\8868\793A\3055\308C\307E\305B\3093\304C\3001\53C2\7167\53EF\80FD\3067\3059\3002\3053\306E\5217\306F\30DA\30FC\30B8\51E6\7406\3067\4F7F\7528\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104425306609308776)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.IMAGE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30E1\30FC\30B8\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104591399091308912)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.IMAGE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30E1\30FC\30B8\3068\3057\3066\5217\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104425221679308776)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.LINK.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30F3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104591260925308911)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.LINK.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30F3\30AF\3068\3057\3066\5217\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104425538469308776)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PCT_GRAPH.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30FC\30BB\30F3\30C8\30FB\30B0\30E9\30D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104591572079308912)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PCT_GRAPH.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30FC\30BB\30F3\30C6\30FC\30B8\30FB\30B0\30E9\30D5\3068\3057\3066\5217\3092\8868\793A\3057\307E\3059\3002\53D6\5F97\3055\308C\308B\5024\306F\30010\304B\3089100\307E\3067\306E\9593\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104425006432308776)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PLAIN.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30EC\30FC\30F3\30FB\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104590974061308911)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PLAIN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\5024\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104425112956308776)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PLAIN_LOV.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30EC\30FC\30F3\30FB\30C6\30AD\30B9\30C8(LOV\306B\57FA\3065\304F)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104591146930308911)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PLAIN_LOV.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\6307\5B9A\3055\308C\305FLOV\304B\3089\8FD4\3055\308C\305F\5024\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104424596635308775)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.POPUP.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DD\30C3\30D7\30A2\30C3\30D7LOV(\623B\308A\5024\3092\8868\793A\3059\308B)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104592084031308912)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.POPUP.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DD\30C3\30D7\30A2\30C3\30D7\304B\3089\5024\3092\9078\629E\3057\307E\3059\3002LOV\304B\3089\306E\623B\308A\5024\304C\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104424651095308776)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.POPUPKEY.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DD\30C3\30D7\30A2\30C3\30D7LOV(\5024\3092\8868\793A\3059\308B)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104591949145308912)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.POPUPKEY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DD\30C3\30D7\30A2\30C3\30D7\304B\3089\5024\3092\9078\629E\3057\307E\3059\3002LOV\304B\3089\8868\793A\5024\304C\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104424347764308775)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.RADIOGROUP.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30B8\30AA\30FB\30B0\30EB\30FC\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104592199953308912)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.RADIOGROUP.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\6307\5B9A\3055\308C\305FLOV\304B\3089\5358\4E00\306E\30E9\30B8\30AA\30FB\30B0\30EB\30FC\30D7\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104424803121308776)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.ROW_SELECTOR.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\30BB\30EC\30AF\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104590872662308911)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.ROW_SELECTOR.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5404\884C\306E\5148\982D\306B\30C1\30A7\30C3\30AF\30DC\30C3\30AF\30B9\3092\542B\3081\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104424207965308775)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.SELECT_LIST.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\30EA\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104591800663308912)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.SELECT_LIST.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\6307\5B9A\3055\308C\305FLOV\304B\3089\8FD4\3055\308C\305F\5024\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104424709630308776)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.SIMPLE_CHECKBOX.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5358\7D14\306A\30C1\30A7\30C3\30AF\30FB\30DC\30C3\30AF\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104592265693308912)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.SIMPLE_CHECKBOX.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5358\4E00\306E\30C1\30A7\30C3\30AF\30DC\30C3\30AF\30B9\3092\9078\629E\307E\305F\306F\9078\629E\89E3\9664\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104424048227308775)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.TEXT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8\30FB\30D5\30A3\30FC\30EB\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104591606056308912)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.TEXT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8\30FB\30D5\30A3\30FC\30EB\30C9\306B\5024\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104424165700308775)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.TEXTAREA.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8\9818\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104591721192308912)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.TEXTAREA.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8\9818\57DF\30D5\30A3\30FC\30EB\30C9\306B\5024\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104256422083308651)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103979370370308420)
,p_name=>'PE.PROPERTY.TARGET.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E2\30FC\30C0\30EB\30FB\30C0\30A4\30A2\30ED\30B0\3092\8D77\52D5\3059\308B\30BF\30FC\30B2\30C3\30C8\3092\30AF\30EA\30C3\30AF\3057\307E\3059\3002\3053\306E\30D6\30E9\30F3\30C1\304C\8D77\52D5\3055\308C\305F\3068\304D\306B\30B3\30FC\30EB\3055\308C\308B\30BF\30FC\30B2\30C3\30C8\3092\5165\529B\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103979242980308420)
,p_name=>'PE.PROPERTY.TARGET.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30FC\30B2\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104559840409308886)
,p_name=>'PE.PROPERTY.TEMPLATE_OPTIONS.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306E\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\3092\30AB\30B9\30BF\30DE\30A4\30BA\3059\308B\305F\3081\306E\30C6\30F3\30D7\30EC\30FC\30C8\30FB\30AA\30D7\30B7\30E7\30F3\3092\9078\629E\3057\307E\3059\3002</p>'),
unistr('<p><strong>\300C\30E9\30A4\30D6\30FB\30C6\30F3\30D7\30EC\30FC\30C8\30FB\30AA\30D7\30B7\30E7\30F3\300D</strong>\3092\4F7F\7528\3057\3066\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\5B9F\884C\6642\306B\30C6\30F3\30D7\30EC\30FC\30C8\30FB\30AA\30D7\30B7\30E7\30F3\3092\5909\66F4\3059\308B\3053\3068\3082\3067\304D\307E\3059\3002'),
unistr('\300C\30E9\30A4\30D6\30FB\30C6\30F3\30D7\30EC\30FC\30C8\30FB\30AA\30D7\30B7\30E7\30F3\300D\3067\306F\3001\30EA\30A2\30EB\30BF\30A4\30E0\3067\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\30AB\30B9\30BF\30DE\30A4\30BA\3057\3001\69D8\3005\306A\30AA\30D7\30B7\30E7\30F3\3092\30D7\30EC\30D3\30E5\30FC\3057\3066\9069\7528\3067\304D\307E\3059\3002'),
unistr('\300C\30E9\30A4\30D6\30FB\30C6\30F3\30D7\30EC\30FC\30C8\30FB\30AA\30D7\30B7\30E7\30F3\300D\306B\30A2\30AF\30BB\30B9\3059\308B\306B\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30D3\30EB\30C0\30FC\304B\3089\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\5B9F\884C\3057\3001\958B\767A\8005\30C4\30FC\30EB\30D0\30FC\306E<em>\300C\30AF\30A4\30C3\30AF\7DE8\96C6\300D</em>\3092\30AF\30EA\30C3\30AF\3057\307E\3059\3002'),
unistr('\30EA\30FC\30B8\30E7\30F3\306A\3069\306E\30DA\30FC\30B8\30FB\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\30AB\30FC\30BD\30EB\3092\5408\305B\3001\5DE6\4E0A\9685\306B\8868\793A\3055\308C\3066\3044\308B\30EC\30F3\30C1\30FB\30A2\30A4\30B3\30F3( <span class="a-Icon icon-util" aria-hidden="true"></span> )\3092\30AF\30EA\30C3\30AF\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104559711220308886)
,p_name=>'PE.PROPERTY.TEMPLATE_OPTIONS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8\30FB\30AA\30D7\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104560087306308887)
,p_name=>'PE.PROPERTY.TEMPLATE_OPTIONS2.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306E\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\3092\30AB\30B9\30BF\30DE\30A4\30BA\3059\308B\305F\3081\306E\30C6\30F3\30D7\30EC\30FC\30C8\30FB\30AA\30D7\30B7\30E7\30F3\3092\9078\629E\3057\307E\3059\3002</p>'),
unistr('<p><strong>\300C\30E9\30A4\30D6\30FB\30C6\30F3\30D7\30EC\30FC\30C8\30FB\30AA\30D7\30B7\30E7\30F3\300D</strong>\3092\4F7F\7528\3057\3066\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\5B9F\884C\6642\306B\30C6\30F3\30D7\30EC\30FC\30C8\30FB\30AA\30D7\30B7\30E7\30F3\3092\5909\66F4\3059\308B\3053\3068\3082\3067\304D\307E\3059\3002'),
unistr('\300C\30E9\30A4\30D6\30FB\30C6\30F3\30D7\30EC\30FC\30C8\30FB\30AA\30D7\30B7\30E7\30F3\300D\3067\306F\3001\30EA\30A2\30EB\30BF\30A4\30E0\3067\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\30AB\30B9\30BF\30DE\30A4\30BA\3057\3001\69D8\3005\306A\30AA\30D7\30B7\30E7\30F3\3092\30D7\30EC\30D3\30E5\30FC\3057\3066\9069\7528\3067\304D\307E\3059\3002'),
unistr('\300C\30E9\30A4\30D6\30FB\30C6\30F3\30D7\30EC\30FC\30C8\30FB\30AA\30D7\30B7\30E7\30F3\300D\306B\30A2\30AF\30BB\30B9\3059\308B\306B\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30D3\30EB\30C0\30FC\304B\3089\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\5B9F\884C\3057\3001\958B\767A\8005\30C4\30FC\30EB\30D0\30FC\306E<em>\300C\30AF\30A4\30C3\30AF\7DE8\96C6\300D</em>\3092\30AF\30EA\30C3\30AF\3057\307E\3059\3002'),
unistr('\30EA\30FC\30B8\30E7\30F3\306A\3069\306E\30DA\30FC\30B8\30FB\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\30AB\30FC\30BD\30EB\3092\5408\305B\3001\5DE6\4E0A\9685\306B\8868\793A\3055\308C\3066\3044\308B\30EC\30F3\30C1\30FB\30A2\30A4\30B3\30F3( <span class="a-Icon icon-util" aria-hidden="true"></span> )\3092\30AF\30EA\30C3\30AF\3057\307E\3059\3002</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104559976664308887)
,p_name=>'PE.PROPERTY.TEMPLATE_OPTIONS2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8\30FB\30AA\30D7\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103808148224308253)
,p_name=>'PE.PROPERTY.TEMPLATE_PLACEHOLDERS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\30FB\30C6\30F3\30D7\30EC\30FC\30C8\5185\306E\30D7\30EC\30FC\30B9\30DB\30EB\30C0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103808012751308253)
,p_name=>'PE.PROPERTY.TEMPLATE_PLACEHOLDERS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8\30FB\30D7\30EC\30FC\30B9\30DB\30EB\30C0\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104241413802308640)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30EC\30DD\30FC\30C8\306E\30C6\30F3\30D7\30EC\30FC\30C8\30FB\30BF\30A4\30D7\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104420644838308773)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.LOV.PREDEFINED.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E8B\524D\5B9A\7FA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104420773353308773)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.LOV.PREDEFINED.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3069\306E\30C6\30FC\30DE\306B\3082\76F4\63A5\95A2\9023\4ED8\3051\3089\308C\3066\3044\306A\3044\4E8B\524D\5B9A\7FA9\306E\30EC\30DD\30FC\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3002\3053\308C\3089\306E\4E8B\524D\5B9A\7FA9\306E\30C6\30F3\30D7\30EC\30FC\30C8\3068\73FE\5728\306E\30C6\30FC\30DE\306E\9593\306B\5BFE\5FDC\95A2\4FC2\304C\306A\3044\305F\3081\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30C6\30FC\30DE\3092\5909\66F4\3057\3066\3082\3001\30EC\30DD\30FC\30C8\30FB\30EC\30A4\30A2\30A6\30C8\306F\540C\3058\307E\307E\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104420454001308772)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.LOV.THEME.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104420503891308773)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.LOV.THEME.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DA\30FC\30B8\306E\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\306E\73FE\5728\306E\30C6\30FC\30DE\306B\57FA\3065\304D\3001\5BFE\5FDC\3059\308B\30C6\30FC\30DE\3067\4F7F\7528\53EF\80FD\306A\30EC\30DD\30FC\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104241379244308640)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8\30FB\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104748680543309041)
,p_name=>'PE.PROPERTY.TEXT_SEARCH_DB_COLUMNS.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\3055\308C\305F<strong>\691C\7D22\30BF\30A4\30D7</strong>\306B\5FDC\3058\3066\3001\30C6\30AD\30B9\30C8\691C\7D22\306B\4F7F\7528\3055\308C\308B\30C7\30FC\30BF\30D9\30FC\30B9\5217\540D\306E1\3064\307E\305F\306F\305D\306E\30EA\30B9\30C8\3092\5165\529B\3057\307E\3059\3002</p>'),
'<ul>',
unistr('  <li><strong>\884C\691C\7D22</strong>: \30C6\30AD\30B9\30C8\691C\7D22\306B\4F7F\7528\3055\308C\308BVARCHAR2\578B\306E\30C7\30FC\30BF\30D9\30FC\30B9\5217\540D(\5927\6587\5B57\3068\5C0F\6587\5B57\3092\533A\5225)\306E\30AB\30F3\30DE\533A\5207\308A\30EA\30B9\30C8\3092\5165\529B\3057\307E\3059\3002\5217\304C\6307\5B9A\3055\308C\3066\3044\306A\3044\5834\5408\306F\3001\3059\3079\3066\306EVARCHAR2\5217\304C\81EA\52D5\7684\306B\4F7F\7528\3055\308C\307E\3059\3002</li>'),
unistr('  <li><strong>Oracle\30C6\30AD\30B9\30C8</strong>: Oracle\30C6\30AD\30B9\30C8\7D22\5F15\3092\542B\3080\30C7\30FC\30BF\30D9\30FC\30B9\5217\540D(\5927\6587\5B57\3068\5C0F\6587\5B57\3092\533A\5225)\3092\5165\529B\3057\307E\3059\3002</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104748536118309041)
,p_name=>'PE.PROPERTY.TEXT_SEARCH_DB_COLUMNS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104020451565308451)
,p_name=>'PE.PROPERTY.THEME.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\306B\95A2\9023\4ED8\3051\308B\30C6\30FC\30DE\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104020325140308451)
,p_name=>'PE.PROPERTY.THEME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104168318619308582)
,p_name=>'PE.PROPERTY.TICK_LABEL_POSITION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\63CF\753B\30A8\30EA\30A2\3092\57FA\6E96\3068\3057\305F\30C6\30A3\30C3\30AF\30FB\30E9\30D9\30EB\306E\4F4D\7F6E\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104168592732308582)
,p_name=>'PE.PROPERTY.TICK_LABEL_POSITION.LOV.INSIDE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5185\5074')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104168412233308582)
,p_name=>'PE.PROPERTY.TICK_LABEL_POSITION.LOV.OUTSIDE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5916\5074')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104168286632308582)
,p_name=>'PE.PROPERTY.TICK_LABEL_POSITION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104167936623308582)
,p_name=>'PE.PROPERTY.TICK_LABEL_RENDERED.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\76EE\76DB\306E\30E9\30D9\30EB\3092\30EC\30F3\30C0\30EA\30F3\30B0\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104167885847308582)
,p_name=>'PE.PROPERTY.TICK_LABEL_RENDERED.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104168186408308582)
,p_name=>'PE.PROPERTY.TICK_LABEL_ROTATION.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\3088\308A\591A\304F\306E\30E9\30D9\30EB\304C\8EF8\4E0A\306B\53CE\307E\308B\3088\3046\306B\3059\308B\305F\3081\306B\3001\30C1\30E3\30FC\30C8\3067\30E9\30D9\30EB\309290\5EA6\81EA\52D5\7684\306B\56DE\8EE2\3055\305B\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002'),
unistr('        \56DE\8EE2\306F\3001\6A2A\8EF8\306E\5206\985E\30E9\30D9\30EB\306B\306E\307F\9069\7528\3055\308C\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104168005078308582)
,p_name=>'PE.PROPERTY.TICK_LABEL_ROTATION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\56DE\8EE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104538729021308866)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.COMPONENT_PROPERTY.MAP_REGION.NULL_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A19\6E96\3068\540C\3058')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104669549961308975)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.COMPONENT_PROPERTY.MAP_REGION.NULL_TEXT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30A4\30C8\30FB\30E2\30FC\30C9\304A\3088\3073\30C0\30FC\30AF\30FB\30E2\30FC\30C9\306B\540C\3058\80CC\666F\30DE\30C3\30D7\3092\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104493361750308833)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C0\30FC\30AF\30FB\30E2\30FC\30C9\304C\6709\52B9\306A\5834\5408\306B\80CC\666F\30DE\30C3\30D7\3068\3057\3066\4F7F\7528\3059\308B\30BF\30A4\30EB\30FB\30EC\30A4\30E4\30FC\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104494256596308834)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.BI-WORLD-MAP.D'
,p_message_language=>'ja'
,p_message_text=>'Oracle BI World Map'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104494363464308834)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.BI-WORLD-MAP.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>HERE Map\30C7\30FC\30BF\306B\57FA\3065\304F\63A7\3048\3081\306A\30D9\30FC\30B9\30FB\30DE\30C3\30D7\3002\3053\306E\30D9\30FC\30B9\30FB\30DE\30C3\30D7\30FB\30B9\30BF\30A4\30EB\306B\3088\3063\3066\3001\30C7\30FC\30BF\306E\30ED\30B1\30FC\30B7\30E7\30F3\30FB\30B3\30F3\30C6\30AD\30B9\30C8\304C\63D0\4F9B\3055\308C\3001\30C7\30FC\30BF\306E\8996\899A\5316\304C\5F37\8ABF\3055\308C\307E\3059\3002</p>'),
unistr('<p>Oracle USA\306B\3088\308B\30B9\30BF\30A4\30EB\30FB\30B9\30AD\30FC\30DE\304A\3088\3073\5B9A\7FA9\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104493876085308833)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-BRIGHT.D'
,p_message_language=>'ja'
,p_message_text=>'OpenStreetMap Bright'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104493949735308834)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-BRIGHT.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<p>OpenStreetMap\30C7\30FC\30BF\306B\57FA\3065\304F\6C4E\7528\30D9\30FC\30B9\30DE\30C3\30D7\3002\3053\306E\30D9\30FC\30B9\30DE\30C3\30D7\30FB\30B9\30BF\30A4\30EB\306B\3088\3063\3066\3001\30C7\30FC\30BF\306E\8A73\7D30\306A\30ED\30B1\30FC\30B7\30E7\30F3\30FB\30B3\30F3\30C6\30AD\30B9\30C8\304C\63D0\4F9B\3055\308C\307E\3059\3002</p>'),
unistr('<p>Mapbox Open Styles\304B\3089\6D3E\751F\3057\305FKlokanTech.com\3068OpenMapTiles\306E\30B3\30F3\30C8\30EA\30D3\30E5\30FC\30BF\306B\3088\308B\30B9\30BF\30A4\30EB\30FB\30B9\30AD\30FC\30DE\304A\3088\3073\5B9A\7FA9\3002BSD/CC-BY\30E9\30A4\30BB\30F3\30B9\306E\4E0B\3067\8A31\53EF\3055\308C\3066\3044\307E\3059\3002</p>'),
unistr('<p><a rel="noreferrer" href="https://github.com/openmaptiles/osm-bright-gl-style" target="_blank">GitHub\3067\8868\793A</a></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104493430348308833)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-DARK-MATTER.D'
,p_message_language=>'ja'
,p_message_text=>'OpenStreetMap Dark'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104493589186308833)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-DARK-MATTER.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<p>OpenStreetMap\30C7\30FC\30BF\306B\57FA\3065\304F\63A7\3048\3081\306A\30E9\30A4\30C8\30FB\30D9\30FC\30B9\30DE\30C3\30D7\3002\3053\306E\30D9\30FC\30B9\30DE\30C3\30D7\30FB\30B9\30BF\30A4\30EB\306B\3088\3063\3066\3001\30C7\30FC\30BF\306E\8996\899A\5316\304C\5F37\8ABF\3055\308C\307E\3059\3002</p>'),
unistr('<p>Mapbox Open Styles\304B\3089\6D3E\751F\3057\305FKlokanTech.com\3068OpenMapTiles\306E\30B3\30F3\30C8\30EA\30D3\30E5\30FC\30BF\306B\3088\308B\30B9\30BF\30A4\30EB\30FB\30B9\30AD\30FC\30DE\304A\3088\3073\5B9A\7FA9\3002BSD/CC-BY\30E9\30A4\30BB\30F3\30B9\306E\4E0B\3067\8A31\53EF\3055\308C\3066\3044\307E\3059\3002Stamen Design\306B\3088\308B\5730\56F3\4F5C\6210\306F\3001CC0\306E\4E0B\3067\8A31\53EF\3055\308C\3066\3044\307E\3059\3002</p>'),
unistr('<p><a rel="noreferrer" href="https://github.com/openmaptiles/positron-gl-style" target="_blank">GitHub\3067\8868\793A</a></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104493641904308833)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-POSITRON.D'
,p_message_language=>'ja'
,p_message_text=>'OpenStreetMap Positron'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104493714703308833)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-POSITRON.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>OpenStreetMap\30C7\30FC\30BF\306B\57FA\3065\304F\63A7\3048\3081\306A\30C0\30FC\30AF\30FB\30D9\30FC\30B9\30DE\30C3\30D7\3002\3053\306E\30D9\30FC\30B9\30DE\30C3\30D7\30FB\30B9\30BF\30A4\30EB\306B\3088\3063\3066\3001\30C7\30FC\30BF\306E\8996\899A\5316\304C\5F37\8ABF\3055\308C\307E\3059\3002</p>'),
unistr('<p>Mapbox Open Styles\304B\3089\6D3E\751F\3057\305FKlokanTech.com\3068OpenMapTiles\306E\30B3\30F3\30C8\30EA\30D3\30E5\30FC\30BF\306B\3088\308B\30B9\30BF\30A4\30EB\30FB\30B9\30AD\30FC\30DE\304A\3088\3073\5B9A\7FA9\3002BSD/CC-BY\30E9\30A4\30BB\30F3\30B9\306E\4E0B\3067\8A31\53EF\3055\308C\3066\3044\307E\3059\3002Stamen Design\306B\3088\308B\5730\56F3\4F5C\6210\306F\3001CC0\306E\4E0B\3067\8A31\53EF\3055\308C\3066\3044\307E\3059\3002</p>'),
unistr('<p><a rel="noreferrer" href="https://github.com/openmaptiles/dark-matter-gl-style" target="_blank">GitHub\3067\8868\793A</a></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104494091907308834)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.WORLD-MAP.D'
,p_message_language=>'ja'
,p_message_text=>'Oracle World Map'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104494151263308834)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.WORLD-MAP.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>HERE Map\30C7\30FC\30BF\306B\57FA\3065\304F\6C4E\7528\30D9\30FC\30B9\30DE\30C3\30D7\3002\3053\306E\30D9\30FC\30B9\30DE\30C3\30D7\30FB\30B9\30BF\30A4\30EB\306B\3088\3063\3066\3001\30C7\30FC\30BF\306E\30ED\30B1\30FC\30B7\30E7\30F3\30FB\30B3\30F3\30C6\30AD\30B9\30C8\304C\63D0\4F9B\3055\308C\3001\30C7\30FC\30BF\306E\8996\899A\5316\304C\5F37\8ABF\3055\308C\307E\3059\3002</p>'),
unistr('<p>Oracle USA\306B\3088\308B\30B9\30BF\30A4\30EB\30FB\30B9\30AD\30FC\30DE\304A\3088\3073\5B9A\7FA9\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104493285198308833)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C0\30FC\30AF\30FB\30E2\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104492153763308832)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\80CC\666F\30DE\30C3\30D7\3068\3057\3066\4F7F\7528\3059\308B\30BF\30A4\30EB\30FB\30EC\30A4\30E4\30FC\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104493040542308833)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.BI-WORLD-MAP.D'
,p_message_language=>'ja'
,p_message_text=>'Oracle BI World Map'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104493126563308833)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.BI-WORLD-MAP.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>HERE Map\30C7\30FC\30BF\306B\57FA\3065\304F\63A7\3048\3081\306A\30D9\30FC\30B9\30FB\30DE\30C3\30D7\3002\3053\306E\30D9\30FC\30B9\30FB\30DE\30C3\30D7\30FB\30B9\30BF\30A4\30EB\306B\3088\3063\3066\3001\30C7\30FC\30BF\306E\30ED\30B1\30FC\30B7\30E7\30F3\30FB\30B3\30F3\30C6\30AD\30B9\30C8\304C\63D0\4F9B\3055\308C\3001\30C7\30FC\30BF\306E\8996\899A\5316\304C\5F37\8ABF\3055\308C\307E\3059\3002</p>'),
unistr('<p>Oracle USA\306B\3088\308B\30B9\30BF\30A4\30EB\30FB\30B9\30AD\30FC\30DE\304A\3088\3073\5B9A\7FA9\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104492618596308833)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-BRIGHT.D'
,p_message_language=>'ja'
,p_message_text=>'OpenStreetMap Bright'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104492750428308833)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-BRIGHT.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<p>OpenStreetMap\30C7\30FC\30BF\306B\57FA\3065\304F\6C4E\7528\30D9\30FC\30B9\30DE\30C3\30D7\3002\3053\306E\30D9\30FC\30B9\30DE\30C3\30D7\30FB\30B9\30BF\30A4\30EB\306B\3088\3063\3066\3001\30C7\30FC\30BF\306E\8A73\7D30\306A\30ED\30B1\30FC\30B7\30E7\30F3\30FB\30B3\30F3\30C6\30AD\30B9\30C8\304C\63D0\4F9B\3055\308C\307E\3059\3002</p>'),
unistr('<p>Mapbox Open Styles\304B\3089\6D3E\751F\3057\305FKlokanTech.com\3068OpenMapTiles\306E\30B3\30F3\30C8\30EA\30D3\30E5\30FC\30BF\306B\3088\308B\30B9\30BF\30A4\30EB\30FB\30B9\30AD\30FC\30DE\304A\3088\3073\5B9A\7FA9\3002BSD/CC-BY\30E9\30A4\30BB\30F3\30B9\306E\4E0B\3067\8A31\53EF\3055\308C\3066\3044\307E\3059\3002</p>'),
unistr('<p><a rel="noreferrer" href="https://github.com/openmaptiles/osm-bright-gl-style" target="_blank">GitHub\3067\8868\793A</a></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104492438209308832)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-DARK-MATTER.D'
,p_message_language=>'ja'
,p_message_text=>'OpenStreetMap Dark'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104492577317308833)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-DARK-MATTER.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>OpenStreetMap\30C7\30FC\30BF\306B\57FA\3065\304F\63A7\3048\3081\306A\30C0\30FC\30AF\30FB\30D9\30FC\30B9\30DE\30C3\30D7\3002\3053\306E\30D9\30FC\30B9\30DE\30C3\30D7\30FB\30B9\30BF\30A4\30EB\306B\3088\3063\3066\3001\30C7\30FC\30BF\306E\8996\899A\5316\304C\5F37\8ABF\3055\308C\307E\3059\3002</p>'),
unistr('<p>Mapbox Open Styles\304B\3089\6D3E\751F\3057\305FKlokanTech.com\3068OpenMapTiles\306E\30B3\30F3\30C8\30EA\30D3\30E5\30FC\30BF\306B\3088\308B\30B9\30BF\30A4\30EB\30FB\30B9\30AD\30FC\30DE\304A\3088\3073\5B9A\7FA9\3002BSD/CC-BY\30E9\30A4\30BB\30F3\30B9\306E\4E0B\3067\8A31\53EF\3055\308C\3066\3044\307E\3059\3002Stamen Design\306B\3088\308B\5730\56F3\4F5C\6210\306F\3001CC0\306E\4E0B\3067\8A31\53EF\3055\308C\3066\3044\307E\3059\3002</p>'),
unistr('<p><a rel="noreferrer" href="https://github.com/openmaptiles/dark-matter-gl-style" target="_blank">GitHub\3067\8868\793A</a></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104492290569308832)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-POSITRON.D'
,p_message_language=>'ja'
,p_message_text=>'OpenStreetMap Positron'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104492328606308832)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-POSITRON.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>OpenStreetMap\30C7\30FC\30BF\306B\57FA\3065\304F\63A7\3048\3081\306A\30E9\30A4\30C8\30FB\30D9\30FC\30B9\30DE\30C3\30D7\3002\3053\306E\30D9\30FC\30B9\30DE\30C3\30D7\30FB\30B9\30BF\30A4\30EB\306B\3088\3063\3066\3001\30C7\30FC\30BF\306E\8996\899A\5316\304C\5F37\8ABF\3055\308C\307E\3059\3002</p>'),
unistr('<p>Mapbox Open Styles\304B\3089\6D3E\751F\3057\305FKlokanTech.com\3068OpenMapTiles\306E\30B3\30F3\30C8\30EA\30D3\30E5\30FC\30BF\306B\3088\308B\30B9\30BF\30A4\30EB\30FB\30B9\30AD\30FC\30DE\304A\3088\3073\5B9A\7FA9\3002BSD/CC-BY\30E9\30A4\30BB\30F3\30B9\306E\4E0B\3067\8A31\53EF\3055\308C\3066\3044\307E\3059\3002Stamen Design\306B\3088\308B\5730\56F3\4F5C\6210\306F\3001CC0\306E\4E0B\3067\8A31\53EF\3055\308C\3066\3044\307E\3059\3002</p>'),
unistr('<p><a rel="noreferrer" href="https://github.com/openmaptiles/positron-gl-style" target="_blank">GitHub\3067\8868\793A</a></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104492841397308833)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.WORLD-MAP.D'
,p_message_language=>'ja'
,p_message_text=>'Oracle World Map'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104492951630308833)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.WORLD-MAP.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>HERE Map\30C7\30FC\30BF\306B\57FA\3065\304F\6C4E\7528\30D9\30FC\30B9\30DE\30C3\30D7\3002\3053\306E\30D9\30FC\30B9\30DE\30C3\30D7\30FB\30B9\30BF\30A4\30EB\306B\3088\3063\3066\3001\30C7\30FC\30BF\306E\30ED\30B1\30FC\30B7\30E7\30F3\30FB\30B3\30F3\30C6\30AD\30B9\30C8\304C\63D0\4F9B\3055\308C\3001\30C7\30FC\30BF\306E\8996\899A\5316\304C\5F37\8ABF\3055\308C\307E\3059\3002</p>'),
unistr('<p>Oracle USA\306B\3088\308B\30B9\30BF\30A4\30EB\30FB\30B9\30AD\30FC\30DE\304A\3088\3073\5B9A\7FA9\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104492026776308832)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A19\6E96')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104491576485308832)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F7F\7528\3059\308B\80CC\666F\30DE\30C3\30D7\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104491855898308832)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.LOV.CUSTOM.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30B9\30BF\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104491930566308832)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.LOV.CUSTOM.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\80CC\666F\30DE\30C3\30D7\306B\4F7F\7528\3059\308B\30DE\30C3\30D7\30FB\30BF\30A4\30EB\30FB\30EC\30A4\30E4\30FC\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104491690419308832)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.LOV.DEFAULT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104491707031308832)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.LOV.DEFAULT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\306E\80CC\666F\30DE\30C3\30D7\8A2D\5B9A\3092\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104491406746308832)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\80CC\666F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104269141507308660)
,p_name=>'PE.PROPERTY.TIME_FORMAT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\6642\9593\66F8\5F0F\306E\8868\793A\65B9\6CD5\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104428916870308779)
,p_name=>'PE.PROPERTY.TIME_FORMAT.LOV.12HOUR.D'
,p_message_language=>'ja'
,p_message_text=>unistr('12\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104429085993308779)
,p_name=>'PE.PROPERTY.TIME_FORMAT.LOV.24HOUR.D'
,p_message_language=>'ja'
,p_message_text=>unistr('24\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104269014414308660)
,p_name=>'PE.PROPERTY.TIME_FORMAT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6642\9593\66F8\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104757822951309048)
,p_name=>'PE.PROPERTY.TITLE.COMPONENT_PROPERTY.JET_CHART_AXES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\8EF8\306E\30BF\30A4\30C8\30EB\3092\5165\529B\3057\307E\3059\3002\3053\306E\30BF\30A4\30C8\30EB\3067\3001\30C1\30E3\30FC\30C8\306E\8EF8\306B\8868\793A\3055\308C\308B\60C5\5831\3092\8A18\8FF0\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103908509730308334)
,p_name=>'PE.PROPERTY.TITLE.COMPONENT_PROPERTY.PAGE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30E9\30A6\30B6\30FB\30A6\30A3\30F3\30C9\30A6\306E\30BF\30A4\30C8\30EB\30FB\30D0\30FC\306B\8868\793A\3059\308B\30BF\30A4\30C8\30EB\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002&PRODUCT_NAME.\30A8\30F3\30B8\30F3\306F\3001\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3067\4F7F\7528\3055\308C\308B<code>#TITLE#</code>\7F6E\63DB\6587\5B57\5217\306E\304B\308F\308A\306B\3001\3053\3053\3067\6307\5B9A\3057\305F\30BF\30A4\30C8\30EB\3092\4F7F\7528\3057\307E\3059\3002\3053\306E\30BF\30A4\30C8\30EB\306F\3001HTML\30BF\30B0<code>&lt;TITLE&gt;</code>\3068<code>&lt;/TITLE&gt;</code>\306E\9593\306B\633F\5165\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103909420485308335)
,p_name=>'PE.PROPERTY.TITLE.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\30FB\30BF\30A4\30C8\30EB\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002 \30EA\30FC\30B8\30E7\30F3\30FB\30BF\30A4\30C8\30EB\306F\3001\30EA\30FC\30B8\30E7\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306B\5B9A\7FA9\3055\308C\3066\3044\308B\5834\5408\306B\306E\307F\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103870891026308301)
,p_name=>'PE.PROPERTY.TITLE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30BF\30A4\30C8\30EB\3092\5165\529B\3057\307E\3059\3002\30DA\30FC\30B8\30FB\30BF\30A4\30C8\30EB\306F\3001\30D6\30E9\30A6\30B6\30FB\30A6\30A3\30F3\30C9\30A6\306E\30BF\30A4\30C8\30EB\30FB\30D0\30FC\306B\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103870745525308301)
,p_name=>'PE.PROPERTY.TITLE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30C8\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104566653520308892)
,p_name=>'PE.PROPERTY.TITLE_ADV_FORMATTING.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\3092\3001\5217\307E\305F\306FHTML\5F0F\304A\3088\3073\30B5\30DD\30FC\30C8\3055\308C\3066\3044\308B\7F6E\63DB\6587\5B57\5217\3092\4F7F\7528\3059\308B\62E1\5F35\30D5\30A9\30FC\30DE\30C3\30C8\306E\3044\305A\308C\3092\4F7F\7528\3057\3066\8868\793A\3059\308B\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104566531400308892)
,p_name=>'PE.PROPERTY.TITLE_ADV_FORMATTING.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\62E1\5F35\30D5\30A9\30FC\30DE\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104566801028308892)
,p_name=>'PE.PROPERTY.TITLE_COLUMN_NAME.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30C8\30EB\3068\3057\3066\4F7F\7528\3059\308B\5217\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104566722625308892)
,p_name=>'PE.PROPERTY.TITLE_COLUMN_NAME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104567357574308892)
,p_name=>'PE.PROPERTY.TITLE_CSS_CLASSES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\8FFD\52A0\3059\308B\30AF\30E9\30B9\3092\5165\529B\3057\307E\3059\3002\8907\6570\306E\30AF\30E9\30B9\306F\7A7A\767D\3067\533A\5207\3063\3066\8FFD\52A0\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104567230892308892)
,p_name=>'PE.PROPERTY.TITLE_CSS_CLASSES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('CSS\30AF\30E9\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104567186257308892)
,p_name=>'PE.PROPERTY.TITLE_HTML_EXPR.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>\30D0\30C3\30AF\30B0\30E9\30A6\30F3\30C9\304A\3088\3073\30C6\30AD\30B9\30C8\306E\8272\306E\5909\66F4</dt>'),
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>\30D8\30C3\30C0\30FC2\306E\4F7F\7528</dt>'),
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>SQL\554F\5408\305B\304B\3089\306E\52D5\7684\30AF\30E9\30B9\306E\4F7F\7528</dt>'),
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    \3053\306E\4F8B\3067<code>&COLUMN_CLASS.</code>\3068<code>&EMPLOYEE_STATUS.</code>\306B\4EE3\5165\3055\308C\308B\306E\306F\3001\30EC\30DD\30FC\30C8SQL\554F\5408\305B\3067\9078\629E\3055\308C\305F\5217\3067\3059\3002</dd>'),
unistr('  <dt>\30DB\30D0\30FC\3067\306E\30A4\30E1\30FC\30B8\304A\3088\3073\30C4\30FC\30EB\30C1\30C3\30D7\306E\8868\793A</dt>'),
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104567065021308892)
,p_name=>'PE.PROPERTY.TITLE_HTML_EXPR.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\5217\306B\8868\793A\3055\308C\308BHTML\5F0F\3092\5165\529B\3057\307E\3059\3002<code>&COLUMN.</code>\69CB\6587\3092\4F7F\7528\3057\3066\3001HTML\306B\5217\5024\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104566906243308892)
,p_name=>'PE.PROPERTY.TITLE_HTML_EXPR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('HTML\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104120192882308533)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C4\30FC\30EB\30D0\30FC\306B\8868\793A\3059\308B\8FFD\52A0\306E\30B3\30F3\30C8\30ED\30FC\30EB\3092\78BA\8A8D\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104120664910308534)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.ACTIONS_MENU.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104120775798308534)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.ACTIONS_MENU.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\901A\5E38\5305\62EC\7684\306A\30AA\30D7\30B7\30E7\30F3\306E\30BB\30C3\30C8\3092\542B\3080\300C\30A2\30AF\30B7\30E7\30F3\300D\30E1\30CB\30E5\30FC\30FB\30DC\30BF\30F3\3092\8868\793A\3057\307E\3059\3002\3053\308C\3089\306E\30AA\30D7\30B7\30E7\30F3\306B\3088\308A\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\3001\4F7F\7528\53EF\80FD\306A\6A5F\80FD\306B\57FA\3065\3044\3066\30EC\30DD\30FC\30C8\3092\30AB\30B9\30BF\30DE\30A4\30BA\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104120830471308534)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.RESET.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30BB\30C3\30C8\30FB\30DC\30BF\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104120941396308534)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.RESET.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\30EA\30BB\30C3\30C8\300D\30DC\30BF\30F3\3092\8868\793A\3057\307E\3059\3002\3053\306E\30DC\30BF\30F3\3092\62BC\3059\3068\3001\30D5\30A3\30EB\30BF\3001\5217\306E\5E45\3001\4E26\66FF\3048\306A\3069\306E\30AB\30B9\30BF\30DE\30A4\30BA\304C\524A\9664\3055\308C\3001\30B5\30FC\30D0\30FC\304B\3089\30EC\30DD\30FC\30C8\5B9A\7FA9\304C\30EA\30ED\30FC\30C9\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104121047325308534)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SAVE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\4FDD\5B58\30DC\30BF\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104121121205308534)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SAVE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\300C\4FDD\5B58\300D\30DC\30BF\30F3\3092\8868\793A\3057\307E\3059\3002\3053\306E\30DC\30BF\30F3\3092\62BC\3059\3068\3001\30DA\30FC\30B8\5168\4F53\3092\4FDD\5B58\305B\305A\306B\3053\306E\5BFE\8A71\30B0\30EA\30C3\30C9\306B\884C\308F\308C\305F\5909\66F4\306E\307F\304C\4FDD\5B58\3055\308C\307E\3059\3002'),
unistr('        <p>\5BFE\8A71\30B0\30EA\30C3\30C9\304C\7DE8\96C6\53EF\80FD\3067\3042\308A\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\8FFD\52A0\3001\66F4\65B0\307E\305F\306F\524A\9664\3059\308B\6A29\9650\304C\3042\308B\5834\5408\306E\307F\3001\4FDD\5B58\30DC\30BF\30F3\304C\8868\793A\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104120274190308533)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SEARCH_COLUMN.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22\5217\306E\9078\629E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104120304508308533)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SEARCH_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\3055\308C\308B\975E\6570\5024\5217\306E\30C9\30ED\30C3\30D7\30FB\30C0\30A6\30F3\30FB\30EA\30B9\30C8\304C\8868\793A\3055\308C\307E\3059\3002\5217\304C\9078\629E\3055\308C\308B\3068\3001\691C\7D22\306F\3001\9078\629E\3055\308C\305F\5217\5185\306E\5024\306B\5BFE\3057\3066\306E\307F\5B9F\884C\3055\308C\307E\3059\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104120485511308533)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SEARCH_FIELD.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22\30D5\30A3\30FC\30EB\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104120502909308533)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SEARCH_FIELD.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22\6761\4EF6\306E\5165\529B\306B\4F7F\7528\3059\308B\30C6\30AD\30B9\30C8\30FB\30D5\30A3\30FC\30EB\30C9\304C\691C\7D22\30D0\30FC\306B\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104120052709308533)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30C8\30ED\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104682639788308985)
,p_name=>'PE.PROPERTY.TREE_NAME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\540D\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104587119969308908)
,p_name=>'PE.PROPERTY.TREE_SQL_STATEMENT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C4\30EA\30FC\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104682718141308985)
,p_name=>'PE.PROPERTY.TREE_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104224526130308627)
,p_name=>'PE.PROPERTY.TZ_DEPENDENT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\5217\304C\30BF\30A4\30E0\30BE\30FC\30F3\306B\5BFE\5FDC\3057\3066\3044\308B\304B\3069\3046\304B\3092\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104224437939308627)
,p_name=>'PE.PROPERTY.TZ_DEPENDENT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30E0\30BE\30FC\30F3\306B\5BFE\5FDC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104257835904308651)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\3053\306E\30EC\30DD\30FC\30C8\5217\304C\53C2\7167\3059\308B\5217\540D\3092\9078\629E\3057\307E\3059\3002'),
unistr('\3053\306E\5C5E\6027\306F\3001\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\306E\30C7\30D5\30A9\30EB\30C8\5024\3092\4F7F\7528\3057\3066\5217\3078\306E\53C2\7167\3092\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\9593\3067\6BD4\8F03\3059\308B\305F\3081\306B\4F7F\7528\3055\308C\307E\3059\3002'),
unistr('\53EF\80FD\306A\5834\5408\3001\3053\306E\53C2\7167\306F\3001\30A6\30A3\30B6\30FC\30C9\3067\521D\671F\5316\3055\308C\305F\5F8C\3001\624B\52D5\3067\4FDD\6301\3055\308C\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104257722707308651)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104257626751308651)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_TABLE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\3053\306E\5217\304C\53C2\7167\3059\308B\8868\307E\305F\306F\30D3\30E5\30FC\3092\9078\629E\3057\307E\3059\3002'),
unistr('\3053\306E\5C5E\6027\306F\3001\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\306E\30C7\30D5\30A9\30EB\30C8\5024\3092\4F7F\7528\3057\3066\5217\3078\306E\53C2\7167\3092\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\9593\3067\6BD4\8F03\3059\308B\305F\3081\306B\4F7F\7528\3055\308C\307E\3059\3002'),
unistr('\53EF\80FD\306A\5834\5408\3001\3053\306E\53C2\7167\306F\3001\30A6\30A3\30B6\30FC\30C9\3067\521D\671F\5316\3055\308C\305F\5F8C\3001\624B\52D5\3067\4FDD\6301\3055\308C\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104257562522308651)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_TABLE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104257417141308651)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_TABLE_OWNER.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\53C2\7167\8868\3092\6240\6709\3059\308B\30B9\30AD\30FC\30DE\3092\9078\629E\3057\307E\3059\3002'),
unistr('\3053\306E\5C5E\6027\306F\3001\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\306E\30C7\30D5\30A9\30EB\30C8\5024\3092\4F7F\7528\3057\3066\5217\3078\306E\53C2\7167\3092\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\9593\3067\6BD4\8F03\3059\308B\5834\5408\306B\4F7F\7528\3055\308C\307E\3059\3002'),
unistr('\53EF\80FD\306A\5834\5408\3001\3053\306E\53C2\7167\306F\3001\30A6\30A3\30B6\30FC\30C9\3067\521D\671F\5316\3055\308C\305F\5F8C\3001\624B\52D5\3067\4FDD\6301\3055\308C\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104257352105308651)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_TABLE_OWNER.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\306E\6240\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104209302842308616)
,p_name=>'PE.PROPERTY.UNIQUELY_IDENTIFY_ROWS_BY.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30EA\30F3\30AF\5217\3092\4F7F\7528\3059\308B\5834\5408\306B\73FE\5728\306E\884C\306E\8B58\5225\306B\4F7F\7528\3055\308C\308B\5217\306E\30BF\30A4\30D7\3092\9078\629E\3057\307E\3059\3002'),
unistr('\30C7\30D5\30A9\30EB\30C8\3067\306F\3001<strong>ROWID</strong>\3092\4F7F\7528\3057\3066\30EC\30DD\30FC\30C8\5185\306E\884C\304C\4E00\610F\306B\8B58\5225\3055\308C\307E\3059\3002\305F\3060\3057\3001<strong>\300C\4E00\610F\5217\300D</strong>\3092\9078\629E\3057\3066\5225\306E\5217\3092\4F7F\7528\3059\308B\3053\3068\3082\3067\304D\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104409582503308764)
,p_name=>'PE.PROPERTY.UNIQUELY_IDENTIFY_ROWS_BY.LOV.COLUMN.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E00\610F\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104409431660308764)
,p_name=>'PE.PROPERTY.UNIQUELY_IDENTIFY_ROWS_BY.LOV.ROWID.D'
,p_message_language=>'ja'
,p_message_text=>'ROWID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104209279740308616)
,p_name=>'PE.PROPERTY.UNIQUELY_IDENTIFY_ROWS_BY.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E00\610F\306B\884C\3092\8B58\5225\3059\308B\57FA\6E96')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104209545409308617)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306E\884C\3092\4E00\610F\306B\8B58\5225\3059\308B\305F\3081\306B\4F7F\7528\3055\308C\308B1\3064\76EE\306E\5217\3092\9078\629E\3057\307E\3059\3002</p>'),
unistr('<p>\4E0B\4F4D\4E92\63DB\306E\305F\3081\306B<strong>ROWID</strong>\3082\4F7F\7528\53EF\80FD\306A\5217\306E\30EA\30B9\30C8\306B\542B\307E\308C\3066\3044\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8: <em>\300C\30EA\30F3\30AF\5217\300D</em>\5C5E\6027\304C<strong>\300C\5358\4E00\884C\30D3\30E5\30FC\3078\306E\30EA\30F3\30AF\300D</strong>\306B\8A2D\5B9A\3055\308C\3066\3044\308B\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\306E\5834\5408\3001\4E00\610F\306E\5217\30921\3064\306E\307F\9078\629E\3067\304D\307E\3059\3002\4ED6\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\3067\306F\3001\6700\59273\5217\306E\9078\629E\304C\30B5\30DD\30FC\30C8\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104209400402308616)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E00\610F\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104209743643308617)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN_2.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306E\884C\3092\4E00\610F\306B\8B58\5225\3059\308B\305F\3081\306B\4F7F\7528\3055\308C\308B2\3064\76EE\306E\5217\3092\9078\629E\3057\307E\3059\3002\8868\306B2\3064\306E\90E8\5206\304B\3089\6210\308B\4E3B\30AD\30FC\304C\3042\308B\5834\5408\3001\3053\306E\5C5E\6027\3092\4F7F\7528\3057\307E\3059\3002</p>'),
unistr('<p>\4E0B\4F4D\4E92\63DB\306E\305F\3081\306B<strong>ROWID</strong>\3082\4F7F\7528\53EF\80FD\306A\5217\306E\30EA\30B9\30C8\306B\542B\307E\308C\3066\3044\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104209660775308617)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN_2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E00\610F\52172')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104209957291308617)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN_3.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306E\884C\3092\4E00\610F\306B\8B58\5225\3059\308B\305F\3081\306B\4F7F\7528\3055\308C\308B3\3064\76EE\306E\5217\3092\9078\629E\3057\307E\3059\3002\8868\306B3\3064\306E\90E8\5206\304B\3089\6210\308B\4E3B\30AD\30FC\304C\3042\308B\5834\5408\3001\3053\306E\5C5E\6027\3092\4F7F\7528\3057\307E\3059\3002</p>'),
unistr('<p>\4E0B\4F4D\4E92\63DB\306E\305F\3081\306B<strong>ROWID</strong>\3082\4F7F\7528\53EF\80FD\306A\5217\306E\30EA\30B9\30C8\306B\542B\307E\308C\3066\3044\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8: \8868\306E\4E3B\30AD\30FC\304C3\5217\3088\308A\591A\3044\5834\5408\3001<strong>ROWID</strong>\306B\3088\3063\3066\884C\3092\4E00\610F\306B\8B58\5225\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104209878891308617)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN_3.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E00\610F\52173')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104097317168308514)
,p_name=>'PE.PROPERTY.UPDATE_AUTHORIZATION_SCHEME.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8A8D\53EF\30B9\30AD\30FC\30E0\3092\9078\629E\3057\3066\3001\884C\3092\66F4\65B0\3067\304D\308B\30E6\30FC\30B6\30FC\3092\5236\9650\3057\307E\3059\3002'),
unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\884C\3092\66F4\65B0\3059\308B\306B\306F\3001\3053\306E\8A8D\53EF\30B9\30AD\30FC\30E0\304C\305D\306E\30E6\30FC\30B6\30FC\306B\5BFE\3057\3066TRUE\3068\8A55\4FA1\3055\308C\308B\5FC5\8981\304C\3042\308A\307E\3059\3002'),
unistr('\8A8D\53EF\30B9\30AD\30FC\30E0\304C\6307\5B9A\3055\308C\306A\3044\5834\5408\3001\3059\3079\3066\306E\30E6\30FC\30B6\30FC\304C\3053\306E\5BFE\8A71\30B0\30EA\30C3\30C9\3067\884C\3092\66F4\65B0\3067\304D\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104097248315308514)
,p_name=>'PE.PROPERTY.UPDATE_AUTHORIZATION_SCHEME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F4\65B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103984859803308424)
,p_name=>'PE.PROPERTY.USER_INTERFACE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DA\30FC\30B8\306E\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103984750981308424)
,p_name=>'PE.PROPERTY.USER_INTERFACE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104019413827308450)
,p_name=>'PE.PROPERTY.USER_INTERFACE_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DA\30FC\30B8\306E\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\30FB\30BF\30A4\30D7\3092\9078\629E\3057\307E\3059\3002\4E3B\3068\3057\3066\30C7\30B9\30AF\30C8\30C3\30D7\3067\4F7F\7528\3059\308B\305F\3081\306B\8A2D\8A08\3059\308B\30DA\30FC\30B8\306E\5834\5408\306F<strong>\300C\30C7\30B9\30AF\30C8\30C3\30D7\300D</strong>\3092\9078\629E\3057\307E\3059\3002\30B9\30DE\30FC\30C8\30D5\30A9\30F3\3084\30BF\30D6\30EC\30C3\30C8\306A\3069\3001\305D\308C\4EE5\5916\306E\30A4\30F3\30BF\30D5\30A7\30FC\30B9\306E\5834\5408\306F\5BFE\5FDC\3059\308B\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104403687104308760)
,p_name=>'PE.PROPERTY.USER_INTERFACE_TYPE.LOV.DESKTOP.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30B9\30AF\30C8\30C3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104403705027308760)
,p_name=>'PE.PROPERTY.USER_INTERFACE_TYPE.LOV.JQM_SMARTPHONE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('jQuery Mobile\30B9\30DE\30FC\30C8\30D5\30A9\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104019382688308450)
,p_name=>'PE.PROPERTY.USER_INTERFACE_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\30FB\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104234522127308635)
,p_name=>'PE.PROPERTY.USE_AS_ROW_HEADER.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\5217\3092\884C\30D8\30C3\30C0\30FC\306B\3082\8868\793A\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002'),
unistr('\5217\5024\3092\542B\3081\308B\3068\3001\30EC\30DD\30FC\30C8\306B\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\308B\30D5\30A9\30FC\30E0\30FB\30D5\30A3\30FC\30EB\30C9\306E\30A2\30AF\30BB\30B7\30D3\30EA\30C6\30A3\304C\5927\5E45\306B\5411\4E0A\3057\307E\3059\3002'),
unistr('\6307\5B9A\3055\308C\308B\3068\3001\884C\30D8\30C3\30C0\30FC\304C\5217\30D8\30C3\30C0\30FC\3068\3068\3082\306B\4F7F\7528\3055\308C\3001<code>''&lt;Column Header&gt; : &lt;Row Header&gt;''</code>\3068\3044\3046\66F8\5F0F\3067\30EC\30DD\30FC\30C8\306E\30D5\30A9\30FC\30E0\30FB\30D5\30A3\30FC\30EB\30C9\306E\30E9\30D9\30EB\304C\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\307E\3059\3002</p>'),
unistr('<p>\305F\3068\3048\3070\3001EMP\8868\306E\30EC\30DD\30FC\30C8\3067\3001ENAME\5217\3092\884C\30D8\30C3\30C0\30FC\3068\3057\3066\5B9A\7FA9\3059\308B\3068\3057\307E\3059\3002ENAME\304CJONES\306E\884C\306E\5834\5408\3001\305D\306E\884C\306ESalary\30D5\30A3\30FC\30EB\30C9\306E\30E9\30D9\30EB\306F\3001"Salary : JONES"\306B\306A\308A\307E\3059\3002'),
unistr('\3053\306E\65B9\6CD5\306B\3088\308A\3001\30B9\30AF\30EA\30FC\30F3\30FB\30EA\30FC\30C0\30FC\306E\30E6\30FC\30B6\30FC\304C\3001\30EC\30DD\30FC\30C8\306E\30D5\30A9\30FC\30E0\30FB\30D5\30A3\30FC\30EB\30C9\3054\3068\306B\30CA\30D3\30B2\30FC\30C8\3067\304D\308B\3088\3046\306B\306A\308A\3001\3069\306E\30D5\30A9\30FC\30E0\30FB\30D5\30A3\30FC\30EB\30C9\304C\3069\306E\884C\306B\95A2\9023\3059\308B\304B\3082\628A\63E1\3067\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104234444917308635)
,p_name=>'PE.PROPERTY.USE_AS_ROW_HEADER.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\30D8\30C3\30C0\30FC\3068\3057\3066\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104262881185308655)
,p_name=>'PE.PROPERTY.USE_CUSTOM_ICON_VIEW.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3\30FB\30D3\30E5\30FC\306B\30AB\30B9\30BF\30E0\30FB\30EA\30F3\30AF\3092\5B9A\7FA9\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002\3053\306E\30AA\30D7\30B7\30E7\30F3\306B\3088\3063\3066\3001\8907\6570\306E\5217\3092\4F7F\7528\3059\308B\6A5F\80FD\306A\3069\3001\30A2\30A4\30B3\30F3\30FB\30D3\30E5\30FC\306E\30B3\30F3\30C6\30F3\30C4\3092\5B9A\7FA9\3059\308B\969B\306E\67D4\8EDF\6027\304C\5897\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104262734883308655)
,p_name=>'PE.PROPERTY.USE_CUSTOM_ICON_VIEW.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30B9\30BF\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103981992333308422)
,p_name=>'PE.PROPERTY.VALIDATION_REGION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\691C\8A3C\306B\5BFE\3057\3066\95A2\9023\4ED8\3051\3089\308C\308B\30EA\30FC\30B8\30E7\30F3\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103981823248308422)
,p_name=>'PE.PROPERTY.VALIDATION_REGION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7DE8\96C6\53EF\80FD\30EA\30FC\30B8\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103980402111308421)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\691C\8A3C\306B\5BFE\3057\3066\30C6\30B9\30C8\3059\308B\7B49\4FA1\306E\30BF\30A4\30D7\3092\9078\629E\3057\307E\3059\3002\9078\629E\306B\3088\3063\3066\306F\3001\3053\306E\691C\8A3C\3092\5B8C\5168\306B\5B9A\7FA9\3059\308B\305F\3081\306B1\3064\4EE5\4E0A\306E\8FFD\52A0\5C5E\6027\304C\5FC5\8981\3067\3059\3002</p>'),
unistr('<p>\691C\8A3C\304C\7B49\4FA1\30C6\30B9\30C8\3092\30D1\30B9\3057\305F\5834\5408\3001\307E\305F\306FTRUE\3068\8A55\4FA1\3055\308C\305F\5834\5408\3001\691C\8A3C\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\306F\8868\793A\3055\308C\307E\305B\3093\3002'),
unistr('\691C\8A3C\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\306F\3001\691C\8A3C\304C\7B49\4FA1\30C6\30B9\30C8\306B\5931\6557\3057\305F\5834\5408\3001FALSE\3068\8A55\4FA1\3055\308C\305F\5834\5408\3001\307E\305F\306F\7A7A\3067\306A\3044\30C6\30AD\30B9\30C8\6587\5B57\5217\304C\8FD4\3055\308C\305F\5834\5408\306B\8868\793A\3055\308C\307E\3059\3002</p>'),
unistr('<p>\691C\8A3C\306E\5931\6557\306B\3088\3063\3066\5F8C\7D9A\306E\691C\8A3C\304C\8A55\4FA1\3055\308C\306A\304F\306A\308B\3053\3068\306F\3042\308A\307E\305B\3093\3002\3057\305F\304C\3063\3066\3001\5F8C\7D9A\306E\5404\691C\8A3C\306B\3088\3063\3066\3055\3089\306B\691C\8A3C\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\304C\767A\751F\3059\308B\53EF\80FD\6027\304C\3042\308A\307E\3059\3002\5F8C\7D9A\306E\691C\8A3C\304C\5B9F\884C\3055\308C\306A\3044\3088\3046\306B\3059\308B\306B\306F\3001\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3092\7279\5B9A\306E\5024\306B\8A2D\5B9A\3057\3066\5F8C\7D9A\306E\691C\8A3C\306E\6761\4EF6\30ED\30B8\30C3\30AF\3092\5FC5\8981\306B\5FDC\3058\3066\5F37\5316\3059\308B\306A\3069\306E\8FFD\52A0\30ED\30B8\30C3\30AF\3092\3001\5931\6557\3057\305F\6700\521D\306E\691C\8A3C\306B\8FFD\52A0\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\5F8C\7D9A\306E\30D7\30ED\30BB\30B9\304A\3088\3073\30D6\30E9\30F3\30C1\306F\30011\3064\4EE5\4E0A\306E\691C\8A3C\304C\8A55\4FA1\306B\5931\6557\3059\308B\3068\5B9F\884C\3055\308C\307E\305B\3093\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104437154222308785)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.EXISTS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\304C\8FD4\3055\308C\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104437262583308785)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.EXISTS.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('SQL\554F\5408\305B\304C\884C\30921\884C\4EE5\4E0A\8FD4\3059\5834\5408\306F\30D1\30B9\3057\307E\3059\3002<br>'),
unistr('SQL\554F\5408\305B\304C\884C\3092\8FD4\3055\306A\3044\5834\5408\306F\5931\6557\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104643333555308954)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104643420038308954)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5F0F\304CTRUE\3068\8A55\4FA1\3055\308C\308B\5834\5408\306F\30D1\30B9\3057\307E\3059\3002<br>'),
unistr('\5F0F\304CFALSE\3068\8A55\4FA1\3055\308C\308B\5834\5408\306F\5931\6557\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104437796559308785)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_BOOLEAN.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53(\30D6\30FC\30EB\3092\8FD4\3059)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104437803763308786)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\304CTRUE\3092\8FD4\3059\5834\5408\306F\30D1\30B9\3057\307E\3059\3002<br>'),
unistr('\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\304CFALSE\3092\8FD4\3059\5834\5408\306F\5931\6557\3057\307E\3059\3002<br>'),
unistr('\30CE\30FC\30C8: \30D5\30A1\30F3\30AF\30B7\30E7\30F3\304B\3089\8FD4\3055\308C\308B\7D50\679C\306F\30D6\30FC\30EB\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104437981268308786)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_ERR_TEXT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53(\30A8\30E9\30FC\30FB\30C6\30AD\30B9\30C8\3092\8FD4\3059)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104438051617308786)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_ERR_TEXT.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\304C\7A7A\306E\6587\5B57\5217\3092\8FD4\3059\5834\5408\306F\30D1\30B9\3057\307E\3059\3002<br>'),
unistr('\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\304C\7A7A\3067\306A\3044\6587\5B57\5217\3092\8FD4\3059\5834\5408\306F\5931\6557\3057\307E\3059\3002\8FD4\3055\308C\308B\6587\5B57\5217\306F\3001\691C\8A3C\306E\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\3068\3057\3066\8868\793A\3055\308C\307E\3059\3002<br>'),
unistr('\30CE\30FC\30C8: \30D5\30A1\30F3\30AF\30B7\30E7\30F3\304B\3089\8FD4\3055\308C\308B\7D50\679C\306F\30C6\30AD\30B9\30C8\6587\5B57\5217\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104438730907308786)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306B\7A7A\767D\304C\542B\307E\308C\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104438815106308786)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30A2\30A4\30C6\30E0\5024\306B\7A7A\767D\304C\542B\307E\308C\306A\3044\5834\5408\306F\30D1\30B9\3057\307E\3059\3002<br>'),
unistr('\30A2\30A4\30C6\30E0\5024\306B\7A7A\767D\304C\542B\307E\308C\308B\5834\5408\306F\5931\6557\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104440736930308788)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_AT_LEAST_ONE_CHAR_IN_STRING2.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306B\5024\306E\6587\5B57\304C1\3064\4EE5\4E0A\542B\307E\308C\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104440811259308788)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_AT_LEAST_ONE_CHAR_IN_STRING2.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30A2\30A4\30C6\30E0\5024\306B<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\306E\6587\5B57\304C1\3064\4EE5\4E0A\542B\307E\308C\308B\5834\5408\306F\30D1\30B9\3057\307E\3059\3002<br>'),
unistr('\30A2\30A4\30C6\30E0\5024\306B<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\306E\6587\5B57\304C\542B\307E\308C\306A\3044\5834\5408\306F\5931\6557\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104440920125308788)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306B\5024\306E\6587\5B57\304C\542B\307E\308C\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104441076031308788)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30A2\30A4\30C6\30E0\5024\306B<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\306E\6587\5B57\304C\542B\307E\308C\306A\3044\5834\5408\306F\30D1\30B9\3057\307E\3059\3002<br>'),
unistr('\30A2\30A4\30C6\30E0\5024\306B<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\306E\6587\5B57\304C1\3064\4EE5\4E0A\542B\307E\308C\308B\5834\5408\306F\5931\6557\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104440597702308788)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_ONLY_CHAR_IN_STRING2.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306B\5024\306B\6307\5B9A\3057\305F\6587\5B57\306E\307F\542B\307E\308C\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104440646590308788)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_ONLY_CHAR_IN_STRING2.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30A2\30A4\30C6\30E0\5024\306B<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\5185\306E\6587\5B57\306E\307F\304C\542B\307E\308C\308B\5834\5408\306F\30D1\30B9\3057\307E\3059\3002<br>'),
unistr('\30A2\30A4\30C6\30E0\5024\306B<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\4EE5\5916\306E\6587\5B57\304C\542B\307E\308C\308B\5834\5408\306F\5931\6557\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104439797630308787)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_EQ_STRING2.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0 = \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104439816350308787)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_EQ_STRING2.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30A2\30A4\30C6\30E0\5024\304C<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\3068\7B49\3057\3044\5834\5408\306F\30D1\30B9\3057\307E\3059\3002<br>'),
unistr('\30A2\30A4\30C6\30E0\5024\304C<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\3068\7B49\3057\304F\306A\3044\5834\5408\306F\5931\6557\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104440159751308787)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_IN_STRING2.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306F\5024\306B\542B\307E\308C\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104440206615308787)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_IN_STRING2.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30A2\30A4\30C6\30E0\5024\304C<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\306B\5B8C\5168\306B\542B\307E\308C\308B\5834\5408\306F\30D1\30B9\3057\307E\3059\3002<br>'),
unistr('\30A2\30A4\30C6\30E0\5024\304C<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\306B\5B8C\5168\306B\306F\542B\307E\308C\306A\3044\5834\5408\306F\5931\6557\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104439939847308787)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_EQ_STRING2.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0 != \5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104440067155308787)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_EQ_STRING2.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30A2\30A4\30C6\30E0\5024\304C<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\3068\7B49\3057\304F\306A\3044\5834\5408\306F\30D1\30B9\3057\307E\3059\3002<br>'),
unistr('\30A2\30A4\30C6\30E0\5024\304C<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\3068\7B49\3057\3044\5834\5408\306F\5931\6557\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104440351789308787)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_IN_STRING2.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306F\5024\306B\542B\307E\308C\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104440467800308788)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_IN_STRING2.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30A2\30A4\30C6\30E0\5024\304C<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\306B\5B8C\5168\306B\306F\542B\307E\308C\306A\3044\5834\5408\306F\30D1\30B9\3057\307E\3059\3002<br>'),
unistr('\30A2\30A4\30C6\30E0\5024\304C<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\30C6\30AD\30B9\30C8\306B\5B8C\5168\306B\542B\307E\308C\308B\5834\5408\306F\5931\6557\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104438906741308786)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306F\82F1\6570\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104439037593308786)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30A2\30A4\30C6\30E0\5024\304C\82F1\6570\5B57\3067\6587\5B57\3068\6570\5B57\306E\307F\304C\542B\307E\308C\3001\7279\6B8A\6587\5B57\304C\542B\307E\308C\306A\3044\5834\5408\306F\30D1\30B9\3057\307E\3059\3002<br>'),
unistr('\30A2\30A4\30C6\30E0\5024\306B\7279\6B8A\6587\5B57\304C\542B\307E\308C\308B\5834\5408\306F\5931\6557\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104439340382308787)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_DATE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306F\6709\52B9\306A\65E5\4ED8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104439486663308787)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_DATE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30A2\30A4\30C6\30E0\5024\304C\6709\52B9\306A\65E5\4ED8\306E\5834\5408\306F\30D1\30B9\3057\307E\3059\3002<br>'),
unistr('\30A2\30A4\30C6\30E0\5024\304C\6709\52B9\306A\65E5\4ED8\3067\306A\3044\5834\5408\306F\5931\6557\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104439178051308787)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306F\6570\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104439211774308787)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30A2\30A4\30C6\30E0\5024\304C\6570\5B57\306E\5834\5408\306F\30D1\30B9\3057\307E\3059\3002<br>'),
unistr('\30A2\30A4\30C6\30E0\5024\306B\6570\5B57\4EE5\5916\306E\6587\5B57(\5148\982D\306E\7A7A\767D\4EE5\5916\306E\7A7A\767D\3092\542B\3080)\304C\542B\307E\308C\308B\5834\5408\306F\5931\6557\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104439501906308787)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_TIMESTAMP.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306F\6709\52B9\306A\30BF\30A4\30E0\30B9\30BF\30F3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104439647785308787)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_TIMESTAMP.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30A2\30A4\30C6\30E0\5024\304C\6709\52B9\306A\30BF\30A4\30E0\30B9\30BF\30F3\30D7\306E\5834\5408\306F\30D1\30B9\3057\307E\3059\3002<br>'),
unistr('\30A2\30A4\30C6\30E0\5024\304C\6709\52B9\306A\30BF\30A4\30E0\30B9\30BF\30F3\30D7\3067\306A\3044\5834\5408\306F\5931\6557\3057\307E\3059\3002')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104438160093308786)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_NULL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306FNULL\3067\306F\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104438233178308786)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_NULL.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30A2\30A4\30C6\30E0\5024\304C\7A7A\3067\306A\3044\5834\5408\306F\30D1\30B9\3057\307E\3059\3002<br>'),
unistr('\30A2\30A4\30C6\30E0\5024\304C\7A7A\306E\5834\5408\306F\5931\6557\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104438355313308786)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306FNULL\3067\306A\304F\30010(\30BC\30ED)\3067\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104438441185308786)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30A2\30A4\30C6\30E0\5024\304C\7A7A\3067\306A\304F\30010(\30BC\30ED)\3067\306A\3044\5834\5408\306F\30D1\30B9\3057\307E\3059\3002<br>'),
unistr('\30A2\30A4\30C6\30E0\5024\304C\7A7A\307E\305F\306F0(\30BC\30ED)\306E\5834\5408\306F\5931\6557\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104438541022308786)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_ZERO.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306F0(\30BC\30ED)\3067\306F\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104438691263308786)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_ZERO.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30A2\30A4\30C6\30E0\5024\304C0(\30BC\30ED)\3067\306A\3044\5834\5408\306F\30D1\30B9\3057\307E\3059\3002<br>'),
unistr('\30A2\30A4\30C6\30E0\5024\304C0(\30BC\30ED)\306E\5834\5408\306F\5931\6557\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104437372168308785)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.NOT_EXISTS.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\304C\8FD4\3055\308C\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104437480902308785)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('SQL\554F\5408\305B\304C\884C\3092\8FD4\3055\306A\3044\5834\5408\306F\30D1\30B9\3057\307E\3059\3002<br>'),
unistr('SQL\554F\5408\305B\304C\884C\30921\884C\4EE5\4E0A\8FD4\3059\5834\5408\306F\5931\6557\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104437514731308785)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.PLSQL_ERROR.D'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\30A8\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104437675032308785)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.PLSQL_ERROR.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('PL/SQL\30B3\30FC\30C9\304C\30A8\30E9\30FC\306B\306A\3089\305A\306B\5B9F\884C\3055\308C\308B\5834\5408\306F\30D1\30B9\3057\307E\3059\3002<br>'),
unistr('PL/SQL\5F0F\304C\5B9F\884C\6642\306B\30A8\30E9\30FC\306B\306A\308B\5834\5408\306F\5931\6557\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104441117254308788)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.REGULAR_EXPRESSION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306F\6B63\898F\8868\73FE\306B\4E00\81F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104441245731308788)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.REGULAR_EXPRESSION.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30A2\30A4\30C6\30E0\5024\304C<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\6B63\898F\8868\73FE\306B\4E00\81F4\3059\308B\5834\5408\306F\30D1\30B9\3057\307E\3059\3002'),
unistr('\30A2\30A4\30C6\30E0\5024\304C<em>\300C\5024\300D</em>\5C5E\6027\306B\5165\529B\3057\305F\6B63\898F\8868\73FE\306B\4E00\81F4\3057\306A\3044\5834\5408\306F\5931\6557\3057\307E\3059\3002<br>'),
unistr('\30CE\30FC\30C8: \6B63\898F\8868\73FE\306B\3088\3063\3066\3001\6587\5B57\3092\76F4\63A5\6BD4\8F03\3059\308B\306E\3067\306F\306A\304F\3001\6A19\6E96\5316\3055\308C\305F\69CB\6587\898F\5247\3092\4F7F\7528\3057\3066\6587\5B57\5217\30C7\30FC\30BF\3067\30D1\30BF\30FC\30F3\3092\691C\7D22\3067\304D\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103980335096308421)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104165567835308580)
,p_name=>'PE.PROPERTY.VALUE_BASELINE_SCALING.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\8EF8\30D9\30FC\30B9\30E9\30A4\30F3\304C\30C7\30FC\30BF\306E\6700\5C0F\5024\3067\59CB\307E\308B\304B\3001\30BC\30ED\3067\59CB\307E\308B\304B\3092\9078\629E\3057\307E\3059\3002\6570\5024\306E\30C7\30FC\30BF\8EF8\306B\306E\307F\9069\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104165605477308580)
,p_name=>'PE.PROPERTY.VALUE_BASELINE_SCALING.LOV.MIN.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104165759659308580)
,p_name=>'PE.PROPERTY.VALUE_BASELINE_SCALING.LOV.ZERO.D'
,p_message_language=>'ja'
,p_message_text=>unistr('0(\30BC\30ED)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104165453543308580)
,p_name=>'PE.PROPERTY.VALUE_BASELINE_SCALING.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D9\30FC\30B9\30E9\30A4\30F3\30FB\30B9\30B1\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104197297346308607)
,p_name=>'PE.PROPERTY.VALUE_COLLECTION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30EC\30AF\30B7\30E7\30F3\540D\3092\5165\529B\3057\307E\3059\3002\3053\306E\30D1\30E9\30E1\30FC\30BF\5024\306E\30BD\30FC\30B9\306F\3001\30B3\30EC\30AF\30B7\30E7\30F3\306E\6700\521D\306E\884C\304B\3089\306ECLOB\5217\306E\5024\306B\57FA\3065\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104197128080308607)
,p_name=>'PE.PROPERTY.VALUE_COLLECTION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\540D\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104151842990308568)
,p_name=>'PE.PROPERTY.VALUE_CURRENCY.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30C1\30E3\30FC\30C8\306E\5024\3092\66F8\5F0F\8A2D\5B9A\3059\308B\5834\5408\306B\4F7F\7528\3059\308B\901A\8CA8\3092\5165\529B\3057\307E\3059\3002'),
unistr('        \5024\306F\3001\30A2\30EB\30D5\30A1\30D9\30C3\30C8\306EISO 4217\901A\8CA8\30B3\30FC\30C9\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\66F8\5F0F\304C\901A\8CA8\306B\8A2D\5B9A\3055\308C\3066\3044\3066\3001\901A\8CA8\304C\3001<strong>\901A\8CA8<strong>\30D7\30ED\30D1\30C6\30A3\306B\6307\5B9A\3055\308C\3066\3044\306A\3044\5834\5408\3001\901A\8CA8\306F\3001\30C1\30E3\30FC\30C8\306E\30EC\30F3\30C0\30EA\30F3\30B0\6642\306B\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\8A00\8A9E\304B\3089\81EA\52D5\7684\306B\5C0E\51FA\3055\308C\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104151736883308568)
,p_name=>'PE.PROPERTY.VALUE_CURRENCY.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\901A\8CA8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104277960376308666)
,p_name=>'PE.PROPERTY.VALUE_DECIMAL_PLACES.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\306E\6570\5024\306B\9069\7528\3059\308B\5C0F\6570\70B9\306E\4F4D\7F6E\306E\6570\5024\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104265547239308657)
,p_name=>'PE.PROPERTY.VALUE_DECIMAL_PLACES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024\30E9\30D9\30EB\306B\4F7F\7528\3059\308B\5C0F\6570\70B9\306E\4F4D\7F6E\306E\6570\5024\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104265486202308657)
,p_name=>'PE.PROPERTY.VALUE_DECIMAL_PLACES.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C0F\6570\70B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104654232524308962)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F\5F0F\306E\8A55\4FA1\306B\4F7F\7528\3055\308C\308B\8A00\8A9E\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104654670395308963)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'ja'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104654538240308963)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'ja'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104654453733308962)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'ja'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104654773193308963)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'ja'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104654360945308962)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'ja'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104654154993308962)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A00\8A9E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104152255887308568)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\306E\5024\306E\30B9\30B1\30FC\30EB\52D5\4F5C\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104152478850308568)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.AUTO.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104152759117308569)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.BILLION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('10\5104')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104152625094308569)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.MILLION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('100\4E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104152364634308568)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.NONE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104152925375308569)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.QUADRILLION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('1000\5146')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104152543490308568)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.THOUSAND.D'
,p_message_language=>'ja'
,p_message_text=>'1000'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104152821380308569)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.TRILLION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('1\5146')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104152166319308568)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F8\5F0F\30B9\30B1\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104277805186308666)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30C1\30E3\30FC\30C8\306E\5024\306B\9069\7528\3055\308C\308B\66F8\5F0F\8A2D\5B9A\306E\30BF\30A4\30D7\3092\6307\5B9A\3057\307E\3059\3002'),
unistr('        \66F8\5F0F<strong>\300C\5C0F\6570\300D</strong>\3001<strong>\300C\30D1\30FC\30BB\30F3\30C8\300D</strong>\307E\305F\306F<strong>\300C\901A\8CA8\300D</strong>\306F\3001\6570\5024\306B\306E\307F\9069\7528\3055\308C\307E\3059\3002'),
unistr('        <strong>\300C\65E5\4ED8\300D</strong>\3001<strong>\300C\6642\9593\300D</strong>\304A\3088\3073<strong>\300C\65E5\6642\300D</strong>\66F8\5F0F\306F\3001\30C1\30E3\30FC\30C8\306E\305D\306E\30C7\30FC\30BF\578B\306E\5024\306B\306E\307F\9069\7528\3055\308C\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104150240565308567)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\306E\5024\306B\9069\7528\3055\308C\308B\66F8\5F0F\8A2D\5B9A\306E\6570\5024\3001\65E5\4ED8\307E\305F\306F\6642\9593\30BF\30A4\30D7\3092\9078\629E\3057\307E\3059\3002\65E5\4ED8\307E\305F\306F\6642\9593\306E\66F8\5F0F\8A2D\5B9A\3067\306F\3001\30C1\30E3\30FC\30C8\5C5E\6027<strong>\300C\6642\9593\8EF8\30BF\30A4\30D7\300D</strong>\304C\30C1\30E3\30FC\30C8\30FB\30C7\30FC\30BF\306B\5FDC\3058\3066\6B21\306E\3044\305A\308C\304B\306E\5024\306B\8A2D\5B9A\3055\308C\3066\3044\308B\3053\3068\3092\78BA\8A8D\3057\307E\3059: <strong>\300C\6709\52B9\300D</strong>\3001<strong>\300C\6DF7\5408\983B\5EA6\300D</strong>\307E\305F\306F<strong>\300C\9593\9694\306E\30B9\30AD\30C3\30D7\300D</strong>\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104151518989308568)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.CURRENCY.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\901A\8CA8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104288861560308674)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.CURRENCY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\6570\5024\304C\901A\8CA8\3068\3057\3066\66F8\5F0F\8A2D\5B9A\3055\308C\308B\3068\3001\6570\5024\3092\66F8\5F0F\8A2D\5B9A\3059\308B\3068\304D\306B\4F7F\7528\3055\308C\308B\901A\8CA8\3092\6307\5B9A\3059\308B\305F\3081\306B\901A\8CA8\30D7\30ED\30D1\30C6\30A3\3092\8A2D\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104150640480308567)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-FULL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5\4ED8 - \5B8C\5168')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104287797759308673)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-FULL.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\65E5\4ED8\304C\5B8C\5168\3068\3057\3066\66F8\5F0F\8A2D\5B9A\3055\308C\308B\3068\3001\66F8\5F0F\8A2D\5B9A\3055\308C\305F\65E5\4ED8\306B\306F\3001\9577\3044\5E73\65E5(EEEE)\3001\5E74(y)\3001\9577\3044\6708(MMMM)\3001\65E5(d)\304C\542B\307E\308C\307E\3059\3002\305F\3068\3048\3070\3001Wednesday, January 6, 2016\306A\3069\3067\3059\3002'),
unistr('        \8A00\8A9E\306B\3088\3063\3066\306F\3001\9577\3044\6708\304C\4F7F\7528\3055\308C\307E\305B\3093\3002\305F\3068\3048\3070\3001\65E5\672C\8A9E\306E\6570\5024\306E\6708\306F\30D1\30BF\30FC\30F3\3067\4F7F\7528\3055\308C\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104150539255308567)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-LONG.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5\4ED8 - \9577')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104287693984308673)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-LONG.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5\4ED8\304C\9577\3068\3057\3066\66F8\5F0F\8A2D\5B9A\3055\308C\308B\3068\3001\66F8\5F0F\8A2D\5B9A\3055\308C\305F\65E5\4ED8\306B\306F\3001\5E74\3001\9577\3044\6708\3001\65E5\304C\542B\307E\308C\307E\3059\3002\305F\3068\3048\3070\3001January 6, 2016\306A\3069\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104150401022308567)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-MEDIUM.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5\4ED8 - \4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104287546498308673)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-MEDIUM.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\65E5\4ED8\304C\4E2D\3068\3057\3066\66F8\5F0F\8A2D\5B9A\3055\308C\308B\3068\3001\66F8\5F0F\8A2D\5B9A\3055\308C\305F\65E5\4ED8\306B\306F\3001\5E74\3001\7701\7565\5F62\306E\6708(MMM)\3001\65E5\304C\542B\307E\308C\307E\3059\3002\305F\3068\3048\3070\3001Jan 6, 2016\306A\3069\3067\3059\3002'),
unistr('        \8A00\8A9E\306B\3088\3063\3066\306F\3001\7701\7565\5F62\306E\6708\304C\4F7F\7528\3055\308C\307E\305B\3093\3002\305D\306E\5834\5408\3001\4E2D\66F8\5F0F\3067\306F\6570\5024\306E\6708(MM/M)\304C\542B\307E\308C\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104150351211308567)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-SHORT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5\4ED8 - \77ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104287466758308673)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-SHORT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5\4ED8\304C\77ED\3068\3057\3066\66F8\5F0F\8A2D\5B9A\3055\308C\308B\3068\3001\66F8\5F0F\8A2D\5B9A\3055\308C\305F\65E5\4ED8\306B\306F\3001\5E74\3001\6570\5024\306E\6708(MM/M)\3001\65E5\304C\542B\307E\308C\307E\3059\3002\305F\3068\3048\3070\30011/6/16\306A\3069\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104288510496308673)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-FULL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('DateTime - \5B8C\5168')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104288617267308674)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-FULL.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\65E5\6642\304C\5B8C\5168\3068\3057\3066\66F8\5F0F\8A2D\5B9A\3055\308C\308B\3068\3001\66F8\5F0F\8A2D\5B9A\3055\308C\305F\65E5\6642\306B\306F\3001\9577\3044\5E73\65E5(EEEE)\3001\5E74(y)\3001\9577\3044\6708(MMMM)\3001\65E5(d)\3001\6642\9593(h/H)\3001\5206(mm)\3001\79D2(ss)\304A\3088\3073\30BE\30FC\30F3(zzzz)\304C\542B\307E\308C\307E\3059\3002\305F\3068\3048\3070\3001Wednesday, January 6, 2016 7 h 30 min 21 s\306A\3069\3067\3059\3002'),
unistr('        \6642\9593\66F8\5F0F\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\8A00\8A9E\304C12\6642\9593\5358\4F4D\3092\4F7F\7528\3059\308B\304B\3069\3046\304B\306B\3088\3063\3066\7570\306A\308A\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104151332814308568)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-LONG.D'
,p_message_language=>'ja'
,p_message_text=>unistr('DateTime - \9577')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104288472480308673)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-LONG.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\65E5\6642\304C\9577\3068\3057\3066\66F8\5F0F\8A2D\5B9A\3055\308C\308B\3068\3001\66F8\5F0F\8A2D\5B9A\3055\308C\305F\65E5\6642\306B\306F\3001\5E74\3001\9577\3044\6708\3001\65E5\3001\6642\9593\3001\5206\3001\79D2\304A\3088\3073\30BE\30FC\30F3(z)\304C\542B\307E\308C\307E\3059\3002\305F\3068\3048\3070\3001Jan 6, 2016 7:30:21 AM\306A\3069\3067\3059\3002'),
unistr('        \6642\9593\66F8\5F0F\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\8A00\8A9E\304C12\6642\9593\5358\4F4D\3092\4F7F\7528\3059\308B\304B\3069\3046\304B\306B\3088\3063\3066\7570\306A\308A\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104151299338308568)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-MEDIUM.D'
,p_message_language=>'ja'
,p_message_text=>unistr('DateTime - \4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104288352040308673)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-MEDIUM.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\65E5\6642\304C\4E2D\3068\3057\3066\66F8\5F0F\8A2D\5B9A\3055\308C\308B\3068\3001\66F8\5F0F\8A2D\5B9A\3055\308C\305F\65E5\6642\306B\306F\3001\5E74\3001\7701\7565\5F62\306E\6708(MMM)\3001\65E5\3001\6642\9593\3001\5206\3001\79D2\304A\3088\3073\30BE\30FC\30F3(z)\304C\542B\307E\308C\307E\3059\3002\305F\3068\3048\3070\3001Jan 6, 2016 7:30:21 AM\306A\3069\3067\3059\3002'),
unistr('        \6642\9593\66F8\5F0F\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\8A00\8A9E\304C12\6642\9593\5358\4F4D\3092\4F7F\7528\3059\308B\304B\3069\3046\304B\306B\3088\3063\3066\7570\306A\308A\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104151189841308567)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-SHORT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('DateTime - \77ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104288276847308673)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-SHORT.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\65E5\6642\304C\77ED\3068\3057\3066\66F8\5F0F\8A2D\5B9A\3055\308C\308B\3068\3001\66F8\5F0F\8A2D\5B9A\3055\308C\305F\65E5\6642\306B\306F\3001\5E74\3001\6570\5024\306E\6708(MM/M)\3001\65E5\3001\6642\9593\3001\5206\304C\542B\307E\308C\307E\3059\3002\305F\3068\3048\3070\30011/6/16 7:30 AM\306A\3069\3067\3059\3002'),
unistr('        \6642\9593\66F8\5F0F\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\8A00\8A9E\304C12\6642\9593\5358\4F4D\3092\4F7F\7528\3059\308B\304B\3069\3046\304B\306B\3088\3063\3066\7570\306A\308A\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104151403383308568)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DECIMAL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C0F\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104288750370308674)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DECIMAL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\6570\5024\304C\5C0F\6570\3068\3057\3066\66F8\5F0F\8A2D\5B9A\3055\308C\308B\3068\3001\5C0F\6570\70B9\306E\8A18\53F7\304C\30ED\30B1\30FC\30EB\306E\6700\9069\306A\8A18\53F7\306B\7F6E\63DB\3055\308C\307E\3059\3002\82F1\8A9E\306F\5C0F\6570\70B9(".")\3067\3001\591A\304F\306E\30ED\30B1\30FC\30EB\306F\5C0F\6570\30B3\30F3\30DE(",")\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104151632367308568)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.PERCENT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5272\5408')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104288941125308674)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.PERCENT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\6570\5024\304C\30D1\30FC\30BB\30F3\30C8\3068\3057\3066\66F8\5F0F\8A2D\5B9A\3055\308C\308B\3068\3001\30C1\30E3\30FC\30C8\306E\5024\306B100\304C\4E57\7B97\3055\308C\3001\30D1\30FC\30BB\30F3\30C8\3068\3057\3066\66F8\5F0F\8A2D\5B9A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104151049462308567)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-FULL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6642\9593 - \5B8C\5168')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104288163054308673)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-FULL.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6642\9593\304C\5B8C\5168\3068\3057\3066\66F8\5F0F\8A2D\5B9A\3055\308C\308B\3068\3001\66F8\5F0F\8A2D\5B9A\3055\308C\305F\6642\9593\306B\306F\3001\6642\9593(h/H)\3001\5206(mm)\3001\79D2(ss)\304A\3088\3073\30BE\30FC\30F3(zzzz)\304C\542B\307E\308C\307E\3059\3002\305F\3068\3048\3070\30017 h 30 min 21 s\306A\3069\3067\3059\3002'),
unistr('        \6642\9593\66F8\5F0F\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\8A00\8A9E\304C12\6642\9593\5358\4F4D\3092\4F7F\7528\3059\308B\304B\3069\3046\304B\306B\3088\3063\3066\7570\306A\308A\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104150993347308567)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-LONG.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6642\9593 - \9577')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104288025030308673)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-LONG.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6642\9593\304C\9577\3068\3057\3066\66F8\5F0F\8A2D\5B9A\3055\308C\308B\3068\3001\66F8\5F0F\8A2D\5B9A\3055\308C\305F\6642\9593\306B\306F\3001\6642\9593\3001\5206\3001\79D2\304A\3088\3073\30BE\30FC\30F3(z)\304C\542B\307E\308C\307E\3059\3002\305F\3068\3048\3070\30017:30:21 AM\306A\3069\3067\3059\3002'),
unistr('        \6642\9593\66F8\5F0F\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\8A00\8A9E\304C12\6642\9593\5358\4F4D\3092\4F7F\7528\3059\308B\304B\3069\3046\304B\306B\3088\3063\3066\7570\306A\308A\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104150886787308567)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-MEDIUM.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6642\9593 - \4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104287932326308673)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-MEDIUM.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6642\9593\304C\4E2D\3068\3057\3066\66F8\5F0F\8A2D\5B9A\3055\308C\308B\3068\3001\66F8\5F0F\8A2D\5B9A\3055\308C\305F\6642\9593\306B\306F\3001\6642\9593\3001\5206\3001\79D2\304C\542B\307E\308C\307E\3059\3002\305F\3068\3048\3070\30017:30:21 AM\306A\3069\3067\3059\3002'),
unistr('        \6642\9593\66F8\5F0F\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\8A00\8A9E\304C12\6642\9593\5358\4F4D\3092\4F7F\7528\3059\308B\304B\3069\3046\304B\306B\3088\3063\3066\7570\306A\308A\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104150781404308567)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-SHORT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6642\9593 - \77ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104287894095308673)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-SHORT.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6642\9593\304C\77ED\3068\3057\3066\66F8\5F0F\8A2D\5B9A\3055\308C\308B\3068\3001\66F8\5F0F\8A2D\5B9A\3055\308C\305F\6642\9593\306B\306F\3001\6642\9593\3001\5206\304C\542B\307E\308C\307E\3059\3002\305F\3068\3048\3070\30017:30 AM\306A\3069\3067\3059\3002'),
unistr('        \6642\9593\66F8\5F0F\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\8A00\8A9E\304C12\6642\9593\5358\4F4D\3092\4F7F\7528\3059\308B\304B\3069\3046\304B\306B\3088\3063\3066\7570\306A\308A\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104150174765308567)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F8\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104656206345308964)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\306E\5B9F\884C\306B\4F7F\7528\3055\308C\308B\8A00\8A9E\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104656586453308964)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'ja'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104656431535308964)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'ja'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104656329634308964)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'ja'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104656633299308964)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'ja'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104656186242308964)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A00\8A9E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104194116647308605)
,p_name=>'PE.PROPERTY.VALUE_ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\3053\306E\30D1\30E9\30E1\30FC\30BF\5024\306E\30BD\30FC\30B9\3068\3057\3066\4F7F\7528\3055\308C\308B\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002'),
unistr('\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104194025985308605)
,p_name=>'PE.PROPERTY.VALUE_ITEM.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104655830384308964)
,p_name=>'PE.PROPERTY.VALUE_JAVA_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30D1\30E9\30E1\30FC\30BF\5024\306E\30BD\30FC\30B9\3068\3057\3066\4F7F\7528\3055\308C\308B\5024\3092\751F\6210\3059\308BJava\5F0F\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104655752850308963)
,p_name=>'PE.PROPERTY.VALUE_JAVA_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('Java\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104657421008308965)
,p_name=>'PE.PROPERTY.VALUE_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30D1\30E9\30E1\30FC\30BF\5024\306E\30BD\30FC\30B9\3068\3057\3066\4F7F\7528\3055\308C\308B\5024\3092\8FD4\3059Java\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104657359196308965)
,p_name=>'PE.PROPERTY.VALUE_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('Java\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104655625850308963)
,p_name=>'PE.PROPERTY.VALUE_JS_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3059\308B\304B\3001\30DE\30CD\30FC\30B8\30E3\3067\3042\308B\5834\5408\3001YES\3092\8FD4\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" ? "YES" : "NO" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104655504883308963)
,p_name=>'PE.PROPERTY.VALUE_JS_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30D1\30E9\30E1\30FC\30BF\5024\306E\30BD\30FC\30B9\3068\3057\3066\4F7F\7528\3055\308C\308B\5024\3092\751F\6210\3059\308BJavaScript\5F0F\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104655470379308963)
,p_name=>'PE.PROPERTY.VALUE_JS_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('JavaScript\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104657284411308965)
,p_name=>'PE.PROPERTY.VALUE_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3059\308B\5834\5408\3001YES\3092\8FD4\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES", "NO" );',
'</pre></dd>',
'</dl>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104657152317308965)
,p_name=>'PE.PROPERTY.VALUE_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30D1\30E9\30E1\30FC\30BF\5024\306E\30BD\30FC\30B9\3068\3057\3066\4F7F\7528\3055\308C\308B\5024\3092\8FD4\3059JavaScript\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104657081036308965)
,p_name=>'PE.PROPERTY.VALUE_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('JavaScript\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104150042130308567)
,p_name=>'PE.PROPERTY.VALUE_MIN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\306E\6700\5C0F\5024\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104149966388308567)
,p_name=>'PE.PROPERTY.VALUE_MIN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104278054678308666)
,p_name=>'PE.PROPERTY.VALUE_NUMERIC_PATTERN.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\306E\6570\5024\306B\9069\7528\3059\308B\6570\5024\30D1\30BF\30FC\30F3\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104769737352309065)
,p_name=>'PE.PROPERTY.VALUE_NUMERIC_PATTERN.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\83EF\6C0F\3067\6E29\5EA6\3092\8868\3059\305F\3081\306E\6570\5024\30D1\30BF\30FC\30F3(15&deg;F\306A\3069)</dt>'),
'<dd><pre>',
'#&deg;F',
'</pre></dd>',
unistr('<dt>\7279\5B9A\306E\66F8\5F0F\3067\6570\3092\8868\3059\305F\3081\306E\6570\5024\30D1\30BF\30FC\30F3(12,30,00\306A\3069)</dt>'),
'<dd><pre>',
'##,##,##',
'</pre></dd>',
unistr('<dt>\30DF\30EA\30E1\30FC\30C8\30EB\3067\6570\3092\8868\3059\305F\3081\306E\6570\5024\30D1\30BF\30FC\30F3</dt>'),
'<dd><pre>',
'# mm',
'</pre></dd>',
unistr('<dt>\6708\5E74\3067\65E5\4ED8\3092\8868\3059\305F\3081\306E\65E5\4ED8\30D1\30BF\30FC\30F3(Jul 2016\306A\3069)</dt>'),
'<dd><pre>',
'MMM yyyy',
'</pre></dd>',
unistr('<dt>\6708\3067\65E5\4ED8\3092\8868\3059\305F\3081\306E\65E5\4ED8\30D1\30BF\30FC\30F3(July\306A\3069)</dt>'),
'<dd><pre>',
'MMMM',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104152036681308568)
,p_name=>'PE.PROPERTY.VALUE_NUMERIC_PATTERN.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30D1\30BF\30FC\30F3\3067\4F7F\7528\3055\308C\308B\6587\5B57\304C\65E5\6642\66F8\5F0F\306B\5BFE\3057\3066Unicode CLDR\306B\6E96\62E0\3059\308B\30AA\30D7\30B7\30E7\30F3\306E\30ED\30FC\30AB\30E9\30A4\30BA\3055\308C\305F\6570\5024\307E\305F\306F\65E5\4ED8\30D1\30BF\30FC\30F3\3092\5165\529B\3057\307E\3059\3002'),
unistr('        \5B58\5728\3059\308B\5834\5408\3001\3053\308C\306F\9078\629E\3055\308C\305F\300C\66F8\5F0F\300D\3092\30AA\30FC\30D0\30FC\30E9\30A4\30C9\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104151903171308568)
,p_name=>'PE.PROPERTY.VALUE_NUMERIC_PATTERN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30BF\30FC\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104655343383308963)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3059\308B\304B\3001\30DE\30CD\30FC\30B8\30E3\3067\3042\308B\5834\5408\3001YES\3092\8FD4\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'case when ( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' ) then ''YES'' else ''NO'' end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104655238884308963)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30D1\30E9\30E1\30FC\30BF\5024\306E\30BD\30FC\30B9\3068\3057\3066\4F7F\7528\3055\308C\308B\5024\3092\751F\6210\3059\308BPL/SQL\5F0F\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104655126315308963)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104656920319308964)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3059\308B\5834\5408\3001YES\3092\8FD4\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104656813685308964)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30D1\30E9\30E1\30FC\30BF\5024\306E\30BD\30FC\30B9\3068\3057\3066\4F7F\7528\3055\308C\308B\5024\3092\8FD4\3059PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104656719282308964)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103623407363308105)
,p_name=>'PE.PROPERTY.VALUE_POSITION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024\3092\30C1\30E3\30FC\30C8\306B\8868\793A\3059\308B\4F4D\7F6E\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103622846797308104)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.AUTO.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103623512640308105)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.AUTO.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\5024\306F\3001\30C1\30E3\30FC\30C8\306E\30C7\30D5\30A9\30EB\30C8\306E\4F4D\7F6E(\63CF\753B\30A8\30EA\30A2\306E\5916\5074)\306B\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103622904751308104)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.CENTER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E2D\592E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103623671853308105)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.CENTER.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\5024\306F\3001\30C1\30E3\30FC\30C8\306E\30A4\30F3\30B8\30B1\30FC\30BF\306E\4E2D\592E\306B\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103623051262308104)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.INSIDEINDICATOREDGE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30B8\30B1\30FC\30BF\306E\30A8\30C3\30B8\5185')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103623701821308105)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.INSIDEINDICATOREDGE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\5024\306F\3001\30C1\30E3\30FC\30C8\306E\30A4\30F3\30B8\30B1\30FC\30BF\306E\30A8\30C3\30B8\5185\306B\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103623122107308104)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.OUTSIDEINDICATOREDGE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30B8\30B1\30FC\30BF\306E\30A8\30C3\30B8\5916')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103623849360308105)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.OUTSIDEINDICATOREDGE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\5024\306F\3001\30C1\30E3\30FC\30C8\306E\30A4\30F3\30B8\30B1\30FC\30BF\306E\30A8\30C3\30B8\5916\306B\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103623226311308104)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.OUTSIDEPLOTAREA.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\63CF\753B\30A8\30EA\30A2\5916')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103623912574308105)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.OUTSIDEPLOTAREA.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\5024\306F\3001\30C1\30E3\30FC\30C8\306E\63CF\753B\30A8\30EA\30A2\5916\306B\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103623354968308105)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.WITHLABEL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB\4ED8\304D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103624066437308105)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.WITHLABEL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\30E9\30D9\30EB\304C\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\308B\5834\5408\3001\5024\306F\3001\30E9\30D9\30EB\3068\540C\3058\4F4D\7F6E\306B\8868\793A\3055\308C\307E\3059\3002\30E9\30D9\30EB\304C\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\306A\3044\5834\5408\3001\5024\306F\3001\30C1\30E3\30FC\30C8\306E\63CF\753B\30A8\30EA\30A2\5916\306B\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103622753119308104)
,p_name=>'PE.PROPERTY.VALUE_POSITION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104194351785308605)
,p_name=>'PE.PROPERTY.VALUE_PREFERENCE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30D1\30E9\30E1\30FC\30BF\5024\306E\30BD\30FC\30B9\3068\3057\3066\4F7F\7528\3055\308C\308B\30E6\30FC\30B6\30FC\30FB\30D7\30EA\30D5\30A1\30EC\30F3\30B9\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104194241885308605)
,p_name=>'PE.PROPERTY.VALUE_PREFERENCE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30EA\30D5\30A1\30EC\30F3\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104656041675308964)
,p_name=>'PE.PROPERTY.VALUE_PYTHON_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30D1\30E9\30E1\30FC\30BF\5024\306E\30BD\30FC\30B9\3068\3057\3066\4F7F\7528\3055\308C\308B\5024\3092\751F\6210\3059\308BPython\5F0F\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104655934371308964)
,p_name=>'PE.PROPERTY.VALUE_PYTHON_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('Python\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104657643100308965)
,p_name=>'PE.PROPERTY.VALUE_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30D1\30E9\30E1\30FC\30BF\5024\306E\30BD\30FC\30B9\3068\3057\3066\4F7F\7528\3055\308C\308B\5024\3092\8FD4\3059Python\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104657574537308965)
,p_name=>'PE.PROPERTY.VALUE_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('Python\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104193988085308605)
,p_name=>'PE.PROPERTY.VALUE_QUERY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30D1\30E9\30E1\30FC\30BF\5024\306E\30BD\30FC\30B9\3068\3057\3066\4F7F\7528\3055\308C\308BSQL\554F\5408\305B\3092\5165\529B\3057\307E\3059\3002\8907\6570\306E\884C\304C\8FD4\3055\308C\308B\5834\5408\3001\6700\521D\306E\884C\306E\5024\304C\4F7F\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104193822540308604)
,p_name=>'PE.PROPERTY.VALUE_QUERY.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103881290754308309)
,p_name=>'PE.PROPERTY.VALUE_REQUIRED.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p><strong>\300C\30AA\30F3\300D</strong>\306B\8A2D\5B9A\3057\3001\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\304C\8868\793A\3055\308C\3066\3044\308B\5834\5408\3001\30DA\30FC\30B8\306E\9001\4FE1\6642\306B&PRODUCT_NAME.\3067\81EA\52D5\7684\306BNOT NULL\691C\8A3C\304C\5B9F\884C\3055\308C\307E\3059\3002</p>'),
unistr('<p><strong>APEX.PAGE_ITEM_IS_REQUIRED</strong>\3068\3044\3046\30E1\30C3\30BB\30FC\30B8\3092\300C\5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8\300D > \300C\30C6\30AD\30B9\30C8\30FB\30E1\30C3\30BB\30FC\30B8\300D\3067\5B9A\7FA9\3059\308B\3068\3001\4E8B\524D\5B9A\7FA9\3055\308C\305F\30A8\30E9\30FC\30FB\30C6\30AD\30B9\30C8\3092\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\56FA\6709\306E\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\306B\7F6E\63DB\3067\304D\307E\3059\3002</p>'),
unistr('<p>\30E1\30C3\30BB\30FC\30B8\306E\8868\793A\5834\6240\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30EC\30D9\30EB\8A2D\5B9A\306E<strong>\300C\30C7\30D5\30A9\30EB\30C8\306E\30A8\30E9\30FC\8868\793A\4F4D\7F6E\300D</strong>\3067\5B9A\7FA9\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103881188070308309)
,p_name=>'PE.PROPERTY.VALUE_REQUIRED.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5FC5\9808\306E\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104655012292308963)
,p_name=>'PE.PROPERTY.VALUE_SQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\30DE\30CD\30FC\30B8\30E3\3067\3001\90E8\9580\304C\30B7\30AB\30B4\306B\5B58\5728\3059\308B\5834\5408\3001YES\3092\8FD4\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'case',
'when :P2_JOB = ''MANAGER'' and',
'     exists ( select 1',
'                from dept',
'               where deptno = :P2_DEPTNO',
'                 and loc    = ''CHICAGO'' ) then ''YES''',
'else ''NO''',
'end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104654941989308963)
,p_name=>'PE.PROPERTY.VALUE_SQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30D1\30E9\30E1\30FC\30BF\5024\306E\30BD\30FC\30B9\3068\3057\3066\4F7F\7528\3055\308C\308B\5024\3092\751F\6210\3059\308BSQL\5F0F\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104654828439308963)
,p_name=>'PE.PROPERTY.VALUE_SQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104193775162308604)
,p_name=>'PE.PROPERTY.VALUE_STATIC_VALUE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30D1\30E9\30E1\30FC\30BF\5024\306E\30BD\30FC\30B9\3068\3057\3066\4F7F\7528\3059\308B\9759\7684\5024\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104193646085308604)
,p_name=>'PE.PROPERTY.VALUE_STATIC_VALUE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\9759\7684\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104276092436308665)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5408\8A08\5024\306E\6570\307E\305F\306F\30D1\30FC\30BB\30F3\30C6\30FC\30B8\3068\3057\3066\5024\3092\30C1\30E3\30FC\30C8\306B\8868\793A\3059\308B\65B9\6CD5\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104275884332308664)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.LOV.NUMBER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6570\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104278302592308666)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.LOV.NUMBER.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\5024\306F\3001\30C1\30E3\30FC\30C8\4E0A\306B\6570\3068\3057\3066\8868\793A\3055\308C\307E\3059\3002</p> <p>\30CE\30FC\30C8: \30C1\30E3\30FC\30C8\306B\8868\793A\3055\308C\308B\30E9\30D9\30EB\304A\3088\3073\5024\306B\30AB\30B9\30BF\30E0\306E\5C0F\6570\70B9\307E\305F\306F\901A\8CA8\306E\66F8\5F0F\8A2D\5B9A\3092\9069\7528\3059\308B\306B\306F\3001<strong>\66F8\5F0F</strong>\5C5E\6027\306E\307F\4F7F\7528\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104275903930308664)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.LOV.PERCENT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5272\5408')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104278455370308666)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.LOV.PERCENT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\5024\306F\30010%\3068100%\306E\9593\306E\30D1\30FC\30BB\30F3\30C8\3068\3057\3066\8868\793A\3055\308C\307E\3059\3002</p> <p>\30CE\30FC\30C8: <strong>\66F8\5F0F</strong>\304C<strong>\30D1\30FC\30BB\30F3\30C8</strong>\306B\8A2D\5B9A\3055\308C\3066\3044\308B\5834\5408\3001\30C1\30E3\30FC\30C8\306E\5024\306B100\304C\4E57\7B97\3055\308C\3066\30D1\30FC\30BB\30F3\30C8\3068\3057\3066\66F8\5F0F\8A2D\5B9A\3055\308C\307E\3059\3002\66F8\5F0F\5C5E\6027\3092\4F7F\7528\3059\308B\5834\5408\3001\30E9\30D9\30EB\30FB\30BF\30A4\30D7\304C\6570\5024\306B\8A2D\5B9A\3055\308C\3066\3044\308B\3053\3068\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104275718621308664)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104192189340308603)
,p_name=>'PE.PROPERTY.VALUE_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30D1\30E9\30E1\30FC\30BF\306E\79FB\5165\65B9\6CD5\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104196984985308607)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.COLLECTION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30EC\30AF\30B7\30E7\30F3(CLOB)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104197039653308607)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.COLLECTION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F<em>\30B3\30EC\30AF\30B7\30E7\30F3</em>\304B\3089\306E\6700\521D\306E\884C\306ECLOB\5217\5024\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104474037673308812)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.DEFAULT.D'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\30BD\30FC\30B9\30FB\30C7\30D5\30A9\30EB\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104474163354308812)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.DEFAULT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\30C7\30FC\30BF\30FB\30BD\30FC\30B9\5185\306B\30C7\30D5\30A9\30EB\30C8\3068\3057\3066\5B9A\7FA9\3055\308C\3066\3044\308B\5024\3092\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104192464483308603)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.ITEM.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104192545721308603)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F<em>\30A2\30A4\30C6\30E0</em>\306E\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\306B\4FDD\6301\3055\308C\3066\3044\308B\5024\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104193497136308604)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.NULL.D'
,p_message_language=>'ja'
,p_message_text=>'NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104193590152308604)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.NULL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024\306E\6307\5B9A\304C\306A\3044\305F\3081null\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104192873692308604)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PLSQL_EXPRESSION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104192981742308604)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PLSQL_EXPRESSION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F<em>PL/SQL\5F0F</em>\306E\5B9F\884C\7D50\679C\306E\5024\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104193052396308604)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PLSQL_FUNCTION_BODY.D'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104193171566308604)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PLSQL_FUNCTION_BODY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F<em>PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53</em>\304B\3089\8FD4\3055\308C\305F\5024\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104193227689308604)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PREFERENCE.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30EA\30D5\30A1\30EC\30F3\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104193337937308604)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PREFERENCE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F<em>\30D7\30EA\30D5\30A1\30EC\30F3\30B9</em>\306E\5024\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104192647205308603)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B(\5358\4E00\306E\5024\3092\8FD4\3059)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104192748055308603)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F<em>SQL\554F\5408\305B</em>\304B\3089\6700\521D\306B\8FD4\3055\308C\305F\5024\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104192253267308603)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.STATIC.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\9759\7684\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104192314183308603)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.STATIC.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<em>\300C\9759\7684\5024\300D</em>\306B\5165\529B\3055\308C\305F\30C6\30AD\30B9\30C8\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104192092658308603)
,p_name=>'PE.PROPERTY.VALUE_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104645296809308955)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F\5F0F\306E\8A55\4FA1\306B\4F7F\7528\3055\308C\308B\8A00\8A9E\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104645607051308956)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'ja'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104645597224308955)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'ja'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104645488825308955)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'ja'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104645785444308956)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'ja'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104645396026308955)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'ja'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104645174508308955)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A00\8A9E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104647269852308957)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\306E\5B9F\884C\306B\4F7F\7528\3055\308C\308B\8A00\8A9E\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104647561805308957)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'ja'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104647452285308957)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'ja'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104647390296308957)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'ja'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104647606804308957)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'ja'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104647175621308957)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A00\8A9E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104643632840308954)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\306E\5B9F\884C\306B\4F7F\7528\3055\308C\308B\8A00\8A9E\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104643975005308954)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.LOV.JAVA.D'
,p_message_language=>'ja'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104643817403308954)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.LOV.JAVASCRIPT.D'
,p_message_language=>'ja'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104643792089308954)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.LOV.PLSQL.D'
,p_message_language=>'ja'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104644081860308954)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.LOV.PYTHON.D'
,p_message_language=>'ja'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104643521532308954)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A00\8A9E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104340050594308712)
,p_name=>'PE.PROPERTY.VAL_ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\691C\8A3C\3067\4F7F\7528\3055\308C\308B\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104339950835308712)
,p_name=>'PE.PROPERTY.VAL_ITEM.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104646855112308956)
,p_name=>'PE.PROPERTY.VAL_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C\3092\5B9A\7FA9\3059\308BJava\5F0F\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104646761404308956)
,p_name=>'PE.PROPERTY.VAL_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('Java\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104648414020308958)
,p_name=>'PE.PROPERTY.VAL_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\691C\8A3C\306E\30D9\30FC\30B9\3068\3057\3066\30D6\30FC\30EB\5024\3092\8FD4\3059Java\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104648341301308958)
,p_name=>'PE.PROPERTY.VAL_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('Java\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104644858876308955)
,p_name=>'PE.PROPERTY.VAL_JAVA_FUNC_BODY_ERROR.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\691C\8A3C\306E\30D9\30FC\30B9\3068\3057\3066\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\30FB\30C6\30AD\30B9\30C8\3092\8FD4\3059Java\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104644705923308955)
,p_name=>'PE.PROPERTY.VAL_JAVA_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC\30FB\30C6\30AD\30B9\30C8\3092\8FD4\3059Java\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104646681359308956)
,p_name=>'PE.PROPERTY.VAL_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3059\308B\304B\3001\30DE\30CD\30FC\30B8\30E3\3067\3042\308B\5834\5408\3001\691C\8A3C\306B\5408\683C\3057\3001\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\306F\51FA\529B\3055\308C\307E\305B\3093\3002</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB == "MANAGER" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104646580084308956)
,p_name=>'PE.PROPERTY.VAL_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C\3092\5B9A\7FA9\3059\308BJavaScript\5F0F\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104646482995308956)
,p_name=>'PE.PROPERTY.VAL_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('JavaScript\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104648227815308958)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3059\308B\5834\5408\3001\691C\8A3C\306B\5408\683C\3057\3001\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\306F\51FA\529B\3055\308C\307E\305B\3093\3002</dt>'),
'<dd><pre>',
'if ( apex.env.P2_DEPTNO === "30" ) {',
'    return true;',
'} else {',
'    return false;',
'}',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104648103158308957)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\691C\8A3C\306E\30D9\30FC\30B9\3068\3057\3066\30D6\30FC\30EB\5024\3092\8FD4\3059JavaScript\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104648097880308957)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('JavaScript\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104644639775308955)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_ERROR.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3059\308B\5834\5408\3001\691C\8A3C\306B\5408\683C\3057\3001\6307\5B9A\3057\305F\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\306F\51FA\529B\3055\308C\307E\305B\3093\3002</dt>'),
'<dd><pre>',
'if ( apex.env.P2_DEPTNO !== "30" ) {',
'    return "Employee is in Department " + apex.env.P2_DEPTNO + " and not Department 30";',
'}',
'return "";',
'</pre></dd>',
'</dl>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104644584340308955)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_ERROR.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\691C\8A3C\306E\30D9\30FC\30B9\3068\3057\3066\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\30FB\30C6\30AD\30B9\30C8\3092\8FD4\3059JavaScript\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104644425371308955)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC\30FB\30C6\30AD\30B9\30C8\3092\8FD4\3059JavaScript\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104764903261309062)
,p_name=>'PE.PROPERTY.VAL_PLSQL.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3059\308B\5834\5408\3001\691C\8A3C\306B\5408\683C\3057\3001\6307\5B9A\3057\305F\30A8\30E9\30FC\306F\51FA\529B\3055\308C\307E\305B\3093\3002</dt>'),
'<dd><pre>',
'begin',
'    if :P2_DEPTNO <> 30 then',
'        raise_application_error( -20000, ''Employee is in Department '' || :P2_DEPTNO || '' and not Department 30'' );',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104339894429308712)
,p_name=>'PE.PROPERTY.VAL_PLSQL.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\691C\8A3C\306E\30D9\30FC\30B9\3068\3057\3066\30A8\30E9\30FC\3092\767A\751F\3059\308BPL/SQL\5F0F\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104339708416308711)
,p_name=>'PE.PROPERTY.VAL_PLSQL.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC\3092\767A\751F\3059\308BPL/SQL\30B3\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104646325752308956)
,p_name=>'PE.PROPERTY.VAL_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3059\308B\304B\3001\30DE\30CD\30FC\30B8\30E3\3067\3042\308B\5834\5408\3001\691C\8A3C\306B\5408\683C\3057\3001\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\306F\51FA\529B\3055\308C\307E\305B\3093\3002</dt>'),
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104646272304308956)
,p_name=>'PE.PROPERTY.VAL_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C\3092\5B9A\7FA9\3059\308BPL/SQL\5F0F\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104646174827308956)
,p_name=>'PE.PROPERTY.VAL_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104647947154308957)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3059\308B\5834\5408\3001\691C\8A3C\306B\5408\683C\3057\3001\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\306F\51FA\529B\3055\308C\307E\305B\3093\3002</dt>'),
'<dd><pre>',
'begin',
'    if :P2_DEPTNO = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104647805583308957)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\691C\8A3C\306E\30D9\30FC\30B9\3068\3057\3066\30D6\30FC\30EB\5024\3092\8FD4\3059PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104647798957308957)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104644365543308954)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_ERROR.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3059\308B\5834\5408\3001\691C\8A3C\306B\5408\683C\3057\3001\6307\5B9A\3057\305F\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\306F\51FA\529B\3055\308C\307E\305B\3093\3002</dt>'),
'<dd><pre>',
'begin',
'    if :P2_DEPTNO <> 30 then',
'        return ''Employee is in Department '' || :P2_DEPTNO || '' and not Department 30'';',
'    end if;',
'    return null;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104644238241308954)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_ERROR.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\691C\8A3C\306E\30D9\30FC\30B9\3068\3057\3066\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\30FB\30C6\30AD\30B9\30C8\3092\8FD4\3059PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104644167977308954)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC\30FB\30C6\30AD\30B9\30C8\3092\8FD4\3059PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104647086827308957)
,p_name=>'PE.PROPERTY.VAL_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C\3092\5B9A\7FA9\3059\308BPython\5F0F\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104646911260308957)
,p_name=>'PE.PROPERTY.VAL_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('Python\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104648632189308958)
,p_name=>'PE.PROPERTY.VAL_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\691C\8A3C\306E\30D9\30FC\30B9\3068\3057\3066\30D6\30FC\30EB\5024\3092\8FD4\3059Python\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104648583124308958)
,p_name=>'PE.PROPERTY.VAL_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('Python\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104645078707308955)
,p_name=>'PE.PROPERTY.VAL_PYTHON_FUNC_BODY_ERROR.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\691C\8A3C\306E\30D9\30FC\30B9\3068\3057\3066\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\30FB\30C6\30AD\30B9\30C8\3092\8FD4\3059Python\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104644984001308955)
,p_name=>'PE.PROPERTY.VAL_PYTHON_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC\30FB\30C6\30AD\30B9\30C8\3092\8FD4\3059Python\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104340488580308712)
,p_name=>'PE.PROPERTY.VAL_REGULAR_EXPRESSION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\691C\8A3C\306B\6307\5B9A\3055\308C\305F\30A2\30A4\30C6\30E0\3068\306E\4E00\81F4\306B\4F7F\7528\3059\308B\6B63\898F\8868\73FE\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104340359772308712)
,p_name=>'PE.PROPERTY.VAL_REGULAR_EXPRESSION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B63\898F\8868\73FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104646064872308956)
,p_name=>'PE.PROPERTY.VAL_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5F93\696D\54E1\304C\30DE\30CD\30FC\30B8\30E3\3067\3042\308B\304B\3001\90E8\9580\304C\30B7\30AB\30B4\306B\5B58\5728\3059\308B\5834\5408\3001\691C\8A3C\306B\5408\683C\3057\3001\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\306F\51FA\529B\3055\308C\307E\305B\3093\3002</dt>'),
'<dd><pre>',
':P2_JOB = ''MANAGER'' or',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104645948050308956)
,p_name=>'PE.PROPERTY.VAL_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C\3092\5B9A\7FA9\3059\308BSQL\5F0F\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104645877286308956)
,p_name=>'PE.PROPERTY.VAL_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104764853161309062)
,p_name=>'PE.PROPERTY.VAL_SQL_STATEMENT.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt><strong>\300C\884C\304C\8FD4\3055\308C\308B\300D</strong>\3067\3001\5F93\696D\54E1\304C\90E8\958030\306B\6240\5C5E\3059\308B\5834\5408\3001\691C\8A3C\306B\5408\683C\3057\3001\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\306F\51FA\529B\3055\308C\307E\305B\3093\3002</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
unistr('<dt><strong>\300C\884C\304C\8FD4\3055\308C\306A\3044\300D</strong>\3067\3001\5F93\696D\54E1\304C\90E8\958040\306B\6240\5C5E\3059\308B\5834\5408\3001\691C\8A3C\306B\5408\683C\3057\3001\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\306F\51FA\529B\3055\308C\307E\305B\3093\3002</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno <> 40',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104339622914308711)
,p_name=>'PE.PROPERTY.VAL_SQL_STATEMENT.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\691C\8A3C\3092\5B9A\7FA9\3059\308BSQL\554F\5408\305B\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104339530893308711)
,p_name=>'PE.PROPERTY.VAL_SQL_STATEMENT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104340287668308712)
,p_name=>'PE.PROPERTY.VAL_VALUE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\691C\8A3C\306B\6307\5B9A\3055\308C\305F\30A2\30A4\30C6\30E0\5217\306E\5024\3068\306E\6BD4\8F03\306B\4F7F\7528\3059\308B\5024\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104340115488308712)
,p_name=>'PE.PROPERTY.VAL_VALUE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104470957432308810)
,p_name=>'PE.PROPERTY.VERIFY_FUNCTION_NAME.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\4F7F\7528\3092\7279\5B9A\306E\696D\52D9\6642\9593\306B\5236\9650</dt>'),
'<dd><pre>',
'function check_business_hours return boolean',
'is',
'begin',
'    return to_char(to_char(sysdate, ''hh24:mi'')) between ''08:00'' and ''17:00'';',
'end check_business_hours;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103963634832308408)
,p_name=>'PE.PROPERTY.VERIFY_FUNCTION_NAME.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30BB\30C3\30B7\30E7\30F3\76E3\8996\304C\6B63\5E38\306B\5FA9\5E30\3057\305F\5F8C\30B3\30FC\30EB\3055\308C\308B\30D5\30A1\30F3\30AF\30B7\30E7\30F3\306E\540D\524D\3092\5165\529B\3057\307E\3059\3002'),
unistr('\30D5\30A1\30F3\30AF\30B7\30E7\30F3\306F\3001\300CPL/SQL\30B3\30FC\30C9\300D\5C5E\6027\307E\305F\306F\30C7\30FC\30BF\30D9\30FC\30B9\3067\5B9A\7FA9\3055\308C\307E\3059\3002'),
unistr('\7D50\679C\306F\3001\30D6\30FC\30EB(\30E6\30FC\30B6\30FC\304C\691C\8A3C\3055\308C\305F\3053\3068\3092\8868\3059"True"\304A\3088\3073\30E6\30FC\30B6\30FC\304C\691C\8A3C\306B\5931\6557\3057\305F\3053\3068\3092\8868\3059"False")\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103963593328308408)
,p_name=>'PE.PROPERTY.VERIFY_FUNCTION_NAME.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30F3\30AF\30B7\30E7\30F3\540D\306E\78BA\8A8D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103901286842308328)
,p_name=>'PE.PROPERTY.WAIT_FOR_RESULT.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3059\3079\3066\306E\4FDD\7559\4E2D\306E\30A2\30AF\30B7\30E7\30F3\304C\3001\73FE\5728\306E\30A2\30AF\30B7\30E7\30F3\306E\7D50\679C\3092\5F85\6A5F\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002'),
unistr('\4FDD\7559\4E2D\306E\30A2\30AF\30B7\30E7\30F3\304C\3053\306E\30A2\30AF\30B7\30E7\30F3\306E\7D50\679C\306B\4F9D\5B58\3059\308B\5834\5408\306F\3001\3053\306E\5C5E\6027\3092<strong>\300C\30AA\30F3\300D</strong>\306B\8A2D\5B9A\3057\3001'),
unistr('\4F9D\5B58\95A2\4FC2\306F\306A\304F\3001\975E\540C\671F\306B\5B9F\884C\3067\304D\3066\5F85\6A5F\306E\5FC5\8981\304C\306A\3044\5834\5408\306F<strong>\300C\30AA\30D5\300D</strong>\306B\8A2D\5B9A\3057\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8: \7279\5B9A\306E\30A2\30AF\30B7\30E7\30F3\306E\5B9F\884C\306E\9806\5E8F\306F\3001\5404\30A2\30AF\30B7\30E7\30F3\306B\6307\5B9A\3055\308C\305F\9806\5E8F\306B\3088\3063\3066\6C7A\307E\308A\307E\3059\3002'),
unistr('\30A2\30AF\30B7\30E7\30F3\304C\540C\3058\9806\5E8F\3067\5B9F\884C\3055\308C\308B\3088\3046\306B\3059\308B\305F\3081\306B\3001\3059\3079\3066\306ETrue\30A2\30AF\30B7\30E7\30F3\304A\3088\3073\3059\3079\3066\306EFalse\30A2\30AF\30B7\30E7\30F3\3067\9806\5E8F\756A\53F7\3092\4E00\610F\306B\3059\308B\3053\3068\3092\304A\85A6\3081\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103901116089308328)
,p_name=>'PE.PROPERTY.WAIT_FOR_RESULT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D50\679C\3092\5F85\6A5F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103989204944308427)
,p_name=>'PE.PROPERTY.WEB_SRC_HAS_LOCAL_TABLE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\30C7\30FC\30BF\30FB\30BD\30FC\30B9\306B\30ED\30FC\30AB\30EB\540C\671F\5316\8868\304C\542B\307E\308C\308B\304B\3069\3046\304B\3092\793A\3057\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103989144799308427)
,p_name=>'PE.PROPERTY.WEB_SRC_HAS_LOCAL_TABLE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\30C7\30FC\30BF\30FB\30BD\30FC\30B9\306B\540C\671F\5316\8868\304C\542B\307E\308C\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104191950779308603)
,p_name=>'PE.PROPERTY.WEB_SRC_PARAM.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\540D\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103989457787308427)
,p_name=>'PE.PROPERTY.WEB_SRC_USE_LOCAL_TABLE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\3053\308C\3092\6709\52B9\306B\3059\308B\3068\3001\30ED\30FC\30AB\30EB\8868\3092\4F7F\7528\3067\304D\307E\3059\3002\30ED\30FC\30AB\30EB\8868\306F\3001\5916\90E8REST\30B5\30FC\30D3\30B9\306B\30A2\30AF\30BB\30B9\305B\305A\306B\3001REST\30C7\30FC\30BF\30FB\30BD\30FC\30B9\306E<strong>\300C\540C\671F\5316\300D</strong>\30BB\30AF\30B7\30E7\30F3\5185\3067\69CB\6210\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103989336468308427)
,p_name=>'PE.PROPERTY.WEB_SRC_USE_LOCAL_TABLE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\540C\671F\5316\8868\306E\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103875407204308305)
,p_name=>'PE.PROPERTY.WHEN_BUTTON.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\52D5\7684\30A2\30AF\30B7\30E7\30F3\3092\30C8\30EA\30AC\30FC\3059\308B\30DC\30BF\30F3\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103875347027308305)
,p_name=>'PE.PROPERTY.WHEN_BUTTON.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103980134233308420)
,p_name=>'PE.PROPERTY.WHEN_BUTTON_PRESSED.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DA\30FC\30B8\51E6\7406\30B3\30F3\30DD\30FC\30CD\30F3\30C8\3092\3001\6307\5B9A\3057\305F\30DC\30BF\30F3\304C\30AF\30EA\30C3\30AF\3055\308C\305F\3068\304D\306E\307F\5B9F\884C\3059\308B\5834\5408\3001\30EA\30B9\30C8\304B\3089\30DC\30BF\30F3\3092\9078\629E\3057\307E\3059\3002\3053\306E\30DC\30BF\30F3\306E\6761\4EF6\3092\4ED6\306E\6761\4EF6\3068\7D71\5408\3057\3001\3053\306E\30DA\30FC\30B8\51E6\7406\30B3\30F3\30DD\30FC\30CD\30F3\30C8\304C\3044\3064\5B9F\884C\3055\308C\308B\304B\3092\3055\3089\306B\7D5E\308A\8FBC\3080\3053\3068\304C\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103980002882308420)
,p_name=>'PE.PROPERTY.WHEN_BUTTON_PRESSED.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3\62BC\4E0B\6642')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104736816408309032)
,p_name=>'PE.PROPERTY.WHEN_COLUMNS.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\52D5\7684\30A2\30AF\30B7\30E7\30F3\3092\30C8\30EA\30AC\30FC\3059\308B1\3064\4EE5\4E0A\306E\5217\3092\5165\529B\3057\307E\3059\3002'),
unistr('\8907\6570\306E\5217\306E\5834\5408\3001\5404\30A2\30A4\30C6\30E0\540D\3092\30AB\30F3\30DE\3067\533A\5207\308A\307E\3059\3002'),
unistr('\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\5217\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002'),
unistr('\30EA\30B9\30C8\304B\3089\9078\629E\3057\3001\3059\3067\306B\5165\529B\3055\308C\3066\3044\308B\30C6\30AD\30B9\30C8\304C\3042\308B\5834\5408\3001\65E2\5B58\306E\30C6\30AD\30B9\30C8\306E\6700\5F8C\306B\30AB\30F3\30DE\304C\4ED8\3051\3089\308C\3001\30EA\30B9\30C8\304B\3089\8FD4\3055\308C\305F\5217\540D\304C\305D\308C\306B\7D9A\304D\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104736781506309032)
,p_name=>'PE.PROPERTY.WHEN_COLUMNS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103875820446308305)
,p_name=>'PE.PROPERTY.WHEN_DOM_OBJECT.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\52D5\7684\30A2\30AF\30B7\30E7\30F3\3092\30C8\30EA\30AC\30FC\3059\308B\8981\7D20\3068\3057\3066DOM\30AA\30D6\30B8\30A7\30AF\30C8(<code>document</code>\3001<code>window</code>)\307E\305F\306FDOM\30AA\30D6\30B8\30A7\30AF\30C8\306E<em>ID</em>(<code>myElementID</code>)\306E\3044\305A\308C\304B\3092\5165\529B\3057\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8: <em>DOM\30AA\30D6\30B8\30A7\30AF\30C8</em>\306F\975E\63A8\5968\3067\3059\3002<em>JavaScript\5F0F</em>\307E\305F\306F<em>jQuery\30BB\30EC\30AF\30BF</em>\3067\7F6E\304D\63DB\3048\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103875789437308305)
,p_name=>'PE.PROPERTY.WHEN_DOM_OBJECT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('DOM\30AA\30D6\30B8\30A7\30AF\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103875696291308305)
,p_name=>'PE.PROPERTY.WHEN_ITEMS.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\52D5\7684\30A2\30AF\30B7\30E7\30F3\3092\30C8\30EA\30AC\30FC\3059\308B\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002'),
unistr('\8907\6570\306E\30A2\30A4\30C6\30E0\306E\5834\5408\3001\5404\30A2\30A4\30C6\30E0\540D\3092\30AB\30F3\30DE\3067\533A\5207\308A\307E\3059\3002'),
unistr('\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002'),
unistr('\30EA\30B9\30C8\304B\3089\9078\629E\3057\3001\3059\3067\306B\5165\529B\3055\308C\3066\3044\308B\30C6\30AD\30B9\30C8\304C\3042\308B\5834\5408\3001\65E2\5B58\306E\30C6\30AD\30B9\30C8\306E\6700\5F8C\306B\30AB\30F3\30DE\304C\4ED8\3051\3089\308C\3001\30EA\30B9\30C8\304B\3089\8FD4\3055\308C\305F\30A2\30A4\30C6\30E0\540D\304C\305D\308C\306B\7D9A\304D\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103875533093308305)
,p_name=>'PE.PROPERTY.WHEN_ITEMS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104732523818309029)
,p_name=>'PE.PROPERTY.WHEN_JAVASCRIPT_EXPRESSION.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\30D6\30E9\30A6\30B6\306E<code>window</code> DOM\30AA\30D6\30B8\30A7\30AF\30C8\3078\306E\53C2\7167\3092\623B\3057\307E\3059\3002</dt>'),
'<dd><code>window</code></dd>',
unistr('<dt>\30D6\30E9\30A6\30B6\306E<code>document</code> DOM\30AA\30D6\30B8\30A7\30AF\30C8\3078\306E\53C2\7167\3092\623B\3057\307E\3059\3002</dt>'),
'<dd><code>document</code></dd>',
unistr('<dt>jQuery\30BB\30EC\30AF\30BF\306F\3001''alert''\306E\30AF\30E9\30B9\3092\6301\3064\3059\3079\3066\306EDIV\8981\7D20\3092\9078\629E\3057\3001\3059\3079\3066\306E\89AA\3092\542B\3080jQuery\30AA\30D6\30B8\30A7\30AF\30C8\3092\623B\3057\307E\3059\3002</dt>'),
'<dd><code>$( "div.alert" ).parent()</code></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104732461300309028)
,p_name=>'PE.PROPERTY.WHEN_JAVASCRIPT_EXPRESSION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\52D5\7684\30A2\30AF\30B7\30E7\30F3\3092\30C8\30EA\30AC\30FC\3059\308B\8981\7D20\3068\3057\3066\5358\4E00\304A\3088\3073\8907\6570\306EDOM\30AA\30D6\30B8\30A7\30AF\30C8\307E\305F\306FjQuery\30AA\30D6\30B8\30A7\30AF\30C8\3092\8FD4\3059\305F\3081\306B\8A55\4FA1\3059\308BJavaScript\5F0F\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104732326556309028)
,p_name=>'PE.PROPERTY.WHEN_JAVASCRIPT_EXPRESSION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('JavaScript\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104387215305308747)
,p_name=>'PE.PROPERTY.WHEN_JQUERY_SELECTOR.EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>DOM ID <code>my_id</code>\3092\4F7F\7528\3057\305F\30DA\30FC\30B8\8981\7D20\306E\9078\629E</dt>'),
'<dd><pre>#my_id</pre></dd>',
unistr('<dt>\30AF\30E9\30B9<code>my_class</code>\3092\4F7F\7528\3057\305F\3059\3079\3066\306E\30DA\30FC\30B8\8981\7D20\306E\9078\629E</dt>'),
'<dd><pre>.my_class</pre></dd>',
unistr('<dt>\5165\529B\3067\3042\308B\3059\3079\3066\306E\30DA\30FC\30B8\8981\7D20\306E\9078\629E</dt>'),
'<dd><pre>input</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103876091822308305)
,p_name=>'PE.PROPERTY.WHEN_JQUERY_SELECTOR.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\52D5\7684\30A2\30AF\30B7\30E7\30F3\3092\30C8\30EA\30AC\30FC\3059\308B1\3064\4EE5\4E0A\306E\30DA\30FC\30B8\8981\7D20\3092\8FD4\3059jQuery\30BB\30EC\30AF\30BF\306E\69CB\6587\3092\5165\529B\3057\307E\3059\3002jQuery\30E9\30A4\30D6\30E9\30EA\306B\306F\3001\30DA\30FC\30B8\304B\30891\3064\4EE5\4E0A\306E\8981\7D20\306B\7C21\5358\306B\30A2\30AF\30BB\30B9\3059\308B\65B9\6CD5\3092\63D0\4F9B\3059\308B\975E\5E38\306B\5F37\529B\306A\30BB\30EC\30AF\30BF\304C\7528\610F\3055\308C\3066\3044\307E\3059\3002</p>'),
unistr('<p>\30BB\30EC\30AF\30BF\306E\69CB\6587\306E\8A73\7D30\306F\3001<a rel="noreferrer" target="_blank" href="http://docs.jquery.com">jQuery\306E\30DB\30FC\30E0\30DA\30FC\30B8</a>\304B\3089\30A2\30AF\30BB\30B9\3067\304D\308B\516C\5F0F\306E\30C9\30AD\30E5\30E1\30F3\30C8\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103875921853308305)
,p_name=>'PE.PROPERTY.WHEN_JQUERY_SELECTOR.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('jQuery\30BB\30EC\30AF\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104112612182308527)
,p_name=>'PE.PROPERTY.WHEN_MORE_DATA_FOUND_MESSAGE.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<strong>\300C\51E6\7406\3059\308B\6700\5927\884C\6570\300D</strong>\306E\5236\9650\3092\8D85\3048\305F\5834\5408\306B\8868\793A\3059\308B\30C6\30AD\30B9\30C8\30FB\30E1\30C3\30BB\30FC\30B8\3092\5165\529B\3057\307E\3059\3002'),
unistr('\30C7\30D5\30A9\30EB\30C8\30FB\30E1\30C3\30BB\30FC\30B8\3067\306F\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\3001\51E6\7406\3059\308B\30EC\30B3\30FC\30C9\306E\6570\3092\5236\9650\3059\308B\305F\3081\306B\8FFD\52A0\306E\30D5\30A3\30EB\30BF\3092\8A2D\5B9A\3059\308B\3088\3046\306B\6307\793A\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104257985640308652)
,p_name=>'PE.PROPERTY.WHEN_MORE_DATA_FOUND_MESSAGE.COMPONENT_PROPERTY.IR_ATTRIBUTES.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B\3055\308C\305F\6700\5927\884C\6570\3088\308A\591A\304F\306E\884C\304C\554F\5408\305B\304B\3089\8FD4\3055\308C\308B\5834\5408\306B\8868\793A\3059\308B\30C6\30AD\30B9\30C8\30FB\30E1\30C3\30BB\30FC\30B8\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104539358464308867)
,p_name=>'PE.PROPERTY.WHEN_MORE_DATA_FOUND_MESSAGE.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30A4\30E4\30FC\306E<strong>\300C\51E6\7406\3059\308B\6700\5927\884C\6570\300D</strong>\306E\5236\9650\3092\8D85\3048\305F\5834\5408\306B<strong>\300C\30E1\30C3\30BB\30FC\30B8\300D</strong>\9818\57DF\306B\8868\793A\3059\308B\30C6\30AD\30B9\30C8\30FB\30E1\30C3\30BB\30FC\30B8\3092\5165\529B\3057\307E\3059\3002\5B9F\969B\306B\30D5\30A7\30C3\30C1\3055\308C\308B\884C\6570\306E\304B\308F\308A\306B<strong>#MAX_ROW_COUNT#</strong>\3092\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104243295050308641)
,p_name=>'PE.PROPERTY.WHEN_MORE_DATA_FOUND_MESSAGE.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30EC\30DD\30FC\30C8\884C\304C\3055\3089\306B\5B58\5728\3059\308B\5834\5408\306B\8868\793A\3055\308C\308B\30C6\30AD\30B9\30C8\30FB\30E1\30C3\30BB\30FC\30B8\3092\5165\529B\3057\307E\3059\3002'),
unistr('\3053\306E\65B9\6CD5\306F\3001\30DA\30FC\30B8\533A\5207\308A\306E\304B\308F\308A(\7279\306B\3001\30EC\30DD\30FC\30C8\306B\901A\5E38\4E0D\9023\7D9A\306E\30EC\30B3\30FC\30C9\30FB\30BB\30C3\30C8\306E\307F\304C\542B\307E\308C\308B\5834\5408)\306B\4F7F\7528\3057\307E\3059\3002'),
unistr('\30EC\30DD\30FC\30C8\554F\5408\305B\3067\3055\3089\306B\884C\304C\8FD4\3055\308C\308B\5834\5408\3001\5358\306B\7570\306A\308B\30DA\30FC\30B8\533A\5207\308A\30B3\30F3\30C8\30ED\30FC\30EB\3092\8868\793A\3059\308B\306E\3067\306F\306A\304F\3001\3053\306E\30E1\30C3\30BB\30FC\30B8\3092\4F7F\7528\3057\3066\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\4F8B\5916\3092\77E5\3089\305B\308B\3053\3068\304C\3067\304D\307E\3059\3002'),
unistr('\30C6\30AD\30B9\30C8\30FB\30E1\30C3\30BB\30FC\30B8\306B\30B3\30FC\30EB\30FB\30A2\30AF\30B7\30E7\30F3\3092\7C21\5358\306B\7D44\307F\8FBC\3080\3053\3068\304C\3067\304D\308B\305F\3081\3001\3053\306E\901A\5E38\3068\306F\7570\306A\308B\554F\5408\305B\7D50\679C\306B\5BFE\5FDC\3059\308B\65B9\6CD5\3092\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\624B\5F15\304D\3057\305F\308A\3001\30DA\30FC\30B8\307E\305F\306FURL\30EA\30F3\30AF\3092\542B\3081\308B\3053\3068\304C\3067\304D\307E\3059\3002</p>'),
unistr('<p>\6B21\306E\30DA\30FC\30B8\533A\5207\308A\7F6E\63DB\6587\5B57\5217\3092\30E1\30C3\30BB\30FC\30B8\306B\4F7F\7528\3067\304D\307E\3059\3002</p>'),
'<dl>',
'  <dt><code>#ROWS_FETCHED#</code></dt>',
unistr('    <dd>\8868\793A\3055\308C\308B\884C\6570(\30DA\30FC\30B8\30FB\30B5\30A4\30BA)</dd>'),
'  <dt><code>#TOTAL_ROWS#</code></dt>',
unistr('    <dd>Z\306E\884CX\304B\3089Y\306E\300CZ\300D</dd>'),
'  <dt><code>#FIRST_ROW_FETCHED#</code></dt>',
unistr('    <dd>Z\306E\884CX\304B\3089Y\306E\300CX\300D</dd>'),
'  <dt><code>#LAST_ROW_FETCHED#</code></dt>',
unistr('    <dd>Z\306E\884CX\304B\3089Y\306E\300CY\300D</dd>'),
'  <dt><code>#ROW_RANGES"</code></dt>',
unistr('    <dd>\8868\793A: \884C1\304B\308915 16\304B\308930 30\304B\308932</dd>'),
'  <dt><code>#ROW_RANGES_IN_SELECT_LIST</code></dt>',
unistr('    <dd>\884C\306E\7BC4\56F2\3068\540C\3058\3001\305F\3060\3057\9078\629E\30EA\30B9\30C8\5185<dd>'),
'  <dt><code>#INTERNET_PAGINATION#</code></dt>',
unistr('    <dd>\30DA\30FC\30B8\30FB\30BB\30C3\30C8: 1 2 3 4 5 6</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104243126993308641)
,p_name=>'PE.PROPERTY.WHEN_MORE_DATA_FOUND_MESSAGE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\304C\3055\3089\306B\898B\3064\304B\3063\305F\5834\5408')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104716945851309014)
,p_name=>'PE.PROPERTY.WHEN_NO_DATA_FOUND_MESSAGE.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\554F\5408\305B\306B\3088\3063\3066\884C\304C\8FD4\3055\308C\306A\3044\5834\5408\306B\8868\793A\3059\308B\30C6\30AD\30B9\30C8\30FB\30E1\30C3\30BB\30FC\30B8\3092\5165\529B\3057\307E\3059\3002\7A7A\306E\307E\307E\306B\3059\308B\3068\3001Oracle JET\3067\306F\30C7\30D5\30A9\30EB\30C8\30FB\30E1\30C3\30BB\30FC\30B8\306E\300C\8868\793A\3059\308B\30C7\30FC\30BF\304C\3042\308A\307E\305B\3093\300D\304C\81EA\52D5\7684\306B\4F7F\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104669740401308975)
,p_name=>'PE.PROPERTY.WHEN_NO_DATA_FOUND_MESSAGE.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30A4\30E4\30FC\554F\5408\305B\306B\3088\3063\3066\884C\304C\8FD4\3055\308C\306A\3044\5834\5408\306B<strong>\300C\30E1\30C3\30BB\30FC\30B8\300D</strong>\9818\57DF\306B\8868\793A\3059\308B\30C6\30AD\30B9\30C8\30FB\30E1\30C3\30BB\30FC\30B8\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104207356907308615)
,p_name=>'PE.PROPERTY.WHEN_NO_DATA_FOUND_MESSAGE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\554F\5408\305B\306B\3088\3063\3066\884C\304C\8FD4\3055\308C\306A\3044\5834\5408\306B\8868\793A\3059\308B\30C6\30AD\30B9\30C8\30FB\30E1\30C3\30BB\30FC\30B8\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104207246550308615)
,p_name=>'PE.PROPERTY.WHEN_NO_DATA_FOUND_MESSAGE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\304C\898B\3064\304B\3089\306A\3044\5834\5408')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103875258932308305)
,p_name=>'PE.PROPERTY.WHEN_REGION.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\52D5\7684\30A2\30AF\30B7\30E7\30F3\3092\30C8\30EA\30AC\30FC\3059\308B\30EA\30FC\30B8\30E7\30F3\306E\540D\524D\3092\9078\629E\3057\307E\3059\3002'),
unistr('\305F\3068\3048\3070\3001\30EC\30DD\30FC\30C8\304C\30EA\30D5\30EC\30C3\30B7\30E5\3057\305F\3068\304D\306B\8D77\52D5\3055\308C\308B\52D5\7684\30A2\30AF\30B7\30E7\30F3\3092\5B9A\7FA9\3059\308B\3001\300C\30EA\30D5\30EC\30C3\30B7\30E5\5F8C\300D\30A4\30D9\30F3\30C8\3068\3068\3082\306B\4F7F\7528\3055\308C\308B\300C\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\300D\30EA\30FC\30B8\30E7\30F3\306A\3069\3067\3059\3002</p>'),
unistr('<p>\30EA\30FC\30B8\30E7\30F3\5185\306E\8907\6570\306E\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306B\540C\69D8\306E\52D5\4F5C\3092\5B9A\7FA9\3059\308B\5834\5408\3001\30EA\30FC\30B8\30E7\30F3\3067\306E\52D5\7684\30A2\30AF\30B7\30E7\30F3\306E\30C8\30EA\30AC\30FC\304C\6709\7528\3067\3059\3002\305F\3060\3057\3001\3053\308C\306F\3001\305D\306E\30EA\30FC\30B8\30E7\30F3\5185\306E\30A2\30A4\30C6\30E0\306B\3088\3063\3066\8D77\52D5\3055\308C\308B\7279\5B9A\306E\30A4\30D9\30F3\30C8\306B\306E\307F\53EF\80FD\3067\3059\3002'),
unistr('\3053\306E\30BF\30A4\30D7\306E\5B9A\7FA9\3092\30B5\30DD\30FC\30C8\3059\308B\30A4\30D9\30F3\30C8\306E\30EA\30B9\30C8\304A\3088\3073\3053\306E\5229\7528\65B9\6CD5\306E\4F8B\306F\3001\300C\30A2\30AF\30B7\30E7\30F3\300D\30DA\30FC\30B8\306E\300C\30A4\30D9\30F3\30C8\6709\52B9\7BC4\56F2\300D\306E<em>\300C\5F71\97FF\3092\53D7\3051\308B\8981\7D20\300D</em> &gt; <em>\300C\9078\629E\30BF\30A4\30D7\300D</em>\3067\30A2\30A4\30C6\30E0\30FB\30D8\30EB\30D7\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103875153666308304)
,p_name=>'PE.PROPERTY.WHEN_REGION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103875050907308304)
,p_name=>'PE.PROPERTY.WHEN_TYPE.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30D9\30F3\30C8\306E\30C8\30EA\30AC\30FC\306B\4F7F\7528\3055\308C\308B\30DA\30FC\30B8\8981\7D20\307E\305F\306F\69CB\9020\4F53\306E\30BF\30A4\30D7\3092\9078\629E\3057\307E\3059\3002\7279\5B9A\306E\9078\629E\30BF\30A4\30D7\306E\4F7F\7528\4F8B\306F\3001\95A2\9023\3059\308B\5C5E\6027\306E\30D8\30EB\30D7\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104386926354308747)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.BUTTON.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104688378302308990)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.BUTTON.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3\306B\3088\3063\3066\30C8\30EA\30AC\30FC\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104735085898309031)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.COLUMN.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104688505043308991)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.COLUMN.HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('1\3064\4EE5\4E0A\306E\5217\306B\3088\3063\3066\30C8\30EA\30AC\30FC\3055\308C\307E\3059\3002'' );'),
'    --',
'    store_property_lov_values (',
'        p_property_id   => l_property_id,',
'        p_display_value => ''DOM Object'',',
'        p_return_value  => ''DOM_OBJECT'',',
'        p_is_deprecated => ''Y'',',
unistr('        p_help_text     => q''~<p>DOM\30AA\30D6\30B8\30A7\30AF\30C8(<code>document</code>\3001<code>window</code>)\307E\305F\306FDOM\30AA\30D6\30B8\30A7\30AF\30C8\306E<em>ID</em> (<code>myElementID</code>)\306B\3088\3063\3066\30C8\30EA\30AC\30FC\3055\308C\307E\3059\3002</p>'),
unistr('        <p>\30CE\30FC\30C8: <em>DOM\30AA\30D6\30B8\30A7\30AF\30C8</em>\306F\975E\63A8\5968\3067\3059\3002<em>JavaScript\5F0F</em>\307E\305F\306F<em>jQuery\30BB\30EC\30AF\30BF</em>\3067\7F6E\304D\63DB\3048\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104386864445308747)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.ITEM.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104688205746308990)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.ITEM.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('1\3064\4EE5\4E0A\306E\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306B\3088\3063\3066\30C8\30EA\30AC\30FC\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104731780385309028)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.JAVASCRIPT_EXPRESSION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('JavaScript\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104688705707308991)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.JAVASCRIPT_EXPRESSION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('JavaScript\5F0F\306B\3088\3063\3066\623B\3055\308C\308B\30DA\30FC\30B8\8981\7D20\306B\3088\3063\3066\30C8\30EA\30AC\30FC\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104387177531308747)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.JQUERY_SELECTOR.D'
,p_message_language=>'ja'
,p_message_text=>unistr('jQuery\30BB\30EC\30AF\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104688664044308991)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.JQUERY_SELECTOR.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('jQuery\30BB\30EC\30AF\30BF\306B\3088\3063\3066\623B\3055\308C\308B1\3064\4EE5\4E0A\306E\30DA\30FC\30B8\8981\7D20\306B\3088\3063\3066\30C8\30EA\30AC\30FC\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104387001038308747)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.REGION.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104688467174308990)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.REGION.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\306B\3088\3063\3066\30C8\30EA\30AC\30FC\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103874982763308304)
,p_name=>'PE.PROPERTY.WHEN_TYPE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103930748688308382)
,p_name=>'PENDING'
,p_message_language=>'ja'
,p_message_text=>unistr('\4FDD\7559\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104021131152308452)
,p_name=>'PENDING_ENTRIES'
,p_message_language=>'ja'
,p_message_text=>unistr('\4FDD\7559\4E2D\306E\30A8\30F3\30C8\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104029862784308459)
,p_name=>'PENDING_REQUESTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\4FDD\7559\4E2D\306E\30EA\30AF\30A8\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104051942262308477)
,p_name=>'PERCENT_CLOSED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30ED\30FC\30BA\7387')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104049859864308475)
,p_name=>'PERCENT_COMPLETE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B8C\4E86\7387')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104052013905308477)
,p_name=>'PERCENT_OPENED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30FC\30D7\30F3\7387')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104009097276308442)
,p_name=>'PIE_CHART'
,p_message_language=>'ja'
,p_message_text=>unistr('\5186\30B0\30E9\30D5')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104031138520308460)
,p_name=>'PKC1'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E3B\30AD\30FC\52171')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104031244185308460)
,p_name=>'PKC2'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E3B\30AD\30FC\52172')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104723404427309019)
,p_name=>'PKG.APP.AVAILABLE.TO.INSTALL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30B9\30C8\30FC\30EB\306B\4F7F\7528\53EF\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104723529937309019)
,p_name=>'PKG.APP.AVAILABLE.TO.UPGRADE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30C3\30D7\30B0\30EC\30FC\30C9\306B\4F7F\7528\53EF\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104723660486309019)
,p_name=>'PKG.APP.EVENTS_FOR_LAST_X'
,p_message_language=>'ja'
,p_message_text=>unistr('\751F\7523\6027/\30B5\30F3\30D7\30EB\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30A4\30D9\30F3\30C8: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104727010354309022)
,p_name=>'PKG.APP.USER_ACTIVITY'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\30E6\30FC\30B6\30FC - %1\30D3\30E5\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104766729702309063)
,p_name=>'PKG_APP_INSTALL.PREREQ_CHECK_FAILED'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6B21\306E\524D\63D0\6761\4EF6\306E\30C1\30A7\30C3\30AF\306B\5931\6557\3057\307E\3057\305F\3002\3053\308C\3089\306E\554F\984C\304C\89E3\6C7A\3059\308B\307E\3067\3001\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304A\3088\3073\30B5\30DD\30FC\30C8\3059\308B\30AA\30D6\30B8\30A7\30AF\30C8\306E\30A4\30F3\30B9\30C8\30FC\30EB\306F\7D9A\884C\3067\304D\307E\305B\3093\3002</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104766991380309063)
,p_name=>'PKG_APP_INSTALL.SUP_OBJ_EXISTS'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30AA\30D6\30B8\30A7\30AF\30C8\304C\5B58\5728: <br />'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104766852784309063)
,p_name=>'PKG_APP_INSTALL.SUP_OBJ_REQUIRED_PRIVS'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5FC5\8981\306A\6A29\9650: <br />'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104752003974309044)
,p_name=>'PKG_APP_USER_TYPE_DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30DA\30FC\30B8\3092\4F7F\7528\3057\3066\3001Application Express\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9\7BA1\7406\8005\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\958B\767A\8005\304A\3088\3073\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306E\30A2\30AF\30BB\30B9\3092\5236\5FA1\3057\307E\3059\3002</p>'),
'',
unistr('<p><strong>\30EF\30FC\30AF\30B9\30DA\30FC\30B9\7BA1\7406\8005</strong>\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30A4\30F3\30B9\30C8\30FC\30EB\3001\524A\9664\307E\305F\306F\30A2\30C3\30D7\30B0\30EC\30FC\30C9\306B\52A0\3048\3001\30E6\30FC\30B6\30FC\30FB\30A2\30AB\30A6\30F3\30C8\304A\3088\3073\958B\767A\30B5\30FC\30D3\30B9\306E\7BA1\7406\304C\53EF\80FD\3067\3059\3002</p>'),
'',
unistr('<p><strong>\958B\767A\8005</strong>\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30A4\30F3\30B9\30C8\30FC\30EB\3001\524A\9664\307E\305F\306F\30A2\30C3\30D7\30B0\30EC\30FC\30C9\304C\53EF\80FD\3067\3059\3002</p>'),
'',
unistr('<p><strong>\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC</strong>\306F\3001\958B\767A\6A29\9650\3092\6240\6709\305B\305A\3001\5916\90E8\8A8D\8A3C\30B9\30AD\30FC\30E0\3092\4F7F\7528\3057\306A\3044\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3078\306E\30A2\30AF\30BB\30B9\306E\307F\304C\53EF\80FD\3067\3059\3002</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104723347060309019)
,p_name=>'PLEASE_SELECT_A_WORKSPACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306B\793A\3059\30EA\30B9\30C8\304B\3089\30EF\30FC\30AF\30B9\30DA\30FC\30B9\3092\9078\629E\3057\3066\304F\3060\3055\3044')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103993011623308430)
,p_name=>'PLSQL'
,p_message_language=>'ja'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103806840456308252)
,p_name=>'PLSQL_EXPRESSION'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104059723500308483)
,p_name=>'PLSQL_FUNCTION_BODY_LOV_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\6587\3092\623B\3059PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\306B\57FA\3065\304FLOV\306B\306F\30A8\30E9\30FC\304C\542B\307E\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103752843641308210)
,p_name=>'PLSQL_PROCEDURE'
,p_message_language=>'ja'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103999381111308435)
,p_name=>'PLSQL_REGION'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\30EA\30FC\30B8\30E7\30F3')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104294387193308678)
,p_name=>'PLUG-IN FILES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30E9\30B0\30A4\30F3\30FB\30D5\30A1\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104272769911308662)
,p_name=>'PLUGIN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30E9\30B0\30A4\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104676980435308981)
,p_name=>'PLUGIN.CATEGORY.COMPONENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30DD\30FC\30CD\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104676643471308980)
,p_name=>'PLUGIN.CATEGORY.EFFECT'
,p_message_language=>'ja'
,p_message_text=>unistr('\52B9\679C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104676802942308980)
,p_name=>'PLUGIN.CATEGORY.EXECUTE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9F\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104727700102309023)
,p_name=>'PLUGIN.CATEGORY.INIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\521D\671F\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104676476924308980)
,p_name=>'PLUGIN.CATEGORY.MISC'
,p_message_language=>'ja'
,p_message_text=>unistr('\305D\306E\4ED6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104667761325308973)
,p_name=>'PLUGIN.CATEGORY.NAVIGATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CA\30D3\30B2\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104676793054308980)
,p_name=>'PLUGIN.CATEGORY.NOTIFICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\901A\77E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104676532821308980)
,p_name=>'PLUGIN.CATEGORY.STYLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30BF\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104226677921308629)
,p_name=>'PLUGIN.DEPRECATED'
,p_message_language=>'ja'
,p_message_text=>unistr(' [\975E\63A8\5968]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104012898913308445)
,p_name=>'PLUGIN.DISPLAY_NAME_POSTFIX'
,p_message_language=>'ja'
,p_message_text=>unistr(' [\30D7\30E9\30B0\30A4\30F3]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104559151909308886)
,p_name=>'PLUGIN.LEGACY'
,p_message_language=>'ja'
,p_message_text=>unistr(' [\30EC\30AC\30B7\30FC]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104179272468308592)
,p_name=>'PLUGIN.TYPE.AUTHENTICATION_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\30B9\30AD\30FC\30E0\30FB\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103558923680308058)
,p_name=>'PLUGIN.TYPE.AUTHORIZATION TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\53EF\30B9\30AD\30FC\30E0\30FB\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103626653064308107)
,p_name=>'PLUGIN.TYPE.DYNAMIC ACTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\52D5\7684\30A2\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103626091354308107)
,p_name=>'PLUGIN.TYPE.ITEM TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104324223891308700)
,p_name=>'PLUGIN.TYPE.PROCESS TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30BB\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103626169720308107)
,p_name=>'PLUGIN.TYPE.REGION TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104043489307308470)
,p_name=>'PLUGIN.TYPE.REPORT COLUMN TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104788660815309080)
,p_name=>'PLUGIN_LINK_HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>URL\3092\5165\529B\3057\3066\3044\308B\5834\5408\3001<code>&amp;APP_ID.</code>\3001<code>&amp;SESSION.</code>\304A\3088\3073<code>&amp;DEBUG.</code>\7F6E\63DB\6587\5B57\5217\3068<code>&amp;COLUMN_NAME.</code>\69CB\6587\3092\4F7F\7528\3057\3066\3001\30BF\30FC\30B2\30C3\30C8\30FB\30DA\30FC\30B8\306E\884CID\307E\305F\306F\4E3B\30AD\30FC\3092\8A2D\5B9A\3059\308B\304B\3001\8FFD\52A0\306E\5C5E\6027\5024\3092\8A2D\5B9A\3057\307E\3059\3002</p>'),
unistr('<p><strong>\4F8B</strong></p>'),
'<p><pre>f?p=&amp;APP_ID.:10:&amp;SESSION.::&amp;DEBUG.:10:P10_EMPNO:&amp;EMPNO.</pre></p>',
unistr('<p><code>f?p</code>\69CB\6587\306E\8A73\7D30\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30D3\30EB\30C0\30FC\30FB\30E6\30FC\30B6\30FC\30BA\30FB\30AC\30A4\30C9\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104044583368308471)
,p_name=>'PLUGIN_SUCCESS_MSG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30E9\30B0\30A4\30F3\306F\6B63\5E38\306B\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104376249268308738)
,p_name=>'PNONUS'
,p_message_language=>'ja'
,p_message_text=>unistr('\56FD\5916\306E\5F93\696D\54E1\306E\5272\5408')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103754668454308211)
,p_name=>'POPUP_LOV'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DD\30C3\30D7\30A2\30C3\30D7LOV')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104093108081308511)
,p_name=>'POPUP_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DD\30C3\30D7\30A2\30C3\30D7LOV\30C6\30F3\30D7\30EC\30FC\30C8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104053512397308478)
,p_name=>'POST AUTH PROCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\5F8C\306E\51E6\7406')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104053330279308478)
,p_name=>'PRE AUTH PROCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\524D\306E\51E6\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103936687057308387)
,p_name=>'PRECISION'
,p_message_language=>'ja'
,p_message_text=>unistr('\7CBE\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104273938771308663)
,p_name=>'PREFERENCES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30EA\30D5\30A1\30EC\30F3\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103745746847308204)
,p_name=>'PREFS_APPLY_PERMISSIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A29\9650\306E\9069\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103746309130308205)
,p_name=>'PREFS_NOACTION_REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3\306F\5FC5\8981\3042\308A\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103746049901308204)
,p_name=>'PREFS_REVOKE_PERMISSIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A29\9650\3092\53D6\6D88\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103611844971308096)
,p_name=>'PREF_EQ_EXP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5F0F\306E\30D7\30EA\30D5\30A1\30EC\30F3\30B9\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103611978027308096)
,p_name=>'PREF_NE_EXP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5F0F1\306E\30D7\30EA\30D5\30A1\30EC\30F3\30B9\306E\5024 != \5F0F2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103713933995308179)
,p_name=>'PRESENTATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30EC\30BC\30F3\30C6\30FC\30B7\30E7\30F3')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103773594528308226)
,p_name=>'PRINT SERVER NOT CONFIGURED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\51FA\529B\306F\3001\73FE\5728\4F7F\7528\3067\304D\307E\305B\3093\3002\30D7\30EA\30F3\30C8\30FB\30B5\30FC\30D0\30FC\304C\69CB\6210\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104021535320308452)
,p_name=>'PRINT_SERVER_ADVANCED'
,p_message_language=>'ja'
,p_message_text=>unistr('\62E1\5F35(Oracle BI Publisher\304C\5FC5\8981)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104021677348308452)
,p_name=>'PRINT_SERVER_STANDARD'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A19\6E96')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104006756889308440)
,p_name=>'PRIORITIZED'
,p_message_language=>'ja'
,p_message_text=>unistr('\512A\5148\5EA6\3042\308A')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104017289070308448)
,p_name=>'PROBLEMS_CORRECTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\554F\984C\4FEE\6B63\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104017125237308448)
,p_name=>'PROBLEMS_IDENTIFIED'
,p_message_language=>'ja'
,p_message_text=>unistr('\554F\984C\7279\5B9A\6E08')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103751579300308209)
,p_name=>'PROCEDURE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30B7\30FC\30B8\30E3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104665021713308971)
,p_name=>'PROCESS.NATIVE_DATA_LOADING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\306E\30ED\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103529162474308037)
,p_name=>'PROCESS.NATIVE_PLSQL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30FC\30C9\3092\5B9F\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103529247615308037)
,p_name=>'PROCESS.NATIVE_SEND_EMAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\306E\9001\4FE1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103615892731308099)
,p_name=>'PROCESSES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30BB\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103549310268308051)
,p_name=>'PROCESSING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30AF\30A8\30B9\30C8\3092\51E6\7406\3057\3066\3044\307E\3059\3002\304A\5F85\3061\304F\3060\3055\3044\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104338833278308711)
,p_name=>'PRODUCTION_DOWN'
,p_message_language=>'ja'
,p_message_text=>unistr('\672C\756A\306E\505C\6B62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104739133320309034)
,p_name=>'PRODUCT_PORTAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\88FD\54C1\30DD\30FC\30BF\30EB')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104753926027309045)
,p_name=>'PROMPT_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30F3\30D7\30C8: %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103568952410308065)
,p_name=>'PROVIDER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30D0\30A4\30C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103569071346308065)
,p_name=>'PROVIDER_EMAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30D0\30A4\30C0\96FB\5B50\30E1\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104025973441308455)
,p_name=>'PROVISIONED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30D3\30B8\30E7\30CB\30F3\30B0\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104140410370308550)
,p_name=>'PROVISIONED_SPACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E2\5B58\306E\30D7\30ED\30D3\30B8\30E7\30CB\30F3\30B0\6E08\9818\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104021761075308452)
,p_name=>'PROVISIONING_MODE_EMAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\96FB\5B50\30E1\30FC\30EB\306E\691C\8A3C\300D\3067\306E\30E6\30FC\30B6\30FC\30FB\30EA\30AF\30A8\30B9\30C8\306B\3088\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104021961315308452)
,p_name=>'PROVISIONING_MODE_MANUAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\624B\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104021817675308452)
,p_name=>'PROVISIONING_MODE_REQUEST'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\30FB\30EA\30AF\30A8\30B9\30C8\306B\3088\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103760107950308216)
,p_name=>'PROVISION_REQUEST.ADMIN_INFO'
,p_message_language=>'ja'
,p_message_text=>unistr('\7BA1\7406\8005\60C5\5831')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103761122608308216)
,p_name=>'PROVISION_REQUEST.CREATE_TBLSPACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F5C\6210\3055\308C\308B\8868\9818\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103761355104308217)
,p_name=>'PROVISION_REQUEST.DATAFILE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\9818\57DF\7528\306E\30C7\30FC\30BF\30D5\30A1\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103759949952308215)
,p_name=>'PROVISION_REQUEST.DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\8AAC\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103760360608308216)
,p_name=>'PROVISION_REQUEST.EMAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103761271865308216)
,p_name=>'PROVISION_REQUEST.FLOW_XXX'
,p_message_language=>'ja'
,p_message_text=>'APEX_XXX'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103759698852308215)
,p_name=>'PROVISION_REQUEST.NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\540D\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103759433264308215)
,p_name=>'PROVISION_REQUEST.NEW'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F%0\306E\30D7\30ED\30D3\30B8\30E7\30CB\30F3\30B0\3092\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103760972336308216)
,p_name=>'PROVISION_REQUEST.NO'
,p_message_language=>'ja'
,p_message_text=>unistr('\3044\3044\3048')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103760792726308216)
,p_name=>'PROVISION_REQUEST.REUSE_SCHEMA'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E2\5B58\306E\30B9\30AD\30FC\30DE\306E\518D\5229\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103760689883308216)
,p_name=>'PROVISION_REQUEST.SCHEMA_INFO'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AD\30FC\30DE\60C5\5831')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103761050582308216)
,p_name=>'PROVISION_REQUEST.SCHEMA_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AD\30FC\30DE\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103759738061308215)
,p_name=>'PROVISION_REQUEST.SGID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103759885831308215)
,p_name=>'PROVISION_REQUEST.SYSTEM_ASSIGNED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30B9\30C6\30E0\5272\5F53\3066\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103760414391308216)
,p_name=>'PROVISION_REQUEST.TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30C8\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103760289803308216)
,p_name=>'PROVISION_REQUEST.USER_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103759522732308215)
,p_name=>'PROVISION_REQUEST.WORKSPACE_INFO'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\60C5\5831')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103760824727308216)
,p_name=>'PROVISION_REQUEST.YES'
,p_message_language=>'ja'
,p_message_text=>unistr('\306F\3044')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104064917717308487)
,p_name=>'PROXY_SERVER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30AD\30B7\30FB\30B5\30FC\30D0\30FC')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103746897160308205)
,p_name=>'PUBLISH_ITEM_HELP.CONFIRM'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\30A2\30A4\30C6\30E0\30FB\30D8\30EB\30D7\3092\30EA\30D5\30EC\30C3\30B7\30E5\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103746974734308205)
,p_name=>'PUBLISH_ITEM_HELP.CONFIRM2'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\308C\304C\6B63\3057\3044\5834\5408\306F\3001\300C\3059\3079\3066\3092\30EA\30D5\30EC\30C3\30B7\30E5\300D\3092\30AF\30EA\30C3\30AF\3057\3066\304F\3060\3055\3044\3002\6B63\3057\304F\306A\3044\5834\5408\306F\3001\300C\53D6\6D88\300D\3092\30AF\30EA\30C3\30AF\3057\3066\304F\3060\3055\3044\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104370677777308734)
,p_name=>'PURGE.ADMINISTRATORS'
,p_message_language=>'ja'
,p_message_text=>unistr('\7BA1\7406\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104366389427308731)
,p_name=>'PURGE.BEGIN_DELETE_WORKSPACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9%0\306E\524A\9664\306E\958B\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104366120203308731)
,p_name=>'PURGE.BEGIN_DROP_TABLESPACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\9818\57DF%0(\30EF\30FC\30AF\30B9\30DA\30FC\30B9%1)\306E\524A\9664\306E\958B\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104365786565308731)
,p_name=>'PURGE.BEGIN_DROP_USER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC%0(\30EF\30FC\30AF\30B9\30DA\30FC\30B9%1)\306E\524A\9664\306E\958B\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104365379059308730)
,p_name=>'PURGE.BEGIN_PURGE_OF_WORKSPACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9%0\306E\30D1\30FC\30B8\306E\958B\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104370587952308734)
,p_name=>'PURGE.BYTES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D0\30A4\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104366667568308731)
,p_name=>'PURGE.DELETE_WORKSPACE_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9%0\306E\524A\9664\4E2D\306E\30A8\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104366266903308731)
,p_name=>'PURGE.DROP_TABLESPACE_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\9818\57DF%0(\30EF\30FC\30AF\30B9\30DA\30FC\30B9%1)\306E\524A\9664\4E2D\306E\30A8\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104366095791308731)
,p_name=>'PURGE.DROP_USER_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC%0(\30EF\30FC\30AF\30B9\30DA\30FC\30B9%1)\306E\524A\9664\4E2D\306E\30A8\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104365138073308730)
,p_name=>'PURGE.EMAIL_BODY'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Oracle APEX\30E6\30FC\30B6\30FC\306E\65B9\3078'),
'',
unistr('%1\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9%0\306B\306F\6700\8FD1\306E\30A2\30AF\30C6\30A3\30D3\30C6\30A3\304C\3042\308A\307E\305B\3093\3002\975E\30A2\30AF\30C6\30A3\30D6\306A\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306F%2\4EE5\964D\306B\30D1\30FC\30B8\3055\308C\308B\3053\3068\304C\73FE\5728\4E88\5B9A\3055\308C\3066\3044\307E\3059\3002'),
'',
unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\3092\524A\9664\3057\306A\3044\5834\5408\306F\3001\4E0B\306EURL\3092\30AF\30EA\30C3\30AF\3057\3066\30EF\30FC\30AF\30B9\30DA\30FC\30B9\3092\524A\9664\3057\306A\3044\3053\3068\3092\9078\629E\3057\3066\304F\3060\3055\3044\3002\3053\306E\4F5C\696D\306F\672C\65E5\304B\3089%3\65E5\4EE5\5185\306B\884C\3063\3066\304F\3060\3055\3044\3002\3053\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9\304C\3082\3046\5FC5\8981\306A\3044\5834\5408\306F\3001\64CD\4F5C\306F\4E0D\8981\3067\3059\3002'),
'',
unistr('\78BA\8A8D\7528\30EA\30F3\30AF:  %4')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104365205814308730)
,p_name=>'PURGE.EMAIL_SUBJECT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30FC\30B8\4E88\5B9A\306EOracle APEX\30EF\30FC\30AF\30B9\30DA\30FC\30B9:   %1\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104366457933308731)
,p_name=>'PURGE.END_DELETE_WORKSPACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9%0\306E\524A\9664\306E\7D42\4E86')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104677347341308981)
,p_name=>'PURGE.END_DROP_TABLESPACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\9818\57DF%0(\30EF\30FC\30AF\30B9\30DA\30FC\30B9%1)\306E\524A\9664\306E\7D42\4E86')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104365935395308731)
,p_name=>'PURGE.END_DROP_USER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC%0(\30EF\30FC\30AF\30B9\30DA\30FC\30B9%1)\306E\524A\9664\306E\7D42\4E86')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104363276917308729)
,p_name=>'PURGE.LOG.ADD_TO_PURGE_LIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9%0\3092\30D1\30FC\30B8\30FB\30EA\30B9\30C8\306B\8FFD\52A0\3057\3066\3044\307E\3059\3002\975E\30A2\30AF\30C6\30A3\30D6\65E5\306F%1\65E5\4EE5\4E0A\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104363300983308729)
,p_name=>'PURGE.LOG.REMOVE_FROM_PURGE_LIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\8FD1\306E\30A2\30AF\30C6\30A3\30D3\30C6\30A3\306E\7D50\679C\3001\30EF\30FC\30AF\30B9\30DA\30FC\30B9%0\3092\30D1\30FC\30B8\30FB\30EA\30B9\30C8\304B\3089\524A\9664\3057\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104363459536308729)
,p_name=>'PURGE.LOG.SENT_EMAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306B\9001\4FE1\3055\308C\305F\96FB\5B50\30E1\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104363809270308729)
,p_name=>'PURGE.MOVED_TO_PURGE_LIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\4FDD\6301\30EA\30B9\30C8\304B\3089\30D1\30FC\30B8\30FB\30EA\30B9\30C8\306B\30EF\30FC\30AF\30B9\30DA\30FC\30B9%0\3092\79FB\52D5\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104369740947308734)
,p_name=>'PURGE.REPORT_BYTES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D0\30A4\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104367149932308732)
,p_name=>'PURGE.REPORT_COUNT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4EF6\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104369679187308734)
,p_name=>'PURGE.REPORT_DATAFILES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D5\30A1\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104369355842308733)
,p_name=>'PURGE.REPORT_SCHEMAS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AD\30FC\30DE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104367023638308732)
,p_name=>'PURGE.REPORT_STATUS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30C6\30FC\30BF\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104367419945308732)
,p_name=>'PURGE.REPORT_SUMMARY_DELETE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30FC\30B8\30FB\30EA\30B9\30C8\304B\3089\524A\9664\6E08(\6700\8FD1\306E\30A2\30AF\30C6\30A3\30D3\30C6\30A3\306E\7D50\679C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104368181363308732)
,p_name=>'PURGE.REPORT_SUMMARY_MOVED_TO_NEW'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30FC\30B8\30FB\30EA\30B9\30C8\306B\518D\3073\8FFD\52A0(\4FDD\6301\3055\308C\3066\3044\307E\3057\305F\304C%0\65E5\9593\30A2\30AF\30C6\30A3\30D3\30C6\30A3\304C\3042\308A\307E\305B\3093)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104367894605308732)
,p_name=>'PURGE.REPORT_SUMMARY_NEW'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30FC\30B8\30FB\30EA\30B9\30C8\306B\65B0\3057\304F\8FFD\52A0\6E08(%0\65E5\9593\306F\975E\30A2\30AF\30C6\30A3\30D6)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104368738196308733)
,p_name=>'PURGE.REPORT_SUMMARY_PURGED_TODAY'
,p_message_language=>'ja'
,p_message_text=>unistr('\672C\65E5\30D1\30FC\30B8\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104367648593308732)
,p_name=>'PURGE.REPORT_SUMMARY_RETAIN'
,p_message_language=>'ja'
,p_message_text=>unistr('\4FDD\6301(\7BA1\7406\8005\304C\30EF\30FC\30AF\30B9\30DA\30FC\30B9\3092\30D1\30FC\30B8\3057\306A\3044\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104368311616308733)
,p_name=>'PURGE.REPORT_SUMMARY_TO_BE_PURGED'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\65E5\5F8C\306B\30D1\30FC\30B8\4E88\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104369472792308733)
,p_name=>'PURGE.REPORT_TABLESPACES'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\9818\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104369247528308733)
,p_name=>'PURGE.REPORT_WORKSPACES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104368855014308733)
,p_name=>'PURGE.REPORT_WORKSPACES_REMAINING'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B8B\308A\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104363644155308729)
,p_name=>'PURGE.SAVE_RESPONSE'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB%0\5024/%1\304B\3089\306E\30EC\30B9\30DD\30F3\30B9\3092\8A18\9332\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104370354981308734)
,p_name=>'PURGE.SCHEMA'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AD\30FC\30DE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104365434468308730)
,p_name=>'PURGE.SET_SCHEMA_STATUS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AD\30FC\30DE%0\306E\30B9\30C6\30FC\30BF\30B9\3092\30B9\30C6\30FC\30BF\30B9%1\306B\3001\30EF\30FC\30AF\30B9\30DA\30FC\30B9%2\306B\304A\3044\3066\8A2D\5B9A\3057\3066\3044\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104365500164308731)
,p_name=>'PURGE.SET_TABLESPACE_STATUS'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\9818\57DF%0\306E\30B9\30C6\30FC\30BF\30B9\3092\30B9\30C6\30FC\30BF\30B9%1\306B\3001\30EF\30FC\30AF\30B9\30DA\30FC\30B9%2\306B\304A\3044\3066\8A2D\5B9A\3057\3066\3044\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104375841910308738)
,p_name=>'PURGE.SUBJECT_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('Application Express\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9\30D1\30FC\30B8\306E\65E5\6B21\30B5\30DE\30EA\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104370497765308734)
,p_name=>'PURGE.TABLESPACE_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\9818\57DF\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104370922926308734)
,p_name=>'PURGE.WORKSPACES_ADDED_BACK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30FC\30B8\30FB\30EA\30B9\30C8\306B\518D\3073\8FFD\52A0\3055\308C\305F\30EF\30FC\30AF\30B9\30DA\30FC\30B9(\4FDD\6301\3055\308C\3066\3044\307E\3057\305F\304C%0\65E5\9593\30A2\30AF\30C6\30A3\30D3\30C6\30A3\304C\3042\308A\307E\305B\3093)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104370887310308734)
,p_name=>'PURGE.WORKSPACES_NEWLY_ADDED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30FC\30B8\30FB\30EA\30B9\30C8\306B\65B0\3057\304F\8FFD\52A0\3055\308C\305F\30EF\30FC\30AF\30B9\30DA\30FC\30B9(%0\65E5\9593\306F\975E\30A2\30AF\30C6\30A3\30D6)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104369816351308734)
,p_name=>'PURGE.WORKSPACES_PURGED_SUMMARY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30FC\30B8\3057\305F\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306E\30B5\30DE\30EA\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104370095113308734)
,p_name=>'PURGE.WORKSPACES_PURGED_TODAY'
,p_message_language=>'ja'
,p_message_text=>unistr('\672C\65E5\30D1\30FC\30B8\3057\305F\30EF\30FC\30AF\30B9\30DA\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104371033996308735)
,p_name=>'PURGE.WORKSPACES_REMOVED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30FC\30B8\30FB\30EA\30B9\30C8\304B\3089\524A\9664\3055\308C\305F\30EF\30FC\30AF\30B9\30DA\30FC\30B9(\6700\8FD1\306E\30A2\30AF\30C6\30A3\30D3\30C6\30A3\306E\7D50\679C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104371173438308735)
,p_name=>'PURGE.WORKSPACES_RETAINED'
,p_message_language=>'ja'
,p_message_text=>unistr('\4FDD\6301\3055\308C\305F\30EF\30FC\30AF\30B9\30DA\30FC\30B9(\7BA1\7406\8005\304C\30EF\30FC\30AF\30B9\30DA\30FC\30B9\3092\30D1\30FC\30B8\3057\306A\3044\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104370712068308734)
,p_name=>'PURGE.WORKSPACES_TO_BE_PURGED'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\65E5\5F8C\306B\30D1\30FC\30B8\4E88\5B9A\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104370209383308734)
,p_name=>'PURGE.WORKSPACE_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104366905546308732)
,p_name=>'PURGE.WORKSPACE_PURGE_COMPLETE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9%0\306E\30D1\30FC\30B8\304C\5B8C\4E86\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104668861006308974)
,p_name=>'PURGED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30FC\30B8\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104753537935309045)
,p_name=>'PURGE_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30FC\30B8: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104131084834308542)
,p_name=>'QB_ACTIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('&nbsp;\30A2\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103808286218308253)
,p_name=>'QB_CREATE_QUERY'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D50\679C\3092\8868\793A\3059\308B\306B\306F\3001\6709\52B9\306A\554F\5408\305B\3092\5165\529B\3057\3066\304F\3060\3055\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104130892244308542)
,p_name=>'QB_DUPLICATE_QUERY'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30AF\30A8\30EA\30FC\30FB\30D3\30EB\30C0\30FC\307E\305F\306FSQL\30B3\30DE\30F3\30C9\30FB\30D7\30ED\30BB\30C3\30B5\306E\65E2\5B58\306E\554F\5408\305B\3067\3059\3067\306B\4F7F\7528\3055\308C\3066\3044\308B\540D\524D\3067\3059\3002<br> '),
unistr('\65B0\3057\3044\540D\524D\3092\9078\629E\3057\3066\3001\518D\5EA6\4FDD\5B58\3057\3066\304F\3060\3055\3044\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103989526552308427)
,p_name=>'QB_NOTHING_TO_SAVE'
,p_message_language=>'ja'
,p_message_text=>unistr('\4FDD\5B58\5BFE\8C61\304C\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103969740244308413)
,p_name=>'QB_SAVE_QUERY'
,p_message_language=>'ja'
,p_message_text=>unistr('\554F\5408\305B\304C\4FDD\5B58\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104136328184308547)
,p_name=>'QB_TABLE_ACTIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\306E\51E6\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104136469081308547)
,p_name=>'QB_VIEW_ACTIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\51E6\7406\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104089186249308507)
,p_name=>'QB_WARN_MESSAGE'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Visual Query Builder\3067\73FE\5728\306E\554F\5408\305B\3092\958B\304F\3053\3068\304C\3067\304D\307E\305B\3093\3002<br>'),
unistr('\300C\4F5C\6210\300D\3092\30AF\30EA\30C3\30AF\3057\3066\73FE\5728\306E\554F\5408\305B\3092\65B0\3057\3044\554F\5408\305B\306B\7F6E\304D\63DB\3048\3066\304F\3060\3055\3044\3002\73FE\5728\306E\554F\5408\305B\306E\307E\307E\306B\3059\308B\306B\306F\3001\300C\623B\308B\300D\3092\30AF\30EA\30C3\30AF\3057\3066\304F\3060\3055\3044\3002')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104089087933308507)
,p_name=>'QUERY'
,p_message_language=>'ja'
,p_message_text=>unistr('\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103614124478308098)
,p_name=>'QUERY BUILDER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30A8\30EA\30FC\30FB\30D3\30EB\30C0\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103781021931308232)
,p_name=>'QUERY.INVALID_NO_SELECT'
,p_message_language=>'ja'
,p_message_text=>unistr('\554F\5408\305B\304C\7121\52B9\3067\3059\3002SELECT\6587\304C\898B\3064\304B\308A\307E\305B\3093\3067\3057\305F\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103613953041308098)
,p_name=>'QUESTIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\8CEA\554F')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104333381909308707)
,p_name=>'QUICKPICK_NUMERIC_MASK'
,p_message_language=>'ja'
,p_message_text=>unistr('\6570\5024\66F8\5F0F\30DE\30B9\30AF: 999G999G999G999G990')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104139369774308549)
,p_name=>'QUICKSQL.ABOUT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30A4\30C3\30AFSQL\306B\3064\3044\3066')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104139454611308549)
,p_name=>'QUICKSQL.ABOUT.DETAIL'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30AF\30A4\30C3\30AFSQL\306F\3001\30A4\30F3\30C7\30F3\30C8\3055\308C\305F\30C6\30AD\30B9\30C8\30FB\30C9\30AD\30E5\30E1\30F3\30C8\304B\3089\30EA\30EC\30FC\30B7\30E7\30CA\30EB\30FB\30C7\30FC\30BF\30FB\30E2\30C7\30EB\3092\4F5C\6210\3059\308B\305F\3081\306B\5FC5\8981\306ASQL\3092\3059\3070\3084\304F\751F\6210\3059\308B\65B9\6CD5\3092\63D0\4F9B\3057\307E\3059\3002\3053\306E\30C4\30FC\30EB\306F\3001SQL\306E\8868\3001\30C8\30EA\30AC\30FC\3001\304A\3088\3073\7D22\5F15\69CB\9020\306E\4F5C\6210\306B\5FC5\8981\306A\6642\9593\3068\52B4\529B\3092\524A\6E1B\3059\308B\3088\3046\306B\8A2D\8A08\3055\308C\3066\3044\307E\3059\3002\3053\306E\30C4\30FC\30EB\306F\30C7\30FC\30BF\30FB\30E2\30C7\30EA\30F3\30B0\306E\4EE3\66FF\306B\306A\308B\3088\3046\306B\8A2D\8A08\3055\308C\305F\3082\306E\3067\306F\306A\304F\3001\5358\7D14\306A\8868\3084\30D3\30E5\30FC\7528\306E\30B9\30AF\30EA\30D7\30C8\3092\958B\767A\3059\308B\305F\3081\306E\7C21\5358\306A\65B9\6CD5\3067\3059\3002SQL\304C\751F\6210\3055\308C\308B\3068\3001\305D\308C\3092\5FAE\8ABF\6574\3057\3066\62E1\5F35\3067\304D\307E\3059\3002</p>'),
'',
unistr('<p>\4E0A\4F4D\306E\30E6\30FC\30B9\30B1\30FC\30B9\306F\6B21\306E\3068\304A\308A\3067\3059:'),
'<ul>',
unistr('  <li>\5805\7262\306A\30C7\30FC\30BF\30FB\30E2\30C7\30EB\3092\3059\3070\3084\304F\4F5C\6210</li>'),
unistr('  <li>\30AF\30A4\30C3\30AFSQL\77ED\7E2E\69CB\6587\3092\3001\30E2\30C7\30EB\5909\66F4\3092\53CD\5FA9\51E6\7406\3059\308B\305F\3081\306E\30E2\30C7\30EB\3068\3057\3066\4FDD\5B58\3001\307E\305F\306F\6B21\306E\30E2\30C7\30EB\8A2D\8A08\3092\52B9\7387\7684\306B\958B\59CB\3059\308B\305F\3081\306E\30C6\30F3\30D7\30EC\30FC\30C8\30FB\30E2\30C7\30EB\3068\3057\3066\4F7F\7528</li>'),
unistr('  <li>\30E9\30F3\30C0\30E0\30FB\30C7\30FC\30BF\3092\7C21\5358\306B\751F\6210</li>'),
unistr('  <li>\63D0\4F9B\3055\308C\305F\4F8B\3092\4F7F\7528\3057\305F\3001SQL\306E\8868\4F5C\6210\3001\9078\629E\3001\633F\5165\3001\7D22\5F15\3001\30C8\30EA\30AC\30FC\3001PL/SQL\30D1\30C3\30B1\30FC\30B8\304A\3088\3073\30D3\30E5\30FC\306E\69CB\6587\3092\5B66\7FD2</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104032290138308461)
,p_name=>'QUICKSQL.APEX_SETTING_PART1'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\3053\306E\8A2D\5B9A\306F\3001\76E3\67FB\5217\3092\30B5\30DD\30FC\30C8\3059\308B\305F\3081\306B\751F\6210\3055\308C\308B\69CB\6587\3092\5236\5FA1\3057\307E\3059\3002\7279\306B\3001\76E3\67FB\5217\304C\6709\52B9\306B\306A\3063\3066\3044\308B\5834\5408\306F\3001\30E6\30FC\30B6\30FC\304C\884C\3092\4F5C\6210\3057\3066\30E6\30FC\30B6\30FC\304C\6700\5F8C\306B\884C\3092\66F4\65B0\3059\308B\3088\3046\306B\30C8\30EA\30AC\30FC\304C\751F\6210\3055\308C\307E\3059\3002\6709\52B9\306B\3059\308B\3068\3001\6B21\306E\30D5\30A1\30F3\30AF\30B7\30E7\30F3\304C\4F7F\7528\3055\308C\307E\3059\3002'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104032391050308461)
,p_name=>'QUICKSQL.APEX_SETTING_PART2'
,p_message_language=>'ja'
,p_message_text=>unistr('\6709\52B9\306B\3057\306A\3044\3068\3001\6B21\306E\30D5\30A1\30F3\30AF\30B7\30E7\30F3\304C\4F7F\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104032426582308461)
,p_name=>'QUICKSQL.API_SETTING'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F5C\6210\3001\633F\5165\3001\66F4\65B0\3001\524A\9664\304A\3088\3073\554F\5408\305B\3092\884C\3046\3059\3079\3066\306E\8868\3067PL/SQL API\3092\751F\6210\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104032571200308461)
,p_name=>'QUICKSQL.AUDITCOLS'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F5C\6210\3055\308C\305F\3059\3079\3066\306E\8868\306B\3001created\3001created_by\3001updated\304A\3088\3073updated_by\5217\3092\8FFD\52A0\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104032606776308461)
,p_name=>'QUICKSQL.COMPRESS_SETTING'
,p_message_language=>'ja'
,p_message_text=>unistr('\6709\52B9\306B\3059\308B\3068\3001\3059\3079\3066\306E\8868\306F\5727\7E2E\3057\3066\4F5C\6210\3055\308C\307E\3059\3002\30C7\30D5\30A9\30EB\30C8\3067\306F\5727\7E2E\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104032758090308461)
,p_name=>'QUICKSQL.CREATEDBYCOL_SETTING'
,p_message_language=>'ja'
,p_message_text=>unistr('\76E3\67FB\5217\3092\6709\52B9\306B\3059\308B\3068\3001\884C\3092\4F5C\6210\3057\305F\30E6\30FC\30B6\30FC\306E\30C8\30E9\30C3\30AD\30F3\30B0\306B\4F7F\7528\3055\308C\308B\30C7\30D5\30A9\30EB\30C8\306E\5217\306FCREATED_BY\3067\3059\3002\3053\306E\8A2D\5B9A\3092\4F7F\7528\3057\3066\3001\30C7\30D5\30A9\30EB\30C8\306E\76E3\67FB\5217\540D\3092\30AA\30FC\30D0\30FC\30E9\30A4\30C9\3057\307E\3059\3002 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104032821761308461)
,p_name=>'QUICKSQL.CREATED_SETTING'
,p_message_language=>'ja'
,p_message_text=>unistr('\76E3\67FB\5217\3092\6709\52B9\306B\3059\308B\3068\3001\884C\3092\4F5C\6210\3057\305F\30E6\30FC\30B6\30FC\306E\30C8\30E9\30C3\30AD\30F3\30B0\306B\4F7F\7528\3055\308C\308B\30C7\30D5\30A9\30EB\30C8\306E\5217\306FCREATED\3067\3059\3002\3053\306E\8A2D\5B9A\3092\4F7F\7528\3057\3066\3001\30C7\30D5\30A9\30EB\30C8\306E\76E3\67FB\5217\540D\3092\30AA\30FC\30D0\30FC\30E9\30A4\30C9\3057\307E\3059\3002 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104034831171308463)
,p_name=>'QUICKSQL.DATE_SETTING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\3067\306F\3001\3059\3079\3066\306EDATE\5217\306FOracle DATE\30C7\30FC\30BF\578B\3092\4F7F\7528\3057\3066\4F5C\6210\3055\308C\307E\3059\3002\3053\306E\8A2D\5B9A\3092\4F7F\7528\3057\3066\3001\3053\306E\30C7\30D5\30A9\30EB\30C8\3092\30AA\30FC\30D0\30FC\30E9\30A4\30C9\3057\307E\3059\3002\6709\52B9\306A\5024\306F\6B21\306E\3068\304A\308A\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104037183115308465)
,p_name=>'QUICKSQL.DB_SETTING'
,p_message_language=>'ja'
,p_message_text=>unistr('\69CB\6587\3068\4E92\63DB\6027\306E\3042\308B\30C7\30FC\30BF\30D9\30FC\30B9\306E\30D0\30FC\30B8\30E7\30F3\3092\6307\5B9A\3057\307E\3059\3002\6709\52B9\306A\5024\306F\6B21\306E\3068\304A\308A\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104041545060308468)
,p_name=>'QUICKSQL.DEFAULT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104709143279309008)
,p_name=>'QUICKSQL.DEPARTMENTSANDEMPLOYEES'
,p_message_language=>'ja'
,p_message_text=>unistr('\90E8\9580\304A\3088\3073\5F93\696D\54E1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104709785014309008)
,p_name=>'QUICKSQL.DEPARTMENTSANDEMPLOYEES_DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\7D50\5408\30D3\30E5\30FC\3092\6301\3064DEPARTMENTS\8868\304A\3088\3073EMPLOYEES\8868\3092\4F5C\6210\3059\308B\77ED\7E2ESQL\69CB\6587\3067\3059\3002\30E9\30F3\30C0\30E0\30FB\30C7\30FC\30BF\306F\3001/INSERT\69CB\6587\3092\4F7F\7528\3057\3066\3082\751F\6210\3055\308C\307E\3059\3002/NN\306F\3001NOT NULL SQL\5217\5236\7D04\3092\8FFD\52A0\3057\307E\3059\3002\30A4\30F3\30C7\30F3\30C8\3055\308C\305F\30EA\30B9\30C8\306F\3001\8868\3001\5217\304A\3088\3073\5B50\8868\3092\5B9A\7FA9\3059\308B\305F\3081\306B\4F7F\7528\3055\308C\307E\3059\3002\4E3B\30AD\30FC\5217\304A\3088\3073\5916\90E8\30AD\30FC\5217\306F\81EA\52D5\7684\306B\8FFD\52A0\3055\308C\307E\3059\3002\4E3B\30AD\30FC\5217\307E\305F\306F\5916\90E8\30AD\30FC\5217\3092\6307\5B9A\3059\308B\5FC5\8981\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103961601160308406)
,p_name=>'QUICKSQL.DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\8AAC\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104040255482308467)
,p_name=>'QUICKSQL.DROP_SETTING'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F5C\6210\3055\308C\305F\5404\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30AA\30D6\30B8\30A7\30AF\30C8\3092\524A\9664\3059\308BSQL\30B3\30DE\30F3\30C9\3092\542B\3081\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104709352846309008)
,p_name=>'QUICKSQL.EMPLOYEESKILLS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5F93\696D\54E1\30B9\30AD\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104709537349309008)
,p_name=>'QUICKSQL.EMPLOYEESKILLS.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\89AA\8868\304A\3088\3073\5B50\8868\3092\8B58\5225\3059\308B\30A4\30F3\30C7\30F3\30C8\3092\4F7F\7528\3057\3066\3001DEPARTMENTS\3001EMPLOYEES\304A\3088\3073SKILLS\8868\3092\4F5C\6210\3057\307E\3059\3002\77ED\7E2E\69CB\6587VC255\306F\3001SQL\30C7\30FC\30BF\578B\306E\6307\5B9A\306B\4F7F\7528\3055\308C\307E\3059\3002/INSERT\69CB\6587\306F\3001\30E9\30F3\30C0\30E0\30FB\30C7\30FC\30BF\3092\751F\6210\3059\308B\305F\3081\306B\4F7F\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103961450048308406)
,p_name=>'QUICKSQL.EXAMPLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F8B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104139740344308549)
,p_name=>'QUICKSQL.EXAMPLE_N'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F8B%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104042213511308469)
,p_name=>'QUICKSQL.GENPK_SETTING'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\3054\3068\306BID\4E3B\30AD\30FC\5217\304C\81EA\52D5\7684\306B\751F\6210\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104139527137308549)
,p_name=>'QUICKSQL.GETTING_STARTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30BF\30FC\30C8\30FB\30AC\30A4\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104139621662308549)
,p_name=>'QUICKSQL.GETTING_STARTED.DETAIL'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30A4\30F3\30C7\30F3\30C8\305B\305A\306B\89AA\8868\540D\3092\5165\529B\3057\307E\3059\30022\3064\4EE5\4E0A\306E\7A7A\767D\306E\5747\4E00\306A\30A4\30F3\30C7\30F3\30C8\3067\8868\306E\5217\3092\5165\529B\3057\307E\3059\3002\901A\5E38\3001\4E3B\30AD\30FC\3092\6307\5B9A\3057\306A\3044\3053\3068\3092\304A\85A6\3081\3057\307E\3059\3002\30B7\30B9\30C6\30E0\306B\3088\308A\4E3B\30AD\30FC\304C\751F\6210\3055\308C\307E\3059\3002\89AA\5B50\95A2\4FC2\306F\3001\89AA\8868\306E\4E0B\306B\5B50\8868\3092\30A4\30F3\30C7\30F3\30C8\3059\308B\3060\3051\3067\4F5C\6210\3055\308C\307E\3059\3002</p>'),
'',
unistr('<p>\5225\306E\30C7\30FC\30BF\578B\306E\5217\306E\5217\540D\306E\672B\5C3E\306B\3001\7A7A\767D\3068NUM\3001INT\3001DATE\3092\8FFD\52A0\3059\308B\5834\5408\3001\30C7\30FC\30BF\578B\306F\901A\5E38VARCHAR2\306B\30C7\30D5\30A9\30EB\30C8\8A2D\5B9A\3055\308C\307E\3059\3002\6307\5B9A\3055\308C\305F\30C7\30FC\30BF\578B\304C\306A\3044\5834\5408\3001\5217\540D\306B\542B\307E\308C\308B\82F1\8A9E\306E\30C6\30AD\30B9\30C8\306B\57FA\3065\3044\3066\3001\30B7\30B9\30C6\30E0\3067\306F\3001\5217\540D\306B\3064\3044\3066\7D4C\9A13\306B\57FA\3065\3044\305F\63A8\6E2C\3092\884C\3044\307E\3059\3002\305F\3068\3048\3070\3001\5217\540D\306BDATE\3068\3044\3046\8A9E\304C\542B\307E\308C\3066\3044\308B\5834\5408\306F\65E5\4ED8\30C7\30FC\30BF\578B\306B\306A\308A\3001\5217\540D\306BNUMBER\307E\305F\306FNUM\3068\3044\3046\8A9E\304C\542B\307E\308C\3066\3044\308B\5834\5408\306F\6570\5024\30C7\30FC\30BF\578B\306B\306A\308A\307E\3059\3002\7279\5B9A\306EVARCHAR2\306E\9577\3055\3092\6307\5B9A\3059\308B\5834\5408\306F\300CVCn\300D\3068\5165\529B\3057\307E\3059\3002n\306FVARC')
||unistr('HAR2\306E\9577\3055\3067\3059\3002\300C\69CB\6587\300D\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\4F7F\7528\53EF\80FD\306A\69CB\6587\304C\8868\793A\3055\308C\307E\3059\3002\30AA\30D6\30B8\30A7\30AF\30C8\540D\306F\81EA\52D5\7684\306B\30D5\30A9\30FC\30DE\30C3\30C8\3055\308C\3001\7A7A\767D\306F\30A2\30F3\30C0\30FC\30B9\30B3\30A2\306B\7F6E\304D\63DB\3048\3089\308C\307E\3059\3002\305D\306E\305F\3081\3001\5217\540D\3068\8868\540D\306B\7A7A\767D\3092\4F7F\7528\3067\304D\307E\3059\3002</p>'),
'',
unistr('<p>\300C\8A2D\5B9A\300D\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\591A\304F\306E\751F\6210\30AA\30D7\30B7\30E7\30F3\304C\8868\793A\3055\308C\307E\3059\3002\81EA\52D5\7684\306B\30E6\30FC\30B6\30FC\5217(\305F\3068\3048\3070\7279\5B9A\306E\884C\306E\4F5C\6210\307E\305F\306F\6700\7D42\66F4\65B0\3092\884C\3063\305F\30E6\30FC\30B6\30FC\3068\305D\306E\65E5\6642)\3092\8FFD\52A0\3067\304D\307E\3059\3002\5404\884C\306E\66F4\65B0\6642\306B\81EA\52D5\7684\306B1\305A\3064\5897\5206\3059\308B\884C\9806\5E8F\5217\3092\8FFD\52A0\3067\304D\307E\3059\3002\884C\9806\5E8F\306F\3001\5931\308F\308C\305F\66F4\65B0\691C\51FA\3092\7C21\7565\5316\3059\308B\5834\5408\306B\4FBF\5229\3067\3059\3002\8868\3054\3068\306B\30D1\30C3\30B1\30FC\30B8\3092\63D0\4F9B\3057\3001\884C\306E\554F\5408\305B\3001\633F\5165\3001\66F4\65B0\304A\3088\3073\524A\9664\3092\884C\3046\30D7\30ED\30B7\30FC\30B8\30E3\3092\63D0\4F9B\3059\308BPL/SQL API\3082\751F\6210\3067\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104714401387309012)
,p_name=>'QUICKSQL.HELP.API'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\5185\306E\30C7\30FC\30BF\306E\554F\5408\305B\3001\633F\5165\3001\66F4\65B0\304A\3088\3073\524A\9664\3092\884C\3046PL/SQL\30D1\30C3\30B1\30FC\30B8API\3092\751F\6210\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104714537452309012)
,p_name=>'QUICKSQL.HELP.AUDIT'
,p_message_language=>'ja'
,p_message_text=>unistr('Oracle\76E3\67FB\3092\8FFD\52A0\3057\307E\3059\3002\30C7\30D5\30A9\30EB\30C8\306FAUDIT ALL ON [TABLE NAME]\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104714668186309012)
,p_name=>'QUICKSQL.HELP.AUDITCOLS'
,p_message_language=>'ja'
,p_message_text=>unistr('UPDATED\3001UPDATED_BY\3001INSERTED\304A\3088\3073INSERTED_BY\5217\3068\3001\5217\5024\3092\8A2D\5B9A\3059\308B\30C8\30EA\30AC\30FC\30FB\30ED\30B8\30C3\30AF\306F\3001\81EA\52D5\7684\306B\8FFD\52A0\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104713873992309012)
,p_name=>'QUICKSQL.HELP.BETWEEN'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\306Bbetween\30C1\30A7\30C3\30AF\5236\7D04\3092\8FFD\52A0\3057\307E\3059(\4F8B: /between 1 and 100)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104713213665309011)
,p_name=>'QUICKSQL.HELP.CHECK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30F3\30DE\307E\305F\306F\7A7A\767D\3067\533A\5207\3089\308C\305F\5024\3092\4F7F\7528\3057\305F\30C1\30A7\30C3\30AF\5236\7D04\3092\4F5C\6210\3057\307E\3059(\4F8B: /check Yes, No)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104043380904308470)
,p_name=>'QUICKSQL.HELP.COLPREFIX'
,p_message_language=>'ja'
,p_message_text=>unistr('\7279\5B9A\306E\8868\306E\3059\3079\3066\306E\5217\306B\3053\306E\5024\3092\63A5\982D\8F9E\3068\3057\3066\4ED8\3051\307E\3059\3002\6307\5B9A\3055\308C\3066\3044\306A\3044\5834\5408\306F\30A2\30F3\30C0\30FC\30B9\30B3\30A2\304C\81EA\52D5\7684\306B\8FFD\52A0\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104083435931308503)
,p_name=>'QUICKSQL.HELP.COLUMN_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104714269631309012)
,p_name=>'QUICKSQL.HELP.COMMENTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30E1\30F3\30C8\306F\3001\5927\30AB\30C3\30B3\307E\305F\306F\30C0\30C3\30B7\30E5\69CB\6587\3092\4F7F\7528\3057\3066\56F2\307F\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104714744224309012)
,p_name=>'QUICKSQL.HELP.COMPRESSED'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\306F\5727\7E2E\3057\3066\4F5C\6210\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104713385391309011)
,p_name=>'QUICKSQL.HELP.CONSTANT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\306E\751F\6210\6642\306B\3001\3053\306E\5217\3092\5B9A\6570\5024\306B\8A2D\5B9A\3057\307E\3059\3002\4F8B: /constant NYC\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104546649865308872)
,p_name=>'QUICKSQL.HELP.DEFAULT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\304CNULL\306E\5834\5408\306E\30C7\30D5\30A9\30EB\30C8\5024\3092\8FFD\52A0\3057\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104043227349308470)
,p_name=>'QUICKSQL.HELP.FILE_DATATYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('BLOB\5217\3092\8FFD\52A0\3057\3001\30D6\30E9\30A6\30B6\7D4C\7531\3067\30D5\30A1\30A4\30EB\306E\30C0\30A6\30F3\30ED\30FC\30C9\6A5F\80FD\3092\5F37\5316\3059\308B_FILENAME\3001_CHARSET\3001_MIMETYPE\3001_LASTUPD\5217\3092\8FFD\52A0\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104714014260309012)
,p_name=>'QUICKSQL.HELP.FK'
,p_message_language=>'ja'
,p_message_text=>unistr('\5916\90E8\30AD\30FC\53C2\7167(\4F8B: /references table_name)\3002\30E2\30C7\30EB\306E\4E00\90E8\3067\306F\306A\3044\8868\3092\53C2\7167\3067\304D\308B\3053\3068\306B\6CE8\610F\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104713905887309012)
,p_name=>'QUICKSQL.HELP.HIDDEN'
,p_message_language=>'ja'
,p_message_text=>unistr('select * from table\3092\4F7F\7528\3059\308B\3068\3001\975E\8868\793A\5217\306F\8868\793A\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104307268384308687)
,p_name=>'QUICKSQL.HELP.INDEX'
,p_message_language=>'ja'
,p_message_text=>unistr('\95A2\9023\4ED8\3051\3089\308C\305F\5217\306B\4E00\610F\3067\306A\3044\7D22\5F15\3092\4F5C\6210\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104714807315309012)
,p_name=>'QUICKSQL.HELP.INSERT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30F3\30C0\30E0\30FB\30C7\30FC\30BF\3092\6301\3064<strong>NN</strong> SQL INSERT\6587\3092\751F\6210\3057\307E\3059\3002\4F8B: /INSERT 20\3002(\6700\5927 = 1000)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104713676477309011)
,p_name=>'QUICKSQL.HELP.LOWER'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\5024\3092\5C0F\6587\5B57\306B\5F37\5236\3057\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104714320027309012)
,p_name=>'QUICKSQL.HELP.NNN'
,p_message_language=>'ja'
,p_message_text=>unistr('NNN\306F1\304B\308932767\307E\3067\306E\6570\5024\3092\8B58\5225\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104713762878309011)
,p_name=>'QUICKSQL.HELP.NOTNULL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\306Enot null\5236\7D04\3092\8FFD\52A0\3057\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104714145647309012)
,p_name=>'QUICKSQL.HELP.PK'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\3092\8868\306E\4E3B\30AD\30FC\3068\3057\3066\8B58\5225\3057\307E\3059\3002\4E3B\30AD\30FC\3092\624B\52D5\3067\6307\5B9A\305B\305A\3001\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\4E3B\30AD\30FC\5217\3092\81EA\52D5\7684\306B\4F5C\6210\3059\308B\3053\3068\3092\304A\85A6\3081\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104715095588309013)
,p_name=>'QUICKSQL.HELP.REST'
,p_message_language=>'ja'
,p_message_text=>unistr('Oracle REST Data Services (ORDS)\3092\4F7F\7528\3057\3066\8868\306EREST\6709\52B9\5316\3092\751F\6210\3057\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104714919002309012)
,p_name=>'QUICKSQL.HELP.SELECT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5404\8868\306E\30C7\30FC\30BF\3092\751F\6210\3057\305F\5F8C\306BSQL SELECT\6587\3092\751F\6210\3057\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103848943526308284)
,p_name=>'QUICKSQL.HELP.TABLE_UNIQUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\30EC\30D9\30EB\306E\4E00\610F\5236\7D04\3092\751F\6210\3057\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104713109166309011)
,p_name=>'QUICKSQL.HELP.UNIQUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E00\610F\5236\7D04\3092\4F5C\6210\3057\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104713573889309011)
,p_name=>'QUICKSQL.HELP.UPPER'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\5024\3092\5927\6587\5B57\306B\5F37\5236\3057\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104713453890309011)
,p_name=>'QUICKSQL.HELP.VALUES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\306E\751F\6210\6642\306B\4F7F\7528\3059\308B\5024\306E\30AB\30F3\30DE\533A\5207\308A\30EA\30B9\30C8\3002\4F8B: /values 1, 2, 3, 4\307E\305F\306F/values Yes, No\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104142133861308551)
,p_name=>'QUICKSQL.IMPLEMENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30AA\30D6\30B8\30A7\30AF\30C8\306E\4F5C\6210\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104170085704308583)
,p_name=>'QUICKSQL.IMPLEMENT.DETAIL'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30AF\30A4\30C3\30AFSQL\77ED\7E2E\306E\5165\529B\3092\5B8C\4E86\3057\3066\9069\5207\306A\8A2D\5B9A\3092\9069\7528\3059\308B\3068\3001SQL\3092\4F7F\7528\3057\3066\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30AA\30D6\30B8\30A7\30AF\30C8\3092\4F5C\6210\3057\3001\6F5C\5728\7684\306B\8868\306B\30E9\30F3\30C0\30E0\30FB\30C7\30FC\30BF\3092\79FB\5165\3067\304D\307E\3059\3002\6B21\306E\30B9\30C6\30C3\30D7\306B\5F93\3044\307E\3059:<br>'),
'<ol>',
unistr('  <li><strong>\300C\30E2\30C7\30EB\306E\4FDD\5B58\300D</strong>\3092\30AF\30EA\30C3\30AF\3057\3066\3001\5C06\6765\518D\5229\7528\3059\308B\305F\3081\306B\30AF\30A4\30C3\30AFSQL\77ED\7E2E\69CB\6587\3092\30E2\30C7\30EB\3068\3057\3066\4FDD\5B58\3057\307E\3059\3002</li>'),
unistr('  <li>\30E2\30C7\30EB\540D\3092\5165\529B\3057\307E\3059\3002</li>'),
unistr('  <li><strong>\300CSQL\30B9\30AF\30EA\30D7\30C8\3092\4FDD\5B58\300D</strong>\3092\30AF\30EA\30C3\30AF\3057\3066\3001\51FA\529B\3092\30B9\30AF\30EA\30D7\30C8\3068\3057\3066\4FDD\5B58\3057\307E\3059\3002</li>'),
unistr('  <li>\30B9\30AF\30EA\30D7\30C8\540D\3092\5165\529B\3057\307E\3059\3002</li>'),
unistr('  <li><strong>\300C\30EC\30D3\30E5\30FC\304A\3088\3073\5B9F\884C\300D</strong>\3092\30AF\30EA\30C3\30AF\3057\3066\3001\30B9\30AF\30EA\30D7\30C8\30FB\30A8\30C7\30A3\30BF\306B\30CA\30D3\30B2\30FC\30C8\3057\307E\3059\3002</li>'),
unistr('  <li>\30B9\30AF\30EA\30D7\30C8\30FB\30A8\30C7\30A3\30BF\3067\3001\30B9\30AF\30EA\30D7\30C8\306E\5185\5BB9\304C\6B63\3057\3044\3053\3068\3092\78BA\8A8D\3057\307E\3059\3002</li>'),
unistr('  <li><strong>\300C\5B9F\884C\300D</strong>\3092\30AF\30EA\30C3\30AF\3057\3066\3001\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30AA\30D6\30B8\30A7\30AF\30C8\3092\4F5C\6210\3057\307E\3059\3002</li>'),
unistr('  <li>\30B9\30AF\30EA\30D7\30C8\306E\78BA\8A8D\30DA\30FC\30B8\3067\3001<strong>\300C\5373\6642\5B9F\884C\300D</strong>\3092\30AF\30EA\30C3\30AF\3057\307E\3059\3002</li>'),
unistr('  <li>\7D50\679C\30DA\30FC\30B8\3067\3001\6587\306E\51E6\7406\3001\6210\529F\304A\3088\3073\30A8\30E9\30FC\3092\78BA\8A8D\3057\307E\3059\3002<br>'),
unistr('  \30A8\30E9\30FC\304C\5831\544A\3055\308C\305F\5834\5408\3001\7279\5B9A\306EOracle\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\3092\8868\793A\3059\308B\7D50\679C\30DA\30FC\30B8\306B\30CA\30D3\30B2\30FC\30C8\3057\307E\3059\3002</li>'),
unistr('  <li>\30AA\30D7\30B7\30E7\30F3\3067\3001<strong>\300C\30B9\30AF\30EA\30D7\30C8\304B\3089\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\4F5C\6210\300D</strong>\3092\30AF\30EA\30C3\30AF\3057\3066\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\4F5C\6210\30A6\30A3\30B6\30FC\30C9\306B\79FB\52D5\3057\3001\30B9\30AF\30EA\30D7\30C8\3067\6307\5B9A\3055\308C\305F\8868\304A\3088\3073\30D3\30E5\30FC\306B\57FA\3065\3044\3066\30DA\30FC\30B8\304C\81EA\52D5\7684\306B\751F\6210\3055\308C\308B\3088\3046\306B\3057\307E\3059\3002</li>'),
'</ol>',
'</p>',
'',
unistr('<p><em><strong>\30CE\30FC\30C8:</strong> \4ECA\5F8C\540C\3058SQL\77ED\7E2E\3092\66F4\65B0\3059\308B\5834\5408\306F\3001SQL\77ED\7E2E\3092\30B3\30F3\30D4\30E5\30FC\30BF\306B\30C0\30A6\30F3\30ED\30FC\30C9\3059\308B\3053\3068\3092\304A\85A6\3081\3057\307E\3059\3002\8A2D\5B9A\3092\6307\5B9A\3057\305F\5834\5408\306F\3001\300COracle SQL\51FA\529B\300D\30DA\30A4\30F3\306E\4E0B\90E8\306B\30CA\30D3\30B2\30FC\30C8\3057\3001<code># settings =</code>\3067\59CB\307E\308B\884C\3092\300C\30AF\30A4\30C3\30AFSQL\77ED\7E2E\300D\30DA\30A4\30F3\306E\4E0A\90E8\306B\30B3\30D4\30FC\3057\307E\3059\3002<br>'),
unistr('<strong>\300C\30C0\30A6\30F3\30ED\30FC\30C9\300D</strong>\3092\30AF\30EA\30C3\30AF\3057\3066\3001SQL\30D5\30A1\30A4\30EB\3092\30B3\30F3\30D4\30E5\30FC\30BF\306B\4FDD\5B58\3057\307E\3059\3002</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104041236189308468)
,p_name=>'QUICKSQL.LANGUAGE_SETTING'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\8A00\8A9E\3092\4F7F\7528\3057\3066\3001INSERT\6587\306B\4F7F\7528\3055\308C\308B\30C7\30FC\30BF\3092\751F\6210\3057\307E\3059\3002\30C7\30D5\30A9\30EB\30C8\306F\82F1\8A9E\3067\3059\3002\30B5\30DD\30FC\30C8\3055\308C\3066\3044\308B\8A00\8A9E\306F\6B21\306E\3068\304A\308A\3067\3059\3002 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104041413658308468)
,p_name=>'QUICKSQL.LONGID_SETTING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30AA\30D6\30B8\30A7\30AF\30C8\540D\306B\4F7F\7528\3055\308C\308B\9577\3044\8B58\5225\5B50\306E\4F7F\7528\3092\6307\5B9A\3057\307E\3059\3002\6709\52B9\306B\3057\305F\5834\5408\3001\8B58\5225\5B50\3092\9577\304F\3059\308B\3068\3001\6700\5927128\6587\5B57\306E\9577\3055\306E\30AA\30D6\30B8\30A7\30AF\30C8\540D\3092\4F7F\7528\3067\304D\307E\3059\3002\6709\52B9\306B\3057\306A\3044\5834\5408\3001\30AA\30D6\30B8\30A7\30AF\30C8\540D\306E\6700\5927\9577\306F30\6587\5B57\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104041626332308468)
,p_name=>'QUICKSQL.LONGVC_SETTING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30AA\30D6\30B8\30A7\30AF\30C8\540D\306B\9577\3044\8B58\5225\5B50\3092\4F7F\7528\3067\304D\308B\3088\3046\306B\3057\307E\3059\3002\8B58\5225\5B50\3092\9577\304F\3059\308B\3068\3001VARCHAR2\5217\306E\30C7\30FC\30BF\578B\306E\6700\5927\9577\306F32767\6587\5B57\306B\306A\308A\307E\3059\3002\8A2D\5B9A\3057\306A\3044\3068\3001VARCHAR2\5217\306E\30C7\30FC\30BF\578B\306E\6700\5927\9577\306F4000\6587\5B57\306B\306A\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104041779550308468)
,p_name=>'QUICKSQL.ONDELETE_SETTING'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\8A2D\5B9A\306F\3001\5916\90E8\30AD\30FCON DELETE\8A2D\5B9A\306E\65B9\6CD5\3092\5236\5FA1\3057\307E\3059\3002\6709\52B9\306A\5024\306F\6B21\306E\3068\304A\308A\3067\3059\3002 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104041866308308468)
,p_name=>'QUICKSQL.OVERRIDESETTINGS_SETTING'
,p_message_language=>'ja'
,p_message_text=>unistr('\6709\52B9\306B\3059\308B\3068\3001\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\30FB\30B3\30F3\30BD\30FC\30EB\3092\4ECB\3057\3066\8A2D\5B9A\3055\308C\305F\3059\3079\3066\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\8A2D\5B9A\306F\7121\8996\3055\308C\3001\30B9\30AF\30EA\30D7\30C8\3067\884C\308F\308C\305F\8A2D\5B9A\306E\307F\304C\4F7F\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104041947544308469)
,p_name=>'QUICKSQL.PK_SETTING'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E3B\30AD\30FC\306E\8A2D\5B9A\65B9\6CD5\3092\6C7A\5B9A\3057\307E\3059\3002\4E3B\30AD\30FC\306F\3001SYS_GUID\3001\30A2\30A4\30C7\30F3\30C6\30A3\30C6\30A3\5217\307E\305F\306F\9806\5E8F\3092\4F7F\7528\3057\3066\8A2D\5B9A\3067\304D\307E\3059\3002\6709\52B9\306A\5024\306F\6B21\306E\3068\304A\308A\3067\3059:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104042106165308469)
,p_name=>'QUICKSQL.PREFIXPKWITHTNAME_SETTING'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E3B\30AD\30FC\306E\30C7\30FC\30BF\30D9\30FC\30B9\8868\306E\5217\306B\8868\306E\540D\524D\3092\63A5\982D\8F9E\3068\3057\3066\4ED8\3051\307E\3059\3002\305F\3068\3048\3070\3001EMPLOYEE\8868\306E\4E3B\30AD\30FC\306FEMPLOYEE_ID\3067\3059\3002\6697\9ED9\7684\306B\4F5C\6210\3055\308C\305F\4E3B\30AD\30FC\5217\306E\540D\524D\3092\8A2D\5B9A\3057\306A\3044\3068\3001ID\306B\306A\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104042000159308469)
,p_name=>'QUICKSQL.PREFIX_SETTING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30AA\30D6\30B8\30A7\30AF\30C8\306E\63A5\982D\8F9E\3002\6307\5B9A\3055\308C\3066\3044\306A\3044\5834\5408\306F\30A2\30F3\30C0\30FC\30B9\30B3\30A2\304C\4ED8\52A0\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104709279055309008)
,p_name=>'QUICKSQL.PRODUCTSALES'
,p_message_language=>'ja'
,p_message_text=>unistr('\88FD\54C1\58F2\4E0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104709887669309008)
,p_name=>'QUICKSQL.PRODUCTSALES_DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('PRODUCTS\3001CUSTOMERS\3001CHANNELS\3001PROMOTIONS\304A\3088\3073SALES\8868\3092\6301\3064\30B9\30BF\30FC\30FB\30B9\30AD\30FC\30DE\3092\4F5C\6210\3059\308B\77ED\7E2E\69CB\6587\3067\3059\3002SALES\8868\306B\306F\3001\4ED6\306E\8868\3078\306E\5916\90E8\30AD\30FC\53C2\7167\304C\542B\307E\308C\3066\3044\307E\3059\30025\3064\306E\8868\3092\3059\3079\3066\7D50\5408\3059\308BSQL\30D3\30E5\30FC\3082\4F5C\6210\3055\308C\307E\3059\3002\30E9\30F3\30C0\30E0\30FB\30B5\30F3\30D7\30EB\30FB\30C7\30FC\30BF\3082\751F\6210\3055\308C\307E\3059\3002\6570\5024\5217\306FNUM\69CB\6587\3067\8B58\5225\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104709070825309007)
,p_name=>'QUICKSQL.PROJECTMANAGEMENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30B8\30A7\30AF\30C8\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104709607144309008)
,p_name=>'QUICKSQL.PROJECTMANAGEMENT_DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('PROJECT_MANAGEMENT\304A\3088\30734\3064\306E\30C7\30A3\30C6\30FC\30EB\8868\3092\4F5C\6210\3057\307E\3059\3002/VIEW\69CB\6587\3092\4F7F\7528\3057\3066\30012\3064\306E\30D3\30E5\30FC\304C\4F5C\6210\3055\308C\307E\3059\3002\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30C1\30A7\30C3\30AF\5236\7D04\306F\3001/CHECK\69CB\6587\3092\4F7F\7528\3057\3066\3082\8FFD\52A0\3055\308C\307E\3059\3002#APEX\3092\4F7F\7528\3057\3066\3001SQL\69CB\6587\751F\6210\3092\5236\5FA1\3059\308B\8A2D\5B9A\3082\884C\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104042346948308469)
,p_name=>'QUICKSQL.RESETSETTINGS_SETTING'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\8A2D\5B9A\3092\30C7\30D5\30A9\30EB\30C8\5024\306B\30EA\30BB\30C3\30C8\3057\307E\3059\3002\6307\5B9A\3059\308B\3068\3001\30BB\30C3\30B7\30E7\30F3\3067\73FE\5728\30A2\30AF\30C6\30A3\30D6\306A\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\8A2D\5B9A\306F\3059\3079\3066\7121\8996\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104042496208308469)
,p_name=>'QUICKSQL.ROWKEY_SETTING'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F5C\6210\3055\308C\305F\5404\8868\306B\5BFE\3057\3066\3001\82F1\6570\5B57\8B58\5225\5B50\3092\751F\6210\3059\308BROW_KEY\5217\3092\8FFD\52A0\3057\307E\3059\3002ROW_KEY\5217\306E\5024\306F\3001\751F\6210\3055\308C\305F\30C7\30FC\30BF\30D9\30FC\30B9\8868\30C8\30EA\30AC\30FC\30FB\30ED\30B8\30C3\30AF\306B\3088\3063\3066\8A2D\5B9A\3055\308C\307E\3059\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104042682387308469)
,p_name=>'QUICKSQL.ROWVERSION'
,p_message_language=>'ja'
,p_message_text=>unistr('\751F\6210\3055\308C\305F\5404\8868\306B\5BFE\3057\3066\3001\66F4\65B0\3054\3068\306B1\305A\3064\5897\5206\3059\308BROW_VERSION\5217\3092\8FFD\52A0\3057\307E\3059\3002\6709\52B9\306A\5834\5408\3001\66F4\65B0\6642\306B\884C\30D0\30FC\30B8\30E7\30F3\3092\5897\5206\3059\308B\305F\3081\306B\3001\30C7\30FC\30BF\30D9\30FC\30B9\8868\30C8\30EA\30AC\30FC\30FB\30ED\30B8\30C3\30AF\304C\751F\6210\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104042795873308469)
,p_name=>'QUICKSQL.SCHEMA_SETTING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30D6\30B8\30A7\30AF\30C8\540D\306B\30B9\30AD\30FC\30DE\540D\3092\63A5\982D\8F9E\3068\3057\3066\4ED8\3051\307E\3059\3002\30C7\30D5\30A9\30EB\30C8\3067\306F\3001\30AA\30D6\30B8\30A7\30AF\30C8\540D\306E\30B9\30AD\30FC\30DE\63A5\982D\8F9E\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104042515326308469)
,p_name=>'QUICKSQL.SECURITYGROUPID_SETTING'
,p_message_language=>'ja'
,p_message_text=>unistr('\5404\8868\306B\5BFE\3057\3066\3001\30DE\30EB\30C1\30C6\30CA\30F3\30C8\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\30B5\30DD\30FC\30C8\3059\308BTENANT_ID\5217\3092\8FFD\52A0\3057\307E\3059\3002\3053\306E\5217\306E\5024\306F\5358\306B\8868\306B\8FFD\52A0\3055\308C\308B\306E\307F\3067\3001\3053\306E\5024\3092\4FDD\6301\3059\308B\306B\306F\958B\767A\8005\304C\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104043104914308469)
,p_name=>'QUICKSQL.SEMANTICS_SETTING'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\30BB\30DE\30F3\30C6\30A3\30AF\30B9\3092\9078\629E\3057\306A\3044\304B\3001BYTE\30BB\30DE\30F3\30C6\30A3\30AF\30B9\307E\305F\306FCHARY\30BB\30DE\30F3\30C6\30A3\30AF\30B9\3092\9078\629E\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103961550577308406)
,p_name=>'QUICKSQL.SETTING'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104024708746308454)
,p_name=>'QUICKSQL.SETTINGS_DESC'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>SQL\69CB\6587\751F\6210\30AA\30D7\30B7\30E7\30F3\3092\660E\793A\7684\306B\8A2D\5B9A\3059\308B\305F\3081\306E\30A4\30F3\30E9\30A4\30F3\8A2D\5B9A\3092\5165\529B\3067\304D\307E\3059\3002\307E\305F\3001\53F3\30DA\30A4\30F3\306E\4E0A\90E8\306B\3042\308B<strong>\300C\8A2D\5B9A\300D</strong>\3092\30AF\30EA\30C3\30AF\3057\3066\3001\751F\6210\30AA\30D7\30B7\30E7\30F3\3092\5BA3\8A00\7684\306B\8A2D\5B9A\3059\308B\3053\3068\3082\3067\304D\307E\3059\3002</p>'),
'',
unistr('<p>\300C\30AF\30A4\30C3\30AFSQL\77ED\7E2E\300D\30DA\30A4\30F3\306B\76F4\63A5\8A2D\5B9A\3092\5165\529B\3059\308B\3068\3001\30B9\30AF\30EA\30D7\30C8\3092\30C0\30A6\30F3\30ED\30FC\30C9\3057\3066\5F8C\3067\8CBC\308A\4ED8\3051\3066\3082\3001\540C\3058SQL\751F\6210\30AA\30D7\30B7\30E7\30F3\304C\4F7F\7528\3055\308C\307E\3059\3002\305F\3068\3048\3070\3001\6B21\306E\3088\3046\306B\5165\529B\3059\308B\3068\3001\3059\3079\3066\306E\8868\540D\306E\524D\306BTEST\304C\4ED8\52A0\3055\308C\3001\30B9\30AD\30FC\30DEOBE\7528\306B\751F\6210\3055\308C\307E\3059\3002<br>'),
unistr('<code># settings = { prefix: "test", schema: "OBE" }</code>\3002<br>'),
unistr('\307E\305F\306F\3001\540C\3058\7D50\679C\306E\5225\306E\884C\306B\5404\8A2D\5B9A\3092\5165\529B\3057\307E\3059\3002<br>'),
'<code># prefix: "test"<br>',
'# schema: "OBE"</code>',
'</p>',
unistr('<p><em><strong>\30CE\30FC\30C8:</strong> \8A2D\5B9A\306F\65B0\3057\3044\884C\304B\3089\958B\59CB\3057\3001\8907\6570\306E\8A2D\5B9A\3092\5165\529B\3059\308B\306B\306F<code># settings = </code>\3001\884C\3054\3068\306B1\3064\306E\8A2D\5B9A\3092\5165\529B\3059\308B\306B\306F<code># </code>\3067\59CB\307E\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\3059\3079\3066\306E\5024\306F\5927/\5C0F\6587\5B57\3092\533A\5225\3057\307E\305B\3093\3002\30AB\30C3\30B3\3001\7A7A\767D\304A\3088\3073\30AB\30F3\30DE\3092\308F\304B\308A\3084\3059\304F\3059\308B\305F\3081\306B\8FFD\52A0\3059\308B\3053\3068\306F\3067\304D\307E\3059\304C\3001\7121\8996\3055\308C\307E\3059\3002\3059\3079\3066\306E\8A2D\5B9A\3092\751F\6210\3059\308B\306B\306F\3001<code># verbose: true</code>\3092\4F7F\7528\3057\307E\3059\3002</em> '),
'</p>',
'&nbsp;<br>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103961241661308406)
,p_name=>'QUICKSQL.SYNTAX'
,p_message_language=>'ja'
,p_message_text=>unistr('\69CB\6587')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104731098956309027)
,p_name=>'QUICKSQL.TODOS'
,p_message_language=>'ja'
,p_message_text=>'ToDo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104731153615309027)
,p_name=>'QUICKSQL.TODOS_DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('ASSIGNEES\3068TODOS\8868\3092\4F5C\6210\3057\307E\3059\3002\3053\308C\306F\3001\30AB\30B9\30BF\30DE\30A4\30BA\3055\308C\305FToDo\30B7\30B9\30C6\30E0\3092\6570\5206\4EE5\5185\306B\4F5C\6210\3067\304D\308B\3088\3046\306B\3059\308B\305F\3081\306E\51FA\767A\70B9\3068\306A\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104042871536308469)
,p_name=>'QUICKSQL.UPDATEDBYCOL_SETTING'
,p_message_language=>'ja'
,p_message_text=>unistr('\76E3\67FB\5217\3092\6709\52B9\306B\3059\308B\3068\3001\3053\306E\8A2D\5B9A\3092\4F7F\7528\3057\3066\3001\30C7\30D5\30A9\30EB\30C8\306E\76E3\67FB\5217\540D\3092\30AA\30FC\30D0\30FC\30E9\30A4\30C9\3057\307E\3059\3002 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104042911707308469)
,p_name=>'QUICKSQL.UPDATEDCOL_SETTING'
,p_message_language=>'ja'
,p_message_text=>unistr('\76E3\67FB\5217\3092\6709\52B9\306B\3059\308B\3068\3001\3053\306E\8A2D\5B9A\3092\4F7F\7528\3057\3066\3001\30C7\30D5\30A9\30EB\30C8\306E\76E3\67FB\5217\540D\3092\30AA\30FC\30D0\30FC\30E9\30A4\30C9\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104043081765308469)
,p_name=>'QUICKSQL.VERBOSE_SETTING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\3068\306F\7570\306A\308B\8A2D\5B9A\3060\3051\3067\306A\304F\3001\3059\3079\3066\306E\8A2D\5B9A\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103961358448308406)
,p_name=>'QUICKSQL.VIEW_SYNTAX_DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D3\30E5\30FC\540D\306B\7A7A\767D\304C\542B\307E\308C\3066\3044\306A\3044\3053\3068\3092\78BA\8A8D\3057\3001\8868\540D\306B\7A7A\767D\304C\542B\307E\308C\3066\3044\306A\3044\3053\3068\3092\78BA\8A8D\3057\307E\3059\3002\8868\540D\306F\7A7A\767D\307E\305F\306F\30AB\30F3\30DE\3067\533A\5207\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104170123561308584)
,p_name=>'QUICK_APP.LOAD_DETAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30ED\30FC\30C9\30FB\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103809551943308254)
,p_name=>'QUICK_APP_ANALYSIS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5206\6790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104017425396308448)
,p_name=>'QUICK_APP_AVERAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5E73\5747%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103692845130308160)
,p_name=>'QUICK_APP_BY'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\5225')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103809945868308255)
,p_name=>'QUICK_APP_CHARTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103692789060308160)
,p_name=>'QUICK_APP_CHART_BY'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\5225\306E\30C1\30E3\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103691445124308159)
,p_name=>'QUICK_APP_DETAIL_VIEW'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A73\7D30\30D3\30E5\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103809895299308255)
,p_name=>'QUICK_APP_REPORTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104017530508308449)
,p_name=>'QUICK_APP_SUM'
,p_message_language=>'ja'
,p_message_text=>unistr('\5408\8A08%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104185466934308597)
,p_name=>'QUICK_SQL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30A4\30C3\30AFSQL')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103527129251308035)
,p_name=>'RANGE2DCOLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\7BC4\56F22D\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103527229177308035)
,p_name=>'RANGE3DCOLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\7BC4\56F23D\5217')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104842784127309120)
,p_name=>'READERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30C0\30FC')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104759006283309049)
,p_name=>'REASSIGN_ITEM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306E\518D\5272\5F53\3066: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103550592450308052)
,p_name=>'REASSIGN_PAGES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306E\518D\5272\5F53\3066')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103935928022308386)
,p_name=>'RECYCLE_BIN'
,p_message_language=>'ja'
,p_message_text=>unistr('\3054\307F\7BB1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104139868567308550)
,p_name=>'REDIRECT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30C0\30A4\30EC\30AF\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104140011496308550)
,p_name=>'REDIRECT_BUTTON_WARNING'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DC\30BF\30F3\306B\3088\3063\3066URL\306B\30EA\30C0\30A4\30EC\30AF\30C8\3055\308C\307E\3059\304C\3001\30DA\30FC\30B8\306F\9001\4FE1\3055\308C\306A\3044\53EF\80FD\6027\304C\3042\308A\307E\3059\3002  \3053\306E\30DC\30BF\30F3\3067\30DA\30FC\30B8\3092\9001\4FE1\3059\308B\5834\5408\306F\3001\30EA\30C0\30A4\30EC\30AF\30C8\30FB\30DA\30FC\30B8\307E\305F\306FURL\3092\6307\5B9A\3057\306A\3044\3067\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103806241296308252)
,p_name=>'REDIRECT_TO'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306B\30EA\30C0\30A4\30EC\30AF\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104271938340308662)
,p_name=>'REDIRECT_TO_APP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3%0\3001\30DA\30FC\30B8%1\3078\306E\30EA\30C0\30A4\30EC\30AF\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103806167920308252)
,p_name=>'REDIRECT_TO_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8%0\306B\30EA\30C0\30A4\30EC\30AF\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103613772131308098)
,p_name=>'REDIRECT_TO_PAGE_IN_THIS_APP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30DA\30FC\30B8\306B\30EA\30C0\30A4\30EC\30AF\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103613887692308098)
,p_name=>'REDIRECT_TO_URL'
,p_message_language=>'ja'
,p_message_text=>unistr('URL\306B\30EA\30C0\30A4\30EC\30AF\30C8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103987160100308425)
,p_name=>'REFERENCED'
,p_message_language=>'ja'
,p_message_text=>unistr('\53C2\7167')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103614719666308098)
,p_name=>'REGEN_VER'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C\30B3\30FC\30C9\306E\518D\751F\6210')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103989794230308428)
,p_name=>'REGION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104134279973308545)
,p_name=>'REGION BUTTON POSITONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\30FB\30DC\30BF\30F3\306E\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104053774022308478)
,p_name=>'REGION CONDITION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104046995812308473)
,p_name=>'REGION CONTENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\30FB\30B3\30F3\30C6\30F3\30C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103592628828308082)
,p_name=>'REGION.BUTTONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\30FB\30DC\30BF\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103615736157308099)
,p_name=>'REGIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103773748417308226)
,p_name=>'REGIONS_LIST_TEMPLATE_OVERRIDE'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\3057\3044\30EA\30B9\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306E\30EA\30FC\30B8\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103998014937308434)
,p_name=>'REGION_DISPLAY_SELECTOR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\8868\793A\30BB\30EC\30AF\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103516454307308027)
,p_name=>'REGION_NAME.NATIVE_BREADCRUMB'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104262378602308655)
,p_name=>'REGION_NAME.NATIVE_CALENDAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30EC\30F3\30C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103534612217308041)
,p_name=>'REGION_NAME.NATIVE_CARDS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103982389266308422)
,p_name=>'REGION_NAME.NATIVE_CSS_CALENDAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30EC\30F3\30C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103558893459308058)
,p_name=>'REGION_NAME.NATIVE_DATA_UPLOAD_COLUMN_MAPPING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30A2\30C3\30D7\30ED\30FC\30C9\5217\306E\30DE\30C3\30D4\30F3\30B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103996441442308433)
,p_name=>'REGION_NAME.NATIVE_DISPLAY_SELECTOR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\8868\793A\30BB\30EC\30AF\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104327044769308702)
,p_name=>'REGION_NAME.NATIVE_FACETED_SEARCH'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30BB\30C3\30C8\691C\7D22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104116303088308530)
,p_name=>'REGION_NAME.NATIVE_FORM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103517591556308028)
,p_name=>'REGION_NAME.NATIVE_HELP_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D8\30EB\30D7\30FB\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104123556743308536)
,p_name=>'REGION_NAME.NATIVE_IG'
,p_message_language=>'ja'
,p_message_text=>unistr('\5BFE\8A71\30B0\30EA\30C3\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104237223072308637)
,p_name=>'REGION_NAME.NATIVE_IR'
,p_message_language=>'ja'
,p_message_text=>unistr('\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103976728995308418)
,p_name=>'REGION_NAME.NATIVE_JET_CHART'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104695193252308996)
,p_name=>'REGION_NAME.NATIVE_JQM_COLUMN_TOGGLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\5207\66FF\3048\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103558740547308058)
,p_name=>'REGION_NAME.NATIVE_JQM_LIST_VIEW'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8\30FB\30D3\30E5\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104695221270308996)
,p_name=>'REGION_NAME.NATIVE_JQM_REFLOW'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30D5\30ED\30FC\30FB\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104262563566308655)
,p_name=>'REGION_NAME.NATIVE_JSTREE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C4\30EA\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103515948255308027)
,p_name=>'REGION_NAME.NATIVE_LIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104699043976308999)
,p_name=>'REGION_NAME.NATIVE_MAP_REGION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30C3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104337036487308710)
,p_name=>'REGION_NAME.NATIVE_PLSQL'
,p_message_language=>'ja'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104261914808308654)
,p_name=>'REGION_NAME.NATIVE_SIMPLE_CHART'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8(HTML - \30EC\30AC\30B7\30FC)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104233034747308634)
,p_name=>'REGION_NAME.NATIVE_SQL_REPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104337182274308710)
,p_name=>'REGION_NAME.NATIVE_STATIC'
,p_message_language=>'ja'
,p_message_text=>unistr('\9759\7684\30B3\30F3\30C6\30F3\30C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104261864517308654)
,p_name=>'REGION_NAME.NATIVE_SVG_CHART'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8(SVG - \30EC\30AC\30B7\30FC)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104237323254308637)
,p_name=>'REGION_NAME.NATIVE_TABFORM'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\5F62\5F0F\30D5\30A9\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104262419327308655)
,p_name=>'REGION_NAME.NATIVE_TREE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30E9\30B7\30C3\30AF\30FB\30C4\30EA\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103516764635308028)
,p_name=>'REGION_NAME.NATIVE_URL'
,p_message_language=>'ja'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103682797465308152)
,p_name=>'REGION_TEMPLATES_NO_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8\306A\3057')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104001727870308437)
,p_name=>'REJECTED_OR_DUPLICATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\62D2\5426\307E\305F\306F\91CD\8907')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104022496784308453)
,p_name=>'RELEASE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30EA\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103569204254308065)
,p_name=>'RELEASED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30EA\30FC\30B9\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104052338046308477)
,p_name=>'RELEASE_SUMMARY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30EA\30FC\30B9\30FB\30B5\30DE\30EA\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104052238168308477)
,p_name=>'RELEASE_SUMMARY_FOR_WORKSPACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306E\30EA\30EA\30FC\30B9\30FB\30B5\30DE\30EA\30FC: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104727605522309023)
,p_name=>'REMOTE.MORE_INFORMATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A73\7D30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104768780517309065)
,p_name=>'REMOTE.OWA_TOOLKIT_REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL Web\30C4\30FC\30EB\30AD\30C3\30C8%0\304C\5FC5\8981\3067\3059<a href="%1" target="_blank">[\8A73\7D30]</a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104768548058309065)
,p_name=>'REMOTE.PATCHSET_AVAILABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30C3\30C1\8A2D\5B9A%0\3092\4F7F\7528\3067\304D\307E\3059<a href="%1" target="_blank">[\8A73\7D30]</a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104768638278309065)
,p_name=>'REMOTE.RELEASE_AVAILABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('Oracle APEX %0\3092\4F7F\7528\3067\304D\307E\3059<a href="%1" target="_blank">[\8A73\7D30]</a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104727516266309023)
,p_name=>'REMOTE.SYSTEM_UP_TO_DATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30B9\30C6\30E0\306F\6700\65B0\3067\3059')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104669059712308974)
,p_name=>'REMOVED_DUE_TO_ACTIVITY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30C6\30A3\30D3\30C6\30A3\306E\7D50\679C\3001\524A\9664\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103568771460308065)
,p_name=>'REMOVE_APPLICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104560179982308887)
,p_name=>'REMOVE_DB_PKG_APP_WARNING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5B9A\7FA9\304C\3001\4F5C\6210\3055\308C\305F\30B5\30DD\30FC\30C8\3059\308B\30AA\30D6\30B8\30A7\30AF\30C8\3068\3068\3082\306B\524A\9664\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104068012408308490)
,p_name=>'REMOVE_WORKSPACE_SUCCESS_MSG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306F\6B63\5E38\306B\524A\9664\3055\308C\307E\3057\305F\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104132212068308543)
,p_name=>'RENAME_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\540D%0\306E%1\3078\306E\5909\66F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104132416641308543)
,p_name=>'RENAME_TABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\540D%0\306E%1\3078\306E\5909\66F4')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103849367057308285)
,p_name=>'REORDER_BUTTONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\30FB\30DC\30BF\30F3\306E\9806\5E8F\5909\66F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103864442343308296)
,p_name=>'REORDER_NAVBAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30D0\30FC\30FB\30A8\30F3\30C8\30EA\306E\9806\5E8F\5909\66F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103849434943308285)
,p_name=>'REORDER_REGIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\306E\9806\5E8F\5909\66F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103849085243308285)
,p_name=>'REORDER_REGION_ITEMS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\30FB\30A2\30A4\30C6\30E0\306E\9806\5E8F\5909\66F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103864301805308296)
,p_name=>'REORDER_TABS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30D6\306E\9806\5E8F\5909\66F4')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103969647806308413)
,p_name=>'REPORT COLUMNS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104752729933309044)
,p_name=>'REPORT_ALIAS_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\5225\540D: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103969974031308413)
,p_name=>'REPORT_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104086510123308505)
,p_name=>'REPORT_COLUMNS_PAGE_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104061337170308484)
,p_name=>'REPORT_COLUMN_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\5217\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104060909944308484)
,p_name=>'REPORT_FORM_SUCCESS_MSG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30FC\30E0\304A\3088\3073\30EC\30DD\30FC\30C8\304C\6B63\5E38\306B\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104025796029308455)
,p_name=>'REPORT_GENERATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\751F\6210\3055\308C\305F\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104093465593308511)
,p_name=>'REPORT_LAYOUT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\30FB\30EC\30A4\30A2\30A6\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103922118760308376)
,p_name=>'REPORT_ON'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306E\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104086832191308505)
,p_name=>'REPORT_PAGE_ATTRIBUTES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\30FB\30DA\30FC\30B8\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103678354265308149)
,p_name=>'REPORT_QUERIES.VALID_QUERY'
,p_message_language=>'ja'
,p_message_text=>unistr('\554F\5408\305B\306F\6709\52B9\3067\3059\3002\30D0\30A4\30F3\30C9\5909\6570\306F\89E3\6790\6E08\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104093301998308511)
,p_name=>'REPORT_QUERY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103926900119308380)
,p_name=>'REPORT_QUERY_STEP1'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30C6\30C3\30D71 - XML\30D5\30A1\30A4\30EB\306E\30C0\30A6\30F3\30ED\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103927018628308380)
,p_name=>'REPORT_QUERY_STEP2'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30C6\30C3\30D72 - \30EC\30DD\30FC\30C8\30FB\30EC\30A4\30A2\30A6\30C8\306E\8A2D\8A08\304A\3088\3073RTF\5F62\5F0F\3067\306E\4FDD\5B58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103927252200308380)
,p_name=>'REPORT_QUERY_STEP2_XSL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30C6\30C3\30D72 - XSL-FO\30D5\30A1\30A4\30EB\306E\30A2\30C3\30D7\30ED\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103927185634308380)
,p_name=>'REPORT_QUERY_STEP3'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30C6\30C3\30D73 - RTF\30D5\30A1\30A4\30EB\306E\30A2\30C3\30D7\30ED\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104059400224308483)
,p_name=>'REPORT_ROWS_FETCHED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A7\30C3\30C1\3055\308C\305F\30EC\30DD\30FC\30C8\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104127536206308539)
,p_name=>'REPORT_SUCCESS_MSG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\304C\6B63\5E38\306B\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104061488539308484)
,p_name=>'REPORT_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104066655671308489)
,p_name=>'REPORT_WS_SUCCESS_MSG'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B5\30FC\30D3\30B9\306E\30EC\30DD\30FC\30C8\30FB\30DA\30FC\30B8\304C\6B63\5E38\306B\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103983201504308423)
,p_name=>'REQUEST'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30AF\30A8\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104056968003308481)
,p_name=>'REQUESTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30AF\30A8\30B9\30C8\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104321157392308698)
,p_name=>'REQUEST_CHANGE_DB_SIZE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9"%1"\306E%0\3067\3001\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30B5\30A4\30BA\3092%2\8FFD\52A0\3059\308B\5909\66F4\304C\30EA\30AF\30A8\30B9\30C8\3055\308C\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104321098326308698)
,p_name=>'REQUEST_NEW_SCHEMA'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306B\3088\308A\3001%2\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9"%1"\306E\65B0\898F\30B9\30AD\30FC\30DE\304C\30EA\30AF\30A8\30B9\30C8\3055\308C\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104320996923308698)
,p_name=>'REQUEST_WORKSPACE'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306B\3088\308A\3001\30B5\30A4\30BA%2\306E\65B0\898F\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9"%1"\304C\30EA\30AF\30A8\30B9\30C8\3055\308C\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103570973381308067)
,p_name=>'REQUEST_WORKSPACE_EXISTING_SCHEMA'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\65B0\898F\30EF\30FC\30AF\30B9\30DA\30FC\30B9"%1"\3092\30EA\30AF\30A8\30B9\30C8\3057\307E\3059')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104010094901308443)
,p_name=>'RESEARCHING'
,p_message_language=>'ja'
,p_message_text=>unistr('\8ABF\67FB\4E2D')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103545531303308048)
,p_name=>'RESET_4000'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30BB\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103592478849308082)
,p_name=>'RESET_TO_NULL_VALUE'
,p_message_language=>'ja'
,p_message_text=>unistr('NULL\5024\306B\30EA\30BB\30C3\30C8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103577332779308071)
,p_name=>'RESOURCE_MANAGER_CONSUMER_GROUP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30BD\30FC\30B9\30FB\30DE\30CD\30FC\30B8\30E3\30FB\30B3\30F3\30B7\30E5\30FC\30DE\30FB\30B0\30EB\30FC\30D7')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104275131367308664)
,p_name=>'RESTRICTED_ACCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5236\9650\3055\308C\305F\30A2\30AF\30BB\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103845601010308282)
,p_name=>'RESTRICTED_NO_SET_FROM_BROWSER'
,p_message_language=>'ja'
,p_message_text=>unistr('\5236\9650\4ED8\304D - \30D6\30E9\30A6\30B6\304B\3089\8A2D\5B9A\4E0D\53EF')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104063207847308486)
,p_name=>'REST_SUCCESS_MSG'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B5\30FC\30D3\30B9\53C2\7167\304C\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3%0\306B\8FFD\52A0\3055\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103675289348308147)
,p_name=>'REST_WS.ALIASED'
,p_message_language=>'ja'
,p_message_text=>unistr('\5225\540D\6307\5B9A\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104473895486308812)
,p_name=>'REST_WS.APEX_READ_ONLY'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>APEX RESTful\30B5\30FC\30D3\30B9\304C\8AAD\53D6\308A\5C02\7528\30E2\30FC\30C9\306B\306A\3063\3066\3044\307E\3059\3002</p>'),
'',
unistr('<p>APEX\30D9\30FC\30B9\306ERESTful\30B5\30FC\30D3\30B9\3092\5B9A\7FA9\3055\308C\305F\3068\304A\308A\306B\4F7F\7528\3067\304D\307E\3059\3002\305F\3060\3057\3001<strong>\300CORDS RESTful\30B5\30FC\30D3\30B9\3078\306E\79FB\884C\300D</strong>\3092\30AF\30EA\30C3\30AF\3057\3066\3001\3053\308C\3089\306E\30B5\30FC\30D3\30B9\3092ORDS\306B\79FB\884C\3059\308B\3053\3068\3092\304A\85A6\3081\3057\307E\3059\3002</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104470436993308810)
,p_name=>'REST_WS.CURR_VESION_NULL'
,p_message_language=>'ja'
,p_message_text=>unistr('ORDS\306E\73FE\5728\5B9F\884C\4E2D\306E\30D0\30FC\30B8\30E7\30F3\304C\898B\3064\304B\308A\307E\305B\3093\3002 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103674693052308146)
,p_name=>'REST_WS.DISABLED'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104473788579308812)
,p_name=>'REST_WS.DROP_REST_WARNING'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30A2\30AF\30B7\30E7\30F3\306F\3001\9078\629E\3057\305F\30B9\30AD\30FC\30DE\306E\3059\3079\3066\306EORDS REST\30B5\30FC\30D3\30B9\306E\5B9A\7FA9\3092\767B\9332\89E3\9664\304A\3088\3073\524A\9664\3057\307E\3059\3002\3053\306E\30A2\30AF\30B7\30E7\30F3\306F\5143\306B\623B\305B\307E\305B\3093\3002</p>'),
'',
unistr('<p>\3053\306E\30B9\30AD\30FC\30DE\3092\767B\9332\89E3\9664\3057\307E\3059\304B\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103923774511308377)
,p_name=>'REST_WS.DUPLICATE_PATH_PREFIX'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\5024\3092\542B\3080APEX\30D1\30B9\63A5\982D\8F9E\306F\3059\3067\306B\5225\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306B\5BFE\3057\3066\5B9A\7FA9\3055\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103985037577308424)
,p_name=>'REST_WS.DUPLICATE_SCHEMA_ALIAS'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B9\30AD\30FC\30DE\5225\540D\306F\4ED6\306E\30B9\30AD\30FC\30DE\3067\3059\3067\306B\4F7F\7528\3055\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103674512939308146)
,p_name=>'REST_WS.ENABLED'
,p_message_language=>'ja'
,p_message_text=>unistr('\6709\52B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104710286218309008)
,p_name=>'REST_WS.ENABLED_OBJECT_COUNT_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5408\8A08\5BFE\5FDC\30AA\30D6\30B8\30A7\30AF\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103658342051308134)
,p_name=>'REST_WS.GLOB_MUST_BE_LAST'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30ED\30D6\306E(*)\6587\5B57\306F\3001\6700\5F8C\306E\6587\5B57\3068\3057\3066\306E\307F\30EB\30FC\30C8\30FB\30D1\30BF\30FC\30F3\306B\542B\3081\308B\3053\3068\304C\3067\304D\3001\540D\524D\4ED8\304D\30D1\30E9\30E1\30FC\30BF\307E\305F\306F\30B9\30E9\30C3\30B7\30E5(/)\306E\307F\304C\5148\884C\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104323351168308699)
,p_name=>'REST_WS.HANDLER_CREATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F5C\6210\3055\308C\305F\30CF\30F3\30C9\30E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104323587486308700)
,p_name=>'REST_WS.HANDLER_DELETED'
,p_message_language=>'ja'
,p_message_text=>unistr('\524A\9664\3055\308C\305F\30CF\30F3\30C9\30E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104293091562308677)
,p_name=>'REST_WS.HANDLER_ID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CF\30F3\30C9\30E9ID\304C\5FC5\8981\3067\3059\304CNULL\3092\53D7\3051\53D6\308A\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104323440173308699)
,p_name=>'REST_WS.HANDLER_UPDATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F4\65B0\3055\308C\305F\30CF\30F3\30C9\30E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103658262682308134)
,p_name=>'REST_WS.INVALID_CHARS_IN_LITERAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EB\30FC\30C8\30FB\30D1\30BF\30FC\30F3\306E\30EA\30C6\30E9\30EB\90E8\5206\306B\7121\52B9\306A\6587\5B57\304C\898B\3064\304B\308A\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103695192347308162)
,p_name=>'REST_WS.METADATA_ACCESS_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\53EF\304C\5FC5\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104743184998309037)
,p_name=>'REST_WS.MIGRATION_CONFIRMATION'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div style="padding: 20px; font-size: 12px;">\300C\79FB\884C\300D\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\3059\3079\3066\306EAPEX\30D9\30FC\30B9\306EREST\30B5\30FC\30D3\30B9\306E\30E1\30BF\30C7\30FC\30BF\304CORDS\306B\30B3\30D4\30FC\3055\308C\307E\3059\3002\65E2\5B58\306EAPEX\30D9\30FC\30B9\306E\30B5\30FC\30D3\30B9\306E\5B9A\7FA9\306F\305D\306E\307E\307E\6B8B\308A\307E\3059\304C\3001\4E00\81F4\3059\308B\30B5\30FC\30D3\30B9\304CORDS\306B\5B58\5728\3059\308B\304B\304E\308A\5B9F\884C\3055\308C\307E\305B\3093\3002 '),
'',
unistr('\79FB\884C\5F8C\3001\79FB\884C\3055\308C\305FORDS\30D9\30FC\30B9\306E\30B5\30FC\30D3\30B9\306E\691C\8A3C\304A\3088\3073\30C6\30B9\30C8\3092\884C\3046\3053\3068\3092\304A\85A6\3081\3057\307E\3059\3002\691C\8A3C\304C\6E08\3093\3060\3089\3001APEX\30D9\30FC\30B9\306E\30B5\30FC\30D3\30B9\3092\30A8\30AF\30B9\30DD\30FC\30C8\3057\3001\524A\9664\3057\3066\304F\3060\3055\3044\3002</div>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104743065923309037)
,p_name=>'REST_WS.MIGRATION_WARNING_18_2_PLUS'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div style="padding:20px; font-size: 12px;"><p>APEX\306F\3001URI\63A5\982D\8F9E\304CNULL\306EAPEX\30D9\30FC\30B9\306EREST\30E2\30B8\30E5\30FC\30EB\304C\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306B2\3064\4EE5\4E0A\542B\307E\308C\3066\3044\308B\3053\3068\3092\691C\51FA\3057\307E\3057\305F\3002ORDS\306F\3001\8907\6570\306E\30E2\30B8\30E5\30FC\30EB\304C\540C\3058\30D9\30FC\30B9URI\63A5\982D\8F9E\3092\6301\3064\3053\3068\3092\8A31\53EF\3057\307E\305B\3093\3002 </p>'),
'',
unistr('<p>\3053\308C\3089\306E\30B5\30FC\30D3\30B9\3092ORDS\306B\79FB\884C\3059\308B\5834\5408\3001\6B21\306E\30EB\30FC\30EB\304C\9069\7528\3055\308C\307E\3059: </p>'),
'',
'<ul>',
unistr('<li>\5F71\97FF\3092\53D7\3051\308B\3059\3079\3066\306E\30E2\30B8\30E5\30FC\30EB\304C\3001<em><strong>merged.apex.rest.services</strong></em>\3068\3044\3046\5358\4E00\306EORDS\30E2\30B8\30E5\30FC\30EB\306B\7E2E\5C0F\3055\308C\307E\3059\3002</li>'),
unistr('<li>\30DE\30FC\30B8\3055\308C\308BAPEX\30D9\30FC\30B9\306E\30E2\30B8\30E5\30FC\30EB\306E<strong><em>\3044\305A\308C\304B\304C\516C\958B\6E08</em></strong>\306E\5834\5408\3001\30DE\30FC\30B8\6E08\306E\65B0\3057\3044\30E2\30B8\30E5\30FC\30EB\306F<strong><em>\516C\958B\3055\308C\307E\3059</em></strong>\3002</li>'),
unistr('<li>\30DE\30FC\30B8\3055\308C\308BAPEX\30D9\30FC\30B9\306E\30E2\30B8\30E5\30FC\30EB\306E<strong><em>\3044\305A\308C\3082\516C\958B\6E08\3067\306A\3044</em></strong>\5834\5408\3001\30DE\30FC\30B8\6E08\306E\65B0\3057\3044\30E2\30B8\30E5\30FC\30EB\306F<strong><em>\516C\958B\3055\308C\307E\305B\3093</em></strong>\3002</li>'),
unistr('<li>\30DE\30FC\30B8\3055\308C\308BAPEX\30D9\30FC\30B9\306E\30E2\30B8\30E5\30FC\30EB\306B\95A2\9023\4ED8\3051\3089\308C\3066\3044\308B<strong><em>\3059\3079\3066\306E\30ED\30FC\30EB</em></strong>\304C<strong><em>\30DE\30FC\30B8\6E08\306E\65B0\3057\3044\30E2\30B8\30E5\30FC\30EB\306B\5272\308A\5F53\3066\3089\308C\307E\3059</em></strong>\3002</li>'),
unistr('<li>\30DE\30FC\30B8\6E08\306E\30E2\30B8\30E5\30FC\30EB\306E<strong><em>\30DA\30FC\30B8\533A\5207\308A\30B5\30A4\30BA</em></strong>\306F\3001\30DE\30FC\30B8\3055\308C\308B\30E2\30B8\30E5\30FC\30EB\306E<strong><em>\6700\5927\30DA\30FC\30B8\533A\5207\308A\30B5\30A4\30BA</em></strong>\306B\8A2D\5B9A\3055\308C\307E\3059\3002</li>'),
unistr('<li>\30D9\30FC\30B9URI\304CNULL\3067\3001\91CD\8907\3057\305F\30C6\30F3\30D7\30EC\30FC\30C8URI\3092\6301\3064APEX\30E2\30B8\30E5\30FC\30EB\304C\3042\308B\5834\5408\3001\6B21\306E\72B6\6CC1\304C\767A\751F\3057\307E\3059:'),
'',
'<ul>',
unistr('<li>\6700\5F8C\306B\66F4\65B0\3055\308C\305F\30C6\30F3\30D7\30EC\30FC\30C8\304C\91CD\8907\3057\305FURI\3092\4FDD\6301\3057\307E\3059</li>'),
unistr('<li>\305D\306E\4ED6\3059\3079\3066\306E\30C6\30F3\30D7\30EC\30FC\30C8\306Bdup001_*\3068\3044\3046\63A5\982D\8F9E\304C\4ED8\304D\307E\3059</li>'),
unistr('<li>\30C6\30F3\30D7\30EC\30FC\30C8\306E\30B3\30E1\30F3\30C8\306B\3001\79FB\884C\5143\306E\30E2\30B8\30E5\30FC\30EB\540D\3068\5143\306E\30C6\30F3\30D7\30EC\30FC\30C8URI\304C\542B\3081\3089\308C\307E\3059</li>'),
'</ul></li>',
'</ul>',
'</div>',
'<hr/>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104742978423309037)
,p_name=>'REST_WS.MIGRATION_WARNING_PRE_18_2'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div style="padding:20px; font-size: 12px;"><p>APEX\306F\3001URI\63A5\982D\8F9E\304CNULL\306EAPEX\30D9\30FC\30B9\306EREST\30E2\30B8\30E5\30FC\30EB\304C\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306B2\3064\4EE5\4E0A\542B\307E\308C\3066\3044\308B\3053\3068\3092\691C\51FA\3057\307E\3057\305F\3002ORDS\306F\3001\8907\6570\306E\30E2\30B8\30E5\30FC\30EB\304C\540C\3058\30D9\30FC\30B9URI\63A5\982D\8F9E\3092\6301\3064\3053\3068\3092\8A31\53EF\3057\307E\305B\3093\3002 </p>'),
'',
unistr('<p>\73FE\5728\3001APEX\30D9\30FC\30B9\306EREST\30B5\30FC\30D3\30B9\3092ORDS\306B\79FB\884C\3059\308B\3053\3068\306F\3067\304D\307E\305B\3093\3002\79FB\884C\306FORDS\30D0\30FC\30B8\30E7\30F318.2\4EE5\4E0A\3067\53EF\80FD\306B\306A\308A\307E\3059\3002</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104709978275309008)
,p_name=>'REST_WS.MODULE_COUNT_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5408\8A08\30E2\30B8\30E5\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104322786057308699)
,p_name=>'REST_WS.MODULE_CREATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F5C\6210\3055\308C\305F\30E2\30B8\30E5\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104322958951308699)
,p_name=>'REST_WS.MODULE_DELETED'
,p_message_language=>'ja'
,p_message_text=>unistr('\524A\9664\3055\308C\305F\30E2\30B8\30E5\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104292866589308677)
,p_name=>'REST_WS.MODULE_ID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E2\30B8\30E5\30FC\30EBID\304C\5FC5\8981\3067\3059\304CNULL\3092\53D7\3051\53D6\308A\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104322862645308699)
,p_name=>'REST_WS.MODULE_UPDATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F4\65B0\3055\308C\305F\30E2\30B8\30E5\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103658054129308134)
,p_name=>'REST_WS.NAMED_PARAM_CONTAINS_INVALID_CHARS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EB\30FC\30C8\30FB\30D1\30BF\30FC\30F3\5185\306E\540D\524D\4ED8\304D\30D1\30E9\30E1\30FC\30BF\306B\7121\52B9\306A\6587\5B57\304C\542B\307E\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104540004943308867)
,p_name=>'REST_WS.NOT_ORDS_ENABLED'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B9\30AD\30FC\30DE\306FORDS RESTful Data Services\306B\767B\9332\3055\308C\3066\3044\307E\305B\3093\3002\3053\306E\30B9\30AD\30FC\30DE\3092\767B\9332\3059\308B\306B\306F\3001<strong>\300CORDS\306B\30B9\30AD\30FC\30DE\3092\767B\9332\300D</strong>\3092\30AF\30EA\30C3\30AF\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103658450223308134)
,p_name=>'REST_WS.NOT_URI_OR_ROUTE'
,p_message_language=>'ja'
,p_message_text=>unistr('URI\304CURI\307E\305F\306FROUTE\30B9\30BF\30A4\30EB\30FB\30D1\30BF\30FC\30F3\306B\4E00\81F4\3057\307E\305B\3093\3067\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103658514913308134)
,p_name=>'REST_WS.NO_MORE_THAN_ONE_FORWARD_SLASH'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\308C\306F\30012\3064\4EE5\4E0A\306E\9023\7D9A\3059\308B\30B9\30E9\30C3\30B7\30E5\3092\4F7F\7528\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103657902999308134)
,p_name=>'REST_WS.NO_QUERY_STRING_IN_ROUTE_PATTERN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EB\30FC\30C8\30FB\30D1\30BF\30FC\30F3\306E\554F\5408\305B\6587\5B57\5217\3092\4F7F\7528\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103561930254308060)
,p_name=>'REST_WS.NO_REST_IN_CDB'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>APEX\306F\3001\73FE\5728CDB\3067\5B9F\884C\3055\308C\3066\3044\307E\3059\3002CDB\3067ORDS\30D9\30FC\30B9\306EREST\30B5\30FC\30D3\30B9\3092\5B9A\7FA9\3059\308B\3053\3068\306F\3067\304D\307E\305B\3093\3002</p><p>\5F15\304D\7D9A\304D\3001APEX\30D9\30FC\30B9\306ERESTful\30B5\30FC\30D3\30B9\3092\4F7F\7528\3067\304D\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104473614058308812)
,p_name=>'REST_WS.OLD_ORDS_VERSION'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\73FE\5728\30A4\30F3\30B9\30C8\30FC\30EB\3055\308C\3066\3044\308BORDS\306E\30D0\30FC\30B8\30E7\30F3(%0)\306F\3001Application Express\306EORDS\30D9\30FC\30B9\306ERESTful\30B5\30FC\30D3\30B9\3092\6709\52B9\306B\3059\308B\305F\3081\306B\5FC5\8981\306A\3059\3079\3066\306E\6A5F\80FD\3092\30B5\30DD\30FC\30C8\3057\3066\3044\308B\308F\3051\3067\306F\3042\308A\307E\305B\3093\3002%1\306E\6700\4F4E\30D0\30FC\30B8\30E7\30F3\3092\30A4\30F3\30B9\30C8\30FC\30EB\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>'),
unistr('<p>APEX\30D9\30FC\30B9\306ERESTful\30B5\30FC\30D3\30B9\3092\5F15\304D\7D9A\304D\4F7F\7528\3067\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103658178911308134)
,p_name=>'REST_WS.OPTIONAL_CHAR_MUST_BE_LAST'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30D7\30B7\30E7\30F3\306E(?)\6587\5B57\306F\3001\6700\5F8C\306E\6587\5B57\3068\3057\3066\306E\307F\30EB\30FC\30C8\30FB\30D1\30BF\30FC\30F3\306B\542B\3081\308B\3053\3068\304C\3067\304D\3001\540D\524D\4ED8\304D\30D1\30E9\30E1\30FC\30BF\304C\5148\884C\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103656981287308133)
,p_name=>'REST_WS.ORDS_NOT_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>ORDS REST\30EF\30FC\30AF\30B7\30E7\30C3\30D7\3092\6709\52B9\306B\3059\308B\305F\3081\306B\5FC5\8981\306AORDS_METADATA\30B9\30AD\30FC\30DE\304C\898B\3064\304B\308A\307E\305B\3093\3067\3057\305F\3002\30A4\30F3\30B9\30C8\30FC\30EB\624B\9806\306B\3064\3044\3066\306F\3001Oracle REST Data Services\306E\30A4\30F3\30B9\30C8\30EC\30FC\30B7\30E7\30F3\30FB\30AC\30A4\30C9\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002</p> <p>APEX\30D9\30FC\30B9\306ERESTful\30B5\30FC\30D3\30B9\3092\5F15\304D\7D9A\304D\4F7F\7528\3067\304D\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103675191099308146)
,p_name=>'REST_WS.PARTIALLY_SECURED'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E00\90E8\4FDD\8B77')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103656838965308133)
,p_name=>'REST_WS.PLSQL_GATEWAY'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\3053\306E\30B7\30B9\30C6\30E0\306F\73FE\5728\3001Oracle Embedded PL/SQL Gateway\3092\4F7F\7528\3057\3066\3044\307E\3059\3002ORDS REST\30EF\30FC\30AF\30B7\30E7\30C3\30D7\3078\306E\30A2\30AF\30BB\30B9\3092\6709\52B9\306B\3059\308B\306B\306F\3001\30D0\30FC\30B8\30E7\30F3%0\4EE5\4E0A\306EOracle REST Data Services\3092\30A4\30F3\30B9\30C8\30FC\30EB\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p> <p>APEX\30D9\30FC\30B9\306ERESTful\30B5\30FC\30D3\30B9\3092\5F15\304D\7D9A\304D\4F7F\7528\3067\304D\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104710099130309008)
,p_name=>'REST_WS.PRIVILEGE_COUNT_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5408\8A08\6A29\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104323977578308700)
,p_name=>'REST_WS.PRIVILEGE_CREATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F5C\6210\3055\308C\305F\6A29\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104324106206308700)
,p_name=>'REST_WS.PRIVILEGE_DELETED'
,p_message_language=>'ja'
,p_message_text=>unistr('\524A\9664\3055\308C\305F\6A29\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104324033139308700)
,p_name=>'REST_WS.PRIVILEGE_UPDATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F4\65B0\3055\308C\305F\6A29\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103674764605308146)
,p_name=>'REST_WS.PUBLISHED'
,p_message_language=>'ja'
,p_message_text=>unistr('\516C\958B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103675881326308147)
,p_name=>'REST_WS.RESET_SAMPLE_WARNING'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30A2\30AF\30B7\30E7\30F3\3067\306F\3001\73FE\5728\9078\629E\3055\308C\3066\3044\308B\30B9\30AD\30FC\30DE\306E<strong>oracle.example.hr</strong>\30E2\30B8\30E5\30FC\30EB\304A\3088\3073\95A2\9023\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30AA\30D6\30B8\30A7\30AF\30C8\304C\524A\9664\3055\308C\3001\518D\4F5C\6210\3055\308C\307E\3059\3002\884C\3063\305F\5909\66F4\307E\305F\306F\8FFD\52A0\306F\5931\308F\308C\3001\5143\306B\623B\305B\307E\305B\3093\3002</p>'),
unistr('<p>\30B5\30F3\30D7\30EB\30FB\30B5\30FC\30D3\30B9\3092\30EA\30BB\30C3\30C8\3057\307E\3059\304B\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104710158537309008)
,p_name=>'REST_WS.ROLE_COUNT_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5408\8A08\30ED\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104323637416308700)
,p_name=>'REST_WS.ROLE_CREATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F5C\6210\3055\308C\305F\30ED\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104323888337308700)
,p_name=>'REST_WS.ROLE_DELETED'
,p_message_language=>'ja'
,p_message_text=>unistr('\524A\9664\3055\308C\305F\30ED\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104323752396308700)
,p_name=>'REST_WS.ROLE_UPDATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F4\65B0\3055\308C\305F\30ED\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103695004302308162)
,p_name=>'REST_WS.SCHEMA_ACCESS_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30BB\30B9\30FB\30B9\30C6\30FC\30BF\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103695239128308162)
,p_name=>'REST_WS.SCHEMA_ALIAS_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AD\30FC\30DE\5225\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104470639625308810)
,p_name=>'REST_WS.SCRIPT_TOO_LONG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30C3\30D7\30ED\30FC\30C9\3055\308C\305F\30B9\30AF\30EA\30D7\30C8\304C\5927\304D\3059\304E\307E\3059\3002Application Express\306E\5236\9650\306F32MB (32767\30D0\30A4\30C8)\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103674925047308146)
,p_name=>'REST_WS.SECURED'
,p_message_language=>'ja'
,p_message_text=>unistr('\4FDD\8B77')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104292985734308677)
,p_name=>'REST_WS.SEQ_ID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30E9\30E1\30FC\30BF\306E\30B7\30FC\30B1\30F3\30B9ID\304C\5FC5\8981\3067\3059\304CNULL\3092\53D7\3051\53D6\308A\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104710431366309009)
,p_name=>'REST_WS.SIMPLE_STATUS_FAILURE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5931\6557')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104710330062309008)
,p_name=>'REST_WS.SIMPLE_STATUS_SUCCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6210\529F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104710578601309009)
,p_name=>'REST_WS.SIMPLE_STATUS_WARNING'
,p_message_language=>'ja'
,p_message_text=>unistr('\8B66\544A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104323090228308699)
,p_name=>'REST_WS.TEMPLATE_CREATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F5C\6210\3055\308C\305F\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104323247959308699)
,p_name=>'REST_WS.TEMPLATE_DELETED'
,p_message_language=>'ja'
,p_message_text=>unistr('\524A\9664\3055\308C\305F\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104293192898308677)
,p_name=>'REST_WS.TEMPLATE_ID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8ID\304C\5FC5\8981\3067\3059\304CNULL\3092\53D7\3051\53D6\308A\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103593159918308083)
,p_name=>'REST_WS.TEMPLATE_MAY_NOT_BE_NULL'
,p_message_language=>'ja'
,p_message_text=>unistr('URI\30C6\30F3\30D7\30EC\30FC\30C8\306Fnull\306B\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104323127743308699)
,p_name=>'REST_WS.TEMPLATE_UPDATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F4\65B0\3055\308C\305F\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103675435059308147)
,p_name=>'REST_WS.TREE_ENABLED_OBJECTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6709\52B9\306A\30AA\30D6\30B8\30A7\30AF\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103675536362308147)
,p_name=>'REST_WS.TREE_MODULES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E2\30B8\30E5\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103675629190308147)
,p_name=>'REST_WS.TREE_PRIVILEGES'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A29\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103675770047308147)
,p_name=>'REST_WS.TREE_ROLES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104698985965308999)
,p_name=>'REST_WS.TREE_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('RESTful\30C7\30FC\30BF\30FB\30B5\30FC\30D3\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103675318762308147)
,p_name=>'REST_WS.UNALIASED'
,p_message_language=>'ja'
,p_message_text=>unistr('\5225\540D\672A\6307\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103674867292308146)
,p_name=>'REST_WS.UNPUBLISHED'
,p_message_language=>'ja'
,p_message_text=>unistr('\975E\516C\958B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103675024675308146)
,p_name=>'REST_WS.UNSECURED'
,p_message_language=>'ja'
,p_message_text=>unistr('\975E\4FDD\8B77')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103657876878308134)
,p_name=>'REST_WS.VARIABLE_SYNTAX_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('1\3064\4EE5\4E0A\306EURI\5909\6570\306B\69CB\6587\30A8\30E9\30FC\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104274097024308663)
,p_name=>'REST_WS.WRONG_SCRIPT_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30FC\30C9\3057\3088\3046\3068\3057\3066\3044\308B\30B9\30AF\30EA\30D7\30C8\306FAPEX\30D9\30FC\30B9\306ERESTful\30B5\30FC\30D3\30B9\306E\30A8\30AF\30B9\30DD\30FC\30C8\3067\3059\3002ORDS RESTful\30B5\30FC\30D3\30B9\306E\30A4\30F3\30DD\30FC\30C8\30FB\30DA\30FC\30B8\3092\4F7F\7528\3057\3066\30ED\30FC\30C9\3059\308B\3053\3068\306F\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104537667789308866)
,p_name=>'REST_WS.WRONG_SCRIPT_TYPE_APEX'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30FC\30C9\3057\3088\3046\3068\3057\3066\3044\308B\30B9\30AF\30EA\30D7\30C8\306FORDS\30D9\30FC\30B9\306ERESTful\30B5\30FC\30D3\30B9\306E\30A8\30AF\30B9\30DD\30FC\30C8\3067\3059\3002APEX RESTful\30B5\30FC\30D3\30B9\306E\30A4\30F3\30DD\30FC\30C8\30FB\30DA\30FC\30B8\3092\4F7F\7528\3057\3066\30ED\30FC\30C9\3059\308B\3053\3068\306F\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104710665100309009)
,p_name=>'REST_WS_COPY_TO_CLIPBOARD'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30EA\30C3\30D7\30DC\30FC\30C9\306B\30B3\30D4\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104710759090309009)
,p_name=>'REST_WS_COPY_TO_CLIPBOARD_ARIA'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B8C\5168\306AURL\3092\30AF\30EA\30C3\30D7\30DC\30FC\30C9\306B\30B3\30D4\30FC')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104668974529308974)
,p_name=>'RETAINED'
,p_message_language=>'ja'
,p_message_text=>unistr('\4FDD\6301')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103783612273308234)
,p_name=>'RETURN_TO_LOGIN_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306E\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8\306B\623B\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104788968665309080)
,p_name=>'RETURN_VALUE.N'
,p_message_language=>'ja'
,p_message_text=>unistr('\623B\308A\5024: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104010326067308443)
,p_name=>'REVIEWING'
,p_message_language=>'ja'
,p_message_text=>unistr('\78BA\8A8D\4E2D')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104271788473308661)
,p_name=>'ROLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30FC\30EB')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103789842782308239)
,p_name=>'ROLLBACK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30FC\30EB\30D0\30C3\30AF\6587\306F\9069\7528\3055\308C\307E\305B\3093\3002\3059\3079\3066\306E\6587\306F\81EA\52D5\7684\306B\30B3\30DF\30C3\30C8\3055\308C\307E\3059\3002')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104133621947308544)
,p_name=>'ROWS_IN_SECONDS'
,p_message_language=>'ja'
,p_message_text=>unistr('%1\79D2\9593\306B%0\884C\304C\623B\3055\308C\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103613561071308097)
,p_name=>'ROWS_RETURNED_IN'
,p_message_language=>'ja'
,p_message_text=>unistr('\623B\3055\308C\305F\884C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104224373832308627)
,p_name=>'RUN'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9F\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103538646625308043)
,p_name=>'RUN_AND_BUILD'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9F\884C\3068\958B\767A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103989837649308428)
,p_name=>'RUN_APPLICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\5B9F\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104227131360308629)
,p_name=>'RUN_APPLICATION_ID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\5B9F\884C: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103786538033308237)
,p_name=>'RUN_ONLY'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9F\884C\306E\307F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104229152577308631)
,p_name=>'RUN_PAGE_ID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306E\5B9F\884C: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103592746690308082)
,p_name=>'SAMPLE APPLICATIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30F3\30D7\30EB\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104186911129308599)
,p_name=>'SAMPLE_DS.COUNTRY'
,p_message_language=>'ja'
,p_message_text=>unistr('\56FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104187232307308599)
,p_name=>'SAMPLE_DS.COUNTRY.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\56FD\3001\4EBA\53E3\304A\3088\3073\9996\90FD\306E\30EA\30B9\30C8\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103774318967308227)
,p_name=>'SAMPLE_DS.EMP_DEPT'
,p_message_language=>'ja'
,p_message_text=>'EMP / DEPT'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103774475700308227)
,p_name=>'SAMPLE_DS.EMP_DEPT.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\6C4E\7528EMP\8868\304A\3088\3073DEPT\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104187010630308599)
,p_name=>'SAMPLE_DS.F1'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30FC\30DF\30E5\30E91')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104187451717308599)
,p_name=>'SAMPLE_DS.F1.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30FC\30DF\30E5\30E91\306E\4E16\754C\30C1\30E3\30F3\30D4\30AA\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104668287779308974)
,p_name=>'SAMPLE_DS.HEALTH_UPDATES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D8\30EB\30B9\66F4\65B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104668309677308974)
,p_name=>'SAMPLE_DS.HEALTH_UPDATES.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\533B\7642\63D0\4F9B\8005\5411\3051\306E\7C21\7565\5316\3055\308C\305F\60A3\8005\5831\544A\306E\30D8\30EB\30B9\30FB\30B9\30C6\30FC\30BF\30B9\66F4\65B0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103774541200308227)
,p_name=>'SAMPLE_DS.OEHR'
,p_message_language=>'ja'
,p_message_text=>unistr('HR\30C7\30FC\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103774613602308227)
,p_name=>'SAMPLE_DS.OEHR.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('Oracle Education\3067\983B\7E41\306B\4F7F\7528\3055\308C\308B\6C4E\7528HR\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104227204134308629)
,p_name=>'SAMPLE_DS.ORDERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\9867\5BA2\30AA\30FC\30C0\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104227375613308630)
,p_name=>'SAMPLE_DS.ORDERS.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\9867\5BA2\3001\5E97\8217\3001\88FD\54C1\306A\3069\306E\30B3\30EC\30AF\30B7\30E7\30F3\3002\3053\306E\30C7\30FC\30BF\30BB\30C3\30C8\306B\306F\3001\88FD\54C1\306E\8AAC\660E\304A\3088\3073\5E97\8217\306E\7D4C\5EA6/\7DEF\5EA6\306EJSON\30C7\30FC\30BF\304C\542B\307E\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103774158006308227)
,p_name=>'SAMPLE_DS.PROJECT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30B8\30A7\30AF\30C8\30FB\30C7\30FC\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103774285759308227)
,p_name=>'SAMPLE_DS.PROJECT.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30B8\30A7\30AF\30C8\3001\30DE\30A4\30EB\30B9\30C8\30F3\3001\30BF\30B9\30AF\306A\3069\306E\30B3\30EC\30AF\30B7\30E7\30F3\3002\3053\306E\30C7\30FC\30BF\30BB\30C3\30C8\306B\306F\3001\30DE\30B9\30BF\30FC\30FB\30C7\30A3\30C6\30FC\30EB\95A2\4FC2\3001\304A\3088\3073\30C1\30E3\30FC\30C8\4F5C\6210\306E\305F\3081\306E\6709\7528\306A\30D3\30E5\30FC\304C\542B\307E\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103774725588308227)
,p_name=>'SAMPLE_DS.TASKS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30B9\30AF\30FB\30B9\30D7\30EC\30C3\30C9\30B7\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103774824902308227)
,p_name=>'SAMPLE_DS.TASKS.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30B9\30AF\3001\65E5\4ED8\3001\30B9\30C6\30FC\30BF\30B9\3001\5272\5F53\3066\5148\3001\30B3\30B9\30C8\304A\3088\3073\4E88\7B97\306A\3069\306E\6B63\898F\5316\3055\308C\3066\3044\306A\3044\30C7\30FC\30BF\3092\542B\3080\5358\4E00\306E\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104186858044308598)
,p_name=>'SAMPLE_DS.TENNIS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30CB\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104187326269308599)
,p_name=>'SAMPLE_DS.TENNIS.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30E9\30F3\30C9\30FB\30B9\30E9\30E0\30FB\30A4\30D9\30F3\30C8\306E\7537\5973\306E\512A\52DD\8005\304A\3088\3073\6E96\512A\52DD\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104187170282308599)
,p_name=>'SAMPLE_DS.WORLD_CUP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30EB\30C9\30AB\30C3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104187573223308599)
,p_name=>'SAMPLE_DS.WORLD_CUP.DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30C3\30AB\30FC\30FB\30EF\30FC\30EB\30C9\30AB\30C3\30D7\306E\7D50\679C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104070742422308492)
,p_name=>'SAMPLE_WEBSHEET'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30F3\30D7\30EBWeb\30B7\30FC\30C8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104057574981308481)
,p_name=>'SAVED_REPORTS.LINK_ALIAS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30F3\30AF\306E\5225\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104057658943308481)
,p_name=>'SAVED_REPORTS.LINK_EXAMPLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30F3\30AF\4F8B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104057727357308481)
,p_name=>'SAVED_REPORTS.MORE_SAVED_REPORTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\305D\306E\4ED6\306E\4FDD\5B58\6E08\30EC\30DD\30FC\30C8...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104057224811308481)
,p_name=>'SAVED_REPORTS.PRIMARY_REPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30E9\30A4\30DE\30EA\30FB\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104056513600308480)
,p_name=>'SAVED_REPORTS.PRIVATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30E9\30A4\30D9\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104056638440308481)
,p_name=>'SAVED_REPORTS.PRIVATE.NOTIFICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30E9\30A4\30D9\30FC\30C8\30FB\30B5\30D6\30B9\30AF\30EA\30D7\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104057135604308481)
,p_name=>'SAVED_REPORTS.PUBLIC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30D6\30EA\30C3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104057470865308481)
,p_name=>'SAVED_REPORTS.REPORT_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104057360324308481)
,p_name=>'SAVED_REPORTS.REPORT_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\30FB\30BF\30A4\30D7')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103701570565308168)
,p_name=>'SC.BC.BCE_DELETED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0\30FB\30A8\30F3\30C8\30EA\304C\524A\9664\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103701750304308168)
,p_name=>'SC.BC.BCE_INSERTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0\30FB\30A8\30F3\30C8\30EA\304C\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103701603314308168)
,p_name=>'SC.BC.BCE_UPDATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0\30FB\30A8\30F3\30C8\30EA\304C\66F4\65B0\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103701411692308168)
,p_name=>'SC.BC.BC_DELETED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0\304C\524A\9664\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103701310860308168)
,p_name=>'SC.BC.BC_UPDATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0\304C\66F4\65B0\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103673307303308145)
,p_name=>'SC.LOV.IG_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\5BFE\8A71\30B0\30EA\30C3\30C9\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103673263561308145)
,p_name=>'SC.LOV.PAGE_ITEM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104029720814308458)
,p_name=>'SCHEMAS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AD\30FC\30DE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104141295496308551)
,p_name=>'SCHEMA_INSERT_EXCEPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('wwv_flow_companies\30B9\30AD\30FC\30DE\306E\633F\5165\4F8B\5916')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104140294900308550)
,p_name=>'SCHEMA_IS_AVAILABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AD\30FC\30DE"%0"\306F\4F7F\7528\53EF\80FD\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104140329822308550)
,p_name=>'SCHEMA_IS_NOT_AVAILABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AD\30FC\30DE"%0"\306F\65E2\5B58\306E\30E6\30FC\30B6\30FC\3068\7AF6\5408\3057\3066\3044\308B\305F\3081\3001\73FE\5728\306F\4F7F\7528\4E0D\53EF\80FD\3067\3042\308A\3001\4F5C\6210\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103937949784308388)
,p_name=>'SCHEMA_PASSWORD'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AD\30FC\30DE\306E\30D1\30B9\30EF\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103754782284308211)
,p_name=>'SCHEMES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AD\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104708854780309007)
,p_name=>'SCREEN_READER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AF\30EA\30FC\30F3\30FB\30EA\30FC\30C0\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104060897814308484)
,p_name=>'SCREEN_READER_TOGGLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AF\30EA\30FC\30F3\30FB\30EA\30FC\30C0\30FC\5207\66FF\3048')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104091437330308509)
,p_name=>'SCRIPT_EXPORTED_FROM_FOREIGN_WORKSPACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30D5\30A1\30A4\30EB\306F\3001\5225\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9(%0)\304B\3001\5225\306E%1\30C7\30FC\30BF\30D9\30FC\30B9\304B\3089\30A8\30AF\30B9\30DD\30FC\30C8\3055\308C\305F\53EF\80FD\6027\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104733087752309029)
,p_name=>'SCRIPT_NAME_LOCKED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AF\30EA\30D7\30C8%0\304C\30ED\30C3\30AF\3055\308C\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104732951980309029)
,p_name=>'SCRIPT_NAME_UNLOCKED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AF\30EA\30D7\30C8%0\304C\30ED\30C3\30AF\89E3\9664\3055\308C\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104742194206309036)
,p_name=>'SCRIPT_NOT_LOCKED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AF\30EA\30D7\30C8\304C\30ED\30C3\30AF\3055\308C\3066\3044\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104018140912308449)
,p_name=>'SC_DESCRIBE'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
unistr('\30AA\30D6\30B8\30A7\30AF\30C8\3001\30BF\30A4\30D7\5B9A\7FA9\3092\8868\793A\3059\308B\306B\306F\3001<br><br> '),
'',
unistr('\4E0A\306E\30B3\30DE\30F3\30C9\30FB\30DA\30A4\30F3\306B\300CDESCRIBE &lt \30AA\30D6\30B8\30A7\30AF\30C8\540D &gt\300D\3068\5165\529B\3057\3066\300C\5B9F\884C\300D\3092\30AF\30EA\30C3\30AF\3057\307E\3059\3002'),
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104047660672308473)
,p_name=>'SC_NAME_NN'
,p_message_language=>'ja'
,p_message_text=>unistr('\554F\5408\305B\540D\306FNULL\306B\3067\304D\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104059619493308483)
,p_name=>'SC_NOT_VALID_OBJECT'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre><br>',
unistr('\8A18\8FF0\3055\308C\308B\30AA\30D6\30B8\30A7\30AF\30C8\304C\898B\3064\304B\308A\307E\305B\3093\3067\3057\305F\3002'),
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104050245887308475)
,p_name=>'SC_SC'
,p_message_language=>'ja'
,p_message_text=>unistr('Visual Query\4EE5\5916')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103984682262308424)
,p_name=>'SC_SQL_RUNNING'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\6587\3092\5B9F\884C\3057\3066\3044\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104050161996308475)
,p_name=>'SC_VQ'
,p_message_language=>'ja'
,p_message_text=>'Visual Query'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104672601135308977)
,p_name=>'SEARCH_BAR_SETTINGS'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22\30D0\30FC\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104092602746308510)
,p_name=>'SEARCH_FIELD'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22\30D5\30A3\30FC\30EB\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103938334561308388)
,p_name=>'SEARCH_NOT_ENABLED'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\554F\5408\305B\306B\306Fvarchar\5217\304C\306A\3044\305F\3081\3001\691C\7D22\3092\6709\52B9\306B\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103927768979308380)
,p_name=>'SEARCH_NOT_REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22\5BFE\8C61\306Evarchar\5217\304C\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104092538259308510)
,p_name=>'SEARCH_PACKAGED_APPS'
,p_message_language=>'ja'
,p_message_text=>unistr('\751F\7523\6027\304A\3088\3073\30B5\30F3\30D7\30EB\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\691C\7D22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104487053077308829)
,p_name=>'SEARCH_RESULTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22\7D50\679C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104674510152308979)
,p_name=>'SECTIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30AF\30B7\30E7\30F3')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103733504932308194)
,p_name=>'SECURITY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30AD\30E5\30EA\30C6\30A3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104024801244308455)
,p_name=>'SECURITY_ASSIGNEE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30AD\30E5\30EA\30C6\30A3\5272\5F53\3066\5148')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104375747618308738)
,p_name=>'SECURITY_GROUP_ID_INVALID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30AD\30E5\30EA\30C6\30A3\30FB\30B0\30EB\30FC\30D7ID(\30EF\30FC\30AF\30B9\30DA\30FC\30B9\8B58\5225\60C5\5831)\304C\7121\52B9\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104022944983308453)
,p_name=>'SECURITY_IMPACT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30AD\30E5\30EA\30C6\30A3\306E\5F71\97FF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104064884963308487)
,p_name=>'SECURITY_SCHEME'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\53EF\30B9\30AD\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104051348411308476)
,p_name=>'SECURITY_SCHEME.MUST_NOT_BE_PUBLIC_USER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30D6\30EA\30C3\30AF\30FB\30E6\30FC\30B6\30FC\306F\4E0D\53EF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104025283496308455)
,p_name=>'SECURITY_STATUS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30AD\30E5\30EA\30C6\30A3\30FB\30B9\30C6\30FC\30BF\30B9')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104050862336308476)
,p_name=>'SEE_ATTACHED_REPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6DFB\4ED8\30EC\30DD\30FC\30C8\306E\8868\793A')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103586055657308077)
,p_name=>'SELECT_ALL'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\9078\629E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103932005825308383)
,p_name=>'SELECT_APPLICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\9078\629E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103540548556308045)
,p_name=>'SELECT_DATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\304B\3089\65E5\4ED8\3092\9078\629E\3057\307E\3059\3002\5F53\6708= %0\3001\5F53\5E74= %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104559077018308886)
,p_name=>'SELECT_DYNAMIC_ACTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\52D5\7684\30A2\30AF\30B7\30E7\30F3\306E\9078\629E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103743162889308202)
,p_name=>'SELECT_LABEL_TEMPLATE.THEME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103743042096308202)
,p_name=>'SELECT_LIST_TEMPLATE.THEME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103742991965308202)
,p_name=>'SELECT_PAGE_TEMPLATE.THEME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103742827641308202)
,p_name=>'SELECT_REGION_TEMPLATE.THEME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103743221681308202)
,p_name=>'SELECT_REPORT_TEMPLATE.THEME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104760079503309050)
,p_name=>'SELECT_ROW_C'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\306E\9078\629E: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104195449128308606)
,p_name=>'SELECT_WORKSPACE_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0B\304B\3089\30EF\30FC\30AF\30B9\30DA\30FC\30B9\3092\9078\629E\3057\3066Application Express\958B\767A\74B0\5883\3092\958B\304D\307E\3059\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104119090459308532)
,p_name=>'SELF_SERVICE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30EB\30D5\30FB\30B5\30FC\30D3\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104118945417308532)
,p_name=>'SELF_SERVICE_WITH_EMAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\306E\691C\8A3C\3067\306E\30BB\30EB\30D5\30FB\30B5\30FC\30D3\30B9')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104732619986309029)
,p_name=>'SEPARATOR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30D1\30EC\30FC\30BF')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103751604371308209)
,p_name=>'SEQUENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104180023786308593)
,p_name=>'SEQUENCE_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30FC\30B1\30F3\30B9: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103616979874308100)
,p_name=>'SERIES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30EA\30FC\30BA%0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104021407763308452)
,p_name=>'SERVICE_CHANGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30FC\30D3\30B9\5909\66F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103564595321308062)
,p_name=>'SERVICE_LOGIN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30A4\30C8\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104001524421308436)
,p_name=>'SERVICE_REQUEST'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30FC\30D3\30B9\30FB\30EA\30AF\30A8\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103759246448308215)
,p_name=>'SERVICE_SIGNUP.ACCEPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5927/\5C0F\6587\5B57\3092\533A\5225\3057\305F\691C\8A3C\30B3\30FC\30C9\3092\5165\529B\3057\3066\3001\300C<strong>\30EA\30AF\30A8\30B9\30C8\306E\9001\4FE1</strong>\300D\3092\30AF\30EA\30C3\30AF\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103758175565308214)
,p_name=>'SERVICE_SIGNUP.ADMIN_INFO'
,p_message_language=>'ja'
,p_message_text=>unistr('\7BA1\7406\8005\60C5\5831')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103759185064308215)
,p_name=>'SERVICE_SIGNUP.DB_SIZE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30B5\30A4\30BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103758021558308214)
,p_name=>'SERVICE_SIGNUP.DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\8AAC\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103758421039308214)
,p_name=>'SERVICE_SIGNUP.EMAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103758288507308214)
,p_name=>'SERVICE_SIGNUP.FIRST_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103757848373308214)
,p_name=>'SERVICE_SIGNUP.JUSTIFICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B63\5F53\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103758393349308214)
,p_name=>'SERVICE_SIGNUP.LAST_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\59D3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103757765567308214)
,p_name=>'SERVICE_SIGNUP.NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\540D\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103758943016308215)
,p_name=>'SERVICE_SIGNUP.NO'
,p_message_language=>'ja'
,p_message_text=>unistr('\3044\3044\3048')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103758509749308214)
,p_name=>'SERVICE_SIGNUP.PHONE'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\8A71\756A\53F7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103758797618308214)
,p_name=>'SERVICE_SIGNUP.REUSE_SCHEMA'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E2\5B58\306E\30B9\30AD\30FC\30DE\306E\518D\5229\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103758612048308214)
,p_name=>'SERVICE_SIGNUP.SCHEMA_INFO'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AD\30FC\30DE\60C5\5831')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103759044085308215)
,p_name=>'SERVICE_SIGNUP.SCHEMA_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AD\30FC\30DE\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103757696614308214)
,p_name=>'SERVICE_SIGNUP.WORKSPACE_INFO'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\60C5\5831')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103758894149308215)
,p_name=>'SERVICE_SIGNUP.YES'
,p_message_language=>'ja'
,p_message_text=>unistr('\306F\3044')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103950578414308398)
,p_name=>'SESSION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30C3\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104053273201308478)
,p_name=>'SESSION VERIFY FUNCTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30C3\30B7\30E7\30F3\691C\8A3C\30D5\30A1\30F3\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103594269211308083)
,p_name=>'SESSIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30C3\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104116976483308530)
,p_name=>'SESSION_MON_BUFFER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D0\30C3\30D5\30A1:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104116782463308530)
,p_name=>'SESSION_MON_CPU'
,p_message_language=>'ja'
,p_message_text=>'CPU:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104116460302308530)
,p_name=>'SESSION_MON_CURRENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30EC\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104116802249308530)
,p_name=>'SESSION_MON_DISK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30A3\30B9\30AF:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104116639071308530)
,p_name=>'SESSION_MON_ELAPSED'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D4C\904E:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104116575964308530)
,p_name=>'SESSION_MON_PREVIOUS'
,p_message_language=>'ja'
,p_message_text=>unistr('\4EE5\524D')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103677819515308149)
,p_name=>'SET_BINDS'
,p_message_language=>'ja'
,p_message_text=>unistr('\554F\5408\305B\306E\30C6\30B9\30C8\3067\306F\3001\3059\3079\3066\306E\30D0\30A4\30F3\30C9\5909\6570\306B\5024\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103580077437308073)
,p_name=>'SET_FEATURE_DUE_DATE_TO_MILESTONE_DATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30EA\30FC\30B9%2\306E%1\306B\5272\308A\5F53\3066\3089\308C\305F%0\306E\4E0D\5B8C\5168\306A\6A5F\80FD\306E\671F\65E5\3092\30DE\30A4\30EB\30B9\30C8\30F3\306E\65E5\4ED8\306B\8A2D\5B9A\3057\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103699845624308166)
,p_name=>'SET_MILESTONE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30A4\30EB\30B9\30C8\30F3\306E\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103580375192308073)
,p_name=>'SET_MILESTONES_NOT_YET_SET'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30EA\30FC\30B9%2\306E%1\306B\5272\308A\5F53\3066\3089\308C\305F%0\306E\672A\5B8C\4E86\306E\6A5F\80FD\306B\3064\3044\3066\30DE\30A4\30EB\30B9\30C8\30F3\306E\6B20\843D\3057\3066\3044\308B\6A5F\80FD\3092\30DE\30A4\30EB\30B9\30C8\30F3(%3)\306B\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103580256235308073)
,p_name=>'SET_MILESTONE_OF_INCOMPLETE_FEATURES'
,p_message_language=>'ja'
,p_message_text=>unistr('\671F\9650\3092\7D4C\904E\3057\305F\30DE\30A4\30EB\30B9\30C8\30F3\306B\5BFE\5FDC\3059\308B\30EA\30EA\30FC\30B9%2\306E%1\306B\5272\308A\5F53\3066\3089\308C\305F%0\306E\672A\5B8C\4E86\306E\6A5F\80FD\306E\30DE\30A4\30EB\30B9\30C8\30F3\3092\30DE\30A4\30EB\30B9\30C8\30F3(%3)\306B\5909\66F4\3057\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103699401800308166)
,p_name=>'SET_OPEN_FEATURES_M1'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306E\30AA\30FC\30D7\30F3\306A\6A5F\80FD\304C\9078\629E\3057\305F\30DE\30A4\30EB\30B9\30C8\30F3\306B\5272\308A\5F53\3066\3089\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103699964217308167)
,p_name=>'SET_OPEN_FEATURES_M2'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306E\30AA\30FC\30D7\30F3\306A\6A5F\80FD\306E\671F\65E5\304C\30DE\30A4\30EB\30B9\30C8\30F3\65E5\4ED8\306B\8A2D\5B9A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104737145455309032)
,p_name=>'SET_PREFERENCES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30EA\30D5\30A1\30EC\30F3\30B9\306E\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103700192773308167)
,p_name=>'SET_RELEASE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30EA\30FC\30B9\306E\8A2D\5B9A')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104115799810308529)
,p_name=>'SHARED'
,p_message_language=>'ja'
,p_message_text=>unistr('\5171\6709')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104294976741308678)
,p_name=>'SHARED COMPONENTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104052935129308477)
,p_name=>'SHARED DYNAMIC LOV'
,p_message_language=>'ja'
,p_message_text=>unistr('\5171\6709\52D5\7684LOV')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103549453523308051)
,p_name=>'SHARED POOL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5171\6709\30D7\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104052862883308477)
,p_name=>'SHARED STATIC LOV CONDITION'
,p_message_language=>'ja'
,p_message_text=>unistr('\5171\6709\9759\7684LOV\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103624489650308105)
,p_name=>'SHARED_COMPONENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104292224619308676)
,p_name=>'SHARED_VALIDATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\5171\6709\691C\8A3C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103754843136308211)
,p_name=>'SHORTCUT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30E7\30FC\30C8\30AB\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104197497205308608)
,p_name=>'SHORTCUTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30E7\30FC\30C8\30AB\30C3\30C8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104004447810308439)
,p_name=>'SIGNIFICANT_IMPACT'
,p_message_language=>'ja'
,p_message_text=>unistr('\91CD\5927\306A\5F71\97FF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104007580867308441)
,p_name=>'SIGNIFICANT_PROGRESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5927\5E45\306A\9032\6357')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103753365192308210)
,p_name=>'SIMPLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30F3\30D7\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103998985603308435)
,p_name=>'SIMPLE_CHART'
,p_message_language=>'ja'
,p_message_text=>unistr('\5358\7D14\306A\30C1\30E3\30FC\30C8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104076094799308497)
,p_name=>'SINCE_DATE_MASK'
,p_message_language=>'ja'
,p_message_text=>unistr('16\6642\9593\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104135512916308546)
,p_name=>'SINCE_DAY_AGO'
,p_message_language=>'ja'
,p_message_text=>unistr('1\65E5\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104135488619308546)
,p_name=>'SINCE_HOUR_AGO'
,p_message_language=>'ja'
,p_message_text=>unistr('1\6642\9593\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104755413279309046)
,p_name=>'SINCE_SHORT_DATE_MASK'
,p_message_language=>'ja'
,p_message_text=>unistr('16\6642\9593\4EE5\5185')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104135615950308546)
,p_name=>'SINCE_WEEK_AGO'
,p_message_language=>'ja'
,p_message_text=>unistr('1\9031\9593\524D')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103591024055308081)
,p_name=>'SIZE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30A4\30BA')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104711885500309010)
,p_name=>'SL.APP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104707973899309007)
,p_name=>'SL.EDIT.PAGE.IN.APP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3%1\306E\30DA\30FC\30B8%0\3092\7DE8\96C6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104708032222309007)
,p_name=>'SL.GO.TO.APP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3%0\306B\79FB\52D5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104537835680308866)
,p_name=>'SL.MATCH.FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E00\81F4\304C1\3064\898B\3064\304B\308A\307E\3057\305F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104537953599308866)
,p_name=>'SL.N.MATCHES.FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E00\81F4\304C%0\898B\3064\304B\308A\307E\3057\305F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104555231599308883)
,p_name=>'SL.NO.MATCH.FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E00\81F4\3059\308B\3082\306E\304C\898B\3064\304B\308A\307E\305B\3093')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104711960595309010)
,p_name=>'SL.PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104229287927308631)
,p_name=>'SL.PLACEHOLDER'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104274556726308663)
,p_name=>'SL.SEARCH.ALLAPPS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306E\3059\3079\3066\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\691C\7D22')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104708343607309007)
,p_name=>'SL.SEARCH.APP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067%0\3092\691C\7D22')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104470077061308809)
,p_name=>'SL.SEARCH.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22\3059\308B\6587\5B57\30922\500B\4EE5\4E0A\5165\529B\3057\3066\304F\3060\3055\3044')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104708284155309007)
,p_name=>'SL.SEARCH.PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\3067%0\3092\691C\7D22')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104708414221309007)
,p_name=>'SL.SEARCH.TEAM.DEV'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30FC\30E0\958B\767A\3067%0\3092\691C\7D22')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104708586664309007)
,p_name=>'SL.SEARCH.USER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC%0\306E\691C\7D22')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104708657155309007)
,p_name=>'SL.SEARCH.WP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\3067%0\3092\691C\7D22')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104708186521309007)
,p_name=>'SL.SHARED.COMP.APP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3%0\306E\5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104001463444308436)
,p_name=>'SOFTWARE_DEFECT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BD\30D5\30C8\30A6\30A7\30A2\306E\4E0D\5177\5408')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104006472982308440)
,p_name=>'SOMEWHAT_DESIRABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C11\3057\671B\307E\3057\3044')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104333838247308707)
,p_name=>'SOURCE_IDENTIFIER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BD\30FC\30B9\8B58\5225\5B50')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104140591932308550)
,p_name=>'SPACE_UTILIZATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E2\5B58\306E\9818\57DF\4F7F\7528\7387')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103990098332308428)
,p_name=>'SQL NOT AVAILABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\306F\4F7F\7528\3067\304D\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104197817764308608)
,p_name=>'SQL WORKSHOP'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\30EF\30FC\30AF\30B7\30E7\30C3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104133596356308544)
,p_name=>'SQL_COMMANDS'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\30B3\30DE\30F3\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104028854219308458)
,p_name=>'SQL_COMMAND_HISTORY'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\30B3\30DE\30F3\30C9\306E\5C65\6B74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103806792619308252)
,p_name=>'SQL_EXPRESSION'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104067131299308489)
,p_name=>'SQL_INJECT_LINE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6298\308C\7DDA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104066851715308489)
,p_name=>'SQL_INJECT_PACKAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30C3\30B1\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104066984984308489)
,p_name=>'SQL_INJECT_PROCEDURE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30B7\30FC\30B8\30E3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104066736878308489)
,p_name=>'SQL_INJECT_SCHEMA'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AD\30FC\30DE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104067032286308489)
,p_name=>'SQL_INJECT_VAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\5909\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104352501209308721)
,p_name=>'SQL_NOT_ENABLED_APP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\306FSQL\3068PL/SQL\30A2\30AF\30BB\30B9\304C\7121\52B9\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104352658620308721)
,p_name=>'SQL_NOT_ENABLED_INST'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A4\30F3\30B9\30BF\30F3\30B9\3067\306FSQL\3068PL/SQL\30A2\30AF\30BB\30B9\304C\7121\52B9\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103752427856308209)
,p_name=>'SQL_QUERY'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103558491246308058)
,p_name=>'SQL_QUERY_REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\554F\5408\305B\304C\7121\52B9\3067\3059\3002SELECT\6587\304C\898B\3064\304B\308A\307E\305B\3093\3067\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103853948708308288)
,p_name=>'SQL_REPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103657332563308133)
,p_name=>'SQL_REPORT_WIZ.APPEND'
,p_message_language=>'ja'
,p_message_text=>unistr('\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103746108827308204)
,p_name=>'SQL_REPORT_WIZ.DEFAULT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103746634349308205)
,p_name=>'SQL_REPORT_WIZ.DISABLE_SORT_COL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BD\30FC\30C8\5217\306E\7121\52B9\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103745800502308204)
,p_name=>'SQL_REPORT_WIZ.DISPLAY_VALUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103746253745308204)
,p_name=>'SQL_REPORT_WIZ.PRIMARY_SORT_COL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30E9\30A4\30DE\30EA\30FB\30BD\30FC\30C8\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103657269609308133)
,p_name=>'SQL_REPORT_WIZ.REPLACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\7F6E\63DB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103745921893308204)
,p_name=>'SQL_REPORT_WIZ.RETURN_VALUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\623B\308A\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103746466781308205)
,p_name=>'SQL_REPORT_WIZ.SECONDARY_SORT_COL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30AB\30F3\30C0\30EA\30FB\30BD\30FC\30C8\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103746540999308205)
,p_name=>'SQL_REPORT_WIZ.SELECT_COL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\306E\9078\629E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104029072645308458)
,p_name=>'SQL_SCRIPTS'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\30B9\30AF\30EA\30D7\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104028983910308458)
,p_name=>'SQL_SCRIPT_RESULTS'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\30B9\30AF\30EA\30D7\30C8\306E\7D50\679C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104338662893308711)
,p_name=>'SQL_TAG_REF_NOT_DEFINED'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A31\5BB9\3055\308C\308B\8868\30EA\30B9\30C8\306B\6B21\306E\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30AA\30D6\30B8\30A7\30AF\30C8\3092\5B9A\7FA9\3059\308B\5FC5\8981\304C\3042\308A\307E\3059: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104029146314308458)
,p_name=>'SQL_WORKSHOP'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\30EF\30FC\30AF\30B7\30E7\30C3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103809088988308254)
,p_name=>'SQL_WS.OB.DUPLICATE_ALIAS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6307\5B9A\3057\305F\5225\540D\306F\5225\306E\30AA\30D6\30B8\30A7\30AF\30C8\3067\3059\3067\306B\4F7F\7528\3055\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103808904733308254)
,p_name=>'SQL_WS.OB.INVALID_ALIAS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6307\5B9A\3057\305F\30AA\30D6\30B8\30A7\30AF\30C8\5225\540D\304C\7121\52B9\3067\3059\3002\6709\52B9\306A\5225\540D\306B\4F7F\7528\3067\304D\308B\306E\306F\3001\6587\5B57\3001\6570\5B57\3001\30A2\30F3\30C0\30FC\30B9\30B3\30A2\304A\3088\3073\30C0\30C3\30B7\30E5\306E\307F\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104122683299308535)
,p_name=>'SQL_WS.OB.NOT_ORDS_ENABLED'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B9\30AD\30FC\30DE\306FORDS RESTful Data Services\306B\767B\9332\3055\308C\3066\3044\307E\305B\3093\3002\3053\306E\30B9\30AD\30FC\30DE\3092\767B\9332\3059\308B\306B\306F\3001<strong>\300CRESTful\30B5\30FC\30D3\30B9\300D\2192\300CORDS RESTful\30B5\30FC\30D3\30B9\300D</strong>\306B\79FB\52D5\3057\3001<strong>\300CORDS\306B\30B9\30AD\30FC\30DE\3092\767B\9332\300D</strong>\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104137687198308548)
,p_name=>'SQL_WS.OB.NO_REST_IN_CDB'
,p_message_language=>'ja'
,p_message_text=>unistr('APEX\306F\3001\73FE\5728CDB\3067\5B9F\884C\3055\308C\3066\3044\307E\3059\3002CDB\3067ORDS\30D9\30FC\30B9\306EREST\30B5\30FC\30D3\30B9\3092\5B9A\7FA9\3059\308B\3053\3068\306F\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104137425659308548)
,p_name=>'SQL_WS.OB.OLD_ORDS_VERSION'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\30A4\30F3\30B9\30C8\30FC\30EB\3055\308C\3066\3044\308BORDS\30D0\30FC\30B8\30E7\30F3(%0)\306F\3001\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30AA\30D6\30B8\30A7\30AF\30C8\3092REST\5BFE\5FDC\306B\3059\308B\305F\3081\306B\5FC5\8981\306A\3059\3079\3066\306E\6A5F\80FD\3092\30B5\30DD\30FC\30C8\3057\3066\3044\307E\305B\3093\3002%1\306E\6700\4F4E\30D0\30FC\30B8\30E7\30F3\3092\30A4\30F3\30B9\30C8\30FC\30EB\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104137295024308547)
,p_name=>'SQL_WS.OB.ORDS_NOT_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('ORDS RESTful\30B5\30FC\30D3\30B9\3092\6709\52B9\306B\3059\308B\305F\3081\306B\5FC5\8981\306AORDS_METADATA\30B9\30AD\30FC\30DE\304C\898B\3064\304B\308A\307E\305B\3093\3067\3057\305F\3002\30A4\30F3\30B9\30C8\30FC\30EB\624B\9806\306B\3064\3044\3066\306F\3001Oracle REST Data Services\306E\30A4\30F3\30B9\30C8\30EC\30FC\30B7\30E7\30F3\30FB\30AC\30A4\30C9\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104137501615308548)
,p_name=>'SQL_WS.OB.ORDS_VERION'
,p_message_language=>'ja'
,p_message_text=>unistr('ORDS\30D0\30FC\30B8\30E7\30F3<strong>%0</strong>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104137394114308547)
,p_name=>'SQL_WS.OB.PLSQL_GATEWAY'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B7\30B9\30C6\30E0\306F\73FE\5728\3001Oracle Embedded PL/SQL Gateway\3092\4F7F\7528\3057\3066\3044\307E\3059\3002\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30AA\30D6\30B8\30A7\30AF\30C8\3092REST\5BFE\5FDC\306B\3059\308B\306B\306F\3001\30D0\30FC\30B8\30E7\30F3%0\4EE5\4E0A\306EOracle REST Data Services\3092\30A4\30F3\30B9\30C8\30FC\30EB\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103527371437308035)
,p_name=>'STACKED2DCOLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\7A4D\4E0A\30522D\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103527488425308035)
,p_name=>'STACKED3DCOLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\7A4D\4E0A\30523D\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103527550921308035)
,p_name=>'STACKEDHORIZONTAL2DCOLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\7A4D\4E0A\3052\6C34\5E732D\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103527687805308035)
,p_name=>'STACKEDHORIZONTAL3DCOLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\7A4D\4E0A\3052\6C34\5E733D\5217')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104293784804308677)
,p_name=>'STANDARD _TABS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A19\6E96\30BF\30D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104295444368308679)
,p_name=>'STANDARD_TAB'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A19\6E96\30BF\30D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103733615236308194)
,p_name=>'STANDARD_TAB_SET'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A19\6E96\30BF\30D6\30FB\30BB\30C3\30C8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103619894356308102)
,p_name=>'STATIC APPLICATION FILES'
,p_message_language=>'ja'
,p_message_text=>unistr('\9759\7684\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30D5\30A1\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103619787958308102)
,p_name=>'STATIC WORKSPACE FILES'
,p_message_language=>'ja'
,p_message_text=>unistr('\9759\7684\30EF\30FC\30AF\30B9\30DA\30FC\30B9\30FB\30D5\30A1\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104790495679309081)
,p_name=>'STATICSEARCH.MINIMUM_LENGTH'
,p_message_language=>'ja'
,p_message_text=>unistr('2\6587\5B57\4EE5\4E0A\306E\30AD\30FC\30EF\30FC\30C9\3092\5C11\306A\304F\3068\30821\3064\5165\529B\3057\3066\304F\3060\3055\3044\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104790503114309081)
,p_name=>'STATICSEARCH.NO_RESULTS_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22\554F\5408\305B\306B\4E00\81F4\3059\308B\7D50\679C\304C\898B\3064\304B\308A\307E\305B\3093\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103806572821308252)
,p_name=>'STATIC_ASSIGNMENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\9759\7684\5272\5F53\3066')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104139026075308549)
,p_name=>'STATIC_FILES_NO_APPLICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\95A2\9023\4ED8\3051\3089\308C\305F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103550607498308052)
,p_name=>'STATIC_HTML'
,p_message_language=>'ja'
,p_message_text=>unistr('\9759\7684HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103534108879308040)
,p_name=>'STATIC_REFERENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\9759\7684\53C2\7167')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103997739139308434)
,p_name=>'STATIC_REGION'
,p_message_language=>'ja'
,p_message_text=>unistr('\9759\7684\30EA\30FC\30B8\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104062340352308485)
,p_name=>'STATIC_SUBSTITUTION_STRINGS'
,p_message_language=>'ja'
,p_message_text=>unistr('\9759\7684\7F6E\63DB\6587\5B57\5217')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104753170076309045)
,p_name=>'STATUS_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30C6\30FC\30BF\30B9: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103933517400308385)
,p_name=>'STATUS_MODIFIED'
,p_message_language=>'ja'
,p_message_text=>unistr('\5909\66F4\3055\308C\305F\30B9\30C6\30FC\30BF\30B9')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104048972480308474)
,p_name=>'STD TAB CONDITION'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A19\6E96\30BF\30D6\6761\4EF6')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104742204876309036)
,p_name=>'STEAL_LOCK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30C3\30AF\306E\30B9\30C6\30A3\30FC\30EB')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103593986093308083)
,p_name=>'STORAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A18\61B6\57DF:')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103752544328308209)
,p_name=>'STRUCTURED_QUERY'
,p_message_language=>'ja'
,p_message_text=>unistr('\69CB\9020\5316\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103853713227308288)
,p_name=>'STRUCTURED_REPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\69CB\9020\5316\30EC\30DD\30FC\30C8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104139928665308550)
,p_name=>'SUBMIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\9001\4FE1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103933492025308385)
,p_name=>'SUBMITTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\9001\4FE1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103849257445308285)
,p_name=>'SUBMIT_AS'
,p_message_language=>'ja'
,p_message_text=>unistr('\9001\4FE1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104059145547308483)
,p_name=>'SUBMIT_FEEDBACK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30FC\30C9\30D0\30C3\30AF\306E\9001\4FE1')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103991239361308429)
,p_name=>'SUBORDINATE CURRENT ENTRY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30EC\30F3\30C8\306E\5F93\5C5E\30A8\30F3\30C8\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103991323268308429)
,p_name=>'SUBORDINATE NON CURRENT ENTRY'
,p_message_language=>'ja'
,p_message_text=>unistr('\975E\30AB\30EC\30F3\30C8\306E\5F93\5C5E\30A8\30F3\30C8\30EA')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104768039746309064)
,p_name=>'SUBSCRIBED_FROM.NONEXISTING_MASTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B58\5728\3057\306A\3044\30DE\30B9\30BF\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104768229965309064)
,p_name=>'SUBSCRIBED_FROM.THEME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104768140388309064)
,p_name=>'SUBSCRIBED_FROM.THEME_REPOSITORY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\30FB\30EA\30DD\30B8\30C8\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103735772922308196)
,p_name=>'SUBSCRIBE_AUTHORIZATION.COPIED_FROM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30D4\30FC\5143\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103736055052308196)
,p_name=>'SUBSCRIBE_AUTHORIZATION.MASTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\308C\304C\3053\306E\8A8D\53EF\30B9\30AD\30FC\30E0\306E\300C\30DE\30B9\30BF\30FC\300D\30B3\30D4\30FC\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103736244299308196)
,p_name=>'SUBSCRIBE_AUTHORIZATION.NO_SUBSCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\8A8D\53EF\30B9\30AD\30FC\30E0\3092\30B5\30D6\30B9\30AF\30E9\30A4\30D6\3059\308B\8A8D\53EF\30B9\30AD\30FC\30E0\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103736136228308196)
,p_name=>'SUBSCRIBE_AUTHORIZATION.REFERENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\8A8D\53EF\30B9\30AD\30FC\30E0\3092\30B5\30D6\30B9\30AF\30E9\30A4\30D6\3059\308B\8A8D\53EF\30B9\30AD\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103538187941308043)
,p_name=>'SUBSCRIBE_DATA_LOAD.COPIED_FROM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30D4\30FC\5143\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103538427074308043)
,p_name=>'SUBSCRIBE_DATA_LOAD.MASTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\308C\304C\3053\306E\30C7\30FC\30BF\30FB\30ED\30FC\30C9\5B9A\7FA9\306E\30DE\30B9\30BF\30FC\30FB\30B3\30D4\30FC\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103538342345308043)
,p_name=>'SUBSCRIBE_DATA_LOAD.NO_SUBSCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\5B9A\7FA9\306B\30B5\30D6\30B9\30AF\30E9\30A4\30D6\3057\3066\3044\308B\30C7\30FC\30BF\30FB\30ED\30FC\30C9\5B9A\7FA9\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103538203756308043)
,p_name=>'SUBSCRIBE_DATA_LOAD.REFERENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\5B9A\7FA9\306B\30B5\30D6\30B9\30AF\30E9\30A4\30D6\3057\3066\3044\308B\30C7\30FC\30BF\30FB\30ED\30FC\30C9\5B9A\7FA9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103735167444308196)
,p_name=>'SUBSCRIBE_ITEM_HELP.COPIED_FROM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30D4\30FC\5143\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103735229340308196)
,p_name=>'SUBSCRIBE_ITEM_HELP.MASTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\308C\304C\3053\306E\30A2\30A4\30C6\30E0\30FB\30D8\30EB\30D7\306E\300C\30DE\30B9\30BF\30FC\300D\30B3\30D4\30FC\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103735469347308196)
,p_name=>'SUBSCRIBE_ITEM_HELP.NO_SUBSCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30A4\30C6\30E0\30FB\30D8\30EB\30D7\30FB\30C6\30AD\30B9\30C8\3092\30B5\30D6\30B9\30AF\30E9\30A4\30D6\3059\308B\30A2\30A4\30C6\30E0\306F\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103735323890308196)
,p_name=>'SUBSCRIBE_ITEM_HELP.REFERENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30A4\30C6\30E0\30FB\30D8\30EB\30D7\30FB\30C6\30AD\30B9\30C8\3092\30B5\30D6\30B9\30AF\30E9\30A4\30D6\3059\308B\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103737775132308198)
,p_name=>'SUBSCRIBE_LOV.COPIED_FROM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30D4\30FC\5143\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103737896443308198)
,p_name=>'SUBSCRIBE_LOV.MASTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\308C\304C\3053\306ELOV\306E\30DE\30B9\30BF\30FC\30FB\30B3\30D4\30FC\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103738069064308198)
,p_name=>'SUBSCRIBE_LOV.NO_SUBSCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306ELOV\3092\30B5\30D6\30B9\30AF\30E9\30A4\30D6\3059\308BLOV\304C\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103737932452308198)
,p_name=>'SUBSCRIBE_LOV.REFERENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306ELOV\3092\30B5\30D6\30B9\30AF\30E9\30A4\30D6\3059\308BLOV')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103625802994308106)
,p_name=>'SUBSCRIBE_NAVBAR.COPIED_FROM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30D4\30FC\5143\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103739324348308199)
,p_name=>'SUBSCRIBE_NAVBAR.MASTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\308C\304C\3053\306E\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30D0\30FC\306E\300C\30DE\30B9\30BF\30FC\300D\30B3\30D4\30FC\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103739982110308199)
,p_name=>'SUBSCRIBE_NAVBAR.NO_SUBSCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30D0\30FC\3092\30B5\30D6\30B9\30AF\30E9\30A4\30D6\3059\308B\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30D0\30FC\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103739607550308199)
,p_name=>'SUBSCRIBE_NAVBAR.REFERENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30D0\30FC\3092\30B5\30D6\30B9\30AF\30E9\30A4\30D6\3059\308B\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30D0\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103625482730308106)
,p_name=>'SUBSCRIBE_PLUGIN.COPIED_FROM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30D4\30FC\5143\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103625545028308106)
,p_name=>'SUBSCRIBE_PLUGIN.MASTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\308C\304C\3053\306E\30D7\30E9\30B0\30A4\30F3\306E\300C\30DE\30B9\30BF\30FC\300D\30B3\30D4\30FC\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103625772792308106)
,p_name=>'SUBSCRIBE_PLUGIN.NO_SUBSCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30D7\30E9\30B0\30A4\30F3\3092\30B5\30D6\30B9\30AF\30E9\30A4\30D6\3059\308B\30D7\30E9\30B0\30A4\30F3\306F\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103625601869308106)
,p_name=>'SUBSCRIBE_PLUGIN.REFERENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30D7\30E9\30B0\30A4\30F3\306B\30B5\30D6\30B9\30AF\30E9\30A4\30D6\3057\3066\3044\308B\30D7\30E9\30B0\30A4\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103736523997308197)
,p_name=>'SUBSCRIBE_SHORTCUT.COPIED_FROM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30D4\30FC\5143\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103736739180308197)
,p_name=>'SUBSCRIBE_SHORTCUT.MASTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\308C\304C\3053\306E\30B7\30E7\30FC\30C8\30AB\30C3\30C8\306E\300C\30DE\30B9\30BF\30FC\300D\30B3\30D4\30FC\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103737085349308197)
,p_name=>'SUBSCRIBE_SHORTCUT.NO_SUBSCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B7\30E7\30FC\30C8\30AB\30C3\30C8\3092\30B5\30D6\30B9\30AF\30E9\30A4\30D6\3059\308B\30B7\30E7\30FC\30C8\30AB\30C3\30C8\306F\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103736998479308197)
,p_name=>'SUBSCRIBE_SHORTCUT.REFERENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B7\30E7\30FC\30C8\30AB\30C3\30C8\3092\30B5\30D6\30B9\30AF\30E9\30A4\30D6\3059\308B\30B7\30E7\30FC\30C8\30AB\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103731347707308192)
,p_name=>'SUBSCRIBE_TEMPLATE.COPIED_FROM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30D4\30FC\5143\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103731569669308193)
,p_name=>'SUBSCRIBE_TEMPLATE.MASTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\308C\304C\3053\306E\30C6\30F3\30D7\30EC\30FC\30C8\306E\300C\30DE\30B9\30BF\30FC\300D\30B3\30D4\30FC\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103731641900308193)
,p_name=>'SUBSCRIBE_TEMPLATE.NO_SUBSCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30C6\30F3\30D7\30EC\30FC\30C8\3092\30B5\30D6\30B9\30AF\30E9\30A4\30D6\3059\308B\30C6\30F3\30D7\30EC\30FC\30C8\306F\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103731405235308192)
,p_name=>'SUBSCRIBE_TEMPLATE.POPUP_LOV'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DD\30C3\30D7\30A2\30C3\30D7LOV\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103742457096308201)
,p_name=>'SUBSCRIBE_TEMPLATE.REFERENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30C6\30F3\30D7\30EC\30FC\30C8\3092\30B5\30D6\30B9\30AF\30E9\30A4\30D6\3059\308B\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104706830894309006)
,p_name=>'SUBSCRIBE_THEME.COPIED_FROM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30C6\30FC\30DE\306B\30B5\30D6\30B9\30AF\30E9\30A4\30D6\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104749423029309042)
,p_name=>'SUBSCRIBE_THEME.COPIED_FROM_THEME'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A19\6E96\30C6\30FC\30DE\306B\30B5\30D6\30B9\30AF\30E9\30A4\30D6\3055\308C\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104707278940309006)
,p_name=>'SUBSCRIBE_THEME.MASTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\308C\304C\3053\306E\30C6\30FC\30DE\306E\300C\30DE\30B9\30BF\30FC\300D\30B3\30D4\30FC\3067\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104707131930309006)
,p_name=>'SUBSCRIBE_THEME.NO_SUBSCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30C6\30FC\30DE\3092\30B5\30D6\30B9\30AF\30E9\30A4\30D6\3059\308B\30C6\30FC\30DE\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104706945466309006)
,p_name=>'SUBSCRIBE_THEME.POPUP_LOV'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DD\30C3\30D7\30A2\30C3\30D7LOV\30C6\30FC\30DE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104707021191309006)
,p_name=>'SUBSCRIBE_THEME.REFERENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30C6\30FC\30DE\306B\30B5\30D6\30B9\30AF\30E9\30A4\30D6\3057\3066\3044\308B\30C6\30FC\30DE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104114795708308529)
,p_name=>'SUBSCRIBE_WEB_SRC.COPIED_FROM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30D4\30FC\5143\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104114897846308529)
,p_name=>'SUBSCRIBE_WEB_SRC.MASTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\308C\304C\3053\306EREST\30C7\30FC\30BF\30FB\30BD\30FC\30B9\306E\30DE\30B9\30BF\30FC\30FB\30B3\30D4\30FC\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104115099590308529)
,p_name=>'SUBSCRIBE_WEB_SRC.NO_SUBSCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30BD\30FC\30B9\306B\30B5\30D6\30B9\30AF\30E9\30A4\30D6\3057\3066\3044\308BREST\30C7\30FC\30BF\30FB\30BD\30FC\30B9\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104114968822308529)
,p_name=>'SUBSCRIBE_WEB_SRC.REFERENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30BD\30FC\30B9\306B\30B5\30D6\30B9\30AF\30E9\30A4\30D6\3057\3066\3044\308BREST\30C7\30FC\30BF\30FB\30BD\30FC\30B9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103741496852308201)
,p_name=>'SUBSCRIPTION_BUTTON_TEMPL.COPIED_FROM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30D4\30FC\5143\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103742264077308201)
,p_name=>'SUBSCRIPTION_BUTTON_TEMPL.MASTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\308C\304C\3053\306E\30DC\30BF\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306E\300C\30DE\30B9\30BF\30FC\300D\30B3\30D4\30FC\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103742656470308202)
,p_name=>'SUBSCRIPTION_BUTTON_TEMPL.NO_SUBSCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DC\30BF\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\30B5\30D6\30B9\30AF\30E9\30A4\30D6\3059\308B\30C6\30F3\30D7\30EC\30FC\30C8\306F\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103742580816308201)
,p_name=>'SUBSCRIPTION_BUTTON_TEMPL.REFERENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DC\30BF\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\30B5\30D6\30B9\30AF\30E9\30A4\30D6\3059\308B\30DC\30BF\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103569477244308066)
,p_name=>'SUBSTITUTION_STRING_USAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\7F6E\63DB\6587\5B57\5217\306E\4F7F\7528\72B6\6CC1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103970156013308413)
,p_name=>'SUCCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6210\529F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104046607892308472)
,p_name=>'SUCCESS MESSAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6210\529F\30E1\30C3\30BB\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103932568321308384)
,p_name=>'SUCCESSES'
,p_message_language=>'ja'
,p_message_text=>unistr('\6210\529F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103799261923308246)
,p_name=>'SUCCESS_MSG.CLUSTER_TRUNCATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30E9\30B9\30BF\304C\5207\308A\6368\3066\3089\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103795581317308244)
,p_name=>'SUCCESS_MSG.CMD_EXECUTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30DE\30F3\30C9\304C\5B9F\884C\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103798373694308246)
,p_name=>'SUCCESS_MSG.CONTEXT_DROPPED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30C6\30AD\30B9\30C8\304C\524A\9664\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103798595397308246)
,p_name=>'SUCCESS_MSG.DATABASE_LINK_CREATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30EA\30F3\30AF\304C\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103798450485308246)
,p_name=>'SUCCESS_MSG.DATABASE_LINK_DROPPED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30EA\30F3\30AF\304C\524A\9664\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103799404550308247)
,p_name=>'SUCCESS_MSG.FUNCTION_ALTERED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30F3\30AF\30B7\30E7\30F3\304C\5909\66F4\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103794413388308243)
,p_name=>'SUCCESS_MSG.FUNCTION_CREATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30F3\30AF\30B7\30E7\30F3\304C\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103797386100308245)
,p_name=>'SUCCESS_MSG.FUNCTION_DROPPED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30F3\30AF\30B7\30E7\30F3\304C\524A\9664\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103799060030308246)
,p_name=>'SUCCESS_MSG.INDEXTYPE_ALTERED'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D22\5F15\30BF\30A4\30D7\304C\5909\66F4\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103798235910308246)
,p_name=>'SUCCESS_MSG.INDEXTYPE_DROPPED'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D22\5F15\30BF\30A4\30D7\304C\524A\9664\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103794833700308243)
,p_name=>'SUCCESS_MSG.INDEX_CREATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D22\5F15\304C\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103797663164308245)
,p_name=>'SUCCESS_MSG.INDEX_DROPPED'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D22\5F15\304C\524A\9664\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103795150570308243)
,p_name=>'SUCCESS_MSG.MATERIALIZED_VIEW_CREATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30C6\30EA\30A2\30E9\30A4\30BA\30C9\30FB\30D3\30E5\30FC\304C\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103797739113308245)
,p_name=>'SUCCESS_MSG.MATERIALIZED_VIEW_DROPPED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30C6\30EA\30A2\30E9\30A4\30BA\30C9\30FB\30D3\30E5\30FC\304C\524A\9664\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103799363481308247)
,p_name=>'SUCCESS_MSG.PACKAGE_ALTERED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30C3\30B1\30FC\30B8\304C\5909\66F4\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103794630635308243)
,p_name=>'SUCCESS_MSG.PKG_BODY_CREATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30C3\30B1\30FC\30B8\672C\4F53\304C\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103794716720308243)
,p_name=>'SUCCESS_MSG.PKG_CREATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30C3\30B1\30FC\30B8\304C\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103796634536308244)
,p_name=>'SUCCESS_MSG.PKG_DROPPED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30C3\30B1\30FC\30B8\304C\524A\9664\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103799586048308247)
,p_name=>'SUCCESS_MSG.PROCEDURE_ALTERED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30B7\30FC\30B8\30E3\304C\5909\66F4\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103794598148308243)
,p_name=>'SUCCESS_MSG.PROCEDURE_CREATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30B7\30FC\30B8\30E3\540D\304C\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103797454685308245)
,p_name=>'SUCCESS_MSG.PROCEDURE_DROPPED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30B7\30FC\30B8\30E3\304C\524A\9664\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103795274329308243)
,p_name=>'SUCCESS_MSG.ROLE_CREATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30FC\30EB\304C\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103797881805308245)
,p_name=>'SUCCESS_MSG.ROLE_DROPPED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30FC\30EB\304C\524A\9664\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103796036741308244)
,p_name=>'SUCCESS_MSG.ROWS_DELETED'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\884C\304C\524A\9664\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103795880208308244)
,p_name=>'SUCCESS_MSG.ROWS_INSERTED'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\884C\304C\633F\5165\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103795748013308244)
,p_name=>'SUCCESS_MSG.ROWS_UPDATED'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\884C\304C\66F4\65B0\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103799693269308247)
,p_name=>'SUCCESS_MSG.SEQ_ALTERED'
,p_message_language=>'ja'
,p_message_text=>unistr('\9806\5E8F\304C\5909\66F4\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103795303153308243)
,p_name=>'SUCCESS_MSG.SEQ_CREATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\9806\5E8F\304C\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103797021368308245)
,p_name=>'SUCCESS_MSG.SEQ_DROPPED'
,p_message_language=>'ja'
,p_message_text=>unistr('\9806\5E8F\304C\524A\9664\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103521061060308031)
,p_name=>'SUCCESS_MSG.SINGLE_ROW_CREATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\304C\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103520931578308031)
,p_name=>'SUCCESS_MSG.SINGLE_ROW_DELETED'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\304C\524A\9664\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103520866034308030)
,p_name=>'SUCCESS_MSG.SINGLE_ROW_UPDATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\304C\66F4\65B0\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103555863493308056)
,p_name=>'SUCCESS_MSG.STMT_PROCESSED'
,p_message_language=>'ja'
,p_message_text=>unistr('\6587\304C\51E6\7406\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103795434813308243)
,p_name=>'SUCCESS_MSG.SYNONYM_CREATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30CE\30CB\30E0\304C\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103797984555308245)
,p_name=>'SUCCESS_MSG.SYNONYM_DROPPED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30CE\30CB\30E0\304C\524A\9664\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103797198728308245)
,p_name=>'SUCCESS_MSG.TABLE_ALTERED'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\304C\5909\66F4\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103794042945308242)
,p_name=>'SUCCESS_MSG.TABLE_CREATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\304C\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103796529603308244)
,p_name=>'SUCCESS_MSG.TABLE_DROPPED'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\304C\524A\9664\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103798658447308246)
,p_name=>'SUCCESS_MSG.TABLE_RENAMED'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\540D\304C\5909\66F4\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103799118676308246)
,p_name=>'SUCCESS_MSG.TABLE_TRUNCATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\304C\5207\308A\6368\3066\3089\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103798986847308246)
,p_name=>'SUCCESS_MSG.TRIGGER_ALTERED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C8\30EA\30AC\30FC\304C\5909\66F4\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103794308004308243)
,p_name=>'SUCCESS_MSG.TRIGGER_CREATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C8\30EA\30AC\30FC\304C\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103798034420308246)
,p_name=>'SUCCESS_MSG.TRIGGER_DROPPED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C8\30EA\30AC\30FC\304C\524A\9664\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103798852416308246)
,p_name=>'SUCCESS_MSG.TYPE_ALTERED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7\304C\5909\66F4\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103794978378308243)
,p_name=>'SUCCESS_MSG.TYPE_CREATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7\304C\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103798156104308246)
,p_name=>'SUCCESS_MSG.TYPE_DROPPED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7\304C\524A\9664\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103799727722308247)
,p_name=>'SUCCESS_MSG.USER_ALTERED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\304C\5909\66F4\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103795051074308243)
,p_name=>'SUCCESS_MSG.USER_CREATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\304C\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103796733757308244)
,p_name=>'SUCCESS_MSG.USER_DROPPED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\304C\524A\9664\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103798713829308246)
,p_name=>'SUCCESS_MSG.VIEW_ALTERED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D3\30E5\30FC\304C\5909\66F4\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103794104341308242)
,p_name=>'SUCCESS_MSG.VIEW_CREATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D3\30E5\30FC\304C\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103796851580308245)
,p_name=>'SUCCESS_MSG.VIEW_DROPPED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D3\30E5\30FC\304C\524A\9664\3055\308C\307E\3057\305F\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104138662322308549)
,p_name=>'SUPPORTING_OBJECTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30DD\30FC\30C8\3059\308B\30AA\30D6\30B8\30A7\30AF\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104675337705308979)
,p_name=>'SUPPORTING_OBJECTS.OBJECT_DEF_CHANGED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30D6\30B8\30A7\30AF\30C8\5B9A\7FA9\304C\5909\66F4\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104675439234308979)
,p_name=>'SUPPORTING_OBJECTS.OBJECT_DELETED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30D6\30B8\30A7\30AF\30C8\306F\5B58\5728\3057\306A\304F\306A\308A\307E\3057\305F\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103999288962308435)
,p_name=>'SVG CHART'
,p_message_language=>'ja'
,p_message_text=>unistr('SVG\30C1\30E3\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104088718987308507)
,p_name=>'SVG PLUGIN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\3092\8868\793A\3059\308B\306B\306F\3001SVG Viewer\3092\30A4\30F3\30B9\30C8\30FC\30EB\3057\3066\304F\3060\3055\3044\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103519366757308029)
,p_name=>'SW_EMPTY_SCRIPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7A7A\306ESQL\30B9\30AF\30EA\30D7\30C8\306F\7DE8\96C6\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103519491890308029)
,p_name=>'SW_GREATER_THAN_30K'
,p_message_language=>'ja'
,p_message_text=>unistr('30,000\30D0\30A4\30C8\3092\8D85\3048\308B\30B9\30AF\30EA\30D7\30C8\306F\7DE8\96C6\3067\304D\307E\305B\3093\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103751771905308209)
,p_name=>'SYNONYM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30CE\30CB\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104353029859308721)
,p_name=>'SYNONYM_IN_PAREN'
,p_message_language=>'ja'
,p_message_text=>unistr('(\30B7\30CE\30CB\30E0)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104131901492308543)
,p_name=>'SYNONYM_NOUN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30CE\30CB\30E0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104263159499308655)
,p_name=>'SYSTEM_MESSAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30B9\30C6\30E0\30FB\30E1\30C3\30BB\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103933624404308385)
,p_name=>'SYSTEM_STATUS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30B9\30C6\30E0\30FB\30B9\30C6\30FC\30BF\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103933765268308385)
,p_name=>'SYSTEM_STATUS_MODIFIED'
,p_message_language=>'ja'
,p_message_text=>unistr('\5909\66F4\3055\308C\305F\30B7\30B9\30C6\30E0\30FB\30B9\30C6\30FC\30BF\30B9')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103751807265308209)
,p_name=>'TABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103999874457308435)
,p_name=>'TABLE NOT FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\3001\6709\52B9\306A\8868\540D\307E\305F\306F\30D3\30E5\30FC\540D\3067\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104029688311308458)
,p_name=>'TABLESPACES'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\9818\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103750828415308208)
,p_name=>'TABLE_IN_PAREN'
,p_message_language=>'ja'
,p_message_text=>unistr('(\8868)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104046050378308472)
,p_name=>'TABLE_NAME_TOO_LONG'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\540D%0\306E\30B5\30A4\30BA\304C\8A31\5BB9\5024\3092\8D85\3048\3066\3044\307E\3059\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104058981561308482)
,p_name=>'TABULAR_FORM'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\5F62\5F0F\30D5\30A9\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104065456802308488)
,p_name=>'TABULAR_FORM_SUCCESS_MSG'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\5F62\5F0F\30D5\30A9\30FC\30E0\304C\6B63\5E38\306B\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103746785767308205)
,p_name=>'TAB_MANAGER.WARNING'
,p_message_language=>'ja'
,p_message_text=>unistr('\8B66\544A: \89AA\30BF\30D6\306E\30BF\30FC\30B2\30C3\30C8\300C%0\300D\304C\3001\5B58\5728\3057\306A\3044\30DA\30FC\30B8\3092\53C2\7167\3059\308B\305F\3081\306B\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103738497848308198)
,p_name=>'TAB_SEQUENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30D6\306E\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103737317195308197)
,p_name=>'TAB_SET'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30D6\30FB\30BB\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104293612162308677)
,p_name=>'TAB_SETS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30D6\30FB\30BB\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103737539175308198)
,p_name=>'TAB_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30D6\30FB\30C6\30AD\30B9\30C8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104754324150309046)
,p_name=>'TAG_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30B0: %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103578862103308072)
,p_name=>'TARGETED_FEATURES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30FC\30B2\30C3\30C8\6A5F\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104792421777309082)
,p_name=>'TARGET_PAGE_ID_OR_CUSTOM_URL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30FC\30B2\30C3\30C8\30FB\30DA\30FC\30B8ID\307E\305F\306F\30AB\30B9\30BF\30E0URL')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104002549024308437)
,p_name=>'TASK_COMPLETE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30B9\30AF\5B8C\4E86')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104026717251308456)
,p_name=>'TEAM_DEVELOPMENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30FC\30E0\958B\767A')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103732338961308193)
,p_name=>'TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104781523316309074)
,p_name=>'TEMPLATE.ACTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103986255835308425)
,p_name=>'TEMPLATE.AFTER_HEADER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D8\30C3\30C0\30FC\306E\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103986326273308425)
,p_name=>'TEMPLATE.BEFORE_FOOTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30C3\30BF\30FC\306E\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104781255340309074)
,p_name=>'TEMPLATE.COPY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8\306E\30B3\30D4\30FC: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104781484603309074)
,p_name=>'TEMPLATE.NEW_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F\30C6\30F3\30D7\30EC\30FC\30C8: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103514921745308026)
,p_name=>'TEMPLATE.PAGE_TMP_BDY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\30FB\30DC\30C7\30A3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103985986418308425)
,p_name=>'TEMPLATE.PAGE_TMP_BDY1'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\30FB\30DC\30C7\30A3(1)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103986074365308425)
,p_name=>'TEMPLATE.PAGE_TMP_BDY2'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\30FB\30DC\30C7\30A3(2)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103986156443308425)
,p_name=>'TEMPLATE.PAGE_TMP_BDY3'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\30FB\30DC\30C7\30A3(3)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104781373059309074)
,p_name=>'TEMPLATE.PREVIEW'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8\306E\30D7\30EC\30D3\30E5\30FC: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103985190342308424)
,p_name=>'TEMPLATE.T_REGION_POS09'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\4F4D\7F6E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103985264281308424)
,p_name=>'TEMPLATE.T_REGION_POS10'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\4F4D\7F6E10')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103985340806308424)
,p_name=>'TEMPLATE.T_REGION_POS11'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\4F4D\7F6E11')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103985430954308424)
,p_name=>'TEMPLATE.T_REGION_POS12'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\4F4D\7F6E12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103985534198308424)
,p_name=>'TEMPLATE.T_REGION_POS13'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\4F4D\7F6E13')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103985646808308424)
,p_name=>'TEMPLATE.T_REGION_POS14'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\4F4D\7F6E14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103985784189308424)
,p_name=>'TEMPLATE.T_REGION_POS15'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\4F4D\7F6E15')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103985806761308425)
,p_name=>'TEMPLATE.T_REGION_POS16'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\4F4D\7F6E16')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104488873676308830)
,p_name=>'TEMPLATES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104119118636308532)
,p_name=>'TEMPLATE_APPLICATIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103548998161308051)
,p_name=>'TEMPLATE_APP_INSTALL_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\57FA\3065\3044\305F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\4F5C\6210\6642\306E\30A8\30E9\30FC\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104186118088308598)
,p_name=>'TEMPLATE_DRIVEN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8\306B\3088\308B\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104117240074308531)
,p_name=>'TEMPLATE_OPTIONS.ADVANCED'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A73\7D30')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104117102915308531)
,p_name=>'TEMPLATE_OPTIONS.COMMON'
,p_message_language=>'ja'
,p_message_text=>unistr('\5171\901A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104561116914308887)
,p_name=>'TEMPLATE_OPTIONS.DEFAULT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104117047493308530)
,p_name=>'TEMPLATE_OPTIONS.GENERAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E00\822C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104678211680308982)
,p_name=>'TEMPLATE_OPTIONS.NO_OPTIONS_DEFINED'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E00\81F4\3059\308B\30C6\30F3\30D7\30EC\30FC\30C8\30FB\30AA\30D7\30B7\30E7\30F3\306F\5B9A\7FA9\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104685968939308988)
,p_name=>'TEMPLATE_OPTIONS.NO_OPTION_SELECTED'
,p_message_language=>'ja'
,p_message_text=>unistr('- \30AA\30D7\30B7\30E7\30F3\304C\9078\629E\3055\308C\3066\3044\307E\305B\3093 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104662473629308969)
,p_name=>'TEMPLATE_OPTIONS.USE_TEMPLATE_DEFAULTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8\30FB\30C7\30D5\30A9\30EB\30C8\306E\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104768874143309065)
,p_name=>'TEMPLATE_OPTIONS_MISMATCH'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8\30FB\30AA\30D7\30B7\30E7\30F3\306E\4E0D\4E00\81F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104789995943309081)
,p_name=>'TEMPLATE_SUBSCRIPTION.THEME_AND_TEMPLATE_SUBSCRIBED'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30C6\30F3\30D7\30EC\30FC\30C8\306F\3001\30DE\30B9\30BF\30FC\30FB\30C6\30FC\30DE\306E\5BFE\5FDC\3059\308B\30C6\30F3\30D7\30EC\30FC\30C8\306B\30B5\30D6\30B9\30AF\30E9\30A4\30D6\3055\308C\307E\3059\3002\3053\306E\30C6\30F3\30D7\30EC\30FC\30C8\3092\5909\66F4\3059\308B\306B\306F\3001\30DE\30B9\30BF\30FC\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\7DE8\96C6\3057\3066\3001\30C6\30FC\30DE\3092\30EA\30D5\30EC\30C3\30B7\30E5\3057\3066\304F\3060\3055\3044\3002\307E\305F\306F\3001\3053\306E\30C6\30F3\30D7\30EC\30FC\30C8\306E\30ED\30FC\30AB\30EB\306E\30B5\30D6\30B9\30AF\30E9\30A4\30D6\89E3\9664\3057\305F\30B3\30D4\30FC\3092\4F5C\6210\3067\304D\307E\3059\3002\30B5\30D6\30B9\30AF\30E9\30A4\30D6\89E3\9664\3057\305F\30C6\30F3\30D7\30EC\30FC\30C8\306F\7DE8\96C6\53EF\80FD\3067\3001\30C6\30FC\30DE\306E\30EA\30D5\30EC\30C3\30B7\30E5\3067\4E0A\66F8\304D\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104789819169309080)
,p_name=>'TEMPLATE_SUBSCRIPTION.THEME_SUBSCRIBED'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\3053\306E\30C6\30F3\30D7\30EC\30FC\30C8\306F\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\30ED\30FC\30AB\30EB\3067\3042\308A\3001\30B5\30D6\30B9\30AF\30E9\30A4\30D6\89E3\9664\3055\308C\3066\3044\307E\3059\3002'),
unistr('\95A2\9023\4ED8\3051\3089\308C\305F\30C6\30FC\30DE\304C\30B5\30D6\30B9\30AF\30E9\30A4\30D6\3055\308C\3066\3044\308B\5834\5408\3001\500B\5225\30C6\30F3\30D7\30EC\30FC\30C8\3092\30B5\30D6\30B9\30AF\30E9\30A4\30D6\3059\308B\3053\3068\306F\3067\304D\307E\305B\3093\3002'),
unistr('\30ED\30FC\30AB\30EB\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\5B9A\7FA9\3059\308B\304B\308F\308A\306B\3001\65B0\3057\3044\30C6\30F3\30D7\30EC\30FC\30C8\3092\30DE\30B9\30BF\30FC\30FB\30C6\30FC\30DE\306B\8FFD\52A0\3057\3066\3001\305D\308C\3092\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\7C21\5358\306B\30D7\30C3\30B7\30E5\307E\305F\306F\30D7\30EB\3067\304D\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103743563277308202)
,p_name=>'TEMPLATE_UTILIZATION.DEFAULT_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30C7\30D5\30A9\30EB\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3068\3057\3066\53C2\7167\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103743731774308202)
,p_name=>'TEMPLATE_UTILIZATION.ERROR_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3068\3057\3066\53C2\7167\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103743928804308203)
,p_name=>'TEMPLATE_UTILIZATION.NOT_REFERENCED'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306F\53C2\7167\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103744056893308203)
,p_name=>'TEMPLATE_UTILIZATION.PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306F\6B21\306E\3068\304A\308A\3067\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103743879542308203)
,p_name=>'TEMPLATE_UTILIZATION.PAGE_REFERENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\5185\3067\53C2\7167')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103743676537308202)
,p_name=>'TEMPLATE_UTILIZATION.PRINTER_FRIENDLY_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5370\5237\7528\30C6\30F3\30D7\30EC\30FC\30C8\3068\3057\3066\53C2\7167\3055\308C\307E\3057\305F\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103938169764308388)
,p_name=>'TEMPORARY_TABLESPACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E00\6642\8868\9818\57DF')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103799803664308247)
,p_name=>'TEST'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104024697030308454)
,p_name=>'TESTING_ASSIGNEE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30B9\30C8\5272\5F53\3066\5148')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104022887192308453)
,p_name=>'TESTING_IMPACT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30B9\30C8\306E\5F71\97FF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104025064218308455)
,p_name=>'TESTING_STATUS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30B9\30C8\306E\30B9\30C6\30FC\30BF\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104091327146308509)
,p_name=>'TEST_QUERY'
,p_message_language=>'ja'
,p_message_text=>unistr('\554F\5408\305B\306E\30C6\30B9\30C8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104294862092308678)
,p_name=>'TEXT FILES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8\30FB\30D5\30A1\30A4\30EB')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103693028854308161)
,p_name=>'THEME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103619609759308102)
,p_name=>'THEME FILES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\30FB\30D5\30A1\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104294412719308678)
,p_name=>'THEME IMAGES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\30FB\30A4\30E1\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104755587261309047)
,p_name=>'THEME.COMPATIBLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E92\63DB\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104546808237308872)
,p_name=>'THEME.SELECTOR.APP.GROUP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103687405058308156)
,p_name=>'THEMES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104790065290309081)
,p_name=>'THEME_IS_SUBSCRIBED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\30FB\30EC\30D9\30EB\3067\5225\306E\30C6\30FC\30DE\306B\30B5\30D6\30B9\30AF\30E9\30A4\30D6\3055\308C\3066\3044\308B\30C6\30FC\30DE\306E\4E00\90E8\3067\3042\308B\500B\5225\30C6\30F3\30D7\30EC\30FC\30C8\3092\30B5\30D6\30B9\30AF\30E9\30A4\30D6\89E3\9664\3059\308B\3053\3068\306F\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104790376464309081)
,p_name=>'THEME_SWITCH.CANNOT_CONVERT_TO_TABS'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306F\3001\30EA\30B9\30C8\30D9\30FC\30B9\306E\30CA\30D3\30B2\30FC\30B7\30E7\30F3\3092\4F7F\7528\3057\3066\3044\308B\305F\3081\3001\30BF\30D6\30D9\30FC\30B9\306E\30CA\30D3\30B2\30FC\30B7\30E7\30F3\3092\4F7F\7528\3059\308B\30C6\30FC\30DE\306B\306F\5909\63DB\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104790239499309081)
,p_name=>'THEME_SWITCH.CANNOT_CONVERT_TWO_LEVEL_TABS'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306F\30012\30EC\30D9\30EB\306E\30BF\30D6\3092\4F7F\7528\3057\3066\3044\308B\305F\3081\3001\30EA\30B9\30C8\30D9\30FC\30B9\306E\30BF\30D6\3092\4F7F\7528\3059\308B\30C6\30FC\30DE\306B\306F\5909\63DB\3067\304D\307E\305B\3093\3002\30C6\30FC\30DE\3092\5207\308A\66FF\3048\308B\524D\306B\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\66F4\65B0\3057\3066\30011\30EC\30D9\30EB\306E\30BF\30D6\306E\307F\3092\4F7F\7528\3059\308B\3088\3046\306B\73FE\5728\306E\30BF\30D6\8A2D\5B9A\3092\8A2D\5B9A\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104006602423308440)
,p_name=>'THEME_SWITCH.CANNOT_SWITCH_DESKTOP_TO_MOBILE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30B9\30AF\30C8\30C3\30D7\30FB\30C6\30FC\30DE\3092\30E2\30D0\30A4\30EB\30FB\30C6\30FC\30DE\306B\5207\308A\66FF\3048\3089\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103913073820308337)
,p_name=>'THEME_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\30FB\30BF\30A4\30D7')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104753798404309045)
,p_name=>'TITLE_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30C8\30EB: %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104001971533308437)
,p_name=>'TO DO'
,p_message_language=>'ja'
,p_message_text=>'To Do'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104048728445308474)
,p_name=>'TODO'
,p_message_language=>'ja'
,p_message_text=>'To Do'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104028463938308457)
,p_name=>'TODOS'
,p_message_language=>'ja'
,p_message_text=>'To Do'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103578003724308072)
,p_name=>'TODO_COMPLETE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B8C\4E86\3057\305FTo Do (%0 / %1):')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104333481419308707)
,p_name=>'TODO_DASH_1'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\4EF6\306E\30A8\30F3\30C8\30EA\3001%1\4EF6\304C\30AA\30FC\30D7\30F3\3001%2\4EF6\304C\5B8C\4E86\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104333596419308707)
,p_name=>'TODO_DASH_2'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\4EF6\306E\30A8\30F3\30C8\30EA\306F\4E00\90E8\304C\5B8C\4E86')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104333604667308707)
,p_name=>'TODO_DASH_3'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\4EF6\306E\30A8\30F3\30C8\30EA\306F\4E00\90E8\304C\5B8C\4E86')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104027202336308456)
,p_name=>'TOP_TABLES_BY_ROW_COUNT'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\6570\5225%0\4E0A\4F4D\8868\3001\30B9\30AD\30FC\30DE\306B\3088\308B\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104051864268308477)
,p_name=>'TOTAL_CLOSED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30ED\30FC\30BA\306E\5408\8A08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104049383788308475)
,p_name=>'TOTAL_MILESTONES'
,p_message_language=>'ja'
,p_message_text=>unistr('\5408\8A08\30DE\30A4\30EB\30B9\30C8\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104051757296308476)
,p_name=>'TOTAL_OPENED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30FC\30D7\30F3\306E\5408\8A08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104027312984308457)
,p_name=>'TOTAL_RENDER_ELAPSED_SECONDS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5408\8A08\30EC\30F3\30C0\30EA\30F3\30B0\6642\9593(\79D2)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104669279051308974)
,p_name=>'TO_BE_PURGED_IN_NEXT_7_DAYS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30FC\30B8\4E88\5B9A(\4ECA\5F8C7\65E5\4EE5\5185)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104050457867308475)
,p_name=>'TO_DOS'
,p_message_language=>'ja'
,p_message_text=>'To Do'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104355567964308723)
,p_name=>'TO_DO_PERCENT_COMPLETE'
,p_message_language=>'ja'
,p_message_text=>unistr('To Do\306E\5B8C\4E86\7387(%0/%1):')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103753844595308210)
,p_name=>'TREE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C4\30EA\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104176699526308589)
,p_name=>'TREE_EXAMPLES_EXISTING_ITEM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C4\30EA\30FC\3092\958B\59CB\3059\308B\305F\3081\306E\65E2\5B58\30A2\30A4\30C6\30E0\306E\5165\529B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104176782620308590)
,p_name=>'TREE_EXAMPLES_SQL_QUERY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C4\30EA\30FC\3092\958B\59CB\3059\308B\305F\3081\306ESQL\554F\5408\305B\306E\5165\529B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104176936801308590)
,p_name=>'TREE_EXAMPLES_START_NULL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C4\30EA\30FC\3092\958B\59CB\3059\308B\5024\304CNULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104176802711308590)
,p_name=>'TREE_EXAMPLES_STATIC_VALUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C4\30EA\30FC\3092\958B\59CB\3059\308B\305F\3081\306E\9759\7684\5024\306E\5165\529B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103667019789308141)
,p_name=>'TREE_SUCCESS_MSG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C4\30EA\30FC\304C\6B63\5E38\306B\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103751983172308209)
,p_name=>'TRIGGER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C8\30EA\30AC\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103628765290308112)
,p_name=>'TRIGGER.BUTTON_TAB_NAMES_NOT_EQUAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3\540D\306B\306F\3001\65E2\5B58\306E\30BF\30D6\3068\540C\3058\540D\524D\3092\6307\5B9A\3067\304D\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104134752662308545)
,p_name=>'TRIGGER.FLOWID_SGID_MISMATCH'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3ID\304A\3088\3073\73FE\884C\306E\30BB\30AD\30E5\30EA\30C6\30A3\30FB\30B0\30EB\30FC\30D7ID\306B\4E00\8CAB\6027\304C\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103628684102308112)
,p_name=>'TRIGGER.SGID_RESERVED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30AD\30E5\30EA\30C6\30A3\30FB\30B0\30EB\30FC\30D7ID 20\306F\3001\30EF\30FC\30AF\30B9\30DA\30FC\30B9\300CORACLE\300D\306B\4E88\7D04\3055\308C\3066\3044\307E\3059')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104132618858308544)
,p_name=>'TRUNCATE_TABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868%0\306E\5207\6368\3066')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104177586107308590)
,p_name=>'TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104179407207308592)
,p_name=>'TYPE_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104128071710308540)
,p_name=>'UI_DEF_CUSTOM_ITEM_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30B9\30BF\30E0\30FB\30A2\30A4\30C6\30E0\30FB\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104134616286308545)
,p_name=>'UI_DEF_VIEW_DB_COL_DEFN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\5217\306E\5B9A\7FA9\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104021006806308451)
,p_name=>'UI_PAGE_SKIP_TO_CONTENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E1\30A4\30F3\30FB\30B3\30F3\30C6\30F3\30C4\306B\30B9\30AD\30C3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103541820953308046)
,p_name=>'UI_TYPE.DESKTOP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30B9\30AF\30C8\30C3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103541970885308046)
,p_name=>'UI_TYPE.JQM_SMARTPHONE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E2\30D0\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103542044511308046)
,p_name=>'UI_TYPE.JQM_TABLET'
,p_message_language=>'ja'
,p_message_text=>unistr('jQuery Mobile\30BF\30D6\30EC\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103542159959308046)
,p_name=>'UI_TYPE.PHONEGAP_JQM_SMARTPHONE'
,p_message_language=>'ja'
,p_message_text=>unistr('PhoneGap\5411\3051jQuery Mobile\30B9\30DE\30FC\30C8\30D5\30A9\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103542229491308046)
,p_name=>'UI_TYPE.PHONEGAP_JQM_TABLET'
,p_message_language=>'ja'
,p_message_text=>unistr('PhoneGap\5411\3051jQuery Mobile\30BF\30D6\30EC\30C3\30C8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103700070141308167)
,p_name=>'UNABLE_TO_DETERMINE_MS_DATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30A4\30EB\30B9\30C8\30F3\65E5\4ED8\3092\5224\5225\3067\304D\307E\305B\3093')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104071260446308493)
,p_name=>'UNASSIGNED'
,p_message_language=>'ja'
,p_message_text=>unistr('\672A\5272\5F53\3066')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104094294535308511)
,p_name=>'UNAUTHENTICATED_USER'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\3055\308C\3066\3044\306A\3044\30E6\30FC\30B6\30FC')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104275387135308664)
,p_name=>'UNAVAILABLE_REDIRECT_TO_URL'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F7F\7528\4E0D\53EF(URL\306B\30EA\30C0\30A4\30EC\30AF\30C8)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104275290835308664)
,p_name=>'UNAVAILABLE_STATUS_SHOWN_WITH_PLSQL'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F7F\7528\4E0D\53EF(PL/SQL\3067\8868\793A\3055\308C\308B\30B9\30C6\30FC\30BF\30B9)')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104009702005308443)
,p_name=>'UNDER_CONSIDERATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A0E\4E2D')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103624728405308106)
,p_name=>'UNEXPIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\6709\52B9')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104136204223308547)
,p_name=>'UNLOCK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30C3\30AF\89E3\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104224246805308627)
,p_name=>'UNLOCKED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30C3\30AF\89E3\9664\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103588819929308079)
,p_name=>'UNLOCKED_APPLICATIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30C3\30AF\89E3\9664\3055\308C\305F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103585840813308077)
,p_name=>'UNLOCK_APPLICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30C3\30AF\89E3\9664')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103845743759308282)
,p_name=>'UNRESTRICTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\5236\9650\306A\3057')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103800566872308247)
,p_name=>'UP'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0A\3078')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103753683919308210)
,p_name=>'UPDATEABLE_REPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F4\65B0\53EF\80FD\306A\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104333763571308707)
,p_name=>'UPDATED_BY'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F4\65B0\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103783820999308234)
,p_name=>'UPDATED_ON'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F4\65B0\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104186321435308598)
,p_name=>'UPDATE_APP_DISP_VERSION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30D0\30FC\30B8\30E7\30F3\306E\66F4\65B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104186449048308598)
,p_name=>'UPDATE_VERSION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D0\30FC\30B8\30E7\30F3\3078\306E\66F4\65B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104685863286308988)
,p_name=>'UPGRADE_APP.UNSUPPORTED_DATE_FORMAT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30DD\30FC\30C8\3055\308C\3066\3044\308B\65E5\4ED8\66F8\5F0F\3067\306F\3042\308A\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104356676526308724)
,p_name=>'UPGRADE_APPLICATION.INVALID_DATE_FORMAT'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5\4ED8\66F8\5F0F\304C\30B5\30DD\30FC\30C8\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104736994733309032)
,p_name=>'UPGRADE_CANDLESTICK_CHART'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30C3\30D7\30B0\30EC\30FC\30C9\5F8C\306B\3001\30B7\30EA\30FC\30BA\5C5E\6027\306E\300C\30E9\30D9\30EB\5217\300D\304C\65E5\4ED8/\30BF\30A4\30E0\30B9\30BF\30F3\30D7\5217\306B\30DE\30C3\30D7\3055\308C\3066\3044\308B\3053\3068\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103753751153308210)
,p_name=>'URL'
,p_message_language=>'ja'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103990252598308428)
,p_name=>'URL LINK'
,p_message_language=>'ja'
,p_message_text=>unistr('URL\30EA\30F3\30AF')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104013806799308446)
,p_name=>'USERID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FCID')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104030156336308459)
,p_name=>'USERS_AND_MOST_RECENT_CREATE'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\30E6\30FC\30B6\30FC\3001\6700\65B0\306E\30E6\30FC\30B6\30FC\4F5C\6210%1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104135019416308546)
,p_name=>'USER_INTERFACE.NO_GLOBAL_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30ED\30FC\30D0\30EB\30FB\30DA\30FC\30B8\304C\5B9A\7FA9\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104024569248308454)
,p_name=>'USER_INTERFACE_ASSIGNEE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\5272\5F53\3066\5148')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104024088220308454)
,p_name=>'USER_INTERFACE_IMPACT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\306E\5F71\97FF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104025534792308455)
,p_name=>'USER_INTERFACE_STATUS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\30FB\30B9\30C6\30FC\30BF\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103643411680308123)
,p_name=>'USER_TYPE_DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30DA\30FC\30B8\3092\4F7F\7528\3057\3066\3001Application Express\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9\7BA1\7406\8005\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\958B\767A\8005\304A\3088\3073\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306E\30A2\30AF\30BB\30B9\3092\5236\5FA1\3057\307E\3059\3002</p>'),
'',
unistr('<p><strong>\30EF\30FC\30AF\30B9\30DA\30FC\30B9\7BA1\7406\8005</strong>\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304A\3088\3073\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30AA\30D6\30B8\30A7\30AF\30C8\306E\4F5C\6210\3084\5909\66F4\306B\52A0\3048\3001\30E6\30FC\30B6\30FC\30FB\30A2\30AB\30A6\30F3\30C8\3001\30B0\30EB\30FC\30D7\304A\3088\3073\958B\767A\30B5\30FC\30D3\30B9\306E\7BA1\7406\304C\53EF\80FD\3067\3059\3002</p>'),
'',
unistr('<p><strong>\958B\767A\8005</strong>\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304A\3088\3073\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30AA\30D6\30B8\30A7\30AF\30C8\306E\4F5C\6210\3084\5909\66F4\304C\53EF\80FD\3067\3059\3002</p>'),
'',
unistr('<p><strong>\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC</strong>\306F\3001\958B\767A\6A29\9650\3092\6240\6709\305B\305A\3001\5916\90E8\8A8D\8A3C\30B9\30AD\30FC\30E0\3092\4F7F\7528\3057\306A\3044\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3078\306E\30A2\30AF\30BB\30B9\306E\307F\304C\53EF\80FD\3067\3059\3002</p>'),
'',
unistr('<p><a target="_blank" href="%0/aeadm/managing-users-in-a-workspace.html">\3055\3089\306B\5B66\3076...</a></p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103667661653308141)
,p_name=>'USER_TYPE_DESCRIPTION_CLOUD'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30DA\30FC\30B8\3092\4F7F\7528\3057\3066\3001Application Express\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306E\30A2\30AF\30BB\30B9\3092\5236\5FA1\3057\307E\3059\3002</p>'),
'',
unistr('<p><strong>\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC</strong>\306F\3001\958B\767A\6A29\9650\3092\6240\6709\305B\305A\3001\5916\90E8\8A8D\8A3C\30B9\30AD\30FC\30E0\3092\4F7F\7528\3057\306A\3044\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3078\306E\30A2\30AF\30BB\30B9\306E\307F\304C\53EF\80FD\3067\3059\3002</p>'),
'',
unistr('<p><strong>\30EF\30FC\30AF\30B9\30DA\30FC\30B9\7BA1\7406\8005</strong>\304A\3088\3073<strong>\958B\767A\8005</strong>\306F\3001\30A2\30A4\30C7\30F3\30C6\30A3\30C6\30A3\30FB\30B3\30F3\30BD\30FC\30EB\3092\4F7F\7528\3057\3066\7BA1\7406\3055\308C\307E\3059\3002\30EF\30FC\30AF\30B9\30DA\30FC\30B9\7BA1\7406\8005\307E\305F\306F\958B\767A\8005\304CApplication Express\306B\30ED\30B0\30A4\30F3\3059\308B\305F\3073\306B\3001\30B7\30E3\30C9\30A6\30FB\30A2\30AB\30A6\30F3\30C8\304C\4F5C\6210\3055\308C\307E\3059\3002\5FC5\8981\306B\5FDC\3058\3066\3001\3053\308C\3089\306E\30B7\30E3\30C9\30A6\30FB\30E6\30FC\30B6\30FC\3092\524A\9664\3067\304D\307E\3059\3002</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103755192168308212)
,p_name=>'USE_BUILTIN_LOGIN_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D44\8FBC\307F\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8\3092\4F7F\7528\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103754942348308211)
,p_name=>'USE_PAGE_AS_LOGIN_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8%0\3092\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8\3068\3057\3066\4F7F\7528\3057\3066\304F\3060\3055\3044\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104117915308308531)
,p_name=>'USING_CLEAR_CACHE_AND_PAGE_LINKS'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<strong>\30AD\30E3\30C3\30B7\30E5\306E\30AF\30EA\30A2</strong>\5C5E\6027\3092\4F7F\7528\3057\3066\3001\30DA\30FC\30B8\306E\30AB\30F3\30DE\533A\5207\308A\30EA\30B9\30C8\306E\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\3092\524A\9664\3057\307E\3059\3002\6B21\306E\30AD\30E3\30C3\30B7\30E5\306E\30AF\30EA\30A2\69CB\6587\3082\4F7F\7528\3067\304D\307E\3059\3002'),
'<ul>',
unistr('<li>RIR - \5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\306E\30EA\30BB\30C3\30C8</li>'),
unistr('<li>CIR - \5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\306E\30AF\30EA\30A2</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104140908065308550)
,p_name=>'USING_EXISTING_SCHEMA'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E2\5B58\306E\30B9\30AD\30FC\30DE\3092\4F7F\7528\4E2D')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104762684249309052)
,p_name=>'UTR.BUTTONS.CLOSE'
,p_message_language=>'ja'
,p_message_text=>unistr('\9589\3058\308B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104762912007309053)
,p_name=>'UTR.BUTTONS.CODE_EDITOR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30FC\30C9\30FB\30A8\30C7\30A3\30BF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104762882516309053)
,p_name=>'UTR.BUTTONS.MAXIMIZE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5927\5316')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104762733596309052)
,p_name=>'UTR.BUTTONS.MINIMIZE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5C0F\5316')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104764096465309054)
,p_name=>'UTR.CHANGE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB\3092\5909\66F4\3059\308B\3068\3001\4FDD\5B58\3057\3066\3044\306A\3044\5909\66F4\304C\30EA\30BB\30C3\30C8\3055\308C\307E\3059\3002\3053\306E\64CD\4F5C\306F\5143\306B\623B\305B\307E\305B\3093\3002\7D9A\884C\3057\307E\3059\304B\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104791339534309082)
,p_name=>'UTR.CHANGE_THEME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\306E\5909\66F4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104762586949309052)
,p_name=>'UTR.COMMON.BASE_STYLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30BF\30A4\30EB')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104762344327309052)
,p_name=>'UTR.COMMON.CANCEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\53D6\6D88')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104761702255309052)
,p_name=>'UTR.COMMON.CONFIRM'
,p_message_language=>'ja'
,p_message_text=>unistr('\78BA\8A8D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104791019594309081)
,p_name=>'UTR.COMMON.COPY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30D4\30FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104762146150309052)
,p_name=>'UTR.COMMON.NO'
,p_message_language=>'ja'
,p_message_text=>unistr('\3044\3044\3048')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104762274686309052)
,p_name=>'UTR.COMMON.OK'
,p_message_language=>'ja'
,p_message_text=>'OK'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104790909582309081)
,p_name=>'UTR.COMMON.SET_CURRENT_WHEN_READ_ONLY_PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr(' \8AAD\53D6\308A\5C02\7528\306E\30C6\30FC\30DE\306B\5BFE\3057\3066\5909\66F4\3092\884C\3044\307E\3057\305F\3002\3053\308C\3092\73FE\5728\306E\30C6\30FC\30DE\3068\3059\308B\5834\5408\3001\5909\66F4\5185\5BB9\306F\6D88\53BB\3055\308C\307E\3059\3002\7D9A\884C\3057\307E\3059\304B\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104762426554309052)
,p_name=>'UTR.COMMON.STYLE_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30BF\30A4\30EB\540D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104761823434309052)
,p_name=>'UTR.COMMON.SUCCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6210\529F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104791169622309081)
,p_name=>'UTR.COMMON.WARNING'
,p_message_language=>'ja'
,p_message_text=>unistr('\8B66\544A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104762044800309052)
,p_name=>'UTR.COMMON.YES'
,p_message_language=>'ja'
,p_message_text=>unistr('\306F\3044')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104787677367309079)
,p_name=>'UTR.CONFIG_OUTPUT'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\69CB\6210\3092\30C6\30FC\30DE\30FB\30ED\30FC\30E9\30FC\306B\30ED\30FC\30C9\3059\308B\306B\306F\3001\6B21\306E\30B3\30FC\30C9\884C\3092JS\30B3\30F3\30BD\30FC\30EB\306B\8CBC\308A\4ED8\3051\3066\304F\3060\3055\3044\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104787751336309079)
,p_name=>'UTR.CONFIG_OUTPUT_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\69CB\6210\3092\51FA\529B\3059\308B\306B\306F\3001\30C6\30FC\30DE\30FB\30ED\30FC\30E9\30FC\304C\958B\3044\3066\3044\3066\3001\73FE\5728\306E\30B9\30BF\30A4\30EB\304C\6709\52B9\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104675788241308980)
,p_name=>'UTR.CONTRAST_DIALOG.TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30C8\30E9\30B9\30C8\6BD4:')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104769101403309065)
,p_name=>'UTR.CONTRAST_VALIDATION.FAILED'
,p_message_language=>'ja'
,p_message_text=>unistr('\5931\6557')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104771561856309067)
,p_name=>'UTR.CONTRAST_VALIDATION.LARGE_TEXT_NOTICE'
,p_message_language=>'ja'
,p_message_text=>unistr('18pt\3088\308A\4E0A\306E\30C6\30AD\30B9\30C8\307E\305F\306F14pt\3088\308A\4E0A\306E\592A\5B57\7528')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104769213409309065)
,p_name=>'UTR.CONTRAST_VALIDATION.MESSAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\901A\5E38\30B5\30A4\30BA\30FB\30D5\30A9\30F3\30C8\306E\30AB\30E9\30FC\30FB\30B3\30F3\30C8\30E9\30B9\30C8\306EWeb\30B3\30F3\30C6\30F3\30C4\30FB\30A2\30AF\30BB\30B7\30D3\30EA\30C6\30A3\30FB\30AC\30A4\30C9\30E9\30A4\30F3(WCAG) 2.0\306B\5F93\3063\3066\3001\691C\8A3C\304C\5B9F\884C\3055\308C\307E\3059')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104769040808309065)
,p_name=>'UTR.CONTRAST_VALIDATION.PASSED'
,p_message_language=>'ja'
,p_message_text=>unistr('\5408\683C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104768997644309065)
,p_name=>'UTR.CONTRAST_VALIDATION.TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30E9\30FC\30FB\30B3\30F3\30C8\30E9\30B9\30C8\60C5\5831')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104790837042309081)
,p_name=>'UTR.CURRENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30EC\30F3\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104763837551309053)
,p_name=>'UTR.CUSTOM_CSS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30B9\30BF\30E0CSS')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104763930953309053)
,p_name=>'UTR.CUSTOM_CSS.DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30BF\30A4\30EB\30B7\30FC\30C8\306E\6700\5F8C\306B\3053\306E\30B3\30FC\30C9\304C\542B\307E\308C\307E\3059')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104772787465309068)
,p_name=>'UTR.CUSTOM_CSS.WARNING'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306ECSS\30B3\30FC\30C9\306F\3001\300C\30C6\30FC\30DE\30FB\30ED\30FC\30E9\30FC\300D\30C0\30A4\30A2\30ED\30B0\3092\975E\8868\793A\306B\3057\307E\3059\3002\3053\308C\306F\30DA\30FC\30B8\306B\306F\9069\7528\3055\308C\3066\3044\307E\305B\3093\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104353500904308722)
,p_name=>'UTR.DOWNLOAD'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C0\30A6\30F3\30ED\30FC\30C9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104353858798308722)
,p_name=>'UTR.DRAG_AND_DROP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\3092\30C9\30E9\30C3\30B0\30FB\30A2\30F3\30C9\30FB\30C9\30ED\30C3\30D7\3059\308B\304B\3001\30AF\30EA\30C3\30AF\3057\3066\9078\629E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104354073999308722)
,p_name=>'UTR.ENABLE_LESS_COMPILATION'
,p_message_language=>'ja'
,p_message_text=>unistr('LESS\30B3\30F3\30D1\30A4\30EB\306E\6709\52B9\5316')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104761910646309052)
,p_name=>'UTR.ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104764499016309054)
,p_name=>'UTR.ERROR.CREATE_FAILED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB\3092\4F5C\6210\3067\304D\307E\305B\3093\3067\3057\305F\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104772438871309068)
,p_name=>'UTR.ERROR.INPUT_NOT_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('1\3064\4EE5\4E0A\306ECSS\30D5\30A1\30A4\30EB\306EURL\306E\30ED\30FC\30C9\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104764228224309054)
,p_name=>'UTR.ERROR.INVALID_STYLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB\306ELESS\30B3\30FC\30C9\304C\7121\52B9\3067\3059\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104764690768309061)
,p_name=>'UTR.ERROR.LOAD_FAILED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB\3092\30ED\30FC\30C9\3067\304D\307E\305B\3093\3067\3057\305F\3002\300C\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30D3\30EB\30C0\30FC\300D\30A6\30A3\30F3\30C9\30A6\304C\307E\3060\958B\3044\3066\3044\3066\3001\30BB\30C3\30B7\30E7\30F3\304C\6709\52B9\3067\3042\308B\3053\3068\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104791255504309082)
,p_name=>'UTR.ERROR.SET_AS_CURRENT_FAILED'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3057\305F\30C6\30FC\30DE\3092\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\73FE\5728\306E\30C6\30FC\30DE\3068\3057\3066\4F7F\7528\3067\304D\307E\305B\3093\3067\3057\305F\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104764128388309054)
,p_name=>'UTR.ERROR.UNSUPPORTED_STYLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB\306F\30C6\30FC\30DE\30FB\30ED\30FC\30E9\30FC\306E\30AB\30B9\30BF\30DE\30A4\30BA\3092\30B5\30DD\30FC\30C8\3057\3066\3044\307E\305B\3093')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104764348588309054)
,p_name=>'UTR.ERROR.UNSUPPORTED_THEME'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30C6\30FC\30DE\306B\306F\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB\304C\3042\308A\307E\305B\3093\3002\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB\3092\4F7F\7528\3057\305F\30C6\30FC\30DE\3092\9078\629E\3057\3066\3001\30C6\30FC\30DE\30FB\30ED\30FC\30E9\30FC\3092\4F7F\7528\3057\3066\304F\3060\3055\3044\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104764595318309061)
,p_name=>'UTR.ERROR.UPDATE_FAILED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB\3092\66F4\65B0\3067\304D\307E\305B\3093\3067\3057\305F\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104664769333308971)
,p_name=>'UTR.FILTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30EB\30BF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104771628600309067)
,p_name=>'UTR.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D8\30EB\30D7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104771727779309067)
,p_name=>'UTR.HELP.P1'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\30FB\30ED\30FC\30E9\30FC\3067\306F\3001\69D8\3005\306A\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306E\8272\306E\9078\629E\3068\30B9\30BF\30A4\30EB\306E\8A2D\5B9A\304C\3067\304D\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30E6\30FC\30B6\30FC\30FB\30A4\30F3\30BF\30D5\30A7\30FC\30B9\3092\7C21\5358\306B\30AB\30B9\30BF\30DE\30A4\30BA\3067\304D\307E\3059\3002\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\306F\4EFB\610F\306E\6570\306E\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB\3092\5B9A\7FA9\3067\304D\307E\3059\304C\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\8868\793A\3059\308B\305F\3081\306B\4F7F\7528\3055\308C\308B\306E\306F\3001\73FE\5728\306E\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB\306E\307F\3067\3059\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104771836655309067)
,p_name=>'UTR.HELP.P2'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5909\66F4\3092\884C\3063\305F\5F8C\3001\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB\5168\4F53\306B\5BFE\3057\3066\300C\30EA\30BB\30C3\30C8\300D\30DC\30BF\30F3\3092\62BC\3059\304B\3001\30B0\30EB\30FC\30D7\306E\30EA\30BB\30C3\30C8\30FB\30A2\30A4\30B3\30F3\3092\62BC\3057\3066\3001\5C5E\6027\3092\7C21\5358\306B\30EA\30B9\30C8\30A2\3067\304D\307E\3059\3002'),
'',
unistr('\524D\666F\8272\304A\3088\3073\80CC\666F\8272\3092\9078\629E\3067\304D\308B\5C5E\6027\306B\3064\3044\3066\306F\30012\3064\306E\8272\306E\9078\629E\9805\76EE\306E\524D\306B\3042\308B\30C1\30A7\30C3\30AF\30FB\30DC\30C3\30AF\30B9\306B\3001Web\30B3\30F3\30C6\30F3\30C4\30FB\30A2\30AF\30BB\30B7\30D3\30EA\30C6\30A3\30FB\30AC\30A4\30C9\30E9\30A4\30F3(WCAG) 2.0\306B\57FA\3065\304F\30AB\30E9\30FC\30FB\30B3\30F3\30C8\30E9\30B9\30C8\60C5\5831\304C\793A\3055\308C\307E\3059\3002\8A08\7B97\3055\308C\305F\30B3\30F3\30C8\30E9\30B9\30C8\30FB\30B9\30B3\30A2\304C\9AD8\3044\307B\3069\3001\305D\306E\8272\306E\7D44\5408\305B\304C\3088\308A\30A2\30AF\30BB\30B9\53EF\80FD\3067\3042\308B\3053\3068\3092\793A\3057\3066\3044\307E\3059\3002')))
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104548656473308874)
,p_name=>'UTR.INLINE_EDITOR_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30E9\30A4\30F3\30FB\30A8\30C7\30A3\30BF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104073390804308494)
,p_name=>'UTR.LESS.ACCENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30BB\30F3\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104783402154309076)
,p_name=>'UTR.LESS.ACTIONS_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3\5217')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104786914673309078)
,p_name=>'UTR.LESS.ACTIVE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30C6\30A3\30D6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104787594433309079)
,p_name=>'UTR.LESS.ACTIVE_STATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30C6\30A3\30D6\72B6\614B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104785496842309077)
,p_name=>'UTR.LESS.BACKGROUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\80CC\666F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104073491764308494)
,p_name=>'UTR.LESS.BADGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D0\30C3\30B8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104783394869309076)
,p_name=>'UTR.LESS.BODY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30C7\30A3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104783282161309076)
,p_name=>'UTR.LESS.BODY_ACCENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30C7\30A3\30FB\30A2\30AF\30BB\30F3\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104787823656309079)
,p_name=>'UTR.LESS.BODY_CONTENT_MAX_WIDTH'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30C7\30A3\30FB\30B3\30F3\30C6\30F3\30C4\306E\6700\5927\5E45')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104784053366309076)
,p_name=>'UTR.LESS.BORDER_RADIUS'
,p_message_language=>'ja'
,p_message_text=>unistr('\67A0\7DDA\306E\89D2\306E\4E38\3081')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104782133891309075)
,p_name=>'UTR.LESS.BUTTONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104785628918309077)
,p_name=>'UTR.LESS.COLOR_1'
,p_message_language=>'ja'
,p_message_text=>unistr('\82721')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104786492584309078)
,p_name=>'UTR.LESS.COLOR_10'
,p_message_language=>'ja'
,p_message_text=>unistr('\827210')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104754941737309046)
,p_name=>'UTR.LESS.COLOR_11'
,p_message_language=>'ja'
,p_message_text=>unistr('\827211')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104755098819309046)
,p_name=>'UTR.LESS.COLOR_12'
,p_message_language=>'ja'
,p_message_text=>unistr('\827212')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104755108140309046)
,p_name=>'UTR.LESS.COLOR_13'
,p_message_language=>'ja'
,p_message_text=>unistr('\827213')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104755266784309046)
,p_name=>'UTR.LESS.COLOR_14'
,p_message_language=>'ja'
,p_message_text=>unistr('\827214')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104755360290309046)
,p_name=>'UTR.LESS.COLOR_15'
,p_message_language=>'ja'
,p_message_text=>unistr('\827215')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104785750179309077)
,p_name=>'UTR.LESS.COLOR_2'
,p_message_language=>'ja'
,p_message_text=>unistr('\82722')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104786554879309078)
,p_name=>'UTR.LESS.COLOR_3'
,p_message_language=>'ja'
,p_message_text=>unistr('\82723')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104785867054309078)
,p_name=>'UTR.LESS.COLOR_4'
,p_message_language=>'ja'
,p_message_text=>unistr('\82724')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104785909329309078)
,p_name=>'UTR.LESS.COLOR_5'
,p_message_language=>'ja'
,p_message_text=>unistr('\82725')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104786070923309078)
,p_name=>'UTR.LESS.COLOR_6'
,p_message_language=>'ja'
,p_message_text=>unistr('\82726')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104786163921309078)
,p_name=>'UTR.LESS.COLOR_7'
,p_message_language=>'ja'
,p_message_text=>unistr('\82727')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104786221916309078)
,p_name=>'UTR.LESS.COLOR_8'
,p_message_language=>'ja'
,p_message_text=>unistr('\82728')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104786356363309078)
,p_name=>'UTR.LESS.COLOR_9'
,p_message_language=>'ja'
,p_message_text=>unistr('\82729')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104782254160309075)
,p_name=>'UTR.LESS.CONTAINERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30C6\30CA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104786687463309078)
,p_name=>'UTR.LESS.CONTAINER_BORDER_RADIUS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30C6\30CA\67A0\7DDA\306E\89D2\306E\4E38\3081')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104784485567309077)
,p_name=>'UTR.LESS.DANGER'
,p_message_language=>'ja'
,p_message_text=>unistr('\5371\967A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104784863445309077)
,p_name=>'UTR.LESS.DISABLED'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104783724734309076)
,p_name=>'UTR.LESS.FOCUS_OUTLINE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30FC\30AB\30B9\30FB\30A2\30A6\30C8\30E9\30A4\30F3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104785280682309077)
,p_name=>'UTR.LESS.FOREGROUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\524D\666F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104792089174309082)
,p_name=>'UTR.LESS.FORMS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30FC\30E0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104781930844309075)
,p_name=>'UTR.LESS.GLOBAL_COLORS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30ED\30FC\30D0\30EB\8272')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104785514959309077)
,p_name=>'UTR.LESS.HEADER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D8\30C3\30C0\30FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104783106188309076)
,p_name=>'UTR.LESS.HEADER_ACCENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D8\30C3\30C0\30FC\30FB\30A2\30AF\30BB\30F3\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104075885197308496)
,p_name=>'UTR.LESS.HEADER_HEIGHT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D8\30C3\30C0\30FC\306E\9AD8\3055')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104784207839309076)
,p_name=>'UTR.LESS.HOT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DB\30C3\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104787298632309079)
,p_name=>'UTR.LESS.HOVER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DB\30D0\30FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104787382838309079)
,p_name=>'UTR.LESS.HOVER_STATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DB\30D0\30FC\72B6\614B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104786828805309078)
,p_name=>'UTR.LESS.ICON'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104784903807309077)
,p_name=>'UTR.LESS.INFO'
,p_message_language=>'ja'
,p_message_text=>unistr('\60C5\5831')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104783043931309075)
,p_name=>'UTR.LESS.INTERACTIVE_REPORTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104792130027309082)
,p_name=>'UTR.LESS.ITEM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104792259368309082)
,p_name=>'UTR.LESS.LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104782398323309075)
,p_name=>'UTR.LESS.LAYOUT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30A4\30A2\30A6\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104783925117309076)
,p_name=>'UTR.LESS.LEFT_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\5DE6\5074\306E\5217')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104783644583309076)
,p_name=>'UTR.LESS.LINK_COLOR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30F3\30AF\8272')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104785167743309077)
,p_name=>'UTR.LESS.MENU'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E1\30CB\30E5\30FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104778190422309072)
,p_name=>'UTR.LESS.MENUS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E1\30CB\30E5\30FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104119997246308533)
,p_name=>'UTR.LESS.MENU_ITEM_HOVER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E1\30CB\30E5\30FC\30FB\30A2\30A4\30C6\30E0\306E\30DB\30D0\30FC\72B6\614B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104782469473309075)
,p_name=>'UTR.LESS.NAVIGATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CA\30D3\30B2\30FC\30B7\30E7\30F3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104786745302309078)
,p_name=>'UTR.LESS.NAVIGATION_TREE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30C4\30EA\30FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104784180804309076)
,p_name=>'UTR.LESS.NORMAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A19\6E96')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104787014950309078)
,p_name=>'UTR.LESS.NOT_ACTIVE'
,p_message_language=>'ja'
,p_message_text=>unistr('\975E\30A2\30AF\30C6\30A3\30D6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104782717933309075)
,p_name=>'UTR.LESS.PALETTE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30EC\30C3\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104784337530309076)
,p_name=>'UTR.LESS.PRIMARY'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E3B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103949210702308397)
,p_name=>'UTR.LESS.PRIMARY_ACCENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30E9\30A4\30DE\30EA\30FB\30A2\30AF\30BB\30F3\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104782068416309075)
,p_name=>'UTR.LESS.REGIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104783820233309076)
,p_name=>'UTR.LESS.REGION_HEADER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D8\30C3\30C0\30FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104767024745309063)
,p_name=>'UTR.LESS.REPORTS_GRIDS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\3068\30B0\30EA\30C3\30C9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104684274745308986)
,p_name=>'UTR.LESS.RW.CLASSES.BODY_BACKGROUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\672C\6587\80CC\666F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104684110560308986)
,p_name=>'UTR.LESS.RW.CLASSES.BODY_HEADER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30C7\30A3\30FB\30D8\30C3\30C0\30FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104684947788308987)
,p_name=>'UTR.LESS.RW.CLASSES.DISPLAY_MODE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\30E2\30FC\30C9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104685147809308987)
,p_name=>'UTR.LESS.RW.CLASSES.DISPLAY_MODE.COMPACT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30D1\30AF\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104685032646308987)
,p_name=>'UTR.LESS.RW.CLASSES.DISPLAY_MODE.STANDARD'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A19\6E96(\30C7\30D5\30A9\30EB\30C8)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104668691453308974)
,p_name=>'UTR.LESS.RW.CLASSES.LAYOUT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30A4\30A2\30A6\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104672207337308977)
,p_name=>'UTR.LESS.RW.CLASSES.LAYOUT.CONTAINED'
,p_message_language=>'ja'
,p_message_text=>unistr('\542B\307E\308C\308B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104672053911308977)
,p_name=>'UTR.LESS.RW.CLASSES.LAYOUT.EDGE_TO_EDGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30C3\30B8\304B\3089\30A8\30C3\30B8(\30C7\30D5\30A9\30EB\30C8)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104672100169308977)
,p_name=>'UTR.LESS.RW.CLASSES.LAYOUT.FLOATING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30ED\30FC\30C6\30A3\30F3\30B0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104668518797308974)
,p_name=>'UTR.LESS.RW.CLASSES.MODE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E2\30FC\30C9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104671843567308976)
,p_name=>'UTR.LESS.RW.CLASSES.MODE.DARK'
,p_message_language=>'ja'
,p_message_text=>unistr('\6FC3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104671966425308977)
,p_name=>'UTR.LESS.RW.CLASSES.MODE.DARK_BODY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C0\30FC\30AF\30FB\30DC\30C7\30A3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104685310288308987)
,p_name=>'UTR.LESS.RW.CLASSES.MODE.DARK_DEFAULT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C0\30FC\30AF(\30C7\30D5\30A9\30EB\30C8)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104671797962308976)
,p_name=>'UTR.LESS.RW.CLASSES.MODE.LIGHT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6DE1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104685444894308987)
,p_name=>'UTR.LESS.RW.CLASSES.MODE.LIGHT_DEFAULT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30A4\30C8(\30C7\30D5\30A9\30EB\30C8)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104668409054308974)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D4\30E9\30FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104683962738308986)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.BEIGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D9\30FC\30B8\30E5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104683596127308986)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.LILAC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30A4\30E9\30C3\30AF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104682930098308985)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.NEUTRAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\8272(\30C7\30D5\30A9\30EB\30C8)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104683433159308986)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.OCEAN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30FC\30B7\30E3\30F3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104683097311308985)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.PEBBLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30D6\30EB')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104683269001308986)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.PINE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30A4\30F3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104683835655308986)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.PLUM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30E9\30E0')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104683640232308986)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.ROSE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30FC\30BA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104683735265308986)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.SIENNA'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30A8\30CA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104683194845308985)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.SLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30EC\30FC\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104683337790308986)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.TEAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30A3\30FC\30EB')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104684001667308986)
,p_name=>'UTR.LESS.RW.GROUP.APPEARANCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5916\89B3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104682881716308985)
,p_name=>'UTR.LESS.RW.GROUP.CLASSES'
,p_message_language=>'ja'
,p_message_text=>unistr('Redwood\30AA\30D7\30B7\30E7\30F3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103864644542308296)
,p_name=>'UTR.LESS.SCALE_LEVEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30B1\30FC\30EB')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103949336325308397)
,p_name=>'UTR.LESS.SECONDARY_ACCENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30AB\30F3\30C0\30EA\30FB\30A2\30AF\30BB\30F3\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104787139610309079)
,p_name=>'UTR.LESS.SELECTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\6E08')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104787470288309079)
,p_name=>'UTR.LESS.SELECTED_STATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3057\305F\72B6\614B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104784755304309077)
,p_name=>'UTR.LESS.SIMPLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30F3\30D7\30EB')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104782524958309075)
,p_name=>'UTR.LESS.STATES'
,p_message_language=>'ja'
,p_message_text=>unistr('\5DDE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104784601686309077)
,p_name=>'UTR.LESS.SUCCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6210\529F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104785359784309077)
,p_name=>'UTR.LESS.TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104783517370309076)
,p_name=>'UTR.LESS.TITLE_BAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30C8\30EB\30FB\30D0\30FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104784503006309077)
,p_name=>'UTR.LESS.WARNING'
,p_message_language=>'ja'
,p_message_text=>unistr('\8B66\544A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104664816030308971)
,p_name=>'UTR.LOADING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30FC\30C9\4E2D...')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103667286280308141)
,p_name=>'UTR.LOGO.ALT_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4EE3\66FF\30C6\30AD\30B9\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104316914201308695)
,p_name=>'UTR.LOGO.CUSTOM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30B9\30BF\30E0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104316857403308695)
,p_name=>'UTR.LOGO.CUSTOM.MESSAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30D3\30EB\30C0\30FC\3067\30ED\30B4\30FB\30DE\30FC\30AF\30A2\30C3\30D7\3092\7DE8\96C6\3067\304D\307E\3059')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104354566953308722)
,p_name=>'UTR.LOGO.ERROR_LOAD_FAILED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30B4\30FB\30C7\30FC\30BF\3092\30ED\30FC\30C9\3067\304D\307E\305B\3093\3067\3057\305F\3002\300C\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30D3\30EB\30C0\30FC\300D\30A6\30A3\30F3\30C9\30A6\304C\307E\3060\958B\3044\3066\3044\3066\3001\30BB\30C3\30B7\30E7\30F3\304C\6709\52B9\3067\3042\308B\3053\3068\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104316723794308695)
,p_name=>'UTR.LOGO.IMAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30E1\30FC\30B8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104356727538308724)
,p_name=>'UTR.LOGO.IMAGE_DEFAULT_VALUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30E1\30FC\30B8\304C\30ED\30FC\30C9\3055\308C\307E\305B\3093\3067\3057\305F\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104316680482308694)
,p_name=>'UTR.LOGO.IMAGE_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30E1\30FC\30B8\3068\30C6\30AD\30B9\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104354108286308722)
,p_name=>'UTR.LOGO.MAX_FILESIZE_IN_KB'
,p_message_language=>'ja'
,p_message_text=>unistr('%0KB\3088\308A\5C0F\3055\3044\30D5\30A1\30A4\30EB\3092\9078\629E\3057\3066\304F\3060\3055\3044')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104316590369308694)
,p_name=>'UTR.LOGO.NONE'
,p_message_language=>'ja'
,p_message_text=>unistr('\306A\3057')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104354216537308722)
,p_name=>'UTR.LOGO.ONLY_IMAGE_FILES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30E1\30FC\30B8\30FB\30D5\30A1\30A4\30EB\306E\307F\304C\8A31\53EF\3055\308C\307E\3059')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104353464703308722)
,p_name=>'UTR.LOGO.SAVE_LOGO'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30B4\306E\4FDD\5B58')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104354392092308722)
,p_name=>'UTR.LOGO.SET_LOGO_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30B4\3092\4FDD\5B58\3067\304D\307E\305B\3093\3067\3057\305F\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104354442828308722)
,p_name=>'UTR.LOGO.SET_LOGO_SUCCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30B4\306F\6B63\5E38\306B\4FDD\5B58\3055\308C\307E\3057\305F\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104316453138308694)
,p_name=>'UTR.LOGO.TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104316259272308694)
,p_name=>'UTR.LOGO.TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104316171121308694)
,p_name=>'UTR.LOGO.UPLOAD_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\3092\30C9\30E9\30C3\30B0\30FB\30A2\30F3\30C9\30FB\30C9\30ED\30C3\30D7\3059\308B\304B\3001\30AF\30EA\30C3\30AF\3057\3066\9078\629E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104546986273308872)
,p_name=>'UTR.LOGO_EDITOR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30B4\306E\7DE8\96C6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104353939793308722)
,p_name=>'UTR.ONLY_JSON_ALLOWED'
,p_message_language=>'ja'
,p_message_text=>unistr('JSON\30D5\30A1\30A4\30EB\306E\307F\304C\8A31\53EF\3055\308C\307E\3059')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104779722245309073)
,p_name=>'UTR.PALETTE_GENERATOR.ADJACENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\96A3\63A5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104779546025309073)
,p_name=>'UTR.PALETTE_GENERATOR.BASE_RGB'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D9\30FC\30B9RGB')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104791846934309082)
,p_name=>'UTR.PALETTE_GENERATOR.DUAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E8C\91CD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104779673146309073)
,p_name=>'UTR.PALETTE_GENERATOR.MONOCHROMATIC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E2\30CE\30AF\30ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104780168892309073)
,p_name=>'UTR.PALETTE_GENERATOR.SEPARATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\9593\9694')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104779990407309073)
,p_name=>'UTR.PALETTE_GENERATOR.TETRAD'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30C8\30E9\30FC\30C9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104779820872309073)
,p_name=>'UTR.PALETTE_GENERATOR.TRIAD'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C8\30E9\30A4\30A2\30FC\30C9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104780068362309073)
,p_name=>'UTR.PALETTE_GENERATOR.WITH_COMPLEMENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\88DC\8272\3042\308A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104075208397308496)
,p_name=>'UTR.PENDING_LOGO_CHANGES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30B4\306E\5909\66F4\304C\4FDD\5B58\3055\308C\3066\3044\307E\305B\3093\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104075352241308496)
,p_name=>'UTR.PENDING_THEME_CHANGES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\306E\5909\66F4\304C\4FDD\5B58\3055\308C\3066\3044\307E\305B\3093\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104782916571309075)
,p_name=>'UTR.REDO'
,p_message_language=>'ja'
,p_message_text=>unistr('\3084\308A\76F4\3057')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104763629763309053)
,p_name=>'UTR.RESET'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30BB\30C3\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104763747269309053)
,p_name=>'UTR.RESET.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('CSS\3092\30EA\30BB\30C3\30C8\3057\307E\3059\304B\3002\3059\3079\3066\306E\5909\66F4\304C\5931\308F\308C\307E\3059\3002\3053\306E\64CD\4F5C\306F\5143\306B\623B\305B\307E\305B\3093\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104791433349309082)
,p_name=>'UTR.RESET.STYLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30BF\30A4\30EB\306E\30EA\30BB\30C3\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104763386303309053)
,p_name=>'UTR.SAVE'
,p_message_language=>'ja'
,p_message_text=>unistr('\4FDD\5B58')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104763494018309053)
,p_name=>'UTR.SAVE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB\306E\540D\524D\3092\5909\66F4\3059\308B\306B\306F\3001\540D\524D\3092\66F4\65B0\3057\3066\304F\3060\3055\3044\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104763513575309053)
,p_name=>'UTR.SAVE.SUCCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB\306F\6B63\5E38\306B\66F4\65B0\3055\308C\307E\3057\305F\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104763072968309053)
,p_name=>'UTR.SAVE_AS'
,p_message_language=>'ja'
,p_message_text=>unistr('\540D\524D\3092\4ED8\3051\3066\4FDD\5B58')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104763176929309053)
,p_name=>'UTR.SAVE_AS.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB\306E\540D\524D\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104763254884309053)
,p_name=>'UTR.SAVE_AS.SUCCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB\304C\6B63\5E38\306B\4F5C\6210\3055\308C\307E\3057\305F\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104779476851309073)
,p_name=>'UTR.SEARCH'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104547049924308873)
,p_name=>'UTR.SELECT_THEME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\3092\9078\629E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104790719403309081)
,p_name=>'UTR.SET_AS_CURRENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\884C\3068\3057\3066\8A2D\5B9A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104791595645309082)
,p_name=>'UTR.SET_AS_CURRENT_THEME_STYLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB\3068\3057\3066\8A2D\5B9A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104791666486309082)
,p_name=>'UTR.SET_AS_CURRENT_THEME_STYLE_SUCCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3057\305F\30C6\30FC\30DE\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\73FE\5728\306E\30C6\30FC\30DE\3067\3059\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104791764896309082)
,p_name=>'UTR.SET_AS_CURRENT_WHEN_READ_ONLY.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8AAD\53D6\308A\5C02\7528\306E\30C6\30FC\30DE\306B\5BFE\3057\3066\5909\66F4\3092\884C\3044\307E\3057\305F\3002\3053\306E\30C6\30FC\30DE\3092\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\73FE\5728\306E\30C6\30FC\30DE\3068\3057\3066\8A2D\5B9A\3059\308B\5834\5408\3001\5909\66F4\5185\5BB9\306F\6D88\53BB\3055\308C\307E\3059\3002\7D9A\884C\3057\307E\3059\304B\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104316023525308694)
,p_name=>'UTR.TABS.LOGO'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30B4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104315960294308694)
,p_name=>'UTR.TABS.THEME_STYLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104761655276309052)
,p_name=>'UTR.THEME_ROLLER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\30FB\30ED\30FC\30E9\30FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104772381858309067)
,p_name=>'UTR.TOOLBAR.BUTTONS.ALL'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\8868\793A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104772219008309067)
,p_name=>'UTR.TOOLBAR.BUTTONS.COMMON'
,p_message_language=>'ja'
,p_message_text=>unistr('\5171\901A\306E\8868\793A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104788567450309080)
,p_name=>'UTR.TOOLBAR.BUTTONS.PALETTE_GENERATOR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30E9\30FC\30FB\30DB\30A4\30FC\30EB')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104782808613309075)
,p_name=>'UTR.UNDO'
,p_message_language=>'ja'
,p_message_text=>unistr('\5143\306B\623B\3059')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104353614007308722)
,p_name=>'UTR.UPLOAD'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30C3\30D7\30ED\30FC\30C9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104353771495308722)
,p_name=>'UTR.UPLOAD_CONFIG_FILE'
,p_message_language=>'ja'
,p_message_text=>unistr('\69CB\6210\30D5\30A1\30A4\30EB\306E\30A2\30C3\30D7\30ED\30FC\30C9')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103763570231308218)
,p_name=>'V.ALIAS_CONVERSION_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('ERR-1812 \30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5225\540D(%0)\3092\5909\63DB\4E2D\306B\4E88\671F\3057\306A\3044\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104752550111309044)
,p_name=>'VALIDATION_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103544724328308048)
,p_name=>'VIEW ALL PAGE GROUPS'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\306E\30DA\30FC\30B8\30FB\30B0\30EB\30FC\30D7\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103544879283308048)
,p_name=>'VIEW ALL PAGE TYPES'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\306E\30DA\30FC\30B8\30FB\30BF\30A4\30D7\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103692319062308160)
,p_name=>'VIEWS2'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D3\30E5\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104292788142308677)
,p_name=>'VIEW_DEBUG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D0\30C3\30B0\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103567707714308064)
,p_name=>'VIEW_DETAILS'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A73\7D30\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104136972520308547)
,p_name=>'VIEW_FOR_ALT_TAG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D3\30E5\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103562773428308061)
,p_name=>'VIEW_FOR_PRINTING'
,p_message_language=>'ja'
,p_message_text=>unistr('\5370\5237\7528\30D3\30E5\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104321241008308698)
,p_name=>'VIEW_HISTORY'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C65\6B74\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104711661429309010)
,p_name=>'VIEW_IN_BUILDER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D3\30E5\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103750951554308208)
,p_name=>'VIEW_IN_PAREN'
,p_message_language=>'ja'
,p_message_text=>unistr('(\30D3\30E5\30FC)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104742301268309036)
,p_name=>'VIEW_LOCK_HISTORY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30C3\30AF\5C65\6B74\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104673165720308978)
,p_name=>'VIEW_OUTPUT_OF_XML_DEMO'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306ESQL\554F\5408\305B\306F\3001<strong>\300CXML\306E\8868\793A\300D</strong>\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3059\308B\3068\8868\793A\3055\308C\308BXML\306E\751F\6210\306B\4F7F\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103545381774308048)
,p_name=>'VIEW_PAGES_OF_THIS_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30BF\30A4\30D7\306E\30DA\30FC\30B8\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104316301583308694)
,p_name=>'VIEW_PAGE_HISTORY'
,p_message_language=>'ja'
,p_message_text=>unistr('"%0"\30DA\30FC\30B8\306E\5909\66F4\5C65\6B74\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103657530191308134)
,p_name=>'VIEW_USER_ACTIVITY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30C6\30A3\30D3\30C6\30A3\306E\8868\793A: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104065125225308487)
,p_name=>'VPD'
,p_message_language=>'ja'
,p_message_text=>unistr('\4EEE\60F3\30D7\30E9\30A4\30D9\30FC\30C8\30FB\30C7\30FC\30BF\30D9\30FC\30B9(VPD)')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104077166434308497)
,p_name=>'WAITING.APP_DEFINITION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30A4\30F3\30B9\30C8\30FC\30EB\4E2D...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104758376264309049)
,p_name=>'WAITING.APP_REMOVAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\524A\9664\4E2D...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104758588865309049)
,p_name=>'WAITING.APP_UNLOCK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30ED\30C3\30AF\89E3\9664\4E2D...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104758413529309049)
,p_name=>'WAITING.APP_UPDATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\66F4\65B0\4E2D...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104077217341308498)
,p_name=>'WAITING.GENERIC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30AF\30A8\30B9\30C8\306E\51E6\7406\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104077389238308498)
,p_name=>'WAITING.SUPPORTING_OBJECTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30DD\30FC\30C8\3059\308B\30AA\30D6\30B8\30A7\30AF\30C8\306E\30A4\30F3\30B9\30C8\30FC\30EB\4E2D')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104186734896308598)
,p_name=>'WARNING_MISSING_CLASS'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E00\81F4\3059\308B\30AF\30E9\30B9\304C\3042\308A\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104186616739308598)
,p_name=>'WARNING_MULTIPLE_MATCHES'
,p_message_language=>'ja'
,p_message_text=>unistr('\8907\6570\4E00\81F4\3057\307E\3057\305F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103532011217308039)
,p_name=>'WEB.SOURCE.ADD_FROM_CATALOG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30FC\30D3\30B9\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103533032482308039)
,p_name=>'WEB.SOURCE.SERVICE_FROM_CATALOG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30BF\30ED\30B0\304B\3089\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103532838231308039)
,p_name=>'WEB.SOURCE.UNADD_FROM_CATALOG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30FC\30D3\30B9\306E\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103998775786308434)
,p_name=>'WEBSHEET'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B7\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104029313032308458)
,p_name=>'WEBSHEET ATTACHMENTS'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B7\30FC\30C8\306E\6DFB\4ED8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104738721384309033)
,p_name=>'WEBSHEET.ANYCO.SAMPLE.APP'
,p_message_language=>'ja'
,p_message_text=>unistr('AnyCo IT\90E8\9580')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104738662560309033)
,p_name=>'WEBSHEET.ANYCO.SAMPLE.APP.DESCR'
,p_message_language=>'ja'
,p_message_text=>unistr('AnyCo IT\90E8\9580\3067\306F\3001Web\30D9\30FC\30B9\306E\30B3\30F3\30C6\30F3\30C4\5171\6709\3068\30D3\30B8\30CD\30B9\30FB\30AF\30EA\30C6\30A3\30AB\30EB\306A\30C7\30FC\30BF\306E\30EC\30DD\30FC\30C8\306B\3064\3044\3066\3001Web\30B7\30FC\30C8\306E\6A5F\80FD\306E\4F7F\7528\65B9\6CD5\3092\91CD\70B9\7684\306B\8AAC\660E\3057\307E\3059\3002\3053\306E\30B5\30F3\30D7\30EBWeb\30B7\30FC\30C8\306F\3001\3044\304F\3064\304B\306E\30C7\30FC\30BF\30FB\30B0\30EA\30C3\30C9\3092\542B\307F\3001\57CB\8FBC\307F\306E\30EC\30DD\30FC\30C8\304A\3088\3073\30C1\30E3\30FC\30C8\306B\30C7\30FC\30BF\3092\8FFD\52A0\3059\308B\65B9\6CD5\3092\8AAC\660E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104684433171308986)
,p_name=>'WEBSHEET.DEMO.SAMPLE.APP'
,p_message_language=>'ja'
,p_message_text=>'Big Cats'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104684748858308987)
,p_name=>'WEBSHEET.DEMO.SAMPLE.APP.DESCR'
,p_message_language=>'ja'
,p_message_text=>unistr('Big Cats\3067\306F\3001\30A4\30E1\30FC\30B8\306E\57CB\8FBC\307F\3084\30DA\30FC\30B8\30FB\30EA\30F3\30AF\306A\3069\3001Web\30B7\30FC\30C8\306E\69D8\3005\306A\7279\5FB4\3068\6A5F\80FD\3092\91CD\70B9\7684\306B\8AAC\660E\3057\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103598864502308087)
,p_name=>'WEBSHEETS'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B7\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104375248011308738)
,p_name=>'WEBSHEETS_FAQ_A1'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B7\30FC\30C8\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306F\30C6\30AD\30B9\30C8\3092\30C7\30FC\30BF\3068\7D44\307F\5408\305B\308BWeb\30DA\30FC\30B8\3067\69CB\6210\3055\308C\307E\3059\3002\3053\308C\306F\30E6\30FC\30B6\30FC\306B\3088\3063\3066\5B9A\7FA9\3055\308C\308B\975E\5E38\306B\52D5\7684\306A\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\3059\3002\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\306F\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30B3\30F3\30C8\30ED\30FC\30EB\3001\691C\7D22\6A5F\80FD\3084\3001\30D5\30A1\30A4\30EB\3001\30CE\30FC\30C8\304A\3088\3073\30BF\30B0\306A\3069\306E\6CE8\91C8\3092\8FFD\52A0\3059\308B\6A5F\80FD\304C\3042\308A\307E\3059\3002\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\5B89\5168\6027\306F\3001\30A2\30AF\30BB\30B9\5236\5FA1\30EA\30B9\30C8\3084\8907\6570\306E\7D44\8FBC\307F\8A8D\8A3C\30E2\30C7\30EB\3092\4F7F\7528\3059\308B\3053\3068\3067\7DAD\6301\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104375374274308738)
,p_name=>'WEBSHEETS_FAQ_A2'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30C8\30EA\30D3\30E5\30FC\30BF\306E\30B0\30EB\30FC\30D7\306FWeb\30B7\30FC\30C8\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\5229\7528\3059\308B\3053\3068\3067\3001Web\30D6\30E9\30A6\30B6\306E\307F\3092\4F7F\7528\3057\3066\60C5\5831\30DA\30FC\30B8(\30EC\30DD\30FC\30C8\3084\30C1\30E3\30FC\30C8\306A\3069)\3092\8FC5\901F\306B\4F5C\6210\3067\304D\307E\3059\3002\30E6\30FC\30B6\30FC\306F\30C6\30AD\30B9\30C8\3068\30ED\30FC\30AB\30EB\30FB\30C7\30FC\30BF(\30C7\30FC\30BF\30FB\30B0\30EA\30C3\30C9\3068\547C\3070\308C\308B)\3092\7C21\5358\306B\7BA1\7406\3067\304D\308B\3060\3051\3067\306A\304F\3001SQL\554F\5408\305B\3067\30C7\30FC\30BF\3092\8868\793A\3059\308B\3053\3068\3082\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104375477028308738)
,p_name=>'WEBSHEETS_FAQ_A3'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B7\30FC\30C8\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\306FWIKI\3068\540C\69D8\306E\6A5F\80FD\304C\3042\308A\307E\3059\304C\3001\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306F\30C7\30FC\30BF\306E\7D71\5408\304A\3088\3073\8868\793A\306B\9069\3057\3066\3044\307E\3059\3002\305F\3068\3048\3070\3001\8868\5F62\5F0F\60C5\5831\3092\683C\7D0D\3059\308B\30C7\30FC\30BF\30FB\30B0\30EA\30C3\30C9\3084\3001\65E2\5B58\306E\8868\306B\5BFE\3059\308B\30EC\30DD\30FC\30C8\3092\5B9A\7FA9\3057\305F\308A\3001\307E\305F\306F\5358\7D14\306BSQL\30BF\30B0\3092\4F7F\7528\3057\3066\30DA\30FC\30B8\5185\306E\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30C7\30FC\30BF\3092\8868\793A\3059\308B\3053\3068\304C\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104375516517308738)
,p_name=>'WEBSHEETS_FAQ_A4'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30B0\30EA\30C3\30C9\306F\30B9\30D7\30EC\30C3\30C9\30B7\30FC\30C8\306B\985E\4F3C\3057\305FWeb\30B7\30FC\30C8\30FB\30B3\30F3\30DD\30FC\30CD\30F3\30C8\3067\3001\8868\5F62\5F0F\60C5\5831\306E\7C21\5358\306A\7BA1\7406\306B\5F79\7ACB\3061\307E\3059\3002\5927\304D\306A\9055\3044\306F\30D5\30A1\30A4\30EB\306B\30ED\30FC\30AB\30EB\3067\683C\7D0D\3055\308C\308B\306E\3067\306F\306A\304F\3001\3059\3079\3066\306EWeb\30B7\30FC\30C8\30FB\30C7\30FC\30BF\304COracle Database\5185\3067\4E00\5143\7684\306B\683C\7D0D\3055\308C\308B\3053\3068\3067\3059\3002\30C7\30FC\30BF\30FB\30B0\30EA\30C3\30C9\3092\4F7F\7528\3059\308B\3068\3001\30D5\30A1\30A4\30EB\3001\30CE\30FC\30C8\3001\30BF\30B0\304A\3088\3073\30EA\30F3\30AF\306A\3069\306E\6CE8\91C8\3092\30C7\30FC\30BF\306E\5404\884C\306B\8FFD\52A0\3067\304D\307E\3059\3002\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\691C\7D22\3092\4F7F\7528\3057\3066\3059\3079\3066\306E\30C7\30FC\30BF\304C\691C\7D22\53EF\80FD\3067\3042\308B\3053\3068\3082\3001\3082\30461\3064\306E\5229\70B9\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104375952556308738)
,p_name=>'WEBSHEETS_FAQ_A5'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30E6\30FC\30B6\30FC\306FSQL\30BF\30B0\3092\5229\7528\3057\3066\3001 \30C7\30FC\30BF\30D9\30FC\30B9\8868\306B\5BFE\3057\3066\8A18\8FF0\3055\308C\305FSQL\6587\306B\57FA\3065\3044\3066\3001\30EC\30DD\30FC\30C8\3092\30DA\30FC\30B8\306B\7C21\5358\306B\57CB\3081\8FBC\3080\3053\3068\304C\3067\304D\307E\3059\3002SQL\3092\4F7F\7528\3059\308B\3068\3001\30E6\30FC\30B6\30FC\306F\76EE\7684\306E\8868\304B\3089\76F4\63A5\3001\30C7\30FC\30BF\3092\7C21\5358\306B\53D6\5F97\3067\304D\307E\3059\3002\305F\3068\3048\3070\3001\671F\9650\3092\904E\304E\305F\30AA\30FC\30D7\30F3\30FB\30D0\30B0\3092\898B\3064\3051\308B\306B\306F\6B21\306E\30BF\30B0\3092\4F7F\7528\3057\307E\3059: '),
'<pre>[[SQL: select * from bugs where due_date < sysdate and status = ''OPEN'']] </pre>',
unistr('\3053\306E\554F\5408\305B\306F\30DA\30FC\30B8\304C\8868\793A\3055\308C\308B\305F\3073\306B\5B9F\884C\3055\308C\308B\305F\3081\3001\3042\308B\6642\70B9\306E\4E00\822C\7684\306A\30B9\30CA\30C3\30D7\30B7\30E7\30C3\30C8\3067\306F\306A\304F\3001\52D5\7684\306A\30C7\30FC\30BF\304C\63D0\4F9B\3055\308C\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104375653646308738)
,p_name=>'WEBSHEETS_FAQ_A6'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Web\30B7\30FC\30C8\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\306F\30B3\30F3\30C6\30F3\30C4\306E\5171\6709\304C\5BB9\6613\3067\3001\7565\5F0F\306E\57FA\672C\7684\306A\30EC\30DD\30FC\30C8\4F5C\6210\304C\53EF\80FD\3067\3059\3002Web\30B7\30FC\30C8\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\69CB\9020\304A\3088\3073\30B3\30F3\30C6\30F3\30C4\306F\3059\3079\3066\3001\30E6\30FC\30B6\30FC(\30B3\30F3\30C8\30EA\30D3\30E5\30FC\30BF\304A\3088\3073\7BA1\7406\8005)\306B\3088\3063\3066\7BA1\7406\3055\308C\307E\3059\3002\5BFE\7167\7684\306B\3001\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306F\3088\308A\6B63\5F0F\306A\3001\8907\96D1\304B\3064\5C02\9580\7684\306A\30C7\30FC\30BF\30FB\30E1\30F3\30C6\30CA\30F3\30B9\304A\3088\3073\30EC\30DD\30FC\30C8\4F5C\6210\306E\305F\3081\306B\4F7F\7528\3055\308C\307E\3059\3002\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\69CB\9020\306F\7BA1\7406\8005\306B\3088\3063\3066\7BA1\7406\3055\308C\307E\3059\304C\3001\30B3\30F3\30C6\30F3\30C4\306F\4E00\822C\7684\306B\30A8\30F3\30C9\30E6\30FC\30B6\30FC\304C\7BA1\7406\3057\307E\3059\3002'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104374748001308737)
,p_name=>'WEBSHEETS_FAQ_Q1'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B7\30FC\30C8\3068\306F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104374937212308737)
,p_name=>'WEBSHEETS_FAQ_Q2'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B7\30FC\30C8\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\4F5C\6210\3059\308B\7406\7531')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104375026340308737)
,p_name=>'WEBSHEETS_FAQ_Q3'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B7\30FC\30C8\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304CWIKI\3068\306F\7570\306A\308B\7406\7531')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104375189081308738)
,p_name=>'WEBSHEETS_FAQ_Q4'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B7\30FC\30C8\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306F\30AA\30F3\30E9\30A4\30F3\306E\30B9\30D7\30EC\30C3\30C9\30B7\30FC\30C8\304B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104376027890308738)
,p_name=>'WEBSHEETS_FAQ_Q5'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\30BF\30B0\3068\306F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104374840379308737)
,p_name=>'WEBSHEETS_FAQ_Q6'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B7\30FC\30C8\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304C\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3068\306F\7570\306A\308B\7406\7531')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103657646012308134)
,p_name=>'WEBSHEETS_NOT_INSTALLED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30DD\30FC\30CD\30F3\30C8\304C\30A4\30F3\30B9\30C8\30FC\30EB\3055\308C\3066\3044\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104760470408309051)
,p_name=>'WEBSHEET_ACCESS_CONTROL'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B7\30FC\30C8\30FB\30A2\30AF\30BB\30B9\30FB\30B3\30F3\30C8\30ED\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104739499251309034)
,p_name=>'WEBSHEET_APPLICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B7\30FC\30C8\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103583492158308076)
,p_name=>'WEBSHEET_APPLICATIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B7\30FC\30C8\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104326858383308702)
,p_name=>'WEBSHEET_APPLICATION_NOT_AVAILABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3%0\306F\73FE\5728\4F7F\7528\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104030401091308459)
,p_name=>'WEBSHEET_ATTACHMENTS'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B7\30FC\30C8\306E\6DFB\4ED8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104321320137308698)
,p_name=>'WEBSHEET_CONTENT_LAST_UPDATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30C6\30F3\30C4\306F%0\306B%1\306B\3088\308A\6700\7D42\66F4\65B0\3055\308C\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104321418156308698)
,p_name=>'WEBSHEET_CREATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306F%0\306B%1\306B\3088\308A\4F5C\6210\3055\308C\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104684867867308987)
,p_name=>'WEBSHEET_INSTALLATION_MESSAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30F3\30D7\30EBWeb\30B7\30FC\30C8\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\30A4\30F3\30B9\30C8\30FC\30EB\3057\3088\3046\3068\3057\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104753381613309045)
,p_name=>'WEBSHEET_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B7\30FC\30C8: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104313770814308692)
,p_name=>'WEBSHEET_LAST_UPDATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306F%0\306B%1\306B\3088\308A\6700\7D42\66F4\65B0\3055\308C\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104029267901308458)
,p_name=>'WEBSHEET_NON_BLOB_DATA'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B7\30FC\30C8\306E\975EBLOB\30C7\30FC\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104724446655309020)
,p_name=>'WEBSHEET_OBJECTS_NOT_VALID'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B7\30FC\30C8\30FB\30AA\30D6\30B8\30A7\30AF\30C8\304C\7121\52B9\3067\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104074055764308495)
,p_name=>'WEBSHEET_SUCCESS_MSG'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B7\30FC\30C8\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3%0\304C\30A4\30F3\30B9\30C8\30FC\30EB\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104338387664308710)
,p_name=>'WEBSHEET_TABLE_ACCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\30AA\30D6\30B8\30A7\30AF\30C8\306FSQL\30DE\30FC\30AF\30A2\30C3\30D7\30FB\30BF\30B0\3092\4F7F\7528\3057\3066\554F\5408\305B\3059\308B\304B\3001\30EC\30DD\30FC\30C8\5185\304B\3089\4F7F\7528\53EF\80FD\3067\3059\3002\5927/\5C0F\6587\5B57\3092\533A\5225\3059\308B\30AA\30D6\30B8\30A7\30AF\30C8\540D\3092\7279\5B9A\3059\308B\306B\306F\4E8C\91CD\5F15\7528\7B26\3092\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104027702079308457)
,p_name=>'WEBSHEET_VIEWS'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B7\30FC\30C8\30FB\30DA\30FC\30B8\30FB\30D3\30E5\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104058673309308482)
,p_name=>'WEB_SERVICE'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B5\30FC\30D3\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103753190517308210)
,p_name=>'WEB_SERVICE_RESULT'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B5\30FC\30D3\30B9\306E\7D50\679C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103518594130308029)
,p_name=>'WEB_SOURCE.NATIVE_ADFBC'
,p_message_language=>'ja'
,p_message_text=>'Oracle Cloud Applications (SaaS) REST Service'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103518380456308029)
,p_name=>'WEB_SOURCE.NATIVE_HTTP'
,p_message_language=>'ja'
,p_message_text=>unistr('\7C21\6613HTTP')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103518674396308029)
,p_name=>'WEB_SOURCE.NATIVE_OCI'
,p_message_language=>'ja'
,p_message_text=>'Oracle Cloud Infrastructure (OCI)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103518423943308029)
,p_name=>'WEB_SOURCE.NATIVE_ORDS'
,p_message_language=>'ja'
,p_message_text=>'Oracle REST Data Services'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103578668630308072)
,p_name=>'WELCOME_TEXT_4700_P1'
,p_message_language=>'ja'
,p_message_text=>unistr('Oracle APEX\30EF\30FC\30AF\30B9\30DA\30FC\30B9\3092\30EA\30AF\30A8\30B9\30C8\3059\308B\306B\306F\3001\3053\306E\767B\9332\30A6\30A3\30B6\30FC\30C9\3092\5B8C\4E86\3057\3066\304F\3060\3055\3044\3002')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104070194087308492)
,p_name=>'WHITE_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\767D\8272\306E\30C6\30AD\30B9\30C8')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103611248861308096)
,p_name=>'WITHIN_NEXT_1_DAY'
,p_message_language=>'ja'
,p_message_text=>unistr('\4ECA\5F8C1\65E5\4EE5\5185')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104678122033308981)
,p_name=>'WITHIN_NEXT_X_DAYS'
,p_message_language=>'ja'
,p_message_text=>unistr('\4ECA\5F8C%0\65E5\4EE5\5185')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104030201392308459)
,p_name=>'WITH_ADMIN'
,p_message_language=>'ja'
,p_message_text=>'WITH ADMIN OPTION'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103753535619308210)
,p_name=>'WITH_SHORTCUTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30E7\30FC\30C8\30AB\30C3\30C8\4ED8\304D')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104135911917308546)
,p_name=>'WIZ.RESERVE_PAGE.PAGE_ID.EXISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\756A\53F7\306F\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\3059\3067\306B\5B58\5728\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104135335693308546)
,p_name=>'WIZ.RESERVE_PAGE.PAGE_ID.RESERVED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\756A\53F7\306F\4E88\7D04\3055\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103786600306308237)
,p_name=>'WIZAPI_DELETE_CHECKED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30A7\30C3\30AF\3057\305F\9805\76EE\306E\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103663648726308138)
,p_name=>'WIZARD.BUILD_OPTION.COMMENTED_OUT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30E1\30F3\30C8\30FB\30A2\30A6\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103521156325308031)
,p_name=>'WIZARD.CLEAR_CACHE_PROCESS_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306E\30EA\30BB\30C3\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104558925354308886)
,p_name=>'WIZARD.CREATE.FS.CARD_COLUMNS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30FC\30C9\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103534521438308040)
,p_name=>'WIZARD.CREATE.PAGE.CARDS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30FC\30C9\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104362090626308728)
,p_name=>'WIZARD.CREATE.PAGE.CLASSIC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30E9\30B7\30C3\30AF\30FB\30EC\30DD\30FC\30C8\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104327273395308702)
,p_name=>'WIZARD.CREATE.PAGE.FACETED_SEARCH'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30BB\30C3\30C8\691C\7D22\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104362564573308728)
,p_name=>'WIZARD.CREATE.PAGE.FORMNLISTVIEW'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30FC\30E0\3068\30EA\30B9\30C8\30FB\30D3\30E5\30FC\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104362923571308729)
,p_name=>'WIZARD.CREATE.PAGE.FORMONPROCEDURE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30B7\30FC\30B8\30E3\306E\30D5\30A9\30FC\30E0\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104362860221308729)
,p_name=>'WIZARD.CREATE.PAGE.FORMONSQL'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B\306E\30D5\30A9\30FC\30E0\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104362710726308728)
,p_name=>'WIZARD.CREATE.PAGE.FORMONTABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30FC\30E0\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104737080239309032)
,p_name=>'WIZARD.CREATE.PAGE.FORMONWEBSERVICE'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B5\30FC\30D3\30B9\306E\30D5\30A9\30FC\30E0\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103541499058308045)
,p_name=>'WIZARD.CREATE.PAGE.FS.FACET'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30BB\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104361953653308728)
,p_name=>'WIZARD.CREATE.PAGE.GRID'
,p_message_language=>'ja'
,p_message_text=>unistr('\5BFE\8A71\30B0\30EA\30C3\30C9\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104361889231308728)
,p_name=>'WIZARD.CREATE.PAGE.INTERACTIVE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103532742820308039)
,p_name=>'WIZARD.CREATE.PAGE.MAP_REGION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30C3\30D7\30FB\30DA\30FC\30B8\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104362160240308728)
,p_name=>'WIZARD.CREATE.PAGE.MD'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30B9\30BF\30FC\30FB\30C7\30A3\30C6\30FC\30EB\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104362329453308728)
,p_name=>'WIZARD.CREATE.PAGE.REPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104362496697308728)
,p_name=>'WIZARD.CREATE.PAGE.REPORTWFORM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30FC\30E0\4ED8\304D\30EC\30DD\30FC\30C8\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103540313488308045)
,p_name=>'WIZARD.CREATE.PAGE.SMART_FILTERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30DE\30FC\30C8\30FB\30D5\30A3\30EB\30BF\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103541594644308045)
,p_name=>'WIZARD.CREATE.PAGE.SMART_FILTERS.FILTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30EB\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104362613924308728)
,p_name=>'WIZARD.CREATE.PAGE.TABULARFORM'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\5F62\5F0F\30D5\30A9\30FC\30E0\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104362231786308728)
,p_name=>'WIZARD.CREATE.PAGE.WEBSERVICE'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B5\30FC\30D3\30B9\306E\30EC\30DD\30FC\30C8\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103706611209308173)
,p_name=>'WIZARD.CREATE_PAGE.UT.REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A6\30A3\30B6\30FC\30C9\3067\306F\3001\30E6\30CB\30D0\30FC\30B5\30EB\30FB\30C6\30FC\30DE\30FB\30D9\30FC\30B9\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304C\5FC5\8981\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103520603799308030)
,p_name=>'WIZARD.FORM.DML_PROCESS_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30BB\30B9\30FB\30D5\30A9\30FC\30E0%0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103520579423308030)
,p_name=>'WIZARD.FORM.INIT_PROCESS_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\521D\671F\5316\30D5\30A9\30FC\30E0%0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104117499515308531)
,p_name=>'WIZARD.FORM.QUERY'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104117373985308531)
,p_name=>'WIZARD.FORM.TABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104131166447308542)
,p_name=>'WIZARD.IG.DML_PROCESS_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('%0 - \5BFE\8A71\30B0\30EA\30C3\30C9\30FB\30C7\30FC\30BF\306E\4FDD\5B58')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104123956956308536)
,p_name=>'WIZARD.REPORT.CLASSIC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30E9\30B7\30C3\30AF\30FB\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104123868794308536)
,p_name=>'WIZARD.REPORT.GRID'
,p_message_language=>'ja'
,p_message_text=>unistr('\5BFE\8A71\30B0\30EA\30C3\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104123733441308536)
,p_name=>'WIZARD.REPORT.INTERACTIVE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104124152553308536)
,p_name=>'WIZARD.REPORT.REPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104124088664308536)
,p_name=>'WIZARD.REPORT.WEBSERVICE'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B5\30FC\30D3\30B9\306E\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103727116052308189)
,p_name=>'WIZARD.VALIDATION.PAGE_ITEM_IS_REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('#LABEL#\306B\5024\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104047877737308473)
,p_name=>'WIZARD.VALIDATION.PAGE_LEVEL_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104047713578308473)
,p_name=>'WIZARD.VALIDATION.TABFORM_COLUMN_IS_REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('#COLUMN_HEADER#\306B\5024\304C\5FC5\8981\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104081299251308501)
,p_name=>'WIZARD_PAGES_SUCCESS_MSG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A6\30A3\30B6\30FC\30C9\30FB\30DA\30FC\30B8\304C\6B63\5E38\306B\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104788012690309079)
,p_name=>'WIZARD_PROGRESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A6\30A3\30B6\30FC\30C9\9032\6357')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104066535639308489)
,p_name=>'WIZARD_REPORT_SUCCESS_MSG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A6\30A3\30B6\30FC\30C9\30FB\30EC\30DD\30FC\30C8\30FB\30DA\30FC\30B8\304C\6B63\5E38\306B\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103755282731308212)
,p_name=>'WORKSPACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104055152389308479)
,p_name=>'WORKSPACE IMAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\30FB\30A4\30E1\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104117620502308531)
,p_name=>'WORKSPACES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104026563241308456)
,p_name=>'WORKSPACE_APPLICATIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104026845878308456)
,p_name=>'WORKSPACE_APPLICATION_ACTIVITY_SUMMARY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30AF\30C6\30A3\30D3\30C6\30A3\30FB\30B5\30DE\30EA\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104669326074308974)
,p_name=>'WORKSPACE_COUNT'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104025837453308455)
,p_name=>'WORKSPACE_ID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104337979714308710)
,p_name=>'WORKSPACE_IMAGES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\30FB\30A4\30E1\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104118122023308531)
,p_name=>'WORKSPACE_INITCAP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103936505745308387)
,p_name=>'WORKSPACE_INIT_CAP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103595598995308084)
,p_name=>'WORKSPACE_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103564652964308062)
,p_name=>'WORKSPACE_LOGIN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\30FB\30ED\30B0\30A4\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104263276744308655)
,p_name=>'WORKSPACE_MESSAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\30FB\30E1\30C3\30BB\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104025624887308455)
,p_name=>'WORKSPACE_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104174537088308588)
,p_name=>'WORKSPACE_OVERRIDE_ID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306E\30AA\30FC\30D0\30FC\30E9\30A4\30C9ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104058036692308482)
,p_name=>'WORKSPACE_REQUEST'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\30FB\30EA\30AF\30A8\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104026448421308456)
,p_name=>'WORKSPACE_SCHEMAS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\30FB\30B9\30AD\30FC\30DE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103614682342308098)
,p_name=>'WORKSPACE_SIGNUP_SUCCESS_01'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30EA\30AF\30A8\30B9\30C8\304C\627F\8A8D\3055\308C\308B\3068\3001\30EF\30FC\30AF\30B9\30DA\30FC\30B9\3092\30A2\30AF\30C6\30A3\30D6\5316\3059\308B\305F\3081\306E\96FB\5B50\30E1\30FC\30EB\304C\9001\4FE1\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104117828385308531)
,p_name=>'WORKSPACE_USERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\30FB\30E6\30FC\30B6\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104030391082308459)
,p_name=>'WORKSPACE_WEBSHEETS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9Web\30B7\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104026175770308456)
,p_name=>'WORKSPACE_WORKSPACE_SUMMARY'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\30EF\30FC\30AF\30B9\30DA\30FC\30B9\30FB\30B5\30DE\30EA\30FC')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104002156160308437)
,p_name=>'WORK_INITIATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F5C\696D\958B\59CB\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104002274472308437)
,p_name=>'WORK_PROGRESSING'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F5C\696D\9032\884C\4E2D')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104010235597308443)
,p_name=>'WRITING'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F8\8FBC\307F\4E2D')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104673548767308978)
,p_name=>'WS.CAPABILITY'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A5F\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104673458620308978)
,p_name=>'WS.READER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30C0\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104065913314308488)
,p_name=>'WSDL_SUCCESS_MSG'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B5\30FC\30D3\30B9\53C2\7167\304C\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3%0\306B\8FFD\52A0\3055\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103555064346308055)
,p_name=>'WS_ACCESS_CONTROL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30BB\30B9\5236\5FA1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104299021705308681)
,p_name=>'WS_ADD_FILE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104737239581309032)
,p_name=>'WS_ADD_FILE_NOT_ENOUGH_SPACE_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\3092\8FFD\52A0\3067\304D\308B\5341\5206\306A\9818\57DF\304C\3042\308A\307E\305B\3093\3067\3057\305F\3002\7BA1\7406\30DA\30FC\30B8\306B\79FB\52D5\3057\3066\8FFD\52A0\306E\8A18\61B6\57DF\3092\30EA\30AF\30A8\30B9\30C8\3057\3001\7BA1\7406\30B5\30FC\30D3\30B9\306B\79FB\52D5\3057\3066\30EA\30AF\30A8\30B9\30C8\300C\8A18\61B6\57DF\306E\30EA\30AF\30A8\30B9\30C8\300D\3092\30AF\30EA\30C3\30AF\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104322404830308699)
,p_name=>'WS_ADD_LINK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30F3\30AF\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104357307890308724)
,p_name=>'WS_ADD_NEW'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104322539508308699)
,p_name=>'WS_ADD_NOTE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CE\30FC\30C8\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104321984212308698)
,p_name=>'WS_ADD_ROW'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104322395951308699)
,p_name=>'WS_ADD_TAGS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30B0\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104366548028308731)
,p_name=>'WS_ADD_VALIDATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103554849487308055)
,p_name=>'WS_ADMINISTRATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104298689676308681)
,p_name=>'WS_ALIAS_NOT_NULL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5225\540D\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103547319614308050)
,p_name=>'WS_ALIAS_NOT_VALID'
,p_message_language=>'ja'
,p_message_text=>unistr('\5225\540D\306B\306F\82F1\6570\5B57\3092\4F7F\7528\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103558582549308058)
,p_name=>'WS_ALIAS_TOO_LONG'
,p_message_language=>'ja'
,p_message_text=>unistr('\5225\540D\304C\9577\3059\304E\307E\3059\3002\5236\9650\306F255\6587\5B57\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104363555385308729)
,p_name=>'WS_ALL_ROWS'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\306E\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104357490793308725)
,p_name=>'WS_ANNOTATIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6CE8\91C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103554969057308055)
,p_name=>'WS_APPLICATION_PROPERTIES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30D7\30ED\30D1\30C6\30A3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104372012797308735)
,p_name=>'WS_CANNOT_USE_LOV'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3057\305F\8868\793A\30BF\30A4\30D7\306FLOV\3092\4F7F\7528\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104374403388308737)
,p_name=>'WS_CHANGED'
,p_message_language=>'ja'
,p_message_text=>unistr('\5909\66F4\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104358841595308726)
,p_name=>'WS_CHANGE_COLUMN_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\30BF\30A4\30D7\306E\5909\66F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104374631024308737)
,p_name=>'WS_CHG_WS_RPT_QRY_HLP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\554F\5408\305B\306E\5909\66F4\3092\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002\554F\5408\305B\306B\5217\3092\8FFD\52A0\3057\305F\5834\5408\3001\30EC\30DD\30FC\30C8\306E\5B9F\884C\6642\306B\306F\8868\793A\3055\308C\307E\305B\3093\3002\30A2\30AF\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC\3092\4F7F\7528\3057\3066\3001\5217\3092\9078\629E\3059\308B\304B<strong>\300C\30EA\30BB\30C3\30C8\300D</strong>\3092\30AF\30EA\30C3\30AF\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\554F\5408\305B\304B\3089\5217\3092\524A\9664\3057\305F\5834\5408\3001\65E2\5B58\306E\30D5\30A3\30EB\30BF\3001\30CF\30A4\30E9\30A4\30C8\898F\5247\3001\304A\3088\3073\305D\306E\5217\3092\53C2\7167\3059\308B\4ED6\306E\30EC\30DD\30FC\30C8\8A2D\5B9A\304C\7121\52B9\306B\306A\308A\307E\3059\3002\30EA\30AF\30A8\30B9\30C8\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103552441808308053)
,p_name=>'WS_CHOOSE_FILE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\306E\9078\629E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104359357602308726)
,p_name=>'WS_COLUMN_ALIGNMENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\306E\4F4D\7F6E\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104322204033308699)
,p_name=>'WS_COLUMN_GROUPS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\30B0\30EB\30FC\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104733879744309030)
,p_name=>'WS_COLUMN_NAME_NOT_UNIQUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\540D\306F\3059\3067\306B\5B58\5728\3057\3066\3044\307E\3059\3002\5225\306E\540D\524D\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104322183503308698)
,p_name=>'WS_COLUMN_PROPERTIES'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\30D7\30ED\30D1\30C6\30A3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104360366503308727)
,p_name=>'WS_COL_CONFIRM_DELETE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\524A\9664\64CD\4F5C\306E\5B9F\884C\306E\78BA\8A8D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104371808047308735)
,p_name=>'WS_COL_LABEL_MUST_BE_SPEC'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\30E9\30D9\30EB\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104373168725308736)
,p_name=>'WS_COL_MUST_BE_SEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024\3092\5909\66F4\3059\308B\5217\3092\9078\629E\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104373370686308736)
,p_name=>'WS_COL_MUST_BE_SEL_REP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024\3092\7F6E\304D\63DB\3048\308B\5217\3092\9078\629E\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104372443128308736)
,p_name=>'WS_COL_NAME_MUST_BE_SPEC'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\540D\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104371797220308735)
,p_name=>'WS_COL_SEL_TO_EDIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7DE8\96C6\3059\308B\5217\3092\9078\629E\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104372562898308736)
,p_name=>'WS_COL_SEL_TO_REMOVE'
,p_message_language=>'ja'
,p_message_text=>unistr('\524A\9664\3059\308B\5217\3092\9078\629E\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104358374493308725)
,p_name=>'WS_COMMA_SEP_LIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30F3\30DE\533A\5207\308A\30EA\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104360066632308726)
,p_name=>'WS_COMMA_SEP_LIST2'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30F3\30DE\533A\5207\308A\30EA\30B9\30C8\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104371499864308735)
,p_name=>'WS_CONF_DELETE'
,p_message_language=>'ja'
,p_message_text=>unistr('\524A\9664\3059\308B\3053\3068\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104747252683309040)
,p_name=>'WS_CONTROL_PANEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30C8\30ED\30FC\30EB\30FB\30D1\30CD\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104670336392308975)
,p_name=>'WS_COPY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30D4\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104284935046308671)
,p_name=>'WS_COPY_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30D4\30FC\306E\65B0\898F\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104308078624308688)
,p_name=>'WS_CREATE_APP_CONFIRM'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\5C5E\6027\3092\6301\3064Web\30B7\30FC\30C8\3092\4F5C\6210\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002\9078\629E\5185\5BB9\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104284350176308670)
,p_name=>'WS_CREATE_CHART_SECTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\30FB\30BB\30AF\30B7\30E7\30F3\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104063327813308486)
,p_name=>'WS_CREATE_DATA_GRID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30B0\30EA\30C3\30C9\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104284482728308671)
,p_name=>'WS_CREATE_DATA_SECTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30BB\30AF\30B7\30E7\30F3\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104358592497308725)
,p_name=>'WS_CREATE_DATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\65E5\4ED8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104284605259308671)
,p_name=>'WS_CREATE_NAV_SECTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30BB\30AF\30B7\30E7\30F3\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104284899612308671)
,p_name=>'WS_CREATE_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103588523884308079)
,p_name=>'WS_CREATE_PLSQL_SECTION'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\30BB\30AF\30B7\30E7\30F3\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104284225819308670)
,p_name=>'WS_CREATE_SECTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30AF\30B7\30E7\30F3\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104284589004308671)
,p_name=>'WS_CREATE_TEXT_SECTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8\30FB\30BB\30AF\30B7\30E7\30F3\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104358626942308725)
,p_name=>'WS_CURRENT_USER'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\884C\30E6\30FC\30B6\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103554691974308055)
,p_name=>'WS_DASHBOARD'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C0\30C3\30B7\30E5\30DC\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103531913328308039)
,p_name=>'WS_DATA'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104044420900308471)
,p_name=>'WS_DATA_GRID_COLUMN_LIMIT_REACHED'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\30BF\30A4\30D7\3067\4F7F\7528\53EF\80FD\306A\5217\306E\6700\5927\6570\306B\9054\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104734051989309030)
,p_name=>'WS_DATA_GRID_DUP_COL_NAME_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\91CD\8907\3057\305F\5217\540D\304C\898B\3064\304B\308A\307E\3057\305F\3002\5217\540D\306F\4E00\610F\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104699494552309000)
,p_name=>'WS_DATA_GRID_NAME_NOT_UNIQUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30B0\30EA\30C3\30C9\540D\306F\3059\3067\306B\5B58\5728\3057\3066\3044\307E\3059\3002\5225\306E\540D\524D\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104358787951308726)
,p_name=>'WS_DEFAULT_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\30FB\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104358469763308725)
,p_name=>'WS_DEFAULT_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\30FB\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104760983714309051)
,p_name=>'WS_DEFINE_DATA_GRID_COLUMNS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30B0\30EA\30C3\30C9\5217\306E\5B9A\7FA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104360162199308727)
,p_name=>'WS_DELETE_COLUMNS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\306E\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104294048308308678)
,p_name=>'WS_DELETE_DATA_GRID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30B0\30EA\30C3\30C9\306E\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104364546931308730)
,p_name=>'WS_DELETE_ROWS'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\306E\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104360212172308727)
,p_name=>'WS_DEL_COL_DIALOG_HLP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\3068\3068\3082\306B\5B8C\5168\306B\524A\9664\3059\308B\5217\3092\9078\629E\3057\3066\304F\3060\3055\3044:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103577567385308071)
,p_name=>'WS_DGQ_FIRST_COL_MUST_BE_PK'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\30EA\30F3\30AF\306E\7DE8\96C6\307E\305F\306F\8FFD\52A0\3092\8868\793A\3059\308B\306B\306F\3001\6700\521D\306E\5217\30C7\30FC\30BF\30FB\30B0\30EA\30C3\30C9\306E\4E3B\30AD\30FC\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\4E3B\30AD\30FC\3092\542B\3081\308B\306B\306F\3001SELECT\6587\306E\6700\521D\306E\5217\3068\3057\3066"APXWS_DATA_GRID_PK"\7F6E\63DB\3092\8FFD\52A0\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103570896561308067)
,p_name=>'WS_DGQ_MORE_THAN_ONE_DATA_GRID'
,p_message_language=>'ja'
,p_message_text=>unistr('\554F\5408\305B\306F\3001\884C\30EA\30F3\30AF\306E\7DE8\96C6\307E\305F\306F\8FFD\52A0\3092\8868\793A\3059\308B\305F\3081\306B\3001\30C7\30FC\30BF\30FB\30B0\30EA\30C3\30C9\30921\5EA6\306E\307F\53C2\7167\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103577604684308071)
,p_name=>'WS_DGQ_MULTI_SELECT_STMT'
,p_message_language=>'ja'
,p_message_text=>unistr('\554F\5408\305B\306B\8907\6570\306ESELECT\6587\304C\542B\307E\308C\3066\3044\307E\3059\3002\884C\30EA\30F3\30AF\306E\7DE8\96C6\307E\305F\306F\8FFD\52A0\3092\8868\793A\3059\308B\306B\306F\3001SELECT\6587\306E\6700\521D\306E\5217\3068\3057\3066"APXWS_DATA_GRID_PK"\7F6E\63DB\3092\8FFD\52A0\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104376127973308738)
,p_name=>'WS_DGQ_SQLVALUE_EXAMPLE'
,p_message_language=>'ja'
,p_message_text=>unistr('SQLVALUE\30BF\30B0\69CB\6587:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104123230147308536)
,p_name=>'WS_DGQ_SQL_EXAMPLE'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\30BF\30B0\69CB\6587:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104357908792308725)
,p_name=>'WS_DISPLAY_AS'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\5F62\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104357807408308725)
,p_name=>'WS_DOCUMENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C9\30AD\30E5\30E1\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104298502582308681)
,p_name=>'WS_DUPLICATE_PK_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\540C\3058\5217\3092\4E3B\30AD\30FC\3068\3057\3066\9078\629E\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104357181129308724)
,p_name=>'WS_EDIT_ATTACHMENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6DFB\4ED8\306E\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104670402859308975)
,p_name=>'WS_EDIT_ATTRIBUTES'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C5E\6027\306E\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103553755158308054)
,p_name=>'WS_EDIT_FILE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\306E\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103553310449308054)
,p_name=>'WS_EDIT_NOTE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CE\30FC\30C8\306E\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104284757158308671)
,p_name=>'WS_EDIT_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306E\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104670525449308975)
,p_name=>'WS_EDIT_QUERY'
,p_message_language=>'ja'
,p_message_text=>unistr('\554F\5408\305B\306E\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104291949674308676)
,p_name=>'WS_EDIT_SECTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30AF\30B7\30E7\30F3\306E\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104355313430308723)
,p_name=>'WS_EDIT_SECTIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30AF\30B7\30E7\30F3\306E\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103553829138308054)
,p_name=>'WS_EDIT_TAG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30B0\306E\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103617615696308100)
,p_name=>'WS_EDIT_TAGS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30B0\306E\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103593854657308083)
,p_name=>'WS_EMAIL_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\30FB\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104360787810308727)
,p_name=>'WS_EMPTY_ROW'
,p_message_language=>'ja'
,p_message_text=>unistr('\7A7A\767D\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104292502681308677)
,p_name=>'WS_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC%0 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104370191988308734)
,p_name=>'WS_ERR_MESSAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104373831711308737)
,p_name=>'WS_ERR_MSG_MUST_BE_SPEC'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\300D\306B\5024\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104324347629308700)
,p_name=>'WS_FILE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104300192089308682)
,p_name=>'WS_FILES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104782622218309075)
,p_name=>'WS_FILE_REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\306B\5024\3092\542B\3081\308B\5FC5\8981\304C\3042\308A\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104364132180308729)
,p_name=>'WS_FILL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5165\529B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104364296471308730)
,p_name=>'WS_FILL_HLP'
,p_message_language=>'ja'
,p_message_text=>unistr('NULL\306E\5217\5024\306B\4E0A\306E\30BB\30EB\306E\5217\5024\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104363935513308729)
,p_name=>'WS_FIND_WHAT'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104279086221308667)
,p_name=>'WS_GETTING_STARTED_CONTENT'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Web\30B7\30FC\30C8\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\4F7F\7528\3059\308B\3068\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\958B\767A\8005\3092\5FC5\8981\3068\305B\305A\306B\3001\69CB\9020\5316\30C7\30FC\30BF\304A\3088\3073\975E\69CB\9020\5316\30C7\30FC\30BF\3092\7BA1\7406\3067\304D\307E\3059\3002Web\30B7\30FC\30C8\3092\4F7F\7528\3059\308B\3068\3001\6B21\306E\3053\3068\3092\5B9F\884C\3067\304D\307E\3059\3002'),
'<ul>',
unistr('<li>Web\30D6\30E9\30A6\30B6\3092\4F7F\7528\3057\3066\3001Web\4E0A\3067\30B3\30F3\30C6\30F3\30C4\3092\4F5C\6210\304A\3088\3073\5171\6709\3067\304D\307E\3059\3002</li>'),
unistr('<li>\968E\5C64\306E\3042\308B\30AF\30ED\30B9\30EA\30F3\30AF\30FB\30DA\30FC\30B8\306B\30DA\30FC\30B8\3092\69CB\6210\3067\304D\307E\3059\3002</li>'),
unistr('<li>\30C7\30FC\30BF\30FB\30B0\30EA\30C3\30C9\3068\547C\3070\308C\308B\57CB\8FBC\307F\6A5F\80FD\3092\4F7F\7528\3057\3066\3001\8868\5F62\5F0F\30C7\30FC\30BF\3092\4F5C\6210\304A\3088\3073\7BA1\7406\3067\304D\307E\3059\3002</li>'),
unistr('<li>\30C7\30FC\30BF\30D9\30FC\30B9\5185\306E\65E2\5B58\306E\30C7\30FC\30BF\69CB\9020\306B\304A\3044\3066\3001SQL\3092\4F7F\7528\3057\3066\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\3092\4F5C\6210\3057\307E\3059\3002</li>'),
unistr('<li>\30C1\30E3\30FC\30C8\307E\305F\306F\30EC\30DD\30FC\30C8\3068\3057\3066\3001\30DA\30FC\30B8\5185\306B\30C7\30FC\30BF\30FB\30B0\30EA\30C3\30C9\304A\3088\3073\30EC\30DD\30FC\30C8\30FB\30C7\30FC\30BF\3092\8868\793A\3067\304D\307E\3059\3002</li>'),
unistr('<li>\30DA\30FC\30B8\306B\30D5\30A1\30A4\30EB\3001\30BF\30B0\304A\3088\3073\30CE\30FC\30C8\3067\6CE8\91C8\3092\4ED8\3051\307E\3059\3002\95A2\9023\4ED8\3051\3089\308C\305F\30A4\30E1\30FC\30B8\3092\30DA\30FC\30B8\30FB\30B3\30F3\30C6\30F3\30C4\5185\306B\30A4\30F3\30E9\30A4\30F3\3067\8868\793A\3067\304D\307E\3059\3002</li>'),
unistr('<li>\30DA\30FC\30B8\30FB\30B3\30F3\30C6\30F3\30C4\3092\691C\7D22\3067\304D\307E\3059(\7D44\8FBC\307F\691C\7D22\6A5F\80FD\3092\4F7F\7528)\3002</li>'),
unistr('<li>\30ED\30B0\30A4\30F3\3067\304D\308B\30E6\30FC\30B6\30FC\306E\7BA1\7406\3002\30ED\30B0\30A4\30F3\5F8C\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\8AAD\53D6\308A/\66F8\8FBC\307F/\7BA1\7406\6A29\9650\3092\7BA1\7406\3067\304D\307E\3059(\8A8D\53EF\304A\3088\3073\8A8D\8A3C)\3002</li>'),
'</ul>',
unistr('<p>\8A73\7D30\306F\3001\300C\30D8\30EB\30D7\300D\3092\30AF\30EA\30C3\30AF\3057\3066\304F\3060\3055\3044\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104358951272308726)
,p_name=>'WS_GROUP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30EB\30FC\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104364985626308730)
,p_name=>'WS_GROUP_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30EB\30FC\30D7\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104372858634308736)
,p_name=>'WS_GROUP_NAME_MUST_BE_SPEC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30EB\30FC\30D7\540D\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104359285166308726)
,p_name=>'WS_HEADING_ALIGNMENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D8\30C3\30C0\30FC\306E\4F4D\7F6E\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104359608777308726)
,p_name=>'WS_HEIGHT'
,p_message_language=>'ja'
,p_message_text=>unistr('\9AD8\3055')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104373022970308736)
,p_name=>'WS_INVALID_COL'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9\306A\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104371672557308735)
,p_name=>'WS_INVALID_COL_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9\306A\5217\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104329886842308704)
,p_name=>'WS_INVALID_DATA_GRID_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30B0\30EA\30C3\30C9\306E\540D\524D\307E\305F\306F\5225\540D\304C\7121\52B9\3067\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104300330384308682)
,p_name=>'WS_LINKS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30F3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104365676434308731)
,p_name=>'WS_LINK_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30F3\30AF\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104298884024308681)
,p_name=>'WS_LINK_TO_THIS_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DA\30FC\30B8\3078\306E\30EA\30F3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104364464921308730)
,p_name=>'WS_LOAD_ORDER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30FC\30C9\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104372204256308735)
,p_name=>'WS_LOV_ALREADY_EXISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('LOV\540D\304C\3059\3067\306B\5B58\5728\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104358299789308725)
,p_name=>'WS_LOV_DEF'
,p_message_language=>'ja'
,p_message_text=>unistr('LOV\5B9A\7FA9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104372368651308735)
,p_name=>'WS_LOV_DEF_MUST_BE_SPEC'
,p_message_language=>'ja'
,p_message_text=>unistr('LOV\5B9A\7FA9\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104359811360308726)
,p_name=>'WS_LOV_DIALOG_HLP1'
,p_message_language=>'ja'
,p_message_text=>unistr('LOV\306F\3001\30E6\30FC\30B6\30FC\304C\5165\529B\3067\304D\308B\5217\5024\3092\5236\9650\3059\308B\305F\3081\306B\4F7F\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104359966643308726)
,p_name=>'WS_LOV_DIALOG_HLP2'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\30D7\30ED\30D1\30C6\30A3\306E\7DE8\96C6\6642\306B\3001\5B9A\7FA9\6E08\306ELOV\3092\5217\306B\95A2\9023\4ED8\3051\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104371919170308735)
,p_name=>'WS_LOV_MUST_BE_DEF'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3057\305F\8868\793A\30BF\30A4\30D7\306B\3064\3044\3066LOV\304C\5B9A\7FA9\3055\308C\3066\3044\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104372120549308735)
,p_name=>'WS_LOV_MUST_BE_SPEC'
,p_message_language=>'ja'
,p_message_text=>unistr('LOV\540D\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104358111848308725)
,p_name=>'WS_LOV_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('LOV\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104299994081308682)
,p_name=>'WS_MAP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30C3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104359567905308726)
,p_name=>'WS_MAX_WIDTH'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5927\5E45')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104131563940308543)
,p_name=>'WS_MAX_WIDTH_LIMIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5927\5E45\306B\306F4000\3092\8D85\3048\3066\6307\5B9A\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104357255299308724)
,p_name=>'WS_MINIMIZE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5C0F\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104322017649308698)
,p_name=>'WS_MOVE_COLUMNS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\306E\79FB\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104684668815308987)
,p_name=>'WS_MUST_BE_DATE'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\304C%1\306E\65E5\4ED8\66F8\5F0F\3068\4E00\81F4\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104372991731308736)
,p_name=>'WS_NAME_MUST_BE_SPEC'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F\30C7\30FC\30BF\30FB\30B0\30EA\30C3\30C9\540D\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104298472988308681)
,p_name=>'WS_NAME_NOT_NULL'
,p_message_language=>'ja'
,p_message_text=>unistr('\540D\524D\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104360515171308727)
,p_name=>'WS_NEW_COL_VAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F\5217\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103554419228308055)
,p_name=>'WS_NEW_DATA_GRID'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F\30C7\30FC\30BF\30FB\30B0\30EA\30C3\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104364747426308730)
,p_name=>'WS_NEW_DATA_GRID_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F\30C7\30FC\30BF\30FB\30B0\30EA\30C3\30C9\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104364866084308730)
,p_name=>'WS_NEW_GROUP'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F\30B0\30EB\30FC\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104358055488308725)
,p_name=>'WS_NEW_LOV'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898FLOV')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104359723866308726)
,p_name=>'WS_NEW_LOV_BASED_ON_CURR'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\884C\5024\306B\57FA\3065\304F\65B0\3057\3044LOV')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103554288241308055)
,p_name=>'WS_NEW_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103554588245308055)
,p_name=>'WS_NEW_REPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103554190514308055)
,p_name=>'WS_NEW_SECTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F\30BB\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104366709656308731)
,p_name=>'WS_NEW_VALIDATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F\691C\8A3C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104374213909308737)
,p_name=>'WS_NEW_VALUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\3057\3044\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104259710664308653)
,p_name=>'WS_NOTE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CE\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104300210664308682)
,p_name=>'WS_NOTES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CE\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104259816704308653)
,p_name=>'WS_NOTE_REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CE\30FC\30C8\306B\5024\304C\542B\307E\308C\3066\3044\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103554033674308055)
,p_name=>'WS_NO_COLUMNS_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\304C\898B\3064\304B\308A\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103553630828308054)
,p_name=>'WS_NO_FILES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103552539345308053)
,p_name=>'WS_NO_FILE_CHOSEN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\304C\9078\629E\3055\308C\3066\3044\307E\305B\3093')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103553472463308054)
,p_name=>'WS_NO_NOTES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CE\30FC\30C8\306F\3042\308A\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103553996136308054)
,p_name=>'WS_NO_TAGS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30B0\304C\3042\308A\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104357731461308725)
,p_name=>'WS_NUMBER'
,p_message_language=>'ja'
,p_message_text=>unistr('\6570\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104374191658308737)
,p_name=>'WS_OLD_VALUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5143\306E\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104364312979308730)
,p_name=>'WS_ORDER_BY'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E26\66FF\3048\57FA\6E96')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104324541553308700)
,p_name=>'WS_PAGE_ALIAS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306E\5225\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103593673338308083)
,p_name=>'WS_PAGE_CREATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\304C\4F5C\6210\3055\308C\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104324640524308700)
,p_name=>'WS_PAGE_DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\8A73\7D30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103554305311308055)
,p_name=>'WS_PAGE_DIRECTORY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30C7\30A3\30EC\30AF\30C8\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103554701932308055)
,p_name=>'WS_PAGE_HISTORY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\5C65\6B74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104722726103309019)
,p_name=>'WS_PAGE_LIST_WITH_CHILD_PAGES'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B50\30DA\30FC\30B8\304C\3042\308B\968E\5C64\578B\30DA\30FC\30B8\30FB\30EA\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104670080656308975)
,p_name=>'WS_PROPERTIES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30D1\30C6\30A3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104371306329308735)
,p_name=>'WS_QRY_MORE_10K'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\554F\5408\305B\306F10,000\3092\8D85\3048\308B\884C\6570\3092\8FD4\3057\307E\3059\3002\7D50\679C\304C\5B8C\5168\306B\306A\308B\3088\3046\306B\30C7\30FC\30BF\3092\30D5\30A3\30EB\30BF\51E6\7406\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104338250201308710)
,p_name=>'WS_QUERY_NOT_ALLOWED'
,p_message_language=>'ja'
,p_message_text=>unistr('\5185\90E8\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30AA\30D6\30B8\30A7\30AF\30C8\306E\554F\5408\305B\306F\8A31\53EF\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104359181409308726)
,p_name=>'WS_READ_ONLY'
,p_message_language=>'ja'
,p_message_text=>unistr('\8AAD\53D6\308A\5C02\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104373992059308737)
,p_name=>'WS_RECENT_CHGS_LISTED_BELOW'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\8FD1\306E\5909\66F4\304C\4E0B\306B\8868\793A\3055\308C\307E\3059:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104670241842308975)
,p_name=>'WS_REPLACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\7F6E\63DB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104364033695308729)
,p_name=>'WS_REPLACE_WITH'
,p_message_language=>'ja'
,p_message_text=>unistr('\7F6E\63DB\9805\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104374076572308737)
,p_name=>'WS_ROW'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104364682908308730)
,p_name=>'WS_ROWS_W_EMPTY_COL'
,p_message_language=>'ja'
,p_message_text=>unistr('\7A7A\767D\5217\306E\3042\308B\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104682281592308985)
,p_name=>'WS_ROW_CREATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C%0\306F%2\306B\3088\3063\3066%1\3092\4F5C\6210\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104682193580308985)
,p_name=>'WS_ROW_KEY'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\30AD\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104682365703308985)
,p_name=>'WS_ROW_LAST_UPDATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30C6\30F3\30C4\306F%0\306B%1\306B\3088\308A\6700\7D42\66F4\65B0\3055\308C\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104373271861308736)
,p_name=>'WS_ROW_MUST_BE_SEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\5024\3092\8A2D\5B9A\3059\308B\884C\3092\9078\629E\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104300097860308682)
,p_name=>'WS_ROW_ORDER'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104371500650308735)
,p_name=>'WS_ROW_SELECTED_DEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\524A\9664\3059\308B\884C\3092\9078\629E\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104308164253308688)
,p_name=>'WS_SAMPLE_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30F3\30D7\30EB\306E\30DB\30FC\30E0\30DA\30FC\30B8\304C\4F5C\6210\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104321866928308698)
,p_name=>'WS_SAVE_ADD_ANOTHER'
,p_message_language=>'ja'
,p_message_text=>unistr('\4FDD\5B58\3057\3066\3055\3089\306B\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104723775989309019)
,p_name=>'WS_SEARCH_REPORT_X'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22\30EC\30DD\30FC\30C8%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104324439134308700)
,p_name=>'WS_SECTION_CONTENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30AF\30B7\30E7\30F3\30FB\30B3\30F3\30C6\30F3\30C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103593505678308083)
,p_name=>'WS_SECTION_CREATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30AF\30B7\30E7\30F3\304C\4F5C\6210\3055\308C\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104308283350308688)
,p_name=>'WS_SECTION_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30AF\30B7\30E7\30F3\30FB\30BF\30A4\30C8\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104360685247308727)
,p_name=>'WS_SELECTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104363736619308729)
,p_name=>'WS_SELECTED_ROWS'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104359003934308726)
,p_name=>'WS_SELECT_COLUMN_GROUP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\30B0\30EB\30FC\30D7\306E\9078\629E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104280614823308668)
,p_name=>'WS_SELECT_RPT_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\3092\8868\793A\3059\308B\30EC\30DD\30FC\30C8\540D\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104372731582308736)
,p_name=>'WS_SEQ_MUST_BE_NUM'
,p_message_language=>'ja'
,p_message_text=>unistr('\9806\5E8F\306F\6570\5024\3067\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104372684106308736)
,p_name=>'WS_SEQ_MUST_BE_SPEC'
,p_message_language=>'ja'
,p_message_text=>unistr('\9806\5E8F\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104360480919308727)
,p_name=>'WS_SET_COL_VAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\5024\306E\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104730798324309026)
,p_name=>'WS_SIGNUP.PRIVACY_POLICY'
,p_message_language=>'ja'
,p_message_text=>unistr('<a href="https://www.oracle.com/legal/privacy/index.html" target="_new">Oracle\30D7\30E9\30A4\30D0\30B7\30FB\30DD\30EA\30B7\30FC</a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104723227988309019)
,p_name=>'WS_SIGNUP.TERMS'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0B\306E\300C\6B21\300D\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3059\308B\3053\3068\3067\3001\30AA\30E9\30AF\30EB\306EWeb\30B5\30A4\30C8\306E\4F7F\7528\306B\306F\3001<a href="https://www.oracle.com/us/legal/terms/index.html" target="_new">Oracle.com\306E\4F7F\7528\6761\4EF6</a>\304C\9069\7528\3055\308C\308B\3053\3068\3092\7406\89E3\3057\3001\5408\610F\3059\308B\3082\306E\3068\3057\307E\3059\3002\500B\4EBA\60C5\5831\3078\306E\30A2\30AF\30BB\30B9\3001\4FDD\6301\3001\6539\6B63\3001\524A\9664\3001\30BB\30AD\30E5\30EA\30C6\30A3\3001\56FD\5883\9593\306E\8EE2\9001\306B\95A2\3059\308B\60C5\5831\3068\305D\306E\4ED6\306E\30C8\30D4\30C3\30AF\3092\542B\3081\3001\30AA\30E9\30AF\30EB\306B\3088\308B\500B\4EBA\60C5\5831\306E\53CE\96C6\304A\3088\3073\4F7F\7528\306B\95A2\3059\308B\8A73\7D30\306F\3001<a href="https://ww')
||unistr('w.oracle.com/legal/privacy/index.html" target="_new">\30AA\30E9\30AF\30EB\306E\30D7\30E9\30A4\30D0\30B7\30FB\30DD\30EA\30B7\30FC</a>\3067\3054\78BA\8A8D\3044\305F\3060\304F\3053\3068\304C\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104357608164308725)
,p_name=>'WS_STRING'
,p_message_language=>'ja'
,p_message_text=>unistr('\6587\5B57\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104373452556308736)
,p_name=>'WS_STR_MUST_BE_SPEC'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22\3059\308B\6587\5B57\5217\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104300417030308682)
,p_name=>'WS_TAGS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104670154790308975)
,p_name=>'WS_TOGGLE_CHECKBOXES'
,p_message_language=>'ja'
,p_message_text=>unistr('\5207\66FF\3048\30C1\30A7\30C3\30AF\30DC\30C3\30AF\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104366895026308731)
,p_name=>'WS_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104365046681308730)
,p_name=>'WS_UNASSIGNED_COLUMNS'
,p_message_language=>'ja'
,p_message_text=>unistr('\672A\5272\5F53\3066\306E\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104357549326308725)
,p_name=>'WS_UNIQUE_IDENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E00\610F\306E\8B58\5225\5B50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104365853404308731)
,p_name=>'WS_URL_TARGET'
,p_message_language=>'ja'
,p_message_text=>unistr('URL\30BF\30FC\30B2\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104373573276308736)
,p_name=>'WS_URL_TARGET_SPEC'
,p_message_language=>'ja'
,p_message_text=>unistr('\300CURL\30BF\30FC\30B2\30C3\30C8\300D\306B\5024\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104374328822308737)
,p_name=>'WS_USER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104729042904309024)
,p_name=>'WS_USERNAME_TOO_LONG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\540D\304C\9577\3059\304E\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104684552667308987)
,p_name=>'WS_VALUE_NUMERIC'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\6570\5024\306B\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104259629931308653)
,p_name=>'WS_VALUE_REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('(\5FC5\9808\306E\5024)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104369921650308734)
,p_name=>'WS_VAL_EXPRESSION'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104373689781308736)
,p_name=>'WS_VAL_NAME_MUST_BE_SPEC'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C\540D\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104367765063308732)
,p_name=>'WS_VAL_NOT_EQ_STR_EXP'
,p_message_language=>'ja'
,p_message_text=>unistr('\6307\5B9A\3057\305F\5217\304C\5F0F\306E\6587\5B57\5217\30EA\30C6\30E9\30EB\3068\4E00\81F4\3057\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104373726161308736)
,p_name=>'WS_VAL_SEQ_MUST_BE_SPEC'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\691C\8A3C\9806\5E8F\300D\306B\5024\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104367353057308732)
,p_name=>'WS_VAL_TYPE_CHAR_IN_EXP'
,p_message_language=>'ja'
,p_message_text=>unistr('\6307\5B9A\3057\305F\5217\306B\5F0F\306E\6587\5B57\304C1\3064\4EE5\4E0A\542B\307E\308C\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104369089301308733)
,p_name=>'WS_VAL_TYPE_COL_ALPHA'
,p_message_language=>'ja'
,p_message_text=>unistr('\6307\5B9A\3057\305F\5217\304C\82F1\6570\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104368411354308733)
,p_name=>'WS_VAL_TYPE_COL_IN_EXP'
,p_message_language=>'ja'
,p_message_text=>unistr('\6307\5B9A\3057\305F\5217\304C\5F0F\306B\542B\307E\308C\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104368528932308733)
,p_name=>'WS_VAL_TYPE_COL_NOT_0'
,p_message_language=>'ja'
,p_message_text=>unistr('\6307\5B9A\3057\305F\5217\304C0(\30BC\30ED)\3067\306F\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104368267863308733)
,p_name=>'WS_VAL_TYPE_COL_NOT_EXP'
,p_message_language=>'ja'
,p_message_text=>unistr('\6307\5B9A\3057\305F\5217\304C\5F0F\306B\542B\307E\308C\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104368983445308733)
,p_name=>'WS_VAL_TYPE_COL_NOT_NULL_OR_0'
,p_message_language=>'ja'
,p_message_text=>unistr('\6307\5B9A\3057\305F\5217\304CNULL\304A\3088\30730(\30BC\30ED)\4EE5\5916')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104368699324308733)
,p_name=>'WS_VAL_TYPE_COL_NO_SP'
,p_message_language=>'ja'
,p_message_text=>unistr('\6307\5B9A\3057\305F\5217\306B\7A7A\767D\304C\542B\307E\308C\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104369148294308733)
,p_name=>'WS_VAL_TYPE_COL_NUM'
,p_message_language=>'ja'
,p_message_text=>unistr('\6307\5B9A\3057\305F\5217\304C\6570\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104369559865308733)
,p_name=>'WS_VAL_TYPE_COL_VAL_DATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6307\5B9A\3057\305F\5217\304C\6709\52B9\306A\65E5\4ED8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104368047535308732)
,p_name=>'WS_VAL_TYPE_EQ_STR_EXP'
,p_message_language=>'ja'
,p_message_text=>unistr('\6307\5B9A\3057\305F\5217\304C\5F0F\306E\6587\5B57\5217\30EA\30C6\30E9\30EB\3068\4E00\81F4\3059\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104367988873308732)
,p_name=>'WS_VAL_TYPE_NOT_ANY_CHAR_EXP'
,p_message_language=>'ja'
,p_message_text=>unistr('\6307\5B9A\3057\305F\5217\304C\5F0F\306E\6587\5B57\3092\542B\307E\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104367203916308732)
,p_name=>'WS_VAL_TYPE_NOT_NULL'
,p_message_language=>'ja'
,p_message_text=>unistr('\6307\5B9A\3057\305F\5217\304CNOT NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104367589605308732)
,p_name=>'WS_VAL_TYPE_ONLY_CHAR_EXP'
,p_message_language=>'ja'
,p_message_text=>unistr('\6307\5B9A\3057\305F\5217\306B\5F0F\306E\6587\5B57\306E\307F\304C\542B\307E\308C\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104374509124308737)
,p_name=>'WS_VIEW'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D3\30E5\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104722626151309019)
,p_name=>'WS_VIEW_DATA_GRID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30B0\30EA\30C3\30C9\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104356815430308724)
,p_name=>'WS_VIEW_FILES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104357000982308724)
,p_name=>'WS_VIEW_NOTES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CE\30FC\30C8\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104356988928308724)
,p_name=>'WS_VIEW_TAGS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30B0\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104298799720308681)
,p_name=>'WS_WEBSHEET_ALIAS_NOT_UNIQUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5225\540D\306F\3059\3067\306B\5B58\5728\3057\307E\3059\3002\4ED6\306E\5225\540D\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104669912511308975)
,p_name=>'WS_WEBSHEET_PROP'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B7\30FC\30C8\30FB\30D7\30ED\30D1\30C6\30A3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104279157426308667)
,p_name=>'WS_WELCOME'
,p_message_language=>'ja'
,p_message_text=>unistr('Web\30B7\30FC\30C8\3078\3088\3046\3053\305D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104359420668308726)
,p_name=>'WS_WIDTH'
,p_message_language=>'ja'
,p_message_text=>unistr('\5E45')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104299237383308682)
,p_name=>'WS_WITHOUT_FILES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104299625837308682)
,p_name=>'WS_WITHOUT_LINKS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30F3\30AF\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104299807436308682)
,p_name=>'WS_WITHOUT_LOCATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F4D\7F6E\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104299413720308682)
,p_name=>'WS_WITHOUT_NOTES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CE\30FC\30C8\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104299114715308681)
,p_name=>'WS_WITH_FILES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\3042\308A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104299503526308682)
,p_name=>'WS_WITH_LINKS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30F3\30AF\3042\308A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104299782339308682)
,p_name=>'WS_WITH_LOCATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F4D\7F6E\3042\308A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104299395001308682)
,p_name=>'WS_WITH_NOTES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CE\30FC\30C8\3042\308A')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104050944080308476)
,p_name=>'WWV_CALENDAR_INVALID_QUERY'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\554F\5408\305B\306F\30011\3064\4EE5\4E0A\306E\65E5\4ED8\5217\307E\305F\306F\30BF\30A4\30E0\30B9\30BF\30F3\30D7\5217\3092\542B\3080\5FC5\8981\304C\3042\308A\307E\3059\3002\554F\5408\305B\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002(%0)</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103786221816308236)
,p_name=>'WWV_CRYPT.KEY_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AD\30FC\306F\30018\300116\307E\305F\306F24\30D0\30A4\30C8\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103555444186308056)
,p_name=>'WWV_DATA_PKG.APP_NOT_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3%0\306F\3001\3053\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306B\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103555665424308056)
,p_name=>'WWV_DATA_PKG.LOAD_TABLE_FAILED'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868%0\306E\30ED\30FC\30C9\304C\5931\6557\3057\307E\3057\305F\3002\8868%1\306B\30A8\30E9\30FC\304C\8A18\9332\3055\308C\307E\3057\305F\3002\3053\306E\8868\306F\3001\518D\5B9F\884C\306E\524D\306B\524A\9664\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103555347309308055)
,p_name=>'WWV_DATA_PKG.NO_FILE_GENERATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\304C\751F\6210\3055\308C\3066\3044\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103555256777308055)
,p_name=>'WWV_DATA_PKG.ROWS_EXPORTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\304C\30A8\30AF\30B9\30DD\30FC\30C8\3055\308C\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103555753798308056)
,p_name=>'WWV_DATA_PKG.TABLE_EXISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC\8868%0\306F\3059\3067\306B\5B58\5728\3057\307E\3059\3002\3053\306E\8868\306F\3001\518D\5B9F\884C\306E\524D\306B\524A\9664\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103555514281308056)
,p_name=>'WWV_DATA_PKG.UNSUPPORTED_DATA_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\542B\307E\308C\3066\3044\308B\3059\3079\3066\306E\5217\306F\3001\30B5\30DD\30FC\30C8\3055\308C\3066\3044\306A\3044\30C7\30FC\30BF\578B\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103532699273308039)
,p_name=>'WWV_DBMS_CLOUD.DATA_PUMP_DIR_PRIVS_MISSING'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\30B9\30AD\30FC\30DE\306B\306FDATA_PUMP_DIR\30C7\30A3\30EC\30AF\30C8\30EA\306B\5BFE\3059\308BREAD\304A\3088\3073WRITE\6A29\9650\304C\5FC5\8981\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103536909019308042)
,p_name=>'WWV_DBMS_CLOUD.FILE_TOO_LARGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F\30AA\30D6\30B8\30A7\30AF\30C8\30FB\30B9\30C8\30A2\30FB\30D5\30A1\30A4\30EB\306F\5927\304D\3059\304E\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103524041497308033)
,p_name=>'WWV_DBMS_CLOUD.INTERNAL_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('DBMS_CLOUD\30EA\30AF\30A8\30B9\30C8\306E\51E6\7406\4E2D\306B\5185\90E8\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103524137383308033)
,p_name=>'WWV_DBMS_CLOUD.INVALID_CREDENTIAL_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30D6\30B8\30A7\30AF\30C8\30FB\30B9\30C8\30A2\53C2\7167\306B\306F\7121\52B9\306A\8CC7\683C\8A3C\660E\30BF\30A4\30D7\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103532581038308039)
,p_name=>'WWV_DBMS_CLOUD.NO_DATA_PUMP_DIR_ACCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\30B9\30AD\30FC\30DE\306B\306FDATA_PUMP_DIR\30C7\30A3\30EC\30AF\30C8\30EA\3078\306E\30A2\30AF\30BB\30B9\6A29\9650\304C\5FC5\8981\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103535520955308041)
,p_name=>'WWV_DBMS_CLOUD.NO_DBMS_CLOUD'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B7\30B9\30C6\30E0\3067DBMS_CLOUD\30D1\30C3\30B1\30FC\30B8\306F\4F7F\7528\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103532455873308039)
,p_name=>'WWV_DBMS_CLOUD.NO_DBMS_CLOUD_ACCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\30B9\30AD\30FC\30DE\306B\306FDBMS_CLOUD\30D1\30C3\30B1\30FC\30B8\306B\5BFE\3059\308BEXECUTE\6A29\9650\304C\5FC5\8981\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103767980327308222)
,p_name=>'WWV_DBMS_SQL.FUNC_BODY_NULL_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\89E3\6790\30A8\30E9\30FC: \30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\306FNULL\306B\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103768029341308222)
,p_name=>'WWV_DBMS_SQL.PARSE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\89E3\6790\30A8\30E9\30FC: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103760552069308216)
,p_name=>'WWV_FLOW.APP_NOT_FND_FOOTER_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3=%0 \73FE\884C\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9=%1 \30EA\30AF\30A8\30B9\30C8\3055\308C\305F\30EF\30FC\30AF\30B9\30DA\30FC\30B9=%2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103760074734308215)
,p_name=>'WWV_FLOW.APP_NOT_FND_INV_COMP_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('ERR-1014 \30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304C\898B\3064\304B\308A\307E\305B\3093\3002\7121\52B9\306A\30EF\30FC\30AF\30B9\30DA\30FC\30B9\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103762163147308217)
,p_name=>'WWV_FLOW.APP_PAGE_REQUEST_FOOTER_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3=%0 \30DA\30FC\30B8=%1 \30EA\30AF\30A8\30B9\30C8=%2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103756187448308212)
,p_name=>'WWV_FLOW.AUTH_SCHEME_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('ERR-1082 \8A8D\53EF\30B9\30AD\30FC\30E0\30FB\30B3\30FC\30C9\306E\5B9F\884C\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103756900450308213)
,p_name=>'WWV_FLOW.BRANCH_POINT_NULL_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('ERR-1007 \30D6\30E9\30F3\30C1\30FB\30DD\30A4\30F3\30C8\306FNULL\306B\3067\304D\307E\305B\3093: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103757027479308213)
,p_name=>'WWV_FLOW.BRANCH_TO_PAGE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('ERR-1008 \30DA\30FC\30B8%0\306B\30D6\30E9\30F3\30C1\3092\5B9F\884C\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103517461518308028)
,p_name=>'WWV_FLOW.BRANCH_TO_PAGE_MODE_PAGE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('ERR-7746 \30C0\30A4\30A2\30ED\30B0\30FB\30DA\30FC\30B8\304B\3089\7570\306A\308B\30DA\30FC\30B8\30FB\30E2\30FC\30C9\306E\30DA\30FC\30B8\3078\306E\30D6\30E9\30F3\30C1\3092\51E6\7406\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103765326055308220)
,p_name=>'WWV_FLOW.BUTTON_TEMP_FETCH_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8ID=%0\306E\30D5\30A7\30C3\30C1\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103755704272308212)
,p_name=>'WWV_FLOW.CLICK_TO_LOGIN'
,p_message_language=>'ja'
,p_message_text=>unistr('<p><a href="%0">\3053\3053</a>\3092\30AF\30EA\30C3\30AF\3057\3066\30ED\30B0\30A4\30F3</a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103756462310308213)
,p_name=>'WWV_FLOW.COMP_EXP_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('ERR-1030 \8A08\7B97\5F0F\306E\5B9F\884C\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103756577488308213)
,p_name=>'WWV_FLOW.COMP_FUNCTION_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('ERR-1004 \30D5\30A1\30F3\30AF\30B7\30E7\30F3\3092\8A08\7B97\3067\304D\307E\305B\3093\3002computation_point=%0\3001computation_type=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103756349198308213)
,p_name=>'WWV_FLOW.COMP_QUERY_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('ERR-1003 \8A08\7B97\306E\554F\5408\305B\3092\5B9F\884C\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103756238946308212)
,p_name=>'WWV_FLOW.CREATE_ITEM_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('ERR-1001 \30A2\30A4\30C6\30E0\306E\4F5C\6210\4E2D\306B\4E88\671F\3057\306A\3044\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F: FSP_PROCESS_STATE_%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103755904087308212)
,p_name=>'WWV_FLOW.DEEPLINKING_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('ERR-1001 make_deeplinking_item session=%0\3067\4E88\671F\3057\306A\3044\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103757593040308214)
,p_name=>'WWV_FLOW.DET_COMPANY_FOOTER_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('p_company\307E\305F\306Fwwv_flow_company\306ECookie\306B\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\6240\6709\8005\306E\30BB\30AD\30E5\30EA\30C6\30A3\30FB\30B0\30EB\30FC\30D7ID\3092\542B\3081\3088\3046\3068\3057\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103761814559308217)
,p_name=>'WWV_FLOW.DET_COMPANY_ON_ACCEPT_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('ERR-7621 \30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\53D7\5165\308C\6642\306B\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3(%0)\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9\3092\5224\65AD\3067\304D\307E\305B\3093\3067\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103761969555308217)
,p_name=>'WWV_FLOW.DET_COMP_FOR_FLOW_FOOTER_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('p_company\307E\305F\306Fwwv_flow_company\306ECookie\306B\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\6240\6709\8005\306E\30BB\30AD\30E5\30EA\30C6\30A3\30FB\30B0\30EB\30FC\30D7ID\3092\542B\3081\3088\3046\3068\3057\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103757389726308213)
,p_name=>'WWV_FLOW.EVAL_TYPE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('ERR-1011 \7121\52B9\306A\8A55\4FA1\30BF\30A4\30D7: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103765217178308220)
,p_name=>'WWV_FLOW.FETCH_VALUE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('fetch_value\3067\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103756042935308212)
,p_name=>'WWV_FLOW.FIND_ITEM_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('ERR-1902 \30A2\30A4\30C6\30E0ID\304Cfind_item_name\30EB\30FC\30C1\30F3\3067NULL\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103756800677308213)
,p_name=>'WWV_FLOW.FUNC_BODY_RET_BOOL_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('ERR-1021 \300C\30D6\30FC\30EB\3092\623B\3059\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\300D\306E\691C\8A3C\3092\5B9F\884C\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103756799988308213)
,p_name=>'WWV_FLOW.FUNC_BODY_RET_TEXT_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('ERR-1024 \300C\30C6\30AD\30B9\30C8\3092\623B\3059\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\300D\306E\691C\8A3C\3092\5B9F\884C\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103757417066308213)
,p_name=>'WWV_FLOW.G_FLOW_ID_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('ERR-1812 G_FLOW_ID(%0)\3092\5272\5F53\3066\4E2D\306B\4E88\671F\3057\306A\3044\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103762056026308217)
,p_name=>'WWV_FLOW.INSUFFICENT_INFO_ON_REQ_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('ERR-9988 \3053\306E\30EA\30AF\30A8\30B9\30C8\306B\5BFE\3057\3066\6307\5B9A\3055\308C\305F\60C5\5831\304C\4E0D\5341\5206\3067\3059:  \524D\306E\30DA\30FC\30B8\304C\5B8C\5168\306B\30ED\30FC\30C9\3055\308C\306A\304B\3063\305F\53EF\80FD\6027\304C\3042\308A\307E\3059\3002\7D9A\884C\3059\308B\306B\306F\3001\30D6\30E9\30A6\30B6\306E\300C\623B\308B\300D\304A\3088\3073\300C\30EA\30ED\30FC\30C9\300D\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3059\308B\304B\3001\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30DB\30FC\30E0\30DA\30FC\30B8\306B\30CA\30D3\30B2\30FC\30C8\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103757918626308214)
,p_name=>'WWV_FLOW.LOGIN_SERVER_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('ERR-1555 Oracle Login Server\306B\30ED\30B0\30A4\30F3\3055\308C\3066\3044\307E\305B\3093\3002\30D1\30D6\30EA\30C3\30AF\30FB\30E6\30FC\30B6\30FC\304C\6307\5B9A\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103761595287308217)
,p_name=>'WWV_FLOW.LOGOUT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30B0\30A2\30A6\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103755699808308212)
,p_name=>'WWV_FLOW.NOT_LOGGED_IN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30B0\30A4\30F3\3055\308C\3066\3044\307E\305B\3093\3002  \8A8D\8A3C\306B\5FC5\8981\306ACookie\304C\6B20\843D\3057\3066\3044\308B\304B\3001\307E\305F\306F\7121\52B9\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103762597162308217)
,p_name=>'WWV_FLOW.NO_PAGE_TO_BRANCH_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('ERR-1777: \30DA\30FC\30B8%0\306B\30D6\30E9\30F3\30C1\5148\306E\30DA\30FC\30B8\304C\6307\5B9A\3055\308C\3066\3044\307E\305B\3093\3002\3053\306E\30A8\30E9\30FC\3092\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\7BA1\7406\8005\306B\9023\7D61\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103761666438308217)
,p_name=>'WWV_FLOW.NO_PRIV_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('ERR-1013 \30E6\30FC\30B6\30FC%0\304C\8A66\884C\3057\305F\64CD\4F5C\306B\5BFE\3059\308B\6A29\9650\304C\3042\308A\307E\305B\3093\3002 \30ED\30FC\30EB%1\304C\5FC5\8981\3067\3059\3002\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\7BA1\7406\8005\306B\9023\7D61\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103587402901308078)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.CHECKSUM_REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30A7\30C3\30AF\30B5\30E0\304C\8868\793A\30D7\30ED\30B7\30FC\30B8\30E3\306B\6E21\3055\308C\308B\5834\5408\3001\5F15\6570\3092\6307\5B9A\3057\3066\30DA\30FC\30B8\3092\30EA\30AF\30A8\30B9\30C8\3067\304D\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103587679077308079)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.DIRECT_BRANCH_ONLY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306B\306F\3001\300C\30DA\30FC\30B8\306B\30D6\30E9\30F3\30C1\300D\30BF\30A4\30D7\306E\30D6\30E9\30F3\30C1\3092\4F7F\7528\3057\305F\5834\5408\306B\306E\307F\3001\5225\306E\30DA\30FC\30B8\304B\3089\30A2\30AF\30BB\30B9\3067\304D\307E\3059 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103587583406308078)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.NO_ARGS_ALLOWED '
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306B\306F\5F15\6570\3092\6307\5B9A\3057\306A\3044\5834\5408\306B\306E\307F\30A2\30AF\30BB\30B9\3067\304D\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103587861757308079)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.SHOW_NO_ARGS_ALLOWED'
,p_message_language=>'ja'
,p_message_text=>unistr('\5F15\6570\306F\3001\5F15\6570(\30EA\30AF\30A8\30B9\30C8\3001\30AD\30E3\30C3\30B7\30E5\306E\30AF\30EA\30A2\3001\30A2\30A4\30C6\30E0\5024)\3092\53D7\3051\5165\308C\306A\3044\30DA\30FC\30B8\306B\6E21\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103587329854308078)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.UNPROTECTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306B\4FDD\8B77\304C\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103761482332308217)
,p_name=>'WWV_FLOW.REQUIRED_ROLE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\5FC5\8981\306A\30ED\30FC\30EB\304C\6709\52B9\3067\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103762644278308218)
,p_name=>'WWV_FLOW.RESTART_APP'
,p_message_language=>'ja'
,p_message_text=>unistr('<a href="f?p=%0">\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\518D\8D77\52D5</a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103755842357308212)
,p_name=>'WWV_FLOW.SAVE_ROUTINE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('ERR-1001 \4FDD\5B58\30EB\30FC\30C1\30F3\3067\4E88\671F\3057\306A\3044\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103757268970308213)
,p_name=>'WWV_FLOW.SQL_EXP_HEADING_TEXT_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('ERR-1910 \30D8\30C3\30C0\30FC\30FB\30C6\30AD\30B9\30C8\306ESQL\5F0F\3092\8A55\4FA1\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103788404466308238)
,p_name=>'WWV_FLOW.UNABLE_HOME_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DB\30FC\30E0\30DA\30FC\30B8\306B\79FB\52D5\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103761778288308217)
,p_name=>'WWV_FLOW.UNABLE_RESOLVE_ALIAS_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('ERR-1512 \30DA\30FC\30B8\5225\540D(%0)\3092\89E3\6C7A\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103765574492308220)
,p_name=>'WWV_FLOW.UNABLE_SET_TIMED_STAT_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('timed_statistics\3092\8A2D\5B9A\3067\304D\307E\305B\3093: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103765404681308220)
,p_name=>'WWV_FLOW.UNABLE_TO_TRACE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C8\30EC\30FC\30B9\3067\304D\307E\305B\3093: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103759334549308215)
,p_name=>'WWV_FLOW.UNSUPP_AUTH_SCHEME_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('ERR-1444 \8A8D\8A3C\30B9\30AD\30FC\30E0\304C\30B5\30DD\30FC\30C8\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103756660819308213)
,p_name=>'WWV_FLOW.VALIDATION_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('ERR-1006 \691C\8A3C\30EB\30FC\30C1\30F3\3067\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103768196745308222)
,p_name=>'WWV_FLOW_ADMINISTRATION.DEPRECATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\975E\63A8\5968')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103796346119308244)
,p_name=>'WWV_FLOW_ADMIN_API.DELETE_DEV_ROLE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\767A\8005\30ED\30FC\30EB\306E\524A\9664\3067\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103796289991308244)
,p_name=>'WWV_FLOW_ADMIN_API.FETCH_FND_USER_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\691C\7D22\60C5\5831\3092\30D5\30A7\30C3\30C1\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103996310940308433)
,p_name=>'WWV_FLOW_ADMIN_API.NO_DEV_PRIV'
,p_message_language=>'ja'
,p_message_text=>unistr('\8B66\544A: \30E6\30FC\30B6\30FC%0\306F\958B\767A\8005\6A29\9650\3092\6240\6709\3057\3066\3044\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103663407806308138)
,p_name=>'WWV_FLOW_API.COMPATIBLE'
,p_message_language=>'ja'
,p_message_text=>unistr('COMPATIBLE(\554F\984C\306A\304F\3053\306E\30A4\30F3\30DD\30FC\30C8\3092\5B9F\884C\3067\304D\307E\3059\3002)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104541655147308869)
,p_name=>'WWV_FLOW_API.CREDENTIAL_WARNING'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8CC7\683C\8A3C\660E"%0" (\9759\7684ID)\306E\8B66\544A:'),
'',
unistr('- Application Express\30A8\30AF\30B9\30DD\30FC\30C8\30FB\30D5\30A1\30A4\30EB\306B\306F\3001\8CC7\683C\8A3C\660E\60C5\5831\304C\542B\307E\308C\3066\3044\307E\305B\3093\3002'),
unistr('- APEX_CREDENTIAL.SET_PERSISTENT_CREDENTIAL\30D7\30ED\30B7\30FC\30B8\30E3\3092\4F7F\7528\3057\3066\3001'),
unistr('- \30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30A4\30F3\30DD\30FC\30C8\5F8C\306B\8CC7\683C\8A3C\660E\3092\8A2D\5B9A\3057\307E\3059\3002\8CC7\683C\8A3C\660E\306F\3001'),
unistr('- \9759\7684ID "%0"\3067\53C2\7167\3055\308C\3066\3044\307E\3059')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103658917772308135)
,p_name=>'WWV_FLOW_API.CURRENT_FLOWS_VERSION'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\884C\306E\30D0\30FC\30B8\30E7\30F3:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104131465487308543)
,p_name=>'WWV_FLOW_API.DELETE_APP_IN_DIFFERENT_WORKSPACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3%0\3092\524A\9664\3067\304D\307E\305B\3093\3002\7570\306A\308B\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306B\30A4\30F3\30B9\30C8\30FC\30EB\3055\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103663069298308138)
,p_name=>'WWV_FLOW_API.ERR_AUTH_SCHEME_CREATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\540D\524D=%0\306E\8A8D\8A3C\30B9\30AD\30FC\30E0\3092\4F5C\6210\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103661632197308137)
,p_name=>'WWV_FLOW_API.ERR_BRANCH_CREATE'
,p_message_language=>'ja'
,p_message_text=>unistr('ID=\300C%0\300D\306E\30D6\30E9\30F3\30C1\3092\4F5C\6210\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103662813493308138)
,p_name=>'WWV_FLOW_API.ERR_BUG_CREATE'
,p_message_language=>'ja'
,p_message_text=>unistr('ID=\300C%0\300D\306E\30D0\30B0\3092\4F5C\6210\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103660114950308136)
,p_name=>'WWV_FLOW_API.ERR_BUILD_OPTION_CREATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\540D\524D=\300C%0\300D\306E\30D3\30EB\30C9\30FB\30AA\30D7\30B7\30E7\30F3\3092\4F5C\6210\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103660242730308136)
,p_name=>'WWV_FLOW_API.ERR_BUILD_OPTION_SET'
,p_message_language=>'ja'
,p_message_text=>unistr('ID=\300C%0\300D\306E\30D3\30EB\30C9\30FB\30AA\30D7\30B7\30E7\30F3\3092\8A2D\5B9A\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103661508502308137)
,p_name=>'WWV_FLOW_API.ERR_BUTTON_CREATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\540D\524D=\300C%0\300D\3001ID=\300C%1\300D\306E\30DC\30BF\30F3\3092\4F5C\6210\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104016918458308448)
,p_name=>'WWV_FLOW_API.ERR_DA_ACTION_CREATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\540D\524D=\300C%0\300D\3001ID=\300C%1\300D\306E\52D5\7684\30A2\30AF\30B7\30E7\30F3\306E\30B5\30D6\30A2\30AF\30B7\30E7\30F3\3092\4F5C\6210\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104016821601308448)
,p_name=>'WWV_FLOW_API.ERR_DA_EVENT_CREATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8=\300C%0\300D\3001\540D\524D=\300C%1\300D\3001ID=\300C%2\300D\306E\52D5\7684\30A2\30AF\30B7\30E7\30F3\3092\4F5C\6210\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103701018208308168)
,p_name=>'WWV_FLOW_API.ERR_DUP_PAGE_ITEM_CREATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8=\300C%0\300D\3001\30A2\30A4\30C6\30E0=\300C%1\300D\3001ID=\300C%2\300D\306E\30A8\30E9\30FC\306F\3001\65E2\5B58\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30EC\30D9\30EB\306E\30A2\30A4\30C6\30E0\3068\540C\3058\540D\524D\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103660712414308136)
,p_name=>'WWV_FLOW_API.ERR_FLOW_COMPUTATION_CREATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\8A08\7B97\30A2\30A4\30C6\30E0=\300C%0\300D\306E\4F5C\6210\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103660662221308136)
,p_name=>'WWV_FLOW_API.ERR_FLOW_ITEM_CREATE'
,p_message_language=>'ja'
,p_message_text=>unistr('ID=\300C%0\300D\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\4F5C\6210\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103617990231308101)
,p_name=>'WWV_FLOW_API.ERR_FLOW_PLUGIN_ATTR_CREATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30E9\30B0\30A4\30F3\5C5E\6027ID="%0"\306E\4F5C\6210\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F	')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104030893697308459)
,p_name=>'WWV_FLOW_API.ERR_FLOW_PLUGIN_ATTR_VALUE_CREATE'
,p_message_language=>'ja'
,p_message_text=>unistr('ID=\300C%0\300D\306E\30D7\30E9\30B0\30A4\30F3\5C5E\6027\5024\306E\4F5C\6210\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103617804113308101)
,p_name=>'WWV_FLOW_API.ERR_FLOW_PLUGIN_CREATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30E9\30B0\30A4\30F3ID="%0"\306E\4F5C\6210\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103674233909308146)
,p_name=>'WWV_FLOW_API.ERR_FLOW_PLUGIN_EVENT_CREATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30E9\30B0\30A4\30F3\30FB\30A4\30D9\30F3\30C8ID="%0"\306E\4F5C\6210\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103660451587308136)
,p_name=>'WWV_FLOW_API.ERR_FLOW_PROCESS_CREATE'
,p_message_language=>'ja'
,p_message_text=>unistr('ID=\300C%0\300D\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30D7\30ED\30BB\30B9\3092\4F5C\6210\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104705662036309005)
,p_name=>'WWV_FLOW_API.ERR_FLOW_TEMPLATE_OPTION_CREATE'
,p_message_language=>'ja'
,p_message_text=>unistr('ID=\300C%0\300D\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8\30FB\30AA\30D7\30B7\30E7\30F3\3092\4F5C\6210\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104705530485309005)
,p_name=>'WWV_FLOW_API.ERR_FLOW_TEMPLATE_OPT_GROUP_CREATE'
,p_message_language=>'ja'
,p_message_text=>unistr('ID=\300C%0\300D\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8\30FB\30AA\30D7\30B7\30E7\30F3\30FB\30B0\30EB\30FC\30D7\3092\4F5C\6210\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103662613790308137)
,p_name=>'WWV_FLOW_API.ERR_FORM_ADDED_TO_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E2\5B58\306E\30DA\30FC\30B8%0\306B\30D5\30A9\30FC\30E0\304C\8FFD\52A0\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103637660719308118)
,p_name=>'WWV_FLOW_API.ERR_INSTALL_CREATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30AA\30D6\30B8\30A7\30AF\30C8\306E\30A4\30F3\30B9\30C8\30FC\30EB\5C5E\6027id="%0"\3092\30A4\30F3\30DD\30FC\30C8\3067\304D\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103637791341308118)
,p_name=>'WWV_FLOW_API.ERR_INSTALL_SCRIPT_CREATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30B9\30C8\30FC\30EB\30FB\30B9\30AF\30EA\30D7\30C8ID="%0"\306E\4F5C\6210\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103662331912308137)
,p_name=>'WWV_FLOW_API.ERR_INVALID_REPORT_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9\306A\30EC\30DD\30FC\30C8\30FB\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103662134066308137)
,p_name=>'WWV_FLOW_API.ERR_LANG_MAP_CREATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\7FFB\8A33\30DE\30C3\30D7\306E\4F5C\6210\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103559969550308059)
,p_name=>'WWV_FLOW_API.ERR_LOV_COL_CREATE'
,p_message_language=>'ja'
,p_message_text=>unistr('ID=\300C%0\300D\306ELOV\5217\3092\4F5C\6210\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103661109532308136)
,p_name=>'WWV_FLOW_API.ERR_LOV_CREATE'
,p_message_language=>'ja'
,p_message_text=>unistr('ID=\300C%0\300D\306E\5024\30EA\30B9\30C8\3092\4F5C\6210\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103660325465308136)
,p_name=>'WWV_FLOW_API.ERR_NAV_BAR_ITEM_CREATE'
,p_message_language=>'ja'
,p_message_text=>unistr('ID=\300C%0\300D\306E\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30D0\30FC\30FB\30A2\30A4\30C6\30E0\3092\4F5C\6210\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103661897756308137)
,p_name=>'WWV_FLOW_API.ERR_PAGE_COMPUTATION_CREATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8=%0\3001\30A2\30A4\30C6\30E0=%1\3001ID=\300C%2\300D\306E\30DA\30FC\30B8\8A08\7B97\3092\4F5C\6210\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103661255235308136)
,p_name=>'WWV_FLOW_API.ERR_PAGE_CREATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\540D\524D=\300C%0\300D\3001ID=\300C%1\300D\306E\30DA\30FC\30B8\3092\4F5C\6210\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104071096608308492)
,p_name=>'WWV_FLOW_API.ERR_PAGE_GROUP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30B0\30EB\30FC\30D7\306E\4F5C\6210\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103662598045308137)
,p_name=>'WWV_FLOW_API.ERR_PAGE_HAS_BUTTONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8%0\306B\306F\3059\3067\306B\30DC\30BF\30F3\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103661349989308136)
,p_name=>'WWV_FLOW_API.ERR_PAGE_HELP_CREATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8%0\306E\30D8\30EB\30D7\30FB\30C6\30AD\30B9\30C8\306E\4F5C\6210\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103661763922308137)
,p_name=>'WWV_FLOW_API.ERR_PAGE_ITEM_CREATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8=\300C%0\300D\3001\30A2\30A4\30C6\30E0=\300C%1\300D\3001ID=\300C%2\300D\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103661424735308137)
,p_name=>'WWV_FLOW_API.ERR_PAGE_NAME_UPD'
,p_message_language=>'ja'
,p_message_text=>unistr('\540D\524D=\300C%0\300D\3001ID=\300C%1\300D\306E\30DA\30FC\30B8\3092\66F4\65B0\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103662252334308137)
,p_name=>'WWV_FLOW_API.ERR_PAGE_ON_TABLE_CREATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\300C%0\300D\306B\30DA\30FC\30B8\3092\4F5C\6210\3067\304D\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103662056042308137)
,p_name=>'WWV_FLOW_API.ERR_PAGE_PROCESS_CREATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8=%0\3001\540D\524D=%1\306E\30DA\30FC\30B8\30FB\30D7\30ED\30BB\30B9\3092\4F5C\6210\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103661932302308137)
,p_name=>'WWV_FLOW_API.ERR_PAGE_VALIDATION_CREATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8=%0\3001\540D\524D=%1\306E\30DA\30FC\30B8\691C\8A3C\3092\4F5C\6210\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103661015012308136)
,p_name=>'WWV_FLOW_API.ERR_PARENT_TAB_CREATE'
,p_message_language=>'ja'
,p_message_text=>unistr('ID=\300C%0\300D\306E\89AA\30BF\30D6\306E\4F5C\6210\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103660513207308136)
,p_name=>'WWV_FLOW_API.ERR_PROCESS_SQL_SET'
,p_message_language=>'ja'
,p_message_text=>unistr('ID="%0"\306E\51E6\7406SQL\3092\8A2D\5B9A\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103662463107308137)
,p_name=>'WWV_FLOW_API.ERR_REPORT_PAGE_EXISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\30FB\30DA\30FC\30B8%0\304C\5B58\5728\3057\3001\30EC\30DD\30FC\30C8\30FB\30EA\30FC\30B8\30E7\30F3\304C\8FFD\52A0\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103662718169308137)
,p_name=>'WWV_FLOW_API.ERR_REPORT_PAGE_EXISTS2'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8%0\306F\3001\3059\3067\306B\5B58\5728\3057\3066\3044\308B\305F\3081\4F5C\6210\3055\308C\307E\305B\3093\3067\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103662972218308138)
,p_name=>'WWV_FLOW_API.ERR_SHORTCUT_CREATE'
,p_message_language=>'ja'
,p_message_text=>unistr('ID=\300C%0\300D\306E\30B7\30E7\30FC\30C8\30AB\30C3\30C8\3092\4F5C\6210\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103660895442308136)
,p_name=>'WWV_FLOW_API.ERR_STD_TAB_CREATE'
,p_message_language=>'ja'
,p_message_text=>unistr('ID=\300C%0\300D\306E\6A19\6E96\30BF\30D6\306E\4F5C\6210\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103660960752308136)
,p_name=>'WWV_FLOW_API.ERR_TABSET_RENAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30D6\30FB\30BB\30C3\30C8%1\3092%0\306B\30EA\30CD\30FC\30E0\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103660008007308136)
,p_name=>'WWV_FLOW_API.ERR_TEMPL_CREATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\540D\524D=\300C%0\300D\306E\30C6\30F3\30D7\30EC\30FC\30C8\3092\4F5C\6210\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103658836833308135)
,p_name=>'WWV_FLOW_API.FLOWS_API_LAST_EXTENDED'
,p_message_language=>'ja'
,p_message_text=>unistr('API\306E\6700\7D42\62E1\5F35\65E5:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103663346224308138)
,p_name=>'WWV_FLOW_API.FLOWS_API_RUNTIME_INCOMPATIBLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A8\30AF\30B9\30DD\30FC\30C8\30FB\30D5\30A1\30A4\30EB\306F\3001\30D5\30A1\30A4\30EB\3092\30A4\30F3\30DD\30FC\30C8\3057\3088\3046\3068\3057\3066\3044\308BApplication Express\306E\30D0\30FC\30B8\30E7\30F3\3068\4E92\63DB\6027\304C\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103659835686308135)
,p_name=>'WWV_FLOW_API.FLOW_ID_MISSING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30B7\30FC\30B8\30E3%0\304C\3001p_id\306B\5024\3092\6307\5B9A\305B\305A\306B\30B3\30FC\30EB\3055\308C\307E\3057\305F-\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3ID\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103519165203308029)
,p_name=>'WWV_FLOW_API.FLOW_ID_OUT_OF_RANGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3ID"%0"\304C\8A31\5BB9\7BC4\56F2(%1 - %2)\306B\3042\308A\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104130979812308542)
,p_name=>'WWV_FLOW_API.FLOW_ID_RANGE_RESERVED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3ID"%0"\306F\4F7F\7528\3067\304D\305A\3001\7BC4\56F2(%1 - %2)\306F\4E88\7D04\3055\308C\3066\3044\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103663263374308138)
,p_name=>'WWV_FLOW_API.FLOW_ID_RESERVED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3ID %0\306F\30AA\30E9\30AF\30EB\793E\306B\4E88\7D04\3055\308C\3066\3044\307E\3059 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103519220663308029)
,p_name=>'WWV_FLOW_API.FLOW_ID_RESERVED_FOR_OTHER_WORKSPACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3ID"%0"\306F\5225\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9\7528\306B\4E88\7D04\3055\308C\3066\3044\308B\305F\3081\3001\3053\3053\3067\306F\4F7F\7528\3067\304D\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103659935003308135)
,p_name=>'WWV_FLOW_API.FLOW_NOT_DELETED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3%0\306F\524A\9664\3055\308C\307E\305B\3093\3067\3057\305F\3002\30A4\30F3\30DD\30FC\30C8\306F\8A66\884C\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103659012159308135)
,p_name=>'WWV_FLOW_API.IMPORT_COMPATIBLE_WITH_VERSION'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A4\30F3\30DD\30FC\30C8\306F\6B21\306E\30D0\30FC\30B8\30E7\30F3\3068\4E92\63DB\6027\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104089404120308508)
,p_name=>'WWV_FLOW_API.IMPORT_SCRIPT_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AF\30EA\30D7\30C8\3092\30A4\30F3\30DD\30FC\30C8\3067\304D\307E\305B\3093\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103659506426308135)
,p_name=>'WWV_FLOW_API.INVALID_CREDENTIALS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\540D\3001\30D1\30B9\30EF\30FC\30C9\307E\305F\306F\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306E\7121\52B9\306A\7D44\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103659166812308135)
,p_name=>'WWV_FLOW_API.MISSING_EXPORT_VERSION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30A4\30F3\30DD\30FC\30C8\3067\306F\30A8\30AF\30B9\30DD\30FC\30C8\306E\30D0\30FC\30B8\30E7\30F3\306F\63D0\4F9B\3055\308C\307E\305B\3093\3067\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104541533816308868)
,p_name=>'WWV_FLOW_API.MUST_USE_APEX_APP_INSTALL'
,p_message_language=>'ja'
,p_message_text=>unistr('\9759\7684ID "%0"\306E\30EA\30E2\30FC\30C8\30FB\30B5\30FC\30D0\30FC\306B\5024\304C\6307\5B9A\3055\308C\3066\3044\307E\305B\3093\3002\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\30A4\30F3\30B9\30C8\30FC\30EB\3059\308B\524D\306B\3001APEX_APPLICATION_INSTALL.SET_REMOTE_SERVER\3092\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104089353511308508)
,p_name=>'WWV_FLOW_API.NEW_SCRIPT_FILE'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103663505316308138)
,p_name=>'WWV_FLOW_API.NOT_COMPATIBLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E92\63DB\6027\304C\3042\308A\307E\305B\3093(\30A8\30AF\30B9\30DD\30FC\30C8\306B\3001%0\306E\30D0\30FC\30B8\30E7\30F3\3067\30B5\30DD\30FC\30C8\3055\308C\3066\3044\306A\3044\30B3\30FC\30EB\304C\542B\307E\308C\3066\3044\308B\5834\5408\304C\3042\308A\307E\3059\3002)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104541913644308869)
,p_name=>'WWV_FLOW_API.REMOTE_SERVER_WARNING_1'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30EA\30E2\30FC\30C8\30FB\30B5\30FC\30D0\30FC"%0" (\9759\7684ID)\306E\8B66\544A\3002'),
'',
unistr('- \3053\306E\30EA\30E2\30FC\30C8\30FB\30B5\30FC\30D0\30FC\306E\5C5E\6027\306F\3001APEX_APPLICATION_INSTALL\3067\8A2D\5B9A\3055\308C\307E\3059\3002'),
unistr('- \4ED6\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3082\3053\306E\30EA\30E2\30FC\30C8\30FB\30B5\30FC\30D0\30FC\30FB\30AA\30D6\30B8\30A7\30AF\30C8\3092\4F7F\7528\3059\308B\3053\3068\306B\6CE8\610F\3057\3066\304F\3060\3055\3044\3002'),
'',
unistr('\3057\305F\304C\3063\3066\3001\30EF\30FC\30AF\30B9\30DA\30FC\30B9\30FB\30EA\30E2\30FC\30C8\30FB\30B5\30FC\30D0\30FC\306E\5C5E\6027\306F\66F4\65B0\3055\308C\307E\3059\3002'),
unistr('- \30D9\30FC\30B9URL:      %1'),
unistr('- HTTPS\30DB\30B9\30C8:    %2'),
unistr('- ORDS\30BF\30A4\30E0\30BE\30FC\30F3: %3')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104541809357308869)
,p_name=>'WWV_FLOW_API.REMOTE_SERVER_WARNING_2'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30EA\30E2\30FC\30C8\30FB\30B5\30FC\30D0\30FC"%0" (\9759\7684ID)\306E\8B66\544A\3002'),
'',
unistr('- PROMPT_ON_INSTALL\5C5E\6027\306F\300C\306F\3044\300D\306B\8A2D\5B9A\3055\308C\307E\3059\3002'),
unistr('- APEX_APPLICATION_INSTALL\306B\5C5E\6027\306F\6307\5B9A\3055\308C\307E\305B\3093\3002'),
'',
unistr('\3057\305F\304C\3063\3066\3001\30EF\30FC\30AF\30B9\30DA\30FC\30B9\30FB\30EA\30E2\30FC\30C8\30FB\30B5\30FC\30D0\30FC\306E\8A2D\5B9A\306F\5909\66F4\3055\308C\306A\3044\307E\307E\3067\3059\3002'),
unistr('- \30D9\30FC\30B9URL:      %1'),
unistr('- HTTPS\30DB\30B9\30C8:    %2'),
unistr('- ORDS\30BF\30A4\30E0\30BE\30FC\30F3: %3'),
'',
unistr('APEX_APPLICATION_INSTALL.SET_REMOTE_SERVER\3092\4F7F\7528\3057\3066\3001\5C5E\6027\3092\5909\66F4\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104541777286308869)
,p_name=>'WWV_FLOW_API.REMOTE_SERVER_WARNING_3'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30EA\30E2\30FC\30C8\30FB\30B5\30FC\30D0\30FC"%0" (\9759\7684ID)\306E\8B66\544A\3002'),
'',
unistr('- PROMPT_ON_INSTALL\5C5E\6027\306F\300C\3044\3044\3048\300D\306B\8A2D\5B9A\3055\308C\307E\3059\3002'),
unistr('- \30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A4\30F3\30DD\30FC\30C8\30FB\30D5\30A1\30A4\30EB\306E\8A2D\5B9A\306F\65E2\5B58\306E\5C5E\6027\3068\306F\7570\306A\308A\307E\3059\3002'),
unistr('- \3053\306E\30EA\30E2\30FC\30C8\30FB\30B5\30FC\30D0\30FC\306F\3001\3053\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306E\4ED6\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\3082\4F7F\7528\3055\308C\307E\3059\3002'),
'',
unistr('\3057\305F\304C\3063\3066\3001\30EF\30FC\30AF\30B9\30DA\30FC\30B9\30FB\30EA\30E2\30FC\30C8\30FB\30B5\30FC\30D0\30FC\306E\8A2D\5B9A\306F\5909\66F4\3055\308C\306A\3044\307E\307E\3067\3059\3002'),
unistr('- \30D9\30FC\30B9URL:      %1'),
unistr('- HTTPS\30DB\30B9\30C8:    %2'),
unistr('- ORDS\30BF\30A4\30E0\30BE\30FC\30F3: %3'),
'',
unistr('APEX_APPLICATION_INSTALL.SET_REMOTE_SERVER\3092\4F7F\7528\3057\3066\3001\5C5E\6027\3092\5909\66F4\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104089295248308507)
,p_name=>'WWV_FLOW_API.REPLACE_SCRIPT_FILE'
,p_message_language=>'ja'
,p_message_text=>unistr('\7F6E\63DB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104327480360308702)
,p_name=>'WWV_FLOW_API.SAME_SOURCE_IDENTIFIER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30FC\30C9\30D0\30C3\30AF\3092\540C\3058\30B7\30B9\30C6\30E0\306B\30A4\30F3\30DD\30FC\30C8\3059\308B\3053\3068\306F\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104089517927308508)
,p_name=>'WWV_FLOW_API.SCRIPT_EXCEEDS_MAX'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AF\30EA\30D7\30C8\306E\30B5\30A4\30BA%0\30D0\30A4\30C8\306F\6700\5927\5024\3092\8D85\3048\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103663140356308138)
,p_name=>'WWV_FLOW_API.SGID_NOT_SET'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30C3\30B1\30FC\30B8\5909\6570g_security_group_id\3092\8A2D\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103659730636308135)
,p_name=>'WWV_FLOW_API.SGID_NOT_SET_IMPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\30A4\30F3\30DD\30FC\30C8\3059\308B\306B\306F\3001\30D1\30C3\30B1\30FC\30B8\5909\6570g_security_group_id\3092\8A2D\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103659375529308135)
,p_name=>'WWV_FLOW_API.UNKOWN_API_VERSION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30B8\30F3\306EAPI\306E\6700\7D42\30D0\30FC\30B8\30E7\30F3\3092\78BA\7ACB\3067\304D\307E\305B\3093\3067\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103659258974308135)
,p_name=>'WWV_FLOW_API.UNKOWN_ENGINE_VERSION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30B8\30F3\306E\30D0\30FC\30B8\30E7\30F3\3092\78BA\7ACB\3067\304D\307E\305B\3093\3067\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103659431764308135)
,p_name=>'WWV_FLOW_API.UPGRADE_NEEDED'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A8\30AF\30B9\30DD\30FC\30C8\3092\30A4\30F3\30DD\30FC\30C8\3059\308B\306B\306F\3001\30A2\30C3\30D7\30B0\30EC\30FC\30C9\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104327373642308702)
,p_name=>'WWV_FLOW_API.WRONG_DEPLOYMENT_SYSTEM'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30C7\30D7\30ED\30A4\30E1\30F3\30C8\30FB\30B7\30B9\30C6\30E0\306B\306F\30D5\30A3\30FC\30C9\30D0\30C3\30AF\304C\30A8\30AF\30B9\30DD\30FC\30C8\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103531737338308038)
,p_name=>'WWV_FLOW_AUTOMATION.CANNOT_COPY_WSM_AUTOMATION'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\30C7\30FC\30BF\30FB\30BD\30FC\30B9\3092\53C2\7167\3059\308B\81EA\52D5\5316\306F\5225\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304B\3089\30B3\30D4\30FC\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103530153765308037)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.NEW_ACTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F\30A2\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103708276427308174)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.PLSQL_REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B\3092\623B\3059PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\304C\5FC5\8981\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103708122008308174)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.QUERY_REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B\304C\5FC5\8981\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103708368636308174)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.REMOTE_SERVER_REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\5BFE\5FDCSQL\30B5\30FC\30D3\30B9\304C\5FC5\8981\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103708042620308174)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.TABLE_REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\540D\304C\5FC5\8981\3067\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103708444603308174)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.WEB_SRC_MODULE_REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\30C7\30FC\30BF\30FB\30BD\30FC\30B9\304C\5FC5\8981\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103708588405308174)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.WHERE_ORDERBY_REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('WHERE\307E\305F\306FORDER BY\53E5\304C\5FC5\8981\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103763606828308218)
,p_name=>'WWV_FLOW_BUILDER.APPLICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103779958545308231)
,p_name=>'WWV_FLOW_BUILDER.NO_FLOW_SELECTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304C\9078\629E\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103763995996308219)
,p_name=>'WWV_FLOW_BUILDER.NO_PAGES'
,p_message_language=>'ja'
,p_message_text=>unistr('<span class="tiny">\30DA\30FC\30B8\304C\898B\3064\304B\308A\307E\305B\3093\3002</font>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103763773008308218)
,p_name=>'WWV_FLOW_BUILDER.PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103764073620308219)
,p_name=>'WWV_FLOW_BUILDER.PAGES'
,p_message_language=>'ja'
,p_message_text=>unistr('%0 <font size=-2>\30DA\30FC\30B8</span>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103950204268308398)
,p_name=>'WWV_FLOW_BUILDER.PAGE_COUNT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30AB\30A6\30F3\30C8:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103950337415308398)
,p_name=>'WWV_FLOW_BUILDER.PAGE_LIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30EA\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103763844177308218)
,p_name=>'WWV_FLOW_BUILDER.PLSQL_LINES_SOURCE'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL %0 %1\306B\306F\3001%2\884C\306E\30BD\30FC\30B9\30FB\30B3\30FC\30C9\304C\542B\307E\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104198908981308609)
,p_name=>'WWV_FLOW_BUILDER.REMOTESQL.CODE_COMPLETION_NOT_SUPPORTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30E2\30FC\30C8SQL\3067\306F\3001\30B3\30FC\30C9\88DC\5B8C\306F\30B5\30DD\30FC\30C8\3055\308C\3066\3044\307E\305B\3093\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104198279335308608)
,p_name=>'WWV_FLOW_BUILDER.REMOTESQL.QUERY_BUILDER_NOT_SUPPORTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30E2\30FC\30C8SQL\3067\306F\3001\30AF\30A8\30EA\30FC\30FB\30D3\30EB\30C0\30FC\306F\30B5\30DD\30FC\30C8\3055\308C\3066\3044\307E\305B\3093\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103796431393308244)
,p_name=>'WWV_FLOW_BUILDER.UPDATABLE_REPORT_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F4\65B0\53EF\80FD\306A\30EC\30DD\30FC\30C8\306E\89E3\6790\30A8\30E9\30FC: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104731315270309027)
,p_name=>'WWV_FLOW_BUTTON.REDIRECT_TO_PAGE_MODE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C0\30A4\30A2\30ED\30B0\30FB\30DA\30FC\30B8\304B\3089\6A19\6E96\30DA\30FC\30B8\306B\30EA\30C0\30A4\30EC\30AF\30C8\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103768372107308222)
,p_name=>'WWV_FLOW_CACHE.OBSOLETE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5EC3\6B62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103768285779308222)
,p_name=>'WWV_FLOW_CACHE.PURGE_DUP_SESSIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\91CD\8907\30BB\30C3\30B7\30E7\30F3\3092\30D1\30FC\30B8\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103736674426308197)
,p_name=>'WWV_FLOW_CHANGE_PASSWORD.PSSWD_CHG_ONLY_YOURS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\306F\3001\30E6\30FC\30B6\30FC\81EA\8EAB\306E\30D1\30B9\30EF\30FC\30C9\306E\307F\5909\66F4\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103736878585308197)
,p_name=>'WWV_FLOW_CHANGE_PASSWORD.PSSWD_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30B9\30EF\30FC\30C9\5909\66F4\30EA\30AF\30A8\30B9\30C8\306E\51E6\7406\4E2D\306B\4E88\671F\3057\306A\3044\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103736314475308196)
,p_name=>'WWV_FLOW_CHANGE_PASSWORD.PSSWD_NOT_SUPPLIED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30B9\30EF\30FC\30C9\304A\3088\3073\78BA\8A8D\7528\30D1\30B9\30EF\30FC\30C9\3092\6307\5B9A\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103736470261308197)
,p_name=>'WWV_FLOW_CHANGE_PASSWORD.PSSWD_NO_MATCH'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30B9\30EF\30FC\30C9\304C\4E00\81F4\3057\3066\3044\307E\305B\3093\3002\3082\3046\4E00\5EA6\5165\529B\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103737438665308197)
,p_name=>'WWV_FLOW_CHECK.ERR_ORCL'
,p_message_language=>'ja'
,p_message_text=>unistr('Oracle\30A8\30E9\30FC: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103737136332308197)
,p_name=>'WWV_FLOW_CHECK.ERR_PROC_PLSQL'
,p_message_language=>'ja'
,p_message_text=>unistr('ERR-1025 PL/SQL\5F0F\306E\51E6\7406\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002  %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103628054699308108)
,p_name=>'WWV_FLOW_COLLECTION.ATTRIBUTE_NUMBER_INVALID'
,p_message_language=>'ja'
,p_message_text=>unistr('\6307\5B9A\3057\305F\30E1\30F3\30D0\30FC\5C5E\6027\756A\53F7%0\306F\7121\52B9\3067\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103768793783308222)
,p_name=>'WWV_FLOW_CONDITIONS.INVALID_EXISTS_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B58\5728\306E\6709\7121\306B\95A2\3059\308B\7121\52B9\306A\6761\4EF6: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103768507018308222)
,p_name=>'WWV_FLOW_CONDITIONS.INVALID_FUNC_BODY_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\306E\7121\52B9\306A\6761\4EF6: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103768411849308222)
,p_name=>'WWV_FLOW_CONDITIONS.INVALID_PLSQL_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\5F0F\306E\7121\52B9\306A\6761\4EF6: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103768660253308222)
,p_name=>'WWV_FLOW_CONDITIONS.INVALID_SQL_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\5F0F\306E\7121\52B9\306A\6761\4EF6: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103782883353308234)
,p_name=>'WWV_FLOW_COPY.EXECUTION_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('wwv_flow_copy\306E\5B9F\884C\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F: %0 >> %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103517899828308028)
,p_name=>'WWV_FLOW_COPY.INVALID_TRANSLATED_APPLICATION_ID'
,p_message_language=>'ja'
,p_message_text=>unistr('\7FFB\8A33\3055\308C\305F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3ID\304C\7121\52B9\3067\3059\3002\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3ID\306F\3001\65E2\5B58\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\3088\3063\3066\4F7F\7528\3055\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103782717233308233)
,p_name=>'WWV_FLOW_COPY.NO_SGID_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30AD\30E5\30EA\30C6\30A3\30FB\30B0\30EB\30FC\30D7ID(\30EF\30FC\30AF\30B9\30DA\30FC\30B9\8B58\5225\60C5\5831)\304C\8A2D\5B9A\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104070482083308492)
,p_name=>'WWV_FLOW_COPY_METADATA.COMPATIBILITY_MODE_210200'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\306E\30EA\30D5\30EC\30C3\30B7\30E5\3092\884C\3046\306B\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3"%0"\306E\4E92\63DB\6027\30E2\30FC\30C9\309221.2\4EE5\4E0A\306B\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\4E92\63DB\6027\30E2\30FC\30C9\306F\300C\30D7\30ED\30D1\30C6\30A3\300D\306E\300C\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5B9A\7FA9\300D\304B\3089\5909\66F4\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104767177396309063)
,p_name=>'WWV_FLOW_COPY_METADATA.INCOMPATIBLE_THEME'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30C6\30FC\30DE\306F\9078\629E\3057\305F\30DE\30B9\30BF\30FC\30FB\30C6\30FC\30DE\3068\4E92\63DB\6027\304C\306A\304F\3001\30C6\30FC\30DE\8B58\5225\5B50\304C\4E00\81F4\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104195813974308606)
,p_name=>'WWV_FLOW_COPY_METADATA.PARENT_NOT_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8\3092\30EA\30D5\30EC\30C3\30B7\30E5\3067\304D\307E\305B\3093\3002\89AA\30C6\30F3\30D7\30EC\30FC\30C8\304C\898B\3064\304B\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103636075196308117)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_AUTH_SETUP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8A8D\8A3C\30B9\30AD\30FC\30E0\3092\30D1\30D6\30EA\30C3\30B7\30E5\3067\304D\307E\305B\3093\3002 %0'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103635467907308117)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_BUTTON_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30DC\30BF\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\30D1\30D6\30EA\30C3\30B7\30E5\3067\304D\307E\305B\3093\3002 %0'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103789620977308239)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_CAL_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30AB\30EC\30F3\30C0\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\30D1\30D6\30EA\30C3\30B7\30E5\3067\304D\307E\305B\3093\3002 %0'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103635287375308117)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_FIELD_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30FC\30EB\30C9\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\30D1\30D6\30EA\30C3\30B7\30E5\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103636168801308117)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_ITEM_HELP'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30A2\30A4\30C6\30E0\30FB\30D8\30EB\30D7\3092\30D1\30D6\30EA\30C3\30B7\30E5\3067\304D\307E\305B\3093\3002 %0'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103635087828308116)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_LIST_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\30D1\30D6\30EA\30C3\30B7\30E5\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103635965787308117)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_LOV'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('LOV\3092\30D1\30D6\30EA\30C3\30B7\30E5\3067\304D\307E\305B\3093\3002 %0'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103635540138308117)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_MENU_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\30D1\30D6\30EA\30C3\30B7\30E5\3067\304D\307E\305B\3093\3002 %0'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103635828227308117)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_NAVBAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30D0\30FC\3092\30D1\30D6\30EA\30C3\30B7\30E5\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103634899916308116)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_PAGE_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\30D1\30D6\30EA\30C3\30B7\30E5\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103635387583308117)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_POPUP_LOV_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DD\30C3\30D7\30A2\30C3\30D7LOV\30C6\30F3\30D7\30EC\30FC\30C8\3092\30D1\30D6\30EA\30C3\30B7\30E5\3067\304D\307E\305B\3093\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103634976949308116)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_REGION_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\30D1\30D6\30EA\30C3\30B7\30E5\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103635159677308117)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_REPORT_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\30D1\30D6\30EA\30C3\30B7\30E5\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103635644374308117)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_SECURITY_SCHEME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30AD\30E5\30EA\30C6\30A3\30FB\30B9\30AD\30FC\30E0\3092\30D1\30D6\30EA\30C3\30B7\30E5\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103635779886308117)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_SHORTCUT'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30B7\30E7\30FC\30C8\30AB\30C3\30C8\3092\30D1\30D6\30EA\30C3\30B7\30E5\3067\304D\307E\305B\3093\3002 %0'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103633291059308115)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_AUTH_SETUP_REFERENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\30B9\30AD\30FC\30E0\53C2\7167ID\3092\524A\9664\3067\304D\307E\305B\3093\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103632192416308114)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_BUTTON_TEMPLATE_REFERENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8\53C2\7167ID\3092\524A\9664\3067\304D\307E\305B\3093\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103789580989308239)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_CAL_TEMPLATE_REFERENCE'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30AB\30EC\30F3\30C0\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\30B5\30D6\30B9\30AF\30E9\30A4\30D6\3067\304D\307E\305B\3093\3002 %0'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103631433002308114)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_FIELD_REFERENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30FC\30EB\30C9\53C2\7167ID\3092\524A\9664\3067\304D\307E\305B\3093\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103633305705308115)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_ITEM_HELP_REFERENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\30FB\30D8\30EB\30D7\53C2\7167ID\3092\524A\9664\3067\304D\307E\305B\3093\3002%0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103631253264308114)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_LIST_REFERENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8\53C2\7167ID\3092\524A\9664\3067\304D\307E\305B\3093\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103631869651308114)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_LOV_REFERENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('LOV\53C2\7167ID\3092\524A\9664\3067\304D\307E\305B\3093\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103632029538308114)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_MENU_TEMPLATE_REFERENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0\30FB\30C6\30F3\30D7\30EC\30FC\30C8\53C2\7167ID\3092\524A\9664\3067\304D\307E\305B\3093\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103631791937308114)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_NAVBAR_REFERENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30D0\30FC\53C2\7167ID\3092\524A\9664\3067\304D\307E\305B\3093\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103631027210308113)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_PAGE_REFERENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\53C2\7167ID\3092\524A\9664\3067\304D\307E\305B\3093\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103631926532308114)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_POPUP_LOV_TEMPLATE_REFERENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DD\30C3\30D7\30A2\30C3\30D7LOV\30C6\30F3\30D7\30EC\30FC\30C8\53C2\7167ID\3092\524A\9664\3067\304D\307E\305B\3093\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103631173056308114)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_REGION_REFERENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\53C2\7167ID\3092\524A\9664\3067\304D\307E\305B\3093\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103631388190308114)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_REPORT_REFERENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\53C2\7167ID\3092\524A\9664\3067\304D\307E\305B\3093\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103631549629308114)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_SECURITY_SCHEME_REFERENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30AD\30E5\30EA\30C6\30A3\30FB\30B9\30AD\30FC\30E0\53C2\7167ID\3092\524A\9664\3067\304D\307E\305B\3093\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103631606480308114)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_SHORTCUT_REFERENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30E7\30FC\30C8\30AB\30C3\30C8\53C2\7167ID\3092\524A\9664\3067\304D\307E\305B\3093\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103634623596308116)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_AUTH_SETUP'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\30B9\30AD\30FC\30E0\3092\30B5\30D6\30B9\30AF\30E9\30A4\30D6\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103634182501308116)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_BUTTON_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\30B5\30D6\30B9\30AF\30E9\30A4\30D6\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104726914179309022)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_CAL_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30EC\30F3\30C0\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\30B5\30D6\30B9\30AF\30E9\30A4\30D6\3067\304D\307E\305B\3093\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103633815765308116)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_FIELD_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30FC\30EB\30C9\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\30B5\30D6\30B9\30AF\30E9\30A4\30D6\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103634796367308116)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_ITEM_HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\30FB\30D8\30EB\30D7\3092\30B5\30D6\30B9\30AF\30E9\30A4\30D6\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103633622831308115)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_LIST_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\30B5\30D6\30B9\30AF\30E9\30A4\30D6\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103634557465308116)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_LOV'
,p_message_language=>'ja'
,p_message_text=>unistr('LOV\3092\30B5\30D6\30B9\30AF\30E9\30A4\30D6\3067\304D\307E\305B\3093\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103634098247308116)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_MENU_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\30B5\30D6\30B9\30AF\30E9\30A4\30D6\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103634437033308116)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_NAVBAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30D0\30FC\3092\30B5\30D6\30B9\30AF\30E9\30A4\30D6\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103633451480308115)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_PAGE_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\30B5\30D6\30B9\30AF\30E9\30A4\30D6\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103633948408308116)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_POPUP_LOV_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DD\30C3\30D7\30A2\30C3\30D7LOV\30C6\30F3\30D7\30EC\30FC\30C8\3092\30B5\30D6\30B9\30AF\30E9\30A4\30D6\3067\304D\307E\305B\3093\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103633541453308115)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_REGION_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\30B5\30D6\30B9\30AF\30E9\30A4\30D6\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103633769345308115)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_REPORT_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\30B5\30D6\30B9\30AF\30E9\30A4\30D6\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103634276065308116)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_SECURITY_SCHEME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30AD\30E5\30EA\30C6\30A3\30FB\30B9\30AD\30FC\30E0\3092\30B5\30D6\30B9\30AF\30E9\30A4\30D6\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103634396367308116)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_SHORTCUT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30E7\30FC\30C8\30AB\30C3\30C8\3092\30B5\30D6\30B9\30AF\30E9\30A4\30D6\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104706066883309005)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_THEME_OPTIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\30FB\30AA\30D7\30B7\30E7\30F3\3092\30B5\30D6\30B9\30AF\30E9\30A4\30D6\3067\304D\307E\305B\3093\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103796908742308245)
,p_name=>'WWV_FLOW_COPY_PAGE.EXECUTION_PAGE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('wwv_flow_copy_page\306E\5B9F\884C\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F: %0 >> %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103783055072308234)
,p_name=>'WWV_FLOW_COPY_PAGE_ITEM.EXECUTION_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('wwv_flow_copy_page_item\306E\5B9F\884C\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F: %0 >> %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103656083066308132)
,p_name=>'WWV_FLOW_COPY_UTIL.OBJ_NOT_FOUND_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30D4\30FC\3059\308B%0(%1)\304C\898B\3064\304B\308A\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103983381819308423)
,p_name=>'WWV_FLOW_COPY_UTIL.SHORTCUT_NAME_UNAVAILABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\3068\3044\3046\540D\524D\306E\30B7\30E7\30FC\30C8\30AB\30C3\30C8\306F\3059\3067\306B\5B58\5728\3057\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103783409116308234)
,p_name=>'WWV_FLOW_COPY_UTIL.UNABLE_TO_FIND_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30D4\30FC\3059\308B\30B7\30E7\30FC\30C8\30AB\30C3\30C8(%0)\304C\898B\3064\304B\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103784437240308235)
,p_name=>'WWV_FLOW_CREATE_FLOW.CREATE_RPT_TEMPLATE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\4F5C\6210(\30EC\30DD\30FC\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306E\4F5C\6210)\3067\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103785068027308235)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COMPUTE_TAB_TARGET_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\4F5C\6210(\30BF\30D6\30FB\30BF\30FC\30B2\30C3\30C8\306E\8A08\7B97)\3067\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103788375164308238)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_AUTHENTICATION_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\4F5C\6210(\8A8D\8A3C\30B9\30AD\30FC\30E0\306E\30B3\30D4\30FC)\3067\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103788231926308238)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_AUTHORIZATION_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\4F5C\6210(\8A8D\53EF\30B9\30AD\30FC\30E0\306E\30B3\30D4\30FC)\3067\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103785815291308236)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_BUTTON_TEMPLATE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\4F5C\6210(\30DC\30BF\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306E\30B3\30D4\30FC)\3067\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103785380270308236)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_FIELD_TEMPLATE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\4F5C\6210(\30D5\30A3\30FC\30EB\30C9\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306E\30B3\30D4\30FC)\3067\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103785631244308236)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_LIST_TEMPLATE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\4F5C\6210(\30EA\30B9\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306E\30B3\30D4\30FC)\3067\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103786046476308236)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_LOV_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\4F5C\6210(LOV\306E\30B3\30D4\30FC)\3067\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103785791453308236)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_MENU_TEMPLATE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\4F5C\6210(\30D6\30EC\30C3\30C9\30AF\30E9\30E0\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306E\30B3\30D4\30FC)\3067\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103785904603308236)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_NAVBAR_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\4F5C\6210(\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30D0\30FC\306E\30B3\30D4\30FC)\3067\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103785252305308236)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_PAGE_TEMPLATE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\4F5C\6210(\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306E\30B3\30D4\30FC)\3067\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103785516403308236)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_REGION_TEMPLATE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\4F5C\6210(\30EA\30FC\30B8\30E7\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306E\30B3\30D4\30FC)\3067\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103785480159308236)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_REPORT_TEMPLATES_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\4F5C\6210(\30EC\30DD\30FC\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306E\30B3\30D4\30FC)\3067\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F: %0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103786102977308236)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_SECURITY_SCHEME_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\4F5C\6210(\30BB\30AD\30E5\30EA\30C6\30A3\30FB\30B9\30AD\30FC\30E0\306E\30B3\30D4\30FC)\3067\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103784367087308235)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_FIELD_TEMPLATE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\4F5C\6210(\30D5\30A3\30FC\30EB\30C9\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306E\4F5C\6210)\3067\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103784653545308235)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_LIST_TEMPLATE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\4F5C\6210(\30EA\30B9\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306E\4F5C\6210)\3067\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103784701784308235)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_MENU_TEMPLATE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\4F5C\6210(\30D6\30EC\30C3\30C9\30AF\30E9\30E0\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306E\4F5C\6210)\3067\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103784156964308235)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_PAGE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\4F5C\6210(\30DA\30FC\30B8\306E\4F5C\6210)\3067\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F: %0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103785169424308235)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_PARENT_TABS_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\4F5C\6210(\89AA\30BF\30D6\306E\4F5C\6210)\3067\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103784269241308235)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_PG_TEMPLATE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\4F5C\6210(\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306E\4F5C\6210)\3067\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103784877126308235)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_POPUP_TEMPLATE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\4F5C\6210(\30DD\30C3\30D7\30A2\30C3\30D7LOV\30C6\30F3\30D7\30EC\30FC\30C8\306E\4F5C\6210)\3067\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103784564843308235)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_REGION_TEMPLATE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\4F5C\6210(\30EA\30FC\30B8\30E7\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8\306E\4F5C\6210)\3067\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103784987515308235)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_STANDARD_TABS_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\4F5C\6210(\6A19\6E96\30BF\30D6\306E\4F5C\6210)\3067\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103784006983308235)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.VERIFY_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306E\691C\8A3C\30A8\30E9\30FC: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103983154043308423)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.ADD_ROWS'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103983024211308422)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.APPLY_MRD'
,p_message_language=>'ja'
,p_message_text=>unistr('MRD\306E\9069\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103982963985308422)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.APPLY_MRU'
,p_message_language=>'ja'
,p_message_text=>unistr('MRU\306E\9069\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103970215187308413)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.CREATE'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104047954766308473)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.CREATE_FORM_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30FC\30E0\30FB\30DA\30FC\30B8\3092\4F5C\6210\3067\304D\307E\305B\3093\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104074426154308495)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.CREATE_GLOBAL_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30ED\30FC\30D0\30EB\30FB\30DA\30FC\30B8\3092\4F5C\6210\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104558812619308886)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.CREATE_IG'
,p_message_language=>'ja'
,p_message_text=>unistr('\5BFE\8A71\30B0\30EA\30C3\30C9\30FB\30DA\30FC\30B8\3092\4F5C\6210\3067\304D\307E\305B\3093\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104048163172308474)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.CREATE_PAGES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306E\4F5C\6210\30A8\30E9\30FC\3067\3059\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104048017856308473)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.CREATE_TABULAR_FORM'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\5F62\5F0F\30D5\30A9\30FC\30E0\30FB\30DA\30FC\30B8\3092\4F5C\6210\3067\304D\307E\305B\3093\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104048242709308474)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.FETCH_ROW'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\304B\3089\884C\3092\30D5\30A7\30C3\30C1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104091663282308509)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.GET_USERNAME_COOKIE'
,p_message_language=>'ja'
,p_message_text=>unistr('Cookie\306E\30E6\30FC\30B6\30FC\540D\3092\53D6\5F97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104187667980308599)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.MENUBAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104047556055308473)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.NAVIGATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E1\30CB\30E5\30FC\30FB\30DA\30FC\30B8%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104048305679308474)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.PROCESS_ROW'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306E\884C\3092\51E6\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104136647855308547)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.RELEASE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30EA\30FC\30B9%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103975859957308417)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.RESET_HIDDEN_ITEM'
,p_message_language=>'ja'
,p_message_text=>unistr('\975E\8868\793A\306E\30A2\30A4\30C6\30E0\306E\30EA\30BB\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103969338182308412)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.RESET_RPT_SEARCH'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\691C\7D22\306E\30EA\30BB\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104064150141308487)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.RPT_MAX_ROW'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\3054\3068\306E\884C\6570\3092\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104060269928308483)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.RUNNING_SCRIPT_X'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AF\30EA\30D7\30C8\306E\5B9F\884C\4E2D: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104091527755308509)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.SET_USERNAME_COOKIE'
,p_message_language=>'ja'
,p_message_text=>unistr('Cookie\306E\30E6\30FC\30B6\30FC\540D\3092\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103977023578308418)
,p_name=>'WWV_FLOW_CREDENTIAL.INVALID_CONTEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30D7\30ED\30B7\30FC\30B8\30E3\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30BB\30C3\30B7\30E7\30F3\304B\3089\8D77\52D5\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103538701074308043)
,p_name=>'WWV_FLOW_CREDENTIAL.NOT_VALID_FOR_URL'
,p_message_language=>'ja'
,p_message_text=>unistr('\8CC7\683C\8A3C\660E\3092\3053\306EURL\30A8\30F3\30C9\30DD\30A4\30F3\30C8\306B\4F7F\7528\3059\308B\3053\3068\306F\8A31\53EF\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103532244731308039)
,p_name=>'WWV_FLOW_CREDENTIAL.URL_MUST_START_WITH_HTTP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8\306EURL\306F\3001http://\307E\305F\306Fhttps://\3067\59CB\307E\308B\5FC5\8981\304C\3042\308A\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104077588493308498)
,p_name=>'WWV_FLOW_CREDENTIAL_DEV.CREDENTIALS_FOR'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306E\8CC7\683C\8A3C\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103786330086308236)
,p_name=>'WWV_FLOW_CSS_API.UNABLE_TO_REMOVE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('css\3092\524A\9664\3067\304D\307E\305B\3093: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104092264048308510)
,p_name=>'WWV_FLOW_CSS_CALENDAR.DRAG_DROP_NOT_SUPPORTED_FOR_WEB_SOURCE'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\30C7\30FC\30BF\30FB\30BD\30FC\30B9\3067\306F\3001\30C9\30E9\30C3\30B0\30FB\30A2\30F3\30C9\30FB\30C9\30ED\30C3\30D7\306F\30B5\30DD\30FC\30C8\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103767829840308222)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_APPLY'
,p_message_language=>'ja'
,p_message_text=>unistr('\5909\66F4\306E\9069\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103649322445308127)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION1'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\76E3\8996\30D5\30A1\30F3\30AF\30B7\30E7\30F3\306F\3001\30A8\30F3\30B8\30F3\306B\5BFE\3057\3001\7D44\8FBC\307F\30BB\30C3\30B7\30E7\30F3\306E\59A5\5F53\6027\30C1\30A7\30C3\30AF\306E\30D6\30FC\30EB\7D50\679C\3092\623B\3057\307E\3059\3002\7D50\679C\304CTRUE\306E\5834\5408\3001\30A8\30F3\30B8\30F3\306F\7D99\7D9A\3057\3066\30DA\30FC\30B8\3092\8868\793A\307E\305F\306F\53D7\3051\5165\308C\307E\3059\3002\7D50\679C\304CFALSE\306E\5834\5408\3001\30A8\30F3\30B8\30F3\306F\7121\52B9\306A\30BB\30C3\30B7\30E7\30F3\30FB\30DA\30FC\30B8\307E\305F\306F\3053\306E\8A8D\8A3C\30B9\30AD\30FC\30E0\3067\6307\5B9A\3057\305FURL\306B\30EA\30C0\30A4\30EC\30AF\30C8\3055\308C\307E\3059(\6B21\3092\53C2\7167)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103650683794308128)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION10'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\76E3\8996\30D5\30A1\30F3\30AF\30B7\30E7\30F3\304CTRUE\3092\623B\3059\3068\3001\30DA\30FC\30B8\30FB\30EC\30F3\30C0\30EA\30F3\30B0\307E\305F\306F\30DA\30FC\30B8\30FB\30D7\30ED\30BB\30B9\306F\7D99\7D9A\3055\308C\307E\3059\3002\7D50\679C\304CFALSE\306E\5834\5408\3001\8A8D\8A3C\30B9\30AD\30FC\30E0\306B\7121\52B9\306A\30BB\30C3\30B7\30E7\30F3\30FB\30BF\30FC\30B2\30C3\30C8\304C\6307\5B9A\3055\308C\3066\3044\306A\3044\305F\3081\3001\30A8\30F3\30B8\30F3\3092\505C\6B62\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\3053\306E\5834\5408\3001\30E6\30FC\30B6\30FC\5B9A\7FA9\306E\30DA\30FC\30B8\76E3\8996\30D5\30A1\30F3\30AF\30B7\30E7\30F3\306F\3001%0\74B0\5883\5916\306E\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8(\5916\90E8\8A8D\8A3C\30DD\30FC\30BF\30EB)\306B\30EA\30C0\30A4\30EC\30AF\30C8\3055\308C\3066\3044\308B\3068\60F3\5B9A\3055\308C\307E\3059\3002\307E\305F\3001\3053\306E\30D5\30A1\30F3\30AF\30B7\30E7\30F3\306F\3001\30B0\30ED\30FC\30D0\30EB\5909\6570g_unrecoverable_error := true\3092\8A2D\5B9A\3057\3066\3001\30A8\30E9\30FC\30FB\30DA\30FC\30B8\3092\8868\793A\305B')
||unistr('\305A\306B\30A8\30F3\30B8\30F3\3092\505C\6B62\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103650763926308128)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION11'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30B8\30F3\306F\3001\3053\306E\8A8D\8A3C\30B9\30AD\30FC\30E0\306E\8A8D\8A3C\524D\306E\51E6\7406\3068\3057\3066\6307\5B9A\3055\308C\3066\3044\308B\6B21\306E\30B3\30FC\30C9\3092\5B9F\884C\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103650852842308128)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION12'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\308C\306F\3001\5024\3092\623B\3055\306A\3044\7121\540D\30D6\30ED\30C3\30AF\3068\3057\3066\5B9F\884C\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103650905451308129)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION13'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B9\30AD\30FC\30E0\3067\306F\3001\8A8D\8A3C\524D\306E\30AB\30B9\30BF\30E0\51E6\7406\30B3\30FC\30C9\306F\6307\5B9A\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103651110222308129)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION14'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30B0\30A4\30F3\30FB\30D5\30A9\30FC\30E0\306B\5165\529B\3059\308B\30E6\30FC\30B6\30FC\540D\3068\30D1\30B9\30EF\30FC\30C9\306E\4EFB\610F\306E\7D44\5408\305B\304C\6709\52B9\3068\307F\306A\3055\308C\307E\3059\3002\5165\529B\3057\305F\30E6\30FC\30B6\30FC\540D\306F\3001\30BB\30C3\30B7\30E7\30F3\304C\7D42\4E86\3059\308B\307E\3067\30ED\30B0\30A4\30F3\30FB\30E6\30FC\30B6\30FC\540D\3068\3057\3066\4F7F\7528\3057\307E\3059\3002\3053\306E\65B9\6CD5\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\958B\767A\4E2D\3001\5B9F\969B\306E\30E6\30FC\30B6\30FC\30FB\30A2\30AB\30A6\30F3\30C8\304C\78BA\7ACB\3055\308C\308B\307E\3067\6709\52B9\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103651213975308129)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION15'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30D3\30EB\30C0\30FC(Cookie\30E6\30FC\30B6\30FC)\306E\30A2\30AB\30A6\30F3\30C8\306B\5BFE\3057\3066\3001\30ED\30B0\30A4\30F3\30FB\30D5\30A9\30FC\30E0\306B\5165\529B\3059\308B\30E6\30FC\30B6\30FC\540D\3068\30D1\30B9\30EF\30FC\30C9\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002\3053\308C\3089\306E\30A2\30AB\30A6\30F3\30C8\306F\3001%0\306B\30ED\30B0\30A4\30F3\3059\308B\305F\3081\306B\30EF\30FC\30AF\30B9\30DA\30FC\30B9\3067\4F7F\7528\3059\308B\30A2\30AB\30A6\30F3\30C8\3068\540C\3058\3067\3059\3002\3053\306E\65B9\6CD5\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30E6\30FC\30B6\30FC\304C\3001\540C\3058\30C7\30FC\30BF\30D9\30FC\30B9\304A\3088\3073\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306E%0\30A2\30AB\30A6\30F3\30C8\3092\6240\6709\3059\308B\958B\767A\8005\3067\3042\308B\5834\5408\306B\6709\52B9\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103583527081308076)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION15A'
,p_message_language=>'ja'
,p_message_text=>unistr('Oracle\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30A2\30AB\30A6\30F3\30C8\306B\5BFE\3057\3066\3001\30ED\30B0\30A4\30F3\30FB\30D5\30A9\30FC\30E0\306B\5165\529B\3057\305F\30E6\30FC\30B6\30FC\540D\3068\30D1\30B9\30EF\30FC\30C9\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002\3053\306E\65B9\6CD5\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30E6\30FC\30B6\30FC\304C\3001\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30A2\30AB\30A6\30F3\30C8\3092\6240\6709\3059\308B\5834\5408\306B\4FBF\5229\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103651315283308129)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION16'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\8A8D\8A3C\30B9\30AD\30FC\30E0\3067\6307\5B9A\3057\305FLDAP\30C7\30A3\30EC\30AF\30C8\30EA\3092\4F7F\7528\3057\3066\3001\30ED\30B0\30A4\30F3\30FB\30D5\30A9\30FC\30E0\306B\5165\529B\3057\305F\30E6\30FC\30B6\30FC\540D\3068\30D1\30B9\30EF\30FC\30C9\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103651411171308129)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION17'
,p_message_language=>'ja'
,p_message_text=>unistr('LDAP\30D1\30E9\30E1\30FC\30BF\306F\6B21\306E\3068\304A\308A\8A2D\5B9A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103652147960308129)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION18'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\30AB\30B9\30BF\30E0\30FB\30B3\30FC\30C9\3092\5B9F\884C\3057\3066\8CC7\683C\8A3C\660E\3092\691C\8A3C\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103652369888308130)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION19'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D44\8FBC\307F\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8\3067\4F7F\7528\3059\308B\30BB\30C3\30B7\30E7\30F3\306E\7D44\8FBC\307F\30BB\30C3\30B7\30E7\30F3\306E\8868\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002\30BB\30C3\30B7\30E7\30F3\304C\5B58\5728\3057\3001\5225\306E\30E6\30FC\30B6\30FC\306B\3088\3063\3066\6240\6709\3055\308C\3066\3044\306A\3044\5834\5408\306F\3001\30ED\30B0\30A4\30F3\30FB\30D5\30A9\30FC\30E0\306E\30E6\30FC\30B6\30FC\540D\3092\4F7F\7528\3057\3066\300C\73FE\5728\306F\8A8D\8A3C\30E6\30FC\30B6\30FC\304C\6240\6709\300D\3068\30DE\30FC\30AF\3057\3066\304F\3060\3055\3044\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103649440354308127)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION2'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\76E3\8996\30D5\30A1\30F3\30AF\30B7\30E7\30F3\306F\3001\30A8\30F3\30B8\30F3\306B\5BFE\3057\3001\30E6\30FC\30B6\30FC\5B9A\7FA9\30BB\30C3\30B7\30E7\30F3\306E\59A5\5F53\6027\30C1\30A7\30C3\30AF\306E\7D50\679C\3067AND\51E6\7406\3055\308C\305F\7D44\8FBC\307F\30BB\30C3\30B7\30E7\30F3\306E\59A5\5F53\6027\30C1\30A7\30C3\30AF\306E\30D6\30FC\30EB\7D50\679C\3092\623B\3057\307E\3059\3002\7D50\679C\304CTRUE\306E\5834\5408\3001\30A8\30F3\30B8\30F3\306F\7D99\7D9A\3057\3066\30DA\30FC\30B8\3092\8868\793A\307E\305F\306F\53D7\3051\5165\308C\307E\3059\3002\7D50\679C\304CFALSE\306E\5834\5408\3001\30A8\30F3\30B8\30F3\306F\7121\52B9\306A\30BB\30C3\30B7\30E7\30F3\30FB\30DA\30FC\30B8\307E\305F\306F\3053\306E\8A8D\8A3C\30B9\30AD\30FC\30E0\3067\6307\5B9A\3057\305FURL\306B\30EA\30C0\30A4\30EC\30AF\30C8\3055\308C\307E\3059(\6B21\3092\53C2\7167)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103652426513308130)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION20'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\3068\3044\3046Cookie\3092\3001\5185\90E8\30BB\30C3\30B7\30E7\30F3\8868\306E\884C\306E\4F4D\7F6E\3092\7279\5B9A\3059\308B\5024\306B\8A2D\5B9A\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103652596880308130)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION22'
,p_message_language=>'ja'
,p_message_text=>unistr('URL\3092\6C7A\5B9A\3057\3066\6B21\306E\30B5\30A4\30C8\306B\30EA\30C0\30A4\30EC\30AF\30C8\3057\3066\304F\3060\3055\3044\3002\30EC\30F3\30C0\30EA\30F3\30B0\30FB\30A8\30F3\30B8\30F3\306B\3088\3063\3066\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\306B\300C\30C7\30A3\30FC\30D7\30FB\30EA\30F3\30AF\300D\304C\8A18\9332\3055\308C\305F\5834\5408\306F\3001\305D\306E\30EA\30F3\30AF\3092\79FB\52D5\5148URL\3068\3057\3066\4F7F\7528\3057\3066\304F\3060\3055\3044\3002\4F7F\7528\3057\306A\3044\5834\5408\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30DB\30FC\30E0\30FB\30EA\30F3\30AF\5C5E\6027\3068\3057\3066\6307\5B9A\3057\305FURL\306B\79FB\52D5\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103652769825308130)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION23'
,p_message_language=>'ja'
,p_message_text=>unistr('\8CC7\683C\8A3C\660E\306E\691C\8A3C\5F8C\3001\30A8\30F3\30B8\30F3\306F\3001\3053\306E\8A8D\8A3C\30B9\30AD\30FC\30E0\306E\8A8D\8A3C\5F8C\306E\51E6\7406\3068\3057\3066\6307\5B9A\3055\308C\3066\3044\308B\6B21\306E\30B3\30FC\30C9\3092\5B9F\884C\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103652879948308130)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION24'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\308C\306F\3001\5024\3092\623B\3055\306A\3044\7121\540D\30D6\30ED\30C3\30AF\3068\3057\3066\5B9F\884C\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103652926800308130)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION25'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B9\30AD\30FC\30E0\3067\306F\3001\8A8D\8A3C\5F8C\306E\30AB\30B9\30BF\30E0\51E6\7406\30B3\30FC\30C9\306F\6307\5B9A\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103653051620308130)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION26'
,p_message_language=>'ja'
,p_message_text=>unistr('\524D\8FF0\306E\624B\9806\3067\6C7A\5B9A\3057\305FURL\306B\30EA\30C0\30A4\30EC\30AF\30C8\3057\3066\304F\3060\3055\3044\3002\7D44\8FBC\307F\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8\304A\3088\3073\7D44\8FBC\307F\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8\304C\30B3\30FC\30EB\3059\308BAPI\3092\4F7F\7528\3057\3066\3001\30ED\30B0\30A4\30F3\51E6\7406\306E\7D42\4E86\3092\30DE\30FC\30AF\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103649523380308127)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION3'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30B9\30BF\30E0\30FB\30ED\30B8\30C3\30AF\3092\4F7F\7528\3057\3066\30DA\30FC\30B8\76E3\8996\30BF\30B9\30AF\3092\5B9F\884C\3057\3066\304F\3060\3055\3044\3002\5404\30DA\30FC\30B8\30FB\30EA\30AF\30A8\30B9\30C8\3067\3001\30A8\30F3\30B8\30F3\306F\6B21\306E\30B3\30FC\30C9\3092\5B9F\884C\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103649659020308128)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION4'
,p_message_language=>'ja'
,p_message_text=>unistr('\524D\8FF0\306E\30D6\30ED\30C3\30AF\306E\30D6\30FC\30EB\7D50\679C\304C\30A8\30F3\30B8\30F3\306B\623B\3055\308C\307E\3059\3002\7D50\679C\304CTRUE\306E\5834\5408\3001\30A8\30F3\30B8\30F3\306F\7D99\7D9A\3057\3066\30DA\30FC\30B8\3092\8868\793A\307E\305F\306F\53D7\3051\5165\308C\307E\3059\3002\7D50\679C\304CFALSE\306E\5834\5408\3001\30A8\30F3\30B8\30F3\306F\7121\52B9\306A\30BB\30C3\30B7\30E7\30F3\30FB\30DA\30FC\30B8\306B\30EA\30C0\30A4\30EC\30AF\30C8\3055\308C\307E\3059(\6B21\3092\53C2\7167)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103649732035308128)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION5'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\958B\767A\8005\306F\3001\6B21\306EAPI\30B3\30FC\30EB\3092\4F7F\7528\3057\3066\3001\7D44\8FBC\307F\65B9\5F0F\306E\30BB\30C3\30B7\30E7\30F3\691C\8A3C\3092\5B9F\884C\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103649827594308128)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION6'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30D6\30FC\30EB\30FB\30D5\30A1\30F3\30AF\30B7\30E7\30F3\306E\7D50\679C\306F\3001\8A8D\8A3C\30B9\30AD\30FC\30E0\3067\6307\5B9A\3055\308C\305F\30E6\30FC\30B6\30FC\5B9A\7FA9\306E\30DA\30FC\30B8\76E3\8996\30D5\30A1\30F3\30AF\30B7\30E7\30F3\306E\305D\306E\4ED6\306E\7D50\679C\3068\7D44\307F\5408\305B\308B\3053\3068\304C\3067\304D\307E\3059\3002\3053\306EAPI\3092\30B3\30FC\30EB\3059\308B\3068\3001%0\3068\3044\3046Cookie\304C\78BA\8A8D\3055\308C\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103649986480308128)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION7'
,p_message_language=>'ja'
,p_message_text=>unistr('Cookie\304C\5B58\5728\3057\3001\305D\306E\30C7\30B3\30FC\30C9\3055\308C\305F\5024\306B\3088\3063\3066\5185\90E8\30BB\30C3\30B7\30E7\30F3\8868\306E\884C\304C\7279\5B9A\3055\308C\308B\5834\5408\3001\30BB\30C3\30B7\30E7\30F3\306F\6709\52B9\3068\307F\306A\3055\308C\3001\30B3\30FC\30EB\5143\306E\30DA\30FC\30B8\76E3\8996\30D5\30A1\30F3\30AF\30B7\30E7\30F3\306BTRUE\5024\304C\623B\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103650193697308128)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION8'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\76E3\8996\30D5\30A1\30F3\30AF\30B7\30E7\30F3\304CTRUE\3092\623B\3059\3068\3001\30DA\30FC\30B8\30FB\30EC\30F3\30C0\30EA\30F3\30B0\307E\305F\306F\30DA\30FC\30B8\30FB\30D7\30ED\30BB\30B9\306F\7D99\7D9A\3055\308C\307E\3059\3002\7D50\679C\304CFALSE\306E\5834\5408\3001\30A8\30F3\30B8\30F3\306F\30DA\30FC\30B8\300C%0\300D\3092\8868\793A\3057\307E\3059\3002\3053\306E\30DA\30FC\30B8\306F\3001\3053\306E\8A8D\8A3C\30B9\30AD\30FC\30E0\3067\7121\52B9\306A\30BB\30C3\30B7\30E7\30F3\30FB\30DA\30FC\30B8\3068\3057\3066\6307\5B9A\3055\308C\3066\3044\308B\305F\3081\3001\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8\3067\3042\308B\3068\307F\306A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103650501524308128)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION9'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\76E3\8996\30D5\30A1\30F3\30AF\30B7\30E7\30F3\306F\3001\30A8\30F3\30B8\30F3\306B\30D6\30FC\30EB\7D50\679C\3092\623B\3057\307E\3059\3002\7D50\679C\304CTRUE\306E\5834\5408\3001\30DA\30FC\30B8\30FB\30EC\30F3\30C0\30EA\30F3\30B0\307E\305F\306F\30DA\30FC\30B8\30FB\30D7\30ED\30BB\30B9\306F\7D99\7D9A\3055\308C\307E\3059\3002\7D50\679C\304CFALSE\306E\5834\5408\3001\30A8\30F3\30B8\30F3\306F%0\306B\30EA\30C0\30A4\30EC\30AF\30C8\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103653144474308130)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.API_COMMON1'
,p_message_language=>'ja'
,p_message_text=>unistr('\901A\5E38\306E\65B9\6CD5\3067\306F\3001\30DA\30FC\30B8\306E\30ED\30B0\30A4\30F3\30FB\30D5\30A9\30FC\30E0\3092\4F7F\7528\3057\3066\30E6\30FC\30B6\30FC\306E\8CC7\683C\8A3C\660E\3092\53D6\5F97\3057\307E\3059\3002\6B21\306B\3001\30DA\30FC\30B8\306E\9001\4FE1\5F8C\306E\51E6\7406\3067\8A8D\8A3C\30E2\30B8\30E5\30FC\30EB\3092\30B3\30FC\30EB\3057\3066\8CC7\683C\8A3C\660E\3092\691C\8A3C\3057\307E\3059\3002\8A8D\8A3C\5F8C\3001\30BB\30C3\30B7\30E7\30F3\767B\9332\30BF\30B9\30AF\304A\3088\3073Cookie\8A2D\5B9A\30BF\30B9\30AF\304C\30DA\30FC\30B8\3067\5B9F\884C\3055\308C\307E\3059\3002\6700\5F8C\306B\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30B9\30BF\30FC\30C8\30FB\30DA\30FC\30B8\306B\30EA\30C0\30A4\30EC\30AF\30C8\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103653273069308130)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.API_COMMON2'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\3088\3046\306A\9001\4FE1\5F8C\306E\51E6\7406\3092\5B9F\884C\3057\3066%0 API: wwv_flow_custom_auth_std\3092\30B3\30FC\30EB\3057\3001\524D\8FF0\306E\3053\308C\3089\306E\30B9\30C6\30C3\30D7\3092\5B9F\884C\3067\304D\307E\3059\3002\6B21\306E2\3064\306E\30A8\30F3\30C8\30EA\30FB\30DD\30A4\30F3\30C8\304C\4F7F\7528\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103653369898308130)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.API_COMMON3'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30B0\30A4\30F3\30FB\30D7\30ED\30B7\30FC\30B8\30E3\3092\30B3\30FC\30EB\3057\3066\3001\3059\3079\3066\306E\30B9\30C6\30C3\30D7\3092\30A8\30F3\30B8\30F3\306B\5B9F\884C\3055\305B\307E\3059\3002\30A8\30F3\30B8\30F3\306F\3001\7D44\8FBC\307F\30BB\30C3\30B7\30E7\30F3\8868\3092\4F7F\7528\3057\3001\30BB\30C3\30B7\30E7\30F3\767B\9332\30BF\30B9\30AF\304A\3088\3073Cookie\8A2D\5B9A\30BF\30B9\30AF\3092\5B9F\884C\3057\307E\3059\3002\3053\306E\8A8D\8A3C\30B9\30AD\30FC\30E0\3067\6307\5B9A\3059\308B\3059\3079\3066\306E\30AB\30B9\30BF\30E0\30FB\30B3\30FC\30C9\306F\3001\8A8D\8A3C\524D\3001\8A8D\8A3C\4E2D\307E\305F\306F\8A8D\8A3C\5F8C\306B\5B9F\884C\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103653437890308130)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.API_COMMON4'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\306F\30E6\30FC\30B6\30FC\81EA\8EAB\304C\5B9F\884C\3057\3001\8A8D\8A3C\5F8C\306E\3059\3079\3066\306E\51E6\7406\306F%0\3067\5B9F\884C\3059\308B\5834\5408\306F\3001post_login\30D7\30ED\30B7\30FC\30B8\30E3\3092\30B3\30FC\30EB\3057\3066\304F\3060\3055\3044\3002\3053\308C\3089\306E2\3064\306E\30A8\30F3\30C8\30EA\30FB\30DD\30A4\30F3\30C8\3092\4F7F\7528\3059\308B\3068\3001\30E6\30FC\30B6\30FC\72EC\81EA\306E\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8\304A\3088\3073\305D\306E\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8\3067\5B9F\884C\3059\308B\3059\3079\3066\306E\51E6\7406\3068\7D44\307F\5408\305B\3066\3001\7D44\8FBC\307F\30ED\30B0\30A4\30F3\51E6\7406\306E\3059\3079\3066\306E\30B9\30C6\30C3\30D7\3092\5B9F\884C\3067\304D\307E\3059\3002\7D44\307F\8FBC\307E\308C\305F\8A8D\8A3C\5F8C\306E\51E6\7406\3092\4F7F\7528\3059\308B\3068\3001\7D44\8FBC\307F\30DA\30FC\30B8\76E3\8996\51E6\7406\304A\3088\3073\30BB\30C3\30B7\30E7\30F3\691C\8A3C\51E6\7406\3082\5B9F\884C\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103650200272308128)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.BUILTIN_LOGIN_PG'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D44\8FBC\307F\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103653535609308131)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN1'
,p_message_language=>'ja'
,p_message_text=>unistr('\5916\90E8\30ED\30B0\30A4\30F3\51E6\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103654376564308131)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN12'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30B0\30A4\30F3URL %0\306F\3001%1\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30DA\30FC\30B8\3092\7121\52B9\306A\30BB\30C3\30B7\30E7\30F3\30FB\30BF\30FC\30B2\30C3\30C8\3068\3057\3066\6307\5B9A\3059\308B\305F\3081\306B\306F\8868\793A\3055\308C\307E\305B\3093\3002\307E\305F\3001\3053\306E\8A8D\8A3C\30B9\30AD\30FC\30E0\306B\30ED\30B0\30A4\30F3\51E6\7406\306E\5024\306F\3042\308A\307E\305B\3093\3002\3053\306E\30DA\30FC\30B8\3092\4F7F\7528\3057\3066\3001\6B21\306E\30B9\30C6\30C3\30D7\3092\5B9F\884C\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103654498503308131)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN13'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306EURL\3067\958B\59CB\3055\308C\305F\30B5\30FC\30D3\30B9\304C\3001%0wwv_custom_auth_std API\3092\4F7F\7528\3057\3066\30BB\30C3\30B7\30E7\30F3\767B\9332\30BF\30B9\30AF\3092\652F\63F4\3057\306A\3044\304B\304E\308A\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\306F\7D44\8FBC\307F\30DA\30FC\30B8\76E3\8996\307E\305F\306F\30BB\30C3\30B7\30E7\30F3\691C\8A3C\51E6\7406\3092\4F7F\7528\3067\304D\306A\3044\3053\3068\306B\6CE8\610F\3057\3066\304F\3060\3055\3044\3002\4EFB\610F\306E\65B9\6CD5\3067\3053\306E\4F5C\696D\3092\5B9F\884C\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103654723747308131)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN14'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30B0\30A4\30F3URL %0\306F\3001%1\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30DA\30FC\30B8\3092\7121\52B9\306A\30BB\30C3\30B7\30E7\30F3\30FB\30BF\30FC\30B2\30C3\30C8\3068\3057\3066\6307\5B9A\3059\308B\305F\3081\306B\306F\8868\793A\3055\308C\307E\305B\3093\3002\3053\306E\30DA\30FC\30B8\3092\4F7F\7528\3057\3066\3001\6B21\306E\30B9\30C6\30C3\30D7\3092\5B9F\884C\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103654849952308132)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN15'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\30B9\30AD\30FC\30E0\306E\30ED\30B0\30A4\30F3\51E6\7406\306E\5024\30BB\30C3\30C8\3092\6B21\306B\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103654946465308132)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN16'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B9\30AD\30FC\30E0\3067\6307\5B9A\3055\308C\3066\3044\308B\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8\306F\3001\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30DA\30FC\30B8[%0]\3067\3059\3002\3053\306E\30DA\30FC\30B8\3092\4F7F\7528\3057\3066\3001\6B21\306E\30B9\30C6\30C3\30D7\3092\5B9F\884C\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103655076700308132)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN17'
,p_message_language=>'ja'
,p_message_text=>unistr('\305F\3060\3057\3001\3053\306E\8A8D\8A3C\30B9\30AD\30FC\30E0\306B\30ED\30B0\30A4\30F3\51E6\7406\306E\5024\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103655152229308132)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN18'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\3053\306E\30DA\30FC\30B8\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\8B58\5225\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8\3067\3042\308B\305F\3081\3001\521D\3081\3066\8868\793A\3059\308B\5834\5408\306F\3001\30DA\30FC\30B8\306E\4E00\90E8\306E\64CD\4F5C\3092\5B9F\884C\3067\304D\307E\305B\3093\3002\30E6\30FC\30B6\30FC\8A8D\8A3C\304C\5B9F\884C\3055\308C\3066\3044\306A\3044\305F\3081\3067\3059\3002\307E\305F\3001\4E00\90E8\306E\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\5909\6570\304A\3088\3073\30BB\30C3\30B7\30E7\30F3\8B58\5225\5909\6570\3082\3001\8A8D\8A3C\5F8C\306B\51E6\7406\3055\308C\308B\901A\5E38\306E\30DA\30FC\30B8\3068\540C\69D8\306B\3001\30DA\30FC\30B8\306E\8A08\7B97\307E\305F\306F\51E6\7406\306B\4F7F\7528\3067\304D\307E\305B\3093\3002\3053\308C\3089\306E\7406\7531\304B\3089\3001\8A8D\8A3C\30B9\30AD\30FC\30E0\306E\30DA\30FC\30B8\756A\53F7\3092\4F7F\7528\3057\305F\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8\306E\8B58\5225\306F\3001\30ED\30B0\30A4\30F3\30FB\30D5\30A9\30FC\30E0\51E6\7406\4EE5\5916\306E\6A5F\80FD\304C\307B\3068\3093\3069\307E\305F\306F\307E\3063\305F\304F\306A\3044\30DA\30FC\30B8\306B\5BFE\3057\3066\306E\307F\9069\3057\3066\3044\307E\3059\3002\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8\3092\3088\308A\30A2\30AF')
||unistr('\30C6\30A3\30D6\306B\3059\308B\5FC5\8981\304C\3042\308B\5834\5408\306F\3001\8A8D\8A3C\30B9\30AD\30FC\30E0\30FB\30A6\30A3\30B6\30FC\30C9\307E\305F\306F\7DE8\96C6\30DA\30FC\30B8\306E\300C\30ED\30B0\30A4\30F3\5148URL\300D\3092\4F7F\7528\3057\3066\304F\3060\3055\3044\3002\30D3\30EB\30C0\30FC\306E\30DA\30FC\30B8\5C5E\6027\30D5\30A9\30FC\30E0\3092\4F7F\7528\3057\3066\516C\958B\30DA\30FC\30B8\306E\5C5E\6027\3092\300C\306F\3044 - \3053\306E\30DA\30FC\30B8\306F\30D1\30D6\30EA\30C3\30AF\3067\3059\300D\306B\8A2D\5B9A\3057\3066\3044\308C\3070\3001'),
unistr('\3053\306E\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8\3092\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8\3068\3057\3066\4F7F\7528\3067\304D\308B\306E\307F\3067\306A\304F\3001\3053\306E\30ED\30B0\3067%0\6A5F\80FD\3092\5B8C\5168\306B\4F7F\7528\3067\304D\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103653688790308131)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN2'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\8A8D\8A3C\30B9\30AD\30FC\30E0\3067\306F\3001\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8\307E\305F\306FURL\306E\3044\305A\308C\3082\3001\7121\52B9\306A\30BB\30C3\30B7\30E7\30F3\30FB\30BF\30FC\30B2\30C3\30C8\306B\5BFE\3057\3066\4F7F\7528\3067\304D\308B\3088\3046\306B\306F\6307\5B9A\3057\307E\305B\3093\3002\3053\308C\306F\3001\30DA\30FC\30B8\76E3\8996\30D5\30A1\30F3\30AF\30B7\30E7\30F3\304C\3053\306E\554F\984C\3092\51E6\7406\3059\308B\3053\3068\3092\610F\5473\3057\307E\3059\3002\3053\306E\30D5\30A1\30F3\30AF\30B7\30E7\30F3\306F\3001\30B7\30F3\30B0\30EB\30FB\30B5\30A4\30F3\30AA\30F3\30FB\30DD\30FC\30BF\30EB\307E\305F\306F\4ED6\306E\30ED\30B0\30A4\30F3\30FB\30B5\30FC\30D0\30FC\306B\30EA\30C0\30A4\30EC\30AF\30C8\3055\308C\307E\3059\3002\307E\305F\3001\3053\306E\8A8D\8A3C\30B9\30AD\30FC\30E0\306B\30ED\30B0\30A4\30F3\51E6\7406\306E\5024\306F\3042\308A\307E\305B\3093\3002\3053\308C\304C\4E88\60F3\5916\306E\7D50\679C\3067\3042\308B\5834\5408\306F\3001\3053\306E\8A8D\8A3C\30B9\30AD\30FC\30E0\3092\7DE8\96C6\3057\3001\7121\52B9\306A\30DA\30FC\30B8\307E\305F\306FURL\3092\6307\5B9A\3057\305F\5F8C\3067\3001\3053\306E\30C1\30E3\30FC\30C8\306E\30D3\30E5\30FC\3092\518D\5EA6\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103653728395308131)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN3'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\8A8D\8A3C\30B9\30AD\30FC\30E0\3067\306F\3001\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8\307E\305F\306FURL\306E\3044\305A\308C\3082\3001\7121\52B9\306A\30BB\30C3\30B7\30E7\30F3\30FB\30BF\30FC\30B2\30C3\30C8\306B\5BFE\3057\3066\4F7F\7528\3067\304D\308B\3088\3046\306B\306F\6307\5B9A\3057\307E\305B\3093\3002\3053\308C\306F\3001\30DA\30FC\30B8\76E3\8996\30D5\30A1\30F3\30AF\30B7\30E7\30F3\304C\3053\306E\554F\984C\3092\51E6\7406\3059\308B\3053\3068\3092\610F\5473\3057\307E\3059\3002\3053\306E\30D5\30A1\30F3\30AF\30B7\30E7\30F3\306F\3001\30B7\30F3\30B0\30EB\30FB\30B5\30A4\30F3\30AA\30F3\30FB\30DD\30FC\30BF\30EB\307E\305F\306F\4ED6\306E\30ED\30B0\30A4\30F3\30FB\30B5\30FC\30D0\30FC\306B\30EA\30C0\30A4\30EC\30AF\30C8\3055\308C\307E\3059\3002\305F\3060\3057\3001\6B21\306B\793A\3059\3068\304A\308A\3001\8A8D\8A3C\30B9\30AD\30FC\30E0\306B\306F\30ED\30B0\30A4\30F3\51E6\7406\306E\5024\30BB\30C3\30C8\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103653808952308131)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN4'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30B0\30A4\30F3URL %0\306F\3001%1\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30DA\30FC\30B8\3092\7121\52B9\306A\30BB\30C3\30B7\30E7\30F3\30FB\30BF\30FC\30B2\30C3\30C8\3068\3057\3066\6307\5B9A\3059\308B\305F\3081\306B\8868\793A\3055\308C\307E\3059\3002\305F\3060\3057\3001\3053\306E\8A8D\8A3C\30B9\30AD\30FC\30E0\306B\30ED\30B0\30A4\30F3\51E6\7406\306E\5024\306F\3042\308A\307E\305B\3093\3002\3053\306E\30DA\30FC\30B8\3092\4F7F\7528\3057\3066\3001\6B21\306E\30B9\30C6\30C3\30D7\3092\5B9F\884C\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103653911732308131)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN6'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\30A8\30F3\30B8\30F3\304C\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8\3092\8868\793A\307E\305F\306F\53D7\3051\5165\308C\308B\3088\3046\306B\3059\308B\306B\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30D3\30EB\30C0\30FC\306E\300C\30DA\30FC\30B8\5C5E\6027\300D\30DA\30FC\30B8\3067\30DA\30FC\30B8\5C5E\6027\300C\306F\3044 - \3053\306E\30DA\30FC\30B8\306F\30D1\30D6\30EA\30C3\30AF\3067\3059\300D\3092\9078\629E\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\9078\629E\3057\306A\304B\3063\305F\5834\5408\3001\30A8\30F3\30B8\30F3\306F\30DA\30FC\30B8\3092\8868\793A\3059\308B\524D\306B\30DA\30FC\30B8\76E3\8996\30D5\30A1\30F3\30AF\30B7\30E7\30F3\306E\5B9F\884C\3092\8A66\884C\3057\307E\3059\3002\30ED\30B0\30A4\30F3\3057\3066\3044\306A\3044\5834\5408\306F\3001\540C\3058URL\3078\306E\30EA\30C0\30A4\30EC\30AF\30C8\304C\8A66\884C\3055\308C\307E\3059\3002\3053\308C\306F\3001\610F\56F3\3057\306A\3044\30EB\30FC\30D7\306E\539F\56E0\3068\306A\308A\307E\3059\3002\30E6\30FC\30B6\30FC\304C\72EC\81EA\306E\30DA\30FC\30B8\76E3\8996\30D5\30A1\30F3\30AF\30B7\30E7\30F3\3092\30B3\30FC\30C9\5316\3059\308B\5834\5408\306F\3001\30AB\30EC\30F3\30C8\30FB\30DA\30FC\30B8\3092\3053\306E')
||unistr('\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8\3068\3057\3001\4ED6\306E\30DA\30FC\30B8\3068\7570\306A\308B\65B9\6CD5\3067\51E6\7406\3059\308B\30BF\30A4\30DF\30F3\30B0\3092\8A8D\8B58\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\30DA\30FC\30B8\756A\53F7\3067\6307\5B9A\3067\304D\308B\5834\5408\306F\554F\984C\3042\308A\307E\305B\3093\3002\30D6\30FC\30EB\30FB\30D5\30A1\30F3\30AF\30B7\30E7\30F3wwv_flow_custom_auth.current_page_is_public\3092\4F7F\7528\3057\3066\3001\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5185\306E\4ED6\306E\30DA\30FC\30B8\306Epublic\5C5E\6027\3092\8A8D\8B58\3059\308B\65B9\6CD5\304C\3088\308A\4E00\822C\7684\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103654090901308131)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN7'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30B0\30A4\30F3URL %0\306F\3001%1\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30DA\30FC\30B8\3092\7121\52B9\306A\30BB\30C3\30B7\30E7\30F3\30FB\30BF\30FC\30B2\30C3\30C8\3068\3057\3066\6307\5B9A\3059\308B\305F\3081\306B\8868\793A\3055\308C\307E\3059\3002\3053\306E\30DA\30FC\30B8\3092\4F7F\7528\3057\3066\3001\6B21\306E\30B9\30C6\30C3\30D7\3092\5B9F\884C\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103654155434308131)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN8'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\30B9\30AD\30FC\30E0\306E\30ED\30B0\30A4\30F3\51E6\7406\306E\5024\30BB\30C3\30C8\3092\6B21\306B\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103654272160308131)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN9'
,p_message_language=>'ja'
,p_message_text=>unistr('Oracle Application Server Single Sign-On Server\306F\3001\30E6\30FC\30B6\30FC\8A8D\8A3C\306E\7D42\4E86\5F8C\3001\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\30EA\30C0\30A4\30EC\30AF\30C8\3055\308C\307E\3059\3002\30A8\30F3\30C8\30EA\30FB\30DD\30A4\30F3\30C8\306F\3001%0\30B9\30AD\30FC\30DE\5185\306Ewwv_flow_custom_auth_sso.process_success\30D7\30ED\30B7\30FC\30B8\30E3\3067\3059\3002 %0\306F\3001Oracle Application Server Single Sign-On\306E\30D1\30FC\30C8\30CA\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3068\3057\3066\767B\9332\3055\308C\3001\30ED\30B0\30A4\30F3\30FB\30B5\30FC\30D0\30FC\306B\5BFE\3059\308B\3059\3079\3066\306E\30A4\30F3\30BF\30D5\30A7\30FC\30B9\3092\7BA1\7406\3067\304D\307E\3059\3002 ')
||unistr('\305F\3060\3057\3001\5FC5\8981\306B\5FDC\3058\3066\3001\81EA\5206\306E\30B9\30AD\30FC\30DE\306B\72EC\81EA\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\767B\9332\3059\308B\3053\3068\3082\3067\304D\307E\3059\3002 \72EC\81EA\306E\30DA\30FC\30B8\76E3\8996\3092\4F5C\6210\3059\308B\304B\3001\307E\305F\306F\8A8D\8A3C\30B9\30AD\30FC\30E0\30FB\30AE\30E3\30E9\30EA\304B\3089Portal-SSO\30B9\30AD\30FC\30E0(\30D1\30FC\30C8\30CA\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3068\3057\3066\306E\72EC\81EA\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3)\306B\57FA\3065\3044\3066\8A8D\8A3C\30B9\30AD\30FC\30E0\3092\4F5C\6210\3059\308B\3053\3068\3082\3067\304D\307E\3059\3002\4F5C\6210\3055\308C\305F\30B9\30AD\30FC\30E0\306F\3001\7D44\8FBC\307FSSO\30DA\30FC\30B8\76E3\8996wwv_flow_custom_auth_std.portal_sso_sentry_v1\3068\547C\3070\308C\307E\3059\3002 \3053\306E\30D5\30A1\30F3\30AF\30B7\30E7\30F3\3067\306F\3001\73FE\884C\306E\8A8D\8A3C\30B9\30AD\30FC\30E0\304C\3001\30E6\30FC\30B6\30FC\306E\30D1\30FC\30C8\30CA')
||unistr('\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\540D\304COracle Application Server Single Sign-On\306B\767B\9332\6E08\3067\3042\308B\3053\3068\3092\8A8D\8B58\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\8A8D\8A3C\30B9\30AD\30FC\30E0\4F5C\6210\30A6\30A3\30B6\30FC\30C9\3067\30D1\30FC\30C8\30CA\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\540D\3092\5165\529B\3059\308B\3088\3046\306B\6C42\3081\3089\308C\307E\3059\3002\6C42\3081\3089\308C\306A\304B\3063\305F\5834\5408\306F\3001\4F5C\6210\3057\305F\30B9\30AD\30FC\30E0\3092\7DE8\96C6\3057\3066\8FFD\52A0\307E\305F\306F\5909\66F4\3067\304D\307E\3059\3002\540D\524D\306F\3001\767B\9332\3055\308C\3066\3044\308B\3068\304A\308A\306B\3001\5927/\5C0F\6587\5B57\3092\533A\5225\3057\3066\5165\529B\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002 \307E\305F\3001\30E6\30FC\30B6\30FC\306F\3001\72EC\81EA\306EURLC\53D7\4FE1\8005\30D7\30ED\30B7\30FC\30B8\30E3\3092\4F5C\6210\3057\3001Oracle Application Server Si')
||unistr('ngle Sign-On\306B\767B\9332\3057\305F\3068\304A\308A\306B\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\540D\3092\5165\529B\3057\3066\3001\305D\306E\30D7\30ED\30B7\30FC\30B8\30E3\304B\3089wwv_flow_custom_auth_sso.process_success API\3092\30B3\30FC\30EB\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\3053\308C\306B\3088\3063\3066\3001\8A8D\8A3C\5F8C\306B\3001%0\3078\306E\30BB\30C3\30B7\30E7\30F3\767B\9332\304C\5B9F\884C\3055\308C\307E\3059\3002\72EC\81EA\306E\30DA\30FC\30B8\76E3\8996\3092\4F5C\6210\3057\305F\5834\5408\3001\8A8D\8A3C\304C\5FC5\8981\3067\3042\308B\3068\5224\65AD\3055\308C\308B\3068\3001\30DA\30FC\30B8\76E3\8996\306B\3088\3063\3066wwv_flow_custom_auth_sso.portal_sso_redirect API\304C\30B3\30FC\30EB\3055\308C\3001\30ED\30B0\30A4\30F3\30FB\30B5\30FC\30D0\30FC\3078\306E\30EA\30C0\30A4\30EC\30AF\30C8\304C\5B9F')
||unistr('\884C\3055\308C\307E\3059\3002\4F5C\6210\3057\305F\30D1\30FC\30C8\30CA\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\767B\9332\540D\3092\3053\306E\30D7\30ED\30B7\30FC\30B8\30E3\306B\6E21\3059\5FC5\8981\304C\3042\308A\307E\3059\3002\8A73\7D30\306F\3001%0\306E\30C9\30AD\30E5\30E1\30F3\30C8\304A\3088\3073%1\306E\30C9\30AD\30E5\30E1\30F3\30C8\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103654681051308131)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_POST_AUTH_PROC'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\5F8C\306E\51E6\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103654533173308131)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_PRE_AUTH_PROC'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\524D\306E\51E6\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103649065826308127)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHK_COOKIE1'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D44\8FBC\307F\30ED\30B8\30C3\30AF\3092\4F7F\7528\3057\3066\3001[%0]\3068\3044\3046\540D\524D\306ECookie\3092\78BA\8A8D\3057\307E\3059\3002Cookie\304C\5B58\5728\3057\3001\305D\306E\30C7\30B3\30FC\30C9\5024\304C\5185\90E8\30BB\30C3\30B7\30E7\30F3\8868\306E\884C\3092\7279\5B9A\3059\308B\5834\5408\3001\30BB\30C3\30B7\30E7\30F3\306F\6709\52B9\3067\3042\308B\3068\307F\306A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103649242906308127)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.COMPUTE_RETURN_VALUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\623B\308A\5024\3092\8A08\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103651083656308129)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CREDENTIALS_VERIFICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\8CC7\683C\8A3C\660E\306E\691C\8A3C(\8A8D\8A3C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103652606882308130)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CUST_POST_AUTH_PROC'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\5F8C\306E\30AB\30B9\30BF\30E0\51E6\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103645713621308124)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ERR_MALFORMED_LOGIN_ARGS2'
,p_message_language=>'ja'
,p_message_text=>unistr('wwv_flow_custom_auth_std.login--p_flow_page:p_session_id:p_entry_point:%0:%1:%2\306B\5BFE\3059\308B\7121\52B9\306A\30A8\30F3\30C8\30EA\30FB\30DD\30A4\30F3\30C8\5F15\6570\3002  ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103645691642308124)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ERR_NULL_LOGIN_ARG'
,p_message_language=>'ja'
,p_message_text=>unistr('wwv_flow_custom_auth_std.login--p_flow_page:%0\306B\5BFE\3059\308BNULL\306Ep_session_id\5F15\6570\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103645544244308124)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ERR_RUN_CRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\8CC7\683C\8A3C\660E\78BA\8A8D\30D5\30A1\30F3\30AF\30B7\30E7\30F3\3092\5B9F\884C\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103650080001308128)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.INVALID_SESS_TARGET'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9\306A\30BB\30C3\30B7\30E7\30F3\30FB\30BF\30FC\30B2\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103651788562308129)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_DN'
,p_message_language=>'ja'
,p_message_text=>unistr('LDAP\691C\7D22\30D9\30FC\30B9:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103651843874308129)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_EDIT_FN'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\30D6\30ED\30C3\30AF\3092\4F7F\7528\3057\3066\3001DBMS_LDAP.SIMPLE_BIND_S\3092\30B3\30FC\30EB\3059\308B\524D\306B\30D5\30A1\30F3\30AF\30B7\30E7\30F3\3092\30B3\30FC\30EB\3057\307E\3059\3002 \30ED\30B0\30A4\30F3\30FB\30D5\30A9\30FC\30E0\3067\53D6\5F97\3057\305F\30E6\30FC\30B6\30FC\540D\304C\305D\306E\30D5\30A1\30F3\30AF\30B7\30E7\30F3\306B\6E21\3055\308C\307E\3059\3002\3053\306E\30D5\30A1\30F3\30AF\30B7\30E7\30F3\306F\3001LDAP\691C\7D22\30D9\30FC\30B9\3067%LDAP_USER%\306B\7F6E\304D\63DB\3048\3089\308C\308B\5024\3092\623B\3057\307E\3059(\524D\8FF0\306E\5185\5BB9\3092\53C2\7167)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103651937419308129)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_EDIT_FN2'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B3\30FC\30C9\30FB\30D6\30ED\30C3\30AF\306B\306F\6B21\306E\30B7\30B0\30CD\30C1\30E3\304C\5FC5\8981\3067\3059\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103652095867308129)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_EDIT_FN3'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6A5F\80FD\3092\4F7F\7528\3059\308B\3068\3001\30ED\30B0\30A4\30F3\30FB\30D5\30A9\30FC\30E0\306B\5165\529B\3057\305F\30E6\30FC\30B6\30FC\540D\3092\3001LDAP\30C7\30A3\30EC\30AF\30C8\30EA\306E\30A8\30F3\30C8\30EA\3068\4E00\81F4\3059\308B\3059\3079\3066\306E\5F62\5F0F\306B\5909\63DB\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103651511435308129)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_HOST'
,p_message_language=>'ja'
,p_message_text=>unistr('LDAP\30DB\30B9\30C8:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103651612028308129)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_PORT'
,p_message_language=>'ja'
,p_message_text=>unistr('LDAP\30DD\30FC\30C8:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103648517253308127)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LOGIN_PG1'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3(%0)\3067\306F\3001\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8\3068\3057\3066\30DA\30FC\30B8%1\3092\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103648680972308127)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LOGIN_PG2'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8%0\3092\30EA\30AF\30A8\30B9\30C8\3057\3066\3082\3001\8A8D\8A3C\78BA\8A8D\306F\5B9F\884C\3055\308C\305A\3001\305D\306E\30DA\30FC\30B8\304C\8868\793A\307E\305F\306F\53D7\3051\5165\308C\3089\308C\307E\3059\3002\3053\308C\306B\3088\3063\3066\3001\8A8D\8A3C\304C\5B9F\884C\3055\308C\308B\524D\306B\3001\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8\3092\8868\793A\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103648473393308127)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LOGIN_PG_HANDLING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8\306E\51E6\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103648747901308127)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.PAGE_SENTRY_FUNCTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\76E3\8996\30D5\30A1\30F3\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103648801248308127)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.PG_SENTRY1'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D44\8FBC\307F\30ED\30B8\30C3\30AF\3092\4F7F\7528\3057\3066\30DA\30FC\30B8\76E3\8996\30BF\30B9\30AF\3092\5B9F\884C\3057\3066\304F\3060\3055\3044\3002\5404\30DA\30FC\30B8\30FB\30EA\30AF\30A8\30B9\30C8\3067\3001\30DA\30FC\30B8\76E3\8996\30D5\30A1\30F3\30AF\30B7\30E7\30F3\304C\30BB\30C3\30B7\30E7\30F3\691C\8A3C\3092\5B9F\884C\3057\3001\623B\308A\5024\3092\8A08\7B97\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103652268170308130)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.POST_AUTH_PROC'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\5F8C\306E\51E6\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103649147566308127)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.SESS_VERIFY1'
,p_message_language=>'ja'
,p_message_text=>unistr('\8FFD\52A0\306E\30E6\30FC\30B6\30FC\5B9A\7FA9\30B3\30FC\30C9\3092\4F7F\7528\3057\3066\3001\30BB\30C3\30B7\30E7\30F3\304C\6709\52B9\304B\3069\3046\304B\3092\5224\65AD\3057\3066\304F\3060\3055\3044\3002\7D44\8FBC\307F\30BB\30C3\30B7\30E7\30F3\306E\59A5\5F53\6027\30C1\30A7\30C3\30AF\304B\3089TRUE\304C\623B\3055\308C\305F\5F8C\3001\6B21\306E\30B3\30FC\30C9\3092\5B9F\884C\3057\3001\305D\306E\30D6\30FC\30EB\623B\308A\5024\3092\899A\3048\3066\304A\3044\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103648951307308127)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.SESS_VERIFY_FUNCTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30C3\30B7\30E7\30F3\691C\8A3C\30D5\30A1\30F3\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103650357915308128)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.SSO_SERVER'
,p_message_language=>'ja'
,p_message_text=>'Oracle Application Server Single Sign-On Server'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103650488205308128)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.THE_URL'
,p_message_language=>'ja'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103797247785308245)
,p_name=>'WWV_FLOW_DATALOAD_XML.ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103535680964308041)
,p_name=>'WWV_FLOW_DATA_LOADER.LOADING_JOB_STARTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30ED\30FC\30C9\30FB\30B8\30E7\30D6\304C\958B\59CB\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103706573668308172)
,p_name=>'WWV_FLOW_DATA_PARSER.FILE_TOO_LARGE'
,p_message_language=>'ja'
,p_message_text=>unistr('%1 MB\3088\308A\5927\304D\3044%0\30D5\30A1\30A4\30EB\306F\3001\30C7\30FC\30BF\306E\30ED\30FC\30C9\3067\30B5\30DD\30FC\30C8\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104092135365308510)
,p_name=>'WWV_FLOW_DATA_PROFILE.INVALID_SQL_EXPR'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9\306ASQL\5F0F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103625934028308106)
,p_name=>'WWV_FLOW_DATA_QUICK_FLOW.ANALYZE_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\3092\89E3\6790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103626326034308107)
,p_name=>'WWV_FLOW_DATA_QUICK_FLOW.VIEW_BY'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\65B9\6CD5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103786435078308236)
,p_name=>'WWV_FLOW_DEBUGTAB_BIU_FER.INVALID_DATE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5\4ED8\66F8\5F0F\304C\7121\52B9\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103766051025308220)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.DEBUG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D0\30C3\30B0:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103766184923308220)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.FEATURE_NOT_SUPPORTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30D0\30FC\30B8\30E7\30F3\3067\306F\6A5F\80FD\304C\30B5\30DD\30FC\30C8\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103763211212308218)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.FUNC_RETURN_QUERY_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('ERR-1101 \554F\5408\305B\3092\623B\3059\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\51E6\7406\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103766383665308220)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.HELP_REQUEST_ERR2'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC4323: \30D8\30EB\30D7\306E\30EA\30AF\30A8\30B9\30C8\3067\3001\30D8\30EB\30D7\8868\793A\5BFE\8C61\306E\6570\5024\30DA\30FC\30B8ID\304C\6307\5B9A\3055\308C\307E\305B\3093\3067\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103763018011308218)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.PLSQL_EXP_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('ERR-1025 PL/SQL\5F0F\306E\51E6\7406\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002  %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103763160923308218)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.PLSQL_EXP_FOOTER_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3=%0 \30DA\30FC\30B8=%1 SQLERRM=%2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103765818873308220)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.PRINT_SHORTCUT_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30E7\30FC\30C8\30AB\30C3\30C8\3092\51FA\529B\3067\304D\307E\305B\3093: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103763327208308218)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.PROC_CURR_COND_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('ERR-1108 \30A2\30A4\30C6\30E0\304C\30AB\30EC\30F3\30C8\3068\306A\308B\6761\4EF6\3092\51E6\7406\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103765979268308220)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.RENDER_CHART_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\306E\30EC\30F3\30C0\30EA\30F3\30B0\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103916119959308371)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.RENDER_COMP_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30DD\30FC\30CD\30F3\30C8\3092\30EC\30F3\30C0\30EA\30F3\30B0\3067\304D\307E\305B\3093: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103560231428308059)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.RENDER_DYN_LIST_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\52D5\7684\30EA\30B9\30C8\30FB\30EA\30FC\30B8\30E7\30F3\306E\30EC\30F3\30C0\30EA\30F3\30B0\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103766278406308220)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.REQUEST_FOR_HELP_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC4322: \30D8\30EB\30D7\306E\30EA\30AF\30A8\30B9\30C8\3067\9069\5207\306A\69CB\6587\304C\4F7F\7528\3055\308C\307E\305B\3093\3067\3057\305F\3002\6709\52B9\306A\30DA\30FC\30B8\756A\53F7\304C\5FC5\8981\306A\5834\5408\306B\3001\30EA\30AF\30A8\30B9\30C8\304CNULL\3067\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103792804148308241)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.UNABLE_TO_BIND_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\3092\30D0\30A4\30F3\30C9\3067\304D\307E\305B\3093\3002\8907\6570\30D0\30A4\30C8\306E\30A2\30A4\30C6\30E0\306B\4E8C\91CD\5F15\7528\7B26\3092\4F7F\7528\3059\308B\304B\3001\30A2\30A4\30C6\30E0\306E\9577\3055\304C30\30D0\30A4\30C8\4EE5\4E0B\3067\3042\308B\3053\3068\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002v()\69CB\6587\3092\4F7F\7528\3057\3066\300130\30D0\30A4\30C8\3092\8D85\3048\308B\30A2\30A4\30C6\30E0\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104330969588308705)
,p_name=>'WWV_FLOW_DML.BLOB_COLUMN_NOT_IN_REPORT_COLUMN_FORMAT_MASK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\5217\306EBLOB\5217\540D\306B\5FC5\8981\306A\66F8\5F0F\30DE\30B9\30AF\306FDOWNLOAD:TABLE_NAME:BLOB_COLUMN...\3067\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104685593352308987)
,p_name=>'WWV_FLOW_DML.COLUMN_NOT_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217%0\304C\8868%1\3067\898B\3064\304B\308A\307E\305B\3093\3067\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103788599730308238)
,p_name=>'WWV_FLOW_DML.DML_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('DML\3067\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F: p_rowid=%0\3001p_alt_rowid=%1\3001p_rowid2=%2\3001p_alt_rowid2=%3\3002%4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103622573053308104)
,p_name=>'WWV_FLOW_DML.DML_INSERT_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\633F\5165\64CD\4F5C\3092\5B9F\884C\3067\304D\307E\305B\3093\3002  %0  %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103944022471308393)
,p_name=>'WWV_FLOW_DML.DML_INVALID_NUMBER_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217%1\306E\6570\5024%0\304C\7121\52B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103629214490308112)
,p_name=>'WWV_FLOW_DML.INVALID_ACTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30AA\30D6\30B8\30A7\30AF\30C8\306B\5BFE\3059\308B\64CD\4F5C%0\306F\7121\52B9\3067\3059\3002 (%1)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104330041523308704)
,p_name=>'WWV_FLOW_DML.INVALID_TABLE_OWNER'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\306E\6240\6709\8005\304C\7121\52B9\3067\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104330165007308704)
,p_name=>'WWV_FLOW_DML.INVALID_URL'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9\306AURL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104329981010308704)
,p_name=>'WWV_FLOW_DML.LAST_UPDATED_COLUMN_HAS_TO_BE_DATE'
,p_message_language=>'ja'
,p_message_text=>unistr('"%2"\3078\306E\66F4\65B0\306E\30C8\30E9\30C3\30AD\30F3\30B0\306B\4F7F\7528\3055\308C\3066\3044\308B\6700\7D42\66F4\65B0\30C7\30FC\30BF\5217"%0"\306E\30C7\30FC\30BF\578B"%1"\306F\3001\65E5\4ED8\307E\305F\306F\30BF\30A4\30E0\30B9\30BF\30F3\30D7\30FB\30C7\30FC\30BF\578B\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104330296166308704)
,p_name=>'WWV_FLOW_DML.NOT_CALLED_FROM_PAGE_WHICH_CONTAINS_FILE_ITEM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC: FILE\30BF\30A4\30D7\306E\30A2\30A4\30C6\30E0\540D\3092\542B\3080\30D5\30A9\30FC\30E0\30FB\30DA\30FC\30B8\304B\3089\30B3\30FC\30EB\3059\308B\5FC5\8981\304C\3042\308A\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104330590598308705)
,p_name=>'WWV_FLOW_DML.NO_FORMAT_MASK'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F8\5F0F\30DE\30B9\30AF\304C\898B\3064\304B\308A\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104331024145308705)
,p_name=>'WWV_FLOW_DML.PK_NOT_IN_REPORT_COLUMN_FORMAT_MASK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\5217\306E\4E3B\30AD\30FC1\5217\540D\306B\5FC5\8981\306A\66F8\5F0F\30DE\30B9\30AF\306FDOWNLOAD:TABLE_NAME:BLOB_COLUMN:PK1_COL_NAME...\3067\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104685695266308987)
,p_name=>'WWV_FLOW_DML.TABLE_NOT_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\307E\305F\306F\30D3\30E5\30FC%0\304C\898B\3064\304B\308A\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104330802064308705)
,p_name=>'WWV_FLOW_DML.TABLE_NOT_IN_REPORT_COLUMN_FORMAT_MASK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\5217\306E\8868\540D\306B\5FC5\8981\306A\66F8\5F0F\30DE\30B9\30AF\306FDOWNLOAD:TABLE_NAME...\3067\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104330744223308705)
,p_name=>'WWV_FLOW_DML.WRONG_FORMAT_MASK'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F8\5F0F\30DE\30B9\30AF\306B\306F\3001\30B3\30ED\30F3\533A\5207\308A\306E\5F15\6570\30924\3064\4EE5\4E0A\542B\3081\308B\5FC5\8981\304C\3042\308A\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104330666041308705)
,p_name=>'WWV_FLOW_DML.WRONG_FORMAT_MASK_PREFIX'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F8\5F0F\30DE\30B9\30AF\306F\3001DOWNLOAD\307E\305F\306FIMAGE\3067\59CB\3081\308B\5FC5\8981\304C\3042\308A\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103976177692308417)
,p_name=>'WWV_FLOW_EXEC.INVALID_COLUMN_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B\306E\5217\540D"%0"\304C\7121\52B9\3067\3059\3002\5217\306B\306F\5FC5\305A\4E00\610F\306E\5225\540D\3092\4F7F\7528\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103621465979308103)
,p_name=>'WWV_FLOW_EXEC.NOT_ALLOWED_ON_WEB_SOURCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\64CD\4F5C\306FREST\30C7\30FC\30BF\30FB\30BD\30FC\30B9\3067\306F\8A31\53EF\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103976089742308417)
,p_name=>'WWV_FLOW_EXEC.WRONG_COLUMN_COUNT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B\3067\9078\629E\3057\305F\5217\306E\6570\304C\6B63\3057\304F\3042\308A\307E\305B\3093\3002\5C5E\6027\306E\30D8\30EB\30D7\3067\8A73\7D30\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103531536672308038)
,p_name=>'WWV_FLOW_EXEC.WRONG_COLUMN_DATA_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\6587\306E%0\306E\30C7\30FC\30BF\578B\304C\6B63\3057\304F\3042\308A\307E\305B\3093\3002\5217# %1\306F%2\3067\3059\304C\3001\6B63\3057\304F\306F%3\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104077095441308497)
,p_name=>'WWV_FLOW_EXEC_DEV.COLUMN_NOT_UNIQUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\540D"%0"\306FSQL\554F\5408\305B\3067\3059\3067\306B\4F7F\7528\3055\308C\3066\3044\307E\3059\3002\5217\306B\306F\5FC5\305A\4E00\610F\306E\5225\540D\3092\4F7F\7528\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104076936541308497)
,p_name=>'WWV_FLOW_EXEC_DEV.INVALID_COLUMN_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('LOV SQL\554F\5408\305B\306E\5217\540D"%0"\304C\7121\52B9\3067\3059\3002\5217\306B\306F\5FC5\305A\6709\52B9\306A\5225\540D\3092\4F7F\7528\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104076775445308497)
,p_name=>'WWV_FLOW_EXEC_DEV.INVALID_SQL_RETURNED_BY_FUNCTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\89E3\6790\3067\554F\5408\305B\7D50\679C\304C"%0"\306B\623B\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104076841896308497)
,p_name=>'WWV_FLOW_EXEC_DEV.WRONG_COLUMN_COUNT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B\3067\9078\629E\3057\305F\5217\306E\6570\304C\6B63\3057\304F\3042\308A\307E\305B\3093\3002\5C5E\6027\306E\30D8\30EB\30D7\3067\8A73\7D30\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103531097073308038)
,p_name=>'WWV_FLOW_EXEC_WEB_SRC.MODULE_TYPE_NOT_SUPPORTED'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\30C7\30FC\30BF\30FB\30BD\30FC\30B9\30FB\30BF\30A4\30D7%0\306F\30B5\30DD\30FC\30C8\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103532938323308039)
,p_name=>'WWV_FLOW_EXPORT_INT.DUPLICATE_FILENAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\91CD\8907\3059\308B\30D5\30A1\30A4\30EB\540D: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104725334949309021)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.APPLICATION_ITEM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104725127883309021)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.CONSTANT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9A\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104724825061309020)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.FUNCTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30F3\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104725956996309021)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.KEYWORD'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AD\30FC\30EF\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104725866138309021)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.MATERIALIZED VIEW'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30C6\30EA\30A2\30E9\30A4\30BA\30C9\30FB\30D3\30E5\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104725473806309021)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.PACKAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30C3\30B1\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104725214102309021)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.PAGE_ITEM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104724764015309020)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.PROCEDURE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30ED\30B7\30FC\30B8\30E3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104725516501309021)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.SEQUENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104725694661309021)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.TABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104726059342309021)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104724994139309020)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104725009782309020)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.VARIABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5909\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104725713570309021)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.VIEW'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D3\30E5\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104289920187308675)
,p_name=>'WWV_FLOW_F4000_UTIL.INVALID_LOV_SQL'
,p_message_language=>'ja'
,p_message_text=>unistr('LOV SQL\554F\5408\305B\306E\89E3\6790\306B\5931\6557\3057\307E\3057\305F\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104054754829308479)
,p_name=>'WWV_FLOW_F4000_UTIL.INVALID_QUERY_FILTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9\306A\554F\5408\305B\30D5\30A3\30EB\30BF\304C\9001\4FE1\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104290819399308675)
,p_name=>'WWV_FLOW_F4000_UTIL.LOV_SQL_COLUMN_NOT_UNIQUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\540D"%0"\306FLOV SQL\554F\5408\305B\3067\3059\3067\306B\4F7F\7528\3055\308C\3066\3044\307E\3059\3002\5217\306B\306F\5FC5\305A\4E00\610F\306E\5225\540D\3092\4F7F\7528\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104290793839308675)
,p_name=>'WWV_FLOW_F4000_UTIL.LOV_SQL_INVALID_COLUMN_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('LOV SQL\554F\5408\305B\306E\5217\540D"%0"\304C\7121\52B9\3067\3059\3002\5217\306B\306F\5FC5\305A\6709\52B9\306A\5225\540D\3092\4F7F\7528\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104289827731308675)
,p_name=>'WWV_FLOW_F4000_UTIL.LOV_SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'ja'
,p_message_text=>unistr('LOV SQL\554F\5408\305B\3067\9078\629E\3055\308C\3066\3044\308B\5217\6570\304C\6B63\3057\304F\3042\308A\307E\305B\3093\3002\4F8B\3067\6709\52B9\306A\6587\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103629069575308112)
,p_name=>'WWV_FLOW_FILE_API.ERROR_REMOVING_FILE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30FC\30D0\30FC\3067\30D5\30A1\30A4\30EB\300C%0\300D\3092\524A\9664\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103629193914308112)
,p_name=>'WWV_FLOW_FILE_API.ERROR_REMOVING_FILE2'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB%0\3092\524A\9664\3067\304D\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103628810050308112)
,p_name=>'WWV_FLOW_FILE_API.ERROR_WRITING_TO_DIRECTORY'
,p_message_language=>'ja'
,p_message_text=>unistr('\7269\7406\30D5\30A1\30A4\30EB\30FB\30C7\30A3\30EC\30AF\30C8\30EA\300C%0\300D\3078\306E\66F8\8FBC\307F\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002 (%1: %2)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103764367799308219)
,p_name=>'WWV_FLOW_FILE_API.EXCEEDED_WORKSPACE_NON_INTERNAL_FILES_LIMIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\975E\5185\90E8\30EF\30FC\30AF\30B9\30DA\30FC\30B9\30FB\30D5\30A1\30A4\30EB\306B\5BFE\3059\308B\30B5\30A4\30BA\306E\6700\5927\9650\5EA6\3092\8D85\3048\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103628958671308112)
,p_name=>'WWV_FLOW_FILE_API.NO_FILE_TO_WRITE'
,p_message_language=>'ja'
,p_message_text=>unistr('ID%0\306B\66F8\304D\8FBC\3080\30D5\30A1\30A4\30EB\304C\3042\308A\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103764247295308219)
,p_name=>'WWV_FLOW_FILE_API.WORKSPACE_MAX_FILE_BYTES.EXCEEDED'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9\30FB\30D5\30A1\30A4\30EB\306B\5BFE\3059\308B\30B5\30A4\30BA\306E\6700\5927\9650\5EA6\3092\8D85\3048\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103797507819308245)
,p_name=>'WWV_FLOW_FND_DEVELOPER_API.DEV_ROLE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\767A\8005\30ED\30FC\30EB\306E\524A\9664\3067\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103673591847308145)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_FND_USER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\306F\6B21\306E\7406\7531\3067\4F5C\6210\3055\308C\307E\305B\3093\3067\3057\305F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104338107790308710)
,p_name=>'WWV_FLOW_FND_USER_API.INVALID_EMAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\7121\52B9\306A\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9\3067\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103791286387308240)
,p_name=>'WWV_FLOW_FORMS.COMBO_JS_NO_QUERY_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('/js\30EA\30C0\30A4\30EC\30AF\30C8\4ED8\304D\30BF\30A4\30D7\9078\629E\30EA\30B9\30C8\306E\30A2\30A4\30C6\30E0%0\306B\554F\5408\305B\304C\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103791196214308240)
,p_name=>'WWV_FLOW_FORMS.COMBO_NO_QUERY_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7\9078\629E\30EA\30B9\30C8\306E\30A2\30A4\30C6\30E0%0\306B\554F\5408\305B\304C\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103791338693308240)
,p_name=>'WWV_FLOW_FORMS.COMBO_URL_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('URL\30EA\30C0\30A4\30EC\30AF\30C8\4ED8\304D\30BF\30A4\30D7\9078\629E\30EA\30B9\30C8\306E\30A2\30A4\30C6\30E0%0\306B\554F\5408\305B\304C\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103791439347308240)
,p_name=>'WWV_FLOW_FORMS.COMBO_URL_PAGE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\3078\306EURL\30EA\30C0\30A4\30EC\30AF\30C8\4ED8\304D\30BF\30A4\30D7\9078\629E\30EA\30B9\30C8\306E\30A2\30A4\30C6\30E0%0\306B\554F\5408\305B\304C\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103765798506308220)
,p_name=>'WWV_FLOW_FORMS.EDIT ITEM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0%0\304B\3089%1\3092\7DE8\96C6\3002\9806\5E8F: %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103762854419308218)
,p_name=>'WWV_FLOW_FORMS.ITEM_DEFAULT_FUNC_BODY_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('ERR-1904 \30A2\30A4\30C6\30E0\306E\30C7\30D5\30A9\30EB\30C8\3092\8A08\7B97\3067\304D\307E\305B\3093\3002\30BF\30A4\30D7=\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3001computation_type= %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103762775127308218)
,p_name=>'WWV_FLOW_FORMS.PLSQL_ITEM_PROC_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('ERR-1020 PL/SQL\30A2\30A4\30C6\30E0\306E\30D7\30ED\30BB\30B9(\30D5\30A1\30F3\30AF\30B7\30E7\30F3)\3067\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103762951123308218)
,p_name=>'WWV_FLOW_FORMS.SPELL_CHK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30DA\30EB\30FB\30C1\30A7\30C3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103765667879308220)
,p_name=>'WWV_FLOW_FORMS.UNABLE_CAST_VALUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024\300C%0\300D\3092\65E5\4ED8\66F8\5F0F\30DE\30B9\30AF%1\306B\30AD\30E3\30B9\30C8\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103530705865308038)
,p_name=>'WWV_FLOW_FORM_REGION.BLOB_NOT_SUPPORTED'
,p_message_language=>'ja'
,p_message_text=>unistr('BLOB\30C7\30FC\30BF\578B\306E\30A2\30A4\30C6\30E0\306F\3001REST\5BFE\5FDCSQL\307E\305F\306FREST\30C7\30FC\30BF\30FB\30BD\30FC\30B9\3067\306F\30B5\30DD\30FC\30C8\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103530949683308038)
,p_name=>'WWV_FLOW_FORM_REGION.CANNOT_FETCH_META_DATA'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3ID %s\306E\30E1\30BF\30C7\30FC\30BF\3092\30D5\30A7\30C3\30C1\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104010979141308443)
,p_name=>'WWV_FLOW_FORM_REGION.FORM_REGION_IS_NULL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30FC\30E0DML\307E\305F\306F\521D\671F\5316\30D7\30ED\30BB\30B9\306B\30D5\30A9\30FC\30E0\30FB\30EA\30FC\30B8\30E7\30F3\304C\5272\308A\5F53\3066\3089\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104016606306308448)
,p_name=>'WWV_FLOW_FORM_REGION.MIGRATE_FORM_REGION_DESCRIBE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30AC\30B7\30FC\30FB\30D5\30A9\30FC\30E0\30FB\30DA\30FC\30B8\306E\30D5\30A9\30FC\30E0\30FB\30EA\30FC\30B8\30E7\30F3\3078\306E\79FB\884C\3067\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002DML\30D7\30ED\30BB\30B9\3067\53C2\7167\3055\308C\3066\3044\308B\8868\3092\8A18\8FF0\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103747808941308206)
,p_name=>'WWV_FLOW_FORM_REGION.NO_CHECKSUM_AVAILABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5931\308F\308C\305F\66F4\65B0\3092\691C\51FA\3059\308B\305F\3081\306E\30C1\30A7\30C3\30AF\30B5\30E0\304C\898B\3064\304B\308A\307E\305B\3093\3002\65E2\5B58\306E\884C\306B\5BFE\3059\308BUPDATE\307E\305F\306FDELETE\306E\307F\3092\5B9F\884C\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104317207109308695)
,p_name=>'WWV_FLOW_FORM_REGION.NO_DML_ON_WSM_SYNC_TABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\540C\671F\5316\304C\6709\52B9\306B\306A\3063\305FREST\30BD\30FC\30B9\3067\30D5\30A9\30FC\30E0DML\3092\5B9F\884C\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103530606027308038)
,p_name=>'WWV_FLOW_FORM_REGION.NO_PRIMARY_KEY_ITEM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30FC\30E0\30FB\30EA\30FC\30B8\30E7\30F3%0\306B\5BFE\3057\3066\4E3B\30AD\30FC\30FB\30A2\30A4\30C6\30E0\304C\5B9A\7FA9\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103530821461308038)
,p_name=>'WWV_FLOW_FORM_REGION.WRONG_ITEM_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0%0\306B\7121\52B9\306A\30C7\30FC\30BF\578B\304C\542B\307E\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103698864138308166)
,p_name=>'WWV_FLOW_GENERATE_DDL.DOMAIN_INDEX_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3057\305F%0\306B\30C9\30E1\30A4\30F3\7D22\5F15\304C\5B58\5728\3057\307E\3059\3002  Generate DDL\306F\3001\30C9\30E1\30A4\30F3\7D22\5F15\306EDDL\3092\751F\6210\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103637303089308118)
,p_name=>'WWV_FLOW_GENERATE_DDL.GENERATE_DDL_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('Rem %0 %1\306B\5BFE\3057\3066DDL\3092\751F\6210\3067\304D\307E\305B\3093\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103668083699308141)
,p_name=>'WWV_FLOW_GENERATE_DDL.NO_DDL'
,p_message_language=>'ja'
,p_message_text=>unistr('DDL\3092\751F\6210\3059\308B%0\304C\898B\3064\304B\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103637518917308118)
,p_name=>'WWV_FLOW_GENERATE_DDL.SAVE_DDL ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('Save_ddl\30A8\30E9\30FC%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103625152369308106)
,p_name=>'WWV_FLOW_GENERATE_DDL.SAVE_DDL_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('DDL\3092\30B9\30AF\30EA\30D7\30C8\30FB\30D5\30A1\30A4\30EB\3068\3057\3066\4FDD\5B58\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103637457678308118)
,p_name=>'WWV_FLOW_GENERATE_DDL.SAVE_DDL_PARSE_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('DDL\30B9\30AF\30EA\30D7\30C8\306E\89E3\6790\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103791565238308240)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.PACKAGE_INVALID_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002\30D1\30C3\30B1\30FC\30B8\540D: %0\306F\7121\52B9\304B\3001\307E\305F\306F\3059\3067\306B\4F7F\7528\3055\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103772649568308225)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_COMMENT'
,p_message_language=>'ja'
,p_message_text=>unistr('-- \30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3%0\306E\8868API\3002\751F\6210\65E5: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103771312693308224)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_CREATE'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6B21\306E\30D7\30ED\30B7\30FC\30B8\30E3\3067PL/SQL\30D1\30C3\30B1\30FC\30B8%0\3092\4F5C\6210:'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103772217296308225)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DESC1'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\3092%0\306B\633F\5165\3059\308B\305F\3081\306B\4F7F\7528\3057\307E\3059\3002\4E3B\30AD\30FC\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103772329187308225)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DESC2'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E3B\30AD\30FC\306B\3088\3063\3066\8B58\5225\3055\308C\308B%0\306E\30C7\30FC\30BF\3092\66F4\65B0\3059\308B\305F\3081\306B\4F7F\7528\3057\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103772486367308225)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DESC3'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E3B\30AD\30FC\306B\57FA\3065\3044\3066%0\304B\3089\30C7\30FC\30BF\3092\524A\9664\3059\308B\305F\3081\306B\4F7F\7528\3057\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103772547422308225)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DESC4'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E3B\30AD\30FC\306B\57FA\3065\3044\3066%0\304B\3089\30C7\30FC\30BF\3092\53D6\5F97\3059\308B\305F\3081\306B\4F7F\7528\3057\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103772179494308225)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\8AAC\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103771911793308225)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DOWN_BODY'
,p_message_language=>'ja'
,p_message_text=>unistr('\672C\4F53\3092\30C0\30A6\30F3\30ED\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103771835479308225)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DOWN_SPEC'
,p_message_language=>'ja'
,p_message_text=>unistr('\4ED5\69D8\90E8\3092\30C0\30A6\30F3\30ED\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103771716984308225)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_HIDE_BODY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30C7\30A3\3092\975E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103771555444308225)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_HIDE_SPEC'
,p_message_language=>'ja'
,p_message_text=>unistr('\4ED5\69D8\90E8\3092\975E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103845333097308282)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_PKG_BODY_COMMENT'
,p_message_language=>'ja'
,p_message_text=>unistr('-- \30D1\30C3\30B1\30FC\30B8\672C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103845495862308282)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_PKG_SPEC_COMMENT'
,p_message_language=>'ja'
,p_message_text=>unistr('-- \30D1\30C3\30B1\30FC\30B8\306E\4ED5\69D8\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103771644857308225)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_SHOW_BODY'
,p_message_language=>'ja'
,p_message_text=>unistr('\672C\4F53\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103771446479308225)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_SHOW_SPEC'
,p_message_language=>'ja'
,p_message_text=>unistr('\4ED5\69D8\90E8\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103772099381308225)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_SUBPROGRAM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30D6\30D7\30ED\30B0\30E9\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103844835134308281)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_TABLE_CREATE_COMMENT'
,p_message_language=>'ja'
,p_message_text=>unistr('-- \8868"%0"\306E\30D7\30ED\30B7\30FC\30B8\30E3\306E\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103845042817308282)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_TABLE_DELETE_COMMENT'
,p_message_language=>'ja'
,p_message_text=>unistr('-- \8868"%0"\306E\30D7\30ED\30B7\30FC\30B8\30E3\306E\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103845156944308282)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_TABLE_GET_COMMENT'
,p_message_language=>'ja'
,p_message_text=>unistr('-- \8868"%0"\306E\30D7\30ED\30B7\30FC\30B8\30E3\306E\53D6\5F97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103845201630308282)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_TABLE_MD5_COMMENT'
,p_message_language=>'ja'
,p_message_text=>unistr('-- \8868"%0"\306EMD5\30D5\30A1\30F3\30AF\30B7\30E7\30F3\306E\30D3\30EB\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103844981739308281)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_TABLE_UPDATE_COMMENT'
,p_message_language=>'ja'
,p_message_text=>unistr('-- \8868"%0"\306E\30D7\30ED\30B7\30FC\30B8\30E3\306E\66F4\65B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103791674213308241)
,p_name=>'WWV_FLOW_GENERIC_ATTR.ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104329308072308704)
,p_name=>'WWV_FLOW_GEN_API2.COMPANY_SOURCE_IDENTIFIER_NULL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306E\30BD\30FC\30B9\8B58\5225\5B50\3092\5B9A\7FA9\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104329489508308704)
,p_name=>'WWV_FLOW_GEN_API2.DEPLOYMENT_SYSTEM_NULL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D7\30ED\30A4\30E1\30F3\30C8\30FB\30B7\30B9\30C6\30E0\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103669605770308143)
,p_name=>'WWV_FLOW_GRID_LAYOUT.FIXED_POSITION_CONFLICT'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5225\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\304C\3053\306E\5217\5185\306B\3059\3067\306B\5B58\5728\3059\308B\305F\3081\3001\30B3\30F3\30DD\30FC\30CD\30F3\30C8<strong>%0</strong>\3092<strong>\5217%1</strong>\3067\30EC\30F3\30C0\30EA\30F3\30B0\3067\304D\307E\305B\3093\3002</p>'),
unistr('<p>\901A\5E38\3001\5217\3092<strong>\300C\81EA\52D5\300D</strong>\306B\8A2D\5B9A\3059\308B\3068\3001\3053\306E\554F\984C\306F\89E3\6C7A\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104773974564309069)
,p_name=>'WWV_FLOW_GRID_LAYOUT.LABEL_COLUMN_SPAN_TOO_BIG'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\3053\306E\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306E\30E9\30D9\30EB\5217\30B9\30D1\30F3\30FB\30B0\30EA\30C3\30C9\8A2D\5B9A\304C\7121\52B9\3067\3042\308B\305F\3081\3001\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0<strong>%0</strong>\306E\30E9\30D9\30EB\3092\30EC\30F3\30C0\30EA\30F3\30B0\3067\304D\307E\305B\3093\3002<strong>%1\306E\30E9\30D9\30EB\5217\30B9\30D1\30F3</strong>\3092\4F7F\7528\3057\305F\8868\793A\306B\8A2D\5B9A\3055\308C\307E\3059\3002\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\81EA\4F53\306B\306E\307F\4F7F\7528\3067\304D\308B<strong>%2\5217</strong>\304C\3042\308B\305F\3081\3001\3053\308C\306F\30B5\30DD\30FC\30C8\3055\308C\3066\3044\307E\305B\3093\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103669487210308142)
,p_name=>'WWV_FLOW_GRID_LAYOUT.MORE_THAN_CALCULATED_COLUMNS'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306E\30B0\30EA\30C3\30C9\8A2D\5B9A\304C\7121\52B9\3067\3042\308B\305F\3081\3001\30B3\30F3\30DD\30FC\30CD\30F3\30C8<strong>%0</strong>\3092\30EC\30F3\30C0\30EA\30F3\30B0\3067\304D\307E\305B\3093\3002<span>%2\306E\5217\30B9\30D1\30F3</strong>\3092\4F7F\7528\3057\305F<strong>\5217%1</strong>\306B\8868\793A\3059\308B\3088\3046\8A2D\5B9A\3055\308C\307E\3059\3002\3053\306E\30DA\30FC\30B8\306E\30B0\30EA\30C3\30C9\306E\307F\304C\6700\5927<strong>%3\5217</strong>\3092\30B5\30DD\30FC\30C8\3057\3066\3044\308B\305F\3081\3001\3053\308C\306F\30B5\30DD\30FC\30C8\3055\308C\3066\3044\307E\305B\3093\3002</p>'),
unistr('<p>\901A\5E38\3001\3059\3079\3066\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306E\5217\304A\3088\3073\5217\30B9\30D1\30F3\3092<strong>\300C\81EA\52D5\300D</strong>\306B\8A2D\5B9A\3059\308B\3068\3001\3053\306E\554F\984C\306F\89E3\6C7A\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103669557965308143)
,p_name=>'WWV_FLOW_GRID_LAYOUT.MORE_THAN_SUPPORTED_COLUMNS'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306E\30B0\30EA\30C3\30C9\8A2D\5B9A\304C\7121\52B9\3067\3042\308B\305F\3081\3001\30B3\30F3\30DD\30FC\30CD\30F3\30C8<strong>%0</strong>\3092\30EC\30F3\30C0\30EA\30F3\30B0\3067\304D\307E\305B\3093\3002<strong>%2\306E\5217\30B9\30D1\30F3</strong>\3092\4F7F\7528\3057\305F<strong>\5217%1</strong>\306B\8868\793A\3059\308B\3088\3046\8A2D\5B9A\3055\308C\307E\3059\3002\3053\306E\30DA\30FC\30B8\306E\30B0\30EA\30C3\30C9\306E\307F\304C<strong>%3\5217</strong>\3092\30B5\30DD\30FC\30C8\3057\3066\3044\308B\305F\3081\3001\3053\308C\306F\30B5\30DD\30FC\30C8\3055\308C\3066\3044\307E\305B\3093\3002</p>'),
unistr('<p>\901A\5E38\3001\3059\3079\3066\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306E\5217\304A\3088\3073\5217\30B9\30D1\30F3\3092<strong>\300C\81EA\52D5\300D</strong>\306B\8A2D\5B9A\3059\308B\3068\3001\3053\306E\554F\984C\306F\89E3\6C7A\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103551697057308053)
,p_name=>'WWV_FLOW_HELP.2_DAY_DBA'
,p_message_language=>'ja'
,p_message_text=>unistr('2\65E5\3067\30C7\30FC\30BF\30D9\30FC\30B9\7BA1\7406\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103551512558308053)
,p_name=>'WWV_FLOW_HELP.2_DAY_DEV'
,p_message_language=>'ja'
,p_message_text=>unistr('2\65E5\3067\958B\767A\8005\30AC\30A4\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103517995590308028)
,p_name=>'WWV_FLOW_HELP.ADMIN_GUIDE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\7BA1\7406\30AC\30A4\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103518036800308028)
,p_name=>'WWV_FLOW_HELP.API'
,p_message_language=>'ja'
,p_message_text=>unistr('API\30EA\30D5\30A1\30EC\30F3\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104093822656308511)
,p_name=>'WWV_FLOW_HELP.CONTENTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\76EE\6B21')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104087885281308506)
,p_name=>'WWV_FLOW_HELP.CONTEXT_HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\60C5\5831: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104093975791308511)
,p_name=>'WWV_FLOW_HELP.FIND'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103551422450308053)
,p_name=>'WWV_FLOW_HELP.HTMLDB_USER_GUIDE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30D3\30EB\30C0\30FC\30FB\30E6\30FC\30B6\30FC\30BA\30FB\30AC\30A4\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104199812132308609)
,p_name=>'WWV_FLOW_HELP.INITIAL_INDEX_CREATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\521D\306E\7D22\5F15\4F5C\6210\306B\306F\6570\79D2\304B\304B\308A\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103518173624308029)
,p_name=>'WWV_FLOW_HELP.MIGRATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\79FB\884C\30AC\30A4\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104093663189308511)
,p_name=>'WWV_FLOW_HELP.NO_INDEX_MAP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C9\30AD\30E5\30E1\30F3\30C8\30FB\30DE\30C3\30D4\30F3\30B0\30FB\30D5\30A1\30A4\30EB\304C\898B\3064\304B\308A\307E\305B\3093: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104094054769308511)
,p_name=>'WWV_FLOW_HELP.SCORE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A18\9332')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103518203457308029)
,p_name=>'WWV_FLOW_HELP.SQL_WORKSHOP'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\30EF\30FC\30AF\30B7\30E7\30C3\30D7\304A\3088\3073\30E6\30FC\30C6\30A3\30EA\30C6\30A3\30FB\30AC\30A4\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103800770991308248)
,p_name=>'WWV_FLOW_HINT.CREATE_NORMALIZE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B63\898F\5316\306E\4F5C\6210\30A8\30E9\30FC: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103976932707308418)
,p_name=>'WWV_FLOW_HINT.NO_PRIVS_ON_SCHEMA'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30DD\30FC\30C8\3057\3066\3044\308B\30B9\30AD\30FC\30DE\3078\306E\30A2\30AF\30BB\30B9\6A29\3092\6240\6709\3057\3066\3044\307E\305B\3093\3002  \30A4\30F3\30DD\30FC\30C8\306B\5931\6557\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103800632283308248)
,p_name=>'WWV_FLOW_HINT.REMOVE_TABLE_HINT_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('p_table_id\306E\6307\5B9A\306A\3057\306Bremove_table_hint\304C\30B3\30FC\30EB\3055\308C\307E\3057\305F\3002\8868\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103706424626308172)
,p_name=>'WWV_FLOW_IMP_PARSER.CREATE_WS_SEC_VIOLATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306E\30A4\30F3\30B9\30C8\30FC\30EB\6642\306B\30012\56DE\76EE\306Ecreate_company\30B3\30FC\30EB\304C\5B9F\884C\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103669274567308142)
,p_name=>'WWV_FLOW_IMP_PARSER.GET_BLOCK'
,p_message_language=>'ja'
,p_message_text=>unistr('GET_BLOCK\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103669131259308142)
,p_name=>'WWV_FLOW_IMP_PARSER.GET_STMT'
,p_message_language=>'ja'
,p_message_text=>unistr('GET_STMT\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103669337139308142)
,p_name=>'WWV_FLOW_IMP_PARSER.NO_FILE_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\304C\898B\3064\304B\308A\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103535469003308041)
,p_name=>'WWV_FLOW_IMP_PARSER.NO_INSTALL_FILE'
,p_message_language=>'ja'
,p_message_text=>unistr('Zip\30A2\30FC\30AB\30A4\30D6\304C\7121\52B9\3067\3059\3002\30A4\30F3\30B9\30C8\30FC\30EB\30FB\30DE\30CB\30D5\30A7\30B9\30C8\30FB\30D5\30A1\30A4\30EB\304C\898B\3064\304B\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103672753245308145)
,p_name=>'WWV_FLOW_IMP_PARSER.NO_PRIV'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\30B9\30AD\30FC\30DE\306B\5BFE\3059\308B\6A29\9650\3092\6240\6709\3057\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103669091977308142)
,p_name=>'WWV_FLOW_IMP_PARSER.RUN_STMT_ERROR'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6587\3092\6B63\5E38\306B\5B9F\884C\3067\304D\307E\305B\3093\3067\3057\305F\3002 %0'),
'<pre>%1</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103709055695308175)
,p_name=>'WWV_FLOW_IMP_PARSER.SEC_VIOLATION'
,p_message_language=>'ja'
,p_message_text=>unistr('remove_page\30D7\30ED\30B7\30FC\30B8\30E3\3078\306EAPI\30B3\30FC\30EB\304C\3001\30A8\30AF\30B9\30DD\30FC\30C8\30FB\30D5\30A1\30A4\30EB\306E\5927\304D\3044\30D6\30ED\30C3\30AF\5185\3067\691C\51FA\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103970360337308413)
,p_name=>'WWV_FLOW_ITEM_HELP.NO_LABEL_EXISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30A4\30C6\30E0\306B\30E9\30D9\30EB\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103587139412308078)
,p_name=>'WWV_FLOW_JAVASCRIPT.IMAGES_DIRECTORY_CONTAINS_WRONG_VERSION'
,p_message_language=>'ja'
,p_message_text=>unistr('Application Express\30D5\30A1\30A4\30EB\304C\6700\65B0\3067\306A\3044\305F\3081\3001\74B0\5883\306B\554F\984C\304C\3042\308A\307E\3059\3002\30D0\30FC\30B8\30E7\30F3#LOADED_VERSION#\306E\30D5\30A1\30A4\30EB\304C\30ED\30FC\30C9\3055\308C\307E\3057\305F\304C\3001%0\304C\5FC5\8981\3067\3059\3002\30A4\30F3\30B9\30C8\30EC\30FC\30B7\30E7\30F3\30FB\30AC\30A4\30C9\306E\6307\793A\306B\5F93\3063\3066\3001\30A4\30E1\30FC\30B8\30FB\30C7\30A3\30EC\30AF\30C8\30EA\304C\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30B5\30FC\30D0\30FC\306B\30B3\30D4\30FC\3055\308C\3066\3044\308B\3053\3068\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103587099692308078)
,p_name=>'WWV_FLOW_JAVASCRIPT.IMAGES_DIRECTORY_NOT_COPIED'
,p_message_language=>'ja'
,p_message_text=>unistr('Application Express\30D5\30A1\30A4\30EB\304C\30ED\30FC\30C9\3055\308C\3066\3044\306A\3044\305F\3081\3001\74B0\5883\306B\554F\984C\304C\3042\308A\307E\3059\3002\30A4\30F3\30B9\30C8\30EC\30FC\30B7\30E7\30F3\30FB\30AC\30A4\30C9\306E\6307\793A\306B\5F93\3063\3066\3001\30A4\30E1\30FC\30B8\30FB\30C7\30A3\30EC\30AF\30C8\30EA\304C\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30B5\30FC\30D0\30FC\306B\30B3\30D4\30FC\3055\308C\3066\3044\308B\3053\3068\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002\307E\305F\3001\30A4\30E1\30FC\30B8\63A5\982D\8F9E\30D1\30B9\304C\6B63\3057\3044\3053\3068\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002\73FE\5728\306E\30D1\30B9\306F%0\3067\3059(\30C7\30D5\30A9\30EB\30C8\306E/i/\306A\3069\3001\958B\59CB\3068\7D42\4E86\306E\30B9\30E9\30C3\30B7\30E5\3092\542B\3081\308B\5FC5\8981\304C\3042\308A\307E\3059)\3002\5909\66F4\3059\308B\5FC5\8981\304C\3042\308B\5834\5408\3001SQL\30B9\30AF\30EA\30D7\30C8reset_image_prefix.sql\3092\4F7F\7528\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103790628090308240)
,p_name=>'WWV_FLOW_JOB.UNAUTHORIZED_ATTEMPT_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3%2\3067\3001\30B9\30AD\30FC\30DE%1\306B\3088\3063\3066\30B8\30E7\30D6%0\304C\4E0D\6B63\306B\5B9F\884C\3055\308C\3088\3046\3068\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103801254246308248)
,p_name=>'WWV_FLOW_LOAD_DATA.COLLECTION_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30EC\30AF\30B7\30E7\30F3\3092\4F5C\6210\3067\304D\307E\305B\3093: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103800878201308248)
,p_name=>'WWV_FLOW_LOAD_DATA.ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103800982596308248)
,p_name=>'WWV_FLOW_LOAD_DATA.FIND_DATA_TYPE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\578B\306E\691C\7D22\30A8\30E9\30FC: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103801184361308248)
,p_name=>'WWV_FLOW_LOAD_DATA.GET_DATATYPE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\578B\306E\53D6\5F97\30A8\30E9\30FC: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103801099406308248)
,p_name=>'WWV_FLOW_LOAD_DATA.GET_MAX_COL_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5927\5217\9577\306E\53D6\5F97\30A8\30E9\30FC1: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103988984770308427)
,p_name=>'WWV_FLOW_LOAD_DATA.NO_32KB_INSERT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\304C32KB\3092\8D85\3048\308B\884C\306F\633F\5165\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103801346729308248)
,p_name=>'WWV_FLOW_LOOKUP_TABLES.PRIVS_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC%0\306F\3001%1\30B9\30AD\30FC\30DE\306B\5BFE\3059\308B\6A29\9650\3092\6240\6709\3057\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103792374542308241)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.BRANCH_COND_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30D6\30E9\30F3\30C1\306E\6761\4EF6\30BF\30A4\30D7\3092\66F4\65B0\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103792244914308241)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_BUTTON_COND_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30DC\30BF\30F3\306E\6761\4EF6\30BF\30A4\30D7\3092\66F4\65B0\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103792063704308241)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_FLOW_COMP_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\8A08\7B97\30BF\30A4\30D7\3092\66F4\65B0\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103791996638308241)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_FLOW_PROC_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\6761\4EF6\30BF\30A4\30D7\306E\5834\5408\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30D7\30ED\30BB\30B9\3092\66F4\65B0\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103792711323308241)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_MISSPELL_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\8AA4\3063\305F\7DB4\308A\306E\8A9E\3092\66F4\65B0\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103791886168308241)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_NAVBAR_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30D0\30FC\306E\8868\793A\6761\4EF6\30BF\30A4\30D7\3092\66F4\65B0\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103792450509308241)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_PAGE_COMP_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\8A08\7B97\30BF\30A4\30D7\3092\66F4\65B0\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103792606233308241)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_PAGE_PROC_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30D7\30ED\30BB\30B9\306E\30BF\30A4\30D7\3092\66F4\65B0\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103792142763308241)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_PAGE_SUBTITLE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306E\30B5\30D6\30BF\30A4\30C8\30EB\30FB\30BF\30A4\30D7\3092\66F4\65B0\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103792577250308241)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_PAGE_VALID_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\691C\8A3C\30BF\30A4\30D7\3092\66F4\65B0\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104339232662308711)
,p_name=>'WWV_FLOW_NATIVE_ITEM.AUTOCOMPLETE_RESTRICTION'
,p_message_language=>'ja'
,p_message_text=>unistr('%0: \300C\30AB\30B9\30B1\30FC\30C9LOV\89AA\30A2\30A4\30C6\30E0\300D\306F\3001\300C\9045\5EF6\30ED\30FC\30C9\300D\304C\300C\306F\3044\300D\306B\8A2D\5B9A\3055\308C\3066\3044\308B\5834\5408\306B\306E\307F\4F7F\7528\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104330433190308705)
,p_name=>'WWV_FLOW_NATIVE_ITEM.MULTIPLE_DML_PROCESSES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC: \5404\30DA\30FC\30B8\306B\8907\6570\306EDML\30D7\30ED\30BB\30B9\306F\5BA3\8A00\3067\304D\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104330329532308705)
,p_name=>'WWV_FLOW_NATIVE_ITEM.NO_DML_PROCESS_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC: \30DA\30FC\30B8%0\306B\5BFE\5FDC\3059\308BDML\30D7\30ED\30BB\30B9\304C\898B\3064\304B\308A\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104331470029308705)
,p_name=>'WWV_FLOW_NATIVE_ITEM.NO_VALID_BLOB_SOURCE'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306B\306F\30BD\30FC\30B9\3068\3057\3066\6709\52B9\306ABLOB\5217\304C\5FC5\8981\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104292199693308676)
,p_name=>'WWV_FLOW_NATIVE_ITEM.PLSQL_CODE_REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0%0\306BHTML\3092\751F\6210\3059\308BPL/SQL\30B3\30FC\30C9\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103802252270308249)
,p_name=>'WWV_FLOW_PARSER.BULK_COLLECT_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D0\30EB\30AF\53CE\96C6\3067\304D\307E\305B\3093: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103801932036308249)
,p_name=>'WWV_FLOW_PARSER.CHECK_CODE_PARSE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30FC\30C9\304C\89E3\6790\3055\308C\3066\3044\308B\304B\3069\3046\304B\3092\78BA\8A8D\3067\304D\307E\305B\3093: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103802048457308249)
,p_name=>'WWV_FLOW_PARSER.CONTROL_FILE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\5236\5FA1\30D5\30A1\30A4\30EB\3092\5B9F\884C\3067\304D\307E\305B\3093: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103802783979308249)
,p_name=>'WWV_FLOW_PARSER.CONTROL_FILE_STATS_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\5236\5FA1\30D5\30A1\30A4\30EB\306E\7D71\8A08\3092\78BA\8A8D\3067\304D\307E\305B\3093: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103802636164308249)
,p_name=>'WWV_FLOW_PARSER.DELETE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\89E3\6790\3055\308C\305F\60C5\5831\3092\524A\9664\3067\304D\307E\305B\3093: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103802583115308249)
,p_name=>'WWV_FLOW_PARSER.EXECUTION_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\6587\3092\6B63\5E38\306B\5B9F\884C\3067\304D\307E\305B\3093\3067\3057\305F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103801421311308248)
,p_name=>'WWV_FLOW_PARSER.FIND_FILE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\304C\898B\3064\304B\308A\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103801625689308248)
,p_name=>'WWV_FLOW_PARSER.GET_STATEMENT_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\6587\3092\53D6\5F97\3067\304D\307E\305B\3093: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103767764366308222)
,p_name=>'WWV_FLOW_PARSER.LINE_TOO_LONG'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C%2\3067\884C\306E\9577\3055%0\304C\6700\5927\9577%1\3092\8D85\3048\3066\3044\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103802445168308249)
,p_name=>'WWV_FLOW_PARSER.PACKAGE_COMP_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\8B66\544A: \30D1\30C3\30B1\30FC\30B8\672C\4F53\304C\30B3\30F3\30D1\30A4\30EB\30FB\30A8\30E9\30FC\3092\623B\3057\3066\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103802119172308249)
,p_name=>'WWV_FLOW_PARSER.RUN_CODE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30FC\30C9\3092\5B9F\884C\3067\304D\307E\305B\3093: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103802348632308249)
,p_name=>'WWV_FLOW_PARSER.RUN_STATEMENT_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\6587\3092\5B9F\884C\3067\304D\307E\305B\3093: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103801757959308248)
,p_name=>'WWV_FLOW_PARSER.SAVE_PARAMETER_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30E9\30E1\30FC\30BF\3092\30C7\30FC\30BF\30D9\30FC\30B9\306B\4FDD\5B58\3067\304D\307E\305B\3093: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103801587306308248)
,p_name=>'WWV_FLOW_PARSER.UNABLE_GET_CODE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30FC\30C9\306E\30D6\30ED\30C3\30AF\3092\53D6\5F97\3067\304D\307E\305B\3093: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103801848356308249)
,p_name=>'WWV_FLOW_PARSER.VALIDATE_FILE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\300C%0\300D\3092\691C\8A3C\3067\304D\307E\305B\3093\3002 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103802819825308249)
,p_name=>'WWV_FLOW_PARSER_PUBLIC.PARSE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\3092\89E3\6790\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104185260615308597)
,p_name=>'WWV_FLOW_PLUGIN.NO_AUTHENTICATION_FUNCTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30E9\30B0\30A4\30F3%0\306B\8A8D\8A3C\30D5\30A1\30F3\30AF\30B7\30E7\30F3\304C\5B9A\7FA9\3055\308C\3066\3044\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104185317607308597)
,p_name=>'WWV_FLOW_PLUGIN.NO_POST_LOGOUT_FUNCTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30E9\30B0\30A4\30F3%0\306B\30ED\30B0\30A2\30A6\30C8\5F8C\30D5\30A1\30F3\30AF\30B7\30E7\30F3\304C\5B9A\7FA9\3055\308C\3066\3044\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104185131696308597)
,p_name=>'WWV_FLOW_PLUGIN.NO_SESSION_SENTRY_FUNCTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30E9\30B0\30A4\30F3%0\306B\30BB\30C3\30B7\30E7\30F3\76E3\8996\30D5\30A1\30F3\30AF\30B7\30E7\30F3\304C\5B9A\7FA9\3055\308C\3066\3044\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104738463835309033)
,p_name=>'WWV_FLOW_PLUGIN_DEV.ACTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104737620007309033)
,p_name=>'WWV_FLOW_PLUGIN_DEV.ACTION_DEFINED_BY_DA'
,p_message_language=>'ja'
,p_message_text=>unistr('\52D5\7684\30A2\30AF\30B7\30E7\30F3\3067\5B9A\7FA9')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104737318746309032)
,p_name=>'WWV_FLOW_PLUGIN_DEV.ACTION_REDIRECT_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30DA\30FC\30B8\306B\30EA\30C0\30A4\30EC\30AF\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104737592067309033)
,p_name=>'WWV_FLOW_PLUGIN_DEV.ACTION_REDIRECT_URL'
,p_message_language=>'ja'
,p_message_text=>unistr('URL\306B\30EA\30C0\30A4\30EC\30AF\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104737450623309032)
,p_name=>'WWV_FLOW_PLUGIN_DEV.ACTION_SUBMIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306E\9001\4FE1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104738001086309033)
,p_name=>'WWV_FLOW_PLUGIN_DEV.CLEAR_CACHE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AD\30E3\30C3\30B7\30E5\306E\30AF\30EA\30A2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104290007818308675)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_LEGACY_LOV_SQL'
,p_message_language=>'ja'
,p_message_text=>unistr('LOV\554F\5408\305B\304C\7121\52B9\3067\3059\3002\8868\793A\5024\304A\3088\3073\623B\308A\5024\304C\5FC5\8981\3067\3059\3002\5217\540D\306F\7570\306A\3063\3066\3044\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\554F\5408\305B\306B\30A4\30F3\30E9\30A4\30F3\554F\5408\305B\304C\542B\307E\308C\308B\5834\5408\3001SQL\6587\306E\6700\521D\306EFROM\53E5\306F\30A4\30F3\30E9\30A4\30F3\554F\5408\305B\306B\5C5E\3057\3066\3044\306A\3044\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104291777483308676)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_REGION_SOURCE_SQL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\30FB\30BD\30FC\30B9\554F\5408\305B\306E\89E3\6790\306B\5931\6557\3057\307E\3057\305F\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103672899820308145)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_SQL'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B\306E\89E3\6790\306B\5931\6557\3057\307E\3057\305F\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104761331348309051)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_SQL_SIMPLE'
,p_message_language=>'ja'
,p_message_text=>'%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104290182857308675)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_STATIC_LOV'
,p_message_language=>'ja'
,p_message_text=>unistr('\9759\7684LOV\304C\7121\52B9\3067\3059\3002\8868\793A\5024\304A\3088\3073\623B\308A\5024\304C\5FC5\8981\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104225750691308628)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_TABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\3001\30D3\30E5\30FC\307E\305F\306F\30B7\30CE\30CB\30E0\304C\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103672324768308144)
,p_name=>'WWV_FLOW_PLUGIN_DEV.IS_OPTIONAL'
,p_message_language=>'ja'
,p_message_text=>unistr('- \9078\629E -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104290442673308675)
,p_name=>'WWV_FLOW_PLUGIN_DEV.LOV_REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\5F62\5F0F\304C\3053\306E\30BF\30A4\30D7\306B\8A2D\5B9A\3055\308C\305F\30A2\30A4\30C6\30E0\306B\5BFE\3057\3066\3001LOV\554F\5408\305B\307E\305F\306F\540D\524D\4ED8\304DLOV\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104290354993308675)
,p_name=>'WWV_FLOW_PLUGIN_DEV.NAMED_LOV_NOT_ALLOWED'
,p_message_language=>'ja'
,p_message_text=>unistr('\540D\524D\4ED8\304DLOV\306E\4F7F\7528\306F\30012\3064\4EE5\4E0A\306ELOV\5217\3092\5FC5\8981\3068\3059\308B\30A2\30A4\30C6\30E0\30FB\30BF\30A4\30D7\3067\306E\307F\30B5\30DD\30FC\30C8\3055\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103673050648308145)
,p_name=>'WWV_FLOW_PLUGIN_DEV.NO_INTEGER'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024\306F\6574\6570\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103672952545308145)
,p_name=>'WWV_FLOW_PLUGIN_DEV.NO_NUMBER'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024\306F\6570\5024\3067\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104737748464309033)
,p_name=>'WWV_FLOW_PLUGIN_DEV.PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103598630833308087)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_COLUMN_HAS_WRONG_DATA_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\306E\30C7\30FC\30BF\578B\304C\8AA4\3063\3066\3044\307E\3059\3002\3053\306E\5C5E\6027\306B\306F\3001\5217\304C\6B21\306E\3044\305A\308C\304B\306E\30C7\30FC\30BF\578B\3067\306A\3051\308C\3070\306A\308A\307E\305B\3093: %0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103586925136308078)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_COLUMN_NOT_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\304C\5B58\5728\3057\306A\3044\304B\30EA\30FC\30B8\30E7\30F3\30FB\30BD\30FC\30B9\306E\554F\5408\305B\304C\7121\52B9\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103598759464308087)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_COLUMN_WRONG_DATA_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9\306A\30C7\30FC\30BF\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104291342629308676)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_SOURCE_REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30EA\30FC\30B8\30E7\30F3\30FB\30BF\30A4\30D7\306E\30EA\30FC\30B8\30E7\30F3\306B\306F\3001\30EA\30FC\30B8\30E7\30F3\30FB\30BD\30FC\30B9\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104291402896308676)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_SOURCE_SQL_COLUMN_NOT_UNIQUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\540D"%0"\306F\3001\30EA\30FC\30B8\30E7\30F3\30FB\30BD\30FC\30B9\554F\5408\305B\3067\3059\3067\306B\4F7F\7528\3055\308C\3066\3044\307E\3059\3002\5217\306B\306F\5FC5\305A\4E00\610F\306E\5225\540D\3092\4F7F\7528\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104291546051308676)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_SOURCE_SQL_INVALID_COLUMN_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\30FB\30BD\30FC\30B9\554F\5408\305B\306E\5217\540D"%0"\304C\7121\52B9\3067\3059\3002\5217\306B\306F\5FC5\305A\4E00\610F\306E\5225\540D\3092\4F7F\7528\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104291699044308676)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_SOURCE_SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\30FB\30BD\30FC\30B9\554F\5408\305B\3067\9078\629E\3055\308C\3066\3044\308B\5217\6570\304C\6B63\3057\304F\3042\308A\307E\305B\3093\3002\4F8B\3067\6709\52B9\306A\6587\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104737946629309033)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REQUEST'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30AF\30A8\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104737848727309033)
,p_name=>'WWV_FLOW_PLUGIN_DEV.RESET_PAGINATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DA\30FC\30B8\306E\30DA\30FC\30B8\533A\5207\308A\3092\30EA\30BB\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104738128426309033)
,p_name=>'WWV_FLOW_PLUGIN_DEV.SET_THESE_ITEMS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\30A2\30A4\30C6\30E0\3092\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104291029343308675)
,p_name=>'WWV_FLOW_PLUGIN_DEV.SQL_COLUMN_NOT_UNIQUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\540D"%0"\306FSQL\554F\5408\305B\3067\3059\3067\306B\4F7F\7528\3055\308C\3066\3044\307E\3059\3002\5217\306B\306F\5FC5\305A\4E00\610F\306E\5225\540D\3092\4F7F\7528\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104290914370308675)
,p_name=>'WWV_FLOW_PLUGIN_DEV.SQL_INVALID_COLUMN_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B\306E\5217\540D"%0"\304C\7121\52B9\3067\3059\3002\5217\306B\306F\5FC5\305A\4E00\610F\306E\5225\540D\3092\4F7F\7528\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103673975333308146)
,p_name=>'WWV_FLOW_PLUGIN_DEV.SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B\3067\9078\629E\3057\305F\5217\306E\6570\304C\6B63\3057\304F\3042\308A\307E\305B\3093\3002\5C5E\6027\306E\30D8\30EB\30D7\3067\8A73\7D30\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104290234212308675)
,p_name=>'WWV_FLOW_PLUGIN_DEV.STATIC_LOV_NOT_ALLOWED'
,p_message_language=>'ja'
,p_message_text=>unistr('\9759\7684LOV\306F\30012\3064\4EE5\4E0A\306ELOV\5217\3092\5FC5\8981\3068\3059\308B\30A2\30A4\30C6\30E0\30FB\30BF\30A4\30D7\3067\306E\307F\30B5\30DD\30FC\30C8\3055\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104738334682309033)
,p_name=>'WWV_FLOW_PLUGIN_DEV.URL_TARGET'
,p_message_language=>'ja'
,p_message_text=>unistr('URL\30BF\30FC\30B2\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104738225020309033)
,p_name=>'WWV_FLOW_PLUGIN_DEV.WITH_THESE_VALUES'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\5024\3092\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103792978212308242)
,p_name=>'WWV_FLOW_POPUP_LOV.CONVERT_ID_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('ERR-1711 \30EA\30AF\30A8\30B9\30C8\306E\30DD\30C3\30D7\30A2\30C3\30D7LOV ID\3092\5909\63DB\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103793076997308242)
,p_name=>'WWV_FLOW_POPUP_LOV.FIND_ITEM_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('ERR-1721 \30EA\30AF\30A8\30B9\30C8\3067\30DD\30C3\30D7\30A2\30C3\30D7LOV ID\306E\30A2\30A4\30C6\30E0\304C\898B\3064\304B\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103566890023308064)
,p_name=>'WWV_FLOW_PRINT_UTIL.INVALID_PROXY_URL'
,p_message_language=>'ja'
,p_message_text=>unistr('\6307\5B9A\3055\308C\305FURL\304C\6B63\3057\304F\306A\3044\304B\3001\30D7\30ED\30AD\30B7\306EURL\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308B\305F\3081\3001\30D7\30EA\30F3\30C8\30FB\30A8\30F3\30B8\30F3\306B\5230\9054\3067\304D\307E\305B\3093\3067\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104471405663308810)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.ABOVE_BOX'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\306E\4E0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104471878344308811)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.BELOW_BOX'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\306E\4E0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104471924294308811)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.BOTTOM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\306E\4E0B\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104471555475308810)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.LEFT_OF_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30C8\30EB\306E\5DE6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104471189632308810)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.RIGHT_OF_IR_SEARCH_BAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\306E\691C\7D22\30D0\30FC\306E\53F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104471631470308810)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.RIGHT_OF_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30C8\30EB\306E\53F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104471740087308811)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.TEMPLATE_DEFAULT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\306E\30C7\30D5\30A9\30EB\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104471296903308810)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.TOP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\306E\4E0A\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104471366122308810)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.TOP_AND_BOTTOM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\306E\4E0A\90E8\304A\3088\3073\4E0B\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104472038036308811)
,p_name=>'WWV_FLOW_PROPERTY_DEV.DP.AFTER_HEADER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D8\30C3\30C0\30FC\306E\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104472150513308811)
,p_name=>'WWV_FLOW_PROPERTY_DEV.DP.BEFORE_FOOTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30C3\30BF\30FC\306E\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104694686191308996)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.COMPONENT_NOT_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30DD\30FC\30CD\30F3\30C8\304C\898B\3064\304B\308A\307E\305B\3093\3002\5225\306E\30E6\30FC\30B6\30FC\306B\3088\3063\3066\524A\9664\3055\308C\305F\53EF\80FD\6027\304C\3042\308A\307E\3059\3002\30DA\30FC\30B8\3092\30EA\30ED\30FC\30C9\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104694575326308996)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.COMPONENT_REFERENCED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30DD\30FC\30CD\30F3\30C8''%0''\304C\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\3092\53C2\7167\3057\3066\3044\308B\305F\3081\3001\524A\9664\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104694407274308995)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.COMPONENT_REFERENCED_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8%1\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8''%0''\304C\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\3092\53C2\7167\3057\3066\3044\308B\305F\3081\3001\524A\9664\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104694728503308996)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.PROPERTY_CHANGED'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C5E\6027\306F\5225\306E\30E6\30FC\30B6\30FC\306B\3088\3063\3066\3059\3067\306B\5909\66F4\3055\308C\3066\3044\307E\3059\3002\30DA\30FC\30B8\3092\30EA\30ED\30FC\30C9\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104694928108308996)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.PROPERTY_NOT_AVAILABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C5E\6027\306F\3053\306E\30B3\30F3\30C6\30AD\30B9\30C8\3067\4F7F\7528\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104694894570308996)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.PROPERTY_NOT_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306F\5225\306E\30E6\30FC\30B6\30FC\306B\3088\3063\3066\5909\66F4\3055\308C\3001\3053\306E\5C5E\6027\306F\3082\3046\5B58\5728\3057\307E\305B\3093\3002\30DA\30FC\30B8\3092\30EA\30ED\30FC\30C9\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104189191254308601)
,p_name=>'WWV_FLOW_PROPERTY_DEV.INVALID_SQL_RETURNED_BY_FUNCTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\89E3\6790\3067\554F\5408\305B\7D50\679C\304C"%0"\306B\623B\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104781775643309075)
,p_name=>'WWV_FLOW_PROPERTY_DEV.INVALID_SQL_RETURNED_BY_REGION_FUNCTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\89E3\6790\3067\554F\5408\305B\7D50\679C\304C"%0"\306B\623B\3055\308C\307E\3057\305F\3002\554F\5408\305B\306E\69CB\6587\304C\6B63\3057\3044\5834\5408\306F\3001\4E0B\306B\3042\308B\300C\6C4E\7528\5217\540D\306E\4F7F\7528\300D\30C1\30A7\30C3\30AF\30FB\30DC\30C3\30AF\30B9\3092\9078\629E\3057\3066\3001\89E3\6790\305B\305A\306B\7D9A\884C\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104733169121309029)
,p_name=>'WWV_FLOW_PROPERTY_DEV.MUST_BE_UNIQUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E00\610F\306B\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104472292863308811)
,p_name=>'WWV_FLOW_PROPERTY_DEV.NO_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104189032985308600)
,p_name=>'WWV_FLOW_PROPERTY_DEV.NULL_QUERY_RETURNED_BY_FUNCTION'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\30D6\30ED\30C3\30AF\306B\3088\3063\3066\554F\5408\305B\304C\623B\3055\308C\307E\305B\3093\3067\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104781848557309075)
,p_name=>'WWV_FLOW_PROPERTY_DEV.NULL_QUERY_RETURNED_BY_REGION_FUNCTION'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\30D6\30ED\30C3\30AF\306B\3088\3063\3066\554F\5408\305B\304C\623B\3055\308C\307E\305B\3093\3067\3057\305F\3002\30B3\30FC\30C9\306E\69CB\6587\304C\6B63\3057\3044\5834\5408\306F\3001\4E0B\306B\3042\308B\300C\6C4E\7528\5217\540D\306E\4F7F\7528\300D\30C1\30A7\30C3\30AF\30FB\30DC\30C3\30AF\30B9\3092\9078\629E\3057\3066\3001\89E3\6790\305B\305A\306B\7D9A\884C\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104472404749308811)
,p_name=>'WWV_FLOW_PROPERTY_DEV.PAGE_LOCKED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306F\5225\306E\30E6\30FC\30B6\30FC\306B\3088\3063\3066\30ED\30C3\30AF\3055\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104472355782308811)
,p_name=>'WWV_FLOW_PROPERTY_DEV.PAGE_LOCKED_SAVE_FAILED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306F\73FE\5728%0\306B\3088\3063\3066\30ED\30C3\30AF\3055\308C\3066\3044\307E\3059\3002\5909\66F4\3092\4FDD\5B58\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104079390145308499)
,p_name=>'WWV_FLOW_PROVISION.CANNOT_EXTEND_TS'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E%0\306B\30B9\30AD\30FC\30DE\304C\5B58\5728\3057\306A\3044\305F\3081\3001\8868\9818\57DF\3092\62E1\5F35\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103793107332308242)
,p_name=>'WWV_FLOW_PROVISION.DROP_TABLESPACE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('drop_tablespace\3067\767A\751F\3057\305F\30A8\30E9\30FCp_name\304CNULL\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103793365369308242)
,p_name=>'WWV_FLOW_PROVISION.DROP_USER_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('drop_user no l_username\3067\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104788758416309080)
,p_name=>'WWV_FLOW_PROVISION.ENCRYPTION_WALLET_NOT_OPEN'
,p_message_language=>'ja'
,p_message_text=>unistr('\6697\53F7\5316\30A6\30A9\30EC\30C3\30C8\304C\958B\304B\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103591993516308082)
,p_name=>'WWV_FLOW_PROVISION.ILLEGAL_PASSWORD'
,p_message_language=>'ja'
,p_message_text=>unistr('wwv_flow_provision.create_user\306B\4E0D\6B63\306A\30D1\30B9\30EF\30FC\30C9\6587\5B57\5217\304C\6E21\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103793970381308242)
,p_name=>'WWV_FLOW_PROVISION.REMOVE_COMPANY_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('remove_provisioned_company\3067\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002\30EF\30FC\30AF\30B9\30DA\30FC\30B9\304CNULL\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103793739353308242)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_CREATE_TABLESPACE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\9818\57DF\3092\4F5C\6210\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103793665164308242)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_CREATE_USER_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\3092\4F5C\6210\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103793200417308242)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_DROP_TABLESPACE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\9818\57DF\3092\524A\9664\3067\304D\307E\305B\3093\3002\30A8\30E9\30FC: %0 \005Cnsql:\005Cn %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103793487307308242)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_DROP_USER_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\3092\524A\9664\3067\304D\307E\305B\3093\3002\30A8\30E9\30FC: %0 \005Cnsql:\005Cn %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103793834940308242)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_GRANT_PRIVS_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\521D\671F\6A29\9650\3092\4ED8\4E0E\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103558159464308057)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_TO_CREATE_TABLESPACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\3001\8868\9818\57DF\3092\4F5C\6210\3067\304D\307E\305B\3093\3002\5F8C\3067\518D\8A66\884C\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103793566731308242)
,p_name=>'WWV_FLOW_PROVISION.WITH_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC: %0 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103636577905308118)
,p_name=>'WWV_FLOW_PROVISIONING.AUTO_PROVISION_FAILURE'
,p_message_language=>'ja'
,p_message_text=>unistr('\300CMAKE_REQUEST\300D\30D5\30A7\30FC\30BA\4E2D\3001\81EA\52D5\30D7\30ED\30D3\30B8\30E7\30CB\30F3\30B0\306B\5931\6557\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103656194021308133)
,p_name=>'WWV_FLOW_PROVISIONING.CANNOT_FIND_SGID'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6307\5B9A\3055\308C\305F\30EF\30FC\30AF\30B9\30DA\30FC\30B9ID\304C\300C%0\300D\306E\30BB\30AD\30E5\30EA\30C6\30A3\30FB\30B0\30EB\30FC\30D7ID\3092\5224\65AD\3067\304D\307E\305B\3093'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103636870683308118)
,p_name=>'WWV_FLOW_PROVISIONING.COMPANY_RESERVED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\540D%0\306F\4E88\7D04\6E08\306E\305F\3081\3001\30EA\30AF\30A8\30B9\30C8\306F\62D2\5426\3055\308C\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103636692067308118)
,p_name=>'WWV_FLOW_PROVISIONING.COMPANY_USER_ADD'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9%0\306B\30E6\30FC\30B6\30FC\3092\8FFD\52A0\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103794282129308243)
,p_name=>'WWV_FLOW_PROVISIONING.ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103776044007308228)
,p_name=>'WWV_FLOW_PROVISIONING.NOT_IMPLEMENTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9F\88C5\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103636382438308117)
,p_name=>'WWV_FLOW_PROVISIONING.NO_COMPANY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9ID\3092\6301\3064\30EF\30FC\30AF\30B9\30DA\30FC\30B9\304C\898B\3064\304B\308A\307E\305B\3093: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103636457174308117)
,p_name=>'WWV_FLOW_PROVISIONING.NO_SCHEMA'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9ID\306B\30B9\30AD\30FC\30DE\304C\5272\308A\5F53\3066\3089\308C\3066\3044\307E\305B\3093: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103656249548308133)
,p_name=>'WWV_FLOW_PROVISIONING.REMOVE_LAST_SCHEMA'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6A5F\80FD\3092\4F7F\7528\3057\3066\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306E\6700\5F8C\306E\30B9\30AD\30FC\30DE\3092\524A\9664\3059\308B\3053\3068\306F\3067\304D\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103637236373308118)
,p_name=>'WWV_FLOW_PROVISIONING.REQUEST_NOT_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30AF\30A8\30B9\30C8%0\304C\898B\3064\304B\308A\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103637015842308118)
,p_name=>'WWV_FLOW_PROVISIONING.REQUEST_NOT_PROCESSED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30AF\30A8\30B9\30C8%0\306F\51E6\7406\3067\304D\307E\305B\3093\3002  %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103636763293308118)
,p_name=>'WWV_FLOW_PROVISIONING.REQUEST_PROCESSED'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30EA\30AF\30A8\30B9\30C8\306F\3001\51E6\7406\304C\7D42\4E86\3057\305F\304B\3001\307E\305F\306F\51E6\7406\4E2D\3067\3059\3002\30B9\30C6\30FC\30BF\30B9\306F\300C%0\300D\3068\540C\7B49\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103656540585308133)
,p_name=>'WWV_FLOW_PROVISIONING.RESET_PASSWORD_NOT_IN_COMPANY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\540D%0\306F\3001\30EF\30FC\30AF\30B9\30DA\30FC\30B9%1\306B\306F\5B58\5728\3057\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103656450510308133)
,p_name=>'WWV_FLOW_PROVISIONING.RESET_PASSWORD_NOT_IN_SCHEMA'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\3068\95A2\9023\4ED8\3051\3089\308C\3066\3044\306A\3044\30B9\30AD\30FC\30DE\306E\30D1\30B9\30EF\30FC\30C9\306E\518D\8A2D\5B9A\306F\8A31\53EF\3055\308C\3066\3044\307E\305B\3093\3002  %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103656378736308133)
,p_name=>'WWV_FLOW_PROVISIONING.RESET_PASSWORD_RESERVED_SCHEMA'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AD\30FC\30DE%0\306E\30D1\30B9\30EF\30FC\30C9\3092\518D\8A2D\5B9A\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103637169499308118)
,p_name=>'WWV_FLOW_PROVISIONING.SCHEMA_EXISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30AF\30A8\30B9\30C8%0\306F\3001\30B9\30AD\30FC\30DE%1\304C%2\8868\306B\5B58\5728\3059\308B\305F\3081\3001\51E6\7406\3067\304D\307E\305B\3093\3067\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103636964770308118)
,p_name=>'WWV_FLOW_PROVISIONING.SCHEMA_RESERVED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AD\30FC\30DE\540D%0\306F\4E88\7D04\6E08\306E\305F\3081\3001\30D7\30ED\30D3\30B8\30E7\30CB\30F3\30B0\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103636249884308117)
,p_name=>'WWV_FLOW_PROVISIONING.USER_NO_PRIVILEGES'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30E6\30FC\30B6\30FC%0\306F\3001%1\30B9\30AD\30FC\30DE\306B\5BFE\3059\308B\6A29\9650\3092\6240\6709\3057\3066\3044\307E\305B\3093\3002'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103596268039308085)
,p_name=>'WWV_FLOW_QUICK_FLOW.ANALYSIS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306E\5206\6790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103599026087308087)
,p_name=>'WWV_FLOW_QUICK_FLOW.ANALYZE'
,p_message_language=>'ja'
,p_message_text=>unistr('\89E3\6790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103581971411308075)
,p_name=>'WWV_FLOW_QUICK_FLOW.AUTH_SCHEME_DESC_DBACCOUNT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30A2\30AB\30A6\30F3\30C8\8CC7\683C\8A3C\660E\3092\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103613075641308097)
,p_name=>'WWV_FLOW_QUICK_FLOW.AUTH_SCHEME_DESC_INTERNAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\5185\90E8%0\30A2\30AB\30A6\30F3\30C8\8CC7\683C\8A3C\660E\3068\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8\3092\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104292399132308676)
,p_name=>'WWV_FLOW_QUICK_FLOW.AUTH_SCHEME_DESC_SSO'
,p_message_language=>'ja'
,p_message_text=>unistr('Oracle Application Server Single Sign-On\3092\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103596323630308085)
,p_name=>'WWV_FLOW_QUICK_FLOW.CHART'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306E\30C1\30E3\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103596143145308085)
,p_name=>'WWV_FLOW_QUICK_FLOW.CHOOSE_A_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\306E\9078\629E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103598317572308086)
,p_name=>'WWV_FLOW_QUICK_FLOW.CLEAR_CACHE_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AD\30E3\30C3\30B7\30E5\3092\30AF\30EA\30A2\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104675957742308980)
,p_name=>'WWV_FLOW_QUICK_FLOW.COLUMN_NOT_NULL'
,p_message_language=>'ja'
,p_message_text=>unistr('#COLUMN_HEADER#\306B\5024\304C\5FC5\8981\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103626411333308107)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_ANALYZE_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5206\6790\30DA\30FC\30B8\3092\4F5C\6210\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103644600944308124)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_BUTTON_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\4F5C\6210\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103645484139308124)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_CHART_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\30FB\30DA\30FC\30B8\3092\4F5C\6210\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103644044914308123)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_FLOW'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\4F5C\6210\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103645815947308125)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_HOME_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DB\30FC\30E0\30DA\30FC\30B8\3092\4F5C\6210\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103645244421308124)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_INSERT_FORM'
,p_message_language=>'ja'
,p_message_text=>unistr('\633F\5165\30D5\30A9\30FC\30E0\3092\4F5C\6210\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103644268457308123)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_LABEL_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\4F5C\6210\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103645998281308125)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_LIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8\3092\4F5C\6210\3067\304D\307E\305B\3093\3002 %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103646084814308125)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_LIST_ITEM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8\30FB\30A2\30A4\30C6\30E0\3092\4F5C\6210\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103643921543308123)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_LIST_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\4F5C\6210\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103645065277308124)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_MENU'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0\3092\4F5C\6210\3067\304D\307E\305B\3093\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103644513375308124)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_MENU_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\4F5C\6210\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103646467057308125)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_MODULES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E2\30B8\30E5\30FC\30EB\3092\4F5C\6210\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103644916104308124)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_NAVBAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30D0\30FC\3092\4F5C\6210\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103596516965308085)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_NEW'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\3092\65B0\898F\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103599234712308087)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_NEW2'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103644159429308123)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_PAGE_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\4F5C\6210\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103644431929308123)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_REGION_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\4F5C\6210\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103645134581308124)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_REPORT_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\30FB\30DA\30FC\30B8\3092\4F5C\6210\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103644354922308123)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_REPORT_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\4F5C\6210\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103646102630308125)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_SUCCESS_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\6210\529F\300D\30DA\30FC\30B8\3092\4F5C\6210\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103644856472308124)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_TAB'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A19\6E96\306E\30BF\30D6\3092\4F5C\6210\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103645315973308124)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_UPDATE_FORM'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F4\65B0\30D5\30A9\30FC\30E0\3092\4F5C\6210\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103598277053308086)
,p_name=>'WWV_FLOW_QUICK_FLOW.CSV_LINK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30D7\30EC\30C3\30C9\30B7\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104676106530308980)
,p_name=>'WWV_FLOW_QUICK_FLOW.DATE_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('#COLUMN_HEADER#\306F\3001\6709\52B9\306A\65E5\4ED8\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103646200816308125)
,p_name=>'WWV_FLOW_QUICK_FLOW.DEFINE_DEFAULT_TEMPLATES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\306E\30C6\30F3\30D7\30EC\30FC\30C8\3092\5B9A\7FA9\3057\3066\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\4F5C\6210\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103600731611308088)
,p_name=>'WWV_FLOW_QUICK_FLOW.DISPLAY_REGION_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30EA\30FC\30B8\30E7\30F3\3092\8868\793A\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103597771900308086)
,p_name=>'WWV_FLOW_QUICK_FLOW.HELP_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DA\30FC\30B8\306B\306F\3001\30DA\30FC\30B8\306E\30D8\30EB\30D7\304C\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103598001051308086)
,p_name=>'WWV_FLOW_QUICK_FLOW.INSERT'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\3092\633F\5165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103596467101308085)
,p_name=>'WWV_FLOW_QUICK_FLOW.INSERT FORM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30FC\30E0\3092\633F\5165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103597289709308086)
,p_name=>'WWV_FLOW_QUICK_FLOW.INSERT_ANOTHER'
,p_message_language=>'ja'
,p_message_text=>unistr('\5225\306E\3082\306E\3092\633F\5165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103598542626308087)
,p_name=>'WWV_FLOW_QUICK_FLOW.INSERT_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306B\884C\3092\633F\5165\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103597120303308086)
,p_name=>'WWV_FLOW_QUICK_FLOW.INSERT_SUCCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\304C\6B63\5E38\306B\633F\5165\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104060330519308484)
,p_name=>'WWV_FLOW_QUICK_FLOW.IS_DATE'
,p_message_language=>'ja'
,p_message_text=>unistr('#LABEL#\306F\3001\6709\52B9\306A\65E5\4ED8\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103596900658308085)
,p_name=>'WWV_FLOW_QUICK_FLOW.IS_NUM'
,p_message_language=>'ja'
,p_message_text=>unistr('#LABEL#\306F\6570\5024\3067\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103996543218308433)
,p_name=>'WWV_FLOW_QUICK_FLOW.IS_TIMESTAMP'
,p_message_language=>'ja'
,p_message_text=>unistr('#LABEL#\306F\6709\52B9\306A\30BF\30A4\30E0\30B9\30BF\30F3\30D7\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103597906228308086)
,p_name=>'WWV_FLOW_QUICK_FLOW.MENU'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\30D6\30EC\30C3\30C9\30AF\30E9\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103596853303308085)
,p_name=>'WWV_FLOW_QUICK_FLOW.NOT_NULL'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306B\5024\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104676080366308980)
,p_name=>'WWV_FLOW_QUICK_FLOW.NUMERIC_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('#COLUMN_HEADER#\306F\6570\5024\3067\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103644762915308124)
,p_name=>'WWV_FLOW_QUICK_FLOW.POPUP_LOV_TEMPLATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DD\30C3\30D7\30A2\30C3\30D7LOV\30C6\30F3\30D7\30EC\30FC\30C8\3092\4F5C\6210\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103599132151308087)
,p_name=>'WWV_FLOW_QUICK_FLOW.REPORT_AND_EDIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\304A\3088\3073\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103598109100308086)
,p_name=>'WWV_FLOW_QUICK_FLOW.REPORT_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\3092\8868\793A\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103598474015308086)
,p_name=>'WWV_FLOW_QUICK_FLOW.RESET_PAGINATION_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\533A\5207\308A\3092\30EA\30BB\30C3\30C8\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103597414497308086)
,p_name=>'WWV_FLOW_QUICK_FLOW.RETURN_HOME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DB\30FC\30E0\306B\623B\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103597828308308086)
,p_name=>'WWV_FLOW_QUICK_FLOW.RETURN_PREV_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\524D\306E\30DA\30FC\30B8\306B\623B\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103595905321308085)
,p_name=>'WWV_FLOW_QUICK_FLOW.SEARCH'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104713082236309011)
,p_name=>'WWV_FLOW_QUICK_FLOW.SEARCH.ALL_APPS'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\691C\7D22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104712250541309010)
,p_name=>'WWV_FLOW_QUICK_FLOW.SEARCH.APPS'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104712080989309010)
,p_name=>'WWV_FLOW_QUICK_FLOW.SEARCH.TEAM.DEV'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30FC\30E0\958B\767A\306E\691C\7D22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104712771995309011)
,p_name=>'WWV_FLOW_QUICK_FLOW.SEARCH.USERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\306E\691C\7D22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103596003559308085)
,p_name=>'WWV_FLOW_QUICK_FLOW.SHOW_CHART_BY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\306E\8868\793A\65B9\6CD5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103600474089308088)
,p_name=>'WWV_FLOW_QUICK_FLOW.SHOW_MENU_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0\3092\8868\793A\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103597528120308086)
,p_name=>'WWV_FLOW_QUICK_FLOW.SUCCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6210\529F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103597099683308085)
,p_name=>'WWV_FLOW_QUICK_FLOW.SUCCESS_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\6210\529F\300D\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104676285582308980)
,p_name=>'WWV_FLOW_QUICK_FLOW.TIMESTAMP_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('#COLUMN_HEADER#\306F\6709\52B9\306A\30BF\30A4\30E0\30B9\30BF\30F3\30D7\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103596740154308085)
,p_name=>'WWV_FLOW_QUICK_FLOW.UPDATE'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306E\66F4\65B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103596640668308085)
,p_name=>'WWV_FLOW_QUICK_FLOW.UPDATE_FORM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30FC\30E0\306E\66F4\65B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103646314815308125)
,p_name=>'WWV_FLOW_QUICK_FLOW.USE_ONE_LEVEL_TAB'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306F\30011\30EC\30D9\30EB\306E\30BF\30D6\3092\4F7F\7528\3057\3066\306E\307F\69CB\7BC9\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103597397695308086)
,p_name=>'WWV_FLOW_QUICK_FLOW.VIEW_REPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103627434249308108)
,p_name=>'WWV_FLOW_REGION_LAYOUT.ABOUT'
,p_message_language=>'ja'
,p_message_text=>unistr('\60C5\5831')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103627581980308108)
,p_name=>'WWV_FLOW_REGION_LAYOUT.BRANCHING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30E9\30F3\30C1\51E6\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103791752628308241)
,p_name=>'WWV_FLOW_REGION_LAYOUT.ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103617776723308100)
,p_name=>'WWV_FLOW_REGION_NATIVE.JQM_LIST_VIEW.NESTED_LIST_CLIENT_SEARCH_ONLY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CD\30B9\30C8\3057\305F\30EA\30B9\30C8\3067\691C\7D22\30BF\30A4\30D7\3068\3057\3066\30B5\30DD\30FC\30C8\3055\308C\308B\306E\306F\3001\300C\30AF\30E9\30A4\30A2\30F3\30C8\5074\300D\306E\307F\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103779862970308231)
,p_name=>'WWV_FLOW_REGION_TREE.UNEXPECTED_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E88\671F\3057\306A\3044\30A8\30E9\30FC: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103763470954308218)
,p_name=>'WWV_FLOW_REGION_TREES.ROOT_NOT_FND_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\8B66\544A: \30C4\30EA\30FC\30FB\30EB\30FC\30C8ID\300C%0\300D\304C\898B\3064\304B\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103975742968308417)
,p_name=>'WWV_FLOW_REMOTE_EXEC.RUN_PLSQL_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30E2\30FC\30C8SQL\51E6\7406\4E2D\306BPLSQL\30B3\30FC\30C9\3067\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103535754503308041)
,p_name=>'WWV_FLOW_REPORT_DEV.CREATE_CARDS_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30FC\30C9\30FB\30DA\30FC\30B8\3092\4F5C\6210\3067\304D\307E\305B\3093\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104117502060308531)
,p_name=>'WWV_FLOW_REST.NOT_ENABLED'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A4\30F3\30B9\30BF\30F3\30B9\3067\306FRESTful\30A2\30AF\30BB\30B9\304C\7121\52B9\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104115830499308530)
,p_name=>'WWV_FLOW_REST.NOT_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\304C\898B\3064\304B\3089\306A\304B\3063\305F\304B\3001REST\304C\6709\52B9\3067\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104115991548308530)
,p_name=>'WWV_FLOW_REST.NO_OUTPUT'
,p_message_language=>'ja'
,p_message_text=>unistr('\51FA\529B\30E1\30BD\30C3\30C9\304C\6307\5B9A\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103766459552308221)
,p_name=>'WWV_FLOW_SECURITY.COMPANY_REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\304C\5FC5\8981\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103766548101308221)
,p_name=>'WWV_FLOW_SECURITY.FLOW_REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304C\5FC5\8981\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103766663656308221)
,p_name=>'WWV_FLOW_SECURITY.INVALID_USER_PASS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\540D\300C%0\300D\307E\305F\306F\30D1\30B9\30EF\30FC\30C9\304C\7121\52B9\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103995946681308432)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.INSERTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F%0\5C5E\6027\304C\633F\5165\3055\308C\305F\305F\3081\7FFB\8A33\304C\5FC5\8981\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103996062057308432)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.PURGED'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\5C5E\6027\304C\30D1\30FC\30B8\3055\308C\305F\305F\3081\3001\7FFB\8A33\306F\5FC5\8981\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103628365848308111)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.SEED_DELETE_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30FC\30C9\306E\524A\9664\30A8\30E9\30FC: %0.%1 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103628265206308111)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.SEED_INSERT_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30FC\30C9\306E\633F\5165\30A8\30E9\30FC: %0.%1 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103996158927308432)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.TOTAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5408\8A08%0\5C5E\6027\306F\7FFB\8A33\306E\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103628134744308108)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.TRANSLATION_NOT_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3%1\306E%0\7FFB\8A33\304C\898B\3064\304B\308A\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103995839035308432)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.UPDATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E2\5B58\306E%0\5C5E\6027\304C\66F4\65B0\3055\308C\305F\305F\3081\7FFB\8A33\304C\5FC5\8981\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103802958692308249)
,p_name=>'WWV_FLOW_SERIES_ATTR.ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104066334316308489)
,p_name=>'WWV_FLOW_SESSION_MON.NO_INDEX'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306B\306F\7D22\5F15\304C\3042\308A\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103997065249308433)
,p_name=>'WWV_FLOW_SODA_DEV.APPEND_INCOMPLETE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30EC\30AF\30B7\30E7\30F3<code>%0</code>\306E\30C7\30FC\30BF\306B\65B0\898F\306E<b id="incompl_success_row_count"></b>\30C9\30AD\30E5\30E1\30F3\30C8\304C\8FFD\52A0\3055\308C\307E\3057\305F\3002<b class="u-danger-text" id="incompl_fail_row_count"></b>\30C9\30AD\30E5\30E1\30F3\30C8\304C\62D2\5426\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103996807656308433)
,p_name=>'WWV_FLOW_SODA_DEV.APPEND_SUCCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30EC\30AF\30B7\30E7\30F3<code>%0</code>\306E\30C7\30FC\30BF\306B\65B0\898F\306E<b id="success_row_count"></b>\30C9\30AD\30E5\30E1\30F3\30C8\304C\8FFD\52A0\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103534844578308041)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_CONTENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30C6\30F3\30C4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103997299771308433)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_CONTENT_SIZE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30A4\30BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103535083076308041)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_CREATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103534707589308041)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_KEY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AD\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103535174514308041)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_LASTMODIFIED'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\7D42\66F4\65B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103534911531308041)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_MEDIA_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E1\30C7\30A3\30A2\30FB\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103540119239308044)
,p_name=>'WWV_FLOW_SODA_DEV.DATA_GUIDE_NOT_AVAILABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30AC\30A4\30C9\306F\4F7F\7528\3067\304D\307E\305B\3093\3002\30B3\30EC\30AF\30B7\30E7\30F3\306B\30C7\30FC\30BF\304C\542B\307E\308C\3066\3044\306A\3044\304B\3001\307E\3060JSON\691C\7D22\7D22\5F15\304C\4F5C\6210\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103534017946308040)
,p_name=>'WWV_FLOW_SODA_DEV.FILE_FORMATS'
,p_message_language=>'ja'
,p_message_text=>unistr('JSON\3001TXT\307E\305F\306FZIP\30D5\30A1\30A4\30EB\3092\30A2\30C3\30D7\30ED\30FC\30C9\3057\307E\3059\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103540243062308044)
,p_name=>'WWV_FLOW_SODA_DEV.META_DATA_NOT_AVAILABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30EC\30AF\30B7\30E7\30F3\30FB\30E1\30BF\30C7\30FC\30BF\3092\4F7F\7528\3067\304D\307E\305B\3093\3002\30B3\30EC\30AF\30B7\30E7\30F3\540D\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103997167186308433)
,p_name=>'WWV_FLOW_SODA_DEV.REPLACE_INCOMPLETE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30EC\30AF\30B7\30E7\30F3<code>%0</code>\306E\30C7\30FC\30BF\304C\65B0\898F\306E<b id="incompl_success_row_count"></b>\30C9\30AD\30E5\30E1\30F3\30C8\306B\7F6E\304D\63DB\3048\3089\308C\307E\3057\305F\3002<b class="u-danger-text" id="incompl_fail_row_count"></b>\30C9\30AD\30E5\30E1\30F3\30C8\304C\62D2\5426\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103996992230308433)
,p_name=>'WWV_FLOW_SODA_DEV.REPLACE_SUCCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30EC\30AF\30B7\30E7\30F3<code>%0</code>\306E\30C7\30FC\30BF\304C\65B0\898F\306E<b id="success_row_count"></b>\30C9\30AD\30E5\30E1\30F3\30C8\306B\7F6E\304D\63DB\3048\3089\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103780769299308232)
,p_name=>'WWV_FLOW_SVG.AXIS_INT_GT_ZERO_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C\306B\5931\6557\3057\307E\3057\305F: \8EF8\306E\9593\9694\306B\306F0(\30BC\30ED)\3088\308A\5927\304D\3044\5024\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103780515537308232)
,p_name=>'WWV_FLOW_SVG.AXIS_MAX_GT_MIN_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C\306B\5931\6557\3057\307E\3057\305F: \8EF8\306E\6700\5927\5024\306B\306F\8EF8\306E\6700\5C0F\5024\3088\308A\5927\304D\3044\5024\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103780961562308232)
,p_name=>'WWV_FLOW_SVG.AXIS_MAX_GT_ZERO_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C\306B\5931\6557\3057\307E\3057\305F: \8EF8\306E\6700\5927\5024\306B\306F0(\30BC\30ED)\3088\308A\5927\304D\3044\5024\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103780860254308232)
,p_name=>'WWV_FLOW_SVG.AXIS_MIN_GT_ZERO_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C\306B\5931\6557\3057\307E\3057\305F: \8EF8\306E\6700\5C0F\5024\306B\306F0(\30BC\30ED)\4EE5\4E0A\306E\5024\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103780629608308232)
,p_name=>'WWV_FLOW_SVG.BAR_WIDTH_GT_ZERO_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C\306B\5931\6557\3057\307E\3057\305F: \30D0\30FC\306E\5E45\306B\306F0(\30BC\30ED)\3088\308A\5927\304D\3044\5024\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103780299851308231)
,p_name=>'WWV_FLOW_SVG.ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103782293600308233)
,p_name=>'WWV_FLOW_SVG.FETCH_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A7\30C3\30C1\30FB\30A8\30E9\30FC: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103782069705308233)
,p_name=>'WWV_FLOW_SVG.FUNC_RET_SQL_QRY_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B\3092\623B\3059\30D5\30A1\30F3\30AF\30B7\30E7\30F3: \554F\5408\305B\3092\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30D3\30EB\30C0\30FC\5185\3067\89E3\6790\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103781176471308232)
,p_name=>'WWV_FLOW_SVG.GAPS_GT_ZERO_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C\306B\5931\6557\3057\307E\3057\305F: \30D0\30FC\306E\9593\9694\306B\306F0(\30BC\30ED)\4EE5\4E0A\306E\5024\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103780368417308232)
,p_name=>'WWV_FLOW_SVG.MAX_ROWS_GT_ZERO_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C\306B\5931\6557\3057\307E\3057\305F: \8868\793A\3059\308B\884C\306E\6700\5927\6570\306B\306F0(\30BC\30ED)\3088\308A\5927\304D\3044\5024\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103782544963308233)
,p_name=>'WWV_FLOW_SVG.MORE_DATA_FND_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\306F\3055\3089\306B\898B\3064\304B\308A\307E\3057\305F\304C\3001\5024\306F30\500B\3092\8D85\3048\3066\8868\793A\3067\304D\307E\305B\3093\3067\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103782124731308233)
,p_name=>'WWV_FLOW_SVG.PARSE_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\89E3\6790\30A8\30E9\30FC: %0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103782485584308233)
,p_name=>'WWV_FLOW_SVG.SVG_CHART_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('SVG\30C1\30E3\30FC\30C8\30FB\30A8\30E9\30FC: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103782365135308233)
,p_name=>'WWV_FLOW_SVG.UNABLE_CALC_GRAPH_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30E9\30D5\30FB\30DB\30EB\30C0\30FC\306E\4F4D\7F6E\3092\8A08\7B97\3067\304D\307E\305B\3093: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103781979996308233)
,p_name=>'WWV_FLOW_SVG.UNABLE_GET_COLOR_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30E9\30FC\3092\53D6\5F97\3067\304D\307E\305B\3093: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103781314539308232)
,p_name=>'WWV_FLOW_SVG.X_AXIS_INT_GT_ZERO_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C\306B\5931\6557\3057\307E\3057\305F: X\8EF8\306E\9593\9694\306B\306F0(\30BC\30ED)\3088\308A\5927\304D\3044\5024\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103781796517308233)
,p_name=>'WWV_FLOW_SVG.X_AXIS_MAX_GT_ZERO_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C\306B\5931\6557\3057\307E\3057\305F: X\8EF8\306E\6700\5927\5024\306B\306F0(\30BC\30ED)\3088\308A\5927\304D\3044\5024\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103781524016308232)
,p_name=>'WWV_FLOW_SVG.X_AXIS_MIN_GT_ZERO_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C\306B\5931\6557\3057\307E\3057\305F: X\8EF8\306E\6700\5C0F\5024\306B\306F0(\30BC\30ED)\4EE5\4E0A\306E\5024\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103781459597308232)
,p_name=>'WWV_FLOW_SVG.Y_AXIS_INT_GT_ZERO_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C\306B\5931\6557\3057\307E\3057\305F: Y\8EF8\306E\9593\9694\306B\306F0(\30BC\30ED)\3088\308A\5927\304D\3044\5024\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103781272023308232)
,p_name=>'WWV_FLOW_SVG.Y_AXIS_MAX_GT_MIN_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C\306B\5931\6557\3057\307E\3057\305F: Y\8EF8\306E\6700\5927\5024\306B\306F\8EF8\306E\6700\5C0F\5024\3088\308A\5927\304D\3044\5024\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103781841335308233)
,p_name=>'WWV_FLOW_SVG.Y_AXIS_MAX_GT_ZERO_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C\306B\5931\6557\3057\307E\3057\305F: Y\8EF8\306E\6700\5927\5024\306B\306F0(\30BC\30ED)\3088\308A\5927\304D\3044\5024\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103781628191308233)
,p_name=>'WWV_FLOW_SVG.Y_AXIS_MIN_GT_ZERO_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C\306B\5931\6557\3057\307E\3057\305F: Y\8EF8\306E\6700\5C0F\5024\306B\306F0(\30BC\30ED)\4EE5\4E0A\306E\5024\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103778494413308230)
,p_name=>'WWV_FLOW_SW_API.ADD_MEMBER_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E1\30F3\30D0\30FC\30FB\30A8\30E9\30FC\3092\8FFD\52A0\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103582670917308075)
,p_name=>'WWV_FLOW_SW_API.CANNOT_RUN_CMD'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\30B3\30DE\30F3\30C9\304C\30D6\30ED\30C3\30AF\3055\308C\307E\3057\305F\3002  SQL\30EF\30FC\30AF\30B7\30E7\30C3\30D7\304B\3089\5B9F\884C\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103775363290308228)
,p_name=>'WWV_FLOW_SW_API.CHECK_PRIV'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC%0\306F\3001%1\30B9\30AD\30FC\30DE\306B\5BFE\3059\308B\6A29\9650\3092\6240\6709\3057\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103595332336308084)
,p_name=>'WWV_FLOW_SW_API.CHECK_PRIV_OBJ'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AD\30FC\30DE%0\306B\306F\3001\8868\307E\305F\306F\30D3\30E5\30FC%1\306B\5BFE\3059\308BSELECT\6A29\9650\304C\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103778641062308230)
,p_name=>'WWV_FLOW_SW_API.CREATE_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AF\30EA\30D7\30C8\306E\4F5C\6210\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103775440814308228)
,p_name=>'WWV_FLOW_SW_API.CREATE_PLAN_TABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('EXPLAIN PLAN\6587\3092\7C21\5358\306B\5B9F\884C\3067\304D\308B\3088\3046\306B\4F5C\6210\3055\308C\305FPLAN TABLE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103775972479308228)
,p_name=>'WWV_FLOW_SW_API.CREATE_SCRIPT_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AF\30EA\30D7\30C8\30FB\30D5\30A1\30A4\30EB\306E\4F5C\6210\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103775554656308228)
,p_name=>'WWV_FLOW_SW_API.ERROR_MSG'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C%0\306E\30A8\30E9\30FC: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103775795741308228)
,p_name=>'WWV_FLOW_SW_API.INSERT_SCRIPT_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\306E\8868\306B\30B9\30AF\30EA\30D7\30C8\3092\633F\5165\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104723815053309019)
,p_name=>'WWV_FLOW_SW_API.INVALID_ROWID'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9\306A\884CID: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103775895711308228)
,p_name=>'WWV_FLOW_SW_API.PARSE_SCRIPT_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AF\30EA\30D7\30C8\306E\89E3\6790\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103775669865308228)
,p_name=>'WWV_FLOW_SW_API.RUN_SQL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AD\30FC\30DE\300C%0\300D\304C\30C7\30FC\30BF\30D9\30FC\30B9\306B\5B58\5728\3057\307E\305B\3093\3002\6B63\3057\3044\30C7\30D5\30A9\30EB\30C8\306E\30B9\30AD\30FC\30DE\3092\8A2D\5B9A\3059\308B\306B\306F\3001\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306E\7BA1\7406\8005\306B\9023\7D61\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103576148464308070)
,p_name=>'WWV_FLOW_SW_API.RUN_SQL_ARR'
,p_message_language=>'ja'
,p_message_text=>unistr('run_sql_arr\3067\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103778582953308230)
,p_name=>'WWV_FLOW_SW_API.UPDATE_MEMBER_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E1\30F3\30D0\30FC\306E\66F4\65B0\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103595229141308084)
,p_name=>'WWV_FLOW_SW_PARSER.LINE_EXCEEDS_32K'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AF\30EA\30D7\30C8\306E\884C\304C32767\30D0\30A4\30C8\3092\8D85\3048\3066\3044\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103562156486308060)
,p_name=>'WWV_FLOW_SW_SCRIPT.CANCELED'
,p_message_language=>'ja'
,p_message_text=>unistr('\53D6\6D88\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103810950966308256)
,p_name=>'WWV_FLOW_SW_SCRIPT.CANCELING'
,p_message_language=>'ja'
,p_message_text=>unistr('\53D6\6D88\3057\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103563177340308061)
,p_name=>'WWV_FLOW_SW_SCRIPT.COMPLETED'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B8C\4E86')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103563504920308061)
,p_name=>'WWV_FLOW_SW_SCRIPT.ELAPSED'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\79D2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103562246592308060)
,p_name=>'WWV_FLOW_SW_SCRIPT.EXECUTING'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9F\884C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103621080328308103)
,p_name=>'WWV_FLOW_SW_SCRIPT.INVALID_STMT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0D\660E\306A\6587\3092\542B\3080\30B9\30AF\30EA\30D7\30C8\3092\5B9F\884C\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002\6B21\306E\6587\3092\524A\9664\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103563277273308061)
,p_name=>'WWV_FLOW_SW_SCRIPT.IN_PROGRESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\9032\884C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103620907576308103)
,p_name=>'WWV_FLOW_SW_SCRIPT.LINE_NUMBER'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\756A\53F7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103582514463308075)
,p_name=>'WWV_FLOW_SW_SCRIPT.MAX_NEST_LEVEL'
,p_message_language=>'ja'
,p_message_text=>unistr('ERR-1004 \30B9\30AF\30EA\30D7\30C8\306F%0\30EC\30D9\30EB\4EE5\4E0A\306B\30CD\30B9\30C8\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103583812332308076)
,p_name=>'WWV_FLOW_SW_SCRIPT.MAX_SCRIPT_OUTPUT_REACHED'
,p_message_language=>'ja'
,p_message_text=>unistr('ERR-1005 \30B9\30AF\30EA\30D7\30C8\306E\51FA\529B\304C\6700\5927\30B5\30A4\30BA\5236\9650\306B\5230\9054\3057\307E\3057\305F\3002\751F\6210\3059\308B\51FA\529B\3092\6E1B\3089\3059\3088\3046\306B\30B9\30AF\30EA\30D7\30C8\3092\5909\66F4\3059\308B\304B\3001\307E\305F\306F\7BA1\7406\8005\306B\9023\7D61\3057\3066\3001\30B9\30AF\30EA\30D7\30C8\306E\6700\5927\7D50\679C\30B5\30A4\30BA\3092\5897\3084\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103912017357308336)
,p_name=>'WWV_FLOW_SW_SCRIPT.MAX_SCRIPT_SIZE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AF\30EA\30D7\30C8\306F%0\30D0\30A4\30C8\306E\6700\5927\8A31\5BB9\30B5\30A4\30BA\3092\8D85\3048\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103583941187308076)
,p_name=>'WWV_FLOW_SW_SCRIPT.MAX_WORKSPACE_OUTPUT_REACHED'
,p_message_language=>'ja'
,p_message_text=>unistr('ERR-1005 \30B9\30AF\30EA\30D7\30C8\306E\51FA\529B\304C\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306E\6700\5927\7D50\679C\30B5\30A4\30BA\5236\9650\306B\5230\9054\3057\307E\3057\305F\3002\65E2\5B58\306E\7D50\679C\3092\524A\9664\3059\308B\304B\3001\307E\305F\306F\7BA1\7406\8005\306B\9023\7D61\3057\3066\3001\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306E\6700\5927\7D50\679C\30B5\30A4\30BA\3092\5897\3084\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103847015550308283)
,p_name=>'WWV_FLOW_SW_SCRIPT.NO_STMT_BUFFER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D0\30C3\30D5\30A1\5185\306B\5B9F\884C\5BFE\8C61\306E\6587\304C\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103577837526308072)
,p_name=>'WWV_FLOW_SW_SCRIPT.QUERY_LIMIT'
,p_message_language=>'ja'
,p_message_text=>unistr('SELECT\6587\306F32KB\4EE5\4E0B\306B\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103563389795308061)
,p_name=>'WWV_FLOW_SW_SCRIPT.RESULT_ROW'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103563485236308061)
,p_name=>'WWV_FLOW_SW_SCRIPT.RESULT_ROWS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103578709356308072)
,p_name=>'WWV_FLOW_SW_SCRIPT.ROWS_SELECTED'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\884C\304C\9078\629E\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103806029216308252)
,p_name=>'WWV_FLOW_SW_SCRIPT.RUN_EMPTY'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9F\884C\53EF\80FD\306A\6587\304C\542B\307E\308C\3066\3044\306A\3044\30B9\30AF\30EA\30D7\30C8\3092\5B9F\884C\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103575915286308070)
,p_name=>'WWV_FLOW_SW_SCRIPT.RUN_FILE_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AF\30EA\30D7\30C8\3092\5B9F\884C\3067\304D\307E\305B\3093\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103576058277308070)
,p_name=>'WWV_FLOW_SW_SCRIPT.RUN_STMT_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('run_statement\3067\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103805970625308252)
,p_name=>'WWV_FLOW_SW_SCRIPT.RUN_WARNING'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\30EF\30FC\30AF\30B7\30E7\30C3\30D7\304C\7121\8996\3059\308B\6587\3092\542B\3080\30B9\30AF\30EA\30D7\30C8\3092\5B9F\884C\3059\308B\3088\3046\306B\30EA\30AF\30A8\30B9\30C8\3057\307E\3057\305F\3002\30EA\30AF\30A8\30B9\30C8\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103582452376308075)
,p_name=>'WWV_FLOW_SW_SCRIPT.SCRIPT_NOT_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('ERR-1001 \30B9\30AF\30EA\30D7\30C8\304C\898B\3064\304B\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103562082890308060)
,p_name=>'WWV_FLOW_SW_SCRIPT.SUBMITTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\9001\4FE1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103810479221308255)
,p_name=>'WWV_FLOW_SW_SCRIPT.UNKNOWN_STATEMENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0D\660E\306A\6587')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103810206140308255)
,p_name=>'WWV_FLOW_SW_SCRIPT.USED'
,p_message_language=>'ja'
,p_message_text=>unistr('%0%\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103795992356308244)
,p_name=>'WWV_FLOW_SW_UTIL.PACKAGE_CREATE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9\306ASQL\69CB\6587\306E\305F\3081\3001\30D1\30C3\30B1\30FC\30B8\306E\4F5C\6210\306B\5931\6557\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103795678536308244)
,p_name=>'WWV_FLOW_SW_UTIL.TABLE_CREATE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9\306ASQL\69CB\6587\306E\305F\3081\3001\8868\306E\4F5C\6210\306B\5931\6557\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103628568253308112)
,p_name=>'WWV_FLOW_SYNC_TRANSLATIONS.SYNC_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\540C\671F\30A8\30E9\30FC: %0.%1 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103952029772308399)
,p_name=>'WWV_FLOW_TABLE_DRILL.REFERENCED_BY'
,p_message_language=>'ja'
,p_message_text=>unistr('\53C2\7167\5143')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103951997085308399)
,p_name=>'WWV_FLOW_TABLE_DRILL.REFERENCES'
,p_message_language=>'ja'
,p_message_text=>unistr('\53C2\7167')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103626813202308107)
,p_name=>'WWV_FLOW_TABULAR_FORM.MAX_COLUMN_NO'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\914D\5217apex_application.g_f%0\306B\30DE\30C3\30D7\3055\308C\308B\8868\5F62\5F0F\30D5\30A9\30FC\30E0\5217\306B\30A2\30AF\30BB\30B9\3092\8A66\307F\307E\3057\305F\304C\3001\72B6\614B\3092\4FDD\5B58\3059\308B%1\5217\306E\307F\30B5\30DD\30FC\30C8\3055\308C\307E\3059\3002\72B6\614B\3092\4FDD\5B58\3059\308B\5217\306E\6570\3092\6E1B\3089\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104189586355308601)
,p_name=>'WWV_FLOW_TAB_MGR.ADD_NEW_PARENT_TAB'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F\89AA\30BF\30D6\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103974955556308416)
,p_name=>'WWV_FLOW_TAB_MGR.ADD_NEW_STD_TAB'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F\6A19\6E96\30BF\30D6\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103975575703308417)
,p_name=>'WWV_FLOW_TAB_MGR.NEW_TABSET'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F\30BF\30D6\30FB\30BB\30C3\30C8(\65B0\898F\30BF\30D6\30FB\30BB\30C3\30C8\306B\6A19\6E96\30BF\30D6\3092\4F5C\6210\53EF\80FD)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103803258478308250)
,p_name=>'WWV_FLOW_TAB_MGR.NEW_TABSET_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\89AA\30BF\30D6ID=%0\306E\65B0\3057\3044\30BF\30D6\30FB\30BB\30C3\30C8\304C\898B\3064\304B\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103803130361308249)
,p_name=>'WWV_FLOW_TAB_MGR.OLD_TABSET_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30D6ID=%0\306E\5143\306E\30BF\30D6\30FB\30BB\30C3\30C8\304C\898B\3064\304B\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103803326158308250)
,p_name=>'WWV_FLOW_TAB_MGR.PAGE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8ID: %0\306F\6570\5024\3067\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103975077729308417)
,p_name=>'WWV_FLOW_TAB_MGR.PAR_TAB'
,p_message_language=>'ja'
,p_message_text=>unistr('\89AA\30BF\30D6\3067\3059\3002\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103975437567308417)
,p_name=>'WWV_FLOW_TAB_MGR.PSEDUO_DESC'
,p_message_language=>'ja'
,p_message_text=>unistr('\89AA\30BF\30D6\306B\95A2\9023\4ED8\3051\3089\308C\3066\3044\307E\305B\3093\3002\3053\306E\30BF\30D6\30FB\30BB\30C3\30C8\5185\306E\6A19\6E96\30BF\30D6\3092\7DE8\96C6\3067\304D\308B\3088\3046\306B\64EC\4F3C\89AA\30BF\30D6\3068\3057\3066\8868\793A\3055\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103975645178308417)
,p_name=>'WWV_FLOW_TAB_MGR.SELECT_STD_TAB'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A19\6E96\30BF\30D6\306E\9078\629E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103975240578308417)
,p_name=>'WWV_FLOW_TAB_MGR.SEL_PAR_TAB'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3057\305F\89AA\30BF\30D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103975116155308417)
,p_name=>'WWV_FLOW_TAB_MGR.SEL_PSD_PAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3057\305F\64EC\4F3C\89AA\30BF\30D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103803008599308249)
,p_name=>'WWV_FLOW_TAB_MGR.SGID_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30AD\30E5\30EA\30C6\30A3\30FB\30B0\30EB\30FC\30D7ID\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103803455842308250)
,p_name=>'WWV_FLOW_TAB_MGR.SPEC_NEW_TABSET_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30D6ID=%0\306E\65B0\3057\3044\30BF\30D6\30FB\30BB\30C3\30C8\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103974873690308416)
,p_name=>'WWV_FLOW_TAB_MGR.STD_TAB_SEQ'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A19\6E96\30BF\30D6\3067\3059\3002\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103974712720308416)
,p_name=>'WWV_FLOW_TAB_MGR.TAB_ALSO_CUR_FOR_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30BF\30D6\3092\30AB\30EC\30F3\30C8\306B\6307\5B9A\3059\308B\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103974647555308416)
,p_name=>'WWV_FLOW_TAB_MGR.TAB_CUR_FOR_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306E\30AB\30EC\30F3\30C8\30FB\30BF\30D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103975333181308417)
,p_name=>'WWV_FLOW_TAB_MGR.THE_TAB_SET'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30D6\30FB\30BB\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103629782238308112)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.BUTTON_TEMPLATE_NOT_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\300C%1\300D\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9\300C%2\300D\5185\3067\3001\30B3\30D4\30FC\3059\308B\30DC\30BF\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8(%0)\304C\898B\3064\304B\308A\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103630678364308113)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.BUTTON_TEMPLATE_REPLACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\7F6E\304D\63DB\3048\308B\3053\3068\304C\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103796183114308244)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103629448998308112)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.FIELD_TEMPLATE_NOT_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\300C%1\300D\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9\300C%2\300D\5185\3067\3001\30B3\30D4\30FC\3059\308B\30D5\30A3\30FC\30EB\30C9\30FB\30C6\30F3\30D7\30EC\30FC\30C8(%0)\304C\898B\3064\304B\308A\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103630337947308113)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.FIELD_TEMPLATE_REPLACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30FC\30EB\30C9\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\7F6E\304D\63DB\3048\308B\3053\3068\304C\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103630267794308113)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.LIST_TEMPLATE_REPLACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\7F6E\304D\63DB\3048\308B\3053\3068\304C\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103629665055308112)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.MENU_TEMPLATE_NOT_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\300C%1\300D\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9\300C%2\300D\5185\3067\3001\30B3\30D4\30FC\3059\308B\30D6\30EC\30C3\30C9\30AF\30E9\30E0\30FB\30C6\30F3\30D7\30EC\30FC\30C8(%0)\304C\898B\3064\304B\308A\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103630490045308113)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.MENU_TEMPLATE_REPLACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\7F6E\304D\63DB\3048\308B\3053\3068\304C\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103629960563308113)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.PAGE_TEMPLATE_REPLACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\7F6E\304D\63DB\3048\308B\3053\3068\304C\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103630500721308113)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.POPUP_LOV_TEMPLATE_REPLACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DD\30C3\30D7\30A2\30C3\30D7LOV\30C6\30F3\30D7\30EC\30FC\30C8\3092\7F6E\304D\63DB\3048\308B\3053\3068\304C\3067\304D\307E\305B\3093\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103912909372308337)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.POPUP_TEMPLATE_NOT_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\300C%1\300D\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9\300C%2\300D\5185\3067\3001\30B3\30D4\30FC\3059\308B\30DD\30C3\30D7\30A2\30C3\30D7\30FB\30C6\30F3\30D7\30EC\30FC\30C8(%0)\304C\898B\3064\304B\308A\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103630068554308113)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.REGION_TEMPLATE_REPLACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\7F6E\304D\63DB\3048\308B\3053\3068\304C\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103630150020308113)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.REPORT_TEMPLATE_REPLACE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\7F6E\304D\63DB\3048\308B\3053\3068\304C\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103629361767308112)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.TEMPLATE_NOT_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30D4\30FC\3059\308B\30C6\30F3\30D7\30EC\30FC\30C8(%0)\304C\898B\3064\304B\308A\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103629844006308112)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.TEMPLATE_REPLACE'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\30C6\30F3\30D7\30EC\30FC\30C8\3092\7F6E\304D\63DB\3048\308B\3053\3068\304C\3067\304D\307E\305B\3093\3002 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104742852555309037)
,p_name=>'WWV_FLOW_THEME.STYLE_NOT_EXISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB\304C\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104760309848309050)
,p_name=>'WWV_FLOW_THEME_DEV.IS_READ_ONLY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30BF\30A4\30EB\3092\66F4\65B0\3067\304D\307E\305B\3093\3002\8AAD\53D6\308A\5C02\7528\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104760211316309050)
,p_name=>'WWV_FLOW_THEME_DEV.WWV_FLOW_THEME_STYLE_UK'
,p_message_language=>'ja'
,p_message_text=>unistr('\540D\524D\306F\3059\3067\306B\65E2\5B58\306E\30B9\30BF\30A4\30EB\304C\4F7F\7528\3057\3066\3044\307E\3059\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103628461577308111)
,p_name=>'WWV_FLOW_TRANSLATIONS.SEED_UPDATE_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30FC\30C9\306E\66F4\65B0\30A8\30E9\30FC: %0.%1 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104077442633308498)
,p_name=>'WWV_FLOW_UPGRADE.METADATA_DML_DISABLED'
,p_message_language=>'ja'
,p_message_text=>unistr('Application Express\3092\65B0\3057\3044\30D0\30FC\30B8\30E7\30F3\306B\30A2\30C3\30D7\30B0\30EC\30FC\30C9\4E2D\3067\3059\3002\30A2\30C3\30D7\30B0\30EC\30FC\30C9\304C\5B8C\4E86\3059\308B\307E\3067\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\5BFE\3059\308B\5909\66F4\306F\7121\52B9\306B\306A\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103740673070308200)
,p_name=>'WWV_FLOW_UTILITIES.ADD'
,p_message_language=>'ja'
,p_message_text=>unistr('\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103545963852308049)
,p_name=>'WWV_FLOW_UTILITIES.APPLICATION_NOT_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30E6\30FC\30B6\30FC%1\3068\3057\3066\30ED\30B0\30A4\30F3\3057\307E\3057\305F\304C\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3%0\304C\898B\3064\304B\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103546084535308049)
,p_name=>'WWV_FLOW_UTILITIES.APPLICATION_PAGE_NOT_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30E6\30FC\30B6\30FC%2\3068\3057\3066\30ED\30B0\30A4\30F3\3057\307E\3057\305F\304C\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3%0\30DA\30FC\30B8%1\304C\898B\3064\304B\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103741680339308201)
,p_name=>'WWV_FLOW_UTILITIES.CAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30EC\30F3\30C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103769694267308223)
,p_name=>'WWV_FLOW_UTILITIES.CHECKBOX_QUERY_LOV'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30A7\30C3\30AF\30DC\30C3\30AF\30B9\554F\5408\305B\306E\8A55\4FA1\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103741704118308201)
,p_name=>'WWV_FLOW_UTILITIES.CLOSE'
,p_message_language=>'ja'
,p_message_text=>unistr('\9589\3058\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103769294370308223)
,p_name=>'WWV_FLOW_UTILITIES.DISP_ONLY_LIST_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC: \8868\793A\306E\307F\306ELOV\306F2\3064\306E\5217\3092\9078\629E\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103740454502308200)
,p_name=>'WWV_FLOW_UTILITIES.ERR_LOV'
,p_message_language=>'ja'
,p_message_text=>unistr('LOV\3092\5224\5225\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103742088204308201)
,p_name=>'WWV_FLOW_UTILITIES.FIND'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\3092\691C\7D22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103791013137308240)
,p_name=>'WWV_FLOW_UTILITIES.GENERATE_POPUP_LOV_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DD\30C3\30D7\30A2\30C3\30D7LOV\306E\751F\6210\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103768967462308223)
,p_name=>'WWV_FLOW_UTILITIES.GENERATE_QUERY_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\554F\5408\305B\306E\751F\6210\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103769058430308223)
,p_name=>'WWV_FLOW_UTILITIES.INIT_LOV_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('LOV\306E\521D\671F\5316\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103769533805308223)
,p_name=>'WWV_FLOW_UTILITIES.INIT_QUERY_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\554F\5408\305B\3092\521D\671F\5316\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103694827155308162)
,p_name=>'WWV_FLOW_UTILITIES.INVALID_LOV_QUERY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DD\30C3\30D7\30A2\30C3\30D7LOV\554F\5408\305B\304C\7121\52B9\3067\3059\3002\8868\793A\5024\304A\3088\3073\623B\308A\5024\304C\5FC5\8981\3067\3059\3002\5217\540D\306F\7570\306A\3063\3066\3044\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103742155064308201)
,p_name=>'WWV_FLOW_UTILITIES.JS_NO_SUPPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30DD\30FC\30C8\3055\308C\3066\3044\306A\3044JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103742387123308201)
,p_name=>'WWV_FLOW_UTILITIES.LIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103742767208308202)
,p_name=>'WWV_FLOW_UTILITIES.LOV2_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('LOV\554F\5408\305B\3092\5B9F\884C\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103741528102308201)
,p_name=>'WWV_FLOW_UTILITIES.NEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103741138523308200)
,p_name=>'WWV_FLOW_UTILITIES.NO_MATCHES'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E00\81F4\3059\308B\3082\306E\304C\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103741821285308201)
,p_name=>'WWV_FLOW_UTILITIES.OK'
,p_message_language=>'ja'
,p_message_text=>'OK'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103790779467308240)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_BG_SELECT_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DD\30C3\30D7\30A2\30C3\30D7LOV\306F\3001\300C\9078\629E\300D\3067\59CB\3081\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103768842838308222)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_FILTER_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30EB\30BF\4ED8\304D\30DD\30C3\30D7\30A2\30C3\30D7LOV\3092\751F\6210\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103790998816308240)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_FILTER_INIT_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30EB\30BF\4ED8\304D\30DD\30C3\30D7\30A2\30C3\30D7LOV\306E\521D\671F\5316\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F: %0 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103790834021308240)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_INIT_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DD\30C3\30D7\30A2\30C3\30D7LOV\306E\521D\671F\5316\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103769334978308223)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_LOV_AUTH_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DD\30C3\30D7\30A2\30C3\30D7LOV\306E\8A8D\8A3C\306B\5931\6557\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103769419612308223)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_LOV_CHECK_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DD\30C3\30D7\30A2\30C3\30D7LOV\306E\30C1\30A7\30C3\30AF\30B5\30E0\691C\8A3C\306B\5931\6557\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103741245349308200)
,p_name=>'WWV_FLOW_UTILITIES.PREV'
,p_message_language=>'ja'
,p_message_text=>unistr('\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103740865513308200)
,p_name=>'WWV_FLOW_UTILITIES.REMOVE'
,p_message_language=>'ja'
,p_message_text=>unistr('\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103741917755308201)
,p_name=>'WWV_FLOW_UTILITIES.SEARCH_DIALOG'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22\30C0\30A4\30A2\30ED\30B0\30FB\30DC\30C3\30AF\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104352955442308721)
,p_name=>'WWV_FLOW_UTILITIES.SHOW_IMAGE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30E1\30FC\30B8\306E\8868\793A\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103770109269308224)
,p_name=>'WWV_FLOW_UTILITIES.T_BOLD'
,p_message_language=>'ja'
,p_message_text=>unistr('\592A\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103770543717308224)
,p_name=>'WWV_FLOW_UTILITIES.T_BULL_LIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\7B87\6761\66F8\304D\30EA\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103770903309308224)
,p_name=>'WWV_FLOW_UTILITIES.T_IND_LEFT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5DE6\30A4\30F3\30C7\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103771008382308224)
,p_name=>'WWV_FLOW_UTILITIES.T_IND_RIGHT'
,p_message_language=>'ja'
,p_message_text=>unistr('\53F3\30A4\30F3\30C7\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103770222724308224)
,p_name=>'WWV_FLOW_UTILITIES.T_ITALICS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30BF\30EA\30C3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103770725275308224)
,p_name=>'WWV_FLOW_UTILITIES.T_JUST_CEN'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E2D\592E\63C3\3048')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103770632470308224)
,p_name=>'WWV_FLOW_UTILITIES.T_JUST_LEFT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5DE6\63C3\3048')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103770825783308224)
,p_name=>'WWV_FLOW_UTILITIES.T_JUST_RT'
,p_message_language=>'ja'
,p_message_text=>unistr('\53F3\63C3\3048')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103770440740308224)
,p_name=>'WWV_FLOW_UTILITIES.T_NO_LIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\756A\53F7\4ED8\304D\30EA\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103770335669308224)
,p_name=>'WWV_FLOW_UTILITIES.T_UNDERLINE'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0B\7DDA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103769144611308223)
,p_name=>'WWV_FLOW_UTILITIES.UNABLE_TO_BIND_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C%0\300D\3092\30D0\30A4\30F3\30C9\3067\304D\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103545880828308049)
,p_name=>'WWV_FLOW_UTILITIES.WEBSHEET_NOT_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30E6\30FC\30B6\30FC%1\3068\3057\3066\30ED\30B0\30A4\30F3\3057\307E\3057\305F\304CWeb\30B7\30FC\30C8\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3%0\304C\898B\3064\304B\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103969860484308413)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_PROXY_OR_URL'
,p_message_language=>'ja'
,p_message_text=>unistr('\6307\5B9A\3057\305FURL\304C\7121\52B9\3001\4F7F\7528\74B0\5883\3067HTTP\30EA\30AF\30A8\30B9\30C8\7528\306B\6709\52B9\306A\30D7\30ED\30AD\30B7\30FB\30B5\30FC\30D0\30FC\30FB\30A2\30C9\30EC\30B9\304C\5FC5\8981\3001\30EA\30AF\30A8\30B9\30C8\304C\30BF\30A4\30E0\30A2\30A6\30C8\3057\305F\3001\307E\305F\306F\30A6\30A9\30EC\30C3\30C8\3092HTTPS\30EA\30AF\30A8\30B9\30C8\7528\306B\69CB\6210\3059\308B\5FC5\8981\304C\3042\308B\305F\3081\3001Web\30B5\30FC\30D3\30B9\306B\30A2\30AF\30BB\30B9\3067\304D\307E\305B\3093\3067\3057\305F\3002SQLERRM: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103616552418308100)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_UNRETRIEVABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6307\5B9A\3057\305FURL\304C\7121\52B9\304B\3001\4F7F\7528\74B0\5883\3067HTTP\30EA\30AF\30A8\30B9\30C8\7528\306B\6709\52B9\306A\30D7\30ED\30AD\30B7\30FB\30B5\30FC\30D0\30FC\30FB\30A2\30C9\30EC\30B9\304C\5FC5\8981\3067\3042\308B\306B\3082\304B\304B\308F\3089\305A\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\7528\306B\5B9A\7FA9\3055\308C\3066\3044\306A\3044\304B\3001\307E\305F\306F\30A6\30A9\30EC\30C3\30C8\3092HTTPS\30EA\30AF\30A8\30B9\30C8\7528\306B\3053\306E&PRODUCT_NAME.\30A4\30F3\30B9\30BF\30F3\30B9\306B\5BFE\3057\3066\69CB\6210\3059\308B\5FC5\8981\304C\3042\308B\305F\3081\3001WSDL\30C9\30AD\30E5\30E1\30F3\30C8\306F\53D6\5F97\3067\304D\307E\305B\3093\3067\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103617217010308100)
,p_name=>'WWV_FLOW_WIZARD_API.ACTION_PROCESSED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3\304C\51E6\7406\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104199231696308609)
,p_name=>'WWV_FLOW_WIZARD_API.ADD_ROW_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\3092\8FFD\52A0\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103611039847308096)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_BUTTON'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3\3092\4F5C\6210\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103647544763308126)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_CALENDAR_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30EC\30F3\30C0\30FB\30DA\30FC\30B8\3092\4F5C\6210\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103647246989308126)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_CHART_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\30FB\30DA\30FC\30B8\3092\4F5C\6210\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104329688061308704)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_DATA_LOAD_WIZARD'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30ED\30FC\30C9\51E6\7406\3092\5B8C\4E86\3067\304D\307E\305B\3093\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103647937551308126)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_EXCEL_CHART'
,p_message_language=>'ja'
,p_message_text=>unistr('Excel\306E\30C1\30E3\30FC\30C8\3092\4F5C\6210\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103647658988308126)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_FORM_ON_EQUIJOIN'
,p_message_language=>'ja'
,p_message_text=>unistr('\7B49\4FA1\7D50\5408\306E\30D5\30A9\30FC\30E0\3092\4F5C\6210\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103646815814308125)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_FORM_ON_SP'
,p_message_language=>'ja'
,p_message_text=>unistr('sp\306B\30D5\30A9\30FC\30E0\3092\4F5C\6210\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103646916874308125)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_FORM_ON_TABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\306B\30D5\30A9\30FC\30E0\3092\4F5C\6210\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103647042642308126)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_INSERT_FORM'
,p_message_language=>'ja'
,p_message_text=>unistr('\633F\5165\30D5\30A9\30FC\30E0\3092\4F5C\6210\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104131346983308542)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_JET_CHART'
,p_message_language=>'ja'
,p_message_text=>unistr('Oracle JET\306E\30C1\30E3\30FC\30C8\3092\4F5C\6210\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103533964007308040)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_MASTER_DETAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30B9\30BF\30FC\30FB\30C7\30A3\30C6\30FC\30EB\30FB\30DA\30FC\30B8\3092\4F5C\6210\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104016730862308448)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_PAGE_DA'
,p_message_language=>'ja'
,p_message_text=>unistr('\52D5\7684\30A2\30AF\30B7\30E7\30F3\3092\4F5C\6210\3067\304D\307E\305B\3093\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103647109681308126)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_QUERY_AND_UPDATE_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\554F\5408\305B\304A\3088\3073\66F4\65B0\30DA\30FC\30B8\3092\4F5C\6210\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103647456413308126)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_REPORT_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\30FB\30DA\30FC\30B8\3092\4F5C\6210\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103648072533308126)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_SUMMARY_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30DE\30EA\30FC\30FB\30DA\30FC\30B8\3092\4F5C\6210\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103648121549308126)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_SVG_CHART'
,p_message_language=>'ja'
,p_message_text=>unistr('SVG\30C1\30E3\30FC\30C8\30FB\30DA\30FC\30B8\3092\4F5C\6210\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103647870340308126)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_TREE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C4\30EA\30FC\3092\4F5C\6210\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103646766454308125)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_UPDATEABLE_REPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F4\65B0\53EF\80FD\30EC\30DD\30FC\30C8\3092\4F5C\6210\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103647701418308126)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_WIZARD'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A6\30A3\30B6\30FC\30C9\4F5C\6210\30A6\30A3\30B6\30FC\30C9\3092\4F5C\6210\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104199120313308609)
,p_name=>'WWV_FLOW_WIZARD_API.DELETE_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\524A\9664\3092\51E6\7406\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104199588482308609)
,p_name=>'WWV_FLOW_WIZARD_API.DELETE_SUCCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('#MRD_COUNT#\884C\304C\524A\9664\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103552902554308054)
,p_name=>'WWV_FLOW_WIZARD_API.GET_NEXT_PREV_PK'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\4E3B\30AD\30FC\5024\307E\305F\306F\524D\306E\4E3B\30AD\30FC\5024\3092\53D6\5F97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103552890710308054)
,p_name=>'WWV_FLOW_WIZARD_API.GET_NEXT_PREV_PK_BUTTON'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DC\30BF\30F3\306F\3001\6B21\306E\4E3B\30AD\30FC\5024\307E\305F\306F\524D\306E\4E3B\30AD\30FC\5024\3092\53D6\5F97\3059\308B\30D7\30ED\30BB\30B9\3067\5FC5\8981\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103552711911308054)
,p_name=>'WWV_FLOW_WIZARD_API.GET_NEXT_PREV_PK_ITEM'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30A4\30C6\30E0\306F\3001\6B21\306E\4E3B\30AD\30FC\5024\307E\305F\306F\524D\306E\4E3B\30AD\30FC\5024\3092\53D6\5F97\3059\308B\30D7\30ED\30BB\30B9\3067\5FC5\8981\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103553545094308054)
,p_name=>'WWV_FLOW_WIZARD_API.GET_NEXT_PREV_PK_PROCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\4E3B\30AD\30FC\5024\307E\305F\306F\524D\306E\4E3B\30AD\30FC\5024\3092\53D6\5F97\3059\308B\30D7\30ED\30BB\30B9\3092\5B9F\884C\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103562687349308061)
,p_name=>'WWV_FLOW_WIZARD_API.GET_NEXT_PREV_PK_SHORTCUT'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DA\30FC\30B8\3092\4FDD\5B58\305B\305A\306B\9589\3058\307E\3059\304B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103911967077308336)
,p_name=>'WWV_FLOW_WIZARD_API.GET_PK2_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('2\6B21\30AD\30FC\306E\30A2\30A4\30C6\30E0\5024\3092\53D6\5F97\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103911863536308336)
,p_name=>'WWV_FLOW_WIZARD_API.GET_PK_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E3B\30AD\30FC\306E\30A2\30A4\30C6\30E0\5024\3092\53D6\5F97\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103647374034308126)
,p_name=>'WWV_FLOW_WIZARD_API.INVALID_REPORT_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\30FB\30BF\30A4\30D7\304C\7121\52B9\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103925995483308379)
,p_name=>'WWV_FLOW_WIZARD_API.IR_REPORT_EXISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3067\306B\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\304C\5B58\5728\3057\3066\3044\307E\3059\30021\3064\306E\30DA\30FC\30B8\306B\8FFD\52A0\3067\304D\308B\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\306F1\3064\306E\307F\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103637855404308119)
,p_name=>'WWV_FLOW_WIZARD_API.NEXT_PREV_PK_PROCESS_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\4E3B\30AD\30FC\5024\307E\305F\306F\524D\306E\4E3B\30AD\30FC\5024\306E\53D6\5F97\30D7\30ED\30BB\30B9\3092\4F5C\6210\3067\304D\307E\305B\3093\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104199019228308609)
,p_name=>'WWV_FLOW_WIZARD_API.NO_PAGE_HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DA\30FC\30B8\3067\4F7F\7528\53EF\80FD\306A\30D8\30EB\30D7\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103646642644308125)
,p_name=>'WWV_FLOW_WIZARD_API.PARSE_ERROR1'
,p_message_language=>'ja'
,p_message_text=>unistr('\89E3\6790\30A8\30E9\30FC: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103646585422308125)
,p_name=>'WWV_FLOW_WIZARD_API.PARSE_ERROR2'
,p_message_language=>'ja'
,p_message_text=>unistr('\89E3\6790\30A8\30E9\30FC2 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104199610062308609)
,p_name=>'WWV_FLOW_WIZARD_API.REQUEST_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30AF\30A8\30B9\30C8\306E\9001\4FE1\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104199984139308609)
,p_name=>'WWV_FLOW_WIZARD_API.SHOW_TREE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C4\30EA\30FC\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104199714704308609)
,p_name=>'WWV_FLOW_WIZARD_API.TREE_ROOT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C4\30EA\30FC\30FB\30EB\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103617076869308100)
,p_name=>'WWV_FLOW_WIZARD_API.UNABLE_TO_FETCH'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\3092\30D5\30A7\30C3\30C1\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103617126603308100)
,p_name=>'WWV_FLOW_WIZARD_API.UNABLE_TO_PROCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868%0\306E\884C\3092\51E6\7406\3067\304D\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103648227417308126)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATEABLE_QUERY_EXISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F4\65B0\53EF\80FD\306ASQL\554F\5408\305B\304C\3059\3067\306B\5B58\5728\3057\307E\3059\30021\3064\306E\30DA\30FC\30B8\306B\8FFD\52A0\3067\304D\308B\66F4\65B0\53EF\80FD\306ASQL\554F\5408\305B\306F1\3064\306E\307F\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104199302503308609)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATE_APPLIED'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F4\65B0\304C\9069\7528\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104199429604308609)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATE_INSERT_SUCCESS'
,p_message_language=>'ja'
,p_message_text=>unistr('#MRU_COUNT#\884C\304C\66F4\65B0\3055\308C\3001#MRI_COUNT#\884C\304C\633F\5165\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104069888671308491)
,p_name=>'WWV_FLOW_WIZ_CONFIRM.COPY_AUTH_SCHEME'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\53EF\30B9\30AD\30FC\30E0\306E\30B3\30D4\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104069645712308491)
,p_name=>'WWV_FLOW_WIZ_CONFIRM.COPY_LIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8\306E\30B3\30D4\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104069421231308491)
,p_name=>'WWV_FLOW_WIZ_CONFIRM.COPY_LOV'
,p_message_language=>'ja'
,p_message_text=>unistr('LOV\306E\30B3\30D4\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104069776334308491)
,p_name=>'WWV_FLOW_WIZ_CONFIRM.USE_EXISTING_LIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E2\5B58\30EA\30B9\30C8\306E\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104069540183308491)
,p_name=>'WWV_FLOW_WIZ_CONFIRM.USE_EXISTING_LOV'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E2\5B58LOV\306E\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103771224360308224)
,p_name=>'WWV_FLOW_WORKSHEET.SHOW_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\306E\30EC\30F3\30C0\30EA\30F3\30B0\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104227490075308630)
,p_name=>'WWV_FLOW_WORKSPACE_REPORTS.TABLESPACE1'
,p_message_language=>'ja'
,p_message_text=>unistr('\5408\8A08%0 GB | %1 GB\4F7F\7528\6E08 | %2\30D1\30FC\30BB\30F3\30C8\4F7F\7528\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103544533389308048)
,p_name=>'WWV_FLOW_XE_CONFIG.SET_PGA_AGG_TARGET'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898FPGA\96C6\8A08\30BF\30FC\30B2\30C3\30C8\306E\8A2D\5B9A\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103544370883308047)
,p_name=>'WWV_FLOW_XE_CONFIG.SET_SGA_TARGET'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898FSGA\30BF\30FC\30B2\30C3\30C8\306E\8A2D\5B9A\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104791938866309082)
,p_name=>'WWV_FLOW_XLIFF.ERROR_PROCESSING'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306E\51E6\7406\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103766942789308221)
,p_name=>'WWV_RENDER_CHART2.T_AVERAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5E73\5747')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103766866018308221)
,p_name=>'WWV_RENDER_CHART2.T_AXIS'
,p_message_language=>'ja'
,p_message_text=>unistr('\8EF8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103767405377308221)
,p_name=>'WWV_RENDER_CHART2.T_FIRST'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\521D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103767520070308221)
,p_name=>'WWV_RENDER_CHART2.T_GO'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9F\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103767327070308221)
,p_name=>'WWV_RENDER_CHART2.T_LAST'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103767113913308221)
,p_name=>'WWV_RENDER_CHART2.T_MAXIMUM'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5927')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103767254866308221)
,p_name=>'WWV_RENDER_CHART2.T_MINIMUM'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103766783155308221)
,p_name=>'WWV_RENDER_CHART2.T_ROWS'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103767063105308221)
,p_name=>'WWV_RENDER_CHART2.T_SUM'
,p_message_language=>'ja'
,p_message_text=>unistr('\5408\8A08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103702461279308169)
,p_name=>'WWV_RENDER_REPORT3.CURSOR_NOT_OPEN'
,p_message_language=>'ja'
,p_message_text=>unistr('\554F\5408\305B\3092\89E3\6790\3067\304D\307E\305B\3093\3002\30AB\30FC\30BD\30EB\304C\30AA\30FC\30D7\30F3\3055\308C\3066\3044\306A\3044\304B\3001\307E\305F\306FSQL\554F\5408\305B\3092\623B\3059\30D5\30A1\30F3\30AF\30B7\30E7\30F3\304C\5024\306A\3057\3067\623B\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104062933422308486)
,p_name=>'WWV_RENDER_REPORT3.DUBLICATE_ALIAS_NAMES'
,p_message_language=>'ja'
,p_message_text=>unistr('\554F\5408\305B\306B\306F\3001\91CD\8907\3059\308B\5225\540D\304C\542B\307E\308C\3066\3044\307E\3059\3002\30EC\30DD\30FC\30C8\3067\4F7F\7528\3059\308B\554F\5408\305B\306B\306F\3001\4E00\610F\306E\5225\540D\304C\5FC5\8981\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103694531739308162)
,p_name=>'WWV_RENDER_REPORT3.ERR_PROC_FUNCTION_BODY'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\554F\5408\305B\3092\623B\3059\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\51E6\7406\3067\304D\307E\305B\3093\3002'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103780438680308232)
,p_name=>'WWV_RENDER_REPORT3.INVALID_COL_NUM'
,p_message_language=>'ja'
,p_message_text=>unistr('\554F\5408\305B\306B\5B9A\7FA9\3055\308C\305F\5217\306E\6570\304C\7121\52B9\3067\3059\3002\3053\306E\30EA\30FC\30B8\30E7\30F3\30FB\30BF\30A4\30D7\306B\306F%0\5217\304C\5FC5\8981\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103702587697308169)
,p_name=>'WWV_RENDER_REPORT3.QUERY_CANNOT_BE_PARSED'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('SQL\554F\5408\305B\3092\623B\3059\30D5\30A1\30F3\30AF\30B7\30E7\30F3: \554F\5408\305B\3092\30D3\30EB\30C0\30FC\5185\3067\89E3\6790\3067\304D\307E\305B\3093\3002\554F\5408\305B\306E\69CB\6587\304C\6B63\3057\3044\5834\5408\306F\3001\30EA\30FC\30B8\30E7\30F3\30FB\30BD\30FC\30B9\306E\4E0B\306E\300C<strong>\6C4E\7528\5217</strong>\300D\30C1\30A7\30C3\30AF\30DC\30C3\30AF\30B9\3092\9078\629E\3057\3066\3001\89E3\6790\3057\306A\3044\3067\7D9A\884C\3057\3066\304F\3060\3055\3044\3002'),
'<br/>',
'(%0)'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103702602083308169)
,p_name=>'WWV_RENDER_REPORT3.SYNTAX_ERROR2'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\554F\5408\305B\3092\30D3\30EB\30C0\30FC\5185\3067\89E3\6790\3067\304D\307E\305B\3093\3002\554F\5408\305B\306E\69CB\6587\304C\6B63\3057\3044\5834\5408\306F\3001\30EA\30FC\30B8\30E7\30F3\30FB\30BD\30FC\30B9\306E\4E0B\306E\300C\6C4E\7528\5217\300D\30C1\30A7\30C3\30AF\30DC\30C3\30AF\30B9\3092\9078\629E\3057\3066\3001\89E3\6790\3057\306A\3044\3067\7D9A\884C\3057\3066\304F\3060\3055\3044\3002'),
'%0</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103778950806308230)
,p_name=>'WWV_SPELING.ADD_WORD'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A9E\53E5\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103779540527308231)
,p_name=>'WWV_SPELING.BUTTON_ADD_TO_DICTIONARY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30A3\30AF\30B7\30E7\30CA\30EA\306B\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103779404599308231)
,p_name=>'WWV_SPELING.BUTTON_APPLY_CHANGES'
,p_message_language=>'ja'
,p_message_text=>unistr('\5909\66F4\306E\9069\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103779360569308231)
,p_name=>'WWV_SPELING.BUTTON_CANCEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\53D6\6D88')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103779237757308231)
,p_name=>'WWV_SPELING.BUTTON_DONE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B8C\4E86')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104138137614308548)
,p_name=>'WWV_SPELING.BUTTON_SUBMIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\9001\4FE1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103779127225308231)
,p_name=>'WWV_SPELING.DUP_WORD_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\3059\3067\306B\30C7\30A3\30AF\30B7\30E7\30CA\30EA\306B\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103779748107308231)
,p_name=>'WWV_SPELING.ENTER_NEW_WORD'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F\8A9E\53E5\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103779614142308231)
,p_name=>'WWV_SPELING.PICK_A_WORD'
,p_message_language=>'ja'
,p_message_text=>unistr('1\8A9E\306E\9078\629E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103997379071308433)
,p_name=>'WWV_SPELING.SPELL_CHECKER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30DA\30EB\30FB\30C1\30A7\30C3\30AF\6A5F\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103779069155308231)
,p_name=>'WWV_SPELING.WORD_ADDED'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\3092\30C7\30A3\30AF\30B7\30E7\30CA\30EA\306B\8FFD\52A0\3057\307E\3057\305F\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103624371046308105)
,p_name=>'XML_LOAD_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('XML\30ED\30FC\30C9\30FB\30A8\30E9\30FC')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104049299676308474)
,p_name=>'X_ADDITIONAL_TAGS_EXIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\8FFD\52A0\306E%0\30BF\30B0\304C\5B58\5728\3057\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104050007302308475)
,p_name=>'X_BUGS_HAVE_NO_FIX_DATES'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\30D0\30B0\306B\65E5\4ED8\5225\306E\4FEE\6B63\304C\3042\308A\307E\305B\3093')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(104224037426308627)
,p_name=>'YEARLY'
,p_message_language=>'ja'
,p_message_text=>unistr('\5E74')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103677715032308149)
,p_name=>'YES_BY_USER'
,p_message_language=>'ja'
,p_message_text=>unistr('\306F\3044(\30E6\30FC\30B6\30FC\5225)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103706833202308173)
,p_name=>'YOUR_EMAIL_IUWS'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9\306F\3001\6B21\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306E\30E6\30FC\30B6\30FC\306B\767B\9332\3055\308C\3066\3044\307E\3059:')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(103988289066308426)
,p_name=>'YOU_ARE_NOW_LOGGED_OUT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30B0\30A2\30A6\30C8\3057\307E\3057\305F\3002')
);
null;
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/security/authentications/no_auth
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(91645213681389498.442)
,p_name=>'no auth'
,p_scheme_type=>'NATIVE_DAD'
,p_attribute_15=>'91645213681389498'
,p_invalid_session_type=>'LOGIN'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
,p_comments=>'Based on authentication scheme from gallery:No Authentication (using DAD)'
);
end;
/
prompt --application/shared_components/plugins/region_type/breadcrumb
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3708767719669.442)
,p_plugin_type=>'REGION TYPE'
,p_name=>'BREADCRUMB'
,p_display_name=>unistr('\30D6\30EC\30C3\30C9\30AF\30E9\30E0')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','BREADCRUMB'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8\306E\30D6\30EC\30C3\30C9\30AF\30E9\30E0\3092\8868\793A\3057\307E\3059\3002')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/region_type/list
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3709973247475.442)
,p_plugin_type=>'REGION TYPE'
,p_name=>'LIST'
,p_display_name=>unistr('\30EA\30B9\30C8')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','LIST'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\9759\7684\307E\305F\306F\52D5\7684\30EA\30B9\30C8\306B\57FA\3065\3044\3066\5024\3092\8868\793A\3057\307E\3059\3002\901A\5E38\3053\308C\3089\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5185\306E\30DA\30FC\30B8\3078\306E\30CA\30D3\30B2\30FC\30B7\30E7\30F3\306B\4F7F\7528\3055\308C\307E\3059\3002')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/dialog_cancel
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3734497742532.442)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'DIALOG_CANCEL'
,p_display_name=>unistr('\30C0\30A4\30A2\30ED\30B0\3092\53D6\308A\6D88\3059')
,p_category=>'NAVIGATION'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','DIALOG_CANCEL'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\73FE\5728\306E\30C0\30A4\30A2\30ED\30B0\30FB\30DA\30FC\30B8\3092\53D6\308A\6D88\3057\307E\3059\3002')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/dialog_close
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3734500756040.442)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'DIALOG_CLOSE'
,p_display_name=>unistr('\30C0\30A4\30A2\30ED\30B0\3092\9589\3058\308B')
,p_category=>'NAVIGATION'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','DIALOG_CLOSE'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\73FE\5728\306E\30C0\30A4\30A2\30ED\30B0\30FB\30DA\30FC\30B8\3092\9589\3058\307E\3059\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3788410042953.442)
,p_plugin_id=>wwv_flow_api.id(3734500756040.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\623B\3059\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30C0\30A4\30A2\30ED\30B0\306B\3088\3063\3066\8FD4\3055\308C\308B1\3064\4EE5\4E0A\306E\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306E\540D\524D\3092\5165\529B\3057\307E\3059\3002\8907\6570\306E\30A2\30A4\30C6\30E0\306E\5834\5408\3001\5404\30A2\30A4\30C6\30E0\540D\3092\30AB\30F3\30DE\3067\533A\5207\308A\307E\3059\3002</p>'),
unistr('<p><strong>\300C\30C0\30A4\30A2\30ED\30B0\306E\623B\308A\30A2\30A4\30C6\30E0\300D</strong>\306E<em>\300C\5024\306E\8A2D\5B9A\300D</em>\304A\3088\3073<strong>\300C\30BF\30A4\30D7\306E\8A2D\5B9A\300D</strong>\306E\30A2\30AF\30B7\30E7\30F3\3068\3068\3082\306B\3001\30C0\30A4\30A2\30ED\30B0\3092\958B\304F\8981\7D20\306E<strong>\300C\30C0\30A4\30A2\30ED\30B0\306E\30AF\30ED\30FC\30BA\300D</strong>\30A4\30D9\30F3\30C8\3067\8D77\52D5\3059\308B\52D5\7684\30A2\30AF\30B7\30E7\30F3\3092\5B9A\7FA9\3057\3066\3001\623B\3055\308C\305F\30A2\30A4\30C6\30E0\5024\306B\30A2\30AF\30BB\30B9\3067\304D\307E\3059\3002</p>')))
);
end;
/
prompt --application/shared_components/plugins/region_type/display_selector
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3782395890396.442)
,p_plugin_type=>'REGION TYPE'
,p_name=>'DISPLAY_SELECTOR'
,p_display_name=>unistr('\30EA\30FC\30B8\30E7\30F3\8868\793A\30BB\30EC\30AF\30BF')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','DISPLAY_SELECTOR'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\6A2A\306E\30EA\30B9\30C8\306B\30EA\30FC\30B8\30E7\30F3\540D\3092\8868\793A\3057\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C1\3064\306E\30EA\30FC\30B8\30E7\30F3\3092\9078\629E\3057\3066\8868\793A\3057\3001\4ED6\306E\30EA\30FC\30B8\30E7\30F3\3092\975E\8868\793A\306B\3067\304D\308B\3088\3046\306B\3057\307E\3059\3002<em>\300C\30EA\30FC\30B8\30E7\30F3\8868\793A\30BB\30EC\30AF\30BF\300D</em>\304C<strong>\300C\306F\3044\300D</strong>\306B\8A2D\5B9A\3055\308C\3066\3044\308B\30DA\30FC\30B8\30FB\30EA\30FC\30B8\30E7\30F3\306E\307F\304C\3001\3053\306E\30EA\30FC\30B8\30E7\30F3\306B\8868\793A\3055\308C\307E\3059\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1764737380560506621.442)
,p_plugin_id=>wwv_flow_api.id(3782395890396.442)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\30B9\30E9\30A4\30C0\3092\542B\3081\308B')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\8868\793A\3055\308C\308B\30EA\30FC\30B8\30E7\30F3\540D\304C\30EA\30FC\30B8\30E7\30F3\306E\5E45\3092\8D85\3048\3066\3044\308B\5834\5408\306B\3001\30EA\30FC\30B8\30E7\30F3\306B\30B9\30E9\30A4\30C0\3092\52D5\7684\306B\8FFD\52A0\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1763653631955156043.442)
,p_plugin_id=>wwv_flow_api.id(3782395890396.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\30E2\30FC\30C9')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STANDARD'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<em>\300C\30EA\30FC\30B8\30E7\30F3\8868\793A\30BB\30EC\30AF\30BF\300D</em>\304C<strong>\300C\306F\3044\300D</strong>\306B\8A2D\5B9A\3055\308C\3066\3044\308B\30EA\30FC\30B8\30E7\30F3\306E\30DA\30FC\30B8\4E0A\3067\306E\8868\793A\65B9\6CD5\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1763654080157157624.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1763653631955156043.442)
,p_display_sequence=>10
,p_display_value=>unistr('\5358\4E00\30EA\30FC\30B8\30E7\30F3\306E\8868\793A')
,p_return_value=>'STANDARD'
,p_help_text=>unistr('\30EA\30FC\30B8\30E7\30F3\3092\30BF\30D6\3068\3057\3066\8868\793A\3057\307E\3059\3002\30BF\30D6\3092\9078\629E\3059\308B\3068\3001\5BFE\5FDC\3059\308B\30EA\30FC\30B8\30E7\30F3\304C\8868\793A\3055\308C\3001\4ED6\306E\9078\629E\9805\76EE\304C\975E\8868\793A\306B\306A\308A\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1763654509981158498.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1763653631955156043.442)
,p_display_sequence=>20
,p_display_value=>unistr('\30B9\30AF\30ED\30FC\30EB\30FB\30A6\30A3\30F3\30C9\30A6')
,p_return_value=>'JUMP'
,p_help_text=>unistr('\5E38\306B\3059\3079\3066\306E\30EA\30FC\30B8\30E7\30F3\3092\30DA\30FC\30B8\306B\8868\793A\3057\307E\3059\3002\30BF\30D6\3092\9078\629E\3059\308B\3068\3001\30A6\30A3\30F3\30C9\30A6\304C\5BFE\5FDC\3059\308B\30EA\30FC\30B8\30E7\30F3\307E\3067\30B9\30AF\30ED\30FC\30EB\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1763973139934187732.442)
,p_plugin_id=>wwv_flow_api.id(3782395890396.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\300C\3059\3079\3066\8868\793A\300D\3092\542B\3081\308B')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1763653631955156043.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STANDARD'
,p_help_text=>unistr('\9078\629E\3057\305F\5834\5408\306B\3059\3079\3066\306E\30EA\30FC\30B8\30E7\30F3\3092\30DA\30FC\30B8\306B\8868\793A\3059\308B\3001\300C\3059\3079\3066\8868\793A\300D\30BF\30D6\3092\4ED8\52A0\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1763975939882192484.442)
,p_plugin_id=>wwv_flow_api.id(3782395890396.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\524D\56DE\306E\9078\629E\3092\8A18\61B6\3059\308B')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\30DA\30FC\30B8\3092\30ED\30FC\30C9\3059\308B\3068\3001\524D\56DE\9078\629E\3057\305F\30EA\30FC\30B8\30E7\30F3\304C\8868\793A\3055\308C\307E\3059\3002')
);
end;
/
prompt --application/shared_components/plugins/region_type/url
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3783484270249.442)
,p_plugin_type=>'REGION TYPE'
,p_name=>'URL'
,p_display_name=>'URL'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','URL'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('URL\3092\30BD\30FC\30B9\3068\3059\308B\30EA\30E2\30FC\30C8\30FB\30B3\30F3\30C6\30F3\30C4\3092\8868\793A\3057\307E\3059\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3783486275401.442)
,p_plugin_id=>wwv_flow_api.id(3783484270249.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>80
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('\30EA\30E2\30FC\30C8\30FB\30B3\30F3\30C6\30F3\30C4\306EURL\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3783489372727.442)
,p_plugin_id=>wwv_flow_api.id(3783484270249.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\7D44\5165\308C\30E2\30FC\30C9')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'IFRAME'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('URL\306E\30EA\30E2\30FC\30C8\30FB\30B3\30F3\30C6\30F3\30C4\3092\30DA\30FC\30B8\306B\3069\306E\3088\3046\306B\542B\3081\308B\304B\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3783492373852.442)
,p_plugin_attribute_id=>wwv_flow_api.id(3783489372727.442)
,p_display_sequence=>10
,p_display_value=>'IFrame'
,p_return_value=>'IFRAME'
,p_help_text=>unistr('\30EA\30E2\30FC\30C8\30FB\30B3\30F3\30C6\30F3\30C4\3092iframe\3068\3057\3066\57CB\3081\8FBC\307F\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3783496377152.442)
,p_plugin_attribute_id=>wwv_flow_api.id(3783489372727.442)
,p_display_sequence=>20
,p_display_value=>unistr('\30A4\30F3\30E9\30A4\30F3(\7279\6B8A\6587\5B57\3092\30A8\30B9\30B1\30FC\30D7)')
,p_return_value=>'ESC_INLINE'
,p_help_text=>unistr('\30DA\30FC\30B8\306E\30EC\30F3\30C0\30EA\30F3\30B0\6642\306B\30EA\30E2\30FC\30C8\30FB\30B3\30F3\30C6\30F3\30C4\3092\8AAD\307F\53D6\3063\3066\57CB\3081\8FBC\307F\307E\3059\304C\3001HTML\7279\6B8A\6587\5B57\3092\30A8\30B9\30B1\30FC\30D7\3057\3066\30AF\30ED\30B9\30B5\30A4\30C8\30B9\30AF\30EA\30D7\30C6\30A3\30F3\30B0\3092\9632\6B62\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3783504380866.442)
,p_plugin_attribute_id=>wwv_flow_api.id(3783489372727.442)
,p_display_sequence=>30
,p_display_value=>unistr('\30A4\30F3\30E9\30A4\30F3(\30A8\30B9\30B1\30FC\30D7\306A\3057)')
,p_return_value=>'NOESC_INLINE'
,p_help_text=>unistr('\30DA\30FC\30B8\306E\30EC\30F3\30C0\30EA\30F3\30B0\6642\306B\30EA\30E2\30FC\30C8\30FB\30B3\30F3\30C6\30F3\30C4\3092\8AAD\307F\53D6\3063\3066\57CB\3081\8FBC\307F\307E\3059\3002HTML\30A8\30B9\30B1\30FC\30D7\304C\884C\308F\308C\306A\3044\305F\3081\3001\30EA\30E2\30FC\30C8\30FB\30B3\30F3\30C6\30F3\30C4\304C\5B8C\5168\306B\4FE1\983C\3067\304D\308B\5834\5408\306B\306E\307F\3053\306E\30AA\30D7\30B7\30E7\30F3\3092\9078\629E\3057\307E\3059\3002\3053\308C\306B\3088\3063\3066\3001\30EA\30FC\30B8\30E7\30F3\304C\30AF\30ED\30B9\30B5\30A4\30C8\30FB\30B9\30AF\30EA\30D7\30C6\30A3\30F3\30B0\653B\6483\3092\53D7\3051\3084\3059\304F\306A\308B\53EF\80FD\6027\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3783511409602.442)
,p_plugin_id=>wwv_flow_api.id(3783484270249.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('IFrame\5C5E\6027')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>80
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3783489372727.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'IFRAME'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'width="300" height="300"',
'</pre>'))
,p_help_text=>unistr('iframe\30BF\30B0\306E\8FFD\52A0HTML\8981\7D20\5C5E\6027\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3783517424673.442)
,p_plugin_id=>wwv_flow_api.id(3783484270249.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('HTML\7834\68C4\306E\7D42\4E86')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3783489372727.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ESC_INLINE,NOESC_INLINE'
,p_help_text=>unistr('\3088\308A\5927\304D\3044\30C9\30AD\30E5\30E1\30F3\30C8\304B\3089HTML\306E\30BB\30AF\30B7\30E7\30F3\3092\30AF\30EA\30C3\30D7\3059\308B\5834\5408\306B\3053\306E\5C5E\6027\3092\4F7F\7528\3057\307E\3059\3002\30BF\30FC\30B2\30C3\30C8\3068\306A\308B\30BB\30AF\30B7\30E7\30F3\306E\5148\982D\3001\307E\305F\306FHTML\306E\5EC3\68C4\306E\7D42\4E86\30DD\30A4\30F3\30C8\3092\8B58\5225\3059\308B\6587\5B57\5217\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3783520428341.442)
,p_plugin_id=>wwv_flow_api.id(3783484270249.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('HTML\7834\68C4\306E\958B\59CB')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3783489372727.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ESC_INLINE,NOESC_INLINE'
,p_help_text=>unistr('\3088\308A\5927\304D\3044HTML\30C9\30AD\30E5\30E1\30F3\30C8\304B\3089HTML\306E\30BB\30AF\30B7\30E7\30F3\3092\30AF\30EA\30C3\30D7\3059\308B\5834\5408\306B\3053\306E\5C5E\6027\3092\4F7F\7528\3057\307E\3059\3002\30BF\30FC\30B2\30C3\30C8\3068\306A\308B\30BB\30AF\30B7\30E7\30F3\306E\6700\5F8C\3001\307E\305F\306F\6B8B\308A\306EHTML\306E\5EC3\68C4\306E\958B\59CB\30DD\30A4\30F3\30C8\3092\8B58\5225\3059\308B\6587\5B57\5217\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002\30BF\30FC\30B2\30C3\30C8\3068\306A\308B\30BB\30AF\30B7\30E7\30F3\306E\6700\5F8C\3092\8B58\5225\3059\308B\3053\306E\6587\5B57\5217\306F\3001\8FD4\3055\308C\308B\30C6\30AD\30B9\30C8\306B\306F\542B\307E\308C\307E\305B\3093\3002')
);
end;
/
prompt --application/shared_components/plugins/region_type/help_text
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3783523603076.442)
,p_plugin_type=>'REGION TYPE'
,p_name=>'HELP_TEXT'
,p_display_name=>unistr('\30D8\30EB\30D7\30FB\30C6\30AD\30B9\30C8')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','HELP_TEXT'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\5C02\7528\306E\30D8\30EB\30D7\30FB\30DA\30FC\30B8\3067\4F7F\7528\3055\308C\308B\7279\5225\306A\30D8\30EB\30D7\30FB\30EA\30FC\30B8\30E7\30F3\3092\8868\793A\3057\307E\3059\3002')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/region_type/faceted_search
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1370261776191667.442)
,p_plugin_type=>'REGION TYPE'
,p_name=>'FACETED_SEARCH'
,p_display_name=>unistr('\30D5\30A1\30BB\30C3\30C8\691C\7D22')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','FACETED_SEARCH'),'')
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('<p>\95A2\9023\3059\308B\30D5\30A1\30BB\30C3\30C8\691C\7D22\306E\30BD\30FC\30B9\306B\57FA\3065\304F\30EA\30FC\30B8\30E7\30F3\3067\3001\5B9F\884C\6642\306B\691C\7D22\7D50\679C\3092\7D5E\308A\8FBC\3080\305F\3081\306B\4F7F\7528\3055\308C\308B\591A\6570\306E\30D5\30A1\30BB\30C3\30C8\3092\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\63D0\4F9B\3057\307E\3059\3002</p>')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1370473361191712.442)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\30D0\30C3\30C1\30FB\30D5\30A1\30BB\30C3\30C8\5909\66F4')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('\30D5\30A1\30BB\30C3\30C8\691C\7D22\30EC\30DD\30FC\30C8\3067\3001\9078\629E\3057\305F\30D5\30A1\30BB\30C3\30C8\3092\30D0\30C3\30C1\9069\7528\3059\308B\304B\3001\500B\5225\306B\9069\7528\3059\308B\304B\3092\9078\629E\3057\307E\3059\3002\300C\306F\3044\300D\306E\5834\5408\3001\30EC\30DD\30FC\30C8\306E\30D5\30A3\30EB\30BF\306F\3001\300C\9069\7528\300D\30DC\30BF\30F3\304C\30AF\30EA\30C3\30AF\3055\308C\305F\3068\304D\306B\5B9F\884C\3055\308C\307E\3059\3002\300C\3044\3044\3048\300D\306E\5834\5408\3001\30EC\30DD\30FC\30C8\306E\30D5\30A3\30EB\30BF\306F\3001\3044\305A\308C\304B\306E\30D5\30A1\30BB\30C3\30C8\5024\304C\5909\66F4\3055\308C\308B\3068\3059\3050\306B\5B9F\884C\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2517816294852101.442)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\73FE\5728\306E\30D5\30A1\30BB\30C3\30C8\306E\8868\793A')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'N'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\73FE\5728\306E\30D5\30A1\30BB\30C3\30C8\9818\57DF\3092\8868\793A\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002\73FE\5728\306E\30D5\30A1\30BB\30C3\30C8\9818\57DF\306B\306F\3001\73FE\5728\9078\629E\3055\308C\3066\3044\308B\30D5\30A1\30BB\30C3\30C8\304C\30EA\30B9\30C8\3055\308C\3001\305D\308C\3089\3092\500B\5225\306B\3001\307E\305F\306F\4E00\5EA6\306B\524A\9664\3059\308B\7C21\5358\306A\65B9\6CD5\304C\63D0\4F9B\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2518140718854747.442)
,p_plugin_attribute_id=>wwv_flow_api.id(2517816294852101.442)
,p_display_sequence=>10
,p_display_value=>unistr('\306F\3044')
,p_return_value=>'Y'
,p_help_text=>unistr('\73FE\5728\306E\30D5\30A1\30BB\30C3\30C8\306E\30EA\30B9\30C8\304C\3001\30D5\30A1\30BB\30C3\30C8\691C\7D22\30EA\30FC\30B8\30E7\30F3\306E\4E00\756A\4E0A\306B\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2518542510858430.442)
,p_plugin_attribute_id=>wwv_flow_api.id(2517816294852101.442)
,p_display_sequence=>20
,p_display_value=>unistr('\3044\3044\3048')
,p_return_value=>'N'
,p_help_text=>unistr('\73FE\5728\306E\30D5\30A1\30BB\30C3\30C8\306E\30EA\30B9\30C8\306F\8868\793A\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2518915492864304.442)
,p_plugin_attribute_id=>wwv_flow_api.id(2517816294852101.442)
,p_display_sequence=>30
,p_display_value=>unistr('\30BB\30EC\30AF\30BF')
,p_return_value=>'E'
,p_help_text=>unistr('\73FE\5728\306E\30D5\30A1\30BB\30C3\30C8\9818\57DF\304C\3001\3053\306E\30BB\30EC\30AF\30BF\3067\6307\5B9A\3055\308C\305F\8981\7D20\5185\306B\8868\793A\3055\308C\307E\3059\3002\3053\308C\306B\3088\308A\3001\73FE\5728\306E\30D5\30A1\30BB\30C3\30C8\9818\57DF\3092\30DA\30FC\30B8\4E0A\306E\4EFB\610F\306E\5834\6240\306B\914D\7F6E\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(728482701453610313.442)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\73FE\5728\306E\30D5\30A1\30BB\30C3\30C8\30FB\30BB\30EC\30AF\30BF')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>40
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2517816294852101.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'E'
,p_examples=>'#currentFacetsArea'
,p_help_text=>unistr('\3053\308C\306F\3001\30D5\30A1\30BB\30C3\30C8\691C\7D22\30EA\30FC\30B8\30E7\30F3\304C\73FE\5728\306E\30D5\30A1\30BB\30C3\30C8\3092\8868\793A\3059\308B\30DA\30FC\30B8\4E0A\306E\8981\7D20\306E\30BB\30EC\30AF\30BF\3067\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1501356115247921.442)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\7DCF\884C\6570\306E\8868\793A')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\5408\8A08\884C\6570\306E\8868\793A\5834\6240\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1501661440256814.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1501356115247921.442)
,p_display_sequence=>10
,p_display_value=>unistr('\3044\3044\3048')
,p_return_value=>'N'
,p_help_text=>unistr('\7DCF\884C\6570\306F\8868\793A\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1502011338258911.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1501356115247921.442)
,p_display_sequence=>20
,p_display_value=>unistr('\306F\3044')
,p_return_value=>'Y'
,p_help_text=>unistr('\7DCF\884C\6570\306F\3001\73FE\5728\306E\30D5\30A1\30BB\30C3\30C8\9818\57DF\306E\4E00\756A\4E0A\306B\8868\793A\3055\308C\308B\304B\3001\300C\73FE\5728\306E\30D5\30A1\30BB\30C3\30C8\306E\8868\793A\300D\304C\300C\3044\3044\3048\300D\306E\5834\5408\306F\30D5\30A1\30BB\30C3\30C8\691C\7D22\30EA\30FC\30B8\30E7\30F3\306E\4E00\756A\4E0A\306B\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1502458150261854.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1501356115247921.442)
,p_display_sequence=>30
,p_display_value=>unistr('\30BB\30EC\30AF\30BF')
,p_return_value=>'E'
,p_help_text=>unistr('\7DCF\884C\6570(\30E9\30D9\30EB\306A\3057)\304C\3001\3053\306E\30BB\30EC\30AF\30BF\3067\6307\5B9A\3055\308C\305F\8981\7D20\5185\306B\8868\793A\3055\308C\307E\3059\3002\3053\308C\306B\3088\308A\3001\7DCF\884C\6570\3092\30DA\30FC\30B8\4E0A\306E\307B\307C\4EFB\610F\306E\5834\6240\306B\914D\7F6E\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1503042014268412.442)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('\7DCF\884C\6570\30E9\30D9\30EB')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1501356115247921.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('\7DCF\884C\6570\306B\4F7F\7528\3059\308B\30E9\30D9\30EB\3002\3053\3053\3067\30E9\30D9\30EB\304C\6307\5B9A\3055\308C\3066\3044\306A\3044\5834\5408\3001APEX\306FAPEX.FS.TOTAL_ROW_COUNT_LABEL\30C6\30AD\30B9\30C8\30FB\30E1\30C3\30BB\30FC\30B8\3092\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1503328055272516.442)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>unistr('\5408\8A08\884C\6570\30BB\30EC\30AF\30BF')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1501356115247921.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'E'
,p_examples=>'#totalRowCountSpan'
,p_help_text=>unistr('\3053\308C\306F\3001\30D5\30A1\30BB\30C3\30C8\691C\7D22\30EA\30FC\30B8\30E7\30F3\304C\7DCF\884C\6570\3092\8868\793A\3059\308B\30DA\30FC\30B8\4E0A\306E\8981\7D20\306E\30BB\30EC\30AF\30BF\3067\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(556135859462274866.442)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>20
,p_prompt=>unistr('\30B3\30F3\30D1\30AF\30C8\306A\6570\5024\306E\3057\304D\3044\5024')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_default_value=>'10000'
,p_display_length=>10
,p_max_length=>10
,p_is_translatable=>false
,p_help_text=>unistr('\4E0A\9650\3092\8D85\3048\305F\5834\5408\306B\3001\30B3\30F3\30D1\30AF\30C8\306A\6570\5024\5F62\5F0F\3067\30D5\30A1\30BB\30C3\30C8\6570\3092\8868\793A\3059\308B\3057\304D\3044\5024\3092\6307\5B9A\3057\307E\3059\3002\30B3\30F3\30D1\30AF\30C8\306A\6570\5024\5F62\5F0F\3067\306F\3001<strong>1,234</strong>\3068\3044\3046\5024\306F\3001<strong>1K</strong>\3068\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2600957382075036.442)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_prompt=>unistr('\30C1\30E3\30FC\30C8\306E\8868\793A')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'Y'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\30D5\30A1\30BB\30C3\30C8\5024\30C1\30E3\30FC\30C8\306E\8868\793A\5834\6240\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2601268677075657.442)
,p_plugin_attribute_id=>wwv_flow_api.id(2600957382075036.442)
,p_display_sequence=>10
,p_display_value=>unistr('\30C0\30A4\30A2\30ED\30B0')
,p_return_value=>'Y'
,p_help_text=>unistr('\30D5\30A1\30BB\30C3\30C8\5024\30C1\30E3\30FC\30C8\306F\975E\30E2\30FC\30C0\30EB\30FB\30C0\30A4\30A2\30ED\30B0\306B\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2601607534076237.442)
,p_plugin_attribute_id=>wwv_flow_api.id(2600957382075036.442)
,p_display_sequence=>20
,p_display_value=>unistr('\3044\3044\3048')
,p_return_value=>'N'
,p_help_text=>unistr('\30D5\30A1\30BB\30C3\30C8\5024\30C1\30E3\30FC\30C8\3092\8868\793A\3059\308B\30E6\30FC\30B6\30FC\7528\306E\30DC\30BF\30F3\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2602011048076805.442)
,p_plugin_attribute_id=>wwv_flow_api.id(2600957382075036.442)
,p_display_sequence=>30
,p_display_value=>unistr('\30BB\30EC\30AF\30BF')
,p_return_value=>'E'
,p_help_text=>unistr('\30D5\30A1\30BB\30C3\30C8\5024\30C1\30E3\30FC\30C8\304C\3001\3053\306E\30BB\30EC\30AF\30BF\3067\6307\5B9A\3055\308C\305F\8981\7D20\306B\8FFD\52A0\3055\308C\307E\3059\3002\3053\308C\306B\3088\308A\3001\30C1\30E3\30FC\30C8\3092\30DA\30FC\30B8\4E0A\306E\307B\307C\4EFB\610F\306E\5834\6240\306B\914D\7F6E\3057\3066\3001\30D5\30A1\30BB\30C3\30C8\5024\30C1\30E3\30FC\30C8\30FB\30C0\30C3\30B7\30E5\30DC\30FC\30C9\3092\4F5C\6210\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2602471299081559.442)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>unistr('\30C1\30E3\30FC\30C8\30FB\30BB\30EC\30AF\30BF')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2600957382075036.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'E'
,p_help_text=>unistr('\3053\308C\306F\3001\30D5\30A1\30BB\30C3\30C8\691C\7D22\30EA\30FC\30B8\30E7\30F3\304C\30D5\30A1\30BB\30C3\30C8\30FB\30C1\30E3\30FC\30C8\3092\8868\793A\3059\308B\30DA\30FC\30B8\4E0A\306E\8981\7D20\306E\30BB\30EC\30AF\30BF\3067\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3900223688176537.442)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>unistr('\30C8\30C3\30D7N\306E\5024\306E\30C1\30E3\30FC\30C8\3092\8868\793A')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'10'
,p_display_length=>3
,p_max_length=>3
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2600957382075036.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'Y,E'
,p_help_text=>unistr('\5404\30D5\30A1\30BB\30C3\30C8\306E\30C1\30E3\30FC\30C8\306B\8868\793A\3059\308B\5024\306E\6570\3092\6307\5B9A\3057\307E\3059\3002<strong>10</strong>\306E\5024\306F\3001\30D5\30A1\30BB\30C3\30C8\306E\4E0B\306E\9806\5E8F\3067<em>\6700\521D\306E10</em>\30A2\30A4\30C6\30E0\304C\30D5\30A1\30BB\30C3\30C8\30FB\30C1\30E3\30FC\30C8\306B\8868\793A\3055\308C\308B\3053\3068\3092\610F\5473\3057\307E\3059\3002\30D5\30A1\30BB\30C3\30C8\30FB\30D7\30ED\30D1\30C6\30A3\306E\300C\4E0A\4F4D\4EF6\6570\3067\30BD\30FC\30C8\300D\304C\30AA\30F3\306E\5834\5408\3001\3053\308C\306F\767A\751F\6570\306B\57FA\3065\304F<em>\30C8\30C3\30D710</em>\30A2\30A4\30C6\30E0\3067\3059\3002\3053\306E\30D7\30ED\30D1\30C6\30A3\306B\5BFE\3059\308B\5909\66F4\306F\3001\73FE\5728\30A2\30AF\30C6\30A3\30D6\306A\30D6\30E9\30A6\30B6\30FB\30BB\30C3\30B7\30E7\30F3\3067\3059\3050\306B\306F\8868\793A\3055\308C\306A\3044\53EF\80FD\6027\304C\3042\308A\307E\3059\3002\3053\306E\5024\3068\3001\5186\30B0\30E9\30D5\307E\305F\306F\68D2\30B0\30E9\30D5\306E\30E6\30FC\30B6\30FC\306E\9078\629E\306F\3001\30D6\30E9\30A6\30B6\30FB\30BB\30C3')
||unistr('\30B7\30E7\30F3\306B\4FDD\5B58\3055\308C\307E\3059\3002\3053\306E\30D7\30ED\30D1\30C6\30A3\306B\5BFE\3059\308B\5909\66F4\306E\52B9\679C\3092\78BA\8A8D\3059\308B\306B\306F\3001\30A6\30A3\30B6\30FC\30C9\3067\751F\6210\3055\308C\305F\300C\30EA\30BB\30C3\30C8\300D\30DC\30BF\30F3\306A\3069\3001\300C\30EA\30FC\30B8\30E7\30F3\306E\30EA\30BB\30C3\30C8\300D\30AD\30E3\30C3\30B7\30E5\5236\5FA1\30AA\30D7\30B7\30E7\30F3\306E\30EA\30F3\30AF\3092\4F7F\7528\3057\3066\30EC\30DD\30FC\30C8\3092\30EA\30BB\30C3\30C8\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(603063046957961274.442)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.442)
,p_name=>'facetsafterremovechart'
,p_display_name=>unistr('\30C1\30E3\30FC\30C8\306E\524A\9664\5F8C')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(603062764743961271.442)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.442)
,p_name=>'facetsbeforeaddchart'
,p_display_name=>unistr('\30C1\30E3\30FC\30C8\306E\8FFD\52A0\524D')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(1372274287191736.442)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.442)
,p_name=>'facetschange'
,p_display_name=>unistr('\30D5\30A1\30BB\30C3\30C8\5909\66F4')
);
end;
/
prompt --application/shared_components/plugins/authentication_type/saml
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1381216513007333.442)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'SAML'
,p_display_name=>unistr('SAML\30B5\30A4\30F3\30A4\30F3')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','SAML'),'')
,p_api_version=>2
,p_standard_attributes=>'INVALID_SESSION'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007334.442)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>70
,p_prompt=>unistr('\7F72\540D\30EA\30AF\30A8\30B9\30C8\306E\8CC7\683C\8A3C\660E\30B9\30C8\30A2')
,p_attribute_type=>'CREDENTIAL ID'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1381216513007335.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30A2\30A4\30C7\30F3\30C6\30A3\30C6\30A3\30FB\30D7\30ED\30D0\30A4\30C0\306B\5BFE\3059\308B\30E1\30C3\30BB\30FC\30B8\3078\306E\7F72\540D\306B\4F7F\7528\3055\308C\308B\516C\958B\8A3C\660E\66F8\304A\3088\3073\79D8\5BC6\30AD\30FC\304C\683C\7D0D\3055\308C\305F\8CC7\683C\8A3C\660E\30B9\30C8\30A2\3092\9078\629E\3057\307E\3059\3002'),
unistr('\30A2\30A4\30C7\30F3\30C6\30A3\30C6\30A3\30FB\30D7\30ED\30D0\30A4\30C0\3067\8A3C\660E\66F8\3092\767B\9332\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002'),
unistr('&PRODUCT_NAME.\306F\3001\30EA\30AF\30A8\30B9\30C8\3078\306E\7F72\540D\306B\79D8\5BC6\30AD\30FC\3092\4F7F\7528\3057\307E\3059\3002'),
unistr('\3053\306E\5C5E\6027\306F\30AA\30D7\30B7\30E7\30F3\3067\3059\304C\3001\30BB\30AD\30E5\30EA\30C6\30A3\4E0A\306E\7406\7531\304B\3089\30EA\30AF\30A8\30B9\30C8\306B\306F\7F72\540D\3059\308B\3053\3068\3092\304A\85A6\3081\3057\307E\3059\3002')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007335.442)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>unistr('SAML\5C5E\6027\306E\4F7F\7528')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'INSTANCE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_deprecated_values=>'APP'
,p_help_text=>unistr('\30A4\30F3\30B9\30BF\30F3\30B9\30EC\30D9\30EB\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\56FA\6709\306E\3069\3061\3089\306ESAML\69CB\6210\3092\4F7F\7528\3059\308B\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1381216513007332.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1381216513007335.442)
,p_display_sequence=>10
,p_display_value=>unistr('\30A4\30F3\30B9\30BF\30F3\30B9')
,p_return_value=>'INSTANCE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('&PRODUCT_NAME.\30A4\30F3\30B9\30BF\30F3\30B9\5168\4F53\306B\5BFE\3057\3066\5171\6709SAML\69CB\6210\3092\4F7F\7528\3057\307E\3059\3002'),
unistr('\3053\306E\5834\5408\3001\30A4\30F3\30B9\30BF\30F3\30B9\7BA1\7406\8005\304C\30A4\30F3\30B9\30BF\30F3\30B9\30EC\30D9\30EB\306ESAML\5C5E\6027\3092\69CB\6210\6E08\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002'),
unistr('\3053\306E\8981\4EF6\304C\6E80\305F\3055\308C\3066\3044\306A\3044\5834\5408\3001\30E9\30F3\30BF\30A4\30E0\30FB\30A8\30E9\30FC\304C\767A\751F\3057\307E\3059\3002')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1381216513007331.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1381216513007335.442)
,p_display_sequence=>20
,p_display_value=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
,p_return_value=>'APP'
,p_is_deprecated=>true
,p_help_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\56FA\6709\306ESAML\69CB\6210\3092\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007336.442)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>20
,p_prompt=>unistr('\30A2\30A4\30C7\30F3\30C6\30A3\30C6\30A3\30FB\30D7\30ED\30D0\30A4\30C0\306E\30B7\30F3\30B0\30EB\30FB\30B5\30A4\30F3\30AA\30F3URL')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1381216513007335.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>unistr('\30A2\30A4\30C7\30F3\30C6\30A3\30C6\30A3\30FB\30D7\30ED\30D0\30A4\30C0\306E\30B7\30F3\30B0\30EB\30FB\30B5\30A4\30F3\30AA\30F3POST URL\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007337.442)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>30
,p_prompt=>unistr('\30A2\30A4\30C7\30F3\30C6\30A3\30C6\30A3\30FB\30D7\30ED\30D0\30A4\30C0\306E\30B7\30F3\30B0\30EB\30FB\30B5\30A4\30F3\30A2\30A6\30C8URL')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1381216513007335.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30A2\30A4\30C7\30F3\30C6\30A3\30C6\30A3\30FB\30D7\30ED\30D0\30A4\30C0\306E\30B7\30F3\30B0\30EB\30FB\30B5\30A4\30F3\30A2\30A6\30C8POST URL\3092\9078\629E\3057\307E\3059\3002'),
unistr('\7A7A\306E\5834\5408\3001\30B7\30F3\30B0\30EB\30FB\30B5\30A4\30F3\30AA\30F3URL\304C\4F7F\7528\3055\308C\307E\3059\3002')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007338.442)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>40
,p_prompt=>unistr('\30A2\30A4\30C7\30F3\30C6\30A3\30C6\30A3\30FB\30D7\30ED\30D0\30A4\30C0\306E\767A\884C\8005')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1381216513007335.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30A2\30A4\30C7\30F3\30C6\30A3\30C6\30A3\30FB\30D7\30ED\30D0\30A4\30C0\306E"\767A\884C\8005"\306E\5024\3092\9078\629E\3057\307E\3059\3002'),
unistr('&PRODUCT_NAME.\306F\3001\30A2\30A4\30C7\30F3\30C6\30A3\30C6\30A3\30FB\30D7\30ED\30D0\30A4\30C0\304B\3089\306E\30E1\30C3\30BB\30FC\30B8\3067\3053\306E\5024\3092\78BA\8A8D\3057\307E\3059\3002')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007339.442)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>50
,p_prompt=>unistr('\30E6\30FC\30B6\30FC\540D\5C5E\6027')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1381216513007335.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30E6\30FC\30B6\30FC\540D\3092\542B\3080SAML\5C5E\6027\3002'),
unistr('\30C7\30D5\30A9\30EB\30C8\3067"Assertion/Subject/NameID"\30CE\30FC\30C9\306E\5024\306B\8A2D\5B9A\3055\308C\307E\3059\3002')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007340.442)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>60
,p_prompt=>unistr('\30A2\30A4\30C7\30F3\30C6\30A3\30C6\30A3\30FB\30D7\30ED\30D0\30A4\30C0\306E\7F72\540D\8A3C\660E\66F8')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1381216513007335.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30A2\30A4\30C7\30F3\30C6\30A3\30C6\30A3\30FB\30D7\30ED\30D0\30A4\30C0\304C\30E1\30C3\30BB\30FC\30B8\3078\306E\7F72\540D\306B\4F7F\7528\3059\308B\8A3C\660E\66F8\3092\5165\529B\3057\307E\3059\3002'),
unistr('&PRODUCT_NAME.\306F\3001\30A2\30A4\30C7\30F3\30C6\30A3\30C6\30A3\30FB\30D7\30ED\30D0\30A4\30C0\304B\3089\306E\30EC\30B9\30DD\30F3\30B9\30FB\30E1\30C3\30BB\30FC\30B8\306E\78BA\8A8D\306B\3053\306E\8A3C\660E\66F8\3092\4F7F\7528\3057\307E\3059\3002'),
unistr('\3053\306E\5C5E\6027\306F\30AA\30D7\30B7\30E7\30F3\3067\3059\304C\3001\30BB\30AD\30E5\30EA\30C6\30A3\4E0A\306E\7406\7531\304B\3089\30EC\30B9\30DD\30F3\30B9\306F\78BA\8A8D\3059\308B\3053\3068\3092\304A\85A6\3081\3057\307E\3059\3002')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(549695930675668342.442)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\30E6\30FC\30B6\30FC\540D\306E\5927\6587\5B57\3078\306E\5909\63DB')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\30E6\30FC\30B6\30FC\540D\306E\5C5E\6027\5024\3092\5927\6587\5B57\306B\5909\63DB\3059\308B\5FC5\8981\304C\3042\308B\304B\3069\3046\304B\3092\69CB\6210\3057\307E\3059\3002')
);
end;
/
prompt --application/shared_components/plugins/item_type/input
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1401075215817352.442)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'INPUT'
,p_display_name=>unistr('\5165\529B\30D5\30A3\30FC\30EB\30C9')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS:APEX_APPL_PAGE_SFILTERS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','INPUT'),'')
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:ELEMENT:ENCRYPT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1401202979819499.442)
,p_plugin_id=>wwv_flow_api.id(1401075215817352.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\6BD4\8F03\6F14\7B97\5B50')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'EQUALS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1401536563820127.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.442)
,p_display_sequence=>10
,p_display_value=>unistr('\6B21\3068\7B49\3057\3044')
,p_return_value=>'EQUALS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1402360244821204.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.442)
,p_display_sequence=>30
,p_display_value=>unistr('\6B21\3088\308A\5C0F\3055\3044')
,p_return_value=>'LT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1402711336822152.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.442)
,p_display_sequence=>40
,p_display_value=>unistr('\6B21\4EE5\4E0B')
,p_return_value=>'LTE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1403187913822669.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.442)
,p_display_sequence=>50
,p_display_value=>unistr('\6B21\3088\308A\5927\304D\3044')
,p_return_value=>'GT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1403530010823859.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.442)
,p_display_sequence=>60
,p_display_value=>unistr('\6B21\4EE5\4E0A')
,p_return_value=>'GTE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1574661752077055.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.442)
,p_display_sequence=>70
,p_display_value=>unistr('\6B21\3067\59CB\307E\308B')
,p_return_value=>'STARTS_WITH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1403924638824893.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.442)
,p_display_sequence=>80
,p_display_value=>unistr('\6B21\3092\542B\3080')
,p_return_value=>'CONTAINS'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1404353085828349.442)
,p_plugin_id=>wwv_flow_api.id(1401075215817352.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\5927/\5C0F\6587\5B57\533A\5225')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1401202979819499.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'STARTS_WITH,CONTAINS'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1581137453249138.442)
,p_plugin_id=>wwv_flow_api.id(1401075215817352.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\5024\306E\5927/\5C0F\6587\5B57')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'MIXED'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1404353085828349.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\3059\3079\3066\306E\30C7\30FC\30BF\5024\306E\5C0F\6587\5B57\307E\305F\306F\5927\6587\5B57\304C\3059\3067\306B\6307\5B9A\3055\308C\3066\3044\308B\5834\5408\3001\3053\3053\3067\305D\306E\5927/\5C0F\6587\5B57\3092\5BA3\8A00\3067\304D\307E\3059\3002\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\6307\5B9A\3059\308B\30D5\30A3\30EB\30BF\306F\3001\5BA3\8A00\3055\308C\305F\5927/\5C0F\6587\5B57\306B\81EA\52D5\7684\306B\5909\63DB\3055\308C\308B\306E\3067\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\5927/\5C0F\6587\5B57\3092\533A\5225\305B\305A\306B\691C\7D22\3092\5B9F\884C\3067\304D\307E\3059\304C\3001\30C7\30FC\30BF\30D9\30FC\30B9\3067\306F\901A\5E38\306E\5927/\5C0F\6587\5B57\3092\533A\5225\3059\308B\691C\7D22\304C\5B9F\884C\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1581469548249721.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1581137453249138.442)
,p_display_sequence=>10
,p_display_value=>unistr('\5927/\5C0F\6587\5B57\306E\6DF7\5408')
,p_return_value=>'MIXED'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1581879901250301.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1581137453249138.442)
,p_display_sequence=>20
,p_display_value=>unistr('\5C0F\6587\5B57')
,p_return_value=>'LOWER'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1582278689250872.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1581137453249138.442)
,p_display_sequence=>30
,p_display_value=>unistr('\5927\6587\5B57')
,p_return_value=>'UPPER'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1573402545049808.442)
,p_plugin_id=>wwv_flow_api.id(1401075215817352.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\73FE\884C\30E9\30D9\30EB')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>unistr('\30D5\30A3\30EB\30BF\30EA\30F3\30B0\5BFE\8C61%0')
,p_help_text=>unistr('\73FE\5728\306E\30D5\30A1\30BB\30C3\30C8\9818\57DF\3067\3001\3053\306E\30D5\30A1\30BB\30C3\30C8\306B\8868\793A\3059\308B\30C6\30AD\30B9\30C8\3092\6307\5B9A\3057\307E\3059\3002\73FE\5728\306E\5024\306F\3001<strong>%0</strong>\30D7\30EC\30FC\30B9\30DB\30EB\30C0\30FC\3067\306E\53C2\7167\306B\3059\308B\3053\3068\304C\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1594998866512975.442)
,p_plugin_id=>wwv_flow_api.id(1401075215817352.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\63A5\982D\8F9E\30C6\30AD\30B9\30C8')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('\5165\529B\30D5\30A3\30FC\30EB\30C9\306E\524D\306B\8868\793A\3055\308C\308B\30C6\30AD\30B9\30C8\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1595229523514009.442)
,p_plugin_id=>wwv_flow_api.id(1401075215817352.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\63A5\5C3E\8F9E\30C6\30AD\30B9\30C8')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('\5165\529B\30D5\30A3\30FC\30EB\30C9\306E\5F8C\306B\8868\793A\3055\308C\308B\30C6\30AD\30B9\30C8\3092\6307\5B9A\3057\307E\3059\3002')
);
end;
/
prompt --application/shared_components/plugins/region_type/cards
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1602002675849340.442)
,p_plugin_type=>'REGION TYPE'
,p_name=>'CARDS'
,p_display_name=>unistr('\30AB\30FC\30C9')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','CARDS'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\30AB\30FC\30C9\5185\306E\5404\884C\306E\30C7\30FC\30BF\3092\8868\793A\3059\308BSQL\554F\5408\305B\306B\57FA\3065\304F\30EC\30DD\30FC\30C8\3002\30AB\30FC\30C9\3092\4F7F\7528\3059\308B\3068\3001\30B3\30F3\30C6\30F3\30C4\306E\30D6\30ED\30C3\30AF\3067\30C7\30FC\30BF\3092\7C21\5358\306B\8996\899A\5316\3067\304D\307E\3059\3002\30D8\30C3\30C0\30FC\3001\30E1\30C7\30A3\30A2\3001\672C\4F53\307E\305F\306F\30A2\30AF\30B7\30E7\30F3\3092\5BA3\8A00\7684\306B\30AB\30B9\30BF\30DE\30A4\30BA\3067\304D\307E\3059\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(1602292184849355.442)
,p_plugin_id=>wwv_flow_api.id(1602002675849340.442)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(633822552473663477.442)
,p_plugin_id=>wwv_flow_api.id(1602002675849340.442)
,p_name=>'tablemodelviewpagechange'
,p_display_name=>unistr('\30DA\30FC\30B8\5909\66F4')
);
end;
/
prompt --application/shared_components/plugins/web_source_type/http
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1677862467038200.442)
,p_plugin_type=>'WEB SOURCE TYPE'
,p_name=>'HTTP'
,p_display_name=>'HTTP'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('WEB SOURCE TYPE','HTTP'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1901267720643867.442)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\30DA\30FC\30B8\533A\5207\308A\30BF\30A4\30D7')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>unistr('\30DA\30FC\30B8\533A\5207\308A\306A\3057')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1901523910653468.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1901267720643867.442)
,p_display_sequence=>10
,p_display_value=>unistr('\30DA\30FC\30B8\30FB\30B5\30A4\30BA\3068\30D5\30A7\30C3\30C1\30FB\30AA\30D5\30BB\30C3\30C8')
,p_return_value=>'FLEXIBLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p><em>\30DA\30FC\30B8\30FB\30B5\30A4\30BA</em>\3084<em>\30AA\30D5\30BB\30C3\30C8</em>(\958B\59CB\884C)\30D1\30E9\30E1\30FC\30BF\3092\4F7F\7528\3057\3066\3001REST API\3067\7279\5B9A\306E\884C\306E\30BB\30C3\30C8\3092\30EA\30AF\30A8\30B9\30C8\3067\304D\308B\67D4\8EDF\306A\30DA\30FC\30B8\533A\5207\308A\3002\901A\5E38\3001URL\306F\6B21\306E\4F8B\306E\3088\3046\306B\306A\308A\307E\3059\3002\3053\306E\5834\5408\3001<strong>20</strong>\884C\30B9\30AD\30C3\30D7\3057\3066\3001\305D\306E\5F8C\306E<strong>100</strong>\884C\304C\30D5\30A7\30C3\30C1\3055\308C\307E\3059:</p>'),
'<pre>',
'http://hostname.domain.com/path/to/rest_api?limit=100&offset=20',
'</pre>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1901988519660109.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1901267720643867.442)
,p_display_sequence=>20
,p_display_value=>unistr('\30DA\30FC\30B8\30FB\30B5\30A4\30BA\3068\30DA\30FC\30B8\756A\53F7')
,p_return_value=>'PAGE_NUMBER_FLEXIBLE_SIZE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p><em>\30DA\30FC\30B8\30FB\30B5\30A4\30BA</em>\3084<em>\30DA\30FC\30B8\756A\53F7</em>\30D1\30E9\30E1\30FC\30BF\3092\4F7F\7528\3057\3066\3001REST API\3067\884C\306E\30BB\30C3\30C8\3092\30EA\30AF\30A8\30B9\30C8\3067\304D\308B\30DA\30FC\30B8\533A\5207\308A\3002\901A\5E38\3001URL\306F\6B21\306E\4F8B\306E\3088\3046\306B\306A\308A\307E\3059\3002\3053\3053\3067\306F\3001\30DA\30FC\30B8\756A\53F7<strong>2</strong>\3001\30DA\30FC\30B8\30FB\30B5\30A4\30BA<strong>100</strong>\304C\30EA\30AF\30A8\30B9\30C8\3055\308C\3066\304A\308A\3001\884C101\304B\3089200\304C\8FD4\3055\308C\307E\3059\3002'),
'</p>',
'<pre>',
'http://hostname.domain.com/path/to/rest_api?size=100&page=2',
'</pre>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1902974368668773.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1901267720643867.442)
,p_display_sequence=>30
,p_display_value=>unistr('\30DA\30FC\30B8\756A\53F7')
,p_return_value=>'PAGE_NUMBER_FIXED_SIZE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p><em>\30DA\30FC\30B8</em>\30FB\30D1\30E9\30E1\30FC\30BF\3092\4F7F\7528\3057\3066\3001REST API\3067\884C\306E\30BB\30C3\30C8\3092\30EA\30AF\30A8\30B9\30C8\3067\304D\308B\30DA\30FC\30B8\533A\5207\308A\3002\30DA\30FC\30B8\30FB\30B5\30A4\30BA\306F\56FA\5B9A\3067\3001REST API\3067\6C7A\3081\3089\308C\3066\3044\307E\3059\3002\901A\5E38\3001URL\306F\6B21\306E\4F8B\306E\3088\3046\306B\306A\308A\307E\3059\3002\3053\3053\3067\306F\3001\30DA\30FC\30B8\756A\53F7<strong>2</strong>\304C\30EA\30AF\30A8\30B9\30C8\3055\308C\3066\3044\307E\3059\3002REST API\3067\4F7F\7528\3055\308C\3066\3044\308B\56FA\5B9A\30DA\30FC\30B8\30FB\30B5\30A4\30BA\304C<strong>20</strong>\306E\5834\5408\3001\884C21\304B\308940\304C\8FD4\3055\308C\307E\3059\3002</p>'),
'<pre>',
'http://hostname.domain.com/path/to/rest_api?page=2',
'</pre>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1904445073685723.442)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\30DA\30FC\30B8\30FB\30B5\30A4\30BAURL\30D1\30E9\30E1\30FC\30BF')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>50
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'FLEXIBLE,PAGE_NUMBER_FLEXIBLE_SIZE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>REST API\304B\3089\30EA\30AF\30A8\30B9\30C8\3055\308C\308B<em>\30DA\30FC\30B8\30FB\30B5\30A4\30BA</em>\3092\6307\5B9A\3059\308B\305F\3081\306EURL\30D1\30E9\30E1\30FC\30BF\3092\6307\5B9A\3057\307E\3059\3002\4E00\822C\7684\306A\5024\306F\3001<strong>limit</strong>\3001<strong>page_size</strong>\307E\305F\306F</strong>per_page</strong>\3067\3059\3002</p>'),
unistr('<p><em>REST\30C7\30FC\30BF\30FB\30BD\30FC\30B9\30FB<strong>\30D1\30E9\30E1\30FC\30BF</strong>\5185\306B\3053\306E\30D1\30E9\30E1\30FC\30BF\3092\8FFD\52A0\3057\306A\3044\3067\304F\3060\3055\3044</em>\3002HTTP\30EA\30AF\30A8\30B9\30C8\306E\5B9F\884C\6642\306B&PRODUCT_NAME.\306B\3088\3063\3066\81EA\52D5\7684\306B\8FFD\52A0\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1904796837692405.442)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\30DA\30FC\30B8\30FB\30B5\30A4\30BA\6700\5927')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>10
,p_max_length=>10
,p_unit=>unistr('\884C')
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'PAGE_NUMBER_FLEXIBLE_SIZE,FLEXIBLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>REST API\3067\30D5\30A7\30C3\30C1\304C\8A31\53EF\3055\308C\308B\3001\30DA\30FC\30B8\5F53\305F\308A\306E\6700\5927\884C\6570\3092\6307\5B9A\3057\307E\3059\3002&PRODUCT_NAME.\3067\30011\30DA\30FC\30B8\306B\5BFE\3057\3066\305D\308C\3092\8D85\3048\308B\884C\304C\30EA\30AF\30A8\30B9\30C8\3055\308C\306A\304F\306A\308A\307E\3059\3002</p>'),
unistr('<p>&PRODUCT_NAME.\3067\306F\3001\30EA\30AF\30A8\30B9\30C8\3055\308C\305F\30DA\30FC\30B8\306F\6700\65B0\306E\30DA\30FC\30B8\3067\3042\308B\3068\8A8D\8B58\3055\308C\308B\305F\3081\3001\30EC\30B9\30DD\30F3\30B9\306B\542B\307E\308C\308B\884C\6570\304C\30EA\30AF\30A8\30B9\30C8\3088\308A\5C11\306A\308A\5834\5408\306F\3001REST API\3067\305D\306E\884C\6570\304C<em>\5B9F\969B\306B\8FD4\3055\308C\308B</em>\3053\3068\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1905045481696652.442)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\30DA\30FC\30B8\756A\53F7URL\30D1\30E9\30E1\30FC\30BF')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>50
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'PAGE_NUMBER_FLEXIBLE_SIZE,PAGE_NUMBER_FIXED_SIZE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>REST API\304B\3089\30EA\30AF\30A8\30B9\30C8\3059\308B<em>\30DA\30FC\30B8\756A\53F7</em>\3092\6307\5B9A\3059\308B\305F\3081\306EURL\30D1\30E9\30E1\30FC\30BF\3092\6307\5B9A\3057\307E\3059\3002\4E00\822C\7684\306A\5024\306F<strong>page</strong>\3067\3059\3002</p>'),
unistr('<p><em>REST\30C7\30FC\30BF\30FB\30BD\30FC\30B9\30FB<strong>\30D1\30E9\30E1\30FC\30BF</strong>\5185\306B\3053\306E\30D1\30E9\30E1\30FC\30BF\3092\8FFD\52A0\3057\306A\3044\3067\304F\3060\3055\3044</em>\3002HTTP\30EA\30AF\30A8\30B9\30C8\306E\5B9F\884C\6642\306B&PRODUCT_NAME.\306B\3088\3063\3066\81EA\52D5\7684\306B\8FFD\52A0\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1905385707699679.442)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\6700\521D\306E\30DA\30FC\30B8\306E\7D22\5F15')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'1'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'PAGE_NUMBER_FLEXIBLE_SIZE,PAGE_NUMBER_FIXED_SIZE'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>REST API\3067\3001\7D22\5F15<strong>"0"</strong>\3068<strong>"1"</strong>\306E\3069\3061\3089\3067\30DA\30FC\30B8\306E\30AB\30A6\30F3\30C8\3092\958B\59CB\3059\308B\304B\3092\6307\5B9A\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1905636932702605.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1905385707699679.442)
,p_display_sequence=>10
,p_display_value=>'1'
,p_return_value=>'1'
,p_is_quick_pick=>true
,p_help_text=>unistr('REST API\3067\306F\3001\6700\521D\306E\30DA\30FC\30B8\304C\30DA\30FC\30B8<strong>1</strong>\3068\3057\3066\53C2\7167\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1906025829704631.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1905385707699679.442)
,p_display_sequence=>20
,p_display_value=>'0'
,p_return_value=>'0'
,p_is_quick_pick=>true
,p_help_text=>unistr('REST API\3067\306F\3001\6700\521D\306E\30DA\30FC\30B8\304C\30DA\30FC\30B8<strong>0</strong>\3068\3057\3066\53C2\7167\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1906661765710861.442)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\56FA\5B9A\30DA\30FC\30B8\30FB\30B5\30A4\30BA')
,p_attribute_type=>'NUMBER'
,p_is_required=>true
,p_display_length=>10
,p_max_length=>10
,p_unit=>unistr('\884C')
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PAGE_NUMBER_FIXED_SIZE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p><em>\30DA\30FC\30B8\30FB\30B5\30A4\30BA</em>(\30DA\30FC\30B8\5F53\305F\308A\306E\884C\6570)\3092\6307\5B9A\3057\307E\3059\3002\3053\306E\30B5\30A4\30BA\306F\3001REST API\3067\5B9A\7FA9\3055\308C\3066\3044\307E\3059\3002</p>'),
unistr('<p>\901A\5E38\3001\3053\306E\60C5\5831\306F\3001REST API\306E\30C9\30AD\30E5\30E1\30F3\30C8\306B\8A18\8F09\3055\308C\3066\3044\307E\3059\3002\3053\3053\3067\306F\5FC5\305A\3001\6B63\3057\3044\5024\3092\6307\5B9A\3057\3066\304F\3060\3055\3044\3002\5024\304C\6B63\78BA\3067\306A\3044\3068\3001&PRODUCT_NAME.\304CREST API\304B\3089\30C7\30FC\30BF\3092\30D5\30A7\30C3\30C1\3059\308B\3068\304D\306B\3001\884C\304C\4E0D\8DB3\3057\305F\308A\91CD\8907\3057\305F\308A\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1906984049714159.442)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\884C\30AA\30D5\30BB\30C3\30C8URL\30D1\30E9\30E1\30FC\30BF')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>50
,p_max_length=>255
,p_unit=>unistr('\884C')
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'FLEXIBLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6700\521D\306E\884C\304C\8FD4\3055\308C\308B\524D\306B\30B9\30AD\30C3\30D7\3059\308B\884C\3092\793A\3059<em>\30AA\30D5\30BB\30C3\30C8</em>\3092\6307\5B9A\3059\308B\305F\3081\306EURL\30D1\30E9\30E1\30FC\30BF\3092\6307\5B9A\3057\307E\3059\3002</p>'),
unistr('<p><em>REST\30C7\30FC\30BF\30FB\30BD\30FC\30B9\30FB<strong>\30D1\30E9\30E1\30FC\30BF</strong>\5185\306B\3053\306E\30D1\30E9\30E1\30FC\30BF\3092\8FFD\52A0\3057\306A\3044\3067\304F\3060\3055\3044</em>\3002HTTP\30EA\30AF\30A8\30B9\30C8\306E\5B9F\884C\6642\306B&PRODUCT_NAME.\306B\3088\3063\3066\81EA\52D5\7684\306B\8FFD\52A0\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1907222147716823.442)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\884C\30AA\30D5\30BB\30C3\30C8\30FB\30BF\30A4\30D7')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'OFFSET'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'FLEXIBLE'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p><strong>\30AA\30D5\30BB\30C3\30C8</strong>\30FB\30D1\30E9\30E1\30FC\30BF\3067\3001<em>\30B9\30AD\30C3\30D7\3059\308B\884C\6570</em>\3068<em>\30D5\30A7\30C3\30C1\3059\308B\6700\521D\306E\884C</em>\306E\3069\3061\3089\3092\6307\5B9A\3059\308B\304B\3092\9078\629E\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1907577038717722.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1907222147716823.442)
,p_display_sequence=>10
,p_display_value=>unistr('\30B9\30AD\30C3\30D7\3059\308B\884C')
,p_return_value=>'OFFSET'
,p_help_text=>unistr('\30AA\30D5\30BB\30C3\30C8\5024\306F\30B9\30AD\30C3\30D7\3059\308B\884C\3092\793A\3057\307E\3059\3002\305F\3068\3048\3070\3001\5024100\3092\6307\5B9A\3059\308B\3068\3001REST API\3067\306F\3001\7D22\5F15101\4EE5\964D\306E\884C\304C\8FD4\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1907904681718986.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1907222147716823.442)
,p_display_sequence=>20
,p_display_value=>unistr('\30D5\30A7\30C3\30C1\3059\308B\6700\521D\306E\884C')
,p_return_value=>'START'
,p_help_text=>unistr('\30AA\30D5\30BB\30C3\30C8\5024\306F\30D5\30A7\30C3\30C1\3092\958B\59CB\3059\308B\884C\3092\793A\3057\307E\3059\3002\305F\3068\3048\3070\3001\5024100\3092\6307\5B9A\3059\308B\3068\3001REST API\3067\306F99\884C\304C\30B9\30AD\30C3\30D7\3055\308C\3001\7D22\5F15100\304B\3089\30D5\30A7\30C3\30C1\304C\958B\59CB\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1908579263746808.442)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\305D\306E\4ED6\306E\884C\30BB\30EC\30AF\30BF')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>50
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>REST API\3067\6B21\306EJSON\30EC\30B9\30DD\30F3\30B9\304C\8FD4\3055\308C\308B\5834\5408:</p>'),
'<pre>',
'{',
'    "items": [',
'         { // row 1 },',
'         { // row 2 },',
'         :',
'         { // row n } ',
'    ],',
'    "metadata": {',
'         "pagination": {',
'             "moreRows": true,',
'             "totalRows": 2712,',
'             "nextPage": 10 ',
'         } ',
'    } ',
'}',
'</pre>',
'<p>',
unistr('<strong>\300C\305D\306E\4ED6\306E\884C\30BB\30EC\30AF\30BF\300D</strong>\306F<strong>metadata.pagination.moreRows</strong>\3067\3059\3002'),
'</p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30EC\30B9\30DD\30F3\30B9\306EREST API\3067\3001\8FFD\52A0\30DA\30FC\30B8\306E\6709\7121\306B\95A2\3059\308B\60C5\5831\3092\8FD4\3059\5834\5408\306F\3001\3053\306E\5C5E\6027\3092\62BD\51FA\3059\308B\305F\3081\306E<em>\30BB\30EC\30AF\30BF</em>\3092\3053\3053\306B\6307\5B9A\3057\307E\3059\3002</p>'),
unistr('<p><strong>\300C\305D\306E\4ED6\306E\884C\30BB\30EC\30AF\30BF\300D</strong>\306E\6307\5B9A\306F\5FC5\9808\3067\306F\3042\308A\307E\305B\3093\304C\3001\6307\5B9A\3057\3066\304A\304F\3068\3001\5168\30C7\30FC\30BF\304C\3059\3067\306B\30D5\30A7\30C3\30C1\3055\308C\3066\3044\308B\5834\5408\306B\3001&PRODUCT_NAME.\304C\8FFD\52A0\306EHTTP\30EA\30AF\30A8\30B9\30C8(\30C7\30FC\30BF\306F\8FD4\3055\308C\306A\3044)\3092\4FDD\5B58\3059\308B\969B\306B\5F79\7ACB\3061\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1908849697751769.442)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('\6B21\306E\5024\306E\3068\304D\306E\305D\306E\4ED6\306E\884C')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'EQUALS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1908579263746808.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p><strong>\300C\305D\306E\4ED6\306E\884C\30BB\30EC\30AF\30BF\300D</strong>\3067\53C2\7167\3055\308C\308B\30EC\30B9\30DD\30F3\30B9\5C5E\6027\306E\5024\3092\3069\306E\3088\3046\306B\89E3\91C8\3059\308B\304B\3092\9078\629E\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1909141279756289.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1908849697751769.442)
,p_display_sequence=>10
,p_display_value=>unistr('\6B21\3068\7B49\3057\3044')
,p_return_value=>'EQUALS'
,p_is_quick_pick=>true
,p_help_text=>unistr('<strong>\300C\305D\306E\4ED6\306E\884C\30BB\30EC\30AF\30BF\300D</strong>\3067\53C2\7167\3055\308C\308B\30EC\30B9\30DD\30F3\30B9\5C5E\6027\3068\5024\304C\7B49\3057\3044\5834\5408\3001\305D\306E\4ED6\306B\3082\884C\304C\3042\308B\3068\63A8\5B9A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1909569602757607.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1908849697751769.442)
,p_display_sequence=>20
,p_display_value=>unistr('Null\3067\306A\3044')
,p_return_value=>'NOT_NULL'
,p_is_quick_pick=>true
,p_help_text=>unistr('<strong>\300C\305D\306E\4ED6\306E\884C\30BB\30EC\30AF\30BF\300D</strong>\3067\53C2\7167\3055\308C\308B\30EC\30B9\30DD\30F3\30B9\5C5E\6027\304C\5B58\5728\3057\3001\7A7A\3067\306A\3044\5834\5408\306F\3001\305D\306E\4ED6\306B\3082\884C\304C\3042\308B\3068\63A8\5B9A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1911015518771444.442)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>unistr('\305D\306E\4ED6\306E\884C\5C5E\6027\5024')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'true'
,p_display_length=>50
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1908849697751769.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'EQUALS'
,p_help_text=>unistr('<p><strong>\300C\305D\306E\4ED6\306E\884C\30BB\30EC\30AF\30BF\300D</strong>\3067\53C2\7167\3055\308C\308B\30EC\30B9\30DD\30F3\30B9\5C5E\6027\306B\3053\306E\5024\304C\542B\307E\308C\3066\3044\308B\3068\3001&PRODUCT_NAME.\306F\3001\305D\306E\4ED6\306B\3082\884C\304C\3042\308B\3068\63A8\5B9A\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1911713410779146.442)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>unistr('\5408\8A08\884C\30BB\30EC\30AF\30BF')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>50
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>REST API\3067\6B21\306EJSON\30EC\30B9\30DD\30F3\30B9\304C\8FD4\3055\308C\308B\5834\5408...</p>'),
'<pre>',
'{',
'    "items": [',
'         { // row 1 },',
'         { // row 2 },',
'         :',
'         { // row n } ',
'    ],',
'    "metadata": {',
'         "pagination": {',
'             "moreRows": true,',
'             "totalRows": 2712,',
'             "nextPage": 10 ',
'         } ',
'    } ',
'}',
'</pre>',
'<p>',
unistr('...<strong>\300C\305D\306E\4ED6\306E\884C\30BB\30EC\30AF\30BF\300D</strong>\306F<strong>metadata.pagination.totalRows</strong>\3067\3059\3002'),
'</p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>REST API\3067\3001\30EC\30B9\30DD\30F3\30B9\306E\4E00\90E8\3068\3057\3066(\5168\30DA\30FC\30B8\306E)<em>\5408\8A08\884C\6570</em>\304C\8FD4\3055\308C\308B\5834\5408\306F\3001\3053\306E\5C5E\6027\3092\62BD\51FA\3059\308B\305F\3081\306E<em>\30BB\30EC\30AF\30BF</em>\3092\3053\3053\306B\6307\5B9A\3057\307E\3059\3002</p>'),
unistr('<p><strong>\300C\305D\306E\4ED6\306E\884C\30BB\30EC\30AF\30BF\300D</strong>\306E\6307\5B9A\306F\5FC5\9808\3067\306F\3042\308A\307E\305B\3093\304C\3001\6307\5B9A\3057\3066\304A\304F\3068\3001<em>\30C7\30FC\30BF\304C\305D\308C\4EE5\4E0A\30D5\30A3\30EB\30BF\3055\308C\306A\3044\304B\304E\308A</em>\3001&PRODUCT_NAME.\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\3042\308B\884C\306E\5408\8A08\6570\3092\8868\793A\3067\304D\307E\3059\3002</p>')))
);
end;
/
prompt --application/shared_components/plugins/item_type/geocoded_address
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1700838675352758.442)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'GEOCODED_ADDRESS'
,p_display_name=>unistr('\30B8\30AA\30B3\30FC\30C7\30A3\30F3\30B0\3055\308C\305F\4F4F\6240')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','GEOCODED_ADDRESS'),'')
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#model#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.tableModelViewBase#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.grid#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.iconList#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.miniMap#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.geoCoder#MIN#.js'))
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:SOURCE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30A2\30A4\30C6\30E0\30FB\30BF\30A4\30D7\306F\3001\30B8\30AA\30B3\30FC\30C7\30A3\30F3\30B0(\4F4F\6240\3092\5EA7\6A19\306B\5909\63DB\3059\308B)\6A5F\80FD\3092\63D0\4F9B\3057\307E\3059\3002<p>'),
unistr('<p>\30B8\30AA\30B3\30FC\30C7\30A3\30F3\30B0\306F\3001<em>\30D6\30E9\30A6\30B6</em>\304C<strong>Oracle Elocation</strong>\30B8\30AA\30B3\30FC\30C7\30A3\30F3\30B0\30FB\30B5\30FC\30D3\30B9(elocation.oracle.com)\3078\306EREST\30EA\30AF\30A8\30B9\30C8\3092\884C\3046\3053\3068\306B\3088\3063\3066\5B9F\884C\3055\308C\307E\3059\3002\3057\305F\304C\3063\3066\3001\30B8\30AA\30B3\30FC\30C7\30A3\30F3\30B0\304C\6A5F\80FD\3059\308B\306B\306F\3001\30D6\30E9\30A6\30B6\304C\30A4\30F3\30BF\30FC\30CD\30C3\30C8\306B\63A5\7D9A\3055\308C\3066\3044\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>'),
unistr('<p>\30B8\30AA\30B3\30FC\30C7\30A3\30F3\30B0\306E\5165\529B\30C7\30FC\30BF\306F\3001\901A\308A\3001\756A\5730\3001\90F5\4FBF\756A\53F7\3001\5E02\306A\3069\306E\4F4F\6240\306E\5404\90E8\5206\306B\30DE\30C3\30D4\30F3\30B0\3055\308C\3066\3044\308B\4ED6\306E\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\304B\3089\53D6\5F97\3055\308C\307E\3059\3002\30B8\30AA\30B3\30FC\30C0\306F\3001\4E00\81F4\5019\88DC\306E\30EA\30B9\30C8\3092\542B\3080\30DD\30C3\30D7\30A2\30C3\30D7\30FB\30A6\30A3\30F3\30C9\30A6\3092\8868\793A\3057\307E\3059\3002\4E00\81F4\3059\308B\3082\306E\3092\9078\629E\3059\308B\3068\3001\30A2\30A4\30C6\30E0\306E\30BB\30C3\30B7\30E7\30F3\72B6\614B\306E\5024\306FGeoJSON\5F62\5F0F\306E\30A2\30C9\30EC\30B9\5EA7\6A19\306B\306A\308A\307E\3059\3002<strong>\300C\4F4F\6240\306E\30B5\30CB\30BF\30A4\30BA\300D</strong>\304C\6709\52B9\306A\5834\5408\3001\4F4F\6240\90E8\5206\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306F\3001\30B8\30AA\30B3\30FC\30C7\30A3\30F3\30B0\30FB\30B5\30FC\30D3\30B9\304B\3089\53D7\3051\53D6\3063\305F\30B5\30CB\30BF\30A4\30BA\3055\308C\305F\5024\3067\4E0A\66F8\304D\3055\308C\307E\3059\3002</p>'),
unistr('<p>\3088\308A\5358\7D14\306A\30E6\30FC\30B9\30B1\30FC\30B9\306E\5834\5408\3001<strong>\300C\975E\69CB\9020\5316\4F4F\6240\300D</strong>\30E2\30FC\30C9\3067\30011\3064\306E\30C6\30AD\30B9\30C8\30FB\30D5\30A3\30FC\30EB\30C9\307E\305F\306F\30C6\30AD\30B9\30C8\9818\57DF(\3053\3053\306B\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\4F4F\6240\306E\5404\90E8\5206\3092\30AB\30F3\30DE\3067\533A\5207\3063\3066\5165\529B\3059\308B)\306E\307F\3092\30DE\30C3\30D7\3067\304D\307E\3059\3002\3053\306E\5834\5408\3001<strong>\300C\4F4F\6240\306E\30B5\30CB\30BF\30A4\30BA\300D</strong>\30E2\30FC\30C9\306F\4F7F\7528\3067\304D\307E\305B\3093\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1701330611413991.442)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.442)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\30B8\30AA\30B3\30FC\30C0\4E00\81F4\30E2\30FC\30C9')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'RELAX_HOUSE_NUMBER'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p><strong>\4E00\81F4\30E2\30FC\30C9</strong>\306F\3001\5165\529B\4F4F\6240\306E\5C5E\6027\304C\30B8\30AA\30B3\30FC\30C7\30A3\30F3\30B0\306B\4F7F\7528\3055\308C\3066\3044\308B\30C7\30FC\30BF\3068\3069\306E\7A0B\5EA6\4E00\81F4\3059\308B\5FC5\8981\304C\3042\308B\304B\3092\6C7A\5B9A\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702013128418533.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1701330611413991.442)
,p_display_sequence=>10
,p_display_value=>unistr('\5B8C\5168')
,p_return_value=>'EXACT'
,p_help_text=>unistr('<p>\6307\5B9A\3055\308C\305F\3059\3079\3066\306E\4F4F\6240\306E\90E8\5206\304C\4E00\81F4\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\305F\3060\3057\3001\756A\5730\3001\901A\308A\540D\307E\305F\306F\901A\308A\30BF\30A4\30D7\304C<em>\3059\3079\3066</em>\306F\4E00\81F4\3057\306A\3044\5834\5408\3001\90F5\4FBF\756A\53F7\3001\5E02\307E\305F\306F\753A\3001\5DDE\306E\6700\521D\306E\4E00\81F4\304C\8FD4\3055\308C\307E\3059\3002\305F\3068\3048\3070\3001\901A\308A\540D\304C\6B63\3057\304F\306A\304F\3066\3082\6709\52B9\306A\90F5\4FBF\756A\53F7\304C\6307\5B9A\3055\308C\3066\3044\308C\3070\3001\90F5\4FBF\756A\53F7\5185\306E\5834\6240\304C\8FD4\3055\308C\307E\3059\3002</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702860244421796.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1701330611413991.442)
,p_display_sequence=>20
,p_display_value=>unistr('\901A\308A\30BF\30A4\30D7\306E\7DE9\548C')
,p_return_value=>'RELAX_STREET_TYPE'
,p_help_text=>unistr('<p>\6307\5B9A\3055\308C\305F<em>\901A\308A\30BF\30A4\30D7</em>\304C\3001\30B8\30AA\30B3\30FC\30C7\30A3\30F3\30B0\306B\4F7F\7528\3055\308C\308B\30C7\30FC\30BF\3068\7570\306A\3063\3066\3044\3066\3082\304B\307E\3044\307E\305B\3093\3002\305F\3068\3048\3070\3001<strong>Main Street</strong>\307E\305F\306F<strong>Main Blvd</strong>\306F\3001\95A2\9023\3059\308B\30A8\30EA\30A2\306B\4ED6\306E<strong>Main Blvd</strong>\307E\305F\306F<strong>Main Street</strong>\304C\306A\3044\5834\5408\3001<strong>Main St</strong>\3068\4E00\81F4\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1708669966452560.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1701330611413991.442)
,p_display_sequence=>30
,p_display_value=>unistr('\756A\5730\306E\7DE9\548C')
,p_return_value=>'RELAX_HOUSE_NUMBER'
,p_help_text=>unistr('<p>\756A\5730\304A\3088\3073\901A\308A\30BF\30A4\30D7\304C\30B8\30AA\30B3\30FC\30C7\30A3\30F3\30B0\306B\4F7F\7528\3055\308C\308B\30C7\30FC\30BF\3068\7570\306A\3063\3066\3044\3066\3082\304B\307E\3044\307E\305B\3093\3002\305F\3068\3048\3070\3001\3042\3044\307E\3044\3055\3084\305D\306E\4ED6\306E\4E00\81F4\304C\306A\3044\304B\304E\308A\3001<strong>123 Main St</strong>\306F<strong>123 Main Lane</strong>\304A\3088\3073<strong>124 Main St</strong>\3068\4E00\81F4\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702428218420313.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1701330611413991.442)
,p_display_sequence=>40
,p_display_value=>unistr('\901A\308A\540D\306E\7DE9\548C')
,p_return_value=>'RELAX_BASE_NAME'
,p_help_text=>unistr('<p>\901A\308A\306E<em>\30D9\30FC\30B9\540D</em>\3001\756A\5730\304A\3088\3073\901A\308A\30BF\30A4\30D7\304C\3001\30B8\30AA\30B3\30FC\30C7\30A3\30F3\30B0\306B\4F7F\7528\3055\308C\308B\30C7\30FC\30BF\3068\306F\7570\306A\3063\3066\3044\3066\3082\304B\307E\3044\307E\305B\3093\3002\305F\3068\3048\3070\3001\30C7\30FC\30BF\306B\3042\3044\307E\3044\3055\3084\305D\306E\4ED6\306E\4E00\81F4\304C\306A\3044\304B\304E\308A\3001<strong>Pleasant Vale</strong>\306F<strong>Pleasant Valley</strong>\3068\4E00\81F4\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1703440180425368.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1701330611413991.442)
,p_display_sequence=>50
,p_display_value=>unistr('\90F5\4FBF\756A\53F7\306E\7DE9\548C')
,p_return_value=>'RELAX_POSTAL_CODE'
,p_help_text=>unistr('<p>\90F5\4FBF\756A\53F7(\6307\5B9A\3055\308C\305F\5834\5408)\3001\901A\308A\540D\3001\901A\308A\30BF\30A4\30D7\304A\3088\3073\756A\5730\304C\3001\30B8\30AA\30B3\30FC\30C7\30A3\30F3\30B0\306B\4F7F\7528\3055\308C\308B\30C7\30FC\30BF\3068\7570\306A\3063\3066\3044\3066\3082\304B\307E\3044\307E\305B\3093\3002</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1703985342434956.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1701330611413991.442)
,p_display_sequence=>60
,p_display_value=>unistr('\3059\3079\3066\7DE9\548C')
,p_return_value=>'RELAX_ALL'
,p_help_text=>unistr('<p>\4F4F\6240\306F\3001\540C\3058\90E1\5185\3067\3042\308B\304B\304E\308A\3001\6307\5B9A\3055\308C\305F\5E02\4EE5\5916\3067\3082\304B\307E\3044\307E\305B\3093\3002<strong>\300C\90F5\4FBF\756A\53F7\306E\7DE9\548C\300D</strong>\306E\7279\6027\3082\542B\307E\308C\307E\3059\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1709401396458135.442)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.442)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\5EA7\6A19\3092\30DD\30C3\30D7\30A2\30C3\30D7\3067\8868\793A')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3010200212280744.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'GRID'
,p_help_text=>unistr('<p>\30B8\30AA\30B3\30FC\30C7\30A3\30F3\30B0\306E\7D50\679C\306E\30DD\30C3\30D7\30A2\30C3\30D7\30FB\30C0\30A4\30A2\30ED\30B0\306B\4F4F\6240\306E\5EA7\6A19(\7D4C\5EA6\3001\7DEF\5EA6)\3092\8868\793A\3059\308B\304B\3069\3046\304B\3092\6C7A\5B9A\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2105827892587713.442)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.442)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\30DE\30C3\30D7\30FB\30D7\30EC\30D3\30E5\30FC')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_default_value=>'POPUP:ITEM'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>\30DE\30C3\30D7\4E0A\3067\30B8\30AA\30B3\30FC\30C7\30A3\30F3\30B0\3055\308C\305F\4F4F\6240\306E\30D7\30EC\30D3\30E5\30FC\3092\8A31\53EF\3059\308B\304B\3069\3046\304B\3002</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2601067718431827.442)
,p_plugin_attribute_id=>wwv_flow_api.id(2105827892587713.442)
,p_display_sequence=>10
,p_display_value=>unistr('\7D50\679C\30DD\30C3\30D7\30A2\30C3\30D7')
,p_return_value=>'POPUP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30B8\30AA\30B3\30FC\30C7\30A3\30F3\30B0\306E\7D50\679C\306E\30DD\30C3\30D7\30A2\30C3\30D7\306B\30DE\30C3\30D7\304C\8868\793A\3055\308C\3001\30E6\30FC\30B6\30FC\306F\4F4D\7F6E\3092\78BA\8A8D\3057\3066\304B\3089\3001\7D50\679C\3092\9078\629E\3067\304D\307E\3059\3002</p>'),
unistr('<p>\3053\308C\306F\3001\300C\8868\793A\5F62\5F0F - \30B0\30EA\30C3\30C9\30FB\30D3\30E5\30FC\300D\304C\6709\52B9\306B\306A\3063\3066\3044\308B\5834\5408\306B\306E\307F\30B5\30DD\30FC\30C8\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2601404353432915.442)
,p_plugin_attribute_id=>wwv_flow_api.id(2105827892587713.442)
,p_display_sequence=>20
,p_display_value=>unistr('\30A2\30A4\30C6\30E0')
,p_return_value=>'ITEM'
,p_help_text=>unistr('\30A2\30A4\30C6\30E0\306E\4F4D\7F6E\306B\4F4F\6240\306E\5834\6240\3092\793A\3057\305F\30DE\30C3\30D7\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1744825789778265.442)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.442)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\80CC\666F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'default'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2105827892587713.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>\30B8\30AA\30B3\30FC\30C7\30A3\30F3\30B0\306E\7D50\679C\3092\8868\793A\3059\308B\80CC\666F\30DE\30C3\30D7\3092\9078\629E\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1746613534792926.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1744825789778265.442)
,p_display_sequence=>5
,p_display_value=>unistr('\30C7\30D5\30A9\30EB\30C8')
,p_return_value=>'default'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30C7\30D5\30A9\30EB\30C8\306E\30DE\30C3\30D7\80CC\666F\3092\4F7F\7528\3057\307E\3059\3002</p>'),
unistr('<p>\30C0\30FC\30AF\30FB\30C6\30FC\30DE\306B\306F"OpenStreetMap Bright"\307E\305F\306F"OpenStreetMap Dark"\306E\3044\305A\308C\304B\304C\4F7F\7528\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1745320076781973.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1744825789778265.442)
,p_display_sequence=>10
,p_display_value=>'OpenStreetMap Bright'
,p_return_value=>'osm-bright'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>OpenStreetMap\30C7\30FC\30BF\306B\57FA\3065\304F\6C4E\7528\30D9\30FC\30B9\30DE\30C3\30D7\3002\3053\306E\30D9\30FC\30B9\30DE\30C3\30D7\30FB\30B9\30BF\30A4\30EB\306B\3088\3063\3066\3001\30C7\30FC\30BF\306E\8A73\7D30\306A\30ED\30B1\30FC\30B7\30E7\30F3\30FB\30B3\30F3\30C6\30AD\30B9\30C8\304C\63D0\4F9B\3055\308C\307E\3059\3002</p>'),
unistr('<p>Mapbox Open Styles\304B\3089\6D3E\751F\3057\305FKlokanTech.com\3068OpenMapTiles\306E\30B3\30F3\30C8\30EA\30D3\30E5\30FC\30BF\306B\3088\308B\30B9\30BF\30A4\30EB\30FB\30B9\30AD\30FC\30DE\304A\3088\3073\5B9A\7FA9\3002BSD/CC-BY\30E9\30A4\30BB\30F3\30B9\306E\4E0B\3067\8A31\53EF\3055\308C\3066\3044\307E\3059\3002</p>'),
unistr('<p><a rel="noreferrer" href="https://github.com/openmaptiles/osm-bright-gl-style" target="_blank">GitHub\3067\8868\793A</a></p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1745780305787850.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1744825789778265.442)
,p_display_sequence=>20
,p_display_value=>'OpenStreetMap Dark'
,p_return_value=>'osm-dark-matter'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>OpenStreetMap\30C7\30FC\30BF\306B\57FA\3065\304F\63A7\3048\3081\306A\30C0\30FC\30AF\30FB\30D9\30FC\30B9\30DE\30C3\30D7\3002\3053\306E\30D9\30FC\30B9\30DE\30C3\30D7\30FB\30B9\30BF\30A4\30EB\306B\3088\3063\3066\3001\30C7\30FC\30BF\306E\8996\899A\5316\304C\5F37\8ABF\3055\308C\307E\3059\3002</p>'),
unistr('<p>Mapbox Open Styles\304B\3089\6D3E\751F\3057\305FKlokanTech.com\3068OpenMapTiles\306E\30B3\30F3\30C8\30EA\30D3\30E5\30FC\30BF\306B\3088\308B\30B9\30BF\30A4\30EB\30FB\30B9\30AD\30FC\30DE\304A\3088\3073\5B9A\7FA9\3002BSD/CC-BY\30E9\30A4\30BB\30F3\30B9\306E\4E0B\3067\8A31\53EF\3055\308C\3066\3044\307E\3059\3002Stamen Design\306B\3088\308B\5730\56F3\4F5C\6210\306F\3001CC0\306E\4E0B\3067\8A31\53EF\3055\308C\3066\3044\307E\3059\3002</p>'),
unistr('<p><a rel="noreferrer" href="https://github.com/openmaptiles/dark-matter-gl-style" target="_blank">GitHub\3067\8868\793A</a></p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1746150917790500.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1744825789778265.442)
,p_display_sequence=>30
,p_display_value=>'OpenStreetMap Positron'
,p_return_value=>'osm-positron'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>OpenStreetMap\30C7\30FC\30BF\306B\57FA\3065\304F\63A7\3048\3081\306A\30E9\30A4\30C8\30FB\30D9\30FC\30B9\30DE\30C3\30D7\3002\3053\306E\30D9\30FC\30B9\30DE\30C3\30D7\30FB\30B9\30BF\30A4\30EB\306B\3088\3063\3066\3001\30C7\30FC\30BF\306E\8996\899A\5316\304C\5F37\8ABF\3055\308C\307E\3059\3002</p>'),
unistr('<p>Mapbox Open Styles\304B\3089\6D3E\751F\3057\305FKlokanTech.com\3068OpenMapTiles\306E\30B3\30F3\30C8\30EA\30D3\30E5\30FC\30BF\306B\3088\308B\30B9\30BF\30A4\30EB\30FB\30B9\30AD\30FC\30DE\304A\3088\3073\5B9A\7FA9\3002BSD/CC-BY\30E9\30A4\30BB\30F3\30B9\306E\4E0B\3067\8A31\53EF\3055\308C\3066\3044\307E\3059\3002Stamen Design\306B\3088\308B\5730\56F3\4F5C\6210\306F\3001CC0\306E\4E0B\3067\8A31\53EF\3055\308C\3066\3044\307E\3059\3002</p>'),
unistr('<p><a rel="noreferrer" href="https://github.com/openmaptiles/positron-gl-style" target="_blank">GitHub\3067\8868\793A</a></p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2601367265556756.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1744825789778265.442)
,p_display_sequence=>40
,p_display_value=>'Oracle World Map'
,p_return_value=>'world-map'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>HERE Map\30C7\30FC\30BF\306B\57FA\3065\304F\6C4E\7528\30D9\30FC\30B9\30DE\30C3\30D7\3002\3053\306E\30D9\30FC\30B9\30DE\30C3\30D7\30FB\30B9\30BF\30A4\30EB\306B\3088\3063\3066\3001\30C7\30FC\30BF\306E\30ED\30B1\30FC\30B7\30E7\30F3\30FB\30B3\30F3\30C6\30AD\30B9\30C8\304C\63D0\4F9B\3055\308C\3001\30C7\30FC\30BF\306E\8996\899A\5316\304C\5F37\8ABF\3055\308C\307E\3059\3002</p>'),
unistr('<p>Oracle USA\306B\3088\308B\30B9\30BF\30A4\30EB\30FB\30B9\30AD\30FC\30DE\304A\3088\3073\5B9A\7FA9\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2206585812380955.442)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.442)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\9AD8\3055')
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_unit=>unistr('\30D4\30AF\30BB\30EB')
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2105827892587713.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ITEM'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8868\793A\3055\308C\308B\30DE\30C3\30D7\306E\9AD8\3055(\30D4\30AF\30BB\30EB)\3092\6307\5B9A\3057\307E\3059\3002</p>'),
unistr('<p>\30DE\30C3\30D7\306E\30C7\30D5\30A9\30EB\30C8\306E\9AD8\3055\306F\3001\305D\306E\5E45\306B\57FA\3065\3044\30663:2\306E\30A2\30B9\30DA\30AF\30C8\6BD4\3067\8A08\7B97\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3010200212280744.442)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.442)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>6
,p_display_sequence=>15
,p_prompt=>unistr('\8868\793A\5F62\5F0F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'LIST'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>\30B8\30AA\30B3\30FC\30C7\30A3\30F3\30B0\7D50\679C\306E\8868\793A\65B9\6CD5\3092\9078\629E\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3011428457283918.442)
,p_plugin_attribute_id=>wwv_flow_api.id(3010200212280744.442)
,p_display_sequence=>10
,p_display_value=>unistr('\30EA\30B9\30C8\30FB\30D3\30E5\30FC')
,p_return_value=>'LIST'
,p_help_text=>unistr('<p>\7D50\679C\306F\30EA\30B9\30C8\30FB\30D3\30E5\30FC\306B\8868\793A\3055\308C\307E\3059\3002</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3011010596282953.442)
,p_plugin_attribute_id=>wwv_flow_api.id(3010200212280744.442)
,p_display_sequence=>20
,p_display_value=>unistr('\30B0\30EA\30C3\30C9\30FB\30D3\30E5\30FC')
,p_return_value=>'GRID'
,p_help_text=>unistr('<p>\7D50\679C\306F\30B0\30EA\30C3\30C9\30FB\30D3\30E5\30FC\306B\8868\793A\3055\308C\307E\3059\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1709967230470781.442)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>60
,p_prompt=>unistr('\69CB\9020\5316\4F4F\6240')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4F4F\6240\306E\5404\90E8\5206\304C\30B8\30AA\30B3\30FC\30C7\30A3\30F3\30B0\30FB\30B5\30FC\30D3\30B9\306B<em>\69CB\9020\5316</em>\65B9\5F0F\3067\63D0\4F9B\3055\308C\308B\304B\3001<em>\975E\69CB\9020\5316</em>\65B9\5F0F\3067\63D0\4F9B\3055\308C\308B\304B\3002</p>'),
unistr('<p>\69CB\9020\5316\3068\306F\3001\660E\793A\7684\306A\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\304C\3001\901A\308A\3001\90F5\4FBF\756A\53F7\3001\5E02\3001\5730\57DF\306A\3069\306E\4F4F\6240\306E\5404\90E8\5206\306B\30DE\30C3\30D4\30F3\30B0\3055\308C\308B\3053\3068\3092\610F\5473\3057\307E\3059\3002\3053\308C\306B\3088\308A\3001\3088\308A\6B63\78BA\306A\30B8\30AA\30B3\30FC\30C7\30A3\30F3\30B0\7D50\679C\304C\5F97\3089\308C\3001'),
unistr('\4FEE\6B63\3055\308C\305F\4F4F\6240\3092\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306B\30D5\30A3\30FC\30C9\30D0\30C3\30AF\3059\308B\3053\3068\3082\3067\304D\307E\3059\3002</p>'),
unistr('<p>\975E\69CB\9020\5316\3068\306F\3001\30A2\30C9\30EC\30B9\5168\4F53\306B1\3064\306E\30A2\30A4\30C6\30E0\306E\307F\304C\4F7F\7528\3055\308C\308B\3053\3068\3092\610F\5473\3057\307E\3059\3002\5404\90E8\5206\306F\30AB\30F3\30DE\3067\533A\5207\3089\308C\307E\3059\3002\3053\306E\30E2\30FC\30C9\3067\306F\3001\4FEE\6B63\3055\308C\305F\4F4F\6240\3092\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306B\30D5\30A3\30FC\30C9\30D0\30C3\30AF\3059\308B\3053\3068\306F\3067\304D\307E\305B\3093\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1710428568474713.442)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>30
,p_prompt=>unistr('\56FD\30BF\30A4\30D7')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STATIC'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>\30B8\30AA\30B3\30FC\30C7\30A3\30F3\30B0\306B\9759\7684\306A\56FD\3092\4F7F\7528\3059\308B\304B\3001\30A2\30A4\30C6\30E0\304B\3089\56FD\3092\5C0E\51FA\3059\308B\304B\3092\9078\629E\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1710966154475523.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1710428568474713.442)
,p_display_sequence=>10
,p_display_value=>unistr('\9759\7684')
,p_return_value=>'STATIC'
,p_help_text=>unistr('<p>\9078\629E\30EA\30B9\30C8\304B\3089\9759\7684\306A\56FD\3092\4F7F\7528\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1711762868476607.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1710428568474713.442)
,p_display_sequence=>20
,p_display_value=>unistr('\30A2\30A4\30C6\30E0')
,p_return_value=>'ITEM'
,p_help_text=>unistr('<p>\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\307E\305F\306F\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\304B\3089\56FD\3092\53D6\5F97\3057\307E\3059\3002\30A2\30A4\30C6\30E0\306B\306F\3001\56FD\306E2\6841\306EISO\30B3\30FC\30C9\304C\542B\307E\308C\3066\3044\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1712263798480014.442)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>40
,p_prompt=>unistr('\56FD')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1710428568474713.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ITEM'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('<li><strong>US</strong>: \7C73\56FD</li>'),
unistr('<li><strong>UK</strong>: \82F1\56FD</li>'),
unistr('<li><strong>DE</strong>: \30C9\30A4\30C4</li>'),
unistr('<li><strong>AT</strong>: \30AA\30FC\30B9\30C8\30EA\30A2</li>'),
'</ul>'))
,p_help_text=>unistr('<p>\30B8\30AA\30B3\30FC\30C7\30A3\30F3\30B0\3059\308B\56FD\3092\53D6\5F97\3059\308B\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\9078\629E\3057\307E\3059\3002\30A2\30A4\30C6\30E0\306B\306F\3001\56FD\306E2\6841\306EISO\30B3\30FC\30C9\304C\542B\307E\308C\3066\3044\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1712712695483947.442)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>50
,p_prompt=>unistr('\56FD')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'US'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1710428568474713.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>\30B8\30AA\30B3\30FC\30C7\30A3\30F3\30B0\306B\4F7F\7528\3059\308B\56FD\3092\9078\629E\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1713260223484493.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.442)
,p_display_sequence=>10
,p_display_value=>unistr('\7C73\56FD')
,p_return_value=>'US'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1713640362485278.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.442)
,p_display_sequence=>20
,p_display_value=>unistr('\30A4\30AE\30EA\30B9')
,p_return_value=>'UK'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1714942400488162.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.442)
,p_display_sequence=>30
,p_display_value=>unistr('\30C9\30A4\30C4')
,p_return_value=>'DE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1715315187488602.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.442)
,p_display_sequence=>40
,p_display_value=>unistr('\30D5\30E9\30F3\30B9')
,p_return_value=>'FR'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1715776600489110.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.442)
,p_display_sequence=>50
,p_display_value=>unistr('\30A4\30BF\30EA\30A2')
,p_return_value=>'IT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1732218107588818.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.442)
,p_display_sequence=>60
,p_display_value=>unistr('\30AB\30CA\30C0')
,p_return_value=>'CA'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1732613691589456.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.442)
,p_display_sequence=>70
,p_display_value=>unistr('\30AA\30E9\30F3\30C0')
,p_return_value=>'NL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1733039072590094.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.442)
,p_display_sequence=>80
,p_display_value=>unistr('\30D9\30EB\30AE\30FC')
,p_return_value=>'BE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1733467346590779.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.442)
,p_display_sequence=>90
,p_display_value=>unistr('\30AA\30FC\30B9\30C8\30EA\30A2')
,p_return_value=>'AT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1733819745591632.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.442)
,p_display_sequence=>100
,p_display_value=>unistr('\30B9\30A4\30B9')
,p_return_value=>'CH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1734205667592050.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.442)
,p_display_sequence=>110
,p_display_value=>unistr('\30B9\30DA\30A4\30F3')
,p_return_value=>'ES'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1734685684592583.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.442)
,p_display_sequence=>120
,p_display_value=>unistr('\30DD\30EB\30C8\30AC\30EB')
,p_return_value=>'PT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1735060793593960.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.442)
,p_display_sequence=>130
,p_display_value=>unistr('\30ED\30B7\30A2\9023\90A6')
,p_return_value=>'RU'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1735422526594737.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.442)
,p_display_sequence=>140
,p_display_value=>unistr('\30A8\30B9\30C8\30CB\30A2')
,p_return_value=>'EE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1735848786595289.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.442)
,p_display_sequence=>150
,p_display_value=>unistr('\30A4\30F3\30C9')
,p_return_value=>'IN'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1736299306596060.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.442)
,p_display_sequence=>160
,p_display_value=>unistr('\30E1\30AD\30B7\30B3')
,p_return_value=>'MX'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1736643807596659.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.442)
,p_display_sequence=>170
,p_display_value=>unistr('\30AA\30FC\30B9\30C8\30E9\30EA\30A2')
,p_return_value=>'AU'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1737040872597462.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.442)
,p_display_sequence=>180
,p_display_value=>unistr('\30D6\30E9\30B8\30EB')
,p_return_value=>'BR'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1737421643598208.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.442)
,p_display_sequence=>190
,p_display_value=>unistr('\30C1\30EA')
,p_return_value=>'CL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1737878315598644.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.442)
,p_display_sequence=>200
,p_display_value=>unistr('\30C1\30A7\30B3\5171\548C\56FD')
,p_return_value=>'CZ'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1738298290599154.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.442)
,p_display_sequence=>210
,p_display_value=>unistr('\30CE\30EB\30A6\30A7\30FC')
,p_return_value=>'NO'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1738640811599640.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.442)
,p_display_sequence=>220
,p_display_value=>unistr('\30D5\30A3\30F3\30E9\30F3\30C9')
,p_return_value=>'FI'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1739045295600254.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.442)
,p_display_sequence=>230
,p_display_value=>unistr('\30C7\30F3\30DE\30FC\30AF')
,p_return_value=>'DK'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1739492220600840.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.442)
,p_display_sequence=>240
,p_display_value=>unistr('\9999\6E2F')
,p_return_value=>'HK'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1739888238601924.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.442)
,p_display_sequence=>250
,p_display_value=>unistr('\30A2\30A4\30EB\30E9\30F3\30C9')
,p_return_value=>'IE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1740248023602467.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.442)
,p_display_sequence=>260
,p_display_value=>unistr('\30E9\30C8\30D3\30A2')
,p_return_value=>'LV'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1740660821603187.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.442)
,p_display_sequence=>270
,p_display_value=>unistr('\30EB\30FC\30DE\30CB\30A2')
,p_return_value=>'RO'
);
end;
/
begin
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1741021923603709.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.442)
,p_display_sequence=>280
,p_display_value=>unistr('\30B3\30ED\30F3\30D3\30A2')
,p_return_value=>'CO'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1741493695604368.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.442)
,p_display_sequence=>290
,p_display_value=>unistr('\30DD\30FC\30E9\30F3\30C9')
,p_return_value=>'PL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1741819445604954.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.442)
,p_display_sequence=>300
,p_display_value=>unistr('\30A2\30E9\30D6\9996\9577\56FD\9023\90A6')
,p_return_value=>'AE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1742273782605774.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.442)
,p_display_sequence=>310
,p_display_value=>unistr('\30CF\30F3\30AC\30EA\30FC')
,p_return_value=>'HU'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1742644763606445.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.442)
,p_display_sequence=>320
,p_display_value=>unistr('\30B5\30A6\30B8\30A2\30E9\30D3\30A2')
,p_return_value=>'SA'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1743094899606998.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.442)
,p_display_sequence=>330
,p_display_value=>unistr('\5357\30A2\30D5\30EA\30AB')
,p_return_value=>'ZA'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1716542235497108.442)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>70
,p_prompt=>unistr('\4F4F\6240\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>unistr('<p>\30AB\30F3\30DE\3067\533A\5207\3063\305F\975E\69CB\9020\5316\4F4F\6240\306E\90E8\5206\3092\542B\3080\30A2\30A4\30C6\30E0\3092\9078\629E\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1720233540512149.442)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>80
,p_prompt=>unistr('\901A\308A\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>\4F4F\6240\306E<em>\901A\308A</em>\90E8\5206\3092\542B\3080\30A2\30A4\30C6\30E0\3092\9078\629E\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1720738899514712.442)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>90
,p_prompt=>unistr('\756A\5730\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>\4F4F\6240\306E<em>\756A\5730</em>\90E8\5206\3092\542B\3080\30A2\30A4\30C6\30E0\3092\9078\629E\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1721280838517001.442)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>120
,p_prompt=>unistr('\5E02\306E\30B5\30D6\30A8\30EA\30A2\30FB\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>\4F4F\6240\306E<em>\30B5\30D6\30A8\30EA\30A2(\5E02\5185)</em>\90E8\5206\3092\542B\3080\30A2\30A4\30C6\30E0\3092\9078\629E\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1721711111518708.442)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>110
,p_prompt=>unistr('\5E02\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>\4F4F\6240\306E<em>\5E02</em>\90E8\5206\3092\542B\3080\30A2\30A4\30C6\30E0\3092\9078\629E\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1722254500520558.442)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('\90F5\4FBF\756A\53F7\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>\4F4F\6240\306E<em>\90F5\4FBF\756A\53F7</em>\90E8\5206\3092\542B\3080\30A2\30A4\30C6\30E0\3092\9078\629E\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1722749669524835.442)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>130
,p_prompt=>unistr('\5730\57DF\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>\4F4F\6240\306E<em>\5730\57DF(\5DDE)</em>\90E8\5206\3092\542B\3080\30A2\30A4\30C6\30E0\3092\9078\629E\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1723298553527158.442)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>65
,p_prompt=>unistr('\4F4F\6240\306E\30B5\30CB\30BF\30A4\30BA')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>\3053\306E\30B9\30A4\30C3\30C1\3092\6709\52B9\306B\3059\308B\3068\3001\4F4F\6240\30C7\30FC\30BF\304C\30B8\30AA\30B3\30FC\30C7\30A3\30F3\30B0\30FB\30B5\30FC\30D3\30B9\304B\3089\30DE\30C3\30D7\3055\308C\305F\30A2\30A4\30C6\30E0\306B\30D5\30A3\30FC\30C9\30D0\30C3\30AF\3055\308C\307E\3059\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1727004690548379.442)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>135
,p_prompt=>unistr('\4E00\81F4\30D9\30AF\30C8\30EB\30FB\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30B8\30AA\30B3\30FC\30C0\304C<em>\4E00\81F4\30D9\30AF\30C8\30EB</em>\3092\8FD4\3059\5148\306E\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3092\9078\629E\3057\307E\3059\3002\4E00\81F4\30D9\30AF\30C8\30EB\306F17\6841\306E\6587\5B57\5217\3067\3001\5404\4F4F\6240\5C5E\6027\304C\30B8\30AA\30B3\30FC\30C7\30A3\30F3\30B0\306B\4F7F\7528\3055\308C\308B\30C7\30FC\30BF\3068\3069\306E\3088\3046\306B\4E00\81F4\3057\305F\304B\306B\95A2\3059\308B\8A73\7D30\60C5\5831\304C\542B\307E\308C\3066\3044\307E\3059\3002</p>'),
unistr('<p><strong>\4E00\81F4\30D9\30AF\30C8\30EB\306E\5404\6841\306B\306F\6B21\306E\5024\304C\4F7F\7528\3055\308C\307E\3059:</strong></p>'),
'<ul>',
unistr('<li><p>0: \5165\529B\5C5E\6027\306Fnull\3067\306F\306A\304F\3001null\4EE5\5916\306E\5024\3068\4E00\81F4\3057\307E\3059\3002</p></li>'),
unistr('<li><p>1: \5165\529B\5C5E\6027\306Fnull\3067\3001null\5024\3068\4E00\81F4\3057\307E\3059\3002</p></li>'),
unistr('<li><p>2: \5165\529B\5C5E\6027\306Fnull\3067\306F\306A\304F\3001\5225\306Enull\4EE5\5916\306E\5024\3067\7F6E\304D\63DB\3048\3089\308C\307E\3059\3002</p></li>'),
unistr('<li><p>3: \5165\529B\5C5E\6027\306Fnull\3067\306F\306A\304F\3001null\5024\3067\7F6E\304D\63DB\3048\3089\308C\307E\3059\3002</p></li>'),
unistr('<li><p>4: \5165\529B\5C5E\6027\306Fnull\3067\3001null\4EE5\5916\306E\5024\3067\7F6E\304D\63DB\3048\3089\308C\307E\3059\3002</p></li>'),
'</ul>',
'<br>',
unistr('<p><strong>\4E00\81F4\30D9\30AF\30C8\30EB\306E\5404\6841\3068\305D\308C\305E\308C\306B\5BFE\5FDC\3059\308B\4F4F\6240\5C5E\6027:</strong></p>'),
'<ul>',
unistr('<li><p>3: \4F4F\6240\30DD\30A4\30F3\30C8(\30B8\30AA\30B3\30FC\30C7\30A3\30F3\30B0\306B\4F7F\7528\3055\308C\308B\30C7\30FC\30BF\3067\4E00\81F4\3059\308B\6B63\78BA\306A\4F4F\6240)</p></li>'),
unistr('<li><p>4: \5BFE\8C61\5730\70B9(POI)\540D</p></li>'),
unistr('<li><p>5: \756A\5730</p></li>'),
unistr('<li><p>6: \901A\308A\306E\63A5\982D\8F9E</p></li>'),
unistr('<li><p>7: \901A\308A\306E\540D\524D</p></li>'),
unistr('<li><p>8: \901A\308A\306E\63A5\5C3E\8F9E</p></li>'),
unistr('<li><p>9: \901A\308A\306E\30BF\30A4\30D7</p></li>'),
unistr('<li><p>10:\90E8\5C4B\756A\53F7\7B49</p></li>'),
unistr('<li><p>11: \5E02</p></li>'),
unistr('<li><p>14: \5730\57DF</p></li>'),
unistr('<li><p>15: \56FD</p></li>'),
unistr('<li><p>16: \90F5\4FBF\756A\53F7</p></li>'),
unistr('<li><p>17: \90F5\4FBF\30A2\30C9\30AA\30F3\30B3\30FC\30C9</p></li>'),
unistr('<li><p><em>\4ED6\306E\6841\306F\307E\3060\4F7F\7528\3055\308C\3066\3044\307E\305B\3093\3002</em></p></li>'),
'</ul>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1727549870549765.442)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>unistr('\30B8\30AA\30B3\30FC\30C7\30A3\30F3\30B0\306E\30C8\30EA\30AC\30FC')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'AUTOMATIC'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>\30B8\30AA\30B3\30FC\30C7\30A3\30F3\30B0\3092\30C8\30EA\30AC\30FC\3059\308B\30BF\30A4\30DF\30F3\30B0\3092\6C7A\5B9A\3057\307E\3059\3002\3053\308C\306B\306F\3001\30D6\30E9\30A6\30B6\304C\30B8\30AA\30B3\30FC\30C7\30A3\30F3\30B0\30FB\30B5\30FC\30D3\30B9\3078\306EREST\30EA\30AF\30A8\30B9\30C8\3092\5B9F\884C\3057\3001\4E00\81F4\5019\88DC\3092\542B\3080\30DD\30C3\30D7\30A2\30C3\30D7\30FB\30A6\30A3\30F3\30C9\30A6\3092\8868\793A\3059\308B\3053\3068\304C\542B\307E\308C\307E\3059\3002</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1728048005551626.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1727549870549765.442)
,p_display_sequence=>10
,p_display_value=>unistr('\81EA\52D5')
,p_return_value=>'AUTOMATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30DA\30FC\30B8\304C\9001\4FE1\3055\308C\308B\524D\306B\3001\30B8\30AA\30B3\30FC\30C7\30A3\30F3\30B0\304C\81EA\52D5\7684\306B\30C8\30EA\30AC\30FC\3055\308C\307E\3059\3002</p>'),
unistr('<p>\4F9D\5B58\30A2\30A4\30C6\30E0\306E\5024\304C\5909\66F4\3055\308C(<em>P1_STREET</em>\306E\5024\306A\3069)\3001\305D\308C\307E\3067\306B\30B8\30AA\30B3\30FC\30C7\30A3\30F3\30B0\304C\5B9F\884C\3055\308C\3066\3044\306A\3044\304B\3001\6709\52B9\306A\4F4F\6240\304C\9078\629E\3055\308C\3066\3044\306A\3044\5834\5408\3001\5FC5\305A\30B8\30AA\30B3\30FC\30C7\30A3\30F3\30B0\304C\81EA\52D5\7684\306B\30C8\30EA\30AC\30FC\3055\308C\307E\3059\3002\3053\306E\5834\5408\3001\73FE\5728\306E\30DA\30FC\30B8\9001\4FE1\306E\9001\4FE1\30D5\30ED\30FC\306F\4E2D\65AD\3055\308C\3001\307E\305A\4E00\81F4\306E\5019\88DC\304C\30DD\30C3\30D7\30A2\30C3\30D7\30FB\30A6\30A3\30F3\30C9\30A6\306B\8868\793A\3055\308C\307E\3059\3002\30E6\30FC\30B6\30FC\304C\4E00\81F4\3059\308B\7D50\679C\3092\9078\629E\3057\305F\5834\5408\306F\3001\305D\308C\4EE5\4E0A\306E\4E2D\65AD\306A\3057\306B\30DA\30FC\30B8\3092\518D\9001\4FE1\3067\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1728439221554365.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1727549870549765.442)
,p_display_sequence=>20
,p_display_value=>unistr('\52D5\7684\30A2\30AF\30B7\30E7\30F3')
,p_return_value=>'DYNAMIC_ACTION'
,p_help_text=>unistr('<p>\30B8\30AA\30B3\30FC\30C7\30A3\30F3\30B0\306F\3001\52D5\7684\30A2\30AF\30B7\30E7\30F3<em>\300C\30B8\30AA\30B3\30FC\30C7\30A3\30F3\30B0\306E\30C8\30EA\30AC\30FC\300D</em>\3092\30DA\30FC\30B8\306B\8FFD\52A0\3059\308B\3053\3068\306B\3088\3063\3066\30C8\30EA\30AC\30FC\3055\308C\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1728803167561342.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1727549870549765.442)
,p_display_sequence=>30
,p_display_value=>unistr('jQuery\30BB\30EC\30AF\30BF')
,p_return_value=>'JQUERY_SELECTOR'
,p_help_text=>unistr('<p>\30B8\30AA\30B3\30FC\30C7\30A3\30F3\30B0\306F\3001\30BB\30EC\30AF\30BF\306E\30BF\30FC\30B2\30C3\30C8\306EDOM\8981\7D20\306B\5BFE\3059\308B\30A4\30D9\30F3\30C8\306B\57FA\3065\3044\3066\30C8\30EA\30AC\30FC\3055\308C\307E\3059\3002\5165\529B\30D5\30A3\30FC\30EB\30C9\304C\53C2\7167\3055\308C\3066\3044\308B\5834\5408\3001\30B8\30AA\30B3\30FC\30C7\30A3\30F3\30B0\306F\3001\8981\7D20\306E<em>\5909\66F4</em>\3067\30C8\30EA\30AC\30FC\3055\308C\3001\30DC\30BF\30F3\304C\53C2\7167\3055\308C\3066\3044\308B\5834\5408\3001\30B8\30AA\30B3\30FC\30C7\30A3\30F3\30B0\306F\3001<em>\30AF\30EA\30C3\30AF</em>\3067\30C8\30EA\30AC\30FC\3055\308C\307E\3059\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1747463542804307.442)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>unistr('\30BB\30EC\30AF\30BF')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1727549870549765.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'JQUERY_SELECTOR'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30A2\30A4\30C6\30E0<em>P1_STREET</em>\304A\3088\3073<em>P1_ZIP_CODE</em>\304C\5909\66F4\3055\308C\305F\5834\5408\306B\30D7\30ED\30BB\30B9\3092\5B9F\884C\3057\307E\3059\3002jQuery\30BB\30EC\30AF\30BF:</p>'),
'<pre>',
'#P1_STREET,#P1_ZIP_CODE',
'</pre>'))
,p_help_text=>unistr('<p>\30B8\30AA\30B3\30FC\30C7\30A3\30F3\30B0\3092\30C8\30EA\30AC\30FC\3059\308B\8981\7D20\3092\53C2\7167\3059\308BjQuery\30BB\30EC\30AF\30BF\3092\6307\5B9A\3057\307E\3059\3002\30DC\30BF\30F3\306F<em>\30AF\30EA\30C3\30AF</em>\3067\30B8\30AA\30B3\30FC\30C7\30A3\30F3\30B0\3092\30C8\30EA\30AC\30FC\3057\3001\4ED6\306E\8981\7D20\306F<em>\5909\66F4</em>\3067\30C8\30EA\30AC\30FC\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(12982963519254231.442)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.442)
,p_name=>'apexgeocoderresponse'
,p_display_name=>unistr('\30B8\30AA\30B3\30FC\30C7\30A3\30F3\30B0\30FB\30EC\30B9\30DD\30F3\30B9')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(12982639254254214.442)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.442)
,p_name=>'apexgeocoderselection'
,p_display_name=>unistr('\7D50\679C\306E\9078\629E')
);
end;
/
prompt --application/shared_components/plugins/region_type/smart_filters
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1800664597261423.442)
,p_plugin_type=>'REGION TYPE'
,p_name=>'SMART_FILTERS'
,p_display_name=>unistr('\30B9\30DE\30FC\30C8\30FB\30D5\30A3\30EB\30BF')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','SMART_FILTERS'),'')
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('<p>\95A2\9023\3059\308B\30B9\30DE\30FC\30C8\30FB\30D5\30A3\30EB\30BF\306E\30BD\30FC\30B9\306B\57FA\3065\304F\30EA\30FC\30B8\30E7\30F3\3002\5B9F\884C\6642\306B\691C\7D22\7D50\679C\3092\7D5E\308A\8FBC\3080\305F\3081\306B\4F7F\7528\3055\308C\308B\591A\6570\306E\30D5\30A3\30EB\30BF\3092\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\63D0\4F9B\3057\307E\3059\3002</p>')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1816085788971276.442)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\6700\5927\30B5\30B8\30A7\30B9\30C1\30E7\30F3\30FB\30C1\30C3\30D7')
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>unistr('\8868\793A\3055\308C\308B\30B5\30B8\30A7\30B9\30C1\30E7\30F3\30FB\30C1\30C3\30D7\306E\6700\5927\6570\3092\6307\5B9A\3057\307E\3059\3002\6307\5B9A\3057\306A\3044\5834\5408\306F\3001\30C7\30D5\30A9\30EB\30C8\306E5\304C\4F7F\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1816321935999387.442)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\305D\306E\4ED6\306E\30D5\30A3\30EB\30BF\30FB\30B5\30B8\30A7\30B9\30C1\30E7\30F3\30FB\30C1\30C3\30D7')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\30B5\30B8\30A7\30B9\30C1\30E7\30F3\30FB\30C1\30C3\30D7\3068\3057\3066\8868\793A\3055\308C\306A\3044\30D5\30A3\30EB\30BF\3092\300C\305D\306E\4ED6\306E\30D5\30A3\30EB\30BF\300D\30C9\30ED\30C3\30D7\30C0\30A6\30F3\30FB\30E1\30CB\30E5\30FC\30FB\30DC\30BF\30F3\304B\3089\9078\629E\3067\304D\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1808803156261456.442)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\30B3\30F3\30D1\30AF\30C8\306A\6570\5024\306E\3057\304D\3044\5024')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'10000'
,p_display_length=>10
,p_max_length=>10
,p_is_translatable=>false
,p_help_text=>unistr('\4E0A\9650\3092\8D85\3048\305F\5834\5408\306B\3001\30B3\30F3\30D1\30AF\30C8\306A\6570\5024\5F62\5F0F\3067\30AB\30A6\30F3\30C8\3092\8868\793A\3059\308B\3057\304D\3044\5024\3092\6307\5B9A\3057\307E\3059\3002\30B3\30F3\30D1\30AF\30C8\306A\6570\5024\5F62\5F0F\3067\306F\3001<strong>1,234</strong>\3068\3044\3046\5024\306F\3001<strong>1K</strong>\3068\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1801137838146661.442)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\7DCF\884C\6570\306E\8868\793A')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\5408\8A08\884C\6570\306E\8868\793A\5834\6240\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1801499572149580.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1801137838146661.442)
,p_display_sequence=>10
,p_display_value=>unistr('\3044\3044\3048')
,p_return_value=>'N'
,p_help_text=>unistr('\7DCF\884C\6570\306F\8868\793A\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1801880772227865.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1801137838146661.442)
,p_display_sequence=>20
,p_display_value=>unistr('\306F\3044')
,p_return_value=>'Y'
,p_help_text=>unistr('\7DCF\884C\6570\304C\3001\30B5\30B8\30A7\30B9\30C1\30E7\30F3\30FB\30C1\30C3\30D7\306E\4E0B\306B\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1802207279232480.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1801137838146661.442)
,p_display_sequence=>30
,p_display_value=>unistr('\30BB\30EC\30AF\30BF')
,p_return_value=>'E'
,p_help_text=>unistr('\7DCF\884C\6570(\30E9\30D9\30EB\306A\3057)\304C\3001\3053\306E\30BB\30EC\30AF\30BF\3067\6307\5B9A\3055\308C\305F\8981\7D20\5185\306B\8868\793A\3055\308C\307E\3059\3002\3053\308C\306B\3088\308A\3001\7DCF\884C\6570\3092\30DA\30FC\30B8\4E0A\306E\307B\307C\4EFB\610F\306E\5834\6240\306B\914D\7F6E\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1802866258261858.442)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\7DCF\884C\6570\30E9\30D9\30EB')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1801137838146661.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('\7DCF\884C\6570\306B\4F7F\7528\3059\308B\30E9\30D9\30EB\3002\3053\3053\3067\30E9\30D9\30EB\304C\6307\5B9A\3055\308C\3066\3044\306A\3044\5834\5408\3001APEX\306FAPEX.FS.TOTAL_ROW_COUNT_LABEL\30C6\30AD\30B9\30C8\30FB\30E1\30C3\30BB\30FC\30B8\3092\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1803111571268834.442)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\5408\8A08\884C\6570\30BB\30EC\30AF\30BF')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1801137838146661.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'E'
,p_examples=>'#totalRowCountSpan'
,p_help_text=>unistr('\3053\308C\306F\3001\30B9\30DE\30FC\30C8\30FB\30D5\30A3\30EB\30BF\30FB\30EA\30FC\30B8\30E7\30F3\304C\7DCF\884C\6570\3092\8868\793A\3059\308B\30DA\30FC\30B8\4E0A\306E\8981\7D20\306E\30BB\30EC\30AF\30BF\3067\3059\3002')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(1812244001261470.442)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.442)
,p_name=>'facetschange'
,p_display_name=>unistr('\30D5\30A3\30EB\30BF\5909\66F4')
);
end;
/
prompt --application/shared_components/plugins/web_source_type/oci
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1900426248156512.442)
,p_plugin_type=>'WEB SOURCE TYPE'
,p_name=>'OCI'
,p_display_name=>'OCI'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('WEB SOURCE TYPE','OCI'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/web_source_type/adfbc
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2200372246708480.442)
,p_plugin_type=>'WEB SOURCE TYPE'
,p_name=>'ADFBC'
,p_display_name=>'ADF BC'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('WEB SOURCE TYPE','ADFBC'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/web_source_type/ords
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2302882720656544.442)
,p_plugin_type=>'WEB SOURCE TYPE'
,p_name=>'ORDS'
,p_display_name=>'ORDS'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('WEB SOURCE TYPE','ORDS'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2700889063556536.442)
,p_plugin_id=>wwv_flow_api.id(2302882720656544.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\30EC\30AC\30B7\30FCORDS JSON\3092\8FD4\3059')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\3053\306EORDS REST\30B5\30FC\30D3\30B9\304C<em>ORDS\30EC\30AC\30B7\30FCJSON\5F62\5F0F</em>\3067\30C7\30FC\30BF\3092\8FD4\3059\5834\5408\3001\3053\308C\3092\6709\52B9\306B\3057\307E\3059\3002')
);
end;
/
prompt --application/shared_components/plugins/item_type/search
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2606845974894125.442)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'SEARCH'
,p_display_name=>unistr('\691C\7D22')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS:APEX_APPL_PAGE_SFILTERS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','SEARCH'),'')
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:PLACEHOLDER:ENCRYPT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\300C\30D5\30A1\30BB\30C3\30C8\691C\7D22\300D\30EA\30FC\30B8\30E7\30F3\306B\3042\308B\30D5\30A1\30BB\30C3\30C8\306E\30EA\30B9\30C8\30FB\30A8\30F3\30C8\30EA\3092\691C\7D22\3067\304D\308B\3088\3046\306B\3059\308B\30C6\30AD\30B9\30C8\30FB\30D5\30A3\30FC\30EB\30C9\3092\8868\793A\3057\307E\3059\3002\300C\30D5\30A1\30BB\30C3\30C8\691C\7D22\300D\30EA\30FC\30B8\30E7\30F3\3067\306F\30011\3064\306E\691C\7D22\30D5\30A1\30BB\30C3\30C8\304C\30B5\30DD\30FC\30C8\3055\308C\307E\3059(\3053\306E\691C\7D22\30D5\30A1\30BB\30C3\30C8\306F\3001\305D\306E\9806\5E8F\306B\304B\304B\308F\3089\305A\3001\5E38\306B\30D5\30A1\30BB\30C3\30C8\30FB\30EA\30B9\30C8\306E\4E00\756A\4E0A\306B\8868\793A\3055\308C\307E\3059)\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2607008165899744.442)
,p_plugin_id=>wwv_flow_api.id(2606845974894125.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\691C\7D22\30BF\30A4\30D7')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ROW'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2607312816901820.442)
,p_plugin_attribute_id=>wwv_flow_api.id(2607008165899744.442)
,p_display_sequence=>10
,p_display_value=>unistr('\884C\691C\7D22')
,p_return_value=>'ROW'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2607759273903144.442)
,p_plugin_attribute_id=>wwv_flow_api.id(2607008165899744.442)
,p_display_sequence=>20
,p_display_value=>'Oracle Text'
,p_return_value=>'ORACLE_TEXT'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2608156895911496.442)
,p_plugin_id=>wwv_flow_api.id(2606845974894125.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\5165\529B\30D5\30A3\30FC\30EB\30C9')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FACET'
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2608417903912546.442)
,p_plugin_attribute_id=>wwv_flow_api.id(2608156895911496.442)
,p_display_sequence=>10
,p_display_value=>unistr('\30D5\30A1\30BB\30C3\30C8\691C\7D22\30EA\30FC\30B8\30E7\30F3\306E\6700\4E0A\90E8')
,p_return_value=>'FACET'
,p_help_text=>unistr('\691C\7D22\30D5\30A3\30FC\30EB\30C9\306F\3001\30D5\30A1\30BB\30C3\30C8\691C\7D22\30EA\30FC\30B8\30E7\30F3\306E\4E00\756A\4E0A\306B\3042\308B\30D5\30A1\30BB\30C3\30C8\306E\4E0A\306B\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2608887428914009.442)
,p_plugin_attribute_id=>wwv_flow_api.id(2608156895911496.442)
,p_display_sequence=>20
,p_display_value=>unistr('\5916\90E8\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0')
,p_return_value=>'PAGE_ITEM'
,p_help_text=>unistr('\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306F\3001\30D5\30A1\30BB\30C3\30C8\691C\7D22\30EA\30FC\30B8\30E7\30F3\306E\691C\7D22\30D5\30A3\30FC\30EB\30C9\3068\3057\3066\4F7F\7528\3055\308C\308B\3001\95A2\9023\4ED8\3051\3089\308C\305F\5916\90E8\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\5C5E\6027\3092\4F7F\7528\3057\3066\9078\629E\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2609288187919863.442)
,p_plugin_id=>wwv_flow_api.id(2606845974894125.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\5916\90E8\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2608156895911496.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PAGE_ITEM'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2205297904876322.442)
,p_plugin_id=>wwv_flow_api.id(2606845974894125.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\7E2E\5C0F\3055\308C\305F\691C\7D22\30D5\30A3\30FC\30EB\30C9')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPL_PAGE_SFILTERS'
,p_is_translatable=>false
,p_help_text=>unistr('\30B9\30DE\30FC\30C8\30FB\30D5\30A3\30EB\30BF\306E\691C\7D22\30D5\30A3\30FC\30EB\30C9\304C\6700\521D\306B\7E2E\5C0F\3055\308C\3066\3044\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
end;
/
prompt --application/shared_components/plugins/region_type/map_region
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2801375174221512.442)
,p_plugin_type=>'REGION TYPE'
,p_name=>'MAP_REGION'
,p_display_name=>unistr('\30DE\30C3\30D7')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','MAP_REGION'),'')
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#libraries/mapbox-gl-js/1.13.0/mapbox-gl.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.spatialMap#MIN#.js'))
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#libraries/mapbox-gl-js/1.13.0/mapbox-gl-apex.css',
''))
,p_api_version=>2
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(2801502987221529.442)
,p_plugin_id=>wwv_flow_api.id(2801375174221512.442)
,p_name=>'SOURCE_LOCATION'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(2501189800179937.442)
,p_plugin_id=>wwv_flow_api.id(2801375174221512.442)
,p_name=>'spatialmapchanged'
,p_display_name=>unistr('\30DE\30C3\30D7\304C\5909\66F4\3055\308C\307E\3057\305F')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(2501913148179938.442)
,p_plugin_id=>wwv_flow_api.id(2801375174221512.442)
,p_name=>'spatialmapclick'
,p_display_name=>unistr('\30DE\30C3\30D7\304C\30AF\30EA\30C3\30AF\3055\308C\307E\3057\305F')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(2500840574179919.442)
,p_plugin_id=>wwv_flow_api.id(2801375174221512.442)
,p_name=>'spatialmapinitialized'
,p_display_name=>unistr('\30DE\30C3\30D7\304C\521D\671F\5316\3055\308C\307E\3057\305F')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(2501516390179938.442)
,p_plugin_id=>wwv_flow_api.id(2801375174221512.442)
,p_name=>'spatialmapobjectclick'
,p_display_name=>unistr('\30DE\30C3\30D7\30FB\30AA\30D6\30B8\30A7\30AF\30C8\304C\30AF\30EA\30C3\30AF\3055\308C\307E\3057\305F')
);
end;
/
prompt --application/shared_components/plugins/region_type/form
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3128550315022076.442)
,p_plugin_type=>'REGION TYPE'
,p_name=>'FORM'
,p_display_name=>unistr('\30D5\30A9\30FC\30E0')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','FORM'),'')
,p_api_version=>2
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:EDITABLE'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\7570\306A\308B\30C7\30FC\30BF\30FB\30BD\30FC\30B9\3092\30B5\30DD\30FC\30C8\3059\308B\30D5\30A9\30FC\30E0\30FB\30EA\30FC\30B8\30E7\30F3\3002\3053\306E\30D5\30A9\30FC\30E0\30FB\30EA\30FC\30B8\30E7\30F3\306B\306F\3001\30C7\30FC\30BF\30FB\30BD\30FC\30B9(\30ED\30FC\30AB\30EB\3001\30EA\30E2\30FC\30C8\307E\305F\306FREST\30B5\30FC\30D3\30B9)\306E\60C5\5831\304C\683C\7D0D\3055\308C\3001\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\304C\5272\308A\5F53\3066\3089\308C\307E\3059\3002\5404\30A2\30A4\30C6\30E0\306F\3001\30D5\30A9\30FC\30E0\30FB\30EA\30FC\30B8\30E7\30F3\3068\8868\793A\30EA\30FC\30B8\30E7\30F3\306B\5272\308A\5F53\3066\3089\308C\307E\3059\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(3128740851022088.442)
,p_plugin_id=>wwv_flow_api.id(3128550315022076.442)
,p_name=>'SOURCE_LOCATION'
);
end;
/
prompt --application/shared_components/plugins/process_type/form_dml
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3129968725049081.442)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_DML'
,p_display_name=>unistr('\30D5\30A9\30FC\30E0 - \884C\306E\81EA\52D5\51E6\7406(DML)')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_DML'),'')
,p_api_version=>2
,p_standard_attributes=>'FORM'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\30D5\30A9\30FC\30E0\30FB\30EA\30FC\30B8\30E7\30F3\306E\884C\3092\633F\5165\3001\66F4\65B0\307E\305F\306F\524A\9664\3059\308B\30D7\30ED\30BB\30B9\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3130191485054761.442)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\30BF\30FC\30B2\30C3\30C8\30FB\30BF\30A4\30D7')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'REGION_SOURCE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\30D5\30A9\30FC\30E0\30FB\30EA\30FC\30B8\30E7\30F3\306B\884C\308F\308C\305F\30C7\30FC\30BF\5909\66F4\3092\4FDD\5B58\3059\308B\305F\3081\306B\5B9F\884C\3059\308B\884C\51E6\7406\65B9\6CD5\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3130418909057477.442)
,p_plugin_attribute_id=>wwv_flow_api.id(3130191485054761.442)
,p_display_sequence=>10
,p_display_value=>unistr('\30EA\30FC\30B8\30E7\30F3\30FB\30BD\30FC\30B9')
,p_return_value=>'REGION_SOURCE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30EA\30FC\30B8\30E7\30F3\30FB\30BD\30FC\30B9SQL\554F\5408\305B\306E\5229\7528\3092\633F\5165\3001\66F4\65B0\304A\3088\3073\524A\9664\3057\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8 - \51E6\7406\304B\3089\9664\5916\3059\308B\305F\3081\3001\633F\5165\53EF\80FD\307E\305F\306F\66F4\65B0\53EF\80FD\3067\306A\3044\5217\306E<strong>\300C\554F\5408\305B\306E\307F\300D</strong>\304C<code>Yes</code>\306B\8A2D\5B9A\3055\308C\3066\3044\308B\3053\3068\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3131111455059474.442)
,p_plugin_attribute_id=>wwv_flow_api.id(3130191485054761.442)
,p_display_sequence=>20
,p_display_value=>unistr('\8868/\30D3\30E5\30FC')
,p_return_value=>'TABLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30EA\30FC\30B8\30E7\30F3\30FB\30BD\30FC\30B9SQL\554F\5408\305B\3067\5B9A\7FA9\3055\308C\3066\3044\306A\3044\5225\306E\8868\307E\305F\306F\30D3\30E5\30FC\306E\5229\7528\3092\633F\5165\3001\66F4\65B0\304A\3088\3073\524A\9664\3057\307E\3059\3002'),
unistr('\305F\3068\3048\3070\3001SQL\554F\5408\305B\3067\8868\7D50\5408\307E\305F\306F\66F4\65B0\53EF\80FD\3067\306A\3044\30D3\30E5\30FC\304B\3089\30C7\30FC\30BF\3092\53D6\5F97\3059\308B\3068\3001DML\51E6\7406\3092\5358\4E00\306E\30D9\30FC\30B9\8868\307E\305F\306F\66F4\65B0\53EF\80FD\306A\30D3\30E5\30FC\306B\5BFE\3057\3066\5B9F\884C\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8 - \51E6\7406\304B\3089\9664\5916\3059\308B\305F\3081\3001\633F\5165\53EF\80FD\307E\305F\306F\66F4\65B0\53EF\80FD\3067\306A\3044\5217\306E<strong>\300C\554F\5408\305B\306E\307F\300D</strong>\304C<code>Yes</code>\306B\8A2D\5B9A\3055\308C\3066\3044\308B\3053\3068\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3131849869061275.442)
,p_plugin_attribute_id=>wwv_flow_api.id(3130191485054761.442)
,p_display_sequence=>30
,p_display_value=>unistr('PL/SQL\30B3\30FC\30C9')
,p_return_value=>'PLSQL_CODE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\51E6\7406\306F\3001\30AB\30B9\30BF\30E0PL/SQL\30B3\30FC\30C9\306B\57FA\3065\3044\3066\3044\307E\3059\3002\3053\306E\30AA\30D7\30B7\30E7\30F3\306B\3088\308A\3001PL/SQL\30B3\30FC\30C9\3092\5B9F\884C\3057\3066\57FA\790E\3068\306A\308B\30C7\30FC\30BF\30D9\30FC\30B9\306E\30C7\30FC\30BF\64CD\4F5C\3092\5B9F\88C5\3067\304D\307E\3059\3002</p>'),
unistr('<p>\8868API\307E\305F\306FRESTful Web\30B5\30FC\30D3\30B9\3078\306E\30B3\30FC\30EB\306A\3069\306E\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30D1\30C3\30B1\30FC\30B8\3092\4F7F\7528\3057\3066\30D3\30B8\30CD\30B9\30FB\30ED\30B8\30C3\30AF\3092\5B9F\88C5\3059\308B\5834\5408\3001\3053\306E\30AA\30D7\30B7\30E7\30F3\3092\5229\7528\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8 - \633F\5165\3001\66F4\65B0\307E\305F\306F\524A\9664\3055\308C\305F\5404\884C\306B\5BFE\3057\3066\3001PL/SQL\30B3\30FC\30C9\304C\30B3\30FC\30EB\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3132468628068159.442)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\8868\306E\6240\6709\8005')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3130191485054761.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TABLE'
,p_help_text=>unistr('\8868\306E\6240\6709\8005(\30B9\30AD\30FC\30DE)\540D\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3132746852071841.442)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\8868\540D')
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(3132468628068159.442)
,p_depending_on_attribute_id=>wwv_flow_api.id(3130191485054761.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TABLE'
,p_help_text=>unistr('\5927/\5C0F\6587\5B57\3092\533A\5225\3057\305F\8868\307E\305F\306F\30D3\30E5\30FC\306E\540D\524D\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3133042217093897.442)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\633F\5165/\66F4\65B0/\524A\9664\3059\308BPL/SQL\30B3\30FC\30C9')
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3130191485054761.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL_CODE'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'begin',
'    case :APEX$ROW_STATUS',
'    when ''C'' then',
'        insert into emp ( empno, ename, deptno )',
'        values ( :EMPNO, :ENAME, :DEPTNO )',
'        returning rowid into :ROWID;',
'    when ''U'' then',
'        update emp',
'           set ename  = :ENAME,',
'               deptno = :DEPTNO',
'         where rowid  = :ROWID;',
'    when ''D'' then',
'        delete emp',
'         where rowid = :ROWID;',
'    end case;',
'end;',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>PL/SQL\30B3\30FC\30C9\3092\5165\529B\3057\3066\3001\30D5\30A9\30FC\30E0\30FB\30EA\30FC\30B8\30E7\30F3\3067\64CD\4F5C\3055\308C\308B\5404\884C\306E\30C7\30FC\30BF\3092\51E6\7406\3057\307E\3059\3002</p>'),
unistr('<p>\5217\306E\5024\306B\30A2\30AF\30BB\30B9\3059\308B\305F\3081\306E\30D0\30A4\30F3\30C9\5909\6570\3068\3057\3066\5217\540D\3092\4F7F\7528\3057\307E\3059\3002\30B7\30B9\30C6\30E0\5909\6570<code>APEX$ROW_STATUS</code>\3067\306F\3001\884C\306E\30B9\30C6\30FC\30BF\30B9\304C\8FD4\3055\308C\308B\305F\3081\3001\884C\304C\4F5C\6210\3001\66F4\65B0\307E\305F\306F\524A\9664\3055\308C\305F\304B\3069\3046\304B\3092\78BA\8A8D\3059\308B\305F\3081\306B\4F7F\7528\3067\304D\307E\3059(\3053\306E\78BA\8A8D\65B9\6CD5\306F\6B21\306E\4F8B\3092\53C2\7167\3057\3066\304F\3060\3055\3044)\3002</p>'),
unistr('<p><em>\30CE\30FC\30C8:</em> \4E3B\30AD\30FC\5217\304C\30C8\30EA\30AC\30FC\307E\305F\306FPL/SQL\30B3\30FC\30C9\3067\79FB\5165\3055\308C\308B\5834\5408\3001&PRODUCT_NAME.\306B\3088\3063\3066\633F\5165\307E\305F\306F\66F4\65B0\5F8C\306E\884C\306E\30D5\30A7\30C3\30C1\306B\4E3B\30AD\30FC\5217\304C\4F7F\7528\3055\308C\308B\305F\3081\3001\3053\308C\3089\306E\5217\306E\30D0\30A4\30F3\30C9\5909\6570\306B\65B0\3057\3044\5024\304C\5272\308A\5F53\3066\3089\308C\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>'),
unistr('<p>\518D\5229\7528\304A\3088\3073\30E1\30F3\30C6\30CA\30F3\30B9\6027\3092\9AD8\3081\308B\305F\3081\306BPL/SQL\30D1\30C3\30B1\30FC\30B8\5185\306E\30D7\30ED\30B7\30FC\30B8\30E3\307E\305F\306F\30D5\30A1\30F3\30AF\30B7\30E7\30F3\3092\30B3\30FC\30EB\3059\308B\3053\3068\3092\304A\85A6\3081\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3133532996097347.442)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\5931\308F\308C\305F\66F4\65B0\306E\9632\6B62')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8907\6570\306E\30E6\30FC\30B6\30FC\304C\540C\3058\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30EC\30B3\30FC\30C9\3092\66F4\65B0\3059\308B\5834\5408\306B\66F4\65B0\304C\5931\308F\308C\306A\3044\3053\3068\3092\78BA\8A8D\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002</p> '),
unistr('<p>2\4EBA\4EE5\4E0A\306E\30E6\30FC\30B6\30FC\304C\540C\3058\30C7\30FC\30BF\3092\66F4\65B0\3057\3088\3046\3068\3057\3001\5909\66F4\3092\4FDD\5B58\3059\308B\305F\3081\306B\6700\5F8C\306E\66F4\65B0\304C\6700\521D\306E\30E6\30FC\30B6\30FC\306E\66F4\65B0\3092\4E0A\66F8\304D\3059\308B\3068\3001\66F4\65B0\304C\5931\308F\308C\307E\3059\3002\3053\306E\767A\751F\3092\9632\6B62\3059\308B\306B\306F\3001\6700\521D\306E\884C\306E\554F\5408\305B\6642\306B\53D6\5F97\3057\305F\5024\3068\3068\3082\306B\30C7\30FC\30BF\30D9\30FC\30B9\306E\65E2\5B58\306E\5217\5024\3092\66F4\65B0\3067\78BA\8A8D\3067\304D\307E\3059\3002</p>'),
unistr('<p>\4F8B:'),
'  <ol>',
unistr('    <li>\30E6\30FC\30B6\30FCA\304C\5F93\696D\54E1(EMP)\30EC\30B3\30FC\30C9\3092\554F\3044\5408\305B\307E\3059\3002</li>'),
unistr('    <li>\30E6\30FC\30B6\30FCB\304C\540C\3058\5F93\696D\54E1\30EC\30B3\30FC\30C9\3092\554F\3044\5408\305B\307E\3059\3002</li>'),
unistr('    <li>\30E6\30FC\30B6\30FCB\304CEMPNO = 7839\306E\5F93\696D\54E1\8A73\7D30\3092\66F4\65B0\3057\3001\30C7\30FC\30BF\30D9\30FC\30B9\3078\306E\5909\66F4\3092\9069\7528(\30B3\30DF\30C3\30C8)\3057\307E\3059\3002</li>'),
unistr('    <li>\30E6\30FC\30B6\30FCA\304CEMPNO = 7839\306E\5F93\696D\54E1\8A73\7D30\3092\66F4\65B0\3057\3001\30C7\30FC\30BF\30D9\30FC\30B9\3078\306E\5909\66F4\3092\9069\7528\3057\3088\3046\3068\3057\307E\3059\3002</li>'),
'  </ol>',
unistr('\30E6\30FC\30B6\30FCA\304C\540C\3058\884C\3092\6B63\5E38\306B\66F4\65B0\3059\308B\3068\3001\30E6\30FC\30B6\30FCB\304C\884C\3063\305F\5909\66F4\304C\5931\308F\308C\307E\3059\3002'),
unistr('\30E6\30FC\30B6\30FCA\304C\5F93\696D\54E1\306E\884C\3092\4FDD\5B58\3057\3088\3046\3068\3059\308B\5834\5408\3001\30C7\30FC\30BF\30D9\30FC\30B9\306E\30C7\30FC\30BF\306F\30E6\30FC\30B6\30FCA\304C\6700\521D\306B\554F\3044\5408\305B\305F\5185\5BB9\3068\7570\306A\3063\3066\3044\307E\3059\3002\524D\8FF0\306E\624B\98061\3067\3001\30E6\30FC\30B6\30FCA\304C\6700\521D\306B\554F\3044\5408\305B\305F\5217\5024\3092\53D6\5F97\3067\304D\307E\3059\3002\524D\8FF0\306E\624B\98064\3067\3001\5024\3092\30C7\30FC\30BF\30D9\30FC\30B9\306E\73FE\5728\306E\5024\3068\6BD4\8F03\3067\304D\307E\3059\3002\30C7\30FC\30BF\30D9\30FC\30B9\5024\304C\624B\98063\3067\30E6\30FC\30B6\30FCB\306B\3088\3063\3066\66F4\65B0\3055\308C\305F\305F\3081\3001\3053\306E\6BD4\8F03\306B\3088\308A\3001\30E6\30FC\30B6\30FCA\306B\5BFE\3057\3066\30A8\30E9\30FC\304C\767A\751F\3057\307E\3059\3002\3053\308C\306B\3088\308A\3001\540C\3058\884C\306B\5BFE\3057\3066\5225\306E\30E6\30FC\30B6\30FC\304C\884C\3063\305F\5909\66F4\306E\4E0A\66F8\304D\304C\9632\6B62\3055\308C\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8 - \5931\308F\308C\305F\66F4\65B0\306E\691C\51FA\65B9\6CD5\306F\3001<strong>\300C\5931\308F\308C\305F\66F4\65B0\30BF\30A4\30D7\300D</strong>\306E\8A2D\5B9A\306B\57FA\3065\3044\3066\3001\5BFE\8A71\30B0\30EA\30C3\30C9\30FB\30EA\30FC\30B8\30E7\30F3\306E\5C5E\6027\3067\6307\5B9A\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3134090605099409.442)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\884C\306E\30ED\30C3\30AF')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>\51E6\7406\3059\308B\524D\306B\66F4\65B0\307E\305F\306F\524A\9664\3059\308B\5404\884C\3092\57FA\790E\3068\306A\308B\8868\3067\30ED\30C3\30AF\3059\308B\304B\3069\3046\304B\3092\9078\629E\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3134396093101055.442)
,p_plugin_attribute_id=>wwv_flow_api.id(3134090605099409.442)
,p_display_sequence=>10
,p_display_value=>unistr('\306F\3044')
,p_return_value=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30C8\30E9\30F3\30B6\30AF\30B7\30E7\30F3\304C\30B3\30DF\30C3\30C8\3055\308C\308B\307E\3067\884C\306E\4ED6\306E\30C8\30E9\30F3\30B6\30AF\30B7\30E7\30F3\306E\5B9F\884C\3092\9632\6B62\3059\308B\305F\3081\306B\3001SELECT ... FOR UPDATE\3092\4F7F\7528\3057\3066\66F4\65B0\307E\305F\306F\524A\9664\3059\308B\884C\304C\30ED\30C3\30AF\3055\308C\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8 - \30ED\30C3\30AF\3092\30B5\30DD\30FC\30C8\3057\3066\3044\306A\3044\66F4\65B0\53EF\80FD\306A\30D3\30E5\30FC\306A\3069\3067\30A8\30E9\30FC\304C\767A\751F\3059\308B\5834\5408\3001PL/SQL\30B3\30FC\30C9\3092\5229\7528\3057\3066\99C6\52D5\8868\3092\30ED\30C3\30AF\3067\304D\308B\53EF\80FD\6027\304C\3042\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3135017839102248.442)
,p_plugin_attribute_id=>wwv_flow_api.id(3134090605099409.442)
,p_display_sequence=>20
,p_display_value=>unistr('\3044\3044\3048')
,p_return_value=>'N'
,p_help_text=>unistr('\884C\304C\30ED\30C3\30AF\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3135486454103394.442)
,p_plugin_attribute_id=>wwv_flow_api.id(3134090605099409.442)
,p_display_sequence=>30
,p_display_value=>unistr('PL/SQL\30B3\30FC\30C9')
,p_return_value=>'PLSQL_CODE'
,p_help_text=>unistr('\30C8\30E9\30F3\30B6\30AF\30B7\30E7\30F3\304C\30B3\30DF\30C3\30C8\3055\308C\308B\307E\3067\3001\30AB\30B9\30BF\30E0PL/SQL\30B3\30FC\30C9\3092\4F7F\7528\3057\3066\884C\3092\30ED\30C3\30AF\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3136083157108563.442)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\884C\3092\30ED\30C3\30AF\3059\308BPL/SQL\30B3\30FC\30C9')
,p_attribute_type=>'PLSQL'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3134090605099409.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL_CODE'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'declare',
'    l_dummy number;',
'begin',
'    select 1',
'      into l_dummy',
'      from emp',
'     where empno = :EMPNO',
'       for update nowait;',
'end;',
'</pre>'))
,p_help_text=>unistr('PL/SQL\30B3\30FC\30C9\3092\5165\529B\3057\3066\3001\66F4\65B0\304A\3088\3073\524A\9664\3059\308B\30C7\30FC\30BF\30D9\30FC\30B9\8868\306E\884C\3092\30ED\30C3\30AF\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3136593347114047.442)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\633F\5165\5F8C\306B\4E3B\30AD\30FC\3092\8FD4\3059')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3130191485054761.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'REGION_SOURCE,TABLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\884C\304C\30C7\30FC\30BF\30D9\30FC\30B9\306B\633F\5165\3055\308C\305F\5F8C\306B\4E3B\30AD\30FC\5217\3092\5BFE\5FDC\3059\308B\30EA\30FC\30B8\30E7\30F3\30FB\30A2\30A4\30C6\30E0\306B\623B\3059\304B\3069\3046\304B\3092\9078\629E\3057\307E\3059\3002'),
unistr('\901A\5E38\3001\4E3B\30AD\30FC\5217\304C\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30C8\30EA\30AC\30FC\307E\305F\306FOracle Database 12 <em>c</em>\30A2\30A4\30C7\30F3\30C6\30A3\30C6\30A3\5217\304B\3089\79FB\5165\3055\308C\308B\5834\5408\3001\3053\306E\30AA\30D7\30B7\30E7\30F3\3092\4F7F\7528\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8 - RETURNING INTO\53E5\304C\8A31\53EF\3055\308C\3066\3044\306A\3044\3053\3068\3092\793A\3059\30A8\30E9\30FC\304C\767A\751F\3059\308B\5834\5408\3001\3053\306E\30AA\30D7\30B7\30E7\30F3\3092\300C\3044\3044\3048\300D\306B\8A2D\5B9A\3057\3001\4E3B\30AD\30FC\5217\3092\4E8B\524D\306B\79FB\5165\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>')))
);
end;
/
prompt --application/shared_components/plugins/process_type/form_init
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3136784192133583.442)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_INIT'
,p_display_name=>unistr('\30D5\30A9\30FC\30E0 - \521D\671F\5316')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_INIT'),'')
,p_api_version=>2
,p_standard_attributes=>'FORM'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\30D5\30A9\30FC\30E0\30FB\30EA\30FC\30B8\30E7\30F3\306E\30A2\30A4\30C6\30E0\3092\521D\671F\5316\3059\308B\30D7\30ED\30BB\30B9\3002\521D\671F\5316\306F\3001\4E3B\30AD\30FC\5024\3092\4F7F\7528\3057\305F\30EA\30FC\30B8\30E7\30F3\30FB\30BD\30FC\30B9\304B\3089\306E\30C7\30FC\30BF\306E\30D5\30A7\30C3\30C1\3067\3042\308B\304B\3001\30D5\30A9\30FC\30E0\30FB\30EA\30FC\30B8\30E7\30F3\306E\30A2\30A4\30C6\30E0\306E\5358\7D14\306A\521D\671F\5316\3067\3059\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1672950586323461.442)
,p_plugin_id=>wwv_flow_api.id(3136784192133583.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\6B21\306E\4E3B\30AD\30FC\30FB\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1673291445325769.442)
,p_plugin_id=>wwv_flow_api.id(3136784192133583.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\524D\306E\4E3B\30AD\30FC\30FB\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1673579797330204.442)
,p_plugin_id=>wwv_flow_api.id(3136784192133583.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\73FE\5728\306E\884C/\30A2\30A4\30C6\30E0\5408\8A08')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
);
end;
/
prompt --application/shared_components/plugins/process_type/data_loading
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3205849286768480.442)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'DATA_LOADING'
,p_display_name=>unistr('\30C7\30FC\30BF\306E\30ED\30FC\30C9')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','DATA_LOADING'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\6307\5B9A\3055\308C\305F\30C7\30FC\30BF\30FB\30ED\30FC\30C9\5B9A\7FA9\306B\57FA\3065\3044\3066\3001\30C7\30FC\30BF\3092\30BF\30FC\30B2\30C3\30C8\8868\307E\305F\306F\30B3\30EC\30AF\30B7\30E7\30F3\306B\30ED\30FC\30C9\3059\308B\30D7\30ED\30BB\30B9\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3206362206778771.442)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\30C7\30FC\30BF\30FB\30ED\30FC\30C9\5B9A\7FA9')
,p_attribute_type=>'DATA LOAD DEFINITION ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8\304B\3089<strong>\300C\30C7\30FC\30BF\30FB\30ED\30FC\30C9\5B9A\7FA9\300D</strong>\3092\9078\629E\3057\307E\3059\3002\4ED6\306E\5C5E\6027\306E\4E2D\3067\3001\30C7\30FC\30BF\30FB\30ED\30FC\30C9\5B9A\7FA9\306F\3001\30BF\30FC\30B2\30C3\30C8\8868\307E\305F\306F\30B3\30EC\30AF\30B7\30E7\30F3\3001\30ED\30FC\30C9\30FB\30E1\30BD\30C3\30C9\304A\3088\3073<em>\30C7\30FC\30BF\30FB\30D7\30ED\30D5\30A1\30A4\30EB</em>\3092\5B9A\7FA9\3057\307E\3059\3002\3059\3079\3066\306E\5217\540D\3001\5217\30DE\30C3\30D4\30F3\30B0\304A\3088\3073\30C7\30FC\30BF\578B\60C5\5831\304C\30C7\30FC\30BF\30FB\30D7\30ED\30D5\30A1\30A4\30EB\5185\306B\683C\7D0D\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3206568816782155.442)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\30BD\30FC\30B9\30FB\30C7\30FC\30BF\578B')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FILE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\30ED\30FC\30C9\3059\308B\30C7\30FC\30BF\306E\30BD\30FC\30B9\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3206878557783527.442)
,p_plugin_attribute_id=>wwv_flow_api.id(3206568816782155.442)
,p_display_sequence=>10
,p_display_value=>unistr('\30D5\30A1\30A4\30EB\53C2\7167\30A2\30A4\30C6\30E0')
,p_return_value=>'FILE'
,p_help_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8\3067\30D5\30A1\30A4\30EB\53C2\7167\30A2\30A4\30C6\30E0\306E\540D\524D\3092\9078\629E\3057\307E\3059\3002APEX\3067\306F\3001\9078\629E\3057\305F\30D5\30A1\30A4\30EB\304B\3089\30C7\30FC\30BF\304C\30ED\30FC\30C9\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3207319585784462.442)
,p_plugin_attribute_id=>wwv_flow_api.id(3206568816782155.442)
,p_display_sequence=>20
,p_display_value=>unistr('\30C6\30AD\30B9\30C8\9818\57DF\30A2\30A4\30C6\30E0\540D')
,p_return_value=>'TEXT'
,p_help_text=>unistr('\30ED\30FC\30C9\3059\308B\30C7\30FC\30BF\3092\542B\3080\30C6\30AD\30B9\30C8\9818\57DF\30A2\30A4\30C6\30E0\306E\540D\524D\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3207692626786156.442)
,p_plugin_attribute_id=>wwv_flow_api.id(3206568816782155.442)
,p_display_sequence=>30
,p_display_value=>unistr('SQL\554F\5408\305B')
,p_return_value=>'SQL_QUERY'
,p_help_text=>unistr('\30ED\30FC\30C9\3059\308B\30C7\30FC\30BF\3092\542B\3080CLOB\307E\305F\306FBLOB\3092\8FD4\3059SQL\554F\5408\305B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3208086445789769.442)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\30D5\30A1\30A4\30EB\53C2\7167\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3206568816782155.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'FILE'
,p_help_text=>unistr('\30C7\30FC\30BF\306E\30ED\30FC\30C9\5143\306E\30D5\30A1\30A4\30EB\53C2\7167\30A2\30A4\30C6\30E0\3092\9078\629E\3057\307E\3059\3002\30A2\30A4\30C6\30E0\306F\3001<strong>\8A18\61B6\57DF\30BF\30A4\30D7</strong>\3068\3057\3066<strong>APEX_APPLICATION_TEMP_FILES</strong>\3092\4F7F\7528\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3208411305791534.442)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\30C6\30AD\30B9\30C8\9818\57DF\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3206568816782155.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TEXT'
,p_help_text=>unistr('\30ED\30FC\30C9\3059\308B\30C7\30FC\30BF\3092\542B\3080\30C6\30AD\30B9\30C8\9818\57DF\30A2\30A4\30C6\30E0\306E\540D\524D\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3208742752793524.442)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('SQL\554F\5408\305B')
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_sql_min_column_count=>1
,p_sql_max_column_count=>1
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3206568816782155.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL_QUERY'
,p_help_text=>unistr('\30C7\30FC\30BF\306E\30ED\30FC\30C9\5143\306EBLOB\307E\305F\306FCLOB\3092\542B\30801\3064\306E\884C\304A\3088\30731\3064\306E\5217\3092\8FD4\3059SQL\554F\5408\305B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3209026300796805.442)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('XLSX\30B7\30FC\30C8\540D\3092\542B\3080\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30A2\30C3\30D7\30ED\30FC\30C9\3055\308C\305FXLSX\30D5\30A1\30A4\30EB\5185\306E\4F7F\7528\53EF\80FD\306A\30EF\30FC\30AF\30B7\30FC\30C8\3092\8868\793A\3059\308B\9078\629E\30EA\30B9\30C8\307E\305F\306F\30DD\30C3\30D7\30A2\30C3\30D7LOV\30A2\30A4\30C6\30E0\306F\3001\6B21\306E<em>LOV\306ESQL\554F\5408\305B</em>\3092\4F7F\7528\3057\307E\3059(<strong>PX_FILE</strong>\306FXLSX\30D5\30A1\30A4\30EB\306E\30A2\30C3\30D7\30ED\30FC\30C9\306B\4F7F\7528\3055\308C\308B\30D5\30A1\30A4\30EB\53C2\7167\30A2\30A4\30C6\30E0\3067\3059)\3002</p><p><strong>SHEET_FILE_NAME</strong>\5C5E\6027\3092LOV\623B\308A\5217\3068\3057\3066\4F7F\7528\3059\308B\5FC5\8981\304C\3042\308B\3053\3068\306B\6CE8\610F\3057\3066\304F\3060\3055\3044\3002</p>'),
'<pre>',
'select s.sheet_display_name display, ',
'       s.sheet_file_name    return',
'  from apex_application_temp_files f,',
'       table( <strong>apex_data_parser.get_xlsx_worksheets</strong>( p_content => f.blob_content ) ) s',
' where f.name = :PX_FILE',
'</pre>'))
,p_help_text=>unistr('<p>\30ED\30FC\30C9\3059\308BXLSX\30D5\30A1\30A4\30EB\306E\30EF\30FC\30AF\30B7\30FC\30C8\540D\3092\542B\3080\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3092\6307\5B9A\3057\307E\3059\3002\6307\5B9A\3057\305F\30EF\30FC\30AF\30B7\30FC\30C8\304B\3089\30C7\30FC\30BF\304C\30ED\30FC\30C9\3055\308C\307E\3059\3002\6307\5B9A\3057\306A\3044\5834\5408\3001APEX\3067\306FXLSX\30D5\30A1\30A4\30EB\306E\6700\521D\306E\30EF\30FC\30AF\30B7\30FC\30C8\304B\3089\30C7\30FC\30BF\304C\30ED\30FC\30C9\3055\308C\307E\3059\3002</p><p>\901A\5E38\3001<em>\9078\629E\30EA\30B9\30C8</em>\30FB\30A2\30A4\30C6\30E0\304C\3053\308C\306B\4F7F\7528\3055\308C\307E\3059\3002<em>LOV\554F\5408\305B</em>\3067\306F\3001\30EF\30FC\30AF\30B7\30FC\30C8\8868\793A\304A\3088\3073\5185\90E8\540D\3092\53D6\5F97\3059\308B\306B\306F\3001<strong>APEX_DATA_PARSER.GET_XLSX_WORKSHEETS</strong>\3092\4F7F\7528\3057\307E')
||unistr('\3059\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1319771677848714.442)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\51E6\7406\6E08\884C\6570\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_help_text=>unistr('\30A2\30C3\30D7\30ED\30FC\30C9\3055\308C\305F(\304A\3088\3073\51E6\7406\3055\308C\305F)\884C\306E\7DCF\6570\3092\683C\7D0D\3059\308B\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3092\9078\629E\3057\307E\3059\3002\5024\306F\3001\30C7\30FC\30BF\30FB\30ED\30FC\30C9\30FB\30D7\30ED\30BB\30B9\304C\5B8C\4E86\3057\305F\5F8C\306B\4F7F\7528\53EF\80FD\306B\306A\308A\3001\30E1\30C3\30BB\30FC\30B8\3067\306E\8868\793A\306B\4F7F\7528\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1320047176851343.442)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\30A8\30E9\30FC\884C\6570\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_help_text=>unistr('\30A8\30E9\30FC\884C\306E\7DCF\6570\3092\683C\7D0D\3059\308B\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3092\9078\629E\3057\307E\3059\3002\5024\306F\3001\30C7\30FC\30BF\30FB\30ED\30FC\30C9\30FB\30D7\30ED\30BB\30B9\304C\5B8C\4E86\3057\305F\5F8C\306B\4F7F\7528\53EF\80FD\306B\306A\308A\3001\30E1\30C3\30BB\30FC\30B8\3067\306E\8868\793A\306B\4F7F\7528\3067\304D\307E\3059\3002')
);
end;
/
prompt --application/shared_components/plugins/item_type/range
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(4386180889228297.442)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'RANGE'
,p_display_name=>unistr('\7BC4\56F2')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS:APEX_APPL_PAGE_SFILTERS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','RANGE'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:ELEMENT:ENCRYPT:LOV:FC_HAS_FEEDBACK:FC_SHOW_SELECTED_FIRST:FC_SHOW_MORE_COUNT:FC_FILTER_VALUES'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('<p>\5024\30BB\30EC\30AF\30BF\306E\7D44\8FBC\307F\30EA\30B9\30C8\4ED8\304D\306E\30A2\30A4\30C6\30E0\3092\8868\793A\3057\307E\3059\3002\30D5\30A1\30BB\30C3\30C8\3067\306F\3001\5358\4E00\307E\305F\306F\8907\6570\306E\9078\629E\3068\3001\624B\52D5\5165\529B\304C\30B5\30DD\30FC\30C8\3055\308C\307E\3059\3002\5358\4E00\9078\629E\306E\30B5\30DD\30FC\30C8\3067\306F\3001\8907\6570\306E\5024\3092\30E9\30B8\30AA\30FB\30DC\30BF\30F3\30FB\30AA\30D7\30B7\30E7\30F3\3068\3057\3066\8868\793A\3057\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C1\3064\306E\5024\3092\9078\629E\3067\304D\308B\3088\3046\306B\3057\307E\3059\3002\8907\6570\9078\629E\306E\30B5\30DD\30FC\30C8\3067\306F\3001\8907\6570\306E\5024\3092\30C1\30A7\30C3\30AF\30FB\30DC\30C3\30AF\30B9\3068\3057\3066\8868\793A\3057\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\8907\6570\306E\5024\3092\9078\629E\3067\304D\308B\3088\3046\306B\3057\307E\3059\3002\624B\52D5\5165\529B\306E\30B5\30DD\30FC\30C8\3067\306F\3001\30D5\30A1\30BB\30C3\30C8\306E\4E0B\306B\30C6\30AD\30B9\30C8\30FB\30D5\30A3\30FC\30EB\30C9\3092\8868\793A\3057\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\30D5\30A3\30EB\30BF\6E08\30EA\30FC\30B8\30E7\30F3\306E\30D5\30A3\30EB\30BF\306B\4F7F\7528\3059\308B\5024')
||unistr('\306E\7BC4\56F2\3092\624B\52D5\3067\5165\529B\3067\304D\308B\3088\3046\306B\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2513920677752961.442)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\8907\6570\306E\9078\629E')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\30D5\30A1\30BB\30C3\30C8\3067\8907\6570\30EA\30B9\30C8\30FB\30A8\30F3\30C8\30EA\306E\9078\629E\3092\30B5\30DD\30FC\30C8\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002<strong>\300C\30AA\30F3\300D</strong>\306B\8A2D\5B9A\3059\308B\3068\3001\30D5\30A1\30BB\30C3\30C8\304C\30C1\30A7\30C3\30AF\30FB\30DC\30C3\30AF\30B9\3068\3057\3066\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\3001\8907\6570\306E\9078\629E\304C\30B5\30DD\30FC\30C8\3055\308C\307E\3059\3002<strong>\300C\30AA\30D5\300D</strong>\306B\8A2D\5B9A\3059\308B\3068\3001\30D5\30A1\30BB\30C3\30C8\304C\30E9\30B8\30AA\30FB\30DC\30BF\30F3\30FB\30AA\30D7\30B7\30E7\30F3\3068\3057\3066\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\3001\5358\4E00\306E\9078\629E\304C\30B5\30DD\30FC\30C8\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2513635447749258.442)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\624B\52D5\5165\529B')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\7BC4\56F2\30D5\30A1\30BB\30C3\30C8\3067\624B\52D5\5165\529B\3092\30B5\30DD\30FC\30C8\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002<strong>\300C\30AA\30F3\300D</strong>\306B\8A2D\5B9A\3059\308B\3068\3001\30D5\30A1\30BB\30C3\30C8\306E\4E0B\306B\30C6\30AD\30B9\30C8\30FB\30D5\30A3\30FC\30EB\30C9\304C\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\30D5\30A3\30EB\30BF\6E08\30EA\30FC\30B8\30E7\30F3\306E\30D5\30A3\30EB\30BF\306B\4F7F\7528\3059\308B\5024\306E\7BC4\56F2\3092\624B\52D5\3067\5165\529B\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(4386359236228299.442)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\7BC4\56F2\30C6\30AD\30B9\30C8')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(2513635447749258.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('\300C\624B\52D5\5165\529B\300D\306E\5404\30C6\30AD\30B9\30C8\30FB\30D5\30A3\30FC\30EB\30C9\9593\306B\8868\793A\3059\308B\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(728476028199560899.442)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\73FE\884C\30E9\30D9\30EB')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(2513635447749258.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>unistr('0%\304B\3089%1')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(728478221838569501.442)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\73FE\884C\30E9\30D9\30EB\30FB\30AA\30FC\30D7\30F3\9AD8')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(2513635447749258.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>unistr('%0\3092\4E0A\56DE\308B')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(728476302635562853.442)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\73FE\884C\30E9\30D9\30EB\30FB\30AA\30FC\30D7\30F3\4F4E')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(2513635447749258.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>unistr('%0\3092\4E0B\56DE\308B')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(4390664988228304.442)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.442)
,p_name=>'LOV'
,p_is_required=>false
,p_sql_min_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>SQL\554F\5408\305B\306B\57FA\3065\3044\305FLOV</dt>'),
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>\540C\3058\8868\793A\304A\3088\3073\623B\308A\5024\3092\4F7F\7528\3057\305FLOV</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>\30CE\30FC\30C8: \8868\793A\5024\3068\623B\308A\5024\306E\4E21\65B9\306B\540C\3058\5217\3092\9078\629E\3059\308B\5834\5408\3001\5217\306E\5225\540D\3092\4F7F\7528\3057\307E\3059\3002</p>'),
'</dd>',
unistr('<dt>\30D0\30A4\30F3\30C9\5909\6570\3092\4F7F\7528\3057\305FLOV</dt>'),
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>\30CE\30FC\30C8: <code>P3_DEPTNO</code>\304C\540C\3058\30DA\30FC\30B8\306E\5909\66F4\53EF\80FD\306A\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306E\5834\5408\3001<em>\300C\30AB\30B9\30B1\30FC\30C9LOV\89AA\30A2\30A4\30C6\30E0\300D</em>\5C5E\6027\3092<code>P3_DEPTNO</code>\306B\8A2D\5B9A\3057\307E\3059\3002</dd>'),
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/item_type/display_map
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(8870444141116576.442)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'DISPLAY_MAP'
,p_display_name=>unistr('\30DE\30C3\30D7\306E\8868\793A')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','DISPLAY_MAP'),'')
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.miniMap#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.displayMap#MIN#.js'))
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:SOURCE:ELEMENT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('GeoJSON\30DD\30A4\30F3\30C8\5F62\5F0F\306E\5EA7\6A19\306B\57FA\3065\3044\3066\30DE\30C3\30D7\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9070464796133078.442)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\80CC\666F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'default'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\4F7F\7528\3059\308B\80CC\666F\30DE\30C3\30D7\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9070760381135077.442)
,p_plugin_attribute_id=>wwv_flow_api.id(9070464796133078.442)
,p_display_sequence=>10
,p_display_value=>unistr('\30C7\30D5\30A9\30EB\30C8')
,p_return_value=>'default'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30C7\30D5\30A9\30EB\30C8\306E\30DE\30C3\30D7\80CC\666F\3092\4F7F\7528\3057\307E\3059\3002</p>'),
unistr('<p>\30C0\30FC\30AF\30FB\30C6\30FC\30DE\306B\306F"OpenStreetMap Bright"\307E\305F\306F"OpenStreetMap Dark"\306E\3044\305A\308C\304B\304C\4F7F\7528\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9071162492136081.442)
,p_plugin_attribute_id=>wwv_flow_api.id(9070464796133078.442)
,p_display_sequence=>20
,p_display_value=>'OpenStreetMap Bright'
,p_return_value=>'osm-bright'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>OpenStreetMap\30C7\30FC\30BF\306B\57FA\3065\304F\6C4E\7528\30D9\30FC\30B9\30DE\30C3\30D7\3002\3053\306E\30D9\30FC\30B9\30DE\30C3\30D7\30FB\30B9\30BF\30A4\30EB\306B\3088\3063\3066\3001\30C7\30FC\30BF\306E\8A73\7D30\306A\30ED\30B1\30FC\30B7\30E7\30F3\30FB\30B3\30F3\30C6\30AD\30B9\30C8\304C\63D0\4F9B\3055\308C\307E\3059\3002</p>'),
unistr('<p>Mapbox Open Styles\304B\3089\6D3E\751F\3057\305FKlokanTech.com\3068OpenMapTiles\306E\30B3\30F3\30C8\30EA\30D3\30E5\30FC\30BF\306B\3088\308B\30B9\30BF\30A4\30EB\30FB\30B9\30AD\30FC\30DE\304A\3088\3073\5B9A\7FA9\3002BSD/CC-BY\30E9\30A4\30BB\30F3\30B9\306E\4E0B\3067\8A31\53EF\3055\308C\3066\3044\307E\3059\3002</p>'),
unistr('<p><a rel="noreferrer" href="https://github.com/openmaptiles/osm-bright-gl-style" target="_blank">GitHub\3067\8868\793A</a></p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9071529690137784.442)
,p_plugin_attribute_id=>wwv_flow_api.id(9070464796133078.442)
,p_display_sequence=>30
,p_display_value=>'OpenStreetMap Dark'
,p_return_value=>'osm-dark-matter'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>OpenStreetMap\30C7\30FC\30BF\306B\57FA\3065\304F\63A7\3048\3081\306A\30C0\30FC\30AF\30FB\30D9\30FC\30B9\30DE\30C3\30D7\3002\3053\306E\30D9\30FC\30B9\30DE\30C3\30D7\30FB\30B9\30BF\30A4\30EB\306B\3088\3063\3066\3001\30C7\30FC\30BF\306E\8996\899A\5316\304C\5F37\8ABF\3055\308C\307E\3059\3002</p>'),
unistr('<p>Mapbox Open Styles\304B\3089\6D3E\751F\3057\305FKlokanTech.com\3068OpenMapTiles\306E\30B3\30F3\30C8\30EA\30D3\30E5\30FC\30BF\306B\3088\308B\30B9\30BF\30A4\30EB\30FB\30B9\30AD\30FC\30DE\304A\3088\3073\5B9A\7FA9\3002BSD/CC-BY\30E9\30A4\30BB\30F3\30B9\306E\4E0B\3067\8A31\53EF\3055\308C\3066\3044\307E\3059\3002Stamen Design\306B\3088\308B\5730\56F3\4F5C\6210\306F\3001CC0\306E\4E0B\3067\8A31\53EF\3055\308C\3066\3044\307E\3059\3002</p>'),
unistr('<p><a rel="noreferrer" href="https://github.com/openmaptiles/dark-matter-gl-style" target="_blank">GitHub\3067\8868\793A</a></p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9071983425139542.442)
,p_plugin_attribute_id=>wwv_flow_api.id(9070464796133078.442)
,p_display_sequence=>40
,p_display_value=>'OpenStreetMap Positron'
,p_return_value=>'osm-positron'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>OpenStreetMap\30C7\30FC\30BF\306B\57FA\3065\304F\63A7\3048\3081\306A\30E9\30A4\30C8\30FB\30D9\30FC\30B9\30DE\30C3\30D7\3002\3053\306E\30D9\30FC\30B9\30DE\30C3\30D7\30FB\30B9\30BF\30A4\30EB\306B\3088\3063\3066\3001\30C7\30FC\30BF\306E\8996\899A\5316\304C\5F37\8ABF\3055\308C\307E\3059\3002</p>'),
unistr('<p>Mapbox Open Styles\304B\3089\6D3E\751F\3057\305FKlokanTech.com\3068OpenMapTiles\306E\30B3\30F3\30C8\30EA\30D3\30E5\30FC\30BF\306B\3088\308B\30B9\30BF\30A4\30EB\30FB\30B9\30AD\30FC\30DE\304A\3088\3073\5B9A\7FA9\3002BSD/CC-BY\30E9\30A4\30BB\30F3\30B9\306E\4E0B\3067\8A31\53EF\3055\308C\3066\3044\307E\3059\3002Stamen Design\306B\3088\308B\5730\56F3\4F5C\6210\306F\3001CC0\306E\4E0B\3067\8A31\53EF\3055\308C\3066\3044\307E\3059\3002</p>'),
unistr('<p><a rel="noreferrer" href="https://github.com/openmaptiles/positron-gl-style" target="_blank">GitHub\3067\8868\793A</a></p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9072395929141067.442)
,p_plugin_attribute_id=>wwv_flow_api.id(9070464796133078.442)
,p_display_sequence=>50
,p_display_value=>'Oracle World Map'
,p_return_value=>'world-map'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>HERE Map\30C7\30FC\30BF\306B\57FA\3065\304F\6C4E\7528\30D9\30FC\30B9\30DE\30C3\30D7\3002\3053\306E\30D9\30FC\30B9\30DE\30C3\30D7\30FB\30B9\30BF\30A4\30EB\306B\3088\3063\3066\3001\30C7\30FC\30BF\306E\30ED\30B1\30FC\30B7\30E7\30F3\30FB\30B3\30F3\30C6\30AD\30B9\30C8\304C\63D0\4F9B\3055\308C\3001\30C7\30FC\30BF\306E\8996\899A\5316\304C\5F37\8ABF\3055\308C\307E\3059\3002</p>'),
unistr('<p>Oracle USA\306B\3088\308B\30B9\30BF\30A4\30EB\30FB\30B9\30AD\30FC\30DE\304A\3088\3073\5B9A\7FA9\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9072916496197068.442)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\30BA\30FC\30E0\30FB\30EC\30D9\30EB')
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'14'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30EC\30A4\30E4\30FC\304C\8868\793A\3055\308C\308B\30BA\30FC\30E0\30FB\30EC\30D9\30EB\3092\6307\5B9A\3057\307E\3059\3002</p>'),
'<p>',
unistr('\6700\5C0F\5024: 1<br>'),
unistr('\6700\5927\5024: 18'),
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9073279785199355.442)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\30DE\30FC\30AB\30FC\306E\8868\793A')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>unistr('<p>\30DE\30FC\30AB\30FC\3092\8868\793A\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9073555327202501.442)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\30DE\30FC\30AB\30FC\306E\8272')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(9073279785199355.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30DE\30FC\30AB\30FC\5857\308A\3064\3076\3057\306E\8272\3092\6307\5B9A\3057\307E\3059\3002</p>'),
unistr('<p>\8272\306F\300116\9032(hex)\8868\8A18\3001RGB\30AB\30E9\30FC\30FB\30B3\30FC\30C9\307E\305F\306FHTML\30AB\30E9\30FC\540D\3092\4F7F\7528\3057\3066\6307\5B9A\3055\308C\307E\3059\300216\9032\8868\8A18\306F#xxyyzz (#\306E\5F8C\306B3\3064\306E2\6841\306E16\9032\6570)\3067\5B9A\7FA9\3055\308C\3001xx\3001yy\304A\3088\3073zz\306F\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E2\6587\5B57\306E16\9032\306E\5024\3092\8868\3057\307E\3059\3002RGB\30B3\30FC\30C9\306FRGB(xxx,xxx,xxx)\3067\5B9A\7FA9\3055\308C\3001xxx\306F0\304B\3089255\306E\9593\306E\6570\5024\3067\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E8\30D3\30C3\30C8\30FB\30D0\30A4\30C8\5024\3092\8868\3057\307E\3059\3002</p>'),
''))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9075223673219708.442)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\30C4\30FC\30EB\30C1\30C3\30D7')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(9073279785199355.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8868\793A\3055\308C\308B\30DE\30FC\30AB\30FC\306E\30C4\30FC\30EB\30C1\30C3\30D7\30FB\30C6\30AD\30B9\30C8\3092\6307\5B9A\3057\307E\3059\3002</p>'),
unistr('<p>\30C4\30FC\30EB\30C1\30C3\30D7\5C5E\6027\306F\3001HTML\304A\3088\3073APEX\30C6\30F3\30D7\30EC\30FC\30C8\30FB\30C7\30A3\30EC\30AF\30C6\30A3\30D6\3092\30B5\30DD\30FC\30C8\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9073839532205482.442)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\30DE\30C3\30D7\30FB\30B3\30F3\30C8\30ED\30FC\30EB\306E\8868\793A')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30DE\30C3\30D7\30FB\30B3\30F3\30C8\30ED\30FC\30EB\3092\8868\793A\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002</p>'),
unistr('<p>\3053\308C\306B\3088\308A\3001\30BA\30FC\30E0\3068\56DE\8EE2\306E\30B3\30F3\30C8\30ED\30FC\30EB\304C\30DE\30C3\30D7\306B\8FFD\52A0\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9074137581210550.442)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\5BFE\8A71\578B\30DE\30C3\30D7')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30DE\30C3\30D7\3092\5BFE\8A71\578B\306B\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002</p>'),
unistr('<p>\300C\3044\3044\3048\300D\306B\8A2D\5B9A\3059\308B\3068\3001\5BFE\8A71\6027\306E\306A\3044\9759\7684\30DE\30C3\30D7\304C\4F5C\6210\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11976499186792296.442)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\9AD8\3055')
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_unit=>unistr('\30D4\30AF\30BB\30EB')
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8868\793A\3055\308C\308B\30DE\30C3\30D7\306E\9AD8\3055(\30D4\30AF\30BB\30EB)\3092\6307\5B9A\3057\307E\3059\3002</p>'),
unistr('<p>\30DE\30C3\30D7\306E\30C7\30D5\30A9\30EB\30C8\306E\9AD8\3055\306F\3001\305D\306E\5E45\306B\57FA\3065\3044\30663:2\306E\30A2\30B9\30DA\30AF\30C8\6BD4\3067\8A08\7B97\3055\308C\307E\3059\3002</p>')))
);
end;
/
prompt --application/shared_components/plugins/authorization_type/exists
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11251017839289082.442)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'EXISTS'
,p_display_name=>unistr('EXISTS SQL\554F\5408\305B')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','EXISTS'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('1\884C\4EE5\4E0A\3092\8FD4\305B\3070\8A8D\53EF\30B9\30AD\30FC\30E0\304C\30D1\30B9\3057\3001\884C\3092\8FD4\3055\306A\3044\5834\5408\306F\30B9\30AD\30FC\30E0\304C\5931\6557\3059\308B\554F\5408\305B\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11251530568311696.442)
,p_plugin_id=>wwv_flow_api.id(11251017839289082.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('SQL\554F\5408\305B')
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select null',
'  from apex_workspace_group_users',
' where user_name  = :APP_USER',
'   and group_name = ''ADMIN''',
'</pre>'))
,p_help_text=>unistr('1\884C\4EE5\4E0A\3092\8FD4\305B\3070\8A8D\53EF\30B9\30AD\30FC\30E0\304C\30D1\30B9\3057\3001\884C\3092\8FD4\3055\306A\3044\5834\5408\306F\30B9\30AD\30FC\30E0\304C\5931\6557\3059\308B\554F\5408\305B\3002')
);
end;
/
prompt --application/shared_components/plugins/authorization_type/not_exists
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11252021695318665.442)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'NOT_EXISTS'
,p_display_name=>unistr('NOT EXISTS SQL\554F\5408\305B')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','NOT_EXISTS'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\884C\3092\8FD4\3055\306A\3051\308C\3070\8A8D\53EF\30B9\30AD\30FC\30E0\304C\30D1\30B9\3057\30011\884C\4EE5\4E0A\3092\8FD4\305B\3070\30B9\30AD\30FC\30E0\304C\5931\6557\3059\308B\554F\5408\305B\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11252200009321795.442)
,p_plugin_id=>wwv_flow_api.id(11252021695318665.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('SQL\554F\5408\305B')
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select null',
'  from apex_workspace_group_users',
' where user_name  = :APP_USER',
'   and group_name = ''GUEST''',
'</pre>'))
,p_help_text=>unistr('1\884C\4EE5\4E0A\3092\8FD4\305B\3070\8A8D\53EF\30B9\30AD\30FC\30E0\304C\5931\6557\3057\3001\884C\3092\8FD4\3055\306A\3044\5834\5408\306F\30B9\30AD\30FC\30E0\304C\6210\529F\3059\308B\554F\5408\305B\3002')
);
end;
/
prompt --application/shared_components/plugins/authorization_type/item_is_null
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11252712476325388.442)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'ITEM_IS_NULL'
,p_display_name=>unistr('\30A2\30A4\30C6\30E0\306FNULL')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','ITEM_IS_NULL'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\30A2\30A4\30C6\30E0\306E\5024\306Fnull\3067\3059\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11252900140331368.442)
,p_plugin_id=>wwv_flow_api.id(11252712476325388.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_display_length=>30
,p_is_translatable=>false
,p_help_text=>unistr('\3053\306E\30A2\30A4\30C6\30E0\306E\5024\304CNULL\306E\5834\5408\306F\8A8D\53EF\304C\6210\529F\3057\3001\305D\3046\3067\306A\3044\5834\5408\306F\5931\6557\3057\307E\3059\3002')
);
end;
/
prompt --application/shared_components/plugins/authorization_type/item_is_not_null
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11253409836334113.442)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'ITEM_IS_NOT_NULL'
,p_display_name=>unistr('\30A2\30A4\30C6\30E0\306FNULL\3067\306F\306A\3044')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','ITEM_IS_NOT_NULL'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\30A2\30A4\30C6\30E0\306E\5024\306Fnull\3067\306F\3042\308A\307E\305B\3093\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11253615031335591.442)
,p_plugin_id=>wwv_flow_api.id(11253409836334113.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\3053\306E\30A2\30A4\30C6\30E0\306E\5024\304CNULL\3067\306A\3044\5834\5408\306F\8A8D\53EF\304C\6210\529F\3057\3001NULL\306E\5834\5408\306F\5931\6557\3057\307E\3059')
);
end;
/
prompt --application/shared_components/plugins/authorization_type/function_body
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11254106158342546.442)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'FUNCTION_BODY'
,p_display_name=>unistr('\30D6\30FC\30EB\3092\623B\3059PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','FUNCTION_BODY'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('TRUE\307E\305F\306FFALSE\3092\8FD4\3059PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3002\5024\304CFALSE\306E\5834\5408\306F\8A8D\53EF\30B9\30AD\30FC\30E0\304C\5931\6557\3057\307E\3059\3002\5024\304CTRUE\306E\5834\5408\306F\6210\529F\3057\307E\3059\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11254314469344909.442)
,p_plugin_id=>wwv_flow_api.id(11254106158342546.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
,p_attribute_type=>'PLSQL FUNCTION BODY BOOLEAN'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('TRUE\307E\305F\306FFALSE\3092\8FD4\3059PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3002\5024\304CFALSE\306E\5834\5408\306F\8A8D\53EF\30B9\30AD\30FC\30E0\304C\5931\6557\3057\307E\3059\3002\5024\304CTRUE\306E\5834\5408\306F\6210\529F\3057\307E\3059\3002'),
'<p/>',
unistr('\4F8B:'),
'<pre>',
'return to_char(sysdate,''hh24'') between ''08'' and ''17'';',
'</pre>'))
);
end;
/
prompt --application/shared_components/plugins/authorization_type/pref_equals_value
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11255012523353865.442)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'PREF_EQUALS_VALUE'
,p_display_name=>unistr('\30D7\30EA\30D5\30A1\30EC\30F3\30B9\306F\5024\3068\7B49\3057\3044')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','PREF_EQUALS_VALUE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\30D7\30EA\30D5\30A1\30EC\30F3\30B9\306E\5024\306F\5024\3068\7B49\3057\3044\3067\3059\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11255227067358013.442)
,p_plugin_id=>wwv_flow_api.id(11255012523353865.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\30D7\30EA\30D5\30A1\30EC\30F3\30B9\540D')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\3053\306E\30D7\30EA\30D5\30A1\30EC\30F3\30B9\306E\5024\304C\4E0B\306E\30D5\30A3\30FC\30EB\30C9\306E\5024\3068\540C\7B49\306E\5834\5408\306F\8A8D\53EF\304C\6210\529F\3057\3001\7570\306A\308B\5834\5408\306F\5931\6557\3057\307E\3059')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11255701918360235.442)
,p_plugin_id=>wwv_flow_api.id(11255012523353865.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\5024')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\4E0A\8A18\3092\53C2\7167')
);
end;
/
prompt --application/shared_components/plugins/authorization_type/pref_not_equals_value
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11257015209373543.442)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'PREF_NOT_EQUALS_VALUE'
,p_display_name=>unistr('\30D7\30EA\30D5\30A1\30EC\30F3\30B9\306F\5024\3068\7B49\3057\304F\306A\3044')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','PREF_NOT_EQUALS_VALUE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\30D7\30EA\30D5\30A1\30EC\30F3\30B9\306E\5024\306F\5024\3068\7B49\3057\304F\306A\3044\3067\3059\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11257220750375150.442)
,p_plugin_id=>wwv_flow_api.id(11257015209373543.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\30D7\30EA\30D5\30A1\30EC\30F3\30B9\540D')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\3053\306E\30D7\30EA\30D5\30A1\30EC\30F3\30B9\306E\5024\304C\4E0B\306E\30D5\30A3\30FC\30EB\30C9\306E\5024\3068\7570\306A\308B\5834\5408\306F\8A8D\53EF\304C\6210\529F\3057\3001\540C\7B49\306E\5834\5408\306F\5931\6557\3057\307E\3059')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11257725944376646.442)
,p_plugin_id=>wwv_flow_api.id(11257015209373543.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\5024')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\4E0A\8A18\3092\53C2\7167')
);
end;
/
prompt --application/shared_components/plugins/authorization_type/item_equals_value
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11258208760381085.442)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'ITEM_EQUALS_VALUE'
,p_display_name=>unistr('\30A2\30A4\30C6\30E0\306F\5024\3068\7B49\3057\3044')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','ITEM_EQUALS_VALUE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\30A2\30A4\30C6\30E0\306E\5024\306F\5024\3068\7B49\3057\3044\3067\3059\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11258417764383723.442)
,p_plugin_id=>wwv_flow_api.id(11258208760381085.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\3053\306E\30A2\30A4\30C6\30E0\306E\5024\304C\4E0B\306E\30D5\30A3\30FC\30EB\30C9\306E\5024\3068\540C\7B49\306E\5834\5408\306F\8A8D\53EF\304C\6210\529F\3057\3001\7570\306A\308B\5834\5408\306F\5931\6557\3057\307E\3059')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11258925383385933.442)
,p_plugin_id=>wwv_flow_api.id(11258208760381085.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\5024')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\4E0A\8A18\3092\53C2\7167')
);
end;
/
prompt --application/shared_components/plugins/authorization_type/item_not_equals_value
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11259414086392075.442)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'ITEM_NOT_EQUALS_VALUE'
,p_display_name=>unistr('\30A2\30A4\30C6\30E0\306F\5024\3068\7B49\3057\304F\306A\3044')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','ITEM_NOT_EQUALS_VALUE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30A2\30A4\30C6\30E0\306E\5024\306F\5024\3068\7B49\3057\304F\306A\3044\3067\3059\3002</p>'),
''))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11259621358394213.442)
,p_plugin_id=>wwv_flow_api.id(11259414086392075.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\3053\306E\30A2\30A4\30C6\30E0\306E\5024\304C\4E0B\306E\30D5\30A3\30FC\30EB\30C9\306E\5024\3068\7570\306A\308B\5834\5408\306F\8A8D\53EF\304C\6210\529F\3057\3001\540C\7B49\306E\5834\5408\306F\5931\6557\3057\307E\3059')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11260124128395028.442)
,p_plugin_id=>wwv_flow_api.id(11259414086392075.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\5024')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\4E0A\8A18\3092\53C2\7167')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/geocoding_trigger
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(12476487024106188.442)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'GEOCODING_TRIGGER'
,p_display_name=>unistr('\30B8\30AA\30B3\30FC\30C7\30A3\30F3\30B0\306E\30C8\30EA\30AC\30FC')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','GEOCODING_TRIGGER'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('<p><em>\30B8\30AA\30B3\30FC\30C7\30A3\30F3\30B0\3055\308C\305F\4F4F\6240</em>\30A2\30A4\30C6\30E0\306E\30B8\30AA\30B3\30FC\30C7\30A3\30F3\30B0\691C\7D22\3092\624B\52D5\3067\30C8\30EA\30AC\30FC\3057\307E\3059\3002</p>')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/social
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(15242808636946504.442)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'SOCIAL'
,p_display_name=>unistr('\30BD\30FC\30B7\30E3\30EB\30FB\30B5\30A4\30F3\30A4\30F3')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','SOCIAL'),'')
,p_api_version=>2
,p_standard_attributes=>'INVALID_SESSION'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Google\3001Facebook\3001\6C4E\7528OpenID Connect\304A\3088\3073\6C4E\7528OAuth2\30A2\30A4\30C7\30F3\30C6\30A3\30C6\30A3\30FB\30D7\30ED\30D0\30A4\30C0\3088\308B\8A8D\8A3C\3092\30B5\30DD\30FC\30C8\3057\307E\3059\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(15243730328988135.442)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\8CC7\683C\8A3C\660E\30B9\30C8\30A2')
,p_attribute_type=>'CREDENTIAL ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\8A8D\8A3C\30D7\30ED\30D0\30A4\30C0\306E\30AF\30E9\30A4\30A2\30F3\30C8ID\304A\3088\3073\30B7\30FC\30AF\30EC\30C3\30C8\3092\542B\3080\8CC7\683C\8A3C\660E\30B9\30C8\30A2\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(15249686303031715.442)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\8A8D\8A3C\30D7\30ED\30D0\30A4\30C0')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'OPENID_CONNECT'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(18383539811983244.442)
,p_plugin_attribute_id=>wwv_flow_api.id(15249686303031715.442)
,p_display_sequence=>10
,p_display_value=>unistr('OpenID Connect\30D7\30ED\30D0\30A4\30C0')
,p_return_value=>'OPENID_CONNECT'
,p_help_text=>unistr('OpenID Connect\30D9\30FC\30B9\306E\8A8D\8A3C\30D7\30ED\30D0\30A4\30C0\3092\4F7F\7528\3057\307E\3059\3002\6B21\306B\793A\3059\30D7\30ED\30D0\30A4\30C0\306EOpenID\691C\51FAURL\3092\5165\529B\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(18384865200013886.442)
,p_plugin_attribute_id=>wwv_flow_api.id(15249686303031715.442)
,p_display_sequence=>20
,p_display_value=>unistr('\6C4E\7528OAuth2\30D7\30ED\30D0\30A4\30C0')
,p_return_value=>'OAUTH2'
,p_help_text=>unistr('OAuth2\8A8D\8A3C\30D7\30ED\30D0\30A4\30C0\3092\4F7F\7528\3057\307E\3059\3002\6B21\306B\793A\3059\8A8D\53EF\30A8\30F3\30C9\30DD\30A4\30F3\30C8\3001\30C8\30FC\30AF\30F3\30FB\30A8\30F3\30C9\30DD\30A4\30F3\30C8\304A\3088\3073\30E6\30FC\30B6\30FC\60C5\5831\30A8\30F3\30C9\30DD\30A4\30F3\30C8\306EURL\3092\5165\529B\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(18650405105549494.442)
,p_plugin_attribute_id=>wwv_flow_api.id(15249686303031715.442)
,p_display_sequence=>30
,p_display_value=>'Google'
,p_return_value=>'GOOGLE'
,p_help_text=>unistr('Google\30ED\30B0\30A4\30F3\306E\4E8B\524D\5B9A\7FA9\6E08\8A2D\5B9A\3092\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(18650810905551172.442)
,p_plugin_attribute_id=>wwv_flow_api.id(15249686303031715.442)
,p_display_sequence=>40
,p_display_value=>'Facebook'
,p_return_value=>'FACEBOOK'
,p_help_text=>unistr('Facebook\30ED\30B0\30A4\30F3\306E\4E8B\524D\5B9A\7FA9\6E08\8A2D\5B9A\3092\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(15249997224035381.442)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\691C\51FAURL')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(15249686303031715.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OPENID_CONNECT'
,p_examples=>'https://accounts.example.com/.well-known/openid-configuration'
,p_help_text=>unistr('OpenID Connect\30D7\30ED\30D0\30A4\30C0\306E\691C\51FAURL\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18385430957035861.442)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\8A8D\53EF\30A8\30F3\30C9\30DD\30A4\30F3\30C8URL')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(15249686303031715.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>unistr('OAuth2\30D7\30ED\30D0\30A4\30C0\306E\8A8D\53EF\30A8\30F3\30C9\30DD\30A4\30F3\30C8URL\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18385701636038222.442)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\30C8\30FC\30AF\30F3\30FB\30A8\30F3\30C9\30DD\30A4\30F3\30C8URL')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(15249686303031715.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>unistr('OAuth2\30D7\30ED\30D0\30A4\30C0\306E\30C8\30FC\30AF\30F3\30FB\30A8\30F3\30C9\30DD\30A4\30F3\30C8URL\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18386081451040404.442)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\30E6\30FC\30B6\30FC\60C5\5831\30A8\30F3\30C9\30DD\30A4\30F3\30C8URL')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(15249686303031715.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>unistr('OAuth2\30D7\30ED\30D0\30A4\30C0\306E\30E6\30FC\30B6\30FC\60C5\5831\30A8\30F3\30C9\30DD\30A4\30F3\30C8URL\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18386627580109078.442)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\6709\52B9\7BC4\56F2')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'profile'
,p_is_translatable=>false
,p_examples=>'email,profile'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('\30ED\30B0\30A4\30F3\3057\3066\3044\308B\30E6\30FC\30B6\30FC\306B\5BFE\3057\3066\30EA\30AF\30A8\30B9\30C8\3059\308B\6A29\9650\306E\30AB\30F3\30DE\533A\5207\308A\30EA\30B9\30C8\3092\5165\529B\3057\307E\3059\3002'),
unistr('\4F7F\7528\53EF\80FD\306A\5024\306F\3001\8A8D\8A3C\30D7\30ED\30D0\30A4\30C0\306B\3088\3063\3066\7570\306A\308A\307E\3059\3002'),
unistr('OpenID Connect\304A\3088\3073Google\306E\5834\5408\3001Application Express\306B\3088\3063\3066"openid"\30B9\30B3\30FC\30D7\304C\81EA\52D5\7684\306B\8FFD\52A0\3055\308C\307E\3059\3002'),
unistr('\8A8D\8A3C\30D7\30ED\30D0\30A4\30C0\306F\3001\3053\308C\3089\306E\6A29\9650\306B\57FA\3065\3044\3066\30E6\30FC\30B6\30FC\5C5E\6027\3092\8FD4\3057\307E\3059\3002'),
unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\306B\5C5E\6027\3092\30DE\30C3\30D7\3059\308B\304B\3001APEX_JSON.GET_%\30D5\30A1\30F3\30AF\30B7\30E7\30F3\3092\4F7F\7528\3057\3066\3001\8A8D\8A3C\5F8C\30D7\30ED\30B7\30FC\30B8\30E3\306B\3088\3063\3066\305D\308C\3089\3092\51E6\7406\3067\304D\307E\3059\3002'),
'</p><p>',
unistr('OpenID Connect\306E\30B9\30B3\30FC\30D7\3068\5C5E\6027(\30AF\30EC\30FC\30E0\3068\3082\547C\3070\308C\308B)\306F\3001\6B21\306E\5834\6240\306B\30EA\30B9\30C8\3055\308C\3066\3044\307E\3059: https://openid.net/specs/openid-connect-basic-1_0.html#Scopes'),
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(226010579134296999.442)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\8A8D\8A3CURI\30D1\30E9\30E1\30FC\30BF')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>'prompt=consent'
,p_help_text=>unistr('\8A8D\8A3CURI\306E\30AA\30D7\30B7\30E7\30F3\30FB\30D1\30E9\30E1\30FC\30BF\3092\5165\529B\3057\307E\3059\3002\30B5\30DD\30FC\30C8\3055\308C\308B\5C5E\6027\306B\3064\3044\3066\306F\3001\8A8D\8A3C\30D7\30ED\30D0\30A4\30C0\306E\30C9\30AD\30E5\30E1\30F3\30C8\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18386934074146656.442)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\30E6\30FC\30B6\30FC\540D')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'#sub# (#APEX_AUTH_NAME#)'
,p_is_translatable=>false
,p_examples=>'#sub# (#APEX_AUTH_NAME#)'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('\30E6\30FC\30B6\30FC\540D\3092\542B\3080\5C5E\6027\3092\5165\529B\3059\308B\304B\3001"#"\3067\56F2\307E\308C\305F1\3064\4EE5\4E0A\306E\5C5E\6027\7F6E\63DB\3092\542B\3080\30D5\30EA\30FC\30FB\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002'),
unistr('#APEX_AUTH_NAME#\3092\4F7F\7528\3057\3066\8A8D\8A3C\30B9\30AD\30FC\30E0\306E\540D\524D\3092\53C2\7167\3067\304D\307E\3059\3002'),
unistr('\305F\3068\3048\3070\3001"#email# (#APEX_AUTH_NAME#)"\3068\3059\308B\3068\3001\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9\3067\69CB\6210\3055\308C\305F\30E6\30FC\30B6\30FC\540D\3001" ("\3001\8A8D\8A3C\30B9\30AD\30FC\30E0\540D\3001")"\306E\9806\306B\3001"jane.doe@example.com (Google)"\306A\3069\304C\751F\6210\3055\308C\307E\3059\3002'),
'</p><p>',
unistr('\30B5\30DD\30FC\30C8\3055\308C\308B\5C5E\6027\306B\3064\3044\3066\306F\3001\8A8D\8A3C\30D7\30ED\30D0\30A4\30C0\306E\30C9\30AD\30E5\30E1\30F3\30C8\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002'),
unistr('\5FC5\9808\30B9\30B3\30FC\30D7\3092\8A2D\5B9A\3059\308B\5FC5\8981\304C\3042\308A\3001\305D\3046\3057\306A\3044\3068\8A8D\8A3C\30D7\30ED\30D0\30A4\30C0\306F\4E00\90E8\306E\5C5E\6027\3092\9001\4FE1\3067\304D\306A\3044\3053\3068\306B\6CE8\610F\3057\3066\304F\3060\3055\3044\3002'),
unistr('OpenID Connect\306E\30B9\30B3\30FC\30D7\3068\5C5E\6027(\30AF\30EC\30FC\30E0\3068\3082\547C\3070\308C\308B)\306F\3001\6B21\306E\5834\6240\306B\30EA\30B9\30C8\3055\308C\3066\3044\307E\3059: https://openid.net/specs/openid-connect-basic-1_0.html#Scopes'),
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18652865850779852.442)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('\8FFD\52A0\30E6\30FC\30B6\30FC\5C5E\6027')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>'link,picture,email'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('\8FFD\52A0\306E\30E6\30FC\30B6\30FC\30FB\30C7\30FC\30BF\5C5E\6027\306E\30AB\30F3\30DE\533A\5207\308A\30EA\30B9\30C8\3092\5165\529B\3057\307E\3059\3002'),
'</p><p>',
unistr('\30B5\30DD\30FC\30C8\3055\308C\308B\5C5E\6027\306B\3064\3044\3066\306F\3001\8A8D\8A3C\30D7\30ED\30D0\30A4\30C0\306E\30C9\30AD\30E5\30E1\30F3\30C8\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002'),
unistr('\5FC5\9808\30B9\30B3\30FC\30D7\3092\8A2D\5B9A\3059\308B\5FC5\8981\304C\3042\308A\3001\305D\3046\3057\306A\3044\3068\8A8D\8A3C\30D7\30ED\30D0\30A4\30C0\306F\4E00\90E8\306E\5C5E\6027\3092\9001\4FE1\3067\304D\306A\3044\3053\3068\306B\6CE8\610F\3057\3066\304F\3060\3055\3044\3002'),
unistr('OpenID Connect\306E\30B9\30B3\30FC\30D7\3068\5C5E\6027(\30AF\30EC\30FC\30E0\3068\3082\547C\3070\308C\308B)\306F\3001\6B21\306E\5834\6240\306B\30EA\30B9\30C8\3055\308C\3066\3044\307E\3059: https://openid.net/specs/openid-connect-basic-1_0.html#Scopes'),
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(118623542514218726.442)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>95
,p_prompt=>unistr('\30E6\30FC\30B6\30FC\540D\306E\5927\6587\5B57\3078\306E\5909\63DB')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\30E6\30FC\30B6\30FC\540D\306E\5C5E\6027\5024\3092\5927\6587\5B57\306B\5909\63DB\3059\308B\5FC5\8981\304C\3042\308B\304B\3069\3046\304B\3092\69CB\6210\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(545768003551719989.442)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>65
,p_prompt=>unistr('\30C8\30FC\30AF\30F3\8A8D\8A3C\65B9\5F0F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'BASIC_AND_CLID'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(15249686303031715.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\8CC7\683C\8A3C\660E\306E\30AF\30E9\30A4\30A2\30F3\30C8ID\3068\30AF\30E9\30A4\30A2\30F3\30C8\30FB\30B7\30FC\30AF\30EC\30C3\30C8\3092\30B5\30FC\30D0\30FC\306B\6E21\3059\65B9\6CD5\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(545768719525723870.442)
,p_plugin_attribute_id=>wwv_flow_api.id(545768003551719989.442)
,p_display_sequence=>10
,p_display_value=>unistr('\57FA\672C\8A8D\8A3C')
,p_return_value=>'BASIC'
,p_help_text=>unistr('\30AF\30E9\30A4\30A2\30F3\30C8ID\3068\30AF\30E9\30A4\30A2\30F3\30C8\30FB\30B7\30FC\30AF\30EC\30C3\30C8\3092\57FA\672C\8A8D\8A3C\30D8\30C3\30C0\30FC\3067\9001\4FE1\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(545768336282722977.442)
,p_plugin_attribute_id=>wwv_flow_api.id(545768003551719989.442)
,p_display_sequence=>22
,p_display_value=>unistr('\672C\6587\306E\57FA\672C\8A8D\8A3C\304A\3088\3073\30AF\30E9\30A4\30A2\30F3\30C8ID')
,p_return_value=>'BASIC_AND_CLID'
,p_help_text=>unistr('\30AF\30E9\30A4\30A2\30F3\30C8ID\3068\30AF\30E9\30A4\30A2\30F3\30C8\30FB\30B7\30FC\30AF\30EC\30C3\30C8\3092\57FA\672C\8A8D\8A3C\30D8\30C3\30C0\30FC\3067\9001\4FE1\3057\307E\3059\304C\3001\30AF\30E9\30A4\30A2\30F3\30C8ID\306F\30EA\30AF\30A8\30B9\30C8\672C\6587\3067\3082\9001\4FE1\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(545769143256728532.442)
,p_plugin_attribute_id=>wwv_flow_api.id(545768003551719989.442)
,p_display_sequence=>30
,p_display_value=>unistr('\672C\6587\306E\30AF\30E9\30A4\30A2\30F3\30C8ID\304A\3088\3073\30AF\30E9\30A4\30A2\30F3\30C8\30FB\30B7\30FC\30AF\30EC\30C3\30C8')
,p_return_value=>'BODY'
,p_help_text=>unistr('\30AF\30E9\30A4\30A2\30F3\30C8ID\3068\30AF\30E9\30A4\30A2\30F3\30C8\30FB\30B7\30FC\30AF\30EC\30C3\30C8\3092\30EA\30AF\30A8\30B9\30C8\672C\6587\3067\9001\4FE1\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(829911196403661792.442)
,p_plugin_attribute_id=>wwv_flow_api.id(545768003551719989.442)
,p_display_sequence=>40
,p_display_value=>unistr('\672C\6587\306E\30AF\30E9\30A4\30A2\30F3\30C8ID')
,p_return_value=>'CLID'
,p_help_text=>unistr('\30AF\30E9\30A4\30A2\30F3\30C8ID\306E\307F\3092\30EA\30AF\30A8\30B9\30C8\672C\6587\3067\9001\4FE1\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328064759558360148.442)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>120
,p_prompt=>unistr('\5C5E\6027\306E\691C\8A3C')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('\6709\52B9\306B\3059\308B\3068\3001&PRODUCT_NAME.\306F\5C5E\6027"#name#_verified" (\305F\3068\3048\3070\3001\5C5E\6027"email"\306E\5834\5408\306F"email_verified")\3092\691C\7D22\3057\307E\3059\3002'),
unistr('OpenID\306F\3001\30A2\30A4\30C7\30F3\30C6\30A3\30C6\30A3\30FB\30D7\30ED\30D0\30A4\30C0\304C\672A\691C\8A3C\306E"email"\304A\3088\3073"phone_number"\5C5E\6027\306B\5BFE\3057\3066<code>"#name#_verified":false</code>\3092\9001\4FE1\3059\308B\3053\3068\3092\5B9A\7FA9\3057\307E\3059\3002'),
unistr('&PRODUCT_NAME.\306F\305D\306E\3088\3046\306A\672A\691C\8A3C\306E\5C5E\6027\3092\7121\8996\3057\307E\3059\3002'),
unistr('\3053\308C\306B\3088\308A\3001"#name#"\304C\300C\30E6\30FC\30B6\30FC\540D\300D\5C5E\6027\306E\5834\5408\3001\8A8D\8A3C\306F\5931\6557\3057\307E\3059\3002'),
'</p><p>',
unistr('\30A2\30A4\30C7\30F3\30C6\30A3\30C6\30A3\30FB\30D7\30ED\30D0\30A4\30C0\304C\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\8A8D\8A3C\306B\4F7F\7528\3055\308C\308B\672A\691C\8A3C\306E\30C7\30FC\30BF\306E\5165\529B\3092\653B\6483\8005\306B\8A31\53EF\3057\305F\5834\5408\3001'),
unistr('\653B\6483\8005\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5185\3067\4ED6\306E\30E6\30FC\30B6\30FC\306B\306A\308A\3059\307E\3059\3053\3068\304C\3067\304D\307E\3059\3002'),
unistr('\300C\5C5E\6027\306E\691C\8A3C\300D\30C1\30A7\30C3\30AF\306B\3088\308A\3001\3053\308C\3092\9632\3050\3053\3068\304C\3067\304D\307E\3059\3002'),
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388762589390412438.442)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>110
,p_prompt=>unistr('\8FFD\52A0\30E6\30FC\30B6\30FC\5C5E\6027\306E\30DE\30C3\30D7\5148')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>'G_EMAIL,G_PROFILE,G_PICTURE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<em>\8FFD\52A0\30E6\30FC\30B6\30FC\5C5E\6027</em>\3092\30DE\30C3\30D7\3059\308B\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\540D\306E\30AB\30F3\30DE\533A\5207\308A\30EA\30B9\30C8\3092\6307\5B9A\3057\307E\3059\3002\305F\3068\3048\3070\3001\6B21\306E\3088\3046\306B\8A2D\5B9A\3057\305F\5834\5408'),
'<ul>',
unistr('<li>\8FFD\52A0\30E6\30FC\30B6\30FC\5C5E\6027: email,profile,picture</li>'),
unistr('<li>\8FFD\52A0\30E6\30FC\30B6\30FC\5C5E\6027\306E\30DE\30C3\30D7\5148: G_EMAIL,G_PROFILE,G_PICTURE</li>'),
'</ul>',
unistr('APEX\306F\3001\5BFE\5FDC\3059\308B\30A2\30A4\30C6\30E0\306E\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\306B\5C5E\6027\5024\3092\81EA\52D5\7684\306B\4FDD\5B58\3057\307E\3059\3002')))
);
end;
/
prompt --application/shared_components/plugins/region_type/jqm_list_view
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(37314610637444633.442)
,p_plugin_type=>'REGION TYPE'
,p_name=>'JQM_LIST_VIEW'
,p_display_name=>unistr('\30EA\30B9\30C8\30FB\30D3\30E5\30FC')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','JQM_LIST_VIEW'),'')
,p_api_version=>1
,p_ajax_function=>'x'
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:FETCHED_ROWS:NO_DATA_FOUND_MESSAGE:ESCAPE_OUTPUT'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\30CA\30D3\30B2\30FC\30C8\3057\3084\3059\3044\30EA\30B9\30C8\306B\30C7\30FC\30BF\3092\8868\793A\3057\307E\3059\3002\69D8\3005\306A\6A5F\80FD\3092\7D44\307F\8FBC\3093\3067\30EA\30B9\30C8\30FB\30D3\30E5\30FC\306E\6A5F\80FD\3092\62E1\5F35\3059\308B\3053\3068\3082\3067\304D\307E\3059\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37319921504457296.442)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\6A5F\80FD')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\3053\306E\30EA\30B9\30C8\30FB\30D3\30E5\30FC\306B\5BFE\3057\3066\6709\52B9\306B\3059\308B\6A5F\80FD\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(37507022952387983.442)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.442)
,p_display_sequence=>5
,p_display_value=>unistr('\62E1\5F35\30D5\30A9\30FC\30DE\30C3\30C8')
,p_return_value=>'ADVANCED_FORMATTING'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24342207873614875.442)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.442)
,p_display_sequence=>10
,p_display_value=>unistr('\30A4\30E1\30FC\30B8\306E\8868\793A')
,p_return_value=>'IMAGE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24341804410613872.442)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.442)
,p_display_sequence=>20
,p_display_value=>unistr('\30EA\30B9\30C8\533A\5207\308A\306E\8868\793A')
,p_return_value=>'DIVIDER'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24343018955618095.442)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.442)
,p_display_sequence=>50
,p_display_value=>unistr('\5206\5272\30DC\30BF\30F3\3042\308A')
,p_return_value=>'SPLIT_BUTTON'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24341429213611599.442)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.442)
,p_display_sequence=>55
,p_display_value=>unistr('\691C\7D22\306E\6709\52B9\5316')
,p_return_value=>'SEARCH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24342612721616279.442)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.442)
,p_display_sequence=>65
,p_display_value=>unistr('\30CD\30B9\30C8\3057\305F\30EA\30B9\30C8\30FB\30D3\30E5\30FC')
,p_return_value=>'NESTED'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(37507428146389462.442)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.442)
,p_display_sequence=>70
,p_display_value=>unistr('\30BB\30C3\30C8\5185\30EA\30B9\30C8')
,p_return_value=>'INSET'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37321616440465218.442)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\30C6\30AD\30B9\30C8\5217')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_help_text=>unistr('\30EA\30B9\30C8\30FB\30D3\30E5\30FC\30FB\30A8\30F3\30C8\30EA\306E\30E1\30A4\30F3\30FB\30B3\30F3\30C6\30F3\30C4\3092\542B\3080\30C7\30FC\30BF\30D9\30FC\30B9\5217\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18004831401462408.442)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\30EA\30B9\30C8\5C5E\6027')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>40
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\30AF\30E9\30A4\30A2\30F3\30C8\306F\30EA\30B9\30C8\30FB\30A2\30A4\30C6\30E0\30FB\30C6\30AD\30B9\30C8\306B\57FA\3065\3044\3066\533A\5207\308A\3092\4F5C\6210</dt>'),
'<dd><pre>',
'data-autodividers=true',
'</pre></dd>',
unistr('<dt>\30A2\30A4\30B3\30F3\3092\5909\66F4</dt>'),
'<dd><pre>',
'data-icon="fa-gear"',
'</pre></dd>',
unistr('<dt>\5206\5272\30DC\30BF\30F3\30FB\30A2\30A4\30B3\30F3\3092\5909\66F4</dt>'),
'<dd><pre>',
'data-split-icon="fa-gear"',
'</pre></dd>',
'</dl>'))
,p_help_text=>unistr('\30EA\30B9\30C8\8981\7D20\306B\8A2D\5B9A\3055\308C\308B\8FFD\52A0\306E\5C5E\6027\3092\5165\529B\3057\307E\3059\3002\30EA\30B9\30C8\30FB\30D3\30E5\30FC\306B\5F71\97FF\3059\308B\5C5E\6027\306E\4F8B\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18003624513413103.442)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\30EA\30B9\30C8\30FB\30A8\30F3\30C8\30EA\306E\5C5E\6027')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>40
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\524A\9664\3059\308B\30EA\30B9\30C8\30FB\30A8\30F3\30C8\30EA\30FB\30EA\30F3\30AF\30FB\30A2\30A4\30B3\30F3\3092\8A2D\5B9A\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'data-icon="delete"',
'</pre></dd>',
'</dl>'))
,p_help_text=>unistr('\30EA\30B9\30C8\30FB\30A2\30A4\30C6\30E0\8981\7D20\306B\8A2D\5B9A\3059\308B\8FFD\52A0\306E\5C5E\6027\3092\5165\529B\3057\307E\3059\3002\30EA\30B9\30C8\30FB\30D3\30E5\30FC\306B\5F71\97FF\3059\308B\5C5E\6027\306E\4F8B\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37322140682472248.442)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\30C6\30AD\30B9\30C8\5F62\5F0F')
,p_attribute_type=>'HTML'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\5F93\696D\54E1\306E\540D\524D\3068\3001\305D\306E\4E0B\306B\5165\793E\65E5\3092\8868\793A</dt>'),
'<dd><pre>',
'&lt;h3&gt;&amp;ENAME.&lt;/h3&gt;',
'&lt;p&gt;Hire date: &amp;HIREDATE.&lt;/p&gt;',
'</pre></dd>',
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30EA\30B9\30C8\30FB\30D3\30E5\30FC\30FB\30A8\30F3\30C8\30EA\306E\30E1\30A4\30F3\30FB\30B3\30F3\30C6\30F3\30C4\3092\30EC\30F3\30C0\30EA\30F3\30B0\3059\308BHTML\30DE\30FC\30AF\30A2\30C3\30D7\3092\5165\529B\3057\307E\3059\3002</p>'),
unistr('<p>\30EA\30B9\30C8\30FB\30D3\30E5\30FC\306E\5217\306E\5024\3092\53C2\7167\3059\308B\305F\3081\306B\3001SQL\6587\306F\7F6E\63DB\69CB\6587\3092\4F7F\7528\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37323637481490256.442)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\88DC\8DB3\60C5\5831\5217')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_help_text=>unistr('\30EA\30B9\30C8\30FB\30D3\30E5\30FC\30FB\30A8\30F3\30C8\30EA\306E\88DC\8DB3\60C5\5831\3092\542B\3080\30C7\30FC\30BF\30D9\30FC\30B9\5217\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37512329447408820.442)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\88DC\8DB3\60C5\5831\306E\5F62\5F0F')
,p_attribute_type=>'HTML'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\7D66\4E0E\3092\592A\5B57\3067\8868\793A</dt>'),
'<dd><pre>',
'USD &lt;strong&gt;&amp;SAL.&lt;/strong&gt;',
'</pre></dd>',
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30EA\30B9\30C8\30FB\30D3\30E5\30FC\30FB\30A8\30F3\30C8\30EA\306E\88DC\8DB3\60C5\5831\3092\30EC\30F3\30C0\30EA\30F3\30B0\3059\308BHTML\30DE\30FC\30AF\30A2\30C3\30D7\3092\5165\529B\3057\307E\3059\3002</p>'),
unistr('<p>\30EA\30B9\30C8\30FB\30D3\30E5\30FC\306E\5217\306E\5024\3092\53C2\7167\3059\308B\305F\3081\306B\3001SQL\6587\306F\7F6E\63DB\69CB\6587\3092\4F7F\7528\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37323130554488257.442)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\30AB\30A6\30F3\30BF\5217')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:NUMBER'
,p_is_translatable=>false
,p_help_text=>unistr('\30AB\30A6\30F3\30C8\30FB\30D0\30D6\30EB\3067\8868\793A\3059\308B\5024\3092\542B\3080\30C7\30FC\30BF\30D9\30FC\30B9\5217\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(42537525650337692.442)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\30A4\30E1\30FC\30B8\30FB\30BF\30A4\30D7')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'IMAGE_BLOB'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'IMAGE'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\8868\793A\3059\308B\30A4\30E1\30FC\30B8\306E\7A2E\985E\3068\3001\305D\306E\8AAD\53D6\308A\30BD\30FC\30B9\3092\9078\629E\3057\307E\3059\3002\8868\793A\3055\308C\308B\30A4\30E1\30FC\30B8\306F\300116x16\30B5\30A4\30BA\306E\30A2\30A4\30B3\30F3\304B\300180x80\30B5\30A4\30BA\306E\30B5\30E0\30CD\30A4\30EB\3067\3059\3002\30A4\30E1\30FC\30B8\306E\30BD\30FC\30B9\306F\3001\30C7\30FC\30BF\30D9\30FC\30B9BLOB\5217\304B\3001\9759\7684\30D5\30A1\30A4\30EB\3078\306EURL\3067\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(42538712275343327.442)
,p_plugin_attribute_id=>wwv_flow_api.id(42537525650337692.442)
,p_display_sequence=>20
,p_display_value=>unistr('BLOB\5F62\5F0F\3067\683C\7D0D\3055\308C\3066\3044\308B\30A2\30A4\30B3\30F3')
,p_return_value=>'ICON_BLOB'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(42539233400349414.442)
,p_plugin_attribute_id=>wwv_flow_api.id(42537525650337692.442)
,p_display_sequence=>30
,p_display_value=>unistr('URL\304B\3089\8AAD\307F\53D6\3089\308C\305F\30A2\30A4\30B3\30F3')
,p_return_value=>'ICON_URL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(42539638940351053.442)
,p_plugin_attribute_id=>wwv_flow_api.id(42537525650337692.442)
,p_display_sequence=>40
,p_display_value=>unistr('BLOB\5F62\5F0F\3067\683C\7D0D\3055\308C\3066\3044\308B\30A4\30E1\30FC\30B8')
,p_return_value=>'IMAGE_BLOB'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(42540042403352086.442)
,p_plugin_attribute_id=>wwv_flow_api.id(42537525650337692.442)
,p_display_sequence=>50
,p_display_value=>unistr('URL\304B\3089\8AAD\307F\53D6\3089\308C\305F\30A4\30E1\30FC\30B8')
,p_return_value=>'IMAGE_URL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37324142675491770.442)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('\30A4\30E1\30FC\30B8BLOB\5217')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'BLOB'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(42537525650337692.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ICON_BLOB,IMAGE_BLOB'
,p_help_text=>unistr('\30A4\30E1\30FC\30B8\3092\542B\3080BLOB\30C7\30FC\30BF\578B\306E\30C7\30FC\30BF\30D9\30FC\30B9\5217\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(42541812668371813.442)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>unistr('\30A4\30E1\30FC\30B8\306E\4E3B\30AD\30FC\52171')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:INTERVAL_Y2M:INTERVAL_D2S:ROWID'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(42537525650337692.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ICON_BLOB,IMAGE_BLOB'
,p_help_text=>unistr('\30A4\30E1\30FC\30B8\306E\30EB\30C3\30AF\30A2\30C3\30D7\306B\4F7F\7528\3059\308B\4E3B\30AD\30FC\5217\307E\305F\306F\4E00\610F\306E\30C7\30FC\30BF\30D9\30FC\30B9\5217\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(24272827642729595.442)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>unistr('\30A4\30E1\30FC\30B8\306E\4E3B\30AD\30FC\52172')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:INTERVAL_Y2M:INTERVAL_D2S'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(42541812668371813.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('\30A4\30E1\30FC\30B8\306E\30EB\30C3\30AF\30A2\30C3\30D7\306B\4F7F\7528\3059\308B2\3064\76EE\306E\4E3B\30AD\30FC\5217\307E\305F\306F\4E00\610F\306E\30C7\30FC\30BF\30D9\30FC\30B9\5217\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(24218503552483082.442)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_prompt=>unistr('\30A4\30E1\30FC\30B8URL\5217')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(42537525650337692.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ICON_URL,IMAGE_URL'
,p_help_text=>unistr('\30A2\30A4\30B3\30F3/\30A4\30E1\30FC\30B8\3078\306EURL\3092\542B\3080\30C7\30FC\30BF\30D9\30FC\30B9\5217\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37324722720495516.442)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>unistr('\30EA\30B9\30C8\533A\5207\308A\5217')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DIVIDER'
,p_help_text=>unistr('\533A\5207\308A\3092\542B\3080\30C7\30FC\30BF\30D9\30FC\30B9\5217\3092\9078\629E\3057\307E\3059\3002\533A\5207\308A\306E\5024\304C\5909\308F\308B\305F\3073\306B\3001\30EA\30B9\30C8\30FB\30D3\30E5\30FC\30FB\30A8\30F3\30C8\30EA\306E\9593\306B\65B0\3057\3044\533A\5207\308A\304C\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(24027626694091285.442)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>unistr('\30EA\30B9\30C8\533A\5207\308A\5F62\5F0F')
,p_attribute_type=>'HTML'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\90E8\9580\540D\3068\5F93\696D\54E1\6570\3092\30D0\30C3\30B8\3068\3057\3066\8868\793A</dt>'),
'<dd><pre>',
'&amp;DNAME. &lt;span class="t-MediaList-badge"&gt;&amp;EMP_COUNT.&lt;/span&gt;',
'</pre></dd>',
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30EA\30B9\30C8\30FB\30D3\30E5\30FC\306E\533A\5207\308A\3092\30EC\30F3\30C0\30EA\30F3\30B0\3059\308BHTML\30DE\30FC\30AF\30A2\30C3\30D7\3092\5165\529B\3057\307E\3059\3002</p>'),
unistr('<p>\30EA\30B9\30C8\30FB\30D3\30E5\30FC\306E\5217\306E\5024\3092\53C2\7167\3059\308B\305F\3081\306B\3001SQL\6587\306F\7F6E\63DB\69CB\6587\3092\4F7F\7528\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37322614971483782.442)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>16
,p_display_sequence=>160
,p_prompt=>unistr('\30EA\30F3\30AF\30FB\30BF\30FC\30B2\30C3\30C8')
,p_attribute_type=>'LINK'
,p_is_required=>false
,p_is_translatable=>false
,p_reference_scope=>'ROW'
,p_help_text=>unistr('<p>\30E6\30FC\30B6\30FC\304C\30EA\30B9\30C8\30FB\30A8\30F3\30C8\30EA\3092\30AF\30EA\30C3\30AF\3057\305F\3068\304D\306B\547C\3073\51FA\3055\308C\308B\30BF\30FC\30B2\30C3\30C8\30FB\30DA\30FC\30B8\3092\5165\529B\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37325839689500405.442)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>17
,p_display_sequence=>170
,p_prompt=>unistr('\30DC\30BF\30F3\306E\30BF\30FC\30B2\30C3\30C8\306E\5206\5272')
,p_attribute_type=>'LINK'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SPLIT_BUTTON'
,p_reference_scope=>'ROW'
,p_help_text=>unistr('<p>\30E6\30FC\30B6\30FC\304C\30EA\30B9\30C8\30FB\30A8\30F3\30C8\30EA\3092\30AF\30EA\30C3\30AF\3057\305F\3068\304D\306B\547C\3073\51FA\3055\308C\308B\30BF\30FC\30B2\30C3\30C8\30FB\30DA\30FC\30B8\3092\5165\529B\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(24021612683850679.442)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>18
,p_display_sequence=>180
,p_prompt=>unistr('\691C\7D22\30BF\30A4\30D7')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'SERVER_EXACT_IGNORE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SEARCH'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\691C\7D22\306E\5B9F\884C\65B9\6CD5\3092\9078\629E\3057\307E\3059\3002</p>'),
unistr('<p>\30AF\30E9\30A4\30A2\30F3\30C8\5074\306E\691C\7D22\306F\3001\30E6\30FC\30B6\30FC\304C\5165\529B\3092\59CB\3081\308B\3068\3059\3050\306B\5B9F\884C\3055\308C\307E\3059\3002\30B5\30FC\30D0\30FC\30D9\30FC\30B9\306E\691C\7D22\306E\5834\5408\3001\30E6\30FC\30B6\30FC\304C[Enter]\3092\62BC\3059\3068\3001\691C\7D22\7D50\679C\304C\8868\793A\3055\308C\307E\3059\3002\30B5\30FC\30D0\30FC\30D9\30FC\30B9\306E\691C\7D22\306E\5834\5408\306E\307F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\5BFE\3057\3066\5B9A\7FA9\3055\308C\3066\3044\308B\300C\6587\5B57\306E\5024\306E\6BD4\8F03\300D\30B0\30ED\30FC\30D0\30EB\5C5E\6027\304C\8003\616E\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24022326881854766.442)
,p_plugin_attribute_id=>wwv_flow_api.id(24021612683850679.442)
,p_display_sequence=>20
,p_display_value=>unistr('\30AF\30E9\30A4\30A2\30F3\30C8\5074')
,p_return_value=>'CLIENT'
,p_help_text=>unistr('\30D6\30E9\30A6\30B6\30D9\30FC\30B9\306E\691C\7D22\3092\5B9F\884C\3059\308B\306B\306F\3001\3059\3079\3066\306E\30EA\30B9\30C8\30FB\30D3\30E5\30FC\30FB\30A8\30F3\30C8\30EA\304C\30D6\30E9\30A6\30B6\306B\30ED\30FC\30C9\3055\308C\3066\3044\308B\5FC5\8981\304C\3042\308A\307E\3059(\3053\306E\5834\5408\3001\300C\30D5\30A7\30C3\30C1\3055\308C\305F\884C\6570\300D\5C5E\6027\306F\7121\8996\3055\308C\308B\3053\3068\306B\6CE8\610F\3057\3066\304F\3060\3055\3044)\3002\3053\306E\691C\7D22\30AA\30D7\30B7\30E7\30F3\306F\5C11\6570\306E\30EA\30B9\30C8\30FB\30A8\30F3\30C8\30EA\306B\306E\307F\4F7F\7528\3057\3001\9577\6642\9593\306E\4E0D\8981\306A\30DA\30FC\30B8\30FB\30ED\30FC\30C9\304C\884C\308F\308C\306A\3044\3088\3046\306B\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24022823811882269.442)
,p_plugin_attribute_id=>wwv_flow_api.id(24021612683850679.442)
,p_display_sequence=>30
,p_display_value=>unistr('\30B5\30FC\30D0\30FC: \5B8C\5168\304A\3088\3073\5927/\5C0F\6587\5B57\533A\5225')
,p_return_value=>'SERVER_EXACT_CASE'
,p_help_text=>unistr('\691C\7D22\3067LIKE [search value]%\3092\4F7F\7528\3057\3066\7D50\679C\3092\554F\3044\5408\305B\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24023232469884808.442)
,p_plugin_attribute_id=>wwv_flow_api.id(24021612683850679.442)
,p_display_sequence=>40
,p_display_value=>unistr('\30B5\30FC\30D0\30FC: \5B8C\5168\304A\3088\3073\5927/\5C0F\6587\5B57\533A\5225\306A\3057')
,p_return_value=>'SERVER_EXACT_IGNORE'
,p_help_text=>unistr('\691C\7D22\3067LIKE UPPER( [search value] )%\3092\4F7F\7528\3057\3066\7D50\679C\3092\554F\3044\5408\305B\307E\3059\3002UPPER\5F0F\3092\4F7F\7528\3057\305F\30D5\30A1\30F3\30AF\30B7\30E7\30F3\30D9\30FC\30B9\306E\7D22\5F15\3067\306A\3044\304B\304E\308A\3001\65E2\5B58\306E\5217\306E\7D22\5F15\306F\4F7F\7528\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24023619787890578.442)
,p_plugin_attribute_id=>wwv_flow_api.id(24021612683850679.442)
,p_display_sequence=>50
,p_display_value=>unistr('\30B5\30FC\30D0\30FC: \985E\4F3C\304A\3088\3073\5927/\5C0F\6587\5B57\533A\5225')
,p_return_value=>'SERVER_LIKE_CASE'
,p_help_text=>unistr('\691C\7D22\3067LIKE %[search value]%\3092\4F7F\7528\3057\3066\7D50\679C\3092\554F\3044\5408\305B\307E\3059\3002\3053\308C\306B\3088\3063\3066\3001\305D\306E\5217\306E\65E2\5B58\306E\7D22\5F15\306F\4F7F\7528\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24024029483893440.442)
,p_plugin_attribute_id=>wwv_flow_api.id(24021612683850679.442)
,p_display_sequence=>60
,p_display_value=>unistr('\30B5\30FC\30D0\30FC: \985E\4F3C\304A\3088\3073\5927/\5C0F\6587\5B57\533A\5225\306A\3057')
,p_return_value=>'SERVER_LIKE_IGNORE'
,p_help_text=>unistr('\691C\7D22\3067LIKE %UPPER( [search value] )%\3092\4F7F\7528\3057\3066\7D50\679C\3092\554F\3044\5408\305B\307E\3059\3002\3053\308C\306B\3088\3063\3066\3001\305D\306E\5217\306E\65E2\5B58\306E\7D22\5F15\306F\4F7F\7528\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(10775027534399383.442)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>19
,p_display_sequence=>190
,p_prompt=>unistr('\5217\306E\691C\7D22')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SEARCH'
,p_help_text=>unistr('\691C\7D22\306B\4F7F\7528\3059\308B\4EE3\66FF\306E\30C7\30FC\30BF\30D9\30FC\30B9\5217\3092\9078\629E\3057\307E\3059\3002\4F55\3082\6307\5B9A\3057\306A\3044\5834\5408\306F\3001\30C6\30AD\30B9\30C8\5217\304C\4F7F\7528\3055\308C\307E\3059\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37327132202507698.442)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>20
,p_display_sequence=>200
,p_prompt=>unistr('\691C\7D22\30DC\30C3\30AF\30B9\306E\30D7\30EC\30FC\30B9\30DB\30EB\30C0\30FC')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SEARCH'
,p_help_text=>unistr('\691C\7D22\30DC\30C3\30AF\30B9\306B\8868\793A\3055\308C\308B\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002\5024\3092\6307\5B9A\3057\306A\3044\5834\5408\306F\3001\30B7\30B9\30C6\30E0\30FB\30E1\30C3\30BB\30FC\30B8<strong>APEX.REGION.JQM_LIST_VIEW.SEARCH</strong>\306E\5024\304C\4F7F\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37325332071498117.442)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>21
,p_display_sequence=>210
,p_prompt=>unistr('\30CD\30B9\30C8\3057\305F\30EA\30B9\30C8\5217')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'NUMBER'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'NESTED'
,p_help_text=>unistr('\30CD\30B9\30C8\3057\305F\554F\5408\305B\306E\968E\5C64\30EC\30D9\30EB\3092\542B\3080\30C7\30FC\30BF\30D9\30FC\30B9\5217\3092\9078\629E\3057\307E\3059\3002CONNECT BY\554F\5408\305B\3092\4F7F\7528\3059\308B\5834\5408\306F\3001\64EC\4F3C\5217<code>LEVEL</code>\3092\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(644548607716477014.442)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.442)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\3059\3079\3066\306E\5F93\696D\54E1\3092\540D\524D\9806\306B\8868\793A</dt>'),
'<dd><pre>',
'SELECT * FROM emp ORDER by ename',
'</pre></dd>',
unistr('<dt>\73FE\5728\306E\90E8\9580\306E\3059\3079\3066\306E\5F93\696D\54E1\3092\540D\524D\9806\306B\8868\793A</dt>'),
'<dd><pre>',
'SELECT * FROM emp ',
'WHERE deptno = :P3_DEPTNO ',
'ORDER by 1',
'</pre>',
unistr('<p>\30D0\30A4\30F3\30C9\5909\6570\3092\4F7F\7528\3057\3066\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3092\53C2\7167\3059\308B\3068\304D\306F\3001<strong>\300C\9001\4FE1\3059\308B\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\300D</strong>\3068\3057\3066\6307\5B9A\3057\3066\304F\3060\3055\3044\3002</p>'),
'</dd>',
unistr('<dt>ROWID\3092\4E3B\30AD\30FC\5217\3068\3057\3066\4F7F\7528</dt>'),
'<dd><pre>',
'SELECT a.rowid as pk_rowid, ',
'       a.* ',
'  FROM emp a ',
'ORDER BY a.ename',
'</pre>',
unistr('<p>ROWID\3092\4F7F\7528\3059\308B\5834\5408\3001\5217\306E\5225\540D\304C\5FC5\8981\3067\3059\3002</p>'),
'</dd>',
unistr('<dt>\3059\3079\3066\306E\5F93\696D\54E1\3092\8FD4\3059\30CD\30B9\30C8\3057\305F\554F\5408\305B</dt>'),
'<dd><pre>',
' select ename,',
'        level',
'   from emp',
'connect by prior empno = mgr',
'  start with mgr is null',
' order siblings by ename',
'</pre></dd>',
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/close_region
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(72276595215456808.442)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'CLOSE_REGION'
,p_display_name=>unistr('\30EA\30FC\30B8\30E7\30F3\3092\9589\3058\308B')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','CLOSE_REGION'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\30A4\30F3\30E9\30A4\30F3\30FB\30C0\30A4\30A2\30ED\30B0\3001\30A4\30F3\30E9\30A4\30F3\30FB\30DD\30C3\30D7\30A2\30C3\30D7\307E\305F\306F\7E2E\5C0F\53EF\80FD\306A\3069\3001\958B\304F\3053\3068\304C\53EF\80FD\304B\73FE\306B\958B\304B\308C\3066\3044\308B\30EA\30FC\30B8\30E7\30F3\3092\9589\3058\307E\3059\3002')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/open_region
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(72276779733456826.442)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'OPEN_REGION'
,p_display_name=>unistr('\30EA\30FC\30B8\30E7\30F3\3092\958B\304F')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','OPEN_REGION'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\30A4\30F3\30E9\30A4\30F3\30FB\30C0\30A4\30A2\30ED\30B0\3001\30A4\30F3\30E9\30A4\30F3\30FB\30DD\30C3\30D7\30A2\30C3\30D7\307E\305F\306F\7E2E\5C0F\53EF\80FD\306A\3069\3001\958B\304F\3053\3068\304C\53EF\80FD\306A\30EA\30FC\30B8\30E7\30F3\3092\958B\304D\307E\3059\3002')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authorization_type/is_in_group
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(132376923088056966.442)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'IS_IN_GROUP'
,p_display_name=>unistr('\30ED\30FC\30EB\307E\305F\306F\30B0\30EB\30FC\30D7\5185\306B\3042\308B')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','IS_IN_GROUP'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(132377321338088226.442)
,p_plugin_id=>wwv_flow_api.id(132376923088056966.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\540D\524D')
,p_attribute_type=>'AUTHORIZATION GROUPS'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('1\3064\4EE5\4E0A\306E\30AB\30F3\30DE\533A\5207\308A\306E\30B0\30EB\30FC\30D7\540D\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(91772529032268265.442)
,p_plugin_id=>wwv_flow_api.id(132376923088056966.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>5
,p_prompt=>unistr('\30BF\30A4\30D7')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'A'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(91772831765269995.442)
,p_plugin_attribute_id=>wwv_flow_api.id(91772529032268265.442)
,p_display_sequence=>10
,p_display_value=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30ED\30FC\30EB')
,p_return_value=>'A'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(91773214348271589.442)
,p_plugin_attribute_id=>wwv_flow_api.id(91772529032268265.442)
,p_display_sequence=>20
,p_display_value=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\30FB\30B0\30EB\30FC\30D7')
,p_return_value=>'W'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(91773695579272344.442)
,p_plugin_attribute_id=>wwv_flow_api.id(91772529032268265.442)
,p_display_sequence=>30
,p_display_value=>unistr('\30AB\30B9\30BF\30E0')
,p_return_value=>'C'
);
end;
/
prompt --application/shared_components/plugins/authorization_type/is_not_in_group
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(132377111646077506.442)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'IS_NOT_IN_GROUP'
,p_display_name=>unistr('\30ED\30FC\30EB\307E\305F\306F\30B0\30EB\30FC\30D7\5185\306B\306A\3044')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','IS_NOT_IN_GROUP'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(135876608363708702.442)
,p_plugin_id=>wwv_flow_api.id(132377111646077506.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\540D\524D')
,p_attribute_type=>'AUTHORIZATION GROUPS'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('1\3064\4EE5\4E0A\306E\30AB\30F3\30DE\533A\5207\308A\306E\30B0\30EB\30FC\30D7\540D\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(91774410321279131.442)
,p_plugin_id=>wwv_flow_api.id(132377111646077506.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>5
,p_prompt=>unistr('\30BF\30A4\30D7')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'A'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(91774719920280165.442)
,p_plugin_attribute_id=>wwv_flow_api.id(91774410321279131.442)
,p_display_sequence=>10
,p_display_value=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30ED\30FC\30EB')
,p_return_value=>'A'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(91775192472281109.442)
,p_plugin_attribute_id=>wwv_flow_api.id(91774410321279131.442)
,p_display_sequence=>20
,p_display_value=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\30FB\30B0\30EB\30FC\30D7')
,p_return_value=>'W'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(91775511878281830.442)
,p_plugin_attribute_id=>wwv_flow_api.id(91774410321279131.442)
,p_display_sequence=>30
,p_display_value=>unistr('\30AB\30B9\30BF\30E0')
,p_return_value=>'C'
);
end;
/
prompt --application/shared_components/plugins/item_type/date_picker_jet
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(144248864922483430.442)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'DATE_PICKER_JET'
,p_display_name=>unistr('\65E5\4ED8\30D4\30C3\30AB\30FC')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','DATE_PICKER_JET'),'')
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_validation_function=>'dummy_to_trigger_basic_validation'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:FORMAT_MASK_DATE:ELEMENT:WIDTH:PLACEHOLDER:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30AB\30EC\30F3\30C0\30FB\30A2\30A4\30B3\30F3\4ED8\304D\306E\30C6\30AD\30B9\30C8\30FB\30D5\30A3\30FC\30EB\30C9\3092\8868\793A\3057\307E\3059\3002\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\3001\30C6\30AD\30B9\30C8\30FB\30A2\30A4\30C6\30E0\306B\76F4\63A5\65E5\4ED8\3092\5165\529B\3059\308B\304B\3001\30AB\30EC\30F3\30C0\30FB\30A2\30A4\30B3\30F3\3092\30AF\30EA\30C3\30AF\3057\3066\30AB\30EC\30F3\30C0\30FB\30DD\30C3\30D7\30A2\30C3\30D7\304B\3089\65E5\4ED8(\304A\3088\3073\30AA\30D7\30B7\30E7\30F3\3067\6642\9593)\3092\9078\629E\3057\307E\3059\3002</p>'),
unistr('<p>\3053\306E\30A2\30A4\30C6\30E0\306E<em>\66F8\5F0F\30DE\30B9\30AF</em>\306B\6642\9593\30B3\30F3\30DD\30FC\30CD\30F3\30C8\304C\542B\307E\308C\3066\3044\308B\5834\5408\3001\6642\9593\306F\30AB\30EC\30F3\30C0\30FB\30DD\30C3\30D7\30A2\30C3\30D7\306B\306E\307F\8868\793A\3055\308C\307E\3059\3002</p>')))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(142750950234528930.442)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.442)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\5916\89B3')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_default_value=>'MONTH-PICKER:YEAR-PICKER'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\65E5\4ED8\306E\9078\629E\306B\4F7F\7528\3055\308C\308B\30AB\30EC\30F3\30C0\306E\5916\89B3\306E\5236\5FA1\3002</p>'),
unistr('<p>\30CE\30FC\30C8: \3053\308C\306F\3001\300C\8868\793A\5F62\5F0F\300D\304C\300C\30DD\30C3\30D7\30A2\30C3\30D7\300D\307E\305F\306F\300C\30A4\30F3\30E9\30A4\30F3\300D\306E\3044\305A\308C\304B\306E\5834\5408\306B\306E\307F\4F7F\7528\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142751748618530462.442)
,p_plugin_attribute_id=>wwv_flow_api.id(142750950234528930.442)
,p_display_sequence=>10
,p_display_value=>unistr('\9031\306E\8868\793A')
,p_return_value=>'SHOW-WEEK'
,p_help_text=>unistr('\5E74\9593\901A\7B97\9031\3092\8868\793A\3059\308B\304B\3069\3046\304B')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142752536880532293.442)
,p_plugin_attribute_id=>wwv_flow_api.id(142750950234528930.442)
,p_display_sequence=>20
,p_display_value=>unistr('\6708\30D4\30C3\30AB\30FC')
,p_return_value=>'MONTH-PICKER'
,p_help_text=>unistr('\6708\3092\30C6\30AD\30B9\30C8\3067\306F\306A\304F\9078\629E\304C\53EF\80FD\306A\30DC\30BF\30F3\3068\3057\3066\30EC\30F3\30C0\30EA\30F3\30B0\3059\308B\304B\3069\3046\304B')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142752956214532903.442)
,p_plugin_attribute_id=>wwv_flow_api.id(142750950234528930.442)
,p_display_sequence=>30
,p_display_value=>unistr('\5E74\30D4\30C3\30AB\30FC')
,p_return_value=>'YEAR-PICKER'
,p_help_text=>unistr('\5E74\3092\30C6\30AD\30B9\30C8\3067\306F\306A\304F\9078\629E\304C\53EF\80FD\306A\30DC\30BF\30F3\3068\3057\3066\30EC\30F3\30C0\30EA\30F3\30B0\3059\308B\304B\3069\3046\304B')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(143948862668782714.442)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.442)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\6708\306E\7BC4\56F2\5916\306E\65E5')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VISIBLE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\73FE\5728\306E\8868\793A\4E2D\306E\6708\4EE5\5916\306E\65E5\306E\52D5\4F5C\3092\6307\5B9A\3057\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8: \3053\308C\306F\3001\300C\8868\793A\5F62\5F0F\300D\304C\300C\30DD\30C3\30D7\30A2\30C3\30D7\300D\307E\305F\306F\300C\30A4\30F3\30E9\30A4\30F3\300D\306E\3044\305A\308C\304B\306E\5834\5408\306B\306E\307F\4F7F\7528\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(143949419755783405.442)
,p_plugin_attribute_id=>wwv_flow_api.id(143948862668782714.442)
,p_display_sequence=>10
,p_display_value=>unistr('\975E\8868\793A')
,p_return_value=>'HIDDEN'
,p_help_text=>unistr('\73FE\5728\8868\793A\4E2D\306E\6708\306E\7BC4\56F2\5916\306E\65E5\306F\975E\8868\793A\306B\306A\308A\307E\3059')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(143949752332784630.442)
,p_plugin_attribute_id=>wwv_flow_api.id(143948862668782714.442)
,p_display_sequence=>20
,p_display_value=>unistr('\9078\629E\53EF\80FD')
,p_return_value=>'SELECTABLE'
,p_help_text=>unistr('\73FE\5728\8868\793A\4E2D\306E\6708\306E\7BC4\56F2\5916\306E\65E5\306F\8868\793A\3055\308C\3001\9078\629E\3067\304D\307E\3059')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(143950165800785286.442)
,p_plugin_attribute_id=>wwv_flow_api.id(143948862668782714.442)
,p_display_sequence=>30
,p_display_value=>unistr('\8868\793A\53EF\80FD')
,p_return_value=>'VISIBLE'
,p_help_text=>unistr('\73FE\5728\8868\793A\4E2D\306E\6708\306E\7BC4\56F2\5916\306E\65E5\306F\8868\793A\3055\308C\307E\3059')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(142148878705941262.442)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.442)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\6642\9593\306E\5897\5206')
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'15'
,p_display_length=>10
,p_max_length=>2
,p_unit=>unistr('\5206')
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6642\9593\9078\629E\5236\5FA1\3067\4F7F\7528\3055\308C\308B\6642\9593\306E\5897\5206(\5206\5358\4F4D)\3002\30CE\30FC\30C8: \3053\308C\306F\3001\6642\9593\306E\9078\629E\306B\4F7F\7528\3055\308C\308B\5236\5FA1\306E\307F\3092\5236\5FA1\3057\3001\3053\308C\3089\306E\5897\5206\4EE5\5916\306E\6642\9593\306F\3001\624B\52D5\3067\5165\529B\3057\4FDD\5B58\3067\304D\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8: \3053\308C\306F\3001\300C\8868\793A\5F62\5F0F\300D\304C\300C\30DD\30C3\30D7\30A2\30C3\30D7\300D\307E\305F\306F\300C\30A4\30F3\30E9\30A4\30F3\300D\306E\3044\305A\308C\304B\3067\3042\308A\3001\304B\3064\300C\6642\9593\306E\8868\793A\300D\304C\30AA\30F3\306E\5834\5408\306B\306E\307F\4F7F\7528\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(267715778102442717.442)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.442)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\8868\793A\6761\4EF6')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FOCUS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\30AB\30EC\30F3\30C0\30FB\30DD\30C3\30D7\30A2\30C3\30D7\304C\8868\793A\3055\308C\308B\30BF\30A4\30DF\30F3\30B0\3092\5236\5FA1\3057\307E\3059\3002\30CE\30FC\30C8: \3053\308C\306F\3001\300C\8868\793A\5F62\5F0F\300D\304C\300C\30DD\30C3\30D7\30A2\30C3\30D7\300D\307E\305F\306F\300C\30A4\30F3\30E9\30A4\30F3\300D\306E\3044\305A\308C\304B\306E\5834\5408\306B\306E\307F\4F7F\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(267716390932439526.442)
,p_plugin_attribute_id=>wwv_flow_api.id(267715778102442717.442)
,p_display_sequence=>10
,p_display_value=>unistr('\30A2\30A4\30C6\30E0\30FB\30D5\30A9\30FC\30AB\30B9')
,p_return_value=>'FOCUS'
,p_help_text=>unistr('\30A2\30A4\30C6\30E0\304C\30D5\30A9\30FC\30AB\30B9\3092\5F97\305F\5834\5408\3001\307E\305F\306F\30AB\30EC\30F3\30C0\30FB\30A2\30A4\30B3\30F3\304C\30AF\30EA\30C3\30AF\3055\308C\305F\5834\5408\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(267716858979438151.442)
,p_plugin_attribute_id=>wwv_flow_api.id(267715778102442717.442)
,p_display_sequence=>20
,p_display_value=>unistr('\30A2\30A4\30B3\30F3\30FB\30AF\30EA\30C3\30AF')
,p_return_value=>'IMAGE'
,p_help_text=>unistr('\30AB\30EC\30F3\30C0\30FB\30A2\30A4\30B3\30F3\304C\30AF\30EA\30C3\30AF\3055\308C\305F\5834\5408\306E\307F\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(141154378544914000.442)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\6642\9593\306E\8868\793A')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\6642\9593\60C5\5831\3092\542B\3081\308B\304B\3069\3046\304B')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(144250268701483448.442)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\8868\793A\5F62\5F0F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'POPUP'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\65E5\4ED8\30D4\30C3\30AB\30FC\306E\8868\793A\30E2\30FC\30C9\3092\9078\629E\3057\307E\3059')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(144250658827483448.442)
,p_plugin_attribute_id=>wwv_flow_api.id(144250268701483448.442)
,p_display_sequence=>10
,p_display_value=>unistr('\30DD\30C3\30D7\30A2\30C3\30D7')
,p_return_value=>'POPUP'
,p_help_text=>unistr('\30AB\30EC\30F3\30C0\306F\3001\30A2\30A4\30C6\30E0\304C\30D5\30A9\30FC\30AB\30B9\3092\5F97\305F\3068\304D\3001\307E\305F\306F\30AB\30EC\30F3\30C0\30FB\30A2\30A4\30B3\30F3\304C\30AF\30EA\30C3\30AF\3055\308C\305F\3068\304D\306B\30DD\30C3\30D7\30A2\30C3\30D7\306B\8868\793A\3055\308C\307E\3059')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(144252202058483449.442)
,p_plugin_attribute_id=>wwv_flow_api.id(144250268701483448.442)
,p_display_sequence=>20
,p_display_value=>unistr('\30A4\30F3\30E9\30A4\30F3')
,p_return_value=>'INLINE'
,p_help_text=>unistr('\30AB\30EC\30F3\30C0\306F\30DA\30FC\30B8\306B\5E38\306B\30A4\30F3\30E9\30A4\30F3\3067\8868\793A\3055\308C\307E\3059\3002\30C6\30AD\30B9\30C8\30FB\30D5\30A3\30FC\30EB\30C9\306F\8868\793A\3055\308C\305A\3001\73FE\5728\306E\65E5\4ED8\306E\9078\629E\304C\30AB\30EC\30F3\30C0\3067\5F37\8ABF\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142151127231126342.442)
,p_plugin_attribute_id=>wwv_flow_api.id(144250268701483448.442)
,p_display_sequence=>30
,p_display_value=>unistr('\30CD\30A4\30C6\30A3\30D6HTML')
,p_return_value=>'NATIVE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30D6\30E9\30A6\30B6\306B\3088\3063\3066\30B5\30DD\30FC\30C8\3055\308C\3066\3044\308B\5834\5408\3001\30CD\30A4\30C6\30A3\30D6HTML\5165\529B\65E5\4ED8\578B\3092\4F7F\7528\3057\3066\30EC\30F3\30C0\30EA\30F3\30B0\3057\307E\3059\3002\300C\6642\9593\306E\8868\793A\300D\304C\30AA\30D5\306E\5834\5408\3001''date''\578B\304C\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\3001\300C\6642\9593\306E\8868\793A\300D\304C\30AA\30F3\306E\5834\5408\3001''datetime-local''\578B\304C\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\307E\3059\3002\30CE\30FC\30C8: \3053\308C\3089\306E\65E5\4ED8\578B\306E\6B63\78BA\306A\8868\793A\306F\3001\30D6\30E9\30A6\30B6\306B\4F9D\5B58\3057\307E\3059\3002\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304C\30E2\30D0\30A4\30EB\30FB\30C7\30D0\30A4\30B9\3067\4F7F\7528\3055\308C\3066\3044\308B\5834\5408\3001\30CD\30A4\30C6\30A3\30D6HTML\304C\63A8\5968\3055\308C\308B\30AA\30D7\30B7\30E7\30F3\3067\3059\3002</p>'),
unistr('<p>\300C\30CD\30A4\30C6\30A3\30D6HTML\300D\3092\4F7F\7528\3057\3066\3044\308B\5834\5408\3001\30CD\30A4\30C6\30A3\30D6\65E5\4ED8\578B\306F\5FC5\8981\3068\3055\308C\308B\65E5\4ED8\66F8\5F0F\306B\3064\3044\3066\975E\5E38\306B\5177\4F53\7684\3067\3042\308B\305F\3081\3001\30A2\30A4\30C6\30E0\306E\300C\66F8\5F0F\30DE\30B9\30AF\300D\304CAPEX\306B\3088\3063\3066\81EA\52D5\7684\306B\8A2D\5B9A\3055\308C\3001\30E6\30FC\30B6\30FC\306F\3053\308C\3092\5909\66F4\3067\304D\306A\3044\3053\3068\306B\6CE8\610F\3057\3066\304F\3060\3055\3044\3002\305F\3060\3057\3001\3053\308C\306F\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\8868\793A\3055\308C\308B\66F8\5F0F\3067\306F\3042\308A\307E\305B\3093\3002\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\306F\3001\73FE\5728\306E\30ED\30B1\30FC\30EB\306B\9069\3057\305F\66F8\5F0F\3067\65E5\4ED8\304C\8868\793A\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(141749600267473768.442)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\6700\5C0F\65E5\4ED8')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\3053\306E\30A2\30A4\30C6\30E0\304C\6700\5C0F\306E\65E5\4ED8\3092\6301\3064\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(141750147879475182.442)
,p_plugin_attribute_id=>wwv_flow_api.id(141749600267473768.442)
,p_display_sequence=>10
,p_display_value=>unistr('\306A\3057')
,p_return_value=>'NONE'
,p_help_text=>unistr('\6700\5C0F\65E5\4ED8\306E\5B9A\7FA9\306A\3057')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(141750575076477005.442)
,p_plugin_attribute_id=>wwv_flow_api.id(141749600267473768.442)
,p_display_sequence=>20
,p_display_value=>unistr('\30A2\30A4\30C6\30E0')
,p_return_value=>'ITEM'
,p_help_text=>unistr('\6700\5C0F\65E5\4ED8\306F\3001\5225\306E\30A2\30A4\30C6\30E0\306E\5024\304B\3089\52D5\7684\306B\5C0E\51FA\3055\308C\307E\3059')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(141750953061477828.442)
,p_plugin_attribute_id=>wwv_flow_api.id(141749600267473768.442)
,p_display_sequence=>30
,p_display_value=>unistr('\9759\7684')
,p_return_value=>'STATIC'
,p_help_text=>unistr('\6700\5C0F\65E5\4ED8\306F\3001\9759\7684\5024\3067\3042\308B\304B\3001\7D76\5BFE\5024\307E\305F\306F\4ECA\65E5\306E\65E5\4ED8\304B\3089\306E\76F8\5BFE\5024\3068\3057\3066\5B9A\7FA9\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(144249127342483446.442)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\6700\5C0F\9759\7684')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(141749600267473768.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>2009-06-25T23:11:00</code></li>',
'<li><code>200906252311</code></li>',
'<li><code>+1y+1m+1w</code></li>',
'<li><code>-1m-1w</code></li>',
'<li><code>+1m-1d</code></li>',
'<li><code>&P1_MIN_AGE_DATE.</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5165\529B\307E\305F\306F\9078\629E\53EF\80FD\306A\6700\5C0F\65E5\4ED8\3092\5165\529B\3057\307E\3059\3002</p>'),
unistr('<p>\65E5\4ED8\5024\306F\3001<code>''YYYY-MM-DDTHH24:MI:SS''</code>\307E\305F\306F<code>''YYYYMMDDHH24MI''</code>\5F62\5F0F\306E\7D76\5BFE\5024\3001\4ECA\65E5\306E\65E5\4ED8\3092\57FA\6E96\3068\3057\305F\76F8\5BFE\5024(<code>+7d</code>\306A\3069)\3001\307E\305F\306F\7F6E\63DB\69CB\6587\3092\4F7F\7528\3057\305F\52D5\7684\5024(\7F6E\63DB\306B\3088\3063\3066\6B63\3057\3044\65E5\4ED8\66F8\5F0F\307E\305F\306F\76F8\5BFE\5024\304C\8FD4\3055\308C\308B\5834\5408)\3067\3059\3002</p>'),
unistr('<p>\76F8\5BFE\65E5\4ED8\5024\306B\306F\3001\6B21\306E\3082\306E\304C\3042\308A\307E\3059\3002</p>'),
'<dl>',
'  <dt>y</dt>',
unistr('    <dd>\4ECA\65E5\306E\65E5\4ED8\304B\3089\306E+ / -\5E74\6570</dd>'),
'  <dt>m</dt>',
unistr('    <dd>\4ECA\65E5\306E\65E5\4ED8\304B\3089\306E+ / -\6708\6570</dd>'),
'  <dt>w</dt>',
unistr('    <dd>\4ECA\65E5\306E\65E5\4ED8\304B\3089\306E+ / -\9031\6570</dd>'),
'  <dt>d</dt>',
unistr('    <dd>\4ECA\65E5\306E\65E5\4ED8\304B\3089\306E+ / -\65E5\6570</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(141754177794489952.442)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\6700\5C0F\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(141749600267473768.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ITEM'
,p_help_text=>unistr('<p>\6700\5C0F\8A31\5BB9\5024\3092\6C7A\5B9A\3059\308B\30A2\30A4\30C6\30E0\3002\3053\308C\306F\3001\73FE\5728\306E\30DA\30FC\30B8\307E\305F\306F\30B0\30ED\30FC\30D0\30EB\30FB\30DA\30FC\30B8\306E\3044\305A\308C\304B\306B\3042\308B\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002<p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(141850062850547994.442)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\6700\5927\65E5\4ED8')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\3053\306E\30A2\30A4\30C6\30E0\304C\6700\5927\306E\65E5\4ED8\3092\6301\3064\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(141850596251549117.442)
,p_plugin_attribute_id=>wwv_flow_api.id(141850062850547994.442)
,p_display_sequence=>10
,p_display_value=>unistr('\306A\3057')
,p_return_value=>'NONE'
,p_help_text=>unistr('\6700\5927\65E5\4ED8\306E\5B9A\7FA9\306A\3057')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(141850928550550352.442)
,p_plugin_attribute_id=>wwv_flow_api.id(141850062850547994.442)
,p_display_sequence=>20
,p_display_value=>unistr('\30A2\30A4\30C6\30E0')
,p_return_value=>'ITEM'
,p_help_text=>unistr('\6700\5927\65E5\4ED8\306F\3001\5225\306E\30A2\30A4\30C6\30E0\306E\5024\304B\3089\52D5\7684\306B\5C0E\51FA\3055\308C\307E\3059')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(141851351298550860.442)
,p_plugin_attribute_id=>wwv_flow_api.id(141850062850547994.442)
,p_display_sequence=>30
,p_display_value=>unistr('\9759\7684')
,p_return_value=>'STATIC'
,p_help_text=>unistr('\6700\5927\65E5\4ED8\306F\3001\9759\7684\5024\3067\3042\308B\304B\3001\7D76\5BFE\5024\307E\305F\306F\4ECA\65E5\306E\65E5\4ED8\304B\3089\306E\76F8\5BFE\5024\3068\3057\3066\5B9A\7FA9\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(144249516166483447.442)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\6700\5927\9759\7684')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(141850062850547994.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>2009-06-25T23:11:00</code></li>',
'<li><code>200906252311</code></li>',
'<li><code>+1y+1m+1w</code></li>',
'<li><code>-1m-1w</code></li>',
'<li><code>+1m-1d</code></li>',
'<li><code>&P1_MAX_SIGNUP_DATE.</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5165\529B\307E\305F\306F\9078\629E\53EF\80FD\306A\6700\5927\65E5\4ED8\3092\5165\529B\3057\307E\3059\3002</p>'),
unistr('<p>\65E5\4ED8\5024\306F\3001<code>''YYYY-MM-DDTHH24:MI:SS''</code>\307E\305F\306F<code>''YYYYMMDDHH24MI''</code>\5F62\5F0F\306E\7D76\5BFE\5024\3001\4ECA\65E5\306E\65E5\4ED8\3092\57FA\6E96\3068\3057\305F\76F8\5BFE\5024(<code>+7d</code>\306A\3069)\3001\307E\305F\306F\7F6E\63DB\69CB\6587\3092\4F7F\7528\3057\305F\52D5\7684\5024(\7F6E\63DB\306B\3088\3063\3066\6B63\3057\3044\65E5\4ED8\66F8\5F0F\307E\305F\306F\76F8\5BFE\5024\304C\8FD4\3055\308C\308B\5834\5408)\3067\3059\3002</p>'),
unistr('<p>\76F8\5BFE\65E5\4ED8\5024\306B\306F\3001\6B21\306E\3082\306E\304C\3042\308A\307E\3059\3002</p>'),
'<dl>',
'  <dt>y</dt>',
unistr('    <dd>\4ECA\65E5\306E\65E5\4ED8\304B\3089\306E+ / -\5E74\6570</dd>'),
'  <dt>m</dt>',
unistr('    <dd>\4ECA\65E5\306E\65E5\4ED8\304B\3089\306E+ / -\6708\6570</dd>'),
'  <dt>w</dt>',
unistr('    <dd>\4ECA\65E5\306E\65E5\4ED8\304B\3089\306E+ / -\9031\6570</dd>'),
'  <dt>d</dt>',
unistr('    <dd>\4ECA\65E5\306E\65E5\4ED8\304B\3089\306E+ / -\65E5\6570</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(141853413671557712.442)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\6700\5927\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(141850062850547994.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ITEM'
,p_help_text=>unistr('<p>\6700\5927\8A31\5BB9\5024\3092\6C7A\5B9A\3059\308B\30A2\30A4\30C6\30E0\3002\3053\308C\306F\3001\73FE\5728\306E\30DA\30FC\30B8\307E\305F\306F\30B0\30ED\30FC\30D0\30EB\30FB\30DA\30FC\30B8\306E\3044\305A\308C\304B\306B\3042\308B\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002<p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(146749239835527240.442)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\8907\6570\6708')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(144250268701483448.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'POPUP,INLINE'
,p_help_text=>unistr('\30AB\30EC\30F3\30C0\306B\8907\6570\306E\6708\3092\8868\793A\3059\308B\304B\3069\3046\304B')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(144253456913483450.442)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('\6708\6570')
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>10
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(146749239835527240.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('\4E00\5EA6\306B\8868\793A\3059\308B\6708\306E\6570')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(142950502812595734.442)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>unistr('\30C7\30D5\30A9\30EB\30C8\306E\4F7F\7528')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\300C\5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8\300D>\300C\30B3\30F3\30DD\30FC\30CD\30F3\30C8\8A2D\5B9A\300D\3067\3001\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\5BFE\3057\3066\5B9A\7FA9\3055\308C\3066\3044\308B\30C7\30D5\30A9\30EB\30C8\307E\305F\306F\30AB\30B9\30BF\30E0\8A2D\5B9A\306E\3044\305A\308C\3092\4F7F\7528\3059\308B\304B\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(142548837341436051.442)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>unistr('\5916\89B3')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_default_value=>'MONTH-PICKER:YEAR-PICKER'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(142950502812595734.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\65E5\4ED8\306E\9078\629E\306B\4F7F\7528\3055\308C\308B\30AB\30EC\30F3\30C0\306E\5916\89B3\306E\5236\5FA1\3002</p>'),
unistr('<p>\30CE\30FC\30C8: \3053\308C\306F\3001\300C\8868\793A\5F62\5F0F\300D\304C\300C\30DD\30C3\30D7\30A2\30C3\30D7\300D\307E\305F\306F\300C\30A4\30F3\30E9\30A4\30F3\300D\306E\3044\305A\308C\304B\306E\5834\5408\306B\306E\307F\4F7F\7528\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142549209563439534.442)
,p_plugin_attribute_id=>wwv_flow_api.id(142548837341436051.442)
,p_display_sequence=>10
,p_display_value=>unistr('\9031\306E\8868\793A')
,p_return_value=>'SHOW-WEEK'
,p_help_text=>unistr('\5E74\9593\901A\7B97\9031\3092\8868\793A\3059\308B\304B\3069\3046\304B')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142549539424440887.442)
,p_plugin_attribute_id=>wwv_flow_api.id(142548837341436051.442)
,p_display_sequence=>20
,p_display_value=>unistr('\6708\30D4\30C3\30AB\30FC')
,p_return_value=>'MONTH-PICKER'
,p_help_text=>unistr('\6708\3092\30C6\30AD\30B9\30C8\3067\306F\306A\304F\9078\629E\304C\53EF\80FD\306A\30DC\30BF\30F3\3068\3057\3066\30EC\30F3\30C0\30EA\30F3\30B0\3059\308B\304B\3069\3046\304B')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142549996724441519.442)
,p_plugin_attribute_id=>wwv_flow_api.id(142548837341436051.442)
,p_display_sequence=>30
,p_display_value=>unistr('\5E74\30D4\30C3\30AB\30FC')
,p_return_value=>'YEAR-PICKER'
,p_help_text=>unistr('\5E74\3092\30C6\30AD\30B9\30C8\3067\306F\306A\304F\9078\629E\304C\53EF\80FD\306A\30DC\30BF\30F3\3068\3057\3066\30EC\30F3\30C0\30EA\30F3\30B0\3059\308B\304B\3069\3046\304B')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(144048842685822298.442)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_prompt=>unistr('\6708\306E\7BC4\56F2\5916\306E\65E5')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VISIBLE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(142950502812595734.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\73FE\5728\306E\8868\793A\4E2D\306E\6708\4EE5\5916\306E\65E5\306E\52D5\4F5C\3092\6307\5B9A\3057\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8: \3053\308C\306F\3001\300C\8868\793A\5F62\5F0F\300D\304C\300C\30DD\30C3\30D7\30A2\30C3\30D7\300D\307E\305F\306F\300C\30A4\30F3\30E9\30A4\30F3\300D\306E\3044\305A\308C\304B\306E\5834\5408\306B\306E\307F\4F7F\7528\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(144049355435823179.442)
,p_plugin_attribute_id=>wwv_flow_api.id(144048842685822298.442)
,p_display_sequence=>10
,p_display_value=>unistr('\975E\8868\793A')
,p_return_value=>'HIDDEN'
,p_help_text=>unistr('\73FE\5728\8868\793A\4E2D\306E\6708\306E\7BC4\56F2\5916\306E\65E5\306F\975E\8868\793A\306B\306A\308A\307E\3059')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(144049732421823927.442)
,p_plugin_attribute_id=>wwv_flow_api.id(144048842685822298.442)
,p_display_sequence=>20
,p_display_value=>unistr('\9078\629E\53EF\80FD')
,p_return_value=>'SELECTABLE'
,p_help_text=>unistr('\73FE\5728\8868\793A\4E2D\306E\6708\306E\7BC4\56F2\5916\306E\65E5\306F\8868\793A\3055\308C\3001\9078\629E\3067\304D\307E\3059')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(144050133633824443.442)
,p_plugin_attribute_id=>wwv_flow_api.id(144048842685822298.442)
,p_display_sequence=>30
,p_display_value=>unistr('\8868\793A\53EF\80FD')
,p_return_value=>'VISIBLE'
,p_help_text=>unistr('\73FE\5728\8868\793A\4E2D\306E\6708\306E\7BC4\56F2\5916\306E\65E5\306F\8868\793A\3055\308C\307E\3059')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(141748859804709713.442)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>unistr('\6642\9593\306E\5897\5206')
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>2
,p_unit=>unistr('\5206')
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(142950502812595734.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6642\9593\9078\629E\5236\5FA1\3067\4F7F\7528\3055\308C\308B\6642\9593\306E\5897\5206(\5206\5358\4F4D)\3002\30CE\30FC\30C8: \3053\308C\306F\3001\6642\9593\306E\9078\629E\306B\4F7F\7528\3055\308C\308B\5236\5FA1\306E\307F\3092\5236\5FA1\3057\3001\3053\308C\3089\306E\5897\5206\4EE5\5916\306E\6642\9593\306F\3001\624B\52D5\3067\5165\529B\3057\4FDD\5B58\3067\304D\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8: \3053\308C\306F\3001\300C\8868\793A\5F62\5F0F\300D\304C\300C\30DD\30C3\30D7\30A2\30C3\30D7\300D\307E\305F\306F\300C\30A4\30F3\30E9\30A4\30F3\300D\306E\3044\305A\308C\304B\3067\3042\308A\3001\304B\3064\300C\6642\9593\306E\8868\793A\300D\304C\30AA\30F3\306E\5834\5408\306B\306E\307F\4F7F\7528\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(267717248823433082.442)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>unistr('\8868\793A\6761\4EF6')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FOCUS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(142950502812595734.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\30AB\30EC\30F3\30C0\30FB\30DD\30C3\30D7\30A2\30C3\30D7\304C\8868\793A\3055\308C\308B\30BF\30A4\30DF\30F3\30B0\3092\5236\5FA1\3057\307E\3059\3002\30CE\30FC\30C8: \3053\308C\306F\3001\300C\8868\793A\5F62\5F0F\300D\304C\300C\30DD\30C3\30D7\30A2\30C3\30D7\300D\307E\305F\306F\300C\30A4\30F3\30E9\30A4\30F3\300D\306E\3044\305A\308C\304B\306E\5834\5408\306B\306E\307F\4F7F\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(267717787671430611.442)
,p_plugin_attribute_id=>wwv_flow_api.id(267717248823433082.442)
,p_display_sequence=>10
,p_display_value=>unistr('\30A2\30A4\30C6\30E0\30FB\30D5\30A9\30FC\30AB\30B9')
,p_return_value=>'FOCUS'
,p_help_text=>unistr('\30A2\30A4\30C6\30E0\304C\30D5\30A9\30FC\30AB\30B9\3092\5F97\305F\5834\5408\3001\307E\305F\306F\30AB\30EC\30F3\30C0\30FB\30A2\30A4\30B3\30F3\304C\30AF\30EA\30C3\30AF\3055\308C\305F\5834\5408\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(267718203365429155.442)
,p_plugin_attribute_id=>wwv_flow_api.id(267717248823433082.442)
,p_display_sequence=>20
,p_display_value=>unistr('\30A2\30A4\30B3\30F3\30FB\30AF\30EA\30C3\30AF')
,p_return_value=>'IMAGE'
,p_help_text=>unistr('\30AB\30EC\30F3\30C0\30FB\30A2\30A4\30B3\30F3\304C\30AF\30EA\30C3\30AF\3055\308C\305F\5834\5408\306E\307F\3002')
);
end;
/
prompt --application/shared_components/plugins/item_type/single_checkbox
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(146860542307282603.442)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'SINGLE_CHECKBOX'
,p_display_name=>unistr('\30C1\30A7\30C3\30AF\30DC\30C3\30AF\30B9')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS:APEX_APPL_PAGE_FACET_GRP_ITEMS:APEX_APPL_PAGE_SFILTER_GRP_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','SINGLE_CHECKBOX'),'')
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:ENCRYPT:FILTER'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\30E6\30FC\30B6\30FC\304C\9078\629E\307E\305F\306F\9078\629E\89E3\9664\3067\304D\308B\5358\4E00\306E\30C1\30A7\30C3\30AF\30FB\30DC\30C3\30AF\30B9\3092\8868\793A\3057\307E\3059\3002\5B9A\7FA9\3055\308C\305F\9078\629E\307E\305F\306F\9078\629E\89E3\9664\306E\5024\306F\3001\9001\4FE1\6642\306B\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\306B\683C\7D0D\3055\308C\307E\3059\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(146860884924292553.442)
,p_plugin_id=>wwv_flow_api.id(146860542307282603.442)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\30C1\30A7\30C3\30AF\6E08\5024')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'Y'
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\30C1\30A7\30C3\30AF\30FB\30DC\30C3\30AF\30B9\3092\9078\629E\3057\305F\5834\5408\306B\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306B\683C\7D0D\3055\308C\308B\5024\3092\5165\529B\3057\307E\3059\3002\5024\306F\6700\5927255\6587\5B57\3067\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(146861562091295771.442)
,p_plugin_id=>wwv_flow_api.id(146860542307282603.442)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\672A\30C1\30A7\30C3\30AF\5024')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_default_value=>'N'
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('\30E6\30FC\30B6\30FC\304C\30C1\30A7\30C3\30AF\30FB\30DC\30C3\30AF\30B9\3092\9078\629E\89E3\9664\3057\305F\5834\5408\306B\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306B\683C\7D0D\3055\308C\308B\5024\3092\5165\529B\3057\307E\3059\3002\9078\629E\3055\308C\305F\3068\304D\306B<code>NULL</code>\3092\683C\7D0D\3059\308B\5834\5408\306F\3001\3053\306E\5C5E\6027\3092\7A7A\767D\306E\307E\307E\306B\3067\304D\307E\3059\3002\5024\306F\6700\5927255\6587\5B57\3067\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(146862485248305221.442)
,p_plugin_id=>wwv_flow_api.id(146860542307282603.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\30C7\30D5\30A9\30EB\30C8\306E\4F7F\7528')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\300C\5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8\300D>\300C\30B3\30F3\30DD\30FC\30CD\30F3\30C8\8A2D\5B9A\300D\3067\3001\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\5BFE\3057\3066\5B9A\7FA9\3055\308C\3066\3044\308B\30C7\30D5\30A9\30EB\30C8\307E\305F\306F\30AB\30B9\30BF\30E0\8A2D\5B9A\306E\3044\305A\308C\3092\4F7F\7528\3059\308B\304B\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(146864548825351464.442)
,p_plugin_id=>wwv_flow_api.id(146860542307282603.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\30C1\30A7\30C3\30AF\6E08\5024')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(146862485248305221.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>unistr('\306F\3044')
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('\30E6\30FC\30B6\30FC\304C\30C1\30A7\30C3\30AF\30FB\30DC\30C3\30AF\30B9\3092\9078\629E\3057\305F\5834\5408\306B\3001\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306B\683C\7D0D\3059\308B\5024\3092\5165\529B\3057\307E\3059\3002\5024\306E\6700\5927\9577\306F255\6587\5B57\3067\3059\3002</p>'),
'<p>',
unistr('\300C\30D5\30A1\30BB\30C3\30C8\691C\7D22\300D\30DA\30FC\30B8\3067\3001\30D5\30A1\30BB\30C3\30C8\304C<em>LOV\306B\57FA\3065\3044\3066</em>\554F\5408\305B\5217\3092\30D5\30A3\30EB\30BF\3059\308B\5834\5408\3001\3053\306E\5024\306FLOV\306E\8868\793A\5024\3068\623B\308A\5024\306E<em>\4E21\65B9</em>\306B\4E00\81F4\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\8868\793A\5024\3068\623B\308A\5024\304C\7570\306A\308B\5834\5408\306F\3001\3053\306E\5217\3067\3053\306E\30D5\30A1\30BB\30C3\30C8\30FB\30BF\30A4\30D7\3092\4F7F\7528\3067\304D\307E\305B\3093\3002\304B\308F\308A\306B\3001<strong>\300C\30C1\30A7\30C3\30AF\30FB\30DC\30C3\30AF\30B9\30FB\30B0\30EB\30FC\30D7\300D</strong>\30D5\30A1\30BB\30C3\30C8\3092\4F7F\7528\3057\3066\304F\3060\3055\3044\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(146865043227355165.442)
,p_plugin_id=>wwv_flow_api.id(146860542307282603.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\672A\30C1\30A7\30C3\30AF\5024')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>19
,p_max_length=>255
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(146862485248305221.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30E6\30FC\30B6\30FC\304C\30C1\30A7\30C3\30AF\30FB\30DC\30C3\30AF\30B9\3092\9078\629E\89E3\9664\3057\305F\5834\5408\306B\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306B\683C\7D0D\3055\308C\308B\5024\3092\5165\529B\3057\307E\3059\3002\9078\629E\89E3\9664\3055\308C\305F\3068\304D\306B<code>NULL</code>\3092\683C\7D0D\3059\308B\5834\5408\306F\3001\3053\306E\5C5E\6027\3092\7A7A\767D\306E\307E\307E\306B\3067\304D\307E\3059\3002\5024\306F\6700\5927255\6587\5B57\3067\3059\3002</p>'),
unistr('<p><em>\30CE\30FC\30C8: \3053\306E\5024\306F\3001\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306B\79FB\5165\3055\308C\308B\5024\304C<strong>\300C\30C1\30A7\30C3\30AF\6E08\5024\300D</strong>\3068<strong>\300C\672A\30C1\30A7\30C3\30AF\5024\300D</strong>\306E\3044\305A\308C\306B\3082\4E00\81F4\3057\306A\3044\5834\5408\306B\4F7F\7528\3055\308C\307E\3059\3002</em></p>')))
);
end;
/
prompt --application/shared_components/plugins/region_type/ig
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(230331270232947234.442)
,p_plugin_type=>'REGION TYPE'
,p_name=>'IG'
,p_display_name=>unistr('\5BFE\8A71\30B0\30EA\30C3\30C9')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','IG'),'')
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>SQL\554F\5408\305B\306B\57FA\3065\304D\3001\5B9F\884C\6642\306B\30AB\30B9\30BF\30DE\30A4\30BA\3059\308B\305F\3081\306E\69D8\3005\306A\6A5F\80FD\3092\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\63D0\4F9B\3059\308B\5305\62EC\7684\306A\30AA\30F3\30E9\30A4\30F3\8907\6570\884C\30EA\30FC\30B8\30E7\30F3\3002'),
unistr('\30EA\30FC\30B8\30E7\30F3\306F\7DE8\96C6\53EF\80FD\307E\305F\306F\8AAD\53D6\308A\5C02\7528\3068\3057\3066\5B9A\7FA9\3067\304D\307E\3059\3002</p>'),
unistr('<p>\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\56FA\6709\306E\8981\4EF6\3092\6E80\305F\3059\305F\3081\306B\6761\4EF6\304C\7570\306A\308B\540C\69D8\306E\30EA\30FC\30B8\30E7\30F3\3092\8907\6570\958B\767A\3059\308B\304B\308F\308A\306B\30011\3064\306E\5BFE\8A71\30B0\30EA\30C3\30C9\3092\5B9A\7FA9\3057\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\305D\308C\305E\308C\56FA\6709\306E\8981\4EF6\3092\6E80\305F\3059\305F\3081\306B\8868\793A\3055\308C\3066\3044\308B\30C7\30FC\30BF\3092\64CD\4F5C\3067\304D\308B\3088\3046\306B\3057\307E\3059\3002</p>')))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(465646569260662699.442)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.442)
,p_name=>'SOURCE_LOCATION'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(936016374443633302.442)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.442)
,p_name=>'apexbeginrecordedit'
,p_display_name=>unistr('\884C\306E\521D\671F\5316')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(233322074007251020.442)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.442)
,p_name=>'gridpagechange'
,p_display_name=>unistr('\30DA\30FC\30B8\5909\66F4')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(233321734838250996.442)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.442)
,p_name=>'interactivegridmodechange'
,p_display_name=>unistr('\30E2\30FC\30C9\5909\66F4')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(233322895758251022.442)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.442)
,p_name=>'interactivegridreportchange'
,p_display_name=>unistr('\5909\66F4\306E\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(230312956793621156.442)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.442)
,p_name=>'interactivegridsave'
,p_display_name=>unistr('\4FDD\5B58')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(936015222634633296.442)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.442)
,p_name=>'interactivegridselectionchange'
,p_display_name=>unistr('\9078\629E\306E\5909\66F4')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(233322485880251022.442)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.442)
,p_name=>'interactivegridviewchange'
,p_display_name=>unistr('\5909\66F4\306E\8868\793A')
);
end;
/
prompt --application/shared_components/plugins/item_type/row_selector
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(253123678064187648.442)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'ROW_SELECTOR'
,p_display_name=>unistr('\884C\30BB\30EC\30AF\30BF')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','ROW_SELECTOR'),'')
,p_api_version=>2
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\884C\64CD\4F5C\306E\305F\3081\306B\7279\5B9A\306E\884C\3092\9078\629E\53EF\80FD\306B\3059\308B\5BFE\8A71\30B0\30EA\30C3\30C9\306E\5404\884C\306E\30C1\30A7\30C3\30AF\30FB\30DC\30C3\30AF\30B9\3092\8868\793A\3057\307E\3059\3002</p>'),
unistr('<p>\30C7\30D5\30A9\30EB\30C8\3067\306F\3001APEX$ROW_SELECTOR\5217\304C\884C\30BB\30EC\30AF\30BF\306E\30BF\30A4\30D7\306B\8A2D\5B9A\3055\308C\307E\3059\3002\5BFE\8A71\30B0\30EA\30C3\30C9\304C\7DE8\96C6\53EF\80FD\306B\306A\308B\3068\3001\3053\306E\5217\304C\81EA\52D5\7684\306B\8FFD\52A0\3055\308C\307E\3059\3002</p>')))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(253123956742195925.442)
,p_plugin_id=>wwv_flow_api.id(253123678064187648.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\8907\6570\9078\629E\306E\6709\52B9\5316')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\8907\6570\306E\884C\306E\9078\629E\3092\8A31\53EF\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(253124243508199498.442)
,p_plugin_id=>wwv_flow_api.id(253123678064187648.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\3059\3079\3066\9078\629E\3092\8868\793A')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(253123956742195925.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('\30E6\30FC\30B6\30FC\306F\3001[Ctrl] + [A]\3092\4F7F\7528\3059\308B\304B\3001<em>\300C\30B3\30F3\30C8\30ED\30FC\30EB\306E\975E\8868\793A\300D</em>\304C<em>\300C\3044\3044\3048\300D</em>\306E\5834\5408\306B\5217\30D8\30C3\30C0\30FC\306E\30C1\30A7\30C3\30AF\30FB\30DC\30C3\30AF\30B9\3092\4F7F\7528\3057\3066\3001\3059\3079\3066\306E\884C\3092\9078\629E\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(276642483200371586.442)
,p_plugin_id=>wwv_flow_api.id(253123678064187648.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\30B3\30F3\30C8\30ED\30FC\30EB\306E\975E\8868\793A')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\5404\884C\306B\8868\793A\3055\308C\308B\30C1\30A7\30C3\30AF\30FB\30DC\30C3\30AF\30B9\307E\305F\306F\30E9\30B8\30AA\30FB\30B3\30F3\30C8\30ED\30FC\30EB\3092\975E\8868\793A\306B\3057\307E\3059\3002')
);
end;
/
prompt --application/shared_components/plugins/item_type/row_action
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(253124868675308889.442)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'ROW_ACTION'
,p_display_name=>unistr('\30A2\30AF\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','ROW_ACTION'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5BFE\8A71\30B0\30EA\30C3\30C9\306E\5404\884C\306E\30A2\30AF\30B7\30E7\30F3\30FB\30A2\30A4\30B3\30F3(\30CF\30F3\30D0\30FC\30AC)\3092\8868\793A\3057\307E\3059\3002'),
unistr('\30A2\30AF\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC\306B\306F\3001\30B0\30EA\30C3\30C9\5C5E\6027\304A\3088\3073\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\8A8D\53EF\306B\5FDC\3058\3066\300C\5358\4E00\884C\30D3\30E5\30FC\300D\3001\300C\884C\306E\8FFD\52A0\300D\3001\300C\884C\306E\524A\9664\300D\3001\300C\884C\306E\30EA\30D5\30EC\30C3\30B7\30E5\300D\306A\3069\306E\30AA\30D7\30B7\30E7\30F3\304C\542B\307E\308C\307E\3059\3002\3053\308C\3089\306E\30E1\30CB\30E5\30FC\30FB\30AA\30D7\30B7\30E7\30F3\306B\3088\308A\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\30B0\30EA\30C3\30C9\306E\73FE\5728\306E\884C\306B\5BFE\3057\3066\7279\5B9A\306E\30A2\30AF\30B7\30E7\30F3\3092\5B9F\884C\3067\304D\307E\3059\3002</p>'),
unistr('<p>\30A2\30AF\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC\306F\3001\7DE8\96C6\53EF\80FD\3068\7DE8\96C6\4E0D\80FD\306E\4E21\65B9\306E\5BFE\8A71\30B0\30EA\30C3\30C9\3067\4F7F\7528\3067\304D\307E\3059\304C\3001\30E1\30CB\30E5\30FC\30FB\30AA\30D7\30B7\30E7\30F3\306F\305D\308C\305E\308C\306B\5FDC\3058\3066\7570\306A\308A\307E\3059\3002\7DE8\96C6\4E0D\80FD\5BFE\8A71\30B0\30EA\30C3\30C9\3067\306F\3001\30E1\30CB\30E5\30FC\306B\306F\300C\5358\4E00\884C\30D3\30E5\30FC\300D\3084\300C\884C\306E\30EA\30D5\30EC\30C3\30B7\30E5\300D\306A\3069\3001\30AA\30D7\30B7\30E7\30F3\306E\4E00\90E8\304C\542B\307E\308C\3001\300C\884C\306E\8FFD\52A0\300D\3084\300C\884C\306E\524A\9664\300D\306A\3069\306E\7DE8\96C6\53EF\80FD\306B\56FA\6709\306E\30A2\30AF\30B7\30E7\30F3\306F\542B\307E\308C\307E\305B\3093\3002</p>'),
unistr('<p>\5BFE\8A71\30B0\30EA\30C3\30C9\304C\7DE8\96C6\53EF\80FD\306B\306A\308B\3068\3001APEX$ROW_ACTION\5217\304C\81EA\52D5\7684\306B\8FFD\52A0\3055\308C\3001\30A2\30AF\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC\306E\30BF\30A4\30D7\306B\8A2D\5B9A\3055\308C\307E\3059\3002\7DE8\96C6\4E0D\80FD\5BFE\8A71\30B0\30EA\30C3\30C9\3067\306F\3001\3053\306E\5217\306F\624B\52D5\3067\8FFD\52A0\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>')))
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/region_type/jet_chart
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(258086019711957603.442)
,p_plugin_type=>'REGION TYPE'
,p_name=>'JET_CHART'
,p_display_name=>unistr('\30C1\30E3\30FC\30C8')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','JET_CHART'),'')
,p_javascript_file_urls=>'[require jet]#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.jetChart#MIN#.js'
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:FETCHED_ROWS:ESCAPE_OUTPUT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\69D8\3005\306A\7D44\8FBC\307F\30C1\30E3\30FC\30C8\30FB\30BF\30A4\30D7\3092\4F7F\7528\3057\305F\30C7\30FC\30BF\3092\8868\793A\3057\307E\3059\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(608666764128858384.442)
,p_plugin_id=>wwv_flow_api.id(258086019711957603.442)
,p_name=>'SOURCE_LOCATION'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/hide
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(258533608465739815.442)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'HIDE'
,p_display_name=>unistr('\975E\8868\793A')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','HIDE'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JQUERY_SELECTOR:JAVASCRIPT_EXPRESSION:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\5F71\97FF\3092\53D7\3051\308B\8981\7D20\3092\975E\8868\793A\306B\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(262136912621901373.442)
,p_plugin_id=>wwv_flow_api.id(258533608465739815.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\540C\3058\884C\306E\3059\3079\3066\306E\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3092\975E\8868\793A')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_deprecated_values=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5F71\97FF\3092\53D7\3051\308B\8981\7D20\3068\540C\3058\884C\306E\3059\3079\3066\306E\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3068\30E9\30D9\30EB\3092\975E\8868\793A\306B\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8: \3053\306E\5C5E\6027\306F\3001\8868\30B0\30EA\30C3\30C9\3092\4F7F\7528\3057\3066\30D5\30A9\30FC\30E0\30FB\30A2\30A4\30C6\30E0\3092\8868\793A\3057\306A\3044\30DA\30FC\30B8\306E\30A2\30A4\30C6\30E0\306B\5BFE\3057\3066\306F\6A5F\80FD\3057\307E\305B\3093\3002\3053\308C\306B\306F\3001\30E2\30D0\30A4\30EB\30FB\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\4F7F\7528\3057\305F\30DA\30FC\30B8\304C\542B\307E\308C\307E\3059\3002</p>')))
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/enable
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(258537221774904509.442)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'ENABLE'
,p_display_name=>unistr('\6709\52B9\5316')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','ENABLE'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\5F71\97FF\3092\53D7\3051\308B\8981\7D20\3092\6709\52B9\306B\3057\307E\3059\3002')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/disable
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(258537428700906571.442)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'DISABLE'
,p_display_name=>unistr('\7121\52B9\5316')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','DISABLE'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\5F71\97FF\3092\53D7\3051\308B\8981\7D20\3092\7121\52B9\306B\3057\307E\3059\3002\7121\52B9\306B\3059\308B\3068\3001\3053\308C\3089\306E\8981\7D20\306F\7DE8\96C6\3067\304D\306A\304F\306A\308A\3001\30DA\30FC\30B8\306E\9001\4FE1\6642\306B\30A2\30A4\30C6\30E0\5024\304C\4FDD\6301\3055\308C\307E\305B\3093\3002')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/set_value
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(258538225714915177.442)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'SET_VALUE'
,p_display_name=>unistr('\5024\306E\8A2D\5B9A')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','SET_VALUE'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:REGION:JQUERY_SELECTOR:JAVASCRIPT_EXPRESSION:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD:STOP_EXECUTION_ON_ERROR:WAIT_FOR_RESULT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\5F71\97FF\3092\53D7\3051\308B\8981\7D20\306E\5024\3092\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(262584206591281622.442)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\30BF\30A4\30D7\306E\8A2D\5B9A')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STATIC_ASSIGNMENT'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\8A2D\5B9A\3059\308B\5024\306E\5C0E\51FA\65B9\6CD5\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(262584812132283213.442)
,p_plugin_attribute_id=>wwv_flow_api.id(262584206591281622.442)
,p_display_sequence=>10
,p_display_value=>unistr('\9759\7684\5272\5F53\3066')
,p_return_value=>'STATIC_ASSIGNMENT'
,p_help_text=>unistr('1\3064\306E\9759\7684\5024\3092\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(262585623560286495.442)
,p_plugin_attribute_id=>wwv_flow_api.id(262584206591281622.442)
,p_display_sequence=>15
,p_display_value=>unistr('JavaScript\5F0F')
,p_return_value=>'JAVASCRIPT_EXPRESSION'
,p_help_text=>unistr('JavaScript\304B\3089\5C0E\51FA\307E\305F\306F\8A08\7B97\3057\305F1\3064\4EE5\4E0A\306E\5024\3092\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(262585216634284505.442)
,p_plugin_attribute_id=>wwv_flow_api.id(262584206591281622.442)
,p_display_sequence=>20
,p_display_value=>unistr('SQL\6587')
,p_return_value=>'SQL_STATEMENT'
,p_help_text=>unistr('SQL\554F\5408\305B\306E\7D50\679C\306B\57FA\3065\3044\30661\3064\4EE5\4E0A\306E\5024\3092\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(427666425507065443.442)
,p_plugin_attribute_id=>wwv_flow_api.id(262584206591281622.442)
,p_display_sequence=>40
,p_display_value=>unistr('PL/SQL\5F0F')
,p_return_value=>'PLSQL_EXPRESSION'
,p_help_text=>unistr('PL/SQL\5F0F\306E\7D50\679C\306B\57FA\3065\3044\3066\5358\4E00\306E\5024\3092\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(427667018365072832.442)
,p_plugin_attribute_id=>wwv_flow_api.id(262584206591281622.442)
,p_display_sequence=>50
,p_display_value=>unistr('PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
,p_return_value=>'FUNCTION_BODY'
,p_help_text=>unistr('PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\306E\7D50\679C\306B\57FA\3065\3044\3066\5358\4E00\306E\5024\3092\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1295383602600152012.442)
,p_plugin_attribute_id=>wwv_flow_api.id(262584206591281622.442)
,p_display_sequence=>60
,p_display_value=>unistr('\30C0\30A4\30A2\30ED\30B0\623B\308A\30A2\30A4\30C6\30E0')
,p_return_value=>'DIALOG_RETURN_ITEM'
,p_help_text=>unistr('\30C0\30A4\30A2\30ED\30B0\306E\623B\308A\30A2\30A4\30C6\30E0\306B\57FA\3065\3044\3066\3001\5358\4E00\306E\5024\3092\8A2D\5B9A\3057\3066\304F\3060\3055\3044\3002\30CE\30FC\30C8: \52D5\7684\30A2\30AF\30B7\30E7\30F3\304C<strong>\300C\30C0\30A4\30A2\30ED\30B0\306E\30AF\30ED\30FC\30BA\300D</strong>\30A4\30D9\30F3\30C8\306B\5BFE\3057\3066\8D77\52D5\3059\308B\5834\5408\3001\3053\306E\30BF\30A4\30D7\306E\307F\52D5\4F5C\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(258539307968928889.442)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\5024')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>50
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC_ASSIGNMENT'
,p_help_text=>unistr('\9759\7684\5024\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(262586323439352724.442)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('SQL\6587')
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_sql_min_column_count=>1
,p_sql_max_column_count=>100
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL_STATEMENT'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select loc,',
'       dname',
'  from dept ',
' where deptno = :P1_DEPTNO',
'</pre>',
unistr('<p>\3053\306E\4F8B\3067\306F\3001<strong>\300C\9001\4FE1\3059\308B\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\300D</strong>\306B<code>P1_DEPTNO</code>\3092\5165\529B\3057\307E\3059\3002<code>loc</code>\304A\3088\3073<code>dname</code>\5217\306E2\3064\306E<em>\5F71\97FF\3092\53D7\3051\308B\8981\7D20</em>(\305F\3068\3048\3070\3001\305D\308C\305E\308CP1_LOC\304A\3088\3073P1_DNAME)\3082\9078\629E\3057\307E\3059\3002</p>')))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>1\304B\3089100\306E\9593\306E\5217\3092\8FD4\3059SQL\6587\3092\5165\529B\3057\307E\3059\3002SQL\6587\3067\9078\629E\3059\308B\5217\306F\3001<strong>\300C\5F71\97FF\3092\53D7\3051\308B\8981\7D20\300D</strong>\3067\9078\629E\3059\308B\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3068\4F4D\7F6E\3067\5BFE\5FDC\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>'),
unistr('<p>\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092<strong>\300C\9001\4FE1\3059\308B\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\300D</strong>\306B\542B\3081\305F\5834\5408\3001\30D0\30A4\30F3\30C9\69CB\6587\3092\4F7F\7528\3057\3066\53C2\7167\3067\304D\307E\3059\3002</p>'),
unistr('<p><em>\30CE\30FC\30C8: SQL\6587\304C1\884C\306E\307F\8FD4\3059\5834\5408\3001\3053\308C\304C\5024\3068\3057\3066\8A2D\5B9A\3055\308C\307E\3059\3002\8907\6570\884C\3092\8FD4\3059\5834\5408\3001\5024\30BB\30C3\30C8\306F\3001\5024\3054\3068\306E\3059\3079\3066\306E\884C\306E\30AB\30F3\30DE\533A\5207\308A\306E\6587\5B57\5217\3067\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(427662501518001786.442)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('PL/SQL\5F0F')
,p_attribute_type=>'PLSQL EXPRESSION'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL_EXPRESSION'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'nvl(:P1_SAL, 0)',
'</pre>',
unistr('<p>\3053\306E\4F8B\3067\306F\3001<strong>\300C\9001\4FE1\3059\308B\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\300D</strong>\306B<code>P1_SAL</code>\3068\5165\529B\3057\307E\3059\3002</p>')))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5024\306E\8A2D\5B9A\306B\4F7F\7528\3055\308C\308BPL/SQL\5F0F\3092\5165\529B\3057\307E\3059\3002</p>'),
unistr('<p><strong>\9001\4FE1\3059\308B\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0</strong>\306B\542B\3081\308B\3068\3001\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\53C2\7167\3067\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(293265419645253258.442)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('JavaScript\5F0F')
,p_attribute_type=>'JAVASCRIPT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'JAVASCRIPT_EXPRESSION'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30B3\30FC\30C9\306F\3001\6B21\306E\52D5\7684\30A2\30AF\30B7\30E7\30F3\95A2\9023\5C5E\6027\306B\30A2\30AF\30BB\30B9\3057\307E\3059\3002</p>'),
'<dl>',
'  <dt><code>this.triggeringElement</code></dt>',
unistr('    <dd>\52D5\7684\30A2\30AF\30B7\30E7\30F3\3092\30C8\30EA\30AC\30FC\3057\305F\8981\7D20\306EDOM\30AA\30D6\30B8\30A7\30AF\30C8\3078\306E\53C2\7167\3002</dd>'),
'  <dt><code>this.affectedElements</code></dt>',
unistr('    <dd>\5F71\97FF\3092\53D7\3051\308B\3059\3079\3066\306E\8981\7D20\3092\542B\3080jQuery\30AA\30D6\30B8\30A7\30AF\30C8\3002</dd>'),
'  <dt><code>this.action</code></dt>',
unistr('    <dd>\30A2\30AF\30B7\30E7\30F3\540D\3068\8FFD\52A0\306E\5C5E\6027\5024\306A\3069\306E\8A73\7D30\3092\542B\3080\30A2\30AF\30B7\30E7\30F3\30FB\30AA\30D6\30B8\30A7\30AF\30C8\3002</dd>'),
'  <dt><code>this.browserEvent</code></dt>',
unistr('     <dd>\30A4\30D9\30F3\30C8\3092\30C8\30EA\30AC\30FC\3057\305F\30A4\30D9\30F3\30C8\306E\30A4\30D9\30F3\30C8\30FB\30AA\30D6\30B8\30A7\30AF\30C8\3002\30CE\30FC\30C8: \30ED\30FC\30C9\6642\3001\3053\308C\306F''load''\3068\540C\7B49\306B\306A\308A\307E\3059\3002</dd>'),
'  <dt><code>this.data</code></dt>',
unistr('    <dd>\30A4\30D9\30F3\30C8\30FB\30CF\30F3\30C9\30E9\304B\3089\6E21\3059\3053\3068\304C\3067\304D\308B\30AA\30D7\30B7\30E7\30F3\306E\8FFD\52A0\30C7\30FC\30BF\3002</dd>'),
'</dl>'))
,p_help_text=>unistr('\5024\306E\8A2D\5B9A\306B\4F7F\7528\3059\308BJavaScript\5F0F\3092\5165\529B\3057\307E\3059\3002\3053\306E\5F0F\306E\7D50\679C\306F\3001\5358\4E00\306E\5024\304B\3001\5024\306E\914D\5217(\8A2D\5B9A\3055\308C\308B\30A2\30A4\30C6\30E0\306F\3001\30B7\30E3\30C8\30EB\306A\3069\306E\8907\6570\306E\5024\3092\30B5\30DD\30FC\30C8\3057\307E\3059)\3067\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(427662910653013912.442)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53')
,p_attribute_type=>'PLSQL FUNCTION BODY'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'FUNCTION_BODY'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'return getCommission(:P1_SAL, :P1_JOB);',
'</pre>',
unistr('<p>\3053\306E\4F8B\3067\306F\3001<strong>\300C\9001\4FE1\3059\308B\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\300D</strong>\306B<code>P1_SAL</code>\304A\3088\3073<code>P1_JOB</code>\3068\5165\529B\3057\307E\3059\3002</p>')))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5024\306E\8A2D\5B9A\306B\4F7F\7528\3055\308C\308BPL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\3092\5165\529B\3057\307E\3059\3002</p>'),
unistr('<p><strong>\9001\4FE1\3059\308B\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0</strong>\306B\542B\3081\308B\3068\3001\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\53C2\7167\3067\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(262597322287494361.442)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\9001\4FE1\3059\308B\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'SQL_STATEMENT,PLSQL_EXPRESSION,FUNCTION_BODY'
,p_help_text=>unistr('\3053\306E\30A2\30AF\30B7\30E7\30F3\3092\5B9F\884C\3059\308B\969B\306B\9001\4FE1\3059\308B\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002\8907\6570\306E\30A2\30A4\30C6\30E0\306E\5834\5408\3001\5404\30A2\30A4\30C6\30E0\540D\3092\30AB\30F3\30DE\3067\533A\5207\308A\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002\30EA\30B9\30C8\304B\3089\9078\629E\3057\3001\3059\3067\306B\5165\529B\3055\308C\3066\3044\308B\30C6\30AD\30B9\30C8\304C\3042\308B\5834\5408\3001\65E2\5B58\306E\30C6\30AD\30B9\30C8\306E\6700\5F8C\306B\30AB\30F3\30DE\304C\4ED8\3051\3089\308C\3001\30EA\30B9\30C8\304B\3089\8FD4\3055\308C\305F\30A2\30A4\30C6\30E0\540D\304C\305D\308C\306B\7D9A\304D\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(618758229653179194.442)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\7279\6B8A\6587\5B57\3092\30A8\30B9\30B1\30FC\30D7')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'SQL_STATEMENT,PLSQL_EXPRESSION,FUNCTION_BODY'
,p_help_text=>unistr('HTML\7279\6B8A\6587\5B57\304C\30A8\30B9\30B1\30FC\30D7\3055\308C\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002\30AF\30ED\30B9\30B5\30A4\30C8\30FB\30B9\30AF\30EA\30D7\30C6\30A3\30F3\30B0(XSS)\653B\6483\3092\9632\3050\305F\3081\306B\3001\3053\306E\5C5E\6027\3092<strong>\300C\306F\3044\300D</strong>\306B\8A2D\5B9A\3059\308B\3053\3068\3092\5F37\304F\304A\85A6\3081\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(399189606786047634.442)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\5909\66F4\30A4\30D9\30F3\30C8\306E\7981\6B62')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('<strong>\300C\8FD4\3055\308C\308B\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\300D</strong>\3067\6307\5B9A\3055\308C\305F\30A2\30A4\30C6\30E0\3067\5909\66F4\30A4\30D9\30F3\30C8\3092\6291\6B62\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002\3053\308C\306B\3088\3063\3066\3001\5F8C\7D9A\306E<em>\5909\66F4</em>\30D9\30FC\30B9\306E\52D5\7684\30A2\30AF\30B7\30E7\30F3\304C\3053\308C\3089\306E\30A2\30A4\30C6\30E0\306B\5BFE\3057\3066\5B9F\884C\3055\308C\306A\304F\306A\308A\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1295495331704184122.442)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>75
,p_prompt=>unistr('\623B\308A\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DIALOG_RETURN_ITEM'
,p_help_text=>unistr('\5024\3092\8A2D\5B9A\3059\308B\305F\3081\306B\4F7F\7528\3055\308C\308B\30C0\30A4\30A2\30ED\30B0\306B\3088\3063\3066\623B\3055\308C\308B\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306E\540D\524D\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/javascript_code
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(258538732294917000.442)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'JAVASCRIPT_CODE'
,p_display_name=>unistr('JavaScript\30B3\30FC\30C9\306E\5B9F\884C')
,p_category=>'EXECUTE'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','JAVASCRIPT_CODE'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JQUERY_SELECTOR:JAVASCRIPT_EXPRESSION:TRIGGERING_ELEMENT:EVENT_SOURCE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\52D5\7684\30A2\30AF\30B7\30E7\30F3\30FB\30D5\30EC\30FC\30E0\30EF\30FC\30AF\5185\3067\4F7F\7528\3059\308B\3001\30AB\30B9\30BF\30E0\3067\30DA\30FC\30B8\56FA\6709\306EJavaScript\30B3\30FC\30C9\3092\5B9A\7FA9\307E\305F\306F\30B3\30FC\30EB\3067\304D\308B\3088\3046\306B\3057\307E\3059\30021\30DA\30FC\30B8\306E\307F\306B\56FA\6709\306EJavaScript\30B3\30FC\30C9\3092\5B9A\7FA9\3059\308B\5834\5408\3001\30DA\30FC\30B8\30EC\30D9\30EB\5C5E\6027<em>\300C\30D5\30A1\30F3\30AF\30B7\30E7\30F3\304A\3088\3073\30B0\30ED\30FC\30D0\30EB\5909\6570\306E\5BA3\8A00\300D</em>\3092\4F7F\7528\3057\3066\5B9A\7FA9\3057\307E\3059\3002\305D\3053\3067\5B9A\7FA9\3055\308C\305F\30D5\30A1\30F3\30AF\30B7\30E7\30F3\3068\5909\6570\306F\3001\3053\306E\30A2\30AF\30B7\30E7\30F3\304B\3089\53C2\7167\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(258539816972931512.442)
,p_plugin_id=>wwv_flow_api.id(258538732294917000.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\30B3\30FC\30C9')
,p_attribute_type=>'JAVASCRIPT'
,p_is_required=>true
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30B3\30FC\30C9\306F\3001\6B21\306E\52D5\7684\30A2\30AF\30B7\30E7\30F3\95A2\9023\5C5E\6027\306B\30A2\30AF\30BB\30B9\3057\307E\3059\3002</p>'),
'<dl>',
'  <dt><code>this.triggeringElement</code></dt>',
unistr('    <dd>\52D5\7684\30A2\30AF\30B7\30E7\30F3\3092\30C8\30EA\30AC\30FC\3057\305F\8981\7D20\306EDOM\30AA\30D6\30B8\30A7\30AF\30C8\3078\306E\53C2\7167\3002</dd>'),
'  <dt><code>this.affectedElements</code></dt>',
unistr('    <dd>\5F71\97FF\3092\53D7\3051\308B\3059\3079\3066\306E\8981\7D20\3092\542B\3080jQuery\30AA\30D6\30B8\30A7\30AF\30C8\3002</dd>'),
'  <dt><code>this.action</code></dt>',
unistr('    <dd>\30A2\30AF\30B7\30E7\30F3\540D\3068\8FFD\52A0\306E\5C5E\6027\5024\306A\3069\306E\8A73\7D30\3092\542B\3080\30A2\30AF\30B7\30E7\30F3\30FB\30AA\30D6\30B8\30A7\30AF\30C8\3002</dd>'),
'  <dt><code>this.browserEvent</code></dt>',
unistr('     <dd>\30A4\30D9\30F3\30C8\3092\30C8\30EA\30AC\30FC\3057\305F\30A4\30D9\30F3\30C8\306E\30A4\30D9\30F3\30C8\30FB\30AA\30D6\30B8\30A7\30AF\30C8\3002\30CE\30FC\30C8: \30ED\30FC\30C9\6642\3001\3053\308C\306F''load''\3068\540C\7B49\306B\306A\308A\307E\3059\3002</dd>'),
'  <dt><code>this.data</code></dt>',
unistr('    <dd>\30A4\30D9\30F3\30C8\30FB\30CF\30F3\30C9\30E9\304B\3089\6E21\3059\3053\3068\304C\3067\304D\308B\30AA\30D7\30B7\30E7\30F3\306E\8FFD\52A0\30C7\30FC\30BF\3002</dd>'),
'</dl>'))
,p_help_text=>unistr('\30DA\30FC\30B8\307E\305F\306F\52D5\7684\30A2\30AF\30B7\30E7\30F3\306B\56FA\6709\306E\30AB\30B9\30BF\30E0JavaScript\3092\5165\529B\3057\307E\3059\3002')
);
end;
/
prompt --application/shared_components/plugins/process_type/ig_dml
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(260818839554927396.442)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'IG_DML'
,p_display_name=>unistr('\5BFE\8A71\30B0\30EA\30C3\30C9 - \884C\306E\81EA\52D5\51E6\7406(DML)')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','IG_DML'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REGION_REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\5BFE\8A71\30B0\30EA\30C3\30C9\306E\884C\3092\633F\5165\3001\66F4\65B0\307E\305F\306F\524A\9664\3059\308B\30D7\30ED\30BB\30B9\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(260819106949935652.442)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\30BF\30FC\30B2\30C3\30C8\30FB\30BF\30A4\30D7')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'REGION_SOURCE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\5BFE\8A71\30B0\30EA\30C3\30C9\306B\884C\308F\308C\305F\30C7\30FC\30BF\5909\66F4\3092\4FDD\5B58\3059\308B\305F\3081\306B\5B9F\884C\3059\308B\884C\51E6\7406\65B9\6CD5\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(260819425689937336.442)
,p_plugin_attribute_id=>wwv_flow_api.id(260819106949935652.442)
,p_display_sequence=>10
,p_display_value=>unistr('\30EA\30FC\30B8\30E7\30F3\30FB\30BD\30FC\30B9')
,p_return_value=>'REGION_SOURCE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30EA\30FC\30B8\30E7\30F3\30FB\30BD\30FC\30B9SQL\554F\5408\305B\306E\5229\7528\3092\633F\5165\3001\66F4\65B0\304A\3088\3073\524A\9664\3057\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8 - \51E6\7406\304B\3089\9664\5916\3059\308B\305F\3081\3001\633F\5165\53EF\80FD\307E\305F\306F\66F4\65B0\53EF\80FD\3067\306A\3044\5217\306E<strong>\300C\554F\5408\305B\306E\307F\300D</strong>\304C<code>Yes</code>\306B\8A2D\5B9A\3055\308C\3066\3044\308B\3053\3068\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(260819835191938290.442)
,p_plugin_attribute_id=>wwv_flow_api.id(260819106949935652.442)
,p_display_sequence=>20
,p_display_value=>unistr('\8868/\30D3\30E5\30FC')
,p_return_value=>'TABLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30EA\30FC\30B8\30E7\30F3\30FB\30BD\30FC\30B9SQL\554F\5408\305B\3067\5B9A\7FA9\3055\308C\3066\3044\306A\3044\5225\306E\8868\307E\305F\306F\30D3\30E5\30FC\306E\5229\7528\3092\633F\5165\3001\66F4\65B0\304A\3088\3073\524A\9664\3057\307E\3059\3002'),
unistr('\305F\3068\3048\3070\3001SQL\554F\5408\305B\3067\8868\7D50\5408\307E\305F\306F\66F4\65B0\53EF\80FD\3067\306A\3044\30D3\30E5\30FC\304B\3089\30C7\30FC\30BF\3092\53D6\5F97\3059\308B\3068\3001DML\51E6\7406\3092\5358\4E00\306E\30D9\30FC\30B9\8868\307E\305F\306F\66F4\65B0\53EF\80FD\306A\30D3\30E5\30FC\306B\5BFE\3057\3066\5B9F\884C\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8 - \51E6\7406\304B\3089\9664\5916\3059\308B\305F\3081\3001\633F\5165\53EF\80FD\307E\305F\306F\66F4\65B0\53EF\80FD\3067\306A\3044\5217\306E<strong>\300C\554F\5408\305B\306E\307F\300D</strong>\304C<code>Yes</code>\306B\8A2D\5B9A\3055\308C\3066\3044\308B\3053\3068\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(260820229830940047.442)
,p_plugin_attribute_id=>wwv_flow_api.id(260819106949935652.442)
,p_display_sequence=>30
,p_display_value=>unistr('PL/SQL\30B3\30FC\30C9')
,p_return_value=>'PLSQL_CODE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\51E6\7406\306F\3001\30AB\30B9\30BF\30E0PL/SQL\30B3\30FC\30C9\306B\57FA\3065\3044\3066\3044\307E\3059\3002\3053\306E\30AA\30D7\30B7\30E7\30F3\306B\3088\308A\3001PL/SQL\30B3\30FC\30C9\3092\5B9F\884C\3057\3066\57FA\790E\3068\306A\308B\30C7\30FC\30BF\30D9\30FC\30B9\306E\30C7\30FC\30BF\64CD\4F5C\3092\5B9F\88C5\3067\304D\307E\3059\3002</p>'),
unistr('<p>\8868API\307E\305F\306FRESTful Web\30B5\30FC\30D3\30B9\3078\306E\30B3\30FC\30EB\306A\3069\306E\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30D1\30C3\30B1\30FC\30B8\3092\4F7F\7528\3057\3066\30D3\30B8\30CD\30B9\30FB\30ED\30B8\30C3\30AF\3092\5B9F\88C5\3059\308B\5834\5408\3001\3053\306E\30AA\30D7\30B7\30E7\30F3\3092\5229\7528\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8 - \633F\5165\3001\66F4\65B0\307E\305F\306F\524A\9664\3055\308C\305F\5404\884C\306B\5BFE\3057\3066\3001PL/SQL\30B3\30FC\30C9\304C\30B3\30FC\30EB\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(260820699209949601.442)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\8868\306E\6240\6709\8005')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(260819106949935652.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TABLE'
,p_help_text=>unistr('\8868\306E\6240\6709\8005(\30B9\30AD\30FC\30DE)\540D\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(260821252819962990.442)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\8868\540D')
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(260820699209949601.442)
,p_depending_on_attribute_id=>wwv_flow_api.id(260819106949935652.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TABLE'
,p_help_text=>unistr('\5927/\5C0F\6587\5B57\3092\533A\5225\3057\305F\8868\307E\305F\306F\30D3\30E5\30FC\306E\540D\524D\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261083814084772472.442)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\633F\5165/\66F4\65B0/\524A\9664\3059\308BPL/SQL\30B3\30FC\30C9')
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(260819106949935652.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL_CODE'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'begin',
'    case :APEX$ROW_STATUS',
'    when ''C'' then',
'        insert into emp ( empno, ename, deptno )',
'        values ( :EMPNO, :ENAME, :DEPTNO )',
'        returning rowid into :ROWID;',
'    when ''U'' then',
'        update emp',
'           set ename  = :ENAME,',
'               deptno = :DEPTNO',
'         where rowid  = :ROWID;',
'    when ''D'' then',
'        delete emp',
'         where rowid = :ROWID;',
'    end case;',
'end;',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>PL/SQL\30B3\30FC\30C9\3092\5165\529B\3057\3066\3001\5BFE\8A71\30B0\30EA\30C3\30C9\3067\64CD\4F5C\3055\308C\308B\5404\884C\306E\30C7\30FC\30BF\3092\51E6\7406\3057\307E\3059\3002</p>'),
unistr('<p>\5217\306E\5024\306B\30A2\30AF\30BB\30B9\3059\308B\305F\3081\306E\30D0\30A4\30F3\30C9\5909\6570\3068\3057\3066\5217\540D\3092\4F7F\7528\3057\307E\3059\3002\30B7\30B9\30C6\30E0\5909\6570<code>APEX$ROW_STATUS</code>\3067\306F\3001\884C\306E\30B9\30C6\30FC\30BF\30B9\304C\8FD4\3055\308C\308B\305F\3081\3001\884C\304C\4F5C\6210\3001\66F4\65B0\307E\305F\306F\524A\9664\3055\308C\305F\304B\3069\3046\304B\3092\78BA\8A8D\3059\308B\305F\3081\306B\4F7F\7528\3067\304D\307E\3059(\3053\306E\78BA\8A8D\65B9\6CD5\306F\6B21\306E\4F8B\3092\53C2\7167\3057\3066\304F\3060\3055\3044)\3002</p>'),
unistr('<p><em>\30CE\30FC\30C8:</em> \4E3B\30AD\30FC\5217\304C\30C8\30EA\30AC\30FC\307E\305F\306FPL/SQL\30B3\30FC\30C9\3067\79FB\5165\3055\308C\308B\5834\5408\3001&PRODUCT_NAME.\306B\3088\3063\3066\633F\5165\307E\305F\306F\66F4\65B0\5F8C\306E\884C\306E\30D5\30A7\30C3\30C1\306B\4E3B\30AD\30FC\5217\304C\4F7F\7528\3055\308C\308B\305F\3081\3001\3053\308C\3089\306E\5217\306E\30D0\30A4\30F3\30C9\5909\6570\306B\65B0\3057\3044\5024\304C\5272\308A\5F53\3066\3089\308C\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>'),
unistr('<p>\518D\5229\7528\304A\3088\3073\30E1\30F3\30C6\30CA\30F3\30B9\6027\3092\9AD8\3081\308B\305F\3081\306BPL/SQL\30D1\30C3\30B1\30FC\30B8\5185\306E\30D7\30ED\30B7\30FC\30B8\30E3\307E\305F\306F\30D5\30A1\30F3\30AF\30B7\30E7\30F3\3092\30B3\30FC\30EB\3059\308B\3053\3068\3092\304A\85A6\3081\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261084825593778341.442)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\5931\308F\308C\305F\66F4\65B0\306E\9632\6B62')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8907\6570\306E\30E6\30FC\30B6\30FC\304C\540C\3058\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30EC\30B3\30FC\30C9\3092\66F4\65B0\3059\308B\5834\5408\306B\66F4\65B0\304C\5931\308F\308C\306A\3044\3053\3068\3092\78BA\8A8D\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002</p> '),
unistr('<p>2\4EBA\4EE5\4E0A\306E\30E6\30FC\30B6\30FC\304C\540C\3058\30C7\30FC\30BF\3092\66F4\65B0\3057\3088\3046\3068\3057\3001\5909\66F4\3092\4FDD\5B58\3059\308B\305F\3081\306B\6700\5F8C\306E\66F4\65B0\304C\6700\521D\306E\30E6\30FC\30B6\30FC\306E\66F4\65B0\3092\4E0A\66F8\304D\3059\308B\3068\3001\66F4\65B0\304C\5931\308F\308C\307E\3059\3002\3053\306E\767A\751F\3092\9632\6B62\3059\308B\306B\306F\3001\6700\521D\306E\884C\306E\554F\5408\305B\6642\306B\53D6\5F97\3057\305F\5024\3068\3068\3082\306B\30C7\30FC\30BF\30D9\30FC\30B9\306E\65E2\5B58\306E\5217\5024\3092\66F4\65B0\3067\78BA\8A8D\3067\304D\307E\3059\3002</p>'),
unistr('<p>\4F8B:'),
'  <ol>',
unistr('    <li>\30E6\30FC\30B6\30FCA\304C\5F93\696D\54E1(EMP)\30EC\30B3\30FC\30C9\3092\554F\3044\5408\305B\307E\3059\3002</li>'),
unistr('    <li>\30E6\30FC\30B6\30FCB\304C\540C\3058\5F93\696D\54E1\30EC\30B3\30FC\30C9\3092\554F\3044\5408\305B\307E\3059\3002</li>'),
unistr('    <li>\30E6\30FC\30B6\30FCB\304CEMPNO = 7839\306E\5F93\696D\54E1\8A73\7D30\3092\66F4\65B0\3057\3001\30C7\30FC\30BF\30D9\30FC\30B9\3078\306E\5909\66F4\3092\9069\7528(\30B3\30DF\30C3\30C8)\3057\307E\3059\3002</li>'),
unistr('    <li>\30E6\30FC\30B6\30FCA\304CEMPNO = 7839\306E\5F93\696D\54E1\8A73\7D30\3092\66F4\65B0\3057\3001\30C7\30FC\30BF\30D9\30FC\30B9\3078\306E\5909\66F4\3092\9069\7528\3057\3088\3046\3068\3057\307E\3059\3002</li>'),
'  </ol>',
unistr('\30E6\30FC\30B6\30FCA\304C\540C\3058\884C\3092\6B63\5E38\306B\66F4\65B0\3059\308B\3068\3001\30E6\30FC\30B6\30FCB\304C\884C\3063\305F\5909\66F4\304C\5931\308F\308C\307E\3059\3002'),
unistr('\30E6\30FC\30B6\30FCA\304C\5F93\696D\54E1\306E\884C\3092\4FDD\5B58\3057\3088\3046\3068\3059\308B\5834\5408\3001\30C7\30FC\30BF\30D9\30FC\30B9\306E\30C7\30FC\30BF\306F\30E6\30FC\30B6\30FCA\304C\6700\521D\306B\554F\3044\5408\305B\305F\5185\5BB9\3068\7570\306A\3063\3066\3044\307E\3059\3002\524D\8FF0\306E\624B\98061\3067\3001\30E6\30FC\30B6\30FCA\304C\6700\521D\306B\554F\3044\5408\305B\305F\5217\5024\3092\53D6\5F97\3067\304D\307E\3059\3002\524D\8FF0\306E\624B\98064\3067\3001\5024\3092\30C7\30FC\30BF\30D9\30FC\30B9\306E\73FE\5728\306E\5024\3068\6BD4\8F03\3067\304D\307E\3059\3002\30C7\30FC\30BF\30D9\30FC\30B9\5024\304C\624B\98063\3067\30E6\30FC\30B6\30FCB\306B\3088\3063\3066\66F4\65B0\3055\308C\305F\305F\3081\3001\3053\306E\6BD4\8F03\306B\3088\308A\3001\30E6\30FC\30B6\30FCA\306B\5BFE\3057\3066\30A8\30E9\30FC\304C\767A\751F\3057\307E\3059\3002\3053\308C\306B\3088\308A\3001\540C\3058\884C\306B\5BFE\3057\3066\5225\306E\30E6\30FC\30B6\30FC\304C\884C\3063\305F\5909\66F4\306E\4E0A\66F8\304D\304C\9632\6B62\3055\308C\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8 - \5931\308F\308C\305F\66F4\65B0\306E\691C\51FA\65B9\6CD5\306F\3001<strong>\300C\5931\308F\308C\305F\66F4\65B0\30BF\30A4\30D7\300D</strong>\306E\8A2D\5B9A\306B\57FA\3065\3044\3066\3001\5BFE\8A71\30B0\30EA\30C3\30C9\30FB\30EA\30FC\30B8\30E7\30F3\306E\5C5E\6027\3067\6307\5B9A\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261085131500782260.442)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\884C\306E\30ED\30C3\30AF')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>\51E6\7406\3059\308B\524D\306B\66F4\65B0\307E\305F\306F\524A\9664\3059\308B\5404\884C\3092\57FA\790E\3068\306A\308B\8868\3067\30ED\30C3\30AF\3059\308B\304B\3069\3046\304B\3092\9078\629E\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(261085409986783810.442)
,p_plugin_attribute_id=>wwv_flow_api.id(261085131500782260.442)
,p_display_sequence=>10
,p_display_value=>unistr('\306F\3044')
,p_return_value=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30C8\30E9\30F3\30B6\30AF\30B7\30E7\30F3\304C\30B3\30DF\30C3\30C8\3055\308C\308B\307E\3067\884C\306E\4ED6\306E\30C8\30E9\30F3\30B6\30AF\30B7\30E7\30F3\306E\5B9F\884C\3092\9632\6B62\3059\308B\305F\3081\306B\3001SELECT ... FOR UPDATE\3092\4F7F\7528\3057\3066\66F4\65B0\307E\305F\306F\524A\9664\3059\308B\884C\304C\30ED\30C3\30AF\3055\308C\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8 - \30ED\30C3\30AF\3092\30B5\30DD\30FC\30C8\3057\3066\3044\306A\3044\66F4\65B0\53EF\80FD\306A\30D3\30E5\30FC\306A\3069\3067\30A8\30E9\30FC\304C\767A\751F\3059\308B\5834\5408\3001PL/SQL\30B3\30FC\30C9\3092\5229\7528\3057\3066\99C6\52D5\8868\3092\30ED\30C3\30AF\3067\304D\308B\53EF\80FD\6027\304C\3042\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(261085868401784451.442)
,p_plugin_attribute_id=>wwv_flow_api.id(261085131500782260.442)
,p_display_sequence=>20
,p_display_value=>unistr('\3044\3044\3048')
,p_return_value=>'N'
,p_help_text=>unistr('\884C\304C\30ED\30C3\30AF\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(261086261920786764.442)
,p_plugin_attribute_id=>wwv_flow_api.id(261085131500782260.442)
,p_display_sequence=>30
,p_display_value=>unistr('PL/SQL\30B3\30FC\30C9')
,p_return_value=>'PLSQL_CODE'
,p_help_text=>unistr('\30C8\30E9\30F3\30B6\30AF\30B7\30E7\30F3\304C\30B3\30DF\30C3\30C8\3055\308C\308B\307E\3067\3001\30AB\30B9\30BF\30E0PL/SQL\30B3\30FC\30C9\3092\4F7F\7528\3057\3066\884C\3092\30ED\30C3\30AF\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261087562475803605.442)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\884C\3092\30ED\30C3\30AF\3059\308BPL/SQL\30B3\30FC\30C9')
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(261085131500782260.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL_CODE'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'declare',
'    l_dummy number;',
'begin',
'    select 1',
'      into l_dummy',
'      from emp',
'     where empno = :EMPNO',
'       for update nowait;',
'end;',
'</pre>'))
,p_help_text=>unistr('PL/SQL\30B3\30FC\30C9\3092\5165\529B\3057\3066\3001\66F4\65B0\304A\3088\3073\524A\9664\3059\308B\30C7\30FC\30BF\30D9\30FC\30B9\8868\306E\884C\3092\30ED\30C3\30AF\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(352431952250846035.442)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\633F\5165\5F8C\306B\4E3B\30AD\30FC\3092\8FD4\3059')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(260819106949935652.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'REGION_SOURCE,TABLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\884C\304C\30C7\30FC\30BF\30D9\30FC\30B9\306B\633F\5165\3055\308C\305F\5F8C\306B\4E3B\30AD\30FC\5217\3092\5BFE\5FDC\3059\308B\5BFE\8A71\30B0\30EA\30C3\30C9\306E\884C\306B\623B\3059\304B\3069\3046\304B\3092\9078\629E\3057\307E\3059\3002'),
unistr('\901A\5E38\3001\4E3B\30AD\30FC\5217\304C\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30C8\30EA\30AC\30FC\307E\305F\306FOracle Database 12 <em>c</em>\30A2\30A4\30C7\30F3\30C6\30A3\30C6\30A3\5217\304B\3089\79FB\5165\3055\308C\308B\5834\5408\3001\3053\306E\30AA\30D7\30B7\30E7\30F3\3092\4F7F\7528\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8 - RETURNING INTO\53E5\304C\8A31\53EF\3055\308C\3066\3044\306A\3044\3053\3068\3092\793A\3059\30A8\30E9\30FC\304C\767A\751F\3059\308B\5834\5408\3001\3053\306E\30AA\30D7\30B7\30E7\30F3\3092\300C\3044\3044\3048\300D\306B\8A2D\5B9A\3057\3001\4E3B\30AD\30FC\5217\3092\4E8B\524D\306B\79FB\5165\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>')))
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/add_class
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(261340108358474705.442)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'ADD_CLASS'
,p_display_name=>unistr('\30AF\30E9\30B9\306E\8FFD\52A0')
,p_category=>'STYLE'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','ADD_CLASS'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JQUERY_SELECTOR:JAVASCRIPT_EXPRESSION:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\5F71\97FF\3092\53D7\3051\308B\8981\7D20\306B1\3064\4EE5\4E0A\306ECSS\30AF\30E9\30B9\3092\8FFD\52A0\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261340305288502177.442)
,p_plugin_id=>wwv_flow_api.id(261340108358474705.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\30AF\30E9\30B9')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('CSS\30AF\30E9\30B9<code>articlenumber</code>\304A\3088\3073<code>highlight</code>\3092\5F71\97FF\3092\53D7\3051\308B\8981\7D20\306EHTML\30BF\30B0\306B\8FFD\52A0\3057\307E\3059\3002'),
'<pre>articlenumber highlight</pre>'))
,p_help_text=>unistr('\5F71\97FF\3092\53D7\3051\308B\8981\7D20\306B\9069\7528\3059\308B1\3064\4EE5\4E0A\306E\30AF\30E9\30B9\3092\6307\5B9A\3057\307E\3059\3002\8907\6570\6307\5B9A\3059\308B\5834\5408\306F\3001\30AF\30E9\30B9\540D\3092\7A7A\767D\3067\533A\5207\308A\307E\3059\3002')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/remove_class
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(261349722930705968.442)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'REMOVE_CLASS'
,p_display_name=>unistr('\30AF\30E9\30B9\306E\524A\9664')
,p_category=>'STYLE'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','REMOVE_CLASS'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\5F71\97FF\3092\53D7\3051\308B\8981\7D20\304B\30891\3064\4EE5\4E0A\306ECSS\30AF\30E9\30B9\3092\524A\9664\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261350305185719779.442)
,p_plugin_id=>wwv_flow_api.id(261349722930705968.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\30AF\30E9\30B9')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('<p>	\5F71\97FF\3092\53D7\3051\308B\8981\7D20\304B\3089\524A\9664\3059\308B1\3064\4EE5\4E0A\306E\30AF\30E9\30B9\540D\3092\6307\5B9A\3057\307E\3059\3002\8907\6570\6307\5B9A\3059\308B\5834\5408\306F\3001\30AF\30E9\30B9\540D\3092\7A7A\767D\3067\533A\5207\308A\307E\3059\3002\5F71\97FF\3092\53D7\3051\308B\8981\7D20\304B\3089\3059\3079\3066\306E\30AF\30E9\30B9\540D\3092\524A\9664\3059\308B\5834\5408\306F\7A7A\767D\306E\307E\307E\306B\3057\3066\304F\3060\3055\3044\3002</p>')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/set_css
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(261356726281848792.442)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'SET_CSS'
,p_display_name=>unistr('\30B9\30BF\30A4\30EB\306E\8A2D\5B9A')
,p_category=>'STYLE'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','SET_CSS'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\5F71\97FF\3092\53D7\3051\308B\8981\7D20\306B\30B9\30BF\30A4\30EB(CSS)\30D7\30ED\30D1\30C6\30A3\3092\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261356901132851044.442)
,p_plugin_id=>wwv_flow_api.id(261356726281848792.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\30B9\30BF\30A4\30EB\540D')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\5F71\97FF\3092\53D7\3051\308B\8981\7D20\306B\8A2D\5B9A\3059\308B\30B9\30BF\30A4\30EB(CSS)\30D7\30ED\30D1\30C6\30A3\306E\540D\524D\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261357406326852547.442)
,p_plugin_id=>wwv_flow_api.id(261356726281848792.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\5024')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('\5F71\97FF\3092\53D7\3051\308B\8981\7D20\306B\8A2D\5B9A\3059\308B\30B9\30BF\30A4\30EB\30FB\30D7\30ED\30D1\30C6\30A3\306E\5024\3092\5165\529B\3057\307E\3059\3002\5F71\97FF\3092\53D7\3051\308B\8981\7D20\304B\3089\30B9\30BF\30A4\30EB\30FB\30D7\30ED\30D1\30C6\30A3\3092\524A\9664\3059\308B\5834\5408\306F\7A7A\767D\306E\307E\307E\306B\3057\3066\304F\3060\3055\3044\3002')
);
end;
/
prompt --application/shared_components/plugins/authentication_type/custom
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(352953211423309033.442)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'CUSTOM'
,p_display_name=>unistr('\30AB\30B9\30BF\30E0')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','CUSTOM'),'')
,p_api_version=>1
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\30E6\30FC\30B6\30FC\8A8D\8A3C\3092\6C7A\5B9A\3059\308B\305F\3081\306E\72EC\81EA\306EPL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\306E\5B9A\7FA9\3092\53EF\80FD\306B\3059\308B\8A8D\8A3C\30B9\30AD\30FC\30E0\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(353179625368369848.442)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\76E3\8996\30D5\30A1\30F3\30AF\30B7\30E7\30F3\540D')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30D6\30FC\30EB\5024\3092\8FD4\3059PL/SQL\30B3\30FC\30C9\3092\300CPL/SQL\30B3\30FC\30C9\300D\306B\6307\5B9A -</p>'),
'<pre>',
'function sentry_basic_auth',
'return boolean',
'is',
'    c_auth_header   constant varchar2(4000) := owa_util.get_cgi_env(''AUTHORIZATION'');',
'    l_user_pass     varchar2(4000);',
'    l_separator_pos pls_integer;',
'begin',
'    if apex_application.g_user <> ''nobody'' then',
'        return true;',
'    end if;',
'',
'    if c_auth_header like ''Basic %'' then',
'        l_user_pass := utl_encode.text_decode (',
'                           buf      => substr(c_auth_header, 7),',
'                           encoding => utl_encode.base64 );',
'        l_separator_pos := instr(l_user_pass, '':'');',
'        if l_separator_pos > 0 then',
'            apex_authentication.login (',
'                p_username => substr(l_user_pass, 1, l_separator_pos-1),',
'                p_password => substr(l_user_pass, l_separator_pos+1) );',
'            return true;',
'        end if;',
'    end if;',
'',
'    return false;',
'end sentry_basic_auth;',
'</pre>',
unistr('<p>PL/SQL\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30D5\30A1\30F3\30AF\30B7\30E7\30F3\3092\6307\5B9A - </p>'),
'<pre>',
'sentry_basic_auth',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>&PRODUCT_NAME.\30A8\30F3\30B8\30F3\306B\3088\308A\30A8\30F3\30B8\30F3\306B\5BFE\3059\308B\30EA\30AF\30A8\30B9\30C8\306E\958B\59CB\6642\306B\5B9F\884C\3055\308C\308B\30D5\30A1\30F3\30AF\30B7\30E7\30F3\306E\540D\524D\3092\5165\529B\3057\307E\3059\3002\305F\3068\3048\3070\3001\5404\30DA\30FC\30B8\304C\8868\793A\307E\305F\306F\51E6\7406\3055\308C\308B\524D\3084\3001AJAX\30EA\30AF\30A8\30B9\30C8\304C\767A\884C\3055\308C\305F\5834\5408\306A\3069\3067\3059\3002'),
unistr('\3053\308C\306F\3001\30D1\30C3\30B1\30FC\30B8\5185\3067\3001\307E\305F\306F\30B9\30C8\30A2\30C9\30FB\30D5\30A1\30F3\30AF\30B7\30E7\30F3\3068\3057\3066\3001\8A8D\8A3C\306EPL/SQL\30B3\30FC\30C9\3067\5B9A\7FA9\3067\304D\307E\3059\3002</p>'),
unistr('<p>\3053\306E\30D5\30A1\30F3\30AF\30B7\30E7\30F3\304CFALSE\3092\8FD4\3057\305F\5834\5408(\30E6\30FC\30B6\30FC\304C\30ED\30B0\30A4\30F3\3057\3066\3044\306A\3044\3053\3068\3092\793A\3059)\3001\30BB\30C3\30B7\30E7\30F3\304C\6709\52B9\3067\306A\3044\3053\3068\3092\793A\3057\3001<em>\7121\52B9\306A\30BB\30C3\30B7\30E7\30F3\30FB\30D7\30ED\30B7\30FC\30B8\30E3</em>\304C\8D77\52D5\3055\308C\307E\3059\3002'),
unistr('\305D\306E\5F8C\3001&PRODUCT_NAME.\306F\300C\30BB\30C3\30B7\30E7\30F3\7121\52B9 > \79FB\52D5\5148\300D\3067\5B9A\7FA9\3055\308C\305FURL\306B\30EA\30C0\30A4\30EC\30AF\30C8\3057\307E\3059\3002'),
unistr('\3053\306E\30D5\30A3\30FC\30EB\30C9\306E\5024\304C\7A7A\306E\5834\5408\3001'),
unistr('\5185\90E8\3067\30C7\30D5\30A9\30EB\30C8\306E\76E3\8996\304C\30B3\30FC\30EB\3055\308C\3001URL\306E\30BB\30C3\30B7\30E7\30F3ID\3068\8A8D\53EF\30B9\30AD\30FC\30E0Cookie(\5931\6557\3057\305F\5834\5408\306F&PRODUCT_NAME.\30D3\30EB\30C0\30FCCookie\3078\306E\30D5\30A9\30FC\30EB\30D0\30C3\30AF)\306E\30BB\30C3\30B7\30E7\30F3\60C5\5831\3092\6BD4\8F03\3059\308B\3053\3068\306B\3088\3063\3066\6709\52B9\306A\30BB\30C3\30B7\30E7\30F3\3092\78BA\7ACB\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551983430308015470.442)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\30BB\30C3\30B7\30E7\30F3\30FB\30D7\30ED\30B7\30FC\30B8\30E3\540D\304C\7121\52B9\3067\3059')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'procedure invalid_session_basic_auth',
'is',
'begin',
'    owa_util.status_line (',
'        nstatus       => 401,',
'        creason       => ''Basic Authentication required'',',
'        bclose_header => false);',
'    htp.p(''WWW-Authenticate: Basic realm="protected realm"'');',
'    apex_application.stop_apex_engine;',
'end invalid_session_basic_auth;',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\7121\52B9\306A\30BB\30C3\30B7\30E7\30F3\304C\691C\51FA\3055\308C\305F\5834\5408\306B\30B3\30FC\30EB\3055\308C\308BPL/SQL\30D7\30ED\30B7\30FC\30B8\30E3\306E\540D\524D\3092\5165\529B\3057\307E\3059\3002</p>'),
'',
unistr('<p>\3053\308C\306F\3001\30C7\30FC\30BF\30D9\30FC\30B9\5185\306E\7121\540DPL/SQL\30B3\30FC\30C9\30FB\30D6\30ED\30C3\30AF\306E\30D5\30A1\30F3\30AF\30B7\30E7\30F3\3001\30D1\30C3\30B1\30FC\30B8\30FB\30D5\30A1\30F3\30AF\30B7\30E7\30F3\3001\307E\305F\306F\30B9\30BF\30F3\30C9\30A2\30ED\30F3\306E\30D5\30A1\30F3\30AF\30B7\30E7\30F3\3092\53C2\7167\3067\304D\307E\3059\3002\305F\3068\3048\3070\3001<code>invalid_session_basic_auth</code>\3067\3059\3002</p>'),
'',
unistr('<p>\30C7\30FC\30BF\30D9\30FC\30B9\306EPL/SQL\30D1\30C3\30B1\30FC\30B8\307E\305F\306F\30B9\30BF\30F3\30C9\30A2\30ED\30F3\306E\30D5\30A1\30F3\30AF\30B7\30E7\30F3\3092\53C2\7167\3059\308B\5834\5408\3001<code>#OWNER#</code>\7F6E\63DB\6587\5B57\5217\3092\4F7F\7528\3057\3066\3001\73FE\5728\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\89E3\6790\5BFE\8C61\30B9\30AD\30FC\30DE\3092\53C2\7167\3067\304D\307E\3059\3002\305F\3068\3048\3070\3001<code>#OWNER#.invalid_session_basic_auth</code>\3067\3059</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(353293115026395181.442)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\8A8D\8A3C\30D5\30A1\30F3\30AF\30B7\30E7\30F3\540D')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\300CPL/SQL\30B3\30FC\30C9\300D\30C6\30AD\30B9\30C8\9818\57DF\306B\6B21\306E\30B3\30FC\30C9\3092\5165\529B\3057\307E\3059</p>'),
'<pre>',
'function my_authentication (',
'    p_username in varchar2,',
'    p_password in varchar2 )',
'    return boolean',
'is',
'    l_user my_users.user_name%type := upper(p_username);',
'    l_id   my_users.id%type;',
'    l_hash my_users.password_hash%type;',
'begin',
'    begin',
'        select id  , password_hash',
'          into l_id, l_hash',
'          from my_users',
'         where user_name = l_user;',
'    exception when no_data_found then',
'        l_hash := ''-invalid-'';',
'    end;',
'',
'    return l_hash = rawtohex(sys.dbms_crypto.hash (',
'                        sys.utl_raw.cast_to_raw (',
'                            p_password||l_id||l_user ),',
'                        sys.dbms_crypto.hash_sh512 ));',
'end;',
'</pre>',
'',
unistr('<p>\300C\8A8D\8A3C\30D5\30A1\30F3\30AF\30B7\30E7\30F3\300D\3068\3057\3066<code>my_authentication</code>\3068\5165\529B\3057\307E\3059\3002')))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8\3067\5165\529B\3055\308C\305F\5F8C\306B\30E6\30FC\30B6\30FC\306E\30E6\30FC\30B6\30FC\540D\304A\3088\3073\30D1\30B9\30EF\30FC\30C9\3092\691C\8A3C\3059\308B\30D5\30A1\30F3\30AF\30B7\30E7\30F3\306E\540D\524D\3092\6307\5B9A\3057\307E\3059\3002'),
unistr('\4F55\3082\5165\529B\3057\306A\3044\5834\5408\3001\3059\3079\3066\306E\30E6\30FC\30B6\30FC\540D/\30D1\30B9\30EF\30FC\30C9\304C\30ED\30B0\30A4\30F3\3067\304D\307E\3059\3002'),
unistr('\30D5\30A1\30F3\30AF\30B7\30E7\30F3\81EA\4F53\306F\3001\30D1\30C3\30B1\30FC\30B8\5185\3067\3001\307E\305F\306F\30B9\30C8\30A2\30C9\30FB\30D5\30A1\30F3\30AF\30B7\30E7\30F3\3068\3057\3066\3001\8A8D\8A3C\306E\300CPL/SQL\30B3\30FC\30C9\300D\30C6\30AD\30B9\30C8\9818\57DF\3067\5B9A\7FA9\3067\304D\307E\3059\3002</p>'),
'',
unistr('<p>\3053\306E\30D5\30A1\30F3\30AF\30B7\30E7\30F3\306F\3001\30B3\30FC\30EB\3057\305F\30ED\30B0\30A4\30F3\30FB\30D7\30ED\30B7\30FC\30B8\30E3\306B\30D6\30FC\30EB\3092\8FD4\3059\5FC5\8981\304C\3042\308A\307E\3059\3002\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8\3067\5165\529B\3057\305F\5024\306B\30A2\30AF\30BB\30B9\3059\308B\306B\306F\3001p_username\3068p_password\306E2\3064\306E\30D1\30E9\30E1\30FC\30BF\3092\4F7F\7528\3067\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(353301225415398269.442)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\30ED\30B0\30A2\30A6\30C8\5F8C\30D7\30ED\30B7\30FC\30B8\30E3\540D')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\300CPL/SQL\30B3\30FC\30C9\300D\30C6\30AD\30B9\30C8\9818\57DF\306B\6B21\306E\30B3\30FC\30C9\3092\5165\529B\3057\307E\3059\3002</p>'),
'<pre>',
'procedure my_post_logout',
'is',
'begin',
'    insert into logout_log (',
'        application_id,',
'        session_id,',
'        logout_time,',
'        user_name',
'    ) values (',
'        :APP_ID,',
'        :APP_SESSION,',
'        sysdate,',
'        :APP_USER );',
'end;',
'</pre>',
'',
unistr('<p>\300C\30ED\30B0\30A2\30A6\30C8\5F8C\306E\624B\9806\300D\3068\3057\3066<code>my_post_logout</code>\3068\5165\529B\3057\307E\3059\3002</p>')))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\30ED\30B0\30A2\30A6\30C8URL\3092\30AF\30EA\30C3\30AF\3057\305F\5F8C\3067\547C\3073\51FA\3055\308C\308B\30D7\30ED\30B7\30FC\30B8\30E3\306E\540D\524D\3002\3053\308C\306F\30ED\30AE\30F3\30B0\306B\4F7F\7528\3067\304D\307E\3059\3002'),
unistr('\30D7\30ED\30B7\30FC\30B8\30E3\81EA\4F53\306F\3001\30D1\30C3\30B1\30FC\30B8\5185\3067\3001\307E\305F\306F\30B9\30C8\30A2\30C9\30FB\30D5\30A1\30F3\30AF\30B7\30E7\30F3\3068\3057\3066\3001\8A8D\8A3C\306E\300CPL/SQL\30B3\30FC\30C9\300D\30C6\30AD\30B9\30C8\9818\57DF\3067\5B9A\7FA9\3067\304D\307E\3059\3002')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629094915193552126.442)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\30EC\30AC\30B7\30FC\8A8D\8A3C\5C5E\6027\3092\6709\52B9\306B\3059\308B')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\3053\306E\9078\629E\30EA\30B9\30C8\3092\300C\306F\3044\300D\306B\8A2D\5B9A\3059\308B\3068\3001\8FFD\52A0\306E\8A8D\8A3C\5C5E\6027\304C\8868\793A\3055\308C\307E\3059\3002'),
unistr('\3053\308C\3089\306F\4E3B\306B\3001&PRODUCT_NAME. 4.0\4EE5\4E0B\304B\3089\79FB\690D\3055\308C\305F\30AB\30B9\30BF\30E0\8A8D\8A3C\306B\95A2\9023\3057\307E\3059\3002')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629174621211563368.442)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('SSO\30D1\30FC\30C8\30CA\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\540D')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Oracle Application Server Single Sign-On\3067\8A8D\8A3C\3057\3001\3054\4F7F\7528\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304CSSO\306B\767B\9332\6E08\306E\30D1\30FC\30C8\30CA\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\5834\5408\306F\3001\30D1\30FC\30C8\30CA\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092SSO\306B\767B\9332\3059\308B\969B\306B\4F7F\7528\3057\305F\540D\524D\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002'),
'',
unistr('Application Express\306B\3088\3063\3066\767B\9332\6E08\306E\30D1\30FC\30C8\30CA\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\306A\3063\3066\3044\308B\5834\5408\306F\3001\3053\306E\30D5\30A3\30FC\30EB\30C9\3092\7A7A\767D\306E\307E\307E\306B\3057\3066\304F\3060\3055\3044\3002')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629550107668606770.442)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('LDAP\30DB\30B9\30C8')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('LDAP\30C7\30A3\30EC\30AF\30C8\30EA\30FB\30B5\30FC\30D0\30FC\306E\30DB\30B9\30C8\540D\3067\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629554415286608926.442)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('LDAP\30DD\30FC\30C8')
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('LDAP\30C7\30A3\30EC\30AF\30C8\30EA\30FB\30DB\30B9\30C8\306E\30DD\30FC\30C8\756A\53F7\3067\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629644211608617346.442)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('SSL\306E\4F7F\7528')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_default_value=>'NO_SSL'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('SSL\3092\4F7F\7528\3057\3066LDAP\30C7\30A3\30EC\30AF\30C8\30EA\306B\30D0\30A4\30F3\30C9\3059\308B\304B\3069\3046\304B\3092\9078\629E\3057\3066\304F\3060\3055\3044\3002\300C\8A8D\8A3C\4ED8\304DSSL\300D\304C\9078\629E\3055\308C\3066\3044\308B\5834\5408\3001\30A6\30A9\30EC\30C3\30C8\3092Application Express\30A4\30F3\30B9\30BF\30F3\30B9\306B\69CB\6210\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(629669815417618470.442)
,p_plugin_attribute_id=>wwv_flow_api.id(629644211608617346.442)
,p_display_sequence=>10
,p_display_value=>'SSL'
,p_return_value=>'SSL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(629680822344620420.442)
,p_plugin_attribute_id=>wwv_flow_api.id(629644211608617346.442)
,p_display_sequence=>20
,p_display_value=>unistr('\8A8D\8A3C\4ED8\304DSSL')
,p_return_value=>'SSL_AUTH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(629685004813624810.442)
,p_plugin_attribute_id=>wwv_flow_api.id(629644211608617346.442)
,p_display_sequence=>30
,p_display_value=>unistr('SSL\306A\3057')
,p_return_value=>'NO_SSL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629825611870636385.442)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('LDAP DN\6587\5B57\5217')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>\5B8C\5168\306ADN</dt>'),
'  <dd><code>cn=%LDAP_USER%,l=amer,dc=yourdomain,dc=com</code></dd>',
unistr('  <dt>\975E\5B8C\5168\306ADN(\691C\7D22\30D9\30FC\30B9)</dt>'),
'  <dd><code>dc=yourdomain,dc=com</code></dd>',
'</dl>'))
,p_help_text=>unistr('\5B8C\5168\306ADN\3092\4F7F\7528\3059\308B\5834\5408\306FDBMS_LDAP.SIMPLE_BIND_S\306B\5B8C\5168\4FEE\98FE\8B58\5225\540D(DN)\6587\5B57\5217\3092\69CB\7BC9\3059\308B\305F\3081\306B\4F7F\7528\3055\308C\308B\30D1\30BF\30FC\30F3\3092\5165\529B\3057\3001\975E\5B8C\5168\306ADN\3092\4F7F\7528\3059\308B\5834\5408\306F\691C\7D22\30D9\30FC\30B9\3092\5165\529B\3057\307E\3059\3002<strong>%LDAP_USER%</strong>\3092\30E6\30FC\30B6\30FC\540D\306E\30D7\30EC\30FC\30B9\30DB\30EB\30C0\30FC\3068\3057\3066\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629787303213633849.442)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>unistr('\5B8C\5168\306A\8B58\5225\540D(DN)\306E\4F7F\7528')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('LDAP\8B58\5225\540D(DN)\6587\5B57\5217\304C\5B8C\5168\304B\975E\5B8C\5168\304B\3092\9078\629E\3057\3066\304F\3060\3055\3044\3002\975E\5B8C\5168\306E\5834\5408\3001LDAP\8B58\5225\540D(DN)\306F\691C\7D22\30D9\30FC\30B9\3067\3001\691C\7D22\30D5\30A3\30EB\30BF\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(741851526139627010.442)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>unistr('\691C\7D22\30D5\30A3\30EB\30BF')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629787303213633849.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'cn=%LDAP_USER%',
'</pre>'))
,p_help_text=>unistr('\5B8C\5168\306A\8B58\5225\540D(DN)\3092\4F7F\7528\3057\306A\3044\5834\5408\306F\3001\691C\7D22\30D5\30A3\30EB\30BF\3092\5165\529B\3057\307E\3059\3002\30E6\30FC\30B6\30FC\540D\306E\30D7\30EC\30FC\30B9\30DB\30EB\30C0\30FC\3068\3057\3066<code>%LDAP_USER%</code>\3092\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629863429878641530.442)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_prompt=>unistr('LDAP\30E6\30FC\30B6\30FC\540D\7DE8\96C6\30D5\30A1\30F3\30AF\30B7\30E7\30F3')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6B21\306E\30B3\30FC\30C9\3067\306F\3001DN\6587\5B57\5217\5185\306E\3059\3079\3066\306E"."\3092"_"\306B\7F6E\63DB\3059\308B\30D5\30A1\30F3\30AF\30B7\30E7\30F3\3092\30B3\30FC\30EB\3057\307E\3059\3002</p>'),
'<pre>',
'return apex_custom_auth.ldap_dnprep;',
'</pre>'))
,p_help_text=>unistr('LDAP\30C7\30A3\30EC\30AF\30C8\30EA\306E\30A8\30F3\30C8\30EA\307E\305F\306FLDAP\30E6\30FC\30B6\30FC\540D\306B\5B8C\5168\306B\9069\5408\3057\305F\5F62\5F0F\306B\3001\30E6\30FC\30B6\30FC\540D\3092\5909\63DB\3059\308B\305F\3081\306B\5B9F\884C\3059\308B\8FFD\52A0\30B3\30FC\30C9\3092\6307\5B9A\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(38291032596231774.442)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>unistr('\30E6\30FC\30B6\30FC\540D\30A8\30B9\30B1\30FC\30D7')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STD'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('LDAP\8B58\5225\540D\304A\3088\3073\691C\7D22\6587\5B57\5217\3067<code><strong>%LDAP_USER%</strong></code>\3092\7F6E\63DB\3059\308B\524D\306B\3001'),
unistr('&PRODUCT_NAME.\3067\30E6\30FC\30B6\30FC\540D\5185\306E\7279\6B8A\6587\5B57\304C\81EA\52D5\7684\306B\30A8\30B9\30B1\30FC\30D7\3055\308C\307E\3059\3002')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(38291304329233033.442)
,p_plugin_attribute_id=>wwv_flow_api.id(38291032596231774.442)
,p_display_sequence=>10
,p_display_value=>unistr('\6A19\6E96')
,p_return_value=>'STD'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('RFC 4514(\8B58\5225\540D\306B\95A2\3059\308B)\304A\3088\3073RFC 4515(\691C\7D22\6587\5B57\5217\306B\95A2\3059\308B)\306B\57FA\3065\3044\3066\7279\6B8A\6587\5B57\3092\30A8\30B9\30B1\30FC\30D7\3057\307E\3059\3002'),
unistr('\3055\3089\306B\3001Unicode\6587\5B57\3082\30A8\30B9\30B1\30FC\30D7\3057\307E\3059\3002'),
unistr('\3053\308C\306F\6700\3082\30BB\30AD\30E5\30A2\306A\8A2D\5B9A\3067\3059\304C\3001\4E00\90E8\306ELDAP\30B5\30FC\30D0\30FC\3067\306F\554F\984C\304C\767A\751F\3059\308B\53EF\80FD\6027\304C\3042\308A\307E\3059\3002')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(38291708139234196.442)
,p_plugin_attribute_id=>wwv_flow_api.id(38291032596231774.442)
,p_display_sequence=>20
,p_display_value=>unistr('\7279\6B8A\6587\5B57\306E\307F')
,p_return_value=>'ONLY'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('RFC 4514(\8B58\5225\540D\306B\95A2\3059\308B)\304A\3088\3073RFC 4515(\691C\7D22\6587\5B57\5217\306B\95A2\3059\308B)\306B\57FA\3065\3044\3066\7279\6B8A\6587\5B57\3092\30A8\30B9\30B1\30FC\30D7\3057\307E\3059\3002'),
unistr('Unicode\6587\5B57\306F\30A8\30B9\30B1\30FC\30D7\3057\307E\305B\3093\3002')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(38292111602235122.442)
,p_plugin_attribute_id=>wwv_flow_api.id(38291032596231774.442)
,p_display_sequence=>30
,p_display_value=>unistr('\30A8\30B9\30B1\30FC\30D7\306A\3057')
,p_return_value=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6587\5B57\3092\30A8\30B9\30B1\30FC\30D7\3057\307E\305B\3093\3002<strong>\30E6\30FC\30B6\30FC\540D\7DE8\96C6\30D5\30A1\30F3\30AF\30B7\30E7\30F3</strong>\3092'),
unistr('\4F7F\7528\3057\3066\3059\3067\306B\30E6\30FC\30B6\30FC\540D\3092\30A8\30B9\30B1\30FC\30D7(<code>apex_escape.ldap_dn</code>\307E\305F\306F'),
unistr('<code>apex_escape.ldap_search_filter</code>\306E\4F7F\7528\306A\3069)\3057\3066\3044\306A\3044\304B\304E\308A\3001\3053\306E\8A2D\5B9A\306F\30BB\30AD\30E5\30A2\3067\306A\3044\53EF\80FD\6027\304C\3042\308A\307E\3059\3002')))
);
end;
/
prompt --application/shared_components/plugins/process_type/plsql
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(360896225809711408.442)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'PLSQL'
,p_display_name=>unistr('\30B3\30FC\30C9\3092\5B9F\884C')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC:APEX_APPL_AUTOMATION_ACTIONS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','PLSQL'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('PL/SQL\30B3\30FC\30C9\3092\5B9F\884C\3059\308B\30D7\30ED\30BB\30B9\3002')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/process_type/close_window
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361240401142661438.442)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'CLOSE_WINDOW'
,p_display_name=>unistr('\30C0\30A4\30A2\30ED\30B0\3092\9589\3058\308B')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','CLOSE_WINDOW'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\73FE\5728\306E\30E2\30FC\30C0\30EB\307E\305F\306F\975E\30E2\30FC\30C0\30EB\30FB\30C0\30A4\30A2\30ED\30B0\30FB\30DA\30FC\30B8\3092\9589\3058\308B\30D7\30ED\30BB\30B9\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(369154203766535800.442)
,p_plugin_id=>wwv_flow_api.id(361240401142661438.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\623B\3059\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30C0\30A4\30A2\30ED\30B0\306B\3088\3063\3066\8FD4\3055\308C\308B1\3064\4EE5\4E0A\306E\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306E\540D\524D\3092\5165\529B\3057\307E\3059\3002\8907\6570\306E\30A2\30A4\30C6\30E0\306E\5834\5408\3001\5404\30A2\30A4\30C6\30E0\540D\3092\30AB\30F3\30DE\3067\533A\5207\308A\307E\3059\3002</p>'),
unistr('<p><strong>\300C\30C0\30A4\30A2\30ED\30B0\306E\623B\308A\30A2\30A4\30C6\30E0\300D</strong>\306E<em>\300C\5024\306E\8A2D\5B9A\300D</em>\304A\3088\3073<strong>\300C\30BF\30A4\30D7\306E\8A2D\5B9A\300D</strong>\306E\30A2\30AF\30B7\30E7\30F3\3068\3068\3082\306B\3001\30C0\30A4\30A2\30ED\30B0\3092\958B\304F\8981\7D20\306E<strong>\300C\30C0\30A4\30A2\30ED\30B0\306E\30AF\30ED\30FC\30BA\300D</strong>\30A4\30D9\30F3\30C8\3067\8D77\52D5\3059\308B\52D5\7684\30A2\30AF\30B7\30E7\30F3\3092\5B9A\7FA9\3057\3066\3001\623B\3055\308C\305F\30A2\30A4\30C6\30E0\5024\306B\30A2\30AF\30BB\30B9\3067\304D\307E\3059\3002</p>')))
);
end;
/
prompt --application/shared_components/plugins/process_type/session_state
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361248208719417603.442)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'SESSION_STATE'
,p_display_name=>unistr('\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\306E\30AF\30EA\30A2')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','SESSION_STATE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('&PRODUCT_NAME.\5185\306B\683C\7D0D\3055\308C\3066\3044\308B\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\3092\30AF\30EA\30A2\3059\308B\30D7\30ED\30BB\30B9\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361248525085440449.442)
,p_plugin_id=>wwv_flow_api.id(361248208719417603.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\30BF\30A4\30D7')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'CLEAR_CACHE_CURRENT_PAGE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\30AF\30EA\30A2\3059\308B\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\306E\30BF\30A4\30D7\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361259116722915252.442)
,p_plugin_attribute_id=>wwv_flow_api.id(361248525085440449.442)
,p_display_sequence=>1
,p_display_value=>unistr('\73FE\5728\306E\30DA\30FC\30B8\306E\3059\3079\3066\306E\30A2\30A4\30C6\30E0\306E\30AF\30EA\30A2')
,p_return_value=>'CLEAR_CACHE_CURRENT_PAGE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361250412576446197.442)
,p_plugin_attribute_id=>wwv_flow_api.id(361248525085440449.442)
,p_display_sequence=>3
,p_display_value=>unistr('\30DA\30FC\30B8\306E\3059\3079\3066\306E\30A2\30A4\30C6\30E0\306E\30AF\30EA\30A2')
,p_return_value=>'CLEAR_CACHE_FOR_PAGES'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361250015380444942.442)
,p_plugin_attribute_id=>wwv_flow_api.id(361248525085440449.442)
,p_display_sequence=>5
,p_display_value=>unistr('\30A2\30A4\30C6\30E0\306E\30AF\30EA\30A2  ')
,p_return_value=>'CLEAR_CACHE_FOR_ITEMS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361249617968443751.442)
,p_plugin_attribute_id=>wwv_flow_api.id(361248525085440449.442)
,p_display_sequence=>7
,p_display_value=>unistr('\73FE\5728\306E\30BB\30C3\30B7\30E7\30F3\306E\30AF\30EA\30A2')
,p_return_value=>'RESET_SESSION_STATE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361249219909442830.442)
,p_plugin_attribute_id=>wwv_flow_api.id(361248525085440449.442)
,p_display_sequence=>9
,p_display_value=>unistr('\73FE\5728\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30AF\30EA\30A2')
,p_return_value=>'CLEAR_CACHE_CURRENT_FLOW'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361248822065441760.442)
,p_plugin_attribute_id=>wwv_flow_api.id(361248525085440449.442)
,p_display_sequence=>10
,p_display_value=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30AF\30EA\30A2')
,p_return_value=>'CLEAR_CACHE_FOR_FLOWS'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361253232596482537.442)
,p_plugin_id=>wwv_flow_api.id(361248208719417603.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(361248525085440449.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'CLEAR_CACHE_FOR_FLOWS'
,p_help_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3ID\306E\30AB\30F3\30DE\533A\5207\308A\306E\30EA\30B9\30C8(<code>100,101,105</code>\306A\3069)\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361254917715489399.442)
,p_plugin_id=>wwv_flow_api.id(361248208719417603.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(361248525085440449.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'CLEAR_CACHE_FOR_ITEMS'
,p_help_text=>unistr('\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\304B\3089\30AF\30EA\30A2\3059\308B\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0(<code>P1_EMPNO,P1_ENAME</code>\306A\3069)\3092\9078\629E\3057\307E\3059\3002\8907\6570\306E\30A2\30A4\30C6\30E0\306E\5834\5408\3001\5404\30A2\30A4\30C6\30E0\540D\3092\30AB\30F3\30DE\3067\533A\5207\308A\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361255209304493322.442)
,p_plugin_id=>wwv_flow_api.id(361248208719417603.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\30DA\30FC\30B8')
,p_attribute_type=>'PAGE NUMBERS'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(361248525085440449.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'CLEAR_CACHE_FOR_PAGES'
,p_help_text=>unistr('\30DA\30FC\30B8\756A\53F7\306E\30AB\30F3\30DE\533A\5207\308A\306E\30EA\30B9\30C8(<code>1,2,5</code>\306A\3069)\3092\5165\529B\3057\307E\3059\3002')
);
end;
/
prompt --application/shared_components/plugins/process_type/reset_pagination
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361603521916198029.442)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'RESET_PAGINATION'
,p_display_name=>unistr('\30DA\30FC\30B8\533A\5207\308A\306E\30EA\30BB\30C3\30C8')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','RESET_PAGINATION'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\73FE\5728\306E\30DA\30FC\30B8\3067\30EC\30DD\30FC\30C8\306E\30DA\30FC\30B8\533A\5207\308A\3092\30EA\30BB\30C3\30C8\3059\308B\30D7\30ED\30BB\30B9\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361603814800201390.442)
,p_plugin_id=>wwv_flow_api.id(361603521916198029.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\30BF\30FC\30B2\30C3\30C8')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'THIS_PAGE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\30DA\30FC\30B8\533A\5207\308A\3092\30EA\30BB\30C3\30C8\3059\308B\306E\306F\3001\3059\3079\3066\306E\30DA\30FC\30B8\304B\3001\4E00\90E8\306E\30DA\30FC\30B8\304B\3001\73FE\5728\306E\30DA\30FC\30B8\304B\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361604111996202714.442)
,p_plugin_attribute_id=>wwv_flow_api.id(361603814800201390.442)
,p_display_sequence=>10
,p_display_value=>unistr('\3053\306E\30DA\30FC\30B8')
,p_return_value=>'THIS_PAGE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361604905742205597.442)
,p_plugin_attribute_id=>wwv_flow_api.id(361603814800201390.442)
,p_display_sequence=>20
,p_display_value=>unistr('\30DA\30FC\30B8')
,p_return_value=>'PAGES'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361604508330204363.442)
,p_plugin_attribute_id=>wwv_flow_api.id(361603814800201390.442)
,p_display_sequence=>30
,p_display_value=>unistr('\3059\3079\3066\306E\30DA\30FC\30B8')
,p_return_value=>'ALL_PAGES'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361606225139211720.442)
,p_plugin_id=>wwv_flow_api.id(361603521916198029.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\30DA\30FC\30B8')
,p_attribute_type=>'PAGE NUMBERS'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(361603814800201390.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PAGES'
,p_help_text=>unistr('\30DA\30FC\30B8\756A\53F7\306E\30AB\30F3\30DE\533A\5207\308A\306E\30EA\30B9\30C8\3092\5165\529B\3057\307E\3059\3002')
);
end;
/
prompt --application/shared_components/plugins/process_type/tabform_add_rows
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361705302264974293.442)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'TABFORM_ADD_ROWS'
,p_display_name=>unistr('\8868\5F62\5F0F\30D5\30A9\30FC\30E0 - \884C\306E\8FFD\52A0')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','TABFORM_ADD_ROWS'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REGION_REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('\8868\5F62\5F0F\30D5\30A9\30FC\30E0\30FB\30EA\30FC\30B8\30E7\30F3\306B\884C\3092\8FFD\52A0\3059\308B\30D7\30ED\30BB\30B9\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361705527915977613.442)
,p_plugin_id=>wwv_flow_api.id(361705302264974293.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\884C\6570')
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'1'
,p_is_translatable=>false
,p_help_text=>unistr('\884C\306E\6570\3092\5165\529B\3057\307E\3059\3002')
);
end;
/
prompt --application/shared_components/plugins/process_type/tabform_update
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361709604296657121.442)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'TABFORM_UPDATE'
,p_display_name=>unistr('\8868\5F62\5F0F\30D5\30A9\30FC\30E0 - \8907\6570\884C\306E\66F4\65B0')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','TABFORM_UPDATE'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REGION_REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('\8868\5F62\5F0F\30D5\30A9\30FC\30E0\30FB\30EA\30FC\30B8\30E7\30F3\304B\3089\8907\6570\306E\884C\3092\66F4\65B0\3059\308B\30D7\30ED\30BB\30B9\3002\3053\306E\30D7\30ED\30BB\30B9\3067\306F\3001\30EA\30FC\30B8\30E7\30F3\306B\8FFD\52A0\3055\308C\308B\30EC\30B3\30FC\30C9\306E\633F\5165\3082\884C\308F\308C\307E\3059\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361709824771662765.442)
,p_plugin_id=>wwv_flow_api.id(361709604296657121.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\8868\306E\6240\6709\8005')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>unistr('\8868\306E\6240\6709\8005(\30B9\30AD\30FC\30DE)\540D\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361710119164665443.442)
,p_plugin_id=>wwv_flow_api.id(361709604296657121.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\8868\540D')
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361709824771662765.442)
,p_help_text=>unistr('\5927/\5C0F\6587\5B57\3092\533A\5225\3057\305F\8868\307E\305F\306F\30D3\30E5\30FC\306E\540D\524D\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361710408812670214.442)
,p_plugin_id=>wwv_flow_api.id(361709604296657121.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\4E3B\30AD\30FC\5217')
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361710119164665443.442)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4E3B\30AD\30FC\5024\3092\542B\3080\5217\3092\9078\629E\3057\307E\3059\30022\3064\3088\308A\591A\3044\90E8\5206\304B\3089\6210\308B\4E3B\30AD\30FC\3092\6301\3064\8868\306E\5834\5408\3001<strong>ROWID</strong>\3092\9078\629E\3057\307E\3059\3002</p>'),
unistr('<p>\4E3B\30AD\30FC\306F\3001\66F4\65B0\3055\308C\308B\884C\306E\8B58\5225\306B\4F7F\7528\3055\308C\3001\8868\5F62\5F0F\30D5\30A9\30FC\30E0\3067\7DE8\96C6\4E0D\53EF\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\65B0\898F\884C\306E\5834\5408\3001\4E3B\30AD\30FC\5024\306F\7A7A\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361710732738674350.442)
,p_plugin_id=>wwv_flow_api.id(361709604296657121.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('2\6B21\30AD\30FC\5217')
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361710119164665443.442)
,p_help_text=>unistr('2\3064\76EE\306E\4E3B\30AD\30FC\5024\3092\542B\3080\5217\3092\9078\629E\3057\307E\3059\3002\3053\306E\5C5E\6027\306B\306F\3001\4E3B\30AD\30FC\304C2\3064\306E\5217\3067\69CB\6210\3055\308C\308B\5834\5408\306B\306E\307F\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361711421080694858.442)
,p_plugin_id=>wwv_flow_api.id(361709604296657121.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\5B9F\884C\6642\306EWHERE\53E5')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6B21\3092\4F7F\7528\3057\3066\90E8\9580\3092\9650\5B9A:'),
'  <code>DEPTNO = 10</code>'))
,p_help_text=>unistr('\751F\6210\3055\308C\308B\3059\3079\3066\306EINSERT\6587\304A\3088\3073UPDATE\6587\306B\8FFD\52A0\3059\308BSQL\306EWHERE\53E5\3092\5165\529B\3057\307E\3059\3002\3053\306E\5C5E\6027\3092\4F7F\7528\3057\3066\3001\81EA\52D5\7684\306B\751F\6210\3055\308C\308BSQL\30B3\30FC\30EB\5185\3067\4F7F\7528\3055\308C\308B\30EC\30B3\30FC\30C9\3092\5236\9650\3057\307E\3059\3002')
);
end;
/
prompt --application/shared_components/plugins/process_type/form_fetch
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361799714569626543.442)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_FETCH'
,p_display_name=>unistr('\884C\306E\81EA\52D5\30D5\30A7\30C3\30C1')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_FETCH'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>unistr('1\3064\306E\30C7\30FC\30BF\30D9\30FC\30B9\8868\307E\305F\306F\30D3\30E5\30FC\304B\3089\30EC\30B3\30FC\30C9\3092\53D6\5F97\3059\308B\30D7\30ED\30BB\30B9\3002\3053\306E\30D7\30ED\30BB\30B9\306F\3001<strong>\300C\30C7\30FC\30BF\30D9\30FC\30B9\5217\300D</strong>\30BF\30A4\30D7\306E\30BD\30FC\30B9\306E\30D5\30A9\30FC\30E0\30FB\30A2\30A4\30C6\30E0\3078\306E\79FB\5165\306B\4F7F\7528\3055\308C\307E\3059\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361800032025633659.442)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\8868\306E\6240\6709\8005')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>unistr('\8868\306E\6240\6709\8005(\30B9\30AD\30FC\30DE)\540D\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361800327927635543.442)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\8868\540D')
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361800032025633659.442)
,p_help_text=>unistr('\5927/\5C0F\6587\5B57\3092\533A\5225\3057\305F\8868\307E\305F\306F\30D3\30E5\30FC\306E\540D\524D\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361800622105638213.442)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\4E3B\30AD\30FC\30FB\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\4E3B\30AD\30FC\5217\5024\3092\4FDD\6301\3059\308B\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
,p_attribute_comment=>'$$$ DJP - Pop-up LOV allows selection of Custom Page, Global Page, Application Items as well - Shouldn''t it only be Page Items?'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361800918654639837.442)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>25
,p_prompt=>unistr('\4E3B\30AD\30FC\5217')
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361800327927635543.442)
,p_help_text=>unistr('\4E3B\30AD\30FC\5024\3092\542B\3080\5217\3092\9078\629E\3057\307E\3059\30022\3064\3088\308A\591A\3044\90E8\5206\304B\3089\6210\308B\4E3B\30AD\30FC\3092\6301\3064\8868\306E\5834\5408\3001<strong>ROWID</strong>\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361801213910642088.442)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('2\6B21\30AD\30FC\30FB\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(361801505499645968.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('2\3064\76EE\306E\4E3B\30AD\30FC\5217\5024\3092\4FDD\6301\3059\308B\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361801505499645968.442)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>40
,p_prompt=>unistr('2\6B21\30AD\30FC\5217')
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361800327927635543.442)
,p_depending_on_attribute_id=>wwv_flow_api.id(361800918654639837.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'ROWID'
,p_help_text=>unistr('2\3064\76EE\306E\4E3B\30AD\30FC\5024\3092\542B\3080\5217\3092\9078\629E\3057\307E\3059\3002\3053\306E\5C5E\6027\306B\306F\3001\4E3B\30AD\30FC\304C2\3064\306E\5217\3067\69CB\6210\3055\308C\308B\5834\5408\306B\306E\307F\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361805328759939092.442)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\884C\30D0\30FC\30B8\30E7\30F3\5217')
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:INTERVAL_Y2M:INTERVAL_D2S'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361800327927635543.442)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\884C\306E\30D0\30FC\30B8\30E7\30F3\3092\8B58\5225\3059\308B\5217\3092\9078\629E\3057\307E\3059\3002\3053\306E\5217\3092\30DA\30FC\30B8\306B\8868\793A\3059\308B\5FC5\8981\306F\3042\308A\307E\305B\3093\3002\7D44\8FBC\307F\30C1\30A7\30C3\30AF\30B5\30E0\3092\4F7F\7528\3059\308B\5834\5408\3001\3053\306E\5C5E\6027\3092\7A7A\767D\306E\307E\307E\306B\3057\307E\3059\3002</p>'),
unistr('<p>\4FBF\5B9C\7684\30ED\30C3\30AF\3067\306F\3001\5931\308F\308C\305F\66F4\65B0\306E\691C\51FA\3092\4F7F\7528\3057\3066\3001\30C7\30FC\30BF\304C\540C\6642\306B\30A2\30AF\30BB\30B9\3055\308C\308B\53EF\80FD\6027\306E\3042\308B\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\306E\30C7\30FC\30BF\306E\5B8C\5168\6027\3092\4FDD\8A3C\3057\307E\3059\3002&PRODUCT_NAME.\306F\3001\7D44\8FBC\307F\30C1\30A7\30C3\30AF\30B5\30E0\3092\4F7F\7528\3057\3066\5931\308F\308C\305F\66F4\65B0\306E\691C\51FA\304A\3088\3073\884C\306E\30D0\30FC\30B8\30E7\30F3\306E\6C7A\5B9A\3092\5B9F\884C\3067\304D\307E\3059\3002\30C1\30A7\30C3\30AF\30B5\30E0\306F\3001\7279\5B9A\306E\8868\306E\884C\306B\5BFE\3059\308B\3059\3079\3066\306E\5217\5024\306E\30CF\30C3\30B7\30E5\95A2\6570\3067\3059\3002\3053\308C\306F\3001\30EC\30B3\30FC\30C9\3092\30C7\30FC\30BF\30D9\30FC\30B9\304B\3089\554F\3044\5408\305B\308B\969B\306B\53D6\5F97\3055\308C\3001<em>\884C\306E\81EA\52D5\51E6\7406</em>\306E\4E00\74B0\3068\3057\3066\30C7\30FC\30BF\30D9\30FC\30B9\5185\306E\73FE\5728\306E\30EC\30B3\30FC\30C9\306E\30CF\30C3\30B7\30E5\3068\6BD4\8F03\3055\308C\307E\3059\30022\3064\306E\5024\304C\540C\3058')
||unistr('\5834\5408\3001\66F4\65B0\304C\9032\3081\3089\308C\307E\3059\3002\540C\3058\3067\306F\306A\3044\5834\5408\3001\884C\306E\81EA\52D5\51E6\7406\306B\3088\3063\3066\30A8\30E9\30FC\304C\751F\6210\3055\308C\307E\3059\3002</p>'),
unistr('<p>\3053\306E\5C5E\6027\306B\3088\3063\3066\3001\7D44\8FBC\307F\30C1\30A7\30C3\30AF\30B5\30E0\51E6\7406\3092\4F7F\7528\3059\308B\304B\308F\308A\3068\306A\308B\3001\884C\30D0\30FC\30B8\30E7\30F3\3092\4FDD\6301\3059\308B1\3064\306E\5217\3092\6307\5B9A\3067\304D\307E\3059\3002\3053\306E\5217\306F\3001\30C7\30FC\30BF\30D9\30FC\30B9\5185\306E\30EC\30B3\30FC\30C9\304C\66F4\65B0\3055\308C\305F\5834\5408\5FC5\305A\66F4\65B0\3055\308C\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\8868\306B\300C\66F4\65B0\524D\300D\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30C8\30EA\30AC\30FC\3092\5B9F\88C5\3057\3066\5897\5206\3059\308B\304B\3001\884C\30D0\30FC\30B8\30E7\30F3\5217\3092\66F4\65B0\3059\308B\3053\3068\3092\304A\85A6\3081\3057\307E\3059\3002NUMBER\5217\306F\3001\884C\306E\9806\5E8F\756A\53F7\3092\542B\3080\3068\307F\306A\3055\308C\307E\3059\3002\305F\3060\3057\3001DATE\304A\3088\3073TIMESTAMP\306E\5217\3082\4F7F\7528\3067\304D\307E\3059\30021\3064\306E\5217\3092\4F7F\7528\3059\308B\5229\70B9\306F\3001&PRODUCT_NAME.\30A8\30F3\30B8\30F3\3067\884C\5168\4F53\306E\30CF\30C3\30B7\30E5\3092\5B9F\884C\3059\308B')
||unistr('\5FC5\8981\304C\306A\3044\3053\3068\3067\3059\3002\304B\308F\308A\306B\30011\3064\306E\5217\5024\3092\6BD4\8F03\3059\308B\306E\307F\3067\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361804814168854679.442)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\5B9F\884C\6642\306EWHERE\53E5')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6B21\3092\4F7F\7528\3057\3066\90E8\9580\3092\9650\5B9A:'),
'  <code>DEPTNO = 10</code>'))
,p_help_text=>unistr('\751F\6210\3055\308C\308BSELECT\6587\306B\8FFD\52A0\3059\308BSQL\306EWHERE\53E5\3092\5165\529B\3057\307E\3059\3002\3053\306E\5C5E\6027\3092\4F7F\7528\3057\3066\3001\81EA\52D5\7684\306B\751F\6210\3055\308C\308BSQL\30B3\30FC\30EB\5185\3067\4F7F\7528\3055\308C\308B\30EC\30B3\30FC\30C9\3092\5236\9650\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361802100261724338.442)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>unistr('\30D5\30A7\30C3\30C1\30FB\30E2\30FC\30C9')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_deprecated_values=>'D'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('\3053\306E\30AA\30D7\30B7\30E7\30F3\304C\3042\308B\306E\306F\3001\4E0B\4F4D\4E92\63DB\6027\306E\305F\3081\306E\307F\3067\3059\3002'),
unistr('\65B0\898F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306F\3001\3053\306E\8A2D\5B9A\3092\5FC5\305A\7A7A\306E\307E\307E\306B\3057\307E\3059\3002'),
unistr('\30AA\30D7\30B7\30E7\30F3\300C\8868\793A\6642\306B\30E1\30E2\30EA\30FC\30FB\30AD\30E3\30C3\30B7\30E5\3092\8A2D\5B9A\300D"\306F\975E\63A8\5968\3067\3001\3053\306E\30EA\30EA\30FC\30B9\306E&PRODUCT_NAME.\3067\751F\6210\3055\308C\308B\30D7\30ED\30BB\30B9\3067\306F\4F7F\7528\3055\308C\307E\305B\3093\3002'),
'</p>',
'<p>',
unistr('\884C\306E\81EA\52D5\30D5\30A7\30C3\30C1\30FB\30D7\30ED\30BB\30B9\3067\884C\304C\9078\629E\3055\308C\308B\3068\3001\5BFE\5FDC\3059\308B\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\304C\30D5\30A7\30C3\30C1\3055\308C\305F\5217\5024\306B\8A2D\5B9A\3055\308C\307E\3059\3002DML\30D5\30A7\30C3\30C1\30FB\30E2\30FC\30C9\306E\8A2D\5B9A\306B\3088\3063\3066\3001\305D\306E\30D7\30ED\30BB\30B9\304C\5B9F\884C\3055\308C\308B\30BF\30A4\30DF\30F3\30B0\304C\6C7A\5B9A\3055\308C\307E\3059\3002\30C7\30D5\30A9\30EB\30C8\30FB\30E2\30FC\30C9\3067\306F\3001\884C\304C\30D5\30A7\30C3\30C1\3055\308C\308B\3068\3059\3050\306B\30A4\30F3\30E1\30E2\30EA\30FC\30FB\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\304C\66F4\65B0\3055\308C\307E\3059\3002\30E2\30FC\30C9\300C\8868\793A\6642\306B\30E1\30E2\30EA\30FC\30FB\30AD\30E3\30C3\30B7\30E5\3092\8A2D\5B9A\300D\3067\306F\3001\30A2\30A4\30C6\30E0\304C\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\305F\5834\5408\306B\306E\307F\3001\3053\306E\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\304C\66F4\65B0\3055\308C\307E\3059\3002\884C\304C\30D5\30A7\30C3\30C1\3055\308C\305F\6642\9593\304B\3089\30A2\30A4\30C6\30E0\304C\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\305F\6642\9593\306E\9593\306B\3001\30D0\30A4\30F3\30C9\5909')
||unistr('\6570\307E\305F\306F<code>v(''ITEM_NAME'')</code>\69CB\6587\3092\4F7F\7528\3057\3066\3001\30D5\30A7\30C3\30C1\3055\308C\305F\30A2\30A4\30C6\30E0\306E\5024\3092\53C2\7167\3059\308B\5FC5\8981\304C\3042\308B\5834\5408\3001\30C7\30D5\30A9\30EB\30C8\30FB\30D5\30A7\30C3\30C1\30FB\30E2\30FC\30C9\3092\4F7F\7528\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\65B0\3057\3044\884C\306E\81EA\52D5\30D5\30A7\30C3\30C1\30FB\30D7\30ED\30BB\30B9\3092\4F5C\6210\3059\308B\3068\3001\305D\306E\30D5\30A7\30C3\30C1\30FB\30E2\30FC\30C9\306F\3053\306E\30C7\30D5\30A9\30EB\30C8\30FB\30E2\30FC\30C9\306B\8A2D\5B9A\3055\308C\307E\3059\3002\30DA\30FC\30B8\306E\30ED\30B8\30C3\30AF\304C\300C\8868\793A\6642\300D\306E\52D5\4F5C\306B\4F9D\5B58\3057\3066\3044\306A\3044\5834\5408\306F\3001\30DA\30FC\30B8\30FB\30EC\30F3\30C0\30EA\30F3\30B0\4E2D\306B\30D5\30A7\30C3\30C1\3055\308C\305F\5217\5024\3092\67D4\8EDF\306B\53C2\7167\3067\304D\308B\3088\3046\306B\3001\30C7\30D5\30A9\30EB\30C8\306E\52D5\4F5C\3092\4F7F\7528\3059\308B\3088\3046\306B\3053\306E\30D7\30ED\30BB\30B9\3092\66F4\65B0\3059\308B\3053\3068\3092\304A\85A6\3081\3057\307E\3059\3002'),
'</p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361803025912727611.442)
,p_plugin_attribute_id=>wwv_flow_api.id(361802100261724338.442)
,p_display_sequence=>20
,p_display_value=>unistr('\8868\793A\6642\306B\30E1\30E2\30EA\30FC\30FB\30AD\30E3\30C3\30B7\30E5\3092\8A2D\5B9A [\975E\63A8\5968]')
,p_return_value=>'D'
);
end;
/
prompt --application/shared_components/plugins/process_type/web_service
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361898027238424612.442)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'WEB_SERVICE'
,p_display_name=>unistr('Web\30B5\30FC\30D3\30B9')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','WEB_SERVICE'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\6307\5B9A\3055\308C\305FWeb\30B5\30FC\30D3\30B9\3092\6D88\8CBB\3059\308B\30D7\30ED\30BB\30B9\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361898312142431520.442)
,p_plugin_id=>wwv_flow_api.id(361898027238424612.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Web\30B5\30FC\30D3\30B9\64CD\4F5C')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_translatable=>false
,p_lov_type=>'COMPONENT'
,p_lov_component_type_id=>3541
,p_help_text=>unistr('Web\30B5\30FC\30D3\30B9\64CD\4F5C\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(703289302749886160.442)
,p_plugin_id=>wwv_flow_api.id(361898027238424612.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\7D50\679C\306E\683C\7D0D\5834\6240')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(703289611172888366.442)
,p_plugin_attribute_id=>wwv_flow_api.id(703289302749886160.442)
,p_display_sequence=>10
,p_display_value=>unistr('\30A2\30A4\30C6\30E0')
,p_return_value=>'ITEMS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(703290033944889185.442)
,p_plugin_attribute_id=>wwv_flow_api.id(703289302749886160.442)
,p_display_sequence=>20
,p_display_value=>unistr('\30B3\30EC\30AF\30B7\30E7\30F3')
,p_return_value=>'COLLECTION'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(703290641370900883.442)
,p_plugin_id=>wwv_flow_api.id(361898027238424612.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\30B3\30EC\30AF\30B7\30E7\30F3\540D')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(703289302749886160.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'COLLECTION'
,p_text_case=>'UPPER'
);
end;
/
prompt --application/shared_components/plugins/process_type/form_pagination
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(362034004386015380.442)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_PAGINATION'
,p_display_name=>unistr('\30D5\30A9\30FC\30E0\30FB\30DA\30FC\30B8\533A\5207\308A')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_PAGINATION'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30C7\30FC\30BF\30D9\30FC\30B9\8868\307E\305F\306F\30D3\30E5\30FC\304B\3089\524D\307E\305F\306F\6B21\306E\30EC\30B3\30FC\30C9\3092\53D6\5F97\3059\308B\30D7\30ED\30BB\30B9\3002\3053\306E\30D7\30ED\30BB\30B9\3092\4F7F\7528\3057\3066\30D5\30A9\30FC\30E0\30FB\30DA\30FC\30B8\306B\30DA\30FC\30B8\533A\5207\308A\304C\914D\7F6E\3055\308C\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\30EC\30DD\30FC\30C8\306B\623B\3089\305A\306B\524D\307E\305F\306F\6B21\306E\30EC\30B3\30FC\30C9\3092\53D6\5F97\3067\304D\307E\3059\3002</p>'),
unistr('<p><em>\30CE\30FC\30C8: \30D5\30A9\30FC\30E0\3067\30C7\30FC\30BF\306E\66F4\65B0\304C\53EF\80FD\306A\5834\5408\3001\901A\5E38\3001\3053\306E\30DA\30FC\30B8\533A\5207\308A\30D7\30ED\30BB\30B9\306E\5B9F\884C\524D\306B\9069\5207\306A\30D5\30A9\30FC\30E0\51E6\7406\304C\884C\308F\308C\308B\3088\3046\306B\3057\307E\3059\3002\305D\3046\3057\306A\3044\3068\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\3088\308B\66F4\65B0\306F\3001\5225\306E\30EC\30B3\30FC\30C9\306B\30CA\30D3\30B2\30FC\30C8\3059\308B\3068\5931\308F\308C\307E\3059\3002</em></p>')))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362034324862021077.442)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\8868\306E\6240\6709\8005')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>unistr('\8868\306E\6240\6709\8005(\30B9\30AD\30FC\30DE)\540D\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362034618176024149.442)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\8868\540D')
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(362034324862021077.442)
,p_help_text=>unistr('\5927/\5C0F\6587\5B57\3092\533A\5225\3057\305F\8868\307E\305F\306F\30D3\30E5\30FC\306E\540D\524D\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362035122261037451.442)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>40
,p_prompt=>unistr('\4E3B\30AD\30FC\30FB\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\4E3B\30AD\30FC\5217\5024\3092\4FDD\6301\3059\308B\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362035415360040649.442)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>30
,p_prompt=>unistr('\4E3B\30AD\30FC\5217')
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_default_value=>'ROWID'
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(362034618176024149.442)
,p_help_text=>unistr('\4E3B\30AD\30FC\5024\3092\542B\3080\5217\3092\9078\629E\3057\307E\3059\30022\3064\3088\308A\591A\3044\90E8\5206\304B\3089\6210\308B\4E3B\30AD\30FC\3092\6301\3064\8868\306E\5834\5408\3001<strong>ROWID>/strong>\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362035708675043722.442)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>60
,p_prompt=>unistr('2\6B21\30AD\30FC\30FB\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(362036002636046567.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('2\3064\76EE\306E\4E3B\30AD\30FC\5217\5024\3092\4FDD\6301\3059\308B\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362036002636046567.442)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>50
,p_prompt=>unistr('2\6B21\30AD\30FC\5217')
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(362034618176024149.442)
,p_depending_on_attribute_id=>wwv_flow_api.id(362035415360040649.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'ROWID'
,p_help_text=>unistr('2\3064\76EE\306E\4E3B\30AD\30FC\5024\3092\542B\3080\5217\3092\9078\629E\3057\307E\3059\3002\3053\306E\5C5E\6027\306B\306F\3001\4E3B\30AD\30FC\304C2\3064\306E\5217\3067\69CB\6210\3055\308C\308B\5834\5408\306B\306E\307F\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362067915033505841.442)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\30CA\30D3\30B2\30FC\30B7\30E7\30F3\9806\5E8F\5217')
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(362034618176024149.442)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30CA\30D3\30B2\30FC\30B7\30E7\30F3\306E\9806\5E8F\5024\3092\542B\3080\5217\3092\9078\629E\3057\307E\3059\3002</p>'),
unistr('<p>\3053\306E\5217\306F\3001\524D\307E\305F\306F\6B21\306E\884C\306E\6C7A\5B9A\306B\4F7F\7528\3055\308C\307E\3059\3002\3057\305F\304C\3063\3066\3001<code>DISPLAY_SEQ</code>\306A\3069\306E\5217\304C\4F7F\7528\306B\9069\3057\305F\5217\3067\3059\3002\9806\5E8F\304B\3089\79FB\5165\3055\308C\308B\5834\5408\307E\305F\306FOracle Database 12<em>c</em>\30A2\30A4\30C7\30F3\30C6\30A3\30C6\30A3\5217\306B\57FA\3065\304F\5834\5408\3001\30EC\30B3\30FC\30C9\3092\4F5C\6210\9806\306B\4E26\3079\308B\306B\306F\3001<code>CREATED</code>\307E\305F\306F<code>ID</code>\306A\3069\306E\5217\3092\4F7F\7528\3067\304D\307E\3059\3002\305F\3060\3057\3001<code>JOB</code>\3068<code>DEPTNO</code>\306A\3069\306E\4EFB\610F\306E2\3064\306E\5217\3067\30EC\30B3\30FC\30C9\3092')
||unistr('\4E26\3079\308B\67D4\8EDF\6027\306F\3042\308A\307E\3059\3002</p>'),
unistr('<p><em>\30CE\30FC\30C8: \30CA\30D3\30B2\30FC\30B7\30E7\30F3\306E\9806\5E8F\5217\306F\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\30CA\30D3\30B2\30FC\30B7\30E7\30F3\3057\3066\3053\306E\30D5\30A9\30FC\30E0\306B\30A2\30AF\30BB\30B9\3059\308B\5834\5408\306E\30EC\30DD\30FC\30C8\306E\9806\5E8F\4ED8\3051\306B\4F7F\7528\3055\308C\308B\30C7\30D5\30A9\30EB\30C8\5217\3068\4E00\81F4\3057\307E\3059\3002\3042\308B\3044\306F\3001\30DC\30BF\30F3\30FB\30E9\30D9\30EB\307E\305F\306F\30D8\30EB\30D7\30FB\30C6\30AD\30B9\30C8\3092\4F7F\7528\3059\308B\306A\3069\3057\3066\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\524D\304A\3088\3073\6B21\306E\884C\306E\6C7A\5B9A\65B9\6CD5\304C\308F\308B\3088\3046\306B\3059\308B\5FC5\8981\304C\3042\308A\307E\3059</em></p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362068209426508489.442)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\30BB\30AB\30F3\30C0\30EA\30FB\30CA\30D3\30B2\30FC\30B7\30E7\30F3\9806\5E8F\5217')
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(362034618176024149.442)
,p_help_text=>unistr('2\3064\76EE\306E\30CA\30D3\30B2\30FC\30B7\30E7\30F3\306E\9806\5E8F\5024\3092\542B\3080\5217\3092\9078\629E\3057\307E\3059\3002\3053\306E\5C5E\6027\306B\306F\3001\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30AD\30FC\304C2\3064\306E\5217\3067\69CB\6210\3055\308C\308B\5834\5408\306B\306E\307F\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362068730117514082.442)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\6B21\306E\4E3B\30AD\30FC\30FB\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('<em>\6B21</em>\306E\30EC\30B3\30FC\30C9\306E\4E3B\30AD\30FC\5217\5024\3092\4FDD\6301\3059\308B\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362069024510516623.442)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('\524D\306E\4E3B\30AD\30FC\30FB\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('<em>\524D</em>\306E\30EC\30B3\30FC\30C9\306E\4E3B\30AD\30FC\5217\5024\3092\4FDD\6301\3059\308B\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362069318687519376.442)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>unistr('\6B21\306E2\6B21\30AD\30FC\30FB\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(362036002636046567.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('<eme>\6B21</em>\306E\30EC\30B3\30FC\30C9\306E2\3064\76EE\306E\4E3B\30AD\30FC\5217\5024\3092\4FDD\6301\3059\308B\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362069614158521442.442)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>unistr('\524D\306E2\6B21\30AD\30FC\30FB\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(362036002636046567.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('<em>\524D</em>\306E\30EC\30B3\30FC\30C9\306E2\3064\76EE\306E\4E3B\30AD\30FC\5217\5024\3092\4FDD\6301\3059\308B\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362070100572527702.442)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_prompt=>unistr('\73FE\5728\306E\884C\6570\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5408\8A08\30EC\30B3\30FC\30C9\6570\306E\5024\3092\4FDD\6301\3059\308B\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002</p>'),
unistr('<p>\7D50\679C\30BB\30C3\30C8\304C10,000\884C\3092\8D85\3048\308B\5834\5408\3001\3053\306E\30A2\30A4\30C6\30E0\3092\5B9A\7FA9\3059\308B\3068\3001\30D1\30D5\30A9\30FC\30DE\30F3\30B9\304C\4F4E\4E0B\3059\308B\3053\3068\304C\3042\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362070418675534553.442)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>unistr('\5B9F\884C\6642\306EWHERE\53E5')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'deptno = :P1_DEPTNO',
'</pre>'))
,p_help_text=>unistr('\554F\5408\305B\306B\3088\3063\3066\8FD4\3055\308C\308B\30EC\30B3\30FC\30C9\3092\5236\9650\3059\308BSQL\6587\3092\5165\529B\3057\307E\3059\3002')
);
end;
/
prompt --application/shared_components/plugins/process_type/web_service_legacy
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(362310022409142749.442)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'WEB_SERVICE_LEGACY'
,p_display_name=>unistr('\30EC\30AC\30B7\30FCWeb\30B5\30FC\30D3\30B9')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','WEB_SERVICE_LEGACY'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('\6307\5B9A\3055\308C\305FWeb\30B5\30FC\30D3\30B9\3092\6D88\8CBB\3059\308B\30D7\30ED\30BB\30B9\3002\3053\306E\30D7\30ED\30BB\30B9\3092<strong>Web\30B5\30FC\30D3\30B9</strong>\306B\66F4\65B0\3059\308B\3053\3068\3092\304A\85A6\3081\3057\307E\3059\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362310307960149400.442)
,p_plugin_id=>wwv_flow_api.id(362310022409142749.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Web\30B5\30FC\30D3\30B9\53C2\7167')
,p_attribute_type=>'NUMBER'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Web\30B5\30FC\30D3\30B9\53C2\7167\756A\53F7\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(704862682583352671.442)
,p_plugin_id=>wwv_flow_api.id(362310022409142749.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\7D50\679C\306E\683C\7D0D\5834\6240')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(704862979987353733.442)
,p_plugin_attribute_id=>wwv_flow_api.id(704862682583352671.442)
,p_display_sequence=>10
,p_display_value=>unistr('\30A2\30A4\30C6\30E0')
,p_return_value=>'ITEMS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(704863378280354870.442)
,p_plugin_attribute_id=>wwv_flow_api.id(704862682583352671.442)
,p_display_sequence=>20
,p_display_value=>unistr('\30B3\30EC\30AF\30B7\30E7\30F3')
,p_return_value=>'COLLECTION'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(704864081757360262.442)
,p_plugin_id=>wwv_flow_api.id(362310022409142749.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\30B3\30EC\30AF\30B7\30E7\30F3\540D')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(704862682583352671.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'COLLECTION'
,p_text_case=>'UPPER'
);
end;
/
prompt --application/shared_components/plugins/item_type/textarea
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(376364131288521442.442)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'TEXTAREA'
,p_display_name=>unistr('\30C6\30AD\30B9\30C8\9818\57DF')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','TEXTAREA'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:ELEMENT:WIDTH:HEIGHT:PLACEHOLDER:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\8907\6570\884C\306E\30C6\30AD\30B9\30C8\9818\57DF\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(376904739508510313.442)
,p_plugin_id=>wwv_flow_api.id(376364131288521442.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\30B5\30A4\30BA\5909\66F4\53EF\80FD')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\30DE\30A6\30B9\3092\4F7F\7528\3057\305F\30C6\30AD\30B9\30C8\9818\57DF\306E\30B5\30A4\30BA\5909\66F4\304C\6709\52B9\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(376905227172516182.442)
,p_plugin_id=>wwv_flow_api.id(376364131288521442.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\9AD8\3055\81EA\52D5\8ABF\6574\6A5F\80FD')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\8868\793A\3055\308C\308B\30C6\30AD\30B9\30C8\306E\91CF\306B\57FA\3065\3044\3066\30C6\30AD\30B9\30C8\9818\57DF\306E\9AD8\3055\3092\5909\3048\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002\3053\306E\30AA\30D7\30B7\30E7\30F3\306F\3001\30C7\30FC\30BF\306E\91CF\306B\5FDC\3058\3066\30C6\30AD\30B9\30C8\9818\57DF\3092\30B9\30B1\30FC\30EA\30F3\30B0\3059\308B\5834\5408\306B\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(376905734098518181.442)
,p_plugin_id=>wwv_flow_api.id(376364131288521442.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\6587\5B57\30AB\30A6\30F3\30C8\6A5F\80FD')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\30C6\30AD\30B9\30C8\9818\57DF\306E\4E0B\306B\30AB\30A6\30F3\30BF\3092\8868\793A\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002\30AB\30A6\30F3\30BF\306B\306F\3001<code>123 / 4000</code>\306A\3069\306E\3088\3046\306B\3001\30D5\30A3\30FC\30EB\30C9\306B\5165\529B\3055\308C\305F\6587\5B57\6570\3068\5408\8A08\8A31\5BB9\6587\5B57\6570\304C\8868\793A\3055\308C\307E\3059\3002\3053\308C\304C\30AA\30F3\306E\5834\5408\3001\6700\5927\9577\5C5E\6027\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362202612251785897.442)
,p_plugin_id=>wwv_flow_api.id(376364131288521442.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\7A7A\767D\306E\5207\6368\3066')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_default_value=>'BOTH'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\30DA\30FC\30B8\306E\9001\4FE1\5F8C\306E\30A2\30A4\30C6\30E0\5024\306E\5207\6368\3066\65B9\6CD5\3092\9078\629E\3057\307E\3059\3002\3053\306E\8A2D\5B9A\306B\3088\3063\3066\3001\5165\529B\3055\308C\305F\30C6\30AD\30B9\30C8\304B\3089\3001\7A7A\767D\3001\30BF\30D6\304A\3088\3073\6539\884C\304C\5207\308A\6368\3066\3089\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362202910095786913.442)
,p_plugin_attribute_id=>wwv_flow_api.id(362202612251785897.442)
,p_display_sequence=>10
,p_display_value=>unistr('\5148\982D')
,p_return_value=>'LEADING'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362203307938787882.442)
,p_plugin_attribute_id=>wwv_flow_api.id(362202612251785897.442)
,p_display_sequence=>20
,p_display_value=>unistr('\672B\5C3E')
,p_return_value=>'TRAILING'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362203705781788933.442)
,p_plugin_attribute_id=>wwv_flow_api.id(362202612251785897.442)
,p_display_sequence=>30
,p_display_value=>unistr('\5148\982D\304A\3088\3073\672B\5C3E')
,p_return_value=>'BOTH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362204104056789676.442)
,p_plugin_attribute_id=>wwv_flow_api.id(362202612251785897.442)
,p_display_sequence=>40
,p_display_value=>unistr('\306A\3057')
,p_return_value=>'NONE'
);
end;
/
prompt --application/shared_components/plugins/region_type/sql_report
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(380028817628072908.442)
,p_plugin_type=>'REGION TYPE'
,p_name=>'SQL_REPORT'
,p_display_name=>unistr('\30AF\30E9\30B7\30C3\30AF\30FB\30EC\30DD\30FC\30C8')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','SQL_REPORT'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:FETCHED_ROWS:NO_DATA_FOUND_MESSAGE:COLUMN_HEADING'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('SQL\554F\5408\305B\306B\57FA\3065\3044\305F\3001\7C21\7565\5316\3055\308C\305F\30EC\30DD\30FC\30C8\3002\30AF\30E9\30B7\30C3\30AF\30FB\30EC\30DD\30FC\30C8\306F\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\3068\4F3C\3066\3044\307E\3059\304C\3001\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\3067\4F7F\7528\3067\304D\308B\69D8\3005\306A\30A8\30F3\30C9\30E6\30FC\30B6\30FC\30FB\30AB\30B9\30BF\30DE\30A4\30BA\30FB\30AA\30D7\30B7\30E7\30F3\304C\542B\307E\308C\3066\3044\307E\305B\3093\3002')
,p_version_identifier=>'1.0'
,p_plugin_comment=>'"Number of Fetched Rows" and "No Data Found Message" have to be checked because are needed to keep REGION PLUGIN ATTRIBUTES component type in sync.'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(234584057047894023.442)
,p_plugin_id=>wwv_flow_api.id(380028817628072908.442)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select empno,',
'       ename,',
'       job,',
'       sal',
'  from emp',
' where deptno = :P1_DEPTNO',
'</pre>'))
);
end;
/
prompt --application/shared_components/plugins/region_type/tabform
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(380029119558081299.442)
,p_plugin_type=>'REGION TYPE'
,p_name=>'TABFORM'
,p_display_name=>unistr('\8868\5F62\5F0F\30D5\30A9\30FC\30E0')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','TABFORM'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_SQL:AJAX_ITEMS_TO_SUBMIT:FETCHED_ROWS:NO_DATA_FOUND_MESSAGE:COLUMN_HEADING'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('\8907\6570\306E\30C7\30FC\30BF\306E\884C\304C\30B0\30EA\30C3\30C9\30FB\30EC\30A4\30A2\30A6\30C8\3067\8868\793A\3055\308C\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\30B0\30EA\30C3\30C9\8981\7D20\5185\3067\76F4\63A5\5024\3092\66F4\65B0\3067\304D\307E\3059\3002')
,p_version_identifier=>'1.0'
,p_plugin_comment=>'"Number of Fetched Rows" and "No Data Found Message" have to be checked because are needed to keep REGION PLUGIN ATTRIBUTES component type in sync.'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845153406632834485.442)
,p_plugin_id=>wwv_flow_api.id(380029119558081299.442)
,p_name=>'SOURCE_SQL'
,p_sql_min_column_count=>1
);
end;
/
prompt --application/shared_components/plugins/region_type/ir
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(380454112071587884.442)
,p_plugin_type=>'REGION TYPE'
,p_name=>'IR'
,p_display_name=>unistr('\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','IR'),'')
,p_javascript_file_urls=>'[require jet]#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.jetChart#MIN#.js'
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>SQL\554F\5408\305B\306B\57FA\3065\304D\3001\5B9F\884C\6642\306B\30EC\30DD\30FC\30C8\306E\30EC\30A4\30A2\30A6\30C8\3092\30AB\30B9\30BF\30DE\30A4\30BA\3059\308B\305F\3081\306E\69D8\3005\306A\6A5F\80FD\3092\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\63D0\4F9B\3059\308B\5305\62EC\7684\306A\30AA\30F3\30E9\30A4\30F3\30FB\30EC\30DD\30FC\30C8\3002\69D8\3005\306A\30EC\30DD\30FC\30C8\30FB\30AB\30B9\30BF\30DE\30A4\30BA\30FB\30AA\30D7\30B7\30E7\30F3\3092\6709\52B9\307E\305F\306F\7121\52B9\306B\3059\308B\3053\3068\306B\3088\3063\3066\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\6A5F\80FD\3092\5236\5FA1\3067\304D\307E\3059\3002</p>'),
unistr('<p>\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\56FA\6709\306E\8981\4EF6\3092\6E80\305F\3059\305F\3081\306B\6761\4EF6\304C\7570\306A\308B\540C\69D8\306E\30EC\30DD\30FC\30C8\3092\8907\6570\958B\767A\3059\308B\304B\308F\308A\306B\30011\3064\306E\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\3092\5B9A\7FA9\3057\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\305D\308C\305E\308C\56FA\6709\306E\30EC\30DD\30FC\30C8\8981\4EF6\3092\6E80\305F\3059\305F\3081\306B\8868\793A\3055\308C\3066\3044\308B\30C7\30FC\30BF\3092\64CD\4F5C\3067\304D\308B\3088\3046\306B\3057\307E\3059\3002</p>')))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1831648887398980457.442)
,p_plugin_id=>wwv_flow_api.id(380454112071587884.442)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\300C\30A2\30AF\30B7\30E7\30F3\300D\30E1\30CB\30E5\30FC\69CB\9020')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'IG'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\300C\30A2\30AF\30B7\30E7\30F3\300D\30E1\30CB\30E5\30FC\69CB\9020\306F\5BFE\8A71\30B0\30EA\30C3\30C9\30FB\30B3\30F3\30DD\30FC\30CD\30F3\30C8\3068\4E00\8CAB\6027\3092\4FDD\3064\304B\3069\3046\304B\3001\307E\305F\306F\30EC\30AC\30B7\30FC\69CB\9020\3092\4F7F\7528\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1831649884271983182.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1831648887398980457.442)
,p_display_sequence=>10
,p_display_value=>unistr('\30EC\30AC\30B7\30FC')
,p_return_value=>'LEGACY'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1831650362309985149.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1831648887398980457.442)
,p_display_sequence=>20
,p_display_value=>unistr('\5BFE\8A71\30B0\30EA\30C3\30C9')
,p_return_value=>'IG'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(234862891586787752.442)
,p_plugin_id=>wwv_flow_api.id(380454112071587884.442)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select empno,',
'       ename,',
'       job,',
'       sal',
'  from emp',
' where deptno = :P1_DEPTNO',
'</pre>'))
);
end;
/
prompt --application/shared_components/plugins/region_type/static
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(384582062506273077.442)
,p_plugin_type=>'REGION TYPE'
,p_name=>'STATIC'
,p_display_name=>unistr('\9759\7684\30B3\30F3\30C6\30F3\30C4')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','STATIC'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_HTML'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306E\30C6\30AD\30B9\30C8\30FB\30B3\30F3\30C6\30F3\30C4\307E\305F\306F\30EA\30FC\30B8\30E7\30F3\30FB\30B3\30F3\30C6\30CA\3092\8868\793A\3057\307E\3059\3002HTML\30DE\30FC\30AF\30A2\30C3\30D7\3092\51FA\529B\3057\3001\30B3\30F3\30C6\30F3\30C4\304C\30A8\30B9\30B1\30FC\30D7\3055\308C\306A\3044\3088\3046\306B\3059\308B\306B\306F\3001<em>\300C\51FA\529B\5F62\5F0F\300D</em>\3092<strong>\300CHTML\300D</strong>\306B\8A2D\5B9A\3057\307E\3059\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(384582415870309214.442)
,p_plugin_id=>wwv_flow_api.id(384582062506273077.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>30
,p_prompt=>unistr('\30B7\30E7\30FC\30C8\30AB\30C3\30C8\3092\958B\304F')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(481599132721933414.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'HTML'
,p_help_text=>unistr('&PRODUCT_NAME.\304CHTML\30DC\30C7\30A3\3067\30B7\30E7\30FC\30C8\30AB\30C3\30C8\3092\958B\304F\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(481599132721933414.442)
,p_plugin_id=>wwv_flow_api.id(384582062506273077.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>unistr('\51FA\529B\5F62\5F0F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'HTML'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\30C6\30AD\30B9\30C8\30FB\30B3\30F3\30C6\30F3\30C4\306E\51FA\529B\65B9\6CD5\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(481599442113934184.442)
,p_plugin_attribute_id=>wwv_flow_api.id(481599132721933414.442)
,p_display_sequence=>10
,p_display_value=>unistr('\30C6\30AD\30B9\30C8(\7279\6B8A\6587\5B57\3092\30A8\30B9\30B1\30FC\30D7)')
,p_return_value=>'TEXT'
,p_help_text=>unistr('&PRODUCT_NAME.\3067\306F\3001\30EA\30FC\30B8\30E7\30F3\30FB\30BD\30FC\30B9\3092\751F\6210\3059\308B\969B\3001<code>"<", ">", "&"</code>\306A\3069\306EHTML\7279\6B8A\6587\5B57\306F\30A8\30B9\30B1\30FC\30D7\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(481600445121939808.442)
,p_plugin_attribute_id=>wwv_flow_api.id(481599132721933414.442)
,p_display_sequence=>20
,p_display_value=>'HTML'
,p_return_value=>'HTML'
,p_help_text=>unistr('&PRODUCT_NAME.\3067\306F\3001\30EA\30FC\30B8\30E7\30F3\30FB\30BD\30FC\30B9\3092\751F\6210\3059\308B\969B\3001HTML\30DE\30FC\30AF\30A2\30C3\30D7\3092\542B\3081\307E\3059\3002\3053\308C\306B\3088\3063\3066\3001\30EA\30FC\30B8\30E7\30F3\304C\30AF\30ED\30B9\30B5\30A4\30C8\30FB\30B9\30AF\30EA\30D7\30C6\30A3\30F3\30B0\306E\653B\6483\3092\53D7\3051\3084\3059\304F\306A\308B\53EF\80FD\6027\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(481600813887948606.442)
,p_plugin_id=>wwv_flow_api.id(384582062506273077.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>20
,p_prompt=>unistr('\6539\884C\306E\8868\793A')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(481599132721933414.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TEXT'
,p_help_text=>unistr('\30EA\30FC\30B8\30E7\30F3\30FB\30BD\30FC\30B9\306E\6539\884C\306B\3088\3063\3066\30EA\30FC\30B8\30E7\30F3\51FA\529B\3067\6539\884C\3055\308C\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(105618485369724390.442)
,p_plugin_id=>wwv_flow_api.id(384582062506273077.442)
,p_name=>'SOURCE_HTML'
,p_is_required=>false
);
end;
/
prompt --application/shared_components/plugins/region_type/plsql
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(385049040242438541.442)
,p_plugin_type=>'REGION TYPE'
,p_name=>'PLSQL'
,p_display_name=>unistr('PL/SQL\52D5\7684\30B3\30F3\30C6\30F3\30C4')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','PLSQL'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_PLSQL'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('PL/SQL\30B3\30FC\30C9\304B\3089HTML\51FA\529B\3092\8868\793A\3057\307E\3059\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845153863368834496.442)
,p_plugin_id=>wwv_flow_api.id(385049040242438541.442)
,p_name=>'SOURCE_PLSQL'
);
end;
/
prompt --application/shared_components/plugins/region_type/svg_chart
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(385104627384108788.442)
,p_plugin_type=>'REGION TYPE'
,p_name=>'SVG_CHART'
,p_display_name=>unistr('SVG\30C1\30E3\30FC\30C8')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','SVG_CHART'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_HTML'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('SVG\30C1\30E3\30FC\30C8\306B\30C7\30FC\30BF\3092\8868\793A\3057\307E\3059\3002\3053\306E\30EA\30FC\30B8\30E7\30F3\30FB\30BF\30A4\30D7\306F\975E\63A8\5968\3067\3059\3002\65B0\3057\3044\30C1\30E3\30FC\30C8\30FB\30EA\30FC\30B8\30E7\30F3\306B\306F<em>\300C\30C1\30E3\30FC\30C8\300D</em>\30EA\30FC\30B8\30E7\30F3\3092\4F7F\7528\3057\3066\304F\3060\3055\3044\3002<em>\300C\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30A2\30C3\30D7\30B0\30EC\30FC\30C9\300D</em>\3092\4F7F\7528\3057\3066\3001\3053\308C\3089\306E\30EA\30FC\30B8\30E7\30F3\3092\540C\7B49\306E\30C1\30E3\30FC\30C8\30FB\30EA\30FC\30B8\30E7\30F3\306B\66F4\65B0\3059\308B\3053\3068\3092\304A\85A6\3081\3057\307E\3059\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845153953839834498.442)
,p_plugin_id=>wwv_flow_api.id(385104627384108788.442)
,p_name=>'SOURCE_HTML'
,p_is_required=>false
);
end;
/
prompt --application/shared_components/plugins/region_type/simple_chart
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(385106170962146118.442)
,p_plugin_type=>'REGION TYPE'
,p_name=>'SIMPLE_CHART'
,p_display_name=>unistr('\5358\7D14\306A\30C1\30E3\30FC\30C8')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','SIMPLE_CHART'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('HTML\30C1\30E3\30FC\30C8\306B\30C7\30FC\30BF\3092\8868\793A\3057\307E\3059\3002\3053\306E\30EA\30FC\30B8\30E7\30F3\30FB\30BF\30A4\30D7\306F\975E\63A8\5968\3067\3059\3002\65B0\3057\3044\30C1\30E3\30FC\30C8\30FB\30EA\30FC\30B8\30E7\30F3\306B\306F<em>\300C\30C1\30E3\30FC\30C8\300D</em>\30EA\30FC\30B8\30E7\30F3\3092\4F7F\7528\3057\3066\304F\3060\3055\3044\3002<em>\300C\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30A2\30C3\30D7\30B0\30EC\30FC\30C9\300D</em>\3092\4F7F\7528\3057\3066\3001\3053\308C\3089\306E\30EA\30FC\30B8\30E7\30F3\3092\540C\7B49\306E\30C1\30E3\30FC\30C8\30FB\30EA\30FC\30B8\30E7\30F3\306B\66F4\65B0\3059\308B\3053\3068\3092\304A\85A6\3081\3057\307E\3059\3002')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/region_type/jstree
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(385504073407123938.442)
,p_plugin_type=>'REGION TYPE'
,p_name=>'JSTREE'
,p_display_name=>unistr('\30C4\30EA\30FC')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','JSTREE'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:ESCAPE_OUTPUT:INIT_JAVASCRIPT_CODE:LAZY_LOADING'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\30EC\30B3\30FC\30C9\9593\306E\89AA\5B50\95A2\4FC2\306B\57FA\3065\3044\3066\3001\968E\5C64\69CB\9020\3067\30C7\30FC\30BF\3092\8868\793A\3057\307E\3059\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388222674242760077.442)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>450
,p_prompt=>unistr('\6B21\306E\3082\306E\3067\30CE\30FC\30C9\30FB\30EA\30F3\30AF\3092\30A2\30AF\30C6\30A3\30D6\5316')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'S'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>\30C4\30EA\30FC\306E\30CE\30FC\30C9\30FB\30EA\30F3\30AF\3092\30A2\30AF\30C6\30A3\30D6\306B\3059\308B\305F\3081\306B\5FC5\8981\306A\30A2\30AF\30B7\30E7\30F3\3092\9078\629E\3057\307E\3059\3002\30C4\30EA\30FC\306F\3001\4E3B\306B\3001\9078\629E/\8868\793A\307E\305F\306F\30CA\30D3\30B2\30FC\30B7\30E7\30F3\306B\4F7F\7528\3067\304D\307E\3059\3002\9078\629E\3068\30CA\30D3\30B2\30FC\30B7\30E7\30F3\306E\4E21\65B9\306B\4F7F\7528\3059\308B\5834\5408\3001\30C0\30D6\30EB\30FB\30AF\30EA\30C3\30AF\306B\8A2D\5B9A\3059\308B\3053\3068\3092\304A\85A6\3081\3057\307E\3059\3002\30B7\30F3\30B0\30EB\30FB\30AF\30EA\30C3\30AF\306F\30CE\30FC\30C9\306E\9078\629E\306B\8A2D\5B9A\3067\304D\308B\3088\3046\306B\3059\308B\305F\3081\3067\3059\3002</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(388222945238760981.442)
,p_plugin_attribute_id=>wwv_flow_api.id(388222674242760077.442)
,p_display_sequence=>10
,p_display_value=>unistr('\30B7\30F3\30B0\30EB\30AF\30EA\30C3\30AF')
,p_return_value=>'S'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(388223328719761701.442)
,p_plugin_attribute_id=>wwv_flow_api.id(388222674242760077.442)
,p_display_sequence=>20
,p_display_value=>unistr('\30C0\30D6\30EB\30AF\30EA\30C3\30AF')
,p_return_value=>'D'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388223746905766372.442)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>600
,p_prompt=>unistr('\9078\629E\3057\305F\30CE\30FC\30C9\306E\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715830565095726781.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\629E\3057\305F\30CE\30FC\30C9\5024\3092\4FDD\6301\3059\308B\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\9078\629E\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002</p>'),
unistr('<p>\3053\306E\30A2\30A4\30C6\30E0\3092\4F7F\7528\3057\3066\3001\6700\5F8C\306B\9078\629E\3057\305F\30CE\30FC\30C9\306E\5024\3092\4FDD\6301\3059\308B\3053\3068\3067\3001\30C4\30EA\30FC\306E\72B6\614B\3092\4FDD\5B58\3067\304D\307E\3059\3002\9078\629E\3057\305F\30CE\30FC\30C9\306E\5024\306F\3001\30CE\30FC\30C9\30FB\30EA\30F3\30AF\5C5E\6027\307E\305F\306F\30DA\30FC\30B8\30FB\30D7\30ED\30BB\30B9\3092\4F7F\7528\3057\3066\3001\9078\629E\3057\305F\30A2\30A4\30C6\30E0\306B\4FDD\5B58\3067\304D\307E\3059\3002\30DA\30FC\30B8\3092\30EA\30ED\30FC\30C9\3059\308B\3068\3001\305D\306E\30C4\30EA\30FC\306F\9078\629E\3057\305F\30CE\30FC\30C9\5024\306B\5BFE\3057\3066\958B\304B\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388224056018770786.442)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>400
,p_prompt=>unistr('\30C4\30FC\30EB\30C1\30C3\30D7')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'N'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\30C4\30FC\30EB\30C1\30C3\30D7\3092\8868\793A\3059\308B\304B\3069\3046\304B\3068\30C4\30FC\30EB\30C1\30C3\30D7\306E\30BD\30FC\30B9\3092\9078\629E\3057\307E\3059\3002\30C4\30FC\30EB\30C1\30C3\30D7\304C\5B9A\7FA9\3055\308C\3066\3044\308B\5834\5408\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\30C4\30EA\30FC\30FB\30CE\30FC\30C9\30FB\30E9\30D9\30EB\3092\30D5\30A9\30FC\30AB\30B9\3059\308B\304B\30C4\30EA\30FC\30FB\30CE\30FC\30C9\30FB\30E9\30D9\30EB\306B\30AB\30FC\30BD\30EB\3092\5408\305B\308B\3068\3001\30C4\30FC\30EB\30C1\30C3\30D7\304C\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(388224310716771380.442)
,p_plugin_attribute_id=>wwv_flow_api.id(388224056018770786.442)
,p_display_sequence=>10
,p_display_value=>unistr('\306A\3057')
,p_return_value=>'N'
,p_help_text=>unistr('\30C4\30FC\30EB\30C1\30C3\30D7\306F\8868\793A\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(388224757018772639.442)
,p_plugin_attribute_id=>wwv_flow_api.id(388224056018770786.442)
,p_display_sequence=>20
,p_display_value=>unistr('\30EC\30AC\30B7\30FC\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
,p_return_value=>'STATIC'
,p_is_deprecated=>true
,p_help_text=>unistr('\6B21\306E\30C7\30FC\30BF\30FB\30BD\30FC\30B9\5217\306E\7F6E\63DB\3067\9759\7684\30C4\30FC\30EB\30C1\30C3\30D7\5024\3092\4F7F\7528\3057\307E\3059: #VALUE#\3001#TITLE#\3001#LINK#\304A\3088\3073#TOOLTIP#')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715829871157706251.442)
,p_plugin_attribute_id=>wwv_flow_api.id(388224056018770786.442)
,p_display_sequence=>30
,p_display_value=>unistr('HTML\5F0F')
,p_return_value=>'TEMPLATE'
,p_help_text=>unistr('\30C4\30FC\30EB\30C1\30C3\30D7\3068\3057\3066\4F7F\7528\3059\308BHTML\5F0F\3092\6307\5B9A\3057\307E\3059\3002\7F6E\63DB\304C\5B9F\884C\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(388225194623774797.442)
,p_plugin_attribute_id=>wwv_flow_api.id(388224056018770786.442)
,p_display_sequence=>40
,p_display_value=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\5217')
,p_return_value=>'DB'
,p_help_text=>unistr('<strong>\300C\30C4\30FC\30EB\30C1\30C3\30D7\5217\300D</strong>\306E\5024\3092\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388225546559783958.442)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>410
,p_prompt=>unistr('\30C4\30FC\30EB\30C1\30C3\30D7\5024')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(388224056018770786.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'STATIC,TEMPLATE'
,p_help_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\30C4\30EA\30FC\8981\7D20\306B\30AB\30FC\30BD\30EB\3092\5408\305B\308B\3068\8868\793A\3055\308C\308B\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388410177919650647.442)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>900
,p_prompt=>unistr('\9759\7684\30C4\30EA\30FCID')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_deprecated_values=>'$NOT_NULL$'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30C4\30EA\30FC\306E\30AA\30D7\30B7\30E7\30F3\306E\4E00\610F\306E\8B58\5225\5B50\3002</p>'),
unistr('<p>\30EA\30FC\30B8\30E7\30F3\306B\9759\7684ID\3092\6307\5B9A\3057\3001apex.region("<i>static-id</i>").widget() API\3092\4F7F\7528\3057\3066\3001\30C4\30EA\30FC\8981\7D20\306B\30A2\30AF\30BB\30B9\3059\308B\3053\3068\3092\304A\85A6\3081\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1397688173262880316.442)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>520
,p_prompt=>unistr('\30A2\30A4\30B3\30F3\30FB\30BF\30A4\30D7CSS\30AF\30E9\30B9')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'a-Icon'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_examples=>'fa'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3059\3079\3066\306E\30CE\30FC\30C9\306B\4F7F\7528\3059\308B\30A2\30A4\30B3\30F3\306E\30BF\30A4\30D7\3092\6307\5B9A\3059\308B\305F\3081\306B\4F7F\7528\3055\308C\308BCSS\30AF\30E9\30B9\3002\3053\306E\30AF\30E9\30B9\306FCSS\30EB\30FC\30EB\3067\4F7F\7528\3055\308C\3001\8A72\5F53\3059\308B\30BF\30A4\30D7\306E\3059\3079\3066\306E\30A2\30A4\30B3\30F3\306E\30D7\30ED\30D1\30C6\30A3\3092\6307\5B9A\3057\307E\3059\3002\30EA\30FC\30B8\30E7\30F3\30FB\30BD\30FC\30B9\306E\30A2\30A4\30B3\30F3\5217\306E\5024\3068\3068\3082\306B\30A2\30A4\30B3\30F3\30FB\30BF\30A4\30D7\304C\5404\30CE\30FC\30C9\306B\4F7F\7528\3059\308B\30A2\30A4\30B3\30F3CSS\30AF\30E9\30B9\3092\6C7A\5B9A\3057\307E\3059\3002</p>'),
unistr('<p>\4E00\822C\7684\306A\5024\306F\6B21\306E\3068\304A\308A\3067\3059\3002</p>'),
'<ul>',
unistr('<li><strong><code>a-Icon</code></strong> \3053\308C\306B\3088\308A\3001\5C11\6570\306E\7D44\8FBC\307FAPEX\30A2\30A4\30B3\30F3(<code>icon-circle</code>\3084<code>icon-tree-folder</code>\306A\3069)\3092\4F7F\7528\3067\304D\307E\3059\3002</li>'),
unistr('<li><strong><code>fa</code></strong> \3053\308C\306B\3088\308A\3001\30D5\30A9\30F3\30C8APEX\307E\305F\306FFont Awesome\30A2\30A4\30B3\30F3\3092\4F7F\7528\3067\304D\307E\3059\3002\30E6\30CB\30D0\30FC\30B5\30EB\30FB\30C6\30FC\30DE\306F\3053\308C\3089\306E\30A2\30A4\30B3\30F3\30FB\30E9\30A4\30D6\30E9\30EA\306E1\3064\3092\4F7F\7528\53EF\80FD\306B\3057\307E\3059\3002</li>'),
'</ul>',
unistr('<p>\5024\304C\6307\5B9A\3055\308C\306A\3044\5834\5408\3001\30A2\30A4\30B3\30F3\30FB\30BF\30A4\30D7\304C\3042\308A\307E\305B\3093\3002\5FC5\8981\306B\5FDC\3058\3066\3001\30A2\30A4\30B3\30F3\30FB\30BF\30A4\30D7CSS\30AF\30E9\30B9\3092\30A2\30A4\30B3\30F3\5217\306B\542B\3081\308B\3053\3068\304C\3067\304D\307E\3059\3002\305F\3068\3048\3070\3001\30A2\30A4\30B3\30F3\5217\306E\5024\3092"fa fa-user"\306B\3067\304D\307E\3059\3002'),
unistr('\30A2\30A4\30B3\30F3\304C\306A\3044\30C4\30EA\30FC\306E\5834\5408\3001\300C\30A2\30A4\30B3\30F3\30FB\30BF\30A4\30D7\300D\304A\3088\3073\300C\30C7\30D5\30A9\30EB\30C8\30FB\30A2\30A4\30B3\30F3\300D\5C5E\6027\3092\7A7A\306B\8A2D\5B9A\3057\3001\300CSQL\554F\5408\305B\300D\30BD\30FC\30B9\3067\30A2\30A4\30B3\30F3\5217\3092null\306B\3057\307E\3059\3002'),
unistr('\30AB\30B9\30BF\30E0\307E\305F\306F\30B5\30FC\30C9\30D1\30FC\30C6\30A3\306E\30C6\30FC\30DE\306F\3001\72EC\81EA\306E\30D5\30A9\30F3\30C8\307E\305F\306FCSS\30B9\30D7\30E9\30A4\30C8\30FB\30A2\30A4\30B3\30F3\30FB\30E9\30A4\30D6\30E9\30EA\3092\6307\5B9A\3057\3001\3053\3053\3067\6307\5B9A\53EF\80FD\306A\5225\306E\30A2\30A4\30B3\30F3\30FB\30BF\30A4\30D7/\63A5\982D\8F9E\30AF\30E9\30B9\3092\4F7F\7528\3067\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388198764505202174.442)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>510
,p_prompt=>unistr('\30C7\30D5\30A9\30EB\30C8\30FB\30A2\30A4\30B3\30F3CSS\30AF\30E9\30B9')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'icon-tree-folder'
,p_is_translatable=>false
,p_examples=>unistr('<p>\30D5\30A9\30F3\30C8APEX\306E\30A2\30A4\30B3\30F3\30FB\30BF\30A4\30D7\304C<code>fa</code>\306E\5834\5408\3001<code>fa-user-circle-o</code>\3001<code>fa-file-o</code>\3001<code>fa-arrow-circle-right</code>\306A\3069\306E\5024\3092\4F7F\7528\3067\304D\307E\3059\3002\3059\3079\3066\306E\30A2\30A4\30B3\30F3\306E\30EA\30B9\30C8\306F\3001\30E6\30CB\30D0\30FC\30B5\30EB\30FB\30C6\30FC\30DE\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002</p>')
,p_help_text=>unistr('\300CSQL\554F\5408\305B\300D\30A2\30A4\30B3\30F3\5217\304Cnull\306E\5834\5408\306B\4F7F\7528\3059\308B\30C7\30D5\30A9\30EB\30C8\30FB\30A2\30A4\30B3\30F3\3002\5024\306F\3001\8868\793A\3055\308C\308B\30A2\30A4\30B3\30F3\3092\6307\5B9A\3059\308BCSS\30AF\30E9\30B9\540D\3067\3059\3002\4F7F\7528\53EF\80FD\306A\5024\306F\30A2\30A4\30B3\30F3\30FB\30BF\30A4\30D7\306B\3088\3063\3066\7570\306A\308A\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715809220298508190.442)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>310
,p_prompt=>unistr('\30CE\30FC\30C9\30FB\30E9\30D9\30EB\5217')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('\30CE\30FC\30C9\30FB\30E9\30D9\30EB\306E\5024\3092\542B\3080\30C7\30FC\30BF\30FB\30BD\30FC\30B9\5217\3092\9078\629E\3057\307E\3059\3002\5024\306B\30DE\30FC\30AF\30A2\30C3\30D7\3092\542B\3081\308B\3053\3068\306F\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715811910493561671.442)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>380
,p_prompt=>unistr('\968E\5C64\30EC\30D9\30EB\5217')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_column_data_types=>'NUMBER'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715810380689519088.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LEVEL'
,p_help_text=>unistr('\30CE\30FC\30C9\306E\968E\5C64\30EC\30D9\30EB\306E\5024\3092\542B\3080\30C7\30FC\30BF\30FB\30BD\30FC\30B9\5217\3092\9078\629E\3057\307E\3059\3002<strong>\300C\968E\5C64\300D</strong>\5C5E\6027\3092<strong>\300C\8A08\7B97\3055\308C\306A\3044\300D</strong>\306B\8A2D\5B9A\3057\305F\5834\5408\306B\5FC5\9808\3067\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715813002119570686.442)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>500
,p_prompt=>unistr('\30A2\30A4\30B3\30F3CSS\30AF\30E9\30B9\5217')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'VARCHAR2'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('\30CE\30FC\30C9\306B\9069\7528\3055\308C\308B\30A2\30A4\30B3\30F3CSS\30AF\30E9\30B9\306E\5024\3092\542B\3080\30C7\30FC\30BF\30FB\30BD\30FC\30B9\5217\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715814135069583776.442)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>330
,p_prompt=>unistr('\30CE\30FC\30C9ID\5217')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715810380689519088.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'LEVEL'
,p_help_text=>unistr('\30CE\30FC\30C9\306EID\3092\542B\3080\30C7\30FC\30BF\30FB\30BD\30FC\30B9\5217\3092\9078\629E\3057\307E\3059\3002\3053\308C\306F\3001\968E\5C64\304CApplication Express\306B\3088\3063\3066\8A08\7B97\3055\308C\3066\3044\308B\5834\5408\306B\5FC5\9808\3067\3059\3002\901A\5E38\3001\4E3B\30AD\30FC\5217\304C\3053\3053\3067\9078\629E\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715815231948590626.442)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>340
,p_prompt=>unistr('\89AA\30AD\30FC\5217')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715810380689519088.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'LEVEL'
,p_help_text=>unistr('\30CE\30FC\30C9\306E\89AA\30AD\30FC\306E\5024\3092\542B\3080\30C7\30FC\30BF\30FB\30BD\30FC\30B9\5217\3092\9078\629E\3057\307E\3059\3002Application Express\3067\968E\5C64\304C\8A08\7B97\3055\308C\308B\5834\5408\306B\5FC5\9808\3067\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715816326045601781.442)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>370
,p_prompt=>unistr('\30CE\30FC\30C9\30FB\30B9\30C6\30FC\30BF\30B9\5217')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_column_data_types=>'NUMBER'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715810380689519088.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LEVEL'
,p_help_text=>unistr('\30CE\30FC\30C9\30FB\30B9\30C6\30FC\30BF\30B9\306E\5024\3092\542B\3080\30C7\30FC\30BF\30FB\30BD\30FC\30B9\5217\3092\9078\629E\3057\307E\3059\3002<strong>\300C\968E\5C64\300D</strong>\5C5E\6027\3092<strong>\300C\8A08\7B97\3055\308C\306A\3044\300D</strong>\306B\8A2D\5B9A\3057\305F\5834\5408\306B\5FC5\9808\3067\3059\3002\3053\306E\5217\306B\306F\3001\30EA\30FC\30D5\30FB\30CE\30FC\30C9\306E\5834\5408\306F<strong>0</strong>\3001\5B50\3092\6301\3064\30CE\30FC\30C9\306E\5834\5408\306F<strong>1</strong>\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715817436034604662.442)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>16
,p_display_sequence=>350
,p_prompt=>unistr('\30C4\30EA\30FC\306E\958B\59CB\65B9\6CD5')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NULL'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715810380689519088.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'LEVEL'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\3053\306E\5C5E\6027\306F\3001\30C4\30EA\30FC\306E\30EB\30FC\30C8\306E\8A08\7B97\65B9\6CD5\3092\6C7A\5B9A\3057\307E\3059\3002\3053\3053\3067\5B9A\7FA9\3055\308C\305F\5024\304C<strong>\89AA\30AD\30FC</strong>\5217\306B\542B\307E\308C\3066\3044\308B\30CE\30FC\30C9\306F\3001\30EB\30FC\30C8\30FB\30CE\30FC\30C9\3068\307F\306A\3055\308C\307E\3059\3002\8907\6570\306E\30EB\30FC\30C8\304C\6307\5B9A\53EF\80FD\3067\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715818524967607963.442)
,p_plugin_attribute_id=>wwv_flow_api.id(715817436034604662.442)
,p_display_sequence=>10
,p_display_value=>unistr('\65E2\5B58\306E\30A2\30A4\30C6\30E0\306B\57FA\3065\304F')
,p_return_value=>'ITEM'
,p_help_text=>unistr('\30A2\30A4\30C6\30E0\5024\3092\4F7F\7528\3057\3066\3001\30C4\30EA\30FC\3092\958B\59CB\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715818952174610864.442)
,p_plugin_attribute_id=>wwv_flow_api.id(715817436034604662.442)
,p_display_sequence=>20
,p_display_value=>unistr('SQL\554F\5408\305B\306B\57FA\3065\304F')
,p_return_value=>'SQL'
,p_help_text=>unistr('SQL\554F\5408\305B\306B\3088\3063\3066\8FD4\3055\308C\305F\5024\3092\4F7F\7528\3057\3066\3001\30C4\30EA\30FC\3092\958B\59CB\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715819396180612829.442)
,p_plugin_attribute_id=>wwv_flow_api.id(715817436034604662.442)
,p_display_sequence=>30
,p_display_value=>unistr('\9759\7684\5024\306B\57FA\3065\304F')
,p_return_value=>'STATIC'
,p_help_text=>unistr('\9759\7684\5024\3092\4F7F\7528\3057\3066\3001\30C4\30EA\30FC\3092\958B\59CB\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715819794480614454.442)
,p_plugin_attribute_id=>wwv_flow_api.id(715817436034604662.442)
,p_display_sequence=>40
,p_display_value=>unistr('\5024\306FNULL')
,p_return_value=>'NULL'
,p_help_text=>unistr('SQL NULL\3092\4F7F\7528\3057\3066\3001\30C4\30EA\30FC\3092\958B\59CB\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715821189465630260.442)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>17
,p_display_sequence=>351
,p_prompt=>unistr('\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715817436034604662.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ITEM'
,p_help_text=>unistr('\30C4\30EA\30FC\3092\958B\59CB\3059\308B\5024\3092\542B\3080\30A2\30A4\30C6\30E0\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715822207129637643.442)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>18
,p_display_sequence=>352
,p_prompt=>unistr('SQL\554F\5408\305B')
,p_attribute_type=>'SQL'
,p_is_required=>false
,p_sql_min_column_count=>1
,p_sql_max_column_count=>1
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715817436034604662.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL'
,p_help_text=>unistr('\30C4\30EA\30FC\3092\958B\59CB\3059\308B\5024\3092\6C7A\5B9A\3059\308BSQL\554F\5408\305B\3092\6307\5B9A\3057\307E\3059\3002SQL\554F\5408\305B\306F\5E38\306B<em>\30ED\30FC\30AB\30EB\30FB\30C7\30FC\30BF\30D9\30FC\30B9</em>\3067\5B9F\884C\3055\308C\30011\3064\306E\5217\306E\307F\3092\8FD4\3059\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715823388473642206.442)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>19
,p_display_sequence=>353
,p_prompt=>unistr('\9759\7684\5024')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715817436034604662.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC'
,p_help_text=>unistr('\30C4\30EA\30FC\3092\958B\59CB\3059\308B\9759\7684\5024\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715830565095726781.442)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>20
,p_display_sequence=>315
,p_prompt=>unistr('\30CE\30FC\30C9\5024\5217')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:ROWID'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('\30CE\30FC\30C9\306E\300C\5024\300D\3092\542B\3080\30C7\30FC\30BF\30FB\30BD\30FC\30B9\5217\3092\9078\629E\3057\307E\3059\3002\3053\306E\5024\306F\8868\793A\3055\308C\307E\305B\3093\304C\3001JavaScript\3092\4F7F\7528\3057\3066\30A2\30AF\30BB\30B9\3067\304D\308B\30C4\30EA\30FC\30FB\30A2\30C0\30D7\30BF\30FB\30CE\30FC\30C9ID\30D7\30ED\30D1\30C6\30A3\306B\8FFD\52A0\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715824464978646322.442)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>21
,p_display_sequence=>460
,p_prompt=>unistr('\30EA\30F3\30AF')
,p_attribute_type=>'LINK'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('\30CE\30FC\30C9\304C\30AF\30EA\30C3\30AF\3055\308C\305F\3068\304D\306B\5B9F\884C\3055\308C\308B\30EA\30F3\30AF\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715825559244651508.442)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>22
,p_display_sequence=>420
,p_prompt=>unistr('\30C4\30FC\30EB\30C1\30C3\30D7\5217')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:CLOB'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(388224056018770786.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB'
,p_help_text=>unistr('\30CE\30FC\30C9\30FB\30C4\30FC\30EB\30C1\30C3\30D7\306E\5024\3092\542B\3080\30C7\30FC\30BF\30FB\30BD\30FC\30B9\5217\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715810380689519088.442)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>23
,p_display_sequence=>320
,p_prompt=>unistr('\968E\5C64')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'SQL'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Application Express\304C\30C7\30FC\30BF\304B\3089\30C4\30EA\30FC\968E\5C64\3092\8A08\7B97\3059\308B\304B\3069\3046\304B\3001\307E\305F\306F\30C7\30FC\30BF\306B\3059\3079\3066\306E\968E\5C64\60C5\5831\304C\3059\3067\306B\542B\307E\308C\3066\3044\308B\304B\3069\3046\304B\3092\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715810629237528987.442)
,p_plugin_attribute_id=>wwv_flow_api.id(715810380689519088.442)
,p_display_sequence=>10
,p_display_value=>unistr('SQL\3092\4F7F\7528\3057\3066\8A08\7B97')
,p_return_value=>'SQL'
,p_help_text=>unistr('\968E\5C64\306F\3001SQL START WITH CONNECT BY\53E5\3092\4F7F\7528\3057\3066\8A08\7B97\3055\308C\307E\3059\3002<strong>\300C\89AA\30AD\30FC\5217\300D</strong>\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\3053\306E\30AA\30D7\30B7\30E7\30F3\306F\3001SQL\554F\5408\305B\306BSTART WITH CONNECT BY\53E5\304C\542B\307E\308C\3066<em>\3044\306A\3044</em>\5834\5408\306B\306E\307F\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715811097049545246.442)
,p_plugin_attribute_id=>wwv_flow_api.id(715810380689519088.442)
,p_display_sequence=>20
,p_display_value=>unistr('\8A08\7B97\3055\308C\306A\3044')
,p_return_value=>'LEVEL'
,p_help_text=>unistr('\3059\3079\3066\306E\968E\5C64\60C5\5831\306F\3059\3067\306B\30C7\30FC\30BF\306B\542B\307E\308C\3066\3044\307E\3059\3002\3053\306E\30AA\30D7\30B7\30E7\30F3\306B\306F\3001<strong>\300C\30CE\30FC\30C9\30FB\30EC\30D9\30EB\300D</strong>\304A\3088\3073<strong>\300C\30CE\30FC\30C9\30FB\30B9\30C6\30FC\30BF\30B9\300D</strong>\5217\3092\30DE\30C3\30D4\30F3\30B0\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002<strong>\300C\30CE\30FC\30C9\30FB\30EC\30D9\30EB\300D</strong>\306B\306F\3001\968E\5C64\30EC\30D9\30EB\3092\6570\5024\3067\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002<strong>\300C\30CE\30FC\30C9\30FB\30B9\30C6\30FC\30BF\30B9\300D</strong>\306B\306F\3001\30EA\30FC\30D5\30FB\30CE\30FC\30C9\306E\5834\5408\306F<strong>0</strong>\3001\975E\30EA\30FC\30D5\30FB\30CE\30FC\30C9\306E\5834\5408\306F<strong>1</strong>\3092')
||unistr('\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715827441883672711.442)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>24
,p_display_sequence=>470
,p_prompt=>unistr('\30EA\30F3\30AF\5217')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715824464978646322.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NULL'
,p_help_text=>unistr('\30CE\30FC\30C9\304C\30AF\30EA\30C3\30AF\3055\308C\305F\3068\304D\306B\5B9F\884C\3055\308C\308B\30EA\30F3\30AF\306E\5024\3092\542B\3080\30C7\30FC\30BF\30FB\30BD\30FC\30B9\5217\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715828729502680591.442)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>25
,p_display_sequence=>360
,p_prompt=>unistr('\5144\5F1F\9806\5E8F\4ED8\3051\57FA\6E96')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715810380689519088.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL'
,p_help_text=>unistr('\89AA\30CE\30FC\30C9\5185\306E\5B50\306E\9806\5E8F\4ED8\3051\306B\4F7F\7528\3059\308B\30C7\30FC\30BF\30FB\30BD\30FC\30B9\5217\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(381686476818136654.442)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.442)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function( options ) {',
'    options.multiple = true;',
'    return options;',
'}',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30C4\30EA\30FC\306E\30AA\30D7\30B7\30E7\30F3\30FB\30AA\30D6\30B8\30A7\30AF\30C8\3092\53D6\5F97\3057\3001\30AA\30D6\30B8\30A7\30AF\30C8\3092\5909\66F4\3057\3066\305D\308C\3092\8FD4\3059JavaScript\95A2\6570\3092\5165\529B\3057\307E\3059\3002\3053\308C\306B\3088\308A\3001treeView\30A6\30A3\30B8\30A7\30C3\30C8\306E\521D\671F\5316\4E2D\306B\30C4\30EA\30FC\306E\8A73\7D30\306A\30AB\30B9\30BF\30DE\30A4\30BA\304C\53EF\80FD\306B\306A\308A\307E\3059\3002\4F7F\7528\53EF\80FD\306A\30AA\30D7\30B7\30E7\30F3\306B\3064\3044\3066\306F\3001treeView\30A6\30A3\30B8\30A7\30C3\30C8\306EJavaScript API\30C9\30AD\30E5\30E1\30F3\30C8\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002<p>'),
unistr('<p>\30C4\30EA\30FC\30FB\30EA\30FC\30B8\30E7\30F3\306B\3088\3063\3066\5B9A\7FA9\3055\308C\308B\8FFD\52A0\306E\30AA\30D7\30B7\30E7\30F3\306F\6B21\306E\3068\304A\308A\3067\3059\3002</p>'),
'<ul>',
unistr('<li><strong>makeNodeAdapter</strong> \30AB\30B9\30BF\30E0nodeAdapter\3092\5B9A\7FA9\3059\308B\305F\3081\306B\4F7F\7528\3055\308C\307E\3059\3002makeDefaultNodeAdapter\3068\540C\3058\5F15\6570\3092\53D6\5F97\3057\3001treeNodeAdapter\30A4\30F3\30BF\30D5\30A7\30FC\30B9\3092\8FD4\3059\5FC5\8981\304C\3042\308B\95A2\6570\3067\3059\3002</li>'),
unistr('<li><strong>initialSelectedNodeId</strong> \9078\629E\3059\308B\30CE\30FC\30C9\306E\5024\3002\3053\308C\306F\3001\300C\9078\629E\3057\305F\30CE\30FC\30C9\306E\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\300D\5C5E\6027\306B\5F93\3063\3066\8A2D\5B9A\3055\308C\307E\3059\3002</li>'),
unistr('<li><strong>nodeHasTooltip</strong> \3053\308C\306F\3001\300C\30C4\30FC\30EB\30C1\30C3\30D7\300D\5C5E\6027\306B\5F93\3063\3066\8A2D\5B9A\3055\308C\307E\3059\3002\30CE\30FC\30C9\306B\30C4\30FC\30EB\30C1\30C3\30D7\304C\3042\308B\5834\5408\306Ftrue\3001\306A\3044\5834\5408\306Ffalse\306B\306A\308A\307E\3059\3002</li>'),
unistr('<li><strong>regionStaticId</strong> \3053\308C\306F\3001\3053\306E\30EA\30FC\30B8\30E7\30F3\306B\4F7F\7528\3055\308C\308B\8981\7D20ID\3067\3059\3002</li>'),
'</ul>'))
);
end;
/
begin
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(715829199415682079.442)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.442)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\300C\968E\5C64\300D\5C5E\6027\3092\300CSQL\3092\4F7F\7528\3057\3066\8A08\7B97\300D\306B\8A2D\5B9A\3057\305F\5834\5408</dt>'),
'<dd><pre>',
' select ename, empno, mgr from emp',
'</pre>',
unistr('<p>\300C\30CE\30FC\30C9ID\5217\300D\5C5E\6027\306BEMPNO\3001\300C\89AA\30AD\30FC\5217\300D\5C5E\6027\306BMGR\3092\6307\5B9A\3057\307E\3059</p>'),
'</dd>',
unistr('<dt>\300C\968E\5C64\300D\5C5E\6027\3092\300C\8A08\7B97\3055\308C\306A\3044\300D\306B\8A2D\5B9A\3057\305F\5834\5408</dt>'),
'<dd><pre>',
' select case when connect_by_isleaf = 1 then 0 when level = 1 then 1 else -1 end as status,',
'        level,',
'        ename as title,',
'        ''icon-tree-folder'' as icon,',
'        empno as value,',
'        ename as tooltip,',
'        null  as link',
'   from emp',
'  start with mgr is null',
'connect by prior empno = mgr',
'  order siblings by ename',
'</pre>',
unistr('<p>\300C\30CE\30FC\30C9\30FB\30B9\30C6\30FC\30BF\30B9\5217\300D\5C5E\6027\306BSTATUS\3001\300C\968E\5C64\30EC\30D9\30EB\5217\300D\5C5E\6027\306BLEVEL\3092\6307\5B9A\3057\307E\3059\3002</p>'),
'</dd>',
'</dl>'))
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(389020154426295680.442)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.442)
,p_name=>'treeviewselectionchange'
,p_display_name=>unistr('\9078\629E\306E\5909\66F4')
);
end;
/
prompt --application/shared_components/plugins/region_type/calendar
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(385516061640387971.442)
,p_plugin_type=>'REGION TYPE'
,p_name=>'CALENDAR'
,p_display_name=>unistr('\30AB\30EC\30F3\30C0')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','CALENDAR'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_SQL:ESCAPE_OUTPUT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\69D8\3005\306A\30AB\30EC\30F3\30C0\30FB\30D3\30E5\30FC\306B\65E5\4ED8\30D9\30FC\30B9\306E\30A8\30F3\30C8\30EA\3092\8868\793A\3057\307E\3059\3002</p>'),
unistr('<p>\65B0\898F\30EA\30FC\30B8\30E7\30F3\3092\4F5C\6210\3059\308B\5834\5408\3001\3053\306E\30EA\30FC\30B8\30E7\30F3\30FB\30BF\30A4\30D7\3067\306F\306A\304F\3001<em>\300C\30AB\30EC\30F3\30C0\300D</em>\3092\4F7F\7528\3057\3066\304F\3060\3055\3044\3002\30AF\30E9\30B7\30C3\30AF\30FB\30AB\30EC\30F3\30C0\30FB\30EA\30FC\30B8\30E7\30F3\306F\3001\901A\5E38\30EA\30EA\30FC\30B94.2\4EE5\524D\306E&PRODUCT_NAME.\3067\4F5C\6210\3055\308C\305F\30EA\30FC\30B8\30E7\30F3\3067\3059\3002</p>')))
,p_version_identifier=>'1.0'
,p_plugin_comment=>'$$$ DJP - Shouldn''t this be ''Is Legacy'' = ''Yes''?'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845154143004834501.442)
,p_plugin_id=>wwv_flow_api.id(385516061640387971.442)
,p_name=>'SOURCE_SQL'
,p_sql_min_column_count=>1
);
end;
/
prompt --application/shared_components/plugins/region_type/tree
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(385516341883422042.442)
,p_plugin_type=>'REGION TYPE'
,p_name=>'TREE'
,p_display_name=>unistr('\30AF\30E9\30B7\30C3\30AF\30FB\30C4\30EA\30FC')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','TREE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30EC\30B3\30FC\30C9\9593\306E\89AA\5B50\95A2\4FC2\306B\57FA\3065\3044\3066\3001\968E\5C64\69CB\9020\3067\30C7\30FC\30BF\3092\8868\793A\3057\307E\3059\3002</p>'),
unistr('<p>\65B0\898F\30EA\30FC\30B8\30E7\30F3\3092\4F5C\6210\3059\308B\5834\5408\3001\3053\306E\30EA\30FC\30B8\30E7\30F3\30FB\30BF\30A4\30D7\3067\306F\306A\304F\3001<em>\300C\30C4\30EA\30FC\300D</em>\3092\4F7F\7528\3057\3066\304F\3060\3055\3044\3002</p>')))
,p_version_identifier=>'1.0'
,p_plugin_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$$$ DJP - Is the name Classic Tree in preparation for John''s tree being implemented as a standard component in 5.0?',
''))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(385518660732877617.442)
,p_plugin_id=>wwv_flow_api.id(385516341883422042.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\30C4\30EA\30FC\30FB\30B3\30F3\30DD\30FC\30CD\30F3\30C8ID')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_is_translatable=>false
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/tree_expand
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(388431570538859249.442)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'TREE_EXPAND'
,p_display_name=>unistr('\30C4\30EA\30FC\3092\958B\304F')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','TREE_EXPAND'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\30C4\30EA\30FC\30FB\30EA\30FC\30B8\30E7\30F3\3067\73FE\5728\306E\30CE\30FC\30C9\3092\958B\304D\307E\3059\3002')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/tree_collapse
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(388635386274723384.442)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'TREE_COLLAPSE'
,p_display_name=>unistr('\30C4\30EA\30FC\3092\9589\3058\308B')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','TREE_COLLAPSE'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\30C4\30EA\30FC\30FB\30EA\30FC\30B8\30E7\30F3\3067\73FE\5728\306E\30CE\30FC\30C9\3092\9589\3058\307E\3059\3002')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/item_type/password
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(435122514730662817.442)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'PASSWORD'
,p_display_name=>unistr('\30D1\30B9\30EF\30FC\30C9')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','PASSWORD'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:SOURCE:ELEMENT:WIDTH:PLACEHOLDER:ICON:ENCRYPT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('HTML\30D1\30B9\30EF\30FC\30C9\30FB\30D5\30A9\30FC\30E0\8981\7D20\3092\8868\793A\3057\307E\3059\3002\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\30C6\30AD\30B9\30C8\3092\5165\529B\3059\308B\3068\3001\5165\529B\3057\305F\5B9F\969B\306E\6587\5B57\306E\304B\308F\308A\306B\9ED2\3044\30C9\30C3\30C8\304C\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(435122925859694465.442)
,p_plugin_id=>wwv_flow_api.id(435122514730662817.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('[Enter]\3092\62BC\3059\3068\9001\4FE1')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\3053\306E\30D5\30A3\30FC\30EB\30C9\3067<em>[Enter]</em>\30AD\30FC\3092\62BC\3059\3068\3001\30DA\30FC\30B8\304C\81EA\52D5\7684\306B\9001\4FE1\3055\308C\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
end;
/
prompt --application/shared_components/plugins/item_type/stop_and_start_html_table
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(442021108862425785.442)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'STOP_AND_START_HTML_TABLE'
,p_display_name=>unistr('\30B0\30EA\30C3\30C9\30FB\30EC\30A4\30A2\30A6\30C8\306E\505C\6B62\3068\958B\59CB')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','STOP_AND_START_HTML_TABLE'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\524D\306EHTML\8868\306E\505C\6B62\304A\3088\3073\65B0\898FHTML\8868\306E\958B\59CB\306B\4F7F\7528\3055\308C\308B\30EC\30AC\30B7\30FC\30FB\30A2\30A4\30C6\30E0\3002&PRODUCT_NAME.\30EA\30EA\30FC\30B9xx\3067<em>\30B0\30EA\30C3\30C9\30FB\30EC\30A4\30A2\30A6\30C8</em>\304C\5C0E\5165\3055\308C\308B\524D\306F\3001\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306E\8868\793A\306E\8ABF\6574\306B\5E83\304F\3053\306E\30A2\30A4\30C6\30E0\30FB\30BF\30A4\30D7\304C\4F7F\7528\3055\308C\3066\3044\307E\3057\305F\3002</p>'),
unistr('<p>\3053\308C\3089\306E\30EC\30AC\30B7\30FC\30FB\30A2\30A4\30C6\30E0\30FB\30BF\30A4\30D7\3092\524A\9664\3057\3001\305D\306E\30EA\30FC\30B8\30E7\30F3\306B\8868\793A\3055\308C\308B\6B21\306E\30DA\30FC\30B8\30FB\30BF\30A4\30E0\306B\5BFE\3057\3066<em>\300C\65B0\898F\30B0\30EA\30C3\30C9\306E\958B\59CB\300D</em>\3092<strong>\300C\306F\3044\300D</strong>\306B\66F4\65B0\3059\308B\3053\3068\3092\304A\85A6\3081\3057\307E\3059\3002\3053\308C\306F\3001\6A5F\80FD\4E0A\300C\30B0\30EA\30C3\30C9\30FB\30EC\30A4\30A2\30A6\30C8\306E\505C\6B62\3068\958B\59CB\300D\30A2\30A4\30C6\30E0\3092\4F7F\7528\3059\308B\3053\3068\3068\540C\3058\3067\3059\3002</p>')))
,p_plugin_comment=>'$$$ DJP - What APEX Release was Grid Layout introduced?'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/refresh
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(457584914213394021.442)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'REFRESH'
,p_display_name=>unistr('\30EA\30D5\30EC\30C3\30B7\30E5')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','REFRESH'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:REGION:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\5F71\97FF\3092\53D7\3051\308B\8981\7D20\306E\30EA\30D5\30EC\30C3\30B7\30E5\3092\30C8\30EA\30AC\30FC\3057\307E\3059\3002\3059\3079\3066\306E\8981\7D20\3067\30EA\30D5\30EC\30C3\30B7\30E5\30FB\30A2\30AF\30B7\30E7\30F3\304C\30B5\30DD\30FC\30C8\3055\308C\308B\308F\3051\3067\306F\3042\308A\307E\305B\3093\3002\3053\306E\30A2\30AF\30B7\30E7\30F3\3092\4F7F\7528\3057\3066\3001\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\3001\30AF\30E9\30B7\30C3\30AF\30FB\30EC\30DD\30FC\30C8\304A\3088\3073\30AB\30B9\30B1\30FC\30C9LOV\304C\30B5\30DD\30FC\30C8\3055\308C\308B\3059\3079\3066\306E\30A2\30A4\30C6\30E0\30FB\30BF\30A4\30D7\3067\30B3\30F3\30C6\30F3\30C4\3092\30EA\30D5\30EC\30C3\30B7\30E5\3067\304D\307E\3059\3002')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/show
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(517009436728139227.442)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'SHOW'
,p_display_name=>unistr('\8868\793A')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','SHOW'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JQUERY_SELECTOR:JAVASCRIPT_EXPRESSION:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\5F71\97FF\3092\53D7\3051\308B\8981\7D20\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(262167718423622079.442)
,p_plugin_id=>wwv_flow_api.id(517009436728139227.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\540C\3058\884C\306B\3059\3079\3066\8868\793A')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_deprecated_values=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5F71\97FF\3092\53D7\3051\308B\8981\7D20\3068\540C\3058\884C\306E\3059\3079\3066\306E\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3068\30E9\30D9\30EB\3092\8868\793A\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8: \3053\306E\5C5E\6027\306F\3001\8868\30B0\30EA\30C3\30C9\3092\4F7F\7528\3057\3066\30D5\30A9\30FC\30E0\30FB\30A2\30A4\30C6\30E0\3092\8868\793A\3057\306A\3044\30DA\30FC\30B8\306E\30A2\30A4\30C6\30E0\306B\5BFE\3057\3066\306F\6A5F\80FD\3057\307E\305B\3093\3002\3053\308C\306B\306F\3001\30E2\30D0\30A4\30EB\30FB\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\4F7F\7528\3057\305F\30DA\30FC\30B8\304C\542B\307E\308C\307E\3059\3002</p>')))
);
end;
/
prompt --application/shared_components/plugins/authentication_type/http_header_variable
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(552639319797428791.442)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'HTTP_HEADER_VARIABLE'
,p_display_name=>unistr('HTTP\30D8\30C3\30C0\30FC\5909\6570')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','HTTP_HEADER_VARIABLE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\5916\90E8\3067\8A8D\8A3C\3057\307E\3059\3002\30E6\30FC\30B6\30FC\540D\306F\3001Web\30B5\30FC\30D0\30FC\306B\3088\3063\3066\8A2D\5B9A\3055\308C\308BHTTP\30D8\30C3\30C0\30FC\5909\6570\306B\683C\7D0D\3055\308C\307E\3059\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(552647115426436957.442)
,p_plugin_id=>wwv_flow_api.id(552639319797428791.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('HTTP\30D8\30C3\30C0\30FC\5909\6570\540D')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30E6\30FC\30B6\30FC\540D\3092\542B\3080HTTP\30D8\30C3\30C0\30FC\5909\6570\306E\540D\524D\3092\6307\5B9A\3057\307E\3059\3002\6307\5B9A\3057\306A\3044\5834\5408\306F\3001REMOTE_USER\304C\4F7F\7528\3055\308C\307E\3059\3002</p>'),
'',
unistr('<p>HTTP\30D8\30C3\30C0\30FC\5909\6570\306F\3001Web\30B5\30FC\30D0\30FC\306B\3088\3063\3066\8A2D\5B9A\3055\308C\308B\5909\6570\3067\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(552651403090442945.442)
,p_plugin_id=>wwv_flow_api.id(552639319797428791.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\30E6\30FC\30B6\30FC\540D\304C\7A7A\306E\5834\5408\306E\30A2\30AF\30B7\30E7\30F3')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'BUILTIN_URL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('HTTP\30D8\30C3\30C0\30FC\5909\6570\306B\683C\7D0D\3055\308C\3066\3044\308B\30E6\30FC\30B6\30FC\540D\304C\7A7A\306E\5834\5408\306B\5B9F\884C\3059\308B\30A2\30AF\30B7\30E7\30F3\3092\6307\5B9A\3057\307E\3059\3002\6B21\306E\30AA\30D7\30B7\30E7\30F3\3092\4F7F\7528\3067\304D\307E\3059:'),
'</p>',
'<p>',
'<ul>',
unistr('  <li><strong>\7D44\8FBC\307FURL\306B\30EA\30C0\30A4\30EC\30AF\30C8</strong> - Web\30B5\30FC\30D0\30FC\306B\3088\308B\30ED\30B0\30A4\30F3\3092\958B\59CB\3057\307E\3059\3002\547C\3073\51FA\3055\308C\305F\3068\304D\306B\30ED\30B0\30A4\30F3\3092\5F37\5236\3059\308B\306B\306F\3001\3053\306E\7D44\8FBC\307FURL\3092Web\30B5\30FC\30D0\30FC\3067\4FDD\8B77\3055\308C\308B\3088\3046\306B\8A2D\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\30ED\30B0\30A4\30F3\3057\305F\3089\3001Web\30B5\30FC\30D0\30FC\306F\691C\8A3C\3055\308C\305F\30E6\30FC\30B6\30FC\540D\3092\3001\8A8D\8A3C\30B9\30AD\30FC\30E0\3067\4F7F\7528\3067\304D\308B\3088\3046\306BHTTP\30D8\30C3\30C0\30FC\5909\6570\306B\683C\7D0D\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\7D44\8FBC\307FURL\306F'),
'<pre>/apex/apex_authentication.callback</pre>',
unistr('\3067\3001\63A5\982D\8F9E<code>/apex/</code>\306F\30B5\30FC\30D0\30FC\69CB\6210\306B\3088\3063\3066\7570\306A\308A\307E\3059\3002'),
'</li>',
unistr('  <li><strong>URL\306B\30EA\30C0\30A4\30EC\30AF\30C8</strong> - \5916\90E8\30B5\30FC\30D0\30FC\3078\306E\30ED\30B0\30A4\30F3\3092\958B\59CB\3057\3001\691C\8A3C\3055\308C\305F\30E6\30FC\30B6\30FC\540D\3092HTTP\30D8\30C3\30C0\30FC\5909\6570\306B\8A2D\5B9A\3057\307E\3059\3002\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\8A8D\8A3C\3092\5B8C\4E86\3059\308B\306B\306F\3001<code>#CALLBACK#</code>\30D7\30EC\30FC\30B9\30DB\30EB\30C0\30FC\3067\751F\6210\3055\308C\308BURL\3092\4F7F\7528\3057\3066\5916\90E8\30B5\30FC\30D0\30FC\304C\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\518D\30EA\30C0\30A4\30EC\30AF\30C8\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</li>'),
unistr('  <li><strong>\30A8\30E9\30FC\8868\793A</strong> - \6307\5B9A\3055\308C\305F\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\3092\8868\793A\3057\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\30ED\30B0\30A4\30F3\306F\5B9F\884C\3055\308C\307E\305B\3093\3002</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(552655716596446845.442)
,p_plugin_attribute_id=>wwv_flow_api.id(552651403090442945.442)
,p_display_sequence=>10
,p_display_value=>unistr('\7D44\8FBC\307FURL\306B\30EA\30C0\30A4\30EC\30AF\30C8')
,p_return_value=>'BUILTIN_URL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(552667630233460180.442)
,p_plugin_attribute_id=>wwv_flow_api.id(552651403090442945.442)
,p_display_sequence=>20
,p_display_value=>unistr('URL\306B\30EA\30C0\30A4\30EC\30AF\30C8')
,p_return_value=>'URL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(552687932441470278.442)
,p_plugin_attribute_id=>wwv_flow_api.id(552651403090442945.442)
,p_display_sequence=>30
,p_display_value=>unistr('\30A8\30E9\30FC\8868\793A')
,p_return_value=>'ERROR'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(552699720929485951.442)
,p_plugin_id=>wwv_flow_api.id(552639319797428791.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(552651403090442945.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'URL'
,p_examples=>'<pre>http://sso.example.com/?success=#CALLBACK#</pre>'
,p_help_text=>unistr('\691C\8A3C\3055\308C\305F\30E6\30FC\30B6\30FC\540D\3092HTTP\30D8\30C3\30C0\30FC\5909\6570\306B\8A2D\5B9A\3059\308B\5916\90E8\30ED\30B0\30A4\30F3\30FB\30B5\30FC\30D0\30FC\306EURL\3092\6307\5B9A\3057\307E\3059\3002\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\8A8D\8A3C\3092\5B8C\4E86\3059\308B\306B\306F\3001<code>#CALLBACK#</code>\30D7\30EC\30FC\30B9\30DB\30EB\30C0\30FC\3067\751F\6210\3055\308C\308BURL\3092\4F7F\7528\3057\3066\5916\90E8\30B5\30FC\30D0\30FC\304C\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\518D\30EA\30C0\30A4\30EC\30AF\30C8\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(552704028894488210.442)
,p_plugin_id=>wwv_flow_api.id(552639319797428791.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(552651403090442945.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ERROR'
,p_help_text=>unistr('HTTP\30D8\30C3\30C0\30FC\5909\6570\306B\5024\304C\542B\307E\308C\3066\3044\306A\3044\3001\307E\305F\306FHTTP\30D8\30C3\30C0\30FC\5909\6570\304C\5B58\5728\3057\306A\3044\5834\5408\306B\8868\793A\3055\308C\308B\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(879327919421164751.442)
,p_plugin_id=>wwv_flow_api.id(552639319797428791.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\30E6\30FC\30B6\30FC\540D\306E\691C\8A3C')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ALWAYS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('HTTP\30D8\30C3\30C0\30FC\5909\6570\306B\683C\7D0D\3055\308C\3066\3044\308B\30E6\30FC\30B6\30FC\540D\3092\691C\8A3C\3059\308B\983B\5EA6\3092\6307\5B9A\3057\307E\3059\3002\6B21\306E\30AA\30D7\30B7\30E7\30F3\3092\4F7F\7528\3067\304D\307E\3059:'),
'</p>',
'<p>',
'<ul>',
unistr('  <li><strong>\30EA\30AF\30A8\30B9\30C8\3054\3068</strong> - Web\30B5\30FC\30D0\30FC\306B\3088\3063\3066\30ED\30B0\30A4\30F3\304C\5B9F\884C\3055\308C\308B\3068\3059\3050\306BCGI\5909\6570\304C\5E38\306B\8A2D\5B9A\3055\308C\307E\3059\3002\30E6\30FC\30B6\30FC\540D\304C\73FE\5728\306E&PRODUCT_NAME.\30BB\30C3\30B7\30E7\30F3\306B\683C\7D0D\3055\308C\3066\3044\308B\540D\524D\306B\4E00\81F4\3057\306A\3044\5834\5408\306F\3001\30BB\30C3\30B7\30E7\30F3\304C\7121\52B9\306B\306A\308A\3001\65B0\3057\3044\30ED\30B0\30A4\30F3\304C\958B\59CB\3055\308C\307E\3059\3002\30ED\30B0\30A2\30A6\30C8\3084\30E6\30FC\30B6\30FC\540D\306E\5909\66F4\304C\691C\51FA\3055\308C\308B\306E\3067\3001\3053\308C\304C\6700\3082\30BB\30AD\30E5\30A2\306A\30AA\30D7\30B7\30E7\30F3\3067\3059\3002'),
'  </li>',
unistr('  <li><strong>\30ED\30B0\30A4\30F3\5F8C</strong> - Web\30B5\30FC\30D0\30FC\304C\30ED\30B0\30A4\30F3\3092\5B9F\884C\3057\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\306E\8A8D\8A3C\3092\5B8C\4E86\3059\308B\30B3\30FC\30EB\30D0\30C3\30AF\3092\547C\3073\51FA\3057\305F\5F8C\3067\521D\3081\3066\3001\30E6\30FC\30B6\30FC\540D\3092\691C\8A3C\3057\3001&PRODUCT_NAME.\30BB\30C3\30B7\30E7\30F3\306B\683C\7D0D\3057\307E\3059\3002\30B3\30FC\30EB\30D0\30C3\30AF\306E\8A73\7D30\306F\3001\300C\30E6\30FC\30B6\30FC\540D\304C\7A7A\306E\5834\5408\306E\30A2\30AF\30B7\30E7\30F3\300D\306E\69CB\6210\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002'),
'  </li>',
'</ul>',
'</p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(879343501197168872.442)
,p_plugin_attribute_id=>wwv_flow_api.id(879327919421164751.442)
,p_display_sequence=>10
,p_display_value=>unistr('\30EA\30AF\30A8\30B9\30C8\3054\3068')
,p_return_value=>'ALWAYS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(879347807777170859.442)
,p_plugin_attribute_id=>wwv_flow_api.id(879327919421164751.442)
,p_display_sequence=>20
,p_display_value=>unistr('\30ED\30B0\30A4\30F3\5F8C')
,p_return_value=>'CALLBACK'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(39504908766917753.442)
,p_plugin_id=>wwv_flow_api.id(552639319797428791.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('SSO\30B5\30FC\30D0\30FC\306E\30ED\30B0\30A2\30A6\30C8URL')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Oracle Access Manager\30D9\30FC\30B9\306ESSO\306E\5834\5408\3001\305F\3068\3048\3070\6B21\306E\3088\3046\306B\5165\529B\3057\307E\3059\3002</p>'),
'<pre>',
'/oamsso/logout.html?end_url=%POST_LOGOUT_URL%',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8A8D\8A3C\30B9\30AD\30FC\30E0\304COracle Access Manager\307E\305F\306F\540C\69D8\306E\30B5\30FC\30D0\30FC\306B\57FA\3065\3044\3066\3044\308B\5834\5408\3001'),
unistr('\3053\306E\5C5E\6027\3092\4F7F\7528\3057\3066\3001\4E2D\592E\306E\30B7\30F3\30B0\30EB\30FB\30B5\30A4\30F3\30AA\30F3\30FB\30B5\30FC\30D0\30FC\304B\3089\30ED\30B0\30A2\30A6\30C8\3059\308BURL\3092\6307\5B9A\3067\304D\307E\3059\3002</p>'),
'',
unistr('<p>\7F6E\63DB\30D1\30E9\30E1\30FC\30BF<code>%POST_LOGOUT_URL%</code>\306F\3001\30A8\30F3\30B3\30FC\30C9\3055\308C\305F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8\306EURL\306B\3088\3063\3066\7F6E\63DB\3055\308C\307E\3059\3002</p>')))
);
end;
/
prompt --application/shared_components/plugins/item_type/html_expression
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(562560582820583985.442)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'HTML_EXPRESSION'
,p_display_name=>unistr('HTML\5F0F')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','HTML_EXPRESSION'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SOURCE:LINK'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('HTML\5F0F\306B\57FA\3065\3044\3066\5165\529B\4E0D\53EF\30A2\30A4\30C6\30E0\3092\8868\793A\3057\307E\3059\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(562566479673647057.442)
,p_plugin_id=>wwv_flow_api.id(562560582820583985.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('HTML\5F0F')
,p_attribute_type=>'HTML'
,p_is_required=>true
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>\30D0\30C3\30AF\30B0\30E9\30A6\30F3\30C9\304A\3088\3073\30C6\30AD\30B9\30C8\306E\8272\306E\5909\66F4</dt>'),
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&amp;EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>\30D8\30C3\30C0\30FC2\306E\4F7F\7528</dt>'),
'    <dd><pre>&lt;h2>&amp;EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>SQL\554F\5408\305B\304B\3089\306E\52D5\7684\30AF\30E9\30B9\306E\4F7F\7528</dt>'),
'    <dd><pre>&lt;span class="&amp;COLUMN_CLASS!ATTR.">&amp;EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    \3053\306E\4F8B\3067<code>&amp;COLUMN_CLASS!ATTR.</code>\3068<code>&amp;EMPLOYEE_STATUS.</code>\306B\4EE3\5165\3055\308C\308B\306E\306F\3001SQL\554F\5408\305B\3067\9078\629E\3055\308C\305F\5217\3067\3059\3002</dd>'),
unistr('  <dt>\30DB\30D0\30FC\3067\306E\30A4\30E1\30FC\30B8\304A\3088\3073\30C4\30FC\30EB\30C1\30C3\30D7\306E\8868\793A</dt>'),
'    <dd><pre>&lt;img src="&amp;IMAGE_NAME!ATTR." title="&amp;EMPLOYEE_NAME!ATTR."&gt;</pre></dd>',
'</dl>'))
,p_help_text=>unistr('\3053\306E\5217\306B\8868\793A\3055\308C\308BHTML\5F0F\3092\5165\529B\3057\307E\3059\3002<code>&amp;COLUMN.</code>\69CB\6587\3092\4F7F\7528\3057\3066\3001HTML\306B\5217\5024\3092\8868\793A\3057\307E\3059\3002')
);
end;
/
prompt --application/shared_components/plugins/item_type/link
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(567106626791482337.442)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'LINK'
,p_display_name=>unistr('\30EA\30F3\30AF')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','LINK'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:ESCAPE_OUTPUT:SOURCE:FILTER:LINK'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\30EA\30F3\30AF\3068\3057\3066\5165\529B\4E0D\53EF\30A2\30A4\30C6\30E0\3092\8868\793A\3057\307E\3059\3002')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/clear
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(626823504054693040.442)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'CLEAR'
,p_display_name=>unistr('\30AF\30EA\30A2')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','CLEAR'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:REGION:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\5F71\97FF\3092\53D7\3051\308B\8981\7D20\3092\30AF\30EA\30A2\3057\307E\3059\3002')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/alert
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(626823719638697634.442)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'ALERT'
,p_display_name=>unistr('\30A2\30E9\30FC\30C8')
,p_category=>'NOTIFICATION'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','ALERT'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('1\3064\306E<em>\300COK\300D</em>\30DC\30BF\30F3\3092\542B\3080\30A2\30E9\30FC\30C8\30FB\30E1\30C3\30BB\30FC\30B8\3092\8868\793A\3057\307E\3059\3002\30DC\30BF\30F3\3092\62BC\3057\3066\5FDC\7B54\3059\308B\5FC5\8981\306F\3042\308B\304C\3001\30A4\30D9\30F3\30C8\306E\5B9F\884C\306F\7D9A\3051\3089\308C\308B\60C5\5831\306E\8868\793A\306B\4F7F\7528\3057\307E\3059\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(626823916999706267.442)
,p_plugin_id=>wwv_flow_api.id(626823719638697634.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>20
,p_prompt=>unistr('\30E1\30C3\30BB\30FC\30B8')
,p_attribute_type=>'HTML'
,p_is_required=>true
,p_is_translatable=>true
,p_examples=>unistr('<p>\5F93\696D\54E1&amp;P1_ENAME.\3092\524A\9664&lt;strong&gt;\3067\304D\307E\305B\3093\3067\3057\305F&lt;&#x2F;strong&gt;\3002</p>')
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30A2\30E9\30FC\30C8\30FB\30C0\30A4\30A2\30ED\30B0\306B\8868\793A\3055\308C\308B\30E1\30C3\30BB\30FC\30B8\3092\5165\529B\3057\307E\3059\3002</p>'),
unistr('<p>\30A2\30A4\30C6\30E0\306E\7F6E\63DB\306F\3001\30C0\30A4\30A2\30ED\30B0\306E\8868\793A\6642\306B\30AF\30E9\30A4\30A2\30F3\30C8\5074\3067\5B9F\884C\3055\308C\307E\3059\3002</p>')))
,p_attribute_comment=>'The above example is escaped properly!'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3701076455936800.442)
,p_plugin_id=>wwv_flow_api.id(626823719638697634.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>unistr('\30BF\30A4\30C8\30EB')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>unistr('<p>\30AA\30D7\30B7\30E7\30F3\3067\30C0\30A4\30A2\30ED\30B0\306E\30BF\30A4\30C8\30EB\3092\6307\5B9A\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3701701323970349.442)
,p_plugin_id=>wwv_flow_api.id(626823719638697634.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\30B9\30BF\30A4\30EB')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>unistr('\30C7\30D5\30A9\30EB\30C8')
,p_help_text=>unistr('\30C0\30A4\30A2\30ED\30B0\306E\30B9\30BF\30A4\30EB\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3703043398973992.442)
,p_plugin_attribute_id=>wwv_flow_api.id(3701701323970349.442)
,p_display_sequence=>10
,p_display_value=>unistr('\60C5\5831')
,p_return_value=>'information'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3702623945972615.442)
,p_plugin_attribute_id=>wwv_flow_api.id(3701701323970349.442)
,p_display_sequence=>20
,p_display_value=>unistr('\5371\967A')
,p_return_value=>'danger'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3702291441971350.442)
,p_plugin_attribute_id=>wwv_flow_api.id(3701701323970349.442)
,p_display_sequence=>30
,p_display_value=>unistr('\8B66\544A')
,p_return_value=>'warning'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3703410946975189.442)
,p_plugin_attribute_id=>wwv_flow_api.id(3701701323970349.442)
,p_display_sequence=>40
,p_display_value=>unistr('\6210\529F')
,p_return_value=>'success'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3705287585006856.442)
,p_plugin_id=>wwv_flow_api.id(626823719638697634.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\30A2\30A4\30B3\30F3')
,p_attribute_type=>'ICON'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('\30AA\30D7\30B7\30E7\30F3\306E\30C0\30A4\30A2\30ED\30B0\30FB\30A2\30A4\30B3\30F3\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3704914260003167.442)
,p_plugin_id=>wwv_flow_api.id(626823719638697634.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('CSS\30AF\30E9\30B9')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('\30C0\30A4\30A2\30ED\30B0\30FB\30B3\30F3\30C6\30CA\306B\9069\7528\3055\308C\308B\30AA\30D7\30B7\30E7\30F3\306ECSS\30AF\30E9\30B9\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3705505358011056.442)
,p_plugin_id=>wwv_flow_api.id(626823719638697634.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('OK\30E9\30D9\30EB')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>unistr('OK\30DC\30BF\30F3\306E\30E9\30D9\30EB\3092\5165\529B\3057\307E\3059\3002\4F55\3082\6307\5B9A\3055\308C\306A\3044\5834\5408\3001\30C6\30AD\30B9\30C8\30FB\30E1\30C3\30BB\30FC\30B8<code>APEX.DIALOG.OK</code>\306E\5024\304C\4F7F\7528\3055\308C\307E\3059\3002')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/confirm
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(626824429466709866.442)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'CONFIRM'
,p_display_name=>unistr('\78BA\8A8D')
,p_category=>'NOTIFICATION'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','CONFIRM'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\300C\53D6\6D88\300D\304A\3088\3073\300C\78BA\8A8D\300D\30DC\30BF\30F3\3092\542B\3080\78BA\8A8D\30C0\30A4\30A2\30ED\30B0\3092\8868\793A\3057\307E\3059\3002\30E6\30FC\30B6\30FC\304C<em>\300C\53D6\6D88\300D</em>\3092\9078\629E\3059\308B\3068\3001\51E6\7406\4E2D\306E\30A2\30AF\30B7\30E7\30F3\306F\5B9F\884C\3055\308C\305A\3001\73FE\5728\306E\30A4\30D9\30F3\30C8\306F\53D6\308A\6D88\3055\308C\307E\3059\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(626824618169716040.442)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>20
,p_prompt=>unistr('\30E1\30C3\30BB\30FC\30B8')
,p_attribute_type=>'HTML'
,p_is_required=>true
,p_is_translatable=>true
,p_examples=>unistr('<p>\5F93\696D\54E1&amp;P1_ENAME.\3092\524A\9664\3057\3066\3082&lt;strong&gt;\3088\308D\3057\3044\3067\3059\304B&lt;&#x2F;strong&gt;\3002</p>')
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\78BA\8A8D\30C0\30A4\30A2\30ED\30B0\306B\8868\793A\3055\308C\308B\30E1\30C3\30BB\30FC\30B8\3092\5165\529B\3057\307E\3059\3002</p>'),
unistr('<p>\30A2\30A4\30C6\30E0\306E\7F6E\63DB\306F\3001\30C0\30A4\30A2\30ED\30B0\304C\8868\793A\3055\308C\308B\969B\306B\30AF\30E9\30A4\30A2\30F3\30C8\5074\3067\5B9F\884C\3055\308C\307E\3059\3002</p>')))
,p_attribute_comment=>'The above example is escaped properly!'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2101389282482255.442)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>unistr('\30BF\30A4\30C8\30EB')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>unistr('<p>\30AA\30D7\30B7\30E7\30F3\3067\3001\30C0\30A4\30A2\30ED\30B0\306E\30BF\30A4\30C8\30EB\3092\6307\5B9A\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2103085785653286.442)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\30B9\30BF\30A4\30EB')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>unistr('\30C7\30D5\30A9\30EB\30C8')
,p_help_text=>unistr('\30C0\30A4\30A2\30ED\30B0\306E\30B9\30BF\30A4\30EB\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2104149014656515.442)
,p_plugin_attribute_id=>wwv_flow_api.id(2103085785653286.442)
,p_display_sequence=>10
,p_display_value=>unistr('\60C5\5831')
,p_return_value=>'information'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2103302674655458.442)
,p_plugin_attribute_id=>wwv_flow_api.id(2103085785653286.442)
,p_display_sequence=>20
,p_display_value=>unistr('\8B66\544A')
,p_return_value=>'warning'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2103765346655897.442)
,p_plugin_attribute_id=>wwv_flow_api.id(2103085785653286.442)
,p_display_sequence=>30
,p_display_value=>unistr('\5371\967A')
,p_return_value=>'danger'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2104502204657360.442)
,p_plugin_attribute_id=>wwv_flow_api.id(2103085785653286.442)
,p_display_sequence=>40
,p_display_value=>unistr('\6210\529F')
,p_return_value=>'success'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2106373192721945.442)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\30A2\30A4\30B3\30F3')
,p_attribute_type=>'ICON'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('\30AA\30D7\30B7\30E7\30F3\306E\30C0\30A4\30A2\30ED\30B0\30FB\30A2\30A4\30B3\30F3\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2106035369711819.442)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('CSS\30AF\30E9\30B9')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('\30C0\30A4\30A2\30ED\30B0\30FB\30B3\30F3\30C6\30CA\306B\9069\7528\3055\308C\308B\30AA\30D7\30B7\30E7\30F3\306ECSS\30AF\30E9\30B9\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2106917926775379.442)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\78BA\8A8D\30E9\30D9\30EB')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>unistr('\78BA\8A8D\30DC\30BF\30F3\306E\30E9\30D9\30EB\3092\5165\529B\3057\307E\3059\3002\4F55\3082\6307\5B9A\3055\308C\306A\3044\5834\5408\3001\30C6\30AD\30B9\30C8\30FB\30E1\30C3\30BB\30FC\30B8<code>APEX.DIALOG.OK</code>\306E\5024\304C\4F7F\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2106670847763561.442)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\53D6\6D88\30E9\30D9\30EB')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>unistr('\53D6\6D88\30DC\30BF\30F3\306E\30E9\30D9\30EB\3092\5165\529B\3057\307E\3059\3002\4F55\3082\6307\5B9A\3055\308C\306A\3044\5834\5408\3001\30C6\30AD\30B9\30C8\30FB\30E1\30C3\30BB\30FC\30B8<code>APEX.DIALOG.CANCEL</code>\306E\5024\304C\4F7F\7528\3055\308C\307E\3059\3002')
);
end;
/
prompt --application/shared_components/plugins/process_type/parse_uploaded_data
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(668666822163400066.442)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'PARSE_UPLOADED_DATA'
,p_display_name=>unistr('\30A2\30C3\30D7\30ED\30FC\30C9\3057\305F\30C7\30FC\30BF\306E\89E3\6790')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','PARSE_UPLOADED_DATA'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>unistr('\65E2\5B58\306E\8868\3078\306E\30ED\30FC\30C9\306B\5099\3048\3066\6E96\5099\3055\308C\305F\30B9\30D7\30EC\30C3\30C9\30B7\30FC\30C8\30FB\30C7\30FC\30BF\3092\89E3\6790\3059\308B\30D7\30ED\30BB\30B9\3002\3053\306E\30D7\30ED\30BB\30B9\30FB\30BF\30A4\30D7\306F\3001<em>\30C7\30FC\30BF\306E\30ED\30FC\30C9</em>\7528\306E\30DA\30FC\30B8\306E\4F5C\6210\30A6\30A3\30B6\30FC\30C9\306B\3088\3063\3066\751F\6210\3055\308C\307E\3059\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668751414675407356.442)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\30C7\30FC\30BF\30FB\30ED\30FC\30C9\5B9A\7FA9')
,p_attribute_type=>'DATA LOAD TABLE ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\30ED\30FC\30C9\3055\308C\308B\8868\3092\5B9A\7FA9\3059\308B\30C7\30FC\30BF\30FB\30ED\30FC\30C9\5B9A\7FA9\3092\5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668863505241423607.442)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\30A4\30F3\30DD\30FC\30C8\5143\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\3088\3063\3066\9078\629E\3055\308C\305F<em>\300C\30A4\30F3\30DD\30FC\30C8\5143\300D</em>\30AA\30D7\30B7\30E7\30F3\3092\4FDD\6301\3059\308B\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(714598810997211212.442)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\30BB\30D1\30EC\30FC\30BF\30FB\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\3088\3063\3066\5165\529B\3055\308C\305F<em>\300C\30BB\30D1\30EC\30FC\30BF\300D</em>\30C6\30AD\30B9\30C8\3092\4FDD\6301\3059\308B\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(714603217923213191.442)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\56F2\307F\6587\5B57\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\3088\3063\3066\5165\529B\3055\308C\305F<em>\300C\56F2\307F\6587\5B57(\30AA\30D7\30B7\30E7\30F3)\300D</em>\30C6\30AD\30B9\30C8\3092\4FDD\6301\3059\308B\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668904302255432174.442)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\6700\521D\306E\884C\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\3088\3063\3066\5165\529B\3055\308C\305F<em>\300C1\884C\76EE\306B\5217\540D\304C\3042\308B\300D</em>\30C1\30A7\30C3\30AF\30DC\30C3\30AF\30B9\5024\3092\4FDD\6301\3059\308B\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668954022687438059.442)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\901A\8CA8\8A18\53F7\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\3088\3063\3066\5165\529B\3055\308C\305F<em>\300C\901A\8CA8\8A18\53F7\300D</em>\30C6\30AD\30B9\30C8\3092\4FDD\6301\3059\308B\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668962228228439718.442)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\30B0\30EB\30FC\30D7\30FB\30BB\30D1\30EC\30FC\30BF\30FB\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\3088\3063\3066\5165\529B\3055\308C\305F<em>\300C\30B0\30EB\30FC\30D7\30FB\30BB\30D1\30EC\30FC\30BF\300D</em>\30C6\30AD\30B9\30C8\3092\4FDD\6301\3059\308B\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668977904810442452.442)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\5C0F\6570\70B9\6587\5B57\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\3088\3063\3066\5165\529B\3055\308C\305F<em>\300C\5C0F\6570\70B9\6587\5B57\300D</em>\30C6\30AD\30B9\30C8\3092\4FDD\6301\3059\308B\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668982211736444415.442)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\30D5\30A1\30A4\30EB\540D\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\3088\3063\3066\5165\529B\3055\308C\305F<em>\300C\30D5\30A1\30A4\30EB\540D\300D</em>\5024\3092\4FDD\6301\3059\308B\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(669001326628448680.442)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('\30B3\30D4\30FC\30FB\30A2\30F3\30C9\30FB\30DA\30FC\30B9\30C8\30FB\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\3088\3063\3066\5165\529B\3055\308C\305F<em>\300C\30C7\30EA\30DF\30BF\3067\533A\5207\3089\308C\305F\65E5\4ED8\3092\30B3\30D4\30FC\30FB\30A2\30F3\30C9\30FB\30DA\30FC\30B9\30C8\300D</em>\30C6\30AD\30B9\30C8\3092\4FDD\6301\3059\308B\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(24234014577732260.442)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>unistr('\6587\5B57\30BB\30C3\30C8\30FB\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\3088\3063\3066\9078\629E\3055\308C\305F<em>\30D5\30A1\30A4\30EB\306E\6587\5B57\30BB\30C3\30C8</em>\3092\4FDD\6301\3059\308B\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(48837321936282082.442)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>unistr('\65E5\4ED8\66F8\5F0F\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\3088\3063\3066\5165\529B\3055\308C\305F<em>\300C\65E5\4ED8\66F8\5F0F\300D</em>\30C6\30AD\30B9\30C8\3092\4FDD\6301\3059\308B\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
end;
/
prompt --application/shared_components/plugins/region_type/data_upload_column_mapping
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(669051019271465508.442)
,p_plugin_type=>'REGION TYPE'
,p_name=>'DATA_UPLOAD_COLUMN_MAPPING'
,p_display_name=>unistr('\30C7\30FC\30BF\30FB\30A2\30C3\30D7\30ED\30FC\30C9\5217\306E\30DE\30C3\30D4\30F3\30B0')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','DATA_UPLOAD_COLUMN_MAPPING'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>unistr('\30A2\30C3\30D7\30ED\30FC\30C9\3055\308C\305F\30B9\30D7\30EC\30C3\30C9\30B7\30FC\30C8\306E\5217\3092\8868\306E\5217\306B\30DE\30C3\30D7\3057\307E\3059\3002\3053\306E\30EA\30FC\30B8\30E7\30F3\30FB\30BF\30A4\30D7\306F\3001<em>\300C\30C7\30FC\30BF\306E\30ED\30FC\30C9\300D</em>\7528\306E\30DA\30FC\30B8\306E\4F5C\6210\30A6\30A3\30B6\30FC\30C9\306B\3088\3063\3066\751F\6210\3055\308C\307E\3059\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(669071925851467433.442)
,p_plugin_id=>wwv_flow_api.id(669051019271465508.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\30C7\30FC\30BF\30FB\30ED\30FC\30C9\5B9A\7FA9')
,p_attribute_type=>'DATA LOAD TABLE ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('<em>\30C7\30FC\30BF\306E\30ED\30FC\30C9</em>\30FB\30D7\30ED\30BB\30B9\5185\3067\5B9A\7FA9\3055\308C\305F\30C7\30FC\30BF\30FB\30ED\30FC\30C9\5B9A\7FA9\3092\9078\629E\3057\307E\3059\3002')
);
end;
/
prompt --application/shared_components/plugins/process_type/prepare_uploaded_data
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(669101621133475493.442)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'PREPARE_UPLOADED_DATA'
,p_display_name=>unistr('\30A2\30C3\30D7\30ED\30FC\30C9\30FB\30C7\30FC\30BF\306E\6E96\5099')
,p_supported_ui_types=>'DESKTOP:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','PREPARE_UPLOADED_DATA'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>unistr('\65E2\5B58\306E\8868\306B\30A2\30C3\30D7\30ED\30FC\30C9\3059\308B\305F\3081\306B\30B9\30D7\30EC\30C3\30C9\30B7\30FC\30C8\30FB\30C7\30FC\30BF\3092\6E96\5099\3059\308B\30D7\30ED\30BB\30B9\3002\3053\306E\30D7\30ED\30BB\30B9\30FB\30BF\30A4\30D7\306F\3001<em>\30C7\30FC\30BF\306E\30ED\30FC\30C9</em>\7528\306E\30DA\30FC\30B8\306E\4F5C\6210\30A6\30A3\30B6\30FC\30C9\306B\3088\3063\3066\751F\6210\3055\308C\307E\3059\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(670229105709707629.442)
,p_plugin_id=>wwv_flow_api.id(669101621133475493.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\30C7\30FC\30BF\30FB\30ED\30FC\30C9\5B9A\7FA9')
,p_attribute_type=>'DATA LOAD TABLE ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\30ED\30FC\30C9\3055\308C\308B\8868\3092\5B9A\7FA9\3059\308B\30C7\30FC\30BF\30FB\30ED\30FC\30C9\5B9A\7FA9\3092\5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(380468155644060156.442)
,p_plugin_id=>wwv_flow_api.id(669101621133475493.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\633F\5165\6570\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('\633F\5165\3055\308C\308B\30EC\30B3\30FC\30C9\306E\6570\3092\4FDD\6301\3059\308B\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(380468974968063264.442)
,p_plugin_id=>wwv_flow_api.id(669101621133475493.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\66F4\65B0\6570\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('\66F4\65B0\3055\308C\308B\30EC\30B3\30FC\30C9\306E\6570\3092\4FDD\6301\3059\308B\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(380469514614067903.442)
,p_plugin_id=>wwv_flow_api.id(669101621133475493.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\30A8\30E9\30FC\6570\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('\30A8\30E9\30FC\306E\3042\308B\30EC\30B3\30FC\30C9\306E\6570\3092\4FDD\6301\3059\308B\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(380470030664073278.442)
,p_plugin_id=>wwv_flow_api.id(669101621133475493.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\30EC\30D3\30E5\30FC\6570\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('\30EC\30D3\30E5\30FC\3055\308C\305F\30EC\30B3\30FC\30C9\306E\6570\3092\4FDD\6301\3059\308B\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
end;
/
prompt --application/shared_components/plugins/process_type/load_uploaded_data
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(669285217502512352.442)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'LOAD_UPLOADED_DATA'
,p_display_name=>unistr('\30A2\30C3\30D7\30ED\30FC\30C9\30FB\30C7\30FC\30BF\306E\30ED\30FC\30C9')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','LOAD_UPLOADED_DATA'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>unistr('\89E3\6790\3055\308C\305F\30B9\30D7\30EC\30C3\30C9\30B7\30FC\30C8\30FB\30C7\30FC\30BF\3092\65E2\5B58\306E\8868\307E\305F\306F\30D3\30E5\30FC\306B\30ED\30FC\30C9\3059\308B\30D7\30ED\30BB\30B9\3002\3053\306E\30D7\30ED\30BB\30B9\30FB\30BF\30A4\30D7\306F\3001<em>\30C7\30FC\30BF\306E\30ED\30FC\30C9</em>\7528\306E\30DA\30FC\30B8\306E\4F5C\6210\30A6\30A3\30B6\30FC\30C9\306B\3088\3063\3066\751F\6210\3055\308C\307E\3059\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(669308626852514974.442)
,p_plugin_id=>wwv_flow_api.id(669285217502512352.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\30C7\30FC\30BF\30FB\30ED\30FC\30C9\5B9A\7FA9')
,p_attribute_type=>'DATA LOAD TABLE ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\30ED\30FC\30C9\3055\308C\308B\8868\3092\5B9A\7FA9\3059\308B\30C7\30FC\30BF\30FB\30ED\30FC\30C9\5B9A\7FA9\3092\5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(669317208629519157.442)
,p_plugin_id=>wwv_flow_api.id(669285217502512352.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\633F\5165\6570\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\633F\5165\3055\308C\305F\30EC\30B3\30FC\30C9\306E\6570\3092\4FDD\6301\3059\308B\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002'),
unistr('\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(669321513477520652.442)
,p_plugin_id=>wwv_flow_api.id(669285217502512352.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\66F4\65B0\6570\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\66F4\65B0\3055\308C\305F\30EC\30B3\30FC\30C9\306E\6570\3092\4FDD\6301\3059\308B\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002'),
unistr('\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(669325819364522297.442)
,p_plugin_id=>wwv_flow_api.id(669285217502512352.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\30A8\30E9\30FC\6570\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30A8\30E9\30FC\306E\3042\308B\30EC\30B3\30FC\30C9\306E\6570\3092\4FDD\6301\3059\308B\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002'),
unistr('\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(208350031209048901.442)
,p_plugin_id=>wwv_flow_api.id(669285217502512352.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\30EC\30D3\30E5\30FC\6570\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30EC\30D3\30E5\30FC\3055\308C\305F\30EC\30B3\30FC\30C9\306E\6570\3092\4FDD\6301\3059\308B\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002'),
unistr('\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')))
);
end;
/
prompt --application/shared_components/plugins/authentication_type/apex_accounts
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(707619648734994478.442)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'APEX_ACCOUNTS'
,p_display_name=>unistr('Application Express\30A2\30AB\30A6\30F3\30C8')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','APEX_ACCOUNTS'),'')
,p_api_version=>1
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('<p>&PRODUCT_NAME.\30A2\30AB\30A6\30F3\30C8\306E\30E6\30FC\30B6\30FC\540D\304A\3088\3073\30D1\30B9\30EF\30FC\30C9\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002\5404\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306B\306F\3001\72EC\81EA\306E\30E6\30FC\30B6\30FC\30FB\30A2\30AB\30A6\30F3\30C8\30FB\30EA\30DD\30B8\30C8\30EA\304C\3042\308A\307E\3059\3002\30ED\30B0\30A4\30F3\3057\3066\3044\308B\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306F\3001\30EF\30FC\30AF\30B9\30DA\30FC\30B9&amp;F4155_WORKSPACE_NAME.\306B\5C5E\3057\3066\3044\307E\3059\3002\30D1\30B9\30EF\30FC\30C9\306F\5927/\5C0F\6587\5B57\304C\533A\5225\3055\308C\307E\3059\3002</p>')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/open_door
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(707675753928996044.442)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'OPEN_DOOR'
,p_display_name=>unistr('\516C\958B\8CC7\683C\8A3C\660E')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','OPEN_DOOR'),'')
,p_api_version=>1
,p_standard_attributes=>'LOGIN_PAGE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\3060\308C\3067\3082\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\30A2\30AF\30BB\30B9\3067\304D\307E\3059\3002\3053\306E\30BB\30C3\30B7\30E7\30F3\4E2D\306B\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30E6\30FC\30B6\30FC\3067\3042\308B\3053\3068\3092\8B58\5225\3059\308B\8B58\5225\5B50\3092\5165\529B\3057\307E\3059\3002\3053\308C\306B\3088\3063\3066\3001APP_USER\5909\6570\306E\5024\304C\8A2D\5B9A\3055\308C\307E\3059\3002')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/db_accounts
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(707686311942002797.442)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'DB_ACCOUNTS'
,p_display_name=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30A2\30AB\30A6\30F3\30C8')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','DB_ACCOUNTS'),'')
,p_api_version=>1
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\3053\306E\8A8D\8A3C\30B9\30AD\30FC\30E0\3067\306F\3001\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30E6\30FC\30B6\30FC(\30B9\30AD\30FC\30DE)\306F\30ED\30FC\30AB\30EB\30FB\30C7\30FC\30BF\30D9\30FC\30B9\306B\5B58\5728\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\3053\306E\65B9\6CD5\3092\4F7F\7528\3059\308B\5834\5408\3001\30E6\30FC\30B6\30FC\306E\8A8D\8A3C\306B\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30A2\30AB\30A6\30F3\30C8\306E\30E6\30FC\30B6\30FC\540D\304A\3088\3073\30D1\30B9\30EF\30FC\30C9\304C\4F7F\7528\3055\308C\307E\3059\3002')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/ldap
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(707764939992010930.442)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'LDAP'
,p_display_name=>unistr('LDAP\30C7\30A3\30EC\30AF\30C8\30EA')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','LDAP'),'')
,p_api_version=>1
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('LDAP\30B5\30FC\30D0\30FC\3078\306E\8A8D\8A3C\30EA\30AF\30A8\30B9\30C8\306B\3088\308B\30E6\30FC\30B6\30FC/\30D1\30B9\30EF\30FC\30C9\306E\8A8D\8A3C\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708018036276066565.442)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\30DB\30B9\30C8')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('LDAP\30C7\30A3\30EC\30AF\30C8\30EA\30FB\30B5\30FC\30D0\30FC\306E\30DB\30B9\30C8\540D\3067\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708026427403073465.442)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\30DD\30FC\30C8')
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>6
,p_max_length=>10
,p_is_translatable=>false
,p_help_text=>unistr('LDAP\30C7\30A3\30EC\30AF\30C8\30EA\30FB\30DB\30B9\30C8\306E\30DD\30FC\30C8\756A\53F7\3067\3059\3002\30C7\30D5\30A9\30EB\30C8\5024\306F389\3067\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708041750260080084.442)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('SSL\306E\4F7F\7528')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NO_SSL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('SSL\3092\4F7F\7528\3057\3066LDAP\30C7\30A3\30EC\30AF\30C8\30EA\306B\30D0\30A4\30F3\30C9\3059\308B\304B\3069\3046\304B\3092\9078\629E\3057\3066\304F\3060\3055\3044\3002\300C\8A8D\8A3C\4ED8\304DSSL\300D\304C\9078\629E\3055\308C\3066\3044\308B\5834\5408\3001\30A6\30A9\30EC\30C3\30C8\3092&PRODUCT_NAME.\30A4\30F3\30B9\30BF\30F3\30B9\306B\69CB\6210\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(708049024764082165.442)
,p_plugin_attribute_id=>wwv_flow_api.id(708041750260080084.442)
,p_display_sequence=>10
,p_display_value=>'SSL'
,p_return_value=>'SSL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(708053230651083932.442)
,p_plugin_attribute_id=>wwv_flow_api.id(708041750260080084.442)
,p_display_sequence=>20
,p_display_value=>unistr('\8A8D\8A3C\4ED8\304DSSL')
,p_return_value=>'SSL_AUTH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(708057433075084636.442)
,p_plugin_attribute_id=>wwv_flow_api.id(708041750260080084.442)
,p_display_sequence=>30
,p_display_value=>unistr('SSL\306A\3057')
,p_return_value=>'NO_SSL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708170045804107167.442)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\8B58\5225\540D(DN)\6587\5B57\5217')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5B8C\5168\306ADN\3092\4F7F\7528\3059\308B\5834\5408\306FDBMS_LDAP.SIMPLE_BIND_S\306B\5B8C\5168\4FEE\98FE\8B58\5225\540D(DN)\6587\5B57\5217\3092\69CB\7BC9\3059\308B\305F\3081\306B\4F7F\7528\3055\308C\308B\30D1\30BF\30FC\30F3\3092\3001\975E\5B8C\5168\306ADN\3092\4F7F\7528\3059\308B\5834\5408\306F\691C\7D22\30D9\30FC\30B9\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002<strong>%LDAP_USER%</strong>\3092\30E6\30FC\30B6\30FC\540D\306E\30D7\30EC\30FC\30B9\30DB\30EB\30C0\30FC\3068\3057\3066\4F7F\7528\3057\3066\304F\3060\3055\3044\3002\4F8B:'),
'<p>',
unistr('<strong>\5B8C\5168\306ADNDN</strong>'),
'</p>',
'<p>',
'cn=%LDAP_USER%,l=amer,dc=yourdomain,dc=com',
'</p>',
'<p>',
unistr('<strong>\975E\5B8C\5168\306A DN (\691C\7D22\30D9\30FC\30B9)</strong>'),
'</p>',
'<p>',
'dc=yourdomain,dc=com',
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708104537708095412.442)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\5B8C\5168\306A\8B58\5225\540D(DN)\306E\4F7F\7528')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('LDAP\8B58\5225\540D(DN)\6587\5B57\5217\304C\5B8C\5168\304B\975E\5B8C\5168\304B\3092\9078\629E\3057\3066\304F\3060\3055\3044\3002\975E\5B8C\5168\306E\5834\5408\3001LDAP\8B58\5225\540D(DN)\306F\691C\7D22\30D9\30FC\30B9\3067\3001\691C\7D22\30D5\30A3\30EB\30BF\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708207443165115942.442)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\691C\7D22\30D5\30A3\30EB\30BF')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(708104537708095412.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5B8C\5168\306A\8B58\5225\540D(DN)\3092\4F7F\7528\3057\306A\3044\5834\5408\306F\3001\691C\7D22\30D5\30A3\30EB\30BF\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002\30E6\30FC\30B6\30FC\540D\306E\30D7\30EC\30FC\30B9\30DB\30EB\30C0\30FC\3068\3057\3066<strong>%LDAP_USER%</strong>\3092\4F7F\7528\3057\307E\3059\3002\6B21\306B\4F8B\3092\793A\3057\307E\3059\3002'),
'</p>',
'<p><pre>cn=%LDAP_USER%</pre></p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708300825765129776.442)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('LDAP\30E6\30FC\30B6\30FC\540D\7DE8\96C6\30D5\30A1\30F3\30AF\30B7\30E7\30F3')
,p_attribute_type=>'PLSQL FUNCTION BODY'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('LDAP\30C7\30A3\30EC\30AF\30C8\30EA\306E\30A8\30F3\30C8\30EA\307E\305F\306FLDAP\30E6\30FC\30B6\30FC\540D\306B\5B8C\5168\306B\9069\5408\3057\305F\5F62\5F0F\306B\3001\30E6\30FC\30B6\30FC\540D\3092\5909\63DB\3059\308B\305F\3081\306B\5B9F\884C\3059\308B\8FFD\52A0\30B3\30FC\30C9\3092\6307\5B9A\3067\304D\307E\3059\3002'),
unistr('\30D0\30A4\30F3\30C9\5909\6570:USERNAME\306B\306F\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\6307\5B9A\3057\305F\540D\524D\304C\542B\307E\308C\307E\3059\3002'),
unistr('\305F\3068\3048\3070\3001\6B21\306E\30B3\30FC\30C9\306FDN\6587\5B57\5217\306E\3059\3079\3066\306E\300C.\300D\3092\300C_\300D\306B\7F6E\63DB\3059\308B\30D5\30A1\30F3\30AF\30B7\30E7\30F3\3092\30B3\30FC\30EB\3057\307E\3059:</p>'),
'',
'<p><pre>',
'return apex_custom_auth.ldap_dnprep(p_username => :USERNAME);',
'</pre></p>',
'',
unistr('<p>&PRODUCT_NAME.\306F\3001\8FD4\3055\308C\305F\30E6\30FC\30B6\30FC\540D\3092\8A8D\8A3C\5C5E\6027<strong>\300C\30E6\30FC\30B6\30FC\540D\30A8\30B9\30B1\30FC\30D7\300D</strong>\306B\57FA\3065\3044\3066\30A8\30B9\30B1\30FC\30D7\3057\307E\3059\3002')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(38288205752186126.442)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\30E6\30FC\30B6\30FC\540D\30A8\30B9\30B1\30FC\30D7')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STD'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('LDAP\8B58\5225\540D\3068\691C\7D22\6587\5B57\5217\3067<strong>%LDAP_USER%</strong>\3092\7F6E\63DB\3059\308B\524D\306B\3001&PRODUCT_NAME.\306F'),
unistr('\30E6\30FC\30B6\30FC\540D\306E\4E2D\306E\7279\6B8A\6587\5B57\3092\81EA\52D5\7684\306B\30A8\30B9\30B1\30FC\30D7\3067\304D\307E\3059\3002'),
'<p/>',
unistr('\30A8\30B9\30B1\30FC\30D7\306B\4F7F\7528\3067\304D\308B\30EB\30FC\30EB\306F\6B21\306E\3068\304A\308A\3067\3059\3002'),
'<ul>',
unistr('<li><strong>\6A19\6E96</strong>: '),
unistr('RFC 4514 (\8B58\5225\540D)\3068RFC 4515 (\691C\7D22\6587\5B57\5217)\306B\57FA\3065\3044\3066\7279\6B8A\6587\5B57\3092\30A8\30B9\30B1\30FC\30D7\3057\307E\3059\3002'),
unistr('\52A0\3048\3066\3001Unicode\6587\5B57\3082\30A8\30B9\30B1\30FC\30D7\3057\307E\3059\3002'),
unistr('\3053\308C\306F\6700\3082\30BB\30AD\30E5\30A2\306A\8A2D\5B9A\3067\3059\304C\3001\4E00\90E8\306ELDAP\30B5\30FC\30D0\30FC\3067\306F\554F\984C\306E\539F\56E0\306B\306A\308B\3053\3068\304C\3042\308A\307E\3059\3002</li>'),
unistr('<li><strong>\7279\6B8A\6587\5B57\306E\307F</strong>: '),
unistr('RFC 4514 (\8B58\5225\540D)\3068RFC 4515 (\691C\7D22\6587\5B57\5217)\306B\57FA\3065\3044\3066\7279\6B8A\6587\5B57\3092\30A8\30B9\30B1\30FC\30D7\3057\307E\3059\3002'),
unistr('Unicode\6587\5B57\306F\30A8\30B9\30B1\30FC\30D7\3057\307E\305B\3093\3002</li>'),
unistr('<li><strong>\30A8\30B9\30B1\30FC\30D7\306A\3057</strong>: '),
unistr('\3069\306E\6587\5B57\3082\30A8\30B9\30B1\30FC\30D7\3057\307E\305B\3093\3002'),
unistr('<strong>\30E6\30FC\30B6\30FC\540D\7DE8\96C6\30D5\30A1\30F3\30AF\30B7\30E7\30F3</strong>\3092\63A1\7528\3057\3066\3059\3067\306B'),
unistr('\30E6\30FC\30B6\30FC\540D\3092\30A8\30B9\30B1\30FC\30D7\3057\3066\3044\308B(\305F\3068\3048\3070\3001apex_escape.ldap_dn\3001apex_escape.ldap_search_filter\306A\3069)'),
unistr('\306E\3067\306A\3044\304B\304E\308A\3001\3053\306E\8A2D\5B9A\306F\30BB\30AD\30E5\30A2\3067\306A\3044\53EF\80FD\6027\304C\3042\308A\307E\3059\3002</li>'),
'</ul>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(38288513717188434.442)
,p_plugin_attribute_id=>wwv_flow_api.id(38288205752186126.442)
,p_display_sequence=>10
,p_display_value=>unistr('\6A19\6E96')
,p_return_value=>'STD'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(38288919604190164.442)
,p_plugin_attribute_id=>wwv_flow_api.id(38288205752186126.442)
,p_display_sequence=>20
,p_display_value=>unistr('\7279\6B8A\6587\5B57\306E\307F')
,p_return_value=>'ONLY'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(38289324453191614.442)
,p_plugin_attribute_id=>wwv_flow_api.id(38288205752186126.442)
,p_display_sequence=>30
,p_display_value=>unistr('\30A8\30B9\30B1\30FC\30D7\306A\3057')
,p_return_value=>'NO'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/ias_sso
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(707826526617016488.442)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'IAS_SSO'
,p_display_name=>'Oracle Application Server Single Sign-On'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','IAS_SSO'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Oracle AS Single Sign-On(SSO)\30B5\30FC\30D0\30FC\306B\8A8D\8A3C\3092\59D4\8B72\3057\307E\3059\3002\3053\306E\8A8D\8A3C\30B9\30AD\30FC\30E0\3092\4F7F\7528\3059\308B\306B\306F\3001\30B5\30A4\30C8\304CSSO\30B5\30FC\30D0\30FC\306B\30D1\30FC\30C8\30CA\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3068\3057\3066\767B\9332\3055\308C\3066\3044\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(707874032982027788.442)
,p_plugin_id=>wwv_flow_api.id(707826526617016488.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\30D1\30FC\30C8\30CA\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\540D')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>40
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Oracle Application Server Single Sign-On\3067\8A8D\8A3C\3057\3001\3054\4F7F\7528\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304CSSO\306B\767B\9332\6E08\306E\30D1\30FC\30C8\30CA\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\5834\5408\306F\3001\30D1\30FC\30C8\30CA\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092SSO\306B\767B\9332\3057\305F\969B\306B\4F7F\7528\3057\305F\540D\524D\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002'),
'</p>',
'<p>',
unistr('&PRODUCT_NAME.\306B\3088\3063\3066\767B\9332\6E08\306E\30D1\30FC\30C8\30CA\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\306A\3063\3066\3044\308B\5834\5408\306F\3001\3053\306E\30D5\30A3\30FC\30EB\30C9\3092\7A7A\767D\306E\307E\307E\306B\3057\3066\304F\3060\3055\3044\3002'),
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(477693327944088403.442)
,p_plugin_id=>wwv_flow_api.id(707826526617016488.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('SSO\30B5\30FC\30D0\30FC\306E\30ED\30B0\30A2\30A6\30C8URL')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>60
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30B7\30F3\30B0\30EB\30FB\30B5\30A4\30F3\30AA\30F3\30FB\30B5\30FC\30D0\30FC\306E\30ED\30B0\30A2\30A6\30C8\30FB\30D1\30B9\3092\5165\529B\3057\307E\3059\3002\305F\3068\3048\3070\3001'),
unistr('<em>https://login.example.com/sso/logout</em>\306A\3069\3067\3059\3002'),
unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30ED\30B0\30A2\30A6\30C8\6642\306B\3001&PRODUCT_NAME.\306F\3053\306E\5024\3092\4F7F\7528\3057\3066''?p_done_url=''\3068\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30ED\30B0\30A4\30F3URL\3092\9023\7D50\3057\3001\751F\6210\3055\308C\308BURL\3092\4F7F\7528\3057\3066\30B7\30F3\30B0\30EB\30FB\30B5\30A4\30F3\30AA\30F3\304B\3089\30ED\30B0\30A2\30A6\30C8\3057\305F\4E0A\3067\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\30EA\30C0\30A4\30EC\30AF\30C8\3067\623B\308A\307E\3059\3002')))
);
end;
/
prompt --application/shared_components/plugins/authentication_type/dad
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(707880052029033247.442)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'DAD'
,p_display_name=>unistr('\8A8D\8A3C\306A\3057')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','DAD'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\73FE\5728\306E\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30E6\30FC\30B6\30FC\3092\63A1\7528\3057\307E\3059\3002\3053\308C\306F\3001\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30BB\30C3\30B7\30E7\30F3\30FB\30E6\30FC\30B6\30FC\306E\8A2D\5B9A\306B\57FA\672C\8A8D\8A3C\3092\4F7F\7528\3059\308Bmod_plsql DAD\69CB\6210\3068\7D44\307F\5408\305B\3066\4F7F\7528\3067\304D\307E\3059\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(38519294499392621.442)
,p_plugin_id=>wwv_flow_api.id(707880052029033247.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\30E6\30FC\30B6\30FC\540D')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_default_value=>'nobody'
,p_is_translatable=>false
,p_help_text=>unistr('&PRODUCT_NAME.\30BB\30C3\30B7\30E7\30F3\306E\30E6\30FC\30B6\30FC\540D\3092\5165\529B\3057\307E\3059\3002\7A7A\306E\5834\5408\3001&PRODUCT_NAME.\306F\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30BB\30C3\30B7\30E7\30F3\30FB\30E6\30FC\30B6\30FC(\901A\5E38\3001APEX_PUBLIC_USER)\3092\4F7F\7528\3057\307E\3059\3002')
);
end;
/
prompt --application/shared_components/plugins/region_type/css_calendar
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(716993259356536483.442)
,p_plugin_type=>'REGION TYPE'
,p_name=>'CSS_CALENDAR'
,p_display_name=>unistr('\30AB\30EC\30F3\30C0')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','CSS_CALENDAR'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:ESCAPE_OUTPUT:INIT_JAVASCRIPT_CODE:LAZY_LOADING'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\69D8\3005\306A\30AB\30EC\30F3\30C0\30FB\30D3\30E5\30FC\306B\65E5\4ED8\30D9\30FC\30B9\306E\30A8\30F3\30C8\30EA\3092\8868\793A\3057\307E\3059\3002\7D42\4E86\65E5\3092\542B\3081\308B\3068\3001\30AB\30EC\30F3\30C0\3067\671F\9593\30D9\30FC\30B9\306E\30A4\30D9\30F3\30C8\3092\8868\793A\3067\304D\307E\3059\3002\300C\30C9\30E9\30C3\30B0\30FB\30A2\30F3\30C9\30FB\30C9\30ED\30C3\30D7\300D\304C\6709\52B9\306A\5834\5408\3001\30AB\30EC\30F3\30C0\3067\30EC\30B3\30FC\30C9\3092\76F4\63A5\66F4\65B0\3059\308B\3053\3068\3082\3067\304D\307E\3059\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1992827406647874094.442)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.442)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Google\30AB\30EC\30F3\30C0API\30AD\30FC[\975E\63A8\5968]')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>255
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5185\306E\30AB\30EC\30F3\30C0\3092Google\30AB\30EC\30F3\30C0\30FB\30C7\30FC\30BF\3068\7D71\5408\3067\304D\308B\3088\3046\306B\3059\308B\305F\3081\306B\3001Google\30AB\30EC\30F3\30C0API\30AD\30FC\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716993576597543647.442)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>5
,p_prompt=>unistr('\958B\59CB\65E5\5217')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>unistr('\3053\306E\30AB\30EC\30F3\30C0\306B\8868\793A\3055\308C\308B\30A4\30D9\30F3\30C8\306E\958B\59CB\65E5\3092\4FDD\6301\3059\308B\5217\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716993872715545529.442)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>unistr('\7D42\4E86\65E5\5217')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>unistr('\3053\306E\30AB\30EC\30F3\30C0\306B\8868\793A\3055\308C\308B\30A4\30D9\30F3\30C8\306E\7D42\4E86\65E5\3092\4FDD\6301\3059\308B\5217\3092\9078\629E\3057\307E\3059\3002\3053\306E\5C5E\6027\304C\6307\5B9A\3055\308C\3066\3044\308B\5834\5408\3001\30AB\30EC\30F3\30C0\306B\671F\9593\30D9\30FC\30B9\306E\30A4\30D9\30F3\30C8\304C\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716994160638551031.442)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>2
,p_prompt=>unistr('\8868\793A\5217')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:INTERVAL_Y2M:INTERVAL_D2S'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>unistr('\3053\306E\30AB\30EC\30F3\30C0\3067\30A4\30D9\30F3\30C8\306B\5BFE\3057\3066\8868\793A\3055\308C\308B\30C6\30AD\30B9\30C8\3092\4FDD\6301\3059\308B\5217\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716994453521554330.442)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>12
,p_prompt=>unistr('\4E3B\30AD\30FC\5217')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_column_data_types=>'VARCHAR2:NUMBER:ROWID'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30AB\30EC\30F3\30C0\30FB\30A4\30D9\30F3\30C8\306E\4E3B\30AD\30FC\5024\3092\4FDD\6301\3059\308B\5217\3092\9078\629E\3057\307E\3059\3002\8868\306B\8907\6570\306E\90E8\5206\304B\3089\6210\308B\4E3B\30AD\30FC\304C\3042\308B\5834\5408\3001<strong>ROWID</strong>\3092\9078\629E\3057\307E\3059\3002</p>'),
unistr('<p>\3053\306E\5217\306E\5024\306F\3001<code>APEX$PK_VALUE</code>\7F6E\63DB\5909\6570\3067\8FD4\3055\308C\307E\3059\3002\3053\306E\5909\6570\3092<em>\300C\30B3\30FC\30C9\306E\30C9\30E9\30C3\30B0\30FB\30A2\30F3\30C9\30FB\30C9\30ED\30C3\30D7\300D</em>\5C5E\6027\3067\4F7F\7528\3057\3001\30AB\30EC\30F3\30C0\3067\306E\30C9\30E9\30C3\30B0\30FB\30A2\30F3\30C9\30FB\30C9\30ED\30C3\30D7\64CD\4F5C\306E\5F8C\306B\66F4\65B0\3055\308C\308B\30EC\30B3\30FC\30C9\3092\8B58\5225\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716994772918560561.442)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>65
,p_prompt=>unistr('\30EA\30F3\30AF\306E\8868\793A/\7DE8\96C6')
,p_attribute_type=>'LINK'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_reference_scope=>'ROW'
,p_help_text=>unistr('<p>\30E6\30FC\30B6\30FC\304C\65E2\5B58\30A8\30F3\30C8\30EA\3092\30AF\30EA\30C3\30AF\3057\305F\3068\304D\306B\547C\3073\51FA\3055\308C\308B\30BF\30FC\30B2\30C3\30C8\30FB\30DA\30FC\30B8\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716995064292564584.442)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\30EA\30F3\30AF\306E\4F5C\6210')
,p_attribute_type=>'LINK'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30E6\30FC\30B6\30FC\304C\7A7A\306E\30BB\30EB\3001\307E\305F\306F\65E2\5B58\30AB\30EC\30F3\30C0\30FB\30A8\30F3\30C8\30EA\306E\5916\5074\3092\30AF\30EA\30C3\30AF\3057\305F\3068\304D\306B\547C\3073\51FA\3055\308C\308B\30BF\30FC\30B2\30C3\30C8\30FB\30DA\30FC\30B8\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002</p>'),
unistr('<p>\9078\629E\3057\305F\65E5\4ED8\3092\30AB\30EC\30F3\30C0\304B\3089\30BF\30FC\30B2\30C3\30C8\30FB\30DA\30FC\30B8\306B\6E21\3059\305F\3081\306B\3001\7279\6B8A\306A\30AB\30EC\30F3\30C0\4EE3\66FF\5909\6570<pre>&APEX$NEW_START_DATE.</pre>\304A\3088\3073<pre>&APEX$NEW_END_DATE.</pre>\3092\4F7F\7528\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716995378729573099.442)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>45
,p_prompt=>unistr('\30C9\30E9\30C3\30B0\30FB\30A2\30F3\30C9\30FB\30C9\30ED\30C3\30D7')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(716994453521554330.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30C9\30E9\30C3\30B0\30FB\30A2\30F3\30C9\30FB\30C9\30ED\30C3\30D7\64CD\4F5C\304C\3053\306E\30AB\30EC\30F3\30C0\3067\8A31\53EF\3055\308C\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002</p>'),
unistr('<p><em>\30CE\30FC\30C8: \30C9\30E9\30C3\30B0\30FB\30A2\30F3\30C9\30FB\30C9\30ED\30C3\30D7\304C\6709\52B9\306A\5834\5408\3001\3053\306E\30AB\30EC\30F3\30C0\3092\8868\793A\3059\308B\6A29\9650\3092\6301\3064\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\3001\30AB\30EC\30F3\30C0\30FB\30A8\30F3\30C8\30EA\3092\66F4\65B0\3059\308B\6A29\9650\3082\6301\3061\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716995668377577896.442)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>55
,p_prompt=>unistr('PL/SQL\30B3\30FC\30C9\306E\30C9\30E9\30C3\30B0\30FB\30A2\30F3\30C9\30FB\30C9\30ED\30C3\30D7')
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(716995378729573099.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\958B\59CB\65E5\306E\307F\3092\4F7F\7528\3057\305F\4F8B(\671F\9593\30D9\30FC\30B9\3067\306A\3044\30A4\30D9\30F3\30C8\306E\5834\5408)</dt>'),
'<dd><pre>',
'begin',
'    update emp',
'       set hiredate = to_date(:APEX$NEW_START_DATE, ''YYYYMMDDHH24MISS'')',
'     where empno = :APEX$PK_VALUE;',
'end;',
'</pre></dd>',
unistr('<dt>\958B\59CB\65E5\304A\3088\3073\7D42\4E86\65E5\3092\4F7F\7528\3057\305F\4F8B(\671F\9593\30D9\30FC\30B9\306E\30A4\30D9\30F3\30C8\306E\5834\5408)</dt>'),
'<dd><pre>',
'begin',
'    update projects',
'       set start_date = to_date(:APEX$NEW_START_DATE, ''YYYYMMDDHH24MISS''),',
'           end_date = to_date(:APEX$NEW_END_DATE, ''YYYYMMDDHH24MISS'')',
'     where id = :APEX$PK_VALUE;',
'end;',
'</pre></dd>',
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30C9\30E9\30C3\30B0\30FB\30A2\30F3\30C9\30FB\30C9\30ED\30C3\30D7\3092\4F7F\7528\3057\3066\30AB\30EC\30F3\30C0\30FB\30A8\30F3\30C8\30EA\304C\66F4\65B0\3055\308C\305F\3068\304D\306B\3001\57FA\790E\3068\306A\308B\8868\307E\305F\306F\66F4\65B0\53EF\80FD\306A\30D3\30E5\30FC\3092\66F4\65B0\3059\308BPL/SQL\30B3\30FC\30C9\3092\5165\529B\3057\307E\3059\3002</p>'),
unistr('<p>\3053\306E\30AB\30EC\30F3\30C0\306B(\7D42\4E86\65E5\306E\5217\3092\9078\629E\3057\3066)\671F\9593\30D9\30FC\30B9\306E\30A4\30D9\30F3\30C8\304C\8868\793A\3055\308C\308B\5834\5408\3001PL/SQL\30B3\30FC\30C9\3067\3053\306E\5024\3082\66F4\65B0\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\30A4\30D9\30F3\30C8\5168\4F53\304C\30C9\30E9\30C3\30B0\3055\308C\305F\5834\5408\3001\7D42\4E86\65E5\306B\306F\73FE\5728\306E\671F\9593\304C\4FDD\6301\3055\308C\307E\3059\3002\30A4\30D9\30F3\30C8\306E\7D42\4E86\304C\30C9\30E9\30C3\30B0\3055\308C\305F\5834\5408\3001\30A4\30D9\30F3\30C8\306E\671F\9593\304C\66F4\65B0\3055\308C\307E\3059\3002\3053\306E\3088\3046\306A\5834\5408\3001\958B\59CB\65E5\306F\5909\66F4\3055\308C\307E\305B\3093\304C\3001\5909\66F4\3055\308C\305F\671F\9593\3092\53CD\6620\3057\3066\7D42\4E86\65E5\306F\66F4\65B0\3055\308C\307E\3059\3002</p>'),
unistr('<p>\30AB\30EC\30F3\30C0\306E\7F6E\63DB\5909\6570\306F\6B21\306E\3068\304A\308A\3067\3059\3002</p>'),
'<dl>',
'  <dt>APEX$NEW_START_DATE</dt>',
unistr('    <dd>\5909\66F4\3055\308C\305F\958B\59CB\65E5\3092\8FD4\3057\307E\3059\3002\3053\306E\30AB\30EC\30F3\30C0\306E<em>\300C\6642\9593\306E\8868\793A\300D</em>\304C<strong>\300C\3044\3044\3048\300D</strong>\306E\5834\5408\3067\3082\3001\65E5\4ED8\66F8\5F0F\306F\3001<code>''YYYYMMDDHH24MISS''</code>\3067\3059\3002</dd>'),
'  <dt>APEX$NEW_END_DATE</dt>',
unistr('    <dd>\671F\9593\30D9\30FC\30B9\306E\30A4\30D9\30F3\30C8\306E\5909\66F4\3055\308C\305F\7D42\4E86\65E5\3092\8FD4\3057\307E\3059\3002\3053\306E\30AB\30EC\30F3\30C0\306E<em>\300C\6642\9593\306E\8868\793A\300D</em>\304C<strong>\300C\3044\3044\3048\300D</strong>\306E\5834\5408\3067\3082\3001\65E5\4ED8\66F8\5F0F\306F\3001<code>''YYYYMMDDHH24MISS''</code>\3067\3059\3002</dd>'),
'  <dt>APEX$PK_VALUE</dt>',
unistr('    <dd>\4E3B\30AD\30FC\5217\3067\6307\5B9A\3055\308C\305F\5217\306E\5024\3092\8FD4\3057\307E\3059\3002</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716995977422588893.442)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>40
,p_prompt=>unistr('\8FFD\52A0\306E\30AB\30EC\30F3\30C0\30FB\30D3\30E5\30FC')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'list:navigation'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(739025333221911743.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8868\793A\3059\308B\8FFD\52A0\306E\30AB\30EC\30F3\30C0\30FB\30D3\30E5\30FC\3092\9078\629E\3057\307E\3059\3002\6708\6B21\30D3\30E5\30FC\306F\5E38\306B\8868\793A\3055\308C\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8: \300C\6642\9593\306E\8868\793A\300D\306B<strong>\300C\3044\3044\3048\300D</strong>\3068\6307\5B9A\3055\308C\3066\3044\308B\5834\5408\3001\9031\6B21\304A\3088\3073\65E5\6B21\30D3\30E5\30FC\306F\4F7F\7528\3067\304D\307E\305B\3093\3002</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(484632936569874213.442)
,p_plugin_attribute_id=>wwv_flow_api.id(716995977422588893.442)
,p_display_sequence=>40
,p_display_value=>unistr('\30EA\30B9\30C8')
,p_return_value=>'list'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(484633358657877168.442)
,p_plugin_attribute_id=>wwv_flow_api.id(716995977422588893.442)
,p_display_sequence=>50
,p_display_value=>unistr('\30CA\30D3\30B2\30FC\30B7\30E7\30F3')
,p_return_value=>'navigation'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716997678919603353.442)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('\30A8\30AF\30B9\30DD\30FC\30C8')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30AB\30EC\30F3\30C0\306E\4E0B\90E8\306B\8868\793A\3059\308B\30A8\30AF\30B9\30DD\30FC\30C8\30FB\30EA\30F3\30AF\3092\9078\629E\3057\307E\3059\3002</p>'),
unistr('<p><em>\30CE\30FC\30C8: \3053\308C\306B\3088\3063\3066\30011\3064\306E\30AB\30EC\30F3\30C0\30FB\30A8\30F3\30C8\30EA\3067\306F\306A\304F\3001\73FE\5728\8868\793A\3055\308C\3066\3044\308B\3059\3079\3066\306E\30AB\30EC\30F3\30C0\30FB\30A8\30F3\30C8\30EA\304C\30A8\30AF\30B9\30DD\30FC\30C8\3055\308C\307E\3059\3002</em></p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(716999168568608195.442)
,p_plugin_attribute_id=>wwv_flow_api.id(716997678919603353.442)
,p_display_sequence=>10
,p_display_value=>'CSV'
,p_return_value=>'CSV'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(716997976116604645.442)
,p_plugin_attribute_id=>wwv_flow_api.id(716997678919603353.442)
,p_display_sequence=>30
,p_display_value=>'iCal'
,p_return_value=>'ICAL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(716998373959605713.442)
,p_plugin_attribute_id=>wwv_flow_api.id(716997678919603353.442)
,p_display_sequence=>40
,p_display_value=>'XML'
,p_return_value=>'XML'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716999779985618067.442)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>40
,p_prompt=>unistr('\30AB\30EC\30F3\30C0\30FB\30D3\30E5\30FC\3068\30CA\30D3\30B2\30FC\30B7\30E7\30F3')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'month:week:day:list:navigation'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(739025333221911743.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>\8868\793A\3059\308B\30AB\30EC\30F3\30C0\30FB\30D3\30E5\30FC\3092\9078\629E\3057\307E\3059\3002<strong>\300C\65E5\300D</strong>\3001<strong>\300C\9031\300D</strong>\307E\305F\306F<strong>\300C\6708\300D</strong>\306E\3046\3061\5C11\306A\304F\3068\30821\3064\3092\9078\629E\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\9078\629E\3057\306A\3044\5834\5408\3001\30AB\30EC\30F3\30C0\306B\306F\81EA\52D5\7684\306B<strong>\6708\6B21</strong>\30D3\30E5\30FC\304C\8868\793A\3055\308C\307E\3059\3002</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(772524462334484489.442)
,p_plugin_attribute_id=>wwv_flow_api.id(716999779985618067.442)
,p_display_sequence=>10
,p_display_value=>unistr('\6708')
,p_return_value=>'month'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(717000472653621483.442)
,p_plugin_attribute_id=>wwv_flow_api.id(716999779985618067.442)
,p_display_sequence=>20
,p_display_value=>unistr('\9031')
,p_return_value=>'week'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(717000871143622145.442)
,p_plugin_attribute_id=>wwv_flow_api.id(716999779985618067.442)
,p_display_sequence=>30
,p_display_value=>unistr('\65E5')
,p_return_value=>'day'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(696140132483024062.442)
,p_plugin_attribute_id=>wwv_flow_api.id(716999779985618067.442)
,p_display_sequence=>35
,p_display_value=>unistr('\30EA\30B9\30C8')
,p_return_value=>'list'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(717001267693623757.442)
,p_plugin_attribute_id=>wwv_flow_api.id(716999779985618067.442)
,p_display_sequence=>40
,p_display_value=>unistr('\30CA\30D3\30B2\30FC\30B7\30E7\30F3')
,p_return_value=>'navigation'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(718537383340695404.442)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>unistr('Google\30AB\30EC\30F3\30C0ID')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>255
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(5924531429537178.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'3'
,p_examples=>unistr('<p>Google\30AB\30EC\30F3\30C0ID: abc123@group.calendar.google.com</p>')
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30AB\30EC\30F3\30C0\306B\8868\793A\3059\308B\30AB\30EC\30F3\30C0\30FB\30C7\30FC\30BF\30FB\30D5\30A3\30FC\30C9\306EGoogle\30AB\30EC\30F3\30C0ID\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002</p>'),
unistr('<p>Google\30AB\30EC\30F3\30C0\306E\30BB\30AD\30E5\30EA\30C6\30A3\4E0A\306E\5236\7D04\306B\3088\308A\3001\3053\308C\3089\306E\30AB\30EC\30F3\30C0\306F\3001\30D1\30D6\30EA\30C3\30AF\30FB\30AB\30EC\30F3\30C0\3067\3042\308B\304B\3001\3053\306E\30AB\30EC\30F3\30C0\306E\3059\3079\3066\306E\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\4F7F\7528\3067\304D\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>'),
unistr('<p><em>\30CE\30FC\30C8: Google\30AB\30EC\30F3\30C0\3092\6B63\5E38\306B\6A5F\80FD\3055\305B\308B\306B\306F\3001Google\30AB\30EC\30F3\30C0API\30AD\30FC\3092\5165\529B\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30AD\30FC\3092\8A2D\5B9A\3059\308B\306B\306F\3001\300C\5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8\300D\2192\300C\30B3\30F3\30DD\30FC\30CD\30F3\30C8\8A2D\5B9A\300D\2192\300C\30AB\30EC\30F3\30C0\300D\306E\9806\306B\9078\629E\3057\307E\3059\3002</em></p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(739025333221911743.442)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>15
,p_prompt=>unistr('\6642\9593\306E\8868\793A')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'N'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\65E5\4ED8\306E\6642\9593\90E8\5206\3092\8868\793A\3059\308B\304B\3069\3046\304B\3092\9078\629E\3057\307E\3059\3002</p>'),
unistr('<p>\300C\6642\9593\306E\8868\793A\300D\304C<strong>\300C\306F\3044\300D</strong>\306B\8A2D\5B9A\3055\308C\3066\3044\308B\5834\5408\306B\306E\307F\3001\9031\6B21\304A\3088\3073\65E5\6B21\30D3\30E5\30FC\304C\8868\793A\3055\308C\307E\3059\3002\958B\59CB\65E5\307E\305F\306F\7D42\4E86\65E5\306E\5217\306B\6642\9593\30B3\30F3\30DD\30FC\30CD\30F3\30C8\304C\542B\307E\308C\3066\3044\306A\3044\5834\5408\3001\3053\308C\3089\306F\5348\524D12:00\3068\3057\3066\8868\793A\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(163693512506908039.442)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>80
,p_prompt=>unistr('CSS\30AF\30E9\30B9')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_column_data_types=>'VARCHAR2'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30D7\30ED\30B8\30A7\30AF\30C8\30FB\30B9\30C6\30FC\30BF\30B9\306B\57FA\3065\3044\3066\30AB\30EC\30F3\30C0\3092\30B9\30BF\30A4\30EB\8A2D\5B9A</p>'),
'<pre>',
'select ID,',
'       START_DATE,',
'       END_DATE,',
'       TASK_NAME,',
'       <strong>case STATUS',
'           when ''Open''    then ''apex-cal-green''',
'           when ''Pending'' then ''apex-cal-yellow''',
'           when ''Closed''  then ''apex-cal-red''',
'           when ''On-Hold'' then ''apex-cal-black''',
'       end as css_class,</strong>',
'       ASSIGNED_TO as supplemental_info',
'  from PROJECTS',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\3053\306E\30AB\30EC\30F3\30C0\306B\8868\793A\3055\308C\308B\30A4\30D9\30F3\30C8\306E\30B9\30BF\30A4\30EB\3092\8A2D\5B9A\3059\308B\305F\3081\306ECSS\30AF\30E9\30B9\3092\542B\3081\308B\5217\3092\9078\629E\3057\3066\304F\3060\3055\3044\3002<br>'),
unistr('\591A\6570\306E\30C7\30D5\30A9\30EB\30C8\30FB\30AF\30E9\30B9\3092\4F7F\7528\3067\304D\307E\3059\3002'),
'<ul>',
'  <li>apex-cal-red</li>',
'  <li>apex-cal-cyan</li>',
'  <li>apex-cal-blue</li>',
'  <li>apex-cal-bluesky</li>',
'  <li>apex-cal-darkblue</li>',
'  <li>apex-cal-green</li>',
'  <li>apex-cal-yellow</li>',
'  <li>apex-cal-silver</li>',
'  <li>apex-cal-brown</li>',
'  <li>apex-cal-lime</li>',
'  <li>apex-cal-white</li>',
'  <li>apex-cal-gray</li>',
'  <li>apex-cal-black</li>',
'  <li>apex-cal-orange</li>',
'</ul>',
unistr('CSS\30AF\30E9\30B9\306E\8FFD\52A0\306B\95A2\3059\308B\30C9\30AD\30E5\30E1\30F3\30C8\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2604378152305541.442)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>unistr('REST Web\30B5\30FC\30D3\30B9(JSON)')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(5924531429537178.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'3'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30AB\30EC\30F3\30C0\306B\8868\793A\3059\308BRESTful Web\30B5\30FC\30D3\30B9\30FB\30D5\30A3\30FC\30C9\306EURL\3092\5165\529B\3057\307E\3059\3002\30AB\30EC\30F3\30C0\3067\306F\3001Oracle REST Data Services\306A\3069\306E\5916\90E8\30BD\30FC\30B9\304B\3089\53D6\5F97\3055\308C\305FJSON\30C7\30FC\30BF\3092\30EC\30F3\30C0\30EA\30F3\30B0\3067\304D\307E\3059\3002\3053\308C\3089\306EWeb\30B5\30FC\30D3\30B9\306F\30D1\30D6\30EA\30C3\30AF\3067\3042\308B\304B\3001\3053\306E\30AB\30EC\30F3\30C0\306E\3059\3079\3066\306E\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\4F7F\7528\53EF\80FD\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>'),
unistr('<p>JSON\30D5\30A3\30FC\30C9\306F\6B21\306E\3082\306E\3092\542B\3080\3088\3046\306B\30D5\30A9\30FC\30DE\30C3\30C8\3057\307E\3059\3002</p>'),
'<ol>',
unistr('<li>\30A4\30D9\30F3\30C8\914D\5217\306E\30EA\30B9\30C8 - <code>items</code></li>'),
unistr('<li>\5404\30A4\30D9\30F3\30C8\30FB\30AA\30D6\30B8\30A7\30AF\30C8 - <code>{ id, title, start, allday, end, description }</code><br>title\304A\3088\3073start\5C5E\6027\306F\5FC5\9808\3067\3059\3002</li>'),
'</ol>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2604471144293543.442)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>16
,p_display_sequence=>30
,p_prompt=>unistr('\88DC\8DB3\60C5\5831')
,p_attribute_type=>'HTML'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_reference_scope=>'ROW'
,p_examples=>'&EMPNO.'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30EA\30B9\30C8\30FB\30D3\30E5\30FC\304A\3088\3073\30C4\30FC\30EB\30C1\30C3\30D7\306B\8868\793A\3059\308B\8FFD\52A0\306EHTML\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002&COLUMN.\69CB\6587\3092\4F7F\7528\3057\3066\3001HTML\306E\5217\306E\5024\3092\8868\793A\3057\3066\304F\3060\3055\3044\3002</p>'),
unistr('<p>\30CE\30FC\30C8: \3053\306E\88DC\8DB3\60C5\5831\3092\6708\3001\9031\304A\3088\3073\65E5\30D3\30E5\30FC\306B\8868\793A\3059\308B\305F\3081\3001\300C\30C4\30FC\30EB\30C1\30C3\30D7\306E\8868\793A\300D\3092<strong>\300C\306F\3044\300D</strong>\306B\8A2D\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(491266533374023782.442)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>17
,p_display_sequence=>75
,p_prompt=>unistr('\9031\672B\3092\8868\793A')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('\3053\306E\30AB\30EC\30F3\30C0\3067\571F\66DC\65E5\304A\3088\3073\65E5\66DC\65E5\3092\8868\793A\3059\308B\304B\3069\3046\304B\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(518889601605918244.442)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>18
,p_display_sequence=>20
,p_prompt=>unistr('\6642\9593\66F8\5F0F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'00'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(739025333221911743.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>\3053\306E\30AB\30EC\30F3\30C0\306E\30A4\30D9\30F3\30C8\306E\6642\9593\90E8\5206\306E\8868\793A\306B\4F7F\7528\3055\308C\308B\6642\9593\5F62\5F0F\3092\9078\629E\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(518893959287938933.442)
,p_plugin_attribute_id=>wwv_flow_api.id(518889601605918244.442)
,p_display_sequence=>10
,p_display_value=>unistr('\30C7\30D5\30A9\30EB\30C8')
,p_return_value=>'00'
,p_help_text=>unistr('\300C\30B0\30ED\30FC\30D0\30EA\30BC\30FC\30B7\30E7\30F3\300D\306B\5165\529B\3055\308C\305F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30BF\30A4\30E0\30B9\30BF\30F3\30D7\66F8\5F0F\3092\4F7F\7528\3057\307E\3059\3002\3053\306E\5C5E\6027\304C\6307\5B9A\3055\308C\3066\3044\306A\3044\5834\5408\3001\30C7\30FC\30BF\30D9\30FC\30B9\306ENLS\8A2D\5B9A\304C\4F7F\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(518914467554939737.442)
,p_plugin_attribute_id=>wwv_flow_api.id(518889601605918244.442)
,p_display_sequence=>20
,p_display_value=>unistr('12\6642\9593')
,p_return_value=>'12'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>8:00 a.m.\30844:00 p.m.\306A\3069\306E\3088\3046\306Ba.m.(\30E9\30C6\30F3\8A9E\3067\6B63\5348\524D\3092\610F\5473\3059\308B<em>ante meridiem</em>\306B\7531\6765)\304A\3088\3073p.m.(\6B63\5348\5F8C\3092\610F\5473\3059\308B<em>post meridiem</em>\306B\7531\6765)\3092\542B\308012\6642\9593\8868\8A18\3092\4F7F\7528\3057\3066\6642\9593\3092\8868\793A\3057\307E\3059\3002</p>'),
unistr('<p>\5927\6587\5B57\3084\30D4\30EA\30AA\30C9\306A\3069\306Ea.m./p.m.\306E\5B9F\969B\306E\8868\793A\66F8\5F0F\306F\3001\30BF\30A4\30E0\30B9\30BF\30F3\30D7\66F8\5F0F\304B\3089\5C0E\51FA\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(518914796377940460.442)
,p_plugin_attribute_id=>wwv_flow_api.id(518889601605918244.442)
,p_display_sequence=>30
,p_display_value=>unistr('24\6642\9593')
,p_return_value=>'24'
,p_help_text=>unistr('08:00\308416:00\306A\3069\306E\3088\3046\306B24\6642\9593\8868\8A18\3092\4F7F\7528\3057\3066\6642\9593\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(623002076135066927.442)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>19
,p_display_sequence=>35
,p_prompt=>unistr('\30C4\30FC\30EB\30C1\30C3\30D7\306E\8868\793A')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30E6\30FC\30B6\30FC\304C\3053\306E\30AB\30EC\30F3\30C0\306E\30A4\30D9\30F3\30C8\306E\4E0A\306B\30AB\30FC\30BD\30EB\3092\5408\305B\308B\3068\304D\306B\30C4\30FC\30EB\30C1\30C3\30D7\3092\8868\793A\3059\308B\304B\3069\3046\304B\3092\9078\629E\3057\307E\3059\3002</p>'),
unistr('<p><em>\30C9\30ED\30C3\30D7\30FB\30C0\30A6\30F3\30FB\30C0\30A4\30A2\30ED\30B0\306B\306F\3001\30A4\30D9\30F3\30C8\540D\3001\88DC\8DB3\60C5\5831\304A\3088\3073\65E5\4ED8\306E\8A73\7D30\304C\8868\793A\3055\308C\307E\3059\3002</em></p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(673441164964154995.442)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>20
,p_display_sequence=>25
,p_prompt=>unistr('\6700\521D\306E1\6642\9593')
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'9'
,p_display_length=>2
,p_max_length=>2
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(739025333221911743.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('0\304B\308923\306E\9593\306E\6574\6570\3092\5165\529B\3057\3066\3001\9031\304A\3088\3073\65E5\306E\30AB\30EC\30F3\30C0\306B\8868\793A\3055\308C\308B\6700\521D\306E1\6642\9593\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1218336983535257968.442)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>21
,p_display_sequence=>70
,p_prompt=>unistr('\6700\5927\306E\30A4\30D9\30F3\30C8/\65E5')
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'10'
,p_display_length=>2
,p_max_length=>2
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6708\6B21\30D3\30E5\30FC\5185\306E\65E5\3054\3068\306B\8868\793A\3055\308C\308B\30A4\30D9\30F3\30C8\306E\6700\5927\6570\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002</p>'),
unistr('<p>\7279\5B9A\306E\65E5\306B\6307\5B9A\3055\308C\305F\6570\306E\30A4\30D9\30F3\30C8\3092\8D85\3048\3066\3044\308B\5834\5408\3001\305D\306E\65E5\306B\306F<strong>\300C\8A73\7D30 ...\300D</strong>\304C\542B\307E\308C\307E\3059\3002\3053\306E\30A2\30A4\30C6\30E0\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\305D\306E\7279\5B9A\306E\65E5\306E\3059\3079\3066\306E\30A4\30D9\30F3\30C8\3068\3068\3082\306B\30DD\30C3\30D7\30A2\30C3\30D7\30FB\30A6\30A3\30F3\30C9\30A6\304C\8868\793A\3055\308C\307E\3059\3002</p>')))
);
end;
/
begin
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2080058124058207989.442)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>22
,p_display_sequence=>32
,p_prompt=>unistr('\8907\6570\884C\30A4\30D9\30F3\30C8')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\300C\8868\793A\5217\300D\306E\30C6\30AD\30B9\30C8\9577\306B\57FA\3065\3044\3066\3001\30A4\30D9\30F3\30C8\3092\8907\6570\306E\884C\306B\308F\305F\3063\3066\8868\793A\3059\308B\306B\306F\3001<strong>\300C\306F\3044\300D</strong>\3092\9078\629E\3057\307E\3059\3002</p>'),
unistr('<p>\5404\30A4\30D9\30F3\30C8\3092\5358\4E00\306E\884C\306B\8868\793A\3057\3001\8868\793A\3067\304D\306A\3044\30C6\30AD\30B9\30C8\3092\5207\308A\6368\3066\308B\306B\306F\3001<strong>\300C\3044\3044\3048\300D</strong>\3092\9078\629E\3057\307E\3059\3002\5B8C\5168\306A\30C6\30AD\30B9\30C8\306F\30C4\30FC\30EB\30C1\30C3\30D7\306B\8868\793A\3055\308C\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8: \8907\6570\884C\30A4\30D9\30F3\30C8\306E\8A2D\5B9A\306F\3001\6708\6B21\30D3\30E5\30FC\5185\3067\306E\307F\4F7F\7528\3055\308C\307E\3059\3002\9031\6B21\30D3\30E5\30FC\304A\3088\3073\65E5\6B21\30D3\30E5\30FC\3067\306F\3001\30A4\30D9\30F3\30C8\306E\671F\9593\306B\3088\3063\3066\3001\8868\793A\3055\308C\308B\30A4\30D9\30F3\30C8\306E\9AD8\3055\304C\6C7A\5B9A\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(5924531429537178.442)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>23
,p_display_sequence=>1
,p_prompt=>unistr('\30D0\30FC\30B8\30E7\30F3')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>'FullCalendar 5'
,p_deprecated_values=>'3'
,p_help_text=>unistr('<p>FullCalendar 3\306F\975E\63A8\5968\306B\306A\3063\3066\304A\308A\3001\307E\3082\306A\304FFullCalendar 5\306B\7F6E\304D\63DB\3048\3089\308C\307E\3059\3002\5C06\6765\306E\30D0\30FC\30B8\30E7\30F3\3067\3054\4F7F\7528\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304C\4F7F\7528\3067\304D\306A\304F\306A\308B\30EA\30B9\30AF\3092\907F\3051\308B\305F\3081\306B\3001\3053\306E\5207\66FF\3048\3092\4ECA\3059\3050\306B\884C\3046\3053\3068\3092\304A\85A6\3081\3057\307E\3059\3002\30AB\30B9\30BF\30E0\521D\671F\5316Javascript\30B3\30FC\30C9\3092\4F7F\7528\3057\3066\3044\308B\5834\5408\306F\3001FullCalendar\306EAPI\304C\5909\66F4\3055\308C\3066\3044\308B\305F\3081\3001\3054\4F7F\7528\306E\30B3\30FC\30C9\3092\8ABF\6574\3059\308B\5FC5\8981\304C\751F\3058\308B\53EF\80FD\6027\304C\9AD8\3044\3053\3068\306B\6CE8\610F\3057\3066\304F\3060\3055\3044\3002</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(5925071337539542.442)
,p_plugin_attribute_id=>wwv_flow_api.id(5924531429537178.442)
,p_display_sequence=>10
,p_display_value=>unistr('FullCalendar 3 [\975E\63A8\5968]')
,p_return_value=>'3'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(848019138346305412.442)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.442)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function ( pOptions) {',
unistr('    pOptions.titleFormat      = "[Conference Schedule]";                                // \30AB\30B9\30BF\30E0\30FB\30BF\30A4\30C8\30EB'),
unistr('    pOptions.slotMinTime      = "07:00:00";                                             // minTime\524D\306E\30B9\30ED\30C3\30C8\306E\975E\8868\793A'),
unistr('    pOptions.slotMaxTime      = "18:00:00";                                             // maxTime\5F8C\306E\30B9\30ED\30C3\30C8\306E\975E\8868\793A'),
unistr('    pOptions.dayHeaderFormat  = { weekday: ''short'', month: ''numeric'', day: ''numeric'' }; // \9031\6B21\30D3\30E5\30FC\306E\5217\30D8\30C3\30C0\30FC'),
unistr('    pOptions.slotDuration     = "00:15:00";                                             // \30AB\30B9\30BF\30E0\30FB\30B9\30ED\30C3\30C8\671F\9593'),
unistr('    pOptions.weekNumbers      = true;                                                   // \9031\756A\53F7\306E\8868\793A'),
'    pOptions.weekText         = "CW";                                    ',
'    return pOptions;',
'}',
'</pre>'))
,p_help_text=>unistr('\6A19\6E96\306EFullCalendar\521D\671F\5316\5C5E\6027\3092\30AA\30FC\30D0\30FC\30E9\30A4\30C9\3059\308BJavaScript\95A2\6570\3092\5165\529B\3057\307E\3059\3002\3053\306E\95A2\6570\306F\3001\30D1\30E9\30E1\30FC\30BF\3068\3057\3066\30AB\30EC\30F3\30C0\521D\671F\5316\5C5E\6027\3092\542B\3080\30AA\30D6\30B8\30A7\30AF\30C8\3092\8FD4\3059\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(236983483525335070.442)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.442)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30D7\30ED\30B8\30A7\30AF\30C8\30FB\30B9\30C6\30FC\30BF\30B9\306B\57FA\3065\3044\3066\30AB\30EC\30F3\30C0\3092\30B9\30BF\30A4\30EB\8A2D\5B9A</p>,'),
'<pre>',
'select ID,',
'       START_DATE,',
'       END_DATE,',
'       TASK_NAME,',
'       <strong>case STATUS',
'           when ''Open''    then ''apex-cal-green''',
'           when ''Pending'' then ''apex-cal-yellow''',
'           when ''Closed''  then ''apex-cal-red''',
'           when ''On-Hold'' then ''apex-cal-black''',
'       end as css_class,</strong>',
'       ASSIGNED_TO as supplemental_info',
'  from PROJECTS',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30AB\30EC\30F3\30C0\306B\8868\793A\3055\308C\308B\30A4\30D9\30F3\30C8\306E\30B9\30BF\30A4\30EB\3092\8A2D\5B9A\3059\308B\305F\3081\306ECSS\30AF\30E9\30B9\3092\542B\3081\308B\5217\3092\9078\629E\3057\3066\304F\3060\3055\3044\3002\591A\6570\306E\30C7\30D5\30A9\30EB\30C8\30FB\30AF\30E9\30B9\3092\4F7F\7528\3067\304D\307E\3059\3002</p>'),
'<ul>',
'  <li>apex-cal-red</li>',
'  <li>apex-cal-cyan</li>',
'  <li>apex-cal-blue</li>',
'  <li>apex-cal-bluesky</li>',
'  <li>apex-cal-darkblue</li>',
'  <li>apex-cal-green</li>',
'  <li>apex-cal-yellow</li>',
'  <li>apex-cal-silver</li>',
'  <li>apex-cal-brown</li>',
'  <li>apex-cal-lime</li>',
'  <li>apex-cal-white</li>',
'  <li>apex-cal-gray</li>',
'  <li>apex-cal-black</li>',
'  <li>apex-cal-orange</li>',
'</ul>',
unistr('<p>CSS\30AF\30E9\30B9\306E\8FFD\52A0\306B\95A2\3059\308B\30C9\30AD\30E5\30E1\30F3\30C8\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002</p>')))
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(493100634228105571.442)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.442)
,p_name=>'apexcalendardateselect'
,p_display_name=>unistr('\65E5\4ED8\304C\9078\629E\3055\308C\307E\3057\305F')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(493100238395105571.442)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.442)
,p_name=>'apexcalendareventselect'
,p_display_name=>unistr('\30A4\30D9\30F3\30C8\304C\9078\629E\3055\308C\307E\3057\305F')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(493099818743105570.442)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.442)
,p_name=>'apexcalendarviewchange'
,p_display_name=>unistr('\30D3\30E5\30FC\304C\5909\66F4\3055\308C\307E\3057\305F')
);
end;
/
prompt --application/shared_components/plugins/process_type/tabform_delete
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(723477031014918732.442)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'TABFORM_DELETE'
,p_display_name=>unistr('\8868\5F62\5F0F\30D5\30A9\30FC\30E0 - \8907\6570\884C\306E\524A\9664')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','TABFORM_DELETE'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REGION_REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('\8868\5F62\5F0F\30D5\30A9\30FC\30E0\30FB\30EA\30FC\30B8\30E7\30F3\304B\3089\8907\6570\884C\3092\524A\9664\3059\308B\30D7\30ED\30BB\30B9\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723477251489924376.442)
,p_plugin_id=>wwv_flow_api.id(723477031014918732.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\8868\306E\6240\6709\8005')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>unistr('\8868\306E\6240\6709\8005(\30B9\30AD\30FC\30DE)\540D\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723477545882927054.442)
,p_plugin_id=>wwv_flow_api.id(723477031014918732.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\8868\540D')
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(723477251489924376.442)
,p_help_text=>unistr('\5927/\5C0F\6587\5B57\3092\533A\5225\3057\305F\8868\307E\305F\306F\66F4\65B0\53EF\80FD\306A\30D3\30E5\30FC\306E\540D\524D\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723477835530931825.442)
,p_plugin_id=>wwv_flow_api.id(723477031014918732.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\4E3B\30AD\30FC\5217')
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(723477545882927054.442)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4E3B\30AD\30FC\5024\3092\542B\3080\5217\3092\9078\629E\3057\307E\3059\30022\3064\3088\308A\591A\3044\90E8\5206\304B\3089\6210\308B\4E3B\30AD\30FC\3092\6301\3064\8868\306E\5834\5408\3001<strong>ROWID</strong>\3092\9078\629E\3057\307E\3059\3002</p>'),
unistr('<p>\4E3B\30AD\30FC\306F\3001\524A\9664\3055\308C\308B\884C\306E\8B58\5225\306B\4F7F\7528\3055\308C\3001\8868\5F62\5F0F\30D5\30A9\30FC\30E0\3067\7DE8\96C6\4E0D\53EF\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\65B0\898F\884C\306E\5834\5408\3001\4E3B\30AD\30FC\5024\306F\7A7A\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723478159456935961.442)
,p_plugin_id=>wwv_flow_api.id(723477031014918732.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('2\6B21\30AD\30FC\5217')
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(723477545882927054.442)
,p_help_text=>unistr('2\3064\76EE\306E\4E3B\30AD\30FC\5024\3092\542B\3080\5217\3092\9078\629E\3057\307E\3059\3002\3053\306E\5C5E\6027\306B\306F\3001\4E3B\30AD\30FC\304C2\3064\306E\5217\3067\69CB\6210\3055\308C\308B\5834\5408\306B\306E\307F\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723478847798956469.442)
,p_plugin_id=>wwv_flow_api.id(723477031014918732.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\5B9F\884C\6642\306EWHERE\53E5')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6B21\3092\4F7F\7528\3057\3066\90E8\9580\3092\9650\5B9A:'),
'  <code>DEPTNO = 10</code>'))
,p_help_text=>unistr('\751F\6210\3055\308C\308BDELETE\6587\306B\8FFD\52A0\3059\308BSQL\306EWHERE\53E5\3092\5165\529B\3057\307E\3059\3002\3053\306E\5C5E\6027\3092\4F7F\7528\3057\3066\3001\81EA\52D5\7684\306B\751F\6210\3055\308C\308BSQL\30B3\30FC\30EB\5185\3067\4F7F\7528\3055\308C\308B\30EC\30B3\30FC\30C9\3092\5236\9650\3057\307E\3059\3002')
);
end;
/
prompt --application/shared_components/plugins/process_type/user_preferences
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(723624323202892766.442)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'USER_PREFERENCES'
,p_display_name=>unistr('\30E6\30FC\30B6\30FC\30FB\30D7\30EA\30D5\30A1\30EC\30F3\30B9')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','USER_PREFERENCES'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306E\30E6\30FC\30B6\30FC\30FB\30D7\30EA\30D5\30A1\30EC\30F3\30B9\3092\8A2D\5B9A\3059\308B\30D7\30ED\30BB\30B9\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723624639568915612.442)
,p_plugin_id=>wwv_flow_api.id(723624323202892766.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\30BF\30A4\30D7')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'RESET_USER_PREFERENCES'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\30E6\30FC\30B6\30FC\30FB\30D7\30EA\30D5\30A1\30EC\30F3\30B9\3092\30EA\30BB\30C3\30C8\307E\305F\306F\8A2D\5B9A\3059\308B\30D7\30ED\30BB\30B9\30FB\30BF\30A4\30D7\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(723626924903922340.442)
,p_plugin_attribute_id=>wwv_flow_api.id(723624639568915612.442)
,p_display_sequence=>10
,p_display_value=>unistr('\30D7\30EA\30D5\30A1\30EC\30F3\30B9\3092\30EA\30BB\30C3\30C8(\73FE\884C\306E\30E6\30FC\30B6\30FC\306E\3059\3079\3066\306E\30D7\30EA\30D5\30A1\30EC\30F3\30B9\3092\524A\9664)')
,p_return_value=>'RESET_USER_PREFERENCES'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(723627321668923828.442)
,p_plugin_attribute_id=>wwv_flow_api.id(723624639568915612.442)
,p_display_sequence=>20
,p_display_value=>unistr('\30A2\30A4\30C6\30E0\5024\306B\8A2D\5B9A')
,p_return_value=>'SET_PREFERENCE_TO_ITEM_VALUE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(723627719296924995.442)
,p_plugin_attribute_id=>wwv_flow_api.id(723624639568915612.442)
,p_display_sequence=>30
,p_display_value=>unistr('Null\3067\306A\3044\5834\5408\30A2\30A4\30C6\30E0\5024\306B\8A2D\5B9A')
,p_return_value=>'SET_PREFERENCE_TO_ITEM_VALUE_IF_ITEM_NOT_NULL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723631645557973527.442)
,p_plugin_id=>wwv_flow_api.id(723624323202892766.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\30D7\30EA\30D5\30A1\30EC\30F3\30B9\540D')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(723624639568915612.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'SET_PREFERENCE_TO_ITEM_VALUE,SET_PREFERENCE_TO_ITEM_VALUE_IF_ITEM_NOT_NULL'
,p_text_case=>'UPPER'
,p_help_text=>unistr('\30D7\30EA\30D5\30A1\30EC\30F3\30B9\540D\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723631934127978868.442)
,p_plugin_id=>wwv_flow_api.id(723624323202892766.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(723624639568915612.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'SET_PREFERENCE_TO_ITEM_VALUE,SET_PREFERENCE_TO_ITEM_VALUE_IF_ITEM_NOT_NULL'
,p_help_text=>unistr('\30D7\30EA\30D5\30A1\30EC\30F3\30B9\5024\3092\4FDD\6301\3059\308B\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\9078\629E\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
end;
/
prompt --application/shared_components/plugins/process_type/form_process
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(723640922660606468.442)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_PROCESS'
,p_display_name=>unistr('\884C\306E\81EA\52D5\51E6\7406(DML)')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_PROCESS'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>unistr('1\3064\306E\30C7\30FC\30BF\30D9\30FC\30B9\8868\307E\305F\306F\66F4\65B0\53EF\80FD\306A\30D3\30E5\30FC\306B\5BFE\3057\3066\30EC\30B3\30FC\30C9\3092\633F\5165\3001\66F4\65B0\307E\305F\306F\524A\9664\3059\308B\30D7\30ED\30BB\30B9\3002\3053\306E\30D7\30ED\30BB\30B9\306F\3001\30BD\30FC\30B9\304C<strong>\30C7\30FC\30BF\30D9\30FC\30B9\5217</strong>\30BF\30A4\30D7\306E\30D5\30A9\30FC\30E0\30FB\30A2\30A4\30C6\30E0\306E\51E6\7406\306B\4F7F\7528\3055\308C\307E\3059\3002\3053\306E\30D7\30ED\30BB\30B9\306B\5BFE\3057\3066\5165\529B\3055\308C\305F\5C5E\6027\306F\3001<em>\884C\306E\81EA\52D5\30D5\30A7\30C3\30C1</em>\30FB\30D7\30ED\30BB\30B9\3067\5165\529B\3055\308C\305F\5C5E\6027\306B\95A2\9023\4ED8\3051\3089\308C\307E\3059\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723641240116613584.442)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\8868\306E\6240\6709\8005')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>unistr('\8868\306E\6240\6709\8005(\30B9\30AD\30FC\30DE)\540D\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723641536018615468.442)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\8868\540D')
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(723641240116613584.442)
,p_help_text=>unistr('\5927/\5C0F\6587\5B57\3092\533A\5225\3057\305F\8868\307E\305F\306F\30D3\30E5\30FC\306E\540D\524D\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723641830196618138.442)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>40
,p_prompt=>unistr('\4E3B\30AD\30FC\30FB\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\4E3B\30AD\30FC\5217\5024\3092\4FDD\6301\3059\308B\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723642126745619762.442)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>30
,p_prompt=>unistr('\4E3B\30AD\30FC\5217')
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(723641536018615468.442)
,p_help_text=>unistr('\4E3B\30AD\30FC\5024\3092\542B\3080\5217\3092\9078\629E\3057\307E\3059\30022\3064\3088\308A\591A\3044\90E8\5206\304B\3089\6210\308B\4E3B\30AD\30FC\3092\6301\3064\8868\306E\5834\5408\3001<strong>ROWID</strong>\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723642422001622013.442)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>60
,p_prompt=>unistr('2\6B21\30AD\30FC\30FB\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(723642713590625893.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('2\6B21\30AD\30FC\5217\5024\3092\4FDD\6301\3059\308B\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723642713590625893.442)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>50
,p_prompt=>unistr('2\6B21\30AD\30FC\5217')
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(723641536018615468.442)
,p_depending_on_attribute_id=>wwv_flow_api.id(723642126745619762.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'ROWID'
,p_help_text=>unistr('2\3064\76EE\306E\4E3B\30AD\30FC\5024\3092\542B\3080\5217\3092\9078\629E\3057\307E\3059\3002\3053\306E\5C5E\6027\306B\306F\3001\4E3B\30AD\30FC\304C2\3064\306E\5217\3067\69CB\6210\3055\308C\308B\5834\5408\306B\306E\307F\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723646536850919017.442)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\884C\30D0\30FC\30B8\30E7\30F3\5217')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\884C\306E\30D0\30FC\30B8\30E7\30F3\3092\8B58\5225\3059\308B\5217\3092\9078\629E\3057\307E\3059\3002\3053\306E\5217\3092\30DA\30FC\30B8\306B\8868\793A\3059\308B\5FC5\8981\306F\3042\308A\307E\305B\3093\3002\7D44\8FBC\307F\30C1\30A7\30C3\30AF\30B5\30E0\3092\4F7F\7528\3059\308B\5834\5408\3001\3053\306E\5C5E\6027\3092\7A7A\767D\306E\307E\307E\306B\3057\307E\3059\3002</p>'),
unistr('<p>\4FBF\5B9C\7684\30ED\30C3\30AF\3067\306F\3001\5931\308F\308C\305F\66F4\65B0\306E\691C\51FA\3092\4F7F\7528\3057\3066\3001\30C7\30FC\30BF\304C\540C\6642\306B\30A2\30AF\30BB\30B9\3055\308C\308B\53EF\80FD\6027\306E\3042\308B\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\306E\30C7\30FC\30BF\306E\5B8C\5168\6027\3092\4FDD\8A3C\3057\307E\3059\3002&PRODUCT_NAME.\306F\3001\7D44\8FBC\307F\30C1\30A7\30C3\30AF\30B5\30E0\3092\4F7F\7528\3057\3066\5931\308F\308C\305F\66F4\65B0\306E\691C\51FA\304A\3088\3073\884C\306E\30D0\30FC\30B8\30E7\30F3\306E\6C7A\5B9A\3092\5B9F\884C\3067\304D\307E\3059\3002\30C1\30A7\30C3\30AF\30B5\30E0\306F\3001\7279\5B9A\306E\8868\306E\884C\306B\5BFE\3059\308B\3059\3079\3066\306E\5217\5024\306E\30CF\30C3\30B7\30E5\95A2\6570\3067\3059\3002\3053\308C\306F\3001<em>\884C\306E\81EA\52D5\30D5\30A7\30C3\30C1</em>\3067\30EC\30B3\30FC\30C9\3092\30C7\30FC\30BF\30D9\30FC\30B9\304B\3089\554F\3044\5408\305B\308B\969B\306B\53D6\5F97\3055\308C\3001\3053\306E\30D7\30ED\30BB\30B9\306E\4E00\74B0\3068\3057\3066\30C7\30FC\30BF\30D9\30FC\30B9\5185\306E\73FE\5728\306E\30EC\30B3\30FC\30C9\306E\30CF\30C3\30B7\30E5\3068\6BD4\8F03\3055\308C\307E')
||unistr('\3059\30022\3064\306E\5024\304C\540C\3058\5834\5408\3001\66F4\65B0\304C\9032\3081\3089\308C\307E\3059\3002\540C\3058\3067\306F\306A\3044\5834\5408\3001\3053\306E\30D7\30ED\30BB\30B9\306B\3088\3063\3066\30A8\30E9\30FC\304C\751F\6210\3055\308C\307E\3059\3002</p>'),
unistr('<p>\3053\306E\5C5E\6027\306B\3088\3063\3066\3001\7D44\8FBC\307F\30C1\30A7\30C3\30AF\30B5\30E0\51E6\7406\3092\4F7F\7528\3059\308B\304B\308F\308A\3068\306A\308B\3001\884C\30D0\30FC\30B8\30E7\30F3\3092\4FDD\6301\3059\308B1\3064\306E\5217\3092\6307\5B9A\3067\304D\307E\3059\3002\3053\306E\5217\306F\3001\30C7\30FC\30BF\30D9\30FC\30B9\5185\306E\30EC\30B3\30FC\30C9\304C\66F4\65B0\3055\308C\305F\5834\5408\5FC5\305A\66F4\65B0\3055\308C\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\8868\306B<em>\300C\66F4\65B0\524D\300D</en>\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30C8\30EA\30AC\30FC\3092\5B9F\88C5\3057\3066\5897\5206\3059\308B\304B\3001\884C\30D0\30FC\30B8\30E7\30F3\5217\3092\66F4\65B0\3059\308B\3053\3068\3092\304A\85A6\3081\3057\307E\3059\3002NUMBER\5217\306F\3001\884C\306E\9806\5E8F\756A\53F7\3092\542B\3080\3068\307F\306A\3055\308C\307E\3059\3002\305F\3060\3057\3001DATE\304A\3088\3073TIMESTAMP\306E\5217\3082\4F7F\7528\3067\304D\307E\3059\30021\3064\306E\5217\3092\4F7F\7528\3059\308B\5229\70B9\306F\3001&PRODUCT_NAME.\30A8\30F3\30B8\30F3\3067\884C\5168\4F53\306E')
||unistr('\30CF\30C3\30B7\30E5\3092\5B9F\884C\3059\308B\5FC5\8981\304C\306A\3044\3053\3068\3067\3059\3002\304B\308F\308A\306B\30011\3064\306E\5217\5024\3092\6BD4\8F03\3059\308B\306E\307F\3067\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723646022259834604.442)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\5B9F\884C\6642\306EWHERE\53E5')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\90E8\9580\3092\9650\5B9A:</p>'),
'<pre>DEPTNO = 10</pre>'))
,p_help_text=>unistr('\751F\6210\3055\308C\308B\3059\3079\3066\306EINSERT\6587\3001UPDATE\6587\304A\3088\3073DELETE\6587\306B\8FFD\52A0\3059\308BSQL\306EWHERE\53E5\3092\5165\529B\3057\307E\3059\3002\3053\306E\5C5E\6027\3092\4F7F\7528\3057\3066\3001\81EA\52D5\7684\306B\751F\6210\3055\308C\308BSQL\30B3\30FC\30EB\5185\3067\4F7F\7528\3055\308C\308B\30EC\30B3\30FC\30C9\3092\5236\9650\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361842218629998562.442)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\623B\308A\30AD\30FC\5165\529B\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>SQL INSERT\6587\304B\3089\8FD4\3055\308C\308B\4E3B\30AD\30FC\5217\5024\3092\4FDD\6301\3059\308B\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002</p>'),
unistr('<p>\9806\5E8F\307E\305F\306F\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30C8\30EA\30AC\30FC\306B\3088\3063\3066\79FB\5165\3055\308C\305F\4E3B\30AD\30FC\30FB\30D5\30A3\30FC\30EB\30C9\3092\8FD4\3059\306B\306F\3001\3053\306E\5217\3092\6307\5B9A\3057\307E\3059\3002\3053\306E\5024\306F\3001\30D7\30ED\30BB\30B9\306B\3088\3063\3066\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\306B\8A2D\5B9A\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361842512807001262.442)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('\623B\308A2\6B21\30AD\30FC\5165\529B\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(723642713590625893.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('SQL INSERT\6587\306B\3088\3063\3066\8FD4\3055\308C\308B2\3064\76EE\306E\4E3B\30AD\30FC\5217\5024\3092\4FDD\6301\3059\308B\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361843216017030111.442)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>unistr('\30B5\30DD\30FC\30C8\3055\308C\3066\3044\308B\64CD\4F5C')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>true
,p_default_value=>'I:U:D'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\30B5\30DD\30FC\30C8\3055\308C\308B\30C7\30FC\30BF\64CD\4F5C\8A00\8A9E(DML)\306E\64CD\4F5C\3092\30C1\30A7\30C3\30AF\3057\307E\3059\3002\3053\306E\30C7\30FC\30BF\64CD\4F5C\30D7\30ED\30BB\30B9\306F\3001\30EA\30AF\30A8\30B9\30C8\5024\304C\30EA\30B9\30C8\3055\308C\305F\5024\306E\3044\305A\308C\304B\3067\3042\308B\5834\5408\306B\3001DML\3092\5B9F\884C\3057\307E\3059\3002\30DC\30BF\30F3\3092\4F7F\7528\3057\3066\3053\306E\30DA\30FC\30B8\3092\9001\4FE1\3059\308B\3068\3001\30EA\30AF\30A8\30B9\30C8\5024\306F\30DC\30BF\30F3\306B\3088\3063\3066\8A2D\5B9A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362471227178028863.442)
,p_plugin_attribute_id=>wwv_flow_api.id(361843216017030111.442)
,p_display_sequence=>10
,p_display_value=>unistr('\633F\5165')
,p_return_value=>'I'
,p_help_text=>unistr('\30EA\30AF\30A8\30B9\30C8\5024\306B\3088\3063\3066\30C8\30EA\30AC\30FC\3055\308C\307E\3059: INSERT\3001CREATE\3001CREATE_AGAIN\3001CREATEAGAIN')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362471623727030373.442)
,p_plugin_attribute_id=>wwv_flow_api.id(361843216017030111.442)
,p_display_sequence=>20
,p_display_value=>unistr('\66F4\65B0')
,p_return_value=>'U'
,p_help_text=>unistr('\30EA\30AF\30A8\30B9\30C8\5024\306B\3088\3063\3066\30C8\30EA\30AC\30FC\3055\308C\307E\3059: SAVE\3001APPLY CHANGES\3001UPDATE\3001UPDATE ROW\3001CHANGE\3001APPLY\3001APPLY%CHANGES%\3001GET_NEXT%\3001GET_PREV%')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362472022649030909.442)
,p_plugin_attribute_id=>wwv_flow_api.id(361843216017030111.442)
,p_display_sequence=>30
,p_display_value=>unistr('\524A\9664')
,p_return_value=>'D'
,p_help_text=>unistr('\30EA\30AF\30A8\30B9\30C8\5024\306B\3088\3063\3066\30C8\30EA\30AC\30FC\3055\308C\307E\3059: DELETE\3001REMOVE\3001DELETE ROW\3001DROP')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(216670983590615543.442)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>105
,p_prompt=>unistr('\884C\306E\30ED\30C3\30AF')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('<p>\51E6\7406\3059\308B\524D\306B\66F4\65B0\307E\305F\306F\524A\9664\3059\308B\5404\884C\3092\57FA\790E\3068\306A\308B\8868\3067\30ED\30C3\30AF\3059\308B\304B\3069\3046\304B\3092\9078\629E\3057\307E\3059\3002</p>')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/set_focus
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(854773928315984269.442)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'SET_FOCUS'
,p_display_name=>unistr('\30D5\30A9\30FC\30AB\30B9\306E\8A2D\5B9A')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','SET_FOCUS'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\5F71\97FF\3092\53D7\3051\308B\8981\7D20\306B\30D5\30A9\30FC\30AB\30B9\3092\8A2D\5B9A\3057\307E\3059\3002\8907\6570\3042\308B\5834\5408\30011\3064\76EE\306E\5F71\97FF\3092\53D7\3051\308B\8981\7D20\306B\30C7\30D5\30A9\30EB\30C8\3067\8A2D\5B9A\3055\308C\307E\3059\3002<em>\8868\793A</em>\304A\3088\3073<em>\6709\52B9\5316</em>\30A2\30AF\30B7\30E7\30F3\3068\7D44\307F\5408\305B\3066\4F7F\7528\3057\305F\5834\5408\3001\30E6\30FC\30B6\30FC\304C\9069\5207\306A\30A2\30A4\30C6\30E0\306B\76F4\63A5\79FB\52D5\3067\304D\3001\7279\306B\6709\7528\3067\3059\3002')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/submit_page
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(854776817374066356.442)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'SUBMIT_PAGE'
,p_display_name=>unistr('\30DA\30FC\30B8\306E\9001\4FE1')
,p_category=>'NAVIGATION'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','SUBMIT_PAGE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\30DA\30FC\30B8\3092\9001\4FE1\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(854777422315124533.442)
,p_plugin_id=>wwv_flow_api.id(854776817374066356.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\30EA\30AF\30A8\30B9\30C8/\30DC\30BF\30F3\540D')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('\30DA\30FC\30B8\306E\9001\4FE1\306B\4F7F\7528\3055\308C\308B\30EA\30AF\30A8\30B9\30C8\5024\3092\5165\529B\3057\307E\3059\3002\30DC\30BF\30F3\304C\52D5\7684\30A2\30AF\30B7\30E7\30F3\3092\30C8\30EA\30AC\30FC\3059\308B\5834\5408\3001\3053\308C\3092\30DC\30BF\30F3\540D\306B\8A2D\5B9A\3057\307E\3059\3002\305D\3046\3059\308B\3068\3001\30DA\30FC\30B8\306E\51E6\7406\4E2D\306B\305D\306E\30DC\30BF\30F3\306E<em>\300C\691C\8A3C\306E\5B9F\884C\300D</em>\5C5E\6027\304C\512A\5148\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(477648707512082509.442)
,p_plugin_id=>wwv_flow_api.id(854776817374066356.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\51E6\7406\4E2D\3092\8868\793A')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\30DA\30FC\30B8\9001\4FE1\4E2D\306B\73FE\5728\306E\30DA\30FC\30B8\3092\30B0\30EC\30FC\30A2\30A6\30C8\3057\3066\300C\51E6\7406\4E2D\300D\30B9\30BF\30A4\30EB\306E\30A2\30CB\30E1\30FC\30B7\30E7\30F3\3092\8868\793A\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002\3053\308C\306F\3001\30EC\30DD\30FC\30C8\306E\30EA\30D5\30EC\30C3\30B7\30E5\306B\6642\9593\304C\304B\304B\3063\3066\3044\308B\3068\304D\306B\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\691C\7D22\30DC\30BF\30F3\3092\518D\5EA6\30AF\30EA\30C3\30AF\3059\308B\306A\3069\3001\51E6\7406\306B\6642\9593\304C\304B\304B\3063\3066\3044\308B\3068\304D\306E\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\30FB\30A2\30AF\30B7\30E7\30F3\3092\9632\3050\5834\5408\306B\4FBF\5229\3067\3059\3002')
);
end;
/
prompt --application/shared_components/plugins/item_type/number_field
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(858626633540183539.442)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'NUMBER_FIELD'
,p_display_name=>unistr('\6570\5024\30D5\30A3\30FC\30EB\30C9')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','NUMBER_FIELD'),'')
,p_api_version=>1
,p_validation_function=>'dummy_to_trigger_basic_validation'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:FORMAT_MASK_NUMBER:ELEMENT:WIDTH:PLACEHOLDER:ICON:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\6570\5024\30D5\30A3\30FC\30EB\30C9\3092\8868\793A\3057\307E\3059\3002\3053\306E\30A2\30A4\30C6\30E0\30FB\30BF\30A4\30D7\3067\306F\3001\5024\304C\6570\5024\3067\3042\308B\3053\3068\304C\81EA\52D5\7684\306B\691C\8A3C\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(858627014886206552.442)
,p_plugin_id=>wwv_flow_api.id(858626633540183539.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\6700\5C0F\5024')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>0</code></li>',
'<li><code>0.99</code></li>',
'<li><code>&P1_MIN_SALARY.</code></li>',
'</ul>'))
,p_help_text=>unistr('\6700\5C0F\8A31\5BB9\5024\3092\5165\529B\3057\307E\3059\3002\5024\306F\3001\9759\7684\5024\307E\305F\306F\7F6E\63DB\69CB\6587\3092\4F7F\7528\3057\305F\52D5\7684\5024\3067\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(858627524583209309.442)
,p_plugin_id=>wwv_flow_api.id(858626633540183539.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\6700\5927\5024')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>1000</code></li>',
'<li><code>49.99</code></li>',
'<li><code>&P1_MAX_SALARY.</code></li>',
'</ul>'))
,p_help_text=>unistr('\6700\5927\8A31\5BB9\5024\3092\5165\529B\3057\307E\3059\3002\5024\306F\3001\9759\7684\5024\307E\305F\306F\7F6E\63DB\69CB\6587\3092\4F7F\7528\3057\305F\52D5\7684\5024\3067\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(858676504215733205.442)
,p_plugin_id=>wwv_flow_api.id(858626633540183539.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\6570\5B57\306E\4F4D\7F6E\5408\305B')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_default_value=>'right'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\8868\793A\3059\308B\6570\5024\306E\4F4D\7F6E\5408\305B\65B9\6CD5\3092\9078\629E\3057\307E\3059\3002\30A2\30A4\30C6\30E0\304C<em>\8AAD\53D6\308A\5C02\7528</em>\3068\3057\3066\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\308B\5834\5408\3001\307E\305F\306F<strong>HTML\30D5\30A9\30FC\30E0\306E\8981\7D20\5C5E\6027</strong>\304C\6307\5B9A\3055\308C\3066\3044\308B\5834\5408\3001\3053\306E\8A2D\5B9A\306F\9069\7528\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(858678212526735663.442)
,p_plugin_attribute_id=>wwv_flow_api.id(858676504215733205.442)
,p_display_sequence=>10
,p_display_value=>unistr('\5DE6')
,p_return_value=>'left'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(858678618067737263.442)
,p_plugin_attribute_id=>wwv_flow_api.id(858676504215733205.442)
,p_display_sequence=>20
,p_display_value=>unistr('\4E2D\592E')
,p_return_value=>'center'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(858679023954738917.442)
,p_plugin_attribute_id=>wwv_flow_api.id(858676504215733205.442)
,p_display_sequence=>30
,p_display_value=>unistr('\53F3')
,p_return_value=>'right'
);
end;
/
prompt --application/shared_components/plugins/item_type/slider
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(880057283386968314.442)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'SLIDER'
,p_display_name=>unistr('\30B9\30E9\30A4\30C0')
,p_supported_ui_types=>'JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','SLIDER'),'')
,p_api_version=>1
,p_validation_function=>'dummy_to_trigger_basic_validation'
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:SOURCE:ELEMENT:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\30B9\30E9\30A4\30C0\30FB\30A2\30A4\30C6\30E0\30FB\30BF\30A4\30D7\3092\8868\793A\3057\307E\3059\3002\30E6\30FC\30B6\30FC\306F\3001\30B3\30F3\30C8\30ED\30FC\30EB\3092\5DE6\307E\305F\306F\53F3\306B\30B9\30E9\30A4\30C9\3059\308B\3053\3068\3067\30A2\30A4\30C6\30E0\5024\3092\66F4\65B0\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(880057664732991327.442)
,p_plugin_id=>wwv_flow_api.id(880057283386968314.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\6700\5C0F\5024')
,p_attribute_type=>'NUMBER'
,p_is_required=>true
,p_default_value=>'0'
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'  <li><code>0</code></li>',
'  <li><code>&P1_MIN_SALARY.</code></li>',
'</ul>'))
,p_help_text=>unistr('\6700\5C0F\8A31\5BB9\5024\3092\5165\529B\3057\307E\3059\3002\5024\306F\3001\9759\7684\5024\307E\305F\306F\7F6E\63DB\69CB\6587\3092\4F7F\7528\3057\305F\52D5\7684\5024\3067\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(880058174429994084.442)
,p_plugin_id=>wwv_flow_api.id(880057283386968314.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\6700\5927\5024')
,p_attribute_type=>'NUMBER'
,p_is_required=>true
,p_default_value=>'100'
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'  <li><code>100</code></li>',
'  <li><code>&P1_MAX_SALARY.</code></li>',
'</ul>'))
,p_help_text=>unistr('\6700\5927\8A31\5BB9\5024\3092\5165\529B\3057\307E\3059\3002\5024\306F\3001\9759\7684\5024\307E\305F\306F\7F6E\63DB\69CB\6587\3092\4F7F\7528\3057\305F\52D5\7684\5024\3067\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(880107154062517980.442)
,p_plugin_id=>wwv_flow_api.id(880057283386968314.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\30B9\30C6\30C3\30D7\5897\5206')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'  <li><code>5</code></li>',
'  <li><code>&P1_STEP_SIZE.</code></li>',
'</ul>'))
,p_help_text=>unistr('\30B9\30E9\30A4\30C0\3092\5F37\5236\7684\306B\7279\5B9A\306E\5897\5206\306B\5408\305B\308B\5024\3092\5165\529B\3057\307E\3059\3002\5024\306F\3001\9759\7684\5024\307E\305F\306F\7F6E\63DB\69CB\6587\3092\4F7F\7528\3057\305F\52D5\7684\5024\3067\3059\3002')
,p_attribute_comment=>'$$$ DJP - No default value set = 1'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(10717732308427631.442)
,p_plugin_id=>wwv_flow_api.id(880057283386968314.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\9078\629E\6E08\3092\30CF\30A4\30E9\30A4\30C8')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\30B9\30E9\30A4\30C0\3067\3001\73FE\5728\306E\30B9\30E9\30A4\30C0\30FB\30CF\30F3\30C9\30EB\306E\4F4D\7F6E\307E\3067\8ECC\8DE1\3092\30CF\30A4\30E9\30A4\30C8\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
end;
/
prompt --application/shared_components/plugins/process_type/send_email
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(956011735689077213.442)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'SEND_EMAIL'
,p_display_name=>unistr('\96FB\5B50\30E1\30FC\30EB\306E\9001\4FE1')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC:APEX_APPL_AUTOMATION_ACTIONS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','SEND_EMAIL'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304B\3089\96FB\5B50\30E1\30FC\30EB(\304A\3088\3073\30AA\30D7\30B7\30E7\30F3\30671\3064\4EE5\4E0A\306E\6DFB\4ED8)\3092\9001\4FE1\3059\308B\30D7\30ED\30BB\30B9\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956092037052376563.442)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\5909\63DB\5143')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'&APP_EMAIL.'
,p_display_length=>60
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>noreply@test.com</code></li>',
'<li><code>Do not reply &lt;noreply@test.com&gt;</code></li>',
'<li><code>&amp;P6_FROM.</code></li>',
'</ul>'))
,p_help_text=>unistr('\96FB\5B50\30E1\30FC\30EB\306E\9001\4FE1\8005\3068\3057\3066\8868\793A\3059\308B\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9\3092\5165\529B\3057\307E\3059\3002\3053\306E\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9\306F\6709\52B9\306A\30A2\30C9\30EC\30B9\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\6709\52B9\3067\306A\3044\5834\5408\3001\30E1\30C3\30BB\30FC\30B8\306F\9001\4FE1\3055\308C\307E\305B\3093\3002\52D5\7684\5024\3092\4F7F\7528\3059\308B\5834\5408\306F\7F6E\63DB\69CB\6587\3092\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956050619869980888.442)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\5B9B\5148')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>john.doe@test.com, jane.doe@test.com</code></li>',
'<li><code>John Doe &lt;john.doe@test.com&gt;, Jane Doe &lt;jane.doe@test.com&gt;</code></li>',
'<li><code>&amp;P6_TO.</code></li>',
'</ul>'))
,p_help_text=>unistr('1\3064\4EE5\4E0A\306E\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9\3092\6307\5B9A\3057\3066\3001\96FB\5B50\30E1\30FC\30EB\53D7\4FE1\8005\3092\5165\529B\3057\307E\3059\3002\8907\6570\306E\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9\306E\5834\5408\3001\30AB\30F3\30DE\533A\5207\308A\30EA\30B9\30C8\3092\4F7F\7528\3057\307E\3059\3002\52D5\7684\5024\3092\4F7F\7528\3059\308B\5834\5408\306F\7F6E\63DB\69CB\6587\3092\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956051928180983251.442)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'CC'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>60
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>john.doe@test.com, jane.doe@test.com</code></li>',
'<li><code>John Doe &lt;john.doe@test.com&gt;, Jane Doe &lt;jane.doe@test.com&gt;</code></li>',
'<li><code>&amp;P6_CC.</code></li>',
'</ul>'))
,p_help_text=>unistr('1\3064\4EE5\4E0A\306E\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9\3092\6307\5B9A\3057\3066\3001\30AB\30FC\30DC\30F3\30FB\30B3\30D4\30FC\96FB\5B50\30E1\30FC\30EB\53D7\4FE1\8005\3092\5165\529B\3057\307E\3059\3002\8907\6570\306E\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9\306E\5834\5408\3001\30AB\30F3\30DE\533A\5207\308A\30EA\30B9\30C8\3092\4F7F\7528\3057\307E\3059\3002\52D5\7684\5024\3092\4F7F\7528\3059\308B\5834\5408\306F\7F6E\63DB\69CB\6587\3092\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956052531990984386.442)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'BCC'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>60
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>john.doe@test.com, jane.doe@test.com</code></li>',
'<li><code>John Doe &lt;john.doe@test.com&gt;, Jane Doe &lt;jane.doe@test.com&gt;</code></li>',
'<li><code>&amp;P6_BCC.</code></li>',
'</ul>'))
,p_help_text=>unistr('1\3064\4EE5\4E0A\306E\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9\3092\6307\5B9A\3057\3066\3001\30D6\30E9\30A4\30F3\30C9\30FB\30AB\30FC\30DC\30F3\30FB\30B3\30D4\30FC\96FB\5B50\30E1\30FC\30EB\53D7\4FE1\8005\3092\5165\529B\3057\307E\3059\3002\8907\6570\306E\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9\306E\5834\5408\3001\30AB\30F3\30DE\533A\5207\308A\30EA\30B9\30C8\3092\4F7F\7528\3057\307E\3059\3002\52D5\7684\5024\3092\4F7F\7528\3059\308B\5834\5408\306F\7F6E\63DB\69CB\6587\3092\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956082217032200544.442)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\8FD4\4FE1\5148')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>60
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>john.doe@test.com</code></li>',
'<li><code>John Doe &lt;john.doe@test.com&gt;</code></li>',
'<li><code>&amp;P6_REPLY_TO.</code></li>',
'</ul>'))
,p_help_text=>unistr('\8FD4\4FE1\306E\9001\4FE1\5148\3068\306A\308B\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9\3092\5165\529B\3057\307E\3059\3002\6307\5B9A\3055\308C\3066\3044\306A\3044\5834\5408\306F\3001<strong>\300C\5DEE\51FA\4EBA\300D</strong>\306B\5165\529B\3055\308C\305F\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9\304C\4F7F\7528\3055\308C\307E\3059\3002\52D5\7684\5024\3092\4F7F\7528\3059\308B\5834\5408\306F\7F6E\63DB\69CB\6587\3092\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956053241340987086.442)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>70
,p_prompt=>unistr('\4EF6\540D')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1801033763884282.442)
,p_depending_on_has_to_exist=>false
,p_depending_on_condition_type=>'NULL'
,p_help_text=>unistr('\96FB\5B50\30E1\30FC\30EB\306E\4EF6\540D\3092\5165\529B\3057\307E\3059\3002\52D5\7684\5024\3092\542B\3081\308B\5834\5408\306F\3001<code>&amp;P6_PRODUCT_NAME.</code>\306A\3069\306E\7F6E\63DB\69CB\6587\3092\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956053823463991423.442)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>80
,p_prompt=>unistr('\30DC\30C7\30A3\30FB\30D7\30EC\30FC\30F3\30FB\30C6\30AD\30B9\30C8')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1801033763884282.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NULL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\96FB\5B50\30E1\30FC\30EB\306E\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002\53D7\4FE1\8005\306E\96FB\5B50\30E1\30FC\30EB\30FB\30AF\30E9\30A4\30A2\30F3\30C8\304C\30EA\30C3\30C1\30FB\30C6\30AD\30B9\30C8\8868\793A\3092\30B5\30DD\30FC\30C8\3057\3066\3044\306A\3044\5834\5408\306F\3001\30D7\30EC\30FC\30F3\30FB\30C6\30AD\30B9\30C8\30FB\30D0\30FC\30B8\30E7\30F3\304C\4F7F\7528\3055\308C\307E\3059\3002\30C6\30AD\30B9\30C8\306B\52D5\7684\30B3\30F3\30C6\30F3\30C4\3092\4F7F\7528\3059\308B\5834\5408\306F\7F6E\63DB\69CB\6587(<code>&amp;P6_PRODUCT_NAME.</code>\306A\3069)\3092\4F7F\7528\3057\307E\3059\3002</p>'),
unistr('<p><em>\30CE\30FC\30C8: SMTP/MIME\306E\4ED5\69D8\3067\306F\30011\884C\306E\6587\5B57\6570\306F1000\6587\5B57\4EE5\4E0B\3068\3055\308C\3066\3044\307E\3059\3002\3053\306E\5236\7D04\306B\5F93\3046\305F\3081\3001\30AD\30E3\30EA\30C3\30B8\30FB\30EA\30BF\30FC\30F3\307E\305F\306F\6539\884C\6587\5B57\3092\8FFD\52A0\3057\3066\30C6\30AD\30B9\30C8\30921000\6587\5B57\4EE5\4E0B\306B\5206\5272\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\3053\306E\51E6\7406\3092\5B9F\884C\3057\3066\3044\306A\3044\3068\3001\30E1\30C3\30BB\30FC\30B8\306E\4E00\90E8\304C\6B20\843D\3057\3066\3044\305F\308A\3001\7121\95A2\4FC2\306A\611F\5606\7B26\304C\8868\793A\3055\308C\308B\3088\3046\306A\3001\8AA4\3063\305F\96FB\5B50\30E1\30FC\30EB\30FB\30E1\30C3\30BB\30FC\30B8\304C\4F5C\6210\3055\308C\307E\3059\3002</em></p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956082724997202851.442)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>90
,p_prompt=>unistr('\30DC\30C7\30A3HTML')
,p_attribute_type=>'HTML'
,p_is_required=>false
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1801033763884282.442)
,p_depending_on_has_to_exist=>false
,p_depending_on_condition_type=>'NULL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30D7\30EC\30FC\30F3\30FB\30C6\30AD\30B9\30C8\3068HTML\30B3\30F3\30C6\30F3\30C4\306E\4E21\65B9\3092\542B\3080\30DE\30EB\30C1\30D1\30FC\30C8HTML\30E1\30C3\30BB\30FC\30B8\3092\751F\6210\3059\308B\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002\53D7\4FE1\8005\306E\96FB\5B50\30E1\30FC\30EB\30FB\30AF\30E9\30A4\30A2\30F3\30C8\306E\8A2D\5B9A\304A\3088\3073\6A5F\80FD\306B\3088\3063\3066\3001\8868\793A\306F\5909\308F\308A\307E\3059\3002\6700\8FD1\306E\307B\3068\3093\3069\306E\96FB\5B50\30E1\30FC\30EB\30FB\30AF\30E9\30A4\30A2\30F3\30C8\306FHTML\5F62\5F0F\306E\96FB\5B50\30E1\30FC\30EB\3092\8AAD\307F\53D6\308B\3053\3068\304C\3067\304D\307E\3059\304C\3001\30BB\30AD\30E5\30EA\30C6\30A3\4E0A\306E\7406\7531\304B\3089\3053\306E\6A5F\80FD\3092\7121\52B9\306B\3057\3066\3044\308B\30E6\30FC\30B6\30FC\3082\3044\308B\306E\3067\6CE8\610F\3057\3066\304F\3060\3055\3044\3002\30C6\30AD\30B9\30C8\306B\52D5\7684\30B3\30F3\30C6\30F3\30C4\3092\542B\3081\308B\5834\5408\3001<code>&amp;P6_PRODUCT_NAME.</code>\306A\3069\306E\7F6E\63DB\69CB\6587\3092\4F7F\7528\3057')
||unistr('\307E\3059\3002</p>'),
unistr('<p>&lt;img /&gt;\30BF\30B0\3092\4F7F\7528\3057\3066\30A4\30E1\30FC\30B8\3092\53C2\7167\3059\308B\969B\306F\3001\30A4\30E1\30FC\30B8\3092\53D7\4FE1\8005\306E\96FB\5B50\30E1\30FC\30EB\30FB\30AF\30E9\30A4\30A2\30F3\30C8\306B\5BFE\3057\3066\30A2\30AF\30BB\30B9\53EF\80FD\306B\3057\3066\3001\53D7\4FE1\8005\304C\30A4\30E1\30FC\30B8\3092\898B\3089\308C\308B\3088\3046\306B\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\305F\3068\3048\3070\3001\30CD\30C3\30C8\30EF\30FC\30AF\4E0A\306B\3042\308Bhello.gif\3068\3044\3046\30A4\30E1\30FC\30B8\3092\6B21\306E\3088\3046\306B\53C2\7167\3059\308B\3068\4EEE\5B9A\3057\307E\3059:</p>'),
'<pre>',
'&lt;img src=&quot;http://example.com/hello.gif&quot; alt=&quot;Hello&quot; /&gt;',
'</pre>',
unistr('<p>\3053\306E\4F8B\3067\306F\3001\30A4\30E1\30FC\30B8\306F\96FB\5B50\30E1\30FC\30EB\306B\6DFB\4ED8\3055\308C\3066\3044\307E\305B\3093\304C\3001\96FB\5B50\30E1\30FC\30EB\306B\3088\3063\3066\53C2\7167\3055\308C\3066\3044\307E\3059\3002\53D7\4FE1\8005\306F\30A4\30E1\30FC\30B8\3092\898B\308B\305F\3081\3001Web\30D6\30E9\30A6\30B6\3092\4F7F\7528\3057\3066\305D\306E\30A4\30E1\30FC\30B8\306B\30A2\30AF\30BB\30B9\3067\304D\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\30A4\30E1\30FC\30B8\304C\30D5\30A1\30A4\30A2\30A6\30A9\30FC\30EB\5185\306B\3042\308A\3001\53D7\4FE1\8005\304C\30D5\30A1\30A4\30A2\30A6\30A9\30FC\30EB\5916\306B\3044\308B\5834\5408\3001\30A4\30E1\30FC\30B8\306F\8868\793A\3055\308C\307E\305B\3093\3002\3053\306E\3088\3046\306A\7406\7531\306E\305F\3081\3001\30A4\30E1\30FC\30B8\306E\4F7F\7528\306F\907F\3051\3066\304F\3060\3055\3044\3002\30A4\30E1\30FC\30B8\306E\4F7F\7528\304C\5FC5\8981\306A\5834\5408\306F\3001\30A4\30E1\30FC\30B8\304C\30A2\30AF\30BB\30B9\4E0D\53EF\80FD\306A\3068\304D\306B\30C6\30AD\30B9\30C8\306E\8AAC\660E\3092\8868\793A\3059\308BALT\5C5E\6027\3092\3001\5FC5\305A\4F7F\7528\3057\3066\304F\3060\3055\3044\3002</p>'),
unistr('<p><em>\30CE\30FC\30C8: SMTP/MIME\306E\4ED5\69D8\3067\306F\30011\884C\306E\6587\5B57\6570\306F1000\6587\5B57\4EE5\4E0B\3068\3055\308C\3066\3044\307E\3059\3002\3053\306E\5236\7D04\306B\5F93\3046\305F\3081\3001\30AD\30E3\30EA\30C3\30B8\30FB\30EA\30BF\30FC\30F3\307E\305F\306F\6539\884C\6587\5B57\3092\8FFD\52A0\3057\3066\30C6\30AD\30B9\30C8\30921000\6587\5B57\4EE5\4E0B\306B\5206\5272\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\3053\306E\51E6\7406\3092\5B9F\884C\3057\3066\3044\306A\3044\3068\3001\30E1\30C3\30BB\30FC\30B8\306E\4E00\90E8\304C\6B20\843D\3057\3066\3044\305F\308A\3001\7121\95A2\4FC2\306A\611F\5606\7B26\304C\8868\793A\3055\308C\308B\3088\3046\306A\3001\8AA4\3063\305F\96FB\5B50\30E1\30FC\30EB\30FB\30E1\30C3\30BB\30FC\30B8\304C\4F5C\6210\3055\308C\307E\3059\3002</em></p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956084325437259694.442)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>120
,p_prompt=>unistr('\6DFB\4ED8SQL')
,p_attribute_type=>'SQL'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_sql_min_column_count=>2
,p_sql_max_column_count=>4
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>SQL\6587\306F\6B21\306E\5F62\5F0F\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059:</p>'),
'<pre>',
'select blob_column,',
'       file_name,',
'       mime_type,',
'       content_id',
'  from table',
'</pre>',
unistr('<p>mime_type\304A\3088\3073content_id\5217\306F\30AA\30D7\30B7\30E7\30F3\3067\3059\3002content_id\304C\3042\308B\5834\5408\3001\30D5\30A1\30A4\30EB\306F\30A4\30F3\30E9\30A4\30F3\3067\6DFB\4ED8\3055\308C\3001content_id\306E\5024\304C\6DFB\4ED8\306ECID\306B\4F7F\7528\3055\308C\307E\3059\3002</p>'),
unistr('<p>content_id\5217\306B\5024''my_inline_content''\304C\542B\307E\308C\308B\5834\5408\3001\305D\306E\30A4\30E1\30FC\30B8\306F\6B21\306EHTML\3092\4F7F\7528\3057\3066\96FB\5B50\30E1\30FC\30EB\5185\306B\57CB\3081\8FBC\307E\308C\307E\3059:</p>'),
'<p>',
'<pre>',
'&lt;div&gt;',
'&nbsp;&nbsp;&lt;h1&gt;Some Embedded Content&lt;/h1&gt;',
'&nbsp;&nbsp;&lt;p&gt;',
'&nbsp;&nbsp;&nbsp;&nbsp;&lt;img src="cid:my_inline_content" alt="Inline Image" &gt;',
'&nbsp;&nbsp;&lt;/p&gt;',
'&lt;/div&gt;',
'</pre>',
'</p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\96FB\5B50\30E1\30FC\30EB\306B\30D5\30A1\30A4\30EB\3068\3057\3066\6DFB\4ED8\3055\308C\308B1\3064\4EE5\4E0A\306EBLOB\3092\8FD4\3059SQL\6587\3092\5165\529B\3057\307E\3059\3002</p>'),
unistr('<p>content_id\5217\306Bnull\5024\304C\542B\307E\308C\308B\5834\5408\3001\95A2\9023\4ED8\3051\3089\308C\308B\30D5\30A1\30A4\30EB\306F\901A\5E38\306E\6DFB\4ED8\30D5\30A1\30A4\30EB\306B\306A\308A\307E\3059\3002\30C9\30AD\30E5\30E1\30F3\30C8\3084zip\30A2\30FC\30AB\30A4\30D6\306A\3069\306E\30D5\30A1\30A4\30EB\306F\3001\901A\5E38\3001\3053\306E\65B9\6CD5\3067\6DFB\4ED8\3055\308C\307E\3059\3002</p>'),
unistr('<p>content_id\306E\5024\304Cnull\4EE5\5916\306E\5834\5408\3001\95A2\9023\4ED8\3051\3089\308C\308B\30D5\30A1\30A4\30EB\306F\30A4\30F3\30E9\30A4\30F3\3067\6DFB\4ED8\3055\308C\3066\3044\308B\3082\306E\3068\3057\3066\30DE\30FC\30AF\3055\308C\307E\3059\3002content_id\5217\306E\5024\306F\6DFB\4ED8\306ECID(\30B3\30F3\30C6\30F3\30C4ID)\3068\3057\3066\4F7F\7528\3055\308C\307E\3059\3002\3053\306ECID\5024\306F\3001\30A4\30E1\30FC\30B8\3092\96FB\5B50\30E1\30FC\30EB\30FB\30B3\30F3\30C6\30F3\30C4\5185\306B\76F4\63A5\57CB\3081\8FBC\3080\305F\3081\306B\96FB\5B50\30E1\30FC\30EB\306EHTML\30B3\30FC\30C9\3067\4F7F\7528\3067\304D\307E\3059\3002\4E00\90E8\306E\96FB\5B50\30E1\30FC\30EB\30FB\30AF\30E9\30A4\30A2\30F3\30C8\306F\30A4\30F3\30E9\30A4\30F3\6DFB\4ED8\3092\81EA\52D5\7684\306B\8868\793A\3057\306A\3044\5834\5408\304C\3042\308B\3053\3068\306B\6CE8\610F\3057\3066\304F\3060\3055\3044\3002\307E\305F\3001\96FB\5B50\30E1\30FC\30EB\306E\6A19\6E96\3067\306F\3001\30B3\30F3\30C6\30F3\30C4\8B58\5225\5B50\306E\5F62\5F0F\306B\95A2\3059\308B\69D8\3005\306A\8981\4EF6\304C\898F\5B9A\3055\308C\3066\3044')
||unistr('\308B\3053\3068\306B\3082\6CE8\610F\3057\3066\304F\3060\3055\3044\3002Oracle Application Express\306F\3001\3053\308C\3089\306E\6A19\6E96\3078\306E\6E96\62E0\3092\5F37\5236\3057\307E\305B\3093\3002</p>'),
''))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(965817719331444057.442)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>130
,p_prompt=>unistr('\5373\6642\306B\9001\4FE1')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\3053\306E\96FB\5B50\30E1\30FC\30EB\3092\305F\3060\3061\306B\9001\4FE1\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002\3053\308C\306B\3088\308A\3001&PRODUCT_NAME.\96FB\5B50\30E1\30FC\30EB\30FB\30AD\30E5\30FC\8868\5185\306B\73FE\5728\3042\308B\3059\3079\3066\306E\96FB\5B50\30E1\30FC\30EB\3082\9001\4FE1\3055\308C\307E\3059\3002\30C7\30D5\30A9\30EB\30C8\3067\306F\3001&PRODUCT_NAME.\306F\672A\9001\4FE1\306E\96FB\5B50\30E1\30FC\30EB\30FB\30E1\30C3\30BB\30FC\30B8\3092\8868\306B\683C\7D0D\3057\3001\5B9A\671F\7684\306B\914D\4FE1\3057\3066\3001\30B7\30B9\30C6\30E0\306E\30D1\30D5\30A9\30FC\30DE\30F3\30B9\3092\5411\4E0A\3055\305B\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1801033763884282.442)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>60
,p_prompt=>unistr('\96FB\5B50\30E1\30FC\30EB\30FB\30C6\30F3\30D7\30EC\30FC\30C8')
,p_attribute_type=>'EMAIL TEMPLATE ID'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('\4F7F\7528\3059\308B\96FB\5B50\30E1\30FC\30EB\30FB\30C6\30F3\30D7\30EC\30FC\30C8\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1802168961897202.442)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>100
,p_prompt=>unistr('\30D7\30EC\30FC\30B9\30DB\30EB\30C0\5024')
,p_attribute_type=>'PLACEHOLDER JSON'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1801033763884282.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8\30FB\30D7\30EC\30FC\30B9\30DB\30EB\30C0\540D\3068\7F6E\63DB\5BFE\8C61\306E\5024\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1802477287905419.442)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>110
,p_prompt=>unistr('\8A00\8A9E\30AA\30FC\30D0\30FC\30E9\30A4\30C9')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1801033763884282.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8A00\8A9E\30B3\30FC\30C9\304C\6307\5B9A\3055\308C\3066\3044\308B\5834\5408\3001\30D7\30ED\30BB\30B9\306F\3053\306E\8A00\8A9E\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\7FFB\8A33\304B\3089\30C6\30F3\30D7\30EC\30FC\30C8\3092\691C\7D22\3057\307E\3059\3002\7FFB\8A33\304C\5B58\5728\3057\306A\3057\5834\5408\3001\30D7\30ED\30BB\30B9\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30D7\30E9\30A4\30DE\30EA\8A00\8A9E\3092\4F7F\7528\3057\307E\3059\3002\7F6E\63DB\69CB\6587\304C\30B5\30DD\30FC\30C8\3055\308C\307E\3059\3002</p>'),
unistr('<p>\8A00\8A9E\30B3\30FC\30C9\968E\5C64\304C\30B5\30DD\30FC\30C8\3055\308C\307E\3059\3002\5024"fr-ca"(\30D5\30E9\30F3\30B9\8A9E - \30AB\30CA\30C0)\304C\6307\5B9A\3055\308C\305F\304C\3001"fr"(\30D5\30E9\30F3\30B9\8A9E)\306E\7FFB\8A33\306E\307F\304C\5B58\5728\3059\308B\5834\5408\3001\3053\306E\7FFB\8A33\304C\4F7F\7528\3055\308C\307E\3059\3002</p>')))
);
end;
/
prompt --application/shared_components/plugins/item_type/file
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(961772418825259055.442)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'FILE'
,p_display_name=>unistr('\30D5\30A1\30A4\30EB\53C2\7167...')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','FILE'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:WIDTH:ICON'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('<em>\300C\53C2\7167...\300D</em>\30DC\30BF\30F3\4ED8\304D\306E\30C6\30AD\30B9\30C8\30FB\30D5\30A3\30FC\30EB\30C9\3092\8868\793A\3057\307E\3059\3002\30E6\30FC\30B6\30FC\306F\3001\300C\53C2\7167\300D\30DC\30BF\30F3\3092\4F7F\7528\3057\3066\30ED\30FC\30AB\30EB\30FB\30D5\30A1\30A4\30EB\30FB\30B7\30B9\30C6\30E0\304B\3089\30D5\30A1\30A4\30EB\3092\7279\5B9A\3057\305F\308A\3001\30A2\30C3\30D7\30ED\30FC\30C9\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961797912421645170.442)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>40
,p_prompt=>unistr('\8A18\61B6\57DF\30BF\30A4\30D7')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'DB_COLUMN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\30A2\30C3\30D7\30ED\30FC\30C9\3055\308C\305F\30D5\30A1\30A4\30EB\304C\683C\7D0D\3055\308C\308B\30C7\30FC\30BF\30D9\30FC\30B9\8868\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(961799013591654950.442)
,p_plugin_attribute_id=>wwv_flow_api.id(961797912421645170.442)
,p_display_sequence=>10
,p_display_value=>unistr('\30A2\30A4\30C6\30E0\30FB\30BD\30FC\30B9\5C5E\6027\3067\6307\5B9A\3055\308C\305FBLOB\5217')
,p_return_value=>'DB_COLUMN'
,p_help_text=>unistr('<strong>\884C\306E\81EA\52D5\51E6\7406(DML)</strong>\30D7\30ED\30BB\30B9\306B\3088\3063\3066\4F7F\7528\3055\308C\308B\8868\304A\3088\3073\30A2\30A4\30C6\30E0\30FB\30BD\30FC\30B9\5C5E\6027\3067\6307\5B9A\3055\308C\305F\5217\306B\30A2\30C3\30D7\30ED\30FC\30C9\3055\308C\308B\30D5\30A1\30A4\30EB\3092\683C\7D0D\3057\307E\3059\3002\5217\306FBLOB\30C7\30FC\30BF\578B\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\30D5\30A1\30A4\30EB\304C\30C0\30A6\30F3\30ED\30FC\30C9\3055\308C\308B\5834\5408\3001<strong>\884C\306E\81EA\52D5\30D5\30A7\30C3\30C1</strong>\30FB\30D7\30ED\30BB\30B9\306E\8868\540D\304C\4F7F\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(728348831149058771.442)
,p_plugin_attribute_id=>wwv_flow_api.id(961797912421645170.442)
,p_display_sequence=>20
,p_display_value=>unistr('\8868APEX_APPLICATION_TEMP_FILES')
,p_return_value=>'APEX_APPLICATION_TEMP_FILES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30D3\30E5\30FCAPEX_APPLICATION_TEMP_FILES\3067\30A2\30AF\30BB\30B9\3067\304D\308B\4E00\6642\7684\306A\5834\6240\306B\30A2\30C3\30D7\30ED\30FC\30C9\3057\305F\30D5\30A1\30A4\30EB\3092\683C\7D0D\3057\307E\3059\3002&PRODUCT_NAME.\306F\3001<strong>\300C\30D5\30A1\30A4\30EB\3092\30D1\30FC\30B8\3059\308B\30BF\30A4\30DF\30F3\30B0\300D</strong>\306E\9078\629E\306B\5FDC\3058\3066\30BB\30C3\30B7\30E7\30F3\306E\7D42\4E86\6642\307E\305F\306F\30A2\30C3\30D7\30ED\30FC\30C9\30FB\30EA\30AF\30A8\30B9\30C8\306E\7D42\4E86\6642\306B\81EA\52D5\7684\306B\30D5\30A1\30A4\30EB\3092\524A\9664\3057\307E\3059\3002</p>'),
unistr('<p><strong>\300C\8907\6570\30D5\30A1\30A4\30EB\306E\8A31\53EF\300D</strong>\304C<strong>\300C\3044\3044\3048\300D</strong>\306B\8A2D\5B9A\3055\308C\3066\3044\308B\5834\5408\306B\30D5\30A1\30A4\30EB\306B\30A2\30AF\30BB\30B9\3059\308B\306B\306F:</p>'),
'<pre>',
'select *',
'  from apex_application_temp_files',
' where name = :<em>page item name</em>;',
'</pre>',
unistr('<p><strong>\300C\8907\6570\30D5\30A1\30A4\30EB\306E\8A31\53EF\300D</strong>\304C<strong>\300C\306F\3044\300D</strong>\306B\8A2D\5B9A\3055\308C\3066\3044\308B\5834\5408\306B\30D5\30A1\30A4\30EB\306B\30A2\30AF\30BB\30B9\3059\308B\306B\306F:</p>'),
'<pre>',
'declare',
'    l_file_names apex_t_varchar2;',
'    l_file       apex_application_temp_files%rowtype;',
'begin',
'    l_file_names := apex_string.split (',
'                        p_str => :<em>page item name</em>,',
'                        p_sep => '':'' );',
'    for i in 1 .. l_file_names.count loop',
'        select *',
'          into l_file',
'          from apex_application_temp_files',
'         where name = l_file_names(i);',
'        -- add code here to store the uploaded file in your own table',
'    end loop;',
'end;',
'</pre>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(961799722296685857.442)
,p_plugin_attribute_id=>wwv_flow_api.id(961797912421645170.442)
,p_display_sequence=>30
,p_display_value=>unistr('WWV_FLOW_FILES\8868')
,p_return_value=>'WWV_FLOW_FILES'
,p_is_deprecated=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30A2\30C3\30D7\30ED\30FC\30C9\3055\308C\308B\30D5\30A1\30A4\30EB\3092&PRODUCT_NAME.\306E\8868<code>WWV_FLOW_FILES</code>\306B\683C\7D0D\3057\307E\3059\3002</p>'),
unistr('<p>\30D5\30A1\30A4\30EB\306E\4F7F\7528\306B\30A2\30AF\30BB\30B9\3059\308B\306B\306F:</p>'),
'<pre>',
'select *',
'  from wwv_flow_files',
' where name = :<em>page item name</em>;',
'</pre>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961780714070314496.442)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>50
,p_prompt=>unistr('MIME\30BF\30A4\30D7\5217')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('\30A2\30C3\30D7\30ED\30FC\30C9\3055\308C\305F\30D5\30A1\30A4\30EB\306EMIME\30BF\30A4\30D7\306E\683C\7D0D\306B\4F7F\7528\3055\308C\308B\5927\6587\5B57\306E\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\540D\3092\5165\529B\3057\307E\3059\3002MIME\30BF\30A4\30D7\306F\3001\30D5\30A1\30A4\30EB\306E\30C0\30A6\30F3\30ED\30FC\30C9\6642\306BBLOB\306E\30B3\30F3\30C6\30F3\30C4\306E\8868\793A\306B\4F7F\7528\3055\308C\308B\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\8B58\5225\3059\308B\305F\3081\306B\30D6\30E9\30A6\30B6\306B\3088\3063\3066\4F7F\7528\3055\308C\307E\3059\3002')
,p_attribute_comment=>'$$$ DJP - Shouldn''t this be an ITEM Pop-up'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961781218572315783.442)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>60
,p_prompt=>unistr('\30D5\30A1\30A4\30EB\540D\5217')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('\30A2\30C3\30D7\30ED\30FC\30C9\3055\308C\305F\30D5\30A1\30A4\30EB\306E\30D5\30A1\30A4\30EB\540D\306E\683C\7D0D\306B\4F7F\7528\3055\308C\308B\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002')
,p_attribute_comment=>'$$$ DJP - Shouldn''t this be an ITEM Pop-up'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961781726537318040.442)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>70
,p_prompt=>unistr('\6587\5B57\30BB\30C3\30C8\5217')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('\30A2\30C3\30D7\30ED\30FC\30C9\3055\308C\305F\30D5\30A1\30A4\30EB\306E\6587\5B57\30BB\30C3\30C8\306E\683C\7D0D\306B\4F7F\7528\3055\308C\308B\5927\6587\5B57\306E\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\540D\3092\5165\529B\3057\307E\3059\3002BLOB\306E\6587\5B57\30BB\30C3\30C8\306F\3001\30A2\30C3\30D7\30ED\30FC\30C9\6642\306B\81EA\52D5\7684\306B\8A2D\5B9A\3055\308C\307E\305B\3093\3002\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\3001\30A2\30C3\30D7\30ED\30FC\30C9\3059\308B\30C9\30AD\30E5\30E1\30F3\30C8\306E\6587\5B57\30BB\30C3\30C8\3092\8A2D\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
,p_attribute_comment=>'$$$ DJP - Shouldn''t this be an ITEM Pop-up'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961782232078319703.442)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>80
,p_prompt=>unistr('BLOB\6700\7D42\66F4\65B0\5217')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('\30D5\30A1\30A4\30EB\306E\30A2\30C3\30D7\30ED\30FC\30C9\6642\306E\73FE\5728\306E\30BF\30A4\30E0\30B9\30BF\30F3\30D7\306E\683C\7D0D\306B\4F7F\7528\3055\308C\308B\5927\6587\5B57\306E\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\540D\3092\5165\529B\3057\307E\3059\3002\3053\306E\65E5\4ED8\5024\306F\3001\30D6\30E9\30A6\30B6\30FB\30AD\30E3\30C3\30B7\30E5\306B\4F7F\7528\3055\308C\307E\3059\3002')
,p_attribute_comment=>'$$$ DJP - Shouldn''t this be an ITEM Pop-up'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961805334341783950.442)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>90
,p_prompt=>unistr('\30C0\30A6\30F3\30ED\30FC\30C9\30FB\30EA\30F3\30AF\306E\8868\793A')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('\3053\306E\30A2\30A4\30C6\30E0\306B\7A7A\3067\306A\3044BLOB\304C\95A2\9023\4ED8\3051\3089\308C\3066\3044\308B\5834\5408\306B\30C0\30A6\30F3\30ED\30FC\30C9\30FB\30EA\30F3\30AF\3092\8868\793A\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961784310308341810.442)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>100
,p_prompt=>unistr('\30EA\30F3\30AF\30FB\30C6\30AD\30B9\30C8\306E\30C0\30A6\30F3\30ED\30FC\30C9')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(961805334341783950.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('\30C0\30A6\30F3\30ED\30FC\30C9\30FB\30EA\30F3\30AF\306E\4E00\90E8\3068\3057\3066\8868\793A\3055\308C\308B\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002\6307\5B9A\3055\308C\306A\3044\5834\5408\3001\5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8\5185\306E<code>APEX.FILE_BROWSE.DOWNLOAD_LINK_TEXT</code>\306E\30C6\30AD\30B9\30C8\30FB\30E1\30C3\30BB\30FC\30B8\306B\683C\7D0D\3055\308C\3066\3044\308B\30C6\30AD\30B9\30C8\304C\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961782727361327744.442)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>110
,p_prompt=>unistr('\30B3\30F3\30C6\30F3\30C4\914D\7F6E')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'attachment'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961805334341783950.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30C0\30A6\30F3\30ED\30FC\30C9\6642\306E\30D6\30E9\30A6\30B6\306B\3088\308B\30B3\30F3\30C6\30F3\30C4\306E\51E6\7406\65B9\6CD5\3092\9078\629E\3057\307E\3059\3002</p>'),
unistr('<p><em>\30CE\30FC\30C8: \3059\3079\3066\306E\30B3\30F3\30C6\30F3\30C4\304C\30A4\30F3\30E9\30A4\30F3\8868\793A\3055\308C\308B\308F\3051\3067\306F\3042\308A\307E\305B\3093\3002\30B3\30F3\30C6\30F3\30C4\306E\30A4\30F3\30E9\30A4\30F3\8868\793A\306B\5BFE\3059\308B\30B5\30DD\30FC\30C8\306F\3001\30D6\30E9\30A6\30B6\306B\3088\3063\3066\7279\5B9A\306EMIME\30BF\30A4\30D7\304C\30B5\30DD\30FC\30C8\3055\308C\3066\3044\308B\304B\3069\3046\304B\306B\3088\3063\3066\7570\306A\308A\307E\3059\3002</em></p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(961783330131328554.442)
,p_plugin_attribute_id=>wwv_flow_api.id(961782727361327744.442)
,p_display_sequence=>10
,p_display_value=>unistr('\30A4\30F3\30E9\30A4\30F3')
,p_return_value=>'inline'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(961783735326330101.442)
,p_plugin_attribute_id=>wwv_flow_api.id(961782727361327744.442)
,p_display_sequence=>20
,p_display_value=>unistr('\6DFB\4ED8')
,p_return_value=>'attachment'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(728349541683084558.442)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>120
,p_prompt=>unistr('\30D5\30A1\30A4\30EB\3092\30D1\30FC\30B8\3059\308B\30BF\30A4\30DF\30F3\30B0')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'SESSION'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APEX_APPLICATION_TEMP_FILES'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('&PRODUCT_NAME.\304C\4E00\6642\30D5\30A1\30A4\30EB\3092\524A\9664\3059\308B\6642\9593\3092\5B9A\7FA9\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(728349853284087310.442)
,p_plugin_attribute_id=>wwv_flow_api.id(728349541683084558.442)
,p_display_sequence=>10
,p_display_value=>unistr('\30BB\30C3\30B7\30E7\30F3\306E\7D42\308F\308A')
,p_return_value=>'SESSION'
,p_help_text=>unistr('\73FE\5728\306E&PRODUCT_NAME.\30BB\30C3\30B7\30E7\30F3\306E\7D42\4E86\6642\306B\30D5\30A1\30A4\30EB\3092\524A\9664\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(728350242833089332.442)
,p_plugin_attribute_id=>wwv_flow_api.id(728349541683084558.442)
,p_display_sequence=>20
,p_display_value=>unistr('\30EA\30AF\30A8\30B9\30C8\306E\7D42\308F\308A')
,p_return_value=>'REQUEST'
,p_help_text=>unistr('\73FE\5728\306EHTTP\30EA\30AF\30A8\30B9\30C8\306E\7D42\4E86\6642\306B\30D5\30A1\30A4\30EB\3092\524A\9664\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(451543969001781322.442)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>130
,p_prompt=>unistr('\8907\6570\30D5\30A1\30A4\30EB\306E\8A31\53EF')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APEX_APPLICATION_TEMP_FILES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8907\6570\306E\30D5\30A1\30A4\30EB\3092\4E00\5EA6\306B\30A2\30C3\30D7\30ED\30FC\30C9\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002</p>'),
'',
unistr('<p>\30CE\30FC\30C8 - \8907\6570\306E\30D5\30A1\30A4\30EB\540D\306F\3001\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306B\30B3\30ED\30F3\3067\533A\5207\308A\3089\308C\305F\30EA\30B9\30C8\3068\3057\3066\683C\7D0D\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(451544768593842902.442)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>140
,p_prompt=>unistr('\30D5\30A1\30A4\30EB\30FB\30BF\30A4\30D7')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<dt>\30A4\30E1\30FC\30B8\30FB\30D5\30A1\30A4\30EB\306E\307F\3092\53D7\3051\5165\308C\308B\3053\3068\3092\6307\5B9A</dt>'),
'<dd><pre>image/*</pre></dd>',
unistr('<dt>\30A4\30E1\30FC\30B8\30FB\30D5\30A1\30A4\30EB\3068\30D3\30C7\30AA\30FB\30D5\30A1\30A4\30EB\306E\307F\3092\53D7\3051\5165\308C\308B\3053\3068\3092\6307\5B9A</dt>'),
'<dd><pre>image/*,video/*</pre></dd>',
unistr('<dt>PNG\30A4\30E1\30FC\30B8\30FB\30D5\30A1\30A4\30EB\306E\307F\3092\53D7\3051\5165\308C\308B\3053\3068\3092\6307\5B9A</dt>'),
'<dd><pre>image/png</pre></dd>'))
,p_help_text=>unistr('\30D6\30E9\30A6\30B6\304C\30A2\30C3\30D7\30ED\30FC\30C9\3059\308B\30D5\30A1\30A4\30EB\3092\5236\9650\3059\308B\305F\3081\306B\4F7F\7528\3067\304D\308B\30AB\30F3\30DE\3067\533A\5207\3089\308C\305F\30D5\30A1\30A4\30EB\30FB\30BF\30A4\30D7\306E\30EA\30B9\30C8\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(13629201915222128.442)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>10
,p_prompt=>unistr('\8868\793A\5F62\5F0F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'INLINE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\30D5\30A1\30A4\30EB\53C2\7167\30A2\30A4\30C6\30E0\306E\8868\793A\65B9\6CD5\3092\793A\3059\8868\793A\30B9\30BF\30A4\30EB\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(13629582056224659.442)
,p_plugin_attribute_id=>wwv_flow_api.id(13629201915222128.442)
,p_display_sequence=>10
,p_display_value=>unistr('\30A4\30F3\30E9\30A4\30F3\30FB\30D5\30A1\30A4\30EB\53C2\7167')
,p_return_value=>'INLINE'
,p_help_text=>unistr('\30DA\30FC\30B8\4E0A\306E\4ED6\306E\30C6\30AD\30B9\30C8\30FB\30D5\30A3\30FC\30EB\30C9\3068\30A2\30A4\30C6\30E0\306B\4F3C\305F\30D5\30A1\30A4\30EB\53C2\7167\5165\529B\30D5\30A3\30FC\30EB\30C9\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(13629902085226258.442)
,p_plugin_attribute_id=>wwv_flow_api.id(13629201915222128.442)
,p_display_sequence=>20
,p_display_value=>unistr('\30A4\30F3\30E9\30A4\30F3\30FB\30C9\30ED\30C3\30D7\30FB\30BE\30FC\30F3')
,p_return_value=>'DROPZONE_INLINE'
,p_help_text=>unistr('\30A4\30F3\30E9\30A4\30F3\30FB\30C9\30ED\30C3\30D7\30FB\30BE\30FC\30F3\306B\30BF\30A4\30C8\30EB\3068\8AAC\660E\304C\793A\3055\308C\308B\30D5\30A1\30A4\30EB\53C2\7167\5165\529B\30D5\30A3\30FC\30EB\30C9\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(13741737113486642.442)
,p_plugin_attribute_id=>wwv_flow_api.id(13629201915222128.442)
,p_display_sequence=>30
,p_display_value=>unistr('\30D6\30ED\30C3\30AF\30FB\30C9\30ED\30C3\30D7\30FB\30BE\30FC\30F3')
,p_return_value=>'DROPZONE_BLOCK'
,p_help_text=>unistr('\30A6\30A3\30B6\30FC\30C9\5F62\5F0F\306E\30C9\30ED\30C3\30D7\30FB\30BE\30FC\30F3\306B\30BF\30A4\30C8\30EB\3068\8AAC\660E\304A\3088\3073\30D5\30A1\30A4\30EB\3092\9078\629E\3059\308B\305F\3081\306E\30DC\30BF\30F3\304C\793A\3055\308C\308B\30D5\30A1\30A4\30EB\53C2\7167\5165\529B\30D5\30A3\30FC\30EB\30C9\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(18970520653850634.442)
,p_plugin_attribute_id=>wwv_flow_api.id(13629201915222128.442)
,p_display_sequence=>40
,p_display_value=>unistr('\30CD\30A4\30C6\30A3\30D6\30FB\30D5\30A1\30A4\30EB\53C2\7167')
,p_return_value=>'NATIVE'
,p_help_text=>unistr('\30D6\30E9\30A6\30B6\306E\30CD\30A4\30C6\30A3\30D6\30FB\30D5\30A9\30FC\30DE\30C3\30C8\3092\4F7F\7528\3057\3066\3001\30D5\30A1\30A4\30EB\53C2\7167\30A2\30A4\30C6\30E0\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(13631853022534008.442)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>20
,p_prompt=>unistr('\30C9\30ED\30C3\30D7\30FB\30BE\30FC\30F3\306E\30BF\30A4\30C8\30EB')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(13629201915222128.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'INLINE,DROPZONE_INLINE,DROPZONE_BLOCK'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30C9\30ED\30C3\30D7\30FB\30BE\30FC\30F3\306E\30BF\30A4\30C8\30EB\3092\6307\5B9A\3057\307E\3059\3002'),
unistr('\3053\306E\30D5\30A3\30FC\30EB\30C9\304C\7A7A\767D\306E\307E\307E\306E\5834\5408\306F\3001\30C7\30D5\30A9\30EB\30C8\3067\3001\30C6\30AD\30B9\30C8\30FB\30E1\30C3\30BB\30FC\30B8<code>APEX.ITEM.FILE.DROP_FILE</code>\307E\305F\306F<code>APEX.ITEM.FILE.DROP_FILES</code>\304C\4F7F\7528\3055\308C\307E\3059\3002')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(13643896497789547.442)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>30
,p_prompt=>unistr('\30C9\30ED\30C3\30D7\30FB\30BE\30FC\30F3\306E\8AAC\660E')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(13629201915222128.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'DROPZONE_INLINE,DROPZONE_BLOCK'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30C9\30ED\30C3\30D7\30FB\30BE\30FC\30F3\306E\8AAC\660E\30C6\30AD\30B9\30C8\3092\6307\5B9A\3057\307E\3059\3002</p>'),
unistr('<p>\3053\306E\30D5\30A3\30FC\30EB\30C9\304C\7A7A\767D\306E\307E\307E\306E\5834\5408\3001\300C\8868\793A\5F62\5F0F\300D\30D7\30ED\30D1\30C6\30A3\306B\5FDC\3058\3066\3001\6B21\306E\30C6\30AD\30B9\30C8\30FB\30E1\30C3\30BB\30FC\30B8\304C\30C7\30D5\30A9\30EB\30C8\3067\4F7F\7528\3055\308C\307E\3059\3002</p>'),
unistr('<p><strong>\30D6\30ED\30C3\30AF\30FB\30C9\30ED\30C3\30D7\30FB\30BE\30FC\30F3</strong><br />'),
'<code>APEX.ITEM.FILE.DROP_OR_CHOOSE_FILE</code> <br />',
'<code>APEX.ITEM.FILE.DROP_OR_CHOOSE_FILES</code>',
'</p>',
unistr('<p><strong>\30A4\30F3\30E9\30A4\30F3\30FB\30C9\30ED\30C3\30D7\30FB\30BE\30FC\30F3</strong><br />'),
'<code>APEX.ITEM.FILE.DROP_OR_SELECT_FILE</code> <br />',
'<code>APEX.ITEM.FILE.DROP_OR_SELECT_FILES</code>',
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(13644378210801196.442)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>unistr('\6700\5927\30D5\30A1\30A4\30EB\30FB\30B5\30A4\30BA')
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_unit=>'KB'
,p_is_translatable=>false
,p_help_text=>unistr('\3053\306E\30A2\30A4\30C6\30E0\3092\4ECB\3057\3066\30A2\30C3\30D7\30ED\30FC\30C9\3055\308C\308B\30D5\30A1\30A4\30EB\306E\8A31\5BB9\3055\308C\308B\6700\5927\30D5\30A1\30A4\30EB\30FB\30B5\30A4\30BA(KB)\3092\5165\529B\3057\307E\3059\3002')
);
end;
/
prompt --application/shared_components/plugins/item_type/list_manager
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(973073216779459799.442)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'LIST_MANAGER'
,p_display_name=>unistr('\30EA\30B9\30C8\30FB\30DE\30CD\30FC\30B8\30E3')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','LIST_MANAGER'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:SOURCE:ELEMENT:ELEMENT_OPTION:PLACEHOLDER:ENCRYPT:LOV:CASCADING_LOV:JOIN_LOV:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30DD\30C3\30D7\30A2\30C3\30D7LOV\30A2\30A4\30B3\30F3\3001<em>\300C\8FFD\52A0\300D</em>\304A\3088\3073<em>\300C\524A\9664\300D</em>\30DC\30BF\30F3\3001\9078\629E\3055\308C\305F\5024\306E\30EA\30B9\30C8\3092\542B\3080\30C6\30AD\30B9\30C8\30FB\30A2\30A4\30C6\30E0\3092\8868\793A\3057\307E\3059\3002</p>'),
unistr('<p>\5024\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002\30DC\30BF\30F3\3092\4F7F\7528\3057\3066\3001\9078\629E\3055\308C\305F\5024\3092\7BA1\7406\3067\304D\307E\3059\3002\9078\629E\3055\308C\305F\5024\306F\30011\3064\306E\30B3\30ED\30F3\3067\533A\5207\3089\308C\305F\6587\5B57\5217\306B\683C\7D0D\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(973075623967480816.442)
,p_plugin_id=>wwv_flow_api.id(973073216779459799.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\30D5\30A7\30C3\30C1')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FIRST_ROWSET'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\30DD\30C3\30D7\30A2\30C3\30D7LOV\304C\958B\304B\308C\305F\3068\304D\306E\30C7\30FC\30BF\306E\8868\793A\65B9\6CD5\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(973076228816482253.442)
,p_plugin_attribute_id=>wwv_flow_api.id(973075623967480816.442)
,p_display_sequence=>10
,p_display_value=>unistr('\30D5\30A7\30C3\30C1\306A\3057')
,p_return_value=>'NO_FETCH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(973077034010483721.442)
,p_plugin_attribute_id=>wwv_flow_api.id(973075623967480816.442)
,p_display_sequence=>20
,p_display_value=>unistr('\6700\521D\306E\884C\30BB\30C3\30C8\3092\30D5\30A7\30C3\30C1')
,p_return_value=>'FIRST_ROWSET'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(973077408168485730.442)
,p_plugin_attribute_id=>wwv_flow_api.id(973075623967480816.442)
,p_display_sequence=>30
,p_display_value=>unistr('\6700\521D\306E\884C\30BB\30C3\30C8\3092\30D5\30A7\30C3\30C1\3057\3066\73FE\5728\306E\5024\3092\30D5\30A3\30EB\30BF')
,p_return_value=>'FIRST_ROWSET_FILTER'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(973074833187474061.442)
,p_plugin_id=>wwv_flow_api.id(973073216779459799.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\5927/\5C0F\6587\5B57\3092\4FDD\6301')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\5024\3092\5165\529B\3069\304A\308A\306E\307E\307E\306B\3059\308B\304B\3001\5927\6587\5B57\306B\5909\63DB\3059\308B\304B\3092\6307\5B9A\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845154323494834504.442)
,p_plugin_id=>wwv_flow_api.id(973073216779459799.442)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_sql_max_column_count=>2
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>SQL\554F\5408\305B\306B\57FA\3065\3044\305FLOV</dt>'),
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>\540C\3058\8868\793A\304A\3088\3073\623B\308A\5024\3092\4F7F\7528\3057\305FLOV</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>\30CE\30FC\30C8: \8868\793A\5024\3068\623B\308A\5024\306E\4E21\65B9\306B\540C\3058\5217\3092\9078\629E\3059\308B\5834\5408\3001\5217\306E\5225\540D\3092\4F7F\7528\3057\307E\3059\3002</p>'),
'</dd>',
unistr('<dt>\30D0\30A4\30F3\30C9\5909\6570\3092\4F7F\7528\3057\305FLOV</dt>'),
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>\30CE\30FC\30C8: <code>P3_DEPTNO</code>\304C\540C\3058\30DA\30FC\30B8\306E\5909\66F4\53EF\80FD\306A\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306E\5834\5408\3001<em>\300C\30AB\30B9\30B1\30FC\30C9LOV\89AA\30A2\30A4\30C6\30E0\300D</em>\5C5E\6027\3092<code>P3_DEPTNO</code>\306B\8A2D\5B9A\3057\307E\3059\3002</dd>'),
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/process_type/form_process_legacy
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1086048547681945775.442)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_PROCESS_LEGACY'
,p_display_name=>unistr('\884C\306E\30EC\30AC\30B7\30FC\81EA\52D5\51E6\7406')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_PROCESS_LEGACY'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('1\3064\306E\30C7\30FC\30BF\30D9\30FC\30B9\8868\307E\305F\306F\66F4\65B0\53EF\80FD\306A\30D3\30E5\30FC\306B\5BFE\3057\3066\30EC\30B3\30FC\30C9\3092\633F\5165\3001\66F4\65B0\307E\305F\306F\524A\9664\3059\308B\30D7\30ED\30BB\30B9\3002\3053\306E\30D7\30ED\30BB\30B9\306F\3001\30BD\30FC\30B9\304C<strong>\30C7\30FC\30BF\30D9\30FC\30B9\5217</strong>\30BF\30A4\30D7\306E\30D5\30A9\30FC\30E0\30FB\30A2\30A4\30C6\30E0\306E\51E6\7406\306B\4F7F\7528\3055\308C\307E\3059\3002\3053\306E\30D7\30ED\30BB\30B9\30FB\30BF\30A4\30D7\3092<strong>\884C\306E\81EA\52D5\51E6\7406(DML)</strong>\306B\66F4\65B0\3059\308B\3053\3068\3092\304A\85A6\3081\3057\307E\3059\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(724250841038369418.442)
,p_plugin_id=>wwv_flow_api.id(1086048547681945775.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\30BF\30A4\30D7')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'INSERT'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\30B5\30DD\30FC\30C8\3055\308C\308B\30C7\30FC\30BF\64CD\4F5C\8A00\8A9E(DML)\306E\64CD\4F5C\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362408026159343735.442)
,p_plugin_attribute_id=>wwv_flow_api.id(724250841038369418.442)
,p_display_sequence=>10
,p_display_value=>unistr('\633F\5165')
,p_return_value=>'INSERT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362408425080344291.442)
,p_plugin_attribute_id=>wwv_flow_api.id(724250841038369418.442)
,p_display_sequence=>20
,p_display_value=>unistr('\66F4\65B0')
,p_return_value=>'UPDATE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362408824002344800.442)
,p_plugin_attribute_id=>wwv_flow_api.id(724250841038369418.442)
,p_display_sequence=>30
,p_display_value=>unistr('\524A\9664')
,p_return_value=>'DELETE'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1086048865137952891.442)
,p_plugin_id=>wwv_flow_api.id(1086048547681945775.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\8868\306E\6240\6709\8005')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>unistr('\8868\306E\6240\6709\8005(\30B9\30AD\30FC\30DE)\540D\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1086049161039954775.442)
,p_plugin_id=>wwv_flow_api.id(1086048547681945775.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\8868\540D')
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(1086048865137952891.442)
,p_help_text=>unistr('\5927/\5C0F\6587\5B57\3092\533A\5225\3057\305F\8868\307E\305F\306F\30D3\30E5\30FC\306E\540D\524D\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1086049455217957445.442)
,p_plugin_id=>wwv_flow_api.id(1086048547681945775.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>50
,p_prompt=>unistr('\4E3B\30AD\30FC\30FB\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\4E3B\30AD\30FC\5217\5024\3092\4FDD\6301\3059\308B\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002\540D\524D\3092\5165\529B\3059\308B\304B\3001\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1086049751766959069.442)
,p_plugin_id=>wwv_flow_api.id(1086048547681945775.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>40
,p_prompt=>unistr('\4E3B\30AD\30FC\5217')
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(1086049161039954775.442)
,p_help_text=>unistr('\4E3B\30AD\30FC\5024\3092\542B\3080\5217\3092\9078\629E\3057\307E\3059\3002\8868\306B\8907\6570\306E\90E8\5206\304B\3089\6210\308B\4E3B\30AD\30FC\304C\3042\308B\5834\5408\3001<strong>ROWID</strong>\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1086053647281173911.442)
,p_plugin_id=>wwv_flow_api.id(1086048547681945775.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\5B9F\884C\6642\306EWHERE\53E5')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\90E8\9580\3092\9650\5B9A:</p>'),
'<pre>DEPTNO = 10</pre>'))
,p_help_text=>unistr('\751F\6210\3055\308C\308B\3059\3079\3066\306ESELECT\6587\3001UPDATE\6587\304A\3088\3073DELETE\6587\306B\8FFD\52A0\3059\308BSQL\306EWHERE\53E5\3092\5165\529B\3057\307E\3059\3002\3053\306E\5C5E\6027\3092\4F7F\7528\3057\3066\3001\81EA\52D5\7684\306B\751F\6210\3055\308C\308BSQL\30B3\30FC\30EB\5185\3067\4F7F\7528\3055\308C\308B\30EC\30B3\30FC\30C9\3092\5236\9650\3057\307E\3059\3002')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/cancel_event
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1112790930653153311.442)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'CANCEL_EVENT'
,p_display_name=>unistr('\30A4\30D9\30F3\30C8\306E\53D6\6D88')
,p_category=>'MISC'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','CANCEL_EVENT'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\73FE\5728\306E\30A4\30D9\30F3\30C8\3092\53D6\308A\6D88\3057\307E\3059\3002')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/item_type/date_picker
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1166598346362318406.442)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'DATE_PICKER'
,p_display_name=>unistr('\65E5\4ED8\30D4\30C3\30AB\30FC(jQuery)')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','DATE_PICKER'),'')
,p_api_version=>1
,p_validation_function=>'dummy_to_trigger_basic_validation'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:FORMAT_MASK_DATE:ELEMENT:WIDTH:PLACEHOLDER:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30AB\30EC\30F3\30C0\30FB\30A2\30A4\30B3\30F3\4ED8\304D\306E\30C6\30AD\30B9\30C8\30FB\30D5\30A3\30FC\30EB\30C9\3092\8868\793A\3057\307E\3059\3002\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\3001\30C6\30AD\30B9\30C8\30FB\30A2\30A4\30C6\30E0\306B\76F4\63A5\65E5\4ED8\3092\5165\529B\3059\308B\304B\3001\30AB\30EC\30F3\30C0\30FB\30A2\30A4\30B3\30F3\3092\30AF\30EA\30C3\30AF\3057\3066\30AB\30EC\30F3\30C0\30FB\30DD\30C3\30D7\30A2\30C3\30D7\304B\3089\65E5\4ED8(\304A\3088\3073\30AA\30D7\30B7\30E7\30F3\3067\6642\9593)\3092\9078\629E\3057\307E\3059\3002</p>'),
unistr('<p>\3053\306E\30A2\30A4\30C6\30E0\306E<em>\66F8\5F0F\30DE\30B9\30AF</em>\306B\6642\9593\30B3\30F3\30DD\30FC\30CD\30F3\30C8\304C\542B\307E\308C\3066\3044\308B\5834\5408\3001\6642\9593\306F\30AB\30EC\30F3\30C0\30FB\30DD\30C3\30D7\30A2\30C3\30D7\306B\306E\307F\8868\793A\3055\308C\307E\3059\3002</p>')))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166599468441343733.442)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\30CF\30A4\30E9\30A4\30C8\3055\308C\305F\65E5\4ED8')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>20090624</code></li>',
'<li><code>+1y+1m+1w</code></li>',
'<li><code>-1m-1w</code></li>',
'<li><code>+1m-1d</code></li>',
'<li><code>&P1_NEXT_AVAILABLE_DATE.</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30AB\30EC\30F3\30C0\30FB\30DD\30C3\30D7\30A2\30C3\30D7\306E\8D77\52D5\6642\306B\30CF\30A4\30E9\30A4\30C8\3055\308C\308B\30C7\30D5\30A9\30EB\30C8\306E\65E5\4ED8\5024\3092\5165\529B\3057\307E\3059\3002\6307\5B9A\3055\308C\306A\3044\5834\5408\3001\30AB\30EC\30F3\30C0\3067\73FE\5728\306E\65E5\4ED8\3068\6642\9593\304C\30CF\30A4\30E9\30A4\30C8\3055\308C\307E\3059\3002</p>'),
unistr('<p>\5024\306F\3001<code>''YYYYMMDDHH24MI''</code>\5F62\5F0F\306E\7D76\5BFE\5024\3001\4ECA\65E5\306E\65E5\4ED8\3092\57FA\6E96\3068\3057\305F\76F8\5BFE\5024(<code>+7d</code>\306A\3069)\3001\307E\305F\306F\7F6E\63DB\69CB\6587\3092\4F7F\7528\3057\305F\52D5\7684\5024(\7F6E\63DB\306B\3088\3063\3066\6B63\3057\3044\65E5\4ED8\66F8\5F0F\307E\305F\306F\76F8\5BFE\5024\304C\8FD4\3055\308C\308B\5834\5408)\3067\3059\3002</p>'),
unistr('<p>\76F8\5BFE\65E5\4ED8\5024\306B\306F\3001\6B21\306E\3082\306E\304C\3042\308A\307E\3059\3002</p>'),
'<dl>',
'  <dt>y</dt>',
unistr('    <dd>\4ECA\65E5\306E\65E5\4ED8\304B\3089\306E+ / -\5E74\6570</dd>'),
'  <dt>m</dt>',
unistr('    <dd>\4ECA\65E5\306E\65E5\4ED8\304B\3089\306E+ / -\6708\6570</dd>'),
'  <dt>w</dt>',
unistr('    <dd>\4ECA\65E5\306E\65E5\4ED8\304B\3089\306E+ / -\9031\6570</dd>'),
'  <dt>d</dt>',
unistr('    <dd>\4ECA\65E5\306E\65E5\4ED8\304B\3089\306E+ / -\65E5\6570</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166598552726329767.442)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\6700\5C0F\65E5\4ED8')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>2009-06-25T23:11:00</code></li>',
'<li><code>200906252311</code></li>',
'<li><code>+1y+1m+1w</code></li>',
'<li><code>-1m-1w</code></li>',
'<li><code>+1m-1d</code></li>',
'<li><code>&P1_MIN_AGE_DATE.</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5165\529B\307E\305F\306F\9078\629E\53EF\80FD\306A\6700\5C0F\65E5\4ED8\3092\5165\529B\3057\307E\3059\3002</p>'),
unistr('<p>\65E5\4ED8\5024\306F\3001<code>''YYYY-MM-DDTHH24:MI:SS''</code>\307E\305F\306F<code>''YYYYMMDDHH24MI''</code>\5F62\5F0F\306E\7D76\5BFE\5024\3001\4ECA\65E5\306E\65E5\4ED8\3092\57FA\6E96\3068\3057\305F\76F8\5BFE\5024(<code>+7d</code>\306A\3069)\3001\307E\305F\306F\7F6E\63DB\69CB\6587\3092\4F7F\7528\3057\305F\52D5\7684\5024(\7F6E\63DB\306B\3088\3063\3066\6B63\3057\3044\65E5\4ED8\66F8\5F0F\307E\305F\306F\76F8\5BFE\5024\304C\8FD4\3055\308C\308B\5834\5408)\3067\3059\3002</p>'),
unistr('<p>\76F8\5BFE\65E5\4ED8\5024\306B\306F\3001\6B21\306E\3082\306E\304C\3042\308A\307E\3059\3002</p>'),
'<dl>',
'  <dt>y</dt>',
unistr('    <dd>\4ECA\65E5\306E\65E5\4ED8\304B\3089\306E+ / -\5E74\6570</dd>'),
'  <dt>m</dt>',
unistr('    <dd>\4ECA\65E5\306E\65E5\4ED8\304B\3089\306E+ / -\6708\6570</dd>'),
'  <dt>w</dt>',
unistr('    <dd>\4ECA\65E5\306E\65E5\4ED8\304B\3089\306E+ / -\9031\6570</dd>'),
'  <dt>d</dt>',
unistr('    <dd>\4ECA\65E5\306E\65E5\4ED8\304B\3089\306E+ / -\65E5\6570</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166598957228331042.442)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\6700\5927\65E5\4ED8')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>2009-06-25T23:11:00</code></li>',
'<li><code>200906252311</code></li>',
'<li><code>+1y+1m+1w</code></li>',
'<li><code>-1m-1w</code></li>',
'<li><code>+1m-1d</code></li>',
'<li><code>&P1_MAX_SIGNUP_DATE.</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5165\529B\307E\305F\306F\9078\629E\53EF\80FD\306A\6700\5927\65E5\4ED8\3092\5165\529B\3057\307E\3059\3002</p>'),
unistr('<p>\65E5\4ED8\5024\306F\3001<code>''YYYY-MM-DDTHH24:MI:SS''</code>\307E\305F\306F<code>''YYYYMMDDHH24MI''</code>\5F62\5F0F\306E\7D76\5BFE\5024\3001\4ECA\65E5\306E\65E5\4ED8\3092\57FA\6E96\3068\3057\305F\76F8\5BFE\5024(<code>+7d</code>\306A\3069)\3001\307E\305F\306F\7F6E\63DB\69CB\6587\3092\4F7F\7528\3057\305F\52D5\7684\5024(\7F6E\63DB\306B\3088\3063\3066\6B63\3057\3044\65E5\4ED8\66F8\5F0F\307E\305F\306F\76F8\5BFE\5024\304C\8FD4\3055\308C\308B\5834\5408)\3067\3059\3002</p>'),
unistr('<p>\76F8\5BFE\65E5\4ED8\5024\306B\306F\3001\6B21\306E\3082\306E\304C\3042\308A\307E\3059\3002</p>'),
'<dl>',
'  <dt>y</dt>',
unistr('    <dd>\4ECA\65E5\306E\65E5\4ED8\304B\3089\306E+ / -\5E74\6570</dd>'),
'  <dt>m</dt>',
unistr('    <dd>\4ECA\65E5\306E\65E5\4ED8\304B\3089\306E+ / -\6708\6570</dd>'),
'  <dt>w</dt>',
unistr('    <dd>\4ECA\65E5\306E\65E5\4ED8\304B\3089\306E+ / -\9031\6570</dd>'),
'  <dt>d</dt>',
unistr('    <dd>\4ECA\65E5\306E\65E5\4ED8\304B\3089\306E+ / -\65E5\6570</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166599961992351304.442)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\8868\793A')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'button'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\65E5\4ED8\30D4\30C3\30AB\30FC\30FB\30DD\30C3\30D7\30A2\30C3\30D7\30FB\30AB\30EC\30F3\30C0\3092\3044\3064\8868\793A\3059\308B\304B\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(975967945937309446.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1166599961992351304.442)
,p_display_sequence=>10
,p_display_value=>unistr('\30D5\30A9\30FC\30AB\30B9\6642')
,p_return_value=>'focus'
,p_help_text=>unistr('\30A2\30A4\30C6\30E0\304C\30D5\30A9\30FC\30AB\30B9\3092\5F97\308B\3068\3059\3050\306B\30AB\30EC\30F3\30C0\30FB\30DD\30C3\30D7\30A2\30C3\30D7\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(975968322865312246.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1166599961992351304.442)
,p_display_sequence=>20
,p_display_value=>unistr('\30A2\30A4\30B3\30F3\30FB\30AF\30EA\30C3\30AF\6642')
,p_return_value=>'button'
,p_help_text=>unistr('\30A2\30A4\30B3\30F3\304C\30AF\30EA\30C3\30AF\3055\308C\308B\3068\3001\30AB\30EC\30F3\30C0\30FB\30DD\30C3\30D7\30A2\30C3\30D7\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(975968729792314196.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1166599961992351304.442)
,p_display_sequence=>30
,p_display_value=>unistr('\4E21\65B9')
,p_return_value=>'both'
,p_help_text=>unistr('\30A2\30A4\30C6\30E0\304C\30D5\30A9\30FC\30AB\30B9\3092\5F97\305F\3068\304D\3001\304A\3088\3073\30A2\30A4\30B3\30F3\304C\30AF\30EA\30C3\30AF\3055\308C\305F\3068\304D\306B\30AB\30EC\30F3\30C0\30FB\30DD\30C3\30D7\30A2\30C3\30D7\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(977131519506267935.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1166599961992351304.442)
,p_display_sequence=>40
,p_display_value=>unistr('\30A4\30F3\30E9\30A4\30F3')
,p_return_value=>'inline'
,p_help_text=>unistr('\30AB\30EC\30F3\30C0\306F\30DA\30FC\30B8\306B\5E38\306B\30A4\30F3\30E9\30A4\30F3\3067\8868\793A\3055\308C\307E\3059\3002\30C6\30AD\30B9\30C8\30FB\30D5\30A3\30FC\30EB\30C9\306F\8868\793A\3055\308C\305A\3001\73FE\5728\306E\65E5\4ED8\306E\9078\629E\304C\30AB\30EC\30F3\30C0\3067\5F37\8ABF\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166600445500356042.442)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\4ED6\306E\6708\3092\8868\793A')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\5148\982D\306B\524D\6708\306E\65E5\4ED8\3092\8868\793A\3057\3001\672B\5C3E\306B\7FCC\6708\306E\65E5\4ED8\3092\8868\793A\3059\308B\304B\3092\6307\5B9A\3057\307E\3059\3002\5148\982D\304A\3088\3073\672B\5C3E\306E\65E5\4ED8\306B\3088\3063\3066\3001\30AB\30EC\30F3\30C0\306E\6700\521D\306E\884C\3068\6700\5F8C\306E\884C\304C\5B8C\5168\306B\57CB\307E\308A\307E\3059\3002\305F\3068\3048\3070\3001\9031\304C\65E5\66DC\65E5\304B\3089\59CB\307E\308A\3001\8868\793A\3055\308C\308B\73FE\5728\306E\6708\306E\6700\521D\306E\65E5\304C\6C34\66DC\65E5\306E\5834\5408\3001\65E5\66DC\65E5\3001\6708\66DC\65E5\304A\3088\3073\706B\66DC\65E5\306B\524D\6708\306E\6700\5F8C\306E3\65E5\9593\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166601947494375554.442)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\6708\6570')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>10
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1166600445500356042.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>3</dt>',
unistr('    <dd>\7E26\306B3\304B\6708\8868\793A\3057\307E\3059\3002</dd>'),
'  <dt>[2,3]</dt>',
unistr('    <dd>2\884C3\5217\30676\304B\6708\8868\793A\3057\307E\3059\3002</dd>'),
'  <dt>[4,3]</dt>',
unistr('    <dd>4\884C3\5217\306712\304B\6708\8868\793A\3057\307E\3059\3002</dd>'),
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30AB\30EC\30F3\30C0\30FB\30DD\30C3\30D7\30A2\30C3\30D7\306B\8868\793A\3059\308B\6708\306E\6570\3092\5165\529B\3057\307E\3059\3002</p>'),
unistr('<p>\6574\6570\5024\307E\305F\306F<code>[<em>row,column</em>]</code>\3092\4F7F\7528\3057\3066\8868\793A\3059\308B\884C\3068\5217\306E\6570\3092\5B9A\7FA9\3057\305F2\6B21\5143\914D\5217\3092\5165\529B\3067\304D\307E\3059\3002</p>'),
unistr('<p><em>\30CE\30FC\30C8: <strong>\300C\30CF\30A4\30E9\30A4\30C8\3055\308C\305F\65E5\4ED8\300D</strong>\3088\308A\5F8C\306E\6708\304C\8868\793A\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166602447625385046.442)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\6B21\306E\30CA\30D3\30B2\30FC\30B7\30E7\30F3\30FB\30EA\30B9\30C8')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\30AB\30EC\30F3\30C0\30FB\30DD\30C3\30D7\30A2\30C3\30D7\5185\306E\6708\307E\305F\306F\5E74\306B\9078\629E\30EA\30B9\30C8\3092\8868\793A\3059\308B\304B\3069\3046\304B\3092\9078\629E\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(785072709337552768.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1166602447625385046.442)
,p_display_sequence=>5
,p_display_value=>unistr('\306A\3057')
,p_return_value=>'NONE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(785071421673546859.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1166602447625385046.442)
,p_display_sequence=>10
,p_display_value=>unistr('\6708')
,p_return_value=>'MONTH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(785071825829548006.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1166602447625385046.442)
,p_display_sequence=>20
,p_display_value=>unistr('\5E74')
,p_return_value=>'YEAR'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(785072306567551978.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1166602447625385046.442)
,p_display_sequence=>30
,p_display_value=>unistr('\6708\3068\5E74')
,p_return_value=>'MONTH_AND_YEAR'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166600943554364880.442)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\5E74\306E\7BC4\56F2')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>50
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1166602447625385046.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'YEAR,MONTH_AND_YEAR'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>2000:2010</dt>',
unistr('    <dd>\7D76\5BFE\5E74\3092\4F7F\7528\3057\3066\3001\8A31\5BB9\3055\308C\308B\5E74\30922000\5E74\30682010\5E74\306E\9593(2000\5E74\30682010\5E74\3092\542B\3080)\306B\5236\9650\3057\307E\3059\3002</dd>'),
'  <dt>-05:+05</dt>',
unistr('    <dd>\76F8\5BFE\65E5\3092\4F7F\7528\3057\3066\3001\8A31\5BB9\3055\308C\308B\5E74\3092\73FE\5728\306E\5E74\304B\3089+/- 5\5E74\306B\5236\9650\3057\307E\3059\3002</dd>'),
'  <dt>+01:+03</dt>',
unistr('    <dd>\76F8\5BFE\65E5\3092\4F7F\7528\3057\3066\3001\8A31\5BB9\3055\308C\308B\5E74\3092\7FCC\5E74\304B\30892\5E74\9593\306B\5236\9650\3057\307E\3059\3002</dd>'),
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30AB\30EC\30F3\30C0\30FB\30DD\30C3\30D7\30A2\30C3\30D7\5185\306E<strong>\300C\5E74\300D</strong>\9078\629E\30EA\30B9\30C8\306B\8868\793A\3055\308C\308B\3001\8A31\5BB9\3055\308C\308B\5E74\306E\7BC4\56F2\3092\5165\529B\3057\307E\3059\3002</p>'),
unistr('<p>\5E74\306E\5024\306F\3001<code>''YYYY:YYYY''</code>\5F62\5F0F\306E\7D76\5BFE\5024\307E\305F\306F	<code>''-nn:+nn''</code> (<code>nn</code>\306F\6574\6570\5024)\5F62\5F0F\306E\76F8\5BFE\5024\3067\3059\3002')))
);
end;
/
prompt --application/shared_components/plugins/item_type/text_field
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1230861140507488144.442)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'TEXT_FIELD'
,p_display_name=>unistr('\30C6\30AD\30B9\30C8\30FB\30D5\30A3\30FC\30EB\30C9')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','TEXT_FIELD'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:ELEMENT:WIDTH:PLACEHOLDER:ICON:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\30C6\30AD\30B9\30C8\30FB\30D5\30A3\30FC\30EB\30C9\3092\8868\793A\3057\307E\3059\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1230861330595494795.442)
,p_plugin_id=>wwv_flow_api.id(1230861140507488144.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>20
,p_prompt=>unistr('[Enter]\3092\62BC\3059\3068\9001\4FE1')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>unistr('\3053\306E\30D5\30A3\30FC\30EB\30C9\3067<em>[Enter]</em>\30AD\30FC\3092\62BC\3059\3068\3001\30DA\30FC\30B8\304C\81EA\52D5\7684\306B\9001\4FE1\3055\308C\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1230861822761501984.442)
,p_plugin_id=>wwv_flow_api.id(1230861140507488144.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>30
,p_prompt=>unistr('\7121\52B9')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30A2\30A4\30C6\30E0\3092\7121\52B9\306B\3057\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\5024\3092\5909\66F4\3067\304D\306A\3044\3088\3046\306B\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002</p>'),
unistr('<p>HTML\66F8\5F0F\304C\524A\9664\3055\308C\308B\3001<em>\8868\793A\306E\307F</em>\306E\30A2\30A4\30C6\30E0\30FB\30BF\30A4\30D7\3068\306F\7570\306A\308A\3001\7121\52B9\306A\30C6\30AD\30B9\30C8\30FB\30A2\30A4\30C6\30E0\306F\540C\3058HTML\66F8\5F0F\3067\8868\793A\3055\308C\307E\3059\3002\7121\52B9\306A\30C6\30AD\30B9\30C8\30FB\30A2\30A4\30C6\30E0\306F\30DA\30FC\30B8\30FB\30BD\30FC\30B9\306E\4E00\90E8\3067\3001\305D\306E\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\3092\8A55\4FA1\3067\304D\307E\3059\3002\53CD\5BFE\306B\3001\8868\793A\306E\307F\306E\30A2\30A4\30C6\30E0\306F\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\306B\683C\7D0D\3055\308C\307E\305B\3093\3002</p>')))
,p_attribute_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$$ DJP  - Is this equivalent to specifying Read Only = Always?',
'If so do we need this attribute?'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1230862319775510558.442)
,p_plugin_id=>wwv_flow_api.id(1230861140507488144.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>40
,p_prompt=>unistr('\30DA\30FC\30B8\306E\9001\4FE1\6642\306B\9001\4FE1')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1230861822761501984.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('\30DA\30FC\30B8\306E\9001\4FE1\6642\306B\73FE\5728\306E\30A2\30A4\30C6\30E0\5024\3092\9001\4FE1\3059\308B\5FC5\8981\304C\3042\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
,p_attribute_comment=>'$$$ DJP - Why can this only be set when Disabled = Y?'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2642009195904118.442)
,p_plugin_id=>wwv_flow_api.id(1230861140507488144.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>10
,p_prompt=>unistr('\30B5\30D6\30BF\30A4\30D7')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'TEXT'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('HTML5\30C6\30AD\30B9\30C8\30FB\30B5\30D6\30BF\30A4\30D7\3092\9078\629E\3057\307E\3059\3002\3053\308C\306B\3088\3063\3066\3001\30AA\30F3\30B9\30AF\30EA\30FC\30F3\30FB\30AD\30FC\30DC\30FC\30C9\306E\4ED8\3044\305F\30C7\30D0\30A4\30B9\3067\3001\30B5\30D6\30BF\30A4\30D7\3054\3068\306B\6700\9069\5316\3055\308C\305F\30AD\30FC\30DC\30FC\30C9\30FB\30EC\30A4\30A2\30A6\30C8\3092\8868\793A\3067\304D\308B\305F\3081\3001\30C7\30FC\30BF\5165\529B\304C\7C21\5358\306B\306A\308A\307E\3059\3002\30B5\30D6\30BF\30A4\30D7\306E\9078\629E\306F\3001\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306E\5024\3092\4F7F\7528\3057\3066\9069\5207\306A\30EA\30F3\30AF\3092\30EC\30F3\30C0\30EA\30F3\30B0\3059\308B\969B\306B\3082\4F7F\7528\3055\308C\307E\3059(\8AAD\53D6\308A\5C02\7528\3067\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\308B\5834\5408)\3002\7269\7406\30AD\30FC\30DC\30FC\30C9\3092\4F7F\7528\3059\308B\5834\5408\3001\3053\306E\5C5E\6027\3067\30C6\30AD\30B9\30C8\30FB\30A2\30A4\30C6\30E0\3084\30C7\30FC\30BF\30FB\30A8\30F3\30C8\30EA\306F\5909\66F4\3055\308C\307E\305B\3093\3002'),
'</p>',
unistr('<p><strong><em>\30CE\30FC\30C8: </strong>\3053\308C\306FHTML5\306E\6A5F\80FD\306E\305F\3081\3001\5BFE\5FDC\3059\308B\30D6\30E9\30A6\30B6\3067\306E\307F\6A5F\80FD\3057\307E\3059\3002\53E4\3044\3001HTML5\306B\6E96\62E0\3057\3066\3044\306A\3044\30D6\30E9\30A6\30B6\3067\306F\3053\306E\5C5E\6027\306F\7121\8996\3055\308C\3001\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306F\901A\5E38\306E\30C6\30AD\30B9\30C8\30FB\30D5\30A3\30FC\30EB\30C9\3068\3057\3066\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\307E\3059\3002</em></p>')))
,p_attribute_comment=>'$$$ DJP - Shouldn''t this be for Mobile UI only?'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(4337919498933328.442)
,p_plugin_attribute_id=>wwv_flow_api.id(2642009195904118.442)
,p_display_sequence=>5
,p_display_value=>unistr('\30C6\30AD\30B9\30C8')
,p_return_value=>'TEXT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2643201361911326.442)
,p_plugin_attribute_id=>wwv_flow_api.id(2642009195904118.442)
,p_display_sequence=>10
,p_display_value=>unistr('\96FB\5B50\30E1\30FC\30EB')
,p_return_value=>'EMAIL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2643606901912900.442)
,p_plugin_attribute_id=>wwv_flow_api.id(2642009195904118.442)
,p_display_sequence=>20
,p_display_value=>unistr('\96FB\8A71\756A\53F7')
,p_return_value=>'TEL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(228427524363055714.442)
,p_plugin_attribute_id=>wwv_flow_api.id(2642009195904118.442)
,p_display_sequence=>25
,p_display_value=>unistr('\691C\7D22')
,p_return_value=>'SEARCH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2644810018913786.442)
,p_plugin_attribute_id=>wwv_flow_api.id(2642009195904118.442)
,p_display_sequence=>30
,p_display_value=>'URL'
,p_return_value=>'URL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362145212820086745.442)
,p_plugin_id=>wwv_flow_api.id(1230861140507488144.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>15
,p_prompt=>unistr('\7A7A\767D\306E\5207\6368\3066')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_default_value=>'BOTH'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\30DA\30FC\30B8\306E\9001\4FE1\5F8C\306E\30A2\30A4\30C6\30E0\5024\306E\5207\6368\3066\65B9\6CD5\3092\9078\629E\3057\307E\3059\3002\3053\306E\8A2D\5B9A\306B\3088\3063\3066\3001\5165\529B\3055\308C\305F\30C6\30AD\30B9\30C8\304B\3089\3001\7A7A\767D\3001\30BF\30D6\304A\3088\3073\6539\884C\304C\5207\308A\6368\3066\3089\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362145508722088644.442)
,p_plugin_attribute_id=>wwv_flow_api.id(362145212820086745.442)
,p_display_sequence=>10
,p_display_value=>unistr('\5148\982D')
,p_return_value=>'LEADING'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362145906566089618.442)
,p_plugin_attribute_id=>wwv_flow_api.id(362145212820086745.442)
,p_display_sequence=>20
,p_display_value=>unistr('\672B\5C3E')
,p_return_value=>'TRAILING'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362146304625090506.442)
,p_plugin_attribute_id=>wwv_flow_api.id(362145212820086745.442)
,p_display_sequence=>30
,p_display_value=>unistr('\5148\982D\304A\3088\3073\672B\5C3E')
,p_return_value=>'BOTH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362147027041095284.442)
,p_plugin_attribute_id=>wwv_flow_api.id(362145212820086745.442)
,p_display_sequence=>40
,p_display_value=>unistr('\306A\3057')
,p_return_value=>'NONE'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(580485075516965313.442)
,p_plugin_id=>wwv_flow_api.id(1230861140507488144.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>16
,p_prompt=>unistr('\30C6\30AD\30B9\30C8\306E\5927/\5C0F\6587\5B57')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>unistr('\5909\66F4\306A\3057')
,p_help_text=>unistr('\30A2\30A4\30C6\30E0\5024\306E\30C6\30AD\30B9\30C8\306E\5927/\5C0F\6587\5B57\3092\5909\63DB\3059\308B\65B9\6CD5\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(580485397894966793.442)
,p_plugin_attribute_id=>wwv_flow_api.id(580485075516965313.442)
,p_display_sequence=>10
,p_display_value=>unistr('\5C0F\6587\5B57')
,p_return_value=>'LOWER'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(580485762023967520.442)
,p_plugin_attribute_id=>wwv_flow_api.id(580485075516965313.442)
,p_display_sequence=>20
,p_display_value=>unistr('\5927\6587\5B57')
,p_return_value=>'UPPER'
);
end;
/
prompt --application/shared_components/plugins/item_type/hidden
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1230888011377927220.442)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'HIDDEN'
,p_display_name=>unistr('\975E\8868\793A')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','HIDDEN'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE:ENCRYPT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\30DA\30FC\30B8\30FB\30BD\30FC\30B9\5185\306B\542B\307E\308C\3066\3044\308B\304C\3001\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\306A\3044\30A2\30A4\30C6\30E0\3002\975E\8868\793A\306E\30A2\30A4\30C6\30E0\5024\306F\3001\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\306B\4FDD\5B58\3055\308C\307E\3059\3002\901A\5E38\3001\30DA\30FC\30B8\51E6\7406\307E\305F\306F\4ED6\306E\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3067\5FC5\8981\3068\3055\308C\308B\5024\306E\683C\7D0D\306B\4F7F\7528\3055\308C\307E\3059\304C\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306B\8868\793A\3055\308C\307E\305B\3093\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1230888530209942193.442)
,p_plugin_id=>wwv_flow_api.id(1230888011377927220.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\4FDD\8B77\3055\308C\305F\5024')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\30DA\30FC\30B8\306E\6295\7A3F\6642\306B\30A2\30A4\30C6\30E0\3092\4FDD\8B77\3057\3001\5024\304C\64CD\4F5C\3055\308C\306A\3044\3088\3046\306B\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
end;
/
prompt --application/shared_components/plugins/item_type/display_image
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1411721528366264478.442)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'DISPLAY_IMAGE'
,p_display_name=>unistr('\30A4\30E1\30FC\30B8\306E\8868\793A')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','DISPLAY_IMAGE'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SOURCE:ELEMENT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9BLOB\5217\306B\683C\7D0D\3055\308C\3066\3044\308B\30A4\30E1\30FC\30B8\307E\305F\306F\30A4\30E1\30FC\30B8URL\306B\57FA\3065\3044\305F\30A4\30E1\30FC\30B8\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1411722225512282537.442)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\57FA\6E96')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'DB_COLUMN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\30A4\30E1\30FC\30B8\306E\53D6\5F97\5143\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1411722839364286570.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1411722225512282537.442)
,p_display_sequence=>10
,p_display_value=>unistr('\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\5024\306B\683C\7D0D\3055\308C\305F\30A4\30E1\30FC\30B8URL')
,p_return_value=>'URL'
,p_help_text=>unistr('\30A4\30E1\30FC\30B8URL\306F\3001\6307\5B9A\3055\308C\305F\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306E\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\306B\683C\7D0D\3055\308C\3066\3044\308B\5024\304B\3089\8AAD\307F\53D6\3089\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1411723213999298173.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1411722225512282537.442)
,p_display_sequence=>20
,p_display_value=>unistr('\30A2\30A4\30C6\30E0\30FB\30BD\30FC\30B9\3067\6307\5B9A\3055\308C\305FBLOB\5217')
,p_return_value=>'DB_COLUMN'
,p_help_text=>unistr('<strong>\300C\30A2\30A4\30C6\30E0\30FB\30BD\30FC\30B9\300D</strong>\5C5E\6027\3067\6307\5B9A\3055\308C\305FBLOB\5217\304B\3089\30A4\30E1\30FC\30B8\3092\8AAD\307F\53D6\308A\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(967663732298251689.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1411722225512282537.442)
,p_display_sequence=>30
,p_display_value=>unistr('SQL\6587\3067\623B\3055\308C\305FBLOB\5217')
,p_return_value=>'SQL'
,p_help_text=>unistr('\6307\5B9A\3055\308C\305FSQL\6587\306B\3088\3063\3066\8FD4\3055\308C\308BBLOB\5217\306B\57FA\3065\3044\305F\30A4\30E1\30FC\30B8\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1411726413054354627.442)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\4EE3\66FF\30C6\30AD\30B9\30C8')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1411722225512282537.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'URL'
,p_help_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\3053\306E\30A2\30A4\30C6\30E0\306B\30CA\30D3\30B2\30FC\30C8\3057\305F\3068\304D\30B9\30AF\30EA\30FC\30F3\30FB\30EA\30FC\30C0\30FC\306B\3088\3063\3066\8AAD\307F\4E0A\3052\3089\308C\308B\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(483911502060080155.442)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\4EE3\66FF\30C6\30AD\30B9\30C8\5217')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1411722225512282537.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('\3053\306E\30A4\30E1\30FC\30B8\306E\4EE3\66FF\30C6\30AD\30B9\30C8\3092\4FDD\6301\3059\308B\5927\6587\5B57\306E\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\540D\3092\5165\529B\3057\307E\3059\3002\3053\306E\30C6\30AD\30B9\30C8\306F\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\3053\306E\30A2\30A4\30C6\30E0\306B\30CA\30D3\30B2\30FC\30C8\3059\308B\3068\3001\30B9\30AF\30EA\30FC\30F3\30FB\30EA\30FC\30C0\30FC\306B\3088\3063\3066\8AAD\307F\4E0A\3052\3089\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1411725016255336668.442)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\30D5\30A1\30A4\30EB\540D\5217')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1411722225512282537.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('BLOB\5217\306B\95A2\9023\4ED8\3051\3089\308C\3066\3044\308B\30D5\30A1\30A4\30EB\540D\5217\5024\3092\4FDD\6301\3059\308B\5927\6587\5B57\306E\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\540D\3092\5165\529B\3057\307E\3059\3002')
,p_attribute_comment=>'$$$ DJP - Why isn''t this an ITEM Popup LOV'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1411725531492341063.442)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>60
,p_prompt=>unistr('BLOB\6700\7D42\66F4\65B0\5217')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1411722225512282537.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\95A2\9023\4ED8\3051\3089\308C\3066\3044\308BBLOB\304C\6700\5F8C\306B\66F4\65B0\3055\308C\305F\65E5\4ED8\306E\5217\5024\3092\4FDD\6301\3059\308B\5927\6587\5B57\306E\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\540D\3092\5165\529B\3057\307E\3059\3002</p>'),
unistr('<p>\3053\306E\5024\306F\3001\30D6\30E9\30A6\30B6\30FB\30AD\30E3\30C3\30B7\30F3\30B0\304A\3088\3073\30D6\30E9\30A6\30B6\304B\3089\306E\6700\5F8C\306E\30EA\30AF\30A8\30B9\30C8\4EE5\964D\30A4\30E1\30FC\30B8\304C\5909\66F4\3055\308C\305F\304B\3069\3046\304B\306E\8B58\5225\306B\4F7F\7528\3055\308C\307E\3059\3002\30A4\30E1\30FC\30B8\304C\66F4\65B0\3055\308C\3066\3044\306A\3044\5834\5408\3001\30A4\30E1\30FC\30B8\304C\30D6\30E9\30A6\30B6\30FB\30AD\30E3\30C3\30B7\30E5\306B\3042\308C\3070\305D\306E\30A4\30E1\30FC\30B8\304C\53D6\5F97\3055\308C\307E\3059\3002</p>')))
,p_attribute_comment=>'$$$ DJP - Why isn''t this an ITEM Popup LOV'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(967666433253270876.442)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>70
,p_prompt=>unistr('SQL\6587')
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_sql_min_column_count=>1
,p_sql_max_column_count=>4
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1411722225512282537.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select product_image,',
'       product_name as alt_text,',
'       filename,',
'       mimetype',
'  from demo_product_info',
' where product_id = :P6_PRODUCT_ID',
'</pre>'))
,p_help_text=>unistr('\30A4\30E1\30FC\30B8\3092\542B\3080BLOB\5217\3092\8FD4\3059SQL\6587\3092\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(91302656605713331.442)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>50
,p_prompt=>unistr('MIME\30BF\30A4\30D7\5217')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1411722225512282537.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('\30A2\30C3\30D7\30ED\30FC\30C9\3055\308C\305F\30D5\30A1\30A4\30EB\306EMIME\30BF\30A4\30D7\306E\683C\7D0D\306B\4F7F\7528\3055\308C\308B\5927\6587\5B57\306E\30DA\30FC\30B8\307E\305F\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\540D\3092\5165\529B\3057\307E\3059\3002MIME\30BF\30A4\30D7\306F\3001\30D5\30A1\30A4\30EB\306E\30C0\30A6\30F3\30ED\30FC\30C9\6642\306BBLOB\306E\30B3\30F3\30C6\30F3\30C4\306E\8868\793A\306B\4F7F\7528\3055\308C\308B\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\8B58\5225\3059\308B\305F\3081\306B\30D6\30E9\30A6\30B6\306B\3088\3063\3066\4F7F\7528\3055\308C\307E\3059\3002')
);
end;
/
prompt --application/shared_components/plugins/item_type/auto_complete
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1446346919506821055.442)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'AUTO_COMPLETE'
,p_display_name=>unistr('\30AA\30FC\30C8\30B3\30F3\30D7\30EA\30FC\30C8\304C\6709\52B9\306A\30C6\30AD\30B9\30C8\30FB\30D5\30A3\30FC\30EB\30C9')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','AUTO_COMPLETE'),'')
,p_javascript_file_urls=>'[require jet]#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.inputSearch#MIN#.js'
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_validation_function=>'dummy'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:ESCAPE_OUTPUT:SOURCE:ELEMENT:WIDTH:PLACEHOLDER:ICON:ENCRYPT:LOV:CASCADING_LOV:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\5165\529B\3057\305F\30C6\30AD\30B9\30C8\306B\57FA\3065\3044\3066\30C6\30AD\30B9\30C8\30FB\30A2\30A4\30C6\30E0\304C\57CB\3081\8FBC\307E\308C\305F\3001\4F7F\7528\53EF\80FD\306A\5024\306E\30EA\30B9\30C8\3092\8868\793A\3059\308B\30C6\30AD\30B9\30C8\30FB\30D5\30A3\30FC\30EB\30C9\3092\8868\793A\3057\307E\3059\3002\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\30C6\30AD\30B9\30C8\3092\5165\529B\3059\308B\306B\3064\308C\3066\30EA\30B9\30C8\304C\7D5E\308A\8FBC\307E\308C\307E\3059\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1446356110531045518.442)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\691C\7D22')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'CONTAINS_IGNORE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5165\529B\5024\306B\5BFE\3059\308B\691C\7D22\306E\5B9F\884C\65B9\6CD5\3092\9078\629E\3057\307E\3059\3002<em>\9045\5EF6\30ED\30FC\30C9</em>\3092\4F7F\7528\3059\308B\5834\5408\3001\3053\306E\8A2D\5B9A\304C\554F\5408\305B\306E\30D1\30D5\30A9\30FC\30DE\30F3\30B9\306B\5F71\97FF\3059\308B\3053\3068\304C\3042\308A\307E\3059\3002</p>'),
unistr('<p><em>\30CE\30FC\30C8: <strong>\300C\300C\6B21\3092\542B\3080\300D\304A\3088\3073\300C\5927/\5C0F\6587\5B57\3092\533A\5225\300D\300D</strong>\307E\305F\306F<strong>\300C\300C\6B21\3092\542B\3080\300D\304A\3088\3073\300C\5927/\5C0F\6587\5B57\533A\5225\306A\3057\300D\300D</strong>\3092\9078\629E\3059\308B\3068\3001\5217\7D22\5F15\304C\4F7F\7528\3055\308C\307E\305B\3093\3002</em></p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1097406465150066557.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1446356110531045518.442)
,p_display_sequence=>10
,p_display_value=>unistr('\300C\6B21\3092\542B\3080\300D\304A\3088\3073\300C\5927/\5C0F\6587\5B57\3092\533A\5225\300D')
,p_return_value=>'CONTAINS_CASE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1097406557760066557.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1446356110531045518.442)
,p_display_sequence=>20
,p_display_value=>unistr('\5B8C\5168\304A\3088\3073\5927/\5C0F\6587\5B57\533A\5225')
,p_return_value=>'EXACT_CASE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1097406651197066557.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1446356110531045518.442)
,p_display_sequence=>30
,p_display_value=>unistr('\300C\6B21\3092\542B\3080\300D\304A\3088\3073\300C\5927/\5C0F\6587\5B57\533A\5225\306A\3057\300D')
,p_return_value=>'CONTAINS_IGNORE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1097406756688066558.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1446356110531045518.442)
,p_display_sequence=>40
,p_display_value=>unistr('\300C\5B8C\5168\300D\304A\3088\3073\300C\5927/\5C0F\6587\5B57\533A\5225\306A\3057\300D')
,p_return_value=>'EXACT_IGNORE'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1446360005383072413.442)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\9045\5EF6\30ED\30FC\30C9')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p><em>\9045\5EF6\30ED\30FC\30C9</em>\624B\6CD5\3092\4F7F\7528\3057\3066\4E00\81F4\3059\308B\5024\3092\30C7\30FC\30BF\30D9\30FC\30B9\304B\3089\53D6\5F97\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002\9045\5EF6\30ED\30FC\30C9\3067\306F\3001\30E6\30FC\30B6\30FC\304C\6587\5B57\3092\5165\529B\3059\308B\305F\3073\306B\3001\4E00\81F4\3059\308B\30EC\30B3\30FC\30C9\304C\30C7\30FC\30BF\30D9\30FC\30B9\304B\3089\53D6\5F97\3055\308C\307E\3059\3002\305D\3046\3067\306F\306A\3044\5834\5408\3001\3059\3079\3066\306E\30EA\30B9\30C8\5024\304C\30DA\30FC\30B8\306E\30ED\30FC\30C9\6642\306B\30ED\30FC\30C9\3055\308C\307E\3059\3002</p>'),
unistr('<p>\591A\6570\306E\30EC\30B3\30FC\30C9\306E\30ED\30FC\30C9\306B\3088\3063\3066\30DA\30FC\30B8\306E\521D\671F\30ED\30FC\30C9\6642\9593\304C\5F71\97FF\3092\53D7\3051\308B\3053\3068\304C\3042\308B\305F\3081\3001\9078\629E\30EA\30B9\30C8\304C\5927\304D\3044\5834\5408\3001<em>\9045\5EF6\30ED\30FC\30C9</em>\3092\4F7F\7528\3059\308B\3053\3068\3092\304A\85A6\3081\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1446361019928076629.442)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\30EA\30B9\30C8\5185\306E\6700\5927\5024')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>3
,p_max_length=>3
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1446360005383072413.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9078\629E\30DC\30C3\30AF\30B9\306B\8868\793A\3059\308B\30A2\30A4\30C6\30E0\306E\6700\5927\6570\3092\5165\529B\3057\307E\3059\3002</p> '),
unistr('<p>\3053\306E\5024\306B\3088\3063\3066\3001\591A\6570\306E\884C\3092\8FD4\3059\3053\3068\306B\3088\308B\30D1\30D5\30A9\30FC\30DE\30F3\30B9\306E\554F\984C\3092\56DE\907F\3067\304D\3001\6570\6587\5B57\306E\307F\304C\5165\529B\3055\308C\305F\5834\5408\306B\623B\308A\30BB\30C3\30C8\304C\975E\5E38\306B\5927\304D\304F\306A\308B\3053\3068\3082\907F\3051\3089\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(224532777127157782.442)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\6700\5C0F\691C\7D22')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_show_in_wizard=>false
,p_unit=>unistr('\6587\5B57')
,p_is_translatable=>false
,p_help_text=>unistr('<p>\691C\7D22\3092\5B9F\884C\3059\308B\524D\306B\3001\5165\529B\3059\308B\5FC5\8981\304C\3042\308B\6700\5C0F\6587\5B57\6570\3092\6307\5B9A\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388196560996701804.442)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>45
,p_prompt=>unistr('\30AD\30E3\30C3\30B7\30E5')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1446360005383072413.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>\9045\5EF6\30ED\30FC\30C9\3092\4F7F\7528\3057\3066\4E00\81F4\3059\308B\30EC\30B3\30FC\30C9\3092\53D6\5F97\3059\308B\969B\306B\3001\691C\7D22\7D50\679C\3092\30AD\30E3\30C3\30B7\30E5\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845152901732834477.442)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.442)
,p_name=>'LOV'
,p_sql_min_column_count=>1
,p_sql_max_column_count=>1
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\5185\306E\540C\3058\5024\306E\8868\793A\3068\683C\7D0D</dt>'),
'<dd><pre>',
'select ename',
'  from emp',
' order by 1',
'</pre></dd>',
unistr('<dt>\30D0\30A4\30F3\30C9\5909\6570\306E\4F7F\7528\306B\3088\308B\7279\5B9A\306E\90E8\9580\306E\5F93\696D\54E1\306E\8868\793A</dt>'),
'<dd><pre>',
'select ename',
'  from emp',
' where deptno = :P3_DEPTNO',
' order by 1',
'</pre>',
unistr('<p>\30CE\30FC\30C8: <code>P3_DEPTNO</code>\304C\540C\3058\30DA\30FC\30B8\306E\5909\66F4\53EF\80FD\306A\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306E\5834\5408\3001<em>\300C\30AB\30B9\30B1\30FC\30C9LOV\89AA\30A2\30A4\30C6\30E0\300D</em>\5C5E\6027\3092<code>P3_DEPTNO</code>\306B\8A2D\5B9A\3057\307E\3059\3002</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(345454551021287898.442)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.442)
,p_name=>'ojupdate'
,p_display_name=>unistr('\66F4\65B0')
);
end;
/
prompt --application/shared_components/plugins/item_type/rich_text_editor
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1630055805138100682.442)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'RICH_TEXT_EDITOR'
,p_display_name=>unistr('\30EA\30C3\30C1\30FB\30C6\30AD\30B9\30C8\30FB\30A8\30C7\30A3\30BF')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','RICH_TEXT_EDITOR'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:WIDTH:HEIGHT:PLACEHOLDER:ENCRYPT:FILTER:LINK:INIT_JAVASCRIPT_CODE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\69D8\3005\306A\30C6\30AD\30B9\30C8\66F8\5F0F\8A2D\5B9A\30AA\30D7\30B7\30E7\30F3\3092\6301\3064\30C6\30AD\30B9\30C8\9818\57DF\3092\8868\793A\3057\307E\3059\3002\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\3001Microsoft Word\306A\3069\306E\30EF\30FC\30C9\30FB\30D7\30ED\30BB\30C3\30B5\3092\4F7F\7528\3057\305F\5834\5408\3068\540C\69D8\306E\5F62\5F0F\3067\8868\793A\3055\308C\308B\30B3\30F3\30C6\30F3\30C4\3092\5411\4E0A\3055\305B\308B\3053\3068\304C\3067\304D\307E\3059\3002\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\3001\30EA\30C3\30C1\30FB\30C6\30AD\30B9\30C8\30FB\30D5\30A9\30FC\30DE\30C3\30C8(RTF)\30D5\30A1\30A4\30EB\5F62\5F0F\306E\30C9\30AD\30E5\30E1\30F3\30C8\3092\3053\306E\30A2\30A4\30C6\30E0\306B<em>\30AB\30C3\30C8\30FB\30A2\30F3\30C9\30FB\30DA\30FC\30B9\30C8</em>\3059\308B\3053\3068\3082\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1343844517421090812.442)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.442)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\30EC\30B9\30DD\30F3\30B7\30D6[\975E\63A8\5968]')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>unistr('\30EA\30C3\30C1\30FB\30C6\30AD\30B9\30C8\30FB\30A8\30C7\30A3\30BF\3092\30B3\30F3\30C6\30CA\30FB\30EA\30FC\30B8\30E7\30F3\306E\30B5\30A4\30BA\306B\81EA\52D5\7684\306B\5408\305B\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002\3053\308C\3092\884C\3046\306B\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304C\30E6\30CB\30D0\30FC\30B5\30EB\30FB\30C6\30FC\30DE\307E\305F\306F\5225\306E\30EC\30B9\30DD\30F3\30B7\30D6\30FB\30C6\30FC\30DE\3092\4F7F\7528\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1630056002845109474.442)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\30C4\30FC\30EB\30D0\30FC')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_default_value=>'Intermediate'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(635934396859331517.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'HTML'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\30A8\30C7\30A3\30BF\5185\3067\4F7F\7528\3067\304D\308B\30C6\30AD\30B9\30C8\66F8\5F0F\8A2D\5B9A\30AA\30D7\30B7\30E7\30F3\306E\6570\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1630056586699114299.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1630056002845109474.442)
,p_display_sequence=>10
,p_display_value=>unistr('\57FA\672C')
,p_return_value=>'Basic'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1263397500002270668.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1630056002845109474.442)
,p_display_sequence=>20
,p_display_value=>unistr('\4E2D\9593')
,p_return_value=>'Intermediate'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1630056989123115033.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1630056002845109474.442)
,p_display_sequence=>30
,p_display_value=>unistr('\5B8C\5168')
,p_return_value=>'Full'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1630057694103125908.442)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\30C4\30FC\30EB\30D0\30FC\306E\62E1\5F35')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1262285287257225297.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'4'
,p_help_text=>unistr('\30A8\30C7\30A3\30BF\304C\30C6\30AD\30B9\30C8\9818\57DF\5185\3067\521D\3081\306F\958B\304B\308C\3066\3044\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1630058192849134992.442)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\30B9\30AD\30F3')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1262285287257225297.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'4'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\30A8\30C7\30A3\30BF\306E\30B9\30BF\30A4\30EB\8A2D\5B9A\306B\4F7F\7528\3055\308C\308B\30A8\30C7\30A3\30BF\30FB\30B9\30AD\30F3\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1630058796312136026.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1630058192849134992.442)
,p_display_sequence=>1
,p_display_value=>'Moono'
,p_return_value=>'moono'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1637507209047437360.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1630058192849134992.442)
,p_display_sequence=>2
,p_display_value=>'Moono color'
,p_return_value=>'moonocolor'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1630059200467137193.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1630058192849134992.442)
,p_display_sequence=>3
,p_display_value=>'Kama'
,p_return_value=>'kama'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1270283182212293963.442)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\30C4\30FC\30EB\30D0\30FC\306E\4F4D\7F6E')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_default_value=>'top'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1262285287257225297.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'4'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\30A8\30C7\30A3\30BF\3092\8868\793A\3059\308B\30C6\30AD\30B9\30C8\9818\57DF\5185\306E\5834\6240\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1270283477898295997.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1270283182212293963.442)
,p_display_sequence=>10
,p_display_value=>unistr('\30C8\30C3\30D7')
,p_return_value=>'top'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1270283876173296808.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1270283182212293963.442)
,p_display_sequence=>20
,p_display_value=>unistr('\4E0B')
,p_return_value=>'bottom'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1262285287257225297.442)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>5
,p_prompt=>unistr('\30D0\30FC\30B8\30E7\30F3')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>unistr('CK\30A8\30C7\30A3\30BF5')
,p_deprecated_values=>'4'
,p_help_text=>unistr('<p>CKEditor 4\306F\975E\63A8\5968\306B\306A\3063\3066\304A\308A\3001\307E\3082\306A\304FCKEditor 5\306B\7F6E\304D\63DB\3048\3089\308C\307E\3059\3002\5C06\6765\306E\30D0\30FC\30B8\30E7\30F3\3067\3054\4F7F\7528\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304C\4F7F\7528\3067\304D\306A\304F\306A\308B\30EA\30B9\30AF\3092\907F\3051\308B\305F\3081\306B\3001\3053\306E\5207\66FF\3048\3092\4ECA\3059\3050\306B\884C\3046\3053\3068\3092\304A\85A6\3081\3057\307E\3059\3002\30AB\30B9\30BF\30E0\521D\671F\5316Javascript\30B3\30FC\30C9\3092\4F7F\7528\3057\3066\3044\308B\5834\5408\306F\3001CKEditor\306EAPI\304C\5909\66F4\3055\308C\3066\3044\308B\305F\3081\3001\3054\4F7F\7528\306E\30B3\30FC\30C9\3092\8ABF\6574\3059\308B\5FC5\8981\304C\751F\3058\308B\53EF\80FD\6027\304C\9AD8\3044\3053\3068\306B\6CE8\610F\3057\3066\304F\3060\3055\3044\3002</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1262285918525227088.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1262285287257225297.442)
,p_display_sequence=>10
,p_display_value=>unistr('CK\30A8\30C7\30A3\30BF4 [\975E\63A8\5968]')
,p_return_value=>'4'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1262287152809234036.442)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\6700\5C0F\9AD8')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_default_value=>'180'
,p_display_length=>100
,p_unit=>unistr('\30D4\30AF\30BB\30EB')
,p_is_translatable=>false
,p_help_text=>unistr('\7DE8\96C6\53EF\80FD\9818\57DF\306E\9AD8\3055\306E\6700\5C0F\5024\3092\30D4\30AF\30BB\30EB\5358\4F4D\3067\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1262288044006238954.442)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\6700\5927\9AD8')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>100
,p_unit=>unistr('\30D4\30AF\30BB\30EB')
,p_is_translatable=>false
,p_help_text=>unistr('\7DE8\96C6\53EF\80FD\9818\57DF\306E\9AD8\3055\306E\6700\5927\5024\3092\30D4\30AF\30BB\30EB\5358\4F4D\3067\8A2D\5B9A\3057\307E\3059\3002\3053\306E\5C5E\6027\3092\7A7A\306E\307E\307E\306B\3059\308B\3068\3001\5165\529B\306B\5408\308F\305B\3066\30A8\30C7\30A3\30BF\304C\7121\9650\306B\62E1\5F35\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(635934396859331517.442)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>1
,p_prompt=>unistr('\66F8\5F0F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'MARKDOWN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\30EA\30C3\30C1\30FB\30C6\30AD\30B9\30C8\30FB\30A8\30C7\30A3\30BF\3067\5165\529B\3055\308C\308B\30B3\30F3\30C6\30F3\30C4\306E\51FA\529B\5F62\5F0F\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(635934864536336814.442)
,p_plugin_attribute_id=>wwv_flow_api.id(635934396859331517.442)
,p_display_sequence=>10
,p_display_value=>'HTML'
,p_return_value=>'HTML'
,p_help_text=>unistr('\3053\306E\30EA\30C3\30C1\30FB\30C6\30AD\30B9\30C8\30FB\30A8\30C7\30A3\30BF\306E\30BD\30FC\30B9\304A\3088\3073\51FA\529B\7528\306BHTML\3092\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(635935286305339196.442)
,p_plugin_attribute_id=>wwv_flow_api.id(635934396859331517.442)
,p_display_sequence=>20
,p_display_value=>unistr('\30DE\30FC\30AF\30C0\30A6\30F3')
,p_return_value=>'MARKDOWN'
,p_help_text=>unistr('\3053\306E\30EA\30C3\30C1\30FB\30C6\30AD\30B9\30C8\30FB\30A8\30C7\30A3\30BF\306E\30BD\30FC\30B9\304A\3088\3073\51FA\529B\7528\306B\30DE\30FC\30AF\30C0\30A6\30F3\5F62\5F0F\3092\4F7F\7528\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(3112575602612766963.442)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.442)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function(options){',
unistr('    // \81EA\52D5\66F8\5F0F\8A2D\5B9A\6A5F\80FD\3092\7121\52B9\306B\3057\307E\3059'),
'    options.editorOptions.removePlugins.push(''Autoformat'');',
unistr('    // \30AB\30B9\30BF\30E0\30FB\30C4\30FC\30EB\30D0\30FC\3092\9069\7528\3057\307E\3059'),
'    options.editorOptions.toolbar = [',
'        ''heading'', ''bulletedList'', ''numberedList'', ''fontSize'', ''undo'', ''redo''',
'    ];',
'    return options;',
'}',
'</pre>'))
,p_help_text=>unistr('\6A19\6E96\30A8\30C7\30A3\30BF\69CB\6210\3092\30AA\30FC\30D0\30FC\30E9\30A4\30C9\3059\308BJavaScript\95A2\6570\3092\5165\529B\3057\307E\3059\3002CKEditor5\56FA\6709\306E\30AA\30D7\30B7\30E7\30F3\306F\3001<code>options.editorOptions</code>\306B\9069\7528\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\8A73\7D30\306F\3001CKEditor5 API\30C9\30AD\30E5\30E1\30F3\30C8\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002')
);
end;
/
prompt --application/shared_components/plugins/item_type/color_picker
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1779772489424311086.442)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COLOR_PICKER'
,p_display_name=>unistr('\30AB\30E9\30FC\30FB\30D4\30C3\30AB\30FC')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COLOR_PICKER'),'')
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:ELEMENT:WIDTH:PLACEHOLDER:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\30E6\30FC\30B6\30FC\306B\30AB\30E9\30FC\306E\9078\629E\307E\305F\306F\5165\529B\3092\8A31\53EF\3057\307E\3059\3002\30AB\30E9\30FC\306F\30AB\30E9\30FC\30FB\30B9\30DA\30AF\30C8\30EB\304B\3089\9078\629E\3067\304D\307E\3059\3002')
,p_version_identifier=>'2.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(550403250259918560.442)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.442)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>20
,p_prompt=>unistr('\30E2\30FC\30C9')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FULL'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(551367544301244965.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'NATIVE'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\30AB\30E9\30FC\30FB\30D4\30C3\30AB\30FC\306B\8868\793A\3055\308C\308B\60C5\5831\306E\91CF\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550403921767922285.442)
,p_plugin_attribute_id=>wwv_flow_api.id(550403250259918560.442)
,p_display_sequence=>10
,p_display_value=>unistr('\30B7\30F3\30D7\30EB')
,p_return_value=>'SIMPLE'
,p_help_text=>unistr('\30AB\30E9\30FC\30FB\30B9\30DA\30AF\30C8\30EB\30FB\30B3\30F3\30C8\30ED\30FC\30EB\3068\30AB\30E9\30FC\30FB\30D7\30EA\30BB\30C3\30C8\306E\307F\3092\8868\793A\3057\307E\3059(\5B9A\7FA9\3055\308C\3066\3044\308B\5834\5408)\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550404269414923460.442)
,p_plugin_attribute_id=>wwv_flow_api.id(550403250259918560.442)
,p_display_sequence=>20
,p_display_value=>unistr('\5B8C\5168')
,p_return_value=>'FULL'
,p_help_text=>unistr('\300C\623B\308A\5024\306E\5F62\5F0F\300D\306B\5FDC\3058\3066\30AA\30D7\30B7\30E7\30F3\306E\30A2\30EB\30D5\30A1\5024\3092\6301\3064\30AB\30E9\30FC\3092HEX\3001HSL\3001\307E\305F\306FRGB\5024\3068\3057\3066\8868\793A\307E\305F\306F\5165\529B\3059\308B\8FFD\52A0\30D5\30A3\30FC\30EB\30C9\3092\8868\793A\3057\307E\3059\3002\300C\6700\521D\306E\30AB\30E9\30FC\300D\3068\300C\73FE\5728\306E\30AB\30E9\30FC\300D\3082\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551367544301244965.442)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.442)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>unistr('\8868\793A\5F62\5F0F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'POPUP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\30AB\30E9\30FC\30FB\30D4\30C3\30AB\30FC\306E\8868\793A\65B9\6CD5\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551368003116247557.442)
,p_plugin_attribute_id=>wwv_flow_api.id(551367544301244965.442)
,p_display_sequence=>10
,p_display_value=>unistr('\30DD\30C3\30D7\30A2\30C3\30D7')
,p_return_value=>'POPUP'
,p_help_text=>unistr('\30AB\30E9\30FC\306F\30C6\30AD\30B9\30C8\30FB\30D5\30A3\30FC\30EB\30C9\306B\5165\529B\3059\308B\304B\3001\30DD\30C3\30D7\30A2\30C3\30D7\30FB\30AB\30E9\30FC\30FB\30D4\30C3\30AB\30FC\304B\3089\9078\629E\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551368367822248327.442)
,p_plugin_attribute_id=>wwv_flow_api.id(551367544301244965.442)
,p_display_sequence=>20
,p_display_value=>unistr('\30A4\30F3\30E9\30A4\30F3')
,p_return_value=>'INLINE'
,p_help_text=>unistr('\30AB\30E9\30FC\30FB\30D4\30C3\30AB\30FC\304C\30A4\30F3\30E9\30A4\30F3\3067\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551368820390249888.442)
,p_plugin_attribute_id=>wwv_flow_api.id(551367544301244965.442)
,p_display_sequence=>30
,p_display_value=>unistr('\30AB\30E9\30FC\306E\307F\306E\30DD\30C3\30D7\30A2\30C3\30D7')
,p_return_value=>'COLOR_ONLY'
,p_help_text=>unistr('\30DC\30BF\30F3\3067\30DD\30C3\30D7\30A2\30C3\30D7\30FB\30AB\30E9\30FC\30FB\30D4\30C3\30AB\30FC\304C\958B\304D\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551469948272853196.442)
,p_plugin_attribute_id=>wwv_flow_api.id(551367544301244965.442)
,p_display_sequence=>40
,p_display_value=>unistr('\30CD\30A4\30C6\30A3\30D6\30FB\30AB\30E9\30FC\30FB\30D4\30C3\30AB\30FC')
,p_return_value=>'NATIVE'
,p_help_text=>unistr('\30CD\30A4\30C6\30A3\30D6\30FB\30D6\30E9\30A6\30B6\306E\30AB\30E9\30FC\5165\529B\3002UI\306F\30D6\30E9\30A6\30B6\306B\4F9D\5B58\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(630450561726642679.442)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\30C7\30D5\30A9\30EB\30C8\306E\4F7F\7528')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\300C\5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8\300D>\300C\30B3\30F3\30DD\30FC\30CD\30F3\30C8\8A2D\5B9A\300D\3067\3001\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\5BFE\3057\3066\5B9A\7FA9\3055\308C\3066\3044\308B\30C7\30D5\30A9\30EB\30C8\307E\305F\306F\30AB\30B9\30BF\30E0\8A2D\5B9A\306E\3044\305A\308C\3092\4F7F\7528\3059\308B\304B\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(550407832783006227.442)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>30
,p_prompt=>unistr('\30E2\30FC\30C9')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FULL'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(630450561726642679.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30AB\30E9\30FC\30FB\30D4\30C3\30AB\30FC\306B\8868\793A\3055\308C\308B\60C5\5831\306E\91CF\3092\9078\629E\3057\307E\3059\3002</p>'),
unistr('<p>\300C\8868\793A\5F62\5F0F\300D\304C\300C\30CD\30A4\30C6\30A3\30D6\30FB\30AB\30E9\30FC\30FB\30D4\30C3\30AB\30FC\300D\306E\5834\5408\3001\3053\308C\306F\9069\7528\3055\308C\306A\3044\3053\3068\306B\6CE8\610F\3057\3066\304F\3060\3055\3044\3002</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550408418705007375.442)
,p_plugin_attribute_id=>wwv_flow_api.id(550407832783006227.442)
,p_display_sequence=>10
,p_display_value=>unistr('\30B7\30F3\30D7\30EB')
,p_return_value=>'SIMPLE'
,p_help_text=>unistr('\30AB\30E9\30FC\30FB\30B9\30DA\30AF\30C8\30EB\30FB\30B3\30F3\30C8\30ED\30FC\30EB\3068\30AB\30E9\30FC\30FB\30D7\30EA\30BB\30C3\30C8\306E\307F\3092\8868\793A\3057\307E\3059(\5B9A\7FA9\3055\308C\3066\3044\308B\5834\5408)\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550408900996015864.442)
,p_plugin_attribute_id=>wwv_flow_api.id(550407832783006227.442)
,p_display_sequence=>20
,p_display_value=>unistr('\5B8C\5168')
,p_return_value=>'FULL'
,p_help_text=>unistr('\300C\623B\308A\5024\306E\5F62\5F0F\300D\306B\5FDC\3058\3066\30AA\30D7\30B7\30E7\30F3\306E\30A2\30EB\30D5\30A1\5024\3092\6301\3064\30AB\30E9\30FC\3092HEX\3001HSL\3001\307E\305F\306FRGB\5024\3068\3057\3066\8868\793A\307E\305F\306F\5165\529B\3059\308B\8FFD\52A0\30D5\30A3\30FC\30EB\30C9\3092\8868\793A\3057\307E\3059\3002\300C\6700\521D\306E\30AB\30E9\30FC\300D\3068\300C\73FE\5728\306E\30AB\30E9\30FC\300D\3082\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(550764493023397466.442)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>20
,p_prompt=>unistr('\8868\793A\5F62\5F0F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'POPUP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(630450561726642679.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\30AB\30E9\30FC\30FB\30D4\30C3\30AB\30FC\306E\8868\793A\65B9\6CD5\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550765244915400562.442)
,p_plugin_attribute_id=>wwv_flow_api.id(550764493023397466.442)
,p_display_sequence=>10
,p_display_value=>unistr('\30DD\30C3\30D7\30A2\30C3\30D7')
,p_return_value=>'POPUP'
,p_help_text=>unistr('\30AB\30E9\30FC\306F\30C6\30AD\30B9\30C8\30FB\30D5\30A3\30FC\30EB\30C9\306B\5165\529B\3059\308B\304B\3001\30DD\30C3\30D7\30A2\30C3\30D7\30FB\30AB\30E9\30FC\30FB\30D4\30C3\30AB\30FC\304B\3089\9078\629E\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550764781445398986.442)
,p_plugin_attribute_id=>wwv_flow_api.id(550764493023397466.442)
,p_display_sequence=>20
,p_display_value=>unistr('\30A4\30F3\30E9\30A4\30F3')
,p_return_value=>'INLINE'
,p_help_text=>unistr('\30AB\30E9\30FC\30FB\30D4\30C3\30AB\30FC\304C\30A4\30F3\30E9\30A4\30F3\3067\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550765575345402504.442)
,p_plugin_attribute_id=>wwv_flow_api.id(550764493023397466.442)
,p_display_sequence=>30
,p_display_value=>unistr('\30AB\30E9\30FC\306E\307F\306E\30DD\30C3\30D7\30A2\30C3\30D7')
,p_return_value=>'COLOR_ONLY'
,p_help_text=>unistr('\30DC\30BF\30F3\3067\30DD\30C3\30D7\30A2\30C3\30D7\30FB\30AB\30E9\30FC\30FB\30D4\30C3\30AB\30FC\304C\958B\304D\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551473676631880984.442)
,p_plugin_attribute_id=>wwv_flow_api.id(550764493023397466.442)
,p_display_sequence=>40
,p_display_value=>unistr('\30CD\30A4\30C6\30A3\30D6\30FB\30AB\30E9\30FC\30FB\30D4\30C3\30AB\30FC')
,p_return_value=>'NATIVE'
,p_help_text=>unistr('\30CD\30A4\30C6\30A3\30D6\30FB\30D6\30E9\30A6\30B6\306E\30AB\30E9\30FC\5165\529B\3002UI\306F\30D6\30E9\30A6\30B6\306B\4F9D\5B58\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551688608315986495.442)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\30AB\30E9\30FC\30FB\30D7\30EA\30BB\30C3\30C8')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'THEME_STYLE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(550764493023397466.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'NATIVE'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\30AB\30E9\30FC\30FB\30D4\30C3\30AB\30FC\3067\4E8B\524D\5B9A\7FA9\6E08\30AB\30E9\30FC\306E\30BB\30C3\30C8\3092\8868\793A\3059\308B\304B\3001\307E\305F\8868\793A\3059\308B\5834\5408\306F\30C6\30FC\30DE\3068\30AB\30B9\30BF\30E0\306E\3069\3061\3089\304B\3089\8868\793A\3059\308B\304B\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551689124385987538.442)
,p_plugin_attribute_id=>wwv_flow_api.id(551688608315986495.442)
,p_display_sequence=>10
,p_display_value=>unistr('\306A\3057')
,p_return_value=>'NONE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551689545726989556.442)
,p_plugin_attribute_id=>wwv_flow_api.id(551688608315986495.442)
,p_display_sequence=>20
,p_display_value=>unistr('\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB\30FB\30AB\30E9\30FC')
,p_return_value=>'THEME_STYLE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551689930702991102.442)
,p_plugin_attribute_id=>wwv_flow_api.id(551688608315986495.442)
,p_display_sequence=>30
,p_display_value=>unistr('\30AB\30B9\30BF\30E0\30FB\30AB\30E9\30FC')
,p_return_value=>'CUSTOM'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551690436138997704.442)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\30AB\30E9\30FC')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(551688608315986495.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'CUSTOM'
,p_examples=>'#FF0000;#00FF00;#0000FF;rgb(27,204,119)'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30AB\30E9\30FC\30FB\30D4\30C3\30AB\30FC\306E\30C0\30A4\30A2\30ED\30B0\306B\8868\793A\3055\308C\308B\30D7\30EA\30BB\30C3\30C8\30FB\30AB\30E9\30FC\306E\30EA\30B9\30C8\3002'),
unistr('\30BB\30DF\30B3\30ED\30F3\3092\4F7F\7528\3057\3066\30AB\30E9\30FC\3092\533A\5207\308A\307E\3059\3002')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551690938640005057.442)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\30B3\30F3\30C8\30E9\30B9\30C8\5BFE\8C61')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(550764493023397466.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'NATIVE'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\3053\306E\30A2\30A4\30C6\30E0\306E\30AB\30E9\30FC\3092\5225\306E\30A2\30A4\30C6\30E0\306E\30AB\30E9\30FC\307E\305F\306F\9759\7684\5024\3068\6BD4\8F03\3057\3066\3001\305D\308C\3089\306E\9593\306E\30B3\30F3\30C8\30E9\30B9\30C8\6BD4\3092\30AB\30E9\30FC\30FB\30D4\30C3\30AB\30FCUI\306B\8868\793A\3067\304D\308B\3088\3046\306B\3057\307E\3059\3002  '),
unistr('\3053\308C\306F\3001\30E6\30FC\30B6\30FC\304C\3059\3079\3066\306E\4EBA\306B\3068\3063\3066\898B\3084\3059\3044\5341\5206\306A\30B3\30F3\30C8\30E9\30B9\30C8\306E\30AB\30E9\30FC\3092\9078\629E\3059\308B\306E\306B\5F79\7ACB\3064\5834\5408\304C\3042\308A\307E\3059\3002')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551691368715005731.442)
,p_plugin_attribute_id=>wwv_flow_api.id(551690938640005057.442)
,p_display_sequence=>10
,p_display_value=>unistr('\306A\3057')
,p_return_value=>'NONE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551691786900007756.442)
,p_plugin_attribute_id=>wwv_flow_api.id(551690938640005057.442)
,p_display_sequence=>20
,p_display_value=>unistr('\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0')
,p_return_value=>'PAGE_ITEM'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551692243251008710.442)
,p_plugin_attribute_id=>wwv_flow_api.id(551690938640005057.442)
,p_display_sequence=>30
,p_display_value=>unistr('\9759\7684\30AB\30E9\30FC')
,p_return_value=>'STATIC'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551692721781014969.442)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\30B3\30F3\30C8\30E9\30B9\30C8\30FB\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(551690938640005057.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PAGE_ITEM'
,p_help_text=>unistr('\30B3\30F3\30C8\30E9\30B9\30C8\6BD4\8F03\306B\4F7F\7528\3059\308B\30A2\30A4\30C6\30E0\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551693186879019659.442)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\30B3\30F3\30C8\30E9\30B9\30C8\30FB\30AB\30E9\30FC')
,p_attribute_type=>'COLOR'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(551690938640005057.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC'
,p_help_text=>unistr('\30B3\30F3\30C8\30E9\30B9\30C8\6BD4\8F03\306B\4F7F\7528\3059\308B\8272\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(549148889210907047.442)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\623B\308A\5024\306E\5F62\5F0F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'HEX'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(550764493023397466.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'NATIVE'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\3053\306E\30A2\30A4\30C6\30E0\306B\3088\3063\3066\8FD4\3055\308C\308B\30AB\30E9\30FC\5024\306E\5F62\5F0F\3092\6307\5B9A\3057\307E\3059\3002\30AB\30E9\30FC\304C\5225\306E\6709\52B9\306A\5F62\5F0F\3067\5165\529B\3055\308C\305F\5834\5408\3067\3082\3001\3053\306E\5F62\5F0F\3067\8868\793A\3055\308C\3001\8FD4\3055\308C\3001\30B5\30FC\30D0\30FC\306B\9001\4FE1\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(549149330423908665.442)
,p_plugin_attribute_id=>wwv_flow_api.id(549148889210907047.442)
,p_display_sequence=>10
,p_display_value=>unistr('16\9032')
,p_return_value=>'HEX'
,p_help_text=>unistr('HEX\30AB\30E9\30FC\5024\3002\30A2\30EB\30D5\30A1\5024\306F\8A31\53EF\3055\308C\307E\305B\3093\3002\4F8B: #2244ee')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(549149780463910228.442)
,p_plugin_attribute_id=>wwv_flow_api.id(549148889210907047.442)
,p_display_sequence=>20
,p_display_value=>'RGB'
,p_return_value=>'RGB'
,p_help_text=>unistr('rgb\95A2\6570\8868\8A18\306E\8D64\3001\7DD1\3001\9752\3002\4F8B: rgb(34,68,238)')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(549320695805038594.442)
,p_plugin_attribute_id=>wwv_flow_api.id(549148889210907047.442)
,p_display_sequence=>30
,p_display_value=>'RGB/RGBA'
,p_return_value=>'RGBA'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('rgb/rgba\95A2\6570\8868\8A18\3067\3001\30AA\30D7\30B7\30E7\30F3\306E\30A2\30EB\30D5\30A1(\900F\660E\5EA6)\304C\3042\308B\8D64\3001\7DD1\3001\9752\3002'),
unistr('\30AB\30E9\30FC\306B\30A2\30EB\30D5\30A1\304C\306A\3044(\30A2\30EB\30D5\30A1\304C1\306B\7B49\3057\3044)\5834\5408\3001RGB\5F62\5F0F\304C\4F7F\7528\3055\308C\307E\3059\3002'),
unistr('\30AB\30E9\30FC\306B\30A2\30EB\30D5\30A1\304C\3042\308B\5834\5408\3001RGBA\5F62\5F0F\304C\4F7F\7528\3055\308C\307E\3059\3002'),
unistr('\4F8B: rgba(34,68,238,0.5)')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(549150182877911677.442)
,p_plugin_attribute_id=>wwv_flow_api.id(549148889210907047.442)
,p_display_sequence=>40
,p_display_value=>'HSL'
,p_return_value=>'HSL'
,p_help_text=>unistr('hsl\95A2\6570\8868\8A18\306E\8272\76F8\3001\5F69\5EA6\3001\660E\5EA6\3002\4F8B: hsl(230,86,53)')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(549321101724039553.442)
,p_plugin_attribute_id=>wwv_flow_api.id(549148889210907047.442)
,p_display_sequence=>50
,p_display_value=>'HSL/HSLA'
,p_return_value=>'HSLA'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('hsl/hsla\95A2\6570\8868\8A18\3067\3001\30AA\30D7\30B7\30E7\30F3\306E\30A2\30EB\30D5\30A1(\900F\660E\5EA6)\304C\3042\308B\8272\76F8\3001\5F69\5EA6\3001\660E\5EA6\3002'),
unistr('\30AB\30E9\30FC\306B\30A2\30EB\30D5\30A1\304C\306A\3044(\30A2\30EB\30D5\30A1\304C1\306B\7B49\3057\3044)\5834\5408\3001HSL\5F62\5F0F\304C\4F7F\7528\3055\308C\307E\3059\3002'),
unistr('\30AB\30E9\30FC\306B\30A2\30EB\30D5\30A1\304C\3042\308B\5834\5408\3001HSLA\5F62\5F0F\304C\4F7F\7528\3055\308C\307E\3059\3002'),
unistr('\4F8B: hsla(230,86,53,0.5)')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(549321450357041193.442)
,p_plugin_attribute_id=>wwv_flow_api.id(549148889210907047.442)
,p_display_sequence=>60
,p_display_value=>unistr('\4EFB\610F\306ECSS\5024')
,p_return_value=>'CSS'
,p_help_text=>unistr('\30AB\30E9\30FC\540D\307E\305F\306FCSS\5909\6570\3092\542B\3080\4EFB\610F\306E\6709\52B9\306ACSS\30AB\30E9\30FC\5F62\5F0F\3002')
);
end;
/
prompt --application/shared_components/plugins/item_type/popup_lov
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1800066898109169760.442)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'POPUP_LOV'
,p_display_name=>unistr('\30DD\30C3\30D7\30A2\30C3\30D7LOV')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','POPUP_LOV'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:ELEMENT:WIDTH:PLACEHOLDER:ICON:ENCRYPT:LOV:LOV_DISPLAY_NULL:CASCADING_LOV:JOIN_LOV:FILTER:LINK:INIT_JAVASCRIPT_CODE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30DD\30C3\30D7\30A2\30C3\30D7LOV\30A2\30A4\30B3\30F3\4ED8\304D\306E\30C6\30AD\30B9\30C8\30FB\30A2\30A4\30C6\30E0\3092\8868\793A\3057\307E\3059\3002\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\30A2\30A4\30B3\30F3\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\691C\7D22\30D5\30A3\30FC\30EB\30C9\304A\3088\3073\30B5\30DD\30FC\30C8\3055\308C\308B\5024\306E\30EA\30B9\30C8\3092\542B\3080\30DD\30C3\30D7\30A2\30C3\30D7\30FB\30A6\30A3\30F3\30C9\30A6\304C\8868\793A\3055\308C\307E\3059\3002</p>'),
unistr('<p>\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\691C\7D22\57FA\6E96\3092\5165\529B\3057\3066\3001\8868\793A\3055\308C\308B\4F7F\7528\53EF\80FD\306A\5024\3092\7D5E\308A\8FBC\3080\3053\3068\304C\3067\304D\308B\305F\3081\3001\5927\304D\306A\30EA\30B9\30C8\306B\306F\30DD\30C3\30D7\30A2\30C3\30D7LOV\304C\6700\9069\3067\3059\3002\6BD4\8F03\7684\5C0F\3055\306A\30EA\30B9\30C8\306B\306F\3001\591A\304F\306E\5834\5408<em>\9078\629E\30EA\30B9\30C8</em>\306E\65B9\304C\9069\3057\3066\3044\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1800068983311222289.442)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\8868\793A\5F62\5F0F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'POPUP'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\30DD\30C3\30D7\30A2\30C3\30D7LOV\306E\8868\793A\65B9\6CD5\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1800069590238224258.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1800068983311222289.442)
,p_display_sequence=>10
,p_display_value=>unistr('\30E2\30FC\30C0\30EB\30FB\30C0\30A4\30A2\30ED\30B0')
,p_return_value=>'DIALOG'
,p_help_text=>unistr('LOV\306F\30E2\30FC\30C0\30EB\30FB\30C0\30A4\30A2\30ED\30B0\306B\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1800069993701225262.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1800068983311222289.442)
,p_display_sequence=>20
,p_display_value=>unistr('\30A4\30F3\30E9\30A4\30F3\30FB\30DD\30C3\30D7\30A2\30C3\30D7')
,p_return_value=>'POPUP'
,p_help_text=>unistr('LOV\306F\30D5\30A3\30FC\30EB\30C9\306E\4E0B\3067\30A4\30F3\30E9\30A4\30F3\30FB\30DD\30C3\30D7\30A2\30C3\30D7\306B\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1800067187898204706.442)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\521D\671F\30D5\30A7\30C3\30C1')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FIRST_ROWSET'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('LOV\7528\306E\30C7\30FC\30BF\306E\521D\671F\30D5\30A7\30C3\30C1\65B9\6CD5\3092\9078\629E\3057\307E\3059\3002\3053\308C\304C\9069\7528\3055\308C\308B\306E\306F\3001\30DA\30FC\30B8\30FB\30ED\30FC\30C9\5F8C\3001\307E\305F\306F\30AB\30B9\30B1\30FC\30C9\306A\3069\306B\3088\3063\3066\30A2\30A4\30C6\30E0\304C\30EA\30D5\30EC\30C3\30B7\30E5\3055\308C\305F\5F8C\306B\3001\30DD\30C3\30D7\30A2\30C3\30D7\304C\521D\3081\3066\958B\3044\305F\3068\304D\306E\307F\3067\3059\3002\5C5E\6027\306E\6700\5C0F\6587\5B57\6570\3082\53C2\7167\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1800067791014205587.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1800067187898204706.442)
,p_display_sequence=>10
,p_display_value=>unistr('\30E6\30FC\30B6\30FC\30FB\30EA\30AF\30A8\30B9\30C8\6642')
,p_return_value=>'NO_FETCH'
,p_help_text=>unistr('\30E6\30FC\30B6\30FC\304C\691C\7D22(\691C\7D22\6587\5B57\5217\306E\6709\7121\306B\95A2\4FC2\306A\304F)\3059\308B\307E\3067\3001LOV\306F\521D\671F\30D5\30A7\30C3\30C1\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1800068204174209405.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1800067187898204706.442)
,p_display_sequence=>20
,p_display_value=>unistr('\81EA\52D5')
,p_return_value=>'FIRST_ROWSET'
,p_help_text=>unistr('\691C\7D22\6587\5B57\5217\306A\3057\3067LOV\3092\521D\671F\30D5\30A7\30C3\30C1\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1800068585605213520.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1800067187898204706.442)
,p_display_sequence=>30
,p_display_value=>unistr('\81EA\52D5(\73FE\5728\306E\5024\3092\4F7F\7528)')
,p_return_value=>'FIRST_ROWSET_FILTER'
,p_help_text=>unistr('\73FE\5728\306E\5024\3092\691C\7D22\6587\5B57\5217\3068\3057\3066\3001LOV\3092\521D\671F\30D5\30A7\30C3\30C1\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(828501710103102611.442)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\8907\6570\306E\5024')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\3053\306E\30A2\30A4\30C6\30E0\304C\8907\6570\306E\5024\3092\4FDD\6301\3067\304D\308B\304B\3001\5358\4E00\306E\5024\306E\307F\4FDD\6301\3067\304D\308B\304B\3092\6307\5B9A\3057\307E\3059\3002\8907\6570\306E\5024\306F\3001\30AB\30F3\30DE\533A\5207\308A\306E\30EA\30B9\30C8\3067\8FD4\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9037093113159140.442)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\624B\52D5\5165\529B')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\624B\52D5\5165\529B\3092\8A31\53EF\3059\308B\304B\3069\3046\304B\3092\9078\629E\3057\307E\3059\3002\300C\306F\3044\300D\306E\5834\5408\3001\30E6\30FC\30B6\30FC\306F\30DD\30C3\30D7\30A2\30C3\30D7LOV\304B\3089\65E2\5B58\306E\5024\3092\9078\629E\3059\308B\304B\3001\624B\52D5\3067\5024\3092\5165\529B\3067\304D\307E\3059\3002\30B3\30F3\30DC\30DC\30C3\30AF\30B9\306B\4F3C\3066\3044\307E\3059\3002\300C\3044\3044\3048\300D\306E\5834\5408\3001\30DD\30C3\30D7\30A2\30C3\30D7LOV\304B\3089\5024\3092\9078\629E\3059\308B\3053\3068\306E\307F\53EF\80FD\3067\3059\3002\9078\629E\30EA\30B9\30C8\306B\4F3C\3066\3044\307E\3059\3002\624B\52D5\5165\529B\304C\8A31\53EF\3055\308C\3066\3044\308B\5834\5408\3001\3053\308C\306F\3001\5165\529B\3059\308B\5FC5\8981\306E\3042\308B\5BFE\5FDC\3059\308BLOV\306E\623B\308A\5024\3067\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9037383318177266.442)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\5165\529B\6642\306B\691C\7D22')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\300C\306F\3044\300D\306E\5834\5408\3001\691C\7D22\30D5\30A3\30FC\30EB\30C9\3078\306E\5165\529B\3068\540C\6642\306BLOV\304C\30D5\30A3\30EB\30BF\51E6\7406\3055\308C\307E\3059\3002\300C\3044\3044\3048\300D\306E\5834\5408\3001[Enter]\30AD\30FC\307E\305F\306F\300C\691C\7D22\300D\30A2\30A4\30B3\30F3\30FB\30DC\30BF\30F3\304C\62BC\3055\308C\308B\307E\3067LOV\306F\30D5\30A3\30EB\30BF\51E6\7406\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9037699825192444.442)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\6700\5C0F\6587\5B57\6570')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'0'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(9037383318177266.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('LOV\304C\30D5\30A7\30C3\30C1\3055\308C\308B\524D\306B\3001\691C\7D22\6587\5B57\5217\306B\5FC5\8981\306A\6700\5C0F\6587\5B57\6570\3092\6307\5B9A\3057\307E\3059\3002\3053\308C\306F\3001LOV\554F\5408\305B\306B\6642\9593\304C\304B\304B\308B\5834\5408\3001\5B9F\884C\3055\308C\308B\691C\7D22\306E\91CF\3092\6E1B\3089\3059\4E0A\3067\5F79\7ACB\3061\307E\3059\3002\30EA\30B9\30C8\5185\306E\3059\3079\3066\306E\8868\793A\5024\306F\3053\306E\6700\5C0F\6587\5B57\6570\3088\308A\3082\9577\304F\306A\308A\3001\77ED\3044\5834\5408\306F\691C\51FA\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9037973825195793.442)
,p_plugin_attribute_id=>wwv_flow_api.id(9037699825192444.442)
,p_display_sequence=>10
,p_display_value=>unistr('\6700\5C0F\5024\306A\3057 (0)')
,p_return_value=>'0'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9038300277196807.442)
,p_plugin_attribute_id=>wwv_flow_api.id(9037699825192444.442)
,p_display_sequence=>20
,p_display_value=>'1'
,p_return_value=>'1'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9038738010197706.442)
,p_plugin_attribute_id=>wwv_flow_api.id(9037699825192444.442)
,p_display_sequence=>30
,p_display_value=>'2'
,p_return_value=>'2'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9039143176198691.442)
,p_plugin_attribute_id=>wwv_flow_api.id(9037699825192444.442)
,p_display_sequence=>40
,p_display_value=>'3'
,p_return_value=>'3'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9039528380199625.442)
,p_plugin_attribute_id=>wwv_flow_api.id(9037699825192444.442)
,p_display_sequence=>50
,p_display_value=>'4'
,p_return_value=>'4'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9039968403200723.442)
,p_plugin_attribute_id=>wwv_flow_api.id(9037699825192444.442)
,p_display_sequence=>60
,p_display_value=>'5'
,p_return_value=>'5'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9040583894241082.442)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\30BF\30A4\30C8\30EB')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('\30DD\30C3\30D7\30A2\30C3\30D7\30FB\30C0\30A4\30A2\30ED\30B0\306E\30BF\30A4\30C8\30EB\3002\7A7A\767D\306E\5834\5408\306F\30C7\30D5\30A9\30EB\30C8\306E\30BF\30A4\30C8\30EB\304C\4F7F\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9040894549248059.442)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\30DD\30C3\30D7\30A2\30C3\30D7\306E\5E45')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_unit=>unistr('\30D4\30AF\30BB\30EB')
,p_is_translatable=>false
,p_help_text=>unistr('\30DD\30C3\30D7\30A2\30C3\30D7\306E\5E45\3002\7A7A\767D\306E\5834\5408\306F\30C7\30D5\30A9\30EB\30C8\304C\4F7F\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9041180669256760.442)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\30DD\30C3\30D7\30A2\30C3\30D7\306E\9AD8\3055')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_unit=>unistr('\30D4\30AF\30BB\30EB')
,p_is_translatable=>false
,p_help_text=>unistr('\30DD\30C3\30D7\30A2\30C3\30D7\306E\9AD8\3055\3002\7A7A\767D\306E\5834\5408\306F\30C7\30D5\30A9\30EB\30C8\304C\4F7F\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9041484550137059.442)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('\8FFD\52A0\51FA\529B')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(828501710103102611.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_examples=>'COL1:P1_ITEM1,COL2:P1_ITEM2'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8FFD\52A0\306E\5024\30EA\30B9\30C8(LOV)\5217\3092\3001\4ED6\306E\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\304A\3088\3073\5BFE\8A71\30B0\30EA\30C3\30C9\5217\306B\8FD4\3057\307E\3059\3002\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\540D\307E\305F\306F\5BFE\8A71\30B0\30EA\30C3\30C9\5217\306E\9759\7684ID\3078\306ELOV\5217\540D\306E\30DE\30C3\30D4\30F3\30B0\3092\5B9A\7FA9\3057\307E\3059\3002</p>'),
unistr('<p>\30CE\30FC\30C8: \3053\308C\306F\3001LOV\5B9A\7FA9\306B\8FFD\52A0\306E\5217\304C\542B\307E\308C\308B\5834\5408\306B\306E\307F\9069\7528\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(311784600505681020.442)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>35
,p_prompt=>unistr('\30BB\30D1\30EC\30FC\30BF')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>':'
,p_display_length=>10
,p_max_length=>10
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(828501710103102611.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(9034124600967605.442)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.442)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>function(options) {',
'    options.resizable = false;',
'    return options;',
'}',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30DD\30C3\30D7\30A2\30C3\30D7LOV\30A2\30A4\30C6\30E0\306E\30AA\30D7\30B7\30E7\30F3\30FB\30AA\30D6\30B8\30A7\30AF\30C8\3092\53D6\5F97\3057\3001\30AA\30D6\30B8\30A7\30AF\30C8\3092\5909\66F4\3057\3066\305D\308C\3092\8FD4\3059JavaScript\95A2\6570\3092\5165\529B\3057\307E\3059\3002\3053\308C\306B\3088\308A\3001\521D\671F\5316\4E2D\306B\30DD\30C3\30D7\30A2\30C3\30D7LOV\30A2\30A4\30C6\30E0\30FB\30C0\30A4\30A2\30ED\30B0\3068\305D\306E\5185\5BB9\306E\8A73\7D30\306A\30AB\30B9\30BF\30DE\30A4\30BA\304C\53EF\80FD\306B\306A\308A\307E\3059\3002</p>'),
'',
unistr('<p>\3053\308C\3089\306E\30AA\30D7\30B7\30E7\30F3\306F\3001\6B21\306E<code>popup</code>\30A6\30A3\30B8\30A7\30C3\30C8\307E\305F\306FjQuery UI <code>dialog</code>\30A6\30A3\30B8\30A7\30C3\30C8\306B\6E21\3055\308C\307E\3059:<br>'),
unistr('draggable, resizable, width, height, minWidth, minHeight, maxWidth\304A\3088\3073maxHeight<br>'),
unistr('\8A73\7D30\306F\3001JQuery UI\30C0\30A4\30A2\30ED\30B0\30FB\30A6\30A3\30B8\30A7\30C3\30C8\306E\30C9\30AD\30E5\30E1\30F3\30C8\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002</p>'),
'',
unistr('<p>\7D50\679C\304C\5358\7D14\306A\30EA\30B9\30C8\306B\8868\793A\3055\308C\308B\5834\5408\3001<code>defaultIconListOptions</code>\30AA\30D7\30B7\30E7\30F3\306F\3001<code>tableModelView</code>\30A6\30A3\30B8\30A7\30C3\30C8\306B\6E21\3055\308C\308B\30AA\30D6\30B8\30A7\30AF\30C8\3067\3059\3002\4F7F\7528\53EF\80FD\306A\30AA\30D7\30B7\30E7\30F3\306F\3001APEX tableModelView\30A6\30A3\30B8\30A7\30C3\30C8\306E\30C9\30AD\30E5\30E1\30F3\30C8\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002</p>'),
'',
unistr('<p>\7D50\679C\304C\30B0\30EA\30C3\30C9\306B\8868\793A\3055\308C\308B\5834\5408\3001<code>defaultGridOptions</code>\30AA\30D7\30B7\30E7\30F3\306F\3001<code>grid</code>\30A6\30A3\30B8\30A7\30C3\30C8\306B\6E21\3055\308C\308B\30AA\30D6\30B8\30A7\30AF\30C8\3067\3059\3002'),
unistr('\4F7F\7528\53EF\80FD\306A\30AA\30D7\30B7\30E7\30F3\306F\3001APEX\30B0\30EA\30C3\30C9\30FB\30A6\30A3\30B8\30A7\30C3\30C8\306E\30C9\30AD\30E5\30E1\30F3\30C8\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002</p>')))
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845153088232834479.442)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.442)
,p_name=>'LOV'
,p_sql_min_column_count=>1
,p_sql_max_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>SQL\554F\5408\305B\306B\57FA\3065\3044\305FLOV</dt>'),
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>\540C\3058\8868\793A\304A\3088\3073\623B\308A\5024\3092\4F7F\7528\3057\305FLOV</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>\30CE\30FC\30C8: \8868\793A\5024\3068\623B\308A\5024\306E\4E21\65B9\306B\540C\3058\5217\3092\9078\629E\3059\308B\5834\5408\3001\5217\306E\5225\540D\3092\4F7F\7528\3057\307E\3059\3002</p>'),
'</dd>',
unistr('<dt>\30D0\30A4\30F3\30C9\5909\6570\3092\4F7F\7528\3057\305FLOV</dt>'),
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>\30CE\30FC\30C8: <code>P3_DEPTNO</code>\304C\540C\3058\30DA\30FC\30B8\306E\5909\66F4\53EF\80FD\306A\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306E\5834\5408\3001<em>\300C\30AB\30B9\30B1\30FC\30C9LOV\89AA\30A2\30A4\30C6\30E0\300D</em>\5C5E\6027\3092<code>P3_DEPTNO</code>\306B\8A2D\5B9A\3057\307E\3059\3002</dd>'),
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/execute_plsql_code
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1811565602388283608.442)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'EXECUTE_PLSQL_CODE'
,p_display_name=>unistr('\30B5\30FC\30D0\30FC\5074\306E\30B3\30FC\30C9\3092\5B9F\884C')
,p_category=>'EXECUTE'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','EXECUTE_PLSQL_CODE'),'')
,p_api_version=>1
,p_standard_attributes=>'STOP_EXECUTION_ON_ERROR:WAIT_FOR_RESULT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\30B3\30FC\30C9\3092\30B5\30FC\30D0\30FC\3067\5B9F\884C\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1811566513386305684.442)
,p_plugin_id=>wwv_flow_api.id(1811565602388283608.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('PL/SQL\30B3\30FC\30C9')
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2700405449462251.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<dl><dt>\6607\7D66\306E\8CC7\683C\304C\3042\308B\5F93\696D\54E1\306E\7D66\4E0E\30923%\5897\3084\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'begin',
'    for l_emp ( select empno',
'                  from emp',
'                 where deptno = :P2_DEPTNO )',
'    loop',
'        if needs_salary_raise( l_empno.empno ) then',
'            update emp',
'               set sal = sal * 1.03',
'             where empno = l_emp.empno;',
'        end if;',
'    end loop;',
'end;',
'</pre></dd>',
'</dl>',
unistr('<p>\3053\306E\4F8B\3067\306F\3001<strong>\300C\9001\4FE1\3059\308B\30A2\30A4\30C6\30E0\300D</strong>\306B<code>P2_DEPTNO</code>\3068\5165\529B\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>')))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30B5\30FC\30D0\30FC\3067\5B9F\884C\3055\308C\308B\3001PL/SQL\7121\540D\30D6\30ED\30C3\30AF\306E\307F\306E\5B9F\884C\3092\6307\5B9A\3057\307E\3059\3002</p>'),
unistr('<p>\30D0\30A4\30F3\30C9\69CB\6587(<code>:P1_MY_ITEM</code>\306A\3069)\3092\4F7F\7528\3057\3066\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5185\304B\3089\4ED6\306E\30DA\30FC\30B8\3084\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\53C2\7167\3067\304D\307E\3059\3002\53C2\7167\3055\308C\308B\30A2\30A4\30C6\30E0\3092<strong>\300C\9001\4FE1\3059\308B\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\300D</strong>\306B\542B\3081\308B\5FC5\8981\3082\3042\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2700703882467720.442)
,p_plugin_id=>wwv_flow_api.id(1811565602388283608.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>11
,p_prompt=>unistr('JavaScript\30B3\30FC\30C9')
,p_attribute_type=>'MLE JAVASCRIPT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2700405449462251.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'JAVASCRIPT'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<dl><dt>\6607\7D66\306E\8CC7\683C\304C\3042\308B\5F93\696D\54E1\306E\7D66\4E0E\30923%\5897\3084\3057\307E\3059\3002</dt>'),
'<dd><pre>',
'var rows;',
'function needsSalaryRaise( empno ) {',
'  // placeholder for some complicated logic to calculate if employee needs a raise',
'  return true;',
'}',
'rows = apex.conn.execute( "select empno from emp where deptno = :deptno", { deptno: apex.env.P2_DEPTNO } ).rows;',
'for ( var row of rows ) {',
'  if ( needsSalaryRaise( row.EMPNO )) {',
'    apex.conn.execute( "update emp set sal = sal * 1.03 where empno = :empno", { empno: row.EMPNO } );',
'  }',
'}',
'</pre></dd>',
'</dl>',
unistr('<p>\3053\306E\4F8B\3067\306F\3001<strong>\300C\9001\4FE1\3059\308B\30A2\30A4\30C6\30E0\300D</strong>\306B<code>P2_DEPTNO</code>\3068\5165\529B\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>')))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30B5\30FC\30D0\30FC\3067\5B9F\884C\3055\308C\308B\3001JavaScript\30D6\30ED\30C3\30AF\306E\307F\306E\5B9F\884C\3092\6307\5B9A\3057\307E\3059\3002</p>'),
unistr('<p>\30D0\30A4\30F3\30C9\69CB\6587(<code>apex.env.P1_MY_ITEM</code>\306A\3069)\3092\4F7F\7528\3057\3066\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5185\304B\3089\4ED6\306E\30DA\30FC\30B8\3084\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30A2\30A4\30C6\30E0\3092\53C2\7167\3067\304D\307E\3059\3002\53C2\7167\3055\308C\308B\30A2\30A4\30C6\30E0\3092<strong>\300C\9001\4FE1\3059\308B\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\300D</strong>\306B\542B\3081\308B\5FC5\8981\3082\3042\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1811567115248315739.442)
,p_plugin_id=>wwv_flow_api.id(1811565602388283608.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\9001\4FE1\3059\308B\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30B5\30FC\30D0\30FC\306B\9001\4FE1\3055\308C\3001\305D\306E\7D50\679C<strong>PL/SQL\30B3\30FC\30C9</strong>\5185\3067\4F7F\7528\3067\304D\308B\3088\3046\306B\306A\308B\5927\6587\5B57\306E\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002</p>'),
unistr('<p>\540D\524D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002'),
unistr('\30EA\30B9\30C8\304B\3089\9078\629E\3057\3001\3059\3067\306B\5165\529B\3055\308C\3066\3044\308B\30C6\30AD\30B9\30C8\304C\3042\308B\5834\5408\3001\65E2\5B58\306E\30C6\30AD\30B9\30C8\306E\6700\5F8C\306B\30AB\30F3\30DE\304C\4ED8\3051\3089\308C\3001\30EA\30B9\30C8\304B\3089\8FD4\3055\308C\305F\30A2\30A4\30C6\30E0\540D\304C\305D\308C\306B\7D9A\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(888122401495541038.442)
,p_plugin_id=>wwv_flow_api.id(1811565602388283608.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\623B\3059\30A2\30A4\30C6\30E0')
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'    apex_util.set_session_state(''P1_MY_ITEM'', ''New Value'');',
'</pre>',
'</p>',
unistr('<p>\3053\306E\4F8B\3067\306F\3001''New Value''\3092\30DA\30FC\30B8\306E\305D\306E\30A2\30A4\30C6\30E0\306B\8868\793A\3059\308B\305F\3081\306B\3001\3053\306E\5C5E\6027\306B<code>P1_MY_ITEM</code>\3068\5165\529B\3057\307E\3059\3002</p>')))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\5185\306E\73FE\5728\306E\5024\306B\57FA\3065\3044\3066\3001\30B5\30FC\30D0\30FC\3078\306E\30B3\30FC\30EB\306E\623B\308A\3067\8A2D\5B9A\3055\308C\308B\5927\6587\5B57\306E\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3092\5165\529B\3057\307E\3059\3002<strong>PL/SQL\30B3\30FC\30C9</strong>\30671\3064\4EE5\4E0A\306E\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\5024\3092\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\306B\8A2D\5B9A\3059\308B\5834\5408\3001\305D\308C\3089\306E\30A2\30A4\30C6\30E0\3092\3053\306E\5C5E\6027\306B\5B9A\7FA9\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002</p>'),
unistr('<p>\30A2\30A4\30C6\30E0\540D\3092\5165\529B\3059\308B\304B\3001\4F7F\7528\53EF\80FD\306A\30A2\30A4\30C6\30E0\306E\30EA\30B9\30C8\304B\3089\9078\629E\3057\307E\3059\3002'),
unistr('\30EA\30B9\30C8\304B\3089\9078\629E\3057\3001\3059\3067\306B\5165\529B\3055\308C\3066\3044\308B\30C6\30AD\30B9\30C8\304C\3042\308B\5834\5408\3001\65E2\5B58\306E\30C6\30AD\30B9\30C8\306E\6700\5F8C\306B\30AB\30F3\30DE\304C\4ED8\3051\3089\308C\3001\30EA\30B9\30C8\304B\3089\8FD4\3055\308C\305F\30A2\30A4\30C6\30E0\540D\304C\305D\308C\306B\7D9A\304D\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1002790918416823799.442)
,p_plugin_id=>wwv_flow_api.id(1811565602388283608.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\5909\66F4\30A4\30D9\30F3\30C8\306E\7981\6B62')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(888122401495541038.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('<strong>\300C\8FD4\3055\308C\308B\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\300D</strong>\3067\6307\5B9A\3055\308C\305F\30A2\30A4\30C6\30E0\3067\5909\66F4\30A4\30D9\30F3\30C8\3092\6291\6B62\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002\3053\308C\306B\3088\3063\3066\3001\5F8C\7D9A\306E<em>\5909\66F4</em>\30D9\30FC\30B9\306E\52D5\7684\30A2\30AF\30B7\30E7\30F3\304C\3053\308C\3089\306E\30A2\30A4\30C6\30E0\306B\5BFE\3057\3066\5B9F\884C\3055\308C\306A\304F\306A\308A\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2700405449462251.442)
,p_plugin_id=>wwv_flow_api.id(1811565602388283608.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>5
,p_prompt=>unistr('\8A00\8A9E')
,p_attribute_type=>'CODE LANGUAGE'
,p_is_required=>true
,p_default_value=>'PLSQL'
,p_is_translatable=>false
);
end;
/
prompt --application/shared_components/plugins/item_type/display_only
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2248579157998483215.442)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'DISPLAY_ONLY'
,p_display_name=>unistr('\8868\793A\306E\307F')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','DISPLAY_ONLY'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SOURCE:ELEMENT:ICON:ENCRYPT:LOV:JOIN_LOV:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\5165\529B\4E0D\53EF\30C6\30AD\30B9\30C8\30FB\30A2\30A4\30C6\30E0\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2248592969903496143.442)
,p_plugin_id=>wwv_flow_api.id(2248579157998483215.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>50
,p_prompt=>unistr('\30DA\30FC\30B8\306E\9001\4FE1\6642\306B\9001\4FE1')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>unistr('\30DA\30FC\30B8\306E\9001\4FE1\6642\306B\73FE\5728\306E\30A2\30A4\30C6\30E0\5024\3092\9001\4FE1\3059\308B\5FC5\8981\304C\3042\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1803821466219365649.442)
,p_plugin_id=>wwv_flow_api.id(2248579157998483215.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\57FA\6E96')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VALUE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(4800927632436292.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLAIN'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\8868\793A\3055\308C\308B\5024\306E\6C7A\5B9A\65B9\6CD5\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1803822070028366811.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1803821466219365649.442)
,p_display_sequence=>10
,p_display_value=>unistr('\30A2\30A4\30C6\30E0\5024')
,p_return_value=>'VALUE'
,p_help_text=>unistr('\30A2\30A4\30C6\30E0\306E\73FE\5728\306E\5024\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1803822445572369209.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1803821466219365649.442)
,p_display_sequence=>20
,p_display_value=>unistr('LOV\306E\5024\306E\8868\793A')
,p_return_value=>'LOV'
,p_help_text=>unistr('\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306E\73FE\5728\306E\5024\306F\3001LOV\3092\4F7F\7528\3057\3066\5225\306E\8868\793A\5024\306B\30DE\30C3\30D7\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1803822855268372026.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1803821466219365649.442)
,p_display_sequence=>30
,p_display_value=>unistr('PL/SQL\30B3\30FC\30C9\306E\51FA\529B')
,p_return_value=>'PLSQL'
,p_is_deprecated=>true
,p_help_text=>unistr('\6307\5B9A\3055\308C\305FPL/SQL\30B3\30FC\30C9\306F\3001\8868\793A\3055\308C\308B\51FA\529B\3092\751F\6210\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1803823354360381170.442)
,p_plugin_id=>wwv_flow_api.id(2248579157998483215.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('PL/SQL\30B3\30FC\30C9')
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1803821466219365649.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p><code>sys.htp.p</code>\307E\305F\306F<code>sys.htp.prn</code>\3092\4F7F\7528\3057\3066HTML\30B3\30FC\30C9\3092\751F\6210\3059\308BPL/SQL\30B3\30FC\30C9\3092\5165\529B\3057\307E\3059\3002</p>'),
unistr('<p>HTML\30BF\30B0\304C\30A8\30B9\30B1\30FC\30D7\3055\308C\308B\3088\3046\3001<code>sys.htf.escape_sc</code>\3092\4F7F\7528\3057\3066\30C7\30FC\30BF\30D9\30FC\30B9\304B\3089\53D6\5F97\3055\308C\308B\30C7\30FC\30BF\3092\30A8\30B9\30B1\30FC\30D7\3059\308B\3053\3068\3092\304A\85A6\3081\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1363556632373484636.442)
,p_plugin_id=>wwv_flow_api.id(2248579157998483215.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\6539\884C\306E\8868\793A')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1803821466219365649.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'VALUE,LOV'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6539\884C\304C\51FA\529B\3067\4FDD\6301\3055\308C\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002</p>'),
unistr('<p>\8868\793A\306FHTML\3068\3057\3066\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\308B\305F\3081\3001<strong>\300C\306F\3044\300D</strong>\306B\8A2D\5B9A\3055\308C\305F\5834\5408\3001\8868\793A\5024\306E\6539\884C\306FHTML\306E\6539\884C\306B\5909\63DB\3055\308C\3001\6B63\3057\304F\8868\793A\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(4800927632436292.442)
,p_plugin_id=>wwv_flow_api.id(2248579157998483215.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>10
,p_prompt=>unistr('\66F8\5F0F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'PLAIN'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(4801218870437281.442)
,p_plugin_attribute_id=>wwv_flow_api.id(4800927632436292.442)
,p_display_sequence=>10
,p_display_value=>unistr('\30D7\30EC\30FC\30F3\30FB\30C6\30AD\30B9\30C8')
,p_return_value=>'PLAIN'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(4801656011439608.442)
,p_plugin_attribute_id=>wwv_flow_api.id(4800927632436292.442)
,p_display_sequence=>20
,p_display_value=>'HTML'
,p_return_value=>'HTML'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(4802071527441522.442)
,p_plugin_attribute_id=>wwv_flow_api.id(4800927632436292.442)
,p_display_sequence=>30
,p_display_value=>unistr('\30DE\30FC\30AF\30C0\30A6\30F3')
,p_return_value=>'MARKDOWN'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845153181852834480.442)
,p_plugin_id=>wwv_flow_api.id(2248579157998483215.442)
,p_name=>'LOV'
,p_is_required=>false
,p_sql_min_column_count=>2
,p_sql_max_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('<strong>\4F8B1: SQL\554F\5408\305B\306B\57FA\3065\3044\305FLOV</strong>'),
'<pre>',
'SELECT dname, deptno from dept',
'</pre>',
'</p>',
'<p>',
unistr('<strong>\4F8B2: \9759\7684\30EA\30B9\30C8\306E\4F8B</strong>'),
'<ul>',
unistr('<li>STATIC:Yes;Y,No;N (Y/N\306E\304B\308F\308A\306BYes/No\3092\8868\793A)</li>'),
'</ul>',
'</p>',
'',
'<p>',
unistr('<strong>\4F8B3: \30D0\30A4\30F3\30C9\5909\6570\3092\4F7F\7528\3057\3066\8FFD\52A0\3067\5236\9650\3057\305FLOV</strong>'),
'<pre>',
'SELECT dname, deptno from dept where location=:P3_LOCATION',
'</pre>',
'</p>'))
);
end;
/
prompt --application/shared_components/plugins/item_type/star_rating
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2547808060578229016.442)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'STAR_RATING'
,p_display_name=>unistr('\661F\8A55\4FA1')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','STAR_RATING'),'')
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:SOURCE:ICON:ENCRYPT:FILTER'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p><strong>\6700\65B0\661F\8A55\4FA1\30A2\30A4\30C6\30E0</strong></p>'),
unistr('<p>\3053\306E\30A2\30A4\30C6\30E0\306F\3001\661F\306A\3069\306E\30A2\30A4\30B3\30F3\306E\6570\3068\3057\3066\6570\5024\3092\8868\793A\3057\307E\3059\3002\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\3001\5E0C\671B\3059\308B\661F\306E\6570\3092\9078\629E\3057\3066\5024\3092\5909\66F4\3067\304D\307E\3059\3002\5024\3092\8ABF\6574\3059\308B\306B\306F\3001\30DE\30A6\30B9\3084\30AD\30FC\30DC\30FC\30C9\3092\4F7F\7528\3057\3066\661F\306E\6570\3092\30AF\30EA\30C3\30AF\3057\307E\3059\3002</p>'),
unistr('<p>\8868\793A\3055\308C\308B\30A2\30A4\30B3\30F3\3068\3001\80CC\666F\304A\3088\3073\524D\666F\306E\8272\306F\3001\30B3\30F3\30DD\30FC\30CD\30F3\30C8\8A2D\5B9A\307E\305F\306F\500B\3005\306E\30A2\30A4\30C6\30E0\8A2D\5B9A\3067\8ABF\6574\3067\304D\307E\3059\3002\500B\3005\306E\30A2\30A4\30C6\30E0\304A\3088\3073\8272\3092\4F7F\7528\3059\308B\306B\306F\3001\5C5E\6027<strong>\300C\30B3\30F3\30DD\30FC\30CD\30F3\30C8\30FB\30C7\30D5\30A9\30EB\30C8\306E\4F7F\7528\300D</strong>\3092<strong>\300C\3044\3044\3048\300D</strong>\306B\8A2D\5B9A\3057\307E\3059\3002</p>'),
unistr('<p>\30A2\30A4\30B3\30F3\306B\3064\3044\3066\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\4F7F\7528\3067\304D\308B\30A2\30A4\30B3\30F3\30FB\30D5\30A9\30F3\30C8\304B\3089\4EFB\610F\306E\30A2\30A4\30B3\30F3\3092\4F7F\7528\3067\304D\307E\3059\3002\30E6\30CB\30D0\30FC\30B5\30EB\30FB\30C6\30FC\30DE\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\306F\3001<em>\30D5\30A9\30F3\30C8APEX</em>\30E9\30A4\30D6\30E9\30EA\306E\30A2\30A4\30B3\30F3\3092\4F7F\7528\3057\307E\3059\3002</p>')))
,p_version_identifier=>'1.0'
,p_files_version=>1149
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(475527326399196418.442)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.442)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\30C7\30D5\30A9\30EB\30C8\30FB\30A2\30A4\30B3\30F3')
,p_attribute_type=>'ICON'
,p_is_required=>true
,p_default_value=>'fa-star'
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'fa-star',
'fa-thumbs-up',
'fa-database',
'</pre>'))
,p_help_text=>unistr('\4F7F\7528\3059\308B\30C7\30D5\30A9\30EB\30C8\30FB\30A2\30A4\30B3\30F3\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2721912433448449647.442)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.442)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\30A2\30AF\30C6\30A3\30D6\306A\8272')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>unistr('\30A2\30AF\30C6\30A3\30D6\306A\661F\306E\30C7\30D5\30A9\30EB\30C8\306E\8272\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2721912884614449648.442)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.442)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\975E\30A2\30AF\30C6\30A3\30D6\306A\8272')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>unistr('\975E\30A2\30AF\30C6\30A3\30D6\306A\661F\306E\30C7\30D5\30A9\30EB\30C8\306E\8272\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(475538451111203492.442)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.442)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\30C4\30FC\30EB\30C1\30C3\30D7')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_default_value=>'#VALUE#'
,p_is_translatable=>false
,p_examples=>unistr('\8A55\4FA1: #VALUE#\306E\661F\3002')
,p_help_text=>unistr('\30C4\30FC\30EB\30C1\30C3\30D7\306E\30C6\30F3\30D7\30EC\30FC\30C8\3092\6307\5B9A\3057\307E\3059\3002#VALUE#\7F6E\63DB\306F\3001\73FE\5728\306E\8A55\4FA1\5024\306B\3088\3063\3066\7F6E\63DB\3055\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(470180844645338807.442)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\661F\306E\6570')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'5'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\8868\793A\3059\308B\661F\306E\5408\8A08\6570\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470251151324440675.442)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.442)
,p_display_sequence=>10
,p_display_value=>'1'
,p_return_value=>'1'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470263362673575666.442)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.442)
,p_display_sequence=>20
,p_display_value=>'2'
,p_return_value=>'2'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470263792668576010.442)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.442)
,p_display_sequence=>30
,p_display_value=>'3'
,p_return_value=>'3'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470264197754576285.442)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.442)
,p_display_sequence=>40
,p_display_value=>'4'
,p_return_value=>'4'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470264650749576748.442)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.442)
,p_display_sequence=>50
,p_display_value=>'5'
,p_return_value=>'5'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470264961143577132.442)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.442)
,p_display_sequence=>60
,p_display_value=>'6'
,p_return_value=>'6'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470265413888577465.442)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.442)
,p_display_sequence=>70
,p_display_value=>'7'
,p_return_value=>'7'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470265803806577966.442)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.442)
,p_display_sequence=>80
,p_display_value=>'8'
,p_return_value=>'8'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470266183252578379.442)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.442)
,p_display_sequence=>90
,p_display_value=>'9'
,p_return_value=>'9'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470266568693578886.442)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.442)
,p_display_sequence=>100
,p_display_value=>'10'
,p_return_value=>'10'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(470195603586349451.442)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\30C7\30D5\30A9\30EB\30C8\306E\4F7F\7528')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\300C\5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8\300D>\300C\30B3\30F3\30DD\30FC\30CD\30F3\30C8\8A2D\5B9A\300D\3067\3001\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\5BFE\3057\3066\5B9A\7FA9\3055\308C\3066\3044\308B\30C7\30D5\30A9\30EB\30C8\307E\305F\306F\30AB\30B9\30BF\30E0\8A2D\5B9A\306E\3044\305A\308C\3092\4F7F\7528\3059\308B\304B\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(470360305601388583.442)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\30A2\30A4\30B3\30F3')
,p_attribute_type=>'ICON'
,p_is_required=>true
,p_default_value=>'fa-star'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'fa-star',
'fa-thumb-up',
'fa-database',
'</pre>'))
,p_help_text=>unistr('\4F7F\7528\3059\308B\30A2\30A4\30B3\30F3\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2721914847860449650.442)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\30A2\30AF\30C6\30A3\30D6\306A\8272')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>unistr('\30A2\30AF\30C6\30A3\30D6\306A\661F\306E\30C7\30D5\30A9\30EB\30C8\306E\8272\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2721915319189449650.442)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\975E\30A2\30AF\30C6\30A3\30D6\306A\8272')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>unistr('\975E\30A2\30AF\30C6\30A3\30D6\306A\661F\306E\30C7\30D5\30A9\30EB\30C8\306E\8272\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2721915642741449650.442)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\30C4\30FC\30EB\30C1\30C3\30D7')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'#VALUE#'
,p_display_length=>30
,p_max_length=>50
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_examples=>unistr('\8A55\4FA1: #VALUE#\306E\661F\3002')
,p_help_text=>unistr('\30C4\30FC\30EB\30C1\30C3\30D7\306E\30C6\30F3\30D7\30EC\30FC\30C8\3092\6307\5B9A\3057\307E\3059\3002#VALUE#\7F6E\63DB\306F\3001\73FE\5728\306E\8A55\4FA1\5024\306B\3088\3063\3066\7F6E\63DB\3055\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(576030049193688277.442)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\300C\30AF\30EA\30A2\300D\30DC\30BF\30F3\306E\8868\793A')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>unistr('\300C\30AF\30EA\30A2\300D\30DC\30BF\30F3\3092\8868\793A\3059\308B\304B\3069\3046\304B\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(470218232268377857.442)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\5024\306E\8868\793A')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>unistr('\661F\306E\6A2A\306B\5024\3092\8868\793A\3059\308B\304B\3069\3046\304B\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(470221148895382244.442)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\8AAD\53D6\308A\5C02\7528\8868\793A')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STARS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\30A2\30A4\30C6\30E0\304C\8AAD\53D6\308A\5C02\7528\306E\5834\5408\306B\8868\793A\3059\308B\5185\5BB9\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470238266735410069.442)
,p_plugin_attribute_id=>wwv_flow_api.id(470221148895382244.442)
,p_display_sequence=>20
,p_display_value=>unistr('\661F')
,p_return_value=>'STARS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470238737727410979.442)
,p_plugin_attribute_id=>wwv_flow_api.id(470221148895382244.442)
,p_display_sequence=>30
,p_display_value=>unistr('\5024')
,p_return_value=>'VALUE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470239127391413405.442)
,p_plugin_attribute_id=>wwv_flow_api.id(470221148895382244.442)
,p_display_sequence=>40
,p_display_value=>unistr('\661F\3068\5024')
,p_return_value=>'STARS_AND_VALUE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470239521066415362.442)
,p_plugin_attribute_id=>wwv_flow_api.id(470221148895382244.442)
,p_display_sequence=>50
,p_display_value=>unistr('1\3064\306E\661F\3068\5024')
,p_return_value=>'SINGLE_STAR_AND_VALUE'
);
end;
/
prompt --application/shared_components/plugins/item_type/checkbox
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2693981597889753854.442)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'CHECKBOX'
,p_display_name=>unistr('\30C1\30A7\30C3\30AF\30FB\30DC\30C3\30AF\30B9\30FB\30B0\30EB\30FC\30D7')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS:APEX_APPL_PAGE_FACETS:APEX_APPL_PAGE_SFILTERS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','CHECKBOX'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:ESCAPE_OUTPUT:SOURCE:ELEMENT:ELEMENT_OPTION:ENCRYPT:LOV:CASCADING_LOV:JOIN_LOV:FILTER:LINK:FC_HAS_FEEDBACK:FC_SHOW_SELECTED_FIRST:FC_SHOW_MORE_COUNT:FC_FILTER_VALUES:FC_LOV_DISPLAY_NULL'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\8907\6570\306E\5024\3092\30C1\30A7\30C3\30AF\30FB\30DC\30C3\30AF\30B9\3068\3057\3066\8868\793A\3057\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\8907\6570\306E\5024\3092\9078\629E\3067\304D\308B\3088\3046\306B\3057\307E\3059\3002\30C1\30A7\30C3\30AF\30FB\30DC\30C3\30AF\30B9\3068\3057\3066\8868\793A\3059\308B\30A2\30A4\30C6\30E0\306B\306FLOV\304C\5FC5\8981\3067\3059\3002\9078\629E\3055\308C\305F\30DC\30C3\30AF\30B9\306B\5BFE\5FDC\3059\308B\5024\306F\30011\3064\306E\30B3\30ED\30F3\3067\533A\5207\3089\308C\305F\6587\5B57\5217\306B\683C\7D0D\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(911353315791136342.442)
,p_plugin_id=>wwv_flow_api.id(2693981597889753854.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\5217\306E\6570')
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'1'
,p_display_length=>3
,p_max_length=>3
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_help_text=>unistr('\30C1\30A7\30C3\30AF\30FB\30DC\30C3\30AF\30B9\306E\8868\793A\306B\4F7F\7528\3055\308C\308B\30EC\30A4\30A2\30A6\30C8\5217\306E\6570\3092\5165\529B\3057\307E\3059\3002\305F\3068\3048\3070\30012\3068\3044\3046\5024\3092\6307\5B9A\3059\308B\3068\30012\5217\306E\30C1\30A7\30C3\30AF\30FB\30DC\30C3\30AF\30B9\304C\8868\793A\3055\308C\307E\3059\3002\30C7\30D5\30A9\30EB\30C8\3067\306F\3001\3059\3079\3066\306E\5024\304C1\3064\306E\5217\306B\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(12186014788201255.442)
,p_plugin_id=>wwv_flow_api.id(2693981597889753854.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>5
,p_prompt=>unistr('\5411\304D\3092\8868\793A')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VERTICAL'
,p_supported_ui_types=>'JQM_SMARTPHONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\30C1\30A7\30C3\30AF\30FB\30DC\30C3\30AF\30B9\306E\30EC\30F3\30C0\30EA\30F3\30B0\65B9\6CD5\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(12186517905202120.442)
,p_plugin_attribute_id=>wwv_flow_api.id(12186014788201255.442)
,p_display_sequence=>10
,p_display_value=>unistr('\7E26')
,p_return_value=>'VERTICAL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(12186921368203093.442)
,p_plugin_attribute_id=>wwv_flow_api.id(12186014788201255.442)
,p_display_sequence=>20
,p_display_value=>unistr('\6A2A')
,p_return_value=>'HORIZONTAL'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845156526173834547.442)
,p_plugin_id=>wwv_flow_api.id(2693981597889753854.442)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>SQL\554F\5408\305B\306B\57FA\3065\3044\305FLOV</dt>'),
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>\540C\3058\8868\793A\304A\3088\3073\623B\308A\5024\3092\4F7F\7528\3057\305FLOV</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>\30CE\30FC\30C8: \8868\793A\5024\3068\623B\308A\5024\306E\4E21\65B9\306B\540C\3058\5217\3092\9078\629E\3059\308B\5834\5408\3001\5217\306E\5225\540D\3092\4F7F\7528\3057\307E\3059\3002</p>'),
'</dd>',
unistr('<dt>\30D0\30A4\30F3\30C9\5909\6570\3092\4F7F\7528\3057\305FLOV</dt>'),
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>\30CE\30FC\30C8: <code>P3_DEPTNO</code>\304C\540C\3058\30DA\30FC\30B8\306E\5909\66F4\53EF\80FD\306A\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306E\5834\5408\3001<em>\300C\30AB\30B9\30B1\30FC\30C9LOV\89AA\30A2\30A4\30C6\30E0\300D</em>\5C5E\6027\3092<code>P3_DEPTNO</code>\306B\8A2D\5B9A\3057\307E\3059\3002</dd>'),
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/item_type/select_list
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2698572619073428716.442)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'SELECT_LIST'
,p_display_name=>unistr('\9078\629E\30EA\30B9\30C8')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS:APEX_APPL_PAGE_FACETS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','SELECT_LIST'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:ELEMENT:HEIGHT:ELEMENT_OPTION:ICON:ENCRYPT:LOV:LOV_DISPLAY_NULL:CASCADING_LOV:JOIN_LOV:FILTER:LINK:FC_HAS_FEEDBACK:FC_LOV_DISPLAY_NULL'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5024\30BB\30EC\30AF\30BF\306E\7D44\8FBC\307F\30EA\30B9\30C8\4ED8\304D\306E\30A2\30A4\30C6\30E0\3092\8868\793A\3057\307E\3059\3002\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\30A2\30A4\30C6\30E0\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\30B5\30DD\30FC\30C8\3055\308C\308B\5024\306E\30EA\30B9\30C8\304C\73FE\5728\306E\30A2\30A4\30C6\30E0\306B\76F4\63A5\57CB\3081\8FBC\307E\308C\3066\8868\793A\3055\308C\307E\3059\3002</p>'),
unistr('<p>\9078\629E\30EA\30B9\30C8\306F\3001\6BD4\8F03\7684\5C0F\3055\306A\4E0D\9023\7D9A\306E\30EA\30B9\30C8\306B\6700\9069\3067\3059\3002\30A8\30F3\30C9\30E6\30FC\30B6\30FC\306F\3001\30DD\30C3\30D7\30A2\30C3\30D7\30FB\30C0\30A4\30A2\30ED\30B0\306B\30D5\30A9\30FC\30AB\30B9\3092\5909\66F4\3059\308B\3053\3068\306A\304F\3001\975E\5E38\306B\7C21\5358\306B\30EA\30B9\30C8\304B\3089\5024\3092\9078\629E\3067\304D\307E\3059\3002\5927\304D\306A\30EA\30B9\30C8\306B\306F\3001\591A\304F\306E\5834\5408<em>\30DD\30C3\30D7\30A2\30C3\30D7LOV</em>\306E\65B9\304C\9069\3057\3066\3044\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2698572905698434305.442)
,p_plugin_id=>wwv_flow_api.id(2698572619073428716.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\9078\629E\6642\306E\30DA\30FC\30B8\30FB\30A2\30AF\30B7\30E7\30F3')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\30EA\30B9\30C8\5024\304C\9078\629E\3055\308C\305F\3068\304D\306B\5B9F\884C\3055\308C\308B\30A2\30AF\30B7\30E7\30F3\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2264411080592689929.442)
,p_plugin_attribute_id=>wwv_flow_api.id(2698572905698434305.442)
,p_display_sequence=>1
,p_display_value=>unistr('\306A\3057')
,p_return_value=>'NONE'
,p_help_text=>unistr('\5024\304C\5909\66F4\3055\308C\305F\3068\304D\306B\305F\3060\3061\306B\5B9F\884C\3055\308C\308B\30A2\30AF\30B7\30E7\30F3\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2698575413579455462.442)
,p_plugin_attribute_id=>wwv_flow_api.id(2698572905698434305.442)
,p_display_sequence=>5
,p_display_value=>unistr('\30DA\30FC\30B8\306E\9001\4FE1')
,p_return_value=>'SUBMIT'
,p_help_text=>unistr('\30DA\30FC\30B8\306F\3001\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\540D\306B\8A2D\5B9A\3055\308C\305F\30DA\30FC\30B8REQUEST\3068\3068\3082\306B\9001\4FE1\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2698574606653453436.442)
,p_plugin_attribute_id=>wwv_flow_api.id(2698572905698434305.442)
,p_display_sequence=>7
,p_display_value=>unistr('\5024\306E\30EA\30C0\30A4\30EC\30AF\30C8\3068\8A2D\5B9A')
,p_return_value=>'REDIRECT_SET_VALUE'
,p_help_text=>unistr('\30D6\30E9\30A6\30B6\306F\73FE\5728\306E\30DA\30FC\30B8\306B\30EA\30C0\30A4\30EC\30AF\30C8\3055\308C\3001\73FE\5728\306E\30A2\30A4\30C6\30E0\306E\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\306F\9078\629E\3055\308C\305F\5024\306B\8A2D\5B9A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2698574220720448121.442)
,p_plugin_attribute_id=>wwv_flow_api.id(2698572905698434305.442)
,p_display_sequence=>9
,p_display_value=>unistr('\30DA\30FC\30B8\306B\30EA\30C0\30A4\30EC\30AF\30C8')
,p_return_value=>'REDIRECT_PAGE'
,p_help_text=>unistr('\30D6\30E9\30A6\30B6\306F\3001\9078\629E\3055\308C\305F\5024\306B\542B\307E\308C\3066\3044\308B\30DA\30FC\30B8\306B\30EA\30C0\30A4\30EC\30AF\30C8\3055\308C\307E\3059\3002\30EA\30B9\30C8\306E\623B\308A\5024\306B\6709\52B9\306A\30DA\30FC\30B8\756A\53F7\307E\305F\306F\30DA\30FC\30B8\306E\5225\540D\304C\542B\307E\308C\3066\3044\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2698573815526446624.442)
,p_plugin_attribute_id=>wwv_flow_api.id(2698572905698434305.442)
,p_display_sequence=>10
,p_display_value=>unistr('URL\306B\30EA\30C0\30A4\30EC\30AF\30C8')
,p_return_value=>'REDIRECT_URL'
,p_help_text=>unistr('\30D6\30E9\30A6\30B6\306F\3001\9078\629E\3055\308C\305F\5024\306B\542B\307E\308C\3066\3044\308BURL\306B\30EA\30C0\30A4\30EC\30AF\30C8\3055\308C\307E\3059\3002\30EA\30B9\30C8\306E\623B\308A\5024\306B\6709\52B9\306AURL\304C\542B\307E\308C\3066\3044\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(912506420442525842.442)
,p_plugin_id=>wwv_flow_api.id(2698572619073428716.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\8907\6570\9078\629E\3092\8A31\53EF')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2698572905698434305.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'NONE'
,p_help_text=>unistr('LOV\304B\3089\8907\6570\306E\5024\3092\9078\629E\3067\304D\308B\304B\30011\3064\306E\5024\306E\307F\9078\629E\3067\304D\308B\304B\3092\6307\5B9A\3057\307E\3059\3002\8907\6570\306E\5024\306F\3001\30AB\30F3\30DE\533A\5207\308A\306E\30EA\30B9\30C8\3067\8FD4\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(459061412834919653.442)
,p_plugin_id=>wwv_flow_api.id(2698572619073428716.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\691C\8A3C\306E\5B9F\884C')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2698572905698434305.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SUBMIT'
,p_help_text=>unistr('<strong>\300C\30DA\30FC\30B8\306E\9001\4FE1\300D</strong>\306E\30DA\30FC\30B8\30FB\30A2\30AF\30B7\30E7\30F3\8A2D\5B9A\306B\57FA\3065\3044\3066\3001\30DA\30FC\30B8\306E\9001\4FE1\6642\306B\691C\8A3C\3092\5B9F\884C\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845156662497834548.442)
,p_plugin_id=>wwv_flow_api.id(2698572619073428716.442)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>SQL\554F\5408\305B\306B\57FA\3065\3044\305FLOV</dt>'),
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>\540C\3058\8868\793A\304A\3088\3073\623B\308A\5024\3092\4F7F\7528\3057\305FLOV</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>\30CE\30FC\30C8: \8868\793A\5024\3068\623B\308A\5024\306E\4E21\65B9\306B\540C\3058\5217\3092\9078\629E\3059\308B\5834\5408\3001\5217\306E\5225\540D\3092\4F7F\7528\3057\307E\3059\3002</p>'),
'</dd>',
unistr('<dt>\30D0\30A4\30F3\30C9\5909\6570\3092\4F7F\7528\3057\305FLOV</dt>'),
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>\30CE\30FC\30C8: <code>P3_DEPTNO</code>\304C\540C\3058\30DA\30FC\30B8\306E\5909\66F4\53EF\80FD\306A\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306E\5834\5408\3001<em>\300C\30AB\30B9\30B1\30FC\30C9LOV\89AA\30A2\30A4\30C6\30E0\300D</em>\5C5E\6027\3092<code>P3_DEPTNO</code>\306B\8A2D\5B9A\3057\307E\3059\3002</dd>'),
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/region_type/jqm_column_toggle
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3482208123256545756.442)
,p_plugin_type=>'REGION TYPE'
,p_name=>'JQM_COLUMN_TOGGLE'
,p_display_name=>unistr('\5217\5207\66FF\3048\30EC\30DD\30FC\30C8')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','JQM_COLUMN_TOGGLE'),'')
,p_api_version=>1
,p_render_function=>'xxx'
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:NO_DATA_FOUND_MESSAGE:COLUMNS:COLUMN_HEADING:HEADING_ALIGNMENT:VALUE_ALIGNMENT:VALUE_CSS:VALUE_ATTRIBUTE:VALUE_ESCAPE_OUTPUT'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\5B9F\884C\6642\306B\8868\793A\3059\308B\5217\3092\9078\629E\3067\304D\308B\30EC\30DD\30FC\30C8\3092\8868\793A\3057\307E\3059\3002\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\3001\30EC\30DD\30FC\30C8\306E\8868\793A\306B\4F7F\7528\3059\308B\753B\9762\306E\5E45\3084\5411\304D\306B\57FA\3065\3044\3066\5217\3092\5909\66F4\3067\304D\307E\3059\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1823587226519967208.442)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.442)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\30BF\30A4\30D7')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'PLAIN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\3053\306E\30EC\30DD\30FC\30C8\5217\306E\30D9\30FC\30B9\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1823587544288968547.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1823587226519967208.442)
,p_display_sequence=>10
,p_display_value=>unistr('\30D7\30EC\30FC\30F3\30FB\30C6\30AD\30B9\30C8')
,p_return_value=>'PLAIN'
,p_help_text=>unistr('\5217\5024\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1823587907770969285.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1823587226519967208.442)
,p_display_sequence=>20
,p_display_value=>unistr('\30EA\30F3\30AF')
,p_return_value=>'LINK'
,p_help_text=>unistr('\30EA\30F3\30AF\3068\3057\3066\5217\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1305234852618727263.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1823587226519967208.442)
,p_display_sequence=>30
,p_display_value=>unistr('\30D1\30FC\30BB\30F3\30C8\30FB\30B0\30E9\30D5')
,p_return_value=>'PCT_GRAPH'
,p_help_text=>unistr('\30D1\30FC\30BB\30F3\30C6\30FC\30B8\30FB\30B0\30E9\30D5\3068\3057\3066\5217\3092\8868\793A\3057\307E\3059\3002\53D6\5F97\3055\308C\308B\5024\306F\30010\304B\3089100\307E\3067\306E\9593\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1823588275617978359.442)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.442)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\30BF\30FC\30B2\30C3\30C8')
,p_attribute_type=>'LINK'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1823587226519967208.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>unistr('<p>\30E6\30FC\30B6\30FC\304C\65E2\5B58\30A8\30F3\30C8\30EA\3092\30AF\30EA\30C3\30AF\3057\305F\3068\304D\306B\547C\3073\51FA\3055\308C\308B\30BF\30FC\30B2\30C3\30C8\30FB\30DA\30FC\30B8\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1238927721819003883.442)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.442)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\30EA\30F3\30AF\30FB\30C6\30AD\30B9\30C8')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1823587226519967208.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>unistr('\30EA\30F3\30AF\3068\3057\3066\8868\793A\3055\308C\308BHTML\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002\30A4\30E1\30FC\30B8\3092\8868\793A\3059\308B\306B\306F\3001\30A4\30E1\30FC\30B8\30FB\30BF\30B0\3092\4F7F\7528\3059\308B\304B\3001\30C7\30D5\30A9\30EB\30C8\30FB\30A4\30E1\30FC\30B8\306E\30EA\30B9\30C8\304B\3089\30A4\30E1\30FC\30B8\3092\53D6\5F97\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1238931409403155860.442)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.442)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\30EA\30F3\30AF\5C5E\6027')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1823587226519967208.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>unistr('<code>&lt;a href=...&gt;</code>\30BF\30B0\306B\542B\3081\308B\8FFD\52A0\306E\5217\30EA\30F3\30AF\5C5E\6027(\30EA\30F3\30AF\30FB\30BF\30FC\30B2\30C3\30C8\3001\30AF\30E9\30B9\3001\30B9\30BF\30A4\30EB\306A\3069)\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1305278757261772485.442)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.442)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\30D0\30C3\30AF\30B0\30E9\30A6\30F3\30C9\30FB\30AB\30E9\30FC')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1823587226519967208.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\306AHTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\306E\4F8B\306B\306F\6B21\306E\3082\306E\304C\3042\308A\307E\3059 - '),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30B0\30E9\30D5\306E\30D0\30C3\30AF\30B0\30E9\30A6\30F3\30C9\306B\4F7F\7528\3055\308C\308B\8272\3092\5165\529B\3057\307E\3059\3002'),
unistr('\8272\306F\300116\9032(hex)\8868\8A18\3001RGB\30AB\30E9\30FC\30FB\30B3\30FC\30C9\307E\305F\306FHTML\30AB\30E9\30FC\540D\3092\4F7F\7528\3057\3066\6307\5B9A\3055\308C\307E\3059\3002</p>'),
unistr('<p>16\9032\8868\8A18\306F#xxyyzz (#\306E\5F8C\306B3\3064\306E2\6841\306E16\9032\6570)\3067\5B9A\7FA9\3055\308C\3001xx\3001yy\304A\3088\3073zz\306F\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E2\6587\5B57\306E16\9032\306E\5024\3092\8868\3057\307E\3059\3002'),
unistr('RGB\30B3\30FC\30C9\306FRGB(xxx,xxx,xxx)\3067\5B9A\7FA9\3055\308C\3001xxx\306F0\304B\3089255\306E\9593\306E\6570\5024\3067\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E8\30D3\30C3\30C8\30FB\30D0\30A4\30C8\5024\3092\8868\3057\307E\3059\3002</p>'),
unistr('<p>\30A4\30F3\30BF\30FC\30CD\30C3\30C8\3067HTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\3092\691C\7D22\3059\308B\3068\3001\4F7F\7528\3059\308B\8272\306E16\9032\30B3\30FC\30C9\307E\305F\306FRGB\30B3\30FC\30C9\304C\308F\304B\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1305279121857779186.442)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.442)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\524D\666F\8272')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1823587226519967208.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\306AHTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\306E\4F8B\306B\306F\6B21\306E\3082\306E\304C\3042\308A\307E\3059 - '),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30B0\30E9\30D5\306E\524D\666F\306B\4F7F\7528\3055\308C\308B\8272\3092\5165\529B\3057\307E\3059\3002'),
unistr('\8272\306F\300116\9032(hex)\8868\8A18\3001RGB\30AB\30E9\30FC\30FB\30B3\30FC\30C9\307E\305F\306FHTML\30AB\30E9\30FC\540D\3092\4F7F\7528\3057\3066\6307\5B9A\3055\308C\307E\3059\3002</p>'),
unistr('<p>16\9032\8868\8A18\306F#xxyyzz (#\306E\5F8C\306B3\3064\306E2\6841\306E16\9032\6570)\3067\5B9A\7FA9\3055\308C\3001xx\3001yy\304A\3088\3073zz\306F\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E2\6587\5B57\306E16\9032\306E\5024\3092\8868\3057\307E\3059\3002'),
unistr('RGB\30B3\30FC\30C9\306FRGB(xxx,xxx,xxx)\3067\5B9A\7FA9\3055\308C\3001xxx\306F0\304B\3089255\306E\9593\306E\6570\5024\3067\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E8\30D3\30C3\30C8\30FB\30D0\30A4\30C8\5024\3092\8868\3057\307E\3059\3002</p>'),
unistr('<p>\30A4\30F3\30BF\30FC\30CD\30C3\30C8\3067HTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\3092\691C\7D22\3059\308B\3068\3001\4F7F\7528\3059\308B\8272\306E16\9032\30B3\30FC\30C9\307E\305F\306FRGB\30B3\30FC\30C9\304C\308F\304B\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1305282212210798696.442)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.442)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\68D2\306E\5E45')
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>3
,p_max_length=>3
,p_unit=>unistr('\30D4\30AF\30BB\30EB')
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1823587226519967208.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_help_text=>unistr('\3053\306E\68D2\30B0\30E9\30D5\306E\5E45\3092\30D4\30AF\30BB\30EB\5358\4F4D\3067\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(149106414354906696.442)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.442)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\884C\30D8\30C3\30C0\30FC\3068\3057\3066\4F7F\7528')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\3053\308C\306F\3001\884C\306E\30B3\30F3\30C6\30F3\30C4\3092\6700\9069\306B\8868\3059\5217\3092\8B58\5225\3059\308B\305F\3081\306E\30A2\30AF\30BB\30B7\30D3\30EA\30C6\30A3\306B\4F7F\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2695400128710862038.442)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.442)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>25
,p_display_sequence=>250
,p_prompt=>unistr('\512A\5148\5EA6')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'1'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30EC\30DD\30FC\30C8\306F\3001\4F7F\7528\53EF\80FD\306A\753B\9762\306E\5E45\3068\30E6\30FC\30B6\30FC\306B\3088\308B\5217\30D4\30C3\30AB\30FC\30FB\30E1\30CB\30E5\30FC\3067\306E\8868\793A\5217\306E\9078\629E/\9078\629E\89E3\9664\306E2\3064\306E\5165\529B\306B\57FA\3065\3044\3066\5217\3092\975E\8868\793A\306B\3057\305F\308A\8868\793A\3059\308B\3053\3068\3067\6A5F\80FD\3057\307E\3059\3002\30EC\30B9\30DD\30F3\30B7\30D6\306B\8868\793A\3059\308B\5404\5217\306E\512A\5148\5EA6\306E\5024\3092\9078\629E\3057\307E\3059\3002\512A\5148\5EA6\304C\6307\5B9A\3055\308C\305F\5217\306F\5217\30D4\30C3\30AB\30FC\30FB\30E1\30CB\30E5\30FC\3067\4F7F\7528\53EF\80FD\306B\306A\308A\307E\3059\3002<p>'),
'',
unistr('<p>\5217\3092\6C38\7D9A\306B\3057\3066\975E\8868\793A\306B\306A\3089\306A\3044\3088\3046\306B\3059\308B\306B\306F\3001<strong>\300C\5E38\306B\8868\793A\300D</strong>\3092\9078\629E\3057\307E\3059\3002\3053\308C\306B\3088\3063\3066\3001\5217\30D4\30C3\30AB\30FC\30FB\30E1\30CB\30E5\30FC\304B\3089\306E\5217\306E\524A\9664\3082\884C\308F\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(686758760912714500.442)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.442)
,p_display_sequence=>5
,p_display_value=>unistr('\5E38\306B\8868\793A')
,p_return_value=>'ALWAYS'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1245557520909123628.442)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.442)
,p_display_sequence=>10
,p_display_value=>unistr('1 - \6700\5F8C\3092\975E\8868\793A')
,p_return_value=>'1'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1245557959195124246.442)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.442)
,p_display_sequence=>20
,p_display_value=>'2'
,p_return_value=>'2'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1245558584414124867.442)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.442)
,p_display_sequence=>30
,p_display_value=>'3'
,p_return_value=>'3'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1245558946802125444.442)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.442)
,p_display_sequence=>40
,p_display_value=>'4'
,p_return_value=>'4'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1245559350856125993.442)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.442)
,p_display_sequence=>50
,p_display_value=>'5'
,p_return_value=>'5'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1245559812372127827.442)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.442)
,p_display_sequence=>60
,p_display_value=>unistr('6 - \6700\521D\3092\975E\8868\793A')
,p_return_value=>'6'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1823549938363826650.442)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\30EC\30A4\30A2\30A6\30C8\30FB\30AA\30D7\30B7\30E7\30F3')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'STRIPE:STROKE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\8FFD\52A0\30EC\30DD\30FC\30C8\30FB\30EC\30A4\30A2\30A6\30C8\30FB\30AA\30D7\30B7\30E7\30F3\3092\78BA\8A8D\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1238928674387055064.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1823549938363826650.442)
,p_display_sequence=>10
,p_display_value=>unistr('\30B9\30C8\30E9\30A4\30D7')
,p_return_value=>'STRIPE'
,p_help_text=>unistr('\5404\884C\306B1\884C\304A\304D\306E\884C\30B9\30C8\30E9\30A4\30D7\3092\8FFD\52A0\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1238929097998055827.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1823549938363826650.442)
,p_display_sequence=>20
,p_display_value=>unistr('\30B9\30C8\30ED\30FC\30AF')
,p_return_value=>'STROKE'
,p_help_text=>unistr('\5404\884C\306E\9593\306B\6A2A\7DDA\3092\8FFD\52A0\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1238929416131062515.442)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('CSS\30AF\30E9\30B9')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\542B\3081\3089\308C\308B\8FFD\52A0\306ECSS\30AF\30E9\30B9\3092\7A7A\767D\3067\533A\5207\3063\3066\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1238929773245063952.442)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\30AB\30B9\30BF\30E0\5C5E\6027')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('<p>\8868\306EHTML\30BF\30B0\306B\542B\3081\308B\8FFD\52A0\306E\5C5E\6027\3092\5165\529B\3057\307E\3059\3002\30AF\30E9\30B9\306EHTML\5C5E\6027\306F\751F\6210\3055\308C\308B\305F\3081\3001\6307\5B9A\3057\307E\305B\3093\3002\304B\308F\308A\306B\5C02\7528\306E<em>\300CCSS\30AF\30E9\30B9\300D</em>\5C5E\6027\3092\4F7F\7528\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(106020849730927710.442)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\5217\30DC\30BF\30F3\30FB\30C6\30AD\30B9\30C8')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_help_text=>unistr('\3053\308C\306F\3001\5217\9078\629E\30DD\30C3\30D7\30A2\30C3\30D7\3092\958B\304F\30DC\30BF\30F3\306B\4F7F\7528\3059\308B\30E9\30D9\30EB\3067\3059\3002\30C6\30AD\30B9\30C8\304C\6307\5B9A\3055\308C\3066\3044\306A\3044\5834\5408\3001\30C7\30D5\30A9\30EB\30C8\30FB\30E9\30D9\30EB\304C\4F7F\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(107062574864851281.442)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.442)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\3059\3079\3066\306E\5F93\696D\54E1\3092\540D\524D\9806\306B\8868\793A</dt>'),
'<dd><pre>',
'SELECT * FROM emp ORDER by ename',
'</pre></dd>',
unistr('<dt>\73FE\5728\306E\90E8\9580\306E\3059\3079\3066\306E\5F93\696D\54E1\3092\540D\524D\9806\306B\8868\793A</dt>'),
'<dd><pre>',
'SELECT * FROM emp ',
'WHERE deptno = :P3_DEPTNO ',
'ORDER by 1',
'</pre>',
unistr('<p>\30D0\30A4\30F3\30C9\5909\6570\3092\4F7F\7528\3057\3066\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3092\53C2\7167\3059\308B\3068\304D\306F\3001<strong>\300C\9001\4FE1\3059\308B\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\300D</strong>\3068\3057\3066\6307\5B9A\3057\3066\304F\3060\3055\3044\3002</p>'),
'</dd>',
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/item_type/shuttle
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3601651046632666378.442)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'SHUTTLE'
,p_display_name=>unistr('\30B7\30E3\30C8\30EB')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','SHUTTLE'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:SOURCE:ELEMENT:HEIGHT:ELEMENT_OPTION:ENCRYPT:LOV:CASCADING_LOV:JOIN_LOV:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30EA\30B9\30C8\3092\542B\30802\3064\306E\30DC\30C3\30AF\30B9\3092\542B\3080\8907\6570\306E\9078\629E\30EA\30B9\30C8\3068\3057\3066\8868\793A\3057\307E\3059\3002\5DE6\306E\30EA\30B9\30C8\306B\306F\3001\9078\629E\3055\308C\3066\3044\306A\3044\5024\306E\30BD\30FC\30B9\30FB\30EA\30B9\30C8\304C\8868\793A\3055\308C\3001\53F3\306E\30EA\30B9\30C8\306B\306F\3001\73FE\5728\9078\629E\3055\308C\3066\3044\308B\5024\304C\8868\793A\3055\308C\307E\3059\3002\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\3001\30EA\30B9\30C8\30671\3064\4EE5\4E0A\306E\5024\3092\9078\629E\3057\3001\9078\629E\3057\305F\5024\307E\305F\306F\3059\3079\3066\306E\5024\3092\30B7\30E3\30C8\30EB\30FB\30B3\30F3\30C8\30ED\30FC\30EB\3092\4F7F\7528\3057\3066\79FB\52D5\3067\304D\307E\3059\3002</p>'),
unistr('<p>\73FE\5728\306E\5024\306F\30011\3064\306E\30B3\30ED\30F3\3067\533A\5207\3089\308C\305F\6587\5B57\5217\306B\683C\7D0D\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1815740271128931626.442)
,p_plugin_id=>wwv_flow_api.id(3601651046632666378.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\30B3\30F3\30C8\30ED\30FC\30EB\306E\8868\793A')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ALL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\30B7\30E3\30C8\30EB\306E\4E2D\592E\306B\8868\793A\3059\308B\30C7\30FC\30BF\79FB\52D5\30B3\30F3\30C8\30ED\30FC\30EB\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1815740874245932549.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1815740271128931626.442)
,p_display_sequence=>10
,p_display_value=>unistr('\3059\3079\3066')
,p_return_value=>'ALL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1815741286365936063.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1815740271128931626.442)
,p_display_sequence=>20
,p_display_value=>unistr('\79FB\52D5\306E\307F')
,p_return_value=>'MOVE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1815741691214937407.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1815740271128931626.442)
,p_display_sequence=>30
,p_display_value=>unistr('\4E26\66FF\3048\306E\307F')
,p_return_value=>'ORDER'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1815746874076970329.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1815740271128931626.442)
,p_display_sequence=>40
,p_display_value=>unistr('\306A\3057')
,p_return_value=>'NONE'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845156821574834552.442)
,p_plugin_id=>wwv_flow_api.id(3601651046632666378.442)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_sql_max_column_count=>2
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>SQL\554F\5408\305B\306B\57FA\3065\3044\305FLOV</dt>'),
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>\540C\3058\8868\793A\304A\3088\3073\623B\308A\5024\3092\4F7F\7528\3057\305FLOV</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>\30CE\30FC\30C8: \8868\793A\5024\3068\623B\308A\5024\306E\4E21\65B9\306B\540C\3058\5217\3092\9078\629E\3059\308B\5834\5408\3001\5217\306E\5225\540D\3092\4F7F\7528\3057\307E\3059\3002</p>'),
'</dd>',
unistr('<dt>\30D0\30A4\30F3\30C9\5909\6570\3092\4F7F\7528\3057\305FLOV</dt>'),
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>\30CE\30FC\30C8: <code>P3_DEPTNO</code>\304C\540C\3058\30DA\30FC\30B8\306E\5909\66F4\53EF\80FD\306A\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306E\5834\5408\3001<em>\300C\30AB\30B9\30B1\30FC\30C9LOV\89AA\30A2\30A4\30C6\30E0\300D</em>\5C5E\6027\3092<code>P3_DEPTNO</code>\306B\8A2D\5B9A\3057\307E\3059\3002</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(1815705269182590478.442)
,p_plugin_id=>wwv_flow_api.id(3601651046632666378.442)
,p_name=>'shuttlechangeorder'
,p_display_name=>unistr('\9806\5E8F\306E\5909\66F4')
);
end;
/
prompt --application/shared_components/plugins/item_type/radiogroup
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3605341835055239817.442)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'RADIOGROUP'
,p_display_name=>unistr('\30E9\30B8\30AA\30FB\30B0\30EB\30FC\30D7')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS:APEX_APPL_PAGE_FACETS:APEX_APPL_PAGE_SFILTERS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','RADIOGROUP'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:ESCAPE_OUTPUT:SOURCE:ELEMENT:ELEMENT_OPTION:ENCRYPT:LOV:LOV_DISPLAY_NULL:CASCADING_LOV:JOIN_LOV:FILTER:LINK:FC_HAS_FEEDBACK:FC_SHOW_SELECTED_FIRST:FC_SHOW_MORE_COUNT:FC_FILTER_VALUES:FC_LOV_DISPLAY_NULL'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\8907\6570\306E\5024\3092\30E9\30B8\30AA\30FB\30DC\30BF\30F3\30FB\30AA\30D7\30B7\30E7\30F3\3068\3057\3066\8868\793A\3057\3001\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C1\3064\306E\5024\3092\9078\629E\3067\304D\308B\3088\3046\306B\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1822713552956622305.442)
,p_plugin_id=>wwv_flow_api.id(3605341835055239817.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\5217\306E\6570')
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'1'
,p_display_length=>3
,p_max_length=>3
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_help_text=>unistr('\8868\793A\3059\308B\30E9\30B8\30AA\30FB\30B0\30EB\30FC\30D7\5217\306E\6570\3092\5165\529B\3057\307E\3059\3002\305F\3068\3048\3070\3001<code>2</code>\3068\3044\3046\5024\3067\306F2\5217\304C\8868\793A\3055\308C\308B\305F\3081\3001\5024\304C5\500B\3042\308B\5834\5408\30013\884C\306B\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1823061668632450689.442)
,p_plugin_id=>wwv_flow_api.id(3605341835055239817.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\9078\629E\6642\306E\30DA\30FC\30B8\30FB\30A2\30AF\30B7\30E7\30F3')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\30E9\30B8\30AA\30FB\30B0\30EB\30FC\30D7\5024\304C\9078\629E\3055\308C\305F\3068\304D\306B\5B9F\884C\3055\308C\308B\30A2\30AF\30B7\30E7\30F3\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1823062574865452418.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1823061668632450689.442)
,p_display_sequence=>10
,p_display_value=>unistr('\306A\3057')
,p_return_value=>'NONE'
,p_help_text=>unistr('\5024\304C\5909\66F4\3055\308C\305F\3068\304D\306B\305F\3060\3061\306B\5B9F\884C\3055\308C\308B\30A2\30AF\30B7\30E7\30F3\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1823062977982453399.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1823061668632450689.442)
,p_display_sequence=>20
,p_display_value=>unistr('\30DA\30FC\30B8\306E\9001\4FE1')
,p_return_value=>'SUBMIT'
,p_help_text=>unistr('\30DA\30FC\30B8\306F\3001\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\540D\306B\8A2D\5B9A\3055\308C\305F\30DA\30FC\30B8REQUEST\3068\3068\3082\306B\9001\4FE1\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1823063380406454049.442)
,p_plugin_attribute_id=>wwv_flow_api.id(1823061668632450689.442)
,p_display_sequence=>30
,p_display_value=>unistr('\5024\306E\30EA\30C0\30A4\30EC\30AF\30C8\3068\8A2D\5B9A')
,p_return_value=>'REDIRECT_SET_VALUE'
,p_help_text=>unistr('\30D6\30E9\30A6\30B6\306F\73FE\5728\306E\30DA\30FC\30B8\306B\30EA\30C0\30A4\30EC\30AF\30C8\3057\3001\73FE\5728\306E\30A2\30A4\30C6\30E0\306E\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\306F\9078\629E\3055\308C\305F\5024\306B\8A2D\5B9A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(459060107939889859.442)
,p_plugin_id=>wwv_flow_api.id(3605341835055239817.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\691C\8A3C\306E\5B9F\884C')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1823061668632450689.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SUBMIT'
,p_help_text=>unistr('\30DA\30FC\30B8\30FB\30A2\30AF\30B7\30E7\30F3\8A2D\5B9A<strong>\300C\30DA\30FC\30B8\306E\9001\4FE1\300D</strong>\306E\305F\3081\306B\30DA\30FC\30B8\306E\9001\4FE1\6642\306B\691C\8A3C\3092\5B9F\884C\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(12184106346189362.442)
,p_plugin_id=>wwv_flow_api.id(3605341835055239817.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>5
,p_prompt=>unistr('\5411\304D\3092\8868\793A')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VERTICAL'
,p_supported_ui_types=>'JQM_SMARTPHONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\30E9\30B8\30AA\30FB\30B0\30EB\30FC\30D7\5024\3092\8868\793A\3059\308B\5411\304D\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(12184610155190440.442)
,p_plugin_attribute_id=>wwv_flow_api.id(12184106346189362.442)
,p_display_sequence=>10
,p_display_value=>unistr('\7E26')
,p_return_value=>'VERTICAL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(12185014311191660.442)
,p_plugin_attribute_id=>wwv_flow_api.id(12184106346189362.442)
,p_display_sequence=>20
,p_display_value=>unistr('\6A2A')
,p_return_value=>'HORIZONTAL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(728745079326901742.442)
,p_plugin_id=>wwv_flow_api.id(3605341835055239817.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\30E9\30B8\30AA\30FB\30DC\30BF\30F3\306E\975E\8868\793A')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS'
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845156982734834553.442)
,p_plugin_id=>wwv_flow_api.id(3605341835055239817.442)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>SQL\554F\5408\305B\306B\57FA\3065\3044\305FLOV</dt>'),
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>\540C\3058\8868\793A\304A\3088\3073\623B\308A\5024\3092\4F7F\7528\3057\305FLOV</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>\30CE\30FC\30C8: \8868\793A\5024\3068\623B\308A\5024\306E\4E21\65B9\306B\540C\3058\5217\3092\9078\629E\3059\308B\5834\5408\3001\5217\306E\5225\540D\3092\4F7F\7528\3057\307E\3059\3002</p>'),
'</dd>',
unistr('<dt>\30D0\30A4\30F3\30C9\5909\6570\3092\4F7F\7528\3057\305FLOV</dt>'),
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>\30CE\30FC\30C8: <code>P3_DEPTNO</code>\304C\540C\3058\30DA\30FC\30B8\306E\5909\66F4\53EF\80FD\306A\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306E\5834\5408\3001<em>\300C\30AB\30B9\30B1\30FC\30C9LOV\89AA\30A2\30A4\30C6\30E0\300D</em>\5C5E\6027\3092<code>P3_DEPTNO</code>\306B\8A2D\5B9A\3057\307E\3059\3002</dd>'),
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/region_type/jqm_reflow
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(4136056421507264989.442)
,p_plugin_type=>'REGION TYPE'
,p_name=>'JQM_REFLOW'
,p_display_name=>unistr('\30EA\30D5\30ED\30FC\30FB\30EC\30DD\30FC\30C8')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','JQM_REFLOW'),'')
,p_api_version=>1
,p_render_function=>'xxx'
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:NO_DATA_FOUND_MESSAGE:COLUMNS:COLUMN_HEADING:HEADING_ALIGNMENT:VALUE_ALIGNMENT:VALUE_CSS:VALUE_ATTRIBUTE:VALUE_ESCAPE_OUTPUT'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\30B5\30A4\30BA\306E\5C0F\3055\3044\30D6\30E9\30A6\30B6(\753B\9762)\306B\30EC\30DD\30FC\30C8\3092\8868\793A\3059\308B\305F\3081\306B\5217\304B\3089\884C\306B\5909\63DB\3059\308B\30EC\30B9\30DD\30F3\30B7\30D6\306A\30EC\30DD\30FC\30C8\3092\8868\793A\3057\307E\3059\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2477435524770686441.442)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.442)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\30BF\30A4\30D7')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'PLAIN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\3053\306E\30EC\30DD\30FC\30C8\5217\306E\30D9\30FC\30B9\3092\9078\629E\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2477435842539687780.442)
,p_plugin_attribute_id=>wwv_flow_api.id(2477435524770686441.442)
,p_display_sequence=>10
,p_display_value=>unistr('\30D7\30EC\30FC\30F3\30FB\30C6\30AD\30B9\30C8')
,p_return_value=>'PLAIN'
,p_help_text=>unistr('\5217\5024\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2477436206021688518.442)
,p_plugin_attribute_id=>wwv_flow_api.id(2477435524770686441.442)
,p_display_sequence=>20
,p_display_value=>unistr('\30EA\30F3\30AF')
,p_return_value=>'LINK'
,p_help_text=>unistr('\30EA\30F3\30AF\3068\3057\3066\5217\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1959083150869446496.442)
,p_plugin_attribute_id=>wwv_flow_api.id(2477435524770686441.442)
,p_display_sequence=>30
,p_display_value=>unistr('\30D1\30FC\30BB\30F3\30C8\30FB\30B0\30E9\30D5')
,p_return_value=>'PCT_GRAPH'
,p_help_text=>unistr('\30D1\30FC\30BB\30F3\30C6\30FC\30B8\30FB\30B0\30E9\30D5\3068\3057\3066\5217\3092\8868\793A\3057\307E\3059\3002\53D6\5F97\3055\308C\308B\5024\306F\30010\304B\3089100\307E\3067\306E\9593\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2477436573868697592.442)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.442)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\30BF\30FC\30B2\30C3\30C8')
,p_attribute_type=>'LINK'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2477435524770686441.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>unistr('<p>\30E6\30FC\30B6\30FC\304C\65E2\5B58\30A8\30F3\30C8\30EA\3092\30AF\30EA\30C3\30AF\3057\305F\3068\304D\306B\547C\3073\51FA\3055\308C\308B\30BF\30FC\30B2\30C3\30C8\30FB\30DA\30FC\30B8\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1892776020069723116.442)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.442)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\30EA\30F3\30AF\30FB\30C6\30AD\30B9\30C8')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(2477435524770686441.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>unistr('\30EA\30F3\30AF\3068\3057\3066\8868\793A\3055\308C\308BHTML\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002\30A4\30E1\30FC\30B8\3092\8868\793A\3059\308B\306B\306F\3001\30A4\30E1\30FC\30B8\30FB\30BF\30B0\3092\4F7F\7528\3059\308B\304B\3001\30C7\30D5\30A9\30EB\30C8\30FB\30A4\30E1\30FC\30B8\306E\30EA\30B9\30C8\304B\3089\30A4\30E1\30FC\30B8\3092\53D6\5F97\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1892779707653875093.442)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.442)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\30EA\30F3\30AF\5C5E\6027')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2477435524770686441.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>unistr('<code>&lt;a href=...&gt;</code>\30BF\30B0\306B\542B\3081\308B\8FFD\52A0\306E\5217\30EA\30F3\30AF\5C5E\6027(\30EA\30F3\30AF\30FB\30BF\30FC\30B2\30C3\30C8\3001\30AF\30E9\30B9\3001\30B9\30BF\30A4\30EB\306A\3069)\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1959127055512491718.442)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.442)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\30D0\30C3\30AF\30B0\30E9\30A6\30F3\30C9\30FB\30AB\30E9\30FC')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2477435524770686441.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\306AHTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\306E\4F8B\306B\306F\6B21\306E\3082\306E\304C\3042\308A\307E\3059 - '),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30B0\30E9\30D5\306E\30D0\30C3\30AF\30B0\30E9\30A6\30F3\30C9\306B\4F7F\7528\3055\308C\308B\8272\3092\5165\529B\3057\307E\3059\3002'),
unistr('\8272\306F\300116\9032(hex)\8868\8A18\3001RGB\30AB\30E9\30FC\30FB\30B3\30FC\30C9\307E\305F\306FHTML\30AB\30E9\30FC\540D\3092\4F7F\7528\3057\3066\6307\5B9A\3055\308C\307E\3059\3002</p>'),
unistr('<p>16\9032\8868\8A18\306F#xxyyzz (#\306E\5F8C\306B3\3064\306E2\6841\306E16\9032\6570)\3067\5B9A\7FA9\3055\308C\3001xx\3001yy\304A\3088\3073zz\306F\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E2\6587\5B57\306E16\9032\306E\5024\3092\8868\3057\307E\3059\3002'),
unistr('RGB\30B3\30FC\30C9\306FRGB(xxx,xxx,xxx)\3067\5B9A\7FA9\3055\308C\3001xxx\306F0\304B\3089255\306E\9593\306E\6570\5024\3067\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E8\30D3\30C3\30C8\30FB\30D0\30A4\30C8\5024\3092\8868\3057\307E\3059\3002</p>'),
unistr('<p>\30A4\30F3\30BF\30FC\30CD\30C3\30C8\3067HTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\3092\691C\7D22\3059\308B\3068\3001\4F7F\7528\3059\308B\8272\306E16\9032\30B3\30FC\30C9\307E\305F\306FRGB\30B3\30FC\30C9\304C\308F\304B\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1959127420108498419.442)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.442)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\524D\666F\8272')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2477435524770686441.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\306AHTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\306E\4F8B\306B\306F\6B21\306E\3082\306E\304C\3042\308A\307E\3059 - '),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30B0\30E9\30D5\306E\524D\666F\306B\4F7F\7528\3055\308C\308B\8272\3092\5165\529B\3057\307E\3059\3002'),
unistr('\8272\306F\300116\9032(hex)\8868\8A18\3001RGB\30AB\30E9\30FC\30FB\30B3\30FC\30C9\307E\305F\306FHTML\30AB\30E9\30FC\540D\3092\4F7F\7528\3057\3066\6307\5B9A\3055\308C\307E\3059\3002</p>'),
unistr('<p>16\9032\8868\8A18\306F#xxyyzz (#\306E\5F8C\306B3\3064\306E2\6841\306E16\9032\6570)\3067\5B9A\7FA9\3055\308C\3001xx\3001yy\304A\3088\3073zz\306F\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E2\6587\5B57\306E16\9032\306E\5024\3092\8868\3057\307E\3059\3002'),
unistr('RGB\30B3\30FC\30C9\306FRGB(xxx,xxx,xxx)\3067\5B9A\7FA9\3055\308C\3001xxx\306F0\304B\3089255\306E\9593\306E\6570\5024\3067\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E8\30D3\30C3\30C8\30FB\30D0\30A4\30C8\5024\3092\8868\3057\307E\3059\3002</p>'),
unistr('<p>\30A4\30F3\30BF\30FC\30CD\30C3\30C8\3067HTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\3092\691C\7D22\3059\308B\3068\3001\4F7F\7528\3059\308B\8272\306E16\9032\30B3\30FC\30C9\307E\305F\306FRGB\30B3\30FC\30C9\304C\308F\304B\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1959130510461517929.442)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.442)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\68D2\306E\5E45')
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>3
,p_max_length=>3
,p_unit=>unistr('\30D4\30AF\30BB\30EB')
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2477435524770686441.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_help_text=>unistr('\3053\306E\68D2\30B0\30E9\30D5\306E\5E45\3092\30D4\30AF\30BB\30EB\5358\4F4D\3067\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(149105606951887044.442)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.442)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\884C\30D8\30C3\30C0\30FC\3068\3057\3066\4F7F\7528')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\3053\308C\306F\3001\884C\306E\30B3\30F3\30C6\30F3\30C4\3092\6700\9069\306B\8868\3059\5217\3092\8B58\5225\3059\308B\305F\3081\306E\30A2\30AF\30BB\30B7\30D3\30EA\30C6\30A3\306B\4F7F\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2477398236614545883.442)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\30EC\30A4\30A2\30A6\30C8\30FB\30AA\30D7\30B7\30E7\30F3')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'STRIPE:STROKE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\8FFD\52A0\30EC\30DD\30FC\30C8\30FB\30EC\30A4\30A2\30A6\30C8\30FB\30AA\30D7\30B7\30E7\30F3\3092\78BA\8A8D\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1892776972637774297.442)
,p_plugin_attribute_id=>wwv_flow_api.id(2477398236614545883.442)
,p_display_sequence=>10
,p_display_value=>unistr('\30B9\30C8\30E9\30A4\30D7')
,p_return_value=>'STRIPE'
,p_help_text=>unistr('\5404\884C\306B1\884C\304A\304D\306E\884C\30B9\30C8\30E9\30A4\30D7\3092\8FFD\52A0\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1892777396248775060.442)
,p_plugin_attribute_id=>wwv_flow_api.id(2477398236614545883.442)
,p_display_sequence=>20
,p_display_value=>unistr('\30B9\30C8\30ED\30FC\30AF')
,p_return_value=>'STROKE'
,p_help_text=>unistr('\5404\884C\306E\9593\306B\6A2A\7DDA\3092\8FFD\52A0\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1892777714381781748.442)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('CSS\30AF\30E9\30B9')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\542B\3081\3089\308C\308B\8FFD\52A0\306ECSS\30AF\30E9\30B9\3092\7A7A\767D\3067\533A\5207\3063\3066\5165\529B\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1892778071495783185.442)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\30AB\30B9\30BF\30E0\5C5E\6027')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('<p>\8868\306EHTML\30BF\30B0\306B\542B\3081\308B\8FFD\52A0\306E\5C5E\6027\3092\5165\529B\3057\307E\3059\3002\30AF\30E9\30B9\306EHTML\5C5E\6027\306F\751F\6210\3055\308C\308B\305F\3081\3001\6307\5B9A\3057\307E\305B\3093\3002\304B\308F\308A\306B\5C02\7528\306E<em>\300CCSS\30AF\30E9\30B9\300D</em>\5C5E\6027\3092\4F7F\7528\3057\307E\3059\3002</p>')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(107061404414844166.442)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.442)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\3059\3079\3066\306E\5F93\696D\54E1\3092\540D\524D\9806\306B\8868\793A</dt>'),
'<dd><pre>',
'SELECT * FROM emp ORDER by ename',
'</pre></dd>',
unistr('<dt>\73FE\5728\306E\90E8\9580\306E\3059\3079\3066\306E\5F93\696D\54E1\3092\540D\524D\9806\306B\8868\793A</dt>'),
'<dd><pre>',
'SELECT * FROM emp ',
'WHERE deptno = :P3_DEPTNO ',
'ORDER by 1',
'</pre>',
unistr('<p>\30D0\30A4\30F3\30C9\5909\6570\3092\4F7F\7528\3057\3066\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3092\53C2\7167\3059\308B\3068\304D\306F\3001<strong>\300C\9001\4FE1\3059\308B\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\300D</strong>\3068\3057\3066\6307\5B9A\3057\3066\304F\3060\3055\3044\3002</p>'),
'</dd>',
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/item_type/pct_graph
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(6012795064666735813.442)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'PCT_GRAPH'
,p_display_name=>unistr('\30D1\30FC\30BB\30F3\30C8\30FB\30B0\30E9\30D5')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','PCT_GRAPH'),'')
,p_javascript_file_urls=>'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.pctGraph#MIN#.js'
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:SOURCE:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\30D1\30FC\30BB\30F3\30C6\30FC\30B8\30FB\30B0\30E9\30D5\3068\3057\3066\5024\3092\8868\793A\3057\307E\3059\3002\53D6\5F97\3055\308C\308B\5024\306F\30010\304B\3089100\307E\3067\306E\9593\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
,p_version_identifier=>'1.0'
,p_files_version=>16
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1760373882350100186.442)
,p_plugin_id=>wwv_flow_api.id(6012795064666735813.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\5024\306E\8868\793A')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\30D1\30FC\30BB\30F3\30C8\5024\3092\8868\793A\3059\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1765925486701799362.442)
,p_plugin_id=>wwv_flow_api.id(6012795064666735813.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\30D0\30C3\30AF\30B0\30E9\30A6\30F3\30C9\30FB\30AB\30E9\30FC')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30B0\30E9\30D5\306E\30D0\30C3\30AF\30B0\30E9\30A6\30F3\30C9\306B\4F7F\7528\3055\308C\308B\8272\3092\5165\529B\3057\307E\3059\3002'),
unistr('\8272\306F\300116\9032(hex)\8868\8A18\3001RGB\30AB\30E9\30FC\30FB\30B3\30FC\30C9\307E\305F\306FHTML\30AB\30E9\30FC\540D\3092\4F7F\7528\3057\3066\6307\5B9A\3055\308C\307E\3059\3002</p>'),
unistr('<p>16\9032\8868\8A18\306F#xxyyzz (#\306E\5F8C\306B3\3064\306E2\6841\306E16\9032\6570)\3067\5B9A\7FA9\3055\308C\3001xx\3001yy\304A\3088\3073zz\306F\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E2\6587\5B57\306E16\9032\306E\5024\3092\8868\3057\307E\3059\3002'),
unistr('RGB\30B3\30FC\30C9\306FRGB(xxx,xxx,xxx)\3067\5B9A\7FA9\3055\308C\3001xxx\306F0\304B\3089255\306E\9593\306E\6570\5024\3067\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E8\30D3\30C3\30C8\30FB\30D0\30A4\30C8\5024\3092\8868\3057\307E\3059\3002</p>'),
unistr('<p>\30A4\30F3\30BF\30FC\30CD\30C3\30C8\3067HTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\3092\691C\7D22\3059\308B\3068\3001\4F7F\7528\3059\308B\8272\306E16\9032\30B3\30FC\30C9\307E\305F\306FRGB\30B3\30FC\30C9\304C\308F\304B\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1765925773847803225.442)
,p_plugin_id=>wwv_flow_api.id(6012795064666735813.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\524D\666F\8272')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30B0\30E9\30D5\306E\524D\666F\306B\4F7F\7528\3055\308C\308B\8272\3092\5165\529B\3057\307E\3059\3002'),
unistr('\8272\306F\300116\9032(hex)\8868\8A18\3001RGB\30AB\30E9\30FC\30FB\30B3\30FC\30C9\307E\305F\306FHTML\30AB\30E9\30FC\540D\3092\4F7F\7528\3057\3066\6307\5B9A\3055\308C\307E\3059\3002</p>'),
unistr('<p>16\9032\8868\8A18\306F#xxyyzz (#\306E\5F8C\306B3\3064\306E2\6841\306E16\9032\6570)\3067\5B9A\7FA9\3055\308C\3001xx\3001yy\304A\3088\3073zz\306F\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E2\6587\5B57\306E16\9032\306E\5024\3092\8868\3057\307E\3059\3002'),
unistr('RGB\30B3\30FC\30C9\306FRGB(xxx,xxx,xxx)\3067\5B9A\7FA9\3055\308C\3001xxx\306F0\304B\3089255\306E\9593\306E\6570\5024\3067\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E8\30D3\30C3\30C8\30FB\30D0\30A4\30C8\5024\3092\8868\3057\307E\3059\3002</p>'),
unistr('<p>\30A4\30F3\30BF\30FC\30CD\30C3\30C8\3067HTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\3092\691C\7D22\3059\308B\3068\3001\4F7F\7528\3059\308B\8272\306E16\9032\30B3\30FC\30C9\307E\305F\306FRGB\30B3\30FC\30C9\304C\308F\304B\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1760374133781106494.442)
,p_plugin_id=>wwv_flow_api.id(6012795064666735813.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\30C6\30AD\30B9\30C8\30FB\30AB\30E9\30FC')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1760373882350100186.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30B0\30E9\30D5\306E\30C6\30AD\30B9\30C8\306B\4F7F\7528\3055\308C\308B\8272\3092\5165\529B\3057\307E\3059\3002'),
unistr('\8272\306F\300116\9032(hex)\8868\8A18\3001RGB\30AB\30E9\30FC\30FB\30B3\30FC\30C9\307E\305F\306FHTML\30AB\30E9\30FC\540D\3092\4F7F\7528\3057\3066\6307\5B9A\3055\308C\307E\3059\3002</p>'),
unistr('<p>16\9032\8868\8A18\306F#xxyyzz (#\306E\5F8C\306B3\3064\306E2\6841\306E16\9032\6570)\3067\5B9A\7FA9\3055\308C\3001xx\3001yy\304A\3088\3073zz\306F\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E2\6587\5B57\306E16\9032\306E\5024\3092\8868\3057\307E\3059\3002'),
unistr('RGB\30B3\30FC\30C9\306FRGB(xxx,xxx,xxx)\3067\5B9A\7FA9\3055\308C\3001xxx\306F0\304B\3089255\306E\9593\306E\6570\5024\3067\3001\305D\308C\305E\308C\8D64\3001\7DD1\3001\9752\306E8\30D3\30C3\30C8\30FB\30D0\30A4\30C8\5024\3092\8868\3057\307E\3059\3002</p>'),
unistr('<p>\30A4\30F3\30BF\30FC\30CD\30C3\30C8\3067HTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\3092\691C\7D22\3059\308B\3068\3001\4F7F\7528\3059\308B\8272\306E16\9032\30B3\30FC\30C9\307E\305F\306FRGB\30B3\30FC\30C9\304C\308F\304B\308A\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1765926334751816120.442)
,p_plugin_id=>wwv_flow_api.id(6012795064666735813.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\68D2\306E\5E45')
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>3
,p_unit=>unistr('\30D4\30AF\30BB\30EB')
,p_is_translatable=>false
,p_help_text=>unistr('\3053\306E\68D2\30B0\30E9\30D5\306E\5E45\3092\30D4\30AF\30BB\30EB\5358\4F4D\3067\5165\529B\3057\307E\3059\3002')
);
end;
/
prompt --application/shared_components/plugins/item_type/markdown_editor
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(8511644498934019458.442)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'MARKDOWN_EDITOR'
,p_display_name=>unistr('Markdown\30A8\30C7\30A3\30BF')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','MARKDOWN_EDITOR'),'')
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:PLACEHOLDER:ENCRYPT:FILTER:INIT_JAVASCRIPT_CODE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\30C6\30AD\30B9\30C8\66F8\5F0F\8A2D\5B9A\30AA\30D7\30B7\30E7\30F3\3001\7D44\8FBC\307F\30A4\30E1\30FC\30B8\306E\30B5\30DD\30FC\30C8\3001\304A\3088\3073\66F8\5F0F\8A2D\5B9A\6E08\30C6\30AD\30B9\30C8\3092\8868\793A\3059\308B\30D7\30EC\30D3\30E5\30FC\30FB\30AA\30D7\30B7\30E7\30F3\4ED8\304D\3067\3001Markdown\5165\529B\3092\30B5\30DD\30FC\30C8\3059\308B\30C6\30AD\30B9\30C8\9818\57DF\3092\8868\793A\3057\307E\3059\3002Markdown\30A8\30C7\30A3\30BF\3067\306F\3001\8AAD\53D6\308A\3068\66F8\8FBC\307F\304C\5BB9\6613\306A\30D7\30EC\30FC\30F3\30FB\30C6\30AD\30B9\30C8\3092\4F7F\7528\3057\3066\8A18\8FF0\3092\884C\3044\3001\4ED8\5C5E\3059\308B\69D8\3005\306A\30AA\30D7\30B7\30E7\30F3\3084\30B5\30DD\30FC\30C8\3055\308C\308B\69CB\6587\3092\4F7F\7528\3057\3066\305D\306E\30C6\30AD\30B9\30C8\3092\69CB\9020\7684\306B\6709\52B9\306AHTML\306B\5909\63DB\3067\304D\307E\3059\3002')
,p_version_identifier=>'1.0.0'
,p_files_version=>408
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(34405931740234149.442)
,p_plugin_id=>wwv_flow_api.id(8511644498934019458.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\30C4\30FC\30EB\30D0\30FC')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'SIMPLE'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Markdown\30A8\30C7\30A3\30BF\306E\30C4\30FC\30EB\30D0\30FC\3092\69CB\6210\3059\308B\305F\3081\306E\3044\304F\3064\304B\306E\30AA\30D7\30B7\30E7\30F3\3092\63D0\4F9B\3057\307E\3059')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(34408106298242570.442)
,p_plugin_attribute_id=>wwv_flow_api.id(34405931740234149.442)
,p_display_sequence=>10
,p_display_value=>unistr('\30B7\30F3\30D7\30EB')
,p_return_value=>'SIMPLE'
,p_help_text=>unistr('\30C4\30FC\30EB\30D0\30FC\306B\57FA\672C\306E\66F8\5F0F\8A2D\5B9A\30B3\30F3\30C8\30ED\30FC\30EB\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(34408560093252260.442)
,p_plugin_attribute_id=>wwv_flow_api.id(34405931740234149.442)
,p_display_sequence=>20
,p_display_value=>unistr('\5B8C\5168')
,p_return_value=>'FULL'
,p_help_text=>unistr('\30C4\30FC\30EB\30D0\30FC\306B\66F8\5F0F\8A2D\5B9A\30B3\30F3\30C8\30ED\30FC\30EB\306E\5B8C\5168\30BB\30C3\30C8\3092\8868\793A\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(34408916632257999.442)
,p_plugin_attribute_id=>wwv_flow_api.id(34405931740234149.442)
,p_display_sequence=>40
,p_display_value=>unistr('\306A\3057')
,p_return_value=>'NONE'
,p_help_text=>unistr('\30C4\30FC\30EB\30D0\30FC\3092\975E\8868\793A\306B\3057\307E\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(590983936587988716.442)
,p_plugin_id=>wwv_flow_api.id(8511644498934019458.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\69CB\6587\306E\5F37\8ABF\8868\793A')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\592A\5B57\3001\30A4\30BF\30EA\30C3\30AF\3001\30B3\30FC\30C9\30FB\30D6\30ED\30C3\30AF\306A\3069\306E\7279\5B9A\306E\30DE\30FC\30AF\30C0\30A6\30F3\8981\7D20\306B\69CB\6587\306E\5F37\8ABF\8868\793A\3092\9069\7528\3059\308B\304B\3069\3046\304B\3002</p>'),
unistr('<p>\5F37\8ABF\8868\793A\306F\3001\9577\3055\304C4000\6587\5B57\672A\6E80\306E\30B3\30F3\30C6\30F3\30C4\3067\306E\307F\884C\308F\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(55495142284465026.442)
,p_plugin_id=>wwv_flow_api.id(8511644498934019458.442)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>function( options ) {',
'    options.toolbar.widgetOptions.actions.push( {',
'        name: ''custom'',',
'        action: function(){',
'            alert( ''custom'' );',
'        }',
'    } );',
'    options.toolbar.widgetOptions.data.push( {',
'        groupTogether: true,',
'        controls: [',
'            {',
'                type: ''BUTTON'',',
'                label: ''Custom Button'',',
'                iconOnly: true,',
'                icon: ''fa fa-file-o'',',
'                action: ''custom''',
'            }',
'        ]',
'    } );',
'',
'    return options;',
'}</pre>'))
,p_help_text=>unistr('<p>Markdown\30A8\30C7\30A3\30BF\306E\69CB\6210\30AA\30D6\30B8\30A7\30AF\30C8\3092\53D6\5F97\3057\3001\30AA\30D6\30B8\30A7\30AF\30C8\3092\5909\66F4\3057\3066\305D\308C\3092\8FD4\3059JavaScript\95A2\6570\3092\5165\529B\3057\307E\3059\3002\3053\308C\306B\3088\308A\3001Markdown\30A8\30C7\30A3\30BF\306E\5916\89B3\3001\6A5F\80FD\304A\3088\3073\52D5\4F5C(\30C4\30FC\30EB\30D0\30FC\3001\30E1\30CB\30E5\30FC\304A\3088\3073\30A2\30AF\30B7\30E7\30F3\3092\542B\3080)\306E\8A73\7D30\306A\30AB\30B9\30BF\30DE\30A4\30BA\304C\53EF\80FD\306B\306A\308A\307E\3059\3002<p>')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(9126110225642555867.442)
,p_plugin_id=>wwv_flow_api.id(8511644498934019458.442)
,p_name=>'markdownified'
,p_display_name=>unistr('markdownify\9069\7528')
);
end;
/
prompt --application/shared_components/plugins/item_type/yes_no
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(16382027049111291021.442)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'YES_NO'
,p_display_name=>unistr('\5207\66FF\3048')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','YES_NO'),'')
,p_api_version=>2
,p_render_function=>'D'
,p_validation_function=>'validate_yes_no'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\30D5\30EA\30C3\30D7\30FB\30C8\30B0\30EB\30FB\30B9\30A4\30C3\30C1\3068\3057\3066\8868\793A\3057\307E\3059\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(14841509770799749.442)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.442)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\30AA\30F3\5024')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'Y'
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C<strong>\300C\30AA\30F3\300D</strong>\30AA\30D7\30B7\30E7\30F3\3092\9078\629E\3057\305F\5834\5408\306B\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306B\683C\7D0D\3055\308C\308B\5024\3092\5165\529B\3057\307E\3059\3002\5024\306F\6700\5927255\6587\5B57\3067\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(14842132411815696.442)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.442)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\30AA\30F3\30FB\30E9\30D9\30EB')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>40
,p_is_translatable=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<strong>\300C\30AA\30F3\300D</strong>\30AA\30D7\30B7\30E7\30F3\306B\8868\793A\3055\308C\308B\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002\30C6\30AD\30B9\30C8\3092\5165\529B\3057\306A\3044\5834\5408\306F\3001\30B7\30B9\30C6\30E0\306E\30C7\30D5\30A9\30EB\30C8\30FB\30E9\30D9\30EB\304C\4F7F\7528\3055\308C\307E\3059\3002'),
unistr('<p>\30CE\30FC\30C8: \30B3\30F3\30DD\30FC\30CD\30F3\30C8\8A2D\5B9A\306E\300C\8868\793A\30B9\30BF\30A4\30EB\300D\304C<strong>\300C\5207\66FF\3048\300D</strong>\306E\5834\5408\3001\3053\306E\5C5E\6027\306F\3001\5BFE\8A71\30B0\30EA\30C3\30C9\5217\306E\8868\793A\5024\3068\3057\3066\306E\307F\4F7F\7528\3055\308C\307E\3059\3002\901A\5E38\306E\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3067\306F\8868\793A\3055\308C\307E\305B\3093\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(14842724970851430.442)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.442)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\30AA\30D5\5024')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'N'
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30E6\30FC\30B6\30FC\304C<strong>\300C\30AA\30D5\300D</strong>\30AA\30D7\30B7\30E7\30F3\3092\9078\629E\3057\305F\5834\5408\306B\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306B\683C\7D0D\3055\308C\308B\5024\3092\5165\529B\3057\307E\3059\3002\5024\306F\6700\5927255\6587\5B57\3067\3059\3002</p>'),
unistr('<p><em>\30CE\30FC\30C8: \3053\306E\5024\306F\3001\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306B\79FB\5165\3055\308C\308B\5024\304C<strong>\300C\30AA\30F3\5024\300D</strong>\3068<strong>\300C\30AA\30D5\5024\300D</strong>\306E\3044\305A\308C\306B\3082\4E00\81F4\3057\306A\3044\5834\5408\306B\4F7F\7528\3055\308C\307E\3059\3002</em></p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(14843532719863116.442)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.442)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\30AA\30D5\30FB\30E9\30D9\30EB')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>40
,p_is_translatable=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<strong>\300C\30AA\30D5\300D</strong>\30AA\30D7\30B7\30E7\30F3\306B\8868\793A\3055\308C\308B\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002\30C6\30AD\30B9\30C8\3092\5165\529B\3057\306A\3044\5834\5408\306F\3001\30B7\30B9\30C6\30E0\306E\30C7\30D5\30A9\30EB\30C8\30FB\30E9\30D9\30EB\304C\4F7F\7528\3055\308C\307E\3059\3002'),
unistr('<p>\30CE\30FC\30C8: \30B3\30F3\30DD\30FC\30CD\30F3\30C8\8A2D\5B9A\306E\300C\8868\793A\30B9\30BF\30A4\30EB\300D\304C<strong>\300C\5207\66FF\3048\300D</strong>\306E\5834\5408\3001\3053\306E\5C5E\6027\306F\3001\5BFE\8A71\30B0\30EA\30C3\30C9\5217\306E\8868\793A\5024\3068\3057\3066\306E\307F\4F7F\7528\3055\308C\307E\3059\3002\901A\5E38\306E\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3067\306F\8868\793A\3055\308C\307E\305B\3093\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2089613064757884864.442)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.442)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>5
,p_display_sequence=>1
,p_prompt=>unistr('\8868\793A\30B9\30BF\30A4\30EB')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'SWITCH_CB'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(306600152922320417.442)
,p_plugin_attribute_id=>wwv_flow_api.id(2089613064757884864.442)
,p_display_sequence=>5
,p_display_value=>unistr('\5207\66FF\3048')
,p_return_value=>'SWITCH_CB'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2089613549171886868.442)
,p_plugin_attribute_id=>wwv_flow_api.id(2089613064757884864.442)
,p_display_sequence=>10
,p_display_value=>unistr('\30D4\30EB\30FB\30DC\30BF\30F3')
,p_return_value=>'SWITCH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2089613999173888214.442)
,p_plugin_attribute_id=>wwv_flow_api.id(2089613064757884864.442)
,p_display_sequence=>20
,p_display_value=>unistr('\9078\629E\30EA\30B9\30C8')
,p_return_value=>'SELECT_LIST'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(10610711090664543.442)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\30C7\30D5\30A9\30EB\30C8\306E\4F7F\7528')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\300C\5171\6709\30B3\30F3\30DD\30FC\30CD\30F3\30C8\300D>\300C\30B3\30F3\30DD\30FC\30CD\30F3\30C8\8A2D\5B9A\300D\3067\3001\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306B\5BFE\3057\3066\5B9A\7FA9\3055\308C\3066\3044\308B\30C7\30D5\30A9\30EB\30C8\307E\305F\306F\30AB\30B9\30BF\30E0\8A2D\5B9A\306E\3044\305A\308C\3092\4F7F\7528\3059\308B\304B\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(16382071946350365830.442)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\30AA\30F3\5024')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(10610711090664543.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>unistr('\30E6\30FC\30B6\30FC\304C<strong>\300C\30AA\30F3\300D</strong>\30AA\30D7\30B7\30E7\30F3\3092\9078\629E\3057\305F\5834\5408\306B\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306B\683C\7D0D\3055\308C\308B\5024\3092\5165\529B\3057\307E\3059\3002\5024\306F\6700\5927255\6587\5B57\3067\3059\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(16382622645104567710.442)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\30AA\30F3\30FB\30E9\30D9\30EB')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>40
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(10610711090664543.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<strong>\300C\30AA\30F3\300D</strong>\30AA\30D7\30B7\30E7\30F3\306B\8868\793A\3055\308C\308B\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002'),
unistr('<p>\30CE\30FC\30C8: \30B3\30F3\30DD\30FC\30CD\30F3\30C8\8A2D\5B9A\306E\300C\8868\793A\30B9\30BF\30A4\30EB\300D\304C<strong>\300C\5207\66FF\3048\300D</strong>\306E\5834\5408\3001\3053\306E\5C5E\6027\306F\3001\5F71\97FF\3092\53CA\307C\3057\307E\305B\3093\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(16382623150298569207.442)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\30AA\30D5\5024')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(10610711090664543.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30E6\30FC\30B6\30FC\304C<strong>\300C\30AA\30D5\300D</strong>\30AA\30D7\30B7\30E7\30F3\3092\9078\629E\3057\305F\5834\5408\306B\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306B\683C\7D0D\3055\308C\308B\5024\3092\5165\529B\3057\307E\3059\3002\300C\30AA\30D5\300D\30AA\30D7\30B7\30E7\30F3\304C\9078\629E\3055\308C\305F\3068\304D\306B<code>NULL</code>\3092\683C\7D0D\3059\308B\5834\5408\306F\3001\3053\306E\5C5E\6027\3092\7A7A\767D\306E\307E\307E\306B\3067\304D\307E\3059\3002\5024\306F\6700\5927255\6587\5B57\3067\3059\3002</p>'),
unistr('<p><em>\30CE\30FC\30C8: \3053\306E\5024\306F\3001\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\306B\79FB\5165\3055\308C\308B\5024\304C<strong>\300C\30AA\30F3\5024\300D</strong>\3068<strong>\300C\30AA\30D5\5024\300D</strong>\306E\3044\305A\308C\306B\3082\4E00\81F4\3057\306A\3044\5834\5408\306B\4F7F\7528\3055\308C\307E\3059\3002</em></p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(21162632375092489.442)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\30AA\30D5\30FB\30E9\30D9\30EB')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>40
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(10610711090664543.442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<strong>\300C\30AA\30D5\300D</strong>\30AA\30D7\30B7\30E7\30F3\306B\8868\793A\3055\308C\308B\30C6\30AD\30B9\30C8\3092\5165\529B\3057\307E\3059\3002'),
unistr('<p>\30CE\30FC\30C8: \30B3\30F3\30DD\30FC\30CD\30F3\30C8\8A2D\5B9A\306E\300C\8868\793A\30B9\30BF\30A4\30EB\300D\304C<strong>\300C\5207\66FF\3048\300D</strong>\306E\5834\5408\3001\3053\306E\5C5E\6027\306F\3001\5F71\97FF\3092\53CA\307C\3057\307E\305B\3093\3002</p>')))
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_api.create_user_interface(
 p_id=>wwv_flow_api.id(4968506573302342.442)
,p_ui_type_name=>'DESKTOP'
,p_display_name=>unistr('\30C7\30B9\30AF\30C8\30C3\30D7')
,p_display_seq=>10
,p_use_auto_detect=>true
,p_is_default=>true
,p_theme_id=>1
,p_home_url=>'f?p=4411:1:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_nav_list_template_options=>'#DEFAULT#'
,p_include_legacy_javascript=>'PRE18:18'
,p_nav_bar_type=>'NAVBAR'
,p_nav_bar_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_api.create_page(
 p_id=>1.442
,p_user_interface_id=>wwv_flow_api.id(4968506573302342.442)
,p_name=>unistr('\30E1\30C3\30BB\30FC\30B8')
,p_step_title=>unistr('\30E1\30C3\30BB\30FC\30B8')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_api.id(91626406749381989.442)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/end_environment
begin
wwv_flow_api.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false));
commit;
end;
/
set verify on feedback on define on
prompt  ...done
