prompt --application/set_environment
set define off verify off feedback off
--------------------------------------------------------------------------------
--
-- ORACLE Application Express (APEX) export file
--
-- You should run the script connected to SQL*Plus as the Oracle user
-- APEX_210200 or as the owner (parsing schema) of the application.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_api.import_begin (
 p_version_yyyy_mm_dd=>'2021.10.15'
,p_release=>'21.2.0-19'
,p_default_workspace_id=>10
,p_default_application_id=>4479
,p_default_id_offset=>109671377647632083
,p_default_owner=>'APEX_210200'
);
end;
/
 
prompt APPLICATION 4479 - Oracle APEX Runtime Messages
--
-- Application Export:
--   Application:     4479
--   Name:            Oracle APEX Runtime Messages
--   Exported By:     APEX_210200
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                      1
--     Shared Components:
--       Logic:
--       Navigation:
--         Breadcrumbs:            1
--       Security:
--         Authentication:         1
--       User Interface:
--         Templates:
--           Page:                 7
--           Region:              11
--           Label:                7
--           List:                 6
--           Popup LOV:            1
--           Calendar:             1
--           Breadcrumb:           1
--           Button:               6
--           Report:               8
--       Globalization:
--         Messages:           1,800
--       Reports:
--       E-Mail:
--     Supporting Objects:  Excluded
--   Version:         21.2.0-19
--   Instance ID:     697872254810262
--

prompt --application/delete_application
begin
wwv_flow_api.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_flow_api.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'APEX_210200')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Oracle APEX Runtime Messages')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'A116102568784403655')
,p_page_view_logging=>'YES'
,p_charset=>'utf-8'
,p_page_protection_enabled_y_n=>'Y'
,p_checksum_salt_last_reset=>'20211020113125'
,p_bookmark_checksum_function=>'SH1'
,p_compatibility_mode=>'5.0'
,p_flow_language=>'ja'
,p_flow_language_derived_from=>'SESSION'
,p_date_format=>'&DATE_FORMAT.'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_authentication=>'PLUGIN'
,p_authentication_id=>wwv_flow_api.id(109678305570583962.4479)
,p_populate_roles=>'A'
,p_application_tab_set=>0
,p_logo_type=>'C'
,p_logo=>'<img src="#IMAGE_PREFIX#apex_ui/apexlogo.png" width="282" height="20" alt="&PRODUCT_NAME." />'
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'&PRODUCT_NAME. 21.2.0-19'
,p_flow_status=>'AVAILABLE_W_EDIT_LINK'
,p_flow_unavailable_text=>'This application is currently unavailable at this time.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'D'
,p_runtime_api_usage=>'O:W'
,p_security_scheme=>wwv_flow_api.id(860535012146524358)
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'Y'
,p_auto_time_zone=>'N'
,p_friendly_url=>'N'
,p_last_updated_by=>'APEX_210200'
,p_last_upd_yyyymmddhh24miss=>'20211020113351'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_ui_type_name => null
,p_print_server_type=>'INSTANCE'
,p_is_pwa=>'N'
);
end;
/
prompt --application/plugin_settings
begin
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(110599941590099161.4479)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(111465476128037500.4479)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_CSS_CALENDAR'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(201677315619204524.4479)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_RICH_TEXT_EDITOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(209516503264520988.4479)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(285800719532138903.4479)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(649595203182764436.4479)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(701907820392341530.4479)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1874744429444344138.4479)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1941451863897626238.4479)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2027366558906572283.4479)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2120597162971751123.4479)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_COM.ORACLE.FLOTLINECHART2'
,p_attribute_01=>'3'
,p_attribute_02=>'1.333'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
null;
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
null;
end;
/
prompt --application/pages/page_groups
begin
null;
end;
/
prompt --application/shared_components/navigation/breadcrumbs/breadcrumb
begin
wwv_flow_api.create_menu(
 p_id=>wwv_flow_api.id(649613204592764515.4479)
,p_name=>' Breadcrumb'
);
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(850359229090693491.4479)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Dialog.ja'
,p_internal_name=>'APEX_5.0_WIZARD_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.builder.initWizardModal();',
'apex.builder.initWizardProgressBar();'))
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="utf-8">  ',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'<meta name="viewport" content="width=device-width,initial-scale=1" />',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog a-Dialog--wizard">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--wizard'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689061037088924910.4479
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161778160347686.4479)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4479)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161835522347686.4479)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4479)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161954309347685.4479)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4479)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037359784626333.4479)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Dialog.ja'
,p_internal_name=>'APEX_5.0_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>'apex.builder.initWizardModal();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog" role="dialog" aria-label="#TITLE#">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--uiDialog'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>120828417372192930.4479
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162085053347685.4479)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4479)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162150671347685.4479)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4479)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162280992347685.4479)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4479)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_edit_screen
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037631091626378.4479)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Edit Screen.ja'
,p_internal_name=>'APEX_5.0_EDIT_SCREEN'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initStickyHeader(''a_EditScreen_header'');'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'      #REGION_POSITION_02#',
'      <div class="a-EditScreen">',
'        <div class="a-EditScreen-header" id="a_EditScreen_header">',
'          #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'          #REGION_POSITION_04#',
'        </div>',
'        <div class="a-EditScreen-body">',
'          #BODY#',
'        </div>',
'      </div>',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'        #REGION_POSITION_05#',
'    </aside>',
'  </div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689595297061847770.4479
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162482551347683.4479)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4479)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162565984347683.4479)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4479)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162631318347683.4479)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4479)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162776979347683.4479)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4479)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162894857347683.4479)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4479)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162922323347683.4479)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4479)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055105627189852.4479)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4479)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055592800189852.4479)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4479)
,p_name=>'Edit Screen Header'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_no_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851039898661626389.4479)
,p_theme_id=>3
,p_name=>'APEX 5.0 - No Side Bar.ja'
,p_internal_name=>'APEX_5.0_NO_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #BODY#',
'    </main>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#MESSAGE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>637437892049443496.4479
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163030050347682.4479)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4479)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163116466347682.4479)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4479)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163291443347682.4479)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4479)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163395758347682.4479)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4479)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163408834347682.4479)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4479)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163558979347682.4479)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4479)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163680191347681.4479)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4479)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_right_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851040471818626394.4479)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Right Side Bar.ja'
,p_internal_name=>'APEX_5.0_RIGHT_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#REGION_POSITION_02#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        #BODY#',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'    </aside>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>386895861966224222.4479
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269059575338189855.4479)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4479)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060070650189855.4479)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4479)
,p_name=>'Page Header (Position 3)'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060559989189856.4479)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4479)
,p_name=>'Page Header (Position 4)'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061028359189856.4479)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4479)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061478998189856.4479)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4479)
,p_name=>'After Body'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062069508189856.4479)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4479)
,p_name=>'Page Header (Position 1)'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062521535189857.4479)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4479)
,p_name=>'Page Header (Position 2)'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_sign_up_wizard
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851041812938626395.4479)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Sign Up Wizard.ja'
,p_internal_name=>'APEX_5.0_SIGN_UP_WIZARD'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--simpleWizard" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'<div class="u-Layout u-Layout--centerVertically">',
'  #BODY#',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702692008314080052.4479
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163743791347677.4479)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4479)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163890712347677.4479)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4479)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163982775347677.4479)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4479)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164006858347677.4479)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4479)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164176675347677.4479)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4479)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164264131347677.4479)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4479)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164343110347677.4479)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4479)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_page
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851042476105626395.4479)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Page.ja'
,p_internal_name=>'APEX_5.0_WIZARD_PAGE'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--wizard #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'<div class="u-Layout u-Layout--centerVertically">',
'  <div class="a-Wizard a-Wizard--default">',
'    #REGION_POSITION_02#',
'    <div class="a-Wizard-controls">#REGION_POSITION_01#</div>',
'    <div class="a-Wizard-body">#BODY#</div>',
'    <div class="a-Wizard-buttons">#REGION_POSITION_03#</div>',
'  </div>',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'BODY_3'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'      </div>',
'      <div class="a-Alert-body">',
'        <h2 class="a-Alert-subTitle">#MESSAGE#</h2>',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702684260095026477.4479
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165035853347674.4479)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4479)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165105515347674.4479)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4479)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165240488347674.4479)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4479)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165340836347674.4479)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4479)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165473370347674.4479)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4479)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165515674347674.4479)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4479)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165694196347674.4479)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4479)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514381861202541059.4479)
,p_template_name=>'APEX 5.0 - Button'
,p_internal_name=>'APEX_5.0_BUTTON'
,p_template=>'<button onclick="#JAVASCRIPT#" class="a-Button #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button onclick="#JAVASCRIPT#" class="a-Button a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174750904387485475.4479
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_menu_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382190540541061.4479)
,p_template_name=>'APEX 5.0 - Icon Menu Button'
,p_internal_name=>'APEX_5.0_ICON_MENU_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_'
||'CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class='
||'"a-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon  icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_reference_id=>3705338883615.4479
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_only_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382538845541061.4479)
,p_template_name=>'APEX 5.0 - Icon Only Button'
,p_internal_name=>'APEX_5.0_ICON_ONLY_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#" aria-h'
||'idden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CL'
||'ASSES#" aria-hidden="true"></span></button>'
,p_reference_id=>353820721334283301.4479
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_large
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629666890811728.4479)
,p_template_name=>'APEX 5.0 - Button (Large)'
,p_internal_name=>'APEX_5.0_BUTTON_LARGE'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large a-Button--hot #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174756119980565636.4479
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_small
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629778318811745.4479)
,p_template_name=>'APEX 5.0 - Button (Small)'
,p_internal_name=>'APEX_5.0_BUTTON_SMALL'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174755910284562884.4479
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_with_icon
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(868252865986181054.4479)
,p_template_name=>'APEX 5.0 - Button with Icon'
,p_internal_name=>'APEX_5.0_BUTTON_WITH_ICON'
,p_template=>'<button class="a-Button a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_reference_id=>404889142313786233.4479
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514338947870435171.4479)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  <div class="a-Region-bodyHeader">#REGION_HEADER#</div>',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region'
,p_internal_name=>'APEX_5.0_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174748721787471587.4479
,p_translate_this_template=>'N'
,p_template_comment=>'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI a-Button--goToTop" onclick="uF();" type="button" title="&TOP."><span class="a-Icon icon-up-chevron"></span></button>'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143405975518340709.4479)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4479)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406085485340709.4479)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4479)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406168378340709.4479)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4479)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406270366340709.4479)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4479)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406371972340709.4479)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4479)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406493020340708.4479)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4479)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406554385340708.4479)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4479)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406692306340708.4479)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4479)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406747305340708.4479)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4479)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406811703340708.4479)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4479)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406940024340708.4479)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4479)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407082581340708.4479)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4479)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407110986340708.4479)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4479)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_div_with_id_class_and_region_attributes
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514343873675436760.4479)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="#REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Div with ID, Class, and Region Attributes'
,p_internal_name=>'APEX_5.0_DIV_WITH_ID,_CLASS,_AND_REGION_ATTRIBUTES'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>716895227337398760.4479
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407202750340708.4479)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4479)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407359309340707.4479)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4479)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407475956340707.4479)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4479)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407586842340707.4479)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4479)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_body_hide_show
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(771803843049318447.4479)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion aWizardRegion--disclosure" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="wizardRegionHeading">',
'    <h2>',
'        <button type="button">#TITLE#</button>',
'    </h2>',
'    <div class="buttonContainer">',
'    #EDIT##CLOSE##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT##CREATE##CREATE2#',
'    </div>',
'  </div>',
'  <div class="hideShowRegion" id="#REGION_STATIC_ID#_content">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Body (Hide/Show)'
,p_internal_name=>'APEX_5.0_WIZARD_BODY_HIDE/SHOW'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$( "##REGION_STATIC_ID#" ).collapsible({',
'    content: $( "##REGION_STATIC_ID#_content" )',
'});'))
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>399850559367741099.4479
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407695677340707.4479)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4479)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407764991340707.4479)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4479)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407888229340707.4479)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4479)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407939357340707.4479)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4479)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408003435340707.4479)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4479)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408143312340707.4479)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4479)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408206123340706.4479)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4479)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408351234340706.4479)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4479)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408443044340706.4479)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4479)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408520126340706.4479)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4479)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408600823340706.4479)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4479)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408783461340706.4479)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4479)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_button_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850406444708718383.4479)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ButtonRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-ButtonRegion-wrap">',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--left"><div class="a-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--content">',
'      <h2 class="a-ButtonRegion-title">#TITLE#</h2>',
'      #BODY#',
'      <div class="a-ButtonRegion-buttons">#CHANGE#</div>',
'    </div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--right"><div class="a-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Button Region'
,p_internal_name=>'APEX_5.0_BUTTON_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-ButtonRegion--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>687153470345619376.4479
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408840730340706.4479)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4479)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408984947340706.4479)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4479)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409077112340706.4479)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4479)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409105003340706.4479)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4479)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409262902340705.4479)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4479)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409316978340705.4479)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4479)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409413495340705.4479)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4479)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409513204340705.4479)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4479)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409624820340705.4479)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4479)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850442966147812557.4479)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Wizard-region a-Form #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <h2 class="u-VisuallyHidden">#TITLE#</h2>',
'  <div class="a-Wizard-regionHeader">#REGION_HEADER#</div>',
'  <div class="a-Wizard-regionBody">#BODY#</div>',
'  <div class="a-Wizard-regionFooter">#REGION_FOOTER#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Region'
,p_internal_name=>'APEX_5.0_WIZARD_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>702777601713950915.4479
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409767168340705.4479)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4479)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409825123340705.4479)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4479)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_alert
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(856206049762521193.4479)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#TITLE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #BODY#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      #PREVIOUS##CLOSE##CREATE##NEXT#',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Alert'
,p_internal_name=>'APEX_5.0_ALERT'
,p_theme_id=>3
,p_theme_class_id=>7
,p_default_template_options=>'a-Alert--defaultIcons'
,p_preset_template_options=>'a-Alert--warning:a-Alert--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>746362351042209764.4479
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409979473340705.4479)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4479)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410082302340705.4479)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4479)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410172873340704.4479)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4479)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410278786340704.4479)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4479)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410369941340704.4479)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4479)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410473248340704.4479)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4479)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_header
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914802799655239969.4479)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wizardHeader" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Header'
,p_internal_name=>'APEX_5.0_WIZARD_HEADER'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42210710875242480.4479
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410569446340704.4479)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4479)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410685133340704.4479)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4479)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_title_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914803495164240003.4479)
,p_layout=>'TABLE'
,p_template=>'<div class="#REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#><h1 class="a-Wizard-title">#TITLE#</h1></div>'
,p_page_plug_template_name=>'APEX 5.0 - Wizard Title Region'
,p_internal_name=>'APEX_5.0_WIZARD_TITLE_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>703469000349150769.4479
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418798026340694.4479)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4479)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418882854340694.4479)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4479)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_interactive_report_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915210356236972585.4479)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="a-IRR-region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#><h2 class="u-VisuallyHidden">#TITLE#</h2>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Interactive Report Region'
,p_internal_name=>'APEX_5.0_INTERACTIVE_REPORT_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-IRR-region--responsiveIconView'
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>678354360586321695.4479
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418912636340694.4479)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4479)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419028911340693.4479)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4479)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419193341340693.4479)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4479)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419232024340693.4479)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4479)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_hide_show_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915371118115573423.4479)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--hideShow #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--controls">',
'        <h2 class="a-Region-title">',
'            <button class="a-Region-toggle" type="button">#TITLE#</button>',
'        </h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Hide + Show Region'
,p_internal_name=>'APEX_5.0_HIDE_+_SHOW_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-Region--flush'
,p_preset_template_options=>'is-expanded'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>689955986849128825.4479
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419351130340693.4479)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4479)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419433470340693.4479)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4479)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419510757340693.4479)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4479)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419662625340693.4479)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4479)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419708090340693.4479)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4479)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419872972340693.4479)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4479)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419977851340692.4479)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4479)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420075889340692.4479)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4479)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420134349340692.4479)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4479)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420241403340692.4479)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4479)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420369250340692.4479)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4479)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420425928340692.4479)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4479)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420576629340692.4479)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4479)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_processing_spinner_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(1274355059486017828.4479)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ProcessingRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <span class="u-Processing"><span class="u-Processing-spinner"></span></span>',
'  <div class="a-ProcessingRegion-title">#TITLE#</div>',
'  <div class="a-ProcessingRegion-body">#BODY#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Processing Spinner Region'
,p_internal_name=>'APEX_5.0_PROCESSING_SPINNER_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>1147280303078953726.4479
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420676303340692.4479)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4479)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420779344340692.4479)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4479)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_navigation_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332014414430986.4479)
,p_list_template_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Navigation List'
,p_internal_name=>'APEX_5.0_NAVIGATION_LIST'
,p_theme_id=>3
,p_theme_class_id=>7
,p_list_template_before_rows=>'<ul>'
,p_list_template_after_rows=>'</ul>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_reference_id=>573607518145151423.4479
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_menu_popup
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332292784430987.4479)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Menu Popup'
,p_internal_name=>'APEX_5.0_MENU_POPUP'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("##PARENT_STATIC_ID#_menu", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  apex.actions.addFromMarkup(e);',
'}',
'e.menu({ slide: e.hasClass("js-slide")});',
''))
,p_theme_id=>3
,p_theme_class_id=>20
,p_list_template_before_rows=>'<div id="#PARENT_STATIC_ID#_menu" class="#COMPONENT_CSS_CLASSES#" style="display:none;"><ul>'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_reference_id=>747588010155545129.4479
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_image_navigation
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(860563697365629462.4479)
,p_list_template_current=>'<li class="a-ImageNav-item"><button type="button" data-link="#LINK#" class="a-ImageNav-link launch-aut #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></button></li>'
,p_list_template_noncurrent=>'<li class="a-ImageNav-item"><a href="#LINK#" class="a-ImageNav-link #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></a></li>'
,p_list_template_name=>'APEX 5.0 - Image Navigation'
,p_internal_name=>'APEX_5.0_IMAGE_NAVIGATION'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="a-ImageNav #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>481290423891543508.4479
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_wizard_progress
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(865273508717512144.4479)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-active" aria-current="step">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-inactive">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Wizard Progress'
,p_internal_name=>'APEX_5.0_WIZARD_PROGRESS'
,p_theme_id=>3
,p_theme_class_id=>17
,p_default_template_options=>'a-WizardSteps--slim'
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul aria-label="#CURRENT_PROGRESS#" class="a-WizardSteps #COMPONENT_CSS_CLASSES#">',
''))
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>687902065557685310.4479
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_media_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(908020362212234651.4479)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item is-active" aria-current="page">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_name=>'APEX 5.0 - Media List'
,p_internal_name=>'APEX_5.0_MEDIA_LIST'
,p_theme_id=>3
,p_theme_class_id=>9
,p_default_template_options=>'a-MediaList--noBadge'
,p_list_template_before_rows=>'<ul class="a-MediaList #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>692720897220784060.4479
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_links_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(914818080687341593.4479)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_template_options=>'a-LinksList--showArrow'
,p_list_template_before_rows=>'<ul class="a-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current is-expanded #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_reference_id=>60219508156141083.4479
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_named_column
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851049711466639395.4479)
,p_row_template_name=>'APEX 5.0 - Badge List (Named Column)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_NAMED_COLUMN'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-BadgeList-item #A01#">',
'  <span class="a-BadgeList-label">#COLUMN_HEADER#</span>',
'  <span class="a-BadgeList-value">#COLUMN_VALUE#</span>',
'</li>',
''))
,p_row_template_before_rows=>'<ul class="a-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_preset_template_options=>'a-BadgeList--fixed:a-BadgeList--large'
,p_reference_id=>488487951233692049.4479
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_row
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851054516889639461.4479)
,p_row_template_name=>'APEX 5.0 - Badge List (Row)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_ROW'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-BadgeList-item">',
'  <span class="t-BadgeList-label">#1#</span>',
'  <span class="t-BadgeList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>6
,p_reference_id=>689060248369886348.4479
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_links_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851055225644639463.4479)
,p_row_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_row_template1=>'<li class="a-LinksList-item">#COLUMN_VALUE#</li>'
,p_row_template_before_rows=>'<ul class="a-LinksList a-LinksList--report #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES#>'
,p_row_template_after_rows=>'</ul>'
,p_row_template_before_first=>'OMIT'
,p_row_template_after_last=>'OMIT'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'OMIT'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-LinksList--nowrap:a-LinksList--showArrow'
,p_reference_id=>17383712077884846.4479
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_standard_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851056531929639482.4479)
,p_row_template_name=>'APEX 5.0 - Standard Report'
,p_internal_name=>'APEX_5.0_STANDARD_REPORT'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th class="a-Report-colHead" #ALIGNMENT# id="#COLUMN_HEADER_NAME#" #COLUMN_WIDTH#>#COLUMN_HEADER#</th>'
,p_after_column_heading=>'</thead><tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4479
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_column_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792024808213039.4479)
,p_row_template_name=>'APEX 5.0 - Portlet  Column Template'
,p_internal_name=>'APEX_5.0_PORTLET_COLUMN_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#COLUMN_HEADER#</span>',
'  <span class="a-AVPList-value">#COLUMN_VALUE#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>43020300221196425.4479
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_row_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792322768213043.4479)
,p_row_template_name=>'APEX 5.0 - Portlet Row Template'
,p_internal_name=>'APEX_5.0_PORTLET_ROW_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#1#</span>',
'  <span class="a-AVPList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">',
''))
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>46763700145123930.4479
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_one_column_unordered_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(915377874236666939.4479)
,p_row_template_name=>'APEX 5.0 - One Column Unordered List'
,p_internal_name=>'APEX_5.0_ONE_COLUMN_UNORDERED_LIST'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_after_column_heading=>'<tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4479
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_app_cards_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(1041941432531249038.4479)
,p_row_template_name=>'APEX 5.0 - App Cards Report'
,p_internal_name=>'APEX_5.0_APP_CARDS_REPORT'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <div class="a-AppCards-iconContainer">',
'      <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'    </div>',
'    <div class="a-AppCards-contentContainer" id="#ID#_name">',
'      <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'      <div class="a-AppCards-info">#APP_INFO#</div>',
'    </div>',
'    <div class="a-AppCards-actionsContainer">',
'        #MODIFY_APP_BUTTON#',
'        #RUN_APP_BUTTON#',
'    </div>',
'  </div>',
'</li>'))
,p_row_template_condition1=>':CARD_LINK is null'
,p_row_template2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <a href="#CARD_LINK#" class="a-AppCards-link">',
'      <div class="a-AppCards-iconContainer">',
'        <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'      </div>',
'      <div class="a-AppCards-contentContainer" id="#ID#_name">',
'        <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'        <div class="a-AppCards-info">#APP_INFO#</div>',
'      </div>',
'    </a>',
'  </div>',
'</li>'))
,p_row_template_condition2=>':CARD_LINK is not null'
,p_row_template_before_rows=>'<ul class="a-AppCards #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>932268343459577530.4479
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_dynamic_attribute
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(850683711614406253.4479)
,p_template_name=>'APEX 5.0 - Dynamic Attribute'
,p_internal_name=>'APEX_5.0_DYNAMIC_ATTRIBUTE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-dynamicItemHelp" data-itemname="#CURRENT_ITEM_NAME#" data-appid="&FB_FLOW_ID." title="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help"></span><span cl'
||'ass="u-VisuallyHidden">#CURRENT_ITEM_HELP_LABEL#</span></button>#ERROR_TEMPLATE#</div>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>692681574974429799.4479
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047536471633848.4479)
,p_template_name=>'APEX 5.0 - Optional Label'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487444299516703815.4479
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047676005633854.4479)
,p_template_name=>'APEX 5.0 - Optional Label (Above)'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_on_error_after_label=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492676964457041934.4479
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047684809633856.4479)
,p_template_name=>'APEX 5.0 - Required Label'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487443659585685414.4479
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047795461633856.4479)
,p_template_name=>'APEX 5.0 - Required Label (Above)'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492677038682043223.4479
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/hidden_label_read_by_screen_reader
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(860542631889572088.4479)
,p_template_name=>'Hidden label, read by screen reader'
,p_internal_name=>'HIDDEN_LABEL,_READ_BY_SCREEN_READER'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999" class="hideMeButHearMe">'
,p_template_body2=>'</label>'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#'
,p_theme_id=>3
,p_theme_class_id=>13
,p_reference_id=>4903009179971452.4479
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_hidden_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(1321751941832424103.4479)
,p_template_name=>'APEX 5.0 - Hidden Label'
,p_internal_name=>'APEX_5.0_HIDDEN_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer a-Form-labelContainer--visuallyhidden">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label visuallyhidden">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>687907221148719616.4479
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/apex_5_0_breadcrumbs
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(514333590213433126.4479)
,p_name=>'APEX 5.0 - Breadcrumbs'
,p_internal_name=>'APEX_5.0_BREADCRUMBS'
,p_before_first=>'<ul class="a-Breadcrumb">'
,p_current_page_option=>'<li class="a-Breadcrumb-item a-Breadcrumb-item is-active" aria-current="page"><span class="a-Breadcrumb-label">#NAME#</span></li>'
,p_non_current_page_option=>'<li class="a-Breadcrumb-item"><a href="#LINK#" class="a-Breadcrumb-label">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>6
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>689285808648404711.4479
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_api.create_popup_lov_template(
 p_id=>wwv_flow_api.id(649611704621764507.4479)
,p_page_name=>'winlov'
,p_page_title=>unistr('\691C\7D22\30C0\30A4\30A2\30ED\30B0')
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#APEX_JAVASCRIPT#',
'<meta name="viewport" content="width=device-width,initial-scale=1.0" />',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#favicon.ico" type="image/x-icon">',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'</head>'))
,p_page_body_attr=>'onload="first_field()" class="a-Page a-Page--popupLOV"'
,p_before_field_text=>'<div class="a-PopupLOV-actions a-Form--large">'
,p_filter_width=>'15'
,p_filter_max_width=>'100'
,p_filter_text_attr=>'class="a-Form-field a-Form-searchField"'
,p_find_button_text=>unistr('\691C\7D22')
,p_find_button_attr=>'class="a-Button a-Button--hot a-Button--padLeft"'
,p_close_button_text=>unistr('\9589\3058\308B')
,p_close_button_attr=>'class="a-Button u-pullRight"'
,p_next_button_text=>unistr('\6B21 &gt;')
,p_next_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_prev_button_text=>unistr('&lt; \524D')
,p_prev_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'380'
,p_height=>'480'
,p_result_row_x_of_y=>unistr('<div class="a-PopupLOV-pagination">\884C#FIRST_ROW# - #LAST_ROW#</div>')
,p_result_rows_per_pg=>200
,p_before_result_set=>'<div class="a-PopupLOV-links">'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>17343114994581872.4479
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/default_calander
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(649611609668764506.4479)
,p_cal_template_name=>'Default Calander'
,p_internal_name=>'DEFAULT_CALANDER'
,p_day_of_week_format=>'<th scope="col" width="14%" class="htmldbDayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbCalendarHolder" cellpadding="0" cellspacing="0" border="0" width="100%" summary="" role="presentation"><tr>',
'<td class="htmldbMonthTitle">#IMONTH# #YYYY#</td>',
'</tr>',
'<tr><td>'))
,p_month_open_format=>'<table class="htmldbCalendar" cellpadding="0" cellspacing="3" border="0" width="100%" summary="#CALENDAR_TITLE# #IMONTH# #YYYY#">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td></tr></table>',
'',
''))
,p_day_title_format=>'<div class="htmldbDayTitle">#DD#</div>'
,p_day_open_format=>'<td class="htmldbDay">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td class="htmldbToday">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="htmldbWeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td class="htmldbWeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="htmldbNonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="htmldbNonDay">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr>'
,p_daily_title_format=>'<th width="14%" class="calheader">#IDAY#</th>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>353925314576528967.4479
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(182005134783173294.4479)
,p_theme_id=>3
,p_name=>'DARK'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>true
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074212329754757.4479)
,p_theme_id=>3
,p_name=>'STANDARD_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074525535755551.4479)
,p_theme_id=>3
,p_name=>'DARK_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(717250289307903026.4479)
,p_theme_id=>3
,p_name=>'STANDARD'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(806925000765340952.4479)
,p_theme_id=>3
,p_name=>'DISPLAY_ICONS'
,p_display_name=>'Display Icons'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_null_text=>'Default - No Icons'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380142596819918.4479)
,p_theme_id=>3
,p_name=>'ALTERNATING_TABLE_ROWS'
,p_display_name=>'Alternating Table Rows'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Enable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380828683819918.4479)
,p_theme_id=>3
,p_name=>'ROW_HIGHLIGHTING'
,p_display_name=>'Row Highlighting'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Disable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808381542095819918.4479)
,p_theme_id=>3
,p_name=>'REPORT_BORDER'
,p_display_name=>'Report Border'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default Border'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808383088145819924.4479)
,p_theme_id=>3
,p_name=>'REPORT_WIDTH'
,p_display_name=>'Report Width'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850406791580718389.4479)
,p_theme_id=>3
,p_name=>'REGION_TITLE'
,p_display_name=>'Region Title'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407096779718396.4479)
,p_theme_id=>3
,p_name=>'REGION_PADDING'
,p_display_name=>'Region Padding'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Padding'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407509193718398.4479)
,p_theme_id=>3
,p_name=>'REGION_STYLE'
,p_display_name=>'Region Style'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Style'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851050160062639437.4479)
,p_theme_id=>3
,p_name=>'BADGE_LAYOUT'
,p_display_name=>'Badge Layout'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851051045625639457.4479)
,p_theme_id=>3
,p_name=>'BADGE_SIZE'
,p_display_name=>'Badge Size'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856113214217058023.4479)
,p_theme_id=>3
,p_name=>'HEIGHT'
,p_display_name=>'Height'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114568019058024.4479)
,p_theme_id=>3
,p_name=>'FORM_LABEL_ALIGNMENT'
,p_display_name=>'Form Label Alignment'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Set Form Alignment for Grid Based forms'
,p_null_text=>'Right'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114830529058024.4479)
,p_theme_id=>3
,p_name=>'FORM_LABEL_WIDTH'
,p_display_name=>'Form Label Width'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856115135223058024.4479)
,p_theme_id=>3
,p_name=>'BUTTON_SET'
,p_display_name=>'Button Set'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Not Part of Button Set'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116214022058024.4479)
,p_theme_id=>3
,p_name=>'LABEL_WIDTH'
,p_display_name=>'Label Width'
,p_display_sequence=>1
,p_template_types=>'FIELD'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116523282058024.4479)
,p_theme_id=>3
,p_name=>'FORM_LABEL_POSITION'
,p_display_name=>'Form Label Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116798725058025.4479)
,p_theme_id=>3
,p_name=>'BUTTON_SIZE'
,p_display_name=>'Button Size'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Button Size'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117102944058028.4479)
,p_theme_id=>3
,p_name=>'SPACING_LEFT'
,p_display_name=>'Spacing left'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Left Spacing'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117454663058028.4479)
,p_theme_id=>3
,p_name=>'SPACING_RIGHT'
,p_display_name=>'Spacing Right'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Right Spacing'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117908453058029.4479)
,p_theme_id=>3
,p_name=>'ICON_POSITION'
,p_display_name=>'Icon Position'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Icon on Right'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856118261810058029.4479)
,p_theme_id=>3
,p_name=>'BUTTON_TYPE'
,p_display_name=>'Button Type'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206461450521195.4479)
,p_theme_id=>3
,p_name=>'ALERT_TYPE'
,p_display_name=>'Alert Type'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206736628521198.4479)
,p_theme_id=>3
,p_name=>'DISPLAY'
,p_display_name=>'Display'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860570508910721307.4479)
,p_theme_id=>3
,p_name=>'REGION_POSITION'
,p_display_name=>'Region Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860571060920721309.4479)
,p_theme_id=>3
,p_name=>'REGION_OVERFLOW'
,p_display_name=>'Region Overflow'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(908020718209234676.4479)
,p_theme_id=>3
,p_name=>'LAYOUT'
,p_display_name=>'Layout'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
end;
/
prompt --application/shared_components/user_interface/template_options
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134384175764258.4479)
,p_theme_id=>3
,p_name=>'LARGELEFT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134654971764258.4479)
,p_theme_id=>3
,p_name=>'LARGERIGHT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134823880764258.4479)
,p_theme_id=>3
,p_name=>'LEFTICON'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135009020764258.4479)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'Large'
,p_display_sequence=>3
,p_css_classes=>'a-Button--large'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135269851764258.4479)
,p_theme_id=>3
,p_name=>'SMALLLEFT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135477215764258.4479)
,p_theme_id=>3
,p_name=>'SMALLRIGHT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135634744764258.4479)
,p_theme_id=>3
,p_name=>'INNERBUTTON'
,p_display_name=>'Inner Button'
,p_display_sequence=>2
,p_css_classes=>'a-Button--pill'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135785730764258.4479)
,p_theme_id=>3
,p_name=>'LASTBUTTON'
,p_display_name=>'Last Button'
,p_display_sequence=>3
,p_css_classes=>'a-Button--pillEnd'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136068296764258.4479)
,p_theme_id=>3
,p_name=>'FIRSTBUTTON'
,p_display_name=>'First Button'
,p_display_sequence=>1
,p_css_classes=>'a-Button--pillStart'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136225140764258.4479)
,p_theme_id=>3
,p_name=>'PRIMARY'
,p_display_name=>'Primary'
,p_display_sequence=>1
,p_css_classes=>'a-Button--primary'
,p_group_id=>wwv_flow_api.id(856118261810058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136360666764258.4479)
,p_theme_id=>3
,p_name=>'REGIONHEADERBUTTON'
,p_display_name=>'Button in Region Header'
,p_display_sequence=>1
,p_css_classes=>'a-Button--regionHeader'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136507481764259.4479)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--small'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136620486764259.4479)
,p_theme_id=>3
,p_name=>'STRONGBUTTONLABEL'
,p_display_name=>'Strong Button Label'
,p_display_sequence=>1
,p_css_classes=>'a-Button--strongLabel'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136861925764259.4479)
,p_theme_id=>3
,p_name=>'AUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form--autoWidthLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137023291764259.4479)
,p_theme_id=>3
,p_name=>'FIXEDWIDTH'
,p_display_name=>'Fixed'
,p_display_sequence=>10
,p_css_classes=>'a-Form--fixedLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137193234764259.4479)
,p_theme_id=>3
,p_name=>'LABELSABOVE'
,p_display_name=>'Labels Above'
,p_display_sequence=>1
,p_css_classes=>'a-Form--labelsAbove'
,p_group_id=>wwv_flow_api.id(856116523282058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137470293764259.4479)
,p_theme_id=>3
,p_name=>'ALIGNLABELSLEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Form--leftLabels'
,p_group_id=>wwv_flow_api.id(856114568019058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137586003764259.4479)
,p_theme_id=>3
,p_name=>'LABELAUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_group_id=>wwv_flow_api.id(856116214022058024)
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137737661764259.4479)
,p_theme_id=>3
,p_name=>'STRETCHFORMFIELD'
,p_display_name=>'Stretch Form Field'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--stretch'
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137933035764259.4479)
,p_theme_id=>3
,p_name=>'FIXEDLARGE'
,p_display_name=>'Fixed (Large Width)'
,p_display_sequence=>30
,p_css_classes=>'a-Form-fixedLabelsLarge'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138175863764259.4479)
,p_theme_id=>3
,p_name=>'FIXEDMEDIUM'
,p_display_name=>'Fixed (Medium Width)'
,p_display_sequence=>20
,p_css_classes=>'a-Form-fixedLabelsMed'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138340877764259.4479)
,p_theme_id=>3
,p_name=>'180PX'
,p_display_name=>'180px'
,p_display_sequence=>10
,p_css_classes=>'h180'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138553321764259.4479)
,p_theme_id=>3
,p_name=>'240PX'
,p_display_name=>'240px'
,p_display_sequence=>20
,p_css_classes=>'h240'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138777457764259.4479)
,p_theme_id=>3
,p_name=>'320PX'
,p_display_name=>'320px'
,p_display_sequence=>30
,p_css_classes=>'h320'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138891974764260.4479)
,p_theme_id=>3
,p_name=>'480PX'
,p_display_name=>'480px'
,p_display_sequence=>50
,p_css_classes=>'h480'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139153872764260.4479)
,p_theme_id=>3
,p_name=>'540PX'
,p_display_name=>'540px'
,p_display_sequence=>60
,p_css_classes=>'h540'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139375337764260.4479)
,p_theme_id=>3
,p_name=>'640PX'
,p_display_name=>'640px'
,p_display_sequence=>70
,p_css_classes=>'h640'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145206107768768.4479)
,p_theme_id=>3
,p_name=>'USE_COLORED_BACKGROUND'
,p_display_name=>'Use Colored Background'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4479)
,p_css_classes=>'a-Alert--colorBG'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145328630768768.4479)
,p_theme_id=>3
,p_name=>'USE_DEFAULT_ICONS'
,p_display_name=>'Use Default Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4479)
,p_css_classes=>'a-Alert--defaultIcons'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145505007768768.4479)
,p_theme_id=>3
,p_name=>'WARNING'
,p_display_name=>'Warning'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4479)
,p_css_classes=>'a-Alert--warning'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145725778768768.4479)
,p_theme_id=>3
,p_name=>'ERROR'
,p_display_name=>'Error'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4479)
,p_css_classes=>'a-Alert--danger'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145892117768768.4479)
,p_theme_id=>3
,p_name=>'INFORMATIONAL'
,p_display_name=>'Informational'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4479)
,p_css_classes=>'a-Alert--info'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146085228768768.4479)
,p_theme_id=>3
,p_name=>'HORIZONTAL'
,p_display_name=>'Horizontal'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4479)
,p_css_classes=>'a-Alert--horizontal'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146322225768769.4479)
,p_theme_id=>3
,p_name=>'WIZARD'
,p_display_name=>'Wizard'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4479)
,p_css_classes=>'a-Alert--wizard'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146393064768769.4479)
,p_theme_id=>3
,p_name=>'REMOVE_ICON'
,p_display_name=>'Remove Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4479)
,p_css_classes=>'a-Alert--noIcon'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146615368768769.4479)
,p_theme_id=>3
,p_name=>'SUCCESS'
,p_display_name=>'Success'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4479)
,p_css_classes=>'a-Alert--success'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147042367768771.4479)
,p_theme_id=>3
,p_name=>'REGIONCONTAINSITEMSTEXT'
,p_display_name=>'Region Contains Items / Text'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4479)
,p_css_classes=>'a-ButtonRegion--withItems'
,p_template_types=>'REGION'
,p_help_text=>'Check this option if this region contains items or text.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147189725768771.4479)
,p_theme_id=>3
,p_name=>'REMOVEUIDECORATION'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4479)
,p_css_classes=>'a-ButtonRegion--noUI'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147385795768771.4479)
,p_theme_id=>3
,p_name=>'REMOVEBORDERS'
,p_display_name=>'Remove Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4479)
,p_css_classes=>'a-ButtonRegion--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147655668768771.4479)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4479)
,p_css_classes=>'a-ButtonRegion--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147872948768771.4479)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4479)
,p_css_classes=>'a-ButtonRegion--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147976018768771.4479)
,p_theme_id=>3
,p_name=>'WIZARDDIALOG'
,p_display_name=>'Used for Wizard Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4479)
,p_css_classes=>'a-ButtonRegion--wizard'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148162424768771.4479)
,p_theme_id=>3
,p_name=>'VISIBLE'
,p_display_name=>'Visible'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4479)
,p_css_classes=>'a-ButtonRegion--showTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148341454768771.4479)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4479)
,p_css_classes=>'a-ButtonRegion--accessibleTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
,p_help_text=>'Use this option to add a visually hidden heading which is accessible for screen readers, but otherwise not visible to users.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149438708768778.4479)
,p_theme_id=>3
,p_name=>'FLOATITEMS'
,p_display_name=>'Float Items'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4479)
,p_css_classes=>'a-BadgeList--float'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149614105768778.4479)
,p_theme_id=>3
,p_name=>'FIXED'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4479)
,p_css_classes=>'a-BadgeList--fixed'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149843563768778.4479)
,p_theme_id=>3
,p_name=>'STACKEDVERTICALLY'
,p_display_name=>'Stacked Vertically'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4479)
,p_css_classes=>'a-BadgeList--stacked'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149998210768778.4479)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'32px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4479)
,p_css_classes=>'a-BadgeList--small'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150194417768778.4479)
,p_theme_id=>3
,p_name=>'MEDIUM'
,p_display_name=>'48px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4479)
,p_css_classes=>'a-BadgeList--medium'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150439507768778.4479)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'64px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4479)
,p_css_classes=>'a-BadgeList--large'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150608654768780.4479)
,p_theme_id=>3
,p_name=>'XLARGE'
,p_display_name=>'96px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4479)
,p_css_classes=>'a-BadgeList--xlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150792333768780.4479)
,p_theme_id=>3
,p_name=>'XXLARGE'
,p_display_name=>'128px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4479)
,p_css_classes=>'a-BadgeList--xxlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151008734768780.4479)
,p_theme_id=>3
,p_name=>'2COLUMNNGRID'
,p_display_name=>'2 Columnn Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4479)
,p_css_classes=>'a-BadgeList--cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151259777768780.4479)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4479)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--3cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151408063768780.4479)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4479)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--4cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151643103768780.4479)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4479)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--5cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151861194768780.4479)
,p_theme_id=>3
,p_name=>'FLEXIBLEBOX'
,p_display_name=>'Flexible Box'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4479)
,p_css_classes=>'a-BadgeList--flex'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798730495581814.4479)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4479)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798963380581814.4479)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4479)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799089194581814.4479)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4479)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799349986581814.4479)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4479)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799577541581814.4479)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4479)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799637215581814.4479)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4479)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799807498581814.4479)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4479)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022191342234716.4479)
,p_theme_id=>3
,p_name=>'2COLUMNGRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4479)
,p_css_classes=>'a-MediaList--cols a-MediaList--2cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022392217234716.4479)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4479)
,p_css_classes=>'a-MediaList--cols a-MediaList--3cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022597980234716.4479)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4479)
,p_css_classes=>'a-MediaList--cols a-MediaList--4cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022867300234717.4479)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4479)
,p_css_classes=>'a-MediaList--cols a-MediaList--5cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023065592234717.4479)
,p_theme_id=>3
,p_name=>'SPANHORIZONTALLY'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4479)
,p_css_classes=>'a-MediaList--horizontal'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023131122234717.4479)
,p_theme_id=>3
,p_name=>'HIDEBADGE'
,p_display_name=>'Hide Badge'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4479)
,p_css_classes=>'a-MediaList--noBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023191297234717.4479)
,p_theme_id=>3
,p_name=>'HIDEDESCRIPTION'
,p_display_name=>'Hide Description'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4479)
,p_css_classes=>'a-MediaList--noDesc'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023315038234717.4479)
,p_theme_id=>3
,p_name=>'HIDETITLE'
,p_display_name=>'Hide Title'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4479)
,p_css_classes=>'a-MediaList--noTitle'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023432264234717.4479)
,p_theme_id=>3
,p_name=>'HIDEICONS'
,p_display_name=>'Hide Icons'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4479)
,p_css_classes=>'a-MediaList--noIcons'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023494059234717.4479)
,p_theme_id=>3
,p_name=>'SLIMLIST'
,p_display_name=>'Slim List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4479)
,p_css_classes=>'a-MediaList--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378094918666945.4479)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4479)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378225037666947.4479)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4479)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378370589666947.4479)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4479)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378467813666947.4479)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4479)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378526097666947.4479)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4479)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378615102666947.4479)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4479)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378735377666947.4479)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4479)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071796325339624.4479)
,p_theme_id=>3
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4479)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071972285339624.4479)
,p_theme_id=>3
,p_name=>'ADD_SLIDE_ANIMATION'
,p_display_name=>'Add Slide Animation'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4479)
,p_css_classes=>'js-slide'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1050367122398973653.4479)
,p_theme_id=>3
,p_name=>'SLIMPROGRESSLIST'
,p_display_name=>'Slim Progress List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(865273508717512144.4479)
,p_css_classes=>'a-WizardSteps--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1309233880682664517.4479)
,p_theme_id=>3
,p_name=>'LEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_button_template_id=>wwv_flow_api.id(868252865986181054.4479)
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1351338307429029043.4479)
,p_theme_id=>3
,p_name=>'USED_IN_DIALOG'
,p_display_name=>'Used in Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1274355059486017828.4479)
,p_css_classes=>'a-ProcessingRegion--dialog'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333722717814196.4479)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4479)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333859287814196.4479)
,p_theme_id=>3
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4479)
,p_css_classes=>'a-LinksList--showBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333887728814196.4479)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4479)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334039640814196.4479)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4479)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334247146814196.4479)
,p_theme_id=>3
,p_name=>'FORTOPLEVELONLY'
,p_display_name=>'For top level only'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4479)
,p_css_classes=>'a-LinksList--showTopIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334455135814196.4479)
,p_theme_id=>3
,p_name=>'FORALLITEMS'
,p_display_name=>'For all items'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4479)
,p_css_classes=>'a-LinksList--showIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491342397110118.4479)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4479)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491390428110118.4479)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4479)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491480011110118.4479)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4479)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'REPORT'
);
end;
/
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488722406040473.4479)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4479)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488933681040473.4479)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4479)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489165994040473.4479)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4479)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489304869040473.4479)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4479)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489519844040473.4479)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4479)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489753255040473.4479)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4479)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489941797040473.4479)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4479)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490153471040473.4479)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4479)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490336091040473.4479)
,p_theme_id=>3
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4479)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490377667040473.4479)
,p_theme_id=>3
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4479)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490659850040473.4479)
,p_theme_id=>3
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4479)
,p_css_classes=>'a-Region--simple'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664501980442158869.4479)
,p_theme_id=>3
,p_name=>'RESPONSIVEICONCOLUMNS'
,p_display_name=>'Responsive Icon Columns'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4479)
,p_css_classes=>'a-IRR-region--responsiveIconView'
,p_template_types=>'REGION'
,p_help_text=>'Automatically increases number of icon columns to show based on screen resolution.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502160891158869.4479)
,p_theme_id=>3
,p_name=>'ICONLABELSRIGHT'
,p_display_name=>'Icon Labels on Right'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4479)
,p_css_classes=>'a-IRR-region--iconLabelsRight'
,p_template_types=>'REGION'
,p_help_text=>'Shows labels in Icon View to the right of the icon.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502181188158869.4479)
,p_theme_id=>3
,p_name=>'REMOVEOUTERBORDERS'
,p_display_name=>'Remove Outer Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4479)
,p_css_classes=>'a-IRR-region--noOuterBorders'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508367504174332.4479)
,p_theme_id=>3
,p_name=>'FLUSHREGION'
,p_display_name=>'Flush Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4479)
,p_css_classes=>'a-Region--flush'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508426350174332.4479)
,p_theme_id=>3
,p_name=>'STACKEDREGION'
,p_display_name=>'Stacked Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4479)
,p_css_classes=>'a-Region--stacked'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508588305174332.4479)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4479)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508810521174332.4479)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4479)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509005841174332.4479)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4479)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509270186174332.4479)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4479)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509448573174333.4479)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4479)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509659839174333.4479)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4479)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509822387174334.4479)
,p_theme_id=>3
,p_name=>'EXPANDED'
,p_display_name=>'Expanded'
,p_display_sequence=>.1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4479)
,p_css_classes=>'is-expanded'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664510028962174334.4479)
,p_theme_id=>3
,p_name=>'COLLAPSED'
,p_display_name=>'Collapsed'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4479)
,p_css_classes=>'is-collapsed'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
end;
/
prompt --application/shared_components/globalization/language
begin
null;
end;
/
prompt --application/shared_components/logic/build_options
begin
null;
end;
/
prompt --application/shared_components/globalization/messages
begin
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112893615373400515)
,p_name=>'4150_COLUMN_NUMBER'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217%0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112880705582400506)
,p_name=>'ACCESS_CONTROL_ADMIN'
,p_message_language=>'ja'
,p_message_text=>unistr('\7BA1\7406\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112880680814400506)
,p_name=>'ACCESS_CONTROL_USERNAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112937931514400549)
,p_name=>'ACCESS_DENIED_SIMPLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\62D2\5426\3055\308C\305F\30A2\30AF\30BB\30B9')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112897604655400518)
,p_name=>'ACCOUNT_HAS_BEEN_CREATED'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\30A2\30AB\30A6\30F3\30C8\304C\4F5C\6210\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112883212374400508)
,p_name=>'ACCOUNT_LOCKED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AB\30A6\30F3\30C8\304C\30ED\30C3\30AF\3055\308C\3066\3044\307E\3059\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112873170842400500)
,p_name=>'AM_PM'
,p_message_language=>'ja'
,p_message_text=>'AM / PM'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113007540100400600)
,p_name=>'APEX.ACTIONS.TOGGLE'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306E\5207\66FF\3048')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113015622983400606)
,p_name=>'APEX.ACTIVE_STATE'
,p_message_language=>'ja'
,p_message_text=>unistr('(\30A2\30AF\30C6\30A3\30D6)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112985137494400584)
,p_name=>'APEX.AJAX_SERVER_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('Ajax\30B3\30FC\30EB\3067%1\306E\30B5\30FC\30D0\30FC\30FB\30A8\30E9\30FC%0\304C\8FD4\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112915959827400532)
,p_name=>'APEX.APPLICATION.ALIAS.NON_UNIQUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\5225\540D\300C%0\300D\306F\3001\4E00\610F\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3ID\306B\5909\63DB\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112916065129400532)
,p_name=>'APEX.APPLICATION.ALIAS.NOT_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\5225\540D"%0"\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304C\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112905607109400524)
,p_name=>'APEX.APPLICATION.ALIAS.UNHANDLED_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('ERR-1816 \30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\5225\540Dp_flow_alias_or_id(%0)\306E\5909\63DB\4E2D\306B\4E88\671F\3057\306A\3044\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112998594711400593)
,p_name=>'APEX.APPLICATION.CHECKSUM.DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30C1\30A7\30C3\30AF\30B5\30E0\3092\4F7F\7528\3059\308B\3068\3001\540C\3058\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304C\30EF\30FC\30AF\30B9\30DA\30FC\30B9\5168\4F53\306B\30C7\30D7\30ED\30A4\3055\308C\3066\3044\308B\304B\3069\3046\304B\3092\7C21\5358\306B\5224\5225\3067\304D\307E\3059\3002\3053\306E\30C1\30A7\30C3\30AF\30B5\30E0\3092\6BD4\8F03\3057\3066\3001\4E00\81F4\3059\308B\3082\306E\304C\3042\308B\304B\3069\3046\304B\3092\5224\5225\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112891486296400514)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNC.UNHANDLED_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\30D5\30A1\30F3\30AF\30B7\30E7\30F3\306E\51E6\7406\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112876889638400503)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\30D5\30A1\30F3\30AF\30B7\30E7\30F3\306E\51E6\7406\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113040315051400624)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.HOST_PREFIX_MISMATCH'
,p_message_language=>'ja'
,p_message_text=>unistr('Oracle Cloud Identity Management\306B\3088\3063\3066\8FD4\3055\308C\305F\30C6\30CA\30F3\30C8\540D%0\304C\3001\30C9\30E1\30A4\30F3%1\306B\306F\8A31\53EF\3055\308C\3066\3044\307E\305B\3093\3002<br/><a href="&LOGOUT_URL.">\518D\30ED\30B0\30A4\30F3</a>\3057\3001\8A31\53EF\3055\308C\305F\30C6\30CA\30F3\30C8\540D\3092\6307\5B9A\3059\308B\304BURL\3092\5909\66F4\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112874509046400501)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.USER_IS_NOT_DEVELOPER'
,p_message_language=>'ja'
,p_message_text=>unistr('\3054\4F7F\7528\306E\30A2\30AB\30A6\30F3\30C8"%0"\306B\306F\3001\30EF\30FC\30AF\30B9\30DA\30FC\30B9"%1"\306B\5FC5\8981\306A\958B\767A\6A29\9650(DB_DEVELOPER\307E\305F\306FDB_ADMINISTRATOR)<br/>\304C\3042\308A\307E\305B\3093\3002\6A29\9650\3092\4ED8\4E0E\3057\3066\304B\3089<a href="&LOGOUT_URL.">\518D\30ED\30B0\30A4\30F3</a>\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112873601264400501)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.WRONG_GROUP_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('Oracle Cloud Identity Management\306B\3088\3063\3066\8FD4\3055\308C\305F\30C6\30CA\30F3\30C8\540D\304C\3001\73FE\5728\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306B\306F\8A31\53EF\3055\308C\3066\3044\307E\305B\3093\3002<br/><a href="&LOGOUT_URL.">\518D\30ED\30B0\30A4\30F3</a>\3057\3001\8A31\53EF\3055\308C\305F\30C6\30CA\30F3\30C8\540D\3092\6307\5B9A\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112874611746400501)
,p_name=>'APEX.AUTHENTICATION.HOST_PREFIX_MISMATCH'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30AD\30E5\30EA\30C6\30A3\4E0A\306E\7406\7531\3067\3001URL\306E\30C9\30E1\30A4\30F3\3092\4ECB\3057\3066\3053\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\5B9F\884C\3059\308B\3053\3068\306F\8A31\53EF\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112891111590400513)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.ASK_FOR_INSTALLATION'
,p_message_language=>'ja'
,p_message_text=>unistr('DBA\306B$ORACLE_HOME/rdbms/admin/catldap.sql\306E\5B9F\884C\3092\4F9D\983C\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112891030968400513)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.MISSING'
,p_message_language=>'ja'
,p_message_text=>unistr('SYS.DBMS_LDAP\30D1\30C3\30B1\30FC\30B8\304C\5B58\5728\3057\306A\3044\304B\7121\52B9\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112890975395400513)
,p_name=>'APEX.AUTHENTICATION.LDAP.EDIT_USER_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('LDAP\30E6\30FC\30B6\30FC\95A2\6570\306E\51E6\7406\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112891298657400514)
,p_name=>'APEX.AUTHENTICATION.LDAP.UNHANDLED_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('LDAP\8A8D\8A3C\306E\51E6\7406\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112892068342400514)
,p_name=>'APEX.AUTHENTICATION.LOGIN.ILLEGAL_PAGE_ARG'
,p_message_language=>'ja'
,p_message_text=>unistr('login_page\30D7\30ED\30B7\30FC\30B8\30E3\306B\5BFE\3059\308Bp_flow_page\5F15\6570\3067\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112891664363400514)
,p_name=>'APEX.AUTHENTICATION.LOGIN.INVALID_ARG'
,p_message_language=>'ja'
,p_message_text=>unistr('wwv_flow_custom_auth_std.login--p_flow_page:%0 p_session_id:%1\3067\306E\7121\52B9\306Ap_session\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112939503318400550)
,p_name=>'APEX.AUTHENTICATION.LOGIN.MALFORMED_ARGS'
,p_message_language=>'ja'
,p_message_text=>unistr('wwv_flow_custom_auth_std.login--p_flow_page:p_session_id:p_entry_point:%0:%1:%2\306B\5BFE\3059\308B\8AA4\3063\305F\5F15\6570\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112891780771400514)
,p_name=>'APEX.AUTHENTICATION.LOGIN.NULL_USER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30B0\30A4\30F3\30FB\30D7\30ED\30B7\30FC\30B8\30E3\306B\6E21\3055\308C\305F\30E6\30FC\30B6\30FC\540D\304CNULL\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112880560370400506)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.COUNTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\518D\5EA6\30B5\30A4\30F3\30A4\30F3\3059\308B\307E\3067<span id="apex_login_throttle_sec">%0</span>\79D2\304A\5F85\3061\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112881851330400507)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30B0\30A4\30F3\8A66\884C\304C\30D6\30ED\30C3\30AF\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112937310368400548)
,p_name=>'APEX.AUTHENTICATION.NOT_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C"%0"\304C\898B\3064\304B\308A\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112882143989400507)
,p_name=>'APEX.AUTHENTICATION.NO_SECURITY_GROUP_ID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30AD\30E5\30EA\30C6\30A3\30FB\30B0\30EB\30FC\30D7ID\304CNULL\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112891511112400514)
,p_name=>'APEX.AUTHENTICATION.POST_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\5F8C\51E6\7406\306E\5B9F\884C\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112891378616400514)
,p_name=>'APEX.AUTHENTICATION.PRE_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\524D\51E6\7406\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112892567025400515)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD.INSTRUCTIONS'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30D1\30B9\30EF\30FC\30C9\306E\518D\8A2D\5B9A\30EA\30AF\30A8\30B9\30C8\3092\958B\59CB\3057\305F\30D6\30E9\30A6\30B6\3067URL\3092\958B\3044\3066\304F\3060\3055\3044\3002\300C\30D1\30B9\30EF\30FC\30C9\518D\8A2D\5B9A\306EURL\300D\3092\30AF\30EA\30C3\30AF\3057\3001\30ED\30B0\30A4\30F3\30FB\30DA\30FC\30B8\306B\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\308B\5834\5408\306F\3001'),
unistr('\3082\3046\4E00\5EA6\300C\30D1\30B9\30EF\30FC\30C9\306E\518D\8A2D\5B9A\300D\3092\958B\59CB\3057\3001\30D6\30E9\30A6\30B6\3092'),
unistr('\958B\3044\305F\307E\307E\306B\3057\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113037893365400622)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD_URL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30B9\30EF\30FC\30C9\518D\8A2D\5B9A\306EURL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112874851123400502)
,p_name=>'APEX.AUTHENTICATION.RM_GROUP_NOT_GRANTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30BD\30FC\30B9\30FB\30DE\30CD\30FC\30B8\30E3\30FB\30B3\30F3\30B7\30E5\30FC\30DE\30FB\30B0\30EB\30FC\30D7%0\306B\306F%1\304C\4ED8\4E0E\3055\308C\3066\3044\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112874946524400502)
,p_name=>'APEX.AUTHENTICATION.RM_INFO_TO_GRANT'
,p_message_language=>'ja'
,p_message_text=>unistr('DBMS_RESOURCE_MANAGER_PRIVS.GRANT_SWITCH_CONSUMER_GROUP\3092\4F7F\7528\3057\3066\3001\6B20\843D\3057\3066\3044\308B\6A29\9650\3092\4ED8\4E0E\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112902936028400522)
,p_name=>'APEX.AUTHENTICATION.SESSION_SENTRY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30C3\30B7\30E7\30F3\76E3\8996\30D5\30A1\30F3\30AF\30B7\30E7\30F3\306E\51E6\7406\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112903002405400522)
,p_name=>'APEX.AUTHENTICATION.SESSION_VERIFY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30C3\30B7\30E7\30F3\691C\8A3C\30D5\30A1\30F3\30AF\30B7\30E7\30F3\306E\51E6\7406\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112903207095400522)
,p_name=>'APEX.AUTHENTICATION.SSO.ASK_FOR_INSTALLATION'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306E\7BA1\7406\8005\306BOracle Application Server Single Sign-On\306E\30A8\30F3\30B8\30F3\306E\69CB\6210\3092\4F9D\983C\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112912788638400530)
,p_name=>'APEX.AUTHENTICATION.SSO.BAD_URLC'
,p_message_language=>'ja'
,p_message_text=>unistr('SSO\306B\3088\3063\3066\3001%1\30C8\30FC\30AF\30F3\306E\7121\52B9\306A%0\304C\623B\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112891987305400514)
,p_name=>'APEX.AUTHENTICATION.SSO.FIX_PARTNER_APP'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\30B9\30AD\30FC\30E0\3092\7DE8\96C6\3057\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\540D\3092\8FFD\52A0\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112912420694400529)
,p_name=>'APEX.AUTHENTICATION.SSO.ILLEGAL_CALLER'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\30D7\30ED\30B7\30FC\30B8\30E3\306E\7121\52B9\306A\30B3\30FC\30EB\5143:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112912691154400530)
,p_name=>'APEX.AUTHENTICATION.SSO.INVALID_APP_SESSION'
,p_message_language=>'ja'
,p_message_text=>unistr('urlc\30C8\30FC\30AF\30F3\3067\306E\7121\52B9\306A\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30BB\30C3\30B7\30E7\30F3: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112912278134400529)
,p_name=>'APEX.AUTHENTICATION.SSO.MISSING_APP_REGISTRATION'
,p_message_language=>'ja'
,p_message_text=>unistr('portal_sso_redirect\3067\306E\30A8\30E9\30FC: \30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\767B\9332\60C5\5831\306E\6B20\843D: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112903185716400522)
,p_name=>'APEX.AUTHENTICATION.SSO.PACKAGE_MISSING'
,p_message_language=>'ja'
,p_message_text=>unistr('WWSEC_SSO_ENABLER_PRIVATE\30D1\30C3\30B1\30FC\30B8\304C\3001\5B58\5728\3057\306A\3044\304B\7121\52B9\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112891872506400514)
,p_name=>'APEX.AUTHENTICATION.SSO.PARTNER_APP_IS_NULL'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\30B9\30AD\30FC\30E0\3067\767B\9332\6E08\30D1\30FC\30C8\30CA\30FB\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\540D\304C\898B\3064\304B\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112912332803400529)
,p_name=>'APEX.AUTHENTICATION.SSO.REGISTER_APP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30B9\30C8\30EC\30FC\30B7\30E7\30F3\30FB\30AC\30A4\30C9\3067\8AAC\660E\3055\308C\3066\3044\308B\3068\304A\308A\3001\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\767B\9332\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112903395824400522)
,p_name=>'APEX.AUTHENTICATION.SSO.UNHANDLED_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('SSO\8A8D\8A3C\306E\51E6\7406\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113012770508400604)
,p_name=>'APEX.AUTHENTICATION.UNAUTHORIZED_URL'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\53EF\3055\308C\3066\3044\306A\3044URL: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112902708813400522)
,p_name=>'APEX.AUTHENTICATION.UNHANDLED_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\51E6\7406\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112874720252400501)
,p_name=>'APEX.AUTHENTICATION.WORKSPACE_NOT_ASSIGNED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9"%0"\304C\975E\30A2\30AF\30C6\30A3\30D6\3067\3059\3002\7BA1\7406\8005\306B\9023\7D61\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112875162611400502)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED'
,p_message_language=>'ja'
,p_message_text=>'%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112881537954400506)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.APPLICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30BB\30AD\30E5\30EA\30C6\30A3\30FB\30C1\30A7\30C3\30AF\306B\3088\3063\3066\62D2\5426\3055\308C\305F\30A2\30AF\30BB\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112881664284400506)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306E\30BB\30AD\30E5\30EA\30C6\30A3\30FB\30C1\30A7\30C3\30AF\306B\3088\3063\3066\62D2\5426\3055\308C\305F\30A2\30AF\30BB\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112881790327400507)
,p_name=>'APEX.AUTHORIZATION.UNHANDLED_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\53EF\51E6\7406\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112945148500400554)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX'
,p_message_language=>'ja'
,p_message_text=>'Built with %0 using %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112945255732400554)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX.ACCESSIBLE.LOVE'
,p_message_language=>'ja'
,p_message_text=>'love'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113003034780400597)
,p_name=>'APEX.CALENDAR.EVENT_DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30D9\30F3\30C8\306E\8AAC\660E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113002860753400597)
,p_name=>'APEX.CALENDAR.EVENT_END'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D42\4E86\65E5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113003160626400597)
,p_name=>'APEX.CALENDAR.EVENT_ID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30D9\30F3\30C8ID')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113002797763400596)
,p_name=>'APEX.CALENDAR.EVENT_START'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\59CB\65E5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113002935674400597)
,p_name=>'APEX.CALENDAR.EVENT_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30D9\30F3\30C8\30FB\30BF\30A4\30C8\30EB')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112893546843400515)
,p_name=>'APEX.CHECKSUM.CONTENT_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30A7\30C3\30AF\30B5\30E0\30FB\30B3\30F3\30C6\30F3\30C4\30FB\30A8\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112893460810400515)
,p_name=>'APEX.CHECKSUM.FORMAT_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30A7\30C3\30AF\30B5\30E0\5F62\5F0F\30A8\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112957428124400563)
,p_name=>'APEX.CLIPBOARD.COPIED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30EA\30C3\30D7\30DC\30FC\30C9\306B\30B3\30D4\30FC\3055\308C\307E\3057\305F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112957163989400563)
,p_name=>'APEX.CLIPBOARD.NOTSUP'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30D6\30E9\30A6\30B6\3067\306F\3001\30DC\30BF\30F3\307E\305F\306F\30E1\30CB\30E5\30FC\304B\3089\306E\30B3\30D4\30FC\304C\30B5\30DD\30FC\30C8\3055\308C\3066\3044\307E\305B\3093\3002[Ctrl]\3092\62BC\3057\306A\304C\3089[C]\3092\62BC\3059\304B\3001[Command]\3092\62BC\3057\306A\304C\3089[C]\3092\62BC\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112945668929400555)
,p_name=>'APEX.CLOSE_NOTIFICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\901A\77E5\3092\9589\3058\308B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113001651437400596)
,p_name=>'APEX.COLOR_PICKER.CONTRAST'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30C8\30E9\30B9\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112996145817400592)
,p_name=>'APEX.COLOR_PICKER.CURRENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30EC\30F3\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112996035376400592)
,p_name=>'APEX.COLOR_PICKER.INITIAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\521D\671F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113000278776400595)
,p_name=>'APEX.COLOR_PICKER.INVALID_COLOR'
,p_message_language=>'ja'
,p_message_text=>unistr('#LABEL#\306F\6709\52B9\306A\30AB\30E9\30FC\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\4F8B: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112995939966400592)
,p_name=>'APEX.COLOR_PICKER.TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8272\306E\9078\629E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112996221303400592)
,p_name=>'APEX.COLOR_PICKER.TOGGLE_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8272\5F62\5F0F\306E\5909\66F4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113035475914400620)
,p_name=>'APEX.COMBOBOX.LIST_OF_VALUES'
,p_message_language=>'ja'
,p_message_text=>'LOV'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113035576286400620)
,p_name=>'APEX.COMBOBOX.SHOW_ALL_VALUES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8\306E\30AA\30FC\30D7\30F3: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113015778817400606)
,p_name=>'APEX.COMPLETED_STATE'
,p_message_language=>'ja'
,p_message_text=>unistr('(\5B8C\4E86)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112908099819400526)
,p_name=>'APEX.CONTACT_ADMIN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\7BA1\7406\8005\306B\9023\7D61\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112922466850400537)
,p_name=>'APEX.CONTACT_ADMIN.DEBUG'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\7BA1\7406\8005\306B\9023\7D61\3057\3066\304F\3060\3055\3044\3002'),
unistr('\3053\306E\30A4\30F3\30B7\30C7\30F3\30C8\306E\8A73\7D30\306F\3001\30C7\30D0\30C3\30B0ID "%0"\3088\308A\53C2\7167\3067\304D\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113000578196400595)
,p_name=>'APEX.CORRECT_ERRORS'
,p_message_language=>'ja'
,p_message_text=>unistr('\4FDD\5B58\3059\308B\524D\306B\30A8\30E9\30FC\3092\4FEE\6B63\3057\3066\304F\3060\3055\3044\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112946563525400555)
,p_name=>'APEX.CS.MATCHES_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\4EF6\306E\4E00\81F4\304C\898B\3064\304B\308A\307E\3057\305F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112946433601400555)
,p_name=>'APEX.CS.NO_MATCHES'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E00\81F4\304C\898B\3064\304B\308A\307E\305B\3093\3067\3057\305F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113016295726400606)
,p_name=>'APEX.CURRENT_PROGRESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\9032\884C\72B6\6CC1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113000996698400595)
,p_name=>'APEX.DATA.LOAD.FILE_DOES_NOT_EXIST'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\30A2\30A4\30C6\30E0\3067\6307\5B9A\3055\308C\3066\3044\308B\30D5\30A1\30A4\30EB\306F\3001APEX_APPLICATION_TEMP_FILES\306B\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112989400018400587)
,p_name=>'APEX.DATA_HAS_CHANGED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\304C\66F4\65B0\51E6\7406\3092\958B\59CB\3057\3066\304B\3089\3001\30C7\30FC\30BF\30D9\30FC\30B9\5185\306E\73FE\884C\30D0\30FC\30B8\30E7\30F3\306E\30C7\30FC\30BF\304C\5909\66F4\3055\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112958518368400564)
,p_name=>'APEX.DATA_LOAD.DO_NOT_LOAD'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30FC\30C9\3057\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113005563110400599)
,p_name=>'APEX.DATA_LOAD.FAILED'
,p_message_language=>'ja'
,p_message_text=>unistr('\524D\51E6\7406\30A8\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113005363479400598)
,p_name=>'APEX.DATA_LOAD.INSERT'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\306E\633F\5165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113019462285400608)
,p_name=>'APEX.DATA_LOAD.SEQUENCE_ACTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\9806\5E8F: \30A2\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113005475417400598)
,p_name=>'APEX.DATA_LOAD.UPDATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\306E\66F4\65B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112946960306400555)
,p_name=>'APEX.DATEPICKER.ICON_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DD\30C3\30D7\30A2\30C3\30D7\30FB\30AB\30EC\30F3\30C0: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112869548971400498)
,p_name=>'APEX.DATEPICKER_JET.NEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112869666328400498)
,p_name=>'APEX.DATEPICKER_JET.PREVIOUS'
,p_message_language=>'ja'
,p_message_text=>unistr('\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113005731093400599)
,p_name=>'APEX.DATEPICKER_JET.REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('#LABEL#\306B\5024\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113005607839400599)
,p_name=>'APEX.DATEPICKER_JET.VALUE_INVALID'
,p_message_language=>'ja'
,p_message_text=>unistr('#LABEL#\306F\6709\52B9\306A\65E5\4ED8\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002\4F8B: %0\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112873211154400500)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_BETWEEN'
,p_message_language=>'ja'
,p_message_text=>unistr('#LABEL#\306F%0\304B\3089%1\306E\9593\306B\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112873392176400500)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_AFTER'
,p_message_language=>'ja'
,p_message_text=>unistr('#LABEL#\306F%0\4EE5\964D\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112873457272400500)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_BEFORE'
,p_message_language=>'ja'
,p_message_text=>unistr('#LABEL#\306F%0\4EE5\524D\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112950465329400558)
,p_name=>'APEX.DATEPICKER_VALUE_GREATER_MAX_DATE'
,p_message_language=>'ja'
,p_message_text=>unistr('#LABEL#\304C\3001\6307\5B9A\3057\305F\6700\5927\65E5\4ED8%0\3088\308A\5927\304D\3044\5024\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112950842622400558)
,p_name=>'APEX.DATEPICKER_VALUE_INVALID'
,p_message_language=>'ja'
,p_message_text=>unistr('#LABEL#\304C\3001\5F62\5F0F%0\3068\4E00\81F4\3057\307E\305B\3093\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112950309281400558)
,p_name=>'APEX.DATEPICKER_VALUE_LESS_MIN_DATE'
,p_message_language=>'ja'
,p_message_text=>unistr('#LABEL#\304C\3001\6307\5B9A\3057\305F\6700\5C0F\65E5\4ED8%0\3088\308A\5C0F\3055\3044\5024\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112950505613400558)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'ja'
,p_message_text=>unistr('#LABEL#\304C%0\304B\3089%1\306E\6709\52B9\306A\7BC4\56F2\306B\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112950757797400558)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_IN_YEAR_RANGE'
,p_message_language=>'ja'
,p_message_text=>unistr('#LABEL#\304C\3001\6709\52B9\306A%0\3068%1\306E\5E74\306E\7BC4\56F2\5185\306B\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113000886683400595)
,p_name=>'APEX.DIALOG.CANCEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\53D6\6D88')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113028005724400615)
,p_name=>'APEX.DIALOG.CLOSE'
,p_message_language=>'ja'
,p_message_text=>unistr('\9589\3058\308B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113030081911400616)
,p_name=>'APEX.DIALOG.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D8\30EB\30D7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113000609779400595)
,p_name=>'APEX.DIALOG.OK'
,p_message_language=>'ja'
,p_message_text=>'OK'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113000776876400595)
,p_name=>'APEX.DIALOG.SAVE'
,p_message_language=>'ja'
,p_message_text=>unistr('\4FDD\5B58')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112906950010400525)
,p_name=>'APEX.ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112874306112400501)
,p_name=>'APEX.ERROR.CALLBACK_FAILED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC\51E6\7406\30B3\30FC\30EB\30D0\30C3\30AF\306E\5B9F\884C\4E2D\306B\6B21\306E\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112883046484400508)
,p_name=>'APEX.ERROR.ERROR_PAGE.UNHANDLED_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC\30FB\30DA\30FC\30B8\306E\30DA\30A4\30F3\30C8\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112875036225400502)
,p_name=>'APEX.ERROR.INTERNAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5185\90E8\30A8\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113014836362400605)
,p_name=>'APEX.ERROR.INTERNAL.CONTACT_ADMINISTRATOR'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\7BA1\7406\8005\306B\9023\7D61\3057\3066\304F\3060\3055\3044\3002'),
unistr('\3053\306E\30A4\30F3\30B7\30C7\30F3\30C8\306E\8A73\7D30\306F\3001\30C7\30D0\30C3\30B0ID "%0"\3088\308A\53C2\7167\3067\304D\307E\3059\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113009158912400601)
,p_name=>'APEX.ERROR.ORA-16000'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\306F\8AAD\53D6\308A\5C02\7528\30A2\30AF\30BB\30B9\7528\306B\30AA\30FC\30D7\30F3\3055\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113039773880400623)
,p_name=>'APEX.ERROR.ORA-28353'
,p_message_language=>'ja'
,p_message_text=>unistr('ORA-28353: \30A6\30A9\30EC\30C3\30C8\306E\30AA\30FC\30D7\30F3\306B\5931\6557\3057\307E\3057\305F\3002\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30C7\30FC\30BF\306B\306F\73FE\5728\30A2\30AF\30BB\30B9\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113009207475400601)
,p_name=>'APEX.ERROR.PAGE_NOT_AVAILABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DA\30FC\30B8\306F\4F7F\7528\3067\304D\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112876782132400503)
,p_name=>'APEX.ERROR.TECHNICAL_INFO'
,p_message_language=>'ja'
,p_message_text=>unistr('\6280\8853\60C5\5831(\958B\767A\8005\306E\307F\306B\8868\793A)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112972857532400575)
,p_name=>'APEX.ERROR_MESSAGE_HEADING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC\30FB\30E1\30C3\30BB\30FC\30B8')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112986713815400585)
,p_name=>'APEX.EXPECTED_FORMAT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5FC5\8981\306A\66F8\5F0F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112953412512400560)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.ALREADY_IN_ACL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\306F\30A2\30AF\30BB\30B9\5236\5FA1\30EA\30B9\30C8\306B\3059\3067\306B\5B58\5728\3057\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112953367637400560)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.CREATE_CONFIRM'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E%0\30E6\30FC\30B6\30FC\306E<strong>%1</strong>\30A2\30AF\30BB\30B9\5236\5FA1\30EA\30B9\30C8\3078\306E\8FFD\52A0\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112953890318400560)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.DUPLICATE_USER'
,p_message_language=>'ja'
,p_message_text=>unistr('\91CD\8907\3059\308B\30E6\30FC\30B6\30FC\304C\5B58\5728\3057\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112953585478400560)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_AT_SIGN'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9\306B\30A2\30C3\30C8\30DE\30FC\30AF(@)\304C\3042\308A\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112953637581400560)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_DOT'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9\306B\30D4\30EA\30AA\30C9(.)\304C\3042\308A\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112953746400400560)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.USERNAME_TOO_LONG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\540D\304C\9577\3059\304E\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112954039011400561)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_ONLY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30A2\30AF\30BB\30B9\5236\5FA1\30EA\30B9\30C8\306B\5B9A\7FA9\3055\308C\305F\30E6\30FC\30B6\30FC\306E\307F\304C\3001\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\30A2\30AF\30BB\30B9\3067\304D\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112954172974400561)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_VALUE_INVALID'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E88\671F\3057\306A\3044\30A2\30AF\30BB\30B9\5236\5FA1\8A2D\5B9A\5024: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112953968552400561)
,p_name=>'APEX.FEATURE.ACL.INFO.ALL_USERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\306E\8A8D\8A3C\6E08\30E6\30FC\30B6\30FC\304C\3001\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\30A2\30AF\30BB\30B9\3067\304D\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112996707586400592)
,p_name=>'APEX.FEATURE.CONFIG.DISABLED'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112996607174400592)
,p_name=>'APEX.FEATURE.CONFIG.ENABLED'
,p_message_language=>'ja'
,p_message_text=>unistr('\6709\52B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112996930253400592)
,p_name=>'APEX.FEATURE.CONFIG.IS_DISABLED'
,p_message_language=>'ja'
,p_message_text=>unistr('%0: \7121\52B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112996895575400592)
,p_name=>'APEX.FEATURE.CONFIG.IS_ENABLED'
,p_message_language=>'ja'
,p_message_text=>unistr('%0: \6709\52B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112996516958400592)
,p_name=>'APEX.FEATURE.TOP_USERS.USERNAME.NOT_IDENTIFIED'
,p_message_language=>'ja'
,p_message_text=>unistr('\6307\5B9A\3055\308C\3066\3044\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112989691791400587)
,p_name=>'APEX.FILE_BROWSE.DOWNLOAD_LINK_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C0\30A6\30F3\30ED\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112946109823400555)
,p_name=>'APEX.FS.APPLIED_FACET'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30EB\30BF%0\3092\9069\7528\6E08')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112987260829400585)
,p_name=>'APEX.FS.BATCH_APPLY'
,p_message_language=>'ja'
,p_message_text=>unistr('\9069\7528')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112872188365400500)
,p_name=>'APEX.FS.CHART_BAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\68D2\30B0\30E9\30D5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112999913634400594)
,p_name=>'APEX.FS.CHART_OTHERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\305D\306E\4ED6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112872222547400500)
,p_name=>'APEX.FS.CHART_PIE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5186\30B0\30E9\30D5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112998631954400593)
,p_name=>'APEX.FS.CHART_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112871953412400499)
,p_name=>'APEX.FS.CHART_VALUE_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30A6\30F3\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112987799312400586)
,p_name=>'APEX.FS.CLEAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30EA\30A2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112987862066400586)
,p_name=>'APEX.FS.CLEAR_ALL'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\30AF\30EA\30A2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112987988084400586)
,p_name=>'APEX.FS.CLEAR_VALUE'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306E\30AF\30EA\30A2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113005173042400598)
,p_name=>'APEX.FS.COLUMN_UNAUTHORIZED'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217%1\306F\3001\30D5\30A1\30BB\30C3\30C8%0\306B\53C2\7167\3055\308C\3066\3044\307E\3059\304C\3001\4F7F\7528\3067\304D\306A\3044\304B\8A8D\53EF\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112862357918400492)
,p_name=>'APEX.FS.CONFIG_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\3059\308B\30D5\30A3\30EB\30BF\306E\9078\629E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112944393113400554)
,p_name=>'APEX.FS.COUNT_RESULTS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\4EF6\306E\7D50\679C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112944444166400554)
,p_name=>'APEX.FS.COUNT_SELECTED'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\4EF6\9078\629E\6E08')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112947000587400556)
,p_name=>'APEX.FS.CUR_FILTERS_LM'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30D5\30A3\30EB\30BF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112863898657400493)
,p_name=>'APEX.FS.FACETS_LIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\30D5\30A3\30EB\30BF\300D\30EA\30B9\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113003601045400597)
,p_name=>'APEX.FS.FACET_VALUE_LIMIT_EXCEEDED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30BB\30C3\30C8%1\3067\500B\5225\5024\306E\5236\9650(%0)\3092\8D85\3048\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112989202377400587)
,p_name=>'APEX.FS.FC_TYPE_UNSUPPORTED_FOR_DATE_COLUMNS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30BB\30C3\30C8%0\306F\3001DATE\307E\305F\306FTIMESTAMP\5217\3067\306F\30B5\30DD\30FC\30C8\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112987308947400585)
,p_name=>'APEX.FS.FILTER'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306E\30D5\30A3\30EB\30BF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112987489778400585)
,p_name=>'APEX.FS.GO'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9F\884C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112988834114400586)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306B\7B49\3057\3044')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112872965810400500)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_CONTAINS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\3092\542B\3080')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112872634090400500)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GT'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\3088\308A\5927\304D\3044')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112872773877400500)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GTE'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\4EE5\4E0A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112872440296400500)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LT'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\672A\6E80')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112872559447400500)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LTE'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\4EE5\4E0B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112872878444400500)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_STARTSWITH'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\3067\59CB\307E\308B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112875370038400502)
,p_name=>'APEX.FS.INPUT_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\30C7\30FC\30BF\578B(%1)\306F\3001\5165\529B\30D5\30A3\30FC\30EB\30C9\30FB\30D5\30A1\30BB\30C3\30C8\3067\30B5\30DD\30FC\30C8\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112865565961400495)
,p_name=>'APEX.FS.MULTI_VALUE_REQUIRES_DB_12_2'
,p_message_language=>'ja'
,p_message_text=>unistr('\8907\6570\5024\30D5\30A1\30BB\30C3\30C8\306B\306F12.2\4EE5\4E0A\306E\30C7\30FC\30BF\30D9\30FC\30B9\304C\5FC5\8981\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112989068280400587)
,p_name=>'APEX.FS.NO_SEARCH_COLUMNS_PROVIDED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30BB\30C3\30C8%0\306B\5BFE\3057\3066\691C\7D22\5217\304C\63D0\4F9B\3055\308C\3066\3044\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112862437619400492)
,p_name=>'APEX.FS.OPEN_CONFIG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30EB\30BF\306E\8FFD\52A0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112944505587400554)
,p_name=>'APEX.FS.RANGE_BEGIN'
,p_message_language=>'ja'
,p_message_text=>unistr('\7BC4\56F2\306E\958B\59CB')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112988553202400586)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\304B\3089%1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112988698500400586)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_HI'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\3092\4E0A\56DE\308B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112988740674400586)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_LO'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\3092\4E0B\56DE\308B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112944632930400554)
,p_name=>'APEX.FS.RANGE_END'
,p_message_language=>'ja'
,p_message_text=>unistr('\7BC4\56F2\306E\7D42\4E86')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113007444595400600)
,p_name=>'APEX.FS.RANGE_LOV_ITEM_INVALID'
,p_message_language=>'ja'
,p_message_text=>unistr('\7BC4\56F2\30D5\30A1\30BB\30C3\30C8%0\306ELOV\30A2\30A4\30C6\30E0#%2 ("%1")\304C\7121\52B9\3067\3059("|"\30BB\30D1\30EC\30FC\30BF\304C\3042\308A\307E\305B\3093)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112988982472400587)
,p_name=>'APEX.FS.RANGE_MANUAL_NOT_SUPPORTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\7BC4\56F2\30D5\30A1\30BB\30C3\30C8%0\306E\624B\52D5\5165\529B\306F\3001\5217\304CDATE\307E\305F\306FTIMESTAMP\3067\3042\308B\305F\3081\73FE\5728\30B5\30DD\30FC\30C8\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112988264726400586)
,p_name=>'APEX.FS.RANGE_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\304B\3089')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112872055155400499)
,p_name=>'APEX.FS.REMOVE_CHART'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30E9\30D5\306E\524A\9664')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112941187380400551)
,p_name=>'APEX.FS.RESET'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30BB\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112987675749400586)
,p_name=>'APEX.FS.SEARCH_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112987595262400585)
,p_name=>'APEX.FS.SEARCH_PLACEHOLDER'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112988433370400586)
,p_name=>'APEX.FS.SELECT_PLACEHOLDER'
,p_message_language=>'ja'
,p_message_text=>unistr('- \9078\629E -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112871892236400499)
,p_name=>'APEX.FS.SHOW_CHART'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\306E\8868\793A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112988051444400586)
,p_name=>'APEX.FS.SHOW_LESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C11\306A\304F\8868\793A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112988144698400586)
,p_name=>'APEX.FS.SHOW_MORE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3055\3089\306B\8868\793A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112988377803400586)
,p_name=>'APEX.FS.STAR_RATING_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\661F\4EE5\4E0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112946042132400555)
,p_name=>'APEX.FS.SUGGESTIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30EB\30BF\5019\88DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112989167683400587)
,p_name=>'APEX.FS.TEXT_FIELD_ONLY_FOR_NUMBER_COLUMNS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8\30FB\30D5\30A3\30FC\30EB\30C9\30FB\30D5\30A1\30BB\30C3\30C8%0\306F\3001\73FE\5728NUMBER\5217\3067\306E\307F\30B5\30DD\30FC\30C8\3055\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112862262868400492)
,p_name=>'APEX.FS.TOTAL_ROW_COUNT_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5408\8A08\884C\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113005210227400598)
,p_name=>'APEX.FS.UNSUPPORTED_DATA_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\30C7\30FC\30BF\578B(%1)\306F\3001\30D5\30A1\30BB\30C3\30C8\691C\7D22\3067\30B5\30DD\30FC\30C8\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112997132765400592)
,p_name=>'APEX.GO_TO_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC\306B\79FB\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112954784742400561)
,p_name=>'APEX.GV.AGG_CONTEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\96C6\8A08\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112962343130400567)
,p_name=>'APEX.GV.BREAK_COLLAPSE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30C8\30ED\30FC\30EB\30FB\30D6\30EC\30FC\30AF\3092\9589\3058\308B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112954891749400561)
,p_name=>'APEX.GV.BREAK_CONTEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30C8\30ED\30FC\30EB\30FB\30D6\30EC\30FC\30AF\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112962219163400567)
,p_name=>'APEX.GV.BREAK_EXPAND'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30C8\30ED\30FC\30EB\30FB\30D6\30EC\30FC\30AF\3092\958B\304F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113040929282400624)
,p_name=>'APEX.GV.COLUMN_CONTEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217%0\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112962058377400566)
,p_name=>'APEX.GV.DELETED_COUNT'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\884C\524A\9664\3055\308C\307E\3057\305F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113032440220400618)
,p_name=>'APEX.GV.DUP_REC_ID'
,p_message_language=>'ja'
,p_message_text=>unistr('\91CD\8907\30A2\30A4\30C7\30F3\30C6\30A3\30C6\30A3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112951785227400559)
,p_name=>'APEX.GV.FIRST_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\521D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112955058557400561)
,p_name=>'APEX.GV.GROUP_CONTEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30EB\30FC\30D7\30FB\30D8\30C3\30C0\30FC\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112954919182400561)
,p_name=>'APEX.GV.HEADER_CONTEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D8\30C3\30C0\30FC\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112951889776400559)
,p_name=>'APEX.GV.LAST_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5F8C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112971831766400574)
,p_name=>'APEX.GV.LOAD_MORE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3055\3089\306B\884C\3092\30ED\30FC\30C9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112951592262400559)
,p_name=>'APEX.GV.NEXT_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112955131496400561)
,p_name=>'APEX.GV.PAGE_RANGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\884C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112951912840400559)
,p_name=>'APEX.GV.PAGE_RANGE_XY'
,p_message_language=>'ja'
,p_message_text=>'%0 - %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112952081879400559)
,p_name=>'APEX.GV.PAGE_RANGE_XYZ'
,p_message_language=>'ja'
,p_message_text=>unistr('%2\4EF6\4E2D%0-%1\4EF6\76EE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113008088950400600)
,p_name=>'APEX.GV.PAGE_SELECTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306E\9078\629E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112951656850400559)
,p_name=>'APEX.GV.PREV_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\524D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113032279102400618)
,p_name=>'APEX.GV.ROW_ADDED'
,p_message_language=>'ja'
,p_message_text=>unistr('\8FFD\52A0\6E08')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113032325446400618)
,p_name=>'APEX.GV.ROW_CHANGED'
,p_message_language=>'ja'
,p_message_text=>unistr('\5909\66F4\6E08')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113040761419400624)
,p_name=>'APEX.GV.ROW_COLUMN_CONTEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C%0\3001\5217%1\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113040875224400624)
,p_name=>'APEX.GV.ROW_CONTEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C%0\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113032149352400618)
,p_name=>'APEX.GV.ROW_DELETED'
,p_message_language=>'ja'
,p_message_text=>unistr('\524A\9664\6E08')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112955349114400562)
,p_name=>'APEX.GV.ROW_HEADER'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\30D8\30C3\30C0\30FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112950977410400558)
,p_name=>'APEX.GV.SELECTION_CELL_COUNT'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\30BB\30EB\304C\9078\629E\3055\308C\307E\3057\305F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112952142196400559)
,p_name=>'APEX.GV.SELECTION_COUNT'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\884C\304C\9078\629E\3055\308C\307E\3057\305F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112992486930400589)
,p_name=>'APEX.GV.SELECT_ALL'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\9078\629E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112962120285400567)
,p_name=>'APEX.GV.SELECT_PAGE_N'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8%0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112955286854400561)
,p_name=>'APEX.GV.SELECT_ROW'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\306E\9078\629E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112955416728400562)
,p_name=>'APEX.GV.SORTED_ASCENDING'
,p_message_language=>'ja'
,p_message_text=>unistr('\6607\9806\30BD\30FC\30C8\6E08%0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112955563582400562)
,p_name=>'APEX.GV.SORTED_DESCENDING'
,p_message_language=>'ja'
,p_message_text=>unistr('\964D\9806\30BD\30FC\30C8\6E08%0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112951066470400558)
,p_name=>'APEX.GV.SORT_ASCENDING'
,p_message_language=>'ja'
,p_message_text=>unistr('\6607\9806\30BD\30FC\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112951366844400559)
,p_name=>'APEX.GV.SORT_ASCENDING_ORDER'
,p_message_language=>'ja'
,p_message_text=>unistr('\6607\9806\30BD\30FC\30C8 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112951179314400558)
,p_name=>'APEX.GV.SORT_DESCENDING'
,p_message_language=>'ja'
,p_message_text=>unistr('\964D\9806\30BD\30FC\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112951443787400559)
,p_name=>'APEX.GV.SORT_DESCENDING_ORDER'
,p_message_language=>'ja'
,p_message_text=>unistr('\964D\9806\30BD\30FC\30C8 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112951295786400559)
,p_name=>'APEX.GV.SORT_OFF'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BD\30FC\30C8\3057\306A\3044')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112961919762400566)
,p_name=>'APEX.GV.TOTAL_PAGES'
,p_message_language=>'ja'
,p_message_text=>unistr('\5408\8A08%0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112888300338400511)
,p_name=>'APEX.HTTP.REQUEST_FAILED'
,p_message_language=>'ja'
,p_message_text=>unistr('"%0"\3078\306EHTTP\30EA\30AF\30A8\30B9\30C8\304C\5931\6557\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113029619776400616)
,p_name=>'APEX.ICON_LIST.GRID_DIM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30EA\30C3\30C9\9078\629E\30EA\30B9\30C8%0\5217\306E%1\884C\3002\77E2\5370\30AD\30FC\3092\4F7F\7528\3057\307E\3059')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112961807740400566)
,p_name=>'APEX.ICON_LIST.LIST_DIM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8%0\884C\3092\9078\629E\3057\307E\3059\3002\77E2\5370\30AD\30FC\3092\4F7F\7528\3057\3066\304F\3060\3055\3044')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113040527180400624)
,p_name=>'APEX.IG.ACC_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5BFE\8A71\30B0\30EA\30C3\30C9%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112948673477400557)
,p_name=>'APEX.IG.ACTIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112949610448400557)
,p_name=>'APEX.IG.ADD'
,p_message_language=>'ja'
,p_message_text=>unistr('\8FFD\52A0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112949557695400557)
,p_name=>'APEX.IG.ADD_ROW'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\306E\8FFD\52A0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113034014078400619)
,p_name=>'APEX.IG.AGGREGATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\96C6\8A08')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113019597533400608)
,p_name=>'APEX.IG.AGGREGATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\96C6\8A08')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113021244234400610)
,p_name=>'APEX.IG.ALL'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112977642061400578)
,p_name=>'APEX.IG.ALL_TEXT_COLUMNS'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\306E\30C6\30AD\30B9\30C8\5217')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112978831980400579)
,p_name=>'APEX.IG.ALTERNATIVE'
,p_message_language=>'ja'
,p_message_text=>unistr('\4EE3\66FF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112979914261400580)
,p_name=>'APEX.IG.AND'
,p_message_language=>'ja'
,p_message_text=>unistr('\304A\3088\3073')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112999327540400594)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5225\3005\306B\30AB\30A6\30F3\30C8(\6982\6570)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113035076157400620)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT_OVERALL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5225\3005\306B\30AB\30A6\30F3\30C8(\5168\4F53\306E\6982\6570)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113018166874400607)
,p_name=>'APEX.IG.AREA'
,p_message_language=>'ja'
,p_message_text=>unistr('\9762')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113020052061400609)
,p_name=>'APEX.IG.ASCENDING'
,p_message_language=>'ja'
,p_message_text=>unistr('\6607\9806')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112978979832400579)
,p_name=>'APEX.IG.AUTHORIZATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\53EF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113034129442400619)
,p_name=>'APEX.IG.AUTO'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\52D5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112999786116400594)
,p_name=>'APEX.IG.AVG'
,p_message_language=>'ja'
,p_message_text=>unistr('\5E73\5747')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113034701533400620)
,p_name=>'APEX.IG.AVG_OVERALL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5168\4F53\306E\5E73\5747')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113017621486400607)
,p_name=>'APEX.IG.AXIS_LABEL_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB\306E\8EF8\30BF\30A4\30C8\30EB')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113017871391400607)
,p_name=>'APEX.IG.AXIS_VALUE_DECIMAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C0F\6570\4F4D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113017742255400607)
,p_name=>'APEX.IG.AXIS_VALUE_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024\306E\8EF8\30BF\30A4\30C8\30EB')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113023800940400612)
,p_name=>'APEX.IG.BACKGROUND_COLOR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D0\30C3\30AF\30B0\30E9\30A6\30F3\30C9\30FB\30AB\30E9\30FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113018293188400608)
,p_name=>'APEX.IG.BAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\68D2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112974282048400576)
,p_name=>'APEX.IG.BETWEEN'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\9593\306B\3042\308B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113025039366400612)
,p_name=>'APEX.IG.BOTH'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E21\65B9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113018303133400608)
,p_name=>'APEX.IG.BUBBLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D0\30D6\30EB')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112949802911400558)
,p_name=>'APEX.IG.CANCEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\53D6\6D88')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112979805422400580)
,p_name=>'APEX.IG.CASE_SENSITIVE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5927/\5C0F\6587\5B57\3092\533A\5225')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113035671452400620)
,p_name=>'APEX.IG.CASE_SENSITIVE_WITH_BRACKETS'
,p_message_language=>'ja'
,p_message_text=>unistr('(\5927/\5C0F\6587\5B57\3092\533A\5225)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113006509391400599)
,p_name=>'APEX.IG.CHANGES_SAVED'
,p_message_language=>'ja'
,p_message_text=>unistr('\5909\66F4\304C\4FDD\5B58\3055\308C\307E\3057\305F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112950211887400558)
,p_name=>'APEX.IG.CHANGE_VIEW'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\306E\5909\66F4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112980911630400581)
,p_name=>'APEX.IG.CHART'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112977444868400578)
,p_name=>'APEX.IG.CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'ja'
,p_message_text=>unistr('\554F\5408\305B\306F\30011\30C1\30E3\30FC\30C8\5F53\305F\308A\306E\6700\5927\30C7\30FC\30BF\30FB\30DD\30A4\30F3\30C8\6570\3067\3042\308B%0\3092\8D85\3048\3066\3044\307E\3059\3002\30D5\30A3\30EB\30BF\3092\9069\7528\3057\3066\3001\30D9\30FC\30B9\554F\5408\305B\306E\30EC\30B3\30FC\30C9\6570\3092\524A\6E1B\3057\3066\304F\3060\3055\3044\3002')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112948580583400557)
,p_name=>'APEX.IG.CHART_VIEW'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\30FB\30D3\30E5\30FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112955862757400562)
,p_name=>'APEX.IG.CLEAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30EA\30A2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113017116001400607)
,p_name=>'APEX.IG.CLOSE_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\9589\3058\308B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113024016817400612)
,p_name=>'APEX.IG.COLORS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30E9\30FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113000142227400595)
,p_name=>'APEX.IG.COLOR_PREVIEW'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30EC\30D3\30E5\30FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112979258283400579)
,p_name=>'APEX.IG.COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112948717214400557)
,p_name=>'APEX.IG.COLUMNS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113025838980400613)
,p_name=>'APEX.IG.COLUMN_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\306E\76EE\7684')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112979326542400579)
,p_name=>'APEX.IG.COMPLEX'
,p_message_language=>'ja'
,p_message_text=>unistr('\8907\5408')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112948972992400557)
,p_name=>'APEX.IG.COMPUTE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A08\7B97')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112974880183400576)
,p_name=>'APEX.IG.CONTAINS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\3092\542B\3080')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112981148024400581)
,p_name=>'APEX.IG.CONTROL_BREAK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30C8\30ED\30FC\30EB\30FB\30D6\30EC\30FC\30AF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112955616012400562)
,p_name=>'APEX.IG.COPY_CB'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30EA\30C3\30D7\30DC\30FC\30C9\306B\30B3\30D4\30FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112955791287400562)
,p_name=>'APEX.IG.COPY_DOWN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30D4\30FC\30FB\30C0\30A6\30F3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112999103788400594)
,p_name=>'APEX.IG.COUNT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30A6\30F3\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112999236191400594)
,p_name=>'APEX.IG.COUNT_DISTINCT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5225\3005\306B\30AB\30A6\30F3\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113034920199400620)
,p_name=>'APEX.IG.COUNT_DISTINCT_OVERALL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5225\3005\306B\30AB\30A6\30F3\30C8(\5168\4F53)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113034829197400620)
,p_name=>'APEX.IG.COUNT_OVERALL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5168\4EF6\6570')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113032519420400618)
,p_name=>'APEX.IG.CREATE_X'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306E\4F5C\6210')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112977810506400578)
,p_name=>'APEX.IG.DATA'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113025690859400613)
,p_name=>'APEX.IG.DATA_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\578B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113025271805400613)
,p_name=>'APEX.IG.DATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5\4ED8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113006310669400599)
,p_name=>'APEX.IG.DATE_INVALID_VALUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5\4ED8\5024\304C\7121\52B9\3067\3059')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112975532987400577)
,p_name=>'APEX.IG.DAYS'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112978571672400579)
,p_name=>'APEX.IG.DEFAULT_SETTINGS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\8A2D\5B9A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112978329040400579)
,p_name=>'APEX.IG.DEFAULT_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\30FB\30BF\30A4\30D7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112949752363400558)
,p_name=>'APEX.IG.DELETE'
,p_message_language=>'ja'
,p_message_text=>unistr('\524A\9664')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113026886649400614)
,p_name=>'APEX.IG.DELETE_REPORT_CONFIRM'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30EC\30DD\30FC\30C8\3092\524A\9664\3057\3066\3082\3088\3044\3067\3059\304B\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112982928076400582)
,p_name=>'APEX.IG.DELETE_ROW'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\306E\524A\9664')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112981777545400581)
,p_name=>'APEX.IG.DELETE_ROWS'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\306E\524A\9664')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113020121892400609)
,p_name=>'APEX.IG.DESCENDING'
,p_message_language=>'ja'
,p_message_text=>unistr('\964D\9806')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112980675001400580)
,p_name=>'APEX.IG.DETAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A73\7D30')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112948273286400556)
,p_name=>'APEX.IG.DETAIL_VIEW'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A73\7D30\30D3\30E5\30FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113008848774400601)
,p_name=>'APEX.IG.DIRECTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B9\5411')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112980307242400580)
,p_name=>'APEX.IG.DISABLED'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112974974898400576)
,p_name=>'APEX.IG.DOES_NOT_CONTAIN'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\3092\542B\307E\306A\3044')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112975116766400576)
,p_name=>'APEX.IG.DOES_NOT_START_WITH'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\3067\59CB\307E\3089\306A\3044')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113018472304400608)
,p_name=>'APEX.IG.DONUT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C9\30FC\30CA\30C4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112981366813400581)
,p_name=>'APEX.IG.DOWNLOAD'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C0\30A6\30F3\30ED\30FC\30C9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112880056412400505)
,p_name=>'APEX.IG.DOWNLOAD_DATA_ONLY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\306E\307F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113027832732400615)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F8\5F0F\306E\9078\629E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112892645792400515)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT_NOT_ENABLED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C0\30A6\30F3\30ED\30FC\30C9\66F8\5F0F%0\306F\6709\52B9\5316\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113020865152400609)
,p_name=>'APEX.IG.DUPLICATE_AGGREGATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\91CD\8907\96C6\8A08')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113020979857400609)
,p_name=>'APEX.IG.DUPLICATE_CONTROLBREAK'
,p_message_language=>'ja'
,p_message_text=>unistr('\91CD\8907\30B3\30F3\30C8\30ED\30FC\30EB\30FB\30D6\30EC\30FC\30AF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112982869211400582)
,p_name=>'APEX.IG.DUPLICATE_ROW'
,p_message_language=>'ja'
,p_message_text=>unistr('\91CD\8907\884C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112981648568400581)
,p_name=>'APEX.IG.DUPLICATE_ROWS'
,p_message_language=>'ja'
,p_message_text=>unistr('\91CD\8907\884C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112949330179400557)
,p_name=>'APEX.IG.EDIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7DE8\96C6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113019930819400609)
,p_name=>'APEX.IG.EDIT_CHART'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\306E\7DE8\96C6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113031413195400617)
,p_name=>'APEX.IG.EDIT_GROUP_BY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30EB\30FC\30D7\5316\306E\7DE8\96C6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113027469997400614)
,p_name=>'APEX.IG.EMAIL_BCC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30E9\30A4\30F3\30C9\30FB\30B3\30D4\30FC(bcc)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113027683097400614)
,p_name=>'APEX.IG.EMAIL_BODY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E1\30C3\30BB\30FC\30B8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113027397541400614)
,p_name=>'APEX.IG.EMAIL_CC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30D4\30FC(cc)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113027068885400614)
,p_name=>'APEX.IG.EMAIL_SENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\304C\9001\4FE1\3055\308C\307E\3057\305F\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113027585567400614)
,p_name=>'APEX.IG.EMAIL_SUBJECT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4EF6\540D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113027294624400614)
,p_name=>'APEX.IG.EMAIL_TO'
,p_message_language=>'ja'
,p_message_text=>unistr('\53D7\4FE1\8005(to)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112980053337400580)
,p_name=>'APEX.IG.ENABLED'
,p_message_language=>'ja'
,p_message_text=>unistr('\6709\52B9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112973225774400575)
,p_name=>'APEX.IG.EQUALS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\3068\7B49\3057\3044')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113026404406400613)
,p_name=>'APEX.IG.EXAMPLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F8B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112980194003400580)
,p_name=>'APEX.IG.EXPRESSION'
,p_message_language=>'ja'
,p_message_text=>unistr('\5F0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113026304555400613)
,p_name=>'APEX.IG.FD_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112992340584400589)
,p_name=>'APEX.IG.FILE_PREPARED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\304C\6E96\5099\3055\308C\307E\3057\305F\3002\30C0\30A6\30F3\30ED\30FC\30C9\3092\958B\59CB\3057\3066\3044\307E\3059\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112955913981400562)
,p_name=>'APEX.IG.FILL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30EB')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112957016638400563)
,p_name=>'APEX.IG.FILL_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30EB\306E\9078\629E\306B\4F7F\7528')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112956956941400563)
,p_name=>'APEX.IG.FILL_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30EB\306E\9078\629E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112948873197400557)
,p_name=>'APEX.IG.FILTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30EB\30BF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112979449387400580)
,p_name=>'APEX.IG.FILTERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30EB\30BF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113034448998400619)
,p_name=>'APEX.IG.FILTER_WITH_DOTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30EB\30BF...')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113020328077400609)
,p_name=>'APEX.IG.FIRST'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\521D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112949090629400557)
,p_name=>'APEX.IG.FLASHBACK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30E9\30C3\30B7\30E5\30D0\30C3\30AF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112977919412400578)
,p_name=>'APEX.IG.FORMAT'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F8\5F0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113024922241400612)
,p_name=>'APEX.IG.FORMATMASK'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F8\5F0F\30DE\30B9\30AF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113026733526400614)
,p_name=>'APEX.IG.FORMAT_CSV'
,p_message_language=>'ja'
,p_message_text=>'CSV'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113026661583400614)
,p_name=>'APEX.IG.FORMAT_HTML'
,p_message_language=>'ja'
,p_message_text=>'HTML'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112939492423400550)
,p_name=>'APEX.IG.FORMAT_PDF'
,p_message_language=>'ja'
,p_message_text=>'PDF'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112878714187400504)
,p_name=>'APEX.IG.FORMAT_XLSX'
,p_message_language=>'ja'
,p_message_text=>'Excel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112982534492400582)
,p_name=>'APEX.IG.FREEZE'
,p_message_language=>'ja'
,p_message_text=>unistr('\56FA\5B9A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112980219750400580)
,p_name=>'APEX.IG.FUNCTIONS_AND_OPERATORS'
,p_message_language=>'ja'
,p_message_text=>unistr('\95A2\6570\3068\6F14\7B97\5B50')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113018526324400608)
,p_name=>'APEX.IG.FUNNEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30F3\30CD\30EB')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112999085780400594)
,p_name=>'APEX.IG.GO'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9F\884C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112973804117400575)
,p_name=>'APEX.IG.GREATER_THAN'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\3088\308A\5927\304D\3044')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112973937998400576)
,p_name=>'APEX.IG.GREATER_THAN_OR_EQUALS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\4EE5\4E0A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112980583157400580)
,p_name=>'APEX.IG.GRID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30EA\30C3\30C9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112948005309400556)
,p_name=>'APEX.IG.GRID_VIEW'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30EA\30C3\30C9\30FB\30D3\30E5\30FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113021107555400610)
,p_name=>'APEX.IG.GROUP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30EB\30FC\30D7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112980722354400581)
,p_name=>'APEX.IG.GROUP_BY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30EB\30FC\30D7\5316')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112948387007400556)
,p_name=>'APEX.IG.GROUP_BY_VIEW'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30EB\30FC\30D7\5316\30D3\30E5\30FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113025501156400613)
,p_name=>'APEX.IG.HD_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6761\4EF6\30BF\30A4\30D7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113024461203400612)
,p_name=>'APEX.IG.HEADING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D8\30C3\30C0\30FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113024631162400612)
,p_name=>'APEX.IG.HEADING_ALIGN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D8\30C3\30C0\30FC\306E\4F4D\7F6E\5408\305B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113034397653400619)
,p_name=>'APEX.IG.HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D8\30EB\30D7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113029889753400616)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\5BFE\8A71\30B0\30EA\30C3\30C9\5185\3067\30C7\30FC\30BF\3092\76F4\63A5\633F\5165\3001\66F4\65B0\304A\3088\3073\524A\9664\3067\304D\307E\3059\3002</p>'),
'',
unistr('<p>\65B0\3057\3044\884C\3092\633F\5165\3059\308B\306B\306F\3001\300C\884C\306E\8FFD\52A0\300D\30DC\30BF\30F3\3092\30AF\30EA\30C3\30AF\3057\307E\3059\3002</p>'),
'',
unistr('<p>\65E2\5B58\306E\30C7\30FC\30BF\3092\7DE8\96C6\3059\308B\306B\306F\3001\7279\5B9A\306E\30BB\30EB\3092\30C0\30D6\30EB\30AF\30EA\30C3\30AF\3057\307E\3059\3002\7DE8\96C6\4F5C\696D\306E\7BC4\56F2\304C\5E83\3044\5834\5408\3001\300C\7DE8\96C6\300D\3092\30AF\30EA\30C3\30AF\3057\3066\7DE8\96C6\30E2\30FC\30C9\306B\5165\308A\307E\3059\3002\7DE8\96C6\30E2\30FC\30C9\3067\306F\30011\56DE\30AF\30EA\30C3\30AF\3059\308B\304B\30AD\30FC\30DC\30FC\30C9\3092\4F7F\7528\3059\308B\3053\3068\3067\3001\7279\5B9A\306E\30BB\30EB\3092\7DE8\96C6\3067\304D\307E\3059\3002</p>'),
'',
unistr('<p>\300C\5909\66F4\300D\30E1\30CB\30E5\30FC\3092\4F7F\7528\3059\308B\3068\3001\884C\3092\8907\88FD\304A\3088\3073\524A\9664\3067\304D\307E\3059\3002\300C\5909\66F4\300D\30E1\30CB\30E5\30FC\3092\6709\52B9\306B\3059\308B\306B\306F\3001\30C1\30A7\30C3\30AF\30FB\30DC\30C3\30AF\30B9\3092\4F7F\7528\3057\30661\3064\4EE5\4E0A\306E\884C\3092\9078\629E\3057\307E\3059\3002</p>'),
'',
unistr('<p>\9078\629E\3057\305F\884C\3092\8907\88FD\3059\308B\306B\306F\3001\300C\5909\66F4\300D\30E1\30CB\30E5\30FC\3092\30AF\30EA\30C3\30AF\3057\3066\300C\884C\306E\8907\88FD\300D\3092\9078\629E\3057\307E\3059\3002\9078\629E\3057\305F\884C\3092\524A\9664\3059\308B\306B\306F\3001\300C\5909\66F4\300D\30E1\30CB\30E5\30FC\3092\30AF\30EA\30C3\30AF\3057\3066\300C\884C\306E\524A\9664\300D\3092\9078\629E\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113031999836400618)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING_HEADING'
,p_message_language=>'ja'
,p_message_text=>unistr('\7DE8\96C6\6A5F\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113032062606400618)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5BFE\8A71\30B0\30EA\30C3\30C9\306B\306F\3001\691C\7D22\304A\3088\3073\30AB\30B9\30BF\30DE\30A4\30BA\53EF\80FD\306A\30EC\30DD\30FC\30C8\306E\30C7\30FC\30BF\306E\30BB\30C3\30C8\304C\8868\793A\3055\308C\307E\3059\3002\8FD4\3055\308C\308B\30EC\30B3\30FC\30C9\3092\5236\9650\3059\308B\69D8\3005\306A\64CD\4F5C\3092\5B9F\884C\3057\3001\30C7\30FC\30BF\306E\8868\793A\65B9\6CD5\3092\5909\66F4\3067\304D\307E\3059\3002</p>'),
'',
unistr('<p>\300C\691C\7D22\300D\30D5\30A3\30FC\30EB\30C9\3092\4F7F\7528\3057\3066\3001\8FD4\3055\308C\308B\30EC\30B3\30FC\30C9\3092\30D5\30A3\30EB\30BF\3057\307E\3059\3002\300C\30A2\30AF\30B7\30E7\30F3\300D\3092\30AF\30EA\30C3\30AF\3057\3066\30EC\30DD\30FC\30C8\30FB\30EC\30A4\30A2\30A6\30C8\3092\5909\66F4\3059\308B\305F\3081\306E\69D8\3005\306A\30AA\30D7\30B7\30E7\30F3\306B\30A2\30AF\30BB\30B9\3057\305F\308A\3001\8868\793A\5217\306E\5217\30D8\30C3\30C0\30FC\30FB\30E1\30CB\30E5\30FC\3092\4F7F\7528\3057\307E\3059\3002</p>'),
'',
unistr('<p>\300C\30EC\30DD\30FC\30C8\8A2D\5B9A\300D\3092\4F7F\7528\3057\3066\3001\30EC\30DD\30FC\30C8\306B\5BFE\3059\308B\30AB\30B9\30BF\30DE\30A4\30BA\3092\4FDD\5B58\3057\307E\3059\3002\30EC\30DD\30FC\30C8\304B\3089\5916\90E8\30D5\30A1\30A4\30EB\306B\30C7\30FC\30BF\3092\30C0\30A6\30F3\30ED\30FC\30C9\3057\305F\308A\3001\81EA\5206\3084\4ED6\306E\30E6\30FC\30B6\30FC\306B\30C7\30FC\30BF\3092\96FB\5B50\30E1\30FC\30EB\3067\9001\4FE1\3059\308B\3053\3068\3082\3067\304D\307E\3059\3002</p>'),
'',
unistr('<p>\3055\3089\306B\5B66\7FD2\3059\308B\306B\306F\3001<em>\300EOracle Application Express\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\30FB\30AC\30A4\30C9\300F</em>\306E\5BFE\8A71\30B0\30EA\30C3\30C9\306E\4F7F\7528\306B\95A2\3059\308B\9805\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113031720543400617)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO_HEADING'
,p_message_language=>'ja'
,p_message_text=>unistr('\6982\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113029722350400616)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\7D44\8FBC\307F\6A5F\80FD\3092\4F7F\7528\3057\3066\3001\30C7\30FC\30BF\3092\69D8\3005\306A\65B9\6CD5\3067\8868\793A\3059\308B\3088\3046\306B\5BFE\8A71\30B0\30EA\30C3\30C9\3092\30AB\30B9\30BF\30DE\30A4\30BA\3067\304D\307E\3059\3002</p>'),
'',
unistr('<p>\5217\30D8\30C3\30C0\30FC\30FB\30E1\30CB\30E5\30FC\307E\305F\306F\300C\30A2\30AF\30B7\30E7\30F3\300D\30E1\30CB\30E5\30FC\3092\4F7F\7528\3057\3066\3001\8868\793A\3059\308B\5217\3001\305D\306E\9806\5E8F\304A\3088\3073\56FA\5B9A\5217\3092\6307\5B9A\3057\307E\3059\3002\69D8\3005\306A\30C7\30FC\30BF\30FB\30D5\30A3\30EB\30BF\3092\5B9A\7FA9\3057\3066\3001\8FD4\3055\308C\308B\30C7\30FC\30BF\3092\30BD\30FC\30C8\3059\308B\3053\3068\3082\3067\304D\307E\3059\3002</p>'),
'',
unistr('<p>\300C\691C\7D22\300D\30D5\30A3\30FC\30EB\30C9\306E\6A2A\306B\3042\308B\300C\8868\793A\300D\30DC\30BF\30F3\3092\4F7F\7528\3059\308B\3068\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\958B\767A\8005\304C\5B9A\7FA9\3057\305F\4ED6\306E\30C7\30FC\30BF\30FB\30D3\30E5\30FC\306B\30A2\30AF\30BB\30B9\3067\304D\307E\3059\3002\30C1\30E3\30FC\30C8\3092\4F5C\6210\3057\305F\308A\3001\65E2\5B58\306E\30C1\30E3\30FC\30C8\3092\8868\793A\3059\308B\3053\3068\3082\53EF\80FD\3067\3059\3002</p>  '),
'',
unistr('<p><em>\30CE\30FC\30C8: \5BFE\8A71\30B0\30EA\30C3\30C9\30FB\30C0\30A4\30A2\30ED\30B0\306E<strong>\300C\30D8\30EB\30D7\300D</strong>\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\9078\629E\3057\305F\6A5F\80FD\306B\95A2\3059\308B\8A73\7D30\60C5\5831\3092\5165\624B\3067\304D\307E\3059\3002</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113031809423400617)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING_HEADING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\6A5F\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112981501112400581)
,p_name=>'APEX.IG.HELP.ACTIONS_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5BFE\8A71\30B0\30EA\30C3\30C9\306E\30D8\30EB\30D7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113028697030400615)
,p_name=>'APEX.IG.HELP.AGGREGATE'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30C0\30A4\30A2\30ED\30B0\3092\4F7F\7528\3057\3066\3001\5217\3092\96C6\8A08\3057\307E\3059\3002\96C6\8A08\3055\308C\305F\5024\306F\3001\30C7\30FC\30BF\306E\4E00\756A\4E0B\306B(\30B3\30F3\30C8\30ED\30FC\30EB\30FB\30D6\30EC\30FC\30AF\304C\5B9A\7FA9\3055\308C\3066\3044\308B\5834\5408\306F\5404\30D6\30EC\30FC\30AF\306E\4E00\756A\4E0B\306B)\8868\793A\3055\308C\307E\3059\3002</p>'),
'',
unistr('<p><strong>\96C6\8A08\30EA\30B9\30C8</strong><br>'),
unistr('\300C\96C6\8A08\30EA\30B9\30C8\300D\306B\306F\3001\5B9A\7FA9\6E08\306E\96C6\8A08\304C\8868\793A\3055\308C\307E\3059\3002\65E2\5B58\306E\96C6\8A08\3092\7121\52B9\5316\3059\308B\306B\306F\3001\305D\308C\3092\9078\629E\89E3\9664\3057\307E\3059\3002<br>'),
unistr('\300C\8FFD\52A0\300D( &plus; )\3092\30AF\30EA\30C3\30AF\3059\308B\3068\65B0\3057\3044\96C6\8A08\304C\4F5C\6210\3055\308C\3001\300C\524A\9664\300D( &minus; )\3092\30AF\30EA\30C3\30AF\3059\308B\3068\65E2\5B58\306E\96C6\8A08\304C\524A\9664\3055\308C\307E\3059\3002</p>'),
'',
unistr('<p><strong>\96C6\8A08\8A2D\5B9A</strong><br>'),
unistr('\53F3\5074\306E\30D5\30A9\30FC\30E0\3092\4F7F\7528\3057\3066\96C6\8A08\3092\5B9A\7FA9\3057\307E\3059\3002<br>'),
unistr('\5217\540D\3068\96C6\8A08\30BF\30A4\30D7\3092\9078\629E\3057\307E\3059\3002<br>'),
unistr('\30AA\30D7\30B7\30E7\30F3\3067\3001\96C6\8A08\306E\30C4\30FC\30EB\30C1\30C3\30D7\3092\5165\529B\3057\307E\3059\3002<br>'),
unistr('\30B3\30F3\30C8\30ED\30FC\30EB\30FB\30D6\30EC\30FC\30AF\3092\5B9A\7FA9\3057\3066\3044\308B\5834\5408\3001<strong>\300C\5168\4F53\306E\5024\306E\8868\793A\300D</strong>\3092\9078\629E\3059\308B\3068\3001\5168\4F53\306E\5E73\5747\3001\5408\8A08\307E\305F\306F\985E\4F3C\5024\304C\30C7\30FC\30BF\306E\4E00\756A\4E0B\306B\8868\793A\3055\308C\307E\3059\3002</p>'),
'',
unistr('<p><em>\30CE\30FC\30C8: \300C\96C6\8A08\300D\30C0\30A4\30A2\30ED\30B0\306B\306F\3001\300C\30A2\30AF\30B7\30E7\30F3\300D\30E1\30CB\30E5\30FC\3067\30A2\30AF\30BB\30B9\3059\308B\304B\3001\5217\30D8\30C3\30C0\30FC\3068\5408\8A08( &sum; )\3092\30AF\30EA\30C3\30AF\3057\3066\30A2\30AF\30BB\30B9\3057\307E\3059\3002</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113030828278400617)
,p_name=>'APEX.IG.HELP.AGGREGATE_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\96C6\8A08\306E\30D8\30EB\30D7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113029355310400616)
,p_name=>'APEX.IG.HELP.CHART'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30C0\30A4\30A2\30ED\30B0\3092\4F7F\7528\3057\3066\3001\5225\306E\30C7\30FC\30BF\30FB\30D3\30E5\30FC\3068\3057\3066\8868\793A\3055\308C\308B\30C1\30E3\30FC\30C8\3092\5B9A\7FA9\3057\307E\3059\3002<br>'),
unistr('\30C1\30E3\30FC\30C8\30FB\30BF\30A4\30D7\304A\3088\3073\30C1\30E3\30FC\30C8\5C5E\6027\3092\9078\629E\3057\307E\3059\3002</p>'),
unistr('<p><strong>\30C1\30E3\30FC\30C8\5C5E\6027</strong></br>'),
unistr('\4F7F\7528\53EF\80FD\306A\30C1\30E3\30FC\30C8\5C5E\6027\306F\3001\30C1\30E3\30FC\30C8\30FB\30BF\30A4\30D7\306B\5FDC\3058\3066\7570\306A\308A\307E\3059\3002</p>'),
'<p>',
'<ul>',
unistr('  <li>\5C5E\6027\306E\5024\3092\542B\3080\5217\3092\9078\629E\3057\307E\3059:'),
'    <ul>',
unistr('      <li>\30E9\30D9\30EB - \5404\30C7\30FC\30BF\30FB\30DD\30A4\30F3\30C8\306E\30C6\30AD\30B9\30C8\3002</li>'),
unistr('      <li>\5024 - \30D7\30ED\30C3\30C8\3059\308B\30C7\30FC\30BF\3002</li>'),
unistr('      <li>\7CFB\5217 - \8907\6570\7CFB\5217\52D5\7684\554F\5408\305B\306E\5B9A\7FA9\7528\3002</li>'),
unistr('      <li>\958B\59CB - 1\65E5\306E\59CB\5024(\682A\4FA1\306E\307F)\3002</li>'),
unistr('      <li>\7D42\4E86 - 1\65E5\306E\7D42\5024(\682A\4FA1\306E\307F)\3002</li>'),
unistr('      <li>\9AD8 - \9AD8\3044\5024(\7BC4\56F2\304A\3088\3073\682A\4FA1\306E\307F)\3002</li>'),
unistr('      <li>\4F4E - \4F4E\3044\5024(\7BC4\56F2\304A\3088\3073\682A\4FA1\306E\307F)\3002</li>'),
unistr('      <li>\30DC\30EA\30E5\30FC\30E0 - 1\65E5\306E\51FA\6765\9AD8(\682A\4FA1\306E\307F)\3002</li>'),
unistr('      <li>\30BF\30FC\30B2\30C3\30C8 - \30BF\30FC\30B2\30C3\30C8\5024\3002(\30D5\30A1\30F3\30CD\30EB\306E\307F)\3002</li>'),
unistr('      <li>X - x\8EF8\5024(\30D0\30D6\30EB\304A\3088\3073\6563\5E03\56F3\306E\307F)\3002</li>'),
unistr('      <li>Y - y\8EF8\5024(\30D0\30D6\30EB\304A\3088\3073\6563\5E03\56F3\306E\307F)\3002</li>'),
unistr('      <li>Z - \68D2\306E\5E45\307E\305F\306F\30D0\30D6\30EB\306E\534A\5F84(\68D2\3001\30D0\30D6\30EB\304A\3088\3073\7BC4\56F2\306E\307F)\3002</li>'),
'    </ul>',
'  </li>',
unistr('  <li>\5411\304D - \7E26\307E\305F\306F\6A2A\3002</li>'),
unistr('  <li>\96C6\8A08 - \30C1\30E3\30FC\30C8\306E\5024\3092\96C6\8A08\3059\308B\65B9\6CD5\3092\9078\629E\3057\307E\3059\3002</li>'),
unistr('  <li>\7A4D\4E0A\3052 - \30C7\30FC\30BF\30FB\30A2\30A4\30C6\30E0\3092\7A4D\307F\4E0A\3052\308B\304B\3069\3046\304B\3092\6307\5B9A\3057\307E\3059\3002</li>'),
unistr('  <li>\30BD\30FC\30C8\57FA\6E96 - \30E9\30D9\30EB\307E\305F\306F\5024\3067\30BD\30FC\30C8\3057\307E\3059\3002'),
'    <ul>',
unistr('      <li>\65B9\5411 - \5024\306E\6607\9806\307E\305F\306F\964D\9806\3067\30BD\30FC\30C8\3057\307E\3059</li>'),
unistr('      <li>null - null\4EE5\5916\306E\5024\3092\6301\3064\30EC\30B3\30FC\30C9\306B\95A2\9023\3057\3066\3001null\5024\3092\6301\3064\30EC\30B3\30FC\30C9\3092\30BD\30FC\30C8\3059\308B\65B9\6CD5\3092\6307\5B9A\3057\307E\3059\3002</li>'),
'    </ul>',
'  </li>',
unistr('  <li>\5C0F\6570\4F4D</li>'),
unistr('  <li>\30E9\30D9\30EB\306E\8EF8\30BF\30A4\30C8\30EB</li>'),
unistr('  <li>\5024\306E\8EF8\30BF\30A4\30C8\30EB</li>'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113031271701400617)
,p_name=>'APEX.IG.HELP.CHART_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\306E\30D8\30EB\30D7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113028385385400615)
,p_name=>'APEX.IG.HELP.COLUMNS'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30C0\30A4\30A2\30ED\30B0\3092\4F7F\7528\3057\3066\3001\3069\306E\5217\3092\3069\306E\9806\5E8F\3067\8868\793A\3059\308B\304B\3092\9078\629E\3057\307E\3059\3002</p>'),
'',
unistr('<p>\5217\3092\9078\629E\89E3\9664\3059\308B\3068\975E\8868\793A\306B\306A\308A\307E\3059\3002<br>'),
unistr('\5217\3092\4E26\3079\66FF\3048\308B\306B\306F\3001\300C\4E0A\3078\300D( &uarr; )\307E\305F\306F\300C\4E0B\3078\300D( &darr; )\3092\30AF\30EA\30C3\30AF\3057\307E\3059\3002<br>'),
unistr('\30C9\30ED\30C3\30D7\30C0\30A6\30F3\30FB\30BB\30EC\30AF\30BF\3092\4F7F\7528\3059\308B\3068\3001\3059\3079\3066\306E\5217\3001\8868\793A\5217\307E\305F\306F\975E\8868\793A\5217\3092\30EA\30B9\30C8\3067\304D\307E\3059\3002</p>'),
'',
unistr('<p>\30AA\30D7\30B7\30E7\30F3\3067\3001\30D5\30A9\30FC\30E0\3092\4F7F\7528\3057\3066\5217\306E\6700\5C0F\5E45\3092\30D4\30AF\30BB\30EB\5358\4F4D\3067\6307\5B9A\3057\307E\3059\3002</p>'),
'',
unistr('<p><em>\30CE\30FC\30C8: \8868\793A\5217\306F\3001\30C9\30E9\30C3\30B0\30FB\30CF\30F3\30C9\30EB(\5217\898B\51FA\3057\306E\958B\59CB\90E8\5206)\3092\30AF\30EA\30C3\30AF\3057\3001\5217\3092\5DE6\53F3\306B\30C9\30E9\30C3\30B0\3059\308B\3053\3068\3067\3082\4E26\3079\66FF\3048\308B\3053\3068\304C\3067\304D\307E\3059\3002\8868\793A\5217\306E\5217\5E45\306F\3001\898B\51FA\3057\306E\9593\306E\5217\30BB\30D1\30EC\30FC\30BF\3092\9078\629E\3057\3066\5DE6\53F3\306B\79FB\52D5\3059\308B\3053\3068\3067\3082\5909\66F4\3067\304D\307E\3059\3002</em></p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113031106708400617)
,p_name=>'APEX.IG.HELP.COLUMNS_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\306E\30D8\30EB\30D7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113028754958400615)
,p_name=>'APEX.IG.HELP.COMPUTE'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30C0\30A4\30A2\30ED\30B0\3092\4F7F\7528\3059\308B\3068\3001\65E2\5B58\306E\5217\306B\5BFE\3057\3066\5B9F\884C\3055\308C\308B\6570\5B66\7684\304A\3088\3073\95A2\6570\7684\8A08\7B97\306B\57FA\3065\3044\3066\8FFD\52A0\306E\5217\3092\5B9A\7FA9\3067\304D\307E\3059\3002</p>'),
'',
unistr('<p><strong>\8A08\7B97\30EA\30B9\30C8</strong><br>'),
unistr('\300C\8A08\7B97\30EA\30B9\30C8\300D\306B\306F\3001\5B9A\7FA9\6E08\306E\8A08\7B97\304C\8868\793A\3055\308C\307E\3059\3002\65E2\5B58\306E\8A08\7B97\3092\7121\52B9\5316\3059\308B\306B\306F\3001\305D\308C\3092\9078\629E\89E3\9664\3057\307E\3059\3002<br>'),
unistr('\300C\8FFD\52A0\300D( &plus; )\3092\30AF\30EA\30C3\30AF\3059\308B\3068\65B0\3057\3044\8A08\7B97\304C\8FFD\52A0\3055\308C\3001\300C\524A\9664\300D( &minus; )\3092\30AF\30EA\30C3\30AF\3059\308B\3068\65E2\5B58\306E\8A08\7B97\304C\524A\9664\3055\308C\307E\3059\3002</p>'),
'',
unistr('<p><strong>\8A08\7B97\8A2D\5B9A</strong><br>'),
unistr('\30D5\30A9\30FC\30E0\3092\4F7F\7528\3057\3066\8A08\7B97\3092\5B9A\7FA9\3057\307E\3059\3002<br>'),
unistr('\30D8\30C3\30C0\30FC\3084\30E9\30D9\30EB\306A\3069\306E\5217\306E\8A73\7D30\3092\5165\529B\3057\3001\4F4D\7F6E\5408\305B\8A2D\5B9A\3092\9078\629E\3057\307E\3059\3002<br> '),
unistr('\300C\5F0F\300D\30C6\30AD\30B9\30C8\9818\57DF\3092\4F7F\7528\3057\3066\3001\8A08\7B97\306E\5217\304A\3088\3073\95A2\9023\30D5\30A1\30F3\30AF\30B7\30E7\30F3\3092\5165\529B\3057\307E\3059\3002<br>'),
unistr('\65B0\3057\3044\5217\306E\9069\5207\306A\30C7\30FC\30BF\578B(\304A\3088\3073\30AA\30D7\30B7\30E7\30F3\306E\66F8\5F0F\30DE\30B9\30AF)\3092\9078\629E\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113030780242400617)
,p_name=>'APEX.IG.HELP.COMPUTE_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A08\7B97\306E\30D8\30EB\30D7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113029026614400615)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30C0\30A4\30A2\30ED\30B0\3092\4F7F\7528\3057\3066\30011\3064\4EE5\4E0A\306E\5217\306B\30B3\30F3\30C8\30ED\30FC\30EB\30FB\30D6\30EC\30FC\30AF\3092\5B9A\7FA9\3057\307E\3059\3002</p>'),
'',
unistr('<p><strong>\30B3\30F3\30C8\30ED\30FC\30EB\30FB\30D6\30EC\30FC\30AF\30FB\30EA\30B9\30C8</strong><br>'),
unistr('\300C\30B3\30F3\30C8\30ED\30FC\30EB\30FB\30D6\30EC\30FC\30AF\30FB\30EA\30B9\30C8\300D\306B\306F\3001\5B9A\7FA9\6E08\306E\30B3\30F3\30C8\30ED\30FC\30EB\30FB\30D6\30EC\30FC\30AF\304C\8868\793A\3055\308C\307E\3059\3002\65E2\5B58\306E\30B3\30F3\30C8\30ED\30FC\30EB\30FB\30D6\30EC\30FC\30AF\5217\3092\7121\52B9\5316\3059\308B\306B\306F\3001\305D\308C\3092\9078\629E\89E3\9664\3057\307E\3059\3002<br>'),
unistr('\300C\8FFD\52A0\300D( &plus; )\3092\30AF\30EA\30C3\30AF\3059\308B\3068\65B0\3057\3044\5217\304C\30B3\30F3\30C8\30ED\30FC\30EB\30FB\30D6\30EC\30FC\30AF\306B\542B\307E\308C\3001\300C\524A\9664\300D( &minus; )\3092\30AF\30EA\30C3\30AF\3059\308B\3068\65E2\5B58\306E\5217\304C\30B3\30F3\30C8\30ED\30FC\30EB\30FB\30D6\30EC\30FC\30AF\304B\3089\524A\9664\3055\308C\307E\3059\3002<br>'),
unistr('\5217\3092\4E26\3079\66FF\3048\308B\306B\306F\3001\300C\4E0A\3078\300D( &uarr; )\307E\305F\306F\300C\4E0B\3078\300D( &darr; )\3092\30AF\30EA\30C3\30AF\3057\3066\3001\9078\629E\3057\305F\5217\3092\4ED6\306E\5217\3092\57FA\6E96\3068\3057\3066\4E0A\4E0B\306B\79FB\52D5\3057\307E\3059\3002</p>'),
'',
unistr('<p><strong>\30B3\30F3\30C8\30ED\30FC\30EB\30FB\30D6\30EC\30FC\30AF\8A2D\5B9A</strong><br>'),
unistr('\30D5\30A9\30FC\30E0\3092\4F7F\7528\3057\3066\30B3\30F3\30C8\30ED\30FC\30EB\30FB\30D6\30EC\30FC\30AF\5217\3092\5B9A\7FA9\3057\307E\3059\3002<br>'),
unistr('\30B3\30F3\30C8\30ED\30FC\30EB\30FB\30D6\30EC\30FC\30AF\5217\3001\30BD\30FC\30C8\65B9\5411\3001\304A\3088\3073NULL\5217(\5024\306E\306A\3044\5217)\306E\4E26\66FF\3048\65B9\6CD5\3092\9078\629E\3057\307E\3059\3002</p>'),
'',
unistr('<p><em>\30CE\30FC\30C8: \5BFE\8A71\30B0\30EA\30C3\30C9\3092\8868\793A\3059\308B\5834\5408\3001\5217\30D8\30C3\30C0\30FC\3092\30AF\30EA\30C3\30AF\3057\3066\30B3\30F3\30C8\30ED\30FC\30EB\30FB\30D6\30EC\30FC\30AF\30FB\30A2\30A4\30B3\30F3\3092\9078\629E\3059\308B\3053\3068\3067\3001\30B3\30F3\30C8\30ED\30FC\30EB\30FB\30D6\30EC\30FC\30AF\3092\5B9A\7FA9\3067\304D\307E\3059\3002</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113030499756400616)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30C8\30ED\30FC\30EB\30FB\30D6\30EC\30FC\30AF\306E\30D8\30EB\30D7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113029294003400616)
,p_name=>'APEX.IG.HELP.DOWNLOAD'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30C0\30A4\30A2\30ED\30B0\3092\4F7F\7528\3057\3066\3001\5916\90E8\30D5\30A1\30A4\30EB\306B\73FE\5728\306E\3059\3079\3066\306E\884C\3092\30C0\30A6\30F3\30ED\30FC\30C9\3057\307E\3059\3002\30D5\30A1\30A4\30EB\306B\306F\3001\30C7\30FC\30BF\306B\9069\7528\3055\308C\305F\4EFB\610F\306E\30D5\30A3\30EB\30BF\3084\30BD\30FC\30C8\3092\4F7F\7528\3057\3066\3001\73FE\5728\8868\793A\3055\308C\3066\3044\308B\5217\306E\307F\304C\542B\307E\308C\307E\3059\3002</p>'),
'',
unistr('<p>\30D5\30A1\30A4\30EB\5F62\5F0F\3092\9078\629E\3057\3066\300C\30C0\30A6\30F3\30ED\30FC\30C9\300D\3092\30AF\30EA\30C3\30AF\3057\307E\3059\3002<br>'),
unistr('\30CE\30FC\30C8: CSV\306B\306F\3001\96C6\8A08\3084\30B3\30F3\30C8\30ED\30FC\30EB\30FB\30D6\30EC\30FC\30AF\306A\3069\306E\30C6\30AD\30B9\30C8\5F62\5F0F\306F\542B\307E\308C\307E\305B\3093\3002</p>'),
'',
unistr('<p>\30D5\30A1\30A4\30EB\3092\96FB\5B50\30E1\30FC\30EB\3067\9001\4FE1\3059\308B\306B\306F\3001\300C\96FB\5B50\30E1\30FC\30EB\3067\9001\4FE1\300D\3092\9078\629E\3057\3001\96FB\5B50\30E1\30FC\30EB\306E\8A73\7D30(\53D7\4FE1\8005\3001\4EF6\540D\304A\3088\3073\30E1\30C3\30BB\30FC\30B8)\3092\5165\529B\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113030226711400616)
,p_name=>'APEX.IG.HELP.DOWNLOAD_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C0\30A6\30F3\30ED\30FC\30C9\306E\30D8\30EB\30D7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113028400562400615)
,p_name=>'APEX.IG.HELP.FILTER'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30C0\30A4\30A2\30ED\30B0\3092\4F7F\7528\3057\3066\3001\8FD4\3055\308C\308B\884C\3092\5236\9650\3059\308B\30C7\30FC\30BF\30FB\30D5\30A3\30EB\30BF\3092\69CB\6210\3057\307E\3059\3002</p>'),
'',
unistr('<p><strong>\30D5\30A3\30EB\30BF\30FB\30EA\30B9\30C8</strong><br>'),
unistr('\300C\30D5\30A3\30EB\30BF\30FB\30EA\30B9\30C8\300D\306B\306F\3001\5B9A\7FA9\6E08\306E\30D5\30A3\30EB\30BF\304C\8868\793A\3055\308C\307E\3059\3002\65E2\5B58\306E\30D5\30A3\30EB\30BF\3092\7121\52B9\5316\3059\308B\306B\306F\3001\305D\308C\3092\9078\629E\89E3\9664\3057\307E\3059\3002<br>'),
unistr('\300C\8FFD\52A0\300D( &plus; )\3092\30AF\30EA\30C3\30AF\3059\308B\3068\65B0\3057\3044\30D5\30A3\30EB\30BF\304C\4F5C\6210\3055\308C\3001\300C\524A\9664\300D( &minus; )\3092\30AF\30EA\30C3\30AF\3059\308B\3068\65E2\5B58\306E\30D5\30A3\30EB\30BF\304C\524A\9664\3055\308C\307E\3059\3002</p>'),
'',
unistr('<p><strong>\30D5\30A3\30EB\30BF\8A2D\5B9A</strong><br>'),
unistr('\30D5\30A9\30FC\30E0\3092\4F7F\7528\3057\3066\30D5\30A3\30EB\30BF\30FB\30D7\30ED\30D1\30C6\30A3\3092\5B9A\7FA9\3057\307E\3059\3002<br>'),
unistr('\9069\5207\306A\30D5\30A3\30EB\30BF\30FB\30BF\30A4\30D7\3092\9078\629E\3057\307E\3059:<br>'),
unistr('&nbsp;&nbsp;&nbsp;\884C - \30D5\30A3\30EB\30BF\53EF\80FD\306A\4EFB\610F\306E\5217\306E\8A9E\53E5\3092\30D5\30A3\30EB\30BF\3057\307E\3059\3002<br>'),
unistr('&nbsp;&nbsp;&nbsp;\5217 - \6307\5B9A\3057\305F\6F14\7B97\5B50\3068\5024\3067\7279\5B9A\306E\5217\3092\30D5\30A3\30EB\30BF\3057\307E\3059\3002</p>'),
'',
unistr('<p><em>\30CE\30FC\30C8: \5BFE\8A71\30B0\30EA\30C3\30C9\3092\8868\793A\3059\308B\5834\5408\3001\300C\691C\7D22\300D\30D5\30A3\30FC\30EB\30C9\306B\76F4\63A5\5165\529B\3059\308B\3053\3068\3067\3001\884C\30D5\30A3\30EB\30BF\3092\5B9A\7FA9\3067\304D\307E\3059\3002\300C\691C\7D22\5217\306E\9078\629E\300D\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\691C\7D22\3092\7279\5B9A\306E\5217\306B\5236\9650\3067\304D\307E\3059\3002\307E\305F\306F\3001\5217\30D8\30C3\30C0\30FC\30FB\30E1\30CB\30E5\30FC\3092\958B\304D\3001\5024\3092\9078\629E\3057\3066\5217\30D5\30A3\30EB\30BF\3092\4F5C\6210\3067\304D\307E\3059\3002</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113031031743400617)
,p_name=>'APEX.IG.HELP.FILTER_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30EB\30BF\306E\30D8\30EB\30D7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113028823520400615)
,p_name=>'APEX.IG.HELP.FLASHBACK'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30C0\30A4\30A2\30ED\30B0\3092\4F7F\7528\3057\3066\3001\904E\53BB\306E\3042\308B\6642\70B9\306B\5B58\5728\3057\3066\3044\305F\30C7\30FC\30BF\3092\8868\793A\3057\307E\3059\3002</p>'),
unistr('<p>\904E\53BB\306E\5206\6570\3092\5165\529B\3057\3066\30D5\30E9\30C3\30B7\30E5\30D0\30C3\30AF\554F\5408\305B\3092\5B9F\884C\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113030645299400617)
,p_name=>'APEX.IG.HELP.FLASHBACK_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30E9\30C3\30B7\30E5\30D0\30C3\30AF\306E\30D8\30EB\30D7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113031352331400617)
,p_name=>'APEX.IG.HELP.GROUP_BY_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30EB\30FC\30D7\5316\306E\30D8\30EB\30D7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113028992029400615)
,p_name=>'APEX.IG.HELP.HIGHLIGHT'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30C0\30A4\30A2\30ED\30B0\3092\4F7F\7528\3057\3066\3001\5165\529B\3057\305F\6761\4EF6\306B\57FA\3065\3044\3066\30C7\30FC\30BF\306E\884C\307E\305F\306F\5217\3092\30CF\30A4\30E9\30A4\30C8\3057\307E\3059\3002</p>'),
'',
unistr('<p><strong>\30CF\30A4\30E9\30A4\30C8\30FB\30EA\30B9\30C8</strong><br>'),
unistr('\300C\30CF\30A4\30E9\30A4\30C8\30FB\30EA\30B9\30C8\300D\306B\306F\3001\5B9A\7FA9\6E08\306E\30CF\30A4\30E9\30A4\30C8\304C\8868\793A\3055\308C\307E\3059\3002\65E2\5B58\306E\30CF\30A4\30E9\30A4\30C8\3092\7121\52B9\5316\3059\308B\306B\306F\3001\305D\308C\3092\9078\629E\89E3\9664\3057\307E\3059\3002<br>'),
unistr('\300C\8FFD\52A0\300D( &plus; )\3092\30AF\30EA\30C3\30AF\3059\308B\3068\65B0\3057\3044\30CF\30A4\30E9\30A4\30C8\304C\4F5C\6210\3055\308C\3001\300C\524A\9664\300D( &minus; )\3092\30AF\30EA\30C3\30AF\3059\308B\3068\65E2\5B58\306E\30CF\30A4\30E9\30A4\30C8\304C\524A\9664\3055\308C\307E\3059\3002</p>'),
'',
unistr('<p><strong>\30CF\30A4\30E9\30A4\30C8\8A2D\5B9A</strong><br>'),
unistr('\30D5\30A9\30FC\30E0\3092\4F7F\7528\3057\3066\30CF\30A4\30E9\30A4\30C8\30FB\30D7\30ED\30D1\30C6\30A3\3092\5B9A\7FA9\3057\307E\3059\3002<br>'),
unistr('\540D\524D\3092\5165\529B\3057\3001\300C\884C\300D\307E\305F\306F\300C\5217\300D\3092\9078\629E\3057\3066\3001\30D0\30C3\30AF\30B0\30E9\30A6\30F3\30C9\304A\3088\3073\30C6\30AD\30B9\30C8\306EHTML\30AB\30E9\30FC\30FB\30B3\30FC\30C9\3092\9078\629E\3057\307E\3059\3002<br>'),
unistr('\9069\5207\306A<strong>\300C\6761\4EF6\30BF\30A4\30D7\300D</strong>\3092\9078\629E\3057\3066\7279\5B9A\306E\30C7\30FC\30BF\3092\30CF\30A4\30E9\30A4\30C8\3057\307E\3059\3002<br>'),
unistr('&nbsp;&nbsp;&nbsp;\884C - \4EFB\610F\306E\5217\306E\8A9E\53E5\3092\30CF\30A4\30E9\30A4\30C8\3057\307E\3059\3002<br>'),
unistr('&nbsp;&nbsp;&nbsp;\5217 - \6307\5B9A\3057\305F\6F14\7B97\5B50\3068\5024\306B\57FA\3065\3044\3066\7279\5B9A\306E\5217\5185\3092\30CF\30A4\30E9\30A4\30C8\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113030542106400617)
,p_name=>'APEX.IG.HELP.HIGHLIGHT_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CF\30A4\30E9\30A4\30C8\306E\30D8\30EB\30D7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113029168695400615)
,p_name=>'APEX.IG.HELP.REPORT'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30C0\30A4\30A2\30ED\30B0\3092\4F7F\7528\3057\3066\3001\73FE\5728\306E\30B0\30EA\30C3\30C9\30FB\30EC\30A4\30A2\30A6\30C8\304A\3088\3073\69CB\6210\306B\52A0\3048\305F\5909\66F4\3092\4FDD\5B58\3057\307E\3059\3002<br>'),
unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\958B\767A\8005\306F\3001\8907\6570\306E\4EE3\66FF\30EC\30DD\30FC\30C8\30FB\30EC\30A4\30A2\30A6\30C8\3092\5B9A\7FA9\3067\304D\307E\3059\3002\8A31\5BB9\3055\308C\308B\5834\5408\3001\81EA\5206\3068\4ED6\306E\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\3001\300C\30D1\30D6\30EA\30C3\30AF\300D\3068\3057\3066\30EC\30DD\30FC\30C8\3092\4FDD\5B58\3057\3001\30B0\30EA\30C3\30C9\306E\4ED6\306E\3059\3079\3066\306E\30E6\30FC\30B6\30FC\304C\30EC\30DD\30FC\30C8\3092\4F7F\7528\3067\304D\308B\3088\3046\306B\8A2D\5B9A\3067\304D\307E\3059\3002\307E\305F\3001\81EA\5206\306E\307F\304C\53C2\7167\3067\304D\308B\30D7\30E9\30A4\30D9\30FC\30C8\30FB\30EC\30DD\30FC\30C8\3068\3057\3066\30EC\30DD\30FC\30C8\3092\4FDD\5B58\3059\308B\3053\3068\3082\3067\304D\307E\3059\3002</p>'),
unistr('<p>\4F7F\7528\53EF\80FD\306A\30BF\30A4\30D7\304B\3089\9078\629E\3057\3066\3001\4FDD\5B58\3059\308B\30EC\30DD\30FC\30C8\306E\540D\524D\3092\5165\529B\3057\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113030308645400616)
,p_name=>'APEX.IG.HELP.REPORT_TITLE'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30EC\30DD\30FC\30C8\306E\30D8\30EB\30D7'),
''))
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113028504529400615)
,p_name=>'APEX.IG.HELP.SORT'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\3053\306E\30C0\30A4\30A2\30ED\30B0\3092\4F7F\7528\3057\3066\3001\8868\793A\9806\5E8F\3092\8A2D\5B9A\3057\307E\3059\3002</p>'),
'',
unistr('<p><strong>\30BD\30FC\30C8\30FB\30EA\30B9\30C8</strong><br>'),
unistr('\300C\30BD\30FC\30C8\300D\30C0\30A4\30A2\30ED\30B0\306B\306F\3001\69CB\6210\6E08\306E\30BD\30FC\30C8\30FB\30EB\30FC\30EB\306E\30EA\30B9\30C8\304C\8868\793A\3055\308C\307E\3059\3002<br>'),
unistr('\300C\8FFD\52A0\300D( &plus; )\3092\30AF\30EA\30C3\30AF\3059\308B\3068\30BD\30FC\30C8\5217\304C\4F5C\6210\3055\308C\3001\300C\524A\9664\300D( &minus; )\3092\30AF\30EA\30C3\30AF\3059\308B\3068\30BD\30FC\30C8\5217\304C\524A\9664\3055\308C\307E\3059\3002<br>'),
unistr('\300C\4E0A\3078\300D( &uarr; )\304A\3088\3073\300C\4E0B\3078\300D( &darr; )\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\9078\629E\3057\305F\30BD\30FC\30C8\5217\3092\3001\4ED6\306E\30BD\30FC\30C8\5217\3092\57FA\6E96\3068\3057\3066\4E0A\4E0B\306B\79FB\52D5\3067\304D\307E\3059\3002</p>'),
'',
unistr('<p><strong>\30BD\30FC\30C8\8A2D\5B9A</strong><br>'),
unistr('\30BD\30FC\30C8\5217\3001\30BD\30FC\30C8\65B9\5411\3001\304A\3088\3073NULL\5217(\5024\306E\306A\3044\5217)\306E\4E26\66FF\3048\65B9\6CD5\3092\9078\629E\3057\307E\3059\3002</p>'),
'',
unistr('<p><em>\30CE\30FC\30C8: \30C7\30FC\30BF\306F\975E\8868\793A\306E\5217\306B\3088\3063\3066\30BD\30FC\30C8\3067\304D\307E\3059\304C\3001\3059\3079\3066\306E\5217\304C\30BD\30FC\30C8\53EF\80FD\306A\308F\3051\3067\306F\3042\308A\307E\305B\3093\3002</em><br>'),
unistr('<em>\8868\793A\5217\306F\3001\5217\30D8\30C3\30C0\30FC\306E\672B\5C3E\306B\3042\308B\4E0A\77E2\5370(\6607\9806)\307E\305F\306F\4E0B\77E2\5370(\964D\9806)\3092\62BC\3059\3053\3068\3067\30BD\30FC\30C8\3067\304D\307E\3059\3002\65E2\5B58\306E\30BD\30FC\30C8\306B\5F8C\7D9A\306E\5217\3092\8FFD\52A0\3059\308B\306B\306F\3001[Shift]\30AD\30FC\3092\62BC\3057\306A\304C\3089\4E0A\77E2\5370\307E\305F\306F\4E0B\77E2\5370\3092\30AF\30EA\30C3\30AF\3057\307E\3059\3002</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113030979903400617)
,p_name=>'APEX.IG.HELP.SORT_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BD\30FC\30C8\306E\30D8\30EB\30D7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113030142273400616)
,p_name=>'APEX.IG.HELP.SUBSCRIPTION_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30D6\30B9\30AF\30EA\30D7\30B7\30E7\30F3\306E\30D8\30EB\30D7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112982412838400582)
,p_name=>'APEX.IG.HIDE'
,p_message_language=>'ja'
,p_message_text=>unistr('\975E\8868\793A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112949203900400557)
,p_name=>'APEX.IG.HIGHLIGHT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CF\30A4\30E9\30A4\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113017298696400607)
,p_name=>'APEX.IG.HIGH_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\9AD8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113018033257400607)
,p_name=>'APEX.IG.HORIZONTAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A2A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112975457779400577)
,p_name=>'APEX.IG.HOURS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6642\9593')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112980415179400580)
,p_name=>'APEX.IG.ICON'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112948101941400556)
,p_name=>'APEX.IG.ICON_VIEW'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3\30FB\30D3\30E5\30FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112973640135400575)
,p_name=>'APEX.IG.IN'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306B\542B\307E\308C\308B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112982061922400581)
,p_name=>'APEX.IG.INACTIVE_SETTING'
,p_message_language=>'ja'
,p_message_text=>unistr('\975E\30A2\30AF\30C6\30A3\30D6\306A\8A2D\5B9A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112982166092400582)
,p_name=>'APEX.IG.INACTIVE_SETTINGS'
,p_message_language=>'ja'
,p_message_text=>unistr('\975E\30A2\30AF\30C6\30A3\30D6\306A\8A2D\5B9A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112989736322400587)
,p_name=>'APEX.IG.INTERNAL_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\5BFE\8A71\30B0\30EA\30C3\30C9\30FB\30EA\30AF\30A8\30B9\30C8\306E\51E6\7406\4E2D\306B\5185\90E8\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112885513393400509)
,p_name=>'APEX.IG.INVALID_COLUMN_FILTER_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217"%1"\3067\306F\5217\30D5\30A3\30EB\30BF\30FB\30BF\30A4\30D7"%0"\306F\30B5\30DD\30FC\30C8\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113029956084400616)
,p_name=>'APEX.IG.INVALID_DATE_FORMAT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9\306A\65E5\4ED8\66F8\5F0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113004192580400597)
,p_name=>'APEX.IG.INVALID_FILTER_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\5BFE\8A71\30B0\30EA\30C3\30C9\3067\306F\3001\5217%0\306B\30D5\30A3\30EB\30BF\3092\5B9A\7FA9\3059\308B\3053\3068\306F\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113004000105400597)
,p_name=>'APEX.IG.INVALID_FILTER_OPERATOR'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\3001\5BFE\8A71\30B0\30EA\30C3\30C9\30FB\30D5\30A3\30EB\30BF\306E\5B9A\7FA9\306B\6709\52B9\306A\30D5\30A3\30EB\30BF\30FB\30BF\30A4\30D7\3067\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112890673322400513)
,p_name=>'APEX.IG.INVALID_NUMBER_FORMAT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9\306A\6570\5024\66F8\5F0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113032621355400618)
,p_name=>'APEX.IG.INVALID_SETTING'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9\306A\8A2D\5B9A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113032748731400618)
,p_name=>'APEX.IG.INVALID_SETTINGS'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9\306A\8A2D\5B9A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113023735490400612)
,p_name=>'APEX.IG.INVALID_SORT_BY'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\30BD\30FC\30C8\57FA\6E96\300D\304C%0\306B\8A2D\5B9A\3055\308C\3066\3044\307E\3059\304C\3001%0\306B\5BFE\3057\3066\5217\304C\9078\629E\3055\308C\3066\3044\307E\305B\3093\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113021005731400610)
,p_name=>'APEX.IG.INVALID_VALUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9\306A\5024')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113016128223400606)
,p_name=>'APEX.IG.INVISIBLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\975E\8868\793A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112974400577400576)
,p_name=>'APEX.IG.IN_THE_LAST'
,p_message_language=>'ja'
,p_message_text=>unistr('\904E\53BB')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112974627368400576)
,p_name=>'APEX.IG.IN_THE_NEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\3088\308A\5F8C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112973530828400575)
,p_name=>'APEX.IG.IS_NOT_NULL'
,p_message_language=>'ja'
,p_message_text=>unistr('\7A7A\3067\306F\3042\308A\307E\305B\3093')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112973476689400575)
,p_name=>'APEX.IG.IS_NULL'
,p_message_language=>'ja'
,p_message_text=>unistr('\7A7A\3067\3059')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113024589250400612)
,p_name=>'APEX.IG.LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113016560385400606)
,p_name=>'APEX.IG.LABEL_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113020499765400609)
,p_name=>'APEX.IG.LAST'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5F8C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112963750061400568)
,p_name=>'APEX.IG.LAST.DAY'
,p_message_language=>'ja'
,p_message_text=>unistr('\904E\53BB1\65E5\9593')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112963908115400568)
,p_name=>'APEX.IG.LAST.HOUR'
,p_message_language=>'ja'
,p_message_text=>unistr('\904E\53BB1\6642\9593')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112964435348400568)
,p_name=>'APEX.IG.LAST.MINUTE'
,p_message_language=>'ja'
,p_message_text=>unistr('\904E\53BB1\5206')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112963440454400568)
,p_name=>'APEX.IG.LAST.MONTH'
,p_message_language=>'ja'
,p_message_text=>unistr('\904E\53BB1\304B\6708\9593')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112963592672400568)
,p_name=>'APEX.IG.LAST.WEEK'
,p_message_language=>'ja'
,p_message_text=>unistr('\904E\53BB1\9031\9593')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112963642007400568)
,p_name=>'APEX.IG.LAST.X_DAYS'
,p_message_language=>'ja'
,p_message_text=>unistr('\904E\53BB%0\65E5\9593')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112963874947400568)
,p_name=>'APEX.IG.LAST.X_HOURS'
,p_message_language=>'ja'
,p_message_text=>unistr('\904E\53BB%0\6642\9593')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112964578923400568)
,p_name=>'APEX.IG.LAST.X_MINUTES'
,p_message_language=>'ja'
,p_message_text=>unistr('\904E\53BB%0\5206')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112964357854400568)
,p_name=>'APEX.IG.LAST.X_MONTHS'
,p_message_language=>'ja'
,p_message_text=>unistr('\904E\53BB%0\304B\6708')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112964219809400568)
,p_name=>'APEX.IG.LAST.X_WEEKS'
,p_message_language=>'ja'
,p_message_text=>unistr('\904E\53BB%0\9031\9593')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112963246709400567)
,p_name=>'APEX.IG.LAST.X_YEARS'
,p_message_language=>'ja'
,p_message_text=>unistr('\904E\53BB%0\5E74\9593')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112963392290400567)
,p_name=>'APEX.IG.LAST.YEAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\904E\53BB1\5E74\9593')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113024759950400612)
,p_name=>'APEX.IG.LAYOUT_ALIGN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30EB\306E\4F4D\7F6E\5408\305B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113024851684400612)
,p_name=>'APEX.IG.LAYOUT_USEGROUPFOR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30EB\30FC\30D7\306E\4F7F\7528')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112974052873400576)
,p_name=>'APEX.IG.LESS_THAN'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\3088\308A\5C0F\3055\3044')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112974168062400576)
,p_name=>'APEX.IG.LESS_THAN_OR_EQUALS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\4EE5\4E0B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113018642157400608)
,p_name=>'APEX.IG.LINE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6298\308C\7DDA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113018785909400608)
,p_name=>'APEX.IG.LINE_WITH_AREA'
,p_message_language=>'ja'
,p_message_text=>unistr('\9762\4ED8\304D\6298\308C\7DDA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113025139334400613)
,p_name=>'APEX.IG.LISTAGG'
,p_message_language=>'ja'
,p_message_text=>'Listagg'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113017364970400607)
,p_name=>'APEX.IG.LOW_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F4E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113027782658400614)
,p_name=>'APEX.IG.MAILADDRESSES_COMMASEP'
,p_message_language=>'ja'
,p_message_text=>unistr('\8907\6570\306E\30A2\30C9\30EC\30B9\306F\30AB\30F3\30DE\3067\533A\5207\308A\307E\3059')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112975298174400576)
,p_name=>'APEX.IG.MATCHES_REGULAR_EXPRESSION'
,p_message_language=>'ja'
,p_message_text=>unistr('\304C\6B21\306E\6B63\898F\8868\73FE\3068\4E00\81F4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112999633343400594)
,p_name=>'APEX.IG.MAX'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5927')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113035228878400620)
,p_name=>'APEX.IG.MAX_OVERALL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5168\4F53\306E\6700\5927')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112999892420400594)
,p_name=>'APEX.IG.MEDIAN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E1\30B8\30A2\30F3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113035364476400620)
,p_name=>'APEX.IG.MEDIAN_OVERALL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5168\4F53\306E\30E1\30B8\30A2\30F3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112999596845400594)
,p_name=>'APEX.IG.MIN'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5C0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112975333117400577)
,p_name=>'APEX.IG.MINUTES'
,p_message_language=>'ja'
,p_message_text=>unistr('\5206')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113000349897400595)
,p_name=>'APEX.IG.MINUTES_AGO'
,p_message_language=>'ja'
,p_message_text=>unistr('\5206\524D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113035130227400620)
,p_name=>'APEX.IG.MIN_OVERALL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5168\4F53\306E\6700\5C0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112975799846400577)
,p_name=>'APEX.IG.MONTHS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6708')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112982384906400582)
,p_name=>'APEX.IG.MORE_DATA_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\306B\6700\5927\8A31\5BB9\6570\3088\308A\591A\3044%0\3092\8D85\3048\308B\884C\304C\542B\307E\308C\307E\3059\3002\7D50\679C\3092\8868\793A\3059\308B\306B\306F\8FFD\52A0\306E\30D5\30A3\30EB\30BF\3092\9069\7528\3057\3066\304F\3060\3055\3044\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113009082042400601)
,p_name=>'APEX.IG.MULTIIG_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306B\306F\8907\6570\306E\5BFE\8A71\30B0\30EA\30C3\30C9\304C\542B\307E\308C\3066\3044\308B\305F\3081\3001\30EA\30FC\30B8\30E7\30F3\306E\9759\7684ID\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112978468052400579)
,p_name=>'APEX.IG.NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\540D\524D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112978604863400579)
,p_name=>'APEX.IG.NAMED_REPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\540D\524D\4ED8\304D\30EC\30DD\30FC\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112962631682400567)
,p_name=>'APEX.IG.NEXT.DAY'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E1\65E5\9593')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112962455569400567)
,p_name=>'APEX.IG.NEXT.HOUR'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\6642\9593')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112964675409400568)
,p_name=>'APEX.IG.NEXT.MINUTE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\5206')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112962954517400567)
,p_name=>'APEX.IG.NEXT.MONTH'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\6708')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112962847127400567)
,p_name=>'APEX.IG.NEXT.WEEK'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\9031')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112962747659400567)
,p_name=>'APEX.IG.NEXT.X_DAYS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E%0\65E5\9593')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112962599634400567)
,p_name=>'APEX.IG.NEXT.X_HOURS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E%0\6642\9593')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112964731443400568)
,p_name=>'APEX.IG.NEXT.X_MINUTES'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E%0\5206')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112964067936400568)
,p_name=>'APEX.IG.NEXT.X_MONTHS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E%0\304B\6708')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112964119213400568)
,p_name=>'APEX.IG.NEXT.X_WEEKS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E%0\9031\9593')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112963126001400567)
,p_name=>'APEX.IG.NEXT.X_YEARS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E%0\5E74')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112963079350400567)
,p_name=>'APEX.IG.NEXT.YEAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\5E74')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112974366031400576)
,p_name=>'APEX.IG.NOT_BETWEEN'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\9593\306B\306A\3044')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112973308941400575)
,p_name=>'APEX.IG.NOT_EQUALS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\3068\7B49\3057\304F\306A\3044')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113039576168400623)
,p_name=>'APEX.IG.NOT_EXIST'
,p_message_language=>'ja'
,p_message_text=>unistr('ID %0\306E\30EA\30FC\30B8\30E7\30F3\306F\5BFE\8A71\30B0\30EA\30C3\30C9\30FB\30EA\30FC\30B8\30E7\30F3\3067\306F\306A\3044\304B\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3%1\306B\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112973787186400575)
,p_name=>'APEX.IG.NOT_IN'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306B\542B\307E\308C\306A\3044')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112974561068400576)
,p_name=>'APEX.IG.NOT_IN_THE_LAST'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5F8C\3067\306A\3044')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112974790714400576)
,p_name=>'APEX.IG.NOT_IN_THE_NEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\3067\306A\3044')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112982229894400582)
,p_name=>'APEX.IG.NO_DATA_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\304C\898B\3064\304B\308A\307E\305B\3093')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113020229660400609)
,p_name=>'APEX.IG.NULLS'
,p_message_language=>'ja'
,p_message_text=>'null'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113025334499400613)
,p_name=>'APEX.IG.NUMBER'
,p_message_language=>'ja'
,p_message_text=>unistr('\6570\5024')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113020540373400609)
,p_name=>'APEX.IG.OFF'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30D5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113020602293400609)
,p_name=>'APEX.IG.ON'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30F3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112972573687400574)
,p_name=>'APEX.IG.ONE_MINUTE_AGO'
,p_message_language=>'ja'
,p_message_text=>unistr('1\5206\524D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113028290314400615)
,p_name=>'APEX.IG.OPEN_COLORPICKER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30E9\30FC\30FB\30D4\30C3\30AB\30FC\3092\958B\304F: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113017010994400607)
,p_name=>'APEX.IG.OPEN_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\304F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112979508790400580)
,p_name=>'APEX.IG.OPERATOR'
,p_message_language=>'ja'
,p_message_text=>unistr('\6F14\7B97\5B50')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113016445735400606)
,p_name=>'APEX.IG.ORIENTATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\5411\304D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113018878192400608)
,p_name=>'APEX.IG.PIE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5186')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112980845337400581)
,p_name=>'APEX.IG.PIVOT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D4\30DC\30C3\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112948468830400557)
,p_name=>'APEX.IG.PIVOT_VIEW'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D4\30DC\30C3\30C8\30FB\30D3\30E5\30FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113028172875400615)
,p_name=>'APEX.IG.PLACEHOLDER_INVALUES'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024\306F"%0"\3067\533A\5207\308A\307E\3059')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113018903688400608)
,p_name=>'APEX.IG.POLAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\6975')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113024227273400612)
,p_name=>'APEX.IG.POSITION_CENTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E2D\592E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113024377819400612)
,p_name=>'APEX.IG.POSITION_END'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D42\4E86')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113024109440400612)
,p_name=>'APEX.IG.POSITION_START'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\59CB')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112978717551400579)
,p_name=>'APEX.IG.PRIMARY'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E3B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112979070741400579)
,p_name=>'APEX.IG.PRIMARY_DEFAULT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30E9\30A4\30DE\30EA\30FB\30C7\30D5\30A9\30EB\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112995506179400591)
,p_name=>'APEX.IG.PRIMARY_REPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30E9\30A4\30DE\30EA\30FB\30EC\30DD\30FC\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112877780614400504)
,p_name=>'APEX.IG.PRINT_ACCESSIBLE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30BB\30B7\30D3\30EA\30C6\30A3\30FB\30BF\30B0\3092\542B\3081\308B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112876487024400503)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A2A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112876570666400503)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\7E26')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112876326564400503)
,p_name=>'APEX.IG.PRINT_ORIENTATION.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306E\5411\304D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112876229075400503)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A3.D'
,p_message_language=>'ja'
,p_message_text=>'A3'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112876127212400502)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A4.D'
,p_message_language=>'ja'
,p_message_text=>'A4'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112877885583400504)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.CUSTOM.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30B9\30BF\30E0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112875977404400502)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LEGAL.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30AC\30EB')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112875862986400502)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LETTER.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30BF\30FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112876092537400502)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.TABLOID.D'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30D6\30ED\30A4\30C9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112875775872400502)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30B5\30A4\30BA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112865995566400495)
,p_name=>'APEX.IG.PRINT_STRIP_RICH_TEXT.PROMPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30C3\30C1\30FB\30C6\30AD\30B9\30C8\3092\524A\9664')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113019058204400608)
,p_name=>'APEX.IG.RADAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30FC\30C0\30FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113019145962400608)
,p_name=>'APEX.IG.RANGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\7BC4\56F2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113029456832400616)
,p_name=>'APEX.IG.REFRESH'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30D5\30EC\30C3\30B7\30E5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112983069812400582)
,p_name=>'APEX.IG.REFRESH_ROW'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\306E\30EA\30D5\30EC\30C3\30B7\30E5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112981838337400581)
,p_name=>'APEX.IG.REFRESH_ROWS'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\306E\30EA\30D5\30EC\30C3\30B7\30E5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112987012681400585)
,p_name=>'APEX.IG.REGION_NOT_EXIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3%0\3001\30DA\30FC\30B8%1\3001\30EA\30FC\30B8\30E7\30F3%2\306B\306F\5BFE\8A71\30B0\30EA\30C3\30C9\30FB\30EA\30FC\30B8\30E7\30F3\304C\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112949965212400558)
,p_name=>'APEX.IG.REMOVE_CONTROL'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306E\524A\9664')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112978188706400579)
,p_name=>'APEX.IG.REPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113038750602400622)
,p_name=>'APEX.IG.REPORT.DELETED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\304C\524A\9664\3055\308C\307E\3057\305F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113038448612400622)
,p_name=>'APEX.IG.REPORT.SAVED.ALTERNATIVE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\306E\30E6\30FC\30B6\30FC\306B\5BFE\3059\308B\4EE3\66FF\30EC\30DD\30FC\30C8\304C\4FDD\5B58\3055\308C\307E\3057\305F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113038307582400622)
,p_name=>'APEX.IG.REPORT.SAVED.DEFAULT'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\306E\30E6\30FC\30B6\30FC\306B\5BFE\3059\308B\30C7\30D5\30A9\30EB\30C8\306E\30EC\30DD\30FC\30C8\304C\4FDD\5B58\3055\308C\307E\3057\305F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113038673197400622)
,p_name=>'APEX.IG.REPORT.SAVED.PRIVATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30E9\30A4\30D9\30FC\30C8\30FB\30EC\30DD\30FC\30C8\304C\4FDD\5B58\3055\308C\307E\3057\305F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113038511733400622)
,p_name=>'APEX.IG.REPORT.SAVED.PUBLIC'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\306E\30E6\30FC\30B6\30FC\306B\5BFE\3059\308B\30D1\30D6\30EA\30C3\30AF\30FB\30EC\30DD\30FC\30C8\304C\4FDD\5B58\3055\308C\307E\3057\305F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112987150507400585)
,p_name=>'APEX.IG.REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\540D\524D%0\3067\4FDD\5B58\3055\308C\305F\5BFE\8A71\30B0\30EA\30C3\30C9\304C\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112972487133400574)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF.X.MINUTES_AGO'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\5206\524D\306E\30C7\30FC\30BF\3092\30EC\30DD\30FC\30C8\3057\307E\3059\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112972350653400574)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF_ONE_MINUTE_AGO'
,p_message_language=>'ja'
,p_message_text=>unistr('1\5206\524D\306E\30C7\30FC\30BF\3092\30EC\30DD\30FC\30C8\3057\307E\3059')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112912003459400529)
,p_name=>'APEX.IG.REPORT_DOES_NOT_EXIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\5BFE\8A71\30B0\30EA\30C3\30C9\30FB\30EC\30DD\30FC\30C8\304C\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113031678012400617)
,p_name=>'APEX.IG.REPORT_EDIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8 - \7DE8\96C6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112986913724400585)
,p_name=>'APEX.IG.REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'ja'
,p_message_text=>unistr('ID %0\3067\4FDD\5B58\3055\308C\305F\5BFE\8A71\30B0\30EA\30C3\30C9\304C\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113031559891400617)
,p_name=>'APEX.IG.REPORT_SAVE_AS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8 - \540D\524D\3092\4ED8\3051\3066\4FDD\5B58')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112950080970400558)
,p_name=>'APEX.IG.REPORT_SETTINGS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\8A2D\5B9A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113039646637400623)
,p_name=>'APEX.IG.REPORT_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\9759\7684ID %0\3067\4FDD\5B58\3055\308C\305F\5BFE\8A71\30B0\30EA\30C3\30C9\304C\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113034542620400619)
,p_name=>'APEX.IG.REPORT_VIEW'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\30FB\30D3\30E5\30FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112949121537400557)
,p_name=>'APEX.IG.RESET'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30BB\30C3\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112983114874400582)
,p_name=>'APEX.IG.REVERT_CHANGES'
,p_message_language=>'ja'
,p_message_text=>unistr('\5909\66F4\306E\56DE\5FA9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112981932045400581)
,p_name=>'APEX.IG.REVERT_ROWS'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\306E\56DE\5FA9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112979104900400579)
,p_name=>'APEX.IG.ROW'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112978027708400579)
,p_name=>'APEX.IG.ROWS_PER_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\3054\3068\306E\884C\6570')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113039226515400623)
,p_name=>'APEX.IG.ROW_ACTIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\30A2\30AF\30B7\30E7\30F3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113040425274400624)
,p_name=>'APEX.IG.ROW_ACTIONS_FOR'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C%0\306E\30A2\30AF\30B7\30E7\30F3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112949457035400557)
,p_name=>'APEX.IG.SAVE'
,p_message_language=>'ja'
,p_message_text=>unistr('\4FDD\5B58')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112992173266400589)
,p_name=>'APEX.IG.SAVED'
,p_message_language=>'ja'
,p_message_text=>unistr('\4FDD\5B58\6E08')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112947642550400556)
,p_name=>'APEX.IG.SAVED_REPORTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\4FDD\5B58\3055\308C\305F\30EC\30DD\30FC\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112947746529400556)
,p_name=>'APEX.IG.SAVED_REPORT_DEFAULT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112922258478400537)
,p_name=>'APEX.IG.SAVED_REPORT_EXISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\3068\3044\3046\4FDD\5B58\6E08\30EC\30DD\30FC\30C8\306F\3059\3067\306B\5B58\5728\3057\307E\3059\3002\65B0\3057\3044\540D\524D\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112947837651400556)
,p_name=>'APEX.IG.SAVED_REPORT_PRIVATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30E9\30A4\30D9\30FC\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112947908864400556)
,p_name=>'APEX.IG.SAVED_REPORT_PUBLIC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30D6\30EA\30C3\30AF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113034235944400619)
,p_name=>'APEX.IG.SAVE_AS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5225\540D\4FDD\5B58')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112981205923400581)
,p_name=>'APEX.IG.SAVE_REPORT_SETTINGS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\8A2D\5B9A\306E\4FDD\5B58')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113019288530400608)
,p_name=>'APEX.IG.SCATTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\6563\5E03')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112947527772400556)
,p_name=>'APEX.IG.SEARCH'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113026502531400614)
,p_name=>'APEX.IG.SEARCH.ALL_COLUMNS'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22: \3059\3079\3066\306E\30C6\30AD\30B9\30C8\5217')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112947431240400556)
,p_name=>'APEX.IG.SEARCH.COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113025797557400613)
,p_name=>'APEX.IG.SEARCH.ORACLE_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22: \5168\6587')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112972277257400574)
,p_name=>'APEX.IG.SEARCH_FOR.X'
,p_message_language=>'ja'
,p_message_text=>unistr('''%0''\306E\691C\7D22')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113015820202400606)
,p_name=>'APEX.IG.SELECT'
,p_message_language=>'ja'
,p_message_text=>unistr('- \9078\629E -')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112956084907400562)
,p_name=>'APEX.IG.SELECTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113008724527400601)
,p_name=>'APEX.IG.SELECT_1_ROW_IN_MASTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30B9\30BF\30FC\30FB\30EA\30FC\30B8\30E7\30F3\30671\884C\3092\9078\629E\3057\307E\3059')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112947374487400556)
,p_name=>'APEX.IG.SELECT_COLUMNS_TO_SEARCH'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22\5217\306E\9078\629E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113038903594400623)
,p_name=>'APEX.IG.SEL_ACTIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\30A2\30AF\30B7\30E7\30F3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112956222600400562)
,p_name=>'APEX.IG.SEL_MODE_CELL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30EB\306E\9078\629E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112956175624400562)
,p_name=>'APEX.IG.SEL_MODE_ROW'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\9078\629E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113027175780400614)
,p_name=>'APEX.IG.SEND_AS_EMAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\3067\9001\4FE1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113019675387400609)
,p_name=>'APEX.IG.SERIES_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30EA\30FC\30BA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112945341490400554)
,p_name=>'APEX.IG.SHOW'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112997972150400593)
,p_name=>'APEX.IG.SHOW_OVERALL_VALUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5168\4F53\306E\5024\306E\8868\793A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112982774315400582)
,p_name=>'APEX.IG.SINGLE_ROW_VIEW'
,p_message_language=>'ja'
,p_message_text=>unistr('\5358\4E00\884C\30D3\30E5\30FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112981094203400581)
,p_name=>'APEX.IG.SORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BD\30FC\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113019705645400609)
,p_name=>'APEX.IG.SORT_BY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BD\30FC\30C8\57FA\6E96')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113039374943400623)
,p_name=>'APEX.IG.SORT_ONLY_ONE_PER_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\3054\3068\306B\30BD\30FC\30C8\30921\3064\306E\307F\5B9A\7FA9\3067\304D\307E\3059\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113039166670400623)
,p_name=>'APEX.IG.SRV_CHANGE_MENU'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E1\30CB\30E5\30FC\306E\5909\66F4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113020788600400609)
,p_name=>'APEX.IG.STACK'
,p_message_language=>'ja'
,p_message_text=>unistr('\7A4D\4E0A\3052')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112975024447400576)
,p_name=>'APEX.IG.STARTS_WITH'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\3067\59CB\307E\308B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113019381682400608)
,p_name=>'APEX.IG.STOCK'
,p_message_language=>'ja'
,p_message_text=>unistr('\682A\4FA1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112940303152400551)
,p_name=>'APEX.IG.STRETCH_COLUMNS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\5E45\306E\62E1\5F35')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112981495035400581)
,p_name=>'APEX.IG.SUBSCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30D6\30B9\30AF\30EA\30D7\30B7\30E7\30F3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112999460586400594)
,p_name=>'APEX.IG.SUM'
,p_message_language=>'ja'
,p_message_text=>unistr('\5408\8A08')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113040692889400624)
,p_name=>'APEX.IG.SUMMARY'
,p_message_language=>'ja'
,p_message_text=>unistr('\5BFE\8A71\30B0\30EA\30C3\30C9\3002\30EC\30DD\30FC\30C8: %0\3001\30D3\30E5\30FC: %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113034603856400620)
,p_name=>'APEX.IG.SUM_OVERALL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5168\4F53\306E\5408\8A08')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113017503880400607)
,p_name=>'APEX.IG.TARGET_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30FC\30B2\30C3\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113023924071400612)
,p_name=>'APEX.IG.TEXT_COLOR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8\30FB\30AB\30E9\30FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112950157958400558)
,p_name=>'APEX.IG.TOGGLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5207\66FF\3048')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112997812966400593)
,p_name=>'APEX.IG.TOOLTIP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C4\30FC\30EB\30C1\30C3\30D7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112978287359400579)
,p_name=>'APEX.IG.TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30D7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112982614813400582)
,p_name=>'APEX.IG.UNFREEZE'
,p_message_language=>'ja'
,p_message_text=>unistr('\56FA\5B9A\89E3\9664')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112979738485400580)
,p_name=>'APEX.IG.UNIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5358\4F4D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113026949963400614)
,p_name=>'APEX.IG.UNSAVED_CHANGES_CONTINUE_CONFIRM'
,p_message_language=>'ja'
,p_message_text=>unistr('\4FDD\5B58\3057\3066\3044\306A\3044\5909\66F4\304C\3042\308A\307E\3059\3002\7D9A\884C\3057\307E\3059\304B\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112979698725400580)
,p_name=>'APEX.IG.VALUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113016666024400606)
,p_name=>'APEX.IG.VALUE_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113021523483400610)
,p_name=>'APEX.IG.VALUE_REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024\304C\5FC5\8981\3067\3059\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113006436009400599)
,p_name=>'APEX.IG.VALUE_TIMESTAMP_TZ'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024(\30BF\30A4\30E0\30BE\30FC\30F3\306F\5909\66F4\3067\304D\307E\305B\3093)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113025437253400613)
,p_name=>'APEX.IG.VARCHAR2'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113017964332400607)
,p_name=>'APEX.IG.VERTICAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\7E26')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112977726914400578)
,p_name=>'APEX.IG.VIEW'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D3\30E5\30FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113015967671400606)
,p_name=>'APEX.IG.VISIBLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113017420348400607)
,p_name=>'APEX.IG.VOLUME_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30EA\30E5\30FC\30E0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112975640169400577)
,p_name=>'APEX.IG.WEEKS'
,p_message_language=>'ja'
,p_message_text=>unistr('\9031')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113016073451400606)
,p_name=>'APEX.IG.WIDTH'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5C0F\5217\5E45(\30D4\30AF\30BB\30EB)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112966813610400570)
,p_name=>'APEX.IG.X.BETWEEN.Y.AND.Z'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F%1\3068%2\306E\9593\306B\3042\308B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112966535265400570)
,p_name=>'APEX.IG.X.CONTAINS.Y'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306B\306F%1\304C\542B\307E\308C\3066\3044\307E\3059')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112966632439400570)
,p_name=>'APEX.IG.X.DOES_NOT_CONTAIN.Y'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306B\306F%1\304C\542B\307E\308C\3066\3044\307E\305B\3093\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112944715610400554)
,p_name=>'APEX.IG.X.DOES_NOT_START_WITH.Y'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F%1\3067\958B\59CB\3055\308C\3066\3044\307E\305B\3093')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112965312193400569)
,p_name=>'APEX.IG.X.EQUALS.Y'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F%1\3068\7B49\3057\3044')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112965575230400569)
,p_name=>'APEX.IG.X.GREATER_THAN.Y'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F%1\3088\308A\5927\304D\3044')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112965657205400569)
,p_name=>'APEX.IG.X.GREATER_THAN_OR_EQUALS.Y'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F%1\4EE5\4E0A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112966340544400570)
,p_name=>'APEX.IG.X.IN.Y'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F%1\306B\542B\307E\308C\308B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112967576508400571)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.DAYS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\904E\53BB%1\65E5\4EE5\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112967382876400570)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.HOURS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\904E\53BB%1\6642\9593\4EE5\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112967175796400570)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MINUTES'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\904E\53BB%1\5206\4EE5\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112967965017400571)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MONTHS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\904E\53BB%1\304B\6708\4EE5\5185')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112967723693400571)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.WEEKS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\904E\53BB%1\9031\9593\4EE5\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112968188184400571)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.YEARS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\904E\53BB%1\5E74\4EE5\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112967449543400570)
,p_name=>'APEX.IG.X.IN_THE_LAST_DAY'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\904E\53BB1\65E5\4EE5\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112967234541400570)
,p_name=>'APEX.IG.X.IN_THE_LAST_HOUR'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\904E\53BB1\6642\9593\4EE5\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112967034473400570)
,p_name=>'APEX.IG.X.IN_THE_LAST_MINUTE'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\904E\53BB1\5206\4EE5\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112967888749400571)
,p_name=>'APEX.IG.X.IN_THE_LAST_MONTH'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\904E\53BB1\304B\6708\4EE5\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112967677062400571)
,p_name=>'APEX.IG.X.IN_THE_LAST_WEEK'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\904E\53BB1\9031\9593\4EE5\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112968099901400571)
,p_name=>'APEX.IG.X.IN_THE_LAST_YEAR'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\904E\53BB1\5E74\4EE5\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112969985594400572)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.DAYS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\6B21\306E%1\65E5\4EE5\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112969735458400572)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.HOURS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\6B21\306E%1\6642\9593\4EE5\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112969564018400572)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\6B21\306E%1\5206\4EE5\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112970341686400573)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\6B21\306E%1\304B\6708\4EE5\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112970161295400573)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\6B21\306E%1\9031\9593\4EE5\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112970541538400573)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.YEARS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\6B21\306E%1\5E74\4EE5\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112969854745400572)
,p_name=>'APEX.IG.X.IN_THE_NEXT_DAY'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\6B21\306E1\65E5\4EE5\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112969634461400572)
,p_name=>'APEX.IG.X.IN_THE_NEXT_HOUR'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\6B21\306E1\6642\9593\4EE5\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112969420584400572)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MINUTE'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\6B21\306E1\5206\4EE5\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112970232965400573)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MONTH'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\6B21\306E1\304B\6708\4EE5\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112970023106400573)
,p_name=>'APEX.IG.X.IN_THE_NEXT_WEEK'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\6B21\306E1\9031\9593\4EE5\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112970445812400573)
,p_name=>'APEX.IG.X.IN_THE_NEXT_YEAR'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\6B21\306E1\5E74\4EE5\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112966082928400569)
,p_name=>'APEX.IG.X.IS_NOT_NULL'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\7A7A\3067\306F\3042\308A\307E\305B\3093')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112965908272400569)
,p_name=>'APEX.IG.X.IS_NULL'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\7A7A\3067\3059')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112965789838400569)
,p_name=>'APEX.IG.X.LESS_THAN.Y'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F%1\3088\308A\5C0F\3055\3044')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112965851267400569)
,p_name=>'APEX.IG.X.LESS_THAN_OR_EQUALS.Y'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F%1\4EE5\4E0B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112966193244400570)
,p_name=>'APEX.IG.X.LIKE.Y'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F%1\3068\985E\4F3C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112966760744400570)
,p_name=>'APEX.IG.X.MATCHES_REGULAR_EXPRESSION.Y'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\6B63\898F\8868\73FE%1\3068\4E00\81F4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112972648822400574)
,p_name=>'APEX.IG.X.MINUTES_AGO'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\5206\524D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112966906612400570)
,p_name=>'APEX.IG.X.NOT_BETWEEN.Y.AND.Z'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F%1\3068%2\306E\9593\306B\306A\3044')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112965450727400569)
,p_name=>'APEX.IG.X.NOT_EQUALS.Y'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F%1\3068\7B49\3057\304F\306A\3044')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112966436274400570)
,p_name=>'APEX.IG.X.NOT_IN.Y'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F%1\306B\542B\307E\308C\306A\3044')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112968794551400572)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.DAYS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\904E\53BB%1\65E5\4EE5\5185\3067\306A\3044')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112968568534400571)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.HOURS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\904E\53BB%1\6642\9593\4EE5\5185\3067\306A\3044')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112968313337400571)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MINUTES'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\904E\53BB%1\5206\4EE5\5185\3067\306A\3044')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112969158438400572)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MONTHS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\904E\53BB%1\304B\6708\4EE5\5185\3067\306A\3044')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112968949310400572)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.WEEKS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\904E\53BB%1\9031\9593\4EE5\5185\3067\306A\3044')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112969372015400572)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.YEARS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\904E\53BB%1\5E74\4EE5\5185\3067\306A\3044')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112968637713400572)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_DAY'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\904E\53BB1\65E5\4EE5\5185\3067\306A\3044')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112968403193400571)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_HOUR'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\904E\53BB1\6642\9593\4EE5\5185\3067\306A\3044')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112968255163400571)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MINUTE'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\904E\53BB1\5206\4EE5\5185\3067\306A\3044')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112969072143400572)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MONTH'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\904E\53BB1\304B\6708\4EE5\5185\3067\306A\3044')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112968856867400572)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_WEEK'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\904E\53BB1\9031\9593\4EE5\5185\3067\306A\3044')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112969277770400572)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_YEAR'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\904E\53BB1\5E74\4EE5\5185\3067\306A\3044')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112971145633400573)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.DAYS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\6B21\306E%1\65E5\4EE5\5185\3067\306A\3044')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112970956357400573)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.HOURS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\6B21\306E%1\6642\9593\4EE5\5185\3067\306A\3044')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112970717227400573)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\6B21\306E%1\5206\4EE5\5185\3067\306A\3044')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112971514912400574)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\6B21\306E%1\304B\6708\4EE5\5185\3067\306A\3044')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112971370463400574)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\6B21\306E%1\9031\9593\4EE5\5185\3067\306A\3044')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112971754682400574)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.YEARS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\6B21\306E%1\5E74\4EE5\5185\3067\306A\3044')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112971045337400573)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_DAY'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\6B21\306E1\65E5\4EE5\5185\3067\306A\3044')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112970839064400573)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_HOUR'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\6B21\306E1\6642\9593\4EE5\5185\3067\306A\3044')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112970615077400573)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MINUTE'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\6B21\306E1\5206\4EE5\5185\3067\306A\3044')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112971445224400574)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MONTH'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\6B21\306E1\304B\6708\4EE5\5185\3067\306A\3044')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112971287705400573)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_WEEK'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\6B21\306E1\9031\9593\4EE5\5185\3067\306A\3044')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112971680600400574)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_YEAR'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\6B21\306E1\5E74\4EE5\5185\3067\306A\3044')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112966246976400570)
,p_name=>'APEX.IG.X.NOT_LIKE.Y'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F%1\3068\985E\4F3C\3057\3066\3044\306A\3044')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112973120759400575)
,p_name=>'APEX.IG.X.STARTS_WITH.Y'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F%1\3067\59CB\307E\308A\307E\3059')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113016700258400606)
,p_name=>'APEX.IG.X_COLUMN'
,p_message_language=>'ja'
,p_message_text=>'X'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112975827531400577)
,p_name=>'APEX.IG.YEARS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5E74')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113016842809400607)
,p_name=>'APEX.IG.Y_COLUMN'
,p_message_language=>'ja'
,p_message_text=>'Y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113016938291400607)
,p_name=>'APEX.IG.Z_COLUMN'
,p_message_language=>'ja'
,p_message_text=>'Z'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113025987448400613)
,p_name=>'APEX.IG_FORMAT_SAMPLE_1'
,p_message_language=>'ja'
,p_message_text=>unistr('2016\5E741\670812\65E5(\6708\66DC\65E5)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113026028238400613)
,p_name=>'APEX.IG_FORMAT_SAMPLE_2'
,p_message_language=>'ja'
,p_message_text=>unistr('1\6708')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113026105014400613)
,p_name=>'APEX.IG_FORMAT_SAMPLE_3'
,p_message_language=>'ja'
,p_message_text=>unistr('16\6642\9593\524D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113026212220400613)
,p_name=>'APEX.IG_FORMAT_SAMPLE_4'
,p_message_language=>'ja'
,p_message_text=>unistr('16\6642\9593\4EE5\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112881222865400506)
,p_name=>'APEX.ITEM.FILE.ACCEPTED_TYPES'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9\306A\30D5\30A1\30A4\30EB\30FB\30BF\30A4\30D7\3002\30B5\30DD\30FC\30C8\3055\308C\308B\30D5\30A1\30A4\30EB\30FB\30BF\30A4\30D7\306F%0\3067\3059\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113008142802400600)
,p_name=>'APEX.ITEM.FILE.BROWSE'
,p_message_language=>'ja'
,p_message_text=>unistr('\53C2\7167')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113007846521400600)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\306E\9078\629E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113007964961400600)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\306E\9078\629E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112881053280400506)
,p_name=>'APEX.ITEM.FILE.DROP_FILE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C9\30E9\30C3\30B0\30FB\30A2\30F3\30C9\30FB\30C9\30ED\30C3\30D7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112881468222400506)
,p_name=>'APEX.ITEM.FILE.DROP_FILES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\3092\30C9\30E9\30C3\30B0\30FB\30A2\30F3\30C9\30FB\30C9\30ED\30C3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112882690246400507)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\3092\9078\629E\3059\308B\304B\3001\3053\3053\306B\30C9\30ED\30C3\30D7\3057\307E\3059')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112882776673400507)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\3092\9078\629E\3059\308B\304B\3001\3053\3053\306B\30C9\30ED\30C3\30D7\3057\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112882826077400507)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\3092\9078\629E\3059\308B\304B\3001\3053\3053\306B\30C9\30ED\30C3\30D7\3057\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112882928266400507)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\3092\9078\629E\3059\308B\304B\3001\3053\3053\306B\30C9\30ED\30C3\30D7\3057\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112881394270400506)
,p_name=>'APEX.ITEM.FILE.FILES_WITH_COUNT'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\30D5\30A1\30A4\30EB')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112881176782400506)
,p_name=>'APEX.ITEM.FILE.MAX_FILE_SIZE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\304C\5927\304D\3059\304E\307E\3059\3002\6700\5927\30D5\30A1\30A4\30EB\30FB\30B5\30A4\30BA\306F%0\3067\3059\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112868974622400497)
,p_name=>'APEX.ITEM.GEOCODE.ADDRESS_REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F4F\6240\306F\5FC5\9808\3067\3059\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112867877877400496)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_CITY'
,p_message_language=>'ja'
,p_message_text=>unistr('\5E02')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112868229620400497)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_COUNTRY'
,p_message_language=>'ja'
,p_message_text=>unistr('\56FD\30B3\30FC\30C9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112867913977400496)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_HOUSENUMBER'
,p_message_language=>'ja'
,p_message_text=>unistr('\756A\5730')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112868895969400497)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LATITUDE'
,p_message_language=>'ja'
,p_message_text=>unistr('\7DEF\5EA6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112868763111400497)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LONGITUDE'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D4C\5EA6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112868605750400497)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MAPLINK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30C3\30D7\306B\8868\793A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112868317739400497)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MATCHSCORE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A18\9332')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112868015522400497)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_POSTALCODE'
,p_message_language=>'ja'
,p_message_text=>unistr('\90F5\4FBF\756A\53F7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112868124470400497)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30C6\30FC\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112867711020400496)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STREET'
,p_message_language=>'ja'
,p_message_text=>unistr('\901A\308A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112867616117400496)
,p_name=>'APEX.ITEM.GEOCODE.DIALOG_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B8\30AA\30B3\30FC\30C7\30A3\30F3\30B0\306E\7D50\679C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112880244814400505)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_DONE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B8\30AA\30B3\30FC\30C9\3042\308A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112880355201400506)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_OPEN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B8\30AA\30B3\30FC\30C9\306A\3057')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112868512069400497)
,p_name=>'APEX.ITEM.GEOCODE.MAP_DIALOG_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30C3\30D7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112868445118400497)
,p_name=>'APEX.ITEM.GEOCODE.NO_DATA_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30C9\30EC\30B9\304C\898B\3064\304B\308A\307E\305B\3093')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112869073530400497)
,p_name=>'APEX.ITEM.GEOCODE.REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\5FC5\9808\3067\3059\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113038805417400623)
,p_name=>'APEX.ITEM.HELP_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D8\30EB\30D7\30FB\30C6\30AD\30B9\30C8: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112932275218400545)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.CHECKED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30A7\30C3\30AF\6E08')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112932327741400545)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.UNCHECKED'
,p_message_language=>'ja'
,p_message_text=>unistr('\672A\30C1\30A7\30C3\30AF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112878211355400504)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'ja'
,p_message_text=>unistr('#LABEL#\304C%0\304B\3089%1\306E\6709\52B9\306A\7BC4\56F2\306B\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112878375849400504)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_MULTIPLE_OF_STEP'
,p_message_language=>'ja'
,p_message_text=>unistr('#LABEL#\304C%0\306E\500D\6570\3067\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112877976406400504)
,p_name=>'APEX.ITEM_TYPE.YES_NO.INVALID_VALUE'
,p_message_language=>'ja'
,p_message_text=>unistr('#LABEL#\306F\5024%0\304A\3088\3073%1\306B\4E00\81F4\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112878193896400504)
,p_name=>'APEX.ITEM_TYPE.YES_NO.NO_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\3044\3044\3048')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112956486227400562)
,p_name=>'APEX.ITEM_TYPE.YES_NO.OFF_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112956551452400562)
,p_name=>'APEX.ITEM_TYPE.YES_NO.ON_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112878040881400504)
,p_name=>'APEX.ITEM_TYPE.YES_NO.YES_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\306F\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112861430366400492)
,p_name=>'APEX.LIST_MANAGER.ADD_ENTRY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30F3\30C8\30EA\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112990688798400588)
,p_name=>'APEX.LIST_MANAGER.BUTTON_ADD'
,p_message_language=>'ja'
,p_message_text=>unistr('\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112990710488400588)
,p_name=>'APEX.LIST_MANAGER.BUTTON_REMOVE'
,p_message_language=>'ja'
,p_message_text=>unistr('\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112861598104400492)
,p_name=>'APEX.LIST_MANAGER.SELECTED_ENTRY'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\3055\308C\305F\30A8\30F3\30C8\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112994430177400591)
,p_name=>'APEX.LTO.ADVANCED'
,p_message_language=>'ja'
,p_message_text=>unistr('\62E1\5F35')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112994781978400591)
,p_name=>'APEX.LTO.CANCEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\53D6\6D88')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112994517022400591)
,p_name=>'APEX.LTO.COMMON'
,p_message_language=>'ja'
,p_message_text=>unistr('\5171\901A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112994867610400591)
,p_name=>'APEX.LTO.LIVE_TEMPLATE_OPTIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30A4\30D6\30FB\30C6\30F3\30D7\30EC\30FC\30C8\30FB\30AA\30D7\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112995437088400591)
,p_name=>'APEX.LTO.NOT_APPLICABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30B3\30F3\30DD\30FC\30CD\30F3\30C8\306F\30DA\30FC\30B8\306B\30EC\30F3\30C0\30EA\30F3\30B0\3055\308C\306A\3044\305F\3081\3001\30C6\30F3\30D7\30EC\30FC\30C8\30FB\30AA\30D7\30B7\30E7\30F3\306F\4F7F\7528\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112994326209400590)
,p_name=>'APEX.LTO.NO_OPTIONS_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30F3\30D7\30EC\30FC\30C8\30FB\30AA\30D7\30B7\30E7\30F3\304C\898B\3064\304B\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112994618871400591)
,p_name=>'APEX.LTO.SAVE'
,p_message_language=>'ja'
,p_message_text=>unistr('\4FDD\5B58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112869992637400498)
,p_name=>'APEX.MAPS.CLEAR_CIRCLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5186\306E\30AF\30EA\30A2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112871740313400499)
,p_name=>'APEX.MAPS.CUSTOM_STYLES_INVALID_JSON'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30B9\30BF\30E0\30FB\30B9\30BF\30A4\30EB\306F\6709\52B9\306AJSON\3067\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112870245989400498)
,p_name=>'APEX.MAPS.DISTANCE_TOOL'
,p_message_language=>'ja'
,p_message_text=>unistr('\8DDD\96E2\30C4\30FC\30EB')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112870011885400498)
,p_name=>'APEX.MAPS.DRAW_CIRCLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5186\306E\63CF\753B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112862633209400493)
,p_name=>'APEX.MAPS.FACETED_SEARCH_NEEDS_REGION_QUERY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30BB\30C3\30C8\691C\7D22\306B\306F\3001\30EA\30FC\30B8\30E7\30F3\30FB\30EC\30D9\30EB\306E\30C7\30FC\30BF\30FB\30BD\30FC\30B9\304C\5FC5\8981\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112865230652400494)
,p_name=>'APEX.MAPS.FIND_MY_LOCATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\4F4D\7F6E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112866394381400495)
,p_name=>'APEX.MAPS.INIT_POINT_COORDINATES_INVALID'
,p_message_language=>'ja'
,p_message_text=>unistr('\521D\671F\4F4D\7F6E\5EA7\6A19\304C\7121\52B9\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112863713353400493)
,p_name=>'APEX.MAPS.INIT_POINT_GEOMETRY_REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\521D\671F\4F4D\7F6E\306F\30DD\30A4\30F3\30C8\30FB\30B8\30AA\30E1\30C8\30EA\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112866146607400495)
,p_name=>'APEX.MAPS.KM'
,p_message_language=>'ja'
,p_message_text=>'km'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112864757419400494)
,p_name=>'APEX.MAPS.LAYER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30A4\30E4\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112998012791400593)
,p_name=>'APEX.MAPS.LAYER_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30A4\30E4\30FC: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112869302321400497)
,p_name=>'APEX.MAPS.MAP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30C3\30D7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112862503826400492)
,p_name=>'APEX.MAPS.MAP_MESSAGES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E1\30C3\30BB\30FC\30B8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112866205640400495)
,p_name=>'APEX.MAPS.MILES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30A4\30EB')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112997060477400592)
,p_name=>'APEX.MAPS.MORE_DATA_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\306B\6700\5927\8A31\5BB9\6570\3088\308A\591A\3044%0\3092\8D85\3048\308B\884C\304C\542B\307E\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112864579640400494)
,p_name=>'APEX.MAPS.ORACLE_MAP_COPYRIGHT'
,p_message_language=>'ja'
,p_message_text=>unistr('&copy; 2018 Oracle Corporation &nbsp;&nbsp; <a target="_blank" href="https://elocation.oracle.com/elocation/legal.html">\4F7F\7528\6761\4EF6</a> &nbsp;&nbsp; Map data &copy; 2017 HERE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112863449345400493)
,p_name=>'APEX.MAPS.ORACLE_SDO_GEOMETRY_NOT_AVAILABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('SDO_GEOMETRY\30C7\30FC\30BF\578B\306F\3001\3053\306E\30C7\30FC\30BF\30D9\30FC\30B9\3067\4F7F\7528\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112864670144400494)
,p_name=>'APEX.MAPS.OSM_MAP_COPYRIGHT'
,p_message_language=>'ja'
,p_message_text=>unistr('<a target="_blank" href="http://openmaptiles.org"> &copy; OpenMapTiles </a> &nbsp; <a target="_blank" href="https://www.openstreetmap.org/copyright"> &copy; OpenStreetMap\30B3\30F3\30C8\30EA\30D3\30E5\30FC\30BF </a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112864893108400494)
,p_name=>'APEX.MAPS.POINTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DD\30A4\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112998133504400593)
,p_name=>'APEX.MAPS.POINTS_COUNT'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\30DD\30A4\30F3\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112870105883400498)
,p_name=>'APEX.MAPS.RECTANGLE_ZOOM'
,p_message_language=>'ja'
,p_message_text=>unistr('\56DB\89D2\5F62\30BA\30FC\30E0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112869820239400498)
,p_name=>'APEX.MAPS.REMOVE_MESSAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\524A\9664')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112865199044400494)
,p_name=>'APEX.MAPS.RESET_BEARING_TO_NORTH'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B9\89D2\3092\5317\306B\30EA\30BB\30C3\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112945441385400554)
,p_name=>'APEX.MAPS.TOGGLE_2D_MODE'
,p_message_language=>'ja'
,p_message_text=>unistr('2D\30E2\30FC\30C9\306B\5207\66FF\3048')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112945585719400554)
,p_name=>'APEX.MAPS.TOGGLE_3D_MODE'
,p_message_language=>'ja'
,p_message_text=>unistr('3D\30E2\30FC\30C9\306B\5207\66FF\3048')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112869779899400498)
,p_name=>'APEX.MAPS.TOGGLE_COPYRIGHT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30D4\30FC\30E9\30A4\30C8\306E\5207\66FF\3048')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112870392353400498)
,p_name=>'APEX.MAPS.TOTAL_DISTANCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\306E\8DDD\96E2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112864903666400494)
,p_name=>'APEX.MAPS.ZOOM_IN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BA\30FC\30E0\30FB\30A4\30F3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112865018705400494)
,p_name=>'APEX.MAPS.ZOOM_OUT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BA\30FC\30E0\30FB\30A2\30A6\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112992518045400589)
,p_name=>'APEX.MARKDOWN.BOLD'
,p_message_language=>'ja'
,p_message_text=>unistr('\592A\5B57')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112993462350400590)
,p_name=>'APEX.MARKDOWN.IMAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30E1\30FC\30B8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112993084942400589)
,p_name=>'APEX.MARKDOWN.INLINE_CODE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30F3\30E9\30A4\30F3\30FB\30B3\30FC\30C9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113006677546400599)
,p_name=>'APEX.MARKDOWN.INSERT_IMAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30E1\30FC\30B8\306E\633F\5165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113006782616400599)
,p_name=>'APEX.MARKDOWN.INSERT_LINK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30F3\30AF\306E\633F\5165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112992624314400589)
,p_name=>'APEX.MARKDOWN.ITALIC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30BF\30EA\30C3\30AF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113007351332400600)
,p_name=>'APEX.MARKDOWN.LINK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30F3\30AF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112993388976400590)
,p_name=>'APEX.MARKDOWN.LIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112993238442400590)
,p_name=>'APEX.MARKDOWN.ORDERED_LIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\9806\5E8F\4ED8\3051\3055\308C\305F\30EA\30B9\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112992792445400589)
,p_name=>'APEX.MARKDOWN.PREVIEW'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30EC\30D3\30E5\30FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112992881243400589)
,p_name=>'APEX.MARKDOWN.PREVIEW_EMPTY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30EC\30D3\30E5\30FC\5BFE\8C61\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112992980561400589)
,p_name=>'APEX.MARKDOWN.STRIKETHROUGH'
,p_message_language=>'ja'
,p_message_text=>unistr('\53D6\6D88\7DDA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112993126943400590)
,p_name=>'APEX.MARKDOWN.UNORDERED_LIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\9806\5E8F\4ED8\3051\3055\308C\3066\3044\306A\3044\30EA\30B9\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112972088605400574)
,p_name=>'APEX.MENU.CURRENT_MENU'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30EC\30F3\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113029578194400616)
,p_name=>'APEX.MENU.OVERFLOW_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A73\7D30...')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112971932833400574)
,p_name=>'APEX.MENU.PROCESSING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30FC\30C9\4E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113003779144400597)
,p_name=>'APEX.NOTIFICATION_MESSAGE_HEADING'
,p_message_language=>'ja'
,p_message_text=>unistr('\901A\77E5\30E1\30C3\30BB\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112977018899400578)
,p_name=>'APEX.NUMBER_FIELD.VALUE_GREATER_MAX_VALUE'
,p_message_language=>'ja'
,p_message_text=>unistr('#LABEL#\306F%0\4EE5\4E0B\306E\6570\5024\306B\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112977113662400578)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID'
,p_message_language=>'ja'
,p_message_text=>unistr('#LABEL#\306F\6709\52B9\306A\6570\5024\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112977255787400578)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID2'
,p_message_language=>'ja'
,p_message_text=>unistr('#LABEL#\304C\6570\5024\66F8\5F0F%0\3068\4E00\81F4\3057\307E\305B\3093(\4F8B: %1)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112976996815400578)
,p_name=>'APEX.NUMBER_FIELD.VALUE_LESS_MIN_VALUE'
,p_message_language=>'ja'
,p_message_text=>unistr('#LABEL#\306F%0\4EE5\4E0A\306E\6570\5024\306B\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112976857057400578)
,p_name=>'APEX.NUMBER_FIELD.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'ja'
,p_message_text=>unistr('#LABEL#\306F%0\304B\3089%1\306E\9593\306E\6570\5024\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112972146412400574)
,p_name=>'APEX.OPENS_IN_NEW_WINDOW_LOWER'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F\30A6\30A3\30F3\30C9\30A6\3067\958B\304F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112925376579400539)
,p_name=>'APEX.PAGE.DUPLICATE_SUBMIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DA\30FC\30B8\306F\3059\3067\306B\9001\4FE1\3055\308C\3066\3044\308B\305F\3081\3001\518D\9001\4FE1\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112907920469400526)
,p_name=>'APEX.PAGE.NOT_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\300C%0\300D\306E\30DA\30FC\30B8\300C%1\300D\304C\898B\3064\304B\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112941780255400552)
,p_name=>'APEX.PAGE_ITEM_IS_REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('#LABEL#\306B\5024\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112885027000400509)
,p_name=>'APEX.POPUP.SEARCH'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112991005825400588)
,p_name=>'APEX.POPUP_LOV.BUTTON_CLOSE'
,p_message_language=>'ja'
,p_message_text=>unistr('\9589\3058\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112990964773400588)
,p_name=>'APEX.POPUP_LOV.BUTTON_FIND'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\3092\691C\7D22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112991289127400588)
,p_name=>'APEX.POPUP_LOV.BUTTON_NEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112991122896400588)
,p_name=>'APEX.POPUP_LOV.BUTTON_PREV'
,p_message_language=>'ja'
,p_message_text=>unistr('\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112877113562400503)
,p_name=>'APEX.POPUP_LOV.FILTER_REQ'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22\6587\5B57\5217\3092%0\6587\5B57\4EE5\4E0A\3067\5165\529B\3057\3066\304F\3060\3055\3044\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112946687868400555)
,p_name=>'APEX.POPUP_LOV.ICON_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DD\30C3\30D7\30A2\30C3\30D7LOV: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112877203851400503)
,p_name=>'APEX.POPUP_LOV.INITIAL_FILTER_REQ'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22\8A9E\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112877043954400503)
,p_name=>'APEX.POPUP_LOV.NO_RESULTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D50\679C\304C\898B\3064\304B\308A\307E\305B\3093\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112876983469400503)
,p_name=>'APEX.POPUP_LOV.REMOVE_VALUE'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306E\524A\9664')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112964820173400569)
,p_name=>'APEX.POPUP_LOV.SEARCH'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22\6587\5B57\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112990874115400588)
,p_name=>'APEX.POPUP_LOV.TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113001500937400596)
,p_name=>'APEX.PROCESSING'
,p_message_language=>'ja'
,p_message_text=>unistr('\51E6\7406\4E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112875587741400502)
,p_name=>'APEX.PWA.DIALOG.TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DB\30FC\30E0\753B\9762\306B\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112871537266400499)
,p_name=>'APEX.PWA.INSTRUCTIONS'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\3054\4F7F\7528\306E\30C7\30D0\30A4\30B9\307E\305F\306F\30D6\30E9\30A6\30B6\306F\3001\73FE\5728\30D7\30ED\30B0\30EC\30C3\30B7\30D6Web\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30A4\30F3\30B9\30C8\30FC\30EB\3092\30B5\30DD\30FC\30C8\3057\3066\3044\306A\3044\3088\3046\3067\3059\3002</p>'),
unistr('    <p class="a-pwaDialog-intro">\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304C\30C7\30D0\30A4\30B9\306B\3059\3067\306B\30A4\30F3\30B9\30C8\30FC\30EB\3055\308C\3066\3044\308B\5834\5408\3001\30DB\30FC\30E0\753B\9762\304B\3089\958B\304D\307E\3059\3002</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112871183271400499)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.FIREFOX'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\3053\306EWeb\30B5\30A4\30C8\306B\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\6A5F\80FD\304C\3042\308A\307E\3059\3002\5168\753B\9762\3067\4F7F\7528\3059\308B\306B\306F\3001\30DB\30FC\30E0\753B\9762\306B\8FFD\52A0\3057\3066\304F\3060\3055\3044\3002</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \4E0B\90E8\306E\30CA\30D3\30B2\30FC\30B7\30E7\30F3\306B\3042\308B<strong>\300C\30E1\30CB\30E5\30FC\300D</strong>\30A2\30A4\30B3\30F3\3092\30BF\30C3\30D7\3057\307E\3059</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. <strong>\300C\30A4\30F3\30B9\30C8\30FC\30EB\300D</strong>\3092\30BF\30C3\30D7\3057\307E\3059</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. <strong>\300C\8FFD\52A0\300D</strong>\3092\30BF\30C3\30D7\3057\3066\78BA\8A8D\3057\307E\3059</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112871280868400499)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.WEBVIEW'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\3053\306EWeb\30B5\30A4\30C8\306B\306F\3001Chrome\307E\305F\306FEdge\3067\306E\6700\9AD8\306E\4F53\9A13\3067\3042\308B\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\6A5F\80FD\304C\3042\308A\307E\3059\3002</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \30A2\30C9\30EC\30B9\30FB\30D0\30FC\306E\6A2A\306B\3042\308B<strong>\300C\30E1\30CB\30E5\30FC\300D</strong>\30A2\30A4\30B3\30F3\3092\30BF\30C3\30D7\3057\307E\3059</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. <strong>\300C\30A4\30F3\30B9\30C8\30FC\30EB\300D</strong>\3092\30BF\30C3\30D7\3057\307E\3059</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112870813405400499)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.GSA'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\3053\306EWeb\30B5\30A4\30C8\306B\306F\3001Safari\3067\306E\6700\9AD8\306E\4F53\9A13\3067\3042\308B\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\6A5F\80FD\304C\3042\308A\307E\3059\3002</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \4E0B\90E8\306E\30CA\30D3\30B2\30FC\30B7\30E7\30F3\306B\3042\308B<strong>\300C\5171\6709\300D</strong>\30A2\30A4\30B3\30F3\3092\30BF\30C3\30D7\3057\307E\3059</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. <strong>\300CSafari\3067\958B\304F\300D</strong>\3092\30BF\30C3\30D7\3057\307E\3059</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112870592216400498)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPAD'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\3053\306EWeb\30B5\30A4\30C8\306B\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\6A5F\80FD\304C\3042\308A\307E\3059\3002\30DB\30FC\30E0\753B\9762\306B\8FFD\52A0\3059\308B\3068\3001\6700\9AD8\306E\4F53\9A13\304C\3067\304D\307E\3059\3002</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \30A2\30C9\30EC\30B9\30FB\30D0\30FC\306E\6A2A\306B\3042\308B<strong>\300C\5171\6709\300D</strong>\30A2\30A4\30B3\30F3\3092\30BF\30C3\30D7\3057\307E\3059</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. <strong>\300C\30DB\30FC\30E0\753B\9762\306B\8FFD\52A0\300D</strong>\3092\30BF\30C3\30D7\3057\307E\3059</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. <strong style="color:#007AE1;">\300C\8FFD\52A0\300D</strong>\3092\30BF\30C3\30D7\3057\3066\78BA\8A8D\3057\307E\3059</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112870469294400498)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\3053\306EWeb\30B5\30A4\30C8\306B\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\6A5F\80FD\304C\3042\308A\307E\3059\3002\30DB\30FC\30E0\753B\9762\306B\8FFD\52A0\3059\308B\3068\3001\6700\9AD8\306E\4F53\9A13\304C\3067\304D\307E\3059\3002</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \4E0B\90E8\306E\30CA\30D3\30B2\30FC\30B7\30E7\30F3\306B\3042\308B<strong>\300C\5171\6709\300D</strong>\30A2\30A4\30B3\30F3\3092\30BF\30C3\30D7\3057\307E\3059</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. \4E0B\306B\30B9\30AF\30ED\30FC\30EB\3057\3066<strong>\300C\30DB\30FC\30E0\753B\9762\306B\8FFD\52A0\300D</strong>\3092\30BF\30C3\30D7\3057\307E\3059</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. <strong style="color:#007AE1;">\300C\8FFD\52A0\300D</strong>\3092\30BF\30C3\30D7\3057\3066\78BA\8A8D\3057\307E\3059</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112865404869400495)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE.15'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\3053\306EWeb\30B5\30A4\30C8\306B\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\6A5F\80FD\304C\3042\308A\307E\3059\3002\30DB\30FC\30E0\753B\9762\306B\8FFD\52A0\3059\308B\3068\3001\6700\9AD8\306E\4F53\9A13\304C\3067\304D\307E\3059\3002</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-15.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \30A2\30C9\30EC\30B9\30FB\30D0\30FC\306E\6A2A\306B\3042\308B<strong>\300C\8A73\7D30\300D</strong>\30A2\30A4\30B3\30F3\3092\30BF\30C3\30D7\3057\307E\3059</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. <strong>\300C\30DB\30FC\30E0\753B\9762\306B\8FFD\52A0\300D</strong>\3092\30BF\30C3\30D7\3057\307E\3059</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. <strong style="color:#007AE1;">\300C\8FFD\52A0\300D</strong>\3092\30BF\30C3\30D7\3057\3066\78BA\8A8D\3057\307E\3059</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112870740399400499)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPAD'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\3053\306EWeb\30B5\30A4\30C8\306B\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\6A5F\80FD\304C\3042\308A\307E\3059\3002\30DB\30FC\30E0\753B\9762\306B\8FFD\52A0\3059\308B\3068\3001\6700\9AD8\306E\4F53\9A13\304C\3067\304D\307E\3059\3002</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">\30A2\30C9\30EC\30B9\30FB\30D0\30FC\306E\6A2A\306B\3042\308B<strong>\300C\5171\6709\300D</strong>\30A2\30A4\30B3\30F3\3092\30BF\30C3\30D7\3057\307E\3059</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText"><strong>\300CSafari\3067\958B\304F\300D</strong>\3092\30BF\30C3\30D7\3057\307E\3059</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112870611370400498)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPHONE'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\3053\306EWeb\30B5\30A4\30C8\306B\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\6A5F\80FD\304C\3042\308A\307E\3059\3002\30DB\30FC\30E0\753B\9762\306B\8FFD\52A0\3059\308B\3068\3001\6700\9AD8\306E\4F53\9A13\304C\3067\304D\307E\3059\3002</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">\4E0B\90E8\306E\30CA\30D3\30B2\30FC\30B7\30E7\30F3\306B\3042\308B<strong>\300C\5171\6709\300D</strong>\30A2\30A4\30B3\30F3\3092\30BF\30C3\30D7\3057\307E\3059</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText"><strong>\300CSafari\3067\958B\304F\300D</strong>\3092\30BF\30C3\30D7\3057\307E\3059</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112871471923400499)
,p_name=>'APEX.PWA.INSTRUCTIONS.LINUX.FIREFOX'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\3053\306EWeb\30B5\30A4\30C8\306B\306F\3001Chrome\3067\306E\6700\9AD8\306E\4F53\9A13\3067\3042\308B\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\6A5F\80FD\304C\3042\308A\307E\3059\3002</p>'),
unistr('    <p class="a-pwaDialog-intro">Firefox\306F\73FE\5728\3001Web\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30A4\30F3\30B9\30C8\30FC\30EB\3092\30B5\30DD\30FC\30C8\3057\3066\3044\307E\305B\3093\3002</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112870965546400499)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.FIREFOX'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\3053\306EWeb\30B5\30A4\30C8\306B\306F\3001Chrome\307E\305F\306FEdge\3067\306E\6700\9AD8\306E\4F53\9A13\3067\3042\308B\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\6A5F\80FD\304C\3042\308A\307E\3059\3002</p>'),
unistr('    <p class="a-pwaDialog-intro">Firefox\306F\73FE\5728\3001macOS\3078\306EWeb\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30A4\30F3\30B9\30C8\30FC\30EB\3092\30B5\30DD\30FC\30C8\3057\3066\3044\307E\305B\3093\3002</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112871015592400499)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.SAFARI'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\3053\306EWeb\30B5\30A4\30C8\306B\306F\3001Chrome\307E\305F\306FEdge\3067\306E\6700\9AD8\306E\4F53\9A13\3067\3042\308B\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\6A5F\80FD\304C\3042\308A\307E\3059\3002</p>'),
unistr('    <p class="a-pwaDialog-intro">Safari\306F\73FE\5728\3001macOS\3078\306EWeb\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30A4\30F3\30B9\30C8\30FC\30EB\3092\30B5\30DD\30FC\30C8\3057\3066\3044\307E\305B\3093\3002</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112871308971400499)
,p_name=>'APEX.PWA.INSTRUCTIONS.WINDOWS.FIREFOX'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\3053\306EWeb\30B5\30A4\30C8\306B\306F\3001Chrome\307E\305F\306FEdge\3067\306E\6700\9AD8\306E\4F53\9A13\3067\3042\308B\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\6A5F\80FD\304C\3042\308A\307E\3059\3002</p>'),
unistr('    <p class="a-pwaDialog-intro">Firefox\306F\73FE\5728\3001Windows\3078\306EWeb\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\30A4\30F3\30B9\30C8\30FC\30EB\3092\30B5\30DD\30FC\30C8\3057\3066\3044\307E\305B\3093\3002</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112873891639400501)
,p_name=>'APEX.PWA.OFFLINE.BODY'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<main>',
'    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 400 280" role="presentation">',
'      <g fill="none">',
'        <path d="M316.846 213.183c39.532 0 63.154-30.455 63.154-62.764 0-30.943-22.158-56.615-51.441-62.179v-1.17c0-48.123-38.947-87.07-87.07-87.07-39.044 0-72.036 25.672-83.066 61.007-8.492-3.612-17.863-5.564-27.722-5.564-34.261 0-62.764 24.11-69.69'
||'4 56.322a51.007 51.007 0 0 0-9.468-.879C23.036 110.79 0 133.825 0 162.327c0 28.405 23.036 51.441 51.441 51.441l265.405-.585z" fill="currentColor" opacity=".2"/>',
'        <circle fill="#D63B25" cx="336" cy="216" r="64"/>',
'        <path d="M367.357 198.439c-.395-.395-.947-.632-1.657-.632-.71 0-1.184.237-1.657.632L351.97 210.51l-10.494-10.493 12.072-12.072c.395-.395.71-.947.71-1.657A2.29 2.29 0 0 0 351.97 184c-.631 0-1.183.237-1.657.631l-12.071 12.072-7.496-7.496c-.394-'
||'.394-.947-.71-1.657-.71a2.29 2.29 0 0 0-2.288 2.288c0 .632.237 1.184.71 1.657l2.604 2.604-13.176 13.176a13.781 13.781 0 0 0-4.024 9.705c0 3.787 1.499 7.18 4.024 9.705l2.13 2.13-14.36 14.36c-.394.394-.71.947-.71 1.657a2.29 2.29 0 0 0 2.288 2.288c.631 '
||'0 1.184-.237 1.657-.71l14.36-14.36 1.736 1.736a13.781 13.781 0 0 0 9.704 4.024c3.787 0 7.18-1.5 9.705-4.024l13.176-13.177 2.92 2.92c.394.394.946.71 1.656.71a2.29 2.29 0 0 0 2.289-2.288c0-.632-.237-1.184-.71-1.657l-7.575-7.496 12.072-12.071c.394-.395.'
||'71-.947.71-1.657.079-.632-.237-1.184-.631-1.578zm-27.142 33.059a9.398 9.398 0 0 1-6.47 2.603c-2.525 0-4.813-.946-6.47-2.603l-7.1-7.101a9.124 9.124 0 0 1-2.683-6.47 9.124 9.124 0 0 1 2.682-6.47l13.177-13.176 3.156 3.156c.079.079.079.158.158.158l.157.1'
||'57 13.413 13.413c.08.08.08.158.158.158l.158.158 2.761 2.762-13.097 13.255z" fill="#FFF"/>',
'      </g>',
'    </svg>',
unistr('    <h1>\63A5\7D9A\3067\304D\307E\305B\3093</h1>'),
unistr('    <p>\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3092\4F7F\7528\3059\308B\306B\306F\3001\30A4\30F3\30BF\30FC\30CD\30C3\30C8\63A5\7D9A\304C\5FC5\8981\3067\3059\3002</p>'),
unistr('    <button type="button">\518D\8A66\884C</button>'),
'</main>',
'',
'<script>',
'    document.querySelector("button").addEventListener("click", () => {',
'        window.location.reload();',
'    });',
'</script>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112873723759400501)
,p_name=>'APEX.PWA.OFFLINE.TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\63A5\7D9A\3067\304D\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113013594144400604)
,p_name=>'APEX.REGION.CSSCALENDAR.ADD'
,p_message_language=>'ja'
,p_message_text=>unistr('\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112957959498400563)
,p_name=>'APEX.REGION.CSSCALENDAR.ALL_DAY'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D42\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113036859922400621)
,p_name=>'APEX.REGION.CSSCALENDAR.BUTTON.SENDEMAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('\62DB\5F85\306E\9001\4FE1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113036648186400621)
,p_name=>'APEX.REGION.CSSCALENDAR.CHOOSE_ACTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30D7\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112959766597400565)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_ALLDAY'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D42\65E5\306E\65E5\3054\3068\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112959536314400565)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_TIME_SPECIFIC'
,p_message_language=>'ja'
,p_message_text=>unistr('\6642\9593\4ED8\304D\306E\30C7\30FC\30BF\306E\65E5\3054\3068\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113004442024400598)
,p_name=>'APEX.REGION.CSSCALENDAR.DAY'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112998882662400594)
,p_name=>'APEX.REGION.CSSCALENDAR.DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\8AAC\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112889472412400512)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.CSV'
,p_message_language=>'ja'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112889244359400512)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.ICALENDAR'
,p_message_language=>'ja'
,p_message_text=>'iCal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112889188842400512)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.PDF'
,p_message_language=>'ja'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112889335607400512)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.XML'
,p_message_language=>'ja'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112888872919400512)
,p_name=>'APEX.REGION.CSSCALENDAR.ENDDATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D42\4E86\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112889004474400512)
,p_name=>'APEX.REGION.CSSCALENDAR.EVENTNAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30D9\30F3\30C8\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113036790302400621)
,p_name=>'APEX.REGION.CSSCALENDAR.INVITATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\62DB\5F85')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113004594844400598)
,p_name=>'APEX.REGION.CSSCALENDAR.LIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113004257807400598)
,p_name=>'APEX.REGION.CSSCALENDAR.MONTH'
,p_message_language=>'ja'
,p_message_text=>unistr('\6708')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113007088381400600)
,p_name=>'APEX.REGION.CSSCALENDAR.NEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113021361925400610)
,p_name=>'APEX.REGION.CSSCALENDAR.NOEVENTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A4\30D9\30F3\30C8\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113037095212400621)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.FORM'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E2\5B58\306E\30A4\30D9\30F3\30C8\3092\7DE8\96C6\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113036969327400621)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.SEND'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\3067\62DB\5F85\3092\9001\4FE1\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113007123334400600)
,p_name=>'APEX.REGION.CSSCALENDAR.PREVIOUS'
,p_message_language=>'ja'
,p_message_text=>unistr('\524D')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113015116370400605)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\306E\9001\4FE1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113014954432400605)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.BUTTON'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\306E\9001\4FE1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113037714077400622)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\306E\30D5\30A3\30FC\30EB\30C9\304C\5FC5\9808\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113037612844400622)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\62DB\5F85\306E\9001\4FE1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113036599351400621)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.SUBJECT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4EF6\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113015051017400605)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.TO'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9B\5148')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112888962449400512)
,p_name=>'APEX.REGION.CSSCALENDAR.STARTDATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\59CB\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113012827467400604)
,p_name=>'APEX.REGION.CSSCALENDAR.TABLEFORM'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306E\30D5\30A9\30FC\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112959398367400564)
,p_name=>'APEX.REGION.CSSCALENDAR.TIME'
,p_message_language=>'ja'
,p_message_text=>unistr('\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113007204985400600)
,p_name=>'APEX.REGION.CSSCALENDAR.TODAY'
,p_message_language=>'ja'
,p_message_text=>unistr('\4ECA\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113005039362400598)
,p_name=>'APEX.REGION.CSSCALENDAR.VIEW'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D3\30E5\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113004320325400598)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEK'
,p_message_language=>'ja'
,p_message_text=>unistr('\9031')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112959636187400565)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_ALLDAY'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D42\65E5\306E\9031\3054\3068\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112959403227400564)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_TIME_SPECIFIC'
,p_message_language=>'ja'
,p_message_text=>unistr('\6642\9593\4ED8\304D\306E\30C7\30FC\30BF\306E\9031\3054\3068\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113004940167400598)
,p_name=>'APEX.REGION.CSSCALENDAR.YEAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\5E74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113004656015400598)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.COLUMNS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113004791147400598)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.LOAD_MORE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3055\3089\306B\30ED\30FC\30C9...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112936816704400548)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.BACK'
,p_message_language=>'ja'
,p_message_text=>unistr('\623B\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112883150102400508)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.LOAD_MORE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3055\3089\306B\30ED\30FC\30C9...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112885214783400509)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.SEARCH'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113004831166400598)
,p_name=>'APEX.REGION.JQM_REFLOW.LOAD_MORE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3055\3089\306B\30ED\30FC\30C9...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113006925607400600)
,p_name=>'APEX.REGION.NOT_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3ID %0\304C\898B\3064\304B\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112885154883400509)
,p_name=>'APEX.REGION.NO_DATA_FOUND_MESSAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\304C\898B\3064\304B\308A\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112909267601400527)
,p_name=>'APEX.REGION.PAGINATION.RESET_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\306E\30DA\30FC\30B8\533A\5207\308A\3092\30EA\30BB\30C3\30C8\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112877432441400503)
,p_name=>'APEX.REGION.PAGINATION.UNHANDLED_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\306E\30DA\30FC\30B8\533A\5207\308A\306E\8A2D\5B9A\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112998265058400593)
,p_name=>'APEX.REGION.RESPONSIVE_TABLE.COLUMNS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113006804404400599)
,p_name=>'APEX.REGION.TYPE_NOT_SUPPORTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\30FB\30BF\30A4\30D7%0\306F\30B5\30DD\30FC\30C8\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112877341829400503)
,p_name=>'APEX.REGION.UNHANDLED_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3"#COMPONENT_NAME#"\306E\30EC\30F3\30C0\30EA\30F3\30B0\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112941824146400552)
,p_name=>'APEX.REGION_COLUMN_IS_REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('#COLUMN_HEADER#\306B\5024\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113036123802400621)
,p_name=>'APEX.RICH_TEXT_EDITOR.ACCESSIBLE_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\3001\30EA\30C3\30C1\30FB\30C6\30AD\30B9\30C8\30FB\30A8\30C7\30A3\30BF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112943987288400553)
,p_name=>'APEX.RICH_TEXT_EDITOR.MAXIMUM_LENGTH_EXCEEDED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30C3\30C1\30FB\30C6\30AD\30B9\30C8HTML\30DE\30FC\30AF\30A2\30C3\30D7\304C\30A2\30A4\30C6\30E0\306E\6700\5927\9577\3092\8D85\3048\3066\3044\307E\3059(\5B9F\969B\306F%0\6587\5B57\3067\3001%1\6587\5B57\304C\8A31\53EF\3055\308C\3066\3044\307E\3059)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113003860756400597)
,p_name=>'APEX.RV.DELETE'
,p_message_language=>'ja'
,p_message_text=>unistr('\524A\9664')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112995662044400591)
,p_name=>'APEX.RV.DUPLICATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8907\88FD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112993970612400590)
,p_name=>'APEX.RV.EXCLUDE_HIDDEN'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\5217')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112993839111400590)
,p_name=>'APEX.RV.EXCLUDE_NULL'
,p_message_language=>'ja'
,p_message_text=>unistr('NULL\5024\306E\9664\5916')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113003934465400597)
,p_name=>'APEX.RV.INSERT'
,p_message_language=>'ja'
,p_message_text=>unistr('\8FFD\52A0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112957533324400563)
,p_name=>'APEX.RV.MOVE_DOWN'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0B\306B\79FB\52D5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112957671197400563)
,p_name=>'APEX.RV.MOVE_UP'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0A\306B\79FB\52D5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112993641859400590)
,p_name=>'APEX.RV.NEXT_RECORD'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112994233040400590)
,p_name=>'APEX.RV.NOT_GROUPED_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\305D\306E\4ED6\306E\5217')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112993793797400590)
,p_name=>'APEX.RV.PREV_RECORD'
,p_message_language=>'ja'
,p_message_text=>unistr('\524D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112994040712400590)
,p_name=>'APEX.RV.REC_X'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C%0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112994120147400590)
,p_name=>'APEX.RV.REC_XY'
,p_message_language=>'ja'
,p_message_text=>unistr('%1\884C\4E2D%0\884C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112995746354400591)
,p_name=>'APEX.RV.REFRESH'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30D5\30EC\30C3\30B7\30E5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112995848309400591)
,p_name=>'APEX.RV.REVERT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5909\66F4\306E\56DE\5FA9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112993502994400590)
,p_name=>'APEX.RV.SETTINGS_MENU'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\8A2D\5B9A\300D\30E1\30CB\30E5\30FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112954517565400561)
,p_name=>'APEX.SAMPLE_FORMAT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F8B: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112862007171400492)
,p_name=>'APEX.SESSION.ALERT.CREATE_NEW'
,p_message_language=>'ja'
,p_message_text=>unistr('\518D\5EA6\30B5\30A4\30F3\30A4\30F3\3057\3066\304F\3060\3055\3044')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112861999879400492)
,p_name=>'APEX.SESSION.ALERT.EXPIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30C3\30B7\30E7\30F3\304C\7D42\4E86\3057\307E\3057\305F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112862197975400492)
,p_name=>'APEX.SESSION.ALERT.EXTEND'
,p_message_language=>'ja'
,p_message_text=>unistr('\5EF6\9577')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112861706455400492)
,p_name=>'APEX.SESSION.ALERT.IDLE_WARN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30C3\30B7\30E7\30F3\306F%0\306B\7D42\4E86\3057\307E\3059\3002\5EF6\9577\3057\307E\3059\304B\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112861804758400492)
,p_name=>'APEX.SESSION.ALERT.MAX_WARN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30C3\30B7\30E7\30F3\306F%0\306B\7D42\4E86\3057\3001\5EF6\9577\3067\304D\307E\305B\3093\3002\30C7\30FC\30BF\304C\5931\308F\308C\306A\3044\3088\3046\306B\3001\73FE\5728\306E\4F5C\696D\3092\3059\3079\3066\4FDD\5B58\3057\3066\304F\3060\3055\3044')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113014769006400605)
,p_name=>'APEX.SESSION.DB_SESSION_CLEANUP.UNHANDLED_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30BB\30C3\30B7\30E7\30F3\306E\30AF\30EA\30FC\30F3\30A2\30C3\30D7\30FB\30B3\30FC\30C9\306E\51E6\7406\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112907806618400526)
,p_name=>'APEX.SESSION.DB_SESSION_INIT.UNHANDLED_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30BB\30C3\30B7\30E7\30F3\306E\8A2D\5B9A\30B3\30FC\30C9\306E\51E6\7406\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112881929303400507)
,p_name=>'APEX.SESSION.EXPIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30C3\30B7\30E7\30F3\304C\7D42\4E86\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113013645619400604)
,p_name=>'APEX.SESSION.EXPIRED.CLOSE_DIALOG'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30C0\30A4\30A2\30ED\30B0\3092\9589\3058\3001\30D6\30E9\30A6\30B6\306E\300C\30EA\30ED\30FC\30C9\300D\30DC\30BF\30F3\3092\62BC\3057\3066\65B0\3057\3044\30BB\30C3\30B7\30E7\30F3\3092\53D6\5F97\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113032900590400618)
,p_name=>'APEX.SESSION.EXPIRED.NEW_SESSION'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F\30BB\30C3\30B7\30E7\30F3\3092\4F5C\6210\3059\308B\306B\306F\3001<a href="%0">\3053\3053</a>\3092\30AF\30EA\30C3\30AF\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112919512617400535)
,p_name=>'APEX.SESSION.NOT_VALID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30C3\30B7\30E7\30F3\7121\52B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112959026122400564)
,p_name=>'APEX.SESSION.RAS.NO_DYNAMIC_ROLES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC"%0"\306EReal Application Security\30BB\30C3\30B7\30E7\30F3\3067\52D5\7684\30ED\30FC\30EB\3092\6709\52B9\306B\3067\304D\307E\305B\3093\3067\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112905711769400524)
,p_name=>'APEX.SESSION.UNHANDLED_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('ERR-99900 \4E00\610F\306E\30BB\30C3\30B7\30E7\30F3ID\3092\4F5C\6210\3067\304D\307E\305B\3093\3067\3057\305F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112922032728400537)
,p_name=>'APEX.SESSION_STATE.ITEM_VALUE_PROTECTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\306E\4FDD\8B77\9055\53CD: \3053\308C\306F\3001\4FDD\8B77\3055\308C\305F\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0%0\306E\624B\52D5\5909\66F4\304C\539F\56E0\3067\767A\751F\3057\305F\53EF\80FD\6027\304C\3042\308A\307E\3059\3002\3053\306E\30A8\30E9\30FC\306E\539F\56E0\304C\4E0D\660E\306A\5834\5408\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\7BA1\7406\8005\306B\9023\7D61\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113041162629400624)
,p_name=>'APEX.SESSION_STATE.PAGE_PROTECTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\4FDD\8B77\9055\53CD: \3053\308C\306F\3001\307E\3060\30ED\30FC\30C9\304C\5B8C\4E86\3057\3066\3044\306A\3044\30DA\30FC\30B8\3092\767A\884C\3057\305F\3001\307E\305F\306F\4FDD\8B77\3055\308C\3066\3044\308B\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3092\624B\52D5\3067\5909\66F4\3057\305F\3053\3068\304C\539F\56E0\3067\767A\751F\3057\305F\53EF\80FD\6027\304C\3042\308A\307E\3059\3002\8A73\7D30\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\7BA1\7406\8005\306B\554F\3044\5408\305B\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113040129149400624)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306B\306F\3001&<>"/;,*|=% or --\306E\3044\305A\308C\304B\306E\7121\52B9\306A\6587\5B57\304C\542B\307E\308C\3066\3044\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113040277062400624)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR_NL'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306B\306F\3001&<>"/;,*|=% or --\3001\307E\305F\306F\6539\884C\306E\3044\305A\308C\304B\306E\7121\52B9\306A\6587\5B57\304C\542B\307E\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113039989861400623)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.US_ONLY'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306B\7279\6B8A\6587\5B57\304C\542B\307E\308C\3066\3044\307E\3059\3002\4ED5\69D8\3067\304D\308B\306E\306Fa-Z\30010-9\304A\3088\3073\7A7A\767D\306E\307F\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113040009907400623)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306B\306F\3001\7121\52B9\306A\6587\5B57<\3001>\307E\305F\306F"\304C\542B\307E\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112884107680400508)
,p_name=>'APEX.SESSION_STATE.SSP_CHECKSUM_MISSING'
,p_message_language=>'ja'
,p_message_text=>unistr('1\3064\4EE5\4E0A\306E\30EA\30AF\30A8\30B9\30C8\3001\30AD\30E3\30C3\30B7\30E5\306E\30AF\30EA\30A2\307E\305F\306F\5F15\6570\5024\304C\30D1\30E9\30E1\30FC\30BF\3068\3057\3066\6E21\3055\308C\308B\5834\5408\306B\30C1\30A7\30C3\30AF\30B5\30E0\3092\5FC5\8981\3068\3059\308B\30DA\30FC\30B8\306E\8868\793A\51E6\7406\306B\5BFE\3057\30C1\30A7\30C3\30AF\30B5\30E0\304C\63D0\4F9B\3055\308C\307E\305B\3093\3067\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112916918209400533)
,p_name=>'APEX.SESSION_STATE.SSP_VIOLATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30C3\30B7\30E7\30F3\30FB\30B9\30C6\30FC\30C8\306E\4FDD\8B77\9055\53CD: \3053\308C\306F\3001\30C1\30A7\30C3\30AF\30B5\30E0\3092\542B\3080URL\306E\624B\52D5\5909\66F4\3001\3042\308B\3044\306F\4E0D\9069\5207\307E\305F\306F\6B20\843D\3057\305F\30C1\30A7\30C3\30AF\30B5\30E0\3092\542B\3080\30EA\30F3\30AF\306E\4F7F\7528\304C\539F\56E0\3067\767A\751F\3057\305F\53EF\80FD\6027\304C\3042\308A\307E\3059\3002\3053\306E\30A8\30E9\30FC\306E\539F\56E0\304C\4E0D\660E\306A\5834\5408\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\7BA1\7406\8005\306B\9023\7D61\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112994925349400591)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_OFF'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CF\30A4\30FB\30B3\30F3\30C8\30E9\30B9\30C8\30FB\30E2\30FC\30C9\3092\30AA\30D5\306B\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112995082348400591)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_ON'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CF\30A4\30FB\30B3\30F3\30C8\30E9\30B9\30C8\30FB\30E2\30FC\30C9\3092\30AA\30F3\306B\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112913633585400530)
,p_name=>'APEX.SHUTTLE.CONTROL_BOTTOM'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E00\756A\4E0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112913884983400531)
,p_name=>'APEX.SHUTTLE.CONTROL_DOWN'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0B\3078')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112913914231400531)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE'
,p_message_language=>'ja'
,p_message_text=>unistr('\79FB\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112914087627400531)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE_ALL'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\79FB\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112914125621400531)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE'
,p_message_language=>'ja'
,p_message_text=>unistr('\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112914205296400531)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE_ALL'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112914348913400531)
,p_name=>'APEX.SHUTTLE.CONTROL_RESET'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30BB\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112913597678400530)
,p_name=>'APEX.SHUTTLE.CONTROL_TOP'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E00\756A\4E0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112913751714400530)
,p_name=>'APEX.SHUTTLE.CONTROL_UP'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0A\3078')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113022675875400611)
,p_name=>'APEX.SINCE.SHORT.DAYS_AGO'
,p_message_language=>'ja'
,p_message_text=>'%0d'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113023363337400611)
,p_name=>'APEX.SINCE.SHORT.DAYS_FROM_NOW'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\65E5\4EE5\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113022530783400611)
,p_name=>'APEX.SINCE.SHORT.HOURS_AGO'
,p_message_language=>'ja'
,p_message_text=>'%0h'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113023487069400611)
,p_name=>'APEX.SINCE.SHORT.HOURS_FROM_NOW'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\6642\9593\4EE5\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113022303130400611)
,p_name=>'APEX.SINCE.SHORT.MINUTES_AGO'
,p_message_language=>'ja'
,p_message_text=>'%0m'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113023555244400611)
,p_name=>'APEX.SINCE.SHORT.MINUTES_FROM_NOW'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\5206\4EE5\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113022987224400611)
,p_name=>'APEX.SINCE.SHORT.MONTHS_AGO'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\304B\6708')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113023127212400611)
,p_name=>'APEX.SINCE.SHORT.MONTHS_FROM_NOW'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\304B\6708\4EE5\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113022458293400611)
,p_name=>'APEX.SINCE.SHORT.SECONDS_AGO'
,p_message_language=>'ja'
,p_message_text=>'%0s'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113023201286400611)
,p_name=>'APEX.SINCE.SHORT.SECONDS_FROM_NOW'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\79D2\4EE5\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113022771819400611)
,p_name=>'APEX.SINCE.SHORT.WEEKS_AGO'
,p_message_language=>'ja'
,p_message_text=>'%0w'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113023662404400611)
,p_name=>'APEX.SINCE.SHORT.WEEKS_FROM_NOW'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\9031\9593\4EE5\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113022872062400611)
,p_name=>'APEX.SINCE.SHORT.YEARS_AGO'
,p_message_language=>'ja'
,p_message_text=>'%0y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113023045375400611)
,p_name=>'APEX.SINCE.SHORT.YEARS_FROM_NOW'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\5E74\4EE5\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112862902760400493)
,p_name=>'APEX.SPATIAL.GEOMETRY.LINE'
,p_message_language=>'ja'
,p_message_text=>unistr('[\884C]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112863305797400493)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTILINE'
,p_message_language=>'ja'
,p_message_text=>unistr('[\8907\6570\306E\884C]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112863140196400493)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOINT'
,p_message_language=>'ja'
,p_message_text=>unistr('[\8907\6570\306E\30DD\30A4\30F3\30C8]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112863505711400493)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOLYGON'
,p_message_language=>'ja'
,p_message_text=>unistr('[\8907\6570\306E\30DD\30EA\30B4\30F3]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112863682225400493)
,p_name=>'APEX.SPATIAL.GEOMETRY.OTHER'
,p_message_language=>'ja'
,p_message_text=>unistr('[\30B8\30AA\30E1\30C8\30EA\30FB\30AA\30D6\30B8\30A7\30AF\30C8]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112862881931400493)
,p_name=>'APEX.SPATIAL.GEOMETRY.POINT'
,p_message_language=>'ja'
,p_message_text=>unistr('[\30DD\30A4\30F3\30C8(%0,%1)]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112863099535400493)
,p_name=>'APEX.SPATIAL.GEOMETRY.POLYGON'
,p_message_language=>'ja'
,p_message_text=>unistr('[\30DD\30EA\30B4\30F3]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112940265022400551)
,p_name=>'APEX.SPLITTER.COLLAPSE_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7E2E\5C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112940151266400551)
,p_name=>'APEX.SPLITTER.RESTORE_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8\30A2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112986669626400585)
,p_name=>'APEX.STAR_RATING.CLEAR_RATING'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A55\4FA1\306E\30AF\30EA\30A2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112976551437400577)
,p_name=>'APEX.STAR_RATING.INVALID_RATING_RANGE'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F1\304B\3089%1\307E\3067\306E\6709\52B9\306A\8A55\4FA1\7BC4\56F2\5185\306B\3042\308A\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112976622695400578)
,p_name=>'APEX.STAR_RATING.IS_NOT_NUMERIC'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306F\6570\5024\3067\306F\3042\308A\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112972777580400575)
,p_name=>'APEX.SUCCESS_MESSAGE_HEADING'
,p_message_language=>'ja'
,p_message_text=>unistr('\6210\529F\30E1\30C3\30BB\30FC\30B8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113035837718400620)
,p_name=>'APEX.TABS.NEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113035758178400620)
,p_name=>'APEX.TABS.PREVIOUS'
,p_message_language=>'ja'
,p_message_text=>unistr('\524D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113021413458400610)
,p_name=>'APEX.TB.TOOLBAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C4\30FC\30EB\30D0\30FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113036235207400621)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_NAV_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CA\30D3\30B2\30FC\30B7\30E7\30F3\306E\62E1\5F35/\7E2E\5C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113036385512400621)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_SIDE_COL_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A2A\306E\5217\306E\62E1\5F35/\7E2E\5C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112945998975400555)
,p_name=>'APEX.TEMPLATE.MAIN_NAV_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E1\30A4\30F3\30FB\30CA\30D3\30B2\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112952931404400560)
,p_name=>'APEX.TIME.DAY'
,p_message_language=>'ja'
,p_message_text=>unistr('1\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112952756164400560)
,p_name=>'APEX.TIME.HOUR'
,p_message_language=>'ja'
,p_message_text=>unistr('1\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112953017192400560)
,p_name=>'APEX.TIME.N_DAYS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112952855240400560)
,p_name=>'APEX.TIME.N_HOURS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112952628974400560)
,p_name=>'APEX.TIME.N_MINUTES'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\5206')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112953277839400560)
,p_name=>'APEX.TIME.N_WEEKS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\9031\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112953118685400560)
,p_name=>'APEX.TIME.WEEK'
,p_message_language=>'ja'
,p_message_text=>unistr('1\9031\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113039405836400623)
,p_name=>'APEX.UI.BACK_TO_TOP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306E\958B\59CB')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112901430253400521)
,p_name=>'APEX.UI.ENABLED'
,p_message_language=>'ja'
,p_message_text=>unistr('\6709\52B9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112875262884400502)
,p_name=>'APEX.UNHANDLED_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30AF\30A8\30B9\30C8\306E\51E6\7406\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112954628345400561)
,p_name=>'APEX.VALUE_REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\5FC5\9808\306E\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113037530170400622)
,p_name=>'APEX.WAIT_UNTIL_PAGE_LOADED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\304C\5B8C\5168\306B\30ED\30FC\30C9\3055\308C\308B\307E\3067\5F85\6A5F\3057\3066\304B\3089\518D\8A66\884C\3057\3066\304F\3060\3055\3044\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112997737975400593)
,p_name=>'APEX.WARN_ON_UNSAVED_CHANGES'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DA\30FC\30B8\306B\306F\4FDD\5B58\3055\308C\3066\3044\306A\3044\5909\66F4\304C\3042\308A\307E\3059\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112878628428400504)
,p_name=>'APEX.XLSX.ERROR.NO_ACTIVE_WORKSHEET'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30D6\30C3\30AF\306B\30A2\30AF\30C6\30A3\30D6\306A\30EF\30FC\30AF\30B7\30FC\30C8\304C\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112878569826400504)
,p_name=>'APEX.XLSX.ERROR.WORKBOOK_NOT_INITIALIZED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30D6\30C3\30AF\304C\521D\671F\5316\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112878448024400504)
,p_name=>'APEX.XLSX.INTERNAL_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('XLSX\30D5\30A1\30A4\30EB\306E\4F5C\6210\4E2D\306B\5185\90E8\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112880922762400506)
,p_name=>'APEX.XLSX.SHEET'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B7\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113012622854400604)
,p_name=>'APEXIR_ACTIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112930175359400543)
,p_name=>'APEXIR_ACTIONS_MENU'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112925881969400540)
,p_name=>'APEXIR_ADD_FUNCTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30F3\30AF\30B7\30E7\30F3\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112925778430400540)
,p_name=>'APEXIR_ADD_GROUP_BY_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\5225\306E\30B0\30EB\30FC\30D7\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112959955482400565)
,p_name=>'APEXIR_ADD_PIVOT_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D4\30DC\30C3\30C8\5217\306E\8FFD\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112960087227400565)
,p_name=>'APEXIR_ADD_ROW_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\5217\306E\8FFD\52A0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112900228650400520)
,p_name=>'APEXIR_AGGREGATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\96C6\8A08')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112936328293400548)
,p_name=>'APEXIR_AGGREGATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\96C6\8A08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112917496817400533)
,p_name=>'APEXIR_AGG_AVG'
,p_message_language=>'ja'
,p_message_text=>unistr('\5E73\5747')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112921721877400537)
,p_name=>'APEXIR_AGG_COUNT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30A6\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112917566517400533)
,p_name=>'APEXIR_AGG_MAX'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5927')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112917777528400534)
,p_name=>'APEXIR_AGG_MEDIAN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E1\30B8\30A2\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112917641700400534)
,p_name=>'APEXIR_AGG_MIN'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112917360236400533)
,p_name=>'APEXIR_AGG_SUM'
,p_message_language=>'ja'
,p_message_text=>unistr('\5408\8A08%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112918486687400534)
,p_name=>'APEXIR_ALL'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112899505407400520)
,p_name=>'APEXIR_ALL_COLUMNS'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\306E\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112882009438400507)
,p_name=>'APEXIR_ALL_ROWS'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\306E\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113009648309400601)
,p_name=>'APEXIR_ALTERNATIVE'
,p_message_language=>'ja'
,p_message_text=>unistr('\4EE3\66FF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113011203307400603)
,p_name=>'APEXIR_ALTERNATIVE_DEFAULT_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\4EE3\66FF\30C7\30D5\30A9\30EB\30C8: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112912185345400529)
,p_name=>'APEXIR_AND'
,p_message_language=>'ja'
,p_message_text=>unistr('\304A\3088\3073')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112901660801400521)
,p_name=>'APEXIR_APPLY'
,p_message_language=>'ja'
,p_message_text=>unistr('\9069\7528')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112895311290400517)
,p_name=>'APEXIR_ASCENDING'
,p_message_language=>'ja'
,p_message_text=>unistr('\6607\9806')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112914954935400531)
,p_name=>'APEXIR_AS_OF'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\73FE\5728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113011896051400603)
,p_name=>'APEXIR_AVERAGE_X'
,p_message_language=>'ja'
,p_message_text=>unistr('\5E73\5747%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113003237668400597)
,p_name=>'APEXIR_BAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D0\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112901028734400521)
,p_name=>'APEXIR_BETWEEN'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\9593\306B\3042\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112894128409400516)
,p_name=>'APEXIR_BGCOLOR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D0\30C3\30AF\30B0\30E9\30A6\30F3\30C9\30FB\30AB\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112896051983400517)
,p_name=>'APEXIR_BLUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\9752')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112927715315400541)
,p_name=>'APEXIR_BOTTOM'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E00\756A\4E0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112896636947400518)
,p_name=>'APEXIR_CANCEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\53D6\6D88')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112902558965400522)
,p_name=>'APEXIR_CATEGORY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30C6\30B4\30EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112894063300400516)
,p_name=>'APEXIR_CELL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BB\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112918354250400534)
,p_name=>'APEXIR_CHART'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112928674270400542)
,p_name=>'APEXIR_CHART_INITIALIZING'
,p_message_language=>'ja'
,p_message_text=>unistr('\521D\671F\5316\4E2D...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112964982332400569)
,p_name=>'APEXIR_CHART_LABEL_NOT_NULL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\30FB\30E9\30D9\30EB\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112977313024400578)
,p_name=>'APEXIR_CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'ja'
,p_message_text=>unistr('\554F\5408\305B\306F\30011\30C1\30E3\30FC\30C8\5F53\305F\308A\306E\6700\5927\30C7\30FC\30BF\30FB\30DD\30A4\30F3\30C8\6570\3067\3042\308B%0\3092\8D85\3048\3066\3044\307E\3059\3002\30D5\30A3\30EB\30BF\3092\9069\7528\3057\3066\3001\30D9\30FC\30B9\554F\5408\305B\306E\30EC\30B3\30FC\30C9\6570\3092\524A\6E1B\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112976250532400577)
,p_name=>'APEXIR_CHART_MAX_ROW_CNT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\554F\5408\305B\306E\884C\30AB\30A6\30F3\30C8\6700\5927\5024\306F\3001\8868\793A\3055\308C\308B\884C\6570\3067\306F\306A\304F\30D9\30FC\30B9\554F\5408\305B\306E\884C\6570\3092\5236\9650\3057\307E\3059\3002\30D9\30FC\30B9\554F\5408\305B\304C\884C\30AB\30A6\30F3\30C8\6700\5927\5024%0\3092\8D85\3048\3066\3044\307E\3059\3002\30D5\30A3\30EB\30BF\3092\9069\7528\3057\3066\3001\30D9\30FC\30B9\554F\5408\305B\306E\30EC\30B3\30FC\30C9\6570\3092\524A\6E1B\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112899647985400520)
,p_name=>'APEXIR_CHART_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\30FB\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112972930769400575)
,p_name=>'APEXIR_CHECK_ALL'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\3092\30C1\30A7\30C3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112915307856400532)
,p_name=>'APEXIR_CHOOSE_DOWNLOAD_FORMAT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\5F62\5F0F\306E\9078\629E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112922796150400537)
,p_name=>'APEXIR_CLEAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AF\30EA\30A2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112896560525400517)
,p_name=>'APEXIR_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112933941039400546)
,p_name=>'APEXIR_COLUMNS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113006271922400599)
,p_name=>'APEXIR_COLUMN_FILTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30EB\30BF...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112924709806400539)
,p_name=>'APEXIR_COLUMN_HEADING_MENU'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\30D8\30C3\30C0\30FC\30FB\30E1\30CB\30E5\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112928487912400542)
,p_name=>'APEXIR_COLUMN_INFO'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\60C5\5831')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113008594685400601)
,p_name=>'APEXIR_COLUMN_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\30E9\30D9\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112926138280400540)
,p_name=>'APEXIR_COLUMN_N'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112910220242400528)
,p_name=>'APEXIR_COMPARISON_CONTAINS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\3092\542B\3080')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112911130895400528)
,p_name=>'APEXIR_COMPARISON_DOESNOT_CONTAIN'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\3092\542B\307E\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112895075623400516)
,p_name=>'APEXIR_COMPARISON_IN'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306B\542B\307E\308C\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112911374115400529)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_LAST'
,p_message_language=>'ja'
,p_message_text=>unistr('\304C\904E\53BB\306E\6B21\306E\671F\9593\5916')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112919856125400535)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_NEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\304C\4ECA\5F8C\306E\6B21\306E\671F\9593\5916')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112911205379400528)
,p_name=>'APEXIR_COMPARISON_IS_IN_LAST'
,p_message_language=>'ja'
,p_message_text=>unistr('\304C\904E\53BB\306E\6B21\306E\671F\9593\5185')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112919748961400535)
,p_name=>'APEXIR_COMPARISON_IS_IN_NEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\304C\4ECA\5F8C\306E\6B21\306E\671F\9593\5185')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112894936532400516)
,p_name=>'APEXIR_COMPARISON_IS_NOT_NULL'
,p_message_language=>'ja'
,p_message_text=>unistr('null\3067\306F\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112894861328400516)
,p_name=>'APEXIR_COMPARISON_IS_NULL'
,p_message_language=>'ja'
,p_message_text=>unistr('null\3067\3042\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112894603495400516)
,p_name=>'APEXIR_COMPARISON_LIKE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\3068\985E\4F3C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112895145693400516)
,p_name=>'APEXIR_COMPARISON_NOT_IN'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306B\542B\307E\308C\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112894735627400516)
,p_name=>'APEXIR_COMPARISON_NOT_LIKE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\3068\985E\4F3C\3067\306F\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112910555711400528)
,p_name=>'APEXIR_COMPARISON_REGEXP_LIKE'
,p_message_language=>'ja'
,p_message_text=>unistr('\304C\6B21\306E\6B63\898F\8868\73FE\3068\4E00\81F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112915299324400532)
,p_name=>'APEXIR_COMPUTATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A08\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112975965433400577)
,p_name=>'APEXIR_COMPUTATION_EXPRESSION'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A08\7B97\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112934288068400546)
,p_name=>'APEXIR_COMPUTATION_FOOTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\306E\5225\540D\3092\4F7F\7528\3057\3066\8A08\7B97\3092\4F5C\6210\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112934380057400546)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E1'
,p_message_language=>'ja'
,p_message_text=>'(B+C)*100'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112934440337400546)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E2'
,p_message_language=>'ja'
,p_message_text=>'INITCAP(B)||'', ''||INITCAP(C)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112934532179400546)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E3'
,p_message_language=>'ja'
,p_message_text=>'CASE WHEN A = 10 THEN B + C ELSE B END'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112880435326400506)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E4'
,p_message_language=>'ja'
,p_message_text=>'ROUND(C / 1000000)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112919199602400535)
,p_name=>'APEXIR_COMPUTE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A08\7B97')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112926755887400541)
,p_name=>'APEXIR_CONTROL_BREAK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30C8\30ED\30FC\30EB\30FB\30D6\30EC\30FC\30AF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112929731217400543)
,p_name=>'APEXIR_CONTROL_BREAKS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30C8\30ED\30FC\30EB\30FB\30D6\30EC\30FC\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113014149749400605)
,p_name=>'APEXIR_CONTROL_BREAK_COLUMNS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D6\30EC\30FC\30AF\5217\306E\5236\5FA1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112877568341400503)
,p_name=>'APEXIR_COUNT_DISTINCT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5225\3005\306B\30AB\30A6\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113012316904400603)
,p_name=>'APEXIR_COUNT_DISTINCT_X'
,p_message_language=>'ja'
,p_message_text=>unistr('\5225\3005\306B\30AB\30A6\30F3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113012230092400603)
,p_name=>'APEXIR_COUNT_X'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30A6\30F3\30C8%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112984335579400583)
,p_name=>'APEXIR_DAILY'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113039056842400623)
,p_name=>'APEXIR_DATA'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112928544651400542)
,p_name=>'APEXIR_DATA_AS_OF'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\5206\524D\306E\30C7\30FC\30BF\3092\30EC\30DD\30FC\30C8\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113002054313400596)
,p_name=>'APEXIR_DATA_GRID_HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30B0\30EA\30C3\30C9\30FB\30D8\30EB\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112900325055400520)
,p_name=>'APEXIR_DATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5\4ED8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112932414912400545)
,p_name=>'APEXIR_DEFAULT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113009408103400601)
,p_name=>'APEXIR_DEFAULT_REPORT_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\306E\30EC\30DD\30FC\30C8\30FB\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112896753400400518)
,p_name=>'APEXIR_DELETE'
,p_message_language=>'ja'
,p_message_text=>unistr('\524A\9664')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112900664345400521)
,p_name=>'APEXIR_DELETE_CONFIRM'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\308C\3089\306E\30EC\30DD\30FC\30C8\8A2D\5B9A\3092\524A\9664\3057\307E\3059\304B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112995325528400591)
,p_name=>'APEXIR_DELETE_DEFAULT_REPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\30FB\30EC\30DD\30FC\30C8\306E\524A\9664')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112926476255400540)
,p_name=>'APEXIR_DELETE_REPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\306E\524A\9664')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112895440800400517)
,p_name=>'APEXIR_DESCENDING'
,p_message_language=>'ja'
,p_message_text=>unistr('\964D\9806')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112902601193400522)
,p_name=>'APEXIR_DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\8AAC\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112924619179400539)
,p_name=>'APEXIR_DETAIL_VIEW'
,p_message_language=>'ja'
,p_message_text=>unistr('\5358\4E00\884C\30D3\30E5\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112932953964400545)
,p_name=>'APEXIR_DIRECTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B9\5411%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112933842961400546)
,p_name=>'APEXIR_DISABLED'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112896253438400517)
,p_name=>'APEXIR_DISPLAYED'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112899441762400520)
,p_name=>'APEXIR_DISPLAYED_COLUMNS'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112932869861400545)
,p_name=>'APEXIR_DISPLAY_IN_REPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\306B\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112927636061400541)
,p_name=>'APEXIR_DOWN'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0B\3078')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112919229815400535)
,p_name=>'APEXIR_DOWNLOAD'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C0\30A6\30F3\30ED\30FC\30C9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112932712445400545)
,p_name=>'APEXIR_DO_NOT_DISPLAY'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\3057\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112998731422400594)
,p_name=>'APEXIR_DUPLICATE_HIGHLIGHT_COND'
,p_message_language=>'ja'
,p_message_text=>unistr('\540C\3058\6761\4EF6\306E\30CF\30A4\30E9\30A4\30C8\304C\3059\3067\306B\5B58\5728\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113014316704400605)
,p_name=>'APEXIR_DUPLICATE_PIVOT_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D4\30DC\30C3\30C8\5217\304C\91CD\8907\3057\3066\3044\307E\3059\3002\30D4\30DC\30C3\30C8\5217\30EA\30B9\30C8\306F\4E00\610F\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113014545342400605)
,p_name=>'APEXIR_EDIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112928762629400542)
,p_name=>'APEXIR_EDIT_CHART'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\8A2D\5B9A\306E\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112935343765400547)
,p_name=>'APEXIR_EDIT_CHART2'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\306E\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112935751193400547)
,p_name=>'APEXIR_EDIT_FILTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30EB\30BF\306E\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112990107803400587)
,p_name=>'APEXIR_EDIT_GROUP_BY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30EB\30FC\30D7\5316\306E\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112935665458400547)
,p_name=>'APEXIR_EDIT_HIGHLIGHT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CF\30A4\30E9\30A4\30C8\306E\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112960284798400565)
,p_name=>'APEXIR_EDIT_PIVOT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D4\30DC\30C3\30C8\306E\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113009756073400602)
,p_name=>'APEXIR_EMAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112888425635400511)
,p_name=>'APEXIR_EMAIL_ADDRESS'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113010093721400602)
,p_name=>'APEXIR_EMAIL_BCC'
,p_message_language=>'ja'
,p_message_text=>'BCC'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113010207579400602)
,p_name=>'APEXIR_EMAIL_BODY'
,p_message_language=>'ja'
,p_message_text=>unistr('\672C\6587')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113009963792400602)
,p_name=>'APEXIR_EMAIL_CC'
,p_message_language=>'ja'
,p_message_text=>'CC'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113010735847400602)
,p_name=>'APEXIR_EMAIL_FREQUENCY'
,p_message_language=>'ja'
,p_message_text=>unistr('\983B\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112892143416400514)
,p_name=>'APEXIR_EMAIL_NOT_CONFIGURED'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\306F\96FB\5B50\30E1\30FC\30EB\304C\69CB\6210\3055\308C\3066\3044\307E\305B\3093\3002\7BA1\7406\8005\306B\9023\7D61\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112983632596400583)
,p_name=>'APEXIR_EMAIL_REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9\300D\306B\5024\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113010397260400602)
,p_name=>'APEXIR_EMAIL_SEE_ATTACHED'
,p_message_language=>'ja'
,p_message_text=>unistr('\6DFB\4ED8\3092\53C2\7167')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113010159294400602)
,p_name=>'APEXIR_EMAIL_SUBJECT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4EF6\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112984652153400583)
,p_name=>'APEXIR_EMAIL_SUBJECT_REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\96FB\5B50\30E1\30FC\30EB\306E\4EF6\540D\300D\306B\5024\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113009895505400602)
,p_name=>'APEXIR_EMAIL_TO'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9B\5148')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112893813224400515)
,p_name=>'APEXIR_ENABLED'
,p_message_language=>'ja'
,p_message_text=>unistr('\6709\52B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112935531315400547)
,p_name=>'APEXIR_ENABLE_DISABLE_ALT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6709\52B9\5316/\7121\52B9\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112935021275400547)
,p_name=>'APEXIR_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112934690048400546)
,p_name=>'APEXIR_EXAMPLES'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F8B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112935469313400547)
,p_name=>'APEXIR_EXAMPLES_WITH_COLON'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F8B:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112899398570400520)
,p_name=>'APEXIR_EXCLUDE_NULL'
,p_message_language=>'ja'
,p_message_text=>unistr('NULL\5024\306E\9664\5916')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112936057230400548)
,p_name=>'APEXIR_EXPAND_COLLAPSE_ALT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C55\958B/\7E2E\5C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112933673093400546)
,p_name=>'APEXIR_EXPRESSION'
,p_message_language=>'ja'
,p_message_text=>unistr('\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112918721726400534)
,p_name=>'APEXIR_FILTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30EB\30BF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112929684066400543)
,p_name=>'APEXIR_FILTERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30EB\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112939952441400550)
,p_name=>'APEXIR_FILTER_EXPRESSION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30EB\30BF\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113036414992400621)
,p_name=>'APEXIR_FILTER_EXPR_TOO_LONG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30EB\30BF\5F0F\304C\9577\3059\304E\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112939814016400550)
,p_name=>'APEXIR_FILTER_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30EB\30BF\30FB\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112936207306400548)
,p_name=>'APEXIR_FINDER_ALT'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22\5217\306E\9078\629E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112919017045400535)
,p_name=>'APEXIR_FLASHBACK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30E9\30C3\30B7\30E5\30D0\30C3\30AF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112933439686400545)
,p_name=>'APEXIR_FLASHBACK_DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30E9\30C3\30B7\30E5\30D0\30C3\30AF\554F\5408\305B\3092\4F7F\7528\3059\308B\3068\3001\3042\308B\6642\70B9\3067\5B58\5728\3057\3066\3044\305F\30C7\30FC\30BF\3092\8868\793A\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112984055116400583)
,p_name=>'APEXIR_FLASHBACK_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30E9\30C3\30B7\30E5\30D0\30C3\30AF\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112985470488400584)
,p_name=>'APEXIR_FORMAT'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F8\5F0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112915141425400531)
,p_name=>'APEXIR_FORMAT_MASK'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F8\5F0F\30DE\30B9\30AF%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112926378224400540)
,p_name=>'APEXIR_FUNCTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30F3\30AF\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112934168949400546)
,p_name=>'APEXIR_FUNCTIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30F3\30AF\30B7\30E7\30F3%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113009311399400601)
,p_name=>'APEXIR_FUNCTIONS_OPERATORS'
,p_message_language=>'ja'
,p_message_text=>unistr('\95A2\6570/\6F14\7B97\5B50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112926079197400540)
,p_name=>'APEXIR_FUNCTION_N'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30F3\30AF\30B7\30E7\30F3%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112918569540400534)
,p_name=>'APEXIR_GO'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9F\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112894380242400516)
,p_name=>'APEXIR_GREEN'
,p_message_language=>'ja'
,p_message_text=>unistr('\7DD1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112877604031400504)
,p_name=>'APEXIR_GROUP_BY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30EB\30FC\30D7\5316')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113010433626400602)
,p_name=>'APEXIR_GROUP_BY_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('GROUP BY\5217%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112965009572400569)
,p_name=>'APEXIR_GROUP_BY_COL_NOT_NULL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30EB\30FC\30D7\5316\5217\304C\6307\5B9A\3055\308C\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112976157257400577)
,p_name=>'APEXIR_GROUP_BY_MAX_ROW_CNT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30EB\30FC\30D7\5316\554F\5408\305B\306E\884C\30AB\30A6\30F3\30C8\6700\5927\5024\306F\3001\8868\793A\3055\308C\308B\884C\6570\3067\306F\306A\304F\30D9\30FC\30B9\554F\5408\305B\306E\884C\6570\3092\5236\9650\3057\307E\3059\3002\30D9\30FC\30B9\554F\5408\305B\304C\884C\30AB\30A6\30F3\30C8\6700\5927\5024%0\3092\8D85\3048\3066\3044\307E\3059\3002\30D5\30A3\30EB\30BF\3092\9069\7528\3057\3066\3001\30D9\30FC\30B9\554F\5408\305B\306E\30EC\30B3\30FC\30C9\6570\3092\524A\6E1B\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112956728939400563)
,p_name=>'APEXIR_GROUP_BY_SORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BD\30FC\30C8\5225\306E\30B0\30EB\30FC\30D7\5316')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113014238450400605)
,p_name=>'APEXIR_GROUP_BY_SORT_ORDER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BD\30FC\30C8\9806\306B\3088\308B\30B0\30EB\30FC\30D7\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112899722205400520)
,p_name=>'APEXIR_HCOLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\6C34\5E73\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112931340625400544)
,p_name=>'APEXIR_HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D8\30EB\30D7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112923179906400538)
,p_name=>'APEXIR_HELP_01'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306F\3001\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\3092\4F7F\7528\3057\3066\3001\30EC\30DD\30FC\30C8\3092\30AB\30B9\30BF\30DE\30A4\30BA\3067\304D\307E\3059\3002\30E6\30FC\30B6\30FC\306F\3001\5217\306E\9078\629E\3001\30D5\30A3\30EB\30BF\306E\9069\7528\3001\30CF\30A4\30E9\30A4\30C8\307E\305F\306F\30BD\30FC\30C8\3092\884C\3063\3066\3001\30EC\30DD\30FC\30C8\30FB\30C7\30FC\30BF\306E\30EC\30A4\30A2\30A6\30C8\3092\5909\66F4\3067\304D\307E\3059\3002\307E\305F\3001\30D6\30EC\30FC\30AF\3001\96C6\8A08\3001\30C1\30E3\30FC\30C8\3001\30B0\30EB\30FC\30D7\5316\3092\5B9A\7FA9\3057\3001\72EC\81EA\306E\8A08\7B97\3092\8FFD\52A0\3067\304D\307E\3059\3002\30B5\30D6\30B9\30AF\30EA\30D7\30B7\30E7\30F3\3092\8A2D\5B9A\3057\3066\3001HTML\30D0\30FC\30B8\30E7\30F3\306E\30EC\30DD\30FC\30C8\3092\6307\5B9A\3057\305F\9593\9694\3067\96FB\5B50\30E1\30FC\30EB\9001\4FE1\3059\308B\3088\3046\306B\3082\8A2D\5B9A\3067\304D\307E\3059\3002\30E6\30FC\30B6\30FC\306F\30EC\30DD\30FC\30C8\306E\8907\6570\306E\30D0\30EA\30A8\30FC\30B7\30E7\30F3\3092\4F5C\6210\3057\3001\30D1\30D6\30EA\30C3\30AF\307E\305F\306F\30D7\30E9\30A4\30D9\30FC\30C8\306E\53C2\7167\7528\306B\540D\524D\4ED8\304D\30EC\30DD\30FC\30C8\3068\3057\3066')
||unistr('\4FDD\5B58\3067\304D\307E\3059\3002'),
'<p/>',
unistr('\4EE5\964D\306E\9805\306B\3001\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\306E\30AB\30B9\30BF\30DE\30A4\30BA\65B9\6CD5\3092\8981\7D04\3057\307E\3059\3002\3055\3089\306B\5B66\7FD2\3059\308B\306B\306F\3001<i>\300EOracle Application Express\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\30FB\30AC\30A4\30C9\300F</i></a>\306E\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\306E\4F7F\7528\306B\95A2\3059\308B\9805\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112930262833400543)
,p_name=>'APEXIR_HELP_ACTIONS_MENU'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC\306F\691C\7D22\30D0\30FC\306E\300C\5B9F\884C\300D\30DC\30BF\30F3\306E\53F3\5074\306B\8868\793A\3055\308C\307E\3059\3002\3053\306E\30E1\30CB\30E5\30FC\3092\4F7F\7528\3057\3066\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\3092\30AB\30B9\30BF\30DE\30A4\30BA\3057\307E\3059\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112923950998400538)
,p_name=>'APEXIR_HELP_AGGREGATE'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\96C6\8A08\306F\30011\3064\306E\4F8B\306B\5BFE\3057\3066\5B9F\884C\3055\308C\308B\6570\5B66\7684\8A08\7B97\3067\3059\3002\96C6\8A08\306F\3001\5404\30B3\30F3\30C8\30ED\30FC\30EB\30FB\30D6\30EC\30FC\30AF\306E\5F8C\3068\30EC\30DD\30FC\30C8\306E\6700\5F8C\306B\3001\96C6\8A08\3092\5B9A\7FA9\3057\305F\5217\5185\3067\8868\793A\3055\308C\307E\3059\3002\30AA\30D7\30B7\30E7\30F3\306F\6B21\306E\3068\304A\308A\3067\3059\3002'),
'<p>',
'</p><ul>',
unistr('<li><strong>\300C\96C6\8A08\300D</strong>\3067\306F\3001\4EE5\524D\306B\5B9A\7FA9\3057\305F\96C6\8A08\3092\9078\629E\3057\3066\7DE8\96C6\3067\304D\307E\3059\3002</li>'),
unistr('<li><strong>\300C\30D5\30A1\30F3\30AF\30B7\30E7\30F3\300D</strong>\306F\3001\5B9F\884C\3055\308C\308B\95A2\6570(SUM\3001MIN\306A\3069)\3067\3059\3002</li>'),
unistr('<li><strong>\300C\5217\300D</strong>\3092\4F7F\7528\3057\3066\3001\6570\5B66\95A2\6570\3092\9069\7528\3059\308B\5BFE\8C61\306E\5217\3092\9078\629E\3057\307E\3059\3002\6570\5024\306E\5217\306E\307F\304C\8868\793A\3055\308C\307E\3059\3002</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112924052670400538)
,p_name=>'APEXIR_HELP_CHART'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4FDD\5B58\3057\305F\30EC\30DD\30FC\30C8\3054\3068\306B\30011\3064\306E\30C1\30E3\30FC\30C8\3092\5B9A\7FA9\3067\304D\307E\3059\3002'),
unistr('\30C1\30E3\30FC\30C8\3092\5B9A\7FA9\3059\308B\3068\3001\691C\7D22\30D0\30FC\306E\30D3\30E5\30FC\30FB\30A2\30A4\30B3\30F3\3092\4F7F\7528\3057\3066\30C1\30E3\30FC\30C8\3068\30EC\30DD\30FC\30C8\306E\8868\793A\3092\5207\308A\66FF\3048\308B\3053\3068\304C\3067\304D\307E\3059\3002'),
unistr('\30AA\30D7\30B7\30E7\30F3\306F\6B21\306E\3068\304A\308A\3067\3059:'),
'<p>',
'</p><ul>',
unistr('<li><strong>\300C\30C1\30E3\30FC\30C8\30FB\30BF\30A4\30D7\300D</strong>\3067\3001\542B\3081\308B\30C1\30E3\30FC\30C8\306E\30BF\30A4\30D7\3092\6307\5B9A\3057\307E\3059\3002'),
unistr('\300C\6A2A\68D2\300D\3001\300C\7E26\68D2\300D\3001\300C\5186\300D\3001\300C\6298\308C\7DDA\300D\304B\3089\9078\629E\3057\307E\3059\3002</li>'),
unistr('<li><strong>\300C\30E9\30D9\30EB\300D</strong>\3067\3001\30E9\30D9\30EB\3068\3057\3066\4F7F\7528\3059\308B\5217\3092\9078\629E\3067\304D\307E\3059\3002</li>'),
unistr('<li><strong>\300C\30E9\30D9\30EB\306E\8EF8\30BF\30A4\30C8\30EB\300D</strong>\306F\3001\300C\30E9\30D9\30EB\300D\3067\9078\629E\3057\305F\5217\306B\5BFE\5FDC\3059\308B\8EF8\4E0A\306B\8868\793A\3055\308C\308B\30BF\30A4\30C8\30EB\3067\3059\3002'),
unistr('\5186\30B0\30E9\30D5\3067\306F\4F7F\7528\3067\304D\307E\305B\3093\3002</li>'),
unistr('<li><strong>\300C\5024\300D</strong>\3067\3001\5024\3068\3057\3066\4F7F\7528\3059\308B\5217\3092\9078\629E\3067\304D\307E\3059\3002COUNT\95A2\6570\3092'),
unistr('\4F7F\7528\3059\308B\5834\5408\3001\300C\5024\300D\3092\9078\629E\3059\308B\5FC5\8981\306F\3042\308A\307E\305B\3093\3002</li>'),
unistr('<li><strong>\300C\5024\306E\8EF8\30BF\30A4\30C8\30EB\300D</strong>\306F\3001\300C\5024\300D\3067\9078\629E\3057\305F\5217\306B\5BFE\5FDC\3059\308B\8EF8\4E0A\306B\8868\793A\3055\308C\308B\30BF\30A4\30C8\30EB\3067\3059\3002'),
unistr('\5186\30B0\30E9\30D5\3067\306F\4F7F\7528\3067\304D\307E\305B\3093\3002</li>'),
unistr('<li><strong>\300C\30D5\30A1\30F3\30AF\30B7\30E7\30F3\300D</strong>\306F\3001\300C\5024\300D\3067\9078\629E\3057\305F\5217\306B\5BFE\3057\3066\5B9F\884C\3055\308C\308B\30AA\30D7\30B7\30E7\30F3\306E\95A2\6570\3067\3059\3002</li>'),
unistr('<li><strong>\300C\30BD\30FC\30C8\300D</strong>\3067\3001\7D50\679C\30BB\30C3\30C8\3092\30BD\30FC\30C8\3067\304D\307E\3059\3002</li></ul>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112923353815400538)
,p_name=>'APEXIR_HELP_COLUMN_HEADING_MENU'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4EFB\610F\306E\5217\30D8\30C3\30C0\30FC\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\5217\30D8\30C3\30C0\30FC\30FB\30E1\30CB\30E5\30FC\304C\958B\304D\307E\3059\3002\30AA\30D7\30B7\30E7\30F3\306F\6B21\306E\3068\304A\308A\3067\3059:'),
'<p></p>',
'<ul>',
unistr('<li><strong>\300C\6607\9806\30BD\30FC\30C8\300D<strong>\30A2\30A4\30B3\30F3\3067\3001\5217\3092\57FA\6E96\306B\3057\3066\30EC\30DD\30FC\30C8\3092\6607\9806\306B\30BD\30FC\30C8\3057\307E\3059\3002</li>'),
unistr('<li><strong>\300C\964D\9806\30BD\30FC\30C8\300D</strong>\30A2\30A4\30B3\30F3\3067\3001\5217\3092\57FA\6E96\306B\3057\3066\30EC\30DD\30FC\30C8\3092\964D\9806\306B\30BD\30FC\30C8\3057\307E\3059\3002</li>'),
unistr('<li><strong>\300C\5217\306E\975E\8868\793A\300D</strong>\3067\3001\5217\3092\975E\8868\793A\306B\3057\307E\3059\3002\3059\3079\3066\306E\5217\3092\975E\8868\793A\306B\3067\304D\308B\3068\306F\304B\304E\308A\307E\305B\3093\3002\5217\3092\975E\8868\793A\306B\3067\304D\306A\3044\5834\5408\3001\300C\5217\306E\975E\8868\793A\300D\30A2\30A4\30B3\30F3\306F\8868\793A\3055\308C\307E\305B\3093\3002</li>'),
unistr('<li><strong>\300C\30D6\30EC\30FC\30AF\5217\300D</strong>\3067\3001\5217\306B\30D6\30EC\30FC\30AF\30FB\30B0\30EB\30FC\30D7\3092\4F5C\6210\3057\307E\3059\3002\30EC\30DD\30FC\30C8\304B\3089\3001\5217\304C\30DE\30B9\30BF\30FC\30FB\30EC\30B3\30FC\30C9\3068\3057\3066\62BD\51FA\3055\308C\307E\3059\3002</li>'),
unistr('<li><strong>\300C\5217\60C5\5831\300D</strong>\3067\3001\5217\306B\95A2\3059\308B\30D8\30EB\30D7\30FB\30C6\30AD\30B9\30C8(\5229\7528\53EF\80FD\306A\5834\5408)\3092\8868\793A\3057\307E\3059\3002</li>'),
unistr('<li><strong>\30C6\30AD\30B9\30C8\9818\57DF</strong>\3067\306F\3001\5927/\5C0F\6587\5B57\3092\533A\5225\3057\306A\3044\691C\7D22\57FA\6E96\3092\5165\529B\3057\307E\3059(\30EF\30A4\30EB\30C9\30AB\30FC\30C9\306F\4E0D\8981)\3002\5024\3092\5165\529B\3059\308B\3068\3001\30E1\30CB\30E5\30FC\4E0B\90E8\306ELOV\304C\7E2E\5C0F\3055\308C\307E\3059\3002\4E0B\90E8\304B\3089\5024\3092\9078\629E\3059\308B\3068\3001\9078\629E\3057\305F\5024\304C\300C=\300D\3092\4F7F\7528\3057\3066\30D5\30A3\30EB\30BF\3068\3057\3066\4F5C\6210\3055\308C\307E\3059(\4F8B: <code>column = ''ABC''</code>)\3002\3042\308B\3044\306F\3001\61D0\4E2D\96FB\706F\30A2\30A4\30B3\30F3\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\5165\529B\3057\305F\5024\304C\300CLIKE\300D\4FEE\98FE\5B50\3092\4F7F\7528\3057\3066\30D5\30A3\30EB\30BF\3068\3057\3066\4F5C\6210\3055\308C\307E\3059(\4F8B: <code>column LIKE ''%ABC%''</co')
||unistr('de>)\3002</li>'),
unistr('<li><b>\4E00\610F\306ELOV</b>\306B\306F\3001\30D5\30A3\30EB\30BF\57FA\6E96\306B\4E00\81F4\3059\308B\4E00\610F\306E\5024\306E\3046\3061\6700\521D\306E500\4EF6\304C\8868\793A\3055\308C\307E\3059\3002\5217\304C\65E5\4ED8\306E\5834\5408\306F\3001\304B\308F\308A\306B\65E5\4ED8\7BC4\56F2\306E\30EA\30B9\30C8\304C\8868\793A\3055\308C\307E\3059\3002\5024\3092\9078\629E\3059\308B\3068\3001\300C=\300D\3092\4F7F\7528\3057\3066\30D5\30A3\30EB\30BF\304C\4F5C\6210\3055\308C\307E\3059(\4F8B: <code>column = ''ABC''</code>)\3002</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112923814237400538)
,p_name=>'APEXIR_HELP_COMPUTE'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30EC\30DD\30FC\30C8\306B\8A08\7B97\7D50\679C\306E\5217\3092\8FFD\52A0\3067\304D\307E\3059\3002\6570\5B66\7684\8A08\7B97(\4F8B: <code>NBR_HOURS/24</code>)\3084\3001\65E2\5B58\306E\5217\306B\9069\7528\3055\308C\308BOracle\6A19\6E96\306E\95A2\6570\3092\4F7F\7528\3067\304D\307E\3059\3002\4E00\90E8\306F\4F8B\304A\3088\3073\305D\306E\4ED6\3068\3057\3066\8868\793A\3055\308C\3066\3044\307E\3059(<code>TO_DATE</code>\306A\3069\3082\4F7F\7528\3067\304D\307E\3059)\3002\30AA\30D7\30B7\30E7\30F3\306F\6B21\306E\3068\304A\308A\3067\3059\3002'),
'<p></p>',
'<ul>',
unistr('<li><strong>\300C\8A08\7B97\300D</strong>\3067\306F\3001\4EE5\524D\306B\5B9A\7FA9\3057\305F\8A08\7B97\3092\9078\629E\3057\3066\7DE8\96C6\3067\304D\307E\3059\3002</li>'),
unistr('<li><strong>\300C\5217\30D8\30C3\30C0\30FC\300D</strong>\306F\3001\65B0\3057\3044\5217\306E\5217\30D8\30C3\30C0\30FC\3067\3059\3002</li>'),
unistr('<li><strong>\300C\66F8\5F0F\30DE\30B9\30AF\300D</strong>\306F\3001\5217\306B\9069\7528\3059\308BOracle\66F8\5F0F\30DE\30B9\30AF(\4F8B: S9999)\3067\3059\3002</li>'),
unistr('<li><strong>\300C\8A08\7B97\300D</strong>\306F\3001\5B9F\884C\3055\308C\308B\8A08\7B97\3067\3059\3002\8A08\7B97\306E\969B\3001\5217\306F\8868\793A\3055\308C\3066\3044\308B\5225\540D\3067\53C2\7167\3055\308C\307E\3059\3002</li>'),
'</ul>',
unistr('<p>\8A08\7B97\306E\4E0B\306B\306F\3001\554F\5408\305B\306E\5217\3068\305D\308C\306B\5BFE\5FDC\3059\308B\5225\540D\304C\8868\793A\3055\308C\307E\3059\3002\5217\540D\307E\305F\306F\5225\540D\3092\30AF\30EA\30C3\30AF\3059\308B\3068\3001\300C\8A08\7B97\300D\306B\66F8\304D\8FBC\307E\308C\307E\3059\3002\5217\306E\3068\306A\308A\306B\30AD\30FC\30D1\30C3\30C9\304C\3042\308A\307E\3059\3002\3053\308C\306F\3001\983B\7E41\306B\4F7F\7528\3055\308C\308B\30AD\30FC\306E\30B7\30E7\30FC\30C8\30AB\30C3\30C8\3067\3059\3002\53F3\7AEF\306B\95A2\6570\304C\3042\308A\307E\3059\3002</p>'),
unistr('<p>\7D66\4E0E\5408\8A08\3092\8868\793A\3059\308B\8A08\7B97\306E\4F8B\306F\3001\6B21\306E\3088\3046\306B\306A\308A\307E\3059\3002</p>'),
'<pre>CASE WHEN A = ''SALES'' THEN B + C ELSE B END</pre>',
unistr('(A\306FORGANIZATION\3001B\306FSALARY\3001C\306FCOMMISSION)</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112930373985400543)
,p_name=>'APEXIR_HELP_CONTROL_BREAK'
,p_message_language=>'ja'
,p_message_text=>unistr('1\3064\307E\305F\306F\8907\6570\306E\5217\306B\30D6\30EC\30FC\30AF\30FB\30B0\30EB\30FC\30D7\3092\4F5C\6210\3057\307E\3059\3002\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\304B\3089\5217\304C\62BD\51FA\3055\308C\3001\30DE\30B9\30BF\30FC\30FB\30EC\30B3\30FC\30C9\3068\3057\3066\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112924500733400539)
,p_name=>'APEXIR_HELP_DETAIL_VIEW'
,p_message_language=>'ja'
,p_message_text=>unistr('\5358\4E00\884C\30D3\30E5\30FC\306E\8A73\7D30\3092\4E00\5EA6\306B\8868\793A\3059\308B\306B\306F\3001\8868\793A\3057\305F\3044\884C\3067\5358\4E00\884C\30D3\30E5\30FC\306E\8868\793A\30A2\30A4\30B3\30F3\3092\30AF\30EA\30C3\30AF\3057\307E\3059\3002\4F7F\7528\53EF\80FD\306A\5834\5408\3001\5358\4E00\884C\30D3\30E5\30FC\306F\5E38\306B\6700\521D\306E\5217\306B\306A\308A\307E\3059\3002\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\306E\30AB\30B9\30BF\30DE\30A4\30BA\5185\5BB9\306B\3088\3063\3066\3001\5358\4E00\884C\30D3\30E5\30FC\306F\6A19\6E96\30D3\30E5\30FC\3067\3042\308B\5834\5408\3082\3001\66F4\65B0\53EF\80FD\306A\30AB\30B9\30BF\30E0\30FB\30DA\30FC\30B8\3067\3042\308B\5834\5408\3082\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112924473375400539)
,p_name=>'APEXIR_HELP_DOWNLOAD'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\7D50\679C\30BB\30C3\30C8\306E\30C0\30A6\30F3\30ED\30FC\30C9\3092\8A31\53EF\3057\307E\3059\3002\30C0\30A6\30F3\30ED\30FC\30C9\5F62\5F0F\306F\3001\30A4\30F3\30B9\30C8\30FC\30EB\74B0\5883\3068\30EC\30DD\30FC\30C8\5B9A\7FA9\306B\3088\3063\3066\7570\306A\308A\307E\3059\304C\3001CSV\3001HTML\3001\96FB\5B50\30E1\30FC\30EB\3001XLS\3001PDF\307E\305F\306FRTF\304C\4F7F\7528\53EF\80FD\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112923593018400538)
,p_name=>'APEXIR_HELP_FILTER'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\554F\5408\305B\3067<code>WHERE</code>\53E5\306E\8FFD\52A0\307E\305F\306F\5909\66F4\306B\3088\3063\3066\30EC\30DD\30FC\30C8\3092\30D5\30A9\30FC\30AB\30B9\3057\307E\3059\3002\5217\307E\305F\306F\884C\3067\30D5\30A3\30EB\30BF\3067\304D\307E\3059\3002'),
unistr('<p>\5217\3067\30D5\30A3\30EB\30BF\3059\308B\5834\5408\3001\307E\305A\5217\3092\9078\629E\3057(\8868\793A\3055\308C\3066\3044\308B\5217\3067\306A\304F\3068\3082\3088\3044)\3001Oracle\6A19\6E96\306E\6F14\7B97\5B50(=\3001!=\3001not in\3001between)\3092\9078\629E\3057\3066\3001\6BD4\8F03\5BFE\8C61\306E\5F0F\3092\5165\529B\3057\307E\3059\3002\5F0F\3067\306F\5927/\5C0F\6587\5B57\304C\533A\5225\3055\308C\3001\30EF\30A4\30EB\30C9\30AB\30FC\30C9\3068\3057\3066%\3092\4F7F\7528\3067\304D\307E\3059(\4F8B: <code>STATE_NAME like A%)</code>\3002</p>'),
unistr('<p>\884C\3067\30D5\30A3\30EB\30BF\3059\308B\5834\5408\3001\5217\5225\540D\304A\3088\3073\4EFB\610F\306EOracle\95A2\6570\3084\6F14\7B97\5B50(<code>G = ''VA''\307E\305F\306FG = ''CT''</code>\306A\3069\3002<code>G</code>\306F<code>CUSTOMER_STATE</code>\306E\5225\540D)\3092\4F7F\7528\3057\3066\3001\8907\96D1\306A<code>WHERE</code>\53E5\3092\4F5C\6210\3067\304D\307E\3059\3002</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112924136212400539)
,p_name=>'APEXIR_HELP_FLASHBACK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30E9\30C3\30B7\30E5\30D0\30C3\30AF\554F\5408\305B\306B\3088\3063\3066\3001\3042\308B\6642\70B9\3067\5B58\5728\3057\3066\3044\305F\30C7\30FC\30BF\3092\8868\793A\3067\304D\307E\3059\3002\30D5\30E9\30C3\30B7\30E5\30D0\30C3\30AF\53EF\80FD\306A\6642\9593\306E\30C7\30D5\30A9\30EB\30C8\306F3\6642\9593(180\5206)\3067\3059\304C\3001\5B9F\969B\306E\6642\9593\306F\30C7\30FC\30BF\30D9\30FC\30B9\3054\3068\306B\7570\306A\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112985397741400584)
,p_name=>'APEXIR_HELP_FORMAT'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\300C\66F8\5F0F\300D\3092\4F7F\7528\3059\308B\3068\30EC\30DD\30FC\30C8\306E\8868\793A\3092\30AB\30B9\30BF\30DE\30A4\30BA\3067\304D\307E\3059\3002'),
unistr('\300C\66F8\5F0F\300D\306B\306F\6B21\306E\30B5\30D6\30E1\30CB\30E5\30FC\304C\3042\308A\307E\3059\3002</p>'),
unistr('<ul><li>\30BD\30FC\30C8</li>'),
unistr('<li>\30B3\30F3\30C8\30ED\30FC\30EB\30FB\30D6\30EC\30FC\30AF</li>'),
unistr('<li>\30CF\30A4\30E9\30A4\30C8</li>'),
unistr('<li>\8A08\7B97</li>'),
unistr('<li>\96C6\8A08</li>'),
unistr('<li>\30C1\30E3\30FC\30C8</li>'),
unistr('<li>\30B0\30EB\30FC\30D7\5316</li>'),
unistr('<li>\30D4\30DC\30C3\30C8</li>'),
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112983504172400583)
,p_name=>'APEXIR_HELP_GROUP_BY'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4FDD\5B58\3057\305F\30EC\30DD\30FC\30C8\3054\3068\306B1\3064\306E\30B0\30EB\30FC\30D7\5316\30D3\30E5\30FC\3092\5B9A\7FA9\3067\304D\307E\3059\3002'),
unistr('\5B9A\7FA9\3059\308B\3068\3001\691C\7D22\30D0\30FC\306E\30D3\30E5\30FC\30FB\30A2\30A4\30B3\30F3\3092\4F7F\7528\3057\3066\3001\30B0\30EB\30FC\30D7\5316\30D3\30E5\30FC\3068'),
unistr('\30EC\30DD\30FC\30C8\30FB\30D3\30E5\30FC\3092\5207\308A\66FF\3048\3067\304D\307E\3059\3002\30B0\30EB\30FC\30D7\5316\30D3\30E5\30FC\3092\4F5C\6210\3059\308B\306B\306F\3001'),
unistr('\6B21\306E\9078\629E\3092\3057\307E\3059\3002'),
'<p></p><ul>',
unistr('<li>\30B0\30EB\30FC\30D7\5316\3059\308B\5217</li>'),
unistr('<li>\96C6\8A08\3059\308B\5217\3068\5B9F\884C\3059\308B\95A2\6570(average\3001sum\3001count\306A\3069)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112923784086400538)
,p_name=>'APEXIR_HELP_HIGHLIGHT'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30D5\30A3\30EB\30BF\3092\5B9A\7FA9\3067\304D\307E\3059\3002\30D5\30A3\30EB\30BF\57FA\6E96\306B\4E00\81F4\3057\305F\884C\306F\3001\30D5\30A3\30EB\30BF\306B\95A2\9023\4ED8\3051\3089\308C\3066\3044\308B\7279\6027\3092\4F7F\7528\3057\3066\30CF\30A4\30E9\30A4\30C8\8868\793A\3055\308C\307E\3059\3002'),
unistr('\30AA\30D7\30B7\30E7\30F3\306F\6B21\306E\3068\304A\308A\3067\3059\3002</p>'),
unistr('<ul><li><strong>\300C\540D\524D\300D</strong>\306F\3001\8868\793A\7528\306E\307F\306B\4F7F\7528\3055\308C\307E\3059\3002</li>'),
unistr('<li><strong>\300C\9806\5E8F\300D</strong>\3067\3001\898F\5247\304C\8A55\4FA1\3055\308C\308B\9806\5E8F\3092\6307\5B9A\3057\307E\3059\3002</li>'),
unistr('<li><strong>\300C\6709\52B9\300D</strong>\3067\3001\898F\5247\304C\6709\52B9\304B\7121\52B9\304B\3092\6307\5B9A\3057\307E\3059\3002</li>'),
unistr('<li><strong>\300C\30CF\30A4\30E9\30A4\30C8\30FB\30BF\30A4\30D7\300D</strong>\3067\3001\30CF\30A4\30E9\30A4\30C8\3059\308B\5BFE\8C61\3092\300C\884C\300D\3068\300C\30BB\30EB\300D\306E\3069\3061\3089\304B\306B\6307\5B9A\3057\307E\3059\3002\300C\30BB\30EB\300D\3092\9078\629E\3057\305F\5834\5408\3001\300C\30CF\30A4\30E9\30A4\30C8\6761\4EF6\300D\3067\53C2\7167\3055\308C\308B\5217\304C\30CF\30A4\30E9\30A4\30C8\3055\308C\307E\3059\3002</li>'),
unistr('<li><strong>\300C\30D0\30C3\30AF\30B0\30E9\30A6\30F3\30C9\30FB\30AB\30E9\30FC\300D</strong>\306F\3001\30CF\30A4\30E9\30A4\30C8\3055\308C\308B\7BC4\56F2\306E\30D0\30C3\30AF\30B0\30E9\30A6\30F3\30C9\306E\65B0\3057\3044\8272\3067\3059\3002</li>'),
unistr('<li><strong>\300C\30C6\30AD\30B9\30C8\30FB\30AB\30E9\30FC\300D</strong>\306F\3001\30CF\30A4\30E9\30A4\30C8\3055\308C\308B\7BC4\56F2\306B\3042\308B\30C6\30AD\30B9\30C8\306E\65B0\3057\3044\8272\3067\3059\3002</li>'),
unistr('<li><strong>\300C\30CF\30A4\30E9\30A4\30C8\6761\4EF6\300D</strong>\3067\3001\30D5\30A3\30EB\30BF\6761\4EF6\3092\5B9A\7FA9\3057\307E\3059\3002</li></ul>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112861308522400492)
,p_name=>'APEXIR_HELP_PIVOT'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4FDD\5B58\3057\305F\30EC\30DD\30FC\30C8\3054\3068\306B1\3064\306E\30D4\30DC\30C3\30C8\30FB\30D3\30E5\30FC\3092\5B9A\7FA9\3067\304D\307E\3059\3002\5B9A\7FA9\3059\308B\3068\3001\691C\7D22\30D0\30FC\306E\30D3\30E5\30FC\30FB\30A2\30A4\30B3\30F3\3092\4F7F\7528\3057\3066\3001\30D4\30DC\30C3\30C8\30FB\30D3\30E5\30FC\3068\30EC\30DD\30FC\30C8\30FB\30D3\30E5\30FC\3092\5207\308A\66FF\3048\308B\3053\3068\304C\3067\304D\307E\3059\3002\30D4\30DC\30C3\30C8\30FB\30D3\30E5\30FC\3092\4F5C\6210\3059\308B\306B\306F\6B21\3092\9078\629E\3057\307E\3059\3002'),
'<p></p>',
'<ul>',
unistr('<li>\30D4\30DC\30C3\30C8\5BFE\8C61\306E\5217</li>'),
unistr('<li>\884C\3068\3057\3066\8868\793A\3059\308B\5217</li>'),
unistr('<li>\5B9F\884C\3059\308B\95A2\6570(average\3001sum\3001count\306A\3069)\3092\4F7F\7528\3057\3066\96C6\8A08\3059\308B\5217</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112934862562400547)
,p_name=>'APEXIR_HELP_REPORT_SETTINGS'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\3092\30AB\30B9\30BF\30DE\30A4\30BA\3057\3066\3044\308B\5834\5408\306F\3001\691C\7D22\30D0\30FC\306E\4E0B\3001\30EC\30DD\30FC\30C8\306E\4E0A\90E8\306B\30EC\30DD\30FC\30C8\8A2D\5B9A\304C\8868\793A\3055\308C\307E\3059\3002\3053\306E\30A8\30EA\30A2\306F\3001\5DE6\306B\3042\308B\30A2\30A4\30B3\30F3\3092\4F7F\7528\3057\3066\958B\9589\3067\304D\307E\3059\3002'),
'<p>',
unistr('\5404\30EC\30DD\30FC\30C8\8A2D\5B9A\306B\3064\3044\3066\3001\6B21\306E\64CD\4F5C\304C\53EF\80FD\3067\3059\3002'),
'</p><ul>',
unistr('<li>\8A2D\5B9A\3092\7DE8\96C6\3059\308B\306B\306F\540D\524D\3092\30AF\30EA\30C3\30AF\3057\307E\3059\3002</li>'),
unistr('<li>\8A2D\5B9A\3092\6709\52B9\5316/\7121\52B9\5316\3059\308B\306B\306F\3001\300C\6709\52B9/\7121\52B9\300D\30C1\30A7\30C3\30AF\30FB\30DC\30C3\30AF\30B9\3092\9078\629E\307E\305F\306F\9078\629E\89E3\9664\3057\307E\3059\3002\3053\306E\30B3\30F3\30C8\30ED\30FC\30EB\306F\8A2D\5B9A\306E\30AA\30F3/\30AA\30D5\3092\4E00\6642\7684\306B\5207\308A\66FF\3048\308B\3068\304D\4F7F\7528\3057\307E\3059\3002</li>'),
unistr('<li>\8A2D\5B9A\3092\524A\9664\3059\308B\306B\306F\300C\524A\9664\300D\30A2\30A4\30B3\30F3\3092\30AF\30EA\30C3\30AF\3057\307E\3059\3002</li>'),
'</ul>',
unistr('<p>\30C1\30E3\30FC\30C8\3001\30B0\30EB\30FC\30D7\5316\307E\305F\306F\30D4\30DC\30C3\30C8\3092\4F5C\6210\3057\3066\3044\308B\5834\5408\306F\3001\53F3\306B\8868\793A\3055\308C\3066\3044\308B\30EC\30DD\30FC\30C8\30FB\30D3\30E5\30FC\3001\30C1\30E3\30FC\30C8\30FB\30D3\30E5\30FC\3001\30B0\30EB\30FC\30D7\5316\30D3\30E5\30FC\304A\3088\3073\30D4\30DC\30C3\30C8\30FB\30D3\30E5\30FC\306E\30EA\30F3\30AF\3092\4F7F\7528\3057\3066\3001\30C1\30E3\30FC\30C8\3001\30B0\30EB\30FC\30D7\5316\307E\305F\306F\30D4\30DC\30C3\30C8\3068\30D9\30FC\30B9\30FB\30EC\30DD\30FC\30C8\3092\5207\308A\66FF\3048\308B\3053\3068\304C\3067\304D\307E\3059\3002\30C1\30E3\30FC\30C8\3001\30B0\30EB\30FC\30D7\5316\307E\305F\306F\30D4\30DC\30C3\30C8\3092\8868\793A\3057\3066\3044\308B\5834\5408\306F\3001\300C\7DE8\96C6\300D\30EA\30F3\30AF\3092\4F7F\7528\3057\3066\3082\8A2D\5B9A\3092\7DE8\96C6\3067\304D\307E\3059\3002</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112924361474400539)
,p_name=>'APEXIR_HELP_RESET'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30B9\30BF\30DE\30A4\30BA\3057\305F\5185\5BB9\3092\7834\68C4\3057\3066\3001\30EC\30DD\30FC\30C8\3092\30C7\30D5\30A9\30EB\30C8\8A2D\5B9A\306B\623B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112985668094400584)
,p_name=>'APEXIR_HELP_ROWS_PER_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\3054\3068\306B\8868\793A\3059\308B\30EC\30B3\30FC\30C9\6570\3092\8A2D\5B9A\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112924272613400539)
,p_name=>'APEXIR_HELP_SAVE_REPORT'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30AB\30B9\30BF\30DE\30A4\30BA\3057\305F\30EC\30DD\30FC\30C8\3092\4ECA\5F8C\306E\4F7F\7528\306E\305F\3081\306B\4FDD\5B58\3057\307E\3059\3002\540D\524D\3068\8AAC\660E(\4EFB\610F)\3092\5165\529B\3057\3001\30EC\30DD\30FC\30C8\3092\30D1\30D6\30EA\30C3\30AF\306B\30A2\30AF\30BB\30B9\53EF\80FD\306B\3059\308B\3053\3068\304C\3067\304D\307E\3059(\3064\307E\308A\3001\3059\3079\3066\306E\30E6\30FC\30B6\30FC\304C\30D7\30E9\30A4\30DE\30EA\30FB\30C7\30D5\30A9\30EB\30C8\30FB\30EC\30DD\30FC\30C8\306B\30A2\30AF\30BB\30B9\3067\304D\307E\3059)\3002\6B21\306E4\7A2E\985E\306E\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\3092\4FDD\5B58\3067\304D\307E\3059\3002</p>'),
'<ul>',
unistr('<li><strong>\300C\30D7\30E9\30A4\30DE\30EA\30FB\30C7\30D5\30A9\30EB\30C8\300D</strong>(\958B\767A\8005\306E\307F)\3002\30D7\30E9\30A4\30DE\30EA\30FB\30C7\30D5\30A9\30EB\30C8\306F\6700\521D\306B\8868\793A\3055\308C\308B\30EC\30DD\30FC\30C8\3067\3059\3002\30D7\30E9\30A4\30DE\30EA\30FB\30C7\30D5\30A9\30EB\30C8\30FB\30EC\30DD\30FC\30C8\306E\540D\524D\306E\5909\66F4\3084\524A\9664\306F\3067\304D\307E\305B\3093\3002</li>'),
unistr('<li><strong>\300C\4EE3\66FF\30EC\30DD\30FC\30C8\300D</strong>(\958B\767A\8005\306E\307F)\3002\3053\306E\30EC\30DD\30FC\30C8\3092\4F7F\7528\3059\308B\3068\3001\958B\767A\8005\306F\8907\6570\306E\30EC\30DD\30FC\30C8\306E\30EC\30A4\30A2\30A6\30C8\3092\4F5C\6210\3067\304D\307E\3059\3002\4EE3\66FF\30EC\30DD\30FC\30C8\306E\4FDD\5B58\3001\540D\524D\306E\5909\66F4\3001\307E\305F\306F\524A\9664\304C\3067\304D\308B\306E\306F\958B\767A\8005\3060\3051\3067\3059\3002</li>'),
unistr('<li><strong>\300C\30D1\30D6\30EA\30C3\30AF\30FB\30EC\30DD\30FC\30C8\300D</strong>(\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC)\3002\3053\306E\30EC\30DD\30FC\30C8\3092\4F5C\6210\3057\305F\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\304C\4FDD\5B58\3001\540D\524D\306E\5909\66F4\3001\307E\305F\306F\524A\9664\3092\5B9F\884C\3067\304D\307E\3059\3002\4ED6\306E\30E6\30FC\30B6\30FC\306F\5225\306E\30EC\30DD\30FC\30C8\3068\3057\3066\30EC\30A4\30A2\30A6\30C8\3092\8868\793A\304A\3088\3073\4FDD\5B58\3067\304D\307E\3059\3002</li>'),
unistr('<li><strong>\300C\30D7\30E9\30A4\30D9\30FC\30C8\30FB\30EC\30DD\30FC\30C8\300D</strong>(\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC)\3002\3053\306E\30EC\30DD\30FC\30C8\3092\4F5C\6210\3057\305F\30A8\30F3\30C9\30FB\30E6\30FC\30B6\30FC\306E\307F\304C\30EC\30DD\30FC\30C8\306E\8868\793A\3001\4FDD\5B58\3001\540D\524D\306E\5909\66F4\3001\307E\305F\306F\524A\9664\3092\5B9F\884C\3067\304D\307E\3059\3002</li>'),
'</ul>',
unistr('<p>\30AB\30B9\30BF\30DE\30A4\30BA\3057\305F\30EC\30DD\30FC\30C8\3092\4FDD\5B58\3059\308B\3068\3001\884C\30BB\30EC\30AF\30BF\306E\5DE6\5074\306B\3042\308B\691C\7D22\30D0\30FC\306B\30EC\30DD\30FC\30C8\30FB\30BB\30EC\30AF\30BF\304C\8868\793A\3055\308C\307E\3059(\3053\306E\6A5F\80FD\304C\6709\52B9\306A\5834\5408)\3002</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112923299126400538)
,p_name=>'APEXIR_HELP_SEARCH_BAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\5404\30EC\30DD\30FC\30C8\30FB\30DA\30FC\30B8\306E\6700\4E0A\90E8\306B\306F\691C\7D22\30EA\30FC\30B8\30E7\30F3\304C\3042\308A\307E\3059\3002\3053\306E\30EA\30FC\30B8\30E7\30F3(\307E\305F\306F\691C\7D22\30D0\30FC)\306B\306F\6B21\306E\6A5F\80FD\304C\3042\308A\307E\3059:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112986252374400585)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ACTIONS_MENU'
,p_message_language=>'ja'
,p_message_text=>unistr('<li><strong>\300C\30A2\30AF\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC\300D</strong>\3067\306F\30EC\30DD\30FC\30C8\3092\30AB\30B9\30BF\30DE\30A4\30BA\3067\304D\307E\3059\3002\6B21\306B\7D9A\304F\30BB\30AF\30B7\30E7\30F3\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112985749734400584)
,p_name=>'APEXIR_HELP_SEARCH_BAR_FINDER'
,p_message_language=>'ja'
,p_message_text=>unistr('<li><strong>\300C\5217\306E\9078\629E\300D\30A2\30A4\30B3\30F3</strong>\3092\4F7F\7528\3057\3066\3001\691C\7D22\3059\308B(\307E\305F\306F\3059\3079\3066\306E)\5217\3092\6307\5B9A\3067\304D\307E\3059\3002</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112986075683400584)
,p_name=>'APEXIR_HELP_SEARCH_BAR_REPORTS'
,p_message_language=>'ja'
,p_message_text=>unistr('<li><strong>\300C\30EC\30DD\30FC\30C8\300D</strong>\306B\306F\3001\4EE3\66FF\306E\30C7\30D5\30A9\30EB\30C8\3001\304A\3088\3073\4FDD\5B58\3055\308C\305F\30D7\30E9\30A4\30D9\30FC\30C8\307E\305F\306F\30D1\30D6\30EA\30C3\30AF\306E\30EC\30DD\30FC\30C8\304C\8868\793A\3055\308C\307E\3059\3002</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112985911888400584)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ROWS'
,p_message_language=>'ja'
,p_message_text=>unistr('<li><strong>\300C\884C\300D</strong>\3067\306F\3001\30DA\30FC\30B8\3054\3068\306B\8868\793A\3055\308C\308B\30EC\30B3\30FC\30C9\6570\3092\8A2D\5B9A\3057\307E\3059\3002</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112985896098400584)
,p_name=>'APEXIR_HELP_SEARCH_BAR_TEXTBOX'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<li><strong>\300C\30C6\30AD\30B9\30C8\9818\57DF\300D</strong>\3067\306F\3001\5927/\5C0F\6587\5B57\3092\533A\5225\3057\306A\3044\691C\7D22\57FA\6E96(\30EF\30A4\30EB\30C9\30AB\30FC\30C9\6587\5B57\3092\542B\3080)\3092\5165\529B\3067\304D\307E\3059\3002</li>'),
unistr('<li><strong>\300C\5B9F\884C\300D\30DC\30BF\30F3</strong>\3092\62BC\3059\3068\691C\7D22\304C\5B9F\884C\3055\308C\307E\3059\3002\30AB\30FC\30BD\30EB\304C\691C\7D22\30C6\30AD\30B9\30C8\9818\57DF\306B\3042\308B\5834\5408\3001[Enter]\30AD\30FC\3092\62BC\3057\3066\3082\691C\7D22\304C\5B9F\884C\3055\308C\307E\3059\3002</li>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112986105236400584)
,p_name=>'APEXIR_HELP_SEARCH_BAR_VIEW'
,p_message_language=>'ja'
,p_message_text=>unistr('<li><strong>\300C\30D3\30E5\30FC\300D\30A2\30A4\30B3\30F3</strong>\306F\3001\5B9A\7FA9\3055\308C\3066\3044\308B\5834\5408\306B\30EC\30DD\30FC\30C8\306E\30A2\30A4\30B3\30F3\3001\30EC\30DD\30FC\30C8\3001\8A73\7D30\3001\30C1\30E3\30FC\30C8\3001\30B0\30EB\30FC\30D7\5316\304A\3088\3073\30D4\30DC\30C3\30C8\30FB\30D3\30E5\30FC\3092\5207\308A\66FF\3048\307E\3059\3002</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113002128155400596)
,p_name=>'APEXIR_HELP_SEARCH_BAR_WS_MANAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('<li><strong>\300C\7BA1\7406\300D</strong>\3092\4F7F\7528\3059\308B\3068\3001\30EC\30DD\30FC\30C8\307E\305F\306F\30C7\30FC\30BF\30FB\30B0\30EA\30C3\30C9\306E\30D7\30ED\30D1\30C6\30A3\3001\5217\3001\884C\304A\3088\3073\8868\793A\5C65\6B74\3092\7BA1\7406\3067\304D\307E\3059\3002</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112923435559400538)
,p_name=>'APEXIR_HELP_SELECT_COLUMNS'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A\3055\308C\308B\5217\3092\5909\66F4\3057\307E\3059\3002\53F3\5074\306E\5217\304C\8868\793A\3055\308C\3001\5DE6\5074\306E\5217\306F\975E\8868\793A\306B\306A\308A\307E\3059\3002\53F3\7AEF\306B\3042\308B\77E2\5370\3092\4F7F\7528\3057\3066\3001\8868\793A\3055\308C\308B\5217\3092\4E26\3079\66FF\3048\308B\3053\3068\304C\3067\304D\307E\3059\3002\8A08\7B97\7D50\679C\306E\5217\306F\3001\5148\982D\306B<strong>**</strong>\304C\4ED8\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112923643594400538)
,p_name=>'APEXIR_HELP_SORT'
,p_message_language=>'ja'
,p_message_text=>unistr('<p>\30BD\30FC\30C8\5BFE\8C61\306E\5217\3068\3001\6607\9806/\964D\9806\3092\5909\66F4\3057\307E\3059\3002<code>NULLs</code>\306E\51E6\7406\65B9\6CD5\3082\6307\5B9A\3067\304D\307E\3059\3002\30C7\30D5\30A9\30EB\30C8\8A2D\5B9A\306F<code>NULLs</code>\3092\5E38\306B\6700\5F8C\306B\8868\793A\3059\308B\304B\3001\5E38\306B\6700\521D\306B\8868\793A\3059\308B\304B\3067\3059\3002\30BD\30FC\30C8\7D50\679C\306F\3001\30EC\30DD\30FC\30C8\306E\5217\30D8\30C3\30C0\30FC\306E\53F3\306B\8868\793A\3055\308C\307E\3059\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112983363535400582)
,p_name=>'APEXIR_HELP_SUBSCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30D6\30B9\30AF\30EA\30D7\30B7\30E7\30F3\3092\8FFD\52A0\3059\308B\969B\3001\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9(\307E\305F\306F\8907\6570\306E\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9\3092\30AB\30F3\30DE\3067\533A\5207\3063\305F\3082\306E)\3001\96FB\5B50\30E1\30FC\30EB\306E\4EF6\540D\3001\983B\5EA6\304A\3088\3073\958B\59CB\65E5\3068\7D42\4E86\65E5\3092\6307\5B9A\3057\307E\3059\3002\7D50\679C\306E\96FB\5B50\30E1\30FC\30EB\306F\3001\30B5\30D6\30B9\30AF\30EA\30D7\30B7\30E7\30F3\8FFD\52A0\6642\306E\30EC\30DD\30FC\30C8\8A2D\5B9A\3092\4F7F\7528\3057\305F\73FE\5728\306E\30C7\30FC\30BF\3092\542B\3080\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\306EHTML\30D0\30FC\30B8\30E7\30F3\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113001951213400596)
,p_name=>'APEXIR_HELP_WS_01'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30C7\30FC\30BF\30FB\30B0\30EA\30C3\30C9\306F\3001\9AD8\5EA6\306A\30AB\30B9\30BF\30DE\30A4\30BA\304C\53EF\80FD\306A\3001\57FA\672C\7684\306B\7DE8\96C6\53EF\80FD\306A\30EC\30DD\30FC\30C8\3067\3059\3002\30E6\30FC\30B6\30FC\306F\3001\5217\306E\9078\629E\3001\30D5\30A3\30EB\30BF\306E\9069\7528\3001\30CF\30A4\30E9\30A4\30C8\307E\305F\306F\30BD\30FC\30C8\3092\884C\3063\3066\3001\30EC\30DD\30FC\30C8\30FB\30C7\30FC\30BF\306E\30EC\30A4\30A2\30A6\30C8\3092\5909\66F4\3067\304D\307E\3059\3002\307E\305F\3001\30D6\30EC\30FC\30AF\3001\96C6\8A08\3001\30C1\30E3\30FC\30C8\3001\30B0\30EB\30FC\30D7\5316\306E\5B9A\7FA9\3084\3001\72EC\81EA\306E\8A08\7B97\306E\8FFD\52A0\3082\53EF\80FD\3067\3059\3002\30B5\30D6\30B9\30AF\30EA\30D7\30B7\30E7\30F3\3092\8A2D\5B9A\3057\3066\3001\30EC\30DD\30FC\30C8\3092\6307\5B9A\3057\305F\9593\9694\3067\96FB\5B50\30E1\30FC\30EB\3059\308B\3053\3068\3082\3067\304D\307E\3059\3002\30E6\30FC\30B6\30FC\306F\30EC\30DD\30FC\30C8\306E\8907\6570\306E\30D0\30EA\30A8\30FC\30B7\30E7\30F3\3092\4F5C\6210\3057\3001\30D7\30E9\30A4\30D9\30FC\30C8\306E\53C2\7167\7528\306B\540D\524D\4ED8\304D\30EC\30DD\30FC\30C8\3068\3057\3066\4FDD\5B58\3067\304D\307E\3059\3002'),
'<p/>',
unistr('\30C7\30FC\30BF\30FB\30B0\30EA\30C3\30C9\306F\3001\691C\7D22\30D0\30FC\3001\30A2\30AF\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC\3001\7BA1\7406\30E1\30CB\30E5\30FC\307E\305F\306F\5217\30D8\30C3\30C0\30FC\30FB\30E1\30CB\30E5\30FC\3092\4F7F\7528\3057\3066\30AB\30B9\30BF\30DE\30A4\30BA\3067\304D\307E\3059\3002')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113013724684400604)
,p_name=>'APEXIR_HELP_WS_ACTIONS_MENU'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30B7\30E7\30F3\30FB\30E1\30CB\30E5\30FC\306F\691C\7D22\30D0\30FC\306E\300C\5B9F\884C\300D\30DC\30BF\30F3\306E\53F3\5074\306B\8868\793A\3055\308C\307E\3059\3002\3053\306E\30E1\30CB\30E5\30FC\3092\4F7F\7528\3057\3066\30C7\30FC\30BF\30FB\30B0\30EA\30C3\30C9\30FB\30EC\30DD\30FC\30C8\3092\30AB\30B9\30BF\30DE\30A4\30BA\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113002426078400596)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\884C\306E\8FFD\52A0/\7DE8\96C6\300D\30DA\30FC\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113002599417400596)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT_ROW'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30C7\30FC\30BF\30FB\30B0\30EA\30C3\30C9\306B\884C\3092\8FFD\52A0\3059\308B\306B\306F\3001\300C\884C\306E\8FFD\52A0\300D\3092\30AF\30EA\30C3\30AF\3057\307E\3059\3002\884C\306E\8A73\7D30\3092\7DE8\96C6\3059\308B\306B\306F\3001\7DE8\96C6\3059\308B\884C\3067\884C\7DE8\96C6\30A2\30A4\30B3\30F3(\6700\521D\306E\5217)\3092\30AF\30EA\30C3\30AF\3057\307E\3059\3002\30C7\30FC\30BF\30FB\30B0\30EA\30C3\30C9\306E\5217\3092\793A\3059\300C\884C\306E\8FFD\52A0/\7DE8\96C6\300D\30DA\30FC\30B8\304C\8868\793A\3055\308C\307E\3059\3002</p>'),
'',
unistr('<p>\884C\306E\7DE8\96C6\3067\306F\6B21\306E\64CD\4F5C\304C\53EF\80FD\3067\3059:</p>'),
'',
'<p><ul>',
unistr('<li>\884C\3092<strong>\300C\524A\9664\300D</strong>\3057\307E\3059\3002</li>'),
unistr('<li><strong>\300C\5909\66F4\306E\9069\7528\300D</strong>\3067\3001\884C\306B\5BFE\3059\308B\5909\66F4\3092\4FDD\5B58\3057\307E\3059\3002</li>'),
unistr('<li><strong>\300C\30A2\30AF\30B7\30E7\30F3\300D</strong>\5185\3067\3001\884C\306E\8FFD\52A0\3001\30D5\30A1\30A4\30EB\3001\30CE\30FC\30C8\3001\30EA\30F3\30AF\307E\305F\306F\30BF\30B0\306E\8FFD\52A0\3001\5C65\6B74\306E\8868\793A\306A\3069\3092\884C\3044\307E\3059\3002</li>'),
unistr('<li><strong>\300C\6B21\3078\300D\304A\3088\3073\300C\623B\308B\300D</strong>\884C\306B\30CA\30D3\30B2\30FC\30C8\3057\307E\3059\3002</li>'),
unistr('<li><strong>\300C\7BA1\7406\300D</strong>\5185\3067\3001\5217\30D7\30ED\30D1\30C6\30A3\3001\5217\30B0\30EB\30FC\30D7\3001\691C\8A3C\304A\3088\3073LOV\306E\8A2D\5B9A\3092\884C\3044\307E\3059\3002</li>'),
'</ul></p>',
'',
unistr('<p>\30DA\30FC\30B8\4E0B\90E8\306B\3042\308B\300C\6CE8\91C8\300D\30EA\30FC\30B8\30E7\30F3\306B\306F\3001\73FE\5728\306E\884C\306B\95A2\9023\4ED8\3051\3089\308C\3066\3044\308B\30D5\30A1\30A4\30EB\3001\30CE\30FC\30C8\3001\30EA\30F3\30AF\307E\305F\306F\30BF\30B0\304C\3042\308C\3070\8868\793A\3055\308C\307E\3059\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113013827293400604)
,p_name=>'APEXIR_HELP_WS_CONTROL_BREAK'
,p_message_language=>'ja'
,p_message_text=>unistr('1\3064\307E\305F\306F\8907\6570\306E\5217\306B\30D6\30EC\30FC\30AF\30FB\30B0\30EB\30FC\30D7\3092\4F5C\6210\3057\307E\3059\3002\30C7\30FC\30BF\30FB\30B0\30EA\30C3\30C9\30FB\30EC\30DD\30FC\30C8\304B\3089\5217\304C\62BD\51FA\3055\308C\3001\30DE\30B9\30BF\30FC\30FB\30EC\30B3\30FC\30C9\3068\3057\3066\8868\793A\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113002301615400596)
,p_name=>'APEXIR_HELP_WS_DOWNLOAD'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\7D50\679C\30BB\30C3\30C8\306E\30C0\30A6\30F3\30ED\30FC\30C9\3092\6709\52B9\306B\3057\307E\3059\3002\30C0\30A6\30F3\30ED\30FC\30C9\5F62\5F0F\306B\306FCSV\3001HTML\307E\305F\306F\96FB\5B50\30E1\30FC\30EB\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113013972584400605)
,p_name=>'APEXIR_HELP_WS_REPORT_SETTINGS'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30C7\30FC\30BF\30FB\30B0\30EA\30C3\30C9\30FB\30EC\30DD\30FC\30C8\3092\30AB\30B9\30BF\30DE\30A4\30BA\3057\3066\3044\308B\5834\5408\306F\3001\691C\7D22\30D0\30FC\306E\4E0B\3001\30EC\30DD\30FC\30C8\306E\4E0A\90E8\306B\30EC\30DD\30FC\30C8\8A2D\5B9A\304C\8868\793A\3055\308C\307E\3059\3002\3053\306E\30A8\30EA\30A2\306F\3001\5DE6\306B\3042\308B\30A2\30A4\30B3\30F3\3092\4F7F\7528\3057\3066\958B\9589\3067\304D\307E\3059\3002'),
'<p>',
unistr('\5404\30EC\30DD\30FC\30C8\8A2D\5B9A\306B\3064\3044\3066\3001\6B21\306E\64CD\4F5C\304C\53EF\80FD\3067\3059\3002'),
'</p><ul>',
unistr('<li>\8A2D\5B9A\3092\7DE8\96C6\3059\308B\306B\306F\540D\524D\3092\30AF\30EA\30C3\30AF\3057\307E\3059\3002</li>'),
unistr('<li>\8A2D\5B9A\3092\6709\52B9\5316/\7121\52B9\5316\3059\308B\306B\306F\3001\300C\6709\52B9/\7121\52B9\300D\30C1\30A7\30C3\30AF\30FB\30DC\30C3\30AF\30B9\3092\9078\629E\307E\305F\306F\9078\629E\89E3\9664\3057\307E\3059\3002\3053\306E\30B3\30F3\30C8\30ED\30FC\30EB\306F\8A2D\5B9A\306E\30AA\30F3/\30AA\30D5\3092\4E00\6642\7684\306B\5207\308A\66FF\3048\308B\3068\304D\4F7F\7528\3057\307E\3059\3002</li>'),
unistr('<li>\8A2D\5B9A\3092\524A\9664\3059\308B\306B\306F\300C\524A\9664\300D\30A2\30A4\30B3\30F3\3092\30AF\30EA\30C3\30AF\3057\307E\3059\3002</li>'),
'</ul>',
unistr('<p>\30C1\30E3\30FC\30C8\3084\30B0\30EB\30FC\30D7\5316\3092\4F5C\6210\3057\3066\3044\308B\5834\5408\306F\3001\53F3\306B\8868\793A\3055\308C\3066\3044\308B\30EC\30DD\30FC\30C8\30FB\30D3\30E5\30FC\3001\30C1\30E3\30FC\30C8\30FB\30D3\30E5\30FC\304A\3088\3073\30B0\30EB\30FC\30D7\5316\30D3\30E5\30FC\306E\30EA\30F3\30AF\3092\4F7F\7528\3057\3066\3001\30C1\30E3\30FC\30C8\3084\30B0\30EB\30FC\30D7\5316\3068\30D9\30FC\30B9\30FB\30EC\30DD\30FC\30C8\3092\5207\308A\66FF\3048\308B\3053\3068\304C\3067\304D\307E\3059\3002\30C1\30E3\30FC\30C8\3084\30B0\30EB\30FC\30D7\5316\3092\8868\793A\3057\3066\3044\308B\5834\5408\306F\3001\300C\7DE8\96C6\300D\30EA\30F3\30AF\3092\4F7F\7528\3057\3066\3082\8A2D\5B9A\3092\7DE8\96C6\3067\304D\307E\3059\3002</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113002210297400596)
,p_name=>'APEXIR_HELP_WS_SAVE_REPORT'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\30AB\30B9\30BF\30DE\30A4\30BA\3057\305F\30C7\30FC\30BF\30FB\30B0\30EA\30C3\30C9\30FB\30EC\30DD\30FC\30C8\30FB\30EC\30A4\30A2\30A6\30C8\3092\4ECA\5F8C\306E\4F7F\7528\306E\305F\3081\306B\4FDD\5B58\3057\307E\3059\3002\540D\524D\3068\8AAC\660E(\4EFB\610F)\3092\5165\529B\3057\307E\3059\3002\6B21\306E3\7A2E\985E\306E\30C7\30FC\30BF\30FB\30B0\30EA\30C3\30C9\30FB\30EC\30DD\30FC\30C8\30FB\30EC\30A4\30A2\30A6\30C8\3092\4FDD\5B58\3067\304D\307E\3059\3002</p>'),
'<ul>',
unistr('<li><strong>\300C\30D7\30E9\30A4\30DE\30EA\30FB\30C7\30D5\30A9\30EB\30C8\300D</strong>(\7BA1\7406\8005\306E\307F)\3002\30D7\30E9\30A4\30DE\30EA\30FB\30C7\30D5\30A9\30EB\30C8\306F\6700\521D\306B\8868\793A\3055\308C\308B\30EC\30A4\30A2\30A6\30C8\3067\3059\3002\30D7\30E9\30A4\30DE\30EA\30FB\30C7\30D5\30A9\30EB\30C8\30FB\30EC\30DD\30FC\30C8\306E\540D\524D\306E\5909\66F4\3084\524A\9664\306F\3067\304D\307E\305B\3093\3002</li>'),
unistr('<li><strong>\300C\4EE3\66FF\30EC\30DD\30FC\30C8\300D</strong>(\7BA1\7406\8005\306E\307F)\3002\3053\306E\30EC\30DD\30FC\30C8\3092\4F7F\7528\3059\308B\3068\3001\7BA1\7406\8005\306F\8907\6570\306E\30EC\30DD\30FC\30C8\30FB\30EC\30A4\30A2\30A6\30C8\3092\4F5C\6210\3067\304D\307E\3059\3002\4EE3\66FF\30EC\30DD\30FC\30C8\306E\4FDD\5B58\3001\540D\524D\306E\5909\66F4\3001\307E\305F\306F\524A\9664\304C\3067\304D\308B\306E\306F\7BA1\7406\8005\3060\3051\3067\3059\3002</li>'),
unistr('<li><strong>\300C\30D7\30E9\30A4\30D9\30FC\30C8\30FB\30EC\30DD\30FC\30C8\300D</strong>(\5168\30E6\30FC\30B6\30FC)\3002\3053\306E\30EC\30DD\30FC\30C8\30FB\30EC\30A4\30A2\30A6\30C8\3092\4F5C\6210\3057\305F\30E6\30FC\30B6\30FC\304C\30EC\30DD\30FC\30C8\306E\8868\793A\3001\4FDD\5B58\3001\540D\524D\306E\5909\66F4\3001\307E\305F\306F\524A\9664\3092\5B9F\884C\3067\304D\307E\3059\3002</li>'),
'</ul>',
unistr('<p>\30AB\30B9\30BF\30DE\30A4\30BA\3057\305F\30EC\30DD\30FC\30C8\3092\4FDD\5B58\3059\308B\3068\3001\884C\30BB\30EC\30AF\30BF\306E\5DE6\5074\306B\3042\308B\691C\7D22\30D0\30FC\306B\30EC\30DD\30FC\30C8\30FB\30BB\30EC\30AF\30BF\304C\8868\793A\3055\308C\307E\3059(\3053\306E\6A5F\80FD\304C\6709\52B9\306A\5834\5408)\3002</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112928352823400542)
,p_name=>'APEXIR_HIDE_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\306E\975E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112918974295400535)
,p_name=>'APEXIR_HIGHLIGHT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CF\30A4\30E9\30A4\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112929813047400543)
,p_name=>'APEXIR_HIGHLIGHTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CF\30A4\30E9\30A4\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112934966053400547)
,p_name=>'APEXIR_HIGHLIGHT_CONDITION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CF\30A4\30E9\30A4\30C8\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112983988668400583)
,p_name=>'APEXIR_HIGHLIGHT_STYLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CF\30A4\30E9\30A4\30C8\30FB\30B9\30BF\30A4\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112893971164400516)
,p_name=>'APEXIR_HIGHLIGHT_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CF\30A4\30E9\30A4\30C8\30FB\30BF\30A4\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113003465266400597)
,p_name=>'APEXIR_HORIZONTAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A2A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113033029105400618)
,p_name=>'APEXIR_INACTIVE_SETTING'
,p_message_language=>'ja'
,p_message_text=>unistr('1\3064\306E\975E\30A2\30AF\30C6\30A3\30D6\306A\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113033157662400618)
,p_name=>'APEXIR_INACTIVE_SETTINGS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306E\975E\30A2\30AF\30C6\30A3\30D6\306A\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112924905480400539)
,p_name=>'APEXIR_INTERACTIVE_REPORT_HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\306E\30D8\30EB\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112935973430400547)
,p_name=>'APEXIR_INVALID'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112929322585400542)
,p_name=>'APEXIR_INVALID_COMPUTATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A08\7B97\306E\5F0F\304C\7121\52B9\3067\3059\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112888708226400512)
,p_name=>'APEXIR_INVALID_END_DATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D42\4E86\65E5\306F\958B\59CB\65E5\3088\308A\3082\5F8C\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112943635620400553)
,p_name=>'APEXIR_INVALID_FILTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9\306A\30D5\30A3\30EB\30BF\5F0F\3067\3059\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113011432541400603)
,p_name=>'APEXIR_INVALID_FILTER_QUERY'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9\306A\30D5\30A3\30EB\30BF\554F\5408\305B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113033240903400619)
,p_name=>'APEXIR_INVALID_SETTING'
,p_message_language=>'ja'
,p_message_text=>unistr('1\3064\306E\7121\52B9\306A\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113033335897400619)
,p_name=>'APEXIR_INVALID_SETTINGS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306E\7121\52B9\306A\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112984151030400583)
,p_name=>'APEXIR_IN_MINUTES'
,p_message_language=>'ja'
,p_message_text=>unistr('(\5206\5358\4F4D)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113001117065400595)
,p_name=>'APEXIR_IS_IN_THE_LAST'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\304C\904E\53BB\306E%1\5185\306B\3042\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113001393080400595)
,p_name=>'APEXIR_IS_IN_THE_NEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\304C\4ECA\5F8C\306E%1\5185\306B\3042\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113001229001400595)
,p_name=>'APEXIR_IS_NOT_IN_THE_LAST'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\304C\904E\53BB\306E%1\5185\306B\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113001457631400596)
,p_name=>'APEXIR_IS_NOT_IN_THE_NEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\304C\4ECA\5F8C\306E%1\5185\306B\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112934061486400546)
,p_name=>'APEXIR_KEYPAD'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AD\30FC\30D1\30C3\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112900196395400520)
,p_name=>'APEXIR_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112927922904400541)
,p_name=>'APEXIR_LABEL_AXIS_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB\306E\8EF8\30BF\30A4\30C8\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112920406696400536)
,p_name=>'APEXIR_LAST_DAY'
,p_message_language=>'ja'
,p_message_text=>unistr('\904E\53BB1\65E5\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112920605494400536)
,p_name=>'APEXIR_LAST_HOUR'
,p_message_language=>'ja'
,p_message_text=>unistr('\904E\53BB1\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112920171889400535)
,p_name=>'APEXIR_LAST_MONTH'
,p_message_language=>'ja'
,p_message_text=>unistr('\904E\53BB1\304B\6708\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112920213572400536)
,p_name=>'APEXIR_LAST_WEEK'
,p_message_language=>'ja'
,p_message_text=>unistr('\904E\53BB1\9031\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112920345373400536)
,p_name=>'APEXIR_LAST_X_DAYS'
,p_message_language=>'ja'
,p_message_text=>unistr('\904E\53BB%0\65E5\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112920531147400536)
,p_name=>'APEXIR_LAST_X_HOURS'
,p_message_language=>'ja'
,p_message_text=>unistr('\904E\53BB%0\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112919915976400535)
,p_name=>'APEXIR_LAST_X_YEARS'
,p_message_language=>'ja'
,p_message_text=>unistr('\904E\53BB%0\5E74\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112920087673400535)
,p_name=>'APEXIR_LAST_YEAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\904E\53BB1\5E74\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112900084685400520)
,p_name=>'APEXIR_LINE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6298\308C\7DDA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112896870096400518)
,p_name=>'APEXIR_LINE_WITH_AREA'
,p_message_language=>'ja'
,p_message_text=>unistr('\9762\4ED8\304D\6298\308C\7DDA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113011384872400603)
,p_name=>'APEXIR_MAP_IT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DE\30C3\30D7\3059\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112928841717400542)
,p_name=>'APEXIR_MAX_QUERY_COST'
,p_message_language=>'ja'
,p_message_text=>unistr('\554F\5408\305B\304C\3001\6700\5927\8A31\5BB9\30EA\30BD\30FC\30B9\3092\8D85\3048\308B\3068\63A8\5B9A\3055\308C\307E\3059\3002\30EC\30DD\30FC\30C8\8A2D\5B9A\3092\5909\66F4\3057\3066\304B\3089\518D\8A66\884C\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112911091525400528)
,p_name=>'APEXIR_MAX_ROW_CNT'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30EC\30DD\30FC\30C8\306E\6700\5927\884C\6570\306F%0\884C\3067\3059\3002\30D5\30A3\30EB\30BF\3092\9069\7528\3057\3066\3001\554F\5408\305B\306E\30EC\30B3\30FC\30C9\6570\3092\524A\6E1B\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113011939796400603)
,p_name=>'APEXIR_MAX_X'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5927%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113012170582400603)
,p_name=>'APEXIR_MEDIAN_X'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E1\30B8\30A2\30F3%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112915085297400531)
,p_name=>'APEXIR_MIN_AGO'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\5206\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113012083445400603)
,p_name=>'APEXIR_MIN_X'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5C0F%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113011018713400602)
,p_name=>'APEXIR_MONTH'
,p_message_language=>'ja'
,p_message_text=>unistr('\6708')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112984509917400583)
,p_name=>'APEXIR_MONTHLY'
,p_message_language=>'ja'
,p_message_text=>unistr('\6708')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112927108251400541)
,p_name=>'APEXIR_MOVE'
,p_message_language=>'ja'
,p_message_text=>unistr('\79FB\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112927099427400541)
,p_name=>'APEXIR_MOVE_ALL'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\79FB\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113038294795400622)
,p_name=>'APEXIR_MULTIIR_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306B\306F\8907\6570\306E\5BFE\8A71\30EC\30DD\30FC\30C8\304C\542B\307E\308C\3066\3044\308B\305F\3081\3001\30EA\30FC\30B8\30E7\30F3\306E\9759\7684ID\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112895540388400517)
,p_name=>'APEXIR_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\540D\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112922990676400538)
,p_name=>'APEXIR_NEW_AGGREGATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F\96C6\8A08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113033995573400619)
,p_name=>'APEXIR_NEW_CATEGORY_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F\30AB\30C6\30B4\30EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112923087054400538)
,p_name=>'APEXIR_NEW_COMPUTATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F\8A08\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112917871095400534)
,p_name=>'APEXIR_NEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112920924175400536)
,p_name=>'APEXIR_NEXT_DAY'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E1\65E5\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112920798399400536)
,p_name=>'APEXIR_NEXT_HOUR'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112921220358400536)
,p_name=>'APEXIR_NEXT_MONTH'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\6708')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112921110842400536)
,p_name=>'APEXIR_NEXT_WEEK'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\9031')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112921030529400536)
,p_name=>'APEXIR_NEXT_X_DAYS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E%0\65E5\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112920883274400536)
,p_name=>'APEXIR_NEXT_X_HOURS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E%0\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112921437485400536)
,p_name=>'APEXIR_NEXT_X_YEARS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E%0\5E74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112921311134400536)
,p_name=>'APEXIR_NEXT_YEAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\5E74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112895846647400517)
,p_name=>'APEXIR_NO'
,p_message_language=>'ja'
,p_message_text=>unistr('\3044\3044\3048')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112936183203400548)
,p_name=>'APEXIR_NONE'
,p_message_language=>'ja'
,p_message_text=>unistr('- \306A\3057 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112983792395400583)
,p_name=>'APEXIR_NOT_VALID_EMAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9\306A\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112932688144400545)
,p_name=>'APEXIR_NULLS_ALWAYS_FIRST'
,p_message_language=>'ja'
,p_message_text=>unistr('NULL\3092\5E38\306B\6700\521D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112932538298400545)
,p_name=>'APEXIR_NULLS_ALWAYS_LAST'
,p_message_language=>'ja'
,p_message_text=>unistr('NULL\3092\5E38\306B\6700\5F8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112933046721400545)
,p_name=>'APEXIR_NULL_SORTING'
,p_message_language=>'ja'
,p_message_text=>unistr('NULL\30BD\30FC\30C8%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112929409839400543)
,p_name=>'APEXIR_NUMERIC_FLASHBACK_TIME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30E9\30C3\30B7\30E5\30D0\30C3\30AF\6642\9593\306F\6570\5024\3067\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112929051486400542)
,p_name=>'APEXIR_NUMERIC_SEQUENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\9806\5E8F\306F\6570\5024\3067\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112933548681400546)
,p_name=>'APEXIR_OPERATOR'
,p_message_language=>'ja'
,p_message_text=>unistr('\6F14\7B97\5B50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112894432256400516)
,p_name=>'APEXIR_ORANGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AA\30EC\30F3\30B8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113003328190400597)
,p_name=>'APEXIR_ORIENTATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\5411\304D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112896383525400517)
,p_name=>'APEXIR_OTHER'
,p_message_language=>'ja'
,p_message_text=>unistr('\305D\306E\4ED6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112879187409400505)
,p_name=>'APEXIR_PDF_ORIENTATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306E\5411\304D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112879864371400505)
,p_name=>'APEXIR_PDF_ORIENTATION_HORIZONTAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A2A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112879911870400505)
,p_name=>'APEXIR_PDF_ORIENTATION_VERTICAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\7E26')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112879002386400505)
,p_name=>'APEXIR_PDF_PAGE_SIZE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30B5\30A4\30BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112879681371400505)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A3'
,p_message_language=>'ja'
,p_message_text=>'A3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112879516601400505)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A4'
,p_message_language=>'ja'
,p_message_text=>'A4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112879798384400505)
,p_name=>'APEXIR_PDF_PAGE_SIZE_CUSTOM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30B9\30BF\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112879359766400505)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LEGAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30AC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112879238693400505)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LETTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30BF\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112879423309400505)
,p_name=>'APEXIR_PDF_PAGE_SIZE_TABLOID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30D6\30ED\30A4\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113012412380400603)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_COUNT_X'
,p_message_language=>'ja'
,p_message_text=>unistr('\5408\8A08\30AB\30A6\30F3\30C8%0\306B\5BFE\3059\308B\5272\5408(%)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113011617119400603)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_SUM_X'
,p_message_language=>'ja'
,p_message_text=>unistr('\7DCF\5408\8A08%0\306B\5BFE\3059\308B\5272\5408(%)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113010625256400602)
,p_name=>'APEXIR_PERCENT_TOTAL_COUNT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5408\8A08\30AB\30A6\30F3\30C8\306B\5BFE\3059\308B\5272\5408')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113010559630400602)
,p_name=>'APEXIR_PERCENT_TOTAL_SUM'
,p_message_language=>'ja'
,p_message_text=>unistr('\7DCF\5408\8A08\306B\5BFE\3059\308B\5272\5408')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112899934607400520)
,p_name=>'APEXIR_PIE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5186')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112959812215400565)
,p_name=>'APEXIR_PIVOT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D4\30DC\30C3\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112961336802400566)
,p_name=>'APEXIR_PIVOT_AGG_NOT_NULL'
,p_message_language=>'ja'
,p_message_text=>unistr('\96C6\8A08\304C\6307\5B9A\3055\308C\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112961510138400566)
,p_name=>'APEXIR_PIVOT_AGG_NOT_ON_ROW_COL'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\5217\3068\3057\3066\9078\629E\3055\308C\305F\5217\3067\96C6\8A08\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112960733124400565)
,p_name=>'APEXIR_PIVOT_COLUMNS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D4\30DC\30C3\30C8\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112960538176400565)
,p_name=>'APEXIR_PIVOT_COLUMN_N'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D4\30DC\30C3\30C8\5217%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112961198750400566)
,p_name=>'APEXIR_PIVOT_COLUMN_NOT_NULL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D4\30DC\30C3\30C8\5217\304C\6307\5B9A\3055\308C\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112861213686400492)
,p_name=>'APEXIR_PIVOT_MAX_ROW_CNT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D4\30DC\30C3\30C8\554F\5408\305B\306E\884C\30AB\30A6\30F3\30C8\6700\5927\5024\306F\3001\8868\793A\3055\308C\308B\884C\6570\3067\306F\306A\304F\30D9\30FC\30B9\554F\5408\305B\306E\884C\6570\3092\5236\9650\3057\307E\3059\3002\30D9\30FC\30B9\554F\5408\305B\304C\884C\30AB\30A6\30F3\30C8\6700\5927\5024%0\3092\8D85\3048\3066\3044\307E\3059\3002\30D5\30A3\30EB\30BF\3092\9069\7528\3057\3066\3001\30D9\30FC\30B9\554F\5408\305B\306E\30EC\30B3\30FC\30C9\6570\3092\524A\6E1B\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112961053589400566)
,p_name=>'APEXIR_PIVOT_SORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D4\30DC\30C3\30C8\30FB\30BD\30FC\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112930491256400543)
,p_name=>'APEXIR_PIVOT_TOO_MANY_VALUES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D4\30DC\30C3\30C8\5217\306B\542B\307E\308C\308B\500B\5225\5024\304C\591A\3059\304E\307E\3059 - \30D4\30DC\30C3\30C8SQL\3092\751F\6210\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112983887971400583)
,p_name=>'APEXIR_PREVIEW'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30EC\30D3\30E5\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112917915381400534)
,p_name=>'APEXIR_PREVIOUS'
,p_message_language=>'ja'
,p_message_text=>unistr('\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113009582603400601)
,p_name=>'APEXIR_PRIMARY'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E3B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112984805417400584)
,p_name=>'APEXIR_PRIMARY_REPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30E9\30A4\30DE\30EA\30FB\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112878971099400505)
,p_name=>'APEXIR_PRINT_ACCESSIBLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30BB\30B7\30D3\30EA\30C6\30A3\30FB\30BF\30B0\3092\542B\3081\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112865847589400495)
,p_name=>'APEXIR_PRINT_STRIP_RICH_TEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30C3\30C1\30FB\30C6\30AD\30B9\30C8\3092\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112942610924400552)
,p_name=>'APEXIR_PRIVATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30E9\30A4\30D9\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112900580183400520)
,p_name=>'APEXIR_PUBLIC'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30D6\30EA\30C3\30AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112896104646400517)
,p_name=>'APEXIR_RED'
,p_message_language=>'ja'
,p_message_text=>unistr('\8D64')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113038148899400622)
,p_name=>'APEXIR_REGION_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\306E\9759\7684ID %0\306F\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112927240126400541)
,p_name=>'APEXIR_REMOVE'
,p_message_language=>'ja'
,p_message_text=>unistr('\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112927311090400541)
,p_name=>'APEXIR_REMOVE_ALL'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113033425680400619)
,p_name=>'APEXIR_REMOVE_CHART'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30E9\30D5\306E\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112926821464400541)
,p_name=>'APEXIR_REMOVE_CONTROL_BREAK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30C8\30ED\30FC\30EB\30FB\30D6\30EC\30FC\30AF\306E\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112926526204400540)
,p_name=>'APEXIR_REMOVE_FILTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A3\30EB\30BF\306E\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112926654507400540)
,p_name=>'APEXIR_REMOVE_FLASHBACK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30E9\30C3\30B7\30E5\30D0\30C3\30AF\306E\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113033566327400619)
,p_name=>'APEXIR_REMOVE_GROUP_BY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30EB\30FC\30D7\5316\306E\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112926901504400541)
,p_name=>'APEXIR_REMOVE_HIGHLIGHT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CF\30A4\30E9\30A4\30C8\306E\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113033671841400619)
,p_name=>'APEXIR_REMOVE_PIVOT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D4\30DC\30C3\30C8\306E\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113014617572400605)
,p_name=>'APEXIR_REMOVE_REPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\306E\524A\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112995234641400591)
,p_name=>'APEXIR_RENAME_DEFAULT_REPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\30FB\30EC\30DD\30FC\30C8\540D\306E\5909\66F4')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112936466538400548)
,p_name=>'APEXIR_RENAME_REPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\306E\540D\524D\5909\66F4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112918285193400534)
,p_name=>'APEXIR_REPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113012542013400603)
,p_name=>'APEXIR_REPORTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112892795704400515)
,p_name=>'APEXIR_REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\5225\540D%0\3067\4FDD\5B58\3055\308C\305F\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\304C\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112942947813400553)
,p_name=>'APEXIR_REPORT_DOES_NOT_EXIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\304C\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112892863692400515)
,p_name=>'APEXIR_REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\4FDD\5B58\3055\308C\305F\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8ID %0\304C\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112934770720400547)
,p_name=>'APEXIR_REPORT_SETTINGS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112915565823400532)
,p_name=>'APEXIR_REPORT_VIEW'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\30FB\30D3\30E5\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112919479847400535)
,p_name=>'APEXIR_RESET'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30BB\30C3\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112900776995400521)
,p_name=>'APEXIR_RESET_CONFIRM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\3092\30C7\30D5\30A9\30EB\30C8\8A2D\5B9A\306B\623B\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112895954955400517)
,p_name=>'APEXIR_ROW'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113008673203400601)
,p_name=>'APEXIR_ROWID_NOT_SUPPORTED_FOR_WEBSOURCE'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\30C7\30FC\30BF\30FB\30BD\30FC\30B9\306E\4E3B\30AD\30FC\5217\3068\3057\3066ROWID\3092\4F7F\7528\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112925996199400540)
,p_name=>'APEXIR_ROWS'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112985502637400584)
,p_name=>'APEXIR_ROWS_PER_PAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\3054\3068\306E\884C\6570')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112960840462400565)
,p_name=>'APEXIR_ROW_COLUMNS'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112960650068400565)
,p_name=>'APEXIR_ROW_COLUMN_N'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\5217%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112961261973400566)
,p_name=>'APEXIR_ROW_COLUMN_NOT_NULL'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\5217\304C\6307\5B9A\3055\308C\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112961489636400566)
,p_name=>'APEXIR_ROW_COL_DIFF_FROM_PIVOT_COL'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\5217\30BF\30A4\30D7\306F\30D4\30DC\30C3\30C8\5217\3068\7570\306A\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112940075723400550)
,p_name=>'APEXIR_ROW_FILTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\30D5\30A3\30EB\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112915685580400532)
,p_name=>'APEXIR_ROW_OF'
,p_message_language=>'ja'
,p_message_text=>unistr('%1\884C\4E2D%0\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112919674060400535)
,p_name=>'APEXIR_ROW_TEXT_CONTAINS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\3092\542B\3080\884C\30C6\30AD\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112895239043400517)
,p_name=>'APEXIR_SAVE'
,p_message_language=>'ja'
,p_message_text=>unistr('\4FDD\5B58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112930051064400543)
,p_name=>'APEXIR_SAVED_REPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4FDD\5B58\3055\308C\305F\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112929985433400543)
,p_name=>'APEXIR_SAVED_REPORT_MSG'
,p_message_language=>'ja'
,p_message_text=>unistr('\4FDD\5B58\3055\308C\305F\30EC\30DD\30FC\30C8 = "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112932163877400545)
,p_name=>'APEXIR_SAVE_DEFAULT_CONFIRM'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30EC\30DD\30FC\30C8\8A2D\5B9A\304C\3001\3059\3079\3066\306E\30E6\30FC\30B6\30FC\3067\30C7\30D5\30A9\30EB\30C8\3068\3057\3066\4F7F\7528\3055\308C\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112995169672400591)
,p_name=>'APEXIR_SAVE_DEFAULT_REPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\30FB\30EC\30DD\30FC\30C8\306E\4FDD\5B58')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112919359224400535)
,p_name=>'APEXIR_SAVE_REPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\306E\4FDD\5B58')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113033832332400619)
,p_name=>'APEXIR_SAVE_REPORT_DEFAULT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\306E\4FDD\5B58*')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112986551023400585)
,p_name=>'APEXIR_SEARCH'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112924854805400539)
,p_name=>'APEXIR_SEARCH_BAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22\30D0\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113033701163400619)
,p_name=>'APEXIR_SEARCH_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112992093799400589)
,p_name=>'APEXIR_SEARCH_REPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112976077410400577)
,p_name=>'APEXIR_SELECTED_COLUMNS'
,p_message_language=>'ja'
,p_message_text=>unistr('\9078\629E\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112896910669400518)
,p_name=>'APEXIR_SELECT_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('- \5217\306E\9078\629E -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112918680312400534)
,p_name=>'APEXIR_SELECT_COLUMNS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\306E\9078\629E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112900432723400520)
,p_name=>'APEXIR_SELECT_FUNCTION'
,p_message_language=>'ja'
,p_message_text=>unistr('- \30D5\30A1\30F3\30AF\30B7\30E7\30F3\306E\9078\629E -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112925683878400540)
,p_name=>'APEXIR_SELECT_GROUP_BY_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('- \5217\5225\306E\30B0\30EB\30FC\30D7\306E\9078\629E -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112960335155400565)
,p_name=>'APEXIR_SELECT_PIVOT_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('- \30D4\30DC\30C3\30C8\5217\306E\9078\629E -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113011598236400603)
,p_name=>'APEXIR_SELECT_ROW'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\306E\9078\629E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112960407769400565)
,p_name=>'APEXIR_SELECT_ROW_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('- \884C\5217\306E\9078\629E -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112869167429400497)
,p_name=>'APEXIR_SEND'
,p_message_language=>'ja'
,p_message_text=>unistr('\9001\4FE1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112875425617400502)
,p_name=>'APEXIR_SEND_AS_EMAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\3067\9001\4FE1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112895617359400517)
,p_name=>'APEXIR_SEQUENCE'
,p_message_language=>'ja'
,p_message_text=>unistr('\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112918884805400534)
,p_name=>'APEXIR_SORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BD\30FC\30C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112928197052400542)
,p_name=>'APEXIR_SORT_ASCENDING'
,p_message_language=>'ja'
,p_message_text=>unistr('\6607\9806\30BD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112928224654400542)
,p_name=>'APEXIR_SORT_DESCENDING'
,p_message_language=>'ja'
,p_message_text=>unistr('\964D\9806\30BD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113014015178400605)
,p_name=>'APEXIR_SORT_ORDER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BD\30FC\30C8\9806\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112922618581400537)
,p_name=>'APEXIR_SPACE_AS_IN_ONE_EMPTY_STRING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30DA\30FC\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112933768776400546)
,p_name=>'APEXIR_STATUS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30C6\30FC\30BF\30B9%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112984254629400583)
,p_name=>'APEXIR_SUBSCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30D6\30B9\30AF\30EA\30D7\30B7\30E7\30F3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113010932851400602)
,p_name=>'APEXIR_SUBSCRIPTION_ENDING'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D42\4E86')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112865305092400495)
,p_name=>'APEXIR_SUBSCRIPTION_SKIP_IF_NDF'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\304C\898B\3064\304B\3089\306A\3044\5834\5408\306F\30B9\30AD\30C3\30D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113010873845400602)
,p_name=>'APEXIR_SUBSCRIPTION_STARTING_FROM'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\59CB\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113011768536400603)
,p_name=>'APEXIR_SUM_X'
,p_message_language=>'ja'
,p_message_text=>unistr('\5408\8A08%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113001773286400596)
,p_name=>'APEXIR_TABLE_SUMMARY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3 = %0\3001\30EC\30DD\30FC\30C8 = %1\3001\30D3\30E5\30FC = %2\3001\8868\793A\884C\306E\958B\59CB = %3\3001\8868\793A\884C\306E\7D42\4E86 = %4\3001\884C\5408\8A08 = %5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112922352944400537)
,p_name=>'APEXIR_TABLE_SUMMARY_NO_TOTAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3 = %0\3001\30EC\30DD\30FC\30C8 = %1\3001\30D3\30E5\30FC = %2\3001\8868\793A\884C\306E\958B\59CB = %3\3001\8868\793A\884C\306E\7D42\4E86 = %4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112894579848400516)
,p_name=>'APEXIR_TEXT_COLOR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30AD\30B9\30C8\30FB\30AB\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112911602294400529)
,p_name=>'APEXIR_TIME_DAYS'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112911522209400529)
,p_name=>'APEXIR_TIME_HOURS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112911434244400529)
,p_name=>'APEXIR_TIME_MINS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5206')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112911842267400529)
,p_name=>'APEXIR_TIME_MONTHS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6708')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112911760866400529)
,p_name=>'APEXIR_TIME_WEEKS'
,p_message_language=>'ja'
,p_message_text=>unistr('\9031')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112911973773400529)
,p_name=>'APEXIR_TIME_YEARS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5E74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113014486237400605)
,p_name=>'APEXIR_TOGGLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5207\66FF\3048')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112927403109400541)
,p_name=>'APEXIR_TOP'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E00\756A\4E0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113007621704400600)
,p_name=>'APEXIR_UNGROUPED_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30EB\30FC\30D7\5316\3055\308C\3066\3044\306A\3044\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112928943931400542)
,p_name=>'APEXIR_UNIQUE_HIGHLIGHT_NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CF\30A4\30E9\30A4\30C8\540D\306F\4E00\610F\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112899280607400519)
,p_name=>'APEXIR_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30DD\30FC\30C8\3055\308C\3066\3044\306A\3044\30C7\30FC\30BF\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112927540510400541)
,p_name=>'APEXIR_UP'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0A\3078')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112929186014400542)
,p_name=>'APEXIR_VALID_COLOR'
,p_message_language=>'ja'
,p_message_text=>unistr('\6709\52B9\306A\8272\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112929269602400542)
,p_name=>'APEXIR_VALID_FORMAT_MASK'
,p_message_language=>'ja'
,p_message_text=>unistr('\6709\52B9\306A\66F8\5F0F\30DE\30B9\30AF\3092\5165\529B\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112896451113400517)
,p_name=>'APEXIR_VALUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112928063754400541)
,p_name=>'APEXIR_VALUE_AXIS_TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024\306E\8EF8\30BF\30A4\30C8\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112935801503400547)
,p_name=>'APEXIR_VALUE_REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\5FC5\9808\306E\5024')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112899806167400520)
,p_name=>'APEXIR_VCOLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\5782\76F4\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113003595603400597)
,p_name=>'APEXIR_VERTICAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\7E26')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112935136101400547)
,p_name=>'APEXIR_VIEW_CHART'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112990357534400588)
,p_name=>'APEXIR_VIEW_DETAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A73\7D30\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113035907592400620)
,p_name=>'APEXIR_VIEW_DOES_NOT_EXIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\306B\5B9A\7FA9\3055\308C\305F%0\30D3\30E5\30FC\304C\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112990463591400588)
,p_name=>'APEXIR_VIEW_GROUP_BY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B0\30EB\30FC\30D7\5316\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112990273064400587)
,p_name=>'APEXIR_VIEW_ICONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112960195000400565)
,p_name=>'APEXIR_VIEW_PIVOT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D4\30DC\30C3\30C8\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112935273191400547)
,p_name=>'APEXIR_VIEW_REPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112984407220400583)
,p_name=>'APEXIR_WEEKLY'
,p_message_language=>'ja'
,p_message_text=>unistr('\9031')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112918132890400534)
,p_name=>'APEXIR_WORKING_REPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F5C\696D\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113013152353400604)
,p_name=>'APEXIR_X_DAYS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113013025305400604)
,p_name=>'APEXIR_X_HOURS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113012960057400604)
,p_name=>'APEXIR_X_MINS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\5206')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113013334790400604)
,p_name=>'APEXIR_X_MONTHS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\304B\6708')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113013217526400604)
,p_name=>'APEXIR_X_WEEKS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\9031\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113013473521400604)
,p_name=>'APEXIR_X_YEARS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\5E74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113011172965400603)
,p_name=>'APEXIR_YEAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\5E74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112894268467400516)
,p_name=>'APEXIR_YELLOW'
,p_message_language=>'ja'
,p_message_text=>unistr('\9EC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112895739068400517)
,p_name=>'APEXIR_YES'
,p_message_language=>'ja'
,p_message_text=>unistr('\306F\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112927808873400541)
,p_name=>'APEX_GROUP.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306B\3001\7121\52B9\306A\6587\5B57\3067\3042\308B<\307E\305F\306F>\304C\542B\307E\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112950666955400558)
,p_name=>'APEX_REGION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112878825543400504)
,p_name=>'API_PRECONDITION_VIOLATED'
,p_message_language=>'ja'
,p_message_text=>unistr('API\306E\524D\63D0\6761\4EF6\9055\53CD')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112898317256400519)
,p_name=>'APP.SETTING.CANNOT.GET'
,p_message_language=>'ja'
,p_message_text=>unistr('\95A2\9023\4ED8\3051\3089\308C\305F\30D3\30EB\30C9\30FB\30AA\30D7\30B7\30E7\30F3\304C\7121\52B9\306B\306A\3063\3066\3044\308B\3068\304D\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\8A2D\5B9A%0\306E\5024\3092\53D6\5F97\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112898218727400519)
,p_name=>'APP.SETTING.CANNOT.SET'
,p_message_language=>'ja'
,p_message_text=>unistr('\95A2\9023\4ED8\3051\3089\308C\305F\30D3\30EB\30C9\30FB\30AA\30D7\30B7\30E7\30F3\304C\7121\52B9\306B\306A\3063\3066\3044\308B\3068\304D\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\8A2D\5B9A%0\306E\5024\3092\8A2D\5B9A\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113005943177400599)
,p_name=>'APP.SETTING.INVALID.VALUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\8A2D\5B9A%0\306E\5024\304C\7121\52B9\3067\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113005874764400599)
,p_name=>'APP.SETTING.NOT.DEFINED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30AF\30A8\30B9\30C8\3057\305F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\8A2D\5B9A%0\306F\5B9A\7FA9\3055\308C\3066\3044\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113006036472400599)
,p_name=>'APP.SETTING.VALUE.NOT.NULL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\8A2D\5B9A%0\306Fnull\5024\306B\8A2D\5B9A\3067\304D\307E\305B\3093')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112886943348400510)
,p_name=>'BACK'
,p_message_language=>'ja'
,p_message_text=>unistr('\623B\308B')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112873993892400501)
,p_name=>'BUILDER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D3\30EB\30C0\30FC')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112938095246400549)
,p_name=>'BUTTON LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3\30FB\30E9\30D9\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112873059588400500)
,p_name=>'BUTTON_CSS_CLASSES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DC\30BF\30F3\306ECSS\30AF\30E9\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112902276419400522)
,p_name=>'BUTTON_ID'
,p_message_language=>'ja'
,p_message_text=>unistr('\751F\6210\3055\308C\305F\30DC\30BF\30F3\306EID\306F\3001\5B9A\7FA9\3055\308C\3066\3044\308B\5834\5408\306F\30DC\30BF\30F3\306E\9759\7684ID\3001\305D\3046\3067\306A\3051\308C\3070''B'' || [\5185\90E8\30DC\30BF\30F3ID]\306E\5F62\5F0F\306E\5185\90E8\751F\6210\3055\308C\305FID\3067\3059\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112865778733400495)
,p_name=>'CANDLESTICK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30FC\30BD\30AF\8DB3')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112947227764400556)
,p_name=>'CENTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E2D\592E')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112897231122400518)
,p_name=>'CHANGE_PW_REQUEST'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306E\30EA\30AF\30A8\30B9\30C8')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112888684398400512)
,p_name=>'CHECK$'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\30BB\30EC\30AF\30BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113007744986400600)
,p_name=>'CHECKED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30A7\30C3\30AF\6E08')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112983221035400582)
,p_name=>'COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112943798107400553)
,p_name=>'COMMENTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30E1\30F3\30C8')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112925212923400539)
,p_name=>'CONTINUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D9A\884C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112887208263400511)
,p_name=>'COPYRIGHT'
,p_message_language=>'ja'
,p_message_text=>'Copyright &copy; %0, All rights reserved.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112930949668400544)
,p_name=>'COUNT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30A6\30F3\30C8')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112937643038400549)
,p_name=>'CREATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112989985497400587)
,p_name=>'CREATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F5C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112990068233400587)
,p_name=>'CREATED_BY'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F5C\6210\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112914860504400531)
,p_name=>'CREATED_ON'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F5C\6210\65E5')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112925457422400540)
,p_name=>'CUSTOM'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30B9\30BF\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112936601973400548)
,p_name=>'CUSTOMIZE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30B9\30BF\30DE\30A4\30BA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112938295944400549)
,p_name=>'CUSTOMIZE.USER_PAGE_PREFS_RESET'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30D7\30EA\30D5\30A1\30EC\30F3\30B9\304C\30E6\30FC\30B6\30FC%0\7528\306B\30EA\30BB\30C3\30C8\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112938340262400549)
,p_name=>'CUSTOMIZE.USER_PREFS_CHANGED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30EA\30D5\30A1\30EC\30F3\30B9\304C\30E6\30FC\30B6\30FC%0\7528\306B\5909\66F4\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112938128237400549)
,p_name=>'CUSTOMIZE.USER_PREFS_RESET'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30D7\30EA\30D5\30A1\30EC\30F3\30B9\304C\30E6\30FC\30B6\30FC%0\7528\306B\30EA\30BB\30C3\30C8\3055\308C\307E\3057\305F\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112901964420400521)
,p_name=>'DAILY'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112873552904400501)
,p_name=>'DATA.LOAD.INVALID_FILE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30C3\30D7\30ED\30FC\30C9\3055\308C\305F\30D5\30A1\30A4\30EB\306F\7121\52B9\3067\3042\308B\304B\3001\62E1\5F35\5B50\304C\9593\9055\3063\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112897431945400518)
,p_name=>'DATA.LOAD.INVALID_SELECTOR'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9\306AXML\307E\305F\306FJSON\30BB\30EC\30AF\30BF\304C\4F7F\7528\3055\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112866782633400496)
,p_name=>'DATA.LOAD.NO_COMMON_COLUMNS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30D7\30ED\30D5\30A1\30A4\30EB\3068\30A2\30C3\30D7\30ED\30FC\30C9\3055\308C\305F\30D5\30A1\30A4\30EB\306B\306F\3001\30BF\30FC\30B2\30C3\30C8\8868\306E\5217\304C\542B\307E\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112952462914400559)
,p_name=>'DATA.LOAD.NO_FILE_CONTENTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30C3\30D7\30ED\30FC\30C9\3055\308C\305F\30D5\30A1\30A4\30EB\306B\30C7\30FC\30BF\304C\898B\3064\304B\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112952581057400559)
,p_name=>'DATA.LOAD.NO_WORKSHEET_CONTENTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\304C\30EF\30FC\30AF\30B7\30FC\30C8"%0"\306B\898B\3064\304B\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112872360724400500)
,p_name=>'DATA.LOAD.NO_XLSX_FILE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6307\5B9A\3055\308C\305F\30D5\30A1\30A4\30EB\306F\3001XLSX\30D5\30A1\30A4\30EB\3067\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112862705747400493)
,p_name=>'DATA.LOAD.ROWS_PROCESSED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30ED\30FC\30C9\7D42\4E86: %0\884C\304C\51E6\7406\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112863905998400494)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROW'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30ED\30FC\30C9\7D42\4E86: %0\884C\304C1\30A8\30E9\30FC\3067\51E6\7406\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112864245807400494)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30ED\30FC\30C9\7D42\4E86: %0\884C\304C%1\30A8\30E9\30FC\3067\51E6\7406\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112864034232400494)
,p_name=>'DATA.LOAD.ROW_PROCESSED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30ED\30FC\30C9\7D42\4E86: 1\884C\304C\51E6\7406\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112867026746400496)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROW'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30ED\30FC\30C9\7D42\4E86: 1\884C\304C\30A8\30E9\30FC\3067\51E6\7406\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112864190870400494)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30ED\30FC\30C9\7D42\4E86: 1\884C\304C\30A8\30E9\30FC\306A\3057\3067\51E6\7406\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112957743345400563)
,p_name=>'DATA_LOAD.COLUMN_NAMES_MAPPING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30FC\30B2\30C3\30C8\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112957877496400563)
,p_name=>'DATA_LOAD.FIRST_COLUMN_NAMES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BD\30FC\30B9\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112958685537400564)
,p_name=>'DATA_LOAD.FORMAT'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5\4ED8/\6570\5024\66F8\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113022093792400610)
,p_name=>'DATA_LOAD.LOOKUP_FAILED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EB\30C3\30AF\30A2\30C3\30D7\5024\306E\53D6\5F97\306B\5931\6557\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112990543455400588)
,p_name=>'DATA_LOAD.MAPPING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\3068\8868\306E\30DE\30C3\30D4\30F3\30B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112958700236400564)
,p_name=>'DATA_LOAD.ROW'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112954257153400561)
,p_name=>'DATA_LOAD.TRANSFORMATION_FAILED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C8\30E9\30F3\30B9\30D5\30A9\30FC\30E1\30FC\30B7\30E7\30F3\30FB\30EB\30FC\30EB\306B\5931\6557\3057\307E\3057\305F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112930529408400543)
,p_name=>'DATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5\4ED8')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112904624337400523)
,p_name=>'DAY'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112904784890400524)
,p_name=>'DAYS'
,p_message_language=>'ja'
,p_message_text=>unistr('\65E5')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112943468401400553)
,p_name=>'DEBUGGING_OFF'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3067\306F\3001\30C9\30E9\30C3\30B0\306F\4F7F\7528\3067\304D\307E\305B\3093\3002')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112992223680400589)
,p_name=>'DEFAULT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112905448007400524)
,p_name=>'DELETE'
,p_message_language=>'ja'
,p_message_text=>unistr('\524A\9664')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112865645012400495)
,p_name=>'DIAL_PCT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C0\30A4\30E4\30EB(%)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112880114784400505)
,p_name=>'DOWNLOAD'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C0\30A6\30F3\30ED\30FC\30C9')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112991394757400588)
,p_name=>'DUP_USER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8\5185\306E\30E6\30FC\30B6\30FC\540D\304C\91CD\8907\3057\3066\3044\307E\3059\3002')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112887766195400511)
,p_name=>'EDIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7DE8\96C6')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112897181234400518)
,p_name=>'EMAIL_NOT_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9"%0"\304C\898B\3064\304B\308A\307E\305B\3093\3067\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112882286983400507)
,p_name=>'EMAIL_SENT_BY'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\96FB\5B50\30E1\30FC\30EB\306F%0\306B\3088\3063\3066\9001\4FE1\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112991538880400588)
,p_name=>'EMAIL_TOO_LONG'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9\304C\9577\3059\304E\307E\3059\3002\5236\9650\306F240\6587\5B57\3067\3059\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112925186891400539)
,p_name=>'ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112954351160400561)
,p_name=>'ERROR_SET_ITEM_STATE_FOR_PPR_REGION'
,p_message_language=>'ja'
,p_message_text=>unistr('\90E8\5206\30DA\30FC\30B8\30FB\30EA\30D5\30EC\30C3\30B7\30E5\30FB\30EA\30FC\30B8\30E7\30F3\306B\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\30FB\30BD\30FC\30B9\5024\3092\8A2D\5B9A\3067\304D\307E\305B\3093')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112916657222400533)
,p_name=>'F4500_P10_CREATED_BY'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F5C\6210\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112882583623400507)
,p_name=>'F4500_P2613_EXPIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30B9\30EF\30FC\30C9\306E\6709\52B9\671F\9650\5207\308C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112876615724400503)
,p_name=>'FILE_EMPTY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\304C\7A7A\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112956838949400563)
,p_name=>'FILE_TOO_LARGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30C3\30D7\30ED\30FC\30C9\3057\305F\30D5\30A1\30A4\30EB\306E\30B5\30A4\30BA\304C%0MB\3092\8D85\3048\3066\3044\307E\3059\3002\3088\308A\5C0F\3055\3044\30D5\30A1\30A4\30EB\3092\30A2\30C3\30D7\30ED\30FC\30C9\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112884694084400509)
,p_name=>'FILE_UPLOAD_AUTHENTICATION_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\8A8D\8A3C\304C\5931\6557\3057\30011\3064\4EE5\4E0A\306E\30D5\30A1\30A4\30EB\304C\30A2\30C3\30D7\30ED\30FC\30C9\3055\308C\307E\305B\3093\3067\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112884756530400509)
,p_name=>'FILE_UPLOAD_PUBLICUSER_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A4\30F3\30B9\30BF\30F3\30B9\3067\306F\3001\8A8D\8A3C\3055\308C\3066\3044\306A\3044\30E6\30FC\30B6\30FC\306B\30D5\30A1\30A4\30EB\306E\30A2\30C3\30D7\30ED\30FC\30C9\306F\8A31\53EF\3055\308C\307E\305B\3093\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112937791127400549)
,p_name=>'FLOW.SINGLE_VALIDATION_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('1\3064\306E\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112936924487400548)
,p_name=>'FLOW.VALIDATION_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112887134176400510)
,p_name=>'FORM_OF'
,p_message_language=>'ja'
,p_message_text=>'%0/%1'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112921837334400537)
,p_name=>'GO'
,p_message_language=>'ja'
,p_message_text=>unistr('\5B9F\884C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113021624064400610)
,p_name=>'HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D8\30EB\30D7')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112874008369400501)
,p_name=>'HOME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DB\30FC\30E0')
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112904495150400523)
,p_name=>'HOUR'
,p_message_language=>'ja'
,p_message_text=>unistr('\6642\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112904554283400523)
,p_name=>'HOURS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6642\9593')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112888536282400512)
,p_name=>'ICON'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30B3\30F3%0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112938548685400549)
,p_name=>'INVALID_CREDENTIALS'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9\306A\30ED\30B0\30A4\30F3\8CC7\683C\8A3C\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113038030925400622)
,p_name=>'INVALID_VALUE_FOR_PARAMETER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30E9\30E1\30FC\30BF\306E\5024\304C\7121\52B9\3067\3059: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112933250548400545)
,p_name=>'IR_AS_DEFAULT_REPORT_SETTING'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8\306E\30EC\30DD\30FC\30C8\8A2D\5B9A\3068\3057\3066\4FDD\5B58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112933381462400545)
,p_name=>'IR_AS_NAMED_REPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\540D\524D\4ED8\304D\30EC\30DD\30FC\30C8\3068\3057\3066\4FDD\5B58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112915727813400532)
,p_name=>'IR_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\30A8\30E9\30FC\3002%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112915456447400532)
,p_name=>'IR_FRM_NAV_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A9\30FC\30E0\30FB\30CA\30D3\30B2\30FC\30B7\30E7\30F3\3092\8A08\7B97\3067\304D\307E\305B\3093\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112893035659400515)
,p_name=>'IR_NOT_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\304C\898B\3064\304B\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112892415045400514)
,p_name=>'IR_REGION_NOT_EXIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3%0\3001\30DA\30FC\30B8%1\3001\30EA\30FC\30B8\30E7\30F3%2\306B\306F\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\306E\30EA\30FC\30B8\30E7\30F3\304C\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112933172538400545)
,p_name=>'IR_STAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\767A\8005\306B\306E\307F\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112921512571400537)
,p_name=>'IR_UNIQUE_KEY_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\554F\5408\305B\306B\306F\5404\884C\3092\8B58\5225\3059\308B\4E00\610F\30AD\30FC\304C\5FC5\8981\3067\3059\3002\6307\5B9A\3055\308C\305F\30AD\30FC\306F\3001\3053\306E\554F\5408\305B\306B\4F7F\7528\3067\304D\307E\305B\3093\3002\4E00\610F\30AD\30FC\306E\5217\3092\5B9A\7FA9\3057\3066\304F\3060\3055\3044\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112921644682400537)
,p_name=>'IR_UNIQUE_KEY_ERROR2'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\554F\5408\305B\306B\306F\5404\884C\3092\8B58\5225\3059\308B\4E00\610F\30AD\30FC\304C\5FC5\8981\3067\3059\3002\6307\5B9A\3055\308C\305F\30AD\30FC\306F\3001\3053\306E\554F\5408\305B\306B\4F7F\7528\3067\304D\307E\305B\3093\3002\30EC\30DD\30FC\30C8\5C5E\6027\3092\7DE8\96C6\3057\3066\3001\4E00\610F\30AD\30FC\306E\5217\3092\5B9A\7FA9\3057\3066\304F\3060\3055\3044\3002%0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112958917183400564)
,p_name=>'ITEM.FILE_UPLOAD.CHOOSE_FILE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\306E\9078\629E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112958873255400564)
,p_name=>'ITEM.FILE_UPLOAD.DRAG_DROP_FILE_HERE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D5\30A1\30A4\30EB\3092\3053\3053\306B\30C9\30E9\30C3\30B0\30FB\30A2\30F3\30C9\30FB\30C9\30ED\30C3\30D7\3001\307E\305F\306F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112887423680400511)
,p_name=>'ITEMS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112916829651400533)
,p_name=>'ITEM_VALUE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\5024')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112931214072400544)
,p_name=>'LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E9\30D9\30EB')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112943374609400553)
,p_name=>'LANGUAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A00\8A9E')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112905159794400524)
,p_name=>'LAST'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5F8C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112884573051400509)
,p_name=>'LENGTH'
,p_message_language=>'ja'
,p_message_text=>unistr('\9577\3055')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112937842934400549)
,p_name=>'LOGIN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30ED\30B0\30A4\30F3')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112976469928400577)
,p_name=>'MANAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\7BA1\7406')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113041038490400624)
,p_name=>'MAXIMIZE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5927\5316')
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112904264322400523)
,p_name=>'MINUTE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5206')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112904337331400523)
,p_name=>'MINUTES'
,p_message_language=>'ja'
,p_message_text=>unistr('\5206')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112991730909400589)
,p_name=>'MISSING_AT'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9\306B"@"\304C\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112991993264400589)
,p_name=>'MISSING_DIALOG_PAGE_TEMPLATE_WARNING'
,p_message_language=>'ja'
,p_message_text=>unistr('\8B66\544A: \30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3%1\306E\30C0\30A4\30A2\30ED\30B0\30FB\30DA\30FC\30B8%0\306B\30C0\30A4\30A2\30ED\30B0\30FB\30DA\30FC\30B8\30FB\30C6\30F3\30D7\30EC\30FC\30C8\304C\5B9A\7FA9\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112991620616400588)
,p_name=>'MISSING_DOT'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\30FB\30A2\30C9\30EC\30B9\306E\30C9\30E1\30A4\30F3\306B"."\304C\3042\308A\307E\305B\3093\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112940843523400551)
,p_name=>'MODULE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E2\30B8\30E5\30FC\30EB')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112897968346400519)
,p_name=>'MONTH'
,p_message_language=>'ja'
,p_message_text=>unistr('\6708')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112901799476400521)
,p_name=>'MONTHLY'
,p_message_language=>'ja'
,p_message_text=>unistr('\6708')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112898076984400519)
,p_name=>'MONTHS'
,p_message_language=>'ja'
,p_message_text=>unistr('\6708')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112930816297400544)
,p_name=>'MOVE'
,p_message_language=>'ja'
,p_message_text=>unistr('\79FB\52D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112998383371400593)
,p_name=>'MOVE_FROM'
,p_message_language=>'ja'
,p_message_text=>unistr('\79FB\52D5\5143')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112998436954400593)
,p_name=>'MOVE_TO'
,p_message_language=>'ja'
,p_message_text=>unistr('\79FB\52D5\5148')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112918073831400534)
,p_name=>'MRU.ERROR_IN_MRD'
,p_message_language=>'ja'
,p_message_text=>unistr('\8907\6570\884C\306E\524A\9664\64CD\4F5C\3067\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F: \884C= %0\3001%1\3001%2')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112917007192400533)
,p_name=>'MUST_NOT_BE_PUBLIC_USER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30D6\30EA\30C3\30AF\30FB\30E6\30FC\30B6\30FC\306F\4E0D\53EF')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112874273110400501)
,p_name=>'NAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\540D\524D')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112931052946400544)
,p_name=>'NEW'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112897768462400518)
,p_name=>'NEW_ACCOUNT_LOGIN_INSTRUCTIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306B\30ED\30B0\30A4\30F3\3059\308B\306B\306F\3001\6B21\306B\79FB\52D5\3057\307E\3059:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112897826542400518)
,p_name=>'NEW_ACCOUNT_NOTIFICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F%0\30A2\30AB\30A6\30F3\30C8\306E\901A\77E5')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113021804397400610)
,p_name=>'NEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112940786169400551)
,p_name=>'NO'
,p_message_language=>'ja'
,p_message_text=>unistr('\3044\3044\3048')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113036057107400621)
,p_name=>'NOBODY'
,p_message_language=>'ja'
,p_message_text=>unistr('\306A\3057')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112905522208400524)
,p_name=>'NOT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\3067\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112946380529400555)
,p_name=>'NOT_NULL'
,p_message_language=>'ja'
,p_message_text=>unistr('null\3067\306A\3044')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112917172806400533)
,p_name=>'NOT_W_ARGUMENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\975E%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112936741364400548)
,p_name=>'NO_DATA_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\304C\898B\3064\304B\308A\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112945813246400555)
,p_name=>'NO_UPDATEABLE_REPORT_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F4\65B0\53EF\80FD\306A\30EC\30DD\30FC\30C8\304C\898B\3064\304B\308A\307E\305B\3093\3002 \8907\6570\884C\306E\66F4\65B0\304A\3088\3073\524A\9664\64CD\4F5C\306F\3001\300C\66F4\65B0\53EF\80FD\306A\30EC\30DD\30FC\30C8\300D\30BF\30A4\30D7\306E\8868\5F62\5F0F\30D5\30A9\30FC\30E0\3067\306E\307F\5B9F\884C\3067\304D\307E\3059\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112946791528400555)
,p_name=>'OK'
,p_message_language=>'ja'
,p_message_text=>'OK'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112942445468400552)
,p_name=>'ORACLE_APPLICATION_EXPRESS'
,p_message_language=>'ja'
,p_message_text=>'Oracle Application Express'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113039852939400623)
,p_name=>'ORA_06550'
,p_message_language=>'ja'
,p_message_text=>unistr('ORA-06550: \884C%0\3001\5217%1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112989333697400587)
,p_name=>'OUTDATED_BROWSER'
,p_message_language=>'ja'
,p_message_text=>unistr('\53E4\3044Web\30D6\30E9\30A6\30B6\3092\4F7F\7528\3057\3066\3044\307E\3059\3002\30B5\30DD\30FC\30C8\3055\308C\3066\3044\308B\30D6\30E9\30A6\30B6\306E\30EA\30B9\30C8\306F\3001\300EOracle Application Express\30A4\30F3\30B9\30C8\30EC\30FC\30B7\30E7\30F3\30FB\30AC\30A4\30C9\300F\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112890725357400513)
,p_name=>'OUT_OF_RANGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30AF\30A8\30B9\30C8\3055\308C\305F\4E00\9023\306E\884C\306F\7121\52B9\3067\3059\3002\30EC\30DD\30FC\30C8\306E\30BD\30FC\30B9\30FB\30C7\30FC\30BF\304C\5909\66F4\3055\308C\3066\3044\307E\3059\3002')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112910801349400528)
,p_name=>'P.VALID_PAGE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\6709\52B9\306A\30DA\30FC\30B8\756A\53F7(p?n=1234\306A\3069)\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112914440705400531)
,p_name=>'PAGINATION.NEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112914595660400531)
,p_name=>'PAGINATION.NEXT_SET'
,p_message_language=>'ja'
,p_message_text=>unistr('\6B21\306E\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112914688430400531)
,p_name=>'PAGINATION.PREVIOUS'
,p_message_language=>'ja'
,p_message_text=>unistr('\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112914737112400531)
,p_name=>'PAGINATION.PREVIOUS_SET'
,p_message_language=>'ja'
,p_message_text=>unistr('\524D\306E\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113021763941400610)
,p_name=>'PAGINATION.SELECT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\533A\5207\308A\306E\9078\629E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112952381597400559)
,p_name=>'PASSWORD'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30B9\30EF\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112897030767400518)
,p_name=>'PASSWORD_CHANGED'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306E\30D1\30B9\30EF\30FC\30C9\304C\5909\66F4\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112886865480400510)
,p_name=>'PASSWORD_COMPLEXITY_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30B9\30EF\30FC\30C9\304C\3053\306E\30B5\30A4\30C8\306E\30D1\30B9\30EF\30FC\30C9\306E\8907\96D1\6027\30EB\30FC\30EB\306B\6E96\62E0\3057\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112885948042400510)
,p_name=>'PASSWORD_DIFFERS_BY_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\65B0\898F\30D1\30B9\30EF\30FC\30C9\3068\53E4\3044\30D1\30B9\30EF\30FC\30C9\306F%0\6587\5B57\4EE5\4E0A\7570\306A\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112886542855400510)
,p_name=>'PASSWORD_LIKE_USERNAME_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30B9\30EF\30FC\30C9\306B\306F\30E6\30FC\30B6\30FC\540D\3092\4F7F\7528\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112886745742400510)
,p_name=>'PASSWORD_LIKE_WORDS_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\7981\6B62\3055\308C\305F\5358\7D14\306A\5358\8A9E\304C\30D1\30B9\30EF\30FC\30C9\306B\542B\307E\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112886637280400510)
,p_name=>'PASSWORD_LIKE_WORKSPACE_NAME_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30B9\30EF\30FC\30C9\306B\306F\30EF\30FC\30AF\30B9\30DA\30FC\30B9\540D\3092\4F7F\7528\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112885858525400510)
,p_name=>'PASSWORD_MIN_LEN_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30B9\30EF\30FC\30C9\306F%0\6587\5B57\4EE5\4E0A\306B\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112886042361400510)
,p_name=>'PASSWORD_ONE_ALPHA_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30B9\30EF\30FC\30C9\306B\306F\30A2\30EB\30D5\30A1\30D9\30C3\30C8\30921\6587\5B57\4EE5\4E0A\542B\3081\308B\5FC5\8981\304C\3042\308A\307E\3059(%0)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112886495526400510)
,p_name=>'PASSWORD_ONE_LOWER_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30B9\30EF\30FC\30C9\306B\306F\5C0F\6587\5B57\306E\30A2\30EB\30D5\30A1\30D9\30C3\30C8\30921\3064\4EE5\4E0A\542B\3081\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112886144717400510)
,p_name=>'PASSWORD_ONE_NUMERIC_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30B9\30EF\30FC\30C9\306B\306F\6570\5B57(0123456789)\30921\3064\4EE5\4E0A\542B\3081\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112886233159400510)
,p_name=>'PASSWORD_ONE_PUNCTUATION_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30B9\30EF\30FC\30C9\306B\306F\8A18\53F7\30921\3064\4EE5\4E0A\542B\3081\308B\5FC5\8981\304C\3042\308A\307E\3059(%0)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112886308499400510)
,p_name=>'PASSWORD_ONE_UPPER_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30B9\30EF\30FC\30C9\306B\306F\5927\6587\5B57\306E\30A2\30EB\30D5\30A1\30D9\30C3\30C8\30921\3064\4EE5\4E0A\542B\3081\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112897546311400518)
,p_name=>'PASSWORD_RESET_NOTIFICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30B9\30EF\30FC\30C9\30FB\30EA\30BB\30C3\30C8\306E\901A\77E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112884837856400509)
,p_name=>'PASSWORD_REUSE_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30B9\30EF\30FC\30C9\306F\3001\904E\53BB%0\65E5\4EE5\5185\306B\4F7F\7528\3055\308C\3066\3044\308B\306E\3067\4F7F\7528\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112965131450400569)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.PLURAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112965225555400569)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.SINGULAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112942220663400552)
,p_name=>'PERCENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\5272\5408')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112912589659400530)
,p_name=>'PLEASE_CONTACT_ADMINISTRATOR'
,p_message_language=>'ja'
,p_message_text=>unistr('\7BA1\7406\8005\306B\554F\3044\5408\305B\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113021982960400610)
,p_name=>'PREVIOUS'
,p_message_language=>'ja'
,p_message_text=>unistr('\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112957380815400563)
,p_name=>'PRINT'
,p_message_language=>'ja'
,p_message_text=>unistr('\51FA\529B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112941025983400551)
,p_name=>'PRIVILEGES'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A29\9650')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112910930403400528)
,p_name=>'REGIOIN_REFERENCES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\53C2\7167')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112931193085400544)
,p_name=>'REPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112940991309400551)
,p_name=>'REPORTING_PERIOD'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\4F5C\6210\671F\9593')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113022104843400610)
,p_name=>'REPORT_LABEL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112941624240400552)
,p_name=>'REPORT_TOTAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\5408\8A08')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112890869329400513)
,p_name=>'RESET'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\533A\5207\308A\306E\30EA\30BB\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112916732108400533)
,p_name=>'RESET_PAGINATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\533A\5207\308A\306E\30EA\30BB\30C3\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112945732436400555)
,p_name=>'RESET_PASSWORD'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30B9\30EF\30FC\30C9\306E\30EA\30BB\30C3\30C8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112922540300400537)
,p_name=>'RESTORE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8\30A2')
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112954478684400561)
,p_name=>'RESULTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\7D50\679C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112946856948400555)
,p_name=>'RETURN_TO_APPLICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\623B\308B\3002')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112947116467400556)
,p_name=>'RIGHT'
,p_message_language=>'ja'
,p_message_text=>unistr('\53F3')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112976741222400578)
,p_name=>'ROW'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112930787123400544)
,p_name=>'ROW_COUNT'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\30AB\30A6\30F3\30C8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112946220832400555)
,p_name=>'SAVE'
,p_message_language=>'ja'
,p_message_text=>unistr('\4FDD\5B58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112942882261400553)
,p_name=>'SAVED_REPORTS.ALTERNATIVE.DEFAULT'
,p_message_language=>'ja'
,p_message_text=>unistr('\4EE3\66FF\30C7\30D5\30A9\30EB\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112943246443400553)
,p_name=>'SAVED_REPORTS.DESCRIPTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\8AAC\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112942792517400552)
,p_name=>'SAVED_REPORTS.PRIMARY.DEFAULT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30E9\30A4\30DE\30EA\30FB\30C7\30D5\30A9\30EB\30C8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112943529133400553)
,p_name=>'SC_REPORT_ROWS'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\3092\8D85\3048\308B\884C\3092\4F7F\7528\3067\304D\307E\3059\3002\3088\308A\591A\304F\306E\884C\3092\8868\793A\3059\308B\306B\306F\3001\884C\30BB\30EC\30AF\30BF\3092\5897\3084\3057\3066\304F\3060\3055\3044\3002')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113008969679400601)
,p_name=>'SEARCH'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\7D22')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112904150537400523)
,p_name=>'SECONDS'
,p_message_language=>'ja'
,p_message_text=>unistr('\79D2')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112942379370400552)
,p_name=>'SEE_ATTACHED'
,p_message_language=>'ja'
,p_message_text=>unistr('\6DFB\4ED8\3092\53C2\7167')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113000071085400595)
,p_name=>'SELECT_ROW'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\306E\9078\629E')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112942086768400552)
,p_name=>'SET_SCREEN_READER_MODE_OFF'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AF\30EA\30FC\30F3\30FB\30EA\30FC\30C0\30FC\30FB\30E2\30FC\30C9\3092\30AA\30D5\306B\8A2D\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112942106967400552)
,p_name=>'SET_SCREEN_READER_MODE_ON'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B9\30AF\30EA\30FC\30F3\30FB\30EA\30FC\30C0\30FC\30FB\30E2\30FC\30C9\3092\30AA\30F3\306B\8A2D\5B9A')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112938465784400549)
,p_name=>'SHOW'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113001859358400596)
,p_name=>'SHOW_ALL'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\8868\793A')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113027995142400615)
,p_name=>'SIGN_IN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30A4\30F3\30A4\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112977543131400578)
,p_name=>'SIGN_OUT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30A4\30F3\30A2\30A6\30C8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112931790814400544)
,p_name=>'SINCE_DAYS_AGO'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\65E5\524D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112938988045400550)
,p_name=>'SINCE_DAYS_FROM_NOW'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\65E5\5F8C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112931659149400544)
,p_name=>'SINCE_HOURS_AGO'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\6642\9593\524D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112938831191400550)
,p_name=>'SINCE_HOURS_FROM_NOW'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\6642\9593\5F8C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112931515024400544)
,p_name=>'SINCE_MINUTES_AGO'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\5206\524D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112938717386400550)
,p_name=>'SINCE_MINUTES_FROM_NOW'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\5206\5F8C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112931917333400544)
,p_name=>'SINCE_MONTHS_AGO'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\304B\6708\524D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112939181764400550)
,p_name=>'SINCE_MONTHS_FROM_NOW'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\304B\6708\5F8C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112939316946400550)
,p_name=>'SINCE_NOW'
,p_message_language=>'ja'
,p_message_text=>unistr('\5373\6642')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112931470093400544)
,p_name=>'SINCE_SECONDS_AGO'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\79D2\524D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112938607728400549)
,p_name=>'SINCE_SECONDS_FROM_NOW'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\79D2\5F8C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112931800574400544)
,p_name=>'SINCE_WEEKS_AGO'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\9031\524D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112939069067400550)
,p_name=>'SINCE_WEEKS_FROM_NOW'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\9031\9593\5F8C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112932065533400544)
,p_name=>'SINCE_YEARS_AGO'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\5E74\524D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112939249805400550)
,p_name=>'SINCE_YEARS_FROM_NOW'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\5E74\5F8C')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112925547232400540)
,p_name=>'STANDARD'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A19\6E96')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112941954589400552)
,p_name=>'START_DATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\958B\59CB\65E5')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112882453318400507)
,p_name=>'SUBSCRIPTION_CREATED_BY'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\96FB\5B50\30E1\30FC\30EB\306F\3001%0\306B\3088\3063\3066\4F5C\6210\3055\308C\305F\5BFE\8A71\30E2\30FC\30C9\30FB\30EC\30DD\30FC\30C8\306E\30B5\30D6\30B9\30AF\30EA\30D7\30B7\30E7\30F3\304B\3089\9001\4FE1\3055\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113037178611400621)
,p_name=>'SUBSCRIPTION_REFERENCES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30D6\30B9\30AF\30EA\30D7\30B7\30E7\30F3')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112985223700400584)
,p_name=>'TAB'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30D6')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112904089729400523)
,p_name=>'TITLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30BF\30A4\30C8\30EB')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112887082415400510)
,p_name=>'TODAY'
,p_message_language=>'ja'
,p_message_text=>unistr('\4ECA\65E5')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112941513461400552)
,p_name=>'TOTAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\5408\8A08')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112888022718400511)
,p_name=>'TO_MANY_COLUMNS_SELECTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\6700\5927%0\5217\3092\9078\629E\3067\304D\307E\3059\3002')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112866517397400495)
,p_name=>'TREE.COLLAPSE_ALL'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\7E2E\5C0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112866808125400496)
,p_name=>'TREE.COLLAPSE_ALL_BELOW'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0B\3092\3059\3079\3066\7E2E\5C0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112866496431400495)
,p_name=>'TREE.EXPAND_ALL'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\5C55\958B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112866645614400495)
,p_name=>'TREE.EXPAND_ALL_BELOW'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0B\3092\3059\3079\3066\5C55\958B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112866917774400496)
,p_name=>'TREE.REPARENT'
,p_message_language=>'ja'
,p_message_text=>unistr('\89AA\306E\5909\66F4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112959149739400564)
,p_name=>'TREES'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C4\30EA\30FC')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113002610553400596)
,p_name=>'UI.FORM.REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\5FC5\9808')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112926259065400540)
,p_name=>'UNAUTHORIZED'
,p_message_language=>'ja'
,p_message_text=>unistr('\672A\8A8D\53EF')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112973072414400575)
,p_name=>'UNAVAILABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F7F\7528\4E0D\53EF')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112939722522400550)
,p_name=>'UNKNOWN'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0D\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112883399369400508)
,p_name=>'UNKNOWN_AUTHENTICATION_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8B58\3055\308C\3066\3044\306A\3044\8A8D\8A3C\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112885341368400509)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_HTML'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\306E\53D7\4FE1\3092\4ECA\5F8C\5E0C\671B\3057\306A\3044\5834\5408\306B\306F\3001<a href="%0">\300C\30B5\30D6\30B9\30AF\30E9\30A4\30D6\89E3\9664\300D</a>\3092\30AF\30EA\30C3\30AF\3057\3066\30B5\30D6\30B9\30AF\30EA\30D7\30B7\30E7\30F3\3092\7BA1\7406\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112882367048400507)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_TXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\306E\53D7\4FE1\3092\4ECA\5F8C\5E0C\671B\3057\306A\3044\5834\5408\306B\306F\3001\6B21\306EURL\306B\30A2\30AF\30BB\30B9\3057\3066\30B5\30D6\30B9\30AF\30EA\30D7\30B7\30E7\30F3\3092\7BA1\7406\3057\3066\304F\3060\3055\3044\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112917225295400533)
,p_name=>'UNSUPPORTED_DATA_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30DD\30FC\30C8\3055\308C\3066\3044\306A\3044\30C7\30FC\30BF\578B')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112905398827400524)
,p_name=>'UPDATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F4\65B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112903962216400523)
,p_name=>'UPDATED'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F4\65B0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112910621489400528)
,p_name=>'URL_PROHIBITED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30AF\30A8\30B9\30C8\3055\308C\305FURL\306F\4F7F\7528\3067\304D\307E\305B\3093\3002\7BA1\7406\8005\306B\9023\7D61\3057\3066\304F\3060\3055\3044\3002')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112930644729400543)
,p_name=>'USER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112952214277400559)
,p_name=>'USERNAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112991850614400589)
,p_name=>'USERNAME_TOO_LONG'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\540D\304C\9577\3059\304E\307E\3059\3002\5236\9650\306F%0\6587\5B57\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112937475197400549)
,p_name=>'USERS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112991414910400588)
,p_name=>'USER_EXISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\540D\306F\3059\3067\306B\5B58\5728\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113006148430400599)
,p_name=>'USER_PROFILE_IMAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC%0\306E\30D7\30ED\30D5\30A1\30A4\30EB\30FB\30A4\30E1\30FC\30B8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112893757348400515)
,p_name=>'VALID'
,p_message_language=>'ja'
,p_message_text=>unistr('\6709\52B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112887361408400511)
,p_name=>'VALIDATIONS'
,p_message_language=>'ja'
,p_message_text=>unistr('\691C\8A3C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112943096630400553)
,p_name=>'VALUE_MUST_BE_SPECIFIED'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112986449301400585)
,p_name=>'VALUE_MUST_BE_SPECIFIED_FOR'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306E\5024\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112912983811400530)
,p_name=>'VERTICAL'
,p_message_language=>'ja'
,p_message_text=>unistr('\7E26')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112905293133400524)
,p_name=>'VIEW'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112937566870400549)
,p_name=>'VIEWS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D3\30E5\30FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112943828330400553)
,p_name=>'VIEW_ALL'
,p_message_language=>'ja'
,p_message_text=>unistr('\3059\3079\3066\3092\8868\793A')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112925057281400539)
,p_name=>'WARNING'
,p_message_language=>'ja'
,p_message_text=>unistr('\8B66\544A')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112904829158400524)
,p_name=>'WEEK'
,p_message_language=>'ja'
,p_message_text=>unistr('\9031')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112901840272400521)
,p_name=>'WEEKLY'
,p_message_language=>'ja'
,p_message_text=>unistr('\9031')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112904945922400524)
,p_name=>'WEEKS'
,p_message_language=>'ja'
,p_message_text=>unistr('\9031')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112943193322400553)
,p_name=>'WELCOME_USER'
,p_message_language=>'ja'
,p_message_text=>unistr('\3088\3046\3053\305D: %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112941370294400551)
,p_name=>'WWV_DBMS_SQL.INVALID_CLOB'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9\306A\5024\304C\691C\51FA\3055\308C\307E\3057\305F\3002\5165\529B\3055\308C\305F\30C7\30FC\30BF\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112941427082400552)
,p_name=>'WWV_DBMS_SQL.INVALID_DATATYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9\306A\5024\304C\691C\51FA\3055\308C\307E\3057\305F\3002\5165\529B\3055\308C\305F\30C7\30FC\30BF\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112884494295400509)
,p_name=>'WWV_DBMS_SQL.INVALID_DATE'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9\306A\65E5\4ED8\5024\304C\691C\51FA\3055\308C\307E\3057\305F\3002\65E5\4ED8\66F8\5F0F\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112941277541400551)
,p_name=>'WWV_DBMS_SQL.INVALID_NUMBER'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9\306A\6570\5024\304C\691C\51FA\3055\308C\307E\3057\305F\3002\6570\5024\66F8\5F0F\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112893343334400515)
,p_name=>'WWV_DBMS_SQL.INVALID_TIMESTAMP'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9\306A\30BF\30A4\30E0\30B9\30BF\30F3\30D7\5024\304C\691C\51FA\3055\308C\307E\3057\305F\3002\30BF\30A4\30E0\30B9\30BF\30F3\30D7\66F8\5F0F\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112915861708400532)
,p_name=>'WWV_DBMS_SQL.UNABLE_TO_BIND_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\3092\30D0\30A4\30F3\30C9\3067\304D\307E\305B\3093\3002\8907\6570\30D0\30A4\30C8\306E\30A2\30A4\30C6\30E0\306B\4E8C\91CD\5F15\7528\7B26\3092\4F7F\7528\3059\308B\304B\3001\30A2\30A4\30C6\30E0\306E\9577\3055\304C30\30D0\30A4\30C8\4EE5\4E0B\3067\3042\308B\3053\3068\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002v()\69CB\6587\3092\4F7F\7528\3057\3066\300130\30D0\30A4\30C8\3092\8D85\3048\308B\30A2\30A4\30C6\30E0\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112906382594400525)
,p_name=>'WWV_FLOW.ACCESS_DENIED'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\30BB\30AD\30E5\30EA\30C6\30A3\30FB\30C1\30A7\30C3\30AF\306B\3088\3063\3066\62D2\5426\3055\308C\305F\30A2\30AF\30BB\30B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112908832745400527)
,p_name=>'WWV_FLOW.APP_NOT_AVAILABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\4F7F\7528\3067\304D\306A\3044\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112907200002400525)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('ERR-1014 \30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304C\898B\3064\304B\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112907314267400526)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_FOOTER_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3=%0  \30EF\30FC\30AF\30B9\30DA\30FC\30B9=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112907789223400526)
,p_name=>'WWV_FLOW.APP_RESTRICTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3078\306E\30A2\30AF\30BB\30B9\306F\5236\9650\3055\308C\3066\3044\307E\3059\3002\5F8C\3067\3001\3082\3046\4E00\5EA6\30A2\30AF\30BB\30B9\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112907689170400526)
,p_name=>'WWV_FLOW.APP_RESTRICTED_TO_DEV'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\3078\306E\30A2\30AF\30BB\30B9\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\958B\767A\8005\306E\307F\306B\5236\9650\3055\308C\3066\3044\307E\3059\3002\5F8C\3067\3001\3082\3046\4E00\5EA6\30A2\30AF\30BB\30B9\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112906833245400525)
,p_name=>'WWV_FLOW.BRANCH_FUNC_RETURNING_URL_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('ERR-7744 URL\3092\623B\3059\30D5\30A1\30F3\30AF\30B7\30E7\30F3\3078\306E\30D6\30E9\30F3\30C1\3092\51E6\7406\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112906733868400525)
,p_name=>'WWV_FLOW.BRANCH_TO_FUNCT_RET_PAGE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('ERR-7744 \30DA\30FC\30B8\3092\623B\3059\30D5\30A1\30F3\30AF\30B7\30E7\30F3\3078\306E\30D6\30E9\30F3\30C1\3092\51E6\7406\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112907026908400525)
,p_name=>'WWV_FLOW.CALL_TO_SHOW_FROM_PROC_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('ERR-1430 \30DA\30FC\30B8\30FB\30D7\30ED\30BB\30B9\304B\3089\306E\8868\793A\306E\305F\3081\306E\30B3\30FC\30EB\306F\30B5\30DD\30FC\30C8\3055\308C\3066\3044\307E\305B\3093: G_FLOW_STEP_ID(%0)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112908184712400526)
,p_name=>'WWV_FLOW.CLEAR_STEP_CACHE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('ERR-1018 \30B9\30C6\30C3\30D7\30FB\30AD\30E3\30C3\30B7\30E5\306E\30AF\30EA\30A2\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112906511756400525)
,p_name=>'WWV_FLOW.COMP_UNKNOWN_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('ERR-1005 \8A08\7B97\30BF\30A4\30D7\304C\4E0D\660E\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112907415628400526)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('ERR-1201 \30BB\30C3\30B7\30E7\30F3ID\304C\30AB\30B9\30BF\30E0\8A8D\8A3C\306B\5BFE\3057\3066\8A2D\5B9A\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112907556084400526)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_FOOTER_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8=%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112907124489400525)
,p_name=>'WWV_FLOW.DET_COMPANY_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('ERR-7620 \30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3(%0)\306E\30EF\30FC\30AF\30B9\30DA\30FC\30B9\3092\5224\65AD\3067\304D\307E\305B\3093\3067\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112889512798400512)
,p_name=>'WWV_FLOW.EDIT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7DE8\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112906210831400525)
,p_name=>'WWV_FLOW.FIND_ITEM_ERR2'
,p_message_language=>'ja'
,p_message_text=>unistr('ERR-1802 \30A2\30A4\30C6\30E0ID\300C%0\300D\304C\898B\3064\304B\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112905934447400525)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('ERR-1002 \30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\300C%1\300D\5185\306E\30A2\30A4\30C6\30E0\300C%0\300D\306E\30A2\30A4\30C6\30E0ID\304C\898B\3064\304B\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112906010091400525)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR2'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E88\671F\3057\306A\3044\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30EC\30D9\30EB\307E\305F\306F\30DA\30FC\30B8\30FB\30EC\30D9\30EB\3067\30A2\30A4\30C6\30E0\540D\3092\691C\7D22\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112906463071400525)
,p_name=>'WWV_FLOW.FIRST_PAGE_DATA_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\306E\6700\521D\306E\30DA\30FC\30B8\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112921972649400537)
,p_name=>'WWV_FLOW.ITEM_POSTING_VIOLATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0ID(%0)\306F\3001\73FE\5728\306E\30DA\30FC\30B8\3067\5B9A\7FA9\3055\308C\3066\3044\308B\30A2\30A4\30C6\30E0\3067\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112884055199400508)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.INTERNAL_ONLY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306F\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306B\5F15\6570\3092\6E21\3057\3066\3082\8A2D\5B9A\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112884333995400508)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.NO_CHECKSUM'
,p_message_language=>'ja'
,p_message_text=>unistr('(\30C1\30A7\30C3\30AF\30B5\30E0\306F\63D0\4F9B\3055\308C\3066\3044\307E\305B\3093)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112883811332400508)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PRIVATE_BOOKMARK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306F\3001\30E6\30FC\30B6\30FC\30EC\30D9\30EB\30FB\30D6\30C3\30AF\30DE\30FC\30AF\30FB\30C1\30A7\30C3\30AF\30B5\30E0\3092\4F34\3046\5834\5408\306B\8A2D\5B9A\3067\304D\307E\3059\3002 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112883735795400508)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PUBLIC_BOOKMARK'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30EC\30D9\30EB\30FB\30D6\30C3\30AF\30DE\30FC\30AF\30FB\30C1\30A7\30C3\30AF\30B5\30E0\3092\4F34\3046\5834\5408\306B\8A2D\5B9A\3067\304D\307E\3059\3002 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112883949072400508)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.SESSION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306F\3001\30BB\30C3\30B7\30E7\30F3\30FB\30C1\30A7\30C3\30AF\30B5\30E0\3092\4F34\3046\5834\5408\306B\8A2D\5B9A\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112883687313400508)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.UNPROTECTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30A4\30C6\30E0\306B\306F\4FDD\8B77\304C\8A2D\5B9A\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112908243793400526)
,p_name=>'WWV_FLOW.NO_PAGE_HELP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30D8\30EB\30D7\306F\4F7F\7528\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112897306216400518)
,p_name=>'WWV_FLOW.NO_PRIV_ON_SCHEMA'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9%0\306F\3001\30B9\30AD\30FC\30DE%1\3068\3057\3066\89E3\6790\3059\308B\6A29\9650\3092\6240\6709\3057\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112906675790400525)
,p_name=>'WWV_FLOW.PAGE_ACCEPT_RECUR_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('ERR-1010 \30DA\30FC\30B8\3078\306E\30D6\30E9\30F3\30C1\306E\53D7\5165\308C\51E6\7406\306E\518D\5E30\5236\9650\3092\8D85\3048\3066\3044\307E\3059\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112884225850400508)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.SHOW_NO_URL_ALLOWED'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DA\30FC\30B8\306F\3001\8868\793A\30D7\30ED\30B7\30FC\30B8\30E3\306B\5BFE\3059\308BURL\3084\3001GET\307E\305F\306FPOST\3092\4F7F\7528\3057\3066\3082\8D77\52D5\3067\304D\307E\305B\3093\3002\3053\306E\30DA\30FC\30B8\306F\3001\300C\30DA\30FC\30B8\306B\30D6\30E9\30F3\30C1\300D\30D6\30E9\30F3\30C1\30FB\30BF\30A4\30D7\3092\4F7F\7528\3057\3066\30B3\30FC\30EB\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112960977223400566)
,p_name=>'WWV_FLOW.SAVE_ROUTINE_NUMERIC_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\6570\5024\4EE5\5916\306E\5024\3092\30A2\30A4\30C6\30E0%0\306B\4FDD\5B58\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112899039574400519)
,p_name=>'WWV_FLOW.SCHEMA_NOT_EXISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30D9\30FC\30B9\306B\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\89E3\6790\5BFE\8C61\30B9\30AD\30FC\30DE"%0"\304C\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112899183125400519)
,p_name=>'WWV_FLOW.SERVICE_ADMIN_LINK'
,p_message_language=>'ja'
,p_message_text=>unistr('INTERNAL\30EF\30FC\30AF\30B9\30DA\30FC\30B9\5185\306E\30A2\30AB\30A6\30F3\30C8\306F\3001&PRODUCT_NAME.<a href="%0">\7BA1\7406\30B5\30FC\30D3\30B9</a>\306B\30A2\30AF\30BB\30B9\3059\308B\76EE\7684\3067\306E\307F\4F7F\7528\3067\304D\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112905849063400524)
,p_name=>'WWV_FLOW.SESSION_INFO_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('ERR-1029 \30BB\30C3\30B7\30E7\30F3\60C5\5831\3092\683C\7D0D\3067\304D\307E\305B\3093\3002  \30BB\30C3\30B7\30E7\30F3=%0 \30A2\30A4\30C6\30E0=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112908974147400527)
,p_name=>'WWV_FLOW.UNABLE_TO_STOP_TRACE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C8\30EC\30FC\30B9\3092\505C\6B62\3067\304D\307E\305B\3093: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112906153698400525)
,p_name=>'WWV_FLOW.UNEXPECTED_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E88\671F\3057\306A\3044\30A8\30E9\30FC\3067\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112916125777400532)
,p_name=>'WWV_FLOW.UPDATE_SUB_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('update_substitution_cache\3067\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112909083413400527)
,p_name=>'WWV_FLOW.VIEW_HELP_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D8\30EB\30D7\3092\53C2\7167\3059\308B\306B\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\304A\3088\3073\30DA\30FC\30B8\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112929505774400543)
,p_name=>'WWV_FLOW_AUTOMATION.AUTOMATION_NOT_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\81EA\52D5\5316\304C\898B\3064\304B\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112910198735400528)
,p_name=>'WWV_FLOW_CACHE.PURGE_SESSION'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\30BB\30C3\30B7\30E7\30F3\3092\30D1\30FC\30B8\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112869496850400498)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.LANGUAGE_NOT_SUPPORTED'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\30B3\30FC\30C9\3092\5B9F\884C\3067\304D\307E\305B\3093\3002\3053\308C\306F\30C7\30FC\30BF\30D9\30FC\30B9\3067\30B5\30DD\30FC\30C8\3055\308C\3066\3044\306A\3044\304B\3001\30A4\30F3\30B9\30BF\30F3\30B9\30FB\30D1\30E9\30E1\30FC\30BFMLE_LANGUAGES\306B\3088\3063\3066\6709\52B9\306B\306A\3063\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112869231473400497)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.MLE_NOT_SUPPORTED'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30C7\30FC\30BF\30D9\30FC\30B9\30FB\30D0\30FC\30B8\30E7\30F3\3067\306FMultilingual Engine\306F\4F7F\7528\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112890039304400513)
,p_name=>'WWV_FLOW_COLLECTION.ARRAY_NOT_NULL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30B3\30EC\30AF\30B7\30E7\30F3\306E\914D\5217\306FNULL\306B\3067\304D\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112889832504400513)
,p_name=>'WWV_FLOW_COLLECTION.ATTRIBUTE_NUMBER_OUTSIDE_RANGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6307\5B9A\3057\305F\30E1\30F3\30D0\30FC\5C5E\6027\756A\53F7%0\306F\7121\52B9\3067\3059\3002\5C5E\6027\756A\53F7\306F\30011\304B\3089%1\306E\9593\3067\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112890304702400513)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_EXISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30B3\30EC\30AF\30B7\30E7\30F3\304C\5B58\5728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112890181717400513)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_NOT_NULL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30EC\30AF\30B7\30E7\30F3\540D\306FNULL\306B\3067\304D\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112890296317400513)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_TOO_LARGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30EC\30AF\30B7\30E7\30F3\540D\306F255\6587\5B57\3092\8D85\3048\3066\6307\5B9A\3067\304D\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112889662358400512)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NOT_EXIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30B3\30EC\30AF\30B7\30E7\30F3%0\306F\5B58\5728\3057\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112890439001400513)
,p_name=>'WWV_FLOW_COLLECTION.CURSOR_NOT_OPEN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30AB\30FC\30BD\30EB\304C\30AA\30FC\30D7\30F3\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112889777729400512)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_NOT_EXIST'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30E1\30F3\30D0\30FC\30FB\30B7\30FC\30B1\30F3\30B9%0\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30B3\30EC\30AF\30B7\30E7\30F3\300C%1\300D\306B\306F\5B58\5728\3057\307E\305B\3093'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112889987746400513)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_SEQUENCE_NUMBER_INVALID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E1\30F3\30D0\30FC\30FB\30B7\30FC\30B1\30F3\30B9%0\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30B3\30EC\30AF\30B7\30E7\30F3\300C%1\300D\306B\306F\5B58\5728\3057\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112961702749400566)
,p_name=>'WWV_FLOW_CRYPTO.UNSUPPORTED_FUNCTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\6697\53F7\5316\30D5\30A1\30F3\30AF\30B7\30E7\30F3"%0"\306F\3053\306E\30B7\30B9\30C6\30E0\3067\30B5\30DD\30FC\30C8\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113015299471400605)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_ACCESSIBLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30AF\30BB\30B7\30D3\30EA\30C6\30A3\306E\30C6\30B9\30C8\6E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112909648172400527)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CLOSE'
,p_message_language=>'ja'
,p_message_text=>unistr('\9589\3058\308B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112909713772400527)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CUST_OPT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\306E\30AB\30B9\30BF\30DE\30A4\30BA\30FB\30AA\30D7\30B7\30E7\30F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112909884443400527)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DEFAULT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30D5\30A9\30EB\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112909929664400528)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DISP'
,p_message_language=>'ja'
,p_message_text=>unistr('\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112910025450400528)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_HIDDEN'
,p_message_language=>'ja'
,p_message_text=>unistr('\975E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112909403018400527)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE1'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DA\30FC\30B8\306B\542B\3081\308B\30EA\30FC\30B8\30E7\30F3\3092\9078\629E\3057\3066\304F\3060\3055\3044\3002\9078\629E\3057\305F\30EA\30FC\30B8\30E7\30F3\306F\3001\9069\5207\306A\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30B3\30F3\30C6\30AD\30B9\30C8\3067\306A\3044\5834\5408\307E\305F\306F\9069\5207\306A\6A29\9650\304C\306A\3044\5834\5408\3001\8868\793A\3055\308C\306A\3044\3053\3068\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112909566387400527)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE2'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30DA\30FC\30B8\306F\30AB\30B9\30BF\30DE\30A4\30BA\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113015546714400606)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE3'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB\3092\5909\66F4\3057\3066\3053\306E\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\306E\5916\89B3\3092\30D1\30FC\30BD\30CA\30E9\30A4\30BA\3067\304D\307E\3059\3002\6B21\306E\30EA\30B9\30C8\304B\3089\30C6\30FC\30DE\30FB\30B9\30BF\30A4\30EB\3092\9078\629E\3057\3066\3001\300C\5909\66F4\306E\9069\7528\300D\3092\30AF\30EA\30C3\30AF\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113016339765400606)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REGION_DISP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30FC\30B8\30E7\30F3\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113015473364400606)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REMOVE_STYLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30C7\30D5\30A9\30EB\30C8\30FB\30B9\30BF\30A4\30EB\306E\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113015343977400605)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_THEME_STYLE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5916\89B3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112958352257400564)
,p_name=>'WWV_FLOW_DATA_EXPORT.AGG_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\96C6\8A08%0\3067\53C2\7167\3055\308C\308B\5217\7D22\5F15\304C\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112861626427400492)
,p_name=>'WWV_FLOW_DATA_EXPORT.CLOB_NOT_SUPPORTED'
,p_message_language=>'ja'
,p_message_text=>unistr('CLOB\51FA\529B\306F%0\5F62\5F0F\3067\306F\30B5\30DD\30FC\30C8\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112958018270400563)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_BREAK_MUST_BE_IN_THE_BEGGINING'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\914D\5217\306E\5148\982D\306B\5217\30D6\30EC\30FC\30AF\304C\5FC5\8981\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112958190707400563)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_GROUP_IDX_NOT_EXIST'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\3067\53C2\7167\3055\308C\308B\5217\30B0\30EB\30FC\30D7\7D22\5F15\304C\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112875620756400502)
,p_name=>'WWV_FLOW_DATA_EXPORT.EXPORT'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30AF\30B9\30DD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112880865689400506)
,p_name=>'WWV_FLOW_DATA_EXPORT.FORMAT_MUST_BE_XML'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30AF\30B9\30DD\30FC\30C8\5F62\5F0F\306FORDS\3092\30D7\30EA\30F3\30C8\30FB\30B5\30FC\30D0\30FC\3068\3057\3066\4F7F\7528\3059\308BXML\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112958419626400564)
,p_name=>'WWV_FLOW_DATA_EXPORT.HIGHLIGHT_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\30CF\30A4\30E9\30A4\30C8%0\3067\53C2\7167\3055\308C\308B\5217\7D22\5F15\304C\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112874162847400501)
,p_name=>'WWV_FLOW_DATA_EXPORT.INVALID_FORMAT'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9\306A\30A8\30AF\30B9\30DD\30FC\30C8\5F62\5F0F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112958253785400564)
,p_name=>'WWV_FLOW_DATA_EXPORT.PARENT_GROUP_IDX_NOT_EXIST'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\3067\53C2\7167\3055\308C\308B\89AA\30B0\30EB\30FC\30D7\7D22\5F15\304C\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112983440320400582)
,p_name=>'WWV_FLOW_DATA_LOADER.CANNOT_LOAD_INTO_GENERATED_ALWAYS_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\8868\306E%1\5217\306F\3001"GENERATED ALWAYS"\30A2\30A4\30C7\30F3\30C6\30A3\30C6\30A3\5217\3067\3059\3002\300C\69CB\6210\300D\30C0\30A4\30A2\30ED\30B0\3067\30BD\30FC\30B9\5217\304C%1\5217\306B\30DE\30C3\30D7\3055\308C\3066\3044\306A\3044\3053\3068\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112900883204400521)
,p_name=>'WWV_FLOW_DATA_LOADER.COMMIT_INTERVAL_TOO_LOW'
,p_message_language=>'ja'
,p_message_text=>unistr('\6307\5B9A\3055\308C\305F\30B3\30DF\30C3\30C8\9593\9694\304C\5C0F\3055\3059\304E\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112900921914400521)
,p_name=>'WWV_FLOW_DATA_LOADER.NO_COLUMNS_PROVIDED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30ED\30FC\30C9\7528\306E\5217\304C\6307\5B9A\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112902172339400522)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_COLUMNS_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\884C\30BB\30EC\30AF\30BF"%0"\306E\5217\304C\898B\3064\304B\308A\307E\305B\3093\3002\81EA\52D5\691C\51FA\3092\8A66\307F\308B\304B\3001JSON\69CB\9020\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112910448322400528)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_WORKSHEETS_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('XLSX\30D5\30A1\30A4\30EB\306B\30EF\30FC\30AF\30B7\30FC\30C8\304C\898B\3064\304B\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112910324659400528)
,p_name=>'WWV_FLOW_DATA_PARSER.WORKSHEET_DOES_NOT_EXIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\6307\5B9A\3055\308C\305F\30EF\30FC\30AF\30B7\30FC\30C8\304CXLSX\30D5\30A1\30A4\30EB\306B\5B58\5728\3057\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112890588208400513)
,p_name=>'WWV_FLOW_DML.VERSION_OF_DATA_CHANGED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\304C\66F4\65B0\51E6\7406\3092\958B\59CB\3057\3066\304B\3089\3001\30C7\30FC\30BF\30D9\30FC\30B9\5185\306E\73FE\884C\30D0\30FC\30B8\30E7\30F3\306E\30C7\30FC\30BF\304C\5909\66F4\3055\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112892909098400515)
,p_name=>'WWV_FLOW_EDIT_REPORT.ERR_UPDATING_COLS'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\306E\5217\3092\66F4\65B0\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112997619119400593)
,p_name=>'WWV_FLOW_EXEC.CANNOT_CONVERT_TO_SDOGEOMETRY'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\3092SDO_GEOMETRY\306B\5909\63DB\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112937106795400548)
,p_name=>'WWV_FLOW_EXEC.CAN_NOT_CONVERT_TO_VARCHAR2'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217%0\306F\30C7\30FC\30BF\578B\304C%1\3067\3042\308A\3001VARCHAR2\306B\5909\63DB\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112944145326400553)
,p_name=>'WWV_FLOW_EXEC.COLUMN_NOT_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C5E\6027"%1"\306B\6307\5B9A\3055\308C\305F\5217"%0"\304C\3001\30C7\30FC\30BF\30FB\30BD\30FC\30B9\3067\898B\3064\304B\308A\307E\305B\3093\3067\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112885446761400509)
,p_name=>'WWV_FLOW_EXEC.FILTER_NOT_SUPPORTED_WITH_MULTIPLE_VALUES'
,p_message_language=>'ja'
,p_message_text=>unistr('\8907\6570\5024\5217\3067\306F\30D5\30A3\30EB\30BF\30FB\30BF\30A4\30D7%0\306F\30B5\30DD\30FC\30C8\3055\308C\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113001060810400595)
,p_name=>'WWV_FLOW_EXEC.INVALID_BETWEEN_FILTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\300C\304C\6B21\306E\9593\300D\30D5\30A3\30EB\30BF\304C\7121\52B9\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112867558307400496)
,p_name=>'WWV_FLOW_EXEC.INVALID_LOV_SPECIFICATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9\306ALOV\30BF\30A4\30D7\304C\6307\5B9A\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112867430301400496)
,p_name=>'WWV_FLOW_EXEC.INVALID_QUERY_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\554F\5408\305B\30BF\30A4\30D7\304C\7121\52B9\3067\3059\3002\554F\5408\305B\30BF\30A4\30D7\306F\3001\8868\3001SQL\554F\5408\305B\3001\307E\305F\306FSQL\554F\5408\305B\3092\623B\3059PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\3067\3042\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112937268791400548)
,p_name=>'WWV_FLOW_EXEC.INVALID_SQL_QUERY'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\554F\5408\305B\306E\89E3\6790\306B\5931\6557\3057\307E\3057\305F\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112944277877400554)
,p_name=>'WWV_FLOW_EXEC.LEGACY_COLUMN_NOT_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C5E\6027"%1"\306B\6307\5B9A\3055\308C\305F\5217\4F4D\7F6E%0\304C\3001SQL\6587\3067\898B\3064\304B\308A\307E\305B\3093\3067\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112866054751400495)
,p_name=>'WWV_FLOW_EXEC.MULTI_VALUE_TOO_MANY_ITEMS'
,p_message_language=>'ja'
,p_message_text=>unistr('\8907\6570\5024\30D5\30A3\30EB\30BF\3067\4F7F\7528\3055\308C\3066\3044\308B\30A2\30A4\30C6\30E0\304C\591A\3059\304E\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112944001133400553)
,p_name=>'WWV_FLOW_EXEC.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C5E\6027"%0"\306B\5217\304C\6307\5B9A\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112867340890400496)
,p_name=>'WWV_FLOW_EXEC.NULL_QUERY_RETURNED_BY_FUNCTION'
,p_message_language=>'ja'
,p_message_text=>unistr('PL/SQL\30D5\30A1\30F3\30AF\30B7\30E7\30F3\672C\4F53\304C\5024\3092\623B\3057\307E\305B\3093\3067\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112957266401400563)
,p_name=>'WWV_FLOW_EXEC.OPERATION_NOT_PRESENT_IN_WEB_SRC_MODULE'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\30C7\30FC\30BF\30FB\30BD\30FC\30B9\306B\3001\30EA\30AF\30A8\30B9\30C8\3055\308C\305FDML\30A2\30AF\30B7\30E7\30F3\3092\51E6\7406\3059\308B\305F\3081\306E\64CD\4F5C\304C\542B\307E\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112863200401400493)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_JSON_NOT_AVAILABLE'
,p_message_language=>'ja'
,p_message_text=>unistr('GeoJSON\304B\3089SDO_GEOMETRY\3078\306E\5909\63DB(\5217%0)\306F\3001\3053\306E\30C7\30FC\30BF\30D9\30FC\30B9\3067\4F7F\7528\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112864317142400494)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_NOT_SUPPORTED_FOR_XML'
,p_message_language=>'ja'
,p_message_text=>unistr('SDO_GEOMETRY\5909\63DB(\5217%0)\306F\3001XML\30C7\30FC\30BF\30FB\30BD\30FC\30B9\3067\306F\30B5\30DD\30FC\30C8\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112871655288400499)
,p_name=>'WWV_FLOW_EXEC.UNSUPPPORTED_MULTI_VALUE_SEPARATOR'
,p_message_language=>'ja'
,p_message_text=>unistr('\6587\5B57%0\306F\3001\8907\6570\5024\30BB\30D1\30EC\30FC\30BF\3068\3057\3066\30B5\30DD\30FC\30C8\3055\308C\3066\3044\307E\305B\3093\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112998990195400594)
,p_name=>'WWV_FLOW_EXEC.WRONG_CONTEXT_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\6A5F\80FD\306F\3001\554F\5408\305B\30B3\30F3\30C6\30AD\30B9\30C8\3067\306F\4F7F\7528\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112864476116400494)
,p_name=>'WWV_FLOW_EXEC_API.INVALID_DATA_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\306E\30C7\30FC\30BF\578B\306E\4E0D\4E00\81F4\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112867230319400496)
,p_name=>'WWV_FLOW_EXEC_REMOTE.ORDS_OUT_BIND_LIMIT_EXCEEDED'
,p_message_language=>'ja'
,p_message_text=>unistr('\5185\90E8ORDS OUT\30D0\30A4\30F3\30C9\5236\9650\3092\8D85\3048\307E\3057\305F\3002DML\884C\306E\7DCF\6570\3092\6E1B\3089\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112945009295400554)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RESPONSE_PARSING_ERROR'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30EA\30E2\30FC\30C8\30FB\30B5\30FC\30D0\30FC\304B\3089\306EJSON\30EC\30B9\30DD\30F3\30B9\3092\89E3\6790\3067\304D\307E\305B\3093\3067\3057\305F: '),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112867100041400496)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RUN_PLSQL_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B3\30F3\30C6\30AD\30B9\30C8\30FB\30BF\30A4\30D7\304C\4E0D\660E\307E\305F\306F\7121\52B9\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112961691114400566)
,p_name=>'WWV_FLOW_FILE_PARSER.UNKNOWN_FILE_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30D5\30A1\30A4\30EB\30FB\30BF\30A4\30D7\306F\30D1\30FC\30B5\30FC\3067\30B5\30DD\30FC\30C8\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112916232864400532)
,p_name=>'WWV_FLOW_FND_DEVELOPER_API.CREDENTIALS_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0D\5F53\306A\30A2\30AF\30BB\30B9\3067\3059(wwv_flow_api.set_credentials\304C\8A2D\5B9A\3055\308C\3066\3044\307E\305B\3093)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112893286474400515)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_COMPANY'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\306F\3001\3059\3067\306B\5B58\5728\3059\308B\305F\3081\4F5C\6210\3055\308C\307E\305B\3093\3067\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112893152301400515)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_USER_GROUP'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\30FB\30B0\30EB\30FC\30D7\306F\3001\3059\3067\306B\5B58\5728\3059\308B\305F\3081\4F5C\6210\3055\308C\307E\305B\3093\3067\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112903481639400523)
,p_name=>'WWV_FLOW_FND_USER_API.DUP_USER'
,p_message_language=>'ja'
,p_message_text=>unistr('\91CD\8907\3059\308B\30E6\30FC\30B6\30FC\540D\304C%0\306B\5BFE\3057\3066\898B\3064\304B\308A\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112903578778400523)
,p_name=>'WWV_FLOW_FND_USER_API.LOAD_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\306E\30ED\30FC\30C9\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002\30E6\30FC\30B6\30FC%0\306B\5BFE\3057\3066\6B63\5E38\306B\5B9F\884C\3055\308C\307E\305B\3093\3067\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112913454382400530)
,p_name=>'WWV_FLOW_FND_USER_API.T_MESSAGE'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\30E6\30FC\30B6\30FC\3092\30ED\30FC\30C9\3057\305F\53EF\80FD\6027\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112913205983400530)
,p_name=>'WWV_FLOW_FND_USER_API.T_PASSWORD'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30B9\30EF\30FC\30C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112913338376400530)
,p_name=>'WWV_FLOW_FND_USER_API.T_PRIVILEGE'
,p_message_language=>'ja'
,p_message_text=>unistr('\6A29\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112913034825400530)
,p_name=>'WWV_FLOW_FND_USER_API.T_USERNAME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E6\30FC\30B6\30FC\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112989515280400587)
,p_name=>'WWV_FLOW_FORM.UNHANDLED_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0#COMPONENT_NAME#\306E\30EC\30F3\30C0\30EA\30F3\30B0\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112909144088400527)
,p_name=>'WWV_FLOW_FORMS.FORM_NOT_OPEN_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('HTML\30D5\30A9\30FC\30E0\304C\307E\3060\958B\304B\308C\3066\3044\306A\3044\305F\3081\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0\3092\8868\793A\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112874455716400501)
,p_name=>'WWV_FLOW_FORMS.ITEM_DEFAULT_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0#COMPONENT_NAME#\306E\30C7\30D5\30A9\30EB\30C8\5024\3092\8A08\7B97\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112908424015400526)
,p_name=>'WWV_FLOW_FORMS.ITEM_POST_CALC_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0#COMPONENT_NAME#\306E\8A08\7B97\5F8C\306E\30A2\30A4\30C6\30E0\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112908352588400526)
,p_name=>'WWV_FLOW_FORMS.ITEM_SOURCE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\30FB\30A2\30A4\30C6\30E0#COMPONENT_NAME#\306E\30BD\30FC\30B9\5024\3092\8A08\7B97\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112888155174400511)
,p_name=>'WWV_FLOW_HELP.UNAUTHORIZED'
,p_message_language=>'ja'
,p_message_text=>unistr('\4E0D\5F53\306A\30A2\30AF\30BB\30B9\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112908696025400527)
,p_name=>'WWV_FLOW_ITEM.JS_NOT_SUPPORTED'
,p_message_language=>'ja'
,p_message_text=>unistr('JavaScript\304C\30B5\30DD\30FC\30C8\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112908776761400527)
,p_name=>'WWV_FLOW_ITEM.LIST'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30B9\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112909310317400527)
,p_name=>'WWV_FLOW_ITEM.UNABLE_INIT_QUERY'
,p_message_language=>'ja'
,p_message_text=>unistr('\554F\5408\305B\3092\521D\671F\5316\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112916592389400533)
,p_name=>'WWV_FLOW_ITEM.UPDATE_NOT_SUPPORTED_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306E\66F4\65B0\306F\30B5\30DD\30FC\30C8\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112910713063400528)
,p_name=>'WWV_FLOW_ITEM_HELP.INVALID_ITEM_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\7121\52B9\306A\30A2\30A4\30C6\30E0ID: %0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112937053366400548)
,p_name=>'WWV_FLOW_ITEM_HELP.NO_HELP_EXISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30A2\30A4\30C6\30E0\306B\30D8\30EB\30D7\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112901532650400521)
,p_name=>'WWV_FLOW_JET_CHART.QUERY_GENERATION_FAILED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C1\30E3\30FC\30C8\554F\5408\305B\306E\751F\6210\306B\5931\6557\3057\307E\3057\305F\3002\30BD\30FC\30B9\3068\5217\306E\30DE\30C3\30D4\30F3\30B0\306E\8A2D\5B9A\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112996339116400592)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.ATTACHMENT_EXCEEDS_MAXIMUM_SIZE'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30A4\30BA%0 MB\306E\6DFB\4ED8\306F\6DFB\4ED8\306E\6700\5927\30B5\30A4\30BA%1 MB\3092\8D85\3048\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112902451233400522)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.INVALID_MAIL_ID'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30E9\30E1\30FC\30BFp_mail_id\306E\5024\304C\7121\52B9\3067\3059: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113019898977400609)
,p_name=>'WWV_FLOW_MAIL.EMAIL_LIMIT_EXCEEDED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\5F53\305F\308A\306E\96FB\5B50\30E1\30FC\30EB\30FB\30E1\30C3\30BB\30FC\30B8\306E\6700\5927\6570\3092\8D85\3048\3066\3044\307E\3059\3002\7BA1\7406\8005\306B\9023\7D61\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112883405071400508)
,p_name=>'WWV_FLOW_MAIL.INVALID_CONTEXT'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30D7\30ED\30B7\30FC\30B8\30E3\306F\3001\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3\30FB\30BB\30C3\30B7\30E7\30F3\304B\3089\8D77\52D5\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112902370214400522)
,p_name=>'WWV_FLOW_MAIL.PARAMETER_NULL'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D1\30E9\30E1\30FC\30BF%0\306BNULL\5024\304C\6307\5B9A\3055\308C\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112956313113400562)
,p_name=>'WWV_FLOW_MAIL.PREPARE_TEMPLATE.NO_DATA_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB\30FB\30C6\30F3\30D7\30EC\30FC\30C8"%0"\304C\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3%1\306B\898B\3064\304B\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113032885825400618)
,p_name=>'WWV_FLOW_MAIL.SMTP_HOST_ADDRESS_REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('SMTP_HOST_ADDRESS\30A4\30F3\30B9\30BF\30F3\30B9\30FB\30D1\30E9\30E1\30FC\30BF\3092\8A2D\5B9A\3057\3066\96FB\5B50\30E1\30FC\30EB\3092\9001\4FE1\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112902066472400522)
,p_name=>'WWV_FLOW_MAIL.TO_IS_REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30E1\30FC\30EB\3092\9001\4FE1\3059\308B\30E1\30C3\30BB\30FC\30B8\53D7\4FE1\8005\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113022244727400610)
,p_name=>'WWV_FLOW_MAIL.UNABLE_TO_OPEN_SMTP_CONNECTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\69CB\6210\6E08\306E\96FB\5B50\30E1\30FC\30EB\30FB\30B5\30FC\30D0\30FC\3068SMTP\63A5\7D9A\3092\78BA\7ACB\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112996418926400592)
,p_name=>'WWV_FLOW_PLUGIN.INVALID_AJAX_CALL'
,p_message_language=>'ja'
,p_message_text=>unistr('Ajax\30B3\30FC\30EB\304C\7121\52B9\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112887836536400511)
,p_name=>'WWV_FLOW_PLUGIN.NO_AJAX_FUNCTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30E9\30B0\30A4\30F3%0\306BAjax\30D5\30A1\30F3\30AF\30B7\30E7\30F3\304C\5B9A\7FA9\3055\308C\3066\3044\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112986871411400585)
,p_name=>'WWV_FLOW_PLUGIN.NO_EXECUTION_FUNCTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30E9\30B0\30A4\30F3%0\306B\5B9F\884C\30D5\30A1\30F3\30AF\30B7\30E7\30F3\304C\5B9A\7FA9\3055\308C\3066\3044\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112887979219400511)
,p_name=>'WWV_FLOW_PLUGIN.NO_RENDER_FUNCTION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30E9\30B0\30A4\30F3%0\306B\30EC\30F3\30C0\30EA\30F3\30B0\30FB\30D5\30A1\30F3\30AF\30B7\30E7\30F3\304C\5B9A\7FA9\3055\308C\3066\3044\307E\305B\3093')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112997324179400593)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_CAPABILITIES_FUNCTION'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\30C7\30FC\30BF\30FB\30BD\30FC\30B9\30FB\30D7\30E9\30B0\30A4\30F3"%0"\306B\306F\300C\6A5F\80FD\300D\30D5\30A1\30F3\30AF\30B7\30E7\30F3\304C\542B\307E\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112997279217400593)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_DML_FUNCTION'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\30C7\30FC\30BF\30FB\30BD\30FC\30B9\30FB\30D7\30E9\30B0\30A4\30F3"%0"\306B\306FDML\30D5\30A1\30F3\30AF\30B7\30E7\30F3\304C\542B\307E\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112997475609400593)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_EXECUTE_FUNCTION'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\30C7\30FC\30BF\30FB\30BD\30FC\30B9\30FB\30D7\30E9\30B0\30A4\30F3"%0"\306B\306Fexecute\30D5\30A1\30F3\30AF\30B7\30E7\30F3\304C\542B\307E\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112997581657400593)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_FETCH_FUNCTION'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\30C7\30FC\30BF\30FB\30BD\30FC\30B9\30FB\30D7\30E9\30B0\30A4\30F3"%0"\306B\306Ffetch\30D5\30A1\30F3\30AF\30B7\30E7\30F3\304C\542B\307E\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112885685829400509)
,p_name=>'WWV_FLOW_PLUGIN.RUN_PLSQL_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30D7\30E9\30B0\30A4\30F3\51E6\7406\4E2D\306BPLSQL\30B3\30FC\30C9\3067\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112892205543400514)
,p_name=>'WWV_FLOW_PLUGIN_DEV.IS_REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('\5024\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112922812636400538)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.CANT_CONVERT_TO_VARCHAR2'
,p_message_language=>'ja'
,p_message_text=>unistr('\30C7\30FC\30BF\30FB\30BF\30A4\30D7%0\306FVARCHAR2\306B\5909\63DB\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113008478118400601)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.COLUMN_NOT_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C5E\6027"%1"\306B\6307\5B9A\3055\308C\305F\5217"%0"\304C\3001SQL\6587\3067\898B\3064\304B\308A\307E\305B\3093\3067\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112984744624400583)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_REQUIRED'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306B\5BFE\3057\3066\3001LOV\554F\5408\305B\307E\305F\306F\540D\524D\4ED8\304DLOV\3092\6307\5B9A\3059\308B\5FC5\8981\304C\3042\308A\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112986388425400585)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'ja'
,p_message_text=>unistr('%0\306ELOV SQL\554F\5408\305B\3067\9078\629E\3055\308C\3066\3044\308B\5217\6570\304C\6B63\3057\304F\3042\308A\307E\305B\3093\3002\4F8B\3067\6709\52B9\306A\6587\3092\53C2\7167\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113008292229400600)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C5E\6027"%0"\306B\5217\304C\6307\5B9A\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113037967470400622)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NUMBER_ATTRIBUTE_VALUE_INVALID'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C5E\6027"%1"\306B\5BFE\3057\3066\5165\529B\3055\308C\305F\5024%0\306F\6570\5024\3067\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112989852683400587)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.SQL_WRONG_DATA_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('SQL\6587\306E%0\306E\30C7\30FC\30BF\578B\304C\6B63\3057\304F\3042\308A\307E\305B\3093\3002\5217# %1\306F%2\3067\3059\304C\3001\6B63\3057\304F\306F%3\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113008321079400601)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.WRONG_COLUMN_DATA_TYPE'
,p_message_language=>'ja'
,p_message_text=>unistr('\5C5E\6027"%1"\306B\6307\5B9A\3055\308C\305F\5217"%0"\306B\3001\30C7\30FC\30BF\578B\304C%2\304C\3042\308A\307E\3059\304C\3001%3\3067\306A\3051\308C\3070\306A\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112884971964400509)
,p_name=>'WWV_FLOW_PRINT_UTIL.REPORT_LAYOUT_NOT_FOUND'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\30FB\30EC\30A4\30A2\30A6\30C8\304C\898B\3064\304B\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112944966034400554)
,p_name=>'WWV_FLOW_RENDER_REPORT3.COMPUTE_SUM_NOT_SUPPORTED_FOR_WEB_SOURCES'
,p_message_language=>'ja'
,p_message_text=>unistr('REST\30C7\30FC\30BF\30FB\30BD\30FC\30B9\306B\57FA\3065\304F\30EC\30DD\30FC\30C8\3067\306F\3001\300C\5408\8A08\306E\8A08\7B97\300D\6A5F\80FD\3092\4F7F\7528\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112908508372400526)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNABLE_SET_SHORT_VAL_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('ERR-2904 \30B7\30E7\30FC\30C8\30AB\30C3\30C8\5024\3092\8A2D\5B9A\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112912832968400530)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNKNOWN_TYPE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A8\30E9\30FC: \30B7\30E7\30FC\30C8\30AB\30C3\30C8\306E\30BF\30A4\30D7\304C\4E0D\660E\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112902855501400522)
,p_name=>'WWV_FLOW_SECURITY.AUTH_SCHEME_FETCH_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\30A2\30D7\30EA\30B1\30FC\30B7\30E7\30F3%0\306Eauthentication_scheme\3092\30D5\30A7\30C3\30C1\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112976350022400577)
,p_name=>'WWV_FLOW_SESSION_API.TENANT_ID_EXISTS'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\30BB\30C3\30B7\30E7\30F3\306E\30C6\30CA\30F3\30C8ID\306F\3059\3067\306B\5B58\5728\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112913152747400530)
,p_name=>'WWV_FLOW_USER_API.T_EMAIL'
,p_message_language=>'ja'
,p_message_text=>unistr('\96FB\5B50\30E1\30FC\30EB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113037372161400621)
,p_name=>'WWV_FLOW_WEB_SERVICES.AUTHENTICATION_FAILED'
,p_message_language=>'ja'
,p_message_text=>unistr('\8A8D\8A3C\306B\5931\6557\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112939698487400550)
,p_name=>'WWV_FLOW_WEB_SERVICES.COOKIE_INVALID'
,p_message_language=>'ja'
,p_message_text=>unistr('apex_util.g_request_cookies\306B\8A2D\5B9A\3055\308C\3066\3044\308B1\3064\4EE5\4E0A\306ECookie\306B\7121\52B9\306A\5024\304C\542B\307E\308C\3066\3044\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112922199046400537)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_UDDI_RESPONSE'
,p_message_language=>'ja'
,p_message_text=>unistr('UDDI\30EC\30B8\30B9\30C8\30EA\304B\3089\306E\30EC\30B9\30DD\30F3\30B9\306F\7121\52B9\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112885747751400509)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_WSDL'
,p_message_language=>'ja'
,p_message_text=>unistr('\6307\5B9A\3057\305FURL\306F\3001\6709\52B9\306AWSDL\30C9\30AD\30E5\30E1\30F3\30C8\3092\623B\3057\307E\305B\3093\3067\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112888224421400511)
,p_name=>'WWV_FLOW_WEB_SERVICES.MULTIPLE_SOAP'
,p_message_language=>'ja'
,p_message_text=>unistr('WSDL\30C9\30AD\30E5\30E1\30F3\30C8\306B\8907\6570\306ESOAP\30D0\30A4\30F3\30C7\30A3\30F3\30B0\304C\542B\307E\308C\3066\3044\307E\3059\3002&PRODUCT_NAME.\306F1\3064\306ESOAP\30D0\30A4\30F3\30C7\30A3\30F3\30B0\3092\542B\3080WSDL\30C9\30AD\30E5\30E1\30F3\30C8\306E\307F\3092\30B5\30DD\30FC\30C8\3057\3066\3044\307E\3059\3002\3053\306E\30B5\30FC\30D3\30B9\306B\5BFE\3059\308B\53C2\7167\306E\4F5C\6210\3092\7D9A\884C\3059\308B\306B\306F\300CWeb\30B5\30FC\30D3\30B9\53C2\7167\306E\624B\52D5\4F5C\6210\300D\3092\30AF\30EA\30C3\30AF\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112956612014400562)
,p_name=>'WWV_FLOW_WEB_SERVICES.NOT_XML'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30FC\30D3\30B9\304B\3089\306E\30EC\30B9\30DD\30F3\30B9\304CXML\3067\306F\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113037200610400621)
,p_name=>'WWV_FLOW_WEB_SERVICES.NO_VALID_OAUTH_TOKEN'
,p_message_language=>'ja'
,p_message_text=>unistr('OAuth\30A2\30AF\30BB\30B9\30FB\30C8\30FC\30AF\30F3\304C\4F7F\7528\4E0D\53EF\307E\305F\306F\671F\9650\5207\308C\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113000455911400595)
,p_name=>'WWV_FLOW_WEB_SERVICES.REQUEST_LIMIT_EXCEEDED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EF\30FC\30AF\30B9\30DA\30FC\30B9\5F53\305F\308A\306EWeb\30B5\30FC\30D3\30B9\30FB\30EA\30AF\30A8\30B9\30C8\306E\6700\5927\6570\3092\8D85\3048\3066\3044\307E\3059\3002\7BA1\7406\8005\306B\9023\7D61\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113037487255400622)
,p_name=>'WWV_FLOW_WEB_SERVICES.UNSUPPORTED_OAUTH_TOKEN'
,p_message_language=>'ja'
,p_message_text=>unistr('\30B5\30FC\30D0\30FC\304C\30B5\30DD\30FC\30C8\3055\308C\3066\3044\306A\3044OAuth\30C8\30FC\30AF\30F3\30FB\30BF\30A4\30D7\306B\5FDC\7B54\3057\307E\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112887620007400511)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_NO_SOAP'
,p_message_language=>'ja'
,p_message_text=>unistr('WSDL\30C9\30AD\30E5\30E1\30F3\30C8\306B\306F\3001\53C2\7167\306E\8FFD\52A0\306B\5FC5\8981\306ASOAP\7528\306E\30D0\30A4\30F3\30C7\30A3\30F3\30B0\304C\542B\307E\308C\3066\3044\307E\305B\3093\3067\3057\305F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112883578013400508)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_REQUIRES_AUTH'
,p_message_language=>'ja'
,p_message_text=>unistr('WSDL\306B\306F\8A8D\8A3C\8CC7\683C\8A3C\660E\304C\5FC5\8981\3067\3059\3002\30E6\30FC\30B6\30FC\540D\304A\3088\3073\30D1\30B9\30EF\30FC\30C9\3092\6B21\306B\5165\529B\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112892396554400514)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_UNHANDLED'
,p_message_language=>'ja'
,p_message_text=>unistr('WSDL\30C9\30AD\30E5\30E1\30F3\30C8\3092\30EC\30F3\30C0\30EA\30F3\30B0\30FB\30A8\30F3\30B8\30F3\3067\89E3\91C8\3067\304D\307E\305B\3093\3067\3057\305F\3002\3053\306E\30B5\30FC\30D3\30B9\306B\5BFE\3059\308B\53C2\7167\306E\4F5C\6210\3092\7D9A\884C\3059\308B\306B\306F\300CWeb\30B5\30FC\30D3\30B9\53C2\7167\306E\624B\52D5\4F5C\6210\300D\3092\30AF\30EA\30C3\30AF\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112959230448400564)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATE_ERROR'
,p_message_language=>'ja'
,p_message_text=>unistr('\66F4\65B0\3092\51E6\7406\3067\304D\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112985022384400584)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_DISPLAY_AND_RETURN_COLUMN_EQUAL'
,p_message_language=>'ja'
,p_message_text=>unistr('LOV\306E\623B\308A\5217\3068\8868\793A\5217\304C\540C\3058\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112984960106400584)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_NO_RETURN_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('LOV\306B\623B\308A\5217\304C\3042\308A\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112916476543400532)
,p_name=>'WWV_RENDER_REPORT3.COLUMN_VALUE_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\5217\5024\306E\30D5\30A7\30C3\30C1\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112940478139400551)
,p_name=>'WWV_RENDER_REPORT3.DATA_TOO_OLD'
,p_message_language=>'ja'
,p_message_text=>unistr('\73FE\5728\306E\8868\5F62\5F0F\30D5\30A9\30FC\30E0\30FB\30C7\30FC\30BF\306F\53E4\3059\304E\3066\3001\30BD\30FC\30B9\30FB\30C7\30FC\30BF\304C\4FEE\6B63\3055\308C\3066\3044\307E\3059\3002<br/>\5909\66F4\3092\7834\68C4\3057\3066\30C7\30FC\30BF\30D9\30FC\30B9\306E\30C7\30FC\30BF\3092\518D\30ED\30FC\30C9\3059\308B\306B\306F\3001<strong><a href="%0">\3053\3053</a></strong>\3092\30AF\30EA\30C3\30AF\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112898516339400519)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_PAGINATION'
,p_message_language=>'ja'
,p_message_text=>unistr('\30DA\30FC\30B8\533A\5207\308A\6587\5B57\5217\306E\5224\65AD\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112898439355400519)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_QUERY_HEADINGS'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\554F\5408\305B\30D8\30C3\30C0\30FC\3092\5224\65AD\3067\304D\307E\305B\3093\3002'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112898684225400519)
,p_name=>'WWV_RENDER_REPORT3.ERR_REPORT_FOOTER'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\30FB\30D5\30C3\30BF\30FC\306E\7F6E\63DB\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112898791105400519)
,p_name=>'WWV_RENDER_REPORT3.FAILED_PARSING_QUERY'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('SQL\554F\5408\305B\306E\89E3\6790\306B\5931\6557:'),
'%0',
'%1'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112903755954400523)
,p_name=>'WWV_RENDER_REPORT3.FOUND_BUT_NOT_DISPLAYED'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EA\30AF\30A8\30B9\30C8\3055\308C\305F\6700\5C0F\884C: %0\3002\691C\51FA\3055\308C\305F\304C\8868\793A\3055\308C\306A\304B\3063\305F\884C: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112901243230400521)
,p_name=>'WWV_RENDER_REPORT3.HTML_USE_COLUMN_ALIAS'
,p_message_language=>'ja'
,p_message_text=>unistr('\554F\5408\305B\5217#%0(%1)\306F\7121\52B9\3067\3059\3002HTML\3092\4F7F\7528\3059\308B\5217\306B\306F\5225\540D\304C\5FC5\8981\3067\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112916316529400532)
,p_name=>'WWV_RENDER_REPORT3.QUERY_HEADING_ERR'
,p_message_language=>'ja'
,p_message_text=>unistr('\554F\5408\305B\30D8\30C3\30C0\30FC\306E\5909\63DB\4E2D\306B\30A8\30E9\30FC\304C\767A\751F\3057\307E\3057\305F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112898881375400519)
,p_name=>'WWV_RENDER_REPORT3.REPORT_ERROR'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\30EC\30DD\30FC\30C8\30FB\30A8\30E9\30FC:'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112936509533400548)
,p_name=>'WWV_RENDER_REPORT3.SORT_BY_THIS_COLUMN'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\5217\3067\30BD\30FC\30C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112901312846400521)
,p_name=>'WWV_RENDER_REPORT3.SYNTAX_ERROR'
,p_message_language=>'ja'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\554F\5408\305B\3092\89E3\6790\3067\304D\307E\305B\3093\3002\554F\5408\305B\306E\69CB\6587\3092\78BA\8A8D\3057\3066\304F\3060\3055\3044\3002'),
'(%0)',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112940514350400551)
,p_name=>'WWV_RENDER_REPORT3.UNSAVED_DATA'
,p_message_language=>'ja'
,p_message_text=>unistr('\3053\306E\30D5\30A9\30FC\30E0\306B\306F\3001\672A\4FDD\5B58\306E\5909\66F4\304C\542B\307E\308C\3066\3044\307E\3059\3002\300COK\300D\3092\62BC\3059\3068\3001\5909\66F4\3092\4FDD\5B58\305B\305A\306B\7D9A\884C\3057\307E\3059\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112944883181400554)
,p_name=>'WWV_RENDER_REPORT3.UNSUPPORTED_PAGINATION_SCHEME'
,p_message_language=>'ja'
,p_message_text=>unistr('\30EC\30DD\30FC\30C8\30FB\30DA\30FC\30B8\533A\5207\308A\30B9\30AD\30FC\30E0(%0)\306F\3001\9078\629E\3057\305F\30C7\30FC\30BF\30FB\30BD\30FC\30B9\3067\30B5\30DD\30FC\30C8\3055\308C\3066\3044\307E\305B\3093\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112901125668400521)
,p_name=>'WWV_RENDER_REPORT3.USE_COLUMN_ALIAS'
,p_message_language=>'ja'
,p_message_text=>unistr('\554F\5408\305B\5217#%0(%1)\306F\7121\52B9\3067\3059\3002\5217\306E\5225\540D\3092\4F7F\7528\3057\3066\304F\3060\3055\3044\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112903859971400523)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z'
,p_message_language=>'ja'
,p_message_text=>unistr('%2\4EF6\4EE5\4E0A%0-%1\4EF6\76EE\306E\8868\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112942540481400552)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z_2'
,p_message_language=>'ja'
,p_message_text=>unistr('%2\3092\8D85\3048\308B%0 - %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112903674077400523)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z'
,p_message_language=>'ja'
,p_message_text=>unistr('%2\884C\4E2D%0-%1\884C\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112887539640400511)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z_2'
,p_message_language=>'ja'
,p_message_text=>unistr('%2\4EF6\4E2D%0-%1\4EF6\76EE')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112898909545400519)
,p_name=>'Y'
,p_message_language=>'ja'
,p_message_text=>'Y'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112905009195400524)
,p_name=>'YEAR'
,p_message_language=>'ja'
,p_message_text=>unistr('\5E74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112898102268400519)
,p_name=>'YEARS'
,p_message_language=>'ja'
,p_message_text=>unistr('\5E74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112940645639400551)
,p_name=>'YES'
,p_message_language=>'ja'
,p_message_text=>unistr('\306F\3044')
);
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/security/authentications/no_auth
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(109678305570583962.4479)
,p_name=>'No Auth'
,p_scheme_type=>'NATIVE_DAD'
,p_attribute_01=>'nobody'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_api.create_user_interface(
 p_id=>wwv_flow_api.id(649611912251764510.4479)
,p_ui_type_name=>'DESKTOP'
,p_display_name=>unistr('\30C7\30B9\30AF\30C8\30C3\30D7')
,p_display_seq=>10
,p_use_auto_detect=>false
,p_is_default=>true
,p_theme_id=>3
,p_home_url=>'f?p=&APP_ID.:1:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_nav_list_template_options=>'#DEFAULT#'
,p_include_legacy_javascript=>'PRE18:18'
,p_nav_bar_type=>'NAVBAR'
,p_nav_bar_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_api.create_page(
 p_id=>1.4479
,p_user_interface_id=>wwv_flow_api.id(649611912251764510.4479)
,p_name=>unistr('\30E1\30C3\30BB\30FC\30B8')
,p_alias=>'MESSAGES'
,p_step_title=>unistr('\30E1\30C3\30BB\30FC\30B8')
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/end_environment
begin
wwv_flow_api.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false));
commit;
end;
/
set verify on feedback on define on
prompt  ...done
